/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ue=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ae=function(V){for(var t=[],i=0,F=V.length;i<F;i++)t[i]=ue[V[i]];return t};const He=this,Ge=typeof global=="object"?global:{};var $e;(function(V){V.global=He;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof V.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}V.Environment=t})($e||($e={}));var $e;(function(V){class t{constructor(c,p,d){this.type=c,this.detail=p,this.timestamp=d}}V.LoaderEvent=t;class i{constructor(c){this._events=[new t(1,"",c)]}record(c,p){this._events.push(new t(c,p,V.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}V.LoaderEventRecorder=i;class F{record(c,p){}getEvents(){return[]}}F.INSTANCE=new F,V.NullLoaderEventRecorder=F})($e||($e={}));var $e;(function(V){class t{static fileUriToFilePath(F,M){if(M=decodeURI(M).replace(/%23/g,"#"),F){if(/^file:\/\/\//.test(M))return M.substr(8);if(/^file:\/\//.test(M))return M.substr(5)}else if(/^file:\/\//.test(M))return M.substr(7);return M}static startsWith(F,M){return F.length>=M.length&&F.substr(0,M.length)===M}static endsWith(F,M){return F.length>=M.length&&F.substr(F.length-M.length)===M}static containsQueryString(F){return/^[^\#]*\?/gi.test(F)}static isAbsolutePath(F){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(F)}static forEachProperty(F,M){if(F){let c;for(c in F)F.hasOwnProperty(c)&&M(c,F[c])}}static isEmpty(F){let M=!0;return t.forEachProperty(F,()=>{M=!1}),M}static recursiveClone(F){if(!F||typeof F!="object"||F instanceof RegExp||!Array.isArray(F)&&Object.getPrototypeOf(F)!==Object.prototype)return F;let M=Array.isArray(F)?[]:{};return t.forEachProperty(F,(c,p)=>{p&&typeof p=="object"?M[c]=t.recursiveClone(p):M[c]=p}),M}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(F){return t.startsWith(F,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=V.global.performance&&typeof V.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?V.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,V.Utilities=t})($e||($e={}));var $e;(function(V){function t(M){if(M instanceof Error)return M;const c=new Error(M.message||String(M)||"Unknown Error");return M.stack&&(c.stack=M.stack),c}V.ensureError=t;class i{static validateConfigurationOptions(c){function p(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=p),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(V.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){const d=t(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",c.onError(d),c.nodeCachedData=void 0}return c}static mergeConfigurationOptions(c=null,p=null){let d=V.Utilities.recursiveClone(p||{});return V.Utilities.forEachProperty(c,(a,u)=>{a==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(u):a==="paths"&&typeof d.paths<"u"?V.Utilities.forEachProperty(u,(f,w)=>d.paths[f]=w):a==="config"&&typeof d.config<"u"?V.Utilities.forEachProperty(u,(f,w)=>d.config[f]=w):d[a]=V.Utilities.recursiveClone(u)}),i.validateConfigurationOptions(d)}}V.ConfigurationOptionsUtil=i;class F{constructor(c,p){if(this._env=c,this.options=i.mergeConfigurationOptions(p),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,a=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],V.Utilities.forEachProperty(this.options.paths,(c,p)=>{Array.isArray(p)?this.sortedPathsRules.push({from:c,to:p}):this.sortedPathsRules.push({from:c,to:[p]})}),this.sortedPathsRules.sort((c,p)=>p.from.length-c.from.length)}cloneAndMerge(c){return new F(this._env,i.mergeConfigurationOptions(c,this.options))}getOptionsLiteral(){return this.options}_applyPaths(c){let p;for(let d=0,a=this.sortedPathsRules.length;d<a;d++)if(p=this.sortedPathsRules[d],V.Utilities.startsWith(c,p.from)){let u=[];for(let f=0,w=p.to.length;f<w;f++)u.push(p.to[f]+c.substr(p.from.length));return u}return[c]}_addUrlArgsToUrl(c){return V.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c}_addUrlArgsIfNecessaryToUrls(c){if(this.options.urlArgs)for(let p=0,d=c.length;p<d;p++)c[p]=this._addUrlArgsToUrl(c[p]);return c}moduleIdToPaths(c){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c))return this.isBuild()?["empty:"]:["node|"+c];let p=c,d;if(!V.Utilities.endsWith(p,".js")&&!V.Utilities.isAbsolutePath(p)){d=this._applyPaths(p);for(let a=0,u=d.length;a<u;a++)this.isBuild()&&d[a]==="empty:"||(V.Utilities.isAbsolutePath(d[a])||(d[a]=this.options.baseUrl+d[a]),!V.Utilities.endsWith(d[a],".js")&&!V.Utilities.containsQueryString(d[a])&&(d[a]=d[a]+".js"))}else!V.Utilities.endsWith(p,".js")&&!V.Utilities.containsQueryString(p)&&(p=p+".js"),d=[p];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(c){let p=c;return V.Utilities.isAbsolutePath(p)||(p=this._applyPaths(p)[0],V.Utilities.isAbsolutePath(p)||(p=this.options.baseUrl+p)),this._addUrlArgsIfNecessaryToUrl(p)}isBuild(){return this.options.isBuild}shouldInvokeFactory(c){return!!(!this.options.isBuild||V.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])}isDuplicateMessageIgnoredFor(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)}getConfigForModule(c){if(this.options.config)return this.options.config[c]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(c){this.options.onError(c)}}V.Configuration=F})($e||($e={}));var $e;(function(V){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,f,w,g){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new M;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new i:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new i;let m={callback:w,errorback:g};if(this._callbackMap.hasOwnProperty(f)){this._callbackMap[f].push(m);return}this._callbackMap[f]=[m],this._scriptLoader.load(u,f,()=>this.triggerCallback(f),e=>this.triggerErrorback(f,e))}triggerCallback(u){let f=this._callbackMap[u];delete this._callbackMap[u];for(let w=0;w<f.length;w++)f[w].callback()}triggerErrorback(u,f){let w=this._callbackMap[u];delete this._callbackMap[u];for(let g=0;g<w.length;g++)w[g].errorback(f)}}class i{attachListeners(u,f,w){let g=()=>{u.removeEventListener("load",m),u.removeEventListener("error",e)},m=L=>{g(),f()},e=L=>{g(),w(L)};u.addEventListener("load",m),u.addEventListener("error",e)}load(u,f,w,g){if(/^node\|/.test(f)){let m=u.getConfig().getOptionsLiteral(),e=p(u.getRecorder(),m.nodeRequire||V.global.nodeRequire),L=f.split("|"),E=null;try{E=e(L[1])}catch(N){g(N);return}u.enqueueDefineAnonymousModule([],()=>E),w()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,w,g);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(f=e.createScriptURL(f)),m.setAttribute("src",f);const{cspNonce:L}=u.getConfig().getOptionsLiteral();L&&m.setAttribute("nonce",L),document.getElementsByTagName("head")[0].appendChild(m)}}}function F(a){const{trustedTypesPolicy:u}=a.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class M{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=F(u)),this._cachedCanUseEval}load(u,f,w,g){if(/^node\|/.test(f)){const m=u.getConfig().getOptionsLiteral(),e=p(u.getRecorder(),m.nodeRequire||V.global.nodeRequire),L=f.split("|");let E=null;try{E=e(L[1])}catch(N){g(N);return}u.enqueueDefineAnonymousModule([],function(){return E}),w()}else{const{trustedTypesPolicy:m}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(f).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${f}`,(m?self.eval(m.createScript("",L)):new Function(L)).call(self),w()}).then(void 0,g);return}try{m&&(f=m.createScriptURL(f)),importScripts(f),w()}catch(L){g(L)}}}}class c{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,f){const{nodeCachedData:w}=f.getConfig().getOptionsLiteral();if(!w||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const g=this,m=u("module");function e(L){const E=L.constructor;let N=function(v){try{return L.require(v)}finally{}};return N.resolve=function(v,j){return E._resolveFilename(v,L,!1,j)},N.resolve.paths=function(v){return E._resolveLookupPaths(v,L)},N.main=process.mainModule,N.extensions=E._extensions,N.cache=E._cache,N}m.prototype._compile=function(L,E){const N=m.wrap(L.replace(/^#!.*/,"")),$=f.getRecorder(),v=g._getCachedDataPath(w,E),j={filename:E};let l;try{const R=g._fs.readFileSync(v);l=R.slice(0,16),j.cachedData=R.slice(16),$.record(60,v)}catch{$.record(61,v)}const n=new g._vm.Script(N,j),s=n.runInThisContext(j),h=g._path.dirname(E),o=e(this),b=[this.exports,o,this,E,h,process,Ge,Buffer],A=s.apply(this.exports,b);return g._handleCachedData(n,N,v,!j.cachedData,f),g._verifyCachedData(n,N,v,l,f),A}}load(u,f,w,g){const m=u.getConfig().getOptionsLiteral(),e=p(u.getRecorder(),m.nodeRequire||V.global.nodeRequire),L=m.nodeInstrumenter||function(N){return N};this._init(e),this._initNodeRequire(e,u);let E=u.getRecorder();if(/^node\|/.test(f)){let N=f.split("|"),$=null;try{$=e(N[1])}catch(v){g(v);return}u.enqueueDefineAnonymousModule([],()=>$),w()}else{f=V.Utilities.fileUriToFilePath(this._env.isWindows,f);const N=this._path.normalize(f),$=this._getElectronRendererScriptPathOrUri(N),v=!!m.nodeCachedData,j=v?this._getCachedDataPath(m.nodeCachedData,f):void 0;this._readSourceAndCachedData(N,j,E,(l,n,s,h)=>{if(l){g(l);return}let o;n.charCodeAt(0)===c._BOM?o=c._PREFIX+n.substring(1)+c._SUFFIX:o=c._PREFIX+n+c._SUFFIX,o=L(o,N);const b={filename:$,cachedData:s},A=this._createAndEvalScript(u,o,b,w,g);this._handleCachedData(A,o,j,v&&!s,u),this._verifyCachedData(A,o,j,h,u)})}}_createAndEvalScript(u,f,w,g,m){const e=u.getRecorder();e.record(31,w.filename);const L=new this._vm.Script(f,w),E=L.runInThisContext(w),N=u.getGlobalAMDDefineFunc();let $=!1;const v=function(){return $=!0,N.apply(null,arguments)};return v.amd=N.amd,E.call(V.global,u.getGlobalAMDRequireFunc(),v,w.filename,this._path.dirname(w.filename)),e.record(32,w.filename),$?g():m(new Error(`Didn't receive define call in ${w.filename}!`)),L}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let f=u.match(/^([a-z])\:(.*)/i);return f?`file:///${(f[1].toUpperCase()+":"+f[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,f){const w=this._crypto.createHash("md5").update(f,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),g=this._path.basename(f).replace(/\.js$/,"");return this._path.join(u.path,`${g}-${w}.code`)}_handleCachedData(u,f,w,g,m){u.cachedDataRejected?this._fs.unlink(w,e=>{m.getRecorder().record(62,w),this._createAndWriteCachedData(u,f,w,m),e&&m.getConfig().onError(e)}):g&&this._createAndWriteCachedData(u,f,w,m)}_createAndWriteCachedData(u,f,w,g){let m=Math.ceil(g.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,L=0,E;const N=()=>{setTimeout(()=>{E||(E=this._crypto.createHash("md5").update(f,"utf8").digest());const $=u.createCachedData();if(!($.length===0||$.length===e||L>=5)){if($.length<e){N();return}e=$.length,this._fs.writeFile(w,Buffer.concat([E,$]),v=>{v&&g.getConfig().onError(v),g.getRecorder().record(63,w),N()})}},m*Math.pow(4,L++))};N()}_readSourceAndCachedData(u,f,w,g){if(!f)this._fs.readFile(u,{encoding:"utf8"},g);else{let m,e,L,E=2;const N=$=>{$?g($):--E===0&&g(void 0,m,e,L)};this._fs.readFile(u,{encoding:"utf8"},($,v)=>{m=v,N($)}),this._fs.readFile(f,($,v)=>{!$&&v&&v.length>0?(L=v.slice(0,16),e=v.slice(16),w.record(60,f)):w.record(61,f),N()})}}_verifyCachedData(u,f,w,g,m){g&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(f,"utf8").digest();g.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${w}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(w,L=>{L&&m.getConfig().onError(L)}))},Math.ceil(5e3*(1+Math.random()))))}}c._BOM=65279,c._PREFIX="(function (require, define, __filename, __dirname) { ",c._SUFFIX=`
});`;function p(a,u){if(u.__$__isRecorded)return u;const f=function(g){a.record(33,g);try{return u(g)}finally{a.record(34,g)}};return f.__$__isRecorded=!0,f}V.ensureRecordedNodeRequire=p;function d(a){return new t(a)}V.createScriptLoader=d})($e||($e={}));var $e;(function(V){class t{constructor(a){let u=a.lastIndexOf("/");u!==-1?this.fromModulePath=a.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(a){let u=a,f;for(f=/\/\.\//;f.test(u);)u=u.replace(f,"/");for(u=u.replace(/^\.\//g,""),f=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;f.test(u);)u=u.replace(f,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(a){let u=a;return V.Utilities.isAbsolutePath(u)||(V.Utilities.startsWith(u,"./")||V.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),V.ModuleIdResolver=t;class i{constructor(a,u,f,w,g,m){this.id=a,this.strId=u,this.dependencies=f,this._callback=w,this._errorback=g,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,u){try{return{returnedValue:a.apply(V.global,u),producedError:null}}catch(f){return{returnedValue:null,producedError:f}}}static _invokeFactory(a,u,f,w){return a.shouldInvokeFactory(u)?a.shouldCatchError()?this._safeInvokeFunction(f,w):{returnedValue:f.apply(V.global,w),producedError:null}:{returnedValue:null,producedError:null}}complete(a,u,f,w){this._isComplete=!0;let g=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let m=i._invokeFactory(u,this.strId,this._callback,f);g=m.producedError,a.record(22,this.strId),!g&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||V.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(g){let m=V.ensureError(g);m.phase="factory",m.moduleId=this.strId,m.neededBy=w(this.id),this.error=m,u.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}V.Module=i;class F{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let u=this._strModuleIdToIntModuleId.get(a);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(a,u),this._intModuleIdToStrModuleId[u]=a),u}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class M{constructor(a){this.id=a}}M.EXPORTS=new M(0),M.MODULE=new M(1),M.REQUIRE=new M(2),V.RegularDependency=M;class c{constructor(a,u,f){this.id=a,this.pluginId=u,this.pluginParam=f}}V.PluginDependency=c;class p{constructor(a,u,f,w,g=0){this._env=a,this._scriptLoader=u,this._loaderAvailableTimestamp=g,this._defineFunc=f,this._requireFunc=w,this._moduleIdProvider=new F,this._config=new V.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new p(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,u){let f=m=>m.replace(/\\/g,"/"),w=f(a),g=u.split(/\n/);for(let m=0;m<g.length;m++){let e=g[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let L=e[1],E=e[2],N=e[3],$=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr($),L=f(L),L===w){let v={line:parseInt(E,10),col:parseInt(N,10)};return v.line===1&&(v.col-=53),v}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],u=0;for(let f=0,w=this._modules2.length;f<w;f++){let g=this._modules2[f];if(!g)continue;let m=this._buildInfoPath[g.id]||null,e=this._buildInfoDefineStack[g.id]||null,L=this._buildInfoDependencies[g.id];a[u++]={id:g.strId,path:m,defineLocation:m&&e?p._findRelevantLocationInStack(m,e):null,dependencies:L,shim:null,exports:g.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new V.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=V.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let f=null;this._config.isBuild()&&(f=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:f,dependencies:a,callback:u}}defineModule(a,u,f,w,g,m=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let L=new i(e,a,this._normalizeDependencies(u,m),f,w,m);this._modules2[e]=L,this._config.isBuild()&&(this._buildInfoDefineStack[e]=g,this._buildInfoDependencies[e]=(L.dependencies||[]).map(E=>this._moduleIdProvider.getStrModuleId(E.id))),this._resolve(L)}_normalizeDependency(a,u){if(a==="exports")return M.EXPORTS;if(a==="module")return M.MODULE;if(a==="require")return M.REQUIRE;let f=a.indexOf("!");if(f>=0){let w=u.resolveModule(a.substr(0,f)),g=u.resolveModule(a.substr(f+1)),m=this._moduleIdProvider.getModuleId(w+"!"+g),e=this._moduleIdProvider.getModuleId(w);return new c(m,e,g)}return new M(this._moduleIdProvider.getModuleId(u.resolveModule(a)))}_normalizeDependencies(a,u){let f=[],w=0;for(let g=0,m=a.length;g<m;g++)f[w++]=this._normalizeDependency(a[g],u);return f}_relativeRequire(a,u,f,w){if(typeof u=="string")return this.synchronousRequire(u,a);this.defineModule(V.Utilities.generateAnonymousModule(),u,f,w,null,a)}synchronousRequire(a,u=new t(a)){let f=this._normalizeDependency(a,u),w=this._modules2[f.id];if(!w)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!w.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(w.error)throw w.error;return w.exports}configure(a,u){let f=this._config.shouldRecordStats();u?this._config=new V.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!f&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),u.dependencies,u.callback,null,u.stack)}}_createLoadError(a,u){let f=this._moduleIdProvider.getStrModuleId(a),w=(this._inverseDependencies2[a]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const g=V.ensureError(u);return g.phase="loading",g.moduleId=f,g.neededBy=w,g}_onLoadError(a,u){const f=this._createLoadError(a,u);this._modules2[a]||(this._modules2[a]=new i(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let w=[];for(let e=0,L=this._moduleIdProvider.getMaxModuleId();e<L;e++)w[e]=!1;let g=!1,m=[];for(m.push(a),w[a]=!0;m.length>0;){let e=m.shift(),L=this._modules2[e];L&&(g=L.onDependencyError(f)||g);let E=this._inverseDependencies2[e];if(E)for(let N=0,$=E.length;N<$;N++){let v=E[N];w[v]||(m.push(v),w[v]=!0)}}g||this._config.onError(f)}_hasDependencyPath(a,u){let f=this._modules2[a];if(!f)return!1;let w=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)w[m]=!1;let g=[];for(g.push(f),w[a]=!0;g.length>0;){let e=g.shift().dependencies;if(e)for(let L=0,E=e.length;L<E;L++){let N=e[L];if(N.id===u)return!0;let $=this._modules2[N.id];$&&!w[N.id]&&(w[N.id]=!0,g.push($))}}return!1}_findCyclePath(a,u,f){if(a===u||f===50)return[a];let w=this._modules2[a];if(!w)return null;let g=w.dependencies;if(g)for(let m=0,e=g.length;m<e;m++){let L=this._findCyclePath(g[m].id,u,f+1);if(L!==null)return L.push(a),L}return null}_createRequire(a){let u=(f,w,g)=>this._relativeRequire(a,f,w,g);return u.toUrl=f=>this._config.requireToUrl(a.resolveModule(f)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(f,w=!1)=>{this.configure(f,w)},u.__$__nodeRequire=V.global.nodeRequire,u}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let u=this._moduleIdProvider.getStrModuleId(a),f=this._config.moduleIdToPaths(u),w=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||w.test(u))&&f.push("node|"+u);let g=-1,m=e=>{if(g++,g>=f.length)this._onLoadError(a,e);else{let L=f[g],E=this.getRecorder();if(this._config.isBuild()&&L==="empty:"){this._buildInfoPath[a]=L,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}E.record(10,L),this._scriptLoader.load(this,L,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=L),E.record(11,L),this._onLoad(a)},N=>{E.record(12,L),m(N)})}};m(null)}_loadPluginDependency(a,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let f=w=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],w,null,null)};f.error=w=>{this._config.onError(this._createLoadError(u.id,w))},a.load(u.pluginParam,this._createRequire(t.ROOT),f,this._config.getOptionsLiteral())}_resolve(a){let u=a.dependencies;if(u)for(let f=0,w=u.length;f<w;f++){let g=u[f];if(g===M.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(g===M.MODULE){a.unresolvedDependenciesCount--;continue}if(g===M.REQUIRE){a.unresolvedDependenciesCount--;continue}let m=this._modules2[g.id];if(m&&m.isComplete()){if(m.error){a.onDependencyError(m.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(g.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(g.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(g.id,a.id,0)||[];e.reverse(),e.push(g.id),console.warn(e.map(L=>this._moduleIdProvider.getStrModuleId(L)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[g.id]=this._inverseDependencies2[g.id]||[],this._inverseDependencies2[g.id].push(a.id),g instanceof c){let e=this._modules2[g.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,g);continue}let L=this._inversePluginDependencies2.get(g.pluginId);L||(L=[],this._inversePluginDependencies2.set(g.pluginId,L)),L.push(g),this._loadModule(g.pluginId);continue}this._loadModule(g.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let u=this.getRecorder();if(a.isComplete())return;let f=a.dependencies,w=[];if(f)for(let L=0,E=f.length;L<E;L++){let N=f[L];if(N===M.EXPORTS){w[L]=a.exports;continue}if(N===M.MODULE){w[L]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(N===M.REQUIRE){w[L]=this._createRequire(a.moduleIdResolver);continue}let $=this._modules2[N.id];if($){w[L]=$.exports;continue}w[L]=null}const g=L=>(this._inverseDependencies2[L]||[]).map(E=>this._moduleIdProvider.getStrModuleId(E));a.complete(u,this._config,w,g);let m=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,m)for(let L=0,E=m.length;L<E;L++){let N=m[L],$=this._modules2[N];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let L=0,E=e.length;L<E;L++)this._loadPluginDependency(a.exports,e[L])}}}V.ModuleManager=p})($e||($e={}));var se,$e;(function(V){const t=new V.Environment;let i=null;const F=function(d,a,u){typeof d!="string"&&(u=a,a=d,d=null),(typeof a!="object"||!Array.isArray(a))&&(u=a,a=null),a||(a=["require","exports","module"]),d?i.defineModule(d,a,u,null,null):i.enqueueDefineAnonymousModule(a,u)};F.amd={jQuery:!0};const M=function(d,a=!1){i.configure(d,a)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){M(arguments[0]);return}if(typeof arguments[0]=="string")return i.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){i.defineModule(V.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=M,c.getConfig=function(){return i.getConfig().getOptionsLiteral()},c.reset=function(){i=i.reset()},c.getBuildInfo=function(){return i.getBuildInfo()},c.getStats=function(){return i.getLoaderEvents()},c.define=F;function p(){if(typeof V.global.require<"u"||typeof require<"u"){const d=V.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const a=V.ensureRecordedNodeRequire(i.getRecorder(),d);V.global.nodeRequire=a,c.nodeRequire=a,c.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=c:(t.isElectronRenderer||(V.global.define=F),V.global.require=c)}V.init=p,(typeof V.global.define!="function"||!V.global.define.amd)&&(i=new V.ModuleManager(t,V.createScriptLoader(t),F,c,V.Utilities.getHighPerformanceTimestamp()),typeof V.global.require<"u"&&typeof V.global.require!="function"&&c.config(V.global.require),se=function(){return F.apply(null,arguments)},se.amd=F.amd,typeof doNotInitLoader>"u"&&p())})($e||($e={})),se(ue[72],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=i;function i(d,a,u,f){if(f=f||{},(f["vs/css"]||{}).disabled){u({});return}const g=a.toUrl(d+".css");F(d,g,()=>{u({})},m=>{typeof u.error=="function"&&u.error("Could not find "+g+".")})}function F(d,a,u,f){if(M(d,a)){u();return}c(d,a,u,f)}function M(d,a){const u=window.document.getElementsByTagName("link");for(let f=0,w=u.length;f<w;f++){const g=u[f].getAttribute("data-name"),m=u[f].getAttribute("href");if(g===d||m===a)return!0}return!1}function c(d,a,u,f){const w=document.createElement("link");w.setAttribute("rel","stylesheet"),w.setAttribute("type","text/css"),w.setAttribute("data-name",d),p(d,w,u,f),w.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(w)}function p(d,a,u,f){const w=()=>{a.removeEventListener("load",g),a.removeEventListener("error",m)},g=e=>{w(),u()},m=e=>{w(),f(e)};a.addEventListener("load",g),a.addEventListener("error",m)}}),se("vs/nls",["require","exports"],function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=f,t.localize2=w,t.getConfiguredDefaultLocale=g,t.setPseudoTranslation=m,t.create=e,t.load=L;let i=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const F="i-default";function M(E,N){let $;return N.length===0?$=E:$=E.replace(/\{(\d+)\}/g,(v,j)=>{const l=j[0],n=N[l];let s=v;return typeof n=="string"?s=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(s=String(n)),s}),i&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function c(E,N){let $=E[N];return $||($=E["*"],$)?$:null}function p(E){return E.charAt(E.length-1)==="/"?E:E+"/"}async function d(E,N,$){const v=p(E)+p(N)+"vscode/"+p($),j=await fetch(v);if(j.ok)return await j.json();throw new Error(`${j.status} - ${j.statusText}`)}function a(E){return function(N,$){const v=Array.prototype.slice.call(arguments,2);return M(E[N],v)}}function u(E){return(N,$,...v)=>({value:M(E[N],v),original:M($,v)})}function f(E,N,...$){return M(N,$)}function w(E,N,...$){const v=M(N,$);return{value:v,original:v}}function g(E){}function m(E){i=E}function e(E,N){return{localize:a(N[E]),localize2:u(N[E]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??($=>{})}}function L(E,N,$,v){const j=v["vs/nls"]??{};if(!E||E.length===0)return $({localize:f,localize2:w,getConfiguredDefaultLocale:()=>j.availableLanguages?.["*"]});const l=j.availableLanguages?c(j.availableLanguages,E):null,n=l===null||l===F;let s=".nls";n||(s=s+"."+l);const h=o=>{Array.isArray(o)?(o.localize=a(o),o.localize2=u(o)):(o.localize=a(o[E]),o.localize2=u(o[E])),o.getConfiguredDefaultLocale=()=>j.availableLanguages?.["*"],$(o)};typeof j.loadBundle=="function"?j.loadBundle(E,l,(o,b)=>{o?N([E+".nls"],h):h(b)}):j.translationServiceUrl&&!n?(async()=>{try{const o=await d(j.translationServiceUrl,l,E);return h(o)}catch(o){if(!l.includes("-"))return console.error(o),N([E+".nls"],h);try{const b=l.split("-")[0],A=await d(j.translationServiceUrl,b,E);return j.availableLanguages??={},j.availableLanguages["*"]=b,h(A)}catch(b){return console.error(b),N([E+".nls"],h)}}})():N([E+s],h,o=>{if(s===".nls"){console.error("Failed trying to load default language strings",o);return}console.error(`Failed to load message bundle for language ${l}. Falling back to the default language:`,o),N([E+".nls"],h)})}}),function(){const V=globalThis.MonacoEnvironment,t=V&&V.baseUrl?V.baseUrl:"../../../";function i(f,w){if(V?.createTrustedTypesPolicy)try{return V.createTrustedTypesPolicy(f,w)}catch(g){console.warn(g);return}try{return self.trustedTypes?.createPolicy(f,w)}catch(g){console.warn(g);return}}const F=i("amdLoader",{createScriptURL:f=>f,createScript:(f,...w)=>{const g=w.slice(0,-1).join(","),m=w.pop().toString();return`(function anonymous(${g}) { ${m}
})`}});function M(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function c(){return new Promise((f,w)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return f();const g=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,globalThis.origin.length)!==globalThis.origin)&&M()){fetch(g).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${g}`,(F?globalThis.eval(F.createScript("",e)):new Function(e)).call(globalThis),f()}).then(void 0,w);return}F?importScripts(F.createScriptURL(g)):importScripts(g),f()})}function p(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function d(f){c().then(()=>{p(),require([f],function(w){setTimeout(function(){const g=w.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>g.onmessage(m.data,m.ports);u.length>0;){const m=u.shift();g.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&p();let a=!0;const u=[];globalThis.onmessage=f=>{if(!a){u.push(f);return}a=!1,d(f.data)}}(),se(ue[9],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=F,t.$hb=M,t.$ib=c,t.$jb=p,t.$kb=d,t.$lb=a,t.$nb=f,t.$ob=w,t.$pb=g,t.$qb=m,t.$rb=e;function i(L,E){const N=F(L,E);if(N!==-1)return L[N]}function F(L,E,N=L.length-1){for(let $=N;$>=0;$--){const v=L[$];if(E(v))return $}return-1}function M(L,E){const N=c(L,E);return N===-1?void 0:L[N]}function c(L,E,N=0,$=L.length){let v=N,j=$;for(;v<j;){const l=Math.floor((v+j)/2);E(L[l])?v=l+1:j=l}return v-1}function p(L,E){const N=d(L,E);return N===L.length?void 0:L[N]}function d(L,E,N=0,$=L.length){let v=N,j=$;for(;v<j;){const l=Math.floor((v+j)/2);E(L[l])?j=l:v=l+1}return v}function a(L,E,N=0,$=L.length){const v=d(L,E,N,$);return v===L.length?-1:v}class u{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(u.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!E($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const N=c(this.e,E,this.c);return this.c=N+1,N===-1?void 0:this.e[N]}}t.$mb=u;function f(L,E){if(L.length===0)return;let N=L[0];for(let $=1;$<L.length;$++){const v=L[$];E(v,N)>0&&(N=v)}return N}function w(L,E){if(L.length===0)return;let N=L[0];for(let $=1;$<L.length;$++){const v=L[$];E(v,N)>=0&&(N=v)}return N}function g(L,E){return f(L,(N,$)=>-E(N,$))}function m(L,E){if(L.length===0)return-1;let N=0;for(let $=1;$<L.length;$++){const v=L[$];E(v,L[N])>0&&(N=$)}return N}function e(L,E){for(const N of L){const $=E(N);if($!==void 0)return $}}}),se(ue[35],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=F,t.$M=M,t.$N=c;function i(p,d){const a=Object.create(null);for(const u of p){const f=d(u);let w=a[f];w||(w=a[f]=[]),w.push(u)}return a}function F(p,d){const a=[],u=[];for(const f of p)d.has(f)||a.push(f);for(const f of d)p.has(f)||u.push(f);return{removed:a,added:u}}function M(p,d){const a=[],u=[];for(const[f,w]of p)d.has(f)||a.push(w);for(const[f,w]of d)p.has(f)||u.push(w);return{removed:a,added:u}}function c(p,d){const a=new Set;for(const u of d)p.has(u)&&a.add(u);return a}}),se(ue[36],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pt=t.$Ot=t.$Nt=t.$Mt=void 0;function i(d,a){const u=Math.pow(10,a);return Math.round(d*u)/u}class F{constructor(a,u,f,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=i(Math.max(Math.min(1,w),0),3)}static equals(a,u){return a.r===u.r&&a.g===u.g&&a.b===u.b&&a.a===u.a}}t.$Mt=F;class M{constructor(a,u,f,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.l=i(Math.max(Math.min(1,f),0),3),this.a=i(Math.max(Math.min(1,w),0),3)}static equals(a,u){return a.h===u.h&&a.s===u.s&&a.l===u.l&&a.a===u.a}static fromRGBA(a){const u=a.r/255,f=a.g/255,w=a.b/255,g=a.a,m=Math.max(u,f,w),e=Math.min(u,f,w);let L=0,E=0;const N=(e+m)/2,$=m-e;if($>0){switch(E=Math.min(N<=.5?$/(2*N):$/(2-2*N),1),m){case u:L=(f-w)/$+(f<w?6:0);break;case f:L=(w-u)/$+2;break;case w:L=(u-f)/$+4;break}L*=60,L=Math.round(L)}return new M(L,E,N,g)}static i(a,u,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?a+(u-a)*6*f:f<1/2?u:f<2/3?a+(u-a)*(2/3-f)*6:a}static toRGBA(a){const u=a.h/360,{s:f,l:w,a:g}=a;let m,e,L;if(f===0)m=e=L=w;else{const E=w<.5?w*(1+f):w+f-w*f,N=2*w-E;m=M.i(N,E,u+1/3),e=M.i(N,E,u),L=M.i(N,E,u-1/3)}return new F(Math.round(m*255),Math.round(e*255),Math.round(L*255),g)}}t.$Nt=M;class c{constructor(a,u,f,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.v=i(Math.max(Math.min(1,f),0),3),this.a=i(Math.max(Math.min(1,w),0),3)}static equals(a,u){return a.h===u.h&&a.s===u.s&&a.v===u.v&&a.a===u.a}static fromRGBA(a){const u=a.r/255,f=a.g/255,w=a.b/255,g=Math.max(u,f,w),m=Math.min(u,f,w),e=g-m,L=g===0?0:e/g;let E;return e===0?E=0:g===u?E=((f-w)/e%6+6)%6:g===f?E=(w-u)/e+2:E=(u-f)/e+4,new c(Math.round(E*60),L,g,a.a)}static toRGBA(a){const{h:u,s:f,v:w,a:g}=a,m=w*f,e=m*(1-Math.abs(u/60%2-1)),L=w-m;let[E,N,$]=[0,0,0];return u<60?(E=m,N=e):u<120?(E=e,N=m):u<180?(N=m,$=e):u<240?(N=e,$=m):u<300?(E=e,$=m):u<=360&&(E=m,$=e),E=Math.round((E+L)*255),N=Math.round((N+L)*255),$=Math.round(($+L)*255),new F(E,N,$,g)}}t.$Ot=c;class p{static fromHex(a){return p.Format.CSS.parseHex(a)||p.red}static equals(a,u){return!a&&!u?!0:!a||!u?!1:a.equals(u)}get hsla(){return this.i?this.i:M.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:c.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof F)this.rgba=a;else if(a instanceof M)this.i=a,this.rgba=M.toRGBA(a);else if(a instanceof c)this.j=a,this.rgba=c.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&F.equals(this.rgba,a.rgba)&&M.equals(this.hsla,a.hsla)&&c.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=p.k(this.rgba.r),u=p.k(this.rgba.g),f=p.k(this.rgba.b),w=.2126*a+.7152*u+.0722*f;return i(w,4)}static k(a){const u=a/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(a){const u=this.getRelativeLuminance(),f=a.getRelativeLuminance();return u>f?(u+.05)/(f+.05):(f+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const u=this.getRelativeLuminance(),f=a.getRelativeLuminance();return u>f}isDarkerThan(a){const u=this.getRelativeLuminance(),f=a.getRelativeLuminance();return u<f}lighten(a){return new p(new M(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new p(new M(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:u,g:f,b:w,a:g}=this.rgba;return new p(new F(u,f,w,g*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new p(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const u=a.rgba,f=this.rgba.a,w=u.a,g=f+w*(1-f);if(g<1e-6)return p.transparent;const m=this.rgba.r*f/g+u.r*w*(1-f)/g,e=this.rgba.g*f/g+u.g*w*(1-f)/g,L=this.rgba.b*f/g+u.b*w*(1-f)/g;return new p(new F(m,e,L,g))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:u,g:f,b:w,a:g}=this.rgba;return new p(new F(a.rgba.r-g*(a.rgba.r-u),a.rgba.g-g*(a.rgba.g-f),a.rgba.b-g*(a.rgba.b-w),1))}flatten(...a){const u=a.reduceRight((f,w)=>p.o(w,f));return p.o(this,u)}static o(a,u){const f=1-a.rgba.a;return new p(new F(f*u.rgba.r+a.rgba.a*a.rgba.r,f*u.rgba.g+a.rgba.a*a.rgba.g,f*u.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=p.Format.CSS.format(this)),this.u}static getLighterColor(a,u,f){if(a.isLighterThan(u))return a;f=f||.5;const w=a.getRelativeLuminance(),g=u.getRelativeLuminance();return f=f*(g-w)/g,a.lighten(f)}static getDarkerColor(a,u,f){if(a.isDarkerThan(u))return a;f=f||.5;const w=a.getRelativeLuminance(),g=u.getRelativeLuminance();return f=f*(w-g)/w,a.darken(f)}static{this.white=new p(new F(255,255,255,1))}static{this.black=new p(new F(0,0,0,1))}static{this.red=new p(new F(255,0,0,1))}static{this.blue=new p(new F(0,0,255,1))}static{this.green=new p(new F(0,255,0,1))}static{this.cyan=new p(new F(0,255,255,1))}static{this.lightgrey=new p(new F(211,211,211,1))}static{this.transparent=new p(new F(0,0,0,0))}}t.$Pt=p,function(d){let a;(function(u){let f;(function(w){function g(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:d.Format.CSS.formatRGBA(n)}w.formatRGB=g;function m(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}w.formatRGBA=m;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:d.Format.CSS.formatHSLA(n)}w.formatHSL=e;function L(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}w.formatHSLA=L;function E(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function N(n){return`#${E(n.rgba.r)}${E(n.rgba.g)}${E(n.rgba.b)}`}w.formatHex=N;function $(n,s=!1){return s&&n.rgba.a===1?d.Format.CSS.formatHex(n):`#${E(n.rgba.r)}${E(n.rgba.g)}${E(n.rgba.b)}${E(Math.round(n.rgba.a*255))}`}w.formatHexA=$;function v(n){return n.isOpaque()?d.Format.CSS.formatHex(n):d.Format.CSS.formatRGBA(n)}w.format=v;function j(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const h=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),o=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),b=16*l(n.charCodeAt(5))+l(n.charCodeAt(6));return new d(new F(h,o,b,1))}if(s===9){const h=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),o=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),b=16*l(n.charCodeAt(5))+l(n.charCodeAt(6)),A=16*l(n.charCodeAt(7))+l(n.charCodeAt(8));return new d(new F(h,o,b,A/255))}if(s===4){const h=l(n.charCodeAt(1)),o=l(n.charCodeAt(2)),b=l(n.charCodeAt(3));return new d(new F(16*h+h,16*o+o,16*b+b))}if(s===5){const h=l(n.charCodeAt(1)),o=l(n.charCodeAt(2)),b=l(n.charCodeAt(3)),A=l(n.charCodeAt(4));return new d(new F(16*h+h,16*o+o,16*b+b,(16*A+A)/255))}return null}w.parseHex=j;function l(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=u.CSS||(u.CSS={}))})(a=d.Format||(d.Format={}))}(p||(t.$Pt=p={}))}),se(ue[37],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xt=void 0;class i{constructor(M,c,p,d){this.originalStart=M,this.originalLength=c,this.modifiedStart=p,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$xt=i}),se(ue[3],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=F,t.$Z=M,t.$1=c,t.$2=p,t.$3=d,t.$4=u,t.$6=w,t.$7=g,t.$8=m,t.$0=L;class i{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?v.isErrorNoTelemetry(n)?new v(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$W=i,t.$X=new i;function F(l){t.$X.setUnexpectedErrorHandler(l)}function M(l){if(!l||typeof l!="object")return!1;const n=l;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function c(l){u(l)||t.$X.onUnexpectedError(l)}function p(l){u(l)||t.$X.onUnexpectedExternalError(l)}function d(l){if(l instanceof Error){const{name:n,message:s}=l,h=l.stacktrace||l.stack;return{$isError:!0,name:n,message:s,stack:h,noTelemetry:v.isErrorNoTelemetry(l)}}return l}const a="Canceled";function u(l){return l instanceof f?!0:l instanceof Error&&l.name===a&&l.message===a}class f extends Error{constructor(){super(a),this.name=this.message}}t.$5=f;function w(){const l=new Error(a);return l.name=l.message,l}function g(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function L(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class E extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$$=E;class N extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$_=N;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class v extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof v)return n;const s=new v;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$bb=v;class j extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,j.prototype)}}t.$cb=j}),se(ue[6],ae([0,1,3,9]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=M,t.$tb=c,t.$ub=p,t.$vb=d,t.$wb=a,t.$xb=u,t.$yb=f,t.$zb=w,t.$Ab=g,t.$Bb=m,t.$Cb=e,t.$Db=L,t.$Eb=E,t.top=N,t.$Gb=$,t.$Hb=j,t.$Ib=l,t.$Jb=n,t.$Kb=s,t.$Lb=h,t.$Mb=o,t.$Nb=b,t.$Ob=A,t.$Pb=R,t.$Qb=y,t.$Rb=P,t.$Sb=T,t.$Tb=I,t.$Ub=Q,t.$Vb=x,t.$Wb=S,t.$Xb=C,t.$Yb=Y,t.$Zb=Z,t.$1b=H,t.$2b=G,t.$3b=K,t.$4b=ee,t.$5b=k,t.$6b=X,t.$7b=ve,t.$8b=r,t.$$b=qe;function M(B,W=0){return B[B.length-(1+W)]}function c(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function p(B,W,O=(J,te)=>J===te){if(B===W)return!0;if(!B||!W||B.length!==W.length)return!1;for(let J=0,te=B.length;J<te;J++)if(!O(B[J],W[J]))return!1;return!0}function d(B,W){const O=B.length-1;W<O&&(B[W]=B[O]),B.pop()}function a(B,W,O){return u(B.length,J=>O(B[J],W))}function u(B,W){let O=0,J=B-1;for(;O<=J;){const te=(O+J)/2|0,he=W(te);if(he<0)O=te+1;else if(he>0)J=te-1;else return te}return-(O+1)}function f(B,W,O){if(B=B|0,B>=W.length)throw new TypeError("invalid index");const J=W[Math.floor(W.length*Math.random())],te=[],he=[],me=[];for(const re of W){const U=O(re,J);U<0?te.push(re):U>0?he.push(re):me.push(re)}return B<te.length?f(B,te,O):B<te.length+me.length?me[0]:f(B-(te.length+me.length),he,O)}function w(B,W){const O=[];let J;for(const te of B.slice(0).sort(W))!J||W(J[0],te)!==0?(J=[te],O.push(J)):J.push(te);return O}function*g(B,W){let O,J;for(const te of B)J!==void 0&&W(J,te)?O.push(te):(O&&(yield O),O=[te]),J=te;O&&(yield O)}function m(B,W){for(let O=0;O<=B.length;O++)W(O===0?void 0:B[O-1],O===B.length?void 0:B[O])}function e(B,W){for(let O=0;O<B.length;O++)W(O===0?void 0:B[O-1],B[O],O+1===B.length?void 0:B[O+1])}function L(B,W,O){const J=[];function te(re,U,ie){if(U===0&&ie.length===0)return;const ne=J[J.length-1];ne&&ne.start+ne.deleteCount===re?(ne.deleteCount+=U,ne.toInsert.push(...ie)):J.push({start:re,deleteCount:U,toInsert:ie})}let he=0,me=0;for(;;){if(he===B.length){te(he,0,W.slice(me));break}if(me===W.length){te(he,B.length-he,[]);break}const re=B[he],U=W[me],ie=O(re,U);ie===0?(he+=1,me+=1):ie<0?(te(he,1,[]),he+=1):ie>0&&(te(he,0,[U]),me+=1)}return J}function E(B,W,O){const J=L(B,W,O),te=[],he=[];for(const me of J)te.push(...B.slice(me.start,me.start+me.deleteCount)),he.push(...me.toInsert);return{removed:te,added:he}}function N(B,W,O){if(O===0)return[];const J=B.slice(0,O).sort(W);return v(B,W,J,O,B.length),J}function $(B,W,O,J,te){return O===0?Promise.resolve([]):new Promise((he,me)=>{(async()=>{const re=B.length,U=B.slice(0,O).sort(W);for(let ie=O,ne=Math.min(O+J,re);ie<re;ie=ne,ne=Math.min(ne+J,re)){if(ie>O&&await new Promise(oe=>setTimeout(oe)),te&&te.isCancellationRequested)throw new i.$5;v(B,W,U,ie,ne)}return U})().then(he,me)})}function v(B,W,O,J,te){for(const he=O.length;J<te;J++){const me=B[J];if(W(me,O[he-1])<0){O.pop();const re=(0,F.$kb)(O,U=>W(me,U)<0);O.splice(re,0,me)}}}function j(B){return B.filter(W=>!!W)}function l(B){let W=0;for(let O=0;O<B.length;O++)B[O]&&(B[W]=B[O],W+=1);B.length=W}function n(B,W,O){B.splice(O,0,B.splice(W,1)[0])}function s(B){return!Array.isArray(B)||B.length===0}function h(B){return Array.isArray(B)&&B.length>0}function o(B,W=O=>O){const O=new Set;return B.filter(J=>{const te=W(J);return O.has(te)?!1:(O.add(te),!0)})}function b(B){const W=new Set;return O=>{const J=B(O);return W.has(J)?!1:(W.add(J),!0)}}function A(B,W){return B.length>0?B[0]:W}function R(B,W){return B.length>0?B[B.length-1]:W}function y(B,W,O=(J,te)=>J===te){let J=0;for(let te=0,he=Math.min(B.length,W.length);te<he&&O(B[te],W[te]);te++)J++;return J}function P(B){return[].concat(...B)}function T(B,W){let O=typeof W=="number"?B:0;typeof W=="number"?O=B:(O=0,W=B);const J=[];if(O<=W)for(let te=O;te<W;te++)J.push(te);else for(let te=O;te>W;te--)J.push(te);return J}function I(B,W,O){return B.reduce((J,te)=>(J[W(te)]=O?O(te):te,J),Object.create(null))}function Q(B,W){return B.push(W),()=>x(B,W)}function x(B,W){const O=B.indexOf(W);if(O>-1)return B.splice(O,1),W}function S(B,W,O){const J=B.slice(0,W),te=B.slice(W);return J.concat(O,te)}function C(B,W){let O;if(typeof W=="number"){let J=W;O=()=>{const te=Math.sin(J++)*179426549;return te-Math.floor(te)}}else O=Math.random;for(let J=B.length-1;J>0;J-=1){const te=Math.floor(O()*(J+1)),he=B[J];B[J]=B[te],B[te]=he}}function Y(B,W){const O=B.indexOf(W);O>-1&&(B.splice(O,1),B.unshift(W))}function Z(B,W){const O=B.indexOf(W);O>-1&&(B.splice(O,1),B.push(W))}function H(B,W){for(const O of W)B.push(O)}function G(B,W){return Array.isArray(B)?B.map(W):W(B)}function K(B){return Array.isArray(B)?B:[B]}function ee(B){return B[Math.floor(Math.random()*B.length)]}function k(B,W,O){const J=de(B,W),te=B.length,he=O.length;B.length=te+he;for(let me=te-1;me>=J;me--)B[me+he]=B[me];for(let me=0;me<he;me++)B[me+J]=O[me]}function X(B,W,O,J){const te=de(B,W);let he=B.splice(te,O);return he===void 0&&(he=[]),k(B,te,J),he}function de(B,W){return W<0?Math.max(W+B.length,0):Math.min(W,B.length)}var fe;(function(B){function W(he){return he<0}B.isLessThan=W;function O(he){return he<=0}B.isLessThanOrEqual=O;function J(he){return he>0}B.isGreaterThan=J;function te(he){return he===0}B.isNeitherLessOrGreaterThan=te,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(fe||(t.CompareResult=fe={}));function ve(B,W){return(O,J)=>W(B(O),B(J))}function r(...B){return(W,O)=>{for(const J of B){const te=J(W,O);if(!fe.isNeitherLessOrGreaterThan(te))return te}return fe.neitherLessOrGreaterThan}}const je=(B,W)=>B-W;t.$9b=je;const Ae=(B,W)=>(0,t.$9b)(B?1:0,W?1:0);t.$0b=Ae;function qe(B){return(W,O)=>-B(W,O)}class De{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let O=this.c;for(;O<this.g.length&&W(this.g[O]);)O++;const J=O===this.c?null:this.g.slice(this.c,O);return this.c=O,J}takeFromEndWhile(W){let O=this.d;for(;O>=0&&W(this.g[O]);)O--;const J=O===this.d?null:this.g.slice(O+1,this.d+1);return this.d=O,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const O=this.g.slice(this.c,this.c+W);return this.c+=W,O}}t.$_b=De;class Fe{static{this.empty=new Fe(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(O=>(W(O),!0))}toArray(){const W=[];return this.iterate(O=>(W.push(O),!0)),W}filter(W){return new Fe(O=>this.iterate(J=>W(J)?O(J):!0))}map(W){return new Fe(O=>this.iterate(J=>O(W(J))))}some(W){let O=!1;return this.iterate(J=>(O=W(J),!O)),O}findFirst(W){let O;return this.iterate(J=>W(J)?(O=J,!1):!0),O}findLast(W){let O;return this.iterate(J=>(W(J)&&(O=J),!0)),O}findLastMaxBy(W){let O,J=!0;return this.iterate(te=>((J||fe.isGreaterThan(W(te,O)))&&(J=!1,O=te),!0)),O}}t.$ac=Fe;class Te{constructor(W){this.c=W}static createSortPermutation(W,O){const J=Array.from(W.keys()).sort((te,he)=>O(W[te],W[he]));return new Te(J)}apply(W){return W.map((O,J)=>W[this.c[J]])}inverse(){const W=this.c.slice();for(let O=0;O<this.c.length;O++)W[this.c[O]]=O;return new Te(W)}}t.$bc=Te}),se(ue[13],ae([0,1,3]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=F,t.$fd=M,t.$gd=c,t.$hd=p,t.$id=d,t.$jd=a;function F(u,f){if(!u)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function M(u,f="Unreachable"){throw new Error(f)}function c(u){if(!u)throw new i.$cb("Assertion Failed")}function p(u){u||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function d(u){if(!u()){debugger;u(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function a(u,f){let w=0;for(;w<u.length-1;){const g=u[w],m=u[w+1];if(!f(g,m))return!1;w++}return!0}}),se(ue[20],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(F,M){const c=this;let p=!1,d;return function(){if(p)return d;if(p=!0,M)try{d=F.apply(c,arguments)}finally{M()}else d=F.apply(c,arguments);return d}}}),se(ue[21],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(F){function M(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}F.is=M;const c=Object.freeze([]);function p(){return c}F.empty=p;function*d(n){yield n}F.single=d;function a(n){return M(n)?n:d(n)}F.wrap=a;function u(n){return n||c}F.from=u;function*f(n){for(let s=n.length-1;s>=0;s--)yield n[s]}F.reverse=f;function w(n){return!n||n[Symbol.iterator]().next().done===!0}F.isEmpty=w;function g(n){return n[Symbol.iterator]().next().value}F.first=g;function m(n,s){for(const h of n)if(s(h))return!0;return!1}F.some=m;function e(n,s){for(const h of n)if(s(h))return h}F.find=e;function*L(n,s){for(const h of n)s(h)&&(yield h)}F.filter=L;function*E(n,s){let h=0;for(const o of n)yield s(o,h++)}F.map=E;function*N(...n){for(const s of n)yield*s}F.concat=N;function $(n,s,h){let o=h;for(const b of n)o=s(o,b);return o}F.reduce=$;function*v(n,s,h=n.length){for(s<0&&(s+=n.length),h<0?h+=n.length:h>n.length&&(h=n.length);s<h;s++)yield n[s]}F.slice=v;function j(n,s=Number.POSITIVE_INFINITY){const h=[];if(s===0)return[h,n];const o=n[Symbol.iterator]();for(let b=0;b<s;b++){const A=o.next();if(A.done)return[h,F.empty()];h.push(A.value)}return[h,{[Symbol.iterator](){return o}}]}F.consume=j;async function l(n){const s=[];for await(const h of n)s.push(h);return Promise.resolve(s)}F.asyncToArray=l})(i||(t.Iterable=i={}))}),se(ue[38],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Dr=t.$Cr=t.$Br=t.$Ar=t.$zr=t.ScanCode=t.KeyCode=void 0,t.$Er=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(L,E){this._keyCodeToStr[L]=E,this._strToKeyCode[E.toLowerCase()]=L}keyCodeToStr(L){return this._keyCodeToStr[L]}strToKeyCode(L){return this._strToKeyCode[L.toLowerCase()]||0}}const c=new M,p=new M,d=new M;t.$zr=new Array(230),t.$Ar={};const a=[],u=Object.create(null),f=Object.create(null);t.$Br={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>u[e]||0,toString:e=>a[e]||"None"},t.$Cr=[],t.$Dr=[];for(let e=0;e<=193;e++)t.$Cr[e]=-1;for(let e=0;e<=132;e++)t.$Dr[e]=-1;(function(){const e="",L=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],E=[],N=[];for(const $ of L){const[v,j,l,n,s,h,o,b,A]=$;if(N[j]||(N[j]=!0,a[j]=l,u[l]=j,f[l.toLowerCase()]=j,v&&(t.$Cr[j]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.$Dr[n]=j))),!E[n]){if(E[n]=!0,!s)throw new Error(`String representation missing for key code ${n} around scan code ${l}`);c.define(n,s),p.define(n,b||s),d.define(n,A||b||s)}h&&(t.$zr[h]=n),o&&(t.$Ar[o]=n)}t.$Dr[3]=46})();var w;(function(e){function L(l){return c.keyCodeToStr(l)}e.toString=L;function E(l){return c.strToKeyCode(l)}e.fromString=E;function N(l){return p.keyCodeToStr(l)}e.toUserSettingsUS=N;function $(l){return d.keyCodeToStr(l)}e.toUserSettingsGeneral=$;function v(l){return p.strToKeyCode(l)||d.strToKeyCode(l)}e.fromUserSettings=v;function j(l){if(l>=98&&l<=113)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return c.keyCodeToStr(l)}e.toElectronAccelerator=j})(w||(t.KeyCodeUtils=w={}));var g;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(g||(t.KeyMod=g={}));function m(e,L){const E=(L&65535)<<16>>>0;return(e|E)>>>0}}),se(ue[39],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(M){this.d=M,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(M){this.c=M}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),se(ue[22],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(c){this.element=c,this.next=i.Undefined,this.prev=i.Undefined}}class F{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let c=this.a;for(;c!==i.Undefined;){const p=c.next;c.prev=i.Undefined,c.next=i.Undefined,c=p}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(c){return this.d(c,!1)}push(c){return this.d(c,!0)}d(c,p){const d=new i(c);if(this.a===i.Undefined)this.a=d,this.b=d;else if(p){const u=this.b;this.b=d,d.prev=u,u.next=d}else{const u=this.a;this.a=d,d.next=u,u.prev=d}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(d))}}shift(){if(this.a!==i.Undefined){const c=this.a.element;return this.e(this.a),c}}pop(){if(this.b!==i.Undefined){const c=this.b.element;return this.e(this.b),c}}e(c){if(c.prev!==i.Undefined&&c.next!==i.Undefined){const p=c.prev;p.next=c.next,c.next.prev=p}else c.prev===i.Undefined&&c.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):c.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):c.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let c=this.a;for(;c!==i.Undefined;)yield c.element,c=c.next}}t.$6c=F}),se(ue[14],ae([0,1]),function(V,t){"use strict";var i,F,M;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=c,t.$zc=p,t.$Ac=d,t.$Jc=j;function c(l,n,s){let h=l.get(n);return h===void 0&&(h=s,l.set(n,h)),h}function p(l){const n=[];return l.forEach((s,h)=>{n.push(`${h} => ${s}`)}),`Map(${l.size}) {${n.join(", ")}}`}function d(l){const n=[];return l.forEach(s=>{n.push(s)}),`Set(${l.size}) {${n.join(", ")}}`}class a{constructor(n,s){this.uri=n,this.value=s}}function u(l){return Array.isArray(l)}class f{static{this.c=n=>n.toString()}constructor(n,s){if(this[i]="ResourceMap",n instanceof f)this.d=new Map(n.d),this.e=s??f.c;else if(u(n)){this.d=new Map,this.e=s??f.c;for(const[h,o]of n)this.set(h,o)}else this.d=new Map,this.e=n??f.c}set(n,s){return this.d.set(this.e(n),new a(n,s)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[h,o]of this.d)n(o.value,o.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}t.$Bc=f;class w{constructor(n,s){this[F]="ResourceSet",!n||typeof n=="function"?this.c=new f(n):(this.c=new f(s),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,s){this.c.forEach((h,o)=>n.call(s,o,o,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=w;var g;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(g||(t.Touch=g={}));class m{constructor(){this[M]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,s=0){const h=this.c.get(n);if(h)return s!==0&&this.m(h,s),h.value}set(n,s,h=0){let o=this.c.get(n);if(o)o.value=s,h!==0&&this.m(o,h);else{switch(o={key:n,value:s,next:void 0,previous:void 0},h){case 0:this.k(o);break;case 1:this.j(o);break;case 2:this.k(o);break;default:this.k(o);break}this.c.set(n,o),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this.c.get(n);if(s)return this.c.delete(n),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,s){const h=this.g;let o=this.d;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this.g!==h)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this.g;let h=this.d;const o={[Symbol.iterator](){return o},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const b={value:h.key,done:!1};return h=h.next,b}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this.g;let h=this.d;const o={[Symbol.iterator](){return o},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const b={value:h.value,done:!1};return h=h.next,b}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this.g;let h=this.d;const o={[Symbol.iterator](){return o},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const b={value:[h.key,h.value],done:!1};return h=h.next,b}else return{value:void 0,done:!0}}};return o}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.d,h=this.size;for(;s&&h>n;)this.c.delete(s.key),s=s.next,h--;this.d=s,this.f=h,s&&(s.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.e,h=this.size;for(;s&&h>n;)this.c.delete(s.key),s=s.previous,h--;this.e=s,this.f=h,s&&(s.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const s=n.next,h=n.previous;if(!s||!h)throw new Error("Invalid list");s.previous=h,h.next=s}n.next=void 0,n.previous=void 0,this.g++}m(n,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this.d)return;const h=n.next,o=n.previous;n===this.e?(o.next=void 0,this.e=o):(h.previous=o,o.next=h),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(s===2){if(n===this.e)return;const h=n.next,o=n.previous;n===this.d?(h.previous=void 0,this.d=h):(h.previous=o,o.next=h),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((s,h)=>{n.push([h,s])}),n}fromJSON(n){this.clear();for(const[s,h]of n)this.set(s,h)}}t.$Dc=m;class e extends m{constructor(n,s=1){super(),this.n=n,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class L extends e{constructor(n,s=1){super(n,s)}q(n){this.h(n)}set(n,s){return super.set(n,s),this.p(),this}}t.$Ec=L;class E extends e{constructor(n,s=1){super(n,s)}q(n){this.i(n)}set(n,s){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,s),this}}t.$Fc=E;class N{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let s=this.c.get(n)||0;return s===0?!1:(s--,s===0?this.c.delete(n):this.c.set(n,s),!0)}has(n){return this.c.has(n)}}t.$Gc=N;class ${constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[s,h]of n)this.set(s,h)}clear(){this.c.clear(),this.d.clear()}set(n,s){this.c.set(n,s),this.d.set(s,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const s=this.c.get(n);return s===void 0?!1:(this.c.delete(n),this.d.delete(s),!0)}forEach(n,s){this.c.forEach((h,o)=>{n.call(s,h,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Hc=$;class v{constructor(){this.c=new Map}add(n,s){let h=this.c.get(n);h||(h=new Set,this.c.set(n,h)),h.add(s)}delete(n,s){const h=this.c.get(n);h&&(h.delete(s),h.size===0&&this.c.delete(n))}forEach(n,s){const h=this.c.get(n);h&&h.forEach(s)}get(n){const s=this.c.get(n);return s||new Set}}t.$Ic=v;function j(l,n){if(l===n)return!0;if(l.size!==n.size)return!1;for(const[s,h]of l)if(!n.has(s)||n.get(s)!==h)return!1;for(const[s]of n)if(!l.has(s))return!1;return!0}}),se(ue[10],ae([0,1,6,35,14,20,21]),function(V,t,i,F,M,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Kc=void 0,t.$Lc=f,t.$Mc=w,t.$Nc=g,t.$Oc=L,t.$Pc=E,t.$Qc=N,t.$Rc=$,t.$Sc=v,t.$Tc=j,t.$4c=P;const d=!1;let a=null;class u{constructor(){this.b=new Map}static{this.a=0}c(Q){let x=this.b.get(Q);return x||(x={parent:null,source:null,isSingleton:!1,value:Q,idx:u.a++},this.b.set(Q,x)),x}trackDisposable(Q){const x=this.c(Q);x.source||(x.source=new Error().stack)}setParent(Q,x){const S=this.c(Q);S.parent=x}markAsDisposed(Q){this.b.delete(Q)}markAsSingleton(Q){this.c(Q).isSingleton=!0}f(Q,x){const S=x.get(Q);if(S)return S;const C=Q.parent?this.f(this.c(Q.parent),x):Q;return x.set(Q,C),C}getTrackedDisposables(){const Q=new Map;return[...this.b.entries()].filter(([,S])=>S.source!==null&&!this.f(S,Q).isSingleton).flatMap(([S])=>S)}computeLeakingDisposables(Q=10,x){let S;if(x)S=x;else{const G=new Map,K=[...this.b.values()].filter(k=>k.source!==null&&!this.f(k,G).isSingleton);if(K.length===0)return;const ee=new Set(K.map(k=>k.value));if(S=K.filter(k=>!(k.parent&&ee.has(k.parent))),S.length===0)throw new Error("There are cyclic diposable chains!")}if(!S)return;function C(G){function K(k,X){for(;k.length>0&&X.some(de=>typeof de=="string"?de===k[0]:k[0].match(de));)k.shift()}const ee=G.source.split(`
`).map(k=>k.trim().replace("at ","")).filter(k=>k!=="");return K(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const Y=new M.$Ic;for(const G of S){const K=C(G);for(let ee=0;ee<=K.length;ee++)Y.add(K.slice(0,ee).join(`
`),G)}S.sort((0,i.$7b)(G=>G.idx,i.$9b));let Z="",H=0;for(const G of S.slice(0,Q)){H++;const K=C(G),ee=[];for(let k=0;k<K.length;k++){let X=K[k];X=`(shared with ${Y.get(K.slice(0,k+1).join(`
`)).size}/${S.length} leaks) at ${X}`;const fe=Y.get(K.slice(0,k).join(`
`)),ve=(0,F.$K)([...fe].map(r=>C(r)[k]),r=>r);delete ve[K[k]];for(const[r,je]of Object.entries(ve))ee.unshift(`    - stacktraces of ${je.length} other leaks continue with ${r}`);ee.unshift(X)}Z+=`


==================== Leaking disposable ${H}/${S.length}: ${G.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return S.length>Q&&(Z+=`


... and ${S.length-Q} more leaking disposables

`),{leaks:S,details:Z}}}t.$Kc=u;function f(I){a=I}if(d){const I="__is_disposable_tracked__";f(new class{trackDisposable(Q){const x=new Error("Potentially leaked disposable").stack;setTimeout(()=>{Q[I]||console.log(x)},3e3)}setParent(Q,x){if(Q&&Q!==n.None)try{Q[I]=!0}catch{}}markAsDisposed(Q){if(Q&&Q!==n.None)try{Q[I]=!0}catch{}}markAsSingleton(Q){}})}function w(I){return a?.trackDisposable(I),I}function g(I){a?.markAsDisposed(I)}function m(I,Q){a?.setParent(I,Q)}function e(I,Q){if(a)for(const x of I)a.setParent(x,Q)}function L(I){return a?.markAsSingleton(I),I}function E(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function N(I){if(p.Iterable.is(I)){const Q=[];for(const x of I)if(x)try{x.dispose()}catch(S){Q.push(S)}if(Q.length===1)throw Q[0];if(Q.length>1)throw new AggregateError(Q,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function $(I){for(const Q of I)E(Q)&&Q.dispose();return[]}function v(...I){const Q=j(()=>N(I));return e(I,Q),Q}function j(I){const Q=w({dispose:(0,c.$db)(()=>{g(Q),I()})});return Q}class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{N(this.f)}finally{this.f.clear()}}add(Q){if(!Q)return Q;if(Q===this)throw new Error("Cannot register a disposable on itself!");return m(Q,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(Q),Q}delete(Q){if(Q){if(Q===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(Q),Q.dispose()}}deleteAndLeak(Q){Q&&this.f.has(Q)&&(this.f.delete(Q),m(Q,null))}}t.$Uc=l;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,w(this),m(this.q,this)}dispose(){g(this),this.q.dispose()}B(Q){if(Q===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(Q)}}t.$Vc=n;class s{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(Q){this.b||Q===this.a||(this.a?.dispose(),Q&&m(Q,this),this.a=Q)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const Q=this.a;return this.a=void 0,Q&&m(Q,null),Q}}t.$Wc=s;class h{constructor(Q){this.a=new s,this.b=!1,this.a.value=Q}get value(){return this.a.value}set value(Q){this.b||Q===this.a.value||(this.a.value=Q)}dispose(){this.b=!0,this.a.dispose()}}t.$Xc=h;class o{constructor(Q){this.b=Q,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Yc=o;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(Q){let x=Q;return this.unset=()=>x=void 0,this.isset=()=>x!==void 0,this.dispose=()=>{x&&(x(),x=void 0,g(this))},this}}t.$Zc=b;class A{constructor(){this.a=new Map}acquire(Q,...x){let S=this.a.get(Q);S||(S={counter:0,object:this.b(Q,...x)},this.a.set(Q,S));const{object:C}=S,Y=(0,c.$db)(()=>{--S.counter===0&&(this.c(Q,S.object),this.a.delete(Q))});return S.counter++,{object:C,dispose:Y}}}t.$1c=A;class R{constructor(Q){this.a=Q}async acquire(Q,...x){const S=this.a.acquire(Q,...x);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(C){throw S.dispose(),C}}}t.$2c=R;class y{constructor(Q){this.object=Q}dispose(){}}t.$3c=y;function P(I){const Q=new l;try{I(Q)}finally{Q.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{N(this.a.values())}finally{this.a.clear()}}has(Q){return this.a.has(Q)}get size(){return this.a.size}get(Q){return this.a.get(Q)}set(Q,x,S=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),S||this.a.get(Q)?.dispose(),this.a.set(Q,x)}deleteAndDispose(Q){this.a.get(Q)?.dispose(),this.a.delete(Q)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$5c=T}),se(ue[23],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ae=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(c){return new F(c)}constructor(c){this.c=i&&c===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ae=F}),se(ue[11],ae([0,1,3,20,10,22,23]),function(V,t,i,F,M,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$ce=t.Event=void 0,t.$de=m;const d=!1,a=!1,u=!1;var f;(function(x){x.None=()=>M.$Vc.None;function S(re){if(u){const{onDidAddListener:U}=re,ie=L.create();let ne=0;re.onDidAddListener=()=>{++ne===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),U?.()}}}function C(re,U){return fe(re,()=>{},0,void 0,!0,void 0,U)}x.defer=C;function Y(re){return(U,ie=null,ne)=>{let oe=!1,ce;return ce=re(be=>{if(!oe)return ce?ce.dispose():oe=!0,U.call(ie,be)},null,ne),oe&&ce.dispose(),ce}}x.once=Y;function Z(re,U,ie){return X((ne,oe=null,ce)=>re(be=>ne.call(oe,U(be)),null,ce),ie)}x.map=Z;function H(re,U,ie){return X((ne,oe=null,ce)=>re(be=>{U(be),ne.call(oe,be)},null,ce),ie)}x.forEach=H;function G(re,U,ie){return X((ne,oe=null,ce)=>re(be=>U(be)&&ne.call(oe,be),null,ce),ie)}x.filter=G;function K(re){return re}x.signal=K;function ee(...re){return(U,ie=null,ne)=>{const oe=(0,M.$Sc)(...re.map(ce=>ce(be=>U.call(ie,be))));return de(oe,ne)}}x.any=ee;function k(re,U,ie,ne){let oe=ie;return Z(re,ce=>(oe=U(oe,ce),oe),ne)}x.reduce=k;function X(re,U){let ie;const ne={onWillAddFirstListener(){ie=re(oe.fire,oe)},onDidRemoveLastListener(){ie?.dispose()}};U||S(ne);const oe=new l(ne);return U?.add(oe),oe.event}function de(re,U){return U instanceof Array?U.push(re):U&&U.add(re),re}function fe(re,U,ie=100,ne=!1,oe=!1,ce,be){let we,Le,ke,Ee=0,Se;const Ve={leakWarningThreshold:ce,onWillAddFirstListener(){we=re(Ce=>{Ee++,Le=U(Le,Ce),ne&&!ke&&(Ie.fire(Le),Le=void 0),Se=()=>{const Oe=Le;Le=void 0,ke=void 0,(!ne||Ee>1)&&Ie.fire(Oe),Ee=0},typeof ie=="number"?(clearTimeout(ke),ke=setTimeout(Se,ie)):ke===void 0&&(ke=0,queueMicrotask(Se))})},onWillRemoveListener(){oe&&Ee>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,we.dispose()}};be||S(Ve);const Ie=new l(Ve);return be?.add(Ie),Ie.event}x.debounce=fe;function ve(re,U=0,ie){return x.debounce(re,(ne,oe)=>ne?(ne.push(oe),ne):[oe],U,void 0,!0,void 0,ie)}x.accumulate=ve;function r(re,U=(ne,oe)=>ne===oe,ie){let ne=!0,oe;return G(re,ce=>{const be=ne||!U(ce,oe);return ne=!1,oe=ce,be},ie)}x.latch=r;function je(re,U,ie){return[x.filter(re,U,ie),x.filter(re,ne=>!U(ne),ie)]}x.split=je;function Ae(re,U=!1,ie=[],ne){let oe=ie.slice(),ce=re(Le=>{oe?oe.push(Le):we.fire(Le)});ne&&ne.add(ce);const be=()=>{oe?.forEach(Le=>we.fire(Le)),oe=null},we=new l({onWillAddFirstListener(){ce||(ce=re(Le=>we.fire(Le)),ne&&ne.add(ce))},onDidAddFirstListener(){oe&&(U?setTimeout(be):be())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return ne&&ne.add(we),we.event}x.buffer=Ae;function qe(re,U){return(ne,oe,ce)=>{const be=U(new Fe);return re(function(we){const Le=be.evaluate(we);Le!==De&&ne.call(oe,Le)},void 0,ce)}}x.chain=qe;const De=Symbol("HaltChainable");class Fe{constructor(){this.f=[]}map(U){return this.f.push(U),this}forEach(U){return this.f.push(ie=>(U(ie),ie)),this}filter(U){return this.f.push(ie=>U(ie)?ie:De),this}reduce(U,ie){let ne=ie;return this.f.push(oe=>(ne=U(ne,oe),ne)),this}latch(U=(ie,ne)=>ie===ne){let ie=!0,ne;return this.f.push(oe=>{const ce=ie||!U(oe,ne);return ie=!1,ne=oe,ce?oe:De}),this}evaluate(U){for(const ie of this.f)if(U=ie(U),U===De)break;return U}}function Te(re,U,ie=ne=>ne){const ne=(...we)=>be.fire(ie(...we)),oe=()=>re.on(U,ne),ce=()=>re.removeListener(U,ne),be=new l({onWillAddFirstListener:oe,onDidRemoveLastListener:ce});return be.event}x.fromNodeEventEmitter=Te;function B(re,U,ie=ne=>ne){const ne=(...we)=>be.fire(ie(...we)),oe=()=>re.addEventListener(U,ne),ce=()=>re.removeEventListener(U,ne),be=new l({onWillAddFirstListener:oe,onDidRemoveLastListener:ce});return be.event}x.fromDOMEventEmitter=B;function W(re){return new Promise(U=>Y(re)(U))}x.toPromise=W;function O(re){const U=new l;return re.then(ie=>{U.fire(ie)},()=>{U.fire(void 0)}).finally(()=>{U.dispose()}),U.event}x.fromPromise=O;function J(re,U,ie){return U(ie),re(ne=>U(ne))}x.runAndSubscribe=J;class te{constructor(U,ie){this._observable=U,this.f=0,this.g=!1;const ne={onWillAddFirstListener:()=>{U.addObserver(this)},onDidRemoveLastListener:()=>{U.removeObserver(this)}};ie||S(ne),this.emitter=new l(ne),ie&&ie.add(this.emitter)}beginUpdate(U){this.f++}handlePossibleChange(U){}handleChange(U,ie){this.g=!0}endUpdate(U){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function he(re,U){return new te(re,U).emitter.event}x.fromObservable=he;function me(re){return(U,ie,ne)=>{let oe=0,ce=!1;const be={beginUpdate(){oe++},endUpdate(){oe--,oe===0&&(re.reportChanges(),ce&&(ce=!1,U.call(ie)))},handlePossibleChange(){},handleChange(){ce=!0}};re.addObserver(be),re.reportChanges();const we={dispose(){re.removeObserver(be)}};return ne instanceof M.$Uc?ne.add(we):Array.isArray(ne)&&ne.push(we),we}}x.fromObservableLight=me})(f||(t.Event=f={}));class w{static{this.all=new Set}static{this.f=0}constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${w.f++}`,w.all.add(this)}start(S){this.g=new p.$ae,this.listenerCount=S}stop(){if(this.g){const S=this.g.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this.g=void 0}}}t.$ce=w;let g=-1;function m(x){const S=g;return g=x,{dispose(){g=S}}}class e{constructor(S,C=Math.random().toString(18).slice(2,5)){this.threshold=S,this.name=C,this.g=0}dispose(){this.f?.clear()}check(S,C){const Y=this.threshold;if(Y<=0||C<Y)return;this.f||(this.f=new Map);const Z=this.f.get(S.value)||0;if(this.f.set(S.value,Z+1),this.g-=1,this.g<=0){this.g=Y*.5;let H,G=0;for(const[K,ee]of this.f)(!H||G<ee)&&(H=K,G=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${G}):`),console.warn(H)}return()=>{const H=this.f.get(S.value)||0;this.f.set(S.value,H-1)}}}class L{static create(){return new L(new Error().stack??"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class N{constructor(S){this.value=S,this.id=E++}}const $=2,v=(x,S)=>{if(x instanceof N)S(x);else for(let C=0;C<x.length;C++){const Y=x[C];Y&&S(Y)}},j=d?new FinalizationRegistry(x=>{typeof x=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(x))}):void 0;class l{constructor(S){this.w=0,this.f=S,this.g=g>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??g):void 0,this.j=this.f?._profName?new w(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(a){const S=this.t;queueMicrotask(()=>{v(S,C=>C.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(S,C,Y)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),M.$Vc.None;if(this.m)return M.$Vc.None;C&&(S=S.bind(C));const Z=new N(S);let H,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Z.stack=L.create(),H=this.g.check(Z.stack,this.w+1)),a&&(Z.stack=G??L.create()),this.t?this.t instanceof N?(this.u??=new s,this.t=[this.t,Z]):this.t.push(Z):(this.f?.onWillAddFirstListener?.(this),this.t=Z,this.f?.onDidAddFirstListener?.(this)),this.w++;const K=(0,M.$Tc)(()=>{j?.unregister(K),H?.(),this.x(Z)});if(Y instanceof M.$Uc?Y.add(K):Array.isArray(Y)&&Y.push(K),j){const ee=new Error().stack.split(`
`).slice(2).join(`
`).trim();j.register(K,ee,K)}return K},this.q}x(S){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const C=this.t,Y=C.indexOf(S);if(Y===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,C[Y]=void 0;const Z=this.u.current===this;if(this.w*$<=C.length){let H=0;for(let G=0;G<C.length;G++)C[G]?C[H++]=C[G]:Z&&(this.u.end--,H<this.u.i&&this.u.i--);C.length=H}}y(S,C){if(!S)return;const Y=this.f?.onListenerError||i.$1;if(!Y){S.value(C);return}try{S.value(C)}catch(Z){Y(Z)}}z(S){const C=S.current.t;for(;S.i<S.end;)this.y(C[S.i++],S.value);S.reset()}fire(S){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof N)this.y(this.t,S);else{const C=this.u;C.enqueue(this,S,this.t.length),this.z(C)}this.j?.stop()}hasListeners(){return this.w>0}}t.$ee=l;const n=()=>new s;t.$fe=n;class s{constructor(){this.i=-1,this.end=0}enqueue(S,C,Y){this.i=0,this.end=Y,this.current=S,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class h extends l{async fireAsync(S,C,Y){if(this.t)for(this.h||(this.h=new c.$6c),v(this.t,Z=>this.h.push([Z.value,S]));this.h.size>0&&!C.isCancellationRequested;){const[Z,H]=this.h.shift(),G=[],K={...H,token:C,waitUntil:ee=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");Y&&(ee=Y(ee,Z)),G.push(ee)}};try{Z(K)}catch(ee){(0,i.$1)(ee);continue}Object.freeze(G),await Promise.allSettled(G).then(ee=>{for(const k of ee)k.status==="rejected"&&(0,i.$1)(k.reason)})}}}t.$ge=h;class o extends l{get isPaused(){return this.h!==0}constructor(S){super(S),this.h=0,this.s=new c.$6c,this.A=S?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const S=Array.from(this.s);this.s.clear(),super.fire(this.A(S))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(S){this.w&&(this.h!==0?this.s.push(S):super.fire(S))}}t.$he=o;class b extends o{constructor(S){super(S),this.k=S.delay??100}fire(S){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(S)}}t.$ie=b;class A extends l{constructor(S){super(S),this.h=[],this.k=S?.merge}fire(S){this.hasListeners()&&(this.h.push(S),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}t.$je=A;class R{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(S){const C={event:S,listener:null};this.h.push(C),this.g&&this.m(C);const Y=()=>{this.g&&this.o(C);const Z=this.h.indexOf(C);this.h.splice(Z,1)};return(0,M.$Tc)((0,F.$db)(Y))}j(){this.g=!0,this.h.forEach(S=>this.m(S))}k(){this.g=!1,this.h.forEach(S=>this.o(S))}m(S){S.listener=S.event(C=>this.f.fire(C))}o(S){S.listener?.dispose(),S.listener=null}dispose(){this.f.dispose();for(const S of this.h)S.listener?.dispose();this.h=[]}}t.$ke=R;class y{constructor(S,C,Y,Z){this.f=new M.$Uc;const H=this.f.add(new R),G=this.f.add(new M.$5c);function K(ee){G.set(ee,H.add(Z(ee)))}for(const ee of S)K(ee);this.f.add(C(ee=>{K(ee)})),this.f.add(Y(ee=>{G.deleteAndDispose(ee)})),this.event=H.event}dispose(){this.f.dispose()}}t.$le=y;class P{constructor(){this.f=[]}wrapEvent(S){return(C,Y,Z)=>S(H=>{const G=this.f[this.f.length-1];G?G.push(()=>C.call(Y,H)):C.call(Y,H)},void 0,Z)}bufferEvents(S){const C=[];this.f.push(C);const Y=S();return this.f.pop(),C.forEach(Z=>Z()),Y}}t.$me=P;class T{constructor(){this.f=!1,this.g=f.None,this.h=M.$Vc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(S){this.g=S,this.f&&(this.h.dispose(),this.h=S(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ne=T;class I{static const(S){return new Q(S)}constructor(S){this.g=S,this.f=new l,this.onDidChange=this.f.event}get value(){return this.g}set value(S){S!==this.g&&(this.g=S,this.f.fire(void 0))}}t.$oe=I;class Q{constructor(S){this.value=S,this.onDidChange=f.None}}}),se(ue[24],ae([0,1,11]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pe=t.CancellationToken=void 0,t.$qe=d;const F=Object.freeze(function(a,u){const f=setTimeout(a.bind(u),0);return{dispose(){clearTimeout(f)}}});var M;(function(a){function u(f){return f===a.None||f===a.Cancelled||f instanceof c?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}a.isCancellationToken=u,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(M||(t.CancellationToken=M={}));class c{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new i.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class p{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new c),this.f}cancel(){this.f?this.f instanceof c&&this.f.cancel():this.f=M.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof c&&this.f.dispose():this.f=M.None}}t.$pe=p;function d(a){const u=new p;return a.add({dispose(){u.cancel()}}),u.token}}),se(ue[40],ae([0,1,24]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5e=t.$4e=t.$2e=void 0,t.$3e=M;class F{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new i.$pe,u=this.b(a.token);return this.a={promise:u,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}t.$2e=F;function M(d){return d}class c{constructor(a,u){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=M):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);return this.b!==u&&(this.b=u,this.a=this.c(a)),this.a}}t.$4e=c;class p{get cachedValues(){return this.a}constructor(a,u){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=M):(this.c=u,this.d=a.getCacheKey)}get(a){const u=this.d(a);if(this.b.has(u))return this.b.get(u);const f=this.c(a);return this.a.set(a,f),this.b.set(u,f),f}}t.$5e=p}),se(ue[7],ae([0,1,40,39]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8f=t.$7f=t.$6f=t.GraphemeBreakType=t.$Vf=t.$Of=t.$Hf=t.$Gf=void 0,t.$8e=M,t.$9e=p,t.$0e=a,t.$$e=u,t.$_e=f,t.$af=w,t.$bf=g,t.$cf=m,t.$df=e,t.$ef=L,t.$ff=E,t.$gf=N,t.$hf=$,t.$if=v,t.$jf=j,t.$kf=l,t.$lf=n,t.$mf=s,t.$nf=h,t.$of=o,t.$pf=b,t.$qf=A,t.$rf=R,t.$sf=y,t.$tf=P,t.$uf=T,t.$vf=I,t.$wf=Q,t.$xf=x,t.$yf=S,t.$zf=C,t.$Af=Y,t.$Bf=Z,t.$Cf=H,t.$Df=G,t.$Ef=K,t.$Ff=ee,t.$If=fe,t.$Jf=ve,t.$Kf=r,t.$Lf=je,t.$Mf=De,t.$Nf=Te,t.$Pf=B,t.$Qf=W,t.$Rf=O,t.$Sf=J,t.$Tf=he,t.$Uf=me,t.$Wf=re,t.$Xf=U,t.$Yf=ie,t.$Zf=ne,t.$1f=oe,t.$2f=ce,t.$3f=be,t.$4f=we,t.$5f=Ve;function M(D){return!D||typeof D!="string"?!0:D.trim().length===0}const c=/{(\d+)}/g;function p(D,...q){return q.length===0?D:D.replace(c,function(z,_){const le=parseInt(_,10);return isNaN(le)||le<0||le>=q.length?z:q[le]})}const d=/{([^}]+)}/g;function a(D,q){return Object.keys(q).length===0?D:D.replace(d,(z,_)=>q[_]??z)}function u(D){return D.replace(/[<>"'&]/g,q=>{switch(q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return q})}function f(D){return D.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}function w(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function g(D,q){let z=0;const _=q.charCodeAt(0);for(let le=D.length-1;le>=0;le--)D.charCodeAt(le)===_&&z++;return z}function m(D,q,z="\u2026"){return D.length<=q?D:`${D.substr(0,q)}${z}`}function e(D,q,z="\u2026"){if(D.length<=q)return D;const _=Math.ceil(q/2)-z.length/2,le=Math.floor(q/2)-z.length/2;return`${D.substr(0,_)}${z}${D.substr(D.length-le)}`}function L(D,q=" "){const z=E(D,q);return N(z,q)}function E(D,q){if(!D||!q)return D;const z=q.length;if(z===0||D.length===0)return D;let _=0;for(;D.indexOf(q,_)===_;)_=_+z;return D.substring(_)}function N(D,q){if(!D||!q)return D;const z=q.length,_=D.length;if(z===0||_===0)return D;let le=_,ge=-1;for(;ge=D.lastIndexOf(q,le-1),!(ge===-1||ge+z!==le);){if(ge===0)return"";le=ge}return D.substring(0,le)}function $(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function v(D){return D.replace(/\*/g,"")}function j(D,q,z={}){if(!D)throw new Error("Cannot create regex from empty string");q||(D=w(D)),z.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let _="";return z.global&&(_+="g"),z.matchCase||(_+="i"),z.multiline&&(_+="m"),z.unicode&&(_+="u"),new RegExp(D,_)}function l(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}function n(D){return D.split(/\r\n|\r|\n/)}function s(D){const q=[],z=D.split(/(\r\n|\r|\n)/);for(let _=0;_<Math.ceil(z.length/2);_++)q.push(z[2*_]+(z[2*_+1]??""));return q}function h(D){for(let q=0,z=D.length;q<z;q++){const _=D.charCodeAt(q);if(_!==32&&_!==9)return q}return-1}function o(D,q=0,z=D.length){for(let _=q;_<z;_++){const le=D.charCodeAt(_);if(le!==32&&le!==9)return D.substring(q,_)}return D.substring(q,z)}function b(D,q=D.length-1){for(let z=q;z>=0;z--){const _=D.charCodeAt(z);if(_!==32&&_!==9)return z}return-1}function A(D,q,z){const _=[];let le=0;for(const ge of D.matchAll(q)){if(_.push(D.slice(le,ge.index)),ge.index===void 0)throw new Error("match.index should be defined");le=ge.index+ge[0].length,_.push(z(ge[0],...ge.slice(1),ge.index,D,ge.groups))}return _.push(D.slice(le)),Promise.all(_).then(ge=>ge.join(""))}function R(D,q){return D<q?-1:D>q?1:0}function y(D,q,z=0,_=D.length,le=0,ge=q.length){for(;z<_&&le<ge;z++,le++){const Re=D.charCodeAt(z),Me=q.charCodeAt(le);if(Re<Me)return-1;if(Re>Me)return 1}const Ne=_-z,Pe=ge-le;return Ne<Pe?-1:Ne>Pe?1:0}function P(D,q){return T(D,q,0,D.length,0,q.length)}function T(D,q,z=0,_=D.length,le=0,ge=q.length){for(;z<_&&le<ge;z++,le++){let Re=D.charCodeAt(z),Me=q.charCodeAt(le);if(Re===Me)continue;if(Re>=128||Me>=128)return y(D.toLowerCase(),q.toLowerCase(),z,_,le,ge);Q(Re)&&(Re-=32),Q(Me)&&(Me-=32);const pe=Re-Me;if(pe!==0)return pe}const Ne=_-z,Pe=ge-le;return Ne<Pe?-1:Ne>Pe?1:0}function I(D){return D>=48&&D<=57}function Q(D){return D>=97&&D<=122}function x(D){return D>=65&&D<=90}function S(D,q){return D.length===q.length&&T(D,q)===0}function C(D,q){const z=q.length;return q.length>D.length?!1:T(D,q,0,z)===0}function Y(D,q){const z=Math.min(D.length,q.length);let _;for(_=0;_<z;_++)if(D.charCodeAt(_)!==q.charCodeAt(_))return _;return z}function Z(D,q){const z=Math.min(D.length,q.length);let _;const le=D.length-1,ge=q.length-1;for(_=0;_<z;_++)if(D.charCodeAt(le-_)!==q.charCodeAt(ge-_))return _;return z}function H(D){return 55296<=D&&D<=56319}function G(D){return 56320<=D&&D<=57343}function K(D,q){return(D-55296<<10)+(q-56320)+65536}function ee(D,q,z){const _=D.charCodeAt(z);if(H(_)&&z+1<q){const le=D.charCodeAt(z+1);if(G(le))return K(_,le)}return _}function k(D,q){const z=D.charCodeAt(q-1);if(G(z)&&q>1){const _=D.charCodeAt(q-2);if(H(_))return K(_,z)}return z}class X{get offset(){return this.e}constructor(q,z=0){this.c=q,this.d=q.length,this.e=z}setOffset(q){this.e=q}prevCodePoint(){const q=k(this.c,this.e);return this.e-=q>=65536?2:1,q}nextCodePoint(){const q=ee(this.c,this.d,this.e);return this.e+=q>=65536?2:1,q}eol(){return this.e>=this.d}}t.$Gf=X;class de{get offset(){return this.c.offset}constructor(q,z=0){this.c=new X(q,z)}nextGraphemeLength(){const q=Ee.getInstance(),z=this.c,_=z.offset;let le=q.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const ge=z.offset,Ne=q.getGraphemeBreakType(z.nextCodePoint());if(Le(le,Ne)){z.setOffset(ge);break}le=Ne}return z.offset-_}prevGraphemeLength(){const q=Ee.getInstance(),z=this.c,_=z.offset;let le=q.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const ge=z.offset,Ne=q.getGraphemeBreakType(z.prevCodePoint());if(Le(Ne,le)){z.setOffset(ge);break}le=Ne}return _-z.offset}eol(){return this.c.eol()}}t.$Hf=de;function fe(D,q){return new de(D,q).nextGraphemeLength()}function ve(D,q){return new de(D,q).prevGraphemeLength()}function r(D,q){q>0&&G(D.charCodeAt(q))&&q--;const z=q+fe(D,q);return[z-ve(D,z),z]}function je(D){const q=new de(D);let z=0;for(;!q.eol();)z++,q.nextGraphemeLength();return z}let Ae;function qe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function De(D){return Ae||(Ae=qe()),Ae.test(D)}const Fe=/^[\t\n\r\x20-\x7E]*$/;function Te(D){return Fe.test(D)}t.$Of=/[\u2028\u2029]/;function B(D){return t.$Of.test(D)}function W(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}function O(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}function J(D,q,z=""){const _=D.trimStart();if(_.length<q)return _;const le=/\b/g;let ge=0;for(;le.test(_)&&!(_.length-le.lastIndex<q);)ge=le.lastIndex,le.lastIndex+=1;return ge===0?_:z+_.substring(ge).trimStart()}const te=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*he(D){let q=0;for(const z of D.matchAll(te))q!==z.index&&(yield{isCode:!1,str:D.substring(q,z.index)}),yield{isCode:!0,str:z[0]},q=z.index+z[0].length;q!==D.length&&(yield{isCode:!1,str:D.substring(q)})}function me(D){return D&&(D=D.replace(te,"")),D}t.$Vf="\uFEFF";function re(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}function U(D){return re(D)?D.substr(1):D}function ie(D,q){if(!D||!q||D.length<q.length)return!1;const z=q.length,_=D.toLowerCase();let le=0,ge=-1;for(;le<z;){const Ne=_.indexOf(q[le],ge+1);if(Ne<0)return!1;ge=Ne,le++}return!0}function ne(D,q=!1){return D?(q&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}function oe(D){return D.charAt(0).toUpperCase()+D.slice(1)}function ce(D,q=1){if(q===0)return"";let z=-1;do z=D.indexOf(`
`,z+1),q--;while(q>0&&z>=0);return z===-1?D:(D[z-1]==="\r"&&z--,D.substr(0,z))}function be(D){return D=D%(2*26),D<26?String.fromCharCode(97+D):String.fromCharCode(65+D-26)}function we(D){return Ee.getInstance().getGraphemeBreakType(D)}function Le(D,q){return D===0?q!==5&&q!==7:D===2&&q===3?!1:D===4||D===2||D===3||q===4||q===2||q===3?!0:!(D===8&&(q===8||q===9||q===11||q===12)||(D===11||D===9)&&(q===9||q===10)||(D===12||D===10)&&q===10||q===5||q===13||q===7||D===1||D===13&&q===14||D===6&&q===6)}var ke;(function(D){D[D.Other=0]="Other",D[D.Prepend=1]="Prepend",D[D.CR=2]="CR",D[D.LF=3]="LF",D[D.Control=4]="Control",D[D.Extend=5]="Extend",D[D.Regional_Indicator=6]="Regional_Indicator",D[D.SpacingMark=7]="SpacingMark",D[D.L=8]="L",D[D.V=9]="V",D[D.T=10]="T",D[D.LV=11]="LV",D[D.LVT=12]="LVT",D[D.ZWJ=13]="ZWJ",D[D.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(t.GraphemeBreakType=ke={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=Se()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const z=this.d,_=z.length/3;let le=1;for(;le<=_;)if(q<z[3*le])le=2*le;else if(q>z[3*le+1])le=2*le+1;else return z[3*le+2];return 0}}function Se(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(D,q){if(D===0)return 0;const z=Ie(D,q);if(z!==void 0)return z;const _=new X(q,D);return _.prevCodePoint(),_.offset}function Ie(D,q){const z=new X(q,D);let _=z.prevCodePoint();for(;Ce(_)||_===65039||_===8419;){if(z.offset===0)return;_=z.prevCodePoint()}if(!O(_))return;let le=z.offset;return le>0&&z.prevCodePoint()===8205&&(le=z.offset),le}function Ce(D){return 127995<=D&&D<=127999}var Oe;(function(D){D[D.zwj=8205]="zwj",D[D.emojiVariantSelector=65039]="emojiVariantSelector",D[D.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),t.$6f="\xA0";class xe{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$4e({getCacheKey:JSON.stringify},q=>{function z(pe){const Qe=new Map;for(let ye=0;ye<pe.length;ye+=2)Qe.set(pe[ye],pe[ye+1]);return Qe}function _(pe,Qe){const ye=new Map(pe);for(const[We,ze]of Qe)ye.set(We,ze);return ye}function le(pe,Qe){if(!pe)return Qe;const ye=new Map;for(const[We,ze]of pe)Qe.has(We)&&ye.set(We,ze);return ye}const ge=this.c.value;let Ne=q.filter(pe=>!pe.startsWith("_")&&pe in ge);Ne.length===0&&(Ne=["_default"]);let Pe;for(const pe of Ne){const Qe=z(ge[pe]);Pe=le(Pe,Qe)}const Re=z(ge._common),Me=_(Re,Pe);return new xe(Me)})}static getInstance(q){return xe.d.get(Array.from(q))}static{this.e=new F.$V(()=>Object.keys(xe.c.value).filter(q=>!q.startsWith("_")))}static getLocales(){return xe.e.value}constructor(q){this.f=q}isAmbiguous(q){return this.f.has(q)}getPrimaryConfusable(q){return this.f.get(q)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$7f=xe;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(q){return Be.e().has(q)}static get codePoints(){return Be.e()}}t.$8f=Be}),se(ue[41],ae([0,1,7]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qj=t.$oj=void 0,t.$kj=F,t.$lj=M,t.$mj=c,t.$nj=d,t.$pj=L;function F(N){return M(N,0)}function M(N,$){switch(typeof N){case"object":return N===null?c(349,$):Array.isArray(N)?a(N,$):u(N,$);case"string":return d(N,$);case"boolean":return p(N,$);case"number":return c(N,$);case"undefined":return c(937,$);default:return c(617,$)}}function c(N,$){return($<<5)-$+N|0}function p(N,$){return c(N?433:863,$)}function d(N,$){$=c(149417,$);for(let v=0,j=N.length;v<j;v++)$=c(N.charCodeAt(v),$);return $}function a(N,$){return $=c(104579,$),N.reduce((v,j)=>M(j,v),$)}function u(N,$){return $=c(181387,$),Object.keys(N).sort().reduce((v,j)=>(v=d(j,v),M(N[j],v)),$)}class f{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=M($,this.g),this.g}}t.$oj=f;var w;(function(N){N[N.BLOCK_SIZE=64]="BLOCK_SIZE",N[N.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function g(N,$,v=32){const j=v-$,l=~((1<<j)-1);return(N<<$|(l&N)>>>j)>>>0}function m(N,$=0,v=N.byteLength,j=0){for(let l=0;l<v;l++)N[$+l]=j}function e(N,$,v="0"){for(;N.length<$;)N=v+N;return N}function L(N,$=32){return N instanceof ArrayBuffer?Array.from(new Uint8Array(N)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((N>>>0).toString(16),$/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const v=$.length;if(v===0)return;const j=this.p;let l=this.r,n=this.u,s,h;for(n!==0?(s=n,h=-1,n=0):(s=$.charCodeAt(0),h=0);;){let o=s;if(i.$Cf(s))if(h+1<v){const b=$.charCodeAt(h+1);i.$Df(b)?(h++,o=i.$Ef(s,b)):o=65533}else{n=s;break}else i.$Df(s)&&(o=65533);if(l=this.w(j,l,o),h++,h<v)s=$.charCodeAt(h);else break}this.r=l,this.u=n}w($,v,j){return j<128?$[v++]=j:j<2048?($[v++]=192|(j&1984)>>>6,$[v++]=128|(j&63)>>>0):j<65536?($[v++]=224|(j&61440)>>>12,$[v++]=128|(j&4032)>>>6,$[v++]=128|(j&63)>>>0):($[v++]=240|(j&1835008)>>>18,$[v++]=128|(j&258048)>>>12,$[v++]=128|(j&4032)>>>6,$[v++]=128|(j&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),L(this.h)+L(this.l)+L(this.m)+L(this.n)+L(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=E.g,v=this.q;for(let R=0;R<64;R+=4)$.setUint32(R,v.getUint32(R,!1),!1);for(let R=64;R<320;R+=4)$.setUint32(R,g($.getUint32(R-12,!1)^$.getUint32(R-32,!1)^$.getUint32(R-56,!1)^$.getUint32(R-64,!1),1),!1);let j=this.h,l=this.l,n=this.m,s=this.n,h=this.o,o,b,A;for(let R=0;R<80;R++)R<20?(o=l&n|~l&s,b=1518500249):R<40?(o=l^n^s,b=1859775393):R<60?(o=l&n|l&s|n&s,b=2400959708):(o=l^n^s,b=3395469782),A=g(j,5)+o+h+b+$.getUint32(R*4,!1)&4294967295,h=s,s=n,n=g(l,30),l=j,j=A;this.h=this.h+j&4294967295,this.l=this.l+l&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+h&4294967295}}t.$qj=E}),se(ue[25],ae([0,1,37,41]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$At=t.$yt=void 0,t.$zt=c;class M{constructor(g){this.a=g}getElements(){const g=this.a,m=new Int32Array(g.length);for(let e=0,L=g.length;e<L;e++)m[e]=g.charCodeAt(e);return m}}t.$yt=M;function c(w,g,m){return new f(new M(w),new M(g)).ComputeDiff(m).changes}class p{static Assert(g,m){if(!g)throw new Error(m)}}class d{static Copy(g,m,e,L,E){for(let N=0;N<E;N++)e[L+N]=g[m+N]}static Copy2(g,m,e,L,E){for(let N=0;N<E;N++)e[L+N]=g[m+N]}}var a;(function(w){w[w.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$xt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(g,m){this.b=Math.min(this.b,g),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(g,m){this.b=Math.min(this.b,g),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(g,m,e=null){this.a=e,this.b=g,this.c=m;const[L,E,N]=f.o(g),[$,v,j]=f.o(m);this.d=N&&j,this.e=L,this.f=E,this.g=$,this.h=v,this.k=[],this.m=[]}static n(g){return g.length>0&&typeof g[0]=="string"}static o(g){const m=g.getElements();if(f.n(m)){const e=new Int32Array(m.length);for(let L=0,E=m.length;L<E;L++)e[L]=(0,F.$nj)(m[L],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(g,m){return this.f[g]!==this.h[m]?!1:this.d?this.e[g]===this.g[m]:!0}q(g,m){if(!this.p(g,m))return!1;const e=f.r(this.b,g),L=f.r(this.c,m);return e===L}static r(g,m){return typeof g.getStrictElement=="function"?g.getStrictElement(m):null}s(g,m){return this.f[g]!==this.f[m]?!1:this.d?this.e[g]===this.e[m]:!0}u(g,m){return this.h[g]!==this.h[m]?!1:this.d?this.g[g]===this.g[m]:!0}ComputeDiff(g){return this.v(0,this.f.length-1,0,this.h.length-1,g)}v(g,m,e,L,E){const N=[!1];let $=this.w(g,m,e,L,N);return E&&($=this.z($)),{quitEarly:N[0],changes:$}}w(g,m,e,L,E){for(E[0]=!1;g<=m&&e<=L&&this.p(g,e);)g++,e++;for(;m>=g&&L>=e&&this.p(m,L);)m--,L--;if(g>m||e>L){let n;return e<=L?(p.Assert(g===m+1,"originalStart should only be one more than originalEnd"),n=[new i.$xt(g,0,e,L-e+1)]):g<=m?(p.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),n=[new i.$xt(g,m-g+1,e,0)]):(p.Assert(g===m+1,"originalStart should only be one more than originalEnd"),p.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const N=[0],$=[0],v=this.y(g,m,e,L,N,$,E),j=N[0],l=$[0];if(v!==null)return v;if(!E[0]){const n=this.w(g,j,e,l,E);let s=[];return E[0]?s=[new i.$xt(j+1,m-(j+1)+1,l+1,L-(l+1)+1)]:s=this.w(j+1,m,l+1,L,E),this.H(n,s)}return[new i.$xt(g,m-g+1,e,L-e+1)]}x(g,m,e,L,E,N,$,v,j,l,n,s,h,o,b,A,R,y){let P=null,T=null,I=new u,Q=m,x=e,S=h[0]-A[0]-L,C=-1073741824,Y=this.k.length-1;do{const Z=S+g;Z===Q||Z<x&&j[Z-1]<j[Z+1]?(n=j[Z+1],o=n-S-L,n<C&&I.MarkNextChange(),C=n,I.AddModifiedElement(n+1,o),S=Z+1-g):(n=j[Z-1]+1,o=n-S-L,n<C&&I.MarkNextChange(),C=n-1,I.AddOriginalElement(n,o+1),S=Z-1-g),Y>=0&&(j=this.k[Y],g=j[0],Q=1,x=j.length-1)}while(--Y>=-1);if(P=I.getReverseChanges(),y[0]){let Z=h[0]+1,H=A[0]+1;if(P!==null&&P.length>0){const G=P[P.length-1];Z=Math.max(Z,G.getOriginalEnd()),H=Math.max(H,G.getModifiedEnd())}T=[new i.$xt(Z,s-Z+1,H,b-H+1)]}else{I=new u,Q=N,x=$,S=h[0]-A[0]-v,C=1073741824,Y=R?this.m.length-1:this.m.length-2;do{const Z=S+E;Z===Q||Z<x&&l[Z-1]>=l[Z+1]?(n=l[Z+1]-1,o=n-S-v,n>C&&I.MarkNextChange(),C=n+1,I.AddOriginalElement(n+1,o+1),S=Z+1-E):(n=l[Z-1],o=n-S-v,n>C&&I.MarkNextChange(),C=n,I.AddModifiedElement(n+1,o+1),S=Z-1-E),Y>=0&&(l=this.m[Y],E=l[0],Q=1,x=l.length-1)}while(--Y>=-1);T=I.getChanges()}return this.H(P,T)}y(g,m,e,L,E,N,$){let v=0,j=0,l=0,n=0,s=0,h=0;g--,e--,E[0]=0,N[0]=0,this.k=[],this.m=[];const o=m-g+(L-e),b=o+1,A=new Int32Array(b),R=new Int32Array(b),y=L-e,P=m-g,T=g-e,I=m-L,x=(P-y)%2===0;A[y]=g,R[P]=m,$[0]=!1;for(let S=1;S<=o/2+1;S++){let C=0,Y=0;l=this.J(y-S,S,y,b),n=this.J(y+S,S,y,b);for(let H=l;H<=n;H+=2){H===l||H<n&&A[H-1]<A[H+1]?v=A[H+1]:v=A[H-1]+1,j=v-(H-y)-T;const G=v;for(;v<m&&j<L&&this.p(v+1,j+1);)v++,j++;if(A[H]=v,v+j>C+Y&&(C=v,Y=j),!x&&Math.abs(H-P)<=S-1&&v>=R[H])return E[0]=v,N[0]=j,G<=R[H]&&1447>0&&S<=1448?this.x(y,l,n,T,P,s,h,I,A,R,v,m,E,j,L,N,x,$):null}const Z=(C-g+(Y-e)-S)/2;if(this.a!==null&&!this.a(C,Z))return $[0]=!0,E[0]=C,N[0]=Y,Z>0&&1447>0&&S<=1448?this.x(y,l,n,T,P,s,h,I,A,R,v,m,E,j,L,N,x,$):(g++,e++,[new i.$xt(g,m-g+1,e,L-e+1)]);s=this.J(P-S,S,P,b),h=this.J(P+S,S,P,b);for(let H=s;H<=h;H+=2){H===s||H<h&&R[H-1]>=R[H+1]?v=R[H+1]-1:v=R[H-1],j=v-(H-P)-I;const G=v;for(;v>g&&j>e&&this.p(v,j);)v--,j--;if(R[H]=v,x&&Math.abs(H-y)<=S&&v<=A[H])return E[0]=v,N[0]=j,G>=A[H]&&1447>0&&S<=1448?this.x(y,l,n,T,P,s,h,I,A,R,v,m,E,j,L,N,x,$):null}if(S<=1447){let H=new Int32Array(n-l+2);H[0]=y-l+1,d.Copy2(A,l,H,1,n-l+1),this.k.push(H),H=new Int32Array(h-s+2),H[0]=P-s+1,d.Copy2(R,s,H,1,h-s+1),this.m.push(H)}}return this.x(y,l,n,T,P,s,h,I,A,R,v,m,E,j,L,N,x,$)}z(g){for(let m=0;m<g.length;m++){const e=g[m],L=m<g.length-1?g[m+1].originalStart:this.f.length,E=m<g.length-1?g[m+1].modifiedStart:this.h.length,N=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<L&&e.modifiedStart+e.modifiedLength<E&&(!N||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const j=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!j)break;e.originalStart++,e.modifiedStart++}const v=[null];if(m<g.length-1&&this.I(g[m],g[m+1],v)){g[m]=v[0],g.splice(m+1,1),m--;continue}}for(let m=g.length-1;m>=0;m--){const e=g[m];let L=0,E=0;if(m>0){const n=g[m-1];L=n.originalStart+n.originalLength,E=n.modifiedStart+n.modifiedLength}const N=e.originalLength>0,$=e.modifiedLength>0;let v=0,j=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const s=e.originalStart-n,h=e.modifiedStart-n;if(s<L||h<E||N&&!this.s(s,s+e.originalLength)||$&&!this.u(h,h+e.modifiedLength))break;const b=(s===L&&h===E?5:0)+this.G(s,e.originalLength,h,e.modifiedLength);b>j&&(j=b,v=n)}e.originalStart-=v,e.modifiedStart-=v;const l=[null];if(m>0&&this.I(g[m-1],g[m],l)){g[m-1]=l[0],g.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=g.length;m<e;m++){const L=g[m-1],E=g[m],N=E.originalStart-L.originalStart-L.originalLength,$=L.originalStart,v=E.originalStart+E.originalLength,j=v-$,l=L.modifiedStart,n=E.modifiedStart+E.modifiedLength,s=n-l;if(N<5&&j<20&&s<20){const h=this.A($,j,l,s,N);if(h){const[o,b]=h;(o!==L.originalStart+L.originalLength||b!==L.modifiedStart+L.modifiedLength)&&(L.originalLength=o-L.originalStart,L.modifiedLength=b-L.modifiedStart,E.originalStart=o+N,E.modifiedStart=b+N,E.originalLength=v-E.originalStart,E.modifiedLength=n-E.modifiedStart)}}}return g}A(g,m,e,L,E){if(m<E||L<E)return null;const N=g+m-E+1,$=e+L-E+1;let v=0,j=0,l=0;for(let n=g;n<N;n++)for(let s=e;s<$;s++){const h=this.B(n,s,E);h>0&&h>v&&(v=h,j=n,l=s)}return v>0?[j,l]:null}B(g,m,e){let L=0;for(let E=0;E<e;E++){if(!this.p(g+E,m+E))return 0;L+=this.e[g+E].length}return L}C(g){return g<=0||g>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[g])}D(g,m){if(this.C(g)||this.C(g-1))return!0;if(m>0){const e=g+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(g){return g<=0||g>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[g])}F(g,m){if(this.E(g)||this.E(g-1))return!0;if(m>0){const e=g+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(g,m,e,L){const E=this.D(g,m)?1:0,N=this.F(e,L)?1:0;return E+N}H(g,m){const e=[];if(g.length===0||m.length===0)return m.length>0?m:g;if(this.I(g[g.length-1],m[0],e)){const L=new Array(g.length+m.length-1);return d.Copy(g,0,L,0,g.length-1),L[g.length-1]=e[0],d.Copy(m,1,L,g.length,m.length-1),L}else{const L=new Array(g.length+m.length);return d.Copy(g,0,L,0,g.length),d.Copy(m,0,L,g.length,m.length),L}}I(g,m,e){if(p.Assert(g.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),p.Assert(g.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=m.originalStart||g.modifiedStart+g.modifiedLength>=m.modifiedStart){const L=g.originalStart;let E=g.originalLength;const N=g.modifiedStart;let $=g.modifiedLength;return g.originalStart+g.originalLength>=m.originalStart&&(E=m.originalStart+m.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=m.modifiedStart&&($=m.modifiedStart+m.modifiedLength-g.modifiedStart),e[0]=new i.$xt(L,E,N,$),!0}else return e[0]=null,!1}J(g,m,e,L){if(g>=0&&g<L)return g;const E=e,N=L-e-1,$=m%2===0;if(g<0){const v=E%2===0;return $===v?0:1}else{const v=N%2===0;return $===v?L-1:L-2}}}t.$At=f}),se(ue[26],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9f=i,t.$0f=F,t.$$f=M,t.$_f=c,t.$ag=p,t.$bg=d,t.$cg=a,t.$dg=u,t.$eg=f,t.$fg=w,t.$gg=g,t.$hg=m,t.$ig=e,t.$jg=E,t.$kg=N,t.$lg=$,t.$mg=v,t.$ng=j;function i(l){return typeof l=="string"}function F(l){return Array.isArray(l)&&l.every(n=>i(n))}function M(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function c(l){const n=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof n}function p(l){return typeof l=="number"&&!isNaN(l)}function d(l){return!!l&&typeof l[Symbol.iterator]=="function"}function a(l){return l===!0||l===!1}function u(l){return typeof l>"u"}function f(l){return!w(l)}function w(l){return u(l)||l===null}function g(l,n){if(!l)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function m(l){if(w(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function e(...l){const n=[];for(let s=0;s<l.length;s++){const h=l[s];if(w(h))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(h)}return n}const L=Object.prototype.hasOwnProperty;function E(l){if(!M(l))return!1;for(const n in l)if(L.call(l,n))return!1;return!0}function N(l){return typeof l=="function"}function $(...l){return l.length>0&&l.every(N)}function v(l,n){const s=Math.min(l.length,n.length);for(let h=0;h<s;h++)j(l[h],n[h])}function j(l,n){if(i(n)){if(typeof l!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(N(n)){try{if(l instanceof n)return}catch{}if(!w(l)&&l.constructor===n||n.length===1&&n.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),se(ue[27],ae([0,1,26]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qj=M,t.$Rj=c;const F=Object.create(null);function M(p,d){if((0,i.$9f)(d)){const a=F[d];if(a===void 0)throw new Error(`${p} references an unknown codicon: ${d}`);d=a}return F[p]=d,{id:p}}function c(){return F}}),se(ue[42],ae([0,1,27]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sj=void 0,t.$Sj={add:(0,i.$Qj)("add",6e4),plus:(0,i.$Qj)("plus",6e4),gistNew:(0,i.$Qj)("gist-new",6e4),repoCreate:(0,i.$Qj)("repo-create",6e4),lightbulb:(0,i.$Qj)("lightbulb",60001),lightBulb:(0,i.$Qj)("light-bulb",60001),repo:(0,i.$Qj)("repo",60002),repoDelete:(0,i.$Qj)("repo-delete",60002),gistFork:(0,i.$Qj)("gist-fork",60003),repoForked:(0,i.$Qj)("repo-forked",60003),gitPullRequest:(0,i.$Qj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Qj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Qj)("record-keys",60005),keyboard:(0,i.$Qj)("keyboard",60005),tag:(0,i.$Qj)("tag",60006),gitPullRequestLabel:(0,i.$Qj)("git-pull-request-label",60006),tagAdd:(0,i.$Qj)("tag-add",60006),tagRemove:(0,i.$Qj)("tag-remove",60006),person:(0,i.$Qj)("person",60007),personFollow:(0,i.$Qj)("person-follow",60007),personOutline:(0,i.$Qj)("person-outline",60007),personFilled:(0,i.$Qj)("person-filled",60007),gitBranch:(0,i.$Qj)("git-branch",60008),gitBranchCreate:(0,i.$Qj)("git-branch-create",60008),gitBranchDelete:(0,i.$Qj)("git-branch-delete",60008),sourceControl:(0,i.$Qj)("source-control",60008),mirror:(0,i.$Qj)("mirror",60009),mirrorPublic:(0,i.$Qj)("mirror-public",60009),star:(0,i.$Qj)("star",60010),starAdd:(0,i.$Qj)("star-add",60010),starDelete:(0,i.$Qj)("star-delete",60010),starEmpty:(0,i.$Qj)("star-empty",60010),comment:(0,i.$Qj)("comment",60011),commentAdd:(0,i.$Qj)("comment-add",60011),alert:(0,i.$Qj)("alert",60012),warning:(0,i.$Qj)("warning",60012),search:(0,i.$Qj)("search",60013),searchSave:(0,i.$Qj)("search-save",60013),logOut:(0,i.$Qj)("log-out",60014),signOut:(0,i.$Qj)("sign-out",60014),logIn:(0,i.$Qj)("log-in",60015),signIn:(0,i.$Qj)("sign-in",60015),eye:(0,i.$Qj)("eye",60016),eyeUnwatch:(0,i.$Qj)("eye-unwatch",60016),eyeWatch:(0,i.$Qj)("eye-watch",60016),circleFilled:(0,i.$Qj)("circle-filled",60017),primitiveDot:(0,i.$Qj)("primitive-dot",60017),closeDirty:(0,i.$Qj)("close-dirty",60017),debugBreakpoint:(0,i.$Qj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Qj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Qj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Qj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Qj)("primitive-square",60018),edit:(0,i.$Qj)("edit",60019),pencil:(0,i.$Qj)("pencil",60019),info:(0,i.$Qj)("info",60020),issueOpened:(0,i.$Qj)("issue-opened",60020),gistPrivate:(0,i.$Qj)("gist-private",60021),gitForkPrivate:(0,i.$Qj)("git-fork-private",60021),lock:(0,i.$Qj)("lock",60021),mirrorPrivate:(0,i.$Qj)("mirror-private",60021),close:(0,i.$Qj)("close",60022),removeClose:(0,i.$Qj)("remove-close",60022),x:(0,i.$Qj)("x",60022),repoSync:(0,i.$Qj)("repo-sync",60023),sync:(0,i.$Qj)("sync",60023),clone:(0,i.$Qj)("clone",60024),desktopDownload:(0,i.$Qj)("desktop-download",60024),beaker:(0,i.$Qj)("beaker",60025),microscope:(0,i.$Qj)("microscope",60025),vm:(0,i.$Qj)("vm",60026),deviceDesktop:(0,i.$Qj)("device-desktop",60026),file:(0,i.$Qj)("file",60027),fileText:(0,i.$Qj)("file-text",60027),more:(0,i.$Qj)("more",60028),ellipsis:(0,i.$Qj)("ellipsis",60028),kebabHorizontal:(0,i.$Qj)("kebab-horizontal",60028),mailReply:(0,i.$Qj)("mail-reply",60029),reply:(0,i.$Qj)("reply",60029),organization:(0,i.$Qj)("organization",60030),organizationFilled:(0,i.$Qj)("organization-filled",60030),organizationOutline:(0,i.$Qj)("organization-outline",60030),newFile:(0,i.$Qj)("new-file",60031),fileAdd:(0,i.$Qj)("file-add",60031),newFolder:(0,i.$Qj)("new-folder",60032),fileDirectoryCreate:(0,i.$Qj)("file-directory-create",60032),trash:(0,i.$Qj)("trash",60033),trashcan:(0,i.$Qj)("trashcan",60033),history:(0,i.$Qj)("history",60034),clock:(0,i.$Qj)("clock",60034),folder:(0,i.$Qj)("folder",60035),fileDirectory:(0,i.$Qj)("file-directory",60035),symbolFolder:(0,i.$Qj)("symbol-folder",60035),logoGithub:(0,i.$Qj)("logo-github",60036),markGithub:(0,i.$Qj)("mark-github",60036),github:(0,i.$Qj)("github",60036),terminal:(0,i.$Qj)("terminal",60037),console:(0,i.$Qj)("console",60037),repl:(0,i.$Qj)("repl",60037),zap:(0,i.$Qj)("zap",60038),symbolEvent:(0,i.$Qj)("symbol-event",60038),error:(0,i.$Qj)("error",60039),stop:(0,i.$Qj)("stop",60039),variable:(0,i.$Qj)("variable",60040),symbolVariable:(0,i.$Qj)("symbol-variable",60040),array:(0,i.$Qj)("array",60042),symbolArray:(0,i.$Qj)("symbol-array",60042),symbolModule:(0,i.$Qj)("symbol-module",60043),symbolPackage:(0,i.$Qj)("symbol-package",60043),symbolNamespace:(0,i.$Qj)("symbol-namespace",60043),symbolObject:(0,i.$Qj)("symbol-object",60043),symbolMethod:(0,i.$Qj)("symbol-method",60044),symbolFunction:(0,i.$Qj)("symbol-function",60044),symbolConstructor:(0,i.$Qj)("symbol-constructor",60044),symbolBoolean:(0,i.$Qj)("symbol-boolean",60047),symbolNull:(0,i.$Qj)("symbol-null",60047),symbolNumeric:(0,i.$Qj)("symbol-numeric",60048),symbolNumber:(0,i.$Qj)("symbol-number",60048),symbolStructure:(0,i.$Qj)("symbol-structure",60049),symbolStruct:(0,i.$Qj)("symbol-struct",60049),symbolParameter:(0,i.$Qj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Qj)("symbol-type-parameter",60050),symbolKey:(0,i.$Qj)("symbol-key",60051),symbolText:(0,i.$Qj)("symbol-text",60051),symbolReference:(0,i.$Qj)("symbol-reference",60052),goToFile:(0,i.$Qj)("go-to-file",60052),symbolEnum:(0,i.$Qj)("symbol-enum",60053),symbolValue:(0,i.$Qj)("symbol-value",60053),symbolRuler:(0,i.$Qj)("symbol-ruler",60054),symbolUnit:(0,i.$Qj)("symbol-unit",60054),activateBreakpoints:(0,i.$Qj)("activate-breakpoints",60055),archive:(0,i.$Qj)("archive",60056),arrowBoth:(0,i.$Qj)("arrow-both",60057),arrowDown:(0,i.$Qj)("arrow-down",60058),arrowLeft:(0,i.$Qj)("arrow-left",60059),arrowRight:(0,i.$Qj)("arrow-right",60060),arrowSmallDown:(0,i.$Qj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Qj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Qj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Qj)("arrow-small-up",60064),arrowUp:(0,i.$Qj)("arrow-up",60065),bell:(0,i.$Qj)("bell",60066),bold:(0,i.$Qj)("bold",60067),book:(0,i.$Qj)("book",60068),bookmark:(0,i.$Qj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Qj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Qj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Qj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Qj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Qj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Qj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Qj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Qj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Qj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Qj)("briefcase",60076),broadcast:(0,i.$Qj)("broadcast",60077),browser:(0,i.$Qj)("browser",60078),bug:(0,i.$Qj)("bug",60079),calendar:(0,i.$Qj)("calendar",60080),caseSensitive:(0,i.$Qj)("case-sensitive",60081),check:(0,i.$Qj)("check",60082),checklist:(0,i.$Qj)("checklist",60083),chevronDown:(0,i.$Qj)("chevron-down",60084),chevronLeft:(0,i.$Qj)("chevron-left",60085),chevronRight:(0,i.$Qj)("chevron-right",60086),chevronUp:(0,i.$Qj)("chevron-up",60087),chromeClose:(0,i.$Qj)("chrome-close",60088),chromeMaximize:(0,i.$Qj)("chrome-maximize",60089),chromeMinimize:(0,i.$Qj)("chrome-minimize",60090),chromeRestore:(0,i.$Qj)("chrome-restore",60091),circleOutline:(0,i.$Qj)("circle-outline",60092),circle:(0,i.$Qj)("circle",60092),debugBreakpointUnverified:(0,i.$Qj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Qj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Qj)("circle-slash",60093),circuitBoard:(0,i.$Qj)("circuit-board",60094),clearAll:(0,i.$Qj)("clear-all",60095),clippy:(0,i.$Qj)("clippy",60096),closeAll:(0,i.$Qj)("close-all",60097),cloudDownload:(0,i.$Qj)("cloud-download",60098),cloudUpload:(0,i.$Qj)("cloud-upload",60099),code:(0,i.$Qj)("code",60100),collapseAll:(0,i.$Qj)("collapse-all",60101),colorMode:(0,i.$Qj)("color-mode",60102),commentDiscussion:(0,i.$Qj)("comment-discussion",60103),creditCard:(0,i.$Qj)("credit-card",60105),dash:(0,i.$Qj)("dash",60108),dashboard:(0,i.$Qj)("dashboard",60109),database:(0,i.$Qj)("database",60110),debugContinue:(0,i.$Qj)("debug-continue",60111),debugDisconnect:(0,i.$Qj)("debug-disconnect",60112),debugPause:(0,i.$Qj)("debug-pause",60113),debugRestart:(0,i.$Qj)("debug-restart",60114),debugStart:(0,i.$Qj)("debug-start",60115),debugStepInto:(0,i.$Qj)("debug-step-into",60116),debugStepOut:(0,i.$Qj)("debug-step-out",60117),debugStepOver:(0,i.$Qj)("debug-step-over",60118),debugStop:(0,i.$Qj)("debug-stop",60119),debug:(0,i.$Qj)("debug",60120),deviceCameraVideo:(0,i.$Qj)("device-camera-video",60121),deviceCamera:(0,i.$Qj)("device-camera",60122),deviceMobile:(0,i.$Qj)("device-mobile",60123),diffAdded:(0,i.$Qj)("diff-added",60124),diffIgnored:(0,i.$Qj)("diff-ignored",60125),diffModified:(0,i.$Qj)("diff-modified",60126),diffRemoved:(0,i.$Qj)("diff-removed",60127),diffRenamed:(0,i.$Qj)("diff-renamed",60128),diff:(0,i.$Qj)("diff",60129),diffSidebyside:(0,i.$Qj)("diff-sidebyside",60129),discard:(0,i.$Qj)("discard",60130),editorLayout:(0,i.$Qj)("editor-layout",60131),emptyWindow:(0,i.$Qj)("empty-window",60132),exclude:(0,i.$Qj)("exclude",60133),extensions:(0,i.$Qj)("extensions",60134),eyeClosed:(0,i.$Qj)("eye-closed",60135),fileBinary:(0,i.$Qj)("file-binary",60136),fileCode:(0,i.$Qj)("file-code",60137),fileMedia:(0,i.$Qj)("file-media",60138),filePdf:(0,i.$Qj)("file-pdf",60139),fileSubmodule:(0,i.$Qj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Qj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Qj)("file-symlink-file",60142),fileZip:(0,i.$Qj)("file-zip",60143),files:(0,i.$Qj)("files",60144),filter:(0,i.$Qj)("filter",60145),flame:(0,i.$Qj)("flame",60146),foldDown:(0,i.$Qj)("fold-down",60147),foldUp:(0,i.$Qj)("fold-up",60148),fold:(0,i.$Qj)("fold",60149),folderActive:(0,i.$Qj)("folder-active",60150),folderOpened:(0,i.$Qj)("folder-opened",60151),gear:(0,i.$Qj)("gear",60152),gift:(0,i.$Qj)("gift",60153),gistSecret:(0,i.$Qj)("gist-secret",60154),gist:(0,i.$Qj)("gist",60155),gitCommit:(0,i.$Qj)("git-commit",60156),gitCompare:(0,i.$Qj)("git-compare",60157),compareChanges:(0,i.$Qj)("compare-changes",60157),gitMerge:(0,i.$Qj)("git-merge",60158),githubAction:(0,i.$Qj)("github-action",60159),githubAlt:(0,i.$Qj)("github-alt",60160),globe:(0,i.$Qj)("globe",60161),grabber:(0,i.$Qj)("grabber",60162),graph:(0,i.$Qj)("graph",60163),gripper:(0,i.$Qj)("gripper",60164),heart:(0,i.$Qj)("heart",60165),home:(0,i.$Qj)("home",60166),horizontalRule:(0,i.$Qj)("horizontal-rule",60167),hubot:(0,i.$Qj)("hubot",60168),inbox:(0,i.$Qj)("inbox",60169),issueReopened:(0,i.$Qj)("issue-reopened",60171),issues:(0,i.$Qj)("issues",60172),italic:(0,i.$Qj)("italic",60173),jersey:(0,i.$Qj)("jersey",60174),json:(0,i.$Qj)("json",60175),kebabVertical:(0,i.$Qj)("kebab-vertical",60176),key:(0,i.$Qj)("key",60177),law:(0,i.$Qj)("law",60178),lightbulbAutofix:(0,i.$Qj)("lightbulb-autofix",60179),linkExternal:(0,i.$Qj)("link-external",60180),link:(0,i.$Qj)("link",60181),listOrdered:(0,i.$Qj)("list-ordered",60182),listUnordered:(0,i.$Qj)("list-unordered",60183),liveShare:(0,i.$Qj)("live-share",60184),loading:(0,i.$Qj)("loading",60185),location:(0,i.$Qj)("location",60186),mailRead:(0,i.$Qj)("mail-read",60187),mail:(0,i.$Qj)("mail",60188),markdown:(0,i.$Qj)("markdown",60189),megaphone:(0,i.$Qj)("megaphone",60190),mention:(0,i.$Qj)("mention",60191),milestone:(0,i.$Qj)("milestone",60192),gitPullRequestMilestone:(0,i.$Qj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Qj)("mortar-board",60193),move:(0,i.$Qj)("move",60194),multipleWindows:(0,i.$Qj)("multiple-windows",60195),mute:(0,i.$Qj)("mute",60196),noNewline:(0,i.$Qj)("no-newline",60197),note:(0,i.$Qj)("note",60198),octoface:(0,i.$Qj)("octoface",60199),openPreview:(0,i.$Qj)("open-preview",60200),package:(0,i.$Qj)("package",60201),paintcan:(0,i.$Qj)("paintcan",60202),pin:(0,i.$Qj)("pin",60203),play:(0,i.$Qj)("play",60204),run:(0,i.$Qj)("run",60204),plug:(0,i.$Qj)("plug",60205),preserveCase:(0,i.$Qj)("preserve-case",60206),preview:(0,i.$Qj)("preview",60207),project:(0,i.$Qj)("project",60208),pulse:(0,i.$Qj)("pulse",60209),question:(0,i.$Qj)("question",60210),quote:(0,i.$Qj)("quote",60211),radioTower:(0,i.$Qj)("radio-tower",60212),reactions:(0,i.$Qj)("reactions",60213),references:(0,i.$Qj)("references",60214),refresh:(0,i.$Qj)("refresh",60215),regex:(0,i.$Qj)("regex",60216),remoteExplorer:(0,i.$Qj)("remote-explorer",60217),remote:(0,i.$Qj)("remote",60218),remove:(0,i.$Qj)("remove",60219),replaceAll:(0,i.$Qj)("replace-all",60220),replace:(0,i.$Qj)("replace",60221),repoClone:(0,i.$Qj)("repo-clone",60222),repoForcePush:(0,i.$Qj)("repo-force-push",60223),repoPull:(0,i.$Qj)("repo-pull",60224),repoPush:(0,i.$Qj)("repo-push",60225),report:(0,i.$Qj)("report",60226),requestChanges:(0,i.$Qj)("request-changes",60227),rocket:(0,i.$Qj)("rocket",60228),rootFolderOpened:(0,i.$Qj)("root-folder-opened",60229),rootFolder:(0,i.$Qj)("root-folder",60230),rss:(0,i.$Qj)("rss",60231),ruby:(0,i.$Qj)("ruby",60232),saveAll:(0,i.$Qj)("save-all",60233),saveAs:(0,i.$Qj)("save-as",60234),save:(0,i.$Qj)("save",60235),screenFull:(0,i.$Qj)("screen-full",60236),screenNormal:(0,i.$Qj)("screen-normal",60237),searchStop:(0,i.$Qj)("search-stop",60238),server:(0,i.$Qj)("server",60240),settingsGear:(0,i.$Qj)("settings-gear",60241),settings:(0,i.$Qj)("settings",60242),shield:(0,i.$Qj)("shield",60243),smiley:(0,i.$Qj)("smiley",60244),sortPrecedence:(0,i.$Qj)("sort-precedence",60245),splitHorizontal:(0,i.$Qj)("split-horizontal",60246),splitVertical:(0,i.$Qj)("split-vertical",60247),squirrel:(0,i.$Qj)("squirrel",60248),starFull:(0,i.$Qj)("star-full",60249),starHalf:(0,i.$Qj)("star-half",60250),symbolClass:(0,i.$Qj)("symbol-class",60251),symbolColor:(0,i.$Qj)("symbol-color",60252),symbolConstant:(0,i.$Qj)("symbol-constant",60253),symbolEnumMember:(0,i.$Qj)("symbol-enum-member",60254),symbolField:(0,i.$Qj)("symbol-field",60255),symbolFile:(0,i.$Qj)("symbol-file",60256),symbolInterface:(0,i.$Qj)("symbol-interface",60257),symbolKeyword:(0,i.$Qj)("symbol-keyword",60258),symbolMisc:(0,i.$Qj)("symbol-misc",60259),symbolOperator:(0,i.$Qj)("symbol-operator",60260),symbolProperty:(0,i.$Qj)("symbol-property",60261),wrench:(0,i.$Qj)("wrench",60261),wrenchSubaction:(0,i.$Qj)("wrench-subaction",60261),symbolSnippet:(0,i.$Qj)("symbol-snippet",60262),tasklist:(0,i.$Qj)("tasklist",60263),telescope:(0,i.$Qj)("telescope",60264),textSize:(0,i.$Qj)("text-size",60265),threeBars:(0,i.$Qj)("three-bars",60266),thumbsdown:(0,i.$Qj)("thumbsdown",60267),thumbsup:(0,i.$Qj)("thumbsup",60268),tools:(0,i.$Qj)("tools",60269),triangleDown:(0,i.$Qj)("triangle-down",60270),triangleLeft:(0,i.$Qj)("triangle-left",60271),triangleRight:(0,i.$Qj)("triangle-right",60272),triangleUp:(0,i.$Qj)("triangle-up",60273),twitter:(0,i.$Qj)("twitter",60274),unfold:(0,i.$Qj)("unfold",60275),unlock:(0,i.$Qj)("unlock",60276),unmute:(0,i.$Qj)("unmute",60277),unverified:(0,i.$Qj)("unverified",60278),verified:(0,i.$Qj)("verified",60279),versions:(0,i.$Qj)("versions",60280),vmActive:(0,i.$Qj)("vm-active",60281),vmOutline:(0,i.$Qj)("vm-outline",60282),vmRunning:(0,i.$Qj)("vm-running",60283),watch:(0,i.$Qj)("watch",60284),whitespace:(0,i.$Qj)("whitespace",60285),wholeWord:(0,i.$Qj)("whole-word",60286),window:(0,i.$Qj)("window",60287),wordWrap:(0,i.$Qj)("word-wrap",60288),zoomIn:(0,i.$Qj)("zoom-in",60289),zoomOut:(0,i.$Qj)("zoom-out",60290),listFilter:(0,i.$Qj)("list-filter",60291),listFlat:(0,i.$Qj)("list-flat",60292),listSelection:(0,i.$Qj)("list-selection",60293),selection:(0,i.$Qj)("selection",60293),listTree:(0,i.$Qj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Qj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Qj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Qj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Qj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Qj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Qj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Qj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Qj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Qj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Qj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Qj)("symbol-string",60301),debugReverseContinue:(0,i.$Qj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Qj)("debug-step-back",60303),debugRestartFrame:(0,i.$Qj)("debug-restart-frame",60304),debugAlt:(0,i.$Qj)("debug-alt",60305),callIncoming:(0,i.$Qj)("call-incoming",60306),callOutgoing:(0,i.$Qj)("call-outgoing",60307),menu:(0,i.$Qj)("menu",60308),expandAll:(0,i.$Qj)("expand-all",60309),feedback:(0,i.$Qj)("feedback",60310),gitPullRequestReviewer:(0,i.$Qj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Qj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Qj)("ungroup-by-ref-type",60312),account:(0,i.$Qj)("account",60313),gitPullRequestAssignee:(0,i.$Qj)("git-pull-request-assignee",60313),bellDot:(0,i.$Qj)("bell-dot",60314),debugConsole:(0,i.$Qj)("debug-console",60315),library:(0,i.$Qj)("library",60316),output:(0,i.$Qj)("output",60317),runAll:(0,i.$Qj)("run-all",60318),syncIgnored:(0,i.$Qj)("sync-ignored",60319),pinned:(0,i.$Qj)("pinned",60320),githubInverted:(0,i.$Qj)("github-inverted",60321),serverProcess:(0,i.$Qj)("server-process",60322),serverEnvironment:(0,i.$Qj)("server-environment",60323),pass:(0,i.$Qj)("pass",60324),issueClosed:(0,i.$Qj)("issue-closed",60324),stopCircle:(0,i.$Qj)("stop-circle",60325),playCircle:(0,i.$Qj)("play-circle",60326),record:(0,i.$Qj)("record",60327),debugAltSmall:(0,i.$Qj)("debug-alt-small",60328),vmConnect:(0,i.$Qj)("vm-connect",60329),cloud:(0,i.$Qj)("cloud",60330),merge:(0,i.$Qj)("merge",60331),export:(0,i.$Qj)("export",60332),graphLeft:(0,i.$Qj)("graph-left",60333),magnet:(0,i.$Qj)("magnet",60334),notebook:(0,i.$Qj)("notebook",60335),redo:(0,i.$Qj)("redo",60336),checkAll:(0,i.$Qj)("check-all",60337),pinnedDirty:(0,i.$Qj)("pinned-dirty",60338),passFilled:(0,i.$Qj)("pass-filled",60339),circleLargeFilled:(0,i.$Qj)("circle-large-filled",60340),circleLarge:(0,i.$Qj)("circle-large",60341),circleLargeOutline:(0,i.$Qj)("circle-large-outline",60341),combine:(0,i.$Qj)("combine",60342),gather:(0,i.$Qj)("gather",60342),table:(0,i.$Qj)("table",60343),variableGroup:(0,i.$Qj)("variable-group",60344),typeHierarchy:(0,i.$Qj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Qj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Qj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Qj)("git-pull-request-create",60348),runAbove:(0,i.$Qj)("run-above",60349),runBelow:(0,i.$Qj)("run-below",60350),notebookTemplate:(0,i.$Qj)("notebook-template",60351),debugRerun:(0,i.$Qj)("debug-rerun",60352),workspaceTrusted:(0,i.$Qj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Qj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Qj)("workspace-unknown",60355),terminalCmd:(0,i.$Qj)("terminal-cmd",60356),terminalDebian:(0,i.$Qj)("terminal-debian",60357),terminalLinux:(0,i.$Qj)("terminal-linux",60358),terminalPowershell:(0,i.$Qj)("terminal-powershell",60359),terminalTmux:(0,i.$Qj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Qj)("terminal-ubuntu",60361),terminalBash:(0,i.$Qj)("terminal-bash",60362),arrowSwap:(0,i.$Qj)("arrow-swap",60363),copy:(0,i.$Qj)("copy",60364),personAdd:(0,i.$Qj)("person-add",60365),filterFilled:(0,i.$Qj)("filter-filled",60366),wand:(0,i.$Qj)("wand",60367),debugLineByLine:(0,i.$Qj)("debug-line-by-line",60368),inspect:(0,i.$Qj)("inspect",60369),layers:(0,i.$Qj)("layers",60370),layersDot:(0,i.$Qj)("layers-dot",60371),layersActive:(0,i.$Qj)("layers-active",60372),compass:(0,i.$Qj)("compass",60373),compassDot:(0,i.$Qj)("compass-dot",60374),compassActive:(0,i.$Qj)("compass-active",60375),azure:(0,i.$Qj)("azure",60376),issueDraft:(0,i.$Qj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Qj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Qj)("git-pull-request-draft",60379),debugAll:(0,i.$Qj)("debug-all",60380),debugCoverage:(0,i.$Qj)("debug-coverage",60381),runErrors:(0,i.$Qj)("run-errors",60382),folderLibrary:(0,i.$Qj)("folder-library",60383),debugContinueSmall:(0,i.$Qj)("debug-continue-small",60384),beakerStop:(0,i.$Qj)("beaker-stop",60385),graphLine:(0,i.$Qj)("graph-line",60386),graphScatter:(0,i.$Qj)("graph-scatter",60387),pieChart:(0,i.$Qj)("pie-chart",60388),bracket:(0,i.$Qj)("bracket",60175),bracketDot:(0,i.$Qj)("bracket-dot",60389),bracketError:(0,i.$Qj)("bracket-error",60390),lockSmall:(0,i.$Qj)("lock-small",60391),azureDevops:(0,i.$Qj)("azure-devops",60392),verifiedFilled:(0,i.$Qj)("verified-filled",60393),newline:(0,i.$Qj)("newline",60394),layout:(0,i.$Qj)("layout",60395),layoutActivitybarLeft:(0,i.$Qj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Qj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Qj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Qj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Qj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Qj)("layout-panel-right",60401),layoutPanel:(0,i.$Qj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Qj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Qj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Qj)("layout-statusbar",60405),layoutMenubar:(0,i.$Qj)("layout-menubar",60406),layoutCentered:(0,i.$Qj)("layout-centered",60407),target:(0,i.$Qj)("target",60408),indent:(0,i.$Qj)("indent",60409),recordSmall:(0,i.$Qj)("record-small",60410),errorSmall:(0,i.$Qj)("error-small",60411),terminalDecorationError:(0,i.$Qj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Qj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Qj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Qj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Qj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Qj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Qj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Qj)("layout-sidebar-left-off",60418),blank:(0,i.$Qj)("blank",60419),heartFilled:(0,i.$Qj)("heart-filled",60420),map:(0,i.$Qj)("map",60421),mapHorizontal:(0,i.$Qj)("map-horizontal",60421),foldHorizontal:(0,i.$Qj)("fold-horizontal",60421),mapFilled:(0,i.$Qj)("map-filled",60422),mapHorizontalFilled:(0,i.$Qj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Qj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Qj)("circle-small",60423),bellSlash:(0,i.$Qj)("bell-slash",60424),bellSlashDot:(0,i.$Qj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Qj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Qj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Qj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Qj)("search-fuzzy",60429),commentDraft:(0,i.$Qj)("comment-draft",60430),send:(0,i.$Qj)("send",60431),sparkle:(0,i.$Qj)("sparkle",60432),insert:(0,i.$Qj)("insert",60433),mic:(0,i.$Qj)("mic",60434),thumbsdownFilled:(0,i.$Qj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Qj)("thumbsup-filled",60436),coffee:(0,i.$Qj)("coffee",60437),snake:(0,i.$Qj)("snake",60438),game:(0,i.$Qj)("game",60439),vr:(0,i.$Qj)("vr",60440),chip:(0,i.$Qj)("chip",60441),piano:(0,i.$Qj)("piano",60442),music:(0,i.$Qj)("music",60443),micFilled:(0,i.$Qj)("mic-filled",60444),repoFetch:(0,i.$Qj)("repo-fetch",60445),copilot:(0,i.$Qj)("copilot",60446),lightbulbSparkle:(0,i.$Qj)("lightbulb-sparkle",60447),robot:(0,i.$Qj)("robot",60448),sparkleFilled:(0,i.$Qj)("sparkle-filled",60449),diffSingle:(0,i.$Qj)("diff-single",60450),diffMultiple:(0,i.$Qj)("diff-multiple",60451),surroundWith:(0,i.$Qj)("surround-with",60452),share:(0,i.$Qj)("share",60453),gitStash:(0,i.$Qj)("git-stash",60454),gitStashApply:(0,i.$Qj)("git-stash-apply",60455),gitStashPop:(0,i.$Qj)("git-stash-pop",60456),vscode:(0,i.$Qj)("vscode",60457),vscodeInsiders:(0,i.$Qj)("vscode-insiders",60458),codeOss:(0,i.$Qj)("code-oss",60459),runCoverage:(0,i.$Qj)("run-coverage",60460),runAllCoverage:(0,i.$Qj)("run-all-coverage",60461),coverage:(0,i.$Qj)("coverage",60462),githubProject:(0,i.$Qj)("github-project",60463),mapVertical:(0,i.$Qj)("map-vertical",60464),foldVertical:(0,i.$Qj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Qj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Qj)("fold-vertical-filled",60465),goToSearch:(0,i.$Qj)("go-to-search",60466),percentage:(0,i.$Qj)("percentage",60467),sortPercentage:(0,i.$Qj)("sort-percentage",60467)}}),se(ue[43],ae([0,1,27,42]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vj=t.$Uj=void 0,t.$Tj=M;function M(){return Object.values(t.$Vj)}t.$Uj={dialogError:(0,i.$Qj)("dialog-error","error"),dialogWarning:(0,i.$Qj)("dialog-warning","warning"),dialogInfo:(0,i.$Qj)("dialog-info","info"),dialogClose:(0,i.$Qj)("dialog-close","close"),treeItemExpanded:(0,i.$Qj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Qj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Qj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Qj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Qj)("tree-item-loading","loading"),menuSelection:(0,i.$Qj)("menu-selection","check"),menuSubmenu:(0,i.$Qj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Qj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Qj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Qj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Qj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Qj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Qj)("toolbar-more","more"),quickInputBack:(0,i.$Qj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Qj)("drop-down-button",60084),symbolCustomColor:(0,i.$Qj)("symbol-customcolor",60252),exportIcon:(0,i.$Qj)("export",60332),workspaceUnspecified:(0,i.$Qj)("workspace-unspecified",60355),newLine:(0,i.$Qj)("newline",60394),thumbsDownFilled:(0,i.$Qj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Qj)("thumbsup-filled",60436),gitFetch:(0,i.$Qj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Qj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Qj)("debug-breakpoint-pending",60377)},t.$Vj={...F.$Sj,...t.$Uj}}),se(ue[15],ae([0,1,26]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3n=F,t.$4n=M,t.$5n=p,t.$6n=a,t.$7n=u,t.$8n=f,t.$9n=w,t.$0n=g,t.$$n=m,t.$_n=e,t.$ao=L,t.$bo=E;function F(N){if(!N||typeof N!="object"||N instanceof RegExp)return N;const $=Array.isArray(N)?[]:{};return Object.entries(N).forEach(([v,j])=>{$[v]=j&&typeof j=="object"?F(j):j}),$}function M(N){if(!N||typeof N!="object")return N;const $=[N];for(;$.length>0;){const v=$.shift();Object.freeze(v);for(const j in v)if(c.call(v,j)){const l=v[j];typeof l=="object"&&!Object.isFrozen(l)&&!(0,i.$_f)(l)&&$.push(l)}}return N}const c=Object.prototype.hasOwnProperty;function p(N,$){return d(N,$,new Set)}function d(N,$,v){if((0,i.$fg)(N))return N;const j=$(N);if(typeof j<"u")return j;if(Array.isArray(N)){const l=[];for(const n of N)l.push(d(n,$,v));return l}if((0,i.$$f)(N)){if(v.has(N))throw new Error("Cannot clone recursive data-structure");v.add(N);const l={};for(const n in N)c.call(N,n)&&(l[n]=d(N[n],$,v));return v.delete(N),l}return N}function a(N,$,v=!0){return(0,i.$$f)(N)?((0,i.$$f)($)&&Object.keys($).forEach(j=>{j in N?v&&((0,i.$$f)(N[j])&&(0,i.$$f)($[j])?a(N[j],$[j],v):N[j]=$[j]):N[j]=$[j]}),N):$}function u(N,$){if(N===$)return!0;if(N==null||$===null||$===void 0||typeof N!=typeof $||typeof N!="object"||Array.isArray(N)!==Array.isArray($))return!1;let v,j;if(Array.isArray(N)){if(N.length!==$.length)return!1;for(v=0;v<N.length;v++)if(!u(N[v],$[v]))return!1}else{const l=[];for(j in N)l.push(j);l.sort();const n=[];for(j in $)n.push(j);if(n.sort(),!u(l,n))return!1;for(v=0;v<l.length;v++)if(!u(N[l[v]],$[l[v]]))return!1}return!0}function f(N){const $=new Set;return JSON.stringify(N,(v,j)=>{if((0,i.$$f)(j)||Array.isArray(j)){if($.has(j))return"[Circular]";$.add(j)}return typeof j=="bigint"?`[BigInt ${j.toString()}]`:j})}function w(N,$){const v=Object.create(null);return!N||!$||Object.keys($).forEach(l=>{const n=N[l],s=$[l];u(n,s)||(v[l]=s)}),v}function g(N,$){const v=$.toLowerCase(),j=Object.keys(N).find(l=>l.toLowerCase()===v);return j?N[j]:N[$]}function m(N,$){const v=Object.create(null);for(const[j,l]of Object.entries(N))$(j,l)&&(v[j]=l);return v}function e(N){let $=[];for(;Object.prototype!==N;)$=$.concat(Object.getOwnPropertyNames(N)),N=Object.getPrototypeOf(N);return $}function L(N){const $=[];for(const v of e(N))typeof N[v]=="function"&&$.push(v);return $}function E(N,$){const v=l=>function(){const n=Array.prototype.slice.call(arguments,0);return $(l,n)},j={};for(const l of N)j[l]=v(l);return j}}),se(ue[28],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$6e=F,t.$7e=M;var i;(function(c){c[c.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",c[c.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",c[c.MAX_UINT_8=255]="MAX_UINT_8",c[c.MAX_UINT_16=65535]="MAX_UINT_16",c[c.MAX_UINT_32=4294967295]="MAX_UINT_32",c[c.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function F(c){return c<0?0:c>255?255:c|0}function M(c){return c<0?0:c>4294967295?4294967295:c|0}}),se(ue[29],ae([0,1,28]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jt=t.$It=void 0;class F{constructor(d){const a=(0,i.$6e)(d);this.c=a,this.a=F.d(a),this.b=new Map}static d(d){const a=new Uint8Array(256);return a.fill(d),a}set(d,a){const u=(0,i.$6e)(a);d>=0&&d<256?this.a[d]=u:this.b.set(d,u)}get(d){return d>=0&&d<256?this.a[d]:this.b.get(d)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$It=F;var M;(function(p){p[p.False=0]="False",p[p.True=1]="True"})(M||(M={}));class c{constructor(){this.a=new F(0)}add(d){this.a.set(d,1)}has(d){return this.a.get(d)===1}clear(){return this.a.clear()}}t.$Jt=c}),se(ue[4],ae([0,1,3]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ct=t.$Bt=void 0;class F{static addRange(p,d){let a=0;for(;a<d.length&&d[a].endExclusive<p.start;)a++;let u=a;for(;u<d.length&&d[u].start<=p.endExclusive;)u++;if(a===u)d.splice(a,0,p);else{const f=Math.min(p.start,d[a].start),w=Math.max(p.endExclusive,d[u-1].endExclusive);d.splice(a,u-a,new F(f,w))}}static tryCreate(p,d){if(!(p>d))return new F(p,d)}static ofLength(p){return new F(0,p)}static ofStartAndLength(p,d){return new F(p,p+d)}constructor(p,d){if(this.start=p,this.endExclusive=d,p>d)throw new i.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(p){return new F(this.start+p,this.endExclusive+p)}deltaStart(p){return new F(this.start+p,this.endExclusive)}deltaEnd(p){return new F(this.start,this.endExclusive+p)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(p){return this.start===p.start&&this.endExclusive===p.endExclusive}containsRange(p){return this.start<=p.start&&p.endExclusive<=this.endExclusive}contains(p){return this.start<=p&&p<this.endExclusive}join(p){return new F(Math.min(this.start,p.start),Math.max(this.endExclusive,p.endExclusive))}intersect(p){const d=Math.max(this.start,p.start),a=Math.min(this.endExclusive,p.endExclusive);if(d<=a)return new F(d,a)}intersects(p){const d=Math.max(this.start,p.start),a=Math.min(this.endExclusive,p.endExclusive);return d<a}intersectsOrTouches(p){const d=Math.max(this.start,p.start),a=Math.min(this.endExclusive,p.endExclusive);return d<=a}isBefore(p){return this.endExclusive<=p.start}isAfter(p){return this.start>=p.endExclusive}slice(p){return p.slice(this.start,this.endExclusive)}substring(p){return p.substring(this.start,this.endExclusive)}clip(p){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,p))}clipCyclic(p){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return p<this.start?this.endExclusive-(this.start-p)%this.length:p>=this.endExclusive?this.start+(p-this.start)%this.length:p}map(p){const d=[];for(let a=this.start;a<this.endExclusive;a++)d.push(p(a));return d}forEach(p){for(let d=this.start;d<this.endExclusive;d++)p(d)}}t.$Bt=F;class M{constructor(){this.a=[]}addRange(p){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<p.start;)d++;let a=d;for(;a<this.a.length&&this.a[a].start<=p.endExclusive;)a++;if(d===a)this.a.splice(d,0,p);else{const u=Math.min(p.start,this.a[d].start),f=Math.max(p.endExclusive,this.a[a-1].endExclusive);this.a.splice(d,a-d,new F(u,f))}}toString(){return this.a.map(p=>p.toString()).join(", ")}intersectsStrict(p){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<=p.start;)d++;return d<this.a.length&&this.a[d].start<p.endExclusive}intersectWithRange(p){const d=new M;for(const a of this.a){const u=a.intersect(p);u&&d.addRange(u)}return d}intersectWithRangeLength(p){return this.intersectWithRange(p).length}get length(){return this.a.reduce((p,d)=>p+d.length,0)}}t.$Ct=M}),se(ue[5],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tt=void 0;class i{constructor(M,c){this.lineNumber=M,this.column=c}with(M=this.lineNumber,c=this.column){return M===this.lineNumber&&c===this.column?this:new i(M,c)}delta(M=0,c=0){return this.with(this.lineNumber+M,this.column+c)}equals(M){return i.equals(this,M)}static equals(M,c){return!M&&!c?!0:!!M&&!!c&&M.lineNumber===c.lineNumber&&M.column===c.column}isBefore(M){return i.isBefore(this,M)}static isBefore(M,c){return M.lineNumber<c.lineNumber?!0:c.lineNumber<M.lineNumber?!1:M.column<c.column}isBeforeOrEqual(M){return i.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,c){return M.lineNumber<c.lineNumber?!0:c.lineNumber<M.lineNumber?!1:M.column<=c.column}static compare(M,c){const p=M.lineNumber|0,d=c.lineNumber|0;if(p===d){const a=M.column|0,u=c.column|0;return a-u}return p-d}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new i(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$tt=i}),se(ue[2],ae([0,1,5]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ut=void 0;class F{constructor(c,p,d,a){c>d||c===d&&p>a?(this.startLineNumber=d,this.startColumn=a,this.endLineNumber=c,this.endColumn=p):(this.startLineNumber=c,this.startColumn=p,this.endLineNumber=d,this.endColumn=a)}isEmpty(){return F.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return F.containsPosition(this,c)}static containsPosition(c,p){return!(p.lineNumber<c.startLineNumber||p.lineNumber>c.endLineNumber||p.lineNumber===c.startLineNumber&&p.column<c.startColumn||p.lineNumber===c.endLineNumber&&p.column>c.endColumn)}static strictContainsPosition(c,p){return!(p.lineNumber<c.startLineNumber||p.lineNumber>c.endLineNumber||p.lineNumber===c.startLineNumber&&p.column<=c.startColumn||p.lineNumber===c.endLineNumber&&p.column>=c.endColumn)}containsRange(c){return F.containsRange(this,c)}static containsRange(c,p){return!(p.startLineNumber<c.startLineNumber||p.endLineNumber<c.startLineNumber||p.startLineNumber>c.endLineNumber||p.endLineNumber>c.endLineNumber||p.startLineNumber===c.startLineNumber&&p.startColumn<c.startColumn||p.endLineNumber===c.endLineNumber&&p.endColumn>c.endColumn)}strictContainsRange(c){return F.strictContainsRange(this,c)}static strictContainsRange(c,p){return!(p.startLineNumber<c.startLineNumber||p.endLineNumber<c.startLineNumber||p.startLineNumber>c.endLineNumber||p.endLineNumber>c.endLineNumber||p.startLineNumber===c.startLineNumber&&p.startColumn<=c.startColumn||p.endLineNumber===c.endLineNumber&&p.endColumn>=c.endColumn)}plusRange(c){return F.plusRange(this,c)}static plusRange(c,p){let d,a,u,f;return p.startLineNumber<c.startLineNumber?(d=p.startLineNumber,a=p.startColumn):p.startLineNumber===c.startLineNumber?(d=p.startLineNumber,a=Math.min(p.startColumn,c.startColumn)):(d=c.startLineNumber,a=c.startColumn),p.endLineNumber>c.endLineNumber?(u=p.endLineNumber,f=p.endColumn):p.endLineNumber===c.endLineNumber?(u=p.endLineNumber,f=Math.max(p.endColumn,c.endColumn)):(u=c.endLineNumber,f=c.endColumn),new F(d,a,u,f)}intersectRanges(c){return F.intersectRanges(this,c)}static intersectRanges(c,p){let d=c.startLineNumber,a=c.startColumn,u=c.endLineNumber,f=c.endColumn;const w=p.startLineNumber,g=p.startColumn,m=p.endLineNumber,e=p.endColumn;return d<w?(d=w,a=g):d===w&&(a=Math.max(a,g)),u>m?(u=m,f=e):u===m&&(f=Math.min(f,e)),d>u||d===u&&a>f?null:new F(d,a,u,f)}equalsRange(c){return F.equalsRange(this,c)}static equalsRange(c,p){return!c&&!p?!0:!!c&&!!p&&c.startLineNumber===p.startLineNumber&&c.startColumn===p.startColumn&&c.endLineNumber===p.endLineNumber&&c.endColumn===p.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(c){return new i.$tt(c.endLineNumber,c.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(c){return new i.$tt(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,p){return new F(this.startLineNumber,this.startColumn,c,p)}setStartPosition(c,p){return new F(c,p,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(c){return new F(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(c){return new F(c.endLineNumber,c.endColumn,c.endLineNumber,c.endColumn)}delta(c){return new F(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static fromPositions(c,p=c){return new F(c.lineNumber,c.column,p.lineNumber,p.column)}static lift(c){return c?new F(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,p){return!(c.endLineNumber<p.startLineNumber||c.endLineNumber===p.startLineNumber&&c.endColumn<p.startColumn||p.endLineNumber<c.startLineNumber||p.endLineNumber===c.startLineNumber&&p.endColumn<c.startColumn)}static areIntersecting(c,p){return!(c.endLineNumber<p.startLineNumber||c.endLineNumber===p.startLineNumber&&c.endColumn<=p.startColumn||p.endLineNumber<c.startLineNumber||p.endLineNumber===c.startLineNumber&&p.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,p){if(c&&p){const u=c.startLineNumber|0,f=p.startLineNumber|0;if(u===f){const w=c.startColumn|0,g=p.startColumn|0;if(w===g){const m=c.endLineNumber|0,e=p.endLineNumber|0;if(m===e){const L=c.endColumn|0,E=p.endColumn|0;return L-E}return m-e}return w-g}return u-f}return(c?1:0)-(p?1:0)}static compareRangesUsingEnds(c,p){return c.endLineNumber===p.endLineNumber?c.endColumn===p.endColumn?c.startLineNumber===p.startLineNumber?c.startColumn-p.startColumn:c.startLineNumber-p.startLineNumber:c.endColumn-p.endColumn:c.endLineNumber-p.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}t.$ut=F}),se(ue[44],ae([0,1,2]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vt=void 0;class F{static insert(c,p){return{range:new i.$ut(c.lineNumber,c.column,c.lineNumber,c.column),text:p,forceMoveMarkers:!0}}static delete(c){return{range:c,text:null}}static replace(c,p){return{range:c,text:p}}static replaceMove(c,p){return{range:c,text:p,forceMoveMarkers:!0}}}t.$vt=F}),se(ue[12],ae([0,1,3,4,2,9]),function(V,t,i,F,M,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mv=t.$Lv=void 0;class p{static fromRange(u){return new p(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new p(u.startLineNumber,u.endLineNumber+1)}static subtract(u,f){return f?u.startLineNumber<f.startLineNumber&&f.endLineNumberExclusive<u.endLineNumberExclusive?[new p(u.startLineNumber,f.startLineNumber),new p(f.endLineNumberExclusive,u.endLineNumberExclusive)]:f.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=f.endLineNumberExclusive?[]:f.endLineNumberExclusive<u.endLineNumberExclusive?[new p(Math.max(f.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new p(u.startLineNumber,Math.min(f.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let f=new d(u[0].slice());for(let w=1;w<u.length;w++)f=f.getUnion(new d(u[w].slice()));return f.ranges}static join(u){if(u.length===0)throw new i.$cb("lineRanges cannot be empty");let f=u[0].startLineNumber,w=u[0].endLineNumberExclusive;for(let g=1;g<u.length;g++)f=Math.min(f,u[g].startLineNumber),w=Math.max(w,u[g].endLineNumberExclusive);return new p(f,w)}static ofLength(u,f){return new p(u,u+f)}static deserialize(u){return new p(u[0],u[1])}static invert(u,f){if(u.isEmpty)return[];const w=[];return u.startLineNumber>1&&w.push(new p(1,u.startLineNumber)),u.endLineNumberExclusive<f.getLineCount()+1&&w.push(new p(u.endLineNumberExclusive,f.getLineCount()+1)),w.filter(g=>!g.isEmpty)}static asRange(u,f){return u.isEmpty?new M.$ut(u.startLineNumber,1,u.startLineNumber,f.getLineLength(u.startLineNumber)):new M.$ut(u.startLineNumber,1,u.endLineNumberExclusive-1,f.getLineLength(u.endLineNumberExclusive-1))}constructor(u,f){if(u>f)throw new i.$cb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${f}`);this.startLineNumber=u,this.endLineNumberExclusive=f}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new p(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new p(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new p(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const f=Math.max(this.startLineNumber,u.startLineNumber),w=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(f<=w)return new p(f,w)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new M.$ut(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new M.$ut(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const f=[];for(let w=this.startLineNumber;w<this.endLineNumberExclusive;w++)f.push(u(w));return f}forEach(u){for(let f=this.startLineNumber;f<this.endLineNumberExclusive;f++)u(f)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new F.$Bt(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$Lv=p;class d{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const f=(0,c.$kb)(this.c,g=>g.endLineNumberExclusive>=u.startLineNumber),w=(0,c.$ib)(this.c,g=>g.startLineNumber<=u.endLineNumberExclusive)+1;if(f===w)this.c.splice(f,0,u);else if(f===w-1){const g=this.c[f];this.c[f]=g.join(u)}else{const g=this.c[f].join(this.c[w-1]).join(u);this.c.splice(f,w-f,g)}}contains(u){const f=(0,c.$hb)(this.c,w=>w.startLineNumber<=u);return!!f&&f.endLineNumberExclusive>u}intersects(u){const f=(0,c.$hb)(this.c,w=>w.startLineNumber<u.endLineNumberExclusive);return!!f&&f.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const f=[];let w=0,g=0,m=null;for(;w<this.c.length||g<u.c.length;){let e=null;if(w<this.c.length&&g<u.c.length){const L=this.c[w],E=u.c[g];L.startLineNumber<E.startLineNumber?(e=L,w++):(e=E,g++)}else w<this.c.length?(e=this.c[w],w++):(e=u.c[g],g++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new p(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(f.push(m),m=e)}return m!==null&&f.push(m),new d(f)}subtractFrom(u){const f=(0,c.$kb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),w=(0,c.$ib)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(f===w)return new d([u]);const g=[];let m=u.startLineNumber;for(let e=f;e<w;e++){const L=this.c[e];L.startLineNumber>m&&g.push(new p(m,L.startLineNumber)),m=L.endLineNumberExclusive}return m<u.endLineNumberExclusive&&g.push(new p(m,u.endLineNumberExclusive)),new d(g)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const f=[];let w=0,g=0;for(;w<this.c.length&&g<u.c.length;){const m=this.c[w],e=u.c[g],L=m.intersect(e);L&&!L.isEmpty&&f.push(L),m.endLineNumberExclusive<e.endLineNumberExclusive?w++:g++}return new d(f)}getWithDelta(u){return new d(this.c.map(f=>f.delta(u)))}}t.$Mv=d}),se(ue[45],ae([0,1,5,2]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wt=t.SelectionDirection=void 0;var M;(function(p){p[p.LTR=0]="LTR",p[p.RTL=1]="RTL"})(M||(t.SelectionDirection=M={}));class c extends F.$ut{constructor(d,a,u,f){super(d,a,u,f),this.selectionStartLineNumber=d,this.selectionStartColumn=a,this.positionLineNumber=u,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return c.selectionsEqual(this,d)}static selectionsEqual(d,a){return d.selectionStartLineNumber===a.selectionStartLineNumber&&d.selectionStartColumn===a.selectionStartColumn&&d.positionLineNumber===a.positionLineNumber&&d.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,a){return this.getDirection()===0?new c(this.startLineNumber,this.startColumn,d,a):new c(d,a,this.startLineNumber,this.startColumn)}getPosition(){return new i.$tt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new i.$tt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,a){return this.getDirection()===0?new c(d,a,this.endLineNumber,this.endColumn):new c(this.endLineNumber,this.endColumn,d,a)}static fromPositions(d,a=d){return new c(d.lineNumber,d.column,a.lineNumber,a.column)}static fromRange(d,a){return a===0?new c(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new c(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new c(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,a){if(d&&!a||!d&&a)return!1;if(!d&&!a)return!0;if(d.length!==a.length)return!1;for(let u=0,f=d.length;u<f;u++)if(!this.selectionsEqual(d[u],a[u]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,a,u,f,w){return w===0?new c(d,a,u,f):new c(u,f,d,a)}}t.$wt=c}),se(ue[46],ae([0,1,14,29]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kt=t.WordCharacterClass=void 0,t.$Lt=d;var M;(function(a){a[a.Regular=0]="Regular",a[a.Whitespace=1]="Whitespace",a[a.WordSeparator=2]="WordSeparator"})(M||(t.WordCharacterClass=M={}));class c extends F.$It{constructor(u,f){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=f,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let w=0,g=u.length;w<g;w++)this.set(u.charCodeAt(w),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(u,f){let w=null;for(const g of this.h(u)){if(g.index>f)break;w=g}return w}findNextIntlWordAtOrAfterOffset(u,f){for(const w of this.h(u))if(!(w.index<f))return w;return null}h(u){return this.e?this.f===u?this.g:(this.f=u,this.g=this.j(this.e.segment(u)),this.g):[]}j(u){const f=[];for(const w of u)this.k(w)&&f.push(w);return f}k(u){return!!u.isWordLike}}t.$Kt=c;const p=new i.$Ec(10);function d(a,u){const f=`${a}/${u.join(",")}`;let w=p.get(f);return w||(w=new c(a,u),p.set(f,w)),w}}),se(ue[30],ae([0,1,21,10,22]),function(V,t,i,F,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6s=t.$5s=void 0,t.$7s=p,t.$8s=a,t.$9s=u,t.$5s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function c(w=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$5s)w.indexOf(m)>=0||(g+="\\"+m);return g+="\\s]+)",new RegExp(g,"g")}t.$6s=c();function p(w){let g=t.$6s;if(w&&w instanceof RegExp)if(w.global)g=w;else{let m="g";w.ignoreCase&&(m+="i"),w.multiline&&(m+="m"),w.unicode&&(m+="u"),g=new RegExp(w.source,m)}return g.lastIndex=0,g}const d=new M.$6c;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(w){const g=d.unshift(w);return(0,F.$Tc)(g)}function u(w,g,m,e,L){if(g=p(g),L||(L=i.Iterable.first(d)),m.length>L.maxLen){let j=w-L.maxLen/2;return j<0?j=0:e+=j,m=m.substring(j,w+L.maxLen/2),u(w,g,m,e,L)}const E=Date.now(),N=w-1-e;let $=-1,v=null;for(let j=1;!(Date.now()-E>=L.timeBudget);j++){const l=N-L.windowSize*j;g.lastIndex=Math.max(0,l);const n=f(g,m,N,$);if(!n&&v||(v=n,l<=0))break;$=l}if(v){const j={word:v[0],startColumn:e+1+v.index,endColumn:e+1+v.index+v[0].length};return g.lastIndex=0,j}return null}function f(w,g,m,e){let L;for(;L=w.exec(g);){const E=L.index||0;if(E<=m&&w.lastIndex>=m)return L;if(e>0&&E>e)return null}return null}}),se(ue[8],ae([0,1,6,3,4]),function(V,t,i,F,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$v3=t.$u3=t.$t3=t.$s3=t.$r3=void 0;class c{static trivial(w,g){return new c([new p(M.$Bt.ofLength(w.length),M.$Bt.ofLength(g.length))],!1)}static trivialTimedOut(w,g){return new c([new p(M.$Bt.ofLength(w.length),M.$Bt.ofLength(g.length))],!0)}constructor(w,g){this.diffs=w,this.hitTimeout=g}}t.$r3=c;class p{static invert(w,g){const m=[];return(0,i.$Bb)(w,(e,L)=>{m.push(p.fromOffsetPairs(e?e.getEndExclusives():d.zero,L?L.getStarts():new d(g,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+g)))}),m}static fromOffsetPairs(w,g){return new p(new M.$Bt(w.offset1,g.offset1),new M.$Bt(w.offset2,g.offset2))}constructor(w,g){this.seq1Range=w,this.seq2Range=g}swap(){return new p(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(w){return new p(this.seq1Range.join(w.seq1Range),this.seq2Range.join(w.seq2Range))}delta(w){return w===0?this:new p(this.seq1Range.delta(w),this.seq2Range.delta(w))}deltaStart(w){return w===0?this:new p(this.seq1Range.deltaStart(w),this.seq2Range.deltaStart(w))}deltaEnd(w){return w===0?this:new p(this.seq1Range.deltaEnd(w),this.seq2Range.deltaEnd(w))}intersectsOrTouches(w){return this.seq1Range.intersectsOrTouches(w.seq1Range)||this.seq2Range.intersectsOrTouches(w.seq2Range)}intersect(w){const g=this.seq1Range.intersect(w.seq1Range),m=this.seq2Range.intersect(w.seq2Range);if(!(!g||!m))return new p(g,m)}getStarts(){return new d(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new d(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$s3=p;class d{static{this.zero=new d(0,0)}static{this.max=new d(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(w,g){this.offset1=w,this.offset2=g}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(w){return w===0?this:new d(this.offset1+w,this.offset2+w)}equals(w){return this.offset1===w.offset1&&this.offset2===w.offset2}}t.$t3=d;class a{static{this.instance=new a}isValid(){return!0}}t.$u3=a;class u{constructor(w){if(this.e=w,this.c=Date.now(),this.d=!0,w<=0)throw new F.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$v3=u}),se(ue[31],ae([0,1,4,8]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$A3=void 0;class M{compute(u,f,w=F.$u3.instance){if(u.length===0||f.length===0)return F.$r3.trivial(u,f);const g=u,m=f;function e(s,h){for(;s<g.length&&h<m.length&&g.getElement(s)===m.getElement(h);)s++,h++;return s}let L=0;const E=new p;E.set(0,e(0,0));const N=new d;N.set(0,E.get(0)===0?null:new c(null,0,0,E.get(0)));let $=0;e:for(;;){if(L++,!w.isValid())return F.$r3.trivialTimedOut(g,m);const s=-Math.min(L,m.length+L%2),h=Math.min(L,g.length+L%2);for($=s;$<=h;$+=2){let o=0;const b=$===h?-1:E.get($+1),A=$===s?-1:E.get($-1)+1;o++;const R=Math.min(Math.max(b,A),g.length),y=R-$;if(o++,R>g.length||y>m.length)continue;const P=e(R,y);E.set($,P);const T=R===b?N.get($+1):N.get($-1);if(N.set($,P!==R?new c(T,R,y,P-R):T),E.get($)===g.length&&E.get($)-$===m.length)break e}}let v=N.get($);const j=[];let l=g.length,n=m.length;for(;;){const s=v?v.x+v.length:0,h=v?v.y+v.length:0;if((s!==l||h!==n)&&j.push(new F.$s3(new i.$Bt(s,l),new i.$Bt(h,n))),!v)break;l=v.x,n=v.y,v=v.prev}return j.reverse(),new F.$r3(j,!1)}}t.$A3=M;class c{constructor(u,f,w,g){this.prev=u,this.x=f,this.y=w,this.length=g}}class p{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,f){if(u<0){if(u=-u-1,u>=this.b.length){const w=this.b;this.b=new Int32Array(w.length*2),this.b.set(w)}this.b[u]=f}else{if(u>=this.a.length){const w=this.a;this.a=new Int32Array(w.length*2),this.a.set(w)}this.a[u]=f}}}class d{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,f){u<0?(u=-u-1,this.b[u]=f):this.a[u]=f}}}),se(ue[47],ae([0,1,6,4,8]),function(V,t,i,F,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$E3=c,t.$F3=u,t.$G3=f,t.$H3=g,t.$I3=m;function c(e,L,E){let N=E;return N=p(e,L,N),N=p(e,L,N),N=d(e,L,N),N}function p(e,L,E){if(E.length===0)return E;const N=[];N.push(E[0]);for(let v=1;v<E.length;v++){const j=N[N.length-1];let l=E[v];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=l.seq1Range.start-j.seq1Range.endExclusive;let s;for(s=1;s<=n&&!(e.getElement(l.seq1Range.start-s)!==e.getElement(l.seq1Range.endExclusive-s)||L.getElement(l.seq2Range.start-s)!==L.getElement(l.seq2Range.endExclusive-s));s++);if(s--,s===n){N[N.length-1]=new M.$s3(new F.$Bt(j.seq1Range.start,l.seq1Range.endExclusive-n),new F.$Bt(j.seq2Range.start,l.seq2Range.endExclusive-n));continue}l=l.delta(-s)}N.push(l)}const $=[];for(let v=0;v<N.length-1;v++){const j=N[v+1];let l=N[v];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=j.seq1Range.start-l.seq1Range.endExclusive;let s;for(s=0;s<n&&!(!e.isStronglyEqual(l.seq1Range.start+s,l.seq1Range.endExclusive+s)||!L.isStronglyEqual(l.seq2Range.start+s,l.seq2Range.endExclusive+s));s++);if(s===n){N[v+1]=new M.$s3(new F.$Bt(l.seq1Range.start+n,j.seq1Range.endExclusive),new F.$Bt(l.seq2Range.start+n,j.seq2Range.endExclusive));continue}s>0&&(l=l.delta(s))}$.push(l)}return N.length>0&&$.push(N[N.length-1]),$}function d(e,L,E){if(!e.getBoundaryScore||!L.getBoundaryScore)return E;for(let N=0;N<E.length;N++){const $=N>0?E[N-1]:void 0,v=E[N],j=N+1<E.length?E[N+1]:void 0,l=new F.$Bt($?$.seq1Range.endExclusive+1:0,j?j.seq1Range.start-1:e.length),n=new F.$Bt($?$.seq2Range.endExclusive+1:0,j?j.seq2Range.start-1:L.length);v.seq1Range.isEmpty?E[N]=a(v,e,L,l,n):v.seq2Range.isEmpty&&(E[N]=a(v.swap(),L,e,n,l).swap())}return E}function a(e,L,E,N,$){let j=1;for(;e.seq1Range.start-j>=N.start&&e.seq2Range.start-j>=$.start&&E.isStronglyEqual(e.seq2Range.start-j,e.seq2Range.endExclusive-j)&&j<100;)j++;j--;let l=0;for(;e.seq1Range.start+l<N.endExclusive&&e.seq2Range.endExclusive+l<$.endExclusive&&E.isStronglyEqual(e.seq2Range.start+l,e.seq2Range.endExclusive+l)&&l<100;)l++;if(j===0&&l===0)return e;let n=0,s=-1;for(let h=-j;h<=l;h++){const o=e.seq2Range.start+h,b=e.seq2Range.endExclusive+h,A=e.seq1Range.start+h,R=L.getBoundaryScore(A)+E.getBoundaryScore(o)+E.getBoundaryScore(b);R>s&&(s=R,n=h)}return e.delta(n)}function u(e,L,E){const N=[];for(const $ of E){const v=N[N.length-1];if(!v){N.push($);continue}$.seq1Range.start-v.seq1Range.endExclusive<=2||$.seq2Range.start-v.seq2Range.endExclusive<=2?N[N.length-1]=new M.$s3(v.seq1Range.join($.seq1Range),v.seq2Range.join($.seq2Range)):N.push($)}return N}function f(e,L,E){const N=M.$s3.invert(E,e.length),$=[];let v=new M.$t3(0,0);function j(n,s){if(n.offset1<v.offset1||n.offset2<v.offset2)return;const h=e.findWordContaining(n.offset1),o=L.findWordContaining(n.offset2);if(!h||!o)return;let b=new M.$s3(h,o);const A=b.intersect(s);let R=A.seq1Range.length,y=A.seq2Range.length;for(;N.length>0;){const P=N[0];if(!(P.seq1Range.intersects(b.seq1Range)||P.seq2Range.intersects(b.seq2Range)))break;const I=e.findWordContaining(P.seq1Range.start),Q=L.findWordContaining(P.seq2Range.start),x=new M.$s3(I,Q),S=x.intersect(P);if(R+=S.seq1Range.length,y+=S.seq2Range.length,b=b.join(x),b.seq1Range.endExclusive>=P.seq1Range.endExclusive)N.shift();else break}R+y<(b.seq1Range.length+b.seq2Range.length)*2/3&&$.push(b),v=b.getEndExclusives()}for(;N.length>0;){const n=N.shift();n.seq1Range.isEmpty||(j(n.getStarts(),n),j(n.getEndExclusives().delta(-1),n))}return w(E,$)}function w(e,L){const E=[];for(;e.length>0||L.length>0;){const N=e[0],$=L[0];let v;N&&(!$||N.seq1Range.start<$.seq1Range.start)?v=e.shift():v=L.shift(),E.length>0&&E[E.length-1].seq1Range.endExclusive>=v.seq1Range.start?E[E.length-1]=E[E.length-1].join(v):E.push(v)}return E}function g(e,L,E){let N=E;if(N.length===0)return N;let $=0,v;do{v=!1;const j=[N[0]];for(let l=1;l<N.length;l++){let h=function(b,A){const R=new F.$Bt(s.seq1Range.endExclusive,n.seq1Range.start);return e.getText(R).replace(/\s/g,"").length<=4&&(b.seq1Range.length+b.seq2Range.length>5||A.seq1Range.length+A.seq2Range.length>5)};const n=N[l],s=j[j.length-1];h(s,n)?(v=!0,j[j.length-1]=j[j.length-1].join(n)):j.push(n)}N=j}while($++<10&&v);return N}function m(e,L,E){let N=E;if(N.length===0)return N;let $=0,v;do{v=!1;const l=[N[0]];for(let n=1;n<N.length;n++){let o=function(A,R){const y=new F.$Bt(h.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(y)>5||y.length>500)return!1;const T=e.getText(y).trim();if(T.length>20||T.split(/\r\n|\r|\n/).length>1)return!1;const I=e.countLinesIn(A.seq1Range),Q=A.seq1Range.length,x=L.countLinesIn(A.seq2Range),S=A.seq2Range.length,C=e.countLinesIn(R.seq1Range),Y=R.seq1Range.length,Z=L.countLinesIn(R.seq2Range),H=R.seq2Range.length,G=2*40+50;function K(ee){return Math.min(ee,G)}return Math.pow(Math.pow(K(I*40+Q),1.5)+Math.pow(K(x*40+S),1.5),1.5)+Math.pow(Math.pow(K(C*40+Y),1.5)+Math.pow(K(Z*40+H),1.5),1.5)>(G**1.5)**1.5*1.3};const s=N[n],h=l[l.length-1];o(h,s)?(v=!0,l[l.length-1]=l[l.length-1].join(s)):l.push(s)}N=l}while($++<10&&v);const j=[];return(0,i.$Cb)(N,(l,n,s)=>{let h=n;function o(T){return T.length>0&&T.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const b=e.extendToFullLines(n.seq1Range),A=e.getText(new F.$Bt(b.start,n.seq1Range.start));o(A)&&(h=h.deltaStart(-A.length));const R=e.getText(new F.$Bt(n.seq1Range.endExclusive,b.endExclusive));o(R)&&(h=h.deltaEnd(R.length));const y=M.$s3.fromOffsetPairs(l?l.getEndExclusives():M.$t3.zero,s?s.getStarts():M.$t3.max),P=h.intersect(y);j.length>0&&P.getStarts().equals(j[j.length-1].getEndExclusives())?j[j.length-1]=j[j.length-1].join(P):j.push(P)}),j}}),se(ue[48],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$D3=void 0;class i{constructor(c,p){this.a=c,this.b=p}getElement(c){return this.a[c]}get length(){return this.a.length}getBoundaryScore(c){const p=c===0?0:F(this.b[c-1]),d=c===this.b.length?0:F(this.b[c]);return 1e3-(p+d)}getText(c){return this.b.slice(c.start,c.endExclusive).join(`
`)}isStronglyEqual(c,p){return this.b[c]===this.b[p]}}t.$D3=i;function F(M){let c=0;for(;c<M.length&&(M.charCodeAt(c)===32||M.charCodeAt(c)===9);)c++;return c}}),se(ue[16],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$y3=t.$w3=void 0,t.$x3=F;class i{constructor(p,d){this.width=p,this.height=d,this.a=[],this.a=new Array(p*d)}get(p,d){return this.a[p+d*this.width]}set(p,d,a){this.a[p+d*this.width]=a}}t.$w3=i;function F(c){return c===32||c===9}class M{static{this.a=new Map}static b(p){let d=this.a.get(p);return d===void 0&&(d=this.a.size,this.a.set(p,d)),d}constructor(p,d,a){this.range=p,this.lines=d,this.source=a,this.d=[];let u=0;for(let f=p.startLineNumber-1;f<p.endLineNumberExclusive-1;f++){const w=d[f];for(let m=0;m<w.length;m++){u++;const e=w[m],L=M.b(e);this.d[L]=(this.d[L]||0)+1}u++;const g=M.b(`
`);this.d[g]=(this.d[g]||0)+1}this.c=u}computeSimilarity(p){let d=0;const a=Math.max(this.d.length,p.d.length);for(let u=0;u<a;u++)d+=Math.abs((this.d[u]??0)-(p.d[u]??0));return 1-d/(this.c+p.c)}}t.$y3=M}),se(ue[49],ae([0,1,4,8,16]),function(V,t,i,F,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$z3=void 0;class c{compute(d,a,u=F.$u3.instance,f){if(d.length===0||a.length===0)return F.$r3.trivial(d,a);const w=new M.$w3(d.length,a.length),g=new M.$w3(d.length,a.length),m=new M.$w3(d.length,a.length);for(let j=0;j<d.length;j++)for(let l=0;l<a.length;l++){if(!u.isValid())return F.$r3.trivialTimedOut(d,a);const n=j===0?0:w.get(j-1,l),s=l===0?0:w.get(j,l-1);let h;d.getElement(j)===a.getElement(l)?(j===0||l===0?h=0:h=w.get(j-1,l-1),j>0&&l>0&&g.get(j-1,l-1)===3&&(h+=m.get(j-1,l-1)),h+=f?f(j,l):1):h=-1;const o=Math.max(n,s,h);if(o===h){const b=j>0&&l>0?m.get(j-1,l-1):0;m.set(j,l,b+1),g.set(j,l,3)}else o===n?(m.set(j,l,0),g.set(j,l,1)):o===s&&(m.set(j,l,0),g.set(j,l,2));w.set(j,l,o)}const e=[];let L=d.length,E=a.length;function N(j,l){(j+1!==L||l+1!==E)&&e.push(new F.$s3(new i.$Bt(j+1,L),new i.$Bt(l+1,E))),L=j,E=l}let $=d.length-1,v=a.length-1;for(;$>=0&&v>=0;)g.get($,v)===3?(N($,v),$--,v--):g.get($,v)===1?$--:v--;return N(-1,-1),e.reverse(),new F.$r3(e,!1)}}t.$z3=c}),se(ue[32],ae([0,1,9,4,5,2,16]),function(V,t,i,F,M,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$B3=void 0;class d{constructor(e,L,E){this.lines=e,this.considerWhitespaceChanges=E,this.b=[],this.c=[],this.d=[];let N=!1;L.start>0&&L.endExclusive>=e.length&&(L=new F.$Bt(L.start-1,L.endExclusive),N=!0),this.lineRange=L,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let v=e[$],j=0;if(N)j=v.length,v="",N=!1;else if(!E){const l=v.trimStart();j=v.length-l.length,v=l.trimEnd()}this.d.push(j);for(let l=0;l<v.length;l++)this.b.push(v.charCodeAt(l));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new F.$Bt(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(L=>String.fromCharCode(L)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const L=g(e>0?this.b[e-1]:-1),E=g(e<this.b.length?this.b[e]:-1);if(L===7&&E===8)return 0;if(L===8)return 150;let N=0;return L!==E&&(N+=10,L===0&&E===1&&(N+=1)),N+=w(L),N+=w(E),N}translateOffset(e){if(this.lineRange.isEmpty)return new M.$tt(this.lineRange.start+1,1);const L=(0,i.$ib)(this.c,E=>E<=e);return new M.$tt(this.lineRange.start+L+1,e-this.c[L]+this.d[L]+1)}translateRange(e){return c.$ut.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!a(this.b[e]))return;let L=e;for(;L>0&&a(this.b[L-1]);)L--;let E=e;for(;E<this.b.length&&a(this.b[E]);)E++;return new F.$Bt(L,E)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,L){return this.b[e]===this.b[L]}extendToFullLines(e){const L=(0,i.$hb)(this.c,N=>N<=e.start)??0,E=(0,i.$jb)(this.c,N=>e.endExclusive<=N)??this.b.length;return new F.$Bt(L,E)}}t.$B3=d;function a(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var u;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(u||(u={}));const f={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function w(m){return f[m]}function g(m){return m===10?8:m===13?7:(0,p.$x3)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),se(ue[33],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rv=t.$Qv=void 0;class i{constructor(c,p,d){this.changes=c,this.moves=p,this.hitTimeout=d}}t.$Qv=i;class F{constructor(c,p){this.lineRangeMapping=c,this.changes=p}flip(){return new F(this.lineRangeMapping.flip(),this.changes.map(c=>c.flip()))}}t.$Rv=F}),se(ue[17],ae([0,1,12]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pv=t.$Ov=t.$Nv=void 0;class F{static inverse(d,a,u){const f=[];let w=1,g=1;for(const e of d){const L=new F(new i.$Lv(w,e.original.startLineNumber),new i.$Lv(g,e.modified.startLineNumber));L.modified.isEmpty||f.push(L),w=e.original.endLineNumberExclusive,g=e.modified.endLineNumberExclusive}const m=new F(new i.$Lv(w,a+1),new i.$Lv(g,u+1));return m.modified.isEmpty||f.push(m),f}static clip(d,a,u){const f=[];for(const w of d){const g=w.original.intersect(a),m=w.modified.intersect(u);g&&!g.isEmpty&&m&&!m.isEmpty&&f.push(new F(g,m))}return f}constructor(d,a){this.original=d,this.modified=a}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new F(this.modified,this.original)}join(d){return new F(this.original.join(d.original),this.modified.join(d.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$Nv=F;class M extends F{static fromRangeMappings(d){const a=i.$Lv.join(d.map(f=>i.$Lv.fromRangeInclusive(f.originalRange))),u=i.$Lv.join(d.map(f=>i.$Lv.fromRangeInclusive(f.modifiedRange)));return new M(a,u,d)}constructor(d,a,u){super(d,a),this.innerChanges=u}flip(){return new M(this.modified,this.original,this.innerChanges?.map(d=>d.flip()))}withInnerChangesFromLineRanges(){return new M(this.original,this.modified,[new c(this.original.toExclusiveRange(),this.modified.toExclusiveRange())])}}t.$Ov=M;class c{constructor(d,a){this.originalRange=d,this.modifiedRange=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new c(this.modifiedRange,this.originalRange)}}t.$Pv=c}),se(ue[50],ae([0,1,8,17,6,9,14,12,4,32,16,31]),function(V,t,i,F,M,c,p,d,a,u,f,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$C3=g;function g(v,j,l,n,s,h){let{moves:o,excludedChanges:b}=e(v,j,l,h);if(!h.isValid())return[];const A=v.filter(y=>!b.has(y)),R=L(A,n,s,j,l,h);return(0,M.$1b)(o,R),o=N(o),o=o.filter(y=>{const P=y.original.toOffsetRange().slice(j).map(I=>I.trim());return P.join(`
`).length>=15&&m(P,I=>I.length>=2)>=2}),o=$(v,o),o}function m(v,j){let l=0;for(const n of v)j(n)&&l++;return l}function e(v,j,l,n){const s=[],h=v.filter(A=>A.modified.isEmpty&&A.original.length>=3).map(A=>new f.$y3(A.original,j,A)),o=new Set(v.filter(A=>A.original.isEmpty&&A.modified.length>=3).map(A=>new f.$y3(A.modified,l,A))),b=new Set;for(const A of h){let R=-1,y;for(const P of o){const T=A.computeSimilarity(P);T>R&&(R=T,y=P)}if(R>.9&&y&&(o.delete(y),s.push(new F.$Nv(A.range,y.range)),b.add(A.source),b.add(y.source)),!n.isValid())return{moves:s,excludedChanges:b}}return{moves:s,excludedChanges:b}}function L(v,j,l,n,s,h){const o=[],b=new p.$Ic;for(const T of v)for(let I=T.original.startLineNumber;I<T.original.endLineNumberExclusive-2;I++){const Q=`${j[I-1]}:${j[I+1-1]}:${j[I+2-1]}`;b.add(Q,{range:new d.$Lv(I,I+3)})}const A=[];v.sort((0,M.$7b)(T=>T.modified.startLineNumber,M.$9b));for(const T of v){let I=[];for(let Q=T.modified.startLineNumber;Q<T.modified.endLineNumberExclusive-2;Q++){const x=`${l[Q-1]}:${l[Q+1-1]}:${l[Q+2-1]}`,S=new d.$Lv(Q,Q+3),C=[];b.forEach(x,({range:Y})=>{for(const H of I)if(H.originalLineRange.endLineNumberExclusive+1===Y.endLineNumberExclusive&&H.modifiedLineRange.endLineNumberExclusive+1===S.endLineNumberExclusive){H.originalLineRange=new d.$Lv(H.originalLineRange.startLineNumber,Y.endLineNumberExclusive),H.modifiedLineRange=new d.$Lv(H.modifiedLineRange.startLineNumber,S.endLineNumberExclusive),C.push(H);return}const Z={modifiedLineRange:S,originalLineRange:Y};A.push(Z),C.push(Z)}),I=C}if(!h.isValid())return[]}A.sort((0,M.$$b)((0,M.$7b)(T=>T.modifiedLineRange.length,M.$9b)));const R=new d.$Mv,y=new d.$Mv;for(const T of A){const I=T.modifiedLineRange.startLineNumber-T.originalLineRange.startLineNumber,Q=R.subtractFrom(T.modifiedLineRange),x=y.subtractFrom(T.originalLineRange).getWithDelta(I),S=Q.getIntersection(x);for(const C of S.ranges){if(C.length<3)continue;const Y=C,Z=C.delta(-I);o.push(new F.$Nv(Z,Y)),R.addRange(Y),y.addRange(Z)}}o.sort((0,M.$7b)(T=>T.original.startLineNumber,M.$9b));const P=new c.$mb(v);for(let T=0;T<o.length;T++){const I=o[T],Q=P.findLastMonotonous(K=>K.original.startLineNumber<=I.original.startLineNumber),x=(0,c.$hb)(v,K=>K.modified.startLineNumber<=I.modified.startLineNumber),S=Math.max(I.original.startLineNumber-Q.original.startLineNumber,I.modified.startLineNumber-x.modified.startLineNumber),C=P.findLastMonotonous(K=>K.original.startLineNumber<I.original.endLineNumberExclusive),Y=(0,c.$hb)(v,K=>K.modified.startLineNumber<I.modified.endLineNumberExclusive),Z=Math.max(C.original.endLineNumberExclusive-I.original.endLineNumberExclusive,Y.modified.endLineNumberExclusive-I.modified.endLineNumberExclusive);let H;for(H=0;H<S;H++){const K=I.original.startLineNumber-H-1,ee=I.modified.startLineNumber-H-1;if(K>n.length||ee>s.length||R.contains(ee)||y.contains(K)||!E(n[K-1],s[ee-1],h))break}H>0&&(y.addRange(new d.$Lv(I.original.startLineNumber-H,I.original.startLineNumber)),R.addRange(new d.$Lv(I.modified.startLineNumber-H,I.modified.startLineNumber)));let G;for(G=0;G<Z;G++){const K=I.original.endLineNumberExclusive+G,ee=I.modified.endLineNumberExclusive+G;if(K>n.length||ee>s.length||R.contains(ee)||y.contains(K)||!E(n[K-1],s[ee-1],h))break}G>0&&(y.addRange(new d.$Lv(I.original.endLineNumberExclusive,I.original.endLineNumberExclusive+G)),R.addRange(new d.$Lv(I.modified.endLineNumberExclusive,I.modified.endLineNumberExclusive+G))),(H>0||G>0)&&(o[T]=new F.$Nv(new d.$Lv(I.original.startLineNumber-H,I.original.endLineNumberExclusive+G),new d.$Lv(I.modified.startLineNumber-H,I.modified.endLineNumberExclusive+G)))}return o}function E(v,j,l){if(v.trim()===j.trim())return!0;if(v.length>300&&j.length>300)return!1;const s=new w.$A3().compute(new u.$B3([v],new a.$Bt(0,1),!1),new u.$B3([j],new a.$Bt(0,1),!1),l);let h=0;const o=i.$s3.invert(s.diffs,v.length);for(const y of o)y.seq1Range.forEach(P=>{(0,f.$x3)(v.charCodeAt(P))||h++});function b(y){let P=0;for(let T=0;T<v.length;T++)(0,f.$x3)(y.charCodeAt(T))||P++;return P}const A=b(v.length>j.length?v:j);return h/A>.6&&A>10}function N(v){if(v.length===0)return v;v.sort((0,M.$7b)(l=>l.original.startLineNumber,M.$9b));const j=[v[0]];for(let l=1;l<v.length;l++){const n=j[j.length-1],s=v[l],h=s.original.startLineNumber-n.original.endLineNumberExclusive,o=s.modified.startLineNumber-n.modified.endLineNumberExclusive;if(h>=0&&o>=0&&h+o<=2){j[j.length-1]=n.join(s);continue}j.push(s)}return j}function $(v,j){const l=new c.$mb(v);return j=j.filter(n=>{const s=l.findLastMonotonous(b=>b.original.startLineNumber<n.original.endLineNumberExclusive)||new F.$Nv(new d.$Lv(1,1),new d.$Lv(1,1)),h=(0,c.$hb)(v,b=>b.modified.startLineNumber<n.modified.endLineNumberExclusive);return s!==h}),j}}),se(ue[51],ae([0,1,6,13,12,4,2,8,49,31,50,47,48,32,33,17]),function(V,t,i,F,M,c,p,d,a,u,f,w,g,m,e,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J3=void 0,t.$K3=N,t.$L3=$;class E{constructor(){this.e=new a.$z3,this.f=new u.$A3}computeDiff(j,l,n){if(j.length<=1&&(0,i.$ub)(j,l,(G,K)=>G===K))return new e.$Qv([],[],!1);if(j.length===1&&j[0].length===0||l.length===1&&l[0].length===0)return new e.$Qv([new L.$Ov(new M.$Lv(1,j.length+1),new M.$Lv(1,l.length+1),[new L.$Pv(new p.$ut(1,1,j.length,j[j.length-1].length+1),new p.$ut(1,1,l.length,l[l.length-1].length+1))])],[],!1);const s=n.maxComputationTimeMs===0?d.$u3.instance:new d.$v3(n.maxComputationTimeMs),h=!n.ignoreTrimWhitespace,o=new Map;function b(G){let K=o.get(G);return K===void 0&&(K=o.size,o.set(G,K)),K}const A=j.map(G=>b(G.trim())),R=l.map(G=>b(G.trim())),y=new g.$D3(A,j),P=new g.$D3(R,l),T=y.length+P.length<1700?this.e.compute(y,P,s,(G,K)=>j[G]===l[K]?l[K].length===0?.1:1+Math.log(1+l[K].length):.99):this.f.compute(y,P);let I=T.diffs,Q=T.hitTimeout;I=(0,w.$E3)(y,P,I),I=(0,w.$H3)(y,P,I);const x=[],S=G=>{if(h)for(let K=0;K<G;K++){const ee=C+K,k=Y+K;if(j[ee]!==l[k]){const X=this.j(j,l,new d.$s3(new c.$Bt(ee,ee+1),new c.$Bt(k,k+1)),s,h);for(const de of X.mappings)x.push(de);X.hitTimeout&&(Q=!0)}}};let C=0,Y=0;for(const G of I){(0,F.$id)(()=>G.seq1Range.start-C===G.seq2Range.start-Y);const K=G.seq1Range.start-C;S(K),C=G.seq1Range.endExclusive,Y=G.seq2Range.endExclusive;const ee=this.j(j,l,G,s,h);ee.hitTimeout&&(Q=!0);for(const k of ee.mappings)x.push(k)}S(j.length-C);const Z=N(x,j,l);let H=[];return n.computeMoves&&(H=this.h(Z,j,l,A,R,s,h)),(0,F.$id)(()=>{function G(ee,k){if(ee.lineNumber<1||ee.lineNumber>k.length)return!1;const X=k[ee.lineNumber-1];return!(ee.column<1||ee.column>X.length+1)}function K(ee,k){return!(ee.startLineNumber<1||ee.startLineNumber>k.length+1||ee.endLineNumberExclusive<1||ee.endLineNumberExclusive>k.length+1)}for(const ee of Z){if(!ee.innerChanges)return!1;for(const k of ee.innerChanges)if(!(G(k.modifiedRange.getStartPosition(),l)&&G(k.modifiedRange.getEndPosition(),l)&&G(k.originalRange.getStartPosition(),j)&&G(k.originalRange.getEndPosition(),j)))return!1;if(!K(ee.modified,l)||!K(ee.original,j))return!1}return!0}),new e.$Qv(Z,H,Q)}h(j,l,n,s,h,o,b){return(0,f.$C3)(j,l,n,s,h,o).map(y=>{const P=this.j(l,n,new d.$s3(y.original.toOffsetRange(),y.modified.toOffsetRange()),o,b),T=N(P.mappings,l,n,!0);return new e.$Rv(y,T)})}j(j,l,n,s,h){const o=new m.$B3(j,n.seq1Range,h),b=new m.$B3(l,n.seq2Range,h),A=o.length+b.length<500?this.e.compute(o,b,s):this.f.compute(o,b,s);let R=A.diffs;return R=(0,w.$E3)(o,b,R),R=(0,w.$G3)(o,b,R),R=(0,w.$F3)(o,b,R),R=(0,w.$I3)(o,b,R),{mappings:R.map(P=>new L.$Pv(o.translateRange(P.seq1Range),b.translateRange(P.seq2Range))),hitTimeout:A.hitTimeout}}}t.$J3=E;function N(v,j,l,n=!1){const s=[];for(const h of(0,i.$Ab)(v.map(o=>$(o,j,l)),(o,b)=>o.original.overlapOrTouch(b.original)||o.modified.overlapOrTouch(b.modified))){const o=h[0],b=h[h.length-1];s.push(new L.$Ov(o.original.join(b.original),o.modified.join(b.modified),h.map(A=>A.innerChanges[0])))}return(0,F.$id)(()=>!n&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||l.length-s[s.length-1].modified.endLineNumberExclusive!==j.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,F.$jd)(s,(h,o)=>o.original.startLineNumber-h.original.endLineNumberExclusive===o.modified.startLineNumber-h.modified.endLineNumberExclusive&&h.original.endLineNumberExclusive<o.original.startLineNumber&&h.modified.endLineNumberExclusive<o.modified.startLineNumber)),s}function $(v,j,l){let n=0,s=0;v.modifiedRange.endColumn===1&&v.originalRange.endColumn===1&&v.originalRange.startLineNumber+n<=v.originalRange.endLineNumber&&v.modifiedRange.startLineNumber+n<=v.modifiedRange.endLineNumber&&(s=-1),v.modifiedRange.startColumn-1>=l[v.modifiedRange.startLineNumber-1].length&&v.originalRange.startColumn-1>=j[v.originalRange.startLineNumber-1].length&&v.originalRange.startLineNumber<=v.originalRange.endLineNumber+s&&v.modifiedRange.startLineNumber<=v.modifiedRange.endLineNumber+s&&(n=1);const h=new M.$Lv(v.originalRange.startLineNumber+n,v.originalRange.endLineNumber+1+s),o=new M.$Lv(v.modifiedRange.startLineNumber+n,v.modifiedRange.endLineNumber+1+s);return new L.$Ov(h,o,[v])}}),se(ue[34],ae([0,1,25,33,17,7,2,13,12]),function(V,t,i,F,M,c,p,d,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tv=t.$Sv=void 0;const u=3;class f{computeDiff(n,s,h){const b=new N(n,s,{maxComputationTime:h.maxComputationTimeMs,shouldIgnoreTrimWhitespace:h.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),A=[];let R=null;for(const y of b.changes){let P;y.originalEndLineNumber===0?P=new a.$Lv(y.originalStartLineNumber+1,y.originalStartLineNumber+1):P=new a.$Lv(y.originalStartLineNumber,y.originalEndLineNumber+1);let T;y.modifiedEndLineNumber===0?T=new a.$Lv(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):T=new a.$Lv(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let I=new M.$Ov(P,T,y.charChanges?.map(Q=>new M.$Pv(new p.$ut(Q.originalStartLineNumber,Q.originalStartColumn,Q.originalEndLineNumber,Q.originalEndColumn),new p.$ut(Q.modifiedStartLineNumber,Q.modifiedStartColumn,Q.modifiedEndLineNumber,Q.modifiedEndColumn))));R&&(R.modified.endLineNumberExclusive===I.modified.startLineNumber||R.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new M.$Ov(R.original.join(I.original),R.modified.join(I.modified),R.innerChanges&&I.innerChanges?R.innerChanges.concat(I.innerChanges):void 0),A.pop()),A.push(I),R=I}return(0,d.$id)(()=>(0,d.$jd)(A,(y,P)=>P.original.startLineNumber-y.original.endLineNumberExclusive===P.modified.startLineNumber-y.modified.endLineNumberExclusive&&y.original.endLineNumberExclusive<P.original.startLineNumber&&y.modified.endLineNumberExclusive<P.modified.startLineNumber)),new F.$Qv(A,[],b.quitEarly)}}t.$Sv=f;function w(l,n,s,h){return new i.$At(l,n,s).ComputeDiff(h)}class g{constructor(n){const s=[],h=[];for(let o=0,b=n.length;o<b;o++)s[o]=$(n[o],1),h[o]=v(n[o],1);this.lines=n,this.a=s,this.b=h}getElements(){const n=[];for(let s=0,h=this.lines.length;s<h;s++)n[s]=this.lines[s].substring(this.a[s]-1,this.b[s]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,s,h){const o=[],b=[],A=[];let R=0;for(let y=s;y<=h;y++){const P=this.lines[y],T=n?this.a[y]:1,I=n?this.b[y]:P.length+1;for(let Q=T;Q<I;Q++)o[R]=P.charCodeAt(Q-1),b[R]=y+1,A[R]=Q,R++;!n&&y<h&&(o[R]=10,b[R]=y+1,A[R]=P.length+1,R++)}return new m(o,b,A)}}class m{constructor(n,s,h){this.a=n,this.b=s,this.d=h}toString(){return"["+this.a.map((n,s)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this.b[s]},${this.d[s]})`).join(", ")+"]"}e(n,s){if(n<0||n>=s.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(n){return n>0&&n===this.b.length?this.getEndLineNumber(n-1):(this.e(n,this.b),this.b[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this.e(n,this.b),this.a[n]===10?this.b[n]+1:this.b[n])}getStartColumn(n){return n>0&&n===this.d.length?this.getEndColumn(n-1):(this.e(n,this.d),this.d[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this.e(n,this.d),this.a[n]===10?1:this.d[n]+1)}}class e{constructor(n,s,h,o,b,A,R,y){this.originalStartLineNumber=n,this.originalStartColumn=s,this.originalEndLineNumber=h,this.originalEndColumn=o,this.modifiedStartLineNumber=b,this.modifiedStartColumn=A,this.modifiedEndLineNumber=R,this.modifiedEndColumn=y}static createFromDiffChange(n,s,h){const o=s.getStartLineNumber(n.originalStart),b=s.getStartColumn(n.originalStart),A=s.getEndLineNumber(n.originalStart+n.originalLength-1),R=s.getEndColumn(n.originalStart+n.originalLength-1),y=h.getStartLineNumber(n.modifiedStart),P=h.getStartColumn(n.modifiedStart),T=h.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),I=h.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(o,b,A,R,y,P,T,I)}}function L(l){if(l.length<=1)return l;const n=[l[0]];let s=n[0];for(let h=1,o=l.length;h<o;h++){const b=l[h],A=b.originalStart-(s.originalStart+s.originalLength),R=b.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(A,R)<u?(s.originalLength=b.originalStart+b.originalLength-s.originalStart,s.modifiedLength=b.modifiedStart+b.modifiedLength-s.modifiedStart):(n.push(b),s=b)}return n}class E{constructor(n,s,h,o,b){this.originalStartLineNumber=n,this.originalEndLineNumber=s,this.modifiedStartLineNumber=h,this.modifiedEndLineNumber=o,this.charChanges=b}static createFromDiffResult(n,s,h,o,b,A,R){let y,P,T,I,Q;if(s.originalLength===0?(y=h.getStartLineNumber(s.originalStart)-1,P=0):(y=h.getStartLineNumber(s.originalStart),P=h.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(T=o.getStartLineNumber(s.modifiedStart)-1,I=0):(T=o.getStartLineNumber(s.modifiedStart),I=o.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),A&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&b()){const x=h.createCharSequence(n,s.originalStart,s.originalStart+s.originalLength-1),S=o.createCharSequence(n,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(x.getElements().length>0&&S.getElements().length>0){let C=w(x,S,b,!0).changes;R&&(C=L(C)),Q=[];for(let Y=0,Z=C.length;Y<Z;Y++)Q.push(e.createFromDiffChange(C[Y],x,S))}}return new E(y,P,T,I,Q)}}class N{constructor(n,s,h){this.a=h.shouldComputeCharChanges,this.b=h.shouldPostProcessCharChanges,this.d=h.shouldIgnoreTrimWhitespace,this.e=h.shouldMakePrettyDiff,this.f=n,this.g=s,this.h=new g(n),this.j=new g(s),this.k=j(h.maxComputationTime),this.l=j(h.maxComputationTime===0?0:Math.min(h.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=w(this.h,this.j,this.k,this.e),s=n.changes,h=n.quitEarly;if(this.d){const R=[];for(let y=0,P=s.length;y<P;y++)R.push(E.createFromDiffResult(this.d,s[y],this.h,this.j,this.l,this.a,this.b));return{quitEarly:h,changes:R}}const o=[];let b=0,A=0;for(let R=-1,y=s.length;R<y;R++){const P=R+1<y?s[R+1]:null,T=P?P.originalStart:this.f.length,I=P?P.modifiedStart:this.g.length;for(;b<T&&A<I;){const Q=this.f[b],x=this.g[A];if(Q!==x){{let S=$(Q,1),C=$(x,1);for(;S>1&&C>1;){const Y=Q.charCodeAt(S-2),Z=x.charCodeAt(C-2);if(Y!==Z)break;S--,C--}(S>1||C>1)&&this.m(o,b+1,1,S,A+1,1,C)}{let S=v(Q,1),C=v(x,1);const Y=Q.length+1,Z=x.length+1;for(;S<Y&&C<Z;){const H=Q.charCodeAt(S-1),G=Q.charCodeAt(C-1);if(H!==G)break;S++,C++}(S<Y||C<Z)&&this.m(o,b+1,S,Y,A+1,C,Z)}}b++,A++}P&&(o.push(E.createFromDiffResult(this.d,P,this.h,this.j,this.l,this.a,this.b)),b+=P.originalLength,A+=P.modifiedLength)}return{quitEarly:h,changes:o}}m(n,s,h,o,b,A,R){if(this.n(n,s,h,o,b,A,R))return;let y;this.a&&(y=[new e(s,h,s,o,b,A,b,R)]),n.push(new E(s,s,b,b,y))}n(n,s,h,o,b,A,R){const y=n.length;if(y===0)return!1;const P=n[y-1];return P.originalEndLineNumber===0||P.modifiedEndLineNumber===0?!1:P.originalEndLineNumber===s&&P.modifiedEndLineNumber===b?(this.a&&P.charChanges&&P.charChanges.push(new e(s,h,s,o,b,A,b,R)),!0):P.originalEndLineNumber+1===s&&P.modifiedEndLineNumber+1===b?(P.originalEndLineNumber=s,P.modifiedEndLineNumber=b,this.a&&P.charChanges&&P.charChanges.push(new e(s,h,s,o,b,A,b,R)),!0):!1}}t.$Tv=N;function $(l,n){const s=c.$nf(l);return s===-1?n:s+1}function v(l,n){const s=c.$pf(l);return s===-1?n:s+2}function j(l){if(l===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<l}}),se(ue[52],ae([0,1,34,51]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M3=void 0,t.$M3={getLegacy:()=>new i.$Sv,getDefault:()=>new F.$J3}}),se(ue[53],ae([0,1,36]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N3=w;function F(g){const m=[];for(const e of g){const L=Number(e);(L||L===0&&e.replace(/\s/g,"")!=="")&&m.push(L)}return m}function M(g,m,e,L){return{red:g/255,blue:e/255,green:m/255,alpha:L}}function c(g,m){const e=m.index,L=m[0].length;if(!e)return;const E=g.positionAt(e);return{startLineNumber:E.lineNumber,startColumn:E.column,endLineNumber:E.lineNumber,endColumn:E.column+L}}function p(g,m){if(!g)return;const e=i.$Pt.Format.CSS.parseHex(m);if(e)return{range:g,color:M(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(g,m,e){if(!g||m.length!==1)return;const E=m[0].values(),N=F(E);return{range:g,color:M(N[0],N[1],N[2],e?N[3]:1)}}function a(g,m,e){if(!g||m.length!==1)return;const E=m[0].values(),N=F(E),$=new i.$Pt(new i.$Nt(N[0],N[1]/100,N[2]/100,e?N[3]:1));return{range:g,color:M($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function u(g,m){return typeof g=="string"?[...g.matchAll(m)]:g.findMatches(m)}function f(g){const m=[],L=u(g,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(L.length>0)for(const E of L){const N=E.filter(l=>l!==void 0),$=N[1],v=N[2];if(!v)continue;let j;if($==="rgb"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;j=d(c(g,E),u(v,l),!1)}else if($==="rgba"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;j=d(c(g,E),u(v,l),!0)}else if($==="hsl"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;j=a(c(g,E),u(v,l),!1)}else if($==="hsla"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;j=a(c(g,E),u(v,l),!0)}else $==="#"&&(j=p(c(g,E),$+v));j&&m.push(j)}return m}function w(g){return!g||typeof g.getValue!="function"||typeof g.positionAt!="function"?[]:f(g)}}),se(ue[54],ae([0,1,29]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$m3=t.$l3=t.State=void 0,t.$n3=g;var F;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(F||(t.State=F={}));class M{constructor(e,L,E){const N=new Uint8Array(e*L);for(let $=0,v=e*L;$<v;$++)N[$]=E;this.a=N,this.rows=e,this.cols=L}get(e,L){return this.a[e*this.cols+L]}set(e,L,E){this.a[e*this.cols+L]=E}}class c{constructor(e){let L=0,E=0;for(let $=0,v=e.length;$<v;$++){const[j,l,n]=e[$];l>L&&(L=l),j>E&&(E=j),n>E&&(E=n)}L++,E++;const N=new M(E,L,0);for(let $=0,v=e.length;$<v;$++){const[j,l,n]=e[$];N.set(j,l,n)}this.a=N,this.b=L}nextState(e,L){return L<0||L>=this.b?0:this.a.get(e,L)}}t.$l3=c;let p=null;function d(){return p===null&&(p=new c([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),p}var a;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let u=null;function f(){if(u===null){u=new i.$It(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let L=0;L<m.length;L++)u.set(m.charCodeAt(L),1);const e=".,;:";for(let L=0;L<e.length;L++)u.set(e.charCodeAt(L),2)}return u}class w{static a(e,L,E,N,$){let v=$-1;do{const j=L.charCodeAt(v);if(e.get(j)!==2)break;v--}while(v>N);if(N>0){const j=L.charCodeAt(N-1),l=L.charCodeAt(v);(j===40&&l===41||j===91&&l===93||j===123&&l===125)&&v--}return{range:{startLineNumber:E,startColumn:N+1,endLineNumber:E,endColumn:v+2},url:L.substring(N,v+1)}}static computeLinks(e,L=d()){const E=f(),N=[];for(let $=1,v=e.getLineCount();$<=v;$++){const j=e.getLineContent($),l=j.length;let n=0,s=0,h=0,o=1,b=!1,A=!1,R=!1,y=!1;for(;n<l;){let P=!1;const T=j.charCodeAt(n);if(o===13){let I;switch(T){case 40:b=!0,I=0;break;case 41:I=b?0:1;break;case 91:R=!0,A=!0,I=0;break;case 93:R=!1,I=A?0:1;break;case 123:y=!0,I=0;break;case 125:I=y?0:1;break;case 39:case 34:case 96:h===T?I=1:h===39||h===34||h===96?I=0:I=1;break;case 42:I=h===42?1:0;break;case 124:I=h===124?1:0;break;case 32:I=R?0:1;break;default:I=E.get(T)}I===1&&(N.push(w.a(E,j,$,s,n)),P=!0)}else if(o===12){let I;T===91?(A=!0,I=0):I=E.get(T),I===1?P=!0:o=13}else o=L.nextState(o,T),o===0&&(P=!0);P&&(o=1,b=!1,A=!1,y=!1,s=n+1,h=T),n++}o===13&&N.push(w.a(E,j,$,s,l))}return N}}t.$m3=w;function g(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:w.computeLinks(m)}}),se(ue[55],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$o3=void 0;class i{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new i}navigateValueSet(M,c,p,d,a){if(M&&c){const u=this.a(c,a);if(u)return{range:M,value:u}}if(p&&d){const u=this.a(d,a);if(u)return{range:p,value:u}}return null}a(M,c){const p=this.b(M,c);return p!==null?p:this.d(M,c)}b(M,c){const p=Math.pow(10,M.length-(M.lastIndexOf(".")+1));let d=Number(M);const a=parseFloat(M);return!isNaN(d)&&!isNaN(a)&&d===a?d===0&&!c?null:(d=Math.floor(d*p),d+=c?p:-p,String(d/p)):null}d(M,c){return this.e(this.c,M,c)}e(M,c,p){let d=null;for(let a=0,u=M.length;d===null&&a<u;a++)d=this.f(M[a],c,p);return d}f(M,c,p){let d=M.indexOf(c);return d>=0?(d+=p?1:-1,d<0?d=M.length-1:d%=M.length,M[d]):null}}t.$o3=i}),se(ue[56],ae([0,1,15]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jv=t.$Iv=t.$Hv=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.$Fv=t.$Ev=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.$Gv=e,t.$Kv=j;var F;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(F||(t.OverviewRulerLane=F={}));var M;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=3]="Right"})(M||(t.GlyphMarginLane=M={}));var c;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(c||(t.MinimapPosition=c={}));var p;(function(l){l[l.Normal=1]="Normal",l[l.Underlined=2]="Underlined"})(p||(t.MinimapSectionHeaderStyle=p={}));var d;(function(l){l[l.Both=0]="Both",l[l.Right=1]="Right",l[l.Left=2]="Left",l[l.None=3]="None"})(d||(t.InjectedTextCursorStops=d={}));var a;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(a||(t.EndOfLinePreference=a={}));var u;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(u||(t.DefaultEndOfLine=u={}));var f;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(f||(t.EndOfLineSequence=f={}));class w{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(n){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,n.tabSize|0),n.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,n.indentSize|0),this.a=!1),this.insertSpaces=!!n.insertSpaces,this.defaultEOL=n.defaultEOL|0,this.trimAutoWhitespace=!!n.trimAutoWhitespace,this.bracketPairColorizationOptions=n.bracketPairColorizationOptions}equals(n){return this.tabSize===n.tabSize&&this.a===n.a&&this.indentSize===n.indentSize&&this.insertSpaces===n.insertSpaces&&this.defaultEOL===n.defaultEOL&&this.trimAutoWhitespace===n.trimAutoWhitespace&&(0,i.$7n)(this.bracketPairColorizationOptions,n.bracketPairColorizationOptions)}createChangeEvent(n){return{tabSize:this.tabSize!==n.tabSize,indentSize:this.indentSize!==n.indentSize,insertSpaces:this.insertSpaces!==n.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==n.trimAutoWhitespace}}}t.$Ev=w;class g{constructor(n,s){this._findMatchBrand=void 0,this.range=n,this.matches=s}}t.$Fv=g;var m;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(t.TrackedRangeStickiness=m={}));function e(l){return l&&typeof l.read=="function"}var L;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None",l[l.LeftOfInjectedText=3]="LeftOfInjectedText",l[l.RightOfInjectedText=4]="RightOfInjectedText"})(L||(t.PositionAffinity=L={}));var E;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(t.ModelConstants=E={}));class N{constructor(n,s,h,o,b,A){this.identifier=n,this.range=s,this.text=h,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=b,this._isTracked=A}}t.$Hv=N;class ${constructor(n,s,h){this.regex=n,this.wordSeparators=s,this.simpleSearch=h}}t.$Iv=$;class v{constructor(n,s,h){this.reverseEdits=n,this.changes=s,this.trimAutoWhitespaceLineNumbers=h}}t.$Jv=v;function j(l){return!l.isTooLargeForSyncing()&&!l.isForSimpleWidget}}),se(ue[57],ae([0,1,6,28]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yv=t.$Xv=t.$Wv=void 0;class M{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,u){a=(0,F.$7e)(a);const f=this.a,w=this.b,g=u.length;return g===0?!1:(this.a=new Uint32Array(f.length+g),this.a.set(f.subarray(0,a),0),this.a.set(f.subarray(a),a+g),this.a.set(u,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(w.subarray(0,this.c[0]+1)),!0)}setValue(a,u){return a=(0,F.$7e)(a),u=(0,F.$7e)(u),this.a[a]===u?!1:(this.a[a]=u,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,u){a=(0,F.$7e)(a),u=(0,F.$7e)(u);const f=this.a,w=this.b;if(a>=f.length)return!1;const g=f.length-a;return u>=g&&(u=g),u===0?!1:(this.a=new Uint32Array(f.length-u),this.a.set(f.subarray(0,a),0),this.a.set(f.subarray(a+u),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(w.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,F.$7e)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),a>=this.a.length&&(a=this.a.length-1);for(let f=u;f<=a;f++)this.b[f]=this.b[f-1]+this.a[f];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let u=0,f=this.a.length-1,w=0,g=0,m=0;for(;u<=f;)if(w=u+(f-u)/2|0,g=this.b[w],m=g-this.a[w],a<m)f=w-1;else if(a>=g)u=w+1;else break;return new p(w,a-m)}}t.$Wv=M;class c{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const u=this.e[a],f=u>0?this.d[u-1]:0;return new p(u,a-f)}removeValues(a,u){this.a.splice(a,u),this.f(a)}insertValues(a,u){this.a=(0,i.$Wb)(this.a,a,u),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,u=this.a.length;a<u;a++){const f=this.a[a],w=a>0?this.d[a-1]:0;this.d[a]=w+f;for(let g=0;g<f;g++)this.e[w+g]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,u){this.a[a]!==u&&(this.a[a]=u,this.f(a))}}t.$Xv=c;class p{constructor(a,u){this.index=a,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=u}}t.$Yv=p}),se(ue[58],ae([0,1,7,5,57]),function(V,t,i,F,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zv=void 0;class c{constructor(d,a,u,f){this.d=d,this.f=a,this.g=u,this.h=f,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(d){d.eol&&d.eol!==this.g&&(this.g=d.eol,this.j=null);const a=d.changes;for(const u of a)this.o(u.range),this.p(new F.$tt(u.range.startLineNumber,u.range.startColumn),u.text);this.h=d.versionId,this.k=null}l(){if(!this.j){const d=this.g.length,a=this.f.length,u=new Uint32Array(a);for(let f=0;f<a;f++)u[f]=this.f[f].length+d;this.j=new M.$Wv(u)}}n(d,a){this.f[d]=a,this.j&&this.j.setValue(d,this.f[d].length+this.g.length)}o(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.startLineNumber-1].substring(d.endColumn-1));return}this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.endLineNumber-1].substring(d.endColumn-1)),this.f.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this.j&&this.j.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}p(d,a){if(a.length===0)return;const u=(0,i.$lf)(a);if(u.length===1){this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+u[0]+this.f[d.lineNumber-1].substring(d.column-1));return}u[u.length-1]+=this.f[d.lineNumber-1].substring(d.column-1),this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+u[0]);const f=new Uint32Array(u.length-1);for(let w=1;w<u.length;w++)this.f.splice(d.lineNumber+w-1,0,u[w]),f[w-1]=u[w].length+this.g.length;this.j&&this.j.insertValues(d.lineNumber,f)}}t.$Zv=c}),se(ue[59],ae([0,1,7,46,5,2,56]),function(V,t,i,F,M,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OC=t.$MC=t.$JC=void 0,t.$KC=u,t.$LC=f,t.$NC=L;const d=999;class a{constructor($,v,j,l){this.searchString=$,this.isRegex=v,this.matchCase=j,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=u(this.searchString):$=this.searchString.indexOf(`
`)>=0;let v=null;try{v=i.$jf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!v)return null;let j=!this.isRegex&&!$;return j&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(j=this.matchCase),new p.$Iv(v,this.wordSeparators?(0,F.$Lt)(this.wordSeparators,[]):null,j?this.searchString:null)}}t.$JC=a;function u(N){if(!N||N.length===0)return!1;for(let $=0,v=N.length;$<v;$++){const j=N.charCodeAt($);if(j===10)return!0;if(j===92){if($++,$>=v)break;const l=N.charCodeAt($);if(l===110||l===114||l===87)return!0}}return!1}function f(N,$,v){if(!v)return new p.$Fv(N,null);const j=[];for(let l=0,n=$.length;l<n;l++)j[l]=$[l];return new p.$Fv(N,j)}class w{constructor($){const v=[];let j=0;for(let l=0,n=$.length;l<n;l++)$.charCodeAt(l)===10&&(v[j++]=l);this.a=v}findLineFeedCountBeforeOffset($){const v=this.a;let j=0,l=v.length-1;if(l===-1||$<=v[0])return 0;for(;j<l;){const n=j+((l-j)/2>>0);v[n]>=$?l=n-1:v[n+1]>=$?(j=n,l=n):j=n+1}return j+1}}class g{static findMatches($,v,j,l,n){const s=v.parseSearchRequest();return s?s.regex.multiline?this.b($,j,new E(s.wordSeparators,s.regex),l,n):this.c($,j,s,l,n):[]}static a($,v,j,l,n,s){let h,o=0;l?(o=l.findLineFeedCountBeforeOffset(n),h=v+n+o):h=v+n;let b;if(l){const P=l.findLineFeedCountBeforeOffset(n+s.length)-o;b=h+s.length+P}else b=h+s.length;const A=$.getPositionAt(h),R=$.getPositionAt(b);return new c.$ut(A.lineNumber,A.column,R.lineNumber,R.column)}static b($,v,j,l,n){const s=$.getOffsetAt(v.getStartPosition()),h=$.getValueInRange(v,1),o=$.getEOL()===`\r
`?new w(h):null,b=[];let A=0,R;for(j.reset(0);R=j.next(h);)if(b[A++]=f(this.a($,s,h,o,R.index,R[0]),R,l),A>=n)return b;return b}static c($,v,j,l,n){const s=[];let h=0;if(v.startLineNumber===v.endLineNumber){const b=$.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return h=this.d(j,b,v.startLineNumber,v.startColumn-1,h,s,l,n),s}const o=$.getLineContent(v.startLineNumber).substring(v.startColumn-1);h=this.d(j,o,v.startLineNumber,v.startColumn-1,h,s,l,n);for(let b=v.startLineNumber+1;b<v.endLineNumber&&h<n;b++)h=this.d(j,$.getLineContent(b),b,0,h,s,l,n);if(h<n){const b=$.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);h=this.d(j,b,v.endLineNumber,0,h,s,l,n)}return s}static d($,v,j,l,n,s,h,o){const b=$.wordSeparators;if(!h&&$.simpleSearch){const y=$.simpleSearch,P=y.length,T=v.length;let I=-P;for(;(I=v.indexOf(y,I+P))!==-1;)if((!b||L(b,v,T,I,P))&&(s[n++]=new p.$Fv(new c.$ut(j,I+1+l,j,I+1+P+l),null),n>=o))return n;return n}const A=new E($.wordSeparators,$.regex);let R;A.reset(0);do if(R=A.next(v),R&&(s[n++]=f(new c.$ut(j,R.index+1+l,j,R.index+1+R[0].length+l),R,h),n>=o))return n;while(R);return n}static findNextMatch($,v,j,l){const n=v.parseSearchRequest();if(!n)return null;const s=new E(n.wordSeparators,n.regex);return n.regex.multiline?this.e($,j,s,l):this.f($,j,s,l)}static e($,v,j,l){const n=new M.$tt(v.lineNumber,1),s=$.getOffsetAt(n),h=$.getLineCount(),o=$.getValueInRange(new c.$ut(n.lineNumber,n.column,h,$.getLineMaxColumn(h)),1),b=$.getEOL()===`\r
`?new w(o):null;j.reset(v.column-1);const A=j.next(o);return A?f(this.a($,s,o,b,A.index,A[0]),A,l):v.lineNumber!==1||v.column!==1?this.e($,new M.$tt(1,1),j,l):null}static f($,v,j,l){const n=$.getLineCount(),s=v.lineNumber,h=$.getLineContent(s),o=this.g(j,h,s,v.column,l);if(o)return o;for(let b=1;b<=n;b++){const A=(s+b-1)%n,R=$.getLineContent(A+1),y=this.g(j,R,A+1,1,l);if(y)return y}return null}static g($,v,j,l,n){$.reset(l-1);const s=$.next(v);return s?f(new c.$ut(j,s.index+1,j,s.index+1+s[0].length),s,n):null}static findPreviousMatch($,v,j,l){const n=v.parseSearchRequest();if(!n)return null;const s=new E(n.wordSeparators,n.regex);return n.regex.multiline?this.h($,j,s,l):this.j($,j,s,l)}static h($,v,j,l){const n=this.b($,new c.$ut(1,1,v.lineNumber,v.column),j,l,10*d);if(n.length>0)return n[n.length-1];const s=$.getLineCount();return v.lineNumber!==s||v.column!==$.getLineMaxColumn(s)?this.h($,new M.$tt(s,$.getLineMaxColumn(s)),j,l):null}static j($,v,j,l){const n=$.getLineCount(),s=v.lineNumber,h=$.getLineContent(s).substring(0,v.column-1),o=this.k(j,h,s,l);if(o)return o;for(let b=1;b<=n;b++){const A=(n+s-b-1)%n,R=$.getLineContent(A+1),y=this.k(j,R,A+1,l);if(y)return y}return null}static k($,v,j,l){let n=null,s;for($.reset(0);s=$.next(v);)n=f(new c.$ut(j,s.index+1,j,s.index+1+s[0].length),s,l);return n}}t.$MC=g;function m(N,$,v,j,l){if(j===0)return!0;const n=$.charCodeAt(j-1);if(N.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=$.charCodeAt(j);if(N.get(s)!==0)return!0}return!1}function e(N,$,v,j,l){if(j+l===v)return!0;const n=$.charCodeAt(j+l);if(N.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=$.charCodeAt(j+l-1);if(N.get(s)!==0)return!0}return!1}function L(N,$,v,j,l){return m(N,$,v,j,l)&&e(N,$,v,j,l)}class E{constructor($,v){this._wordSeparators=$,this.a=v,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const v=$.length;let j;do{if(this.b+this.c===v||(j=this.a.exec($),!j))return null;const l=j.index,n=j[0].length;if(l===this.b&&n===this.c){if(n===0){i.$Ff($,v,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=n,!this._wordSeparators||L(this._wordSeparators,$,v,l,n))return j}while(j);return null}}t.$OC=E}),se(ue[60],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$O3=M;const i=/\bMARK:\s*(.*)$/d,F=/^-+|-+$/g;function M(u,f){let w=[];if(f.findRegionSectionHeaders&&f.foldingRules?.markers){const g=c(u,f);w=w.concat(g)}if(f.findMarkSectionHeaders){const g=p(u);w=w.concat(g)}return w}function c(u,f){const w=[],g=u.getLineCount();for(let m=1;m<=g;m++){const e=u.getLineContent(m),L=e.match(f.foldingRules.markers.start);if(L){const E={startLineNumber:m,startColumn:L[0].length+1,endLineNumber:m,endColumn:e.length+1};if(E.endColumn>E.startColumn){const N={range:E,...a(e.substring(L[0].length)),shouldBeInComments:!1};(N.text||N.hasSeparatorLine)&&w.push(N)}}}return w}function p(u){const f=[],w=u.getLineCount();for(let g=1;g<=w;g++){const m=u.getLineContent(g);d(m,g,f)}return f}function d(u,f,w){i.lastIndex=0;const g=i.exec(u);if(g){const m=g.indices[1][0]+1,e=g.indices[1][1]+1,L={startLineNumber:f,startColumn:m,endLineNumber:f,endColumn:e};if(L.endColumn>L.startColumn){const E={range:L,...a(g[1]),shouldBeInComments:!0};(E.text||E.hasSeparatorLine)&&w.push(E)}}}function a(u){u=u.trim();const f=u.startsWith("-");return u=u.replace(F,""),{text:u,hasSeparatorLine:f}}}),se(ue[61],ae([0,1,2,59,7,13,30]),function(V,t,i,F,M,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$k3=void 0;class d{static computeUnicodeHighlights(e,L,E){const N=E?E.startLineNumber:1,$=E?E.endLineNumber:e.getLineCount(),v=new f(L),j=v.getCandidateCodePoints();let l;j==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${a(Array.from(j))}`,"g");const n=new F.$OC(null,l),s=[];let h=!1,o,b=0,A=0,R=0;e:for(let y=N,P=$;y<=P;y++){const T=e.getLineContent(y),I=T.length;n.reset(0);do if(o=n.next(T),o){let Q=o.index,x=o.index+o[0].length;if(Q>0){const Z=T.charCodeAt(Q-1);M.$Cf(Z)&&Q--}if(x+1<I){const Z=T.charCodeAt(x-1);M.$Cf(Z)&&x++}const S=T.substring(Q,x);let C=(0,p.$9s)(Q+1,p.$6s,T,0);C&&C.endColumn<=Q+1&&(C=null);const Y=v.shouldHighlightNonBasicASCII(S,C?C.word:null);if(Y!==0){if(Y===3?b++:Y===2?A++:Y===1?R++:(0,c.$fd)(Y),s.length>=1e3){h=!0;break e}s.push(new i.$ut(y,Q+1,y,x+1))}}while(o)}return{ranges:s,hasMore:h,ambiguousCharacterCount:b,invisibleCharacterCount:A,nonBasicAsciiCharacterCount:R}}static computeUnicodeHighlightReason(e,L){const E=new f(L);switch(E.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),v=E.ambiguousCharacters.getPrimaryConfusable($),j=M.$7f.getLocales().filter(l=>!M.$7f.getInstance(new Set([...L.allowedLocales,l])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(v),notAmbiguousInLocales:j}}case 1:return{kind:2}}}}t.$k3=d;function a(m,e){return`[${M.$af(m.map(E=>String.fromCodePoint(E)).join(""))}]`}var u;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class f{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=M.$7f.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const L of M.$8f.codePoints)w(String.fromCodePoint(L))||e.add(L);if(this.b.ambiguousCharacters)for(const L of this.ambiguousCharacters.getConfusableCodePoints())e.add(L);for(const L of this.a)e.delete(L);return e}shouldHighlightNonBasicASCII(e,L){const E=e.codePointAt(0);if(this.a.has(E))return 0;if(this.b.nonBasicASCII)return 1;let N=!1,$=!1;if(L)for(const v of L){const j=v.codePointAt(0),l=M.$Nf(v);N=N||l,!l&&!this.ambiguousCharacters.isAmbiguous(j)&&!M.$8f.isInvisibleCharacter(j)&&($=!0)}return!N&&$?0:this.b.invisibleCharacters&&!w(e)&&M.$8f.isInvisibleCharacter(E)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(E)?3:0}}function w(m){return m===" "||m===`
`||m==="	"}var g;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(g||(g={}))}),se(ue[62],ae([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.HoverVerbosityAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var i;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(i||(t.AccessibilitySupport=i={}));var F;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(F||(t.CodeActionTriggerType=F={}));var M;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(M||(t.CompletionItemInsertTextRule=M={}));var c;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(c||(t.CompletionItemKind=c={}));var p;(function(r){r[r.Deprecated=1]="Deprecated"})(p||(t.CompletionItemTag=p={}));var d;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(t.CompletionTriggerKind=d={}));var a;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var f;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(f||(t.DefaultEndOfLine=f={}));var w;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(w||(t.DocumentHighlightKind=w={}));var g;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(g||(t.EditorAutoIndentStrategy=g={}));var m;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSegmenterLocales=130]="wordSegmenterLocales",r[r.wordSeparators=131]="wordSeparators",r[r.wordWrap=132]="wordWrap",r[r.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=135]="wordWrapColumn",r[r.wordWrapOverride1=136]="wordWrapOverride1",r[r.wordWrapOverride2=137]="wordWrapOverride2",r[r.wrappingIndent=138]="wrappingIndent",r[r.wrappingStrategy=139]="wrappingStrategy",r[r.showDeprecated=140]="showDeprecated",r[r.inlayHints=141]="inlayHints",r[r.editorClassName=142]="editorClassName",r[r.pixelRatio=143]="pixelRatio",r[r.tabFocusMode=144]="tabFocusMode",r[r.layoutInfo=145]="layoutInfo",r[r.wrappingInfo=146]="wrappingInfo",r[r.defaultColorDecorators=147]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var L;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(L||(t.EndOfLineSequence=L={}));var E;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(E||(t.GlyphMarginLane=E={}));var N;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(N||(t.HoverVerbosityAction=N={}));var $;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})($||(t.IndentAction=$={}));var v;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var j;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(j||(t.InlayHintKind=j={}));var l;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(l||(t.InlineCompletionTriggerKind=l={}));var n;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(n||(t.InlineEditTriggerKind=n={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(t.KeyCode=s={}));var h;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(h||(t.MarkerSeverity=h={}));var o;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(o||(t.MarkerTag=o={}));var b;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(b||(t.MinimapPosition=b={}));var A;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(A||(t.MinimapSectionHeaderStyle=A={}));var R;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(R||(t.MouseTargetType=R={}));var y;(function(r){r[r.AIGenerated=1]="AIGenerated"})(y||(t.NewSymbolNameTag=y={}));var P;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(P||(t.NewSymbolNameTriggerKind=P={}));var T;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(T||(t.OverlayWidgetPositionPreference=T={}));var I;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(I||(t.OverviewRulerLane=I={}));var Q;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(Q||(t.PartialAcceptTriggerKind=Q={}));var x;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(x||(t.PositionAffinity=x={}));var S;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(S||(t.RenderLineNumbersType=S={}));var C;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(C||(t.RenderMinimap=C={}));var Y;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(Y||(t.ScrollType=Y={}));var Z;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(Z||(t.ScrollbarVisibility=Z={}));var H;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(H||(t.SelectionDirection=H={}));var G;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(G||(t.ShowLightbulbIconMode=G={}));var K;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(K||(t.SignatureHelpTriggerKind=K={}));var ee;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(ee||(t.SymbolKind=ee={}));var k;(function(r){r[r.Deprecated=1]="Deprecated"})(k||(t.SymbolTag=k={}));var X;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(X||(t.TextEditorCursorBlinkingStyle=X={}));var de;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(de||(t.TextEditorCursorStyle=de={}));var fe;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(fe||(t.TrackedRangeStickiness=fe={}));var ve;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(ve||(t.WrappingIndent=ve={}))}),se(ue[63],ae([0,1,11,10]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zt=void 0;class M{constructor(){this.a=new Map,this.b=new Map,this.c=new i.$ee,this.onDidChange=this.c.event,this.d=null}handleChange(d){this.c.fire({changedLanguages:d,changedColorMap:!1})}register(d,a){return this.a.set(d,a),this.handleChange([d]),(0,F.$Tc)(()=>{this.a.get(d)===a&&(this.a.delete(d),this.handleChange([d]))})}get(d){return this.a.get(d)||null}registerFactory(d,a){this.b.get(d)?.dispose();const u=new c(this,d,a);return this.b.set(d,u),(0,F.$Tc)(()=>{const f=this.b.get(d);!f||f!==u||(this.b.delete(d),f.dispose())})}async getOrCreate(d){const a=this.get(d);if(a)return a;const u=this.b.get(d);return!u||u.isResolved?null:(await u.resolve(),this.get(d))}isResolved(d){if(this.get(d))return!0;const u=this.b.get(d);return!!(!u||u.isResolved)}setColorMap(d){this.d=d,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Zt=M;class c extends F.$Vc{get isResolved(){return this.c}constructor(d,a,u){super(),this.f=d,this.g=a,this.h=u,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const d=await this.h.tokenizationSupport;this.c=!0,d&&!this.a&&this.B(this.f.register(this.g,d))}}}),se(ue[64],ae([65,66]),function(V,t){return V.create("vs/base/common/platform",t)}),se(ue[18],ae([0,1,64]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=s,t.$D=y,t.$J=P,t.$g="en";let F=!1,M=!1,c=!1,p=!1,d=!1,a=!1,u=!1,f=!1,w=!1,g=!1,m,e=t.$g,L=t.$g,E,N;const $=globalThis;let v;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?v=$.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const j=typeof v?.versions?.electron=="string",l=j&&v?.type==="renderer";if(typeof v=="object"){F=v.platform==="win32",M=v.platform==="darwin",c=v.platform==="linux",p=c&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,u=j,w=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const T=v.env.VSCODE_NLS_CONFIG;if(T)try{const I=JSON.parse(T),Q=I.availableLanguages["*"];m=I.locale,L=I.osLocale,e=Q||t.$g,E=I._translationsConfigFile}catch{}d=!0}else typeof navigator=="object"&&!l?(N=navigator.userAgent,F=N.indexOf("Windows")>=0,M=N.indexOf("Macintosh")>=0,f=(N.indexOf("Macintosh")>=0||N.indexOf("iPad")>=0||N.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,c=N.indexOf("Linux")>=0,g=N?.indexOf("Mobi")>=0,a=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=m,L=navigator.language):console.error("Unable to resolve platform.");var n;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(n||(t.Platform=n={}));function s(T){switch(T){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let h=0;M?h=1:F?h=3:c&&(h=2),t.$i=F,t.$j=M,t.$k=c,t.$l=p,t.$m=d,t.$n=u,t.$o=a,t.$p=a&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=f,t.$s=g,t.$t=w,t.$u=h,t.$v=N,t.$w=e;var o;(function(T){function I(){return t.$w}T.value=I;function Q(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}T.isDefaultVariant=Q;function x(){return t.$w==="en"}T.isDefault=x})(o||(t.Language=o={})),t.$x=m,t.$y=L,t.$z=E,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const T=[];$.addEventListener("message",Q=>{if(Q.data&&Q.data.vscodeScheduleAsyncWork)for(let x=0,S=T.length;x<S;x++){const C=T[x];if(C.id===Q.data.vscodeScheduleAsyncWork){T.splice(x,1),C.callback();return}}});let I=0;return Q=>{const x=++I;T.push({id:x,callback:Q}),$.postMessage({vscodeScheduleAsyncWork:x},"*")}}return T=>setTimeout(T)})();var b;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(b||(t.OperatingSystem=b={})),t.OS=M||f?2:F?1:3;let A=!0,R=!1;function y(){if(!R){R=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,A=new Uint16Array(T.buffer)[0]===513}return A}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function P(T){return parseFloat(T)>=20}}),se(ue[67],ae([0,1,18]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let F;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const c=M.process;F={get platform(){return c.platform},get arch(){return c.arch},get env(){return c.env},cwd(){return c.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.$ec=F.platform,t.$fc=F.arch}),se(ue[68],ae([0,1,67]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const F=65,M=97,c=90,p=122,d=46,a=47,u=92,f=58,w=63;class g extends Error{constructor(s,h,o){let b;typeof h=="string"&&h.indexOf("not ")===0?(b="must not be",h=h.replace(/^not /,"")):b="must be";const A=s.indexOf(".")!==-1?"property":"argument";let R=`The "${s}" ${A} ${b} of type ${h}`;R+=`. Received type ${typeof o}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function m(n,s){if(n===null||typeof n!="object")throw new g(s,"Object",n)}function e(n,s){if(typeof n!="string")throw new g(s,"string",n)}const L=i.$ec==="win32";function E(n){return n===a||n===u}function N(n){return n===a}function $(n){return n>=F&&n<=c||n>=M&&n<=p}function v(n,s,h,o){let b="",A=0,R=-1,y=0,P=0;for(let T=0;T<=n.length;++T){if(T<n.length)P=n.charCodeAt(T);else{if(o(P))break;P=a}if(o(P)){if(!(R===T-1||y===1))if(y===2){if(b.length<2||A!==2||b.charCodeAt(b.length-1)!==d||b.charCodeAt(b.length-2)!==d){if(b.length>2){const I=b.lastIndexOf(h);I===-1?(b="",A=0):(b=b.slice(0,I),A=b.length-1-b.lastIndexOf(h)),R=T,y=0;continue}else if(b.length!==0){b="",A=0,R=T,y=0;continue}}s&&(b+=b.length>0?`${h}..`:"..",A=2)}else b.length>0?b+=`${h}${n.slice(R+1,T)}`:b=n.slice(R+1,T),A=T-R-1;R=T,y=0}else P===d&&y!==-1?++y:y=-1}return b}function j(n,s){m(s,"pathObject");const h=s.dir||s.root,o=s.base||`${s.name||""}${s.ext||""}`;return h?h===s.root?`${h}${o}`:`${h}${n}${o}`:o}t.$gc={resolve(...n){let s="",h="",o=!1;for(let b=n.length-1;b>=-1;b--){let A;if(b>=0){if(A=n[b],e(A,"path"),A.length===0)continue}else s.length===0?A=i.cwd():(A=i.env[`=${s}`]||i.cwd(),(A===void 0||A.slice(0,2).toLowerCase()!==s.toLowerCase()&&A.charCodeAt(2)===u)&&(A=`${s}\\`));const R=A.length;let y=0,P="",T=!1;const I=A.charCodeAt(0);if(R===1)E(I)&&(y=1,T=!0);else if(E(I))if(T=!0,E(A.charCodeAt(1))){let Q=2,x=Q;for(;Q<R&&!E(A.charCodeAt(Q));)Q++;if(Q<R&&Q!==x){const S=A.slice(x,Q);for(x=Q;Q<R&&E(A.charCodeAt(Q));)Q++;if(Q<R&&Q!==x){for(x=Q;Q<R&&!E(A.charCodeAt(Q));)Q++;(Q===R||Q!==x)&&(P=`\\\\${S}\\${A.slice(x,Q)}`,y=Q)}}}else y=1;else $(I)&&A.charCodeAt(1)===f&&(P=A.slice(0,2),y=2,R>2&&E(A.charCodeAt(2))&&(T=!0,y=3));if(P.length>0)if(s.length>0){if(P.toLowerCase()!==s.toLowerCase())continue}else s=P;if(o){if(s.length>0)break}else if(h=`${A.slice(y)}\\${h}`,o=T,T&&s.length>0)break}return h=v(h,!o,"\\",E),o?`${s}\\${h}`:`${s}${h}`||"."},normalize(n){e(n,"path");const s=n.length;if(s===0)return".";let h=0,o,b=!1;const A=n.charCodeAt(0);if(s===1)return N(A)?"\\":n;if(E(A))if(b=!0,E(n.charCodeAt(1))){let y=2,P=y;for(;y<s&&!E(n.charCodeAt(y));)y++;if(y<s&&y!==P){const T=n.slice(P,y);for(P=y;y<s&&E(n.charCodeAt(y));)y++;if(y<s&&y!==P){for(P=y;y<s&&!E(n.charCodeAt(y));)y++;if(y===s)return`\\\\${T}\\${n.slice(P)}\\`;y!==P&&(o=`\\\\${T}\\${n.slice(P,y)}`,h=y)}}}else h=1;else $(A)&&n.charCodeAt(1)===f&&(o=n.slice(0,2),h=2,s>2&&E(n.charCodeAt(2))&&(b=!0,h=3));let R=h<s?v(n.slice(h),!b,"\\",E):"";return R.length===0&&!b&&(R="."),R.length>0&&E(n.charCodeAt(s-1))&&(R+="\\"),o===void 0?b?`\\${R}`:R:b?`${o}\\${R}`:`${o}${R}`},isAbsolute(n){e(n,"path");const s=n.length;if(s===0)return!1;const h=n.charCodeAt(0);return E(h)||s>2&&$(h)&&n.charCodeAt(1)===f&&E(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,h;for(let A=0;A<n.length;++A){const R=n[A];e(R,"path"),R.length>0&&(s===void 0?s=h=R:s+=`\\${R}`)}if(s===void 0)return".";let o=!0,b=0;if(typeof h=="string"&&E(h.charCodeAt(0))){++b;const A=h.length;A>1&&E(h.charCodeAt(1))&&(++b,A>2&&(E(h.charCodeAt(2))?++b:o=!1))}if(o){for(;b<s.length&&E(s.charCodeAt(b));)b++;b>=2&&(s=`\\${s.slice(b)}`)}return t.$gc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s)return"";const h=t.$gc.resolve(n),o=t.$gc.resolve(s);if(h===o||(n=h.toLowerCase(),s=o.toLowerCase(),n===s))return"";let b=0;for(;b<n.length&&n.charCodeAt(b)===u;)b++;let A=n.length;for(;A-1>b&&n.charCodeAt(A-1)===u;)A--;const R=A-b;let y=0;for(;y<s.length&&s.charCodeAt(y)===u;)y++;let P=s.length;for(;P-1>y&&s.charCodeAt(P-1)===u;)P--;const T=P-y,I=R<T?R:T;let Q=-1,x=0;for(;x<I;x++){const C=n.charCodeAt(b+x);if(C!==s.charCodeAt(y+x))break;C===u&&(Q=x)}if(x!==I){if(Q===-1)return o}else{if(T>I){if(s.charCodeAt(y+x)===u)return o.slice(y+x+1);if(x===2)return o.slice(y+x)}R>I&&(n.charCodeAt(b+x)===u?Q=x:x===2&&(Q=3)),Q===-1&&(Q=0)}let S="";for(x=b+Q+1;x<=A;++x)(x===A||n.charCodeAt(x)===u)&&(S+=S.length===0?"..":"\\..");return y+=Q,S.length>0?`${S}${o.slice(y,P)}`:(o.charCodeAt(y)===u&&++y,o.slice(y,P))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=t.$gc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===u){if(s.charCodeAt(1)===u){const h=s.charCodeAt(2);if(h!==w&&h!==d)return`\\\\?\\UNC\\${s.slice(2)}`}}else if($(s.charCodeAt(0))&&s.charCodeAt(1)===f&&s.charCodeAt(2)===u)return`\\\\?\\${s}`;return n},dirname(n){e(n,"path");const s=n.length;if(s===0)return".";let h=-1,o=0;const b=n.charCodeAt(0);if(s===1)return E(b)?n:".";if(E(b)){if(h=o=1,E(n.charCodeAt(1))){let y=2,P=y;for(;y<s&&!E(n.charCodeAt(y));)y++;if(y<s&&y!==P){for(P=y;y<s&&E(n.charCodeAt(y));)y++;if(y<s&&y!==P){for(P=y;y<s&&!E(n.charCodeAt(y));)y++;if(y===s)return n;y!==P&&(h=o=y+1)}}}}else $(b)&&n.charCodeAt(1)===f&&(h=s>2&&E(n.charCodeAt(2))?3:2,o=h);let A=-1,R=!0;for(let y=s-1;y>=o;--y)if(E(n.charCodeAt(y))){if(!R){A=y;break}}else R=!1;if(A===-1){if(h===-1)return".";A=h}return n.slice(0,A)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let h=0,o=-1,b=!0,A;if(n.length>=2&&$(n.charCodeAt(0))&&n.charCodeAt(1)===f&&(h=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let R=s.length-1,y=-1;for(A=n.length-1;A>=h;--A){const P=n.charCodeAt(A);if(E(P)){if(!b){h=A+1;break}}else y===-1&&(b=!1,y=A+1),R>=0&&(P===s.charCodeAt(R)?--R===-1&&(o=A):(R=-1,o=y))}return h===o?o=y:o===-1&&(o=n.length),n.slice(h,o)}for(A=n.length-1;A>=h;--A)if(E(n.charCodeAt(A))){if(!b){h=A+1;break}}else o===-1&&(b=!1,o=A+1);return o===-1?"":n.slice(h,o)},extname(n){e(n,"path");let s=0,h=-1,o=0,b=-1,A=!0,R=0;n.length>=2&&n.charCodeAt(1)===f&&$(n.charCodeAt(0))&&(s=o=2);for(let y=n.length-1;y>=s;--y){const P=n.charCodeAt(y);if(E(P)){if(!A){o=y+1;break}continue}b===-1&&(A=!1,b=y+1),P===d?h===-1?h=y:R!==1&&(R=1):h!==-1&&(R=-1)}return h===-1||b===-1||R===0||R===1&&h===b-1&&h===o+1?"":n.slice(h,b)},format:j.bind(null,"\\"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const h=n.length;let o=0,b=n.charCodeAt(0);if(h===1)return E(b)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(E(b)){if(o=1,E(n.charCodeAt(1))){let Q=2,x=Q;for(;Q<h&&!E(n.charCodeAt(Q));)Q++;if(Q<h&&Q!==x){for(x=Q;Q<h&&E(n.charCodeAt(Q));)Q++;if(Q<h&&Q!==x){for(x=Q;Q<h&&!E(n.charCodeAt(Q));)Q++;Q===h?o=Q:Q!==x&&(o=Q+1)}}}}else if($(b)&&n.charCodeAt(1)===f){if(h<=2)return s.root=s.dir=n,s;if(o=2,E(n.charCodeAt(2))){if(h===3)return s.root=s.dir=n,s;o=3}}o>0&&(s.root=n.slice(0,o));let A=-1,R=o,y=-1,P=!0,T=n.length-1,I=0;for(;T>=o;--T){if(b=n.charCodeAt(T),E(b)){if(!P){R=T+1;break}continue}y===-1&&(P=!1,y=T+1),b===d?A===-1?A=T:I!==1&&(I=1):A!==-1&&(I=-1)}return y!==-1&&(A===-1||I===0||I===1&&A===y-1&&A===R+1?s.base=s.name=n.slice(R,y):(s.name=n.slice(R,A),s.base=n.slice(R,y),s.ext=n.slice(A,y))),R>0&&R!==o?s.dir=n.slice(0,R-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(L){const n=/\\/g;return()=>{const s=i.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...n){let s="",h=!1;for(let o=n.length-1;o>=-1&&!h;o--){const b=o>=0?n[o]:l();e(b,"path"),b.length!==0&&(s=`${b}/${s}`,h=b.charCodeAt(0)===a)}return s=v(s,!h,"/",N),h?`/${s}`:s.length>0?s:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===a,h=n.charCodeAt(n.length-1)===a;return n=v(n,!s,"/",N),n.length===0?s?"/":h?"./":".":(h&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===a},join(...n){if(n.length===0)return".";let s;for(let h=0;h<n.length;++h){const o=n[h];e(o,"path"),o.length>0&&(s===void 0?s=o:s+=`/${o}`)}return s===void 0?".":t.$hc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s||(n=t.$hc.resolve(n),s=t.$hc.resolve(s),n===s))return"";const h=1,o=n.length,b=o-h,A=1,R=s.length-A,y=b<R?b:R;let P=-1,T=0;for(;T<y;T++){const Q=n.charCodeAt(h+T);if(Q!==s.charCodeAt(A+T))break;Q===a&&(P=T)}if(T===y)if(R>y){if(s.charCodeAt(A+T)===a)return s.slice(A+T+1);if(T===0)return s.slice(A+T)}else b>y&&(n.charCodeAt(h+T)===a?P=T:T===0&&(P=0));let I="";for(T=h+P+1;T<=o;++T)(T===o||n.charCodeAt(T)===a)&&(I+=I.length===0?"..":"/..");return`${I}${s.slice(A+P)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===a;let h=-1,o=!0;for(let b=n.length-1;b>=1;--b)if(n.charCodeAt(b)===a){if(!o){h=b;break}}else o=!1;return h===-1?s?"/":".":s&&h===1?"//":n.slice(0,h)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let h=0,o=-1,b=!0,A;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let R=s.length-1,y=-1;for(A=n.length-1;A>=0;--A){const P=n.charCodeAt(A);if(P===a){if(!b){h=A+1;break}}else y===-1&&(b=!1,y=A+1),R>=0&&(P===s.charCodeAt(R)?--R===-1&&(o=A):(R=-1,o=y))}return h===o?o=y:o===-1&&(o=n.length),n.slice(h,o)}for(A=n.length-1;A>=0;--A)if(n.charCodeAt(A)===a){if(!b){h=A+1;break}}else o===-1&&(b=!1,o=A+1);return o===-1?"":n.slice(h,o)},extname(n){e(n,"path");let s=-1,h=0,o=-1,b=!0,A=0;for(let R=n.length-1;R>=0;--R){const y=n.charCodeAt(R);if(y===a){if(!b){h=R+1;break}continue}o===-1&&(b=!1,o=R+1),y===d?s===-1?s=R:A!==1&&(A=1):s!==-1&&(A=-1)}return s===-1||o===-1||A===0||A===1&&s===o-1&&s===h+1?"":n.slice(s,o)},format:j.bind(null,"/"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const h=n.charCodeAt(0)===a;let o;h?(s.root="/",o=1):o=0;let b=-1,A=0,R=-1,y=!0,P=n.length-1,T=0;for(;P>=o;--P){const I=n.charCodeAt(P);if(I===a){if(!y){A=P+1;break}continue}R===-1&&(y=!1,R=P+1),I===d?b===-1?b=P:T!==1&&(T=1):b!==-1&&(T=-1)}if(R!==-1){const I=A===0&&h?1:A;b===-1||T===0||T===1&&b===R-1&&b===A+1?s.base=s.name=n.slice(I,R):(s.name=n.slice(I,b),s.base=n.slice(I,R),s.ext=n.slice(b,R))}return A>0?s.dir=n.slice(0,A-1):h&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=L?t.$gc.normalize:t.$hc.normalize,t.$jc=L?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=L?t.$gc.join:t.$hc.join,t.$lc=L?t.$gc.resolve:t.$hc.resolve,t.$mc=L?t.$gc.relative:t.$hc.relative,t.$nc=L?t.$gc.dirname:t.$hc.dirname,t.$oc=L?t.$gc.basename:t.$hc.basename,t.$pc=L?t.$gc.extname:t.$hc.extname,t.$qc=L?t.$gc.format:t.$hc.format,t.$rc=L?t.$gc.parse:t.$hc.parse,t.$sc=L?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=L?t.$gc.sep:t.$hc.sep,t.$uc=L?t.$gc.delimiter:t.$hc.delimiter}),se(ue[19],ae([0,1,68,18]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=j;const M=/^\w[\w\d+.-]*$/,c=/^\//,p=/^\/\//;function d(o,b){if(!o.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!M.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!c.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(o,b){return!o&&!b?"file":o}function u(o,b){switch(o){case"https":case"http":case"file":b?b[0]!==w&&(b=w+b):b=w;break}return b}const f="",w="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(b){return b instanceof m?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,A,R,y,P,T=!1){typeof b=="object"?(this.scheme=b.scheme||f,this.authority=b.authority||f,this.path=b.path||f,this.query=b.query||f,this.fragment=b.fragment||f):(this.scheme=a(b,T),this.authority=A||f,this.path=u(this.scheme,R||f),this.query=y||f,this.fragment=P||f,d(this,T))}get fsPath(){return j(this,!1)}with(b){if(!b)return this;let{scheme:A,authority:R,path:y,query:P,fragment:T}=b;return A===void 0?A=this.scheme:A===null&&(A=f),R===void 0?R=this.authority:R===null&&(R=f),y===void 0?y=this.path:y===null&&(y=f),P===void 0?P=this.query:P===null&&(P=f),T===void 0?T=this.fragment:T===null&&(T=f),A===this.scheme&&R===this.authority&&y===this.path&&P===this.query&&T===this.fragment?this:new E(A,R,y,P,T)}static parse(b,A=!1){const R=g.exec(b);return R?new E(R[2]||f,h(R[4]||f),h(R[5]||f),h(R[7]||f),h(R[9]||f),A):new E(f,f,f,f,f)}static file(b){let A=f;if(F.$i&&(b=b.replace(/\\/g,w)),b[0]===w&&b[1]===w){const R=b.indexOf(w,2);R===-1?(A=b.substring(2),b=w):(A=b.substring(2,R),b=b.substring(R)||w)}return new E("file",A,b,f,f)}static from(b,A){return new E(b.scheme,b.authority,b.path,b.query,b.fragment,A)}static joinPath(b,...A){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return F.$i&&b.scheme==="file"?R=m.file(i.$gc.join(j(b,!0),...A)).path:R=i.$hc.join(b.path,...A),b.with({path:R})}toString(b=!1){return l(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof m)return b;{const A=new E(b);return A._formatted=b.external??null,A._fsPath=b._sep===L?b.fsPath??null:null,A}}else return b}}t.URI=m;function e(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}const L=F.$i?1:void 0;class E extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=j(this,!1)),this._fsPath}toString(b=!1){return b?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const b={$mid:1};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=L),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const N={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(o,b,A){let R,y=-1;for(let P=0;P<o.length;P++){const T=o.charCodeAt(P);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||b&&T===47||A&&T===91||A&&T===93||A&&T===58)y!==-1&&(R+=encodeURIComponent(o.substring(y,P)),y=-1),R!==void 0&&(R+=o.charAt(P));else{R===void 0&&(R=o.substr(0,P));const I=N[T];I!==void 0?(y!==-1&&(R+=encodeURIComponent(o.substring(y,P)),y=-1),R+=I):y===-1&&(y=P)}}return y!==-1&&(R+=encodeURIComponent(o.substring(y))),R!==void 0?R:o}function v(o){let b;for(let A=0;A<o.length;A++){const R=o.charCodeAt(A);R===35||R===63?(b===void 0&&(b=o.substr(0,A)),b+=N[R]):b!==void 0&&(b+=o[A])}return b!==void 0?b:o}function j(o,b){let A;return o.authority&&o.path.length>1&&o.scheme==="file"?A=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?b?A=o.path.substr(1):A=o.path[1].toLowerCase()+o.path.substr(2):A=o.path,F.$i&&(A=A.replace(/\//g,"\\")),A}function l(o,b){const A=b?v:$;let R="",{scheme:y,authority:P,path:T,query:I,fragment:Q}=o;if(y&&(R+=y,R+=":"),(P||y==="file")&&(R+=w,R+=w),P){let x=P.indexOf("@");if(x!==-1){const S=P.substr(0,x);P=P.substr(x+1),x=S.lastIndexOf(":"),x===-1?R+=A(S,!1,!1):(R+=A(S.substr(0,x),!1,!1),R+=":",R+=A(S.substr(x+1),!1,!0)),R+="@"}P=P.toLowerCase(),x=P.lastIndexOf(":"),x===-1?R+=A(P,!1,!0):(R+=A(P.substr(0,x),!1,!0),R+=P.substr(x))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const x=T.charCodeAt(1);x>=65&&x<=90&&(T=`/${String.fromCharCode(x+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const x=T.charCodeAt(0);x>=65&&x<=90&&(T=`${String.fromCharCode(x+32)}:${T.substr(2)}`)}R+=A(T,!0,!1)}return I&&(R+="?",R+=A(I,!1,!1)),Q&&(R+="#",R+=b?Q:$(Q,!1,!1)),R}function n(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+n(o.substr(3)):o}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(o){return o.match(s)?o.replace(s,b=>n(b)):o}}),se(ue[73],ae([0,1,3,11,10,15,18,7]),function(V,t,i,F,M,c,p,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=f,t.create=s;const a="$initialize";let u=!1;function f(h){p.$o&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(h.message))}var w;(function(h){h[h.Request=0]="Request",h[h.Reply=1]="Reply",h[h.SubscribeEvent=2]="SubscribeEvent",h[h.Event=3]="Event",h[h.UnsubscribeEvent=4]="UnsubscribeEvent"})(w||(w={}));class g{constructor(o,b,A,R){this.vsWorker=o,this.req=b,this.method=A,this.args=R,this.type=0}}class m{constructor(o,b,A,R){this.vsWorker=o,this.seq=b,this.res=A,this.err=R,this.type=1}}class e{constructor(o,b,A,R){this.vsWorker=o,this.req=b,this.eventName=A,this.arg=R,this.type=2}}class L{constructor(o,b,A){this.vsWorker=o,this.req=b,this.event=A,this.type=3}}class E{constructor(o,b){this.vsWorker=o,this.req=b,this.type=4}}class N{constructor(o){this.a=-1,this.g=o,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(o){this.a=o}sendMessage(o,b){const A=String(++this.b);return new Promise((R,y)=>{this.c[A]={resolve:R,reject:y},this.o(new g(this.a,A,o,b))})}listen(o,b){let A=null;const R=new F.$ee({onWillAddFirstListener:()=>{A=String(++this.b),this.d.set(A,R),this.o(new e(this.a,A,o,b))},onDidRemoveLastListener:()=>{this.d.delete(A),this.o(new E(this.a,A)),A=null}});return R.event}handleMessage(o){!o||!o.vsWorker||this.a!==-1&&o.vsWorker!==this.a||this.h(o)}h(o){switch(o.type){case 1:return this.j(o);case 0:return this.k(o);case 2:return this.l(o);case 3:return this.m(o);case 4:return this.n(o)}}j(o){if(!this.c[o.seq]){console.warn("Got reply to unknown seq");return}const b=this.c[o.seq];if(delete this.c[o.seq],o.err){let A=o.err;o.err.$isError&&(A=new Error,A.name=o.err.name,A.message=o.err.message,A.stack=o.err.stack),b.reject(A);return}b.resolve(o.res)}k(o){const b=o.req;this.g.handleMessage(o.method,o.args).then(R=>{this.o(new m(this.a,b,R,void 0))},R=>{R.detail instanceof Error&&(R.detail=(0,i.$3)(R.detail)),this.o(new m(this.a,b,void 0,(0,i.$3)(R)))})}l(o){const b=o.req,A=this.g.handleEvent(o.eventName,o.arg)(R=>{this.o(new L(this.a,b,R))});this.f.set(b,A)}m(o){if(!this.d.has(o.req)){console.warn("Got event for unknown req");return}this.d.get(o.req).fire(o.event)}n(o){if(!this.f.has(o.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(o.req).dispose(),this.f.delete(o.req)}o(o){const b=[];if(o.type===0)for(let A=0;A<o.args.length;A++)o.args[A]instanceof ArrayBuffer&&b.push(o.args[A]);else o.type===1&&o.res instanceof ArrayBuffer&&b.push(o.res);this.g.sendMessage(o,b)}}class $ extends M.$Vc{constructor(o,b,A){super();let R=null;this.a=this.B(o.create("vs/base/common/worker/simpleWorker",x=>{this.c.handleMessage(x)},x=>{R?.(x)})),this.c=new N({sendMessage:(x,S)=>{this.a.postMessage(x,S)},handleMessage:(x,S)=>{if(typeof A[x]!="function")return Promise.reject(new Error("Missing method "+x+" on main thread host."));try{return Promise.resolve(A[x].apply(A,S))}catch(C){return Promise.reject(C)}},handleEvent:(x,S)=>{if(j(x)){const C=A[x].call(A,S);if(typeof C!="function")throw new Error(`Missing dynamic event ${x} on main thread host.`);return C}if(v(x)){const C=A[x];if(typeof C!="function")throw new Error(`Missing event ${x} on main thread host.`);return C}throw new Error(`Malformed event name ${x}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const P=globalThis.require;typeof P<"u"&&typeof P.getConfig=="function"?y=P.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const T=(0,c.$ao)(A);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(y)),b,T]);const I=(x,S)=>this.g(x,S),Q=(x,S)=>this.c.listen(x,S);this.f=new Promise((x,S)=>{R=S,this.b.then(C=>{x(l(C,I,Q))},C=>{S(C),this.h("Worker failed to load "+b,C)})})}getProxyObject(){return this.f}g(o,b){return new Promise((A,R)=>{this.b.then(()=>{this.c.sendMessage(o,b).then(A,R)},R)})}h(o,b){console.error(o),console.info(b)}}t.SimpleWorkerClient=$;function v(h){return h[0]==="o"&&h[1]==="n"&&d.$xf(h.charCodeAt(2))}function j(h){return/^onDynamic/.test(h)&&d.$xf(h.charCodeAt(9))}function l(h,o,b){const A=P=>function(){const T=Array.prototype.slice.call(arguments,0);return o(P,T)},R=P=>function(T){return b(P,T)},y={};for(const P of h){if(j(P)){y[P]=R(P);continue}if(v(P)){y[P]=b(P,void 0);continue}y[P]=A(P)}return y}class n{constructor(o,b){this.a=b,this.b=null,this.c=new N({sendMessage:(A,R)=>{o(A,R)},handleMessage:(A,R)=>this.d(A,R),handleEvent:(A,R)=>this.f(A,R)})}onmessage(o){this.c.handleMessage(o)}d(o,b){if(o===a)return this.g(b[0],b[1],b[2],b[3]);if(!this.b||typeof this.b[o]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+o));try{return Promise.resolve(this.b[o].apply(this.b,b))}catch(A){return Promise.reject(A)}}f(o,b){if(!this.b)throw new Error("Missing requestHandler");if(j(o)){const A=this.b[o].call(this.b,b);if(typeof A!="function")throw new Error(`Missing dynamic event ${o} on request handler.`);return A}if(v(o)){const A=this.b[o];if(typeof A!="function")throw new Error(`Missing event ${o} on request handler.`);return A}throw new Error(`Malformed event name ${o}`)}g(o,b,A,R){this.c.setWorkerId(o);const T=l(R,(I,Q)=>this.c.sendMessage(I,Q),(I,Q)=>this.c.listen(I,Q));return this.a?(this.b=this.a(T),Promise.resolve((0,c.$ao)(this.b))):(b&&(typeof b.baseUrl<"u"&&delete b.baseUrl,typeof b.paths<"u"&&typeof b.paths.vs<"u"&&delete b.paths.vs,typeof b.trustedTypesPolicy<"u"&&delete b.trustedTypesPolicy,b.catchError=!0,globalThis.require.config(b)),new Promise((I,Q)=>{(globalThis.require||V)([A],S=>{if(this.b=S.create(T),!this.b){Q(new Error("No RequestHandler!"));return}I((0,c.$ao)(this.b))},Q)}))}}t.SimpleWorkerServer=n;function s(h){return new n(h,null)}}),se(ue[69],ae([65,66]),function(V,t){return V.create("vs/editor/common/languages",t)}),se(ue[70],ae([0,1,43,19,44,2,63,69]),function(V,t,i,F,M,c,p,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$fu=t.$eu=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.$du=t.$cu=t.SymbolKinds=t.SymbolTag=t.$au=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.$$t=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.HoverVerbosityAction=t.$0t=t.$9t=t.$8t=void 0,t.$_t=h,t.$bu=b;class a{constructor(X,de,fe){this.offset=X,this.type=de,this.language=fe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$8t=a;class u{constructor(X,de){this.tokens=X,this.endState=de,this._tokenizationResultBrand=void 0}}t.$9t=u;class f{constructor(X,de){this.tokens=X,this.endState=de,this._encodedTokenizationResultBrand=void 0}}t.$0t=f;var w;(function(k){k[k.Increase=0]="Increase",k[k.Decrease=1]="Decrease"})(w||(t.HoverVerbosityAction=w={}));var g;(function(k){k[k.Method=0]="Method",k[k.Function=1]="Function",k[k.Constructor=2]="Constructor",k[k.Field=3]="Field",k[k.Variable=4]="Variable",k[k.Class=5]="Class",k[k.Struct=6]="Struct",k[k.Interface=7]="Interface",k[k.Module=8]="Module",k[k.Property=9]="Property",k[k.Event=10]="Event",k[k.Operator=11]="Operator",k[k.Unit=12]="Unit",k[k.Value=13]="Value",k[k.Constant=14]="Constant",k[k.Enum=15]="Enum",k[k.EnumMember=16]="EnumMember",k[k.Keyword=17]="Keyword",k[k.Text=18]="Text",k[k.Color=19]="Color",k[k.File=20]="File",k[k.Reference=21]="Reference",k[k.Customcolor=22]="Customcolor",k[k.Folder=23]="Folder",k[k.TypeParameter=24]="TypeParameter",k[k.User=25]="User",k[k.Issue=26]="Issue",k[k.Snippet=27]="Snippet"})(g||(t.CompletionItemKind=g={}));var m;(function(k){const X=new Map;X.set(0,i.$Vj.symbolMethod),X.set(1,i.$Vj.symbolFunction),X.set(2,i.$Vj.symbolConstructor),X.set(3,i.$Vj.symbolField),X.set(4,i.$Vj.symbolVariable),X.set(5,i.$Vj.symbolClass),X.set(6,i.$Vj.symbolStruct),X.set(7,i.$Vj.symbolInterface),X.set(8,i.$Vj.symbolModule),X.set(9,i.$Vj.symbolProperty),X.set(10,i.$Vj.symbolEvent),X.set(11,i.$Vj.symbolOperator),X.set(12,i.$Vj.symbolUnit),X.set(13,i.$Vj.symbolValue),X.set(15,i.$Vj.symbolEnum),X.set(14,i.$Vj.symbolConstant),X.set(15,i.$Vj.symbolEnum),X.set(16,i.$Vj.symbolEnumMember),X.set(17,i.$Vj.symbolKeyword),X.set(27,i.$Vj.symbolSnippet),X.set(18,i.$Vj.symbolText),X.set(19,i.$Vj.symbolColor),X.set(20,i.$Vj.symbolFile),X.set(21,i.$Vj.symbolReference),X.set(22,i.$Vj.symbolCustomColor),X.set(23,i.$Vj.symbolFolder),X.set(24,i.$Vj.symbolTypeParameter),X.set(25,i.$Vj.account),X.set(26,i.$Vj.issues);function de(r){let je=X.get(r);return je||(console.info("No codicon found for CompletionItemKind "+r),je=i.$Vj.symbolProperty),je}k.toIcon=de;const fe=new Map;fe.set("method",0),fe.set("function",1),fe.set("constructor",2),fe.set("field",3),fe.set("variable",4),fe.set("class",5),fe.set("struct",6),fe.set("interface",7),fe.set("module",8),fe.set("property",9),fe.set("event",10),fe.set("operator",11),fe.set("unit",12),fe.set("value",13),fe.set("constant",14),fe.set("enum",15),fe.set("enum-member",16),fe.set("enumMember",16),fe.set("keyword",17),fe.set("snippet",27),fe.set("text",18),fe.set("color",19),fe.set("file",20),fe.set("reference",21),fe.set("customcolor",22),fe.set("folder",23),fe.set("type-parameter",24),fe.set("typeParameter",24),fe.set("account",25),fe.set("issue",26);function ve(r,je){let Ae=fe.get(r);return typeof Ae>"u"&&!je&&(Ae=9),Ae}k.fromString=ve})(m||(t.CompletionItemKinds=m={}));var e;(function(k){k[k.Deprecated=1]="Deprecated"})(e||(t.CompletionItemTag=e={}));var L;(function(k){k[k.None=0]="None",k[k.KeepWhitespace=1]="KeepWhitespace",k[k.InsertAsSnippet=4]="InsertAsSnippet"})(L||(t.CompletionItemInsertTextRule=L={}));var E;(function(k){k[k.Word=0]="Word",k[k.Line=1]="Line",k[k.Suggest=2]="Suggest"})(E||(t.PartialAcceptTriggerKind=E={}));var N;(function(k){k[k.Invoke=0]="Invoke",k[k.TriggerCharacter=1]="TriggerCharacter",k[k.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(N||(t.CompletionTriggerKind=N={}));var $;(function(k){k[k.Automatic=0]="Automatic",k[k.Explicit=1]="Explicit"})($||(t.InlineCompletionTriggerKind=$={}));class v{constructor(X,de,fe,ve){this.range=X,this.text=de,this.completionKind=fe,this.isSnippetText=ve}equals(X){return c.$ut.lift(this.range).equalsRange(X.range)&&this.text===X.text&&this.completionKind===X.completionKind&&this.isSnippetText===X.isSnippetText}}t.$$t=v;var j;(function(k){k[k.Invoke=1]="Invoke",k[k.Auto=2]="Auto"})(j||(t.CodeActionTriggerType=j={}));var l;(function(k){k[k.Automatic=0]="Automatic",k[k.PasteAs=1]="PasteAs"})(l||(t.DocumentPasteTriggerKind=l={}));var n;(function(k){k[k.Invoke=1]="Invoke",k[k.TriggerCharacter=2]="TriggerCharacter",k[k.ContentChange=3]="ContentChange"})(n||(t.SignatureHelpTriggerKind=n={}));var s;(function(k){k[k.Text=0]="Text",k[k.Read=1]="Read",k[k.Write=2]="Write"})(s||(t.DocumentHighlightKind=s={}));function h(k){return k&&F.URI.isUri(k.uri)&&c.$ut.isIRange(k.range)&&(c.$ut.isIRange(k.originSelectionRange)||c.$ut.isIRange(k.targetSelectionRange))}var o;(function(k){k[k.File=0]="File",k[k.Module=1]="Module",k[k.Namespace=2]="Namespace",k[k.Package=3]="Package",k[k.Class=4]="Class",k[k.Method=5]="Method",k[k.Property=6]="Property",k[k.Field=7]="Field",k[k.Constructor=8]="Constructor",k[k.Enum=9]="Enum",k[k.Interface=10]="Interface",k[k.Function=11]="Function",k[k.Variable=12]="Variable",k[k.Constant=13]="Constant",k[k.String=14]="String",k[k.Number=15]="Number",k[k.Boolean=16]="Boolean",k[k.Array=17]="Array",k[k.Object=18]="Object",k[k.Key=19]="Key",k[k.Null=20]="Null",k[k.EnumMember=21]="EnumMember",k[k.Struct=22]="Struct",k[k.Event=23]="Event",k[k.Operator=24]="Operator",k[k.TypeParameter=25]="TypeParameter"})(o||(t.SymbolKind=o={})),t.$au={17:(0,d.localize)(0,null),16:(0,d.localize)(1,null),4:(0,d.localize)(2,null),13:(0,d.localize)(3,null),8:(0,d.localize)(4,null),9:(0,d.localize)(5,null),21:(0,d.localize)(6,null),23:(0,d.localize)(7,null),7:(0,d.localize)(8,null),0:(0,d.localize)(9,null),11:(0,d.localize)(10,null),10:(0,d.localize)(11,null),19:(0,d.localize)(12,null),5:(0,d.localize)(13,null),1:(0,d.localize)(14,null),2:(0,d.localize)(15,null),20:(0,d.localize)(16,null),15:(0,d.localize)(17,null),18:(0,d.localize)(18,null),24:(0,d.localize)(19,null),3:(0,d.localize)(20,null),6:(0,d.localize)(21,null),14:(0,d.localize)(22,null),22:(0,d.localize)(23,null),25:(0,d.localize)(24,null),12:(0,d.localize)(25,null)};function b(k,X){return(0,d.localize)(26,null,k,t.$au[X])}var A;(function(k){k[k.Deprecated=1]="Deprecated"})(A||(t.SymbolTag=A={}));var R;(function(k){const X=new Map;X.set(0,i.$Vj.symbolFile),X.set(1,i.$Vj.symbolModule),X.set(2,i.$Vj.symbolNamespace),X.set(3,i.$Vj.symbolPackage),X.set(4,i.$Vj.symbolClass),X.set(5,i.$Vj.symbolMethod),X.set(6,i.$Vj.symbolProperty),X.set(7,i.$Vj.symbolField),X.set(8,i.$Vj.symbolConstructor),X.set(9,i.$Vj.symbolEnum),X.set(10,i.$Vj.symbolInterface),X.set(11,i.$Vj.symbolFunction),X.set(12,i.$Vj.symbolVariable),X.set(13,i.$Vj.symbolConstant),X.set(14,i.$Vj.symbolString),X.set(15,i.$Vj.symbolNumber),X.set(16,i.$Vj.symbolBoolean),X.set(17,i.$Vj.symbolArray),X.set(18,i.$Vj.symbolObject),X.set(19,i.$Vj.symbolKey),X.set(20,i.$Vj.symbolNull),X.set(21,i.$Vj.symbolEnumMember),X.set(22,i.$Vj.symbolStruct),X.set(23,i.$Vj.symbolEvent),X.set(24,i.$Vj.symbolOperator),X.set(25,i.$Vj.symbolTypeParameter);function de(fe){let ve=X.get(fe);return ve||(console.info("No codicon found for SymbolKind "+fe),ve=i.$Vj.symbolProperty),ve}k.toIcon=de})(R||(t.SymbolKinds=R={}));class y{static asEditOperation(X){return M.$vt.replace(c.$ut.lift(X.range),X.text)}}t.$cu=y;class P{static{this.Comment=new P("comment")}static{this.Imports=new P("imports")}static{this.Region=new P("region")}static fromValue(X){switch(X){case"comment":return P.Comment;case"imports":return P.Imports;case"region":return P.Region}return new P(X)}constructor(X){this.value=X}}t.$du=P;var T;(function(k){k[k.AIGenerated=1]="AIGenerated"})(T||(t.NewSymbolNameTag=T={}));var I;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(I||(t.NewSymbolNameTriggerKind=I={}));var Q;(function(k){function X(de){return!de||typeof de!="object"?!1:typeof de.id=="string"&&typeof de.title=="string"}k.is=X})(Q||(t.Command=Q={}));var x;(function(k){k[k.Collapsed=0]="Collapsed",k[k.Expanded=1]="Expanded"})(x||(t.CommentThreadCollapsibleState=x={}));var S;(function(k){k[k.Unresolved=0]="Unresolved",k[k.Resolved=1]="Resolved"})(S||(t.CommentThreadState=S={}));var C;(function(k){k[k.Current=0]="Current",k[k.Outdated=1]="Outdated"})(C||(t.CommentThreadApplicability=C={}));var Y;(function(k){k[k.Editing=0]="Editing",k[k.Preview=1]="Preview"})(Y||(t.CommentMode=Y={}));var Z;(function(k){k[k.Published=0]="Published",k[k.Draft=1]="Draft"})(Z||(t.CommentState=Z={}));var H;(function(k){k[k.Type=1]="Type",k[k.Parameter=2]="Parameter"})(H||(t.InlayHintKind=H={}));class G{constructor(X){this.b=X,this.a=null}dispose(){this.a&&this.a.then(X=>{X&&X.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$eu=G,t.$fu=new p.$Zt;var K;(function(k){k[k.None=0]="None",k[k.Option=1]="Option",k[k.Default=2]="Default",k[k.Preferred=3]="Preferred"})(K||(t.ExternalUriOpenerPriority=K={}));var ee;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(ee||(t.InlineEditTriggerKind=ee={}))}),se(ue[71],ae([0,1,24,11,38,19,5,2,45,70,62]),function(V,t,i,F,M,c,p,d,a,u,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$p3=void 0,t.$q3=g;class w{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,L){return(0,M.$Er)(e,L)}}t.$p3=w;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.$pe,Emitter:F.$ee,KeyCode:f.KeyCode,KeyMod:w,Position:p.$tt,Range:d.$ut,Selection:a.$wt,SelectionDirection:f.SelectionDirection,MarkerSeverity:f.MarkerSeverity,MarkerTag:f.MarkerTag,Uri:c.URI,Token:u.$8t}}}),se(ue[74],ae([0,1,25,19,5,2,58,30,54,55,71,23,61,34,52,15,3,53,60]),function(V,t,i,F,M,c,p,d,a,u,f,w,g,m,e,L,E,N,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=void 0,t.create=l;class v extends p.$Zv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(s){const h=[];for(let o=0;o<this.f.length;o++){const b=this.f[o],A=this.offsetAt(new M.$tt(o+1,1)),R=b.matchAll(s);for(const y of R)(y.index||y.index===0)&&(y.index=y.index+A),h.push(y)}return h}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(s){return this.f[s-1]}getWordAtPosition(s,h){const o=(0,d.$9s)(s.column,(0,d.$7s)(h),this.f[s.lineNumber-1],0);return o?new c.$ut(s.lineNumber,o.startColumn,s.lineNumber,o.endColumn):null}getWordUntilPosition(s,h){const o=this.getWordAtPosition(s,h);return o?{word:this.f[s.lineNumber-1].substring(o.startColumn-1,s.column-1),startColumn:o.startColumn,endColumn:s.column}:{word:"",startColumn:s.column,endColumn:s.column}}words(s){const h=this.f,o=this.q.bind(this);let b=0,A="",R=0,y=[];return{*[Symbol.iterator](){for(;;)if(R<y.length){const P=A.substring(y[R].start,y[R].end);R+=1,yield P}else if(b<h.length)A=h[b],y=o(A,s),R=0,b+=1;else break}}}getLineWords(s,h){const o=this.f[s-1],b=this.q(o,h),A=[];for(const R of b)A.push({word:o.substring(R.start,R.end),startColumn:R.start+1,endColumn:R.end+1});return A}q(s,h){const o=[];let b;for(h.lastIndex=0;(b=h.exec(s))&&b[0].length!==0;)o.push({start:b.index,end:b.index+b[0].length});return o}getValueInRange(s){if(s=this.r(s),s.startLineNumber===s.endLineNumber)return this.f[s.startLineNumber-1].substring(s.startColumn-1,s.endColumn-1);const h=this.g,o=s.startLineNumber-1,b=s.endLineNumber-1,A=[];A.push(this.f[o].substring(s.startColumn-1));for(let R=o+1;R<b;R++)A.push(this.f[R]);return A.push(this.f[b].substring(0,s.endColumn-1)),A.join(h)}offsetAt(s){return s=this.s(s),this.l(),this.j.getPrefixSum(s.lineNumber-2)+(s.column-1)}positionAt(s){s=Math.floor(s),s=Math.max(0,s),this.l();const h=this.j.getIndexOf(s),o=this.f[h.index].length;return{lineNumber:1+h.index,column:1+Math.min(h.remainder,o)}}r(s){const h=this.s({lineNumber:s.startLineNumber,column:s.startColumn}),o=this.s({lineNumber:s.endLineNumber,column:s.endColumn});return h.lineNumber!==s.startLineNumber||h.column!==s.startColumn||o.lineNumber!==s.endLineNumber||o.column!==s.endColumn?{startLineNumber:h.lineNumber,startColumn:h.column,endLineNumber:o.lineNumber,endColumn:o.column}:s}s(s){if(!M.$tt.isIPosition(s))throw new Error("bad position");let{lineNumber:h,column:o}=s,b=!1;if(h<1)h=1,o=1,b=!0;else if(h>this.f.length)h=this.f.length,o=this.f[h-1].length+1,b=!0;else{const A=this.f[h-1].length+1;o<1?(o=1,b=!0):o>A&&(o=A,b=!0)}return b?{lineNumber:h,column:o}:s}}class j{constructor(s,h){this.d=s,this.f=Object.create(null),this.g=h,this.h=null}dispose(){this.f=Object.create(null)}j(s){return this.f[s]}k(){const s=[];return Object.keys(this.f).forEach(h=>s.push(this.f[h])),s}acceptNewModel(s){this.f[s.url]=new v(F.URI.parse(s.url),s.lines,s.EOL,s.versionId)}acceptModelChanged(s,h){if(!this.f[s])return;this.f[s].onEvents(h)}acceptRemovedModel(s){this.f[s]&&delete this.f[s]}async computeUnicodeHighlights(s,h,o){const b=this.j(s);return b?g.$k3.computeUnicodeHighlights(b,h,o):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(s,h){const o=this.j(s);return o?(0,$.$O3)(o,h):[]}async computeDiff(s,h,o,b){const A=this.j(s),R=this.j(h);return!A||!R?null:j.l(A,R,o,b)}static l(s,h,o,b){const A=b==="advanced"?e.$M3.getDefault():e.$M3.getLegacy(),R=s.getLinesContent(),y=h.getLinesContent(),P=A.computeDiff(R,y,o),T=P.changes.length>0?!1:this.n(s,h);function I(Q){return Q.map(x=>[x.original.startLineNumber,x.original.endLineNumberExclusive,x.modified.startLineNumber,x.modified.endLineNumberExclusive,x.innerChanges?.map(S=>[S.originalRange.startLineNumber,S.originalRange.startColumn,S.originalRange.endLineNumber,S.originalRange.endColumn,S.modifiedRange.startLineNumber,S.modifiedRange.startColumn,S.modifiedRange.endLineNumber,S.modifiedRange.endColumn])])}return{identical:T,quitEarly:P.hitTimeout,changes:I(P.changes),moves:P.moves.map(Q=>[Q.lineRangeMapping.original.startLineNumber,Q.lineRangeMapping.original.endLineNumberExclusive,Q.lineRangeMapping.modified.startLineNumber,Q.lineRangeMapping.modified.endLineNumberExclusive,I(Q.changes)])}}static n(s,h){const o=s.getLineCount(),b=h.getLineCount();if(o!==b)return!1;for(let A=1;A<=o;A++){const R=s.getLineContent(A),y=h.getLineContent(A);if(R!==y)return!1}return!0}async computeDirtyDiff(s,h,o){const b=this.j(s),A=this.j(h);if(!b||!A)return null;const R=b.getLinesContent(),y=A.getLinesContent();return new m.$Tv(R,y,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:o,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(s,h,o){const b=this.j(s);if(!b)return h;const A=[];let R;h=h.slice(0).sort((P,T)=>{if(P.range&&T.range)return c.$ut.compareRangesUsingStarts(P.range,T.range);const I=P.range?0:1,Q=T.range?0:1;return I-Q});let y=0;for(let P=1;P<h.length;P++)c.$ut.getEndPosition(h[y].range).equals(c.$ut.getStartPosition(h[P].range))?(h[y].range=c.$ut.fromPositions(c.$ut.getStartPosition(h[y].range),c.$ut.getEndPosition(h[P].range)),h[y].text+=h[P].text):(y++,h[y]=h[P]);h.length=y+1;for(let{range:P,text:T,eol:I}of h){if(typeof I=="number"&&(R=I),c.$ut.isEmpty(P)&&!T)continue;const Q=b.getValueInRange(P);if(T=T.replace(/\r\n|\n|\r/g,b.eol),Q===T)continue;if(Math.max(T.length,Q.length)>j.o){A.push({range:P,text:T});continue}const x=(0,i.$zt)(Q,T,o),S=b.offsetAt(c.$ut.lift(P).getStartPosition());for(const C of x){const Y=b.positionAt(S+C.originalStart),Z=b.positionAt(S+C.originalStart+C.originalLength),H={text:T.substr(C.modifiedStart,C.modifiedLength),range:{startLineNumber:Y.lineNumber,startColumn:Y.column,endLineNumber:Z.lineNumber,endColumn:Z.column}};b.getValueInRange(H.range)!==H.text&&A.push(H)}}return typeof R=="number"&&A.push({eol:R,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),A}computeHumanReadableDiff(s,h,o){const b=this.j(s);if(!b)return h;const A=[];let R;h=h.slice(0).sort((y,P)=>{if(y.range&&P.range)return c.$ut.compareRangesUsingStarts(y.range,P.range);const T=y.range?0:1,I=P.range?0:1;return T-I});for(let{range:y,text:P,eol:T}of h){let Y=function(H,G){return new M.$tt(H.lineNumber+G.lineNumber-1,G.lineNumber===1?H.column+G.column-1:G.column)},Z=function(H,G){const K=[];for(let ee=G.startLineNumber;ee<=G.endLineNumber;ee++){const k=H[ee-1];ee===G.startLineNumber&&ee===G.endLineNumber?K.push(k.substring(G.startColumn-1,G.endColumn-1)):ee===G.startLineNumber?K.push(k.substring(G.startColumn-1)):ee===G.endLineNumber?K.push(k.substring(0,G.endColumn-1)):K.push(k)}return K};if(typeof T=="number"&&(R=T),c.$ut.isEmpty(y)&&!P)continue;const I=b.getValueInRange(y);if(P=P.replace(/\r\n|\n|\r/g,b.eol),I===P)continue;if(Math.max(P.length,I.length)>j.o){A.push({range:y,text:P});continue}const Q=I.split(/\r\n|\n|\r/),x=P.split(/\r\n|\n|\r/),S=e.$M3.getDefault().computeDiff(Q,x,o),C=c.$ut.lift(y).getStartPosition();for(const H of S.changes)if(H.innerChanges)for(const G of H.innerChanges)A.push({range:c.$ut.fromPositions(Y(C,G.originalRange.getStartPosition()),Y(C,G.originalRange.getEndPosition())),text:Z(x,G.modifiedRange).join(b.eol)});else throw new E.$cb("The experimental diff algorithm always produces inner changes")}return typeof R=="number"&&A.push({eol:R,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),A}async computeLinks(s){const h=this.j(s);return h?(0,a.$n3)(h):null}async computeDefaultDocumentColors(s){const h=this.j(s);return h?(0,N.$N3)(h):null}static{this.p=1e4}async textualSuggest(s,h,o,b){const A=new w.$ae,R=new RegExp(o,b),y=new Set;e:for(const P of s){const T=this.j(P);if(T){for(const I of T.words(R))if(!(I===h||!isNaN(Number(I)))&&(y.add(I),y.size>j.p))break e}}return{words:Array.from(y),duration:A.elapsed()}}async computeWordRanges(s,h,o,b){const A=this.j(s);if(!A)return Object.create(null);const R=new RegExp(o,b),y=Object.create(null);for(let P=h.startLineNumber;P<h.endLineNumber;P++){const T=A.getLineWords(P,R);for(const I of T){if(!isNaN(Number(I.word)))continue;let Q=y[I.word];Q||(Q=[],y[I.word]=Q),Q.push({startLineNumber:P,startColumn:I.startColumn,endLineNumber:P,endColumn:I.endColumn})}}return y}async navigateValueSet(s,h,o,b,A){const R=this.j(s);if(!R)return null;const y=new RegExp(b,A);h.startColumn===h.endColumn&&(h={startLineNumber:h.startLineNumber,startColumn:h.startColumn,endLineNumber:h.endLineNumber,endColumn:h.endColumn+1});const P=R.getValueInRange(h),T=R.getWordAtPosition({lineNumber:h.startLineNumber,column:h.startColumn},y);if(!T)return null;const I=R.getValueInRange(T);return u.$o3.INSTANCE.navigateValueSet(h,P,T,I,o)}loadForeignModule(s,h,o){const b=(y,P)=>this.d.fhr(y,P),R={host:(0,L.$bo)(o,b),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(R,h),Promise.resolve((0,L.$ao)(this.h))):new Promise((y,P)=>{V([s],T=>{this.h=T.create(R,h),y((0,L.$ao)(this.h))},P)})}fmr(s,h){if(!this.h||typeof this.h[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this.h[s].apply(this.h,h))}catch(o){return Promise.reject(o)}}}t.EditorSimpleWorker=j;function l(n){return new j(n,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,f.$q3)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/17235b28ebca8f946926ec11374b67cd53c0619d/core/vs/base/worker/workerMain.js.map
