/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],oe=function(J){for(var e=[],n=0,C=J.length;n<C;n++)e[n]=re[J[n]];return e};define(re[136],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=C,e.$hb=S,e.$ib=R,e.$jb=j,e.$kb=E,e.$lb=h,e.$nb=d,e.$ob=b,e.$pb=v,e.$qb=m,e.$rb=f;function n(y,p){const g=C(y,p);if(g!==-1)return y[g]}function C(y,p,g=y.length-1){for(let l=g;l>=0;l--){const w=y[l];if(p(w))return l}return-1}function S(y,p){const g=R(y,p);return g===-1?void 0:y[g]}function R(y,p,g=0,l=y.length){let w=g,k=l;for(;w<k;){const a=Math.floor((w+k)/2);p(y[a])?w=a+1:k=a}return w-1}function j(y,p){const g=E(y,p);return g===y.length?void 0:y[g]}function E(y,p,g=0,l=y.length){let w=g,k=l;for(;w<k;){const a=Math.floor((w+k)/2);p(y[a])?k=a:w=a+1}return w}function h(y,p,g=0,l=y.length){const w=E(y,p,g,l);return w===y.length?-1:w}class c{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(c.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!p(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const g=R(this.e,p,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$mb=c;function d(y,p){if(y.length===0)return;let g=y[0];for(let l=1;l<y.length;l++){const w=y[l];p(w,g)>0&&(g=w)}return g}function b(y,p){if(y.length===0)return;let g=y[0];for(let l=1;l<y.length;l++){const w=y[l];p(w,g)>=0&&(g=w)}return g}function v(y,p){return d(y,(g,l)=>-p(g,l))}function m(y,p){if(y.length===0)return-1;let g=0;for(let l=1;l<y.length;l++){const w=y[l];p(w,y[g])>0&&(g=l)}return g}function f(y,p){for(const g of y){const l=p(g);if(l!==void 0)return l}}}),define(re[137],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=n,e.$L=C,e.$M=S,e.$N=R;function n(j,E){const h=Object.create(null);for(const c of j){const d=E(c);let b=h[d];b||(b=h[d]=[]),b.push(c)}return h}function C(j,E){const h=[],c=[];for(const d of j)E.has(d)||h.push(d);for(const d of E)j.has(d)||c.push(d);return{removed:h,added:c}}function S(j,E){const h=[],c=[];for(const[d,b]of j)E.has(d)||h.push(b);for(const[d,b]of E)j.has(d)||c.push(b);return{removed:h,added:c}}function R(j,E){const h=new Set;for(const c of E)j.has(c)&&h.add(c);return h}}),define(re[138],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=e.$Ot=e.$Nt=e.$Mt=void 0;function n(E,h){const c=Math.pow(10,h);return Math.round(E*c)/c}class C{constructor(h,c,d,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=n(Math.max(Math.min(1,b),0),3)}static equals(h,c){return h.r===c.r&&h.g===c.g&&h.b===c.b&&h.a===c.a}}e.$Mt=C;class S{constructor(h,c,d,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,d),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.l===c.l&&h.a===c.a}static fromRGBA(h){const c=h.r/255,d=h.g/255,b=h.b/255,v=h.a,m=Math.max(c,d,b),f=Math.min(c,d,b);let y=0,p=0;const g=(f+m)/2,l=m-f;if(l>0){switch(p=Math.min(g<=.5?l/(2*g):l/(2-2*g),1),m){case c:y=(d-b)/l+(d<b?6:0);break;case d:y=(b-c)/l+2;break;case b:y=(c-d)/l+4;break}y*=60,y=Math.round(y)}return new S(y,p,g,v)}static i(h,c,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?h+(c-h)*6*d:d<1/2?c:d<2/3?h+(c-h)*(2/3-d)*6:h}static toRGBA(h){const c=h.h/360,{s:d,l:b,a:v}=h;let m,f,y;if(d===0)m=f=y=b;else{const p=b<.5?b*(1+d):b+d-b*d,g=2*b-p;m=S.i(g,p,c+1/3),f=S.i(g,p,c),y=S.i(g,p,c-1/3)}return new C(Math.round(m*255),Math.round(f*255),Math.round(y*255),v)}}e.$Nt=S;class R{constructor(h,c,d,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,d),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.v===c.v&&h.a===c.a}static fromRGBA(h){const c=h.r/255,d=h.g/255,b=h.b/255,v=Math.max(c,d,b),m=Math.min(c,d,b),f=v-m,y=v===0?0:f/v;let p;return f===0?p=0:v===c?p=((d-b)/f%6+6)%6:v===d?p=(b-c)/f+2:p=(c-d)/f+4,new R(Math.round(p*60),y,v,h.a)}static toRGBA(h){const{h:c,s:d,v:b,a:v}=h,m=b*d,f=m*(1-Math.abs(c/60%2-1)),y=b-m;let[p,g,l]=[0,0,0];return c<60?(p=m,g=f):c<120?(p=f,g=m):c<180?(g=m,l=f):c<240?(g=f,l=m):c<300?(p=f,l=m):c<=360&&(p=m,l=f),p=Math.round((p+y)*255),g=Math.round((g+y)*255),l=Math.round((l+y)*255),new C(p,g,l,v)}}e.$Ot=R;class j{static fromHex(h){return j.Format.CSS.parseHex(h)||j.red}static equals(h,c){return!h&&!c?!0:!h||!c?!1:h.equals(c)}get hsla(){return this.i?this.i:S.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof C)this.rgba=h;else if(h instanceof S)this.i=h,this.rgba=S.toRGBA(h);else if(h instanceof R)this.j=h,this.rgba=R.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&C.equals(this.rgba,h.rgba)&&S.equals(this.hsla,h.hsla)&&R.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=j.k(this.rgba.r),c=j.k(this.rgba.g),d=j.k(this.rgba.b),b=.2126*h+.7152*c+.0722*d;return n(b,4)}static k(h){const c=h/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(h){const c=this.getRelativeLuminance(),d=h.getRelativeLuminance();return c>d?(c+.05)/(d+.05):(d+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const c=this.getRelativeLuminance(),d=h.getRelativeLuminance();return c>d}isDarkerThan(h){const c=this.getRelativeLuminance(),d=h.getRelativeLuminance();return c<d}lighten(h){return new j(new S(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new j(new S(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:c,g:d,b,a:v}=this.rgba;return new j(new C(c,d,b,v*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new j(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const c=h.rgba,d=this.rgba.a,b=c.a,v=d+b*(1-d);if(v<1e-6)return j.transparent;const m=this.rgba.r*d/v+c.r*b*(1-d)/v,f=this.rgba.g*d/v+c.g*b*(1-d)/v,y=this.rgba.b*d/v+c.b*b*(1-d)/v;return new j(new C(m,f,y,v))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:c,g:d,b,a:v}=this.rgba;return new j(new C(h.rgba.r-v*(h.rgba.r-c),h.rgba.g-v*(h.rgba.g-d),h.rgba.b-v*(h.rgba.b-b),1))}flatten(...h){const c=h.reduceRight((d,b)=>j.o(b,d));return j.o(this,c)}static o(h,c){const d=1-h.rgba.a;return new j(new C(d*c.rgba.r+h.rgba.a*h.rgba.r,d*c.rgba.g+h.rgba.a*h.rgba.g,d*c.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=j.Format.CSS.format(this)),this.u}static getLighterColor(h,c,d){if(h.isLighterThan(c))return h;d=d||.5;const b=h.getRelativeLuminance(),v=c.getRelativeLuminance();return d=d*(v-b)/v,h.lighten(d)}static getDarkerColor(h,c,d){if(h.isDarkerThan(c))return h;d=d||.5;const b=h.getRelativeLuminance(),v=c.getRelativeLuminance();return d=d*(b-v)/b,h.darken(d)}static{this.white=new j(new C(255,255,255,1))}static{this.black=new j(new C(0,0,0,1))}static{this.red=new j(new C(255,0,0,1))}static{this.blue=new j(new C(0,0,255,1))}static{this.green=new j(new C(0,255,0,1))}static{this.cyan=new j(new C(0,255,255,1))}static{this.lightgrey=new j(new C(211,211,211,1))}static{this.transparent=new j(new C(0,0,0,0))}}e.$Pt=j,function(E){let h;(function(c){let d;(function(b){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}b.formatRGB=v;function m(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}b.formatRGBA=m;function f(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}b.formatHSL=f;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}b.formatHSLA=y;function p(t){const r=t.toString(16);return r.length!==2?"0"+r:r}function g(t){return`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}`}b.formatHex=g;function l(t,r=!1){return r&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}${p(Math.round(t.rgba.a*255))}`}b.formatHexA=l;function w(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}b.format=w;function k(t){const r=t.length;if(r===0||t.charCodeAt(0)!==35)return null;if(r===7){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new E(new C(s,i,o,1))}if(r===9){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),u=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new E(new C(s,i,o,u/255))}if(r===4){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3));return new E(new C(16*s+s,16*i+i,16*o+o))}if(r===5){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3)),u=a(t.charCodeAt(4));return new E(new C(16*s+s,16*i+i,16*o+o,(16*u+u)/255))}return null}b.parseHex=k;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=c.CSS||(c.CSS={}))})(h=E.Format||(E.Format={}))}(j||(e.$Pt=j={}))}),define(re[51],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=C,e.$2h=S,e.$3h=R;function n(j){return(E,h,c)=>{let d=null,b=null;if(typeof c.value=="function"?(d="value",b=c.value):typeof c.get=="function"&&(d="get",b=c.get),!b)throw new Error("not supported");c[d]=j(b,h)}}function C(j,E,h){let c=null,d=null;if(typeof h.value=="function"?(c="value",d=h.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",d=h.get),!d)throw new Error("not supported");const b=`$memoize$${E}`;h[c]=function(...v){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,v)}),this[b]}}function S(j,E,h){return n((c,d)=>{const b=`$debounce$${d}`,v=`$debounce$result$${d}`;return function(...m){this[v]||(this[v]=h?h():void 0),clearTimeout(this[b]),E&&(this[v]=E(this[v],...m),m=[this[v]]),this[b]=setTimeout(()=>{c.apply(this,m),this[v]=h?h():void 0},j)}})}function R(j,E,h){return n((c,d)=>{const b=`$throttle$timer$${d}`,v=`$throttle$result$${d}`,m=`$throttle$lastRun$${d}`,f=`$throttle$pending$${d}`;return function(...y){if(this[v]||(this[v]=h?h():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),E&&(this[v]=E(this[v],...y)),this[f])return;const p=this[m]+j;p<=Date.now()?(this[m]=Date.now(),c.apply(this,[this[v]]),this[v]=h?h():void 0):(this[f]=!0,this[b]=setTimeout(()=>{this[f]=!1,this[m]=Date.now(),c.apply(this,[this[v]]),this[v]=h?h():void 0},p-Date.now()))}})}}),define(re[15],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=C,e.$Z=S,e.$1=R,e.$2=j,e.$3=E,e.$4=c,e.$6=b,e.$7=v,e.$8=m,e.$0=y;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?w.isErrorNoTelemetry(t)?new w(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function C(a){e.$X.setUnexpectedErrorHandler(a)}function S(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(a){c(a)||e.$X.onUnexpectedError(a)}function j(a){c(a)||e.$X.onUnexpectedExternalError(a)}function E(a){if(a instanceof Error){const{name:t,message:r}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:s,noTelemetry:w.isErrorNoTelemetry(a)}}return a}const h="Canceled";function c(a){return a instanceof d?!0:a instanceof Error&&a.name===h&&a.message===h}class d extends Error{constructor(){super(h),this.name=this.message}}e.$5=d;function b(){const a=new Error(h);return a.name=a.message,a}function v(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function m(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class f extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=f;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class p extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=p;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=g;class l extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=l;class w extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof w)return t;const r=new w;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=w;class k extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.$cb=k}),define(re[22],oe([0,1,15,136]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=S,e.$tb=R,e.$ub=j,e.$vb=E,e.$wb=h,e.$xb=c,e.$yb=d,e.$zb=b,e.$Ab=v,e.$Bb=m,e.$Cb=f,e.$Db=y,e.$Eb=p,e.top=g,e.$Gb=l,e.$Hb=k,e.$Ib=a,e.$Jb=t,e.$Kb=r,e.$Lb=s,e.$Mb=i,e.$Nb=o,e.$Ob=u,e.$Pb=$,e.$Qb=P,e.$Rb=D,e.$Sb=I,e.$Tb=O,e.$Ub=M,e.$Vb=W,e.$Wb=F,e.$Xb=T,e.$Yb=q,e.$Zb=ue,e.$1b=ee,e.$2b=ce,e.$3b=K,e.$4b=G,e.$5b=B,e.$6b=L,e.$7b=ae,e.$8b=x,e.$$b=A;function S(X,H=0){return X[X.length-(1+H)]}function R(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}function j(X,H,V=(U,se)=>U===se){if(X===H)return!0;if(!X||!H||X.length!==H.length)return!1;for(let U=0,se=X.length;U<se;U++)if(!V(X[U],H[U]))return!1;return!0}function E(X,H){const V=X.length-1;H<V&&(X[H]=X[V]),X.pop()}function h(X,H,V){return c(X.length,U=>V(X[U],H))}function c(X,H){let V=0,U=X-1;for(;V<=U;){const se=(V+U)/2|0,he=H(se);if(he<0)V=se+1;else if(he>0)U=se-1;else return se}return-(V+1)}function d(X,H,V){if(X=X|0,X>=H.length)throw new TypeError("invalid index");const U=H[Math.floor(H.length*Math.random())],se=[],he=[],$e=[];for(const me of H){const ye=V(me,U);ye<0?se.push(me):ye>0?he.push(me):$e.push(me)}return X<se.length?d(X,se,V):X<se.length+$e.length?$e[0]:d(X-(se.length+$e.length),he,V)}function b(X,H){const V=[];let U;for(const se of X.slice(0).sort(H))!U||H(U[0],se)!==0?(U=[se],V.push(U)):U.push(se);return V}function*v(X,H){let V,U;for(const se of X)U!==void 0&&H(U,se)?V.push(se):(V&&(yield V),V=[se]),U=se;V&&(yield V)}function m(X,H){for(let V=0;V<=X.length;V++)H(V===0?void 0:X[V-1],V===X.length?void 0:X[V])}function f(X,H){for(let V=0;V<X.length;V++)H(V===0?void 0:X[V-1],X[V],V+1===X.length?void 0:X[V+1])}function y(X,H,V){const U=[];function se(me,ye,ke){if(ye===0&&ke.length===0)return;const Ee=U[U.length-1];Ee&&Ee.start+Ee.deleteCount===me?(Ee.deleteCount+=ye,Ee.toInsert.push(...ke)):U.push({start:me,deleteCount:ye,toInsert:ke})}let he=0,$e=0;for(;;){if(he===X.length){se(he,0,H.slice($e));break}if($e===H.length){se(he,X.length-he,[]);break}const me=X[he],ye=H[$e],ke=V(me,ye);ke===0?(he+=1,$e+=1):ke<0?(se(he,1,[]),he+=1):ke>0&&(se(he,0,[ye]),$e+=1)}return U}function p(X,H,V){const U=y(X,H,V),se=[],he=[];for(const $e of U)se.push(...X.slice($e.start,$e.start+$e.deleteCount)),he.push(...$e.toInsert);return{removed:se,added:he}}function g(X,H,V){if(V===0)return[];const U=X.slice(0,V).sort(H);return w(X,H,U,V,X.length),U}function l(X,H,V,U,se){return V===0?Promise.resolve([]):new Promise((he,$e)=>{(async()=>{const me=X.length,ye=X.slice(0,V).sort(H);for(let ke=V,Ee=Math.min(V+U,me);ke<me;ke=Ee,Ee=Math.min(Ee+U,me)){if(ke>V&&await new Promise(Oe=>setTimeout(Oe)),se&&se.isCancellationRequested)throw new n.$5;w(X,H,ye,ke,Ee)}return ye})().then(he,$e)})}function w(X,H,V,U,se){for(const he=V.length;U<se;U++){const $e=X[U];if(H($e,V[he-1])<0){V.pop();const me=(0,C.$kb)(V,ye=>H($e,ye)<0);V.splice(me,0,$e)}}}function k(X){return X.filter(H=>!!H)}function a(X){let H=0;for(let V=0;V<X.length;V++)X[V]&&(X[H]=X[V],H+=1);X.length=H}function t(X,H,V){X.splice(V,0,X.splice(H,1)[0])}function r(X){return!Array.isArray(X)||X.length===0}function s(X){return Array.isArray(X)&&X.length>0}function i(X,H=V=>V){const V=new Set;return X.filter(U=>{const se=H(U);return V.has(se)?!1:(V.add(se),!0)})}function o(X){const H=new Set;return V=>{const U=X(V);return H.has(U)?!1:(H.add(U),!0)}}function u(X,H){return X.length>0?X[0]:H}function $(X,H){return X.length>0?X[X.length-1]:H}function P(X,H,V=(U,se)=>U===se){let U=0;for(let se=0,he=Math.min(X.length,H.length);se<he&&V(X[se],H[se]);se++)U++;return U}function D(X){return[].concat(...X)}function I(X,H){let V=typeof H=="number"?X:0;typeof H=="number"?V=X:(V=0,H=X);const U=[];if(V<=H)for(let se=V;se<H;se++)U.push(se);else for(let se=V;se>H;se--)U.push(se);return U}function O(X,H,V){return X.reduce((U,se)=>(U[H(se)]=V?V(se):se,U),Object.create(null))}function M(X,H){return X.push(H),()=>W(X,H)}function W(X,H){const V=X.indexOf(H);if(V>-1)return X.splice(V,1),H}function F(X,H,V){const U=X.slice(0,H),se=X.slice(H);return U.concat(V,se)}function T(X,H){let V;if(typeof H=="number"){let U=H;V=()=>{const se=Math.sin(U++)*179426549;return se-Math.floor(se)}}else V=Math.random;for(let U=X.length-1;U>0;U-=1){const se=Math.floor(V()*(U+1)),he=X[U];X[U]=X[se],X[se]=he}}function q(X,H){const V=X.indexOf(H);V>-1&&(X.splice(V,1),X.unshift(H))}function ue(X,H){const V=X.indexOf(H);V>-1&&(X.splice(V,1),X.push(H))}function ee(X,H){for(const V of H)X.push(V)}function ce(X,H){return Array.isArray(X)?X.map(H):H(X)}function K(X){return Array.isArray(X)?X:[X]}function G(X){return X[Math.floor(Math.random()*X.length)]}function B(X,H,V){const U=z(X,H),se=X.length,he=V.length;X.length=se+he;for(let $e=se-1;$e>=U;$e--)X[$e+he]=X[$e];for(let $e=0;$e<he;$e++)X[$e+U]=V[$e]}function L(X,H,V,U){const se=z(X,H);let he=X.splice(se,V);return he===void 0&&(he=[]),B(X,se,U),he}function z(X,H){return H<0?Math.max(H+X.length,0):Math.min(H,X.length)}var Q;(function(X){function H(he){return he<0}X.isLessThan=H;function V(he){return he<=0}X.isLessThanOrEqual=V;function U(he){return he>0}X.isGreaterThan=U;function se(he){return he===0}X.isNeitherLessOrGreaterThan=se,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function ae(X,H){return(V,U)=>H(X(V),X(U))}function x(...X){return(H,V)=>{for(const U of X){const se=U(H,V);if(!Q.isNeitherLessOrGreaterThan(se))return se}return Q.neitherLessOrGreaterThan}}const le=(X,H)=>X-H;e.$9b=le;const Z=(X,H)=>(0,e.$9b)(X?1:0,H?1:0);e.$0b=Z;function A(X){return(H,V)=>-X(H,V)}class N{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let V=this.c;for(;V<this.g.length&&H(this.g[V]);)V++;const U=V===this.c?null:this.g.slice(this.c,V);return this.c=V,U}takeFromEndWhile(H){let V=this.d;for(;V>=0&&H(this.g[V]);)V--;const U=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,U}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const V=this.g.slice(this.c,this.c+H);return this.c+=H,V}}e.$_b=N;class _{static{this.empty=new _(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(V=>(H(V),!0))}toArray(){const H=[];return this.iterate(V=>(H.push(V),!0)),H}filter(H){return new _(V=>this.iterate(U=>H(U)?V(U):!0))}map(H){return new _(V=>this.iterate(U=>V(H(U))))}some(H){let V=!1;return this.iterate(U=>(V=H(U),!V)),V}findFirst(H){let V;return this.iterate(U=>H(U)?(V=U,!1):!0),V}findLast(H){let V;return this.iterate(U=>(H(U)&&(V=U),!0)),V}findLastMaxBy(H){let V,U=!0;return this.iterate(se=>((U||Q.isGreaterThan(H(se,V)))&&(U=!1,V=se),!0)),V}}e.$ac=_;class ne{constructor(H){this.c=H}static createSortPermutation(H,V){const U=Array.from(H.keys()).sort((se,he)=>V(H[se],H[he]));return new ne(U)}apply(H){return H.map((V,U)=>H[this.c[U]])}inverse(){const H=this.c.slice();for(let V=0;V<this.c.length;V++)H[this.c[V]]=V;return new ne(H)}}e.$bc=ne}),define(re[139],oe([0,1,15]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=C,e.$fd=S,e.$gd=R,e.$hd=j,e.$id=E,e.$jd=h;function C(c,d){if(!c)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}function S(c,d="Unreachable"){throw new Error(d)}function R(c){if(!c)throw new n.$cb("Assertion Failed")}function j(c){c||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function E(c){if(!c()){debugger;c(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function h(c,d){let b=0;for(;b<c.length-1;){const v=c[b],m=c[b+1];if(!d(v,m))return!1;b++}return!0}}),define(re[86],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(C,S){const R=this;let j=!1,E;return function(){if(j)return E;if(j=!0,S)try{E=C.apply(R,arguments)}finally{S()}else E=C.apply(R,arguments);return E}}}),define(re[71],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(C){function S(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}C.is=S;const R=Object.freeze([]);function j(){return R}C.empty=j;function*E(t){yield t}C.single=E;function h(t){return S(t)?t:E(t)}C.wrap=h;function c(t){return t||R}C.from=c;function*d(t){for(let r=t.length-1;r>=0;r--)yield t[r]}C.reverse=d;function b(t){return!t||t[Symbol.iterator]().next().done===!0}C.isEmpty=b;function v(t){return t[Symbol.iterator]().next().value}C.first=v;function m(t,r){for(const s of t)if(r(s))return!0;return!1}C.some=m;function f(t,r){for(const s of t)if(r(s))return s}C.find=f;function*y(t,r){for(const s of t)r(s)&&(yield s)}C.filter=y;function*p(t,r){let s=0;for(const i of t)yield r(i,s++)}C.map=p;function*g(...t){for(const r of t)yield*r}C.concat=g;function l(t,r,s){let i=s;for(const o of t)i=r(i,o);return i}C.reduce=l;function*w(t,r,s=t.length){for(r<0&&(r+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);r<s;r++)yield t[r]}C.slice=w;function k(t,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,t];const i=t[Symbol.iterator]();for(let o=0;o<r;o++){const u=i.next();if(u.done)return[s,C.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return i}}]}C.consume=k;async function a(t){const r=[];for await(const s of t)r.push(s);return Promise.resolve(r)}C.asyncToArray=a})(n||(e.Iterable=n={}))}),define(re[42],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=j,e.$In=b,e.$Jn=v,e.$Kn=m,e.$Ln=f,e.$Mn=y,e.$Nn=p,e.$On=g,e.$Pn=l,e.$Qn=w,e.$Rn=k,e.$Sn=a;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function j(t,r=!1){let s=0;const i=t.length;let o="",u=0,$=16,P=0;function D(q){let ue=0,ee=0;for(;ue<q;){const ce=t.charCodeAt(s);if(ce>=48&&ce<=57)ee=ee*16+ce-48;else if(ce>=65&&ce<=70)ee=ee*16+ce-65+10;else if(ce>=97&&ce<=102)ee=ee*16+ce-97+10;else break;s++,ue++}return ue<q&&(ee=-1),ee}function I(q){s=q,o="",u=0,$=16,P=0}function O(){const q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&c(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&c(t.charCodeAt(s)))for(s++;s<t.length&&c(t.charCodeAt(s));)s++;else return P=3,t.substring(q,s);let ue=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&c(t.charCodeAt(s))){for(s++;s<t.length&&c(t.charCodeAt(s));)s++;ue=s}else P=3;return t.substring(q,ue)}function M(){let q="",ue=s;for(;;){if(s>=i){q+=t.substring(ue,s),P=2;break}const ee=t.charCodeAt(s);if(ee===34){q+=t.substring(ue,s),s++;break}if(ee===92){if(q+=t.substring(ue,s),s++,s>=i){P=2;break}switch(t.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const K=D(4);K>=0?q+=String.fromCharCode(K):P=4;break}default:P=5}ue=s;continue}if(ee>=0&&ee<=31)if(h(ee)){q+=t.substring(ue,s),P=2;break}else P=6;s++}return q}function W(){if(o="",P=0,u=s,s>=i)return u=i,$=17;let q=t.charCodeAt(s);if(E(q)){do s++,o+=String.fromCharCode(q),q=t.charCodeAt(s);while(E(q));return $=15}if(h(q))return s++,o+=String.fromCharCode(q),q===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),$=14;switch(q){case 123:return s++,$=1;case 125:return s++,$=2;case 91:return s++,$=3;case 93:return s++,$=4;case 58:return s++,$=6;case 44:return s++,$=5;case 34:return s++,o=M(),$=10;case 47:{const ue=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!h(t.charCodeAt(s));)s++;return o=t.substring(ue,s),$=12}if(t.charCodeAt(s+1)===42){s+=2;const ee=i-1;let ce=!1;for(;s<ee;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ce=!0;break}s++}return ce||(s++,P=1),o=t.substring(ue,s),$=13}return o+=String.fromCharCode(q),s++,$=16}case 45:if(o+=String.fromCharCode(q),s++,s===i||!c(t.charCodeAt(s)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),$=11;default:for(;s<i&&F(q);)s++,q=t.charCodeAt(s);if(u!==s){switch(o=t.substring(u,s),o){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return o+=String.fromCharCode(q),s++,$=16}}function F(q){if(E(q)||h(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let q;do q=W();while(q>=12&&q<=15);return q}return{setPosition:I,getPosition:()=>s,scan:r?T:W,getToken:()=>$,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>P}}function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var d;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(d||(d={}));function b(t,r){const s=[],i=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function P(D,I,O,M){u.value=D,u.offset=I,u.length=O,u.type=M,u.colonOffset=void 0,o=u}try{w(t,{onObjectBegin:(D,I)=>{if(r<=D)throw i;o=void 0,$=r>D,s.push("")},onObjectProperty:(D,I,O)=>{if(r<I||(P(D,I,O,"property"),s[s.length-1]=D,r<=I+O))throw i},onObjectEnd:(D,I)=>{if(r<=D)throw i;o=void 0,s.pop()},onArrayBegin:(D,I)=>{if(r<=D)throw i;o=void 0,s.push(0)},onArrayEnd:(D,I)=>{if(r<=D)throw i;o=void 0,s.pop()},onLiteralValue:(D,I,O)=>{if(r<I||(P(D,I,O,a(D)),r<=I+O))throw i},onSeparator:(D,I,O)=>{if(r<=I)throw i;if(D===":"&&o&&o.type==="property")o.colonOffset=I,$=!1,o=void 0;else if(D===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:($=!0,s[s.length-1]=""),o=void 0}}})}catch(D){if(D!==i)throw D}return{path:s,previousNode:o,isAtPropertyKey:$,matches:D=>{let I=0;for(let O=0;I<D.length&&O<s.length;O++)if(D[I]===s[O]||D[I]==="*")I++;else if(D[I]!=="**")return!1;return I===D.length}}}function v(t,r=[],s=R.DEFAULT){let i=null,o=[];const u=[];function $(D){Array.isArray(o)?o.push(D):i!==null&&(o[i]=D)}return w(t,{onObjectBegin:()=>{const D={};$(D),u.push(o),o=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const D=[];$(D),u.push(o),o=D,i=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:$,onError:(D,I,O)=>{r.push({error:D,offset:I,length:O})}},s),o[0]}function m(t,r=[],s=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function u(D){return i.children.push(D),D}w(t,{onObjectBegin:D=>{i=u({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,I,O)=>{i=u({type:"property",offset:I,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:I,length:O,parent:i})},onObjectEnd:(D,I)=>{i.length=D+I-i.offset,i=i.parent,o(D+I)},onArrayBegin:(D,I)=>{i=u({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,I)=>{i.length=D+I-i.offset,i=i.parent,o(D+I)},onLiteralValue:(D,I,O)=>{u({type:a(D),offset:I,length:O,parent:i,value:D}),o(I+O)},onSeparator:(D,I,O)=>{i.type==="property"&&(D===":"?i.colonOffset=I:D===","&&o(I))},onError:(D,I,O)=>{r.push({error:D,offset:I,length:O})}},s);const P=i.children[0];return P&&delete P.parent,P}function f(t,r){if(!t)return;let s=t;for(const i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===i){s=u.children[1],o=!0;break}if(!o)return}else{const o=i;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}function y(t){if(!t.parent||!t.parent.children)return[];const r=y(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const r=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=p(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function g(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}function l(t,r,s=!1){if(g(t,r,s)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=r;o++){const u=l(i[o],r,s);if(u)return u}return t}}function w(t,r,s=R.DEFAULT){const i=j(t,!1);function o(ae){return ae?()=>ae(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(ae){return ae?x=>ae(x,i.getTokenOffset(),i.getTokenLength()):()=>!0}const $=o(r.onObjectBegin),P=u(r.onObjectProperty),D=o(r.onObjectEnd),I=o(r.onArrayBegin),O=o(r.onArrayEnd),M=u(r.onLiteralValue),W=u(r.onSeparator),F=o(r.onComment),T=u(r.onError),q=s&&s.disallowComments,ue=s&&s.allowTrailingComma;function ee(){for(;;){const ae=i.scan();switch(i.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:q||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(ae){case 12:case 13:q?ce(10):F();break;case 16:ce(1);break;case 15:case 14:break;default:return ae}}}function ce(ae,x=[],le=[]){if(T(ae),x.length+le.length>0){let Z=i.getToken();for(;Z!==17;){if(x.indexOf(Z)!==-1){ee();break}else if(le.indexOf(Z)!==-1)break;Z=ee()}}}function K(ae){const x=i.getTokenValue();return ae?M(x):P(x),ee(),!0}function G(){switch(i.getToken()){case 11:{let ae=0;try{ae=JSON.parse(i.getTokenValue()),typeof ae!="number"&&(ce(2),ae=0)}catch{ce(2)}M(ae);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return ee(),!0}function B(){return i.getToken()!==10?(ce(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(W(":"),ee(),Q()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function L(){$(),ee();let ae=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ae||ce(4,[],[]),W(","),ee(),i.getToken()===2&&ue)break}else ae&&ce(6,[],[]);B()||ce(4,[],[2,5]),ae=!0}return D(),i.getToken()!==2?ce(7,[2],[]):ee(),!0}function z(){I(),ee();let ae=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ae||ce(4,[],[]),W(","),ee(),i.getToken()===4&&ue)break}else ae&&ce(6,[],[]);Q()||ce(4,[],[4,5]),ae=!0}return O(),i.getToken()!==4?ce(8,[4],[]):ee(),!0}function Q(){switch(i.getToken()){case 3:return z();case 1:return L();case 10:return K(!0);default:return G()}}return ee(),i.getToken()===17?s.allowEmptyContent?!0:(ce(4,[],[]),!1):Q()?(i.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function k(t,r){const s=j(t),i=[];let o,u=0,$;do switch($=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:u!==$&&i.push(t.substring(u,$)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),u=s.getPosition();break}while(o!==17);return i.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(re[140],oe([0,1,42]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=C,e.$Un=S,e.$Vn=E,e.$Wn=h;function C(c,d,b){let v,m,f,y,p;if(d){for(y=d.offset,p=y+d.length,f=y;f>0&&!h(c,f-1);)f--;let $=p;for(;$<c.length&&!h(c,$);)$++;m=c.substring(f,$),v=j(m,b)}else m=c,v=0,f=0,y=0,p=c.length;const g=E(b,c);let l=!1,w=0,k;b.insertSpaces?k=R(" ",b.tabSize||4):k="	";const a=(0,n.$Hn)(m,!1);let t=!1;function r(){return g+R(k,v+w)}function s(){let $=a.scan();for(l=!1;$===15||$===14;)l=l||$===14,$=a.scan();return t=$===16||a.getTokenError()!==0,$}const i=[];function o($,P,D){!t&&P<p&&D>y&&c.substring(P,D)!==$&&i.push({offset:P,length:D-P,content:$})}let u=s();if(u!==17){const $=a.getTokenOffset()+f,P=R(k,v);o(P,f,$)}for(;u!==17;){let $=a.getTokenOffset()+a.getTokenLength()+f,P=s(),D="";for(;!l&&(P===12||P===13);){const O=a.getTokenOffset()+f;o(" ",$,O),$=a.getTokenOffset()+a.getTokenLength()+f,D=P===12?r():"",P=s()}if(P===2)u!==1&&(w--,D=r());else if(P===4)u!==3&&(w--,D=r());else{switch(u){case 3:case 1:w++,D=r();break;case 5:case 12:D=r();break;case 13:l?D=r():D=" ";break;case 6:D=" ";break;case 10:if(P===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?D=" ":P!==5&&P!==17&&(t=!0);break;case 16:t=!0;break}l&&(P===12||P===13)&&(D=r())}const I=a.getTokenOffset()+f;o(D,$,I),u=P}return i}function S(c,d){const b=JSON.stringify(c,void 0,d.insertSpaces?d.tabSize||4:"	");return d.eol!==void 0?b.replace(/\r\n|\r|\n/g,d.eol):b}function R(c,d){let b="";for(let v=0;v<d;v++)b+=c;return b}function j(c,d){let b=0,v=0;const m=d.tabSize||4;for(;b<c.length;){const f=c.charAt(b);if(f===" ")v++;else if(f==="	")v+=m;else break;b++}return Math.floor(v/m)}function E(c,d){for(let b=0;b<d.length;b++){const v=d.charAt(b);if(v==="\r")return b+1<d.length&&d.charAt(b+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return c&&c.eol||`
`}function h(c,d){return`\r
`.indexOf(c.charAt(d))!==-1}}),define(re[103],oe([0,1,42,140]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=S,e.$Yn=R,e.$Zn=j,e.$1n=E,e.$2n=h;function S(c,d,b){return R(c,d,void 0,b)}function R(c,d,b,v,m){const f=d.slice(),y=[],p=(0,n.$Kn)(c,y);let g,l;for(;f.length>0&&(l=f.pop(),g=(0,n.$Ln)(p,f),g===void 0&&b!==void 0);)typeof l=="string"?b={[l]:b}:b=[b];if(g)if(g.type==="object"&&typeof l=="string"&&Array.isArray(g.children)){const w=(0,n.$Ln)(g,[l]);if(w!==void 0)if(b===void 0){if(!w.parent)throw new Error("Malformed AST");const k=g.children.indexOf(w.parent);let a,t=w.parent.offset+w.parent.length;if(k>0){const r=g.children[k-1];a=r.offset+r.length}else a=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return j(c,{offset:a,length:t-a,content:""},v)}else return j(c,{offset:w.offset,length:w.length,content:JSON.stringify(b)},v);else{if(b===void 0)return[];const k=`${JSON.stringify(l)}: ${JSON.stringify(b)}`,a=m?m(g.children.map(r=>r.children[0].value)):g.children.length;let t;if(a>0){const r=g.children[a-1];t={offset:r.offset+r.length,length:0,content:","+k}}else g.children.length===0?t={offset:g.offset+1,length:0,content:k}:t={offset:g.offset+1,length:0,content:k+","};return j(c,t,v)}}else if(g.type==="array"&&typeof l=="number"&&Array.isArray(g.children))if(b!==void 0){const w=`${JSON.stringify(b)}`;let k;if(g.children.length===0||l===0)k={offset:g.offset+1,length:0,content:g.children.length===0?w:w+","};else{const a=l===-1||l>g.children.length?g.children.length:l,t=g.children[a-1];k={offset:t.offset+t.length,length:0,content:","+w}}return j(c,k,v)}else{const w=l,k=g.children[w];let a;if(g.children.length===1)a={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===w){const t=g.children[w-1],r=t.offset+t.length,s=g.offset+g.length;a={offset:r,length:s-2-r,content:""}}else a={offset:k.offset,length:g.children[w+1].offset-k.offset,content:""};return j(c,a,v)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${g.type}`);else return b===void 0?[]:j(c,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(b)},v)}function j(c,d,b){let v=E(c,d),m=d.offset,f=d.offset+d.content.length;if(d.length===0||d.content.length===0){for(;m>0&&!(0,C.$Wn)(v,m-1);)m--;for(;f<v.length&&!(0,C.$Wn)(v,f);)f++}const y=(0,C.$Tn)(v,{offset:m,length:f-m},b);for(let g=y.length-1;g>=0;g--){const l=y[g];v=E(v,l),m=Math.min(m,l.offset),f=Math.max(f,l.offset+l.length),f+=l.content.length-l.length}const p=c.length-(v.length-f)-m;return[{offset:m,length:p,content:v.substring(m,f)}]}function E(c,d){return c.substring(0,d.offset)+d.content+c.substring(d.offset+d.length)}function h(c,d){const b=d.slice(0).sort((m,f)=>{const y=m.offset-f.offset;return y===0?m.length-f.length:y});let v=c.length;for(let m=b.length-1;m>=0;m--){const f=b[m];if(f.offset+f.length<=v)c=E(c,f);else throw new Error("Overlapping edit");v=f.offset}return c}}),define(re[62],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(re[104],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(R){this.element=R,this.next=n.Undefined,this.prev=n.Undefined}}class C{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let R=this.a;for(;R!==n.Undefined;){const j=R.next;R.prev=n.Undefined,R.next=n.Undefined,R=j}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,j){const E=new n(R);if(this.a===n.Undefined)this.a=E,this.b=E;else if(j){const c=this.b;this.b=E,E.prev=c,c.next=E}else{const c=this.a;this.a=E,E.next=c,c.prev=E}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(E))}}shift(){if(this.a!==n.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==n.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==n.Undefined&&R.next!==n.Undefined){const j=R.prev;j.next=R.next,R.next.prev=j}else R.prev===n.Undefined&&R.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):R.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):R.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==n.Undefined;)yield R.element,R=R.next}}e.$6c=C}),define(re[32],oe([0,1]),function(J,e){"use strict";var n,C,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=j,e.$Ac=E,e.$Jc=k;function R(a,t,r){let s=a.get(t);return s===void 0&&(s=r,a.set(t,s)),s}function j(a){const t=[];return a.forEach((r,s)=>{t.push(`${s} => ${r}`)}),`Map(${a.size}) {${t.join(", ")}}`}function E(a){const t=[];return a.forEach(r=>{t.push(r)}),`Set(${a.size}) {${t.join(", ")}}`}class h{constructor(t,r){this.uri=t,this.value=r}}function c(a){return Array.isArray(a)}class d{static{this.c=t=>t.toString()}constructor(t,r){if(this[n]="ResourceMap",t instanceof d)this.d=new Map(t.d),this.e=r??d.c;else if(c(t)){this.d=new Map,this.e=r??d.c;for(const[s,i]of t)this.set(s,i)}else this.d=new Map,this.e=t??d.c}set(t,r){return this.d.set(this.e(t),new h(t,r)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[s,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=d;class b{constructor(t,r){this[C]="ResourceSet",!t||typeof t=="function"?this.c=new d(t):(this.c=new d(r),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,r){this.c.forEach((s,i)=>t.call(r,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=b;var v;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class m{constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,r=0){const s=this.c.get(t);if(s)return r!==0&&this.m(s,r),s.value}set(t,r,s=0){let i=this.c.get(t);if(i)i.value=r,s!==0&&this.m(i,s);else{switch(i={key:t,value:r,next:void 0,previous:void 0},s){case 0:this.k(i);break;case 1:this.j(i);break;case 2:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.c.get(t);if(r)return this.c.delete(t),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,r){const s=this.g;let i=this.d;for(;i;){if(r?t.bind(r)(i.value,i.key,this):t(i.value,i.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.key,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}values(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.value,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}entries(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:[s.key,s.value],done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.d,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.next,s--;this.d=r,this.f=s,r&&(r.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.e,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.previous,s--;this.e=r,this.f=s,r&&(r.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const r=t.next,s=t.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}t.next=void 0,t.previous=void 0,this.g++}m(t,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.d)return;const s=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(s.previous=i,i.next=s),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(r===2){if(t===this.e)return;const s=t.next,i=t.previous;t===this.d?(s.previous=void 0,this.d=s):(s.previous=i,i.next=s),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((r,s)=>{t.push([s,r])}),t}fromJSON(t){this.clear();for(const[r,s]of t)this.set(r,s)}}e.$Dc=m;class f extends m{constructor(t,r=1){super(),this.n=t,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class y extends f{constructor(t,r=1){super(t,r)}q(t){this.h(t)}set(t,r){return super.set(t,r),this.p(),this}}e.$Ec=y;class p extends f{constructor(t,r=1){super(t,r)}q(t){this.i(t)}set(t,r){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,r),this}}e.$Fc=p;class g{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let r=this.c.get(t)||0;return r===0?!1:(r--,r===0?this.c.delete(t):this.c.set(t,r),!0)}has(t){return this.c.has(t)}}e.$Gc=g;class l{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[r,s]of t)this.set(r,s)}clear(){this.c.clear(),this.d.clear()}set(t,r){this.c.set(t,r),this.d.set(r,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const r=this.c.get(t);return r===void 0?!1:(this.c.delete(t),this.d.delete(r),!0)}forEach(t,r){this.c.forEach((s,i)=>{t.call(r,s,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=l;class w{constructor(){this.c=new Map}add(t,r){let s=this.c.get(t);s||(s=new Set,this.c.set(t,s)),s.add(r)}delete(t,r){const s=this.c.get(t);s&&(s.delete(r),s.size===0&&this.c.delete(t))}forEach(t,r){const s=this.c.get(t);s&&s.forEach(r)}get(t){const r=this.c.get(t);return r||new Set}}e.$Ic=w;function k(a,t){if(a===t)return!0;if(a.size!==t.size)return!1;for(const[r,s]of a)if(!t.has(r)||t.get(r)!==s)return!1;for(const[r]of t)if(!a.has(r))return!1;return!0}}),define(re[2],oe([0,1,22,137,32,86,71]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=d,e.$Mc=b,e.$Nc=v,e.$Oc=y,e.$Pc=p,e.$Qc=g,e.$Rc=l,e.$Sc=w,e.$Tc=k,e.$4c=D;const E=!1;let h=null;class c{constructor(){this.b=new Map}static{this.a=0}c(M){let W=this.b.get(M);return W||(W={parent:null,source:null,isSingleton:!1,value:M,idx:c.a++},this.b.set(M,W)),W}trackDisposable(M){const W=this.c(M);W.source||(W.source=new Error().stack)}setParent(M,W){const F=this.c(M);F.parent=W}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,W){const F=W.get(M);if(F)return F;const T=M.parent?this.f(this.c(M.parent),W):M;return W.set(M,T),T}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,M).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(M=10,W){let F;if(W)F=W;else{const ce=new Map,K=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,ce).isSingleton);if(K.length===0)return;const G=new Set(K.map(B=>B.value));if(F=K.filter(B=>!(B.parent&&G.has(B.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(ce){function K(B,L){for(;B.length>0&&L.some(z=>typeof z=="string"?z===B[0]:B[0].match(z));)B.shift()}const G=ce.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return K(G,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),G.reverse()}const q=new S.$Ic;for(const ce of F){const K=T(ce);for(let G=0;G<=K.length;G++)q.add(K.slice(0,G).join(`
`),ce)}F.sort((0,n.$7b)(ce=>ce.idx,n.$9b));let ue="",ee=0;for(const ce of F.slice(0,M)){ee++;const K=T(ce),G=[];for(let B=0;B<K.length;B++){let L=K[B];L=`(shared with ${q.get(K.slice(0,B+1).join(`
`)).size}/${F.length} leaks) at ${L}`;const Q=q.get(K.slice(0,B).join(`
`)),ae=(0,C.$K)([...Q].map(x=>T(x)[B]),x=>x);delete ae[K[B]];for(const[x,le]of Object.entries(ae))G.unshift(`    - stacktraces of ${le.length} other leaks continue with ${x}`);G.unshift(L)}ue+=`


==================== Leaking disposable ${ee}/${F.length}: ${ce.value.constructor.name} ====================
${G.join(`
`)}
============================================================

`}return F.length>M&&(ue+=`


... and ${F.length-M} more leaking disposables

`),{leaks:F,details:ue}}}e.$Kc=c;function d(O){h=O}if(E){const O="__is_disposable_tracked__";d(new class{trackDisposable(M){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[O]||console.log(W)},3e3)}setParent(M,W){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsSingleton(M){}})}function b(O){return h?.trackDisposable(O),O}function v(O){h?.markAsDisposed(O)}function m(O,M){h?.setParent(O,M)}function f(O,M){if(h)for(const W of O)h.setParent(W,M)}function y(O){return h?.markAsSingleton(O),O}function p(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function g(O){if(j.Iterable.is(O)){const M=[];for(const W of O)if(W)try{W.dispose()}catch(F){M.push(F)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function l(O){for(const M of O)p(M)&&M.dispose();return[]}function w(...O){const M=k(()=>g(O));return f(O,M),M}function k(O){const M=b({dispose:(0,R.$db)(()=>{v(M),O()})});return M}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return m(M,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),m(M,null))}}e.$Uc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,b(this),m(this.q,this)}dispose(){v(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Vc=t;class r{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&m(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&m(M,null),M}}e.$Wc=r;class s{constructor(M){this.a=new r,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=s;class i{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=i;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(M){let W=M;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,v(this))},this}}e.$Zc=o;class u{constructor(){this.a=new Map}acquire(M,...W){let F=this.a.get(M);F||(F={counter:0,object:this.b(M,...W)},this.a.set(M,F));const{object:T}=F,q=(0,R.$db)(()=>{--F.counter===0&&(this.c(M,F.object),this.a.delete(M))});return F.counter++,{object:T,dispose:q}}}e.$1c=u;class ${constructor(M){this.a=M}async acquire(M,...W){const F=this.a.acquire(M,...W);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$2c=$;class P{constructor(M){this.object=M}dispose(){}}e.$3c=P;function D(O){const M=new a;try{O(M)}finally{M.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,W,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(M)?.dispose(),this.a.set(M,W)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=I}),define(re[72],oe([0,1,32]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0,e.$bm=S,e.$cm=j;const C=new n.$Ec(1e4);function S(c){return h(c,"NFC",C)}const R=new n.$Ec(1e4);function j(c){return h(c,"NFD",R)}const E=/[^\u0000-\u0080]/;function h(c,d,b){if(!c)return c;const v=b.get(c);if(v)return v;let m;return E.test(c)?m=c.normalize(d):m=c,b.set(c,m),m}e.$dm=function(){const c=/[\u0300-\u036f]/g;return function(d){return j(d).replace(c,"")}}()}),define(re[141],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0,e.$Bm=n,e.rot=C;function n(E,h,c){return Math.min(Math.max(E,h),c)}function C(E,h){return(h+E%h)%h}class S{constructor(){this.a=0}getNext(){return this.a++}}e.$Dm=S;class R{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Em=R;class j{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Fm=j}),function(){function J(S){const R=[];typeof S=="number"&&R.push("code/timeOrigin",S);function j(h){R.push(h,Date.now())}function E(){const h=[];for(let c=0;c<R.length;c+=2)h.push({name:R[c],startTime:R[c+1]});return h}return{mark:j,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const j of performance.getEntriesByType("mark"))R.push({name:j.name,startTime:Math.round(S+j.startTime)});return R}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function n(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=n(C))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var C in n)(typeof exports=="object"?exports:J)[C]=n[C]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function n(C){if(e[C])return e[C].exports;var S=e[C]={i:C,l:!1,exports:{}};return J[C].call(S.exports,S,S.exports,n),S.l=!0,S.exports}return n.m=J,n.c=e,n.d=function(C,S,R){n.o(C,S)||Object.defineProperty(C,S,{enumerable:!0,get:R})},n.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},n.t=function(C,S){if(1&S&&(C=n(C)),8&S||4&S&&typeof C=="object"&&C&&C.__esModule)return C;var R=Object.create(null);if(n.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:C}),2&S&&typeof C!="string")for(var j in C)n.d(R,j,function(E){return C[E]}.bind(null,j));return R},n.n=function(C){var S=C&&C.__esModule?function(){return C.default}:function(){return C};return n.d(S,"a",S),S},n.o=function(C,S){return Object.prototype.hasOwnProperty.call(C,S)},n.p="",n(n.s=0)}([function(J,e,n){(function(C){var S;e=J.exports=le,S=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],h=e.src=[],c=0,d=c++;h[d]="0|[1-9]\\d*";var b=c++;h[b]="[0-9]+";var v=c++;h[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=c++;h[m]="("+h[d]+")\\.("+h[d]+")\\.("+h[d]+")";var f=c++;h[f]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var y=c++;h[y]="(?:"+h[d]+"|"+h[v]+")";var p=c++;h[p]="(?:"+h[b]+"|"+h[v]+")";var g=c++;h[g]="(?:-("+h[y]+"(?:\\."+h[y]+")*))";var l=c++;h[l]="(?:-?("+h[p]+"(?:\\."+h[p]+")*))";var w=c++;h[w]="[0-9A-Za-z-]+";var k=c++;h[k]="(?:\\+("+h[w]+"(?:\\."+h[w]+")*))";var a=c++,t="v?"+h[m]+h[g]+"?"+h[k]+"?";h[a]="^"+t+"$";var r="[v=\\s]*"+h[f]+h[l]+"?"+h[k]+"?",s=c++;h[s]="^"+r+"$";var i=c++;h[i]="((?:<|>)?=?)";var o=c++;h[o]=h[b]+"|x|X|\\*";var u=c++;h[u]=h[d]+"|x|X|\\*";var $=c++;h[$]="[v=\\s]*("+h[u]+")(?:\\.("+h[u]+")(?:\\.("+h[u]+")(?:"+h[g]+")?"+h[k]+"?)?)?";var P=c++;h[P]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[l]+")?"+h[k]+"?)?)?";var D=c++;h[D]="^"+h[i]+"\\s*"+h[$]+"$";var I=c++;h[I]="^"+h[i]+"\\s*"+h[P]+"$";var O=c++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=c++;h[M]="(?:~>?)";var W=c++;h[W]="(\\s*)"+h[M]+"\\s+",E[W]=new RegExp(h[W],"g");var F=c++;h[F]="^"+h[M]+h[$]+"$";var T=c++;h[T]="^"+h[M]+h[P]+"$";var q=c++;h[q]="(?:\\^)";var ue=c++;h[ue]="(\\s*)"+h[q]+"\\s+",E[ue]=new RegExp(h[ue],"g");var ee=c++;h[ee]="^"+h[q]+h[$]+"$";var ce=c++;h[ce]="^"+h[q]+h[P]+"$";var K=c++;h[K]="^"+h[i]+"\\s*("+r+")$|^$";var G=c++;h[G]="^"+h[i]+"\\s*("+t+")$|^$";var B=c++;h[B]="(\\s*)"+h[i]+"\\s*("+r+"|"+h[$]+")",E[B]=new RegExp(h[B],"g");var L=c++;h[L]="^\\s*("+h[$]+")\\s+-\\s+("+h[$]+")\\s*$";var z=c++;h[z]="^\\s*("+h[P]+")\\s+-\\s+("+h[P]+")\\s*$";var Q=c++;h[Q]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)S(ae,h[ae]),E[ae]||(E[ae]=new RegExp(h[ae]));function x(Y,fe){if(Y instanceof le)return Y;if(typeof Y!="string"||Y.length>R||!(fe?E[s]:E[a]).test(Y))return null;try{return new le(Y,fe)}catch{return null}}function le(Y,fe){if(Y instanceof le){if(Y.loose===fe)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof le))return new le(Y,fe);S("SemVer",Y,fe),this.loose=fe;var ge=Y.trim().match(fe?E[s]:E[a]);if(!ge)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Re=+je;if(Re>=0&&Re<j)return Re}return je}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=x,e.valid=function(Y,fe){var ge=x(Y,fe);return ge?ge.version:null},e.clean=function(Y,fe){var ge=x(Y.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=le,le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},le.prototype.toString=function(){return this.version},le.prototype.compare=function(Y){return S("SemVer.compare",this.version,this.loose,Y),Y instanceof le||(Y=new le(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},le.prototype.compareMain=function(Y){return Y instanceof le||(Y=new le(Y,this.loose)),A(this.major,Y.major)||A(this.minor,Y.minor)||A(this.patch,Y.patch)},le.prototype.comparePre=function(Y){if(Y instanceof le||(Y=new le(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],je=Y.prerelease[fe];if(S("prerelease compare",fe,ge,je),ge===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ge===void 0)return-1;if(ge!==je)return A(ge,je)}while(++fe)},le.prototype.inc=function(Y,fe){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,fe,ge,je){typeof ge=="string"&&(je=ge,ge=void 0);try{return new le(Y,ge).inc(fe,je).version}catch{return null}},e.diff=function(Y,fe){if(X(Y,fe))return null;var ge=x(Y),je=x(fe);if(ge.prerelease.length||je.prerelease.length){for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==je[Re])return"pre"+Re;return"prerelease"}for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==je[Re])return Re},e.compareIdentifiers=A;var Z=/^[0-9]+$/;function A(Y,fe){var ge=Z.test(Y),je=Z.test(fe);return ge&&je&&(Y=+Y,fe=+fe),ge&&!je?-1:je&&!ge?1:Y<fe?-1:Y>fe?1:0}function N(Y,fe,ge){return new le(Y,ge).compare(new le(fe,ge))}function _(Y,fe,ge){return N(Y,fe,ge)>0}function ne(Y,fe,ge){return N(Y,fe,ge)<0}function X(Y,fe,ge){return N(Y,fe,ge)===0}function H(Y,fe,ge){return N(Y,fe,ge)!==0}function V(Y,fe,ge){return N(Y,fe,ge)>=0}function U(Y,fe,ge){return N(Y,fe,ge)<=0}function se(Y,fe,ge,je){var Re;switch(fe){case"===":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Re=Y===ge;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Re=Y!==ge;break;case"":case"=":case"==":Re=X(Y,ge,je);break;case"!=":Re=H(Y,ge,je);break;case">":Re=_(Y,ge,je);break;case">=":Re=V(Y,ge,je);break;case"<":Re=ne(Y,ge,je);break;case"<=":Re=U(Y,ge,je);break;default:throw new TypeError("Invalid operator: "+fe)}return Re}function he(Y,fe){if(Y instanceof he){if(Y.loose===fe)return Y;Y=Y.value}if(!(this instanceof he))return new he(Y,fe);S("comparator",Y,fe),this.loose=fe,this.parse(Y),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(Y,fe){return A(fe,Y)},e.major=function(Y,fe){return new le(Y,fe).major},e.minor=function(Y,fe){return new le(Y,fe).minor},e.patch=function(Y,fe){return new le(Y,fe).patch},e.compare=N,e.compareLoose=function(Y,fe){return N(Y,fe,!0)},e.rcompare=function(Y,fe,ge){return N(fe,Y,ge)},e.sort=function(Y,fe){return Y.sort(function(ge,je){return e.compare(ge,je,fe)})},e.rsort=function(Y,fe){return Y.sort(function(ge,je){return e.rcompare(ge,je,fe)})},e.gt=_,e.lt=ne,e.eq=X,e.neq=H,e.gte=V,e.lte=U,e.cmp=se,e.Comparator=he;var $e={};function me(Y,fe){if(Y instanceof me)return Y.loose===fe?Y:new me(Y.raw,fe);if(Y instanceof he)return new me(Y.value,fe);if(!(this instanceof me))return new me(Y,fe);if(this.loose=fe,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function ye(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function ke(Y,fe,ge,je,Re,Be,Le,Fe,Qe,He,Xe,Te,te){return((fe=ye(ge)?"":ye(je)?">="+ge+".0.0":ye(Re)?">="+ge+"."+je+".0":">="+fe)+" "+(Fe=ye(Qe)?"":ye(He)?"<"+(+Qe+1)+".0.0":ye(Xe)?"<"+Qe+"."+(+He+1)+".0":Te?"<="+Qe+"."+He+"."+Xe+"-"+Te:"<="+Fe)).trim()}function Ee(Y,fe){for(var ge=0;ge<Y.length;ge++)if(!Y[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<Y.length;ge++)if(S(Y[ge].semver),Y[ge].semver!==$e&&Y[ge].semver.prerelease.length>0){var je=Y[ge].semver;if(je.major===fe.major&&je.minor===fe.minor&&je.patch===fe.patch)return!0}return!1}return!0}function Oe(Y,fe,ge){try{fe=new me(fe,ge)}catch{return!1}return fe.test(Y)}function we(Y,fe,ge,je){var Re,Be,Le,Fe,Qe;switch(Y=new le(Y,je),fe=new me(fe,je),ge){case">":Re=_,Be=U,Le=ne,Fe=">",Qe=">=";break;case"<":Re=ne,Be=V,Le=_,Fe="<",Qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(Y,fe,je))return!1;for(var He=0;He<fe.set.length;++He){var Xe=fe.set[He],Te=null,te=null;if(Xe.forEach(function(de){de.semver===$e&&(de=new he(">=0.0.0")),Te=Te||de,te=te||de,Re(de.semver,Te.semver,je)?Te=de:Le(de.semver,te.semver,je)&&(te=de)}),Te.operator===Fe||Te.operator===Qe||(!te.operator||te.operator===Fe)&&Be(Y,te.semver)||te.operator===Qe&&Le(Y,te.semver))return!1}return!0}he.prototype.parse=function(Y){var fe=this.loose?E[K]:E[G],ge=Y.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+Y);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new le(ge[2],this.loose):this.semver=$e},he.prototype.toString=function(){return this.value},he.prototype.test=function(Y){return S("Comparator.test",Y,this.loose),this.semver===$e||(typeof Y=="string"&&(Y=new le(Y,this.loose)),se(Y,this.operator,this.semver,this.loose))},he.prototype.intersects=function(Y,fe){if(!(Y instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new me(Y.value,fe),Oe(this.value,ge,fe);if(Y.operator==="")return ge=new me(this.value,fe),Oe(Y.semver,ge,fe);var je=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Be=this.semver.version===Y.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Fe=se(this.semver,"<",Y.semver,fe)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),Qe=se(this.semver,">",Y.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return je||Re||Be&&Le||Fe||Qe},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(Y){var fe=this.loose;Y=Y.trim(),S("range",Y,fe);var ge=fe?E[z]:E[L];Y=Y.replace(ge,ke),S("hyphen replace",Y),Y=Y.replace(E[B],"$1$2$3"),S("comparator trim",Y,E[B]),Y=(Y=(Y=Y.replace(E[W],"$1~")).replace(E[ue],"$1^")).split(/\s+/).join(" ");var je=fe?E[K]:E[G],Re=Y.split(" ").map(function(Be){return function(Le,Fe){return S("comp",Le),Le=function(Qe,He){return Qe.trim().split(/\s+/).map(function(Xe){return function(Te,te){S("caret",Te,te);var de=te?E[ce]:E[ee];return Te.replace(de,function(pe,ve,Pe,Me,ze){var Ge;return S("caret",Te,pe,ve,Pe,Me,ze),ye(ve)?Ge="":ye(Pe)?Ge=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Me)?Ge=ve==="0"?">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+".0 <"+(+ve+1)+".0.0":ze?(S("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ge=ve==="0"?Pe==="0"?">="+ve+"."+Pe+"."+Me+ze+" <"+ve+"."+Pe+"."+(+Me+1):">="+ve+"."+Pe+"."+Me+ze+" <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+"."+Me+ze+" <"+(+ve+1)+".0.0"):(S("no pr"),Ge=ve==="0"?Pe==="0"?">="+ve+"."+Pe+"."+Me+" <"+ve+"."+Pe+"."+(+Me+1):">="+ve+"."+Pe+"."+Me+" <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+"."+Me+" <"+(+ve+1)+".0.0"),S("caret return",Ge),Ge})}(Xe,He)}).join(" ")}(Le,Fe),S("caret",Le),Le=function(Qe,He){return Qe.trim().split(/\s+/).map(function(Xe){return function(Te,te){var de=te?E[T]:E[F];return Te.replace(de,function(pe,ve,Pe,Me,ze){var Ge;return S("tilde",Te,pe,ve,Pe,Me,ze),ye(ve)?Ge="":ye(Pe)?Ge=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Me)?Ge=">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0":ze?(S("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ge=">="+ve+"."+Pe+"."+Me+ze+" <"+ve+"."+(+Pe+1)+".0"):Ge=">="+ve+"."+Pe+"."+Me+" <"+ve+"."+(+Pe+1)+".0",S("tilde return",Ge),Ge})}(Xe,He)}).join(" ")}(Le,Fe),S("tildes",Le),Le=function(Qe,He){return S("replaceXRanges",Qe,He),Qe.split(/\s+/).map(function(Xe){return function(Te,te){Te=Te.trim();var de=te?E[I]:E[D];return Te.replace(de,function(pe,ve,Pe,Me,ze,Ge){S("xRange",Te,pe,ve,Pe,Me,ze,Ge);var Ye=ye(Pe),Ze=Ye||ye(Me),Ke=Ze||ye(ze);return ve==="="&&Ke&&(ve=""),Ye?pe=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Ke?(Ze&&(Me=0),Ke&&(ze=0),ve===">"?(ve=">=",Ze?(Pe=+Pe+1,Me=0,ze=0):Ke&&(Me=+Me+1,ze=0)):ve==="<="&&(ve="<",Ze?Pe=+Pe+1:Me=+Me+1),pe=ve+Pe+"."+Me+"."+ze):Ze?pe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ke&&(pe=">="+Pe+"."+Me+".0 <"+Pe+"."+(+Me+1)+".0"),S("xRange return",pe),pe})}(Xe,He)}).join(" ")}(Le,Fe),S("xrange",Le),Le=function(Qe,He){return S("replaceStars",Qe,He),Qe.trim().replace(E[Q],"")}(Le,Fe),S("stars",Le),Le}(Be,fe)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Be){return!!Be.match(je)})),Re=Re.map(function(Be){return new he(Be,fe)})},me.prototype.intersects=function(Y,fe){if(!(Y instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(je){return Y.set.some(function(Re){return Re.every(function(Be){return je.intersects(Be,fe)})})})})},e.toComparators=function(Y,fe){return new me(Y,fe).set.map(function(ge){return ge.map(function(je){return je.value}).join(" ").trim().split(" ")})},me.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new le(Y,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Ee(this.set[fe],Y))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(Y,fe,ge){var je=null,Re=null;try{var Be=new me(fe,ge)}catch{return null}return Y.forEach(function(Le){Be.test(Le)&&(je&&Re.compare(Le)!==-1||(Re=new le(je=Le,ge)))}),je},e.minSatisfying=function(Y,fe,ge){var je=null,Re=null;try{var Be=new me(fe,ge)}catch{return null}return Y.forEach(function(Le){Be.test(Le)&&(je&&Re.compare(Le)!==1||(Re=new le(je=Le,ge)))}),je},e.validRange=function(Y,fe){try{return new me(Y,fe).range||"*"}catch{return null}},e.ltr=function(Y,fe,ge){return we(Y,fe,"<",ge)},e.gtr=function(Y,fe,ge){return we(Y,fe,">",ge)},e.outside=we,e.prerelease=function(Y,fe){var ge=x(Y,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Y,fe,ge){return Y=new me(Y,ge),fe=new me(fe,ge),Y.intersects(fe)},e.coerce=function(Y){if(Y instanceof le)return Y;if(typeof Y!="string")return null;var fe=Y.match(E[O]);return fe==null?null:x((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,n(1))},function(J,e){var n,C,S=J.exports={};function R(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function E(p){if(n===setTimeout)return setTimeout(p,0);if((n===R||!n)&&setTimeout)return n=setTimeout,setTimeout(p,0);try{return n(p,0)}catch{try{return n.call(null,p,0)}catch{return n.call(this,p,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:R}catch{n=R}try{C=typeof clearTimeout=="function"?clearTimeout:j}catch{C=j}})();var h,c=[],d=!1,b=-1;function v(){d&&h&&(d=!1,h.length?c=h.concat(c):b=-1,c.length&&m())}function m(){if(!d){var p=E(v);d=!0;for(var g=c.length;g;){for(h=c,c=[];++b<g;)h&&h[b].run();b=-1,g=c.length}h=null,d=!1,function(l){if(C===clearTimeout)return clearTimeout(l);if((C===j||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(l);try{C(l)}catch{try{return C.call(null,l)}catch{return C.call(this,l)}}}(p)}}function f(p,g){this.fun=p,this.array=g}function y(){}S.nextTick=function(p){var g=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)g[l-1]=arguments[l];c.push(new f(p,g)),c.length!==1||d||E(m)},f.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=y,S.addListener=y,S.once=y,S.off=y,S.removeListener=y,S.removeAllListeners=y,S.emit=y,S.prependListener=y,S.prependOnceListener=y,S.listeners=function(p){return[]},S.binding=function(p){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(p){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(re[142],oe([0,1]),function(J,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class C{constructor(E,h,c){this.level=E,this.key=h,this.value=c,this.forward=[]}}const S=void 0;class R{constructor(E,h=2**16){this.comparator=E,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new C(this.c,S,S)}get size(){return this.f}clear(){this.e=new C(this.c,S,S),this.f=0}has(E){return!!R.g(this,E,this.comparator)}get(E){return R.g(this,E,this.comparator)?.value}set(E,h){return R.h(this,E,h,this.comparator)&&(this.f+=1),this}delete(E){const h=R.k(this,E,this.comparator);return h&&(this.f-=1),h}forEach(E,h){let c=this.e.forward[0];for(;c;)E.call(h,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",h=this.e.forward[0];for(;h;)E+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return E}static g(E,h,c){let d=E.e;for(let b=E.d-1;b>=0;b--)for(;d.forward[b]&&c(d.forward[b].key,h)<0;)d=d.forward[b];if(d=d.forward[0],d&&c(d.key,h)===0)return d}static h(E,h,c,d){const b=[];let v=E.e;for(let m=E.d-1;m>=0;m--){for(;v.forward[m]&&d(v.forward[m].key,h)<0;)v=v.forward[m];b[m]=v}if(v=v.forward[0],v&&d(v.key,h)===0)return v.value=c,!1;{const m=R.j(E);if(m>E.d){for(let f=E.d;f<m;f++)b[f]=E.e;E.d=m}v=new C(m,h,c);for(let f=0;f<m;f++)v.forward[f]=b[f].forward[f],b[f].forward[f]=v;return!0}}static j(E,h=.5){let c=1;for(;Math.random()<h&&c<E.c;)c+=1;return c}static k(E,h,c){const d=[];let b=E.e;for(let v=E.d-1;v>=0;v--){for(;b.forward[v]&&c(b.forward[v].key,h)<0;)b=b.forward[v];d[v]=b}if(b=b.forward[0],!b||c(b.key,h)!==0)return!1;for(let v=0;v<E.d&&d[v].forward[v]===b;v++)d[v].forward[v]=b.forward[v];for(;E.d>0&&E.e.forward[E.d-1]===S;)E.d-=1;return!0}}e.$zs=R}),define(re[73],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(R){return new C(R)}constructor(R){this.c=n&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ae=C}),define(re[3],oe([0,1,15,86,2,104,73]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$ce=e.Event=void 0,e.$de=m;const E=!1,h=!1,c=!1;var d;(function(W){W.None=()=>S.$Vc.None;function F(me){if(c){const{onDidAddListener:ye}=me,ke=y.create();let Ee=0;me.onDidAddListener=()=>{++Ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),ye?.()}}}function T(me,ye){return Q(me,()=>{},0,void 0,!0,void 0,ye)}W.defer=T;function q(me){return(ye,ke=null,Ee)=>{let Oe=!1,we;return we=me(Y=>{if(!Oe)return we?we.dispose():Oe=!0,ye.call(ke,Y)},null,Ee),Oe&&we.dispose(),we}}W.once=q;function ue(me,ye,ke){return L((Ee,Oe=null,we)=>me(Y=>Ee.call(Oe,ye(Y)),null,we),ke)}W.map=ue;function ee(me,ye,ke){return L((Ee,Oe=null,we)=>me(Y=>{ye(Y),Ee.call(Oe,Y)},null,we),ke)}W.forEach=ee;function ce(me,ye,ke){return L((Ee,Oe=null,we)=>me(Y=>ye(Y)&&Ee.call(Oe,Y),null,we),ke)}W.filter=ce;function K(me){return me}W.signal=K;function G(...me){return(ye,ke=null,Ee)=>{const Oe=(0,S.$Sc)(...me.map(we=>we(Y=>ye.call(ke,Y))));return z(Oe,Ee)}}W.any=G;function B(me,ye,ke,Ee){let Oe=ke;return ue(me,we=>(Oe=ye(Oe,we),Oe),Ee)}W.reduce=B;function L(me,ye){let ke;const Ee={onWillAddFirstListener(){ke=me(Oe.fire,Oe)},onDidRemoveLastListener(){ke?.dispose()}};ye||F(Ee);const Oe=new a(Ee);return ye?.add(Oe),Oe.event}function z(me,ye){return ye instanceof Array?ye.push(me):ye&&ye.add(me),me}function Q(me,ye,ke=100,Ee=!1,Oe=!1,we,Y){let fe,ge,je,Re=0,Be;const Le={leakWarningThreshold:we,onWillAddFirstListener(){fe=me(Qe=>{Re++,ge=ye(ge,Qe),Ee&&!je&&(Fe.fire(ge),ge=void 0),Be=()=>{const He=ge;ge=void 0,je=void 0,(!Ee||Re>1)&&Fe.fire(He),Re=0},typeof ke=="number"?(clearTimeout(je),je=setTimeout(Be,ke)):je===void 0&&(je=0,queueMicrotask(Be))})},onWillRemoveListener(){Oe&&Re>0&&Be?.()},onDidRemoveLastListener(){Be=void 0,fe.dispose()}};Y||F(Le);const Fe=new a(Le);return Y?.add(Fe),Fe.event}W.debounce=Q;function ae(me,ye=0,ke){return W.debounce(me,(Ee,Oe)=>Ee?(Ee.push(Oe),Ee):[Oe],ye,void 0,!0,void 0,ke)}W.accumulate=ae;function x(me,ye=(Ee,Oe)=>Ee===Oe,ke){let Ee=!0,Oe;return ce(me,we=>{const Y=Ee||!ye(we,Oe);return Ee=!1,Oe=we,Y},ke)}W.latch=x;function le(me,ye,ke){return[W.filter(me,ye,ke),W.filter(me,Ee=>!ye(Ee),ke)]}W.split=le;function Z(me,ye=!1,ke=[],Ee){let Oe=ke.slice(),we=me(ge=>{Oe?Oe.push(ge):fe.fire(ge)});Ee&&Ee.add(we);const Y=()=>{Oe?.forEach(ge=>fe.fire(ge)),Oe=null},fe=new a({onWillAddFirstListener(){we||(we=me(ge=>fe.fire(ge)),Ee&&Ee.add(we))},onDidAddFirstListener(){Oe&&(ye?setTimeout(Y):Y())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return Ee&&Ee.add(fe),fe.event}W.buffer=Z;function A(me,ye){return(Ee,Oe,we)=>{const Y=ye(new _);return me(function(fe){const ge=Y.evaluate(fe);ge!==N&&Ee.call(Oe,ge)},void 0,we)}}W.chain=A;const N=Symbol("HaltChainable");class _{constructor(){this.f=[]}map(ye){return this.f.push(ye),this}forEach(ye){return this.f.push(ke=>(ye(ke),ke)),this}filter(ye){return this.f.push(ke=>ye(ke)?ke:N),this}reduce(ye,ke){let Ee=ke;return this.f.push(Oe=>(Ee=ye(Ee,Oe),Ee)),this}latch(ye=(ke,Ee)=>ke===Ee){let ke=!0,Ee;return this.f.push(Oe=>{const we=ke||!ye(Oe,Ee);return ke=!1,Ee=Oe,we?Oe:N}),this}evaluate(ye){for(const ke of this.f)if(ye=ke(ye),ye===N)break;return ye}}function ne(me,ye,ke=Ee=>Ee){const Ee=(...fe)=>Y.fire(ke(...fe)),Oe=()=>me.on(ye,Ee),we=()=>me.removeListener(ye,Ee),Y=new a({onWillAddFirstListener:Oe,onDidRemoveLastListener:we});return Y.event}W.fromNodeEventEmitter=ne;function X(me,ye,ke=Ee=>Ee){const Ee=(...fe)=>Y.fire(ke(...fe)),Oe=()=>me.addEventListener(ye,Ee),we=()=>me.removeEventListener(ye,Ee),Y=new a({onWillAddFirstListener:Oe,onDidRemoveLastListener:we});return Y.event}W.fromDOMEventEmitter=X;function H(me){return new Promise(ye=>q(me)(ye))}W.toPromise=H;function V(me){const ye=new a;return me.then(ke=>{ye.fire(ke)},()=>{ye.fire(void 0)}).finally(()=>{ye.dispose()}),ye.event}W.fromPromise=V;function U(me,ye,ke){return ye(ke),me(Ee=>ye(Ee))}W.runAndSubscribe=U;class se{constructor(ye,ke){this._observable=ye,this.f=0,this.g=!1;const Ee={onWillAddFirstListener:()=>{ye.addObserver(this)},onDidRemoveLastListener:()=>{ye.removeObserver(this)}};ke||F(Ee),this.emitter=new a(Ee),ke&&ke.add(this.emitter)}beginUpdate(ye){this.f++}handlePossibleChange(ye){}handleChange(ye,ke){this.g=!0}endUpdate(ye){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function he(me,ye){return new se(me,ye).emitter.event}W.fromObservable=he;function $e(me){return(ye,ke,Ee)=>{let Oe=0,we=!1;const Y={beginUpdate(){Oe++},endUpdate(){Oe--,Oe===0&&(me.reportChanges(),we&&(we=!1,ye.call(ke)))},handlePossibleChange(){},handleChange(){we=!0}};me.addObserver(Y),me.reportChanges();const fe={dispose(){me.removeObserver(Y)}};return Ee instanceof S.$Uc?Ee.add(fe):Array.isArray(Ee)&&Ee.push(fe),fe}}W.fromObservableLight=$e})(d||(e.Event=d={}));class b{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${b.f++}`,b.all.add(this)}start(F){this.g=new j.$ae,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$ce=b;let v=-1;function m(W){const F=v;return v=W,{dispose(){v=F}}}class f{constructor(F,T=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=T,this.g=0}dispose(){this.f?.clear()}check(F,T){const q=this.threshold;if(q<=0||T<q)return;this.f||(this.f=new Map);const ue=this.f.get(F.value)||0;if(this.f.set(F.value,ue+1),this.g-=1,this.g<=0){this.g=q*.5;let ee,ce=0;for(const[K,G]of this.f)(!ee||ce<G)&&(ee=K,ce=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${ce}):`),console.warn(ee)}return()=>{const ee=this.f.get(F.value)||0;this.f.set(F.value,ee-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class g{constructor(F){this.value=F,this.id=p++}}const l=2,w=(W,F)=>{if(W instanceof g)F(W);else for(let T=0;T<W.length;T++){const q=W[T];q&&F(q)}},k=E?new FinalizationRegistry(W=>{typeof W=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(W))}):void 0;class a{constructor(F){this.w=0,this.f=F,this.g=v>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const F=this.t;queueMicrotask(()=>{w(F,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,T,q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),S.$Vc.None;if(this.m)return S.$Vc.None;T&&(F=F.bind(T));const ue=new g(F);let ee,ce;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ue.stack=y.create(),ee=this.g.check(ue.stack,this.w+1)),h&&(ue.stack=ce??y.create()),this.t?this.t instanceof g?(this.u??=new r,this.t=[this.t,ue]):this.t.push(ue):(this.f?.onWillAddFirstListener?.(this),this.t=ue,this.f?.onDidAddFirstListener?.(this)),this.w++;const K=(0,S.$Tc)(()=>{k?.unregister(K),ee?.(),this.x(ue)});if(q instanceof S.$Uc?q.add(K):Array.isArray(q)&&q.push(K),k){const G=new Error().stack.split(`
`).slice(2).join(`
`).trim();k.register(K,G,K)}return K},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,q=T.indexOf(F);if(q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[q]=void 0;const ue=this.u.current===this;if(this.w*l<=T.length){let ee=0;for(let ce=0;ce<T.length;ce++)T[ce]?T[ee++]=T[ce]:ue&&(this.u.end--,ee<this.u.i&&this.u.i--);T.length=ee}}y(F,T){if(!F)return;const q=this.f?.onListenerError||n.$1;if(!q){F.value(T);return}try{F.value(T)}catch(ue){q(ue)}}z(F){const T=F.current.t;for(;F.i<F.end;)this.y(T[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,F);else{const T=this.u;T.enqueue(this,F,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ee=a;const t=()=>new r;e.$fe=t;class r{constructor(){this.i=-1,this.end=0}enqueue(F,T,q){this.i=0,this.end=q,this.current=F,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends a{async fireAsync(F,T,q){if(this.t)for(this.h||(this.h=new R.$6c),w(this.t,ue=>this.h.push([ue.value,F]));this.h.size>0&&!T.isCancellationRequested;){const[ue,ee]=this.h.shift(),ce=[],K={...ee,token:T,waitUntil:G=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");q&&(G=q(G,ue)),ce.push(G)}};try{ue(K)}catch(G){(0,n.$1)(G);continue}Object.freeze(ce),await Promise.allSettled(ce).then(G=>{for(const B of G)B.status==="rejected"&&(0,n.$1)(B.reason)})}}}e.$ge=s;class i extends a{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new R.$6c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$he=i;class o extends i{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$ie=o;class u extends a{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$je=u;class ${constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const T={event:F,listener:null};this.h.push(T),this.g&&this.m(T);const q=()=>{this.g&&this.o(T);const ue=this.h.indexOf(T);this.h.splice(ue,1)};return(0,S.$Tc)((0,C.$db)(q))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(T=>this.f.fire(T))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$ke=$;class P{constructor(F,T,q,ue){this.f=new S.$Uc;const ee=this.f.add(new $),ce=this.f.add(new S.$5c);function K(G){ce.set(G,ee.add(ue(G)))}for(const G of F)K(G);this.f.add(T(G=>{K(G)})),this.f.add(q(G=>{ce.deleteAndDispose(G)})),this.event=ee.event}dispose(){this.f.dispose()}}e.$le=P;class D{constructor(){this.f=[]}wrapEvent(F){return(T,q,ue)=>F(ee=>{const ce=this.f[this.f.length-1];ce?ce.push(()=>T.call(q,ee)):T.call(q,ee)},void 0,ue)}bufferEvents(F){const T=[];this.f.push(T);const q=F();return this.f.pop(),T.forEach(ue=>ue()),q}}e.$me=D;class I{constructor(){this.f=!1,this.g=d.None,this.h=S.$Vc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ne=I;class O{static const(F){return new M(F)}constructor(F){this.g=F,this.f=new a,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$oe=O;class M{constructor(F){this.value=F,this.onDidChange=d.None}}}),define(re[23],oe([0,1,3]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.CancellationToken=void 0,e.$qe=E;const C=Object.freeze(function(h,c){const d=setTimeout(h.bind(c),0);return{dispose(){clearTimeout(d)}}});var S;(function(h){function c(d){return d===h.None||d===h.Cancelled||d instanceof R?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}h.isCancellationToken=c,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(S||(e.CancellationToken=S={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new n.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=S.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=S.None}}e.$pe=j;function E(h){const c=new j;return h.add({dispose(){c.cancel()}}),c.token}}),define(re[143],oe([0,1,23]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=e.$2e=void 0,e.$3e=S;class C{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new n.$pe,c=this.b(h.token);return this.a={promise:c,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}e.$2e=C;function S(E){return E}class R{constructor(h,c){this.a=void 0,this.b=void 0,typeof h=="function"?(this.c=h,this.d=S):(this.c=c,this.d=h.getCacheKey)}get(h){const c=this.d(h);return this.b!==c&&(this.b=c,this.a=this.c(h)),this.a}}e.$4e=R;class j{get cachedValues(){return this.a}constructor(h,c){this.a=new Map,this.b=new Map,typeof h=="function"?(this.c=h,this.d=S):(this.c=c,this.d=h.getCacheKey)}get(h){const c=this.d(h);if(this.b.has(c))return this.b.get(c);const d=this.c(h);return this.a.set(h,d),this.b.set(c,d),d}}e.$5e=j}),define(re[63],oe([0,1,15,2]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=S,e.$se=R,e.$te=j,e.$ue=E,e.$ve=c,e.$we=d,e.$xe=b,e.$ye=v,e.$ze=m,e.$Ae=f,e.$Be=y,e.$Ce=p,e.$De=g,e.$Ee=l,e.$Fe=w;function S(k){const a=k;return a?typeof a.read=="function":!1}function R(k){const a=k;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function j(k){const a=k;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function E(k,a){return new h(k,a)}class h{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,n.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(t);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(k,a){const t=[];let r;for(;(r=k.read())!==null;)t.push(r);return a(t)}function d(k,a,t){const r=[];let s;for(;(s=k.read())!==null&&r.length<t;)r.push(s);return s===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return k.read()}}}function b(k,a){return new Promise((t,r)=>{const s=[];v(k,{onData:i=>{a&&s.push(i)},onError:i=>{a?r(i):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}function v(k,a,t){k.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),k.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),k.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}function m(k,a){return new Promise((t,r)=>{const s=new C.$Uc,i=[],o=P=>{if(i.push(P),i.length>a)return s.dispose(),k.pause(),t({stream:k,buffer:i,ended:!1})},u=P=>(s.dispose(),r(P)),$=()=>(s.dispose(),t({stream:k,buffer:i,ended:!0}));s.add((0,C.$Tc)(()=>k.removeListener("error",u))),k.on("error",u),s.add((0,C.$Tc)(()=>k.removeListener("end",$))),k.on("end",$),s.add((0,C.$Tc)(()=>k.removeListener("data",o))),k.on("data",o)})}function f(k,a){const t=E(a);return t.end(k),t}function y(){const k=E(()=>{throw new Error("not supported")});return k.end(),k}function p(k){let a=!1;return{read:()=>a?null:(a=!0,k)}}function g(k,a,t){const r=E(t);return v(k,{onData:s=>r.write(a.data(s)),onError:s=>r.error(a.error?a.error(s):s),onEnd:()=>r.end()}),r}function l(k,a,t){let r=!1;return{read:()=>{const s=a.read();return r?s:(r=!0,s!==null?t([k,s]):k)}}}function w(k,a,t){let r=!1;const s=E(t);return v(a,{onData:i=>r?s.write(i):(r=!0,s.write(t([k,i]))),onError:i=>s.error(i),onEnd:()=>{r||(r=!0,s.write(k)),s.end()}}),s}}),define(re[17],oe([0,1,62,63]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=void 0,e.$He=c,e.$Ie=d,e.$Je=b,e.$Ke=v,e.$Le=m,e.$Me=f,e.$Ne=y,e.$Oe=p,e.$Pe=g,e.$Qe=l,e.$Re=w,e.$Se=k,e.$Te=a,e.$Ue=t,e.$Ve=r,e.$We=s,e.$Xe=i,e.$Ye=o,e.$Ze=u,e.$1e=D;const S=typeof Buffer<"u",R=new n.$V(()=>new Uint8Array(256));let j,E;class h{static alloc(O){return S?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return S&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,M){return!(M?.dontUseNodeBuffer||!1)&&S?new h(Buffer.from(O)):(j||(j=new TextEncoder),new h(j.encode(O)))}static fromByteArray(O){const M=h.alloc(O.length);for(let W=0,F=O.length;W<F;W++)M.buffer[W]=O[W];return M}static concat(O,M){if(typeof M>"u"){M=0;for(let T=0,q=O.length;T<q;T++)M+=O[T].byteLength}const W=h.alloc(M);let F=0;for(let T=0,q=O.length;T<q;T++){const ue=O[T];W.set(ue,F),F+=ue.byteLength}return W}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return S?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(O,M){return new h(this.buffer.subarray(O,M))}set(O,M){if(O instanceof h)this.buffer.set(O.buffer,M);else if(O instanceof Uint8Array)this.buffer.set(O,M);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),M);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return v(this.buffer,O)}writeUInt32BE(O,M){m(this.buffer,O,M)}readUInt32LE(O){return f(this.buffer,O)}writeUInt32LE(O,M){y(this.buffer,O,M)}readUInt8(O){return p(this.buffer,O)}writeUInt8(O,M){g(this.buffer,O,M)}indexOf(O,M=0){return c(this.buffer,O instanceof h?O.buffer:O,M)}}e.$Ge=h;function c(I,O,M=0){const W=O.byteLength,F=I.byteLength;if(W===0)return 0;if(W===1)return I.indexOf(O[0]);if(W>F-M)return-1;const T=R.value;T.fill(O.length);for(let ce=0;ce<O.length;ce++)T[O[ce]]=O.length-ce-1;let q=M+O.length-1,ue=q,ee=-1;for(;q<F;)if(I[q]===O[ue]){if(ue===0){ee=q;break}q--,ue--}else q+=Math.max(O.length-ue,T[I[q]]),ue=O.length-1;return ee}function d(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0}function b(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255}function v(I,O){return I[O]*2**24+I[O+1]*2**16+I[O+2]*2**8+I[O+3]}function m(I,O,M){I[M+3]=O,O=O>>>8,I[M+2]=O,O=O>>>8,I[M+1]=O,O=O>>>8,I[M]=O}function f(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0|I[O+2]<<16>>>0|I[O+3]<<24>>>0}function y(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255,O=O>>>8,I[M+2]=O&255,O=O>>>8,I[M+3]=O&255}function p(I,O){return I[O]}function g(I,O,M){I[M]=O}function l(I){return C.$ve(I,O=>h.concat(O))}function w(I){return C.$Ce(I)}function k(I){return C.$xe(I,O=>h.concat(O))}async function a(I){return I.ended?h.concat(I.buffer):h.concat([...I.buffer,await k(I.stream)])}function t(I){return C.$Ae(I,O=>h.concat(O))}function r(I){return C.$De(I,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}function s(I){return C.$ue(O=>h.concat(O),I)}function i(I,O){return C.$Ee(I,O,M=>h.concat(M))}function o(I,O){return C.$Fe(I,O,M=>h.concat(M))}function u(I){let O=0,M=0,W=0;const F=new Uint8Array(Math.floor(I.length/4*3)),T=ue=>{switch(M){case 3:F[W++]=O|ue,M=0;break;case 2:F[W++]=O|ue>>>2,O=ue<<6,M=3;break;case 1:F[W++]=O|ue>>>4,O=ue<<4,M=2;break;default:O=ue<<2,M=1}};for(let ue=0;ue<I.length;ue++){const ee=I.charCodeAt(ue);if(ee>=65&&ee<=90)T(ee-65);else if(ee>=97&&ee<=122)T(ee-97+26);else if(ee>=48&&ee<=57)T(ee-48+52);else if(ee===43||ee===45)T(62);else if(ee===47||ee===95)T(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${I[ue]}`)}}const q=W;for(;M>0;)T(0);return h.wrap(F).slice(0,q)}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:I},O=!0,M=!1){const W=M?P:$;let F="";const T=I.byteLength%3;let q=0;for(;q<I.byteLength-T;q+=3){const ue=I[q+0],ee=I[q+1],ce=I[q+2];F+=W[ue>>>2],F+=W[(ue<<4|ee>>>4)&63],F+=W[(ee<<2|ce>>>6)&63],F+=W[ce&63]}if(T===1){const ue=I[q+0];F+=W[ue>>>2],F+=W[ue<<4&63],O&&(F+="==")}else if(T===2){const ue=I[q+0],ee=I[q+1];F+=W[ue>>>2],F+=W[(ue<<4|ee>>>4)&63],F+=W[ee<<2&63],O&&(F+="=")}return F}}),define(re[25],oe([0,1,143,62]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Of=e.$Hf=e.$Gf=void 0,e.$8e=S,e.$9e=j,e.$0e=h,e.$$e=c,e.$_e=d,e.$af=b,e.$bf=v,e.$cf=m,e.$df=f,e.$ef=y,e.$ff=p,e.$gf=g,e.$hf=l,e.$if=w,e.$jf=k,e.$kf=a,e.$lf=t,e.$mf=r,e.$nf=s,e.$of=i,e.$pf=o,e.$qf=u,e.$rf=$,e.$sf=P,e.$tf=D,e.$uf=I,e.$vf=O,e.$wf=M,e.$xf=W,e.$yf=F,e.$zf=T,e.$Af=q,e.$Bf=ue,e.$Cf=ee,e.$Df=ce,e.$Ef=K,e.$Ff=G,e.$If=Q,e.$Jf=ae,e.$Kf=x,e.$Lf=le,e.$Mf=N,e.$Nf=ne,e.$Pf=X,e.$Qf=H,e.$Rf=V,e.$Sf=U,e.$Tf=he,e.$Uf=$e,e.$Wf=me,e.$Xf=ye,e.$Yf=ke,e.$Zf=Ee,e.$1f=Oe,e.$2f=we,e.$3f=Y,e.$4f=fe,e.$5f=Le;function S(te){return!te||typeof te!="string"?!0:te.trim().length===0}const R=/{(\d+)}/g;function j(te,...de){return de.length===0?te:te.replace(R,function(pe,ve){const Pe=parseInt(ve,10);return isNaN(Pe)||Pe<0||Pe>=de.length?pe:de[Pe]})}const E=/{([^}]+)}/g;function h(te,de){return Object.keys(de).length===0?te:te.replace(E,(pe,ve)=>de[ve]??pe)}function c(te){return te.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function d(te){return te.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function b(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function v(te,de){let pe=0;const ve=de.charCodeAt(0);for(let Pe=te.length-1;Pe>=0;Pe--)te.charCodeAt(Pe)===ve&&pe++;return pe}function m(te,de,pe="\u2026"){return te.length<=de?te:`${te.substr(0,de)}${pe}`}function f(te,de,pe="\u2026"){if(te.length<=de)return te;const ve=Math.ceil(de/2)-pe.length/2,Pe=Math.floor(de/2)-pe.length/2;return`${te.substr(0,ve)}${pe}${te.substr(te.length-Pe)}`}function y(te,de=" "){const pe=p(te,de);return g(pe,de)}function p(te,de){if(!te||!de)return te;const pe=de.length;if(pe===0||te.length===0)return te;let ve=0;for(;te.indexOf(de,ve)===ve;)ve=ve+pe;return te.substring(ve)}function g(te,de){if(!te||!de)return te;const pe=de.length,ve=te.length;if(pe===0||ve===0)return te;let Pe=ve,Me=-1;for(;Me=te.lastIndexOf(de,Pe-1),!(Me===-1||Me+pe!==Pe);){if(Me===0)return"";Pe=Me}return te.substring(0,Pe)}function l(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function w(te){return te.replace(/\*/g,"")}function k(te,de,pe={}){if(!te)throw new Error("Cannot create regex from empty string");de||(te=b(te)),pe.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let ve="";return pe.global&&(ve+="g"),pe.matchCase||(ve+="i"),pe.multiline&&(ve+="m"),pe.unicode&&(ve+="u"),new RegExp(te,ve)}function a(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function t(te){return te.split(/\r\n|\r|\n/)}function r(te){const de=[],pe=te.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil(pe.length/2);ve++)de.push(pe[2*ve]+(pe[2*ve+1]??""));return de}function s(te){for(let de=0,pe=te.length;de<pe;de++){const ve=te.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}function i(te,de=0,pe=te.length){for(let ve=de;ve<pe;ve++){const Pe=te.charCodeAt(ve);if(Pe!==32&&Pe!==9)return te.substring(de,ve)}return te.substring(de,pe)}function o(te,de=te.length-1){for(let pe=de;pe>=0;pe--){const ve=te.charCodeAt(pe);if(ve!==32&&ve!==9)return pe}return-1}function u(te,de,pe){const ve=[];let Pe=0;for(const Me of te.matchAll(de)){if(ve.push(te.slice(Pe,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Pe=Me.index+Me[0].length,ve.push(pe(Me[0],...Me.slice(1),Me.index,te,Me.groups))}return ve.push(te.slice(Pe)),Promise.all(ve).then(Me=>Me.join(""))}function $(te,de){return te<de?-1:te>de?1:0}function P(te,de,pe=0,ve=te.length,Pe=0,Me=de.length){for(;pe<ve&&Pe<Me;pe++,Pe++){const Ye=te.charCodeAt(pe),Ze=de.charCodeAt(Pe);if(Ye<Ze)return-1;if(Ye>Ze)return 1}const ze=ve-pe,Ge=Me-Pe;return ze<Ge?-1:ze>Ge?1:0}function D(te,de){return I(te,de,0,te.length,0,de.length)}function I(te,de,pe=0,ve=te.length,Pe=0,Me=de.length){for(;pe<ve&&Pe<Me;pe++,Pe++){let Ye=te.charCodeAt(pe),Ze=de.charCodeAt(Pe);if(Ye===Ze)continue;if(Ye>=128||Ze>=128)return P(te.toLowerCase(),de.toLowerCase(),pe,ve,Pe,Me);M(Ye)&&(Ye-=32),M(Ze)&&(Ze-=32);const Ke=Ye-Ze;if(Ke!==0)return Ke}const ze=ve-pe,Ge=Me-Pe;return ze<Ge?-1:ze>Ge?1:0}function O(te){return te>=48&&te<=57}function M(te){return te>=97&&te<=122}function W(te){return te>=65&&te<=90}function F(te,de){return te.length===de.length&&I(te,de)===0}function T(te,de){const pe=de.length;return de.length>te.length?!1:I(te,de,0,pe)===0}function q(te,de){const pe=Math.min(te.length,de.length);let ve;for(ve=0;ve<pe;ve++)if(te.charCodeAt(ve)!==de.charCodeAt(ve))return ve;return pe}function ue(te,de){const pe=Math.min(te.length,de.length);let ve;const Pe=te.length-1,Me=de.length-1;for(ve=0;ve<pe;ve++)if(te.charCodeAt(Pe-ve)!==de.charCodeAt(Me-ve))return ve;return pe}function ee(te){return 55296<=te&&te<=56319}function ce(te){return 56320<=te&&te<=57343}function K(te,de){return(te-55296<<10)+(de-56320)+65536}function G(te,de,pe){const ve=te.charCodeAt(pe);if(ee(ve)&&pe+1<de){const Pe=te.charCodeAt(pe+1);if(ce(Pe))return K(ve,Pe)}return ve}function B(te,de){const pe=te.charCodeAt(de-1);if(ce(pe)&&de>1){const ve=te.charCodeAt(de-2);if(ee(ve))return K(ve,pe)}return pe}class L{get offset(){return this.e}constructor(de,pe=0){this.c=de,this.d=de.length,this.e=pe}setOffset(de){this.e=de}prevCodePoint(){const de=B(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=G(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Gf=L;class z{get offset(){return this.c.offset}constructor(de,pe=0){this.c=new L(de,pe)}nextGraphemeLength(){const de=Re.getInstance(),pe=this.c,ve=pe.offset;let Pe=de.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Me=pe.offset,ze=de.getGraphemeBreakType(pe.nextCodePoint());if(ge(Pe,ze)){pe.setOffset(Me);break}Pe=ze}return pe.offset-ve}prevGraphemeLength(){const de=Re.getInstance(),pe=this.c,ve=pe.offset;let Pe=de.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Me=pe.offset,ze=de.getGraphemeBreakType(pe.prevCodePoint());if(ge(ze,Pe)){pe.setOffset(Me);break}Pe=ze}return ve-pe.offset}eol(){return this.c.eol()}}e.$Hf=z;function Q(te,de){return new z(te,de).nextGraphemeLength()}function ae(te,de){return new z(te,de).prevGraphemeLength()}function x(te,de){de>0&&ce(te.charCodeAt(de))&&de--;const pe=de+Q(te,de);return[pe-ae(te,pe),pe]}function le(te){const de=new z(te);let pe=0;for(;!de.eol();)pe++,de.nextGraphemeLength();return pe}let Z;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(te){return Z||(Z=A()),Z.test(te)}const _=/^[\t\n\r\x20-\x7E]*$/;function ne(te){return _.test(te)}e.$Of=/[\u2028\u2029]/;function X(te){return e.$Of.test(te)}function H(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function V(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function U(te,de,pe=""){const ve=te.trimStart();if(ve.length<de)return ve;const Pe=/\b/g;let Me=0;for(;Pe.test(ve)&&!(ve.length-Pe.lastIndex<de);)Me=Pe.lastIndex,Pe.lastIndex+=1;return Me===0?ve:pe+ve.substring(Me).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*he(te){let de=0;for(const pe of te.matchAll(se))de!==pe.index&&(yield{isCode:!1,str:te.substring(de,pe.index)}),yield{isCode:!0,str:pe[0]},de=pe.index+pe[0].length;de!==te.length&&(yield{isCode:!1,str:te.substring(de)})}function $e(te){return te&&(te=te.replace(se,"")),te}e.$Vf="\uFEFF";function me(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}function ye(te){return me(te)?te.substr(1):te}function ke(te,de){if(!te||!de||te.length<de.length)return!1;const pe=de.length,ve=te.toLowerCase();let Pe=0,Me=-1;for(;Pe<pe;){const ze=ve.indexOf(de[Pe],Me+1);if(ze<0)return!1;Me=ze,Pe++}return!0}function Ee(te,de=!1){return te?(de&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function Oe(te){return te.charAt(0).toUpperCase()+te.slice(1)}function we(te,de=1){if(de===0)return"";let pe=-1;do pe=te.indexOf(`
`,pe+1),de--;while(de>0&&pe>=0);return pe===-1?te:(te[pe-1]==="\r"&&pe--,te.substr(0,pe))}function Y(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}function fe(te){return Re.getInstance().getGraphemeBreakType(te)}function ge(te,de){return te===0?de!==5&&de!==7:te===2&&de===3?!1:te===4||te===2||te===3||de===4||de===2||de===3?!0:!(te===8&&(de===8||de===9||de===11||de===12)||(te===11||te===9)&&(de===9||de===10)||(te===12||te===10)&&de===10||de===5||de===13||de===7||te===1||te===13&&de===14||te===6&&de===6)}var je;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Be()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const pe=this.d,ve=pe.length/3;let Pe=1;for(;Pe<=ve;)if(de<pe[3*Pe])Pe=2*Pe;else if(de>pe[3*Pe+1])Pe=2*Pe+1;else return pe[3*Pe+2];return 0}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(te,de){if(te===0)return 0;const pe=Fe(te,de);if(pe!==void 0)return pe;const ve=new L(de,te);return ve.prevCodePoint(),ve.offset}function Fe(te,de){const pe=new L(de,te);let ve=pe.prevCodePoint();for(;Qe(ve)||ve===65039||ve===8419;){if(pe.offset===0)return;ve=pe.prevCodePoint()}if(!V(ve))return;let Pe=pe.offset;return Pe>0&&pe.prevCodePoint()===8205&&(Pe=pe.offset),Pe}function Qe(te){return 127995<=te&&te<=127999}var He;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),e.$6f="\xA0";class Xe{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$4e({getCacheKey:JSON.stringify},de=>{function pe(Ke){const st=new Map;for(let it=0;it<Ke.length;it+=2)st.set(Ke[it],Ke[it+1]);return st}function ve(Ke,st){const it=new Map(Ke);for(const[ot,at]of st)it.set(ot,at);return it}function Pe(Ke,st){if(!Ke)return st;const it=new Map;for(const[ot,at]of Ke)st.has(ot)&&it.set(ot,at);return it}const Me=this.c.value;let ze=de.filter(Ke=>!Ke.startsWith("_")&&Ke in Me);ze.length===0&&(ze=["_default"]);let Ge;for(const Ke of ze){const st=pe(Me[Ke]);Ge=Pe(Ge,st)}const Ye=pe(Me._common),Ze=ve(Ye,Ge);return new Xe(Ze)})}static getInstance(de){return Xe.d.get(Array.from(de))}static{this.e=new C.$V(()=>Object.keys(Xe.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=Xe;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(de){return Te.e().has(de)}static get codePoints(){return Te.e()}}e.$8f=Te}),define(re[46],oe([0,1,25]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=C,e.$lj=S,e.$mj=R,e.$nj=E,e.$pj=y;function C(g){return S(g,0)}function S(g,l){switch(typeof g){case"object":return g===null?R(349,l):Array.isArray(g)?h(g,l):c(g,l);case"string":return E(g,l);case"boolean":return j(g,l);case"number":return R(g,l);case"undefined":return R(937,l);default:return R(617,l)}}function R(g,l){return(l<<5)-l+g|0}function j(g,l){return R(g?433:863,l)}function E(g,l){l=R(149417,l);for(let w=0,k=g.length;w<k;w++)l=R(g.charCodeAt(w),l);return l}function h(g,l){return l=R(104579,l),g.reduce((w,k)=>S(k,w),l)}function c(g,l){return l=R(181387,l),Object.keys(g).sort().reduce((w,k)=>(w=E(k,w),S(g[k],w)),l)}class d{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=S(l,this.g),this.g}}e.$oj=d;var b;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function v(g,l,w=32){const k=w-l,a=~((1<<k)-1);return(g<<l|(a&g)>>>k)>>>0}function m(g,l=0,w=g.byteLength,k=0){for(let a=0;a<w;a++)g[l+a]=k}function f(g,l,w="0"){for(;g.length<l;)g=w+g;return g}function y(g,l=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(w=>w.toString(16).padStart(2,"0")).join(""):f((g>>>0).toString(16),l/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const w=l.length;if(w===0)return;const k=this.p;let a=this.r,t=this.u,r,s;for(t!==0?(r=t,s=-1,t=0):(r=l.charCodeAt(0),s=0);;){let i=r;if(n.$Cf(r))if(s+1<w){const o=l.charCodeAt(s+1);n.$Df(o)?(s++,i=n.$Ef(r,o)):i=65533}else{t=r;break}else n.$Df(r)&&(i=65533);if(a=this.w(k,a,i),s++,s<w)r=l.charCodeAt(s);else break}this.r=a,this.u=t}w(l,w,k){return k<128?l[w++]=k:k<2048?(l[w++]=192|(k&1984)>>>6,l[w++]=128|(k&63)>>>0):k<65536?(l[w++]=224|(k&61440)>>>12,l[w++]=128|(k&4032)>>>6,l[w++]=128|(k&63)>>>0):(l[w++]=240|(k&1835008)>>>18,l[w++]=128|(k&258048)>>>12,l[w++]=128|(k&4032)>>>6,l[w++]=128|(k&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,l[0]=l[64],l[1]=l[65],l[2]=l[66]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=p.g,w=this.q;for(let $=0;$<64;$+=4)l.setUint32($,w.getUint32($,!1),!1);for(let $=64;$<320;$+=4)l.setUint32($,v(l.getUint32($-12,!1)^l.getUint32($-32,!1)^l.getUint32($-56,!1)^l.getUint32($-64,!1),1),!1);let k=this.h,a=this.l,t=this.m,r=this.n,s=this.o,i,o,u;for(let $=0;$<80;$++)$<20?(i=a&t|~a&r,o=1518500249):$<40?(i=a^t^r,o=1859775393):$<60?(i=a&t|a&r|t&r,o=2400959708):(i=a^t^r,o=3395469782),u=v(k,5)+i+s+o+l.getUint32($*4,!1)&4294967295,s=r,r=t,t=v(a,30),a=k,k=u;this.h=this.h+k&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+s&4294967295}}e.$qj=p}),define(re[74],oe([0,1,25]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(C||(C={})),function(S){const R="error",j="warning",E="warn",h="info",c="ignore";function d(v){return v?n.$yf(R,v)?S.Error:n.$yf(j,v)||n.$yf(E,v)?S.Warning:n.$yf(h,v)?S.Info:S.Ignore:S.Ignore}S.fromValue=d;function b(v){switch(v){case S.Error:return R;case S.Warning:return j;case S.Info:return h;default:return c}}S.toString=b}(C||(C={})),e.default=C}),define(re[144],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(re[59],oe([0,1,22,25]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class S{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const f=m.charCodeAt(0),y=this.b.charCodeAt(this.c);return f-y}value(){return this.b[this.c]}}e.$yi=S;class R{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,C.$sf)(m,this.b,0,m.length,this.c,this.d):(0,C.$uf)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=R;class j{constructor(m=!0,f=!0){this.f=m,this.g=f}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let f=m.length-1;f>=0;f--,this.c--){const y=this.b.charCodeAt(f);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,C.$sf)(m,this.b,0,m.length,this.d,this.e):(0,C.$uf)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=j;var E;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(m,f){this.f=m,this.g=f,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,C.$tf)(m,this.c.scheme);if(this.d[this.e]===2)return(0,C.$tf)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,C.$rf)(m,this.c.query);if(this.d[this.e]===5)return(0,C.$rf)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=h;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(d||(d={}));class b{static forUris(m=()=>!1,f=()=>!1){return new b(new h(m,f))}static forPaths(m=!1){return new b(new j(void 0,!m))}static forStrings(){return new b(new S)}static forConfigKeys(){return new b(new R)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,f){if(f){const y=f.slice(0);(0,n.$Xb)(y);for(const p of y)this.set(p,m)}else{const y=m.slice(0);(0,n.$Xb)(y);for(const p of y)this.set(p[0],p[1])}}set(m,f){const y=this.b.reset(m);let p;this.c||(this.c=new c,this.c.segment=y.value());const g=[];for(p=this.c;;){const w=y.cmp(p.segment);if(w>0)p.left||(p.left=new c,p.left.segment=y.value()),g.push([-1,p]),p=p.left;else if(w<0)p.right||(p.right=new c,p.right.segment=y.value()),g.push([1,p]),p=p.right;else if(y.hasNext())y.next(),p.mid||(p.mid=new c,p.mid.segment=y.value()),g.push([0,p]),p=p.mid;else break}const l=p.value;p.value=f,p.key=m;for(let w=g.length-1;w>=0;w--){const k=g[w][1];k.updateHeight();const a=k.balanceFactor();if(a<-1||a>1){const t=g[w][0],r=g[w+1][0];if(t===1&&r===1)g[w][1]=k.rotateLeft();else if(t===-1&&r===-1)g[w][1]=k.rotateRight();else if(t===1&&r===-1)k.right=g[w+1][1]=g[w+1][1].rotateRight(),g[w][1]=k.rotateLeft();else if(t===-1&&r===1)k.left=g[w+1][1]=g[w+1][1].rotateLeft(),g[w][1]=k.rotateRight();else throw new Error;if(w>0)switch(g[w-1][0]){case-1:g[w-1][1].left=g[w][1];break;case 1:g[w-1][1].right=g[w][1];break;case 0:g[w-1][1].mid=g[w][1];break}else this.c=g[0][1]}}return l}get(m){return this.d(m)?.value}d(m){const f=this.b.reset(m);let y=this.c;for(;y;){const p=f.cmp(y.segment);if(p>0)y=y.left;else if(p<0)y=y.right;else if(f.hasNext())f.next(),y=y.mid;else break}return y}has(m){const f=this.d(m);return!(f?.value===void 0&&f?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,f){const y=this.b.reset(m),p=[];let g=this.c;for(;g;){const l=y.cmp(g.segment);if(l>0)p.push([-1,g]),g=g.left;else if(l<0)p.push([1,g]),g=g.right;else if(y.hasNext())y.next(),p.push([0,g]),g=g.mid;else break}if(g){if(f?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const l=this.f(g.right);if(l.key){const{key:w,value:k,segment:a}=l;this.e(l.key,!1),g.key=w,g.value=k,g.segment=a}}else{const l=g.left??g.right;if(p.length>0){const[w,k]=p[p.length-1];switch(w){case-1:k.left=l;break;case 0:k.mid=l;break;case 1:k.right=l;break}}else this.c=l}for(let l=p.length-1;l>=0;l--){const w=p[l][1];w.updateHeight();const k=w.balanceFactor();if(k>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),p[l][1]=w.rotateLeft()):k<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),p[l][1]=w.rotateRight()),l>0)switch(p[l-1][0]){case-1:p[l-1][1].left=p[l][1];break;case 1:p[l-1][1].right=p[l][1];break;case 0:p[l-1][1].mid=p[l][1];break}else this.c=p[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const f=this.b.reset(m);let y=this.c,p;for(;y;){const g=f.cmp(y.segment);if(g>0)y=y.left;else if(g<0)y=y.right;else if(f.hasNext())f.next(),p=y.value||p,y=y.mid;else break}return y&&y.value||p}findSuperstr(m){return this.g(m,!1)}g(m,f){const y=this.b.reset(m);let p=this.c;for(;p;){const g=y.cmp(p.segment);if(g>0)p=p.left;else if(g<0)p=p.right;else if(y.hasNext())y.next(),p=p.mid;else return p.mid?this.h(p.mid):f?p.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[f,y]of this)m(y,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const f=[];return this.j(m,f),f[Symbol.iterator]()}j(m,f){m&&(m.left&&this.j(m.left,f),m.value&&f.push([m.key,m.value]),m.mid&&this.j(m.mid,f),m.right&&this.j(m.right,f))}_isBalanced(){const m=f=>{if(!f)return!0;const y=f.balanceFactor();return y<-1||y>1?!1:m(f.left)&&m(f.right)};return m(this.c)}}e.$Ci=b}),define(re[12],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=n,e.$0f=C,e.$$f=S,e.$_f=R,e.$ag=j,e.$bg=E,e.$cg=h,e.$dg=c,e.$eg=d,e.$fg=b,e.$gg=v,e.$hg=m,e.$ig=f,e.$jg=p,e.$kg=g,e.$lg=l,e.$mg=w,e.$ng=k;function n(a){return typeof a=="string"}function C(a){return Array.isArray(a)&&a.every(t=>n(t))}function S(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function j(a){return typeof a=="number"&&!isNaN(a)}function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}function h(a){return a===!0||a===!1}function c(a){return typeof a>"u"}function d(a){return!b(a)}function b(a){return c(a)||a===null}function v(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function m(a){if(b(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function f(...a){const t=[];for(let r=0;r<a.length;r++){const s=a[r];if(b(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}const y=Object.prototype.hasOwnProperty;function p(a){if(!S(a))return!1;for(const t in a)if(y.call(a,t))return!1;return!0}function g(a){return typeof a=="function"}function l(...a){return a.length>0&&a.every(g)}function w(a,t){const r=Math.min(a.length,t.length);for(let s=0;s<r;s++)k(a[s],t[s])}function k(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(a instanceof t)return}catch{}if(!b(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(re[105],oe([0,1,12]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=S,e.$Rj=R;const C=Object.create(null);function S(j,E){if((0,n.$9f)(E)){const h=C[E];if(h===void 0)throw new Error(`${j} references an unknown codicon: ${E}`);E=h}return C[j]=E,{id:j}}function R(){return C}}),define(re[145],oe([0,1,105]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0,e.$Sj={add:(0,n.$Qj)("add",6e4),plus:(0,n.$Qj)("plus",6e4),gistNew:(0,n.$Qj)("gist-new",6e4),repoCreate:(0,n.$Qj)("repo-create",6e4),lightbulb:(0,n.$Qj)("lightbulb",60001),lightBulb:(0,n.$Qj)("light-bulb",60001),repo:(0,n.$Qj)("repo",60002),repoDelete:(0,n.$Qj)("repo-delete",60002),gistFork:(0,n.$Qj)("gist-fork",60003),repoForked:(0,n.$Qj)("repo-forked",60003),gitPullRequest:(0,n.$Qj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Qj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Qj)("record-keys",60005),keyboard:(0,n.$Qj)("keyboard",60005),tag:(0,n.$Qj)("tag",60006),gitPullRequestLabel:(0,n.$Qj)("git-pull-request-label",60006),tagAdd:(0,n.$Qj)("tag-add",60006),tagRemove:(0,n.$Qj)("tag-remove",60006),person:(0,n.$Qj)("person",60007),personFollow:(0,n.$Qj)("person-follow",60007),personOutline:(0,n.$Qj)("person-outline",60007),personFilled:(0,n.$Qj)("person-filled",60007),gitBranch:(0,n.$Qj)("git-branch",60008),gitBranchCreate:(0,n.$Qj)("git-branch-create",60008),gitBranchDelete:(0,n.$Qj)("git-branch-delete",60008),sourceControl:(0,n.$Qj)("source-control",60008),mirror:(0,n.$Qj)("mirror",60009),mirrorPublic:(0,n.$Qj)("mirror-public",60009),star:(0,n.$Qj)("star",60010),starAdd:(0,n.$Qj)("star-add",60010),starDelete:(0,n.$Qj)("star-delete",60010),starEmpty:(0,n.$Qj)("star-empty",60010),comment:(0,n.$Qj)("comment",60011),commentAdd:(0,n.$Qj)("comment-add",60011),alert:(0,n.$Qj)("alert",60012),warning:(0,n.$Qj)("warning",60012),search:(0,n.$Qj)("search",60013),searchSave:(0,n.$Qj)("search-save",60013),logOut:(0,n.$Qj)("log-out",60014),signOut:(0,n.$Qj)("sign-out",60014),logIn:(0,n.$Qj)("log-in",60015),signIn:(0,n.$Qj)("sign-in",60015),eye:(0,n.$Qj)("eye",60016),eyeUnwatch:(0,n.$Qj)("eye-unwatch",60016),eyeWatch:(0,n.$Qj)("eye-watch",60016),circleFilled:(0,n.$Qj)("circle-filled",60017),primitiveDot:(0,n.$Qj)("primitive-dot",60017),closeDirty:(0,n.$Qj)("close-dirty",60017),debugBreakpoint:(0,n.$Qj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Qj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Qj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Qj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Qj)("primitive-square",60018),edit:(0,n.$Qj)("edit",60019),pencil:(0,n.$Qj)("pencil",60019),info:(0,n.$Qj)("info",60020),issueOpened:(0,n.$Qj)("issue-opened",60020),gistPrivate:(0,n.$Qj)("gist-private",60021),gitForkPrivate:(0,n.$Qj)("git-fork-private",60021),lock:(0,n.$Qj)("lock",60021),mirrorPrivate:(0,n.$Qj)("mirror-private",60021),close:(0,n.$Qj)("close",60022),removeClose:(0,n.$Qj)("remove-close",60022),x:(0,n.$Qj)("x",60022),repoSync:(0,n.$Qj)("repo-sync",60023),sync:(0,n.$Qj)("sync",60023),clone:(0,n.$Qj)("clone",60024),desktopDownload:(0,n.$Qj)("desktop-download",60024),beaker:(0,n.$Qj)("beaker",60025),microscope:(0,n.$Qj)("microscope",60025),vm:(0,n.$Qj)("vm",60026),deviceDesktop:(0,n.$Qj)("device-desktop",60026),file:(0,n.$Qj)("file",60027),fileText:(0,n.$Qj)("file-text",60027),more:(0,n.$Qj)("more",60028),ellipsis:(0,n.$Qj)("ellipsis",60028),kebabHorizontal:(0,n.$Qj)("kebab-horizontal",60028),mailReply:(0,n.$Qj)("mail-reply",60029),reply:(0,n.$Qj)("reply",60029),organization:(0,n.$Qj)("organization",60030),organizationFilled:(0,n.$Qj)("organization-filled",60030),organizationOutline:(0,n.$Qj)("organization-outline",60030),newFile:(0,n.$Qj)("new-file",60031),fileAdd:(0,n.$Qj)("file-add",60031),newFolder:(0,n.$Qj)("new-folder",60032),fileDirectoryCreate:(0,n.$Qj)("file-directory-create",60032),trash:(0,n.$Qj)("trash",60033),trashcan:(0,n.$Qj)("trashcan",60033),history:(0,n.$Qj)("history",60034),clock:(0,n.$Qj)("clock",60034),folder:(0,n.$Qj)("folder",60035),fileDirectory:(0,n.$Qj)("file-directory",60035),symbolFolder:(0,n.$Qj)("symbol-folder",60035),logoGithub:(0,n.$Qj)("logo-github",60036),markGithub:(0,n.$Qj)("mark-github",60036),github:(0,n.$Qj)("github",60036),terminal:(0,n.$Qj)("terminal",60037),console:(0,n.$Qj)("console",60037),repl:(0,n.$Qj)("repl",60037),zap:(0,n.$Qj)("zap",60038),symbolEvent:(0,n.$Qj)("symbol-event",60038),error:(0,n.$Qj)("error",60039),stop:(0,n.$Qj)("stop",60039),variable:(0,n.$Qj)("variable",60040),symbolVariable:(0,n.$Qj)("symbol-variable",60040),array:(0,n.$Qj)("array",60042),symbolArray:(0,n.$Qj)("symbol-array",60042),symbolModule:(0,n.$Qj)("symbol-module",60043),symbolPackage:(0,n.$Qj)("symbol-package",60043),symbolNamespace:(0,n.$Qj)("symbol-namespace",60043),symbolObject:(0,n.$Qj)("symbol-object",60043),symbolMethod:(0,n.$Qj)("symbol-method",60044),symbolFunction:(0,n.$Qj)("symbol-function",60044),symbolConstructor:(0,n.$Qj)("symbol-constructor",60044),symbolBoolean:(0,n.$Qj)("symbol-boolean",60047),symbolNull:(0,n.$Qj)("symbol-null",60047),symbolNumeric:(0,n.$Qj)("symbol-numeric",60048),symbolNumber:(0,n.$Qj)("symbol-number",60048),symbolStructure:(0,n.$Qj)("symbol-structure",60049),symbolStruct:(0,n.$Qj)("symbol-struct",60049),symbolParameter:(0,n.$Qj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Qj)("symbol-type-parameter",60050),symbolKey:(0,n.$Qj)("symbol-key",60051),symbolText:(0,n.$Qj)("symbol-text",60051),symbolReference:(0,n.$Qj)("symbol-reference",60052),goToFile:(0,n.$Qj)("go-to-file",60052),symbolEnum:(0,n.$Qj)("symbol-enum",60053),symbolValue:(0,n.$Qj)("symbol-value",60053),symbolRuler:(0,n.$Qj)("symbol-ruler",60054),symbolUnit:(0,n.$Qj)("symbol-unit",60054),activateBreakpoints:(0,n.$Qj)("activate-breakpoints",60055),archive:(0,n.$Qj)("archive",60056),arrowBoth:(0,n.$Qj)("arrow-both",60057),arrowDown:(0,n.$Qj)("arrow-down",60058),arrowLeft:(0,n.$Qj)("arrow-left",60059),arrowRight:(0,n.$Qj)("arrow-right",60060),arrowSmallDown:(0,n.$Qj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Qj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Qj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Qj)("arrow-small-up",60064),arrowUp:(0,n.$Qj)("arrow-up",60065),bell:(0,n.$Qj)("bell",60066),bold:(0,n.$Qj)("bold",60067),book:(0,n.$Qj)("book",60068),bookmark:(0,n.$Qj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Qj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Qj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Qj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Qj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Qj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Qj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Qj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Qj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Qj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Qj)("briefcase",60076),broadcast:(0,n.$Qj)("broadcast",60077),browser:(0,n.$Qj)("browser",60078),bug:(0,n.$Qj)("bug",60079),calendar:(0,n.$Qj)("calendar",60080),caseSensitive:(0,n.$Qj)("case-sensitive",60081),check:(0,n.$Qj)("check",60082),checklist:(0,n.$Qj)("checklist",60083),chevronDown:(0,n.$Qj)("chevron-down",60084),chevronLeft:(0,n.$Qj)("chevron-left",60085),chevronRight:(0,n.$Qj)("chevron-right",60086),chevronUp:(0,n.$Qj)("chevron-up",60087),chromeClose:(0,n.$Qj)("chrome-close",60088),chromeMaximize:(0,n.$Qj)("chrome-maximize",60089),chromeMinimize:(0,n.$Qj)("chrome-minimize",60090),chromeRestore:(0,n.$Qj)("chrome-restore",60091),circleOutline:(0,n.$Qj)("circle-outline",60092),circle:(0,n.$Qj)("circle",60092),debugBreakpointUnverified:(0,n.$Qj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Qj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Qj)("circle-slash",60093),circuitBoard:(0,n.$Qj)("circuit-board",60094),clearAll:(0,n.$Qj)("clear-all",60095),clippy:(0,n.$Qj)("clippy",60096),closeAll:(0,n.$Qj)("close-all",60097),cloudDownload:(0,n.$Qj)("cloud-download",60098),cloudUpload:(0,n.$Qj)("cloud-upload",60099),code:(0,n.$Qj)("code",60100),collapseAll:(0,n.$Qj)("collapse-all",60101),colorMode:(0,n.$Qj)("color-mode",60102),commentDiscussion:(0,n.$Qj)("comment-discussion",60103),creditCard:(0,n.$Qj)("credit-card",60105),dash:(0,n.$Qj)("dash",60108),dashboard:(0,n.$Qj)("dashboard",60109),database:(0,n.$Qj)("database",60110),debugContinue:(0,n.$Qj)("debug-continue",60111),debugDisconnect:(0,n.$Qj)("debug-disconnect",60112),debugPause:(0,n.$Qj)("debug-pause",60113),debugRestart:(0,n.$Qj)("debug-restart",60114),debugStart:(0,n.$Qj)("debug-start",60115),debugStepInto:(0,n.$Qj)("debug-step-into",60116),debugStepOut:(0,n.$Qj)("debug-step-out",60117),debugStepOver:(0,n.$Qj)("debug-step-over",60118),debugStop:(0,n.$Qj)("debug-stop",60119),debug:(0,n.$Qj)("debug",60120),deviceCameraVideo:(0,n.$Qj)("device-camera-video",60121),deviceCamera:(0,n.$Qj)("device-camera",60122),deviceMobile:(0,n.$Qj)("device-mobile",60123),diffAdded:(0,n.$Qj)("diff-added",60124),diffIgnored:(0,n.$Qj)("diff-ignored",60125),diffModified:(0,n.$Qj)("diff-modified",60126),diffRemoved:(0,n.$Qj)("diff-removed",60127),diffRenamed:(0,n.$Qj)("diff-renamed",60128),diff:(0,n.$Qj)("diff",60129),diffSidebyside:(0,n.$Qj)("diff-sidebyside",60129),discard:(0,n.$Qj)("discard",60130),editorLayout:(0,n.$Qj)("editor-layout",60131),emptyWindow:(0,n.$Qj)("empty-window",60132),exclude:(0,n.$Qj)("exclude",60133),extensions:(0,n.$Qj)("extensions",60134),eyeClosed:(0,n.$Qj)("eye-closed",60135),fileBinary:(0,n.$Qj)("file-binary",60136),fileCode:(0,n.$Qj)("file-code",60137),fileMedia:(0,n.$Qj)("file-media",60138),filePdf:(0,n.$Qj)("file-pdf",60139),fileSubmodule:(0,n.$Qj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Qj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Qj)("file-symlink-file",60142),fileZip:(0,n.$Qj)("file-zip",60143),files:(0,n.$Qj)("files",60144),filter:(0,n.$Qj)("filter",60145),flame:(0,n.$Qj)("flame",60146),foldDown:(0,n.$Qj)("fold-down",60147),foldUp:(0,n.$Qj)("fold-up",60148),fold:(0,n.$Qj)("fold",60149),folderActive:(0,n.$Qj)("folder-active",60150),folderOpened:(0,n.$Qj)("folder-opened",60151),gear:(0,n.$Qj)("gear",60152),gift:(0,n.$Qj)("gift",60153),gistSecret:(0,n.$Qj)("gist-secret",60154),gist:(0,n.$Qj)("gist",60155),gitCommit:(0,n.$Qj)("git-commit",60156),gitCompare:(0,n.$Qj)("git-compare",60157),compareChanges:(0,n.$Qj)("compare-changes",60157),gitMerge:(0,n.$Qj)("git-merge",60158),githubAction:(0,n.$Qj)("github-action",60159),githubAlt:(0,n.$Qj)("github-alt",60160),globe:(0,n.$Qj)("globe",60161),grabber:(0,n.$Qj)("grabber",60162),graph:(0,n.$Qj)("graph",60163),gripper:(0,n.$Qj)("gripper",60164),heart:(0,n.$Qj)("heart",60165),home:(0,n.$Qj)("home",60166),horizontalRule:(0,n.$Qj)("horizontal-rule",60167),hubot:(0,n.$Qj)("hubot",60168),inbox:(0,n.$Qj)("inbox",60169),issueReopened:(0,n.$Qj)("issue-reopened",60171),issues:(0,n.$Qj)("issues",60172),italic:(0,n.$Qj)("italic",60173),jersey:(0,n.$Qj)("jersey",60174),json:(0,n.$Qj)("json",60175),kebabVertical:(0,n.$Qj)("kebab-vertical",60176),key:(0,n.$Qj)("key",60177),law:(0,n.$Qj)("law",60178),lightbulbAutofix:(0,n.$Qj)("lightbulb-autofix",60179),linkExternal:(0,n.$Qj)("link-external",60180),link:(0,n.$Qj)("link",60181),listOrdered:(0,n.$Qj)("list-ordered",60182),listUnordered:(0,n.$Qj)("list-unordered",60183),liveShare:(0,n.$Qj)("live-share",60184),loading:(0,n.$Qj)("loading",60185),location:(0,n.$Qj)("location",60186),mailRead:(0,n.$Qj)("mail-read",60187),mail:(0,n.$Qj)("mail",60188),markdown:(0,n.$Qj)("markdown",60189),megaphone:(0,n.$Qj)("megaphone",60190),mention:(0,n.$Qj)("mention",60191),milestone:(0,n.$Qj)("milestone",60192),gitPullRequestMilestone:(0,n.$Qj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Qj)("mortar-board",60193),move:(0,n.$Qj)("move",60194),multipleWindows:(0,n.$Qj)("multiple-windows",60195),mute:(0,n.$Qj)("mute",60196),noNewline:(0,n.$Qj)("no-newline",60197),note:(0,n.$Qj)("note",60198),octoface:(0,n.$Qj)("octoface",60199),openPreview:(0,n.$Qj)("open-preview",60200),package:(0,n.$Qj)("package",60201),paintcan:(0,n.$Qj)("paintcan",60202),pin:(0,n.$Qj)("pin",60203),play:(0,n.$Qj)("play",60204),run:(0,n.$Qj)("run",60204),plug:(0,n.$Qj)("plug",60205),preserveCase:(0,n.$Qj)("preserve-case",60206),preview:(0,n.$Qj)("preview",60207),project:(0,n.$Qj)("project",60208),pulse:(0,n.$Qj)("pulse",60209),question:(0,n.$Qj)("question",60210),quote:(0,n.$Qj)("quote",60211),radioTower:(0,n.$Qj)("radio-tower",60212),reactions:(0,n.$Qj)("reactions",60213),references:(0,n.$Qj)("references",60214),refresh:(0,n.$Qj)("refresh",60215),regex:(0,n.$Qj)("regex",60216),remoteExplorer:(0,n.$Qj)("remote-explorer",60217),remote:(0,n.$Qj)("remote",60218),remove:(0,n.$Qj)("remove",60219),replaceAll:(0,n.$Qj)("replace-all",60220),replace:(0,n.$Qj)("replace",60221),repoClone:(0,n.$Qj)("repo-clone",60222),repoForcePush:(0,n.$Qj)("repo-force-push",60223),repoPull:(0,n.$Qj)("repo-pull",60224),repoPush:(0,n.$Qj)("repo-push",60225),report:(0,n.$Qj)("report",60226),requestChanges:(0,n.$Qj)("request-changes",60227),rocket:(0,n.$Qj)("rocket",60228),rootFolderOpened:(0,n.$Qj)("root-folder-opened",60229),rootFolder:(0,n.$Qj)("root-folder",60230),rss:(0,n.$Qj)("rss",60231),ruby:(0,n.$Qj)("ruby",60232),saveAll:(0,n.$Qj)("save-all",60233),saveAs:(0,n.$Qj)("save-as",60234),save:(0,n.$Qj)("save",60235),screenFull:(0,n.$Qj)("screen-full",60236),screenNormal:(0,n.$Qj)("screen-normal",60237),searchStop:(0,n.$Qj)("search-stop",60238),server:(0,n.$Qj)("server",60240),settingsGear:(0,n.$Qj)("settings-gear",60241),settings:(0,n.$Qj)("settings",60242),shield:(0,n.$Qj)("shield",60243),smiley:(0,n.$Qj)("smiley",60244),sortPrecedence:(0,n.$Qj)("sort-precedence",60245),splitHorizontal:(0,n.$Qj)("split-horizontal",60246),splitVertical:(0,n.$Qj)("split-vertical",60247),squirrel:(0,n.$Qj)("squirrel",60248),starFull:(0,n.$Qj)("star-full",60249),starHalf:(0,n.$Qj)("star-half",60250),symbolClass:(0,n.$Qj)("symbol-class",60251),symbolColor:(0,n.$Qj)("symbol-color",60252),symbolConstant:(0,n.$Qj)("symbol-constant",60253),symbolEnumMember:(0,n.$Qj)("symbol-enum-member",60254),symbolField:(0,n.$Qj)("symbol-field",60255),symbolFile:(0,n.$Qj)("symbol-file",60256),symbolInterface:(0,n.$Qj)("symbol-interface",60257),symbolKeyword:(0,n.$Qj)("symbol-keyword",60258),symbolMisc:(0,n.$Qj)("symbol-misc",60259),symbolOperator:(0,n.$Qj)("symbol-operator",60260),symbolProperty:(0,n.$Qj)("symbol-property",60261),wrench:(0,n.$Qj)("wrench",60261),wrenchSubaction:(0,n.$Qj)("wrench-subaction",60261),symbolSnippet:(0,n.$Qj)("symbol-snippet",60262),tasklist:(0,n.$Qj)("tasklist",60263),telescope:(0,n.$Qj)("telescope",60264),textSize:(0,n.$Qj)("text-size",60265),threeBars:(0,n.$Qj)("three-bars",60266),thumbsdown:(0,n.$Qj)("thumbsdown",60267),thumbsup:(0,n.$Qj)("thumbsup",60268),tools:(0,n.$Qj)("tools",60269),triangleDown:(0,n.$Qj)("triangle-down",60270),triangleLeft:(0,n.$Qj)("triangle-left",60271),triangleRight:(0,n.$Qj)("triangle-right",60272),triangleUp:(0,n.$Qj)("triangle-up",60273),twitter:(0,n.$Qj)("twitter",60274),unfold:(0,n.$Qj)("unfold",60275),unlock:(0,n.$Qj)("unlock",60276),unmute:(0,n.$Qj)("unmute",60277),unverified:(0,n.$Qj)("unverified",60278),verified:(0,n.$Qj)("verified",60279),versions:(0,n.$Qj)("versions",60280),vmActive:(0,n.$Qj)("vm-active",60281),vmOutline:(0,n.$Qj)("vm-outline",60282),vmRunning:(0,n.$Qj)("vm-running",60283),watch:(0,n.$Qj)("watch",60284),whitespace:(0,n.$Qj)("whitespace",60285),wholeWord:(0,n.$Qj)("whole-word",60286),window:(0,n.$Qj)("window",60287),wordWrap:(0,n.$Qj)("word-wrap",60288),zoomIn:(0,n.$Qj)("zoom-in",60289),zoomOut:(0,n.$Qj)("zoom-out",60290),listFilter:(0,n.$Qj)("list-filter",60291),listFlat:(0,n.$Qj)("list-flat",60292),listSelection:(0,n.$Qj)("list-selection",60293),selection:(0,n.$Qj)("selection",60293),listTree:(0,n.$Qj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Qj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Qj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Qj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Qj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Qj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Qj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Qj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Qj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Qj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Qj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Qj)("symbol-string",60301),debugReverseContinue:(0,n.$Qj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Qj)("debug-step-back",60303),debugRestartFrame:(0,n.$Qj)("debug-restart-frame",60304),debugAlt:(0,n.$Qj)("debug-alt",60305),callIncoming:(0,n.$Qj)("call-incoming",60306),callOutgoing:(0,n.$Qj)("call-outgoing",60307),menu:(0,n.$Qj)("menu",60308),expandAll:(0,n.$Qj)("expand-all",60309),feedback:(0,n.$Qj)("feedback",60310),gitPullRequestReviewer:(0,n.$Qj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Qj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Qj)("ungroup-by-ref-type",60312),account:(0,n.$Qj)("account",60313),gitPullRequestAssignee:(0,n.$Qj)("git-pull-request-assignee",60313),bellDot:(0,n.$Qj)("bell-dot",60314),debugConsole:(0,n.$Qj)("debug-console",60315),library:(0,n.$Qj)("library",60316),output:(0,n.$Qj)("output",60317),runAll:(0,n.$Qj)("run-all",60318),syncIgnored:(0,n.$Qj)("sync-ignored",60319),pinned:(0,n.$Qj)("pinned",60320),githubInverted:(0,n.$Qj)("github-inverted",60321),serverProcess:(0,n.$Qj)("server-process",60322),serverEnvironment:(0,n.$Qj)("server-environment",60323),pass:(0,n.$Qj)("pass",60324),issueClosed:(0,n.$Qj)("issue-closed",60324),stopCircle:(0,n.$Qj)("stop-circle",60325),playCircle:(0,n.$Qj)("play-circle",60326),record:(0,n.$Qj)("record",60327),debugAltSmall:(0,n.$Qj)("debug-alt-small",60328),vmConnect:(0,n.$Qj)("vm-connect",60329),cloud:(0,n.$Qj)("cloud",60330),merge:(0,n.$Qj)("merge",60331),export:(0,n.$Qj)("export",60332),graphLeft:(0,n.$Qj)("graph-left",60333),magnet:(0,n.$Qj)("magnet",60334),notebook:(0,n.$Qj)("notebook",60335),redo:(0,n.$Qj)("redo",60336),checkAll:(0,n.$Qj)("check-all",60337),pinnedDirty:(0,n.$Qj)("pinned-dirty",60338),passFilled:(0,n.$Qj)("pass-filled",60339),circleLargeFilled:(0,n.$Qj)("circle-large-filled",60340),circleLarge:(0,n.$Qj)("circle-large",60341),circleLargeOutline:(0,n.$Qj)("circle-large-outline",60341),combine:(0,n.$Qj)("combine",60342),gather:(0,n.$Qj)("gather",60342),table:(0,n.$Qj)("table",60343),variableGroup:(0,n.$Qj)("variable-group",60344),typeHierarchy:(0,n.$Qj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Qj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Qj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Qj)("git-pull-request-create",60348),runAbove:(0,n.$Qj)("run-above",60349),runBelow:(0,n.$Qj)("run-below",60350),notebookTemplate:(0,n.$Qj)("notebook-template",60351),debugRerun:(0,n.$Qj)("debug-rerun",60352),workspaceTrusted:(0,n.$Qj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Qj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Qj)("workspace-unknown",60355),terminalCmd:(0,n.$Qj)("terminal-cmd",60356),terminalDebian:(0,n.$Qj)("terminal-debian",60357),terminalLinux:(0,n.$Qj)("terminal-linux",60358),terminalPowershell:(0,n.$Qj)("terminal-powershell",60359),terminalTmux:(0,n.$Qj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Qj)("terminal-ubuntu",60361),terminalBash:(0,n.$Qj)("terminal-bash",60362),arrowSwap:(0,n.$Qj)("arrow-swap",60363),copy:(0,n.$Qj)("copy",60364),personAdd:(0,n.$Qj)("person-add",60365),filterFilled:(0,n.$Qj)("filter-filled",60366),wand:(0,n.$Qj)("wand",60367),debugLineByLine:(0,n.$Qj)("debug-line-by-line",60368),inspect:(0,n.$Qj)("inspect",60369),layers:(0,n.$Qj)("layers",60370),layersDot:(0,n.$Qj)("layers-dot",60371),layersActive:(0,n.$Qj)("layers-active",60372),compass:(0,n.$Qj)("compass",60373),compassDot:(0,n.$Qj)("compass-dot",60374),compassActive:(0,n.$Qj)("compass-active",60375),azure:(0,n.$Qj)("azure",60376),issueDraft:(0,n.$Qj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Qj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Qj)("git-pull-request-draft",60379),debugAll:(0,n.$Qj)("debug-all",60380),debugCoverage:(0,n.$Qj)("debug-coverage",60381),runErrors:(0,n.$Qj)("run-errors",60382),folderLibrary:(0,n.$Qj)("folder-library",60383),debugContinueSmall:(0,n.$Qj)("debug-continue-small",60384),beakerStop:(0,n.$Qj)("beaker-stop",60385),graphLine:(0,n.$Qj)("graph-line",60386),graphScatter:(0,n.$Qj)("graph-scatter",60387),pieChart:(0,n.$Qj)("pie-chart",60388),bracket:(0,n.$Qj)("bracket",60175),bracketDot:(0,n.$Qj)("bracket-dot",60389),bracketError:(0,n.$Qj)("bracket-error",60390),lockSmall:(0,n.$Qj)("lock-small",60391),azureDevops:(0,n.$Qj)("azure-devops",60392),verifiedFilled:(0,n.$Qj)("verified-filled",60393),newline:(0,n.$Qj)("newline",60394),layout:(0,n.$Qj)("layout",60395),layoutActivitybarLeft:(0,n.$Qj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Qj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Qj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Qj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Qj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Qj)("layout-panel-right",60401),layoutPanel:(0,n.$Qj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Qj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Qj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Qj)("layout-statusbar",60405),layoutMenubar:(0,n.$Qj)("layout-menubar",60406),layoutCentered:(0,n.$Qj)("layout-centered",60407),target:(0,n.$Qj)("target",60408),indent:(0,n.$Qj)("indent",60409),recordSmall:(0,n.$Qj)("record-small",60410),errorSmall:(0,n.$Qj)("error-small",60411),terminalDecorationError:(0,n.$Qj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Qj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Qj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Qj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Qj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Qj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Qj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Qj)("layout-sidebar-left-off",60418),blank:(0,n.$Qj)("blank",60419),heartFilled:(0,n.$Qj)("heart-filled",60420),map:(0,n.$Qj)("map",60421),mapHorizontal:(0,n.$Qj)("map-horizontal",60421),foldHorizontal:(0,n.$Qj)("fold-horizontal",60421),mapFilled:(0,n.$Qj)("map-filled",60422),mapHorizontalFilled:(0,n.$Qj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Qj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Qj)("circle-small",60423),bellSlash:(0,n.$Qj)("bell-slash",60424),bellSlashDot:(0,n.$Qj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Qj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Qj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Qj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Qj)("search-fuzzy",60429),commentDraft:(0,n.$Qj)("comment-draft",60430),send:(0,n.$Qj)("send",60431),sparkle:(0,n.$Qj)("sparkle",60432),insert:(0,n.$Qj)("insert",60433),mic:(0,n.$Qj)("mic",60434),thumbsdownFilled:(0,n.$Qj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Qj)("thumbsup-filled",60436),coffee:(0,n.$Qj)("coffee",60437),snake:(0,n.$Qj)("snake",60438),game:(0,n.$Qj)("game",60439),vr:(0,n.$Qj)("vr",60440),chip:(0,n.$Qj)("chip",60441),piano:(0,n.$Qj)("piano",60442),music:(0,n.$Qj)("music",60443),micFilled:(0,n.$Qj)("mic-filled",60444),repoFetch:(0,n.$Qj)("repo-fetch",60445),copilot:(0,n.$Qj)("copilot",60446),lightbulbSparkle:(0,n.$Qj)("lightbulb-sparkle",60447),robot:(0,n.$Qj)("robot",60448),sparkleFilled:(0,n.$Qj)("sparkle-filled",60449),diffSingle:(0,n.$Qj)("diff-single",60450),diffMultiple:(0,n.$Qj)("diff-multiple",60451),surroundWith:(0,n.$Qj)("surround-with",60452),share:(0,n.$Qj)("share",60453),gitStash:(0,n.$Qj)("git-stash",60454),gitStashApply:(0,n.$Qj)("git-stash-apply",60455),gitStashPop:(0,n.$Qj)("git-stash-pop",60456),vscode:(0,n.$Qj)("vscode",60457),vscodeInsiders:(0,n.$Qj)("vscode-insiders",60458),codeOss:(0,n.$Qj)("code-oss",60459),runCoverage:(0,n.$Qj)("run-coverage",60460),runAllCoverage:(0,n.$Qj)("run-all-coverage",60461),coverage:(0,n.$Qj)("coverage",60462),githubProject:(0,n.$Qj)("github-project",60463),mapVertical:(0,n.$Qj)("map-vertical",60464),foldVertical:(0,n.$Qj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Qj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Qj)("fold-vertical-filled",60465),goToSearch:(0,n.$Qj)("go-to-search",60466),percentage:(0,n.$Qj)("percentage",60467),sortPercentage:(0,n.$Qj)("sort-percentage",60467)}}),define(re[75],oe([0,1,105,145]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=void 0,e.$Tj=S;function S(){return Object.values(e.$Vj)}e.$Uj={dialogError:(0,n.$Qj)("dialog-error","error"),dialogWarning:(0,n.$Qj)("dialog-warning","warning"),dialogInfo:(0,n.$Qj)("dialog-info","info"),dialogClose:(0,n.$Qj)("dialog-close","close"),treeItemExpanded:(0,n.$Qj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Qj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Qj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Qj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Qj)("tree-item-loading","loading"),menuSelection:(0,n.$Qj)("menu-selection","check"),menuSubmenu:(0,n.$Qj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Qj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Qj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Qj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Qj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Qj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Qj)("toolbar-more","more"),quickInputBack:(0,n.$Qj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Qj)("drop-down-button",60084),symbolCustomColor:(0,n.$Qj)("symbol-customcolor",60252),exportIcon:(0,n.$Qj)("export",60332),workspaceUnspecified:(0,n.$Qj)("workspace-unspecified",60355),newLine:(0,n.$Qj)("newline",60394),thumbsDownFilled:(0,n.$Qj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Qj)("thumbsup-filled",60436),gitFetch:(0,n.$Qj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Qj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Qj)("debug-breakpoint-pending",60377)},e.$Vj={...C.$Sj,...e.$Uj}}),define(re[35],oe([0,1,12]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=C,e.$4n=S,e.$5n=j,e.$6n=h,e.$7n=c,e.$8n=d,e.$9n=b,e.$0n=v,e.$$n=m,e.$_n=f,e.$ao=y,e.$bo=p;function C(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const l=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([w,k])=>{l[w]=k&&typeof k=="object"?C(k):k}),l}function S(g){if(!g||typeof g!="object")return g;const l=[g];for(;l.length>0;){const w=l.shift();Object.freeze(w);for(const k in w)if(R.call(w,k)){const a=w[k];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.$_f)(a)&&l.push(a)}}return g}const R=Object.prototype.hasOwnProperty;function j(g,l){return E(g,l,new Set)}function E(g,l,w){if((0,n.$fg)(g))return g;const k=l(g);if(typeof k<"u")return k;if(Array.isArray(g)){const a=[];for(const t of g)a.push(E(t,l,w));return a}if((0,n.$$f)(g)){if(w.has(g))throw new Error("Cannot clone recursive data-structure");w.add(g);const a={};for(const t in g)R.call(g,t)&&(a[t]=E(g[t],l,w));return w.delete(g),a}return g}function h(g,l,w=!0){return(0,n.$$f)(g)?((0,n.$$f)(l)&&Object.keys(l).forEach(k=>{k in g?w&&((0,n.$$f)(g[k])&&(0,n.$$f)(l[k])?h(g[k],l[k],w):g[k]=l[k]):g[k]=l[k]}),g):l}function c(g,l){if(g===l)return!0;if(g==null||l===null||l===void 0||typeof g!=typeof l||typeof g!="object"||Array.isArray(g)!==Array.isArray(l))return!1;let w,k;if(Array.isArray(g)){if(g.length!==l.length)return!1;for(w=0;w<g.length;w++)if(!c(g[w],l[w]))return!1}else{const a=[];for(k in g)a.push(k);a.sort();const t=[];for(k in l)t.push(k);if(t.sort(),!c(a,t))return!1;for(w=0;w<a.length;w++)if(!c(g[a[w]],l[a[w]]))return!1}return!0}function d(g){const l=new Set;return JSON.stringify(g,(w,k)=>{if((0,n.$$f)(k)||Array.isArray(k)){if(l.has(k))return"[Circular]";l.add(k)}return typeof k=="bigint"?`[BigInt ${k.toString()}]`:k})}function b(g,l){const w=Object.create(null);return!g||!l||Object.keys(l).forEach(a=>{const t=g[a],r=l[a];c(t,r)||(w[a]=r)}),w}function v(g,l){const w=l.toLowerCase(),k=Object.keys(g).find(a=>a.toLowerCase()===w);return k?g[k]:g[l]}function m(g,l){const w=Object.create(null);for(const[k,a]of Object.entries(g))l(k,a)&&(w[k]=a);return w}function f(g){let l=[];for(;Object.prototype!==g;)l=l.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return l}function y(g){const l=[];for(const w of f(g))typeof g[w]=="function"&&l.push(w);return l}function p(g,l){const w=a=>function(){const t=Array.prototype.slice.call(arguments,0);return l(a,t)},k={};for(const a of g)k[a]=w(a);return k}}),define(re[106],oe([0,1,75]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=S;var C;(function(j){function E(h){return h&&typeof h=="object"&&typeof h.id=="string"}j.isThemeColor=E})(C||(e.ThemeColor=C={}));function S(j){return{id:j}}var R;(function(j){j.iconNameSegment="[A-Za-z0-9]+",j.iconNameExpression="[A-Za-z0-9-]+",j.iconModifierExpression="~[A-Za-z]+",j.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${j.iconNameExpression})(${j.iconModifierExpression})?$`);function h(l){const w=E.exec(l.id);if(!w)return h(n.$Vj.error);const[,k,a]=w,t=["codicon","codicon-"+k];return a&&t.push("codicon-modifier-"+a.substring(1)),t}j.asClassNameArray=h;function c(l){return h(l).join(" ")}j.asClassName=c;function d(l){return"."+h(l).join(".")}j.asCSSSelector=d;function b(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||C.isThemeColor(l.color))}j.isThemeIcon=b;const v=new RegExp(`^\\$\\((${j.iconNameExpression}(?:${j.iconModifierExpression})?)\\)$`);function m(l){const w=v.exec(l);if(!w)return;const[,k]=w;return{id:k}}j.fromString=m;function f(l){return{id:l}}j.fromId=f;function y(l,w){let k=l.id;const a=k.lastIndexOf("~");return a!==-1&&(k=k.substring(0,a)),w&&(k=`${k}~${w}`),{id:k}}j.modify=y;function p(l){const w=l.id.lastIndexOf("~");if(w!==-1)return l.id.substring(w+1)}j.getModifier=p;function g(l,w){return l.id===w.id&&l.color?.id===w.color?.id}j.isEqual=g})(R||(e.ThemeIcon=R={}))}),define(re[33],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=C;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(S){return n.test(S)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(E){for(let h=0;h<E.length;h++)E[h]=Math.floor(Math.random()*256);return E};const R=new Uint8Array(16),j=[];for(let E=0;E<256;E++)j.push(E.toString(16).padStart(2,"0"));return function(){S(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,c="";return c+=j[R[h++]],c+=j[R[h++]],c+=j[R[h++]],c+=j[R[h++]],c+="-",c+=j[R[h++]],c+=j[R[h++]],c+="-",c+=j[R[h++]],c+=j[R[h++]],c+="-",c+=j[R[h++]],c+=j[R[h++]],c+="-",c+=j[R[h++]],c+=j[R[h++]],c+=j[R[h++]],c+=j[R[h++]],c+=j[R[h++]],c+=j[R[h++]],c}}()}),define(re[146],oe([0,1,87,43,86]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OW=R;async function R(j,E){if(await new Promise((d,b)=>{const v=C.createReadStream(j),m=n.createHash("sha256");v.pipe(m);const f=(0,S.$db)((y,p)=>{v.removeAllListeners(),m.removeAllListeners(),y?b(y):d(p)});v.once("error",f),v.once("end",f),m.once("error",f),m.once("data",y=>f(void 0,y.toString("hex")))})!==E)throw new Error("Hash mismatch")}}),define(re[147],oe([0,1,26]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=R;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(j){const E=j.replace(/\-/g,":").toLowerCase();return!C.has(E)}function R(){const j=(0,n.networkInterfaces)();for(const E in j){const h=j[E];if(h){for(const{mac:c}of h)if(S(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(re[107],oe([0,1,88]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=void 0,e.$Ug=C,e.$Wg=R;function C(E,h,c,d=1){let b=!1;return new Promise(v=>{const m=setTimeout(()=>{if(!b)return b=!0,v(0)},c);S(E,h,d,f=>{if(!b)return b=!0,clearTimeout(m),v(f)})})}function S(E,h,c,d){if(h===0)return d(0);const b=new n.Socket;b.once("connect",()=>(j(b),S(E+c,h-1,c,d))),b.once("data",()=>{}),b.once("error",v=>(j(b),v.code!=="ECONNREFUSED"?S(E+c,h-1,c,d):d(E))),b.connect(E,"127.0.0.1")}e.$Vg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(E,h,c,d="127.0.0.1"){let b=!1,v,m=1;const f=n.createServer({pauseOnConnect:!0});function y(p,g){b||(b=!0,f.removeAllListeners(),f.close(),v&&clearTimeout(v),g(p))}return new Promise(p=>{v=setTimeout(()=>{y(0,p)},c),f.on("listening",()=>{y(E,p)}),f.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&m<h?(E++,m++,f.listen(E,d)):y(0,p)}),f.on("close",()=>{y(0,p)}),f.listen(E,d)})}function j(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(h){console.error(h)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function n(h){const c=new Set;if(Array.isArray(h))for(const d of h)typeof d=="string"&&c.add(d);return Array.from(c)}function C(){const h=e();return h?Array.from(h):[]}function S(h){if(process.platform!=="win32")return;const c=e();if(c)if(typeof h=="string")c.add(h.toLowerCase());else for(const d of n(h))S(d)}function R(h){if(typeof h!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let d;for(const b of c){if(h.indexOf(b)!==0)continue;const m=h.indexOf("\\",b.length);if(m===-1)continue;const f=h.substring(b.length,m);if(f){d=f;break}}return d}function j(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:S,getUNCHost:R,disableUNCAccessRestrictions:j,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(re[148],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UW=e.$TW=void 0,e.$TW="vscode:contextmenu",e.$UW="vscode:onCloseContextMenu"}),define(re[149],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2W=void 0;class n{constructor(S,R){this.a=S,this.onMessage=R}send(S){try{this.a.send("vscode:message",S.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$2W=n}),define(re[150],oe([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(re[151],oe([0,1,150]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=c,e.$3m=d,e.$4m=b;const C=60,S=C*60,R=S*24,j=R*7,E=R*30,h=R*365;function c(v,m,f,y){typeof v!="number"&&(v=v.getTime());const p=Math.round((new Date().getTime()-v)/1e3);if(p<-30)return(0,n.localize)(0,null,c(new Date().getTime()+p*1e3,!1));if(!y&&p<30)return(0,n.localize)(1,null);let g;return p<C?(g=p,m?g===1?f?(0,n.localize)(2,null,g):(0,n.localize)(3,null,g):f?(0,n.localize)(4,null,g):(0,n.localize)(5,null,g):g===1?f?(0,n.localize)(6,null,g):(0,n.localize)(7,null,g):f?(0,n.localize)(8,null,g):(0,n.localize)(9,null,g)):p<S?(g=Math.floor(p/C),m?g===1?f?(0,n.localize)(10,null,g):(0,n.localize)(11,null,g):f?(0,n.localize)(12,null,g):(0,n.localize)(13,null,g):g===1?f?(0,n.localize)(14,null,g):(0,n.localize)(15,null,g):f?(0,n.localize)(16,null,g):(0,n.localize)(17,null,g)):p<R?(g=Math.floor(p/S),m?g===1?f?(0,n.localize)(18,null,g):(0,n.localize)(19,null,g):f?(0,n.localize)(20,null,g):(0,n.localize)(21,null,g):g===1?f?(0,n.localize)(22,null,g):(0,n.localize)(23,null,g):f?(0,n.localize)(24,null,g):(0,n.localize)(25,null,g)):p<j?(g=Math.floor(p/R),m?g===1?(0,n.localize)(26,null,g):(0,n.localize)(27,null,g):g===1?(0,n.localize)(28,null,g):(0,n.localize)(29,null,g)):p<E?(g=Math.floor(p/j),m?g===1?f?(0,n.localize)(30,null,g):(0,n.localize)(31,null,g):f?(0,n.localize)(32,null,g):(0,n.localize)(33,null,g):g===1?f?(0,n.localize)(34,null,g):(0,n.localize)(35,null,g):f?(0,n.localize)(36,null,g):(0,n.localize)(37,null,g)):p<h?(g=Math.floor(p/E),m?g===1?f?(0,n.localize)(38,null,g):(0,n.localize)(39,null,g):f?(0,n.localize)(40,null,g):(0,n.localize)(41,null,g):g===1?f?(0,n.localize)(42,null,g):(0,n.localize)(43,null,g):f?(0,n.localize)(44,null,g):(0,n.localize)(45,null,g)):(g=Math.floor(p/h),m?g===1?f?(0,n.localize)(46,null,g):(0,n.localize)(47,null,g):f?(0,n.localize)(48,null,g):(0,n.localize)(49,null,g):g===1?f?(0,n.localize)(50,null,g):(0,n.localize)(51,null,g):f?(0,n.localize)(52,null,g):(0,n.localize)(53,null,g))}function d(v,m){const f=Math.abs(v/1e3);return f<1?m?(0,n.localize)(54,null,v):(0,n.localize)(55,null,v):f<C?m?(0,n.localize)(56,null,Math.round(v)/1e3):(0,n.localize)(57,null,Math.round(v)/1e3):f<S?m?(0,n.localize)(58,null,Math.round(v/(1e3*C))):(0,n.localize)(59,null,Math.round(v/(1e3*C))):f<R?m?(0,n.localize)(60,null,Math.round(v/(1e3*S))):(0,n.localize)(61,null,Math.round(v/(1e3*S))):(0,n.localize)(62,null,Math.round(v/(1e3*R)))}function b(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(re[152],oe([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(re[47],oe([0,1,22,12,152]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=h,e.$ij=c,e.$jj=d;function R(b,v){return v&&(b.stack||b.stacktrace)?S.localize(0,null,E(b),j(b.stack)||j(b.stacktrace)):E(b)}function j(b){return Array.isArray(b)?b.join(`
`):b}function E(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?S.localize(1,null,b.message):b.message||S.localize(2,null)}function h(b=null,v=!1){if(!b)return S.localize(3,null);if(Array.isArray(b)){const m=n.$Hb(b),f=h(m[0],v);return m.length>1?S.localize(4,null,f,m.length):f}if(C.$9f(b))return b;if(b.detail){const m=b.detail;if(m.error)return R(m.error,v);if(m.exception)return R(m.exception,v)}return b.stack?R(b,v):b.message?b.message:S.localize(5,null)}function c(b){const v=b;return v instanceof Error&&Array.isArray(v.actions)}function d(b,v){let m;return typeof b=="string"?m=new Error(b):m=b,m.actions=v,m}}),define(re[153],oe([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(re[154],oe([0,1,153]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=C;function C(S){switch(S){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(re[155],oe([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,155]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=P,e.$J=D,e.$g="en";let C=!1,S=!1,R=!1,j=!1,E=!1,h=!1,c=!1,d=!1,b=!1,v=!1,m,f=e.$g,y=e.$g,p,g;const l=globalThis;let w;typeof l.vscode<"u"&&typeof l.vscode.process<"u"?w=l.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const k=typeof w?.versions?.electron=="string",a=k&&w?.type==="renderer";if(typeof w=="object"){C=w.platform==="win32",S=w.platform==="darwin",R=w.platform==="linux",j=R&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,c=k,b=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.$g,f=e.$g;const I=w.env.VSCODE_NLS_CONFIG;if(I)try{const O=JSON.parse(I),M=O.availableLanguages["*"];m=O.locale,y=O.osLocale,f=M||e.$g,p=O._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!a?(g=navigator.userAgent,C=g.indexOf("Windows")>=0,S=g.indexOf("Macintosh")>=0,d=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=g.indexOf("Linux")>=0,v=g?.indexOf("Mobi")>=0,h=!0,m=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,f=m,y=navigator.language):console.error("Unable to resolve platform.");var t;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;S?s=1:C?s=3:R&&(s=2),e.$i=C,e.$j=S,e.$k=R,e.$l=j,e.$m=E,e.$n=c,e.$o=h,e.$p=h&&typeof l.importScripts=="function",e.$q=e.$p?l.origin:void 0,e.$r=d,e.$s=v,e.$t=b,e.$u=s,e.$v=g,e.$w=f;var i;(function(I){function O(){return e.$w}I.value=O;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}I.isDefaultVariant=M;function W(){return e.$w==="en"}I.isDefault=W})(i||(e.Language=i={})),e.$x=m,e.$y=y,e.$z=p,e.$A=typeof l.postMessage=="function"&&!l.importScripts,e.$B=(()=>{if(e.$A){const I=[];l.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let W=0,F=I.length;W<F;W++){const T=I[W];if(T.id===M.data.vscodeScheduleAsyncWork){I.splice(W,1),T.callback();return}}});let O=0;return M=>{const W=++O;I.push({id:W,callback:M}),l.postMessage({vscodeScheduleAsyncWork:W},"*")}}return I=>setTimeout(I)})();var o;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=S||d?2:C?1:3;let u=!0,$=!1;function P(){if(!$){$=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,u=new Uint16Array(I.buffer)[0]===513}return u}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function D(I){return parseFloat(I)>=20}}),define(re[36],oe([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let C;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const R=S.process;C={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$ec=C.platform,e.$fc=C.arch}),define(re[9],oe([0,1,36]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const C=65,S=97,R=90,j=122,E=46,h=47,c=92,d=58,b=63;class v extends Error{constructor(r,s,i){let o;typeof s=="string"&&s.indexOf("not ")===0?(o="must not be",s=s.replace(/^not /,"")):o="must be";const u=r.indexOf(".")!==-1?"property":"argument";let $=`The "${r}" ${u} ${o} of type ${s}`;$+=`. Received type ${typeof i}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function m(t,r){if(t===null||typeof t!="object")throw new v(r,"Object",t)}function f(t,r){if(typeof t!="string")throw new v(r,"string",t)}const y=n.$ec==="win32";function p(t){return t===h||t===c}function g(t){return t===h}function l(t){return t>=C&&t<=R||t>=S&&t<=j}function w(t,r,s,i){let o="",u=0,$=-1,P=0,D=0;for(let I=0;I<=t.length;++I){if(I<t.length)D=t.charCodeAt(I);else{if(i(D))break;D=h}if(i(D)){if(!($===I-1||P===1))if(P===2){if(o.length<2||u!==2||o.charCodeAt(o.length-1)!==E||o.charCodeAt(o.length-2)!==E){if(o.length>2){const O=o.lastIndexOf(s);O===-1?(o="",u=0):(o=o.slice(0,O),u=o.length-1-o.lastIndexOf(s)),$=I,P=0;continue}else if(o.length!==0){o="",u=0,$=I,P=0;continue}}r&&(o+=o.length>0?`${s}..`:"..",u=2)}else o.length>0?o+=`${s}${t.slice($+1,I)}`:o=t.slice($+1,I),u=I-$-1;$=I,P=0}else D===E&&P!==-1?++P:P=-1}return o}function k(t,r){m(r,"pathObject");const s=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${i}`:`${s}${t}${i}`:i}e.$gc={resolve(...t){let r="",s="",i=!1;for(let o=t.length-1;o>=-1;o--){let u;if(o>=0){if(u=t[o],f(u,"path"),u.length===0)continue}else r.length===0?u=n.cwd():(u=n.env[`=${r}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==r.toLowerCase()&&u.charCodeAt(2)===c)&&(u=`${r}\\`));const $=u.length;let P=0,D="",I=!1;const O=u.charCodeAt(0);if($===1)p(O)&&(P=1,I=!0);else if(p(O))if(I=!0,p(u.charCodeAt(1))){let M=2,W=M;for(;M<$&&!p(u.charCodeAt(M));)M++;if(M<$&&M!==W){const F=u.slice(W,M);for(W=M;M<$&&p(u.charCodeAt(M));)M++;if(M<$&&M!==W){for(W=M;M<$&&!p(u.charCodeAt(M));)M++;(M===$||M!==W)&&(D=`\\\\${F}\\${u.slice(W,M)}`,P=M)}}}else P=1;else l(O)&&u.charCodeAt(1)===d&&(D=u.slice(0,2),P=2,$>2&&p(u.charCodeAt(2))&&(I=!0,P=3));if(D.length>0)if(r.length>0){if(D.toLowerCase()!==r.toLowerCase())continue}else r=D;if(i){if(r.length>0)break}else if(s=`${u.slice(P)}\\${s}`,i=I,I&&r.length>0)break}return s=w(s,!i,"\\",p),i?`${r}\\${s}`:`${r}${s}`||"."},normalize(t){f(t,"path");const r=t.length;if(r===0)return".";let s=0,i,o=!1;const u=t.charCodeAt(0);if(r===1)return g(u)?"\\":t;if(p(u))if(o=!0,p(t.charCodeAt(1))){let P=2,D=P;for(;P<r&&!p(t.charCodeAt(P));)P++;if(P<r&&P!==D){const I=t.slice(D,P);for(D=P;P<r&&p(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&!p(t.charCodeAt(P));)P++;if(P===r)return`\\\\${I}\\${t.slice(D)}\\`;P!==D&&(i=`\\\\${I}\\${t.slice(D,P)}`,s=P)}}}else s=1;else l(u)&&t.charCodeAt(1)===d&&(i=t.slice(0,2),s=2,r>2&&p(t.charCodeAt(2))&&(o=!0,s=3));let $=s<r?w(t.slice(s),!o,"\\",p):"";return $.length===0&&!o&&($="."),$.length>0&&p(t.charCodeAt(r-1))&&($+="\\"),i===void 0?o?`\\${$}`:$:o?`${i}\\${$}`:`${i}${$}`},isAbsolute(t){f(t,"path");const r=t.length;if(r===0)return!1;const s=t.charCodeAt(0);return p(s)||r>2&&l(s)&&t.charCodeAt(1)===d&&p(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,s;for(let u=0;u<t.length;++u){const $=t[u];f($,"path"),$.length>0&&(r===void 0?r=s=$:r+=`\\${$}`)}if(r===void 0)return".";let i=!0,o=0;if(typeof s=="string"&&p(s.charCodeAt(0))){++o;const u=s.length;u>1&&p(s.charCodeAt(1))&&(++o,u>2&&(p(s.charCodeAt(2))?++o:i=!1))}if(i){for(;o<r.length&&p(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.$gc.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r)return"";const s=e.$gc.resolve(t),i=e.$gc.resolve(r);if(s===i||(t=s.toLowerCase(),r=i.toLowerCase(),t===r))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===c;)o++;let u=t.length;for(;u-1>o&&t.charCodeAt(u-1)===c;)u--;const $=u-o;let P=0;for(;P<r.length&&r.charCodeAt(P)===c;)P++;let D=r.length;for(;D-1>P&&r.charCodeAt(D-1)===c;)D--;const I=D-P,O=$<I?$:I;let M=-1,W=0;for(;W<O;W++){const T=t.charCodeAt(o+W);if(T!==r.charCodeAt(P+W))break;T===c&&(M=W)}if(W!==O){if(M===-1)return i}else{if(I>O){if(r.charCodeAt(P+W)===c)return i.slice(P+W+1);if(W===2)return i.slice(P+W)}$>O&&(t.charCodeAt(o+W)===c?M=W:W===2&&(M=3)),M===-1&&(M=0)}let F="";for(W=o+M+1;W<=u;++W)(W===u||t.charCodeAt(W)===c)&&(F+=F.length===0?"..":"\\..");return P+=M,F.length>0?`${F}${i.slice(P,D)}`:(i.charCodeAt(P)===c&&++P,i.slice(P,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$gc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===c){if(r.charCodeAt(1)===c){const s=r.charCodeAt(2);if(s!==b&&s!==E)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(l(r.charCodeAt(0))&&r.charCodeAt(1)===d&&r.charCodeAt(2)===c)return`\\\\?\\${r}`;return t},dirname(t){f(t,"path");const r=t.length;if(r===0)return".";let s=-1,i=0;const o=t.charCodeAt(0);if(r===1)return p(o)?t:".";if(p(o)){if(s=i=1,p(t.charCodeAt(1))){let P=2,D=P;for(;P<r&&!p(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&p(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&!p(t.charCodeAt(P));)P++;if(P===r)return t;P!==D&&(s=i=P+1)}}}}else l(o)&&t.charCodeAt(1)===d&&(s=r>2&&p(t.charCodeAt(2))?3:2,i=s);let u=-1,$=!0;for(let P=r-1;P>=i;--P)if(p(t.charCodeAt(P))){if(!$){u=P;break}}else $=!1;if(u===-1){if(s===-1)return".";u=s}return t.slice(0,u)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let s=0,i=-1,o=!0,u;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===d&&(s=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let $=r.length-1,P=-1;for(u=t.length-1;u>=s;--u){const D=t.charCodeAt(u);if(p(D)){if(!o){s=u+1;break}}else P===-1&&(o=!1,P=u+1),$>=0&&(D===r.charCodeAt($)?--$===-1&&(i=u):($=-1,i=P))}return s===i?i=P:i===-1&&(i=t.length),t.slice(s,i)}for(u=t.length-1;u>=s;--u)if(p(t.charCodeAt(u))){if(!o){s=u+1;break}}else i===-1&&(o=!1,i=u+1);return i===-1?"":t.slice(s,i)},extname(t){f(t,"path");let r=0,s=-1,i=0,o=-1,u=!0,$=0;t.length>=2&&t.charCodeAt(1)===d&&l(t.charCodeAt(0))&&(r=i=2);for(let P=t.length-1;P>=r;--P){const D=t.charCodeAt(P);if(p(D)){if(!u){i=P+1;break}continue}o===-1&&(u=!1,o=P+1),D===E?s===-1?s=P:$!==1&&($=1):s!==-1&&($=-1)}return s===-1||o===-1||$===0||$===1&&s===o-1&&s===i+1?"":t.slice(s,o)},format:k.bind(null,"\\"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.length;let i=0,o=t.charCodeAt(0);if(s===1)return p(o)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(p(o)){if(i=1,p(t.charCodeAt(1))){let M=2,W=M;for(;M<s&&!p(t.charCodeAt(M));)M++;if(M<s&&M!==W){for(W=M;M<s&&p(t.charCodeAt(M));)M++;if(M<s&&M!==W){for(W=M;M<s&&!p(t.charCodeAt(M));)M++;M===s?i=M:M!==W&&(i=M+1)}}}}else if(l(o)&&t.charCodeAt(1)===d){if(s<=2)return r.root=r.dir=t,r;if(i=2,p(t.charCodeAt(2))){if(s===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let u=-1,$=i,P=-1,D=!0,I=t.length-1,O=0;for(;I>=i;--I){if(o=t.charCodeAt(I),p(o)){if(!D){$=I+1;break}continue}P===-1&&(D=!1,P=I+1),o===E?u===-1?u=I:O!==1&&(O=1):u!==-1&&(O=-1)}return P!==-1&&(u===-1||O===0||O===1&&u===P-1&&u===$+1?r.base=r.name=t.slice($,P):(r.name=t.slice($,u),r.base=t.slice($,P),r.ext=t.slice(u,P))),$>0&&$!==i?r.dir=t.slice(0,$-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(y){const t=/\\/g;return()=>{const r=n.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>n.cwd()})();e.$hc={resolve(...t){let r="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const o=i>=0?t[i]:a();f(o,"path"),o.length!==0&&(r=`${o}/${r}`,s=o.charCodeAt(0)===h)}return r=w(r,!s,"/",g),s?`/${r}`:r.length>0?r:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===h,s=t.charCodeAt(t.length-1)===h;return t=w(t,!r,"/",g),t.length===0?r?"/":s?"./":".":(s&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let r;for(let s=0;s<t.length;++s){const i=t[s];f(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.$hc.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r||(t=e.$hc.resolve(t),r=e.$hc.resolve(r),t===r))return"";const s=1,i=t.length,o=i-s,u=1,$=r.length-u,P=o<$?o:$;let D=-1,I=0;for(;I<P;I++){const M=t.charCodeAt(s+I);if(M!==r.charCodeAt(u+I))break;M===h&&(D=I)}if(I===P)if($>P){if(r.charCodeAt(u+I)===h)return r.slice(u+I+1);if(I===0)return r.slice(u+I)}else o>P&&(t.charCodeAt(s+I)===h?D=I:I===0&&(D=0));let O="";for(I=s+D+1;I<=i;++I)(I===i||t.charCodeAt(I)===h)&&(O+=O.length===0?"..":"/..");return`${O}${r.slice(u+D)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===h;let s=-1,i=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===h){if(!i){s=o;break}}else i=!1;return s===-1?r?"/":".":r&&s===1?"//":t.slice(0,s)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let s=0,i=-1,o=!0,u;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let $=r.length-1,P=-1;for(u=t.length-1;u>=0;--u){const D=t.charCodeAt(u);if(D===h){if(!o){s=u+1;break}}else P===-1&&(o=!1,P=u+1),$>=0&&(D===r.charCodeAt($)?--$===-1&&(i=u):($=-1,i=P))}return s===i?i=P:i===-1&&(i=t.length),t.slice(s,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===h){if(!o){s=u+1;break}}else i===-1&&(o=!1,i=u+1);return i===-1?"":t.slice(s,i)},extname(t){f(t,"path");let r=-1,s=0,i=-1,o=!0,u=0;for(let $=t.length-1;$>=0;--$){const P=t.charCodeAt($);if(P===h){if(!o){s=$+1;break}continue}i===-1&&(o=!1,i=$+1),P===E?r===-1?r=$:u!==1&&(u=1):r!==-1&&(u=-1)}return r===-1||i===-1||u===0||u===1&&r===i-1&&r===s+1?"":t.slice(r,i)},format:k.bind(null,"/"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.charCodeAt(0)===h;let i;s?(r.root="/",i=1):i=0;let o=-1,u=0,$=-1,P=!0,D=t.length-1,I=0;for(;D>=i;--D){const O=t.charCodeAt(D);if(O===h){if(!P){u=D+1;break}continue}$===-1&&(P=!1,$=D+1),O===E?o===-1?o=D:I!==1&&(I=1):o!==-1&&(I=-1)}if($!==-1){const O=u===0&&s?1:u;o===-1||I===0||I===1&&o===$-1&&o===u+1?r.base=r.name=t.slice(O,$):(r.name=t.slice(O,o),r.base=t.slice(O,$),r.ext=t.slice(o,$))}return u>0?r.dir=t.slice(0,u-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=y?e.$gc.normalize:e.$hc.normalize,e.$jc=y?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=y?e.$gc.join:e.$hc.join,e.$lc=y?e.$gc.resolve:e.$hc.resolve,e.$mc=y?e.$gc.relative:e.$hc.relative,e.$nc=y?e.$gc.dirname:e.$hc.dirname,e.$oc=y?e.$gc.basename:e.$hc.basename,e.$pc=y?e.$gc.extname:e.$hc.extname,e.$qc=y?e.$gc.format:e.$hc.format,e.$rc=y?e.$gc.parse:e.$hc.parse,e.$sc=y?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=y?e.$gc.sep:e.$hc.sep,e.$uc=y?e.$gc.delimiter:e.$hc.delimiter}),define(re[31],oe([0,1,9,4,25,12]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=j,e.$pg=E,e.$qg=h,e.$rg=c,e.$sg=d,e.$tg=f,e.$ug=y,e.$vg=p,e.$wg=g,e.$xg=l,e.$yg=w,e.$zg=k,e.$Ag=a,e.$Bg=t,e.$Cg=r,e.$Dg=s,e.$Eg=u;function j($){return $===47||$===92}function E($){return $.replace(/[\\/]/g,n.$hc.sep)}function h($){return $.indexOf("/")===-1&&($=E($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}function c($,P=n.$hc.sep){if(!$)return"";const D=$.length,I=$.charCodeAt(0);if(j(I)){if(j($.charCodeAt(1))&&!j($.charCodeAt(2))){let M=3;const W=M;for(;M<D&&!j($.charCodeAt(M));M++);if(W!==M&&!j($.charCodeAt(M+1))){for(M+=1;M<D;M++)if(j($.charCodeAt(M)))return $.slice(0,M+1).replace(/[\\/]/g,P)}}return P}else if(g(I)&&$.charCodeAt(1)===58)return j($.charCodeAt(2))?$.slice(0,2)+P:$.slice(0,2);let O=$.indexOf("://");if(O!==-1){for(O+=3;O<D;O++)if(j($.charCodeAt(O)))return $.slice(0,O+1)}return""}function d($){if(!C.$i||!$||$.length<5)return!1;let P=$.charCodeAt(0);if(P!==92||(P=$.charCodeAt(1),P!==92))return!1;let D=2;const I=D;for(;D<$.length&&(P=$.charCodeAt(D),P!==92);D++);return!(I===D||(P=$.charCodeAt(D+1),isNaN(P)||P===92))}const b=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f($,P=C.$i){const D=P?b:v;return!(!$||$.length===0||/^\s+$/.test($)||(D.lastIndex=0,D.test($))||P&&m.test($)||$==="."||$===".."||P&&$[$.length-1]==="."||P&&$.length!==$.trim().length||$.length>255)}function y($,P,D){const I=$===P;return!D||I?I:!$||!P?!1:(0,S.$yf)($,P)}function p($,P,D,I=n.sep){if($===P)return!0;if(!$||!P||P.length>$.length)return!1;if(D){if(!(0,S.$zf)($,P))return!1;if(P.length===$.length)return!0;let M=P.length;return P.charAt(P.length-1)===I&&M--,$.charAt(M)===I}return P.charAt(P.length-1)!==I&&(P+=I),$.indexOf(P)===0}function g($){return $>=65&&$<=90||$>=97&&$<=122}function l($,P){return C.$i&&$.endsWith(":")&&($+=n.sep),(0,n.$jc)($)||($=(0,n.$kc)(P,$)),$=(0,n.$ic)($),w($)}function w($){return C.$i?($=(0,S.$gf)($,n.sep),$.endsWith(":")&&($+=n.sep)):($=(0,S.$gf)($,n.sep),$||($=n.sep)),$}function k($){const P=(0,n.$ic)($);return C.$i?$.length>3?!1:a(P)&&($.length===2||P.charCodeAt(2)===92):P===n.$hc.sep}function a($,P=C.$i){return P?g($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}function t($,P=C.$i){return a($,P)?$[0]:void 0}function r($,P,D){return P.length>$.length?-1:$===P?0:(D&&($=$.toLowerCase(),P=P.toLowerCase()),$.indexOf(P))}function s($){const P=$.split(":");let D,I,O;for(const M of P){const W=Number(M);(0,R.$ag)(W)?I===void 0?I=W:O===void 0&&(O=W):D=D?[D,M].join(":"):M}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:I!==void 0?I:void 0,column:O!==void 0?O:I!==void 0?1:void 0}}const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u($,P,D=8){let I="";for(let M=0;M<D;M++){let W;M===0&&C.$i&&!P&&(D===3||D===4)?W=o:W=i,I+=W.charAt(Math.floor(Math.random()*W.length))}let O;return P?O=`${P}-${I}`:O=I,$?(0,n.$kc)($,O):O}}),define(re[76],oe([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=R,e.$nm=j;var C;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(C||(e.Source=C={}));var S;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function R(E,...h){const c=h.reduce((v,m)=>(v[m]=!0,v),{}),d=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(v=>!c[v]).forEach(v=>{for(let m=0;m<d.length;m++)if(v.search(d[m])!==-1){delete E[v];break}})}function j(E){E&&(delete E.DEBUG,n.$j&&delete E.DYLD_LIBRARY_PATH,n.$k&&delete E.LD_PRELOAD)}}),define(re[7],oe([0,1,9,4]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=f,e.$xc=k;const S=/^\w[\w\d+.-]*$/,R=/^\//,j=/^\/\//;function E(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!S.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,o){return!i&&!o?"file":i}function c(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==b&&(o=b+o):o=b;break}return o}const d="",b="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(o){return o instanceof m?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,u,$,P,D,I=!1){typeof o=="object"?(this.scheme=o.scheme||d,this.authority=o.authority||d,this.path=o.path||d,this.query=o.query||d,this.fragment=o.fragment||d):(this.scheme=h(o,I),this.authority=u||d,this.path=c(this.scheme,$||d),this.query=P||d,this.fragment=D||d,E(this,I))}get fsPath(){return k(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:$,path:P,query:D,fragment:I}=o;return u===void 0?u=this.scheme:u===null&&(u=d),$===void 0?$=this.authority:$===null&&($=d),P===void 0?P=this.path:P===null&&(P=d),D===void 0?D=this.query:D===null&&(D=d),I===void 0?I=this.fragment:I===null&&(I=d),u===this.scheme&&$===this.authority&&P===this.path&&D===this.query&&I===this.fragment?this:new p(u,$,P,D,I)}static parse(o,u=!1){const $=v.exec(o);return $?new p($[2]||d,s($[4]||d),s($[5]||d),s($[7]||d),s($[9]||d),u):new p(d,d,d,d,d)}static file(o){let u=d;if(C.$i&&(o=o.replace(/\\/g,b)),o[0]===b&&o[1]===b){const $=o.indexOf(b,2);$===-1?(u=o.substring(2),o=b):(u=o.substring(2,$),o=o.substring($)||b)}return new p("file",u,o,d,d)}static from(o,u){return new p(o.scheme,o.authority,o.path,o.query,o.fragment,u)}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return C.$i&&o.scheme==="file"?$=m.file(n.$gc.join(k(o,!0),...u)).path:$=n.$hc.join(o.path,...u),o.with({path:$})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof m)return o;{const u=new p(o);return u._formatted=o.external??null,u._fsPath=o._sep===y?o.fsPath??null:null,u}}else return o}}e.URI=m;function f(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const y=C.$i?1:void 0;class p extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=y),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const g={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function l(i,o,u){let $,P=-1;for(let D=0;D<i.length;D++){const I=i.charCodeAt(D);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||o&&I===47||u&&I===91||u&&I===93||u&&I===58)P!==-1&&($+=encodeURIComponent(i.substring(P,D)),P=-1),$!==void 0&&($+=i.charAt(D));else{$===void 0&&($=i.substr(0,D));const O=g[I];O!==void 0?(P!==-1&&($+=encodeURIComponent(i.substring(P,D)),P=-1),$+=O):P===-1&&(P=D)}}return P!==-1&&($+=encodeURIComponent(i.substring(P))),$!==void 0?$:i}function w(i){let o;for(let u=0;u<i.length;u++){const $=i.charCodeAt(u);$===35||$===63?(o===void 0&&(o=i.substr(0,u)),o+=g[$]):o!==void 0&&(o+=i[u])}return o!==void 0?o:i}function k(i,o){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,C.$i&&(u=u.replace(/\//g,"\\")),u}function a(i,o){const u=o?w:l;let $="",{scheme:P,authority:D,path:I,query:O,fragment:M}=i;if(P&&($+=P,$+=":"),(D||P==="file")&&($+=b,$+=b),D){let W=D.indexOf("@");if(W!==-1){const F=D.substr(0,W);D=D.substr(W+1),W=F.lastIndexOf(":"),W===-1?$+=u(F,!1,!1):($+=u(F.substr(0,W),!1,!1),$+=":",$+=u(F.substr(W+1),!1,!0)),$+="@"}D=D.toLowerCase(),W=D.lastIndexOf(":"),W===-1?$+=u(D,!1,!0):($+=u(D.substr(0,W),!1,!0),$+=D.substr(W))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const W=I.charCodeAt(1);W>=65&&W<=90&&(I=`/${String.fromCharCode(W+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const W=I.charCodeAt(0);W>=65&&W<=90&&(I=`${String.fromCharCode(W+32)}:${I.substr(2)}`)}$+=u(I,!0,!1)}return O&&($+="?",$+=u(O,!1,!1)),M&&($+="#",$+=o?M:l(M,!1,!1)),$}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(r)?i.replace(r,o=>t(o)):i}}),define(re[156],oe([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=C,e.$Wq=S,e.$Xq=R,e.log=E;function C(c){const d=c;return d&&typeof d.type=="string"&&typeof d.severity=="string"}function S(c){const d=[];let b;try{const v=JSON.parse(c.arguments),m=v[v.length-1];m&&m.__$stack&&(v.pop(),b=m.__$stack),d.push(...v)}catch{d.push("Unable to log remote console arguments",c.arguments)}return{args:d,stack:b}}function R(c){if(typeof c!="string")return R(S(c).stack);const d=c;if(d){const b=j(d),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(v&&v.length===4)return{uri:n.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function j(c){if(!c)return c;const d=c.indexOf(`
`);return d===-1?c:c.substring(0,d)}function E(c,d){const{args:b,stack:v}=S(c),m=typeof b[0]=="string"&&b.length===1;let f=j(v);f&&(f=`(${f.trim()})`);let y=[];if(typeof b[0]=="string"?f&&m?y=[`%c[${d}] %c${b[0]} %c${f}`,h("blue"),h(""),h("grey")]:y=[`%c[${d}] %c${b[0]}`,h("blue"),h(""),...b.slice(1)]:y=[`%c[${d}]%`,h("blue"),...b],f&&!m&&y.push(f),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,y)}function h(c){return`color: ${c}`}}),define(re[77],oe([0,1,17,7]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=S,e.$5h=R,e.$6h=E;function S(h){return JSON.stringify(h,j)}function R(h){let c=JSON.parse(h);return c=E(c),c}function j(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function E(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return C.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof n.$Ge||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let d=0;d<h.length;++d)h[d]=E(h[d],c+1);else for(const d in h)Object.hasOwnProperty.call(h,d)&&(h[d]=E(h[d],c+1))}return h}}),define(re[13],oe([0,1,15,4,25,7,9]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=h,e.$Gg=c,e.$Kg=b;var E;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(E||(e.Schemas=E={}));function h(f,y){return R.URI.isUri(f)?(0,S.$yf)(f.scheme,y):(0,S.$zf)(f,y+":")}function c(f,...y){return y.some(p=>h(f,p))}e.$Hg="vscode-tkn",e.$Ig="tkn";class d{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y,p){this.f=b(y,p)}getServerRootPath(){return this.f}get g(){return j.$hc.join(this.f,E.vscodeRemoteResource)}set(y,p,g){this.a[y]=p,this.b[y]=g}setConnectionToken(y,p){this.c[y]=p}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)try{return this.e(y)}catch(a){return n.$1(a),y}const p=y.authority;let g=this.a[p];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const l=this.b[p],w=this.c[p];let k=`path=${encodeURIComponent(y.path)}`;return typeof w=="string"&&(k+=`&${e.$Ig}=${encodeURIComponent(w)}`),R.URI.from({scheme:C.$o?this.d:E.vscodeRemoteResource,authority:`${g}:${l}`,path:this.g,query:k})}}e.$Jg=new d;function b(f,y){return j.$hc.join(y??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class v{static{this.a=e.$Pg}asBrowserUri(y){const p=this.b(y,J);return this.uriToBrowserUri(p)}uriToBrowserUri(y){return y.scheme===E.vscodeRemote?e.$Jg.rewrite(y):y.scheme===E.file&&(C.$m||C.$q===`${E.vscodeFileResource}://${v.a}`)?y.with({scheme:E.vscodeFileResource,authority:y.authority||v.a,query:null,fragment:null}):y}asFileUri(y){const p=this.b(y,J);return this.uriToFileUri(p)}uriToFileUri(y){return y.scheme===E.vscodeFileResource?y.with({scheme:E.file,authority:y.authority!==v.a?y.authority:null,query:null,fragment:null}):y}b(y,p){return R.URI.isUri(y)?y:R.URI.parse(p.toUrl(y))}}e.$Qg=new v;var m;(function(f){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(y.get("3"));const p="vscode-coi";function g(w){let k;typeof w=="string"?k=new URL(w).searchParams:w instanceof URL?k=w.searchParams:R.URI.isUri(w)&&(k=new URL(w.toString(!0)).searchParams);const a=k?.get(p);if(a)return y.get(a)}f.getHeadersFromQuery=g;function l(w,k,a){if(!globalThis.crossOriginIsolated)return;const t=k&&a?"3":a?"2":"1";w instanceof URLSearchParams?w.set(p,t):w[p]=t}f.addSearchParam=l})(m||(e.COI=m={}))}),define(re[19],oe([0,1,31,13,9,4,25,7]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=h,e.$gh=d,e.$hh=v;function h(m){return(0,E.$xc)(m,!0)}class c{constructor(f){this.a=f}compare(f,y,p=!1){return f===y?0:(0,j.$rf)(this.getComparisonKey(f,p),this.getComparisonKey(y,p))}isEqual(f,y,p=!1){return f===y?!0:!f||!y?!1:this.getComparisonKey(f,p)===this.getComparisonKey(y,p)}getComparisonKey(f,y=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,y,p=!1){if(f.scheme===y.scheme){if(f.scheme===C.Schemas.file)return n.$vg(h(f),h(y),this.a(f))&&f.query===y.query&&(p||f.fragment===y.fragment);if((0,e.$ch)(f.authority,y.authority))return n.$vg(f.path,y.path,this.a(f),"/")&&f.query===y.query&&(p||f.fragment===y.fragment)}return!1}joinPath(f,...y){return E.URI.joinPath(f,...y)}basenameOrAuthority(f){return(0,e.$7g)(f)||f.authority}basename(f){return S.$hc.basename(f.path)}extname(f){return S.$hc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let y;return f.scheme===C.Schemas.file?y=E.URI.file(S.$nc(h(f))).path:(y=S.$hc.dirname(f.path),f.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),y="/")),f.with({path:y})}normalizePath(f){if(!f.path.length)return f;let y;return f.scheme===C.Schemas.file?y=E.URI.file(S.$ic(h(f))).path:y=S.$hc.normalize(f.path),f.with({path:y})}relativePath(f,y){if(f.scheme!==y.scheme||!(0,e.$ch)(f.authority,y.authority))return;if(f.scheme===C.Schemas.file){const l=S.$mc(h(f),h(y));return R.$i?n.$pg(l):l}let p=f.path||"/";const g=y.path||"/";if(this.a(f)){let l=0;for(const w=Math.min(p.length,g.length);l<w&&!(p.charCodeAt(l)!==g.charCodeAt(l)&&p.charAt(l).toLowerCase()!==g.charAt(l).toLowerCase());l++);p=g.substr(0,l)+p.substr(l)}return S.$hc.relative(p,g)}resolvePath(f,y){if(f.scheme===C.Schemas.file){const p=E.URI.file(S.$lc(h(f),y));return f.with({authority:p.authority,path:p.path})}return y=n.$qg(y),f.with({path:S.$hc.resolve(f.path,y)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,y){return f===y||f!==void 0&&y!==void 0&&(0,j.$yf)(f,y)}hasTrailingPathSeparator(f,y=S.sep){if(f.scheme===C.Schemas.file){const p=h(f);return p.length>n.$rg(p).length&&p[p.length-1]===y}else{const p=f.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,y=S.sep){return(0,e.$dh)(f,y)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,y=S.sep){let p=!1;if(f.scheme===C.Schemas.file){const g=h(f);p=g!==void 0&&g.length===n.$rg(g).length&&g[g.length-1]===y}else{y="/";const g=f.path;p=g.length===1&&g.charCodeAt(g.length-1)===47}return!p&&!(0,e.$dh)(f,y)?f.with({path:f.path+"/"}):f}}e.$Yg=c,e.$Zg=new c(()=>!1),e.$1g=new c(m=>m.scheme===C.Schemas.file?!R.$k:!0),e.$2g=new c(m=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function d(m,f){const y=[];for(let p=0;p<m.length;p++){const g=f(m[p]);m.some((l,w)=>w===p?!1:(0,e.$4g)(g,f(l)))||y.push(m[p])}return y}var b;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function f(y){const p=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(w=>{const[k,a]=w.split(":");k&&a&&p.set(k,a)});const l=y.path.substring(0,y.path.indexOf(";"));return l&&p.set(m.META_DATA_MIME,l),p}m.parseMetaData=f})(b||(e.DataUri=b={}));function v(m,f,y){if(f){let p=m.path;return p&&p[0]!==S.$hc.sep&&(p=S.$hc.sep+p),m.with({scheme:y,authority:f,path:p})}return m.with({scheme:y})}}),define(re[8],oe([0,1,23,15,3,2,19,4,144,62]),function(J,e,n,C,S,R,j,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=d,e.$jh=b,e.$kh=v,e.$lh=m,e.$mh=f,e.$nh=y,e.$oh=p,e.$ph=g,e.$xh=u,e.$yh=$,e.$zh=P,e.$Ah=D,e.$Bh=I,e.$Qh=L,e.$Yh=X;function d(V){return!!V&&typeof V.then=="function"}function b(V){const U=new n.$pe,se=V(U.token),he=new Promise(($e,me)=>{const ye=U.token.onCancellationRequested(()=>{ye.dispose(),me(new C.$5)});Promise.resolve(se).then(ke=>{ye.dispose(),U.dispose(),$e(ke)},ke=>{ye.dispose(),U.dispose(),me(ke)})});return new class{cancel(){U.cancel(),U.dispose()}then($e,me){return he.then($e,me)}catch($e){return this.then(void 0,$e)}finally($e){return he.finally($e)}}}function v(V,U,se){return new Promise((he,$e)=>{const me=U.onCancellationRequested(()=>{me.dispose(),he(se)});V.then(he,$e).finally(()=>me.dispose())})}function m(V,U){return new Promise((se,he)=>{const $e=U.onCancellationRequested(()=>{$e.dispose(),he(new C.$5)});V.then(se,he).finally(()=>$e.dispose())})}async function f(V){let U=-1;const se=V.map((he,$e)=>he.then(me=>(U=$e,me)));try{return await Promise.race(se)}finally{V.forEach((he,$e)=>{$e!==U&&he.cancel()})}}function y(V,U,se){let he;const $e=setTimeout(()=>{he?.(void 0),se?.()},U);return Promise.race([V.finally(()=>clearTimeout($e)),new Promise(me=>he=me)])}function p(V){return new Promise((U,se)=>{const he=V();d(he)?he.then(U,se):U(he)})}function g(){let V,U;return{promise:new Promise((he,$e)=>{V=he,U=$e}),resolve:V,reject:U}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(U){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=U,!this.b){const se=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(se,se).then(he)})}return new Promise((se,he)=>{this.b.then(se,he)})}return this.a=U(),new Promise((se,he)=>{this.a.then($e=>{this.a=null,se($e)},$e=>{this.a=null,he($e)})})}dispose(){this.f=!0}}e.$qh=l;class w{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.$rh=w;class k{constructor(){this.a=new Map}queue(U,se){const $e=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(U)===$e&&this.a.delete(U)});return this.a.set(U,$e),$e}}e.$sh=k;const a=(V,U)=>{let se=!0;const he=setTimeout(()=>{se=!1,U()},V);return{isTriggered:()=>se,dispose:()=>{clearTimeout(he),se=!1}}},t=V=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,V())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};class r{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,se=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise(($e,me)=>{this.d=$e,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=se===h.$be?t(he):a(se,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=r;class s{constructor(U){this.a=new r(U),this.b=new l}trigger(U,se){return this.a.trigger(()=>this.b.queue(U),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=s;class i{constructor(){this.a=!1,this.b=new Promise((U,se)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=i;class o extends i{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.$wh=o;function u(V,U){return U?new Promise((se,he)=>{const $e=setTimeout(()=>{me.dispose(),se()},V),me=U.onCancellationRequested(()=>{clearTimeout($e),me.dispose(),he(new C.$5)})}):b(se=>u(V,se))}function $(V,U=0,se){const he=setTimeout(()=>{V(),se&&$e.dispose()},U),$e=(0,R.$Tc)(()=>{clearTimeout(he),se?.deleteAndLeak($e)});return se?.add($e),$e}function P(V){const U=[];let se=0;const he=V.length;function $e(){return se<he?V[se++]():null}function me(ye){ye!=null&&U.push(ye);const ke=$e();return ke?ke.then(me):Promise.resolve(U)}return Promise.resolve(null).then(me)}function D(V,U=he=>!!he,se=null){let he=0;const $e=V.length,me=()=>{if(he>=$e)return Promise.resolve(se);const ye=V[he++];return Promise.resolve(ye()).then(Ee=>U(Ee)?Promise.resolve(Ee):me())};return me()}function I(V,U=he=>!!he,se=null){if(V.length===0)return Promise.resolve(se);let he=V.length;const $e=()=>{he=-1;for(const me of V)me.cancel?.()};return new Promise((me,ye)=>{for(const ke of V)ke.then(Ee=>{--he>=0&&U(Ee)?($e(),me(Ee)):he===0&&me(se)}).catch(Ee=>{--he>=0&&($e(),ye(Ee))})})}class O{constructor(U){this.a=0,this.b=!1,this.f=U,this.g=[],this.d=0,this.h=new S.$ee}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(U){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,he)=>{this.g.push({factory:U,c:se,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const U=this.g.shift();this.d++;const se=U.factory();se.then(U.c,U.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=O;class M extends O{constructor(){super(1)}}e.$Dh=M;class W{constructor(){this.a=new z,this.b=0}queue(U){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,U())):this.a.run(this.b++,U())}}e.$Eh=W;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const U=new x;return this.b.add(U),U.p}g(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueSize(U,se=j.$Zg){const he=se.getComparisonKey(U);return this.a.get(he)?.size??0}queueFor(U,se,he=j.$Zg){const $e=he.getComparisonKey(U);let me=this.a.get($e);if(!me){me=new M;const ye=this.f++,ke=S.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(ye),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$5c),this.d.set(ye,ke),this.a.set($e,me)}return me.queue(se)}h(){this.g()&&this.j()}j(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=F;class T{constructor(U,se){this.a=-1,typeof U=="function"&&typeof se=="number"&&this.setIfNotSet(U,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},se)}setIfNotSet(U,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},se))}}e.$Gh=T;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(U,se,he=globalThis){this.cancel();const $e=he.setInterval(()=>{U()},se);this.d=(0,R.$Tc)(()=>{he.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=q;class ue{constructor(U,se){this.b=-1,this.a=U,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=ue;class ee{constructor(U,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=U,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=ee;class ce extends ue{constructor(U,se){super(U,se),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.$Kh=ce;class K extends R.$Vc{constructor(U,se){super(),this.g=U,this.h=se,this.a=[],this.b=this.B(new R.$Wc),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of U)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ue(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(V,U)=>{(0,E.$B)(()=>{if(se)return;const he=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Nh=(V,U,se)=>{const he=V.requestIdleCallback(U,typeof se=="number"?{timeout:se}:void 0);let $e=!1;return{dispose(){$e||($e=!0,V.cancelIdleCallback(he))}}},e.$Mh=V=>(0,e.$Nh)(globalThis,V)}();class G{constructor(U,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Nh)(U,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=G;class B extends G{constructor(U){super(globalThis,U)}}e.$Ph=B;async function L(V,U,se){let he;for(let $e=0;$e<se;$e++)try{return await V()}catch(me){he=me,await u(U)}throw he}class z{isRunning(U){return typeof U=="number"?this.a?.taskId===U:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(U,se,he){return this.a={taskId:U,cancel:()=>he?.(),promise:se},se.then(()=>this.d(U),()=>this.d(U)),se}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}queue(U){if(this.b)this.b.run=U;else{const{promise:se,resolve:he,reject:$e}=g();this.b={run:U,promise:se,promiseResolve:he,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=z;class Q{constructor(U,se=()=>Date.now()){this.d=U,this.f=se,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.$Sh=Q;var ae;(function(V){V[V.Resolved=0]="Resolved",V[V.Rejected=1]="Rejected"})(ae||(ae={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((U,se)=>{this.a=U,this.b=se})}complete(U){return new Promise(se=>{this.a(U),this.d={outcome:0,value:U},se()})}error(U){return new Promise(se=>{this.b(U),this.d={outcome:1,value:U},se()})}cancel(){return this.error(new C.$5)}}e.$Th=x;var le;(function(V){async function U(he){let $e;const me=await Promise.all(he.map(ye=>ye.then(ke=>ke,ke=>{$e||($e=ke)})));if(typeof $e<"u")throw $e;return me}V.settled=U;function se(he){return new Promise(async($e,me)=>{try{await he($e,me)}catch(ye){me(ye)}})}V.withAsyncBody=se})(le||(e.Promises=le={}));class Z{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(U){this.a=void 0,this.b=void 0,this.d=!1,this.promise=U.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=Z;class A{constructor(U){this.b=U,this.a=new c.$V(()=>new Z(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=A;var N;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(N||(N={}));class _{static fromArray(U){return new _(se=>{se.emitMany(U)})}static fromPromise(U){return new _(async se=>{se.emitMany(await U)})}static fromPromises(U){return new _(async se=>{await Promise.all(U.map(async he=>se.emitOne(await he)))})}static merge(U){return new _(async se=>{await Promise.all(U.map(async he=>{for await(const $e of he)se.emitOne($e)}))})}static{this.EMPTY=_.fromArray([])}constructor(U,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new S.$ee,queueMicrotask(async()=>{const he={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(U(he)),this.k()}catch($e){this.l($e)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(U,se){return new _(async he=>{for await(const $e of U)he.emitOne(se($e))})}map(U){return _.map(this,U)}static filter(U,se){return new _(async he=>{for await(const $e of U)se($e)&&he.emitOne($e)})}filter(U){return _.filter(this,U)}static coalesce(U){return _.filter(U,se=>!!se)}coalesce(){return _.coalesce(this)}static async toPromise(U){const se=[];for await(const he of U)se.push(he);return se}toPromise(){return _.toPromise(this)}h(U){this.a===0&&(this.b.push(U),this.g.fire())}j(U){this.a===0&&(this.b=this.b.concat(U),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(U){this.a===0&&(this.a=2,this.d=U,this.g.fire())}}e.$Wh=_;class ne extends _{constructor(U,se){super(se),this.m=U}cancel(){this.m.cancel()}}e.$Xh=ne;function X(V){const U=new n.$pe,se=V(U.token);return new ne(U,async he=>{const $e=U.token.onCancellationRequested(()=>{$e.dispose(),U.dispose(),he.reject(new C.$5)});try{for await(const me of se){if(U.token.isCancellationRequested)return;he.emitOne(me)}$e.dispose(),U.dispose()}catch(me){$e.dispose(),U.dispose(),he.reject(me)}})}class H{constructor(U){this.a=new x,this.b=new _($e=>{if(se){$e.reject(se);return}return he&&$e.emitMany(he),this.d=me=>$e.reject(me),this.f=me=>$e.emitOne(me),this.a.p},U);let se,he;this.f=$e=>{he||(he=[]),he.push($e)},this.d=$e=>{se||(se=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(U){this.d(U),this.a.complete()}emitOne(U){this.f(U)}}e.$Zh=H}),define(re[108],oe([0,1,22,8,31,32,9,4,25]),function(J,e,n,C,S,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=c,e.$ok=f,e.$pk=M,e.$qk=W,e.$rk=F,e.$sk=T,e.$tk=q,e.$uk=K;function c(){return Object.create(null)}e.$mk="**",e.$nk="/";const d="[/\\\\]",b="[^/\\\\]",v=/\//g;function m(G,B){switch(G){case 0:return"";case 1:return`${b}*?`;default:return`(?:${d}|${b}+${d}${B?`|${d}${b}+`:""})*?`}}function f(G,B){if(!G)return[];const L=[];let z=!1,Q=!1,ae="";for(const x of G){switch(x){case B:if(!z&&!Q){L.push(ae),ae="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}ae+=x}return ae&&L.push(ae),L}function y(G){if(!G)return"";let B="";const L=f(G,e.$nk);if(L.every(z=>z===e.$mk))B=".*";else{let z=!1;L.forEach((Q,ae)=>{if(Q===e.$mk){if(z)return;B+=m(2,ae===L.length-1)}else{let x=!1,le="",Z=!1,A="";for(const N of Q){if(N!=="}"&&x){le+=N;continue}if(Z&&(N!=="]"||!A)){let _;N==="-"?_=N:(N==="^"||N==="!")&&!A?_="^":N===e.$nk?_="":_=(0,h.$af)(N),A+=_;continue}switch(N){case"{":x=!0;continue;case"[":Z=!0;continue;case"}":{const ne=`(?:${f(le,",").map(X=>y(X)).join("|")})`;B+=ne,x=!1,le="";break}case"]":{B+="["+A+"]",Z=!1,A="";break}case"?":B+=b;continue;case"*":B+=m(1);continue;default:B+=(0,h.$af)(N)}}ae<L.length-1&&(L[ae+1]!==e.$mk||ae+2<L.length)&&(B+=d)}z=Q===e.$mk})}return B}const p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),r=function(){return!1},s=function(){return null};function i(G,B){if(!G)return s;let L;typeof G!="string"?L=G.pattern:L=G,L=L.trim();const z=`${L}_${!!B.trimForExclusions}`;let Q=t.get(z);if(Q)return o(Q,G);let ae;return p.test(L)?Q=$(L.substr(4),L):(ae=g.exec(u(L,B)))?Q=P(ae[1],L):(B.trimForExclusions?w:l).test(L)?Q=D(L,B):(ae=k.exec(u(L,B)))?Q=I(ae[1].substr(1),L,!0):(ae=a.exec(u(L,B)))?Q=I(ae[1],L,!1):Q=O(L),t.set(z,Q),o(Q,G)}function o(G,B){if(typeof B=="string")return G;const L=function(z,Q){return(0,S.$vg)(z,B.base,!E.$k)?G((0,h.$ff)(z.substr(B.base.length),j.sep),Q):null};return L.allBasenames=G.allBasenames,L.allPaths=G.allPaths,L.basenames=G.basenames,L.patterns=G.patterns,L}function u(G,B){return B.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function $(G,B){return function(L,z){return typeof L=="string"&&L.endsWith(G)?B:null}}function P(G,B){const L=`/${G}`,z=`\\${G}`,Q=function(x,le){return typeof x!="string"?null:le?le===G?B:null:x===G||x.endsWith(L)||x.endsWith(z)?B:null},ae=[G];return Q.basenames=ae,Q.patterns=[B],Q.allBasenames=ae,Q}function D(G,B){const L=ce(G.slice(1,-1).split(",").map(le=>i(le,B)).filter(le=>le!==s),G),z=L.length;if(!z)return s;if(z===1)return L[0];const Q=function(le,Z){for(let A=0,N=L.length;A<N;A++)if(L[A](le,Z))return G;return null},ae=L.find(le=>!!le.allBasenames);ae&&(Q.allBasenames=ae.allBasenames);const x=L.reduce((le,Z)=>Z.allPaths?le.concat(Z.allPaths):le,[]);return x.length&&(Q.allPaths=x),Q}function I(G,B,L){const z=j.sep===j.$hc.sep,Q=z?G:G.replace(v,j.sep),ae=j.sep+Q,x=j.$hc.sep+G;let le;return L?le=function(Z,A){return typeof Z=="string"&&(Z===Q||Z.endsWith(ae)||!z&&(Z===G||Z.endsWith(x)))?B:null}:le=function(Z,A){return typeof Z=="string"&&(Z===Q||!z&&Z===G)?B:null},le.allPaths=[(L?"*/":"./")+G],le}function O(G){try{const B=new RegExp(`^${y(G)}$`);return function(L){return B.lastIndex=0,typeof L=="string"&&B.test(L)?G:null}}catch{return s}}function M(G,B,L){return!G||typeof B!="string"?!1:W(G)(B,void 0,L)}function W(G,B={}){if(!G)return r;if(typeof G=="string"||F(G)){const L=i(G,B);if(L===s)return r;const z=function(Q,ae){return!!L(Q,ae)};return L.allBasenames&&(z.allBasenames=L.allBasenames),L.allPaths&&(z.allPaths=L.allPaths),z}return ue(G,B)}function F(G){const B=G;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function T(G){return G.allBasenames||[]}function q(G){return G.allPaths||[]}function ue(G,B){const L=ce(Object.getOwnPropertyNames(G).map(le=>ee(le,G[le],B)).filter(le=>le!==s)),z=L.length;if(!z)return s;if(!L.some(le=>!!le.requiresSiblings)){if(z===1)return L[0];const le=function(N,_){let ne;for(let X=0,H=L.length;X<H;X++){const V=L[X](N,_);if(typeof V=="string")return V;(0,C.$ih)(V)&&(ne||(ne=[]),ne.push(V))}return ne?(async()=>{for(const X of ne){const H=await X;if(typeof H=="string")return H}return null})():null},Z=L.find(N=>!!N.allBasenames);Z&&(le.allBasenames=Z.allBasenames);const A=L.reduce((N,_)=>_.allPaths?N.concat(_.allPaths):N,[]);return A.length&&(le.allPaths=A),le}const Q=function(le,Z,A){let N,_;for(let ne=0,X=L.length;ne<X;ne++){const H=L[ne];H.requiresSiblings&&A&&(Z||(Z=(0,j.$oc)(le)),N||(N=Z.substr(0,Z.length-(0,j.$pc)(le).length)));const V=H(le,Z,N,A);if(typeof V=="string")return V;(0,C.$ih)(V)&&(_||(_=[]),_.push(V))}return _?(async()=>{for(const ne of _){const X=await ne;if(typeof X=="string")return X}return null})():null},ae=L.find(le=>!!le.allBasenames);ae&&(Q.allBasenames=ae.allBasenames);const x=L.reduce((le,Z)=>Z.allPaths?le.concat(Z.allPaths):le,[]);return x.length&&(Q.allPaths=x),Q}function ee(G,B,L){if(B===!1)return s;const z=i(G,L);if(z===s)return s;if(typeof B=="boolean")return z;if(B){const Q=B.when;if(typeof Q=="string"){const ae=(x,le,Z,A)=>{if(!A||!z(x,le))return null;const N=Q.replace("$(basename)",()=>Z),_=A(N);return(0,C.$ih)(_)?_.then(ne=>ne?G:null):_?G:null};return ae.requiresSiblings=!0,ae}}return z}function ce(G,B){const L=G.filter(le=>!!le.basenames);if(L.length<2)return G;const z=L.reduce((le,Z)=>{const A=Z.basenames;return A?le.concat(A):le},[]);let Q;if(B){Q=[];for(let le=0,Z=z.length;le<Z;le++)Q.push(B)}else Q=L.reduce((le,Z)=>{const A=Z.patterns;return A?le.concat(A):le},[]);const ae=function(le,Z){if(typeof le!="string")return null;if(!Z){let N;for(N=le.length;N>0;N--){const _=le.charCodeAt(N-1);if(_===47||_===92)break}Z=le.substr(N)}const A=z.indexOf(Z);return A!==-1?Q[A]:null};ae.basenames=z,ae.patterns=Q,ae.allBasenames=z;const x=G.filter(le=>!le.basenames);return x.push(ae),x}function K(G,B){return(0,n.$ub)(G,B,(L,z)=>typeof L=="string"&&typeof z=="string"?L===z:typeof L!="string"&&typeof z!="string"?L.base===z.base&&L.pattern===z.pattern:!1)}}),define(re[48],oe([0,1,22,31,9,4,19,25]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xw=h,e.$yw=d,e.$zw=v,e.$Aw=m,e.$Bw=g,e.$Cw=w,e.$Dw=k,e.$Ew=a,e.$Fw=t,e.$Gw=r;function h(i,o){const{os:u,tildify:$,relative:P}=o;if(P){const O=c(i,P,u);if(typeof O=="string")return O}let D=i.fsPath;if(u===1&&!R.$i?D=D.replace(/\//g,"\\"):u!==1&&R.$i&&(D=D.replace(/\\/g,"/")),u!==1&&$?.userHome){const O=$.userHome.fsPath;let M;i.scheme!==$.userHome.scheme&&i.path[0]===S.$hc.sep&&i.path[1]!==S.$hc.sep?M=$.userHome.with({path:i.path}).fsPath:M=D,D=v(M,O,u)}return(u===1?S.$gc:S.$hc).normalize(d(D,u===1))}function c(i,o,u){const $=u===1?S.$gc:S.$hc,P=u===3?j.$Zg:j.$2g,D=o.getWorkspace(),I=(0,n.$Ob)(D.folders);if(!I)return;i.scheme!==I.uri.scheme&&i.path[0]===S.$hc.sep&&i.path[1]!==S.$hc.sep&&(i=I.uri.with({path:i.path}));const O=o.getWorkspaceFolder(i);if(!O)return;let M;if(P.isEqual(O.uri,i)?M="":M=P.relativePath(O.uri,i)??"",M&&(M=$.normalize(M)),D.folders.length>1&&!o.noPrefix){const W=O.name?O.name:P.basenameOrAuthority(O.uri);M=M?`${W} \u2022 ${M}`:W}return M}function d(i,o=R.$i){return(0,C.$Ag)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}let b=Object.create(null);function v(i,o,u=R.OS){if(u===1||!i||!o)return i;let $=b.original===o?b.normalized:void 0;$||($=o,R.$i&&($=(0,C.$pg)($)),$=`${(0,E.$gf)($,S.$hc.sep)}${S.$hc.sep}`,b={original:o,normalized:$});let P=i;return R.$i&&(P=(0,C.$pg)(P)),(u===3?P.startsWith($):(0,E.$zf)(P,$))?`~/${P.substr($.length)}`:i}function m(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}const f="\u2026",y="\\\\",p="~";function g(i,o=S.sep){const u=new Array(i.length);let $=!1;for(let P=0;P<i.length;P++){const D=i[P];if(D===""){u[P]=`.${o}`;continue}if(!D){u[P]=D;continue}$=!0;let I="",O=D;O.indexOf(y)===0?(I=O.substr(0,O.indexOf(y)+y.length),O=O.substr(O.indexOf(y)+y.length)):O.indexOf(o)===0?(I=O.substr(0,O.indexOf(o)+o.length),O=O.substr(O.indexOf(o)+o.length)):O.indexOf(p)===0&&(I=O.substr(0,O.indexOf(p)+p.length),O=O.substr(O.indexOf(p)+p.length));const M=O.split(o);for(let W=1;$&&W<=M.length;W++)for(let F=M.length-W;$&&F>=0;F--){$=!1;let T=M.slice(F,F+W).join(o);for(let q=0;!$&&q<i.length;q++)if(q!==P&&i[q]&&i[q].indexOf(T)>-1){const ue=F+W===M.length,ee=F>0&&i[q].indexOf(o)>-1?o+T:T,ce=i[q].endsWith(ee);$=!ue||ce}if(!$){let q="";(M[0].endsWith(":")||I!=="")&&(F===1&&(F=0,W++,T=M[0]+o+T),F>0&&(q=M[0]+o),q=I+q),F>0&&(q=q+f+o),q=q+T,F+W<M.length&&(q=q+o+f),u[P]=q}}$&&(u[P]=D)}return u}var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function w(i,o=Object.create(null)){const u=[];let $=!1,P="";for(const D of i)if(D==="$"||$&&D==="{")P&&u.push({value:P,type:l.TEXT}),P="",$=!0;else if(D==="}"&&$){const I=o[P];if(typeof I=="string")I.length&&u.push({value:I,type:l.VARIABLE});else if(I){const O=u[u.length-1];(!O||O.type!==l.SEPARATOR)&&u.push({value:I.label,type:l.SEPARATOR})}P="",$=!1}else P+=D;return P&&!$&&u.push({value:P,type:l.TEXT}),u.filter((D,I)=>{if(D.type===l.SEPARATOR){const O=u[I-1],M=u[I+1];return[O,M].every(W=>W&&(W.type===l.VARIABLE||W.type===l.TEXT)&&W.value.length>0)}return!0}).map(D=>D.value).join("")}function k(i,o){return R.$j||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function a(i,o){return R.$j||o?i.replace(/\(&&\w\)|&&/g,""):R.$i?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function r(i){if(i.endsWith("]")){const o=i.lastIndexOf(" [",i.length-2);if(o!==-1){const u=s(i.substring(0,o)),$=i.substring(o);return{name:u.name+$,parentPath:u.parentPath}}}return s(i)}function s(i){const o=i.indexOf("/")!==-1?S.$hc:S.$gc,u=o.basename(i),$=o.dirname(i);return u.length?{name:u,parentPath:$}:{name:$,parentPath:""}}}),define(re[157],oe([0,1,17,7]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=E,e.$Bn=c,e.$Cn=d;function S(b){return b.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const m=this.a.transformIncoming(v);return m===v?v:S(C.URI.from(m))}transformOutgoing(v){const m=this.a.transformOutgoing(v);return m===v?v:S(C.URI.from(m))}transformOutgoingURI(v){const m=this.a.transformOutgoing(v);return m===v?v:C.URI.from(m)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$yn=R,e.$zn=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function j(b,v,m){if(!b||m>200)return null;if(typeof b=="object"){if(b instanceof C.URI)return v.transformOutgoing(b);for(const f in b)if(Object.hasOwnProperty.call(b,f)){const y=j(b[f],v,m+1);y!==null&&(b[f]=y)}}return null}function E(b,v){const m=j(b,v,0);return m===null?b:m}function h(b,v,m,f){if(!b||f>200)return null;if(typeof b=="object"){if(b.$mid===1)return m?C.URI.revive(v.transformIncoming(b)):v.transformIncoming(b);if(b instanceof n.$Ge)return null;for(const y in b)if(Object.hasOwnProperty.call(b,y)){const p=h(b[y],v,m,f+1);p!==null&&(b[y]=p)}}return null}function c(b,v){const m=h(b,v,!1,0);return m===null?b:m}function d(b,v){const m=h(b,v,!0,0);return m===null?b:m}}),define(re[89],oe([0,1,26,59,33,147,4]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=void 0,e.$Fn=h,e.$Gn=b,e.$En=new class{c(v){return this.a||(this.a=C.$Ci.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,m=0;const f=(0,n.networkInterfaces)();for(const y in f){const p=f[y];if(p)for(const{mac:g,internal:l}of p)l||(m+=1,this.c(g.toUpperCase())&&(v+=1))}this.b=m>0?v/m:0}return this.b}};let E;async function h(v){return E||(E=(async()=>await c(v)||S.$Sg())()),E}async function c(v){try{const m=await new Promise((y,p)=>{J(["crypto"],y,p)}),f=(0,R.$Dn)();return m.createHash("sha256").update(f,"utf8").digest("hex")}catch(m){v(m);return}}const d="Software\\Microsoft\\SQMClient";async function b(v){if(j.$i){const m=await new Promise((f,y)=>{J(["@vscode/windows-registry"],f,y)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",d,"MachineId")||""}catch(f){return v(f),""}}return""}}),define(re[21],oe([0,1,43,26,158,8,31,72,9,4,19,7]),function(J,e,n,C,S,R,j,E,h,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=p,e.readdirSync=w,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=P;var v;(function(ee){ee[ee.UNLINK=0]="UNLINK",ee[ee.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function m(ee,ce=v.UNLINK,K){if((0,j.$zg)(ee))throw new Error("rimraf - will refuse to recursively delete root");return ce===v.UNLINK?y(ee):f(ee,K)}async function f(ee,ce=(0,j.$Eg)((0,C.tmpdir)())){try{try{await n.promises.rename(ee,ce)}catch(K){return K.code==="ENOENT"?void 0:y(ee)}y(ce).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function y(ee){return(0,S.promisify)(n.rm)(ee,{recursive:!0,force:!0,maxRetries:3})}function p(ee){if((0,j.$zg)(ee))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(ee,{recursive:!0,force:!0,maxRetries:3})}async function g(ee,ce){return k(await(ce?l(ee):(0,S.promisify)(n.readdir)(ee)))}async function l(ee){try{return await(0,S.promisify)(n.readdir)(ee,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const ce=[],K=await g(ee);for(const G of K){let B=!1,L=!1,z=!1;try{const Q=await e.Promises.lstat((0,h.$kc)(ee,G));B=Q.isFile(),L=Q.isDirectory(),z=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}ce.push({name:G,isFile:()=>B,isDirectory:()=>L,isSymbolicLink:()=>z})}return ce}function w(ee){return k(n.readdirSync(ee))}function k(ee){return ee.map(ce=>typeof ce=="string"?c.$j?(0,E.$bm)(ce):ce:(ce.name=c.$j?(0,E.$bm)(ce.name):ce.name,ce))}async function a(ee){const ce=await g(ee),K=[];for(const G of ce)await r.existsDirectory((0,h.$kc)(ee,G))&&K.push(G);return K}function t(ee,ce=1e3){return new Promise(K=>{let G=!1;const B=setInterval(()=>{G||(G=!0,n.access(ee,L=>{G=!1,L&&(clearInterval(B),K(void 0))}))},ce)})}var r;(function(ee){async function ce(B){let L;try{if(L=await e.Promises.lstat(B),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(c.$i&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw Q}throw z}}ee.stat=ce;async function K(B){try{const{stat:L,symbolicLink:z}=await ee.stat(B);return L.isFile()&&z?.dangling!==!0}catch{}return!1}ee.existsFile=K;async function G(B){try{const{stat:L,symbolicLink:z}=await ee.stat(B);return L.isDirectory()&&z?.dangling!==!0}catch{}return!1}ee.existsDirectory=G})(r||(e.SymlinkSupport=r={}));const s=new R.$Fh;function i(ee,ce,K){return s.queueFor(b.URI.file(ee),()=>{const G=D(K);return new Promise((B,L)=>$(ee,ce,G,z=>z?L(z):B()))},d.$1g)}let o=!0;function u(ee){o=ee}function $(ee,ce,K,G){if(!o)return n.writeFile(ee,ce,{mode:K.mode,flag:K.flag},G);n.open(ee,K.flag,K.mode,(B,L)=>{if(B)return G(B);n.writeFile(L,ce,z=>{if(z)return n.close(L,()=>G(z));n.fdatasync(L,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),u(!1)),n.close(L,ae=>G(ae))))})})}function P(ee,ce,K){const G=D(K);if(!o)return n.writeFileSync(ee,ce,{mode:G.mode,flag:G.flag});const B=n.openSync(ee,G.flag,G.mode);try{n.writeFileSync(B,ce);try{n.fdatasyncSync(B)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),u(!1)}}finally{n.closeSync(B)}}function D(ee){return ee?{mode:typeof ee.mode=="number"?ee.mode:438,flag:typeof ee.flag=="string"?ee.flag:"w"}:{mode:438,flag:"w"}}async function I(ee,ce,K=6e4){if(ee!==ce)try{c.$i&&typeof K=="number"?await O(ee,ce,Date.now(),K):await(0,S.promisify)(n.rename)(ee,ce)}catch(G){if(ee.toLowerCase()!==ce.toLowerCase()&&G.code==="EXDEV"||ee.endsWith("."))await M(ee,ce,{preserveSymlinks:!1}),await m(ee,v.MOVE);else throw G}}async function O(ee,ce,K,G,B=0){try{return await(0,S.promisify)(n.rename)(ee,ce)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-K>=G)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${L}`),L;if(B===0){let z=!1;try{const{stat:Q}=await r.stat(ce);Q.isFile()||(z=!0)}catch{}if(z)throw L}return await(0,R.$xh)(Math.min(100,B*10)),O(ee,ce,K,G,B+1)}}async function M(ee,ce,K){return F(ee,ce,{root:{source:ee,target:ce},options:K,handledSourcePaths:new Set})}const W=511;async function F(ee,ce,K){if(K.handledSourcePaths.has(ee))return;K.handledSourcePaths.add(ee);const{stat:G,symbolicLink:B}=await r.stat(ee);if(B){if(K.options.preserveSymlinks)try{return await ue(ee,ce,K)}catch{}if(B.dangling)return}return G.isDirectory()?T(ee,ce,G.mode&W,K):q(ee,ce,G.mode&W)}async function T(ee,ce,K,G){await e.Promises.mkdir(ce,{recursive:!0,mode:K});const B=await g(ee);for(const L of B)await F((0,h.$kc)(ee,L),(0,h.$kc)(ce,L),G)}async function q(ee,ce,K){await e.Promises.copyFile(ee,ce),await e.Promises.chmod(ce,K)}async function ue(ee,ce,K){let G=await e.Promises.readlink(ee);(0,j.$vg)(G,K.root.source,!c.$k)&&(G=(0,h.$kc)(K.root.target,G.substr(K.root.source.length+1))),await e.Promises.symlink(G,ce)}e.Promises=new class{get access(){return(0,S.promisify)(n.access)}get stat(){return(0,S.promisify)(n.stat)}get lstat(){return(0,S.promisify)(n.lstat)}get utimes(){return(0,S.promisify)(n.utimes)}get read(){return(ee,ce,K,G,B)=>new Promise((L,z)=>{n.read(ee,ce,K,G,B,(Q,ae,x)=>Q?z(Q):L({bytesRead:ae,buffer:x}))})}get readFile(){return(0,S.promisify)(n.readFile)}get write(){return(ee,ce,K,G,B)=>new Promise((L,z)=>{n.write(ee,ce,K,G,B,(Q,ae,x)=>Q?z(Q):L({bytesWritten:ae,buffer:x}))})}get appendFile(){return(0,S.promisify)(n.appendFile)}get fdatasync(){return(0,S.promisify)(n.fdatasync)}get truncate(){return(0,S.promisify)(n.truncate)}get copyFile(){return(0,S.promisify)(n.copyFile)}get open(){return(0,S.promisify)(n.open)}get close(){return(0,S.promisify)(n.close)}get symlink(){return(0,S.promisify)(n.symlink)}get readlink(){return(0,S.promisify)(n.readlink)}get chmod(){return(0,S.promisify)(n.chmod)}get mkdir(){return(0,S.promisify)(n.mkdir)}get unlink(){return(0,S.promisify)(n.unlink)}get rmdir(){return(0,S.promisify)(n.rmdir)}get realpath(){return(0,S.promisify)(n.realpath)}async exists(ee){try{return await e.Promises.access(ee),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return m}get rename(){return I}get copy(){return M}}}),define(re[109],oe([0,1,43,9,4,25,21]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=E,e.$5q=h,e.$6q=c,e.$7q=d;function E(v){if(S.$k)return v;const m=(0,C.$nc)(v);if(v===m)return v;const f=((0,C.$oc)(v)||v).toLowerCase();try{const p=(0,j.readdirSync)(m).filter(g=>g.toLowerCase()===f);if(p.length===1){const g=E(m);if(g)return(0,C.$kc)(g,p[0])}else if(p.length>1){const g=p.indexOf(f);if(g>=0){const l=E(m);if(l)return(0,C.$kc)(l,p[g])}}}catch{}return null}async function h(v,m){if(S.$k)return v;const f=(0,C.$nc)(v);if(v===f)return v;const y=((0,C.$oc)(v)||v).toLowerCase();try{if(m?.isCancellationRequested)return null;const g=(await j.Promises.readdir(f)).filter(l=>l.toLowerCase()===y);if(g.length===1){const l=await h(f,m);if(l)return(0,C.$kc)(l,g[0])}else if(g.length>1){const l=g.indexOf(y);if(l>=0){const w=await h(f,m);if(w)return(0,C.$kc)(w,g[l])}}}catch{}return null}async function c(v){try{return await j.Promises.realpath(v)}catch{const f=b(v);return await j.Promises.access(f,n.constants.R_OK),f}}function d(v){try{return n.realpathSync(v)}catch{const f=b(v);return n.accessSync(f,n.constants.R_OK),f}}function b(v){return(0,R.$gf)((0,C.$ic)(v),C.sep)}}),define(re[110],oe([0,1,26,9,21]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=l,e.$lm=w;const R=/^\d+$/,j=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let d;process.env.PROCESSOR_ARCHITEW6432?d=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?d=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?d=1:d=0;class b{constructor(a,t,r){this.exePath=a,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:k=!1}={}){return k?c===0?process.env["ProgramFiles(x86)"]||null:d===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:k=!1,findPreview:a=!1}={}){const t=v({useAlternateBitness:k});if(!t)return null;const r=C.$kc(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(r))return null;let s=-1,i=null;for(const $ of await S.Promises.readdir(r)){let P=-1;if(a){const I=$.indexOf("-");if(I<0)continue;const O=$.substring(0,I);if(!R.test(O)||$.substring(I+1)!=="preview")continue;P=parseInt(O,10)}else{if(!R.test($))continue;P=parseInt($,10)}if(P<=s)continue;const D=C.$kc(r,$,"pwsh.exe");await S.SymlinkSupport.existsFile(D)&&(i=D,s=P)}if(!i)return null;const o=t.includes("x86")?" (x86)":"",u=a?" Preview":"";return new b(i,`PowerShell${u}${o}`,!0)}async function f({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const a=C.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=k?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const s of await S.Promises.readdir(a))if(t.test(s)){const i=C.$kc(a,s,"pwsh.exe");return new b(i,r)}return null}function y(){const k=C.$kc(n.homedir(),".dotnet","tools","pwsh.exe");return new b(k,".NET Core PowerShell Global Tool")}function p(){const k=C.$kc(process.env.windir,c===1&&d!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(k,"Windows PowerShell",!0)}async function*g(){let k=await m();k&&(yield k),k=await m({useAlternateBitness:!0}),k&&(yield k),k=await f(),k&&(yield k),k=y(),k&&(yield k),k=await m({findPreview:!0}),k&&(yield k),k=await f({findPreview:!0}),k&&(yield k),k=await m({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=p(),k&&(yield k)}async function*l(){for await(const k of g())await k.exists()&&(yield k)}async function w(){for await(const k of l())return k;return null}}),define(re[90],oe([0,1,9,4,36,76,12,21]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=h,e.$pm=c,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function h(b=S.env){return b.comspec||"cmd.exe"}function c(b){let v=[],m=!1;const f=function(y){if(m){v.push(y);return}(!b.send(y,g=>{if(g&&console.error(g),m=!1,v.length>0){const l=v.slice(0);v=[],l.forEach(w=>f(w))}})||C.$i)&&(m=!0)};return{send:f}}var d;(function(b){async function v(m,f,y){if(n.$jc(m))return m;if(f===void 0&&(f=S.cwd()),n.$nc(m)!=="."||(y===void 0&&j.$9f(S.env.PATH)&&(y=S.env.PATH.split(n.$uc)),y===void 0||y.length===0))return n.$kc(f,m);async function g(l){if(await E.Promises.exists(l)){let w;try{w=await E.Promises.stat(l)}catch(k){k.message.startsWith("EACCES")&&(w=await E.Promises.lstat(l))}return w?!w.isDirectory():!1}return!1}for(const l of y){let w;if(n.$jc(l)?w=n.$kc(l,m):w=n.$kc(f,l,m),await g(w))return w;let k=w+".com";if(await g(k)||(k=w+".exe",await g(k)))return k}return n.$kc(f,m)}b.findExecutable=v})(d||(e.win32=d={}))}),define(re[111],oe([0,1,49,13]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=S;function S(j){return new Promise((E,h)=>{let c;const d=new Map;function b(m,f,y,p,g){const l=d.get(f);if(m===j||l){const w={name:v(y),cmd:y,pid:m,ppid:f,load:p,mem:g};d.set(m,w),m===j&&(c=w),l&&(l.children||(l.children=[]),l.children.push(w),l.children.length>1&&(l.children=l.children.sort((k,a)=>k.pid-a.pid)))}}function v(m){const f=/--utility-sub-type=network/i,y=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,g=/conhost\.exe.+--headless/i,l=/--type=([a-zA-Z-]+)/;if(y.exec(m))return"electron-crash-reporter";if(p.exec(m))return"winpty-agent";if(g.exec(m))return"conpty-agent";let w=l.exec(m);if(w&&w.length===2)return w[1]==="renderer"?"window":w[1]==="utility"?f.exec(m)?"utility-network-service":"utility-process":w[1]==="extensionHost"?"extension-host":w[1];const k=/[a-zA-Z-]+\.js/g;let a="";do w=k.exec(m),w&&(a+=w+" ");while(w);return a&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${a})`:m}if(process.platform==="win32"){const m=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,y)=>{J(["@vscode/windows-process-tree"],f,y)}).then(f=>{f.getProcessList(j,y=>{if(!y){h(new Error(`Root process ${j} not found`));return}f.getProcessCpuUsage(y,p=>{const g=new Map;p.forEach(l=>{const w=m(l.commandLine||"");g.set(l.pid,{name:v(w),cmd:w,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),c=g.get(j),c?(g.forEach(l=>{const w=g.get(l.ppid);w&&(w.children||(w.children=[]),w.children.push(l))}),g.forEach(l=>{l.children&&(l.children=l.children.sort((w,k)=>w.pid-k.pid))}),E(c)):h(new Error(`Root process ${j} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let m=function(){let f=[c];const y=[];for(;f.length;){const g=f.shift();g&&(y.push(g.pid),g.children&&(f=f.concat(g.children)))}let p=JSON.stringify(C.$Qg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+y.join(" "),(0,n.exec)(p,{},(g,l,w)=>{if(g||w)h(g||new Error(w.toString()));else{const k=l.toString().split(`
`);for(let a=0;a<y.length;a++){const t=d.get(y[a]);t.load=parseFloat(k[a])}if(!c){h(new Error(`Root process ${j} not found`));return}E(c)}})};(0,n.exec)("which ps",{},(f,y,p)=>{if(f||p)if(process.platform!=="linux")h(f||new Error(p.toString()));else{const g=JSON.stringify(C.$Qg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(g,{},(l,w,k)=>{l||k?h(l||new Error(k.toString())):(R(w,b),m())})}else{const g=y.toString().trim();(0,n.exec)(`${g} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,k,a)=>{w||a&&!a.includes("screen size is bogus")?h(w||new Error(a.toString())):(R(k,b),process.platform==="linux"?m():c?E(c):h(new Error(`Root process ${j} not found`)))})}})}})}function R(j,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=j.toString().split(`
`);for(const d of c){const b=h.exec(d.trim());b&&b.length===6&&E(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(re[112],oe([0,1,26,4,110,90]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=j;async function j(b,v){return b===1?C.$i?d():R.$om(v):h(b,v)}let E=null;function h(b,v){if(C.$k&&b===2||C.$j&&b===3)return"/bin/bash";if(!E){let m;if(C.$i)m="/bin/bash";else{if(m=v.SHELL,!m)try{m=(0,n.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}E=m}return E}let c=null;async function d(){return c||(c=(await(0,S.$lm)()).exePath),c}});var Se=this&&this.__decorate||function(J,e,n,C){var S=arguments.length,R=S<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,n):C,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(J,e,n,C);else for(var E=J.length-1;E>=0;E--)(j=J[E])&&(R=(S<3?j(R):S>3?j(e,n,R):j(e,n))||R);return S>3&&R&&Object.defineProperty(e,n,R),R};define(re[44],oe([0,1,22,8,17,23,51,15,3,2,77,25,12]),function(J,e,n,C,S,R,j,E,h,c,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=u,e.$0h=$,e.$ci=W,e.$di=F;var m;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(m||(m={}));function f(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(y||(y={}));function p(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(g||(g={}));function l(B){let L=0;for(let z=0;;z+=7){const Q=B.read(1);if(L|=(Q.buffer[0]&127)<<z,!(Q.buffer[0]&128))return L}}const w=s(0);function k(B,L){if(L===0){B.write(w);return}let z=0;for(let ae=L;ae!==0;ae=ae>>>7)z++;const Q=S.$Ge.alloc(z);for(let ae=0;L!==0;ae++)Q.buffer[ae]=L&127,L=L>>>7,L>0&&(Q.buffer[ae]|=128);B.write(Q)}class a{constructor(L){this.b=L,this.a=0}read(L){const z=this.b.slice(this.a,this.a+L);return this.a+=z.byteLength,z}}e.$7h=a;class t{constructor(){this.a=[]}get buffer(){return S.$Ge.concat(this.a)}write(L){this.a.push(L)}}e.$8h=t;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function s(B){const L=S.$Ge.alloc(1);return L.writeUInt8(B,0),L}const i={Undefined:s(r.Undefined),String:s(r.String),Buffer:s(r.Buffer),VSBuffer:s(r.VSBuffer),Array:s(r.Array),Object:s(r.Object),Uint:s(r.Int)},o=typeof Buffer<"u";function u(B,L){if(typeof L>"u")B.write(i.Undefined);else if(typeof L=="string"){const z=S.$Ge.fromString(L);B.write(i.String),k(B,z.byteLength),B.write(z)}else if(o&&Buffer.isBuffer(L)){const z=S.$Ge.wrap(L);B.write(i.Buffer),k(B,z.byteLength),B.write(z)}else if(L instanceof S.$Ge)B.write(i.VSBuffer),k(B,L.byteLength),B.write(L);else if(Array.isArray(L)){B.write(i.Array),k(B,L.length);for(const z of L)u(B,z)}else if(typeof L=="number"&&(L|0)===L)B.write(i.Uint),k(B,L);else{const z=S.$Ge.fromString(JSON.stringify(L));B.write(i.Object),k(B,z.byteLength),B.write(z)}}function $(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(l(B)).toString();case r.Buffer:return B.read(l(B)).buffer;case r.VSBuffer:return B.read(l(B));case r.Array:{const z=l(B),Q=[];for(let ae=0;ae<z;ae++)Q.push($(B));return Q}case r.Object:return JSON.parse(B.read(l(B)).toString());case r.Int:return l(B)}}class P{constructor(L,z,Q=null,ae=1e3){this.h=L,this.j=z,this.k=Q,this.l=ae,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(L,z){this.b.set(L,z),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const z=this.o([L.type]);this.k?.logOutgoing(z,0,1,p(L.type));return}case 201:case 202:case 204:case 203:{const z=this.o([L.type,L.id],L.data);this.k?.logOutgoing(z,L.id,1,p(L.type),L.data);return}}}o(L,z=void 0){const Q=new t;return u(Q,L),u(Q,z),this.p(Q.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const z=new a(L),Q=$(z),ae=$(z),x=Q[0];switch(x){case 100:return this.k?.logIncoming(L.byteLength,Q[1],1,`${f(x)}: ${Q[2]}.${Q[3]}`,ae),this.s({type:x,id:Q[1],channelName:Q[2],name:Q[3],arg:ae});case 102:return this.k?.logIncoming(L.byteLength,Q[1],1,`${f(x)}: ${Q[2]}.${Q[3]}`,ae),this.t({type:x,id:Q[1],channelName:Q[2],name:Q[3],arg:ae});case 101:return this.k?.logIncoming(L.byteLength,Q[1],1,`${f(x)}`),this.u({type:x,id:Q[1]});case 103:return this.k?.logIncoming(L.byteLength,Q[1],1,`${f(x)}`),this.u({type:x,id:Q[1]})}}s(L){const z=this.b.get(L.channelName);if(!z){this.v(L);return}const Q=new R.$pe;let ae;try{ae=z.call(this.j,L.name,L.arg,Q.token)}catch(Z){ae=Promise.reject(Z)}const x=L.id;ae.then(Z=>{this.m({id:x,data:Z,type:201})},Z=>{Z instanceof Error?this.m({id:x,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.m({id:x,data:Z,type:203})}).finally(()=>{le.dispose(),this.d.delete(L.id)});const le=(0,c.$Tc)(()=>Q.cancel());this.d.set(L.id,le)}t(L){const z=this.b.get(L.channelName);if(!z){this.v(L);return}const Q=L.id,x=z.listen(this.j,L.name,L.arg)(le=>this.m({id:Q,data:le,type:204}));this.d.set(L.id,x)}u(L){const z=this.d.get(L.id);z&&(z.dispose(),this.d.delete(L.id))}v(L){let z=this.g.get(L.channelName);z||(z=[],this.g.set(L.channelName,z));const Q=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:L,timeoutTimer:Q})}w(L){const z=this.g.get(L);if(z){for(const Q of z)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Qc)(this.d.values()),this.d.clear()}}e.$$h=P;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class I{constructor(L,z=null){this.l=L,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=z}getChannel(L){const z=this;return{call(Q,ae,x){return z.a?Promise.reject(new E.$5):z.m(L,Q,ae,x)},listen(Q,ae){return z.a?h.Event.None:z.o(L,Q,ae)}}}m(L,z,Q,ae=R.CancellationToken.None){const x=this.g++,Z={id:x,type:100,channelName:L,name:z,arg:Q};if(ae.isCancellationRequested)return Promise.reject(new E.$5);let A;return new Promise((_,ne)=>{if(ae.isCancellationRequested)return ne(new E.$5);const X=()=>{const se=he=>{switch(he.type){case 201:this.f.delete(x),_(he.data);break;case 202:{this.f.delete(x);const $e=new Error(he.data.message);$e.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,$e.name=he.data.name,ne($e);break}case 203:this.f.delete(x),ne(he.data);break}};this.f.set(x,se),this.p(Z)};let H=null;this.b===g.Idle?X():(H=(0,C.$jh)(se=>this.u()),H.then(()=>{H=null,X()}));const V=()=>{H?(H.cancel(),H=null):this.p({id:x,type:101}),ne(new E.$5)},U=ae.onCancellationRequested(V);A=(0,c.$Sc)((0,c.$Tc)(V),U),this.d.add(A)}).finally(()=>{A.dispose(),this.d.delete(A)})}o(L,z,Q){const ae=this.g++,le={id:ae,type:102,channelName:L,name:z,arg:Q};let Z=null;const A=new h.$ee({onWillAddFirstListener:()=>{Z=(0,C.$jh)(_=>this.u()),Z.then(()=>{Z=null,this.d.add(A),this.p(le)})},onDidRemoveLastListener:()=>{Z?(Z.cancel(),Z=null):(this.d.delete(A),this.p({id:ae,type:103}))}}),N=_=>A.fire(_.data);return this.f.set(ae,N),A.event}p(L){switch(L.type){case 100:case 102:{const z=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(z,L.id,0,`${f(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const z=this.q([L.type,L.id]);this.j?.logOutgoing(z,L.id,0,f(L.type));return}}}q(L,z=void 0){const Q=new t;return u(Q,L),u(Q,z),this.r(Q.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const z=new a(L),Q=$(z),ae=$(z),x=Q[0];switch(x){case 200:return this.j?.logIncoming(L.byteLength,0,0,p(x)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,Q[1],0,p(x),ae),this.t({type:Q[0],id:Q[1],data:ae})}}t(L){if(L.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Qc)(this.d.values()),this.d.clear()}}e.$_h=I,Se([j.$1h],I.prototype,"onDidInitializePromise",null);class O{get connections(){const L=[];return this.f.forEach(z=>L.push(z)),L}constructor(L,z,Q){this.a=new Map,this.f=new Set,this.g=new h.$ee,this.onDidAddConnection=this.g.event,this.h=new h.$ee,this.onDidRemoveConnection=this.h.event,this.j=new c.$Uc,this.j.add(L(({protocol:ae,onDidClientDisconnect:x})=>{const le=h.Event.once(ae.onMessage);this.j.add(le(Z=>{const A=new a(Z),N=$(A),_=new P(ae,N,z,Q),ne=new I(ae,z);this.a.forEach((H,V)=>_.registerChannel(V,H));const X={channelServer:_,channelClient:ne,ctx:N};this.f.add(X),this.g.fire(X),this.j.add(x(()=>{_.dispose(),ne.dispose(),this.f.delete(X),this.h.fire(X)}))}))}))}getChannel(L,z){const Q=this;return{call(ae,x,le){let Z;if((0,v.$kg)(z)){const N=(0,n.$4b)(Q.connections.filter(z));Z=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(Q.onDidAddConnection,z))}else Z=z.routeCall(Q,ae,x);const A=Z.then(N=>N.channelClient.getChannel(L));return W(A).call(ae,x,le)},listen(ae,x){if((0,v.$kg)(z))return Q.k(L,z,ae,x);const le=z.routeEvent(Q,ae,x).then(Z=>Z.channelClient.getChannel(L));return W(le).listen(ae,x)}}}k(L,z,Q,ae){const x=this;let le;const Z=new h.$ee({onWillAddFirstListener:()=>{le=new c.$Uc;const A=new h.$ke,N=new Map,_=X=>{const V=X.channelClient.getChannel(L).listen(Q,ae),U=A.add(V);N.set(X,U)},ne=X=>{const H=N.get(X);H&&(H.dispose(),N.delete(X))};x.connections.filter(z).forEach(_),h.Event.filter(x.onDidAddConnection,z)(_,void 0,le),x.onDidRemoveConnection(ne,void 0,le),A.event(Z.fire,Z,le),le.add(A)},onDidRemoveLastListener:()=>{le?.dispose(),le=void 0}});return Z.event}registerChannel(L,z){this.a.set(L,z);for(const Q of this.f)Q.channelServer.registerChannel(L,z)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=O;class M{constructor(L,z,Q=null){const ae=new t;u(ae,z),L.send(ae.buffer),this.a=new I(L,Q),this.d=new P(L,z,Q)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,z){this.d.registerChannel(L,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=M;function W(B){return{call(L,z,Q){return B.then(ae=>ae.call(L,z,Q))},listen(L,z){const Q=new h.$ne;return B.then(ae=>Q.input=ae.listen(L,z)),Q.event}}}function F(B){let L=!1;return{call(z,Q,ae){return L?B.call(z,Q,ae):(0,C.$xh)(0).then(()=>L=!0).then(()=>B.call(z,Q,ae))},listen(z,Q){if(L)return B.listen(z,Q);const ae=new h.$ne;return(0,C.$xh)(0).then(()=>L=!0).then(()=>ae.input=B.listen(z,Q)),ae.event}}}class T{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const z of L.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await h.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$ei=T;var q;(function(B){function L(x,le,Z){const A=x,N=Z&&Z.disableMarshalling,_=new Map;for(const ne in A)Q(ne)&&_.set(ne,h.Event.buffer(A[ne],!0,void 0,le));return new class{listen(ne,X,H){const V=_.get(X);if(V)return V;const U=A[X];if(typeof U=="function"){if(ae(X))return U.call(A,H);if(Q(X))return _.set(X,h.Event.buffer(A[X],!0,void 0,le)),_.get(X)}throw new E.$bb(`Event not found: ${X}`)}call(ne,X,H){const V=A[X];if(typeof V=="function"){if(!N&&Array.isArray(H))for(let se=0;se<H.length;se++)H[se]=(0,d.$6h)(H[se]);let U=V.apply(A,H);return U instanceof Promise||(U=Promise.resolve(U)),U}throw new E.$bb(`Method not found: ${X}`)}}}B.fromService=L;function z(x,le){const Z=le&&le.disableMarshalling;return new Proxy({},{get(A,N){if(typeof N=="string")return le?.properties?.has(N)?le.properties.get(N):ae(N)?function(_){return x.listen(N,_)}:Q(N)?x.listen(N):async function(..._){let ne;le&&!(0,v.$fg)(le.context)?ne=[le.context,..._]:ne=_;const X=await x.call(N,ne);return Z?X:(0,d.$6h)(X)};throw new E.$bb(`Property not found: ${String(N)}`)}})}B.toService=z;function Q(x){return x[0]==="o"&&x[1]==="n"&&b.$xf(x.charCodeAt(2))}function ae(x){return/^onDynamic/.test(x)&&b.$xf(x.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ee(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const L=B.toString();if(L!=="[object Object]")return L}return B}function ce(B){return Array.isArray(B)?B.map(ee):ee(B)}function K(B,L,z,Q,ae,x,le){le=ce(le);const Z=ue[ae],A=Z[Q%Z.length];let N=[`%c[${B}]%c[${String(L).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(x)?(N=N.concat(le),N.push(")")):N.push(le),console.log.apply(console,N)}class G{constructor(L,z){this.d=L,this.f=z,this.a=0,this.b=0}logOutgoing(L,z,Q,ae,x){this.b+=L,K(this.d,this.b,L,z,Q,ae,x)}logIncoming(L,z,Q,ae,x){this.a+=L,K(this.f,this.a,L,z,Q,ae,x)}}e.$fi=G}),define(re[159],oe([0,1,17,3,44]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZW=e.$YW=void 0;class R{constructor(h){this.a=h,this.onMessage=C.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$Ge.wrap(c.data):n.$Ge.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$YW=R;class j extends S.$bi{constructor(h,c){const d=new R(h);super(d,c),this.b=d}dispose(){this.b.disconnect(),super.dispose()}}e.$ZW=j}),define(re[113],oe([0,1,17,3,2,44]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.ProtocolConstants=e.$gi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var j;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(j||(e.SocketDiagnosticsEventType=j={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let u=0;function $(D,I){if(!o.has(D)){const O=String(++u);o.set(D,O)}return o.get(D)}function P(D,I,O,M){if(!i.enableDiagnostics)return;const W=$(D,I);if(M instanceof n.$Ge||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const F=n.$Ge.alloc(M.byteLength);F.set(M),i.records.push({timestamp:Date.now(),id:W,label:I,type:O,buff:F})}else i.records.push({timestamp:Date.now(),id:W,label:I,type:O,data:M})}i.traceSocketEvent=P})(E||(e.SocketDiagnostics=E={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let c=null;function d(){return c||(c=n.$Ge.alloc(0)),c}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,u){if(o===0)return d();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const I=this.a[0];return u&&(this.a.shift(),this.b-=o),I}if(this.a[0].byteLength>o){const I=this.a[0].slice(0,o);return u&&(this.a[0]=this.a[0].slice(o),this.b-=o),I}const $=n.$Ge.alloc(o);let P=0,D=0;for(;o>0;){const I=this.a[D];if(I.byteLength>o){const O=I.slice(0,o);$.set(O,P),P+=o,u&&(this.a[D]=I.slice(o),this.b-=o),o-=o}else $.set(I,P),P+=I.byteLength,u?(this.a.shift(),this.b-=I.byteLength):D++,o-=I.byteLength}return $}}e.$gi=b;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function m(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class y{constructor(o,u,$,P){this.type=o,this.id=u,this.ack=$,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends S.$Vc{constructor(o){super(),this.f=this.B(new C.$ee),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new b,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,P=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new y($,P,D,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.$Ge.alloc(13);u.writeUInt8(o.type,0),u.writeUInt32BE(o.id,1),u.writeUInt32BE(o.ack,5),u.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(u,o.data)}g(o,u){const $=this.f===0;return this.d.push(o,u),this.f+=o.byteLength+u.byteLength,$}h(){const o=n.$Ge.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,u){this.g(o,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class l extends S.$Vc{constructor(o){super(),this.f=new C.$ee,this.onMessage=this.f.event,this.g=new C.$ee,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new g(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new y(1,0,0,o))}}e.$hi=l;class w extends R.$bi{static fromSocket(o,u){return new w(new l(o),u)}get onDidDispose(){return this.b.onDidDispose}constructor(o,u,$=null){super(o,u,$),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.$ii=w;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$ee({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.$ji=k;class a{constructor(o){this.data=o,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let o=0,u=this.a;for(;u;)u=u.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let u=0,$=this.a;for(;$;)o[u++]=$.data,$=$.next;return o}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const u=new a(o);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const o=Date.now();for(let u=0;u<r.a;u++)this.c[u]=o-1e3*u;setInterval(()=>{for(let u=r.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),u=(1+r.a)*1e3;let $=0;for(let P=0;P<r.a;P++)o-this.c[P]<=u&&$++;return 1-$/r.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(o){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=o.loadEstimator??r.getInstance(),this.t=o.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Uc,this.o=o.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),o.initialChunk&&this.q.acceptChunk(o.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const o=new y(5,0,0,d());this.p.write(o),this.p.flush()}sendPause(){const o=new y(7,0,0,d());this.p.write(o)}sendResume(){const o=new y(8,0,0,d());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,u){this.a=!0,this.r.dispose(),this.r=new S.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage($=>this.z($))),this.r.add(this.o.onClose($=>this.x.fire($))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new y(3,0,this.h,d());this.p.write(o);const u=this.b.toArray();for(let $=0,P=u.length;$<P;$++)this.p.write(u[$]);this.B()}acceptDisconnect(){this.w.fire()}z(o){if(o.ack>this.d){this.d=o.ack;do{const u=this.b.peek();if(u&&u.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new y(6,0,0,d())))}else this.g=o.id,this.j=Date.now(),this.A(),this.v.fire(o.data);break}case 2:{this.u.fire(o.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let $=0,P=u.length;$<P;$++)this.p.write(u[$]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const u=++this.c;this.h=this.g;const $=new y(1,u,this.h,o);this.b.push($),this.a||(this.p.write($),this.B())}sendControl(o){const u=new y(2,0,0,o);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-o+5)}B(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),u=Date.now()-o.writtenTime,$=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(u>=2e4&&$>=2e4&&P>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:$});return}const D=Math.max(2e4-u,2e4-$,2e4-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const o=new y(3,0,this.h,d());this.p.write(o)}D(){this.h=this.g;const o=new y(9,0,this.h,d());this.p.write(o)}}e.$ki=s}),define(re[37],oe([0,1,14,15,13]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VW=void 0;class R{constructor(){this.a=new WeakMap}on(E,h){const c=(d,...b)=>{this.b(E,d)&&h(d,...b)};return this.a.set(h,c),n.ipcMain.on(E,c),this}once(E,h){return n.ipcMain.once(E,(c,...d)=>{this.b(E,c)&&h(c,...d)}),this}handle(E,h){return n.ipcMain.handle(E,(c,...d)=>this.b(E,c)?h(c,...d):Promise.reject(`Invalid channel '${E}' or sender for ipcMain.handle() usage.`)),this}removeHandler(E){return n.ipcMain.removeHandler(E),this}removeListener(E,h){const c=this.a.get(h);return c&&(n.ipcMain.removeListener(E,c),this.a.delete(h)),this}b(E,h){if(!E||!E.startsWith("vscode:"))return(0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because the channel is unknown.`),!1;const c=h.senderFrame,d=c.url;if(!d||d==="about:blank")return!0;let b="unknown";try{b=new URL(d).host}catch{return(0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because of a malformed URL '${d}'.`),!1}return b!==S.$Pg?((0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because of a bad origin of '${b}'.`),!1):c.parent!==null?((0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.$VW=new R}),define(re[160],oe([0,1,14,37,148]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WW=R;function R(){C.$VW.on(S.$TW,(E,h,c,d,b)=>{const v=j(E,d,c);v.popup({x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{v&&E.sender.send(S.$UW,h)}})})}function j(E,h,c){const d=new n.Menu;return c.forEach(b=>{let v;b.type==="separator"?v=new n.MenuItem({type:b.type}):Array.isArray(b.submenu)?v=new n.MenuItem({submenu:j(E,h,b.submenu),label:b.label}):v=new n.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(m,f,y)=>E.sender.send(h,b.id,y)}),d.append(v)}),d}}),define(re[161],oe([0,1,37,17,3,2,44,149]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3W=void 0;function h(d,b){const v=S.Event.fromNodeEventEmitter(n.$VW,b,(f,y)=>({event:f,message:y})),m=S.Event.filter(v,({event:f})=>f.sender.id===d);return S.Event.map(m,({message:f})=>f&&C.$Ge.wrap(f))}class c extends j.$ai{static{this.b=new Map}static d(){const b=S.Event.fromNodeEventEmitter(n.$VW,"vscode:hello",({sender:v})=>v);return S.Event.map(b,v=>{const m=v.id;c.b.get(m)?.dispose();const y=new S.$ee;c.b.set(m,(0,R.$Tc)(()=>y.fire()));const p=h(m,"vscode:message"),g=S.Event.any(S.Event.signal(h(m,"vscode:disconnect")),y.event);return{protocol:new E.$2W(v,p),onDidClientDisconnect:g}})}constructor(){super(c.d())}}e.$3W=c}),define(re[114],oe([0,1,37,3,33,159]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4W=void 0,e.$5W=E;class j extends R.$ZW{constructor(c,d){super({addEventListener:(b,v)=>c.addListener(b,v),removeEventListener:(b,v)=>c.removeListener(b,v),postMessage:b=>c.postMessage(b),start:()=>c.start(),close:()=>c.close()},d)}}e.$4W=j;async function E(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,S.$Sg)();h.webContents.send("vscode:createMessageChannel",c);const d=C.Event.fromNodeEventEmitter(n.$VW,"vscode:createMessageChannelResult",(v,m)=>({nonce:m,port:v.ports[0]})),{port:b}=await C.Event.toPromise(C.Event.once(C.Event.filter(d,v=>v.nonce===c)));return b}}),define(re[162],oe([0,1,49,8,17,23,156,15,3,2,35,90,76,44]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class f extends m.$$h{constructor(g){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",l=>S.$Ge.wrap(Buffer.from(l,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$Zq=f;class y{constructor(g,l){this.i=g,this.j=l,this.c=new Set,this.g=new Map,this.h=new h.$ee,this.onDidProcessExit=this.h.event;const w=l&&l.timeout?l.timeout:6e4;this.b=new C.$th(w),this.d=null,this.f=null}getChannel(g){const l=this;return{call(w,k,a){return l.k(g,w,k,a)},listen(w,k){return l.l(g,w,k)}}}k(g,l,w,k=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const a=this.n(g),t=(0,C.$jh)(i=>a.call(l,w,i)),r=k.onCancellationRequested(()=>t.cancel()),s=(0,c.$Tc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{r.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,l,w){if(!this.b)return h.Event.None;this.b.cancel();let k;const a=new h.$ee({onWillAddFirstListener:()=>{k=this.n(g).listen(l,w)(a.fire,a),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,d.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,v.$nm)(l.env),this.d=(0,n.fork)(this.i,g,l);const w=new h.$ee,a=h.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,j.$Vq)(u)){(0,j.log)(u,`IPC Library: ${this.j.serverName}`);return}w.fire(S.$Ge.wrap(Buffer.from(u,"base64")))}),t=this.j.useQueue?(0,b.$pm)(this.d):this.d,r=u=>this.d&&this.d.connected&&t.send(u.buffer.toString("base64")),s=w.event,i={send:r,onMessage:s};this.f=new m.$_h(i);const o=()=>this.o();process.once("exit",o),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,$)=>{process.removeListener("exit",o),a.dispose(),this.c.forEach(P=>(0,c.$Qc)(P)),this.c.clear(),u!==0&&$!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+$),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:$})})}return this.f}n(g){let l=this.g.get(g);return l||(l=this.m.getChannel(g),this.g.set(g,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=y}),define(re[115],oe([0,1,8,3,2,77,12]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=h;var E;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function h(v){const m=v;return m?.changed instanceof Map||m?.deleted instanceof Set}var c;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(c||(e.StorageState=c={}));class d extends S.$Vc{static{this.a=100}constructor(m,f=Object.create(null)){super(),this.r=m,this.s=f,this.b=this.B(new C.$he),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$uh(d.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach((f,y)=>this.w(y,f)),m.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(m,f){if(this.c===c.Closed)return;let y=!1;(0,j.$fg)(f)?y=this.f.delete(m):this.f.get(m)!==f&&(this.f.set(m,f),y=!0),y&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,f){const y=this.f.get(m);return(0,j.$fg)(y)?f:y}getBoolean(m,f){const y=this.get(m);return(0,j.$fg)(y)?f:y==="true"}getNumber(m,f){const y=this.get(m);return(0,j.$fg)(y)?f:parseInt(y,10)}getObject(m,f){const y=this.get(m);return(0,j.$fg)(y)?f:(0,R.$5h)(y)}async set(m,f,y=!1){if(this.c===c.Closed)return;if((0,j.$fg)(f))return this.delete(m,y);const p=(0,j.$$f)(f)||Array.isArray(f)?(0,R.$4h)(f):String(f);if(this.f.get(m)!==p)return this.f.set(m,p),this.j.set(m,p),this.h.delete(m),this.b.fire({key:m,external:y}),this.D()}async delete(m,f=!1){if(!(this.c===c.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:f}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(this.z)return this.D(m)}async D(m){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Wp=d;class b{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((f,y)=>this.a.set(y,f)),m.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$Xp=b}),define(re[163],oe([0,1,8,3,32,9,21]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oX=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return C.Event.None}static{this.a=2e3}static{this.b=256}constructor(d,b=Object.create(null)){this.g=d,this.h=b,this.c=(0,R.$oc)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const d=await this.f,b=new Map;return(await this.s(d,"SELECT * FROM ItemTable")).forEach(m=>b.set(m.key,m.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${b.size} rows`),b}async updateItems(d){const b=await this.f;return this.j(b,d)}j(d,b){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${b.insert?(0,S.$zc)(b.insert):"0"}), delete(${b.delete?(0,S.$Ac)(b.delete):"0"})`),this.t(d,()=>{const v=b.insert,m=b.delete;if(v&&v.size>0){const f=[];f.push([]);let y=0;v.forEach((p,g)=>{let l=f[y];l.length>E.b&&(y++,l=[],f.push(l)),l.push(g,p)}),f.forEach(p=>{this.u(d,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,g=>g.run(p),()=>{const g=[];let l=0;return v.forEach((w,k)=>{g.push(k),l+=w.length}),`Keys: ${g.join(", ")} Length: ${l}`})})}if(m&&m.size){const f=[];f.push([]);let y=0;m.forEach(p=>{let g=f[y];g.length>E.b&&(y++,g=[],f.push(g)),g.push(p)}),f.forEach(p=>{this.u(d,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,g=>g.run(p),()=>{const g=[];return m.forEach(l=>{g.push(l)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const d=await this.f;return this.q(d,"VACUUM")}async close(d){this.d.trace(`[storage ${this.c}] close()`);const b=await this.f;return this.k(b,d)}k(d,b){return new Promise((v,m)=>{d.db.close(f=>(f&&this.o(d,`[storage ${this.c}] close(): ${f}`),this.g===E.IN_MEMORY_PATH?v():!d.isErroneous&&!d.isInMemory?this.l().then(v,y=>(this.d.error(`[storage ${this.c}] backup(): ${y}`),v())):typeof b=="function"?j.Promises.unlink(this.g).then(()=>this.p(this.g).then(y=>{const p=()=>this.k(y,void 0);return this.j(y,{insert:b()}).then(()=>p(),g=>(p(),Promise.reject(g)))})).then(v,m):m(f||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const d=this.m(this.g);return j.Promises.copy(this.g,d,{preserveSymlinks:!1})}m(d){return`${d}.backup`}async checkIntegrity(d){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${d})`);const b=await this.f,v=await this.r(b,d?"PRAGMA integrity_check":"PRAGMA quick_check"),m=d?v.integrity_check:v.quick_check;return b.isErroneous?`${m} (last error: ${b.lastError})`:b.isInMemory?`${m} (in-memory!)`:m}async n(d,b=!0){this.d.trace(`[storage ${this.c}] open(${d}, retryOnBusy: ${b})`);try{return await this.p(d)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&b)return await(0,n.$xh)(E.a),this.n(d,!1);try{await j.Promises.unlink(d);try{await j.Promises.rename(this.m(d),d,!1)}catch{}return await this.p(d)}catch(m){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${m}`),this.p(E.IN_MEMORY_PATH)}}}o(d,b){d.isErroneous=!0,d.lastError=b,this.d.error(b)}p(d){return new Promise((b,v)=>{new Promise((m,f)=>{J(["@vscode/sqlite3"],m,f)}).then(m=>{const f={db:new(this.d.isTracing?m.verbose().Database:m.Database)(d,y=>y?f.db&&y.code!=="SQLITE_CANTOPEN"?f.db.close(()=>v(y)):v(y):this.q(f,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(f),p=>f.db.close(()=>v(p)))),isInMemory:d===E.IN_MEMORY_PATH};f.db.on("error",y=>this.o(f,`[storage ${this.c}] Error (event): ${y}`)),this.d.isTracing&&f.db.on("trace",y=>this.d.trace(`[storage ${this.c}] Trace (event): ${y}`))},v)})}q(d,b){return new Promise((v,m)=>{d.db.exec(b,f=>f?(this.o(d,`[storage ${this.c}] exec(): ${f}`),m(f)):v())})}r(d,b){return new Promise((v,m)=>{d.db.get(b,(f,y)=>f?(this.o(d,`[storage ${this.c}] get(): ${f}`),m(f)):v(y))})}s(d,b){return new Promise((v,m)=>{d.db.all(b,(f,y)=>f?(this.o(d,`[storage ${this.c}] all(): ${f}`),m(f)):v(y))})}t(d,b){return new Promise((v,m)=>{d.db.serialize(()=>{d.db.run("BEGIN TRANSACTION"),b(),d.db.run("END TRANSACTION",f=>f?(this.o(d,`[storage ${this.c}] transaction(): ${f}`),m(f)):v())})})}u(d,b,v,m){const f=d.db.prepare(b),y=p=>{this.o(d,`[storage ${this.c}] prepare(): ${p} (${b}). Details: ${m()}`)};f.on("error",y),v(f),f.finalize(p=>{p&&y(p),f.removeListener("error",y)})}}e.$oX=E;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(d){d&&typeof d.logTrace=="function"&&process.env[h.a]&&(this.b=d.logTrace),d&&typeof d.logError=="function"&&(this.c=d.logError)}get isTracing(){return!!this.b}trace(d){this.b?.(d)}error(d){this.c?.(d)}}}),define(re[164],oe([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(re[165],oe([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[166],oe([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(re[167],oe([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(re[168],oe([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(re[169],oe([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(re[170],oe([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(re[171],oe([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(re[172],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[173],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[174],oe([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[175],oe([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[176],oe([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(re[177],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(re[178],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(re[179],oe([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(re[180],oe([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(re[181],oe([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[182],oe([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(re[183],oe([11,10]),function(J,e){return J.create("vs/platform/log/common/log",e)}),define(re[184],oe([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(re[185],oe([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(re[186],oe([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(re[187],oe([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(re[188],oe([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[189],oe([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[190],oe([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[191],oe([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(re[192],oe([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[193],oe([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(re[194],oe([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(re[195],oe([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(re[196],oe([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(re[197],oe([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(re[198],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgb=n,e.$lgb=C;function n(S){return S&&S.hasOwnProperty("folderUri")}function C(S){return S&&S.hasOwnProperty("workspace")}}),define(re[199],oe([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=C,e.$Gbc=S,e.$Hbc=R;function C(j){return typeof j?.backupFolder=="string"}function S(j){let E=[];try{Array.isArray(j.workspaces)&&(E=j.workspaces.map(h=>({workspace:{id:h.id,configPath:n.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return E}function R(j){let E=[];try{Array.isArray(j.folders)&&(E=j.folders.map(h=>({folderUri:n.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return E}}),define(re[200],oe([0,1,15,167]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var S;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(S||(e.TokenType=S={}));function R(...c){switch(c.length){case 1:return(0,C.localize)(0,null,c[0]);case 2:return(0,C.localize)(1,null,c[0],c[1]);case 3:return(0,C.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,C.localize)(3,null),E=(0,C.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return d.isTripleEq?"===":"==";case 4:return d.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return d.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return d.lexeme;case 18:return d.lexeme;case 19:return d.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const b=this.d,v=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:v};this.g.push({offset:b,lexeme:v,additionalInfo:d}),this.f.push(m)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const b=this.c.substring(this.d,this.e),v=h.b.get(b);v?this.k(v):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,b=!1,v=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(E);return}const f=this.c.charCodeAt(d);if(b)b=!1;else if(f===47&&!v){d++;break}else f===91?v=!0:f===92?b=!0:f===93&&(v=!1);d++}for(;d<this.c.length&&h.a.has(this.c.charCodeAt(d));)d++;this.e=d;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=h}),define(re[201],oe([0,1,3,2]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=void 0;class S{constructor(){this.a=new n.$ee,this.b=new n.$ee,this.c=new n.$ee,this.d=new n.$ee}static{this.ChannelName="extensionhostdebugservice"}call(E,h,c){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(E,h,c){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Io=S;class R extends C.$Vc{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,h,c){this.b.call("attach",[E,h,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,h){this.b.call("terminate",[E,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,h){return this.b.call("openExtensionDevelopmentHostWindow",[E,h])}}e.$Jo=R}),define(re[202],oe([0,1,151,51,13,9,36,19,7]),function(J,e,n,C,S,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=d,e.$8m=b,e.$5m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,R.$nc)(S.$Qg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,R.$kc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,E.$0g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$0g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,n.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.$kc)(this.userDataPath,"logs",m)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$0g)(h.URI.file((0,R.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$0g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$0g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$0g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=j.env.VSCODE_PORTABLE;return m?h.URI.file((0,R.$kc)(m,"argv.json")):(0,E.$0g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,R.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,R.$lc)(m):(0,R.$ic)((0,R.$kc)(S.$Qg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?h.URI.file((0,R.$lc)(m)):h.URI.file((0,R.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,R.$lc)(m);const f=j.env.VSCODE_EXTENSIONS;if(f)return f;const y=j.env.VSCODE_PORTABLE;return y?(0,R.$kc)(y,"extensions"):(0,E.$0g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(f=>/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,R.$ic)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?h.URI.parse(m):h.URI.file((0,R.$ic)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return d(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$5m.test(m))}get extensionLogLevel(){const m=[];for(const f of this.args.log||[]){const y=e.$5m.exec(f);y&&y[1]&&y[2]&&m.push([y[1],y[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,E.$0g)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=j.env.VSCODE_PORTABLE;return m?h.URI.file((0,R.$kc)(m,"policy.json")):(0,E.$0g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,f,y){this.a=m,this.b=f,this.c=y,this.editSessionId=this.args.editSessionId}}e.$6m=c,Se([C.$1h],c.prototype,"appRoot",null),Se([C.$1h],c.prototype,"userHome",null),Se([C.$1h],c.prototype,"userDataPath",null),Se([C.$1h],c.prototype,"appSettingsHome",null),Se([C.$1h],c.prototype,"tmpDir",null),Se([C.$1h],c.prototype,"cacheHome",null),Se([C.$1h],c.prototype,"stateResource",null),Se([C.$1h],c.prototype,"userRoamingDataHome",null),Se([C.$1h],c.prototype,"userDataSyncHome",null),Se([C.$1h],c.prototype,"sync",null),Se([C.$1h],c.prototype,"machineSettingsResource",null),Se([C.$1h],c.prototype,"workspaceStorageHome",null),Se([C.$1h],c.prototype,"localHistoryHome",null),Se([C.$1h],c.prototype,"keyboardLayoutResource",null),Se([C.$1h],c.prototype,"argvResource",null),Se([C.$1h],c.prototype,"isExtensionDevelopment",null),Se([C.$1h],c.prototype,"untitledWorkspacesHome",null),Se([C.$1h],c.prototype,"builtinExtensionsPath",null),Se([C.$1h],c.prototype,"extensionsPath",null),Se([C.$1h],c.prototype,"extensionDevelopmentLocationURI",null),Se([C.$1h],c.prototype,"extensionDevelopmentKind",null),Se([C.$1h],c.prototype,"extensionTestsLocationURI",null),Se([C.$1h],c.prototype,"debugExtensionHost",null),Se([C.$1h],c.prototype,"logLevel",null),Se([C.$1h],c.prototype,"extensionLogLevel",null),Se([C.$1h],c.prototype,"serviceMachineIdResource",null),Se([C.$1h],c.prototype,"disableTelemetry",null),Se([C.$1h],c.prototype,"disableWorkspaceTrust",null),Se([C.$1h],c.prototype,"useInMemorySecretStorage",null),Se([C.$1h],c.prototype,"policyFile",null);function d(v,m){return b(v["inspect-extensions"],v["inspect-brk-extensions"],5870,m,v.debugId,v.extensionEnvironment)}function b(v,m,f,y,p,g){const w=Number(m||v)||(y?null:f),k=w?!!m:!1;let a;if(g)try{a=JSON.parse(g)}catch{}return{port:w,break:k,debugId:p,env:a}}}),define(re[116],oe([0,1,313,4,170]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0,e.$tm=E,e.$um=c,e.$vm=m,e.$wm=f;const R={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$rm=["tunnel","serve-web"],e.$sm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(y,p,g=j){const l=y.find(u=>u.length>0&&u[0]!=="-"),w={},k=["_"],a=[],t={};let r;for(const u in p){const $=p[u];$.type==="subcommand"?u===l&&(r=$):($.alias&&(w[u]=$.alias),$.type==="string"||$.type==="string[]"?(k.push(u),$.deprecates&&k.push(...$.deprecates)):$.type==="boolean"&&(a.push(u),$.deprecates&&a.push(...$.deprecates)),$.global&&(t[u]=$))}if(r&&l){const u=t;for(const I in r.options)u[I]=r.options[I];const $=y.filter(I=>I!==l),P=g.getSubcommandReporter?g.getSubcommandReporter(l):void 0,D=E($,u,P);return{[l]:D,_:[]}}const s=n(y,{string:k,boolean:a,alias:w}),i={},o=s;i._=s._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(const u in p){const $=p[u];if($.type==="subcommand")continue;$.alias&&delete o[$.alias];let P=o[u];if($.deprecates)for(const D of $.deprecates)o.hasOwnProperty(D)&&(P||(P=o[D],P&&g.onDeprecatedOption(D,$.deprecationMessage||(0,S.localize)(38,null,u))),delete o[D]);if(typeof P<"u"){if($.type==="string[]"){if(Array.isArray(P)||(P=[P]),!$.allowEmptyValue){const D=P.filter(I=>I.length>0);D.length!==P.length&&(g.onEmptyValue(u),P=D.length>0?D:void 0)}}else $.type==="string"&&(Array.isArray(P)?(P=P.pop(),g.onMultipleValues(u,P)):!P&&!$.allowEmptyValue&&(g.onEmptyValue(u),P=void 0));i[u]=P,$.deprecationMessage&&g.onDeprecatedOption(u,$.deprecationMessage)}delete o[u]}for(const u in o)g.onUnknownOption(u);return i}function h(y,p){let g="";return p.args&&(Array.isArray(p.args)?g=` <${p.args.join("> <")}>`:g=` <${p.args}>`),p.alias?`-${p.alias} --${y}${g}`:`--${y}${g}`}function c(y,p){const g=[];for(const l in y){const w=y[l],k=h(l,w);g.push([k,w.description])}return d(g,p)}function d(y,p){const l=y.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(p-l<25)return y.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const w=p-l-1,k=[];for(const a of y){const t=a[0],r=v(a[1],w),s=b(l-t.length-2);k.push("  "+t+s+r[0]);for(let i=1;i<r.length;i++)k.push(b(l)+r[i])}return k}function b(y){return" ".repeat(y)}function v(y,p){const g=[];for(;y.length;){const l=y.length<p?y.length:y.lastIndexOf(" ",p),w=y.slice(0,l).trim();y=y.slice(l),g.push(w)}return g}function m(y,p,g,l,w){const k=process.stdout.isTTY&&process.stdout.columns||80,a=w?.noInputFiles!==!0?`[${(0,S.localize)(39,null)}...]`:"",t=[`${y} ${g}`];t.push(""),t.push(`${(0,S.localize)(40,null)}: ${p} [${(0,S.localize)(41,null)}]${a}`),t.push(""),w?.noPipe!==!0&&(C.$i?t.push((0,S.localize)(42,null,p)):t.push((0,S.localize)(43,null,p)),t.push(""));const r={},s=[];for(const i in l){const o=l[i];if(o.type==="subcommand")o.description&&s.push({command:i,description:o.description});else if(o.description&&o.cat){let u=r[o.cat];u||(r[o.cat]=u={}),u[i]=o}}for(const i in r){const o=i,u=r[o];u&&(t.push(R[o]),t.push(...c(u,k)),t.push(""))}return s.length&&(t.push((0,S.localize)(44,null)),t.push(...d(s.map(i=>[i.command,i.description]),k)),t.push("")),t.join(`
`)}function f(y,p){return`${y||(0,S.localize)(45,null)}
${p||(0,S.localize)(46,null)}
${process.arch}`}}),define(re[203],oe([0,1,88,201,116]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;class R extends C.$Io{constructor(E){super(),this.f=E}call(E,h,c){return h==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(E,h,c)}async g(E,h){const c=(0,S.$tm)(E,S.$sm);c.debugRenderer=h;const d=c.extensionDevelopmentPath;if(!d)return{success:!1};const[b]=await this.f.openExtensionDevelopmentHostWindow(d,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!h)return{success:!0};const v=b.win;if(!v)return{success:!0};const m=v.webContents.debugger;let f=m.isAttached()?1/0:0;const y=(0,n.createServer)(p=>{f++===0&&m.attach();let g=!1;const l=a=>{g||p.write(JSON.stringify(a)+"\0")},w=(a,t,r,s)=>l({method:t,params:r,sessionId:s});v.on("close",()=>{m.removeListener("message",w),p.end(),g=!0}),m.addListener("message",w);let k=Buffer.alloc(0);p.on("data",a=>{k=Buffer.concat([k,a]);for(let t=k.indexOf(0);t!==-1;t=k.indexOf(0)){let r;try{const s=k.slice(0,t).toString("utf8");k=k.slice(t+1),r=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}m.sendCommand(r.method,r.params,r.sessionId).then(s=>l({id:r.id,sessionId:r.sessionId,result:s})).catch(s=>l({id:r.id,sessionId:r.sessionId,error:{code:0,message:s.message}}))}}),p.on("error",a=>{console.error("error on cdp pipe:",a)}),p.on("close",()=>{g=!0,--f===0&&m.detach()})});return await new Promise(p=>y.listen(0,p)),v.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.$hcc=R}),define(re[64],oe([0,1,314,171,116]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=E,e.$ym=h,e.$zm=c,e.$Am=d;function R(b,v){const m=(w,k)=>{console.warn((0,C.localize)(0,null,w,k))},f=w=>{console.warn((0,C.localize)(1,null,w))},y=(w,k)=>{console.warn((0,C.localize)(2,null,w,k))},p=w=>({onUnknownOption:k=>{S.$rm.includes(w)||console.warn((0,C.localize)(3,null,k,w))},onMultipleValues:m,onEmptyValue:f,onDeprecatedOption:y,getSubcommandReporter:S.$rm.includes(w)?p:void 0}),g={onUnknownOption:w=>{console.warn((0,C.localize)(4,null,w))},onMultipleValues:m,onEmptyValue:f,onDeprecatedOption:y,getSubcommandReporter:p},l=(0,S.$tm)(b,S.$sm,v?g:void 0);return l.goto&&l._.forEach(w=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(w),(0,C.localize)(5,null))),l}function j(b){const v=b.findIndex(m=>!/^-/.test(m));if(v>-1)return[...b.slice(0,v),...b.slice(v+1)]}function E(b){let[,...v]=b;process.env.VSCODE_DEV&&(v=j(v)||[]);const m=!d(process.env);return R(v,m)}function h(b){let[,,...v]=b;return process.env.VSCODE_DEV&&(v=j(v)||[]),R(v,!0)}function c(b,...v){const m=b.indexOf("--");return m===-1?b.push(...v):b.splice(m,0,...v),b}function d(b){return b.VSCODE_CLI==="1"}}),function(){"use strict";function J(e,n,C){function S(j,E){const h=R(j,E),c=[h];return e.isAbsolute(h)||c.unshift(C),e.resolve(...c)}function R(j,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,E);const d=j["user-data-dir"];if(d)return d;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(b,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,E)}return{getUserDataPath:S}}if(typeof define=="function")define(re[204],oe([117,26,36]),function(e,n,C){return J(e,n,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=J(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[91],oe([0,1,26,202,204]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=j,e.$$m=E;class R extends C.$6m{constructor(c,d){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,S.getUserDataPath)(c,d.nameShort)},d)}}e.$9m=R;function j(h,c){return(0,C.$8m)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}function E(h,c){return(0,C.$8m)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}}),define(re[205],oe([0,1,43,26,31]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=R;function R(j){const E=(0,S.$Eg)((0,C.tmpdir)());try{return(0,n.writeFileSync)(E,""),j&&console.log(`Marker file for --wait created: ${E}`),E}catch(h){j&&console.error(`Failed to create marker file for --wait: ${h}`);return}}}),define(re[206],oe([0,1,12,173]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=S;function S(j,E,h,c){try{R(j,E,h,c)}catch(d){j.error(d?.message??d)}return E}function R(j,E,h,c){const d=(b,v,m)=>{const f=b[v];if((0,n.$9f)(f)){const y=f,p=y.length;if(p>1&&y[0]==="%"&&y[p-1]==="%"){const g=y.substr(1,p-2);let l=h[g];l===void 0&&c&&(l=c[g]);const w=typeof l=="string"?l:l?.message,k=c?.[g],a=typeof k=="string"?k:k?.message;if(!w){a||j.warn(`[${E.name}]: ${(0,C.localize)(0,null,g)}`);return}if(m&&(v==="title"||v==="category")&&a&&a!==w){const t={value:w,original:a};b[v]=t}else b[v]=w}}else if((0,n.$$f)(f))for(const y in f)f.hasOwnProperty(y)&&(y==="commands"?d(f,y,!0):d(f,y,m));else if(Array.isArray(f))for(let y=0;y<f.length;y++)d(f,y,m)};for(const b in E)E.hasOwnProperty(b)&&d(E,b)}}),define(re[207],oe([0,1,19,74,175,208]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=h,e.$Hp=c,e.$Ip=d,e.$Jp=b,e.$Kp=v,e.$Lp=m,e.$Mp=f;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function h(g){return g=g.trim(),g==="*"||j.test(g)}function c(g){if(!h(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=g.match(j);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}function d(g){if(!g)return null;const l=g.majorBase,w=g.majorMustEqual,k=g.minorBase;let a=g.minorMustEqual;const t=g.patchBase;let r=g.patchMustEqual;g.hasCaret&&(l===0||(a=!1),r=!1);let s=0;if(g.preRelease){const i=E.exec(g.preRelease);if(i){const[,o,u,$]=i;s=Date.UTC(Number(o),Number(u)-1,Number($))}}return{majorBase:l,majorMustEqual:w,minorBase:k,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:g.hasGreaterEquals,notBefore:s}}function b(g,l,w){let k;typeof g=="string"?k=d(c(g)):k=g;let a;l instanceof Date?a=l.getTime():typeof l=="string"&&(a=new Date(l).getTime());let t;if(typeof w=="string"?t=d(c(w)):t=w,!k||!t)return!1;const r=k.majorBase,s=k.minorBase,i=k.patchBase;let o=t.majorBase,u=t.minorBase,$=t.patchBase;const P=t.notBefore;let D=t.majorMustEqual,I=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?r>o?!0:r<o?!1:s>u?!0:s<u||a&&a<P?!1:i>=$:(r===1&&o===0&&(!D||!I||!O)&&(o=1,u=0,$=0,D=!0,I=!1,O=!1),r<o?!1:r>o?!D:s<u?!1:s>u?!I:i<$?!1:i>$?!O:!(a&&a<P))}function v(g,l,w,k,a){const t=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return t.push([C.default.Error,S.localize(0,null)]),t;if(typeof k.name!="string")return t.push([C.default.Error,S.localize(1,null,"name")]),t;if(typeof k.version!="string")return t.push([C.default.Error,S.localize(2,null,"version")]),t;if(!k.engines)return t.push([C.default.Error,S.localize(3,null,"engines")]),t;if(typeof k.engines.vscode!="string")return t.push([C.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof k.extensionDependencies<"u"&&!p(k.extensionDependencies))return t.push([C.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof k.activationEvents<"u"){if(!p(k.activationEvents))return t.push([C.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof k.main>"u"&&typeof k.browser>"u")return t.push([C.default.Error,S.localize(7,null,"activationEvents","main","browser")]),t}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&t.push([C.default.Warning,S.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return t.push([C.default.Error,S.localize(9,null,"main")]),t;{const i=(0,n.$0g)(w,k.main);(0,n.$4g)(i,w)||t.push([C.default.Warning,S.localize(10,null,i.path,w.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return t.push([C.default.Error,S.localize(11,null,"browser")]),t;{const i=(0,n.$0g)(w,k.browser);(0,n.$4g)(i,w)||t.push([C.default.Warning,S.localize(12,null,i.path,w.path)])}}if(!R.valid(k.version))return t.push([C.default.Error,S.localize(13,null)]),t;const r=[];if(!m(g,l,k,a,r))for(const i of r)t.push([C.default.Error,i]);return t}function m(g,l,w,k,a){return k||typeof w.main>"u"&&typeof w.browser>"u"?!0:y(g,l,w.engines.vscode,a)}function f(g,l,w){return g==="*"||y(l,w,g)}function y(g,l,w,k=[]){const a=d(c(w));if(!a)return k.push(S.localize(14,null,w)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return k.push(S.localize(15,null,w)),!1}else if(!a.majorMustEqual)return k.push(S.localize(16,null,w)),!1;return b(g,l,a)?!0:(k.push(S.localize(17,null,g,w)),!1)}function p(g){if(!Array.isArray(g))return!1;for(let l=0,w=g.length;l<w;l++)if(typeof g[l]!="string")return!1;return!0}}),define(re[209],oe([0,1,17,33]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=S;async function S(R,j,E){let h=E&&E.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const d=(await j.readFile(R.serviceMachineIdResource)).value.toString();h=(0,C.$Rg)(d)?d:null}catch{h=null}if(!h){h=(0,C.$Sg)();try{await j.writeFile(R.serviceMachineIdResource,n.$Ge.fromString(h))}catch{}}return E?.store("storage.serviceMachineId",h,-1,1),h}}),define(re[78],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class n{constructor(S,R=[],j=!1){this.ctor=S,this.staticArguments=R,this.supportsDelayedInstantiation=j}}e.$ti=n}),define(re[210],oe([0,1,78]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=R,e.$ys=j;const C=[];var S;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function R(E,h,c){h instanceof n.$ti||(h=new n.$ti(h,[],!!c)),C.push([E,h])}function j(){return C}}),define(re[211],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class n{constructor(R,j){this.key=R,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$ar=n;class C{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const j of this.a.values())j.outgoing.size===0&&R.push(j);return R}insertEdge(R,j){const E=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(j);E.outgoing.set(h.key,h),h.incoming.set(E.key,E)}removeNode(R){const j=this.b(R);this.a.delete(j);for(const E of this.a.values())E.outgoing.delete(j),E.incoming.delete(j)}lookupOrInsertNode(R){const j=this.b(R);let E=this.a.get(j);return E||(E=new n(j,R),this.a.set(j,E)),E}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[j,E]of this.a)R.push(`${j}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,j]of this.a){const E=new Set([R]),h=this.c(j,E);if(h)return h}}c(R,j){for(const[E,h]of R.outgoing){if(j.has(E))return[...j,E].join(" -> ");j.add(E);const c=this.c(h,j);if(c)return c;j.delete(E)}}}e.$br=C}),define(re[6],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=S,e.$xi=R;var n;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function E(h){return h[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=E})(n||(e._util=n={})),e.$vi=S("instantiationService");function C(j,E,h){E[n.DI_TARGET]===E?E[n.DI_DEPENDENCIES].push({id:j,index:h}):(E[n.DI_DEPENDENCIES]=[{id:j,index:h}],E[n.DI_TARGET]=E)}function S(j){if(n.serviceIds.has(j))return n.serviceIds.get(j);const E=function(h,c,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(E,h,d)};return E.toString=()=>j,n.serviceIds.set(j,E),E}function R(j){return j}}),define(re[79],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0,e.$zcc=(0,n.$wi)("auxiliaryWindowsMainService")}),define(re[65],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0,e.$Ibc=(0,n.$wi)("backupMainService")}),define(re[18],oe([0,1,12,7,6]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=R,e.$5i=j,e.$6i=h,e.$7i=c,e.$8i=d,e.$9i=b,e.$0i=v,e.$$i=f,e.$_i=y,e.$aj=p,e.$3i=(0,S.$wi)("configurationService");function R(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof C.URI)}function j(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof C.URI)}var E;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function h(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function c(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}function d(g,l){const w=Object.create(null);for(const k in g)b(w,k,g[k],l);return w}function b(g,l,w,k){const a=l.split("."),t=a.pop();let r=g;for(let s=0;s<a.length;s++){const i=a[s];let o=r[i];switch(typeof o){case"undefined":o=r[i]=Object.create(null);break;case"object":if(o===null){k(`Ignoring ${l} as ${a.slice(0,s+1).join(".")} is null`);return}break;default:k(`Ignoring ${l} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[t]=w}catch{k(`Ignoring ${l} as ${a.join(".")} is ${JSON.stringify(r)}`)}else k(`Ignoring ${l} as ${a.join(".")} is ${JSON.stringify(r)}`)}function v(g,l){const w=l.split(".");m(g,w)}function m(g,l){const w=l.shift();if(l.length===0){delete g[w];return}if(Object.keys(g).indexOf(w)!==-1){const k=g[w];typeof k=="object"&&!Array.isArray(k)&&(m(k,l),Object.keys(k).length===0&&delete g[w])}}function f(g,l,w){function k(r,s){let i=r;for(const o of s){if(typeof i!="object"||i===null)return;i=i[o]}return i}const a=l.split("."),t=k(g,a);return typeof t>"u"?w:t}function y(g,l,w){Object.keys(l).forEach(k=>{k!=="__proto__"&&(k in g?n.$$f(g[k])&&n.$$f(l[k])?y(g[k],l[k],w):w&&(g[k]=l[k]):g[k]=l[k])})}function p(g){return g.replace(/[\[\]]/g,"")}}),define(re[118],oe([0,1,4,25,200,6,166,15]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=c,e.$vj=r,e.$wj=s,e.$Pj=ae;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",n.$j),h.set("isLinux",n.$k),h.set("isWindows",n.$i),h.set("isWeb",n.$o),h.set("isMacNative",n.$j&&!n.$o),h.set("isEdge",n.$H),h.set("isFirefox",n.$F),h.set("isChrome",n.$E),h.set("isSafari",n.$G);function c(Z,A){if(h.get(Z)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(Z,A)}const d=Object.prototype.hasOwnProperty;var b;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const v={regexParsingWithErrorRecovery:!0},m=(0,j.localize)(0,null),f=(0,j.localize)(1,null),y=(0,j.localize)(2,null),p=(0,j.localize)(3,null),g=(0,j.localize)(4,null),l=(0,j.localize)(5,null),w=(0,j.localize)(6,null),k=(0,j.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=v){this.k=A,this.d=new S.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const _=this.D(),ne=_.type===17?l:void 0;throw this.h.push({message:g,offset:_.offset,lexeme:S.$rj.getLexeme(_),additionalInfo:ne}),a.c}return N}catch(N){if(N!==a.c)throw N;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(16);){const N=this.o();A.push(N)}return A.length===1?A[0]:t.or(...A)}o(){const A=[this.s()];for(;this.y(15);){const N=this.s();A.push(N)}return A.length===1?A[0]:t.and(...A)}s(){if(this.y(2)){const A=this.D();switch(A.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,p),N?.negate()}case 17:return this.z(),M.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,p),N}case 17:{const N=A.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const X=ne.lexeme,H=X.lastIndexOf("/"),V=H===X.length-1?void 0:this.w(X.substring(H+1));let U;try{U=new RegExp(X.substring(1,H),V)}catch{throw this.B("REGEX",ne)}return ee.create(N,U)}switch(ne.type){case 10:case 19:{const X=[ne.lexeme];this.z();let H=this.D(),V=0;for(let me=0;me<ne.lexeme.length;me++)ne.lexeme.charCodeAt(me)===40?V++:ne.lexeme.charCodeAt(me)===41&&V--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:V++;break;case 1:V--;break;case 10:case 18:for(let me=0;me<H.lexeme.length;me++)H.lexeme.charCodeAt(me)===40?V++:ne.lexeme.charCodeAt(me)===41&&V--}if(V<0)break;X.push(S.$rj.getLexeme(H)),this.z(),H=this.D()}const U=X.join(""),se=U.lastIndexOf("/"),he=se===U.length-1?void 0:this.w(U.substring(se+1));let $e;try{$e=new RegExp(U.substring(1,se),he)}catch{throw this.B("REGEX",ne)}return t.regex(N,$e)}case 18:{const X=ne.lexeme;this.z();let H=null;if(!(0,C.$8e)(X)){const V=X.indexOf("/"),U=X.lastIndexOf("/");if(V!==U&&V>=0){const se=X.slice(V+1,U),he=X[U+1]==="i"?"i":"";try{H=new RegExp(se,he)}catch{throw this.B("REGEX",ne)}}}if(H===null)throw this.B("REGEX",ne);return ee.create(N,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const ne=this.u();return t.notIn(N,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return t.equals(N,ne);switch(ne){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return t.notEquals(N,ne);switch(ne){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,ne)}}case 5:return this.z(),q.create(N,this.u());case 6:return this.z(),ue.create(N,this.u());case 7:return this.z(),F.create(N,this.u());case 8:return this.z(),T.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:w,offset:A.offset,lexeme:"",additionalInfo:k}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case 17:case 18:return this.z(),A.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,N){if(this.C(A))return this.z();throw this.B(N,this.D())}B(A,N,_){const ne=(0,j.localize)(8,null,A,S.$rj.getLexeme(N)),X=N.offset,H=S.$rj.getLexeme(N);return this.h.push({message:ne,offset:X,lexeme:H,additionalInfo:_}),a.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=a;class t{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(A){return $.create(A)}static equals(A,N){return P.create(A,N)}static notEquals(A,N){return O.create(A,N)}static regex(A,N){return ee.create(A,N)}static in(A,N){return D.create(A,N)}static notIn(A,N){return I.create(A,N)}static not(A){return M.create(A)}static and(...A){return G.create(A,null,!0)}static or(...A){return B.create(A,null,!0)}static greater(A,N){return F.create(A,N)}static greaterEquals(A,N){return T.create(A,N)}static smaller(A,N){return q.create(A,N)}static smallerEquals(A,N){return ue.create(A,N)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$uj=t;function r(Z){const A=new a({regexParsingWithErrorRecovery:!1});return Z.map(N=>(A.parse(N),A.lexingErrors.length>0?A.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,j.localize)(9,null,_.additionalInfo):(0,j.localize)(10,null),offset:_.offset,length:_.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function s(Z,A){const N=Z?Z.substituteConstants():void 0,_=A?A.substituteConstants():void 0;return!N&&!_?!0:!N||!_?!1:N.equals(_)}function i(Z,A){return Z.cmp(A)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return u.INSTANCE}}e.$xj=o;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return o.INSTANCE}}e.$yj=u;class ${static create(A,N=null){const _=h.get(A);return typeof _=="boolean"?_?u.INSTANCE:o.INSTANCE:new $(A,N)}constructor(A,N){this.key=A,this.c=N,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:z(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=h.get(this.key);return typeof A=="boolean"?A?u.INSTANCE:o.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$zj=$;class P{static create(A,N,_=null){if(typeof N=="boolean")return N?$.create(A,_):M.create(A,_);const ne=h.get(A);return typeof ne=="boolean"?N===(ne?"true":"false")?u.INSTANCE:o.INSTANCE:new P(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=h.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?u.INSTANCE:o.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Aj=P;class D{static create(A,N){return new D(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.f),_=A.getValue(this.d);return Array.isArray(N)?N.includes(_):typeof _=="string"&&typeof N=="object"&&N!==null?d.call(N,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$Bj=D;class I{static create(A,N){return new I(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=11,this.c=D.create(A,N)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=I;class O{static create(A,N,_=null){if(typeof N=="boolean")return N?M.create(A,_):$.create(A,_);const ne=h.get(A);return typeof ne=="boolean"?N===(ne?"true":"false")?o.INSTANCE:u.INSTANCE:new O(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=h.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?o.INSTANCE:u.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Dj=O;class M{static create(A,N=null){const _=h.get(A);return typeof _=="boolean"?_?o.INSTANCE:u.INSTANCE:new M(A,N)}constructor(A,N){this.c=A,this.d=N,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:z(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=h.get(this.c);return typeof A=="boolean"?A?o.INSTANCE:u.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$Ej=M;function W(Z,A){if(typeof Z=="string"){const N=parseFloat(Z);isNaN(N)||(Z=N)}return typeof Z=="string"||typeof Z=="number"?A(Z):o.INSTANCE}class F{static create(A,N,_=null){return W(N,ne=>new F(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Fj=F;class T{static create(A,N,_=null){return W(N,ne=>new T(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Gj=T;class q{static create(A,N,_=null){return W(N,ne=>new q(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Hj=q;class ue{static create(A,N,_=null){return W(N,ne=>new ue(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:Q(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Ij=ue;class ee{static create(A,N){return new ee(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return N<_?-1:N>_?1:0}equals(A){if(A.type===this.type){const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return this.d===A.d&&N===_}return!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Jj=ee;class ce{static create(A){return new ce(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new ce(this.c.map(A))}negate(){return this.c}}e.$Kj=ce;function K(Z){let A=null;for(let N=0,_=Z.length;N<_;N++){const ne=Z[N].substituteConstants();if(Z[N]!==ne&&A===null){A=[];for(let X=0;X<N;X++)A[X]=Z[X]}A!==null&&(A[N]=ne)}return A===null?Z:A}class G{static create(A,N,_){return G.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const ne=i(this.expr[N],A.expr[N]);if(ne!==0)return ne}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=K(this.expr);return A===this.expr?this:G.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].evaluate(A))return!1;return!0}static d(A,N,_){const ne=[];let X=!1;for(const H of A)if(H){if(H.type===1){X=!0;continue}if(H.type===0)return o.INSTANCE;if(H.type===6){ne.push(...H.expr);continue}ne.push(H)}if(ne.length===0&&X)return u.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(i);for(let H=1;H<ne.length;H++)ne[H-1].equals(ne[H])&&(ne.splice(H,1),H--);if(ne.length===1)return ne[0];for(;ne.length>1;){const H=ne[ne.length-1];if(H.type!==9)break;ne.pop();const V=ne.pop(),U=ne.length===0,se=B.create(H.expr.map(he=>G.create([he,V],null,_)),null,U);se&&(ne.push(se),ne.sort(i))}if(ne.length===1)return ne[0];if(_){for(let H=0;H<ne.length;H++)for(let V=H+1;V<ne.length;V++)if(ne[H].negate().equals(ne[V]))return o.INSTANCE;if(ne.length===1)return ne[0]}return new G(ne,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new G(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());this.c=B.create(A,this,!0)}return this.c}}e.$Lj=G;class B{static create(A,N,_){return B.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const ne=i(this.expr[N],A.expr[N]);if(ne!==0)return ne}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=K(this.expr);return A===this.expr?this:B.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(this.expr[N].evaluate(A))return!0;return!1}static d(A,N,_){let ne=[],X=!1;if(A){for(let H=0,V=A.length;H<V;H++){const U=A[H];if(U){if(U.type===0){X=!0;continue}if(U.type===1)return u.INSTANCE;if(U.type===9){ne=ne.concat(U.expr);continue}ne.push(U)}}if(ne.length===0&&X)return o.INSTANCE;ne.sort(i)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let H=1;H<ne.length;H++)ne[H-1].equals(ne[H])&&(ne.splice(H,1),H--);if(ne.length===1)return ne[0];if(_){for(let H=0;H<ne.length;H++)for(let V=H+1;V<ne.length;V++)if(ne[H].negate().equals(ne[V]))return u.INSTANCE;if(ne.length===1)return ne[0]}return new B(ne,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new B(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());for(;A.length>1;){const N=A.shift(),_=A.shift(),ne=[];for(const X of le(N))for(const H of le(_))ne.push(G.create([X,H],null,!1));A.unshift(B.create(ne,null,!1))}this.c=B.create(A,this,!0)}return this.c}}e.$Mj=B;class L extends ${static{this.d=[]}static all(){return L.d.values()}constructor(A,N,_){super(A,null),this.f=N,typeof _=="object"?L.d.push({..._,key:A}):_!==!0&&L.d.push({key:A,description:_,type:N!=null?typeof N:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return P.create(this.key,A)}notEqualsTo(A){return O.create(this.key,A)}}e.$Nj=L,e.$Oj=(0,R.$wi)("contextKeyService");function z(Z,A){return Z<A?-1:Z>A?1:0}function Q(Z,A,N,_){return Z<N?-1:Z>N?1:A<_?-1:A>_?1:0}function ae(Z,A){if(Z.type===0||A.type===1)return!0;if(Z.type===9)return A.type===9?x(Z.expr,A.expr):!1;if(A.type===9){for(const N of A.expr)if(ae(Z,N))return!0;return!1}if(Z.type===6){if(A.type===6)return x(A.expr,Z.expr);for(const N of Z.expr)if(ae(N,A))return!0;return!1}return Z.equals(A)}function x(Z,A){let N=0,_=0;for(;N<Z.length&&_<A.length;){const ne=Z[N].cmp(A[_]);if(ne<0)return!1;ne===0&&N++,_++}return N===Z.length}function le(Z){return Z.type===9?Z.expr:[Z]}}),define(re[92],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$dn=e.ID=void 0,e.$en=C,e.ID="diagnosticsService",e.$dn=(0,n.$wi)(e.ID);function C(R){return!!R.hostName&&!!R.errorMessage}class S{async getPerformanceInfo(j,E){return{}}async getSystemInfo(j,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(j,E){return""}async getWorkspaceFileExtensions(j){return{extensions:[]}}async reportWorkspaceStats(j){}}e.$fn=S}),define(re[119],oe([0,1,19,74,168,6,48,4,35]),function(J,e,n,C,S,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Jw=e.$Iw=e.$Hw=void 0,e.$Kw=m,e.$Lw=f,e.$Hw=(0,R.$wi)("dialogService");var c;(function(y){y[y.Confirmation=1]="Confirmation",y[y.Prompt=2]="Prompt",y[y.Input=3]="Input"})(c||(c={}));class d{a(p){return this.d(p,c.Confirmation)}b(p){return this.d(p,c.Prompt)}c(p){return this.d(p,c.Input)}d(p,g){const l=[];switch(g){case c.Confirmation:{const w=p;w.primaryButton?l.push(w.primaryButton):l.push((0,S.localize)(0,null)),w.cancelButton?l.push(w.cancelButton):l.push((0,S.localize)(1,null));break}case c.Prompt:{const w=p;Array.isArray(w.buttons)&&w.buttons.length>0&&l.push(...w.buttons.map(k=>k.label)),w.cancelButton&&(w.cancelButton===!0?l.push((0,S.localize)(2,null)):typeof w.cancelButton=="string"?l.push(w.cancelButton):w.cancelButton.label?l.push(w.cancelButton.label):l.push((0,S.localize)(3,null))),l.length===0&&l.push((0,S.localize)(4,null));break}case c.Input:{const w=p;w.primaryButton?l.push(w.primaryButton):l.push((0,S.localize)(5,null)),w.cancelButton?l.push(w.cancelButton):l.push((0,S.localize)(6,null));break}}return l}e(p){if(typeof p=="string")return p;if(typeof p=="number")return p===C.default.Info?"info":p===C.default.Error?"error":p===C.default.Warning?"warning":"none"}f(p,g,l){const w=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&w.push(p.cancelButton);let k=w[g]?.run({checkboxChecked:l});return k instanceof Promise||(k=Promise.resolve(k)),{result:k,checkboxChecked:l}}}e.$Iw=d,e.$Jw=(0,R.$wi)("fileDialogService");var b;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const v=10;function m(y){const p=[];return p.push(...y.slice(0,v).map(g=>typeof g=="string"?g:(0,n.$7g)(g))),y.length>v&&(y.length-v===1?p.push((0,S.localize)(7,null)):p.push((0,S.localize)(8,null,y.length-v))),p.push(""),p.join(`
`)}function f(y,p){const g=(0,h.$3n)(y);let l=(g.buttons??[]).map(t=>(0,j.$Ew)(t)),w=(y.buttons||[]).map((t,r)=>r),k=0,a=g.cancelId??l.length-1;if(l.length>1){const t=typeof a=="number"?l[a]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&l.length>1&&a!==1){l.splice(a,1),l.splice(1,0,t);const r=w[a];w.splice(a,1),w.splice(1,0,r),a=1}E.$k&&l.length>1&&(l=l.reverse(),w=w.reverse(),k=l.length-1,typeof t=="string"&&(a=k-1))}else if(E.$i&&typeof t=="string"&&l.length>1&&a!==l.length-1){l.splice(a,1),l.push(t);const r=w[a];w.splice(a,1),w.push(r),a=l.length-1}}return g.buttons=l,g.defaultId=k,g.cancelId=a,g.noLink=!0,g.title=g.title||p.nameLong,{options:g,buttonIndeces:w}}}),define(re[120],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$EX=e.$DX=void 0,e.$FX=R,e.$GX=j,e.$DX=(0,n.$wi)("encryptionService"),e.$EX=(0,n.$wi)("encryptionMainService");var C;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(C||(e.PasswordStoreCLIOption=C={}));var S;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(S||(e.KnownStorageProvider=S={}));function R(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}function j(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}}),define(re[38],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,n.$wi)("environmentService"),e.$Ei=(0,n.$xi)(e.$Di)}),define(re[121],oe([0,1,172,6]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=S,e.$1o=R,e.$2o=j,e.$3o=E,e.$4o=h,e.$5o=c,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function S(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function j(l,w){switch(l){case 3:return w==="x64"?"win32-x64":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(l,w){return w==="web"&&!l.includes("web")}function h(l,w,k){return E(w,k)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===k}function c(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var d;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(d||(e.SortBy=d={}));var b;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var m;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$6o=(0,C.$wi)("extensionGalleryService");var f;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Cancelled="Cancelled",l.Unknown="Unknown",l.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));class y extends Error{constructor(w,k){super(w),this.code=k,this.name=k}}e.$7o=y;var p;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed"})(p||(e.ExtensionGalleryErrorCode=p={}));class g extends Error{constructor(w,k){super(w),this.code=k,this.name=k}}e.$8o=g,e.$9o=(0,C.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,C.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,C.$wi)("IExtensionTipsService"),e.$bp=(0,n.localize2)(0,"Extensions"),e.$cp=(0,n.localize2)(1,"Preferences")}),define(re[212],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=void 0,e.$occ=(0,n.$wi)("extensionHostStarter"),e.$pcc="extensionHostStarter"}),define(re[213],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=e.$j7b=void 0,e.$j7b=(0,n.$wi)("externalTerminal"),e.$k7b="Terminal.app"}),define(re[214],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0,e.$rcc=(0,n.$wi)("externalTerminal")}),define(re[215],oe([0,1,49,51,13,9,4,76,21,90,176,213]),function(J,e,n,C,S,R,j,E,h,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=e.$scc=void 0;const v=d.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends m{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,c.$om(),t)}spawnTerminal(a,t,r,s){const i=t.windowsExec||f.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=R.$oc(i,".exe").toLowerCase();if(o==="cmder")return a.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return i.indexOf(" ")>=0&&u.push('""'),u.push(i),o==="wt"&&u.push("-d ."),new Promise(($,P)=>{const D=g(process),I=a.spawn(r,u,{cwd:s,env:D,detached:!0});I.on("error",P),I.on("exit",()=>$())})}async runInTerminal(a,t,r,s,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows(),u=await f.f();return new Promise(($,P)=>{const D=`"${t} - ${v}"`,I=`"${r.join('" "')}" & pause`,O=Object.assign({},g(process),s);Object.keys(O).filter(q=>O[q]===null).forEach(q=>delete O[q]);const M={cwd:t,env:O,windowsVerbatimArguments:!0};let W,F;R.$oc(o,".exe")==="wt"?(W=o,F=["-d",".",f.b,"/c",I]):u?(W=u,F=["-d",".",o,"/c",I]):(W=f.b,F=["/c","start",D,"/wait",o,"/c",`"${I}"`]),n.spawn(W,F,M).on("error",q=>{P(l(q))}),$(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const a=await c.win32.findExecutable("wt");return await h.Promises.exists(a)?a:void 0}catch{return}}}e.$scc=f,Se([C.$1h],f,"f",null);class y extends m{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,r,s,i){const o=i.osxExec||b.$k7b;return new Promise((u,$)=>{if(o===b.$k7b||o==="iTerm.app"){const P=o===b.$k7b?"TerminalHelper":"iTermHelper",I=[S.$Qg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${P}.scpt`).fsPath,"-t",a||v,"-w",t];for(const W of r)I.push("-a"),I.push(W);if(s){const W=Object.assign({},g(process),s);for(const F in W){const T=W[F];T===null?(I.push("-u"),I.push(F)):(I.push("-e"),I.push(`${F}=${T}`))}}let O="";const M=n.spawn(y.b,I);M.on("error",W=>{$(l(W))}),M.stderr.on("data",W=>{O+=W.toString()}),M.on("exit",W=>{if(W===0)u(void 0);else if(O){const F=O.split(`
`,1);$(new Error(F[0]))}else $(new Error(d.localize(1,null,P,W)))})}else $(new Error(d.localize(2,null,o)))})}spawnTerminal(a,t,r){const s=t.osxExec||b.$k7b;return new Promise((i,o)=>{const u=["-a",s];r&&u.push(r);const $=g(process),P=a.spawn("/usr/bin/open",u,{cwd:r,env:$});P.on("error",o),P.on("exit",()=>i())})}}e.$tcc=y;class p extends m{static{this.b=d.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,r,s,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((u,$)=>{const P=[];o.then(D=>{D.indexOf("gnome-terminal")>=0?P.push("-x"):P.push("-e"),P.push("bash"),P.push("-c");const I=`${w(r)}; echo; read -p "${p.b}" -n1;`;P.push(`''${I}''`);const O=Object.assign({},g(process),s);Object.keys(O).filter(T=>O[T]===null).forEach(T=>delete O[T]);const M={cwd:t,env:O};let W="";const F=n.spawn(D,P,M);F.on("error",T=>{$(l(T))}),F.stderr.on("data",T=>{W+=T.toString()}),F.on("exit",T=>{if(T===0)u(void 0);else if(W){const q=W.split(`
`,1);$(new Error(q[0]))}else $(new Error(d.localize(4,null,D,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!j.$k)p.d=Promise.resolve("xterm");else{const a=await h.Promises.exists("/etc/debian_version");p.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return p.d}spawnTerminal(a,t,r){const s=t.linuxExec?Promise.resolve(t.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{s.then(u=>{const $=g(process),P=a.spawn(u,[],{cwd:r,env:$});P.on("error",o),P.on("exit",()=>i())})})}}e.$ucc=p;function g(k){const a={...k.env};return(0,E.$mm)(a),a}function l(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(d.localize(5,null,k.path)):k}function w(k){let a="";for(const t of k)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(re[16],oe([0,1,59,9,25,12,7,178,6,4,13,62]),function(J,e,n,C,S,R,j,E,h,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=v,e.$5k=p,e.$6k=l,e.$7k=w,e.$8k=k,e.$9k=a,e.$0k=t,e.$$k=r,e.$_k=s,e.$al=i,e.$bl=o,e.$dl=P,e.$el=D,e.$fl=I,e.$gl=O,e.$hl=M,e.$kl=ue,e.$wl=L,e.$xl=z,e.$zl=ae,e.$3k=(0,h.$wi)("fileService");function v(x){return x.create===!0}var m;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var f;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var y;(function(x){x[x.UPDATED=2]="UPDATED",x[x.ADDED=4]="ADDED",x[x.DELETED=8]="DELETED"})(y||(e.FileChangeFilter=y={}));function p(x){const le=x;return!!le&&typeof le.onDidChange=="function"}var g;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function l(x){return!!(x.capabilities&2)}function w(x){return!!(x.capabilities&8)}function k(x){return!!(x.capabilities&131072)}function a(x){return!!(x.capabilities&4)}function t(x){return!!(x.capabilities&16)}function r(x){return l(x)?!!(x.capabilities&16384):!1}function s(x){return l(x)?!!(x.capabilities&32768):!1}function i(x){return!!(x.capabilities&65536)}function o(x){return!!(x.capabilities&2048)}var u;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class $ extends Error{static create(le,Z){const A=new $(le.toString(),Z);return I(A,Z),A}constructor(le,Z){super(le),this.code=Z}}e.$cl=$;function P(x,le){return $.create(x,le)}function D(x){return x||P((0,E.localize)(0,null),u.Unknown)}function I(x,le){return x.name=le?`${le} (FileSystemError)`:"FileSystemError",x}function O(x){if(!x)return u.Unknown;if(x instanceof $)return x.code;const le=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!le)return u.Unknown;switch(le[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function M(x){if(x instanceof ee)return x.fileOperationResult;switch(O(x)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}var W;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(W||(e.FileOperation=W={}));class F{constructor(le,Z,A){this.resource=le,this.operation=Z,this.target=A}isOperation(le){return this.operation===le}}e.$il=F;var T;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class q{static{this.a=null}constructor(le,Z){this.c=Z,this.b=void 0,this.d=new b.$V(()=>{const A=n.$Ci.forUris(()=>this.c);return A.fill(this.rawAdded.map(N=>[N,!0])),A}),this.f=new b.$V(()=>{const A=n.$Ci.forUris(()=>this.c);return A.fill(this.rawUpdated.map(N=>[N,!0])),A}),this.g=new b.$V(()=>{const A=n.$Ci.forUris(()=>this.c);return A.fill(this.rawDeleted.map(N=>[N,!0])),A}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const A of le){switch(A.type){case 1:this.rawAdded.push(A.resource);break;case 0:this.rawUpdated.push(A.resource);break;case 2:this.rawDeleted.push(A.resource);break}this.b!==q.a&&(typeof A.cId=="number"?this.b===void 0?this.b=A.cId:this.b!==A.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(le,...Z){return this.h(le,{includeChildren:!1},...Z)}affects(le,...Z){return this.h(le,{includeChildren:!0},...Z)}h(le,Z,...A){if(!le)return!1;const N=A.length>0;return!!((!N||A.includes(1))&&(this.d.value.get(le)||Z.includeChildren&&this.d.value.findSuperstr(le))||(!N||A.includes(0))&&(this.f.value.get(le)||Z.includeChildren&&this.f.value.findSuperstr(le))||(!N||A.includes(2))&&(this.g.value.findSubstr(le)||Z.includeChildren&&this.g.value.findSuperstr(le)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(le){return this.b===le}hasCorrelation(){return typeof this.b=="number"}}e.$jl=q;function ue(x,le,Z){return!x||!le||x===le||le.length>x.length?!1:(le.charAt(le.length-1)!==C.sep&&(le+=C.sep),Z?(0,S.$zf)(x,le):x.indexOf(le)===0)}class ee extends Error{constructor(le,Z,A){super(le),this.fileOperationResult=Z,this.options=A}}e.$ll=ee;class ce extends ee{constructor(le,Z,A,N){super(le,Z,N),this.fileOperationResult=Z,this.size=A}}e.$ml=ce;class K extends ee{constructor(le,Z,A){super(le,2,A),this.stat=Z}}e.$nl=K;var G;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var B;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$vl="";function L(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}async function z(x,le){if(!le.hasProvider(j.URI.from({scheme:x.scheme})))return new Promise(Z=>{const A=le.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===x.scheme&&N.added&&(A.dispose(),Z())})})}class Q{static{this.KB=1024}static{this.MB=Q.KB*Q.KB}static{this.GB=Q.MB*Q.KB}static{this.TB=Q.GB*Q.KB}static formatSize(le){return(0,R.$ag)(le)||(le=0),le<Q.KB?(0,E.localize)(1,null,le.toFixed(0)):le<Q.MB?(0,E.localize)(2,null,(le/Q.KB).toFixed(2)):le<Q.GB?(0,E.localize)(3,null,(le/Q.MB).toFixed(2)):le<Q.TB?(0,E.localize)(4,null,(le/Q.GB).toFixed(2)):(0,E.localize)(5,null,(le/Q.TB).toFixed(2))}}e.$yl=Q;function ae(x){const le=typeof x=="string"||x?.scheme===d.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===d.Schemas.file?1024*Q.MB:le?10*Q.MB:c.$o?50*Q.MB:1024*Q.MB}}),define(re[122],oe([0,1,17,15,179,16]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=j;async function j(d,b,v,m,f,y){let p;try{await E(d,b,v,m,f,y)}catch(g){p=g}finally{p&&f.errorTransformer&&(p=f.errorTransformer(p)),typeof p<"u"&&v.error(p),v.end()}}async function E(d,b,v,m,f,y){h(y);const p=await d.open(b,{create:!1});try{h(y);let g=0,l=0,w=f&&typeof f.length=="number"?f.length:void 0,k=n.$Ge.alloc(Math.min(f.bufferSize,typeof w=="number"?w:f.bufferSize)),a=f&&typeof f.position=="number"?f.position:0,t=0;do l=await d.read(p,a,k.buffer,t,k.byteLength-t),a+=l,t+=l,g+=l,typeof w=="number"&&(w-=l),t===k.byteLength&&(await v.write(m(k)),k=n.$Ge.alloc(Math.min(f.bufferSize,typeof w=="number"?w:f.bufferSize)),t=0);while(l>0&&(typeof w!="number"||w>0)&&h(y)&&c(g,f));if(t>0){let r=t;typeof w=="number"&&(r=Math.min(t,w)),v.write(m(k.slice(0,r)))}}catch(g){throw(0,R.$el)(g)}finally{await d.close(p)}}function h(d){if(d.isCancellationRequested)throw(0,C.$6)();return!0}function c(d,b){if(typeof b?.limits?.size=="number"&&d>b.limits.size)throw(0,R.$dl)((0,S.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[60],oe([0,1,108,2,9,4,7,16]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=void 0,e.$Jq=h,e.$Kq=c,e.$Oq=m,e.$Pq=f,e.$Qq=y,e.$Rq=p,e.$Sq=l,e.$Tq=w;function h(k){return typeof k.correlationId=="number"}function c(k){return k.recursive===!0}class d extends C.$Vc{static{this.a=5}constructor(a,t,r,s){super(),this.h=a,this.j=t,this.m=r,this.n=s,this.c=this.B(new C.$Wc),this.f=void 0,this.g=0}s(){const a=new C.$Uc;this.c.value=a,this.b=this.r(a),this.b.setVerboseLogging(this.m),a.add(this.b.onDidChangeFile(t=>this.h(t))),a.add(this.b.onDidLogMessage(t=>this.j(t))),a.add(this.b.onDidError(t=>this.t(t)))}t(a){this.n.restartOnError?this.g<d.a&&this.f?(this.w(`restarting watcher after error: ${a}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${a}`):this.w(a)}u(a){this.g++,this.s(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.m=a,await this.b?.setVerboseLogging(a)}w(a){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${a}`})}y(a){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Lq=d;class b extends d{constructor(a,t,r){super(a,t,r,{type:"node.js",restartOnError:!1})}}e.$Mq=b;class v extends d{constructor(a,t,r){super(a,t,r,{type:"universal",restartOnError:!0})}}e.$Nq=v;function m(k){return k.map(a=>({type:a.type,resource:j.URI.revive(a.resource),cId:a.cId}))}function f(k){const a=new g;for(const t of k)a.processEvent(t);return a.coalesce()}function y(k,a){return typeof a=="string"&&!a.startsWith(n.$mk)&&!(0,S.$jc)(a)?{base:k,pattern:a}:a}function p(k,a){const t=[];for(const r of a)t.push((0,n.$qk)(y(k,r)));return t}class g{constructor(){this.a=new Set,this.b=new Map}c(a){return R.$k?a.resource.fsPath:a.resource.fsPath.toLowerCase()}processEvent(a){const t=this.b.get(this.c(a));let r=!1;if(t){const s=t.type,i=a.type;t.resource.fsPath!==a.resource.fsPath&&(a.type===2||a.type===1)?r=!0:s===1&&i===2?(this.b.delete(this.c(a)),this.a.delete(t)):s===2&&i===1?t.type=0:s===1&&i===0||(t.type=i)}else r=!0;r&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?(a.push(r),!1):!0).sort((r,s)=>r.resource.fsPath.length-s.resource.fsPath.length).filter(r=>t.some(s=>(0,E.$kl)(r.resource.fsPath,s,!R.$k))?!1:(t.push(r.resource.fsPath),!0)).concat(a)}}function l(k,a){if(typeof a=="number")switch(k.type){case 1:return(a&4)===0;case 2:return(a&8)===0;case 0:return(a&2)===0}return!1}function w(k){if(typeof k=="number"){const a=[];return k&4&&a.push("Added"),k&8&&a.push("Deleted"),k&2&&a.push("Updated"),a.length===0?"<all>":`[${a.join(", ")}]`}return"<none>"}}),define(re[216],oe([0,1,17,47,15,3,2,63,33,16,60]),function(J,e,n,C,S,R,j,E,h,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=e.$wQ=void 0,e.$wQ="localFilesystem";class b extends j.$Vc{constructor(m,f){super(),this.a=m,this.b=f,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.$ee),this.onDidChangeFile=this.f.event,this.g=this.B(new R.$ee),this.onDidWatchError=this.g.event,this.h=(0,h.$Sg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,f){const{buffer:y}=await this.a.call("readFile",[m,f]);return y}readFileStream(m,f,y){const p=(0,E.$ue)(l=>n.$Ge.concat(l.map(w=>n.$Ge.wrap(w))).buffer),g=new j.$Uc;return g.add(this.a.listen("readFileStream",[m,f])(l=>{if(l instanceof n.$Ge)p.write(l.buffer);else{if(l==="end")p.end();else{let w;if(l instanceof Error)w=l;else{const k=l;w=(0,c.$dl)(k.message??(0,C.$hj)(k),k.code??c.FileSystemProviderErrorCode.Unknown)}p.error(w),p.end()}g.dispose()}})),g.add(y.onCancellationRequested(()=>{p.error((0,S.$6)()),p.end(),g.dispose()})),p}writeFile(m,f,y){return this.a.call("writeFile",[m,n.$Ge.wrap(f),y])}open(m,f){return this.a.call("open",[m,f])}close(m){return this.a.call("close",[m])}async read(m,f,y,p,g){const[l,w]=await this.a.call("read",[m,f,g]);return y.set(l.buffer.slice(0,w),p),w}write(m,f,y,p,g){return this.a.call("write",[m,f,n.$Ge.wrap(y),p,g])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,f){return this.a.call("delete",[m,f])}rename(m,f,y){return this.a.call("rename",[m,f,y])}copy(m,f,y){return this.a.call("copy",[m,f,y])}cloneFile(m,f){return this.a.call("cloneFile",[m,f])}j(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const f=m;this.f.fire((0,d.$Oq)(f))}else{const f=m;this.g.fire(f)}}))}watch(m,f){const y=(0,h.$Sg)();return this.a.call("watch",[this.h,y,m,f]),(0,j.$Tc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$xQ=b}),define(re[217],oe([0,1,43,2,60,3,7,8]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class h extends C.$Vc{constructor(){super(),this.a=this.B(new R.$ee),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$ee),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$ee),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new C.$5c),this.m=new Set,this.n=5007,this.r=new E.$Th,this.P=!1,this.B(this.f(d=>this.s(d)))}s(d){this.t(d)&&this.w(d)}t(d){return(0,S.$Jq)(d)}async watch(d){this.r.isSettled||this.r.complete(),this.r=new E.$Th;try{this.h.clear(),this.g.clear();for(const b of d)this.t(b)?this.h.set(b.correlationId,b):this.g.add(b);for(const[b]of this.j)this.h.has(b)||(this.j.deleteAndDispose(b),this.m.delete(b));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))])}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async w(d){if(this.j.has(d.correlationId))return;const b=new C.$Uc;this.j.set(d.correlationId,b),await this.r.p,!b.isDisposed&&(this.z(d,b),this.u())}y(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.u()}z(d,b){this.C(d,b)?(this.N(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.D(d,b),this.m.add(d.correlationId))}C(d,b){const v=this.M?.subscribe(d.path,(m,f)=>{b.isDisposed||(m?this.z(d,b):f?.type===1&&this.F(d))});return v?(b.add(v),!0):!1}D(d,b){let v=!1;const m=(f,y)=>{if(b.isDisposed)return;const p=this.G(f),g=this.G(y),l=v;v=p,!p&&(g||l)&&this.F(d)};this.N(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.watchFile)(d.path,{persistent:!1,interval:this.n},m)}catch(f){this.O(`fs.watchFile() failed with error ${f} on path ${d.path} (correlationId: ${d.correlationId})`)}b.add((0,C.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.unwatchFile)(d.path,m)}catch(f){this.O(`fs.unwatchFile() failed with error ${f} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}F(d){this.N(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const b={resource:j.URI.file(d.path),type:1,cId:d.correlationId};this.a.fire([b]),this.H(b,d),this.y(d)}G(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(d,b){if(this.P){const v=` >> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.I(v,b)}}I(d,b){this.P&&this.N(`${d}${typeof b.correlationId=="number"?` <${b.correlationId}> `:""}`)}J(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,S.$Tq)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.P=d}}e.$3q=h}),define(re[218],oe([0,1,43,8,23,31,2,72,9,4,19,7,109,21,60]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0,e.$9q=p;class y extends j.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(l,w,k,a,t,r){super(),this.s=l,this.t=w,this.u=k,this.w=a,this.y=t,this.z=r,this.c=this.B(new C.$Lh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new C.$Kh(s=>this.M(s),y.b)),this.g=(0,f.$Rq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,f.$Rq)(this.s.path,this.s.includes):void 0,this.j=(0,f.$Jq)(this.s)?this.s.filter:void 0,this.m=new S.$pe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const l=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const w=await m.Promises.stat(l);if(this.m.token.isCancellationRequested)return;this.B(await this.G(l,w.isDirectory()))}catch(l){l.code!=="ENOENT"?this.O(l):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${l})`),this.D()}}D(){this.r=!0,this.w?.()}async F(l){let w=l.path;try{w=await m.Promises.realpath(l.path),l.path===w&&(w=await(0,v.$5q)(l.path,this.m.token)??l.path),l.path!==w&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${l.path}, real: ${w})`)}catch{}return w}async G(l,w){const k=new j.$Uc;return this.H(l,w,k)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(l,w,k)),k}H(l,w,k){if(w)return!1;const a=b.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,s)=>{if(!k.isDisposed)if(r){const i=await this.G(l,w);k.isDisposed?i.dispose():k.add(i)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:a,type:s.type,cId:this.s.correlationId},!0)});return t?(k.add(t),!0):!1}async I(l,w,k){if(c.$j&&(0,R.$vg)(l,"/Volumes/",!0)){this.O(`Refusing to watch ${l} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new S.$pe(this.m.token);k.add((0,j.$Tc)(()=>a.dispose(!0)));const t=new j.$Uc;k.add(t);try{const r=b.URI.file(this.s.path),s=(0,h.$oc)(l),i=(0,n.watch)(l);t.add((0,j.$Tc)(()=>{i.removeAllListeners(),i.close()})),this.Q(`Started watching: '${l}'`);const o=new Set;if(w)try{for(const $ of await m.Promises.readdir(l))o.add($)}catch($){this.O($)}if(a.token.isCancellationRequested)return;const u=new Map;t.add((0,j.$Tc)(()=>{for(const[,$]of u)$.dispose();u.clear()})),i.on("error",($,P)=>{a.token.isCancellationRequested||(this.O(`Failed to watch ${l} for changes using fs.watch() (${$}, ${P})`),this.D())}),i.on("change",($,P)=>{if(a.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${$}"] ${P}`);let D="";if(P&&(D=P.toString(),c.$j&&(D=(0,E.$bm)(D))),!(!D||$!=="change"&&$!=="rename"))if(w)if($==="rename"){u.get(D)?.dispose();const I=setTimeout(async()=>{if(u.delete(D),D===s&&!await m.Promises.exists(l)){this.J(r);return}if(a.token.isCancellationRequested)return;const O=await this.N((0,h.$kc)(l,D));if(a.token.isCancellationRequested)return;let M;O?o.has(D)?M=0:(M=1,o.add(D)):(o.delete(D),M=2),this.L({resource:(0,d.$0g)(r,D),type:M,cId:this.s.correlationId})},y.a);u.set(D,(0,j.$Tc)(()=>clearTimeout(I)))}else{let I;o.has(D)?I=0:(I=1,o.add(D)),this.L({resource:(0,d.$0g)(r,D),type:I,cId:this.s.correlationId})}else if($==="rename"||D!==s){const I=setTimeout(async()=>{const O=await m.Promises.exists(l);a.token.isCancellationRequested||(O?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(l,!1))):this.J(r))},y.a);t.clear(),t.add((0,j.$Tc)(()=>clearTimeout(I)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){a.token.isCancellationRequested||this.O(`Failed to watch ${l} for changes using fs.watch() (${r.toString()})`),this.D()}}J(l){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:l,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(l,w=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`),!w&&this.g.some(k=>k(l.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${l.resource.fsPath}`):!w&&this.h&&this.h.length>0&&!this.h.some(k=>k(l.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${l.resource.fsPath}`):this.f.work(l))}M(l){const w=(0,f.$Pq)(l),k=[];for(const t of w){if((0,f.$Sq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}k.push(t)}if(k.length===0)return;if(this.z)for(const t of k)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(k)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${k[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${k.length}, most recent change: ${k[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(l){if(c.$k)return m.Promises.exists(l);try{const w=(0,h.$oc)(l);return(await m.Promises.readdir((0,h.$nc)(l))).some(a=>a===w)}catch(w){return this.Q(w),!1}}setVerboseLogging(l){this.z=l}O(l){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${l}`})}P(l){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${l}`})}Q(l){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${l}`})}R(l){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${l}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$8q=y;async function p(g,l,w,k,a=512){const t=await m.Promises.open(g,"r"),r=Buffer.allocUnsafe(a),s=new S.$pe(k);let i,o=!1;const u={path:g,excludes:[],recursive:!1},$=new y(u,void 0,P=>{(async()=>{for(const{type:D}of P)if(D===0){if(o)return;o=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:I}=await m.Promises.read(t,r,0,a,null);if(!I||s.token.isCancellationRequested)break;l(r.slice(0,I))}}catch(I){i=new Error(I),s.dispose(!0)}finally{o=!1}}})()});return await $.ready,w(),new Promise((P,D)=>{s.token.onCancellationRequested(async()=>{$.dispose();try{await m.Promises.close(t)}catch(I){i=new Error(I)}i?D(i):P()})})}}),define(re[219],oe([0,1,3,108,217,4,218,31]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class h extends S.$3q{constructor(d){super(),this.M=d,this.onDidError=n.Event.None,this.watchers=new Set}async L(d){d=this.X(d);const b=[],v=new Set(Array.from(this.watchers));for(const m of d){const f=this.S(m);f&&(0,C.$uk)(f.request.excludes,m.excludes)&&(0,C.$uk)(f.request.includes,m.includes)?v.delete(f):b.push(m)}b.length&&this.N(`Request to start watching: ${b.map(m=>this.J(m)).join(",")}`),v.size&&this.N(`Request to stop watching: ${Array.from(v).map(m=>this.J(m.request)).join(",")}`);for(const m of v)this.W(m);for(const m of b)this.U(m)}S(d){for(const b of this.watchers)if(typeof d.correlationId=="number"||typeof b.request.correlationId=="number"){if(b.request.correlationId===d.correlationId)return b}else if((0,E.$ug)(b.request.path,d.path,!R.$k))return b}U(d){const b=new j.$8q(d,this.M,m=>this.a.fire(m),()=>this.c.fire(d),m=>this.b.fire(m),this.P),v={request:d,instance:b};this.watchers.add(v)}async stop(){await super.stop();for(const d of this.watchers)this.W(d)}W(d){this.N("stopping file watcher",d),this.watchers.delete(d),d.instance.dispose()}X(d){const b=new Map;for(const v of d){const m=R.$k?v.path:v.path.toLowerCase();let f=b.get(v.correlationId);f||(f=new Map,b.set(v.correlationId,f)),f.has(m)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(v)}`),f.set(m,v)}return Array.from(b.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(d){super.setVerboseLogging(d);for(const b of this.watchers)b.instance.setVerboseLogging(d)}N(d,b){this.P&&this.b.fire({type:"trace",message:this.$(d,b)})}O(d){this.b.fire({type:"warn",message:this.$(d)})}$(d,b){return b?`[File Watcher (node.js)] ${d} (${this.J(b.request)})`:`[File Watcher (node.js)] ${d}`}}e.$0q=h}),define(re[220],oe([0,1,60,219]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class S extends n.$Mq{constructor(j,E,h){super(j,E,h),this.s()}r(j){return j.add(new C.$0q(void 0))}}e.$$q=S}),define(re[221],oe([0,1,13,44,162,60]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class j extends R.$Nq{constructor(h,c,d){super(h,c,d),this.s()}r(h){const c=h.add(new S.$1q(n.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:d,signal:b})=>this.t(`terminated by itself with code ${d}, signal: ${b} (ETERM)`))),C.ProxyChannel.toService((0,C.$di)(c.getChannel("watcher")))}}e.$2q=j}),define(re[93],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class n{constructor(...S){this.a=new Map;for(const[R,j]of S)this.set(R,j)}set(S,R){const j=this.a.get(S);return this.a.set(S,R),j}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$ui=n}),define(re[222],oe([0,1,8,15,2,78,211,6,93,104]),function(J,e,n,C,S,R,j,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const d=!1;class b extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class v{constructor(p=new h.$ui,g=!1,l,w=d){this.i=p,this.j=g,this.k=l,this.l=w,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(E.$vi,this),this._globalGraph=w?l?._globalGraph??new j.$br(k=>k):void 0}dispose(){if(!this.f){this.f=!0,(0,S.$Qc)(this.h),this.h.clear();for(const p of this.g)(0,S.$Pc)(p)&&p.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(p){this.m();const g=new class extends v{dispose(){this.h.delete(g),super.dispose()}}(p,this.j,this,this.l);return this.h.add(g),g}invokeFunction(p,...g){this.m();const l=f.traceInvocation(this.l,p);let w=!1;try{return p({get:a=>{if(w)throw(0,C.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(a,l);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...g)}finally{w=!0,l.stop()}}createInstance(p,...g){this.m();let l,w;return p instanceof R.$ti?(l=f.traceCreation(this.l,p.ctor),w=this.o(p.ctor,p.staticArguments.concat(g),l)):(l=f.traceCreation(this.l,p),w=this.o(p,g,l)),l.stop(),w}o(p,g=[],l){const w=E._util.getServiceDependencies(p).sort((t,r)=>t.index-r.index),k=[];for(const t of w){const r=this.s(t.id,l);r||this.y(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),k.push(r)}const a=w.length>0?w[0].index:g.length;if(g.length!==a){console.trace(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${g.length} static arguments`);const t=a-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,a)}return Reflect.construct(p,g.concat(k))}q(p,g){if(this.i.get(p)instanceof R.$ti)this.i.set(p,g);else if(this.k)this.k.q(p,g);else throw new Error("illegalState - setting UNKNOWN service instance")}r(p){const g=this.i.get(p);return!g&&this.k?this.k.r(p):g}s(p,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const l=this.r(p);return l instanceof R.$ti?this.u(p,l,g.branch(p,!0)):(g.branch(p,!1),l)}u(p,g,l){if(this.t.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.t.add(p);try{return this.v(p,g,l)}finally{this.t.delete(p)}}v(p,g,l){const w=new j.$br(t=>t.id.toString());let k=0;const a=[{id:p,desc:g,_trace:l}];for(;a.length;){const t=a.pop();if(w.lookupOrInsertNode(t),k++>1e3)throw new b(w);for(const r of E._util.getServiceDependencies(t.desc.ctor)){const s=this.r(r.id);if(s||this.y(`[createInstance] ${p} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),s instanceof R.$ti){const i={id:r.id,desc:s,_trace:t._trace.branch(r.id,!0)};w.insertEdge(t,i),a.push(i)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new b(w);break}for(const{data:r}of t){if(this.r(r.id)instanceof R.$ti){const i=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,i)}w.removeNode(r)}}return this.r(p)}w(p,g,l=[],w,k){if(this.i.get(p)instanceof R.$ti)return this.x(p,g,l,w,k,this.g);if(this.k)return this.k.w(p,g,l,w,k);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}x(p,g,l=[],w,k,a){if(w){const t=new v(void 0,this.j,this,this.l);t.c=String(p);const r=new Map,s=new n.$Ph(()=>{const i=t.o(g,l,k);for(const[o,u]of r){const $=i[o];if(typeof $=="function")for(const P of u)P.disposable=$.apply(i,P.listener)}return r.clear(),a.add(i),i});return new Proxy(Object.create(null),{get(i,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let P=r.get(o);return P||(P=new c.$6c,r.set(o,P)),(I,O,M)=>{if(s.isInitialized)return s.value[o](I,O,M);{const W={listener:[I,O,M],disposable:void 0},F=P.push(W);return(0,S.$Tc)(()=>{F(),W.disposable?.dispose()})}}}if(o in i)return i[o];const u=s.value;let $=u[o];return typeof $!="function"||($=$.bind(u),i[o]=$),$},set(i,o,u){return s.value[o]=u,!0},getPrototypeOf(i){return g.prototype}})}else{const t=this.o(g,l,k);return a.add(t),t}}y(p,g){if(g&&console.warn(p),this.j)throw new Error(p)}}e.$cr=v;var m;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(m||(m={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,g){return p?new f(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(p,g){return p?new f(1,g.name):f.c}static{this.f=0}constructor(p,g){this.type=p,this.name=g,this.g=Date.now(),this.h=[]}branch(p,g){const l=new f(3,p.toString());return this.h.push([p,g,l]),l}stop(){const p=Date.now()-this.g;f.f+=p;let g=!1;function l(k,a){const t=[],r=new Array(k+1).join("	");for(const[s,i,o]of a.h)if(i&&o){g=!0,t.push(`${r}CREATES -> ${s}`);const u=l(k+1,o);u&&t.push(u)}else t.push(`${r}uses -> ${s}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(p>2||g)&&f.all.add(w.join(`
`))}}e.$dr=f}),define(re[223],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Jb=e.IssueSource=e.IssueType=void 0;var C;(function(R){R[R.Bug=0]="Bug",R[R.PerformanceIssue=1]="PerformanceIssue",R[R.FeatureRequest=2]="FeatureRequest"})(C||(e.IssueType=C={}));var S;(function(R){R.VSCode="vscode",R.Extension="extension",R.Marketplace="marketplace"})(S||(e.IssueSource=S={})),e.$0Jb=(0,n.$wi)("issueService")}),define(re[5],oe([0,1,183,47,3,46,2,32,4,19,12,7,118,6]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=y,e.log=g,e.$ek=$,e.$fk=P,e.$gk=D,e.$hk=I,e.$3j=(0,m.$wi)("logService"),e.$4j=(0,m.$wi)("loggerService");function f(){return new Date().toISOString()}function y(O){return(0,d.$ag)(O)}var p;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$6j=p.Info;function g(O,M,W){switch(M){case p.Trace:O.trace(W);break;case p.Debug:O.debug(W);break;case p.Info:O.info(W);break;case p.Warning:O.warn(W);break;case p.Error:O.error(W);break;case p.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function l(O,M=!1){let W="";for(let F=0;F<O.length;F++){let T=O[F];if(T instanceof Error&&(T=(0,C.$hj)(T,M)),typeof T=="object")try{T=JSON.stringify(T)}catch{}W+=(F>0?" ":"")+T}return W}class w extends j.$Vc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new S.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(M){this.b!==M&&(this.b=M,this.c.fire(this.b))}getLevel(){return this.b}f(M){return this.b!==p.Off&&this.b<=M}}e.$8j=w;class k extends w{constructor(M){super(),this.h=M}f(M){return this.h||super.f(M)}trace(M,...W){this.f(p.Trace)&&this.g(p.Trace,l([M,...W],!0))}debug(M,...W){this.f(p.Debug)&&this.g(p.Debug,l([M,...W]))}info(M,...W){this.f(p.Info)&&this.g(p.Info,l([M,...W]))}warn(M,...W){this.f(p.Warning)&&this.g(p.Warning,l([M,...W]))}error(M,...W){if(this.f(p.Error))if(M instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=M.stack,this.g(p.Error,l(F))}else this.g(p.Error,l([M,...W]))}flush(){}}e.$9j=k;class a extends w{constructor(M=e.$6j){super(),this.setLevel(M),this.g=!h.$i}trace(M,...W){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}debug(M,...W){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}info(M,...W){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}warn(M,...W){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,M,...W):console.warn(`[main ${f()}]`,M,...W))}error(M,...W){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,M,...W):console.error(`[main ${f()}]`,M,...W))}flush(){}}e.$0j=a;class t extends w{constructor(M=e.$6j,W=!0){super(),this.g=W,this.setLevel(M)}trace(M,...W){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",M,...W):console.log(M,...W))}debug(M,...W){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",M,...W):console.log(M,...W))}info(M,...W){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",M,...W):console.log(M,...W))}warn(M,...W){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",M,...W):console.log(M,...W))}error(M,...W){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",M,...W):console.error(M,...W))}flush(){}}e.$$j=t;class r extends w{constructor(M,W=e.$6j){super(),this.g=M,this.setLevel(W)}trace(M,...W){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(M),...W])}debug(M,...W){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(M),...W])}info(M,...W){this.f(p.Info)&&this.g.log(p.Info,[this.h(M),...W])}warn(M,...W){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(M),...W])}error(M,...W){this.f(p.Error)&&this.g.log(p.Error,[this.h(M),...W])}h(M){return typeof M=="string"?M:(0,C.$hj)(M,this.f(p.Trace))}flush(){}}e.$_j=r;class s extends w{constructor(M){super(),this.g=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const W of this.g)W.setLevel(M);super.setLevel(M)}trace(M,...W){for(const F of this.g)F.trace(M,...W)}debug(M,...W){for(const F of this.g)F.debug(M,...W)}info(M,...W){for(const F of this.g)F.info(M,...W)}warn(M,...W){for(const F of this.g)F.warn(M,...W)}error(M,...W){for(const F of this.g)F.error(M,...W)}flush(){for(const M of this.g)M.flush()}dispose(){for(const M of this.g)M.dispose();super.dispose()}}e.$ak=s;class i extends j.$Vc{constructor(M,W,F){if(super(),this.h=M,this.j=W,this.b=new E.$Bc,this.c=this.B(new S.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$ee),this.onDidChangeVisibility=this.g.event,F)for(const T of F)this.b.set(T.resource,{logger:void 0,info:T})}m(M){return(0,d.$9f)(M)?[...this.b.values()].find(W=>W.info.id===M):this.b.get(M)}getLogger(M){return this.m(M)?.logger}createLogger(M,W){const F=this.n(M),T=(0,d.$9f)(M)?M:W?.id??(0,R.$kj)(F.toString()).toString(16);let q=this.b.get(F)?.logger;const ue=W?.logLevel==="always"?p.Trace:W?.logLevel;q||(q=this.s(F,ue??this.getLogLevel(F)??this.h,{...W,id:T}));const ee={logger:q,info:{resource:F,id:T,logLevel:ue,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(ee.info),this.b.set(F,ee),q}n(M){return(0,d.$9f)(M)?(0,c.$0g)(this.j,`${M}.log`):M}setLogLevel(M,W){if(b.URI.isUri(M)){const F=M,T=W,q=this.b.get(F);q&&T!==q.info.logLevel&&(q.info.logLevel=T===this.h?void 0:T,q.logger?.setLevel(T),this.b.set(q.info.resource,q),this.f.fire([F,T]))}else{this.h=M;for(const[F,T]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(M,W){const F=this.m(M);F&&W!==!F.info.hidden&&(F.info.hidden=!W,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,W]))}getLogLevel(M){let W;return M&&(W=this.b.get(M)?.info.logLevel),W??this.h}registerLogger(M){const W=this.b.get(M.resource);W?W.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this.b.set(M.resource,{info:M,logger:void 0}),this.c.fire({added:[M],removed:[]}))}deregisterLogger(M){const W=this.b.get(M);W&&(W.logger&&W.logger.dispose(),this.b.delete(M),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const M of this.b.values())yield M.info}getRegisteredLogger(M){return this.b.get(M)?.info}dispose(){this.b.forEach(M=>M.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=i;class o{constructor(){this.onDidChangeLogLevel=new S.$ee().event}setLevel(M){}getLevel(){return p.Info}trace(M,...W){}debug(M,...W){}info(M,...W){}warn(M,...W){}error(M,...W){}critical(M,...W){}dispose(){}flush(){}}e.$ck=o;class u extends o{}e.$dk=u;function $(O){if(O.verbose)return p.Trace;if(typeof O.logLevel=="string"){const M=I(O.logLevel.toLowerCase());if(M!==void 0)return M}return e.$6j}function P(O){switch(O){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function D(O){switch(O){case p.Trace:return{original:"Trace",value:n.localize(0,null)};case p.Debug:return{original:"Debug",value:n.localize(1,null)};case p.Info:return{original:"Info",value:n.localize(2,null)};case p.Warning:return{original:"Warning",value:n.localize(3,null)};case p.Error:return{original:"Error",value:n.localize(4,null)};case p.Off:return{original:"Off",value:n.localize(5,null)}}}function I(O){switch(O){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$ik=new v.$Nj("logLevel",P(p.Info))});var ie=this&&this.__param||function(J,e){return function(n,C){e(n,C,J)}};define(re[224],oe([0,1,14,4,5]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;const R=n.safeStorage;let j=class{constructor(h){this.a=h,n.app.commandLine.getSwitchValue("password-store")==="basic"&&R.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(R.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(h){let c;try{if(c=JSON.parse(h),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const d=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const b=R.decryptString(d);return this.a.trace("[EncryptionMainService] Decrypted value."),b}catch(d){throw this.a.error(d),d}}isEncryptionAvailable(){return Promise.resolve(R.isEncryptionAvailable())}getKeyStorageProvider(){if(C.$i)return Promise.resolve("dpapi");if(C.$j)return Promise.resolve("keychain_access");if(R.getSelectedStorageBackend)try{const h=R.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(C.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(C.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!R.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");R.setUsePlainTextEncryption(!0)}};e.$ncc=j,e.$ncc=j=Se([ie(0,S.$3j)],j)}),define(re[225],oe([0,1,22,8,15,3,31,2,9,60,5]),function(J,e,n,C,S,R,j,E,h,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class b extends E.$Vc{constructor(m,f){super(),this.a=m,this.b=f,this.c=this.B(new R.$ee),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$ee),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new C.$uh(0)),this.w=[],this.y=this.B(new C.$uh(0))}watch(m,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(m,f):this.z(m,f)}n(m,f){const y={path:this.J(m),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},p=(0,n.$Ub)(this.j,y);return this.r(),(0,E.$Tc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,S.$1)(m))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,c.$Oq)(f)),f=>this.G(f),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const f of this.j)(0,c.$Kq)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const f of this.j)(0,c.$Kq)(f)&&m.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,f){const y={path:this.J(m),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},p=(0,n.$Ub)(this.w,y);return this.C(),(0,E.$Tc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,S.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,c.$Oq)(m)),m=>this.G(m),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,h.$ic)(m.fsPath)}J(m){const f=this.I(m);return(0,j.$yg)(f)}}e.$Uq=b}),define(re[226],oe([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;let a=class extends c.$Vc{static{k=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new j.$ee),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$ee),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$ee),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$ee),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$ee),this.Y=this.B(new j.$ee),this.onDidFilesChange=this.Y.event,this.Z=this.B(new j.$ee),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new C.$Fh)}registerProvider(r,s){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${r}`);const i=new c.$Uc;return this.h.set(r,s),this.c.fire({added:!0,scheme:r,provider:s}),i.add(s.onDidChangeFile(o=>{const u=new p.$jl(o,!this.S(s));this.X.fire(u),u.hasCorrelation()||this.Y.fire(u)})),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(o=>this.Z.fire(new Error(o)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:r}))),(0,c.$Tc)(()=>{this.c.fire({added:!1,scheme:r,provider:s}),this.h.delete(r),(0,c.$Qc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const s=[];this.f.fire({scheme:r,join(i){s.push(i)}}),!this.h.has(r)&&await C.Promises.settled(s)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,s){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return h.Iterable.map(this.h,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async j(r){if(!(0,m.$bh)(r))throw new p.$ll((0,y.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const s=this.h.get(r.scheme);if(!s){const i=new w.$bb;throw i.message=(0,y.localize)(1,null,r.toString()),i}return s}async m(r){const s=await this.j(r);if((0,p.$9k)(s)||(0,p.$6k)(s)||(0,p.$0k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const s=await this.j(r);if((0,p.$9k)(s)||(0,p.$6k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.s(r,s)}catch(i){throw(0,p.$gl)(i)===p.FileSystemProviderErrorCode.FileNotFound?new p.$ll((0,y.localize)(2,null,this.sb(r)),1):(0,p.$el)(i)}}async s(r,s){const i=await this.j(r),o=this.S(i),u=s?.resolveTo,$=s?.resolveSingleChildDescendants,P=s?.resolveMetadata,D=await i.stat(r);let I;return this.t(i,r,D,void 0,!!P,(O,M)=>(I||(I=d.$Ci.forUris(()=>!o),I.set(r,!0),u&&I.fill(!0,u)),I.get(O.resource)||I.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&$?M===1:!1))}async t(r,s,i,o,u,$){const{providerExtUri:P}=this.R(r),D={resource:s,name:P.basename(s),isFile:(i.type&p.FileType.File)!==0,isDirectory:(i.type&p.FileType.Directory)!==0,isSymbolicLink:(i.type&p.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&p.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&p.FilePermission.Locked),etag:(0,p.$wl)({mtime:i.mtime,size:i.size}),children:void 0};if(D.isDirectory&&$(D,o)){try{const I=await r.readdir(s),O=await C.Promises.settled(I.map(async([M,W])=>{try{const F=P.joinPath(s,M),T=u?await r.stat(F):{type:W};return await this.t(r,F,T,I.length,u,$)}catch(F){return this.b.trace(F),null}}));D.children=(0,n.$Hb)(O)}catch(I){this.b.trace(I),D.children=[]}return D}return D}async resolveAll(r){return C.Promises.settled(r.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const s=await this.j(r),i=await s.stat(r);return this.t(s,r,i,void 0,!0,()=>!1)}async exists(r){const s=await this.j(r);try{return!!await s.stat(r)}catch{return!1}}async canCreateFile(r,s){try{await this.u(r,s)}catch(i){return i}return!0}async u(r,s){if(!s?.overwrite&&await this.exists(r))throw new p.$ll((0,y.localize)(3,null,this.sb(r)),3,s)}async createFile(r,s=S.$Ge.fromString(""),i){await this.u(r,i);const o=await this.writeFile(r,s);return this.r.fire(new p.$il(r,0,o)),o}async writeFile(r,s,i){const o=this.qb(await this.n(r),r),{providerExtUri:u}=this.R(o);let $=i;if((0,p.$_k)(o)&&!$?.atomic){const P=o.enforceAtomicWriteFile?.(r);P&&($={...i,atomic:P})}try{await this.w(o,r,$)||await this.U(o,u.dirname(r));let D;if((0,p.$6k)(o)&&!(s instanceof S.$Ge))if((0,f.$se)(s)){const I=await(0,f.$ze)(s,3);I.ended?D=S.$Ge.concat(I.buffer):D=I}else D=(0,f.$we)(s,I=>S.$Ge.concat(I),3);else D=s;!(0,p.$9k)(o)||(0,p.$6k)(o)&&D instanceof S.$Ge||(0,p.$6k)(o)&&(0,p.$_k)(o)&&$?.atomic?await this.hb(o,r,$,D):await this.db(o,r,$,D instanceof S.$Ge?(0,S.$Re)(D):D),this.r.fire(new p.$il(r,4))}catch(P){throw new p.$ll((0,y.localize)(4,null,this.sb(r),(0,p.$el)(P).toString()),(0,p.$hl)(P),$)}return this.resolve(r,{resolveMetadata:!0})}async w(r,s,i){const o=!!i?.unlock;if(o&&!(r.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(s)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(s)));if(!(r.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(s)));if(o)throw new Error((0,y.localize)(8,null,this.sb(s)))}let $;try{$=await r.stat(s)}catch{return}if($.type&p.FileType.Directory)throw new p.$ll((0,y.localize)(9,null,this.sb(s)),0,i);if(this.rb(s,$),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==p.$vl&&typeof $.mtime=="number"&&typeof $.size=="number"&&i.mtime<$.mtime&&i.etag!==(0,p.$wl)({mtime:i.mtime,size:$.size}))throw new p.$ll((0,y.localize)(10,null),3,i);return $}async readFile(r,s,i){const o=await this.m(r);return s?.atomic?this.z(o,r,s,i):this.C(o,r,s,i)}async z(r,s,i,o){return new Promise((u,$)=>{this.cb.queueFor(s,async()=>{try{const P=await this.C(r,s,i,o);u(P)}catch(P){$(P)}},this.R(r).providerExtUri)})}async C(r,s,i,o){const u=await this.D(r,s,{...i,preferUnbuffered:!0},o);return{...u,value:await(0,S.$Se)(u.value)}}async readFileStream(r,s,i){const o=await this.m(r);return this.D(o,r,s,i)}async D(r,s,i,o){const u=new R.$pe(o);let $=i;(0,p.$$k)(r)&&r.enforceAtomicReadFile?.(s)&&($={...i,atomic:!0});const P=this.J(s,$).then(I=>I,I=>{throw u.dispose(!0),I});let D;try{return typeof $?.etag=="string"&&$.etag!==p.$vl&&await P,$?.atomic&&(0,p.$$k)(r)||!((0,p.$9k)(r)||(0,p.$0k)(r))||(0,p.$6k)(r)&&$?.preferUnbuffered?D=this.I(r,s,$):(0,p.$0k)(r)?D=this.G(r,s,u.token,$):D=this.H(r,s,u.token,$),D.on("end",()=>u.dispose()),D.on("error",()=>u.dispose()),{...await P,value:D}}catch(I){throw D&&await(0,f.$xe)(D),this.F(I,s,$)}}F(r,s,i){const o=(0,y.localize)(11,null,this.sb(s),(0,p.$el)(r).toString());return r instanceof p.$nl?new p.$nl(o,r.stat,i):r instanceof p.$ml?new p.$ml(o,r.fileOperationResult,r.size,r.options):new p.$ll(o,(0,p.$hl)(r),i)}G(r,s,i,o=Object.create(null)){const u=r.readFileStream(s,o,i);return(0,f.$De)(u,{data:$=>$ instanceof S.$Ge?$:S.$Ge.wrap($),error:$=>this.F($,s,o)},$=>S.$Ge.concat($))}H(r,s,i,o=Object.create(null)){const u=(0,S.$We)();return(0,g.$Hq)(r,s,u,$=>$,{...o,bufferSize:this.a,errorTransformer:$=>this.F($,s,o)},i),u}I(r,s,i){const o=(0,f.$ue)(u=>S.$Ge.concat(u));return(async()=>{try{let u;i?.atomic&&(0,p.$$k)(r)?u=await r.readFile(s,{atomic:!0}):u=await r.readFile(s),typeof i?.position=="number"&&(u=u.slice(i.position)),typeof i?.length=="number"&&(u=u.slice(0,i.length)),this.L(s,u.byteLength,i),o.end(S.$Ge.wrap(u))}catch(u){o.error(u),o.end()}})(),o}async J(r,s){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new p.$ll((0,y.localize)(12,null,this.sb(r)),0,s);if(typeof s?.etag=="string"&&s.etag!==p.$vl&&s.etag===i.etag)throw new p.$nl((0,y.localize)(13,null),i,s);return this.L(r,i.size,s),i}L(r,s,i){if(typeof i?.limits?.size=="number"&&s>i.limits.size)throw new p.$ml((0,y.localize)(14,null,this.sb(r)),7,s,i)}async canMove(r,s,i){return this.M(r,s,"move",i)}async canCopy(r,s,i){return this.M(r,s,"copy",i)}async M(r,s,i,o){if(r.toString()!==s.toString())try{const u=i==="move"?this.qb(await this.n(r),r):await this.m(r),$=this.qb(await this.n(s),s);await this.Q(u,r,$,s,i,o)}catch(u){return u}return!0}async move(r,s,i){const o=this.qb(await this.n(r),r),u=this.qb(await this.n(s),s),$=await this.N(o,r,u,s,"move",!!i),P=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new p.$il(r,$==="move"?2:3,P)),P}async copy(r,s,i){const o=await this.m(r),u=this.qb(await this.n(s),s),$=await this.N(o,r,u,s,"copy",!!i),P=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new p.$il(r,$==="copy"?3:2,P)),P}async N(r,s,i,o,u,$){if(s.toString()===o.toString())return u;const{exists:P,isSameResourceWithDifferentPathCase:D}=await this.Q(r,s,i,o,u,$);if(P&&!D&&$&&await this.del(o,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(o)),u==="copy"){if(r===i&&(0,p.$7k)(r))await r.copy(s,o,{overwrite:$});else{const I=await this.resolve(s);I.isDirectory?await this.P(r,I,i,o):await this.O(r,s,i,o)}return u}else return r===i?(await r.rename(s,o,{overwrite:$}),u):(await this.N(r,s,i,o,"copy",$),await this.del(s,{recursive:!0}),"copy")}async O(r,s,i,o){if((0,p.$9k)(r)&&(0,p.$9k)(i))return this.jb(r,s,i,o);if((0,p.$9k)(r)&&(0,p.$6k)(i))return this.pb(r,s,i,o);if((0,p.$6k)(r)&&(0,p.$9k)(i))return this.nb(r,s,i,o);if((0,p.$6k)(r)&&(0,p.$6k)(i))return this.lb(r,s,i,o)}async P(r,s,i,o){await i.mkdir(o),Array.isArray(s.children)&&await C.Promises.settled(s.children.map(async u=>{const $=this.R(i).providerExtUri.joinPath(o,u.name);return u.isDirectory?this.P(r,await this.resolve(u.resource),i,$):this.O(r,u.resource,i,$)}))}async Q(r,s,i,o,u,$){let P=!1;if(r===i){const{providerExtUri:I,isPathCaseSensitive:O}=this.R(r);if(O||(P=I.isEqual(s,o)),P&&u==="copy")throw new Error((0,y.localize)(15,null,this.sb(s),this.sb(o)));if(!P&&I.isEqualOrParent(o,s))throw new Error((0,y.localize)(16,null,this.sb(s),this.sb(o)))}const D=await this.exists(o);if(D&&!P){if(!$)throw new p.$ll((0,y.localize)(17,null,this.sb(s),this.sb(o)),4);if(r===i){const{providerExtUri:I}=this.R(r);if(I.isEqualOrParent(s,o))throw new Error((0,y.localize)(18,null,this.sb(s),this.sb(o)))}}return{exists:D,isSameResourceWithDifferentPathCase:P}}R(r){const s=this.S(r);return{providerExtUri:s?m.$Zg:m.$2g,isPathCaseSensitive:s}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.qb(await this.j(r),r);await this.U(s,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$il(r,0,i)),i}async U(r,s){const i=[],{providerExtUri:o}=this.R(r);for(;!o.isEqual(s,o.dirname(s));)try{if(!((await r.stat(s)).type&p.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(s)));break}catch(u){if((0,p.$gl)(u)!==p.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(o.basename(s)),s=o.dirname(s)}for(let u=i.length-1;u>=0;u--){s=o.joinPath(s,i[u]);try{await r.mkdir(s)}catch($){if((0,p.$gl)($)!==p.FileSystemProviderErrorCode.FileExists)throw $}}}async canDelete(r,s){try{await this.W(r,s)}catch(i){return i}return!0}async W(r,s){const i=this.qb(await this.j(r),r),o=!!s?.useTrash;if(o&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(r)));const u=s?.atomic;if(u&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(r)));if(o&&u)throw new Error((0,y.localize)(22,null,this.sb(r)));let $;try{$=await i.stat(r)}catch{}if($)this.rb(r,$);else throw new p.$ll((0,y.localize)(23,null,this.sb(r)),1);if(!!!s?.recursive){const D=await this.resolve(r);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(r)))}return i}async del(r,s){const i=await this.W(r,s);let o=s;if((0,p.$al)(i)&&!o?.atomic){const D=i.enforceAtomicDelete?.(r);D&&(o={...s,atomic:D})}const u=!!o?.useTrash,$=!!o?.recursive,P=o?.atomic??!1;await i.delete(r,{recursive:$,useTrash:u,atomic:P}),this.r.fire(new p.$il(r,1))}async cloneFile(r,s){const i=await this.j(r),o=this.qb(await this.n(s),s);if(!(i===o&&this.R(i).providerExtUri.isEqual(r,s)))return i===o&&(0,p.$8k)(i)?i.cloneFile(r,s):(await this.U(o,this.R(o).providerExtUri.dirname(s)),i===o&&(0,p.$7k)(i)?this.cb.queueFor(r,()=>i.copy(r,s,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(r,()=>this.O(i,r,o,s),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(r,s){return this.watch(r,{...s,correlationId:k.ab++})}watch(r,s={recursive:!1,excludes:[]}){const i=new c.$Uc;let o=!1,u=()=>{o=!0};i.add((0,c.$Tc)(()=>u())),(async()=>{try{const P=await this.bb(r,s);o?(0,c.$Qc)(P):u=()=>(0,c.$Qc)(P)}catch(P){this.b.error(P)}})();const $=s.correlationId;if(typeof $=="number"){const P=i.add(new j.$ee);return i.add(this.X.event(I=>{I.correlates($)&&P.fire(I)})),{onDidChange:P.event,dispose:()=>i.dispose()}}return i}async bb(r,s){const i=await this.j(r),o=(0,E.$kj)([this.R(i).providerExtUri.getComparisonKey(r),s]);let u=this.$.get(o);return u||(u={count:0,disposable:i.watch(r,s)},this.$.set(o,u)),u.count+=1,(0,c.$Tc)(()=>{u&&(u.count--,u.count===0&&((0,c.$Qc)(u.disposable),this.$.delete(o)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,c.$Qc)(r.disposable);this.$.clear()}async db(r,s,i,o){return this.cb.queueFor(s,async()=>{const u=await r.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,f.$se)(o)||(0,f.$te)(o)?await this.eb(r,u,o):await this.fb(r,u,o)}catch($){throw(0,p.$el)($)}finally{await r.close(u)}},this.R(r).providerExtUri)}async eb(r,s,i){let o=0,u;if((0,f.$te)(i)){if(i.buffer.length>0){const $=S.$Ge.concat(i.buffer);await this.gb(r,s,$,$.byteLength,o,0),o+=$.byteLength}if(i.ended)return;u=i.stream}else u=i;return new Promise(($,P)=>{(0,f.$ye)(u,{onData:async D=>{u.pause();try{await this.gb(r,s,D,D.byteLength,o,0)}catch(I){return P(I)}o+=D.byteLength,setTimeout(()=>u.resume())},onError:D=>P(D),onEnd:()=>$()})})}async fb(r,s,i){let o=0,u;for(;(u=i.read())!==null;)await this.gb(r,s,u,u.byteLength,o,0),o+=u.byteLength}async gb(r,s,i,o,u,$){let P=0;for(;P<o;){const D=await r.write(s,u+P,i.buffer,$+P,o-P);P+=D}}async hb(r,s,i,o){return this.cb.queueFor(s,()=>this.ib(r,s,i,o),this.R(r).providerExtUri)}async ib(r,s,i,o){let u;o instanceof S.$Ge?u=o:(0,f.$se)(o)?u=await(0,S.$Se)(o):(0,f.$te)(o)?u=await(0,S.$Te)(o):u=(0,S.$Qe)(o),await r.writeFile(s,u.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,s,i,o){return this.cb.queueFor(o,()=>this.kb(r,s,i,o),this.R(i).providerExtUri)}async kb(r,s,i,o){let u,$;try{u=await r.open(s,{create:!1}),$=await i.open(o,{create:!0,unlock:!1});const P=S.$Ge.alloc(this.a);let D=0,I=0,O=0;do O=await r.read(u,D,P.buffer,I,P.byteLength-I),await this.gb(i,$,P,O,D,I),D+=O,I+=O,I===P.byteLength&&(I=0);while(O>0)}catch(P){throw(0,p.$el)(P)}finally{await C.Promises.settled([typeof u=="number"?r.close(u):Promise.resolve(),typeof $=="number"?i.close($):Promise.resolve()])}}async lb(r,s,i,o){return this.cb.queueFor(o,()=>this.mb(r,s,i,o),this.R(i).providerExtUri)}async mb(r,s,i,o){return i.writeFile(o,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,s,i,o){return this.cb.queueFor(o,()=>this.ob(r,s,i,o),this.R(i).providerExtUri)}async ob(r,s,i,o){const u=await i.open(o,{create:!0,unlock:!1});try{const $=await r.readFile(s);await this.gb(i,u,S.$Ge.wrap($),$.byteLength,0,0)}catch($){throw(0,p.$el)($)}finally{await i.close(u)}}async pb(r,s,i,o){const u=await(0,S.$Se)(this.H(r,s,R.CancellationToken.None));await this.hb(i,o,void 0,u)}qb(r,s){if(r.capabilities&2048)throw new p.$ll((0,y.localize)(25,null,this.sb(s)),6);return r}rb(r,s){if((s.permissions??0)&p.FilePermission.Readonly)throw new p.$ll((0,y.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===b.Schemas.file?r.fsPath:r.toString(!0)}};e.$Iq=a,e.$Iq=a=k=Se([ie(0,l.$3j)],a)}),define(re[94],oe([0,1,43,315,8,32,17,3,31,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,(()=>{try{(0,C.gracefulify)(n)}catch(r){console.error(`Error enabling graceful-fs: ${(0,w.$hj)(r)}`)}})();class t extends l.$Uq{static{this.L=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=E.Event.None,this.P=new R.$Bc(o=>v.$1g.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,b.$k&&(this.M|=1024)),this.M}async stat(s){try{const{stat:i,symbolicLink:o}=await f.SymlinkSupport.stat(this.I(s));return{type:this.O(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await f.Promises.readdir(this.I(s),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async u=>{try{let $;u.isSymbolicLink()?$=(await this.stat((0,v.$0g)(s,u.name))).type:$=this.O(u),o.push([u.name,$])}catch($){this.a.trace($)}})),o}catch(i){throw this.hb(i)}}O(s,i){let o;return i?.dangling?o=p.FileType.Unknown:s.isFile()?o=p.FileType.File:s.isDirectory()?o=p.FileType.Directory:o=p.FileType.Unknown,i&&(o|=p.FileType.SymbolicLink),o}async Q(s){const i=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const u=new S.$vh;return this.P.set(s,u),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(s)===u&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(s,i){let o;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),o=await this.Q(s));const u=this.I(s);return await f.Promises.readFile(u)}catch(u){throw this.hb(u)}finally{o?.dispose()}}R(s){t.L&&this.a.trace(s)}readFileStream(s,i,o){const u=(0,m.$ue)($=>j.$Ge.concat($.map(P=>j.$Ge.wrap(P))).buffer);return(0,g.$Hq)(this,s,u,$=>$.buffer,{...i,bufferSize:256*1024},o),u}async writeFile(s,i,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(s)?this.U(s,(0,v.$0g)((0,v.$9g)(s),`${(0,v.$7g)(s)}${o.atomic.postfix}`),i,o):this.W(s,i,o)}async S(s){try{const i=this.I(s),{symbolicLink:o}=await f.SymlinkSupport.stat(i);if(o)return!1}catch{}return!0}async U(s,i,o,u){const $=new c.$Uc;try{$.add(await this.Q(s)),$.add(await this.Q(i)),await this.W(i,o,u,!0);try{await this.rename(i,s,{overwrite:!0})}catch(P){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{$.dispose()}}async W(s,i,o,u){let $;try{const P=this.I(s);if(!o.create||!o.overwrite){if(await f.Promises.exists(P)){if(!o.overwrite)throw(0,p.$dl)((0,y.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,p.$dl)((0,y.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}$=await this.open(s,{create:!0,unlock:o.unlock},u),await this.write($,0,i,0,i.byteLength)}catch(P){throw await this.ib(s,P)}finally{typeof $=="number"&&await this.close($)}}static{this.$=!0}static configureFlushOnWrite(s){t.$=s}async open(s,i,o){const u=this.I(s);let $;(0,p.$4k)(i)&&!o&&($=await this.Q(s));let P;try{if((0,p.$4k)(i)&&i.unlock)try{const{stat:I}=await f.SymlinkSupport.stat(u);I.mode&128||await f.Promises.chmod(u,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let D;if((0,p.$4k)(i)){if(b.$i)try{await f.Promises.truncate(u,0),D="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}D||(D="w")}else D="r";P=await f.Promises.open(u,D)}catch(D){throw $?.dispose(),(0,p.$4k)(i)?await this.ib(s,D):this.hb(D)}if(this.X.set(P,0),(0,p.$4k)(i)&&this.Z.set(P,s),$){const D=this.Y.get(P);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${u})`),this.Y.set(P,$),D&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${u})`),D.dispose())}return P}async close(s){const i=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&t.$)try{await f.Promises.fdatasync(s)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await f.Promises.close(s)}catch(o){throw this.hb(o)}finally{i&&(this.Y.get(s)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,o,u,$){const P=this.ab(s,i);let D=null;try{D=(await f.Promises.read(s,o,u,$,P)).bytesRead}catch(I){throw this.hb(I)}finally{this.bb(s,P,D)}return D}ab(s,i){return i===this.X.get(s)?null:i}bb(s,i,o){const u=this.X.get(s);typeof u=="number"&&(typeof i=="number"||(typeof o=="number"?this.X.set(s,u+o):this.X.delete(s)))}async write(s,i,o,u,$){return(0,S.$Qh)(()=>this.cb(s,i,o,u,$),100,3)}async cb(s,i,o,u,$){const P=this.ab(s,i);let D=null;try{D=(await f.Promises.write(s,o,u,$,P)).bytesWritten}catch(I){throw await this.ib(this.Z.get(s),I)}finally{this.bb(s,P,D)}return D}async mkdir(s){try{await f.Promises.mkdir(this.I(s))}catch(i){throw this.hb(i)}}async delete(s,i){try{const o=this.I(s);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,d.$kc)((0,d.$nc)(o),`${(0,d.$oc)(o)}${i.atomic.postfix}`)),await f.Promises.rm(o,f.RimRafMode.MOVE,u)}else try{await f.Promises.unlink(o)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let $=!1;try{const{stat:P,symbolicLink:D}=await f.SymlinkSupport.stat(o);$=P.isDirectory()&&!D}catch{}if($)await f.Promises.rmdir(o);else throw u}else throw u}}catch(o){throw this.hb(o)}}async rename(s,i,o){const u=this.I(s),$=this.I(i);if(u!==$)try{await this.db(s,i,"move",o.overwrite),await f.Promises.rename(u,$)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(2,null,(0,d.$oc)(u),(0,d.$oc)((0,d.$nc)($)),P.toString()))),this.hb(P)}}async copy(s,i,o){const u=this.I(s),$=this.I(i);if(u!==$)try{await this.db(s,i,"copy",o.overwrite),await f.Promises.copy(u,$,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(3,null,(0,d.$oc)(u),(0,d.$oc)((0,d.$nc)($)),P.toString()))),this.hb(P)}}async db(s,i,o,u){const $=this.I(s),P=this.I(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,h.$ug)($,P,!0)),D){if(o==="copy")throw(0,p.$dl)((0,y.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const O=await this.N(s);if(!O)throw(0,p.$dl)((0,y.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const M=await this.N(i);if(M){if(!u)throw(0,p.$dl)((0,y.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);O.type&p.FileType.File&&M.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.eb(s,i,!1)}async eb(s,i,o){const u=this.I(s),$=this.I(i),P=!!(this.capabilities&1024);if((0,h.$ug)(u,$,!P))return;const D=new c.$Uc;try{D.add(await this.Q(s)),D.add(await this.Q(i)),o&&await f.Promises.mkdir((0,d.$nc)($),{recursive:!0}),await f.Promises.copyFile(u,$)}catch(I){if(I.code==="ENOENT"&&!o)return this.eb(s,i,!0);throw this.hb(I)}finally{D.dispose()}}t(s,i,o){return new k.$2q(u=>s(u),u=>i(u),o)}F(s,i,o){return new a.$$q(u=>s(u),u=>i(u),o)}hb(s){if(s instanceof p.$cl)return s;let i=s,o;switch(s.code){case"ENOENT":o=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=p.FileSystemProviderErrorCode.Unknown;break;default:o=p.FileSystemProviderErrorCode.Unknown}return(0,p.$dl)(i,o)}async ib(s,i){let o=this.hb(i);if(s&&o.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await f.SymlinkSupport.stat(this.I(s));u.mode&128||(o=(0,p.$dl)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return o}}e.$_q=t}),define(re[227],oe([0,1,3,94,2,17,63,23]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=e.$Js=void 0;class h extends S.$Vc{constructor(b,v){super(),this.a=b,this.b=v,this.F=new Map,this.G=new Map}call(b,v,m){const f=this.c(b);switch(v){case"stat":return this.g(f,m[0]);case"readdir":return this.h(f,m[0]);case"open":return this.r(f,m[0],m[1]);case"close":return this.s(m[0]);case"read":return this.t(m[0],m[1],m[2]);case"readFile":return this.j(f,m[0],m[1]);case"write":return this.u(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.n(f,m[0],m[1],m[2]);case"rename":return this.z(f,m[0],m[1],m[2]);case"copy":return this.C(f,m[0],m[1],m[2]);case"cloneFile":return this.D(f,m[0],m[1]);case"mkdir":return this.w(f,m[0]);case"delete":return this.y(f,m[0],m[1]);case"watch":return this.I(f,m[0],m[1],m[2],m[3]);case"unwatch":return this.J(m[0],m[1])}throw new Error(`IPC Command ${v} not found`)}listen(b,v,m){const f=this.c(b);switch(v){case"fileChange":return this.H(f,m[0]);case"readFileStream":return this.m(f,m[0],m[1])}throw new Error(`Unknown event ${v}`)}g(b,v){const m=this.f(b,v,!0);return this.a.stat(m)}h(b,v){const m=this.f(b,v);return this.a.readdir(m)}async j(b,v,m){const f=this.f(b,v,!0),y=await this.a.readFile(f,m);return R.$Ge.wrap(y)}m(b,v,m){const f=this.f(b,v,!0),y=new E.$pe,p=new n.$ee({onDidRemoveLastListener:()=>{y.cancel()}}),g=this.a.readFileStream(f,m,y.token);return(0,j.$ye)(g,{onData:l=>p.fire(R.$Ge.wrap(l)),onError:l=>p.fire(l),onEnd:()=>{p.fire("end"),p.dispose(),y.dispose()}}),p.event}n(b,v,m,f){const y=this.f(b,v);return this.a.writeFile(y,m.buffer,f)}r(b,v,m){const f=this.f(b,v,!0);return this.a.open(f,m)}s(b){return this.a.close(b)}async t(b,v,m){const f=R.$Ge.alloc(m),p=await this.a.read(b,v,f.buffer,0,m);return[f,p]}u(b,v,m,f,y){return this.a.write(b,v,m.buffer,f,y)}w(b,v){const m=this.f(b,v);return this.a.mkdir(m)}y(b,v,m){const f=this.f(b,v);return this.a.delete(f,m)}z(b,v,m,f){const y=this.f(b,v),p=this.f(b,m);return this.a.rename(y,p,f)}C(b,v,m,f){const y=this.f(b,v),p=this.f(b,m);return this.a.copy(y,p,f)}D(b,v,m){const f=this.f(b,v),y=this.f(b,m);return this.a.cloneFile(f,y)}H(b,v){const m=new n.$ee({onWillAddFirstListener:()=>{this.F.set(v,this.L(b,m))},onDidRemoveLastListener:()=>{(0,S.$Qc)(this.F.get(v)),this.F.delete(v)}});return m.event}async I(b,v,m,f,y){const p=this.F.get(v);if(p){const g=this.f(b,f),l=p.watch(m,g,y);this.G.set(v+m,l)}}async J(b,v){const m=b+v,f=this.G.get(m);f&&((0,S.$Qc)(f),this.G.delete(m))}dispose(){super.dispose();for(const[,b]of this.G)b.dispose();this.G.clear();for(const[,b]of this.F)b.dispose();this.F.clear()}}e.$Js=h;class c extends S.$Vc{constructor(b,v,m,f){super(),this.c=b,this.f=m,this.g=f,this.a=new Map,this.b=this.B(new C.$_q(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(b){const v=this.B(new n.$ee);this.B(v.event(m=>{b.fire(m.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile(m=>v.fire(m))),this.B(this.b.onDidWatchError(m=>b.fire(m)))}j(b){}m(b){}watch(b,v,m){const f=this.m(this.g);return Array.isArray(f)&&(m.excludes=[...m.excludes,...f]),this.a.set(b,this.b.watch(v,m)),(0,S.$Tc)(()=>{(0,S.$Qc)(this.a.get(b)),this.a.delete(b)})}dispose(){for(const[,b]of this.a)b.dispose();this.a.clear(),super.dispose()}}e.$Ks=c}),define(re[228],oe([0,1,14,180,4,7,16,9,227,157,47]),function(J,e,n,C,S,R,j,E,h,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class b extends h.$Js{constructor(f,y,p){super(f,y),this.M=p}c(f){return c.$zn}f(f,y){return R.URI.revive(y)}async y(f,y,p){if(!p.useTrash)return super.y(f,y,p);const g=this.f(f,y),l=(0,E.$ic)(g.fsPath);try{await n.shell.trashItem(l)}catch(w){throw(0,j.$dl)(S.$i?(0,C.localize)(0,null,(0,E.$oc)(l),(0,d.$hj)(w)):(0,C.localize)(1,null,(0,E.$oc)(l),(0,d.$hj)(w)),j.FileSystemProviderErrorCode.Unknown)}}L(f,y){return new v(f,y,this.b,this.M)}}e.$vcc=b;class v extends h.$Ks{watch(f,y,p){if(p.recursive)throw(0,j.$dl)("Recursive file watching is not supported from main process for performance reasons.",j.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,p)}}}),define(re[229],oe([0,1,5]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=void 0;class C extends n.$9j{constructor(R=n.$6j){super(),this.m=[],this.n=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(j=>{this.n?.setLevel(j)}))}set logger(R){this.n=R;for(const{level:j,message:E}of this.m)(0,n.log)(R,j,E);this.m=[]}g(R,j){this.n?(0,n.log)(this.n,R,j):this.getLevel()<=R&&this.m.push({level:R,message:j})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$j_b=C}),define(re[230],oe([0,1,7,3,5,2]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=void 0;class j extends S.$bk{constructor(b,v,m,f,y){super(v,m,f),this.r=b,this.t=y,this.B(y.listen("onDidChangeLogLevel",b)(p=>{(0,S.$5j)(p)?super.setLogLevel(p):super.setLogLevel(n.URI.revive(p[0]),p[1])})),this.B(y.listen("onDidChangeVisibility",b)(([p,g])=>super.setVisibility(n.URI.revive(p),g))),this.B(y.listen("onDidChangeLoggers",b)(({added:p,removed:g})=>{for(const l of p)super.registerLogger({...l,resource:n.URI.revive(l.resource)});for(const l of g)super.deregisterLogger(l.resource)}))}createConsoleMainLogger(){return new S.$_j({log:(b,v)=>{this.t.call("consoleLog",[b,v])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,v){super.setLogLevel(b,v),this.t.call("setLogLevel",[b,v])}setVisibility(b,v){super.setVisibility(b,v),this.t.call("setVisibility",[this.n(b),v])}s(b,v,m){return new E(this.t,b,v,m,this.r)}static setLogLevel(b,v,m){return b.call("setLogLevel",[v,m])}}e.$_r=j;class E extends S.$9j{constructor(b,v,m,f,y){super(f?.logLevel==="always"),this.r=b,this.s=v,this.m=!1,this.n=[],this.setLevel(m),this.r.call("createLogger",[v,f,y]).then(()=>{this.u(this.n),this.m=!0})}g(b,v){const m=[[b,v]];this.m?this.u(m):this.n.push(...m)}u(b){this.r.call("log",[this.s,b])}}class h{constructor(b,v){this.a=b,this.b=v}listen(b,v){const m=this.b(b);switch(v){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(y=>this.c(y,m)),removed:[...f.removed].map(y=>this.c(y,m))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,f=>[m.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,f=>(0,S.$5j)(f)?f:[m.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${v}`)}async call(b,v,m){const f=this.b(b);switch(v){case"setLogLevel":return(0,S.$5j)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(n.URI.revive(f.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,f)))}throw new Error(`Call not found: ${v}`)}c(b,v){return{...b,resource:v.transformOutgoingURI(b.resource)}}}e.$as=h;class c extends R.$Vc{constructor(b,v){super(),v.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(m=>v.call("setLogLevel",[m]))),v.call("getRegisteredLoggers").then(m=>{for(const f of m)b.registerLogger({...f,resource:n.URI.revive(f.resource)})}),this.B(v.listen("onDidChangeVisibility")(([m,f])=>b.setVisibility(n.URI.revive(m),f))),this.B(v.listen("onDidChangeLoggers")(({added:m,removed:f})=>{for(const y of m)b.registerLogger({...y,resource:n.URI.revive(y.resource)});for(const y of f)b.deregisterLogger(y.resource)}))}}e.$bs=c}),define(re[231],oe([0,1,2,5]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=void 0;class S extends n.$Vc{constructor(j,E=[]){super(),this.a=new C.$ak([j,...E]),this.B(j.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...E){this.a.trace(j,...E)}debug(j,...E){this.a.debug(j,...E)}info(j,...E){this.a.info(j,...E)}warn(j,...E){this.a.warn(j,...E)}error(j,...E){this.a.error(j,...E)}flush(){this.a.flush()}}e.$OQ=S}),define(re[232],oe([0,1,32,7,5]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class R{constructor(E){this.b=E,this.a=new n.$Bc}listen(E,h,c){switch(h){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(E,h,c){switch(h){case"createLogger":this.c(C.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(C.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,S.$5j)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(C.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(C.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:C.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(C.URI.revive(c[0]))}throw new Error(`Call not found: ${h}`)}c(E,h,c){this.a.set(E,this.b.createLogger(E,h,c))}d(E,h){let c=console.log;switch(E){case S.LogLevel.Error:c=console.error;break;case S.LogLevel.Warning:c=console.warn;break;case S.LogLevel.Info:c=console.info;break}c.call(console,...h)}e(E,h){const c=this.a.get(E);if(!c)throw new Error("Create the logger before logging");for(const[d,b]of h)(0,S.log)(c,d,b)}}e.$qdc=R}),define(re[233],oe([0,1,16,5]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=void 0;var S;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(S||(S={}));async function R(c,d,b,v,m){try{const f=await new Promise((p,g)=>{J(["@vscode/spdlog"],p,g)});f.setFlushOn(S.Trace);const y=await f.createAsyncRotatingLogger(c,d,b,v);return m?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(f){console.error(f)}return null}function j(c,d,b){switch(d){case C.LogLevel.Trace:c.trace(b);break;case C.LogLevel.Debug:c.debug(b);break;case C.LogLevel.Info:c.info(b);break;case C.LogLevel.Warning:c.warn(b);break;case C.LogLevel.Error:c.error(b);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function E(c,d){switch(d){case C.LogLevel.Trace:c.setLevel(S.Trace);break;case C.LogLevel.Debug:c.setLevel(S.Debug);break;case C.LogLevel.Info:c.setLevel(S.Info);break;case C.LogLevel.Warning:c.setLevel(S.Warning);break;case C.LogLevel.Error:c.setLevel(S.Error);break;case C.LogLevel.Off:c.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${d}`)}}class h extends C.$9j{constructor(d,b,v,m,f){super(),this.m=[],this.setLevel(f),this.n=this.s(d,b,v,m),this.B(this.onDidChangeLogLevel(y=>{this.r&&E(this.r,y)}))}async s(d,b,v,m){const f=v?6:1,y=30/f*n.$yl.MB,p=await R(d,b,y,f,m);if(p){this.r=p,E(this.r,this.getLevel());for(const{level:g,message:l}of this.m)j(this.r,g,l);this.m=[]}}g(d,b){this.r?j(this.r,d,b):this.getLevel()<=d&&this.m.push({level:d,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$DQ=h}),define(re[234],oe([0,1,33,5,233]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=void 0;class R extends C.$bk{s(E,h,c){return new S.$DQ((0,n.$Sg)(),E.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$EQ=R}),define(re[67],oe([0,1,32,3,6,5,234]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=e.$3bc=void 0,e.$3bc=(0,S.$xi)(R.$4j);class E extends j.$EQ{constructor(){super(...arguments),this.u=new n.$Bc}createLogger(c,d,b){b!==void 0&&this.u.set(this.n(c),b);try{return super.createLogger(c,d)}catch(v){throw this.u.delete(this.n(c)),v}}registerLogger(c,d){d!==void 0&&this.u.set(c.resource,d),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const d=[];for(const b of super.getRegisteredLoggers())c===this.u.get(b.resource)&&d.push(b);return d}getOnDidChangeLogLevelEvent(c){return C.Event.filter(this.onDidChangeLogLevel,d=>(0,R.$5j)(d)||this.w(d[0],c))}getOnDidChangeVisibilityEvent(c){return C.Event.filter(this.onDidChangeVisibility,([d])=>this.w(d,c))}getOnDidChangeLoggersEvent(c){return C.Event.filter(C.Event.map(this.onDidChangeLoggers,d=>({added:[...d.added].filter(v=>this.w(v.resource,c)),removed:[...d.removed].filter(v=>this.w(v.resource,c))})),d=>d.added.length>0||d.removed.length>0)}deregisterLoggers(c){for(const[d,b]of this.u)b===c&&this.deregisterLogger(d)}w(c,d){const b=this.u.get(c);return b===void 0||b===d}dispose(){super.dispose(),this.u.clear()}}e.$4bc=E}),define(re[235],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=n,e.$Jcc=C,e.$Kcc=S,e.$Lcc=R;function n(j){return j.submenu!==void 0}function C(j){return j.id==="vscode.menubar.separator"}function S(j){return j.uri!==void 0}function R(j){return!n(j)&&!C(j)&&!S(j)}}),define(re[39],oe([0,1,3,71,2,6]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=void 0,e.$eo=(0,R.$wi)("policy");class j extends S.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$ee),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const d=Object.keys(this.f).length;return this.f={...c,...this.f},d!==Object.keys(this.f).length&&await this.j(c),C.Iterable.reduce(this.g.entries(),(b,[v,m])=>({...b,[v]:m}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(c,[d,b])=>({...c,[d]:{definition:b,value:this.g.get(d)}}),{})}}e.$fo=j;class E{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$go=E}),define(re[236],oe([0,1,8,3,71,12,16,5,39]),function(J,e,n,C,S,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;function c(b,v){const m=[];for(const f of new Set(S.Iterable.concat(b.keys(),v.keys())))b.get(f)!==v.get(f)&&m.push(f);return m}let d=class extends h.$fo{constructor(v,m,f){super(),this.m=v,this.n=m,this.s=f,this.c=this.B(new n.$uh(500));const y=C.Event.filter(m.onDidFilesChange,p=>p.affects(v));this.B(m.watch(v)),this.B(y(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const v=new Map;try{const m=await this.n.readFile(this.m),f=JSON.parse(m.value.toString());if(!(0,R.$$f)(f))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(f))this.f[y]&&v.set(y,f[y])}catch(m){m.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",m)}return v}async w(){const v=await this.u(),m=c(this.g,v);this.g=v,m.length>0&&this.h.fire(m)}};e.$Jdc=d,e.$Jdc=d=Se([ie(1,j.$3k),ie(2,E.$3j)],d)}),define(re[237],oe([0,1,3,2,39]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=e.$hdc=void 0;class R{constructor(h){this.b=h,this.a=new C.$Uc}listen(h,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,d=>d.reduce((b,v)=>({...b,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(h,c,d){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(d)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$hdc=R;class j extends S.$fo{constructor(h,c){super(),this.a=c;for(const d in h){const{definition:b,value:v}=h[d];this.f[d]=b,v!==void 0&&this.g.set(d,v)}this.a.listen("onDidChange")(d=>{for(const b in d){const v=d[b];v===null?this.g.delete(b):this.g.set(b,v)}this.h.fire(Object.keys(d))})}async j(h){const c=await this.a.call("updatePolicyDefinitions",h);for(const d in c)this.g.set(d,c[d])}}e.$idc=j}),define(re[238],oe([0,1,39,8,2,5]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;let j=class extends n.$fo{constructor(h,c){super(),this.m=h,this.n=c,this.a=new C.$qh,this.b=this.B(new S.$Wc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:c}=await new Promise((d,b)=>{J(["@vscode/policy-watcher"],d,b)});await this.a.queue(()=>new Promise((d,b)=>{try{this.b.value=c(this.n,h,v=>{this.t(v),d()})}catch(v){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),b(v)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const c in h){const d=h[c];d===void 0?this.g.delete(c):this.g.set(c,d)}this.h.fire(Object.keys(h))}};e.$Idc=j,e.$Idc=j=Se([ie(0,R.$3j)],j)}),define(re[80],oe([0,1,36]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const R=S.context.configuration();if(R)C=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:R.version})}}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(re[27],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,n.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"}),define(re[239],oe([0,1,8,5]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;let S=class{constructor(j,E,h){this.a=j,this.b=E,this.c=h}async inspect(j){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$xh)(j);const h=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const j=this.a.webContents.debugger;j.attach(),await j.sendCommand("Profiler.enable")}async e(){const j=this.a.webContents.debugger;await j.sendCommand("Profiler.disable"),j.detach()}};e.$ycc=S,e.$ycc=S=Se([ie(2,C.$3j)],S)}),define(re[81],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=void 0,e.$Lbc=(0,n.$wi)("protocolMainService")}),define(re[45],oe([0,1,139,12]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class S{constructor(){this.a=new Map}add(j,E){n.ok(C.$9f(j)),n.ok(C.$$f(E)),n.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,E)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$co=new S}),define(re[240],oe([0,1,3,45]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function S(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class R{constructor(){this.b=new n.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[S(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const j=new R;C.$co.add(e.$do.JSONContribution,j)}),define(re[52],oe([0,1,22,3,12,165,18,240,45]),function(J,e,n,C,S,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=y,e.$to=p,e.$uo=g,e.$vo=w,e.$wo=k;var c;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$ho={Configuration:"base.contributions.configuration"};var d;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d||(e.ConfigurationScope=d={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const b=h.$co.as(E.$do.JSONContribution);class v{constructor(){this.h=new Set,this.i=new C.$ee,this.onDidSchemaChange=this.i.event,this.j=new C.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const s=new Set;this.n(t,r,s),b.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const r=new Set;this.o(t,r),b.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const s=new Set;this.o(r,s),this.n(t,!1,s),b.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const s=[];for(const{overrides:i,source:o}of t)for(const u in i)if(r.add(u),e.$ro.test(u)){const $=this.a.get(u),P=$?.valuesSources??new Map;if(o)for(const M of Object.keys(i[u]))P.set(M,o);const D={...$?.value||{},...i[u]};this.a.set(u,{source:o,value:D,valuesSources:P});const I=(0,j.$aj)(u),O={type:"object",default:D,description:R.localize(1,null,I),$ref:e.$oo,defaultDefaultValue:D,source:S.$9f(o)?void 0:o,defaultValueSource:o};s.push(...y(u)),this.d[u]=O,this.b.properties[u]=O}else{this.a.set(u,{value:i[u],source:o});const $=this.d[u];$&&(this.w(u,$),this.r(u,$))}this.m(s)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:s,source:i}of t)for(const o in s){const u=this.a.get(o),$=S.$9f(i)?i:i?.id,P=S.$9f(u?.source)?u?.source:u?.source?.id;if($===P)if(r.add(o),this.a.delete(o),e.$ro.test(o))delete this.d[o],delete this.b.properties[o];else{const D=this.d[o];D&&(this.w(o,D),this.r(o,D))}}this.u()}deltaConfiguration(t){let r=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,s){t.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,s),this.c.push(i),this.q(i)})}o(t,r){const s=i=>{if(i.properties)for(const o in i.properties){r.add(o);const u=this.d[o];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[o],this.s(o,i.properties[o])}i.allOf?.forEach(o=>s(o))};for(const i of t){s(i);const o=this.c.indexOf(i);o!==-1&&this.c.splice(o,1)}}p(t,r=!0,s,i,o=3,u){o=S.$fg(t.scope)?o:t.scope;const $=t.properties;if($)for(const D in $){const I=$[D];if(r&&w(D,I)){delete $[D];continue}if(I.source=s,I.defaultDefaultValue=$[D].default,this.w(D,I),e.$ro.test(D)?I.scope=void 0:(I.scope=S.$fg(I.scope)?o:I.scope,I.restricted=S.$fg(I.restricted)?!!i?.includes(D):I.restricted),$[D].hasOwnProperty("included")&&!$[D].included){this.f[D]=$[D],delete $[D];continue}else this.d[D]=$[D],$[D].policy?.name&&this.e.set($[D].policy.name,D);!$[D].deprecationMessage&&$[D].markdownDeprecationMessage&&($[D].deprecationMessage=$[D].markdownDeprecationMessage),u.add(D)}const P=t.allOf;if(P)for(const D of P)this.p(D,r,s,i,o,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=s=>{const i=s.properties;if(i)for(const u in i)this.r(u,i[u]);s.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$io.properties[t]=r,r.scope){case 1:e.$jo.properties[t]=r;break;case 2:e.$ko.properties[t]=r;break;case 6:e.$lo.properties[t]=r;break;case 3:e.$mo.properties[t]=r;break;case 4:e.$no.properties[t]=r;break;case 5:e.$no.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$io.properties[t],r.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$oo};this.w(r,s),e.$io.properties[r]=s,e.$jo.properties[r]=s,e.$ko.properties[r]=s,e.$lo.properties[r]=s,e.$mo.properties[r]=s,e.$no.properties[r]=s}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,r){const s=this.a.get(t);let i=s?.value,o=s?.source;S.$dg(i)&&(i=r.defaultDefaultValue,o=void 0),S.$dg(i)&&(i=g(r.type)),r.default=i,r.defaultValueSource=o}}const m="\\[([^\\]]+)\\]",f=new RegExp(m,"g");e.$qo=`^(${m})+$`,e.$ro=new RegExp(e.$qo);function y(a){const t=[];if(e.$ro.test(a)){let r=f.exec(a);for(;r?.length;){const s=r[1].trim();s&&t.push(s),r=f.exec(a)}}return(0,n.$Mb)(t)}function p(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}function g(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const l=new v;h.$co.add(e.$ho.Configuration,l);function w(a,t){return a.trim()?e.$ro.test(a)?R.localize(7,null,a):l.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function k(){const a=[],t=l.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(re[123],oe([0,1,22,3,42,2,32,35,12,7,18,52,45]),function(J,e,n,C,S,R,j,E,h,c,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=w;function m(r){return Object.isFrozen(r)?r:E.$4n(r)}class f{static createEmptyModel(s){return new f({},[],[],void 0,s)}constructor(s,i,o,u,$){this.b=s,this.c=i,this.d=o,this.raw=u,this.f=$,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof f)return i;const o=new y("",this.f);return o.parseRaw(i),o.configurationModel});this.g=s.reduce((i,o)=>o===i?o:i.merge(o),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,d.$$i)(this.contents,s):this.contents}inspect(s,i){const o=this;return{get value(){return m(o.rawConfiguration.getValue(s))},get override(){return i?m(o.rawConfiguration.getOverrideValue(s,i)):void 0},get merged(){return m(i?o.rawConfiguration.override(i).getValue(s):o.rawConfiguration.getValue(s))},get overrides(){const u=[];for(const{contents:$,identifiers:P,keys:D}of o.rawConfiguration.overrides){const I=new f($,D,[],void 0,o.f).getValue(s);I!==void 0&&u.push({identifiers:P,value:I})}return u.length?m(u):void 0}}}getOverrideValue(s,i){const o=this.j(i);return o?s?(0,d.$$i)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const o of this.overrides)o.identifiers.includes(s)&&i.push(...o.keys);return n.$Mb(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return n.$Mb(s)}override(s){let i=this.a.get(s);return i||(i=this.h(s),this.a.set(s,i)),i}merge(...s){const i=E.$3n(this.contents),o=E.$3n(this.overrides),u=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const P of s)if($.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.i(i,P.contents);for(const D of P.overrides){const[I]=o.filter(O=>n.$ub(O.identifiers,D.identifiers));I?(this.i(I.contents,D.contents),I.keys.push(...D.keys),I.keys=n.$Mb(I.keys)):o.push(E.$3n(D))}for(const D of P.keys)u.indexOf(D)===-1&&u.push(D)}return new f(i,u,o,$.every(P=>P instanceof f)?void 0:$,this.f)}h(s){const i=this.j(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const u of n.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let $=this.contents[u];const P=i[u];P&&(typeof $=="object"&&typeof P=="object"?($=E.$3n($),this.i($,P)):$=P),o[u]=$}return new f(o,this.keys,this.overrides,void 0,this.f)}i(s,i){for(const o of Object.keys(i)){if(o in s&&h.$$f(s[o])&&h.$$f(i[o])){this.i(s[o],i[o]);continue}s[o]=E.$3n(i[o])}}j(s){let i=null,o=null;const u=$=>{$&&(o?this.i(o,$):o=E.$3n($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===s?i=$.contents:$.identifiers.includes(s)&&u($.contents);return u(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.k(s,i,!0)}setValue(s,i){this.k(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,d.$0i)(this.contents,s),b.$ro.test(s)&&this.overrides.splice(this.overrides.findIndex(o=>n.$ub(o.identifiers,(0,b.$so)(s))),1))}k(s,i,o){(0,d.$9i)(this.contents,s,i,u=>this.f.error(u)),o=o||this.keys.indexOf(s)===-1,o&&this.keys.push(s),b.$ro.test(s)&&this.overrides.push({identifiers:(0,b.$so)(s),keys:Object.keys(this.contents[s]),contents:(0,d.$8i)(this.contents[s],u=>this.f.error(u))})}}e.$xo=f;class y{constructor(s,i){this.f=s,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,i){if(!h.$fg(s)){const o=this.h(s);this.parseRaw(o,i)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,i){this.a=s;const{contents:o,keys:u,overrides:$,restricted:P,hasExcludedProperties:D}=this.i(s,i);this.b=new f(o,u,$,D?[s]:void 0,this.g),this.c=P||[]}h(s){let i={},o=null,u=[];const $=[],P=[];function D(O){Array.isArray(u)?u.push(O):o!==null&&(u[o]=O)}const I={onObjectBegin:()=>{const O={};D(O),$.push(u),u=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{u=$.pop()},onArrayBegin:()=>{const O=[];D(O),$.push(u),u=O,o=null},onArrayEnd:()=>{u=$.pop()},onLiteralValue:D,onError:(O,M,W)=>{P.push({error:O,offset:M,length:W})}};if(s)try{S.$Qn(s,I),i=u[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}i(s,i){const o=v.$co.as(b.$ho.Configuration).getConfigurationProperties(),u=this.j(s,o,!0,i);s=u.raw;const $=(0,d.$8i)(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`)),P=Object.keys(s),D=this.l(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`));return{contents:$,keys:P,overrides:D,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}j(s,i,o,u){let $=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:$};const P={},D=[];for(const I in s)if(b.$ro.test(I)&&o){const O=this.j(s[I],i,!1,u);P[I]=O.raw,$=$||O.hasExcludedProperties,D.push(...O.restricted)}else{const O=i[I],M=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&D.push(I),!u.exclude?.includes(I)&&(u.include?.includes(I)||(M===void 0||u.scopes===void 0||u.scopes.includes(M))&&!(u.skipRestricted&&O?.restricted))?P[I]=s[I]:$=!0}return{raw:P,restricted:D,hasExcludedProperties:$}}l(s,i){const o=[];for(const u of Object.keys(s))if(b.$ro.test(u)){const $={};for(const P in s[u])$[P]=s[u][P];o.push({identifiers:(0,b.$so)(u),keys:Object.keys($),contents:(0,d.$8i)($,i)})}return o}}e.$yo=y;class p extends R.$Vc{constructor(s,i,o,u,$){super(),this.c=s,this.f=i,this.g=u,this.h=$,this.b=this.B(new C.$ee),this.onDidChange=this.b.event,this.a=new y(this.c.toString(),$),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,P=>P.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,P=>(P.isOperation(0)||P.isOperation(3)||P.isOperation(1)||P.isOperation(4))&&o.isEqual(P.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=p;class g{constructor(s,i,o,u,$,P,D,I,O,M,W,F,T){this.a=s,this.b=i,this.c=o,this.overrideIdentifiers=u,this.d=$,this.f=P,this.g=D,this.h=I,this.i=O,this.j=M,this.k=W,this.l=F,this.m=T}get value(){return m(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class l{constructor(s,i,o,u,$,P,D,I,O,M){this.j=s,this.l=i,this.m=o,this.n=u,this.p=$,this.q=P,this.r=D,this.s=I,this.t=O,this.u=M,this.h=null,this.i=new j.$Bc,this.v=null}getValue(s,i,o){return this.w(s,i,o).getValue(s)}updateValue(s,i,o={}){let u;o.resource?(u=this.t.get(o.resource),u||(u=f.createEmptyModel(this.u),this.t.set(o.resource,u))):u=this.s,i===void 0?u.removeValue(s):u.setValue(s,i),o.resource||(this.h=null)}inspect(s,i,o){const u=this.w(s,i,o),$=this.A(i.resource,o),P=i.resource?this.t.get(i.resource)||this.s:this.s,D=new Set;for(const I of u.overrides)for(const O of I.identifiers)u.getOverrideValue(s,O)!==void 0&&D.add(O);return new g(s,i,u.getValue(s),D.size?[...D]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,$||void 0,P)}keys(s){const i=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,i){this.r.set(s,i),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const o=[];if(!i){const{added:u,updated:$,removed:P}=a(this.j,s);i=[...u,...$,...P]}for(const u of i)for(const $ of(0,b.$so)(u)){const P=this.j.getKeysForOverrideIdentifier($),D=s.getKeysForOverrideIdentifier($),I=[...D.filter(O=>P.indexOf(O)===-1),...P.filter(O=>D.indexOf(O)===-1),...P.filter(O=>!E.$7n(this.j.override($).getValue(O),s.override($).getValue(O)))];o.push([$,I])}return this.updateDefaultConfiguration(s),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:o,removed:u}=a(this.l,s),$=[...i,...o,...u];return $.length&&this.updatePolicyConfiguration(s),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:o,removed:u,overrides:$}=a(this.applicationConfiguration,s),P=[...i,...o,...u];return P.length&&this.updateApplicationConfiguration(s),{keys:P,overrides:$}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:o,removed:u,overrides:$}=a(this.localUserConfiguration,s),P=[...i,...o,...u];return P.length&&this.updateLocalUserConfiguration(s),{keys:P,overrides:$}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:o,removed:u,overrides:$}=a(this.remoteUserConfiguration,s),P=[...i,...o,...u];return P.length&&this.updateRemoteUserConfiguration(s),{keys:P,overrides:$}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:o,removed:u,overrides:$}=a(this.workspaceConfiguration,s),P=[...i,...o,...u];return P.length&&this.updateWorkspaceConfiguration(s),{keys:P,overrides:$}}compareAndUpdateFolderConfiguration(s,i){const o=this.folderConfigurations.get(s),{added:u,updated:$,removed:P,overrides:D}=a(o,i),I=[...u,...$,...P];return(I.length||!o)&&this.updateFolderConfiguration(s,i),{keys:I,overrides:D}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:u,removed:$,overrides:P}=a(i,void 0);return{keys:[...o,...u,...$],overrides:P}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,i,o){let u=this.x(i,o);return i.overrideIdentifier&&(u=u.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(u=u.merge(this.l)),u}x({resource:s},i){let o=this.y();if(i&&s){const u=i.getFolder(s);u&&(o=this.z(u.uri)||o);const $=this.t.get(s);$&&(o=o.merge($))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let i=this.i.get(s);if(!i){const o=this.y(),u=this.r.get(s);u?(i=o.merge(u),this.i.set(s,i)):i=o}return i}A(s,i){if(i&&s){const o=i.getFolder(s);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,i)=>{const{contents:o,overrides:u,keys:$}=this.r.get(i);return s.push([i,{contents:o,overrides:u,keys:$}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this.q.keys.forEach(i=>s.add(i)),this.r.forEach(i=>i.keys.forEach(o=>s.add(o))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}D(s){const i=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.q.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(u=>i.add(u))),[...i.values()]}static parse(s,i){const o=this.E(s.defaults,i),u=this.E(s.policy,i),$=this.E(s.application,i),P=this.E(s.user,i),D=this.E(s.workspace,i),I=s.folders.reduce((O,M)=>(O.set(c.URI.revive(M[0]),this.E(M[1],i)),O),new j.$Bc);return new l(o,u,$,P,f.createEmptyModel(i),D,I,f.createEmptyModel(i),new j.$Bc,i)}static E(s,i){return new f(s.contents,s.keys,s.overrides,void 0,i)}}e.$Ao=l;function w(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,i=new Map;for(const u of r)u.keys.forEach($=>s.add($)),u.overrides.forEach(([$,P])=>{const D=(0,j.$yc)(i,$,new Set);P.forEach(I=>D.add(I))});const o=[];return i.forEach((u,$)=>o.push([$,[...u.values()]])),{keys:[...s.values()],overrides:o}}class k{constructor(s,i,o,u,$){this.change=s,this.f=i,this.g=o,this.h=u,this.i=$,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const P of s.keys)this.affectedKeys.add(P);for(const[,P]of s.overrides)for(const D of P)this.affectedKeys.add(D);this.d=this.a;for(const P of this.affectedKeys)this.d+=P+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=l.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,i){const o=this.a+s,u=this.d.indexOf(o);if(u<0)return!1;const $=u+o.length;if($>=this.d.length)return!1;const P=this.d.charCodeAt($);if(P!==this.b&&P!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.f?.workspace):void 0,I=this.g.getValue(s,i,this.h);return!E.$7n(D,I)}return!0}}e.$Co=k;function a(r,s){const{added:i,removed:o,updated:u}=t(s?.rawConfiguration,r?.rawConfiguration),$=[],P=r?.getAllOverrideIdentifiers()||[],D=s?.getAllOverrideIdentifiers()||[];if(s){const I=D.filter(O=>!P.includes(O));for(const O of I)$.push([O,s.getKeysForOverrideIdentifier(O)])}if(r){const I=P.filter(O=>!D.includes(O));for(const O of I)$.push([O,r.getKeysForOverrideIdentifier(O)])}if(s&&r){for(const I of P)if(D.includes(I)){const O=t({contents:r.getOverrideValue(void 0,I)||{},keys:r.getKeysForOverrideIdentifier(I)},{contents:s.getOverrideValue(void 0,I)||{},keys:s.getKeysForOverrideIdentifier(I)});$.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:o,updated:u,overrides:$}}function t(r,s){const i=r?s?r.keys.filter($=>s.keys.indexOf($)===-1):[...r.keys]:[],o=s?r?s.keys.filter($=>r.keys.indexOf($)===-1):[...s.keys]:[],u=[];if(r&&s){for(const $ of s.keys)if(r.keys.indexOf($)!==-1){const P=(0,d.$$i)(s.contents,$),D=(0,d.$$i)(r.contents,$);E.$7n(P,D)||u.push($)}}return{added:i,removed:o,updated:u}}}),define(re[241],oe([0,1,22,3,2,35,12,123,52,5,39,45]),function(J,e,n,C,S,R,j,E,h,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=void 0;class v extends S.$Vc{get configurationModel(){return this.b}constructor(p){super(),this.c=p,this.a=this.B(new C.$ee),this.onDidChangeConfiguration=this.a.event,this.b=E.$xo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(b.$co.as(h.$ho.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:g})=>this.f(Array.from(p),g))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(p,g){this.j(p,b.$co.as(h.$ho.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}g(){return{}}h(){this.b=E.$xo.createEmptyModel(this.c);const p=b.$co.as(h.$ho.Configuration).getConfigurationProperties();this.j(Object.keys(p),p)}j(p,g){const l=this.g();for(const w of p){const k=l[w],a=g[w];k!==void 0?this.b.addValue(w,k):a?this.b.addValue(w,a.default):this.b.removeValue(w)}}}e.$Do=v;class m{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=E.$xo.createEmptyModel(new c.$dk)}async initialize(){return this.configurationModel}}e.$Eo=m;let f=class extends S.$Vc{get configurationModel(){return this.b}constructor(p,g,l){super(),this.c=p,this.f=g,this.g=l,this.a=this.B(new C.$ee),this.onDidChangeConfiguration=this.a.event,this.b=E.$xo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const g={},l=[],w=b.$co.as(h.$ho.Configuration).getConfigurationProperties();for(const k of p){const a=w[k];if(!a){l.push(k);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}l.push(k),g[a.policy.name]={type:a.type}}}return(0,j.$jg)(g)||await this.f.updatePolicyDefinitions(g),l}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const g=b.$co.as(h.$ho.Configuration).getPolicyConfigurations(),l=(0,n.$Hb)(p.map(w=>g.get(w)));this.m(l,!0)}m(p,g){this.g.trace("PolicyConfiguration#update",p);const l=b.$co.as(h.$ho.Configuration).getConfigurationProperties(),w=[],k=this.b.isEmpty();for(const a of p){const t=l[a]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(k?r!==void 0:!(0,R.$7n)(this.b.getValue(a),r))&&w.push([a,r])}else this.b.getValue(a)!==void 0&&w.push([a,void 0])}if(w.length){this.g.trace("PolicyConfiguration#changed",w);const a=this.b;this.b=E.$xo.createEmptyModel(this.g);for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,r]of w)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);g&&this.a.fire(this.b)}}};e.$Fo=f,e.$Fo=f=Se([ie(1,d.$eo),ie(2,c.$3j)],f)}),define(re[242],oe([0,1,22,8,17,3,42,103,2,32,35,4,19,18,123,52,241,39]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=void 0;class l extends h.$Vc{constructor(a,t,r,s){super(),this.m=a,this.n=s,this.h=this.B(new R.$ee),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$Do(s)),this.c=r instanceof g.$go?new p.$Eo:this.B(new p.$Fo(this.b,r,s)),this.f=this.B(new f.$zo(this.m,{},v.$1g,t,s)),this.a=new f.$Ao(this.b.configurationModel,this.c.configurationModel,f.$xo.createEmptyModel(s),f.$xo.createEmptyModel(s),f.$xo.createEmptyModel(s),f.$xo.createEmptyModel(s),new c.$Bc,f.$xo.createEmptyModel(s),new c.$Bc,s),this.j=new w(a,t,this),this.g=this.B(new C.$Ih(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:o})=>this.s(i,o))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$Ao(a,t,f.$xo.createEmptyModel(this.n),r,f.$xo.createEmptyModel(this.n),f.$xo.createEmptyModel(this.n),new c.$Bc,f.$xo.createEmptyModel(this.n),new c.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,t){const r=typeof a=="string"?a:void 0,s=(0,m.$4i)(a)?a:(0,m.$4i)(t)?t:{};return this.a.getValue(r,s,void 0)}async updateValue(a,t,r,s,i){const o=(0,m.$5i)(r)?r:(0,m.$4i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,u=o?s:r;if(u!==void 0&&u!==3&&u!==2)throw new Error(`Unable to write ${a} to target ${u}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,n.$Mb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const $=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if($.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,d.$7n)(t,$.defaultValue)&&(t=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const D=o.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(O=>(0,n.$ub)([...O.identifiers].sort(),D));I&&(o.overrideIdentifiers=I.identifiers)}const P=o?.overrideIdentifiers?.length?[(0,y.$to)(o.overrideIdentifiers),a]:[a];await this.j.write(P,t),await this.reloadConfiguration()}inspect(a,t={}){return this.a.inspect(a,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,t,2)}s(a,t){const r=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(a,t);this.u(s,r,7)}t(a){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,t,7)}u(a,t,r){const s=new f.$Co(a,{data:t},this.a,void 0,this.n);s.source=r,this.h.fire(s)}}e.$Go=l;class w{constructor(a,t,r){this.b=a,this.c=t,this.d=r,this.a=new C.$Dh}write(a,t){return this.a.queue(()=>this.e(a,t))}async e(a,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===1)r="{}";else throw o}const s=[];if((0,j.$Jn)(r,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(r,a,t);r=(0,E.$2n)(r,i),await this.c.writeFile(this.b,S.$Ge.fromString(r))}f(a,t,r){const{tabSize:s,insertSpaces:i,eol:o}=this.h;if(!t.length){const u=JSON.stringify(r,null,i?" ".repeat(s):"	");return[{content:u,length:u.length,offset:0}]}return(0,E.$Yn)(a,t,r,{tabSize:s,insertSpaces:i,eol:o})}get h(){if(!this.g){let a=b.OS===3||b.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(re[243],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=e.$wdc=e.$vdc=void 0,e.$vdc="request",e.$wdc="remoteResourceHandler";class n{async routeCall(S,R,j){if(R!==e.$vdc)throw new Error(`Call not found: ${R}`);const E=j[0];if(E?.authority){const h=S.connections.find(c=>c.ctx===E.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(S,R){throw new Error(`Event not found: ${R}`)}}e.$xdc=n}),define(re[244],oe([0,1,15,6]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=c,e.$Hl=(0,C.$wi)("remoteAuthorityResolverService");var S;(function(d){d[d.WebSocket=0]="WebSocket",d[d.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class R{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=R;class j{constructor(b,v){this.host=b,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=j;var E;(function(d){d.Unknown="Unknown",d.NotAvailable="NotAvailable",d.TemporarilyNotAvailable="TemporarilyNotAvailable",d.NoResolverFound="NoResolverFound",d.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class h extends n.$bb{static isNotAvailable(b){return b instanceof h&&b._code===E.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof h&&b._code===E.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof h&&b._code===E.NoResolverFound}static isInvalidAuthority(b){return b instanceof h&&b._code===E.InvalidAuthority}static isHandled(b){return b instanceof h&&b.isHandled}constructor(b,v=E.Unknown,m){super(b),this._message=b,this._code=v,this._detail=m,this.isHandled=v===E.NotAvailable&&m===!0,Object.setPrototypeOf(this,h.prototype)}}e.$Kl=h;function c(d){const b=d.indexOf("+");return b===-1?d:d.substring(0,b)}}),define(re[245],oe([0,1,8,17,23,15,3,2,13,66,73,33,113,244]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ql=P,e.$Rl=D,e.$Sl=O;const f=30*1e3;var y;(function(Z){Z[Z.Management=1]="Management",Z[Z.ExtensionHost=2]="ExtensionHost",Z[Z.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function p(Z){switch(Z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(Z){const A=new S.$pe;return setTimeout(()=>A.cancel(),Z),A.token}function l(Z,A){if(Z.isCancellationRequested||A.isCancellationRequested)return S.CancellationToken.Cancelled;const N=new S.$pe;return Z.onCancellationRequested(()=>N.cancel()),A.onCancellationRequested(()=>N.cancel()),N.token}class w{get didTimeout(){return this.c==="timedout"}constructor(A){this.c="pending",this.d=new E.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$ph)(),A.isCancellationRequested?this.h():this.d.add(A.onCancellationRequested(()=>this.h()))}registerDisposable(A){this.c==="pending"?this.d.add(A):A.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(A))}reject(A){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(A))}}function k(Z,A){const N=new w(A);return N.registerDisposable(Z.onControlMessage(_=>{const ne=JSON.parse(_.toString()),X=L(ne);X?N.reject(X):N.resolve(ne)})),N.promise}function a(Z,A,N,_,ne,X,H,V){const U=new w(V),se=d.$ae.create(!1);return Z.info(`Creating a socket (${H})...`),c.mark(`code/willCreateSocket/${X}`),A.connect(N,_,ne,H).then(he=>{U.didTimeout?(c.mark(`code/didCreateSocketError/${X}`),Z.info(`Creating a socket (${H}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(c.mark(`code/didCreateSocketOK/${X}`),Z.info(`Creating a socket (${H}) was successful after ${se.elapsed()} ms.`),U.resolve(he))},he=>{c.mark(`code/didCreateSocketError/${X}`),Z.info(`Creating a socket (${H}) returned an error after ${se.elapsed()} ms.`),Z.error(he),U.reject(he)}),U.promise}function t(Z,A){const N=new w(A);return Z.then(_=>{N.didTimeout||N.resolve(_)},_=>{N.didTimeout||N.reject(_)}),N.promise}async function r(Z,A,N,_){const ne=x(Z,A);Z.logService.trace(`${ne} 1/6. invoking socketFactory.connect().`);let X;try{X=await a(Z.logService,Z.remoteSocketFactoryService,Z.connectTo,h.$Jg.getServerRootPath(),`reconnectionToken=${Z.reconnectionToken}&reconnection=${Z.reconnectionProtocol?"true":"false"}`,p(A),`renderer-${p(A)}-${Z.reconnectionToken}`,_)}catch(he){throw Z.logService.error(`${ne} socketFactory.connect() failed or timed out. Error:`),Z.logService.error(he),he}Z.logService.trace(`${ne} 2/6. socketFactory.connect() was successful.`);let H,V;Z.reconnectionProtocol?(Z.reconnectionProtocol.beginAcceptReconnection(X,null),H=Z.reconnectionProtocol,V=!1):(H=new v.$ki({socket:X}),V=!0),Z.logService.trace(`${ne} 3/6. sending AuthRequest control message.`);const U=await t(Z.signService.createNewMessage((0,b.$Sg)()),_),se={type:"auth",auth:Z.connectionToken||"00000000000000000000",data:U.data};H.sendControl(C.$Ge.fromString(JSON.stringify(se)));try{const he=await k(H,l(_,g(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(Z.logService.trace(`${ne} 4/6. received SignRequest control message.`),!await t(Z.signService.validate(U,he.signedData),_)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const me=await t(Z.signService.sign(he.data),_),ye={type:"connectionType",commit:Z.commit,signedData:me,desiredConnectionType:A};return N&&(ye.args=N),Z.logService.trace(`${ne} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(C.$Ge.fromString(JSON.stringify(ye))),{protocol:H,ownsProtocol:V}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(Z.logService.error(`${ne} the handshake timed out. Error:`),Z.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(Z.logService.error(`${ne} received error control message when negotiating connection. Error:`),Z.logService.error(he)),V&&B(H),he}}async function s(Z,A,N,_){const ne=Date.now(),X=x(Z,A),{protocol:H,ownsProtocol:V}=await r(Z,A,N,_),U=new w(_);return U.registerDisposable(H.onControlMessage(se=>{const he=JSON.parse(se.toString()),$e=L(he);$e?(Z.logService.error(`${X} received error control message when negotiating connection. Error:`),Z.logService.error($e),V&&B(H),U.reject($e)):(Z.reconnectionProtocol?.endAcceptReconnection(),Z.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${le(ne)}!`),U.resolve({protocol:H,firstMessage:he}))})),U.promise}async function i(Z,A){const{protocol:N}=await s(Z,1,void 0,A);return{protocol:N}}async function o(Z,A,N){const{protocol:_,firstMessage:ne}=await s(Z,2,A,N),X=ne&&ne.debugPort;return{protocol:_,debugPort:X}}async function u(Z,A,N){const _=Date.now(),ne=x(Z,3),{protocol:X}=await r(Z,3,A,N);return Z.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${le(_)}!`),X}async function $(Z,A,N){const{connectTo:_,connectionToken:ne}=await Z.addressProvider.getAddress();return{commit:Z.commit,quality:Z.quality,connectTo:_,connectionToken:ne,reconnectionToken:A,reconnectionProtocol:N,remoteSocketFactoryService:Z.remoteSocketFactoryService,signService:Z.signService,logService:Z.logService}}async function P(Z,A,N){return I(Z,async _=>{const{protocol:ne}=await i(_,S.CancellationToken.None);return new K(Z,A,N,_.reconnectionToken,ne)})}async function D(Z,A){return I(Z,async N=>{const{protocol:_,debugPort:ne}=await o(N,A,S.CancellationToken.None);return new G(Z,A,N.reconnectionToken,_,ne)})}async function I(Z,A){for(let _=1;;_++)try{const ne=(0,b.$Sg)(),X=await $(Z,ne,null);return await A(X)}catch(ne){if(_<5)Z.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),Z.logService.error(ne);else throw Z.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Z.logService.error(ne),ce.triggerPermanentFailure(0,0,m.$Kl.isHandled(ne)),ne}}async function O(Z,A,N){const _=await $(Z,(0,b.$Sg)(),null);return await u(_,{host:A,port:N},S.CancellationToken.None)}function M(Z){return(0,n.$jh)(A=>new Promise((N,_)=>{const ne=setTimeout(N,Z*1e3);A.onCancellationRequested(()=>{clearTimeout(ne),N()})}))}var W;(function(Z){Z[Z.ConnectionLost=0]="ConnectionLost",Z[Z.ReconnectionWait=1]="ReconnectionWait",Z[Z.ReconnectionRunning=2]="ReconnectionRunning",Z[Z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Z[Z.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class F{constructor(A,N){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.type=0}}e.$Tl=F;class T{constructor(A,N,_,ne){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.durationSeconds=_,this.c=ne,this.type=1}skipWait(){this.c.cancel()}}e.$Ul=T;class q{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=2}}e.$Vl=q;class ue{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=4}}e.$Wl=ue;class ee{constructor(A,N,_,ne){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.handled=ne,this.type=3}}e.$Xl=ee;class ce extends E.$Vc{static triggerPermanentFailure(A,N,_){this._permanentFailure=!0,this.f=A,this.g=N,this.h=_,this.j.forEach(ne=>ne.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(A=>A.y())}static debugPauseSocketWriting(){this.j.forEach(A=>A.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(A,N,_,ne,X){super(),this.t=A,this.u=N,this.reconnectionToken=_,this.protocol=ne,this.w=X,this.m=this.B(new j.$ee),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ue(this.reconnectionToken,0,0)),this.B(ne.onSocketClose(H=>{const V=ae(this.t,this.reconnectionToken,!0);H?H.type===0?(this.u.logService.info(`${V} received socket close event (hadError: ${H.hadError}).`),H.error&&this.u.logService.error(H.error)):(this.u.logService.info(`${V} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this.u.logService.error(H.event)):this.u.logService.info(`${V} received socket close event.`),this.y()})),this.B(ne.onSocketTimeout(H=>{const V=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${V} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,E.$Tc)(()=>{const H=ce.j.indexOf(this);H>=0&&ce.j.splice(H,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const A=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const ne=_<N.length?N[_]:N[N.length-1];try{if(ne>0){const H=M(ne);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ne,H)),this.u.logService.info(`${A} waiting for ${ne} seconds before reconnecting...`);try{await H}catch{}}if(this.n){this.u.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${A} resolving connection...`);const X=await $(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${A} connecting to ${X.connectTo}...`),await this.G(X,g(f)),this.u.logService.info(`${A} reconnected!`),this.m.fire(new ue(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(m.$Kl.isTemporarilyNotAvailable(X)){this.u.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this.u.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((0,R.$4)(X)){this.u.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if(X instanceof m.$Kl){this.u.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,m.$Kl.isHandled(X));break}this.u.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(A,N,_){this.w?ce.triggerPermanentFailure(A,N,_):this.D(A,N,_)}D(A,N,_){this.m.fire(new ee(this.reconnectionToken,A,N,_)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Yl=ce;class K extends ce{constructor(A,N,_,ne,X){super(1,A,ne,X,!0),this.client=this.B(new v.$ii(X,{remoteAuthority:N,clientId:_},A.ipcLogger))}async G(A,N){await i(A,N)}}e.$Zl=K;class G extends ce{constructor(A,N,_,ne,X){super(2,A,_,ne,!1),this.H=N,this.debugPort=X}async G(A,N){await o(A,this.H,N)}}e.$1l=G;function B(Z){try{Z.acceptDisconnect();const A=Z.getSocket();Z.dispose(),A.dispose()}catch(A){(0,R.$1)(A)}}function L(Z){if(Z&&Z.type==="error"){const A=new Error(`Connection error: ${Z.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function z(Z,A){for(;Z.length<A;)Z+=" ";return Z}function Q(Z,A){return`[remote-connection][${z(p(Z),13)}][${A.substr(0,5)}\u2026]`}function ae(Z,A,N){return`${Q(Z,A)}[${N?"reconnect":"initial"}]`}function x(Z,A){return`${ae(A,Z.reconnectionToken,!!Z.reconnectionProtocol)}[${Z.connectTo}]`}function le(Z){return`${Date.now()-Z} ms`}}),define(re[68],oe([0,1,13]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=C,e.$Im=S,e.$Jm=R,e.$Km=j;function C(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}function S(h){if(!h)return;const c=h.indexOf("+");return c<0?h:h.substr(0,c)}function R(h){const{host:c,port:d}=E(h);if(typeof d>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:d}}function j(h,c){let{host:d,port:b}=E(h);return typeof b>"u"&&(b=c),{host:d,port:b}}function E(h){const c=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const d=h.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const b=h.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:h,port:void 0}}}),define(re[124],oe([0,1,25,6,68]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=R,e.$Um=b,e.$Vm=v,e.$Wm=m,e.$Xm=f,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function R(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var j;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(j||(e.ExtensionType=j={}));var E;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class h{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,g){if(typeof p>"u"||p===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof p=="string"||typeof g=="string"){const l=typeof p=="string"?p:p.value,w=typeof g=="string"?g:g.value;return n.$yf(l,w)}return p._lower===g._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$Rm=h;class c{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const g of p)this.add(g)}add(p){this.c.add(h.toKey(p))}delete(p){return this.c.delete(h.toKey(p))}has(p){return this.c.has(h.toKey(p))}}e.$Sm=c;class d{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(h.toKey(p))}get(p){return this.c.get(h.toKey(p))}has(p){return this.c.has(h.toKey(p))}set(p,g){this.c.set(h.toKey(p),g)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=d;function b(y){return v(y)}function v(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}function m(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}function f(y,p){if(p){const g=`onResolveRemoteAuthority:${(0,S.$Im)(p)}`;return!!y.activationEvents?.includes(g)}return!1}e.$Ym=(0,C.$wi)("IBuiltinExtensionsScannerService")}),define(re[246],oe([0,1,2,6]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=void 0,e.$Ml=(0,C.$wi)("remoteSocketFactoryService");class S{constructor(){this.a={}}register(j,E){return this.a[j]??=[],this.a[j].push(E),(0,n.$Tc)(()=>{const h=this.a[j]?.indexOf(E);typeof h=="number"&&h>=0&&this.a[j]?.splice(h,1)})}b(j){return(this.a[j.type]||[]).find(h=>h.supports(j))}connect(j,E,h,c){const d=this.b(j);if(!d)throw new Error(`No socket factory found for ${j}`);return d.connect(j,E,h,c)}}e.$Nl=S}),define(re[247],oe([0,1,26,49,21,117]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=E;let j;async function E(m=!1){return(j===void 0||m)&&(j=h()),j}async function h(){const m=c();if(m===void 0)return!1;if(m>=22e3){const f=b();if(f)return new Promise(y=>{C.execFile(f,["--status"],p=>y(!p))})}else{const f=v();if(f)try{if((await S.Promises.stat(f)).isFile())return!0}catch{}}return!1}function c(){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(m)return parseInt(m[3])}function d(m){const f=process.env.SystemRoot;if(f){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(f,y?"Sysnative":"System32",m)}}function b(){return d("wsl.exe")}function v(){return d("lxss\\LxssManager.dll")}}),define(re[53],oe([0,1,17,15,2,186,52,6,5,45]),function(J,e,n,C,S,R,j,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=v,e.$Qp=m,e.$Rp=f,e.$Sp=y,e.$Tp=p,e.$Up=g,e.$Np=(0,E.$wi)("requestService");class d{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class b extends S.$Vc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,R.localize)(0,null),when:h.$ik.isEqualTo((0,h.$fk)(h.LogLevel.Trace)).serialize()})}async c(a,t,r){const s=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new d(t.headers??{}));try{const i=await r();return this.a.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${s} - error`,t.type,(0,C.$0)(i)),i}}}e.$Op=b;function v(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}function m(k){return k.res.statusCode===204}async function f(k){return m(k)?null:(await(0,n.$Se)(k.stream)).toString()}async function y(k){if(!v(k))throw new Error("Server returned "+k.res.statusCode);return f(k)}async function p(k){if(!v(k))throw new Error("Server returned "+k.res.statusCode);if(m(k))return null;const t=(await(0,n.$Se)(k.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function g(k){w(k)}let l;function w(k){const a=c.$co.as(j.$ho.Configuration),t=l;l={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[l],remove:t?[t]:[]})}w(1)}),define(re[248],oe([0,1,17,23]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=void 0;class S{constructor(E){this.a=E}listen(E,h){throw new Error("Invalid listen")}call(E,h,c,d=C.CancellationToken.None){switch(h){case"request":return this.a.request(c[0],d).then(async({res:b,stream:v})=>{const m=await(0,n.$Se)(v);return[{statusCode:b.statusCode,headers:b.headers},m]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Ur=S;class R{constructor(E){this.a=E}async request(E,h){const[c,d]=await this.a.call("request",[E],h);return{res:c,stream:(0,n.$Ue)(d)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Vr=R}),define(re[249],oe([0,1,250,12]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=R;function S(j,E){return j.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:j.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function R(j,E,h={}){const c=(0,n.parse)(j),d=h.proxyUrl||S(c,E);if(!d)return null;const b=(0,n.parse)(d);if(!/^https?:$/.test(b.protocol||""))return null;const v={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,C.$cg)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((m,f)=>{J(["http-proxy-agent"],m,f)})).HttpProxyAgent(d,v):new(await new Promise((m,f)=>{J(["https-proxy-agent"],m,f)})).HttpsProxyAgent(d,v)}}),define(re[251],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=e.$Rcc=void 0,e.$Rcc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Scc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Tcc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(re[95],oe([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=y;let f;async function y(g,l,w,k){return w["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Am)(k)&&!w["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Am)(k)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=v.Promises.withAsyncBody(async(a,t)=>{const r=new R.$pe;let s=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,m.$Bm)(i,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),t(new Error((0,S.localize)(0,null)))},s);try{a(await p(l,r.token))}catch(u){!(0,E.$4)(u)&&!r.token.isCancellationRequested?t(new Error((0,S.localize)(1,null,(0,j.$hj)(u)))):a({})}finally{clearTimeout(o),r.dispose()}})),f)}async function p(g,l){const w=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",w);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",k);const a=(0,c.$Sg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",r);const s=await(0,d.$qm)(h.OS,r);return g.trace("getUnixShellEnvironment#shell",s),new Promise((i,o)=>{if(l.isCancellationRequested)return o(new E.$5);const u=(0,C.$oc)(s);let $,P;const D="";/^pwsh(-preview)?$/.test(u)?($=`& '${process.execPath}' ${D} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,P=["-Login","-Command"]):u==="nu"?($=`^'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,P=["-i","-l","-c"]):u==="xonsh"?($=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,P=["-i","-l","-c"]):($=`'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,u==="tcsh"||u==="csh"?P=["-ic"]:P=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),$);const I=(0,n.spawn)(s,[...P,$],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});l.onCancellationRequested(()=>(I.kill(),o(new E.$5))),I.on("error",W=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,j.$hj)(W)),o(W)});const O=[];I.stdout.on("data",W=>O.push(W));const M=[];I.stderr.on("data",W=>M.push(W)),I.on("close",(W,F)=>{const T=Buffer.concat(O).toString("utf8");g.trace("getUnixShellEnvironment#raw",T);const q=Buffer.concat(M).toString("utf8");if(q.trim()&&g.trace("getUnixShellEnvironment#stderr",q),W||F)return o(new Error((0,S.localize)(2,null,W,F)));const ue=t.exec(T),ee=ue?ue[1]:"{}";try{const ce=JSON.parse(ee);w?ce.ELECTRON_RUN_AS_NODE=w:delete ce.ELECTRON_RUN_AS_NODE,k?ce.ELECTRON_NO_ATTACH_CONSOLE=k:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ce),i(ce)}catch(ce){g.error("getUnixShellEnvironment#errorCaught",(0,j.$hj)(ce)),o(ce)}})})}}),define(re[252],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(S){try{const R=await this.c();if(R){const j=String(n.a++);return this.b.set(j,R),{id:j,data:R.createNewMessage(S)}}}catch{}return{id:"",data:S}}async validate(S,R){if(!S.id)return!0;const j=this.b.get(S.id);if(!j)return!1;this.b.delete(S.id);try{return j.validate(R)==="ok"}catch{return!1}finally{j.dispose?.()}}async sign(S){try{return await this.d(S)}catch{}return S}}e.$L$b=n}),define(re[96],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol="signService",e.$Pl=(0,n.$wi)(e.$Ol)}),define(re[253],oe([0,1,252]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class C extends n.$L$b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(j=>new j.signer().sign(R))}h(){return new Promise((R,j)=>J(["vsda"],R,j))}}e.$Hdc=C}),define(re[34],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GQ=e.$FQ=void 0,e.$FQ=(0,n.$wi)("stateReadService"),e.$GQ=(0,n.$wi)("stateService")}),define(re[125],oe([0,1,8,17,2,12,38,16,5]),function(J,e,n,C,S,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=e.$IQ=e.$HQ=e.SaveStrategy=void 0;var c;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class d extends S.$Vc{constructor(f,y,p,g){super(),this.h=f,this.j=y,this.m=p,this.n=g,this.a=Object.create(null),this.b="",this.c=this.B(new n.$uh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==1&&this.m.error(f)}}getItem(f,y){const p=this.a[f];return(0,R.$fg)(p)?y:p}setItem(f,y){this.setItems([{key:f,data:y}])}setItems(f){let y=!1;for(const{key:p,data:g}of f)this.a[p]!==g&&((0,R.$fg)(g)?(0,R.$dg)(this.a[p])||(this.a[p]=void 0,y=!0):(this.a[p]=g,y=!0));y&&this.s()}removeItem(f){(0,R.$dg)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,C.$Ge.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(y){this.m.error(y)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$HQ=d;let b=class extends S.$Vc{constructor(f,y,p,g){super(),this.a=this.B(new d(y.stateResource,f,p,g))}async init(){await this.a.init()}getItem(f,y){return this.a.getItem(f,y)}};e.$IQ=b,e.$IQ=b=Se([ie(1,j.$Di),ie(2,h.$3j),ie(3,E.$3k)],b);class v extends b{setItem(f,y){this.a.setItem(f,y)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$JQ=v}),define(re[126],oe([0,1,4,36,33]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=j,e.$ep=E;function R(h){if(n.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function j(h,c,d,b,v,m,f,y,p){const g=Object.create(null);g["common.machineId"]=m,g["common.sqmId"]=f,g.sessionID=(0,S.$Sg)()+Date.now(),g.commitHash=b,g.version=v,g["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,n.$h)(n.$u),g["common.nodePlatform"]=C.$ec,g["common.nodeArch"]=d,g["common.product"]=p||"desktop",y&&(g["common.msftInternal"]=y);let l=0;const w=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),n.$l&&(g["common.snap"]="true");const k=R(c);return k&&(g["common.platformDetail"]=k),g}function E(h){const c=C.env.USERDNSDOMAIN;if(!c)return!1;const d=c.toLowerCase();return h.some(b=>d===b)}}),define(re[28],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,n.$wi)("telemetryService"),e.$3l=(0,n.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var C;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var S;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(re[254],oe([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Es=g,e.$Fs=w,e.$Gs=k;const p=new Map;async function g(t,r){const s=`${t}::${r.join(":")}`,i=p.get(s);if(i)return i;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,$=new Map,P=2e4;function D(O,M,W,F){const T=M.substring(O.length+1);return C.Promises.withAsyncBody(async q=>{let ue;try{ue=await d.Promises.readdir(M,{withFileTypes:!0})}catch{q();return}if(F.count>=P){F.count+=ue.length,F.maxReached=!0,q();return}let ee=ue.length;if(ee===0){q();return}let ce=ue;F.count+ue.length>P&&(F.maxReached=!0,ee=P-F.count,ce=ue.slice(0,ee)),F.count+=ue.length;for(const K of ce)if(K.isDirectory()){if(W.includes(K.name)||await D(O,(0,j.$kc)(M,K.name),W,F),--ee===0){q();return}}else{const G=K.name.lastIndexOf(".");if(G>=0){const B=K.name.substring(G+1);B&&u.set(B,(u.get(B)??0)+1)}for(const B of o)B.relativePathPattern?.test(T)!==!1&&B.filePattern.test(K.name)&&$.set(B.tag,($.get(B.tag)??0)+1);if(--ee===0){q();return}}})}const I=C.Promises.withAsyncBody(async O=>{const M={count:0,maxReached:!1};await D(t,t,r,M);const W=await k(t);O({configFiles:l($),fileTypes:l(u),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:W})});return p.set(s,I),I}function l(t){return Array.from(t.entries(),([r,s])=>({name:r,count:s})).sort((r,s)=>s.count-r.count)}function w(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/m.$yl.GB).toFixed(2)}GB (${(n.freemem()/m.$yl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$En.value()*100)}%`},r=n.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function k(t){try{const r=new Map,s=(0,j.$kc)(t,".vscode","launch.json"),i=await d.Promises.readFile(s),o=[],u=(0,S.$Jn)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,S.$Sn)(u)==="object"&&u.configurations)for(const $ of u.configurations){const P=$.type;P&&(r.has(P)?r.set(P,r.get(P)+1):r.set(P,1))}return l(r)}catch{return[]}}let a=class{constructor(r,s){this.c=r,this.d=s}f(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}g(r){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(n.totalmem()/m.$yl.GB).toFixed(2)}GB (${(n.freemem()/m.$yl.GB).toFixed(2)}GB free)`),E.$i||s.push(`Load (avg):       ${n.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(c.$En.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([(0,b.$Ds)(r.mainPID),this.k(r)]).then(async i=>{let[o,u]=i,$=this.m(r,o);return s.forEach(P=>{if((0,v.$en)(P))$+=`
${P.errorMessage}`,u+=`
${P.errorMessage}`;else if($+=`

Remote: ${P.hostName}`,P.processes&&($+=`
${this.m(r,P.processes)}`),P.workspaceMetadata){u+=`
|  Remote: ${P.hostName}`;for(const D of Object.keys(P.workspaceMetadata)){const I=P.workspaceMetadata[D];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),u+=`|    Folder (${D}): ${O}`,u+=this.h(I)}}}),{processInfo:$,workspaceInfo:u}})}async getSystemInfo(r,s){const{memory:i,vmHint:o,os:u,cpus:$}=w(),P={os:u,memory:i,cpus:$,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return E.$i||(P.load=`${n.loadavg().map(D=>Math.round(D)).join(", ")}`),E.$k&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(r,s){const i=[];return(0,b.$Ds)(r.mainPID).then(async o=>(i.push(""),i.push(this.g(r)),i.push(""),i.push(this.m(r,o)),r.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(r))),s.forEach(u=>{if((0,v.$en)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.f(u.machineInfo)),u.processes&&i.push(this.m(r,u.processes)),u.workspaceMetadata)for(const $ of Object.keys(u.workspaceMetadata)){const P=u.workspaceMetadata[$];let D=`${P.fileCount} files`;P.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${$}): ${D}`),i.push(this.h(P))}}),i.push(""),i.push(""),i.join(`
`)))}h(r){const s=[];let o=0;const u=(I,O)=>{const M=` ${I}(${O})`;o+M.length>60?(s.push($),$="|                 ",o=$.length):o+=M.length,$+=M};let $="|      File types:";const P=10,D=r.fileTypes.length>P?P:r.fileTypes.length;for(let I=0;I<D;I++){const O=r.fileTypes[I];u(O.name,O.count)}if(s.push($),r.configFiles.length>=0&&($="|      Conf files:",o=0,r.configFiles.forEach(I=>{u(I.name,I.count)}),s.push($)),r.launchConfigFiles.length>0){let I="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{const M=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;I+=M}),s.push(I)}return s.join(`
`)}j(r){const s=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${r[i]}`).join(`
                  `)}k(r){const s=[],i=[];return r.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const $=h.URI.revive(u);if($.scheme===R.Schemas.file){const P=$.fsPath;i.push(g(P,["node_modules",".git"]).then(D=>{let I=`${D.fileCount} files`;D.maxFilesReached&&(I=`more than ${I}`),s.push(`|    Folder (${(0,j.$oc)(P)}): ${I}`),s.push(this.h(D))}).catch(D=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${D.toString()})`)}))}else s.push(`|    Folder (${$.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,s){const i=new Map;r.windows.forEach(u=>i.set(u.pid,`window [${u.id}] (${u.title})`)),r.pidToNames.forEach(({pid:u,name:$})=>i.set(u,$));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.n(r.mainPID,i,o,s,0),o.join(`
`)}n(r,s,i,o,u){const $=u===0;let P;$?P=o.pid===r?`${this.d.applicationName} main`:"remote agent":s.has(o.pid)?P=s.get(o.pid):P=`${"  ".repeat(u)} ${o.name}`;const D=process.platform==="win32"?o.mem:n.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(D/m.$yl.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(o.children)&&o.children.forEach(I=>this.n(r,s,i,I,u+1))}async getWorkspaceFileExtensions(r){const s=new Set;for(const{uri:i}of r.folders){const o=h.URI.revive(i);if(o.scheme!==R.Schemas.file)continue;const u=o.fsPath;try{(await g(u,["node_modules",".git"])).fileTypes.forEach(P=>s.add(P.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const i=h.URI.revive(s);if(i.scheme!==R.Schemas.file)continue;const o=i.fsPath;try{const u=await g(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),u.fileTypes.forEach($=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:$.name,count:$.count})}),u.launchConfigFiles.forEach($=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:$.name,count:$.count})}),u.configFiles.forEach($=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:$.name,count:$.count})})}catch{}}}};e.$Hs=a,e.$Hs=a=Se([ie(0,y.$2l),ie(1,f.$jk)],a)}),define(re[255],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0;class n{constructor(R){this.b=R}listen(R,j){throw new Error(`Event not found: ${j}`)}call(R,j,{eventName:E,data:h}){return this.b.forEach(c=>c.log(E,h)),Promise.resolve(null)}}e.$Wcc=n;class C{constructor(R){this.b=R}log(R,j){return this.b.call("log",{eventName:R,data:j}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Xcc=C}),define(re[54],oe([0,1,35,12,68,126,28]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=d,e.$np=b,e.$op=v,e.$pp=m,e.$qp=y,e.$rp=g,e.$sp=l,e.$tp=a;class E{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$fp=E;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=h,e.$hp=new h;class c{async publicLog(r,s,i){}async publicLogError(r,s,i){}}e.$ip=c,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function d(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function b(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function v(t){const r=t.getValue(j.$0l),s=t.getValue(j.$$l);if(t.getValue(j.$_l)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function m(t){const r={},s={},i={};p(t,i);for(let o in i){o=o.length>150?o.substr(o.length-149):o;const u=i[o];typeof u=="number"?s[o]=u:typeof u=="boolean"?s[o]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${u.length}`),r[o]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(r[o]=u)}return{properties:r,measurements:s}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function y(t){if(!t)return"none";const r=(0,S.$Im)(t);return f.has(r)?r:"other"}function p(t,r,s=0,i){if(t)for(const o of Object.getOwnPropertyNames(t)){const u=t[o],$=i?i+o:o;Array.isArray(u)?r[$]=(0,n.$8n)(u):u instanceof Date?r[$]=u.toISOString():(0,C.$$f)(u)?s<2?p(u,r,s+1,$+"."):r[$]=(0,n.$8n)(u):r[$]=u}}function g(t,r){const s=t.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,R.$ep)(s)||i}function l(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function w(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const i=[];for(const P of r)for(;;){const D=P.exec(t);if(!D)break;i.push([D.index,P.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(s="";;){const P=u.exec(t);if(!P)break;const D=i.some(([I,O])=>P.index<O&&I<u.lastIndex);!o.test(P[0])&&!D&&(s+=t.substring($,P.index)+"<REDACTED: user-file-path>",$=u.lastIndex)}return $<t.length&&(s+=t.substr($)),s}function k(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of r)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,r){return(0,n.$5n)(t,s=>{if(s instanceof E||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let i=s.replaceAll("%20"," ");i=w(i,r);for(const o of r)i=i.replace(o,"");return i=k(i),i}})}}),define(re[127],oe([0,1,25,121,124,4,7,15,36,54]),function(J,e,n,C,S,R,j,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=d,e.$wp=f,e.$xp=y,e.$yp=p,e.$zp=g,e.$Ap=l,e.$Bp=w,e.$Cp=k,e.$Ep=a,e.$Fp=r;function d(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,n.$tf)(s.id,i.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const o=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,o,u)}static parse(i){const o=b.exec(i);return o&&o[1]&&o[2]?new v({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?d(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$vp=v;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(s){const i=m.exec(s);return i&&i[1]?[p(i[1]),i[2]]:[p(s),void 0]}function y(s,i){return`${s}.${i}`}function p(s){return s.toLowerCase()}function g(s,i){return p(y(s??S.$Nm,i))}function l(s,i){const o=[],u=$=>{for(const P of o)if(P.some(D=>d(i(D),i($))))return P;return null};for(const $ of s){const P=u($);P?P.push($):o.push([$])}return o}function w(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function k(s){return{id:new c.$fp(s.identifier.id),name:new c.$fp(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Dp=new S.$Rm("pprice.better-merge");function a(s,i){const o=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const $=u.shift();if($&&o.every(P=>!d(P.identifier,{id:$}))){const P=s.filter(D=>d(D.identifier,{id:$}));P.length===1&&(o.push(P[0]),u.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}async function t(s,i){if(!R.$k)return!1;let o;try{o=(await s.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await s.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch($){i.debug("Error while getting the os-release file.",(0,E.$0)($))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,i){const o=await t(s,i),u=(0,C.$2o)(o?"alpine":R.$u,h.$fc);return i.debug("ComputeTargetPlatform:",u),u}}),define(re[256],oe([0,1,209,54]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=S;async function S(R,j,E,h,c,d,b){const v={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${j.nameShort})`};if((0,C.$mp)(j,E)&&(0,C.$op)(h)===3){const m=await(0,n.$7p)(E,c,d);v["X-Market-User-Id"]=m,v["VSCode-SessionId"]=b.machineId||m}return v}}),define(re[257],oe([0,1,2,35,4,25,188,18,52,80,27,45,28,54]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,l,w){this.k=l,this.l=w,this.d={},this.i=new n.$Uc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,R.$af)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.$af)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(v.$0l)||k.affectsConfiguration(v.$_l)||k.affectsConfiguration(v.$$l))&&this.m()}))}setExperimentProperty(g,l){this.d[g]=l}m(){let g=(0,m.$op)(this.k);const l=this.l.enabledTelemetryLevels;if(l){this.h=this.sendErrorTelemetry?l.error:!1;const w=l.usage?3:l.error?2:0;g=Math.min(g,w)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,l,w){this.g<l||(w=(0,C.$6n)(w,this.d),w=(0,m.$tp)(w,this.j),w=(0,C.$6n)(w,this.c),this.b.forEach(k=>k.log(g,w)))}publicLog(g,l){this.n(g,3,l)}publicLog2(g,l){this.publicLog(g,l)}publicLogError(g,l){this.h&&this.n(g,2,l)}publicLogError2(g,l){this.publicLogError(g,l)}};e.$Zr=f,e.$Zr=f=Se([ie(1,E.$3i),ie(2,d.$jk)],f);function y(){const p=(0,j.localize)(0,null,c.default.nameLong),g=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=S.$o?"":(0,j.localize)(3,null),w=(0,j.localize)(4,null),k=(0,j.localize)(5,null),a=(0,j.localize)(6,null),t=(0,j.localize)(7,null),r=`
|       | ${w} | ${k} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,j.localize)(8,null);return`
${p} ${g} ${l}

&nbsp;

${t}
${r}

&nbsp;

${s}
`}b.$co.as(h.$ho.Configuration).registerConfiguration({id:v.$9l,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[v.$0l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$co.as(h.$ho.Configuration).registerConfiguration({id:v.$9l,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[v.$_l]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${v.$0l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[258],oe([0,1,4,89,28]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=R,e.$ndc=j;async function R(E,h){let c=E.getItem(S.$7l);return(typeof c!="string"||n.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,C.$Fn)(h.error.bind(h))),c}async function j(E,h){let c=E.getItem(S.$8l);return typeof c!="string"&&(c=await(0,C.$Gn)(h.error.bind(h))),c}}),define(re[259],oe([0,1,28,258]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=S,e.$pdc=R;async function S(j,E){const h=await(0,C.$mdc)(j,E);return j.setItem(n.$7l,h),h}async function R(j,E){const h=await(0,C.$ndc)(j,E);return j.setItem(n.$8l,h),h}}),define(re[128],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(re[260],oe([0,1,4,128]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0;const S=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class R{constructor(d){this.collections=d,this.a=new Map,this.b=new Map,d.forEach((b,v)=>{this.d(b,v);const m=b.map.entries();let f=m.next();for(;!f.done;){const y=f.value[1],p=f.value[0];let g=this.a.get(p);if(g||(g=[],this.a.set(p,g)),g.length>0&&g[0].type===C.EnvironmentVariableMutatorType.Replace){f=m.next();continue}const l={extensionIdentifier:v,value:y.value,type:y.type,scope:y.scope,variable:y.variable,options:y.options};l.scope||delete l.scope,g.unshift(l),f=m.next()}})}async applyToProcessEnvironment(d,b,v){let m;n.$i&&(m={},Object.keys(d).forEach(f=>m[f.toLowerCase()]=f));for(const[f,y]of this.getVariableMap(b)){const p=n.$i&&m[f.toLowerCase()]||f;for(const g of y){const l=v?await v(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case C.EnvironmentVariableMutatorType.Append:d[p]=(d[p]||"")+l;break;case C.EnvironmentVariableMutatorType.Prepend:d[p]=l+(d[p]||"");break;case C.EnvironmentVariableMutatorType.Replace:d[p]=l;break}if(g.options?.applyAtShellIntegration??!1){const w=`VSCODE_ENV_${S.get(g.type)}`;d[w]=(d[w]?d[w]+":":"")+f+"="+this.c(l)}}}}c(d){return d.replaceAll(":","\\x3a")}diff(d,b){const v=new Map,m=new Map,f=new Map;if(d.getVariableMap(b).forEach((y,p)=>{const g=this.getVariableMap(b).get(p),l=E(y,g);l&&v.set(p,l)}),this.getVariableMap(b).forEach((y,p)=>{const g=d.getVariableMap(b).get(p),l=E(y,g);l&&f.set(p,l)}),this.getVariableMap(b).forEach((y,p)=>{const g=d.getVariableMap(b).get(p),l=h(y,g);l&&m.set(p,l)}),!(v.size===0&&m.size===0&&f.size===0))return{added:v,changed:m,removed:f}}getVariableMap(d){const b=new Map;for(const v of this.a.values()){const m=v.filter(f=>j(f,d));m.length>0&&b.set(m[0].variable,m)}return b}getDescriptionMap(d){const b=new Map;for(const v of this.b.values()){const m=v.filter(f=>j(f,d,!0));for(const f of m)b.set(f.extensionIdentifier,f.description)}return b}d(d,b){if(!d.descriptionMap)return;const v=d.descriptionMap.entries();let m=v.next();for(;!m.done;){const f=m.value[1],y=m.value[0];let p=this.b.get(y);p||(p=[],this.b.set(y,p));const g={extensionIdentifier:b,scope:f.scope,description:f.description};g.scope||delete g.scope,p.push(g),m=v.next()}}}e.$rs=R;function j(c,d,b=!1){return c.scope?!!(c.scope.workspaceFolder&&d?.workspaceFolder&&c.scope.workspaceFolder.index===d.workspaceFolder.index):b?d===c.scope:!0}function E(c,d){if(!d)return c;const b=new Set;d.forEach(m=>b.add(m.extensionIdentifier));const v=[];return c.forEach(m=>{b.has(m.extensionIdentifier)||v.push(m)}),v.length===0?void 0:v}function h(c,d){if(!d)return;const b=new Map;d.forEach(m=>b.set(m.extensionIdentifier,m));const v=[];return c.forEach(m=>{const f=b.get(m.extensionIdentifier);f&&(m.type!==f.type||m.value!==f.value||m.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&v.push(f)}),v.length===0?void 0:v}}),define(re[261],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=n,e.$ms=C,e.$ns=S,e.$os=R,e.$ps=j,e.$qs=E;function n(h){return[...h.entries()]}function C(h){return h?[...h.entries()]:[]}function S(h){return new Map(h)}function R(h){return new Map(h??[])}function j(h){return Array.from(h.entries()).map(c=>[c[0],n(c[1].map),C(c[1].descriptionMap)])}function E(h){return new Map(h.map(c=>[c[0],{map:S(c[1]),descriptionMap:R(c[2])}]))}}),define(re[262],oe([0,1,8,23,3,2,5]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0;let E=class extends R.$Vc{constructor(c,d){super(),this.h=d,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$ee),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,R.$Tc)(()=>{for(const b of this.f.values())(0,R.$Qc)(b)}))}createRequest(c){return new Promise((d,b)=>{const v=++this.a;this.c.set(v,d),this.g.fire({requestId:v,...c});const m=new C.$pe;(0,n.$xh)(this.b,m.token).then(()=>b(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,R.$Tc)(()=>m.cancel())])})}acceptReply(c,d){const b=this.c.get(c);b?(this.c.delete(c),(0,R.$Qc)(this.f.get(c)||[]),this.f.delete(c),b(d)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$cs=E,e.$cs=E=Se([ie(1,j.$3j)],E)}),define(re[129],oe([0,1,6,118,45]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$8r=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$7r=void 0,e.$7r=new C.$Nj("terminalTabFocusMode",!1,!0);var R;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var j;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var E;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(E||(e.PosixShellType=E={}));var h;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(h||(e.WindowsShellType=h={}));var c;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var d;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(d||(e.TerminalIpcChannels=d={}));var b;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.$8r=(0,n.$wi)("ptyService");var v;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var m;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(m||(e.TerminalLocation=m={}));var f;(function(a){a.TerminalView="view",a.Editor="editor"})(f||(e.TerminalLocationString=f={}));var y;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var p;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var g;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var l;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var w;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(w||(e.TerminalExitReason=w={})),e.$9r={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const r=this.b(t.remoteAuthority);if(this.a.has(r))throw new Error(`A terminal backend with remote authority '${r}' was already registered.`);this.a.set(r,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}S.$co.add(e.$9r.Backend,new k),e.$0r=(0,n.$wi)("localPtyService"),e.$$r=(0,n.$wi)("terminalLogService")}),define(re[263],oe([0,1,75,7,190,106]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=j,e.$es=c,e.$fs=d,e.$gs=b;function j(v,m){const f=[{name:null,description:(0,S.localize)(0,null)}];return f.push(...v.map(y=>({name:y.profileName,description:E(y)}))),m&&f.push(...m.map(y=>({name:y.title,description:h(y)}))),{values:f.map(y=>y.name),markdownDescriptions:f.map(y=>y.description)}}function E(v){let m=`$(${R.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:n.$Vj.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?m+=`
- args: "${v.args}"`:m+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(m+=`
- overrideName: ${v.overrideName}`),v.color&&(m+=`
- color: ${v.color}`),v.env&&(m+=`
- env: ${JSON.stringify(v.env)}`),m}function h(v){return`$(${R.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:n.$Vj.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function c(v,m){if(!v&&!m)return!0;if(typeof v=="string"&&typeof m=="string")return v===m;if(Array.isArray(v)&&Array.isArray(m)){if(v.length!==m.length)return!1;for(let f=0;f<v.length;f++)if(v[f]!==m[f])return!1;return!0}return!1}function d(v,m){if(!v&&!m)return!0;if(!v||!m)return!1;if(R.ThemeIcon.isThemeIcon(v)&&R.ThemeIcon.isThemeIcon(m))return v.id===m.id&&v.color===m.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof m=="object"&&"light"in m&&"dark"in m){const f=v,y=m;if((C.URI.isUri(f.light)||b(f.light))&&(C.URI.isUri(f.dark)||b(f.dark))&&(C.URI.isUri(y.light)||b(y.light))&&(C.URI.isUri(y.dark)||b(y.dark)))return f.light.path===y.light.path&&f.dark.path===y.dark.path}if(C.URI.isUri(v)&&C.URI.isUri(m)||b(v)||b(m)){const f=v,y=m;return f.path===y.path&&f.scheme===y.scheme}return!1}function b(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}}),define(re[264],oe([0,1,75,4,189,52,45,263]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=void 0,e.$js=m,e.$ks=y,e.$hs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$is={type:"string",enum:Array.from((0,n.$Tj)(),p=>p.id),markdownEnumDescriptions:Array.from((0,n.$Tj)(),p=>`$(${p.id})`)};const h={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$is},color:{description:(0,S.localize)(3,null),...e.$hs},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},d={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function b(p){const g=p===2?"linux":p===1?"osx":"windows";return(0,S.localize)(7,null,(0,C.$h)(p),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.useWslProfiles":{description:(0,S.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,S.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,S.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){j.$co.as(R.$ho.Configuration).registerConfiguration(v),y()}let f;function y(p,g){const l=j.$co.as(R.$ho.Configuration);let w;p&&(w=(0,E.$ds)(p?.profiles,g));const k=f;f={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:p?.os===3?w?.values:void 0,markdownEnumDescriptions:p?.os===3?w?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:p?.os===2?w?.values:void 0,markdownEnumDescriptions:p?.os===2?w?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:p?.os===1?w?.values:void 0,markdownEnumDescriptions:p?.os===1?w?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[f],remove:k?[k]:[]})}}),define(re[265],oe([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=f,e.$ts=y,e.$us=p;function f(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let $=0;return u&&u.length===4&&($=parseInt(u[3])),$}async function y(u,$,P,D=E.env,I=d.Promises.exists){if(R.$jc(u))return await I(u)?u:void 0;if($===void 0&&($=E.cwd()),R.$nc(u)!=="."){const F=R.$kc($,u);return await I(F)?F:void 0}const M=(0,S.$0n)(D,"PATH");if(P===void 0&&(0,c.$9f)(M)&&(P=M.split(R.$uc)),P===void 0||P.length===0){const F=R.$kc($,u);return await I(F)?F:void 0}for(const F of P){let T;if(R.$jc(F)?T=R.$kc(F,u):T=R.$kc($,F,u),await I(T))return T;if(j.$i){let q=T+".com";if(await I(q)||(q=T+".exe",await I(q)))return q}}const W=R.$kc($,u);return await I(W)?W:void 0}function p(u,$,P,D,I){const O=j.$i&&(!$.windowsEnableConpty||f()<18309);if(!$.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||O)return;const M=u.args,W=E.$ec==="win32"?R.$oc(u.executable).toLowerCase():R.$oc(u.executable),F=R.$nc(C.$Qg.asFileUri("").fsPath);let T;const q={VSCODE_INJECTION:"1"};if($.shellIntegration.nonce&&(q.VSCODE_NONCE=$.shellIntegration.nonce),j.$i){if(W==="pwsh.exe"||W==="powershell.exe")return!M||i(M)?T=w.get(l.WindowsPwsh):s(M)&&(T=w.get(l.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,h.$9e)(T[T.length-1],F,""),$.shellIntegration.suggestEnabled&&(q.VSCODE_SUGGEST="1"),{newArgs:T,envMixin:q}):void 0;if(W==="bash.exe")return!M||M.length===0?T=w.get(l.Bash):o(M)&&(q.VSCODE_SHELL_LOGIN="1",g($,q),T=w.get(l.Bash)),T?(T=[...T],T[T.length-1]=(0,h.$9e)(T[T.length-1],F),{newArgs:T,envMixin:q}):void 0;D.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(W){case"bash":return!M||M.length===0?T=w.get(l.Bash):o(M)&&(q.VSCODE_SHELL_LOGIN="1",g($,q),T=w.get(l.Bash)),T?(T=[...T],T[T.length-1]=(0,h.$9e)(T[T.length-1],F),{newArgs:T,envMixin:q}):void 0;case"fish":{const ue=P?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=R.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${ue}:${ee}`,g($,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!M||i(M)?T=w.get(l.Pwsh):s(M)&&(T=w.get(l.PwshLogin)),T?($.shellIntegration.suggestEnabled&&(q.VSCODE_SUGGEST="1"),T=[...T],T[T.length-1]=(0,h.$9e)(T[T.length-1],F,""),{newArgs:T,envMixin:q}):void 0;case"zsh":{if(!M||M.length===0?T=w.get(l.Zsh):o(M)?(T=w.get(l.ZshLogin),g($,q)):(M===w.get(l.Zsh)||M===w.get(l.ZshLogin))&&(T=M),!T)return;T=[...T],T[T.length-1]=(0,h.$9e)(T[T.length-1],F);let ue;try{ue=n.userInfo().username}catch{ue="unknown"}const ee=R.$kc(n.tmpdir(),`${ue}-${I.applicationName}-zsh`);q.ZDOTDIR=ee;const ce=P?.ZDOTDIR??n.homedir()??"~";q.USER_ZDOTDIR=ce;const K=[];return K.push({source:R.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.$kc(ee,".zshrc")}),K.push({source:R.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.$kc(ee,".zprofile")}),K.push({source:R.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.$kc(ee,".zshenv")}),K.push({source:R.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.$kc(ee,".zlogin")}),{newArgs:T,envMixin:q,filesToCopy:K}}}D.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function g(u,$){if(j.$j&&u.environmentVariableCollections){const P=(0,v.$qs)(u.environmentVariableCollections),I=new m.$rs(P).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),O=[];if(I)for(const M of I)M.type===b.EnvironmentVariableMutatorType.Prepend&&O.push(M.value);O.length>0&&($.VSCODE_PATH_PREFIX=O.join(""))}}var l;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(l||(l={}));const w=new Map;w.set(l.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),w.set(l.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),w.set(l.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),w.set(l.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),w.set(l.Zsh,["-i"]),w.set(l.ZshLogin,["-il"]),w.set(l.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],a=["--login","-l"],t=["-i","--interactive"],r=["-nol","-nologo"];function s(u){return typeof u=="string"?k.includes(u.toLowerCase()):u.length===1&&k.includes(u[0].toLowerCase())||u.length===2&&(k.includes(u[0].toLowerCase())||k.includes(u[1].toLowerCase()))&&(r.includes(u[0].toLowerCase())||r.includes(u[1].toLowerCase()))}function i(u){return typeof u=="string"?r.includes(u.toLowerCase()):u.length===0||u?.length===1&&r.includes(u[0].toLowerCase())}function o(u){return typeof u!="string"&&(u=u.filter($=>!t.includes($.toLowerCase()))),u==="string"&&a.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&a.includes(u[0].toLowerCase())}}),define(re[266],oe([0,1,49,75,9,4,12,21,110,265,117]),function(J,e,n,C,S,R,j,E,h,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=f;var b;(function(u){u.UnixShellsPath="/etc/shells"})(b||(b={}));let v,m=!0;function f(u,$,P,D,I=process.env,O,M,W,F){return O=O||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},R.$i?y(P,O,I,M,D.getValue("terminal.integrated.useWslProfiles")!==!1,u&&typeof u=="object"?{...u}:D.getValue("terminal.integrated.profiles.windows"),typeof $=="string"?$:D.getValue("terminal.integrated.defaultProfile.windows"),F,W):s(O,M,P,u&&typeof u=="object"?{...u}:D.getValue(R.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof $=="string"?$:D.getValue(R.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,W,I)}async function y(u,$,P,D,I,O,M,W,F){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),q=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let ue=!1;(0,c.$ss)()>=16299&&(ue=!0),await w(W);const ee=new Map;if(u){ee.set("PowerShell",{source:"PowerShell",icon:C.$Vj.terminalPowershell,isAutoDetected:!0}),ee.set("Windows PowerShell",{path:`${q}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$Vj.terminalPowershell,isAutoDetected:!0}),ee.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ee.set("Command Prompt",{path:`${q}\\cmd.exe`,icon:C.$Vj.terminalCmd,isAutoDetected:!0}),ee.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ee.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:C.$Vj.terminalBash,isAutoDetected:!0});const K=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ee.set("Cmder",{path:`${q}\\cmd.exe`,args:["/K",K],requiresPath:process.env.CMDER_ROOT?K:{path:K,isUnsafe:!0},isAutoDetected:!0})}i(O,ee);const ce=await p(ee.entries(),M,$,P,D,F);if(u&&I)try{const K=await t(`${q}\\${ue?"wsl":"bash"}.exe`,M);for(const G of K)(!O||!(G.profileName in O))&&ce.push(G)}catch{m&&(D?.trace("WSL is not installed, so could not detect WSL profiles"),m=!1)}return ce}async function p(u,$,P,D=process.env,I,O){const M=[];for(const[W,F]of u)M.push(g(W,F,$,P,D,I,O));return(await Promise.all(M)).filter(W=>!!W)}async function g(u,$,P,D,I=process.env,O,M){if($===null)return;let W,F,T;if("source"in $&&!("path"in $)){const ce=v?.get($.source);if(!ce)return;W=ce.paths,F=$.args||ce.args,$.icon?T=l($.icon):ce.icon&&(T=ce.icon)}else W=Array.isArray($.path)?$.path:[$.path],F=R.$i||Array.isArray($.args)?$.args:void 0,T=l($.icon);let q;if(M){const ce=W.map(G=>typeof G=="string"?G:G.path),K=await M(ce);q=new Array(W.length);for(let G=0;G<W.length;G++)typeof W[G]=="string"?q[G]=K[G]:q[G]={path:K[G],isUnsafe:!0}}else q=W.slice();let ue;if($.requiresPath){let ce;if((0,j.$9f)($.requiresPath)?ce=$.requiresPath:(ce=$.requiresPath.path,$.requiresPath.isUnsafe&&(ue=ce)),!await D.existsFile(ce))return}const ee=await o(u,P,q,D,I,F,$.env,$.overrideName,$.isAutoDetected,ue);if(!ee){O?.debug("Terminal profile not validated",u,W);return}return ee.isAutoDetected=$.isAutoDetected,ee.icon=T,ee.color=$.color,ee}function l(u){return typeof u=="string"?{id:u}:u}async function w(u){if(v&&!u)return;const[$,P]=await Promise.all([k(),u||a()]);v=new Map,v.set("Git Bash",{profileName:"Git Bash",paths:$,args:["--login","-i"]}),v.set("PowerShell",{profileName:"PowerShell",paths:P,icon:C.$Vj.terminalPowershell})}async function k(){const u=new Set,$=await(0,c.$ts)("git.exe");if($){const I=(0,d.dirname)($);u.add((0,d.resolve)(I,"../.."))}function P(I,O){O&&I.add(O)}P(u,process.env.ProgramW6432),P(u,process.env.ProgramFiles),P(u,process.env["ProgramFiles(X86)"]),P(u,`${process.env.LocalAppData}\\Program`);const D=[];for(const I of u)D.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function a(){const u=[];for await(const $ of(0,h.$km)())u.push($.exePath);return u}async function t(u,$){const P=[],D=await new Promise((M,W)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,T)=>{if(F)return W("Problem occurred when getting wsl distros");M(T)})});if(!D)return[];const I=new RegExp(/[\r?\n]/),O=D.split(I).filter(M=>M.trim().length>0&&M!=="");for(const M of O){if(M===""||M.startsWith("docker-desktop"))continue;const W=`${M} (WSL)`,F={profileName:W,path:u,args:["-d",`${M}`],isDefault:W===$,icon:r(M),isAutoDetected:!1};P.push(F)}return P}function r(u){return u.includes("Ubuntu")?C.$Vj.terminalUbuntu:u.includes("Debian")?C.$Vj.terminalDebian:C.$Vj.terminalLinux}async function s(u,$,P,D,I,O,M,W){const F=new Map;if(P&&await u.existsFile("/etc/shells")){const T=(await u.readFile("/etc/shells")).toString(),q=(O||T.split(`
`)).map(ee=>{const ce=ee.indexOf("#");return ce===-1?ee:ee.substring(0,ce)}).filter(ee=>ee.trim().length>0),ue=new Map;for(const ee of q){let ce=(0,S.$oc)(ee),K=ue.get(ce)||0;K++,K>1&&(ce=`${ce} (${K})`),ue.set(ce,K),F.set(ce,{path:ee,isAutoDetected:!0})}}return i(D,F),await p(F.entries(),I,u,W,$,M)}function i(u,$){if(u)for(const[P,D]of Object.entries(u))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?$.delete(P):(D.icon=D.icon||$.get(P)?.icon,$.set(P,D))}async function o(u,$,P,D,I,O,M,W,F,T){if(P.length===0)return Promise.resolve(void 0);const q=P.shift();if(q==="")return o(u,$,P,D,I,O,M,W,F);const ue=typeof q!="string"&&q.isUnsafe,ee=typeof q=="string"?q:q.path,ce={profileName:u,path:ee,args:O,env:M,overrideName:W,isAutoDetected:F,isDefault:u===$,isUnsafePath:ue,requiresUnsafePath:T};if((0,S.$oc)(ee)===ee){const G=I.PATH?I.PATH.split(S.$uc):void 0,B=await(0,c.$ts)(ee,void 0,G,void 0,D.existsFile);return B?(ce.path=B,ce.isFromPath=!0,ce):o(u,$,P,D,I,O)}return await D.existsFile((0,S.$ic)(ee))?ce:o(u,$,P,D,I,O,M,W,F)}}),define(re[267],oe([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,73]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;var p;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let g=class extends C.$Vc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(w,k,a,t){super(),this.M=w,this.N=k,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$ee),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$ee),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$ee),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$ee),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$ee),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$ee),this.onProcessData=this.D.event,this.F=this.B(new n.$ee),this.onProcessReady=this.F.event,this.G=this.B(new n.$ee),this.onProcessReplay=this.G.event,this.H=this.B(new n.$ee),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$ee),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$ee),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$ee),this.onProcessExit=this.L.event,(0,v.$js)(),this.B(this.M),this.B((0,C.$Tc)(()=>this.W())),this.j=this.B(new d.$cs(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$i)return process.env;try{return await(0,c.$Gm)(this.N,this.O,{_:[]},process.env)}catch(w){return this.O.error("ptyHost was unable to resolve shell environment",w),{}}}U(){const w=this.M.start(),k=w.client;this.O.getLevel()===E.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),R.ProxyChannel.toService(k.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(w.onDidProcessExit(r=>{this.u.fire(r.code),!this.m&&!this.q.isDisposed&&(this.n<=p.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${r.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const t=R.ProxyChannel.toService(k.getChannel(b.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(r=>this.D.fire(r))),this.B(t.onProcessReady(r=>this.F.fire(r))),this.B(t.onProcessExit(r=>this.L.fire(r))),this.B(t.onDidChangeProperty(r=>this.J.fire(r))),this.B(t.onProcessReplay(r=>this.G.fire(r))),this.B(t.onProcessOrphanQuestion(r=>this.H.fire(r))),this.B(t.onDidRequestDetach(r=>this.I.fire(r))),this.B(new h.$bs(this.P,k.getChannel(b.TerminalIpcChannels.Logger))),this.a=w,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[w,t]}async createProcess(w,k,a,t,r,s,i,o,u,$,P){const D=setTimeout(()=>this.$(),b.HeartbeatConstants.CreateProcessTimeout),I=await this.f.createProcess(w,k,a,t,r,s,i,o,u,$,P);return clearTimeout(D),I}updateTitle(w,k,a){return this.f.updateTitle(w,k,a)}updateIcon(w,k,a,t){return this.f.updateIcon(w,k,a,t)}attachToProcess(w){return this.f.attachToProcess(w)}detachFromProcess(w,k){return this.f.detachFromProcess(w,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(w){return this.f.start(w)}shutdown(w,k){return this.f.shutdown(w,k)}input(w,k){return this.f.input(w,k)}processBinary(w,k){return this.f.processBinary(w,k)}resize(w,k,a){return this.f.resize(w,k,a)}clearBuffer(w){return this.f.clearBuffer(w)}acknowledgeDataEvent(w,k){return this.f.acknowledgeDataEvent(w,k)}setUnicodeVersion(w,k){return this.f.setUnicodeVersion(w,k)}getInitialCwd(w){return this.f.getInitialCwd(w)}getCwd(w){return this.f.getCwd(w)}async getLatency(){const w=new y.$ae,k=await this.f.getLatency();return w.stop(),[{label:"ptyhostservice<->ptyhost",latency:w.elapsed()},...k]}orphanQuestionReply(w){return this.f.orphanQuestionReply(w)}installAutoReply(w,k){return this.f.installAutoReply(w,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(w){return this.f.uninstallAutoReply(w)}getDefaultSystemShell(w){return this.g?.getDefaultSystemShell(w)??(0,f.$qm)(w??S.OS,process.env)}async getProfiles(w,k,a,t=!1){const r=await this.S();return(0,m.$vs)(k,a,t,this.N,r,void 0,this.O,this.bb.bind(this,w))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(w,k){return this.f.getWslPath(w,k)}getRevivedPtyNewId(w,k){return this.f.getRevivedPtyNewId(w,k)}setTerminalLayoutInfo(w){return this.f.setTerminalLayoutInfo(w)}async getTerminalLayoutInfo(w){return this.g?.getTerminalLayoutInfo(w)}async requestDetachInstance(w,k){return this.f.requestDetachInstance(w,k)}async acceptDetachInstanceReply(w,k){return this.f.acceptDetachInstanceReply(w,k)}async freePortKillProcess(w){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(w)}async serializeTerminalState(w){return this.f.serializeTerminalState(w)}async reviveTerminalProcesses(w,k,a){return this.f.reviveTerminalProcesses(w,k,a)}async refreshProperty(w,k){return this.f.refreshProperty(w,k)}async updateProperty(w,k,a){return this.f.updateProperty(w,k,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(w){this.ab(),this.s=setTimeout(()=>this.Y(),w?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(w,k){return this.j.createRequest({workspaceId:w,originalText:k})}async acceptPtyHostResolvedVariables(w,k){this.j.acceptReply(w,k)}};e.$ws=g,e.$ws=g=Se([ie(1,j.$3i),ie(2,E.$3j),ie(3,E.$4j)],g)}),define(re[69],oe([0,1,14,3,2,4,18,6,34]),function(J,e,n,C,S,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=e.$Mbc=void 0;const c="#FFFFFF",d="#1E1E1E",b="#000000",v="#FFFFFF",m="theme",f="themeBackground",y="windowSplash",p="window.systemColorTheme";e.$Mbc=(0,E.$wi)("themeMainService");let g=class extends S.$Vc{constructor(w,k){super(),this.b=w,this.c=k,this.a=this.B(new C.$ee),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(a=>{a.affectsConfiguration(p)&&this.f()})),this.f(),this.B(C.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue(p)){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(R.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const w=this.getColorScheme();if(w.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return w.dark?b:v;let k=this.b.getItem(f,null);if(!k)switch(this.g()){case"vs":k=c;break;case"hc-black":k=b;break;case"hc-light":k=v;break;default:k=d}return R.$j&&k.toUpperCase()===d&&(k="#171717"),k}g(){switch(this.b.getItem(m,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(w,k){this.b.setItems([{key:m,data:k.baseTheme},{key:f,data:k.colorInfo.background},{key:y,data:k}]),typeof w=="number"&&this.h(w,k),this.f()}h(w,k){for(const a of n.BrowserWindow.getAllWindows())if(a.id===w){a.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(y)}};e.$Nbc=g,e.$Nbc=g=Se([ie(0,h.$GQ),ie(1,j.$3i)],g)}),define(re[130],oe([0,1,3,7,18,6,5]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=e.$jw=e.$hw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$dw=e.$cw=void 0,e.$ew=c,e.$fw=b,e.$gw=v,e.$iw=m,e.$kw=f,e.$lw=y,e.$cw=(0,R.$wi)("tunnelService"),e.$dw=(0,R.$wi)("sharedTunnelsService");var E;(function(l){l.Http="http",l.Https="https"})(E||(e.TunnelProtocol=E={}));var h;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(h||(e.TunnelPrivacyId=h={}));function c(l){return!!l.forwardPort}var d;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function b(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(w)return{address:w[1],port:+w[2]}}function v(l){if(l.scheme!=="http"&&l.scheme!=="https"||!l.query)return;const w=l.query.split("&");for(const k of w){const a=k.split("=")[1];if(/^https?:/.exec(a)){const t=b(C.URI.parse(a));if(t)return t}}}e.$hw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(l){return e.$hw.indexOf(l)>=0}e.$jw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(l){return e.$jw.indexOf(l)>=0}function y(l,w,k,a){if(k===1)return!1;if(k===2&&f(w)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return l<1024}class p{constructor(w,k,a){this.remoteAddress=w,this.localAddress=k,this.b=a,this.a=new n.$ee,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mw=p;let g=class{constructor(w,k){this.k=w,this.l=k,this.a=new n.$ee,this.onTunnelOpened=this.a.event,this.b=new n.$ee,this.onTunnelClosed=this.b.event,this.c=new n.$ee,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const w=this.l.getValue("remote.localPortHost");return!w||w==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(w){return this.f=w,w?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this.g=w.elevation,this.i=w.privacyOptions,this.h=w.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const w=[],k=Array.from(this.e.values());for(const a of k){const t=Array.from(a.values());for(const r of t){const s=await r.value;s&&typeof s!="string"&&w.push(s)}}return w}async dispose(){for(const w of this.e.values()){for(const{value:k}of w.values())await k.then(a=>typeof a!="string"?a?.dispose():void 0);w.clear()}this.e.clear()}setEnvironmentTunnel(w,k,a,t,r){this.q(w,k,Promise.resolve({tunnelRemoteHost:w,tunnelRemotePort:k,localAddress:a,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(w,k){(f(w)||m(w))&&(w=e.$hw[0]);const a=this.s(w,k);if(a)return++a.refcount,a.value}openTunnel(w,k,a,t,r,s=!1,i,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${k}:${a} on local port ${r}.`);const u=this.f??w;if(!u)return;if(k||(k="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const $=this.t(u,k,a,t,r,s,i,o);return $?$.then(P=>{if(P){if(typeof P=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(k,a),P}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(k,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.o(P);return(P.tunnelRemoteHost!==k||P.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&P.privacy!==i&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),$)}o(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const k=this.e.get(w.tunnelRemoteHost);if(k){const a=k.get(w.tunnelRemotePort);a&&(a.refcount--,await this.p(w.tunnelRemoteHost,w.tunnelRemotePort,a))}}}}async p(w,k,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${k}.`);const t=a.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(w)&&this.e.get(w).delete(k),t}}async closeTunnel(w,k){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${k} `);const a=this.e.get(w);if(a&&a.has(k)){const t=a.get(k);t.refcount=0,await this.p(w,k,t)}}q(w,k,a){this.e.has(w)||this.e.set(w,new Map),this.e.get(w).set(k,{refcount:1,value:a})}async r(w,k){const a=this.e.get(w);if(a){const t=a.get(k),r=t?await t.value:void 0;(!r||typeof r=="string")&&a.delete(k),a.size===0&&this.e.delete(w)}}s(w,k){const a=[w];m(w)?(a.push(...e.$hw),a.push(...e.$jw)):f(w)&&a.push(...e.$jw);const t=a.map(r=>this.e.get(r));for(const r of t){const s=r?.get(k);if(s)return s}}canTunnel(w){return!!b(w)}u(w,k,a,t,r,s,i){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${k}:${a} on local port ${t}.`);const o=a;this.j.add(o);const u=t===void 0?a:t,$={elevationRequired:r?this.isPortPrivileged(u):!1},P={remoteAddress:{host:k,port:a},localAddressPort:t,privacy:s,public:s?s!==h.Private:void 0,protocol:i},D=w.forwardPort(P,$);return D?(this.q(k,a,D),D.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),D}};e.$nw=g,e.$nw=g=Se([ie(0,j.$3j),ie(1,S.$3i)],g)}),define(re[50],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UX=e.$TX=e.DisablementReason=e.UpdateType=e.StateType=void 0;var C;(function(j){j.Uninitialized="uninitialized",j.Idle="idle",j.Disabled="disabled",j.CheckingForUpdates="checking for updates",j.AvailableForDownload="available for download",j.Downloading="downloading",j.Downloaded="downloaded",j.Updating="updating",j.Ready="ready"})(C||(e.StateType=C={}));var S;(function(j){j[j.Setup=0]="Setup",j[j.Archive=1]="Archive",j[j.Snap=2]="Snap"})(S||(e.UpdateType=S={}));var R;(function(j){j[j.NotBuilt=0]="NotBuilt",j[j.DisabledByEnvironment=1]="DisabledByEnvironment",j[j.ManuallyDisabled=2]="ManuallyDisabled",j[j.MissingConfiguration=3]="MissingConfiguration",j[j.InvalidConfiguration=4]="InvalidConfiguration",j[j.RunningAsAdmin=5]="RunningAsAdmin"})(R||(e.DisablementReason=R={})),e.$TX={Uninitialized:{type:"uninitialized"},Disabled:j=>({type:"disabled",reason:j}),Idle:(j,E)=>({type:"idle",updateType:j,error:E}),CheckingForUpdates:j=>({type:"checking for updates",explicit:j}),AvailableForDownload:j=>({type:"available for download",update:j}),Downloading:{type:"downloading"},Downloaded:j=>({type:"downloaded",update:j}),Updating:j=>({type:"updating",update:j}),Ready:j=>({type:"ready",update:j})},e.$UX=(0,n.$wi)("updateService")}),define(re[268],oe([0,1,4,191,52,45]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.$co.as(S.$ho.Configuration).registerConfiguration({id:"update",order:15,title:(0,C.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,C.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,C.localize)(2,null),(0,C.localize)(3,null),(0,C.localize)(4,null),(0,C.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,C.localize)(6,null),deprecationMessage:(0,C.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,C.localize)(8,null),description:(0,C.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,C.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(re[269],oe([0,1,3,50]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=e.$Ycc=void 0;class S{constructor(E){this.a=E}listen(E,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(E,h,c){switch(h){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${h}`)}}e.$Ycc=S;class R{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new n.$ee,this.onStateChange=this.a.event,this.b=C.$TX.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$Zcc=R}),define(re[40],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,n.$wi)("IUriIdentityService")}),define(re[270],oe([0,1,40,210,16,19,142,3,2]),function(J,e,n,C,S,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;class c{static{this._clock=0}constructor(v){this.uri=v,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let d=class{constructor(v){this.g=v,this.c=new h.$Uc,this.f=2**16;const m=new Map,f=y=>{let p=m.get(y.scheme);return p===void 0&&(p=v.hasProvider(y)&&!this.g.hasCapability(y,1024),m.set(y.scheme,p)),p};this.c.add(E.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(y=>{m.delete(y.scheme)})),this.extUri=new R.$Yg(f),this.d=new j.$zs((y,p)=>this.extUri.compare(y,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,R.$$g)(v));const m=this.d.get(v);return m?m.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new c(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((f,y)=>f[1].time<y[1].time?1:f[1].time>y[1].time?-1:0);c._clock=0,this.d.clear();const m=this.f*.5;for(let f=0;f<m;f++)this.d.set(v[f][0],v[f][1].touch())}};e.$As=d,e.$As=d=Se([ie(0,S.$3k)],d),(0,C.$xs)(n.$Al,d,1)}),define(re[131],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KX=void 0,e.$KX=(0,n.$wi)("urlService")}),define(re[271],oe([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=e.$7cc=void 0;class C{constructor(E){this.a=E}listen(E,h){throw new Error(`Event not found: ${h}`)}call(E,h,c){switch(h){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${h}`)}}e.$7cc=C;class S{constructor(E){this.a=E}handleURL(E,h){return this.a.call("handleURL",[E.toJSON(),h])}}e.$8cc=S;class R{constructor(E,h){this.a=E,this.b=h}async routeCall(E,h,c,d){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(c)&&c.length>0){const b=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const v=/\bwindowId=(\d+)/.exec(b.query);if(v){const m=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${m}"`,b.toString(!0));const f=new RegExp(`window:${m}`),y=E.connections.find(p=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),f.test(p.ctx)));if(y)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),y;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,h,c,d)}routeEvent(E,h){throw new Error(`Event not found: ${h}`)}}e.$9cc=R}),define(re[272],oe([0,1,8,2,7,27]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MX=e.$LX=void 0;class j extends C.$Vc{constructor(){super(...arguments),this.a=new Set}open(c,d){const b=[...this.a.values()];return(0,n.$Ah)(b.map(v=>()=>v.handleURL(c,d)),void 0,!1).then(v=>v||!1)}registerHandler(c){return this.a.add(c),(0,C.$Tc)(()=>this.a.delete(c))}}e.$LX=j;let E=class extends j{constructor(c){super(),this.b=c}create(c){let{authority:d,path:b,query:v,fragment:m}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return d&&b&&b.indexOf("/")!==0&&(b=`/${b}`),S.URI.from({scheme:this.b.urlProtocol,authority:d,path:b,query:v,fragment:m})}};e.$MX=E,e.$MX=E=Se([ie(0,R.$jk)],E)}),define(re[273],oe([0,1,14,8,3,2,4,7]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class h extends R.$Vc{constructor(d,b,v,m,f,y){if(super(),this.c=b,this.f=y,this.a=[],this.b=0,d&&(y.trace("ElectronURLListener initialUrisToHandle:",d.map(l=>l.originalUrl)),this.a=d),j.$i){const l=m.isBuilt?[]:[`"${m.appRoot}"`];l.push("--open-url","--"),n.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,l)}const p=S.Event.map(S.Event.fromNodeEventEmitter(n.app,"open-url",(l,w)=>({event:l,url:w})),({event:l,url:w})=>(l.preventDefault(),w));this.B(p(l=>{const w=this.g(l);w&&this.c.open(w,{originalUrl:l})})),v.getWindows().filter(l=>l.isReady).length>0?(y.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(y.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(S.Event.once(v.onDidSignalReadyWindow)(()=>this.h())))}g(d){try{return E.URI.parse(d)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const d=[];for(const b of this.a)await this.c.open(b.uri,{originalUrl:b.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),d.push(b));d.length!==0&&(this.a=d,(0,C.$yh)(()=>this.h(),500,this.q))}}e.$0cc=h}),define(re[274],oe([0,1,3,2,16,59,32]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class E extends C.$Vc{constructor(c,d,b,v,m,f){super(),this.f=c,this.g=d,this.h=b,this.j=v,this.m=m,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$ee),this.onDidChangeFile=this.a.event,this.b=R.$Ci.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Cc(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(v.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,d){return this.g.open(this.t(c),d)}close(c){return this.g.close(c)}read(c,d,b,v,m){return this.g.read(c,d,b,v,m)}write(c,d,b,v,m){return this.g.write(c,d,b,v,m)}watch(c,d){this.b.set(c,c);const b=this.g.watch(this.t(c),d);return(0,C.$Tc)(()=>{this.b.delete(c),b.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,d,b){return this.g.rename(this.t(c),this.t(d),b)}readFile(c,d){return this.g.readFile(this.t(c),d)}readFileStream(c,d,b){return this.g.readFileStream(this.t(c),d,b)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,d,b){return this.g.writeFile(this.t(c),d,b)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,d){return this.g.delete(this.t(c),d)}copy(c,d,b){if((0,S.$7k)(this.g))return this.g.copy(this.t(c),this.t(d),b);throw new Error("copy not supported")}cloneFile(c,d){if((0,S.$8k)(this.g))return this.g.cloneFile(this.t(c),this.t(d));throw new Error("clone not supported")}s(c){const d=[];for(const b of c){if(b.resource.scheme!==this.f)continue;const v=this.u(b.resource);this.b.findSubstr(v)&&d.push({resource:v,type:b.type,cId:b.cId})}d.length&&(this.n.debug("User data changed"),this.a.fire(d))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Kdc=E}),define(re[275],oe([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0,e.$rdc="utilityProcessWorker"}),define(re[276],oe([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0,e.$$cc=(0,n.$wi)("webviewManagerService")}),define(re[277],oe([0,1,14,2,13,7]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;class j extends C.$Vc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);n.protocol.registerFileProtocol(S.Schemas.vscodeWebview,h)}b(h,c){try{const d=R.URI.parse(h.url),b=j.a.get(d.path);if(typeof b=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${b}`,m=S.$Qg.asFileUri(v);return c({path:m.fsPath,headers:{...S.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$_cc=j}),define(re[55],oe([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$uD=void 0,e.$vD=C,e.$wD=S,e.$xD=R,e.$yD=j,e.$zD=E,e.$AD=b,e.$BD=v,e.$CD=m,e.$DD=f,e.$ED=y,e.$FD=p,e.$uD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(g){return typeof g.parentId=="number"}function S(g){return!!g.workspaceUri}function R(g){return!!g.folderUri}function j(g){return!!g.fileUri}function E(g){const l=v(g),w=g.getValue("window.menuBarVisibility");return w==="default"||l&&w==="compact"||n.$j&&n.$m?"classic":w}var h;(function(g){g.TITLE_BAR_STYLE="window.titleBarStyle",g.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(h||(e.TitleBarSetting=h={}));var c;(function(g){g.NATIVE="native",g.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var d;(function(g){g.AUTO="auto",g.WINDOWED="windowed",g.NEVER="never"})(d||(e.CustomTitleBarVisibility=d={}));function b(g,l){return!0}function v(g,l){return l||(l=m(g)),l==="native"}function m(g){if(n.$o)return"custom";const l=g.getValue("window");if(l){if(n.$j&&l.nativeTabs===!0||n.$j&&l.nativeFullScreen===!1)return"native";const a=l.titleBarStyle;if(a==="native"||a==="custom")return a}return n.$k?"native":"custom"}function f(g){return!(!n.$i||n.$o||v(g))}function y(g){const l=g.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}function p(g=0){return Math.pow(1.2,g)}}),define(re[82],oe([0,1,14]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Cbc=e.$Bbc=e.UnloadReason=e.LoadReason=void 0;var C;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(C||(e.LoadReason=C={}));var S;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(S||(e.UnloadReason=S={}));const R=function(c=1){return{width:1024,height:768,mode:c}};e.$Bbc=R;const j=function(){const b=n.screen.getPrimaryDisplay().workArea,v=Math.max(b.x+b.width/2-800/2,0),m=Math.max(b.y+b.height/2-600/2,0);return{x:v,y:m,width:800,height:600,mode:1}};e.$Cbc=j;var E;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(E||(e.WindowMode=E={}));var h;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(h||(e.WindowError=h={}))}),define(re[278],oe([0,1,8,3,2]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;class R extends S.$Vc{constructor({onDidOpenMainWindow:E,onDidFocusMainWindow:h,getActiveWindowId:c}){super(),this.a=this.B(new S.$Uc),C.Event.latch(C.Event.any(E,h))(this.f,this,this.a),this.b=(0,n.$jh)(()=>c()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$fdc=R}),define(re[30],oe([0,1,195,9,59,19,7,6,13]),function(J,e,n,C,S,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=c,e.$Hi=d,e.$Ki=b,e.$Li=v,e.$Mi=m,e.$Ni=y,e.$Oi=p,e.$Ri=w,e.$Wi=k,e.$Xi=a,e.$Zi=t,e.$1i=r,e.$2i=s,e.$Fi=(0,E.$wi)("contextService");function c(i){const o=i;return typeof o?.id=="string"&&j.URI.isUri(o.uri)}function d(i){return typeof i?.id=="string"&&!c(i)&&!v(i)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function b(i,o){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,C.$oc)(i)}:o?e.$Ii:e.$Ji;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function v(i){const o=i;return typeof o?.id=="string"&&j.URI.isUri(o.configPath)}function m(i){const o=i;if(o?.uri)return{id:o.id,uri:j.URI.revive(o.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:j.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}var f;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function y(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}function p(i){const o=i;return!!(o&&typeof o=="object"&&j.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}class g{constructor(o,u,$,P,D){this.h=o,this.j=$,this.k=P,this.l=D,this.c=S.$Ci.forUris(this.l,()=>!0),this.folders=u}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=S.$Ci.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=g;class l{constructor(o,u){this.raw=u,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,R.$0g)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=l;function w(i){return new l({uri:i,index:0,name:(0,R.$6g)(i)},{uri:i.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,n.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function k(i,o){return R.$1g.isEqualOrParent(i,o.untitledWorkspacesHome)}function a(i){let o;return j.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===h.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Yi}function r(i,o){return!k(i,o)&&!a(i)}function s(i){return(typeof i=="string"?(0,C.$pc)(i):(0,R.$8g)(i))===e.$Ti}}),define(re[56],oe([0,1,14,8,46,48,2,72,4,21,169,119,6,5,27,30]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=e.$Jbc=void 0,e.$Jbc=(0,v.$wi)("dialogMainService");let p=class{constructor(l,w){this.d=l,this.e=w,this.a=new Map,this.b=new Map,this.c=new C.$Dh}pickFileFolder(l,w){return this.f({...l,pickFolders:!0,pickFiles:!0,title:(0,d.localize)(0,null)},w)}pickFolder(l,w){return this.f({...l,pickFolders:!0,title:(0,d.localize)(1,null)},w)}pickFile(l,w){return this.f({...l,pickFiles:!0,title:(0,d.localize)(2,null)},w)}pickWorkspace(l,w){const k=(0,d.localize)(3,null),a=(0,R.$Ew)((0,d.localize)(4,null)),t=y.$Ui;return this.f({...l,pickFiles:!0,title:k,filters:t,buttonLabel:a},w)}async f(l,w){const k={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters,defaultPath:l.defaultPath};(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(k.properties=void 0,l.pickFiles&&l.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&k.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(k,(w||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(l){if(l){let w=this.b.get(l.id);return w||(w=new C.$Dh,this.b.set(l.id,w)),w}else return this.c}showMessageBox(l,w){return this.g(w).queue(async()=>{const{options:k,buttonIndeces:a}=(0,b.$Lw)(l,this.e);let t;return w?t=await n.dialog.showMessageBox(w,k):t=await n.dialog.showMessageBox(k),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(l,w){const k=this.j(l,w);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(w).queue(async()=>{let a;return w?a=await n.dialog.showSaveDialog(w,l):a=await n.dialog.showSaveDialog(l),a.filePath=this.h(a.filePath),a})}finally{(0,j.$Qc)(k)}}h(l){return l&&h.$j&&(l=(0,E.$bm)(l)),l}i(l){return l.map(w=>this.h(w))}async showOpenDialog(l,w){l.defaultPath&&(await c.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const k=this.j(l,w);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(w).queue(async()=>{let a;return w?a=await n.dialog.showOpenDialog(w,l):a=await n.dialog.showOpenDialog(l),a.filePaths=this.i(a.filePaths),a})}finally{(0,j.$Qc)(k)}}j(l,w){if(!w)return j.$Vc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",l);let k=this.a.get(w.id);k||(k=new Set,this.a.set(w.id,k));const a=(0,S.$kj)(l);if(!k.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",l),k.add(a),(0,j.$Tc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",l),k?.delete(a),k?.size===0&&this.a.delete(w.id)})}};e.$Kbc=p,e.$Kbc=p=Se([ie(0,m.$3j),ie(1,f.$jk)],p)}),define(re[279],oe([0,1,3,2,77,30]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;class j extends C.$Vc{static{this.a=100}constructor(h,c){super(),this.f=h,this.g=c,this.b=this.B(new n.$ee),this.c=new Map,this.h(c.applicationStorage,this.b)}h(h,c){this.B(n.Event.debounce(h.onDidChangeStorage,(d,b)=>(d?d.push(b):d=[b],d),j.a)(d=>{d.length&&c.fire(this.j(d,h))}))}j(h,c){const d=new Map,b=new Set;return h.forEach(v=>{const m=c.get(v.key);typeof m=="string"?d.set(v.key,m):b.add(v.key)}),{changed:Array.from(d.entries()),deleted:Array.from(b.values())}}listen(h,c,d){switch(c){case"onDidChangeStorage":{const b=d.profile?(0,S.$6h)(d.profile):void 0;if(!b)return this.b.event;let v=this.c.get(b.id);return v||(v=this.B(new n.$ee),this.h(this.g.profileStorage(b),v),this.c.set(b.id,v)),v.event}}throw new Error(`Event not found: ${c}`)}async call(h,c,d){const b=d.profile?(0,S.$6h)(d.profile):void 0,v=(0,R.$Mi)(d.workspace),m=await this.m(b,v);switch(c){case"getItems":return Array.from(m.items.entries());case"updateItems":{const f=d;if(f.insert)for(const[y,p]of f.insert)m.set(y,p);f.delete?.forEach(y=>m.delete(y));break}case"optimize":return m.optimize();case"isUsed":{const f=d.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${c}`)}}async m(h,c){let d;c?d=this.g.workspaceStorage(c):h?d=this.g.profileStorage(h):d=this.g.applicationStorage;try{await d.init()}catch(b){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":h?"profile":"application"} storage due to ${b}`)}return d}}e.$Vcc=j}),define(re[41],oe([0,1,46,3,2,19,7,192,38,16,6,5,30,32,40,8,33,25,12]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=k,e.$Dl=a,e.$El=t;var w;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(w||(e.ProfileResourceType=w={}));function k(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&j.URI.isUri(o.location)&&j.URI.isUri(o.globalStorageHome)&&j.URI.isUri(o.settingsResource)&&j.URI.isUri(o.keybindingsResource)&&j.URI.isUri(o.tasksResource)&&j.URI.isUri(o.snippetsHome)&&j.URI.isUri(o.extensionsResource))}e.$Cl=(0,d.$wi)("IUserDataProfilesService");function a(i,o){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:j.URI.revive(i.location).with({scheme:o}),globalStorageHome:j.URI.revive(i.globalStorageHome).with({scheme:o}),settingsResource:j.URI.revive(i.settingsResource).with({scheme:o}),keybindingsResource:j.URI.revive(i.keybindingsResource).with({scheme:o}),tasksResource:j.URI.revive(i.tasksResource).with({scheme:o}),snippetsHome:j.URI.revive(i.snippetsHome).with({scheme:o}),extensionsResource:j.URI.revive(i.extensionsResource).with({scheme:o}),cacheHome:j.URI.revive(i.cacheHome).with({scheme:o}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,o,u,$,P,D){return{id:i,name:o,location:u,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:D&&P?.useDefaultFlags?.globalState?D.globalStorageHome:(0,R.$0g)(u,"globalStorage"),settingsResource:D&&P?.useDefaultFlags?.settings?D.settingsResource:(0,R.$0g)(u,"settings.json"),keybindingsResource:D&&P?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,R.$0g)(u,"keybindings.json"),tasksResource:D&&P?.useDefaultFlags?.tasks?D.tasksResource:(0,R.$0g)(u,"tasks.json"),snippetsHome:D&&P?.useDefaultFlags?.snippets?D.snippetsHome:(0,R.$0g)(u,"snippets"),extensionsResource:D&&P?.useDefaultFlags?.extensions?D.extensionsResource:(0,R.$0g)(u,"extensions.json"),cacheHome:(0,R.$0g)($,i),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let r=class extends S.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(o,u,$,P){super(),this.t=o,this.u=u,this.w=$,this.y=P,this.f=!0,this.h=this.B(new C.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new m.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(o){this.f!==o&&(this.z=void 0,this.f=o)}isEnabled(){return this.f}get C(){if(!this.z){const o=this.D(),u=[o];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,l.$9f)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}u.push(t((0,R.$7g)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},o))}}catch(D){this.y.error(D)}const $=new m.$Bc,P=new Map;if(u.length)try{const D=this.Q();if(D.workspaces)for(const[I,O]of Object.entries(D.workspaces)){const M=j.URI.parse(I),W=u.find(F=>F.id===O);W&&$.set(M,W)}if(D.emptyWindows)for(const[I,O]of Object.entries(D.emptyWindows)){const M=u.find(W=>W.id===O);M&&P.set(I,M)}}catch(D){this.y.error(D)}this.z={profiles:u,workspaces:$,emptyWindows:P}}return this.z}D(){const o=t("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...o,extensionsResource:this.S()??o.extensionsResource,isDefault:!0}}async createTransientProfile(o){const u="Temp",$=new RegExp(`${(0,g.$af)(u)}\\s(\\d+)`);let P=0;for(const I of this.profiles){const O=$.exec(I.name),M=O?parseInt(O[1]):0;P=M>P?M:P}const D=`${u} ${P+1}`;return this.createProfile((0,n.$kj)((0,p.$Sg)()).toString(16),D,{transient:!0},o)}async createNamedProfile(o,u,$){return this.createProfile((0,n.$kj)((0,p.$Sg)()).toString(16),o,u,$)}async createProfile(o,u,$,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(o,u,$);return P&&await this.setProfileForWorkspace(P,D),D}async F(o,u,$){if(!(0,l.$9f)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(u);return P||(P=(async()=>{try{if(this.profiles.find(M=>M.name===u||M.id===o))throw new Error(`Profile with ${u} name already exists`);const I=t(o,u,(0,R.$0g)(this.profilesHome,o),this.g,$,this.defaultProfile);await this.u.createFolder(I.location);const O=[];return this.j.fire({profile:I,join(M){O.push(M)}}),await y.Promises.settled(O),this.I([I],[],[]),I}finally{this.r.delete(u)}})(),this.r.set(u,P)),P}async updateProfile(o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let $=this.profiles.find(P=>P.id===o.id);if(!$)throw new Error(`Profile '${o.name}' does not exist`);return $=t($.id,u.name??$.name,$.location,this.g,{shortName:u.shortName??$.shortName,icon:u.icon===null?void 0:u.icon??$.icon,transient:u.transient??$.isTransient,useDefaultFlags:u.useDefaultFlags??$.useDefaultFlags},this.defaultProfile),this.I([],[],[$]),$}async removeProfile(o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(o.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(P=>P.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);const $=[];this.m.fire({profile:u,join(P){$.push(P)}});try{await Promise.allSettled($)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(P){(0,c.$hl)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=this.profiles.find(P=>P.id===u.id);if(!$)throw new Error(`Profile '${u.name}' does not exist`);this.L(o,$)}unsetWorkspace(o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(o,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const o=await this.u.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(u=>u.isDirectory&&this.profiles.every($=>!this.w.extUri.isEqual($.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(o.map(u=>this.removeProfile(u)))}getProfileForWorkspace(o){const u=this.G(o);return j.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(o){return(0,v.$Gi)(o)?o.uri:(0,v.$Li)(o)?o.configPath:o.id}H(o){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,o.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,o.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,o.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,o.location)))}I(o,u,$){const P=[...this.profiles,...o],D=[];this.s.profiles=[];for(let I of P)I.isDefault||u.some(O=>I.id===O.id)||(I=$.find(O=>I.id===O.id)??I,I.isTransient?this.s.profiles.push(I):D.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags}));this.P(D),this.z=void 0,this.J(o,u,$)}J(o,u,$){this.h.fire({added:o,removed:u,updated:$,all:this.profiles})}L(o,u,$){$=u?.isTransient?!0:$,$||this.L(o,void 0,!0);const P=this.G(o),D=$?this.s:this.C;j.URI.isUri(P)?(D.workspaces.delete(P),u&&D.workspaces.set(P,u)):(D.emptyWindows.delete(P),u&&D.emptyWindows.set(P,u)),$||this.M()}M(){const o={};for(const[$,P]of this.C.workspaces.entries())o[$.toString()]=P.id;const u={};for(const[$,P]of this.C.emptyWindows.entries())u[$.toString()]=P.id;this.R({workspaces:o,emptyWindows:u}),this.z=void 0}N(o){const u={},$=this.D();if(o.workspaces)for(const[D,I]of Object.entries(o.workspaces)){const O=j.URI.parse(I);u[D]=this.w.extUri.isEqual(O,$.location)?$.id:this.w.extUri.basename(O)}const P={};if(o.emptyWindows)for(const[D,I]of Object.entries(o.emptyWindows)){const O=j.URI.parse(I);P[D]=this.w.extUri.isEqual(O,$.location)?$.id:this.w.extUri.basename(O)}return{workspaces:u,emptyWindows:P}}O(){return[]}P(o){throw new Error("not implemented")}Q(){return{}}R(o){throw new Error("not implemented")}S(){}};e.$Fl=r,e.$Fl=r=Se([ie(0,h.$Di),ie(1,c.$3k),ie(2,f.$Al),ie(3,b.$3j)],r);class s extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(o){this.a=o}Q(){return this.X}R(o){this.X=o}}e.$Gl=s}),define(re[83],oe([0,1,8,17,2,3,32,7,121,127,16,6,5,41,40,12,15,28]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=e.$oq=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class w extends Error{constructor(s,i){super(s),this.code=i}}e.$oq=w,e.$pq=(0,b.$wi)("IExtensionsProfileScannerService");let k=class extends S.$Vc{constructor(s,i,o,u,$,P){super(),this.j=s,this.m=i,this.n=o,this.r=u,this.s=$,this.t=P,this.b=this.B(new R.$ee),this.onAddExtensions=this.b.event,this.c=this.B(new R.$ee),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.$ee),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.$ee),this.onDidRemoveExtensions=this.g.event,this.h=new j.$Bc}scanProfileExtensions(s,i){return this.u(s,void 0,i)}async addExtensionsToProfile(s,i,o){const u=[],$=[];try{return await this.u(i,P=>{const D=[];if(o)D.push(...P);else for(const I of P)s.some(([O])=>(0,c.$up)(O.identifier,I.identifier)&&O.manifest.version!==I.version)?u.push(I):D.push(I);for(const[I,O]of s){const M=D.findIndex(F=>(0,c.$up)(F.identifier,I.identifier)&&F.version===I.manifest.version),W={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:O};M===-1?($.push(W),D.push(W)):D.splice(M,1,W)}return $.length&&this.b.fire({extensions:$,profileLocation:i}),u.length&&this.f.fire({extensions:u,profileLocation:i}),D}),$.length&&this.c.fire({extensions:$,profileLocation:i}),u.length&&this.g.fire({extensions:u,profileLocation:i}),$}catch(P){throw $.length&&this.c.fire({extensions:$,error:P,profileLocation:i}),u.length&&this.g.fire({extensions:u,error:P,profileLocation:i}),P}}async updateMetadata(s,i){const o=[];return await this.u(i,u=>{const $=[];for(const P of u){const D=s.find(([I])=>(0,c.$up)(I.identifier,P.identifier)&&I.manifest.version===P.version);D&&(P.metadata={...P.metadata,...D[1]},o.push(P)),$.push(P)}return $}),o}async removeExtensionFromProfile(s,i){const o=[];try{await this.u(i,u=>{const $=[];for(const P of u)(0,c.$up)(P.identifier,s.identifier)?o.push(P):$.push(P);return o.length&&this.f.fire({extensions:o,profileLocation:i}),$}),o.length&&this.g.fire({extensions:o,profileLocation:i})}catch(u){throw o.length&&this.g.fire({extensions:o,error:u,profileLocation:i}),u}}async u(s,i,o){return this.F(s).queue(async()=>{let u=[],$;try{const P=await this.m.readFile(s);$=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,d.$hl)(P)!==1)throw P;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&($=await this.D()),!$&&o?.bailOutWhenFileNotFound)throw new w((0,p.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if($){Array.isArray($)||this.w(s);let P=!1;for(const D of $){a(D)||this.w(s);let I;if((0,y.$9f)(D.relativeLocation)&&D.relativeLocation)I=this.z(D.relativeLocation);else if((0,y.$9f)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{I=E.URI.revive(D.location);const O=this.y(I);O&&(P=!0,D.relativeLocation=O)}(0,y.$dg)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(P=!0,D.metadata.hasPreReleaseVersion=!0),u.push({identifier:D.identifier,location:I,version:D.version,metadata:D.metadata})}P&&await this.m.writeFile(s,C.$Ge.fromString(JSON.stringify($)))}if(i){u=i(u);const P=u.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(s,C.$Ge.fromString(JSON.stringify(P)))}return u})}w(s){const i=new w(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let o;try{o=(await this.m.readFile(s)).value.toString()}catch($){if((0,d.$hl)($)===1)return;throw $}this.t.info("Migrating extensions from old default profile location",s.toString());let u;try{const $=JSON.parse(o);Array.isArray($)&&$.every(P=>a(P))?u=$:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",$)}catch($){this.t.error($)}if(u)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,C.$Ge.fromString(JSON.stringify(u)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch($){if((0,d.$hl)($)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw $}try{await this.m.del(s)}catch($){(0,d.$hl)($)!==1&&this.t.error($)}try{await this.m.del(i)}catch($){(0,d.$hl)($)!==1&&this.t.error($)}return u})()),this.C}F(s){let i=this.h.get(s);return i||(i=new n.$Dh,this.h.set(s,i)),i}};e.$qq=k,e.$qq=k=Se([ie(1,d.$3k),ie(2,m.$Cl),ie(3,f.$Al),ie(4,g.$2l),ie(5,v.$3j)],k);function a(r){return(0,y.$$f)(r)&&(0,h.$5o)(r.identifier)&&(t(r.location)||(0,y.$9f)(r.location)&&r.location)&&((0,y.$dg)(r.relativeLocation)||(0,y.$9f)(r.relativeLocation))&&r.version&&(0,y.$9f)(r.version)}function t(r){return r?(0,y.$9f)(r.path)&&(0,y.$9f)(r.scheme):!1}}),define(re[132],oe([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,74,12,7,174,38,127,124,207,16,6,5,27,3,77,83,41,40,206]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k,a,t,r,s,i,o,u,$,P,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$vq=e.$uq=e.$tq=e.Translations=void 0,e.$wq=ue;var M;(function(ce){function K(G,B){if(G===B)return!0;const L=Object.keys(G),z=new Set;for(const Q of Object.keys(B))z.add(Q);if(L.length!==z.size)return!1;for(const Q of L){if(G[Q]!==B[Q])return!1;z.delete(Q)}return z.size===0}ce.equals=K})(M||(e.Translations=M={})),e.$tq=(0,s.$wi)("IExtensionsScannerService");let W=class extends c.$Vc{constructor(K,G,B,L,z,Q,ae,x,le,Z,A,N){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=G,this.r=B,this.s=L,this.t=z,this.u=Q,this.w=ae,this.y=x,this.z=le,this.C=Z,this.D=A,this.F=N,this.g=this.B(new u.$ee),this.onDidChangeCache=this.g.event,this.h=(0,m.$0g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,k.$Fp)(this.w,this.y)),this.G}async scanAllExtensions(K,G,B){const[L,z]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(G)]),Q=B?await this.scanExtensionsUnderDevelopment(K,[...L,...z]):[];return this.L(L,z,Q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const G=[];G.push(this.M(!!K.useCache,K.language)),G.push(this.N(K.language,!!K.checkControlFile));const[B,L]=await Promise.all(G);return this.J([...B,...L],0,K,!1)}async scanUserExtensions(K){const G=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",G);const B=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(G,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,B,K.productVersion??this.R()),z=K.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let Q;try{Q=await z.scanExtensions(L)}catch(ae){if(ae instanceof P.$oq&&ae.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Q=await z.scanExtensions(L);else throw ae}return Q=await this.J(Q,1,K,!0),this.y.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(K,G){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===d.Schemas.file).map(async L=>{const z=await this.P(L,!1,1,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(z)).map(ae=>(ae.type=G.find(x=>(0,k.$up)(x.identifier,ae.identifier))?.type??ae.type,this.n.validate(ae,z)))}))).flat();return this.J(B,"development",K,!0)}return[]}async scanExistingExtension(K,G,B){const L=await this.P(K,!1,G,!0,B.language,!0,void 0,B.productVersion??this.R()),z=await this.n.scanExtension(L);return!z||!B.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(K,G,B){const L=await this.P(K,!1,G,!0,B.language,!0,void 0,B.productVersion??this.R()),z=await this.n.scanOneOrMultipleExtensions(L);return this.J(z,G,B,!0)}async scanMultipleExtensions(K,G,B){const L=[];return await Promise.all(K.map(async z=>{const Q=await this.scanOneOrMultipleExtensions(z,G,B);L.push(...Q)})),this.J(L,G,B,!0)}async scanMetadata(K){const G=(0,m.$0g)(K,"package.json"),B=(await this.w.readFile(G)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(K,G){const B=(0,m.$0g)(K,"package.json"),L=(await this.w.readFile(B)).value.toString(),z=JSON.parse(L);G.isMachineScoped===!1&&delete G.isMachineScoped,G.isBuiltin===!1&&delete G.isBuiltin,z.__metadata={...z.__metadata,...G},await this.w.writeFile((0,m.$0g)(K,"package.json"),R.$Ge.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof P.$oq&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(G=>[G,G.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,R.$Ge.fromString(JSON.stringify([])))}catch(G){(0,r.$hl)(G)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$0)(G))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,G,B,L){return B.includeAllVersions||(K=this.L(G===0?K:void 0,G===1?K:void 0,G==="development"?K:void 0,await this.getTargetPlatform(),L)),B.includeInvalid||(K=K.filter(z=>z.isValid)),K.sort((z,Q)=>{const ae=b.$oc(z.location.fsPath),x=b.$oc(Q.location.fsPath);return ae<x?-1:ae>x?1:0})}L(K,G,B,L,z){const Q=(x,le,Z)=>{if(x.isValid&&!le.isValid)return!1;if(x.isValid===le.isValid){if(z&&f.gt(x.manifest.version,le.manifest.version))return this.y.debug(`Skipping extension ${le.location.path} with lower version ${le.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(f.eq(x.manifest.version,le.manifest.version)){if(x.type===0)return this.y.debug(`Skipping extension ${le.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===L)return this.y.debug(`Skipping extension ${le.location.path} from different target platform ${le.targetPlatform}`),!1}}return Z?this.y.warn(`Overwriting user extension ${x.location.path} with ${le.location.path}.`):this.y.debug(`Overwriting user extension ${x.location.path} with ${le.location.path}.`),!0},ae=new a.$Tm;return K?.forEach(x=>{const le=ae.get(x.identifier.id);(!le||Q(le,x,!1))&&ae.set(x.identifier.id,x)}),G?.forEach(x=>{const le=ae.get(x.identifier.id);if(!le&&K&&x.type===0){this.y.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!le||Q(le,x,!1))&&ae.set(x.identifier.id,x)}),B?.forEach(x=>{const le=ae.get(x.identifier.id);(!le||Q(le,x,!0))&&ae.set(x.identifier.id,x),ae.set(x.identifier.id,x)}),[...ae.values()]}async M(K,G){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0,this.R()),z=await(K&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",z.length),z}async N(K,G){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const L=G?await this.O():{},z=[],Q=g.URI.file(b.$ic(b.$kc(d.$Qg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of B){const le=L[x.name]||"marketplace";switch(le){case"disabled":break;case"marketplace":z.push((0,m.$0g)(Q,x.name));break;default:z.push(g.URI.file(le));break}}const ae=await Promise.all(z.map(async x=>this.n.scanExtension(await this.P(x,!1,0,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ae.length),(0,n.$Hb)(ae)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,G,B,L,z,Q,ae,x){const le=await this.f(z??v.$w),Z=await this.Q(K),A=G&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,N=A?await this.Q(A):void 0;return new F(K,Z,A,N,G,ae,B,L,Q,x.version,x.date,this.C.commit,!this.z.isBuilt,z,le)}async Q(K){try{const G=await this.w.stat(K);if(typeof G.mtime=="number")return G.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$uq=W,e.$uq=W=Se([ie(4,D.$Cl),ie(5,P.$pq),ie(6,r.$3k),ie(7,i.$3j),ie(8,w.$Di),ie(9,o.$jk),ie(10,I.$Al),ie(11,s.$vi)],W);class F{constructor(K,G,B,L,z,Q,ae,x,le,Z,A,N,_,ne,X){this.location=K,this.mtime=G,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=L,this.profile=z,this.profileScanOptions=Q,this.type=ae,this.excludeObsolete=x,this.validate=le,this.productVersion=Z,this.productDate=A,this.productCommit=N,this.devMode=_,this.language=ne,this.translations=X}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,G){return(0,m.$3g)(K.location,G.location)&&K.mtime===G.mtime&&(0,m.$3g)(K.applicationExtensionslocation,G.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&K.profile===G.profile&&S.$7n(K.profileScanOptions,G.profileScanOptions)&&K.type===G.type&&K.excludeObsolete===G.excludeObsolete&&K.validate===G.validate&&K.productVersion===G.productVersion&&K.productDate===G.productDate&&K.productCommit===G.productCommit&&K.devMode===G.devMode&&K.language===G.language&&M.equals(K.translations,G.translations)}}e.$vq=F;let T=class extends c.$Vc{constructor(K,G,B,L,z){super(),this.f=K,this.g=G,this.h=B,this.j=L,this.m=z}async scanExtensions(K){const G=K.profile?await this.r(K):await this.n(K);let B={};if(K.excludeObsolete&&K.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(L)}catch{}return(0,p.$jg)(B)?G:G.filter(L=>!B[k.$vp.create(L).toString()])}async n(K){const G=await this.j.resolve(K.location);if(!G.children?.length)return[];const B=await Promise.all(G.children.map(async L=>{if(!L.isDirectory||K.type===1&&(0,m.$7g)(L.resource).indexOf(".")===0)return null;const z=new F(L.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(z)}));return(0,n.$Hb)(B).sort((L,z)=>L.location.path<z.location.path?-1:1)}async r(K){let G=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){G=G.filter(L=>!L.metadata?.isApplicationScoped);const B=await this.s(K.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,K);G.push(...B)}return G}async s(K,G,B){const L=await this.g.scanProfileExtensions(K,B.profileScanOptions);if(!L.length)return[];const z=await Promise.all(L.map(async Q=>{if(G(Q)){const ae=new F(Q.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(ae,Q.metadata)}return null}));return(0,n.$Hb)(z)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,m.$0g)(K.location,"package.json"))){const G=await this.scanExtension(K);return G?[G]:[]}else return await this.scanExtensions(K)}catch(G){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,j.$0)(G)),[]}}async scanExtension(K,G){try{let B=await this.scanExtensionManifest(K.location);if(B){B.publisher||(B.publisher=a.$Nm),G=G??B.__metadata,delete B.__metadata;const L=(0,k.$zp)(B.publisher,B.name),z=G?.id?{id:L,uuid:G.id}:{id:L},Q=G?.isSystem?0:K.type,ae=Q===0||!!G?.isBuiltin;B=await this.t(K.location,B,F.createNlsConfiguration(K));const x={type:Q,identifier:z,manifest:B,location:K.location,isBuiltin:ae,targetPlatform:G?.targetPlatform??"undefined",publisherDisplayName:G?.publisherDisplayName,metadata:G,isValid:!0,validations:[]};return K.validate?this.validate(x,K):x}}catch(B){K.type!==0&&this.m.error(B)}return null}validate(K,G){let B=!0;const L=(0,t.$Kp)(G.productVersion,G.productDate,G.location,K.manifest,K.isBuiltin);for(const[z,Q]of L)z===y.default.Error&&(B=!1,this.m.error(this.z(G.location,Q)));return K.isValid=B,K.validations=L,K}async scanExtensionManifest(K){const G=(0,m.$0g)(K,"package.json");let B;try{B=(await this.j.readFile(G)).value.toString()}catch(z){return(0,r.$hl)(z)!==1&&this.m.error(this.z(K,(0,l.localize)(0,null,G.path,z.message))),null}let L;try{L=JSON.parse(B)}catch{const Q=[];(0,E.$Jn)(B,Q);for(const ae of Q)this.m.error(this.z(K,(0,l.localize)(1,null,G.path,ae.offset,ae.length,(0,h.$rq)(ae.error))));return null}return(0,E.$Sn)(L)!=="object"?(this.m.error(this.z(K,(0,l.localize)(2,null,G.path))),null):L}async t(K,G,B){const L=await this.u(K,G,B);if(L)try{const z=[],Q=await this.w(L.default,z);if(z.length>0)return z.forEach(x=>{this.m.error(this.z(K,(0,l.localize)(3,null,L.default?.path,(0,h.$rq)(x.error))))}),G;if((0,E.$Sn)(L)!=="object")return this.m.error(this.z(K,(0,l.localize)(4,null,L.default?.path))),G;const ae=L.values||Object.create(null);return(0,O.$sq)(this.m,G,ae,Q)}catch{}return G}async u(K,G,B){const L=(0,m.$0g)(K,"package.nls.json"),z=(le,Z)=>{Z.forEach(A=>{this.m.error(this.z(K,(0,l.localize)(5,null,le?.path,(0,h.$rq)(A.error))))})},Q=le=>{this.m.error(this.z(K,(0,l.localize)(6,null,le?.path)))},ae=`${G.publisher}.${G.name}`,x=B.translations[ae];if(x)try{const le=g.URI.file(x),Z=(await this.j.readFile(le)).value.toString(),A=[],N=(0,E.$Jn)(Z,A);return A.length>0?(z(le,A),{values:void 0,default:L}):(0,E.$Sn)(N)!=="object"?(Q(le),{values:void 0,default:L}):{values:N.contents?N.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let Z;try{Z=await this.y(K,B)}catch{return}if(!Z.localized)return{values:void 0,default:Z.original};try{const A=(await this.j.readFile(Z.localized)).value.toString(),N=[],_=(0,E.$Jn)(A,N);return N.length>0?(z(Z.localized,N),{values:void 0,default:Z.original}):(0,E.$Sn)(_)!=="object"?(Q(Z.localized),{values:void 0,default:Z.original}):{values:_,default:Z.original}}catch{return{values:void 0,default:Z.original}}}}async w(K,G){if(K)try{const B=(await this.j.readFile(K)).value.toString();return(0,E.$Jn)(B,G)}catch{}}y(K,G){return new Promise((B,L)=>{const z=Q=>{const ae=(0,m.$0g)(K,`package.nls.${Q}.json`);this.j.exists(ae).then(x=>{x&&B({localized:ae,original:(0,m.$0g)(K,"package.nls.json")});const le=Q.lastIndexOf("-");le===-1?B({localized:(0,m.$0g)(K,"package.nls.json"),original:null}):(Q=Q.substring(0,le),z(Q))})};if(G.devMode||G.pseudo||!G.language)return B({localized:(0,m.$0g)(K,"package.nls.json"),original:null});z(G.language)})}z(K,G){return`[${K.path}]: ${G}`}};T=Se([ie(1,P.$pq),ie(2,I.$Al),ie(3,r.$3k),ie(4,i.$3j)],T);let q=class extends T{constructor(K,G,B,L,z,Q,ae){super(G,L,z,Q,ae),this.G=K,this.H=B,this.D=this.B(new C.$uh(3e3)),this.F=this.B(new u.$ee),this.onDidChangeCache=this.F.event}async scanExtensions(K){const G=this.M(K),B=await this.I(G);if(this.C=K,B&&B.input&&F.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",K.location.toString()),this.D.trigger(()=>this.L()),B.result.map(z=>(z.location=g.URI.revive(z.location),z));const L=await super.scanExtensions(K);return await this.J(G,{input:K,result:L}),L}async I(K){try{const G=await this.j.readFile(K),B=JSON.parse(G.value.toString());return{result:B.result,input:(0,$.$6h)(B.input)}}catch(G){this.m.debug("Error while reading the extension cache file:",K.path,(0,j.$0)(G))}return null}async J(K,G){try{await this.j.writeFile(K,R.$Ge.fromString(JSON.stringify(G)))}catch(B){this.m.debug("Error while writing the extension cache file:",K.path,(0,j.$0)(B))}}async L(){if(!this.C)return;const K=this.M(this.C),G=await this.I(K);if(!G)return;const B=G.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$7n(L,B))try{this.m.info("Invalidating Cache",B,L),await this.j.del(K),this.F.fire()}catch(z){this.m.error(z)}}M(K){const G=this.N(K);return this.h.extUri.joinPath(G.cacheHome,K.type===0?a.$Mm:a.$Lm)}N(K){return K.type===0?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(G=>this.h.extUri.isEqual(K.location,G.extensionsResource))??this.G:this.H.defaultProfile}};q=Se([ie(2,D.$Cl),ie(3,P.$pq),ie(4,I.$Al),ie(5,r.$3k),ie(6,i.$3j)],q);function ue(ce,K){const G=(0,k.$xp)(ce.manifest.publisher,ce.manifest.name);return{id:G,identifier:new a.$Rm(G),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:K,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class ee extends W{constructor(K,G,B,L,z,Q,ae,x,le,Z,A,N){super(K,G,(0,m.$0g)(B,".vscode-oss-dev","extensions","control.json"),L,z,Q,ae,x,le,Z,A,N),this.S=(async()=>{if(v.$z)try{const _=await this.w.readFile(g.URI.file(v.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$xq=ee}),define(re[280],oe([0,1,5,41,40,28,83,16,38,7]),function(J,e,n,C,S,R,j,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NQ=void 0;let d=class extends j.$qq{constructor(v,m,f,y,p,g){super(c.URI.file(v.extensionsPath),m,f,y,p,g)}};e.$NQ=d,e.$NQ=d=Se([ie(0,h.$Ei),ie(1,E.$3k),ie(2,C.$Cl),ie(3,S.$Al),ie(4,R.$2l),ie(5,n.$3j)],d)}),define(re[281],oe([0,1,7,38,83,132,16,6,5,27,40,41]),function(J,e,n,C,S,R,j,E,h,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;let v=class extends R.$xq{constructor(f,y,p,g,l,w,k,a){super(n.URI.file(l.builtinExtensionsPath),n.URI.file(l.extensionsPath),l.userHome,f.defaultProfile,f,y,p,g,l,w,k,a)}};e.$jdc=v,e.$jdc=v=Se([ie(0,b.$Cl),ie(1,S.$pq),ie(2,j.$3k),ie(3,h.$3j),ie(4,C.$Ei),ie(5,c.$jk),ie(6,d.$Al),ie(7,E.$vi)],v)}),define(re[282],oe([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;let f=class extends C.$Vc{constructor(p,g,l){super(),this.c=p,this.f=l,this.a=E.$Ci.forPaths(!j.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:S.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:p}=n.session;p.protocol.registerFileProtocol(S.Schemas.vscodeFileResource,(g,l)=>this.j(g,l)),p.protocol.interceptFileProtocol(S.Schemas.file,(g,l)=>this.h(g,l)),this.B((0,C.$Tc)(()=>{p.protocol.unregisterProtocol(S.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(S.Schemas.file)}))}addValidFileRoot(p){const g=(0,R.$ic)(p);return this.a.get(g)?C.$Vc.None:(this.a.set(g,!0),(0,C.$Tc)(()=>this.a.delete(g)))}h(p,g){const l=h.URI.parse(p.url);return this.f.error(`Refused to load resource ${l.fsPath} from ${S.Schemas.file}: protocol (original URL: ${p.url})`),g({error:-3})}j(p,g){const l=this.m(p);let w;return this.c.crossOriginIsolated&&((0,R.$oc)(l)==="workbench.html"||(0,R.$oc)(l)==="workbench-dev.html"?w=S.COI.CoopAndCoep:w=S.COI.getHeadersFromQuery(p.url)),this.a.findSubstr(l)?g({path:l,headers:w}):this.b.has((0,R.$pc)(l).toLowerCase())?g({path:l}):(this.f.error(`${S.Schemas.vscodeFileResource}: Refused to load resource ${l} from ${S.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),g({error:-3}))}m(p){const g=h.URI.parse(p.url),l=S.$Qg.uriToFileUri(g);return(0,R.$ic)(l.fsPath)}createIPCObjectUrl(){let p;const g=h.URI.from({scheme:"vscode",path:(0,c.$Sg)()}),l=g.toString(),w=async()=>p;return d.$VW.handle(l,w),this.f.trace(`IPC Object URL: Registered new channel ${l}.`),{resource:g,update:k=>p=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${l}.`),d.$VW.removeHandler(l)}}}};e.$Bdc=f,e.$Bdc=f=Se([ie(0,b.$Ei),ie(1,m.$Cl),ie(2,v.$3j)],f)}),define(re[97],oe([0,1,8,3,2,66,12,115,6,41]),function(J,e,n,C,S,R,j,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=m,e.$4p=y,e.$6p=g,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,h.$wi)("storageService");var d;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(d||(e.WillSaveStateReason=d={}));var b;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var v;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function m(l){const w=l.get(e.$Zp);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}class f extends S.$Vc{static{this.a=60*1e3}constructor(w={flushInterval:f.a}){super(),this.m=w,this.b=this.B(new C.$he),this.c=this.B(new C.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(w,k,a){return C.Event.filter(this.b.event,t=>t.scope===w&&(k===void 0||t.key===k),a)}n(){this.j.value=(0,n.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(w,k){const{key:a,external:t}=k;if(a===e.$Zp){switch(w){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:a,target:this.J(w)[a],external:t})}w(w){this.f.fire({reason:w})}get(w,k,a){return this.P(k)?.get(w,a)}getBoolean(w,k,a){return this.P(k)?.getBoolean(w,a)}getNumber(w,k,a){return this.P(k)?.getNumber(w,a)}getObject(w,k,a){return this.P(k)?.getObject(w,a)}storeAll(w,k){this.y(()=>{for(const a of w)this.store(a.key,a.value,a.scope,a.target,k)})}store(w,k,a,t,r=!1){if((0,j.$fg)(k)){this.remove(w,a,r);return}this.y(()=>{this.z(w,a,t),this.P(a)?.set(w,k,r)})}remove(w,k,a=!1){this.y(()=>{this.z(w,k,void 0),this.P(k)?.delete(w,a)})}y(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,k){const a=[],t=this.J(w);for(const r of Object.keys(t))t[r]===k&&a.push(r);return a}z(w,k,a,t=!1){const r=this.J(k);typeof a=="number"?r[w]!==a&&(r[w]=a,this.P(k)?.set(e.$Zp,JSON.stringify(r),t)):typeof r[w]=="number"&&(delete r[w],this.P(k)?.set(e.$Zp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(w){switch(w){case-1:return this.I;case 0:return this.G;default:return this.D}}L(w){const k=this.P(w);return k?m(k):Object.create(null)}isNew(w){return this.getBoolean(e.$Yp,w)===!0}async flush(w=d.NONE){this.f.fire({reason:w});const k=this.P(-1),a=this.P(0),t=this.P(1);switch(w){case d.NONE:await n.Promises.settled([k?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case d.SHUTDOWN:await n.Promises.settled([k?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.P(-1)?.items??new Map,k=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return g(w,k,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(w){return await this.flush(),this.P(w)?.optimize()}async switch(w,k){return this.w(d.NONE),(0,c.$Bl)(w)?this.R(w,k):this.S(w,k)}M(w,k){return!(w.id===k.id||y(k)&&y(w))}N(w,k,a){this.y(()=>{const t=new Set;for(const[r,s]of w)t.add(r),k.get(r)!==s&&this.u(a,{key:r,external:!0});for(const[r]of k.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$3p=f;function y(l){return l.isDefault||!!l.useDefaultFlags?.globalState}class p extends f{constructor(){super(),this.U=this.B(new E.$Wp(new E.$Xp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Wp(new E.$Xp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Wp(new E.$Xp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(w=>this.u(1,w))),this.B(this.W.onDidChangeStorage(w=>this.u(0,w))),this.B(this.U.onDidChangeStorage(w=>this.u(-1,w)))}P(w){switch(w){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(w){return!1}}e.$5p=p;async function g(l,w,k,a,t,r){const s=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,o=new Map;l.forEach((M,W)=>{i.set(W,M),o.set(W,s(M))});const u=new Map,$=new Map;w.forEach((M,W)=>{u.set(W,M),$.set(W,s(M))});const P=new Map,D=new Map;k.forEach((M,W)=>{P.set(W,M),D.set(W,s(M))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const I=[];if(i.forEach((M,W)=>{I.push({key:W,value:M})}),console.table(I),console.groupEnd(),console.log(o),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];u.forEach((W,F)=>{M.push({key:F,value:W})}),console.table(M),console.groupEnd(),console.log($)}console.group(`Storage: Workspace (path: ${r})`);const O=[];P.forEach((M,W)=>{O.push({key:W,value:M})}),console.table(O),console.groupEnd(),console.log(D)}}),define(re[283],oe([0,1,22,8,3,2,9,73,7,21,115,163,5,97,28,30,13]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=e.$_bc=e.$$bc=e.$0bc=void 0;class g extends R.$Vc{static{this.a=2e3}get storage(){return this.f}constructor(s,i){super(),this.m=s,this.n=i,this.b=this.B(new S.$ee),this.onDidChangeStorage=this.b.event,this.c=this.B(new S.$ee),this.onDidCloseStorage=this.c.event,this.f=this.B(new d.$Wp(new d.$Xp,{hint:d.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new C.$Th,this.whenInit=this.h.p,this.j=d.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===d.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(o=>this.b.fire(o))),await this.s(s);const i=s.getBoolean(m.$Yp);i===void 0?s.set(m.$Yp,!0):i&&s.set(m.$Yp,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=d.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===v.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,i){return this.f.get(s,i)}set(s,i){return this.f.set(s,i)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new E.$ae(!1);await this.w(),s.stop(),s.elapsed()>g.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const i=(0,n.top)(Array.from(this.f.items.entries()).map(([u,$])=>({key:u,length:$.length})),(u,$)=>$.length-u.length,5).map(u=>`${u.key}:${u.length}`).join(", "),o=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${o}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=d.StorageState.Closed,await this.f.close()}}class l extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,j.$kc)(this.z.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,l.y)}constructor(s,i,o,u){super(o,u),this.z=s,this.C=i}async t(){return new d.$Wp(new b.$oX(this.path??b.$oX.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:d.StorageHint.STORAGE_IN_MEMORY})}}class w extends l{constructor(s,i,o,u){super(s,i,o,u)}}e.$0bc=w;class k extends l{constructor(s,i,o,u){super(i.defaultProfile,s,o,u)}async s(s){await super.s(s),this.G(s)}G(s){s.get(f.$5l,void 0)===void 0&&s.set(f.$5l,new Date().toUTCString());const o=s.get(f.$4l,void 0),u=new Date().toUTCString();s.set(f.$6l,typeof o>"u"?null:o),s.set(f.$4l,u)}}e.$$bc=k;class a extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,j.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id,a.y)}constructor(s,i,o,u,$){super(o,$),this.C=s,this.D=i,this.F=u}async t(){const{storageFilePath:s,wasCreated:i}=await this.H();return new d.$Wp(new b.$oX(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?d.StorageHint.STORAGE_IN_MEMORY:i?d.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:b.$oX.IN_MEMORY_PATH,wasCreated:!0};const s=(0,j.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id),i=(0,j.$kc)(s,a.y);return await c.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:i,wasCreated:!0})}async I(s){let i;if((0,y.$Gi)(this.C)?i={folder:this.C.uri.toString()}:(0,y.$Li)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const o=(0,j.$kc)(s,a.z);await c.Promises.exists(o)||await c.Promises.writeFile(o,JSON.stringify(i,void 0,2))}catch(o){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.$_bc=a;class t extends g{get path(){}async t(){return new d.$Wp(new d.$Xp,{hint:d.StorageHint.STORAGE_IN_MEMORY})}}e.$acc=t}),define(re[284],oe([0,1,3,2,97]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class R extends C.$Vc{constructor(E,h,c){super(),this.b=E,this.c=h,this.f=c;const d=this.B(new C.$Wc);this.a=this.B(new n.$ee({onWillAddFirstListener:()=>d.value=this.g(),onDidRemoveLastListener:()=>d.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new C.$Uc;return E.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,c)=>(h?h.push(c.key):h=[c.key],h),100)(h=>this.h(h))),E.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(h,c)=>{h||(h=new Map);let d=h.get(c.profile.id);return d||h.set(c.profile.id,d={profile:c.profile,keys:[],storage:c.storage}),d.keys.push(c.key),h},100)(h=>this.j(h))),E}h(E){const h=E.includes(S.$Zp)?[this.c.defaultProfile]:[],c=[];if(E=E.filter(d=>d!==S.$Zp),E.length){const d=(0,S.$2p)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:E.map(b=>({key:b,scope:0,target:d[b]}))})}this.m(h,c)}j(E){const h=[],c=new Map;for(const[d,b]of E.entries()){b.keys.includes(S.$Zp)&&h.push(b.profile);const v=b.keys.filter(m=>m!==S.$Zp);if(v.length){const m=(0,S.$2p)(b.storage.storage);c.set(d,{profile:b.profile,changes:v.map(f=>({key:f,scope:0,target:m[f]}))})}}this.m(h,[...c.values()])}m(E,h){(E.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:E})}listen(E,h,c){switch(h){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${h}`)}async call(E,h){throw new Error(`Call not found: ${h}`)}}e.$ldc=R}),define(re[285],oe([0,1,7,38,16,5,34,40,41,12,125]),function(J,e,n,C,S,R,j,E,h,c,d){"use strict";var b,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.$LQ=e.$KQ=void 0;let m=class extends h.$Fl{static{b=this}static{this.a="profileAssociationsMigration"}constructor(g,l,w,k,a){super(w,k,l,a),this.U=g,this.W=w}O(){return this.U.getItem(b.b,[]).map(l=>({...l,location:(0,c.$9f)(l.location)?this.w.extUri.joinPath(this.profilesHome,l.location):n.URI.revive(l.location)}))}Q(){const g=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$KQ=m,e.$KQ=m=b=Se([ie(0,j.$FQ),ie(1,E.$Al),ie(2,C.$Ei),ie(3,S.$3k),ie(4,R.$3j)],m);let f=v=class extends m{constructor(g,l,w,k,a){super(g,l,w,k,a),this.$=g}P(g){g.length?this.$.setItem(v.b,g.map(l=>({...l,location:this.w.extUri.basename(l.location)}))):this.$.removeItem(v.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(v.c,g):this.$.removeItem(v.c)}Q(){const g="workspaceAndProfileInfo",l=this.$.getItem(g,void 0);if(l){this.$.removeItem(g);const k=l.reduce((a,{workspace:t,profile:r})=>(a[n.URI.revive(t).toString()]=n.URI.revive(r).toString(),a),{});this.$.setItem(v.c,{workspaces:k})}const w=super.Q();return this.$.getItem(v.a,!1)||(this.R(w),this.$.setItem(v.a,!0)),w}};e.$LQ=f,e.$LQ=f=v=Se([ie(0,j.$GQ),ie(1,E.$Al),ie(2,C.$Ei),ie(3,S.$3k),ie(4,R.$3j)],f);let y=class extends f{constructor(g,l,w,k){super(new d.$JQ(0,l,k,w),g,l,w,k)}async init(){return await this.$.init(),super.init()}};e.$MQ=y,e.$MQ=y=Se([ie(0,E.$Al),ie(1,C.$Ei),ie(2,S.$3k),ie(3,R.$3j)],y)}),define(re[57],oe([0,1,38,16,6,5,40,41,285,34]),function(J,e,n,C,S,R,j,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=e.$Rbc=void 0,e.$Rbc=(0,S.$xi)(E.$Cl);let d=class extends h.$LQ{constructor(v,m,f,y,p){super(v,m,f,y,p)}getAssociatedEmptyWindows(){const v=[];for(const m of this.C.emptyWindows.keys())v.push({id:m});return v}};e.$Sbc=d,e.$Sbc=d=Se([ie(0,c.$GQ),ie(1,j.$Al),ie(2,n.$Ei),ie(3,C.$3k),ie(4,R.$3j)],d)}),define(re[133],oe([0,1,19,7,30]),function(J,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=R,e.$Ubc=j,e.$Vbc=E;async function R(h,c,d){for(const v of h){const m=v.openedWorkspace;if((0,S.$Li)(m)){const f=await d(m);if(f){if(f.folders.some(y=>n.$1g.isEqualOrParent(c,y.uri)))return v}else if(n.$1g.isEqualOrParent(c,m.configPath))return v}}const b=h.filter(v=>(0,S.$Gi)(v.openedWorkspace)&&n.$1g.isEqualOrParent(c,v.openedWorkspace.uri));if(b.length)return b.sort((v,m)=>-(v.openedWorkspace.uri.path.length-m.openedWorkspace.uri.path.length))[0]}function j(h,c){for(const d of h)if((0,S.$Li)(d.openedWorkspace)&&n.$1g.isEqual(d.openedWorkspace.configPath,c)||(0,S.$Gi)(d.openedWorkspace)&&n.$1g.isEqual(d.openedWorkspace.uri,c))return d}function E(h,c){const d=b=>c.some(v=>n.$1g.isEqual(C.URI.file(v),C.URI.file(b)));for(const b of h)if(b.config?.extensionDevelopmentPath?.some(v=>d(v)))return b}}),define(re[98],oe([0,1,31,42,103,48,13,9,4,19,7,6,68,30]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgb=void 0,e.$ngb=f,e.$ogb=y,e.$pgb=p,e.$qgb=g,e.$rgb=k,e.$sgb=t,e.$tgb=r,e.$ugb=$,e.$vgb=P,e.$mgb=(0,b.$wi)("workspacesService");function f(D){return D.hasOwnProperty("workspace")}function y(D){return D.hasOwnProperty("folderUri")}function p(D){return D.hasOwnProperty("fileUri")}function g(D){return l(D)||w(D)}function l(D){const I=D;return typeof I?.path=="string"&&(!I.name||typeof I.name=="string")}function w(D){const I=D;return typeof I?.uri=="string"&&(!I.name||typeof I.name=="string")}function k(D,I,O,M,W){if(D.scheme!==M.scheme)return{name:O,uri:D.toString(!0)};let F=I?void 0:W.relativePath(M,D);if(F!==void 0)F.length===0?F=".":h.$i&&(F=a(F));else if(D.scheme===j.Schemas.file)F=D.fsPath,h.$i&&(F=a(F));else if(W.isEqualAuthority(D.authority,M.authority))F=D.path;else return{name:O,uri:D.toString(!0)};return{name:O,path:F}}function a(D){return D=(0,R.$yw)(D),(0,n.$sg)(D)||(D=(0,n.$pg)(D)),D}function t(D,I,O){const M=[],W=new Set,F=O.dirname(I);for(const T of D){let q;if(l(T))T.path&&(q=O.resolvePath(F,T.path));else if(w(T))try{q=d.URI.parse(T.uri),q.path[0]!==E.$hc.sep&&(q=q.with({path:E.$hc.sep+q.path}))}catch(ue){console.warn(ue)}if(q){const ue=O.getComparisonKey(q);if(!W.has(ue)){W.add(ue);const ee=T.name||O.basenameOrAuthority(q);M.push(new m.$Qi({uri:q,name:ee,index:M.length},T))}}}return M}function r(D,I,O,M,W){const F=s(I,D),T=W.dirname(I),q=W.dirname(M),ue=[];for(const G of F.folders){const B=l(G)?W.resolvePath(T,G.path):d.URI.parse(G.uri);let L;O?L=!1:L=!l(G)||(0,E.$jc)(G.path),ue.push(k(B,L,G.name,q,W))}const ee={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},ce=S.$Yn(D,["folders"],ue,ee);let K=S.$2n(D,ce);return(0,c.$ch)(F.remoteAuthority,(0,v.$Hm)(M))&&(K=S.$2n(K,S.$Xn(K,["remoteAuthority"],ee))),K}function s(D,I){const O=C.$Jn(I);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(M=>g(M));else throw new Error(`${D} looks like an invalid workspace file.`);return O}function i(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function o(D){return typeof D.folderUri=="string"}function u(D){return typeof D.fileUri=="string"}function $(D,I){const O={workspaces:[],files:[]};if(D){const M=function(F,T){for(let q=0;q<F.length;q++)try{T(F[q],q)}catch(ue){I.warn(`Error restoring recent entry ${JSON.stringify(F[q])}: ${ue.toString()}. Skip entry.`)}},W=D;Array.isArray(W.entries)&&M(W.entries,F=>{const T=F.label,q=F.remoteAuthority;i(F)?O.workspaces.push({label:T,remoteAuthority:q,workspace:{id:F.workspace.id,configPath:d.URI.parse(F.workspace.configPath)}}):o(F)?O.workspaces.push({label:T,remoteAuthority:q,folderUri:d.URI.parse(F.folderUri)}):u(F)&&O.files.push({label:T,remoteAuthority:q,fileUri:d.URI.parse(F.fileUri)})})}return O}function P(D){const I={entries:[]};for(const O of D.workspaces)y(O)?I.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):I.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of D.files)I.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return I}}),define(re[99],oe([0,1,87,13,4,19]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=void 0,e.$Xbc=j,e.$Ybc=E,e.$Zbc=h,e.$Wbc=128/4;function j(c){function d(){let b=c.scheme===C.Schemas.file?(0,R.$Xg)(c):c.toString();return S.$k||(b=b.toLowerCase()),(0,n.createHash)("md5").update(b).digest("hex")}return{id:d(),configPath:c}}function E(c,d){function b(){if(c.scheme!==C.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!d)return;let m;return S.$k?m=d.ino:S.$j?m=d.birthtime.getTime():S.$i&&(typeof d.birthtimeMs=="number"?m=Math.floor(d.birthtimeMs):m=d.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(m?String(m):"").digest("hex")}const v=b();if(typeof v=="string")return{id:v,uri:c}}function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(re[100],oe([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$ni=e.$mi=e.$li=void 0,e.$oi=s,e.$pi=i,e.$ri=$,e.$si=P;class y{traceSocketEvent(I,O){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}constructor(I,O=""){this.f=!0,this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,E.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(I){const O=M=>{this.traceSocketEvent("read",M),I(j.$Ge.wrap(M))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=M=>{I({type:0,hadError:M,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,E.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,E.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$li=y;var p;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var g;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(g||(g={}));class l extends c.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}constructor(I,O,M,W){super(),this.f=this.B(new h.$ee),this.g=this.B(new h.$ee),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:M?.byteLength||0,recordInflateBytes:W}),this.a=this.B(new w(this,O,M,W,this.f,(F,T)=>this.m(F,T))),this.B(this.a.onError(F=>{console.error(F),(0,E.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new f.$gi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this.f.event(I)}onClose(I){return this.g.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let O=0;for(;O<I.byteLength;)this.a.writeMessage(I.slice(O,Math.min(O+262144,I.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(I,{compressed:O,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let W=2;I.byteLength<126?W+=0:I.byteLength<2**16?W+=2:W+=8;const F=j.$Ge.alloc(W),T=O?64:0,q=M&15;if(F.writeUInt8(128|T|q,0),I.byteLength<126)F.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){F.writeUInt8(126,1);let ue=1;F.writeUInt8(I.byteLength>>>8&255,++ue),F.writeUInt8(I.byteLength>>>0&255,++ue)}else{F.writeUInt8(127,1);let ue=1;F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(I.byteLength>>>24&255,++ue),F.writeUInt8(I.byteLength>>>16&255,++ue),F.writeUInt8(I.byteLength>>>8&255,++ue),F.writeUInt8(I.byteLength>>>0&255,++ue)}this.socket.write(j.$Ge.concat([F,I]))}end(){this.h=!0,this.socket.end()}n(I){if(I.byteLength!==0){for(this.b.acceptChunk(I);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),M=O.readUInt8(0),W=(M&128)>>>7,F=(M&64)>>>6,T=M&15,q=O.readUInt8(1),ue=(q&128)>>>7,ee=q&127;this.j.state=2,this.j.readLen=2+(ue?4:0)+(ee===126?2:0)+(ee===127?8:0),this.j.fin=W,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!W,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),M=O.readUInt8(1),W=(M&128)>>>7;let F=M&127,T=1;F===126?F=O.readUInt8(++T)*2**8+O.readUInt8(++T):F===127&&(F=O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T));let q=0;W&&(q=O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T)),this.j.state=3,this.j.readLen=F,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$mi=l;class w extends c.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:j.$Ge.alloc(0)}constructor(I,O,M,W,F,T){super(),this.n=I,this.r=F,this.s=T,this.a=this.B(new h.$ee),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$ee),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$ee),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new k(this.n,W,M,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(I,O){this.g.push({data:I,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:I,options:O}=this.g.shift();if(this.f&&O.compressed){const M=await this.w(this.f,I);this.s(M,O)}else this.s(I,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(I,O){return new Promise((M,W)=>{I.write(O),I.flush(F=>M(F))})}acceptFrame(I,O,M){this.h.push({data:I,isCompressed:O,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const I=this.h.shift();if(this.b&&I.isCompressed){const O=await this.C(this.b,I.data,I.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(I.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(I,O,M){return new Promise((W,F)=>{I.write(O),M&&I.write(j.$Ge.fromByteArray([0,0,255,255])),I.flush(T=>W(T))})}}class k extends c.$Vc{get recordedInflateBytes(){return this.j?j.$Ge.concat(this.f):j.$Ge.alloc(0)}constructor(I,O,M,W){super(),this.h=I,this.j=O,this.a=this.B(new h.$ee),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(W),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(j.$Ge.wrap(F))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(I){this.j&&this.f.push(I.clone()),this.h.traceSocketEvent("zlibInflateWrite",I),this.b.write(I.buffer)}flush(I){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=j.$Ge.concat(this.g);this.g.length=0,I(O)})}}class a extends c.$Vc{constructor(I,O){super(),this.g=I,this.a=this.B(new h.$ee),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(j.$Ge.wrap(M))})}write(I){this.g.traceSocketEvent("zlibDeflateWrite",I.buffer),this.b.write(I.buffer)}flush(I){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=j.$Ge.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function t(D,I){if(I===0)return;const O=D.byteLength>>>2;for(let ue=0;ue<O;ue++){const ee=D.readUInt32BE(ue*4);D.writeUInt32BE(ee^I,ue*4)}const M=O*4,W=D.byteLength-M,F=I>>>24&255,T=I>>>16&255,q=I>>>8&255;W>=1&&D.writeUInt8(D.readUInt8(M)^F,M),W>=2&&D.writeUInt8(D.readUInt8(M+1)^T,M+1),W>=3&&D.writeUInt8(D.readUInt8(M+2)^q,M+2)}e.$ni=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function s(){const D=(0,v.$Sg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const I=process.platform!=="darwin"&&e.$ni?e.$ni:(0,S.tmpdir)(),O=(0,d.$kc)(I,`vscode-ipc-${D}.sock`);return o(O),O}function i(D,I,O){const W=(0,n.createHash)("sha256").update(D).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${O}-${I}-sock`;const F=O.substr(0,4),T=I.substr(0,6);let q;return process.platform!=="darwin"&&e.$ni&&!process.env.VSCODE_PORTABLE?q=(0,d.$kc)(e.$ni,`vscode-${W}-${F}-${T}.sock`):q=(0,d.$kc)(D,`${F}-${T}.sock`),o(q),q}function o(D){const I=r[b.$u];typeof I=="number"&&D.length>=I&&console.warn(`WARNING: IPC handle "${D}" is longer than ${I} chars, try a shorter --user-data-dir`)}class u extends m.$ai{static b(I){const O=h.Event.fromNodeEventEmitter(I,"connection");return h.Event.map(O,M=>({protocol:new f.$hi(new y(M,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(M,"close"))}))}constructor(I){super(u.b(I)),this.d=I}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$qi=u;function $(D){return new Promise((I,O)=>{const M=(0,C.createServer)();M.on("error",O),M.listen(D,()=>{M.removeListener("error",O),I(new u(M))})})}function P(D,I){return new Promise((O,M)=>{const W=(0,C.createConnection)(D,()=>{W.removeListener("error",M),O(f.$ii.fromSocket(new y(W,`ipc-client${I}`),I))});W.once("error",M)})}}),define(re[24],oe([0,1,51,9,4,100,38,91,6]),function(J,e,n,C,S,R,j,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=void 0,e.$Dbc=(0,h.$xi)(j.$Di);class c extends E.$9m{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,C.$kc)(this.userDataPath,"clp")}get backupHome(){return(0,C.$kc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,R.$pi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,C.$kc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(S.$k){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const v=b.slice(0,-17);if(this.d[v])continue;process.env[v]&&(this.d[v]=process.env[v]),process.env[b]?process.env[v]=process.env[b]:delete process.env[v]}}}restoreSnapExportedVariables(){if(S.$k)for(const b in this.d)process.env[b]=this.d[b],delete this.d[b]}}e.$Ebc=c,Se([n.$1h],c.prototype,"cachedLanguagesPath",null),Se([n.$1h],c.prototype,"backupHome",null),Se([n.$1h],c.prototype,"mainIPCHandle",null),Se([n.$1h],c.prototype,"mainLockfile",null),Se([n.$1h],c.prototype,"disableUpdates",null),Se([n.$1h],c.prototype,"crossOriginIsolated",null),Se([n.$1h],c.prototype,"codeCachePath",null),Se([n.$1h],c.prototype,"useCodeCache",null)}),define(re[287],oe([0,1,87,31,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;let w=class{static{l=this}static{this.a="backupWorkspaces"}constructor(a,t,r,s){this.j=a,this.k=t,this.l=r,this.m=s,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$1g,this.i={isEqual:(i,o)=>(0,C.$ug)(i,o,!j.$k)}}async initialize(){const a=this.m.getItem(l.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,c.$Gbc)(a)),this.e=await this.v((0,c.$Hbc)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==m.$pl.OFF}q(){return this.s()===m.$pl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||m.$pl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(s=>a.workspace.id===s.workspace.id)||(this.d.push(a),this.C());const r=(0,R.$kc)(this.c,a.workspace.id);return t?this.t(r,t).then(()=>r):r}async t(a,t){if(await h.Promises.exists(a)&&await this.z(a),await h.Promises.exists(t))try{await h.Promises.rename(t,a,!1)}catch(r){this.l.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,R.$kc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,R.$kc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,r=[];for(const s of a){const i=s.workspace;if(!(0,p.$Li)(i))return[];if(!t.has(i.id)){t.add(i.id);const o=(0,R.$kc)(this.c,i.id);await this.B(o)?i.configPath.scheme!==S.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?r.push(s):await this.z(o):await this.x(o)}}return r}async v(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const i=s.folderUri,o=this.h.getComparisonKey(i);if(!r.has(o)){r.add(o);const u=(0,R.$kc)(this.c,this.D(s));await this.B(u)?i.scheme!==S.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(s):await this.z(u):await this.x(u)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const i=s.backupFolder;if(typeof i!="string")return[];if(!r.has(i)){r.add(i);const o=(0,R.$kc)(this.c,i);await this.B(o)?t.push(s):await this.x(o)}}return t}async x(a){try{await h.Promises.rm(a,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,g.$Zbc)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,g.$Zbc)();return{backupFolder:a.id}}async z(a){const t=this.y(),r=(0,R.$kc)(this.c,t.backupFolder);try{await h.Promises.rename(a,r,!1)}catch(s){return this.l.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,c.$Fbc)(a)?t=(0,R.$kc)(this.c,a.backupFolder):(0,y.$kgb)(a)?t=(0,R.$kc)(this.c,this.D(a)):t=(0,R.$kc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await h.Promises.readdir(a);for(const r of t)try{if((await h.Promises.readdir((0,R.$kc)(a,r))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:r})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return r&&(s.remoteAuthority=r),s}),folders:this.e.map(({folderUri:t,remoteAuthority:r})=>{const s={folderUri:t.toString()};return r&&(s.remoteAuthority=r),s}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:r})=>{const s={backupFolder:t};return r&&(s.remoteAuthority=r),s})};this.m.setItem(l.a,a)}D(a){const t=a.folderUri;let r;return t.scheme===S.Schemas.file?r=j.$k?t.fsPath:t.fsPath.toLowerCase():r=t.toString().toLowerCase(),(0,n.createHash)("md5").update(r).digest("hex")}};e.$gcc=w,e.$gcc=w=l=Se([ie(0,b.$Dbc),ie(1,d.$3i),ie(2,f.$3j),ie(3,v.$GQ)],w)}),define(re[20],oe([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=e.LifecycleMainPhase=e.ShutdownReason=e.$8bc=void 0,e.$8bc=(0,d.$wi)("lifecycleMainService");var y;(function(l){l[l.QUIT=1]="QUIT",l[l.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var p;(function(l){l[l.Starting=1]="Starting",l[l.Ready=2]="Ready",l[l.AfterWindowOpen=3]="AfterWindowOpen",l[l.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let g=class extends j.$Vc{static{f=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(w,k,a){super(),this.F=w,this.G=k,this.H=a,this.c=this.B(new R.$ee),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.$ee),this.onWillShutdown=this.f.event,this.g=this.B(new R.$ee),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.$ee),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(f.b),this.m&&this.G.removeItem(f.b)}J(){const w=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.t===0&&this.L(1))};n.app.addListener("before-quit",w);const k=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!E.$j)&&n.app.quit()};n.app.addListener("window-all-closed",k),n.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",w),n.app.removeListener("window-all-closed",k),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(w){if(this.y)return this.y;const k=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:w,join(t,r){k.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(r.finally(()=>{k.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await S.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(w){if(w<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===w)return;this.S(`lifecycle (main): phase changed (value: ${w})`),this.n=w;const k=this.C.get(this.n);k&&(k.open(),this.C.delete(this.n))}async when(w){if(w<=this.n)return;let k=this.C.get(w);k||(k=new S.$vh,this.C.set(w,k)),await k.wait()}registerWindow(w){const k=new j.$Uc;this.t++,k.add(w.onWillLoad(t=>this.g.fire({window:w,workspace:t.workspace,reason:t.reason})));const a=(0,c.$hg)(w.win);k.add(R.Event.fromNodeEventEmitter(a,"close")(t=>{const r=w.id;if(this.r.has(r)){this.r.delete(r);return}this.S(`Lifecycle#window.on('close') - window ID ${w.id}`),t.preventDefault(),this.unload(w,1).then(s=>{if(s){this.r.delete(r);return}this.r.add(r),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${r}`),this.h.fire(w),w.close()})})),k.add(R.Event.fromNodeEventEmitter(a,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${w.id}`),this.t--,k.dispose(),this.t===0&&(!E.$j||this.j)&&this.L(1)}))}registerAuxWindow(w){const k=(0,c.$hg)(w.win),a=new j.$Uc;a.add(R.Event.fromNodeEventEmitter(k,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${w.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(R.Event.fromNodeEventEmitter(k,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${w.id}`),a.dispose()}))}async reload(w,k){await this.unload(w,3)||w.reload(k)}unload(w,k){const a=this.z.get(w.id);if(a)return a;const t=this.M(w,k).finally(()=>{this.z.delete(w.id)});return this.z.set(w.id,t),t}async M(w,k){if(!w.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${w.id}`);const a=this.j?2:k,t=await this.P(w,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${w.id})`),this.N(t)):(await this.Q(w,a),!1)}N(w){return w?(this.O(!0),this.j=!1,!0):!1}O(w){this.w&&(this.w(w),this.w=void 0,this.u=void 0)}P(w,k){return new Promise(a=>{const t=this.s++,r=`vscode:ok${t}`,s=`vscode:cancel${t}`;C.$VW.once(r,()=>{a(!1)}),C.$VW.once(s,()=>{a(!0)}),w.send("vscode:onBeforeUnload",{okChannel:r,cancelChannel:s,reason:k})})}Q(w,k){return new Promise(a=>{const r=`vscode:reply${this.s++}`;C.$VW.once(r,()=>a()),w.send("vscode:onWillUnload",{replyChannel:r,reason:k})})}quit(w){return this.R(w).then(k=>{if(!k&&w)try{if(E.$i){const a=(0,h.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return k})}R(w){return this.S(`Lifecycle#quit() - begin (willRestart: ${w})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(w&&this.G.setItem(f.b,!0),this.u=new Promise(k=>{this.w=k,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(w){this.H.args["enable-smoke-test-driver"]?this.F.info(w):this.F.trace(w)}setRelaunchHandler(w){this.D=w}async relaunch(w){this.S("Lifecycle#relaunch()");const k=process.argv.slice(1);if(w?.addArgs&&k.push(...w.addArgs),w?.removeArgs)for(const r of w.removeArgs){const s=k.indexOf(r);s>=0&&k.splice(s,1)}const a=()=>{this.D?.handleRelaunch(w)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:k}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(w){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,S.$xh)(1e3),(async()=>{for(const k of n.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let a;k.webContents&&!k.webContents.isDestroyed()?a=new Promise(t=>k.once("closed",t)):a=Promise.resolve(),k.destroy(),await a}})()]),n.app.exit(w)}};e.$9bc=g,e.$9bc=g=f=Se([ie(0,b.$3j),ie(1,v.$GQ),ie(2,m.$Dbc)],g)}),define(re[288],oe([0,1,4,3,2,6,20]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=e.$Dcc=void 0,e.$Dcc=(0,R.$wi)("keyboardLayoutMainService");let E=class extends S.$Vc{constructor(d){super(),this.a=this.B(new C.$ee),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,d.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const d=await new Promise((b,v)=>{J(["native-keymap"],b,v)});this.c=h(d),n.$t||d.onDidChangeKeyboardLayout(()=>{this.c=h(d),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Ecc=E,e.$Ecc=E=Se([ie(0,j.$8bc)],E);function h(c){const d=c.getKeyMap(),b=c.getCurrentKeyboardLayout();return{keyboardMapping:d,keyboardLayoutInfo:b}}}),define(re[289],oe([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0,e.$Yr=p;let f=class extends b.$Op{constructor(l,w,k,a){super(a),this.m=l,this.n=w,this.r=k,this.s(),this.B(l.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const l=this.m.getValue("http");this.f=l?.proxy,this.g=!!l?.proxyStrictSSL,this.h=l?.proxyAuthorization}async request(l,w){const{f:k,g:a}=this;let t;try{t=await(0,c.$Gm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,R.$0)(i)))}const r={...process.env,...t},s=l.agent?l.agent:await(0,v.$Wr)(l.url||"",r,{proxyUrl:k,strictSSL:a});return l.agent=s,l.strictSSL=a,this.h&&(l.headers={...l.headers||{},"Proxy-Authorization":this.h}),this.c(l.isChromiumNetwork?"electron":"node",l,()=>p(l,w))}async resolveProxy(l){}async loadCertificates(){return(await new Promise((w,k)=>{J(["@vscode/proxy-agent"],w,k)})).loadSystemCertificates({log:this.r})}};e.$Xr=f,e.$Xr=f=Se([ie(0,E.$3i),ie(1,h.$Ei),ie(2,d.$3j),ie(3,d.$4j)],f);async function y(g){return((0,n.parse)(g.url).protocol==="https:"?await new Promise((k,a)=>{J(["https"],k,a)}):await new Promise((k,a)=>{J(["http"],k,a)})).request}async function p(g,l){return C.Promises.withAsyncBody(async(w,k)=>{const a=(0,n.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await y(g),r={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,j.$cg)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(r.auth=g.user+":"+g.password);const s=t(r,i=>{const o=(0,j.$ag)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)p({...g,url:i.headers.location,followRedirects:o-1},l).then(w,k);else{let u=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(u=i.pipe((0,m.createGunzip)())),w({res:i,stream:(0,S.$Ve)(u)})}});s.on("error",k),g.timeout&&s.setTimeout(g.timeout),g.isChromiumNetwork&&s.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&s.write(g.data),s.end(),l.onCancellationRequested(()=>{s.abort(),k(new R.$5)})})}}),define(re[290],oe([0,1,14,289]),function(J,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;function S(j){return n.net.request}class R extends C.$Xr{request(E,h){return super.request({...E||{},getRawRequest:S,isChromiumNetwork:!0},h)}}e.$Gdc=R}),define(re[84],oe([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=e.$ccc=e.$bcc=void 0,e.$bcc=(0,E.$wi)("storageMainService");let p=class extends S.$Vc{constructor(w,k,a,t,r,s){super(),this.c=w,this.f=k,this.g=a,this.h=t,this.j=r,this.m=s,this.a=void 0,this.b=this.B(new C.$ee),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(w=>{w.window.profile&&this.profileStorage(w.window.profile).init(),w.workspace&&this.workspaceStorage(w.workspace).init()})),this.B(this.h.onWillShutdown(w=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=w.reason,w.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.t)w.join("profileStorage",k.close());for(const[,k]of this.w)w.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(w=>{w.join((async()=>{await this.j.exists(w.profile.globalStorageHome)||await this.j.createFolder(w.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(w=>{const k=this.t.get(w.profile.id);k&&w.join(k.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const w=new b.$$bc(this.n(),this.g,this.c,this.j);return this.B(C.Event.once(w.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),w}profileStorage(w){if((0,d.$4p)(w))return this.applicationStorage;let k=this.t.get(w.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${w.name})`),k=this.B(this.u(w)),this.t.set(w.id,k);const a=this.B(k.onDidChangeStorage(t=>this.b.fire({...t,storage:k,profile:w})));this.B(C.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${w.name})`),this.t.delete(w.id),a.dispose()}))}return k}u(w){return this.a===2?new b.$acc(this.c,this.j):new b.$0bc(w,this.n(),this.c,this.j)}workspaceStorage(w){let k=this.w.get(w.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${w.id})`),k=this.B(this.y(w)),this.w.set(w.id,k),this.B(C.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${w.id})`),this.w.delete(w.id)}))),k}y(w){return this.a===2?new b.$acc(this.c,this.j):new b.$_bc(w,this.n(),this.c,this.f,this.j)}isUsed(w){const k=n.URI.file(w);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(n.URI.file(a.path),k))return!0;return!1}};e.$ccc=p,e.$ccc=p=Se([ie(0,c.$3j),ie(1,R.$Di),ie(2,m.$Rbc),ie(3,h.$8bc),ie(4,j.$3k),ie(5,f.$Al)],p),e.$dcc=(0,E.$wi)("applicationStorageMainService");let g=class extends d.$3p{constructor(w,k){super(),this.s=w,this.U=k,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(w){if(w===-1)return this.U.applicationStorage.storage}Q(w){if(w===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$ecc=g,e.$ecc=g=Se([ie(0,v.$Cl),ie(1,e.$bcc)],g)}),define(re[291],oe([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=e.$Edc=e.$Ddc=e.$Cdc=void 0;async function g(t,r,s,i,o){let u;for(let $=3;$&&(u?.dispose(),u=await new l(t,r,s,i,o).waitForReady(),!(o&&S.$Vg[o]||!S.$Vg[u.tunnelLocalPort]));$--);return u}class l extends E.$Vc{constructor(r,s,i,o,u){super(),this.m=s,this.n=u,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=n.createServer(),this.c=new j.$vh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=$=>this.r($),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=o,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,s=(0,y.$kw)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,S.$Wg)(r,2,1e3,s),o=null;return this.b.listen(i,this.m),await this.c.wait(),o=this.b.address(),o||(i=0,this.b.listen(i,this.m),await this.c.wait(),o=this.b.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async r(r){r.pause();const s=(0,y.$iw)(this.tunnelRemoteHost)||(0,y.$kw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$Sl)(this.a,s,this.tunnelRemotePort),o=i.getSocket(),u=i.readEntireBuffer();i.dispose(),u.byteLength>0&&r.write(u.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),o.end()}),r.on("close",()=>o.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),o instanceof R.$li?o.socket.destroy():o.end()}),o instanceof R.$li?this.t(r,o):this.s(r,o),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),o.end()})}s(r,s){s.onClose(()=>r.destroy()),s.onEnd(()=>r.end()),s.onData(i=>r.write(i.buffer)),r.on("data",i=>s.write(p.$Ge.wrap(i))),r.resume()}t(r,s){const i=s.socket;i.on("end",()=>r.end()),i.on("close",()=>r.end()),i.on("error",()=>{r.destroy()}),i.pipe(r),r.pipe(i)}}e.$Cdc=l;let w=class extends y.$nw{constructor(r,s,i,o,u){super(s,u),this.v=r,this.w=i,this.y=o}isPortPrivileged(r){return(0,y.$lw)(r,this.m,h.OS,C.release())}t(r,s,i,o,u,$,P,D){const I=this.s(s,i);if(I)return++I.refcount,I.value;if((0,y.$ew)(r))return this.u(r,s,i,u,$,P,D);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${u}.`);const O={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},M=g(O,o,s,i,u);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,i,M),M}}};e.$Ddc=w,e.$Ddc=w=Se([ie(0,m.$Ml),ie(1,d.$3j),ie(2,f.$Pl),ie(3,b.$jk),ie(4,c.$3i)],w);let k=class extends w{constructor(r,s,i,o,u){super(r,s,i,o,u)}};e.$Edc=k,e.$Edc=k=Se([ie(0,m.$Ml),ie(1,d.$3j),ie(2,f.$Pl),ie(3,b.$jk),ie(4,c.$3i)],k);let a=class extends E.$Vc{constructor(r,s,i,o,u){super(),this.b=r,this.c=s,this.f=i,this.g=o,this.h=u,this.a=new Map}async openTunnel(r,s,i,o,u,$,P,D,I){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${o} on local port ${$}.`),!this.a.has(r)){const O=new k(this.b,this.c,this.g,this.f,this.h);this.B(O),this.a.set(r,O),O.onTunnelClosed(async()=>{(await O.tunnels).length===0&&(O.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(s,i,o,u,$,P,D,I)}};e.$Fdc=a,e.$Fdc=a=Se([ie(0,m.$Ml),ie(1,d.$3j),ie(2,b.$jk),ie(3,f.$Pl),ie(4,c.$3i)],a)}),define(re[101],oe([0,1,8,23,3,18,24,20,5,27,53,50]),function(J,e,n,C,S,R,j,E,h,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0,e.$1cc=v;function v(f,y,p){return`${p.updateUrl}/api/update/${f}/${y}/${p.commit}`}let m=class{get state(){return this.b}d(y){this.j.info("update#setState",y.type),this.b=y,this.c.fire(y)}constructor(y,p,g,l,w,k){this.f=y,this.g=p,this.h=g,this.i=l,this.j=w,this.k=k,this.b=b.$TX.Uninitialized,this.c=new S.$ee,this.onStateChange=this.c.event,y.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(b.$TX.Disabled(0));return}if(this.h.disableUpdates){this.d(b.$TX.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(b.$TX.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.g.getValue("update.mode"),p=this.m(y);if(!p){this.d(b.$TX.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(p),!this.a){this.d(b.$TX.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const g=new URL(this.a);g.searchParams.set("prss","true"),this.a=g.toString()}if(this.d(b.$TX.Idle(this.q())),y==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(y){return y==="none"?void 0:this.k.quality}n(y=60*60*1e3){return(0,n.$xh)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(y){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(y)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(y){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},C.CancellationToken.None)).res.statusCode===204}catch(p){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(p);return}}async _applySpecificUpdate(y){}q(){return 1}r(){}};e.$2cc=m,e.$2cc=m=Se([ie(0,E.$8bc),ie(1,R.$3i),ie(2,j.$Dbc),ie(3,d.$Np),ie(4,h.$3j),ie(5,c.$jk)],m)}),define(re[292],oe([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;let p=class extends y.$2cc{get v(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"error",(l,w)=>w)}get w(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(l,w,k,a)=>({version:k,productVersion:k,timestamp:a}))}constructor(l,w,k,a,t,r,s){super(l,w,a,t,r,s),this.z=k,this.u=new j.$Uc,l.setRelaunchHandler(this)}handleRelaunch(l){return l?.addArgs||l?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(l){this.z.publicLog2("update:error",{messageHash:String((0,R.$kj)(String(l)))}),this.j.error("UpdateService error:",l);const w=this.state.type==="checking for updates"&&this.state.explicit?l:void 0;this.d(f.$TX.Idle(1,w))}s(l){let w;this.k.darwinUniversalAssetId?w=this.k.darwinUniversalAssetId:w=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,y.$1cc)(w,l,this.k);try{n.autoUpdater.setFeedURL({url:k})}catch(a){this.j.error("Failed to set update feed URL",a);return}return k}t(l){this.d(f.$TX.CheckingForUpdates(l)),n.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(f.$TX.Downloading)}F(l){this.state.type==="downloading"&&(this.d(f.$TX.Downloaded(l)),this.z.publicLog2("update:downloaded",{version:l.version}),this.d(f.$TX.Ready(l)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$TX.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$3cc=p,Se([C.$1h],p.prototype,"v",null),Se([C.$1h],p.prototype,"w",null),Se([C.$1h],p.prototype,"x",null),Se([C.$1h],p.prototype,"y",null),e.$3cc=p=Se([ie(0,c.$8bc),ie(1,E.$3i),ie(2,m.$2l),ie(3,h.$Dbc),ie(4,v.$Np),ie(5,d.$3j),ie(6,b.$jk)],p)}),define(re[293],oe([0,1,49,43,8,3,9,24,20,5,28,50]),function(J,e,n,C,S,R,j,E,h,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;let v=class{get state(){return this.a}d(y){this.g.info("update#setState",y.type),this.a=y,this.b.fire(y)}constructor(y,p,g){if(this.f=y,this.g=g,this.a=b.$TX.Uninitialized,this.b=new R.$ee,this.onStateChange=this.b.event,p.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(b.$TX.Idle(this.k())),this.h(30*1e3).then(void 0,l=>this.g.error(l))}h(y=60*60*1e3){return(0,S.$xh)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(y){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(y)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(y){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(y){}};v=Se([ie(0,h.$8bc),ie(1,E.$Dbc),ie(2,c.$3j)],v);let m=class extends v{constructor(y,p,g,l,w,k){super(g,l,w),this.o=y,this.p=p,this.q=k;const a=(0,C.watch)(j.$nc(this.o)),t=R.Event.fromNodeEventEmitter(a,"change",(o,u)=>u),r=R.Event.filter(t,o=>o==="current"),i=R.Event.debounce(r,(o,u)=>u,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(b.$TX.CheckingForUpdates(!1)),this.u().then(y=>{y?this.d(b.$TX.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$TX.Idle(2)))},y=>{this.g.error(y),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$TX.Idle(2,y.message||y))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+j.$oc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const y=await new Promise((g,l)=>(0,C.realpath)(`${j.$nc(this.o)}/current`,(w,k)=>w?l(w):g(k))),p=j.$oc(y);return this.p!==p}isLatestVersion(){return this.u().then(void 0,y=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$5cc=m,e.$5cc=m=Se([ie(2,h.$8bc),ie(3,E.$Dbc),ie(4,c.$3j),ie(5,d.$2l)],m)}),define(re[29],oe([0,1,14,4,6,82,55,69,27,18,24,9,138]),function(J,e,n,C,S,R,j,E,h,c,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Obc=void 0,e.$Pbc=f,e.$Qbc=y,e.$Obc=(0,S.$wi)("windowsMainService");var m;(function(g){g[g.CLI=0]="CLI",g[g.DOCK=1]="DOCK",g[g.MENU=2]="MENU",g[g.DIALOG=3]="DIALOG",g[g.DESKTOP=4]="DESKTOP",g[g.API=5]="API"})(m||(e.OpenContext=m={}));function f(g,l,w){const k=g.get(E.$Mbc),a=g.get(h.$jk),t=g.get(c.$3i),r=g.get(d.$Dbc),s=t.getValue("window"),i={backgroundColor:k.getBackgroundColor(),minWidth:j.$uD.WIDTH,minHeight:j.$uD.HEIGHT,title:a.nameLong,show:l.mode!==0&&l.mode!==3,x:l.x,y:l.y,width:l.width,height:l.height,webPreferences:{...w,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,j.$FD)(l.zoomLevel??s?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(C.$k?i.icon=(0,b.$kc)(r.appRoot,"resources/linux/code.png"):C.$i&&!r.isBuilt&&(i.icon=(0,b.$kc)(r.appRoot,"resources/win32/code_150x150.png")),C.$j&&(i.acceptFirstMouse=!0,s?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),C.$j&&!(0,j.$ED)(t)&&(i.fullscreenable=!1),C.$j&&s?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,j.$BD)(t)&&(i.titleBarStyle="hidden",C.$j||(i.frame=!1),(0,j.$DD)(t))){const $=k.getWindowSplash()?.colorInfo.titleBarBackground??k.getBackgroundColor(),P=v.$Pt.fromHex($).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:$,symbolColor:P}}return i}function y(g){let l,w=Number.MIN_VALUE;for(const k of g)k.lastFocusTime>w&&(w=k.lastFocusTime,l=k);return l}var p;(function(g){function l(k,a,t=n.screen.getAllDisplays()){if(k.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){k.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){k.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=w(t[0]);if(k.trace("window#validateWindowState: single monitor working area",i),i){let o=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};o(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),o()}return a}if(a.display&&a.mode===3){const i=t.find(o=>o.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){k.trace("window#validateWindowState: restoring fullscreen to previous display");const o=(0,R.$Bbc)(3);return o.x=i.bounds.x,o.y=i.bounds.y,o}}let r,s;try{r=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),s=w(r),k.trace("window#validateWindowState: multi-monitor working area",s)}catch(i){k.error("window#validateWindowState: error finding display for window state",i)}if(r&&s&&a.x+a.width>s.x&&a.y+a.height>s.y&&a.x<s.x+s.width&&a.y<s.y+s.height)return a;k.trace("window#validateWindowState: state is outside of the multi-monitor working area")}g.validateWindowState=l;function w(k){if(k.workArea.width>0&&k.workArea.height>0)return k.workArea;if(k.bounds.width>0&&k.bounds.height>0)return k.bounds}})(p||(e.WindowStateValidator=p={}))}),define(re[294],oe([0,1,14,23,3,46,2,33,120,5,84,29]),function(J,e,n,C,S,R,j,E,h,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;var v;(function(f){f[f.Initial=1]="Initial",f[f.StoredCredentialsUsed=2]="StoredCredentialsUsed",f[f.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let m=class extends j.$Vc{constructor(y,p,g,l){super(),this.g=y,this.h=p,this.j=g,this.m=l,this.a="proxy-credentials://",this.b=void 0,this.c=v.Initial,this.f=void 0,this.n()}n(){const y=S.Event.fromNodeEventEmitter(n.app,"login",(p,g,l,w,k)=>({event:p,webContents:g,req:l,authInfo:w,callback:k}));this.B(y(this.r,this))}async r({event:y,authInfo:p,req:g,callback:l}){if(!p.isProxy)return;if(!this.b&&this.c===v.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let w;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),w=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(p);try{w=await this.b}finally{this.b=void 0}}l(w?.username,w?.password)}async s(y){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.t(y);if(p)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(y){this.g.trace("auth#doResolveProxyCredentials - enter",y);const p=String((0,R.$kj)({scheme:y.scheme,host:y.host,port:y.port}));let g,l;try{const t=this.m.get(this.a+p,-1);if(t){const r=JSON.parse(await this.j.decrypt(t));g=r.username,l=r.password}}catch(t){this.g.error(t)}if(this.c!==v.StoredCredentialsUsed&&typeof g=="string"&&typeof l=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=v.StoredCredentialsUsed,{username:g,password:l};const w=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!w){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${w.id} to handle proxy login`);const k={authInfo:y,username:this.f?.username??g,password:this.f?.password??l,replyChannel:`vscode:proxyAuthResponse:${(0,E.$Sg)()}`};w.sendWhenReady("vscode:openProxyAuthenticationDialog",C.CancellationToken.None,k),this.c=v.LoginDialogShown;const a=await new Promise(t=>{const r=async(s,i,o)=>{if(i===k.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${w.id}`),w.win?.webContents.off("ipc-message",r),o){const u={username:o.username,password:o.password};try{if(o.remember){const $=await this.j.encrypt(JSON.stringify(u));this.m.store(this.a+p,$,-1,1)}else this.m.remove(this.a+p,-1)}catch($){this.g.error($)}t({username:u.username,password:u.password})}else t(void 0)};w.win?.webContents.on("ipc-message",r)});return this.f=a,a}};e.$fcc=m,e.$fcc=m=Se([ie(0,c.$3j),ie(1,b.$Obc),ie(2,h.$EX),ie(3,d.$dcc)],m)}),define(re[295],oe([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(J,e,n,C,S,R,j,E,h,c,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=e.ID=void 0,e.ID="launchMainService",e.$Gcc=(0,c.$wi)(e.ID);let m=class{constructor(y,p,g,l){this.a=y,this.b=p,this.c=g,this.d=l}async start(y,p){this.a.trace("Received data from other instance: ",y,p),S.$j&&n.app.focus({steal:!0});const g=this.e(y);if(g.length){let l=Promise.resolve();if(this.b.getWindowCount()===0){const w=(0,C.$Ob)(await this.b.openEmptyWindow({context:4}));w&&(l=w.ready())}l.then(()=>{for(const{uri:w,originalUrl:k}of g)this.c.open(w,{originalUrl:k})})}else return this.f(y,p)}e(y){return y["open-url"]&&y._urls&&y._urls.length>0?(0,C.$Hb)(y._urls.map(p=>{try{return{uri:R.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async f(y,p){const g=(0,h.$Am)(p)?0:4;let l=[];const w=y.wait&&y.waitMarkerFilePath?R.URI.file(y.waitMarkerFilePath):void 0,k=y.remote||void 0,a={context:g,cli:y,userEnv:y["preserve-env"]||g===0?p:void 0,waitMarkerFileURI:w,remoteAuthority:k,forceProfile:y.profile,forceTempProfile:y["profile-temp"]};if(y.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(y.extensionDevelopmentPath,a);else if(!y._.length&&!y["folder-uri"]&&!y["file-uri"]){let t=!1;if(y["new-window"]||a.forceProfile||a.forceTempProfile)t=!0;else if(y["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!S.$j}if(t)l=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,a),l=[r]):l=await this.b.open({...a,forceEmpty:!0})}}else l=await this.b.open({...a,forceNewWindow:y["new-window"],preferNewWindow:!y["reuse-window"]&&!y.wait,forceReuseWindow:y["reuse-window"],diffMode:y.diff,mergeMode:y.merge,addMode:y.add,noRecentEntry:!!y["skip-add-to-recently-opened"],gotoLineMode:y.goto});if(w&&l.length===1&&l[0])return Promise.race([l[0].whenClosedOrLoaded,(0,j.whenDeleted)(w.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Hcc=m,e.$Hcc=m=Se([ie(0,d.$3j),ie(1,v.$Obc),ie(2,b.$KX),ie(3,E.$3i)],m)}),define(re[296],oe([0,1,2,20,57,30,8,29]),function(J,e,n,C,S,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;let h=class extends n.$Vc{constructor(d,b,v){super(),this.a=b,this.b=v,this.B(d.onWillLoadWindow(m=>{m.reason===2&&this.c(m.window)})),this.B(d.onBeforeCloseWindow(m=>this.c(m))),this.B(new j.$Ih(()=>this.g(),30*1e3)).schedule()}async c(d){const b=this.f(d),v=this.a.getProfileForWorkspace(b);v?.isTransient&&(this.a.unsetWorkspace(b,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f(d){return d.openedWorkspace??(0,R.$Ki)(d.backupPath,d.isExtensionDevelopmentHost)}g(){const d=this.a.getAssociatedEmptyWindows();if(d.length===0)return;const b=this.b.getWindows().map(v=>this.f(v));for(const v of d)b.some(m=>m.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.$kdc=h,e.$kdc=h=Se([ie(0,C.$8bc),ie(1,S.$Rbc),ie(2,E.$Obc)],h)}),define(re[61],oe([0,1,14,2,3,5,316,8,13,29,74,28,20,76,35,4,102]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=void 0;function l(a){return typeof a.responseWindowId=="number"}let w=class extends C.$Vc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(t,r,s){super(),this.w=t,this.y=r,this.z=s,this.c=String(++g.a),this.f=this.B(new S.$ee),this.onStdout=this.f.event,this.g=this.B(new S.$ee),this.onStderr=this.g.event,this.h=this.B(new S.$ee),this.onMessage=this.h.event,this.j=this.B(new S.$ee),this.onSpawn=this.j.event,this.m=this.B(new S.$ee),this.onExit=this.m.event,this.n=this.B(new S.$ee),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(t,r){let s;switch(this.t?.correlationId?s=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,r){case d.default.Error:this.w.error(s);break;case d.default.Warning:this.w.warn(s);break;case d.default.Info:this.w.trace(s);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",d.default.Error),!1):!0}start(t){const r=this.F(t);return r&&t.payload&&this.postMessage(t.payload)&&this.C("payload sent via postMessage()",d.default.Info),r}F(t){if(!this.D())return!1;this.t=t;const r=`${this.t.type}-${this.c}`,s=h.$Qg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],o=this.t.execArgv??[],u=this.t.allowLoadingUnsignedLibraries,$=this.t.forceAllocationsToV8Sandbox,P="pipe",D=this.G(t);return this.C("creating new...",d.default.Info),this.r=n.utilityProcess.fork(s,i,{serviceName:r,env:D,execArgv:o,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:$,stdio:P}),this.H(this.r,this.t,r),!0}G(t){const r=t.env?{...t.env}:{...(0,f.$3n)(process.env)};r.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(r.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),r.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,y.$i&&((0,p.isUNCAccessRestrictionsDisabled)()?r.NODE_DISABLE_UNC_ACCESS_CHECKS="1":r.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,m.$nm)(r);for(const s of Object.keys(r))r[s]=String(r[s]);return r}H(t,r,s){if(t.stdout){const i=new j.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stdout,"data")(o=>this.f.fire(typeof o=="string"?o:i.write(o))))}if(t.stderr){const i=new j.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stderr,"data")(o=>this.g.fire(typeof o=="string"?o:i.write(o))))}this.B(S.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(S.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&g.b.set(t.pid,{pid:t.pid,name:l(r)?`${r.type} [${r.responseWindowId}]`:r.type}),this.C("successfully created",d.default.Info),this.j.fire(t.pid)})),this.B(S.Event.fromNodeEventEmitter(t,"exit")(i=>{const o=this.I(i)?0:i;this.C(`received exit event with code ${o}`,d.default.Info),this.m.fire({pid:this.s,code:o,signal:"unknown"}),this.J()})),this.B(S.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,o)=>({event:i,details:o}))(({details:i})=>{i.type==="Utility"&&i.name===s&&!this.I(i.exitCode)&&(this.C(`crashed with code ${i.exitCode} and reason '${i.reason}'`,d.default.Error),this.y.publicLog2("utilityprocesscrash",{type:r.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.J())}))}once(t,r){const s=this.B(this.h.event(i=>{i===t&&(s.dispose(),r())}))}postMessage(t,r){return this.r?(this.r.postMessage(t,r),!0):!1}connect(t){const{port1:r,port2:s}=new n.MessageChannelMain;return this.postMessage(t,[s]),r}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",d.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",d.default.Info),this.r.kill()?(this.C("successfully killed the process",d.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",d.default.Warning)}I(t){return t===0?!0:this.u&&t===15}J(){typeof this.s=="number"&&g.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.C("waiting to exit...",d.default.Info),await Promise.race([S.Event.toPromise(this.onExit),(0,E.$xh)(t)]),this.r&&(this.C(`did not exit within ${t}ms, will kill it now...`,d.default.Info),this.kill()))}};e.$icc=w,e.$icc=w=g=Se([ie(0,R.$3j),ie(1,b.$2l),ie(2,v.$8bc)],w);let k=class extends w{constructor(t,r,s,i){super(t,s,i),this.L=r}start(t){const r=this.L.getWindowById(t.responseWindowId);if(!r?.win||r.win.isDestroyed()||r.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",d.default.Error),!0;if(!super.F(t))return!1;this.M(r.win,t);const i=this.connect(t.payload);return r.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}M(t,r){r.windowLifecycleBound&&(this.B(S.Event.filter(this.z.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this.B(S.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$jcc=k,e.$jcc=k=Se([ie(0,R.$3j),ie(1,c.$Obc),ie(2,b.$2l),ie(3,v.$8bc)],k)}),define(re[297],oe([0,1,15,3,5,20,8,61,29,28]),function(J,e,n,C,S,R,j,E,h,c){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;let b=class{static{d=this}static{this.a=0}constructor(m,f,y,p){this.d=m,this.f=f,this.g=y,this.h=p,this.b=new Map,this.c=!1,this.f.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(m){const f=this.b.get(m);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(m){return this.i(m).onStdout}onDynamicStderr(m){return this.i(m).onStderr}onDynamicMessage(m){return this.i(m).onMessage}onDynamicExit(m){return this.i(m).onExit}async createExtensionHost(){if(this.c)throw(0,n.$6)();const m=String(++d.a),f=new E.$jcc(this.d,this.g,this.h,this.f);return this.b.set(m,f),f.onExit(({pid:y,code:p,signal:g})=>{this.d.info(`Extension host with pid ${y} exited with code: ${p}, signal: ${g}.`),setTimeout(()=>{f.dispose(),this.b.delete(m)}),setTimeout(()=>{try{process.kill(y,0),this.d.error(`Extension host with pid ${y} still exists, forcefully killing it...`),process.kill(y)}catch{}},1e3)}),{id:m}}async start(m,f){if(this.c)throw(0,n.$6)();const y=this.i(m);return y.start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:m}),{pid:await C.Event.toPromise(y.onSpawn)}}async enableInspectPort(m){if(this.c)throw(0,n.$6)();const f=this.b.get(m);return f?f.enableInspectPort():!1}async kill(m){if(this.c)throw(0,n.$6)();const f=this.b.get(m);f&&f.kill()}async _killAllNow(){for(const[,m]of this.b)m.kill()}async _waitForAllExit(m){const f=[];for(const[,y]of this.b)f.push(y.waitForExit(m));return j.Promises.settled(f).then(()=>{})}};e.$qcc=b,e.$qcc=b=d=Se([ie(0,S.$3j),ie(1,R.$8bc),ie(2,h.$Obc),ie(3,c.$2l)],b)}),define(re[298],oe([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;let p=class extends S.$Vc{constructor(l,w,k,a,t,r,s,i){super(),this.f=l,this.g=w,this.h=k,this.j=a,this.m=t,this.n=r,this.r=s,this.s=i,this.a=new C.$vh,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){n.$VW.on(y.$Scc.request,(l,w)=>this.u(l,w,y.$Scc.response)),n.$VW.on(y.$Tcc.request,(l,w)=>this.u(l,w,y.$Tcc.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(l,w,k){this.n.trace(`[SharedProcess] onWindowConnection for: ${k}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(k);if(l.sender.isDestroyed())return a.close();l.sender.postMessage(k,w,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(y.$Rcc.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const l=new C.$Th;this.b?.once(y.$Rcc.initDone,()=>l.complete()),await l.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const l=new C.$Th;this.b?.once(y.$Rcc.ipcReady,()=>l.complete()),await l.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new b.$icc(this.n,v.$hp,this.m)),this.c=this.b.onMessage(k=>{typeof k.warning=="string"?this.n.warn(k.warning):typeof k.error=="string"&&this.n.error(k.error)});const l=(0,m.$$m)(this.h.args,this.h.isBuilt);let w;l.port&&(w=["--nolazy"],l.break?w.push(`--inspect-brk=${l.port}`):w.push(`--inspect=${l.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:w})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(l){return await this.C,(0,f.$hg)(this.b).connect(l)}};e.$Ucc=p,e.$Ucc=p=Se([ie(2,R.$Dbc),ie(3,h.$Cl),ie(4,j.$8bc),ie(5,E.$3j),ie(6,d.$3bc),ie(7,c.$eo)],p)}),define(re[299],oe([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;let y=class extends d.$Vc{constructor(g,l,w,k,a){super(),this.f=g,this.g=l,this.h=w,this.j=k,this.m=a,this.a=void 0,this.b=new b.$ee,this.onRequestConnection=this.b.event,this.c=new b.$ee,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$VW.on("vscode:createPtyHostMessageChannel",(t,r)=>this.r(t,r)),this.B((0,d.$Tc)(()=>{c.$VW.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$icc(this.m,j.$hp,this.j);const g=(0,C.$0m)(this.h.args,this.h.isBuilt),l=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:l,args:["--logsPath",this.h.logsHome.with({scheme:f.Schemas.file}).fsPath],env:this.n()});const w=this.a.connect(),k=new h.$4W(w,"ptyHost"),a=new d.$Uc;return a.add(k),a.add((0,d.$Tc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:k,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,v.$3n)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},l=this.g.getValue("terminal.integrated.developer.ptyHost.latency");l&&typeof l=="number"&&(g.VSCODE_LATENCY=String(l));const w=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return w&&typeof w=="number"&&(g.VSCODE_STARTUP_DELAY=String(w)),this.h.restoreSnapExportedVariables(),g}r(g,l){this.b.fire();const w=this.a.connect();if(g.sender.isDestroyed()){w.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",l,[w])}};e.$udc=y,e.$udc=y=Se([ie(1,m.$3i),ie(2,n.$Dbc),ie(3,S.$8bc),ie(4,R.$3j)],y)}),define(re[300],oe([0,1,2,6,5,29,61,28,46,3,8,20]),function(J,e,n,C,S,R,j,E,h,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=e.$sdc=void 0,e.$sdc=(0,C.$wi)("utilityProcessWorker");let v=class extends n.$Vc{constructor(y,p,g,l){super(),this.b=y,this.c=p,this.f=g,this.g=l,this.a=new Map}async createWorker(y){const p=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${p})`);const g=this.h(y);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(y));const l=new m(this.b,this.c,this.f,this.g,y);if(!l.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,l);const w=new d.$Th;return c.Event.once(l.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete(g),w.complete({reason:k})}),w.p}h(y){return(0,h.$kj)({moduleId:y.process.moduleId,windowId:y.reply.windowId})}async disposeWorker(y){const p=this.h(y),g=this.a.get(p);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),g.kill(),this.a.delete(p))}};e.$tdc=v,e.$tdc=v=Se([ie(0,S.$3j),ie(1,R.$Obc),ie(2,E.$2l),ie(3,b.$8bc)],v);let m=class extends n.$Vc{constructor(y,p,g,l,w){super(),this.c=y,this.f=p,this.g=g,this.h=l,this.j=w,this.a=this.B(new c.$ee),this.onDidTerminate=this.a.event,this.b=new j.$jcc(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(y=>this.a.fire({code:y.code,signal:y.signal}))),this.B(this.b.onCrash(y=>this.a.fire({code:y.code,signal:"ECRASH"})))}spawn(){const p=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};m=Se([ie(0,S.$3j),ie(1,R.$Obc),ie(2,E.$2l),ie(3,b.$8bc)],m)}),define(re[301],oe([0,1,14,3,2,277,29]),function(J,e,n,C,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;let E=class extends S.$Vc{constructor(c){super(),this.b=c,this.a=this.B(new C.$ee),this.onFoundInFrame=this.a.event,this.B(new R.$_cc)}async setIgnoreMenuShortcuts(c,d){let b;if(typeof c.windowId=="number"){const{windowId:v}=c,m=this.b.getWindowById(v);if(!m?.win)throw new Error(`Invalid windowId: ${v}`);b=m.win.webContents}else{const{webContentsId:v}=c;if(b=n.webContents.fromId(v),!b)throw new Error(`Invalid webContentsId: ${v}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(d)}async findInFrame(c,d,b,v){const f=this.c(c,d);if(typeof f.findInFrame=="function"){f.findInFrame(b,{findNext:v.findNext,forward:v.forward});const y=(p,g)=>{g.finalUpdate&&(this.a.fire(g),f.removeListener("found-in-frame",y))};f.on("found-in-frame",y)}}async stopFindInFrame(c,d,b){const m=this.c(c,d);typeof m.stopFindInFrame=="function"&&m.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}c(c,d){const b=this.b.getWindowById(c.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${c}`);const v=b.win.webContents.mainFrame.framesInSubtree.find(m=>m.name===d);if(!v)throw new Error(`Unknown frame: ${d}`);return v}};e.$adc=E,e.$adc=E=Se([ie(0,j.$Obc)],E)}),define(re[302],oe([0,1,14,2,4,19,7,18,20,5,34,29,82,30]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0,e.$cdc=p,e.$ddc=l;let y=class extends C.$Vc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,r,s,i){super(),this.g=a,this.h=t,this.j=r,this.m=s,this.n=i,this.b=p(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(o=>!o.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const r=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);r&&(t.lastPluginDevelopmentHostWindow=this.w(r),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?S.$j&&!r.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const o=this.w(i);return o.uiState.mode===3&&(a.has(o.uiState.display)?S.$j&&o.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(o.uiState.mode=1):a.add(o.uiState.display)),o}));const s=l(t);this.h.setItem(f.a,s),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",s)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(r=>{const s=(0,m.$Li)(a.openedWorkspace)&&r.workspace?.id===a.openedWorkspace.id,i=(0,m.$Gi)(a.openedWorkspace)&&r.folderUri&&R.$1g.isEqual(r.folderUri,a.openedWorkspace.uri);(s||i)&&(r.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,m.$Li)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,m.$Gi)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),r=this.n.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(r?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(r.newWindowDimensions)>=0):s=!!(this.j.wasRestarted||r?.restoreFullscreen),s||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const $=a.workspace;if((0,m.$Li)($)){const D=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===$.id).map(I=>I.uiState);if(D.length)return D[0]}if((0,m.$Gi)($)){const D=this.state.openedWindows.filter(I=>I.folderUri&&R.$1g.isEqual(I.folderUri,$.uri)).map(I=>I.uiState);if(D.length)return D[0]}else if(a.backupPath){const D=this.state.openedWindows.filter(I=>I.backupPath===a.backupPath).map(I=>I.uiState);if(D.length)return D[0]}const P=this.c||this.state.lastActiveWindow;if(!t&&P)return P.uiState}let r;const s=n.screen.getAllDisplays();if(s.length===1)r=s[0];else{if(S.$j){const $=n.screen.getCursorScreenPoint();r=n.screen.getDisplayNearestPoint($)}!r&&t&&(r=n.screen.getDisplayMatching(t.getBounds())),r||(r=n.screen.getPrimaryDisplay()||s[0])}let i=(0,v.$Bbc)();i.x=Math.round(r.bounds.x+r.bounds.width/2-i.width/2),i.y=Math.round(r.bounds.y+r.bounds.height/2-i.height/2);const o=this.n.getValue("window");let u=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")i.mode=0,u=!1;else if(o.newWindowDimensions==="fullscreen")i.mode=3,u=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&t){const $=t.serializeWindowState();$.mode===3?i.mode=3:i={...$,zoomLevel:void 0},u=i.mode!==3&&o.newWindowDimensions==="offset"}}return u&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(r=>r.getBounds());for(;t.some(r=>r.x===a.x||r.y===a.y);)a.x+=30,a.y+=30;return a}};e.$bdc=y,e.$bdc=y=f=Se([ie(0,b.$Obc),ie(1,d.$GQ),ie(2,h.$8bc),ie(3,c.$3j),ie(4,E.$3i)],y);function p(k){const a={openedWindows:[]},t=k||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=g(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=g(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(r=>g(r))),a}function g(k){const a={uiState:k.uiState};return k.backupPath&&(a.backupPath=k.backupPath),k.remoteAuthority&&(a.remoteAuthority=k.remoteAuthority),k.folder&&(a.folderUri=j.URI.parse(k.folder)),k.workspaceIdentifier&&(a.workspace={id:k.workspaceIdentifier.id,configPath:j.URI.parse(k.workspaceIdentifier.configURIPath)}),a}function l(k){return{lastActiveWindow:k.lastActiveWindow&&w(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&w(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(a=>w(a))}}function w(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(re[58],oe([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=e.$1bc=void 0,e.$1bc=(0,f.$wi)("workspacesManagementMainService");let a=class extends R.$Vc{constructor(r,s,i,o,u){super(),this.g=r,this.h=s,this.j=i,this.m=o,this.n=u,this.a=this.B(new C.$ee),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new C.$ee),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const r=(await c.Promises.readdir(this.c.with({scheme:j.Schemas.file}).fsPath)).map(s=>(0,h.$0g)(this.c,s,l.$Vi));for(const s of r){const i=(0,k.$Xbc)(s),o=await this.resolveLocalWorkspace(s);o?this.f.push({workspace:i,remoteAuthority:o.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(r){r.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${r}).`)}}resolveLocalWorkspace(r){return this.r(r,s=>c.Promises.readFile(s,"utf8"))}r(r,s){if(this.s(r)&&r.scheme===j.Schemas.file)try{const i=s(r.fsPath);return i instanceof Promise?i.then(o=>this.t(r,o),o=>{}):this.t(r,i)}catch{return}}s(r){return(0,l.$Wi)(r,this.g)||(0,l.$2i)(r)}t(r,s){try{const i=this.u(r,s),o=(0,k.$Xbc)(r);return{id:o.id,configPath:o.configPath,folders:(0,w.$sgb)(i.folders,o.configPath,h.$1g),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(r,s){const i=(0,S.$Jn)(s);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(o=>(0,w.$qgb)(o));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(r,s){const{workspace:i,storedWorkspace:o}=this.w(r,s),u=i.configPath.fsPath;return await c.Promises.mkdir((0,E.$nc)(u),{recursive:!0}),await c.Promises.writeFile(u,JSON.stringify(o,null,"	")),this.f.push({workspace:i,remoteAuthority:s}),i}w(r=[],s){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),o=(0,h.$0g)(this.c,i),u=(0,h.$0g)(o,l.$Vi),$=[];for(const P of r)$.push((0,w.$rgb)(P.uri,!0,P.name,o,h.$1g));return{workspace:(0,k.$Xbc)(u),storedWorkspace:{folders:$,remoteAuthority:s}}}async getWorkspaceIdentifier(r){return(0,k.$Xbc)(r)}isUntitledWorkspace(r){return(0,l.$Wi)(r.configPath,this.g)}async deleteUntitledWorkspace(r){this.isUntitledWorkspace(r)&&(await this.y(r),this.j.isEnabled()&&this.j.unsetWorkspace(r),this.a.fire(r))}async y(r){const s=(0,h.$Xg)(r.configPath);try{await c.Promises.rm((0,E.$nc)(s));const i=(0,E.$kc)(this.g.workspaceStorageHome.with({scheme:j.Schemas.file}).fsPath,r.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,E.$kc)(i,"obsolete"),""),this.f=this.f.filter(o=>o.workspace.id!==r.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${s} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(r,s,i){if(!r||!r.win||!r.isReady||!await this.z(r,s,i))return;const u=await this.C(r,(0,k.$Xbc)(i));if(u)return this.b.fire({window:r,workspace:u.workspace}),u}async z(r,s,i){return i?(0,l.$Li)(r.openedWorkspace)&&h.$1g.isEqual(r.openedWorkspace.configPath,i)?!1:(0,g.$Ubc)(s,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:(0,d.localize)(1,null,(0,h.$7g)(i)),detail:(0,d.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(r,s){if(!r.config)return;r.focus();let i;return r.config.extensionDevelopmentPath||(r.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority},r.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority})),(0,l.$Li)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=s,r.config.backupPath=i,{workspace:s,backupPath:i}}};e.$2bc=a,e.$2bc=a=Se([ie(0,m.$Dbc),ie(1,y.$3j),ie(2,p.$Rbc),ie(3,b.$Ibc),ie(4,v.$Jbc)],a)}),define(re[134],oe([0,1,14,37,23,6,29,30,58,12,5,61]),function(J,e,n,C,S,R,j,E,h,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=e.ID=void 0,e.ID="diagnosticsMainService",e.$lcc=(0,R.$wi)(e.ID);let v=class{constructor(f,y,p){this.a=f,this.b=y,this.c=p}async getRemoteDiagnostics(f){const y=this.a.getWindows();return(await Promise.all(y.map(async g=>{const l=g.remoteAuthority;if(!l)return;const w=`vscode:getDiagnosticInfoResponse${g.id}`,k={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(a=>{g.sendWhenReady("vscode:getDiagnosticInfo",S.CancellationToken.None,{replyChannel:w,args:k}),C.$VW.once(w,(t,r)=>{r||a({hostName:l,errorMessage:`Unable to resolve connection to '${l}'.`}),a(r)}),setTimeout(()=>{a({hostName:l,errorMessage:`Connection to '${l}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const p of n.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(p.id);g?f.push(await this.d(g)):f.push(this.e(p))}const y=[];for(const{pid:p,name:g}of b.$icc.getAll())y.push({pid:p,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:y,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(f){const y=await this.f(f),p=(0,c.$hg)(f.win);return this.e(p,y,f.remoteAuthority)}e(f,y=[],p){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:y,remoteAuthority:p}}async f(f){const y=[],p=f.openedWorkspace;if((0,E.$Gi)(p))y.push(p.uri);else if((0,E.$Li)(p)){const g=await this.b.resolveLocalWorkspace(p.configPath);g&&g.folders.forEach(w=>{y.push(w.uri)})}return y}};e.$mcc=v,e.$mcc=v=Se([ie(0,j.$Obc),ie(1,h.$1bc),ie(2,d.$3j)],v)}),define(re[70],oe([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,79,15]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k,a,t,r,s,i,o,u,$,P,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=e.$Acc=void 0,e.$Acc=(0,k.$wi)("nativeHostMainService");let M=class extends h.$Vc{constructor(F,T,q,ue,ee,ce,K,G,B){super(),this.a=F,this.b=T,this.c=q,this.f=ue,this.g=ee,this.h=ce,this.j=K,this.m=G,this.n=B,this.onDidOpenMainWindow=E.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=E.Event.any(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:z,y:Q})=>({windowId:L.id,x:z,y:Q})),E.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:z,y:Q})=>({windowId:L.id,x:z,y:Q}))),this.onDidMaximizeWindow=E.Event.any(E.Event.map(this.a.onDidMaximizeWindow,L=>L.id),E.Event.map(this.b.onDidMaximizeWindow,L=>L.id)),this.onDidUnmaximizeWindow=E.Event.any(E.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),E.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id)),this.onDidChangeWindowFullScreen=E.Event.any(E.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),E.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(L,z)=>z.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(L,z)=>z.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=E.Event.any(this.onDidBlurMainWindow,E.Event.map(E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(L,z)=>this.b.getWindowByWebContents(z.webContents)),L=>!!L),L=>L.id)),this.onDidFocusMainOrAuxiliaryWindow=E.Event.any(this.onDidFocusMainWindow,E.Event.map(E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(L,z)=>this.b.getWindowByWebContents(z.webContents)),L=>!!L),L=>L.id)),this.onDidResumeOS=E.Event.fromNodeEventEmitter(C.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new E.$ee),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(C.screen,"display-metrics-changed",(L,z,Q)=>Q),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),E.Event.fromNodeEventEmitter(C.screen,"display-added"),E.Event.fromNodeEventEmitter(C.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,T){const q=this.a.getWindows().map(ee=>({id:ee.id,workspace:ee.openedWorkspace??(0,o.$Ki)(ee.backupPath,ee.isExtensionDevelopmentHost),title:ee.win?.getTitle()??"",filename:ee.getRepresentedFilename(),dirty:ee.isDocumentEdited()})),ue=[];return T.includeAuxiliaryWindows&&ue.push(...this.b.getWindows().map(ee=>({id:ee.id,parentId:ee.parentId,title:ee.win?.getTitle()??"",filename:ee.getRepresentedFilename()}))),[...q,...ue]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const T=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(T)return T.id}openWindow(F,T,q){return Array.isArray(T)?this.s(F,T,q):this.t(F,T)}async s(F,T,q=Object.create(null)){T.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:T,cli:this.g.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0,forceProfile:q.forceProfile,forceTempProfile:q.forceTempProfile})}async t(F,T){await this.a.openEmptyWindow({context:5,contextWindowId:F},T)}async toggleFullScreen(F,T){this.C(T?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,T){this.C(T?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const T=C.screen.getCursorScreenPoint(),q=C.screen.getDisplayNearestPoint(T);return{point:T,display:q.bounds}}async isMaximized(F,T){return this.C(T?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,T){this.C(T?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,T,q){const ue=this.C(q?.targetWindowId,F);if(ue?.win){if(ue.win.isFullScreen()){const ee=E.Event.toPromise(E.Event.once(E.Event.fromNodeEventEmitter(ue.win,"leave-full-screen")));ue.win.setFullScreen(!1),await ee}ue.win.setBounds(T)}}async updateWindowControls(F,T){this.C(T?.targetWindowId,F)?.updateWindowControls(T)}async focusWindow(F,T){this.C(T?.targetWindowId,F)?.focus({force:T?.force??!1})}async setMinimumSize(F,T,q){const ue=this.D(F);if(ue?.win){const[ee,ce]=ue.win.getSize(),[K,G]=ue.win.getMinimumSize(),[B,L]=[T??K,q??G],[z,Q]=[Math.max(ee,B),Math.max(ce,L)];(K!==B||G!==L)&&ue.win.setMinimumSize(B,L),(ee!==z||ce!==Q)&&ue.win.setSize(z,Q)}}async saveWindowSplash(F,T){this.m.saveWindowSplash(F,T)}async installShellCommand(F){const{source:T,target:q}=await this.u();try{const{symbolicLink:ue}=await y.SymlinkSupport.stat(T);if(ue&&!ue.dangling){const ee=await(0,m.$6q)(T);if(q===ee)return}await y.Promises.unlink(T)}catch(ue){if(ue.code!=="ENOENT")throw ue}try{await y.Promises.symlink(q,T)}catch(ue){if(ue.code!=="EACCES"&&ue.code!=="ENOENT")throw ue;const{response:ee}=await this.showMessageBox(F,{type:"info",message:(0,g.localize)(0,null,this.j.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ee===1)throw new O.$5;try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${T}'\\" with administrator privileges"`;await(0,R.promisify)(n.exec)(ce)}catch{throw new Error((0,g.localize)(3,null,T))}}}async uninstallShellCommand(F){const{source:T}=await this.u();try{await y.Promises.unlink(T)}catch(q){switch(q.code){case"EACCES":{const{response:ue}=await this.showMessageBox(F,{type:"info",message:(0,g.localize)(4,null,this.j.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(ue===1)throw new O.$5;try{const ee=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,R.promisify)(n.exec)(ee)}catch{throw new Error((0,g.localize)(7,null,T))}break}case"ENOENT":break;default:throw q}}}async u(){const F=(0,d.$lc)(this.g.appRoot,"bin","code"),T=`/usr/local/bin/${this.j.applicationName}`;if(!await y.Promises.exists(F))throw new Error((0,g.localize)(8,null,F));return{source:T,target:F}}async showMessageBox(F,T){const q=this.C(T?.targetWindowId,F);return this.c.showMessageBox(T,q?.win??void 0)}async showSaveDialog(F,T){const q=this.C(T?.targetWindowId,F);return this.c.showSaveDialog(T,q?.win??void 0)}async showOpenDialog(F,T){const q=this.C(T?.targetWindowId,F);return this.c.showOpenDialog(T,q?.win??void 0)}async pickFileFolderAndOpen(F,T){const q=await this.c.pickFileFolder(T);q&&await this.w(await Promise.all(q.map(async ue=>await y.SymlinkSupport.existsDirectory(ue)?{folderUri:v.URI.file(ue)}:{fileUri:v.URI.file(ue)})),T,F)}async pickFolderAndOpen(F,T){const q=await this.c.pickFolder(T);q&&await this.w(q.map(ue=>({folderUri:v.URI.file(ue)})),T,F)}async pickFileAndOpen(F,T){const q=await this.c.pickFile(T);q&&await this.w(q.map(ue=>({fileUri:v.URI.file(ue)})),T,F)}async pickWorkspaceAndOpen(F,T){const q=await this.c.pickWorkspace(T);q&&await this.w(q.map(ue=>({workspaceUri:v.URI.file(ue)})),T,F)}async w(F,T,q){await this.a.open({context:3,contextWindowId:q,cli:this.g.args,urisToOpen:F,forceNewWindow:T.forceNewWindow})}async showItemInFolder(F,T){C.shell.showItemInFolder(T)}async setRepresentedFilename(F,T,q){this.C(q?.targetWindowId,F)?.setRepresentedFilename(T)}async setDocumentEdited(F,T,q){this.C(q?.targetWindowId,F)?.setDocumentEdited(T)}async openExternal(F,T){return this.g.unsetSnapExportedVariables(),C.shell.openExternal(T),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,T){return C.shell.trashItem(T)}async isAdmin(){let F;return b.$i?F=(await new Promise((T,q)=>{J(["native-is-elevated"],T,q)}))():F=process.getuid?.()===0,F}async writeElevated(F,T,q,ue){const ee=await new Promise((ce,K)=>{J(["@vscode/sudo-prompt"],ce,K)});return new Promise((ce,K)=>{const G=[`"${this.z}"`];ue?.unlock&&G.push("--file-chmod"),G.push("--file-write",`"${T.fsPath}"`,`"${q.fsPath}"`);const B={name:this.j.nameLong.replace("-",""),icns:b.$j&&this.g.isBuilt?(0,d.$kc)((0,d.$nc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ee.exec(G.join(" "),B,(L,z,Q)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),Q&&this.h.trace(`[sudo-prompt] received stderr: ${Q}`),L?K(L):ce(void 0)})})}async isRunningUnderARM64Translation(){return b.$k||b.$i?!1:C.app.runningUnderARM64Translation}get z(){return b.$i?this.g.isBuilt?(0,d.$kc)((0,d.$nc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,d.$kc)(this.g.appRoot,"scripts","code-cli.bat"):b.$k?this.g.isBuilt?(0,d.$kc)((0,d.$nc)(process.execPath),"bin",`${this.j.applicationName}`):(0,d.$kc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,d.$kc)(this.g.appRoot,"bin","code"):(0,d.$kc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,S.totalmem)(),freemem:(0,S.freemem)(),loadavg:(0,S.loadavg)()}}async getOSProperties(){return{arch:(0,S.arch)(),platform:(0,S.platform)(),release:(0,S.release)(),type:(0,S.type)(),cpus:(0,S.cpus)()}}async getOSVirtualMachineHint(){return f.$En.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return b.$i&&(0,P.$xcc)()}async killProcess(F,T,q){process.kill(T,q)}async readClipboardText(F,T){return C.clipboard.readText(T)}async writeClipboardText(F,T,q){return C.clipboard.writeText(T,q)}async readClipboardFindText(F){return C.clipboard.readFindText()}async writeClipboardFindText(F,T){return C.clipboard.writeFindText(T)}async writeClipboardBuffer(F,T,q,ue){return C.clipboard.writeBuffer(T,Buffer.from(q.buffer),ue)}async readClipboardBuffer(F,T){return $.$Ge.wrap(C.clipboard.readBuffer(T))}async hasClipboard(F,T,q){return C.clipboard.has(T,q)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){C.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){C.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){C.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){C.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){C.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,T){this.D(F)?.updateTouchBar(T)}async notifyReady(F){this.D(F)?.setReady()}async relaunch(F,T){return this.f.relaunch(T)}async reload(F,T){const q=this.D(F);if(q){if((0,o.$Li)(q.openedWorkspace)){const ue=q.openedWorkspace.configPath;if(ue.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(ue))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.f.reload(q,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(F,T){return this.C(T?.targetWindowId,F)?.win?.close()}async quit(F){const T=this.a.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&T.win?T.win.close():this.f.quit()}async exit(F,T){await this.f.kill(T)}async resolveProxy(F,T){return this.D(F)?.win?.webContents?.session?.resolveProxy(T)}async loadCertificates(F){return(await new Promise((q,ue)=>{J(["@vscode/proxy-agent"],q,ue)})).loadSystemCertificates({log:this.h})}findFreePort(F,T,q,ue,ee=1){return(0,p.$Ug)(T,q,ue,ee)}async openDevTools(F,T){this.C(T?.targetWindowId,F)?.win?.webContents.openDevTools(T?.mode?{mode:T.mode,activate:T.activate}:void 0)}async toggleDevTools(F,T){this.C(T?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,T,q){const ue=this.D(F);if(!ue||!ue.win)throw new Error;return await new D.$ycc(ue.win,T,this.h).inspect(q)}async windowsGetStringRegKey(F,T,q,ue){if(!b.$i)return;const ee=await new Promise((ce,K)=>{J(["@vscode/windows-registry"],ce,K)});try{return ee.GetStringRegKey(T,q,ue)}catch{return}}C(F,T){return this.D(F)??this.F(F)??this.D(T)}D(F){if(typeof F=="number")return this.a.getWindowById(F)}F(F){if(typeof F!="number")return;const T=C.webContents.fromId(F);if(T)return this.b.getWindowByWebContents(T)}};e.$Bcc=M,Se([j.$1h],M.prototype,"z",null),e.$Bcc=M=Se([ie(0,i.$Obc),ie(1,I.$zcc),ie(2,l.$Jbc),ie(3,a.$8bc),ie(4,w.$Dbc),ie(5,t.$3j),ie(6,r.$jk),ie(7,s.$Mbc),ie(8,u.$1bc)],M)}),define(re[303],oe([0,1,14,26,8,23,31,2,13,4,111,37,182,92,134,56,24,5,70,80,27,81,34,61,55,29]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k,a,t,r,s,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;const u="issue.processExplorerWindowState";let $=class{static{o=this}static{this.a="#1E1E1E"}constructor(I,O,M,W,F,T,q,ue,ee,ce,K){this.g=I,this.h=O,this.i=M,this.j=W,this.k=F,this.l=T,this.m=q,this.n=ue,this.o=ee,this.p=ce,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){b.$VW.on("vscode:listProcesses",async I=>{const O=[];try{O.push({name:(0,v.localize)(0,null),rootProcess:await(0,d.$Ds)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,m.$en)(W)?O.push({name:W.hostName,rootProcess:W}):W.processes&&O.push({name:W.hostName,rootProcess:W.processes})})}catch(M){this.i.error(`Listing processes failed: ${M}`)}this.t(I,"vscode:listProcessesResponse",O)}),b.$VW.on("vscode:workbenchCommand",(I,O)=>{const{id:M,from:W,args:F}=O;let T;switch(W){case"processExplorer":T=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}T?.webContents.send("vscode:runAction",{id:M,from:W,args:F})}),b.$VW.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),b.$VW.on("vscode:pidToNameRequest",async I=>{const O=await this.k.getMainDiagnostics(),M=[];for(const W of O.windows)M.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:F}of r.$icc.getAll())M.push([W,F]);this.t(I,"vscode:pidToNameResponse",M)})}async openReporter(I){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const O=new E.$Uc,M=O.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,M,{backgroundColor:I.styles.backgroundColor,title:(0,v.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),M.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,C.type)(),arch:(0,C.arch)(),release:(0,C.release)()},product:w.default}),this.b.loadURL(h.$Qg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,O.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,O.dispose())})}}async openProcessExplorer(I){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const O=new E.$Uc,M=O.add(this.n.createIPCObjectUrl()),W=this.p.getItem(u,void 0),F=P(W)?W:this.v(this.f,800,500);this.d=this.u(F,M,{backgroundColor:I.styles.backgroundColor,title:(0,v.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),M.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:w.default}),this.d.loadURL(h.$Qg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,O.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,O.dispose())});const T=()=>{if(!this.d)return;const q=this.d.getSize(),ue=this.d.getPosition();if(!q||!ue)return;const ee={width:q[0],height:q[1],x:ue[0],y:ue[1]};this.p.setItem(u,ee)};this.d.on("moved",T),this.d.on("resized",T)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await n.contentTracing.stopRecording(`${(0,j.$Eg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null,I),buttons:[(0,v.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,O)}async $getSystemInfo(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,O)}async $getPerformanceInfo(){try{const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,O)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,v.localize)(6,null),buttons:[(0,v.localize)(7,null),(0,v.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,v.localize)(9,null),buttons:[(0,v.localize)(10,null),(0,v.localize)(11,null)]},this.b);return I===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const I=this.q.getWindowById(this.c.id);if(!I)throw new Error("Window not found");return I}async $sendReporterMenu(I,O){const M=this.issueReporterWindowCheck(),W="vscode:triggerReporterMenu",F=new R.$pe;return M.sendWhenReady(W,F.token,{replyChannel:W,extensionId:I,extensionName:O}),await(0,S.$nh)(new Promise(q=>b.$VW.once(`vscode:triggerReporterMenuResponse:${I}`,(ue,ee)=>q(ee))),5e3,()=>{this.i.error(`Error: Extension ${I} timed out waiting for menu response`),F.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,O,...M){I.sender.isDestroyed()||I.sender.send(O,...M)}u(I,O,M,W){const F=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:M.title,backgroundColor:M.backgroundColor||o.a,webPreferences:{preload:h.$Qg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$FD)(M.zoomLevel),sandbox:!0},alwaysOnTop:M.alwaysOnTop,experimentalDarkMode:!0});return F.setMenuBarVisibility(!1),F}v(I,O,M){let W;const F=n.screen.getAllDisplays();if(F.length===1)W=F[0];else{if(c.$j){const ue=n.screen.getCursorScreenPoint();W=n.screen.getDisplayNearestPoint(ue)}!W&&I&&(W=n.screen.getDisplayMatching(I.getBounds())),W||(W=n.screen.getPrimaryDisplay()||F[0])}const T=W.bounds,q={width:O,height:M,x:T.x+T.width/2-O/2,y:T.y+T.height/2-M/2};return T.width>0&&T.height>0&&(q.x<T.x&&(q.x=T.x),q.y<T.y&&(q.y=T.y),q.x>T.x+T.width&&(q.x=T.x),q.y>T.y+T.height&&(q.y=T.y),q.width>T.width&&(q.width=T.width),q.height>T.height&&(q.height=T.height)),q}};e.$Ccc=$,e.$Ccc=$=o=Se([ie(1,p.$Dbc),ie(2,g.$3j),ie(3,m.$dn),ie(4,f.$lcc),ie(5,y.$Jbc),ie(6,l.$Acc),ie(7,a.$Lbc),ie(8,k.$jk),ie(9,t.$GQ),ie(10,i.$Obc)],$);function P(D){return typeof D!="object"||D===null?!1:"x"in D&&"y"in D&&"width"in D&&"height"in D}}),define(re[304],oe([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(J,e,n,C,S,R,j,E,h,c,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;let m=class extends v.$2cc{constructor(y,p,g,l,w,k,a,t){super(y,p,l,w,k,t),this.e=g,this.u=a}s(y){return(0,v.$1cc)(`linux-${process.arch}`,y,this.k)}t(y){this.a&&(this.d(b.$TX.CheckingForUpdates(y)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$Tp).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!y}),this.d(b.$TX.Idle(1))):this.d(b.$TX.AvailableForDownload(p))}).then(void 0,p=>{this.j.error(p);const g=y?p.message||p:void 0;this.d(b.$TX.Idle(1,g))}))}async o(y){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):y.update.url&&this.u.openExternal(void 0,y.update.url),this.d(b.$TX.Idle(1))}};e.$4cc=m,e.$4cc=m=Se([ie(0,R.$8bc),ie(1,C.$3i),ie(2,d.$2l),ie(3,S.$Dbc),ie(4,c.$Np),ie(5,j.$3j),ie(6,E.$Acc),ie(7,h.$jk)],m)}),define(re[305],oe([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;async function s($,P=1e3){for(;!$();)await(0,R.$xh)(P)}let i;function o(){return typeof i>"u"&&(i=C.existsSync(c.$kc(c.$nc(process.execPath),"unins000.exe"))?0:1),i}let u=class extends r.$2cc{get cachePath(){const P=c.$kc((0,S.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return v.Promises.mkdir(P,{recursive:!0}).then(()=>P)}constructor(P,D,I,O,M,W,F,T,q){super(P,D,O,M,W,q),this.u=I,this.v=F,this.w=T,P.setRelaunchHandler(this)}handleRelaunch(P){return P?.addArgs||P?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$TX.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(P){let D=`win32-${process.arch}`;return o()===1?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,r.$1cc)(D,P,this.k)}t(P){this.a&&(this.d(t.$TX.CheckingForUpdates(P)),this.i.request({url:this.a},j.CancellationToken.None).then(k.$Tp).then(D=>{const I=o();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!P}),this.d(t.$TX.Idle(I)),Promise.resolve(null)):I===1?(this.d(t.$TX.AvailableForDownload(D)),Promise.resolve(null)):(this.d(t.$TX.Downloading),this.C(D.version).then(()=>this.B(D.version).then(O=>v.Promises.exists(O).then(M=>{if(M)return Promise.resolve(O);const W=`${O}.tmp`;return this.i.request({url:D.url},j.CancellationToken.None).then(F=>this.v.writeFile(d.URI.file(W),F.stream)).then(D.sha256hash?()=>(0,b.$OW)(W,D.sha256hash):()=>{}).then(()=>v.Promises.rename(W,O,!1)).then(()=>O)})).then(O=>{this.e={packagePath:O},this.d(t.$TX.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$TX.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,h.$kj)(String(D)))}),this.j.error(D);const I=P?D.message||D:void 0;this.d(t.$TX.Idle(o(),I))}))}async o(P){P.update.url&&this.w.openExternal(void 0,P.update.url),this.d(t.$TX.Idle(o()))}async B(P){const D=await this.cachePath;return c.$kc(D,`CodeSetup-${this.k.quality}-${P}.exe`)}async C(P=null){const D=P?W=>!new RegExp(`${this.k.quality}-${P}\\.exe$`).test(W):()=>!0,I=await this.cachePath,M=(await v.Promises.readdir(I)).filter(D).map(async W=>{try{await v.Promises.unlink(c.$kc(I,W))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const P=this.state.update;this.d(t.$TX.Updating(P));const D=await this.cachePath;this.e.updateFilePath=c.$kc(D,`CodeSetup-${this.k.quality}-${P.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$TX.Idle(o()))});const O=`${this.k.win32MutexName}-ready`,M=await new Promise((W,F)=>{J(["@vscode/windows-mutex"],W,F)});s(()=>M.isActive(O)).then(()=>this.d(t.$TX.Ready(P)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?C.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return o()}async _applySpecificUpdate(P){if(this.state.type!=="idle")return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),I={version:"unknown",productVersion:"unknown"};this.d(t.$TX.Downloading),this.e={packagePath:P},this.d(t.$TX.Downloaded(I)),D?this.k.target==="user"&&this.p():this.d(t.$TX.Ready(I))}};e.$6cc=u,Se([E.$1h],u.prototype,"cachePath",null),e.$6cc=u=Se([ie(0,p.$8bc),ie(1,m.$3i),ie(2,a.$2l),ie(3,f.$Dbc),ie(4,k.$Np),ie(5,g.$3j),ie(6,y.$3k),ie(7,l.$Acc),ie(8,w.$jk)],u)}),define(re[135],oe([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,81,256,84,28,106,69,55,29,30,58,82,39,34,57,67,22,6]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k,a,t,r,s,i,o,u,$,P,D,I,O,M,W,F,T,q,ue,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=e.$5bc=void 0;var ce;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(ce||(ce={}));class K extends E.$Vc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(j.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(j.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(j.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(j.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(j.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(j.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const z=!(0,P.$BD)(this.r);if(d.$j&&z&&L.setSheetOffset((0,d.$J)((0,m.release)())?28:22),z&&(d.$i&&(0,P.$DD)(this.r)||d.$j)){const Q=this.s.getItem(K.D);Q&&this.updateWindowControls({height:Q})}d.$i&&z&&L.hookWindowMessage(278,()=>{const[ae,x]=L.getPosition(),le=n.screen.getCursorScreenPoint(),Z=le.x-ae,A=le.y-x;return!(Z>30&&A>=0&&A<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:Z,y:A})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),d.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(L,z,Q,ae){super(),this.r=L,this.s=z,this.t=Q,this.u=ae,this.a=this.B(new j.$ee),this.onDidClose=this.a.event,this.b=this.B(new j.$ee),this.onDidMaximize=this.b.event,this.c=this.B(new j.$ee),this.onDidUnmaximize=this.c.event,this.f=this.B(new j.$ee),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new j.$ee),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new j.$ee),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,P.$DD)(this.r),this.G=void 0,this.H=void 0}w(L,z=n.screen.getAllDisplays().length>0){const Q=this.r.getValue("window"),ae=d.$j&&Q?.nativeTabs===!0;(d.$j||d.$i)&&z&&(!ae||n.BrowserWindow.getAllWindows().length===1)&&[L.width,L.height,L.x,L.y].every(x=>typeof x=="number")&&this.m?.setBounds({width:L.width,height:L.height,x:L.x,y:L.y}),(L.mode===0||L.mode===3)&&(this.m?.maximize(),L.mode===3&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(L){d.$j?this.win?.setRepresentedFilename(L):this.z=L}getRepresentedFilename(){return d.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(L){d.$j&&this.win?.setDocumentEdited(L),this.C=L}isDocumentEdited(){return d.$j?!!this.win?.isDocumentEdited():!!this.C}focus(L){d.$j&&L?.force&&n.app.focus({steal:!0});const z=this.win;z&&(z.isMinimized()&&z.restore(),z.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(d.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.D="windowControlHeight"}updateWindowControls(L){const z=this.win;if(z){if(L.height&&this.s.setItem(G.D,L.height),d.$i&&this.F)z.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(d.$j&&L.height!==void 0){const Q=(L.height-15)/2;Q?z.setWindowButtonPosition({x:Q,y:Q}):z.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(L,z){(0,P.$ED)(this.r)?this.J(L,z):this.M(L)}get isFullScreen(){if(d.$j&&typeof this.G=="boolean")return this.G;const L=this.win,z=L?.isFullScreen(),Q=L?.isSimpleFullScreen();return!!(z||Q)}J(L,z){const Q=this.win;Q?.isSimpleFullScreen()&&Q?.setSimpleFullScreen(!1),this.L(L,z)}L(L,z){if(d.$j){this.G=L;const ae=this.H=new C.$Th;(async()=>{const x=await Promise.race([ae.p,(0,C.$xh)(1e4).then(()=>!1)]);this.H===ae&&(this.G=void 0,this.H=void 0,!x&&L&&z&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}M(L){const z=this.win;z?.isFullScreen()&&this.L(!1,!1),z?.setSimpleFullScreen(L),z?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$5bc=K;let G=class extends K{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const L=this.hb.profiles.find(z=>z.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.hb.getProfileForWorkspace(this.config.workspace??(0,I.$Ki)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(L,z,Q,ae,x,le,Z,A,N,_,ne,X,H,V,U,se,he,$e,me,ye,ke){super(_,ye,ae,z),this.fb=Q,this.gb=x,this.hb=le,this.ib=Z,this.jb=A,this.kb=N,this.lb=ne,this.mb=X,this.nb=H,this.ob=V,this.pb=U,this.qb=se,this.rb=he,this.sb=$e,this.tb=me,this.N=this.B(new j.$ee),this.onWillLoad=this.N.event,this.O=this.B(new j.$ee),this.onDidSignalReady=this.O.event,this.P=this.B(new j.$ee),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=0;{const[Ee,Oe]=this.Eb(L.state);this.U=Ee,this.u.trace("window#ctor: using window state",Ee);const we=ke.invokeFunction(D.$Pbc,this.U,{preload:h.$Qg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow(we),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Oe),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=2;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.X.push(L)})}get isReady(){return this.ub===2}get whenClosedOrLoaded(){return new Promise(L=>{function z(){Q.dispose(),ae.dispose(),L()}const Q=this.onDidClose(()=>z()),ae=this.onWillLoad(()=>z())})}vb(){this.B(j.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(1))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(z,Q)=>Q)(z=>this.yb(2,{...z}))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(z,Q,ae)=>({exitCode:Q,reason:ae}))(({exitCode:z,reason:Q})=>this.yb(3,{reason:Q,exitCode:z}))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(z=>z.preventDefault())),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",S.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",S.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(z=>this.Bb(z))),this.B(this.mb.onDidDeleteUntitledWorkspace(z=>this.Ab(z)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(z,Q)=>{const ae=await this.xb();Q({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,ae)})})}xb(){return this.wb||(this.wb=(0,s.$8p)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(L,z){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:L,reason:z?.reason,code:z?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:Q,checkboxChecked:ae}=await this.pb.showMessageBox({type:"warning",buttons:[(0,v.localize)(0,null),(0,v.localize)(1,null),(0,v.localize)(2,null)],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),checkboxLabel:this.S?.workspace?(0,v.localize)(5,null):void 0},this.m);if(Q!==2){const x=Q===0;await this.zb(x,ae)}}else if(L===2){let Q;z?Q=(0,v.localize)(7,null,z.reason,z.exitCode??"<unknown>"):Q=(0,v.localize)(6,null);const{response:ae,checkboxChecked:x}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,v.localize)(8,null):(0,v.localize)(9,null),(0,v.localize)(10,null)],message:Q,detail:this.S?.workspace?(0,v.localize)(11,null):(0,v.localize)(12,null),checkboxLabel:this.S?.workspace?(0,v.localize)(13,null):void 0},this.m),le=ae===0;await this.zb(le,x)}break}}async zb(L,z){const Q=this.S?.workspace;if(z&&Q)try{const ae=this.kb.workspaceStorage(Q);await ae.init(),ae.delete("memento/workbench.parts.editor"),await ae.close()}catch(ae){this.u.error(ae)}this.P.fire();try{if(L&&this.S){let ae,x;(0,I.$Gi)(Q)?ae={folderUri:Q.uri}:(0,I.$Li)(Q)?ae={workspaceUri:Q.configPath}:x=!0,(0,ue.$Ob)(await this.tb.open({context:5,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:ae?[ae]:void 0,forceEmpty:x,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(L){this.S?.workspace?.id===L.id&&(this.S.workspace=void 0)}Bb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const z=this.Gb();z!==this.W&&(this.W=z,this.Hb(z))}if(!L||L.affectsConfiguration("http.proxy")){let z=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const Q=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.Z||Q!==this.$)){this.Z=z,this.$=Q;const ae=z||"",x=Q?`${Q},<local>`:"<local>";this.u.trace(`Setting proxy to '${ae}', bypassing '${x}'`),this.m.webContents.session.setProxy({proxyRules:ae,proxyBypassRules:x,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:ae,proxyBypassRules:x,pacScript:""})}}}addTabbedWindow(L){d.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,z=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!z.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),z.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(L,z),this.ub===0?this.S=L:this.db=L,this.ub=1,this.m.loadURL(h.$Qg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const Q=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new C.$Ih(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:L.workspace,reason:z.isReload?3:Q?2:1})}Cb(L,z){const Q=(this.S??this.db)?.userEnv;if(Q){const ae=(0,l.$Am)(Q)&&!(0,l.$Am)(L.userEnv),x=this.isExtensionDevelopmentHost;(ae||x)&&(L.userEnv={...Q,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),z.disableExtensions!==void 0&&(L["disable-extensions"]=z.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.lb.getWindowSplash(),L.zoomLevel=this.Jb(),L.isCustomZoomLevel=typeof this.ab=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),L.perfMarks=(0,c.getMarks)(),this.bb.update(L)}async reload(L){const z=Object.assign({},this.S);z.workspace=await this.Db(z),delete z.filesToOpenOrCreate,delete z.filesToDiff,delete z.filesToMerge,delete z.filesToWait,this.isExtensionDevelopmentHost&&L&&(z.verbose=L.verbose,z.debugId=L.debugId,z.extensionEnvironment=L.extensionEnvironment,z["inspect-extensions"]=L["inspect-extensions"],z["inspect-brk-extensions"]=L["inspect-brk-extensions"],z["extensions-dir"]=L["extensions-dir"]),z.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),z.isInitialStartup=!1,z.policiesData=this.gb.serialize(),z.continueOn=this.t.continueOn,z.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},z.logLevel=this.fb.getLogLevel(),z.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(z,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Db(L){if((0,I.$Li)(L.workspace)){const z=L.workspace.configPath;if(z.scheme===h.Schemas.file&&!await this.ib.exists(z))return}else if((0,I.$Gi)(L.workspace)){const z=L.workspace.uri;if(z.scheme===h.Schemas.file&&!await this.ib.exists(z))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,M.$Bbc)();if(this.isFullScreen){let Q;try{Q=n.screen.getDisplayMatching(this.getBounds())}catch{}const ae=(0,M.$Bbc)();return{mode:3,display:Q?Q.id:void 0,width:this.U.width||ae.width,height:this.U.height||ae.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const L=Object.create(null);let z;if(!d.$j&&this.m.isMaximized()?z=0:z=1,z===0?L.mode=0:L.mode=1,z===1||z===0){let Q;z===1?Q=this.getBounds():Q=this.m.getNormalBounds(),L.x=Q.x,L.y=Q.y,L.width=Q.width,L.height=Q.height}return L.zoomLevel=this.ab,L}Eb(L){(0,c.mark)("code/willRestoreCodeWindowState");let z=!1;if(L){this.ab=L.zoomLevel;try{const Q=n.screen.getAllDisplays();z=Q.length>1,L=D.WindowStateValidator.validateWindowState(this.u,L,Q)}catch(Q){this.u.warn(`Unexpected error validating window state: ${Q}
${Q.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[L||(0,M.$Bbc)(),z]}getBounds(){const[L,z]=this.m.getPosition(),[Q,ae]=this.m.getSize();return{x:L,y:z,width:Q,height:ae}}I(L,z){super.I(L,z),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",S.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let L=(0,P.$zD)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Hb(L,z=!0){d.$j||(L==="toggle"&&z&&this.send("vscode:showInfoMessage",(0,v.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Ib(L)}):this.Ib(L))}Ib(L){const z=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!z),this.m.autoHideMenuBar=z;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.ab=L}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,z,...Q){this.isReady?this.send(L,...Q):this.ready().then(()=>{z.isCancellationRequested||this.send(L,...Q)})}send(L,...z){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...z)}catch(Q){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.Q}: ${(0,R.$hj)(Q)}`)}}}updateTouchBar(L){d.$j&&this.Y.forEach((z,Q)=>{const ae=L[Q];z.segments=this.Mb(ae)})}Kb(){if(d.$j){for(let L=0;L<10;L++){const z=this.Lb();this.Y.push(z)}this.m.setTouchBar(new n.TouchBar({items:this.Y}))}}Lb(L=[]){const z=this.Mb(L),Q=new n.TouchBar.TouchBarSegmentedControl({segments:z,mode:"buttons",segmentStyle:"automatic",change:ae=>{this.sendWhenReady("vscode:runAction",S.CancellationToken.None,{id:Q.segments[ae].id,from:"touchbar"})}});return Q}Mb(L=[]){return L.map(Q=>{let ae;Q.icon&&!u.ThemeIcon.isThemeIcon(Q.icon)&&Q.icon?.dark?.scheme===h.Schemas.file&&(ae=n.nativeImage.createFromPath(b.URI.revive(Q.icon.dark).fsPath),ae.isEmpty()&&(ae=void 0));let x;return typeof Q.title=="string"?x=Q.title:x=Q.title.value,{id:Q.id,label:ae?void 0:x,icon:ae}})}matches(L){return this.m?.webContents.id===L.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$6bc=G,e.$6bc=G=Se([ie(1,a.$3j),ie(2,q.$3bc),ie(3,g.$Dbc),ie(4,W.$eo),ie(5,T.$Rbc),ie(6,w.$3k),ie(7,i.$dcc),ie(8,i.$bcc),ie(9,y.$3i),ie(10,$.$Mbc),ie(11,O.$1bc),ie(12,f.$Ibc),ie(13,o.$2l),ie(14,p.$Jbc),ie(15,k.$8bc),ie(16,t.$jk),ie(17,r.$Lbc),ie(18,D.$Obc),ie(19,F.$GQ),ie(20,ee.$vi)],G)}),define(re[306],oe([0,1,14,4,18,24,20,5,34,55,135]),function(J,e,n,C,S,R,j,E,h,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=void 0;let b=class extends d.$5bc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(m,f,y,p,g,l){super(p,g,f,y),this.O=m,this.P=l,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(m){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),m&&!this.N&&(this.N=!0,this.w({x:m.x,y:m.y,width:m.width,height:m.height,mode:m.show===!1?0:1})))}Q(){if(this.m)return;const m=n.BrowserWindow.fromWebContents(this.O);m&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(m),m.setMenu(null),(C.$i||C.$k)&&(0,c.$BD)(this.r)&&m.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(m){return this.O.id===m.id}};e.$7bc=b,e.$7bc=b=Se([ie(1,R.$Dbc),ie(2,E.$3j),ie(3,S.$3i),ie(4,h.$GQ),ie(5,j.$8bc)],b)}),define(re[307],oe([0,1,14,3,2,13,37,306,6,5,82,29]),function(J,e,n,C,S,R,j,E,h,c,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;let v=class extends S.$Vc{constructor(f,y){super(),this.h=f,this.j=y,this.a=this.B(new C.$ee),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new C.$ee),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new C.$ee),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new C.$ee),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(f,y)=>{const p=this.getWindowByWebContents(y.webContents);if(p)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow();else{const g=new S.$Uc;g.add(C.Event.fromNodeEventEmitter(y.webContents,"did-create-window",(l,w)=>({browserWindow:l,details:w}))(({browserWindow:l,details:w})=>{const k=this.getWindowByWebContents(l.webContents);k&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),k.tryClaimWindow(w.options))})),g.add(C.Event.fromNodeEventEmitter(y,"closed")(()=>g.dispose()))}}),j.$VW.handle("vscode:registerAuxiliaryWindow",async(f,y)=>{const p=this.getWindowByWebContents(f.sender);return p&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=y),f.sender.id})}createWindow(f){return this.h.invokeFunction(b.$Pbc,this.n(f),{preload:R.$Qg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const y={},p=f.features.split(",");for(const l of p){const[w,k]=l.split("=");switch(w){case"width":y.width=parseInt(k,10);break;case"height":y.height=parseInt(k,10);break;case"left":y.x=parseInt(k,10);break;case"top":y.y=parseInt(k,10);break;case"window-maximized":y.mode=0;break;case"window-fullscreen":y.mode=3;break}}const g=b.WindowStateValidator.validateWindowState(this.j,y)??(0,d.$Cbc)();return this.j.trace("[aux window] using window state",g),g}registerWindow(f){const y=new S.$Uc,p=this.h.createInstance(E.$7bc,f);this.g.set(p.id,p),y.add((0,S.$Tc)(()=>this.g.delete(p.id))),y.add(p.onDidMaximize(()=>this.a.fire(p))),y.add(p.onDidUnmaximize(()=>this.b.fire(p))),y.add(p.onDidEnterFullScreen(()=>this.c.fire({window:p,fullscreen:!0}))),y.add(p.onDidLeaveFullScreen(()=>this.c.fire({window:p,fullscreen:!1}))),y.add(p.onDidTriggerSystemContextMenu(({x:g,y:l})=>this.f.fire({window:p,x:g,y:l}))),C.Event.once(p.onDidClose)(()=>y.dispose())}getWindowByWebContents(f){const y=this.g.get(f.id);return y?.matches(f)?y:void 0}getFocusedWindow(){const f=n.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,b.$Qbc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$ydc=v,e.$ydc=v=Se([ie(0,h.$vi),ie(1,c.$3j)],v)}),define(re[85],oe([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,84,98,30,58,32,56]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=e.$Mcc=void 0,e.$Mcc=(0,f.$wi)("workspacesHistoryMainService");let s=class extends E.$Vc{static{r=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(o,u,$,P,D){super(),this.f=o,this.g=u,this.h=$,this.j=P,this.m=D,this.c=this.B(new R.$ee),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new S.$uh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){let u=[],$=[];for(const D of o)if((0,l.$ngb)(D))!this.g.isUntitledWorkspace(D.workspace)&&!this.w(u,D.workspace)&&u.push(D);else if((0,l.$ogb)(D))this.y(u,D.folderUri)||u.push(D);else{const I=this.z($,D.fileUri),O=D.fileUri.scheme===h.Schemas.file&&r.G.indexOf((0,d.$7g)(D.fileUri))>=0;!I&&!O&&($.push(D),c.$i&&D.fileUri.scheme===h.Schemas.file&&n.app.addRecentDocument(D.fileUri.fsPath))}const P=await this.r({workspaces:u,files:$});u=P.workspaces,$=P.files,u.length>r.a&&(u.length=r.a),$.length>r.a&&($.length=r.a),await this.t({workspaces:u,files:$}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(o){const u=I=>{const O=this.u(I);for(const M of o)if(d.$1g.isEqual(M,O))return!1;return!0},$=await this.getRecentlyOpened(),P=$.workspaces.filter(u),D=$.files.filter(u);(P.length!==$.workspaces.length||D.length!==$.files.length)&&(await this.t({files:D,workspaces:P}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(o){if(o?.confirm){const{response:u}=await this.m.showMessageBox({type:"warning",buttons:[(0,m.localize)(0,null),(0,m.localize)(1,null)],message:(0,m.localize)(2,null),detail:(0,m.localize)(3,null),cancelId:1});if(u!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(o){const u=new a.$Bc(D=>d.$1g.getComparisonKey(D));if(o?.workspaces)for(const D of o.workspaces)u.set(this.u(D),D);const $=new a.$Bc(D=>d.$1g.getComparisonKey(D));if(o?.files)for(const D of o.files)$.set(this.u(D),D);const P=await this.s();for(const D of P.workspaces){const I=u.get(this.u(D));I?I.label=I.label??D.label:u.set(this.u(D),D)}for(const D of P.files){const I=$.get(this.u(D));I?I.label=I.label??D.label:$.set(this.u(D),D)}return{workspaces:[...u.values()],files:[...$.values()]}}async s(){await this.j.whenReady;let o;const u=this.j.get(r.b,-1);if(typeof u=="string")try{o=JSON.parse(u)}catch($){this.f.error("Unexpected error parsing opened paths list",$)}return(0,l.$ugb)(o,this.f)}async t(o){await this.j.whenReady,this.j.store(r.b,JSON.stringify((0,l.$vgb)(o)),-1,1)}u(o){return(0,l.$ogb)(o)?o.folderUri:(0,l.$pgb)(o)?o.fileUri:o.workspace.configPath}w(o,u){return!!o.find($=>(0,l.$ngb)($)&&$.workspace.id===u.id)}y(o,u){return!!o.find($=>(0,l.$ogb)($)&&d.$1g.isEqual($.folderUri,u))}z(o,u){return!!o.find($=>d.$1g.isEqual($.fileUri,u))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(4,null),description:(0,m.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const u=[];for(const D of n.app.getJumpListSettings().removedItems){const I=D.args;if(I){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(I);O&&u.push(b.URI.parse(O[2]))}}await this.removeRecentlyOpened(u);let $=!1;const P=(0,C.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,r.F).map(D=>{const I=(0,l.$ngb)(D)?D.workspace:D.folderUri,{title:O,description:M}=this.L(I,D.label);let W;return b.URI.isUri(I)?W=`--folder-uri "${I.toString()}"`:($=!0,W=`--file-uri "${I.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:M.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));P.length>0&&o.push({type:"custom",name:$?(0,m.localize)(6,null):(0,m.localize)(7,null),items:P})}o.push({type:"recent"});try{const u=n.app.setJumpList(o);u&&u!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${u}`)}catch(u){this.f.warn("updateWindowsJumpList#setJumpList",u)}}L(o,u){if(u)return{title:(0,j.$Gw)(u).name,description:u};if(b.URI.isUri(o))return{title:(0,d.$7g)(o),description:this.M(o)};if(this.g.isUntitledWorkspace(o))return{title:(0,m.localize)(8,null),description:""};let $=(0,d.$7g)(o.configPath);return $.endsWith(w.$Si)&&($=$.substr(0,$.length-w.$Si.length-1)),{title:(0,m.localize)(9,null,$),description:this.M(o.configPath)}}M(o){return o.scheme==="file"?(0,j.$yw)(o.fsPath):o.toString()}async N(){if(!c.$j)return;n.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),u=[];let $=0;for(let D=0;D<o.workspaces.length&&$<r.C;D++){const I=this.u(o.workspaces[D]);if(I.scheme===h.Schemas.file){const O=(0,d.$Xg)(I);await v.Promises.exists(O)&&(u.push(O),$++)}}const P=[];for(let D=0;D<o.files.length&&$<r.D;D++){const I=this.u(o.files[D]);if(I.scheme===h.Schemas.file){const O=(0,d.$Xg)(I);if(r.G.includes((0,d.$7g)(I))||u.includes(O))continue;await v.Promises.exists(O)&&(P.push(O),$++)}}P.reverse().forEach(D=>n.app.addRecentDocument(D)),u.reverse().forEach(D=>n.app.addRecentDocument(D))}};e.$Ncc=s,e.$Ncc=s=r=Se([ie(0,p.$3j),ie(1,k.$1bc),ie(2,y.$8bc),ie(3,g.$dcc),ie(4,t.$Jbc)],s)}),define(re[308],oe([0,1,14,8,23,48,4,7,184,79,18,24,20,5,235,70,27,34,28,50,55,29,85]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;const s="menu";let i=class{static{r=this}static{this.a="lastKnownMenubarData"}constructor($,P,D,I,O,M,W,F,T,q,ue,ee){this.n=$,this.o=P,this.p=D,this.q=I,this.r=O,this.s=M,this.t=W,this.u=F,this.v=T,this.w=q,this.x=ue,this.y=ee,this.m=Object.create(null),this.g=new C.$Ih(()=>this.F(),0),this.h=new C.$Ih(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(j.$j||(0,k.$BD)(P))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const $=this.t.getItem(r.a);$&&($.menus&&(this.k=$.menus),$.keybindings&&(this.l=$.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(M,W,F)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:W?.id})},this.m["workbench.action.newWindow"]=(M,W,F)=>this.p.openEmptyWindow({context:2,contextWindowId:W?.id}),this.m["workbench.action.files.openFileFolder"]=(M,W,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.files.openFolder"]=(M,W,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.openWorkspace"]=(M,W,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const $=this.x.youTubeUrl;$&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab($,"openYouTubeUrl"));const P=this.x.requestFeatureUrl;P&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(P,"openUserVoiceUrl"));const D=this.x.reportIssueUrl;D&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(D,"openReportIssues"));const I=this.x.licenseUrl;I&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(j.$w){const M=I.indexOf("?")>0?"&":"?";this.ab(`${I}${M}lang=${j.$w}`,"openLicenseUrl")}else this.ab(I,"openLicenseUrl")});const O=this.x.privacyStatementUrl;O&&I&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(O,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount($=>this.G($)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const $=this.o.getValue("window.enableMenuBarMnemonics");return typeof $!="boolean"?!0:$}get D(){if(!j.$j)return!1;const $=this.o.getValue("window.nativeTabs");return typeof $!="boolean"?!1:$}updateMenu($,P){this.k=$.menus,this.l=$.keybindings,this.t.setItem(r.a,$),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G($){j.$j&&($.oldCount===0&&$.newCount>0||$.oldCount>0&&$.newCount===0)&&(this.d=$.newCount===0,this.E())}H(){if(!j.$j)return;const $=n.BrowserWindow.getFocusedWindow();this.f=!$||!!this.y.getWindowByWebContents($.webContents),this.E()}I(){const $=n.Menu.getApplicationMenu();if($&&this.j.push($),Object.keys(this.k).length===0){this.J(j.$j?new n.Menu:null);return}const P=new n.Menu;let D;if(j.$j){const O=new n.Menu;D=new n.MenuItem({label:this.x.nameShort,submenu:O}),this.K(O),P.append(D)}if(j.$j&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.cb(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),n.app.dock.setMenu(O)}if(this.M("File")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(1,null)),submenu:O});this.O(O,"File"),P.append(M)}if(this.M("Edit")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(2,null)),submenu:O});this.O(O,"Edit"),P.append(M)}if(this.M("Selection")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(3,null)),submenu:O});this.O(O,"Selection"),P.append(M)}if(this.M("View")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(4,null)),submenu:O});this.O(O,"View"),P.append(M)}if(this.M("Go")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(5,null)),submenu:O});this.O(O,"Go"),P.append(M)}if(this.M("Run")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(6,null)),submenu:O});this.O(O,"Run"),P.append(M)}if(this.M("Terminal")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(7,null)),submenu:O});this.O(O,"Terminal"),P.append(M)}let I;if(this.M("Window")){const O=new n.Menu;I=new n.MenuItem({label:this.cb(h.localize(8,null)),submenu:O,role:"window"}),this.U(O)}if(I&&P.append(I),this.M("Help")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(9,null)),submenu:O,role:"help"});this.O(O,"Help"),P.append(M)}P.items&&P.items.length>0?this.J(P):this.J(null),this.h.schedule()}J($){if(n.Menu.setApplicationMenu($),$)for(const P of this.y.getWindows())P.win?.setMenu(null)}K($){const P=this.W(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),D=this.V();let I;if(this.M("Preferences")){const ee=new n.Menu;this.O(ee,"Preferences"),I=new n.MenuItem({label:this.cb(h.localize(11,null)),submenu:ee})}const O=new n.Menu,M=new n.MenuItem({label:h.localize(12,null),role:"services",submenu:O}),W=new n.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new n.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),T=new n.MenuItem({label:h.localize(15,null),role:"unhide"}),q=new n.MenuItem(this.$("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(ee,ce,K)=>{const G=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||G?.win?.isMinimized())&&await this.L(K)&&this.w.quit(void 0)}})),ue=[P];ue.push(...D),I&&ue.push(o(),I),ue.push(o(),M,o(),W,F,T,o(),q),ue.forEach(ee=>$.append(ee))}async L($){if(this.p.getWindowCount()===0)return!0;const P=this.o.getValue("window.confirmBeforeClose");if(P==="always"||P==="keyboardOnly"&&this.S($)){const{response:D}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return D===0}return!0}M($){if(!j.$j&&!(0,k.$BD)(this.o))return!1;switch($){case"File":case"Help":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[$];case"Window":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[$]}}N($,P){P.forEach(D=>{if((0,f.$Jcc)(D))$.append(o());else if((0,f.$Icc)(D)){const I=new n.Menu,O=new n.MenuItem({label:this.cb(D.label),submenu:I});this.N(I,D.submenu.items),$.append(O)}else(0,f.$Kcc)(D)?$.append(this.Q(D)):(0,f.$Lcc)(D)&&(D.id==="workbench.action.showAboutDialog"&&this.P($),j.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[D.id]?$.append(new n.MenuItem(this.$(D.id,{label:this.cb(D.label),click:this.m[D.id]}))):$.append(this.W(D.label,D.id,!1,D.checked)):$.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)):$.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)))})}O($,P){this.k&&this.k[P]&&this.N($,this.k[P].items)}P($){const P=this.V();P.length&&(P.forEach(D=>$.append(D)),$.append(o()))}Q($){const P=E.URI.revive($.uri),D=$.id,I=D==="openRecentFile"?{fileUri:P}:D==="openRecentWorkspace"?{workspaceUri:P}:{folderUri:P};return new n.MenuItem(this.$(D,{label:$.label,click:async(O,M,W)=>{const F=this.R(W);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[I],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:$.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([P])}},!1))}R($){return!!($&&(!j.$j&&($.ctrlKey||$.shiftKey)||j.$j&&($.metaKey||$.altKey)))}S($){return!!($.triggeredByAccelerator||$.altKey||$.ctrlKey||$.metaKey||$.shiftKey)}T($,P,D){const I={label:this.cb($),role:D,enabled:!0};return new n.MenuItem(this.Z(P,I))}U($){const P=new n.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),D=new n.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),I=new n.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),O=this.W(h.localize(23,null),"workbench.action.switchWindow"),M=[];this.D&&(M.push(o()),M.push(this.W(h.localize(24,null),"workbench.action.newWindowTab")),M.push(this.T(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.T(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.T(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.T(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[P,D,o(),O,...M,o(),I].forEach(W=>$.append(W))}V(){switch(this.n.state.type){case"idle":return[new n.MenuItem({label:this.cb(h.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.cb(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return j.$j?[]:[new n.MenuItem({label:this.cb(h.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new n.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.cb(h.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W($,P,D,I){const O=this.cb($),M=typeof P=="function"?P:(ue,ee,ce)=>{const K=ue?ue.userSettingsLabel:null;let G=P;Array.isArray(P)&&(G=this.R(ce)?P[1]:P[0]),K&&ce.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:K}):this.Y({type:"commandId",commandId:G})},W=typeof D=="boolean"?D:this.p.getWindowCount()>0,F=typeof I=="boolean"?I:!1,T={label:O,click:M,enabled:W};F&&(T.type="checkbox",T.checked=F);let q;return typeof P=="string"?q=P:Array.isArray(P)&&(q=P[0]),j.$j&&(q==="editor.action.clipboardCutAction"?T.role="cut":q==="editor.action.clipboardCopyAction"?T.role="copy":q==="editor.action.clipboardPasteAction"&&(T.role="paste"),q==="undo"?T.click=this.X(M,{inDevTools:ue=>ue.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?T.click=this.X(M,{inDevTools:ue=>ue.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&(T.click=this.X(M,{inDevTools:ue=>ue.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.Z(q,T))}X($,P){return(D,I,O)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return P.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return P.inDevTools(M.webContents.devToolsWebContents);$(D,I||M,O)}}Y($){let P=n.BrowserWindow.getFocusedWindow();if(P){const I=this.y.getWindowByWebContents(P.webContents);I&&(P=this.p.getWindowById(I.parentId)?.win??null)}if(!P){const I=this.p.getLastActiveWindow();I?.win?.isMinimized()&&(P=I.win)}const D=P?this.p.getWindowById(P.id):void 0;if(D){if(this.v.trace("menubar#runActionInRenderer",$),j.$j&&!this.q.isBuilt&&!D.isReady&&($.type==="commandId"&&$.commandId==="workbench.action.toggleDevTools"||$.type!=="commandId"&&$.userSettingsLabel==="alt+cmd+i"))return!1;if($.type==="commandId"){const I={id:$.commandId,from:"menu"};D.sendWhenReady("vscode:runAction",S.CancellationToken.None,I)}else{const I={userSettingsLabel:$.userSettingsLabel};D.sendWhenReady("vscode:runKeybinding",S.CancellationToken.None,I)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",$),!1}Z($,P){const D=typeof $=="string"?this.l[$]:void 0;if(D?.label){if(D.isNative!==!1)P.accelerator=D.label,P.userSettingsLabel=D.userSettingsLabel;else if(typeof P.label=="string"){const I=P.label.indexOf("[");I>=0?P.label=`${P.label.substr(0,I)} [${D.label}]`:P.label=`${P.label} [${D.label}]`}}else P.accelerator=void 0;return P}$($,P,D=!P.accelerator){D&&(P=this.Z($,P));const I=P.click;return P.click=(O,M,W)=>{this.bb($),I?.(O,M,W)},P}ab($,P){this.w.openExternal(void 0,$),this.bb(P)}bb($){this.r.publicLog2("workbenchActionExecuted",{id:$,from:s})}cb($){return(0,R.$Dw)($,!this.C)}};e.$Occ=i,e.$Occ=i=r=Se([ie(0,w.$UX),ie(1,d.$3i),ie(2,a.$Obc),ie(3,b.$Dbc),ie(4,l.$2l),ie(5,t.$Mcc),ie(6,g.$GQ),ie(7,v.$8bc),ie(8,m.$3j),ie(9,y.$Acc),ie(10,p.$jk),ie(11,c.$zcc)],i);function o(){return new n.MenuItem({type:"separator"})}}),define(re[309],oe([0,1,6,20,5,308]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=e.$Pcc=void 0,e.$Pcc=(0,n.$wi)("menubarMainService");let j=class{constructor(h,c,d){this.b=h,this.c=c,this.d=d,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.$Occ)}async updateMenubar(h,c){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(c,h)}};e.$Qcc=j,e.$Qcc=j=Se([ie(0,n.$vi),ie(1,C.$8bc),ie(2,S.$3j)],j)}),define(re[310],oe([0,1,14,21,102,26,22,23,3,31,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,80,81,68,34,55,135,29,133,302,30,99,85,58,69,39,57,67,79]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k,a,t,r,s,i,o,u,$,P,D,I,O,M,W,F,T,q,ue,ee,ce,K,G,B,L,z,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;function ae(Z){return(0,ue.$Li)(Z?.workspace)}function x(Z){return(0,ue.$Gi)(Z?.workspace)}let le=class extends b.$Vc{constructor(A,N,_,ne,X,H,V,U,se,he,$e,me,ye,ke,Ee,Oe,we,Y,fe,ge){super(),this.s=A,this.t=N,this.u=_,this.w=ne,this.z=X,this.C=H,this.D=V,this.F=U,this.G=se,this.H=he,this.I=$e,this.J=me,this.L=ye,this.M=ke,this.N=Ee,this.O=Oe,this.P=we,this.Q=Y,this.R=fe,this.S=ge,this.a=this.B(new h.$ee),this.onDidOpenWindow=this.a.event,this.b=this.B(new h.$ee),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new h.$ee),this.onDidDestroyWindow=this.c.event,this.f=this.B(new h.$ee),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new h.$ee),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new h.$ee),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new h.$ee),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new h.$ee),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new q.$bdc(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(A=>this.b.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const N=new b.$Uc;if(N.add(h.Event.any(A.onDidClose,A.onDidDestroy)(()=>N.dispose())),A.config.extensionDevelopmentPath)for(const _ of A.config.extensionDevelopmentPath)N.add(this.Q.addValidFileRoot(_));A.config.extensionTestsPath&&N.add(this.Q.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,N){const _=this.F.args,ne=N?.remoteAuthority||void 0,X=!0,H=N?.forceReuseWindow,V=!H;return this.open({...A,cli:_,forceEmpty:X,forceNewWindow:V,forceReuseWindow:H,remoteAuthority:ne})}openExistingWindow(A,N){A.focus(),this.W(N,[A])}async open(A){this.w.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const N=[],_=[],ne=[],X=[],H=[];let V,U=0;const se=await this.cb(A);this.w.trace("windowsManager#open pathsToOpen",se);for(const ke of se)x(ke)?A.addMode?N.push(ke):_.push(ke):ae(ke)?ne.push(ke):ke.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),V.filesToOpenOrCreate.push(ke)):ke.backupPath?H.push({backupFolder:(0,m.$oc)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):U++;A.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),A.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&A.waitMarkerFileURI&&(V.filesToWait={paths:(0,j.$Hb)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(X.push(...this.M.getUntitledWorkspaces()),ne.push(...X),H.push(...this.I.getEmptyWindowBackups())):H.length=0;const{windows:he,filesOpenedInWindow:$e}=await this.X(A,ne,_,H,U,V,N);if(this.w.trace(`windowsManager#open used window count ${he.length} (workspacesToOpen: ${ne.length}, foldersToOpen: ${_.length}, emptyToRestore: ${H.length}, emptyToOpen: ${U})`),he.length>1)if($e)$e.focus();else{const ke=this.r.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let Ee=!0,Oe=!0;if(ke){const we=he.filter(Y=>this.r.state.lastActiveWindow&&Y.backupPath===this.r.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Ee=!1,Oe=!1)}if(Ee)for(let we=he.length-1;we>=0;we--){const Y=he[we];if(!(Y.openedWorkspace&&X.some(fe=>Y.openedWorkspace&&fe.workspace.id===Y.openedWorkspace.id)||Y.backupPath&&H.some(fe=>Y.backupPath&&fe.backupFolder===(0,m.$oc)(Y.backupPath)))){Y.focus(),Oe=!1;break}}Oe&&he[he.length-1].focus()}const me=V&&V.filesToDiff.length>0,ye=V&&V.filesToMerge.length>0;if(!he.some(ke=>ke.isExtensionDevelopmentHost)&&!me&&!ye&&!A.noRecentEntry){const ke=[];for(const Ee of se)ae(Ee)&&!Ee.transient?ke.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):x(Ee)?ke.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&ke.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.L.addRecentlyOpened(ke)}return this.W(A,he),he}W(A,N){const _=A.waitMarkerFileURI;A.context===0&&_&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(A,N,_,ne,X,H,V){const U=[];let se;function he(we,Y){U.push(we),Y&&(se=we,H=void 0)}let{openFolderInNewWindow:$e,openFilesInNewWindow:me}=this.ob(A);if(!A.initialStartup&&V.length>0){const we=V[0].remoteAuthority,Y=this.ub(we);Y&&he(this.$(Y,V.map(fe=>fe.workspace.uri)))}const ye=_.length+N.length+ne.length;if(H&&ye===0){const we=H.filesToOpenOrCreate[0]||H.filesToDiff[0]||H.filesToMerge[3],Y=this.getWindows().filter(ge=>H&&(0,g.$ch)(ge.remoteAuthority,H.remoteAuthority));let fe;we?.fileUri&&!me&&((A.context===4||A.context===0||A.context===1)&&(fe=await(0,T.$Tbc)(Y,we.fileUri,async ge=>ge.configPath.scheme===v.Schemas.file?this.M.resolveLocalWorkspace(ge.configPath):void 0)),fe||(fe=this.vb(Y))),fe?(0,ue.$Li)(fe.openedWorkspace)?N.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,ue.$Gi)(fe.openedWorkspace)?_.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):he(this.Y(A,fe,H),!0):he(await this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:H,forceNewWindow:!0,remoteAuthority:H.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const ke=(0,j.$Mb)(N,we=>we.workspace.id);if(ke.length>0){const we=(0,j.$Hb)(ke.map(Y=>(0,T.$Ubc)(this.getWindows(),Y.workspace.configPath)));if(we.length>0){const Y=we[0],fe=(0,g.$ch)(H?.remoteAuthority,Y.remoteAuthority)?H:void 0;he(this.Y(A,Y,fe),!!fe),$e=!0}for(const Y of ke){if(we.some(je=>je.openedWorkspace&&je.openedWorkspace.id===Y.workspace.id))continue;const fe=Y.remoteAuthority,ge=(0,g.$ch)(H?.remoteAuthority,fe)?H:void 0;he(await this.bb(A,Y,$e,ge),!!ge),$e=!0}}const Ee=(0,j.$Mb)(_,we=>g.$1g.getComparisonKey(we.workspace.uri));if(Ee.length>0){const we=(0,j.$Hb)(Ee.map(Y=>(0,T.$Ubc)(this.getWindows(),Y.workspace.uri)));if(we.length>0){const Y=we[0],fe=(0,g.$ch)(H?.remoteAuthority,Y.remoteAuthority)?H:void 0;he(this.Y(A,Y,fe),!!fe),$e=!0}for(const Y of Ee){if(we.some(je=>(0,ue.$Gi)(je.openedWorkspace)&&g.$1g.isEqual(je.openedWorkspace.uri,Y.workspace.uri)))continue;const fe=Y.remoteAuthority,ge=(0,g.$ch)(H?.remoteAuthority,fe)?H:void 0;he(await this.bb(A,Y,$e,ge),!!ge),$e=!0}}const Oe=(0,j.$Mb)(ne,we=>we.backupFolder);if(Oe.length>0)for(const we of Oe){const Y=we.remoteAuthority,fe=(0,g.$ch)(H?.remoteAuthority,Y)?H:void 0;he(await this.ab(A,!0,Y,fe,we),!!fe),$e=!0}if(U.length===0||H){H&&!X&&X++;const we=H?H.remoteAuthority:A.remoteAuthority;for(let Y=0;Y<X;Y++)he(await this.ab(A,$e,we,H),!!H),$e=!0}return{windows:(0,j.$Mb)(U),filesOpenedInWindow:se}}Y(A,N,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(N);const ne={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",E.CancellationToken.None,ne),N}Z(A){let N=A;const _=n.BrowserWindow.getFocusedWindow();if(_&&_.id!==A.id){const ne=this.S.getWindowByWebContents(_.webContents);ne&&ne.parentId===A.id&&(N=ne)}N.focus()}$(A,N){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),A.focus();const _={foldersToAdd:N};return A.sendWhenReady("vscode:addFolders",E.CancellationToken.None,_),A}ab(A,N,_,ne,X){this.w.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:_,filesToOpen:ne,forceNewWindow:N});let H;return!N&&typeof A.contextWindowId=="number"&&(H=this.getWindowById(A.contextWindowId)),this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:_,forceNewWindow:N,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:ne,windowToUse:H,emptyWindowBackupInfo:X,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}bb(A,N,_,ne,X){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:ne}),!_&&!X&&typeof A.contextWindowId=="number"&&(X=this.getWindowById(A.contextWindowId)),this.pb({workspace:N.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:ne,windowToUse:X,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async cb(A){let N,_=!1,ne=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(N=await this.db(A),_=!0):A.forceEmpty?N=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(N=await this.eb(A.cli),N.length===0&&N.push(Object.create(null)),_=!0):(N=await this.gb(),N.length===0&&N.push(Object.create(null)),ne=!0),!A.addMode&&_){const X=N.filter(H=>x(H));if(X.length>1){const H=X[0].remoteAuthority;if(X.every(V=>(0,g.$ch)(V.remoteAuthority,H))){const V=await this.M.createUntitledWorkspace(X.map(U=>({uri:U.workspace.uri})));N.push({workspace:V,remoteAuthority:H}),N=N.filter(U=>!x(U))}}}if(A.initialStartup&&!ne&&this.J.getValue("window")?.restoreWindows==="preserve"){const X=await this.gb();N.unshift(...X.filter(H=>ae(H)||x(H)||H.backupPath))}return N}async db(A){const N={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},_=await Promise.all((0,j.$Hb)(A.urisToOpen||[]).map(async ne=>{const X=await this.ib(ne,N);if(X)return X.label=ne.label,X;const H=this.kb(ne);this.O.showMessageBox({type:"info",buttons:[(0,k.localize)(0,null)],message:H.scheme===v.Schemas.file?(0,k.localize)(1,null):(0,k.localize)(2,null),detail:H.scheme===v.Schemas.file?(0,k.localize)(3,null,(0,d.$xw)(H,{os:y.OS,tildify:this.F})):(0,k.localize)(4,null,H.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,j.$Hb)(_)}async eb(A){const N=[],_={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},ne=A["folder-uri"];if(ne){const V=await Promise.all(ne.map(U=>{const se=this.fb(U);if(se)return this.ib({folderUri:se},_)}));N.push(...(0,j.$Hb)(V))}const X=A["file-uri"];if(X){const V=await Promise.all(X.map(U=>{const se=this.fb(U);if(se)return this.ib((0,ue.$2i)(U)?{workspaceUri:se}:{fileUri:se},_)}));N.push(...(0,j.$Hb)(V))}const H=await Promise.all(A._.map(V=>_.remoteAuthority?this.nb(V,_):this.lb(V,_)));return N.push(...(0,j.$Hb)(H)),N}fb(A){try{const N=w.URI.parse(A);if(!N.scheme){this.w.error(`Invalid URI input string, scheme missing: ${A}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.w.error(`Invalid URI input string: ${A}, ${N.message}`)}}async gb(){const A=this.hb();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];A!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const _=await Promise.all(N.map(async ne=>{if(ne.workspace){const X=await this.ib({workspaceUri:ne.workspace.configPath},{remoteAuthority:ne.remoteAuthority,rejectTransientWorkspaces:!0});if(ae(X))return X}else if(ne.folderUri){const X=await this.ib({folderUri:ne.folderUri},{remoteAuthority:ne.remoteAuthority});if(x(X))return X}else if(A!=="folders"&&ne.backupPath)return{backupPath:ne.backupPath,remoteAuthority:ne.remoteAuthority}}));return(0,j.$Hb)(_)}}}hb(){let A;return this.H.wasRestarted?A="all":(A=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async ib(A,N=Object.create(null)){const _=this.kb(A);return _.scheme===v.Schemas.file?((0,M.$yD)(A)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,N)):this.jb(A,N)}jb(A,N){let _=this.kb(A);const ne=(0,I.$Hm)(_)||N.remoteAuthority;if(_=(0,g.$eh)((0,g.$$g)(_)),(0,M.$yD)(A)){if(N.gotoLineMode){const{path:X,line:H,column:V}=(0,c.$Dg)(_.path);return{fileUri:_.with({path:X}),options:{selection:H?{startLineNumber:H,startColumn:V||1}:void 0},remoteAuthority:ne}}return{fileUri:_,remoteAuthority:ne}}else if((0,M.$wD)(A))return{workspace:(0,ee.$Xbc)(_),remoteAuthority:ne};return{workspace:(0,ee.$Ybc)(_),remoteAuthority:ne}}kb(A){return(0,M.$wD)(A)?A.workspaceUri:(0,M.$xD)(A)?A.folderUri:A.fileUri}async lb(A,N,_){let ne,X;N.gotoLineMode&&({path:A,line:ne,column:X}=(0,c.$Dg)(A)),A=(0,c.$xg)((0,m.$ic)(A),(0,p.cwd)());try{const H=await C.Promises.stat(A);if(H.isFile()){if(!N.forceOpenWorkspaceAsFile){const V=await this.M.resolveLocalWorkspace(w.URI.file(A));if(V)return V.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:i.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:w.URI.file(A),type:i.FileType.File,exists:!0,options:{selection:ne?{startLineNumber:ne,startColumn:X||1}:void 0}}}else{if(H.isDirectory())return{workspace:(0,ee.$Ybc)(w.URI.file(A),H),type:i.FileType.Directory,exists:!0};if(!y.$i&&A==="/dev/null")return{fileUri:w.URI.file(A),type:i.FileType.File,exists:!0}}}catch(H){if(H.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(A,N);const V=w.URI.file(A);if(this.L.removeRecentlyOpened([V]),N.ignoreFileNotFound)return{fileUri:V,type:i.FileType.File,exists:!1}}}async mb(A,N){const _=w.URI.file(A),{response:ne,checkboxChecked:X}=await this.O.showMessageBox({type:"warning",buttons:[(0,k.localize)(5,null),(0,k.localize)(6,null),(0,k.localize)(7,null)],message:(0,k.localize)(8,null,_.authority),detail:(0,k.localize)(9,null,(0,d.$xw)(_,{os:y.OS,tildify:this.F})),checkboxLabel:(0,k.localize)(10,null,_.authority),cancelId:1});if(ne===0){if((0,S.addUNCHostToAllowlist)(_.authority),X){const H={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(H.channel,H.args),this.sendToOpeningWindow(H.channel,H.args)}return this.lb(A,N,!0)}if(ne===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(A,N)}nb(A,N){const _=A.charCodeAt(0),ne=N.remoteAuthority;let X,H;N.gotoLineMode&&({path:A,line:X,column:H}=(0,c.$Dg)(A)),_!==47&&((0,c.$wg)(_)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,c.$pg)(A)),A=`/${A}`);const V=w.URI.from({scheme:v.Schemas.vscodeRemote,authority:ne,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,ue.$2i)(A))return N.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:X?{startLineNumber:X,startColumn:H||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,ee.$Xbc)(V),remoteAuthority:ne};if(N.gotoLineMode||m.$hc.basename(A).indexOf(".")!==-1)return{fileUri:V,options:{selection:X?{startLineNumber:X,startColumn:H||1}:void 0},remoteAuthority:ne}}return{workspace:(0,ee.$Ybc)(V),remoteAuthority:ne}}ob(A){const N=this.J.getValue("window"),_=N?.openFoldersInNewWindow||"default",ne=N?.openFilesInNewWindow||"off";let X=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(_==="on"||_==="off")&&(X=_==="on");let H=!1;return A.forceNewWindow||A.forceReuseWindow?H=!!A.forceNewWindow&&!A.forceReuseWindow:(y.$j?A.context===1&&(H=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(H=!0),!A.cli.extensionDevelopmentPath&&(ne==="on"||ne==="off")&&(H=ne==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:H}}async openExtensionDevelopmentHostWindow(A,N){const _=(0,T.$Vbc)(this.getWindows(),A);if(_)return this.H.reload(_,N.cli),_.focus(),[_];let ne=N.cli["folder-uri"]||[],X=N.cli["file-uri"]||[],H=N.cli._;if(!H.length&&!ne.length&&!X.length&&!N.cli.extensionTestsPath){const se=this.r.state.lastPluginDevelopmentHostWindow,he=se?.workspace??se?.folderUri;he&&(w.URI.isUri(he)?he.scheme===v.Schemas.file?H=[he.fsPath]:ne=[he.toString()]:he.configPath.scheme===v.Schemas.file?H=[(0,g.$Xg)(he.configPath)]:X=[he.configPath.toString()])}let V=N.remoteAuthority;for(const se of A)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=w.URI.parse(se),$e=(0,I.$Hm)(he);$e&&(V?(0,g.$ch)($e,V)||this.w.error("more than one extension development path authority"):V=$e)}H=H.filter(se=>{const he=w.URI.file(se);return(0,T.$Ubc)(this.getWindows(),he)?!1:(0,g.$ch)((0,I.$Hm)(he),V)}),ne=ne.filter(se=>{const he=this.fb(se);return he&&(0,T.$Ubc)(this.getWindows(),he)?!1:he?(0,g.$ch)((0,I.$Hm)(he),V):!1}),X=X.filter(se=>{const he=this.fb(se);return he&&(0,T.$Ubc)(this.getWindows(),he)?!1:he?(0,g.$ch)((0,I.$Hm)(he),V):!1}),N.cli._=H,N.cli["folder-uri"]=ne,N.cli["file-uri"]=X;const U={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!H.length&&!ne.length&&!X.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:V,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(U)}async pb(A){const N=this.J.getValue("window"),_=this.getLastActiveWindow(),ne=_?.profile??this.G.defaultProfile;let X;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(X=A.windowToUse||_,X&&X.focus());const H={...this.F.args,...A.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,m.$kc)(this.F.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:ne},homeDir:this.F.userHome.with({scheme:v.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:v.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.u,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:v.Schemas.file}).fsPath,product:P.default,isInitialStartup:A.initialStartup,perfMarks:(0,f.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)(),arch:(0,R.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(X){const V=X.config;!H.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(H.extensionDevelopmentPath=V.extensionDevelopmentPath,H.extensionDevelopmentKind=V.extensionDevelopmentKind,H["enable-proposed-api"]=V["enable-proposed-api"],H.verbose=V.verbose,H["inspect-extensions"]=V["inspect-extensions"],H["inspect-brk-extensions"]=V["inspect-brk-extensions"],H.debugId=V.debugId,H.extensionEnvironment=V.extensionEnvironment,H["extensions-dir"]=V["extensions-dir"],H["disable-extensions"]=V["disable-extensions"]),H.loggers={global:H.loggers.global,window:V?.loggers.window??H.loggers.window}}else{const V=this.r.getNewWindowState(H);(0,f.mark)("code/willCreateCodeWindow");const U=X=this.N.createInstance(W.$6bc,{state:V,extensionDevelopmentPath:H.extensionDevelopmentPath,isExtensionTestHost:!!H.extensionTestsPath});(0,f.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(U),this.n.set(U.id,U),this.a.fire(U),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const se=new b.$Uc;se.add(U.onDidSignalReady(()=>this.b.fire(U))),se.add(h.Event.once(U.onDidClose)(()=>this.sb(U,se))),se.add(h.Event.once(U.onDidDestroy)(()=>this.tb(U))),se.add(U.onDidMaximize(()=>this.g.fire(U))),se.add(U.onDidUnmaximize(()=>this.h.fire(U))),se.add(U.onDidEnterFullScreen(()=>this.j.fire({window:U,fullscreen:!0}))),se.add(U.onDidLeaveFullScreen(()=>this.j.fire({window:U,fullscreen:!1}))),se.add(U.onDidTriggerSystemContextMenu(({x:$e,y:me})=>this.m.fire({window:U,x:$e,y:me})));const he=(0,l.$hg)(U.win?.webContents);he.removeAllListeners("devtools-reload-page"),se.add(h.Event.fromNodeEventEmitter(he,"devtools-reload-page")(()=>this.H.reload(U))),this.H.registerWindow(U)}return H.windowId=X.id,X.isReady?this.H.unload(X,4).then(async V=>{V||await this.qb(X,H,A,ne)}):await this.qb(X,H,A,ne),X}async qb(A,N,_,ne){if(N.extensionDevelopmentPath||((0,ue.$Li)(N.workspace)?N.backupPath=this.I.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,ue.$Gi)(N.workspace)?N.backupPath=this.I.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,ee.$Zbc)().id,remoteAuthority:N.remoteAuthority})),this.G.isEnabled()){const X=N.workspace??(0,ue.$Ki)(N.backupPath,!1),H=this.rb(_,X,ne),V=H instanceof Promise?await H:H;N.profiles.profile=V,N.extensionDevelopmentPath||await this.G.setProfileForWorkspace(X,V)}A.load(N)}rb(A,N,_){return A.forceProfile?this.G.profiles.find(ne=>ne.name===A.forceProfile)??this.G.createNamedProfile(A.forceProfile):A.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(N)??_}sb(A,N){this.n.delete(A.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}tb(A){this.n.delete(A.id),this.c.fire(A)}getFocusedWindow(){const A=n.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(A){return this.vb(this.getWindows().filter(N=>(0,g.$ch)(N.remoteAuthority,A)))}vb(A){return(0,F.$Qbc)(A)}sendToFocused(A,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,E.CancellationToken.None,...N)}sendToOpeningWindow(A,...N){this.B(h.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(A,E.CancellationToken.None,...N)}))}sendToAll(A,N,_){for(const ne of this.getWindows())_&&_.indexOf(ne.id)>=0||ne.sendWhenReady(A,E.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(A){return this.n.get(A)}getWindowByWebContents(A){const N=n.BrowserWindow.fromWebContents(A);if(!N)return;const _=this.getWindowById(N.id);return _?.matches(A)?_:void 0}};e.$edc=le,e.$edc=le=Se([ie(3,$.$3j),ie(4,z.$3bc),ie(5,O.$GQ),ie(6,B.$eo),ie(7,s.$Dbc),ie(8,L.$Rbc),ie(9,u.$8bc),ie(10,a.$Ibc),ie(11,t.$3i),ie(12,ce.$Mcc),ie(13,K.$1bc),ie(14,o.$vi),ie(15,r.$Jbc),ie(16,i.$3k),ie(17,D.$Lbc),ie(18,G.$Mbc),ie(19,Q.$zcc)],le)}),define(re[311],oe([0,1,65,29,85,58]),function(J,e,n,C,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;let j=class{constructor(h,c,d,b){this.a=h,this.b=c,this.c=d,this.d=b,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,c){const d=this.b.getWindowById(h);if(d)return this.a.enterWorkspace(d,this.b.getWindows(),c)}createUntitledWorkspace(h,c,d){return this.a.createUntitledWorkspace(c,d)}deleteUntitledWorkspace(h,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(h,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(h,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$gdc=j,e.$gdc=j=Se([ie(0,R.$1bc),ie(1,C.$Obc),ie(2,S.$Mcc),ie(3,n.$Ibc)],j)}),define(re[312],oe([0,1,14,102,37,26,17,47,15,31,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,78,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,84,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,85,311,58,39,237,57,248,53,83,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,79,307,72]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k,a,t,r,s,i,o,u,$,P,D,I,O,M,W,F,T,q,ue,ee,ce,K,G,B,L,z,Q,ae,x,le,Z,A,N,_,ne,X,H,V,U,se,he,$e,me,ye,ke,Ee,Oe,we,Y,fe,ge,je,Re,Be,Le,Fe,Qe,He,Xe,Te,te,de,pe,ve,Pe,Me,ze,Ge,Ye,Ze,Ke,st,it,ot,at,vt,kt,Et,St,Pt,ct,gt,jt,It,Dt,lt,Ct,$t,ut,At,Rt,ht,Ot,mt,Mt,wt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;let dt=class extends m.$Vc{static{ft=this}static{this.a={[f.Schemas.file]:"security.promptForLocalFileProtocolHandling",[f.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ie,De,Ae,be,Ce,qe,Ue,xe,We,Ne,Ve,Je){super(),this.g=Ie,this.h=De,this.j=Ae,this.m=be,this.n=Ce,this.s=qe,this.t=Ue,this.u=xe,this.w=We,this.y=Ne,this.z=Ve,this.C=Je,this.D(),this.F()}D(){const Ie=We=>We?.startsWith(`${f.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((We,Ne,Ve,Je)=>Ie(Je.requestingUrl)?Ve(De.has(Ne)):Ve(!1)),n.session.defaultSession.setPermissionCheckHandler((We,Ne,Ve,Je)=>Ie(Je.requestingUrl)?De.has(Ne):!1);const Ae=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,f.Schemas.vscodeManagedRemoteResource,"devtools"]),be=We=>{for(let Ne=We;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Ce=We=>We.resourceType==="xhr"||be(We.frame),qe=We=>{const Ne=We.frame;if(!Ne||!this.b)return!1;const Ve=n.BrowserWindow.getAllWindows();for(const Je of Ve)if(Ne.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ue=(We,Ne)=>{if(We.path!=="/index.html")return!0;const Ve=Ne.frame;if(!Ve||!this.b)return!1;for(const Je of this.b.getWindows())if(Je.win&&Ve.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((We,Ne)=>{const Ve=l.URI.parse(We.url);return Ve.scheme===f.Schemas.vscodeWebview&&!Ue(Ve,We)?(this.m.error("Blocked vscode-webview request",We.url),Ne({cancel:!0})):Ve.scheme===f.Schemas.vscodeFileResource&&!qe(We)?(this.m.error("Blocked vscode-file request",We.url),Ne({cancel:!0})):Ve.path.endsWith(".svg")&&!Ae.has(Ve.scheme)?Ne({cancel:!Ce(We)}):Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{const Ve=We.responseHeaders,Je=Ve["content-type"]||Ve["Content-Type"];if(Je&&Array.isArray(Je)){const _e=l.URI.parse(We.url);if(_e.path.endsWith(".svg")&&Ae.has(_e.scheme))return Ve["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:Ve});if(!_e.path.endsWith(f.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!Ce(We)})}return Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ve=We.responseHeaders??Object.create(null);if(Ve["Access-Control-Allow-Origin"]===void 0)return Ve["Access-Control-Allow-Origin"]=["*"],Ne({cancel:!1,responseHeaders:Ve})}return Ne({cancel:!1})});const xe=n.session.defaultSession;typeof xe.setCodeCachePath=="function"&&this.s.codeCachePath&&xe.setCodeCachePath((0,y.$kc)(this.s.codeCachePath,"chrome")),p.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,C.disableUNCAccessRestrictions)():(0,C.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,h.setUnexpectedErrorHandler)(Ae=>this.H(Ae)),process.on("uncaughtException",Ae=>{(0,h.$Z)(Ae)||(0,h.$1)(Ae)}),process.on("unhandledRejection",Ae=>(0,h.$1)(Ae)),this.t.onWillShutdown(()=>this.dispose()),(0,k.$WW)(),n.app.on("accessibility-support-changed",(Ae,be)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",be)}),n.app.on("activate",async(Ae,be)=>{this.m.trace("app#activate"),be||await this.b?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(Ae,be)=>{be?.opener?.url.startsWith(`${f.Schemas.vscodeFileResource}://${f.$Pg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(be)),be.on("will-navigate",Ce=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ce.preventDefault()}),be.setWindowOpenHandler(Ce=>Ce.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ce)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ce.url}}`),this.f?.openExternal(void 0,Ce.url),{action:"deny"}))});let Ie=[],De;n.app.on("open-file",(Ae,be)=>{be=(0,wt.$bm)(be),this.m.trace("app#open-file: ",be),Ae.preventDefault(),Ie.push((0,Me.$2i)(be)?{workspaceUri:l.URI.file(be)}:{fileUri:l.URI.file(be)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],De=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),S.$VW.handle("vscode:fetchShellEnv",Ae=>{const be=this.b?.getWindowByWebContents(Ae.sender);let Ce,qe;return be?.config?(Ce=be.config,qe={...process.env,...be.config.userEnv}):(Ce=this.s.args,qe=process.env),this.X(Ce,qe,!1)}),S.$VW.handle("vscode:writeNlsFile",(Ae,be,Ce)=>{const qe=this.G([be]);if(!qe||typeof Ce!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(qe,j.$Ge.fromString(Ce))}),S.$VW.handle("vscode:readNlsFile",async(Ae,...be)=>{const Ce=this.G(be);if(!Ce)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ce)).value.toString()}),S.$VW.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),S.$VW.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),S.$VW.on("vscode:reloadWindow",Ae=>Ae.sender.reload()),S.$VW.handle("vscode:notifyZoomLevel",async(Ae,be)=>{const Ce=this.b?.getWindowByWebContents(Ae.sender);Ce&&Ce.notifyZoomLevel(be)})}G(Ie){let De;for(const Ae of Ie)typeof Ae=="string"&&(typeof De!="string"?De=Ae:De=(0,y.$kc)(De,Ae));if(!(typeof De!="string"||!(0,y.$jc)(De)||!(0,c.$vg)(De,this.s.cachedLanguagesPath,!p.$k)))return l.URI.file(De)}H(Ie){if(Ie){const De={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.m.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.m.error(Ie.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ie=this.z.win32AppUserModelId;p.$i&&Ie&&n.app.setAppUserModelId(Ie);try{p.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.m.error(Ne)}const De=new t.$3W;this.t.onWillShutdown(Ne=>{Ne.reason===2&&De.dispose()}),this.m.trace("Resolving machine identifier...");const[Ae,be]=await Promise.all([(0,gt.$odc)(this.w,this.m),(0,gt.$pdc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcessReady:Ce,sharedProcessClient:qe}=this.P(Ae,be),Ue=await this.Q(Ae,be,Ce);this.B(Ue.createInstance(s.$fcc)),this.B(Ue.createInstance(St.$kdc)),Ue.invokeFunction(Ne=>this.R(Ne,De,qe));const xe=await Ue.invokeFunction(Ne=>this.I(Ne,De));this.J(De),this.t.phase=2,await Ue.invokeFunction(Ne=>this.S(Ne,xe)),this.t.phase=3,this.U(),this.B(new ct.$Ih(()=>{this.B((0,ct.$Mh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ie,De){const Ae=this.b=Ie.get(pe.$Obc),be=Ie.get(Fe.$KX),Ce=this.f=Ie.get(H.$Acc),qe=Ie.get(O.$Jbc),Ue=this;be.registerHandler({async handleURL(_e,nt){return Ue.O(Ae,qe,be,_e,nt)}});const xe=this.B(new Pe.$fdc({onDidOpenMainWindow:Ce.onDidOpenMainWindow,onDidFocusMainWindow:Ce.onDidFocusMainWindow,getActiveWindowId:()=>Ce.getActiveWindowId(-1)})),We=new a.$ei(_e=>xe.getActiveClientId().then(nt=>_e===nt)),Ne=new Qe.$9cc(We,this.m),Ve=De.getChannel("urlHandler",Ne);be.registerHandler(new Qe.$8cc(Ve));const Je=await this.L(Ae,qe);return this.B(new Xe.$0cc(Je?.urls,be,Ae,this.s,this.z,this.m)),Je}J(Ie){const De=()=>({statusCode:404,data:"Not found"}),Ae=new Ot.$V(()=>Ie.getChannel(ht.$wdc,new ht.$xdc));n.protocol.registerBufferProtocol(f.Schemas.vscodeManagedRemoteResource,(be,Ce)=>{const qe=l.URI.parse(be.url);if(!qe.authority.startsWith("window:"))return Ce(De());Ae.value.call(ht.$vdc,[qe]).then(Ue=>Ce({...Ue,data:Buffer.from(Ue.body,"base64")}),Ue=>{this.m.warn("error dispatching remote resource call",Ue),Ce({statusCode:500,data:String(Ue)})})})}async L(Ie,De){const Ae=this.s.args["open-url"]?this.s.args._urls||[]:[];Ae.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ae);const be=global.getOpenUrls()||[];if(be.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",be),Ae.length+be.length===0)return;const Ce=[...Ae,...be].map(xe=>{try{return{uri:l.URI.parse(xe),originalUrl:xe}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",xe);return}}),qe=[],Ue=[];for(const xe of Ce){if(!xe)continue;const We=this.N(xe.uri);if(We)if(await this.M(We,Ie,De)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",xe.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",xe.uri.toString(!0),We),qe.push(We);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",xe.uri.toString(!0)),Ue.push(xe)}return{urls:Ue,openables:qe}}async M(Ie,De,Ae){let be,Ce;if((0,de.$wD)(Ie)?(be=Ie.workspaceUri,Ce=(0,i.localize)(0,null,be.scheme===f.Schemas.file?(0,v.$xw)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(0,de.$xD)(Ie)?(be=Ie.folderUri,Ce=(0,i.localize)(1,null,be.scheme===f.Schemas.file?(0,v.$xw)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(be=Ie.fileUri,Ce=(0,i.localize)(2,null,be.scheme===f.Schemas.file?(0,v.$xw)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)),be.scheme!==f.Schemas.file&&be.scheme!==f.Schemas.vscodeRemote||this.u.getValue(ft.a[be.scheme])===!1)return!1;const{response:Ue,checkboxChecked:xe}=await Ae.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ce,detail:(0,i.localize)(5,null),checkboxLabel:be.scheme===f.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(Ue!==0)return!0;if(xe){const We={channel:"vscode:disablePromptForProtocolHandling",args:be.scheme===f.Schemas.file?"local":"remote"};De.sendToFocused(We.channel,We.args),De.sendToOpeningWindow(We.channel,We.args)}return!1}N(Ie){if(Ie.path){if(Ie.authority===f.Schemas.file){const De=l.URI.file(Ie.fsPath);return(0,Me.$2i)(De)?{workspaceUri:De}:{fileUri:De}}else if(Ie.authority===f.Schemas.vscodeRemote){const De=Ie.path.indexOf(y.$hc.sep,1);if(De!==-1){const Ae=Ie.path.substring(1,De),be=Ie.path.substring(De);let Ce=Ie.query;const qe=new URLSearchParams(Ie.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),Ce=qe.toString());const Ue=l.URI.from({scheme:f.Schemas.vscodeRemote,authority:Ae,path:be,query:Ce,fragment:Ie.fragment});return(0,Me.$2i)(be)?{workspaceUri:Ue}:/:[\d]+$/.test(be)?{fileUri:Ue}:{folderUri:Ue}}}}}async O(Ie,De,Ae,be,Ce){this.m.trace("app#handleProtocolUrl():",be.toString(!0),Ce),be.scheme===this.z.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:l.URI.parse(be.query).path,query:""}));let qe=!1;const Ue=new URLSearchParams(be.query);Ue.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),Ue.delete("windowId"),be=be.with({query:Ue.toString()}),qe=!0):p.$j&&Ie.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),qe=!0);const xe=Ue.get("continueOn");xe!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),Ue.delete("continueOn"),be=be.with({query:Ue.toString()}),this.s.continueOn=xe??void 0);const We=this.N(be);return We?await this.M(We,Ie,De)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",We,be.toString(!0)),(0,$t.$Ob)(await Ie.open({context:5,cli:{...this.s.args},urisToOpen:[We],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,$t.$Ob)(await Ie.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,U.$Hm)(be)}))?.ready(),Ae.open(be,Ce)):(this.m.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Ce),!1)}P(Ie,De){const Ae=this.B(this.j.createInstance(se.$Ucc,Ie,De)),be=(async()=>{this.m.trace("Main->SharedProcess#connect");const qe=await Ae.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new r.$4W(qe,"main")})();return{sharedProcessReady:(async()=>(await Ae.whenReady(),be))(),sharedProcessClient:be}}async Q(Ie,De,Ae){const be=new x.$ui;switch(process.platform){case"win32":be.set(fe.$UX,new Q.$ti(Le.$6cc));break;case"linux":p.$l?be.set(fe.$UX,new Q.$ti(Be.$5cc,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(fe.$UX,new Q.$ti(Re.$4cc));break;case"darwin":be.set(fe.$UX,new Q.$ti(je.$3cc));break}be.set(pe.$Obc,new Q.$ti(ve.$edc,[Ie,De,this.h],!1)),be.set(mt.$zcc,new Q.$ti(Mt.$ydc,void 0,!1));const Ce=new O.$Kbc(this.m,this.z);be.set(O.$Jbc,Ce),be.set(N.$Gcc,new Q.$ti(N.$Hcc,void 0,!1)),be.set(I.$lcc,new Q.$ti(I.$mcc,void 0,!1)),be.set(D.$dn,a.ProxyChannel.toService((0,a.$ci)(Ae.then(Ne=>Ne.getChannel("diagnostics"))))),be.set(le.$0Jb,new Q.$ti(Z.$Ccc,[this.h])),be.set(M.$EX,new Q.$ti(W.$ncc)),be.set(A.$Dcc,new Q.$ti(A.$Ecc)),be.set(H.$Acc,new Q.$ti(H.$Bcc,void 0,!1)),be.set(Te.$$cc,new Q.$ti(te.$adc)),be.set(X.$Pcc,new Q.$ti(X.$Qcc)),be.set(ue.$occ,new Q.$ti(ee.$qcc)),be.set(ye.$bcc,new Q.$ti(ye.$ccc)),be.set(ye.$dcc,new Q.$ti(ye.$ecc));const qe=new At.$udc({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Ue=new Rt.$ws(qe,this.u,this.m,this.n);be.set(ut.$0r,Ue),p.$i?be.set(ce.$rcc,new Q.$ti(K.$scc)):p.$j?be.set(ce.$rcc,new Q.$ti(K.$tcc)):p.$k&&be.set(ce.$rcc,new Q.$ti(K.$ucc));const xe=new u.$gcc(this.s,this.u,this.m,this.w);be.set(o.$Ibc,xe);const We=new Ze.$2bc(this.s,this.m,this.C,xe,Ce);if(be.set(Ze.$1bc,We),be.set(ze.$mgb,new Q.$ti(Ye.$gdc,void 0,!1)),be.set(Ge.$Mcc,new Q.$ti(Ge.$Ncc,void 0,!1)),be.set(Fe.$KX,new Q.$ti(He.$MX,void 0,!1)),(0,Y.$mp)(this.z,this.s)){const Ne=(0,Y.$rp)(this.z,this.u),Ve=(0,a.$ci)(Ae.then(rt=>rt.getChannel("telemetryAppender"))),Je=new Oe.$Xcc(Ve),_e=(0,ke.$dp)((0,R.release)(),(0,R.hostname)(),process.arch,this.z.commit,this.z.version,Ie,De,Ne),nt=(0,Y.$sp)(this.s),et={appenders:[Je],commonProperties:_e,piiPaths:nt,sendErrorTelemetry:!0};be.set(Ee.$2l,new Q.$ti(we.$Zr,[et],!1))}else be.set(Ee.$2l,Y.$hp);return be.set(vt.$pq,new Q.$ti(jt.$NQ,void 0,!0)),be.set(kt.$tq,new Q.$ti(Et.$jdc,void 0,!0)),be.set(lt.$sdc,new Q.$ti(lt.$tdc,void 0,!0)),await ct.Promises.settled([xe.initialize(),We.initialize()]),this.j.createChild(be)}R(Ie,De,Ae){const be=this.B(new m.$Uc),Ce=a.ProxyChannel.fromService(Ie.get(N.$Gcc),be,{disableMarshalling:!0});this.g.registerChannel("launch",Ce);const qe=a.ProxyChannel.fromService(Ie.get(I.$lcc),be,{disableMarshalling:!0});this.g.registerChannel("diagnostics",qe);const Ue=new st.$hdc(Ie.get(Ke.$eo));De.registerChannel("policy",Ue),Ae.then(tt=>tt.registerChannel("policy",Ue));const xe=this.y.getProvider(f.Schemas.file);(0,g.$gg)(xe instanceof z.$_q);const We=new L.$vcc(xe,this.m,this.s);De.registerChannel(G.$wQ,We),Ae.then(tt=>tt.registerChannel(G.$wQ,We));const Ne=a.ProxyChannel.fromService(Ie.get(it.$Rbc),be);De.registerChannel("userDataProfiles",Ne),Ae.then(tt=>tt.registerChannel("userDataProfiles",Ne));const Ve=new ot.$Ur(Ie.get(at.$Np));Ae.then(tt=>tt.registerChannel("request",Ve));const Je=new ge.$Ycc(Ie.get(fe.$UX));De.registerChannel("update",Je);const _e=a.ProxyChannel.fromService(Ie.get(le.$0Jb),be);De.registerChannel("issue",_e);const nt=a.ProxyChannel.fromService(Ie.get(M.$EX),be);De.registerChannel("encryption",nt);const et=a.ProxyChannel.fromService(Ie.get(he.$Pl),be);De.registerChannel("sign",et);const rt=a.ProxyChannel.fromService(Ie.get(A.$Dcc),be);De.registerChannel("keyboardLayout",rt),this.f=Ie.get(H.$Acc);const pt=a.ProxyChannel.fromService(this.f,be);De.registerChannel("nativeHost",pt),Ae.then(tt=>tt.registerChannel("nativeHost",pt));const Lt=a.ProxyChannel.fromService(Ie.get(ze.$mgb),be);De.registerChannel("workspaces",Lt);const Ft=a.ProxyChannel.fromService(Ie.get(X.$Pcc),be);De.registerChannel("menubar",Ft);const Wt=a.ProxyChannel.fromService(Ie.get(Fe.$KX),be);De.registerChannel("url",Wt);const Nt=a.ProxyChannel.fromService(Ie.get(Te.$$cc),be);De.registerChannel("webview",Nt);const bt=this.B(new me.$Vcc(this.m,Ie.get(ye.$bcc)));De.registerChannel("storage",bt),Ae.then(tt=>tt.registerChannel("storage",bt));const Tt=this.B(new Pt.$ldc(Ie.get(ye.$bcc),Ie.get(it.$Rbc),this.m));Ae.then(tt=>tt.registerChannel("profileStorageListener",Tt));const zt=a.ProxyChannel.fromService(Ie.get(ut.$0r),be);De.registerChannel(ut.TerminalIpcChannels.LocalPty,zt);const Bt=a.ProxyChannel.fromService(Ie.get(ce.$rcc),be);De.registerChannel("externalTerminal",Bt);const yt=new It.$qdc(Ie.get(Dt.$3bc));De.registerChannel("logger",yt),Ae.then(tt=>tt.registerChannel("logger",yt));const qt=new P.$hcc(Ie.get(pe.$Obc));De.registerChannel("extensionhostdebugservice",qt);const Qt=a.ProxyChannel.fromService(Ie.get(ue.$occ),be);De.registerChannel(ue.$pcc,Qt);const Ut=a.ProxyChannel.fromService(Ie.get(lt.$sdc),be);De.registerChannel(Ct.$rdc,Ut)}async S(Ie,De){const Ae=this.b=Ie.get(pe.$Obc);this.c=Ie.get(mt.$zcc);const be=(0,T.$Am)(process.env)?0:4,Ce=this.s.args;if(De){if(De.openables.length>0)return Ae.open({context:be,cli:Ce,urisToOpen:De.openables,gotoLineMode:!0,initialStartup:!0});if(De.urls.length>0)for(const et of De.urls){const rt=new URLSearchParams(et.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:rt.toString()}),Ae.open({context:be,cli:Ce,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,Ue=Ce._.length,xe=!!Ce["folder-uri"],We=!!Ce["file-uri"],Ne=Ce["skip-add-to-recently-opened"]===!0,Ve=Ce.wait&&Ce.waitMarkerFilePath?l.URI.file(Ce.waitMarkerFilePath):void 0,Je=Ce.remote||void 0,_e=Ce.profile,nt=Ce["profile-temp"];if(!Ue&&!xe&&!We){if(Ce["new-window"]||_e||nt)return Ae.open({context:be,cli:Ce,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt});if(qe.length)return Ae.open({context:1,cli:Ce,urisToOpen:qe.map(et=>(et=(0,wt.$bm)(et),(0,Me.$2i)(et)?{workspaceUri:l.URI.file(et)}:{fileUri:l.URI.file(et)})),noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0})}return Ae.open({context:be,cli:Ce,forceNewWindow:Ce["new-window"],diffMode:Ce.diff,mergeMode:Ce.merge,noRecentEntry:Ne,waitMarkerFileURI:Ve,gotoLineMode:Ce.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt})}U(){this.W(),n.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(Ie,De)=>{De({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.X(this.s.args,process.env,!0),this.Y(),p.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ie=this.z.win32MutexName;if(p.$i&&Ie)try{const De=await new Promise((be,Ce)=>{J(["@vscode/windows-mutex"],be,Ce)}),Ae=new De.Mutex(Ie);d.Event.once(this.t.onWillShutdown)(()=>Ae.release())}catch(De){this.m.error(De)}}async X(Ie,De,Ae){try{return await(0,q.$Gm)(this.u,this.m,Ie,De)}catch(be){const Ce=(0,E.$hj)(be);Ae?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ce):this.m.error(Ce)}return{}}async Y(){try{const De=(await this.y.readFile(this.s.argvResource)).value.toString(),Ae=JSON.parse((0,b.$Rn)(De)),Ce=(0,Y.$op)(this.u)>=1;if(Ae["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ce},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,w.$Sg)()}"`,"}"],Ue=De.substring(0,De.length-2).concat(`,
`,qe.join(`
`));await this.y.writeFile(this.s.argvResource,j.$Ge.fromString(Ue))}else{const qe=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ce},`);qe!==De&&await this.y.writeFile(this.s.argvResource,j.$Ge.fromString(qe))}}catch(Ie){this.m.error(Ie)}}};e.$zdc=dt,e.$zdc=dt=ft=Se([ie(2,ae.$vi),ie(3,ne.$3j),ie(4,ne.$4j),ie(5,F.$Dbc),ie(6,_.$8bc),ie(7,$.$3i),ie(8,$e.$GQ),ie(9,B.$3k),ie(10,V.$jk),ie(11,it.$Rbc)],dt)}),define(re[317],oe([0,1,14,43,7,22,8,47,15,31,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,78,222,93,20,229,5,80,27,81,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(J,e,n,C,S,R,j,E,h,c,d,b,v,m,f,y,p,g,l,w,k,a,t,r,s,i,o,u,$,P,D,I,O,M,W,F,T,q,ue,ee,ce,K,G,B,L,z,Q,ae,x,le,Z,A,N,_,ne,X,H,V,U,se,he,$e,me,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.a()}catch(we){console.error(we.message),n.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Fe=>console.error(Fe));const[we,Y,fe,ge,je,Re,Be,Le]=this.b();try{try{await this.d(fe,Le,ge,je,Be)}catch(Fe){throw this.g(fe,Be,Fe),Fe}await we.invokeFunction(async Fe=>{const Qe=Fe.get(q.$3j),He=Fe.get(F.$8bc),Xe=Fe.get(P.$3k),Te=Fe.get(q.$4j),te=await this.f(Qe,fe,He,we,Be,!0);return l.Promises.writeFile(fe.mainLockfile,String(process.pid)).catch(de=>{Qe.warn(`app#startup(): Error writing main lockfile: ${de.stack}`)}),Re.logger=Te.createLogger("main",{name:(0,t.localize)(0,null)}),d.Event.once(He.onWillShutdown)(de=>{Xe.dispose(),ge.dispose(),de.join("instanceLockfile",l.Promises.unlink(fe.mainLockfile).catch(()=>{}))}),we.createInstance(a.$zdc,te,Y).startup()})}catch(Fe){we.invokeFunction(this.j,Fe)}}b(){const we=new W.$ui,Y=new X.$Uc;process.once("exit",()=>Y.dispose());const fe={_serviceBrand:void 0,...ue.default};we.set(ee.$jk,fe);const ge=new o.$Ebc(this.k(),fe),je=this.c(ge);we.set(o.$Dbc,ge);const Re=new U.$4bc((0,q.$ek)(ge),ge.logsHome);we.set(U.$3bc,Re);const Be=new T.$j_b(Re.getLogLevel()),Le=Y.add(new se.$OQ(Be,[new q.$0j(Re.getLogLevel())]));we.set(q.$3j,Le);const Fe=new D.$Iq(Le);we.set(P.$3k,Fe);const Qe=new I.$_q(Le);Fe.registerProvider(v.Schemas.file,Qe);const He=new V.$As(Fe);we.set(H.$Al,He);const Xe=new $e.$JQ(1,ge,Le,Fe);we.set(x.$FQ,Xe),we.set(x.$GQ,Xe);const Te=new A.$Sbc(Xe,He,ge,Fe,Le);we.set(A.$Rbc,Te),Fe.registerProvider(v.Schemas.vscodeUserData,new me.$Kdc(v.Schemas.file,Qe,v.Schemas.vscodeUserData,Te,He,Le));const te=y.$i&&fe.win32RegValueName?Y.add(new _.$Idc(Le,fe.win32RegValueName)):ge.policyFile?Y.add(new ne.$Jdc(ge.policyFile,Fe,Le)):new N.$go;we.set(N.$eo,te);const de=new s.$Go(Te.defaultProfile.settingsResource,Fe,te,Le);return we.set(r.$3i,de),we.set(F.$8bc,new O.$ti(F.$9bc,void 0,!1)),we.set(L.$Np,new O.$ti(z.$Gdc,void 0,!0)),we.set(Z.$Mbc,new O.$ti(Z.$Nbc)),we.set(Q.$Pl,new O.$ti(ae.$Hdc,void 0,!1)),we.set(G.$cw,new O.$ti(B.$Edc)),we.set(ce.$Lbc,new K.$Bdc(ge,Te,Le)),[new M.$cr(we,!0),je,ge,de,Xe,Be,fe,Te]}c(we){const Y={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(fe=>{const ge=process.env[fe];typeof ge=="string"&&(Y[fe]=ge)}),Object.assign(process.env,Y),Y}async d(we,Y,fe,ge,je){await j.Promises.settled([Promise.all([this.e(we.extensionsPath),we.codeCachePath,we.logsHome.with({scheme:v.Schemas.file}).fsPath,Y.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath,we.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,we.localHistoryHome.with({scheme:v.Schemas.file}).fsPath,we.backupHome].map(Re=>Re?l.Promises.mkdir(Re,{recursive:!0}):void 0)),ge.init(),fe.initialize()]),Y.init()}e(we){if(y.$i){const Y=(0,ye.getUNCHost)(we);Y&&(0,ye.addUNCHostToAllowlist)(Y)}return we}async f(we,Y,fe,ge,je,Re){let Be;try{(0,f.mark)("code/willStartMainServer"),Be=await(0,k.$ri)(Y.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),d.Event.once(fe.onWillShutdown)(()=>Be.dispose())}catch(Le){if(Le.code!=="EADDRINUSE")throw this.g(Y,je,Le),Le;let Fe;try{Fe=await(0,k.$si)(Y.mainIPCHandle,"main")}catch(Te){if(!Re||y.$i||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.h((0,t.localize)(1,null,je.nameShort),(0,t.localize)(2,null),je),Te;try{(0,C.unlinkSync)(Y.mainIPCHandle)}catch(te){throw we.warn("Could not delete obsolete instance handle",te),te}return this.f(we,Y,fe,ge,je,!1)}if(Y.extensionTestsLocationURI&&!Y.debugExtensionHost.break){const Te=`Running extension tests from the command line is currently only supported if no other instance of ${je.nameShort} is running.`;throw we.error(Te),Fe.dispose(),new Error(Te)}let Qe;!Y.args.wait&&!Y.args.status&&(Qe=setTimeout(()=>{this.h((0,t.localize)(3,null,je.nameShort),(0,t.localize)(4,null),je)},1e4));const He=w.ProxyChannel.toService(Fe.getChannel("launch"),{disableMarshalling:!0}),Xe=w.ProxyChannel.toService(Fe.getChannel("diagnostics"),{disableMarshalling:!0});if(Y.args.status)return ge.invokeFunction(async()=>{const Te=new i.$Hs(le.$hp,je),te=await Xe.getMainDiagnostics(),de=await Xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),pe=await Te.getDiagnostics(te,de);throw console.log(pe),new h.$ab});throw y.$i&&await this.i(He,we),we.trace("Sending env to running instance..."),await He.start(Y.args,process.env),Fe.dispose(),Qe&&clearTimeout(Qe),new h.$ab("Sent env to running instance. Terminating...")}if(Y.args.status)throw console.log((0,t.localize)(5,null,je.nameShort)),new h.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Be}g(we,Y,fe){if(fe.code==="EACCES"||fe.code==="EPERM"){const ge=(0,R.$Hb)([we.userDataPath,we.extensionsPath,k.$ni]).map(je=>(0,b.$xw)(S.URI.file(je),{os:y.OS,tildify:we}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$hj)(fe),ge.join(`
`)),Y)}}h(we,Y,fe){n.dialog.showMessageBoxSync((0,he.$Lw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:we,detail:Y},fe).options)}async i(we,Y){if(y.$i){const fe=await we.getMainProcessId();Y.trace("Sending some foreground love to the running instance:",fe);try{(await new Promise((ge,je)=>{J(["windows-foreground-love"],ge,je)})).allowSetForegroundWindow(fe)}catch(ge){Y.error(ge)}}}j(we,Y){const fe=we.get(q.$3j),ge=we.get(F.$8bc);let je=0;Y&&(Y.isExpected?Y.message&&fe.trace(Y.message):(je=1,Y.stack?fe.error(Y.stack):fe.error(`Startup error: ${Y.toString()}`))),ge.kill(je)}k(){const we=this.l((0,u.$xm)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const Y=(0,$.$Adc)(we.verbose);Y&&((0,u.$zm)(process.argv,"--waitMarkerFilePath",Y),we.waitMarkerFilePath=Y)}return we}l(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const Y=this.m(we._,we.goto);we._=Y}return we}m(we,Y){const fe=(0,p.cwd)(),ge=we.map(Be=>{let Le=String(Be),Fe;Y&&(Fe=(0,c.$Dg)(Le),Le=Fe.path),Le&&(Le=this.n(fe,Le));const Qe=(0,c.$xg)(Le,fe),He=(0,m.$oc)(Qe);return He&&!(0,c.$tg)(He)?null:Y&&Fe?(Fe.path=Qe,this.o(Fe)):Qe}),je=y.$i||y.$j,Re=(0,R.$Mb)(ge,Be=>Be&&je?Be.toLowerCase():Be||"");return(0,R.$Hb)(Re)}n(we,Y){return y.$i&&(Y=(0,g.$gf)(Y,'"')),Y=(0,g.$ef)((0,g.$ef)(Y," "),"	"),y.$i&&(Y=(0,m.$lc)(we,Y),Y=(0,g.$gf)(Y,".")),Y}o(we){const Y=[we.path];return typeof we.line=="number"&&Y.push(String(we.line)),typeof we.column=="number"&&Y.push(String(we.column)),Y.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/17235b28ebca8f946926ec11374b67cd53c0619d/core/vs/code/electron-main/main.js.map
