/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/base/common/types","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/assert","vs/base/common/equals","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/observable","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(se){for(var t=[],i=0,C=se.length;i<C;i++)t[i]=me[se[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:xt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Rt}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,i,C){return t.apply(i,C)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Rt||(Rt=function(t,i){return new t(...i)});const oi=ct(Array.prototype.forEach),zt=ct(Array.prototype.pop),wt=ct(Array.prototype.push),Dt=ct(String.prototype.toLowerCase),Lt=ct(String.prototype.toString),ai=ct(String.prototype.match),dt=ct(String.prototype.replace),li=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),vt=ui(TypeError);function ct(se){return function(t){for(var i=arguments.length,C=new Array(i>1?i-1:0),B=1;B<i;B++)C[B-1]=arguments[B];return Nt(se,t,C)}}function ui(se){return function(){for(var t=arguments.length,i=new Array(t),C=0;C<t;C++)i[C]=arguments[C];return Rt(se,i)}}function Qe(se,t,i){var C;i=(C=i)!==null&&C!==void 0?C:Dt,xt&&xt(se,null);let B=t.length;for(;B--;){let Q=t[B];if(typeof Q=="string"){const A=i(Q);A!==Q&&(ii(t)||(t[B]=A),Q=A)}se[Q]=!0}return se}function bt(se){const t=ri(null);for(const[i,C]of Bt(se))t[i]=C;return t}function Et(se,t){for(;se!==null;){const C=si(se,t);if(C){if(C.get)return ct(C.get);if(typeof C.value=="function")return ct(C.value)}se=ni(se)}function i(C){return console.warn("fallback value for",C),null}return i}const Qt=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Mt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),It=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),jt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ht=ot(["#text"]),Wt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ot=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Vt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),St=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),qt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Kt=ft(/^html$/i);var Gt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Kt});const vi=()=>typeof window>"u"?null:window,yi=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let C=null;const B="data-tt-policy-suffix";i&&i.hasAttribute(B)&&(C=i.getAttribute(B));const Q="dompurify"+(C?"#"+C:"");try{return t.createPolicy(Q,{createHTML(A){return A},createScriptURL(A){return A}})}catch{return console.warn("TrustedTypes policy "+Q+" could not be created."),null}};function Xt(){let se=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Be=>Xt(Be);if(t.version="3.0.5",t.removed=[],!se||!se.document||se.document.nodeType!==9)return t.isSupported=!1,t;const i=se.document,C=i.currentScript;let{document:B}=se;const{DocumentFragment:Q,HTMLTemplateElement:A,Node:T,Element:d,NodeFilter:g,NamedNodeMap:$=se.NamedNodeMap||se.MozNamedAttrMap,HTMLFormElement:P,DOMParser:c,trustedTypes:h}=se,e=d.prototype,n=Et(e,"cloneNode"),o=Et(e,"nextSibling"),l=Et(e,"childNodes"),f=Et(e,"parentNode");if(typeof A=="function"){const Be=B.createElement("template");Be.content&&Be.content.ownerDocument&&(B=Be.content.ownerDocument)}let S,m="";const{implementation:b,createNodeIterator:r,createDocumentFragment:E,getElementsByTagName:k}=B,{importNode:F}=i;let M={};t.isSupported=typeof Bt=="function"&&typeof f=="function"&&b&&b.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:W,ERB_EXPR:p,TMPLIT_EXPR:I,DATA_ATTR:V,ARIA_ATTR:R,IS_SCRIPT_OR_DATA:x,ATTR_WHITESPACE:O}=Gt;let{IS_ALLOWED_URI:G}=Gt,q=null;const ae=Qe({},[...Qt,...Mt,...It,...jt,...Ht]);let ie=null;const ee=Qe({},[...Wt,...Ot,...Vt,...St]);let ce=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),De=null,Ee=null,Me=!0,le=!0,_=!1,ue=!0,re=!1,ye=!1,H=!1,J=!1,ge=!1,we=!1,ke=!1,Fe=!0,Ie=!1;const z="user-content-";let u=!0,y=!1,a={},v=null;const N=Qe({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let s=null;const D=Qe({},["audio","video","img","source","image","track"]);let w=null;const L=Qe({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),j="http://www.w3.org/1998/Math/MathML",X="http://www.w3.org/2000/svg",Z="http://www.w3.org/1999/xhtml";let oe=Z,pe=!1,fe=null;const Le=Qe({},[j,X,Z],Lt);let Te;const Oe=["application/xhtml+xml","text/html"],Se="text/html";let Ce,He=null;const Ue=B.createElement("form"),Xe=function(he){return he instanceof RegExp||he instanceof Function},_e=function(he){if(!(He&&He===he)){if((!he||typeof he!="object")&&(he={}),he=bt(he),Te=Oe.indexOf(he.PARSER_MEDIA_TYPE)===-1?Te=Se:Te=he.PARSER_MEDIA_TYPE,Ce=Te==="application/xhtml+xml"?Lt:Dt,q="ALLOWED_TAGS"in he?Qe({},he.ALLOWED_TAGS,Ce):ae,ie="ALLOWED_ATTR"in he?Qe({},he.ALLOWED_ATTR,Ce):ee,fe="ALLOWED_NAMESPACES"in he?Qe({},he.ALLOWED_NAMESPACES,Lt):Le,w="ADD_URI_SAFE_ATTR"in he?Qe(bt(L),he.ADD_URI_SAFE_ATTR,Ce):L,s="ADD_DATA_URI_TAGS"in he?Qe(bt(D),he.ADD_DATA_URI_TAGS,Ce):D,v="FORBID_CONTENTS"in he?Qe({},he.FORBID_CONTENTS,Ce):N,De="FORBID_TAGS"in he?Qe({},he.FORBID_TAGS,Ce):{},Ee="FORBID_ATTR"in he?Qe({},he.FORBID_ATTR,Ce):{},a="USE_PROFILES"in he?he.USE_PROFILES:!1,Me=he.ALLOW_ARIA_ATTR!==!1,le=he.ALLOW_DATA_ATTR!==!1,_=he.ALLOW_UNKNOWN_PROTOCOLS||!1,ue=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,re=he.SAFE_FOR_TEMPLATES||!1,ye=he.WHOLE_DOCUMENT||!1,ge=he.RETURN_DOM||!1,we=he.RETURN_DOM_FRAGMENT||!1,ke=he.RETURN_TRUSTED_TYPE||!1,J=he.FORCE_BODY||!1,Fe=he.SANITIZE_DOM!==!1,Ie=he.SANITIZE_NAMED_PROPS||!1,u=he.KEEP_CONTENT!==!1,y=he.IN_PLACE||!1,G=he.ALLOWED_URI_REGEXP||qt,oe=he.NAMESPACE||Z,ce=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&Xe(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ce.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&Xe(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ce.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ce.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),re&&(le=!1),we&&(ge=!0),a&&(q=Qe({},[...Ht]),ie=[],a.html===!0&&(Qe(q,Qt),Qe(ie,Wt)),a.svg===!0&&(Qe(q,Mt),Qe(ie,Ot),Qe(ie,St)),a.svgFilters===!0&&(Qe(q,It),Qe(ie,Ot),Qe(ie,St)),a.mathMl===!0&&(Qe(q,jt),Qe(ie,Vt),Qe(ie,St))),he.ADD_TAGS&&(q===ae&&(q=bt(q)),Qe(q,he.ADD_TAGS,Ce)),he.ADD_ATTR&&(ie===ee&&(ie=bt(ie)),Qe(ie,he.ADD_ATTR,Ce)),he.ADD_URI_SAFE_ATTR&&Qe(w,he.ADD_URI_SAFE_ATTR,Ce),he.FORBID_CONTENTS&&(v===N&&(v=bt(v)),Qe(v,he.FORBID_CONTENTS,Ce)),u&&(q["#text"]=!0),ye&&Qe(q,["html","head","body"]),q.table&&(Qe(q,["tbody"]),delete De.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');S=he.TRUSTED_TYPES_POLICY,m=S.createHTML("")}else S===void 0&&(S=yi(h,C)),S!==null&&typeof m=="string"&&(m=S.createHTML(""));ot&&ot(he),He=he}},Y=Qe({},["mi","mo","mn","ms","mtext"]),ne=Qe({},["foreignobject","desc","title","annotation-xml"]),$e=Qe({},["title","style","font","a","script"]),ve=Qe({},Mt);Qe(ve,It),Qe(ve,ci);const Re=Qe({},jt);Qe(Re,fi);const ze=function(he){let Ne=f(he);(!Ne||!Ne.tagName)&&(Ne={namespaceURI:oe,tagName:"template"});const je=Dt(he.tagName),Ke=Dt(Ne.tagName);return fe[he.namespaceURI]?he.namespaceURI===X?Ne.namespaceURI===Z?je==="svg":Ne.namespaceURI===j?je==="svg"&&(Ke==="annotation-xml"||Y[Ke]):!!ve[je]:he.namespaceURI===j?Ne.namespaceURI===Z?je==="math":Ne.namespaceURI===X?je==="math"&&ne[Ke]:!!Re[je]:he.namespaceURI===Z?Ne.namespaceURI===X&&!ne[Ke]||Ne.namespaceURI===j&&!Y[Ke]?!1:!Re[je]&&($e[je]||!ve[je]):!!(Te==="application/xhtml+xml"&&fe[he.namespaceURI]):!1},We=function(he){wt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},et=function(he,Ne){try{wt(t.removed,{attribute:Ne.getAttributeNode(he),from:Ne})}catch{wt(t.removed,{attribute:null,from:Ne})}if(Ne.removeAttribute(he),he==="is"&&!ie[he])if(ge||we)try{We(Ne)}catch{}else try{Ne.setAttribute(he,"")}catch{}},it=function(he){let Ne,je;if(J)he="<remove></remove>"+he;else{const lt=ai(he,/^[\r\n\t ]+/);je=lt&&lt[0]}Te==="application/xhtml+xml"&&oe===Z&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const Ke=S?S.createHTML(he):he;if(oe===Z)try{Ne=new c().parseFromString(Ke,Te)}catch{}if(!Ne||!Ne.documentElement){Ne=b.createDocument(oe,"template",null);try{Ne.documentElement.innerHTML=pe?m:Ke}catch{}}const nt=Ne.body||Ne.documentElement;return he&&je&&nt.insertBefore(B.createTextNode(je),nt.childNodes[0]||null),oe===Z?k.call(Ne,ye?"html":"body")[0]:ye?Ne.documentElement:nt},st=function(he){return r.call(he.ownerDocument||he,he,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},Je=function(he){return he instanceof P&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof $)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},rt=function(he){return typeof T=="object"?he instanceof T:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},tt=function(he,Ne,je){M[he]&&oi(M[he],Ke=>{Ke.call(t,Ne,je,He)})},mt=function(he){let Ne;if(tt("beforeSanitizeElements",he,null),Je(he))return We(he),!0;const je=Ce(he.nodeName);if(tt("uponSanitizeElement",he,{tagName:je,allowedTags:q}),he.hasChildNodes()&&!rt(he.firstElementChild)&&(!rt(he.content)||!rt(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return We(he),!0;if(!q[je]||De[je]){if(!De[je]&&At(je)&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,je)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(je)))return!1;if(u&&!v[je]){const Ke=f(he)||he.parentNode,nt=l(he)||he.childNodes;if(nt&&Ke){const lt=nt.length;for(let Ye=lt-1;Ye>=0;--Ye)Ke.insertBefore(n(nt[Ye],!0),o(he))}}return We(he),!0}return he instanceof d&&!ze(he)||(je==="noscript"||je==="noembed"||je==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(We(he),!0):(re&&he.nodeType===3&&(Ne=he.textContent,Ne=dt(Ne,W," "),Ne=dt(Ne,p," "),Ne=dt(Ne,I," "),he.textContent!==Ne&&(wt(t.removed,{element:he.cloneNode()}),he.textContent=Ne)),tt("afterSanitizeElements",he,null),!1)},gt=function(he,Ne,je){if(Fe&&(Ne==="id"||Ne==="name")&&(je in B||je in Ue))return!1;if(!(le&&!Ee[Ne]&&ht(V,Ne))){if(!(Me&&ht(R,Ne))){if(!ie[Ne]||Ee[Ne]){if(!(At(he)&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,he)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(he))&&(ce.attributeNameCheck instanceof RegExp&&ht(ce.attributeNameCheck,Ne)||ce.attributeNameCheck instanceof Function&&ce.attributeNameCheck(Ne))||Ne==="is"&&ce.allowCustomizedBuiltInElements&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,je)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(je))))return!1}else if(!w[Ne]){if(!ht(G,dt(je,O,""))){if(!((Ne==="src"||Ne==="xlink:href"||Ne==="href")&&he!=="script"&&li(je,"data:")===0&&s[he])){if(!(_&&!ht(x,dt(je,O,"")))){if(je)return!1}}}}}}return!0},At=function(he){return he.indexOf("-")>0},kt=function(he){let Ne,je,Ke,nt;tt("beforeSanitizeAttributes",he,null);const{attributes:lt}=he;if(!lt)return;const Ye={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ie};for(nt=lt.length;nt--;){Ne=lt[nt];const{name:ut,namespaceURI:$t}=Ne;if(je=ut==="value"?Ne.value:hi(Ne.value),Ke=Ce(ut),Ye.attrName=Ke,Ye.attrValue=je,Ye.keepAttr=!0,Ye.forceKeepAttr=void 0,tt("uponSanitizeAttribute",he,Ye),je=Ye.attrValue,Ye.forceKeepAttr||(et(ut,he),!Ye.keepAttr))continue;if(!ue&&ht(/\/>/i,je)){et(ut,he);continue}re&&(je=dt(je,W," "),je=dt(je,p," "),je=dt(je,I," "));const Ft=Ce(he.nodeName);if(gt(Ft,Ke,je)){if(Ie&&(Ke==="id"||Ke==="name")&&(et(ut,he),je=z+je),S&&typeof h=="object"&&typeof h.getAttributeType=="function"&&!$t)switch(h.getAttributeType(Ft,Ke)){case"TrustedHTML":{je=S.createHTML(je);break}case"TrustedScriptURL":{je=S.createScriptURL(je);break}}try{$t?he.setAttributeNS($t,ut,je):he.setAttribute(ut,je),zt(t.removed)}catch{}}}tt("afterSanitizeAttributes",he,null)},Tt=function Be(he){let Ne;const je=st(he);for(tt("beforeSanitizeShadowDOM",he,null);Ne=je.nextNode();)tt("uponSanitizeShadowNode",Ne,null),!mt(Ne)&&(Ne.content instanceof Q&&Be(Ne.content),kt(Ne));tt("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(Be){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Ne,je,Ke,nt;if(pe=!Be,pe&&(Be="<!-->"),typeof Be!="string"&&!rt(Be))if(typeof Be.toString=="function"){if(Be=Be.toString(),typeof Be!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return Be;if(H||_e(he),t.removed=[],typeof Be=="string"&&(y=!1),y){if(Be.nodeName){const ut=Ce(Be.nodeName);if(!q[ut]||De[ut])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(Be instanceof T)Ne=it("<!---->"),je=Ne.ownerDocument.importNode(Be,!0),je.nodeType===1&&je.nodeName==="BODY"||je.nodeName==="HTML"?Ne=je:Ne.appendChild(je);else{if(!ge&&!re&&!ye&&Be.indexOf("<")===-1)return S&&ke?S.createHTML(Be):Be;if(Ne=it(Be),!Ne)return ge?null:ke?m:""}Ne&&J&&We(Ne.firstChild);const lt=st(y?Be:Ne);for(;Ke=lt.nextNode();)mt(Ke)||(Ke.content instanceof Q&&Tt(Ke.content),kt(Ke));if(y)return Be;if(ge){if(we)for(nt=E.call(Ne.ownerDocument);Ne.firstChild;)nt.appendChild(Ne.firstChild);else nt=Ne;return(ie.shadowroot||ie.shadowrootmode)&&(nt=F.call(i,nt,!0)),nt}let Ye=ye?Ne.outerHTML:Ne.innerHTML;return ye&&q["!doctype"]&&Ne.ownerDocument&&Ne.ownerDocument.doctype&&Ne.ownerDocument.doctype.name&&ht(Kt,Ne.ownerDocument.doctype.name)&&(Ye="<!DOCTYPE "+Ne.ownerDocument.doctype.name+`>
`+Ye),re&&(Ye=dt(Ye,W," "),Ye=dt(Ye,p," "),Ye=dt(Ye,I," ")),S&&ke?S.createHTML(Ye):Ye},t.setConfig=function(Be){_e(Be),H=!0},t.clearConfig=function(){He=null,H=!1},t.isValidAttribute=function(Be,he,Ne){He||_e({});const je=Ce(Be),Ke=Ce(he);return gt(je,Ke,Ne)},t.addHook=function(Be,he){typeof he=="function"&&(M[Be]=M[Be]||[],wt(M[Be],he))},t.removeHook=function(Be){if(M[Be])return zt(M[Be])},t.removeHooks=function(Be){M[Be]&&(M[Be]=[])},t.removeAllHooks=function(){M={}},t}var Di=Xt();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define(me[51],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rT=void 0,t.$sT=B;class i{constructor(A){this.domNode=A,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(A){const T=C(A);this.a!==T&&(this.a=T,this.domNode.style.maxWidth=this.a)}setWidth(A){const T=C(A);this.b!==T&&(this.b=T,this.domNode.style.width=this.b)}setHeight(A){const T=C(A);this.c!==T&&(this.c=T,this.domNode.style.height=this.c)}setTop(A){const T=C(A);this.d!==T&&(this.d=T,this.domNode.style.top=this.d)}setLeft(A){const T=C(A);this.e!==T&&(this.e=T,this.domNode.style.left=this.e)}setBottom(A){const T=C(A);this.f!==T&&(this.f=T,this.domNode.style.bottom=this.f)}setRight(A){const T=C(A);this.g!==T&&(this.g=T,this.domNode.style.right=this.g)}setPaddingTop(A){const T=C(A);this.h!==T&&(this.h=T,this.domNode.style.paddingTop=this.h)}setPaddingLeft(A){const T=C(A);this.i!==T&&(this.i=T,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(A){const T=C(A);this.j!==T&&(this.j=T,this.domNode.style.paddingBottom=this.j)}setPaddingRight(A){const T=C(A);this.k!==T&&(this.k=T,this.domNode.style.paddingRight=this.k)}setFontFamily(A){this.l!==A&&(this.l=A,this.domNode.style.fontFamily=this.l)}setFontWeight(A){this.m!==A&&(this.m=A,this.domNode.style.fontWeight=this.m)}setFontSize(A){const T=C(A);this.n!==T&&(this.n=T,this.domNode.style.fontSize=this.n)}setFontStyle(A){this.o!==A&&(this.o=A,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(A){this.p!==A&&(this.p=A,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(A){this.q!==A&&(this.q=A,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(A){this.r!==A&&(this.r=A,this.domNode.style.textDecoration=this.r)}setLineHeight(A){const T=C(A);this.s!==T&&(this.s=T,this.domNode.style.lineHeight=this.s)}setLetterSpacing(A){const T=C(A);this.t!==T&&(this.t=T,this.domNode.style.letterSpacing=this.t)}setClassName(A){this.u!==A&&(this.u=A,this.domNode.className=this.u)}toggleClassName(A,T){this.domNode.classList.toggle(A,T),this.u=this.domNode.className}setDisplay(A){this.v!==A&&(this.v=A,this.domNode.style.display=this.v)}setPosition(A){this.w!==A&&(this.w=A,this.domNode.style.position=this.w)}setVisibility(A){this.x!==A&&(this.x=A,this.domNode.style.visibility=this.x)}setColor(A){this.y!==A&&(this.y=A,this.domNode.style.color=this.y)}setBackgroundColor(A){this.z!==A&&(this.z=A,this.domNode.style.backgroundColor=this.z)}setLayerHinting(A){this.A!==A&&(this.A=A,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(A){this.C!==A&&(this.C=A,this.domNode.style.boxShadow=A)}setContain(A){this.B!==A&&(this.B=A,this.domNode.style.contain=this.B)}setAttribute(A,T){this.domNode.setAttribute(A,T)}removeAttribute(A){this.domNode.removeAttribute(A)}appendChild(A){this.domNode.appendChild(A.domNode)}removeChild(A){this.domNode.removeChild(A.domNode)}}t.$rT=i;function C(Q){return typeof Q=="number"?`${Q}px`:Q}function B(Q){return new i(Q)}}),define(me[79],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JR=void 0,t.$KR=Q;const i=new WeakMap;function C(T){if(!T.parent||T.parent===T)return null;try{const d=T.location,g=T.parent.location;if(d.origin!=="null"&&g.origin!=="null"&&d.origin!==g.origin)return null}catch{return null}return T.parent}class B{static a(d){let g=i.get(d);if(!g){g=[],i.set(d,g);let $=d,P;do P=C($),P?g.push({window:new WeakRef($),iframeElement:$.frameElement||null}):g.push({window:new WeakRef($),iframeElement:null}),$=P;while($)}return g.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(d,g){if(!g||d===g)return{top:0,left:0};let $=0,P=0;const c=this.a(d);for(const h of c){const e=h.window.deref();if($+=e?.scrollY??0,P+=e?.scrollX??0,e===g||!h.iframeElement)break;const n=h.iframeElement.getBoundingClientRect();$+=n.top,P+=n.left}return{top:$,left:P}}}t.$JR=B;async function Q(T,d){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const g=JSON.stringify({parentOrigin:T,salt:d}),P=new TextEncoder().encode(g),c=await crypto.subtle.digest("sha-256",P);return A(c)}function A(T){const g=Array.from(new Uint8Array(T)).map($=>$.toString(16).padStart(2,"0")).join("");return BigInt(`0x${g}`).toString(32).padStart(52,"0")}}),define(me[29],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yU=C,t.$zU=B;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupUpdatableHover:()=>null};function C(Q){i=Q}function B(){return i}}),define(me[80],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bU=t.$aU=t.$_T=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(A){A[A.Copy=0]="Copy",A[A.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var C;(function(A){A.Over="drop-target",A.Before="drop-target-before",A.After="drop-target-after"})(C||(t.ListDragOverEffectPosition=C={})),t.$_T={reject(){return{accept:!1}},accept(){return{accept:!0}}};class B extends Error{constructor(T,d){super(`ListError [${T}] ${d}`)}}t.$aU=B;class Q{constructor(){this.c=new WeakMap}getHeight(T){return this.c.get(T)??this.d(T)}setDynamicHeight(T,d){d>0&&this.c.set(T,d)}}t.$bU=Q}),define(me[81],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2T=void 0;class i{constructor(B){this.a=B}splice(B,Q,A){this.a.forEach(T=>T.splice(B,Q,A))}}t.$2T=i}),define(me[52],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xT=void 0;const i=20;class C{constructor(Q,A,T,d,g,$){this.a=Math.round(A),this.b=Math.round(T),this.c=Math.round(Q),this.d=d,this.e=g,this.f=$,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new C(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(Q){const A=Math.round(Q);return this.d!==A?(this.d=A,this.m(),!0):!1}setScrollSize(Q){const A=Math.round(Q);return this.e!==A?(this.e=A,this.m(),!0):!1}setScrollPosition(Q){const A=Math.round(Q);return this.f!==A?(this.f=A,this.m(),!0):!1}setScrollbarSize(Q){this.a=Math.round(Q)}setOppositeScrollbarSize(Q){this.b=Math.round(Q)}static l(Q,A,T,d,g){const $=Math.max(0,T-Q),P=Math.max(0,$-2*A),c=d>0&&d>T;if(!c)return{computedAvailableSize:Math.round($),computedIsNeeded:c,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const h=Math.round(Math.max(i,Math.floor(T*P/d))),e=(P-h)/(d-T),n=g*e;return{computedAvailableSize:Math.round($),computedIsNeeded:c,computedSliderSize:Math.round(h),computedSliderRatio:e,computedSliderPosition:Math.round(n)}}m(){const Q=C.l(this.b,this.c,this.d,this.e,this.f);this.g=Q.computedAvailableSize,this.h=Q.computedIsNeeded,this.i=Q.computedSliderSize,this.j=Q.computedSliderRatio,this.k=Q.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(Q){if(!this.h)return 0;const A=Q-this.c-this.i/2;return Math.round(A/this.j)}getDesiredScrollPositionFromOffsetPaged(Q){if(!this.h)return 0;const A=Q-this.c;let T=this.f;return A<this.k?T-=this.d:T+=this.d,T}getDesiredScrollPositionFromDelta(Q){if(!this.h)return 0;const A=this.k+Q;return Math.round(A/this.j)}}t.$xT=C}),define(me[30],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$V=t.$0V=t.$9V=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var i;(function(d){d[d.Hidden=0]="Hidden",d[d.Visible=1]="Visible",d[d.Recurse=2]="Recurse"})(i||(t.TreeVisibility=i={}));var C;(function(d){d[d.Expanded=0]="Expanded",d[d.Collapsed=1]="Collapsed",d[d.PreserveOrExpanded=2]="PreserveOrExpanded",d[d.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(C||(t.ObjectTreeElementCollapseState=C={}));var B;(function(d){d[d.Unknown=0]="Unknown",d[d.Twistie=1]="Twistie",d[d.Element=2]="Element",d[d.Filter=3]="Filter"})(B||(t.TreeMouseEventTarget=B={}));var Q;(function(d){d[d.Down=0]="Down",d[d.Up=1]="Up"})(Q||(t.TreeDragOverBubble=Q={})),t.$9V={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(d=!1){return{accept:!0,bubble:0,autoExpand:d}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(d=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:d}}};class A extends Error{constructor(g,$){super(`TreeError [${g}] ${$}`)}}t.$0V=A;class T{constructor(g){this.a=g,this.b=new WeakMap}map(g){let $=this.b.get(g);return $||($=this.a(g),this.b.set(g,$)),$}}t.$$V=T}),define(me[22],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nR=void 0,t.$mR=i,t.$oR=C;function i(B,Q){const A=B;typeof A.vscodeWindowId!="number"&&Object.defineProperty(A,"vscodeWindowId",{get:()=>Q})}t.$nR=window;function C(B){return B===t.$nR?!1:typeof B?.vscodeWindowId=="number"}}),define(me[82],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=C,t.$hb=B,t.$ib=Q,t.$jb=A,t.$kb=T,t.$lb=d,t.$nb=$,t.$ob=P,t.$pb=c,t.$qb=h,t.$rb=e;function i(n,o){const l=C(n,o);if(l!==-1)return n[l]}function C(n,o,l=n.length-1){for(let f=l;f>=0;f--){const S=n[f];if(o(S))return f}return-1}function B(n,o){const l=Q(n,o);return l===-1?void 0:n[l]}function Q(n,o,l=0,f=n.length){let S=l,m=f;for(;S<m;){const b=Math.floor((S+m)/2);o(n[b])?S=b+1:m=b}return S-1}function A(n,o){const l=T(n,o);return l===n.length?void 0:n[l]}function T(n,o,l=0,f=n.length){let S=l,m=f;for(;S<m;){const b=Math.floor((S+m)/2);o(n[b])?m=b:S=b+1}return S}function d(n,o,l=0,f=n.length){const S=T(n,o,l,f);return S===n.length?-1:S}class g{static{this.assertInvariants=!1}constructor(o){this.e=o,this.c=0}findLastMonotonous(o){if(g.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!o(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=o}const l=Q(this.e,o,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}t.$mb=g;function $(n,o){if(n.length===0)return;let l=n[0];for(let f=1;f<n.length;f++){const S=n[f];o(S,l)>0&&(l=S)}return l}function P(n,o){if(n.length===0)return;let l=n[0];for(let f=1;f<n.length;f++){const S=n[f];o(S,l)>=0&&(l=S)}return l}function c(n,o){return $(n,(l,f)=>-o(l,f))}function h(n,o){if(n.length===0)return-1;let l=0;for(let f=1;f<n.length;f++){const S=n[f];o(S,n[l])>0&&(l=f)}return l}function e(n,o){for(const l of n){const f=o(l);if(f!==void 0)return f}}}),define(me[83],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=C,t.$M=B,t.$N=Q;function i(A,T){const d=Object.create(null);for(const g of A){const $=T(g);let P=d[$];P||(P=d[$]=[]),P.push(g)}return d}function C(A,T){const d=[],g=[];for(const $ of A)T.has($)||d.push($);for(const $ of T)A.has($)||g.push($);return{removed:d,added:g}}function B(A,T){const d=[],g=[];for(const[$,P]of A)T.has($)||d.push(P);for(const[$,P]of T)A.has($)||g.push(P);return{removed:d,added:g}}function Q(A,T){const d=new Set;for(const g of T)A.has(g)&&d.add(g);return d}}),define(me[84],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pt=t.$Ot=t.$Nt=t.$Mt=void 0;function i(T,d){const g=Math.pow(10,d);return Math.round(T*g)/g}class C{constructor(d,g,$,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=i(Math.max(Math.min(1,P),0),3)}static equals(d,g){return d.r===g.r&&d.g===g.g&&d.b===g.b&&d.a===g.a}}t.$Mt=C;class B{constructor(d,g,$,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=i(Math.max(Math.min(1,g),0),3),this.l=i(Math.max(Math.min(1,$),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(d,g){return d.h===g.h&&d.s===g.s&&d.l===g.l&&d.a===g.a}static fromRGBA(d){const g=d.r/255,$=d.g/255,P=d.b/255,c=d.a,h=Math.max(g,$,P),e=Math.min(g,$,P);let n=0,o=0;const l=(e+h)/2,f=h-e;if(f>0){switch(o=Math.min(l<=.5?f/(2*l):f/(2-2*l),1),h){case g:n=($-P)/f+($<P?6:0);break;case $:n=(P-g)/f+2;break;case P:n=(g-$)/f+4;break}n*=60,n=Math.round(n)}return new B(n,o,l,c)}static i(d,g,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?d+(g-d)*6*$:$<1/2?g:$<2/3?d+(g-d)*(2/3-$)*6:d}static toRGBA(d){const g=d.h/360,{s:$,l:P,a:c}=d;let h,e,n;if($===0)h=e=n=P;else{const o=P<.5?P*(1+$):P+$-P*$,l=2*P-o;h=B.i(l,o,g+1/3),e=B.i(l,o,g),n=B.i(l,o,g-1/3)}return new C(Math.round(h*255),Math.round(e*255),Math.round(n*255),c)}}t.$Nt=B;class Q{constructor(d,g,$,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=i(Math.max(Math.min(1,g),0),3),this.v=i(Math.max(Math.min(1,$),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(d,g){return d.h===g.h&&d.s===g.s&&d.v===g.v&&d.a===g.a}static fromRGBA(d){const g=d.r/255,$=d.g/255,P=d.b/255,c=Math.max(g,$,P),h=Math.min(g,$,P),e=c-h,n=c===0?0:e/c;let o;return e===0?o=0:c===g?o=(($-P)/e%6+6)%6:c===$?o=(P-g)/e+2:o=(g-$)/e+4,new Q(Math.round(o*60),n,c,d.a)}static toRGBA(d){const{h:g,s:$,v:P,a:c}=d,h=P*$,e=h*(1-Math.abs(g/60%2-1)),n=P-h;let[o,l,f]=[0,0,0];return g<60?(o=h,l=e):g<120?(o=e,l=h):g<180?(l=h,f=e):g<240?(l=e,f=h):g<300?(o=e,f=h):g<=360&&(o=h,f=e),o=Math.round((o+n)*255),l=Math.round((l+n)*255),f=Math.round((f+n)*255),new C(o,l,f,c)}}t.$Ot=Q;class A{static fromHex(d){return A.Format.CSS.parseHex(d)||A.red}static equals(d,g){return!d&&!g?!0:!d||!g?!1:d.equals(g)}get hsla(){return this.i?this.i:B.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:Q.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof C)this.rgba=d;else if(d instanceof B)this.i=d,this.rgba=B.toRGBA(d);else if(d instanceof Q)this.j=d,this.rgba=Q.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&C.equals(this.rgba,d.rgba)&&B.equals(this.hsla,d.hsla)&&Q.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=A.k(this.rgba.r),g=A.k(this.rgba.g),$=A.k(this.rgba.b),P=.2126*d+.7152*g+.0722*$;return i(P,4)}static k(d){const g=d/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(d){const g=this.getRelativeLuminance(),$=d.getRelativeLuminance();return g>$?(g+.05)/($+.05):($+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const g=this.getRelativeLuminance(),$=d.getRelativeLuminance();return g>$}isDarkerThan(d){const g=this.getRelativeLuminance(),$=d.getRelativeLuminance();return g<$}lighten(d){return new A(new B(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new A(new B(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:g,g:$,b:P,a:c}=this.rgba;return new A(new C(g,$,P,c*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const g=d.rgba,$=this.rgba.a,P=g.a,c=$+P*(1-$);if(c<1e-6)return A.transparent;const h=this.rgba.r*$/c+g.r*P*(1-$)/c,e=this.rgba.g*$/c+g.g*P*(1-$)/c,n=this.rgba.b*$/c+g.b*P*(1-$)/c;return new A(new C(h,e,n,c))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:g,g:$,b:P,a:c}=this.rgba;return new A(new C(d.rgba.r-c*(d.rgba.r-g),d.rgba.g-c*(d.rgba.g-$),d.rgba.b-c*(d.rgba.b-P),1))}flatten(...d){const g=d.reduceRight(($,P)=>A.o(P,$));return A.o(this,g)}static o(d,g){const $=1-d.rgba.a;return new A(new C($*g.rgba.r+d.rgba.a*d.rgba.r,$*g.rgba.g+d.rgba.a*d.rgba.g,$*g.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(d,g,$){if(d.isLighterThan(g))return d;$=$||.5;const P=d.getRelativeLuminance(),c=g.getRelativeLuminance();return $=$*(c-P)/c,d.lighten($)}static getDarkerColor(d,g,$){if(d.isDarkerThan(g))return d;$=$||.5;const P=d.getRelativeLuminance(),c=g.getRelativeLuminance();return $=$*(P-c)/P,d.darken($)}static{this.white=new A(new C(255,255,255,1))}static{this.black=new A(new C(0,0,0,1))}static{this.red=new A(new C(255,0,0,1))}static{this.blue=new A(new C(0,0,255,1))}static{this.green=new A(new C(0,255,0,1))}static{this.cyan=new A(new C(0,255,255,1))}static{this.lightgrey=new A(new C(211,211,211,1))}static{this.transparent=new A(new C(0,0,0,0))}}t.$Pt=A,function(T){let d;(function(g){let $;(function(P){function c(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:T.Format.CSS.formatRGBA(r)}P.formatRGB=c;function h(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}P.formatRGBA=h;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:T.Format.CSS.formatHSLA(r)}P.formatHSL=e;function n(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}P.formatHSLA=n;function o(r){const E=r.toString(16);return E.length!==2?"0"+E:E}function l(r){return`#${o(r.rgba.r)}${o(r.rgba.g)}${o(r.rgba.b)}`}P.formatHex=l;function f(r,E=!1){return E&&r.rgba.a===1?T.Format.CSS.formatHex(r):`#${o(r.rgba.r)}${o(r.rgba.g)}${o(r.rgba.b)}${o(Math.round(r.rgba.a*255))}`}P.formatHexA=f;function S(r){return r.isOpaque()?T.Format.CSS.formatHex(r):T.Format.CSS.formatRGBA(r)}P.format=S;function m(r){const E=r.length;if(E===0||r.charCodeAt(0)!==35)return null;if(E===7){const k=16*b(r.charCodeAt(1))+b(r.charCodeAt(2)),F=16*b(r.charCodeAt(3))+b(r.charCodeAt(4)),M=16*b(r.charCodeAt(5))+b(r.charCodeAt(6));return new T(new C(k,F,M,1))}if(E===9){const k=16*b(r.charCodeAt(1))+b(r.charCodeAt(2)),F=16*b(r.charCodeAt(3))+b(r.charCodeAt(4)),M=16*b(r.charCodeAt(5))+b(r.charCodeAt(6)),W=16*b(r.charCodeAt(7))+b(r.charCodeAt(8));return new T(new C(k,F,M,W/255))}if(E===4){const k=b(r.charCodeAt(1)),F=b(r.charCodeAt(2)),M=b(r.charCodeAt(3));return new T(new C(16*k+k,16*F+F,16*M+M))}if(E===5){const k=b(r.charCodeAt(1)),F=b(r.charCodeAt(2)),M=b(r.charCodeAt(3)),W=b(r.charCodeAt(4));return new T(new C(16*k+k,16*F+F,16*M+M,(16*W+W)/255))}return null}P.parseHex=m;function b(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})($=g.CSS||(g.CSS={}))})(d=T.Format||(T.Format={}))}(A||(t.$Pt=A={}))}),define(me[31],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1h=C,t.$2h=B,t.$3h=Q;function i(A){return(T,d,g)=>{let $=null,P=null;if(typeof g.value=="function"?($="value",P=g.value):typeof g.get=="function"&&($="get",P=g.get),!P)throw new Error("not supported");g[$]=A(P,d)}}function C(A,T,d){let g=null,$=null;if(typeof d.value=="function"?(g="value",$=d.value,$.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(g="get",$=d.get),!$)throw new Error("not supported");const P=`$memoize$${T}`;d[g]=function(...c){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:$.apply(this,c)}),this[P]}}function B(A,T,d){return i((g,$)=>{const P=`$debounce$${$}`,c=`$debounce$result$${$}`;return function(...h){this[c]||(this[c]=d?d():void 0),clearTimeout(this[P]),T&&(this[c]=T(this[c],...h),h=[this[c]]),this[P]=setTimeout(()=>{g.apply(this,h),this[c]=d?d():void 0},A)}})}function Q(A,T,d){return i((g,$)=>{const P=`$throttle$timer$${$}`,c=`$throttle$result$${$}`,h=`$throttle$lastRun$${$}`,e=`$throttle$pending$${$}`;return function(...n){if(this[c]||(this[c]=d?d():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),T&&(this[c]=T(this[c],...n)),this[e])return;const o=this[h]+A;o<=Date.now()?(this[h]=Date.now(),g.apply(this,[this[c]]),this[c]=d?d():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[h]=Date.now(),g.apply(this,[this[c]]),this[c]=d?d():void 0},o-Date.now()))}})}}),define(me[85],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xt=void 0;class i{constructor(B,Q,A,T){this.originalStart=B,this.originalLength=Q,this.modifiedStart=A,this.modifiedLength=T}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$xt=i}),define(me[6],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=C,t.$Z=B,t.$1=Q,t.$2=A,t.$3=T,t.$4=g,t.$6=P,t.$7=c,t.$8=h,t.$0=n;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?S.isErrorNoTelemetry(r)?new S(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(E=>{E(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$W=i,t.$X=new i;function C(b){t.$X.setUnexpectedErrorHandler(b)}function B(b){if(!b||typeof b!="object")return!1;const r=b;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function Q(b){g(b)||t.$X.onUnexpectedError(b)}function A(b){g(b)||t.$X.onUnexpectedExternalError(b)}function T(b){if(b instanceof Error){const{name:r,message:E}=b,k=b.stacktrace||b.stack;return{$isError:!0,name:r,message:E,stack:k,noTelemetry:S.isErrorNoTelemetry(b)}}return b}const d="Canceled";function g(b){return b instanceof $?!0:b instanceof Error&&b.name===d&&b.message===d}class $ extends Error{constructor(){super(d),this.name=this.message}}t.$5=$;function P(){const b=new Error(d);return b.name=b.message,b}function c(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}function h(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function n(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}class o extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$$=o;class l extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$_=l;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=f;class S extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof S)return r;const E=new S;return E.message=r.message,E.stack=r.stack,E}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$bb=S;class m extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}t.$cb=m}),define(me[8],be([1,0,6,82]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=B,t.$tb=Q,t.$ub=A,t.$vb=T,t.$wb=d,t.$xb=g,t.$yb=$,t.$zb=P,t.$Ab=c,t.$Bb=h,t.$Cb=e,t.$Db=n,t.$Eb=o,t.top=l,t.$Gb=f,t.$Hb=m,t.$Ib=b,t.$Jb=r,t.$Kb=E,t.$Lb=k,t.$Mb=F,t.$Nb=M,t.$Ob=W,t.$Pb=p,t.$Qb=I,t.$Rb=V,t.$Sb=R,t.$Tb=x,t.$Ub=O,t.$Vb=G,t.$Wb=q,t.$Xb=ae,t.$Yb=ie,t.$Zb=ee,t.$1b=ce,t.$2b=De,t.$3b=Ee,t.$4b=Me,t.$5b=le,t.$6b=_,t.$7b=ye,t.$8b=H,t.$$b=we;function B(z,u=0){return z[z.length-(1+u)]}function Q(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function A(z,u,y=(a,v)=>a===v){if(z===u)return!0;if(!z||!u||z.length!==u.length)return!1;for(let a=0,v=z.length;a<v;a++)if(!y(z[a],u[a]))return!1;return!0}function T(z,u){const y=z.length-1;u<y&&(z[u]=z[y]),z.pop()}function d(z,u,y){return g(z.length,a=>y(z[a],u))}function g(z,u){let y=0,a=z-1;for(;y<=a;){const v=(y+a)/2|0,N=u(v);if(N<0)y=v+1;else if(N>0)a=v-1;else return v}return-(y+1)}function $(z,u,y){if(z=z|0,z>=u.length)throw new TypeError("invalid index");const a=u[Math.floor(u.length*Math.random())],v=[],N=[],s=[];for(const D of u){const w=y(D,a);w<0?v.push(D):w>0?N.push(D):s.push(D)}return z<v.length?$(z,v,y):z<v.length+s.length?s[0]:$(z-(v.length+s.length),N,y)}function P(z,u){const y=[];let a;for(const v of z.slice(0).sort(u))!a||u(a[0],v)!==0?(a=[v],y.push(a)):a.push(v);return y}function*c(z,u){let y,a;for(const v of z)a!==void 0&&u(a,v)?y.push(v):(y&&(yield y),y=[v]),a=v;y&&(yield y)}function h(z,u){for(let y=0;y<=z.length;y++)u(y===0?void 0:z[y-1],y===z.length?void 0:z[y])}function e(z,u){for(let y=0;y<z.length;y++)u(y===0?void 0:z[y-1],z[y],y+1===z.length?void 0:z[y+1])}function n(z,u,y){const a=[];function v(D,w,L){if(w===0&&L.length===0)return;const j=a[a.length-1];j&&j.start+j.deleteCount===D?(j.deleteCount+=w,j.toInsert.push(...L)):a.push({start:D,deleteCount:w,toInsert:L})}let N=0,s=0;for(;;){if(N===z.length){v(N,0,u.slice(s));break}if(s===u.length){v(N,z.length-N,[]);break}const D=z[N],w=u[s],L=y(D,w);L===0?(N+=1,s+=1):L<0?(v(N,1,[]),N+=1):L>0&&(v(N,0,[w]),s+=1)}return a}function o(z,u,y){const a=n(z,u,y),v=[],N=[];for(const s of a)v.push(...z.slice(s.start,s.start+s.deleteCount)),N.push(...s.toInsert);return{removed:v,added:N}}function l(z,u,y){if(y===0)return[];const a=z.slice(0,y).sort(u);return S(z,u,a,y,z.length),a}function f(z,u,y,a,v){return y===0?Promise.resolve([]):new Promise((N,s)=>{(async()=>{const D=z.length,w=z.slice(0,y).sort(u);for(let L=y,j=Math.min(y+a,D);L<D;L=j,j=Math.min(j+a,D)){if(L>y&&await new Promise(X=>setTimeout(X)),v&&v.isCancellationRequested)throw new i.$5;S(z,u,w,L,j)}return w})().then(N,s)})}function S(z,u,y,a,v){for(const N=y.length;a<v;a++){const s=z[a];if(u(s,y[N-1])<0){y.pop();const D=(0,C.$kb)(y,w=>u(s,w)<0);y.splice(D,0,s)}}}function m(z){return z.filter(u=>!!u)}function b(z){let u=0;for(let y=0;y<z.length;y++)z[y]&&(z[u]=z[y],u+=1);z.length=u}function r(z,u,y){z.splice(y,0,z.splice(u,1)[0])}function E(z){return!Array.isArray(z)||z.length===0}function k(z){return Array.isArray(z)&&z.length>0}function F(z,u=y=>y){const y=new Set;return z.filter(a=>{const v=u(a);return y.has(v)?!1:(y.add(v),!0)})}function M(z){const u=new Set;return y=>{const a=z(y);return u.has(a)?!1:(u.add(a),!0)}}function W(z,u){return z.length>0?z[0]:u}function p(z,u){return z.length>0?z[z.length-1]:u}function I(z,u,y=(a,v)=>a===v){let a=0;for(let v=0,N=Math.min(z.length,u.length);v<N&&y(z[v],u[v]);v++)a++;return a}function V(z){return[].concat(...z)}function R(z,u){let y=typeof u=="number"?z:0;typeof u=="number"?y=z:(y=0,u=z);const a=[];if(y<=u)for(let v=y;v<u;v++)a.push(v);else for(let v=y;v>u;v--)a.push(v);return a}function x(z,u,y){return z.reduce((a,v)=>(a[u(v)]=y?y(v):v,a),Object.create(null))}function O(z,u){return z.push(u),()=>G(z,u)}function G(z,u){const y=z.indexOf(u);if(y>-1)return z.splice(y,1),u}function q(z,u,y){const a=z.slice(0,u),v=z.slice(u);return a.concat(y,v)}function ae(z,u){let y;if(typeof u=="number"){let a=u;y=()=>{const v=Math.sin(a++)*179426549;return v-Math.floor(v)}}else y=Math.random;for(let a=z.length-1;a>0;a-=1){const v=Math.floor(y()*(a+1)),N=z[a];z[a]=z[v],z[v]=N}}function ie(z,u){const y=z.indexOf(u);y>-1&&(z.splice(y,1),z.unshift(u))}function ee(z,u){const y=z.indexOf(u);y>-1&&(z.splice(y,1),z.push(u))}function ce(z,u){for(const y of u)z.push(y)}function De(z,u){return Array.isArray(z)?z.map(u):u(z)}function Ee(z){return Array.isArray(z)?z:[z]}function Me(z){return z[Math.floor(Math.random()*z.length)]}function le(z,u,y){const a=ue(z,u),v=z.length,N=y.length;z.length=v+N;for(let s=v-1;s>=a;s--)z[s+N]=z[s];for(let s=0;s<N;s++)z[s+a]=y[s]}function _(z,u,y,a){const v=ue(z,u);let N=z.splice(v,y);return N===void 0&&(N=[]),le(z,v,a),N}function ue(z,u){return u<0?Math.max(u+z.length,0):Math.min(u,z.length)}var re;(function(z){function u(N){return N<0}z.isLessThan=u;function y(N){return N<=0}z.isLessThanOrEqual=y;function a(N){return N>0}z.isGreaterThan=a;function v(N){return N===0}z.isNeitherLessOrGreaterThan=v,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(re||(t.CompareResult=re={}));function ye(z,u){return(y,a)=>u(z(y),z(a))}function H(...z){return(u,y)=>{for(const a of z){const v=a(u,y);if(!re.isNeitherLessOrGreaterThan(v))return v}return re.neitherLessOrGreaterThan}}const J=(z,u)=>z-u;t.$9b=J;const ge=(z,u)=>(0,t.$9b)(z?1:0,u?1:0);t.$0b=ge;function we(z){return(u,y)=>-z(u,y)}class ke{constructor(u){this.g=u,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(u){let y=this.c;for(;y<this.g.length&&u(this.g[y]);)y++;const a=y===this.c?null:this.g.slice(this.c,y);return this.c=y,a}takeFromEndWhile(u){let y=this.d;for(;y>=0&&u(this.g[y]);)y--;const a=y===this.d?null:this.g.slice(y+1,this.d+1);return this.d=y,a}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const u=this.g[this.c];return this.c++,u}removeLast(){const u=this.g[this.d];return this.d--,u}takeCount(u){const y=this.g.slice(this.c,this.c+u);return this.c+=u,y}}t.$_b=ke;class Fe{static{this.empty=new Fe(u=>{})}constructor(u){this.iterate=u}forEach(u){this.iterate(y=>(u(y),!0))}toArray(){const u=[];return this.iterate(y=>(u.push(y),!0)),u}filter(u){return new Fe(y=>this.iterate(a=>u(a)?y(a):!0))}map(u){return new Fe(y=>this.iterate(a=>y(u(a))))}some(u){let y=!1;return this.iterate(a=>(y=u(a),!y)),y}findFirst(u){let y;return this.iterate(a=>u(a)?(y=a,!1):!0),y}findLast(u){let y;return this.iterate(a=>(u(a)&&(y=a),!0)),y}findLastMaxBy(u){let y,a=!0;return this.iterate(v=>((a||re.isGreaterThan(u(v,y)))&&(a=!1,y=v),!0)),y}}t.$ac=Fe;class Ie{constructor(u){this.c=u}static createSortPermutation(u,y){const a=Array.from(u.keys()).sort((v,N)=>y(u[v],u[N]));return new Ie(a)}apply(u){return u.map((y,a)=>u[this.c[a]])}inverse(){const u=this.c.slice();for(let y=0;y<this.c.length;y++)u[this.c[y]]=y;return new Ie(u)}}t.$bc=Ie}),define(me[37],be([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=C,t.$fd=B,t.$gd=Q,t.$hd=A,t.$id=T,t.$jd=d;function C(g,$){if(!g)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}function B(g,$="Unreachable"){throw new Error($)}function Q(g){if(!g)throw new i.$cb("Assertion Failed")}function A(g){g||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function T(g){if(!g()){debugger;g(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function d(g,$){let P=0;for(;P<g.length-1;){const c=g[P],h=g[P+1];if(!$(c,h))return!1;P++}return!0}}),define(me[38],be([1,0,8]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=void 0,t.$8c=B,t.$9c=Q,t.$0c=A,t.$$c=T,t.$_c=d,t.$ad=g;const C=(h,e)=>h===e;t.$7c=C;function B(h=t.$7c){return(e,n)=>i.$ub(e,n,h)}function Q(){return(h,e)=>JSON.stringify(h)===JSON.stringify(e)}function A(){return(h,e)=>h.equals(e)}function T(h,e,n){return!h||!e?h===e:n(h,e)}function d(h,e){if(h===e)return!0;if(Array.isArray(h)&&Array.isArray(e)){if(h.length!==e.length)return!1;for(let n=0;n<h.length;n++)if(!d(h[n],e[n]))return!1;return!0}if(h&&typeof h=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(h)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const n=h,o=e,l=Object.keys(n),f=Object.keys(o),S=new Set(f);if(l.length!==f.length)return!1;for(const m of l)if(!S.has(m)||!d(n[m],o[m]))return!1;return!0}return!1}function g(h){return JSON.stringify(c(h))}let $=0;const P=new WeakMap;function c(h){if(Array.isArray(h))return h.map(c);if(h&&typeof h=="object")if(Object.getPrototypeOf(h)===Object.prototype){const e=h,n=Object.create(null);for(const o of Object.keys(e).sort())n[o]=c(e[o]);return n}else{let e=P.get(h);return e===void 0&&(e=$++,P.set(h,e)),e+"----2b76a038c20c4bcc"}return h}}),define(me[53],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(C,B){const Q=this;let A=!1,T;return function(){if(A)return T;if(A=!0,B)try{T=C.apply(Q,arguments)}finally{B()}else T=C.apply(Q,arguments);return T}}}),define(me[86],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wP=t.$vP=void 0;class i{constructor(B){this.a=B,this.b=0}nextId(){return this.a+ ++this.b}}t.$vP=i,t.$wP=new i("id#")}),define(me[32],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(C){function B(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}C.is=B;const Q=Object.freeze([]);function A(){return Q}C.empty=A;function*T(r){yield r}C.single=T;function d(r){return B(r)?r:T(r)}C.wrap=d;function g(r){return r||Q}C.from=g;function*$(r){for(let E=r.length-1;E>=0;E--)yield r[E]}C.reverse=$;function P(r){return!r||r[Symbol.iterator]().next().done===!0}C.isEmpty=P;function c(r){return r[Symbol.iterator]().next().value}C.first=c;function h(r,E){for(const k of r)if(E(k))return!0;return!1}C.some=h;function e(r,E){for(const k of r)if(E(k))return k}C.find=e;function*n(r,E){for(const k of r)E(k)&&(yield k)}C.filter=n;function*o(r,E){let k=0;for(const F of r)yield E(F,k++)}C.map=o;function*l(...r){for(const E of r)yield*E}C.concat=l;function f(r,E,k){let F=k;for(const M of r)F=E(F,M);return F}C.reduce=f;function*S(r,E,k=r.length){for(E<0&&(E+=r.length),k<0?k+=r.length:k>r.length&&(k=r.length);E<k;E++)yield r[E]}C.slice=S;function m(r,E=Number.POSITIVE_INFINITY){const k=[];if(E===0)return[k,r];const F=r[Symbol.iterator]();for(let M=0;M<E;M++){const W=F.next();if(W.done)return[k,C.empty()];k.push(W.value)}return[k,{[Symbol.iterator](){return F}}]}C.consume=m;async function b(r){const E=[];for await(const k of r)E.push(k);return Promise.resolve(E)}C.asyncToArray=b})(i||(t.Iterable=i={}))}),define(me[54],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Dr=t.$Cr=t.$Br=t.$Ar=t.$zr=t.ScanCode=t.KeyCode=void 0,t.$Er=h;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var C;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(C||(t.ScanCode=C={}));class B{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(n,o){this._keyCodeToStr[n]=o,this._strToKeyCode[o.toLowerCase()]=n}keyCodeToStr(n){return this._keyCodeToStr[n]}strToKeyCode(n){return this._strToKeyCode[n.toLowerCase()]||0}}const Q=new B,A=new B,T=new B;t.$zr=new Array(230),t.$Ar={};const d=[],g=Object.create(null),$=Object.create(null);t.$Br={lowerCaseToEnum:e=>$[e]||0,toEnum:e=>g[e]||0,toString:e=>d[e]||"None"},t.$Cr=[],t.$Dr=[];for(let e=0;e<=193;e++)t.$Cr[e]=-1;for(let e=0;e<=132;e++)t.$Dr[e]=-1;(function(){const e="",n=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],o=[],l=[];for(const f of n){const[S,m,b,r,E,k,F,M,W]=f;if(l[m]||(l[m]=!0,d[m]=b,g[b]=m,$[b.toLowerCase()]=m,S&&(t.$Cr[m]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$Dr[r]=m))),!o[r]){if(o[r]=!0,!E)throw new Error(`String representation missing for key code ${r} around scan code ${b}`);Q.define(r,E),A.define(r,M||E),T.define(r,W||M||E)}k&&(t.$zr[k]=r),F&&(t.$Ar[F]=r)}t.$Dr[3]=46})();var P;(function(e){function n(b){return Q.keyCodeToStr(b)}e.toString=n;function o(b){return Q.strToKeyCode(b)}e.fromString=o;function l(b){return A.keyCodeToStr(b)}e.toUserSettingsUS=l;function f(b){return T.keyCodeToStr(b)}e.toUserSettingsGeneral=f;function S(b){return A.strToKeyCode(b)||T.strToKeyCode(b)}e.fromUserSettings=S;function m(b){if(b>=98&&b<=113)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return Q.keyCodeToStr(b)}e.toElectronAccelerator=m})(P||(t.KeyCodeUtils=P={}));var c;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(c||(t.KeyMod=c={}));function h(e,n){const o=(n&65535)<<16>>>0;return(e|o)>>>0}}),define(me[87],be([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lr=t.$Kr=t.$Jr=t.$Ir=t.$Hr=void 0,t.$Fr=B,t.$Gr=Q;var C;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(C||(C={}));function B(P,c){if(typeof P=="number"){if(P===0)return null;const h=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new d([Q(h,c),Q(e,c)]):new d([Q(h,c)])}else{const h=[];for(let e=0;e<P.length;e++)h.push(Q(P[e],c));return new d(h)}}function Q(P,c){const h=!!(P&2048),e=!!(P&256),n=c===2?e:h,o=!!(P&1024),l=!!(P&512),f=c===2?h:e,S=P&255;return new A(n,o,l,f,S)}class A{constructor(c,h,e,n,o){this.ctrlKey=c,this.shiftKey=h,this.altKey=e,this.metaKey=n,this.keyCode=o}equals(c){return c instanceof A&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`K${c}${h}${e}${n}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new d([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Hr=A;class T{constructor(c,h,e,n,o){this.ctrlKey=c,this.shiftKey=h,this.altKey=e,this.metaKey=n,this.scanCode=o}equals(c){return c instanceof T&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.scanCode===c.scanCode}getHashCode(){const c=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`S${c}${h}${e}${n}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Ir=T;class d{constructor(c){if(c.length===0)throw(0,i.$7)("chords");this.chords=c}getHashCode(){let c="";for(let h=0,e=this.chords.length;h<e;h++)h!==0&&(c+=";"),c+=this.chords[h].getHashCode();return c}equals(c){if(c===null||this.chords.length!==c.chords.length)return!1;for(let h=0;h<this.chords.length;h++)if(!this.chords[h].equals(c.chords[h]))return!1;return!0}}t.$Jr=d;class g{constructor(c,h,e,n,o,l){this.ctrlKey=c,this.shiftKey=h,this.altKey=e,this.metaKey=n,this.keyLabel=o,this.keyAriaLabel=l}}t.$Kr=g;class ${}t.$Lr=$}),define(me[23],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(B){this.d=B,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(B){this.c=B}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),define(me[14],be([1,0,23]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MT=T,t.$NT=d,t.$OT=g;let B=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const Q=new i.$V(()=>B("mouse",!1)),A=new i.$V(()=>B("element",!1));function T($){B=$}function d($){return $==="element"?A.value:Q.value}function g(){return B("element",!0)}}),define(me[55],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(Q){this.element=Q,this.next=i.Undefined,this.prev=i.Undefined}}class C{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let Q=this.a;for(;Q!==i.Undefined;){const A=Q.next;Q.prev=i.Undefined,Q.next=i.Undefined,Q=A}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(Q){return this.d(Q,!1)}push(Q){return this.d(Q,!0)}d(Q,A){const T=new i(Q);if(this.a===i.Undefined)this.a=T,this.b=T;else if(A){const g=this.b;this.b=T,T.prev=g,g.next=T}else{const g=this.a;this.a=T,T.next=g,g.prev=T}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(T))}}shift(){if(this.a!==i.Undefined){const Q=this.a.element;return this.e(this.a),Q}}pop(){if(this.b!==i.Undefined){const Q=this.b.element;return this.e(this.b),Q}}e(Q){if(Q.prev!==i.Undefined&&Q.next!==i.Undefined){const A=Q.prev;A.next=Q.next,Q.next.prev=A}else Q.prev===i.Undefined&&Q.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):Q.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):Q.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let Q=this.a;for(;Q!==i.Undefined;)yield Q.element,Q=Q.next}}t.$6c=C}),define(me[39],be([1,0]),function(se,t){"use strict";var i,C,B;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=Q,t.$zc=A,t.$Ac=T,t.$Jc=m;function Q(b,r,E){let k=b.get(r);return k===void 0&&(k=E,b.set(r,k)),k}function A(b){const r=[];return b.forEach((E,k)=>{r.push(`${k} => ${E}`)}),`Map(${b.size}) {${r.join(", ")}}`}function T(b){const r=[];return b.forEach(E=>{r.push(E)}),`Set(${b.size}) {${r.join(", ")}}`}class d{constructor(r,E){this.uri=r,this.value=E}}function g(b){return Array.isArray(b)}class ${static{this.c=r=>r.toString()}constructor(r,E){if(this[i]="ResourceMap",r instanceof $)this.d=new Map(r.d),this.e=E??$.c;else if(g(r)){this.d=new Map,this.e=E??$.c;for(const[k,F]of r)this.set(k,F)}else this.d=new Map,this.e=r??$.c}set(r,E){return this.d.set(this.e(r),new d(r,E)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,E){typeof E<"u"&&(r=r.bind(E));for(const[k,F]of this.d)r(F.value,F.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}t.$Bc=$;class P{constructor(r,E){this[C]="ResourceSet",!r||typeof r=="function"?this.c=new $(r):(this.c=new $(E),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,E){this.c.forEach((k,F)=>r.call(E,F,F,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=P;var c;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(c||(t.Touch=c={}));class h{constructor(){this[B]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,E=0){const k=this.c.get(r);if(k)return E!==0&&this.m(k,E),k.value}set(r,E,k=0){let F=this.c.get(r);if(F)F.value=E,k!==0&&this.m(F,k);else{switch(F={key:r,value:E,next:void 0,previous:void 0},k){case 0:this.k(F);break;case 1:this.j(F);break;case 2:this.k(F);break;default:this.k(F);break}this.c.set(r,F),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const E=this.c.get(r);if(E)return this.c.delete(r),this.l(E),this.f--,E.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,E){const k=this.g;let F=this.d;for(;F;){if(E?r.bind(E)(F.value,F.key,this):r(F.value,F.key,this),this.g!==k)throw new Error("LinkedMap got modified during iteration.");F=F.next}}keys(){const r=this,E=this.g;let k=this.d;const F={[Symbol.iterator](){return F},next(){if(r.g!==E)throw new Error("LinkedMap got modified during iteration.");if(k){const M={value:k.key,done:!1};return k=k.next,M}else return{value:void 0,done:!0}}};return F}values(){const r=this,E=this.g;let k=this.d;const F={[Symbol.iterator](){return F},next(){if(r.g!==E)throw new Error("LinkedMap got modified during iteration.");if(k){const M={value:k.value,done:!1};return k=k.next,M}else return{value:void 0,done:!0}}};return F}entries(){const r=this,E=this.g;let k=this.d;const F={[Symbol.iterator](){return F},next(){if(r.g!==E)throw new Error("LinkedMap got modified during iteration.");if(k){const M={value:[k.key,k.value],done:!1};return k=k.next,M}else return{value:void 0,done:!0}}};return F}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let E=this.d,k=this.size;for(;E&&k>r;)this.c.delete(E.key),E=E.next,k--;this.d=E,this.f=k,E&&(E.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let E=this.e,k=this.size;for(;E&&k>r;)this.c.delete(E.key),E=E.previous,k--;this.e=E,this.f=k,E&&(E.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const E=r.next,k=r.previous;if(!E||!k)throw new Error("Invalid list");E.previous=k,k.next=E}r.next=void 0,r.previous=void 0,this.g++}m(r,E){if(!this.d||!this.e)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(r===this.d)return;const k=r.next,F=r.previous;r===this.e?(F.next=void 0,this.e=F):(k.previous=F,F.next=k),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(E===2){if(r===this.e)return;const k=r.next,F=r.previous;r===this.d?(k.previous=void 0,this.d=k):(k.previous=F,F.next=k),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((E,k)=>{r.push([k,E])}),r}fromJSON(r){this.clear();for(const[E,k]of r)this.set(E,k)}}t.$Dc=h;class e extends h{constructor(r,E=1){super(),this.n=r,this.o=Math.min(Math.max(0,E),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,E=2){return super.get(r,E)}peek(r){return super.get(r,0)}set(r,E){return super.set(r,E,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class n extends e{constructor(r,E=1){super(r,E)}q(r){this.h(r)}set(r,E){return super.set(r,E),this.p(),this}}t.$Ec=n;class o extends e{constructor(r,E=1){super(r,E)}q(r){this.i(r)}set(r,E){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,E),this}}t.$Fc=o;class l{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let E=this.c.get(r)||0;return E===0?!1:(E--,E===0?this.c.delete(r):this.c.set(r,E),!0)}has(r){return this.c.has(r)}}t.$Gc=l;class f{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[E,k]of r)this.set(E,k)}clear(){this.c.clear(),this.d.clear()}set(r,E){this.c.set(r,E),this.d.set(E,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const E=this.c.get(r);return E===void 0?!1:(this.c.delete(r),this.d.delete(E),!0)}forEach(r,E){this.c.forEach((k,F)=>{r.call(E,k,F,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Hc=f;class S{constructor(){this.c=new Map}add(r,E){let k=this.c.get(r);k||(k=new Set,this.c.set(r,k)),k.add(E)}delete(r,E){const k=this.c.get(r);k&&(k.delete(E),k.size===0&&this.c.delete(r))}forEach(r,E){const k=this.c.get(r);k&&k.forEach(E)}get(r){const E=this.c.get(r);return E||new Set}}t.$Ic=S;function m(b,r){if(b===r)return!0;if(b.size!==r.size)return!1;for(const[E,k]of b)if(!r.has(E)||r.get(E)!==k)return!1;for(const[E]of r)if(!b.has(E))return!1;return!0}}),define(me[2],be([1,0,8,83,39,53,32]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Kc=void 0,t.$Lc=$,t.$Mc=P,t.$Nc=c,t.$Oc=n,t.$Pc=o,t.$Qc=l,t.$Rc=f,t.$Sc=S,t.$Tc=m,t.$4c=V;const T=!1;let d=null;class g{constructor(){this.b=new Map}static{this.a=0}c(O){let G=this.b.get(O);return G||(G={parent:null,source:null,isSingleton:!1,value:O,idx:g.a++},this.b.set(O,G)),G}trackDisposable(O){const G=this.c(O);G.source||(G.source=new Error().stack)}setParent(O,G){const q=this.c(O);q.parent=G}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,G){const q=G.get(O);if(q)return q;const ae=O.parent?this.f(this.c(O.parent),G):O;return G.set(O,ae),ae}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,q])=>q.source!==null&&!this.f(q,O).isSingleton).flatMap(([q])=>q)}computeLeakingDisposables(O=10,G){let q;if(G)q=G;else{const De=new Map,Ee=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,De).isSingleton);if(Ee.length===0)return;const Me=new Set(Ee.map(le=>le.value));if(q=Ee.filter(le=>!(le.parent&&Me.has(le.parent))),q.length===0)throw new Error("There are cyclic diposable chains!")}if(!q)return;function ae(De){function Ee(le,_){for(;le.length>0&&_.some(ue=>typeof ue=="string"?ue===le[0]:le[0].match(ue));)le.shift()}const Me=De.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Ee(Me,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Me.reverse()}const ie=new B.$Ic;for(const De of q){const Ee=ae(De);for(let Me=0;Me<=Ee.length;Me++)ie.add(Ee.slice(0,Me).join(`
`),De)}q.sort((0,i.$7b)(De=>De.idx,i.$9b));let ee="",ce=0;for(const De of q.slice(0,O)){ce++;const Ee=ae(De),Me=[];for(let le=0;le<Ee.length;le++){let _=Ee[le];_=`(shared with ${ie.get(Ee.slice(0,le+1).join(`
`)).size}/${q.length} leaks) at ${_}`;const re=ie.get(Ee.slice(0,le).join(`
`)),ye=(0,C.$K)([...re].map(H=>ae(H)[le]),H=>H);delete ye[Ee[le]];for(const[H,J]of Object.entries(ye))Me.unshift(`    - stacktraces of ${J.length} other leaks continue with ${H}`);Me.unshift(_)}ee+=`


==================== Leaking disposable ${ce}/${q.length}: ${De.value.constructor.name} ====================
${Me.join(`
`)}
============================================================

`}return q.length>O&&(ee+=`


... and ${q.length-O} more leaking disposables

`),{leaks:q,details:ee}}}t.$Kc=g;function $(x){d=x}if(T){const x="__is_disposable_tracked__";$(new class{trackDisposable(O){const G=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[x]||console.log(G)},3e3)}setParent(O,G){if(O&&O!==r.None)try{O[x]=!0}catch{}}markAsDisposed(O){if(O&&O!==r.None)try{O[x]=!0}catch{}}markAsSingleton(O){}})}function P(x){return d?.trackDisposable(x),x}function c(x){d?.markAsDisposed(x)}function h(x,O){d?.setParent(x,O)}function e(x,O){if(d)for(const G of x)d.setParent(G,O)}function n(x){return d?.markAsSingleton(x),x}function o(x){return typeof x=="object"&&x!==null&&typeof x.dispose=="function"&&x.dispose.length===0}function l(x){if(A.Iterable.is(x)){const O=[];for(const G of x)if(G)try{G.dispose()}catch(q){O.push(q)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(x)?[]:x}else if(x)return x.dispose(),x}function f(x){for(const O of x)o(O)&&O.dispose();return[]}function S(...x){const O=m(()=>l(x));return e(x,O),O}function m(x){const O=P({dispose:(0,Q.$db)(()=>{c(O),x()})});return O}class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(c(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return h(O,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),h(O,null))}}t.$Uc=b;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,P(this),h(this.q,this)}dispose(){c(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}t.$Vc=r;class E{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&h(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,c(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&h(O,null),O}}t.$Wc=E;class k{constructor(O){this.a=new E,this.b=!1,this.a.value=O}get value(){return this.a.value}set value(O){this.b||O===this.a.value||(this.a.value=O)}dispose(){this.b=!0,this.a.dispose()}}t.$Xc=k;class F{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Yc=F;class M{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(O){let G=O;return this.unset=()=>G=void 0,this.isset=()=>G!==void 0,this.dispose=()=>{G&&(G(),G=void 0,c(this))},this}}t.$Zc=M;class W{constructor(){this.a=new Map}acquire(O,...G){let q=this.a.get(O);q||(q={counter:0,object:this.b(O,...G)},this.a.set(O,q));const{object:ae}=q,ie=(0,Q.$db)(()=>{--q.counter===0&&(this.c(O,q.object),this.a.delete(O))});return q.counter++,{object:ae,dispose:ie}}}t.$1c=W;class p{constructor(O){this.a=O}async acquire(O,...G){const q=this.a.acquire(O,...G);try{return{object:await q.object,dispose:()=>q.dispose()}}catch(ae){throw q.dispose(),ae}}}t.$2c=p;class I{constructor(O){this.object=O}dispose(){}}t.$3c=I;function V(x){const O=new b;try{x(O)}finally{O.dispose()}}class R{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){c(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,G,q=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),q||this.a.get(O)?.dispose(),this.a.set(O,G)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$5c=R}),function(se,t){typeof define=="function"&&define.amd?define(me[88],be([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(se=typeof globalThis<"u"?globalThis:se||self,t(se.marked={}))}(this,function(se){"use strict";function t(z,u){for(var y=0;y<u.length;y++){var a=u[y];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(z,a.key,a)}}function i(z,u,y){return u&&t(z.prototype,u),y&&t(z,y),Object.defineProperty(z,"prototype",{writable:!1}),z}function C(z,u){if(z){if(typeof z=="string")return B(z,u);var y=Object.prototype.toString.call(z).slice(8,-1);if(y==="Object"&&z.constructor&&(y=z.constructor.name),y==="Map"||y==="Set")return Array.from(z);if(y==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(y))return B(z,u)}}function B(z,u){(u==null||u>z.length)&&(u=z.length);for(var y=0,a=new Array(u);y<u;y++)a[y]=z[y];return a}function Q(z,u){var y=typeof Symbol<"u"&&z[Symbol.iterator]||z["@@iterator"];if(y)return(y=y.call(z)).next.bind(y);if(Array.isArray(z)||(y=C(z))||u&&z&&typeof z.length=="number"){y&&(z=y);var a=0;return function(){return a>=z.length?{done:!0}:{done:!1,value:z[a++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=A();function T(z){se.defaults=z}var d=/[&<>"']/,g=/[&<>"']/g,$=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(u){return c[u]};function e(z,u){if(u){if(d.test(z))return z.replace(g,h)}else if($.test(z))return z.replace(P,h);return z}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(z){return z.replace(n,function(u,y){return y=y.toLowerCase(),y==="colon"?":":y.charAt(0)==="#"?y.charAt(1)==="x"?String.fromCharCode(parseInt(y.substring(2),16)):String.fromCharCode(+y.substring(1)):""})}var l=/(^|[^\[])\^/g;function f(z,u){z=typeof z=="string"?z:z.source,u=u||"";var y={replace:function(v,N){return N=N.source||N,N=N.replace(l,"$1"),z=z.replace(v,N),y},getRegex:function(){return new RegExp(z,u)}};return y}var S=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(z,u,y){if(z){var a;try{a=decodeURIComponent(o(y)).replace(S,"").toLowerCase()}catch{return null}if(a.indexOf("javascript:")===0||a.indexOf("vbscript:")===0||a.indexOf("data:")===0)return null}u&&!m.test(y)&&(y=M(u,y));try{y=encodeURI(y).replace(/%25/g,"%")}catch{return null}return y}var r={},E=/^[^:]+:\/*[^/]*$/,k=/^([^:]+:)[\s\S]*$/,F=/^([^:]+:\/*[^/]*)[\s\S]*$/;function M(z,u){r[" "+z]||(E.test(z)?r[" "+z]=z+"/":r[" "+z]=V(z,"/",!0)),z=r[" "+z];var y=z.indexOf(":")===-1;return u.substring(0,2)==="//"?y?u:z.replace(k,"$1")+u:u.charAt(0)==="/"?y?u:z.replace(F,"$1")+u:z+u}var W={exec:function(){}};function p(z){for(var u=1,y,a;u<arguments.length;u++){y=arguments[u];for(a in y)Object.prototype.hasOwnProperty.call(y,a)&&(z[a]=y[a])}return z}function I(z,u){var y=z.replace(/\|/g,function(N,s,D){for(var w=!1,L=s;--L>=0&&D[L]==="\\";)w=!w;return w?"|":" |"}),a=y.split(/ \|/),v=0;if(a[0].trim()||a.shift(),a.length>0&&!a[a.length-1].trim()&&a.pop(),a.length>u)a.splice(u);else for(;a.length<u;)a.push("");for(;v<a.length;v++)a[v]=a[v].trim().replace(/\\\|/g,"|");return a}function V(z,u,y){var a=z.length;if(a===0)return"";for(var v=0;v<a;){var N=z.charAt(a-v-1);if(N===u&&!y)v++;else if(N!==u&&y)v++;else break}return z.slice(0,a-v)}function R(z,u){if(z.indexOf(u[1])===-1)return-1;for(var y=z.length,a=0,v=0;v<y;v++)if(z[v]==="\\")v++;else if(z[v]===u[0])a++;else if(z[v]===u[1]&&(a--,a<0))return v;return-1}function x(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(z,u){if(u<1)return"";for(var y="";u>1;)u&1&&(y+=z),u>>=1,z+=z;return y+z}function G(z,u,y,a){var v=u.href,N=u.title?e(u.title):null,s=z[1].replace(/\\([\[\]])/g,"$1");if(z[0].charAt(0)!=="!"){a.state.inLink=!0;var D={type:"link",raw:y,href:v,title:N,text:s,tokens:a.inlineTokens(s)};return a.state.inLink=!1,D}return{type:"image",raw:y,href:v,title:N,text:e(s)}}function q(z,u){var y=z.match(/^(\s+)(?:```)/);if(y===null)return u;var a=y[1];return u.split(`
`).map(function(v){var N=v.match(/^\s+/);if(N===null)return v;var s=N[0];return s.length>=a.length?v.slice(a.length):v}).join(`
`)}var ae=function(){function z(y){this.options=y||se.defaults}var u=z.prototype;return u.space=function(a){var v=this.rules.block.newline.exec(a);if(v&&v[0].length>0)return{type:"space",raw:v[0]}},u.code=function(a){var v=this.rules.block.code.exec(a);if(v){var N=v[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:v[0],codeBlockStyle:"indented",text:this.options.pedantic?N:V(N,`
`)}}},u.fences=function(a){var v=this.rules.block.fences.exec(a);if(v){var N=v[0],s=q(N,v[3]||"");return{type:"code",raw:N,lang:v[2]?v[2].trim():v[2],text:s}}},u.heading=function(a){var v=this.rules.block.heading.exec(a);if(v){var N=v[2].trim();if(/#$/.test(N)){var s=V(N,"#");(this.options.pedantic||!s||/ $/.test(s))&&(N=s.trim())}return{type:"heading",raw:v[0],depth:v[1].length,text:N,tokens:this.lexer.inline(N)}}},u.hr=function(a){var v=this.rules.block.hr.exec(a);if(v)return{type:"hr",raw:v[0]}},u.blockquote=function(a){var v=this.rules.block.blockquote.exec(a);if(v){var N=v[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:v[0],tokens:this.lexer.blockTokens(N,[]),text:N}}},u.list=function(a){var v=this.rules.block.list.exec(a);if(v){var N,s,D,w,L,j,X,Z,oe,pe,fe,Le,Te=v[1].trim(),Oe=Te.length>1,Se={type:"list",raw:"",ordered:Oe,start:Oe?+Te.slice(0,-1):"",loose:!1,items:[]};Te=Oe?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=Oe?Te:"[*+-]");for(var Ce=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");a&&(Le=!1,!(!(v=Ce.exec(a))||this.rules.block.hr.test(a)));){if(N=v[0],a=a.substring(N.length),Z=v[2].split(`
`,1)[0],oe=a.split(`
`,1)[0],this.options.pedantic?(w=2,fe=Z.trimLeft()):(w=v[2].search(/[^ ]/),w=w>4?1:w,fe=Z.slice(w),w+=v[1].length),j=!1,!Z&&/^ *$/.test(oe)&&(N+=oe+`
`,a=a.substring(oe.length+1),Le=!0),!Le)for(var He=new RegExp("^ {0,"+Math.min(3,w-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ue=new RegExp("^ {0,"+Math.min(3,w-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Xe=new RegExp("^ {0,"+Math.min(3,w-1)+"}(?:```|~~~)"),_e=new RegExp("^ {0,"+Math.min(3,w-1)+"}#");a&&(pe=a.split(`
`,1)[0],Z=pe,this.options.pedantic&&(Z=Z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Xe.test(Z)||_e.test(Z)||He.test(Z)||Ue.test(a)));){if(Z.search(/[^ ]/)>=w||!Z.trim())fe+=`
`+Z.slice(w);else if(!j)fe+=`
`+Z;else break;!j&&!Z.trim()&&(j=!0),N+=pe+`
`,a=a.substring(pe.length+1)}Se.loose||(X?Se.loose=!0:/\n *\n *$/.test(N)&&(X=!0)),this.options.gfm&&(s=/^\[[ xX]\] /.exec(fe),s&&(D=s[0]!=="[ ] ",fe=fe.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:N,task:!!s,checked:D,loose:!1,text:fe}),Se.raw+=N}Se.items[Se.items.length-1].raw=N.trimRight(),Se.items[Se.items.length-1].text=fe.trimRight(),Se.raw=Se.raw.trimRight();var Y=Se.items.length;for(L=0;L<Y;L++){this.lexer.state.top=!1,Se.items[L].tokens=this.lexer.blockTokens(Se.items[L].text,[]);var ne=Se.items[L].tokens.filter(function(ve){return ve.type==="space"}),$e=ne.every(function(ve){for(var Re=ve.raw.split(""),ze=0,We=Q(Re),et;!(et=We()).done;){var it=et.value;if(it===`
`&&(ze+=1),ze>1)return!0}return!1});!Se.loose&&ne.length&&$e&&(Se.loose=!0,Se.items[L].loose=!0)}return Se}},u.html=function(a){var v=this.rules.block.html.exec(a);if(v){var N={type:"html",raw:v[0],pre:!this.options.sanitizer&&(v[1]==="pre"||v[1]==="script"||v[1]==="style"),text:v[0]};if(this.options.sanitize){var s=this.options.sanitizer?this.options.sanitizer(v[0]):e(v[0]);N.type="paragraph",N.text=s,N.tokens=this.lexer.inline(s)}return N}},u.def=function(a){var v=this.rules.block.def.exec(a);if(v){v[3]&&(v[3]=v[3].substring(1,v[3].length-1));var N=v[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:N,raw:v[0],href:v[2],title:v[3]}}},u.table=function(a){var v=this.rules.block.table.exec(a);if(v){var N={type:"table",header:I(v[1]).map(function(X){return{text:X}}),align:v[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:v[3]&&v[3].trim()?v[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(N.header.length===N.align.length){N.raw=v[0];var s=N.align.length,D,w,L,j;for(D=0;D<s;D++)/^ *-+: *$/.test(N.align[D])?N.align[D]="right":/^ *:-+: *$/.test(N.align[D])?N.align[D]="center":/^ *:-+ *$/.test(N.align[D])?N.align[D]="left":N.align[D]=null;for(s=N.rows.length,D=0;D<s;D++)N.rows[D]=I(N.rows[D],N.header.length).map(function(X){return{text:X}});for(s=N.header.length,w=0;w<s;w++)N.header[w].tokens=this.lexer.inline(N.header[w].text);for(s=N.rows.length,w=0;w<s;w++)for(j=N.rows[w],L=0;L<j.length;L++)j[L].tokens=this.lexer.inline(j[L].text);return N}}},u.lheading=function(a){var v=this.rules.block.lheading.exec(a);if(v)return{type:"heading",raw:v[0],depth:v[2].charAt(0)==="="?1:2,text:v[1],tokens:this.lexer.inline(v[1])}},u.paragraph=function(a){var v=this.rules.block.paragraph.exec(a);if(v){var N=v[1].charAt(v[1].length-1)===`
`?v[1].slice(0,-1):v[1];return{type:"paragraph",raw:v[0],text:N,tokens:this.lexer.inline(N)}}},u.text=function(a){var v=this.rules.block.text.exec(a);if(v)return{type:"text",raw:v[0],text:v[0],tokens:this.lexer.inline(v[0])}},u.escape=function(a){var v=this.rules.inline.escape.exec(a);if(v)return{type:"escape",raw:v[0],text:e(v[1])}},u.tag=function(a){var v=this.rules.inline.tag.exec(a);if(v)return!this.lexer.state.inLink&&/^<a /i.test(v[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(v[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(v[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(v[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:v[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(v[0]):e(v[0]):v[0]}},u.link=function(a){var v=this.rules.inline.link.exec(a);if(v){var N=v[2].trim();if(!this.options.pedantic&&/^</.test(N)){if(!/>$/.test(N))return;var s=V(N.slice(0,-1),"\\");if((N.length-s.length)%2===0)return}else{var D=R(v[2],"()");if(D>-1){var w=v[0].indexOf("!")===0?5:4,L=w+v[1].length+D;v[2]=v[2].substring(0,D),v[0]=v[0].substring(0,L).trim(),v[3]=""}}var j=v[2],X="";if(this.options.pedantic){var Z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);Z&&(j=Z[1],X=Z[3])}else X=v[3]?v[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(N)?j=j.slice(1):j=j.slice(1,-1)),G(v,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:X&&X.replace(this.rules.inline._escapes,"$1")},v[0],this.lexer)}},u.reflink=function(a,v){var N;if((N=this.rules.inline.reflink.exec(a))||(N=this.rules.inline.nolink.exec(a))){var s=(N[2]||N[1]).replace(/\s+/g," ");if(s=v[s.toLowerCase()],!s||!s.href){var D=N[0].charAt(0);return{type:"text",raw:D,text:D}}return G(N,s,N[0],this.lexer)}},u.emStrong=function(a,v,N){N===void 0&&(N="");var s=this.rules.inline.emStrong.lDelim.exec(a);if(s&&!(s[3]&&N.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var D=s[1]||s[2]||"";if(!D||D&&(N===""||this.rules.inline.punctuation.exec(N))){var w=s[0].length-1,L,j,X=w,Z=0,oe=s[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,v=v.slice(-1*a.length+w);(s=oe.exec(v))!=null;)if(L=s[1]||s[2]||s[3]||s[4]||s[5]||s[6],!!L){if(j=L.length,s[3]||s[4]){X+=j;continue}else if((s[5]||s[6])&&w%3&&!((w+j)%3)){Z+=j;continue}if(X-=j,!(X>0)){if(j=Math.min(j,j+X+Z),Math.min(w,j)%2){var pe=a.slice(1,w+s.index+j);return{type:"em",raw:a.slice(0,w+s.index+j+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}var fe=a.slice(2,w+s.index+j-1);return{type:"strong",raw:a.slice(0,w+s.index+j+1),text:fe,tokens:this.lexer.inlineTokens(fe)}}}}}},u.codespan=function(a){var v=this.rules.inline.code.exec(a);if(v){var N=v[2].replace(/\n/g," "),s=/[^ ]/.test(N),D=/^ /.test(N)&&/ $/.test(N);return s&&D&&(N=N.substring(1,N.length-1)),N=e(N,!0),{type:"codespan",raw:v[0],text:N}}},u.br=function(a){var v=this.rules.inline.br.exec(a);if(v)return{type:"br",raw:v[0]}},u.del=function(a){var v=this.rules.inline.del.exec(a);if(v)return{type:"del",raw:v[0],text:v[2],tokens:this.lexer.inlineTokens(v[2])}},u.autolink=function(a,v){var N=this.rules.inline.autolink.exec(a);if(N){var s,D;return N[2]==="@"?(s=e(this.options.mangle?v(N[1]):N[1]),D="mailto:"+s):(s=e(N[1]),D=s),{type:"link",raw:N[0],text:s,href:D,tokens:[{type:"text",raw:s,text:s}]}}},u.url=function(a,v){var N;if(N=this.rules.inline.url.exec(a)){var s,D;if(N[2]==="@")s=e(this.options.mangle?v(N[0]):N[0]),D="mailto:"+s;else{var w;do w=N[0],N[0]=this.rules.inline._backpedal.exec(N[0])[0];while(w!==N[0]);s=e(N[0]),N[1]==="www."?D="http://"+s:D=s}return{type:"link",raw:N[0],text:s,href:D,tokens:[{type:"text",raw:s,text:s}]}}},u.inlineText=function(a,v){var N=this.rules.inline.text.exec(a);if(N){var s;return this.lexer.state.inRawBlock?s=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(N[0]):e(N[0]):N[0]:s=e(this.options.smartypants?v(N[0]):N[0]),{type:"text",raw:N[0],text:s}}},z}(),ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:W,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=f(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=f(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=f(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=f(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=f(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=f(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=p({},ie),ie.gfm=p({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=f(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.paragraph=f(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ie.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=p({},ie.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:W,paragraph:f(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:W,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:W,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=f(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=f(ie._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=f(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=f(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=f(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=f(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=f(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=f(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=f(ee.reflink).replace("label",ee._label).replace("ref",ie._label).getRegex(),ee.nolink=f(ee.nolink).replace("ref",ie._label).getRegex(),ee.reflinkSearch=f(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=p({},ee),ee.pedantic=p({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=p({},ee.normal,{escape:f(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=f(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=p({},ee.gfm,{br:f(ee.br).replace("{2,}","*").getRegex(),text:f(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ce(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function De(z){var u="",y,a,v=z.length;for(y=0;y<v;y++)a=z.charCodeAt(y),Math.random()>.5&&(a="x"+a.toString(16)),u+="&#"+a+";";return u}var Ee=function(){function z(y){this.tokens=[],this.tokens.links=Object.create(null),this.options=y||se.defaults,this.options.tokenizer=this.options.tokenizer||new ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var a={block:ie.normal,inline:ee.normal};this.options.pedantic?(a.block=ie.pedantic,a.inline=ee.pedantic):this.options.gfm&&(a.block=ie.gfm,this.options.breaks?a.inline=ee.breaks:a.inline=ee.gfm),this.tokenizer.rules=a}z.lex=function(a,v){var N=new z(v);return N.lex(a)},z.lexInline=function(a,v){var N=new z(v);return N.inlineTokens(a)};var u=z.prototype;return u.lex=function(a){a=a.replace(/\r\n|\r/g,`
`),this.blockTokens(a,this.tokens);for(var v;v=this.inlineQueue.shift();)this.inlineTokens(v.src,v.tokens);return this.tokens},u.blockTokens=function(a,v){var N=this;v===void 0&&(v=[]),this.options.pedantic?a=a.replace(/\t/g,"    ").replace(/^ +$/gm,""):a=a.replace(/^( *)(\t+)/gm,function(X,Z,oe){return Z+"    ".repeat(oe.length)});for(var s,D,w,L;a;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(X){return(s=X.call({lexer:N},a,v))?(a=a.substring(s.raw.length),v.push(s),!0):!1}))){if(s=this.tokenizer.space(a)){a=a.substring(s.raw.length),s.raw.length===1&&v.length>0?v[v.length-1].raw+=`
`:v.push(s);continue}if(s=this.tokenizer.code(a)){a=a.substring(s.raw.length),D=v[v.length-1],D&&(D.type==="paragraph"||D.type==="text")?(D.raw+=`
`+s.raw,D.text+=`
`+s.text,this.inlineQueue[this.inlineQueue.length-1].src=D.text):v.push(s);continue}if(s=this.tokenizer.fences(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.heading(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.hr(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.blockquote(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.list(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.html(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.def(a)){a=a.substring(s.raw.length),D=v[v.length-1],D&&(D.type==="paragraph"||D.type==="text")?(D.raw+=`
`+s.raw,D.text+=`
`+s.raw,this.inlineQueue[this.inlineQueue.length-1].src=D.text):this.tokens.links[s.tag]||(this.tokens.links[s.tag]={href:s.href,title:s.title});continue}if(s=this.tokenizer.table(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.lheading(a)){a=a.substring(s.raw.length),v.push(s);continue}if(w=a,this.options.extensions&&this.options.extensions.startBlock&&function(){var X=1/0,Z=a.slice(1),oe=void 0;N.options.extensions.startBlock.forEach(function(pe){oe=pe.call({lexer:this},Z),typeof oe=="number"&&oe>=0&&(X=Math.min(X,oe))}),X<1/0&&X>=0&&(w=a.substring(0,X+1))}(),this.state.top&&(s=this.tokenizer.paragraph(w))){D=v[v.length-1],L&&D.type==="paragraph"?(D.raw+=`
`+s.raw,D.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=D.text):v.push(s),L=w.length!==a.length,a=a.substring(s.raw.length);continue}if(s=this.tokenizer.text(a)){a=a.substring(s.raw.length),D=v[v.length-1],D&&D.type==="text"?(D.raw+=`
`+s.raw,D.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=D.text):v.push(s);continue}if(a){var j="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,v},u.inline=function(a,v){return v===void 0&&(v=[]),this.inlineQueue.push({src:a,tokens:v}),v},u.inlineTokens=function(a,v){var N=this;v===void 0&&(v=[]);var s,D,w,L=a,j,X,Z;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(L))!=null;)oe.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(L=L.slice(0,j.index)+"["+O("a",j[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(L))!=null;)L=L.slice(0,j.index)+"["+O("a",j[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(L))!=null;)L=L.slice(0,j.index)+"++"+L.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;a;)if(X||(Z=""),X=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(fe){return(s=fe.call({lexer:N},a,v))?(a=a.substring(s.raw.length),v.push(s),!0):!1}))){if(s=this.tokenizer.escape(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.tag(a)){a=a.substring(s.raw.length),D=v[v.length-1],D&&s.type==="text"&&D.type==="text"?(D.raw+=s.raw,D.text+=s.text):v.push(s);continue}if(s=this.tokenizer.link(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.reflink(a,this.tokens.links)){a=a.substring(s.raw.length),D=v[v.length-1],D&&s.type==="text"&&D.type==="text"?(D.raw+=s.raw,D.text+=s.text):v.push(s);continue}if(s=this.tokenizer.emStrong(a,L,Z)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.codespan(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.br(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.del(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.autolink(a,De)){a=a.substring(s.raw.length),v.push(s);continue}if(!this.state.inLink&&(s=this.tokenizer.url(a,De))){a=a.substring(s.raw.length),v.push(s);continue}if(w=a,this.options.extensions&&this.options.extensions.startInline&&function(){var fe=1/0,Le=a.slice(1),Te=void 0;N.options.extensions.startInline.forEach(function(Oe){Te=Oe.call({lexer:this},Le),typeof Te=="number"&&Te>=0&&(fe=Math.min(fe,Te))}),fe<1/0&&fe>=0&&(w=a.substring(0,fe+1))}(),s=this.tokenizer.inlineText(w,ce)){a=a.substring(s.raw.length),s.raw.slice(-1)!=="_"&&(Z=s.raw.slice(-1)),X=!0,D=v[v.length-1],D&&D.type==="text"?(D.raw+=s.raw,D.text+=s.text):v.push(s);continue}if(a){var pe="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return v},i(z,null,[{key:"rules",get:function(){return{block:ie,inline:ee}}}]),z}(),Me=function(){function z(y){this.options=y||se.defaults}var u=z.prototype;return u.code=function(a,v,N){var s=(v||"").match(/\S*/)[0];if(this.options.highlight){var D=this.options.highlight(a,s);D!=null&&D!==a&&(N=!0,a=D)}return a=a.replace(/\n$/,"")+`
`,s?'<pre><code class="'+this.options.langPrefix+e(s,!0)+'">'+(N?a:e(a,!0))+`</code></pre>
`:"<pre><code>"+(N?a:e(a,!0))+`</code></pre>
`},u.blockquote=function(a){return`<blockquote>
`+a+`</blockquote>
`},u.html=function(a){return a},u.heading=function(a,v,N,s){if(this.options.headerIds){var D=this.options.headerPrefix+s.slug(N);return"<h"+v+' id="'+D+'">'+a+"</h"+v+`>
`}return"<h"+v+">"+a+"</h"+v+`>
`},u.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},u.list=function(a,v,N){var s=v?"ol":"ul",D=v&&N!==1?' start="'+N+'"':"";return"<"+s+D+`>
`+a+"</"+s+`>
`},u.listitem=function(a){return"<li>"+a+`</li>
`},u.checkbox=function(a){return"<input "+(a?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},u.paragraph=function(a){return"<p>"+a+`</p>
`},u.table=function(a,v){return v&&(v="<tbody>"+v+"</tbody>"),`<table>
<thead>
`+a+`</thead>
`+v+`</table>
`},u.tablerow=function(a){return`<tr>
`+a+`</tr>
`},u.tablecell=function(a,v){var N=v.header?"th":"td",s=v.align?"<"+N+' align="'+v.align+'">':"<"+N+">";return s+a+("</"+N+`>
`)},u.strong=function(a){return"<strong>"+a+"</strong>"},u.em=function(a){return"<em>"+a+"</em>"},u.codespan=function(a){return"<code>"+a+"</code>"},u.br=function(){return this.options.xhtml?"<br/>":"<br>"},u.del=function(a){return"<del>"+a+"</del>"},u.link=function(a,v,N){if(a=b(this.options.sanitize,this.options.baseUrl,a),a===null)return N;var s='<a href="'+e(a)+'"';return v&&(s+=' title="'+v+'"'),s+=">"+N+"</a>",s},u.image=function(a,v,N){if(a=b(this.options.sanitize,this.options.baseUrl,a),a===null)return N;var s='<img src="'+a+'" alt="'+N+'"';return v&&(s+=' title="'+v+'"'),s+=this.options.xhtml?"/>":">",s},u.text=function(a){return a},z}(),le=function(){function z(){}var u=z.prototype;return u.strong=function(a){return a},u.em=function(a){return a},u.codespan=function(a){return a},u.del=function(a){return a},u.html=function(a){return a},u.text=function(a){return a},u.link=function(a,v,N){return""+N},u.image=function(a,v,N){return""+N},u.br=function(){return""},z}(),_=function(){function z(){this.seen={}}var u=z.prototype;return u.serialize=function(a){return a.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},u.getNextSafeSlug=function(a,v){var N=a,s=0;if(this.seen.hasOwnProperty(N)){s=this.seen[a];do s++,N=a+"-"+s;while(this.seen.hasOwnProperty(N))}return v||(this.seen[a]=s,this.seen[N]=0),N},u.slug=function(a,v){v===void 0&&(v={});var N=this.serialize(a);return this.getNextSafeSlug(N,v.dryrun)},z}(),ue=function(){function z(y){this.options=y||se.defaults,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new _}z.parse=function(a,v){var N=new z(v);return N.parse(a)},z.parseInline=function(a,v){var N=new z(v);return N.parseInline(a)};var u=z.prototype;return u.parse=function(a,v){v===void 0&&(v=!0);var N="",s,D,w,L,j,X,Z,oe,pe,fe,Le,Te,Oe,Se,Ce,He,Ue,Xe,_e,Y=a.length;for(s=0;s<Y;s++){if(fe=a[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(_e=this.options.extensions.renderers[fe.type].call({parser:this},fe),_e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(fe.type))){N+=_e||"";continue}switch(fe.type){case"space":continue;case"hr":{N+=this.renderer.hr();continue}case"heading":{N+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,o(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{N+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(oe="",Z="",L=fe.header.length,D=0;D<L;D++)Z+=this.renderer.tablecell(this.parseInline(fe.header[D].tokens),{header:!0,align:fe.align[D]});for(oe+=this.renderer.tablerow(Z),pe="",L=fe.rows.length,D=0;D<L;D++){for(X=fe.rows[D],Z="",j=X.length,w=0;w<j;w++)Z+=this.renderer.tablecell(this.parseInline(X[w].tokens),{header:!1,align:fe.align[w]});pe+=this.renderer.tablerow(Z)}N+=this.renderer.table(oe,pe);continue}case"blockquote":{pe=this.parse(fe.tokens),N+=this.renderer.blockquote(pe);continue}case"list":{for(Le=fe.ordered,Te=fe.start,Oe=fe.loose,L=fe.items.length,pe="",D=0;D<L;D++)Ce=fe.items[D],He=Ce.checked,Ue=Ce.task,Se="",Ce.task&&(Xe=this.renderer.checkbox(He),Oe?Ce.tokens.length>0&&Ce.tokens[0].type==="paragraph"?(Ce.tokens[0].text=Xe+" "+Ce.tokens[0].text,Ce.tokens[0].tokens&&Ce.tokens[0].tokens.length>0&&Ce.tokens[0].tokens[0].type==="text"&&(Ce.tokens[0].tokens[0].text=Xe+" "+Ce.tokens[0].tokens[0].text)):Ce.tokens.unshift({type:"text",text:Xe}):Se+=Xe),Se+=this.parse(Ce.tokens,Oe),pe+=this.renderer.listitem(Se,Ue,He);N+=this.renderer.list(pe,Le,Te);continue}case"html":{N+=this.renderer.html(fe.text);continue}case"paragraph":{N+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(pe=fe.tokens?this.parseInline(fe.tokens):fe.text;s+1<Y&&a[s+1].type==="text";)fe=a[++s],pe+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);N+=v?this.renderer.paragraph(pe):pe;continue}default:{var ne='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return N},u.parseInline=function(a,v){v=v||this.renderer;var N="",s,D,w,L=a.length;for(s=0;s<L;s++){if(D=a[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[D.type]&&(w=this.options.extensions.renderers[D.type].call({parser:this},D),w!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(D.type))){N+=w||"";continue}switch(D.type){case"escape":{N+=v.text(D.text);break}case"html":{N+=v.html(D.text);break}case"link":{N+=v.link(D.href,D.title,this.parseInline(D.tokens,v));break}case"image":{N+=v.image(D.href,D.title,D.text);break}case"strong":{N+=v.strong(this.parseInline(D.tokens,v));break}case"em":{N+=v.em(this.parseInline(D.tokens,v));break}case"codespan":{N+=v.codespan(D.text);break}case"br":{N+=v.br();break}case"del":{N+=v.del(this.parseInline(D.tokens,v));break}case"text":{N+=v.text(D.text);break}default:{var j='Token with "'+D.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return N},z}();function re(z,u,y){if(typeof z>"u"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof u=="function"&&(y=u,u=null),u=p({},re.defaults,u||{}),x(u),y){var a=u.highlight,v;try{v=Ee.lex(z,u)}catch(L){return y(L)}var N=function(j){var X;if(!j)try{u.walkTokens&&re.walkTokens(v,u.walkTokens),X=ue.parse(v,u)}catch(Z){j=Z}return u.highlight=a,j?y(j):y(null,X)};if(!a||a.length<3||(delete u.highlight,!v.length))return N();var s=0;re.walkTokens(v,function(L){L.type==="code"&&(s++,setTimeout(function(){a(L.text,L.lang,function(j,X){if(j)return N(j);X!=null&&X!==L.text&&(L.text=X,L.escaped=!0),s--,s===0&&N()})},0))}),s===0&&N();return}function D(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(L.message+"",!0)+"</pre>";throw L}try{var w=Ee.lex(z,u);if(u.walkTokens){if(u.async)return Promise.all(re.walkTokens(w,u.walkTokens)).then(function(){return ue.parse(w,u)}).catch(D);re.walkTokens(w,u.walkTokens)}return ue.parse(w,u)}catch(L){D(L)}}re.options=re.setOptions=function(z){return p(re.defaults,z),T(re.defaults),re},re.getDefaults=A,re.defaults=se.defaults,re.use=function(){for(var z=arguments.length,u=new Array(z),y=0;y<z;y++)u[y]=arguments[y];var a=p.apply(void 0,[{}].concat(u)),v=re.defaults.extensions||{renderers:{},childTokens:{}},N;u.forEach(function(s){if(s.extensions&&(N=!0,s.extensions.forEach(function(w){if(!w.name)throw new Error("extension name required");if(w.renderer){var L=v.renderers?v.renderers[w.name]:null;L?v.renderers[w.name]=function(){for(var j=arguments.length,X=new Array(j),Z=0;Z<j;Z++)X[Z]=arguments[Z];var oe=w.renderer.apply(this,X);return oe===!1&&(oe=L.apply(this,X)),oe}:v.renderers[w.name]=w.renderer}if(w.tokenizer){if(!w.level||w.level!=="block"&&w.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");v[w.level]?v[w.level].unshift(w.tokenizer):v[w.level]=[w.tokenizer],w.start&&(w.level==="block"?v.startBlock?v.startBlock.push(w.start):v.startBlock=[w.start]:w.level==="inline"&&(v.startInline?v.startInline.push(w.start):v.startInline=[w.start]))}w.childTokens&&(v.childTokens[w.name]=w.childTokens)})),s.renderer&&function(){var w=re.defaults.renderer||new Me,L=function(Z){var oe=w[Z];w[Z]=function(){for(var pe=arguments.length,fe=new Array(pe),Le=0;Le<pe;Le++)fe[Le]=arguments[Le];var Te=s.renderer[Z].apply(w,fe);return Te===!1&&(Te=oe.apply(w,fe)),Te}};for(var j in s.renderer)L(j);a.renderer=w}(),s.tokenizer&&function(){var w=re.defaults.tokenizer||new ae,L=function(Z){var oe=w[Z];w[Z]=function(){for(var pe=arguments.length,fe=new Array(pe),Le=0;Le<pe;Le++)fe[Le]=arguments[Le];var Te=s.tokenizer[Z].apply(w,fe);return Te===!1&&(Te=oe.apply(w,fe)),Te}};for(var j in s.tokenizer)L(j);a.tokenizer=w}(),s.walkTokens){var D=re.defaults.walkTokens;a.walkTokens=function(w){var L=[];return L.push(s.walkTokens.call(this,w)),D&&(L=L.concat(D.call(this,w))),L}}N&&(a.extensions=v),re.setOptions(a)})},re.walkTokens=function(z,u){for(var y=[],a=function(){var D=N.value;switch(y=y.concat(u.call(re,D)),D.type){case"table":{for(var w=Q(D.header),L;!(L=w()).done;){var j=L.value;y=y.concat(re.walkTokens(j.tokens,u))}for(var X=Q(D.rows),Z;!(Z=X()).done;)for(var oe=Z.value,pe=Q(oe),fe;!(fe=pe()).done;){var Le=fe.value;y=y.concat(re.walkTokens(Le.tokens,u))}break}case"list":{y=y.concat(re.walkTokens(D.items,u));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[D.type]?re.defaults.extensions.childTokens[D.type].forEach(function(Te){y=y.concat(re.walkTokens(D[Te],u))}):D.tokens&&(y=y.concat(re.walkTokens(D.tokens,u)))}},v=Q(z),N;!(N=v()).done;)a();return y},re.parseInline=function(z,u){if(typeof z>"u"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");u=p({},re.defaults,u||{}),x(u);try{var y=Ee.lexInline(z,u);return u.walkTokens&&re.walkTokens(y,u.walkTokens),ue.parseInline(y,u)}catch(a){if(a.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(a.message+"",!0)+"</pre>";throw a}},re.Parser=ue,re.parser=ue.parse,re.Renderer=Me,re.TextRenderer=le,re.Lexer=Ee,re.lexer=Ee.lex,re.Tokenizer=ae,re.Slugger=_,re.parse=re;var ye=re.options,H=re.setOptions,J=re.use,ge=re.walkTokens,we=re.parseInline,ke=re,Fe=ue.parse,Ie=Ee.lex;se.Lexer=Ee,se.Parser=ue,se.Renderer=Me,se.Slugger=_,se.TextRenderer=le,se.Tokenizer=ae,se.getDefaults=A,se.lexer=Ie,se.marked=re,se.options=ye,se.parse=ke,se.parseInline=we,se.parser=Fe,se.setOptions=H,se.use=J,se.walkTokens=ge,Object.defineProperty(se,"__esModule",{value:!0})}),define(me[89],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vk=i;function i(n){const o=Q(n);if(o&&o.length>0)return new Uint32Array(o)}let C=0;const B=new Uint32Array(10);function Q(n){if(C=0,A(n,P,4352),C>0||(A(n,c,4449),C>0)||(A(n,h,4520),C>0)||(A(n,e,12593),C))return B.subarray(0,C);if(n>=44032&&n<=55203){const o=n-44032,l=o%588,f=Math.floor(o/588),S=Math.floor(l/28),m=l%28-1;if(f<P.length?A(f,P,0):4352+f-12593<e.length&&A(4352+f,e,12593),S<c.length?A(S,c,0):4449+S-12593<e.length&&A(4449+S-12593,e,12593),m>=0&&(m<h.length?A(m,h,0):4520+m-12593<e.length&&A(4520+m-12593,e,12593)),C>0)return B.subarray(0,C)}}function A(n,o,l){n>=l&&n<l+o.length&&T(o[n-l])}function T(n){n!==0&&(B[C++]=n&255,n>>8&&(B[C++]=n>>8&255),n>>16&&(B[C++]=n>>16&255))}var d;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(d||(d={}));var g;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(g||(g={}));var $;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})($||($={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),c=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),h=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(me[90],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nV=void 0;class i{constructor(B,Q=0,A=B.length,T=Q-1){this.a=B,this.b=Q,this.c=A,this.d=T}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$nV=i}),define(me[91],be([1,0,90]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pV=t.$oV=void 0;class C{constructor(A=[],T=10){this.h(A),this.b=T,this.d()}getHistory(){return this.j}add(A){this.a.delete(A),this.a.add(A),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(A){return this.a.has(A)}clear(){this.h([]),this.d()}d(){this.f();const A=this.j;this.c=new i.$nV(A,0,A.length,A.length)}f(){const A=this.j;A.length>this.b&&this.h(A.slice(A.length-this.b))}g(){const A=this.c.current();return A?this.j.indexOf(A):-1}h(A){this.a=new Set;for(const T of A)this.a.add(T)}get j(){const A=[];return this.a.forEach(T=>A.push(T)),A}}t.$oV=C;class B{get size(){return this.f}constructor(A,T=10){if(this.g=T,A.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:A[0],previous:void 0,next:void 0},this.a=new Set([A[0]]);for(let d=1;d<A.length;d++)this.add(A[d])}add(A){const T={value:A,previous:this.c,next:void 0};for(this.c.next=T,this.c=T,this.d=this.c,this.f++,this.a.has(A)?this.h(A):this.a.add(A);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(A){if(this.c.value===A)return A;const T=this.c.value;return this.a.delete(T),this.c.value=A,this.a.has(A)?this.h(A):this.a.add(A),T}prepend(A){if(this.f===this.g||this.a.has(A))return;const T={value:A,previous:void 0,next:this.b};this.b.previous=T,this.b=T,this.f++,this.a.add(A)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(A){return this.a.has(A)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let A=this.b;for(;A;)yield A.value,A=A.next}h(A){let T=this.b;for(;T!==this.c;)T.value===A&&(T===this.b?(this.b=this.b.next,this.b.previous=void 0):(T.previous.next=T.next,T.next.previous=T.previous),this.f--),T=T.next}}t.$pV=B}),define(me[40],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fm=t.$Em=t.$Dm=void 0,t.$Bm=i,t.rot=C;function i(T,d,g){return Math.min(Math.max(T,d),g)}function C(T,d){return(d+T%d)%d}class B{constructor(){this.a=0}getNext(){return this.a++}}t.$Dm=B;class Q{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Em=Q;class A{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const g=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Fm=A}),define(me[26],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bd=void 0,t.$cd=Q,t.$dd=c;class i{constructor(e,n,o){this.owner=e,this.debugNameSource=n,this.referenceFn=o}getDebugName(e){return Q(e,this)}}t.$bd=i;const C=new Map,B=new WeakMap;function Q(h,e){const n=B.get(h);if(n)return n;const o=A(h,e);if(o){let l=C.get(o)??0;l++,C.set(o,l);const f=l===1?o:`${o}#${l}`;return B.set(h,f),f}}function A(h,e){const n=B.get(h);if(n)return n;const o=e.owner?$(e.owner)+".":"";let l;const f=e.debugNameSource;if(f!==void 0)if(typeof f=="function"){if(l=f(),l!==void 0)return o+l}else return o+f;const S=e.referenceFn;if(S!==void 0&&(l=c(S),l!==void 0))return o+l;if(e.owner!==void 0){const m=T(e.owner,h);if(m!==void 0)return o+m}}function T(h,e){for(const n in h)if(h[n]===e)return n}const d=new Map,g=new WeakMap;function $(h){const e=g.get(h);if(e)return e;const n=P(h);let o=d.get(n)??0;o++,d.set(n,o);const l=o===1?n:`${n}#${o}`;return g.set(h,l),l}function P(h){const e=h.constructor;return e?e.name:"Object"}function c(h){const e=h.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(o?o[1]:void 0)?.trim()}}),define(me[27],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0,t.$Id=C,t.$Jd=B;let i;function C(n){i=n}function B(){return i}class Q{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([T(h("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[T(" "),g($(o.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),g($(o.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),g($(o.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(o,l){console.log(...this.b([d("observable value changed"),g(o.debugName,{color:"BlueViolet"}),...this.c(l)]))}formatChanges(o){if(o.size!==0)return g(" (changed deps: "+[...o].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const l=o.handleChange;this.d.set(o,new Set),o.handleChange=(f,S)=>(this.d.get(o).add(f),l.apply(o,[f,S]))}handleDerivedRecomputed(o,l){const f=this.d.get(o);console.log(...this.b([d("derived recomputed"),g(o.debugName,{color:"BlueViolet"}),...this.c(l),this.formatChanges(f),{data:[{fn:o._computeFn}]}])),f.clear()}handleFromEventObservableTriggered(o,l){console.log(...this.b([d("observable from event triggered"),g(o.debugName,{color:"BlueViolet"}),...this.c(l),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const l=o.handleChange;this.d.set(o,new Set),o.handleChange=(f,S)=>(this.d.get(o).add(f),l.apply(o,[f,S]))}handleAutorunTriggered(o){const l=this.d.get(o);console.log(...this.b([d("autorun"),g(o.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:o._runFn}]}])),l.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let l=o.getDebugName();l===void 0&&(l=""),console.log(...this.b([d("transaction"),g(l,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Kd=Q;function A(n){const o=new Array,l=[];let f="";function S(b){if("length"in b)for(const r of b)r&&S(r);else"text"in b?(f+=`%c${b.text}`,o.push(b.style),b.data&&l.push(...b.data)):"data"in b&&l.push(...b.data)}S(n);const m=[f,...o];return m.push(...l),m}function T(n){return g(n,{color:"black"})}function d(n){return g(e(`${n}: `,10),{color:"black",bold:!0})}function g(n,o={color:"black"}){function l(S){return Object.entries(S).reduce((m,[b,r])=>`${m}${b}:${r};`,"")}const f={color:o.color};return o.strikeThrough&&(f["text-decoration"]="line-through"),o.bold&&(f["font-weight"]="bold"),{text:n,style:l(f)}}function $(n,o){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=o?`"${n}"`:`"${n.substr(0,o-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?P(n,o):c(n,o);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function P(n,o){let l="[ ",f=!0;for(const S of n){if(f||(l+=", "),l.length-5>o){l+="...";break}f=!1,l+=`${$(S,o-l.length)}`}return l+=" ]",l}function c(n,o){let l="{ ",f=!0;for(const[S,m]of Object.entries(n)){if(f||(l+=", "),l.length-5>o){l+="...";break}f=!1,l+=`${S}: ${$(m,o-l.length)}`}return l+=" }",l}function h(n,o){let l="";for(let f=1;f<=o;f++)l+=n;return l}function e(n,o){for(;n.length<o;)n+=" ";return n}}),define(me[41],be([1,0,37,2,26,27]),function(se,t,i,C,B,Q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qd=void 0,t.$kd=A,t.$ld=T,t.$md=d,t.$nd=g,t.$od=$,t.$pd=P;function A(e){return new h(new B.$bd(void 0,void 0,e),e,void 0,void 0)}function T(e,n){return new h(new B.$bd(e.owner,e.debugName,e.debugReferenceFn??n),n,void 0,void 0)}function d(e,n){return new h(new B.$bd(e.owner,e.debugName,e.debugReferenceFn??n),n,e.createEmptyChangeSummary,e.handleChange)}function g(e,n){const o=new C.$Uc,l=d({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(f,S)=>{o.clear(),n(f,S,o)});return(0,C.$Tc)(()=>{l.dispose(),o.dispose()})}function $(e){const n=new C.$Uc,o=T({owner:void 0,debugName:void 0,debugReferenceFn:e},l=>{n.clear(),e(l,n)});return(0,C.$Tc)(()=>{o.dispose(),n.dispose()})}function P(e,n){let o;return T({debugReferenceFn:n},l=>{const f=e.read(l),S=o;o=f,n({lastValue:S,newValue:f})})}var c;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(c||(c={}));class h{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(n,o,l,f){this.h=n,this._runFn=o,this.i=l,this.j=f,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,Q.$Jd)()?.handleAutorunCreated(this),this.k(),(0,C.$Mc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,C.$Nc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const o=this.c;try{if(!o){(0,Q.$Jd)()?.handleAutorunTriggered(this);const l=this.g;this.g=this.i?.(),this._runFn(this,l)}}finally{o||(0,Q.$Jd)()?.handleAutorunFinished(this);for(const l of this.f)l.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,i.$id)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,o){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:o,didChange:f=>f===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const o=n.get();return this.e.add(n),this.f.delete(n),o}}t.$qd=h,function(e){e.Observer=h}(A||(t.$kd=A={}))}),define(me[33],be([1,0,38,26,27]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6d=t.$4d=t.$1d=t.$Vd=t.$Ud=void 0,t.$Rd=A,t.$Sd=d,t.$Td=$,t.$Wd=h,t.$Xd=n,t.$Yd=o,t.$Zd=l,t.$2d=S,t.$3d=m,t.$5d=r;let Q;function A(k){Q=k}let T;function d(k){T=k}let g;function $(k){g=k}class P{get TChange(){return null}reportChanges(){this.get()}read(F){return F?F.readObservable(this):this.get()}map(F,M){const W=M===void 0?void 0:F,p=M===void 0?F:M;return g({owner:W,debugName:()=>{const I=(0,C.$dd)(p);if(I!==void 0)return I;const R=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(p.toString());if(R)return`${this.debugName}.${R[2]}`;if(!W)return`${this.debugName} (mapped)`},debugReferenceFn:p},I=>p(this.read(I),I))}recomputeInitiallyAndOnChange(F,M){return F.add(Q(this,M)),this}keepObserved(F){return F.add(T(this)),this}get a(){return this.get()}}t.$Ud=P;class c extends P{constructor(){super(...arguments),this.b=new Set}addObserver(F){const M=this.b.size;this.b.add(F),M===0&&this.c()}removeObserver(F){this.b.delete(F)&&this.b.size===0&&this.f()}c(){}f(){}}t.$Vd=c;function h(k,F){const M=new f(k,F);try{k(M)}finally{M.finish()}}let e;function n(k){if(e)k(e);else{const F=new f(k,void 0);e=F;try{k(F)}finally{F.finish(),e=void 0}}}async function o(k,F){const M=new f(k,F);try{await k(M)}finally{M.finish()}}function l(k,F,M){k?F(k):h(F,M)}class f{constructor(F,M){this._fn=F,this.b=M,this.a=[],(0,B.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,C.$dd)(this._fn)}updateObserver(F,M){this.a.push({observer:F,observable:M}),F.beginUpdate(M)}finish(){const F=this.a;for(let M=0;M<F.length;M++){const{observer:W,observable:p}=F[M];W.endUpdate(p)}this.a=null,(0,B.$Jd)()?.handleEndTransaction()}}t.$1d=f;function S(k,F){let M;return typeof k=="string"?M=new C.$bd(void 0,k,void 0):M=new C.$bd(k,void 0,void 0),new b(M,F,i.$7c)}function m(k,F){return new b(new C.$bd(k.owner,k.debugName,void 0),F,k.equalsFn??i.$7c)}class b extends c{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(F,M,W){super(),this.e=F,this.g=W,this.d=M}get(){return this.d}set(F,M,W){if(this.g(this.d,F))return;let p;M||(M=p=new f(()=>{},()=>`Setting ${this.debugName}`));try{const I=this.d;this.h(F),(0,B.$Jd)()?.handleObservableChanged(this,{oldValue:I,newValue:F,change:W,didChange:!0,hadValue:!0});for(const V of this.b)M.updateObserver(V,this),V.handleChange(this,W)}finally{p&&p.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(F){this.d=F}}t.$4d=b;function r(k,F){let M;return typeof k=="string"?M=new C.$bd(void 0,k,void 0):M=new C.$bd(k,void 0,void 0),new E(M,F,i.$7c)}class E extends b{h(F){this.d!==F&&(this.d&&this.d.dispose(),this.d=F)}dispose(){this.d?.dispose()}}t.$6d=E}),define(me[42],be([1,0,37,38,2,33,26,27]),function(se,t,i,C,B,Q,A,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qd=void 0,t.$Ld=d,t.$Md=g,t.$Nd=$,t.$Od=P,t.$Pd=c;function d(n,o){return o!==void 0?new e(new A.$bd(n,void 0,o),o,void 0,void 0,void 0,C.$7c):new e(new A.$bd(void 0,void 0,n),n,void 0,void 0,void 0,C.$7c)}function g(n,o){return new e(new A.$bd(n.owner,n.debugName,n.debugReferenceFn),o,void 0,void 0,n.onLastObserverRemoved,n.equalsFn??C.$7c)}(0,Q.$Td)(g);function $(n,o){return new e(new A.$bd(n.owner,n.debugName,void 0),o,n.createEmptyChangeSummary,n.handleChange,void 0,n.equalityComparer??C.$7c)}function P(n,o){let l,f;o===void 0?(l=n,f=void 0):(f=n,l=o);const S=new B.$Uc;return new e(new A.$bd(f,void 0,l),m=>(S.clear(),l(m,S)),void 0,void 0,()=>S.dispose(),C.$7c)}function c(n,o){let l,f;o===void 0?(l=n,f=void 0):(f=n,l=o);const S=new B.$Uc;return new e(new A.$bd(f,void 0,l),m=>{S.clear();const b=l(m);return b&&S.add(b),b},void 0,void 0,()=>S.dispose(),C.$7c)}var h;(function(n){n[n.initial=0]="initial",n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(h||(h={}));class e extends Q.$Vd{get debugName(){return this.m.getDebugName(this)??"(anonymous)"}constructor(o,l,f,S,m=void 0,b){super(),this.m=o,this._computeFn=l,this.n=f,this.p=S,this.q=m,this.s=b,this.e=0,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,T.$Jd)()?.handleDerivedCreated(this)}f(){this.e=0,this.g=void 0;for(const o of this.j)o.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.b.size===0){const o=this._computeFn(this,this.n?.());return this.f(),o}else{do{if(this.e===1){for(const o of this.j)if(o.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.u()}while(this.e!==3);return this.g}}u(){if(this.e===3)return;const o=this.k;this.k=this.j,this.j=o;const l=this.e!==0,f=this.g;this.e=3;const S=this.l;this.l=this.n?.();try{this.g=this._computeFn(this,S)}finally{for(const b of this.k)b.removeObserver(this);this.k.clear()}const m=l&&!this.s(f,this.g);if((0,T.$Jd)()?.handleDerivedRecomputed(this,{oldValue:f,newValue:this.g,change:void 0,didChange:m,hadValue:l}),m)for(const b of this.b)b.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(o){this.h++;const l=this.h===1;if(this.e===3&&(this.e=1,!l))for(const f of this.b)f.handlePossibleChange(this);if(l)for(const f of this.b)f.beginUpdate(this)}endUpdate(o){if(this.h--,this.h===0){const l=[...this.b];for(const f of l)f.endUpdate(this)}(0,i.$id)(()=>this.h>=0)}handlePossibleChange(o){if(this.e===3&&this.j.has(o)&&!this.k.has(o)){this.e=1;for(const l of this.b)l.handlePossibleChange(this)}}handleChange(o,l){if(this.j.has(o)&&!this.k.has(o)){const f=this.p?this.p({changedObservable:o,change:l,didChange:m=>m===o},this.l):!0,S=this.e===3;if(f&&(this.e===1||S)&&(this.e=2,S))for(const m of this.b)m.handlePossibleChange(this)}}readObservable(o){o.addObserver(this);const l=o.get();return this.j.add(o),this.k.delete(o),l}addObserver(o){const l=!this.b.has(o)&&this.h>0;super.addObserver(o),l&&o.beginUpdate(this)}removeObserver(o){const l=this.b.has(o)&&this.h>0;super.removeObserver(o),l&&o.endUpdate(this)}}t.$Qd=e}),define(me[56],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(C){function B(d,g){if(d.start>=g.end||g.start>=d.end)return{start:0,end:0};const $=Math.max(d.start,g.start),P=Math.min(d.end,g.end);return P-$<=0?{start:0,end:0}:{start:$,end:P}}C.intersect=B;function Q(d){return d.end-d.start<=0}C.isEmpty=Q;function A(d,g){return!Q(B(d,g))}C.intersects=A;function T(d,g){const $=[],P={start:d.start,end:Math.min(g.start,d.end)},c={start:Math.max(g.end,d.start),end:d.end};return Q(P)||$.push(P),Q(c)||$.push(c),$}C.relativeComplement=T})(i||(t.Range=i={}))}),define(me[92],be([1,0,56]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6T=void 0,t.$3T=C,t.$4T=B,t.$5T=Q;function C(d,g){const $=[];for(const P of g){if(d.start>=P.range.end)continue;if(d.end<P.range.start)break;const c=i.Range.intersect(d,P.range);i.Range.isEmpty(c)||$.push({range:c,size:P.size})}return $}function B({start:d,end:g},$){return{start:d+$,end:g+$}}function Q(d){const g=[];let $=null;for(const P of d){const c=P.range.start,h=P.range.end,e=P.size;if($&&e===$.size){$.range.end=h;continue}$={range:{start:c,end:h},size:e},g.push($)}return g}function A(...d){return Q(d.reduce((g,$)=>g.concat($),[]))}class T{get paddingTop(){return this.c}set paddingTop(g){this.b=this.b+g-this.c,this.c=g}constructor(g){this.a=[],this.b=0,this.c=0,this.c=g??0,this.b=this.c}splice(g,$,P=[]){const c=P.length-$,h=C({start:0,end:g},this.a),e=C({start:g+$,end:Number.POSITIVE_INFINITY},this.a).map(o=>({range:B(o.range,c),size:o.size})),n=P.map((o,l)=>({range:{start:g+l,end:g+l+1},size:o.size}));this.a=A(h,n,e),this.b=this.c+this.a.reduce((o,l)=>o+l.size*(l.range.end-l.range.start),0)}get count(){const g=this.a.length;return g?this.a[g-1].range.end:0}get size(){return this.b}indexAt(g){if(g<0)return-1;if(g<this.c)return 0;let $=0,P=this.c;for(const c of this.a){const h=c.range.end-c.range.start,e=P+h*c.size;if(g<e)return $+Math.floor((g-P)/c.size);$+=h,P=e}return $}indexAfter(g){return Math.min(this.indexAt(g)+1,this.count)}positionAt(g){if(g<0)return-1;let $=0,P=0;for(const c of this.a){const h=c.range.end-c.range.start,e=P+h;if(g<e)return this.c+$+(g-P)*c.size;$+=h*c.size,P=e}return-1}}t.$6T=T}),define(me[93],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ae=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(Q){return new C(Q)}constructor(Q){this.c=i&&Q===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ae=C}),define(me[3],be([1,0,6,53,2,55,93]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$ce=t.Event=void 0,t.$de=h;const T=!1,d=!1,g=!1;var $;(function(G){G.None=()=>B.$Vc.None;function q(D){if(g){const{onDidAddListener:w}=D,L=n.create();let j=0;D.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),L.print()),w?.()}}}function ae(D,w){return re(D,()=>{},0,void 0,!0,void 0,w)}G.defer=ae;function ie(D){return(w,L=null,j)=>{let X=!1,Z;return Z=D(oe=>{if(!X)return Z?Z.dispose():X=!0,w.call(L,oe)},null,j),X&&Z.dispose(),Z}}G.once=ie;function ee(D,w,L){return _((j,X=null,Z)=>D(oe=>j.call(X,w(oe)),null,Z),L)}G.map=ee;function ce(D,w,L){return _((j,X=null,Z)=>D(oe=>{w(oe),j.call(X,oe)},null,Z),L)}G.forEach=ce;function De(D,w,L){return _((j,X=null,Z)=>D(oe=>w(oe)&&j.call(X,oe),null,Z),L)}G.filter=De;function Ee(D){return D}G.signal=Ee;function Me(...D){return(w,L=null,j)=>{const X=(0,B.$Sc)(...D.map(Z=>Z(oe=>w.call(L,oe))));return ue(X,j)}}G.any=Me;function le(D,w,L,j){let X=L;return ee(D,Z=>(X=w(X,Z),X),j)}G.reduce=le;function _(D,w){let L;const j={onWillAddFirstListener(){L=D(X.fire,X)},onDidRemoveLastListener(){L?.dispose()}};w||q(j);const X=new b(j);return w?.add(X),X.event}function ue(D,w){return w instanceof Array?w.push(D):w&&w.add(D),D}function re(D,w,L=100,j=!1,X=!1,Z,oe){let pe,fe,Le,Te=0,Oe;const Se={leakWarningThreshold:Z,onWillAddFirstListener(){pe=D(He=>{Te++,fe=w(fe,He),j&&!Le&&(Ce.fire(fe),fe=void 0),Oe=()=>{const Ue=fe;fe=void 0,Le=void 0,(!j||Te>1)&&Ce.fire(Ue),Te=0},typeof L=="number"?(clearTimeout(Le),Le=setTimeout(Oe,L)):Le===void 0&&(Le=0,queueMicrotask(Oe))})},onWillRemoveListener(){X&&Te>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,pe.dispose()}};oe||q(Se);const Ce=new b(Se);return oe?.add(Ce),Ce.event}G.debounce=re;function ye(D,w=0,L){return G.debounce(D,(j,X)=>j?(j.push(X),j):[X],w,void 0,!0,void 0,L)}G.accumulate=ye;function H(D,w=(j,X)=>j===X,L){let j=!0,X;return De(D,Z=>{const oe=j||!w(Z,X);return j=!1,X=Z,oe},L)}G.latch=H;function J(D,w,L){return[G.filter(D,w,L),G.filter(D,j=>!w(j),L)]}G.split=J;function ge(D,w=!1,L=[],j){let X=L.slice(),Z=D(fe=>{X?X.push(fe):pe.fire(fe)});j&&j.add(Z);const oe=()=>{X?.forEach(fe=>pe.fire(fe)),X=null},pe=new b({onWillAddFirstListener(){Z||(Z=D(fe=>pe.fire(fe)),j&&j.add(Z))},onDidAddFirstListener(){X&&(w?setTimeout(oe):oe())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return j&&j.add(pe),pe.event}G.buffer=ge;function we(D,w){return(j,X,Z)=>{const oe=w(new Fe);return D(function(pe){const fe=oe.evaluate(pe);fe!==ke&&j.call(X,fe)},void 0,Z)}}G.chain=we;const ke=Symbol("HaltChainable");class Fe{constructor(){this.f=[]}map(w){return this.f.push(w),this}forEach(w){return this.f.push(L=>(w(L),L)),this}filter(w){return this.f.push(L=>w(L)?L:ke),this}reduce(w,L){let j=L;return this.f.push(X=>(j=w(j,X),j)),this}latch(w=(L,j)=>L===j){let L=!0,j;return this.f.push(X=>{const Z=L||!w(X,j);return L=!1,j=X,Z?X:ke}),this}evaluate(w){for(const L of this.f)if(w=L(w),w===ke)break;return w}}function Ie(D,w,L=j=>j){const j=(...pe)=>oe.fire(L(...pe)),X=()=>D.on(w,j),Z=()=>D.removeListener(w,j),oe=new b({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return oe.event}G.fromNodeEventEmitter=Ie;function z(D,w,L=j=>j){const j=(...pe)=>oe.fire(L(...pe)),X=()=>D.addEventListener(w,j),Z=()=>D.removeEventListener(w,j),oe=new b({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return oe.event}G.fromDOMEventEmitter=z;function u(D){return new Promise(w=>ie(D)(w))}G.toPromise=u;function y(D){const w=new b;return D.then(L=>{w.fire(L)},()=>{w.fire(void 0)}).finally(()=>{w.dispose()}),w.event}G.fromPromise=y;function a(D,w,L){return w(L),D(j=>w(j))}G.runAndSubscribe=a;class v{constructor(w,L){this._observable=w,this.f=0,this.g=!1;const j={onWillAddFirstListener:()=>{w.addObserver(this)},onDidRemoveLastListener:()=>{w.removeObserver(this)}};L||q(j),this.emitter=new b(j),L&&L.add(this.emitter)}beginUpdate(w){this.f++}handlePossibleChange(w){}handleChange(w,L){this.g=!0}endUpdate(w){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function N(D,w){return new v(D,w).emitter.event}G.fromObservable=N;function s(D){return(w,L,j)=>{let X=0,Z=!1;const oe={beginUpdate(){X++},endUpdate(){X--,X===0&&(D.reportChanges(),Z&&(Z=!1,w.call(L)))},handlePossibleChange(){},handleChange(){Z=!0}};D.addObserver(oe),D.reportChanges();const pe={dispose(){D.removeObserver(oe)}};return j instanceof B.$Uc?j.add(pe):Array.isArray(j)&&j.push(pe),pe}}G.fromObservableLight=s})($||(t.Event=$={}));class P{static{this.all=new Set}static{this.f=0}constructor(q){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${q}_${P.f++}`,P.all.add(this)}start(q){this.g=new A.$ae,this.listenerCount=q}stop(){if(this.g){const q=this.g.elapsed();this.durations.push(q),this.elapsedOverall+=q,this.invocationCount+=1,this.g=void 0}}}t.$ce=P;let c=-1;function h(G){const q=c;return c=G,{dispose(){c=q}}}class e{constructor(q,ae=Math.random().toString(18).slice(2,5)){this.threshold=q,this.name=ae,this.g=0}dispose(){this.f?.clear()}check(q,ae){const ie=this.threshold;if(ie<=0||ae<ie)return;this.f||(this.f=new Map);const ee=this.f.get(q.value)||0;if(this.f.set(q.value,ee+1),this.g-=1,this.g<=0){this.g=ie*.5;let ce,De=0;for(const[Ee,Me]of this.f)(!ce||De<Me)&&(ce=Ee,De=Me);console.warn(`[${this.name}] potential listener LEAK detected, having ${ae} listeners already. MOST frequent listener (${De}):`),console.warn(ce)}return()=>{const ce=this.f.get(q.value)||0;this.f.set(q.value,ce-1)}}}class n{static create(){return new n(new Error().stack??"")}constructor(q){this.value=q}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let o=0;class l{constructor(q){this.value=q,this.id=o++}}const f=2,S=(G,q)=>{if(G instanceof l)q(G);else for(let ae=0;ae<G.length;ae++){const ie=G[ae];ie&&q(ie)}},m=T?new FinalizationRegistry(G=>{typeof G=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(G))}):void 0;class b{constructor(q){this.w=0,this.f=q,this.g=c>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??c):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(d){const q=this.t;queueMicrotask(()=>{S(q,ae=>ae.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(q,ae,ie)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),B.$Vc.None;if(this.m)return B.$Vc.None;ae&&(q=q.bind(ae));const ee=new l(q);let ce,De;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=n.create(),ce=this.g.check(ee.stack,this.w+1)),d&&(ee.stack=De??n.create()),this.t?this.t instanceof l?(this.u??=new E,this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const Ee=(0,B.$Tc)(()=>{m?.unregister(Ee),ce?.(),this.x(ee)});if(ie instanceof B.$Uc?ie.add(Ee):Array.isArray(ie)&&ie.push(Ee),m){const Me=new Error().stack.split(`
`).slice(2).join(`
`).trim();m.register(Ee,Me,Ee)}return Ee},this.q}x(q){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const ae=this.t,ie=ae.indexOf(q);if(ie===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,ae[ie]=void 0;const ee=this.u.current===this;if(this.w*f<=ae.length){let ce=0;for(let De=0;De<ae.length;De++)ae[De]?ae[ce++]=ae[De]:ee&&(this.u.end--,ce<this.u.i&&this.u.i--);ae.length=ce}}y(q,ae){if(!q)return;const ie=this.f?.onListenerError||i.$1;if(!ie){q.value(ae);return}try{q.value(ae)}catch(ee){ie(ee)}}z(q){const ae=q.current.t;for(;q.i<q.end;)this.y(ae[q.i++],q.value);q.reset()}fire(q){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,q);else{const ae=this.u;ae.enqueue(this,q,this.t.length),this.z(ae)}this.j?.stop()}hasListeners(){return this.w>0}}t.$ee=b;const r=()=>new E;t.$fe=r;class E{constructor(){this.i=-1,this.end=0}enqueue(q,ae,ie){this.i=0,this.end=ie,this.current=q,this.value=ae}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class k extends b{async fireAsync(q,ae,ie){if(this.t)for(this.h||(this.h=new Q.$6c),S(this.t,ee=>this.h.push([ee.value,q]));this.h.size>0&&!ae.isCancellationRequested;){const[ee,ce]=this.h.shift(),De=[],Ee={...ce,token:ae,waitUntil:Me=>{if(Object.isFrozen(De))throw new Error("waitUntil can NOT be called asynchronous");ie&&(Me=ie(Me,ee)),De.push(Me)}};try{ee(Ee)}catch(Me){(0,i.$1)(Me);continue}Object.freeze(De),await Promise.allSettled(De).then(Me=>{for(const le of Me)le.status==="rejected"&&(0,i.$1)(le.reason)})}}}t.$ge=k;class F extends b{get isPaused(){return this.h!==0}constructor(q){super(q),this.h=0,this.s=new Q.$6c,this.A=q?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const q=Array.from(this.s);this.s.clear(),super.fire(this.A(q))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(q){this.w&&(this.h!==0?this.s.push(q):super.fire(q))}}t.$he=F;class M extends F{constructor(q){super(q),this.k=q.delay??100}fire(q){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(q)}}t.$ie=M;class W extends b{constructor(q){super(q),this.h=[],this.k=q?.merge}fire(q){this.hasListeners()&&(this.h.push(q),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ae=>super.fire(ae)),this.h=[]}))}}t.$je=W;class p{constructor(){this.g=!1,this.h=[],this.f=new b({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(q){const ae={event:q,listener:null};this.h.push(ae),this.g&&this.m(ae);const ie=()=>{this.g&&this.o(ae);const ee=this.h.indexOf(ae);this.h.splice(ee,1)};return(0,B.$Tc)((0,C.$db)(ie))}j(){this.g=!0,this.h.forEach(q=>this.m(q))}k(){this.g=!1,this.h.forEach(q=>this.o(q))}m(q){q.listener=q.event(ae=>this.f.fire(ae))}o(q){q.listener?.dispose(),q.listener=null}dispose(){this.f.dispose();for(const q of this.h)q.listener?.dispose();this.h=[]}}t.$ke=p;class I{constructor(q,ae,ie,ee){this.f=new B.$Uc;const ce=this.f.add(new p),De=this.f.add(new B.$5c);function Ee(Me){De.set(Me,ce.add(ee(Me)))}for(const Me of q)Ee(Me);this.f.add(ae(Me=>{Ee(Me)})),this.f.add(ie(Me=>{De.deleteAndDispose(Me)})),this.event=ce.event}dispose(){this.f.dispose()}}t.$le=I;class V{constructor(){this.f=[]}wrapEvent(q){return(ae,ie,ee)=>q(ce=>{const De=this.f[this.f.length-1];De?De.push(()=>ae.call(ie,ce)):ae.call(ie,ce)},void 0,ee)}bufferEvents(q){const ae=[];this.f.push(ae);const ie=q();return this.f.pop(),ae.forEach(ee=>ee()),ie}}t.$me=V;class R{constructor(){this.f=!1,this.g=$.None,this.h=B.$Vc.None,this.j=new b({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(q){this.g=q,this.f&&(this.h.dispose(),this.h=q(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ne=R;class x{static const(q){return new O(q)}constructor(q){this.g=q,this.f=new b,this.onDidChange=this.f.event}get value(){return this.g}set value(q){q!==this.g&&(this.g=q,this.f.fire(void 0))}}t.$oe=x;class O{constructor(q){this.value=q,this.onDidChange=$.None}}}),define(me[17],be([1,0,22,3]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FR=t.$ER=t.$DR=t.$CR=t.$BR=t.$AR=t.$zR=t.$yR=t.$tR=void 0,t.$qR=Q,t.$rR=A,t.$sR=T,t.$uR=d,t.$vR=g,t.$wR=$,t.$xR=P,t.$GR=e,t.$HR=n;class B{constructor(){this.a=new Map,this.b=new C.$ee,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new C.$ee,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new B}getZoomLevel(l){return this.a.get(this.f(l))??0}setZoomLevel(l,f){if(this.getZoomLevel(f)===l)return;const S=this.f(f);this.a.set(S,l),this.b.fire(S)}getZoomFactor(l){return this.c.get(this.f(l))??1}setZoomFactor(l,f){this.c.set(this.f(f),l)}setFullscreen(l,f){if(this.isFullscreen(f)===l)return;const S=this.f(f);this.e.set(S,l),this.d.fire(S)}isFullscreen(l){return!!this.e.get(this.f(l))}f(l){return l.vscodeWindowId}}function Q(o,l,f){typeof l=="string"&&(l=o.matchMedia(l)),l.addEventListener("change",f)}function A(o,l){B.INSTANCE.setZoomLevel(o,l)}function T(o){return B.INSTANCE.getZoomLevel(o)}t.$tR=B.INSTANCE.onDidChangeZoomLevel;function d(o){return B.INSTANCE.getZoomFactor(o)}function g(o,l){B.INSTANCE.setZoomFactor(o,l)}function $(o,l){B.INSTANCE.setFullscreen(o,l)}function P(o){return B.INSTANCE.isFullscreen(o)}t.$yR=B.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;t.$zR=c.indexOf("Firefox")>=0,t.$AR=c.indexOf("AppleWebKit")>=0,t.$BR=c.indexOf("Chrome")>=0,t.$CR=!t.$BR&&c.indexOf("Safari")>=0,t.$DR=!t.$BR&&!t.$CR&&t.$AR,t.$ER=c.indexOf("Electron/")>=0,t.$FR=c.indexOf("Android")>=0;let h=!1;if(typeof i.$nR.matchMedia=="function"){const o=i.$nR.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),l=i.$nR.matchMedia("(display-mode: fullscreen)");h=o.matches,Q(i.$nR,o,({matches:f})=>{h&&l.matches||(h=f)})}function e(){return h}function n(){return navigator?.windowControlsOverlay?.visible}}),define(me[24],be([1,0,3]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XT=void 0;class C{get event(){return this.a.event}constructor(Q,A,T){const d=g=>this.a.fire(g);this.a=new i.$ee({onWillAddFirstListener:()=>Q.addEventListener(A,d,T),onDidRemoveLastListener:()=>Q.removeEventListener(A,d,T)})}dispose(){this.a.dispose()}}t.$XT=C}),define(me[34],be([1,0,3]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pe=t.CancellationToken=void 0,t.$qe=T;const C=Object.freeze(function(d,g){const $=setTimeout(d.bind(g),0);return{dispose(){clearTimeout($)}}});var B;(function(d){function g($){return $===d.None||$===d.Cancelled||$ instanceof Q?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}d.isCancellationToken=g,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(B||(t.CancellationToken=B={}));class Q{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new i.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(g){this.f=void 0,this.g=void 0,this.g=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new Q),this.f}cancel(){this.f?this.f instanceof Q&&this.f.cancel():this.f=B.Cancelled}dispose(g=!1){g&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof Q&&this.f.dispose():this.f=B.None}}t.$pe=A;function T(d){const g=new A;return d.add({dispose(){g.cancel()}}),g.token}}),define(me[94],be([1,0,34]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5e=t.$4e=t.$2e=void 0,t.$3e=B;class C{constructor(d){this.b=d,this.a=null}get(){if(this.a)return this.a;const d=new i.$pe,g=this.b(d.token);return this.a={promise:g,dispose:()=>{this.a=null,d.cancel(),d.dispose()}},this.a}}t.$2e=C;function B(T){return T}class Q{constructor(d,g){this.a=void 0,this.b=void 0,typeof d=="function"?(this.c=d,this.d=B):(this.c=g,this.d=d.getCacheKey)}get(d){const g=this.d(d);return this.b!==g&&(this.b=g,this.a=this.c(d)),this.a}}t.$4e=Q;class A{get cachedValues(){return this.a}constructor(d,g){this.a=new Map,this.b=new Map,typeof d=="function"?(this.c=d,this.d=B):(this.c=g,this.d=d.getCacheKey)}get(d){const g=this.d(d);if(this.b.has(g))return this.b.get(g);const $=this.c(d);return this.a.set(d,$),this.b.set(g,$),$}}t.$5e=A}),define(me[95],be([1,0,41,33,42,34,26,38,6]),function(se,t,i,C,B,Q,A,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0d=t.$9d=t.$8d=t.$7d=void 0,t.$$d=h,t.$_d=e;class g{get cachedValue(){return this.a}constructor(o){this.b=o,this.a=(0,C.$2d)(this,void 0)}getValue(){let o=this.a.get();return o||(o=this.b(),this.a.set(o,void 0)),o}}t.$7d=g;class ${constructor(o){this.a=(0,C.$2d)(this,void 0),this.promiseResult=this.a,this.promise=o.then(l=>((0,C.$Wd)(f=>{this.a.set(new P(l,void 0),f)}),l),l=>{throw(0,C.$Wd)(f=>{this.a.set(new P(void 0,l),f)}),l})}}t.$8d=$;class P{constructor(o,l){this.data=o,this.error=l}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$9d=P;class c{constructor(o){this.b=o,this.a=new g(()=>new $(this.b())),this.cachedPromiseResult=(0,B.$Ld)(this,l=>this.a.cachedValue.read(l)?.promiseResult.read(l))}getPromise(){return this.a.getValue().promise}}t.$0d=c;function h(n,o,l,f){return o||(o=S=>S!=null),new Promise((S,m)=>{let b=!0,r=!1;const E=n.map(F=>({isFinished:o(F),error:l?l(F):!1,state:F})),k=(0,i.$kd)(F=>{const{isFinished:M,error:W,state:p}=E.read(F);(M||W)&&(b?r=!0:k.dispose(),W?m(W===!0?p:W):S(p))});if(f){const F=f.onCancellationRequested(()=>{k.dispose(),F.dispose(),m(new d.$5)});if(f.isCancellationRequested){k.dispose(),F.dispose(),m(new d.$5);return}}b=!1,r&&k.dispose()})}function e(n,o){let l,f;o===void 0?(l=n,f=void 0):(f=n,l=o);let S;return new B.$Qd(new A.$bd(f,void 0,l),m=>(S&&S.dispose(!0),S=new Q.$pe,l(m,S.token)),void 0,void 0,()=>S?.dispose(),T.$7c)}}),define(me[96],be([1,0,3,2,41,33,26,42,27]),function(se,t,i,C,B,Q,A,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gd=t.$Cd=t.$ud=void 0,t.$rd=g,t.$sd=P,t.$td=c,t.$vd=e,t.$wd=o,t.$xd=f,t.$yd=S,t.$zd=m,t.$Ad=b,t.$Bd=r,t.$Dd=k,t.$Ed=F,t.$Fd=M,t.$Hd=I;function g(V){return new $(V)}class $ extends Q.$Ud{constructor(R){super(),this.b=R}get debugName(){return this.toString()}get(){return this.b}addObserver(R){}removeObserver(R){}toString(){return`Const: ${this.b}`}}function P(V){const R=(0,Q.$2d)("promiseValue",{});return V.then(x=>{R.set({value:x},void 0)}),R}function c(V,R){return new h(V,R)}class h extends Q.$Vd{constructor(R,x){super(),this.j=R,this._getValue=x,this.g=!1,this.n=O=>{const G=this._getValue(O),q=this.e,ae=!this.g||q!==G;let ie=!1;ae&&(this.e=G,this.g&&(ie=!0,(0,Q.$Zd)(h.globalTransaction,ee=>{(0,d.$Jd)()?.handleFromEventObservableTriggered(this,{oldValue:q,newValue:G,change:void 0,didChange:ae,hadValue:this.g});for(const ce of this.b)ee.updateObserver(ce,this),ce.handleChange(this,void 0)},()=>{const ee=this.k();return"Event fired"+(ee?`: ${ee}`:"")})),this.g=!0),ie||(0,d.$Jd)()?.handleFromEventObservableTriggered(this,{oldValue:q,newValue:G,change:void 0,didChange:ae,hadValue:this.g})}}k(){return(0,A.$dd)(this._getValue)}get debugName(){const R=this.k();return"From Event"+(R?`: ${R}`:"")}c(){this.h=this.j(this.n)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.n(void 0),this.e):this._getValue(void 0)}}t.$ud=h,function(V){V.Observer=h;function R(x,O){let G=!1;h.globalTransaction===void 0&&(h.globalTransaction=x,G=!0);try{O()}finally{G&&(h.globalTransaction=void 0)}}V.batchEventsGlobally=R}(c||(t.$td=c={}));function e(V,R){return new n(V,R)}class n extends Q.$Vd{constructor(R,x){super(),this.debugName=R,this.g=x,this.j=()=>{(0,Q.$Wd)(O=>{for(const G of this.b)O.updateObserver(G,this),G.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function o(V){return typeof V=="string"?new l(V):new l(void 0,V)}class l extends Q.$Vd{get debugName(){return new A.$bd(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}constructor(R,x){super(),this.e=R,this.g=x}trigger(R,x){if(!R){(0,Q.$Wd)(O=>{this.trigger(O,x)},()=>`Trigger signal ${this.debugName}`);return}for(const O of this.b)R.updateObserver(O,this),O.handleChange(this,x)}get(){}}function f(V,R,x){const O=(0,Q.$2d)("debounced",void 0);let G;return x.add((0,B.$kd)(q=>{const ae=V.read(q);G&&clearTimeout(G),G=setTimeout(()=>{(0,Q.$Wd)(ie=>{O.set(ae,ie)})},R)})),O}function S(V,R){let x=!1,O,G;return c(q=>{const ae=(0,B.$kd)(ie=>{const ee=V.read(ie);x?(G&&clearTimeout(G),G=setTimeout(()=>{O=ee,q()},R)):(x=!0,O=ee)});return{dispose(){ae.dispose(),x=!1,O=void 0}}},()=>x?O:V.get())}function m(V,R,x){const O=(0,Q.$2d)("triggeredRecently",!1);let G;return x.add(V(()=>{O.set(!0,void 0),G&&clearTimeout(G),G=setTimeout(()=>{O.set(!1,void 0)},R)})),O}function b(V){const R=new E(!1,void 0);return V.addObserver(R),(0,C.$Tc)(()=>{V.removeObserver(R)})}(0,Q.$Sd)(b);function r(V,R){const x=new E(!0,R);return V.addObserver(x),R?R(V.get()):V.reportChanges(),(0,C.$Tc)(()=>{V.removeObserver(x)})}(0,Q.$Rd)(r);class E{constructor(R,x){this.b=R,this.c=x,this.a=0}beginUpdate(R){this.a++}endUpdate(R){this.a--,this.a===0&&this.b&&(this.c?this.c(R.get()):R.reportChanges())}handlePossibleChange(R){}handleChange(R,x){}}t.$Cd=E;function k(V,R){let x;return(0,T.$Ld)(V,G=>(x=R(G,x),x))}function F(V,R){let x;const O=o("derivedObservableWithWritableCache"),G=(0,T.$Ld)(V,q=>(O.read(q),x=R(q,x),x));return Object.assign(G,{clearCache:q=>{x=void 0,O.trigger(q)},setCache:(q,ae)=>{x=q,O.trigger(ae)}})}function M(V,R,x,O){let G=new W(x,O);return(0,T.$Md)({debugReferenceFn:x,owner:V,onLastObserverRemoved:()=>{G.dispose(),G=new W(x)}},ae=>(G.setItems(R.read(ae)),G.getItems()))}class W{constructor(R,x){this.c=R,this.e=x,this.a=new Map,this.b=[]}dispose(){this.a.forEach(R=>R.store.dispose()),this.a.clear()}setItems(R){const x=[],O=new Set(this.a.keys());for(const G of R){const q=this.e?this.e(G):G;let ae=this.a.get(q);if(ae)O.delete(q);else{const ie=new C.$Uc;ae={out:this.c(G,ie),store:ie},this.a.set(q,ae)}x.push(ae.out)}for(const G of O)this.a.get(G).store.dispose(),this.a.delete(G);this.b=x}getItems(){return this.b}}class p{constructor(R){this.observable=R}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Gd=p;function I(V,R){return R instanceof p?R.observable:c(R.onDidChange,()=>R.value)}}),define(me[57],be([1,0,33,42,41,96,95,27]),function(se,t,i,C,B,Q,A,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$2d}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$5d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$Wd}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$Zd}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return C.$Ld}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return C.$Md}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return C.$Nd}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return C.$Od}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return B.$kd}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return B.$pd}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return B.$md}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return B.$od}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return B.$ld}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return B.$nd}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return Q.$rd}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return Q.$xd}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return Q.$Dd}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return Q.$Ed}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return Q.$Ad}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return Q.$Bd}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return Q.$td}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return Q.$sd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return Q.$wd}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return Q.$vd}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return Q.$zd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return A.$7d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return A.$0d}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return A.$8d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return A.$9d}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return A.$$d}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return A.$_d}}),!1&&(0,T.$Id)(new T.$Kd)}),define(me[58],be([1,0,3,2]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ys=t.$Xs=t.$Ws=t.$Vs=t.ScrollbarVisibility=void 0;var B;(function(h){h[h.Auto=1]="Auto",h[h.Hidden=2]="Hidden",h[h.Visible=3]="Visible"})(B||(t.ScrollbarVisibility=B={}));class Q{constructor(e,n,o,l,f,S,m){this.c=e,this._scrollStateBrand=void 0,this.c&&(n=n|0,o=o|0,l=l|0,f=f|0,S=S|0,m=m|0),this.rawScrollLeft=l,this.rawScrollTop=m,n<0&&(n=0),l+n>o&&(l=o-n),l<0&&(l=0),f<0&&(f=0),m+f>S&&(m=S-f),m<0&&(m=0),this.width=n,this.scrollWidth=o,this.scrollLeft=l,this.height=f,this.scrollHeight=S,this.scrollTop=m}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,n){return new Q(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new Q(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,n){const o=this.width!==e.width,l=this.scrollWidth!==e.scrollWidth,f=this.scrollLeft!==e.scrollLeft,S=this.height!==e.height,m=this.scrollHeight!==e.scrollHeight,b=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:n,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:l,scrollLeftChanged:f,heightChanged:S,scrollHeightChanged:m,scrollTopChanged:b}}}t.$Vs=Q;class A extends C.$Vc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$ee),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new Q(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,n){const o=this.g.withScrollDimensions(e,n);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const n=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(e,n){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const o=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let l;n?l=new $(this.h.from,o,this.h.startTime,this.h.duration):l=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=l}else{const o=this.g.withScrollPosition(e);this.h=$.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),n=this.g.withScrollPosition(e);if(this.n(n,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,n){const o=this.g;o.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(o,n)))}}t.$Ws=A;class T{constructor(e,n,o){this.scrollLeft=e,this.scrollTop=n,this.isDone=o}}t.$Xs=T;function d(h,e){const n=e-h;return function(o){return h+n*c(o)}}function g(h,e,n){return function(o){return o<n?h(o/n):e((o-n)/(1-n))}}class ${constructor(e,n,o,l){this.from=e,this.to=n,this.duration=l,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,n,o){if(Math.abs(e-n)>2.5*o){let f,S;return e<n?(f=e+.75*o,S=n-.75*o):(f=e-.75*o,S=n+.75*o),g(d(e,f),d(S,n),.33)}return d(e,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const n=(e-this.startTime)/this.duration;if(n<1){const o=this.c(n),l=this.d(n);return new T(o,l,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,n,o){return $.start(e,n,o)}static start(e,n,o){o=o+10;const l=Date.now()-10;return new $(e,n,l,o)}}t.$Ys=$;function P(h){return Math.pow(h,3)}function c(h){return 1-P(1-h)}}),define(me[97],be([1,0,6,2]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$re=B,t.$se=Q,t.$te=A,t.$ue=T,t.$ve=g,t.$we=$,t.$xe=P,t.$ye=c,t.$ze=h,t.$Ae=e,t.$Be=n,t.$Ce=o,t.$De=l,t.$Ee=f,t.$Fe=S;function B(m){const b=m;return b?typeof b.read=="function":!1}function Q(m){const b=m;return b?[b.on,b.pause,b.resume,b.destroy].every(r=>typeof r=="function"):!1}function A(m){const b=m;return b?Q(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}function T(m,b){return new d(m,b)}class d{constructor(b,r){this.e=b,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(r=>r(b))}h(b){this.c.error.length===0?(0,i.$1)(b):this.c.error.slice(0).forEach(r=>r(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,r){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(b,r){if(this.a.destroyed)return;let E;switch(b){case"data":E=this.c.data;break;case"end":E=this.c.end;break;case"error":E=this.c.error;break}if(E){const k=E.indexOf(r);k>=0&&E.splice(k,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(E=>E())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(m,b){const r=[];let E;for(;(E=m.read())!==null;)r.push(E);return b(r)}function $(m,b,r){const E=[];let k;for(;(k=m.read())!==null&&E.length<r;)E.push(k);return k===null&&E.length>0?b(E):{read:()=>{if(E.length>0)return E.shift();if(typeof k<"u"){const F=k;return k=void 0,F}return m.read()}}}function P(m,b){return new Promise((r,E)=>{const k=[];c(m,{onData:F=>{b&&k.push(F)},onError:F=>{b?E(F):r(void 0)},onEnd:()=>{r(b?b(k):void 0)}})})}function c(m,b,r){m.on("error",E=>{r?.isCancellationRequested||b.onError(E)}),m.on("end",()=>{r?.isCancellationRequested||b.onEnd()}),m.on("data",E=>{r?.isCancellationRequested||b.onData(E)})}function h(m,b){return new Promise((r,E)=>{const k=new C.$Uc,F=[],M=I=>{if(F.push(I),F.length>b)return k.dispose(),m.pause(),r({stream:m,buffer:F,ended:!1})},W=I=>(k.dispose(),E(I)),p=()=>(k.dispose(),r({stream:m,buffer:F,ended:!0}));k.add((0,C.$Tc)(()=>m.removeListener("error",W))),m.on("error",W),k.add((0,C.$Tc)(()=>m.removeListener("end",p))),m.on("end",p),k.add((0,C.$Tc)(()=>m.removeListener("data",M))),m.on("data",M)})}function e(m,b){const r=T(b);return r.end(m),r}function n(){const m=T(()=>{throw new Error("not supported")});return m.end(),m}function o(m){let b=!1;return{read:()=>b?null:(b=!0,m)}}function l(m,b,r){const E=T(r);return c(m,{onData:k=>E.write(b.data(k)),onError:k=>E.error(b.error?b.error(k):k),onEnd:()=>E.end()}),E}function f(m,b,r){let E=!1;return{read:()=>{const k=b.read();return E?k:(E=!0,k!==null?r([m,k]):m)}}}function S(m,b,r){let E=!1;const k=T(r);return c(b,{onData:F=>E?k.write(F):(E=!0,k.write(r([m,F]))),onError:F=>k.error(F),onEnd:()=>{E||(E=!0,k.write(m)),k.end()}}),k}}),define(me[43],be([1,0,23,97]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ge=void 0,t.$He=g,t.$Ie=$,t.$Je=P,t.$Ke=c,t.$Le=h,t.$Me=e,t.$Ne=n,t.$Oe=o,t.$Pe=l,t.$Qe=f,t.$Re=S,t.$Se=m,t.$Te=b,t.$Ue=r,t.$Ve=E,t.$We=k,t.$Xe=F,t.$Ye=M,t.$Ze=W,t.$1e=V;const B=typeof Buffer<"u",Q=new i.$V(()=>new Uint8Array(256));let A,T;class d{static alloc(x){return B?new d(Buffer.allocUnsafe(x)):new d(new Uint8Array(x))}static wrap(x){return B&&!Buffer.isBuffer(x)&&(x=Buffer.from(x.buffer,x.byteOffset,x.byteLength)),new d(x)}static fromString(x,O){return!(O?.dontUseNodeBuffer||!1)&&B?new d(Buffer.from(x)):(A||(A=new TextEncoder),new d(A.encode(x)))}static fromByteArray(x){const O=d.alloc(x.length);for(let G=0,q=x.length;G<q;G++)O.buffer[G]=x[G];return O}static concat(x,O){if(typeof O>"u"){O=0;for(let ae=0,ie=x.length;ae<ie;ae++)O+=x[ae].byteLength}const G=d.alloc(O);let q=0;for(let ae=0,ie=x.length;ae<ie;ae++){const ee=x[ae];G.set(ee,q),q+=ee.byteLength}return G}constructor(x){this.buffer=x,this.byteLength=this.buffer.byteLength}clone(){const x=d.alloc(this.byteLength);return x.set(this),x}toString(){return B?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(x,O){return new d(this.buffer.subarray(x,O))}set(x,O){if(x instanceof d)this.buffer.set(x.buffer,O);else if(x instanceof Uint8Array)this.buffer.set(x,O);else if(x instanceof ArrayBuffer)this.buffer.set(new Uint8Array(x),O);else if(ArrayBuffer.isView(x))this.buffer.set(new Uint8Array(x.buffer,x.byteOffset,x.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(x){return c(this.buffer,x)}writeUInt32BE(x,O){h(this.buffer,x,O)}readUInt32LE(x){return e(this.buffer,x)}writeUInt32LE(x,O){n(this.buffer,x,O)}readUInt8(x){return o(this.buffer,x)}writeUInt8(x,O){l(this.buffer,x,O)}indexOf(x,O=0){return g(this.buffer,x instanceof d?x.buffer:x,O)}}t.$Ge=d;function g(R,x,O=0){const G=x.byteLength,q=R.byteLength;if(G===0)return 0;if(G===1)return R.indexOf(x[0]);if(G>q-O)return-1;const ae=Q.value;ae.fill(x.length);for(let De=0;De<x.length;De++)ae[x[De]]=x.length-De-1;let ie=O+x.length-1,ee=ie,ce=-1;for(;ie<q;)if(R[ie]===x[ee]){if(ee===0){ce=ie;break}ie--,ee--}else ie+=Math.max(x.length-ee,ae[R[ie]]),ee=x.length-1;return ce}function $(R,x){return R[x+0]<<0>>>0|R[x+1]<<8>>>0}function P(R,x,O){R[O+0]=x&255,x=x>>>8,R[O+1]=x&255}function c(R,x){return R[x]*2**24+R[x+1]*2**16+R[x+2]*2**8+R[x+3]}function h(R,x,O){R[O+3]=x,x=x>>>8,R[O+2]=x,x=x>>>8,R[O+1]=x,x=x>>>8,R[O]=x}function e(R,x){return R[x+0]<<0>>>0|R[x+1]<<8>>>0|R[x+2]<<16>>>0|R[x+3]<<24>>>0}function n(R,x,O){R[O+0]=x&255,x=x>>>8,R[O+1]=x&255,x=x>>>8,R[O+2]=x&255,x=x>>>8,R[O+3]=x&255}function o(R,x){return R[x]}function l(R,x,O){R[O]=x}function f(R){return C.$ve(R,x=>d.concat(x))}function S(R){return C.$Ce(R)}function m(R){return C.$xe(R,x=>d.concat(x))}async function b(R){return R.ended?d.concat(R.buffer):d.concat([...R.buffer,await m(R.stream)])}function r(R){return C.$Ae(R,x=>d.concat(x))}function E(R){return C.$De(R,{data:x=>typeof x=="string"?d.fromString(x):d.wrap(x)},x=>d.concat(x))}function k(R){return C.$ue(x=>d.concat(x),R)}function F(R,x){return C.$Ee(R,x,O=>d.concat(O))}function M(R,x){return C.$Fe(R,x,O=>d.concat(O))}function W(R){let x=0,O=0,G=0;const q=new Uint8Array(Math.floor(R.length/4*3)),ae=ee=>{switch(O){case 3:q[G++]=x|ee,O=0;break;case 2:q[G++]=x|ee>>>2,x=ee<<6,O=3;break;case 1:q[G++]=x|ee>>>4,x=ee<<4,O=2;break;default:x=ee<<2,O=1}};for(let ee=0;ee<R.length;ee++){const ce=R.charCodeAt(ee);if(ce>=65&&ce<=90)ae(ce-65);else if(ce>=97&&ce<=122)ae(ce-97+26);else if(ce>=48&&ce<=57)ae(ce-48+52);else if(ce===43||ce===45)ae(62);else if(ce===47||ce===95)ae(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${R[ee]}`)}}const ie=G;for(;O>0;)ae(0);return d.wrap(q).slice(0,ie)}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function V({buffer:R},x=!0,O=!1){const G=O?I:p;let q="";const ae=R.byteLength%3;let ie=0;for(;ie<R.byteLength-ae;ie+=3){const ee=R[ie+0],ce=R[ie+1],De=R[ie+2];q+=G[ee>>>2],q+=G[(ee<<4|ce>>>4)&63],q+=G[(ce<<2|De>>>6)&63],q+=G[De&63]}if(ae===1){const ee=R[ie+0];q+=G[ee>>>2],q+=G[ee<<4&63],x&&(q+="==")}else if(ae===2){const ee=R[ie+0],ce=R[ie+1];q+=G[ee>>>2],q+=G[(ee<<4|ce>>>4)&63],q+=G[ce<<2&63],x&&(q+="=")}return q}}),define(me[9],be([1,0,94,23]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8f=t.$7f=t.$6f=t.GraphemeBreakType=t.$Vf=t.$Of=t.$Hf=t.$Gf=void 0,t.$8e=B,t.$9e=A,t.$0e=d,t.$$e=g,t.$_e=$,t.$af=P,t.$bf=c,t.$cf=h,t.$df=e,t.$ef=n,t.$ff=o,t.$gf=l,t.$hf=f,t.$if=S,t.$jf=m,t.$kf=b,t.$lf=r,t.$mf=E,t.$nf=k,t.$of=F,t.$pf=M,t.$qf=W,t.$rf=p,t.$sf=I,t.$tf=V,t.$uf=R,t.$vf=x,t.$wf=O,t.$xf=G,t.$yf=q,t.$zf=ae,t.$Af=ie,t.$Bf=ee,t.$Cf=ce,t.$Df=De,t.$Ef=Ee,t.$Ff=Me,t.$If=re,t.$Jf=ye,t.$Kf=H,t.$Lf=J,t.$Mf=ke,t.$Nf=Ie,t.$Pf=z,t.$Qf=u,t.$Rf=y,t.$Sf=a,t.$Tf=N,t.$Uf=s,t.$Wf=D,t.$Xf=w,t.$Yf=L,t.$Zf=j,t.$1f=X,t.$2f=Z,t.$3f=oe,t.$4f=pe,t.$5f=Se;function B(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}const Q=/{(\d+)}/g;function A(Y,...ne){return ne.length===0?Y:Y.replace(Q,function($e,ve){const Re=parseInt(ve,10);return isNaN(Re)||Re<0||Re>=ne.length?$e:ne[Re]})}const T=/{([^}]+)}/g;function d(Y,ne){return Object.keys(ne).length===0?Y:Y.replace(T,($e,ve)=>ne[ve]??$e)}function g(Y){return Y.replace(/[<>"'&]/g,ne=>{switch(ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ne})}function $(Y){return Y.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}function P(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(Y,ne){let $e=0;const ve=ne.charCodeAt(0);for(let Re=Y.length-1;Re>=0;Re--)Y.charCodeAt(Re)===ve&&$e++;return $e}function h(Y,ne,$e="\u2026"){return Y.length<=ne?Y:`${Y.substr(0,ne)}${$e}`}function e(Y,ne,$e="\u2026"){if(Y.length<=ne)return Y;const ve=Math.ceil(ne/2)-$e.length/2,Re=Math.floor(ne/2)-$e.length/2;return`${Y.substr(0,ve)}${$e}${Y.substr(Y.length-Re)}`}function n(Y,ne=" "){const $e=o(Y,ne);return l($e,ne)}function o(Y,ne){if(!Y||!ne)return Y;const $e=ne.length;if($e===0||Y.length===0)return Y;let ve=0;for(;Y.indexOf(ne,ve)===ve;)ve=ve+$e;return Y.substring(ve)}function l(Y,ne){if(!Y||!ne)return Y;const $e=ne.length,ve=Y.length;if($e===0||ve===0)return Y;let Re=ve,ze=-1;for(;ze=Y.lastIndexOf(ne,Re-1),!(ze===-1||ze+$e!==Re);){if(ze===0)return"";Re=ze}return Y.substring(0,Re)}function f(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function S(Y){return Y.replace(/\*/g,"")}function m(Y,ne,$e={}){if(!Y)throw new Error("Cannot create regex from empty string");ne||(Y=P(Y)),$e.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ve="";return $e.global&&(ve+="g"),$e.matchCase||(ve+="i"),$e.multiline&&(ve+="m"),$e.unicode&&(ve+="u"),new RegExp(Y,ve)}function b(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}function r(Y){return Y.split(/\r\n|\r|\n/)}function E(Y){const ne=[],$e=Y.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil($e.length/2);ve++)ne.push($e[2*ve]+($e[2*ve+1]??""));return ne}function k(Y){for(let ne=0,$e=Y.length;ne<$e;ne++){const ve=Y.charCodeAt(ne);if(ve!==32&&ve!==9)return ne}return-1}function F(Y,ne=0,$e=Y.length){for(let ve=ne;ve<$e;ve++){const Re=Y.charCodeAt(ve);if(Re!==32&&Re!==9)return Y.substring(ne,ve)}return Y.substring(ne,$e)}function M(Y,ne=Y.length-1){for(let $e=ne;$e>=0;$e--){const ve=Y.charCodeAt($e);if(ve!==32&&ve!==9)return $e}return-1}function W(Y,ne,$e){const ve=[];let Re=0;for(const ze of Y.matchAll(ne)){if(ve.push(Y.slice(Re,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Re=ze.index+ze[0].length,ve.push($e(ze[0],...ze.slice(1),ze.index,Y,ze.groups))}return ve.push(Y.slice(Re)),Promise.all(ve).then(ze=>ze.join(""))}function p(Y,ne){return Y<ne?-1:Y>ne?1:0}function I(Y,ne,$e=0,ve=Y.length,Re=0,ze=ne.length){for(;$e<ve&&Re<ze;$e++,Re++){const it=Y.charCodeAt($e),st=ne.charCodeAt(Re);if(it<st)return-1;if(it>st)return 1}const We=ve-$e,et=ze-Re;return We<et?-1:We>et?1:0}function V(Y,ne){return R(Y,ne,0,Y.length,0,ne.length)}function R(Y,ne,$e=0,ve=Y.length,Re=0,ze=ne.length){for(;$e<ve&&Re<ze;$e++,Re++){let it=Y.charCodeAt($e),st=ne.charCodeAt(Re);if(it===st)continue;if(it>=128||st>=128)return I(Y.toLowerCase(),ne.toLowerCase(),$e,ve,Re,ze);O(it)&&(it-=32),O(st)&&(st-=32);const Je=it-st;if(Je!==0)return Je}const We=ve-$e,et=ze-Re;return We<et?-1:We>et?1:0}function x(Y){return Y>=48&&Y<=57}function O(Y){return Y>=97&&Y<=122}function G(Y){return Y>=65&&Y<=90}function q(Y,ne){return Y.length===ne.length&&R(Y,ne)===0}function ae(Y,ne){const $e=ne.length;return ne.length>Y.length?!1:R(Y,ne,0,$e)===0}function ie(Y,ne){const $e=Math.min(Y.length,ne.length);let ve;for(ve=0;ve<$e;ve++)if(Y.charCodeAt(ve)!==ne.charCodeAt(ve))return ve;return $e}function ee(Y,ne){const $e=Math.min(Y.length,ne.length);let ve;const Re=Y.length-1,ze=ne.length-1;for(ve=0;ve<$e;ve++)if(Y.charCodeAt(Re-ve)!==ne.charCodeAt(ze-ve))return ve;return $e}function ce(Y){return 55296<=Y&&Y<=56319}function De(Y){return 56320<=Y&&Y<=57343}function Ee(Y,ne){return(Y-55296<<10)+(ne-56320)+65536}function Me(Y,ne,$e){const ve=Y.charCodeAt($e);if(ce(ve)&&$e+1<ne){const Re=Y.charCodeAt($e+1);if(De(Re))return Ee(ve,Re)}return ve}function le(Y,ne){const $e=Y.charCodeAt(ne-1);if(De($e)&&ne>1){const ve=Y.charCodeAt(ne-2);if(ce(ve))return Ee(ve,$e)}return $e}class _{get offset(){return this.e}constructor(ne,$e=0){this.c=ne,this.d=ne.length,this.e=$e}setOffset(ne){this.e=ne}prevCodePoint(){const ne=le(this.c,this.e);return this.e-=ne>=65536?2:1,ne}nextCodePoint(){const ne=Me(this.c,this.d,this.e);return this.e+=ne>=65536?2:1,ne}eol(){return this.e>=this.d}}t.$Gf=_;class ue{get offset(){return this.c.offset}constructor(ne,$e=0){this.c=new _(ne,$e)}nextGraphemeLength(){const ne=Te.getInstance(),$e=this.c,ve=$e.offset;let Re=ne.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const ze=$e.offset,We=ne.getGraphemeBreakType($e.nextCodePoint());if(fe(Re,We)){$e.setOffset(ze);break}Re=We}return $e.offset-ve}prevGraphemeLength(){const ne=Te.getInstance(),$e=this.c,ve=$e.offset;let Re=ne.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const ze=$e.offset,We=ne.getGraphemeBreakType($e.prevCodePoint());if(fe(We,Re)){$e.setOffset(ze);break}Re=We}return ve-$e.offset}eol(){return this.c.eol()}}t.$Hf=ue;function re(Y,ne){return new ue(Y,ne).nextGraphemeLength()}function ye(Y,ne){return new ue(Y,ne).prevGraphemeLength()}function H(Y,ne){ne>0&&De(Y.charCodeAt(ne))&&ne--;const $e=ne+re(Y,ne);return[$e-ye(Y,$e),$e]}function J(Y){const ne=new ue(Y);let $e=0;for(;!ne.eol();)$e++,ne.nextGraphemeLength();return $e}let ge;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(Y){return ge||(ge=we()),ge.test(Y)}const Fe=/^[\t\n\r\x20-\x7E]*$/;function Ie(Y){return Fe.test(Y)}t.$Of=/[\u2028\u2029]/;function z(Y){return t.$Of.test(Y)}function u(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}function y(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}function a(Y,ne,$e=""){const ve=Y.trimStart();if(ve.length<ne)return ve;const Re=/\b/g;let ze=0;for(;Re.test(ve)&&!(ve.length-Re.lastIndex<ne);)ze=Re.lastIndex,Re.lastIndex+=1;return ze===0?ve:$e+ve.substring(ze).trimStart()}const v=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*N(Y){let ne=0;for(const $e of Y.matchAll(v))ne!==$e.index&&(yield{isCode:!1,str:Y.substring(ne,$e.index)}),yield{isCode:!0,str:$e[0]},ne=$e.index+$e[0].length;ne!==Y.length&&(yield{isCode:!1,str:Y.substring(ne)})}function s(Y){return Y&&(Y=Y.replace(v,"")),Y}t.$Vf="\uFEFF";function D(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}function w(Y){return D(Y)?Y.substr(1):Y}function L(Y,ne){if(!Y||!ne||Y.length<ne.length)return!1;const $e=ne.length,ve=Y.toLowerCase();let Re=0,ze=-1;for(;Re<$e;){const We=ve.indexOf(ne[Re],ze+1);if(We<0)return!1;ze=We,Re++}return!0}function j(Y,ne=!1){return Y?(ne&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}function X(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}function Z(Y,ne=1){if(ne===0)return"";let $e=-1;do $e=Y.indexOf(`
`,$e+1),ne--;while(ne>0&&$e>=0);return $e===-1?Y:(Y[$e-1]==="\r"&&$e--,Y.substr(0,$e))}function oe(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}function pe(Y){return Te.getInstance().getGraphemeBreakType(Y)}function fe(Y,ne){return Y===0?ne!==5&&ne!==7:Y===2&&ne===3?!1:Y===4||Y===2||Y===3||ne===4||ne===2||ne===3?!0:!(Y===8&&(ne===8||ne===9||ne===11||ne===12)||(Y===11||Y===9)&&(ne===9||ne===10)||(Y===12||Y===10)&&ne===10||ne===5||ne===13||ne===7||Y===1||Y===13&&ne===14||Y===6&&ne===6)}var Le;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(t.GraphemeBreakType=Le={}));class Te{static{this.c=null}static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=Oe()}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const $e=this.d,ve=$e.length/3;let Re=1;for(;Re<=ve;)if(ne<$e[3*Re])Re=2*Re;else if(ne>$e[3*Re+1])Re=2*Re+1;else return $e[3*Re+2];return 0}}function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(Y,ne){if(Y===0)return 0;const $e=Ce(Y,ne);if($e!==void 0)return $e;const ve=new _(ne,Y);return ve.prevCodePoint(),ve.offset}function Ce(Y,ne){const $e=new _(ne,Y);let ve=$e.prevCodePoint();for(;He(ve)||ve===65039||ve===8419;){if($e.offset===0)return;ve=$e.prevCodePoint()}if(!y(ve))return;let Re=$e.offset;return Re>0&&$e.prevCodePoint()===8205&&(Re=$e.offset),Re}function He(Y){return 127995<=Y&&Y<=127999}var Ue;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),t.$6f="\xA0";class Xe{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$4e({getCacheKey:JSON.stringify},ne=>{function $e(Je){const rt=new Map;for(let tt=0;tt<Je.length;tt+=2)rt.set(Je[tt],Je[tt+1]);return rt}function ve(Je,rt){const tt=new Map(Je);for(const[mt,gt]of rt)tt.set(mt,gt);return tt}function Re(Je,rt){if(!Je)return rt;const tt=new Map;for(const[mt,gt]of Je)rt.has(mt)&&tt.set(mt,gt);return tt}const ze=this.c.value;let We=ne.filter(Je=>!Je.startsWith("_")&&Je in ze);We.length===0&&(We=["_default"]);let et;for(const Je of We){const rt=$e(ze[Je]);et=Re(et,rt)}const it=$e(ze._common),st=ve(it,et);return new Xe(st)})}static getInstance(ne){return Xe.d.get(Array.from(ne))}static{this.e=new C.$V(()=>Object.keys(Xe.c.value).filter(ne=>!ne.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(ne){this.f=ne}isAmbiguous(ne){return this.f.has(ne)}getPrimaryConfusable(ne){return this.f.get(ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$7f=Xe;class _e{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(_e.c())),this.d}static isInvisibleCharacter(ne){return _e.e().has(ne)}static get codePoints(){return _e.e()}}t.$8f=_e}),define(me[44],be([1,0,39,89,9]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jk=t.FuzzyScore=t.$yk=t.$xk=void 0,t.or=Q,t.$zk=T,t.$Ak=d,t.$Bk=P,t.$Ck=W,t.$Dk=p,t.$Ek=G,t.$Fk=q,t.$Gk=ae,t.$Hk=ie,t.$Ik=ke,t.$Kk=u,t.$Lk=v,t.$Mk=N;function Q(...w){return function(L,j){for(let X=0,Z=w.length;X<Z;X++){const oe=w[X](L,j);if(oe)return oe}return null}}t.$xk=A.bind(void 0,!1),t.$yk=A.bind(void 0,!0);function A(w,L,j){if(!j||j.length<L.length)return null;let X;return w?X=B.$zf(j,L):X=j.indexOf(L)===0,X?L.length>0?[{start:0,end:L.length}]:[]:null}function T(w,L){const j=L.toLowerCase().indexOf(w.toLowerCase());return j===-1?null:[{start:j,end:j+w.length}]}function d(w,L){return g(w.toLowerCase(),L.toLowerCase(),0,0)}function g(w,L,j,X){if(j===w.length)return[];if(X===L.length)return null;if(w[j]===L[X]){let Z=null;return(Z=g(w,L,j+1,X+1))?m({start:X,end:X+1},Z):null}return g(w,L,j,X+1)}function $(w){return 97<=w&&w<=122}function P(w){return 65<=w&&w<=90}function c(w){return 48<=w&&w<=57}function h(w){return w===32||w===9||w===10||w===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(w=>e.add(w.charCodeAt(0)));function n(w){return h(w)||e.has(w)}function o(w,L){return w===L||n(w)&&n(L)}const l=new Map;function f(w){if(l.has(w))return l.get(w);let L;const j=(0,C.$vk)(w);return j&&(L=j),l.set(w,L),L}function S(w){return $(w)||P(w)||c(w)}function m(w,L){return L.length===0?L=[w]:w.end===L[0].start?L[0].start=w.start:L.unshift(w),L}function b(w,L){for(let j=L;j<w.length;j++){const X=w.charCodeAt(j);if(P(X)||c(X)||j>0&&!S(w.charCodeAt(j-1)))return j}return w.length}function r(w,L,j,X){if(j===w.length)return[];if(X===L.length)return null;if(w[j]!==L[X].toLowerCase())return null;{let Z=null,oe=X+1;for(Z=r(w,L,j+1,X+1);!Z&&(oe=b(L,oe))<L.length;)Z=r(w,L,j+1,oe),oe++;return Z===null?null:m({start:X,end:X+1},Z)}}function E(w){let L=0,j=0,X=0,Z=0,oe=0;for(let Oe=0;Oe<w.length;Oe++)oe=w.charCodeAt(Oe),P(oe)&&L++,$(oe)&&j++,S(oe)&&X++,c(oe)&&Z++;const pe=L/w.length,fe=j/w.length,Le=X/w.length,Te=Z/w.length;return{upperPercent:pe,lowerPercent:fe,alphaPercent:Le,numericPercent:Te}}function k(w){const{upperPercent:L,lowerPercent:j}=w;return j===0&&L>.6}function F(w){const{upperPercent:L,lowerPercent:j,alphaPercent:X,numericPercent:Z}=w;return j>.2&&L<.8&&X>.6&&Z<.2}function M(w){let L=0,j=0,X=0,Z=0;for(let oe=0;oe<w.length;oe++)X=w.charCodeAt(oe),P(X)&&L++,$(X)&&j++,h(X)&&Z++;return(L===0||j===0)&&Z===0?w.length<=30:L<=5}function W(w,L){if(!L||(L=L.trim(),L.length===0)||!M(w))return null;L.length>60&&(L=L.substring(0,60));const j=E(L);if(!F(j)){if(!k(j))return null;L=L.toLowerCase()}let X=null,Z=0;for(w=w.toLowerCase();Z<L.length&&(X=r(w,L,0,Z))===null;)Z=b(L,Z+1);return X}function p(w,L,j=!1){if(!L||L.length===0)return null;let X=null,Z=0;for(w=w.toLowerCase(),L=L.toLowerCase();Z<L.length&&(X=I(w,L,0,Z,j),X===null);)Z=V(L,Z+1);return X}function I(w,L,j,X,Z){let oe=0;if(j===w.length)return[];if(X===L.length)return null;if(!o(w.charCodeAt(j),L.charCodeAt(X))){const Le=f(w.charCodeAt(j));if(!Le)return null;for(let Te=0;Te<Le.length;Te++)if(!o(Le[Te],L.charCodeAt(X+Te)))return null;oe+=Le.length-1}let pe=null,fe=X+oe+1;if(pe=I(w,L,j+1,fe,Z),!Z)for(;!pe&&(fe=V(L,fe))<L.length;)pe=I(w,L,j+1,fe,Z),fe++;if(!pe)return null;if(w.charCodeAt(j)!==L.charCodeAt(X)){const Le=f(w.charCodeAt(j));if(!Le)return pe;for(let Te=0;Te<Le.length;Te++)if(Le[Te]!==L.charCodeAt(X+Te))return pe}return m({start:X,end:X+oe+1},pe)}function V(w,L){for(let j=L;j<w.length;j++)if(n(w.charCodeAt(j))||j>0&&n(w.charCodeAt(j-1)))return j;return w.length}const R=Q(t.$yk,W,T),x=Q(t.$yk,W,d),O=new i.$Ec(1e4);function G(w,L,j=!1){if(typeof w!="string"||typeof L!="string")return null;let X=O.get(w);X||(X=new RegExp(B.$hf(w),"i"),O.set(w,X));const Z=X.exec(L);return Z?[{start:Z.index,end:Z.index+Z[0].length}]:j?x(w,L):R(w,L)}function q(w,L){const j=u(w,w.toLowerCase(),0,L,L.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?ie(j):null}function ae(w,L,j,X,Z,oe){const pe=Math.min(13,w.length);for(;j<pe;j++){const fe=u(w,L,j,X,Z,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,oe]}function ie(w){if(typeof w>"u")return[];const L=[],j=w[1];for(let X=w.length-1;X>1;X--){const Z=w[X]+j,oe=L[L.length-1];oe&&oe.end===Z?oe.end=Z+1:L.push({start:Z,end:Z+1})}return L}const ee=128;function ce(){const w=[],L=[];for(let j=0;j<=ee;j++)L[j]=0;for(let j=0;j<=ee;j++)w.push(L.slice(0));return w}function De(w){const L=[];for(let j=0;j<=w;j++)L[j]=0;return L}const Ee=De(2*ee),Me=De(2*ee),le=ce(),_=ce(),ue=ce(),re=!1;function ye(w,L,j,X,Z){function oe(fe,Le,Te=" "){for(;fe.length<Le;)fe=Te+fe;return fe}let pe=` |   |${X.split("").map(fe=>oe(fe,3)).join("|")}
`;for(let fe=0;fe<=j;fe++)fe===0?pe+=" |":pe+=`${L[fe-1]}|`,pe+=w[fe].slice(0,Z+1).map(Le=>oe(Le.toString(),3)).join("|")+`
`;return pe}function H(w,L,j,X){w=w.substr(L),j=j.substr(X),console.log(ye(_,w,w.length,j,j.length)),console.log(ye(ue,w,w.length,j,j.length)),console.log(ye(le,w,w.length,j,j.length))}function J(w,L){if(L<0||L>=w.length)return!1;const j=w.codePointAt(L);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!B.$Rf(j)}}function ge(w,L){if(L<0||L>=w.length)return!1;switch(w.charCodeAt(L)){case 32:case 9:return!0;default:return!1}}function we(w,L,j){return L[w]!==j[w]}function ke(w,L,j,X,Z,oe,pe=!1){for(;L<j&&Z<oe;)w[L]===X[Z]&&(pe&&(Ee[L]=Z),L+=1),Z+=1;return L===j}var Fe;(function(w){w[w.Diag=1]="Diag",w[w.Left=2]="Left",w[w.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var Ie;(function(w){w.Default=[-100,0];function L(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}w.isDefault=L})(Ie||(t.FuzzyScore=Ie={}));class z{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(L,j){this.firstMatchCanBeWeak=L,this.boostFullMatch=j}}t.$Jk=z;function u(w,L,j,X,Z,oe,pe=z.default){const fe=w.length>ee?ee:w.length,Le=X.length>ee?ee:X.length;if(j>=fe||oe>=Le||fe-j>Le-oe||!ke(L,j,fe,Z,oe,Le,!0))return;y(fe,Le,j,oe,L,Z);let Te=1,Oe=1,Se=j,Ce=oe;const He=[!1];for(Te=1,Se=j;Se<fe;Te++,Se++){const ne=Ee[Se],$e=Me[Se],ve=Se+1<fe?Me[Se+1]:Le;for(Oe=ne-oe+1,Ce=ne;Ce<ve;Oe++,Ce++){let Re=Number.MIN_SAFE_INTEGER,ze=!1;Ce<=$e&&(Re=a(w,L,Se,j,X,Z,Ce,Le,oe,le[Te-1][Oe-1]===0,He));let We=0;Re!==Number.MAX_SAFE_INTEGER&&(ze=!0,We=Re+_[Te-1][Oe-1]);const et=Ce>ne,it=et?_[Te][Oe-1]+(le[Te][Oe-1]>0?-5:0):0,st=Ce>ne+1&&le[Te][Oe-1]>0,Je=st?_[Te][Oe-2]+(le[Te][Oe-2]>0?-5:0):0;if(st&&(!et||Je>=it)&&(!ze||Je>=We))_[Te][Oe]=Je,ue[Te][Oe]=3,le[Te][Oe]=0;else if(et&&(!ze||it>=We))_[Te][Oe]=it,ue[Te][Oe]=2,le[Te][Oe]=0;else if(ze)_[Te][Oe]=We,ue[Te][Oe]=1,le[Te][Oe]=le[Te-1][Oe-1]+1;else throw new Error("not possible")}}if(re&&H(w,j,X,oe),!He[0]&&!pe.firstMatchCanBeWeak)return;Te--,Oe--;const Ue=[_[Te][Oe],oe];let Xe=0,_e=0;for(;Te>=1;){let ne=Oe;do{const $e=ue[Te][ne];if($e===3)ne=ne-2;else if($e===2)ne=ne-1;else break}while(ne>=1);Xe>1&&L[j+Te-1]===Z[oe+Oe-1]&&!we(ne+oe-1,X,Z)&&Xe+1>le[Te][ne]&&(ne=Oe),ne===Oe?Xe++:Xe=1,_e||(_e=ne),Te--,Oe=ne-1,Ue.push(Oe)}Le===fe&&pe.boostFullMatch&&(Ue[0]+=2);const Y=_e-fe;return Ue[0]-=Y,Ue}function y(w,L,j,X,Z,oe){let pe=w-1,fe=L-1;for(;pe>=j&&fe>=X;)Z[pe]===oe[fe]&&(Me[pe]=fe,pe--),fe--}function a(w,L,j,X,Z,oe,pe,fe,Le,Te,Oe){if(L[j]!==oe[pe])return Number.MIN_SAFE_INTEGER;let Se=1,Ce=!1;return pe===j-X?Se=w[j]===Z[pe]?7:5:we(pe,Z,oe)&&(pe===0||!we(pe-1,Z,oe))?(Se=w[j]===Z[pe]?7:5,Ce=!0):J(oe,pe)&&(pe===0||!J(oe,pe-1))?Se=5:(J(oe,pe-1)||ge(oe,pe-1))&&(Se=5,Ce=!0),Se>1&&j===X&&(Oe[0]=!0),Ce||(Ce=we(pe,Z,oe)||J(oe,pe-1)||ge(oe,pe-1)),j===X?pe>Le&&(Se-=Ce?3:5):Te?Se+=Ce?2:0:Se+=Ce?0:1,pe+1===fe&&(Se-=Ce?3:5),Se}function v(w,L,j,X,Z,oe,pe){return s(w,L,j,X,Z,oe,!0,pe)}function N(w,L,j,X,Z,oe,pe){return s(w,L,j,X,Z,oe,!1,pe)}function s(w,L,j,X,Z,oe,pe,fe){let Le=u(w,L,j,X,Z,oe,fe);if(Le&&!pe)return Le;if(w.length>=3){const Te=Math.min(7,w.length-1);for(let Oe=j+1;Oe<Te;Oe++){const Se=D(w,Oe);if(Se){const Ce=u(Se,Se.toLowerCase(),j,X,Z,oe,fe);Ce&&(Ce[0]-=3,(!Le||Ce[0]>Le[0])&&(Le=Ce))}}}return Le}function D(w,L){if(L+1>=w.length)return;const j=w[L],X=w[L+1];if(j!==X)return w.slice(0,L)+X+j+w.slice(L+2)}}),define(me[59],be([1,0,9]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qj=t.$oj=void 0,t.$kj=C,t.$lj=B,t.$mj=Q,t.$nj=T,t.$pj=n;function C(l){return B(l,0)}function B(l,f){switch(typeof l){case"object":return l===null?Q(349,f):Array.isArray(l)?d(l,f):g(l,f);case"string":return T(l,f);case"boolean":return A(l,f);case"number":return Q(l,f);case"undefined":return Q(937,f);default:return Q(617,f)}}function Q(l,f){return(f<<5)-f+l|0}function A(l,f){return Q(l?433:863,f)}function T(l,f){f=Q(149417,f);for(let S=0,m=l.length;S<m;S++)f=Q(l.charCodeAt(S),f);return f}function d(l,f){return f=Q(104579,f),l.reduce((S,m)=>B(m,S),f)}function g(l,f){return f=Q(181387,f),Object.keys(l).sort().reduce((S,m)=>(S=T(m,S),B(l[m],S)),f)}class ${constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=B(f,this.g),this.g}}t.$oj=$;var P;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function c(l,f,S=32){const m=S-f,b=~((1<<m)-1);return(l<<f|(b&l)>>>m)>>>0}function h(l,f=0,S=l.byteLength,m=0){for(let b=0;b<S;b++)l[f+b]=m}function e(l,f,S="0"){for(;l.length<f;)l=S+l;return l}function n(l,f=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(S=>S.toString(16).padStart(2,"0")).join(""):e((l>>>0).toString(16),f/4)}class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const S=f.length;if(S===0)return;const m=this.p;let b=this.r,r=this.u,E,k;for(r!==0?(E=r,k=-1,r=0):(E=f.charCodeAt(0),k=0);;){let F=E;if(i.$Cf(E))if(k+1<S){const M=f.charCodeAt(k+1);i.$Df(M)?(k++,F=i.$Ef(E,M)):F=65533}else{r=E;break}else i.$Df(E)&&(F=65533);if(b=this.w(m,b,F),k++,k<S)E=f.charCodeAt(k);else break}this.r=b,this.u=r}w(f,S,m){return m<128?f[S++]=m:m<2048?(f[S++]=192|(m&1984)>>>6,f[S++]=128|(m&63)>>>0):m<65536?(f[S++]=224|(m&61440)>>>12,f[S++]=128|(m&4032)>>>6,f[S++]=128|(m&63)>>>0):(f[S++]=240|(m&1835008)>>>18,f[S++]=128|(m&258048)>>>12,f[S++]=128|(m&4032)>>>6,f[S++]=128|(m&63)>>>0),S>=64&&(this.y(),S-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),S}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),n(this.h)+n(this.l)+n(this.m)+n(this.n)+n(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=o.g,S=this.q;for(let p=0;p<64;p+=4)f.setUint32(p,S.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)f.setUint32(p,c(f.getUint32(p-12,!1)^f.getUint32(p-32,!1)^f.getUint32(p-56,!1)^f.getUint32(p-64,!1),1),!1);let m=this.h,b=this.l,r=this.m,E=this.n,k=this.o,F,M,W;for(let p=0;p<80;p++)p<20?(F=b&r|~b&E,M=1518500249):p<40?(F=b^r^E,M=1859775393):p<60?(F=b&r|b&E|r&E,M=2400959708):(F=b^r^E,M=3395469782),W=c(m,5)+F+k+M+f.getUint32(p*4,!1)&4294967295,k=E,E=r,r=c(b,30),b=m,m=W;this.h=this.h+m&4294967295,this.l=this.l+b&4294967295,this.m=this.m+r&4294967295,this.n=this.n+E&4294967295,this.o=this.o+k&4294967295}}t.$qj=o}),define(me[98],be([1,0,85,59]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$At=t.$yt=void 0,t.$zt=Q;class B{constructor(c){this.a=c}getElements(){const c=this.a,h=new Int32Array(c.length);for(let e=0,n=c.length;e<n;e++)h[e]=c.charCodeAt(e);return h}}t.$yt=B;function Q(P,c,h){return new $(new B(P),new B(c)).ComputeDiff(h).changes}class A{static Assert(c,h){if(!c)throw new Error(h)}}class T{static Copy(c,h,e,n,o){for(let l=0;l<o;l++)e[n+l]=c[h+l]}static Copy2(c,h,e,n,o){for(let l=0;l<o;l++)e[n+l]=c[h+l]}}var d;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(d||(d={}));class g{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$xt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(c,h){this.b=Math.min(this.b,c),this.c=Math.min(this.c,h),this.d++}AddModifiedElement(c,h){this.b=Math.min(this.b,c),this.c=Math.min(this.c,h),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class ${constructor(c,h,e=null){this.a=e,this.b=c,this.c=h;const[n,o,l]=$.o(c),[f,S,m]=$.o(h);this.d=l&&m,this.e=n,this.f=o,this.g=f,this.h=S,this.k=[],this.m=[]}static n(c){return c.length>0&&typeof c[0]=="string"}static o(c){const h=c.getElements();if($.n(h)){const e=new Int32Array(h.length);for(let n=0,o=h.length;n<o;n++)e[n]=(0,C.$nj)(h[n],0);return[h,e,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}p(c,h){return this.f[c]!==this.h[h]?!1:this.d?this.e[c]===this.g[h]:!0}q(c,h){if(!this.p(c,h))return!1;const e=$.r(this.b,c),n=$.r(this.c,h);return e===n}static r(c,h){return typeof c.getStrictElement=="function"?c.getStrictElement(h):null}s(c,h){return this.f[c]!==this.f[h]?!1:this.d?this.e[c]===this.e[h]:!0}u(c,h){return this.h[c]!==this.h[h]?!1:this.d?this.g[c]===this.g[h]:!0}ComputeDiff(c){return this.v(0,this.f.length-1,0,this.h.length-1,c)}v(c,h,e,n,o){const l=[!1];let f=this.w(c,h,e,n,l);return o&&(f=this.z(f)),{quitEarly:l[0],changes:f}}w(c,h,e,n,o){for(o[0]=!1;c<=h&&e<=n&&this.p(c,e);)c++,e++;for(;h>=c&&n>=e&&this.p(h,n);)h--,n--;if(c>h||e>n){let r;return e<=n?(A.Assert(c===h+1,"originalStart should only be one more than originalEnd"),r=[new i.$xt(c,0,e,n-e+1)]):c<=h?(A.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),r=[new i.$xt(c,h-c+1,e,0)]):(A.Assert(c===h+1,"originalStart should only be one more than originalEnd"),A.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const l=[0],f=[0],S=this.y(c,h,e,n,l,f,o),m=l[0],b=f[0];if(S!==null)return S;if(!o[0]){const r=this.w(c,m,e,b,o);let E=[];return o[0]?E=[new i.$xt(m+1,h-(m+1)+1,b+1,n-(b+1)+1)]:E=this.w(m+1,h,b+1,n,o),this.H(r,E)}return[new i.$xt(c,h-c+1,e,n-e+1)]}x(c,h,e,n,o,l,f,S,m,b,r,E,k,F,M,W,p,I){let V=null,R=null,x=new g,O=h,G=e,q=k[0]-W[0]-n,ae=-1073741824,ie=this.k.length-1;do{const ee=q+c;ee===O||ee<G&&m[ee-1]<m[ee+1]?(r=m[ee+1],F=r-q-n,r<ae&&x.MarkNextChange(),ae=r,x.AddModifiedElement(r+1,F),q=ee+1-c):(r=m[ee-1]+1,F=r-q-n,r<ae&&x.MarkNextChange(),ae=r-1,x.AddOriginalElement(r,F+1),q=ee-1-c),ie>=0&&(m=this.k[ie],c=m[0],O=1,G=m.length-1)}while(--ie>=-1);if(V=x.getReverseChanges(),I[0]){let ee=k[0]+1,ce=W[0]+1;if(V!==null&&V.length>0){const De=V[V.length-1];ee=Math.max(ee,De.getOriginalEnd()),ce=Math.max(ce,De.getModifiedEnd())}R=[new i.$xt(ee,E-ee+1,ce,M-ce+1)]}else{x=new g,O=l,G=f,q=k[0]-W[0]-S,ae=1073741824,ie=p?this.m.length-1:this.m.length-2;do{const ee=q+o;ee===O||ee<G&&b[ee-1]>=b[ee+1]?(r=b[ee+1]-1,F=r-q-S,r>ae&&x.MarkNextChange(),ae=r+1,x.AddOriginalElement(r+1,F+1),q=ee+1-o):(r=b[ee-1],F=r-q-S,r>ae&&x.MarkNextChange(),ae=r,x.AddModifiedElement(r+1,F+1),q=ee-1-o),ie>=0&&(b=this.m[ie],o=b[0],O=1,G=b.length-1)}while(--ie>=-1);R=x.getChanges()}return this.H(V,R)}y(c,h,e,n,o,l,f){let S=0,m=0,b=0,r=0,E=0,k=0;c--,e--,o[0]=0,l[0]=0,this.k=[],this.m=[];const F=h-c+(n-e),M=F+1,W=new Int32Array(M),p=new Int32Array(M),I=n-e,V=h-c,R=c-e,x=h-n,G=(V-I)%2===0;W[I]=c,p[V]=h,f[0]=!1;for(let q=1;q<=F/2+1;q++){let ae=0,ie=0;b=this.J(I-q,q,I,M),r=this.J(I+q,q,I,M);for(let ce=b;ce<=r;ce+=2){ce===b||ce<r&&W[ce-1]<W[ce+1]?S=W[ce+1]:S=W[ce-1]+1,m=S-(ce-I)-R;const De=S;for(;S<h&&m<n&&this.p(S+1,m+1);)S++,m++;if(W[ce]=S,S+m>ae+ie&&(ae=S,ie=m),!G&&Math.abs(ce-V)<=q-1&&S>=p[ce])return o[0]=S,l[0]=m,De<=p[ce]&&1447>0&&q<=1448?this.x(I,b,r,R,V,E,k,x,W,p,S,h,o,m,n,l,G,f):null}const ee=(ae-c+(ie-e)-q)/2;if(this.a!==null&&!this.a(ae,ee))return f[0]=!0,o[0]=ae,l[0]=ie,ee>0&&1447>0&&q<=1448?this.x(I,b,r,R,V,E,k,x,W,p,S,h,o,m,n,l,G,f):(c++,e++,[new i.$xt(c,h-c+1,e,n-e+1)]);E=this.J(V-q,q,V,M),k=this.J(V+q,q,V,M);for(let ce=E;ce<=k;ce+=2){ce===E||ce<k&&p[ce-1]>=p[ce+1]?S=p[ce+1]-1:S=p[ce-1],m=S-(ce-V)-x;const De=S;for(;S>c&&m>e&&this.p(S,m);)S--,m--;if(p[ce]=S,G&&Math.abs(ce-I)<=q&&S<=W[ce])return o[0]=S,l[0]=m,De>=W[ce]&&1447>0&&q<=1448?this.x(I,b,r,R,V,E,k,x,W,p,S,h,o,m,n,l,G,f):null}if(q<=1447){let ce=new Int32Array(r-b+2);ce[0]=I-b+1,T.Copy2(W,b,ce,1,r-b+1),this.k.push(ce),ce=new Int32Array(k-E+2),ce[0]=V-E+1,T.Copy2(p,E,ce,1,k-E+1),this.m.push(ce)}}return this.x(I,b,r,R,V,E,k,x,W,p,S,h,o,m,n,l,G,f)}z(c){for(let h=0;h<c.length;h++){const e=c[h],n=h<c.length-1?c[h+1].originalStart:this.f.length,o=h<c.length-1?c[h+1].modifiedStart:this.h.length,l=e.originalLength>0,f=e.modifiedLength>0;for(;e.originalStart+e.originalLength<n&&e.modifiedStart+e.modifiedLength<o&&(!l||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!f||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const m=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!m)break;e.originalStart++,e.modifiedStart++}const S=[null];if(h<c.length-1&&this.I(c[h],c[h+1],S)){c[h]=S[0],c.splice(h+1,1),h--;continue}}for(let h=c.length-1;h>=0;h--){const e=c[h];let n=0,o=0;if(h>0){const r=c[h-1];n=r.originalStart+r.originalLength,o=r.modifiedStart+r.modifiedLength}const l=e.originalLength>0,f=e.modifiedLength>0;let S=0,m=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const E=e.originalStart-r,k=e.modifiedStart-r;if(E<n||k<o||l&&!this.s(E,E+e.originalLength)||f&&!this.u(k,k+e.modifiedLength))break;const M=(E===n&&k===o?5:0)+this.G(E,e.originalLength,k,e.modifiedLength);M>m&&(m=M,S=r)}e.originalStart-=S,e.modifiedStart-=S;const b=[null];if(h>0&&this.I(c[h-1],c[h],b)){c[h-1]=b[0],c.splice(h,1),h++;continue}}if(this.d)for(let h=1,e=c.length;h<e;h++){const n=c[h-1],o=c[h],l=o.originalStart-n.originalStart-n.originalLength,f=n.originalStart,S=o.originalStart+o.originalLength,m=S-f,b=n.modifiedStart,r=o.modifiedStart+o.modifiedLength,E=r-b;if(l<5&&m<20&&E<20){const k=this.A(f,m,b,E,l);if(k){const[F,M]=k;(F!==n.originalStart+n.originalLength||M!==n.modifiedStart+n.modifiedLength)&&(n.originalLength=F-n.originalStart,n.modifiedLength=M-n.modifiedStart,o.originalStart=F+l,o.modifiedStart=M+l,o.originalLength=S-o.originalStart,o.modifiedLength=r-o.modifiedStart)}}}return c}A(c,h,e,n,o){if(h<o||n<o)return null;const l=c+h-o+1,f=e+n-o+1;let S=0,m=0,b=0;for(let r=c;r<l;r++)for(let E=e;E<f;E++){const k=this.B(r,E,o);k>0&&k>S&&(S=k,m=r,b=E)}return S>0?[m,b]:null}B(c,h,e){let n=0;for(let o=0;o<e;o++){if(!this.p(c+o,h+o))return 0;n+=this.e[c+o].length}return n}C(c){return c<=0||c>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[c])}D(c,h){if(this.C(c)||this.C(c-1))return!0;if(h>0){const e=c+h;if(this.C(e-1)||this.C(e))return!0}return!1}E(c){return c<=0||c>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[c])}F(c,h){if(this.E(c)||this.E(c-1))return!0;if(h>0){const e=c+h;if(this.E(e-1)||this.E(e))return!0}return!1}G(c,h,e,n){const o=this.D(c,h)?1:0,l=this.F(e,n)?1:0;return o+l}H(c,h){const e=[];if(c.length===0||h.length===0)return h.length>0?h:c;if(this.I(c[c.length-1],h[0],e)){const n=new Array(c.length+h.length-1);return T.Copy(c,0,n,0,c.length-1),n[c.length-1]=e[0],T.Copy(h,1,n,c.length,h.length-1),n}else{const n=new Array(c.length+h.length);return T.Copy(c,0,n,0,c.length),T.Copy(h,0,n,c.length,h.length),n}}I(c,h,e){if(A.Assert(c.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),A.Assert(c.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=h.originalStart||c.modifiedStart+c.modifiedLength>=h.modifiedStart){const n=c.originalStart;let o=c.originalLength;const l=c.modifiedStart;let f=c.modifiedLength;return c.originalStart+c.originalLength>=h.originalStart&&(o=h.originalStart+h.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=h.modifiedStart&&(f=h.modifiedStart+h.modifiedLength-c.modifiedStart),e[0]=new i.$xt(n,o,l,f),!0}else return e[0]=null,!1}J(c,h,e,n){if(c>=0&&c<n)return c;const o=e,l=n-e-1,f=h%2===0;if(c<0){const S=o%2===0;return f===S?0:1}else{const S=l%2===0;return f===S?n-1:n-2}}}t.$At=$}),define(me[60],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=void 0,t.$be=Symbol("MicrotaskDelay")}),define(me[99],be([1,0,8,9]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ci=t.$Bi=t.$Ai=t.$zi=t.$yi=void 0;class B{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const e=h.charCodeAt(0),n=this.b.charCodeAt(this.c);return e-n}value(){return this.b[this.c]}}t.$yi=B;class Q{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,C.$sf)(h,this.b,0,h.length,this.c,this.d):(0,C.$uf)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$zi=Q;class A{constructor(h=!0,e=!0){this.f=h,this.g=e}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let e=h.length-1;e>=0;e--,this.c--){const n=this.b.charCodeAt(e);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,C.$sf)(h,this.b,0,h.length,this.d,this.e):(0,C.$uf)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Ai=A;var T;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(T||(T={}));class d{constructor(h,e){this.f=h,this.g=e,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,C.$tf)(h,this.c.scheme);if(this.d[this.e]===2)return(0,C.$tf)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,C.$rf)(h,this.c.query);if(this.d[this.e]===5)return(0,C.$rf)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Bi=d;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})($||($={}));class P{static forUris(h=()=>!1,e=()=>!1){return new P(new d(h,e))}static forPaths(h=!1){return new P(new A(void 0,!h))}static forStrings(){return new P(new B)}static forConfigKeys(){return new P(new Q)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,e){if(e){const n=e.slice(0);(0,i.$Xb)(n);for(const o of n)this.set(o,h)}else{const n=h.slice(0);(0,i.$Xb)(n);for(const o of n)this.set(o[0],o[1])}}set(h,e){const n=this.b.reset(h);let o;this.c||(this.c=new g,this.c.segment=n.value());const l=[];for(o=this.c;;){const S=n.cmp(o.segment);if(S>0)o.left||(o.left=new g,o.left.segment=n.value()),l.push([-1,o]),o=o.left;else if(S<0)o.right||(o.right=new g,o.right.segment=n.value()),l.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new g,o.mid.segment=n.value()),l.push([0,o]),o=o.mid;else break}const f=o.value;o.value=e,o.key=h;for(let S=l.length-1;S>=0;S--){const m=l[S][1];m.updateHeight();const b=m.balanceFactor();if(b<-1||b>1){const r=l[S][0],E=l[S+1][0];if(r===1&&E===1)l[S][1]=m.rotateLeft();else if(r===-1&&E===-1)l[S][1]=m.rotateRight();else if(r===1&&E===-1)m.right=l[S+1][1]=l[S+1][1].rotateRight(),l[S][1]=m.rotateLeft();else if(r===-1&&E===1)m.left=l[S+1][1]=l[S+1][1].rotateLeft(),l[S][1]=m.rotateRight();else throw new Error;if(S>0)switch(l[S-1][0]){case-1:l[S-1][1].left=l[S][1];break;case 1:l[S-1][1].right=l[S][1];break;case 0:l[S-1][1].mid=l[S][1];break}else this.c=l[0][1]}}return f}get(h){return this.d(h)?.value}d(h){const e=this.b.reset(h);let n=this.c;for(;n;){const o=e.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(e.hasNext())e.next(),n=n.mid;else break}return n}has(h){const e=this.d(h);return!(e?.value===void 0&&e?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,e){const n=this.b.reset(h),o=[];let l=this.c;for(;l;){const f=n.cmp(l.segment);if(f>0)o.push([-1,l]),l=l.left;else if(f<0)o.push([1,l]),l=l.right;else if(n.hasNext())n.next(),o.push([0,l]),l=l.mid;else break}if(l){if(e?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const f=this.f(l.right);if(f.key){const{key:S,value:m,segment:b}=f;this.e(f.key,!1),l.key=S,l.value=m,l.segment=b}}else{const f=l.left??l.right;if(o.length>0){const[S,m]=o[o.length-1];switch(S){case-1:m.left=f;break;case 0:m.mid=f;break;case 1:m.right=f;break}}else this.c=f}for(let f=o.length-1;f>=0;f--){const S=o[f][1];S.updateHeight();const m=S.balanceFactor();if(m>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),o[f][1]=S.rotateLeft()):m<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),o[f][1]=S.rotateRight()),f>0)switch(o[f-1][0]){case-1:o[f-1][1].left=o[f][1];break;case 1:o[f-1][1].right=o[f][1];break;case 0:o[f-1][1].mid=o[f][1];break}else this.c=o[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const e=this.b.reset(h);let n=this.c,o;for(;n;){const l=e.cmp(n.segment);if(l>0)n=n.left;else if(l<0)n=n.right;else if(e.hasNext())e.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(h){return this.g(h,!1)}g(h,e){const n=this.b.reset(h);let o=this.c;for(;o;){const l=n.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this.h(o.mid):e?o.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[e,n]of this)h(n,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const e=[];return this.j(h,e),e[Symbol.iterator]()}j(h,e){h&&(h.left&&this.j(h.left,e),h.value&&e.push([h.key,h.value]),h.mid&&this.j(h.mid,e),h.right&&this.j(h.right,e))}_isBalanced(){const h=e=>{if(!e)return!0;const n=e.balanceFactor();return n<-1||n>1?!1:h(e.left)&&h(e.right)};return h(this.c)}}t.$Ci=P}),define(me[10],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9f=i,t.$0f=C,t.$$f=B,t.$_f=Q,t.$ag=A,t.$bg=T,t.$cg=d,t.$dg=g,t.$eg=$,t.$fg=P,t.$gg=c,t.$hg=h,t.$ig=e,t.$jg=o,t.$kg=l,t.$lg=f,t.$mg=S,t.$ng=m;function i(b){return typeof b=="string"}function C(b){return Array.isArray(b)&&b.every(r=>i(r))}function B(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}function Q(b){const r=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof r}function A(b){return typeof b=="number"&&!isNaN(b)}function T(b){return!!b&&typeof b[Symbol.iterator]=="function"}function d(b){return b===!0||b===!1}function g(b){return typeof b>"u"}function $(b){return!P(b)}function P(b){return g(b)||b===null}function c(b,r){if(!b)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function h(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}function e(...b){const r=[];for(let E=0;E<b.length;E++){const k=b[E];if(P(k))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);r.push(k)}return r}const n=Object.prototype.hasOwnProperty;function o(b){if(!B(b))return!1;for(const r in b)if(n.call(b,r))return!1;return!0}function l(b){return typeof b=="function"}function f(...b){return b.length>0&&b.every(l)}function S(b,r){const E=Math.min(b.length,r.length);for(let k=0;k<E;k++)m(b[k],r[k])}function m(b,r){if(i(r)){if(typeof b!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(l(r)){try{if(b instanceof r)return}catch{}if(!P(b)&&b.constructor===r||r.length===1&&r.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(me[45],be([1,0,10]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qj=B,t.$Rj=Q;const C=Object.create(null);function B(A,T){if((0,i.$9f)(T)){const d=C[T];if(d===void 0)throw new Error(`${A} references an unknown codicon: ${T}`);T=d}return C[A]=T,{id:A}}function Q(){return C}}),define(me[100],be([1,0,45]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sj=void 0,t.$Sj={add:(0,i.$Qj)("add",6e4),plus:(0,i.$Qj)("plus",6e4),gistNew:(0,i.$Qj)("gist-new",6e4),repoCreate:(0,i.$Qj)("repo-create",6e4),lightbulb:(0,i.$Qj)("lightbulb",60001),lightBulb:(0,i.$Qj)("light-bulb",60001),repo:(0,i.$Qj)("repo",60002),repoDelete:(0,i.$Qj)("repo-delete",60002),gistFork:(0,i.$Qj)("gist-fork",60003),repoForked:(0,i.$Qj)("repo-forked",60003),gitPullRequest:(0,i.$Qj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Qj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Qj)("record-keys",60005),keyboard:(0,i.$Qj)("keyboard",60005),tag:(0,i.$Qj)("tag",60006),gitPullRequestLabel:(0,i.$Qj)("git-pull-request-label",60006),tagAdd:(0,i.$Qj)("tag-add",60006),tagRemove:(0,i.$Qj)("tag-remove",60006),person:(0,i.$Qj)("person",60007),personFollow:(0,i.$Qj)("person-follow",60007),personOutline:(0,i.$Qj)("person-outline",60007),personFilled:(0,i.$Qj)("person-filled",60007),gitBranch:(0,i.$Qj)("git-branch",60008),gitBranchCreate:(0,i.$Qj)("git-branch-create",60008),gitBranchDelete:(0,i.$Qj)("git-branch-delete",60008),sourceControl:(0,i.$Qj)("source-control",60008),mirror:(0,i.$Qj)("mirror",60009),mirrorPublic:(0,i.$Qj)("mirror-public",60009),star:(0,i.$Qj)("star",60010),starAdd:(0,i.$Qj)("star-add",60010),starDelete:(0,i.$Qj)("star-delete",60010),starEmpty:(0,i.$Qj)("star-empty",60010),comment:(0,i.$Qj)("comment",60011),commentAdd:(0,i.$Qj)("comment-add",60011),alert:(0,i.$Qj)("alert",60012),warning:(0,i.$Qj)("warning",60012),search:(0,i.$Qj)("search",60013),searchSave:(0,i.$Qj)("search-save",60013),logOut:(0,i.$Qj)("log-out",60014),signOut:(0,i.$Qj)("sign-out",60014),logIn:(0,i.$Qj)("log-in",60015),signIn:(0,i.$Qj)("sign-in",60015),eye:(0,i.$Qj)("eye",60016),eyeUnwatch:(0,i.$Qj)("eye-unwatch",60016),eyeWatch:(0,i.$Qj)("eye-watch",60016),circleFilled:(0,i.$Qj)("circle-filled",60017),primitiveDot:(0,i.$Qj)("primitive-dot",60017),closeDirty:(0,i.$Qj)("close-dirty",60017),debugBreakpoint:(0,i.$Qj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Qj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Qj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Qj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Qj)("primitive-square",60018),edit:(0,i.$Qj)("edit",60019),pencil:(0,i.$Qj)("pencil",60019),info:(0,i.$Qj)("info",60020),issueOpened:(0,i.$Qj)("issue-opened",60020),gistPrivate:(0,i.$Qj)("gist-private",60021),gitForkPrivate:(0,i.$Qj)("git-fork-private",60021),lock:(0,i.$Qj)("lock",60021),mirrorPrivate:(0,i.$Qj)("mirror-private",60021),close:(0,i.$Qj)("close",60022),removeClose:(0,i.$Qj)("remove-close",60022),x:(0,i.$Qj)("x",60022),repoSync:(0,i.$Qj)("repo-sync",60023),sync:(0,i.$Qj)("sync",60023),clone:(0,i.$Qj)("clone",60024),desktopDownload:(0,i.$Qj)("desktop-download",60024),beaker:(0,i.$Qj)("beaker",60025),microscope:(0,i.$Qj)("microscope",60025),vm:(0,i.$Qj)("vm",60026),deviceDesktop:(0,i.$Qj)("device-desktop",60026),file:(0,i.$Qj)("file",60027),fileText:(0,i.$Qj)("file-text",60027),more:(0,i.$Qj)("more",60028),ellipsis:(0,i.$Qj)("ellipsis",60028),kebabHorizontal:(0,i.$Qj)("kebab-horizontal",60028),mailReply:(0,i.$Qj)("mail-reply",60029),reply:(0,i.$Qj)("reply",60029),organization:(0,i.$Qj)("organization",60030),organizationFilled:(0,i.$Qj)("organization-filled",60030),organizationOutline:(0,i.$Qj)("organization-outline",60030),newFile:(0,i.$Qj)("new-file",60031),fileAdd:(0,i.$Qj)("file-add",60031),newFolder:(0,i.$Qj)("new-folder",60032),fileDirectoryCreate:(0,i.$Qj)("file-directory-create",60032),trash:(0,i.$Qj)("trash",60033),trashcan:(0,i.$Qj)("trashcan",60033),history:(0,i.$Qj)("history",60034),clock:(0,i.$Qj)("clock",60034),folder:(0,i.$Qj)("folder",60035),fileDirectory:(0,i.$Qj)("file-directory",60035),symbolFolder:(0,i.$Qj)("symbol-folder",60035),logoGithub:(0,i.$Qj)("logo-github",60036),markGithub:(0,i.$Qj)("mark-github",60036),github:(0,i.$Qj)("github",60036),terminal:(0,i.$Qj)("terminal",60037),console:(0,i.$Qj)("console",60037),repl:(0,i.$Qj)("repl",60037),zap:(0,i.$Qj)("zap",60038),symbolEvent:(0,i.$Qj)("symbol-event",60038),error:(0,i.$Qj)("error",60039),stop:(0,i.$Qj)("stop",60039),variable:(0,i.$Qj)("variable",60040),symbolVariable:(0,i.$Qj)("symbol-variable",60040),array:(0,i.$Qj)("array",60042),symbolArray:(0,i.$Qj)("symbol-array",60042),symbolModule:(0,i.$Qj)("symbol-module",60043),symbolPackage:(0,i.$Qj)("symbol-package",60043),symbolNamespace:(0,i.$Qj)("symbol-namespace",60043),symbolObject:(0,i.$Qj)("symbol-object",60043),symbolMethod:(0,i.$Qj)("symbol-method",60044),symbolFunction:(0,i.$Qj)("symbol-function",60044),symbolConstructor:(0,i.$Qj)("symbol-constructor",60044),symbolBoolean:(0,i.$Qj)("symbol-boolean",60047),symbolNull:(0,i.$Qj)("symbol-null",60047),symbolNumeric:(0,i.$Qj)("symbol-numeric",60048),symbolNumber:(0,i.$Qj)("symbol-number",60048),symbolStructure:(0,i.$Qj)("symbol-structure",60049),symbolStruct:(0,i.$Qj)("symbol-struct",60049),symbolParameter:(0,i.$Qj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Qj)("symbol-type-parameter",60050),symbolKey:(0,i.$Qj)("symbol-key",60051),symbolText:(0,i.$Qj)("symbol-text",60051),symbolReference:(0,i.$Qj)("symbol-reference",60052),goToFile:(0,i.$Qj)("go-to-file",60052),symbolEnum:(0,i.$Qj)("symbol-enum",60053),symbolValue:(0,i.$Qj)("symbol-value",60053),symbolRuler:(0,i.$Qj)("symbol-ruler",60054),symbolUnit:(0,i.$Qj)("symbol-unit",60054),activateBreakpoints:(0,i.$Qj)("activate-breakpoints",60055),archive:(0,i.$Qj)("archive",60056),arrowBoth:(0,i.$Qj)("arrow-both",60057),arrowDown:(0,i.$Qj)("arrow-down",60058),arrowLeft:(0,i.$Qj)("arrow-left",60059),arrowRight:(0,i.$Qj)("arrow-right",60060),arrowSmallDown:(0,i.$Qj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Qj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Qj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Qj)("arrow-small-up",60064),arrowUp:(0,i.$Qj)("arrow-up",60065),bell:(0,i.$Qj)("bell",60066),bold:(0,i.$Qj)("bold",60067),book:(0,i.$Qj)("book",60068),bookmark:(0,i.$Qj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Qj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Qj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Qj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Qj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Qj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Qj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Qj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Qj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Qj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Qj)("briefcase",60076),broadcast:(0,i.$Qj)("broadcast",60077),browser:(0,i.$Qj)("browser",60078),bug:(0,i.$Qj)("bug",60079),calendar:(0,i.$Qj)("calendar",60080),caseSensitive:(0,i.$Qj)("case-sensitive",60081),check:(0,i.$Qj)("check",60082),checklist:(0,i.$Qj)("checklist",60083),chevronDown:(0,i.$Qj)("chevron-down",60084),chevronLeft:(0,i.$Qj)("chevron-left",60085),chevronRight:(0,i.$Qj)("chevron-right",60086),chevronUp:(0,i.$Qj)("chevron-up",60087),chromeClose:(0,i.$Qj)("chrome-close",60088),chromeMaximize:(0,i.$Qj)("chrome-maximize",60089),chromeMinimize:(0,i.$Qj)("chrome-minimize",60090),chromeRestore:(0,i.$Qj)("chrome-restore",60091),circleOutline:(0,i.$Qj)("circle-outline",60092),circle:(0,i.$Qj)("circle",60092),debugBreakpointUnverified:(0,i.$Qj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Qj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Qj)("circle-slash",60093),circuitBoard:(0,i.$Qj)("circuit-board",60094),clearAll:(0,i.$Qj)("clear-all",60095),clippy:(0,i.$Qj)("clippy",60096),closeAll:(0,i.$Qj)("close-all",60097),cloudDownload:(0,i.$Qj)("cloud-download",60098),cloudUpload:(0,i.$Qj)("cloud-upload",60099),code:(0,i.$Qj)("code",60100),collapseAll:(0,i.$Qj)("collapse-all",60101),colorMode:(0,i.$Qj)("color-mode",60102),commentDiscussion:(0,i.$Qj)("comment-discussion",60103),creditCard:(0,i.$Qj)("credit-card",60105),dash:(0,i.$Qj)("dash",60108),dashboard:(0,i.$Qj)("dashboard",60109),database:(0,i.$Qj)("database",60110),debugContinue:(0,i.$Qj)("debug-continue",60111),debugDisconnect:(0,i.$Qj)("debug-disconnect",60112),debugPause:(0,i.$Qj)("debug-pause",60113),debugRestart:(0,i.$Qj)("debug-restart",60114),debugStart:(0,i.$Qj)("debug-start",60115),debugStepInto:(0,i.$Qj)("debug-step-into",60116),debugStepOut:(0,i.$Qj)("debug-step-out",60117),debugStepOver:(0,i.$Qj)("debug-step-over",60118),debugStop:(0,i.$Qj)("debug-stop",60119),debug:(0,i.$Qj)("debug",60120),deviceCameraVideo:(0,i.$Qj)("device-camera-video",60121),deviceCamera:(0,i.$Qj)("device-camera",60122),deviceMobile:(0,i.$Qj)("device-mobile",60123),diffAdded:(0,i.$Qj)("diff-added",60124),diffIgnored:(0,i.$Qj)("diff-ignored",60125),diffModified:(0,i.$Qj)("diff-modified",60126),diffRemoved:(0,i.$Qj)("diff-removed",60127),diffRenamed:(0,i.$Qj)("diff-renamed",60128),diff:(0,i.$Qj)("diff",60129),diffSidebyside:(0,i.$Qj)("diff-sidebyside",60129),discard:(0,i.$Qj)("discard",60130),editorLayout:(0,i.$Qj)("editor-layout",60131),emptyWindow:(0,i.$Qj)("empty-window",60132),exclude:(0,i.$Qj)("exclude",60133),extensions:(0,i.$Qj)("extensions",60134),eyeClosed:(0,i.$Qj)("eye-closed",60135),fileBinary:(0,i.$Qj)("file-binary",60136),fileCode:(0,i.$Qj)("file-code",60137),fileMedia:(0,i.$Qj)("file-media",60138),filePdf:(0,i.$Qj)("file-pdf",60139),fileSubmodule:(0,i.$Qj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Qj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Qj)("file-symlink-file",60142),fileZip:(0,i.$Qj)("file-zip",60143),files:(0,i.$Qj)("files",60144),filter:(0,i.$Qj)("filter",60145),flame:(0,i.$Qj)("flame",60146),foldDown:(0,i.$Qj)("fold-down",60147),foldUp:(0,i.$Qj)("fold-up",60148),fold:(0,i.$Qj)("fold",60149),folderActive:(0,i.$Qj)("folder-active",60150),folderOpened:(0,i.$Qj)("folder-opened",60151),gear:(0,i.$Qj)("gear",60152),gift:(0,i.$Qj)("gift",60153),gistSecret:(0,i.$Qj)("gist-secret",60154),gist:(0,i.$Qj)("gist",60155),gitCommit:(0,i.$Qj)("git-commit",60156),gitCompare:(0,i.$Qj)("git-compare",60157),compareChanges:(0,i.$Qj)("compare-changes",60157),gitMerge:(0,i.$Qj)("git-merge",60158),githubAction:(0,i.$Qj)("github-action",60159),githubAlt:(0,i.$Qj)("github-alt",60160),globe:(0,i.$Qj)("globe",60161),grabber:(0,i.$Qj)("grabber",60162),graph:(0,i.$Qj)("graph",60163),gripper:(0,i.$Qj)("gripper",60164),heart:(0,i.$Qj)("heart",60165),home:(0,i.$Qj)("home",60166),horizontalRule:(0,i.$Qj)("horizontal-rule",60167),hubot:(0,i.$Qj)("hubot",60168),inbox:(0,i.$Qj)("inbox",60169),issueReopened:(0,i.$Qj)("issue-reopened",60171),issues:(0,i.$Qj)("issues",60172),italic:(0,i.$Qj)("italic",60173),jersey:(0,i.$Qj)("jersey",60174),json:(0,i.$Qj)("json",60175),kebabVertical:(0,i.$Qj)("kebab-vertical",60176),key:(0,i.$Qj)("key",60177),law:(0,i.$Qj)("law",60178),lightbulbAutofix:(0,i.$Qj)("lightbulb-autofix",60179),linkExternal:(0,i.$Qj)("link-external",60180),link:(0,i.$Qj)("link",60181),listOrdered:(0,i.$Qj)("list-ordered",60182),listUnordered:(0,i.$Qj)("list-unordered",60183),liveShare:(0,i.$Qj)("live-share",60184),loading:(0,i.$Qj)("loading",60185),location:(0,i.$Qj)("location",60186),mailRead:(0,i.$Qj)("mail-read",60187),mail:(0,i.$Qj)("mail",60188),markdown:(0,i.$Qj)("markdown",60189),megaphone:(0,i.$Qj)("megaphone",60190),mention:(0,i.$Qj)("mention",60191),milestone:(0,i.$Qj)("milestone",60192),gitPullRequestMilestone:(0,i.$Qj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Qj)("mortar-board",60193),move:(0,i.$Qj)("move",60194),multipleWindows:(0,i.$Qj)("multiple-windows",60195),mute:(0,i.$Qj)("mute",60196),noNewline:(0,i.$Qj)("no-newline",60197),note:(0,i.$Qj)("note",60198),octoface:(0,i.$Qj)("octoface",60199),openPreview:(0,i.$Qj)("open-preview",60200),package:(0,i.$Qj)("package",60201),paintcan:(0,i.$Qj)("paintcan",60202),pin:(0,i.$Qj)("pin",60203),play:(0,i.$Qj)("play",60204),run:(0,i.$Qj)("run",60204),plug:(0,i.$Qj)("plug",60205),preserveCase:(0,i.$Qj)("preserve-case",60206),preview:(0,i.$Qj)("preview",60207),project:(0,i.$Qj)("project",60208),pulse:(0,i.$Qj)("pulse",60209),question:(0,i.$Qj)("question",60210),quote:(0,i.$Qj)("quote",60211),radioTower:(0,i.$Qj)("radio-tower",60212),reactions:(0,i.$Qj)("reactions",60213),references:(0,i.$Qj)("references",60214),refresh:(0,i.$Qj)("refresh",60215),regex:(0,i.$Qj)("regex",60216),remoteExplorer:(0,i.$Qj)("remote-explorer",60217),remote:(0,i.$Qj)("remote",60218),remove:(0,i.$Qj)("remove",60219),replaceAll:(0,i.$Qj)("replace-all",60220),replace:(0,i.$Qj)("replace",60221),repoClone:(0,i.$Qj)("repo-clone",60222),repoForcePush:(0,i.$Qj)("repo-force-push",60223),repoPull:(0,i.$Qj)("repo-pull",60224),repoPush:(0,i.$Qj)("repo-push",60225),report:(0,i.$Qj)("report",60226),requestChanges:(0,i.$Qj)("request-changes",60227),rocket:(0,i.$Qj)("rocket",60228),rootFolderOpened:(0,i.$Qj)("root-folder-opened",60229),rootFolder:(0,i.$Qj)("root-folder",60230),rss:(0,i.$Qj)("rss",60231),ruby:(0,i.$Qj)("ruby",60232),saveAll:(0,i.$Qj)("save-all",60233),saveAs:(0,i.$Qj)("save-as",60234),save:(0,i.$Qj)("save",60235),screenFull:(0,i.$Qj)("screen-full",60236),screenNormal:(0,i.$Qj)("screen-normal",60237),searchStop:(0,i.$Qj)("search-stop",60238),server:(0,i.$Qj)("server",60240),settingsGear:(0,i.$Qj)("settings-gear",60241),settings:(0,i.$Qj)("settings",60242),shield:(0,i.$Qj)("shield",60243),smiley:(0,i.$Qj)("smiley",60244),sortPrecedence:(0,i.$Qj)("sort-precedence",60245),splitHorizontal:(0,i.$Qj)("split-horizontal",60246),splitVertical:(0,i.$Qj)("split-vertical",60247),squirrel:(0,i.$Qj)("squirrel",60248),starFull:(0,i.$Qj)("star-full",60249),starHalf:(0,i.$Qj)("star-half",60250),symbolClass:(0,i.$Qj)("symbol-class",60251),symbolColor:(0,i.$Qj)("symbol-color",60252),symbolConstant:(0,i.$Qj)("symbol-constant",60253),symbolEnumMember:(0,i.$Qj)("symbol-enum-member",60254),symbolField:(0,i.$Qj)("symbol-field",60255),symbolFile:(0,i.$Qj)("symbol-file",60256),symbolInterface:(0,i.$Qj)("symbol-interface",60257),symbolKeyword:(0,i.$Qj)("symbol-keyword",60258),symbolMisc:(0,i.$Qj)("symbol-misc",60259),symbolOperator:(0,i.$Qj)("symbol-operator",60260),symbolProperty:(0,i.$Qj)("symbol-property",60261),wrench:(0,i.$Qj)("wrench",60261),wrenchSubaction:(0,i.$Qj)("wrench-subaction",60261),symbolSnippet:(0,i.$Qj)("symbol-snippet",60262),tasklist:(0,i.$Qj)("tasklist",60263),telescope:(0,i.$Qj)("telescope",60264),textSize:(0,i.$Qj)("text-size",60265),threeBars:(0,i.$Qj)("three-bars",60266),thumbsdown:(0,i.$Qj)("thumbsdown",60267),thumbsup:(0,i.$Qj)("thumbsup",60268),tools:(0,i.$Qj)("tools",60269),triangleDown:(0,i.$Qj)("triangle-down",60270),triangleLeft:(0,i.$Qj)("triangle-left",60271),triangleRight:(0,i.$Qj)("triangle-right",60272),triangleUp:(0,i.$Qj)("triangle-up",60273),twitter:(0,i.$Qj)("twitter",60274),unfold:(0,i.$Qj)("unfold",60275),unlock:(0,i.$Qj)("unlock",60276),unmute:(0,i.$Qj)("unmute",60277),unverified:(0,i.$Qj)("unverified",60278),verified:(0,i.$Qj)("verified",60279),versions:(0,i.$Qj)("versions",60280),vmActive:(0,i.$Qj)("vm-active",60281),vmOutline:(0,i.$Qj)("vm-outline",60282),vmRunning:(0,i.$Qj)("vm-running",60283),watch:(0,i.$Qj)("watch",60284),whitespace:(0,i.$Qj)("whitespace",60285),wholeWord:(0,i.$Qj)("whole-word",60286),window:(0,i.$Qj)("window",60287),wordWrap:(0,i.$Qj)("word-wrap",60288),zoomIn:(0,i.$Qj)("zoom-in",60289),zoomOut:(0,i.$Qj)("zoom-out",60290),listFilter:(0,i.$Qj)("list-filter",60291),listFlat:(0,i.$Qj)("list-flat",60292),listSelection:(0,i.$Qj)("list-selection",60293),selection:(0,i.$Qj)("selection",60293),listTree:(0,i.$Qj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Qj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Qj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Qj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Qj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Qj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Qj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Qj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Qj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Qj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Qj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Qj)("symbol-string",60301),debugReverseContinue:(0,i.$Qj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Qj)("debug-step-back",60303),debugRestartFrame:(0,i.$Qj)("debug-restart-frame",60304),debugAlt:(0,i.$Qj)("debug-alt",60305),callIncoming:(0,i.$Qj)("call-incoming",60306),callOutgoing:(0,i.$Qj)("call-outgoing",60307),menu:(0,i.$Qj)("menu",60308),expandAll:(0,i.$Qj)("expand-all",60309),feedback:(0,i.$Qj)("feedback",60310),gitPullRequestReviewer:(0,i.$Qj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Qj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Qj)("ungroup-by-ref-type",60312),account:(0,i.$Qj)("account",60313),gitPullRequestAssignee:(0,i.$Qj)("git-pull-request-assignee",60313),bellDot:(0,i.$Qj)("bell-dot",60314),debugConsole:(0,i.$Qj)("debug-console",60315),library:(0,i.$Qj)("library",60316),output:(0,i.$Qj)("output",60317),runAll:(0,i.$Qj)("run-all",60318),syncIgnored:(0,i.$Qj)("sync-ignored",60319),pinned:(0,i.$Qj)("pinned",60320),githubInverted:(0,i.$Qj)("github-inverted",60321),serverProcess:(0,i.$Qj)("server-process",60322),serverEnvironment:(0,i.$Qj)("server-environment",60323),pass:(0,i.$Qj)("pass",60324),issueClosed:(0,i.$Qj)("issue-closed",60324),stopCircle:(0,i.$Qj)("stop-circle",60325),playCircle:(0,i.$Qj)("play-circle",60326),record:(0,i.$Qj)("record",60327),debugAltSmall:(0,i.$Qj)("debug-alt-small",60328),vmConnect:(0,i.$Qj)("vm-connect",60329),cloud:(0,i.$Qj)("cloud",60330),merge:(0,i.$Qj)("merge",60331),export:(0,i.$Qj)("export",60332),graphLeft:(0,i.$Qj)("graph-left",60333),magnet:(0,i.$Qj)("magnet",60334),notebook:(0,i.$Qj)("notebook",60335),redo:(0,i.$Qj)("redo",60336),checkAll:(0,i.$Qj)("check-all",60337),pinnedDirty:(0,i.$Qj)("pinned-dirty",60338),passFilled:(0,i.$Qj)("pass-filled",60339),circleLargeFilled:(0,i.$Qj)("circle-large-filled",60340),circleLarge:(0,i.$Qj)("circle-large",60341),circleLargeOutline:(0,i.$Qj)("circle-large-outline",60341),combine:(0,i.$Qj)("combine",60342),gather:(0,i.$Qj)("gather",60342),table:(0,i.$Qj)("table",60343),variableGroup:(0,i.$Qj)("variable-group",60344),typeHierarchy:(0,i.$Qj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Qj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Qj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Qj)("git-pull-request-create",60348),runAbove:(0,i.$Qj)("run-above",60349),runBelow:(0,i.$Qj)("run-below",60350),notebookTemplate:(0,i.$Qj)("notebook-template",60351),debugRerun:(0,i.$Qj)("debug-rerun",60352),workspaceTrusted:(0,i.$Qj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Qj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Qj)("workspace-unknown",60355),terminalCmd:(0,i.$Qj)("terminal-cmd",60356),terminalDebian:(0,i.$Qj)("terminal-debian",60357),terminalLinux:(0,i.$Qj)("terminal-linux",60358),terminalPowershell:(0,i.$Qj)("terminal-powershell",60359),terminalTmux:(0,i.$Qj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Qj)("terminal-ubuntu",60361),terminalBash:(0,i.$Qj)("terminal-bash",60362),arrowSwap:(0,i.$Qj)("arrow-swap",60363),copy:(0,i.$Qj)("copy",60364),personAdd:(0,i.$Qj)("person-add",60365),filterFilled:(0,i.$Qj)("filter-filled",60366),wand:(0,i.$Qj)("wand",60367),debugLineByLine:(0,i.$Qj)("debug-line-by-line",60368),inspect:(0,i.$Qj)("inspect",60369),layers:(0,i.$Qj)("layers",60370),layersDot:(0,i.$Qj)("layers-dot",60371),layersActive:(0,i.$Qj)("layers-active",60372),compass:(0,i.$Qj)("compass",60373),compassDot:(0,i.$Qj)("compass-dot",60374),compassActive:(0,i.$Qj)("compass-active",60375),azure:(0,i.$Qj)("azure",60376),issueDraft:(0,i.$Qj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Qj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Qj)("git-pull-request-draft",60379),debugAll:(0,i.$Qj)("debug-all",60380),debugCoverage:(0,i.$Qj)("debug-coverage",60381),runErrors:(0,i.$Qj)("run-errors",60382),folderLibrary:(0,i.$Qj)("folder-library",60383),debugContinueSmall:(0,i.$Qj)("debug-continue-small",60384),beakerStop:(0,i.$Qj)("beaker-stop",60385),graphLine:(0,i.$Qj)("graph-line",60386),graphScatter:(0,i.$Qj)("graph-scatter",60387),pieChart:(0,i.$Qj)("pie-chart",60388),bracket:(0,i.$Qj)("bracket",60175),bracketDot:(0,i.$Qj)("bracket-dot",60389),bracketError:(0,i.$Qj)("bracket-error",60390),lockSmall:(0,i.$Qj)("lock-small",60391),azureDevops:(0,i.$Qj)("azure-devops",60392),verifiedFilled:(0,i.$Qj)("verified-filled",60393),newline:(0,i.$Qj)("newline",60394),layout:(0,i.$Qj)("layout",60395),layoutActivitybarLeft:(0,i.$Qj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Qj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Qj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Qj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Qj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Qj)("layout-panel-right",60401),layoutPanel:(0,i.$Qj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Qj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Qj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Qj)("layout-statusbar",60405),layoutMenubar:(0,i.$Qj)("layout-menubar",60406),layoutCentered:(0,i.$Qj)("layout-centered",60407),target:(0,i.$Qj)("target",60408),indent:(0,i.$Qj)("indent",60409),recordSmall:(0,i.$Qj)("record-small",60410),errorSmall:(0,i.$Qj)("error-small",60411),terminalDecorationError:(0,i.$Qj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Qj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Qj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Qj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Qj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Qj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Qj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Qj)("layout-sidebar-left-off",60418),blank:(0,i.$Qj)("blank",60419),heartFilled:(0,i.$Qj)("heart-filled",60420),map:(0,i.$Qj)("map",60421),mapHorizontal:(0,i.$Qj)("map-horizontal",60421),foldHorizontal:(0,i.$Qj)("fold-horizontal",60421),mapFilled:(0,i.$Qj)("map-filled",60422),mapHorizontalFilled:(0,i.$Qj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Qj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Qj)("circle-small",60423),bellSlash:(0,i.$Qj)("bell-slash",60424),bellSlashDot:(0,i.$Qj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Qj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Qj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Qj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Qj)("search-fuzzy",60429),commentDraft:(0,i.$Qj)("comment-draft",60430),send:(0,i.$Qj)("send",60431),sparkle:(0,i.$Qj)("sparkle",60432),insert:(0,i.$Qj)("insert",60433),mic:(0,i.$Qj)("mic",60434),thumbsdownFilled:(0,i.$Qj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Qj)("thumbsup-filled",60436),coffee:(0,i.$Qj)("coffee",60437),snake:(0,i.$Qj)("snake",60438),game:(0,i.$Qj)("game",60439),vr:(0,i.$Qj)("vr",60440),chip:(0,i.$Qj)("chip",60441),piano:(0,i.$Qj)("piano",60442),music:(0,i.$Qj)("music",60443),micFilled:(0,i.$Qj)("mic-filled",60444),repoFetch:(0,i.$Qj)("repo-fetch",60445),copilot:(0,i.$Qj)("copilot",60446),lightbulbSparkle:(0,i.$Qj)("lightbulb-sparkle",60447),robot:(0,i.$Qj)("robot",60448),sparkleFilled:(0,i.$Qj)("sparkle-filled",60449),diffSingle:(0,i.$Qj)("diff-single",60450),diffMultiple:(0,i.$Qj)("diff-multiple",60451),surroundWith:(0,i.$Qj)("surround-with",60452),share:(0,i.$Qj)("share",60453),gitStash:(0,i.$Qj)("git-stash",60454),gitStashApply:(0,i.$Qj)("git-stash-apply",60455),gitStashPop:(0,i.$Qj)("git-stash-pop",60456),vscode:(0,i.$Qj)("vscode",60457),vscodeInsiders:(0,i.$Qj)("vscode-insiders",60458),codeOss:(0,i.$Qj)("code-oss",60459),runCoverage:(0,i.$Qj)("run-coverage",60460),runAllCoverage:(0,i.$Qj)("run-all-coverage",60461),coverage:(0,i.$Qj)("coverage",60462),githubProject:(0,i.$Qj)("github-project",60463),mapVertical:(0,i.$Qj)("map-vertical",60464),foldVertical:(0,i.$Qj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Qj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Qj)("fold-vertical-filled",60465),goToSearch:(0,i.$Qj)("go-to-search",60466),percentage:(0,i.$Qj)("percentage",60467),sortPercentage:(0,i.$Qj)("sort-percentage",60467)}}),define(me[18],be([1,0,45,100]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vj=t.$Uj=void 0,t.$Tj=B;function B(){return Object.values(t.$Vj)}t.$Uj={dialogError:(0,i.$Qj)("dialog-error","error"),dialogWarning:(0,i.$Qj)("dialog-warning","warning"),dialogInfo:(0,i.$Qj)("dialog-info","info"),dialogClose:(0,i.$Qj)("dialog-close","close"),treeItemExpanded:(0,i.$Qj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Qj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Qj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Qj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Qj)("tree-item-loading","loading"),menuSelection:(0,i.$Qj)("menu-selection","check"),menuSubmenu:(0,i.$Qj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Qj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Qj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Qj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Qj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Qj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Qj)("toolbar-more","more"),quickInputBack:(0,i.$Qj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Qj)("drop-down-button",60084),symbolCustomColor:(0,i.$Qj)("symbol-customcolor",60252),exportIcon:(0,i.$Qj)("export",60332),workspaceUnspecified:(0,i.$Qj)("workspace-unspecified",60355),newLine:(0,i.$Qj)("newline",60394),thumbsDownFilled:(0,i.$Qj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Qj)("thumbsup-filled",60436),gitFetch:(0,i.$Qj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Qj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Qj)("debug-breakpoint-pending",60377)},t.$Vj={...C.$Sj,...t.$Uj}}),define(me[61],be([1,0,10]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3n=C,t.$4n=B,t.$5n=A,t.$6n=d,t.$7n=g,t.$8n=$,t.$9n=P,t.$0n=c,t.$$n=h,t.$_n=e,t.$ao=n,t.$bo=o;function C(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const f=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([S,m])=>{f[S]=m&&typeof m=="object"?C(m):m}),f}function B(l){if(!l||typeof l!="object")return l;const f=[l];for(;f.length>0;){const S=f.shift();Object.freeze(S);for(const m in S)if(Q.call(S,m)){const b=S[m];typeof b=="object"&&!Object.isFrozen(b)&&!(0,i.$_f)(b)&&f.push(b)}}return l}const Q=Object.prototype.hasOwnProperty;function A(l,f){return T(l,f,new Set)}function T(l,f,S){if((0,i.$fg)(l))return l;const m=f(l);if(typeof m<"u")return m;if(Array.isArray(l)){const b=[];for(const r of l)b.push(T(r,f,S));return b}if((0,i.$$f)(l)){if(S.has(l))throw new Error("Cannot clone recursive data-structure");S.add(l);const b={};for(const r in l)Q.call(l,r)&&(b[r]=T(l[r],f,S));return S.delete(l),b}return l}function d(l,f,S=!0){return(0,i.$$f)(l)?((0,i.$$f)(f)&&Object.keys(f).forEach(m=>{m in l?S&&((0,i.$$f)(l[m])&&(0,i.$$f)(f[m])?d(l[m],f[m],S):l[m]=f[m]):l[m]=f[m]}),l):f}function g(l,f){if(l===f)return!0;if(l==null||f===null||f===void 0||typeof l!=typeof f||typeof l!="object"||Array.isArray(l)!==Array.isArray(f))return!1;let S,m;if(Array.isArray(l)){if(l.length!==f.length)return!1;for(S=0;S<l.length;S++)if(!g(l[S],f[S]))return!1}else{const b=[];for(m in l)b.push(m);b.sort();const r=[];for(m in f)r.push(m);if(r.sort(),!g(b,r))return!1;for(S=0;S<b.length;S++)if(!g(l[b[S]],f[b[S]]))return!1}return!0}function $(l){const f=new Set;return JSON.stringify(l,(S,m)=>{if((0,i.$$f)(m)||Array.isArray(m)){if(f.has(m))return"[Circular]";f.add(m)}return typeof m=="bigint"?`[BigInt ${m.toString()}]`:m})}function P(l,f){const S=Object.create(null);return!l||!f||Object.keys(f).forEach(b=>{const r=l[b],E=f[b];g(r,E)||(S[b]=E)}),S}function c(l,f){const S=f.toLowerCase(),m=Object.keys(l).find(b=>b.toLowerCase()===S);return m?l[m]:l[f]}function h(l,f){const S=Object.create(null);for(const[m,b]of Object.entries(l))f(m,b)&&(S[m]=b);return S}function e(l){let f=[];for(;Object.prototype!==l;)f=f.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return f}function n(l){const f=[];for(const S of e(l))typeof l[S]=="function"&&f.push(S);return f}function o(l,f){const S=b=>function(){const r=Array.prototype.slice.call(arguments,0);return f(b,r)},m={};for(const b of l)m[b]=S(b);return m}}),define(me[19],be([1,0,18]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$Wj=B;var C;(function(A){function T(d){return d&&typeof d=="object"&&typeof d.id=="string"}A.isThemeColor=T})(C||(t.ThemeColor=C={}));function B(A){return{id:A}}var Q;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function d(f){const S=T.exec(f.id);if(!S)return d(i.$Vj.error);const[,m,b]=S,r=["codicon","codicon-"+m];return b&&r.push("codicon-modifier-"+b.substring(1)),r}A.asClassNameArray=d;function g(f){return d(f).join(" ")}A.asClassName=g;function $(f){return"."+d(f).join(".")}A.asCSSSelector=$;function P(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||C.isThemeColor(f.color))}A.isThemeIcon=P;const c=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function h(f){const S=c.exec(f);if(!S)return;const[,m]=S;return{id:m}}A.fromString=h;function e(f){return{id:f}}A.fromId=e;function n(f,S){let m=f.id;const b=m.lastIndexOf("~");return b!==-1&&(m=m.substring(0,b)),S&&(m=`${m}~${S}`),{id:m}}A.modify=n;function o(f){const S=f.id.lastIndexOf("~");if(S!==-1)return f.id.substring(S+1)}A.getModifier=o;function l(f,S){return f.id===S.id&&f.color?.id===S.color?.id}A.isEqual=l})(Q||(t.ThemeIcon=Q={}))}),define(me[62],be([1,0,44,9,19]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nk=d,t.$Ok=$,t.$Pk=c,t.$Qk=h,t.$Rk=n,t.$Sk=o;const Q="$(",A=new RegExp(`\\$\\(${B.ThemeIcon.iconNameExpression}(?:${B.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function d(l){return l.replace(T,(f,S)=>S?f:`\\${f}`)}const g=new RegExp(`\\\\${A.source}`,"g");function $(l){return l.replace(g,f=>`\\${f}`)}const P=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function c(l){return l.indexOf(Q)===-1?l:l.replace(P,(f,S,m,b)=>m?f:S||b||"")}function h(l){return l?l.replace(/\$\((.*?)\)/g,(f,S)=>` ${S} `).trim():""}const e=new RegExp(`\\$\\(${B.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(l){e.lastIndex=0;let f="";const S=[];let m=0;for(;;){const b=e.lastIndex,r=e.exec(l),E=l.substring(b,r?.index);if(E.length>0){f+=E;for(let k=0;k<E.length;k++)S.push(m)}if(!r)break;m+=r[0].length}return{text:f,iconOffsets:S}}function o(l,f,S=!1){const{text:m,iconOffsets:b}=f;if(!b||b.length===0)return(0,i.$Ek)(l,m,S);const r=(0,C.$ff)(m," "),E=m.length-r.length,k=(0,i.$Ek)(l,r,S);if(k)for(const F of k){const M=b[F.start+E]+E;F.start+=M,F.end+=M}return k}}),define(me[101],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UW=t.$TW=void 0,t.$TW="vscode:contextmenu",t.$UW="vscode:onCloseContextMenu"}),define(me[102],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2W=void 0;class i{constructor(B,Q){this.a=B,this.onMessage=Q}send(B){try{this.a.send("vscode:message",B.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$2W=i}),define(me[35],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const i=globalThis.vscode;t.$O=i.ipcRenderer,t.$P=i.ipcMessagePort,t.$Q=i.webFrame,t.$R=i.process,t.$S=i.context}),define(me[103],be([1,0,101,35]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XW=Q;let B=0;function Q(T,d,g){const $=[],P=B++,c=`vscode:onContextMenu${P}`,h=(e,n,o)=>{$[n].click?.(o)};C.$O.once(c,h),C.$O.once(i.$UW,(e,n)=>{n===P&&(C.$O.removeListener(c,h),g?.())}),C.$O.send(i.$TW,P,T.map(e=>A(e,$)),c,d)}function A(T,d){const g={id:d.length,label:T.label,type:T.type,accelerator:T.accelerator,checked:T.checked,enabled:typeof T.enabled=="boolean"?T.enabled:!0,visible:typeof T.visible=="boolean"?T.visible:!0};return d.push(T),Array.isArray(T.submenu)&&(g.submenu=T.submenu.map($=>A($,d))),g}}),define(me[63],be([7]),{}),define(me[104],be([7]),{}),define(me[105],be([7]),{}),define(me[106],be([7]),{}),define(me[107],be([1,0,105,106]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(me[108],be([7]),{}),define(me[109],be([7]),{}),define(me[110],be([7]),{}),define(me[111],be([7]),{}),define(me[112],be([7]),{}),define(me[113],be([7]),{}),define(me[114],be([7]),{}),define(me[115],be([7]),{}),define(me[116],be([7]),{}),define(me[117],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[118],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[119],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[120],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[121],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[122],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[123],be([13,12]),function(se,t){return se.create("vs/base/common/actions",t)}),define(me[46],be([1,0,3,2,123]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fj=t.$ej=t.$dj=t.$cj=t.$bj=void 0,t.$gj=$;class Q extends C.$Vc{constructor(c,h="",e="",n=!0,o){super(),this.h=this.B(new i.$ee),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=h,this.u=e,this.w=n,this.C=o}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,h){this.C&&await this.C(c)}}t.$bj=Q;class A extends C.$Vc{constructor(){super(...arguments),this.f=this.B(new i.$ee),this.onWillRun=this.f.event,this.m=this.B(new i.$ee),this.onDidRun=this.m.event}async run(c,h){if(!c.enabled)return;this.f.fire({action:c});let e;try{await this.u(c,h)}catch(n){e=n}this.m.fire({action:c,error:e})}async u(c,h){await c.run(h)}}t.$cj=A;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let h=[];for(const e of c)e.length&&(h.length?h=[...h,new T,...e]:h=e);return h}static{this.ID="vs.actions.separator"}async run(){}}t.$dj=T;class d{get actions(){return this.a}constructor(c,h,e,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=h,this.class=n,this.a=e}async run(){}}t.$ej=d;class g extends Q{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,B.localize(0,null),void 0,!1)}}t.$fj=g;function $(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...c)=>P.run(...c),tooltip:P.label}}}),define(me[124],be([13,12]),function(se,t){return se.create("vs/base/common/platform",t)}),define(me[5],be([1,0,124]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=E,t.$D=I,t.$J=V,t.$g="en";let C=!1,B=!1,Q=!1,A=!1,T=!1,d=!1,g=!1,$=!1,P=!1,c=!1,h,e=t.$g,n=t.$g,o,l;const f=globalThis;let S;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?S=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(S=process);const m=typeof S?.versions?.electron=="string",b=m&&S?.type==="renderer";if(typeof S=="object"){C=S.platform==="win32",B=S.platform==="darwin",Q=S.platform==="linux",A=Q&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,g=m,P=!!S.env.CI||!!S.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t.$g,e=t.$g;const R=S.env.VSCODE_NLS_CONFIG;if(R)try{const x=JSON.parse(R),O=x.availableLanguages["*"];h=x.locale,n=x.osLocale,e=O||t.$g,o=x._translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!b?(l=navigator.userAgent,C=l.indexOf("Windows")>=0,B=l.indexOf("Macintosh")>=0,$=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,Q=l.indexOf("Linux")>=0,c=l?.indexOf("Mobi")>=0,d=!0,h=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=h,n=navigator.language):console.error("Unable to resolve platform.");var r;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(r||(t.Platform=r={}));function E(R){switch(R){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let k=0;B?k=1:C?k=3:Q&&(k=2),t.$i=C,t.$j=B,t.$k=Q,t.$l=A,t.$m=T,t.$n=g,t.$o=d,t.$p=d&&typeof f.importScripts=="function",t.$q=t.$p?f.origin:void 0,t.$r=$,t.$s=c,t.$t=P,t.$u=k,t.$v=l,t.$w=e;var F;(function(R){function x(){return t.$w}R.value=x;function O(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}R.isDefaultVariant=O;function G(){return t.$w==="en"}R.isDefault=G})(F||(t.Language=F={})),t.$x=h,t.$y=n,t.$z=o,t.$A=typeof f.postMessage=="function"&&!f.importScripts,t.$B=(()=>{if(t.$A){const R=[];f.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let G=0,q=R.length;G<q;G++){const ae=R[G];if(ae.id===O.data.vscodeScheduleAsyncWork){R.splice(G,1),ae.callback();return}}});let x=0;return O=>{const G=++x;R.push({id:G,callback:O}),f.postMessage({vscodeScheduleAsyncWork:G},"*")}}return R=>setTimeout(R)})();var M;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(M||(t.OperatingSystem=M={})),t.OS=B||$?2:C?1:3;let W=!0,p=!1;function I(){if(!p){p=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,W=new Uint16Array(R.buffer)[0]===513}return W}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function V(R){return parseFloat(R)>=20}}),define(me[125],be([1,0,17,22,5]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IR=t.KeyboardSupport=void 0;var Q;(function(A){A[A.Always=0]="Always",A[A.FullScreen=1]="FullScreen",A[A.None=2]="None"})(Q||(t.KeyboardSupport=Q={})),t.$IR={clipboard:{writeText:B.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:B.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:B.$m||i.$GR()?0:navigator.keyboard||i.$CR?1:2,touch:"ontouchstart"in C.$nR||navigator.maxTouchPoints>0,pointerEvents:C.$nR.PointerEvent&&("ontouchstart"in C.$nR||navigator.maxTouchPoints>0)}}),define(me[15],be([1,0,17,54,87,5]),function(se,t,i,C,B,Q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QR=void 0,t.$OR=P,t.$PR=c;function A(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return C.KeyCodeUtils.fromString(o)}const n=e.keyCode;if(n===3)return 7;if(i.$zR)switch(n){case 59:return 85;case 60:if(Q.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(Q.$j)return 57;break}else if(i.$AR){if(Q.$j&&n===93)return 57;if(!Q.$j&&n===92)return 57}return C.$zr[n]||0}const T=Q.$j?256:2048,d=512,g=1024,$=Q.$j?2048:256;function P(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function c(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${C.KeyCodeUtils.toString(e.keyCode)}')`}class h{constructor(n){this._standardKeyboardEventBrand=!0;const o=n;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState?.("AltGraph"),this.keyCode=A(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(n){return this.a===n}c(){let n=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode);let o=0;return this.ctrlKey&&(o|=T),this.altKey&&(o|=d),this.shiftKey&&(o|=g),this.metaKey&&(o|=$),o|=n,o}d(){let n=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode),new B.$Hr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,n)}}t.$QR=h}),define(me[20],be([1,0,17,79,5]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NR=t.$MR=t.$LR=void 0;class Q{constructor(g,$){this.timestamp=Date.now(),this.browserEvent=$,this.leftButton=$.button===0,this.middleButton=$.button===1,this.rightButton=$.button===2,this.buttons=$.buttons,this.target=$.target,this.detail=$.detail||1,$.type==="dblclick"&&(this.detail=2),this.ctrlKey=$.ctrlKey,this.shiftKey=$.shiftKey,this.altKey=$.altKey,this.metaKey=$.metaKey,typeof $.pageX=="number"?(this.posx=$.pageX,this.posy=$.pageY):(this.posx=$.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=$.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const P=C.$JR.getPositionOfChildWindowRelativeToAncestorWindow(g,$.view);this.posx-=P.left,this.posy-=P.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$LR=Q;class A extends Q{constructor(g,$){super(g,$),this.dataTransfer=$.dataTransfer}}t.$MR=A;class T{constructor(g,$=0,P=0){this.browserEvent=g||null,this.target=g?g.target||g.targetNode||g.srcElement:null,this.deltaY=P,this.deltaX=$;let c=!1;if(i.$BR){const h=navigator.userAgent.match(/Chrome\/(\d+)/);c=(h?parseInt(h[1]):123)<=122}if(g){const h=g,e=g,n=g.view?.devicePixelRatio||1;if(typeof h.wheelDeltaY<"u")c?this.deltaY=h.wheelDeltaY/(120*n):this.deltaY=h.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(g.type==="wheel"){const o=g;o.deltaMode===o.DOM_DELTA_LINE?i.$zR&&!B.$j?this.deltaY=-g.deltaY/3:this.deltaY=-g.deltaY:this.deltaY=-g.deltaY/40}if(typeof h.wheelDeltaX<"u")i.$CR&&B.$i?this.deltaX=-(h.wheelDeltaX/120):c?this.deltaX=h.wheelDeltaX/(120*n):this.deltaX=h.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-g.detail/3;else if(g.type==="wheel"){const o=g;o.deltaMode===o.DOM_DELTA_LINE?i.$zR&&!B.$j?this.deltaX=-g.deltaX/3:this.deltaX=-g.deltaX:this.deltaX=-g.deltaX/40}this.deltaY===0&&this.deltaX===0&&g.wheelDelta&&(c?this.deltaY=g.wheelDelta/(120*n):this.deltaY=g.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$NR=T}),define(me[126],be([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let C;const B=globalThis.vscode;if(typeof B<"u"&&typeof B.process<"u"){const Q=B.process;C={get platform(){return Q.platform},get arch(){return Q.arch},get env(){return Q.env},cwd(){return Q.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=C.cwd,t.env=C.env,t.$ec=C.platform,t.$fc=C.arch}),define(me[25],be([1,0,126]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const C=65,B=97,Q=90,A=122,T=46,d=47,g=92,$=58,P=63;class c extends Error{constructor(E,k,F){let M;typeof k=="string"&&k.indexOf("not ")===0?(M="must not be",k=k.replace(/^not /,"")):M="must be";const W=E.indexOf(".")!==-1?"property":"argument";let p=`The "${E}" ${W} ${M} of type ${k}`;p+=`. Received type ${typeof F}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function h(r,E){if(r===null||typeof r!="object")throw new c(E,"Object",r)}function e(r,E){if(typeof r!="string")throw new c(E,"string",r)}const n=i.$ec==="win32";function o(r){return r===d||r===g}function l(r){return r===d}function f(r){return r>=C&&r<=Q||r>=B&&r<=A}function S(r,E,k,F){let M="",W=0,p=-1,I=0,V=0;for(let R=0;R<=r.length;++R){if(R<r.length)V=r.charCodeAt(R);else{if(F(V))break;V=d}if(F(V)){if(!(p===R-1||I===1))if(I===2){if(M.length<2||W!==2||M.charCodeAt(M.length-1)!==T||M.charCodeAt(M.length-2)!==T){if(M.length>2){const x=M.lastIndexOf(k);x===-1?(M="",W=0):(M=M.slice(0,x),W=M.length-1-M.lastIndexOf(k)),p=R,I=0;continue}else if(M.length!==0){M="",W=0,p=R,I=0;continue}}E&&(M+=M.length>0?`${k}..`:"..",W=2)}else M.length>0?M+=`${k}${r.slice(p+1,R)}`:M=r.slice(p+1,R),W=R-p-1;p=R,I=0}else V===T&&I!==-1?++I:I=-1}return M}function m(r,E){h(E,"pathObject");const k=E.dir||E.root,F=E.base||`${E.name||""}${E.ext||""}`;return k?k===E.root?`${k}${F}`:`${k}${r}${F}`:F}t.$gc={resolve(...r){let E="",k="",F=!1;for(let M=r.length-1;M>=-1;M--){let W;if(M>=0){if(W=r[M],e(W,"path"),W.length===0)continue}else E.length===0?W=i.cwd():(W=i.env[`=${E}`]||i.cwd(),(W===void 0||W.slice(0,2).toLowerCase()!==E.toLowerCase()&&W.charCodeAt(2)===g)&&(W=`${E}\\`));const p=W.length;let I=0,V="",R=!1;const x=W.charCodeAt(0);if(p===1)o(x)&&(I=1,R=!0);else if(o(x))if(R=!0,o(W.charCodeAt(1))){let O=2,G=O;for(;O<p&&!o(W.charCodeAt(O));)O++;if(O<p&&O!==G){const q=W.slice(G,O);for(G=O;O<p&&o(W.charCodeAt(O));)O++;if(O<p&&O!==G){for(G=O;O<p&&!o(W.charCodeAt(O));)O++;(O===p||O!==G)&&(V=`\\\\${q}\\${W.slice(G,O)}`,I=O)}}}else I=1;else f(x)&&W.charCodeAt(1)===$&&(V=W.slice(0,2),I=2,p>2&&o(W.charCodeAt(2))&&(R=!0,I=3));if(V.length>0)if(E.length>0){if(V.toLowerCase()!==E.toLowerCase())continue}else E=V;if(F){if(E.length>0)break}else if(k=`${W.slice(I)}\\${k}`,F=R,R&&E.length>0)break}return k=S(k,!F,"\\",o),F?`${E}\\${k}`:`${E}${k}`||"."},normalize(r){e(r,"path");const E=r.length;if(E===0)return".";let k=0,F,M=!1;const W=r.charCodeAt(0);if(E===1)return l(W)?"\\":r;if(o(W))if(M=!0,o(r.charCodeAt(1))){let I=2,V=I;for(;I<E&&!o(r.charCodeAt(I));)I++;if(I<E&&I!==V){const R=r.slice(V,I);for(V=I;I<E&&o(r.charCodeAt(I));)I++;if(I<E&&I!==V){for(V=I;I<E&&!o(r.charCodeAt(I));)I++;if(I===E)return`\\\\${R}\\${r.slice(V)}\\`;I!==V&&(F=`\\\\${R}\\${r.slice(V,I)}`,k=I)}}}else k=1;else f(W)&&r.charCodeAt(1)===$&&(F=r.slice(0,2),k=2,E>2&&o(r.charCodeAt(2))&&(M=!0,k=3));let p=k<E?S(r.slice(k),!M,"\\",o):"";return p.length===0&&!M&&(p="."),p.length>0&&o(r.charCodeAt(E-1))&&(p+="\\"),F===void 0?M?`\\${p}`:p:M?`${F}\\${p}`:`${F}${p}`},isAbsolute(r){e(r,"path");const E=r.length;if(E===0)return!1;const k=r.charCodeAt(0);return o(k)||E>2&&f(k)&&r.charCodeAt(1)===$&&o(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let E,k;for(let W=0;W<r.length;++W){const p=r[W];e(p,"path"),p.length>0&&(E===void 0?E=k=p:E+=`\\${p}`)}if(E===void 0)return".";let F=!0,M=0;if(typeof k=="string"&&o(k.charCodeAt(0))){++M;const W=k.length;W>1&&o(k.charCodeAt(1))&&(++M,W>2&&(o(k.charCodeAt(2))?++M:F=!1))}if(F){for(;M<E.length&&o(E.charCodeAt(M));)M++;M>=2&&(E=`\\${E.slice(M)}`)}return t.$gc.normalize(E)},relative(r,E){if(e(r,"from"),e(E,"to"),r===E)return"";const k=t.$gc.resolve(r),F=t.$gc.resolve(E);if(k===F||(r=k.toLowerCase(),E=F.toLowerCase(),r===E))return"";let M=0;for(;M<r.length&&r.charCodeAt(M)===g;)M++;let W=r.length;for(;W-1>M&&r.charCodeAt(W-1)===g;)W--;const p=W-M;let I=0;for(;I<E.length&&E.charCodeAt(I)===g;)I++;let V=E.length;for(;V-1>I&&E.charCodeAt(V-1)===g;)V--;const R=V-I,x=p<R?p:R;let O=-1,G=0;for(;G<x;G++){const ae=r.charCodeAt(M+G);if(ae!==E.charCodeAt(I+G))break;ae===g&&(O=G)}if(G!==x){if(O===-1)return F}else{if(R>x){if(E.charCodeAt(I+G)===g)return F.slice(I+G+1);if(G===2)return F.slice(I+G)}p>x&&(r.charCodeAt(M+G)===g?O=G:G===2&&(O=3)),O===-1&&(O=0)}let q="";for(G=M+O+1;G<=W;++G)(G===W||r.charCodeAt(G)===g)&&(q+=q.length===0?"..":"\\..");return I+=O,q.length>0?`${q}${F.slice(I,V)}`:(F.charCodeAt(I)===g&&++I,F.slice(I,V))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const E=t.$gc.resolve(r);if(E.length<=2)return r;if(E.charCodeAt(0)===g){if(E.charCodeAt(1)===g){const k=E.charCodeAt(2);if(k!==P&&k!==T)return`\\\\?\\UNC\\${E.slice(2)}`}}else if(f(E.charCodeAt(0))&&E.charCodeAt(1)===$&&E.charCodeAt(2)===g)return`\\\\?\\${E}`;return r},dirname(r){e(r,"path");const E=r.length;if(E===0)return".";let k=-1,F=0;const M=r.charCodeAt(0);if(E===1)return o(M)?r:".";if(o(M)){if(k=F=1,o(r.charCodeAt(1))){let I=2,V=I;for(;I<E&&!o(r.charCodeAt(I));)I++;if(I<E&&I!==V){for(V=I;I<E&&o(r.charCodeAt(I));)I++;if(I<E&&I!==V){for(V=I;I<E&&!o(r.charCodeAt(I));)I++;if(I===E)return r;I!==V&&(k=F=I+1)}}}}else f(M)&&r.charCodeAt(1)===$&&(k=E>2&&o(r.charCodeAt(2))?3:2,F=k);let W=-1,p=!0;for(let I=E-1;I>=F;--I)if(o(r.charCodeAt(I))){if(!p){W=I;break}}else p=!1;if(W===-1){if(k===-1)return".";W=k}return r.slice(0,W)},basename(r,E){E!==void 0&&e(E,"ext"),e(r,"path");let k=0,F=-1,M=!0,W;if(r.length>=2&&f(r.charCodeAt(0))&&r.charCodeAt(1)===$&&(k=2),E!==void 0&&E.length>0&&E.length<=r.length){if(E===r)return"";let p=E.length-1,I=-1;for(W=r.length-1;W>=k;--W){const V=r.charCodeAt(W);if(o(V)){if(!M){k=W+1;break}}else I===-1&&(M=!1,I=W+1),p>=0&&(V===E.charCodeAt(p)?--p===-1&&(F=W):(p=-1,F=I))}return k===F?F=I:F===-1&&(F=r.length),r.slice(k,F)}for(W=r.length-1;W>=k;--W)if(o(r.charCodeAt(W))){if(!M){k=W+1;break}}else F===-1&&(M=!1,F=W+1);return F===-1?"":r.slice(k,F)},extname(r){e(r,"path");let E=0,k=-1,F=0,M=-1,W=!0,p=0;r.length>=2&&r.charCodeAt(1)===$&&f(r.charCodeAt(0))&&(E=F=2);for(let I=r.length-1;I>=E;--I){const V=r.charCodeAt(I);if(o(V)){if(!W){F=I+1;break}continue}M===-1&&(W=!1,M=I+1),V===T?k===-1?k=I:p!==1&&(p=1):k!==-1&&(p=-1)}return k===-1||M===-1||p===0||p===1&&k===M-1&&k===F+1?"":r.slice(k,M)},format:m.bind(null,"\\"),parse(r){e(r,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return E;const k=r.length;let F=0,M=r.charCodeAt(0);if(k===1)return o(M)?(E.root=E.dir=r,E):(E.base=E.name=r,E);if(o(M)){if(F=1,o(r.charCodeAt(1))){let O=2,G=O;for(;O<k&&!o(r.charCodeAt(O));)O++;if(O<k&&O!==G){for(G=O;O<k&&o(r.charCodeAt(O));)O++;if(O<k&&O!==G){for(G=O;O<k&&!o(r.charCodeAt(O));)O++;O===k?F=O:O!==G&&(F=O+1)}}}}else if(f(M)&&r.charCodeAt(1)===$){if(k<=2)return E.root=E.dir=r,E;if(F=2,o(r.charCodeAt(2))){if(k===3)return E.root=E.dir=r,E;F=3}}F>0&&(E.root=r.slice(0,F));let W=-1,p=F,I=-1,V=!0,R=r.length-1,x=0;for(;R>=F;--R){if(M=r.charCodeAt(R),o(M)){if(!V){p=R+1;break}continue}I===-1&&(V=!1,I=R+1),M===T?W===-1?W=R:x!==1&&(x=1):W!==-1&&(x=-1)}return I!==-1&&(W===-1||x===0||x===1&&W===I-1&&W===p+1?E.base=E.name=r.slice(p,I):(E.name=r.slice(p,W),E.base=r.slice(p,I),E.ext=r.slice(W,I))),p>0&&p!==F?E.dir=r.slice(0,p-1):E.dir=E.root,E},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(n){const r=/\\/g;return()=>{const E=i.cwd().replace(r,"/");return E.slice(E.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...r){let E="",k=!1;for(let F=r.length-1;F>=-1&&!k;F--){const M=F>=0?r[F]:b();e(M,"path"),M.length!==0&&(E=`${M}/${E}`,k=M.charCodeAt(0)===d)}return E=S(E,!k,"/",l),k?`/${E}`:E.length>0?E:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const E=r.charCodeAt(0)===d,k=r.charCodeAt(r.length-1)===d;return r=S(r,!E,"/",l),r.length===0?E?"/":k?"./":".":(k&&(r+="/"),E?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===d},join(...r){if(r.length===0)return".";let E;for(let k=0;k<r.length;++k){const F=r[k];e(F,"path"),F.length>0&&(E===void 0?E=F:E+=`/${F}`)}return E===void 0?".":t.$hc.normalize(E)},relative(r,E){if(e(r,"from"),e(E,"to"),r===E||(r=t.$hc.resolve(r),E=t.$hc.resolve(E),r===E))return"";const k=1,F=r.length,M=F-k,W=1,p=E.length-W,I=M<p?M:p;let V=-1,R=0;for(;R<I;R++){const O=r.charCodeAt(k+R);if(O!==E.charCodeAt(W+R))break;O===d&&(V=R)}if(R===I)if(p>I){if(E.charCodeAt(W+R)===d)return E.slice(W+R+1);if(R===0)return E.slice(W+R)}else M>I&&(r.charCodeAt(k+R)===d?V=R:R===0&&(V=0));let x="";for(R=k+V+1;R<=F;++R)(R===F||r.charCodeAt(R)===d)&&(x+=x.length===0?"..":"/..");return`${x}${E.slice(W+V)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const E=r.charCodeAt(0)===d;let k=-1,F=!0;for(let M=r.length-1;M>=1;--M)if(r.charCodeAt(M)===d){if(!F){k=M;break}}else F=!1;return k===-1?E?"/":".":E&&k===1?"//":r.slice(0,k)},basename(r,E){E!==void 0&&e(E,"ext"),e(r,"path");let k=0,F=-1,M=!0,W;if(E!==void 0&&E.length>0&&E.length<=r.length){if(E===r)return"";let p=E.length-1,I=-1;for(W=r.length-1;W>=0;--W){const V=r.charCodeAt(W);if(V===d){if(!M){k=W+1;break}}else I===-1&&(M=!1,I=W+1),p>=0&&(V===E.charCodeAt(p)?--p===-1&&(F=W):(p=-1,F=I))}return k===F?F=I:F===-1&&(F=r.length),r.slice(k,F)}for(W=r.length-1;W>=0;--W)if(r.charCodeAt(W)===d){if(!M){k=W+1;break}}else F===-1&&(M=!1,F=W+1);return F===-1?"":r.slice(k,F)},extname(r){e(r,"path");let E=-1,k=0,F=-1,M=!0,W=0;for(let p=r.length-1;p>=0;--p){const I=r.charCodeAt(p);if(I===d){if(!M){k=p+1;break}continue}F===-1&&(M=!1,F=p+1),I===T?E===-1?E=p:W!==1&&(W=1):E!==-1&&(W=-1)}return E===-1||F===-1||W===0||W===1&&E===F-1&&E===k+1?"":r.slice(E,F)},format:m.bind(null,"/"),parse(r){e(r,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return E;const k=r.charCodeAt(0)===d;let F;k?(E.root="/",F=1):F=0;let M=-1,W=0,p=-1,I=!0,V=r.length-1,R=0;for(;V>=F;--V){const x=r.charCodeAt(V);if(x===d){if(!I){W=V+1;break}continue}p===-1&&(I=!1,p=V+1),x===T?M===-1?M=V:R!==1&&(R=1):M!==-1&&(R=-1)}if(p!==-1){const x=W===0&&k?1:W;M===-1||R===0||R===1&&M===p-1&&M===W+1?E.base=E.name=r.slice(x,p):(E.name=r.slice(x,M),E.base=r.slice(x,p),E.ext=r.slice(M,p))}return W>0?E.dir=r.slice(0,W-1):k&&(E.dir="/"),E},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=n?t.$gc.normalize:t.$hc.normalize,t.$jc=n?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=n?t.$gc.join:t.$hc.join,t.$lc=n?t.$gc.resolve:t.$hc.resolve,t.$mc=n?t.$gc.relative:t.$hc.relative,t.$nc=n?t.$gc.dirname:t.$hc.dirname,t.$oc=n?t.$gc.basename:t.$hc.basename,t.$pc=n?t.$gc.extname:t.$hc.extname,t.$qc=n?t.$gc.format:t.$hc.format,t.$rc=n?t.$gc.parse:t.$hc.parse,t.$sc=n?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=n?t.$gc.sep:t.$hc.sep,t.$uc=n?t.$gc.delimiter:t.$hc.delimiter}),define(me[127],be([1,0,25,5,9,10]),function(se,t,i,C,B,Q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$og=A,t.$pg=T,t.$qg=d,t.$rg=g,t.$sg=$,t.$tg=e,t.$ug=n,t.$vg=o,t.$wg=l,t.$xg=f,t.$yg=S,t.$zg=m,t.$Ag=b,t.$Bg=r,t.$Cg=E,t.$Dg=k,t.$Eg=W;function A(p){return p===47||p===92}function T(p){return p.replace(/[\\/]/g,i.$hc.sep)}function d(p){return p.indexOf("/")===-1&&(p=T(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function g(p,I=i.$hc.sep){if(!p)return"";const V=p.length,R=p.charCodeAt(0);if(A(R)){if(A(p.charCodeAt(1))&&!A(p.charCodeAt(2))){let O=3;const G=O;for(;O<V&&!A(p.charCodeAt(O));O++);if(G!==O&&!A(p.charCodeAt(O+1))){for(O+=1;O<V;O++)if(A(p.charCodeAt(O)))return p.slice(0,O+1).replace(/[\\/]/g,I)}}return I}else if(l(R)&&p.charCodeAt(1)===58)return A(p.charCodeAt(2))?p.slice(0,2)+I:p.slice(0,2);let x=p.indexOf("://");if(x!==-1){for(x+=3;x<V;x++)if(A(p.charCodeAt(x)))return p.slice(0,x+1)}return""}function $(p){if(!C.$i||!p||p.length<5)return!1;let I=p.charCodeAt(0);if(I!==92||(I=p.charCodeAt(1),I!==92))return!1;let V=2;const R=V;for(;V<p.length&&(I=p.charCodeAt(V),I!==92);V++);return!(R===V||(I=p.charCodeAt(V+1),isNaN(I)||I===92))}const P=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(p,I=C.$i){const V=I?P:c;return!(!p||p.length===0||/^\s+$/.test(p)||(V.lastIndex=0,V.test(p))||I&&h.test(p)||p==="."||p===".."||I&&p[p.length-1]==="."||I&&p.length!==p.trim().length||p.length>255)}function n(p,I,V){const R=p===I;return!V||R?R:!p||!I?!1:(0,B.$yf)(p,I)}function o(p,I,V,R=i.sep){if(p===I)return!0;if(!p||!I||I.length>p.length)return!1;if(V){if(!(0,B.$zf)(p,I))return!1;if(I.length===p.length)return!0;let O=I.length;return I.charAt(I.length-1)===R&&O--,p.charAt(O)===R}return I.charAt(I.length-1)!==R&&(I+=R),p.indexOf(I)===0}function l(p){return p>=65&&p<=90||p>=97&&p<=122}function f(p,I){return C.$i&&p.endsWith(":")&&(p+=i.sep),(0,i.$jc)(p)||(p=(0,i.$kc)(I,p)),p=(0,i.$ic)(p),S(p)}function S(p){return C.$i?(p=(0,B.$gf)(p,i.sep),p.endsWith(":")&&(p+=i.sep)):(p=(0,B.$gf)(p,i.sep),p||(p=i.sep)),p}function m(p){const I=(0,i.$ic)(p);return C.$i?p.length>3?!1:b(I)&&(p.length===2||I.charCodeAt(2)===92):I===i.$hc.sep}function b(p,I=C.$i){return I?l(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}function r(p,I=C.$i){return b(p,I)?p[0]:void 0}function E(p,I,V){return I.length>p.length?-1:p===I?0:(V&&(p=p.toLowerCase(),I=I.toLowerCase()),p.indexOf(I))}function k(p){const I=p.split(":");let V,R,x;for(const O of I){const G=Number(O);(0,Q.$ag)(G)?R===void 0?R=G:x===void 0&&(x=G):V=V?[V,O].join(":"):O}if(!V)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:V,line:R!==void 0?R:void 0,column:x!==void 0?x:R!==void 0?1:void 0}}const F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",M="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function W(p,I,V=8){let R="";for(let O=0;O<V;O++){let G;O===0&&C.$i&&!I&&(V===3||V===4)?G=M:G=F,R+=G.charAt(Math.floor(Math.random()*G.length))}let x;return I?x=`${I}-${R}`:x=R,p?(0,i.$kc)(p,x):x}}),define(me[128],be([1,0,25]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qs=void 0,t.$Rs=Q,t.$Ss=A,t.$Ts=T,t.$Us=g,t.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function Q($){const P=(0,i.$pc)($),c=C[P.toLowerCase()];return c!==void 0?c:A($)}function A($){const P=(0,i.$pc)($);return B[P.toLowerCase()]}function T($){for(const P in B)if(B[P]===$)return P}const d=/^(.+)\/(.+?)(;.+)?$/;function g($,P){const c=d.exec($);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:P?void 0:$}}),define(me[16],be([1,0,25,5]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=m;const B=/^\w[\w\d+.-]*$/,Q=/^\//,A=/^\/\//;function T(F,M){if(!F.scheme&&M)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${F.authority}", path: "${F.path}", query: "${F.query}", fragment: "${F.fragment}"}`);if(F.scheme&&!B.test(F.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(F.path){if(F.authority){if(!Q.test(F.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(F.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(F,M){return!F&&!M?"file":F}function g(F,M){switch(F){case"https":case"http":case"file":M?M[0]!==P&&(M=P+M):M=P;break}return M}const $="",P="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(M){return M instanceof h?!0:M?typeof M.authority=="string"&&typeof M.fragment=="string"&&typeof M.path=="string"&&typeof M.query=="string"&&typeof M.scheme=="string"&&typeof M.fsPath=="string"&&typeof M.with=="function"&&typeof M.toString=="function":!1}constructor(M,W,p,I,V,R=!1){typeof M=="object"?(this.scheme=M.scheme||$,this.authority=M.authority||$,this.path=M.path||$,this.query=M.query||$,this.fragment=M.fragment||$):(this.scheme=d(M,R),this.authority=W||$,this.path=g(this.scheme,p||$),this.query=I||$,this.fragment=V||$,T(this,R))}get fsPath(){return m(this,!1)}with(M){if(!M)return this;let{scheme:W,authority:p,path:I,query:V,fragment:R}=M;return W===void 0?W=this.scheme:W===null&&(W=$),p===void 0?p=this.authority:p===null&&(p=$),I===void 0?I=this.path:I===null&&(I=$),V===void 0?V=this.query:V===null&&(V=$),R===void 0?R=this.fragment:R===null&&(R=$),W===this.scheme&&p===this.authority&&I===this.path&&V===this.query&&R===this.fragment?this:new o(W,p,I,V,R)}static parse(M,W=!1){const p=c.exec(M);return p?new o(p[2]||$,k(p[4]||$),k(p[5]||$),k(p[7]||$),k(p[9]||$),W):new o($,$,$,$,$)}static file(M){let W=$;if(C.$i&&(M=M.replace(/\\/g,P)),M[0]===P&&M[1]===P){const p=M.indexOf(P,2);p===-1?(W=M.substring(2),M=P):(W=M.substring(2,p),M=M.substring(p)||P)}return new o("file",W,M,$,$)}static from(M,W){return new o(M.scheme,M.authority,M.path,M.query,M.fragment,W)}static joinPath(M,...W){if(!M.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return C.$i&&M.scheme==="file"?p=h.file(i.$gc.join(m(M,!0),...W)).path:p=i.$hc.join(M.path,...W),M.with({path:p})}toString(M=!1){return b(this,M)}toJSON(){return this}static revive(M){if(M){if(M instanceof h)return M;{const W=new o(M);return W._formatted=M.external??null,W._fsPath=M._sep===n?M.fsPath??null:null,W}}else return M}}t.URI=h;function e(F){return!F||typeof F!="object"?!1:typeof F.scheme=="string"&&(typeof F.authority=="string"||typeof F.authority>"u")&&(typeof F.path=="string"||typeof F.path>"u")&&(typeof F.query=="string"||typeof F.query>"u")&&(typeof F.fragment=="string"||typeof F.fragment>"u")}const n=C.$i?1:void 0;class o extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(M=!1){return M?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const M={$mid:1};return this._fsPath&&(M.fsPath=this._fsPath,M._sep=n),this._formatted&&(M.external=this._formatted),this.path&&(M.path=this.path),this.scheme&&(M.scheme=this.scheme),this.authority&&(M.authority=this.authority),this.query&&(M.query=this.query),this.fragment&&(M.fragment=this.fragment),M}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(F,M,W){let p,I=-1;for(let V=0;V<F.length;V++){const R=F.charCodeAt(V);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||M&&R===47||W&&R===91||W&&R===93||W&&R===58)I!==-1&&(p+=encodeURIComponent(F.substring(I,V)),I=-1),p!==void 0&&(p+=F.charAt(V));else{p===void 0&&(p=F.substr(0,V));const x=l[R];x!==void 0?(I!==-1&&(p+=encodeURIComponent(F.substring(I,V)),I=-1),p+=x):I===-1&&(I=V)}}return I!==-1&&(p+=encodeURIComponent(F.substring(I))),p!==void 0?p:F}function S(F){let M;for(let W=0;W<F.length;W++){const p=F.charCodeAt(W);p===35||p===63?(M===void 0&&(M=F.substr(0,W)),M+=l[p]):M!==void 0&&(M+=F[W])}return M!==void 0?M:F}function m(F,M){let W;return F.authority&&F.path.length>1&&F.scheme==="file"?W=`//${F.authority}${F.path}`:F.path.charCodeAt(0)===47&&(F.path.charCodeAt(1)>=65&&F.path.charCodeAt(1)<=90||F.path.charCodeAt(1)>=97&&F.path.charCodeAt(1)<=122)&&F.path.charCodeAt(2)===58?M?W=F.path.substr(1):W=F.path[1].toLowerCase()+F.path.substr(2):W=F.path,C.$i&&(W=W.replace(/\//g,"\\")),W}function b(F,M){const W=M?S:f;let p="",{scheme:I,authority:V,path:R,query:x,fragment:O}=F;if(I&&(p+=I,p+=":"),(V||I==="file")&&(p+=P,p+=P),V){let G=V.indexOf("@");if(G!==-1){const q=V.substr(0,G);V=V.substr(G+1),G=q.lastIndexOf(":"),G===-1?p+=W(q,!1,!1):(p+=W(q.substr(0,G),!1,!1),p+=":",p+=W(q.substr(G+1),!1,!0)),p+="@"}V=V.toLowerCase(),G=V.lastIndexOf(":"),G===-1?p+=W(V,!1,!0):(p+=W(V.substr(0,G),!1,!0),p+=V.substr(G))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const G=R.charCodeAt(1);G>=65&&G<=90&&(R=`/${String.fromCharCode(G+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const G=R.charCodeAt(0);G>=65&&G<=90&&(R=`${String.fromCharCode(G+32)}:${R.substr(2)}`)}p+=W(R,!0,!1)}return x&&(p+="?",p+=W(x,!1,!1)),O&&(p+="#",p+=M?O:f(O,!1,!1)),p}function r(F){try{return decodeURIComponent(F)}catch{return F.length>3?F.substr(0,3)+r(F.substr(3)):F}}const E=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function k(F){return F.match(E)?F.replace(E,M=>r(M)):F}}),define(me[64],be([1,0,43,16]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4h=B,t.$5h=Q,t.$6h=T;function B(d){return JSON.stringify(d,A)}function Q(d){let g=JSON.parse(d);return g=T(g),g}function A(d,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function T(d,g=0){if(!d||g>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return C.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof i.$Ge||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let $=0;$<d.length;++$)d[$]=T(d[$],g+1);else for(const $ in d)Object.hasOwnProperty.call(d,$)&&(d[$]=T(d[$],g+1))}return d}}),define(me[36],be([1,0,6,5,9,16,25]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Jg=t.$Ig=t.$Hg=t.Schemas=void 0,t.$Fg=d,t.$Gg=g,t.$Kg=P;var T;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(T||(t.Schemas=T={}));function d(e,n){return Q.URI.isUri(e)?(0,B.$yf)(e.scheme,n):(0,B.$zf)(e,n+":")}function g(e,...n){return n.some(o=>d(e,o))}t.$Hg="vscode-tkn",t.$Ig="tkn";class ${constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=P(n,o)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,T.vscodeRemoteResource)}set(n,o,l){this.a[n]=o,this.b[n]=l}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(b){return i.$1(b),n}const o=n.authority;let l=this.a[o];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const f=this.b[o],S=this.c[o];let m=`path=${encodeURIComponent(n.path)}`;return typeof S=="string"&&(m+=`&${t.$Ig}=${encodeURIComponent(S)}`),Q.URI.from({scheme:C.$o?this.d:T.vscodeRemoteResource,authority:`${l}:${f}`,path:this.g,query:m})}}t.$Jg=new $;function P(e,n){return A.$hc.join(n??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Lg="vs/../../extensions",t.$Mg="vs/../../node_modules",t.$Ng="vs/../../node_modules.asar",t.$Og="vs/../../node_modules.asar.unpacked",t.$Pg="vscode-app";class c{static{this.a=t.$Pg}asBrowserUri(n){const o=this.b(n,se);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===T.vscodeRemote?t.$Jg.rewrite(n):n.scheme===T.file&&(C.$m||C.$q===`${T.vscodeFileResource}://${c.a}`)?n.with({scheme:T.vscodeFileResource,authority:n.authority||c.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,se);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===T.vscodeFileResource?n.with({scheme:T.file,authority:n.authority!==c.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return Q.URI.isUri(n)?n:Q.URI.parse(o.toUrl(n))}}t.$Qg=new c;var h;(function(e){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function l(S){let m;typeof S=="string"?m=new URL(S).searchParams:S instanceof URL?m=S.searchParams:Q.URI.isUri(S)&&(m=new URL(S.toString(!0)).searchParams);const b=m?.get(o);if(b)return n.get(b)}e.getHeadersFromQuery=l;function f(S,m,b){if(!globalThis.crossOriginIsolated)return;const r=m&&b?"3":b?"2":"1";S instanceof URLSearchParams?S.set(o,r):S[o]=r}e.addSearchParam=f})(h||(t.COI=h={}))}),define(me[47],be([1,0,127,36,25,5,9,16]),function(se,t,i,C,B,Q,A,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=void 0,t.$Xg=d,t.$gh=$,t.$hh=c;function d(h){return(0,T.$xc)(h,!0)}class g{constructor(e){this.a=e}compare(e,n,o=!1){return e===n?0:(0,A.$rf)(this.getComparisonKey(e,o),this.getComparisonKey(n,o))}isEqual(e,n,o=!1){return e===n?!0:!e||!n?!1:this.getComparisonKey(e,o)===this.getComparisonKey(n,o)}getComparisonKey(e,n=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,n,o=!1){if(e.scheme===n.scheme){if(e.scheme===C.Schemas.file)return i.$vg(d(e),d(n),this.a(e))&&e.query===n.query&&(o||e.fragment===n.fragment);if((0,t.$ch)(e.authority,n.authority))return i.$vg(e.path,n.path,this.a(e),"/")&&e.query===n.query&&(o||e.fragment===n.fragment)}return!1}joinPath(e,...n){return T.URI.joinPath(e,...n)}basenameOrAuthority(e){return(0,t.$7g)(e)||e.authority}basename(e){return B.$hc.basename(e.path)}extname(e){return B.$hc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let n;return e.scheme===C.Schemas.file?n=T.URI.file(B.$nc(d(e))).path:(n=B.$hc.dirname(e.path),e.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),n="/")),e.with({path:n})}normalizePath(e){if(!e.path.length)return e;let n;return e.scheme===C.Schemas.file?n=T.URI.file(B.$ic(d(e))).path:n=B.$hc.normalize(e.path),e.with({path:n})}relativePath(e,n){if(e.scheme!==n.scheme||!(0,t.$ch)(e.authority,n.authority))return;if(e.scheme===C.Schemas.file){const f=B.$mc(d(e),d(n));return Q.$i?i.$pg(f):f}let o=e.path||"/";const l=n.path||"/";if(this.a(e)){let f=0;for(const S=Math.min(o.length,l.length);f<S&&!(o.charCodeAt(f)!==l.charCodeAt(f)&&o.charAt(f).toLowerCase()!==l.charAt(f).toLowerCase());f++);o=l.substr(0,f)+o.substr(f)}return B.$hc.relative(o,l)}resolvePath(e,n){if(e.scheme===C.Schemas.file){const o=T.URI.file(B.$lc(d(e),n));return e.with({authority:o.authority,path:o.path})}return n=i.$qg(n),e.with({path:B.$hc.resolve(e.path,n)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,n){return e===n||e!==void 0&&n!==void 0&&(0,A.$yf)(e,n)}hasTrailingPathSeparator(e,n=B.sep){if(e.scheme===C.Schemas.file){const o=d(e);return o.length>i.$rg(o).length&&o[o.length-1]===n}else{const o=e.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,n=B.sep){return(0,t.$dh)(e,n)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,n=B.sep){let o=!1;if(e.scheme===C.Schemas.file){const l=d(e);o=l!==void 0&&l.length===i.$rg(l).length&&l[l.length-1]===n}else{n="/";const l=e.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,t.$dh)(e,n)?e.with({path:e.path+"/"}):e}}t.$Yg=g,t.$Zg=new g(()=>!1),t.$1g=new g(h=>h.scheme===C.Schemas.file?!Q.$k:!0),t.$2g=new g(h=>!0),t.$3g=t.$Zg.isEqual.bind(t.$Zg),t.$4g=t.$Zg.isEqualOrParent.bind(t.$Zg),t.$5g=t.$Zg.getComparisonKey.bind(t.$Zg),t.$6g=t.$Zg.basenameOrAuthority.bind(t.$Zg),t.$7g=t.$Zg.basename.bind(t.$Zg),t.$8g=t.$Zg.extname.bind(t.$Zg),t.$9g=t.$Zg.dirname.bind(t.$Zg),t.$0g=t.$Zg.joinPath.bind(t.$Zg),t.$$g=t.$Zg.normalizePath.bind(t.$Zg),t.$_g=t.$Zg.relativePath.bind(t.$Zg),t.$ah=t.$Zg.resolvePath.bind(t.$Zg),t.$bh=t.$Zg.isAbsolutePath.bind(t.$Zg),t.$ch=t.$Zg.isEqualAuthority.bind(t.$Zg),t.$dh=t.$Zg.hasTrailingPathSeparator.bind(t.$Zg),t.$eh=t.$Zg.removeTrailingPathSeparator.bind(t.$Zg),t.$fh=t.$Zg.addTrailingPathSeparator.bind(t.$Zg);function $(h,e){const n=[];for(let o=0;o<h.length;o++){const l=e(h[o]);h.some((f,S)=>S===o?!1:(0,t.$4g)(l,e(f)))||n.push(h[o])}return n}var P;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function e(n){const o=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(S=>{const[m,b]=S.split(":");m&&b&&o.set(m,b)});const f=n.path.substring(0,n.path.indexOf(";"));return f&&o.set(h.META_DATA_MIME,f),o}h.parseMetaData=e})(P||(t.DataUri=P={}));function c(h,e,n){if(e){let o=h.path;return o&&o[0]!==B.$hc.sep&&(o=B.$hc.sep+o),h.with({scheme:n,authority:e,path:o})}return h.with({scheme:n})}}),define(me[11],be([1,0,34,6,3,2,47,5,60,23]),function(se,t,i,C,B,Q,A,T,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zh=t.$Xh=t.$Wh=t.$Vh=t.$Uh=t.Promises=t.$Th=t.$Sh=t.$Rh=t.$Ph=t.$Oh=t.$Nh=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$wh=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.$qh=void 0,t.$ih=$,t.$jh=P,t.$kh=c,t.$lh=h,t.$mh=e,t.$nh=n,t.$oh=o,t.$ph=l,t.$xh=W,t.$yh=p,t.$zh=I,t.$Ah=V,t.$Bh=R,t.$Qh=_,t.$Yh=z;function $(y){return!!y&&typeof y.then=="function"}function P(y){const a=new i.$pe,v=y(a.token),N=new Promise((s,D)=>{const w=a.token.onCancellationRequested(()=>{w.dispose(),D(new C.$5)});Promise.resolve(v).then(L=>{w.dispose(),a.dispose(),s(L)},L=>{w.dispose(),a.dispose(),D(L)})});return new class{cancel(){a.cancel(),a.dispose()}then(s,D){return N.then(s,D)}catch(s){return this.then(void 0,s)}finally(s){return N.finally(s)}}}function c(y,a,v){return new Promise((N,s)=>{const D=a.onCancellationRequested(()=>{D.dispose(),N(v)});y.then(N,s).finally(()=>D.dispose())})}function h(y,a){return new Promise((v,N)=>{const s=a.onCancellationRequested(()=>{s.dispose(),N(new C.$5)});y.then(v,N).finally(()=>s.dispose())})}async function e(y){let a=-1;const v=y.map((N,s)=>N.then(D=>(a=s,D)));try{return await Promise.race(v)}finally{y.forEach((N,s)=>{s!==a&&N.cancel()})}}function n(y,a,v){let N;const s=setTimeout(()=>{N?.(void 0),v?.()},a);return Promise.race([y.finally(()=>clearTimeout(s)),new Promise(D=>N=D)])}function o(y){return new Promise((a,v)=>{const N=y();$(N)?N.then(a,v):a(N)})}function l(){let y,a;return{promise:new Promise((N,s)=>{y=N,a=s}),resolve:y,reject:a}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(a){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=a,!this.b){const v=()=>{if(this.b=null,this.f)return;const N=this.queue(this.d);return this.d=null,N};this.b=new Promise(N=>{this.a.then(v,v).then(N)})}return new Promise((v,N)=>{this.b.then(v,N)})}return this.a=a(),new Promise((v,N)=>{this.a.then(s=>{this.a=null,v(s)},s=>{this.a=null,N(s)})})}dispose(){this.f=!0}}t.$qh=f;class S{constructor(){this.a=Promise.resolve(null)}queue(a){return this.a=this.a.then(()=>a(),()=>a())}}t.$rh=S;class m{constructor(){this.a=new Map}queue(a,v){const s=(this.a.get(a)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.a.get(a)===s&&this.a.delete(a)});return this.a.set(a,s),s}}t.$sh=m;const b=(y,a)=>{let v=!0;const N=setTimeout(()=>{v=!1,a()},y);return{isTriggered:()=>v,dispose:()=>{clearTimeout(N),v=!1}}},r=y=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,y())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class E{constructor(a){this.defaultDelay=a,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(a,v=this.defaultDelay){this.g=a,this.h(),this.b||(this.b=new Promise((s,D)=>{this.d=s,this.f=D}).then(()=>{if(this.b=null,this.d=null,this.g){const s=this.g;return this.g=null,s()}}));const N=()=>{this.a=null,this.d?.(null)};return this.a=v===d.$be?r(N):b(v,N),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$th=E;class k{constructor(a){this.a=new E(a),this.b=new f}trigger(a,v){return this.a.trigger(()=>this.b.queue(a),v)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$uh=k;class F{constructor(){this.a=!1,this.b=new Promise((a,v)=>{this.d=a})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$vh=F;class M extends F{constructor(a){super(),this.f=setTimeout(()=>this.open(),a)}open(){clearTimeout(this.f),super.open()}}t.$wh=M;function W(y,a){return a?new Promise((v,N)=>{const s=setTimeout(()=>{D.dispose(),v()},y),D=a.onCancellationRequested(()=>{clearTimeout(s),D.dispose(),N(new C.$5)})}):P(v=>W(y,v))}function p(y,a=0,v){const N=setTimeout(()=>{y(),v&&s.dispose()},a),s=(0,Q.$Tc)(()=>{clearTimeout(N),v?.deleteAndLeak(s)});return v?.add(s),s}function I(y){const a=[];let v=0;const N=y.length;function s(){return v<N?y[v++]():null}function D(w){w!=null&&a.push(w);const L=s();return L?L.then(D):Promise.resolve(a)}return Promise.resolve(null).then(D)}function V(y,a=N=>!!N,v=null){let N=0;const s=y.length,D=()=>{if(N>=s)return Promise.resolve(v);const w=y[N++];return Promise.resolve(w()).then(j=>a(j)?Promise.resolve(j):D())};return D()}function R(y,a=N=>!!N,v=null){if(y.length===0)return Promise.resolve(v);let N=y.length;const s=()=>{N=-1;for(const D of y)D.cancel?.()};return new Promise((D,w)=>{for(const L of y)L.then(j=>{--N>=0&&a(j)?(s(),D(j)):N===0&&D(v)}).catch(j=>{--N>=0&&(s(),w(j))})})}class x{constructor(a){this.a=0,this.b=!1,this.f=a,this.g=[],this.d=0,this.h=new B.$ee}whenIdle(){return this.size>0?B.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(a){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((v,N)=>{this.g.push({factory:a,c:v,e:N}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const a=this.g.shift();this.d++;const v=a.factory();v.then(a.c,a.e),v.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$Ch=x;class O extends x{constructor(){super(1)}}t.$Dh=O;class G{constructor(){this.a=new ue,this.b=0}queue(a){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,a())):this.a.run(this.b++,a())}}t.$Eh=G;class q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const a=new H;return this.b.add(a),a.p}g(){for(const[,a]of this.a)if(a.size>0)return!1;return!0}queueSize(a,v=A.$Zg){const N=v.getComparisonKey(a);return this.a.get(N)?.size??0}queueFor(a,v,N=A.$Zg){const s=N.getComparisonKey(a);let D=this.a.get(s);if(!D){D=new O;const w=this.f++,L=B.Event.once(D.onDrained)(()=>{D?.dispose(),this.a.delete(s),this.h(),this.d?.deleteAndDispose(w),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new Q.$5c),this.d.set(w,L),this.a.set(s,D)}return D.queue(v)}h(){this.g()&&this.j()}j(){for(const a of this.b)a.complete();this.b.clear()}dispose(){for(const[,a]of this.a)a.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Fh=q;class ae{constructor(a,v){this.a=-1,typeof a=="function"&&typeof v=="number"&&this.setIfNotSet(a,v)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(a,v){this.cancel(),this.a=setTimeout(()=>{this.a=-1,a()},v)}setIfNotSet(a,v){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,a()},v))}}t.$Gh=ae;class ie{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(a,v,N=globalThis){this.cancel();const s=N.setInterval(()=>{a()},v);this.d=(0,Q.$Tc)(()=>{N.clearInterval(s),this.d=void 0})}dispose(){this.cancel()}}t.$Hh=ie;class ee{constructor(a,v){this.b=-1,this.a=a,this.d=v,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(a=this.d){this.cancel(),this.b=setTimeout(this.f,a)}get delay(){return this.d}set delay(a){this.d=a}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Ih=ee;class ce{constructor(a,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.a=a,this.b=v,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(a=this.b){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(a/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Jh=ce;class De extends ee{constructor(a,v){super(a,v),this.j=[]}work(a){this.j.push(a),this.isScheduled()||this.schedule()}h(){const a=this.j;this.j=[],this.a?.(a)}dispose(){this.j=[],super.dispose()}}t.$Kh=De;class Ee extends Q.$Vc{constructor(a,v){super(),this.g=a,this.h=v,this.a=[],this.b=this.B(new Q.$Wc),this.f=!1}get pending(){return this.a.length}work(a){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+a.length>this.g.maxBufferedWork)return!1}else if(this.pending+a.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const v of a)this.a.push(v);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Lh=Ee,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Nh=(y,a)=>{(0,T.$B)(()=>{if(v)return;const N=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:t.$Nh=(y,a,v)=>{const N=y.requestIdleCallback(a,typeof v=="number"?{timeout:v}:void 0);let s=!1;return{dispose(){s||(s=!0,y.cancelIdleCallback(N))}}},t.$Mh=y=>(0,t.$Nh)(globalThis,y)}();class Me{constructor(a,v){this.g=!1,this.d=()=>{try{this.j=v()}catch(N){this.l=N}finally{this.g=!0}},this.f=(0,t.$Nh)(a,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Oh=Me;class le extends Me{constructor(a){super(globalThis,a)}}t.$Ph=le;async function _(y,a,v){let N;for(let s=0;s<v;s++)try{return await y()}catch(D){N=D,await W(a)}throw N}class ue{isRunning(a){return typeof a=="number"?this.a?.taskId===a:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(a,v,N){return this.a={taskId:a,cancel:()=>N?.(),promise:v},v.then(()=>this.d(a),()=>this.d(a)),v}d(a){this.a&&a===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const a=this.b;this.b=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this.b)this.b.run=a;else{const{promise:v,resolve:N,reject:s}=l();this.b={run:a,promise:v,promiseResolve:N,promiseReject:s}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Rh=ue;class re{constructor(a,v=()=>Date.now()){this.d=a,this.f=v,this.a=0,this.b=0}increment(){const a=this.f();return a-this.a>this.d&&(this.a=a,this.b=0),this.b++,this.b}}t.$Sh=re;var ye;(function(y){y[y.Resolved=0]="Resolved",y[y.Rejected=1]="Rejected"})(ye||(ye={}));class H{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((a,v)=>{this.a=a,this.b=v})}complete(a){return new Promise(v=>{this.a(a),this.d={outcome:0,value:a},v()})}error(a){return new Promise(v=>{this.b(a),this.d={outcome:1,value:a},v()})}cancel(){return this.error(new C.$5)}}t.$Th=H;var J;(function(y){async function a(N){let s;const D=await Promise.all(N.map(w=>w.then(L=>L,L=>{s||(s=L)})));if(typeof s<"u")throw s;return D}y.settled=a;function v(N){return new Promise(async(s,D)=>{try{await N(s,D)}catch(w){D(w)}})}y.withAsyncBody=v})(J||(t.Promises=J={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(a){this.a=void 0,this.b=void 0,this.d=!1,this.promise=a.then(v=>(this.a=v,this.d=!0,v),v=>{throw this.b=v,this.d=!0,v})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Uh=ge;class we{constructor(a){this.b=a,this.a=new g.$V(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Vh=we;var ke;(function(y){y[y.Initial=0]="Initial",y[y.DoneOK=1]="DoneOK",y[y.DoneError=2]="DoneError"})(ke||(ke={}));class Fe{static fromArray(a){return new Fe(v=>{v.emitMany(a)})}static fromPromise(a){return new Fe(async v=>{v.emitMany(await a)})}static fromPromises(a){return new Fe(async v=>{await Promise.all(a.map(async N=>v.emitOne(await N)))})}static merge(a){return new Fe(async v=>{await Promise.all(a.map(async N=>{for await(const s of N)v.emitOne(s)}))})}static{this.EMPTY=Fe.fromArray([])}constructor(a,v){this.a=0,this.b=[],this.d=null,this.f=v,this.g=new B.$ee,queueMicrotask(async()=>{const N={emitOne:s=>this.h(s),emitMany:s=>this.j(s),reject:s=>this.l(s)};try{await Promise.resolve(a(N)),this.k()}catch(s){this.l(s)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(a<this.b.length)return{done:!1,value:this.b[a++]};if(this.a===1)return{done:!0,value:void 0};await B.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(a,v){return new Fe(async N=>{for await(const s of a)N.emitOne(v(s))})}map(a){return Fe.map(this,a)}static filter(a,v){return new Fe(async N=>{for await(const s of a)v(s)&&N.emitOne(s)})}filter(a){return Fe.filter(this,a)}static coalesce(a){return Fe.filter(a,v=>!!v)}coalesce(){return Fe.coalesce(this)}static async toPromise(a){const v=[];for await(const N of a)v.push(N);return v}toPromise(){return Fe.toPromise(this)}h(a){this.a===0&&(this.b.push(a),this.g.fire())}j(a){this.a===0&&(this.b=this.b.concat(a),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(a){this.a===0&&(this.a=2,this.d=a,this.g.fire())}}t.$Wh=Fe;class Ie extends Fe{constructor(a,v){super(v),this.m=a}cancel(){this.m.cancel()}}t.$Xh=Ie;function z(y){const a=new i.$pe,v=y(a.token);return new Ie(a,async N=>{const s=a.token.onCancellationRequested(()=>{s.dispose(),a.dispose(),N.reject(new C.$5)});try{for await(const D of v){if(a.token.isCancellationRequested)return;N.emitOne(D)}s.dispose(),a.dispose()}catch(D){s.dispose(),a.dispose(),N.reject(D)}})}class u{constructor(a){this.a=new H,this.b=new Fe(s=>{if(v){s.reject(v);return}return N&&s.emitMany(N),this.d=D=>s.reject(D),this.f=D=>s.emitOne(D),this.a.p},a);let v,N;this.f=s=>{N||(N=[]),N.push(s)},this.d=s=>{v||(v=s)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(a){this.d(a),this.a.complete()}emitOne(a){this.f(a)}}t.$Zh=u}),define(me[4],be([1,0,17,125,15,20,11,6,3,129,2,36,5,16,59,22]),function(se,t,i,C,B,Q,A,T,d,g,$,P,c,h,e,n){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.$jT=t.$hT=t.$eT=t.DetectedFullscreenMode=t.Namespace=t.$OS=t.$MS=t.$DS=t.$_R=t.$6R=t.$4R=t.$3R=t.$2R=t.$WR=t.$VR=t.$UR=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$SR=l,t.$TR=S,t.$XR=F,t.$YR=M,t.$ZR=W,t.$1R=p,t.$5R=V,t.$7R=O,t.$8R=G,t.$9R=ee,t.$0R=ce,t.$$R=De,t.$aS=le,t.$bS=_,t.$cS=ue,t.$dS=re,t.$eS=ye,t.$fS=H,t.$gS=J,t.$hS=ge,t.$iS=we,t.$jS=ke,t.$kS=Ie,t.$lS=z,t.$mS=y,t.$nS=v,t.$oS=N,t.$pS=s,t.$qS=D,t.$rS=w,t.$sS=L,t.$tS=j,t.$uS=X,t.$vS=Z,t.$wS=oe,t.$xS=pe,t.$yS=fe,t.$zS=Te,t.$AS=Oe,t.$BS=Ce,t.$CS=He,t.$ES=Xe,t.$FS=_e,t.$GS=Re,t.$HS=ze,t.$IS=et,t.$JS=it,t.$KS=st,t.$LS=Je,t.$NS=rt,t.$PS=tt,t.$QS=mt,t.$RS=At,t.$SS=kt,t.$TS=Tt,t.$US=Be,t.$VS=he,t.$=nt,t.$XS=lt,t.$YS=Ye,t.$ZS=ut,t.$1S=$t,t.$2S=Ut,t.$3S=Si,t.$4S=Ai,t.$5S=ki,t.$6S=Ti,t.$7S=Fi,t.$8S=Ci,t.$9S=Ni,t.$0S=Ri,t.$$S=Li,t.$_S=Jt,t.$aT=Mi,t.$bT=Ii,t.$cT=ji,t.$dT=_t,t.$fT=Bi,t.$gT=zi,t.$iT=Qi,t.h=Vi,t.$lT=ti,t.$mT=Ki,o=function(){const K=new Map;(0,n.$mR)(n.$nR,1);const U={window:n.$nR,disposables:new $.$Uc};K.set(n.$nR.vscodeWindowId,U);const te=new d.$ee,de=new d.$ee,Ae=new d.$ee;function xe(Pe,Ve){return(typeof Pe=="number"?K.get(Pe):void 0)??(Ve?U:void 0)}return{onDidRegisterWindow:te.event,onWillUnregisterWindow:Ae.event,onDidUnregisterWindow:de.event,registerWindow(Pe){if(K.has(Pe.vscodeWindowId))return $.$Vc.None;const Ve=new $.$Uc,qe={window:Pe,disposables:Ve.add(new $.$Uc)};return K.set(Pe.vscodeWindowId,qe),Ve.add((0,$.$Tc)(()=>{K.delete(Pe.vscodeWindowId),de.fire(Pe)})),Ve.add(S(Pe,t.$MS.BEFORE_UNLOAD,()=>{Ae.fire(Pe)})),te.fire(qe),Ve},getWindows(){return K.values()},getWindowsCount(){return K.size},getWindowId(Pe){return Pe.vscodeWindowId},hasWindow(Pe){return K.has(Pe)},getWindowById:xe,getWindow(Pe){const Ve=Pe;if(Ve?.ownerDocument?.defaultView)return Ve.ownerDocument.defaultView.window;const qe=Pe;return qe?.view?qe.view.window:n.$nR},getDocument(Pe){const Ve=Pe;return(0,t.getWindow)(Ve).document}}}(),t.registerWindow=o.registerWindow,t.getWindow=o.getWindow,t.getDocument=o.getDocument,t.getWindows=o.getWindows,t.getWindowsCount=o.getWindowsCount,t.getWindowId=o.getWindowId,t.getWindowById=o.getWindowById,t.hasWindow=o.hasWindow,t.onDidRegisterWindow=o.onDidRegisterWindow,t.onWillUnregisterWindow=o.onWillUnregisterWindow,t.onDidUnregisterWindow=o.onDidUnregisterWindow;function l(K){for(;K.firstChild;)K.firstChild.remove()}class f{constructor(U,te,de,Ae){this.f=U,this.g=te,this.d=de,this.j=Ae||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function S(K,U,te,de){return new f(K,U,te,de)}function m(K,U){return function(te){return U(new Q.$LR(K,te))}}function b(K){return function(U){return K(new B.$QR(U))}}const r=function(U,te,de,Ae){let xe=de;return te==="click"||te==="mousedown"?xe=m((0,t.getWindow)(U),de):(te==="keydown"||te==="keypress"||te==="keyup")&&(xe=b(de)),S(U,te,xe,Ae)};t.$UR=r;const E=function(U,te,de){const Ae=m((0,t.getWindow)(U),te);return F(U,Ae,de)};t.$VR=E;const k=function(U,te,de){const Ae=m((0,t.getWindow)(U),te);return W(U,Ae,de)};t.$WR=k;function F(K,U,te){return S(K,c.$r&&C.$IR.pointerEvents?t.$MS.POINTER_DOWN:t.$MS.MOUSE_DOWN,U,te)}function M(K,U,te){return S(K,c.$r&&C.$IR.pointerEvents?t.$MS.POINTER_MOVE:t.$MS.MOUSE_MOVE,U,te)}function W(K,U,te){return S(K,c.$r&&C.$IR.pointerEvents?t.$MS.POINTER_UP:t.$MS.MOUSE_UP,U,te)}function p(K,U,te){return(0,A.$Nh)(K,U,te)}class I extends A.$Oh{constructor(U,te){super(U,te)}}t.$2R=I;function V(K,U,te,de){let Ae=0;const xe=K.setInterval(()=>{Ae++,(typeof de=="number"&&Ae>=de||U()===!0)&&Pe.dispose()},te),Pe=(0,$.$Tc)(()=>{K.clearInterval(xe)});return Pe}class R extends A.$Hh{constructor(U){super(),this.f=U&&(0,t.getWindow)(U)}cancelAndSet(U,te,de){return super.cancelAndSet(U,te,de??this.f)}}t.$6R=R;class x{constructor(U,te=0){this.d=U,this.priority=te,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(U){(0,T.$1)(U)}}static sort(U,te){return te.priority-U.priority}}(function(){const K=new Map,U=new Map,te=new Map,de=new Map,Ae=xe=>{te.set(xe,!1);const Pe=K.get(xe)??[];for(U.set(xe,Pe),K.set(xe,[]),de.set(xe,!0);Pe.length>0;)Pe.sort(x.sort),Pe.shift().execute();de.set(xe,!1)};t.$4R=(xe,Pe,Ve=0)=>{const qe=(0,t.getWindowId)(xe),Ge=new x(Pe,Ve);let at=K.get(qe);return at||(at=[],K.set(qe,at)),at.push(Ge),te.get(qe)||(te.set(qe,!0),xe.requestAnimationFrame(()=>Ae(qe))),Ge},t.$3R=(xe,Pe,Ve)=>{const qe=(0,t.getWindowId)(xe);if(de.get(qe)){const Ge=new x(Pe,Ve);let at=U.get(qe);return at||(at=[],U.set(qe,at)),at.push(Ge),Ge}else return(0,t.$4R)(xe,Pe,Ve)}})();function O(K,U){return(0,t.$4R)(K,U,1e4)}function G(K,U){return(0,t.$4R)(K,U,-1e4)}const q=8,ae=function(K,U){return U};class ie extends $.$Vc{constructor(U,te,de,Ae=ae,xe=q){super();let Pe=null,Ve=0;const qe=this.B(new A.$Gh),Ge=()=>{Ve=new Date().getTime(),de(Pe),Pe=null};this.B(S(U,te,at=>{Pe=Ae(Pe,at);const Ct=new Date().getTime()-Ve;Ct>=xe?(qe.cancel(),Ge()):qe.setIfNotSet(Ge,xe-Ct)}))}}function ee(K,U,te,de,Ae){return new ie(K,U,te,de,Ae)}function ce(K){return(0,t.getWindow)(K).getComputedStyle(K,null)}function De(K,U){const te=(0,t.getWindow)(K),de=te.document;if(K!==de.body)return new Me(K.clientWidth,K.clientHeight);if(c.$r&&te?.visualViewport)return new Me(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Me(te.innerWidth,te.innerHeight);if(de.body&&de.body.clientWidth&&de.body.clientHeight)return new Me(de.body.clientWidth,de.body.clientHeight);if(de.documentElement&&de.documentElement.clientWidth&&de.documentElement.clientHeight)return new Me(de.documentElement.clientWidth,de.documentElement.clientHeight);if(U)return De(U);throw new Error("Unable to figure out browser width and height")}class Ee{static d(U,te){return parseFloat(te)||0}static f(U,te,de){const Ae=ce(U),xe=Ae?Ae.getPropertyValue(te):"0";return Ee.d(U,xe)}static getBorderLeftWidth(U){return Ee.f(U,"border-left-width","borderLeftWidth")}static getBorderRightWidth(U){return Ee.f(U,"border-right-width","borderRightWidth")}static getBorderTopWidth(U){return Ee.f(U,"border-top-width","borderTopWidth")}static getBorderBottomWidth(U){return Ee.f(U,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(U){return Ee.f(U,"padding-left","paddingLeft")}static getPaddingRight(U){return Ee.f(U,"padding-right","paddingRight")}static getPaddingTop(U){return Ee.f(U,"padding-top","paddingTop")}static getPaddingBottom(U){return Ee.f(U,"padding-bottom","paddingBottom")}static getMarginLeft(U){return Ee.f(U,"margin-left","marginLeft")}static getMarginTop(U){return Ee.f(U,"margin-top","marginTop")}static getMarginRight(U){return Ee.f(U,"margin-right","marginRight")}static getMarginBottom(U){return Ee.f(U,"margin-bottom","marginBottom")}}class Me{static{this.None=new Me(0,0)}constructor(U,te){this.width=U,this.height=te}with(U=this.width,te=this.height){return U!==this.width||te!==this.height?new Me(U,te):this}static is(U){return typeof U=="object"&&typeof U.height=="number"&&typeof U.width=="number"}static lift(U){return U instanceof Me?U:new Me(U.width,U.height)}static equals(U,te){return U===te?!0:!U||!te?!1:U.width===te.width&&U.height===te.height}}t.$_R=Me;function le(K){let U=K.offsetParent,te=K.offsetTop,de=K.offsetLeft;for(;(K=K.parentNode)!==null&&K!==K.ownerDocument.body&&K!==K.ownerDocument.documentElement;){te-=K.scrollTop;const Ae=D(K)?null:ce(K);Ae&&(de-=Ae.direction!=="rtl"?K.scrollLeft:-K.scrollLeft),K===U&&(de+=Ee.getBorderLeftWidth(K),te+=Ee.getBorderTopWidth(K),te+=K.offsetTop,de+=K.offsetLeft,U=K.offsetParent)}return{left:de,top:te}}function _(K,U,te){typeof U=="number"&&(K.style.width=`${U}px`),typeof te=="number"&&(K.style.height=`${te}px`)}function ue(K,U,te,de,Ae,xe="absolute"){typeof U=="number"&&(K.style.top=`${U}px`),typeof te=="number"&&(K.style.right=`${te}px`),typeof de=="number"&&(K.style.bottom=`${de}px`),typeof Ae=="number"&&(K.style.left=`${Ae}px`),K.style.position=xe}function re(K){const U=K.getBoundingClientRect(),te=(0,t.getWindow)(K);return{left:U.left+te.scrollX,top:U.top+te.scrollY,width:U.width,height:U.height}}function ye(K){let U=K,te=1;do{const de=ce(U).zoom;de!=null&&de!=="1"&&(te*=de),U=U.parentElement}while(U!==null&&U!==U.ownerDocument.documentElement);return te}function H(K){const U=Ee.getMarginLeft(K)+Ee.getMarginRight(K);return K.offsetWidth+U}function J(K){const U=Ee.getBorderLeftWidth(K)+Ee.getBorderRightWidth(K),te=Ee.getPaddingLeft(K)+Ee.getPaddingRight(K);return K.offsetWidth-U-te}function ge(K){const U=Ee.getMarginLeft(K)+Ee.getMarginRight(K);return K.scrollWidth+U}function we(K){const U=Ee.getBorderTopWidth(K)+Ee.getBorderBottomWidth(K),te=Ee.getPaddingTop(K)+Ee.getPaddingBottom(K);return K.offsetHeight-U-te}function ke(K){const U=Ee.getMarginTop(K)+Ee.getMarginBottom(K);return K.offsetHeight+U}function Fe(K,U){if(K===null)return 0;const te=le(K),de=le(U);return te.left-de.left}function Ie(K,U){const te=U.map(Ae=>Math.max(ge(Ae),H(Ae))+Fe(Ae,K)||0);return Math.max(...te)}function z(K,U){return!!U?.contains(K)}const u="parentFlowToElementId";function y(K,U){K.dataset[u]=U.id}function a(K){const U=K.dataset[u];return typeof U=="string"?K.ownerDocument.getElementById(U):null}function v(K,U){let te=K;for(;te;){if(te===U)return!0;if(te instanceof HTMLElement){const de=a(te);if(de){te=de;continue}}te=te.parentNode}return!1}function N(K,U,te){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K.classList.contains(U))return K;if(te){if(typeof te=="string"){if(K.classList.contains(te))return null}else if(K===te)return null}K=K.parentNode}return null}function s(K,U,te){return!!N(K,U,te)}function D(K){return K&&!!K.host&&!!K.mode}function w(K){return!!L(K)}function L(K){for(;K.parentNode;){if(K===K.ownerDocument?.body)return null;K=K.parentNode}return D(K)?K:null}function j(){let K=pe().activeElement;for(;K?.shadowRoot;)K=K.shadowRoot.activeElement;return K}function X(K){return j()===K}function Z(K){return z(j(),K)}function oe(K){return K.ownerDocument===pe()}function pe(){return(0,t.getWindowsCount)()<=1?n.$nR.document:Array.from((0,t.getWindows)()).map(({window:U})=>U.document).find(U=>U.hasFocus())??n.$nR.document}function fe(){return pe().defaultView?.window??n.$nR}const Le=new Map;function Te(K){return Le.has(K)}function Oe(){return new Se}class Se{constructor(){this.d="",this.f=void 0}setStyle(U){U!==this.d&&(this.d=U,this.f?this.f.innerText=U:this.f=Ce(n.$nR.document.head,te=>te.innerText=U))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ce(K=n.$nR.document.head,U,te){const de=document.createElement("style");if(de.type="text/css",de.media="screen",U?.(de),K.appendChild(de),te&&te.add((0,$.$Tc)(()=>K.removeChild(de))),K===n.$nR.document.head){const Ae=new Set;Le.set(de,Ae);for(const{window:xe,disposables:Pe}of(0,t.getWindows)()){if(xe===n.$nR)continue;const Ve=Pe.add(Ue(de,Ae,xe));te?.add(Ve)}}return de}function He(K){const U=new $.$Uc;for(const[te,de]of Le)U.add(Ue(te,de,K));return U}function Ue(K,U,te){const de=new $.$Uc,Ae=K.cloneNode(!0);te.document.head.appendChild(Ae),de.add((0,$.$Tc)(()=>te.document.head.removeChild(Ae)));for(const xe of ve(K))Ae.sheet?.insertRule(xe.cssText,Ae.sheet?.cssRules.length);return de.add(t.$DS.observe(K,de,{childList:!0})(()=>{Ae.textContent=K.textContent})),U.add(Ae),de.add((0,$.$Tc)(()=>U.delete(Ae))),de}t.$DS=new class{constructor(){this.mutationObservers=new Map}observe(K,U,te){let de=this.mutationObservers.get(K);de||(de=new Map,this.mutationObservers.set(K,de));const Ae=(0,e.$kj)(te);let xe=de.get(Ae);if(xe)xe.users+=1;else{const Pe=new d.$ee,Ve=new MutationObserver(Ge=>Pe.fire(Ge));Ve.observe(K,te);const qe=xe={users:1,observer:Ve,onDidMutate:Pe.event};U.add((0,$.$Tc)(()=>{qe.users-=1,qe.users===0&&(Pe.dispose(),Ve.disconnect(),de?.delete(Ae),de?.size===0&&this.mutationObservers.delete(K))})),de.set(Ae,xe)}return xe.onDidMutate}};function Xe(K=n.$nR.document.head){return Y("meta",K)}function _e(K=n.$nR.document.head){return Y("link",K)}function Y(K,U=n.$nR.document.head){const te=document.createElement(K);return U.appendChild(te),te}let ne=null;function $e(){return ne||(ne=Ce()),ne}function ve(K){return K?.sheet?.rules?K.sheet.rules:K?.sheet?.cssRules?K.sheet.cssRules:[]}function Re(K,U,te=$e()){if(!(!te||!U)){te.sheet?.insertRule(`${K} {${U}}`,0);for(const de of Le.get(te)??[])Re(K,U,de)}}function ze(K,U=$e()){if(!U)return;const te=ve(U),de=[];for(let Ae=0;Ae<te.length;Ae++){const xe=te[Ae];We(xe)&&xe.selectorText.indexOf(K)!==-1&&de.push(Ae)}for(let Ae=de.length-1;Ae>=0;Ae--)U.sheet?.deleteRule(de[Ae]);for(const Ae of Le.get(U)??[])ze(K,Ae)}function We(K){return typeof K.selectorText=="string"}function et(K){return K instanceof MouseEvent||K instanceof(0,t.getWindow)(K).MouseEvent}function it(K){return K instanceof KeyboardEvent||K instanceof(0,t.getWindow)(K).KeyboardEvent}function st(K){return K instanceof PointerEvent||K instanceof(0,t.getWindow)(K).PointerEvent}function Je(K){return K instanceof DragEvent||K instanceof(0,t.getWindow)(K).DragEvent}t.$MS={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$AR?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$AR?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$AR?"webkitAnimationIteration":"animationiteration"};function rt(K){const U=K;return!!(U&&typeof U.preventDefault=="function"&&typeof U.stopPropagation=="function")}t.$OS={stop:(K,U)=>(K.preventDefault(),U&&K.stopPropagation(),K)};function tt(K){const U=[];for(let te=0;K&&K.nodeType===K.ELEMENT_NODE;te++)U[te]=K.scrollTop,K=K.parentNode;return U}function mt(K,U){for(let te=0;K&&K.nodeType===K.ELEMENT_NODE;te++)K.scrollTop!==U[te]&&(K.scrollTop=U[te]),K=K.parentNode}class gt extends $.$Vc{static m(U){if(U instanceof HTMLElement){const te=L(U),de=te?te.activeElement:U.ownerDocument.activeElement;return z(de,U)}else{const te=U;return z(te.document.activeElement,te.document)}}constructor(U){super(),this.f=this.B(new d.$ee),this.onDidFocus=this.f.event,this.g=this.B(new d.$ee),this.onDidBlur=this.g.event;let te=gt.m(U),de=!1;const Ae=()=>{de=!1,te||(te=!0,this.f.fire())},xe=()=>{te&&(de=!0,(U instanceof HTMLElement?(0,t.getWindow)(U):U).setTimeout(()=>{de&&(de=!1,te=!1,this.g.fire())},0))};this.j=()=>{gt.m(U)!==te&&(te?xe():Ae())},this.B(S(U,t.$MS.FOCUS,Ae,!0)),this.B(S(U,t.$MS.BLUR,xe,!0)),U instanceof HTMLElement&&(this.B(S(U,t.$MS.FOCUS_IN,()=>this.j())),this.B(S(U,t.$MS.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function At(K){return new gt(K)}function kt(K,U){return K.after(U),U}function Tt(K,...U){if(K.append(...U),U.length===1&&typeof U[0]!="string")return U[0]}function Be(K,U){return K.insertBefore(U,K.firstChild),U}function he(K,...U){K.innerText="",Tt(K,...U)}const Ne=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var je;(function(K){K.HTML="http://www.w3.org/1999/xhtml",K.SVG="http://www.w3.org/2000/svg"})(je||(t.Namespace=je={}));function Ke(K,U,te,...de){const Ae=Ne.exec(U);if(!Ae)throw new Error("Bad use of emmet");const xe=Ae[1]||"div";let Pe;return K!==je.HTML?Pe=document.createElementNS(K,xe):Pe=document.createElement(xe),Ae[3]&&(Pe.id=Ae[3]),Ae[4]&&(Pe.className=Ae[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([Ve,qe])=>{typeof qe>"u"||(/^on\w+$/.test(Ve)?Pe[Ve]=qe:Ve==="selected"?qe&&Pe.setAttribute(Ve,"true"):Pe.setAttribute(Ve,qe))}),Pe.append(...de),Pe}function nt(K,U,...te){return Ke(je.HTML,K,U,...te)}nt.SVG=function(K,U,...te){return Ke(je.SVG,K,U,...te)};function lt(K,U){const te=[];return K.forEach((de,Ae)=>{Ae>0&&(U instanceof Node?te.push(U.cloneNode()):te.push(document.createTextNode(U))),te.push(de)}),te}function Ye(K,...U){K?ut(...U):$t(...U)}function ut(...K){for(const U of K)U.style.display="",U.removeAttribute("aria-hidden")}function $t(...K){for(const U of K)U.style.display="none",U.setAttribute("aria-hidden","true")}function Ft(K,U){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K instanceof HTMLElement&&K.hasAttribute(U))return K;K=K.parentNode}return null}function Ut(K){!K||!K.hasAttribute("tabIndex")||(K.ownerDocument.activeElement===K&&Ft(K.parentElement,"tabIndex")?.focus(),K.removeAttribute("tabindex"))}function Si(K){return U=>{U.preventDefault(),U.stopPropagation(),K(U)}}function Ai(K){return new Promise(U=>{if(K.document.readyState==="complete"||K.document&&K.document.body!==null)U(void 0);else{const de=()=>{K.window.removeEventListener("DOMContentLoaded",de,!1),U()};K.window.addEventListener("DOMContentLoaded",de,!1)}})}function ki(K,U){const te=K.devicePixelRatio*U;return Math.max(1,Math.floor(te))/K.devicePixelRatio}function Ti(K){n.$nR.open(K,"_blank","noopener")}const Yt=780,Zt=640;function Fi(K){const U=Math.floor(n.$nR.screenLeft+n.$nR.innerWidth/2-Yt/2),te=Math.floor(n.$nR.screenTop+n.$nR.innerHeight/2-Zt/2);n.$nR.open(K,"_blank",`width=${Yt},height=${Zt},top=${te},left=${U}`)}function Ci(K,U=!0){const te=n.$nR.open();return te?(U&&(te.opener=null),te.location.href=K,!0):!1}function Ni(K,U){const te=()=>{U(),de=(0,t.$4R)(K,te)};let de=(0,t.$4R)(K,te);return(0,$.$Tc)(()=>de.dispose())}P.$Jg.setPreferredWebSchema(/^https:/.test(n.$nR.location.href)?"https":"http");function Ri(K){return K?`url('${P.$Qg.uriToBrowserUri(K).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Li(K){return`'${K.replace(/'/g,"%27")}'`}function Jt(K,U){if(K!==void 0){const te=K.match(/^\s*var\((.+)\)$/);if(te){const de=te[1].split(",",2);return de.length===2&&(U=Jt(de[1].trim(),U)),`var(${de[0]}, ${U})`}return K}return U}function Mi(K,U){let te;if(h.URI.isUri(K))te=K.toString(!0);else{const xe=new Blob([K]);te=URL.createObjectURL(xe),setTimeout(()=>URL.revokeObjectURL(te))}const de=fe(),Ae=document.createElement("a");de.document.body.appendChild(Ae),Ae.download=U,Ae.href=te,Ae.click(),setTimeout(()=>de.document.body.removeChild(Ae))}function Ii(){return new Promise(K=>{const U=fe(),te=document.createElement("input");U.document.body.appendChild(te),te.type="file",te.multiple=!0,d.Event.once(d.Event.fromDOMEventEmitter(te,"input"))(()=>{K(te.files??void 0)}),te.click(),setTimeout(()=>U.document.body.removeChild(te))})}var yt;(function(K){K[K.DOCUMENT=1]="DOCUMENT",K[K.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function ji(K){return K.document.fullscreenElement||K.document.webkitFullscreenElement||K.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:K.innerHeight===K.screen.height?{mode:yt.BROWSER,guess:!1}:(c.$j||c.$k)&&K.outerHeight===K.screen.height&&K.outerWidth===K.screen.width?{mode:yt.BROWSER,guess:!0}:null}function _t(K,U=!1){const te=document.createElement("a");return g.addHook("afterSanitizeAttributes",de=>{for(const Ae of["href","src"])if(de.hasAttribute(Ae)){const xe=de.getAttribute(Ae);if(Ae==="href"&&xe.startsWith("#"))continue;if(te.href=xe,!K.includes(te.protocol.replace(/:$/,""))){if(U&&Ae==="src"&&te.href.startsWith("data:"))continue;de.removeAttribute(Ae)}}}),(0,$.$Tc)(()=>{g.removeHook("afterSanitizeAttributes")})}const Oi=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.$eT=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Pi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(K,U){const te=_t(Oi);try{const de=g.sanitize(U,Pi);K.innerHTML=de}finally{te.dispose()}}function xi(K){const U=new Uint16Array(K.length);for(let Ae=0;Ae<U.length;Ae++)U[Ae]=K.charCodeAt(Ae);let te="";const de=new Uint8Array(U.buffer);for(let Ae=0;Ae<de.length;Ae++)te+=String.fromCharCode(de[Ae]);return te}function zi(K){return btoa(xi(K))}class pt extends d.$ee{constructor(){super(),this.o=new $.$Uc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(d.Event.runAndSubscribe(t.onDidRegisterWindow,({window:U,disposables:te})=>this.C(U,te),{window:n.$nR,disposables:this.o}))}C(U,te){te.add(S(U,"keydown",de=>{if(de.defaultPrevented)return;const Ae=new B.$QR(de);if(!(Ae.keyCode===6&&de.repeat)){if(de.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(de.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(de.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(de.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Ae.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyPressed&&(this.A.event=de,this.fire(this.A))}},!0)),te.add(S(U,"keyup",de=>{de.defaultPrevented||(!de.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!de.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!de.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!de.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyReleased&&(this.A.event=de,this.fire(this.A)))},!0)),te.add(S(U.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(S(U.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(S(U.document.body,"mousemove",de=>{de.buttons&&(this.A.lastKeyPressed=void 0)},!0)),te.add(S(U,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$hT=pt;function Qi(K){const U=document.cookie.match("(^|[^;]+)\\s*"+K+"\\s*=\\s*([^;]+)");return U?U.pop():void 0}class Hi extends $.$Vc{constructor(U,te){super(),this.j=U,this.m=te,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(S(this.j,t.$MS.DRAG_START,U=>{this.m.onDragStart?.(U)})),this.m.onDrag&&this.B(S(this.j,t.$MS.DRAG,U=>{this.m.onDrag?.(U)})),this.B(S(this.j,t.$MS.DRAG_ENTER,U=>{this.f++,this.g=U.timeStamp,this.m.onDragEnter?.(U)})),this.B(S(this.j,t.$MS.DRAG_OVER,U=>{U.preventDefault(),this.m.onDragOver?.(U,U.timeStamp-this.g)})),this.B(S(this.j,t.$MS.DRAG_LEAVE,U=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(U))})),this.B(S(this.j,t.$MS.DRAG_END,U=>{this.f=0,this.g=0,this.m.onDragEnd?.(U)})),this.B(S(this.j,t.$MS.DROP,U=>{this.f=0,this.g=0,this.m.onDrop?.(U)}))}}t.$jT=Hi;const Wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Vi(K,...U){let te,de;Array.isArray(U[0])?(te={},de=U[0]):(te=U[0]||{},de=U[1]);const Ae=Wi.exec(K);if(!Ae||!Ae.groups)throw new Error("Bad use of h");const xe=Ae.groups.tag||"div",Pe=document.createElement(xe);Ae.groups.id&&(Pe.id=Ae.groups.id);const Ve=[];if(Ae.groups.class)for(const Ge of Ae.groups.class.split("."))Ge!==""&&Ve.push(Ge);if(te.className!==void 0)for(const Ge of te.className.split("."))Ge!==""&&Ve.push(Ge);Ve.length>0&&(Pe.className=Ve.join(" "));const qe={};if(Ae.groups.name&&(qe[Ae.groups.name]=Pe),de)for(const Ge of de)Ge instanceof HTMLElement?Pe.appendChild(Ge):typeof Ge=="string"?Pe.append(Ge):"root"in Ge&&(Object.assign(qe,Ge),Pe.appendChild(Ge.root));for(const[Ge,at]of Object.entries(te))if(Ge!=="className")if(Ge==="style")for(const[Ct,Pt]of Object.entries(at))Pe.style.setProperty(ei(Ct),typeof Pt=="number"?Pt+"px":""+Pt);else Ge==="tabIndex"?Pe.tabIndex=at:Pe.setAttribute(ei(Ge),at.toString());return qe.root=Pe,qe}function ei(K){return K.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(K,U,te){for(const{name:de,value:Ae}of K.attributes)(!te||te.includes(de))&&U.setAttribute(de,Ae)}function qi(K,U,te){const de=K.getAttribute(te);de?U.setAttribute(te,de):U.removeAttribute(te)}function Ki(K,U,te){ti(K,U,te);const de=new $.$Uc;return de.add(t.$DS.observe(K,de,{attributes:!0,attributeFilter:te})(Ae=>{for(const xe of Ae)xe.type==="attributes"&&xe.attributeName&&qi(K,U,xe.attributeName)})),de}}),define(me[65],be([1,0,4,2,128]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=t.$nT=void 0,t.$pT=A;class Q extends C.$Vc{constructor(d,g){super(),this.B((0,i.$TR)(d,"dragover",$=>{$.preventDefault(),this.a||(this.a=setTimeout(()=>{g(),this.a=null},800))})),["dragleave","drop","dragend"].forEach($=>{this.B((0,i.$TR)(d,$,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$nT=Q,t.$oT={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:B.$Qs.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function A(T,d,g,$,P){const c=document.createElement("div");if(c.className=g,c.textContent=d,P&&(c.style.color=P),$&&(c.style.background=$),T.dataTransfer){const h=(0,i.getWindow)(T).document;h.body.appendChild(c),T.dataTransfer.setDragImage(c,-10,-10),setTimeout(()=>h.body.removeChild(c),0)}}}),define(me[66],be([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UT=C,t.$VT=B,t.$WT=Q;function C(c,h={}){const e=Q(h);return e.textContent=c,e}function B(c,h={}){const e=Q(h);return d(e,g(c,!!h.renderCodeSegments),h.actionHandler,h.renderCodeSegments),e}function Q(c){const h=c.inline?"span":"div",e=document.createElement(h);return c.className&&(e.className=c.className),e}class A{constructor(h){this.b=h,this.c=0}eos(){return this.c>=this.b.length}next(){const h=this.peek();return this.advance(),h}peek(){return this.b[this.c]}advance(){this.c++}}var T;(function(c){c[c.Invalid=0]="Invalid",c[c.Root=1]="Root",c[c.Text=2]="Text",c[c.Bold=3]="Bold",c[c.Italics=4]="Italics",c[c.Action=5]="Action",c[c.ActionClose=6]="ActionClose",c[c.Code=7]="Code",c[c.NewLine=8]="NewLine"})(T||(T={}));function d(c,h,e,n){let o;if(h.type===2)o=document.createTextNode(h.content||"");else if(h.type===3)o=document.createElement("b");else if(h.type===4)o=document.createElement("i");else if(h.type===7&&n)o=document.createElement("code");else if(h.type===5&&e){const l=document.createElement("a");e.disposables.add(i.$UR(l,"click",f=>{e.callback(String(h.index),f)})),o=l}else h.type===8?o=document.createElement("br"):h.type===1&&(o=c);o&&c!==o&&c.appendChild(o),o&&Array.isArray(h.children)&&h.children.forEach(l=>{d(o,l,e,n)})}function g(c,h){const e={type:1,children:[]};let n=0,o=e;const l=[],f=new A(c);for(;!f.eos();){let S=f.next();const m=S==="\\"&&P(f.peek(),h)!==0;if(m&&(S=f.next()),!m&&$(S,h)&&S===f.peek()){f.advance(),o.type===2&&(o=l.pop());const b=P(S,h);if(o.type===b||o.type===5&&b===6)o=l.pop();else{const r={type:b,children:[]};b===5&&(r.index=n,n++),o.children.push(r),l.push(o),o=r}}else if(S===`
`)o.type===2&&(o=l.pop()),o.children.push({type:8});else if(o.type!==2){const b={type:2,content:S};o.children.push(b),l.push(o),o=b}else o.content+=S}return o.type===2&&(o=l.pop()),l.length,e}function $(c,h){return P(c,h)!==0}function P(c,h){switch(c){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return h?7:0;default:return 0}}}),define(me[67],be([1,0,4,2]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tT=void 0;class B{constructor(){this.a=new C.$Uc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(A,T){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const d=this.c;this.c=null,A&&d&&d(T)}isMonitoring(){return!!this.b}startMonitoring(A,T,d,g,$){this.isMonitoring()&&this.stopMonitoring(!1),this.b=g,this.c=$;let P=A;try{A.setPointerCapture(T),this.a.add((0,C.$Tc)(()=>{try{A.releasePointerCapture(T)}catch{}}))}catch{P=i.getWindow(A)}this.a.add(i.$TR(P,i.$MS.POINTER_MOVE,c=>{if(c.buttons!==d){this.stopMonitoring(!0);return}c.preventDefault(),this.b(c)})),this.a.add(i.$TR(P,i.$MS.POINTER_UP,c=>this.stopMonitoring(!0)))}}t.$tT=B});var Ze=this&&this.__decorate||function(se,t,i,C){var B=arguments.length,Q=B<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,i):C,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")Q=Reflect.decorate(se,t,i,C);else for(var T=se.length-1;T>=0;T--)(A=se[T])&&(Q=(B<3?A(Q):B>3?A(t,i,Q):A(t,i))||Q);return B>3&&Q&&Object.defineProperty(t,i,Q),Q};define(me[28],be([1,0,4,22,8,31,3,2,55]),function(se,t,i,C,B,Q,A,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qT=t.EventType=void 0;var g;(function(P){P.Tap="-monaco-gesturetap",P.Change="-monaco-gesturechange",P.Start="-monaco-gesturestart",P.End="-monaco-gesturesend",P.Contextmenu="-monaco-gesturecontextmenu"})(g||(t.EventType=g={}));class $ extends T.$Vc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new d.$6c,this.m=new d.$6c,this.r={},this.n=null,this.s=0,this.B(A.Event.runAndSubscribe(i.onDidRegisterWindow,({window:c,disposables:h})=>{h.add(i.$TR(c.document,"touchstart",e=>this.w(e),{passive:!1})),h.add(i.$TR(c.document,"touchend",e=>this.z(c,e))),h.add(i.$TR(c.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:C.$nR,disposables:this.q}))}static addTarget(c){if(!$.isTouchDevice())return T.$Vc.None;$.f||($.f=(0,T.$Oc)(new $));const h=$.f.j.push(c);return(0,T.$Tc)(h)}static ignoreTarget(c){if(!$.isTouchDevice())return T.$Vc.None;$.f||($.f=(0,T.$Oc)(new $));const h=$.f.m.push(c);return(0,T.$Tc)(h)}static isTouchDevice(){return"ontouchstart"in C.$nR||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w(c){const h=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,n=c.targetTouches.length;e<n;e++){const o=c.targetTouches.item(e);this.r[o.identifier]={id:o.identifier,initialTarget:o.target,initialTimeStamp:h,initialPageX:o.pageX,initialPageY:o.pageY,rollingTimestamps:[h],rollingPageX:[o.pageX],rollingPageY:[o.pageY]};const l=this.C(g.Start,o.target);l.pageX=o.pageX,l.pageY=o.pageY,this.D(l)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}z(c,h){const e=Date.now(),n=Object.keys(this.r).length;for(let o=0,l=h.changedTouches.length;o<l;o++){const f=h.changedTouches.item(o);if(!this.r.hasOwnProperty(String(f.identifier))){console.warn("move of an UNKNOWN touch",f);continue}const S=this.r[f.identifier],m=Date.now()-S.initialTimeStamp;if(m<$.g&&Math.abs(S.initialPageX-B.$sb(S.rollingPageX))<30&&Math.abs(S.initialPageY-B.$sb(S.rollingPageY))<30){const b=this.C(g.Tap,S.initialTarget);b.pageX=B.$sb(S.rollingPageX),b.pageY=B.$sb(S.rollingPageY),this.D(b)}else if(m>=$.g&&Math.abs(S.initialPageX-B.$sb(S.rollingPageX))<30&&Math.abs(S.initialPageY-B.$sb(S.rollingPageY))<30){const b=this.C(g.Contextmenu,S.initialTarget);b.pageX=B.$sb(S.rollingPageX),b.pageY=B.$sb(S.rollingPageY),this.D(b)}else if(n===1){const b=B.$sb(S.rollingPageX),r=B.$sb(S.rollingPageY),E=B.$sb(S.rollingTimestamps)-S.rollingTimestamps[0],k=b-S.rollingPageX[0],F=r-S.rollingPageY[0],M=[...this.j].filter(W=>S.initialTarget instanceof Node&&W.contains(S.initialTarget));this.F(c,M,e,Math.abs(k)/E,k>0?1:-1,b,Math.abs(F)/E,F>0?1:-1,r)}this.D(this.C(g.End,S.initialTarget)),delete this.r[f.identifier]}this.h&&(h.preventDefault(),h.stopPropagation(),this.h=!1)}C(c,h){const e=document.createEvent("CustomEvent");return e.initEvent(c,!1,!0),e.initialTarget=h,e.tapCount=0,e}D(c){if(c.type===g.Tap){const h=new Date().getTime();let e=0;h-this.s>$.u?e=1:e=2,this.s=h,c.tapCount=e}else(c.type===g.Change||c.type===g.Contextmenu)&&(this.s=0);if(c.initialTarget instanceof Node){for(const e of this.m)if(e.contains(c.initialTarget))return;const h=[];for(const e of this.j)if(e.contains(c.initialTarget)){let n=0,o=c.initialTarget;for(;o&&o!==e;)n++,o=o.parentElement;h.push([n,e])}h.sort((e,n)=>e[0]-n[0]);for(const[e,n]of h)n.dispatchEvent(c),this.h=!0}}F(c,h,e,n,o,l,f,S,m){this.n=i.$4R(c,()=>{const b=Date.now(),r=b-e;let E=0,k=0,F=!0;n+=$.c*r,f+=$.c*r,n>0&&(F=!1,E=o*n*r),f>0&&(F=!1,k=S*f*r);const M=this.C(g.Change);M.translationX=E,M.translationY=k,h.forEach(W=>W.dispatchEvent(M)),F||this.F(c,h,b,n,o,l+E,f,S,m+k)})}G(c){const h=Date.now();for(let e=0,n=c.changedTouches.length;e<n;e++){const o=c.changedTouches.item(e);if(!this.r.hasOwnProperty(String(o.identifier))){console.warn("end of an UNKNOWN touch",o);continue}const l=this.r[o.identifier],f=this.C(g.Change,l.initialTarget);f.translationX=o.pageX-B.$sb(l.rollingPageX),f.translationY=o.pageY-B.$sb(l.rollingPageY),f.pageX=o.pageX,f.pageY=o.pageY,this.D(f),l.rollingPageX.length>3&&(l.rollingPageX.shift(),l.rollingPageY.shift(),l.rollingTimestamps.shift()),l.rollingPageX.push(o.pageX),l.rollingPageY.push(o.pageY),l.rollingTimestamps.push(h)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}}t.$qT=$,Ze([Q.$1h],$,"isTouchDevice",null)}),define(me[68],be([1,0,4,104]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YT=g,t.$ZT=$,t.$1T=P;const C=2e4;let B,Q,A,T,d;function g(h){B=document.createElement("div"),B.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),B.appendChild(o),o};Q=e(),A=e();const n=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),B.appendChild(o),o};T=n(),d=n(),h.appendChild(B)}function $(h){B&&(Q.textContent!==h?(i.$SR(A),c(Q,h)):(i.$SR(Q),c(A,h)))}function P(h){B&&(T.textContent!==h?(i.$SR(d),c(T,h)):(i.$SR(T),c(d,h)))}function c(h,e){i.$SR(h),e.length>C&&(e=e.substr(0,C)),h.textContent=e,h.style.visibility="hidden",h.style.visibility="visible"}}),define(me[130],be([1,0,4,19]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rU=Q,t.$sU=A;const B=new RegExp(`(\\\\)?\\$\\((${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?)\\)`,"g");function Q(T){const d=new Array;let g,$=0,P=0;for(;(g=B.exec(T))!==null;){P=g.index||0,$<P&&d.push(T.substring($,P)),$=(g.index||0)+g[0].length;const[,c,h]=g;d.push(c?`$(${h})`:A({id:h}))}return $<T.length&&d.push(T.substring($)),d}function A(T){const d=i.$("span");return d.classList.add(...C.ThemeIcon.asClassNameArray(T)),d}}),define(me[131],be([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7T=void 0;function C(Q){try{Q.parentElement?.removeChild(Q)}catch{}}class B{constructor(A){this.d=A,this.a=new Map,this.b=new Set,this.c=!1}alloc(A){let T=this.h(A).pop(),d=!1;if(T)d=this.b.has(T.domNode),d&&this.b.delete(T.domNode);else{const g=(0,i.$)(".monaco-list-row"),P=this.i(A).renderTemplate(g);T={domNode:g,templateId:A,templateData:P}}return{row:T,isReusingConnectedDomNode:d}}release(A){A&&this.f(A)}transact(A){if(this.c)throw new Error("Already in transaction");this.c=!0;try{A()}finally{for(const T of this.b)this.g(T);this.b.clear(),this.c=!1}}f(A){const{domNode:T,templateId:d}=A;T&&(this.c?this.b.add(T):this.g(T)),this.h(d).push(A)}g(A){A.classList.remove("scrolling"),C(A)}h(A){let T=this.a.get(A);return T||(T=[],this.a.set(A,T)),T}dispose(){this.a.forEach((A,T)=>{for(const d of A)this.i(T).disposeTemplate(d.templateData),d.templateData=null}),this.a.clear(),this.b.clear()}i(A){const T=this.d.get(A);if(!T)throw new Error(`No renderer found for ${A}`);return T}}t.$7T=B}),define(me[132],be([1,0,11,2]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yT=void 0;class B extends C.$Vc{constructor(A,T,d){super(),this.a=A,this.b=T,this.c=d,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$Gh)}setVisibility(A){this.a!==A&&(this.a=A,this.s())}setShouldBeVisible(A){this.g=A,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const A=this.r();this.h!==A&&(this.h=A,this.ensureVisibility())}setIsNeeded(A){this.j!==A&&(this.j=A,this.ensureVisibility())}setDomNode(A){this.f=A,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(A){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(A?" fade":"")))}}t.$yT=B}),define(me[133],be([1,0,4,28,8,3,2,5]),function(se,t,i,C,B,Q,A,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BU=void 0;class d extends A.$Vc{constructor($,P,c,h){super(),this.f=0,this.b=h||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new Q.$ee),this.h=c,this.j(),this.setOptions($,P)}j(){this.B(C.$qT.addTarget(this.a)),[C.EventType.Tap].forEach($=>{this.B(i.$TR(this.a,$,P=>{this.a.focus()}))}),this.B(i.$UR(this.a,"click",$=>{i.$OS.stop($,!0)})),this.B(i.$UR(this.a,"change",$=>{this.a.title=$.target.value,this.g.fire({index:$.target.selectedIndex,selected:$.target.value})})),this.B(i.$UR(this.a,"keydown",$=>{let P=!1;T.$j?($.keyCode===18||$.keyCode===16||$.keyCode===10)&&(P=!0):($.keyCode===18&&$.altKey||$.keyCode===10||$.keyCode===3)&&(P=!0),P&&$.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions($,P){(!this.c||!B.$ub(this.c,$))&&(this.c=$,this.a.options.length=0,this.c.forEach((c,h)=>{this.a.add(this.m(c.text,h,c.isDisabled))})),P!==void 0&&this.select(P)}select($){this.c.length===0?this.f=0:$>=0&&$<this.c.length?this.f=$:$>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel($){this.b.ariaLabel=$,this.a.setAttribute("aria-label",$)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable($){this.a.tabIndex=$?0:-1}render($){$.classList.add("select-container"),$.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style($){this.h=$,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m($,P,c){const h=document.createElement("option");return h.value=$,h.text=$,h.disabled=!!c,h}}t.$BU=d}),define(me[69],be([1,0,30,8,11,60,98,3,32]),function(se,t,i,C,B,Q,A,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bW=void 0,t.$_V=g,t.$aW=$;function g(h){return typeof h=="object"&&"visibility"in h&&"data"in h}function $(h){switch(h){case!0:return 1;case!1:return 0;default:return h}}function P(h){return typeof h.collapsible=="boolean"}class c{constructor(e,n,o,l={}){this.p=e,this.q=n,this.rootRef=[],this.d=new T.$me,this.f=new T.$ee,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new T.$ee,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new T.$ee,this.onDidSplice=this.m.event,this.o=new B.$th(Q.$be),this.h=typeof l.collapseByDefault>"u"?!1:l.collapseByDefault,this.j=l.allowNonCollapsibleParents??!1,this.k=l.filter,this.l=typeof l.autoExpandSingleChildren>"u"?!1:l.autoExpandSingleChildren,this.c={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,n,o=d.Iterable.empty(),l={}){if(e.length===0)throw new i.$0V(this.p,"Invalid tree location");l.diffIdentityProvider?this.s(l.diffIdentityProvider,e,n,o,l):this.t(e,n,o,l)}s(e,n,o,l=d.Iterable.empty(),f,S=f.diffDepth??0){const{parentNode:m}=this.H(n);if(!m.lastDiffIds)return this.t(n,o,l,f);const b=[...l],r=n[n.length-1],E=new A.$At({getElements:()=>m.lastDiffIds},{getElements:()=>[...m.children.slice(0,r),...b,...m.children.slice(r+o)].map(p=>e.getId(p.element).toString())}).ComputeDiff(!1);if(E.quitEarly)return m.lastDiffIds=void 0,this.t(n,o,b,f);const k=n.slice(0,-1),F=(p,I,V)=>{if(S>0)for(let R=0;R<V;R++)p--,I--,this.s(e,[...k,p,0],Number.MAX_SAFE_INTEGER,b[I].children,f,S-1)};let M=Math.min(m.children.length,r+o),W=b.length;for(const p of E.changes.sort((I,V)=>V.originalStart-I.originalStart))F(M,W,M-(p.originalStart+p.originalLength)),M=p.originalStart,W=p.modifiedStart-r,this.t([...k,M],p.originalLength,d.Iterable.slice(b,W,W+p.modifiedLength),f);F(M,W,M)}t(e,n,o=d.Iterable.empty(),{onDidCreateNode:l,onDidDeleteNode:f,diffIdentityProvider:S}){const{parentNode:m,listIndex:b,revealed:r,visible:E}=this.H(e),k=[],F=d.Iterable.map(o,G=>this.x(G,m,m.visible?1:0,r,k,l)),M=e[e.length-1];let W=0;for(let G=M;G>=0&&G<m.children.length;G--){const q=m.children[G];if(q.visible){W=q.visibleChildIndex;break}}const p=[];let I=0,V=0;for(const G of F)p.push(G),V+=G.renderNodeCount,G.visible&&(G.visibleChildIndex=W+I++);const R=(0,C.$6b)(m.children,M,n,p);S?m.lastDiffIds?(0,C.$6b)(m.lastDiffIds,M,n,p.map(G=>S.getId(G.element).toString())):m.lastDiffIds=m.children.map(G=>S.getId(G.element).toString()):m.lastDiffIds=void 0;let x=0;for(const G of R)G.visible&&x++;if(x!==0)for(let G=M+p.length;G<m.children.length;G++){const q=m.children[G];q.visible&&(q.visibleChildIndex-=x)}if(m.visibleChildrenCount+=I-x,r&&E){const G=R.reduce((q,ae)=>q+(ae.visible?ae.renderNodeCount:0),0);this.C(m,V-G),this.q.splice(b,G,k)}if(R.length>0&&f){const G=q=>{f(q),q.children.forEach(G)};R.forEach(G)}this.m.fire({insertedNodes:p,deletedNodes:R});let O=m;for(;O;){if(O.visibility===2){this.o.trigger(()=>this.refilter());break}O=O.parent}}rerender(e){if(e.length===0)throw new i.$0V(this.p,"Invalid tree location");const{node:n,listIndex:o,revealed:l}=this.G(e);n.visible&&l&&this.q.splice(o,1,[n])}updateElementHeight(e,n){if(e.length===0)throw new i.$0V(this.p,"Invalid tree location");const{listIndex:o}=this.G(e);this.q.updateElementHeight(o,n)}has(e){return this.E(e)}getListIndex(e){const{listIndex:n,visible:o,revealed:l}=this.G(e);return o&&l?n:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,n){const o=this.F(e);typeof n>"u"&&(n=!o.collapsible);const l={collapsible:n};return this.d.bufferEvents(()=>this.u(e,l))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,n,o){const l=this.F(e);typeof n>"u"&&(n=!l.collapsed);const f={collapsed:n,recursive:o||!1};return this.d.bufferEvents(()=>this.u(e,f))}u(e,n){const{node:o,listIndex:l,revealed:f}=this.G(e),S=this.v(o,l,f,n);if(o!==this.c&&this.l&&S&&!P(n)&&o.collapsible&&!o.collapsed&&!n.recursive){let m=-1;for(let b=0;b<o.children.length;b++)if(o.children[b].visible)if(m>-1){m=-1;break}else m=b;m>-1&&this.u([...e,m],n)}return S}v(e,n,o,l){const f=this.w(e,l,!1);if(!o||!e.visible||!f)return f;const S=e.renderNodeCount,m=this.y(e),b=S-(n===-1?0:1);return this.q.splice(n+1,b,m.slice(1)),f}w(e,n,o){let l;if(e===this.c?l=!1:(P(n)?(l=e.collapsible!==n.collapsible,e.collapsible=n.collapsible):e.collapsible?(l=e.collapsed!==n.collapsed,e.collapsed=n.collapsed):l=!1,l&&this.f.fire({node:e,deep:o})),!P(n)&&n.recursive)for(const f of e.children)l=this.w(f,n,!0)||l;return l}expandTo(e){this.d.bufferEvents(()=>{let n=this.F(e);for(;n.parent;)n=n.parent,e=e.slice(0,e.length-1),n.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,n=this.A(this.c);this.q.splice(0,e,n),this.o.cancel()}x(e,n,o,l,f,S){const m={parent:n,element:e.element,children:[],depth:n.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},b=this.D(m,o);m.visibility=b,l&&f.push(m);const r=e.children||d.Iterable.empty(),E=l&&b!==0&&!m.collapsed;let k=0,F=1;for(const M of r){const W=this.x(M,m,b,E,f,S);m.children.push(W),F+=W.renderNodeCount,W.visible&&(W.visibleChildIndex=k++)}return this.j||(m.collapsible=m.collapsible||m.children.length>0),m.visibleChildrenCount=k,m.visible=b===2?k>0:b===1,m.visible?m.collapsed||(m.renderNodeCount=F):(m.renderNodeCount=0,l&&f.pop()),S?.(m),m}y(e){const n=e.renderNodeCount,o=[];return this.z(e,o),this.C(e.parent,o.length-n),o}z(e,n){if(e.visible===!1)return 0;if(n.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this.z(o,n);return this.g.fire(e),e.renderNodeCount}A(e){const n=e.renderNodeCount,o=[];return this.B(e,e.visible?1:0,o),this.C(e.parent,o.length-n),o}B(e,n,o,l=!0){let f;if(e!==this.c){if(f=this.D(e,n),f===0)return e.visible=!1,e.renderNodeCount=0,!1;l&&o.push(e)}const S=o.length;e.renderNodeCount=e===this.c?0:1;let m=!1;if(!e.collapsed||f!==0){let b=0;for(const r of e.children)m=this.B(r,f,o,l&&!e.collapsed)||m,r.visible&&(r.visibleChildIndex=b++);e.visibleChildrenCount=b}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=f===2?m:f===1,e.visibility=f),e.visible?e.collapsed||(e.renderNodeCount+=o.length-S):(e.renderNodeCount=0,l&&o.pop()),this.g.fire(e),e.visible}C(e,n){if(n!==0)for(;e;)e.renderNodeCount+=n,this.g.fire(e),e=e.parent}D(e,n){const o=this.k?this.k.filter(e.element,n):1;return typeof o=="boolean"?(e.filterData=void 0,o?1:0):g(o)?(e.filterData=o.data,$(o.visibility)):(e.filterData=void 0,$(o))}E(e,n=this.c){if(!e||e.length===0)return!0;const[o,...l]=e;return o<0||o>n.children.length?!1:this.E(l,n.children[o])}F(e,n=this.c){if(!e||e.length===0)return n;const[o,...l]=e;if(o<0||o>n.children.length)throw new i.$0V(this.p,"Invalid tree location");return this.F(l,n.children[o])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:n,listIndex:o,revealed:l,visible:f}=this.H(e),S=e[e.length-1];if(S<0||S>n.children.length)throw new i.$0V(this.p,"Invalid tree location");const m=n.children[S];return{node:m,listIndex:o,revealed:l,visible:f&&m.visible}}H(e,n=this.c,o=0,l=!0,f=!0){const[S,...m]=e;if(S<0||S>n.children.length)throw new i.$0V(this.p,"Invalid tree location");for(let b=0;b<S;b++)o+=n.children[b].renderNodeCount;return l=l&&!n.collapsed,f=f&&n.visible,m.length===0?{parentNode:n,listIndex:o,revealed:l,visible:f}:this.H(m,n.children[S],o+1,l,f)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const n=[];let o=e;for(;o.parent;)n.push(o.parent.children.indexOf(o)),o=o.parent;return n.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,C.$tb)(e)[0]}getFirstElementChild(e){const n=this.F(e);if(n.children.length!==0)return n.children[0].element}getLastElementAncestor(e=[]){const n=this.F(e);if(n.children.length!==0)return this.I(n)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$bW=c}),define(me[134],be([1,0,69,30,32]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iW=void 0;class Q{get size(){return this.d.size}constructor(T,d,g={}){this.k=T,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$bW(T,d,null,g),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,g.sorter&&(this.j={compare($,P){return g.sorter.compare($.element,P.element)}}),this.h=g.identityProvider}setChildren(T,d=B.Iterable.empty(),g={}){const $=this.o(T);this.l($,this.m(d),g)}l(T,d=B.Iterable.empty(),g){const $=new Set,P=new Set,c=e=>{if(e.element===null)return;const n=e;if($.add(n.element),this.d.set(n.element,n),this.h){const o=this.h.getId(n.element).toString();P.add(o),this.f.set(o,n)}g.onDidCreateNode?.(n)},h=e=>{if(e.element===null)return;const n=e;if($.has(n.element)||this.d.delete(n.element),this.h){const o=this.h.getId(n.element).toString();P.has(o)||this.f.delete(o)}g.onDidDeleteNode?.(n)};this.c.splice([...T,0],Number.MAX_VALUE,d,{...g,onDidCreateNode:c,onDidDeleteNode:h})}m(T=B.Iterable.empty()){return this.j&&(T=[...T].sort(this.j.compare.bind(this.j))),B.Iterable.map(T,d=>{let g=this.d.get(d.element);if(!g&&this.h){const c=this.h.getId(d.element).toString();g=this.f.get(c)}if(!g){let c;return typeof d.collapsed>"u"?c=void 0:d.collapsed===C.ObjectTreeElementCollapseState.Collapsed||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed?c=!0:d.collapsed===C.ObjectTreeElementCollapseState.Expanded||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?c=!1:c=!!d.collapsed,{...d,children:this.m(d.children),collapsed:c}}const $=typeof d.collapsible=="boolean"?d.collapsible:g.collapsible;let P;return typeof d.collapsed>"u"||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?P=g.collapsed:d.collapsed===C.ObjectTreeElementCollapseState.Collapsed?P=!0:d.collapsed===C.ObjectTreeElementCollapseState.Expanded?P=!1:P=!!d.collapsed,{...d,collapsible:$,collapsed:P,children:this.m(d.children)}})}rerender(T){const d=this.o(T);this.c.rerender(d)}updateElementHeight(T,d){const g=this.o(T);this.c.updateElementHeight(g,d)}resort(T=null,d=!0){if(!this.j)return;const g=this.o(T),$=this.c.getNode(g);this.l(g,this.n($,d),{})}n(T,d,g=!0){let $=[...T.children];return(d||g)&&($=$.sort(this.j.compare.bind(this.j))),B.Iterable.map($,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.n(P,d,!1)}))}getFirstElementChild(T=null){const d=this.o(T);return this.c.getFirstElementChild(d)}getLastElementAncestor(T=null){const d=this.o(T);return this.c.getLastElementAncestor(d)}has(T){return this.d.has(T)}getListIndex(T){const d=this.o(T);return this.c.getListIndex(d)}getListRenderCount(T){const d=this.o(T);return this.c.getListRenderCount(d)}isCollapsible(T){const d=this.o(T);return this.c.isCollapsible(d)}setCollapsible(T,d){const g=this.o(T);return this.c.setCollapsible(g,d)}isCollapsed(T){const d=this.o(T);return this.c.isCollapsed(d)}setCollapsed(T,d,g){const $=this.o(T);return this.c.setCollapsed($,d,g)}expandTo(T){const d=this.o(T);this.c.expandTo(d)}refilter(){this.c.refilter()}getNode(T=null){if(T===null)return this.c.getNode(this.c.rootRef);const d=this.d.get(T);if(!d)throw new C.$0V(this.k,`Tree element not found: ${T}`);return d}getNodeLocation(T){return T.element}getParentNodeLocation(T){if(T===null)throw new C.$0V(this.k,"Invalid getParentNodeLocation call");const d=this.d.get(T);if(!d)throw new C.$0V(this.k,`Tree element not found: ${T}`);const g=this.c.getNodeLocation(d),$=this.c.getParentNodeLocation(g);return this.c.getNode($).element}o(T){if(T===null)return[];const d=this.d.get(T);if(!d)throw new C.$0V(this.k,`Tree element not found: ${T}`);return this.c.getNodeLocation(d)}}t.$iW=Q}),define(me[21],be([1,0,4,15,20,28,2]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uT=void 0;class T extends A.$Vc{f(g,$){this.B(i.$TR(g,i.$MS.CLICK,P=>$(new B.$LR(i.getWindow(g),P))))}j(g,$){this.B(i.$TR(g,i.$MS.MOUSE_DOWN,P=>$(new B.$LR(i.getWindow(g),P))))}m(g,$){this.B(i.$TR(g,i.$MS.MOUSE_OVER,P=>$(new B.$LR(i.getWindow(g),P))))}u(g,$){this.B(i.$TR(g,i.$MS.MOUSE_LEAVE,P=>$(new B.$LR(i.getWindow(g),P))))}z(g,$){this.B(i.$TR(g,i.$MS.KEY_DOWN,P=>$(new C.$QR(P))))}C(g,$){this.B(i.$TR(g,i.$MS.KEY_UP,P=>$(new C.$QR(P))))}D(g,$){this.B(i.$TR(g,i.$MS.INPUT,$))}F(g,$){this.B(i.$TR(g,i.$MS.BLUR,$))}G(g,$){this.B(i.$TR(g,i.$MS.FOCUS,$))}H(g,$){this.B(i.$TR(g,i.$MS.CHANGE,$))}I(g){return Q.$qT.ignoreTarget(g)}}t.$uT=T}),define(me[48],be([1,0,67,21,11,19,4]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wT=t.$vT=void 0,t.$vT=11;class T extends C.$uT{constructor(g){super(),this.a=g.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=g.bgWidth+"px",this.bgDomNode.style.height=g.bgHeight+"px",typeof g.top<"u"&&(this.bgDomNode.style.top="0px"),typeof g.left<"u"&&(this.bgDomNode.style.left="0px"),typeof g.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof g.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=g.className,this.domNode.classList.add(...Q.ThemeIcon.asClassNameArray(g.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$vT+"px",this.domNode.style.height=t.$vT+"px",typeof g.top<"u"&&(this.domNode.style.top=g.top+"px"),typeof g.left<"u"&&(this.domNode.style.left=g.left+"px"),typeof g.bottom<"u"&&(this.domNode.style.bottom=g.bottom+"px"),typeof g.right<"u"&&(this.domNode.style.right=g.right+"px"),this.g=this.B(new i.$tT),this.B(A.$UR(this.bgDomNode,A.$MS.POINTER_DOWN,$=>this.h($))),this.B(A.$UR(this.domNode,A.$MS.POINTER_DOWN,$=>this.h($))),this.b=this.B(new A.$6R),this.c=this.B(new B.$Gh)}h(g){if(!g.target||!(g.target instanceof Element))return;const $=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,A.getWindow(g))};this.a(),this.b.cancel(),this.c.cancelAndSet($,200),this.g.startMonitoring(g.target,g.pointerId,g.buttons,P=>{},()=>{this.b.cancel(),this.c.cancel()}),g.preventDefault()}}t.$wT=T}),define(me[70],be([1,0,4,51,67,48,132,21,5]),function(se,t,i,C,B,Q,A,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zT=void 0;const g=140;class $ extends T.$uT{constructor(c){super(),this.g=c.lazyRender,this.a=c.host,this.b=c.scrollable,this.c=c.scrollByPage,this.h=c.scrollbarState,this.n=this.B(new A.$yT(c.visibility,"visible scrollbar "+c.extraScrollbarClassName,"invisible scrollbar "+c.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new B.$tT),this.s=!0,this.domNode=(0,C.$sT)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$TR(this.domNode.domNode,i.$MS.POINTER_DOWN,h=>this.M(h)))}t(c){const h=this.B(new Q.$wT(c));this.domNode.domNode.appendChild(h.bgDomNode),this.domNode.domNode.appendChild(h.domNode)}w(c,h,e,n){this.slider=(0,C.$sT)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(c),this.slider.setLeft(h),typeof e=="number"&&this.slider.setWidth(e),typeof n=="number"&&this.slider.setHeight(n),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$TR(this.slider.domNode,i.$MS.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this.O(o))})),this.f(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}y(c){return this.h.setVisibleSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(c){return this.h.setScrollSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(c){return this.h.setScrollPosition(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(c){c.target===this.domNode.domNode&&this.N(c)}delegatePointerDown(c){const h=this.domNode.domNode.getClientRects()[0].top,e=h+this.h.getSliderPosition(),n=h+this.h.getSliderPosition()+this.h.getSliderSize(),o=this.U(c);e<=o&&o<=n?c.button===0&&(c.preventDefault(),this.O(c)):this.N(c)}N(c){let h,e;if(c.target===this.domNode.domNode&&typeof c.offsetX=="number"&&typeof c.offsetY=="number")h=c.offsetX,e=c.offsetY;else{const o=i.$dS(this.domNode.domNode);h=c.pageX-o.left,e=c.pageY-o.top}const n=this.S(h,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(n):this.h.getDesiredScrollPositionFromOffset(n)),c.button===0&&(c.preventDefault(),this.O(c))}O(c){if(!c.target||!(c.target instanceof Element))return;const h=this.U(c),e=this.W(c),n=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(c.target,c.pointerId,c.buttons,o=>{const l=this.W(o),f=Math.abs(l-e);if(d.$i&&f>g){this.P(n.getScrollPosition());return}const m=this.U(o)-h;this.P(n.getDesiredScrollPositionFromDelta(m))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(c){const h={};this.writeScrollPosition(h,c),this.b.setScrollPositionNow(h)}updateScrollbarSize(c){this.X(c),this.h.setScrollbarSize(c),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$zT=$}),define(me[135],be([1,0,20,70,48,52,18]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AT=void 0;class T extends C.$zT{constructor(g,$,P){const c=g.getScrollDimensions(),h=g.getCurrentScrollPosition();if(super({lazyRender:$.lazyRender,host:P,scrollbarState:new Q.$xT($.horizontalHasArrows?$.arrowSize:0,$.horizontal===2?0:$.horizontalScrollbarSize,$.vertical===2?0:$.verticalScrollbarSize,c.width,c.scrollWidth,h.scrollLeft),visibility:$.horizontal,extraScrollbarClassName:"horizontal",scrollable:g,scrollByPage:$.scrollByPage}),$.horizontalHasArrows){const e=($.arrowSize-B.$vT)/2,n=($.horizontalScrollbarSize-B.$vT)/2;this.t({className:"scra",icon:A.$Vj.scrollbarButtonLeft,top:n,left:e,bottom:void 0,right:void 0,bgWidth:$.arrowSize,bgHeight:$.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$NR(null,1,0))}),this.t({className:"scra",icon:A.$Vj.scrollbarButtonRight,top:n,left:void 0,bottom:void 0,right:e,bgWidth:$.arrowSize,bgHeight:$.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$NR(null,-1,0))})}this.w(Math.floor(($.horizontalScrollbarSize-$.horizontalSliderSize)/2),0,void 0,$.horizontalSliderSize)}R(g,$){this.slider.setWidth(g),this.slider.setLeft($)}Q(g,$){this.domNode.setWidth(g),this.domNode.setHeight($),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(g){return this.s=this.J(g.scrollWidth)||this.s,this.s=this.L(g.scrollLeft)||this.s,this.s=this.y(g.width)||this.s,this.s}S(g,$){return g}U(g){return g.pageX}W(g){return g.pageY}X(g){this.slider.setHeight(g)}writeScrollPosition(g,$){g.scrollLeft=$}updateOptions(g){this.updateScrollbarSize(g.horizontal===2?0:g.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.n.setVisibility(g.horizontal),this.c=g.scrollByPage}}t.$AT=T}),define(me[136],be([1,0,20,70,48,52,18]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BT=void 0;class T extends C.$zT{constructor(g,$,P){const c=g.getScrollDimensions(),h=g.getCurrentScrollPosition();if(super({lazyRender:$.lazyRender,host:P,scrollbarState:new Q.$xT($.verticalHasArrows?$.arrowSize:0,$.vertical===2?0:$.verticalScrollbarSize,0,c.height,c.scrollHeight,h.scrollTop),visibility:$.vertical,extraScrollbarClassName:"vertical",scrollable:g,scrollByPage:$.scrollByPage}),$.verticalHasArrows){const e=($.arrowSize-B.$vT)/2,n=($.verticalScrollbarSize-B.$vT)/2;this.t({className:"scra",icon:A.$Vj.scrollbarButtonUp,top:e,left:n,bottom:void 0,right:void 0,bgWidth:$.verticalScrollbarSize,bgHeight:$.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$NR(null,0,1))}),this.t({className:"scra",icon:A.$Vj.scrollbarButtonDown,top:void 0,left:n,bottom:e,right:void 0,bgWidth:$.verticalScrollbarSize,bgHeight:$.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$NR(null,0,-1))})}this.w(0,Math.floor(($.verticalScrollbarSize-$.verticalSliderSize)/2),$.verticalSliderSize,void 0)}R(g,$){this.slider.setHeight(g),this.slider.setTop($)}Q(g,$){this.domNode.setWidth($),this.domNode.setHeight(g),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(g){return this.s=this.J(g.scrollHeight)||this.s,this.s=this.L(g.scrollTop)||this.s,this.s=this.y(g.height)||this.s,this.s}S(g,$){return $}U(g){return g.pageY}W(g){return g.pageX}X(g){this.slider.setWidth(g)}writeScrollPosition(g,$){g.scrollTop=$}updateOptions(g){this.updateScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(g.vertical),this.c=g.scrollByPage}}t.$BT=T}),define(me[71],be([1,0,17,4,51,20,135,136,21,11,3,2,5,58,111]),function(se,t,i,C,B,Q,A,T,d,g,$,P,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GT=t.$FT=t.$ET=t.$DT=t.$CT=void 0;const e=500,n=50,o=!0;class l{constructor(F,M,W){this.timestamp=F,this.deltaX=M,this.deltaY=W,this.score=0}}class f{static{this.INSTANCE=new f}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let F=1,M=0,W=1,p=this.d;do{const I=p===this.c?F:Math.pow(2,-W);if(F-=I,M+=this.b[p].score*I,p===this.c)break;p=(this.a+p-1)%this.a,W++}while(!0);return M<=.5}acceptStandardWheelEvent(F){if(i.$BR){const M=C.getWindow(F.browserEvent),W=(0,i.$uR)(M);this.accept(Date.now(),F.deltaX*W,F.deltaY*W)}else this.accept(Date.now(),F.deltaX,F.deltaY)}accept(F,M,W){let p=null;const I=new l(F,M,W);this.c===-1&&this.d===-1?(this.b[0]=I,this.c=0,this.d=0):(p=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=I),I.score=this.f(I,p)}f(F,M){if(Math.abs(F.deltaX)>0&&Math.abs(F.deltaY)>0)return 1;let W=.5;if((!this.g(F.deltaX)||!this.g(F.deltaY))&&(W+=.25),M){const p=Math.abs(F.deltaX),I=Math.abs(F.deltaY),V=Math.abs(M.deltaX),R=Math.abs(M.deltaY),x=Math.max(Math.min(p,V),1),O=Math.max(Math.min(I,R),1),G=Math.max(p,V),q=Math.max(I,R);G%x===0&&q%O===0&&(W-=.5)}return Math.min(Math.max(W,0),1)}g(F){return Math.abs(Math.round(F)-F)<.01}}t.$CT=f;class S extends d.$uT{get options(){return this.a}constructor(F,M,W){super(),this.O=this.B(new $.$ee),this.onScroll=this.O.event,this.P=this.B(new $.$ee),this.onWillScroll=this.P.event,F.style.overflow="hidden",this.a=E(M),this.b=W,this.B(this.b.onScroll(I=>{this.P.fire(I),this.S(I),this.O.fire(I)}));const p={onMouseWheel:I=>this.R(I),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new T.$BT(this.b,this.a,p)),this.g=this.B(new A.$AT(this.b,this.a,p)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(F),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,B.$sT)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,B.$sT)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,B.$sT)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,I=>this.Z(I)),this.u(this.t,I=>this.Y(I)),this.L=this.B(new g.$Gh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,P.$Qc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(F){this.c.delegatePointerDown(F)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(F){this.b.setScrollDimensions(F,!1)}updateClassName(F){this.a.className=F,c.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(F){typeof F.handleMouseWheel<"u"&&(this.a.handleMouseWheel=F.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof F.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=F.mouseWheelScrollSensitivity),typeof F.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=F.fastScrollSensitivity),typeof F.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=F.scrollPredominantAxis),typeof F.horizontal<"u"&&(this.a.horizontal=F.horizontal),typeof F.vertical<"u"&&(this.a.vertical=F.vertical),typeof F.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=F.horizontalScrollbarSize),typeof F.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=F.verticalScrollbarSize),typeof F.scrollByPage<"u"&&(this.a.scrollByPage=F.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(F){this.N=F}delegateScrollFromMouseWheelEvent(F){this.R(new Q.$NR(F))}Q(F){if(this.w.length>0!==F&&(this.w=(0,P.$Qc)(this.w),F)){const W=p=>{this.R(new Q.$NR(p))};this.w.push(C.$TR(this.t,C.$MS.MOUSE_WHEEL,W,{passive:!1}))}}R(F){if(F.browserEvent?.defaultPrevented)return;const M=f.INSTANCE;o&&M.acceptStandardWheelEvent(F);let W=!1;if(F.deltaY||F.deltaX){let I=F.deltaY*this.a.mouseWheelScrollSensitivity,V=F.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&V+I===0?V=I=0:Math.abs(I)>=Math.abs(V)?V=0:I=0),this.a.flipAxes&&([I,V]=[V,I]);const R=!c.$j&&F.browserEvent&&F.browserEvent.shiftKey;(this.a.scrollYToX||R)&&!V&&(V=I,I=0),F.browserEvent&&F.browserEvent.altKey&&(V=V*this.a.fastScrollSensitivity,I=I*this.a.fastScrollSensitivity);const x=this.b.getFutureScrollPosition();let O={};if(I){const G=n*I,q=x.scrollTop-(G<0?Math.floor(G):Math.ceil(G));this.c.writeScrollPosition(O,q)}if(V){const G=n*V,q=x.scrollLeft-(G<0?Math.floor(G):Math.ceil(G));this.g.writeScrollPosition(O,q)}O=this.b.validateScrollPosition(O),(x.scrollLeft!==O.scrollLeft||x.scrollTop!==O.scrollTop)&&(o&&this.a.mouseWheelSmoothScroll&&M.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(O):this.b.setScrollPositionNow(O),W=!0)}let p=W;!p&&this.a.alwaysConsumeMouseWheel&&(p=!0),!p&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(p=!0),p&&(F.preventDefault(),F.stopPropagation())}S(F){this.M=this.g.onDidScroll(F)||this.M,this.M=this.c.onDidScroll(F)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const F=this.b.getCurrentScrollPosition(),M=F.scrollTop>0,W=F.scrollLeft>0,p=W?" left":"",I=M?" top":"",V=W||M?" top-left-corner":"";this.n.setClassName(`shadow${p}`),this.r.setClassName(`shadow${I}`),this.s.setClassName(`shadow${V}${I}${p}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(F){this.J=!1,this.ab()}Z(F){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$DT=S;class m extends S{constructor(F,M){M=M||{},M.mouseWheelSmoothScroll=!1;const W=new h.$Ws({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>C.$4R(C.getWindow(F),p)});super(F,M,W),this.B(W)}setScrollPosition(F){this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$ET=m;class b extends S{constructor(F,M,W){super(F,M,W)}setScrollPosition(F){F.reuseAnimation?this.b.setScrollPositionSmooth(F,F.reuseAnimation):this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$FT=b;class r extends S{constructor(F,M){M=M||{},M.mouseWheelSmoothScroll=!1;const W=new h.$Ws({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>C.$4R(C.getWindow(F),p)});super(F,M,W),this.B(W),this.cb=F,this.B(this.onScroll(p=>{p.scrollTopChanged&&(this.cb.scrollTop=p.scrollTop),p.scrollLeftChanged&&(this.cb.scrollLeft=p.scrollLeft)})),this.scanDomNode()}setScrollPosition(F){this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$GT=r;function E(k){const F={lazyRender:typeof k.lazyRender<"u"?k.lazyRender:!1,className:typeof k.className<"u"?k.className:"",useShadows:typeof k.useShadows<"u"?k.useShadows:!0,handleMouseWheel:typeof k.handleMouseWheel<"u"?k.handleMouseWheel:!0,flipAxes:typeof k.flipAxes<"u"?k.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof k.consumeMouseWheelIfScrollbarIsNeeded<"u"?k.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof k.alwaysConsumeMouseWheel<"u"?k.alwaysConsumeMouseWheel:!1,scrollYToX:typeof k.scrollYToX<"u"?k.scrollYToX:!1,mouseWheelScrollSensitivity:typeof k.mouseWheelScrollSensitivity<"u"?k.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof k.fastScrollSensitivity<"u"?k.fastScrollSensitivity:5,scrollPredominantAxis:typeof k.scrollPredominantAxis<"u"?k.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof k.mouseWheelSmoothScroll<"u"?k.mouseWheelSmoothScroll:!0,arrowSize:typeof k.arrowSize<"u"?k.arrowSize:11,listenOnDomNode:typeof k.listenOnDomNode<"u"?k.listenOnDomNode:null,horizontal:typeof k.horizontal<"u"?k.horizontal:1,horizontalScrollbarSize:typeof k.horizontalScrollbarSize<"u"?k.horizontalScrollbarSize:10,horizontalSliderSize:typeof k.horizontalSliderSize<"u"?k.horizontalSliderSize:0,horizontalHasArrows:typeof k.horizontalHasArrows<"u"?k.horizontalHasArrows:!1,vertical:typeof k.vertical<"u"?k.vertical:1,verticalScrollbarSize:typeof k.verticalScrollbarSize<"u"?k.verticalScrollbarSize:10,verticalHasArrows:typeof k.verticalHasArrows<"u"?k.verticalHasArrows:!1,verticalSliderSize:typeof k.verticalSliderSize<"u"?k.verticalSliderSize:0,scrollByPage:typeof k.scrollByPage<"u"?k.scrollByPage:!1};return F.horizontalSliderSize=typeof k.horizontalSliderSize<"u"?k.horizontalSliderSize:F.horizontalScrollbarSize,F.verticalSliderSize=typeof k.verticalSliderSize<"u"?k.verticalSliderSize:F.verticalScrollbarSize,c.$j&&(F.className+=" mac"),F}}),define(me[72],be([1,0,65,4,24,28,71,8,11,31,3,2,56,58,92,131,6,40]),function(se,t,i,C,B,Q,A,T,d,g,$,P,c,h,e,n,o,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$T=t.$0T=t.$9T=t.$8T=t.ListViewTargetSector=void 0;const f={CurrentDragAndDropData:void 0};var S;(function(W){W[W.TOP=0]="TOP",W[W.CENTER_TOP=1]="CENTER_TOP",W[W.CENTER_BOTTOM=2]="CENTER_BOTTOM",W[W.BOTTOM=3]="BOTTOM"})(S||(t.ListViewTargetSector=S={}));const m={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(W){return[W]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class b{get context(){return this.d}set context(p){this.d=p}constructor(p){this.elements=p}update(){}getData(){return this.elements}}t.$8T=b;class r{constructor(p){this.elements=p}update(){}getData(){return this.elements}}t.$9T=r;class E{constructor(){this.types=[],this.files=[]}update(p){if(p.types&&this.types.splice(0,this.types.length,...p.types),p.files){this.files.splice(0,this.files.length);for(let I=0;I<p.files.length;I++){const V=p.files.item(I);V&&(V.size||V.type)&&this.files.push(V)}}}getData(){return{types:this.types,files:this.files}}}t.$0T=E;function k(W,p){return Array.isArray(W)&&Array.isArray(p)?(0,T.$ub)(W,p):W===p}class F{constructor(p){p?.getSetSize?this.getSetSize=p.getSetSize.bind(p):this.getSetSize=(I,V,R)=>R,p?.getPosInSet?this.getPosInSet=p.getPosInSet.bind(p):this.getPosInSet=(I,V)=>V+1,p?.getRole?this.getRole=p.getRole.bind(p):this.getRole=I=>"listitem",p?.isChecked?this.isChecked=p.isChecked.bind(p):this.isChecked=I=>{}}}class M{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(p){if(p!==this.P){if(p&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=p,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const I of this.d)this.ab(I);this.X(),this.q.setScrollDimensions({width:(0,C.$gS)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(p,I,V,R=m){if(this.R=I,this.domId=`list_id_${++M.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new d.$th(50),this.v=!1,this.x=P.$Vc.None,this.y=0,this.G=!1,this.K=P.$Vc.None,this.L=P.$Vc.None,this.M=new P.$Uc,this.N=new $.$ee,this.O=new $.$ee,this.onDidChangeContentHeight=$.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=$.Event.latch(this.O.event,void 0,this.M),this.P=!1,R.horizontalScrolling&&R.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(R.paddingTop??0);for(const O of V)this.j.set(O.templateId,O);this.h=this.M.add(new n.$7T(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof R.mouseSupport=="boolean"?R.mouseSupport:!0),this.P=R.horizontalScrolling??m.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof R.paddingBottom>"u"?0:R.paddingBottom,this.D=new F(R.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(R.transformOptimization??m.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(Q.$qT.addTarget(this.o)),this.p=this.M.add(new h.$Ws({forceIntegerValues:!0,smoothScrollDuration:R.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:O=>(0,C.$4R)((0,C.getWindow)(this.domNode),O)})),this.q=this.M.add(new A.$FT(this.o,{alwaysConsumeMouseWheel:R.alwaysConsumeMouseWheel??m.alwaysConsumeMouseWheel,horizontal:1,vertical:R.verticalScrollMode??m.verticalScrollMode,useShadows:R.useShadows??m.useShadows,mouseWheelScrollSensitivity:R.mouseWheelScrollSensitivity,fastScrollSensitivity:R.fastScrollSensitivity,scrollByPage:R.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),p.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,C.$TR)(this.o,Q.EventType.Change,O=>this.jb(O))),this.M.add((0,C.$TR)(this.q.getDomNode(),"scroll",O=>O.target.scrollTop=0)),this.M.add((0,C.$TR)(this.domNode,"dragover",O=>this.lb(this.hb(O)))),this.M.add((0,C.$TR)(this.domNode,"drop",O=>this.nb(this.hb(O)))),this.M.add((0,C.$TR)(this.domNode,"dragleave",O=>this.mb(this.hb(O)))),this.M.add((0,C.$TR)(this.domNode,"dragend",O=>this.ob(O))),this.z=R.setRowLineHeight??m.setRowLineHeight,this.A=R.setRowHeight??m.setRowHeight,this.B=R.supportDynamicHeights??m.supportDynamicHeights,this.F=R.dnd??this.M.add(m.dnd),this.layout(R.initialSize?.height,R.initialSize?.width)}updateOptions(p){p.paddingBottom!==void 0&&(this.C=p.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),p.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(p.smoothScrolling?125:0),p.horizontalScrolling!==void 0&&(this.Q=p.horizontalScrolling);let I;if(p.scrollByPage!==void 0&&(I={...I??{},scrollByPage:p.scrollByPage}),p.mouseWheelScrollSensitivity!==void 0&&(I={...I??{},mouseWheelScrollSensitivity:p.mouseWheelScrollSensitivity}),p.fastScrollSensitivity!==void 0&&(I={...I??{},fastScrollSensitivity:p.fastScrollSensitivity}),I&&this.q.updateOptions(I),p.paddingTop!==void 0&&p.paddingTop!==this.g.paddingTop){const V=this.vb(this.k,this.m),R=p.paddingTop-this.g.paddingTop;this.g.paddingTop=p.paddingTop,this.Y(V,Math.max(0,this.k+R),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(p){this.q.delegateScrollFromMouseWheelEvent(p)}delegateVerticalScrollbarPointerDown(p){this.q.delegateVerticalScrollbarPointerDown(p)}updateElementHeight(p,I,V){if(p<0||p>=this.d.length)return;const R=this.d[p].size;if(typeof I>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[p].lastDynamicHeightWidth=void 0,I=R+this.xb(p)}if(R===I)return;const x=this.vb(this.k,this.m);let O=0;p<x.start||V!==null&&V>p&&V<x.end?O=I-R:O=0,this.g.splice(p,1,[{size:I}]),this.d[p].size=I,this.Y(x,Math.max(0,this.k+O),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(p){return new e.$6T(p)}splice(p,I,V=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(p,I,V)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(p,I,V=[]){const R=this.vb(this.k,this.m),x={start:p,end:p+I},O=c.Range.intersect(R,x),G=new Map;for(let H=O.end-1;H>=O.start;H--){const J=this.d[H];if(J.dragStartDisposable.dispose(),J.checkedDisposable.dispose(),J.row){let ge=G.get(J.templateId);ge||(ge=[],G.set(J.templateId,ge));const we=this.j.get(J.templateId);we&&we.disposeElement&&we.disposeElement(J.element,H,J.row.templateData,J.size),ge.unshift(J.row)}J.row=null,J.stale=!0}const q={start:p+I,end:this.d.length},ae=c.Range.intersect(q,R),ie=c.Range.relativeComplement(q,R),ee=V.map(H=>({id:String(this.f++),element:H,templateId:this.R.getTemplateId(H),size:this.R.getHeight(H),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(H),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.$Vc.None,checkedDisposable:P.$Vc.None,stale:!1}));let ce;p===0&&I>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ee),ce=this.d,this.d=ee):(this.g.splice(p,I,ee),ce=this.d.splice(p,I,...ee));const De=V.length-I,Ee=this.vb(this.k,this.m),Me=(0,e.$4T)(ae,De),le=c.Range.intersect(Ee,Me);for(let H=le.start;H<le.end;H++)this.bb(this.d[H],H);const _=c.Range.relativeComplement(Me,Ee);for(const H of _)for(let J=H.start;J<H.end;J++)this.db(J);const ue=ie.map(H=>(0,e.$4T)(H,De)),ye=[{start:p,end:p+V.length},...ue].map(H=>c.Range.intersect(Ee,H)).reverse();for(const H of ye)for(let J=H.end-1;J>=H.start;J--){const ge=this.d[J],ke=G.get(ge.templateId)?.pop();this.Z(J,ke)}for(const H of G.values())for(const J of H)this.h.release(J);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ce.map(H=>H.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,C.$4R)((0,C.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let p=0;for(const I of this.d)typeof I.width<"u"&&(p=Math.max(p,I.width));this.E=p,this.q.setScrollDimensions({scrollWidth:p===0?0:p+10}),this.O.fire(this.E)}updateWidth(p){if(!this.Q||typeof this.E>"u")return;const I=this.d[p];this.ab(I),typeof I.width<"u"&&I.width>this.E&&(this.E=I.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const p of this.d)p.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const p=this.firstVisibleIndex,I=this.g.positionAt(p),V=this.g.positionAt(p+1);return V!==-1&&(V-I)/2+I<this.scrollTop?p+1:p}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(p){return this.d[p].element}indexOf(p){return this.d.findIndex(I=>I.element===p)}domElement(p){const I=this.d[p].row;return I&&I.domNode}elementHeight(p){return this.d[p].size}elementTop(p){return this.g.positionAt(p)}indexAt(p){return this.g.indexAt(p)}indexAfter(p){return this.g.indexAfter(p)}layout(p,I){const V={height:typeof p=="number"?p:(0,C.$iS)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,V.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(V),typeof I<"u"&&(this.n=I,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof I=="number"?I:(0,C.$gS)(this.domNode)})}Y(p,I,V,R,x,O=!1){const G=this.vb(I,V),q=c.Range.relativeComplement(G,p).reverse(),ae=c.Range.relativeComplement(p,G);if(O){const ie=c.Range.intersect(p,G);for(let ee=ie.start;ee<ie.end;ee++)this.bb(this.d[ee],ee)}this.h.transact(()=>{for(const ie of ae)for(let ee=ie.start;ee<ie.end;ee++)this.db(ee);for(const ie of q)for(let ee=ie.end-1;ee>=ie.start;ee--)this.Z(ee)}),R!==void 0&&(this.o.style.left=`-${R}px`),this.o.style.top=`-${I}px`,this.Q&&x!==void 0&&(this.o.style.width=`${Math.max(x,this.n)}px`),this.k=I,this.m=V}Z(p,I){const V=this.d[p];if(!V.row)if(I)V.row=I,V.stale=!0;else{const q=this.h.alloc(V.templateId);V.row=q.row,V.stale||=q.isReusingConnectedDomNode}const R=this.D.getRole(V.element)||"listitem";V.row.domNode.setAttribute("role",R);const x=this.D.isChecked(V.element);if(typeof x=="boolean")V.row.domNode.setAttribute("aria-checked",String(!!x));else if(x){const q=ae=>V.row.domNode.setAttribute("aria-checked",String(!!ae));q(x.value),V.checkedDisposable=x.onDidChange(()=>q(x.value))}if(V.stale||!V.row.domNode.parentElement){const q=this.d.at(p+1)?.row?.domNode??null;(V.row.domNode.parentElement!==this.o||V.row.domNode.nextElementSibling!==q)&&this.o.insertBefore(V.row.domNode,q),V.stale=!1}this.bb(V,p);const O=this.j.get(V.templateId);if(!O)throw new Error(`No renderer found for template id ${V.templateId}`);O?.renderElement(V.element,p,V.row.templateData,V.size);const G=this.F.getDragURI(V.element);V.dragStartDisposable.dispose(),V.row.domNode.draggable=!!G,G&&(V.dragStartDisposable=(0,C.$TR)(V.row.domNode,"dragstart",q=>this.kb(V.element,G,q))),this.Q&&(this.ab(V),this.W())}ab(p){if(!p.row||!p.row.domNode)return;p.row.domNode.style.width="fit-content",p.width=(0,C.$gS)(p.row.domNode);const I=(0,C.getWindow)(p.row.domNode).getComputedStyle(p.row.domNode);I.paddingLeft&&(p.width+=parseFloat(I.paddingLeft)),I.paddingRight&&(p.width+=parseFloat(I.paddingRight)),p.row.domNode.style.width=""}bb(p,I){p.row.domNode.style.top=`${this.elementTop(I)}px`,this.A&&(p.row.domNode.style.height=`${p.size}px`),this.z&&(p.row.domNode.style.lineHeight=`${p.size}px`),p.row.domNode.setAttribute("data-index",`${I}`),p.row.domNode.setAttribute("data-last-element",I===this.length-1?"true":"false"),p.row.domNode.setAttribute("data-parity",I%2===0?"even":"odd"),p.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(p.element,I,this.length))),p.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(p.element,I))),p.row.domNode.setAttribute("id",this.getElementDomId(I)),p.row.domNode.classList.toggle("drop-target",p.dropTarget)}db(p){const I=this.d[p];if(I.dragStartDisposable.dispose(),I.checkedDisposable.dispose(),I.row){const V=this.j.get(I.templateId);V&&V.disposeElement&&V.disposeElement(I.element,p,I.row.templateData,I.size),this.h.release(I.row),I.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(p,I){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:p,reuseAnimation:I})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(p){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:p})}get scrollTop(){return this.getScrollTop()}set scrollTop(p){this.setScrollTop(p)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return $.Event.map(this.M.add(new B.$XT(this.domNode,"click")).event,p=>this.eb(p),this.M)}get onMouseDblClick(){return $.Event.map(this.M.add(new B.$XT(this.domNode,"dblclick")).event,p=>this.eb(p),this.M)}get onMouseMiddleClick(){return $.Event.filter($.Event.map(this.M.add(new B.$XT(this.domNode,"auxclick")).event,p=>this.eb(p),this.M),p=>p.browserEvent.button===1,this.M)}get onMouseUp(){return $.Event.map(this.M.add(new B.$XT(this.domNode,"mouseup")).event,p=>this.eb(p),this.M)}get onMouseDown(){return $.Event.map(this.M.add(new B.$XT(this.domNode,"mousedown")).event,p=>this.eb(p),this.M)}get onMouseOver(){return $.Event.map(this.M.add(new B.$XT(this.domNode,"mouseover")).event,p=>this.eb(p),this.M)}get onMouseMove(){return $.Event.map(this.M.add(new B.$XT(this.domNode,"mousemove")).event,p=>this.eb(p),this.M)}get onMouseOut(){return $.Event.map(this.M.add(new B.$XT(this.domNode,"mouseout")).event,p=>this.eb(p),this.M)}get onContextMenu(){return $.Event.any($.Event.map(this.M.add(new B.$XT(this.domNode,"contextmenu")).event,p=>this.eb(p),this.M),$.Event.map(this.M.add(new B.$XT(this.domNode,Q.EventType.Contextmenu)).event,p=>this.gb(p),this.M))}get onTouchStart(){return $.Event.map(this.M.add(new B.$XT(this.domNode,"touchstart")).event,p=>this.fb(p),this.M)}get onTap(){return $.Event.map(this.M.add(new B.$XT(this.o,Q.EventType.Tap)).event,p=>this.gb(p),this.M)}eb(p){const I=this.ub(p.target||null),V=typeof I>"u"?void 0:this.d[I],R=V&&V.element;return{browserEvent:p,index:I,element:R}}fb(p){const I=this.ub(p.target||null),V=typeof I>"u"?void 0:this.d[I],R=V&&V.element;return{browserEvent:p,index:I,element:R}}gb(p){const I=this.ub(p.initialTarget||null),V=typeof I>"u"?void 0:this.d[I],R=V&&V.element;return{browserEvent:p,index:I,element:R}}hb(p){const I=this.ub(p.target||null),V=typeof I>"u"?void 0:this.d[I],R=V&&V.element,x=this.tb(p,I);return{browserEvent:p,index:I,element:R,sector:x}}ib(p){try{const I=this.vb(this.k,this.m);this.Y(I,p.scrollTop,p.height,p.scrollLeft,p.scrollWidth),this.B&&this.wb(p.scrollTop,p.height,p.inSmoothScrolling)}catch(I){throw console.error("Got bad scroll event:",p),I}}jb(p){p.preventDefault(),p.stopPropagation(),this.scrollTop-=p.translationY}kb(p,I,V){if(!V.dataTransfer)return;const R=this.F.getDragElements(p);if(V.dataTransfer.effectAllowed="copyMove",V.dataTransfer.setData(i.$oT.TEXT,I),V.dataTransfer.setDragImage){let x;this.F.getDragLabel&&(x=this.F.getDragLabel(R,V)),typeof x>"u"&&(x=String(R.length));const O=(0,C.$)(".monaco-drag-image");O.textContent=x;const q=(ae=>{for(;ae&&!ae.classList.contains("monaco-workbench");)ae=ae.parentElement;return ae||this.domNode.ownerDocument})(this.domNode);q.appendChild(O),V.dataTransfer.setDragImage(O,-10,-10),setTimeout(()=>q.removeChild(O),0)}this.domNode.classList.add("dragging"),this.H=new b(R),f.CurrentDragAndDropData=new r(R),this.F.onDragStart?.(this.H,V)}lb(p){if(p.browserEvent.preventDefault(),this.L.dispose(),f.CurrentDragAndDropData&&f.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(p.browserEvent),!p.browserEvent.dataTransfer))return!1;if(!this.H)if(f.CurrentDragAndDropData)this.H=f.CurrentDragAndDropData;else{if(!p.browserEvent.dataTransfer.types)return!1;this.H=new E}const I=this.F.onDragOver(this.H,p.element,p.index,p.sector,p.browserEvent);if(this.G=typeof I=="boolean"?I:I.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;p.browserEvent.dataTransfer.dropEffect=typeof I!="boolean"&&I.effect?.type===0?"copy":"move";let V;typeof I!="boolean"&&I.feedback?V=I.feedback:typeof p.index>"u"?V=[-1]:V=[p.index],V=(0,T.$Mb)(V).filter(x=>x>=-1&&x<this.length).sort((x,O)=>x-O),V=V[0]===-1?[-1]:V;let R=typeof I!="boolean"&&I.effect&&I.effect.position?I.effect.position:"drop-target";if(k(this.I,V)&&this.J===R)return!0;if(this.I=V,this.J=R,this.K.dispose(),V[0]===-1)this.domNode.classList.add(R),this.o.classList.add(R),this.K=(0,P.$Tc)(()=>{this.domNode.classList.remove(R),this.o.classList.remove(R)});else{if(V.length>1&&R!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");R==="drop-target-after"&&V[0]<this.length-1&&(V[0]+=1,R="drop-target-before");for(const x of V){const O=this.d[x];O.dropTarget=!0,O.row?.domNode.classList.add(R)}this.K=(0,P.$Tc)(()=>{for(const x of V){const O=this.d[x];O.dropTarget=!1,O.row?.domNode.classList.remove(R)}})}return!0}mb(p){this.L.dispose(),this.L=(0,d.$yh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,p.element,p.index,p.browserEvent)}nb(p){if(!this.G)return;const I=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,f.CurrentDragAndDropData=void 0,!(!I||!p.browserEvent.dataTransfer)&&(p.browserEvent.preventDefault(),I.update(p.browserEvent.dataTransfer),this.F.drop(I,p.element,p.index,p.sector,p.browserEvent))}ob(p){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,f.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(p)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=P.$Vc.None}qb(p){if(!this.w){const I=(0,C.$aS)(this.domNode).top;this.w=(0,C.$9S)((0,C.getWindow)(this.domNode),this.rb.bind(this,I))}this.x.dispose(),this.x=(0,d.$yh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=p.pageY}rb(p){if(this.y===void 0)return;const I=this.y-p,V=this.renderHeight-35;I<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(I-35))):I>V&&(this.scrollTop+=Math.min(14,Math.floor(.3*(I-V))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(p,I){if(I===void 0)return;const V=p.offsetY/this.d[I].size,R=Math.floor(V/.25);return(0,l.$Bm)(R,0,3)}ub(p){const I=this.q.getDomNode();let V=p;for(;V instanceof HTMLElement&&V!==this.o&&I.contains(V);){const R=V.getAttribute("data-index");if(R){const x=Number(R);if(!isNaN(x))return x}V=V.parentElement}}vb(p,I){return{start:this.g.indexAt(p),end:this.g.indexAfter(p+I-1)}}wb(p,I,V){const R=this.vb(p,I);let x,O;p===this.elementTop(R.start)?(x=R.start,O=0):R.end-R.start>1&&(x=R.start+1,O=this.elementTop(x)-p);let G=0;for(;;){const q=this.vb(p,I);let ae=!1;for(let ie=q.start;ie<q.end;ie++){const ee=this.xb(ie);ee!==0&&this.g.splice(ie,1,[this.d[ie]]),G+=ee,ae=ae||ee!==0}if(!ae){G!==0&&this.V();const ie=c.Range.relativeComplement(R,q);for(const ce of ie)for(let De=ce.start;De<ce.end;De++)this.d[De].row&&this.db(De);const ee=c.Range.relativeComplement(q,R).reverse();for(const ce of ee)for(let De=ce.end-1;De>=ce.start;De--)this.Z(De);for(let ce=q.start;ce<q.end;ce++)this.d[ce].row&&this.bb(this.d[ce],ce);if(typeof x=="number"){const ce=this.p.getFutureScrollPosition().scrollTop-p,De=this.elementTop(x)-O+ce;this.setScrollTop(De,V)}this.N.fire(this.contentHeight);return}}}xb(p){const I=this.d[p];if(this.R.getDynamicHeight){const O=this.R.getDynamicHeight(I.element);if(O!==null){const G=I.size;return I.size=O,I.lastDynamicHeightWidth=this.n,O-G}}if(!I.hasDynamicHeight||I.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(I.element))return 0;const V=I.size;if(I.row)return I.row.domNode.style.height="",I.size=I.row.domNode.offsetHeight,I.size===0&&!(0,C.$lS)(I.row.domNode,(0,C.getWindow)(I.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),I.lastDynamicHeightWidth=this.n,I.size-V;const{row:R}=this.h.alloc(I.templateId);R.domNode.style.height="",this.o.appendChild(R.domNode);const x=this.j.get(I.templateId);if(!x)throw new o.$cb("Missing renderer for templateId: "+I.templateId);return x.renderElement(I.element,p,R.templateData,void 0),I.size=R.domNode.offsetHeight,x.disposeElement?.(I.element,p,R.templateData,void 0),this.R.setDynamicHeight?.(I.element,I.size),I.lastDynamicHeightWidth=this.n,this.o.removeChild(R.domNode),this.h.release(R),I.size-V}getElementDomId(p){return`${this.domId}_${p}`}dispose(){for(const p of this.d)if(p.dragStartDisposable.dispose(),p.checkedDisposable.dispose(),p.row){const I=this.j.get(p.row.templateId);I&&(I.disposeElement?.(p.element,-1,p.row.templateData,void 0),I.disposeTemplate(p.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$$T=M,Ze([g.$1h],M.prototype,"onMouseClick",null),Ze([g.$1h],M.prototype,"onMouseDblClick",null),Ze([g.$1h],M.prototype,"onMouseMiddleClick",null),Ze([g.$1h],M.prototype,"onMouseUp",null),Ze([g.$1h],M.prototype,"onMouseDown",null),Ze([g.$1h],M.prototype,"onMouseOver",null),Ze([g.$1h],M.prototype,"onMouseMove",null),Ze([g.$1h],M.prototype,"onMouseOut",null),Ze([g.$1h],M.prototype,"onContextMenu",null),Ze([g.$1h],M.prototype,"onTouchStart",null),Ze([g.$1h],M.prototype,"onTap",null)}),define(me[49],be([1,0,4,24,15,28,68,81,8,11,84,31,3,44,2,40,5,10,80,72,20,57,110]),function(se,t,i,C,B,Q,A,T,d,g,$,P,c,h,e,n,o,l,f,S,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qU=t.$pU=t.$oU=t.$nU=t.$kU=t.TypeNavigationMode=void 0,t.$cU=M,t.$dU=p,t.$eU=I,t.$fU=V,t.$gU=R,t.$hU=x,t.$iU=O,t.$jU=G,t.$lU=De,t.$mU=Ee;class r{constructor(u){this.d=u,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(u){return u}renderElement(u,y,a){const v=this.c.findIndex(N=>N.templateData===a);if(v>=0){const N=this.c[v];this.d.unrender(a),N.index=y}else{const N={index:y,templateData:a};this.c.push(N)}this.d.renderIndex(y,a)}splice(u,y,a){const v=[];for(const N of this.c)N.index<u?v.push(N):N.index>=u+y&&v.push({index:N.index+a-y,templateData:N.templateData});this.c=v}renderIndexes(u){for(const{index:y,templateData:a}of this.c)u.indexOf(y)>-1&&this.d.renderIndex(y,a)}disposeTemplate(u){const y=this.c.findIndex(a=>a.templateData===u);y<0||this.c.splice(y,1)}}class E{get name(){return this.g}get renderer(){return new r(this)}constructor(u){this.g=u,this.c=[],this.d=[],this.f=new c.$ee,this.onChange=this.f.event}splice(u,y,a){const v=a.length-y,N=u+y,s=[];let D=0;for(;D<this.d.length&&this.d[D]<u;)s.push(this.d[D++]);for(let w=0;w<a.length;w++)a[w]&&s.push(w+u);for(;D<this.d.length&&this.d[D]>=N;)s.push(this.d[D++]+v);this.renderer.splice(u,y,a.length),this.h(s,s)}renderIndex(u,y){y.classList.toggle(this.g,this.contains(u))}unrender(u){u.classList.remove(this.g)}set(u,y){return this.h(u,[...u].sort(ge),y)}h(u,y,a){const v=this.c,N=this.d;this.c=u,this.d=y;const s=H(N,u);return this.renderer.renderIndexes(s),this.f.fire({indexes:u,browserEvent:a}),v}get(){return this.c}contains(u){return(0,d.$wb)(this.d,u,ge)>=0}dispose(){(0,e.$Qc)(this.f)}}Ze([P.$1h],E.prototype,"renderer",null);class k extends E{constructor(u){super("selected"),this.k=u}renderIndex(u,y){super.renderIndex(u,y),this.k&&(this.contains(u)?y.setAttribute("aria-selected","true"):y.setAttribute("aria-selected","false"))}}class F{constructor(u,y,a){this.c=u,this.d=y,this.f=a}splice(u,y,a){if(!this.f)return this.c.splice(u,y,new Array(a.length).fill(!1));const v=this.c.get().map(D=>this.f.getId(this.d.element(D)).toString());if(v.length===0)return this.c.splice(u,y,new Array(a.length).fill(!1));const N=new Set(v),s=a.map(D=>N.has(this.f.getId(D).toString()));this.c.splice(u,y,s)}}function M(z){return z.tagName==="INPUT"||z.tagName==="TEXTAREA"}function W(z,u){return z.classList.contains(u)?!0:z.classList.contains("monaco-list")||!z.parentElement?!1:W(z.parentElement,u)}function p(z){return W(z,"monaco-editor")}function I(z){return W(z,"monaco-custom-toggle")}function V(z){return W(z,"action-item")}function R(z){return W(z,"monaco-tl-twistie")}function x(z){return W(z,"monaco-tree-sticky-row")}function O(z){return z.classList.contains("monaco-tree-sticky-container")}function G(z){return z.tagName==="A"&&z.classList.contains("monaco-button")||z.tagName==="DIV"&&z.classList.contains("monaco-button-dropdown")?!0:z.classList.contains("monaco-list")||!z.parentElement?!1:G(z.parentElement)}class q{get g(){return c.Event.chain(this.c.add(new C.$XT(this.k.domNode,"keydown")).event,u=>u.filter(y=>!M(y.target)).map(y=>new B.$QR(y)))}constructor(u,y,a){this.h=u,this.k=y,this.c=new e.$Uc,this.d=new e.$Uc,this.f=a.multipleSelectionSupport,this.c.add(this.g(v=>{switch(v.keyCode){case 3:return this.l(v);case 16:return this.o(v);case 18:return this.p(v);case 11:return this.q(v);case 12:return this.s(v);case 9:return this.u(v);case 31:this.f&&(o.$j?v.metaKey:v.ctrlKey)&&this.t(v)}}))}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.f=u.multipleSelectionSupport)}l(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection(this.h.getFocus(),u.browserEvent)}o(u){u.preventDefault(),u.stopPropagation(),this.h.focusPrevious(1,!1,u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}p(u){u.preventDefault(),u.stopPropagation(),this.h.focusNext(1,!1,u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}q(u){u.preventDefault(),u.stopPropagation(),this.h.focusPreviousPage(u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}s(u){u.preventDefault(),u.stopPropagation(),this.h.focusNextPage(u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}t(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection((0,d.$Sb)(this.h.length),u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(u){this.h.getSelection().length&&(u.preventDefault(),u.stopPropagation(),this.h.setSelection([],u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ze([P.$1h],q.prototype,"g",null);var ae;(function(z){z[z.Automatic=0]="Automatic",z[z.Trigger=1]="Trigger"})(ae||(t.TypeNavigationMode=ae={}));var ie;(function(z){z[z.Idle=0]="Idle",z[z.Typing=1]="Typing"})(ie||(ie={})),t.$kU=new class{mightProducePrintableCharacter(z){return z.ctrlKey||z.metaKey||z.altKey?!1:z.keyCode>=31&&z.keyCode<=56||z.keyCode>=21&&z.keyCode<=30||z.keyCode>=98&&z.keyCode<=107||z.keyCode>=85&&z.keyCode<=95}};class ee{constructor(u,y,a,v,N){this.o=u,this.p=y,this.q=a,this.s=v,this.t=N,this.c=!1,this.d=ie.Idle,this.f=ae.Automatic,this.g=!1,this.h=-1,this.k=new e.$Uc,this.l=new e.$Uc,this.updateOptions(u.options)}updateOptions(u){u.typeNavigationEnabled??!0?this.u():this.v(),this.f=u.typeNavigationMode??ae.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let u=!1;const y=c.Event.chain(this.k.add(new C.$XT(this.p.domNode,"keydown")).event,N=>N.filter(s=>!M(s.target)).filter(()=>this.f===ae.Automatic||this.g).map(s=>new B.$QR(s)).filter(s=>u||this.s(s)).filter(s=>this.t.mightProducePrintableCharacter(s)).forEach(s=>i.$OS.stop(s,!0)).map(s=>s.browserEvent.key)),a=c.Event.debounce(y,()=>null,800,void 0,void 0,void 0,this.k);c.Event.reduce(c.Event.any(y,a),(N,s)=>s===null?null:(N||"")+s,void 0,this.k)(this.x,this,this.k),a(this.w,this,this.k),y(()=>u=!0,void 0,this.k),a(()=>u=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const u=this.o.getFocus();if(u.length>0&&u[0]===this.h){const y=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(u[0]));typeof y=="string"?(0,A.$ZT)(y):y&&(0,A.$ZT)(y.get())}this.h=-1}x(u){if(!u){this.d=ie.Idle,this.g=!1;return}const y=this.o.getFocus(),a=y.length>0?y[0]:0,v=this.d===ie.Idle?1:0;this.d=ie.Typing;for(let N=0;N<this.o.length;N++){const s=(a+N+v)%this.o.length,D=this.q.getKeyboardNavigationLabel(this.p.element(s)),w=D&&D.toString();if(this.o.options.typeNavigationEnabled){if(typeof w<"u"){if((0,h.$yk)(u,w)){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}const L=(0,h.$Fk)(u,w);if(L&&L[0].end-L[0].start>1&&L.length===1){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}}}else if(typeof w>"u"||(0,h.$yk)(u,w)){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ce{constructor(u,y){this.d=u,this.f=y,this.c=new e.$Uc;const a=c.Event.chain(this.c.add(new C.$XT(y.domNode,"keydown")).event,N=>N.filter(s=>!M(s.target)).map(s=>new B.$QR(s)));c.Event.chain(a,N=>N.filter(s=>s.keyCode===2&&!s.ctrlKey&&!s.metaKey&&!s.shiftKey&&!s.altKey))(this.g,this,this.c)}g(u){if(u.target!==this.f.domNode)return;const y=this.d.getFocus();if(y.length===0)return;const a=this.f.domElement(y[0]);if(!a)return;const v=a.querySelector("[tabIndex]");if(!v||!(v instanceof HTMLElement)||v.tabIndex===-1)return;const N=(0,i.getWindow)(v).getComputedStyle(v);N.visibility==="hidden"||N.display==="none"||(u.preventDefault(),u.stopPropagation(),v.focus())}dispose(){this.c.dispose()}}function De(z){return o.$j?z.browserEvent.metaKey:z.browserEvent.ctrlKey}function Ee(z){return z.browserEvent.shiftKey}function Me(z){return(0,i.$IS)(z)&&z.button===2}const le={isSelectionSingleChangeEvent:De,isSelectionRangeChangeEvent:Ee};class _{constructor(u){this.k=u,this.f=new e.$Uc,this.g=new c.$ee,this.onPointer=this.g.event,u.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||le),this.d=typeof u.options.mouseSupport>"u"||!!u.options.mouseSupport,this.d&&(u.onMouseDown(this.s,this,this.f),u.onContextMenu(this.t,this,this.f),u.onMouseDblClick(this.v,this,this.f),u.onTouchStart(this.s,this,this.f),this.f.add(Q.$qT.addTarget(u.getHTMLElement()))),c.Event.any(u.onMouseClick,u.onMouseMiddleClick,u.onTap)(this.u,this,this.f)}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.c=void 0,u.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||le))}o(u){return this.c?this.c.isSelectionSingleChangeEvent(u):!1}p(u){return this.c?this.c.isSelectionRangeChangeEvent(u):!1}q(u){return this.o(u)||this.p(u)}s(u){p(u.browserEvent.target)||(0,i.$tS)()!==u.browserEvent.target&&this.k.domFocus()}t(u){if(M(u.browserEvent.target)||p(u.browserEvent.target))return;const y=typeof u.index>"u"?[]:[u.index];this.k.setFocus(y,u.browserEvent)}u(u){if(!this.d||M(u.browserEvent.target)||p(u.browserEvent.target)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const y=u.index;if(typeof y>"u"){this.k.setFocus([],u.browserEvent),this.k.setSelection([],u.browserEvent),this.k.setAnchor(void 0);return}if(this.q(u))return this.w(u);this.k.setFocus([y],u.browserEvent),this.k.setAnchor(y),Me(u.browserEvent)||this.k.setSelection([y],u.browserEvent),this.g.fire(u)}v(u){if(M(u.browserEvent.target)||p(u.browserEvent.target)||this.q(u)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const y=this.k.getFocus();this.k.setSelection(y,u.browserEvent)}w(u){const y=u.index;let a=this.k.getAnchor();if(this.p(u)){typeof a>"u"&&(a=this.k.getFocus()[0]??y,this.k.setAnchor(a));const v=Math.min(a,y),N=Math.max(a,y),s=(0,d.$Sb)(v,N+1),D=this.k.getSelection(),w=ye(H(D,[a]),a);if(w.length===0)return;const L=H(s,J(D,w));this.k.setSelection(L,u.browserEvent),this.k.setFocus([y],u.browserEvent)}else if(this.o(u)){const v=this.k.getSelection(),N=v.filter(s=>s!==y);this.k.setFocus([y]),this.k.setAnchor(y),v.length===N.length?this.k.setSelection([...N,y],u.browserEvent):this.k.setSelection(N,u.browserEvent)}}dispose(){this.f.dispose()}}t.$nU=_;class ue{constructor(u,y){this.c=u,this.d=y}style(u){const y=this.d&&`.${this.d}`,a=[];u.listBackground&&a.push(`.monaco-list${y} .monaco-list-rows { background: ${u.listBackground}; }`),u.listFocusBackground&&(a.push(`.monaco-list${y}:focus .monaco-list-row.focused { background-color: ${u.listFocusBackground}; }`),a.push(`.monaco-list${y}:focus .monaco-list-row.focused:hover { background-color: ${u.listFocusBackground}; }`)),u.listFocusForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),u.listActiveSelectionBackground&&(a.push(`.monaco-list${y}:focus .monaco-list-row.selected { background-color: ${u.listActiveSelectionBackground}; }`),a.push(`.monaco-list${y}:focus .monaco-list-row.selected:hover { background-color: ${u.listActiveSelectionBackground}; }`)),u.listActiveSelectionForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.selected { color: ${u.listActiveSelectionForeground}; }`),u.listActiveSelectionIconForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.selected .codicon { color: ${u.listActiveSelectionIconForeground}; }`),u.listFocusAndSelectionBackground&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { background-color: ${u.listFocusAndSelectionBackground}; }
			`),u.listFocusAndSelectionForeground&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { color: ${u.listFocusAndSelectionForeground}; }
			`),u.listInactiveFocusForeground&&(a.push(`.monaco-list${y} .monaco-list-row.focused { color:  ${u.listInactiveFocusForeground}; }`),a.push(`.monaco-list${y} .monaco-list-row.focused:hover { color:  ${u.listInactiveFocusForeground}; }`)),u.listInactiveSelectionIconForeground&&a.push(`.monaco-list${y} .monaco-list-row.focused .codicon { color:  ${u.listInactiveSelectionIconForeground}; }`),u.listInactiveFocusBackground&&(a.push(`.monaco-list${y} .monaco-list-row.focused { background-color:  ${u.listInactiveFocusBackground}; }`),a.push(`.monaco-list${y} .monaco-list-row.focused:hover { background-color:  ${u.listInactiveFocusBackground}; }`)),u.listInactiveSelectionBackground&&(a.push(`.monaco-list${y} .monaco-list-row.selected { background-color:  ${u.listInactiveSelectionBackground}; }`),a.push(`.monaco-list${y} .monaco-list-row.selected:hover { background-color:  ${u.listInactiveSelectionBackground}; }`)),u.listInactiveSelectionForeground&&a.push(`.monaco-list${y} .monaco-list-row.selected { color: ${u.listInactiveSelectionForeground}; }`),u.listHoverBackground&&a.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${u.listHoverBackground}; }`),u.listHoverForeground&&a.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${u.listHoverForeground}; }`);const v=(0,i.$_S)(u.listFocusAndSelectionOutline,(0,i.$_S)(u.listSelectionOutline,u.listFocusOutline??""));v&&a.push(`.monaco-list${y}:focus .monaco-list-row.focused.selected { outline: 1px solid ${v}; outline-offset: -1px;}`),u.listFocusOutline&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${y}.last-focused .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
			`);const N=(0,i.$_S)(u.listSelectionOutline,u.listInactiveFocusOutline??"");N&&a.push(`.monaco-list${y} .monaco-list-row.focused.selected { outline: 1px dotted ${N}; outline-offset: -1px; }`),u.listSelectionOutline&&a.push(`.monaco-list${y} .monaco-list-row.selected { outline: 1px dotted ${u.listSelectionOutline}; outline-offset: -1px; }`),u.listInactiveFocusOutline&&a.push(`.monaco-list${y} .monaco-list-row.focused { outline: 1px dotted ${u.listInactiveFocusOutline}; outline-offset: -1px; }`),u.listHoverOutline&&a.push(`.monaco-list${y} .monaco-list-row:hover { outline: 1px dashed ${u.listHoverOutline}; outline-offset: -1px; }`),u.listDropOverBackground&&a.push(`
				.monaco-list${y}.drop-target,
				.monaco-list${y} .monaco-list-rows.drop-target,
				.monaco-list${y} .monaco-list-row.drop-target { background-color: ${u.listDropOverBackground} !important; color: inherit !important; }
			`),u.listDropBetweenBackground&&(a.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${y} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`),a.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${y} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`)),u.tableColumnsBorder&&a.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${u.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),u.tableOddRowsBackgroundColor&&a.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${u.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=a.join(`
`)}}t.$oU=ue,t.$pU={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:$.$Pt.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:$.$Pt.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:$.$Pt.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const re={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function ye(z,u){const y=z.indexOf(u);if(y===-1)return[];const a=[];let v=y-1;for(;v>=0&&z[v]===u-(y-v);)a.push(z[v--]);for(a.reverse(),v=y;v<z.length&&z[v]===u+(v-y);)a.push(z[v++]);return a}function H(z,u){const y=[];let a=0,v=0;for(;a<z.length||v<u.length;)if(a>=z.length)y.push(u[v++]);else if(v>=u.length)y.push(z[a++]);else if(z[a]===u[v]){y.push(z[a]),a++,v++;continue}else z[a]<u[v]?y.push(z[a++]):y.push(u[v++]);return y}function J(z,u){const y=[];let a=0,v=0;for(;a<z.length||v<u.length;)if(a>=z.length)y.push(u[v++]);else if(v>=u.length)y.push(z[a++]);else if(z[a]===u[v]){a++,v++;continue}else z[a]<u[v]?y.push(z[a++]):v++;return y}const ge=(z,u)=>z-u;class we{constructor(u,y){this.c=u,this.d=y}get templateId(){return this.c}renderTemplate(u){return this.d.map(y=>y.renderTemplate(u))}renderElement(u,y,a,v){let N=0;for(const s of this.d)s.renderElement(u,y,a[N++],v)}disposeElement(u,y,a,v){let N=0;for(const s of this.d)s.disposeElement?.(u,y,a[N],v),N+=1}disposeTemplate(u){let y=0;for(const a of this.d)a.disposeTemplate(u[y++])}}class ke{constructor(u){this.c=u,this.templateId="a18n"}renderTemplate(u){return{container:u,disposables:new e.$Uc}}renderElement(u,y,a){const v=this.c.getAriaLabel(u),N=v&&typeof v!="string"?v:(0,b.constObservable)(v);a.disposables.add((0,b.autorun)(D=>{this.d(D.readObservable(N),a.container)}));const s=this.c.getAriaLevel&&this.c.getAriaLevel(u);typeof s=="number"?a.container.setAttribute("aria-level",`${s}`):a.container.removeAttribute("aria-level")}d(u,y){u?y.setAttribute("aria-label",u):y.removeAttribute("aria-label")}disposeElement(u,y,a,v){a.disposables.clear()}disposeTemplate(u){u.disposables.dispose()}}class Fe{constructor(u,y){this.c=u,this.d=y}getDragElements(u){const y=this.c.getSelectedElements();return y.indexOf(u)>-1?y:[u]}getDragURI(u){return this.d.getDragURI(u)}getDragLabel(u,y){if(this.d.getDragLabel)return this.d.getDragLabel(u,y)}onDragStart(u,y){this.d.onDragStart?.(u,y)}onDragOver(u,y,a,v,N){return this.d.onDragOver(u,y,a,v,N)}onDragLeave(u,y,a,v){this.d.onDragLeave?.(u,y,a,v)}onDragEnd(u){this.d.onDragEnd?.(u)}drop(u,y,a,v,N){this.d.drop(u,y,a,v,N)}dispose(){this.d.dispose()}}class Ie{get onDidChangeFocus(){return c.Event.map(this.g.wrapEvent(this.c.onChange),u=>this.G(u),this.y)}get onDidChangeSelection(){return c.Event.map(this.g.wrapEvent(this.d.onChange),u=>this.G(u),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let u=!1;const y=c.Event.chain(this.y.add(new C.$XT(this.k.domNode,"keydown")).event,N=>N.map(s=>new B.$QR(s)).filter(s=>u=s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$OS.stop(s,!0)).filter(()=>!1)),a=c.Event.chain(this.y.add(new C.$XT(this.k.domNode,"keyup")).event,N=>N.forEach(()=>u=!1).map(s=>new B.$QR(s)).filter(s=>s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$OS.stop(s,!0)).map(({browserEvent:s})=>{const D=this.getFocus(),w=D.length?D[0]:void 0,L=typeof w<"u"?this.k.element(w):void 0,j=typeof w<"u"?this.k.domElement(w):this.k.domNode;return{index:w,element:L,anchor:j,browserEvent:s}})),v=c.Event.chain(this.k.onContextMenu,N=>N.filter(s=>!u).map(({element:s,index:D,browserEvent:w})=>({element:s,index:D,anchor:new m.$LR((0,i.getWindow)(this.k.domNode),w),browserEvent:w})));return c.Event.any(y,a,v)}get onKeyDown(){return this.y.add(new C.$XT(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new C.$XT(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new C.$XT(this.k.domNode,"keypress")).event}get onDidFocus(){return c.Event.signal(this.y.add(new C.$XT(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return c.Event.signal(this.y.add(new C.$XT(this.k.domNode,"blur",!0)).event)}constructor(u,y,a,v,N=re){this.A=u,this.B=N,this.c=new E("focused"),this.f=new E("anchor"),this.g=new c.$me,this.x="",this.y=new e.$Uc,this.z=new c.$ee,this.onDidDispose=this.z.event;const s=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new k(s!=="listbox");const D=[this.c.renderer,this.d.renderer];this.u=N.accessibilityProvider,this.u&&(D.push(new ke(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),v=v.map(L=>new we(L.templateId,[...D,L]));const w={...N,dnd:N.dnd&&new Fe(this,N.dnd)};if(this.k=this.C(y,a,v,w),this.k.domNode.setAttribute("role",s),N.styleController)this.q=N.styleController(this.k.domId);else{const L=(0,i.$BS)(this.k.domNode);this.q=new ue(L,this.k.domId)}if(this.o=new T.$2T([new F(this.c,this.k,N.identityProvider),new F(this.d,this.k,N.identityProvider),new F(this.f,this.k,N.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ce(this,this.k)),(typeof N.keyboardSupport!="boolean"||N.keyboardSupport)&&(this.v=new q(this,this.k,N),this.y.add(this.v)),N.keyboardNavigationLabelProvider){const L=N.keyboardNavigationDelegate||t.$kU;this.t=new ee(this,this.k,N.keyboardNavigationLabelProvider,N.keyboardNavigationEventFilter??(()=>!0),L),this.y.add(this.t)}this.w=this.D(N),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(u,y,a,v){return new S.$$T(u,y,a,v)}D(u){return new _(this)}updateOptions(u={}){this.B={...this.B,...u},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(u),this.v?.updateOptions(u),this.k.updateOptions(u)}get options(){return this.B}splice(u,y,a=[]){if(u<0||u>this.k.length)throw new f.$aU(this.A,`Invalid start index: ${u}`);if(y<0)throw new f.$aU(this.A,`Invalid delete count: ${y}`);y===0&&a.length===0||this.g.bufferEvents(()=>this.o.splice(u,y,a))}updateWidth(u){this.k.updateWidth(u)}updateElementHeight(u,y){this.k.updateElementHeight(u,y,null)}rerender(){this.k.rerender()}element(u){return this.k.element(u)}indexOf(u){return this.k.indexOf(u)}indexAt(u){return this.k.indexAt(u)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(u){this.k.setScrollTop(u)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(u){this.k.setScrollLeft(u)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(u){this.x=u,this.k.domNode.setAttribute("aria-label",u)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(u,y){this.k.layout(u,y)}triggerTypeNavigation(){this.t?.trigger()}setSelection(u,y){for(const a of u)if(a<0||a>=this.length)throw new f.$aU(this.A,`Invalid index ${a}`);this.d.set(u,y)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(u=>this.k.element(u))}setAnchor(u){if(typeof u>"u"){this.f.set([]);return}if(u<0||u>=this.length)throw new f.$aU(this.A,`Invalid index ${u}`);this.f.set([u])}getAnchor(){return(0,d.$Ob)(this.f.get(),void 0)}getAnchorElement(){const u=this.getAnchor();return typeof u>"u"?void 0:this.element(u)}setFocus(u,y){for(const a of u)if(a<0||a>=this.length)throw new f.$aU(this.A,`Invalid index ${a}`);this.c.set(u,y)}focusNext(u=1,y=!1,a,v){if(this.length===0)return;const N=this.c.get(),s=this.E(N.length>0?N[0]+u:0,y,v);s>-1&&this.setFocus([s],a)}focusPrevious(u=1,y=!1,a,v){if(this.length===0)return;const N=this.c.get(),s=this.F(N.length>0?N[0]-u:0,y,v);s>-1&&this.setFocus([s],a)}async focusNextPage(u,y){let a=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);a=a===0?0:a-1;const v=this.getFocus()[0];if(v!==a&&(v===void 0||a>v)){const N=this.F(a,!1,y);N>-1&&v!==N?this.setFocus([N],u):this.setFocus([a],u)}else{const N=this.k.getScrollTop();let s=N+this.k.renderHeight;a>v&&(s-=this.k.elementHeight(a)),this.k.setScrollTop(s),this.k.getScrollTop()!==N&&(this.setFocus([]),await(0,g.$xh)(0),await this.focusNextPage(u,y))}}async focusPreviousPage(u,y,a=()=>0){let v;const N=a(),s=this.k.getScrollTop()+N;s===0?v=this.k.indexAt(s):v=this.k.indexAfter(s-1);const D=this.getFocus()[0];if(D!==v&&(D===void 0||D>=v)){const w=this.E(v,!1,y);w>-1&&D!==w?this.setFocus([w],u):this.setFocus([v],u)}else{const w=s;this.k.setScrollTop(s-this.k.renderHeight-N),this.k.getScrollTop()+a()!==w&&(this.setFocus([]),await(0,g.$xh)(0),await this.focusPreviousPage(u,y,a))}}focusLast(u,y){if(this.length===0)return;const a=this.F(this.length-1,!1,y);a>-1&&this.setFocus([a],u)}focusFirst(u,y){this.focusNth(0,u,y)}focusNth(u,y,a){if(this.length===0)return;const v=this.E(u,!1,a);v>-1&&this.setFocus([v],y)}E(u,y=!1,a){for(let v=0;v<this.length;v++){if(u>=this.length&&!y)return-1;if(u=u%this.length,!a||a(this.element(u)))return u;u++}return-1}F(u,y=!1,a){for(let v=0;v<this.length;v++){if(u<0&&!y)return-1;if(u=(this.length+u%this.length)%this.length,!a||a(this.element(u)))return u;u--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(u=>this.k.element(u))}reveal(u,y,a=0){if(u<0||u>=this.length)throw new f.$aU(this.A,`Invalid index ${u}`);const v=this.k.getScrollTop(),N=this.k.elementTop(u),s=this.k.elementHeight(u);if((0,l.$ag)(y)){const D=s-this.k.renderHeight+a;this.k.setScrollTop(D*(0,n.$Bm)(y,0,1)+N-a)}else{const D=N+s,w=v+this.k.renderHeight;N<v+a&&D>=w||(N<v+a||D>=w&&s>=this.k.renderHeight?this.k.setScrollTop(N-a):D>=w&&this.k.setScrollTop(D-this.k.renderHeight))}}getRelativeTop(u,y=0){if(u<0||u>=this.length)throw new f.$aU(this.A,`Invalid index ${u}`);const a=this.k.getScrollTop(),v=this.k.elementTop(u),N=this.k.elementHeight(u);if(v<a+y||v+N>a+this.k.renderHeight)return null;const s=N-this.k.renderHeight+y;return Math.abs((a+y-v)/s)}isDOMFocused(){return(0,i.$uS)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(u){return this.k.getElementDomId(u)}getElementTop(u){return this.k.elementTop(u)}style(u){this.q.style(u)}G({indexes:u,browserEvent:y}){return{indexes:u,elements:u.map(a=>this.k.element(a)),browserEvent:y}}H(){const u=this.c.get();this.k.domNode.classList.toggle("element-focused",u.length>0),this.I()}I(){const u=this.c.get();if(u.length>0){let y;this.u?.getActiveDescendantId&&(y=this.u.getActiveDescendantId(this.k.element(u[0]))),this.k.domNode.setAttribute("aria-activedescendant",y||this.k.getElementDomId(u[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const u=this.d.get();this.k.domNode.classList.toggle("selection-none",u.length===0),this.k.domNode.classList.toggle("selection-single",u.length===1),this.k.domNode.classList.toggle("selection-multiple",u.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$qU=Ie,Ze([P.$1h],Ie.prototype,"onDidChangeFocus",null),Ze([P.$1h],Ie.prototype,"onDidChangeSelection",null),Ze([P.$1h],Ie.prototype,"onContextMenu",null),Ze([P.$1h],Ie.prototype,"onKeyDown",null),Ze([P.$1h],Ie.prototype,"onKeyUp",null),Ze([P.$1h],Ie.prototype,"onKeyPress",null),Ze([P.$1h],Ie.prototype,"onDidFocus",null),Ze([P.$1h],Ie.prototype,"onDidBlur",null)}),define(me[137],be([1,0,6,62,47,9,16]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tk=t.MarkdownStringTextNewlineStyle=void 0,t.$Uk=g,t.$Vk=$,t.$Wk=P,t.$Xk=c,t.$Yk=h,t.$Zk=e,t.$1k=n,t.$2k=o;var T;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(T||(t.MarkdownStringTextNewlineStyle=T={}));class d{constructor(f="",S=!1){if(this.value=f,typeof this.value!="string")throw(0,i.$7)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=S.isTrusted??void 0,this.supportThemeIcons=S.supportThemeIcons??!1,this.supportHtml=S.supportHtml??!1)}appendText(f,S=0){return this.value+=c(this.supportThemeIcons?(0,C.$Nk)(f):f).replace(/([ \t]+)/g,(m,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,S){return this.value+=`
${h(S,f)}
`,this}appendLink(f,S,m){return this.value+="[",this.value+=this.c(S,"]"),this.value+="](",this.value+=this.c(String(f),")"),m&&(this.value+=` "${this.c(this.c(m,'"'),")")}"`),this.value+=")",this}c(f,S){const m=new RegExp((0,Q.$af)(S),"g");return f.replace(m,(b,r)=>f.charAt(r-1)!=="\\"?`\\${b}`:b)}}t.$Tk=d;function g(l){return $(l)?!l.value:Array.isArray(l)?l.every(g):!0}function $(l){return l instanceof d?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}function P(l,f){return l===f?!0:!l||!f?!1:l.value===f.value&&l.isTrusted===f.isTrusted&&l.supportThemeIcons===f.supportThemeIcons&&l.supportHtml===f.supportHtml&&(l.baseUri===f.baseUri||!!l.baseUri&&!!f.baseUri&&(0,B.$3g)(A.URI.from(l.baseUri),A.URI.from(f.baseUri)))}function c(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function h(l,f){const S=l.match(/^`+/gm)?.reduce((b,r)=>b.length>r.length?b:r).length??0,m=S>=3?S+1:3;return[`${"`".repeat(m)}${f}`,l,`${"`".repeat(m)}`].join(`
`)}function e(l){return l.replace(/"/g,"&quot;")}function n(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(l){const f=[],S=l.split("|").map(b=>b.trim());l=S[0];const m=S[1];if(m){const b=/height=(\d+)/.exec(m),r=/width=(\d+)/.exec(m),E=b?b[1]:"",k=r?r[1]:"",F=isFinite(parseInt(k)),M=isFinite(parseInt(E));F&&f.push(`width="${k}"`),M&&f.push(`height="${E}"`)}return{href:l,dimensions:f}}}),define(me[138],be([1,0,4,129,24,66,15,20,130,6,3,137,62,86,23,2,88,64,36,61,47,9,16]),function(se,t,i,C,B,Q,A,T,d,g,$,P,c,h,e,n,o,l,f,S,m,b,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uU=void 0,t.$tU=k,t.$vU=I,t.$wU=V,t.$xU=ae;const E=Object.freeze({image:(H,J,ge)=>{let we=[],ke=[];return H&&({href:H,dimensions:we}=(0,P.$2k)(H),ke.push(`src="${(0,P.$Zk)(H)}"`)),ge&&ke.push(`alt="${(0,P.$Zk)(ge)}"`),J&&ke.push(`title="${(0,P.$Zk)(J)}"`),we.length&&(ke=ke.concat(we)),"<img "+ke.join(" ")+">"},paragraph:H=>`<p>${H}</p>`,link:(H,J,ge)=>typeof H!="string"?"":(H===ge&&(ge=(0,P.$1k)(ge)),J=typeof J=="string"?(0,P.$Zk)((0,P.$1k)(J)):"",H=(0,P.$1k)(H),H=H.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${H}" title="${J||H}" draggable="false">${ge}</a>`)});function k(H,J={},ge={}){const we=new n.$Uc;let ke=!1;const Fe=(0,Q.$WT)(J),Ie=function(w){let L;try{L=(0,l.$5h)(decodeURIComponent(w))}catch{}return L?(L=(0,S.$5n)(L,j=>{if(H.uris&&H.uris[j])return r.URI.revive(H.uris[j])}),encodeURIComponent(JSON.stringify(L))):w},z=function(w,L){const j=H.uris&&H.uris[w];let X=r.URI.revive(j);return L?w.startsWith(f.Schemas.data+":")?w:(X||(X=r.URI.parse(w)),f.$Qg.uriToBrowserUri(X).toString(!0)):!X||r.URI.parse(w).toString()===X.toString()?w:(X.query&&(X=X.with({query:Ie(X.query)})),X.toString())},u=new o.marked.Renderer;u.image=E.image,u.link=E.link,u.paragraph=E.paragraph;const y=[],a=[];if(J.codeBlockRendererSync?u.code=(w,L)=>{const j=h.$wP.nextId(),X=J.codeBlockRendererSync(F(L),w);return a.push([j,X]),`<div class="code" data-code="${j}">${(0,b.$_e)(w)}</div>`}:J.codeBlockRenderer&&(u.code=(w,L)=>{const j=h.$wP.nextId(),X=J.codeBlockRenderer(F(L),w);return y.push(X.then(Z=>[j,Z])),`<div class="code" data-code="${j}">${(0,b.$_e)(w)}</div>`}),J.actionHandler){const w=function(X){let Z=X.target;if(!(Z.tagName!=="A"&&(Z=Z.parentElement,!Z||Z.tagName!=="A")))try{let oe=Z.dataset.href;oe&&(H.baseUri&&(oe=M(r.URI.from(H.baseUri),oe)),J.actionHandler.callback(oe,X))}catch(oe){(0,g.$1)(oe)}finally{X.preventDefault()}},L=J.actionHandler.disposables.add(new B.$XT(Fe,"click")),j=J.actionHandler.disposables.add(new B.$XT(Fe,"auxclick"));J.actionHandler.disposables.add($.Event.any(L.event,j.event)(X=>{const Z=new T.$LR(i.getWindow(Fe),X);!Z.leftButton&&!Z.middleButton||w(Z)})),J.actionHandler.disposables.add(i.$TR(Fe,"keydown",X=>{const Z=new A.$QR(X);!Z.equals(10)&&!Z.equals(3)||w(Z)}))}H.supportHtml||(ge.sanitizer=w=>(H.isTrusted?w.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?w:"",ge.sanitize=!0,ge.silent=!0),ge.renderer=u;let v=H.value??"";v.length>1e5&&(v=`${v.substr(0,1e5)}\u2026`),H.supportThemeIcons&&(v=(0,c.$Ok)(v));let N;if(J.fillInIncompleteTokens){const w={...o.marked.defaults,...ge},L=o.marked.lexer(v,w),j=ae(L);N=o.marked.parser(j,w)}else N=o.marked.parse(v,ge);H.supportThemeIcons&&(N=(0,d.$rU)(N).map(L=>typeof L=="string"?L:L.outerHTML).join(""));const D=new DOMParser().parseFromString(W(H,N),"text/html");if(D.body.querySelectorAll("img, audio, video, source").forEach(w=>{const L=w.getAttribute("src");if(L){let j=L;try{H.baseUri&&(j=M(r.URI.from(H.baseUri),j))}catch{}if(w.setAttribute("src",z(j,!0)),J.disallowRemoteImages){const X=r.URI.parse(j).scheme;X!==f.Schemas.file&&X!==f.Schemas.data&&w.replaceWith(i.$("",void 0,w.outerHTML))}}}),D.body.querySelectorAll("a").forEach(w=>{const L=w.getAttribute("href");if(w.setAttribute("href",""),!L||/^data:|javascript:/i.test(L)||/^command:/i.test(L)&&!H.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(L))w.replaceWith(...w.childNodes);else{let j=z(L,!1);H.baseUri&&(j=M(r.URI.from(H.baseUri),L)),w.dataset.href=j}}),Fe.innerHTML=W(H,D.body.innerHTML),y.length>0)Promise.all(y).then(w=>{if(ke)return;const L=new Map(w),j=Fe.querySelectorAll("div[data-code]");for(const X of j){const Z=L.get(X.dataset.code??"");Z&&i.$VS(X,Z)}J.asyncRenderCallback?.()});else if(a.length>0){const w=new Map(a),L=Fe.querySelectorAll("div[data-code]");for(const j of L){const X=w.get(j.dataset.code??"");X&&i.$VS(j,X)}}if(J.asyncRenderCallback)for(const w of Fe.getElementsByTagName("img")){const L=we.add(i.$TR(w,"load",()=>{L.dispose(),J.asyncRenderCallback()}))}return{element:Fe,dispose:()=>{ke=!0,we.dispose()}}}function F(H){if(!H)return"";const J=H.split(/[\s+|:|,|\{|\?]/,1);return J.length?J[0]:H}function M(H,J){return/^\w[\w\d+.-]*:/.test(J)?J:H.path.endsWith("/")?(0,m.$ah)(H,J).toString():(0,m.$ah)((0,m.$9g)(H),J).toString()}function W(H,J){const{config:ge,allowedSchemes:we}=p(H);C.addHook("uponSanitizeAttribute",(Fe,Ie)=>{if(Ie.attrName==="style"||Ie.attrName==="class"){if(Fe.tagName==="SPAN"){if(Ie.attrName==="style"){Ie.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Ie.attrValue);return}else if(Ie.attrName==="class"){Ie.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Ie.attrValue);return}}Ie.keepAttr=!1;return}else if(Fe.tagName==="INPUT"&&Fe.attributes.getNamedItem("type")?.value==="checkbox"){if(Ie.attrName==="type"&&Ie.attrValue==="checkbox"||Ie.attrName==="disabled"||Ie.attrName==="checked"){Ie.keepAttr=!0;return}Ie.keepAttr=!1}}),C.addHook("uponSanitizeElement",(Fe,Ie)=>{Ie.tagName==="input"&&(Fe.attributes.getNamedItem("type")?.value==="checkbox"?Fe.setAttribute("disabled",""):Fe.parentElement?.removeChild(Fe))});const ke=i.$dT(we);try{return C.sanitize(J,{...ge,RETURN_TRUSTED_TYPE:!0})}finally{C.removeHook("uponSanitizeAttribute"),ke.dispose()}}t.$uU=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function p(H){const J=[f.Schemas.http,f.Schemas.https,f.Schemas.mailto,f.Schemas.data,f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemote,f.Schemas.vscodeRemoteResource];return H.isTrusted&&J.push(f.Schemas.command),{config:{ALLOWED_TAGS:[...i.$eT],ALLOWED_ATTR:t.$uU,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:J}}function I(H){return typeof H=="string"?H:V(H)}function V(H){let J=H.value??"";J.length>1e5&&(J=`${J.substr(0,1e5)}\u2026`);const ge=o.marked.parse(J,{renderer:x.value}).replace(/&(#\d+|[a-zA-Z]+);/g,we=>R.get(we)??we);return W({isTrusted:!1},ge).toString()}const R=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),x=new e.$V(()=>{const H=new o.marked.Renderer;return H.code=J=>J,H.blockquote=J=>J,H.html=J=>"",H.heading=(J,ge,we)=>J+`
`,H.hr=()=>"",H.list=(J,ge)=>J,H.listitem=J=>J+`
`,H.paragraph=J=>J+`
`,H.table=(J,ge)=>J+ge+`
`,H.tablerow=J=>J,H.tablecell=(J,ge)=>J+" ",H.strong=J=>J,H.em=J=>J,H.codespan=J=>J,H.br=()=>`
`,H.del=J=>J,H.image=(J,ge,we)=>"",H.text=J=>J,H.link=(J,ge,we)=>we,H});function O(H){let J="";return H.forEach(ge=>{J+=ge.raw}),J}function G(H){for(let J=0;J<H.tokens.length;J++){const ge=H.tokens[J];if(ge.type==="text"){const we=ge.raw.split(`
`),ke=we[we.length-1];if(ke.includes("`"))return ee(H);if(ke.includes("**"))return _(H);if(ke.match(/\*\w/))return ce(H);if(ke.match(/(^|\s)__\w/))return ue(H);if(ke.match(/(^|\s)_\w/))return De(H);if(ke.match(/(^|\s)\[.*\]\(\w*/)){const Fe=H.tokens.slice(J+1);return Fe[0]?.type==="link"&&Fe[1]?.type==="text"&&Fe[1].raw.match(/^ *"[^"]*$/)?Me(H):Ee(H)}else{if(q(ke))return Ee(H);if(ke.match(/(^|\s)\[\w/)&&!H.tokens.slice(J+1).some(Fe=>q(Fe.raw)))return le(H)}}}}function q(H){return!!H.match(/^[^\[]*\]\([^\)]*$/)}function ae(H){let J,ge;for(J=0;J<H.length;J++){const we=H[J];let ke;if(we.type==="paragraph"&&(ke=we.raw.match(/(\n|^)(````*)/))){const Fe=ke[2];ge=ie(H.slice(J),Fe);break}if(we.type==="paragraph"&&we.raw.match(/(\n|^)\|/)){ge=ye(H.slice(J));break}if(J===H.length-1&&we.type==="paragraph"){const Fe=G(we);if(Fe){ge=[Fe];break}}}if(ge){const we=[...H.slice(0,J),...ge];return we.links=H.links,we}return H}function ie(H,J){const ge=O(H);return o.marked.lexer(ge+`
${J}`)}function ee(H){return re(H,"`")}function ce(H){return re(H,"*")}function De(H){return re(H,"_")}function Ee(H){return re(H,")")}function Me(H){return re(H,'")')}function le(H){return re(H,"](about:blank)")}function _(H){return re(H,"**")}function ue(H){return re(H,"__")}function re(H,J){const ge=O(Array.isArray(H)?H:[H]);return o.marked.lexer(ge+J)[0]}function ye(H){const J=O(H),ge=J.split(`
`);let we,ke=!1;for(let Fe=0;Fe<ge.length;Fe++){const Ie=ge[Fe].trim();if(typeof we>"u"&&Ie.match(/^\s*\|/)){const z=Ie.match(/(\|[^\|]+)(?=\||$)/g);z&&(we=z.length)}else if(typeof we=="number")if(Ie.match(/^\s*\|/)){if(Fe!==ge.length-1)return;ke=!0}else return}if(typeof we=="number"&&we>0){const Fe=ke?ge.slice(0,-1).join(`
`):J,Ie=!!Fe.match(/\|\s*$/),z=Fe+(Ie?"":"|")+`
|${" --- |".repeat(we)}`;return o.marked.lexer(z)}}}),define(me[139],be([1,0,4,24,15,138,29,14,49,8,3,54,2,5,121,113]),function(se,t,i,C,B,Q,A,T,d,g,$,P,c,h,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AU=void 0;const n=i.$,o="selectOption.entry.template";class l{get templateId(){return o}renderTemplate(m){const b=Object.create(null);return b.root=m,b.text=i.$TS(m,n(".option-text")),b.detail=i.$TS(m,n(".option-detail")),b.decoratorRight=i.$TS(m,n(".option-decorator-right")),b}renderElement(m,b,r){const E=r,k=m.text,F=m.detail,M=m.decoratorRight,W=m.isDisabled;E.text.textContent=k,E.detail.textContent=F||"",E.decoratorRight.innerText=M||"",W?E.root.classList.add("option-disabled"):E.root.classList.remove("option-disabled")}disposeTemplate(m){}}class f extends c.$Vc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(m,b,r,E,k){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=E,this.g=k||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=f.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new $.$ee,this.B(this.r),this.Q(),this.P(r),this.n=b||0,m&&this.setOptions(m,b),this.S()}O(m){!this.M&&m?this.M=this.B((0,A.$zU)().setupUpdatableHover((0,T.$NT)("mouse"),this.h,m)):this.M&&this.M.update(m)}getHeight(){return 22}getTemplateId(){return o}P(m){this.u=m,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$TS(this.w,n(".select-box-details-pane"));const b=i.$TS(this.w,n(".select-box-dropdown-container-width-control")),r=i.$TS(b,n(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$TS(r,this.D),this.G=0,this.y=i.$BS(this.w),this.w.setAttribute("draggable","true"),this.B(i.$TR(this.w,i.$MS.DRAG_START,E=>{i.$OS.stop(E,!0)}))}Q(){this.B(i.$UR(this.h,"change",b=>{this.n=b.target.selectedIndex,this.r.fire({index:b.target.selectedIndex,selected:b.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$TR(this.h,i.$MS.CLICK,b=>{i.$OS.stop(b),this.f?this.Z(!0):this.Y()})),this.B(i.$TR(this.h,i.$MS.MOUSE_DOWN,b=>{i.$OS.stop(b)}));let m;this.B(i.$TR(this.h,"touchstart",b=>{m=this.f})),this.B(i.$TR(this.h,"touchend",b=>{i.$OS.stop(b),m?this.Z(!0):this.Y()})),this.B(i.$TR(this.h,i.$MS.KEY_DOWN,b=>{const r=new B.$QR(b);let E=!1;h.$j?(r.keyCode===18||r.keyCode===16||r.keyCode===10||r.keyCode===3)&&(E=!0):(r.keyCode===18&&r.altKey||r.keyCode===16&&r.altKey||r.keyCode===10||r.keyCode===3)&&(E=!0),E&&(this.Y(),i.$OS.stop(b,!0))}))}get onDidSelect(){return this.r.event}setOptions(m,b){g.$ub(this.m,m)||(this.m=m,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((r,E)=>{this.h.add(this.X(r.text,E,r.isDisabled)),typeof r.description=="string"&&(this.H=!0)})),b!==void 0&&(this.select(b),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(m){m>=0&&m<this.m.length?this.n=m:m>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(m){this.g.ariaLabel=m,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(m){this.h.tabIndex=m?0:-1}render(m){this.j=m,m.classList.add("select-container"),m.appendChild(this.h),this.U()}S(){const m=[];this.s.listFocusBackground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(m.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),m.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),m.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=m.join(`
`)}U(){const m=this.s.selectBackground??"",b=this.s.selectForeground??"",r=this.s.selectBorder??"";this.h.style.backgroundColor=m,this.h.style.color=b,this.h.style.borderColor=r}W(){const m=this.s.selectBackground??"",b=i.$_S(this.s.selectListBackground,m);this.C.style.backgroundColor=b,this.I.style.backgroundColor=b;const r=this.s.focusBorder??"";this.w.style.outlineColor=r,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(m,b,r){const E=document.createElement("option");return E.value=m,E.text=m,E.disabled=!!r,E}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:m=>this.ab(m,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:m=>this.ab(m),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(m){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),m&&this.h.focus(),this.u.hideContextView())}ab(m,b){return m.appendChild(this.w),this.cb(b),{dispose:()=>{try{m.removeChild(this.w)}catch{}}}}bb(){let m=0;return this.m.forEach((b,r)=>{this.jb(r),this.I.offsetHeight>m&&(m=this.I.offsetHeight)}),m}cb(m){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const b=i.getWindow(this.h),r=i.$dS(this.h),E=i.getWindow(this.h).getComputedStyle(this.h),k=parseFloat(E.getPropertyValue("--dropdown-padding-top"))+parseFloat(E.getPropertyValue("--dropdown-padding-bottom")),F=b.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),M=r.top-f.b,W=this.h.offsetWidth,p=this.db(this.D),I=Math.max(p,Math.round(W)).toString()+"px";this.w.style.width=I,this.z.getHTMLElement().style.height="",this.z.layout();let V=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const R=this.H?this.L:0,x=V+k+R,O=Math.floor((F-k-R)/this.getHeight()),G=Math.floor((M-k-R)/this.getHeight());if(m)return r.top+r.height>b.innerHeight-22||r.top<f.b||O<1&&G<1?!1:(O<f.c&&G>O&&this.m.length>O?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>b.innerHeight-22||r.top<f.b||this.G===0&&O<1||this.G===1&&G<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&O+G<1)return this.Z(!0),!1;x>F&&(V=O*this.getHeight())}else x>M&&(V=G*this.getHeight());return this.z.layout(V),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=V+k+"px",this.w.style.height=""):this.w.style.height=V+k+"px",this.jb(this.n),this.w.style.width=I,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(m){let b=0;if(m){let r=0,E=0;this.m.forEach((k,F)=>{const M=k.detail?k.detail.length:0,W=k.decoratorRight?k.decoratorRight.length:0,p=k.text.length+M+W;p>E&&(r=F,E=p)}),m.textContent=this.m[r].text+(this.m[r].decoratorRight?this.m[r].decoratorRight+" ":""),b=i.$fS(m)}return b}eb(m){if(this.z)return;this.C=i.$TS(m,n(".select-box-dropdown-list-container")),this.t=new l,this.z=new d.$qU("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:E=>{let k=E.text;return E.detail&&(k+=`. ${E.detail}`),E.decoratorRight&&(k+=`. ${E.decoratorRight}`),E.description&&(k+=`. ${E.description}`),k},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>h.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const b=this.B(new C.$XT(this.C,"keydown")),r=$.Event.chain(b.event,E=>E.filter(()=>this.z.length>0).map(k=>new B.$QR(k)));this.B($.Event.chain(r,E=>E.filter(k=>k.keyCode===3))(this.lb,this)),this.B($.Event.chain(r,E=>E.filter(k=>k.keyCode===2))(this.lb,this)),this.B($.Event.chain(r,E=>E.filter(k=>k.keyCode===9))(this.kb,this)),this.B($.Event.chain(r,E=>E.filter(k=>k.keyCode===16))(this.nb,this)),this.B($.Event.chain(r,E=>E.filter(k=>k.keyCode===18))(this.mb,this)),this.B($.Event.chain(r,E=>E.filter(k=>k.keyCode===12))(this.pb,this)),this.B($.Event.chain(r,E=>E.filter(k=>k.keyCode===11))(this.ob,this)),this.B($.Event.chain(r,E=>E.filter(k=>k.keyCode===14))(this.qb,this)),this.B($.Event.chain(r,E=>E.filter(k=>k.keyCode===13))(this.rb,this)),this.B($.Event.chain(r,E=>E.filter(k=>k.keyCode>=21&&k.keyCode<=56||k.keyCode>=85&&k.keyCode<=113))(this.sb,this)),this.B(i.$TR(this.z.getHTMLElement(),i.$MS.POINTER_UP,E=>this.fb(E))),this.B(this.z.onMouseOver(E=>typeof E.index<"u"&&this.z.setFocus([E.index]))),this.B(this.z.onDidChangeFocus(E=>this.ib(E))),this.B(i.$TR(this.w,i.$MS.FOCUS_OUT,E=>{!this.f||i.$lS(E.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(m){if(!this.z.length)return;i.$OS.stop(m);const b=m.target;if(!b||b.classList.contains("slider"))return;const r=b.closest(".monaco-list-row");if(!r)return;const E=Number(r.getAttribute("data-index")),k=r.classList.contains("option-disabled");E>=0&&E<this.m.length&&!k&&(this.n=E,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(m,b){const r=k=>{for(let F=0;F<k.childNodes.length;F++){const M=k.childNodes.item(F);(M.tagName&&M.tagName.toLowerCase())==="img"?k.removeChild(M):r(M)}},E=(0,Q.$tU)({value:m,supportThemeIcons:!0},{actionHandler:b});return E.element.classList.add("select-box-description-markdown"),r(E.element),E.element}ib(m){!this.f||!this.H||this.jb(m.indexes[0])}jb(m){this.I.innerText="";const b=this.m[m],r=b?.description??"",E=b?.descriptionIsMarkdown??!1;if(r){if(E){const k=b.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(r,k))}else this.I.innerText=r;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(m){i.$OS.stop(m),this.select(this.F),this.Z(!0)}lb(m){i.$OS.stop(m),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(m){if(this.n<this.m.length-1){i.$OS.stop(m,!0);const b=this.m[this.n+1].isDisabled;if(b&&this.m.length>this.n+2)this.n+=2;else{if(b)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(m){this.n>0&&(i.$OS.stop(m,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(m){i.$OS.stop(m),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(m){i.$OS.stop(m),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(m){i.$OS.stop(m),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(m){i.$OS.stop(m),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(m){const b=P.KeyCodeUtils.toString(m.keyCode);let r=-1;for(let E=0;E<this.m.length-1;E++)if(r=(E+this.n+1)%this.m.length,this.m[r].text.charAt(0).toUpperCase()===b&&!this.m[r].isDisabled){this.select(r),this.z.setFocus([r]),this.z.reveal(this.z.getFocus()[0]),i.$OS.stop(m);break}}dispose(){this.Z(!1),super.dispose()}}t.$AU=f}),define(me[140],be([1,0,49,139,133,21,5,112]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DU=t.$CU=void 0,t.$CU={...i.$pU,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class T extends Q.$uT{constructor(g,$,P,c,h){super(),A.$j&&!h?.useCustomDrawn?this.a=new B.$BU(g,$,c,h):this.a=new C.$AU(g,$,P,c,h),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(g,$){this.a.setOptions(g,$)}select(g){this.a.select(g)}setAriaLabel(g){this.a.setAriaLabel(g)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(g){this.a.setFocusable(g)}render(g){this.a.render(g)}}t.$DU=T}),define(me[73],be([1,0,17,65,4,28,14,140,46,2,5,10,117,29,63]),function(se,t,i,C,B,Q,A,T,d,g,$,P,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LU=t.$KU=t.$JU=void 0;class e extends g.$Vc{get action(){return this._action}constructor(f,S,m={}){super(),this.m=m,this._context=f||this,this._action=S,S instanceof d.$bj&&this.B(S.onDidChange(b=>{this.element&&this.t(b)}))}t(f){f.enabled!==void 0&&this.u(),f.checked!==void 0&&this.H(),f.class!==void 0&&this.G(),f.label!==void 0&&(this.w(),this.D()),f.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new d.$cj)),this.j}set actionRunner(f){this.j=f}isEnabled(){return this._action.enabled}setActionContext(f){this._context=f}render(f){const S=this.element=f;this.B(Q.$qT.addTarget(f));const m=this.m&&this.m.draggable;m&&(f.draggable=!0,i.$zR&&this.B((0,B.$TR)(f,B.$MS.DRAG_START,b=>b.dataTransfer?.setData(C.$oT.TEXT,this._action.label)))),this.B((0,B.$TR)(S,Q.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,B.$TR)(S,B.$MS.MOUSE_DOWN,b=>{m||B.$OS.stop(b,!0),this._action.enabled&&b.button===0&&S.classList.add("active")})),$.$j&&this.B((0,B.$TR)(S,B.$MS.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,B.$TR)(S,B.$MS.CLICK,b=>{B.$OS.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,B.$TR)(S,B.$MS.DBLCLICK,b=>{B.$OS.stop(b,!0)})),[B.$MS.MOUSE_UP,B.$MS.MOUSE_OUT].forEach(b=>{this.B((0,B.$TR)(S,b,r=>{B.$OS.stop(r),S.classList.remove("active")}))})}onClick(f,S=!1){B.$OS.stop(f,!0);const m=P.$fg(this._context)?this.m?.useEventAsContext?f:{preserveFocus:S}:this._context;this.actionRunner.run(this._action,m)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(f){this.element&&(this.element.tabIndex=f?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const f=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=f;else if(!this.f&&f!==""){const S=this.m.hoverDelegate??(0,A.$NT)("element");this.f=this.q.add((0,h.$zU)().setupUpdatableHover(S,this.element,f))}else this.f&&this.f.update(f)}F(){if(this.element){const f=this.C()??"";this.element.setAttribute("aria-label",f)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$JU=e;class n extends e{constructor(f,S,m){super(f,S,m),this.m=m,this.m.icon=m.icon!==void 0?m.icon:!1,this.m.label=m.label!==void 0?m.label:!0,this.L=""}render(f){super.render(f),P.$gg(this.element);const S=document.createElement("a");if(S.classList.add("action-label"),S.setAttribute("role",this.M()),this.I=S,this.element.appendChild(S),this.m.label&&this.m.keybinding){const m=document.createElement("span");m.classList.add("keybinding"),m.textContent=this.m.keybinding,this.element.appendChild(m)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===d.$dj.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(f){this.I&&(this.I.tabIndex=f?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let f=null;return this.action.tooltip?f=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(f=this.action.label,this.m.keybinding&&(f=c.localize(0,null,f,this.m.keybinding))),f??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const f=this.C()??"";this.I.setAttribute("aria-label",f)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$KU=n;class o extends e{constructor(f,S,m,b,r,E,k){super(f,S),this.b=new T.$DU(m,b,r,E,k),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(f,S){this.b.setOptions(f,S)}select(f){this.b.select(f)}g(){this.B(this.b.onDidSelect(f=>this.n(f.selected,f.index)))}n(f,S){this.actionRunner.run(this._action,this.r(f,S))}r(f,S){return f}setFocusable(f){this.b.setFocusable(f)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(f){this.b.render(f)}}t.$LU=o}),define(me[74],be([1,0,4,15,73,14,46,3,2,10,63]),function(se,t,i,C,B,Q,A,T,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PT=t.ActionsOrientation=void 0,t.$QT=c;var $;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})($||(t.ActionsOrientation=$={}));class P extends d.$Vc{constructor(e,n={}){super(),this.j=this.B(new d.$Uc),this.s=this.B(new d.$5c),this.y=!1,this.z=!0,this.D=this.B(new T.$ee),this.onDidBlur=this.D.event,this.F=this.B(new T.$ee({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new T.$ee),this.onDidRun=this.H.event,this.I=this.B(new T.$ee),this.onWillRun=this.I.event,this.b=n,this.m=n.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=n.hoverDelegate??this.B((0,Q.$OT)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new A.$cj,this.j.add(this.g)),this.j.add(this.g.onDidRun(f=>this.H.fire(f))),this.j.add(this.g.onWillRun(f=>this.I.fire(f))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let o,l;switch(this.n){case 0:o=[15],l=[17];break;case 1:o=[16],l=[18],this.domNode.className+=" vertical";break}this.B(i.$TR(this.domNode,i.$MS.KEY_DOWN,f=>{const S=new C.$QR(f);let m=!0;const b=typeof this.u=="number"?this.viewItems[this.u]:void 0;o&&(S.equals(o[0])||S.equals(o[1]))?m=this.Q():l&&(S.equals(l[0])||S.equals(l[1]))?m=this.P():S.equals(9)&&this.G?this.F.fire():S.equals(14)?m=this.N():S.equals(13)?m=this.O():S.equals(2)&&b instanceof B.$JU&&b.trapsArrowNavigation?m=this.P():this.L(S)?this.r.keyDown?this.S(S):this.y=!0:m=!1,m&&(S.preventDefault(),S.stopPropagation())})),this.B(i.$TR(this.domNode,i.$MS.KEY_UP,f=>{const S=new C.$QR(f);this.L(S)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(S)),S.preventDefault(),S.stopPropagation()):(S.equals(2)||S.equals(1026)||S.equals(16)||S.equals(18)||S.equals(15)||S.equals(17))&&this.M()})),this.w=this.B(i.$RS(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$tS()===this.domNode||!i.$lS(i.$tS(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),e.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(e){e?this.C.setAttribute("aria-label",e):this.C.removeAttribute("aria-label")}setFocusable(e){if(this.z=e,this.z){const n=this.viewItems.find(o=>o instanceof B.$JU&&o.isEnabled());n instanceof B.$JU&&n.setFocusable(!0)}else this.viewItems.forEach(n=>{n instanceof B.$JU&&n.setFocusable(!1)})}L(e){let n=!1;return this.r.keys.forEach(o=>{n=n||e.equals(o)}),n}M(){for(let e=0;e<this.C.children.length;e++){const n=this.C.children[e];if(i.$lS(i.$tS(),n)){this.u=e,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(e){this.m=e,this.viewItems.forEach(n=>n.setActionContext(e))}get actionRunner(){return this.g}set actionRunner(e){this.g=e,this.j.clear(),this.j.add(this.g.onDidRun(n=>this.H.fire(n))),this.j.add(this.g.onWillRun(n=>this.I.fire(n))),this.viewItems.forEach(n=>n.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(n=>n.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.C;){if(!e.parentElement)return;e=e.parentElement}for(let n=0;n<this.C.childNodes.length;n++)if(this.C.childNodes[n]===e)return this.viewItems[n].action}}push(e,n={}){const o=Array.isArray(e)?e:[e];let l=g.$ag(n.index)?n.index:null;o.forEach(f=>{const S=document.createElement("li");S.className="action-item",S.setAttribute("role","presentation");let m;const b={hoverDelegate:this.f,...n};this.b.actionViewItemProvider&&(m=this.b.actionViewItemProvider(f,b)),m||(m=new B.$KU(this.context,f,b)),this.b.allowContextMenu||this.s.set(m,i.$TR(S,i.$MS.CONTEXT_MENU,r=>{i.$OS.stop(r,!0)})),m.actionRunner=this.g,m.setActionContext(this.context),m.render(S),this.z&&m instanceof B.$JU&&this.viewItems.length===0&&m.setFocusable(!0),l===null||l<0||l>=this.C.children.length?(this.C.appendChild(S),this.viewItems.push(m)):(this.C.insertBefore(S,this.C.children[l]),this.viewItems.splice(l,0,m),l++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[e]),this.s.deleteAndDispose(this.viewItems[e]),(0,d.$Qc)(this.viewItems.splice(e,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,d.$Qc)(this.viewItems),this.s.clearAndDisposeAll(),i.$SR(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let n=!1,o;if(e===void 0?n=!0:typeof e=="number"?o=e:typeof e=="boolean"&&(n=e),n&&typeof this.u>"u"){const l=this.viewItems.findIndex(f=>f.isEnabled());this.u=l===-1?void 0:l,this.R(void 0,void 0,!0)}else o!==void 0&&(this.u=o),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(e){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const n=this.u;let o;do{if(!e&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=n,!1;this.u=(this.u+1)%this.viewItems.length,o=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===A.$dj.ID));return this.R(),!0}Q(e){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const n=this.u;let o;do{if(this.u=this.u-1,this.u<0){if(!e&&this.b.preventLoopNavigation)return this.u=n,!1;this.u=this.viewItems.length-1}o=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===A.$dj.ID));return this.R(!0),!0}R(e,n,o=!1){typeof this.u>"u"&&this.C.focus({preventScroll:n}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const l=this.u!==void 0?this.viewItems[this.u]:void 0;if(l){let f=!0;g.$kg(l.focus)||(f=!1),this.b.focusOnlyEnabledItems&&g.$kg(l.isEnabled)&&!l.isEnabled()&&(f=!1),l.action.id===A.$dj.ID&&(f=!1),f?(o||this.t!==this.u)&&(l.focus(e),this.t=this.u):(this.C.focus({preventScroll:n}),this.t=void 0),f&&l.showHover?.()}}S(e){if(typeof this.u>"u")return;const n=this.viewItems[this.u];if(n instanceof B.$JU){const o=n._context===null||n._context===void 0?e:n._context;this.run(n._action,o)}}async run(e,n){await this.g.run(e,n)}dispose(){this.m=void 0,this.viewItems=(0,d.$Qc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$PT=P;function c(h){if(!h.length)return h;let e=-1;for(let o=0;o<h.length;o++)if(h[o].id!==A.$dj.ID){e=o;break}if(e===-1)return[];h=h.slice(e);for(let o=h.length-1;o>=0&&h[o].id===A.$dj.ID;o--)h.splice(o,1);let n=!1;for(let o=h.length-1;o>=0;o--){const l=h[o].id===A.$dj.ID;l&&!n?h.splice(o,1):l?l&&(n=!1):n=!0}return h}}),define(me[75],be([1,0,4,24,66,74,68,29,14,71,21,3,91,61,120,109]),function(se,t,i,C,B,Q,A,T,d,g,$,P,c,h,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sV=t.$rV=t.$qV=t.MessageType=void 0;const n=i.$;var o;(function(S){S[S.INFO=1]="INFO",S[S.WARNING=2]="WARNING",S[S.ERROR=3]="ERROR"})(o||(t.MessageType=o={})),t.$qV={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class l extends $.$uT{constructor(m,b,r){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new P.$ee),this.onDidChange=this.P.event,this.Q=this.B(new P.$ee),this.onDidHeightChange=this.Q.event,this.a=b,this.g=r,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$TS(m,n(".monaco-inputbox.idle"));const E=this.g.flexibleHeight?"textarea":"input",k=i.$TS(this.element,n(".ibwrapper"));if(this.b=i.$TS(k,n(E+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$TS(k,n("div.mirror")),this.y.innerText="\xA0",this.N=new g.$ET(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$TS(m,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(W=>this.b.scrollTop=W.scrollTop));const F=this.B(new C.$XT(m.ownerDocument,"selectionchange")),M=P.Event.filter(F.event,()=>m.ownerDocument.getSelection()?.anchorNode===k);this.B(M(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new Q.$PT(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(m){this.n=m,this.b.setAttribute("placeholder",m)}setTooltip(m){this.r=m,this.O?this.O.update(m):this.O=this.B((0,T.$zU)().setupUpdatableHover((0,d.$NT)("mouse"),this.b,m))}setAriaLabel(m){this.s=m,m?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(m){this.b.value!==m&&(this.b.value=m,this.Z())}get step(){return this.b.step}set step(m){this.b.step=m}get height(){return typeof this.J=="number"?this.J:i.$jS(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$uS(this.b)}select(m=null){this.b.select(),m&&(this.b.setSelectionRange(m.start,m.end),m.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const m=this.b.selectionStart;if(m===null)return null;const b=this.b.selectionEnd??m;return{start:m,end:b}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(m){m?this.enable():this.disable()}get width(){return i.$fS(this.b)}set width(m){if(this.g.flexibleHeight&&this.g.flexibleWidth){let b=0;if(this.y){const r=parseFloat(this.y.style.paddingLeft||"")||0,E=parseFloat(this.y.style.paddingRight||"")||0;b=r+E}this.b.style.width=m-b+"px"}else this.b.style.width=m+"px";this.y&&(this.y.style.width=m+"px")}set paddingRight(m){this.b.style.width=`calc(100% - ${m}px)`,this.y&&(this.y.style.paddingRight=m+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const m=this.L,b=this.J,r=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:m,height:b}),this.N.setScrollPosition({scrollTop:r})}showMessage(m,b){if(this.w==="open"&&(0,h.$7n)(this.h,m))return;this.h=m,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(m.type));const r=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$_S(r.border,"transparent")}`,this.h.content&&(this.hasFocus()||b)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let m=null;return this.t&&(m=this.t(this.value),m?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(m)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),m?.type}stylesForType(m){const b=this.g.inputBoxStyles;switch(m){case 1:return{border:b.inputValidationInfoBorder,background:b.inputValidationInfoBackground,foreground:b.inputValidationInfoForeground};case 2:return{border:b.inputValidationWarningBorder,background:b.inputValidationWarningBackground,foreground:b.inputValidationWarningForeground};default:return{border:b.inputValidationErrorBorder,background:b.inputValidationErrorBackground,foreground:b.inputValidationErrorForeground}}}W(m){switch(m){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let m;const b=()=>m.style.width=i.$fS(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:E=>{if(!this.h)return null;m=i.$TS(E,n(".monaco-inputbox-container")),b();const k={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,B.$VT)(this.h.content,k):(0,B.$UT)(this.h.content,k);F.classList.add(this.W(this.h.type));const M=this.stylesForType(this.h.type);return F.style.backgroundColor=M.background??"",F.style.color=M.foreground??"",F.style.border=M.border?`1px solid ${M.border}`:"",i.$TS(m,F),null},onHide:()=>{this.w="closed"},layout:b});let r;this.h.type===3?r=e.localize(0,null,this.h.content):this.h.type===2?r=e.localize(1,null,this.h.content):r=e.localize(2,null,this.h.content),A.$ZT(r),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const m=this.value,r=m.charCodeAt(m.length-1)===10?" ":"";(m+r).replace(/\u000c/g,"")?this.y.textContent=m+r:this.y.innerText="\xA0",this.layout()}bb(){const m=this.g.inputBoxStyles,b=m.inputBackground??"",r=m.inputForeground??"",E=m.inputBorder??"";this.element.style.backgroundColor=b,this.element.style.color=r,this.b.style.backgroundColor="inherit",this.b.style.color=r,this.element.style.border=`1px solid ${i.$_S(E,"transparent")}`}layout(){if(!this.y)return;const m=this.L;this.L=i.$jS(this.y),m!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(m){const b=this.inputElement,r=b.selectionStart,E=b.selectionEnd,k=b.value;r!==null&&E!==null&&(this.value=k.substr(0,r)+m+k.substr(E),b.setSelectionRange(r+1,r+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$rV=l;class f extends l{constructor(m,b,r){const E=e.localize(3,null,"\u21C5"),k=e.localize(4,null,"\u21C5");super(m,b,r),this.eb=this.B(new P.$ee),this.onDidFocus=this.eb.event,this.fb=this.B(new P.$ee),this.onDidBlur=this.fb.event,this.cb=new c.$oV(r.history,100);const F=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.n.endsWith(E)&&!this.n.endsWith(k)&&this.cb.getHistory().length){const M=this.n.endsWith(")")?E:k,W=this.n+M;r.showPlaceholderOnFocus&&!i.$uS(this.b)?this.n=W:this.setPlaceHolder(W)}};this.db=new MutationObserver((M,W)=>{M.forEach(p=>{p.target.textContent||F()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>F()),this.F(this.b,()=>{const M=W=>{if(this.n.endsWith(W)){const p=this.n.slice(0,this.n.length-W.length);return r.showPlaceholderOnFocus?this.n=p:this.setPlaceHolder(p),!0}else return!1};M(k)||M(E)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(m){this.value&&(m||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(m){const b=this.getHistory();this.clearHistory(),m.forEach(r=>{this.cb.add(r)}),b.forEach(r=>{this.cb.add(r)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let m=this.kb();m&&(m=m===this.value?this.kb():m),this.value=m??"",A.$1T(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let m=this.jb();m&&(m=m===this.value?this.jb():m),m&&(this.value=m,A.$1T(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(m){super.setPlaceHolder(m),this.setTooltip(m)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let m=this.cb.current();return m||(m=this.cb.last(),this.cb.next()),m}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$sV=f}),define(me[76],be([1,0,73,21,18,19,3,4,14,29,114]),function(se,t,i,C,B,Q,A,T,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IU=t.$HU=t.$GU=t.$FU=t.$EU=void 0,t.$EU={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class $ extends i.$JU{constructor(n,o,l){super(n,o,l),this.a=this.B(new P({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:l.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:l.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:l.toggleStyles?.inputActiveOptionForeground,hoverDelegate:l.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(n){this.element=n,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$FU=$;class P extends C.$uT{constructor(n){super(),this.a=this.B(new A.$ee),this.onChange=this.a.event,this.b=this.B(new A.$ee),this.onKeyDown=this.b.event,this.c=n,this.s=this.c.isChecked;const o=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,o.push(...Q.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&o.push(...this.c.actionClassName.split(" ")),this.s&&o.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,g.$zU)().setupUpdatableHover(n.hoverDelegate??(0,d.$NT)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...o),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,l=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),l.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,l=>{if(l.keyCode===10||l.keyCode===3){this.checked=!this.s,this.a.fire(!0),l.preventDefault(),l.stopPropagation();return}this.b.fire(l)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(n){this.s=n,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(n){this.g&&this.domNode.classList.remove(...Q.ThemeIcon.asClassNameArray(this.g)),this.g=n,this.g&&this.domNode.classList.add(...Q.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(n){this.t.update(n),this.domNode.setAttribute("aria-label",n)}set visible(n){this.domNode.style.display=n?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$GU=P;class c extends C.$uT{constructor(n,o,l){super(),this.g=n,this.h=o,this.a=this.B(new A.$ee),this.onChange=this.a.event,this.b=this.B(new P({title:this.g,isChecked:this.h,icon:B.$Vj.check,actionClassName:"monaco-checkbox",...t.$EU})),this.domNode=this.b.domNode,this.c=l,this.n(),this.B(this.b.onChange(f=>{this.n(),this.a.fire(f)}))}get checked(){return this.b.checked}set checked(n){this.b.checked=n,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,T.$uS)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$HU=c;class h extends i.$JU{constructor(n,o,l){super(n,o,l),this.a=this.B(new c(this._action.label,!!this._action.checked,l.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(n){if(this.element=n,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const o=this.element.appendChild((0,T.$)("span.checkbox-label",void 0,this._action.label));this.B((0,T.$TR)(o,T.$MS.CLICK,l=>{this.a.checked=!this.a.checked,l.stopPropagation(),l.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$IU=h}),define(me[141],be([1,0,14,76,18,119]),function(se,t,i,C,B,Q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FV=t.$EV=t.$DV=void 0;const A=Q.localize(0,null),T=Q.localize(1,null),d=Q.localize(2,null);class g extends C.$GU{constructor(h){super({icon:B.$Vj.caseSensitive,title:A+h.appendTitle,isChecked:h.isChecked,hoverDelegate:h.hoverDelegate??(0,i.$NT)("element"),inputActiveOptionBorder:h.inputActiveOptionBorder,inputActiveOptionForeground:h.inputActiveOptionForeground,inputActiveOptionBackground:h.inputActiveOptionBackground})}}t.$DV=g;class $ extends C.$GU{constructor(h){super({icon:B.$Vj.wholeWord,title:T+h.appendTitle,isChecked:h.isChecked,hoverDelegate:h.hoverDelegate??(0,i.$NT)("element"),inputActiveOptionBorder:h.inputActiveOptionBorder,inputActiveOptionForeground:h.inputActiveOptionForeground,inputActiveOptionBackground:h.inputActiveOptionBackground})}}t.$EV=$;class P extends C.$GU{constructor(h){super({icon:B.$Vj.regex,title:d+h.appendTitle,isChecked:h.isChecked,hoverDelegate:h.hoverDelegate??(0,i.$NT)("element"),inputActiveOptionBorder:h.inputActiveOptionBorder,inputActiveOptionForeground:h.inputActiveOptionForeground,inputActiveOptionBackground:h.inputActiveOptionBackground})}}t.$FV=P}),define(me[142],be([1,0,4,141,75,21,3,118,2,14,108]),function(se,t,i,C,B,Q,A,T,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GV=void 0;const $=T.localize(0,null);class P extends Q.$uT{static{this.OPTION_CHANGE="optionChange"}constructor(h,e,n){super(),this.n=!0,this.s=!1,this.w=this.B(new d.$Wc),this.N=[],this.O=this.B(new A.$ee),this.onDidOptionChange=this.O.event,this.P=this.B(new A.$ee),this.onKeyDown=this.P.event,this.Q=this.B(new A.$ee),this.onMouseDown=this.Q.event,this.R=this.B(new A.$ee),this.onInput=this.R.event,this.S=this.B(new A.$ee),this.onKeyUp=this.S.event,this.U=this.B(new A.$ee),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new A.$ee),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=n.placeholder||"",this.b=n.validation,this.c=n.label||$,this.h=!!n.showCommonFindToggles;const o=n.appendCaseSensitiveLabel||"",l=n.appendWholeWordsLabel||"",f=n.appendRegexLabel||"",S=n.history||[],m=!!n.flexibleHeight,b=!!n.flexibleWidth,r=n.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new B.$sV(this.domNode,e,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:S,showHistoryHint:n.showHistoryHint,flexibleHeight:m,flexibleWidth:b,flexibleMaxHeight:r,inputBoxStyles:n.inputBoxStyles}));const E=this.B((0,g.$OT)());if(this.h){this.J=this.B(new C.$FV({appendTitle:f,isChecked:!1,hoverDelegate:E,...n.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new C.$EV({appendTitle:l,isChecked:!1,hoverDelegate:E,...n.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new C.$DV({appendTitle:o,isChecked:!1,hoverDelegate:E,...n.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const k=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const M=k.indexOf(this.domNode.ownerDocument.activeElement);if(M>=0){let W=-1;F.equals(17)?W=(M+1)%k.length:F.equals(15)&&(M===0?W=k.length-1:W=M-1),F.equals(9)?(k[M].blur(),this.inputBox.focus()):W>=0&&k[W].focus(),i.$OS.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(n?.additionalToggles),this.y&&this.domNode.appendChild(this.y),h?.appendChild(this.domNode),this.B(i.$TR(this.inputBox.inputElement,"compositionstart",k=>{this.s=!0})),this.B(i.$TR(this.inputBox.inputElement,"compositionend",k=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,k=>this.P.fire(k)),this.C(this.inputBox.inputElement,k=>this.S.fire(k)),this.D(this.inputBox.inputElement,k=>this.R.fire()),this.j(this.inputBox.inputElement,k=>this.Q.fire(k))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(h){this.inputBox.layout(),this.X(h.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const h of this.N)h.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const h of this.N)h.disable()}setFocusInputOnOptionClick(h){this.n=h}setEnabled(h){h?this.enable():this.disable()}setAdditionalToggles(h){for(const e of this.N)e.domNode.remove();this.N=[],this.w.value=new d.$Uc;for(const e of h??[])this.w.value.add(e),this.y.appendChild(e.domNode),this.w.value.add(e.onChange(n=>{this.O.fire(n),!n&&this.n&&this.inputBox.focus()})),this.N.push(e);this.N.length>0&&(this.y.style.display=""),this.X()}X(h=!1){h?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((e,n)=>e+n.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(h){this.inputBox.value!==h&&(this.inputBox.value=h)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(h){this.M&&(this.M.checked=h)}getWholeWords(){return this.L?.checked??!1}setWholeWords(h){this.L&&(this.L.checked=h)}getRegex(){return this.J?.checked??!1}setRegex(h){this.J&&(this.J.checked=h,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(h){this.inputBox.showMessage(h)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$GV=P}),define(me[143],be([1,0,4,24,15,74,142,75,72,49,76,69,30,46,8,11,18,19,39,3,44,2,40,10,122,14,57,115]),function(se,t,i,C,B,Q,A,T,d,g,$,P,c,h,e,n,o,l,f,S,m,b,r,E,k,F,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hW=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$gW=t.$fW=t.$eW=t.RenderIndentGuides=t.$dW=t.$cW=void 0;class W extends d.$8T{set context(s){this.c.context=s}get context(){return this.c.context}constructor(s){super(s.elements.map(D=>D.element)),this.c=s}}function p(N){return N instanceof d.$8T?new W(N):N}class I{constructor(s,D){this.d=s,this.f=D,this.b=b.$Vc.None,this.c=new b.$Uc}getDragURI(s){return this.f.getDragURI(s.element)}getDragLabel(s,D){if(this.f.getDragLabel)return this.f.getDragLabel(s.map(w=>w.element),D)}onDragStart(s,D){this.f.onDragStart?.(p(s),D)}onDragOver(s,D,w,L,j,X=!0){const Z=this.f.onDragOver(p(s),D&&D.element,w,L,j),oe=this.a!==D;if(oe&&(this.b.dispose(),this.a=D),typeof D>"u")return Z;if(oe&&typeof Z!="boolean"&&Z.autoExpand&&(this.b=(0,n.$yh)(()=>{const Oe=this.d(),Se=Oe.getNodeLocation(D);Oe.isCollapsed(Se)&&Oe.setCollapsed(Se,!1),this.a=void 0},500,this.c)),typeof Z=="boolean"||!Z.accept||typeof Z.bubble>"u"||Z.feedback){if(!X){const Oe=typeof Z=="boolean"?Z:Z.accept,Se=typeof Z=="boolean"?void 0:Z.effect;return{accept:Oe,effect:Se,feedback:[w]}}return Z}if(Z.bubble===1){const Oe=this.d(),Se=Oe.getNodeLocation(D),Ce=Oe.getParentNodeLocation(Se),He=Oe.getNode(Ce),Ue=Ce&&Oe.getListIndex(Ce);return this.onDragOver(s,He,Ue,L,j,!1)}const pe=this.d(),fe=pe.getNodeLocation(D),Le=pe.getListIndex(fe),Te=pe.getListRenderCount(fe);return{...Z,feedback:(0,e.$Sb)(Le,Le+Te)}}drop(s,D,w,L,j){this.b.dispose(),this.a=void 0,this.f.drop(p(s),D&&D.element,w,L,j)}onDragEnd(s){this.f.onDragEnd?.(s)}dispose(){this.c.dispose(),this.f.dispose()}}function V(N,s){return s&&{...s,identityProvider:s.identityProvider&&{getId(D){return s.identityProvider.getId(D.element)}},dnd:s.dnd&&new I(N,s.dnd),multipleSelectionController:s.multipleSelectionController&&{isSelectionSingleChangeEvent(D){return s.multipleSelectionController.isSelectionSingleChangeEvent({...D,element:D.element})},isSelectionRangeChangeEvent(D){return s.multipleSelectionController.isSelectionRangeChangeEvent({...D,element:D.element})}},accessibilityProvider:s.accessibilityProvider&&{...s.accessibilityProvider,getSetSize(D){const w=N(),L=w.getNodeLocation(D),j=w.getParentNodeLocation(L);return w.getNode(j).visibleChildrenCount},getPosInSet(D){return D.visibleChildIndex+1},isChecked:s.accessibilityProvider&&s.accessibilityProvider.isChecked?D=>s.accessibilityProvider.isChecked(D.element):void 0,getRole:s.accessibilityProvider&&s.accessibilityProvider.getRole?D=>s.accessibilityProvider.getRole(D.element):()=>"treeitem",getAriaLabel(D){return s.accessibilityProvider.getAriaLabel(D.element)},getWidgetAriaLabel(){return s.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:s.accessibilityProvider&&s.accessibilityProvider.getWidgetRole?()=>s.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:s.accessibilityProvider&&s.accessibilityProvider.getAriaLevel?D=>s.accessibilityProvider.getAriaLevel(D.element):D=>D.depth,getActiveDescendantId:s.accessibilityProvider.getActiveDescendantId&&(D=>s.accessibilityProvider.getActiveDescendantId(D.element))},keyboardNavigationLabelProvider:s.keyboardNavigationLabelProvider&&{...s.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(D){return s.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(D.element)}}}}class R{constructor(s){this.a=s}getHeight(s){return this.a.getHeight(s.element)}getTemplateId(s){return this.a.getTemplateId(s.element)}hasDynamicHeight(s){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(s.element)}setDynamicHeight(s,D){this.a.setDynamicHeight?.(s.element,D)}}t.$cW=R;class x{static lift(s){return s instanceof x?s:new x(s)}static empty(s=0){return new x({focus:[],selection:[],expanded:Object.create(null),scrollTop:s})}constructor(s){if(this.focus=new Set(s.focus),this.selection=new Set(s.selection),s.expanded instanceof Array){this.expanded=Object.create(null);for(const D of s.expanded)this.expanded[D]=1}else this.expanded=s.expanded;this.expanded=s.expanded,this.scrollTop=s.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$dW=x;var O;(function(N){N.None="none",N.OnHover="onHover",N.Always="always"})(O||(t.RenderIndentGuides=O={}));class G{get elements(){return this.b}constructor(s,D=[]){this.b=D,this.a=new b.$Uc,this.onDidChange=S.Event.forEach(s,w=>this.b=w,this.a)}dispose(){this.a.dispose()}}class q{static{this.a=8}constructor(s,D,w,L,j,X={}){this.o=s,this.p=D,this.q=L,this.s=j,this.b=new Map,this.c=new Map,this.d=q.a,this.f=!1,this.g=!1,this.j=new Set,this.k=b.$Vc.None,this.m=new b.$Uc,this.templateId=s.templateId,this.updateOptions(X),S.Event.map(w,Z=>Z.node)(this.u,this,this.m),s.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(s={}){if(typeof s.indent<"u"){const D=(0,r.$Bm)(s.indent,0,40);if(D!==this.d){this.d=D;for(const[w,L]of this.c)this.v(w,L)}}if(typeof s.renderIndentGuides<"u"){const D=s.renderIndentGuides!==O.None;if(D!==this.g){this.g=D;for(const[w,L]of this.c)this.w(w,L);if(this.k.dispose(),D){const w=new b.$Uc;this.q.onDidChange(this.x,this,w),this.k=w,this.x(this.q.elements)}}}typeof s.hideTwistiesOfChildlessElements<"u"&&(this.f=s.hideTwistiesOfChildlessElements)}renderTemplate(s){const D=(0,i.$TS)(s,(0,i.$)(".monaco-tl-row")),w=(0,i.$TS)(D,(0,i.$)(".monaco-tl-indent")),L=(0,i.$TS)(D,(0,i.$)(".monaco-tl-twistie")),j=(0,i.$TS)(D,(0,i.$)(".monaco-tl-contents")),X=this.o.renderTemplate(j);return{container:s,indent:w,twistie:L,indentGuidesDisposable:b.$Vc.None,templateData:X}}renderElement(s,D,w,L){this.c.set(s,w),this.b.set(s.element,s),this.v(s,w),this.o.renderElement(s,D,w.templateData,L)}disposeElement(s,D,w,L){w.indentGuidesDisposable.dispose(),this.o.disposeElement?.(s,D,w.templateData,L),typeof L=="number"&&(this.c.delete(s),this.b.delete(s.element))}disposeTemplate(s){this.o.disposeTemplate(s.templateData)}t(s){const D=this.b.get(s);D&&this.u(D)}u(s){const D=this.c.get(s);D&&(this.x(this.q.elements),this.v(s,D))}v(s,D){const w=q.a+(s.depth-1)*this.d;D.twistie.style.paddingLeft=`${w}px`,D.indent.style.width=`${w+this.d-16}px`,s.collapsible?D.container.setAttribute("aria-expanded",String(!s.collapsed)):D.container.removeAttribute("aria-expanded"),D.twistie.classList.remove(...l.ThemeIcon.asClassNameArray(o.$Vj.treeItemExpanded));let L=!1;this.o.renderTwistie&&(L=this.o.renderTwistie(s.element,D.twistie)),s.collapsible&&(!this.f||s.visibleChildrenCount>0)?(L||D.twistie.classList.add(...l.ThemeIcon.asClassNameArray(o.$Vj.treeItemExpanded)),D.twistie.classList.add("collapsible"),D.twistie.classList.toggle("collapsed",s.collapsed)):D.twistie.classList.remove("collapsible","collapsed"),this.w(s,D)}w(s,D){if((0,i.$SR)(D.indent),D.indentGuidesDisposable.dispose(),!this.g)return;const w=new b.$Uc,L=this.p();for(;;){const j=L.getNodeLocation(s),X=L.getParentNodeLocation(j);if(!X)break;const Z=L.getNode(X),oe=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(Z)&&oe.classList.add("active"),D.indent.childElementCount===0?D.indent.appendChild(oe):D.indent.insertBefore(oe,D.indent.firstElementChild),this.s.add(Z,oe),w.add((0,b.$Tc)(()=>this.s.delete(Z,oe))),s=Z}D.indentGuidesDisposable=w}x(s){if(!this.g)return;const D=new Set,w=this.p();s.forEach(L=>{const j=w.getNodeLocation(L);try{const X=w.getParentNodeLocation(j);L.collapsible&&L.children.length>0&&!L.collapsed?D.add(L):X&&D.add(w.getNode(X))}catch{}}),this.j.forEach(L=>{D.has(L)||this.s.forEach(L,j=>j.classList.remove("active"))}),D.forEach(L=>{this.j.has(L)||this.s.forEach(L,j=>j.classList.add("active"))}),this.j=D}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,b.$Qc)(this.m)}}t.$eW=q;class ae{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(s){this.c=s,this.d=s.toLowerCase()}constructor(s,D,w){this.g=s,this.j=D,this.k=w,this.a=0,this.b=0,this.c="",this.d="",this.f=new b.$Uc,s.onWillRefilter(this.m,this,this.f)}filter(s,D){let w=1;if(this.k){const X=this.k.filter(s,D);if(typeof X=="boolean"?w=X?1:0:(0,P.$_V)(X)?w=(0,P.$aW)(X.visibility):w=X,w===0)return!1}if(this.a++,!this.c)return this.b++,{data:m.FuzzyScore.Default,visibility:w};const L=this.j.getKeyboardNavigationLabel(s),j=Array.isArray(L)?L:[L];for(const X of j){const Z=X&&X.toString();if(typeof Z>"u")return{data:m.FuzzyScore.Default,visibility:w};let oe;if(this.g.findMatchType===Ee.Contiguous){const pe=Z.toLowerCase().indexOf(this.d);if(pe>-1){oe=[Number.MAX_SAFE_INTEGER,0];for(let fe=this.d.length;fe>0;fe--)oe.push(pe+fe-1)}}else oe=(0,m.$Kk)(this.c,this.d,0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return this.b++,j.length===1?{data:oe,visibility:w}:{data:{label:Z,score:oe},visibility:w}}return this.g.findMode===De.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(s):2:{data:m.FuzzyScore.Default,visibility:w}}m(){this.a=0,this.b=0}dispose(){(0,b.$Qc)(this.f)}}class ie extends $.$GU{constructor(s){super({icon:o.$Vj.listFilter,title:(0,k.localize)(0,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,F.$NT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$fW=ie;class ee extends $.$GU{constructor(s){super({icon:o.$Vj.searchFuzzy,title:(0,k.localize)(1,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,F.$NT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$gW=ee;const ce={inputBoxStyles:T.$qV,toggleStyles:$.$EU,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var De;(function(N){N[N.Highlight=0]="Highlight",N[N.Filter=1]="Filter"})(De||(t.TreeFindMode=De={}));var Ee;(function(N){N[N.Fuzzy=0]="Fuzzy",N[N.Contiguous=1]="Contiguous"})(Ee||(t.TreeFindMatchType=Ee={}));class Me extends b.$Vc{set mode(s){this.b.checked=s===De.Filter,this.f.inputBox.setPlaceHolder(s===De.Filter?(0,k.localize)(2,null):(0,k.localize)(3,null))}set matchType(s){this.c.checked=s===Ee.Fuzzy}get value(){return this.f.inputBox.value}set value(s){this.f.inputBox.value=s}constructor(s,D,w,L,j,X){super(),this.t=D,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new S.$ee,this.onDidDisable=this._onDidDisable.event,s.appendChild(this.a.root),this.B((0,b.$Tc)(()=>s.removeChild(this.a.root)));const Z=X?.styles??ce;Z.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=Z.listFilterWidgetBackground),Z.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${Z.listFilterWidgetShadow}`);const oe=this.B((0,F.$OT)());this.b=this.B(new ie({...Z.toggleStyles,isChecked:L===De.Filter,hoverDelegate:oe})),this.c=this.B(new ee({...Z.toggleStyles,isChecked:j===Ee.Fuzzy,hoverDelegate:oe})),this.onDidChangeMode=S.Event.map(this.b.onChange,()=>this.b.checked?De.Filter:De.Highlight,this.q),this.onDidChangeMatchType=S.Event.map(this.c.onChange,()=>this.c.checked?Ee.Fuzzy:Ee.Contiguous,this.q),this.f=this.B(new A.$GV(this.a.findInput,w,{label:(0,k.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:Z.inputBoxStyles,toggleStyles:Z.toggleStyles,history:X?.history})),this.g=this.B(new Q.$PT(this.a.actionbar)),this.mode=L;const pe=this.B(new C.$XT(this.f.inputBox.inputElement,"keydown")),fe=S.Event.chain(pe.event,Se=>Se.map(Ce=>new B.$QR(Ce)));this.B(fe(Se=>{if(Se.equals(3)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Se.equals(18)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Se.equals(16)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const Le=this.B(new h.$bj("close",(0,k.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(Le,{icon:!0,label:!1});const Te=this.B(new C.$XT(this.a.grab,"mousedown"));this.B(Te.event(Se=>{const Ce=new b.$Uc,He=Ce.add(new C.$XT((0,i.getWindow)(Se),"mousemove")),Ue=Ce.add(new C.$XT((0,i.getWindow)(Se),"mouseup")),Xe=this.m,_e=Se.pageX,Y=this.s,ne=Se.pageY;this.a.grab.classList.add("grabbing");const $e=this.a.root.style.transition;this.a.root.style.transition="unset";const ve=Re=>{const ze=Re.pageX-_e;this.m=Xe-ze;const We=Re.pageY-ne;this.s=Y+We,this.layout()};Ce.add(He.event(ve)),Ce.add(Ue.event(Re=>{ve(Re),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=$e,Ce.dispose()}))}));const Oe=S.Event.chain(this.B(new C.$XT(this.a.grab,"keydown")).event,Se=>Se.map(Ce=>new B.$QR(Ce)));this.B(Oe(Se=>{let Ce,He;if(Se.keyCode===15?Ce=Number.POSITIVE_INFINITY:Se.keyCode===17?Ce=0:Se.keyCode===10&&(Ce=this.m===0?Number.POSITIVE_INFINITY:0),Se.keyCode===16?He=0:Se.keyCode===18&&(He=Number.POSITIVE_INFINITY),Ce!==void 0&&(Se.preventDefault(),Se.stopPropagation(),this.m=Ce,this.layout()),He!==void 0){Se.preventDefault(),Se.stopPropagation(),this.s=He;const Ue=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ue},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(s=this.j){this.j=s,this.m=(0,r.$Bm)(this.m,0,Math.max(0,s-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,r.$Bm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(s){this.f.showMessage(s)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,n.$xh)(300),super.dispose()}}class le{get pattern(){return this.b}get mode(){return this.d}set mode(s){s!==this.d&&(this.d=s,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(s))}get matchType(){return this.f}set matchType(s){s!==this.f&&(this.f=s,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(s))}constructor(s,D,w,L,j,X={}){this.t=s,this.u=w,this.v=L,this.w=j,this.x=X,this.b="",this.c="",this.j=0,this.k=new S.$ee,this.onDidChangeMode=this.k.event,this.m=new S.$ee,this.onDidChangeMatchType=this.m.event,this.o=new S.$ee,this.onDidChangePattern=this.o.event,this.p=new S.$ee,this.onDidChangeOpenState=this.p.event,this.q=new b.$Uc,this.s=new b.$Uc,this.d=s.options.defaultFindMode??De.Highlight,this.f=s.options.defaultFindMatchType??Ee.Fuzzy,D.onDidSplice(this.z,this,this.s)}updateOptions(s={}){s.defaultFindMode!==void 0&&(this.mode=s.defaultFindMode),s.defaultFindMatchType!==void 0&&(this.matchType=s.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Me(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(s=>this.mode=s,void 0,this.q),this.g.onDidChangeMatchType(s=>this.matchType=s,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(s){this.b=s,this.o.fire(s),this.v.pattern=s,this.t.refilter(),s&&this.t.focusNext(0,!0,void 0,w=>!m.FuzzyScore.isDefault(w.filterData));const D=this.t.getFocus();if(D.length>0){const w=D[0];this.t.getRelativeTop(w)===null&&this.t.reveal(w,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const s=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&s?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,k.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(s){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!m.FuzzyScore.isDefault(s.filterData)}layout(s){this.j=s,this.g?.layout(s)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function _(N,s){return N.position===s.position&&ue(N,s)}function ue(N,s){return N.node.element===s.node.element&&N.startIndex===s.startIndex&&N.height===s.height&&N.endIndex===s.endIndex}class re{constructor(s=[]){this.stickyNodes=s}get count(){return this.stickyNodes.length}equal(s){return(0,e.$ub)(this.stickyNodes,s.stickyNodes,_)}lastNodePartiallyVisible(){if(this.count===0)return!1;const s=this.stickyNodes[this.count-1];if(this.count===1)return s.position!==0;const D=this.stickyNodes[this.count-2];return D.position+D.height!==s.position}animationStateChanged(s){if(!(0,e.$ub)(this.stickyNodes,s.stickyNodes,ue)||this.count===0)return!1;const D=this.stickyNodes[this.count-1],w=s.stickyNodes[s.count-1];return D.position!==w.position}}class ye{constrainStickyScrollNodes(s,D,w){for(let L=0;L<s.length;L++){const j=s[L];if(j.position+j.height>w||L>=D)return s.slice(0,L)}return s}}class H extends b.$Vc{constructor(s,D,w,L,j,X={}){super(),this.g=s,this.j=D,this.m=w,this.s=j,this.c=.4;const Z=this.validateStickySettings(X);this.b=Z.stickyScrollMaxItemCount,this.a=X.stickyScrollDelegate??new ye,this.f=this.B(new J(w.getScrollableElement(),w,s,L,j,X.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(w.onDidScroll(()=>this.u())),this.B(w.onDidChangeContentHeight(()=>this.u())),this.B(s.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(s){return this.f.getNode(s)}t(s){let D;if(s===0?D=this.m.firstVisibleIndex:D=this.m.indexAt(s+this.m.scrollTop),!(D<0||D>=this.m.length))return this.m.element(D)}u(){const s=this.t(0);if(!s||this.g.scrollTop===0){this.f.setState(void 0);return}const D=this.w(s);this.f.setState(D)}w(s){const D=[];let w=s,L=0,j=this.z(w,void 0,L);for(;j&&(D.push(j),L+=j.height,!(D.length<=this.b&&(w=this.y(j),!w)));)j=this.z(w,j.node,L);const X=this.H(D);return X.length?new re(X):void 0}y(s){return this.t(s.position+s.height)}z(s,D,w){const L=this.F(s,D);if(L&&!(L===s&&(!this.J(s)||this.C(s,w))))return this.D(L,w)}C(s,D){const w=this.L(s),L=this.m.getElementTop(w),j=D;return this.m.scrollTop===L-j}D(s,D){const w=this.s.getHeight(s),{startIndex:L,endIndex:j}=this.M(s),X=this.G(j,D,w);return{node:s,position:X,height:w,startIndex:L,endIndex:j}}F(s,D=void 0){let w=s,L=this.I(w);for(;L;){if(L===D)return w;w=L,L=this.I(w)}if(D===void 0)return w}G(s,D,w){let L=this.m.getRelativeTop(s);if(L===null&&this.m.firstVisibleIndex===s&&s+1<this.m.length){const pe=this.s.getHeight(this.m.element(s)),fe=this.m.getRelativeTop(s+1);L=fe?fe-pe/this.m.renderHeight:null}if(L===null)return D;const j=this.m.element(s),X=this.s.getHeight(j),oe=L*this.m.renderHeight+X;return D+w>oe&&D<=oe?oe-w:D}H(s){if(s.length===0)return[];const D=this.m.renderHeight*this.c,w=s[s.length-1];if(s.length<=this.b&&w.position+w.height<=D)return s;const L=this.a.constrainStickyScrollNodes(s,this.b,D);if(!L.length)return[];const j=L[L.length-1];if(L.length>this.b||j.position+j.height>D)throw new Error("stickyScrollDelegate violates constraints");return L}I(s){const D=this.j.getNodeLocation(s),w=this.j.getParentNodeLocation(D);return w?this.j.getNode(w):void 0}J(s){const D=this.j.getNodeLocation(s);return this.j.getListRenderCount(D)>1}L(s){const D=this.j.getNodeLocation(s);return this.j.getListIndex(D)}M(s){const D=this.j.getNodeLocation(s),w=this.j.getListIndex(D);if(w<0)throw new Error("Node not found in tree");const L=this.j.getListRenderCount(D),j=w+L-1;return{startIndex:w,endIndex:j}}nodePositionTopBelowWidget(s){const D=[];let w=this.I(s);for(;w;)D.push(w),w=this.I(w);let L=0;for(let j=0;j<D.length&&j<this.b;j++)L+=this.s.getHeight(D[j]);return L}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(s={}){if(!s.stickyScrollMaxItemCount)return;const D=this.validateStickySettings(s);this.b!==D.stickyScrollMaxItemCount&&(this.b=D.stickyScrollMaxItemCount,this.u())}validateStickySettings(s){let D=7;return typeof s.stickyScrollMaxItemCount=="number"&&(D=Math.max(s.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:D}}}class J{constructor(s,D,w,L,j,X){this.g=D,this.j=w,this.k=L,this.m=j,this.o=X,this.c=[],this.d=new b.$Uc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),s.appendChild(this.a);const Z=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(Z),this.f=new ge(this.a,D),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const s=this.b.stickyNodes[this.b.count-1];return s.position+s.height}get count(){return this.b?.count??0}getNode(s){return this.b?.stickyNodes.find(D=>D.node===s)}setState(s){const D=!!this.b&&this.b.count>0,w=!!s&&s.count>0;if(!D&&!w||D&&w&&this.b.equal(s))return;if(D!==w&&this.s(w),!w){this.b=void 0,this.c=[],this.d.clear();return}const L=s.stickyNodes[s.count-1];if(this.b&&s.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${L.position}px`;else{this.d.clear();const j=Array(s.count);for(let X=s.count-1;X>=0;X--){const Z=s.stickyNodes[X],{element:oe,disposable:pe}=this.p(Z,X,s.count);j[X]=oe,this.a.appendChild(oe),this.d.add(pe)}this.f.updateElements(j,s),this.c=j}this.b=s,this.a.style.height=`${L.position+L.height}px`}p(s,D,w){const L=s.startIndex,j=document.createElement("div");j.style.top=`${s.position}px`,this.j.options.setRowHeight!==!1&&(j.style.height=`${s.height}px`),this.j.options.setRowLineHeight!==!1&&(j.style.lineHeight=`${s.height}px`),j.classList.add("monaco-tree-sticky-row"),j.classList.add("monaco-list-row"),j.setAttribute("data-index",`${L}`),j.setAttribute("data-parity",L%2===0?"even":"odd"),j.setAttribute("id",this.g.getElementID(L));const X=this.q(j,s.node.element,D,w),Z=this.m.getTemplateId(s.node),oe=this.k.find(Te=>Te.templateId===Z);if(!oe)throw new Error(`No renderer found for template id ${Z}`);let pe=s.node;pe===this.j.getNode(this.j.getNodeLocation(s.node))&&(pe=new Proxy(s.node,{}));const fe=oe.renderTemplate(j);oe.renderElement(pe,s.startIndex,fe,s.height);const Le=(0,b.$Tc)(()=>{X.dispose(),oe.disposeElement(pe,s.startIndex,fe,s.height),oe.disposeTemplate(fe),j.remove()});return{element:j,disposable:Le}}q(s,D,w,L){if(!this.o)return b.$Vc.None;this.o.getSetSize&&s.setAttribute("aria-setsize",String(this.o.getSetSize(D,w,L))),this.o.getPosInSet&&s.setAttribute("aria-posinset",String(this.o.getPosInSet(D,w))),this.o.getRole&&s.setAttribute("role",this.o.getRole(D)??"treeitem");const j=this.o.getAriaLabel(D),X=j&&typeof j!="string"?j:(0,M.constObservable)(j),Z=(0,M.autorun)(pe=>{const fe=pe.readObservable(X);fe?s.setAttribute("aria-label",fe):s.removeAttribute("aria-label")});typeof j=="string"||j&&s.setAttribute("aria-label",j.get());const oe=this.o.getAriaLevel&&this.o.getAriaLevel(D);return typeof oe=="number"&&s.setAttribute("aria-level",`${oe}`),s.setAttribute("aria-selected",String(!1)),Z}s(s){this.a.classList.toggle("empty",!s),s||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class ge extends b.$Vc{get m(){return this.j}set m(s){s!==this.j&&(this.f.fire(s),this.j=s)}constructor(s,D){super(),this.s=s,this.t=D,this.a=-1,this.b=[],this.f=new S.$ee,this.onDidChangeHasFocus=this.f.event,this.g=new S.$ee,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(w=>this.w(w))),this.B(this.t.onMouseDown(w=>this.y(w))),this.B(this.t.onContextMenu(w=>this.u(w)))}u(s){const D=s.browserEvent.target;if(!(0,g.$iU)(D)&&!(0,g.$hU)(D)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$JS)(s.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const X=this.c.stickyNodes.findIndex(Z=>Z.node.element===s.element?.element);if(X===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(X);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const L=this.c.stickyNodes[this.a].node.element,j=this.b[this.a];this.g.fire({element:L,anchor:j,browserEvent:s.browserEvent,isStickyScroll:!0})}w(s){if(this.m&&this.c){if(s.key==="ArrowUp")this.z(Math.max(0,this.a-1)),s.preventDefault(),s.stopPropagation();else if(s.key==="ArrowDown"||s.key==="ArrowRight"){if(this.a>=this.c.count-1){const D=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([D]),this.C(D,this.c)}else this.z(this.a+1);s.preventDefault(),s.stopPropagation()}}}y(s){const D=s.browserEvent.target;!(0,g.$iU)(D)&&!(0,g.$hU)(D)||(s.browserEvent.preventDefault(),s.browserEvent.stopPropagation())}updateElements(s,D){if(D&&D.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(D&&D.count!==s.length)throw new Error("Sticky scroll focus received illigel state");const w=this.a;if(this.D(),this.b=s,this.c=D,D){const L=(0,r.$Bm)(w,0,D.count-1);this.F(L)}else this.m&&this.t.domFocus();this.s.tabIndex=D?0:-1}z(s){const D=this.c;if(!D)throw new Error("Cannot set focus when state is undefined");if(this.F(s),!(s<D.count-1)&&D.lastNodePartiallyVisible()){const w=D.stickyNodes[s];this.C(w.endIndex+1,D)}}C(s,D){const w=D.stickyNodes[D.count-1],L=D.count>1?D.stickyNodes[D.count-2]:void 0,j=this.t.getElementTop(s),X=L?L.position+L.height+w.height:w.height;this.t.scrollTop=j-X}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(s){if(0>s)throw new Error("addFocus() can not remove focus");if(!this.c&&s>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&s>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const D=this.a;D>=0&&this.G(this.b[D],!1),s>=0&&this.G(this.b[s],!0),this.a=s}G(s,D){this.I(s,D&&this.m),this.J(s,D)}H(s){this.a!==-1&&this.I(this.b[this.a],s)}I(s,D){s.classList.toggle("focused",D)}J(s,D){s.classList.toggle("passive-focused",D)}L(s){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",s)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function we(N){let s=c.TreeMouseEventTarget.Unknown;return(0,i.$pS)(N.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?s=c.TreeMouseEventTarget.Twistie:(0,i.$pS)(N.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?s=c.TreeMouseEventTarget.Element:(0,i.$pS)(N.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(s=c.TreeMouseEventTarget.Filter),{browserEvent:N.browserEvent,element:N.element?N.element.element:null,target:s}}function ke(N){const s=(0,g.$iU)(N.browserEvent.target);return{element:N.element?N.element.element:null,browserEvent:N.browserEvent,anchor:N.anchor,isStickyScroll:s}}function Fe(N,s){s(N),N.children.forEach(D=>Fe(D,s))}class Ie{get f(){return this.d||(this.d=this.m()),this.d}constructor(s,D){this.g=s,this.j=D,this.a=[],this.c=new S.$ee,this.onDidChange=this.c.event}set(s,D){!D?.__forceEvent&&(0,e.$ub)(this.a,s)||this.k(s,!1,D)}k(s,D,w){if(this.a=[...s],this.b=void 0,this.d=void 0,!D){const L=this;this.c.fire({get elements(){return L.get()},browserEvent:w})}}get(){return this.b||(this.b=this.a.map(s=>s.element)),[...this.b]}getNodes(){return this.a}has(s){return this.f.has(s)}onDidModelSplice({insertedNodes:s,deletedNodes:D}){if(!this.j){const oe=this.m(),pe=fe=>oe.delete(fe);D.forEach(fe=>Fe(fe,pe)),this.set([...oe.values()]);return}const w=new Set,L=oe=>w.add(this.j.getId(oe.element).toString());D.forEach(oe=>Fe(oe,L));const j=new Map,X=oe=>j.set(this.j.getId(oe.element).toString(),oe);s.forEach(oe=>Fe(oe,X));const Z=[];for(const oe of this.a){const pe=this.j.getId(oe.element).toString();if(!w.has(pe))Z.push(oe);else{const Le=j.get(pe);Le&&Le.visible&&Z.push(Le)}}if(this.a.length>0&&Z.length===0){const oe=this.g();oe&&Z.push(oe)}this.k(Z,!0)}m(){const s=new Set;for(const D of this.a)s.add(D);return s}}class z extends g.$nU{constructor(s,D,w){super(s),this.x=D,this.y=w}u(s){if((0,g.$jU)(s.browserEvent.target)||(0,g.$cU)(s.browserEvent.target)||(0,g.$dU)(s.browserEvent.target)||s.browserEvent.isHandledByList)return;const D=s.element;if(!D)return super.u(s);if(this.p(s)||this.o(s))return super.u(s);const w=s.browserEvent.target,L=w.classList.contains("monaco-tl-twistie")||w.classList.contains("monaco-icon-label")&&w.classList.contains("folder-icon")&&s.browserEvent.offsetX<16,j=(0,g.$hU)(s.browserEvent.target);let X=!1;if(j?X=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?X=this.x.expandOnlyOnTwistieClick(D.element):X=!!this.x.expandOnlyOnTwistieClick,j)this.A(s,D);else{if(X&&!L&&s.browserEvent.detail!==2)return super.u(s);if(!this.x.expandOnDoubleClick&&s.browserEvent.detail===2)return super.u(s)}if(D.collapsible&&(!j||L)){const Z=this.x.getNodeLocation(D),oe=s.browserEvent.altKey;if(this.x.setFocus([Z]),this.x.toggleCollapsed(Z,oe),L){s.browserEvent.isHandledByList=!0;return}}j||super.u(s)}A(s,D){if((0,g.$eU)(s.browserEvent.target)||(0,g.$fU)(s.browserEvent.target))return;const w=this.y();if(!w)throw new Error("Sticky scroll controller not found");const L=this.k.indexOf(D),j=this.k.getElementTop(L),X=w.nodePositionTopBelowWidget(D);this.x.scrollTop=j-X,this.k.domFocus(),this.k.setFocus([L]),this.k.setSelection([L])}v(s){s.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||s.browserEvent.isHandledByList||super.v(s)}s(s){const D=s.browserEvent.target;if(!(0,g.$iU)(D)&&!(0,g.$hU)(D)){super.s(s);return}}t(s){const D=s.browserEvent.target;if(!(0,g.$iU)(D)&&!(0,g.$hU)(D)){super.t(s);return}}}class u extends g.$qU{constructor(s,D,w,L,j,X,Z,oe){super(s,D,w,L,oe),this.p=j,this.s=X,this.K=Z}D(s){return new z(this,s.tree,s.stickyScrollProvider)}splice(s,D,w=[]){if(super.splice(s,D,w),w.length===0)return;const L=[],j=[];let X;w.forEach((Z,oe)=>{this.p.has(Z)&&L.push(s+oe),this.s.has(Z)&&j.push(s+oe),this.K.has(Z)&&(X=s+oe)}),L.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...L])),j.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...j])),typeof X=="number"&&super.setAnchor(X)}setFocus(s,D,w=!1){super.setFocus(s,D),w||this.p.set(s.map(L=>this.element(L)),D)}setSelection(s,D,w=!1){super.setSelection(s,D),w||this.s.set(s.map(L=>this.element(L)),D)}setAnchor(s,D=!1){super.setAnchor(s),D||(typeof s>"u"?this.K.set([]):this.K.set([this.element(s)]))}}var y;(function(N){N[N.Tree=0]="Tree",N[N.StickyScroll=1]="StickyScroll"})(y||(t.AbstractTreePart=y={}));class a{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return S.Event.map(this.j.onMouseClick,we)}get onMouseDblClick(){return S.Event.filter(S.Event.map(this.j.onMouseDblClick,we),s=>s.target!==c.TreeMouseEventTarget.Filter)}get onMouseOver(){return S.Event.map(this.j.onMouseOver,we)}get onMouseOut(){return S.Event.map(this.j.onMouseOut,we)}get onContextMenu(){return S.Event.any(S.Event.filter(S.Event.map(this.j.onContextMenu,ke),s=>!s.isStickyScroll),this.B?.onContextMenu??S.Event.None)}get onTap(){return S.Event.map(this.j.onTap,we)}get onPointer(){return S.Event.map(this.j.onPointer,we)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return S.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??De.Highlight}set findMode(s){this.z&&(this.z.mode=s)}get findMatchType(){return this.z?.matchType??Ee.Fuzzy}set findMatchType(s){this.z&&(this.z.matchType=s)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:S.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(s,D,w,L,j={}){this.G=s,this.H=j,this.y=new S.$me,this.onDidChangeFindOpenState=S.Event.None,this.onDidChangeStickyScrollFocused=S.Event.None,this.D=new b.$Uc,this.E=new S.$ee,this.onWillRefilter=this.E.event,this.F=new S.$ee,this.onDidUpdateOptions=this.F.event,this.p=new R(w);const X=new S.$ne,Z=new S.$ne,oe=this.D.add(new G(Z.event)),pe=new f.$Ic;this.k=L.map(Se=>new q(Se,()=>this.o,X.event,oe,pe,j));for(const Se of this.k)this.D.add(Se);let fe;j.keyboardNavigationLabelProvider&&(fe=new ae(this,j.keyboardNavigationLabelProvider,j.filter),j={...j,filter:fe},this.D.add(fe)),this.q=new Ie(()=>this.j.getFocusedElements()[0],j.identityProvider),this.w=new Ie(()=>this.j.getSelectedElements()[0],j.identityProvider),this.x=new Ie(()=>this.j.getAnchorElement(),j.identityProvider),this.j=new u(s,D,this.p,this.k,this.q,this.w,this.x,{...V(()=>this.o,j),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(s,this.j,j),X.input=this.o.onDidChangeCollapseState;const Le=S.Event.forEach(this.o.onDidSplice,Se=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Se),this.w.onDidModelSplice(Se)})},this.D);Le(()=>null,null,this.D);const Te=this.D.add(new S.$ee),Oe=this.D.add(new n.$th(0));if(this.D.add(S.Event.any(Le,this.q.onDidChange,this.w.onDidChange)(()=>{Oe.trigger(()=>{const Se=new Set;for(const Ce of this.q.getNodes())Se.add(Ce);for(const Ce of this.w.getNodes())Se.add(Ce);Te.fire([...Se.values()])})})),Z.input=Te.event,j.keyboardSupport!==!1){const Se=S.Event.chain(this.j.onKeyDown,Ce=>Ce.filter(He=>!(0,g.$cU)(He.target)).map(He=>new B.$QR(He)));S.Event.chain(Se,Ce=>Ce.filter(He=>He.keyCode===15))(this.J,this,this.D),S.Event.chain(Se,Ce=>Ce.filter(He=>He.keyCode===17))(this.K,this,this.D),S.Event.chain(Se,Ce=>Ce.filter(He=>He.keyCode===10))(this.L,this,this.D)}if((j.findWidgetEnabled??!0)&&j.keyboardNavigationLabelProvider&&j.contextViewProvider){const Se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new le(this,this.o,this.j,fe,j.contextViewProvider,Se),this.A=Ce=>this.z.shouldAllowFocus(Ce),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=S.Event.None,this.onDidChangeFindMatchType=S.Event.None;j.enableStickyScroll&&(this.B=new H(this,this.o,this.j,this.k,this.p,j),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$BS)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===O.Always)}updateOptions(s={}){this.H={...this.H,...s};for(const D of this.k)D.updateOptions(s);this.j.updateOptions(this.H),this.z?.updateOptions(s),this.I(s),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===O.Always)}get options(){return this.H}I(s){!this.B&&this.H.enableStickyScroll?(this.B=new H(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=S.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(s)}updateWidth(s){const D=this.o.getListIndex(s);D!==-1&&this.j.updateWidth(D)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(s){this.j.scrollTop=s}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(s){this.j.scrollLeft=s}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let s=this.j.firstVisibleIndex;return this.B&&(s+=this.B.count),s<0||s>=this.j.length?void 0:this.j.element(s).element}get lastVisibleElement(){const s=this.j.lastVisibleIndex;return this.j.element(s).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(s){this.j.ariaLabel=s}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$uS)(this.getHTMLElement())}layout(s,D){this.j.layout(s,D),(0,E.$ag)(D)&&this.z?.layout(D)}style(s){const D=`.${this.j.domId}`,w=[];s.treeIndentGuidesStroke&&(w.push(`.monaco-list${D}:hover .monaco-tl-indent > .indent-guide, .monaco-list${D}.always .monaco-tl-indent > .indent-guide  { border-color: ${s.treeInactiveIndentGuidesStroke}; }`),w.push(`.monaco-list${D} .monaco-tl-indent > .indent-guide.active { border-color: ${s.treeIndentGuidesStroke}; }`));const L=s.treeStickyScrollBackground??s.listBackground;L&&(w.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${L}; }`),w.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${L}; }`)),s.treeStickyScrollBorder&&w.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${s.treeStickyScrollBorder}; }`),s.treeStickyScrollShadow&&w.push(`.monaco-list${D} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${s.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),s.listFocusForeground&&(w.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${s.listFocusForeground}; }`),w.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const j=(0,i.$_S)(s.listFocusAndSelectionOutline,(0,i.$_S)(s.listSelectionOutline,s.listFocusOutline??""));j&&(w.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${j}; outline-offset: -1px;}`),w.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),s.listFocusOutline&&(w.push(`.monaco-list${D}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),w.push(`.monaco-list${D}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),w.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),w.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),w.push(`.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=w.join(`
`),this.j.style(s)}getParentElement(s){const D=this.o.getParentNodeLocation(s);return this.o.getNode(D).element}getFirstElementChild(s){return this.o.getFirstElementChild(s)}getNode(s){return this.o.getNode(s)}getNodeLocation(s){return this.o.getNodeLocation(s)}collapse(s,D=!1){return this.o.setCollapsed(s,!0,D)}expand(s,D=!1){return this.o.setCollapsed(s,!1,D)}toggleCollapsed(s,D=!1){return this.o.setCollapsed(s,void 0,D)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(s){return this.o.isCollapsible(s)}setCollapsible(s,D){return this.o.setCollapsible(s,D)}isCollapsed(s){return this.o.isCollapsed(s)}expandTo(s){this.o.expandTo(s)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(s){if(typeof s>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const D=this.o.getNode(s);this.x.set([D]);const w=this.o.getListIndex(s);w>-1&&this.j.setAnchor(w,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(s,D){this.y.bufferEvents(()=>{const w=s.map(j=>this.o.getNode(j));this.w.set(w,D);const L=s.map(j=>this.o.getListIndex(j)).filter(j=>j>-1);this.j.setSelection(L,D,!0)})}getSelection(){return this.w.get()}setFocus(s,D){this.y.bufferEvents(()=>{const w=s.map(j=>this.o.getNode(j));this.q.set(w,D);const L=s.map(j=>this.o.getListIndex(j)).filter(j=>j>-1);this.j.setFocus(L,D,!0)})}focusNext(s=1,D=!1,w,L=(0,i.$JS)(w)&&w.altKey?void 0:this.A){this.j.focusNext(s,D,w,L)}focusPrevious(s=1,D=!1,w,L=(0,i.$JS)(w)&&w.altKey?void 0:this.A){this.j.focusPrevious(s,D,w,L)}focusNextPage(s,D=(0,i.$JS)(s)&&s.altKey?void 0:this.A){return this.j.focusNextPage(s,D)}focusPreviousPage(s,D=(0,i.$JS)(s)&&s.altKey?void 0:this.A){return this.j.focusPreviousPage(s,D,()=>this.B?.height??0)}focusLast(s,D=(0,i.$JS)(s)&&s.altKey?void 0:this.A){this.j.focusLast(s,D)}focusFirst(s,D=(0,i.$JS)(s)&&s.altKey?void 0:this.A){this.j.focusFirst(s,D)}getFocus(){return this.q.get()}getStickyScrollFocus(){const s=this.B?.getFocus();return s!==void 0?[s]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(s,D){this.o.expandTo(s);const w=this.o.getListIndex(s);if(w!==-1)if(!this.B)this.j.reveal(w,D);else{const L=this.B.nodePositionTopBelowWidget(this.getNode(s));this.j.reveal(w,D,L)}}getRelativeTop(s){const D=this.o.getListIndex(s);if(D===-1)return null;const w=this.B?.getNode(this.getNode(s));return this.j.getRelativeTop(D,w?.position??this.B?.height)}getViewState(s=this.options.identityProvider){if(!s)throw new c.$0V(this.G,"Can't get tree view state without an identity provider");const D=X=>s.getId(X).toString(),w=x.empty(this.scrollTop);for(const X of this.getFocus())w.focus.add(D(X));for(const X of this.getSelection())w.selection.add(D(X));const L=this.o.getNode(),j=[L];for(;j.length>0;){const X=j.shift();X!==L&&X.collapsible&&(w.expanded[D(X.element)]=X.collapsed?0:1),j.push(...X.children)}return w}J(s){s.preventDefault(),s.stopPropagation();const D=this.j.getFocusedElements();if(D.length===0)return;const w=D[0],L=this.o.getNodeLocation(w);if(!this.o.setCollapsed(L,!0)){const X=this.o.getParentNodeLocation(L);if(!X)return;const Z=this.o.getListIndex(X);this.j.reveal(Z),this.j.setFocus([Z])}}K(s){s.preventDefault(),s.stopPropagation();const D=this.j.getFocusedElements();if(D.length===0)return;const w=D[0],L=this.o.getNodeLocation(w);if(!this.o.setCollapsed(L,!1)){if(!w.children.some(oe=>oe.visible))return;const[X]=this.j.getFocus(),Z=X+1;this.j.reveal(Z),this.j.setFocus([Z])}}L(s){s.preventDefault(),s.stopPropagation();const D=this.j.getFocusedElements();if(D.length===0)return;const w=D[0],L=this.o.getNodeLocation(w),j=s.browserEvent.altKey;this.o.setCollapsed(L,void 0,j)}navigate(s){return new v(this.j,this.o,s)}dispose(){(0,b.$Qc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$hW=a;class v{constructor(s,D,w){this.b=s,this.c=D,w?this.a=this.c.getListIndex(w):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[144],be([1,0,143,134,30,32]),function(se,t,i,C,B,Q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sW=void 0;class A extends i.$hW{constructor(d,g,$,P,c,h={}){super(d,g,$,P,h),this.f=d,this.g=c,this.d=new Map,this.c=h.identityProvider}getInput(){return this.b}setInput(d,g){if(g&&!this.c)throw new B.$0V(this.f,"Can't restore tree view state without an identity provider");if(this.b=d,!d){this.d.clear(),this.o.setChildren(null,Q.Iterable.empty());return}if(!g){this.m(d);return}const $=[],P=[],c=e=>{const n=this.c.getId(e).toString();return!g.expanded[n]},h=e=>{const n=this.c.getId(e.element).toString();g.focus.has(n)&&$.push(e.element),g.selection.has(n)&&P.push(e.element)};this.m(d,c,h),this.setFocus($),this.setSelection(P),g&&typeof g.scrollTop=="number"&&(this.scrollTop=g.scrollTop)}updateChildren(d=this.b){if(typeof this.b>"u")throw new B.$0V(this.f,"Tree input not set");let g;this.c&&(g=$=>{const P=this.c.getId($).toString(),c=this.d.get(P);if(c)return c.collapsed}),this.m(d,g)}resort(d=this.b,g=!0){this.o.resort(d===this.b?null:d,g)}refresh(d){if(d===void 0){this.j.rerender();return}this.o.rerender(d)}m(d,g,$){let P;if(this.c){const c=new Set,h=$;$=e=>{const n=this.c.getId(e.element).toString();c.add(n),this.d.set(n,e),h?.(e)},P=e=>{const n=this.c.getId(e.element).toString();c.has(n)||this.d.delete(n)}}this.o.setChildren(d===this.b?null:d,this.s(d,g).elements,{onDidCreateNode:$,onDidDeleteNode:P})}s(d,g){const $=[...this.g.getChildren(d)];return{elements:Q.Iterable.map($,c=>{const{elements:h,size:e}=this.s(c,g),n=this.g.hasChildren?this.g.hasChildren(c):void 0,o=e===0?void 0:g&&g(c);return{element:c,children:h,collapsible:n,collapsed:o}}),size:$.length}}M(d,g,$){return new C.$iW(d,g,$)}}t.$sW=A}),define(me[77],be([1,0,8,11,43,34,31,6,3,2,64,9,10]),function(se,t,i,C,B,Q,A,T,d,g,$,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fi=t.ProxyChannel=t.$ei=t.$bi=t.$ai=t.$_h=t.RequestInitiator=t.$$h=t.$8h=t.$7h=void 0,t.$9h=W,t.$0h=p,t.$ci=G,t.$di=q;var h;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(h||(h={}));function e(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var n;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(n||(n={}));function o(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(l||(l={}));function f(le){let _=0;for(let ue=0;;ue+=7){const re=le.read(1);if(_|=(re.buffer[0]&127)<<ue,!(re.buffer[0]&128))return _}}const S=k(0);function m(le,_){if(_===0){le.write(S);return}let ue=0;for(let ye=_;ye!==0;ye=ye>>>7)ue++;const re=B.$Ge.alloc(ue);for(let ye=0;_!==0;ye++)re.buffer[ye]=_&127,_=_>>>7,_>0&&(re.buffer[ye]|=128);le.write(re)}class b{constructor(_){this.b=_,this.a=0}read(_){const ue=this.b.slice(this.a,this.a+_);return this.a+=ue.byteLength,ue}}t.$7h=b;class r{constructor(){this.a=[]}get buffer(){return B.$Ge.concat(this.a)}write(_){this.a.push(_)}}t.$8h=r;var E;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(E||(E={}));function k(le){const _=B.$Ge.alloc(1);return _.writeUInt8(le,0),_}const F={Undefined:k(E.Undefined),String:k(E.String),Buffer:k(E.Buffer),VSBuffer:k(E.VSBuffer),Array:k(E.Array),Object:k(E.Object),Uint:k(E.Int)},M=typeof Buffer<"u";function W(le,_){if(typeof _>"u")le.write(F.Undefined);else if(typeof _=="string"){const ue=B.$Ge.fromString(_);le.write(F.String),m(le,ue.byteLength),le.write(ue)}else if(M&&Buffer.isBuffer(_)){const ue=B.$Ge.wrap(_);le.write(F.Buffer),m(le,ue.byteLength),le.write(ue)}else if(_ instanceof B.$Ge)le.write(F.VSBuffer),m(le,_.byteLength),le.write(_);else if(Array.isArray(_)){le.write(F.Array),m(le,_.length);for(const ue of _)W(le,ue)}else if(typeof _=="number"&&(_|0)===_)le.write(F.Uint),m(le,_);else{const ue=B.$Ge.fromString(JSON.stringify(_));le.write(F.Object),m(le,ue.byteLength),le.write(ue)}}function p(le){switch(le.read(1).readUInt8(0)){case E.Undefined:return;case E.String:return le.read(f(le)).toString();case E.Buffer:return le.read(f(le)).buffer;case E.VSBuffer:return le.read(f(le));case E.Array:{const ue=f(le),re=[];for(let ye=0;ye<ue;ye++)re.push(p(le));return re}case E.Object:return JSON.parse(le.read(f(le)).toString());case E.Int:return f(le)}}class I{constructor(_,ue,re=null,ye=1e3){this.h=_,this.j=ue,this.k=re,this.l=ye,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(H=>this.q(H)),this.m({type:200})}registerChannel(_,ue){this.b.set(_,ue),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const ue=this.o([_.type]);this.k?.logOutgoing(ue,0,1,o(_.type));return}case 201:case 202:case 204:case 203:{const ue=this.o([_.type,_.id],_.data);this.k?.logOutgoing(ue,_.id,1,o(_.type),_.data);return}}}o(_,ue=void 0){const re=new r;return W(re,_),W(re,ue),this.p(re.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const ue=new b(_),re=p(ue),ye=p(ue),H=re[0];switch(H){case 100:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(H)}: ${re[2]}.${re[3]}`,ye),this.s({type:H,id:re[1],channelName:re[2],name:re[3],arg:ye});case 102:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(H)}: ${re[2]}.${re[3]}`,ye),this.t({type:H,id:re[1],channelName:re[2],name:re[3],arg:ye});case 101:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(H)}`),this.u({type:H,id:re[1]});case 103:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(H)}`),this.u({type:H,id:re[1]})}}s(_){const ue=this.b.get(_.channelName);if(!ue){this.v(_);return}const re=new Q.$pe;let ye;try{ye=ue.call(this.j,_.name,_.arg,re.token)}catch(ge){ye=Promise.reject(ge)}const H=_.id;ye.then(ge=>{this.m({id:H,data:ge,type:201})},ge=>{ge instanceof Error?this.m({id:H,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split?ge.stack.split(`
`):ge.stack:void 0},type:202}):this.m({id:H,data:ge,type:203})}).finally(()=>{J.dispose(),this.d.delete(_.id)});const J=(0,g.$Tc)(()=>re.cancel());this.d.set(_.id,J)}t(_){const ue=this.b.get(_.channelName);if(!ue){this.v(_);return}const re=_.id,H=ue.listen(this.j,_.name,_.arg)(J=>this.m({id:re,data:J,type:204}));this.d.set(_.id,H)}u(_){const ue=this.d.get(_.id);ue&&(ue.dispose(),this.d.delete(_.id))}v(_){let ue=this.g.get(_.channelName);ue||(ue=[],this.g.set(_.channelName,ue));const re=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ue.push({request:_,timeoutTimer:re})}w(_){const ue=this.g.get(_);if(ue){for(const re of ue)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Qc)(this.d.values()),this.d.clear()}}t.$$h=I;var V;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(V||(t.RequestInitiator=V={}));class R{constructor(_,ue=null){this.l=_,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ue}getChannel(_){const ue=this;return{call(re,ye,H){return ue.a?Promise.reject(new T.$5):ue.m(_,re,ye,H)},listen(re,ye){return ue.a?d.Event.None:ue.o(_,re,ye)}}}m(_,ue,re,ye=Q.CancellationToken.None){const H=this.g++,ge={id:H,type:100,channelName:_,name:ue,arg:re};if(ye.isCancellationRequested)return Promise.reject(new T.$5);let we;return new Promise((Fe,Ie)=>{if(ye.isCancellationRequested)return Ie(new T.$5);const z=()=>{const v=N=>{switch(N.type){case 201:this.f.delete(H),Fe(N.data);break;case 202:{this.f.delete(H);const s=new Error(N.data.message);s.stack=Array.isArray(N.data.stack)?N.data.stack.join(`
`):N.data.stack,s.name=N.data.name,Ie(s);break}case 203:this.f.delete(H),Ie(N.data);break}};this.f.set(H,v),this.p(ge)};let u=null;this.b===l.Idle?z():(u=(0,C.$jh)(v=>this.u()),u.then(()=>{u=null,z()}));const y=()=>{u?(u.cancel(),u=null):this.p({id:H,type:101}),Ie(new T.$5)},a=ye.onCancellationRequested(y);we=(0,g.$Sc)((0,g.$Tc)(y),a),this.d.add(we)}).finally(()=>{we.dispose(),this.d.delete(we)})}o(_,ue,re){const ye=this.g++,J={id:ye,type:102,channelName:_,name:ue,arg:re};let ge=null;const we=new d.$ee({onWillAddFirstListener:()=>{ge=(0,C.$jh)(Fe=>this.u()),ge.then(()=>{ge=null,this.d.add(we),this.p(J)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(we),this.p({id:ye,type:103}))}}),ke=Fe=>we.fire(Fe.data);return this.f.set(ye,ke),we.event}p(_){switch(_.type){case 100:case 102:{const ue=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(ue,_.id,0,`${e(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const ue=this.q([_.type,_.id]);this.j?.logOutgoing(ue,_.id,0,e(_.type));return}}}q(_,ue=void 0){const re=new r;return W(re,_),W(re,ue),this.r(re.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const ue=new b(_),re=p(ue),ye=p(ue),H=re[0];switch(H){case 200:return this.j?.logIncoming(_.byteLength,0,0,o(H)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,re[1],0,o(H),ye),this.t({type:re[0],id:re[1],data:ye})}}t(_){if(_.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Qc)(this.d.values()),this.d.clear()}}t.$_h=R,Ze([A.$1h],R.prototype,"onDidInitializePromise",null);class x{get connections(){const _=[];return this.f.forEach(ue=>_.push(ue)),_}constructor(_,ue,re){this.a=new Map,this.f=new Set,this.g=new d.$ee,this.onDidAddConnection=this.g.event,this.h=new d.$ee,this.onDidRemoveConnection=this.h.event,this.j=new g.$Uc,this.j.add(_(({protocol:ye,onDidClientDisconnect:H})=>{const J=d.Event.once(ye.onMessage);this.j.add(J(ge=>{const we=new b(ge),ke=p(we),Fe=new I(ye,ke,ue,re),Ie=new R(ye,ue);this.a.forEach((u,y)=>Fe.registerChannel(y,u));const z={channelServer:Fe,channelClient:Ie,ctx:ke};this.f.add(z),this.g.fire(z),this.j.add(H(()=>{Fe.dispose(),Ie.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(_,ue){const re=this;return{call(ye,H,J){let ge;if((0,c.$kg)(ue)){const ke=(0,i.$4b)(re.connections.filter(ue));ge=ke?Promise.resolve(ke):d.Event.toPromise(d.Event.filter(re.onDidAddConnection,ue))}else ge=ue.routeCall(re,ye,H);const we=ge.then(ke=>ke.channelClient.getChannel(_));return G(we).call(ye,H,J)},listen(ye,H){if((0,c.$kg)(ue))return re.k(_,ue,ye,H);const J=ue.routeEvent(re,ye,H).then(ge=>ge.channelClient.getChannel(_));return G(J).listen(ye,H)}}}k(_,ue,re,ye){const H=this;let J;const ge=new d.$ee({onWillAddFirstListener:()=>{J=new g.$Uc;const we=new d.$ke,ke=new Map,Fe=z=>{const y=z.channelClient.getChannel(_).listen(re,ye),a=we.add(y);ke.set(z,a)},Ie=z=>{const u=ke.get(z);u&&(u.dispose(),ke.delete(z))};H.connections.filter(ue).forEach(Fe),d.Event.filter(H.onDidAddConnection,ue)(Fe,void 0,J),H.onDidRemoveConnection(Ie,void 0,J),we.event(ge.fire,ge,J),J.add(we)},onDidRemoveLastListener:()=>{J?.dispose(),J=void 0}});return ge.event}registerChannel(_,ue){this.a.set(_,ue);for(const re of this.f)re.channelServer.registerChannel(_,ue)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$ai=x;class O{constructor(_,ue,re=null){const ye=new r;W(ye,ue),_.send(ye.buffer),this.a=new R(_,re),this.d=new I(_,ue,re)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,ue){this.d.registerChannel(_,ue)}dispose(){this.a.dispose(),this.d.dispose()}}t.$bi=O;function G(le){return{call(_,ue,re){return le.then(ye=>ye.call(_,ue,re))},listen(_,ue){const re=new d.$ne;return le.then(ye=>re.input=ye.listen(_,ue)),re.event}}}function q(le){let _=!1;return{call(ue,re,ye){return _?le.call(ue,re,ye):(0,C.$xh)(0).then(()=>_=!0).then(()=>le.call(ue,re,ye))},listen(ue,re){if(_)return le.listen(ue,re);const ye=new d.$ne;return(0,C.$xh)(0).then(()=>_=!0).then(()=>ye.input=le.listen(ue,re)),ye.event}}}class ae{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const ue of _.connections)if(await Promise.resolve(this.a(ue.ctx)))return Promise.resolve(ue);return await d.Event.toPromise(_.onDidAddConnection),await this.b(_)}}t.$ei=ae;var ie;(function(le){function _(H,J,ge){const we=H,ke=ge&&ge.disableMarshalling,Fe=new Map;for(const Ie in we)re(Ie)&&Fe.set(Ie,d.Event.buffer(we[Ie],!0,void 0,J));return new class{listen(Ie,z,u){const y=Fe.get(z);if(y)return y;const a=we[z];if(typeof a=="function"){if(ye(z))return a.call(we,u);if(re(z))return Fe.set(z,d.Event.buffer(we[z],!0,void 0,J)),Fe.get(z)}throw new T.$bb(`Event not found: ${z}`)}call(Ie,z,u){const y=we[z];if(typeof y=="function"){if(!ke&&Array.isArray(u))for(let v=0;v<u.length;v++)u[v]=(0,$.$6h)(u[v]);let a=y.apply(we,u);return a instanceof Promise||(a=Promise.resolve(a)),a}throw new T.$bb(`Method not found: ${z}`)}}}le.fromService=_;function ue(H,J){const ge=J&&J.disableMarshalling;return new Proxy({},{get(we,ke){if(typeof ke=="string")return J?.properties?.has(ke)?J.properties.get(ke):ye(ke)?function(Fe){return H.listen(ke,Fe)}:re(ke)?H.listen(ke):async function(...Fe){let Ie;J&&!(0,c.$fg)(J.context)?Ie=[J.context,...Fe]:Ie=Fe;const z=await H.call(ke,Ie);return ge?z:(0,$.$6h)(z)};throw new T.$bb(`Property not found: ${String(ke)}`)}})}le.toService=ue;function re(H){return H[0]==="o"&&H[1]==="n"&&P.$xf(H.charCodeAt(2))}function ye(H){return/^onDynamic/.test(H)&&P.$xf(H.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const _=le.toString();if(_!=="[object Object]")return _}return le}function De(le){return Array.isArray(le)?le.map(ce):ce(le)}function Ee(le,_,ue,re,ye,H,J){J=De(J);const ge=ee[ye],we=ge[re%ge.length];let ke=[`%c[${le}]%c[${String(_).padStart(7," ")}]%c[len: ${String(ue).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${we}`];/\($/.test(H)?(ke=ke.concat(J),ke.push(")")):ke.push(J),console.log.apply(console,ke)}class Me{constructor(_,ue){this.d=_,this.f=ue,this.a=0,this.b=0}logOutgoing(_,ue,re,ye,H){this.b+=_,Ee(this.d,this.b,_,ue,re,ye,H)}logIncoming(_,ue,re,ye,H){this.a+=_,Ee(this.f,this.a,_,ue,re,ye,H)}}t.$fi=Me}),define(me[145],be([1,0,43,3,77,102,35]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6W=void 0;class T extends B.$bi{static f(){const g=C.Event.fromNodeEventEmitter(A.$O,"vscode:message",($,P)=>i.$Ge.wrap(P));return A.$O.send("vscode:hello"),new Q.$2W(A.$O,g)}constructor(g){const $=T.f();super($,g),this.b=$}dispose(){this.b.disconnect(),super.dispose()}}t.$6W=T}),define(me[146],be([13,12]),function(se,t){return se.create("vs/platform/files/common/files",t)}),define(me[147],be([13,12]),function(se,t){return se.create("vs/platform/theme/common/iconRegistry",t)}),define(me[50],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vi=t._util=void 0,t.$wi=B,t.$xi=Q;var i;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function T(d){return d[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=T})(i||(t._util=i={})),t.$vi=B("instantiationService");function C(A,T,d){T[i.DI_TARGET]===T?T[i.DI_DEPENDENCIES].push({id:A,index:d}):(T[i.DI_DEPENDENCIES]=[{id:A,index:d}],T[i.DI_TARGET]=T)}function B(A){if(i.serviceIds.has(A))return i.serviceIds.get(A);const T=function(d,g,$){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(T,d,$)};return T.toString=()=>A,i.serviceIds.set(A,T),T}function Q(A){return A}}),define(me[148],be([1,0,50]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fn=t.$dn=t.ID=void 0,t.$en=C,t.ID="diagnosticsService",t.$dn=(0,i.$wi)(t.ID);function C(Q){return!!Q.hostName&&!!Q.errorMessage}class B{async getPerformanceInfo(A,T){return{}}async getSystemInfo(A,T){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,T){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}t.$fn=B}),define(me[149],be([1,0,99,25,9,10,16,146,50,5,36,23]),function(se,t,i,C,B,Q,A,T,d,g,$,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yl=t.$vl=t.FileKind=t.$ul=t.$tl=t.$sl=t.$rl=t.$ql=t.$pl=t.$ol=t.FileOperationResult=t.$nl=t.$ml=t.$ll=t.$jl=t.FileChangeType=t.$il=t.FileOperation=t.$cl=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.$3k=void 0,t.$4k=c,t.$5k=o,t.$6k=f,t.$7k=S,t.$8k=m,t.$9k=b,t.$0k=r,t.$$k=E,t.$_k=k,t.$al=F,t.$bl=M,t.$dl=I,t.$el=V,t.$fl=R,t.$gl=x,t.$hl=O,t.$kl=ee,t.$wl=_,t.$xl=ue,t.$zl=ye,t.$3k=(0,d.$wi)("fileService");function c(H){return H.create===!0}var h;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(h||(t.FileType=h={}));var e;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var n;(function(H){H[H.UPDATED=2]="UPDATED",H[H.ADDED=4]="ADDED",H[H.DELETED=8]="DELETED"})(n||(t.FileChangeFilter=n={}));function o(H){const J=H;return!!J&&typeof J.onDidChange=="function"}var l;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function f(H){return!!(H.capabilities&2)}function S(H){return!!(H.capabilities&8)}function m(H){return!!(H.capabilities&131072)}function b(H){return!!(H.capabilities&4)}function r(H){return!!(H.capabilities&16)}function E(H){return f(H)?!!(H.capabilities&16384):!1}function k(H){return f(H)?!!(H.capabilities&32768):!1}function F(H){return!!(H.capabilities&65536)}function M(H){return!!(H.capabilities&2048)}var W;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(W||(t.FileSystemProviderErrorCode=W={}));class p extends Error{static create(J,ge){const we=new p(J.toString(),ge);return R(we,ge),we}constructor(J,ge){super(J),this.code=ge}}t.$cl=p;function I(H,J){return p.create(H,J)}function V(H){return H||I((0,T.localize)(0,null),W.Unknown)}function R(H,J){return H.name=J?`${J} (FileSystemError)`:"FileSystemError",H}function x(H){if(!H)return W.Unknown;if(H instanceof p)return H.code;const J=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!J)return W.Unknown;switch(J[1]){case W.FileExists:return W.FileExists;case W.FileIsADirectory:return W.FileIsADirectory;case W.FileNotADirectory:return W.FileNotADirectory;case W.FileNotFound:return W.FileNotFound;case W.FileTooLarge:return W.FileTooLarge;case W.FileWriteLocked:return W.FileWriteLocked;case W.NoPermissions:return W.NoPermissions;case W.Unavailable:return W.Unavailable}return W.Unknown}function O(H){if(H instanceof ce)return H.fileOperationResult;switch(x(H)){case W.FileNotFound:return 1;case W.FileIsADirectory:return 0;case W.FileNotADirectory:return 9;case W.FileWriteLocked:return 5;case W.NoPermissions:return 6;case W.FileExists:return 4;case W.FileTooLarge:return 7;default:return 10}}var G;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(G||(t.FileOperation=G={}));class q{constructor(J,ge,we){this.resource=J,this.operation=ge,this.target=we}isOperation(J){return this.operation===J}}t.$il=q;var ae;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(ae||(t.FileChangeType=ae={}));class ie{static{this.a=null}constructor(J,ge){this.c=ge,this.b=void 0,this.d=new P.$V(()=>{const we=i.$Ci.forUris(()=>this.c);return we.fill(this.rawAdded.map(ke=>[ke,!0])),we}),this.f=new P.$V(()=>{const we=i.$Ci.forUris(()=>this.c);return we.fill(this.rawUpdated.map(ke=>[ke,!0])),we}),this.g=new P.$V(()=>{const we=i.$Ci.forUris(()=>this.c);return we.fill(this.rawDeleted.map(ke=>[ke,!0])),we}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const we of J){switch(we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}this.b!==ie.a&&(typeof we.cId=="number"?this.b===void 0?this.b=we.cId:this.b!==we.cId&&(this.b=ie.a):this.b!==void 0&&(this.b=ie.a))}}contains(J,...ge){return this.h(J,{includeChildren:!1},...ge)}affects(J,...ge){return this.h(J,{includeChildren:!0},...ge)}h(J,ge,...we){if(!J)return!1;const ke=we.length>0;return!!((!ke||we.includes(1))&&(this.d.value.get(J)||ge.includeChildren&&this.d.value.findSuperstr(J))||(!ke||we.includes(0))&&(this.f.value.get(J)||ge.includeChildren&&this.f.value.findSuperstr(J))||(!ke||we.includes(2))&&(this.g.value.findSubstr(J)||ge.includeChildren&&this.g.value.findSuperstr(J)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(J){return this.b===J}hasCorrelation(){return typeof this.b=="number"}}t.$jl=ie;function ee(H,J,ge){return!H||!J||H===J||J.length>H.length?!1:(J.charAt(J.length-1)!==C.sep&&(J+=C.sep),ge?(0,B.$zf)(H,J):H.indexOf(J)===0)}class ce extends Error{constructor(J,ge,we){super(J),this.fileOperationResult=ge,this.options=we}}t.$ll=ce;class De extends ce{constructor(J,ge,we,ke){super(J,ge,ke),this.fileOperationResult=ge,this.size=we}}t.$ml=De;class Ee extends ce{constructor(J,ge,we){super(J,2,we),this.stat=ge}}t.$nl=Ee;var Me;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Me||(t.FileOperationResult=Me={})),t.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$ql="files.associations",t.$rl="files.exclude",t.$sl="files.readonlyInclude",t.$tl="files.readonlyExclude",t.$ul="files.readonlyFromPermissions";var le;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(t.FileKind=le={})),t.$vl="";function _(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}async function ue(H,J){if(!J.hasProvider(A.URI.from({scheme:H.scheme})))return new Promise(ge=>{const we=J.onDidChangeFileSystemProviderRegistrations(ke=>{ke.scheme===H.scheme&&ke.added&&(we.dispose(),ge())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(J){return(0,Q.$ag)(J)||(J=0),J<re.KB?(0,T.localize)(1,null,J.toFixed(0)):J<re.MB?(0,T.localize)(2,null,(J/re.KB).toFixed(2)):J<re.GB?(0,T.localize)(3,null,(J/re.MB).toFixed(2)):J<re.TB?(0,T.localize)(4,null,(J/re.GB).toFixed(2)):(0,T.localize)(5,null,(J/re.TB).toFixed(2))}}t.$yl=re;function ye(H){const J=typeof H=="string"||H?.scheme===$.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===$.Schemas.file?1024*re.MB:J?10*re.MB:g.$o?50*re.MB:1024*re.MB}}),define(me[150],be([1,0,50]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mdc=t.$Ldc=void 0,t.$Ldc=(0,i.$wi)("mainProcessService");class C{constructor(Q,A){this.a=Q,this.b=A}getChannel(Q){return this.a.getChannel(Q,this.b)}registerChannel(Q,A){this.a.registerChannel(Q,A)}}t.$Mdc=C}),define(me[151],be([1,0,2,145]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ndc=void 0;class B extends i.$Vc{constructor(A){super(),this.a=this.B(new C.$6W(`window:${A}`))}getChannel(A){return this.a.getChannel(A)}registerChannel(A,T){this.a.registerChannel(A,T)}}t.$Ndc=B});var Ei=this&&this.__param||function(se,t){return function(i,C){t(i,C,se)}};define(me[152],be([1,0,77,150]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rdc=void 0;let B=class{constructor(A,T){return this.windowId=A,i.ProxyChannel.toService(T.getChannel("nativeHost"),{context:A,properties:(()=>{const d=new Map;return d.set("windowId",A),d})()})}};t.$Rdc=B,t.$Rdc=B=Ze([Ei(1,C.$Ldc)],B)}),define(me[78],be([1,0,37,10]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$co=void 0;class B{constructor(){this.a=new Map}add(A,T){i.ok(C.$9f(A)),i.ok(C.$$f(T)),i.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,T)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}t.$co=new B}),define(me[153],be([1,0,3,78]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$do=void 0,t.$do={JSONContribution:"base.contributions.json"};function B(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class Q{constructor(){this.b=new i.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,g){this.a[B(d)]=g,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const A=new Q;C.$co.add(t.$do.JSONContribution,A)}),define(me[154],be([1,0,11,18,45,19,3,10,16,147,153,78]),function(se,t,i,C,B,Q,A,T,d,g,$,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gx=t.$fx=t.$ex=t.$dx=t.$cx=t.$bx=t.IconFontDefinition=t.IconContribution=t.$$w=void 0,t.$_w=o,t.$ax=l,t.$$w={IconContribution:"base.contributions.icons"};var c;(function(b){function r(E,k){let F=E.defaults;for(;Q.ThemeIcon.isThemeIcon(F);){const M=n.getIcon(F.id);if(!M)return;F=M.defaults}return F}b.getDefinition=r})(c||(t.IconContribution=c={}));var h;(function(b){function r(k){return{weight:k.weight,style:k.style,src:k.src.map(F=>({format:F.format,location:F.location.toString()}))}}b.toJSONObject=r;function E(k){const F=M=>(0,T.$9f)(M)?M:void 0;if(k&&Array.isArray(k.src)&&k.src.every(M=>(0,T.$9f)(M.format)&&(0,T.$9f)(M.location)))return{weight:F(k.weight),style:F(k.style),src:k.src.map(M=>({format:M.format,location:d.URI.parse(M.location)}))}}b.fromJSONObject=E})(h||(t.IconFontDefinition=h={}));class e{constructor(){this.a=new A.$ee,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${Q.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,E,k,F){const M=this.b[r];if(M){if(k&&!M.description){M.description=k,this.d.properties[r].markdownDescription=`${k} $(${r})`;const I=this.e.enum.indexOf(r);I!==-1&&(this.e.enumDescriptions[I]=k),this.a.fire()}return M}const W={id:r,description:k,defaults:E,deprecationMessage:F};this.b[r]=W;const p={$ref:"#/definitions/icons"};return F&&(p.deprecationMessage=F),k&&(p.markdownDescription=`${k}: $(${r})`),this.d.properties[r]=p,this.e.enum.push(r),this.e.enumDescriptions.push(k||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const E=this.e.enum.indexOf(r);E!==-1&&(this.e.enum.splice(E,1),this.e.enumDescriptions.splice(E,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,E){const k=this.f[r];return k||(this.f[r]=E,this.a.fire(),E)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(M,W)=>M.id.localeCompare(W.id),E=M=>{for(;Q.ThemeIcon.isThemeIcon(M.defaults);)M=this.b[M.defaults.id];return`codicon codicon-${M?M.id:""}`},k=[];k.push("| preview     | identifier                        | default codicon ID                | description"),k.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const F=Object.keys(this.b).map(M=>this.b[M]);for(const M of F.filter(W=>!!W.description).sort(r))k.push(`|<i class="${E(M)}"></i>|${M.id}|${Q.ThemeIcon.isThemeIcon(M.defaults)?M.defaults.id:M.id}|${M.description||""}|`);k.push("| preview     | identifier                        "),k.push("| ----------- | --------------------------------- |");for(const M of F.filter(W=>!Q.ThemeIcon.isThemeIcon(W.defaults)).sort(r))k.push(`|<i class="${E(M)}"></i>|${M.id}|`);return k.join(`
`)}}const n=new e;P.$co.add(t.$$w.IconContribution,n);function o(b,r,E,k){return n.registerIcon(b,r,E,k)}function l(){return n}function f(){const b=(0,B.$Rj)();for(const r in b){const E="\\"+b[r].toString(16);n.registerIcon(r,{fontCharacter:E})}}f(),t.$bx="vscode://schemas/icons";const S=P.$co.as($.$do.JSONContribution);S.registerSchema(t.$bx,n.getIconSchema());const m=new i.$Ih(()=>S.notifySchemaChanged(t.$bx),200);n.onDidChange(()=>{m.isScheduled()||m.schedule()}),t.$cx=o("widget-close",C.$Vj.close,(0,g.localize)(2,null)),t.$dx=o("goto-previous-location",C.$Vj.arrowUp,(0,g.localize)(3,null)),t.$ex=o("goto-next-location",C.$Vj.arrowDown,(0,g.localize)(4,null)),t.$fx=Q.ThemeIcon.modify(C.$Vj.sync,"spin"),t.$gx=Q.ThemeIcon.modify(C.$Vj.loading,"spin")}),define(me[155],be([1,0,4,3,2,19,154]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Jb=void 0,t.$2Jb=T;function T(g){const $=new B.$Uc,P=$.add(new C.$ee),c=(0,A.$ax)();return $.add(c.onDidChange(()=>P.fire())),g&&$.add(g.onDidProductIconThemeChange(()=>P.fire())),{dispose:()=>$.dispose(),onDidChange:P.event,getCSS(){const h=g?g.getProductIconTheme():new d,e={},n=[],o=[];for(const l of c.getIcons()){const f=h.getIcon(l);if(!f)continue;const S=f.font,m=`--vscode-icon-${l.id}-font-family`,b=`--vscode-icon-${l.id}-content`;S?(e[S.id]=S.definition,o.push(`${m}: ${(0,i.$$S)(S.id)};`,`${b}: '${f.fontCharacter}';`),n.push(`.codicon-${l.id}:before { content: '${f.fontCharacter}'; font-family: ${(0,i.$$S)(S.id)}; }`)):(o.push(`${b}: '${f.fontCharacter}'; ${m}: 'codicon';`),n.push(`.codicon-${l.id}:before { content: '${f.fontCharacter}'; }`))}for(const l in e){const f=e[l],S=f.weight?`font-weight: ${f.weight};`:"",m=f.style?`font-style: ${f.style};`:"",b=f.src.map(r=>`${(0,i.$0S)(r.location)} format('${r.format}')`).join(", ");n.push(`@font-face { src: ${b}; font-family: ${(0,i.$$S)(l)};${S}${m} font-display: block; }`)}return n.push(`:root { ${o.join(" ")} }`),n.join(`
`)}}}class d{getIcon($){const P=(0,A.$ax)();let c=$.defaults;for(;Q.ThemeIcon.isThemeIcon(c);){const h=P.getIcon(c.id);if(!h)return;c=h.defaults}return c}}t.$3Jb=d}),define(me[156],be([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$uD=void 0,t.$vD=C,t.$wD=B,t.$xD=Q,t.$yD=A,t.$zD=T,t.$AD=P,t.$BD=c,t.$CD=h,t.$DD=e,t.$ED=n,t.$FD=o,t.$uD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(l){return typeof l.parentId=="number"}function B(l){return!!l.workspaceUri}function Q(l){return!!l.folderUri}function A(l){return!!l.fileUri}function T(l){const f=c(l),S=l.getValue("window.menuBarVisibility");return S==="default"||f&&S==="compact"||i.$j&&i.$m?"classic":S}var d;(function(l){l.TITLE_BAR_STYLE="window.titleBarStyle",l.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(d||(t.TitleBarSetting=d={}));var g;(function(l){l.NATIVE="native",l.CUSTOM="custom"})(g||(t.TitlebarStyle=g={}));var $;(function(l){l.AUTO="auto",l.WINDOWED="windowed",l.NEVER="never"})($||(t.CustomTitleBarVisibility=$={}));function P(l,f){return!0}function c(l,f){return f||(f=h(l)),f==="native"}function h(l){if(i.$o)return"custom";const f=l.getValue("window");if(f){if(i.$j&&f.nativeTabs===!0||i.$j&&f.nativeFullScreen===!1)return"native";const b=f.titleBarStyle;if(b==="native"||b==="custom")return b}return i.$k?"native":"custom"}function e(l){return!(!i.$i||i.$o||c(l))}function n(l){const f=l.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}function o(l=0){return Math.pow(1.2,l)}}),define(me[157],be([1,0,17,4,22,35,156]),function(se,t,i,C,B,Q,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Udc=t.$Tdc=t.ApplyZoomTarget=void 0,t.$Vdc=d,t.$Wdc=$,t.$Xdc=P;var T;(function(c){c[c.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",c[c.ALL_WINDOWS=2]="ALL_WINDOWS"})(T||(t.ApplyZoomTarget=T={})),t.$Tdc=8,t.$Udc=-8;function d(c,h){c=Math.min(Math.max(c,t.$Udc),t.$Tdc);const e=[];h===T.ACTIVE_WINDOW?e.push((0,C.$yS)()):h===T.ALL_WINDOWS?e.push(...Array.from((0,C.getWindows)()).map(({window:n})=>n)):e.push(h);for(const n of e)g(n)?.webFrame?.setZoomLevel(c),(0,i.$vR)((0,A.$FD)(c),n),(0,i.$rR)(c,n)}function g(c){if(c===B.$nR)return{ipcRenderer:Q.$O,webFrame:Q.$Q};{const h=c;if(h?.vscode?.ipcRenderer&&h?.vscode?.webFrame)return h.vscode}}function $(c){d((0,i.$sR)(typeof c=="number"?(0,C.$yS)():c)+1,c)}function P(c){d((0,i.$sR)(typeof c=="number"?(0,C.$yS)():c)-1,c)}}),define(me[158],be([1,0,12,4,144,11,103,35,148,149,151,152,155,157,15,22,116,107]),function(se,t,i,C,B,Q,A,T,d,g,$,P,c,h,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=I;const o=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,l=/\s--inspect-port=(?<port>\d+)/;class f{getHeight(R){return 22}getTemplateId(R){return M(R)?"process":k(R)?"machine":(0,d.$en)(R)?"error":F(R)?"header":""}}class S{hasChildren(R){return(0,d.$en)(R)?!1:M(R)?!!R.children?.length:!0}getChildren(R){return M(R)?R.children?R.children:[]:(0,d.$en)(R)?[]:F(R)?R.processRoots.length>1?R.processRoots:[R.processRoots[0].rootProcess]:k(R)?[R.rootProcess]:[R.processes]}}class m{constructor(){this.templateId="header"}renderTemplate(R){const x=(0,C.$TS)(R,(0,C.$)(".row")),O=(0,C.$TS)(x,(0,C.$)(".nameLabel")),G=(0,C.$TS)(x,(0,C.$)(".cpu")),q=(0,C.$TS)(x,(0,C.$)(".memory")),ae=(0,C.$TS)(x,(0,C.$)(".pid"));return{name:O,CPU:G,memory:q,PID:ae}}renderElement(R,x,O,G){O.name.textContent=(0,i.localize)(0,null),O.CPU.textContent=(0,i.localize)(1,null),O.PID.textContent=(0,i.localize)(2,null),O.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(R){}}class b{constructor(){this.templateId="machine"}renderTemplate(R){const x=Object.create(null),O=(0,C.$TS)(R,(0,C.$)(".row"));return x.name=(0,C.$TS)(O,(0,C.$)(".nameLabel")),x}renderElement(R,x,O,G){O.name.textContent=R.element.name}disposeTemplate(R){}}class r{constructor(){this.templateId="error"}renderTemplate(R){const x=Object.create(null),O=(0,C.$TS)(R,(0,C.$)(".row"));return x.name=(0,C.$TS)(O,(0,C.$)(".nameLabel")),x}renderElement(R,x,O,G){O.name.textContent=R.element.errorMessage}disposeTemplate(R){}}class E{constructor(R,x,O){this.a=R,this.b=x,this.c=O,this.templateId="process"}renderTemplate(R){const x=(0,C.$TS)(R,(0,C.$)(".row")),O=(0,C.$TS)(x,(0,C.$)(".nameLabel")),G=(0,C.$TS)(x,(0,C.$)(".cpu")),q=(0,C.$TS)(x,(0,C.$)(".memory")),ae=(0,C.$TS)(x,(0,C.$)(".pid"));return{name:O,CPU:G,PID:ae,memory:q}}renderElement(R,x,O,G){const{element:q}=R,ae=q.pid.toFixed(0);let ie=q.name;this.c.has(q.pid)&&(ie=this.c.get(q.pid)),O.name.textContent=ie,O.name.title=q.cmd,O.CPU.textContent=q.load.toFixed(0),O.PID.textContent=ae,O.PID.parentElement.id=`pid-${ae}`;const ee=this.a==="win32"?q.mem:this.b*(q.mem/100);O.memory.textContent=(ee/g.$yl.MB).toFixed(0)}disposeTemplate(R){}}function k(V){return!!V.name&&!!V.rootProcess}function F(V){return!!V.processRoots}function M(V){return!!V.pid}class W{constructor(R,x){this.f=x,this.b=new Map;const O=new $.$Ndc(R);this.c=new P.$Rdc(R,O),this.k(x.styles),this.g(x),T.$O.on("vscode:pidToNameResponse",(G,q)=>{this.b.clear();for(const[ae,ie]of q)this.b.set(ae,ie)}),T.$O.on("vscode:listProcessesResponse",async(G,q)=>{q.forEach((ae,ie)=>{M(ae.rootProcess)&&(ae.rootProcess.name=ie===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:q}}),this.d.layout(n.$nR.innerHeight,n.$nR.innerWidth)):await this.h(q),this.m(0)}),this.a=Date.now(),T.$O.send("vscode:pidToNameRequest"),T.$O.send("vscode:listProcesses")}g(R){n.$nR.document.onkeydown=x=>{const O=R.platform==="darwin"?x.metaKey:x.ctrlKey;O&&x.keyCode===87&&(x.stopPropagation(),x.preventDefault(),T.$O.send("vscode:closeProcessExplorer")),O&&x.keyCode===187&&(0,h.$Wdc)(n.$nR),O&&x.keyCode===189&&(0,h.$Xdc)(n.$nR)}}async h(R){const x=n.$nR.document.getElementById("process-list");if(!x)return;const{totalmem:O}=await this.c.getOSStatistics(),G=[new E(this.f.platform,O,this.b),new m,new b,new r];this.d=new B.$sW("processExplorer",x,new f,G,new S,{identityProvider:{getId:q=>M(q)?q.pid.toString():(0,d.$en)(q)?q.hostName:F(q)?"processes":k(q)?q.name:"header"}}),this.d.setInput({processes:{processRoots:R}}),this.d.layout(n.$nR.innerHeight,n.$nR.innerWidth),this.d.onKeyDown(q=>{const ae=new e.$QR(q);if(ae.keyCode===35&&ae.altKey){const ie=this.n();Promise.all(ie.map(ee=>this.c.killProcess(ee,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(q=>{M(q.element)&&this.l(q.element,!0)}),x.style.height=`${n.$nR.innerHeight}px`,n.$nR.addEventListener("resize",()=>{x.style.height=`${n.$nR.innerHeight}px`,this.d?.layout(n.$nR.innerHeight,n.$nR.innerWidth)})}i(R){const x=o.exec(R);return x&&x.groups.port!=="0"||R.indexOf("node ")>=0||R.indexOf("node.exe")>=0}j(R){const x={type:"node",request:"attach",name:`process ${R.pid}`};let O=o.exec(R.cmd);O?x.port=Number(O.groups.port):x.processId=String(R.pid),O=l.exec(R.cmd),O&&(x.port=Number(O.groups.port)),T.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[x]})}k(R){const x=(0,C.$BS)(),O=[];R.listFocusBackground&&(O.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${R.listFocusBackground}; }`),O.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${R.listFocusBackground}; }`)),R.listFocusForeground&&O.push(`.monaco-list:focus .monaco-list-row.focused { color: ${R.listFocusForeground}; }`),R.listActiveSelectionBackground&&(O.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${R.listActiveSelectionBackground}; }`),O.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${R.listActiveSelectionBackground}; }`)),R.listActiveSelectionForeground&&O.push(`.monaco-list:focus .monaco-list-row.selected { color: ${R.listActiveSelectionForeground}; }`),R.listHoverBackground&&O.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${R.listHoverBackground}; }`),R.listHoverForeground&&O.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${R.listHoverForeground}; }`),R.listFocusOutline&&O.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${R.listFocusOutline}; outline-offset: -1px; }`),R.listHoverOutline&&O.push(`.monaco-list-row:hover { outline: 1px dashed ${R.listHoverOutline}; outline-offset: -1px; }`),R.scrollbarShadowColor&&O.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${R.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),R.scrollbarSliderBackgroundColor&&O.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${R.scrollbarSliderBackgroundColor};
				}
			`),R.scrollbarSliderHoverBackgroundColor&&O.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${R.scrollbarSliderHoverBackgroundColor};
				}
			`),R.scrollbarSliderActiveBackgroundColor&&O.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${R.scrollbarSliderActiveBackgroundColor};
				}
			`),x.textContent=O.join(`
`),R.color&&(n.$nR.document.body.style.color=R.color)}l(R,x){const O=[],G=Number(R.pid);x&&(O.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(G,"SIGTERM")}}),O.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(G,"SIGKILL")}}),O.push({type:"separator"})),O.push({label:(0,i.localize)(6,null),click:()=>{const q=this.n();q?.includes(G)||(q.length=0,q.push(G));const ae=q?.map(ie=>n.$nR.document.getElementById(`pid-${ie}`)).filter(ie=>!!ie);if(ae){const ie=ae.map(ee=>ee.innerText).filter(ee=>!!ee);this.c.writeClipboardText(ie.join(`
`))}}}),O.push({label:(0,i.localize)(7,null),click:()=>{const q=n.$nR.document.getElementById("process-list");q&&this.c.writeClipboardText(q.innerText)}}),R&&x&&this.i(R.cmd)&&(O.push({type:"separator"}),O.push({label:(0,i.localize)(8,null),click:()=>{this.j(R)}})),(0,A.$XW)(O)}m(R){setTimeout(()=>{const x=Date.now(),O=R+x-this.a;this.a=x,O>1e3?(T.$O.send("vscode:pidToNameRequest"),T.$O.send("vscode:listProcesses")):this.m(O)},200)}n(){return this.d?.getSelection()?.map(R=>{if(!(!R||!("pid"in R)))return R.pid}).filter(R=>!!R)}}function p(){const V=(0,C.$BS)();V.id="codiconStyles";const R=(0,c.$2Jb)(void 0);function x(){V.textContent=R.getCSS()}const O=new Q.$Ih(x,0);R.onDidChange(()=>O.schedule()),O.schedule()}function I(V){const R=V.data.platform==="win32"?"windows":V.data.platform==="linux"?"linux":"mac";n.$nR.document.body.classList.add(R),p(),(0,h.$Vdc)(V.data.zoomLevel,n.$nR),new W(V.windowId,V.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/17235b28ebca8f946926ec11374b67cd53c0619d/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
