/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ne){for(var e=[],D=0,N=ne.length;D<N;D++)e[D]=ae[ne[D]];return e};define(ae[124],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const j=new Map,A=new Map,O=new Map,I=new Map;function C(h,c){h.has(c.detail)||h.set(c.detail,-c.timestamp)}function f(h,c){const p=h.get(c.detail);p&&(p>=0||h.set(c.detail,p+c.timestamp))}let E=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(E=ne.getStats().slice(0).sort((h,c)=>h.timestamp-c.timestamp));for(const h of E)switch(h.type){case 10:C(j,h);break;case 11:case 12:f(j,h);break;case 21:C(A,h);break;case 22:f(A,h);break;case 33:C(O,h);break;case 34:f(O,h);break;case 31:C(I,h);break;case 32:f(I,h);break}let y=0;O.forEach(h=>y+=h);function w(h){const c=[];return h.forEach((p,g)=>c.push([g,p])),c}return{amdLoad:w(j),amdInvoke:w(A),nodeRequire:w(O),nodeEval:w(I),nodeRequireTotal:y}}static toMarkdownTable(j,A){let O="";const I=[];return j.forEach((C,f)=>{I[f]=C.length}),A.forEach(C=>{C.forEach((f,E)=>{typeof f>"u"&&(f=C[E]="-");const y=f.toString().length;I[E]=Math.max(y,I[E])})}),j.forEach((C,f)=>{O+=`| ${C+" ".repeat(I[f]-C.toString().length)} `}),O+=`|
`,j.forEach((C,f)=>{O+=`| ${"-".repeat(I[f])} `}),O+=`|
`,A.forEach(C=>{C.forEach((f,E)=>{typeof f<"u"&&(O+=`| ${f+" ".repeat(I[E]-f.toString().length)} `)}),O+=`|
`}),O}}e.$U=D}),define(ae[125],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=D,e.$gb=N,e.$hb=j,e.$ib=A,e.$jb=O,e.$kb=I,e.$lb=C,e.$nb=E,e.$ob=y,e.$pb=w,e.$qb=h,e.$rb=c;function D(p,g){const l=N(p,g);if(l!==-1)return p[l]}function N(p,g,l=p.length-1){for(let u=l;u>=0;u--){const m=p[u];if(g(m))return u}return-1}function j(p,g){const l=A(p,g);return l===-1?void 0:p[l]}function A(p,g,l=0,u=p.length){let m=l,d=u;for(;m<d;){const $=Math.floor((m+d)/2);g(p[$])?m=$+1:d=$}return m-1}function O(p,g){const l=I(p,g);return l===p.length?void 0:p[l]}function I(p,g,l=0,u=p.length){let m=l,d=u;for(;m<d;){const $=Math.floor((m+d)/2);g(p[$])?d=$:m=$+1}return m}function C(p,g,l=0,u=p.length){const m=I(p,g,l,u);return m===p.length?-1:m}class f{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(f.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!g(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const l=A(this.e,g,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=f;function E(p,g){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const m=p[u];g(m,l)>0&&(l=m)}return l}function y(p,g){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const m=p[u];g(m,l)>=0&&(l=m)}return l}function w(p,g){return E(p,(l,u)=>-g(l,u))}function h(p,g){if(p.length===0)return-1;let l=0;for(let u=1;u<p.length;u++){const m=p[u];g(m,p[l])>0&&(l=u)}return l}function c(p,g){for(const l of p){const u=g(l);if(u!==void 0)return u}}}),define(ae[126],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=D,e.$L=N,e.$M=j,e.$N=A;function D(O,I){const C=Object.create(null);for(const f of O){const E=I(f);let y=C[E];y||(y=C[E]=[]),y.push(f)}return C}function N(O,I){const C=[],f=[];for(const E of O)I.has(E)||C.push(E);for(const E of I)O.has(E)||f.push(E);return{removed:C,added:f}}function j(O,I){const C=[],f=[];for(const[E,y]of O)I.has(E)||C.push(y);for(const[E,y]of I)O.has(E)||f.push(y);return{removed:C,added:f}}function A(O,I){const C=new Set;for(const f of I)O.has(f)&&C.add(f);return C}}),define(ae[84],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=N,e.$2h=j,e.$3h=A;function D(O){return(I,C,f)=>{let E=null,y=null;if(typeof f.value=="function"?(E="value",y=f.value):typeof f.get=="function"&&(E="get",y=f.get),!y)throw new Error("not supported");f[E]=O(y,C)}}function N(O,I,C){let f=null,E=null;if(typeof C.value=="function"?(f="value",E=C.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(f="get",E=C.get),!E)throw new Error("not supported");const y=`$memoize$${I}`;C[f]=function(...w){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,w)}),this[y]}}function j(O,I,C){return D((f,E)=>{const y=`$debounce$${E}`,w=`$debounce$result$${E}`;return function(...h){this[w]||(this[w]=C?C():void 0),clearTimeout(this[y]),I&&(this[w]=I(this[w],...h),h=[this[w]]),this[y]=setTimeout(()=>{f.apply(this,h),this[w]=C?C():void 0},O)}})}function A(O,I,C){return D((f,E)=>{const y=`$throttle$timer$${E}`,w=`$throttle$result$${E}`,h=`$throttle$lastRun$${E}`,c=`$throttle$pending$${E}`;return function(...p){if(this[w]||(this[w]=C?C():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),I&&(this[w]=I(this[w],...p)),this[c])return;const g=this[h]+O;g<=Date.now()?(this[h]=Date.now(),f.apply(this,[this[w]]),this[w]=C?C():void 0):(this[c]=!0,this[y]=setTimeout(()=>{this[c]=!1,this[h]=Date.now(),f.apply(this,[this[w]]),this[w]=C?C():void 0},g-Date.now()))}})}}),define(ae[7],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=j,e.$1=A,e.$2=O,e.$3=I,e.$4=f,e.$6=y,e.$7=w,e.$8=h,e.$0=p;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?m.isErrorNoTelemetry(t)?new m(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function N($){e.$X.setUnexpectedErrorHandler($)}function j($){if(!$||typeof $!="object")return!1;const t=$;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A($){f($)||e.$X.onUnexpectedError($)}function O($){f($)||e.$X.onUnexpectedExternalError($)}function I($){if($ instanceof Error){const{name:t,message:r}=$,n=$.stacktrace||$.stack;return{$isError:!0,name:t,message:r,stack:n,noTelemetry:m.isErrorNoTelemetry($)}}return $}const C="Canceled";function f($){return $ instanceof E?!0:$ instanceof Error&&$.name===C&&$.message===C}class E extends Error{constructor(){super(C),this.name=this.message}}e.$5=E;function y(){const $=new Error(C);return $.name=$.message,$}function w($){return $?new Error(`Illegal argument: ${$}`):new Error("Illegal argument")}function h($){return $?new Error(`Illegal state: ${$}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=c;function p($){return $?$.message?$.message:$.stack?$.stack.split(`
`)[0]:String($):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class l extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=l;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class m extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof m)return t;const r=new m;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=m;class d extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$cb=d}),define(ae[17],ce([0,1,7,125]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=j,e.$tb=A,e.$ub=O,e.$vb=I,e.$wb=C,e.$xb=f,e.$yb=E,e.$zb=y,e.$Ab=w,e.$Bb=h,e.$Cb=c,e.$Db=p,e.$Eb=g,e.top=l,e.$Gb=u,e.$Hb=d,e.$Ib=$,e.$Jb=t,e.$Kb=r,e.$Lb=n,e.$Mb=s,e.$Nb=i,e.$Ob=o,e.$Pb=a,e.$Qb=b,e.$Rb=k,e.$Sb=v,e.$Tb=S,e.$Ub=P,e.$Vb=R,e.$Wb=M,e.$Xb=F,e.$Yb=q,e.$Zb=Y,e.$1b=H,e.$2b=X,e.$3b=W,e.$4b=J,e.$5b=G,e.$6b=B,e.$7b=he,e.$8b=te,e.$$b=L;function j(K,ee=0){return K[K.length-(1+ee)]}function A(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}function O(K,ee,_=(Z,se)=>Z===se){if(K===ee)return!0;if(!K||!ee||K.length!==ee.length)return!1;for(let Z=0,se=K.length;Z<se;Z++)if(!_(K[Z],ee[Z]))return!1;return!0}function I(K,ee){const _=K.length-1;ee<_&&(K[ee]=K[_]),K.pop()}function C(K,ee,_){return f(K.length,Z=>_(K[Z],ee))}function f(K,ee){let _=0,Z=K-1;for(;_<=Z;){const se=(_+Z)/2|0,ue=ee(se);if(ue<0)_=se+1;else if(ue>0)Z=se-1;else return se}return-(_+1)}function E(K,ee,_){if(K=K|0,K>=ee.length)throw new TypeError("invalid index");const Z=ee[Math.floor(ee.length*Math.random())],se=[],ue=[],ge=[];for(const fe of ee){const $e=_(fe,Z);$e<0?se.push(fe):$e>0?ue.push(fe):ge.push(fe)}return K<se.length?E(K,se,_):K<se.length+ge.length?ge[0]:E(K-(se.length+ge.length),ue,_)}function y(K,ee){const _=[];let Z;for(const se of K.slice(0).sort(ee))!Z||ee(Z[0],se)!==0?(Z=[se],_.push(Z)):Z.push(se);return _}function*w(K,ee){let _,Z;for(const se of K)Z!==void 0&&ee(Z,se)?_.push(se):(_&&(yield _),_=[se]),Z=se;_&&(yield _)}function h(K,ee){for(let _=0;_<=K.length;_++)ee(_===0?void 0:K[_-1],_===K.length?void 0:K[_])}function c(K,ee){for(let _=0;_<K.length;_++)ee(_===0?void 0:K[_-1],K[_],_+1===K.length?void 0:K[_+1])}function p(K,ee,_){const Z=[];function se(fe,$e,ye){if($e===0&&ye.length===0)return;const ve=Z[Z.length-1];ve&&ve.start+ve.deleteCount===fe?(ve.deleteCount+=$e,ve.toInsert.push(...ye)):Z.push({start:fe,deleteCount:$e,toInsert:ye})}let ue=0,ge=0;for(;;){if(ue===K.length){se(ue,0,ee.slice(ge));break}if(ge===ee.length){se(ue,K.length-ue,[]);break}const fe=K[ue],$e=ee[ge],ye=_(fe,$e);ye===0?(ue+=1,ge+=1):ye<0?(se(ue,1,[]),ue+=1):ye>0&&(se(ue,0,[$e]),ge+=1)}return Z}function g(K,ee,_){const Z=p(K,ee,_),se=[],ue=[];for(const ge of Z)se.push(...K.slice(ge.start,ge.start+ge.deleteCount)),ue.push(...ge.toInsert);return{removed:se,added:ue}}function l(K,ee,_){if(_===0)return[];const Z=K.slice(0,_).sort(ee);return m(K,ee,Z,_,K.length),Z}function u(K,ee,_,Z,se){return _===0?Promise.resolve([]):new Promise((ue,ge)=>{(async()=>{const fe=K.length,$e=K.slice(0,_).sort(ee);for(let ye=_,ve=Math.min(_+Z,fe);ye<fe;ye=ve,ve=Math.min(ve+Z,fe)){if(ye>_&&await new Promise(Ce=>setTimeout(Ce)),se&&se.isCancellationRequested)throw new D.$5;m(K,ee,$e,ye,ve)}return $e})().then(ue,ge)})}function m(K,ee,_,Z,se){for(const ue=_.length;Z<se;Z++){const ge=K[Z];if(ee(ge,_[ue-1])<0){_.pop();const fe=(0,N.$kb)(_,$e=>ee(ge,$e)<0);_.splice(fe,0,ge)}}}function d(K){return K.filter(ee=>!!ee)}function $(K){let ee=0;for(let _=0;_<K.length;_++)K[_]&&(K[ee]=K[_],ee+=1);K.length=ee}function t(K,ee,_){K.splice(_,0,K.splice(ee,1)[0])}function r(K){return!Array.isArray(K)||K.length===0}function n(K){return Array.isArray(K)&&K.length>0}function s(K,ee=_=>_){const _=new Set;return K.filter(Z=>{const se=ee(Z);return _.has(se)?!1:(_.add(se),!0)})}function i(K){const ee=new Set;return _=>{const Z=K(_);return ee.has(Z)?!1:(ee.add(Z),!0)}}function o(K,ee){return K.length>0?K[0]:ee}function a(K,ee){return K.length>0?K[K.length-1]:ee}function b(K,ee,_=(Z,se)=>Z===se){let Z=0;for(let se=0,ue=Math.min(K.length,ee.length);se<ue&&_(K[se],ee[se]);se++)Z++;return Z}function k(K){return[].concat(...K)}function v(K,ee){let _=typeof ee=="number"?K:0;typeof ee=="number"?_=K:(_=0,ee=K);const Z=[];if(_<=ee)for(let se=_;se<ee;se++)Z.push(se);else for(let se=_;se>ee;se--)Z.push(se);return Z}function S(K,ee,_){return K.reduce((Z,se)=>(Z[ee(se)]=_?_(se):se,Z),Object.create(null))}function P(K,ee){return K.push(ee),()=>R(K,ee)}function R(K,ee){const _=K.indexOf(ee);if(_>-1)return K.splice(_,1),ee}function M(K,ee,_){const Z=K.slice(0,ee),se=K.slice(ee);return Z.concat(_,se)}function F(K,ee){let _;if(typeof ee=="number"){let Z=ee;_=()=>{const se=Math.sin(Z++)*179426549;return se-Math.floor(se)}}else _=Math.random;for(let Z=K.length-1;Z>0;Z-=1){const se=Math.floor(_()*(Z+1)),ue=K[Z];K[Z]=K[se],K[se]=ue}}function q(K,ee){const _=K.indexOf(ee);_>-1&&(K.splice(_,1),K.unshift(ee))}function Y(K,ee){const _=K.indexOf(ee);_>-1&&(K.splice(_,1),K.push(ee))}function H(K,ee){for(const _ of ee)K.push(_)}function X(K,ee){return Array.isArray(K)?K.map(ee):ee(K)}function W(K){return Array.isArray(K)?K:[K]}function J(K){return K[Math.floor(Math.random()*K.length)]}function G(K,ee,_){const Z=ie(K,ee),se=K.length,ue=_.length;K.length=se+ue;for(let ge=se-1;ge>=Z;ge--)K[ge+ue]=K[ge];for(let ge=0;ge<ue;ge++)K[ge+Z]=_[ge]}function B(K,ee,_,Z){const se=ie(K,ee);let ue=K.splice(se,_);return ue===void 0&&(ue=[]),G(K,se,Z),ue}function ie(K,ee){return ee<0?Math.max(ee+K.length,0):Math.min(ee,K.length)}var re;(function(K){function ee(ue){return ue<0}K.isLessThan=ee;function _(ue){return ue<=0}K.isLessThanOrEqual=_;function Z(ue){return ue>0}K.isGreaterThan=Z;function se(ue){return ue===0}K.isNeitherLessOrGreaterThan=se,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function he(K,ee){return(_,Z)=>ee(K(_),K(Z))}function te(...K){return(ee,_)=>{for(const Z of K){const se=Z(ee,_);if(!re.isNeitherLessOrGreaterThan(se))return se}return re.neitherLessOrGreaterThan}}const V=(K,ee)=>K-ee;e.$9b=V;const z=(K,ee)=>(0,e.$9b)(K?1:0,ee?1:0);e.$0b=z;function L(K){return(ee,_)=>-K(ee,_)}class T{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let _=this.c;for(;_<this.g.length&&ee(this.g[_]);)_++;const Z=_===this.c?null:this.g.slice(this.c,_);return this.c=_,Z}takeFromEndWhile(ee){let _=this.d;for(;_>=0&&ee(this.g[_]);)_--;const Z=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,Z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const _=this.g.slice(this.c,this.c+ee);return this.c+=ee,_}}e.$_b=T;class U{static{this.empty=new U(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(_=>(ee(_),!0))}toArray(){const ee=[];return this.iterate(_=>(ee.push(_),!0)),ee}filter(ee){return new U(_=>this.iterate(Z=>ee(Z)?_(Z):!0))}map(ee){return new U(_=>this.iterate(Z=>_(ee(Z))))}some(ee){let _=!1;return this.iterate(Z=>(_=ee(Z),!_)),_}findFirst(ee){let _;return this.iterate(Z=>ee(Z)?(_=Z,!1):!0),_}findLast(ee){let _;return this.iterate(Z=>(ee(Z)&&(_=Z),!0)),_}findLastMaxBy(ee){let _,Z=!0;return this.iterate(se=>((Z||re.isGreaterThan(ee(se,_)))&&(Z=!1,_=se),!0)),_}}e.$ac=U;class x{constructor(ee){this.c=ee}static createSortPermutation(ee,_){const Z=Array.from(ee.keys()).sort((se,ue)=>_(ee[se],ee[ue]));return new x(Z)}apply(ee){return ee.map((_,Z)=>ee[this.c[Z]])}inverse(){const ee=this.c.slice();for(let _=0;_<this.c.length;_++)ee[this.c[_]]=_;return new x(ee)}}e.$bc=x}),define(ae[127],ce([0,1,7]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$fd=j,e.$gd=A,e.$hd=O,e.$id=I,e.$jd=C;function N(f,E){if(!f)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function j(f,E="Unreachable"){throw new Error(E)}function A(f){if(!f)throw new D.$cb("Assertion Failed")}function O(f){f||(0,D.$1)(new D.$cb("Soft Assertion Failed"))}function I(f){if(!f()){debugger;f(),(0,D.$1)(new D.$cb("Assertion Failed"))}}function C(f,E){let y=0;for(;y<f.length-1;){const w=f[y],h=f[y+1];if(!E(w,h))return!1;y++}return!0}}),define(ae[85],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=D;function D(N,j){const A=this;let O=!1,I;return function(){if(O)return I;if(O=!0,j)try{I=N.apply(A,arguments)}finally{j()}else I=N.apply(A,arguments);return I}}}),define(ae[61],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function j(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=j;const A=Object.freeze([]);function O(){return A}N.empty=O;function*I(t){yield t}N.single=I;function C(t){return j(t)?t:I(t)}N.wrap=C;function f(t){return t||A}N.from=f;function*E(t){for(let r=t.length-1;r>=0;r--)yield t[r]}N.reverse=E;function y(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=y;function w(t){return t[Symbol.iterator]().next().value}N.first=w;function h(t,r){for(const n of t)if(r(n))return!0;return!1}N.some=h;function c(t,r){for(const n of t)if(r(n))return n}N.find=c;function*p(t,r){for(const n of t)r(n)&&(yield n)}N.filter=p;function*g(t,r){let n=0;for(const s of t)yield r(s,n++)}N.map=g;function*l(...t){for(const r of t)yield*r}N.concat=l;function u(t,r,n){let s=n;for(const i of t)s=r(s,i);return s}N.reduce=u;function*m(t,r,n=t.length){for(r<0&&(r+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);r<n;r++)yield t[r]}N.slice=m;function d(t,r=Number.POSITIVE_INFINITY){const n=[];if(r===0)return[n,t];const s=t[Symbol.iterator]();for(let i=0;i<r;i++){const o=s.next();if(o.done)return[n,N.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}N.consume=d;async function $(t){const r=[];for await(const n of t)r.push(n);return Promise.resolve(r)}N.asyncToArray=$})(D||(e.Iterable=D={}))}),define(ae[35],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=O,e.$In=y,e.$Jn=w,e.$Kn=h,e.$Ln=c,e.$Mn=p,e.$Nn=g,e.$On=l,e.$Pn=u,e.$Qn=m,e.$Rn=d,e.$Sn=$;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var j;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(j||(e.ParseErrorCode=j={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(t,r=!1){let n=0;const s=t.length;let i="",o=0,a=16,b=0;function k(q){let Y=0,H=0;for(;Y<q;){const X=t.charCodeAt(n);if(X>=48&&X<=57)H=H*16+X-48;else if(X>=65&&X<=70)H=H*16+X-65+10;else if(X>=97&&X<=102)H=H*16+X-97+10;else break;n++,Y++}return Y<q&&(H=-1),H}function v(q){n=q,i="",o=0,a=16,b=0}function S(){const q=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&f(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&f(t.charCodeAt(n)))for(n++;n<t.length&&f(t.charCodeAt(n));)n++;else return b=3,t.substring(q,n);let Y=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&f(t.charCodeAt(n))){for(n++;n<t.length&&f(t.charCodeAt(n));)n++;Y=n}else b=3;return t.substring(q,Y)}function P(){let q="",Y=n;for(;;){if(n>=s){q+=t.substring(Y,n),b=2;break}const H=t.charCodeAt(n);if(H===34){q+=t.substring(Y,n),n++;break}if(H===92){if(q+=t.substring(Y,n),n++,n>=s){b=2;break}switch(t.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const W=k(4);W>=0?q+=String.fromCharCode(W):b=4;break}default:b=5}Y=n;continue}if(H>=0&&H<=31)if(C(H)){q+=t.substring(Y,n),b=2;break}else b=6;n++}return q}function R(){if(i="",b=0,o=n,n>=s)return o=s,a=17;let q=t.charCodeAt(n);if(I(q)){do n++,i+=String.fromCharCode(q),q=t.charCodeAt(n);while(I(q));return a=15}if(C(q))return n++,i+=String.fromCharCode(q),q===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,i=P(),a=10;case 47:{const Y=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!C(t.charCodeAt(n));)n++;return i=t.substring(Y,n),a=12}if(t.charCodeAt(n+1)===42){n+=2;const H=s-1;let X=!1;for(;n<H;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,X=!0;break}n++}return X||(n++,b=1),i=t.substring(Y,n),a=13}return i+=String.fromCharCode(q),n++,a=16}case 45:if(i+=String.fromCharCode(q),n++,n===s||!f(t.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=S(),a=11;default:for(;n<s&&M(q);)n++,q=t.charCodeAt(n);if(o!==n){switch(i=t.substring(o,n),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(q),n++,a=16}}function M(q){if(I(q)||C(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let q;do q=R();while(q>=12&&q<=15);return q}return{setPosition:v,getPosition:()=>n,scan:r?F:R,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>b}}function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function C(t){return t===10||t===13||t===8232||t===8233}function f(t){return t>=48&&t<=57}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function y(t,r){const n=[],s=new Object;let i;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function b(k,v,S,P){o.value=k,o.offset=v,o.length=S,o.type=P,o.colonOffset=void 0,i=o}try{m(t,{onObjectBegin:(k,v)=>{if(r<=k)throw s;i=void 0,a=r>k,n.push("")},onObjectProperty:(k,v,S)=>{if(r<v||(b(k,v,S,"property"),n[n.length-1]=k,r<=v+S))throw s},onObjectEnd:(k,v)=>{if(r<=k)throw s;i=void 0,n.pop()},onArrayBegin:(k,v)=>{if(r<=k)throw s;i=void 0,n.push(0)},onArrayEnd:(k,v)=>{if(r<=k)throw s;i=void 0,n.pop()},onLiteralValue:(k,v,S)=>{if(r<v||(b(k,v,S,$(k)),r<=v+S))throw s},onSeparator:(k,v,S)=>{if(r<=v)throw s;if(k===":"&&i&&i.type==="property")i.colonOffset=v,a=!1,i=void 0;else if(k===","){const P=n[n.length-1];typeof P=="number"?n[n.length-1]=P+1:(a=!0,n[n.length-1]=""),i=void 0}}})}catch(k){if(k!==s)throw k}return{path:n,previousNode:i,isAtPropertyKey:a,matches:k=>{let v=0;for(let S=0;v<k.length&&S<n.length;S++)if(k[v]===n[S]||k[v]==="*")v++;else if(k[v]!=="**")return!1;return v===k.length}}}function w(t,r=[],n=A.DEFAULT){let s=null,i=[];const o=[];function a(k){Array.isArray(i)?i.push(k):s!==null&&(i[s]=k)}return m(t,{onObjectBegin:()=>{const k={};a(k),o.push(i),i=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{const k=[];a(k),o.push(i),i=k,s=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:a,onError:(k,v,S)=>{r.push({error:k,offset:v,length:S})}},n),i[0]}function h(t,r=[],n=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(k){s.type==="property"&&(s.length=k-s.offset,s=s.parent)}function o(k){return s.children.push(k),k}m(t,{onObjectBegin:k=>{s=o({type:"object",offset:k,length:-1,parent:s,children:[]})},onObjectProperty:(k,v,S)=>{s=o({type:"property",offset:v,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:k,offset:v,length:S,parent:s})},onObjectEnd:(k,v)=>{s.length=k+v-s.offset,s=s.parent,i(k+v)},onArrayBegin:(k,v)=>{s=o({type:"array",offset:k,length:-1,parent:s,children:[]})},onArrayEnd:(k,v)=>{s.length=k+v-s.offset,s=s.parent,i(k+v)},onLiteralValue:(k,v,S)=>{o({type:$(k),offset:v,length:S,parent:s,value:k}),i(v+S)},onSeparator:(k,v,S)=>{s.type==="property"&&(k===":"?s.colonOffset=v:k===","&&i(v))},onError:(k,v,S)=>{r.push({error:k,offset:v,length:S})}},n);const b=s.children[0];return b&&delete b.parent,b}function c(t,r){if(!t)return;let n=t;for(const s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===s){n=o.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const r=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(r[n.children[0].value]=g(s))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function l(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}function u(t,r,n=!1){if(l(t,r,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=r;i++){const o=u(s[i],r,n);if(o)return o}return t}}function m(t,r,n=A.DEFAULT){const s=O(t,!1);function i(he){return he?()=>he(s.getTokenOffset(),s.getTokenLength()):()=>!0}function o(he){return he?te=>he(te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=i(r.onObjectBegin),b=o(r.onObjectProperty),k=i(r.onObjectEnd),v=i(r.onArrayBegin),S=i(r.onArrayEnd),P=o(r.onLiteralValue),R=o(r.onSeparator),M=i(r.onComment),F=o(r.onError),q=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function H(){for(;;){const he=s.scan();switch(s.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:q||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(he){case 12:case 13:q?X(10):M();break;case 16:X(1);break;case 15:case 14:break;default:return he}}}function X(he,te=[],V=[]){if(F(he),te.length+V.length>0){let z=s.getToken();for(;z!==17;){if(te.indexOf(z)!==-1){H();break}else if(V.indexOf(z)!==-1)break;z=H()}}}function W(he){const te=s.getTokenValue();return he?P(te):b(te),H(),!0}function J(){switch(s.getToken()){case 11:{let he=0;try{he=JSON.parse(s.getTokenValue()),typeof he!="number"&&(X(2),he=0)}catch{X(2)}P(he);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return H(),!0}function G(){return s.getToken()!==10?(X(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(R(":"),H(),re()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function B(){a(),H();let he=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(he||X(4,[],[]),R(","),H(),s.getToken()===2&&Y)break}else he&&X(6,[],[]);G()||X(4,[],[2,5]),he=!0}return k(),s.getToken()!==2?X(7,[2],[]):H(),!0}function ie(){v(),H();let he=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(he||X(4,[],[]),R(","),H(),s.getToken()===4&&Y)break}else he&&X(6,[],[]);re()||X(4,[],[4,5]),he=!0}return S(),s.getToken()!==4?X(8,[4],[]):H(),!0}function re(){switch(s.getToken()){case 3:return ie();case 1:return B();case 10:return W(!0);default:return J()}}return H(),s.getToken()===17?n.allowEmptyContent?!0:(X(4,[],[]),!1):re()?(s.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}function d(t,r){const n=O(t),s=[];let i,o=0,a;do switch(a=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:o!==a&&s.push(t.substring(o,a)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),o=n.getPosition();break}while(i!==17);return s.join("")}function $(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ae[44],ce([0,1,35]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=N,e.$Un=j,e.$Vn=I,e.$Wn=C;function N(f,E,y){let w,h,c,p,g;if(E){for(p=E.offset,g=p+E.length,c=p;c>0&&!C(f,c-1);)c--;let a=g;for(;a<f.length&&!C(f,a);)a++;h=f.substring(c,a),w=O(h,y)}else h=f,w=0,c=0,p=0,g=f.length;const l=I(y,f);let u=!1,m=0,d;y.insertSpaces?d=A(" ",y.tabSize||4):d="	";const $=(0,D.$Hn)(h,!1);let t=!1;function r(){return l+A(d,w+m)}function n(){let a=$.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=$.scan();return t=a===16||$.getTokenError()!==0,a}const s=[];function i(a,b,k){!t&&b<g&&k>p&&f.substring(b,k)!==a&&s.push({offset:b,length:k-b,content:a})}let o=n();if(o!==17){const a=$.getTokenOffset()+c,b=A(d,w);i(b,c,a)}for(;o!==17;){let a=$.getTokenOffset()+$.getTokenLength()+c,b=n(),k="";for(;!u&&(b===12||b===13);){const S=$.getTokenOffset()+c;i(" ",a,S),a=$.getTokenOffset()+$.getTokenLength()+c,k=b===12?r():"",b=n()}if(b===2)o!==1&&(m--,k=r());else if(b===4)o!==3&&(m--,k=r());else{switch(o){case 3:case 1:m++,k=r();break;case 5:case 12:k=r();break;case 13:u?k=r():k=" ";break;case 6:k=" ";break;case 10:if(b===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?k=" ":b!==5&&b!==17&&(t=!0);break;case 16:t=!0;break}u&&(b===12||b===13)&&(k=r())}const v=$.getTokenOffset()+c;i(k,a,v),o=b}return s}function j(f,E){const y=JSON.stringify(f,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?y.replace(/\r\n|\r|\n/g,E.eol):y}function A(f,E){let y="";for(let w=0;w<E;w++)y+=f;return y}function O(f,E){let y=0,w=0;const h=E.tabSize||4;for(;y<f.length;){const c=f.charAt(y);if(c===" ")w++;else if(c==="	")w+=h;else break;y++}return Math.floor(w/h)}function I(f,E){for(let y=0;y<E.length;y++){const w=E.charAt(y);if(w==="\r")return y+1<E.length&&E.charAt(y+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return f&&f.eol||`
`}function C(f,E){return`\r
`.indexOf(f.charAt(E))!==-1}}),define(ae[62],ce([0,1,35,44]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=j,e.$Yn=A,e.$Zn=O,e.$1n=I,e.$2n=C;function j(f,E,y){return A(f,E,void 0,y)}function A(f,E,y,w,h){const c=E.slice(),p=[],g=(0,D.$Kn)(f,p);let l,u;for(;c.length>0&&(u=c.pop(),l=(0,D.$Ln)(g,c),l===void 0&&y!==void 0);)typeof u=="string"?y={[u]:y}:y=[y];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const m=(0,D.$Ln)(l,[u]);if(m!==void 0)if(y===void 0){if(!m.parent)throw new Error("Malformed AST");const d=l.children.indexOf(m.parent);let $,t=m.parent.offset+m.parent.length;if(d>0){const r=l.children[d-1];$=r.offset+r.length}else $=l.offset+1,l.children.length>1&&(t=l.children[1].offset);return O(f,{offset:$,length:t-$,content:""},w)}else return O(f,{offset:m.offset,length:m.length,content:JSON.stringify(y)},w);else{if(y===void 0)return[];const d=`${JSON.stringify(u)}: ${JSON.stringify(y)}`,$=h?h(l.children.map(r=>r.children[0].value)):l.children.length;let t;if($>0){const r=l.children[$-1];t={offset:r.offset+r.length,length:0,content:","+d}}else l.children.length===0?t={offset:l.offset+1,length:0,content:d}:t={offset:l.offset+1,length:0,content:d+","};return O(f,t,w)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(y!==void 0){const m=`${JSON.stringify(y)}`;let d;if(l.children.length===0||u===0)d={offset:l.offset+1,length:0,content:l.children.length===0?m:m+","};else{const $=u===-1||u>l.children.length?l.children.length:u,t=l.children[$-1];d={offset:t.offset+t.length,length:0,content:","+m}}return O(f,d,w)}else{const m=u,d=l.children[m];let $;if(l.children.length===1)$={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===m){const t=l.children[m-1],r=t.offset+t.length,n=l.offset+l.length;$={offset:r,length:n-2-r,content:""}}else $={offset:d.offset,length:l.children[m+1].offset-d.offset,content:""};return O(f,$,w)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else return y===void 0?[]:O(f,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(y)},w)}function O(f,E,y){let w=I(f,E),h=E.offset,c=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;h>0&&!(0,N.$Wn)(w,h-1);)h--;for(;c<w.length&&!(0,N.$Wn)(w,c);)c++}const p=(0,N.$Tn)(w,{offset:h,length:c-h},y);for(let l=p.length-1;l>=0;l--){const u=p[l];w=I(w,u),h=Math.min(h,u.offset),c=Math.max(c,u.offset+u.length),c+=u.content.length-u.length}const g=f.length-(w.length-c)-h;return[{offset:h,length:g,content:w.substring(h,c)}]}function I(f,E){return f.substring(0,E.offset)+E.content+f.substring(E.offset+E.length)}function C(f,E){const y=E.slice(0).sort((h,c)=>{const p=h.offset-c.offset;return p===0?h.length-c.length:p});let w=f.length;for(let h=y.length-1;h>=0;h--){const c=y[h];if(c.offset+c.length<=w)f=I(f,c);else throw new Error("Overlapping edit");w=c.offset}return f}}),define(ae[53],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(ae[86],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let A=this.a;for(;A!==D.Undefined;){const O=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=O}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const I=new D(A);if(this.a===D.Undefined)this.a=I,this.b=I;else if(O){const f=this.b;this.b=I,I.prev=f,f.next=I}else{const f=this.a;this.a=I,I.next=f,f.prev=I}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(I))}}shift(){if(this.a!==D.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==D.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===D.Undefined&&A.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):A.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):A.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.$6c=N}),define(ae[34],ce([0,1]),function(ne,e){"use strict";var D,N,j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=A,e.$zc=O,e.$Ac=I,e.$Jc=d;function A($,t,r){let n=$.get(t);return n===void 0&&(n=r,$.set(t,n)),n}function O($){const t=[];return $.forEach((r,n)=>{t.push(`${n} => ${r}`)}),`Map(${$.size}) {${t.join(", ")}}`}function I($){const t=[];return $.forEach(r=>{t.push(r)}),`Set(${$.size}) {${t.join(", ")}}`}class C{constructor(t,r){this.uri=t,this.value=r}}function f($){return Array.isArray($)}class E{static{this.c=t=>t.toString()}constructor(t,r){if(this[D]="ResourceMap",t instanceof E)this.d=new Map(t.d),this.e=r??E.c;else if(f(t)){this.d=new Map,this.e=r??E.c;for(const[n,s]of t)this.set(n,s)}else this.d=new Map,this.e=t??E.c}set(t,r){return this.d.set(this.e(t),new C(t,r)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[n,s]of this.d)t(s.value,s.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=E;class y{constructor(t,r){this[N]="ResourceSet",!t||typeof t=="function"?this.c=new E(t):(this.c=new E(r),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,r){this.c.forEach((n,s)=>t.call(r,s,s,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var w;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class h{constructor(){this[j]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,r=0){const n=this.c.get(t);if(n)return r!==0&&this.m(n,r),n.value}set(t,r,n=0){let s=this.c.get(t);if(s)s.value=r,n!==0&&this.m(s,n);else{switch(s={key:t,value:r,next:void 0,previous:void 0},n){case 0:this.k(s);break;case 1:this.j(s);break;case 2:this.k(s);break;default:this.k(s);break}this.c.set(t,s),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.c.get(t);if(r)return this.c.delete(t),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,r){const n=this.g;let s=this.d;for(;s;){if(r?t.bind(r)(s.value,s.key,this):t(s.value,s.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.key,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}values(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.value,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}entries(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:[n.key,n.value],done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.d,n=this.size;for(;r&&n>t;)this.c.delete(r.key),r=r.next,n--;this.d=r,this.f=n,r&&(r.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.e,n=this.size;for(;r&&n>t;)this.c.delete(r.key),r=r.previous,n--;this.e=r,this.f=n,r&&(r.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const r=t.next,n=t.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}t.next=void 0,t.previous=void 0,this.g++}m(t,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.d)return;const n=t.next,s=t.previous;t===this.e?(s.next=void 0,this.e=s):(n.previous=s,s.next=n),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(r===2){if(t===this.e)return;const n=t.next,s=t.previous;t===this.d?(n.previous=void 0,this.d=n):(n.previous=s,s.next=n),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((r,n)=>{t.push([n,r])}),t}fromJSON(t){this.clear();for(const[r,n]of t)this.set(r,n)}}e.$Dc=h;class c extends h{constructor(t,r=1){super(),this.n=t,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class p extends c{constructor(t,r=1){super(t,r)}q(t){this.h(t)}set(t,r){return super.set(t,r),this.p(),this}}e.$Ec=p;class g extends c{constructor(t,r=1){super(t,r)}q(t){this.i(t)}set(t,r){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,r),this}}e.$Fc=g;class l{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let r=this.c.get(t)||0;return r===0?!1:(r--,r===0?this.c.delete(t):this.c.set(t,r),!0)}has(t){return this.c.has(t)}}e.$Gc=l;class u{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[r,n]of t)this.set(r,n)}clear(){this.c.clear(),this.d.clear()}set(t,r){this.c.set(t,r),this.d.set(r,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const r=this.c.get(t);return r===void 0?!1:(this.c.delete(t),this.d.delete(r),!0)}forEach(t,r){this.c.forEach((n,s)=>{t.call(r,n,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=u;class m{constructor(){this.c=new Map}add(t,r){let n=this.c.get(t);n||(n=new Set,this.c.set(t,n)),n.add(r)}delete(t,r){const n=this.c.get(t);n&&(n.delete(r),n.size===0&&this.c.delete(t))}forEach(t,r){const n=this.c.get(t);n&&n.forEach(r)}get(t){const r=this.c.get(t);return r||new Set}}e.$Ic=m;function d($,t){if($===t)return!0;if($.size!==t.size)return!1;for(const[r,n]of $)if(!t.has(r)||t.get(r)!==n)return!1;for(const[r]of t)if(!$.has(r))return!1;return!0}}),define(ae[2],ce([0,1,17,126,34,85,61]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=E,e.$Mc=y,e.$Nc=w,e.$Oc=p,e.$Pc=g,e.$Qc=l,e.$Rc=u,e.$Sc=m,e.$Tc=d,e.$4c=k;const I=!1;let C=null;class f{constructor(){this.b=new Map}static{this.a=0}c(P){let R=this.b.get(P);return R||(R={parent:null,source:null,isSingleton:!1,value:P,idx:f.a++},this.b.set(P,R)),R}trackDisposable(P){const R=this.c(P);R.source||(R.source=new Error().stack)}setParent(P,R){const M=this.c(P);M.parent=R}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,R){const M=R.get(P);if(M)return M;const F=P.parent?this.f(this.c(P.parent),R):P;return R.set(P,F),F}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,P).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(P=10,R){let M;if(R)M=R;else{const X=new Map,W=[...this.b.values()].filter(G=>G.source!==null&&!this.f(G,X).isSingleton);if(W.length===0)return;const J=new Set(W.map(G=>G.value));if(M=W.filter(G=>!(G.parent&&J.has(G.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function F(X){function W(G,B){for(;G.length>0&&B.some(ie=>typeof ie=="string"?ie===G[0]:G[0].match(ie));)G.shift()}const J=X.source.split(`
`).map(G=>G.trim().replace("at ","")).filter(G=>G!=="");return W(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const q=new j.$Ic;for(const X of M){const W=F(X);for(let J=0;J<=W.length;J++)q.add(W.slice(0,J).join(`
`),X)}M.sort((0,D.$7b)(X=>X.idx,D.$9b));let Y="",H=0;for(const X of M.slice(0,P)){H++;const W=F(X),J=[];for(let G=0;G<W.length;G++){let B=W[G];B=`(shared with ${q.get(W.slice(0,G+1).join(`
`)).size}/${M.length} leaks) at ${B}`;const re=q.get(W.slice(0,G).join(`
`)),he=(0,N.$K)([...re].map(te=>F(te)[G]),te=>te);delete he[W[G]];for(const[te,V]of Object.entries(he))J.unshift(`    - stacktraces of ${V.length} other leaks continue with ${te}`);J.unshift(B)}Y+=`


==================== Leaking disposable ${H}/${M.length}: ${X.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return M.length>P&&(Y+=`


... and ${M.length-P} more leaking disposables

`),{leaks:M,details:Y}}}e.$Kc=f;function E(S){C=S}if(I){const S="__is_disposable_tracked__";E(new class{trackDisposable(P){const R=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[S]||console.log(R)},3e3)}setParent(P,R){if(P&&P!==t.None)try{P[S]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[S]=!0}catch{}}markAsSingleton(P){}})}function y(S){return C?.trackDisposable(S),S}function w(S){C?.markAsDisposed(S)}function h(S,P){C?.setParent(S,P)}function c(S,P){if(C)for(const R of S)C.setParent(R,P)}function p(S){return C?.markAsSingleton(S),S}function g(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function l(S){if(O.Iterable.is(S)){const P=[];for(const R of S)if(R)try{R.dispose()}catch(M){P.push(M)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function u(S){for(const P of S)g(P)&&P.dispose();return[]}function m(...S){const P=d(()=>l(S));return c(S,P),P}function d(S){const P=y({dispose:(0,A.$db)(()=>{w(P),S()})});return P}class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return h(P,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),h(P,null))}}e.$Uc=$;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,y(this),h(this.q,this)}dispose(){w(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Vc=t;class r{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&h(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&h(P,null),P}}e.$Wc=r;class n{constructor(P){this.a=new r,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=n;class s{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(P){let R=P;return this.unset=()=>R=void 0,this.isset=()=>R!==void 0,this.dispose=()=>{R&&(R(),R=void 0,w(this))},this}}e.$Zc=i;class o{constructor(){this.a=new Map}acquire(P,...R){let M=this.a.get(P);M||(M={counter:0,object:this.b(P,...R)},this.a.set(P,M));const{object:F}=M,q=(0,A.$db)(()=>{--M.counter===0&&(this.c(P,M.object),this.a.delete(P))});return M.counter++,{object:F,dispose:q}}}e.$1c=o;class a{constructor(P){this.a=P}async acquire(P,...R){const M=this.a.acquire(P,...R);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(F){throw M.dispose(),F}}}e.$2c=a;class b{constructor(P){this.object=P}dispose(){}}e.$3c=b;function k(S){const P=new $;try{S(P)}finally{P.dispose()}}class v{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,R,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(P)?.dispose(),this.a.set(P,R)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=v}),define(ae[87],ce([0,1,34]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0,e.$bm=j,e.$cm=O;const N=new D.$Ec(1e4);function j(f){return C(f,"NFC",N)}const A=new D.$Ec(1e4);function O(f){return C(f,"NFD",A)}const I=/[^\u0000-\u0080]/;function C(f,E,y){if(!f)return f;const w=y.get(f);if(w)return w;let h;return I.test(f)?h=f.normalize(E):h=f,y.set(f,h),h}e.$dm=function(){const f=/[\u0300-\u036f]/g;return function(E){return O(E).replace(f,"")}}()}),function(){function ne(j){const A=[];typeof j=="number"&&A.push("code/timeOrigin",j);function O(C){A.push(C,Date.now())}function I(){const C=[];for(let f=0;f<A.length;f+=2)C.push({name:A[f],startTime:A[f+1]});return C}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(j){performance.mark(j)},getMarks(){let j=performance.timeOrigin;typeof j!="number"&&(j=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(j)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(j+O.startTime)});return A}};if(typeof process=="object"){const j=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(j)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function D(j){return j.MonacoPerformanceMarks||(j.MonacoPerformanceMarks=e()),j.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:ne)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function D(N){if(e[N])return e[N].exports;var j=e[N]={i:N,l:!1,exports:{}};return ne[N].call(j.exports,j,j.exports,D),j.l=!0,j.exports}return D.m=ne,D.c=e,D.d=function(N,j,A){D.o(N,j)||Object.defineProperty(N,j,{enumerable:!0,get:A})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,j){if(1&j&&(N=D(N)),8&j||4&j&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&j&&typeof N!="string")for(var O in N)D.d(A,O,function(I){return N[I]}.bind(null,O));return A},D.n=function(N){var j=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(j,"a",j),j},D.o=function(N,j){return Object.prototype.hasOwnProperty.call(N,j)},D.p="",D(D.s=0)}([function(ne,e,D){(function(N){var j;e=ne.exports=V,j=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],C=e.src=[],f=0,E=f++;C[E]="0|[1-9]\\d*";var y=f++;C[y]="[0-9]+";var w=f++;C[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=f++;C[h]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var c=f++;C[c]="("+C[y]+")\\.("+C[y]+")\\.("+C[y]+")";var p=f++;C[p]="(?:"+C[E]+"|"+C[w]+")";var g=f++;C[g]="(?:"+C[y]+"|"+C[w]+")";var l=f++;C[l]="(?:-("+C[p]+"(?:\\."+C[p]+")*))";var u=f++;C[u]="(?:-?("+C[g]+"(?:\\."+C[g]+")*))";var m=f++;C[m]="[0-9A-Za-z-]+";var d=f++;C[d]="(?:\\+("+C[m]+"(?:\\."+C[m]+")*))";var $=f++,t="v?"+C[h]+C[l]+"?"+C[d]+"?";C[$]="^"+t+"$";var r="[v=\\s]*"+C[c]+C[u]+"?"+C[d]+"?",n=f++;C[n]="^"+r+"$";var s=f++;C[s]="((?:<|>)?=?)";var i=f++;C[i]=C[y]+"|x|X|\\*";var o=f++;C[o]=C[E]+"|x|X|\\*";var a=f++;C[a]="[v=\\s]*("+C[o]+")(?:\\.("+C[o]+")(?:\\.("+C[o]+")(?:"+C[l]+")?"+C[d]+"?)?)?";var b=f++;C[b]="[v=\\s]*("+C[i]+")(?:\\.("+C[i]+")(?:\\.("+C[i]+")(?:"+C[u]+")?"+C[d]+"?)?)?";var k=f++;C[k]="^"+C[s]+"\\s*"+C[a]+"$";var v=f++;C[v]="^"+C[s]+"\\s*"+C[b]+"$";var S=f++;C[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=f++;C[P]="(?:~>?)";var R=f++;C[R]="(\\s*)"+C[P]+"\\s+",I[R]=new RegExp(C[R],"g");var M=f++;C[M]="^"+C[P]+C[a]+"$";var F=f++;C[F]="^"+C[P]+C[b]+"$";var q=f++;C[q]="(?:\\^)";var Y=f++;C[Y]="(\\s*)"+C[q]+"\\s+",I[Y]=new RegExp(C[Y],"g");var H=f++;C[H]="^"+C[q]+C[a]+"$";var X=f++;C[X]="^"+C[q]+C[b]+"$";var W=f++;C[W]="^"+C[s]+"\\s*("+r+")$|^$";var J=f++;C[J]="^"+C[s]+"\\s*("+t+")$|^$";var G=f++;C[G]="(\\s*)"+C[s]+"\\s*("+r+"|"+C[a]+")",I[G]=new RegExp(C[G],"g");var B=f++;C[B]="^\\s*("+C[a]+")\\s+-\\s+("+C[a]+")\\s*$";var ie=f++;C[ie]="^\\s*("+C[b]+")\\s+-\\s+("+C[b]+")\\s*$";var re=f++;C[re]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)j(he,C[he]),I[he]||(I[he]=new RegExp(C[he]));function te(le,me){if(le instanceof V)return le;if(typeof le!="string"||le.length>A||!(me?I[n]:I[$]).test(le))return null;try{return new V(le,me)}catch{return null}}function V(le,me){if(le instanceof V){if(le.loose===me)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof V))return new V(le,me);j("SemVer",le,me),this.loose=me;var we=le.trim().match(me?I[n]:I[$]);if(!we)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<O)return Re}return Pe}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=te,e.valid=function(le,me){var we=te(le,me);return we?we.version:null},e.clean=function(le,me){var we=te(le.trim().replace(/^[=v]+/,""),me);return we?we.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(le){return j("SemVer.compare",this.version,this.loose,le),le instanceof V||(le=new V(le,this.loose)),this.compareMain(le)||this.comparePre(le)},V.prototype.compareMain=function(le){return le instanceof V||(le=new V(le,this.loose)),L(this.major,le.major)||L(this.minor,le.minor)||L(this.patch,le.patch)},V.prototype.comparePre=function(le){if(le instanceof V||(le=new V(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var me=0;do{var we=this.prerelease[me],Pe=le.prerelease[me];if(j("prerelease compare",me,we,Pe),we===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(we===void 0)return-1;if(we!==Pe)return L(we,Pe)}while(++me)},V.prototype.inc=function(le,me){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",me);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",me);break;case"prepatch":this.prerelease.length=0,this.inc("patch",me),this.inc("pre",me);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",me),this.inc("pre",me);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}me&&(this.prerelease[0]===me?isNaN(this.prerelease[1])&&(this.prerelease=[me,0]):this.prerelease=[me,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,me,we,Pe){typeof we=="string"&&(Pe=we,we=void 0);try{return new V(le,we).inc(me,Pe).version}catch{return null}},e.diff=function(le,me){if(K(le,me))return null;var we=te(le),Pe=te(me);if(we.prerelease.length||Pe.prerelease.length){for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Pe[Re])return Re},e.compareIdentifiers=L;var z=/^[0-9]+$/;function L(le,me){var we=z.test(le),Pe=z.test(me);return we&&Pe&&(le=+le,me=+me),we&&!Pe?-1:Pe&&!we?1:le<me?-1:le>me?1:0}function T(le,me,we){return new V(le,we).compare(new V(me,we))}function U(le,me,we){return T(le,me,we)>0}function x(le,me,we){return T(le,me,we)<0}function K(le,me,we){return T(le,me,we)===0}function ee(le,me,we){return T(le,me,we)!==0}function _(le,me,we){return T(le,me,we)>=0}function Z(le,me,we){return T(le,me,we)<=0}function se(le,me,we,Pe){var Re;switch(me){case"===":typeof le=="object"&&(le=le.version),typeof we=="object"&&(we=we.version),Re=le===we;break;case"!==":typeof le=="object"&&(le=le.version),typeof we=="object"&&(we=we.version),Re=le!==we;break;case"":case"=":case"==":Re=K(le,we,Pe);break;case"!=":Re=ee(le,we,Pe);break;case">":Re=U(le,we,Pe);break;case">=":Re=_(le,we,Pe);break;case"<":Re=x(le,we,Pe);break;case"<=":Re=Z(le,we,Pe);break;default:throw new TypeError("Invalid operator: "+me)}return Re}function ue(le,me){if(le instanceof ue){if(le.loose===me)return le;le=le.value}if(!(this instanceof ue))return new ue(le,me);j("comparator",le,me),this.loose=me,this.parse(le),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,j("comp",this)}e.rcompareIdentifiers=function(le,me){return L(me,le)},e.major=function(le,me){return new V(le,me).major},e.minor=function(le,me){return new V(le,me).minor},e.patch=function(le,me){return new V(le,me).patch},e.compare=T,e.compareLoose=function(le,me){return T(le,me,!0)},e.rcompare=function(le,me,we){return T(me,le,we)},e.sort=function(le,me){return le.sort(function(we,Pe){return e.compare(we,Pe,me)})},e.rsort=function(le,me){return le.sort(function(we,Pe){return e.rcompare(we,Pe,me)})},e.gt=U,e.lt=x,e.eq=K,e.neq=ee,e.gte=_,e.lte=Z,e.cmp=se,e.Comparator=ue;var ge={};function fe(le,me){if(le instanceof fe)return le.loose===me?le:new fe(le.raw,me);if(le instanceof ue)return new fe(le.value,me);if(!(this instanceof fe))return new fe(le,me);if(this.loose=me,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function $e(le){return!le||le.toLowerCase()==="x"||le==="*"}function ye(le,me,we,Pe,Re,Me,Le,qe,Te,Ue,ze,Ae,oe){return((me=$e(we)?"":$e(Pe)?">="+we+".0.0":$e(Re)?">="+we+"."+Pe+".0":">="+me)+" "+(qe=$e(Te)?"":$e(Ue)?"<"+(+Te+1)+".0.0":$e(ze)?"<"+Te+"."+(+Ue+1)+".0":Ae?"<="+Te+"."+Ue+"."+ze+"-"+Ae:"<="+qe)).trim()}function ve(le,me){for(var we=0;we<le.length;we++)if(!le[we].test(me))return!1;if(me.prerelease.length){for(we=0;we<le.length;we++)if(j(le[we].semver),le[we].semver!==ge&&le[we].semver.prerelease.length>0){var Pe=le[we].semver;if(Pe.major===me.major&&Pe.minor===me.minor&&Pe.patch===me.patch)return!0}return!1}return!0}function Ce(le,me,we){try{me=new fe(me,we)}catch{return!1}return me.test(le)}function De(le,me,we,Pe){var Re,Me,Le,qe,Te;switch(le=new V(le,Pe),me=new fe(me,Pe),we){case">":Re=U,Me=Z,Le=x,qe=">",Te=">=";break;case"<":Re=x,Me=_,Le=U,qe="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(le,me,Pe))return!1;for(var Ue=0;Ue<me.set.length;++Ue){var ze=me.set[Ue],Ae=null,oe=null;if(ze.forEach(function(de){de.semver===ge&&(de=new ue(">=0.0.0")),Ae=Ae||de,oe=oe||de,Re(de.semver,Ae.semver,Pe)?Ae=de:Le(de.semver,oe.semver,Pe)&&(oe=de)}),Ae.operator===qe||Ae.operator===Te||(!oe.operator||oe.operator===qe)&&Me(le,oe.semver)||oe.operator===Te&&Le(le,oe.semver))return!1}return!0}ue.prototype.parse=function(le){var me=this.loose?I[W]:I[J],we=le.match(me);if(!we)throw new TypeError("Invalid comparator: "+le);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new V(we[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(le){return j("Comparator.test",le,this.loose),this.semver===ge||(typeof le=="string"&&(le=new V(le,this.loose)),se(le,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(le,me){if(!(le instanceof ue))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new fe(le.value,me),Ce(this.value,we,me);if(le.operator==="")return we=new fe(this.value,me),Ce(le.semver,we,me);var Pe=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Me=this.semver.version===le.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),qe=se(this.semver,"<",le.semver,me)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Te=se(this.semver,">",le.semver,me)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Pe||Re||Me&&Le||qe||Te},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(le){var me=this.loose;le=le.trim(),j("range",le,me);var we=me?I[ie]:I[B];le=le.replace(we,ye),j("hyphen replace",le),le=le.replace(I[G],"$1$2$3"),j("comparator trim",le,I[G]),le=(le=(le=le.replace(I[R],"$1~")).replace(I[Y],"$1^")).split(/\s+/).join(" ");var Pe=me?I[W]:I[J],Re=le.split(" ").map(function(Me){return function(Le,qe){return j("comp",Le),Le=function(Te,Ue){return Te.trim().split(/\s+/).map(function(ze){return function(Ae,oe){j("caret",Ae,oe);var de=oe?I[X]:I[H];return Ae.replace(de,function(pe,be,ke,Ie,Oe){var Ne;return j("caret",Ae,pe,be,ke,Ie,Oe),$e(be)?Ne="":$e(ke)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":$e(Ie)?Ne=be==="0"?">="+be+"."+ke+".0 <"+be+"."+(+ke+1)+".0":">="+be+"."+ke+".0 <"+(+be+1)+".0.0":Oe?(j("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=be==="0"?ke==="0"?">="+be+"."+ke+"."+Ie+Oe+" <"+be+"."+ke+"."+(+Ie+1):">="+be+"."+ke+"."+Ie+Oe+" <"+be+"."+(+ke+1)+".0":">="+be+"."+ke+"."+Ie+Oe+" <"+(+be+1)+".0.0"):(j("no pr"),Ne=be==="0"?ke==="0"?">="+be+"."+ke+"."+Ie+" <"+be+"."+ke+"."+(+Ie+1):">="+be+"."+ke+"."+Ie+" <"+be+"."+(+ke+1)+".0":">="+be+"."+ke+"."+Ie+" <"+(+be+1)+".0.0"),j("caret return",Ne),Ne})}(ze,Ue)}).join(" ")}(Le,qe),j("caret",Le),Le=function(Te,Ue){return Te.trim().split(/\s+/).map(function(ze){return function(Ae,oe){var de=oe?I[F]:I[M];return Ae.replace(de,function(pe,be,ke,Ie,Oe){var Ne;return j("tilde",Ae,pe,be,ke,Ie,Oe),$e(be)?Ne="":$e(ke)?Ne=">="+be+".0.0 <"+(+be+1)+".0.0":$e(Ie)?Ne=">="+be+"."+ke+".0 <"+be+"."+(+ke+1)+".0":Oe?(j("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ne=">="+be+"."+ke+"."+Ie+Oe+" <"+be+"."+(+ke+1)+".0"):Ne=">="+be+"."+ke+"."+Ie+" <"+be+"."+(+ke+1)+".0",j("tilde return",Ne),Ne})}(ze,Ue)}).join(" ")}(Le,qe),j("tildes",Le),Le=function(Te,Ue){return j("replaceXRanges",Te,Ue),Te.split(/\s+/).map(function(ze){return function(Ae,oe){Ae=Ae.trim();var de=oe?I[v]:I[k];return Ae.replace(de,function(pe,be,ke,Ie,Oe,Ne){j("xRange",Ae,pe,be,ke,Ie,Oe,Ne);var We=$e(ke),Be=We||$e(Ie),Fe=Be||$e(Oe);return be==="="&&Fe&&(be=""),We?pe=be===">"||be==="<"?"<0.0.0":"*":be&&Fe?(Be&&(Ie=0),Fe&&(Oe=0),be===">"?(be=">=",Be?(ke=+ke+1,Ie=0,Oe=0):Fe&&(Ie=+Ie+1,Oe=0)):be==="<="&&(be="<",Be?ke=+ke+1:Ie=+Ie+1),pe=be+ke+"."+Ie+"."+Oe):Be?pe=">="+ke+".0.0 <"+(+ke+1)+".0.0":Fe&&(pe=">="+ke+"."+Ie+".0 <"+ke+"."+(+Ie+1)+".0"),j("xRange return",pe),pe})}(ze,Ue)}).join(" ")}(Le,qe),j("xrange",Le),Le=function(Te,Ue){return j("replaceStars",Te,Ue),Te.trim().replace(I[re],"")}(Le,qe),j("stars",Le),Le}(Me,me)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Me){return!!Me.match(Pe)})),Re=Re.map(function(Me){return new ue(Me,me)})},fe.prototype.intersects=function(le,me){if(!(le instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Pe){return le.set.some(function(Re){return Re.every(function(Me){return Pe.intersects(Me,me)})})})})},e.toComparators=function(le,me){return new fe(le,me).set.map(function(we){return we.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new V(le,this.loose));for(var me=0;me<this.set.length;me++)if(ve(this.set[me],le))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(le,me,we){var Pe=null,Re=null;try{var Me=new fe(me,we)}catch{return null}return le.forEach(function(Le){Me.test(Le)&&(Pe&&Re.compare(Le)!==-1||(Re=new V(Pe=Le,we)))}),Pe},e.minSatisfying=function(le,me,we){var Pe=null,Re=null;try{var Me=new fe(me,we)}catch{return null}return le.forEach(function(Le){Me.test(Le)&&(Pe&&Re.compare(Le)!==1||(Re=new V(Pe=Le,we)))}),Pe},e.validRange=function(le,me){try{return new fe(le,me).range||"*"}catch{return null}},e.ltr=function(le,me,we){return De(le,me,"<",we)},e.gtr=function(le,me,we){return De(le,me,">",we)},e.outside=De,e.prerelease=function(le,me){var we=te(le,me);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(le,me,we){return le=new fe(le,we),me=new fe(me,we),le.intersects(me)},e.coerce=function(le){if(le instanceof V)return le;if(typeof le!="string")return null;var me=le.match(I[S]);return me==null?null:te((me[1]||"0")+"."+(me[2]||"0")+"."+(me[3]||"0"))}}).call(this,D(1))},function(ne,e){var D,N,j=ne.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(g){if(D===setTimeout)return setTimeout(g,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(g,0);try{return D(g,0)}catch{try{return D.call(null,g,0)}catch{return D.call(this,g,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var C,f=[],E=!1,y=-1;function w(){E&&C&&(E=!1,C.length?f=C.concat(f):y=-1,f.length&&h())}function h(){if(!E){var g=I(w);E=!0;for(var l=f.length;l;){for(C=f,f=[];++y<l;)C&&C[y].run();y=-1,l=f.length}C=null,E=!1,function(u){if(N===clearTimeout)return clearTimeout(u);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(u);try{N(u)}catch{try{return N.call(null,u)}catch{return N.call(this,u)}}}(g)}}function c(g,l){this.fun=g,this.array=l}function p(){}j.nextTick=function(g){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];f.push(new c(g,l)),f.length!==1||E||I(h)},c.prototype.run=function(){this.fun.apply(null,this.array)},j.title="browser",j.browser=!0,j.env={},j.argv=[],j.version="",j.versions={},j.on=p,j.addListener=p,j.once=p,j.off=p,j.removeListener=p,j.removeAllListeners=p,j.emit=p,j.prependListener=p,j.prependOnceListener=p,j.listeners=function(g){return[]},j.binding=function(g){throw new Error("process.binding is not supported")},j.cwd=function(){return"/"},j.chdir=function(g){throw new Error("process.chdir is not supported")},j.umask=function(){return 0}}])}),define(ae[128],ce([0,1]),function(ne,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class N{constructor(I,C,f){this.level=I,this.key=C,this.value=f,this.forward=[]}}const j=void 0;class A{constructor(I,C=2**16){this.comparator=I,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new N(this.c,j,j)}get size(){return this.f}clear(){this.e=new N(this.c,j,j),this.f=0}has(I){return!!A.g(this,I,this.comparator)}get(I){return A.g(this,I,this.comparator)?.value}set(I,C){return A.h(this,I,C,this.comparator)&&(this.f+=1),this}delete(I){const C=A.k(this,I,this.comparator);return C&&(this.f-=1),C}forEach(I,C){let f=this.e.forward[0];for(;f;)I.call(C,f.value,f.key,this),f=f.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",C=this.e.forward[0];for(;C;)I+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return I}static g(I,C,f){let E=I.e;for(let y=I.d-1;y>=0;y--)for(;E.forward[y]&&f(E.forward[y].key,C)<0;)E=E.forward[y];if(E=E.forward[0],E&&f(E.key,C)===0)return E}static h(I,C,f,E){const y=[];let w=I.e;for(let h=I.d-1;h>=0;h--){for(;w.forward[h]&&E(w.forward[h].key,C)<0;)w=w.forward[h];y[h]=w}if(w=w.forward[0],w&&E(w.key,C)===0)return w.value=f,!1;{const h=A.j(I);if(h>I.d){for(let c=I.d;c<h;c++)y[c]=I.e;I.d=h}w=new N(h,C,f);for(let c=0;c<h;c++)w.forward[c]=y[c].forward[c],y[c].forward[c]=w;return!0}}static j(I,C=.5){let f=1;for(;Math.random()<C&&f<I.c;)f+=1;return f}static k(I,C,f){const E=[];let y=I.e;for(let w=I.d-1;w>=0;w--){for(;y.forward[w]&&f(y.forward[w].key,C)<0;)y=y.forward[w];E[w]=y}if(y=y.forward[0],!y||f(y.key,C)!==0)return!1;for(let w=0;w<I.d&&E[w].forward[w]===y;w++)E[w].forward[w]=y.forward[w];for(;I.d>0&&I.e.forward[I.d-1]===j;)I.d-=1;return!0}}e.$zs=A}),define(ae[63],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=D&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ae=N}),define(ae[3],ce([0,1,7,85,2,86,63]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$ce=e.Event=void 0,e.$de=h;const I=!1,C=!1,f=!1;var E;(function(R){R.None=()=>j.$Vc.None;function M(fe){if(f){const{onDidAddListener:$e}=fe,ye=p.create();let ve=0;fe.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ye.print()),$e?.()}}}function F(fe,$e){return re(fe,()=>{},0,void 0,!0,void 0,$e)}R.defer=F;function q(fe){return($e,ye=null,ve)=>{let Ce=!1,De;return De=fe(le=>{if(!Ce)return De?De.dispose():Ce=!0,$e.call(ye,le)},null,ve),Ce&&De.dispose(),De}}R.once=q;function Y(fe,$e,ye){return B((ve,Ce=null,De)=>fe(le=>ve.call(Ce,$e(le)),null,De),ye)}R.map=Y;function H(fe,$e,ye){return B((ve,Ce=null,De)=>fe(le=>{$e(le),ve.call(Ce,le)},null,De),ye)}R.forEach=H;function X(fe,$e,ye){return B((ve,Ce=null,De)=>fe(le=>$e(le)&&ve.call(Ce,le),null,De),ye)}R.filter=X;function W(fe){return fe}R.signal=W;function J(...fe){return($e,ye=null,ve)=>{const Ce=(0,j.$Sc)(...fe.map(De=>De(le=>$e.call(ye,le))));return ie(Ce,ve)}}R.any=J;function G(fe,$e,ye,ve){let Ce=ye;return Y(fe,De=>(Ce=$e(Ce,De),Ce),ve)}R.reduce=G;function B(fe,$e){let ye;const ve={onWillAddFirstListener(){ye=fe(Ce.fire,Ce)},onDidRemoveLastListener(){ye?.dispose()}};$e||M(ve);const Ce=new $(ve);return $e?.add(Ce),Ce.event}function ie(fe,$e){return $e instanceof Array?$e.push(fe):$e&&$e.add(fe),fe}function re(fe,$e,ye=100,ve=!1,Ce=!1,De,le){let me,we,Pe,Re=0,Me;const Le={leakWarningThreshold:De,onWillAddFirstListener(){me=fe(Te=>{Re++,we=$e(we,Te),ve&&!Pe&&(qe.fire(we),we=void 0),Me=()=>{const Ue=we;we=void 0,Pe=void 0,(!ve||Re>1)&&qe.fire(Ue),Re=0},typeof ye=="number"?(clearTimeout(Pe),Pe=setTimeout(Me,ye)):Pe===void 0&&(Pe=0,queueMicrotask(Me))})},onWillRemoveListener(){Ce&&Re>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,me.dispose()}};le||M(Le);const qe=new $(Le);return le?.add(qe),qe.event}R.debounce=re;function he(fe,$e=0,ye){return R.debounce(fe,(ve,Ce)=>ve?(ve.push(Ce),ve):[Ce],$e,void 0,!0,void 0,ye)}R.accumulate=he;function te(fe,$e=(ve,Ce)=>ve===Ce,ye){let ve=!0,Ce;return X(fe,De=>{const le=ve||!$e(De,Ce);return ve=!1,Ce=De,le},ye)}R.latch=te;function V(fe,$e,ye){return[R.filter(fe,$e,ye),R.filter(fe,ve=>!$e(ve),ye)]}R.split=V;function z(fe,$e=!1,ye=[],ve){let Ce=ye.slice(),De=fe(we=>{Ce?Ce.push(we):me.fire(we)});ve&&ve.add(De);const le=()=>{Ce?.forEach(we=>me.fire(we)),Ce=null},me=new $({onWillAddFirstListener(){De||(De=fe(we=>me.fire(we)),ve&&ve.add(De))},onDidAddFirstListener(){Ce&&($e?setTimeout(le):le())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return ve&&ve.add(me),me.event}R.buffer=z;function L(fe,$e){return(ve,Ce,De)=>{const le=$e(new U);return fe(function(me){const we=le.evaluate(me);we!==T&&ve.call(Ce,we)},void 0,De)}}R.chain=L;const T=Symbol("HaltChainable");class U{constructor(){this.f=[]}map($e){return this.f.push($e),this}forEach($e){return this.f.push(ye=>($e(ye),ye)),this}filter($e){return this.f.push(ye=>$e(ye)?ye:T),this}reduce($e,ye){let ve=ye;return this.f.push(Ce=>(ve=$e(ve,Ce),ve)),this}latch($e=(ye,ve)=>ye===ve){let ye=!0,ve;return this.f.push(Ce=>{const De=ye||!$e(Ce,ve);return ye=!1,ve=Ce,De?Ce:T}),this}evaluate($e){for(const ye of this.f)if($e=ye($e),$e===T)break;return $e}}function x(fe,$e,ye=ve=>ve){const ve=(...me)=>le.fire(ye(...me)),Ce=()=>fe.on($e,ve),De=()=>fe.removeListener($e,ve),le=new $({onWillAddFirstListener:Ce,onDidRemoveLastListener:De});return le.event}R.fromNodeEventEmitter=x;function K(fe,$e,ye=ve=>ve){const ve=(...me)=>le.fire(ye(...me)),Ce=()=>fe.addEventListener($e,ve),De=()=>fe.removeEventListener($e,ve),le=new $({onWillAddFirstListener:Ce,onDidRemoveLastListener:De});return le.event}R.fromDOMEventEmitter=K;function ee(fe){return new Promise($e=>q(fe)($e))}R.toPromise=ee;function _(fe){const $e=new $;return fe.then(ye=>{$e.fire(ye)},()=>{$e.fire(void 0)}).finally(()=>{$e.dispose()}),$e.event}R.fromPromise=_;function Z(fe,$e,ye){return $e(ye),fe(ve=>$e(ve))}R.runAndSubscribe=Z;class se{constructor($e,ye){this._observable=$e,this.f=0,this.g=!1;const ve={onWillAddFirstListener:()=>{$e.addObserver(this)},onDidRemoveLastListener:()=>{$e.removeObserver(this)}};ye||M(ve),this.emitter=new $(ve),ye&&ye.add(this.emitter)}beginUpdate($e){this.f++}handlePossibleChange($e){}handleChange($e,ye){this.g=!0}endUpdate($e){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue(fe,$e){return new se(fe,$e).emitter.event}R.fromObservable=ue;function ge(fe){return($e,ye,ve)=>{let Ce=0,De=!1;const le={beginUpdate(){Ce++},endUpdate(){Ce--,Ce===0&&(fe.reportChanges(),De&&(De=!1,$e.call(ye)))},handlePossibleChange(){},handleChange(){De=!0}};fe.addObserver(le),fe.reportChanges();const me={dispose(){fe.removeObserver(le)}};return ve instanceof j.$Uc?ve.add(me):Array.isArray(ve)&&ve.push(me),me}}R.fromObservableLight=ge})(E||(e.Event=E={}));class y{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${y.f++}`,y.all.add(this)}start(M){this.g=new O.$ae,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$ce=y;let w=-1;function h(R){const M=w;return w=R,{dispose(){w=M}}}class c{constructor(M,F=Math.random().toString(18).slice(2,5)){this.threshold=M,this.name=F,this.g=0}dispose(){this.f?.clear()}check(M,F){const q=this.threshold;if(q<=0||F<q)return;this.f||(this.f=new Map);const Y=this.f.get(M.value)||0;if(this.f.set(M.value,Y+1),this.g-=1,this.g<=0){this.g=q*.5;let H,X=0;for(const[W,J]of this.f)(!H||X<J)&&(H=W,X=J);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${X}):`),console.warn(H)}return()=>{const H=this.f.get(M.value)||0;this.f.set(M.value,H-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class l{constructor(M){this.value=M,this.id=g++}}const u=2,m=(R,M)=>{if(R instanceof l)M(R);else for(let F=0;F<R.length;F++){const q=R[F];q&&M(q)}},d=I?new FinalizationRegistry(R=>{typeof R=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(R))}):void 0;class ${constructor(M){this.w=0,this.f=M,this.g=w>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(C){const M=this.t;queueMicrotask(()=>{m(M,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,F,q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),j.$Vc.None;if(this.m)return j.$Vc.None;F&&(M=M.bind(F));const Y=new l(M);let H,X;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Y.stack=p.create(),H=this.g.check(Y.stack,this.w+1)),C&&(Y.stack=X??p.create()),this.t?this.t instanceof l?(this.u??=new r,this.t=[this.t,Y]):this.t.push(Y):(this.f?.onWillAddFirstListener?.(this),this.t=Y,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,j.$Tc)(()=>{d?.unregister(W),H?.(),this.x(Y)});if(q instanceof j.$Uc?q.add(W):Array.isArray(q)&&q.push(W),d){const J=new Error().stack.split(`
`).slice(2).join(`
`).trim();d.register(W,J,W)}return W},this.q}x(M){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,q=F.indexOf(M);if(q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[q]=void 0;const Y=this.u.current===this;if(this.w*u<=F.length){let H=0;for(let X=0;X<F.length;X++)F[X]?F[H++]=F[X]:Y&&(this.u.end--,H<this.u.i&&this.u.i--);F.length=H}}y(M,F){if(!M)return;const q=this.f?.onListenerError||D.$1;if(!q){M.value(F);return}try{M.value(F)}catch(Y){q(Y)}}z(M){const F=M.current.t;for(;M.i<M.end;)this.y(F[M.i++],M.value);M.reset()}fire(M){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,M);else{const F=this.u;F.enqueue(this,M,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ee=$;const t=()=>new r;e.$fe=t;class r{constructor(){this.i=-1,this.end=0}enqueue(M,F,q){this.i=0,this.end=q,this.current=M,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends ${async fireAsync(M,F,q){if(this.t)for(this.h||(this.h=new A.$6c),m(this.t,Y=>this.h.push([Y.value,M]));this.h.size>0&&!F.isCancellationRequested;){const[Y,H]=this.h.shift(),X=[],W={...H,token:F,waitUntil:J=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");q&&(J=q(J,Y)),X.push(J)}};try{Y(W)}catch(J){(0,D.$1)(J);continue}Object.freeze(X),await Promise.allSettled(X).then(J=>{for(const G of J)G.status==="rejected"&&(0,D.$1)(G.reason)})}}}e.$ge=n;class s extends ${get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new A.$6c,this.A=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.A(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.w&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$he=s;class i extends s{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$ie=i;class o extends ${constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}e.$je=o;class a{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const F={event:M,listener:null};this.h.push(F),this.g&&this.m(F);const q=()=>{this.g&&this.o(F);const Y=this.h.indexOf(F);this.h.splice(Y,1)};return(0,j.$Tc)((0,N.$db)(q))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(F=>this.f.fire(F))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$ke=a;class b{constructor(M,F,q,Y){this.f=new j.$Uc;const H=this.f.add(new a),X=this.f.add(new j.$5c);function W(J){X.set(J,H.add(Y(J)))}for(const J of M)W(J);this.f.add(F(J=>{W(J)})),this.f.add(q(J=>{X.deleteAndDispose(J)})),this.event=H.event}dispose(){this.f.dispose()}}e.$le=b;class k{constructor(){this.f=[]}wrapEvent(M){return(F,q,Y)=>M(H=>{const X=this.f[this.f.length-1];X?X.push(()=>F.call(q,H)):F.call(q,H)},void 0,Y)}bufferEvents(M){const F=[];this.f.push(F);const q=M();return this.f.pop(),F.forEach(Y=>Y()),q}}e.$me=k;class v{constructor(){this.f=!1,this.g=E.None,this.h=j.$Vc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ne=v;class S{static const(M){return new P(M)}constructor(M){this.g=M,this.f=new $,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$oe=S;class P{constructor(M){this.value=M,this.onDidChange=E.None}}}),define(ae[26],ce([0,1,3]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.CancellationToken=void 0,e.$qe=I;const N=Object.freeze(function(C,f){const E=setTimeout(C.bind(f),0);return{dispose(){clearTimeout(E)}}});var j;(function(C){function f(E){return E===C.None||E===C.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}C.isCancellationToken=f,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(j||(e.CancellationToken=j={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=j.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=j.None}}e.$pe=O;function I(C){const f=new O;return C.add({dispose(){f.cancel()}}),f.token}}),define(ae[129],ce([0,1,26]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=e.$2e=void 0,e.$3e=j;class N{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new D.$pe,f=this.b(C.token);return this.a={promise:f,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}e.$2e=N;function j(I){return I}class A{constructor(C,f){this.a=void 0,this.b=void 0,typeof C=="function"?(this.c=C,this.d=j):(this.c=f,this.d=C.getCacheKey)}get(C){const f=this.d(C);return this.b!==f&&(this.b=f,this.a=this.c(C)),this.a}}e.$4e=A;class O{get cachedValues(){return this.a}constructor(C,f){this.a=new Map,this.b=new Map,typeof C=="function"?(this.c=C,this.d=j):(this.c=f,this.d=C.getCacheKey)}get(C){const f=this.d(C);if(this.b.has(f))return this.b.get(f);const E=this.c(C);return this.a.set(C,E),this.b.set(f,E),E}}e.$5e=O}),define(ae[50],ce([0,1,7,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=j,e.$se=A,e.$te=O,e.$ue=I,e.$ve=f,e.$we=E,e.$xe=y,e.$ye=w,e.$ze=h,e.$Ae=c,e.$Be=p,e.$Ce=g,e.$De=l,e.$Ee=u,e.$Fe=m;function j(d){const $=d;return $?typeof $.read=="function":!1}function A(d){const $=d;return $?[$.on,$.pause,$.resume,$.destroy].every(t=>typeof t=="function"):!1}function O(d){const $=d;return $?A($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}function I(d,$){return new C(d,$)}class C{constructor($,t){this.e=$,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(t=>t($))}h($){this.c.error.length===0?(0,D.$1)($):this.c.error.slice(0).forEach(t=>t($))}i(){this.c.end.slice(0).forEach($=>$())}on($,t){if(!this.a.destroyed)switch($){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener($,t){if(this.a.destroyed)return;let r;switch($){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(t);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(d,$){const t=[];let r;for(;(r=d.read())!==null;)t.push(r);return $(t)}function E(d,$,t){const r=[];let n;for(;(n=d.read())!==null&&r.length<t;)r.push(n);return n===null&&r.length>0?$(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return d.read()}}}function y(d,$){return new Promise((t,r)=>{const n=[];w(d,{onData:s=>{$&&n.push(s)},onError:s=>{$?r(s):t(void 0)},onEnd:()=>{t($?$(n):void 0)}})})}function w(d,$,t){d.on("error",r=>{t?.isCancellationRequested||$.onError(r)}),d.on("end",()=>{t?.isCancellationRequested||$.onEnd()}),d.on("data",r=>{t?.isCancellationRequested||$.onData(r)})}function h(d,$){return new Promise((t,r)=>{const n=new N.$Uc,s=[],i=b=>{if(s.push(b),s.length>$)return n.dispose(),d.pause(),t({stream:d,buffer:s,ended:!1})},o=b=>(n.dispose(),r(b)),a=()=>(n.dispose(),t({stream:d,buffer:s,ended:!0}));n.add((0,N.$Tc)(()=>d.removeListener("error",o))),d.on("error",o),n.add((0,N.$Tc)(()=>d.removeListener("end",a))),d.on("end",a),n.add((0,N.$Tc)(()=>d.removeListener("data",i))),d.on("data",i)})}function c(d,$){const t=I($);return t.end(d),t}function p(){const d=I(()=>{throw new Error("not supported")});return d.end(),d}function g(d){let $=!1;return{read:()=>$?null:($=!0,d)}}function l(d,$,t){const r=I(t);return w(d,{onData:n=>r.write($.data(n)),onError:n=>r.error($.error?$.error(n):n),onEnd:()=>r.end()}),r}function u(d,$,t){let r=!1;return{read:()=>{const n=$.read();return r?n:(r=!0,n!==null?t([d,n]):d)}}}function m(d,$,t){let r=!1;const n=I(t);return w($,{onData:s=>r?n.write(s):(r=!0,n.write(t([d,s]))),onError:s=>n.error(s),onEnd:()=>{r||(r=!0,n.write(d)),n.end()}}),n}}),define(ae[15],ce([0,1,53,50]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=void 0,e.$He=f,e.$Ie=E,e.$Je=y,e.$Ke=w,e.$Le=h,e.$Me=c,e.$Ne=p,e.$Oe=g,e.$Pe=l,e.$Qe=u,e.$Re=m,e.$Se=d,e.$Te=$,e.$Ue=t,e.$Ve=r,e.$We=n,e.$Xe=s,e.$Ye=i,e.$Ze=o,e.$1e=k;const j=typeof Buffer<"u",A=new D.$V(()=>new Uint8Array(256));let O,I;class C{static alloc(S){return j?new C(Buffer.allocUnsafe(S)):new C(new Uint8Array(S))}static wrap(S){return j&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new C(S)}static fromString(S,P){return!(P?.dontUseNodeBuffer||!1)&&j?new C(Buffer.from(S)):(O||(O=new TextEncoder),new C(O.encode(S)))}static fromByteArray(S){const P=C.alloc(S.length);for(let R=0,M=S.length;R<M;R++)P.buffer[R]=S[R];return P}static concat(S,P){if(typeof P>"u"){P=0;for(let F=0,q=S.length;F<q;F++)P+=S[F].byteLength}const R=C.alloc(P);let M=0;for(let F=0,q=S.length;F<q;F++){const Y=S[F];R.set(Y,M),M+=Y.byteLength}return R}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=C.alloc(this.byteLength);return S.set(this),S}toString(){return j?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(S,P){return new C(this.buffer.subarray(S,P))}set(S,P){if(S instanceof C)this.buffer.set(S.buffer,P);else if(S instanceof Uint8Array)this.buffer.set(S,P);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),P);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return w(this.buffer,S)}writeUInt32BE(S,P){h(this.buffer,S,P)}readUInt32LE(S){return c(this.buffer,S)}writeUInt32LE(S,P){p(this.buffer,S,P)}readUInt8(S){return g(this.buffer,S)}writeUInt8(S,P){l(this.buffer,S,P)}indexOf(S,P=0){return f(this.buffer,S instanceof C?S.buffer:S,P)}}e.$Ge=C;function f(v,S,P=0){const R=S.byteLength,M=v.byteLength;if(R===0)return 0;if(R===1)return v.indexOf(S[0]);if(R>M-P)return-1;const F=A.value;F.fill(S.length);for(let X=0;X<S.length;X++)F[S[X]]=S.length-X-1;let q=P+S.length-1,Y=q,H=-1;for(;q<M;)if(v[q]===S[Y]){if(Y===0){H=q;break}q--,Y--}else q+=Math.max(S.length-Y,F[v[q]]),Y=S.length-1;return H}function E(v,S){return v[S+0]<<0>>>0|v[S+1]<<8>>>0}function y(v,S,P){v[P+0]=S&255,S=S>>>8,v[P+1]=S&255}function w(v,S){return v[S]*2**24+v[S+1]*2**16+v[S+2]*2**8+v[S+3]}function h(v,S,P){v[P+3]=S,S=S>>>8,v[P+2]=S,S=S>>>8,v[P+1]=S,S=S>>>8,v[P]=S}function c(v,S){return v[S+0]<<0>>>0|v[S+1]<<8>>>0|v[S+2]<<16>>>0|v[S+3]<<24>>>0}function p(v,S,P){v[P+0]=S&255,S=S>>>8,v[P+1]=S&255,S=S>>>8,v[P+2]=S&255,S=S>>>8,v[P+3]=S&255}function g(v,S){return v[S]}function l(v,S,P){v[P]=S}function u(v){return N.$ve(v,S=>C.concat(S))}function m(v){return N.$Ce(v)}function d(v){return N.$xe(v,S=>C.concat(S))}async function $(v){return v.ended?C.concat(v.buffer):C.concat([...v.buffer,await d(v.stream)])}function t(v){return N.$Ae(v,S=>C.concat(S))}function r(v){return N.$De(v,{data:S=>typeof S=="string"?C.fromString(S):C.wrap(S)},S=>C.concat(S))}function n(v){return N.$ue(S=>C.concat(S),v)}function s(v,S){return N.$Ee(v,S,P=>C.concat(P))}function i(v,S){return N.$Fe(v,S,P=>C.concat(P))}function o(v){let S=0,P=0,R=0;const M=new Uint8Array(Math.floor(v.length/4*3)),F=Y=>{switch(P){case 3:M[R++]=S|Y,P=0;break;case 2:M[R++]=S|Y>>>2,S=Y<<6,P=3;break;case 1:M[R++]=S|Y>>>4,S=Y<<4,P=2;break;default:S=Y<<2,P=1}};for(let Y=0;Y<v.length;Y++){const H=v.charCodeAt(Y);if(H>=65&&H<=90)F(H-65);else if(H>=97&&H<=122)F(H-97+26);else if(H>=48&&H<=57)F(H-48+52);else if(H===43||H===45)F(62);else if(H===47||H===95)F(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${v[Y]}`)}}const q=R;for(;P>0;)F(0);return C.wrap(M).slice(0,q)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:v},S=!0,P=!1){const R=P?b:a;let M="";const F=v.byteLength%3;let q=0;for(;q<v.byteLength-F;q+=3){const Y=v[q+0],H=v[q+1],X=v[q+2];M+=R[Y>>>2],M+=R[(Y<<4|H>>>4)&63],M+=R[(H<<2|X>>>6)&63],M+=R[X&63]}if(F===1){const Y=v[q+0];M+=R[Y>>>2],M+=R[Y<<4&63],S&&(M+="==")}else if(F===2){const Y=v[q+0],H=v[q+1];M+=R[Y>>>2],M+=R[(Y<<4|H>>>4)&63],M+=R[H<<2&63],S&&(M+="=")}return M}}),define(ae[27],ce([0,1,129,53]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Of=e.$Hf=e.$Gf=void 0,e.$8e=j,e.$9e=O,e.$0e=C,e.$$e=f,e.$_e=E,e.$af=y,e.$bf=w,e.$cf=h,e.$df=c,e.$ef=p,e.$ff=g,e.$gf=l,e.$hf=u,e.$if=m,e.$jf=d,e.$kf=$,e.$lf=t,e.$mf=r,e.$nf=n,e.$of=s,e.$pf=i,e.$qf=o,e.$rf=a,e.$sf=b,e.$tf=k,e.$uf=v,e.$vf=S,e.$wf=P,e.$xf=R,e.$yf=M,e.$zf=F,e.$Af=q,e.$Bf=Y,e.$Cf=H,e.$Df=X,e.$Ef=W,e.$Ff=J,e.$If=re,e.$Jf=he,e.$Kf=te,e.$Lf=V,e.$Mf=T,e.$Nf=x,e.$Pf=K,e.$Qf=ee,e.$Rf=_,e.$Sf=Z,e.$Tf=ue,e.$Uf=ge,e.$Wf=fe,e.$Xf=$e,e.$Yf=ye,e.$Zf=ve,e.$1f=Ce,e.$2f=De,e.$3f=le,e.$4f=me,e.$5f=Le;function j(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}const A=/{(\d+)}/g;function O(oe,...de){return de.length===0?oe:oe.replace(A,function(pe,be){const ke=parseInt(be,10);return isNaN(ke)||ke<0||ke>=de.length?pe:de[ke]})}const I=/{([^}]+)}/g;function C(oe,de){return Object.keys(de).length===0?oe:oe.replace(I,(pe,be)=>de[be]??pe)}function f(oe){return oe.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function E(oe){return oe.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function y(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(oe,de){let pe=0;const be=de.charCodeAt(0);for(let ke=oe.length-1;ke>=0;ke--)oe.charCodeAt(ke)===be&&pe++;return pe}function h(oe,de,pe="\u2026"){return oe.length<=de?oe:`${oe.substr(0,de)}${pe}`}function c(oe,de,pe="\u2026"){if(oe.length<=de)return oe;const be=Math.ceil(de/2)-pe.length/2,ke=Math.floor(de/2)-pe.length/2;return`${oe.substr(0,be)}${pe}${oe.substr(oe.length-ke)}`}function p(oe,de=" "){const pe=g(oe,de);return l(pe,de)}function g(oe,de){if(!oe||!de)return oe;const pe=de.length;if(pe===0||oe.length===0)return oe;let be=0;for(;oe.indexOf(de,be)===be;)be=be+pe;return oe.substring(be)}function l(oe,de){if(!oe||!de)return oe;const pe=de.length,be=oe.length;if(pe===0||be===0)return oe;let ke=be,Ie=-1;for(;Ie=oe.lastIndexOf(de,ke-1),!(Ie===-1||Ie+pe!==ke);){if(Ie===0)return"";ke=Ie}return oe.substring(0,ke)}function u(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function m(oe){return oe.replace(/\*/g,"")}function d(oe,de,pe={}){if(!oe)throw new Error("Cannot create regex from empty string");de||(oe=y(oe)),pe.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let be="";return pe.global&&(be+="g"),pe.matchCase||(be+="i"),pe.multiline&&(be+="m"),pe.unicode&&(be+="u"),new RegExp(oe,be)}function $(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}function t(oe){return oe.split(/\r\n|\r|\n/)}function r(oe){const de=[],pe=oe.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(pe.length/2);be++)de.push(pe[2*be]+(pe[2*be+1]??""));return de}function n(oe){for(let de=0,pe=oe.length;de<pe;de++){const be=oe.charCodeAt(de);if(be!==32&&be!==9)return de}return-1}function s(oe,de=0,pe=oe.length){for(let be=de;be<pe;be++){const ke=oe.charCodeAt(be);if(ke!==32&&ke!==9)return oe.substring(de,be)}return oe.substring(de,pe)}function i(oe,de=oe.length-1){for(let pe=de;pe>=0;pe--){const be=oe.charCodeAt(pe);if(be!==32&&be!==9)return pe}return-1}function o(oe,de,pe){const be=[];let ke=0;for(const Ie of oe.matchAll(de)){if(be.push(oe.slice(ke,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");ke=Ie.index+Ie[0].length,be.push(pe(Ie[0],...Ie.slice(1),Ie.index,oe,Ie.groups))}return be.push(oe.slice(ke)),Promise.all(be).then(Ie=>Ie.join(""))}function a(oe,de){return oe<de?-1:oe>de?1:0}function b(oe,de,pe=0,be=oe.length,ke=0,Ie=de.length){for(;pe<be&&ke<Ie;pe++,ke++){const We=oe.charCodeAt(pe),Be=de.charCodeAt(ke);if(We<Be)return-1;if(We>Be)return 1}const Oe=be-pe,Ne=Ie-ke;return Oe<Ne?-1:Oe>Ne?1:0}function k(oe,de){return v(oe,de,0,oe.length,0,de.length)}function v(oe,de,pe=0,be=oe.length,ke=0,Ie=de.length){for(;pe<be&&ke<Ie;pe++,ke++){let We=oe.charCodeAt(pe),Be=de.charCodeAt(ke);if(We===Be)continue;if(We>=128||Be>=128)return b(oe.toLowerCase(),de.toLowerCase(),pe,be,ke,Ie);P(We)&&(We-=32),P(Be)&&(Be-=32);const Fe=We-Be;if(Fe!==0)return Fe}const Oe=be-pe,Ne=Ie-ke;return Oe<Ne?-1:Oe>Ne?1:0}function S(oe){return oe>=48&&oe<=57}function P(oe){return oe>=97&&oe<=122}function R(oe){return oe>=65&&oe<=90}function M(oe,de){return oe.length===de.length&&v(oe,de)===0}function F(oe,de){const pe=de.length;return de.length>oe.length?!1:v(oe,de,0,pe)===0}function q(oe,de){const pe=Math.min(oe.length,de.length);let be;for(be=0;be<pe;be++)if(oe.charCodeAt(be)!==de.charCodeAt(be))return be;return pe}function Y(oe,de){const pe=Math.min(oe.length,de.length);let be;const ke=oe.length-1,Ie=de.length-1;for(be=0;be<pe;be++)if(oe.charCodeAt(ke-be)!==de.charCodeAt(Ie-be))return be;return pe}function H(oe){return 55296<=oe&&oe<=56319}function X(oe){return 56320<=oe&&oe<=57343}function W(oe,de){return(oe-55296<<10)+(de-56320)+65536}function J(oe,de,pe){const be=oe.charCodeAt(pe);if(H(be)&&pe+1<de){const ke=oe.charCodeAt(pe+1);if(X(ke))return W(be,ke)}return be}function G(oe,de){const pe=oe.charCodeAt(de-1);if(X(pe)&&de>1){const be=oe.charCodeAt(de-2);if(H(be))return W(be,pe)}return pe}class B{get offset(){return this.e}constructor(de,pe=0){this.c=de,this.d=de.length,this.e=pe}setOffset(de){this.e=de}prevCodePoint(){const de=G(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=J(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Gf=B;class ie{get offset(){return this.c.offset}constructor(de,pe=0){this.c=new B(de,pe)}nextGraphemeLength(){const de=Re.getInstance(),pe=this.c,be=pe.offset;let ke=de.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ie=pe.offset,Oe=de.getGraphemeBreakType(pe.nextCodePoint());if(we(ke,Oe)){pe.setOffset(Ie);break}ke=Oe}return pe.offset-be}prevGraphemeLength(){const de=Re.getInstance(),pe=this.c,be=pe.offset;let ke=de.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ie=pe.offset,Oe=de.getGraphemeBreakType(pe.prevCodePoint());if(we(Oe,ke)){pe.setOffset(Ie);break}ke=Oe}return be-pe.offset}eol(){return this.c.eol()}}e.$Hf=ie;function re(oe,de){return new ie(oe,de).nextGraphemeLength()}function he(oe,de){return new ie(oe,de).prevGraphemeLength()}function te(oe,de){de>0&&X(oe.charCodeAt(de))&&de--;const pe=de+re(oe,de);return[pe-he(oe,pe),pe]}function V(oe){const de=new ie(oe);let pe=0;for(;!de.eol();)pe++,de.nextGraphemeLength();return pe}let z;function L(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(oe){return z||(z=L()),z.test(oe)}const U=/^[\t\n\r\x20-\x7E]*$/;function x(oe){return U.test(oe)}e.$Of=/[\u2028\u2029]/;function K(oe){return e.$Of.test(oe)}function ee(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}function _(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}function Z(oe,de,pe=""){const be=oe.trimStart();if(be.length<de)return be;const ke=/\b/g;let Ie=0;for(;ke.test(be)&&!(be.length-ke.lastIndex<de);)Ie=ke.lastIndex,ke.lastIndex+=1;return Ie===0?be:pe+be.substring(Ie).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ue(oe){let de=0;for(const pe of oe.matchAll(se))de!==pe.index&&(yield{isCode:!1,str:oe.substring(de,pe.index)}),yield{isCode:!0,str:pe[0]},de=pe.index+pe[0].length;de!==oe.length&&(yield{isCode:!1,str:oe.substring(de)})}function ge(oe){return oe&&(oe=oe.replace(se,"")),oe}e.$Vf="\uFEFF";function fe(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}function $e(oe){return fe(oe)?oe.substr(1):oe}function ye(oe,de){if(!oe||!de||oe.length<de.length)return!1;const pe=de.length,be=oe.toLowerCase();let ke=0,Ie=-1;for(;ke<pe;){const Oe=be.indexOf(de[ke],Ie+1);if(Oe<0)return!1;Ie=Oe,ke++}return!0}function ve(oe,de=!1){return oe?(de&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}function Ce(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}function De(oe,de=1){if(de===0)return"";let pe=-1;do pe=oe.indexOf(`
`,pe+1),de--;while(de>0&&pe>=0);return pe===-1?oe:(oe[pe-1]==="\r"&&pe--,oe.substr(0,pe))}function le(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}function me(oe){return Re.getInstance().getGraphemeBreakType(oe)}function we(oe,de){return oe===0?de!==5&&de!==7:oe===2&&de===3?!1:oe===4||oe===2||oe===3||de===4||de===2||de===3?!0:!(oe===8&&(de===8||de===9||de===11||de===12)||(oe===11||oe===9)&&(de===9||de===10)||(oe===12||oe===10)&&de===10||de===5||de===13||de===7||oe===1||oe===13&&de===14||oe===6&&de===6)}var Pe;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Me()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const pe=this.d,be=pe.length/3;let ke=1;for(;ke<=be;)if(de<pe[3*ke])ke=2*ke;else if(de>pe[3*ke+1])ke=2*ke+1;else return pe[3*ke+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(oe,de){if(oe===0)return 0;const pe=qe(oe,de);if(pe!==void 0)return pe;const be=new B(de,oe);return be.prevCodePoint(),be.offset}function qe(oe,de){const pe=new B(de,oe);let be=pe.prevCodePoint();for(;Te(be)||be===65039||be===8419;){if(pe.offset===0)return;be=pe.prevCodePoint()}if(!_(be))return;let ke=pe.offset;return ke>0&&pe.prevCodePoint()===8205&&(ke=pe.offset),ke}function Te(oe){return 127995<=oe&&oe<=127999}var Ue;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),e.$6f="\xA0";class ze{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$4e({getCacheKey:JSON.stringify},de=>{function pe(Fe){const Qe=new Map;for(let He=0;He<Fe.length;He+=2)Qe.set(Fe[He],Fe[He+1]);return Qe}function be(Fe,Qe){const He=new Map(Fe);for(const[_e,tt]of Qe)He.set(_e,tt);return He}function ke(Fe,Qe){if(!Fe)return Qe;const He=new Map;for(const[_e,tt]of Fe)Qe.has(_e)&&He.set(_e,tt);return He}const Ie=this.c.value;let Oe=de.filter(Fe=>!Fe.startsWith("_")&&Fe in Ie);Oe.length===0&&(Oe=["_default"]);let Ne;for(const Fe of Oe){const Qe=pe(Ie[Fe]);Ne=ke(Ne,Qe)}const We=pe(Ie._common),Be=be(We,Ne);return new ze(Be)})}static getInstance(de){return ze.d.get(Array.from(de))}static{this.e=new N.$V(()=>Object.keys(ze.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return ze.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=ze;class Ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ae.c())),this.d}static isInvisibleCharacter(de){return Ae.e().has(de)}static get codePoints(){return Ae.e()}}e.$8f=Ae}),define(ae[54],ce([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=N,e.$lj=j,e.$mj=A,e.$nj=I,e.$pj=p;function N(l){return j(l,0)}function j(l,u){switch(typeof l){case"object":return l===null?A(349,u):Array.isArray(l)?C(l,u):f(l,u);case"string":return I(l,u);case"boolean":return O(l,u);case"number":return A(l,u);case"undefined":return A(937,u);default:return A(617,u)}}function A(l,u){return(u<<5)-u+l|0}function O(l,u){return A(l?433:863,u)}function I(l,u){u=A(149417,u);for(let m=0,d=l.length;m<d;m++)u=A(l.charCodeAt(m),u);return u}function C(l,u){return u=A(104579,u),l.reduce((m,d)=>j(d,m),u)}function f(l,u){return u=A(181387,u),Object.keys(l).sort().reduce((m,d)=>(m=I(d,m),j(l[d],m)),u)}class E{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=j(u,this.g),this.g}}e.$oj=E;var y;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function w(l,u,m=32){const d=m-u,$=~((1<<d)-1);return(l<<u|($&l)>>>d)>>>0}function h(l,u=0,m=l.byteLength,d=0){for(let $=0;$<m;$++)l[u+$]=d}function c(l,u,m="0"){for(;l.length<u;)l=m+l;return l}function p(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(m=>m.toString(16).padStart(2,"0")).join(""):c((l>>>0).toString(16),u/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const m=u.length;if(m===0)return;const d=this.p;let $=this.r,t=this.u,r,n;for(t!==0?(r=t,n=-1,t=0):(r=u.charCodeAt(0),n=0);;){let s=r;if(D.$Cf(r))if(n+1<m){const i=u.charCodeAt(n+1);D.$Df(i)?(n++,s=D.$Ef(r,i)):s=65533}else{t=r;break}else D.$Df(r)&&(s=65533);if($=this.w(d,$,s),n++,n<m)r=u.charCodeAt(n);else break}this.r=$,this.u=t}w(u,m,d){return d<128?u[m++]=d:d<2048?(u[m++]=192|(d&1984)>>>6,u[m++]=128|(d&63)>>>0):d<65536?(u[m++]=224|(d&61440)>>>12,u[m++]=128|(d&4032)>>>6,u[m++]=128|(d&63)>>>0):(u[m++]=240|(d&1835008)>>>18,u[m++]=128|(d&258048)>>>12,u[m++]=128|(d&4032)>>>6,u[m++]=128|(d&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=g.g,m=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,w(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let d=this.h,$=this.l,t=this.m,r=this.n,n=this.o,s,i,o;for(let a=0;a<80;a++)a<20?(s=$&t|~$&r,i=1518500249):a<40?(s=$^t^r,i=1859775393):a<60?(s=$&t|$&r|t&r,i=2400959708):(s=$^t^r,i=3395469782),o=w(d,5)+s+n+i+u.getUint32(a*4,!1)&4294967295,n=r,r=t,t=w($,30),$=d,d=o;this.h=this.h+d&4294967295,this.l=this.l+$&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+n&4294967295}}e.$qj=g}),define(ae[88],ce([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(j){j[j.Ignore=0]="Ignore",j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(N||(N={})),function(j){const A="error",O="warning",I="warn",C="info",f="ignore";function E(w){return w?D.$yf(A,w)?j.Error:D.$yf(O,w)||D.$yf(I,w)?j.Warning:D.$yf(C,w)?j.Info:j.Ignore:j.Ignore}j.fromValue=E;function y(w){switch(w){case j.Error:return A;case j.Warning:return O;case j.Info:return C;default:return f}}j.toString=y}(N||(N={})),e.default=N}),define(ae[130],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(ae[51],ce([0,1,17,27]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class j{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const c=h.charCodeAt(0),p=this.b.charCodeAt(this.c);return c-p}value(){return this.b[this.c]}}e.$yi=j;class A{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,N.$sf)(h,this.b,0,h.length,this.c,this.d):(0,N.$uf)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=A;class O{constructor(h=!0,c=!0){this.f=h,this.g=c}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let c=h.length-1;c>=0;c--,this.c--){const p=this.b.charCodeAt(c);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===47||this.f&&c===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,N.$sf)(h,this.b,0,h.length,this.d,this.e):(0,N.$uf)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=O;var I;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(I||(I={}));class C{constructor(h,c){this.f=h,this.g=c,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,N.$tf)(h,this.c.scheme);if(this.d[this.e]===2)return(0,N.$tf)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,N.$rf)(h,this.c.query);if(this.d[this.e]===5)return(0,N.$rf)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=C;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(E||(E={}));class y{static forUris(h=()=>!1,c=()=>!1){return new y(new C(h,c))}static forPaths(h=!1){return new y(new O(void 0,!h))}static forStrings(){return new y(new j)}static forConfigKeys(){return new y(new A)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,c){if(c){const p=c.slice(0);(0,D.$Xb)(p);for(const g of p)this.set(g,h)}else{const p=h.slice(0);(0,D.$Xb)(p);for(const g of p)this.set(g[0],g[1])}}set(h,c){const p=this.b.reset(h);let g;this.c||(this.c=new f,this.c.segment=p.value());const l=[];for(g=this.c;;){const m=p.cmp(g.segment);if(m>0)g.left||(g.left=new f,g.left.segment=p.value()),l.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new f,g.right.segment=p.value()),l.push([1,g]),g=g.right;else if(p.hasNext())p.next(),g.mid||(g.mid=new f,g.mid.segment=p.value()),l.push([0,g]),g=g.mid;else break}const u=g.value;g.value=c,g.key=h;for(let m=l.length-1;m>=0;m--){const d=l[m][1];d.updateHeight();const $=d.balanceFactor();if($<-1||$>1){const t=l[m][0],r=l[m+1][0];if(t===1&&r===1)l[m][1]=d.rotateLeft();else if(t===-1&&r===-1)l[m][1]=d.rotateRight();else if(t===1&&r===-1)d.right=l[m+1][1]=l[m+1][1].rotateRight(),l[m][1]=d.rotateLeft();else if(t===-1&&r===1)d.left=l[m+1][1]=l[m+1][1].rotateLeft(),l[m][1]=d.rotateRight();else throw new Error;if(m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this.c=l[0][1]}}return u}get(h){return this.d(h)?.value}d(h){const c=this.b.reset(h);let p=this.c;for(;p;){const g=c.cmp(p.segment);if(g>0)p=p.left;else if(g<0)p=p.right;else if(c.hasNext())c.next(),p=p.mid;else break}return p}has(h){const c=this.d(h);return!(c?.value===void 0&&c?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,c){const p=this.b.reset(h),g=[];let l=this.c;for(;l;){const u=p.cmp(l.segment);if(u>0)g.push([-1,l]),l=l.left;else if(u<0)g.push([1,l]),l=l.right;else if(p.hasNext())p.next(),g.push([0,l]),l=l.mid;else break}if(l){if(c?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:m,value:d,segment:$}=u;this.e(u.key,!1),l.key=m,l.value=d,l.segment=$}}else{const u=l.left??l.right;if(g.length>0){const[m,d]=g[g.length-1];switch(m){case-1:d.left=u;break;case 0:d.mid=u;break;case 1:d.right=u;break}}else this.c=u}for(let u=g.length-1;u>=0;u--){const m=g[u][1];m.updateHeight();const d=m.balanceFactor();if(d>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[u][1]=m.rotateLeft()):d<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[u][1]=m.rotateRight()),u>0)switch(g[u-1][0]){case-1:g[u-1][1].left=g[u][1];break;case 1:g[u-1][1].right=g[u][1];break;case 0:g[u-1][1].mid=g[u][1];break}else this.c=g[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const c=this.b.reset(h);let p=this.c,g;for(;p;){const l=c.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if(c.hasNext())c.next(),g=p.value||g,p=p.mid;else break}return p&&p.value||g}findSuperstr(h){return this.g(h,!1)}g(h,c){const p=this.b.reset(h);let g=this.c;for(;g;){const l=p.cmp(g.segment);if(l>0)g=g.left;else if(l<0)g=g.right;else if(p.hasNext())p.next(),g=g.mid;else return g.mid?this.h(g.mid):c?g.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[c,p]of this)h(p,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const c=[];return this.j(h,c),c[Symbol.iterator]()}j(h,c){h&&(h.left&&this.j(h.left,c),h.value&&c.push([h.key,h.value]),h.mid&&this.j(h.mid,c),h.right&&this.j(h.right,c))}_isBalanced(){const h=c=>{if(!c)return!0;const p=c.balanceFactor();return p<-1||p>1?!1:h(c.left)&&h(c.right)};return h(this.c)}}e.$Ci=y}),define(ae[13],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=D,e.$0f=N,e.$$f=j,e.$_f=A,e.$ag=O,e.$bg=I,e.$cg=C,e.$dg=f,e.$eg=E,e.$fg=y,e.$gg=w,e.$hg=h,e.$ig=c,e.$jg=g,e.$kg=l,e.$lg=u,e.$mg=m,e.$ng=d;function D($){return typeof $=="string"}function N($){return Array.isArray($)&&$.every(t=>D(t))}function j($){return typeof $=="object"&&$!==null&&!Array.isArray($)&&!($ instanceof RegExp)&&!($ instanceof Date)}function A($){const t=Object.getPrototypeOf(Uint8Array);return typeof $=="object"&&$ instanceof t}function O($){return typeof $=="number"&&!isNaN($)}function I($){return!!$&&typeof $[Symbol.iterator]=="function"}function C($){return $===!0||$===!1}function f($){return typeof $>"u"}function E($){return!y($)}function y($){return f($)||$===null}function w($,t){if(!$)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function h($){if(y($))throw new Error("Assertion Failed: argument is undefined or null");return $}function c(...$){const t=[];for(let r=0;r<$.length;r++){const n=$[r];if(y(n))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(n)}return t}const p=Object.prototype.hasOwnProperty;function g($){if(!j($))return!1;for(const t in $)if(p.call($,t))return!1;return!0}function l($){return typeof $=="function"}function u(...$){return $.length>0&&$.every(l)}function m($,t){const r=Math.min($.length,t.length);for(let n=0;n<r;n++)d($[n],t[n])}function d($,t){if(D(t)){if(typeof $!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if($ instanceof t)return}catch{}if(!y($)&&$.constructor===t||t.length===1&&t.call(void 0,$)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ae[30],ce([0,1,13]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=N,e.$4n=j,e.$5n=O,e.$6n=C,e.$7n=f,e.$8n=E,e.$9n=y,e.$0n=w,e.$$n=h,e.$_n=c,e.$ao=p,e.$bo=g;function N(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([m,d])=>{u[m]=d&&typeof d=="object"?N(d):d}),u}function j(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const m=u.shift();Object.freeze(m);for(const d in m)if(A.call(m,d)){const $=m[d];typeof $=="object"&&!Object.isFrozen($)&&!(0,D.$_f)($)&&u.push($)}}return l}const A=Object.prototype.hasOwnProperty;function O(l,u){return I(l,u,new Set)}function I(l,u,m){if((0,D.$fg)(l))return l;const d=u(l);if(typeof d<"u")return d;if(Array.isArray(l)){const $=[];for(const t of l)$.push(I(t,u,m));return $}if((0,D.$$f)(l)){if(m.has(l))throw new Error("Cannot clone recursive data-structure");m.add(l);const $={};for(const t in l)A.call(l,t)&&($[t]=I(l[t],u,m));return m.delete(l),$}return l}function C(l,u,m=!0){return(0,D.$$f)(l)?((0,D.$$f)(u)&&Object.keys(u).forEach(d=>{d in l?m&&((0,D.$$f)(l[d])&&(0,D.$$f)(u[d])?C(l[d],u[d],m):l[d]=u[d]):l[d]=u[d]}),l):u}function f(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let m,d;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(m=0;m<l.length;m++)if(!f(l[m],u[m]))return!1}else{const $=[];for(d in l)$.push(d);$.sort();const t=[];for(d in u)t.push(d);if(t.sort(),!f($,t))return!1;for(m=0;m<$.length;m++)if(!f(l[$[m]],u[$[m]]))return!1}return!0}function E(l){const u=new Set;return JSON.stringify(l,(m,d)=>{if((0,D.$$f)(d)||Array.isArray(d)){if(u.has(d))return"[Circular]";u.add(d)}return typeof d=="bigint"?`[BigInt ${d.toString()}]`:d})}function y(l,u){const m=Object.create(null);return!l||!u||Object.keys(u).forEach($=>{const t=l[$],r=u[$];f(t,r)||(m[$]=r)}),m}function w(l,u){const m=u.toLowerCase(),d=Object.keys(l).find($=>$.toLowerCase()===m);return d?l[d]:l[u]}function h(l,u){const m=Object.create(null);for(const[d,$]of Object.entries(l))u(d,$)&&(m[d]=$);return m}function c(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}function p(l){const u=[];for(const m of c(l))typeof l[m]=="function"&&u.push(m);return u}function g(l,u){const m=$=>function(){const t=Array.prototype.slice.call(arguments,0);return u($,t)},d={};for(const $ of l)d[$]=m($);return d}}),define(ae[32],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=N;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(j){return D.test(j)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let j;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?j=crypto.getRandomValues.bind(crypto):j=function(I){for(let C=0;C<I.length;C++)I[C]=Math.floor(Math.random()*256);return I};const A=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){j(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let C=0,f="";return f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f+="-",f+=O[A[C++]],f+=O[A[C++]],f+="-",f+=O[A[C++]],f+=O[A[C++]],f+="-",f+=O[A[C++]],f+=O[A[C++]],f+="-",f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f+=O[A[C++]],f}}()}),define(ae[131],ce([0,1,37]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=A;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function j(O){const I=O.replace(/\-/g,":").toLowerCase();return!N.has(I)}function A(){const O=(0,D.networkInterfaces)();for(const I in O){const C=O[I];if(C){for(const{mac:f}of C)if(j(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ae[132],ce([0,1,273,15]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PW=void 0;class j extends D.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const I=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(O,I,C){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let f=0;for(;f<this.a.length;){const E=typeof this.b=="number"?this.a.indexOf(this.b,f):(0,N.$He)(this.a,this.b,f);if(E===-1)break;this.push(this.a.slice(f,E+this.c)),f=E+this.c}this.a=f===this.a.length?void 0:this.a.slice(f),C()}_flush(O){this.a&&this.push(this.a),O()}}e.$PW=j}),define(ae[133],ce([0,1,64]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=void 0,e.$Ug=N,e.$Wg=A;function N(I,C,f,E=1){let y=!1;return new Promise(w=>{const h=setTimeout(()=>{if(!y)return y=!0,w(0)},f);j(I,C,E,c=>{if(!y)return y=!0,clearTimeout(h),w(c)})})}function j(I,C,f,E){if(C===0)return E(0);const y=new D.Socket;y.once("connect",()=>(O(y),j(I+f,C-1,f,E))),y.once("data",()=>{}),y.once("error",w=>(O(y),w.code!=="ECONNREFUSED"?j(I+f,C-1,f,E):E(I))),y.connect(I,"127.0.0.1")}e.$Vg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(I,C,f,E="127.0.0.1"){let y=!1,w,h=1;const c=D.createServer({pauseOnConnect:!0});function p(g,l){y||(y=!0,c.removeAllListeners(),c.close(),w&&clearTimeout(w),l(g))}return new Promise(g=>{w=setTimeout(()=>{p(0,g)},f),c.on("listening",()=>{p(I,g)}),c.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&h<C?(I++,h++,c.listen(I,E)):p(0,g)}),c.on("close",()=>{p(0,g)}),c.listen(I,E)})}function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(C){console.error(C)}}}),define(ae[134],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8W=D;function D(N){return!!N.parentPort}}),define(ae[135],ce([11,10]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ae[65],ce([0,1,135]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=f,e.$3m=E,e.$4m=y;const N=60,j=N*60,A=j*24,O=A*7,I=A*30,C=A*365;function f(w,h,c,p){typeof w!="number"&&(w=w.getTime());const g=Math.round((new Date().getTime()-w)/1e3);if(g<-30)return(0,D.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(!p&&g<30)return(0,D.localize)(1,null);let l;return g<N?(l=g,h?l===1?c?(0,D.localize)(2,null,l):(0,D.localize)(3,null,l):c?(0,D.localize)(4,null,l):(0,D.localize)(5,null,l):l===1?c?(0,D.localize)(6,null,l):(0,D.localize)(7,null,l):c?(0,D.localize)(8,null,l):(0,D.localize)(9,null,l)):g<j?(l=Math.floor(g/N),h?l===1?c?(0,D.localize)(10,null,l):(0,D.localize)(11,null,l):c?(0,D.localize)(12,null,l):(0,D.localize)(13,null,l):l===1?c?(0,D.localize)(14,null,l):(0,D.localize)(15,null,l):c?(0,D.localize)(16,null,l):(0,D.localize)(17,null,l)):g<A?(l=Math.floor(g/j),h?l===1?c?(0,D.localize)(18,null,l):(0,D.localize)(19,null,l):c?(0,D.localize)(20,null,l):(0,D.localize)(21,null,l):l===1?c?(0,D.localize)(22,null,l):(0,D.localize)(23,null,l):c?(0,D.localize)(24,null,l):(0,D.localize)(25,null,l)):g<O?(l=Math.floor(g/A),h?l===1?(0,D.localize)(26,null,l):(0,D.localize)(27,null,l):l===1?(0,D.localize)(28,null,l):(0,D.localize)(29,null,l)):g<I?(l=Math.floor(g/O),h?l===1?c?(0,D.localize)(30,null,l):(0,D.localize)(31,null,l):c?(0,D.localize)(32,null,l):(0,D.localize)(33,null,l):l===1?c?(0,D.localize)(34,null,l):(0,D.localize)(35,null,l):c?(0,D.localize)(36,null,l):(0,D.localize)(37,null,l)):g<C?(l=Math.floor(g/I),h?l===1?c?(0,D.localize)(38,null,l):(0,D.localize)(39,null,l):c?(0,D.localize)(40,null,l):(0,D.localize)(41,null,l):l===1?c?(0,D.localize)(42,null,l):(0,D.localize)(43,null,l):c?(0,D.localize)(44,null,l):(0,D.localize)(45,null,l)):(l=Math.floor(g/C),h?l===1?c?(0,D.localize)(46,null,l):(0,D.localize)(47,null,l):c?(0,D.localize)(48,null,l):(0,D.localize)(49,null,l):l===1?c?(0,D.localize)(50,null,l):(0,D.localize)(51,null,l):c?(0,D.localize)(52,null,l):(0,D.localize)(53,null,l))}function E(w,h){const c=Math.abs(w/1e3);return c<1?h?(0,D.localize)(54,null,w):(0,D.localize)(55,null,w):c<N?h?(0,D.localize)(56,null,Math.round(w)/1e3):(0,D.localize)(57,null,Math.round(w)/1e3):c<j?h?(0,D.localize)(58,null,Math.round(w/(1e3*N))):(0,D.localize)(59,null,Math.round(w/(1e3*N))):c<A?h?(0,D.localize)(60,null,Math.round(w/(1e3*j))):(0,D.localize)(61,null,Math.round(w/(1e3*j))):(0,D.localize)(62,null,Math.round(w/(1e3*A)))}function y(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ae[136],ce([11,10]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,17,13,136]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=C,e.$ij=f,e.$jj=E;function A(y,w){return w&&(y.stack||y.stacktrace)?j.localize(0,null,I(y),O(y.stack)||O(y.stacktrace)):I(y)}function O(y){return Array.isArray(y)?y.join(`
`):y}function I(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?j.localize(1,null,y.message):y.message||j.localize(2,null)}function C(y=null,w=!1){if(!y)return j.localize(3,null);if(Array.isArray(y)){const h=D.$Hb(y),c=C(h[0],w);return h.length>1?j.localize(4,null,c,h.length):c}if(N.$9f(y))return y;if(y.detail){const h=y.detail;if(h.error)return A(h.error,w);if(h.exception)return A(h.exception,w)}return y.stack?A(y,w):y.message?y.message:j.localize(5,null)}function f(y){const w=y;return w instanceof Error&&Array.isArray(w.actions)}function E(y,w){let h;return typeof y=="string"?h=new Error(y):h=y,h.actions=w,h}}),define(ae[137],ce([11,10]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ae[138],ce([0,1,137]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=N;function N(j){switch(j){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}}),define(ae[139],ce([11,10]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,139]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=b,e.$J=k,e.$g="en";let N=!1,j=!1,A=!1,O=!1,I=!1,C=!1,f=!1,E=!1,y=!1,w=!1,h,c=e.$g,p=e.$g,g,l;const u=globalThis;let m;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?m=u.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(m=process);const d=typeof m?.versions?.electron=="string",$=d&&m?.type==="renderer";if(typeof m=="object"){N=m.platform==="win32",j=m.platform==="darwin",A=m.platform==="linux",O=A&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,f=d,y=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,c=e.$g;const v=m.env.VSCODE_NLS_CONFIG;if(v)try{const S=JSON.parse(v),P=S.availableLanguages["*"];h=S.locale,p=S.osLocale,c=P||e.$g,g=S._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!$?(l=navigator.userAgent,N=l.indexOf("Windows")>=0,j=l.indexOf("Macintosh")>=0,E=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=l.indexOf("Linux")>=0,w=l?.indexOf("Mobi")>=0,C=!0,h=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,c=h,p=navigator.language):console.error("Unable to resolve platform.");var t;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;j?n=1:N?n=3:A&&(n=2),e.$i=N,e.$j=j,e.$k=A,e.$l=O,e.$m=I,e.$n=f,e.$o=C,e.$p=C&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=E,e.$s=w,e.$t=y,e.$u=n,e.$v=l,e.$w=c;var s;(function(v){function S(){return e.$w}v.value=S;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=P;function R(){return e.$w==="en"}v.isDefault=R})(s||(e.Language=s={})),e.$x=h,e.$y=p,e.$z=g,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const v=[];u.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let R=0,M=v.length;R<M;R++){const F=v[R];if(F.id===P.data.vscodeScheduleAsyncWork){v.splice(R,1),F.callback();return}}});let S=0;return P=>{const R=++S;v.push({id:R,callback:P}),u.postMessage({vscodeScheduleAsyncWork:R},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=j||E?2:N?1:3;let o=!0,a=!1;function b(){if(!a){a=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,o=new Uint16Array(v.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function k(v){return parseFloat(v)>=20}}),define(ae[36],ce([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.process<"u"){const A=j.process;N={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ae[140],ce([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wW=O;var N;(function(I){I.UNKNOWN="UNKNOWN",I.CINNAMON="CINNAMON",I.DEEPIN="DEEPIN",I.GNOME="GNOME",I.KDE3="KDE3",I.KDE4="KDE4",I.KDE5="KDE5",I.KDE6="KDE6",I.PANTHEON="PANTHEON",I.UNITY="UNITY",I.XFCE="XFCE",I.UKUI="UKUI",I.LXQT="LXQT"})(N||(N={}));const j="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function O(){const I=D.env[j];if(I){const f=I.split(":").map(E=>E.trim()).filter(E=>E.length>0);for(const E of f)switch(E){case"Unity":{const y=D.env.DESKTOP_SESSION;return y&&y.includes("gnome-fallback")?N.GNOME:N.UNITY}case"Deepin":return N.DEEPIN;case"GNOME":return N.GNOME;case"X-Cinnamon":return N.CINNAMON;case"KDE":{const y=D.env[A];return y==="5"?N.KDE5:y==="6"?N.KDE6:N.KDE4}case"Pantheon":return N.PANTHEON;case"XFCE":return N.XFCE;case"UKUI":return N.UKUI;case"LXQt":return N.LXQT}}const C=D.env.DESKTOP_SESSION;if(C)switch(C){case"deepin":return N.DEEPIN;case"gnome":case"mate":return N.GNOME;case"kde4":case"kde-plasma":return N.KDE4;case"kde":return A in D.env?N.KDE4:N.KDE3;case"xfce":case"xubuntu":return N.XFCE;case"ukui":return N.UKUI}return"GNOME_DESKTOP_SESSION_ID"in D.env?N.GNOME:"KDE_FULL_SESSION"in D.env?A in D.env?N.KDE4:N.KDE3:N.UNKNOWN}}),define(ae[14],ce([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,j=97,A=90,O=122,I=46,C=47,f=92,E=58,y=63;class w extends Error{constructor(r,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const o=r.indexOf(".")!==-1?"property":"argument";let a=`The "${r}" ${o} ${i} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,r){if(t===null||typeof t!="object")throw new w(r,"Object",t)}function c(t,r){if(typeof t!="string")throw new w(r,"string",t)}const p=D.$ec==="win32";function g(t){return t===C||t===f}function l(t){return t===C}function u(t){return t>=N&&t<=A||t>=j&&t<=O}function m(t,r,n,s){let i="",o=0,a=-1,b=0,k=0;for(let v=0;v<=t.length;++v){if(v<t.length)k=t.charCodeAt(v);else{if(s(k))break;k=C}if(s(k)){if(!(a===v-1||b===1))if(b===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==I||i.charCodeAt(i.length-2)!==I){if(i.length>2){const S=i.lastIndexOf(n);S===-1?(i="",o=0):(i=i.slice(0,S),o=i.length-1-i.lastIndexOf(n)),a=v,b=0;continue}else if(i.length!==0){i="",o=0,a=v,b=0;continue}}r&&(i+=i.length>0?`${n}..`:"..",o=2)}else i.length>0?i+=`${n}${t.slice(a+1,v)}`:i=t.slice(a+1,v),o=v-a-1;a=v,b=0}else k===I&&b!==-1?++b:b=-1}return i}function d(t,r){h(r,"pathObject");const n=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${s}`:`${n}${t}${s}`:s}e.$gc={resolve(...t){let r="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let o;if(i>=0){if(o=t[i],c(o,"path"),o.length===0)continue}else r.length===0?o=D.cwd():(o=D.env[`=${r}`]||D.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===f)&&(o=`${r}\\`));const a=o.length;let b=0,k="",v=!1;const S=o.charCodeAt(0);if(a===1)g(S)&&(b=1,v=!0);else if(g(S))if(v=!0,g(o.charCodeAt(1))){let P=2,R=P;for(;P<a&&!g(o.charCodeAt(P));)P++;if(P<a&&P!==R){const M=o.slice(R,P);for(R=P;P<a&&g(o.charCodeAt(P));)P++;if(P<a&&P!==R){for(R=P;P<a&&!g(o.charCodeAt(P));)P++;(P===a||P!==R)&&(k=`\\\\${M}\\${o.slice(R,P)}`,b=P)}}}else b=1;else u(S)&&o.charCodeAt(1)===E&&(k=o.slice(0,2),b=2,a>2&&g(o.charCodeAt(2))&&(v=!0,b=3));if(k.length>0)if(r.length>0){if(k.toLowerCase()!==r.toLowerCase())continue}else r=k;if(s){if(r.length>0)break}else if(n=`${o.slice(b)}\\${n}`,s=v,v&&r.length>0)break}return n=m(n,!s,"\\",g),s?`${r}\\${n}`:`${r}${n}`||"."},normalize(t){c(t,"path");const r=t.length;if(r===0)return".";let n=0,s,i=!1;const o=t.charCodeAt(0);if(r===1)return l(o)?"\\":t;if(g(o))if(i=!0,g(t.charCodeAt(1))){let b=2,k=b;for(;b<r&&!g(t.charCodeAt(b));)b++;if(b<r&&b!==k){const v=t.slice(k,b);for(k=b;b<r&&g(t.charCodeAt(b));)b++;if(b<r&&b!==k){for(k=b;b<r&&!g(t.charCodeAt(b));)b++;if(b===r)return`\\\\${v}\\${t.slice(k)}\\`;b!==k&&(s=`\\\\${v}\\${t.slice(k,b)}`,n=b)}}}else n=1;else u(o)&&t.charCodeAt(1)===E&&(s=t.slice(0,2),n=2,r>2&&g(t.charCodeAt(2))&&(i=!0,n=3));let a=n<r?m(t.slice(n),!i,"\\",g):"";return a.length===0&&!i&&(a="."),a.length>0&&g(t.charCodeAt(r-1))&&(a+="\\"),s===void 0?i?`\\${a}`:a:i?`${s}\\${a}`:`${s}${a}`},isAbsolute(t){c(t,"path");const r=t.length;if(r===0)return!1;const n=t.charCodeAt(0);return g(n)||r>2&&u(n)&&t.charCodeAt(1)===E&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,n;for(let o=0;o<t.length;++o){const a=t[o];c(a,"path"),a.length>0&&(r===void 0?r=n=a:r+=`\\${a}`)}if(r===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&g(n.charCodeAt(0))){++i;const o=n.length;o>1&&g(n.charCodeAt(1))&&(++i,o>2&&(g(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<r.length&&g(r.charCodeAt(i));)i++;i>=2&&(r=`\\${r.slice(i)}`)}return e.$gc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r)return"";const n=e.$gc.resolve(t),s=e.$gc.resolve(r);if(n===s||(t=n.toLowerCase(),r=s.toLowerCase(),t===r))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===f;)i++;let o=t.length;for(;o-1>i&&t.charCodeAt(o-1)===f;)o--;const a=o-i;let b=0;for(;b<r.length&&r.charCodeAt(b)===f;)b++;let k=r.length;for(;k-1>b&&r.charCodeAt(k-1)===f;)k--;const v=k-b,S=a<v?a:v;let P=-1,R=0;for(;R<S;R++){const F=t.charCodeAt(i+R);if(F!==r.charCodeAt(b+R))break;F===f&&(P=R)}if(R!==S){if(P===-1)return s}else{if(v>S){if(r.charCodeAt(b+R)===f)return s.slice(b+R+1);if(R===2)return s.slice(b+R)}a>S&&(t.charCodeAt(i+R)===f?P=R:R===2&&(P=3)),P===-1&&(P=0)}let M="";for(R=i+P+1;R<=o;++R)(R===o||t.charCodeAt(R)===f)&&(M+=M.length===0?"..":"\\..");return b+=P,M.length>0?`${M}${s.slice(b,k)}`:(s.charCodeAt(b)===f&&++b,s.slice(b,k))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$gc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===f){if(r.charCodeAt(1)===f){const n=r.charCodeAt(2);if(n!==y&&n!==I)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===E&&r.charCodeAt(2)===f)return`\\\\?\\${r}`;return t},dirname(t){c(t,"path");const r=t.length;if(r===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(r===1)return g(i)?t:".";if(g(i)){if(n=s=1,g(t.charCodeAt(1))){let b=2,k=b;for(;b<r&&!g(t.charCodeAt(b));)b++;if(b<r&&b!==k){for(k=b;b<r&&g(t.charCodeAt(b));)b++;if(b<r&&b!==k){for(k=b;b<r&&!g(t.charCodeAt(b));)b++;if(b===r)return t;b!==k&&(n=s=b+1)}}}}else u(i)&&t.charCodeAt(1)===E&&(n=r>2&&g(t.charCodeAt(2))?3:2,s=n);let o=-1,a=!0;for(let b=r-1;b>=s;--b)if(g(t.charCodeAt(b))){if(!a){o=b;break}}else a=!1;if(o===-1){if(n===-1)return".";o=n}return t.slice(0,o)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===E&&(n=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,b=-1;for(o=t.length-1;o>=n;--o){const k=t.charCodeAt(o);if(g(k)){if(!i){n=o+1;break}}else b===-1&&(i=!1,b=o+1),a>=0&&(k===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=b))}return n===s?s=b:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=n;--o)if(g(t.charCodeAt(o))){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=0,n=-1,s=0,i=-1,o=!0,a=0;t.length>=2&&t.charCodeAt(1)===E&&u(t.charCodeAt(0))&&(r=s=2);for(let b=t.length-1;b>=r;--b){const k=t.charCodeAt(b);if(g(k)){if(!o){s=b+1;break}continue}i===-1&&(o=!1,i=b+1),k===I?n===-1?n=b:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||i===-1||a===0||a===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:d.bind(null,"\\"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return g(i)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(g(i)){if(s=1,g(t.charCodeAt(1))){let P=2,R=P;for(;P<n&&!g(t.charCodeAt(P));)P++;if(P<n&&P!==R){for(R=P;P<n&&g(t.charCodeAt(P));)P++;if(P<n&&P!==R){for(R=P;P<n&&!g(t.charCodeAt(P));)P++;P===n?s=P:P!==R&&(s=P+1)}}}}else if(u(i)&&t.charCodeAt(1)===E){if(n<=2)return r.root=r.dir=t,r;if(s=2,g(t.charCodeAt(2))){if(n===3)return r.root=r.dir=t,r;s=3}}s>0&&(r.root=t.slice(0,s));let o=-1,a=s,b=-1,k=!0,v=t.length-1,S=0;for(;v>=s;--v){if(i=t.charCodeAt(v),g(i)){if(!k){a=v+1;break}continue}b===-1&&(k=!1,b=v+1),i===I?o===-1?o=v:S!==1&&(S=1):o!==-1&&(S=-1)}return b!==-1&&(o===-1||S===0||S===1&&o===b-1&&o===a+1?r.base=r.name=t.slice(a,b):(r.name=t.slice(a,o),r.base=t.slice(a,b),r.ext=t.slice(o,b))),a>0&&a!==s?r.dir=t.slice(0,a-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const $=(()=>{if(p){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.$hc={resolve(...t){let r="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:$();c(i,"path"),i.length!==0&&(r=`${i}/${r}`,n=i.charCodeAt(0)===C)}return r=m(r,!n,"/",l),n?`/${r}`:r.length>0?r:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===C,n=t.charCodeAt(t.length-1)===C;return t=m(t,!r,"/",l),t.length===0?r?"/":n?"./":".":(n&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===C},join(...t){if(t.length===0)return".";let r;for(let n=0;n<t.length;++n){const s=t[n];c(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.$hc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r||(t=e.$hc.resolve(t),r=e.$hc.resolve(r),t===r))return"";const n=1,s=t.length,i=s-n,o=1,a=r.length-o,b=i<a?i:a;let k=-1,v=0;for(;v<b;v++){const P=t.charCodeAt(n+v);if(P!==r.charCodeAt(o+v))break;P===C&&(k=v)}if(v===b)if(a>b){if(r.charCodeAt(o+v)===C)return r.slice(o+v+1);if(v===0)return r.slice(o+v)}else i>b&&(t.charCodeAt(n+v)===C?k=v:v===0&&(k=0));let S="";for(v=n+k+1;v<=s;++v)(v===s||t.charCodeAt(v)===C)&&(S+=S.length===0?"..":"/..");return`${S}${r.slice(o+k)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===C;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===C){if(!s){n=i;break}}else s=!1;return n===-1?r?"/":".":r&&n===1?"//":t.slice(0,n)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,b=-1;for(o=t.length-1;o>=0;--o){const k=t.charCodeAt(o);if(k===C){if(!i){n=o+1;break}}else b===-1&&(i=!1,b=o+1),a>=0&&(k===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=b))}return n===s?s=b:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===C){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=-1,n=0,s=-1,i=!0,o=0;for(let a=t.length-1;a>=0;--a){const b=t.charCodeAt(a);if(b===C){if(!i){n=a+1;break}continue}s===-1&&(i=!1,s=a+1),b===I?r===-1?r=a:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||s===-1||o===0||o===1&&r===s-1&&r===n+1?"":t.slice(r,s)},format:d.bind(null,"/"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.charCodeAt(0)===C;let s;n?(r.root="/",s=1):s=0;let i=-1,o=0,a=-1,b=!0,k=t.length-1,v=0;for(;k>=s;--k){const S=t.charCodeAt(k);if(S===C){if(!b){o=k+1;break}continue}a===-1&&(b=!1,a=k+1),S===I?i===-1?i=k:v!==1&&(v=1):i!==-1&&(v=-1)}if(a!==-1){const S=o===0&&n?1:o;i===-1||v===0||v===1&&i===a-1&&i===o+1?r.base=r.name=t.slice(S,a):(r.name=t.slice(S,i),r.base=t.slice(S,a),r.ext=t.slice(i,a))}return o>0?r.dir=t.slice(0,o-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=p?e.$gc.normalize:e.$hc.normalize,e.$jc=p?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=p?e.$gc.join:e.$hc.join,e.$lc=p?e.$gc.resolve:e.$hc.resolve,e.$mc=p?e.$gc.relative:e.$hc.relative,e.$nc=p?e.$gc.dirname:e.$hc.dirname,e.$oc=p?e.$gc.basename:e.$hc.basename,e.$pc=p?e.$gc.extname:e.$hc.extname,e.$qc=p?e.$gc.format:e.$hc.format,e.$rc=p?e.$gc.parse:e.$hc.parse,e.$sc=p?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=p?e.$gc.sep:e.$hc.sep,e.$uc=p?e.$gc.delimiter:e.$hc.delimiter}),define(ae[40],ce([0,1,14,5,27,13]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=O,e.$pg=I,e.$qg=C,e.$rg=f,e.$sg=E,e.$tg=c,e.$ug=p,e.$vg=g,e.$wg=l,e.$xg=u,e.$yg=m,e.$zg=d,e.$Ag=$,e.$Bg=t,e.$Cg=r,e.$Dg=n,e.$Eg=o;function O(a){return a===47||a===92}function I(a){return a.replace(/[\\/]/g,D.$hc.sep)}function C(a){return a.indexOf("/")===-1&&(a=I(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}function f(a,b=D.$hc.sep){if(!a)return"";const k=a.length,v=a.charCodeAt(0);if(O(v)){if(O(a.charCodeAt(1))&&!O(a.charCodeAt(2))){let P=3;const R=P;for(;P<k&&!O(a.charCodeAt(P));P++);if(R!==P&&!O(a.charCodeAt(P+1))){for(P+=1;P<k;P++)if(O(a.charCodeAt(P)))return a.slice(0,P+1).replace(/[\\/]/g,b)}}return b}else if(l(v)&&a.charCodeAt(1)===58)return O(a.charCodeAt(2))?a.slice(0,2)+b:a.slice(0,2);let S=a.indexOf("://");if(S!==-1){for(S+=3;S<k;S++)if(O(a.charCodeAt(S)))return a.slice(0,S+1)}return""}function E(a){if(!N.$i||!a||a.length<5)return!1;let b=a.charCodeAt(0);if(b!==92||(b=a.charCodeAt(1),b!==92))return!1;let k=2;const v=k;for(;k<a.length&&(b=a.charCodeAt(k),b!==92);k++);return!(v===k||(b=a.charCodeAt(k+1),isNaN(b)||b===92))}const y=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(a,b=N.$i){const k=b?y:w;return!(!a||a.length===0||/^\s+$/.test(a)||(k.lastIndex=0,k.test(a))||b&&h.test(a)||a==="."||a===".."||b&&a[a.length-1]==="."||b&&a.length!==a.trim().length||a.length>255)}function p(a,b,k){const v=a===b;return!k||v?v:!a||!b?!1:(0,j.$yf)(a,b)}function g(a,b,k,v=D.sep){if(a===b)return!0;if(!a||!b||b.length>a.length)return!1;if(k){if(!(0,j.$zf)(a,b))return!1;if(b.length===a.length)return!0;let P=b.length;return b.charAt(b.length-1)===v&&P--,a.charAt(P)===v}return b.charAt(b.length-1)!==v&&(b+=v),a.indexOf(b)===0}function l(a){return a>=65&&a<=90||a>=97&&a<=122}function u(a,b){return N.$i&&a.endsWith(":")&&(a+=D.sep),(0,D.$jc)(a)||(a=(0,D.$kc)(b,a)),a=(0,D.$ic)(a),m(a)}function m(a){return N.$i?(a=(0,j.$gf)(a,D.sep),a.endsWith(":")&&(a+=D.sep)):(a=(0,j.$gf)(a,D.sep),a||(a=D.sep)),a}function d(a){const b=(0,D.$ic)(a);return N.$i?a.length>3?!1:$(b)&&(a.length===2||b.charCodeAt(2)===92):b===D.$hc.sep}function $(a,b=N.$i){return b?l(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}function t(a,b=N.$i){return $(a,b)?a[0]:void 0}function r(a,b,k){return b.length>a.length?-1:a===b?0:(k&&(a=a.toLowerCase(),b=b.toLowerCase()),a.indexOf(b))}function n(a){const b=a.split(":");let k,v,S;for(const P of b){const R=Number(P);(0,A.$ag)(R)?v===void 0?v=R:S===void 0&&(S=R):k=k?[k,P].join(":"):P}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:v!==void 0?v:void 0,column:S!==void 0?S:v!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(a,b,k=8){let v="";for(let P=0;P<k;P++){let R;P===0&&N.$i&&!b&&(k===3||k===4)?R=i:R=s,v+=R.charAt(Math.floor(Math.random()*R.length))}let S;return b?S=`${b}-${v}`:S=v,a?(0,D.$kc)(a,S):S}}),define(ae[141],ce([0,1,14]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Rs=A,e.$Ss=O,e.$Ts=I,e.$Us=f,e.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},j={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(E){const y=(0,D.$pc)(E),w=N[y.toLowerCase()];return w!==void 0?w:O(E)}function O(E){const y=(0,D.$pc)(E);return j[y.toLowerCase()]}function I(E){for(const y in j)if(j[y]===E)return y}const C=/^(.+)\/(.+?)(;.+)?$/;function f(E,y){const w=C.exec(E);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:y?void 0:E}}),define(ae[89],ce([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=A,e.$nm=O;var N;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(N||(e.Source=N={}));var j;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function A(I,...C){const f=C.reduce((w,h)=>(w[h]=!0,w),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(w=>!f[w]).forEach(w=>{for(let h=0;h<E.length;h++)if(w.search(E[h])!==-1){delete I[w];break}})}function O(I){I&&(delete I.DEBUG,D.$j&&delete I.DYLD_LIBRARY_PATH,D.$k&&delete I.LD_PRELOAD)}}),define(ae[8],ce([0,1,14,5]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=c,e.$xc=d;const j=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function I(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!j.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(s,i){return!s&&!i?"file":s}function f(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const E="",y="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,o,a,b,k,v=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=C(i,v),this.authority=o||E,this.path=f(this.scheme,a||E),this.query=b||E,this.fragment=k||E,I(this,v))}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:a,path:b,query:k,fragment:v}=i;return o===void 0?o=this.scheme:o===null&&(o=E),a===void 0?a=this.authority:a===null&&(a=E),b===void 0?b=this.path:b===null&&(b=E),k===void 0?k=this.query:k===null&&(k=E),v===void 0?v=this.fragment:v===null&&(v=E),o===this.scheme&&a===this.authority&&b===this.path&&k===this.query&&v===this.fragment?this:new g(o,a,b,k,v)}static parse(i,o=!1){const a=w.exec(i);return a?new g(a[2]||E,n(a[4]||E),n(a[5]||E),n(a[7]||E),n(a[9]||E),o):new g(E,E,E,E,E)}static file(i){let o=E;if(N.$i&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const a=i.indexOf(y,2);a===-1?(o=i.substring(2),i=y):(o=i.substring(2,a),i=i.substring(a)||y)}return new g("file",o,i,E,E)}static from(i,o){return new g(i.scheme,i.authority,i.path,i.query,i.fragment,o)}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&i.scheme==="file"?a=h.file(D.$gc.join(d(i,!0),...o)).path:a=D.$hc.join(i.path,...o),i.with({path:a})}toString(i=!1){return $(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const o=new g(i);return o._formatted=i.external??null,o._fsPath=i._sep===p?i.fsPath??null:null,o}}else return i}}e.URI=h;function c(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const p=N.$i?1:void 0;class g extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?$(this,!0):(this._formatted||(this._formatted=$(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function u(s,i,o){let a,b=-1;for(let k=0;k<s.length;k++){const v=s.charCodeAt(k);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||i&&v===47||o&&v===91||o&&v===93||o&&v===58)b!==-1&&(a+=encodeURIComponent(s.substring(b,k)),b=-1),a!==void 0&&(a+=s.charAt(k));else{a===void 0&&(a=s.substr(0,k));const S=l[v];S!==void 0?(b!==-1&&(a+=encodeURIComponent(s.substring(b,k)),b=-1),a+=S):b===-1&&(b=k)}}return b!==-1&&(a+=encodeURIComponent(s.substring(b))),a!==void 0?a:s}function m(s){let i;for(let o=0;o<s.length;o++){const a=s.charCodeAt(o);a===35||a===63?(i===void 0&&(i=s.substr(0,o)),i+=l[a]):i!==void 0&&(i+=s[o])}return i!==void 0?i:s}function d(s,i){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,N.$i&&(o=o.replace(/\//g,"\\")),o}function $(s,i){const o=i?m:u;let a="",{scheme:b,authority:k,path:v,query:S,fragment:P}=s;if(b&&(a+=b,a+=":"),(k||b==="file")&&(a+=y,a+=y),k){let R=k.indexOf("@");if(R!==-1){const M=k.substr(0,R);k=k.substr(R+1),R=M.lastIndexOf(":"),R===-1?a+=o(M,!1,!1):(a+=o(M.substr(0,R),!1,!1),a+=":",a+=o(M.substr(R+1),!1,!0)),a+="@"}k=k.toLowerCase(),R=k.lastIndexOf(":"),R===-1?a+=o(k,!1,!0):(a+=o(k.substr(0,R),!1,!0),a+=k.substr(R))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const R=v.charCodeAt(1);R>=65&&R<=90&&(v=`/${String.fromCharCode(R+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const R=v.charCodeAt(0);R>=65&&R<=90&&(v=`${String.fromCharCode(R+32)}:${v.substr(2)}`)}a+=o(v,!0,!1)}return S&&(a+="?",a+=o(S,!1,!1)),P&&(a+="#",a+=i?P:u(P,!1,!1)),a}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(r)?s.replace(r,i=>t(i)):s}}),define(ae[142],ce([0,1,8]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=N,e.$Wq=j,e.$Xq=A,e.log=I;function N(f){const E=f;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function j(f){const E=[];let y;try{const w=JSON.parse(f.arguments),h=w[w.length-1];h&&h.__$stack&&(w.pop(),y=h.__$stack),E.push(...w)}catch{E.push("Unable to log remote console arguments",f.arguments)}return{args:E,stack:y}}function A(f){if(typeof f!="string")return A(j(f).stack);const E=f;if(E){const y=O(E),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(w&&w.length===4)return{uri:D.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function O(f){if(!f)return f;const E=f.indexOf(`
`);return E===-1?f:f.substring(0,E)}function I(f,E){const{args:y,stack:w}=j(f),h=typeof y[0]=="string"&&y.length===1;let c=O(w);c&&(c=`(${c.trim()})`);let p=[];if(typeof y[0]=="string"?c&&h?p=[`%c[${E}] %c${y[0]} %c${c}`,C("blue"),C(""),C("grey")]:p=[`%c[${E}] %c${y[0]}`,C("blue"),C(""),...y.slice(1)]:p=[`%c[${E}]%`,C("blue"),...y],c&&!h&&p.push(c),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,p)}function C(f){return`color: ${f}`}}),define(ae[66],ce([0,1,15,8]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=j,e.$5h=A,e.$6h=I;function j(C){return JSON.stringify(C,O)}function A(C){let f=JSON.parse(C);return f=I(f),f}function O(C,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function I(C,f=0){if(!C||f>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return N.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 17:return new Date(C.source)}if(C instanceof D.$Ge||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let E=0;E<C.length;++E)C[E]=I(C[E],f+1);else for(const E in C)Object.hasOwnProperty.call(C,E)&&(C[E]=I(C[E],f+1))}return C}}),define(ae[23],ce([0,1,7,5,27,8,14]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=C,e.$Gg=f,e.$Kg=y;var I;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(I||(e.Schemas=I={}));function C(c,p){return A.URI.isUri(c)?(0,j.$yf)(c.scheme,p):(0,j.$zf)(c,p+":")}function f(c,...p){return p.some(g=>C(c,g))}e.$Hg="vscode-tkn",e.$Ig="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p,g){this.f=y(p,g)}getServerRootPath(){return this.f}get g(){return O.$hc.join(this.f,I.vscodeRemoteResource)}set(p,g,l){this.a[p]=g,this.b[p]=l}setConnectionToken(p,g){this.c[p]=g}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch($){return D.$1($),p}const g=p.authority;let l=this.a[g];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const u=this.b[g],m=this.c[g];let d=`path=${encodeURIComponent(p.path)}`;return typeof m=="string"&&(d+=`&${e.$Ig}=${encodeURIComponent(m)}`),A.URI.from({scheme:N.$o?this.d:I.vscodeRemoteResource,authority:`${l}:${u}`,path:this.g,query:d})}}e.$Jg=new E;function y(c,p){return O.$hc.join(p??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class w{static{this.a=e.$Pg}asBrowserUri(p){const g=this.b(p,ne);return this.uriToBrowserUri(g)}uriToBrowserUri(p){return p.scheme===I.vscodeRemote?e.$Jg.rewrite(p):p.scheme===I.file&&(N.$m||N.$q===`${I.vscodeFileResource}://${w.a}`)?p.with({scheme:I.vscodeFileResource,authority:p.authority||w.a,query:null,fragment:null}):p}asFileUri(p){const g=this.b(p,ne);return this.uriToFileUri(g)}uriToFileUri(p){return p.scheme===I.vscodeFileResource?p.with({scheme:I.file,authority:p.authority!==w.a?p.authority:null,query:null,fragment:null}):p}b(p,g){return A.URI.isUri(p)?p:A.URI.parse(g.toUrl(p))}}e.$Qg=new w;var h;(function(c){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(p.get("3"));const g="vscode-coi";function l(m){let d;typeof m=="string"?d=new URL(m).searchParams:m instanceof URL?d=m.searchParams:A.URI.isUri(m)&&(d=new URL(m.toString(!0)).searchParams);const $=d?.get(g);if($)return p.get($)}c.getHeadersFromQuery=l;function u(m,d,$){if(!globalThis.crossOriginIsolated)return;const t=d&&$?"3":$?"2":"1";m instanceof URLSearchParams?m.set(g,t):m[g]=t}c.addSearchParam=u})(h||(e.COI=h={}))}),define(ae[143],ce([0,1,124,23,5,8]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1D=E;class O{constructor(w,h,c){this.id=w,this.dependencies=h,this.callback=c}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,h,c)=>{typeof w!="string"&&(c=h,h=w,w=null),(typeof h!="object"||!Array.isArray(h))&&(c=h,h=null),this.c.push(new O(w,h,c))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const h=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!h)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(w){return new Promise((h,c)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const g=()=>{p.removeEventListener("load",l),p.removeEventListener("error",u)},l=m=>{g(),h(this.c.pop())},u=m=>{g(),c(m)};p.addEventListener("load",l),p.addEventListener("error",u),this.f&&(w=this.f.createScriptURL(w)),p.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(p)})}i(w){return new Promise((h,c)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),h(this.c.pop())}catch(p){c(p)}})}async j(w){try{const h=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,g=A.URI.parse(w).fsPath,l=h.readFileSync(g).toString(),u=p.wrap(l.replace(/^#!.*/,""));return new c.Script(u).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const C=new Map;let f={};typeof globalThis.require=="object"&&(f=globalThis.require.paths??{});async function E(y,w,h){if(D.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),f[y]&&(y=f[y]);const c=`${y}/${w}`;if(C.has(c))return C.get(c);let p;if(/^\w[\w\d+.-]*:\/\//.test(c))p=c;else{const m=`${h&&!j.$o?N.$Ng:N.$Mg}/${c}`;p=N.$Qg.asBrowserUri(m).toString(!0)}const g=I.INSTANCE.load(p);return C.set(c,g),g}else return await new Promise((c,p)=>{ne([y],c,p)})}}),define(ae[20],ce([0,1,40,23,14,5,27,8]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=C,e.$gh=E,e.$hh=w;function C(h){return(0,I.$xc)(h,!0)}class f{constructor(c){this.a=c}compare(c,p,g=!1){return c===p?0:(0,O.$rf)(this.getComparisonKey(c,g),this.getComparisonKey(p,g))}isEqual(c,p,g=!1){return c===p?!0:!c||!p?!1:this.getComparisonKey(c,g)===this.getComparisonKey(p,g)}getComparisonKey(c,p=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,p,g=!1){if(c.scheme===p.scheme){if(c.scheme===N.Schemas.file)return D.$vg(C(c),C(p),this.a(c))&&c.query===p.query&&(g||c.fragment===p.fragment);if((0,e.$ch)(c.authority,p.authority))return D.$vg(c.path,p.path,this.a(c),"/")&&c.query===p.query&&(g||c.fragment===p.fragment)}return!1}joinPath(c,...p){return I.URI.joinPath(c,...p)}basenameOrAuthority(c){return(0,e.$7g)(c)||c.authority}basename(c){return j.$hc.basename(c.path)}extname(c){return j.$hc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let p;return c.scheme===N.Schemas.file?p=I.URI.file(j.$nc(C(c))).path:(p=j.$hc.dirname(c.path),c.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),p="/")),c.with({path:p})}normalizePath(c){if(!c.path.length)return c;let p;return c.scheme===N.Schemas.file?p=I.URI.file(j.$ic(C(c))).path:p=j.$hc.normalize(c.path),c.with({path:p})}relativePath(c,p){if(c.scheme!==p.scheme||!(0,e.$ch)(c.authority,p.authority))return;if(c.scheme===N.Schemas.file){const u=j.$mc(C(c),C(p));return A.$i?D.$pg(u):u}let g=c.path||"/";const l=p.path||"/";if(this.a(c)){let u=0;for(const m=Math.min(g.length,l.length);u<m&&!(g.charCodeAt(u)!==l.charCodeAt(u)&&g.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);g=l.substr(0,u)+g.substr(u)}return j.$hc.relative(g,l)}resolvePath(c,p){if(c.scheme===N.Schemas.file){const g=I.URI.file(j.$lc(C(c),p));return c.with({authority:g.authority,path:g.path})}return p=D.$qg(p),c.with({path:j.$hc.resolve(c.path,p)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,p){return c===p||c!==void 0&&p!==void 0&&(0,O.$yf)(c,p)}hasTrailingPathSeparator(c,p=j.sep){if(c.scheme===N.Schemas.file){const g=C(c);return g.length>D.$rg(g).length&&g[g.length-1]===p}else{const g=c.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,p=j.sep){return(0,e.$dh)(c,p)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,p=j.sep){let g=!1;if(c.scheme===N.Schemas.file){const l=C(c);g=l!==void 0&&l.length===D.$rg(l).length&&l[l.length-1]===p}else{p="/";const l=c.path;g=l.length===1&&l.charCodeAt(l.length-1)===47}return!g&&!(0,e.$dh)(c,p)?c.with({path:c.path+"/"}):c}}e.$Yg=f,e.$Zg=new f(()=>!1),e.$1g=new f(h=>h.scheme===N.Schemas.file?!A.$k:!0),e.$2g=new f(h=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function E(h,c){const p=[];for(let g=0;g<h.length;g++){const l=c(h[g]);h.some((u,m)=>m===g?!1:(0,e.$4g)(l,c(u)))||p.push(h[g])}return p}var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function c(p){const g=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(m=>{const[d,$]=m.split(":");d&&$&&g.set(d,$)});const u=p.path.substring(0,p.path.indexOf(";"));return u&&g.set(h.META_DATA_MIME,u),g}h.parseMetaData=c})(y||(e.DataUri=y={}));function w(h,c,p){if(c){let g=h.path;return g&&g[0]!==j.$hc.sep&&(g=j.$hc.sep+g),h.with({scheme:p,authority:c,path:g})}return h.with({scheme:p})}}),define(ae[6],ce([0,1,26,7,3,2,20,5,130,53]),function(ne,e,D,N,j,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=E,e.$jh=y,e.$kh=w,e.$lh=h,e.$mh=c,e.$nh=p,e.$oh=g,e.$ph=l,e.$xh=o,e.$yh=a,e.$zh=b,e.$Ah=k,e.$Bh=v,e.$Qh=B,e.$Yh=K;function E(_){return!!_&&typeof _.then=="function"}function y(_){const Z=new D.$pe,se=_(Z.token),ue=new Promise((ge,fe)=>{const $e=Z.token.onCancellationRequested(()=>{$e.dispose(),fe(new N.$5)});Promise.resolve(se).then(ye=>{$e.dispose(),Z.dispose(),ge(ye)},ye=>{$e.dispose(),Z.dispose(),fe(ye)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(ge,fe){return ue.then(ge,fe)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function w(_,Z,se){return new Promise((ue,ge)=>{const fe=Z.onCancellationRequested(()=>{fe.dispose(),ue(se)});_.then(ue,ge).finally(()=>fe.dispose())})}function h(_,Z){return new Promise((se,ue)=>{const ge=Z.onCancellationRequested(()=>{ge.dispose(),ue(new N.$5)});_.then(se,ue).finally(()=>ge.dispose())})}async function c(_){let Z=-1;const se=_.map((ue,ge)=>ue.then(fe=>(Z=ge,fe)));try{return await Promise.race(se)}finally{_.forEach((ue,ge)=>{ge!==Z&&ue.cancel()})}}function p(_,Z,se){let ue;const ge=setTimeout(()=>{ue?.(void 0),se?.()},Z);return Promise.race([_.finally(()=>clearTimeout(ge)),new Promise(fe=>ue=fe)])}function g(_){return new Promise((Z,se)=>{const ue=_();E(ue)?ue.then(Z,se):Z(ue)})}function l(){let _,Z;return{promise:new Promise((ue,ge)=>{_=ue,Z=ge}),resolve:_,reject:Z}}class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const se=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(se,se).then(ue)})}return new Promise((se,ue)=>{this.b.then(se,ue)})}return this.a=Z(),new Promise((se,ue)=>{this.a.then(ge=>{this.a=null,se(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$qh=u;class m{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$rh=m;class d{constructor(){this.a=new Map}queue(Z,se){const ge=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(Z)===ge&&this.a.delete(Z)});return this.a.set(Z,ge),ge}}e.$sh=d;const $=(_,Z)=>{let se=!0;const ue=setTimeout(()=>{se=!1,Z()},_);return{isTriggered:()=>se,dispose:()=>{clearTimeout(ue),se=!1}}},t=_=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,_())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class r{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,se=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((ge,fe)=>{this.d=ge,this.f=fe}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=se===C.$be?t(ue):$(se,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=r;class n{constructor(Z){this.a=new r(Z),this.b=new u}trigger(Z,se){return this.a.trigger(()=>this.b.queue(Z),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=n;class s{constructor(){this.a=!1,this.b=new Promise((Z,se)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=s;class i extends s{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$wh=i;function o(_,Z){return Z?new Promise((se,ue)=>{const ge=setTimeout(()=>{fe.dispose(),se()},_),fe=Z.onCancellationRequested(()=>{clearTimeout(ge),fe.dispose(),ue(new N.$5)})}):y(se=>o(_,se))}function a(_,Z=0,se){const ue=setTimeout(()=>{_(),se&&ge.dispose()},Z),ge=(0,A.$Tc)(()=>{clearTimeout(ue),se?.deleteAndLeak(ge)});return se?.add(ge),ge}function b(_){const Z=[];let se=0;const ue=_.length;function ge(){return se<ue?_[se++]():null}function fe($e){$e!=null&&Z.push($e);const ye=ge();return ye?ye.then(fe):Promise.resolve(Z)}return Promise.resolve(null).then(fe)}function k(_,Z=ue=>!!ue,se=null){let ue=0;const ge=_.length,fe=()=>{if(ue>=ge)return Promise.resolve(se);const $e=_[ue++];return Promise.resolve($e()).then(ve=>Z(ve)?Promise.resolve(ve):fe())};return fe()}function v(_,Z=ue=>!!ue,se=null){if(_.length===0)return Promise.resolve(se);let ue=_.length;const ge=()=>{ue=-1;for(const fe of _)fe.cancel?.()};return new Promise((fe,$e)=>{for(const ye of _)ye.then(ve=>{--ue>=0&&Z(ve)?(ge(),fe(ve)):ue===0&&fe(se)}).catch(ve=>{--ue>=0&&(ge(),$e(ve))})})}class S{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new j.$ee}whenIdle(){return this.size>0?j.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,ue)=>{this.g.push({factory:Z,c:se,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const se=Z.factory();se.then(Z.c,Z.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=S;class P extends S{constructor(){super(1)}}e.$Dh=P;class R{constructor(){this.a=new ie,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Eh=R;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new te;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,se=O.$Zg){const ue=se.getComparisonKey(Z);return this.a.get(ue)?.size??0}queueFor(Z,se,ue=O.$Zg){const ge=ue.getComparisonKey(Z);let fe=this.a.get(ge);if(!fe){fe=new P;const $e=this.f++,ye=j.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$5c),this.d.set($e,ye),this.a.set(ge,fe)}return fe.queue(se)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=M;class F{constructor(Z,se){this.a=-1,typeof Z=="function"&&typeof se=="number"&&this.setIfNotSet(Z,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},se)}setIfNotSet(Z,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},se))}}e.$Gh=F;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,se,ue=globalThis){this.cancel();const ge=ue.setInterval(()=>{Z()},se);this.d=(0,A.$Tc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=q;class Y{constructor(Z,se){this.b=-1,this.a=Z,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=Y;class H{constructor(Z,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=Z,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=H;class X extends Y{constructor(Z,se){super(Z,se),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Kh=X;class W extends A.$Vc{constructor(Z,se){super(),this.g=Z,this.h=se,this.a=[],this.b=this.B(new A.$Wc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of Z)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Y(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(_,Z)=>{(0,I.$B)(()=>{if(se)return;const ue=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Nh=(_,Z,se)=>{const ue=_.requestIdleCallback(Z,typeof se=="number"?{timeout:se}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,_.cancelIdleCallback(ue))}}},e.$Mh=_=>(0,e.$Nh)(globalThis,_)}();class J{constructor(Z,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Nh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=J;class G extends J{constructor(Z){super(globalThis,Z)}}e.$Ph=G;async function B(_,Z,se){let ue;for(let ge=0;ge<se;ge++)try{return await _()}catch(fe){ue=fe,await o(Z)}throw ue}class ie{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,se,ue){return this.a={taskId:Z,cancel:()=>ue?.(),promise:se},se.then(()=>this.d(Z),()=>this.d(Z)),se}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:se,resolve:ue,reject:ge}=l();this.b={run:Z,promise:se,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=ie;class re{constructor(Z,se=()=>Date.now()){this.d=Z,this.f=se,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$Sh=re;var he;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(he||(he={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Z,se)=>{this.a=Z,this.b=se})}complete(Z){return new Promise(se=>{this.a(Z),this.d={outcome:0,value:Z},se()})}error(Z){return new Promise(se=>{this.b(Z),this.d={outcome:1,value:Z},se()})}cancel(){return this.error(new N.$5)}}e.$Th=te;var V;(function(_){async function Z(ue){let ge;const fe=await Promise.all(ue.map($e=>$e.then(ye=>ye,ye=>{ge||(ge=ye)})));if(typeof ge<"u")throw ge;return fe}_.settled=Z;function se(ue){return new Promise(async(ge,fe)=>{try{await ue(ge,fe)}catch($e){fe($e)}})}_.withAsyncBody=se})(V||(e.Promises=V={}));class z{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=z;class L{constructor(Z){this.b=Z,this.a=new f.$V(()=>new z(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=L;var T;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(T||(T={}));class U{static fromArray(Z){return new U(se=>{se.emitMany(Z)})}static fromPromise(Z){return new U(async se=>{se.emitMany(await Z)})}static fromPromises(Z){return new U(async se=>{await Promise.all(Z.map(async ue=>se.emitOne(await ue)))})}static merge(Z){return new U(async se=>{await Promise.all(Z.map(async ue=>{for await(const ge of ue)se.emitOne(ge)}))})}static{this.EMPTY=U.fromArray([])}constructor(Z,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new j.$ee,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Z(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await j.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,se){return new U(async ue=>{for await(const ge of Z)ue.emitOne(se(ge))})}map(Z){return U.map(this,Z)}static filter(Z,se){return new U(async ue=>{for await(const ge of Z)se(ge)&&ue.emitOne(ge)})}filter(Z){return U.filter(this,Z)}static coalesce(Z){return U.filter(Z,se=>!!se)}coalesce(){return U.coalesce(this)}static async toPromise(Z){const se=[];for await(const ue of Z)se.push(ue);return se}toPromise(){return U.toPromise(this)}h(Z){this.a===0&&(this.b.push(Z),this.g.fire())}j(Z){this.a===0&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Z){this.a===0&&(this.a=2,this.d=Z,this.g.fire())}}e.$Wh=U;class x extends U{constructor(Z,se){super(se),this.m=Z}cancel(){this.m.cancel()}}e.$Xh=x;function K(_){const Z=new D.$pe,se=_(Z.token);return new x(Z,async ue=>{const ge=Z.token.onCancellationRequested(()=>{ge.dispose(),Z.dispose(),ue.reject(new N.$5)});try{for await(const fe of se){if(Z.token.isCancellationRequested)return;ue.emitOne(fe)}ge.dispose(),Z.dispose()}catch(fe){ge.dispose(),Z.dispose(),ue.reject(fe)}})}class ee{constructor(Z){this.a=new te,this.b=new U(ge=>{if(se){ge.reject(se);return}return ue&&ge.emitMany(ue),this.d=fe=>ge.reject(fe),this.f=fe=>ge.emitOne(fe),this.a.p},Z);let se,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{se||(se=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$Zh=ee}),define(ae[90],ce([0,1,17,6,40,34,14,5,27]),function(ne,e,D,N,j,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=f,e.$ok=c,e.$pk=P,e.$qk=R,e.$rk=M,e.$sk=F,e.$tk=q,e.$uk=W;function f(){return Object.create(null)}e.$mk="**",e.$nk="/";const E="[/\\\\]",y="[^/\\\\]",w=/\//g;function h(J,G){switch(J){case 0:return"";case 1:return`${y}*?`;default:return`(?:${E}|${y}+${E}${G?`|${E}${y}+`:""})*?`}}function c(J,G){if(!J)return[];const B=[];let ie=!1,re=!1,he="";for(const te of J){switch(te){case G:if(!ie&&!re){B.push(he),he="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":re=!0;break;case"]":re=!1;break}he+=te}return he&&B.push(he),B}function p(J){if(!J)return"";let G="";const B=c(J,e.$nk);if(B.every(ie=>ie===e.$mk))G=".*";else{let ie=!1;B.forEach((re,he)=>{if(re===e.$mk){if(ie)return;G+=h(2,he===B.length-1)}else{let te=!1,V="",z=!1,L="";for(const T of re){if(T!=="}"&&te){V+=T;continue}if(z&&(T!=="]"||!L)){let U;T==="-"?U=T:(T==="^"||T==="!")&&!L?U="^":T===e.$nk?U="":U=(0,C.$af)(T),L+=U;continue}switch(T){case"{":te=!0;continue;case"[":z=!0;continue;case"}":{const x=`(?:${c(V,",").map(K=>p(K)).join("|")})`;G+=x,te=!1,V="";break}case"]":{G+="["+L+"]",z=!1,L="";break}case"?":G+=y;continue;case"*":G+=h(1);continue;default:G+=(0,C.$af)(T)}}he<B.length-1&&(B[he+1]!==e.$mk||he+2<B.length)&&(G+=E)}ie=re===e.$mk})}return G}const g=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,$=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Ec(1e4),r=function(){return!1},n=function(){return null};function s(J,G){if(!J)return n;let B;typeof J!="string"?B=J.pattern:B=J,B=B.trim();const ie=`${B}_${!!G.trimForExclusions}`;let re=t.get(ie);if(re)return i(re,J);let he;return g.test(B)?re=a(B.substr(4),B):(he=l.exec(o(B,G)))?re=b(he[1],B):(G.trimForExclusions?m:u).test(B)?re=k(B,G):(he=d.exec(o(B,G)))?re=v(he[1].substr(1),B,!0):(he=$.exec(o(B,G)))?re=v(he[1],B,!1):re=S(B),t.set(ie,re),i(re,J)}function i(J,G){if(typeof G=="string")return J;const B=function(ie,re){return(0,j.$vg)(ie,G.base,!I.$k)?J((0,C.$ff)(ie.substr(G.base.length),O.sep),re):null};return B.allBasenames=J.allBasenames,B.allPaths=J.allPaths,B.basenames=J.basenames,B.patterns=J.patterns,B}function o(J,G){return G.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function a(J,G){return function(B,ie){return typeof B=="string"&&B.endsWith(J)?G:null}}function b(J,G){const B=`/${J}`,ie=`\\${J}`,re=function(te,V){return typeof te!="string"?null:V?V===J?G:null:te===J||te.endsWith(B)||te.endsWith(ie)?G:null},he=[J];return re.basenames=he,re.patterns=[G],re.allBasenames=he,re}function k(J,G){const B=X(J.slice(1,-1).split(",").map(V=>s(V,G)).filter(V=>V!==n),J),ie=B.length;if(!ie)return n;if(ie===1)return B[0];const re=function(V,z){for(let L=0,T=B.length;L<T;L++)if(B[L](V,z))return J;return null},he=B.find(V=>!!V.allBasenames);he&&(re.allBasenames=he.allBasenames);const te=B.reduce((V,z)=>z.allPaths?V.concat(z.allPaths):V,[]);return te.length&&(re.allPaths=te),re}function v(J,G,B){const ie=O.sep===O.$hc.sep,re=ie?J:J.replace(w,O.sep),he=O.sep+re,te=O.$hc.sep+J;let V;return B?V=function(z,L){return typeof z=="string"&&(z===re||z.endsWith(he)||!ie&&(z===J||z.endsWith(te)))?G:null}:V=function(z,L){return typeof z=="string"&&(z===re||!ie&&z===J)?G:null},V.allPaths=[(B?"*/":"./")+J],V}function S(J){try{const G=new RegExp(`^${p(J)}$`);return function(B){return G.lastIndex=0,typeof B=="string"&&G.test(B)?J:null}}catch{return n}}function P(J,G,B){return!J||typeof G!="string"?!1:R(J)(G,void 0,B)}function R(J,G={}){if(!J)return r;if(typeof J=="string"||M(J)){const B=s(J,G);if(B===n)return r;const ie=function(re,he){return!!B(re,he)};return B.allBasenames&&(ie.allBasenames=B.allBasenames),B.allPaths&&(ie.allPaths=B.allPaths),ie}return Y(J,G)}function M(J){const G=J;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}function F(J){return J.allBasenames||[]}function q(J){return J.allPaths||[]}function Y(J,G){const B=X(Object.getOwnPropertyNames(J).map(V=>H(V,J[V],G)).filter(V=>V!==n)),ie=B.length;if(!ie)return n;if(!B.some(V=>!!V.requiresSiblings)){if(ie===1)return B[0];const V=function(T,U){let x;for(let K=0,ee=B.length;K<ee;K++){const _=B[K](T,U);if(typeof _=="string")return _;(0,N.$ih)(_)&&(x||(x=[]),x.push(_))}return x?(async()=>{for(const K of x){const ee=await K;if(typeof ee=="string")return ee}return null})():null},z=B.find(T=>!!T.allBasenames);z&&(V.allBasenames=z.allBasenames);const L=B.reduce((T,U)=>U.allPaths?T.concat(U.allPaths):T,[]);return L.length&&(V.allPaths=L),V}const re=function(V,z,L){let T,U;for(let x=0,K=B.length;x<K;x++){const ee=B[x];ee.requiresSiblings&&L&&(z||(z=(0,O.$oc)(V)),T||(T=z.substr(0,z.length-(0,O.$pc)(V).length)));const _=ee(V,z,T,L);if(typeof _=="string")return _;(0,N.$ih)(_)&&(U||(U=[]),U.push(_))}return U?(async()=>{for(const x of U){const K=await x;if(typeof K=="string")return K}return null})():null},he=B.find(V=>!!V.allBasenames);he&&(re.allBasenames=he.allBasenames);const te=B.reduce((V,z)=>z.allPaths?V.concat(z.allPaths):V,[]);return te.length&&(re.allPaths=te),re}function H(J,G,B){if(G===!1)return n;const ie=s(J,B);if(ie===n)return n;if(typeof G=="boolean")return ie;if(G){const re=G.when;if(typeof re=="string"){const he=(te,V,z,L)=>{if(!L||!ie(te,V))return null;const T=re.replace("$(basename)",()=>z),U=L(T);return(0,N.$ih)(U)?U.then(x=>x?J:null):U?J:null};return he.requiresSiblings=!0,he}}return ie}function X(J,G){const B=J.filter(V=>!!V.basenames);if(B.length<2)return J;const ie=B.reduce((V,z)=>{const L=z.basenames;return L?V.concat(L):V},[]);let re;if(G){re=[];for(let V=0,z=ie.length;V<z;V++)re.push(G)}else re=B.reduce((V,z)=>{const L=z.patterns;return L?V.concat(L):V},[]);const he=function(V,z){if(typeof V!="string")return null;if(!z){let T;for(T=V.length;T>0;T--){const U=V.charCodeAt(T-1);if(U===47||U===92)break}z=V.substr(T)}const L=ie.indexOf(z);return L!==-1?re[L]:null};he.basenames=ie,he.patterns=re,he.allBasenames=ie;const te=J.filter(V=>!V.basenames);return te.push(he),te}function W(J,G){return(0,D.$ub)(J,G,(B,ie)=>typeof B=="string"&&typeof ie=="string"?B===ie:typeof B!="string"&&typeof ie!="string"?B.base===ie.base&&B.pattern===ie.pattern:!1)}}),define(ae[91],ce([0,1,15,8]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=I,e.$Bn=f,e.$Cn=E;function j(y){return y.toJSON()}class A{constructor(w){this.a=w}transformIncoming(w){const h=this.a.transformIncoming(w);return h===w?w:j(N.URI.from(h))}transformOutgoing(w){const h=this.a.transformOutgoing(w);return h===w?w:j(N.URI.from(h))}transformOutgoingURI(w){const h=this.a.transformOutgoing(w);return h===w?w:N.URI.from(h)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$yn=A,e.$zn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function O(y,w,h){if(!y||h>200)return null;if(typeof y=="object"){if(y instanceof N.URI)return w.transformOutgoing(y);for(const c in y)if(Object.hasOwnProperty.call(y,c)){const p=O(y[c],w,h+1);p!==null&&(y[c]=p)}}return null}function I(y,w){const h=O(y,w,0);return h===null?y:h}function C(y,w,h,c){if(!y||c>200)return null;if(typeof y=="object"){if(y.$mid===1)return h?N.URI.revive(w.transformIncoming(y)):w.transformIncoming(y);if(y instanceof D.$Ge)return null;for(const p in y)if(Object.hasOwnProperty.call(y,p)){const g=C(y[p],w,h,c+1);g!==null&&(y[p]=g)}}return null}function f(y,w){const h=C(y,w,!1,0);return h===null?y:h}function E(y,w){const h=C(y,w,!0,0);return h===null?y:h}}),define(ae[144],ce([0,1,37,51,32,131,5]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=void 0,e.$Fn=C,e.$Gn=y,e.$En=new class{c(w){return this.a||(this.a=N.$Ci.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,h=0;const c=(0,D.networkInterfaces)();for(const p in c){const g=c[p];if(g)for(const{mac:l,internal:u}of g)u||(h+=1,this.c(l.toUpperCase())&&(w+=1))}this.b=h>0?w/h:0}return this.b}};let I;async function C(w){return I||(I=(async()=>await f(w)||j.$Sg())()),I}async function f(w){try{const h=await new Promise((p,g)=>{ne(["crypto"],p,g)}),c=(0,A.$Dn)();return h.createHash("sha256").update(c,"utf8").digest("hex")}catch(h){w(h);return}}const E="Software\\Microsoft\\SQMClient";async function y(w){if(O.$i){const h=await new Promise((c,p)=>{ne(["@vscode/windows-registry"],c,p)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(c){return w(c),""}}return""}}),define(ae[145],ce([0,1,41,146,14,36]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QW=E,e.$RW=y;const O="XDG_SESSION_TYPE",I="WAYLAND_DISPLAY",C="XDG_RUNTIME_DIR";var f;(function(w){w.Wayland="wayland",w.XWayland="xwayland",w.X11="x11",w.Unknown="unknown"})(f||(f={}));async function E(w){const h=A.env[O];if(h)return h==="wayland"||h==="x11"?h:"unknown";if(A.env[I]){const p=A.env[C];if(p){const g=(0,j.$kc)(p,"wayland-0");try{return await(0,N.access)(g,D.constants.R_OK),"wayland"}catch(l){return w(l),"unknown"}}else return"unknown"}else return"x11"}function y(w,h){if(h)switch(h){case"auto":return w;case"x11":return w==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return w==="wayland"?"xwayland":"x11"}}),define(ae[147],ce([0,1,41,146,274,5]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tg=O;async function O(I){if(A.$j||A.$i)return;let C;for(const f of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{C=await(0,N.open)(f,D.constants.R_OK);break}catch{}if(!C){I("Unable to retrieve release information from known identifier paths.");return}try{const f=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const y of(0,j.createInterface)({input:C.createReadStream(),crlfDelay:1/0})){if(!y.includes("="))continue;const w=y.split("=")[0].toUpperCase().trim();if(f.has(w)){const h=y.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?E.id=h:w==="ID_LIKE"?E.id_like=h:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(E.version_id=h)}}return E}catch(f){I(f)}}}),define(ae[31],ce([0,1,41,37,275,6,40,87,14,5,20,8]),function(ne,e,D,N,j,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=m,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=b;var w;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function h(H,X=w.UNLINK,W){if((0,O.$zg)(H))throw new Error("rimraf - will refuse to recursively delete root");return X===w.UNLINK?p(H):c(H,W)}async function c(H,X=(0,O.$Eg)((0,N.tmpdir)())){try{try{await D.promises.rename(H,X)}catch(W){return W.code==="ENOENT"?void 0:p(H)}p(X).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function p(H){return(0,j.promisify)(D.rm)(H,{recursive:!0,force:!0,maxRetries:3})}function g(H){if((0,O.$zg)(H))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}async function l(H,X){return d(await(X?u(H):(0,j.promisify)(D.readdir)(H)))}async function u(H){try{return await(0,j.promisify)(D.readdir)(H,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const X=[],W=await l(H);for(const J of W){let G=!1,B=!1,ie=!1;try{const re=await e.Promises.lstat((0,C.$kc)(H,J));G=re.isFile(),B=re.isDirectory(),ie=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}X.push({name:J,isFile:()=>G,isDirectory:()=>B,isSymbolicLink:()=>ie})}return X}function m(H){return d(D.readdirSync(H))}function d(H){return H.map(X=>typeof X=="string"?f.$j?(0,I.$bm)(X):X:(X.name=f.$j?(0,I.$bm)(X.name):X.name,X))}async function $(H){const X=await l(H),W=[];for(const J of X)await r.existsDirectory((0,C.$kc)(H,J))&&W.push(J);return W}function t(H,X=1e3){return new Promise(W=>{let J=!1;const G=setInterval(()=>{J||(J=!0,D.access(H,B=>{J=!1,B&&(clearInterval(G),W(void 0))}))},X)})}var r;(function(H){async function X(G){let B;try{if(B=await e.Promises.lstat(G),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(f.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw re}throw ie}}H.stat=X;async function W(G){try{const{stat:B,symbolicLink:ie}=await H.stat(G);return B.isFile()&&ie?.dangling!==!0}catch{}return!1}H.existsFile=W;async function J(G){try{const{stat:B,symbolicLink:ie}=await H.stat(G);return B.isDirectory()&&ie?.dangling!==!0}catch{}return!1}H.existsDirectory=J})(r||(e.SymlinkSupport=r={}));const n=new A.$Fh;function s(H,X,W){return n.queueFor(y.URI.file(H),()=>{const J=k(W);return new Promise((G,B)=>a(H,X,J,ie=>ie?B(ie):G()))},E.$1g)}let i=!0;function o(H){i=H}function a(H,X,W,J){if(!i)return D.writeFile(H,X,{mode:W.mode,flag:W.flag},J);D.open(H,W.flag,W.mode,(G,B)=>{if(G)return J(G);D.writeFile(B,X,ie=>{if(ie)return D.close(B,()=>J(ie));D.fdatasync(B,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),o(!1)),D.close(B,he=>J(he))))})})}function b(H,X,W){const J=k(W);if(!i)return D.writeFileSync(H,X,{mode:J.mode,flag:J.flag});const G=D.openSync(H,J.flag,J.mode);try{D.writeFileSync(G,X);try{D.fdatasyncSync(G)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),o(!1)}}finally{D.closeSync(G)}}function k(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function v(H,X,W=6e4){if(H!==X)try{f.$i&&typeof W=="number"?await S(H,X,Date.now(),W):await(0,j.promisify)(D.rename)(H,X)}catch(J){if(H.toLowerCase()!==X.toLowerCase()&&J.code==="EXDEV"||H.endsWith("."))await P(H,X,{preserveSymlinks:!1}),await h(H,w.MOVE);else throw J}}async function S(H,X,W,J,G=0){try{return await(0,j.promisify)(D.rename)(H,X)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-W>=J)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${B}`),B;if(G===0){let ie=!1;try{const{stat:re}=await r.stat(X);re.isFile()||(ie=!0)}catch{}if(ie)throw B}return await(0,A.$xh)(Math.min(100,G*10)),S(H,X,W,J,G+1)}}async function P(H,X,W){return M(H,X,{root:{source:H,target:X},options:W,handledSourcePaths:new Set})}const R=511;async function M(H,X,W){if(W.handledSourcePaths.has(H))return;W.handledSourcePaths.add(H);const{stat:J,symbolicLink:G}=await r.stat(H);if(G){if(W.options.preserveSymlinks)try{return await Y(H,X,W)}catch{}if(G.dangling)return}return J.isDirectory()?F(H,X,J.mode&R,W):q(H,X,J.mode&R)}async function F(H,X,W,J){await e.Promises.mkdir(X,{recursive:!0,mode:W});const G=await l(H);for(const B of G)await M((0,C.$kc)(H,B),(0,C.$kc)(X,B),J)}async function q(H,X,W){await e.Promises.copyFile(H,X),await e.Promises.chmod(X,W)}async function Y(H,X,W){let J=await e.Promises.readlink(H);(0,O.$vg)(J,W.root.source,!f.$k)&&(J=(0,C.$kc)(W.root.target,J.substr(W.root.source.length+1))),await e.Promises.symlink(J,X)}e.Promises=new class{get access(){return(0,j.promisify)(D.access)}get stat(){return(0,j.promisify)(D.stat)}get lstat(){return(0,j.promisify)(D.lstat)}get utimes(){return(0,j.promisify)(D.utimes)}get read(){return(H,X,W,J,G)=>new Promise((B,ie)=>{D.read(H,X,W,J,G,(re,he,te)=>re?ie(re):B({bytesRead:he,buffer:te}))})}get readFile(){return(0,j.promisify)(D.readFile)}get write(){return(H,X,W,J,G)=>new Promise((B,ie)=>{D.write(H,X,W,J,G,(re,he,te)=>re?ie(re):B({bytesWritten:he,buffer:te}))})}get appendFile(){return(0,j.promisify)(D.appendFile)}get fdatasync(){return(0,j.promisify)(D.fdatasync)}get truncate(){return(0,j.promisify)(D.truncate)}get copyFile(){return(0,j.promisify)(D.copyFile)}get open(){return(0,j.promisify)(D.open)}get close(){return(0,j.promisify)(D.close)}get symlink(){return(0,j.promisify)(D.symlink)}get readlink(){return(0,j.promisify)(D.readlink)}get chmod(){return(0,j.promisify)(D.chmod)}get mkdir(){return(0,j.promisify)(D.mkdir)}get unlink(){return(0,j.promisify)(D.unlink)}get rmdir(){return(0,j.promisify)(D.rmdir)}get realpath(){return(0,j.promisify)(D.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return $}get writeFile(){return s}get rm(){return h}get rename(){return v}get copy(){return P}}}),define(ae[148],ce([0,1,41,14,5,27,31]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=I,e.$5q=C,e.$6q=f,e.$7q=E;function I(w){if(j.$k)return w;const h=(0,N.$nc)(w);if(w===h)return w;const c=((0,N.$oc)(w)||w).toLowerCase();try{const g=(0,O.readdirSync)(h).filter(l=>l.toLowerCase()===c);if(g.length===1){const l=I(h);if(l)return(0,N.$kc)(l,g[0])}else if(g.length>1){const l=g.indexOf(c);if(l>=0){const u=I(h);if(u)return(0,N.$kc)(u,g[l])}}}catch{}return null}async function C(w,h){if(j.$k)return w;const c=(0,N.$nc)(w);if(w===c)return w;const p=((0,N.$oc)(w)||w).toLowerCase();try{if(h?.isCancellationRequested)return null;const l=(await O.Promises.readdir(c)).filter(u=>u.toLowerCase()===p);if(l.length===1){const u=await C(c,h);if(u)return(0,N.$kc)(u,l[0])}else if(l.length>1){const u=l.indexOf(p);if(u>=0){const m=await C(c,h);if(m)return(0,N.$kc)(m,l[u])}}}catch{}return null}async function f(w){try{return await O.Promises.realpath(w)}catch{const c=y(w);return await O.Promises.access(c,D.constants.R_OK),c}}function E(w){try{return D.realpathSync(w)}catch{const c=y(w);return D.accessSync(c,D.constants.R_OK),c}}function y(w){return(0,A.$gf)((0,N.$ic)(w),N.sep)}}),define(ae[149],ce([0,1,14,5,36,89,13,31]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=C,e.$pm=f,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function C(y=j.env){return y.comspec||"cmd.exe"}function f(y){let w=[],h=!1;const c=function(p){if(h){w.push(p);return}(!y.send(p,l=>{if(l&&console.error(l),h=!1,w.length>0){const u=w.slice(0);w=[],u.forEach(m=>c(m))}})||N.$i)&&(h=!0)};return{send:c}}var E;(function(y){async function w(h,c,p){if(D.$jc(h))return h;if(c===void 0&&(c=j.cwd()),D.$nc(h)!=="."||(p===void 0&&O.$9f(j.env.PATH)&&(p=j.env.PATH.split(D.$uc)),p===void 0||p.length===0))return D.$kc(c,h);async function l(u){if(await I.Promises.exists(u)){let m;try{m=await I.Promises.stat(u)}catch(d){d.message.startsWith("EACCES")&&(m=await I.Promises.lstat(u))}return m?!m.isDirectory():!1}return!1}for(const u of p){let m;if(D.$jc(u)?m=D.$kc(u,h):m=D.$kc(c,u,h),await l(m))return m;let d=m+".com";if(await l(d)||(d=m+".exe",await l(d)))return d}return D.$kc(c,h)}y.findExecutable=w})(E||(e.win32=E={}))}),define(ae[150],ce([0,1,67,23]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=j;function j(O){return new Promise((I,C)=>{let f;const E=new Map;function y(h,c,p,g,l){const u=E.get(c);if(h===O||u){const m={name:w(p),cmd:p,pid:h,ppid:c,load:g,mem:l};E.set(h,m),h===O&&(f=m),u&&(u.children||(u.children=[]),u.children.push(m),u.children.length>1&&(u.children=u.children.sort((d,$)=>d.pid-$.pid)))}}function w(h){const c=/--utility-sub-type=network/i,p=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(p.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-agent";if(l.exec(h))return"conpty-agent";let m=u.exec(h);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?c.exec(h)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const d=/[a-zA-Z-]+\.js/g;let $="";do m=d.exec(h),m&&($+=m+" ");while(m);return $&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${$})`:h}if(process.platform==="win32"){const h=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,p)=>{ne(["@vscode/windows-process-tree"],c,p)}).then(c=>{c.getProcessList(O,p=>{if(!p){C(new Error(`Root process ${O} not found`));return}c.getProcessCpuUsage(p,g=>{const l=new Map;g.forEach(u=>{const m=h(u.commandLine||"");l.set(u.pid,{name:w(m),cmd:m,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),f=l.get(O),f?(l.forEach(u=>{const m=l.get(u.ppid);m&&(m.children||(m.children=[]),m.children.push(u))}),l.forEach(u=>{u.children&&(u.children=u.children.sort((m,d)=>m.pid-d.pid))}),I(f)):C(new Error(`Root process ${O} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let h=function(){let c=[f];const p=[];for(;c.length;){const l=c.shift();l&&(p.push(l.pid),l.children&&(c=c.concat(l.children)))}let g=JSON.stringify(N.$Qg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+p.join(" "),(0,D.exec)(g,{},(l,u,m)=>{if(l||m)C(l||new Error(m.toString()));else{const d=u.toString().split(`
`);for(let $=0;$<p.length;$++){const t=E.get(p[$]);t.load=parseFloat(d[$])}if(!f){C(new Error(`Root process ${O} not found`));return}I(f)}})};(0,D.exec)("which ps",{},(c,p,g)=>{if(c||g)if(process.platform!=="linux")C(c||new Error(g.toString()));else{const l=JSON.stringify(N.$Qg.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(l,{},(u,m,d)=>{u||d?C(u||new Error(d.toString())):(A(m,y),h())})}else{const l=p.toString().trim();(0,D.exec)(`${l} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,d,$)=>{m||$&&!$.includes("screen size is bogus")?C(m||new Error($.toString())):(A(d,y),process.platform==="linux"?h():f?I(f):C(new Error(`Root process ${O} not found`)))})}})}})}function A(O,I){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=O.toString().split(`
`);for(const E of f){const y=C.exec(E.trim());y&&y.length===6&&I(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}});var Ee=this&&this.__decorate||function(ne,e,D,N){var j=arguments.length,A=j<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ne,e,D,N);else for(var I=ne.length-1;I>=0;I--)(O=ne[I])&&(A=(j<3?O(A):j>3?O(e,D,A):O(e,D))||A);return j>3&&A&&Object.defineProperty(e,D,A),A};define(ae[42],ce([0,1,17,6,15,26,84,7,3,2,66,27,13]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=o,e.$0h=a,e.$ci=R,e.$di=M;var h;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(h||(h={}));function c(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(p||(p={}));function g(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(l||(l={}));function u(G){let B=0;for(let ie=0;;ie+=7){const re=G.read(1);if(B|=(re.buffer[0]&127)<<ie,!(re.buffer[0]&128))return B}}const m=n(0);function d(G,B){if(B===0){G.write(m);return}let ie=0;for(let he=B;he!==0;he=he>>>7)ie++;const re=j.$Ge.alloc(ie);for(let he=0;B!==0;he++)re.buffer[he]=B&127,B=B>>>7,B>0&&(re.buffer[he]|=128);G.write(re)}class ${constructor(B){this.b=B,this.a=0}read(B){const ie=this.b.slice(this.a,this.a+B);return this.a+=ie.byteLength,ie}}e.$7h=$;class t{constructor(){this.a=[]}get buffer(){return j.$Ge.concat(this.a)}write(B){this.a.push(B)}}e.$8h=t;var r;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(r||(r={}));function n(G){const B=j.$Ge.alloc(1);return B.writeUInt8(G,0),B}const s={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},i=typeof Buffer<"u";function o(G,B){if(typeof B>"u")G.write(s.Undefined);else if(typeof B=="string"){const ie=j.$Ge.fromString(B);G.write(s.String),d(G,ie.byteLength),G.write(ie)}else if(i&&Buffer.isBuffer(B)){const ie=j.$Ge.wrap(B);G.write(s.Buffer),d(G,ie.byteLength),G.write(ie)}else if(B instanceof j.$Ge)G.write(s.VSBuffer),d(G,B.byteLength),G.write(B);else if(Array.isArray(B)){G.write(s.Array),d(G,B.length);for(const ie of B)o(G,ie)}else if(typeof B=="number"&&(B|0)===B)G.write(s.Uint),d(G,B);else{const ie=j.$Ge.fromString(JSON.stringify(B));G.write(s.Object),d(G,ie.byteLength),G.write(ie)}}function a(G){switch(G.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return G.read(u(G)).toString();case r.Buffer:return G.read(u(G)).buffer;case r.VSBuffer:return G.read(u(G));case r.Array:{const ie=u(G),re=[];for(let he=0;he<ie;he++)re.push(a(G));return re}case r.Object:return JSON.parse(G.read(u(G)).toString());case r.Int:return u(G)}}class b{constructor(B,ie,re=null,he=1e3){this.h=B,this.j=ie,this.k=re,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(B,ie){this.b.set(B,ie),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const ie=this.o([B.type]);this.k?.logOutgoing(ie,0,1,g(B.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([B.type,B.id],B.data);this.k?.logOutgoing(ie,B.id,1,g(B.type),B.data);return}}}o(B,ie=void 0){const re=new t;return o(re,B),o(re,ie),this.p(re.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const ie=new $(B),re=a(ie),he=a(ie),te=re[0];switch(te){case 100:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}: ${re[2]}.${re[3]}`,he),this.s({type:te,id:re[1],channelName:re[2],name:re[3],arg:he});case 102:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}: ${re[2]}.${re[3]}`,he),this.t({type:te,id:re[1],channelName:re[2],name:re[3],arg:he});case 101:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}`),this.u({type:te,id:re[1]});case 103:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(te)}`),this.u({type:te,id:re[1]})}}s(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const re=new A.$pe;let he;try{he=ie.call(this.j,B.name,B.arg,re.token)}catch(z){he=Promise.reject(z)}const te=B.id;he.then(z=>{this.m({id:te,data:z,type:201})},z=>{z instanceof Error?this.m({id:te,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:te,data:z,type:203})}).finally(()=>{V.dispose(),this.d.delete(B.id)});const V=(0,f.$Tc)(()=>re.cancel());this.d.set(B.id,V)}t(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const re=B.id,te=ie.listen(this.j,B.name,B.arg)(V=>this.m({id:re,data:V,type:204}));this.d.set(B.id,te)}u(B){const ie=this.d.get(B.id);ie&&(ie.dispose(),this.d.delete(B.id))}v(B){let ie=this.g.get(B.channelName);ie||(ie=[],this.g.set(B.channelName,ie));const re=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:B,timeoutTimer:re})}w(B){const ie=this.g.get(B);if(ie){for(const re of ie)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Qc)(this.d.values()),this.d.clear()}}e.$$h=b;var k;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class v{constructor(B,ie=null){this.l=B,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ie}getChannel(B){const ie=this;return{call(re,he,te){return ie.a?Promise.reject(new I.$5):ie.m(B,re,he,te)},listen(re,he){return ie.a?C.Event.None:ie.o(B,re,he)}}}m(B,ie,re,he=A.CancellationToken.None){const te=this.g++,z={id:te,type:100,channelName:B,name:ie,arg:re};if(he.isCancellationRequested)return Promise.reject(new I.$5);let L;return new Promise((U,x)=>{if(he.isCancellationRequested)return x(new I.$5);const K=()=>{const se=ue=>{switch(ue.type){case 201:this.f.delete(te),U(ue.data);break;case 202:{this.f.delete(te);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,x(ge);break}case 203:this.f.delete(te),x(ue.data);break}};this.f.set(te,se),this.p(z)};let ee=null;this.b===l.Idle?K():(ee=(0,N.$jh)(se=>this.u()),ee.then(()=>{ee=null,K()}));const _=()=>{ee?(ee.cancel(),ee=null):this.p({id:te,type:101}),x(new I.$5)},Z=he.onCancellationRequested(_);L=(0,f.$Sc)((0,f.$Tc)(_),Z),this.d.add(L)}).finally(()=>{L.dispose(),this.d.delete(L)})}o(B,ie,re){const he=this.g++,V={id:he,type:102,channelName:B,name:ie,arg:re};let z=null;const L=new C.$ee({onWillAddFirstListener:()=>{z=(0,N.$jh)(U=>this.u()),z.then(()=>{z=null,this.d.add(L),this.p(V)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(L),this.p({id:he,type:103}))}}),T=U=>L.fire(U.data);return this.f.set(he,T),L.event}p(B){switch(B.type){case 100:case 102:{const ie=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(ie,B.id,0,`${c(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const ie=this.q([B.type,B.id]);this.j?.logOutgoing(ie,B.id,0,c(B.type));return}}}q(B,ie=void 0){const re=new t;return o(re,B),o(re,ie),this.r(re.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const ie=new $(B),re=a(ie),he=a(ie),te=re[0];switch(te){case 200:return this.j?.logIncoming(B.byteLength,0,0,g(te)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,re[1],0,g(te),he),this.t({type:re[0],id:re[1],data:he})}}t(B){if(B.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Qc)(this.d.values()),this.d.clear()}}e.$_h=v,Ee([O.$1h],v.prototype,"onDidInitializePromise",null);class S{get connections(){const B=[];return this.f.forEach(ie=>B.push(ie)),B}constructor(B,ie,re){this.a=new Map,this.f=new Set,this.g=new C.$ee,this.onDidAddConnection=this.g.event,this.h=new C.$ee,this.onDidRemoveConnection=this.h.event,this.j=new f.$Uc,this.j.add(B(({protocol:he,onDidClientDisconnect:te})=>{const V=C.Event.once(he.onMessage);this.j.add(V(z=>{const L=new $(z),T=a(L),U=new b(he,T,ie,re),x=new v(he,ie);this.a.forEach((ee,_)=>U.registerChannel(_,ee));const K={channelServer:U,channelClient:x,ctx:T};this.f.add(K),this.g.fire(K),this.j.add(te(()=>{U.dispose(),x.dispose(),this.f.delete(K),this.h.fire(K)}))}))}))}getChannel(B,ie){const re=this;return{call(he,te,V){let z;if((0,w.$kg)(ie)){const T=(0,D.$4b)(re.connections.filter(ie));z=T?Promise.resolve(T):C.Event.toPromise(C.Event.filter(re.onDidAddConnection,ie))}else z=ie.routeCall(re,he,te);const L=z.then(T=>T.channelClient.getChannel(B));return R(L).call(he,te,V)},listen(he,te){if((0,w.$kg)(ie))return re.k(B,ie,he,te);const V=ie.routeEvent(re,he,te).then(z=>z.channelClient.getChannel(B));return R(V).listen(he,te)}}}k(B,ie,re,he){const te=this;let V;const z=new C.$ee({onWillAddFirstListener:()=>{V=new f.$Uc;const L=new C.$ke,T=new Map,U=K=>{const _=K.channelClient.getChannel(B).listen(re,he),Z=L.add(_);T.set(K,Z)},x=K=>{const ee=T.get(K);ee&&(ee.dispose(),T.delete(K))};te.connections.filter(ie).forEach(U),C.Event.filter(te.onDidAddConnection,ie)(U,void 0,V),te.onDidRemoveConnection(x,void 0,V),L.event(z.fire,z,V),V.add(L)},onDidRemoveLastListener:()=>{V?.dispose(),V=void 0}});return z.event}registerChannel(B,ie){this.a.set(B,ie);for(const re of this.f)re.channelServer.registerChannel(B,ie)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=S;class P{constructor(B,ie,re=null){const he=new t;o(he,ie),B.send(he.buffer),this.a=new v(B,re),this.d=new b(B,ie,re)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,ie){this.d.registerChannel(B,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=P;function R(G){return{call(B,ie,re){return G.then(he=>he.call(B,ie,re))},listen(B,ie){const re=new C.$ne;return G.then(he=>re.input=he.listen(B,ie)),re.event}}}function M(G){let B=!1;return{call(ie,re,he){return B?G.call(ie,re,he):(0,N.$xh)(0).then(()=>B=!0).then(()=>G.call(ie,re,he))},listen(ie,re){if(B)return G.listen(ie,re);const he=new C.$ne;return(0,N.$xh)(0).then(()=>B=!0).then(()=>he.input=G.listen(ie,re)),he.event}}}class F{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const ie of B.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await C.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$ei=F;var q;(function(G){function B(te,V,z){const L=te,T=z&&z.disableMarshalling,U=new Map;for(const x in L)re(x)&&U.set(x,C.Event.buffer(L[x],!0,void 0,V));return new class{listen(x,K,ee){const _=U.get(K);if(_)return _;const Z=L[K];if(typeof Z=="function"){if(he(K))return Z.call(L,ee);if(re(K))return U.set(K,C.Event.buffer(L[K],!0,void 0,V)),U.get(K)}throw new I.$bb(`Event not found: ${K}`)}call(x,K,ee){const _=L[K];if(typeof _=="function"){if(!T&&Array.isArray(ee))for(let se=0;se<ee.length;se++)ee[se]=(0,E.$6h)(ee[se]);let Z=_.apply(L,ee);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new I.$bb(`Method not found: ${K}`)}}}G.fromService=B;function ie(te,V){const z=V&&V.disableMarshalling;return new Proxy({},{get(L,T){if(typeof T=="string")return V?.properties?.has(T)?V.properties.get(T):he(T)?function(U){return te.listen(T,U)}:re(T)?te.listen(T):async function(...U){let x;V&&!(0,w.$fg)(V.context)?x=[V.context,...U]:x=U;const K=await te.call(T,x);return z?K:(0,E.$6h)(K)};throw new I.$bb(`Property not found: ${String(T)}`)}})}G.toService=ie;function re(te){return te[0]==="o"&&te[1]==="n"&&y.$xf(te.charCodeAt(2))}function he(te){return/^onDynamic/.test(te)&&y.$xf(te.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const B=G.toString();if(B!=="[object Object]")return B}return G}function X(G){return Array.isArray(G)?G.map(H):H(G)}function W(G,B,ie,re,he,te,V){V=X(V);const z=Y[he],L=z[re%z.length];let T=[`%c[${G}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(te)?(T=T.concat(V),T.push(")")):T.push(V),console.log.apply(console,T)}class J{constructor(B,ie){this.d=B,this.f=ie,this.a=0,this.b=0}logOutgoing(B,ie,re,he,te){this.b+=B,W(this.d,this.b,B,ie,re,he,te)}logIncoming(B,ie,re,he,te){this.a+=B,W(this.f,this.a,B,ie,re,he,te)}}e.$fi=J}),define(ae[68],ce([0,1,15,3,2,42]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.ProtocolConstants=e.$gi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let o=0;function a(k,v){if(!i.has(k)){const S=String(++o);i.set(k,S)}return i.get(k)}function b(k,v,S,P){if(!s.enableDiagnostics)return;const R=a(k,v);if(P instanceof D.$Ge||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const M=D.$Ge.alloc(P.byteLength);M.set(P),s.records.push({timestamp:Date.now(),id:R,label:v,type:S,buff:M})}else s.records.push({timestamp:Date.now(),id:R,label:v,type:S,data:P})}s.traceSocketEvent=b})(I||(e.SocketDiagnostics=I={}));var C;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C||(e.SocketCloseEventType=C={}));let f=null;function E(){return f||(f=D.$Ge.alloc(0)),f}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,o){if(i===0)return E();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const v=this.a[0];return o&&(this.a.shift(),this.b-=i),v}if(this.a[0].byteLength>i){const v=this.a[0].slice(0,i);return o&&(this.a[0]=this.a[0].slice(i),this.b-=i),v}const a=D.$Ge.alloc(i);let b=0,k=0;for(;i>0;){const v=this.a[k];if(v.byteLength>i){const S=v.slice(0,i);a.set(S,b),b+=i,o&&(this.a[k]=v.slice(i),this.b-=i),i-=i}else a.set(v,b),b+=v.byteLength,o?(this.a.shift(),this.b-=v.byteLength):k++,i-=v.byteLength}return a}}e.$gi=y;var w;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(w||(w={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var c;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(c||(e.ProtocolConstants=c={}));class p{constructor(i,o,a,b){this.type=i,this.id=o,this.ack=a,this.data=b,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends j.$Vc{constructor(i){super(),this.f=this.B(new N.$ee),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new y,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,b=this.g.id,k=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new p(a,b,k,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=D.$Ge.alloc(13);o.writeUInt8(i.type,0),o.writeUInt32BE(i.id,1),o.writeUInt32BE(i.ack,5),o.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(o,i.data)}g(i,o){const a=this.f===0;return this.d.push(i,o),this.f+=i.byteLength+o.byteLength,a}h(){const i=D.$Ge.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,o){this.g(i,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class u extends j.$Vc{constructor(i){super(),this.f=new N.$ee,this.onMessage=this.f.event,this.g=new N.$ee,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new l(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new p(1,0,0,i))}}e.$hi=u;class m extends A.$bi{static fromSocket(i,o){return new m(new u(i),o)}get onDidDispose(){return this.b.onDidDispose}constructor(i,o,a=null){super(i,o,a),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$ii=m;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$ee({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$ji=d;class ${constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,o=this.a;for(;o;)o=o.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let o=0,a=this.a;for(;a;)i[o++]=a.data,a=a.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const o=new $(i);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const i=Date.now();for(let o=0;o<r.a;o++)this.c[o]=i-1e3*o;setInterval(()=>{for(let o=r.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),o=(1+r.a)*1e3;let a=0;for(let b=0;b<r.a;b++)i-this.c[b]<=o&&a++;return 1-a/r.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??r.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new j.$Uc,this.o=i.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new p(5,0,0,E());this.p.write(i),this.p.flush()}sendPause(){const i=new p(7,0,0,E());this.p.write(i)}sendResume(){const i=new p(8,0,0,E());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,o){this.a=!0,this.r.dispose(),this.r=new j.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new p(3,0,this.h,E());this.p.write(i);const o=this.b.toArray();for(let a=0,b=o.length;a<b;a++)this.p.write(o[a]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const o=this.b.peek();if(o&&o.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new p(6,0,0,E())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let a=0,b=o.length;a<b;a++)this.p.write(o[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const o=++this.c;this.h=this.g;const a=new p(1,o,this.h,i);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(i){const o=new p(2,0,0,i);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),o=Date.now()-i.writtenTime,a=Date.now()-this.q.lastReadTime,b=Date.now()-this.n;if(o>=2e4&&a>=2e4&&b>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:a});return}const k=Math.max(2e4-o,2e4-a,2e4-b,500);this.f=setTimeout(()=>{this.f=null,this.B()},k)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new p(3,0,this.h,E());this.p.write(i)}D(){this.h=this.g;const i=new p(9,0,this.h,E());this.p.write(i)}}e.$ki=n}),define(ae[92],ce([0,1,67,6,15,26,142,7,3,2,30,149,89,42]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class c extends h.$$h{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",u=>j.$Ge.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$Zq=c;class p{constructor(l,u){this.i=l,this.j=u,this.c=new Set,this.g=new Map,this.h=new C.$ee,this.onDidProcessExit=this.h.event;const m=u&&u.timeout?u.timeout:6e4;this.b=new N.$th(m),this.d=null,this.f=null}getChannel(l){const u=this;return{call(m,d,$){return u.k(l,m,d,$)},listen(m,d){return u.l(l,m,d)}}}k(l,u,m,d=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const $=this.n(l),t=(0,N.$jh)(s=>$.call(u,m,s)),r=d.onCancellationRequested(()=>t.cancel()),n=(0,f.$Tc)(()=>t.cancel());return this.c.add(n),t.finally(()=>{r.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(l,u,m){if(!this.b)return C.Event.None;this.b.cancel();let d;const $=new C.$ee({onWillAddFirstListener:()=>{d=this.n(l).listen(u,m)($.fire,$),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return $.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,E.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,w.$nm)(u.env),this.d=(0,D.fork)(this.i,l,u);const m=new C.$ee,$=C.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,O.$Vq)(o)){(0,O.log)(o,`IPC Library: ${this.j.serverName}`);return}m.fire(j.$Ge.wrap(Buffer.from(o,"base64")))}),t=this.j.useQueue?(0,y.$pm)(this.d):this.d,r=o=>this.d&&this.d.connected&&t.send(o.buffer.toString("base64")),n=m.event,s={send:r,onMessage:n};this.f=new h.$_h(s);const i=()=>this.o();process.once("exit",i),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,a)=>{process.removeListener("exit",i),$.dispose(),this.c.forEach(b=>(0,f.$Qc)(b)),this.c.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:a})})}return this.f}n(l){let u=this.g.get(l);return u||(u=this.m.getChannel(l),this.g.set(l,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=p}),define(ae[151],ce([0,1,134,15,42,3,13,17]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9W=void 0,e.$0W=E;class C{constructor(w){this.a=w,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",h=>h.data?N.$Ge.wrap(h.data):N.$Ge.alloc(0)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}class f extends j.$ai{static b(w){(0,O.$gg)((0,D.$8W)(process),"Electron Utility Process");const h=new A.$ee;return process.parentPort.on("message",c=>{if(w?.handledClientConnection(c))return;const p=(0,I.$Ob)(c.ports);p&&h.fire(p)}),A.Event.map(h.event,c=>({protocol:new C(c),onDidClientDisconnect:A.Event.fromNodeEventEmitter(c,"close")}))}constructor(w){super(f.b(w))}}e.$9W=f;function E(y,w,h){const c=p=>{p.data===w&&(y.removeListener("message",c),h())};y.on("message",c)}}),define(ae[69],ce([0,1,6,3,2,66,13]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=C;var I;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function C(w){const h=w;return h?.changed instanceof Map||h?.deleted instanceof Set}var f;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(f||(e.StorageState=f={}));class E extends j.$Vc{static{this.a=100}constructor(h,c=Object.create(null)){super(),this.r=h,this.s=c,this.b=this.B(new N.$he),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=this.B(new D.$uh(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach((c,p)=>this.w(p,c)),h.deleted?.forEach(c=>this.w(c,void 0))}finally{this.b.resume()}}w(h,c){if(this.c===f.Closed)return;let p=!1;(0,O.$fg)(c)?p=this.f.delete(h):this.f.get(h)!==c&&(this.f.set(h,c),p=!0),p&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,c){const p=this.f.get(h);return(0,O.$fg)(p)?c:p}getBoolean(h,c){const p=this.get(h);return(0,O.$fg)(p)?c:p==="true"}getNumber(h,c){const p=this.get(h);return(0,O.$fg)(p)?c:parseInt(p,10)}getObject(h,c){const p=this.get(h);return(0,O.$fg)(p)?c:(0,A.$5h)(p)}async set(h,c,p=!1){if(this.c===f.Closed)return;if((0,O.$fg)(c))return this.delete(h,p);const g=(0,O.$$f)(c)||Array.isArray(c)?(0,A.$4h)(c):String(c);if(this.f.get(h)!==g)return this.f.set(h,g),this.j.set(h,g),this.h.delete(h),this.b.fire({key:h,external:p}),this.D()}async delete(h,c=!1){if(!(this.c===f.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:c}),this.D()}async optimize(){if(this.c!==f.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=f.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$Wp=E;class y{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((c,p)=>this.a.set(p,c)),h.delete?.forEach(c=>this.a.delete(c))}async optimize(){}async close(){}}e.$Xp=y}),define(ae[152],ce([11,10]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ae[70],ce([0,1,41,6,14,13,31,152]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0,e.zip=g,e.$jq=l,e.$kq=m,e.$gq="end of central directory record signature not found";const C=new RegExp(e.$gq);class f extends Error{constructor($,t){let r=t.message;switch($){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=$,this.cause=t}}e.$hq=f;function E(d){const $=d.externalFileAttributes>>16||33188;return[448,56,7].map(t=>$&t).reduce((t,r)=>t+r,$&61440)}function y(d){if(d instanceof f)return d;let $;return C.test(d.message)&&($="CorruptZip"),new f($,d)}function w(d,$,t,r,n,s){const i=j.$nc($),o=j.$kc(r,i);if(!o.startsWith(r))return Promise.reject(new Error(I.localize(0,null,$)));const a=j.$kc(r,$);let b;return s.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(O.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((k,v)=>{if(!s.isCancellationRequested)try{b=(0,D.createWriteStream)(a,{mode:t}),b.once("close",()=>k()),b.once("error",v),d.once("error",v),d.pipe(b)}catch(S){v(S)}}))}function h(d,$,t,r){let n=(0,N.$jh)(()=>Promise.resolve()),s=0;const i=r.onCancellationRequested(()=>{n.cancel(),d.close()});return new Promise((o,a)=>{const b=new N.$rh,k=v=>{v.isCancellationRequested||(s++,d.readEntry())};d.once("error",a),d.once("close",()=>n.then(()=>{r.isCancellationRequested||d.entryCount===s?o():a(new f("Incomplete",new Error(I.localize(1,null,s,d.entryCount))))},a)),d.readEntry(),d.on("entry",v=>{if(r.isCancellationRequested)return;if(!t.sourcePathRegex.test(v.fileName)){k(r);return}const S=v.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(S)){const M=j.$kc($,S);n=(0,N.$jh)(F=>O.Promises.mkdir(M,{recursive:!0}).then(()=>k(F)).then(void 0,a));return}const P=p(d,v),R=E(v);n=(0,N.$jh)(M=>b.queue(()=>P.then(F=>w(F,S,R,$,t,M).then(()=>k(M)))).then(null,a))})}).finally(()=>i.dispose())}async function c(d,$=!1){const{open:t}=await new Promise((r,n)=>{ne(["yauzl"],r,n)});return new Promise((r,n)=>{t(d,$?{lazyEntries:!0}:void 0,(s,i)=>{s?n(y(s)):r((0,A.$hg)(i))})})}function p(d,$){return new Promise((t,r)=>{d.openReadStream($,(n,s)=>{n?r(y(n)):t((0,A.$hg)(s))})})}async function g(d,$){const{ZipFile:t}=await new Promise((r,n)=>{ne(["yazl"],r,n)});return new Promise((r,n)=>{const s=new t;$.forEach(o=>{o.contents?s.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&s.addFile(o.localPath,o.path)}),s.end();const i=(0,D.createWriteStream)(d);s.outputStream.pipe(i),s.outputStream.once("error",n),i.once("error",n),i.once("finish",()=>r(d))})}function l(d,$,t={},r){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let s=c(d,!0);return t.overwrite&&(s=s.then(i=>O.Promises.rm($).then(()=>i))),s.then(i=>h(i,$,{sourcePathRegex:n},r))}function u(d,$){return c(d).then(t=>new Promise((r,n)=>{t.on("entry",s=>{s.fileName===$&&p(t,s).then(i=>r(i),i=>n(i))}),t.once("close",()=>n(new Error(I.localize(2,null,$))))}))}function m(d,$){return u(d,$).then(t=>new Promise((r,n)=>{const s=[];t.once("error",n),t.on("data",i=>s.push(i)),t.on("end",()=>r(Buffer.concat(s)))}))}}),define(ae[153],ce([11,10]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[154],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[155],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ae[156],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[157],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[158],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[159],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[160],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[161],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[162],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[163],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ae[164],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ae[165],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ae[166],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[167],ce([11,10]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[168],ce([11,10]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(ae[169],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[170],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[171],ce([11,10]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ae[172],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[173],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[174],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[175],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[176],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[177],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[178],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[179],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[180],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[181],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[182],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[183],ce([11,10]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ae[184],ce([0,1,7,155]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var j;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(j||(e.TokenType=j={}));function A(...f){switch(f.length){case 1:return(0,N.localize)(0,null,f[0]);case 2:return(0,N.localize)(1,null,f[0],f[1]);case 3:return(0,N.localize)(2,null,f[0],f[1],f[2]);default:return}}const O=(0,N.localize)(3,null),I=(0,N.localize)(4,null);class C{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const y=this.d,w=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:w};this.g.push({offset:y,lexeme:w,additionalInfo:E}),this.f.push(h)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const y=this.c.substring(this.d,this.e),w=C.b.get(y);w?this.k(w):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,y=!1,w=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(I);return}const c=this.c.charCodeAt(E);if(y)y=!1;else if(c===47&&!w){E++;break}else c===91?w=!0:c===92?y=!0:c===93&&(w=!1);E++}for(;E<this.c.length&&C.a.has(this.c.charCodeAt(E));)E++;this.e=E;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=C}),define(ae[185],ce([0,1,65,84,23,14,36,20,8]),function(ne,e,D,N,j,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=E,e.$8m=y,e.$5m=/^([^.]+\..+)[:=](.+)$/;class f{get appRoot(){return(0,A.$nc)(j.$Qg.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,A.$kc)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,I.$0g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:j.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$0g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,D.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$kc)(this.userDataPath,"logs",h)}return C.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$0g)(C.URI.file((0,A.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$0g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$0g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$0g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=O.env.VSCODE_PORTABLE;return h?C.URI.file((0,A.$kc)(h,"argv.json")):(0,I.$0g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,A.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.$lc)(h):(0,A.$ic)((0,A.$kc)(j.$Qg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?C.URI.file((0,A.$lc)(h)):C.URI.file((0,A.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.$lc)(h);const c=O.env.VSCODE_EXTENSIONS;if(c)return c;const p=O.env.VSCODE_PORTABLE;return p?(0,A.$kc)(p,"extensions"):(0,I.$0g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(c=>/^[^:/?#]+?:\/\//.test(c)?C.URI.parse(c):C.URI.file((0,A.$ic)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?C.URI.parse(h):C.URI.file((0,A.$ic)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$5m.test(h))}get extensionLogLevel(){const h=[];for(const c of this.args.log||[]){const p=e.$5m.exec(c);p&&p[1]&&p[2]&&h.push([p[1],p[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,I.$0g)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=O.env.VSCODE_PORTABLE;return h?C.URI.file((0,A.$kc)(h,"policy.json")):(0,I.$0g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,c,p){this.a=h,this.b=c,this.c=p,this.editSessionId=this.args.editSessionId}}e.$6m=f,Ee([N.$1h],f.prototype,"appRoot",null),Ee([N.$1h],f.prototype,"userHome",null),Ee([N.$1h],f.prototype,"userDataPath",null),Ee([N.$1h],f.prototype,"appSettingsHome",null),Ee([N.$1h],f.prototype,"tmpDir",null),Ee([N.$1h],f.prototype,"cacheHome",null),Ee([N.$1h],f.prototype,"stateResource",null),Ee([N.$1h],f.prototype,"userRoamingDataHome",null),Ee([N.$1h],f.prototype,"userDataSyncHome",null),Ee([N.$1h],f.prototype,"sync",null),Ee([N.$1h],f.prototype,"machineSettingsResource",null),Ee([N.$1h],f.prototype,"workspaceStorageHome",null),Ee([N.$1h],f.prototype,"localHistoryHome",null),Ee([N.$1h],f.prototype,"keyboardLayoutResource",null),Ee([N.$1h],f.prototype,"argvResource",null),Ee([N.$1h],f.prototype,"isExtensionDevelopment",null),Ee([N.$1h],f.prototype,"untitledWorkspacesHome",null),Ee([N.$1h],f.prototype,"builtinExtensionsPath",null),Ee([N.$1h],f.prototype,"extensionsPath",null),Ee([N.$1h],f.prototype,"extensionDevelopmentLocationURI",null),Ee([N.$1h],f.prototype,"extensionDevelopmentKind",null),Ee([N.$1h],f.prototype,"extensionTestsLocationURI",null),Ee([N.$1h],f.prototype,"debugExtensionHost",null),Ee([N.$1h],f.prototype,"logLevel",null),Ee([N.$1h],f.prototype,"extensionLogLevel",null),Ee([N.$1h],f.prototype,"serviceMachineIdResource",null),Ee([N.$1h],f.prototype,"disableTelemetry",null),Ee([N.$1h],f.prototype,"disableWorkspaceTrust",null),Ee([N.$1h],f.prototype,"useInMemorySecretStorage",null),Ee([N.$1h],f.prototype,"policyFile",null);function E(w,h){return y(w["inspect-extensions"],w["inspect-brk-extensions"],5870,h,w.debugId,w.extensionEnvironment)}function y(w,h,c,p,g,l){const m=Number(h||w)||(p?null:c),d=m?!!h:!1;let $;if(l)try{$=JSON.parse(l)}catch{}return{port:m,break:d,debugId:g,env:$}}}),function(){"use strict";function ne(e,D,N){function j(O,I){const C=A(O,I),f=[C];return e.isAbsolute(C)||f.unshift(N),e.resolve(...f)}function A(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,I);const E=O["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(y,"AppData","Roaming")}break;case"darwin":f=e.join(D.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,I)}return{getUserDataPath:j}}if(typeof define=="function")define(ae[186],ce([276,37,36]),function(e,D,N){return ne(e,D,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=ne(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[187],ce([0,1,37,185,186]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=O,e.$$m=I;class A extends N.$6m{constructor(f,E){super(f,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,j.getUserDataPath)(f,E.nameShort)},E)}}e.$9m=A;function O(C,f){return(0,N.$8m)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,f,C.extensionEnvironment)}function I(C,f){return(0,N.$8m)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,f,C.extensionEnvironment)}}),define(ae[188],ce([0,1,13,158]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=j;function j(O,I,C,f){try{A(O,I,C,f)}catch(E){O.error(E?.message??E)}return I}function A(O,I,C,f){const E=(y,w,h)=>{const c=y[w];if((0,D.$9f)(c)){const p=c,g=p.length;if(g>1&&p[0]==="%"&&p[g-1]==="%"){const l=p.substr(1,g-2);let u=C[l];u===void 0&&f&&(u=f[l]);const m=typeof u=="string"?u:u?.message,d=f?.[l],$=typeof d=="string"?d:d?.message;if(!m){$||O.warn(`[${I.name}]: ${(0,N.localize)(0,null,l)}`);return}if(h&&(w==="title"||w==="category")&&$&&$!==m){const t={value:m,original:$};y[w]=t}else y[w]=m}}else if((0,D.$$f)(c))for(const p in c)c.hasOwnProperty(p)&&(p==="commands"?E(c,p,!0):E(c,p,h));else if(Array.isArray(c))for(let p=0;p<c.length;p++)E(c,p,h)};for(const y in I)I.hasOwnProperty(y)&&E(I,y)}}),define(ae[189],ce([0,1,70,161]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=j;function j(A){return(0,D.$kq)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}}),define(ae[190],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=e.$Dec=void 0;class D{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Dec=D;class N{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,I){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${O}`)}}e.$Eec=N}),define(ae[71],ce([0,1,20,88,162,55]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=C,e.$Hp=f,e.$Ip=E,e.$Jp=y,e.$Kp=w,e.$Lp=h,e.$Mp=c;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(l){return l=l.trim(),l==="*"||O.test(l)}function f(l){if(!C(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(O);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}function E(l){if(!l)return null;const u=l.majorBase,m=l.majorMustEqual,d=l.minorBase;let $=l.minorMustEqual;const t=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(u===0||($=!1),r=!1);let n=0;if(l.preRelease){const s=I.exec(l.preRelease);if(s){const[,i,o,a]=s;n=Date.UTC(Number(i),Number(o)-1,Number(a))}}return{majorBase:u,majorMustEqual:m,minorBase:d,minorMustEqual:$,patchBase:t,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:n}}function y(l,u,m){let d;typeof l=="string"?d=E(f(l)):d=l;let $;u instanceof Date?$=u.getTime():typeof u=="string"&&($=new Date(u).getTime());let t;if(typeof m=="string"?t=E(f(m)):t=m,!d||!t)return!1;const r=d.majorBase,n=d.minorBase,s=d.patchBase;let i=t.majorBase,o=t.minorBase,a=t.patchBase;const b=t.notBefore;let k=t.majorMustEqual,v=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?r>i?!0:r<i?!1:n>o?!0:n<o||$&&$<b?!1:s>=a:(r===1&&i===0&&(!k||!v||!S)&&(i=1,o=0,a=0,k=!0,v=!1,S=!1),r<i?!1:r>i?!k:n<o?!1:n>o?!v:s<a?!1:s>a?!S:!($&&$<b))}function w(l,u,m,d,$){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([N.default.Error,j.localize(0,null)]),t;if(typeof d.name!="string")return t.push([N.default.Error,j.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([N.default.Error,j.localize(2,null,"version")]),t;if(!d.engines)return t.push([N.default.Error,j.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([N.default.Error,j.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!g(d.extensionDependencies))return t.push([N.default.Error,j.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!g(d.activationEvents))return t.push([N.default.Error,j.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([N.default.Error,j.localize(7,null,"activationEvents","main","browser")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([N.default.Warning,j.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([N.default.Error,j.localize(9,null,"main")]),t;{const s=(0,D.$0g)(m,d.main);(0,D.$4g)(s,m)||t.push([N.default.Warning,j.localize(10,null,s.path,m.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([N.default.Error,j.localize(11,null,"browser")]),t;{const s=(0,D.$0g)(m,d.browser);(0,D.$4g)(s,m)||t.push([N.default.Warning,j.localize(12,null,s.path,m.path)])}}if(!A.valid(d.version))return t.push([N.default.Error,j.localize(13,null)]),t;const r=[];if(!h(l,u,d,$,r))for(const s of r)t.push([N.default.Error,s]);return t}function h(l,u,m,d,$){return d||typeof m.main>"u"&&typeof m.browser>"u"?!0:p(l,u,m.engines.vscode,$)}function c(l,u,m){return l==="*"||p(u,m,l)}function p(l,u,m,d=[]){const $=E(f(m));if(!$)return d.push(j.localize(14,null,m)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return d.push(j.localize(15,null,m)),!1}else if(!$.majorMustEqual)return d.push(j.localize(16,null,m)),!1;return y(l,u,$)?!0:(d.push(j.localize(17,null,l,m)),!1)}function g(l){if(!Array.isArray(l))return!1;for(let u=0,m=l.length;u<m;u++)if(typeof l[u]!="string")return!1;return!0}}),define(ae[45],ce([0,1,15,32]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=j;async function j(A,O,I){let C=I&&I.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const E=(await O.readFile(A.serviceMachineIdResource)).value.toString();C=(0,N.$Rg)(E)?E:null}catch{C=null}if(!C){C=(0,N.$Sg)();try{await O.writeFile(A.serviceMachineIdResource,D.$Ge.fromString(C))}catch{}}return I?.store("storage.serviceMachineId",C,-1,1),C}}),define(ae[72],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class D{constructor(j,A=[],O=!1){this.ctor=j,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$ti=D}),define(ae[191],ce([0,1,72]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=A,e.$ys=O;const N=[];var j;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(j||(e.InstantiationType=j={}));function A(I,C,f){C instanceof D.$ti||(C=new D.$ti(C,[],!!f)),N.push([I,C])}function O(){return N}}),define(ae[192],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class D{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$ar=D;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const I=this.lookupOrInsertNode(A),C=this.lookupOrInsertNode(O);I.outgoing.set(C.key,C),C.incoming.set(I.key,I)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let I=this.a.get(O);return I||(I=new D(O,A),this.a.set(O,I)),I}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,I]of this.a)A.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const I=new Set([A]),C=this.c(O,I);if(C)return C}}c(A,O){for(const[I,C]of A.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const f=this.c(C,O);if(f)return f;O.delete(I)}}}e.$br=N}),define(ae[4],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=j,e.$xi=A;var D;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(C){return C[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(D||(e._util=D={})),e.$vi=j("instantiationService");function N(O,I,C){I[D.DI_TARGET]===I?I[D.DI_DEPENDENCIES].push({id:O,index:C}):(I[D.DI_DEPENDENCIES]=[{id:O,index:C}],I[D.DI_TARGET]=I)}function j(O){if(D.serviceIds.has(O))return D.serviceIds.get(O);const I=function(C,f,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(I,C,E)};return I.toString=()=>O,D.serviceIds.set(O,I),I}function A(O){return O}}),define(ae[193],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0,e.$dec=(0,D.$wi)("checksumService")}),define(ae[21],ce([0,1,13,8,4]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=A,e.$5i=O,e.$6i=C,e.$7i=f,e.$8i=E,e.$9i=y,e.$0i=w,e.$$i=c,e.$_i=p,e.$aj=g,e.$3i=(0,j.$wi)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof N.URI)}function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof N.URI)}var I;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function C(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function f(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function E(l,u){const m=Object.create(null);for(const d in l)y(m,d,l[d],u);return m}function y(l,u,m,d){const $=u.split("."),t=$.pop();let r=l;for(let n=0;n<$.length;n++){const s=$[n];let i=r[s];switch(typeof i){case"undefined":i=r[s]=Object.create(null);break;case"object":if(i===null){d(`Ignoring ${u} as ${$.slice(0,n+1).join(".")} is null`);return}break;default:d(`Ignoring ${u} as ${$.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[t]=m}catch{d(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}else d(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}function w(l,u){const m=u.split(".");h(l,m)}function h(l,u){const m=u.shift();if(u.length===0){delete l[m];return}if(Object.keys(l).indexOf(m)!==-1){const d=l[m];typeof d=="object"&&!Array.isArray(d)&&(h(d,u),Object.keys(d).length===0&&delete l[m])}}function c(l,u,m){function d(r,n){let s=r;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const $=u.split("."),t=d(l,$);return typeof t>"u"?m:t}function p(l,u,m){Object.keys(u).forEach(d=>{d!=="__proto__"&&(d in l?D.$$f(l[d])&&D.$$f(u[d])?p(l[d],u[d],m):m&&(l[d]=u[d]):l[d]=u[d])})}function g(l){return l.replace(/[\[\]]/g,"")}}),define(ae[93],ce([0,1,5,27,184,4,154,7]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=f,e.$vj=r,e.$wj=n,e.$Pj=he;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",D.$j),C.set("isLinux",D.$k),C.set("isWindows",D.$i),C.set("isWeb",D.$o),C.set("isMacNative",D.$j&&!D.$o),C.set("isEdge",D.$H),C.set("isFirefox",D.$F),C.set("isChrome",D.$E),C.set("isSafari",D.$G);function f(z,L){if(C.get(z)!==void 0)throw(0,I.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");C.set(z,L)}const E=Object.prototype.hasOwnProperty;var y;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const w={regexParsingWithErrorRecovery:!0},h=(0,O.localize)(0,null),c=(0,O.localize)(1,null),p=(0,O.localize)(2,null),g=(0,O.localize)(3,null),l=(0,O.localize)(4,null),u=(0,O.localize)(5,null),m=(0,O.localize)(6,null),d=(0,O.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=w){this.k=L,this.d=new j.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const T=this.l();if(!this.E()){const U=this.D(),x=U.type===17?u:void 0;throw this.h.push({message:l,offset:U.offset,lexeme:j.$rj.getLexeme(U),additionalInfo:x}),$.c}return T}catch(T){if(T!==$.c)throw T;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(16);){const T=this.o();L.push(T)}return L.length===1?L[0]:t.or(...L)}o(){const L=[this.s()];for(;this.y(15);){const T=this.s();L.push(T)}return L.length===1?L[0]:t.and(...L)}s(){if(this.y(2)){const L=this.D();switch(L.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const T=this.l();return this.A(1,g),T?.negate()}case 17:return this.z(),P.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const T=this.l();return this.A(1,g),T}case 17:{const T=L.lexeme;if(this.z(),this.y(9)){const x=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),x.type!==10)throw this.B("REGEX",x);const K=x.lexeme,ee=K.lastIndexOf("/"),_=ee===K.length-1?void 0:this.w(K.substring(ee+1));let Z;try{Z=new RegExp(K.substring(1,ee),_)}catch{throw this.B("REGEX",x)}return H.create(T,Z)}switch(x.type){case 10:case 19:{const K=[x.lexeme];this.z();let ee=this.D(),_=0;for(let fe=0;fe<x.lexeme.length;fe++)x.lexeme.charCodeAt(fe)===40?_++:x.lexeme.charCodeAt(fe)===41&&_--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let fe=0;fe<ee.lexeme.length;fe++)ee.lexeme.charCodeAt(fe)===40?_++:x.lexeme.charCodeAt(fe)===41&&_--}if(_<0)break;K.push(j.$rj.getLexeme(ee)),this.z(),ee=this.D()}const Z=K.join(""),se=Z.lastIndexOf("/"),ue=se===Z.length-1?void 0:this.w(Z.substring(se+1));let ge;try{ge=new RegExp(Z.substring(1,se),ue)}catch{throw this.B("REGEX",x)}return t.regex(T,ge)}case 18:{const K=x.lexeme;this.z();let ee=null;if(!(0,N.$8e)(K)){const _=K.indexOf("/"),Z=K.lastIndexOf("/");if(_!==Z&&_>=0){const se=K.slice(_+1,Z),ue=K[Z+1]==="i"?"i":"";try{ee=new RegExp(se,ue)}catch{throw this.B("REGEX",x)}}}if(ee===null)throw this.B("REGEX",x);return H.create(T,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const x=this.u();return t.notIn(T,x)}switch(this.D().type){case 3:{this.z();const x=this.u();if(this.x().type===18)return t.equals(T,x);switch(x){case"true":return t.has(T);case"false":return t.not(T);default:return t.equals(T,x)}}case 4:{this.z();const x=this.u();if(this.x().type===18)return t.notEquals(T,x);switch(x){case"true":return t.not(T);case"false":return t.has(T);default:return t.notEquals(T,x)}}case 5:return this.z(),q.create(T,this.u());case 6:return this.z(),Y.create(T,this.u());case 7:return this.z(),M.create(T,this.u());case 8:return this.z(),F.create(T,this.u());case 13:return this.z(),t.in(T,this.u());default:return t.has(T)}}case 20:throw this.h.push({message:m,offset:L.offset,lexeme:"",additionalInfo:d}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case 17:case 18:return this.z(),L.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,T){if(this.C(L))return this.z();throw this.B(T,this.D())}B(L,T,U){const x=(0,O.localize)(8,null,L,j.$rj.getLexeme(T)),K=T.offset,ee=j.$rj.getLexeme(T);return this.h.push({message:x,offset:K,lexeme:ee,additionalInfo:U}),$.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=$;class t{static false(){return i.INSTANCE}static true(){return o.INSTANCE}static has(L){return a.create(L)}static equals(L,T){return b.create(L,T)}static notEquals(L,T){return S.create(L,T)}static regex(L,T){return H.create(L,T)}static in(L,T){return k.create(L,T)}static notIn(L,T){return v.create(L,T)}static not(L){return P.create(L)}static and(...L){return J.create(L,null,!0)}static or(...L){return G.create(L,null,!0)}static greater(L,T){return M.create(L,T)}static greaterEquals(L,T){return F.create(L,T)}static smaller(L,T){return q.create(L,T)}static smallerEquals(L,T){return Y.create(L,T)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$uj=t;function r(z){const L=new $({regexParsingWithErrorRecovery:!1});return z.map(T=>(L.parse(T),L.lexingErrors.length>0?L.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,O.localize)(9,null,U.additionalInfo):(0,O.localize)(10,null),offset:U.offset,length:U.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function n(z,L){const T=z?z.substituteConstants():void 0,U=L?L.substituteConstants():void 0;return!T&&!U?!0:!T||!U?!1:T.equals(U)}function s(z,L){return z.cmp(L)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return o.INSTANCE}}e.$xj=i;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return i.INSTANCE}}e.$yj=o;class a{static create(L,T=null){const U=C.get(L);return typeof U=="boolean"?U?o.INSTANCE:i.INSTANCE:new a(L,T)}constructor(L,T){this.key=L,this.c=T,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:ie(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=C.get(this.key);return typeof L=="boolean"?L?o.INSTANCE:i.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$zj=a;class b{static create(L,T,U=null){if(typeof T=="boolean")return T?a.create(L,U):P.create(L,U);const x=C.get(L);return typeof x=="boolean"?T===(x?"true":"false")?o.INSTANCE:i.INSTANCE:new b(L,T,U)}constructor(L,T,U){this.c=L,this.d=T,this.f=U,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:re(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=C.get(this.c);if(typeof L=="boolean"){const T=L?"true":"false";return this.d===T?o.INSTANCE:i.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Aj=b;class k{static create(L,T){return new k(L,T)}constructor(L,T){this.d=L,this.f=T,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:re(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const T=L.getValue(this.f),U=L.getValue(this.d);return Array.isArray(T)?T.includes(U):typeof U=="string"&&typeof T=="object"&&T!==null?E.call(T,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Bj=k;class v{static create(L,T){return new v(L,T)}constructor(L,T){this.d=L,this.f=T,this.type=11,this.c=k.create(L,T)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=v;class S{static create(L,T,U=null){if(typeof T=="boolean")return T?P.create(L,U):a.create(L,U);const x=C.get(L);return typeof x=="boolean"?T===(x?"true":"false")?i.INSTANCE:o.INSTANCE:new S(L,T,U)}constructor(L,T,U){this.c=L,this.d=T,this.f=U,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:re(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=C.get(this.c);if(typeof L=="boolean"){const T=L?"true":"false";return this.d===T?i.INSTANCE:o.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Dj=S;class P{static create(L,T=null){const U=C.get(L);return typeof U=="boolean"?U?i.INSTANCE:o.INSTANCE:new P(L,T)}constructor(L,T){this.c=L,this.d=T,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:ie(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=C.get(this.c);return typeof L=="boolean"?L?i.INSTANCE:o.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Ej=P;function R(z,L){if(typeof z=="string"){const T=parseFloat(z);isNaN(T)||(z=T)}return typeof z=="string"||typeof z=="number"?L(z):i.INSTANCE}class M{static create(L,T,U=null){return R(T,x=>new M(L,x,U))}constructor(L,T,U){this.c=L,this.d=T,this.f=U,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:re(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Fj=M;class F{static create(L,T,U=null){return R(T,x=>new F(L,x,U))}constructor(L,T,U){this.c=L,this.d=T,this.f=U,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:re(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Gj=F;class q{static create(L,T,U=null){return R(T,x=>new q(L,x,U))}constructor(L,T,U){this.c=L,this.d=T,this.f=U,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:re(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Hj=q;class Y{static create(L,T,U=null){return R(T,x=>new Y(L,x,U))}constructor(L,T,U){this.c=L,this.d=T,this.f=U,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:re(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Ij=Y;class H{static create(L,T){return new H(L,T)}constructor(L,T){this.d=L,this.f=T,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const T=this.f?this.f.source:"",U=L.f?L.f.source:"";return T<U?-1:T>U?1:0}equals(L){if(L.type===this.type){const T=this.f?this.f.source:"",U=L.f?L.f.source:"";return this.d===L.d&&T===U}return!1}substituteConstants(){return this}evaluate(L){const T=L.getValue(this.d);return this.f?this.f.test(T):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$Jj=H;class X{static create(L){return new X(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new X(this.c.map(L))}negate(){return this.c}}e.$Kj=X;function W(z){let L=null;for(let T=0,U=z.length;T<U;T++){const x=z[T].substituteConstants();if(z[T]!==x&&L===null){L=[];for(let K=0;K<T;K++)L[K]=z[K]}L!==null&&(L[T]=x)}return L===null?z:L}class J{static create(L,T,U){return J.d(L,T,U)}constructor(L,T){this.expr=L,this.c=T,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let T=0,U=this.expr.length;T<U;T++){const x=s(this.expr[T],L.expr[T]);if(x!==0)return x}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let T=0,U=this.expr.length;T<U;T++)if(!this.expr[T].equals(L.expr[T]))return!1;return!0}return!1}substituteConstants(){const L=W(this.expr);return L===this.expr?this:J.create(L,this.c,!1)}evaluate(L){for(let T=0,U=this.expr.length;T<U;T++)if(!this.expr[T].evaluate(L))return!1;return!0}static d(L,T,U){const x=[];let K=!1;for(const ee of L)if(ee){if(ee.type===1){K=!0;continue}if(ee.type===0)return i.INSTANCE;if(ee.type===6){x.push(...ee.expr);continue}x.push(ee)}if(x.length===0&&K)return o.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(s);for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];for(;x.length>1;){const ee=x[x.length-1];if(ee.type!==9)break;x.pop();const _=x.pop(),Z=x.length===0,se=G.create(ee.expr.map(ue=>J.create([ue,_],null,U)),null,Z);se&&(x.push(se),x.sort(s))}if(x.length===1)return x[0];if(U){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return i.INSTANCE;if(x.length===1)return x[0]}return new J(x,T)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const T of this.expr)L.push(...T.keys());return L}map(L){return new J(this.expr.map(T=>T.map(L)),null)}negate(){if(!this.c){const L=[];for(const T of this.expr)L.push(T.negate());this.c=G.create(L,this,!0)}return this.c}}e.$Lj=J;class G{static create(L,T,U){return G.d(L,T,U)}constructor(L,T){this.expr=L,this.c=T,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let T=0,U=this.expr.length;T<U;T++){const x=s(this.expr[T],L.expr[T]);if(x!==0)return x}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let T=0,U=this.expr.length;T<U;T++)if(!this.expr[T].equals(L.expr[T]))return!1;return!0}return!1}substituteConstants(){const L=W(this.expr);return L===this.expr?this:G.create(L,this.c,!1)}evaluate(L){for(let T=0,U=this.expr.length;T<U;T++)if(this.expr[T].evaluate(L))return!0;return!1}static d(L,T,U){let x=[],K=!1;if(L){for(let ee=0,_=L.length;ee<_;ee++){const Z=L[ee];if(Z){if(Z.type===0){K=!0;continue}if(Z.type===1)return o.INSTANCE;if(Z.type===9){x=x.concat(Z.expr);continue}x.push(Z)}}if(x.length===0&&K)return i.INSTANCE;x.sort(s)}if(x.length!==0){if(x.length===1)return x[0];for(let ee=1;ee<x.length;ee++)x[ee-1].equals(x[ee])&&(x.splice(ee,1),ee--);if(x.length===1)return x[0];if(U){for(let ee=0;ee<x.length;ee++)for(let _=ee+1;_<x.length;_++)if(x[ee].negate().equals(x[_]))return o.INSTANCE;if(x.length===1)return x[0]}return new G(x,T)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const T of this.expr)L.push(...T.keys());return L}map(L){return new G(this.expr.map(T=>T.map(L)),null)}negate(){if(!this.c){const L=[];for(const T of this.expr)L.push(T.negate());for(;L.length>1;){const T=L.shift(),U=L.shift(),x=[];for(const K of V(T))for(const ee of V(U))x.push(J.create([K,ee],null,!1));L.unshift(G.create(x,null,!1))}this.c=G.create(L,this,!0)}return this.c}}e.$Mj=G;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(L,T,U){super(L,null),this.f=T,typeof U=="object"?B.d.push({...U,key:L}):U!==!0&&B.d.push({key:L,description:U,type:T!=null?typeof T:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return b.create(this.key,L)}notEqualsTo(L){return S.create(this.key,L)}}e.$Nj=B,e.$Oj=(0,A.$wi)("contextKeyService");function ie(z,L){return z<L?-1:z>L?1:0}function re(z,L,T,U){return z<T?-1:z>T?1:L<U?-1:L>U?1:0}function he(z,L){if(z.type===0||L.type===1)return!0;if(z.type===9)return L.type===9?te(z.expr,L.expr):!1;if(L.type===9){for(const T of L.expr)if(he(z,T))return!0;return!1}if(z.type===6){if(L.type===6)return te(L.expr,z.expr);for(const T of z.expr)if(he(T,L))return!0;return!1}return z.equals(L)}function te(z,L){let T=0,U=0;for(;T<z.length&&U<L.length;){const x=z[T].cmp(L[U]);if(x<0)return!1;x===0&&T++,U++}return T===z.length}function V(z){return z.type===9?z.expr:[z]}}),define(ae[94],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$dn=e.ID=void 0,e.$en=N,e.ID="diagnosticsService",e.$dn=(0,D.$wi)(e.ID);function N(A){return!!A.hostName&&!!A.errorMessage}class j{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$fn=j}),define(ae[95],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=void 0,e.$Ko=(0,D.$wi)("downloadService")}),define(ae[16],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,D.$wi)("environmentService"),e.$Ei=(0,D.$xi)(e.$Di)}),define(ae[29],ce([0,1,157,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=j,e.$1o=A,e.$2o=O,e.$3o=I,e.$4o=C,e.$5o=f,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function j(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function O(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function I(u,m){return m==="web"&&!u.includes("web")}function C(u,m,d){return I(m,d)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===d}function f(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var w;(function(u){u.Install="install",u.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var h;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$6o=(0,N.$wi)("extensionGalleryService");var c;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(c||(e.ExtensionManagementErrorCode=c={}));class p extends Error{constructor(m,d){super(m),this.code=d,this.name=d}}e.$7o=p;var g;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class l extends Error{constructor(m,d){super(m),this.code=d,this.name=d}}e.$8o=l,e.$9o=(0,N.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,N.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,N.$wi)("IExtensionTipsService"),e.$bp=(0,D.localize2)(0,"Extensions"),e.$cp=(0,D.localize2)(1,"Preferences")}),define(ae[194],ce([0,1,3,2,30,8,91,29]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.$dq=void 0;function C(g,l){return g?A.URI.revive(l?l.transformIncoming(g):g):void 0}function f(g,l){return l?l.transformOutgoingURI(g):g}function E(g,l){l=l||O.$zn;const u=g.manifest;return{...(0,O.$Cn)({...g,manifest:void 0},l),manifest:u}}function y(g,l){return g?.profileLocation?(0,O.$Cn)(g,l??O.$zn):g}function w(g,l){return l?(0,j.$5n)(g,u=>u instanceof A.URI?l.transformOutgoingURI(u):void 0):g}class h{constructor(l,u){this.a=l,this.b=u,this.onInstallExtension=D.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,u){const m=this.b(l);switch(u){case"onInstallExtension":return D.Event.map(this.onInstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map($=>({...$,local:$.local?w($.local,m):$.local,profileLocation:$.profileLocation?f($.profileLocation,m):$.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,d=>({...d,profileLocation:d.profileLocation?f(d.profileLocation,m):d.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,d=>w(d,m))}throw new Error("Invalid listen")}async call(l,u,m){const d=this.b(l);switch(u){case"zip":{const $=E(m[0],d),t=await this.a.zip($);return f(t,d)}case"unzip":return this.a.unzip(C(m[0],d));case"install":return this.a.install(C(m[0],d),y(m[1],d));case"installFromLocation":return this.a.installFromLocation(C(m[0],d),C(m[1],d));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(m[0],C(m[1],d),C(m[2],d));case"getManifest":return this.a.getManifest(C(m[0],d));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(m[0]);case"installFromGallery":return this.a.installFromGallery(m[0],y(m[1],d));case"installGalleryExtensions":{const $=m[0];return this.a.installGalleryExtensions($.map(({extension:t,options:r})=>({extension:t,options:y(r,d)??{}})))}case"uninstall":return this.a.uninstall(E(m[0],d),y(m[1],d));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(m[0],d));case"getInstalled":return(await this.a.getInstalled(m[0],C(m[1],d),m[2])).map(t=>w(t,d));case"toggleAppliationScope":{const $=await this.a.toggleAppliationScope(E(m[0],d),C(m[1],d));return w($,d)}case"copyExtensions":return this.a.copyExtensions(C(m[0],d),C(m[1],d));case"updateMetadata":{const $=await this.a.updateMetadata(E(m[0],d),m[1],C(m[2],d));return w($,d)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(m[0],m[1],m[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$dq=h;class c extends N.$Vc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new D.$ee),this.f=this.B(new D.$ee),this.g=this.B(new D.$ee),this.h=this.B(new D.$ee),this.j=this.B(new D.$ee),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?A.URI.revive(m.source):m.source,profileLocation:A.URI.revive(m.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(E(u,null))))}n(l,u){l.fire(u)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const u=await this.getTargetPlatform();return l.allTargetPlatforms.some(m=>(0,I.$4o)(m,l.allTargetPlatforms,u))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(u=>A.URI.revive(u)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,u){return Promise.resolve(this.m.call("install",[l,u])).then(m=>E(m,null))}installFromLocation(l,u){return Promise.resolve(this.m.call("installFromLocation",[l,u])).then(m=>E(m,null))}async installExtensionsFromProfile(l,u,m){return(await this.m.call("installExtensionsFromProfile",[l,u,m])).map($=>E($,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,u){return Promise.resolve(this.m.call("installFromGallery",[l,u])).then(m=>E(m,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?A.URI.revive(m.source):m.source,profileLocation:A.URI.revive(m.profileLocation)}))}uninstall(l,u){if(l.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[l,u]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(u=>E(u,null))}getInstalled(l=null,u,m){return Promise.resolve(this.m.call("getInstalled",[l,u,m])).then(d=>d.map($=>E($,null)))}updateMetadata(l,u,m){return Promise.resolve(this.m.call("updateMetadata",[l,u,m])).then(d=>E(d,null))}toggleAppliationScope(l,u){return this.m.call("toggleAppliationScope",[l,u]).then(m=>E(m,null))}copyExtensions(l,u){return this.m.call("copyExtensions",[l,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,u,m){const d=await this.m.call("download",[l,u,m]);return A.URI.revive(d)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$eq=c;class p{constructor(l){this.a=l}listen(l,u){throw new Error("Invalid listen")}call(l,u,m){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$fq=p}),define(ae[96],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s4b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$r4b=j;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function j(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$s4b=(0,D.$wi)("IExtensionRecommendationNotificationService")}),define(ae[12],ce([0,1,51,14,27,13,8,164,4,5,23,53]),function(ne,e,D,N,j,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=w,e.$5k=g,e.$6k=u,e.$7k=m,e.$8k=d,e.$9k=$,e.$0k=t,e.$$k=r,e.$_k=n,e.$al=s,e.$bl=i,e.$dl=b,e.$el=k,e.$fl=v,e.$gl=S,e.$hl=P,e.$kl=Y,e.$wl=B,e.$xl=ie,e.$zl=he,e.$3k=(0,C.$wi)("fileService");function w(te){return te.create===!0}var h;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var c;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var p;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(p||(e.FileChangeFilter=p={}));function g(te){const V=te;return!!V&&typeof V.onDidChange=="function"}var l;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(l||(e.FileSystemProviderCapabilities=l={}));function u(te){return!!(te.capabilities&2)}function m(te){return!!(te.capabilities&8)}function d(te){return!!(te.capabilities&131072)}function $(te){return!!(te.capabilities&4)}function t(te){return!!(te.capabilities&16)}function r(te){return u(te)?!!(te.capabilities&16384):!1}function n(te){return u(te)?!!(te.capabilities&32768):!1}function s(te){return!!(te.capabilities&65536)}function i(te){return!!(te.capabilities&2048)}var o;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class a extends Error{static create(V,z){const L=new a(V.toString(),z);return v(L,z),L}constructor(V,z){super(V),this.code=z}}e.$cl=a;function b(te,V){return a.create(te,V)}function k(te){return te||b((0,I.localize)(0,null),o.Unknown)}function v(te,V){return te.name=V?`${V} (FileSystemError)`:"FileSystemError",te}function S(te){if(!te)return o.Unknown;if(te instanceof a)return te.code;const V=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!V)return o.Unknown;switch(V[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function P(te){if(te instanceof H)return te.fileOperationResult;switch(S(te)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}var R;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class M{constructor(V,z,L){this.resource=V,this.operation=z,this.target=L}isOperation(V){return this.operation===V}}e.$il=M;var F;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class q{static{this.a=null}constructor(V,z){this.c=z,this.b=void 0,this.d=new y.$V(()=>{const L=D.$Ci.forUris(()=>this.c);return L.fill(this.rawAdded.map(T=>[T,!0])),L}),this.f=new y.$V(()=>{const L=D.$Ci.forUris(()=>this.c);return L.fill(this.rawUpdated.map(T=>[T,!0])),L}),this.g=new y.$V(()=>{const L=D.$Ci.forUris(()=>this.c);return L.fill(this.rawDeleted.map(T=>[T,!0])),L}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const L of V){switch(L.type){case 1:this.rawAdded.push(L.resource);break;case 0:this.rawUpdated.push(L.resource);break;case 2:this.rawDeleted.push(L.resource);break}this.b!==q.a&&(typeof L.cId=="number"?this.b===void 0?this.b=L.cId:this.b!==L.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(V,...z){return this.h(V,{includeChildren:!1},...z)}affects(V,...z){return this.h(V,{includeChildren:!0},...z)}h(V,z,...L){if(!V)return!1;const T=L.length>0;return!!((!T||L.includes(1))&&(this.d.value.get(V)||z.includeChildren&&this.d.value.findSuperstr(V))||(!T||L.includes(0))&&(this.f.value.get(V)||z.includeChildren&&this.f.value.findSuperstr(V))||(!T||L.includes(2))&&(this.g.value.findSubstr(V)||z.includeChildren&&this.g.value.findSuperstr(V)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(V){return this.b===V}hasCorrelation(){return typeof this.b=="number"}}e.$jl=q;function Y(te,V,z){return!te||!V||te===V||V.length>te.length?!1:(V.charAt(V.length-1)!==N.sep&&(V+=N.sep),z?(0,j.$zf)(te,V):te.indexOf(V)===0)}class H extends Error{constructor(V,z,L){super(V),this.fileOperationResult=z,this.options=L}}e.$ll=H;class X extends H{constructor(V,z,L,T){super(V,z,T),this.fileOperationResult=z,this.size=L}}e.$ml=X;class W extends H{constructor(V,z,L){super(V,2,L),this.stat=z}}e.$nl=W;var J;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var G;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(G||(e.FileKind=G={})),e.$vl="";function B(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function ie(te,V){if(!V.hasProvider(O.URI.from({scheme:te.scheme})))return new Promise(z=>{const L=V.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===te.scheme&&T.added&&(L.dispose(),z())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(V){return(0,A.$ag)(V)||(V=0),V<re.KB?(0,I.localize)(1,null,V.toFixed(0)):V<re.MB?(0,I.localize)(2,null,(V/re.KB).toFixed(2)):V<re.GB?(0,I.localize)(3,null,(V/re.MB).toFixed(2)):V<re.TB?(0,I.localize)(4,null,(V/re.GB).toFixed(2)):(0,I.localize)(5,null,(V/re.TB).toFixed(2))}}e.$yl=re;function he(te){const V=typeof te=="string"||te?.scheme===E.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===E.Schemas.file?1024*re.MB:V?10*re.MB:f.$o?50*re.MB:1024*re.MB}});var Q=this&&this.__param||function(ne,e){return function(D,N){e(D,N,ne)}};define(ae[195],ce([0,1,73,50,12]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;let A=class{constructor(I){this.a=I}async checksum(I){const C=(await this.a.readFileStream(I)).value;return new Promise((f,E)=>{const y=(0,D.createHash)("sha256");(0,N.$ye)(C,{onData:w=>y.update(w.buffer),onError:w=>E(w),onEnd:()=>f(y.digest("base64").replace(/=+$/,""))})})}};e.$eec=A,e.$eec=A=Ee([Q(0,j.$3k)],A)}),define(ae[97],ce([0,1,15,7,165,12]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=O;async function O(E,y,w,h,c,p){let g;try{await I(E,y,w,h,c,p)}catch(l){g=l}finally{g&&c.errorTransformer&&(g=c.errorTransformer(g)),typeof g<"u"&&w.error(g),w.end()}}async function I(E,y,w,h,c,p){C(p);const g=await E.open(y,{create:!1});try{C(p);let l=0,u=0,m=c&&typeof c.length=="number"?c.length:void 0,d=D.$Ge.alloc(Math.min(c.bufferSize,typeof m=="number"?m:c.bufferSize)),$=c&&typeof c.position=="number"?c.position:0,t=0;do u=await E.read(g,$,d.buffer,t,d.byteLength-t),$+=u,t+=u,l+=u,typeof m=="number"&&(m-=u),t===d.byteLength&&(await w.write(h(d)),d=D.$Ge.alloc(Math.min(c.bufferSize,typeof m=="number"?m:c.bufferSize)),t=0);while(u>0&&(typeof m!="number"||m>0)&&C(p)&&f(l,c));if(t>0){let r=t;typeof m=="number"&&(r=Math.min(t,m)),w.write(h(d.slice(0,r)))}}catch(l){throw(0,A.$el)(l)}finally{await E.close(g)}}function C(E){if(E.isCancellationRequested)throw(0,N.$6)();return!0}function f(E,y){if(typeof y?.limits?.size=="number"&&E>y.limits.size)throw(0,A.$dl)((0,j.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[46],ce([0,1,90,2,14,5,8,12]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=void 0,e.$Jq=C,e.$Kq=f,e.$Oq=h,e.$Pq=c,e.$Qq=p,e.$Rq=g,e.$Sq=u,e.$Tq=m;function C(d){return typeof d.correlationId=="number"}function f(d){return d.recursive===!0}class E extends N.$Vc{static{this.a=5}constructor($,t,r,n){super(),this.h=$,this.j=t,this.m=r,this.n=n,this.c=this.B(new N.$Wc),this.f=void 0,this.g=0}s(){const $=new N.$Uc;this.c.value=$,this.b=this.r($),this.b.setVerboseLogging(this.m),$.add(this.b.onDidChangeFile(t=>this.h(t))),$.add(this.b.onDidLogMessage(t=>this.j(t))),$.add(this.b.onDidError(t=>this.t(t)))}t($){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${$}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${$}`):this.w($)}u($){this.g++,this.s(),this.watch($)}async watch($){this.f=$,await this.b?.watch($)}async setVerboseLogging($){this.m=$,await this.b?.setVerboseLogging($)}w($){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${$}`})}y($){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${$}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Lq=E;class y extends E{constructor($,t,r){super($,t,r,{type:"node.js",restartOnError:!1})}}e.$Mq=y;class w extends E{constructor($,t,r){super($,t,r,{type:"universal",restartOnError:!0})}}e.$Nq=w;function h(d){return d.map($=>({type:$.type,resource:O.URI.revive($.resource),cId:$.cId}))}function c(d){const $=new l;for(const t of d)$.processEvent(t);return $.coalesce()}function p(d,$){return typeof $=="string"&&!$.startsWith(D.$mk)&&!(0,j.$jc)($)?{base:d,pattern:$}:$}function g(d,$){const t=[];for(const r of $)t.push((0,D.$qk)(p(d,r)));return t}class l{constructor(){this.a=new Set,this.b=new Map}c($){return A.$k?$.resource.fsPath:$.resource.fsPath.toLowerCase()}processEvent($){const t=this.b.get(this.c($));let r=!1;if(t){const n=t.type,s=$.type;t.resource.fsPath!==$.resource.fsPath&&($.type===2||$.type===1)?r=!0:n===1&&s===2?(this.b.delete(this.c($)),this.a.delete(t)):n===2&&s===1?t.type=0:n===1&&s===0||(t.type=s)}else r=!0;r&&(this.a.add($),this.b.set(this.c($),$))}coalesce(){const $=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?($.push(r),!1):!0).sort((r,n)=>r.resource.fsPath.length-n.resource.fsPath.length).filter(r=>t.some(n=>(0,I.$kl)(r.resource.fsPath,n,!A.$k))?!1:(t.push(r.resource.fsPath),!0)).concat($)}}function u(d,$){if(typeof $=="number")switch(d.type){case 1:return($&4)===0;case 2:return($&8)===0;case 0:return($&2)===0}return!1}function m(d){if(typeof d=="number"){const $=[];return d&4&&$.push("Added"),d&8&&$.push("Deleted"),d&2&&$.push("Updated"),$.length===0?"<all>":`[${$.join(", ")}]`}return"<none>"}}),define(ae[196],ce([0,1,15,38,7,3,2,50,32,12,46]),function(ne,e,D,N,j,A,O,I,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=e.$wQ=void 0,e.$wQ="localFilesystem";class y extends O.$Vc{constructor(h,c){super(),this.a=h,this.b=c,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$ee),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$ee),this.onDidWatchError=this.g.event,this.h=(0,C.$Sg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,c){const{buffer:p}=await this.a.call("readFile",[h,c]);return p}readFileStream(h,c,p){const g=(0,I.$ue)(u=>D.$Ge.concat(u.map(m=>D.$Ge.wrap(m))).buffer),l=new O.$Uc;return l.add(this.a.listen("readFileStream",[h,c])(u=>{if(u instanceof D.$Ge)g.write(u.buffer);else{if(u==="end")g.end();else{let m;if(u instanceof Error)m=u;else{const d=u;m=(0,f.$dl)(d.message??(0,N.$hj)(d),d.code??f.FileSystemProviderErrorCode.Unknown)}g.error(m),g.end()}l.dispose()}})),l.add(p.onCancellationRequested(()=>{g.error((0,j.$6)()),g.end(),l.dispose()})),g}writeFile(h,c,p){return this.a.call("writeFile",[h,D.$Ge.wrap(c),p])}open(h,c){return this.a.call("open",[h,c])}close(h){return this.a.call("close",[h])}async read(h,c,p,g,l){const[u,m]=await this.a.call("read",[h,c,l]);return p.set(u.buffer.slice(0,m),g),m}write(h,c,p,g,l){return this.a.call("write",[h,c,D.$Ge.wrap(p),g,l])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,c){return this.a.call("delete",[h,c])}rename(h,c,p){return this.a.call("rename",[h,c,p])}copy(h,c,p){return this.a.call("copy",[h,c,p])}cloneFile(h,c){return this.a.call("cloneFile",[h,c])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const c=h;this.f.fire((0,E.$Oq)(c))}else{const c=h;this.g.fire(c)}}))}watch(h,c){const p=(0,C.$Sg)();return this.a.call("watch",[this.h,p,h,c]),(0,O.$Tc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$xQ=y}),define(ae[197],ce([0,1,41,2,46,3,8,6]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class C extends N.$Vc{constructor(){super(),this.a=this.B(new A.$ee),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$ee),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$ee),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$5c),this.m=new Set,this.n=5007,this.r=new I.$Th,this.P=!1,this.B(this.f(E=>this.s(E)))}s(E){this.t(E)&&this.w(E)}t(E){return(0,j.$Jq)(E)}async watch(E){this.r.isSettled||this.r.complete(),this.r=new I.$Th;try{this.h.clear(),this.g.clear();for(const y of E)this.t(y)?this.h.set(y.correlationId,y):this.g.add(y);for(const[y]of this.j)this.h.has(y)||(this.j.deleteAndDispose(y),this.m.delete(y));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(E=>!this.j.has(E.correlationId))])}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async w(E){if(this.j.has(E.correlationId))return;const y=new N.$Uc;this.j.set(E.correlationId,y),await this.r.p,!y.isDisposed&&(this.z(E,y),this.u())}y(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.u()}z(E,y){this.C(E,y)?(this.N(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.D(E,y),this.m.add(E.correlationId))}C(E,y){const w=this.M?.subscribe(E.path,(h,c)=>{y.isDisposed||(h?this.z(E,y):c?.type===1&&this.F(E))});return w?(y.add(w),!0):!1}D(E,y){let w=!1;const h=(c,p)=>{if(y.isDisposed)return;const g=this.G(c),l=this.G(p),u=w;w=g,!g&&(l||u)&&this.F(E)};this.N(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,D.watchFile)(E.path,{persistent:!1,interval:this.n},h)}catch(c){this.O(`fs.watchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}y.add((0,N.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,D.unwatchFile)(E.path,h)}catch(c){this.O(`fs.unwatchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}F(E){this.N(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const y={resource:O.URI.file(E.path),type:1,cId:E.correlationId};this.a.fire([y]),this.H(y,E),this.y(E)}G(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(E,y){if(this.P){const w=` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.I(w,y)}}I(E,y){this.P&&this.N(`${E}${typeof y.correlationId=="number"?` <${y.correlationId}> `:""}`)}J(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,j.$Tq)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.P=E}}e.$3q=C}),define(ae[198],ce([0,1,41,6,26,40,2,87,14,5,20,8,148,31,46]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0,e.$9q=g;class p extends O.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(u,m,d,$,t,r){super(),this.s=u,this.t=m,this.u=d,this.w=$,this.y=t,this.z=r,this.c=this.B(new N.$Lh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.u(n))),this.f=this.B(new N.$Kh(n=>this.M(n),p.b)),this.g=(0,c.$Rq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$Rq)(this.s.path,this.s.includes):void 0,this.j=(0,c.$Jq)(this.s)?this.s.filter:void 0,this.m=new j.$pe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const u=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const m=await h.Promises.stat(u);if(this.m.token.isCancellationRequested)return;this.B(await this.G(u,m.isDirectory()))}catch(u){u.code!=="ENOENT"?this.O(u):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${u})`),this.D()}}D(){this.r=!0,this.w?.()}async F(u){let m=u.path;try{m=await h.Promises.realpath(u.path),u.path===m&&(m=await(0,w.$5q)(u.path,this.m.token)??u.path),u.path!==m&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${m})`)}catch{}return m}async G(u,m){const d=new O.$Uc;return this.H(u,m,d)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(u,m,d)),d}H(u,m,d){if(m)return!1;const $=y.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,n)=>{if(!d.isDisposed)if(r){const s=await this.G(u,m);d.isDisposed?s.dispose():d.add(s)}else n&&(typeof n.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:$,type:n.type,cId:this.s.correlationId},!0)});return t?(d.add(t),!0):!1}async I(u,m,d){if(f.$j&&(0,A.$vg)(u,"/Volumes/",!0)){this.O(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const $=new j.$pe(this.m.token);d.add((0,O.$Tc)(()=>$.dispose(!0)));const t=new O.$Uc;d.add(t);try{const r=y.URI.file(this.s.path),n=(0,C.$oc)(u),s=(0,D.watch)(u);t.add((0,O.$Tc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${u}'`);const i=new Set;if(m)try{for(const a of await h.Promises.readdir(u))i.add(a)}catch(a){this.O(a)}if($.token.isCancellationRequested)return;const o=new Map;t.add((0,O.$Tc)(()=>{for(const[,a]of o)a.dispose();o.clear()})),s.on("error",(a,b)=>{$.token.isCancellationRequested||(this.O(`Failed to watch ${u} for changes using fs.watch() (${a}, ${b})`),this.D())}),s.on("change",(a,b)=>{if($.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${a}"] ${b}`);let k="";if(b&&(k=b.toString(),f.$j&&(k=(0,I.$bm)(k))),!(!k||a!=="change"&&a!=="rename"))if(m)if(a==="rename"){o.get(k)?.dispose();const v=setTimeout(async()=>{if(o.delete(k),k===n&&!await h.Promises.exists(u)){this.J(r);return}if($.token.isCancellationRequested)return;const S=await this.N((0,C.$kc)(u,k));if($.token.isCancellationRequested)return;let P;S?i.has(k)?P=0:(P=1,i.add(k)):(i.delete(k),P=2),this.L({resource:(0,E.$0g)(r,k),type:P,cId:this.s.correlationId})},p.a);o.set(k,(0,O.$Tc)(()=>clearTimeout(v)))}else{let v;i.has(k)?v=0:(v=1,i.add(k)),this.L({resource:(0,E.$0g)(r,k),type:v,cId:this.s.correlationId})}else if(a==="rename"||k!==n){const v=setTimeout(async()=>{const S=await h.Promises.exists(u);$.token.isCancellationRequested||(S?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(u,!1))):this.J(r))},p.a);t.clear(),t.add((0,O.$Tc)(()=>clearTimeout(v)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){$.token.isCancellationRequested||this.O(`Failed to watch ${u} for changes using fs.watch() (${r.toString()})`),this.D()}}J(u){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:u,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(u,m=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!m&&this.g.some(d=>d(u.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${u.resource.fsPath}`):!m&&this.h&&this.h.length>0&&!this.h.some(d=>d(u.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}M(u){const m=(0,c.$Pq)(u),d=[];for(const t of m){if((0,c.$Sq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}d.push(t)}if(d.length===0)return;if(this.z)for(const t of d)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(d)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(u){if(f.$k)return h.Promises.exists(u);try{const m=(0,C.$oc)(u);return(await h.Promises.readdir((0,C.$nc)(u))).some($=>$===m)}catch(m){return this.Q(m),!1}}setVerboseLogging(u){this.z=u}O(u){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}P(u){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}Q(u){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}R(u){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${u}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$8q=p;async function g(l,u,m,d,$=512){const t=await h.Promises.open(l,"r"),r=Buffer.allocUnsafe($),n=new j.$pe(d);let s,i=!1;const o={path:l,excludes:[],recursive:!1},a=new p(o,void 0,b=>{(async()=>{for(const{type:k}of b)if(k===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:v}=await h.Promises.read(t,r,0,$,null);if(!v||n.token.isCancellationRequested)break;u(r.slice(0,v))}}catch(v){s=new Error(v),n.dispose(!0)}finally{i=!1}}})()});return await a.ready,m(),new Promise((b,k)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await h.Promises.close(t)}catch(v){s=new Error(v)}s?k(s):b()})})}}),define(ae[199],ce([0,1,3,90,197,5,198,40]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class C extends j.$3q{constructor(E){super(),this.M=E,this.onDidError=D.Event.None,this.watchers=new Set}async L(E){E=this.X(E);const y=[],w=new Set(Array.from(this.watchers));for(const h of E){const c=this.S(h);c&&(0,N.$uk)(c.request.excludes,h.excludes)&&(0,N.$uk)(c.request.includes,h.includes)?w.delete(c):y.push(h)}y.length&&this.N(`Request to start watching: ${y.map(h=>this.J(h)).join(",")}`),w.size&&this.N(`Request to stop watching: ${Array.from(w).map(h=>this.J(h.request)).join(",")}`);for(const h of w)this.W(h);for(const h of y)this.U(h)}S(E){for(const y of this.watchers)if(typeof E.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===E.correlationId)return y}else if((0,I.$ug)(y.request.path,E.path,!A.$k))return y}U(E){const y=new O.$8q(E,this.M,h=>this.a.fire(h),()=>this.c.fire(E),h=>this.b.fire(h),this.P),w={request:E,instance:y};this.watchers.add(w)}async stop(){await super.stop();for(const E of this.watchers)this.W(E)}W(E){this.N("stopping file watcher",E),this.watchers.delete(E),E.instance.dispose()}X(E){const y=new Map;for(const w of E){const h=A.$k?w.path:w.path.toLowerCase();let c=y.get(w.correlationId);c||(c=new Map,y.set(w.correlationId,c)),c.has(h)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(w)}`),c.set(h,w)}return Array.from(y.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(E){super.setVerboseLogging(E);for(const y of this.watchers)y.instance.setVerboseLogging(E)}N(E,y){this.P&&this.b.fire({type:"trace",message:this.$(E,y)})}O(E){this.b.fire({type:"warn",message:this.$(E)})}$(E,y){return y?`[File Watcher (node.js)] ${E} (${this.J(y.request)})`:`[File Watcher (node.js)] ${E}`}}e.$0q=C}),define(ae[200],ce([0,1,46,199]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class j extends D.$Mq{constructor(O,I,C){super(O,I,C),this.s()}r(O){return O.add(new N.$0q(void 0))}}e.$$q=j}),define(ae[201],ce([0,1,23,42,92,46]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class O extends A.$Nq{constructor(C,f,E){super(C,f,E),this.s()}r(C){const f=C.add(new j.$1q(D.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(f.onDidProcessExit(({code:E,signal:y})=>this.t(`terminated by itself with code ${E}, signal: ${y} (ETERM)`))),N.ProxyChannel.toService((0,N.$di)(f.getChannel("watcher")))}}e.$2q=O}),define(ae[74],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class D{constructor(...j){this.a=new Map;for(const[A,O]of j)this.set(A,O)}set(j,A){const O=this.a.get(j);return this.a.set(j,A),O}has(j){return this.a.has(j)}get(j){return this.a.get(j)}}e.$ui=D}),define(ae[202],ce([0,1,6,7,2,72,192,4,74,86]),function(ne,e,D,N,j,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const E=!1;class y extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class w{constructor(g=new C.$ui,l=!1,u,m=E){this.i=g,this.j=l,this.k=u,this.l=m,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$vi,this),this._globalGraph=m?u?._globalGraph??new O.$br(d=>d):void 0}dispose(){if(!this.f){this.f=!0,(0,j.$Qc)(this.h),this.h.clear();for(const g of this.g)(0,j.$Pc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const l=new class extends w{dispose(){this.h.delete(l),super.dispose()}}(g,this.j,this,this.l);return this.h.add(l),l}invokeFunction(g,...l){this.m();const u=c.traceInvocation(this.l,g);let m=!1;try{return g({get:$=>{if(m)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s($,u);if(!t)throw new Error(`[invokeFunction] unknown service '${$}'`);return t}},...l)}finally{m=!0,u.stop()}}createInstance(g,...l){this.m();let u,m;return g instanceof A.$ti?(u=c.traceCreation(this.l,g.ctor),m=this.o(g.ctor,g.staticArguments.concat(l),u)):(u=c.traceCreation(this.l,g),m=this.o(g,l,u)),u.stop(),m}o(g,l=[],u){const m=I._util.getServiceDependencies(g).sort((t,r)=>t.index-r.index),d=[];for(const t of m){const r=this.s(t.id,u);r||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(r)}const $=m.length>0?m[0].index:l.length;if(l.length!==$){console.trace(`[createInstance] First service dependency of ${g.name} at position ${$+1} conflicts with ${l.length} static arguments`);const t=$-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,$)}return Reflect.construct(g,l.concat(d))}q(g,l){if(this.i.get(g)instanceof A.$ti)this.i.set(g,l);else if(this.k)this.k.q(g,l);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const l=this.i.get(g);return!l&&this.k?this.k.r(g):l}s(g,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const u=this.r(g);return u instanceof A.$ti?this.u(g,u,l.branch(g,!0)):(l.branch(g,!1),u)}u(g,l,u){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,l,u)}finally{this.t.delete(g)}}v(g,l,u){const m=new O.$br(t=>t.id.toString());let d=0;const $=[{id:g,desc:l,_trace:u}];for(;$.length;){const t=$.pop();if(m.lookupOrInsertNode(t),d++>1e3)throw new y(m);for(const r of I._util.getServiceDependencies(t.desc.ctor)){const n=this.r(r.id);if(n||this.y(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),n instanceof A.$ti){const s={id:r.id,desc:n,_trace:t._trace.branch(r.id,!0)};m.insertEdge(t,s),$.push(s)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new y(m);break}for(const{data:r}of t){if(this.r(r.id)instanceof A.$ti){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}m.removeNode(r)}}return this.r(g)}w(g,l,u=[],m,d){if(this.i.get(g)instanceof A.$ti)return this.x(g,l,u,m,d,this.g);if(this.k)return this.k.w(g,l,u,m,d);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}x(g,l,u=[],m,d,$){if(m){const t=new w(void 0,this.j,this,this.l);t.c=String(g);const r=new Map,n=new D.$Ph(()=>{const s=t.o(l,u,d);for(const[i,o]of r){const a=s[i];if(typeof a=="function")for(const b of o)b.disposable=a.apply(s,b.listener)}return r.clear(),$.add(s),s});return new Proxy(Object.create(null),{get(s,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=r.get(i);return b||(b=new f.$6c,r.set(i,b)),(v,S,P)=>{if(n.isInitialized)return n.value[i](v,S,P);{const R={listener:[v,S,P],disposable:void 0},M=b.push(R);return(0,j.$Tc)(()=>{M(),R.disposable?.dispose()})}}}if(i in s)return s[i];const o=n.value;let a=o[i];return typeof a!="function"||(a=a.bind(o),s[i]=a),a},set(s,i,o){return n.value[i]=o,!0},getPrototypeOf(s){return l.prototype}})}else{const t=this.o(l,u,d);return $.add(t),t}}y(g,l){if(l&&console.warn(g),this.j)throw new Error(g)}}e.$cr=w;var h;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(h||(h={}));class c{static{this.all=new Set}static{this.c=new class extends c{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,l){return g?new c(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):c.c}static traceCreation(g,l){return g?new c(1,l.name):c.c}static{this.f=0}constructor(g,l){this.type=g,this.name=l,this.g=Date.now(),this.h=[]}branch(g,l){const u=new c(3,g.toString());return this.h.push([g,l,u]),u}stop(){const g=Date.now()-this.g;c.f+=g;let l=!1;function u(d,$){const t=[],r=new Array(d+1).join("	");for(const[n,s,i]of $.h)if(s&&i){l=!0,t.push(`${r}CREATES -> ${n}`);const o=u(d+1,i);o&&t.push(o)}else t.push(`${r}uses -> ${n}`);return t.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${c.f.toFixed(2)}ms)`];(g>2||l)&&c.all.add(m.join(`
`))}}e.$dr=c}),define(ae[56],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=void 0,e.$Ldc=(0,D.$wi)("mainProcessService");class N{constructor(A,O){this.a=A,this.b=O}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,O){this.a.registerChannel(A,O)}}e.$Mdc=N}),define(ae[75],ce([0,1,26,2,5,167,29,4]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=void 0,e.$Qr=C;function C(E){return E.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$Rr=(0,I.$wi)("languagePackService");let f=class extends N.$Vc{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new D.$pe;setTimeout(()=>y.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const c=w.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(g=>g.startsWith("lp-"))).map(p=>{const g=p.properties.localizedLanguages?.[0],l=C(p);return{...this.f(l,g,p),extensionId:p.identifier.id,galleryExtension:p}});return c.push(this.f("en","English")),c}f(y,w,h){const c=w??y;let p;if(c!==y&&(p=`(${y})`),y.toLowerCase()===j.$w.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),h?.installCount){p??="";const g=h.installCount;let l;g>1e6?l=`${Math.floor(g/1e5)/10}M`:g>1e3?l=`${Math.floor(g/1e3)}K`:l=String(g),p+=` $(cloud-download) ${l}`}return{id:y,label:c,description:p}}};e.$Sr=f,e.$Sr=f=Ee([Q(0,O.$6o)],f)}),define(ae[203],ce([0,1,2,75]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;let j=class extends D.$Vc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$aec=j,e.$aec=j=Ee([Q(0,N.$Rr)],j)}),define(ae[9],ce([0,1,168,38,3,54,2,34,5,20,13,8,93,4]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=p,e.log=l,e.$ek=a,e.$fk=b,e.$gk=k,e.$hk=v,e.$3j=(0,h.$wi)("logService"),e.$4j=(0,h.$wi)("loggerService");function c(){return new Date().toISOString()}function p(S){return(0,E.$ag)(S)}var g;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$6j=g.Info;function l(S,P,R){switch(P){case g.Trace:S.trace(R);break;case g.Debug:S.debug(R);break;case g.Info:S.info(R);break;case g.Warning:S.warn(R);break;case g.Error:S.error(R);break;case g.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function u(S,P=!1){let R="";for(let M=0;M<S.length;M++){let F=S[M];if(F instanceof Error&&(F=(0,N.$hj)(F,P)),typeof F=="object")try{F=JSON.stringify(F)}catch{}R+=(M>0?" ":"")+F}return R}class m extends O.$Vc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new j.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==g.Off&&this.b<=P}}e.$8j=m;class d extends m{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...R){this.f(g.Trace)&&this.g(g.Trace,u([P,...R],!0))}debug(P,...R){this.f(g.Debug)&&this.g(g.Debug,u([P,...R]))}info(P,...R){this.f(g.Info)&&this.g(g.Info,u([P,...R]))}warn(P,...R){this.f(g.Warning)&&this.g(g.Warning,u([P,...R]))}error(P,...R){if(this.f(g.Error))if(P instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=P.stack,this.g(g.Error,u(M))}else this.g(g.Error,u([P,...R]))}flush(){}}e.$9j=d;class $ extends m{constructor(P=e.$6j){super(),this.setLevel(P),this.g=!C.$i}trace(P,...R){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,P,...R):console.log(`[main ${c()}]`,P,...R))}debug(P,...R){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,P,...R):console.log(`[main ${c()}]`,P,...R))}info(P,...R){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,P,...R):console.log(`[main ${c()}]`,P,...R))}warn(P,...R){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,P,...R):console.warn(`[main ${c()}]`,P,...R))}error(P,...R){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,P,...R):console.error(`[main ${c()}]`,P,...R))}flush(){}}e.$0j=$;class t extends m{constructor(P=e.$6j,R=!0){super(),this.g=R,this.setLevel(P)}trace(P,...R){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...R):console.log(P,...R))}debug(P,...R){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...R):console.log(P,...R))}info(P,...R){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...R):console.log(P,...R))}warn(P,...R){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...R):console.log(P,...R))}error(P,...R){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...R):console.error(P,...R))}flush(){}}e.$$j=t;class r extends m{constructor(P,R=e.$6j){super(),this.g=P,this.setLevel(R)}trace(P,...R){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(P),...R])}debug(P,...R){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(P),...R])}info(P,...R){this.f(g.Info)&&this.g.log(g.Info,[this.h(P),...R])}warn(P,...R){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(P),...R])}error(P,...R){this.f(g.Error)&&this.g.log(g.Error,[this.h(P),...R])}h(P){return typeof P=="string"?P:(0,N.$hj)(P,this.f(g.Trace))}flush(){}}e.$_j=r;class n extends m{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const R of this.g)R.setLevel(P);super.setLevel(P)}trace(P,...R){for(const M of this.g)M.trace(P,...R)}debug(P,...R){for(const M of this.g)M.debug(P,...R)}info(P,...R){for(const M of this.g)M.info(P,...R)}warn(P,...R){for(const M of this.g)M.warn(P,...R)}error(P,...R){for(const M of this.g)M.error(P,...R)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$ak=n;class s extends O.$Vc{constructor(P,R,M){if(super(),this.h=P,this.j=R,this.b=new I.$Bc,this.c=this.B(new j.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new j.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new j.$ee),this.onDidChangeVisibility=this.g.event,M)for(const F of M)this.b.set(F.resource,{logger:void 0,info:F})}m(P){return(0,E.$9f)(P)?[...this.b.values()].find(R=>R.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,R){const M=this.n(P),F=(0,E.$9f)(P)?P:R?.id??(0,A.$kj)(M.toString()).toString(16);let q=this.b.get(M)?.logger;const Y=R?.logLevel==="always"?g.Trace:R?.logLevel;q||(q=this.s(M,Y??this.getLogLevel(M)??this.h,{...R,id:F}));const H={logger:q,info:{resource:M,id:F,logLevel:Y,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(H.info),this.b.set(M,H),q}n(P){return(0,E.$9f)(P)?(0,f.$0g)(this.j,`${P}.log`):P}setLogLevel(P,R){if(y.URI.isUri(P)){const M=P,F=R,q=this.b.get(M);q&&F!==q.info.logLevel&&(q.info.logLevel=F===this.h?void 0:F,q.logger?.setLevel(F),this.b.set(q.info.resource,q),this.f.fire([M,F]))}else{this.h=P;for(const[M,F]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,R){const M=this.m(P);M&&R!==!M.info.hidden&&(M.info.hidden=!R,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,R]))}getLogLevel(P){let R;return P&&(R=this.b.get(P)?.info.logLevel),R??this.h}registerLogger(P){const R=this.b.get(P.resource);R?R.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const R=this.b.get(P);R&&(R.logger&&R.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=s;class i{constructor(){this.onDidChangeLogLevel=new j.$ee().event}setLevel(P){}getLevel(){return g.Info}trace(P,...R){}debug(P,...R){}info(P,...R){}warn(P,...R){}error(P,...R){}critical(P,...R){}dispose(){}flush(){}}e.$ck=i;class o extends i{}e.$dk=o;function a(S){if(S.verbose)return g.Trace;if(typeof S.logLevel=="string"){const P=v(S.logLevel.toLowerCase());if(P!==void 0)return P}return e.$6j}function b(S){switch(S){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function k(S){switch(S){case g.Trace:return{original:"Trace",value:D.localize(0,null)};case g.Debug:return{original:"Debug",value:D.localize(1,null)};case g.Info:return{original:"Info",value:D.localize(2,null)};case g.Warning:return{original:"Warning",value:D.localize(3,null)};case g.Error:return{original:"Error",value:D.localize(4,null)};case g.Off:return{original:"Off",value:D.localize(5,null)}}}function v(S){switch(S){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$ik=new w.$Nj("logLevel",b(g.Info))}),define(ae[204],ce([0,1,6,7,2,23,14,20,31,16,9]),function(ne,e,D,N,j,A,O,I,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;let y=class extends j.$Vc{constructor(h,c){super(),this.a=h,this.b=c,this.B(new D.$Ih(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const h=(0,I.$7g)(this.a.logsHome),c=(0,I.$9g)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,l=(await C.Promises.readdir(c)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==h),u=l.slice(0,Math.max(0,l.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(m=>C.Promises.rm((0,O.$kc)(c,m)))))}catch(h){(0,N.$1)(h)}}};e.$bec=y,e.$bec=y=Ee([Q(0,f.$Di),Q(1,E.$3j)],y)}),define(ae[205],ce([0,1,17,6,7,3,40,2,14,46,9]),function(ne,e,D,N,j,A,O,I,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class y extends I.$Vc{constructor(h,c){super(),this.a=h,this.b=c,this.c=this.B(new A.$ee),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$ee),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$uh(0)),this.w=[],this.y=this.B(new N.$uh(0))}watch(h,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(h,c):this.z(h,c)}n(h,c){const p={path:this.J(h),excludes:c.excludes,includes:c.includes,recursive:c.recursive,filter:c.filter,correlationId:c.correlationId},g=(0,D.$Ub)(this.j,p);return this.r(),(0,I.$Tc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(h=>(0,j.$1)(h))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,f.$Oq)(c)),c=>this.G(c),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const h=this.b?.watcher?.recursive?.usePolling;if(h===!0)for(const c of this.j)(0,f.$Kq)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const c of this.j)(0,f.$Kq)(c)&&h.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(h,c){const p={path:this.J(h),excludes:c.excludes,includes:c.includes,recursive:!1,filter:c.filter,correlationId:c.correlationId},g=(0,D.$Ub)(this.w,p);return this.C(),(0,I.$Tc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(h=>(0,j.$1)(h))}D(){return this.u||(this.u=this.B(this.F(h=>this.c.fire((0,f.$Oq)(h)),h=>this.G(h),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(h){h.type==="error"&&this.g.fire(h.message),this.H(h)}H(h){this.a[h.type](h.message)}I(h){return(0,C.$ic)(h.fsPath)}J(h){const c=this.I(h);return(0,O.$yg)(c)}}e.$Uq=y}),define(ae[206],ce([0,1,17,6,15,26,3,54,61,2,51,23,98,20,50,163,12,97,9,7]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;let $=class extends f.$Vc{static{d=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new O.$ee),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$ee),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$ee),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$ee),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$ee),this.Y=this.B(new O.$ee),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$ee),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$Fh)}registerProvider(r,n){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${r}`);const s=new f.$Uc;return this.h.set(r,n),this.c.fire({added:!0,scheme:r,provider:n}),s.add(n.onDidChangeFile(i=>{const o=new g.$jl(i,!this.S(n));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this.Z.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:r}))),(0,f.$Tc)(()=>{this.c.fire({added:!1,scheme:r,provider:n}),this.h.delete(r),(0,f.$Qc)(s)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const n=[];this.f.fire({scheme:r,join(s){n.push(s)}}),!this.h.has(r)&&await N.Promises.settled(n)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,n){const s=this.h.get(r.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return C.Iterable.map(this.h,([r,n])=>({scheme:r,capabilities:n.capabilities}))}async j(r){if(!(0,h.$bh)(r))throw new g.$ll((0,p.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const n=this.h.get(r.scheme);if(!n){const s=new m.$bb;throw s.message=(0,p.localize)(1,null,r.toString()),s}return n}async m(r){const n=await this.j(r);if((0,g.$9k)(n)||(0,g.$6k)(n)||(0,g.$0k)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const n=await this.j(r);if((0,g.$9k)(n)||(0,g.$6k)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,n){try{return await this.s(r,n)}catch(s){throw(0,g.$gl)(s)===g.FileSystemProviderErrorCode.FileNotFound?new g.$ll((0,p.localize)(2,null,this.sb(r)),1):(0,g.$el)(s)}}async s(r,n){const s=await this.j(r),i=this.S(s),o=n?.resolveTo,a=n?.resolveSingleChildDescendants,b=n?.resolveMetadata,k=await s.stat(r);let v;return this.t(s,r,k,void 0,!!b,(S,P)=>(v||(v=E.$Ci.forUris(()=>!i),v.set(r,!0),o&&v.fill(!0,o)),v.get(S.resource)||v.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&a?P===1:!1))}async t(r,n,s,i,o,a){const{providerExtUri:b}=this.R(r),k={resource:n,name:b.basename(n),isFile:(s.type&g.FileType.File)!==0,isDirectory:(s.type&g.FileType.Directory)!==0,isSymbolicLink:(s.type&g.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&g.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((s.permissions??0)&g.FilePermission.Locked),etag:(0,g.$wl)({mtime:s.mtime,size:s.size}),children:void 0};if(k.isDirectory&&a(k,i)){try{const v=await r.readdir(n),S=await N.Promises.settled(v.map(async([P,R])=>{try{const M=b.joinPath(n,P),F=o?await r.stat(M):{type:R};return await this.t(r,M,F,v.length,o,a)}catch(M){return this.b.trace(M),null}}));k.children=(0,D.$Hb)(S)}catch(v){this.b.trace(v),k.children=[]}return k}return k}async resolveAll(r){return N.Promises.settled(r.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(r){const n=await this.j(r),s=await n.stat(r);return this.t(n,r,s,void 0,!0,()=>!1)}async exists(r){const n=await this.j(r);try{return!!await n.stat(r)}catch{return!1}}async canCreateFile(r,n){try{await this.u(r,n)}catch(s){return s}return!0}async u(r,n){if(!n?.overwrite&&await this.exists(r))throw new g.$ll((0,p.localize)(3,null,this.sb(r)),3,n)}async createFile(r,n=j.$Ge.fromString(""),s){await this.u(r,s);const i=await this.writeFile(r,n);return this.r.fire(new g.$il(r,0,i)),i}async writeFile(r,n,s){const i=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(i);let a=s;if((0,g.$_k)(i)&&!a?.atomic){const b=i.enforceAtomicWriteFile?.(r);b&&(a={...s,atomic:b})}try{await this.w(i,r,a)||await this.U(i,o.dirname(r));let k;if((0,g.$6k)(i)&&!(n instanceof j.$Ge))if((0,c.$se)(n)){const v=await(0,c.$ze)(n,3);v.ended?k=j.$Ge.concat(v.buffer):k=v}else k=(0,c.$we)(n,v=>j.$Ge.concat(v),3);else k=n;!(0,g.$9k)(i)||(0,g.$6k)(i)&&k instanceof j.$Ge||(0,g.$6k)(i)&&(0,g.$_k)(i)&&a?.atomic?await this.hb(i,r,a,k):await this.db(i,r,a,k instanceof j.$Ge?(0,j.$Re)(k):k),this.r.fire(new g.$il(r,4))}catch(b){throw new g.$ll((0,p.localize)(4,null,this.sb(r),(0,g.$el)(b).toString()),(0,g.$hl)(b),a)}return this.resolve(r,{resolveMetadata:!0})}async w(r,n,s){const i=!!s?.unlock;if(i&&!(r.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(r.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(r.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(i)throw new Error((0,p.localize)(8,null,this.sb(n)))}let a;try{a=await r.stat(n)}catch{return}if(a.type&g.FileType.Directory)throw new g.$ll((0,p.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==g.$vl&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,g.$wl)({mtime:s.mtime,size:a.size}))throw new g.$ll((0,p.localize)(10,null),3,s);return a}async readFile(r,n,s){const i=await this.m(r);return n?.atomic?this.z(i,r,n,s):this.C(i,r,n,s)}async z(r,n,s,i){return new Promise((o,a)=>{this.cb.queueFor(n,async()=>{try{const b=await this.C(r,n,s,i);o(b)}catch(b){a(b)}},this.R(r).providerExtUri)})}async C(r,n,s,i){const o=await this.D(r,n,{...s,preferUnbuffered:!0},i);return{...o,value:await(0,j.$Se)(o.value)}}async readFileStream(r,n,s){const i=await this.m(r);return this.D(i,r,n,s)}async D(r,n,s,i){const o=new A.$pe(i);let a=s;(0,g.$$k)(r)&&r.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const b=this.J(n,a).then(v=>v,v=>{throw o.dispose(!0),v});let k;try{return typeof a?.etag=="string"&&a.etag!==g.$vl&&await b,a?.atomic&&(0,g.$$k)(r)||!((0,g.$9k)(r)||(0,g.$0k)(r))||(0,g.$6k)(r)&&a?.preferUnbuffered?k=this.I(r,n,a):(0,g.$0k)(r)?k=this.G(r,n,o.token,a):k=this.H(r,n,o.token,a),k.on("end",()=>o.dispose()),k.on("error",()=>o.dispose()),{...await b,value:k}}catch(v){throw k&&await(0,c.$xe)(k),this.F(v,n,a)}}F(r,n,s){const i=(0,p.localize)(11,null,this.sb(n),(0,g.$el)(r).toString());return r instanceof g.$nl?new g.$nl(i,r.stat,s):r instanceof g.$ml?new g.$ml(i,r.fileOperationResult,r.size,r.options):new g.$ll(i,(0,g.$hl)(r),s)}G(r,n,s,i=Object.create(null)){const o=r.readFileStream(n,i,s);return(0,c.$De)(o,{data:a=>a instanceof j.$Ge?a:j.$Ge.wrap(a),error:a=>this.F(a,n,i)},a=>j.$Ge.concat(a))}H(r,n,s,i=Object.create(null)){const o=(0,j.$We)();return(0,l.$Hq)(r,n,o,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.F(a,n,i)},s),o}I(r,n,s){const i=(0,c.$ue)(o=>j.$Ge.concat(o));return(async()=>{try{let o;s?.atomic&&(0,g.$$k)(r)?o=await r.readFile(n,{atomic:!0}):o=await r.readFile(n),typeof s?.position=="number"&&(o=o.slice(s.position)),typeof s?.length=="number"&&(o=o.slice(0,s.length)),this.L(n,o.byteLength,s),i.end(j.$Ge.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async J(r,n){const s=await this.resolve(r,{resolveMetadata:!0});if(s.isDirectory)throw new g.$ll((0,p.localize)(12,null,this.sb(r)),0,n);if(typeof n?.etag=="string"&&n.etag!==g.$vl&&n.etag===s.etag)throw new g.$nl((0,p.localize)(13,null),s,n);return this.L(r,s.size,n),s}L(r,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new g.$ml((0,p.localize)(14,null,this.sb(r)),7,n,s)}async canMove(r,n,s){return this.M(r,n,"move",s)}async canCopy(r,n,s){return this.M(r,n,"copy",s)}async M(r,n,s,i){if(r.toString()!==n.toString())try{const o=s==="move"?this.qb(await this.n(r),r):await this.m(r),a=this.qb(await this.n(n),n);await this.Q(o,r,a,n,s,i)}catch(o){return o}return!0}async move(r,n,s){const i=this.qb(await this.n(r),r),o=this.qb(await this.n(n),n),a=await this.N(i,r,o,n,"move",!!s),b=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$il(r,a==="move"?2:3,b)),b}async copy(r,n,s){const i=await this.m(r),o=this.qb(await this.n(n),n),a=await this.N(i,r,o,n,"copy",!!s),b=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new g.$il(r,a==="copy"?3:2,b)),b}async N(r,n,s,i,o,a){if(n.toString()===i.toString())return o;const{exists:b,isSameResourceWithDifferentPathCase:k}=await this.Q(r,n,s,i,o,a);if(b&&!k&&a&&await this.del(i,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(i)),o==="copy"){if(r===s&&(0,g.$7k)(r))await r.copy(n,i,{overwrite:a});else{const v=await this.resolve(n);v.isDirectory?await this.P(r,v,s,i):await this.O(r,n,s,i)}return o}else return r===s?(await r.rename(n,i,{overwrite:a}),o):(await this.N(r,n,s,i,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(r,n,s,i){if((0,g.$9k)(r)&&(0,g.$9k)(s))return this.jb(r,n,s,i);if((0,g.$9k)(r)&&(0,g.$6k)(s))return this.pb(r,n,s,i);if((0,g.$6k)(r)&&(0,g.$9k)(s))return this.nb(r,n,s,i);if((0,g.$6k)(r)&&(0,g.$6k)(s))return this.lb(r,n,s,i)}async P(r,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async o=>{const a=this.R(s).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),s,a):this.O(r,o.resource,s,a)}))}async Q(r,n,s,i,o,a){let b=!1;if(r===s){const{providerExtUri:v,isPathCaseSensitive:S}=this.R(r);if(S||(b=v.isEqual(n,i)),b&&o==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(i)));if(!b&&v.isEqualOrParent(i,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(i)))}const k=await this.exists(i);if(k&&!b){if(!a)throw new g.$ll((0,p.localize)(17,null,this.sb(n),this.sb(i)),4);if(r===s){const{providerExtUri:v}=this.R(r);if(v.isEqualOrParent(n,i))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(i)))}}return{exists:k,isSameResourceWithDifferentPathCase:b}}R(r){const n=this.S(r);return{providerExtUri:n?h.$Zg:h.$2g,isPathCaseSensitive:n}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const n=this.qb(await this.j(r),r);await this.U(n,r);const s=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new g.$il(r,0,s)),s}async U(r,n){const s=[],{providerExtUri:i}=this.R(r);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await r.stat(n)).type&g.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(o){if((0,g.$gl)(o)!==g.FileSystemProviderErrorCode.FileNotFound)throw o;s.push(i.basename(n)),n=i.dirname(n)}for(let o=s.length-1;o>=0;o--){n=i.joinPath(n,s[o]);try{await r.mkdir(n)}catch(a){if((0,g.$gl)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(r,n){try{await this.W(r,n)}catch(s){return s}return!0}async W(r,n){const s=this.qb(await this.j(r),r),i=!!n?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(r)));const o=n?.atomic;if(o&&!(s.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(r)));if(i&&o)throw new Error((0,p.localize)(22,null,this.sb(r)));let a;try{a=await s.stat(r)}catch{}if(a)this.rb(r,a);else throw new g.$ll((0,p.localize)(23,null,this.sb(r)),1);if(!!!n?.recursive){const k=await this.resolve(r);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(r)))}return s}async del(r,n){const s=await this.W(r,n);let i=n;if((0,g.$al)(s)&&!i?.atomic){const k=s.enforceAtomicDelete?.(r);k&&(i={...n,atomic:k})}const o=!!i?.useTrash,a=!!i?.recursive,b=i?.atomic??!1;await s.delete(r,{recursive:a,useTrash:o,atomic:b}),this.r.fire(new g.$il(r,1))}async cloneFile(r,n){const s=await this.j(r),i=this.qb(await this.n(n),n);if(!(s===i&&this.R(s).providerExtUri.isEqual(r,n)))return s===i&&(0,g.$8k)(s)?s.cloneFile(r,n):(await this.U(i,this.R(i).providerExtUri.dirname(n)),s===i&&(0,g.$7k)(s)?this.cb.queueFor(r,()=>s.copy(r,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(r,()=>this.O(s,r,i,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(r,n){return this.watch(r,{...n,correlationId:d.ab++})}watch(r,n={recursive:!1,excludes:[]}){const s=new f.$Uc;let i=!1,o=()=>{i=!0};s.add((0,f.$Tc)(()=>o())),(async()=>{try{const b=await this.bb(r,n);i?(0,f.$Qc)(b):o=()=>(0,f.$Qc)(b)}catch(b){this.b.error(b)}})();const a=n.correlationId;if(typeof a=="number"){const b=s.add(new O.$ee);return s.add(this.X.event(v=>{v.correlates(a)&&b.fire(v)})),{onDidChange:b.event,dispose:()=>s.dispose()}}return s}async bb(r,n){const s=await this.j(r),i=(0,I.$kj)([this.R(s).providerExtUri.getComparisonKey(r),n]);let o=this.$.get(i);return o||(o={count:0,disposable:s.watch(r,n)},this.$.set(i,o)),o.count+=1,(0,f.$Tc)(()=>{o&&(o.count--,o.count===0&&((0,f.$Qc)(o.disposable),this.$.delete(i)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,f.$Qc)(r.disposable);this.$.clear()}async db(r,n,s,i){return this.cb.queueFor(n,async()=>{const o=await r.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,c.$se)(i)||(0,c.$te)(i)?await this.eb(r,o,i):await this.fb(r,o,i)}catch(a){throw(0,g.$el)(a)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,n,s){let i=0,o;if((0,c.$te)(s)){if(s.buffer.length>0){const a=j.$Ge.concat(s.buffer);await this.gb(r,n,a,a.byteLength,i,0),i+=a.byteLength}if(s.ended)return;o=s.stream}else o=s;return new Promise((a,b)=>{(0,c.$ye)(o,{onData:async k=>{o.pause();try{await this.gb(r,n,k,k.byteLength,i,0)}catch(v){return b(v)}i+=k.byteLength,setTimeout(()=>o.resume())},onError:k=>b(k),onEnd:()=>a()})})}async fb(r,n,s){let i=0,o;for(;(o=s.read())!==null;)await this.gb(r,n,o,o.byteLength,i,0),i+=o.byteLength}async gb(r,n,s,i,o,a){let b=0;for(;b<i;){const k=await r.write(n,o+b,s.buffer,a+b,i-b);b+=k}}async hb(r,n,s,i){return this.cb.queueFor(n,()=>this.ib(r,n,s,i),this.R(r).providerExtUri)}async ib(r,n,s,i){let o;i instanceof j.$Ge?o=i:(0,c.$se)(i)?o=await(0,j.$Se)(i):(0,c.$te)(i)?o=await(0,j.$Te)(i):o=(0,j.$Qe)(i),await r.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(r,n,s,i){return this.cb.queueFor(i,()=>this.kb(r,n,s,i),this.R(s).providerExtUri)}async kb(r,n,s,i){let o,a;try{o=await r.open(n,{create:!1}),a=await s.open(i,{create:!0,unlock:!1});const b=j.$Ge.alloc(this.a);let k=0,v=0,S=0;do S=await r.read(o,k,b.buffer,v,b.byteLength-v),await this.gb(s,a,b,S,k,v),k+=S,v+=S,v===b.byteLength&&(v=0);while(S>0)}catch(b){throw(0,g.$el)(b)}finally{await N.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(r,n,s,i){return this.cb.queueFor(i,()=>this.mb(r,n,s,i),this.R(s).providerExtUri)}async mb(r,n,s,i){return s.writeFile(i,await r.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,n,s,i){return this.cb.queueFor(i,()=>this.ob(r,n,s,i),this.R(s).providerExtUri)}async ob(r,n,s,i){const o=await s.open(i,{create:!0,unlock:!1});try{const a=await r.readFile(n);await this.gb(s,o,j.$Ge.wrap(a),a.byteLength,0,0)}catch(a){throw(0,g.$el)(a)}finally{await s.close(o)}}async pb(r,n,s,i){const o=await(0,j.$Se)(this.H(r,n,A.CancellationToken.None));await this.hb(s,i,void 0,o)}qb(r,n){if(r.capabilities&2048)throw new g.$ll((0,p.localize)(25,null,this.sb(n)),6);return r}rb(r,n){if((n.permissions??0)&g.FilePermission.Readonly)throw new g.$ll((0,p.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===y.Schemas.file?r.fsPath:r.toString(!0)}};e.$Iq=$,e.$Iq=$=d=Ee([Q(0,u.$3j)],$)}),define(ae[207],ce([0,1,41,277,6,34,15,3,40,2,14,5,20,50,31,166,12,97,205,38,201,200]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.$hj)(r)}`)}})();class t extends u.$Uq{static{this.L=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=I.Event.None,this.P=new A.$Bc(i=>w.$1g.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,y.$k&&(this.M|=1024)),this.M}async stat(n){try{const{stat:s,symbolicLink:i}=await c.SymlinkSupport.stat(this.I(n));return{type:this.O(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:g.FilePermission.Locked}}catch(s){throw this.hb(s)}}async N(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await c.Promises.readdir(this.I(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,w.$0g)(n,o.name))).type:a=this.O(o),i.push([o.name,a])}catch(a){this.a.trace(a)}})),i}catch(s){throw this.hb(s)}}O(n,s){let i;return s?.dangling?i=g.FileType.Unknown:n.isFile()?i=g.FileType.File:n.isDirectory()?i=g.FileType.Directory:i=g.FileType.Unknown,s&&(i|=g.FileType.SymbolicLink),i}async Q(n){const s=this.I(n);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.P.get(n);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const o=new j.$vh;return this.P.set(n,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,f.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.P.get(n)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.P.delete(n)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),o.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(n)})`),i=await this.Q(n));const o=this.I(n);return await c.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{i?.dispose()}}R(n){t.L&&this.a.trace(n)}readFileStream(n,s,i){const o=(0,h.$ue)(a=>O.$Ge.concat(a.map(b=>O.$Ge.wrap(b))).buffer);return(0,l.$Hq)(this,n,o,a=>a.buffer,{...s,bufferSize:256*1024},i),o}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(n)?this.U(n,(0,w.$0g)((0,w.$9g)(n),`${(0,w.$7g)(n)}${i.atomic.postfix}`),s,i):this.W(n,s,i)}async S(n){try{const s=this.I(n),{symbolicLink:i}=await c.SymlinkSupport.stat(s);if(i)return!1}catch{}return!0}async U(n,s,i,o){const a=new f.$Uc;try{a.add(await this.Q(n)),a.add(await this.Q(s)),await this.W(s,i,o,!0);try{await this.rename(s,n,{overwrite:!0})}catch(b){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw b}}finally{a.dispose()}}async W(n,s,i,o){let a;try{const b=this.I(n);if(!i.create||!i.overwrite){if(await c.Promises.exists(b)){if(!i.overwrite)throw(0,g.$dl)((0,p.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,g.$dl)((0,p.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:i.unlock},o),await this.write(a,0,s,0,s.byteLength)}catch(b){throw await this.ib(n,b)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(n){t.$=n}async open(n,s,i){const o=this.I(n);let a;(0,g.$4k)(s)&&!i&&(a=await this.Q(n));let b;try{if((0,g.$4k)(s)&&s.unlock)try{const{stat:v}=await c.SymlinkSupport.stat(o);v.mode&128||await c.Promises.chmod(o,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let k;if((0,g.$4k)(s)){if(y.$i)try{await c.Promises.truncate(o,0),k="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}k||(k="w")}else k="r";b=await c.Promises.open(o,k)}catch(k){throw a?.dispose(),(0,g.$4k)(s)?await this.ib(n,k):this.hb(k)}if(this.X.set(b,0),(0,g.$4k)(s)&&this.Z.set(b,n),a){const k=this.Y.get(b);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${b} (${o})`),this.Y.set(b,a),k&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${b} (${o})`),k.dispose())}return b}async close(n){const s=this.Y.get(n);try{if(this.X.delete(n),this.Z.delete(n)&&t.$)try{await c.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await c.Promises.close(n)}catch(i){throw this.hb(i)}finally{s&&(this.Y.get(n)===s&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.Y.delete(n)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,o,a){const b=this.ab(n,s);let k=null;try{k=(await c.Promises.read(n,i,o,a,b)).bytesRead}catch(v){throw this.hb(v)}finally{this.bb(n,b,k)}return k}ab(n,s){return s===this.X.get(n)?null:s}bb(n,s,i){const o=this.X.get(n);typeof o=="number"&&(typeof s=="number"||(typeof i=="number"?this.X.set(n,o+i):this.X.delete(n)))}async write(n,s,i,o,a){return(0,j.$Qh)(()=>this.cb(n,s,i,o,a),100,3)}async cb(n,s,i,o,a){const b=this.ab(n,s);let k=null;try{k=(await c.Promises.write(n,i,o,a,b)).bytesWritten}catch(v){throw await this.ib(this.Z.get(n),v)}finally{this.bb(n,b,k)}return k}async mkdir(n){try{await c.Promises.mkdir(this.I(n))}catch(s){throw this.hb(s)}}async delete(n,s){try{const i=this.I(n);if(s.recursive){let o;s?.atomic!==!1&&s.atomic.postfix&&(o=(0,E.$kc)((0,E.$nc)(i),`${(0,E.$oc)(i)}${s.atomic.postfix}`)),await c.Promises.rm(i,c.RimRafMode.MOVE,o)}else try{await c.Promises.unlink(i)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let a=!1;try{const{stat:b,symbolicLink:k}=await c.SymlinkSupport.stat(i);a=b.isDirectory()&&!k}catch{}if(a)await c.Promises.rmdir(i);else throw o}else throw o}}catch(i){throw this.hb(i)}}async rename(n,s,i){const o=this.I(n),a=this.I(s);if(o!==a)try{await this.db(n,s,"move",i.overwrite),await c.Promises.rename(o,a)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,p.localize)(2,null,(0,E.$oc)(o),(0,E.$oc)((0,E.$nc)(a)),b.toString()))),this.hb(b)}}async copy(n,s,i){const o=this.I(n),a=this.I(s);if(o!==a)try{await this.db(n,s,"copy",i.overwrite),await c.Promises.copy(o,a,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,p.localize)(3,null,(0,E.$oc)(o),(0,E.$oc)((0,E.$nc)(a)),b.toString()))),this.hb(b)}}async db(n,s,i,o){const a=this.I(n),b=this.I(s);let k=!1;if(!!(this.capabilities&1024)||(k=(0,C.$ug)(a,b,!0)),k){if(i==="copy")throw(0,g.$dl)((0,p.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const S=await this.N(n);if(!S)throw(0,g.$dl)((0,p.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const P=await this.N(s);if(P){if(!o)throw(0,g.$dl)((0,p.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);S.type&g.FileType.File&&P.type&g.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.eb(n,s,!1)}async eb(n,s,i){const o=this.I(n),a=this.I(s),b=!!(this.capabilities&1024);if((0,C.$ug)(o,a,!b))return;const k=new f.$Uc;try{k.add(await this.Q(n)),k.add(await this.Q(s)),i&&await c.Promises.mkdir((0,E.$nc)(a),{recursive:!0}),await c.Promises.copyFile(o,a)}catch(v){if(v.code==="ENOENT"&&!i)return this.eb(n,s,!0);throw this.hb(v)}finally{k.dispose()}}t(n,s,i){return new d.$2q(o=>n(o),o=>s(o),i)}F(n,s,i){return new $.$$q(o=>n(o),o=>s(o),i)}hb(n){if(n instanceof g.$cl)return n;let s=n,i;switch(n.code){case"ENOENT":i=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=g.FileSystemProviderErrorCode.Unknown;break;default:i=g.FileSystemProviderErrorCode.Unknown}return(0,g.$dl)(s,i)}async ib(n,s){let i=this.hb(s);if(n&&i.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await c.SymlinkSupport.stat(this.I(n));o.mode&128||(i=(0,g.$dl)(s,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return i}}e.$_q=t}),define(ae[99],ce([0,1,3,2,4,9]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=e.$Aec=void 0,e.$Aec=(0,j.$wi)("sharedProcessLifecycleService");let O=class extends N.$Vc{constructor(C){super(),this.b=C,this.a=this.B(new D.$ee),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Bec=O,e.$Bec=O=Ee([Q(0,A.$3j)],O)}),define(ae[208],ce([0,1,8,3,9,2]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=void 0;class O extends j.$bk{constructor(y,w,h,c,p){super(w,h,c),this.r=y,this.t=p,this.B(p.listen("onDidChangeLogLevel",y)(g=>{(0,j.$5j)(g)?super.setLogLevel(g):super.setLogLevel(D.URI.revive(g[0]),g[1])})),this.B(p.listen("onDidChangeVisibility",y)(([g,l])=>super.setVisibility(D.URI.revive(g),l))),this.B(p.listen("onDidChangeLoggers",y)(({added:g,removed:l})=>{for(const u of g)super.registerLogger({...u,resource:D.URI.revive(u.resource)});for(const u of l)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new j.$_j({log:(y,w)=>{this.t.call("consoleLog",[y,w])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,w){super.setLogLevel(y,w),this.t.call("setLogLevel",[y,w])}setVisibility(y,w){super.setVisibility(y,w),this.t.call("setVisibility",[this.n(y),w])}s(y,w,h){return new I(this.t,y,w,h,this.r)}static setLogLevel(y,w,h){return y.call("setLogLevel",[w,h])}}e.$_r=O;class I extends j.$9j{constructor(y,w,h,c,p){super(c?.logLevel==="always"),this.r=y,this.s=w,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[w,c,p]).then(()=>{this.u(this.n),this.m=!0})}g(y,w){const h=[[y,w]];this.m?this.u(h):this.n.push(...h)}u(y){this.r.call("log",[this.s,y])}}class C{constructor(y,w){this.a=y,this.b=w}listen(y,w){const h=this.b(y);switch(w){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(p=>this.c(p,h)),removed:[...c.removed].map(p=>this.c(p,h))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,c=>[h.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,c=>(0,j.$5j)(c)?c:[h.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${w}`)}async call(y,w,h){const c=this.b(y);switch(w){case"setLogLevel":return(0,j.$5j)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(D.URI.revive(c.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,c)))}throw new Error(`Call not found: ${w}`)}c(y,w){return{...y,resource:w.transformOutgoingURI(y.resource)}}}e.$as=C;class f extends A.$Vc{constructor(y,w){super(),w.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(h=>w.call("setLogLevel",[h]))),w.call("getRegisteredLoggers").then(h=>{for(const c of h)y.registerLogger({...c,resource:D.URI.revive(c.resource)})}),this.B(w.listen("onDidChangeVisibility")(([h,c])=>y.setVisibility(D.URI.revive(h),c))),this.B(w.listen("onDidChangeLoggers")(({added:h,removed:c})=>{for(const p of h)y.registerLogger({...p,resource:D.URI.revive(p.resource)});for(const p of c)y.deregisterLogger(p.resource)}))}}e.$bs=f}),define(ae[209],ce([0,1,2,9]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=void 0;class j extends D.$Vc{constructor(O,I=[]){super(),this.a=new N.$ak([O,...I]),this.B(O.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$OQ=j}),define(ae[57],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0,e.$wcc=(0,D.$wi)("nativeHostService")}),define(ae[210],ce([0,1,42,56]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;let j=class{constructor(O,I){return this.windowId=O,D.ProxyChannel.toService(I.getChannel("nativeHost"),{context:O,properties:(()=>{const C=new Map;return C.set("windowId",O),C})()})}};e.$Rdc=j,e.$Rdc=j=Ee([Q(1,N.$Ldc)],j)}),define(ae[58],ce([0,1,3,61,2,4]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=void 0,e.$eo=(0,A.$wi)("policy");class O extends j.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$ee),this.onDidChange=this.h.event}async updatePolicyDefinitions(f){const E=Object.keys(this.f).length;return this.f={...f,...this.f},E!==Object.keys(this.f).length&&await this.j(f),N.Iterable.reduce(this.g.entries(),(y,[w,h])=>({...y,[w]:h}),{})}getPolicyValue(f){return this.g.get(f)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(f,[E,y])=>({...f,[E]:{definition:y,value:this.g.get(E)}}),{})}}e.$fo=O;class I{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$go=I}),define(ae[211],ce([0,1,3,2,58]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=e.$hdc=void 0;class A{constructor(C){this.b=C,this.a=new N.$Uc}listen(C,f){switch(f){case"onDidChange":return D.Event.map(this.b.onDidChange,E=>E.reduce((y,w)=>({...y,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${f}`)}call(C,f,E){switch(f){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(E)}throw new Error(`Call not found: ${f}`)}dispose(){this.a.dispose()}}e.$hdc=A;class O extends j.$fo{constructor(C,f){super(),this.a=f;for(const E in C){const{definition:y,value:w}=C[E];this.f[E]=y,w!==void 0&&this.g.set(E,w)}this.a.listen("onDidChange")(E=>{for(const y in E){const w=E[y];w===null?this.g.delete(y):this.g.set(y,w)}this.h.fire(Object.keys(E))})}async j(C){const f=await this.a.call("updatePolicyDefinitions",C);for(const E in f)this.g.set(E,f[E])}}e.$idc=O}),define(ae[100],ce([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.context<"u"){const A=j.context.configuration();if(A)N=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:A.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ae[24],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,D.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"}),define(ae[212],ce([0,1,6,7,2,14,31,9,24]),function(ne,e,D,N,j,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;let f=class extends j.$Vc{constructor(y,w,h){super(),this.b=w,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this.B(new D.$Ih(()=>{this.f(y)},3e4)).schedule()}async f(y){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),h=(0,A.$nc)(y),c=(0,A.$oc)(y),p=await O.Promises.readdir(h);await Promise.all(p.map(async g=>{if(g===c)return;const l=(0,A.$kc)(h,g),u=await O.Promises.stat(l);if(u.isDirectory()&&w-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${g}.`),O.Promises.rm(l)}))}catch(w){(0,N.$1)(w)}}};e.$$dc=f,e.$$dc=f=Ee([Q(1,C.$jk),Q(2,I.$3j)],f)}),define(ae[213],ce([0,1,6,7,2,14,31,16,9,24]),function(ne,e,D,N,j,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;let E=class extends j.$Vc{constructor(w,h,c){super(),this.b=w,this.c=h,this.f=c,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$Ih(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),h=JSON.parse(await O.Promises.readFile((0,A.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(h)){const m=h[u];w[`${m.hash}.${u}`]=!0}const c=(0,A.$kc)(this.b.userDataPath,"clp");if(!await O.Promises.exists(c))return;const g=await O.Promises.readdir(c);for(const u of g){if(w[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await O.Promises.rm((0,A.$kc)(c,u))}const l=Date.now();for(const u of Object.keys(w)){const m=(0,A.$kc)(c,u),d=await O.Promises.readdir(m);for(const $ of d){if($==="tcf.json")continue;const t=(0,A.$kc)(m,$),r=await O.Promises.stat(t);r.isDirectory()&&l-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$kc)(u,$)}`),await O.Promises.rm(t))}}}catch(w){(0,N.$1)(w)}}};e.$_dc=E,e.$_dc=E=Ee([Q(0,I.$Ei),Q(1,C.$3j),Q(2,f.$jk)],E)}),define(ae[214],ce([0,1,14,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$oG=void 0,e.$oG=(0,N.$wi)("IV8InspectProfilingService");var j;(function(A){function O(C){return!!(C.samples&&C.timeDeltas)}A.isValidProfile=O;function I(C,f="noAbsolutePaths"){for(const E of C.nodes)E.callFrame&&E.callFrame.url&&((0,D.$jc)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,D.$kc)(f,(0,D.$oc)(E.callFrame.url)));return C}A.rewriteAbsolutePaths=I})(j||(e.Utils=j={}))}),define(ae[215],ce([0,1,32]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;class N{constructor(){this.a=new Map}async startProfiling(A){const I=await(await new Promise((f,E)=>{ne(["v8-inspect-profiler"],f,E)})).startProfiling({host:A.host,port:A.port,checkForPaused:!0}),C=(0,D.$Sg)();return this.a.set(C,I),C}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const I=await O.stop();return this.a.delete(A),I.profile}}e.$qec=N}),define(ae[43],ce([0,1,127,13]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class j{constructor(){this.a=new Map}add(O,I){D.ok(N.$9f(O)),D.ok(N.$$f(I)),D.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$co=new j}),define(ae[101],ce([0,1,3,43]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function j(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this.b=new D.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,f){this.a[j(C)]=f,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;N.$co.add(e.$do.JSONContribution,O)}),define(ae[47],ce([0,1,17,3,13,153,21,101,43]),function(ne,e,D,N,j,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=p,e.$to=g,e.$uo=l,e.$vo=m,e.$wo=d;var f;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$ho={Configuration:"base.contributions.configuration"};var E;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const y=C.$co.as(I.$do.JSONContribution);class w{constructor(){this.h=new Set,this.i=new N.$ee,this.onDidSchemaChange=this.i.event,this.j=new N.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const n=new Set;this.n(t,r,n),y.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const r=new Set;this.o(t,r),y.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const n=new Set;this.o(r,n),this.n(t,!1,n),y.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const n=[];for(const{overrides:s,source:i}of t)for(const o in s)if(r.add(o),e.$ro.test(o)){const a=this.a.get(o),b=a?.valuesSources??new Map;if(i)for(const P of Object.keys(s[o]))b.set(P,i);const k={...a?.value||{},...s[o]};this.a.set(o,{source:i,value:k,valuesSources:b});const v=(0,O.$aj)(o),S={type:"object",default:k,description:A.localize(1,null,v),$ref:e.$oo,defaultDefaultValue:k,source:j.$9f(i)?void 0:i,defaultValueSource:i};n.push(...p(o)),this.d[o]=S,this.b.properties[o]=S}else{this.a.set(o,{value:s[o],source:i});const a=this.d[o];a&&(this.w(o,a),this.r(o,a))}this.m(n)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:n,source:s}of t)for(const i in n){const o=this.a.get(i),a=j.$9f(s)?s:s?.id,b=j.$9f(o?.source)?o?.source:o?.source?.id;if(a===b)if(r.add(i),this.a.delete(i),e.$ro.test(i))delete this.d[i],delete this.b.properties[i];else{const k=this.d[i];k&&(this.w(i,k),this.r(i,k))}}this.u()}deltaConfiguration(t){let r=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,n){t.forEach(s=>{this.p(s,r,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(t,r){const n=s=>{if(s.properties)for(const i in s.properties){r.add(i);const o=this.d[i];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[i],this.s(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.c.indexOf(s);i!==-1&&this.c.splice(i,1)}}p(t,r=!0,n,s,i=3,o){i=j.$fg(t.scope)?i:t.scope;const a=t.properties;if(a)for(const k in a){const v=a[k];if(r&&m(k,v)){delete a[k];continue}if(v.source=n,v.defaultDefaultValue=a[k].default,this.w(k,v),e.$ro.test(k)?v.scope=void 0:(v.scope=j.$fg(v.scope)?i:v.scope,v.restricted=j.$fg(v.restricted)?!!s?.includes(k):v.restricted),a[k].hasOwnProperty("included")&&!a[k].included){this.f[k]=a[k],delete a[k];continue}else this.d[k]=a[k],a[k].policy?.name&&this.e.set(a[k].policy.name,k);!a[k].deprecationMessage&&a[k].markdownDeprecationMessage&&(a[k].deprecationMessage=a[k].markdownDeprecationMessage),o.add(k)}const b=t.allOf;if(b)for(const k of b)this.p(k,r,n,s,i,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=n=>{const s=n.properties;if(s)for(const o in s)this.r(o,s[o]);n.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$io.properties[t]=r,r.scope){case 1:e.$jo.properties[t]=r;break;case 2:e.$ko.properties[t]=r;break;case 6:e.$lo.properties[t]=r;break;case 3:e.$mo.properties[t]=r;break;case 4:e.$no.properties[t]=r;break;case 5:e.$no.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$io.properties[t],r.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$oo};this.w(r,n),e.$io.properties[r]=n,e.$jo.properties[r]=n,e.$ko.properties[r]=n,e.$lo.properties[r]=n,e.$mo.properties[r]=n,e.$no.properties[r]=n}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,r){const n=this.a.get(t);let s=n?.value,i=n?.source;j.$dg(s)&&(s=r.defaultDefaultValue,i=void 0),j.$dg(s)&&(s=l(r.type)),r.default=s,r.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",c=new RegExp(h,"g");e.$qo=`^(${h})+$`,e.$ro=new RegExp(e.$qo);function p($){const t=[];if(e.$ro.test($)){let r=c.exec($);for(;r?.length;){const n=r[1].trim();n&&t.push(n),r=c.exec($)}}return(0,D.$Mb)(t)}function g($){return $.reduce((t,r)=>`${t}[${r}]`,"")}function l($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new w;C.$co.add(e.$ho.Configuration,u);function m($,t){return $.trim()?e.$ro.test($)?A.localize(7,null,$):u.getConfigurationProperties()[$]!==void 0?A.localize(8,null,$):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,$,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function d(){const $=[],t=u.getConfigurationProperties();for(const r of Object.keys(t))$.push([r,t[r].scope]);return $.push(["launch",4]),$.push(["task",4]),$}}),define(ae[76],ce([0,1,17,3,35,2,34,30,13,8,21,47,43]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=m;function h(r){return Object.isFrozen(r)?r:I.$4n(r)}class c{static createEmptyModel(n){return new c({},[],[],void 0,n)}constructor(n,s,i,o,a){this.b=n,this.c=s,this.d=i,this.raw=o,this.f=a,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof c)return s;const i=new p("",this.f);return i.parseRaw(s),i.configurationModel});this.g=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,E.$$i)(this.contents,n):this.contents}inspect(n,s){const i=this;return{get value(){return h(i.rawConfiguration.getValue(n))},get override(){return s?h(i.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return h(s?i.rawConfiguration.override(s).getValue(n):i.rawConfiguration.getValue(n))},get overrides(){const o=[];for(const{contents:a,identifiers:b,keys:k}of i.rawConfiguration.overrides){const v=new c(a,k,[],void 0,i.f).getValue(n);v!==void 0&&o.push({identifiers:b,value:v})}return o.length?h(o):void 0}}}getOverrideValue(n,s){const i=this.j(s);return i?n?(0,E.$$i)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return D.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return D.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.h(n),this.a.set(n,s)),s}merge(...n){const s=I.$3n(this.contents),i=I.$3n(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const b of n)if(a.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.i(s,b.contents);for(const k of b.overrides){const[v]=i.filter(S=>D.$ub(S.identifiers,k.identifiers));v?(this.i(v.contents,k.contents),v.keys.push(...k.keys),v.keys=D.$Mb(v.keys)):i.push(I.$3n(k))}for(const k of b.keys)o.indexOf(k)===-1&&o.push(k)}return new c(s,o,i,a.every(b=>b instanceof c)?void 0:a,this.f)}h(n){const s=this.j(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const o of D.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[o];const b=s[o];b&&(typeof a=="object"&&typeof b=="object"?(a=I.$3n(a),this.i(a,b)):a=b),i[o]=a}return new c(i,this.keys,this.overrides,void 0,this.f)}i(n,s){for(const i of Object.keys(s)){if(i in n&&C.$$f(n[i])&&C.$$f(s[i])){this.i(n[i],s[i]);continue}n[i]=I.$3n(s[i])}}j(n){let s=null,i=null;const o=a=>{a&&(i?this.i(i,a):i=I.$3n(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&o(a.contents);return o(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.k(n,s,!0)}setValue(n,s){this.k(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,E.$0i)(this.contents,n),y.$ro.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>D.$ub(i.identifiers,(0,y.$so)(n))),1))}k(n,s,i){(0,E.$9i)(this.contents,n,s,o=>this.f.error(o)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),y.$ro.test(n)&&this.overrides.push({identifiers:(0,y.$so)(n),keys:Object.keys(this.contents[n]),contents:(0,E.$8i)(this.contents[n],o=>this.f.error(o))})}}e.$xo=c;class p{constructor(n,s){this.f=n,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!C.$fg(n)){const i=this.h(n);this.parseRaw(i,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:i,keys:o,overrides:a,restricted:b,hasExcludedProperties:k}=this.i(n,s);this.b=new c(i,o,a,k?[n]:void 0,this.g),this.c=b||[]}h(n){let s={},i=null,o=[];const a=[],b=[];function k(S){Array.isArray(o)?o.push(S):i!==null&&(o[i]=S)}const v={onObjectBegin:()=>{const S={};k(S),a.push(o),o=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const S=[];k(S),a.push(o),o=S,i=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:k,onError:(S,P,R)=>{b.push({error:S,offset:P,length:R})}};if(n)try{j.$Qn(n,v),s=o[0]||{}}catch(S){this.g.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return s}i(n,s){const i=w.$co.as(y.$ho.Configuration).getConfigurationProperties(),o=this.j(n,i,!0,s);n=o.raw;const a=(0,E.$8i)(n,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`)),b=Object.keys(n),k=this.l(n,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:a,keys:b,overrides:k,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(n,s,i,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const b={},k=[];for(const v in n)if(y.$ro.test(v)&&i){const S=this.j(n[v],s,!1,o);b[v]=S.raw,a=a||S.hasExcludedProperties,k.push(...S.restricted)}else{const S=s[v],P=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&k.push(v),!o.exclude?.includes(v)&&(o.include?.includes(v)||(P===void 0||o.scopes===void 0||o.scopes.includes(P))&&!(o.skipRestricted&&S?.restricted))?b[v]=n[v]:a=!0}return{raw:b,restricted:k,hasExcludedProperties:a}}l(n,s){const i=[];for(const o of Object.keys(n))if(y.$ro.test(o)){const a={};for(const b in n[o])a[b]=n[o][b];i.push({identifiers:(0,y.$so)(o),keys:Object.keys(a),contents:(0,E.$8i)(a,s)})}return i}}e.$yo=p;class g extends A.$Vc{constructor(n,s,i,o,a){super(),this.c=n,this.f=s,this.g=o,this.h=a,this.b=this.B(new N.$ee),this.onDidChange=this.b.event,this.a=new p(this.c.toString(),a),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&i.isEqual(b.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=g;class l{constructor(n,s,i,o,a,b,k,v,S,P,R,M,F){this.a=n,this.b=s,this.c=i,this.overrideIdentifiers=o,this.d=a,this.f=b,this.g=k,this.h=v,this.i=S,this.j=P,this.k=R,this.l=M,this.m=F}get value(){return h(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class u{constructor(n,s,i,o,a,b,k,v,S,P){this.j=n,this.l=s,this.m=i,this.n=o,this.p=a,this.q=b,this.r=k,this.s=v,this.t=S,this.u=P,this.h=null,this.i=new O.$Bc,this.v=null}getValue(n,s,i){return this.w(n,s,i).getValue(n)}updateValue(n,s,i={}){let o;i.resource?(o=this.t.get(i.resource),o||(o=c.createEmptyModel(this.u),this.t.set(i.resource,o))):o=this.s,s===void 0?o.removeValue(n):o.setValue(n,s),i.resource||(this.h=null)}inspect(n,s,i){const o=this.w(n,s,i),a=this.A(s.resource,i),b=s.resource?this.t.get(s.resource)||this.s:this.s,k=new Set;for(const v of o.overrides)for(const S of v.identifiers)o.getOverrideValue(n,S)!==void 0&&k.add(S);return new l(n,s,o.getValue(n),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.q:void 0,a||void 0,b)}keys(n){const s=this.A(void 0,n);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.j=n,this.h=null,this.i.clear()}updatePolicyConfiguration(n){this.l=n}updateApplicationConfiguration(n){this.m=n,this.h=null,this.i.clear()}updateLocalUserConfiguration(n){this.n=n,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(n){this.p=n,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(n){this.q=n,this.h=null,this.i.clear()}updateFolderConfiguration(n,s){this.r.set(n,s),this.i.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.i.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:o,updated:a,removed:b}=$(this.j,n);s=[...o,...a,...b]}for(const o of s)for(const a of(0,y.$so)(o)){const b=this.j.getKeysForOverrideIdentifier(a),k=n.getKeysForOverrideIdentifier(a),v=[...k.filter(S=>b.indexOf(S)===-1),...b.filter(S=>k.indexOf(S)===-1),...b.filter(S=>!I.$7n(this.j.override(a).getValue(S),n.override(a).getValue(S)))];i.push([a,v])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:o}=$(this.l,n),a=[...s,...i,...o];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.applicationConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateApplicationConfiguration(n),{keys:b,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.localUserConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateLocalUserConfiguration(n),{keys:b,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.remoteUserConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateRemoteUserConfiguration(n),{keys:b,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.workspaceConfiguration,n),b=[...s,...i,...o];return b.length&&this.updateWorkspaceConfiguration(n),{keys:b,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const i=this.folderConfigurations.get(n),{added:o,updated:a,removed:b,overrides:k}=$(i,s),v=[...o,...a,...b];return(v.length||!i)&&this.updateFolderConfiguration(n,s),{keys:v,overrides:k}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:o,removed:a,overrides:b}=$(s,void 0);return{keys:[...i,...o,...a],overrides:b}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(n,s,i){let o=this.x(s,i);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(n)!==void 0&&(o=o.merge(this.l)),o}x({resource:n},s){let i=this.y();if(s&&n){const o=s.getFolder(n);o&&(i=this.z(o.uri)||i);const a=this.t.get(n);a&&(i=i.merge(a))}return i}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(n){let s=this.i.get(n);if(!s){const i=this.y(),o=this.r.get(n);o?(s=i.merge(o),this.i.set(n,s)):s=i}return s}A(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this.r.get(i.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((n,s)=>{const{contents:i,overrides:o,keys:a}=this.r.get(s);return n.push([s,{contents:i,overrides:o,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.j.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.q.keys.forEach(s=>n.add(s)),this.r.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}B(){const n=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}D(n){const s=new Set;return this.j.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.q.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.r.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(o=>s.add(o))),[...s.values()]}static parse(n,s){const i=this.E(n.defaults,s),o=this.E(n.policy,s),a=this.E(n.application,s),b=this.E(n.user,s),k=this.E(n.workspace,s),v=n.folders.reduce((S,P)=>(S.set(f.URI.revive(P[0]),this.E(P[1],s)),S),new O.$Bc);return new u(i,o,a,b,c.createEmptyModel(s),k,v,c.createEmptyModel(s),new O.$Bc,s)}static E(n,s){return new c(n.contents,n.keys,n.overrides,void 0,s)}}e.$Ao=u;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,s=new Map;for(const o of r)o.keys.forEach(a=>n.add(a)),o.overrides.forEach(([a,b])=>{const k=(0,O.$yc)(s,a,new Set);b.forEach(v=>k.add(v))});const i=[];return s.forEach((o,a)=>i.push([a,[...o.values()]])),{keys:[...n.values()],overrides:i}}class d{constructor(n,s,i,o,a){this.change=n,this.f=s,this.g=i,this.h=o,this.i=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const b of n.keys)this.affectedKeys.add(b);for(const[,b]of n.overrides)for(const k of b)this.affectedKeys.add(k);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=u.parse(this.f.data,this.i)),this.j}affectsConfiguration(n,s){const i=this.a+n,o=this.d.indexOf(i);if(o<0)return!1;const a=o+i.length;if(a>=this.d.length)return!1;const b=this.d.charCodeAt(a);if(b!==this.b&&b!==this.c)return!1;if(s){const k=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,v=this.g.getValue(n,s,this.h);return!I.$7n(k,v)}return!0}}e.$Co=d;function $(r,n){const{added:s,removed:i,updated:o}=t(n?.rawConfiguration,r?.rawConfiguration),a=[],b=r?.getAllOverrideIdentifiers()||[],k=n?.getAllOverrideIdentifiers()||[];if(n){const v=k.filter(S=>!b.includes(S));for(const S of v)a.push([S,n.getKeysForOverrideIdentifier(S)])}if(r){const v=b.filter(S=>!k.includes(S));for(const S of v)a.push([S,r.getKeysForOverrideIdentifier(S)])}if(n&&r){for(const v of b)if(k.includes(v)){const S=t({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:n.getOverrideValue(void 0,v)||{},keys:n.getKeysForOverrideIdentifier(v)});a.push([v,[...S.added,...S.removed,...S.updated]])}}return{added:s,removed:i,updated:o,overrides:a}}function t(r,n){const s=r?n?r.keys.filter(a=>n.keys.indexOf(a)===-1):[...r.keys]:[],i=n?r?n.keys.filter(a=>r.keys.indexOf(a)===-1):[...n.keys]:[],o=[];if(r&&n){for(const a of n.keys)if(r.keys.indexOf(a)!==-1){const b=(0,E.$$i)(n.contents,a),k=(0,E.$$i)(r.contents,a);I.$7n(b,k)||o.push(a)}}return{added:s,removed:i,updated:o}}}),define(ae[216],ce([0,1,17,3,2,30,13,76,47,9,58,43]),function(ne,e,D,N,j,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=void 0;class w extends j.$Vc{get configurationModel(){return this.b}constructor(g){super(),this.c=g,this.a=this.B(new N.$ee),this.onDidChangeConfiguration=this.a.event,this.b=I.$xo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(y.$co.as(C.$ho.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:l})=>this.f(Array.from(g),l))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(g,l){this.j(g,y.$co.as(C.$ho.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}g(){return{}}h(){this.b=I.$xo.createEmptyModel(this.c);const g=y.$co.as(C.$ho.Configuration).getConfigurationProperties();this.j(Object.keys(g),g)}j(g,l){const u=this.g();for(const m of g){const d=u[m],$=l[m];d!==void 0?this.b.addValue(m,d):$?this.b.addValue(m,$.default):this.b.removeValue(m)}}}e.$Do=w;class h{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=I.$xo.createEmptyModel(new f.$dk)}async initialize(){return this.configurationModel}}e.$Eo=h;let c=class extends j.$Vc{get configurationModel(){return this.b}constructor(g,l,u){super(),this.c=g,this.f=l,this.g=u,this.a=this.B(new N.$ee),this.onDidChangeConfiguration=this.a.event,this.b=I.$xo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const l={},u=[],m=y.$co.as(C.$ho.Configuration).getConfigurationProperties();for(const d of g){const $=m[d];if(!$){u.push(d);continue}if($.policy){if($.type!=="string"&&$.type!=="number"){this.g.warn(`Policy ${$.policy.name} has unsupported type ${$.type}`);continue}u.push(d),l[$.policy.name]={type:$.type}}}return(0,O.$jg)(l)||await this.f.updatePolicyDefinitions(l),u}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const l=y.$co.as(C.$ho.Configuration).getPolicyConfigurations(),u=(0,D.$Hb)(g.map(m=>l.get(m)));this.m(u,!0)}m(g,l){this.g.trace("PolicyConfiguration#update",g);const u=y.$co.as(C.$ho.Configuration).getConfigurationProperties(),m=[],d=this.b.isEmpty();for(const $ of g){const t=u[$]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(d?r!==void 0:!(0,A.$7n)(this.b.getValue($),r))&&m.push([$,r])}else this.b.getValue($)!==void 0&&m.push([$,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const $=this.b;this.b=I.$xo.createEmptyModel(this.g);for(const t of $.keys)this.b.setValue(t,$.getValue(t));for(const[t,r]of m)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);l&&this.a.fire(this.b)}}};e.$Fo=c,e.$Fo=c=Ee([Q(1,E.$eo),Q(2,f.$3j)],c)}),define(ae[217],ce([0,1,17,6,15,3,35,62,2,34,30,5,20,21,76,47,216,58]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=void 0;class u extends C.$Vc{constructor($,t,r,n){super(),this.m=$,this.n=n,this.h=this.B(new A.$ee),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.$Do(n)),this.c=r instanceof l.$go?new g.$Eo:this.B(new g.$Fo(this.b,r,n)),this.f=this.B(new c.$zo(this.m,{},w.$1g,t,n)),this.a=new c.$Ao(this.b.configurationModel,this.c.configurationModel,c.$xo.createEmptyModel(n),c.$xo.createEmptyModel(n),c.$xo.createEmptyModel(n),c.$xo.createEmptyModel(n),new f.$Bc,c.$xo.createEmptyModel(n),new f.$Bc,n),this.j=new m($,t,this),this.g=this.B(new N.$Ih(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:i})=>this.s(s,i))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new c.$Ao($,t,c.$xo.createEmptyModel(this.n),r,c.$xo.createEmptyModel(this.n),c.$xo.createEmptyModel(this.n),new f.$Bc,c.$xo.createEmptyModel(this.n),new f.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue($,t){const r=typeof $=="string"?$:void 0,n=(0,h.$4i)($)?$:(0,h.$4i)(t)?t:{};return this.a.getValue(r,n,void 0)}async updateValue($,t,r,n,s){const i=(0,h.$5i)(r)?r:(0,h.$4i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=i?n:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${$} to target ${o}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,D.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const a=this.inspect($,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${$} because it is configured in system policy.`);if((0,E.$7n)(t,a.defaultValue)&&(t=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const k=i.overrideIdentifiers.sort(),v=this.a.localUserConfiguration.overrides.find(S=>(0,D.$ub)([...S.identifiers].sort(),k));v&&(i.overrideIdentifiers=v.identifiers)}const b=i?.overrideIdentifiers?.length?[(0,p.$to)(i.overrideIdentifiers),$]:[$];await this.j.write(b,t),await this.reloadConfiguration()}inspect($,t={}){return this.a.inspect($,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.r($)}r($){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration($);this.u(r,t,2)}s($,t){const r=this.a.toData(),n=this.a.compareAndUpdateDefaultConfiguration($,t);this.u(n,r,7)}t($){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration($);this.u(r,t,7)}u($,t,r){const n=new c.$Co($,{data:t},this.a,void 0,this.n);n.source=r,this.h.fire(n)}}e.$Go=u;class m{constructor($,t,r){this.b=$,this.c=t,this.d=r,this.a=new N.$Dh}write($,t){return this.a.queue(()=>this.e($,t))}async e($,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)r="{}";else throw i}const n=[];if((0,O.$Jn)(r,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,$,t);r=(0,I.$2n)(r,s),await this.c.writeFile(this.b,j.$Ge.fromString(r))}f($,t,r){const{tabSize:n,insertSpaces:s,eol:i}=this.h;if(!t.length){const o=JSON.stringify(r,null,s?" ".repeat(n):"	");return[{content:o,length:o.length,offset:0}]}return(0,I.$Yn)($,t,r,{tabSize:n,insertSpaces:s,eol:i})}get h(){if(!this.g){let $=y.OS===3||y.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&($=t),this.g={eol:$,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[218],ce([0,1,15,3,2,68]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ovb=e.$mvb=e.$lvb=void 0,e.$nvb=I;const O=(f,E,y)=>{const w=new Uint8Array(16);for(let p=0;p<16;p++)w[p]=Math.round(Math.random()*256);const h=(0,D.$1e)(D.$Ge.wrap(w));return[`GET ws://localhost${f}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.$lvb=O,e.$mvb=D.$Ge.fromString(`\r
\r
`);async function I(f,E,y,w,h){f.write(D.$Ge.fromString((0,e.$lvb)(E,y,w)));const c=new j.$Uc;try{return await new Promise((p,g)=>{let l;c.add(f.onData(u=>{l?l=D.$Ge.concat([l,u],l.byteLength+u.byteLength):l=u;const m=l.indexOf(e.$mvb);if(m===-1)return;p(f),f.pauseData();const d=l.slice(m+e.$mvb.byteLength);d.byteLength&&h.onData.fire(d)})),c.add(f.onClose(u=>g(u??new Error("socket closed")))),c.add(f.onEnd(()=>g(new Error("socket ended"))))})}catch(p){throw f.dispose(),p}finally{c.dispose()}}class C extends j.$Vc{constructor(E,y){super(),this.g=E,this.a=this.B(new N.$he),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new N.$ee),this.onDidDispose=this.b.event,this.f=!1,this.B(y.onData),this.B(y.onData.event(w=>this.a.fire(w))),this.onClose=this.B(y.onClose).event,this.onEnd=this.B(y.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(E,y){A.SocketDiagnostics.traceSocketEvent(this,this.g,E,y)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$ovb=C}),define(ae[219],ce([0,1,7,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=f,e.$Hl=(0,N.$wi)("remoteAuthorityResolverService");var j;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(j||(e.RemoteConnectionType=j={}));class A{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=A;class O{constructor(y,w){this.host=y,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=O;var I;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class C extends D.$bb{static isNotAvailable(y){return y instanceof C&&y._code===I.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof C&&y._code===I.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof C&&y._code===I.NoResolverFound}static isInvalidAuthority(y){return y instanceof C&&y._code===I.InvalidAuthority}static isHandled(y){return y instanceof C&&y.isHandled}constructor(y,w=I.Unknown,h){super(y),this._message=y,this._code=w,this._detail=h,this.isHandled=w===I.NotAvailable&&h===!0,Object.setPrototypeOf(this,C.prototype)}}e.$Kl=C;function f(E){const y=E.indexOf("+");return y===-1?E:E.substring(0,y)}}),define(ae[220],ce([0,1,6,15,26,7,3,2,23,98,63,32,68,219]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ql=b,e.$Rl=k,e.$Sl=S;const c=30*1e3;var p;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function g(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(z){const L=new j.$pe;return setTimeout(()=>L.cancel(),z),L.token}function u(z,L){if(z.isCancellationRequested||L.isCancellationRequested)return j.CancellationToken.Cancelled;const T=new j.$pe;return z.onCancellationRequested(()=>T.cancel()),L.onCancellationRequested(()=>T.cancel()),T.token}class m{get didTimeout(){return this.c==="timedout"}constructor(L){this.c="pending",this.d=new I.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,D.$ph)(),L.isCancellationRequested?this.h():this.d.add(L.onCancellationRequested(()=>this.h()))}registerDisposable(L){this.c==="pending"?this.d.add(L):L.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const L=new Error("Time limit reached");return L.code="ETIMEDOUT",L.syscall="connect",L}resolve(L){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(L))}reject(L){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(L))}}function d(z,L){const T=new m(L);return T.registerDisposable(z.onControlMessage(U=>{const x=JSON.parse(U.toString()),K=B(x);K?T.reject(K):T.resolve(x)})),T.promise}function $(z,L,T,U,x,K,ee,_){const Z=new m(_),se=E.$ae.create(!1);return z.info(`Creating a socket (${ee})...`),f.mark(`code/willCreateSocket/${K}`),L.connect(T,U,x,ee).then(ue=>{Z.didTimeout?(f.mark(`code/didCreateSocketError/${K}`),z.info(`Creating a socket (${ee}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(f.mark(`code/didCreateSocketOK/${K}`),z.info(`Creating a socket (${ee}) was successful after ${se.elapsed()} ms.`),Z.resolve(ue))},ue=>{f.mark(`code/didCreateSocketError/${K}`),z.info(`Creating a socket (${ee}) returned an error after ${se.elapsed()} ms.`),z.error(ue),Z.reject(ue)}),Z.promise}function t(z,L){const T=new m(L);return z.then(U=>{T.didTimeout||T.resolve(U)},U=>{T.didTimeout||T.reject(U)}),T.promise}async function r(z,L,T,U){const x=te(z,L);z.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let K;try{K=await $(z.logService,z.remoteSocketFactoryService,z.connectTo,C.$Jg.getServerRootPath(),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,g(L),`renderer-${g(L)}-${z.reconnectionToken}`,U)}catch(ue){throw z.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ue),ue}z.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let ee,_;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(K,null),ee=z.reconnectionProtocol,_=!1):(ee=new w.$ki({socket:K}),_=!0),z.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const Z=await t(z.signService.createNewMessage((0,y.$Sg)()),U),se={type:"auth",auth:z.connectionToken||"00000000000000000000",data:Z.data};ee.sendControl(N.$Ge.fromString(JSON.stringify(se)));try{const ue=await d(ee,u(U,l(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(z.logService.trace(`${x} 4/6. received SignRequest control message.`),!await t(z.signService.validate(Z,ue.signedData),U)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const fe=await t(z.signService.sign(ue.data),U),$e={type:"connectionType",commit:z.commit,signedData:fe,desiredConnectionType:L};return T&&($e.args=T),z.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(N.$Ge.fromString(JSON.stringify($e))),{protocol:ee,ownsProtocol:_}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(z.logService.error(`${x} the handshake timed out. Error:`),z.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${x} received error control message when negotiating connection. Error:`),z.logService.error(ue)),_&&G(ee),ue}}async function n(z,L,T,U){const x=Date.now(),K=te(z,L),{protocol:ee,ownsProtocol:_}=await r(z,L,T,U),Z=new m(U);return Z.registerDisposable(ee.onControlMessage(se=>{const ue=JSON.parse(se.toString()),ge=B(ue);ge?(z.logService.error(`${K} received error control message when negotiating connection. Error:`),z.logService.error(ge),_&&G(ee),Z.reject(ge)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${V(x)}!`),Z.resolve({protocol:ee,firstMessage:ue}))})),Z.promise}async function s(z,L){const{protocol:T}=await n(z,1,void 0,L);return{protocol:T}}async function i(z,L,T){const{protocol:U,firstMessage:x}=await n(z,2,L,T),K=x&&x.debugPort;return{protocol:U,debugPort:K}}async function o(z,L,T){const U=Date.now(),x=te(z,3),{protocol:K}=await r(z,3,L,T);return z.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${V(U)}!`),K}async function a(z,L,T){const{connectTo:U,connectionToken:x}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,connectTo:U,connectionToken:x,reconnectionToken:L,reconnectionProtocol:T,remoteSocketFactoryService:z.remoteSocketFactoryService,signService:z.signService,logService:z.logService}}async function b(z,L,T){return v(z,async U=>{const{protocol:x}=await s(U,j.CancellationToken.None);return new W(z,L,T,U.reconnectionToken,x)})}async function k(z,L){return v(z,async T=>{const{protocol:U,debugPort:x}=await i(T,L,j.CancellationToken.None);return new J(z,L,T.reconnectionToken,U,x)})}async function v(z,L){for(let U=1;;U++)try{const x=(0,y.$Sg)(),K=await a(z,x,null);return await L(K)}catch(x){if(U<5)z.logService.error(`[remote-connection][attempt ${U}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(x);else throw z.logService.error(`[remote-connection][attempt ${U}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(x),X.triggerPermanentFailure(0,0,h.$Kl.isHandled(x)),x}}async function S(z,L,T){const U=await a(z,(0,y.$Sg)(),null);return await o(U,{host:L,port:T},j.CancellationToken.None)}function P(z){return(0,D.$jh)(L=>new Promise((T,U)=>{const x=setTimeout(T,z*1e3);L.onCancellationRequested(()=>{clearTimeout(x),T()})}))}var R;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(R||(e.PersistentConnectionEventType=R={}));class M{constructor(L,T){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.type=0}}e.$Tl=M;class F{constructor(L,T,U,x){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.durationSeconds=U,this.c=x,this.type=1}skipWait(){this.c.cancel()}}e.$Ul=F;class q{constructor(L,T,U){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.attempt=U,this.type=2}}e.$Vl=q;class Y{constructor(L,T,U){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.attempt=U,this.type=4}}e.$Wl=Y;class H{constructor(L,T,U,x){this.reconnectionToken=L,this.millisSinceLastIncomingData=T,this.attempt=U,this.handled=x,this.type=3}}e.$Xl=H;class X extends I.$Vc{static triggerPermanentFailure(L,T,U){this._permanentFailure=!0,this.f=L,this.g=T,this.h=U,this.j.forEach(x=>x.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(L=>L.y())}static debugPauseSocketWriting(){this.j.forEach(L=>L.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||X._permanentFailure}constructor(L,T,U,x,K){super(),this.t=L,this.u=T,this.reconnectionToken=U,this.protocol=x,this.w=K,this.m=this.B(new O.$ee),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(x.onSocketClose(ee=>{const _=he(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(x.onSocketTimeout(ee=>{const _=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),X.j.push(this),this.B((0,I.$Tc)(()=>{const ee=X.j.indexOf(this);ee>=0&&X.j.splice(ee,1)})),this.n&&this.D(X.f,X.g,X.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const L=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${L} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let U=-1;do{U++;const x=U<T.length?T[U]:T[T.length-1];try{if(x>0){const ee=P(x);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,ee)),this.u.logService.info(`${L} waiting for ${x} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${L} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1)),this.u.logService.info(`${L} resolving connection...`);const K=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${L} connecting to ${K.connectTo}...`),await this.G(K,l(c)),this.u.logService.info(`${L} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${L} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(U>360){this.u.logService.error(`${L} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(h.$Kl.isTemporarilyNotAvailable(K)){this.u.logService.info(`${L} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.u.logService.info(`${L} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((0,A.$4)(K)){this.u.logService.info(`${L} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if(K instanceof h.$Kl){this.u.logService.error(`${L} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,h.$Kl.isHandled(K));break}this.u.logService.error(`${L} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}}while(!this.n&&!this.s)}C(L,T,U){this.w?X.triggerPermanentFailure(L,T,U):this.D(L,T,U)}D(L,T,U){this.m.fire(new H(this.reconnectionToken,L,T,U)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Yl=X;class W extends X{constructor(L,T,U,x,K){super(1,L,x,K,!0),this.client=this.B(new w.$ii(K,{remoteAuthority:T,clientId:U},L.ipcLogger))}async G(L,T){await s(L,T)}}e.$Zl=W;class J extends X{constructor(L,T,U,x,K){super(2,L,U,x,!1),this.H=T,this.debugPort=K}async G(L,T){await i(L,this.H,T)}}e.$1l=J;function G(z){try{z.acceptDisconnect();const L=z.getSocket();z.dispose(),L.dispose()}catch(L){(0,A.$1)(L)}}function B(z){if(z&&z.type==="error"){const L=new Error(`Connection error: ${z.reason}`);return L.code="VSCODE_CONNECTION_ERROR",L}return null}function ie(z,L){for(;z.length<L;)z+=" ";return z}function re(z,L){return`[remote-connection][${ie(g(z),13)}][${L.substr(0,5)}\u2026]`}function he(z,L,T){return`${re(z,L)}[${T?"reconnect":"initial"}]`}function te(z,L){return`${he(L,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.connectTo}]`}function V(z){return`${Date.now()-z} ms`}}),define(ae[102],ce([0,1,23]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=N,e.$Im=j,e.$Jm=A,e.$Km=O;function N(C){return C.scheme===D.Schemas.vscodeRemote?C.authority:void 0}function j(C){if(!C)return;const f=C.indexOf("+");return f<0?C:C.substr(0,f)}function A(C){const{host:f,port:E}=I(C);if(typeof E>"u")throw new Error(`Invalid remote authority: ${C}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:f,port:E}}function O(C,f){let{host:E,port:y}=I(C);return typeof y>"u"&&(y=f),{host:E,port:y}}function I(C){const f=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(f)return{host:f[1],port:parseInt(f[2],10)};const E=C.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=C.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:C,port:void 0}}}),define(ae[48],ce([0,1,27,4,102]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=A,e.$Um=y,e.$Vm=w,e.$Wm=h,e.$Xm=c,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class C{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,l){if(typeof g>"u"||g===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof g=="string"||typeof l=="string"){const u=typeof g=="string"?g:g.value,m=typeof l=="string"?l:l.value;return D.$yf(u,m)}return g._lower===l._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Rm=C;class f{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const l of g)this.add(l)}add(g){this.c.add(C.toKey(g))}delete(g){return this.c.delete(C.toKey(g))}has(g){return this.c.has(C.toKey(g))}}e.$Sm=f;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(C.toKey(g))}get(g){return this.c.get(C.toKey(g))}has(g){return this.c.has(C.toKey(g))}set(g,l){this.c.set(C.toKey(g),l)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=E;function y(p){return w(p)}function w(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function h(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function c(p,g){if(g){const l=`onResolveRemoteAuthority:${(0,j.$Im)(g)}`;return!!p.activationEvents?.includes(l)}return!1}e.$Ym=(0,N.$wi)("IBuiltinExtensionsScannerService")}),define(ae[221],ce([0,1,2,48,12]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class A extends D.$Vc{constructor(I,C,f,E,y){super(),this.a=I,this.b=C,this.c=f,this.f=y,this.B(E.onDidInstallExtensions(w=>this.g(w))),this.B(E.onDidUninstallExtension(w=>this.h(w)))}g(I){for(const C of I)C.local&&this.invalidate(C.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const C of this.a.profiles)this.c.extUri.isEqual(C.extensionsResource,I)&&await this.j(C);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,N.$Lm))}catch(C){(0,j.$hl)(C)!==1&&this.f.error(C)}}}e.$Bq=A}),define(ae[103],ce([0,1,2,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=void 0,e.$Ml=(0,N.$wi)("remoteSocketFactoryService");class j{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,D.$Tc)(()=>{const C=this.a[O]?.indexOf(I);typeof C=="number"&&C>=0&&this.a[O]?.splice(C,1)})}b(O){return(this.a[O.type]||[]).find(C=>C.supports(O))}connect(O,I,C,f){const E=this.b(O);if(!E)throw new Error(`No socket factory found for ${O}`);return E.connect(O,I,C,f)}}e.$Nl=j}),define(ae[222],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=e.$nec=void 0,e.$nec=(0,D.$wi)("sharedProcessTunnelService"),e.$oec="sharedProcessTunnel"}),define(ae[104],ce([0,1,4,169]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=e.$xec=e.$wec=e.$vec=e.$uec=e.TunnelStates=e.$tec=e.$sec=void 0,e.$sec=(0,D.$wi)("IRemoteTunnelService"),e.$tec={active:!1};var j;(function(A){A.disconnected=O=>({type:"disconnected",onTokenFailed:O}),A.connected=(O,I)=>({type:"connected",info:O,serviceInstallFailed:I}),A.connecting=O=>({type:"connecting",progress:O}),A.uninitialized={type:"uninitialized"}})(j||(e.TunnelStates=j={})),e.$uec="remote.tunnels.access",e.$vec=e.$uec+".hostNameOverride",e.$wec=e.$uec+".preventSleep",e.$xec="remoteTunnelService",e.$yec=(0,N.localize)(0,null)}),define(ae[59],ce([0,1,15,7,2,171,47,4,9,43]),function(ne,e,D,N,j,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=w,e.$Qp=h,e.$Rp=c,e.$Sp=p,e.$Tp=g,e.$Up=l,e.$Np=(0,I.$wi)("requestService");class E{constructor($){this.b=$}toJSON(){if(!this.a){const $=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?$[t]="*****":$[t]=this.b[t];this.a=$}return this.a}}class y extends j.$Vc{constructor($){super(),this.b=0,this.a=$.createLogger("network",{name:(0,A.localize)(0,null),when:C.$ik.isEqualTo((0,C.$fk)(C.LogLevel.Trace)).serialize()})}async c($,t,r){const n=`${$} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new E(t.headers??{}));try{const s=await r();return this.a.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,t.type,(0,N.$0)(s)),s}}}e.$Op=y;function w(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}function h(d){return d.res.statusCode===204}async function c(d){return h(d)?null:(await(0,D.$Se)(d.stream)).toString()}async function p(d){if(!w(d))throw new Error("Server returned "+d.res.statusCode);return c(d)}async function g(d){if(!w(d))throw new Error("Server returned "+d.res.statusCode);if(h(d))return null;const t=(await(0,D.$Se)(d.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function l(d){m(d)}let u;function m(d){const $=f.$co.as(O.$ho.Configuration),t=u;u={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},$.updateConfigurations({add:[u],remove:t?[t]:[]})}m(1)}),define(ae[223],ce([0,1,26,23,12,59]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Q=void 0;let O=class{constructor(C,f){this.a=C,this.b=f}async download(C,f,E=D.CancellationToken.None){if(C.scheme===N.Schemas.file||C.scheme===N.Schemas.vscodeRemote){await this.b.copy(C,f);return}const y={type:"GET",url:C.toString(!0)},w=await this.a.request(y,E);if(w.res.statusCode===200)await this.b.writeFile(f,w.stream);else{const h=await(0,A.$Sp)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${h}`)}}};e.$4Q=O,e.$4Q=O=Ee([Q(0,A.$Np),Q(1,j.$3k)],O)}),define(ae[224],ce([0,1,15,26]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=void 0;class j{constructor(I){this.a=I}listen(I,C){throw new Error("Invalid listen")}call(I,C,f,E=N.CancellationToken.None){switch(C){case"request":return this.a.request(f[0],E).then(async({res:y,stream:w})=>{const h=await(0,D.$Se)(w);return[{statusCode:y.statusCode,headers:y.headers},h]});case"resolveProxy":return this.a.resolveProxy(f[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Ur=j;class A{constructor(I){this.a=I}async request(I,C){const[f,E]=await this.a.call("request",[I],C);return{res:f,stream:(0,D.$Ue)(E)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Vr=A}),define(ae[225],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=e.$Rcc=void 0,e.$Rcc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Scc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Tcc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[226],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(j){try{const A=await this.c();if(A){const O=String(D.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(j)}}}catch{}return{id:"",data:j}}async validate(j,A){if(!j.id)return!0;const O=this.b.get(j.id);if(!O)return!1;this.b.delete(j.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(j){try{return await this.d(j)}catch{}return j}}e.$L$b=D}),define(ae[105],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol="signService",e.$Pl=(0,D.$wi)(e.$Ol)}),define(ae[227],ce([0,1,226]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class N extends D.$L$b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(O=>new O.signer().sign(A))}h(){return new Promise((A,O)=>ne(["vsda"],A,O))}}e.$Hdc=N}),define(ae[77],ce([0,1,3,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IKb=e.$HKb=e.$GKb=e.$FKb=void 0;class j extends N.$Vc{constructor(y,w,h){super(),this.a=y,this.b=w,this.c=h}async getItems(){const y={profile:this.b,workspace:this.c},w=await this.a.call("getItems",y);return new Map(w)}updateItems(y){const w={profile:this.b,workspace:this.c};return y.insert&&(w.insert=Array.from(y.insert.entries())),y.delete&&(w.delete=Array.from(y.delete.values())),this.a.call("updateItems",w)}optimize(){const y={profile:this.b,workspace:this.c};return this.a.call("optimize",y)}}class A extends j{constructor(y,w){super(y,w,void 0),this.f=this.B(new D.$ee),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(y=>this.h(y)))}h(y){(Array.isArray(y.changed)||Array.isArray(y.deleted))&&this.f.fire({changed:y.changed?new Map(y.changed):void 0,deleted:y.deleted?new Set(y.deleted):void 0})}}class O extends A{constructor(y){super(y,void 0)}async close(){this.dispose()}}e.$FKb=O;class I extends A{constructor(y,w){super(y,w)}async close(){this.dispose()}}e.$GKb=I;class C extends j{constructor(y,w){super(y,void 0,w),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$HKb=C;class f{constructor(y){this.a=y}isUsed(y){const w={payload:y,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.$IKb=f}),define(ae[106],ce([0,1,5,36,32]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=O,e.$ep=I;function A(C){if(D.$u===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}function O(C,f,E,y,w,h,c,p,g){const l=Object.create(null);l["common.machineId"]=h,l["common.sqmId"]=c,l.sessionID=(0,j.$Sg)()+Date.now(),l.commitHash=y,l.version=w,l["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,D.$h)(D.$u),l["common.nodePlatform"]=N.$ec,l["common.nodeArch"]=E,l["common.product"]=g||"desktop",p&&(l["common.msftInternal"]=p);let u=0;const m=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.$l&&(l["common.snap"]="true");const d=A(f);return d&&(l["common.platformDetail"]=d),l}function I(C){const f=N.env.USERDNSDOMAIN;if(!f)return!1;const E=f.toLowerCase();return C.some(y=>E===y)}}),define(ae[22],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,D.$wi)("telemetryService"),e.$3l=(0,D.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var j;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(j||(e.TelemetryConfiguration=j={}))}),define(ae[228],ce([0,1,37,6,35,23,14,5,8,144,31,150,94,12,24,22]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Es=l,e.$Fs=m,e.$Gs=d;const g=new Map;async function l(t,r){const n=`${t}::${r.join(":")}`,s=g.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,a=new Map,b=2e4;function k(S,P,R,M){const F=P.substring(S.length+1);return N.Promises.withAsyncBody(async q=>{let Y;try{Y=await E.Promises.readdir(P,{withFileTypes:!0})}catch{q();return}if(M.count>=b){M.count+=Y.length,M.maxReached=!0,q();return}let H=Y.length;if(H===0){q();return}let X=Y;M.count+Y.length>b&&(M.maxReached=!0,H=b-M.count,X=Y.slice(0,H)),M.count+=Y.length;for(const W of X)if(W.isDirectory()){if(R.includes(W.name)||await k(S,(0,O.$kc)(P,W.name),R,M),--H===0){q();return}}else{const J=W.name.lastIndexOf(".");if(J>=0){const G=W.name.substring(J+1);G&&o.set(G,(o.get(G)??0)+1)}for(const G of i)G.relativePathPattern?.test(F)!==!1&&G.filePattern.test(W.name)&&a.set(G.tag,(a.get(G.tag)??0)+1);if(--H===0){q();return}}})}const v=N.Promises.withAsyncBody(async S=>{const P={count:0,maxReached:!1};await k(t,t,r,P);const R=await d(t);S({configFiles:u(a),fileTypes:u(o),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:R})});return g.set(n,v),v}function u(t){return Array.from(t.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function m(){const t={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.$yl.GB).toFixed(2)}GB (${(D.freemem()/h.$yl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(f.$En.value()*100)}%`},r=D.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function d(t){try{const r=new Map,n=(0,O.$kc)(t,".vscode","launch.json"),s=await E.Promises.readFile(n),i=[],o=(0,j.$Jn)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,j.$Sn)(o)==="object"&&o.configurations)for(const a of o.configurations){const b=a.type;b&&(r.has(b)?r.set(b,r.get(b)+1):r.set(b,1))}return u(r)}catch{return[]}}let $=class{constructor(r,n){this.c=r,this.d=n}f(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}g(r){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const s=D.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/h.$yl.GB).toFixed(2)}GB (${(D.freemem()/h.$yl.GB).toFixed(2)}GB free)`),I.$i||n.push(`Load (avg):       ${D.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(f.$En.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,y.$Ds)(r.mainPID),this.k(r)]).then(async s=>{let[i,o]=s,a=this.m(r,i);return n.forEach(b=>{if((0,w.$en)(b))a+=`
${b.errorMessage}`,o+=`
${b.errorMessage}`;else if(a+=`

Remote: ${b.hostName}`,b.processes&&(a+=`
${this.m(r,b.processes)}`),b.workspaceMetadata){o+=`
|  Remote: ${b.hostName}`;for(const k of Object.keys(b.workspaceMetadata)){const v=b.workspaceMetadata[k];let S=`${v.fileCount} files`;v.maxFilesReached&&(S=`more than ${S}`),o+=`|    Folder (${k}): ${S}`,o+=this.h(v)}}}),{processInfo:a,workspaceInfo:o}})}async getSystemInfo(r,n){const{memory:s,vmHint:i,os:o,cpus:a}=m(),b={os:o,memory:s,cpus:a,vmHint:i,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return I.$i||(b.load=`${D.loadavg().map(k=>Math.round(k)).join(", ")}`),I.$k&&(b.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(b)}async getDiagnostics(r,n){const s=[];return(0,y.$Ds)(r.mainPID).then(async i=>(s.push(""),s.push(this.g(r)),s.push(""),s.push(this.m(r,i)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(r))),n.forEach(o=>{if((0,w.$en)(o))s.push(`
${o.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${o.hostName}`),s.push(this.f(o.machineInfo)),o.processes&&s.push(this.m(r,o.processes)),o.workspaceMetadata)for(const a of Object.keys(o.workspaceMetadata)){const b=o.workspaceMetadata[a];let k=`${b.fileCount} files`;b.maxFilesReached&&(k=`more than ${k}`),s.push(`Folder (${a}): ${k}`),s.push(this.h(b))}}),s.push(""),s.push(""),s.join(`
`)))}h(r){const n=[];let i=0;const o=(v,S)=>{const P=` ${v}(${S})`;i+P.length>60?(n.push(a),a="|                 ",i=a.length):i+=P.length,a+=P};let a="|      File types:";const b=10,k=r.fileTypes.length>b?b:r.fileTypes.length;for(let v=0;v<k;v++){const S=r.fileTypes[v];o(S.name,S.count)}if(n.push(a),r.configFiles.length>=0&&(a="|      Conf files:",i=0,r.configFiles.forEach(v=>{o(v.name,v.count)}),n.push(a)),r.launchConfigFiles.length>0){let v="|      Launch Configs:";r.launchConfigFiles.forEach(S=>{const P=S.count>1?` ${S.name}(${S.count})`:` ${S.name}`;v+=P}),n.push(v)}return n.join(`
`)}j(r){const n=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${r[s]}`).join(`
                  `)}k(r){const n=[],s=[];return r.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(o=>{const a=C.URI.revive(o);if(a.scheme===A.Schemas.file){const b=a.fsPath;s.push(l(b,["node_modules",".git"]).then(k=>{let v=`${k.fileCount} files`;k.maxFilesReached&&(v=`more than ${v}`),n.push(`|    Folder (${(0,O.$oc)(b)}): ${v}`),n.push(this.h(k))}).catch(k=>{n.push(`|      Error: Unable to collect workspace stats for folder ${b} (${k.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(r,n){const s=new Map;r.windows.forEach(o=>s.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:a})=>s.set(o,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.n(r.mainPID,s,i,n,0),i.join(`
`)}n(r,n,s,i,o){const a=o===0;let b;a?b=i.pid===r?`${this.d.applicationName} main`:"remote agent":n.has(i.pid)?b=n.get(i.pid):b=`${"  ".repeat(o)} ${i.name}`;const k=process.platform==="win32"?i.mem:D.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(k/h.$yl.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${b}`),Array.isArray(i.children)&&i.children.forEach(v=>this.n(r,n,s,v,o+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:s}of r.folders){const i=C.URI.revive(s);if(i.scheme!==A.Schemas.file)continue;const o=i.fsPath;try{(await l(o,["node_modules",".git"])).fileTypes.forEach(b=>n.add(b.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const s=C.URI.revive(n);if(s.scheme!==A.Schemas.file)continue;const i=s.fsPath;try{const o=await l(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Hs=$,e.$Hs=$=Ee([Q(0,p.$2l),Q(1,c.$jk)],$)}),define(ae[107],ce([0,1,7,4,9,22]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.ExtensionSignatureVerificationCode=e.$_p=void 0,e.$_p=(0,N.$wi)("IExtensionSignatureVerificationService");var O;(function(f){f.None="None",f.RequiredArgumentMissing="RequiredArgumentMissing",f.InvalidArgument="InvalidArgument",f.PackageIsUnreadable="PackageIsUnreadable",f.UnhandledException="UnhandledException",f.SignatureManifestIsMissing="SignatureManifestIsMissing",f.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",f.SignatureIsMissing="SignatureIsMissing",f.SignatureIsUnreadable="SignatureIsUnreadable",f.CertificateIsUnreadable="CertificateIsUnreadable",f.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",f.FileAlreadyExists="FileAlreadyExists",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",f.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",f.Success="Success",f.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",f.SignatureIsInvalid="SignatureIsInvalid",f.SignatureManifestIsInvalid="SignatureManifestIsInvalid",f.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",f.EntryIsMissing="EntryIsMissing",f.EntryIsTampered="EntryIsTampered",f.Untrusted="Untrusted",f.CertificateRevoked="CertificateRevoked",f.SignatureIsNotValid="SignatureIsNotValid",f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(O||(e.ExtensionSignatureVerificationCode=O={}));class I extends Error{constructor(E){super(E),this.code=E}}e.$aq=I;let C=class{constructor(E,y){this.b=E,this.c=y}d(){return this.a||(this.a=new Promise((E,y)=>ne(["@vscode/vsce-sign"],async w=>E(w),y))),this.a}async verify(E,y,w){let h;try{h=await this.d()}catch(l){return this.b.error("Could not load vsce-sign module",(0,D.$0)(l)),this.b.info(`Extension signature verification is not done: ${E}`),!1}const c=new Date().getTime();let p;try{p=await h.verify(y,w,this.b.getLevel()===j.LogLevel.Trace)}catch(l){p={code:"UnknownError",didExecute:!1,output:(0,D.$0)(l)}}const g=new Date().getTime()-c;if(this.b.info(`Extension signature verification result for ${E}: ${p.code}. Duration: ${g}ms.`),this.b.trace(`Extension signature verification output for ${E}:
${p.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:E,code:p.code,duration:g,didExecute:p.didExecute}),p.code==="Success")return!0;throw new I(p.code)}};e.$bq=C,e.$bq=C=Ee([Q(0,j.$3j),Q(1,A.$2l)],C)}),define(ae[108],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0;class D{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:I,data:C}){return this.b.forEach(f=>f.log(I,C)),Promise.resolve(null)}}e.$Wcc=D;class N{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Xcc=N}),define(ae[49],ce([0,1,30,13,102,106,22]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=E,e.$np=y,e.$op=w,e.$pp=h,e.$qp=p,e.$rp=l,e.$sp=u,e.$tp=$;class I{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$fp=I;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=C,e.$hp=new C;class f{async publicLog(r,n,s){}async publicLogError(r,n,s){}}e.$ip=f,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function E(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function y(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function w(t){const r=t.getValue(O.$0l),n=t.getValue(O.$$l);if(t.getValue(O.$_l)===!1||n===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function h(t){const r={},n={},s={};g(t,s);for(let i in s){i=i.length>150?i.substr(i.length-149):i;const o=s[i];typeof o=="number"?n[i]=o:typeof o=="boolean"?n[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),r[i]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[i]=o)}return{properties:r,measurements:n}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(t){if(!t)return"none";const r=(0,j.$Im)(t);return c.has(r)?r:"other"}function g(t,r,n=0,s){if(t)for(const i of Object.getOwnPropertyNames(t)){const o=t[i],a=s?s+i:i;Array.isArray(o)?r[a]=(0,D.$8n)(o):o instanceof Date?r[a]=o.toISOString():(0,N.$$f)(o)?n<2?g(o,r,n+1,a+"."):r[a]=(0,D.$8n)(o):r[a]=o}}function l(t,r){const n=t.msftInternalDomains||[],s=r.getValue("telemetry.internalTesting");return(0,A.$ep)(n)||s}function u(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function m(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let n=t;const s=[];for(const b of r)for(;;){const k=b.exec(t);if(!k)break;s.push([k.index,b.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const b=o.exec(t);if(!b)break;const k=s.some(([v,S])=>b.index<S&&v<o.lastIndex);!i.test(b[0])&&!k&&(n+=t.substring(a,b.index)+"<REDACTED: user-file-path>",a=o.lastIndex)}return a<t.length&&(n+=t.substr(a)),n}function d(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of r)if(n.regex.test(t))return`<REDACTED: ${n.label}>`;return t}function $(t,r){return(0,D.$5n)(t,n=>{if(n instanceof I||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=m(s,r);for(const i of r)s=s.replace(i,"");return s=d(s),s}})}}),define(ae[33],ce([0,1,27,29,48,5,8,7,36,49]),function(ne,e,D,N,j,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=E,e.$wp=c,e.$xp=p,e.$yp=g,e.$zp=l,e.$Ap=u,e.$Bp=m,e.$Cp=d,e.$Ep=$,e.$Fp=r;function E(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,D.$tf)(n.id,s.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(s){const i=s.manifest?s.manifest.version:s.version,o=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new w(s.identifier,i,o)}static parse(s){const i=y.exec(s);return i&&i[1]&&i[2]?new w({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof w?E(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$vp=w;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function c(n){const s=h.exec(n);return s&&s[1]?[g(s[1]),s[2]]:[g(n),void 0]}function p(n,s){return`${n}.${s}`}function g(n){return n.toLowerCase()}function l(n,s){return g(p(n??j.$Nm,s))}function u(n,s){const i=[],o=a=>{for(const b of i)if(b.some(k=>E(s(k),s(a))))return b;return null};for(const a of n){const b=o(a);b?b.push(a):i.push([a])}return i}function m(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function d(n){return{id:new f.$fp(n.identifier.id),name:new f.$fp(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Dp=new j.$Rm("pprice.better-merge");function $(n,s){const i=[],o=s.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&i.every(b=>!E(b.identifier,{id:a}))){const b=n.filter(k=>E(k.identifier,{id:a}));b.length===1&&(i.push(b[0]),o.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}async function t(n,s){if(!A.$k)return!1;let i;try{i=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,I.$0)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(n,s){const i=await t(n,s),o=(0,N.$2o)(i?"alpine":A.$u,C.$fc);return s.debug("ComputeTargetPlatform:",o),o}}),define(ae[229],ce([0,1,17,2,20,8,12,24,6,3,14,5,36,33]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=e.$Uac=void 0;let c=class extends N.$Vc{constructor(m,d){super(),this.b=m,this.c=d,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,$])=>this.a.set($.configPath,$))}getConfigBasedTips(m){return this.f(m)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(m){const d=[];for(const[$,t]of this.a)if(!(t.configScheme&&t.configScheme!==m.scheme))try{const r=(await this.b.readFile((0,j.$0g)(m,$))).value.toString();for(const[n,s]of Object.entries(t.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(r))&&d.push({extensionId:n,extensionName:s.name,configName:t.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return d}};e.$Uac=c,e.$Uac=c=Ee([Q(0,O.$3k),Q(1,I.$jk)],c);const p="extensionTips/promptedExecutableTips",g="extensionTips/lastPromptedMediumImpExeTime";class l extends c{constructor(m,d,$,t,r,n,s,i){super(s,i),this.r=m,this.s=d,this.t=$,this.u=t,this.w=r,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([o,a])=>{const b=[],k=[],v=[];Object.entries(a.recommendations).forEach(([S,P])=>{P.important?a.important?b.push({extensionId:S,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):k.push({extensionId:S,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):v.push({extensionId:S,extensionName:P.name,isExtensionPack:!!P.isExtensionPack})}),b.length&&this.g.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:b}),k.length&&this.h.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:k}),v.length&&this.j.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v})}),(0,C.$yh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const m=await this.O(this.g),d=await this.O(this.h);return[...m,...d]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const m=await this.O(this.g),d=await this.O(this.h),$=await this.u.getInstalled();this.m=this.D(m,$),this.n=this.D(d,$)}D(m,d){const $=new Map;m.forEach(i=>$.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:r}=this.N([...$.keys()],d);for(const i of t){const o=$.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:o.exeName})}for(const i of r){const o=$.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:o.exeName})}const n=this.L(),s=new Map;for(const i of r){const o=$.get(i);if(o&&(!n[o.exeName]||!n[o.exeName].includes(o.extensionId))){let a=s.get(o.exeName);a||(a=[],s.set(o.exeName,a)),a.push(o)}}return s}F(){if(this.m.size===0)return;const[m,d]=[...this.m.entries()][0];this.H(d).then($=>{switch($){case"reacted":this.M(d[0].exeName,d);break;case"ignored":this.m.delete(m);break;case"incompatibleWindow":{const t=f.Event.once(f.Event.latch(f.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case"toomany":{const t=this.B(new N.$Wc);t.value=(0,C.$yh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const m=this.I(),d=Date.now()-m,$=7*24*60*60*1e3;if(d<$){const n=this.B(new N.$Wc);n.value=(0,C.$yh)(()=>{n.dispose(),this.G()},$-d);return}const[t,r]=[...this.n.entries()][0];this.H(r).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(t),this.M(r[0].exeName,r);const s=this.B(new N.$Wc);s.value=(0,C.$yh)(()=>{s.dispose(),this.G()},$);break}case"ignored":this.n.delete(t),this.G();break;case"incompatibleWindow":{const s=f.Event.once(f.Event.latch(f.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new N.$Wc);s.value=(0,C.$yh)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(m){const d=await this.u.getInstalled(1),$=m.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(r=>d.every(n=>!(0,h.$up)(n.identifier,{id:r})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:$,source:3,name:m[0].exeFriendlyName,searchValue:`@exe:"${m[0].exeName}"`})}I(){let m=this.w.getNumber(g,-1);return m||(m=Date.now(),this.J(m)),m}J(m){this.w.store(g,m,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(m,d){const $=this.L();$[m]=d.map(({extensionId:t})=>t.toLowerCase()),this.w.store(p,JSON.stringify($),-1,0)}N(m,d){const $=[],t=[],r=d.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return m.forEach(n=>{r.has(n.toLowerCase())?$.push(n):t.push(n)}),{installed:$,uninstalled:t}}async O(m){const d=[],$=new Map;for(const t of m.keys()){const r=m.get(t);if(!r||!(0,D.$Lb)(r.recommendations))continue;const n=[];y.$i?r.windowsPath&&n.push(r.windowsPath.replace("%USERPROFILE%",()=>w.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>w.env.ProgramFiles).replace("%APPDATA%",()=>w.env.APPDATA).replace("%WINDIR%",()=>w.env.WINDIR)):(n.push((0,E.$kc)("/usr/local/bin",t)),n.push((0,E.$kc)("/usr/bin",t)),n.push((0,E.$kc)(this.r.fsPath,t)));for(const s of n){let i=$.get(s);if(i===void 0&&(i=await this.b.exists(A.URI.file(s)),$.set(s,i)),i)for(const{extensionId:o,extensionName:a,isExtensionPack:b,whenNotInstalled:k}of r.recommendations)d.push({extensionId:o,extensionName:a,isExtensionPack:b,exeName:t,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:k})}}return d}}e.$Vac=l}),define(ae[230],ce([0,1,26,33]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I4b=j;async function j(A,O,I,C,f){try{const E=await A.getExtensionsControlManifest();if(!E.deprecated)return;const y=await A.getInstalled(1);for(const[w,h]of Object.entries(E.deprecated)){if(!h?.extension)continue;const{id:c,autoMigrate:p,preRelease:g}=h.extension;if(!p)continue;const l=y.find(m=>(0,N.$up)(m.identifier,{id:w}));if(!l)continue;const u=(await O.getExtensions([{id:c,preRelease:g}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!u){f.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${c}' extension is not found`);continue}try{f.info(`Migrating '${l.identifier.id}' extension to '${c}' extension...`);const m=!C.getDisabledExtensions().some($=>(0,N.$up)($,l.identifier));await A.uninstall(l),f.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let d=y.find($=>(0,N.$up)($.identifier,{id:c}));(!d||!d.isPreReleaseVersion&&m)&&(d=await A.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),f.info(`Installed the pre-release extension '${d.identifier.id}'`),m||(await C.disableExtension(d.identifier),f.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),p.storage&&(I.addToMigrationList((0,N.$xp)(l.manifest.publisher,l.manifest.name),(0,N.$xp)(d.manifest.publisher,d.manifest.name)),f.info("Added pre-release extension to the storage migration list"))),f.info(`Migrated '${l.identifier.id}' extension to '${c}' extension.`)}catch(m){f.error(m)}}}catch(E){f.error(E)}}}),define(ae[231],ce([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,107,12,9]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;let d=class extends j.$Vc{static{m=this}static{this.c=".sigzip"}constructor(t,r,n,s,i,o){super(),this.h=r,this.j=n,this.m=s,this.n=i,this.r=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,r,n){await this.g;const s=(0,O.$0g)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,s,o=>this.j.download(t,o,r))}catch(o){throw new c.$7o(o.message,c.ExtensionManagementErrorCode.Download)}let i=!1;if(n&&this.t(t)){const o=await this.u(t);try{i=await this.n.verify(t.identifier.id,s.fsPath,o.fsPath)}catch(a){if(i=a.code,i==="PackageIsInvalidZip"||i==="SignatureArchiveIsInvalidZip"){try{await this.delete(s)}catch(k){this.r.error(k)}throw new c.$7o(y.$gq,c.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(a){this.r.error(a)}}}return{location:s,verificationStatus:i}}t(t){if(!t.isSigned)return this.r.info(`Extension is not signed: ${t.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,C.$cg)(r)?r:!0}async u(t){await this.g;const r=(0,O.$0g)(this.extensionsDownloadDir,`${this.z(t)}${m.c}`);try{await this.w(t,r,n=>this.j.downloadSignatureArchive(t,n))}catch(n){throw new c.$7o(n.message,c.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(t,r,n){if(await this.h.exists(r))return;if(r.scheme!==A.Schemas.file){await n(r);return}const s=(0,O.$0g)(this.extensionsDownloadDir,`.${(0,f.$Sg)()}`);await this.h.exists(s)||await n(s);try{await E.Promises.rename(s.fsPath,r.fsPath,2*60*1e3)}catch(i){try{await this.h.del(s)}catch{}if(i.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(i)}. Deleted the file from downloaded location`,s.path),i}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const r=[],n=[],s=[];for(const a of t.children)if(a.name.endsWith(m.c))s.push(a.resource);else{const b=p.$vp.parse(a.name);b&&n.push([b,a])}const i=(0,p.$Ap)(n,([a])=>a),o=[];for(const a of i)a.sort((b,k)=>I.rcompare(b[0].version,k[0].version)),r.push(...a.slice(1).map(b=>b[1].resource)),o.push(a[0][1]);o.sort((a,b)=>a.mtime-b.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(a=>a.resource)),r.push(...s),await D.Promises.settled(r.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.r.error(t)}}z(t){return this.f?p.$vp.create(t).toString().toLowerCase():(0,f.$Sg)()}};e.$yq=d,e.$yq=d=m=Ee([Q(0,h.$Ei),Q(1,l.$3k),Q(2,c.$6o),Q(3,w.$3i),Q(4,g.$_p),Q(5,u.$3j)],d)}),define(ae[232],ce([0,1,3,2,34,33,48]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class I extends N.$Vc{constructor(f,E,y,w,h,c,p){super(),this.f=f,this.g=E,this.h=y,this.j=w,this.m=h,this.n=c,this.r=p,this.a=this.B(new D.$ee),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$5c),this.s().then(null,g=>p.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(f=>this.u(f.added))),this.B(this.j.onAddExtensions(f=>this.w(f))),this.B(this.j.onDidAddExtensions(f=>this.y(f))),this.B(this.j.onRemoveExtensions(f=>this.z(f))),this.B(this.j.onDidRemoveExtensions(f=>this.C(f))),this.B(this.n.onDidFilesChange(f=>this.D(f)))}async u(f){try{f.length&&await Promise.all(f.map(E=>(this.c.set(E.id,(0,N.$Sc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w(f){for(const E of f.extensions)this.I(this.L(E.identifier,E.version),f.profileLocation)}async y(f){for(const E of f.extensions){const y=this.L(E.identifier,E.version);f.error?this.J(y,f.profileLocation):this.I(y,f.profileLocation)}}async z(f){for(const E of f.extensions)this.J(this.L(E.identifier,E.version),f.profileLocation)}async C(f){const E=[],y=[];for(const w of f.extensions){const h=this.L(w.identifier,w.version);f.error?this.I(h,f.profileLocation):(this.J(h,f.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),y.push(this.f.scanInstalledExtensionAtLocation(w.location).then(c=>{c?E.push(c):this.r.info("Extension not found at the location",w.location.toString())},c=>this.r.error(c)))))}try{await Promise.all(y),E.length&&await this.H(E)}catch(w){this.r.error(w)}}D(f){for(const E of this.h.profiles)f.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F(f){const E=[],y=[],w=await this.j.scanProfileExtensions(f),h=new Set,c=new Set;for(const[p,g]of this.b)g.has(f)&&c.add(p);for(const p of w){const g=this.L(p.identifier,p.version);h.add(g),c.has(g)||(E.push(p.identifier),this.I(g,f))}for(const p of c)if(!h.has(p)){const g=this.M(p);g&&(y.push(g.identifier),this.J(p,f))}(E.length||y.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:f}:void 0,removed:y.length?{extensions:y,profileLocation:f}:void 0})}async G(f){const E=await this.j.scanProfileExtensions(f);for(const y of E)this.I(this.L(y.identifier,y.version),f)}async H(f){f||(f=(await this.f.scanAllUserInstalledExtensions()).filter(y=>!this.b.has(this.L(y.identifier,y.manifest.version)))),f.length&&await this.f.markAsUninstalled(...f)}I(f,E){let y=this.b.get(f);y||this.b.set(f,y=new j.$Cc(w=>this.m.extUri.getComparisonKey(w))),y.add(E)}J(f,E){const y=this.b.get(f);y&&y.delete(E),y?.size||this.b.delete(f)}L(f,E){return`${O.$Rm.toKey(f.id)}@${E}`}M(f){const[E,y]=(0,A.$wp)(f);return y?{identifier:{id:E},version:y}:void 0}}e.$Cq=I}),define(ae[233],ce([0,1,45,49]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=j;async function j(A,O,I,C,f,E,y){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,N.$mp)(O,I)&&(0,N.$op)(C)===3){const h=await(0,D.$7p)(I,f,E);w["X-Market-User-Id"]=h,w["VSCode-SessionId"]=y.machineId||h}return w}}),define(ae[234],ce([0,1,73,17,6,2,23,14,31,16,29,33,9,75,8]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;let p=class extends h.$Sr{constructor(m,d,$,t){super($),this.h=m,this.j=t,this.g=this.B(new g(d,t)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(m,d){const t=(await this.g.getLanguagePacks())[d];if(!t){this.j.warn(`No language pack found for ${d}`);return}const r=t.translations[m];return r?c.URI.file(r):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),d=Object.keys(m).map($=>{const t=m[$];return{...this.f($,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return d.push(this.f("en","English")),d.sort(($,t)=>$.label.localeCompare(t.label)),d}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const d=await this.g.getLanguagePacks();Object.keys(d).some($=>d[$]&&d[$].extensions.some(t=>(0,y.$up)(t.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),$=await this.g.update(d);return!(0,N.$ub)(Object.keys(m),Object.keys($))}};e.$Tr=p,e.$Tr=p=Ee([Q(0,E.$9o),Q(1,f.$Ei),Q(2,E.$6o),Q(3,w.$3j)],p);let g=class extends A.$Vc{constructor(m,d){super(),this.j=d,this.c={},this.f=(0,I.$kc)(m.userDataPath,"languagepacks.json"),this.g=new j.$Dh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(d=>{Object.keys(d).forEach($=>delete d[$]),this.m(d,...m)}).then(()=>this.c)}m(m,...d){for(const $ of d)$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&this.n(m,$);Object.keys(m).forEach($=>this.r(m[$]))}n(m,d){const $=d.identifier,t=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const r of t)if(d.location.scheme===O.Schemas.file&&l(r)){let n=m[r.languageId];n||(n={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=n);const s=n.extensions.filter(i=>(0,y.$up)(i.extensionIdentifier,$))[0];s?s.version=d.manifest.version:n.extensions.push({extensionIdentifier:$,version:d.manifest.version});for(const i of r.translations)n.translations[i.id]=(0,I.$kc)(d.location.fsPath,i.path)}}r(m){if(m){const d=(0,D.createHash)("md5");for(const $ of m.extensions)d.update($.extensionIdentifier.uuid||$.extensionIdentifier.id).update($.version);m.hash=d.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let d=null;return C.Promises.readFile(this.f,"utf8").then(void 0,$=>$.code==="ENOENT"?Promise.resolve("{}"):Promise.reject($)).then($=>{try{return JSON.parse($)}catch{return{}}}).then($=>(d=m($),$)).then($=>{for(const r of Object.keys($))$[r]||delete $[r];this.c=$,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),C.Promises.writeFile(this.f,t)}).then(()=>d,$=>this.j.error($))})}};g=Ee([Q(0,f.$Ei),Q(1,w.$3j)],g);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const m of u.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ae[235],ce([0,1,143,7,30,49]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BQ=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function C(E,y,w){const h=await(0,D.$1D)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,D.$1D)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new h.AppInsightsCore,g=new c.PostChannel,l={instrumentationKey:E,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(w){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:w};l.extensionConfig[g.identifier]=u}return p.initialize(l,[]),p.addTelemetryInitializer(u=>{u.ext=u.ext??{},u.ext.web=u.ext.web??{},u.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',y&&(u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),p}class f{constructor(y,w,h,c,p){this.e=y,this.f=w,this.g=h,this.h=p,this.c=O,this.d=I,this.g||(this.g={}),typeof c=="function"?this.a=c():this.a=c,this.b=null}i(y){if(this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=C(this.a,this.e,this.h)),this.b.then(w=>{y(w)},w=>{(0,N.$1)(w),console.error(w)})}}log(y,w){if(!this.a)return;w=(0,j.$6n)(w,this.g),w=(0,A.$pp)(w);const h=this.f+"/"+y;try{this.i(c=>{c.pluginVersionString=w?.properties.version??"Unknown",c.track({name:h,baseData:{name:h,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.$BQ=f}),define(ae[109],ce([0,1,2,172,16,9,24,49]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iac=void 0;let C=class extends D.$Vc{constructor(E,y,w,h,c=""){super(),this.b=c;const p=y.getLogger(I.$jp);if(p)this.a=this.B(p);else{const l=(0,I.$np)(h,w)?" (Not Sent)":"",u=()=>(0,I.$mp)(h,w)&&E.getLevel()===A.LogLevel.Trace;this.a=this.B(y.createLogger(I.$jp,{name:(0,N.localize)(0,null,l),hidden:!u()})),this.B(E.onDidChangeLogLevel(()=>y.setVisibility(I.$jp,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(E,y){this.a.trace(`${this.b}telemetry/${E}`,(0,I.$pp)(y))}};e.$iac=C,e.$iac=C=Ee([Q(0,A.$3j),Q(1,A.$4j),Q(2,j.$Di),Q(3,O.$jk)],C)}),define(ae[110],ce([0,1,2,30,5,27,173,21,47,100,24,43,22,49]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;let c=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,m){this.k=u,this.l=m,this.d={},this.i=new D.$Uc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,A.$af)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$af)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(w.$0l)||d.affectsConfiguration(w.$_l)||d.affectsConfiguration(w.$$l))&&this.m()}))}setExperimentProperty(l,u){this.d[l]=u}m(){let l=(0,h.$op)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const m=u.usage?3:u.error?2:0;l=Math.min(l,m)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,u,m){this.g<u||(m=(0,N.$6n)(m,this.d),m=(0,h.$tp)(m,this.j),m=(0,N.$6n)(m,this.c),this.b.forEach(d=>d.log(l,m)))}publicLog(l,u){this.n(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this.h&&this.n(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.$Zr=c,e.$Zr=c=Ee([Q(1,I.$3i),Q(2,E.$jk)],c);function p(){const g=(0,O.localize)(0,null,f.default.nameLong),l=f.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=j.$o?"":(0,O.localize)(3,null),m=(0,O.localize)(4,null),d=(0,O.localize)(5,null),$=(0,O.localize)(6,null),t=(0,O.localize)(7,null),r=`
|       | ${m} | ${d} | ${$} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${g} ${l} ${u}

&nbsp;

${t}
${r}

&nbsp;

${n}
`}y.$co.as(C.$ho.Configuration).registerConfiguration({id:w.$9l,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[w.$0l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$co.as(C.$ho.Configuration).registerConfiguration({id:w.$9l,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[w.$_l]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,O.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,O.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${w.$0l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[236],ce([0,1,15,26,278,235]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CQ=void 0;async function O(E,y){const w=await y.request(E,N.CancellationToken.None),h=(await(0,D.$Se)(w.stream)).toString(),c=w.res.statusCode??200;return{headers:w.res.headers,statusCode:c,responseData:h}}async function I(E){const y={method:E.type,headers:E.headers};return new Promise((h,c)=>{const p=j.request(E.url??"",y,g=>{g.on("data",function(l){h({headers:g.headers,statusCode:g.statusCode??200,responseData:l.toString()})}),g.on("error",function(l){c(l)})});p.write(E.data,g=>{g&&c(g)}),p.end()})}async function C(E,y,w){const h=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),c={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:h};try{const p=E?await O(c,E):await I(c);w(p.statusCode,p.headers,p.responseData)}catch{w(0,{})}}class f extends A.$BQ{constructor(y,w,h,c,p){const g={sendPOST:(l,u)=>{C(y,l,u)}};super(w,h,c,p,g)}}e.$CQ=f}),define(ae[237],ce([0,1,23,92,21,16,9,24,22,108,109,110]),function(ne,e,D,N,j,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;let w=class{constructor(c,p,g,l,u,m){this.b=c,this.c=p,this.d=g,this.e=l,this.f=u,this.g=m,this.a=new Map}h(c){if(!this.a.has(c.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const g=[c.id,JSON.stringify(p),c.aiKey],u=new N.$1q(D.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),m=[new f.$Xcc(u),new E.$iac(this.d,this.e,this.f,this.g,`[${c.id}] `)];this.a.set(c.id,new y.$Zr({appenders:m,sendErrorTelemetry:c.sendErrorTelemetry},this.b,this.g))}return this.a.get(c.id)}publicLog(c,p,g){this.h(c).publicLog(p,g)}publicLogError(c,p,g){this.h(c).publicLogError(p,g)}};e.$fec=w,e.$fec=w=Ee([Q(0,j.$3i),Q(1,C.$2l),Q(2,O.$3j),Q(3,O.$4j),Q(4,A.$Di),Q(5,I.$jk)],w)}),define(ae[78],ce([0,1,3,8,21,4,9]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=e.$jw=e.$hw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$dw=e.$cw=void 0,e.$ew=f,e.$fw=y,e.$gw=w,e.$iw=h,e.$kw=c,e.$lw=p,e.$cw=(0,A.$wi)("tunnelService"),e.$dw=(0,A.$wi)("sharedTunnelsService");var I;(function(u){u.Http="http",u.Https="https"})(I||(e.TunnelProtocol=I={}));var C;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(C||(e.TunnelPrivacyId=C={}));function f(u){return!!u.forwardPort}var E;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function y(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(m)return{address:m[1],port:+m[2]}}function w(u){if(u.scheme!=="http"&&u.scheme!=="https"||!u.query)return;const m=u.query.split("&");for(const d of m){const $=d.split("=")[1];if(/^https?:/.exec($)){const t=y(N.URI.parse($));if(t)return t}}}e.$hw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function h(u){return e.$hw.indexOf(u)>=0}e.$jw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(u){return e.$jw.indexOf(u)>=0}function p(u,m,d,$){if(d===1)return!1;if(d===2&&c(m)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(t?.length===4&&parseInt(t[1])>=18)return!1}return u<1024}class g{constructor(m,d,$){this.remoteAddress=m,this.localAddress=d,this.b=$,this.a=new D.$ee,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mw=g;let l=class{constructor(m,d){this.k=m,this.l=d,this.a=new D.$ee,this.onTunnelOpened=this.a.event,this.b=new D.$ee,this.onTunnelClosed=this.b.event,this.c=new D.$ee,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const m=this.l.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this.f=m,m?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this.g=m.elevation,this.i=m.privacyOptions,this.h=m.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const m=[],d=Array.from(this.e.values());for(const $ of d){const t=Array.from($.values());for(const r of t){const n=await r.value;n&&typeof n!="string"&&m.push(n)}}return m}async dispose(){for(const m of this.e.values()){for(const{value:d}of m.values())await d.then($=>typeof $!="string"?$?.dispose():void 0);m.clear()}this.e.clear()}setEnvironmentTunnel(m,d,$,t,r){this.q(m,d,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:d,localAddress:$,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,d){(c(m)||h(m))&&(m=e.$hw[0]);const $=this.s(m,d);if($)return++$.refcount,$.value}openTunnel(m,d,$,t,r,n=!1,s,i){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${$} on local port ${r}.`);const o=this.f??m;if(!o)return;if(d||(d="localhost"),t||(t=this.m),this.f&&this.j.has($)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(o,d,$,t,r,n,s,i);return a?a.then(b=>{if(b){if(typeof b=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,$),b}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,$);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.o(b);return(b.tunnelRemoteHost!==d||b.tunnelRemotePort!==$)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&b.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const d=this.e.get(m.tunnelRemoteHost);if(d){const $=d.get(m.tunnelRemotePort);$&&($.refcount--,await this.p(m.tunnelRemoteHost,m.tunnelRemotePort,$))}}}}async p(m,d,$){if($.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${d}.`);const t=$.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(m)&&this.e.get(m).delete(d),t}}async closeTunnel(m,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${d} `);const $=this.e.get(m);if($&&$.has(d)){const t=$.get(d);t.refcount=0,await this.p(m,d,t)}}q(m,d,$){this.e.has(m)||this.e.set(m,new Map),this.e.get(m).set(d,{refcount:1,value:$})}async r(m,d){const $=this.e.get(m);if($){const t=$.get(d),r=t?await t.value:void 0;(!r||typeof r=="string")&&$.delete(d),$.size===0&&this.e.delete(m)}}s(m,d){const $=[m];h(m)?($.push(...e.$hw),$.push(...e.$jw)):c(m)&&$.push(...e.$jw);const t=$.map(r=>this.e.get(r));for(const r of t){const n=r?.get(d);if(n)return n}}canTunnel(m){return!!y(m)}u(m,d,$,t,r,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${$} on local port ${t}.`);const i=$;this.j.add(i);const o=t===void 0?$:t,a={elevationRequired:r?this.isPortPrivileged(o):!1},b={remoteAddress:{host:d,port:$},localAddressPort:t,privacy:n,public:n?n!==C.Private:void 0,protocol:s},k=m.forwardPort(b,a);return k?(this.q(d,$,k),k.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(i)})):this.j.delete(i),k}};e.$nw=l,e.$nw=l=Ee([Q(0,O.$3j),Q(1,j.$3i)],l)}),define(ae[238],ce([0,1,9,78,2,7,6]),function(ne,e,D,N,j,A,O){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;class C extends j.$Vc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$Th),this.b.p)}setAddress(y){this.a=y,this.b&&(this.b.complete(y),this.b=null)}setTunnel(y){this.B(y)}}let f=class extends j.$Vc{static{I=this}static{this.a=0}constructor(y,w){super(),this.f=y,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(y=>y.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(y,w,h,c,p,g,l){const u=new C,m=await Promise.resolve(this.f.openTunnel(y,u,h,c,p,g,l));if(!m||typeof m=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${c} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),u.dispose(),await m.dispose(),(0,A.$6)();return u.setTunnel(m),this.b.set(w,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${m.localAddress} (local) to ${h}:${c} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(y,w){const h=this.b.get(y);h&&h.setAddress(w)}async destroyTunnel(y){const w=this.b.get(y);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${y}.`),this.b.delete(y),await w.dispose();return}this.c.add(y)}};e.$pec=f,e.$pec=f=I=Ee([Q(0,N.$dw),Q(1,D.$3j)],f)}),define(ae[28],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,D.$wi)("IUriIdentityService")}),define(ae[239],ce([0,1,28,191,12,20,128,3,2]),function(ne,e,D,N,j,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;class f{static{this._clock=0}constructor(w){this.uri=w,this.time=f._clock++}touch(){return this.time=f._clock++,this}}let E=class{constructor(w){this.g=w,this.c=new C.$Uc,this.f=2**16;const h=new Map,c=p=>{let g=h.get(p.scheme);return g===void 0&&(g=w.hasProvider(p)&&!this.g.hasCapability(p,1024),h.set(p.scheme,g)),g};this.c.add(I.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(p=>{h.delete(p.scheme)})),this.extUri=new A.$Yg(c),this.d=new O.$zs((p,g)=>this.extUri.compare(p,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,A.$$g)(w));const h=this.d.get(w);return h?h.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new f(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((c,p)=>c[1].time<p[1].time?1:c[1].time>p[1].time?-1:0);f._clock=0,this.d.clear();const h=this.f*.5;for(let c=0;c<h;c++)this.d.set(w[c][0],w[c][1].touch())}};e.$As=E,e.$As=E=Ee([Q(0,j.$3k)],E),(0,N.$xs)(D.$Al,E,1)}),define(ae[240],ce([0,1,3,2,12,51,34]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class I extends N.$Vc{constructor(f,E,y,w,h,c){super(),this.f=f,this.g=E,this.h=y,this.j=w,this.m=h,this.n=c,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$ee),this.onDidChangeFile=this.a.event,this.b=A.$Ci.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Cc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(w.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const f of this.j.profiles)this.c.add(f.settingsResource),this.c.add(f.keybindingsResource),this.c.add(f.tasksResource),this.c.add(f.extensionsResource)}open(f,E){return this.g.open(this.t(f),E)}close(f){return this.g.close(f)}read(f,E,y,w,h){return this.g.read(f,E,y,w,h)}write(f,E,y,w,h){return this.g.write(f,E,y,w,h)}watch(f,E){this.b.set(f,f);const y=this.g.watch(this.t(f),E);return(0,N.$Tc)(()=>{this.b.delete(f),y.dispose()})}stat(f){return this.g.stat(this.t(f))}mkdir(f){return this.g.mkdir(this.t(f))}rename(f,E,y){return this.g.rename(this.t(f),this.t(E),y)}readFile(f,E){return this.g.readFile(this.t(f),E)}readFileStream(f,E,y){return this.g.readFileStream(this.t(f),E,y)}readdir(f){return this.g.readdir(this.t(f))}enforceAtomicReadFile(f){return this.c.has(f)}writeFile(f,E,y){return this.g.writeFile(this.t(f),E,y)}enforceAtomicWriteFile(f){return this.c.has(f)?{postfix:".vsctmp"}:!1}delete(f,E){return this.g.delete(this.t(f),E)}copy(f,E,y){if((0,j.$7k)(this.g))return this.g.copy(this.t(f),this.t(E),y);throw new Error("copy not supported")}cloneFile(f,E){if((0,j.$8k)(this.g))return this.g.cloneFile(this.t(f),this.t(E));throw new Error("clone not supported")}s(f){const E=[];for(const y of f){if(y.resource.scheme!==this.f)continue;const w=this.u(y.resource);this.b.findSubstr(w)&&E.push({resource:w,type:y.type,cId:y.cId})}E.length&&(this.n.debug("User data changed"),this.a.fire(E))}t(f){return f.with({scheme:this.f})}u(f){return f.with({scheme:this.h})}}e.$Kdc=I}),define(ae[79],ce([0,1,62]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=N,e.$lKb=j,e.$mKb=A;function N(O,I,C,f){const E=(0,D.$Yn)(O,I,C,f)[0];return E&&(O=O.substring(0,E.offset)+E.content+O.substring(E.offset+E.length)),O}function j(O,I,C){let f=C;for(;f>=0;){if(O.charAt(f)===I.charAt(I.length-1)&&I.length===1)return f+1;if(f--,I.length===2&&f>=0&&O.charAt(f)===I.charAt(0))return f+2}return 0}function A(O,I,C){let f=C;for(;f>=0;)if(O.charAt(f)===I.charAt(I.length-1)&&I.length===1||(f++,I.length===2&&f>=0&&O.charAt(f)===I.charAt(1)))return f;return O.length-1}}),define(ae[241],ce([0,1,30,55,13]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=A;function A(h,c,p,g,l,u){const m=[],d=[],$=[];if(!c){const q=h.filter(({identifier:Y})=>l.every(H=>H.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:m,removed:d,updated:$},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}h=h.map(y),c=c.map(y),p=p?p.map(y):null;const t=new Map,r=q=>{q.uuid&&t.set(q.id.toLowerCase(),q.uuid)};h.forEach(({identifier:q})=>r(q)),c.forEach(({identifier:q})=>r(q)),p?.forEach(({identifier:q})=>r(q)),g?.forEach(({identifier:q})=>r(q)),u?.forEach(q=>r(q));const n=q=>{const Y=q.identifier.uuid||t.get(q.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${q.identifier.id.toLowerCase()}`},s=(q,Y)=>(q.set(n(Y),Y),q),i=h.reduce(s,new Map),o=c.reduce(s,new Map),a=c.reduce((q,Y)=>s(q,(0,D.$3n)(Y)),new Map),b=p?p.reduce(s,new Map):null,k=g.reduce(s,new Map),v=l.reduce((q,Y)=>{const H=t.get(Y.toLowerCase());return q.add(H?`uuid:${H}`:`id:${Y.toLowerCase()}`)},new Set),S=u?u.reduce((q,{id:Y,uuid:H})=>(H=H??t.get(Y.toLowerCase()),q.add(H?`uuid:${H}`:`id:${Y.toLowerCase()}`)),new Set):null,P=O(i,o,v,!1);if(P.added.size>0||P.removed.size>0||P.updated.size>0){const q=O(b,i,v,!1),Y=O(b,o,v,!0),H=(X,W,J,G)=>{let B,ie,re;return W.installed?(B=G.pinned,re=G.preRelease,B&&(ie=G.version)):(B=J.pinned,re=J.preRelease,B&&(ie=J.version)),B===void 0&&(B=W.pinned,B&&(ie=W.version)),re===void 0&&(re=W.preRelease),{...G,installed:W.installed||J.installed,pinned:B,preRelease:re,version:ie??(J.version&&(!W.installed||N.gt(J.version,W.version))?J.version:W.version),state:C(W,J,b?.get(X))}};for(const X of Y.removed.values()){const W=i.get(X);if(!W)continue;const J=(0,j.$hg)(b?.get(X)),G=S&&!S.has(X)&&J.installed;W.installed&&G?d.push(W.identifier):a.set(X,W)}for(const X of Y.added.values()){const W=(0,j.$hg)(o.get(X)),J=i.get(X);if(J){if(P.updated.has(X)){const G=H(X,J,W,W);I(J,W,!1,!1)||$.push(w(G,X)),a.set(X,G)}}else W.installed&&m.push(w(W,X))}for(const X of Y.updated.values()){const W=(0,j.$hg)(o.get(X)),J=(0,j.$hg)(b?.get(X)),G=i.get(X);if(G)if(S&&!S.has(X)&&J.installed&&G.installed&&!W.installed)d.push(G.identifier);else{const ie=H(X,G,W,W);$.push(w(ie,X)),a.set(X,ie)}else W.installed&&m.push(w(W,X))}for(const X of q.added.values())Y.added.has(X)||a.set(X,(0,j.$hg)(i.get(X)));for(const X of q.updated.values()){if(Y.removed.has(X)||Y.updated.has(X))continue;const W=(0,j.$hg)(i.get(X)),J=(0,j.$hg)(o.get(X));a.set(X,H(X,W,J,W))}for(const X of q.removed.values())Y.updated.has(X)||Y.removed.has(X)||k.has(X)||(0,j.$hg)(o.get(X)).installed&&S&&(S.has(X)||!(0,j.$hg)(b?.get(X)).installed||a.delete(X))}const R=[],M=O(o,a,new Set,!0),F=M.added.size>0||M.updated.size>0||M.removed.size>0;return F&&a.forEach((q,Y)=>R.push(w(q,Y))),{local:{added:m,removed:d,updated:$},remote:F?{added:[...M.added].map(q=>a.get(q)),updated:[...M.updated].map(q=>a.get(q)),removed:[...M.removed].map(q=>o.get(q)),all:R}:null}}function O(h,c,p,g){const l=h?[...h.keys()].filter(t=>!p.has(t)):[],u=[...c.keys()].filter(t=>!p.has(t)),m=u.filter(t=>!l.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),d=l.filter(t=>!u.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),$=new Set;for(const t of l){if(d.has(t))continue;const r=h.get(t),n=c.get(t);(!n||!I(r,n,g,!0))&&$.add(t)}return{added:m,removed:d,updated:$}}function I(h,c,p,g){return!(h.disabled!==c.disabled||!!h.isApplicationScoped!=!!c.isApplicationScoped||g&&h.installed!==c.installed||h.installed&&c.installed&&(h.preRelease!==c.preRelease||h.pinned!==c.pinned||c.pinned&&h.version!==c.version)||!E(h.state,c.state)||p&&h.version!==c.version)}function C(h,c,p){const g=h.state,l=c.state,u=p?.state;if(!c.version||g&&N.gt(h.version,c.version))return g;if(l&&N.gt(c.version,h.version)||!g)return l;if(!l)return g;const m=(0,D.$3n)(g),d=u?f(u,l):{added:Object.keys(l).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set},$=u?f(u,g):{added:Object.keys(g).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set};for(const t of[...d.added.values(),...d.updated.values()])m[t]=l[t];for(const t of d.removed.values())$.updated.has(t)||delete m[t];return m}function f(h,c){const p=Object.keys(h),g=Object.keys(c),l=g.filter(d=>!p.includes(d)).reduce((d,$)=>(d.add($),d),new Set),u=p.filter(d=>!g.includes(d)).reduce((d,$)=>(d.add($),d),new Set),m=new Set;for(const d of p){if(u.has(d))continue;const $=h[d],t=c[d];(0,D.$7n)($,t)||m.add(d)}return{added:l,removed:u,updated:m}}function E(h={},c={}){const{added:p,removed:g,updated:l}=f(h,c);return p.size===0&&g.size===0&&l.size===0}function y(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function w(h,c){const p={...h,identifier:{id:h.identifier.id,uuid:c.startsWith("uuid:")?c.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete p.disabled,h.installed||delete p.installed,h.state||delete p.state,h.isApplicationScoped||delete p.isApplicationScoped,p}}),define(ae[111],ce([0,1,17,21,4]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uMb=e.$tMb=void 0,e.$tMb=(0,j.$wi)("IIgnoredExtensionsManagementService");let A=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,C){let f=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return f=f.filter(E=>E!==I&&E!==`-${I}`),C&&f.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}updateSynchronizedExtensions(I,C){let f=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return f=f.filter(E=>E!==I&&E!==`-${I}`),C&&f.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}getIgnoredExtensions(I){const C=I.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),f=this.b().map(w=>w.toLowerCase()),E=[],y=[];if(Array.isArray(f))for(const w of f)w.startsWith("-")?y.push(w.substring(1)):E.push(w);return(0,D.$Mb)([...C,...E].filter(w=>!y.includes(w)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};e.$uMb=A,e.$uMb=A=Ee([Q(0,N.$3i)],A)}),define(ae[242],ce([0,1,17,35,30,93,79]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=C;function I(d){return(0,N.$Jn)(d)||[]}async function C(d,$,t,r,n){const s=I(d),i=I($),o=t?I(t):null,a=[...s,...i,...o||[]].map(H=>H.key),b=await n.resolveUserBindings(a),k=E(s,i,o,b);if(!k.hasLocalForwarded&&!k.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!k.hasLocalForwarded&&k.hasRemoteForwarded)return{mergeContent:$,hasChanges:!0,hasConflicts:!1};if(k.hasLocalForwarded&&!k.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const v=w(s),S=w(i),P=o?w(o):null,R=c(v,S,b),M=P?c(P,v,b):{added:[...v.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},F=P?c(P,S,b):{added:[...S.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},q=f(R,M,F);let Y=d;for(const H of q.removed.values())q.conflicts.has(H)||(Y=u(Y,H,r));for(const H of q.added.values()){if(q.conflicts.has(H))continue;const X=S.get(H);if(X.some(W=>W.command!==`-${H}`&&k.conflicts.has(b[W.key]))){q.conflicts.add(H);continue}Y=l(Y,X,r)}for(const H of q.updated.values()){if(q.conflicts.has(H))continue;const X=S.get(H);if(X.some(W=>W.command!==`-${H}`&&k.conflicts.has(b[W.key]))){q.conflicts.add(H);continue}Y=m(Y,H,X,r)}return{mergeContent:Y,hasChanges:!0,hasConflicts:q.conflicts.size>0}}function f(d,$,t){const r=new Set,n=new Set,s=new Set,i=new Set;for(const o of $.removed.values())t.updated.has(o)&&i.add(o);for(const o of t.removed.values())i.has(o)||($.updated.has(o)?i.add(o):n.add(o));for(const o of $.added.values())i.has(o)||t.added.has(o)&&d.updated.has(o)&&i.add(o);for(const o of t.added.values())i.has(o)||($.added.has(o)?d.updated.has(o)&&i.add(o):r.add(o));for(const o of $.updated.values())i.has(o)||t.updated.has(o)&&d.updated.has(o)&&i.add(o);for(const o of t.updated.values())i.has(o)||($.updated.has(o)?d.updated.has(o)&&i.add(o):s.add(o));return{added:r,removed:n,updated:s,conflicts:i}}function E(d,$,t,r){const n=new Set,s=y(d,r),i=y($,r),o=t?y(t,r):null,a=h(s,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const b=o?h(o,s):{added:[...s.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const k=o?h(o,i):{added:[...i.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set};if(k.added.size===0&&k.removed.size===0&&k.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:v,removed:S,updated:P,conflicts:R}=f(a,b,k);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:v,removed:S,updated:P,conflicts:R}}function y(d,$){const t=new Map;for(const r of d){const n=$[r.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(r)}return t}function w(d){const $=new Map;for(const t of d){const r=t.command[0]==="-"?t.command.substring(1):t.command;let n=$.get(r);n||(n=[],$.set(r,n)),n.push(t)}return $}function h(d,$){const t=[...d.keys()],r=[...$.keys()],n=r.filter(o=>!t.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),s=t.filter(o=>!r.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),i=new Set;for(const o of t){if(s.has(o))continue;const a=d.get(o).map(k=>({...k,key:o})),b=$.get(o).map(k=>({...k,key:o}));(0,D.$ub)(a,b,(k,v)=>g(k,v))||i.add(o)}return{added:n,removed:s,updated:i}}function c(d,$,t){const r=[...d.keys()],n=[...$.keys()],s=n.filter(a=>!r.includes(a)).reduce((a,b)=>(a.add(b),a),new Set),i=r.filter(a=>!n.includes(a)).reduce((a,b)=>(a.add(b),a),new Set),o=new Set;for(const a of r){if(i.has(a))continue;const b=d.get(a).map(v=>({...v,key:t[v.key]})),k=$.get(a).map(v=>({...v,key:t[v.key]}));p(b,k)||o.add(a)}return{added:s,removed:i,updated:o}}function p(d,$){return!(!(0,D.$ub)(d.filter(({command:t})=>t[0]!=="-"),$.filter(({command:t})=>t[0]!=="-"),(t,r)=>g(t,r))||!(0,D.$ub)(d.filter(({command:t})=>t[0]==="-"),$.filter(({command:t})=>t[0]==="-"),(t,r)=>g(t,r)))}function g(d,$){if(d.command!==$.command||d.key!==$.key)return!1;const t=A.$uj.deserialize(d.when),r=A.$uj.deserialize($.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!j.$7n(d.args,$.args))}function l(d,$,t){for(const r of $)d=O.edit(d,[-1],r,t);return d}function u(d,$,t){const r=I(d);for(let n=r.length-1;n>=0;n--)(r[n].command===$||r[n].command===`-${$}`)&&(d=O.edit(d,[n],void 0,t));return d}function m(d,$,t,r){const n=I(d),s=n.findIndex(i=>i.command===$||i.command===`-${$}`);for(let i=n.length-1;i>=0;i--)(n[i].command===$||n[i].command===`-${$}`)&&(d=O.edit(d,[i],void 0,r));for(let i=t.length-1;i>=0;i--)d=O.edit(d,[s],t[i],r);return d}}),define(ae[243],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=D,e.$a_b=j;function D(A,O,I){const C={},f={},E=new Set;if(!O)return{local:{added:C,updated:f,removed:[...E.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const y=N(A,O);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:C,updated:f,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=N(I,A),h=N(I,O),c={},p={},g=new Set,l=new Set;for(const u of w.removed.values())h.updated.has(u)?C[u]=O[u]:g.add(u);for(const u of h.removed.values())l.has(u)||(w.updated.has(u)?l.add(u):E.add(u));for(const u of w.updated.values())l.has(u)||(h.updated.has(u)?y.updated.has(u)&&l.add(u):p[u]=A[u]);for(const u of h.updated.values())l.has(u)||(w.updated.has(u)?y.updated.has(u)&&l.add(u):A[u]!==void 0&&(f[u]=O[u]));for(const u of w.added.values())l.has(u)||(h.added.has(u)?y.updated.has(u)&&l.add(u):c[u]=A[u]);for(const u of h.added.values())l.has(u)||(w.added.has(u)?y.updated.has(u)&&l.add(u):C[u]=O[u]);return{local:{added:C,removed:[...E.values()],updated:f},remote:{added:c,removed:[...g.values()],updated:p},conflicts:[...l.values()]}}function N(A,O){const I=A?Object.keys(A):[],C=O?Object.keys(O):[],f=C.filter(w=>!I.includes(w)).reduce((w,h)=>(w.add(h),w),new Set),E=I.filter(w=>!C.includes(w)).reduce((w,h)=>(w.add(h),w),new Set),y=new Set;for(const w of I){if(E.has(w))continue;const h=A[w],c=O[w];h!==c&&y.add(w)}return{added:f,removed:E,updated:y}}function j(A,O){const{added:I,removed:C,updated:f}=N(A,O);return I.size===0&&C.size===0&&f.size===0}}),define(ae[244],ce([0,1,30]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=N;function N(A,O,I,C){const f={added:[],removed:[],updated:[]};let E={added:[],removed:[],updated:[]};if(!O){const w=A.filter(({id:h})=>!C.includes(h));return w.length?E.added=w:E=null,{local:f,remote:E}}const y=j(A,O,C);if(y.added.length>0||y.removed.length>0||y.updated.length>0){const w=j(I,A,C),h=j(I,O,C);for(const c of h.removed){const p=A.find(g=>g.id===c);p&&f.removed.push(p)}for(const c of h.added){const p=O.find(g=>g.id===c);w.added.includes(c)?y.updated.includes(c)&&f.updated.push(p):f.added.push(p)}for(const c of h.updated)f.updated.push(O.find(p=>p.id===c));for(const c of w.added)h.added.includes(c)||E.added.push(A.find(p=>p.id===c));for(const c of w.updated)h.removed.includes(c)||h.updated.includes(c)||E.updated.push(A.find(p=>p.id===c));for(const c of w.removed){const p=O.find(g=>g.id===c);p&&E.removed.push(p)}}return E.added.length===0&&E.removed.length===0&&E.updated.length===0&&(E=null),{local:f,remote:E}}function j(A,O,I){A=A?A.filter(({id:h})=>!I.includes(h)):[],O=O.filter(({id:h})=>!I.includes(h));const C=A.map(({id:h})=>h),f=O.map(({id:h})=>h),E=f.filter(h=>!C.includes(h)),y=C.filter(h=>!f.includes(h)),w=[];for(const{id:h,name:c,shortName:p,icon:g,useDefaultFlags:l}of A){if(y.includes(h))continue;const u=O.find(m=>m.id===h);(!u||u.name!==c||u.shortName!==p||u.icon!==g||!(0,D.$7n)(u.useDefaultFlags,l))&&w.push(h)}return{added:E,removed:y,updated:w}}}),define(ae[25],ce([0,1,17,13,179,47,29,4,101,43]),function(ne,e,D,N,j,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llb=e.$klb=e.$jlb=e.$ilb=e.$hlb=e.$glb=e.$flb=e.$elb=e.$dlb=e.$blb=e.MergeState=e.Change=e.SyncStatus=e.$alb=e.$_kb=e.$$kb=e.UserDataSyncErrorCode=e.$9kb=e.$8kb=e.$7kb=e.$6kb=e.$5kb=e.$2kb=e.SyncResource=e.$Ykb=e.$Xkb=void 0,e.$Vkb=E,e.$Wkb=y,e.$Zkb=w,e.$1kb=h,e.$3kb=p,e.$4kb=g,e.$0kb=l,e.$clb=s;function E(){const i=f.$co.as(A.$ho.Configuration).getConfigurationProperties();return Object.keys(i).filter(o=>!!i[o].disallowSyncIgnore)}function y(){const i=f.$co.as(A.$ho.Configuration).getConfigurationProperties(),o=Object.keys(i).filter(k=>!!i[k].ignoreSync),a=Object.keys(i).filter(k=>i[k].scope===2||i[k].scope===6),b=E();return(0,D.$Mb)([...o,...a,...b])}e.$Xkb="settingsSync",e.$Ykb="settingsSync.keybindingsPerPlatform";function w(){const i="vscode://schemas/ignoredSettings",o=f.$co.as(A.$ho.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,j.localize)(0,null),type:"object",properties:{[e.$Ykb]:{type:"boolean",description:(0,j.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,j.localize)(2,null),items:[{type:"string",pattern:O.$To,errorMessage:(0,j.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,j.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=f.$co.as(C.$do.JSONContribution),b=()=>{const k=E(),v=y(),S=Object.keys(A.$io.properties).filter(M=>!v.includes(M)),P=v.filter(M=>!k.includes(M)),R={items:{type:"string",enum:[...S,...P.map(M=>`-${M}`)]}};a.registerSchema(i,R)};return o.onDidUpdateConfiguration(()=>b())}function h(i){return i&&(0,N.$$f)(i)&&(0,N.$9f)(i.id)&&Array.isArray(i.scopes)}var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(c||(e.SyncResource=c={})),e.$2kb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(i,...o){return i?[i,...o]:o}function g(i,o,a,b){return b.joinPath(a.userDataSyncHome,...p(i,o,`lastSync${o}.json`))}e.$5kb=(0,I.$wi)("IUserDataSyncStoreManagementService"),e.$6kb=(0,I.$wi)("IUserDataSyncStoreService"),e.$7kb=(0,I.$wi)("IUserDataSyncLocalStoreService"),e.$8kb="x-operation-id",e.$9kb="X-Execution-Id";function l(i){const o={};return o[e.$9kb]=i,o}var u;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class m extends Error{constructor(o,a,b,k){super(o),this.code=a,this.resource=b,this.operationId=k,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$$kb=m;class d extends m{constructor(o,a,b,k,v){super(o,b,void 0,v),this.url=a,this.serverCode=k}}e.$_kb=d;class $ extends m{constructor(o,a){super(o,a)}}e.$alb=$,function(i){function o(a){if(a instanceof i)return a;const b=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(b&&b[1]){const k=b[2]==="unknown"?void 0:b[2],v=b[3]==="unknown"?void 0:b[3];return new i(a.message,b[1],k,v)}return new i(a.message,"Unknown")}i.toUserDataSyncError=o}(m||(e.$$kb=m={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var r;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(r||(e.Change=r={}));var n;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(n||(e.MergeState=n={})),e.$blb="sync.store.url.type";function s(i){return`sync.enable.${i}`}e.$dlb=(0,I.$wi)("IUserDataSyncEnablementService"),e.$elb=(0,I.$wi)("IUserDataSyncService"),e.$flb=(0,I.$wi)("IUserDataSyncResourceProviderService"),e.$glb=(0,I.$wi)("IUserDataAutoSyncService"),e.$hlb=(0,I.$wi)("IUserDataSyncUtilService"),e.$ilb=(0,I.$wi)("IUserDataSyncLogService"),e.$jlb="userDataSync",e.$klb="vscode-userdata-sync",e.$llb="preview"}),define(ae[245],ce([0,1,30,25]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LLb=j;function j(O,I,C,f,E){if(!I)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const y=A(O,I);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=C?A(C,I):{added:Object.keys(I).reduce((u,m)=>(u.add(m),u),new Set),removed:new Set,updated:new Set},h=C?A(C,O):{added:Object.keys(O).reduce((u,m)=>(u.add(m),u),new Set),removed:new Set,updated:new Set},c={added:{},removed:[],updated:{}},p=D.$3n(I),g=!C;for(const u of h.added.values())u!==N.$blb&&g&&w.added.has(u)||(p[u]=O[u]);for(const u of h.updated.values())p[u]=O[u];for(const u of h.removed.values())f.unregistered.includes(u)||delete p[u];for(const u of w.added.values()){const m=I[u];if(f.machine.includes(u)){E.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(C&&h.added.has(u))continue;const d=O[u];d&&d.value===m.value||u===N.$blb&&g&&h.added.has(u)||(d?c.updated[u]=m:c.added[u]=m)}for(const u of w.updated.values()){const m=I[u];if(f.machine.includes(u)){E.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(u)||h.removed.has(u))continue;const d=O[u];d&&d.value===m.value||(c.updated[u]=m)}for(const u of w.removed.values()){if(f.machine.includes(u)){E.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}h.updated.has(u)||h.removed.has(u)||c.removed.push(u)}const l=A(I,p);return{local:c,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:p}}}function A(O,I){const C=Object.keys(O),f=Object.keys(I),E=f.filter(h=>!C.includes(h)).reduce((h,c)=>(h.add(c),h),new Set),y=C.filter(h=>!f.includes(h)).reduce((h,c)=>(h.add(c),h),new Set),w=new Set;for(const h of C){if(y.has(h))continue;const c=O[h],p=I[h];D.$7n(c,p)||w.add(h)}return{added:E,removed:y,updated:w}}}),define(ae[246],ce([0,1,17,35,62,44,30,79,25]),function(ne,e,D,N,j,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nKb=f,e.$oKb=w,e.$pKb=h,e.$qKb=c,e.$rKb=g,e.$sKb=u;function f(a,b,k){let v=[];k?v=y(k):v=E(b);const S=[],P=[...(0,C.$Vkb)()];if(Array.isArray(v))for(const R of v)R.startsWith("-")?P.push(R.substring(1)):S.push(R);return(0,D.$Mb)([...a,...S].filter(R=>!P.includes(R)))}function E(a){let b=a.inspect("settingsSync.ignoredSettings").userValue;return b!==void 0||(b=a.inspect("sync.ignoredSettings").userValue,b!==void 0)?b:a.getValue("settingsSync.ignoredSettings")||[]}function y(a){const b=(0,N.$Jn)(a);return b?b["settingsSync.ignoredSettings"]||b["sync.ignoredSettings"]||[]:[]}function w(a,b){const k=(0,N.$Jn)(a)||{};let v="{}";for(const S of Object.keys(k)){const P=(0,j.$Yn)(v,[S],k[S],b);v=(0,j.$2n)(v,P)}return v}function h(a,b,k,v){if(k.length){const S=o(b),P=(0,N.$Jn)(b)||{},R=(0,N.$Jn)(a);if(!R)return a;const M=[];for(const F of k){const q=P[F],Y=R[F];q===void 0?a=I.edit(a,[F],void 0,v):Y!==void 0?a=I.edit(a,[F],q,v):M.push(t(F,S))}M.sort((F,q)=>F.startOffset-q.startOffset),M.forEach(F=>a=u(F.setting.key,b,a,v))}return a}function c(a,b,k,v,S,P){const R=h(a,b,v,P),M=k!==R,F=k!==b;if(!M&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:null,remoteContent:R,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:h(b,a,v,P),remoteContent:null,hasConflicts:!1};if(k===null&&g(a)){const T=p(a,b,v)?null:h(b,a,v,P);return{conflictsSettings:[],localContent:T,remoteContent:null,hasConflicts:!1}}let q=a,Y=b;const H=(0,N.$Jn)(a),X=(0,N.$Jn)(b),W=k?(0,N.$Jn)(k):null,J=v.reduce((T,U)=>(T.add(U),T),new Set),G=l(H,X,J),B=l(W,H,J),ie=l(W,X,J),re=new Map,he=new Set,te=T=>{he.add(T);const U=S.filter(({key:x})=>x===T)[0];U?(q=I.edit(q,[T],U.value,P),Y=I.edit(Y,[T],U.value,P)):re.set(T,{key:T,localValue:H[T],remoteValue:X[T]})};for(const T of B.removed.values())ie.updated.has(T)?te(T):Y=I.edit(Y,[T],void 0,P);for(const T of ie.removed.values())he.has(T)||(B.updated.has(T)?te(T):q=I.edit(q,[T],void 0,P));for(const T of B.updated.values())he.has(T)||(ie.updated.has(T)?G.updated.has(T)&&te(T):Y=I.edit(Y,[T],H[T],P));for(const T of ie.updated.values())he.has(T)||(B.updated.has(T)?G.updated.has(T)&&te(T):q=I.edit(q,[T],X[T],P));for(const T of B.added.values())he.has(T)||(ie.added.has(T)?G.updated.has(T)&&te(T):Y=u(T,q,Y,P));for(const T of ie.added.values())he.has(T)||(B.added.has(T)?G.updated.has(T)&&te(T):q=u(T,Y,q,P));const V=re.size>0||!p(q,Y,v),z=V||!p(q,a,[]),L=V||!p(Y,b,[]);return{localContent:z?q:null,remoteContent:L?Y:null,conflictsSettings:[...re.values()],hasConflicts:V}}function p(a,b,k){if(a===b)return!0;const v=(0,N.$Jn)(a),S=(0,N.$Jn)(b),P=k.reduce((F,q)=>(F.add(q),F),new Set),R=o(a).filter(F=>!(F.setting&&P.has(F.setting.key))),M=o(b).filter(F=>!(F.setting&&P.has(F.setting.key)));if(R.length!==M.length)return!1;for(let F=0;F<R.length;F++){const q=R[F],Y=M[F];if(q.setting&&Y.setting){if(q.setting.key!==Y.setting.key||!O.$7n(v[q.setting.key],S[q.setting.key]))return!1}else if(!q.setting&&!Y.setting){if(q.value!==Y.value)return!1}else return!1}return!0}function g(a){return a?o(a).length===0:!0}function l(a,b,k){const v=a?Object.keys(a).filter(F=>!k.has(F)):[],S=Object.keys(b).filter(F=>!k.has(F)),P=S.filter(F=>!v.includes(F)).reduce((F,q)=>(F.add(q),F),new Set),R=v.filter(F=>!S.includes(F)).reduce((F,q)=>(F.add(q),F),new Set),M=new Set;if(a)for(const F of v){if(R.has(F))continue;const q=a[F],Y=b[F];O.$7n(q,Y)||M.add(F)}return{added:P,removed:R,updated:M}}function u(a,b,k,v){const S=(0,N.$Jn)(b),P=o(b),R=o(k),M=m(a,P,R);return d(k,a,S[a],M,R,v)}function m(a,b,k){const v=b.findIndex(P=>P.setting?.key===a),S=b[v-1];if(S){if(S.setting){const R=t(S.setting.key,k);if(R)return{index:k.indexOf(R),insertAfter:!0}}else{const R=r(v,b);if(R){const M=t(R.setting.key,k);if(M){const F=n(k.indexOf(M),k),q=s(b,R,b[v]);if(F){const Y=s(k,M,F),H=i(q,Y);return H?{index:k.indexOf(H),insertAfter:!0}:{index:k.indexOf(F),insertAfter:!1}}else{const Y=s(k,M,k[k.length-1]),H=i(q,Y);return H?{index:k.indexOf(H),insertAfter:!0}:{index:k.length-1,insertAfter:!0}}}}}const P=b[v+1];if(P)if(P.setting){const R=t(P.setting.key,k);if(R)return{index:k.indexOf(R),insertAfter:!1}}else{const R=n(v,b);if(R){const M=t(R.setting.key,k);if(M){const F=r(k.indexOf(M),k),q=s(b,b[v],R);if(F){const Y=s(k,F,M),H=i(q.reverse(),Y.reverse());return H?{index:k.indexOf(H),insertAfter:!1}:{index:k.indexOf(F),insertAfter:!0}}else{const Y=s(k,k[0],M),H=i(q.reverse(),Y.reverse());return H?{index:k.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:k.length-1,insertAfter:!0}}function d(a,b,k,v,S,P){let R;return v.index===-1?R=(0,j.$Yn)(a,[b],k,P):R=$(a,b,k,v,S,P).map(M=>(0,j.$Zn)(a,M,P)[0]),(0,j.$2n)(a,R)}function $(a,b,k,v,S,P){const R=`${JSON.stringify(b)}: ${JSON.stringify(k)}`,M=(0,A.$Vn)(P,a),F=S[v.index];if(v.insertAfter){const q=[];if(F.setting)q.push({offset:F.endOffset,length:0,content:","+R});else{const Y=n(v.index,S),H=r(v.index,S),X=H?.setting?.commaOffset;H&&X===void 0&&q.push({offset:H.endOffset,length:0,content:","});const W=X!==void 0&&X>F.endOffset;q.push({offset:W?X+1:F.endOffset,length:0,content:Y?M+R+",":M+R})}return q}else{if(F.setting)return[{offset:F.startOffset,length:0,content:R+","}];const q=(S[v.index-1]&&!S[v.index-1].setting?M:"")+R+(n(v.index,S)?",":"")+M;return[{offset:F.startOffset,length:0,content:q}]}}function t(a,b){return b.filter(k=>k.setting?.key===a)[0]}function r(a,b){for(let k=a-1;k>=0;k--)if(b[k].setting)return b[k]}function n(a,b){for(let k=a+1;k<b.length;k++)if(b[k].setting)return b[k]}function s(a,b,k){const v=a.indexOf(b),S=a.indexOf(k);return a.filter((P,R)=>v<R&&R<S)}function i(a,b){if(a.length&&b.length){let k=0;for(;k<b.length&&k<a.length;k++)if(a[k].value!==b[k].value)return b[k-1];return b[k-1]}}function o(a){const b=[];let k=-1,v,S;const P={onObjectBegin:R=>{k++},onObjectProperty:(R,M,F)=>{k===0&&(v=M,S=R)},onObjectEnd:(R,M)=>{k--,k===0&&b.push({startOffset:v,endOffset:R+M,value:a.substring(v,R+M),setting:{key:S,commaOffset:void 0}})},onArrayBegin:(R,M)=>{k++},onArrayEnd:(R,M)=>{k--,k===0&&b.push({startOffset:v,endOffset:R+M,value:a.substring(v,R+M),setting:{key:S,commaOffset:void 0}})},onLiteralValue:(R,M,F)=>{k===0&&b.push({startOffset:v,endOffset:M+F,value:a.substring(v,M+F),setting:{key:S,commaOffset:void 0}})},onSeparator:(R,M,F)=>{if(k===0&&R===","){let q=b.length-1;for(;q>=0&&!b[q].setting;q--);const Y=b[q];Y&&b.splice(q,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:M}})}},onComment:(R,M)=>{k===0&&b.push({startOffset:R,endOffset:R+M,value:a.substring(R,R+M)})}};return(0,N.$Qn)(a,P),b}}),define(ae[80],ce([0,1,3,2,4,25]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Jb=e.$8Jb=void 0,e.$8Jb=(0,j.$wi)("IUserDataSyncAccountService");let O=class extends N.$Vc{get account(){return this.a}constructor(C,f){super(),this.g=C,this.h=f,this.b=this.B(new D.$ee),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$ee),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(E=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,E),this.updateAccount(void 0),E==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};e.$9Jb=O,e.$9Jb=O=Ee([Q(0,A.$6kb),Q(1,A.$ilb)],O)}),define(ae[247],ce([0,1,20,180,16,9,25]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vMb=void 0;let I=class extends A.$8j{constructor(f,E){super(),this.g=this.B(f.createLogger((0,D.$0g)(E.logsHome,`${O.$jlb}.log`),{id:O.$jlb,name:(0,N.localize)(0,null)}))}trace(f,...E){this.g.trace(f,...E)}debug(f,...E){this.g.debug(f,...E)}info(f,...E){this.g.info(f,...E)}warn(f,...E){this.g.warn(f,...E)}error(f,...E){this.g.error(f,...E)}flush(){this.g.flush()}};e.$vMb=I,e.$vMb=I=Ee([Q(0,A.$4j),Q(1,j.$Di)],I)}),define(ae[248],ce([0,1,6,3,2]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;class A extends j.$Vc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:C,getActiveWindowId:f}){super(),this.a=this.B(new j.$Uc),N.Event.latch(N.Event.any(I,C))(this.f,this,this.a),this.b=(0,D.$jh)(()=>f()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$fdc=A}),define(ae[112],ce([0,1,183,14,51,20,8,4,23]),function(ne,e,D,N,j,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=f,e.$Hi=E,e.$Ki=y,e.$Li=w,e.$Mi=h,e.$Ni=p,e.$Oi=g,e.$Ri=m,e.$Wi=d,e.$Xi=$,e.$Zi=t,e.$1i=r,e.$2i=n,e.$Fi=(0,I.$wi)("contextService");function f(s){const i=s;return typeof i?.id=="string"&&O.URI.isUri(i.uri)}function E(s){return typeof s?.id=="string"&&!f(s)&&!w(s)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function y(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$oc)(s)}:i?e.$Ii:e.$Ji;const o=s;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function w(s){const i=s;return typeof i?.id=="string"&&O.URI.isUri(i.configPath)}function h(s){const i=s;if(i?.uri)return{id:i.id,uri:O.URI.revive(i.uri)};const o=s;if(o?.configPath)return{id:o.id,configPath:O.URI.revive(o.configPath)};if(s?.id)return{id:s.id}}var c;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(c||(e.WorkbenchState=c={}));function p(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}function g(s){const i=s;return!!(i&&typeof i=="object"&&O.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}class l{constructor(i,o,a,b,k){this.h=i,this.j=a,this.k=b,this.l=k,this.c=j.$Ci.forUris(this.l,()=>!0),this.folders=o}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=j.$Ci.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=l;class u{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,A.$0g)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=u;function m(s){return new u({uri:s,index:0,name:(0,A.$6g)(s)},{uri:s.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,D.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function d(s,i){return A.$1g.isEqualOrParent(s,i.untitledWorkspacesHome)}function $(s){let i;return O.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===C.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Yi}function r(s,i){return!d(s,i)&&!$(s)}function n(s){return(typeof s=="string"?(0,N.$pc)(s):(0,A.$8g)(s))===e.$Ti}}),define(ae[18],ce([0,1,54,3,2,20,8,174,16,12,4,9,112,34,28,6,32,27,13]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=d,e.$Dl=$,e.$El=t;var m;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function d(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&O.URI.isUri(i.location)&&O.URI.isUri(i.globalStorageHome)&&O.URI.isUri(i.settingsResource)&&O.URI.isUri(i.keybindingsResource)&&O.URI.isUri(i.tasksResource)&&O.URI.isUri(i.snippetsHome)&&O.URI.isUri(i.extensionsResource))}e.$Cl=(0,E.$wi)("IUserDataProfilesService");function $(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:i}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function t(s,i,o,a,b,k){return{id:s,name:i,location:o,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:k&&b?.useDefaultFlags?.globalState?k.globalStorageHome:(0,A.$0g)(o,"globalStorage"),settingsResource:k&&b?.useDefaultFlags?.settings?k.settingsResource:(0,A.$0g)(o,"settings.json"),keybindingsResource:k&&b?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,A.$0g)(o,"keybindings.json"),tasksResource:k&&b?.useDefaultFlags?.tasks?k.tasksResource:(0,A.$0g)(o,"tasks.json"),snippetsHome:k&&b?.useDefaultFlags?.snippets?k.snippetsHome:(0,A.$0g)(o,"snippets"),extensionsResource:k&&b?.useDefaultFlags?.extensions?k.extensionsResource:(0,A.$0g)(o,"extensions.json"),cacheHome:(0,A.$0g)(a,s),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let r=class extends j.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,o,a,b){super(),this.t=i,this.u=o,this.w=a,this.y=b,this.f=!0,this.h=this.B(new N.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),o=[i];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,u.$9f)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}o.push(t((0,A.$7g)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},i))}}catch(k){this.y.error(k)}const a=new h.$Bc,b=new Map;if(o.length)try{const k=this.Q();if(k.workspaces)for(const[v,S]of Object.entries(k.workspaces)){const P=O.URI.parse(v),R=o.find(M=>M.id===S);R&&a.set(P,R)}if(k.emptyWindows)for(const[v,S]of Object.entries(k.emptyWindows)){const P=o.find(R=>R.id===S);P&&b.set(v,P)}}catch(k){this.y.error(k)}this.z={profiles:o,workspaces:a,emptyWindows:b}}return this.z}D(){const i=t("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const o="Temp",a=new RegExp(`${(0,l.$af)(o)}\\s(\\d+)`);let b=0;for(const v of this.profiles){const S=a.exec(v.name),P=S?parseInt(S[1]):0;b=P>b?P:b}const k=`${o} ${b+1}`;return this.createProfile((0,D.$kj)((0,g.$Sg)()).toString(16),k,{transient:!0},i)}async createNamedProfile(i,o,a){return this.createProfile((0,D.$kj)((0,g.$Sg)()).toString(16),i,o,a)}async createProfile(i,o,a,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(i,o,a);return b&&await this.setProfileForWorkspace(b,k),k}async F(i,o,a){if(!(0,u.$9f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(o);return b||(b=(async()=>{try{if(this.profiles.find(P=>P.name===o||P.id===i))throw new Error(`Profile with ${o} name already exists`);const v=t(i,o,(0,A.$0g)(this.profilesHome,i),this.g,a,this.defaultProfile);await this.u.createFolder(v.location);const S=[];return this.j.fire({profile:v,join(P){S.push(P)}}),await p.Promises.settled(S),this.I([v],[],[]),v}finally{this.r.delete(o)}})(),this.r.set(o,b)),b}async updateProfile(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(b=>b.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,o.name??a.name,a.location,this.g,{shortName:o.shortName??a.shortName,icon:o.icon===null?void 0:o.icon??a.icon,transient:o.transient??a.isTransient,useDefaultFlags:o.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(b=>b.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.m.fire({profile:o,join(b){a.push(b)}});try{await Promise.allSettled(a)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(b){(0,f.$hl)(b)!==1&&this.y.error(b)}}async setProfileForWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(b=>b.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);this.L(i,a)}unsetWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.G(i);return O.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(i){return(0,w.$Gi)(i)?i.uri:(0,w.$Li)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location)))}I(i,o,a){const b=[...this.profiles,...i],k=[];this.s.profiles=[];for(let v of b)v.isDefault||o.some(S=>v.id===S.id)||(v=a.find(S=>v.id===S.id)??v,v.isTransient?this.s.profiles.push(v):k.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags}));this.P(k),this.z=void 0,this.J(i,o,a)}J(i,o,a){this.h.fire({added:i,removed:o,updated:a,all:this.profiles})}L(i,o,a){a=o?.isTransient?!0:a,a||this.L(i,void 0,!0);const b=this.G(i),k=a?this.s:this.C;O.URI.isUri(b)?(k.workspaces.delete(b),o&&k.workspaces.set(b,o)):(k.emptyWindows.delete(b),o&&k.emptyWindows.set(b,o)),a||this.M()}M(){const i={};for(const[a,b]of this.C.workspaces.entries())i[a.toString()]=b.id;const o={};for(const[a,b]of this.C.emptyWindows.entries())o[a.toString()]=b.id;this.R({workspaces:i,emptyWindows:o}),this.z=void 0}N(i){const o={},a=this.D();if(i.workspaces)for(const[k,v]of Object.entries(i.workspaces)){const S=O.URI.parse(v);o[k]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}const b={};if(i.emptyWindows)for(const[k,v]of Object.entries(i.emptyWindows)){const S=O.URI.parse(v);b[k]=this.w.extUri.isEqual(S,a.location)?a.id:this.w.extUri.basename(S)}return{workspaces:o,emptyWindows:b}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$Fl=r,e.$Fl=r=Ee([Q(0,C.$Di),Q(1,f.$3k),Q(2,c.$Al),Q(3,y.$3j)],r);class n extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$Gl=n}),define(ae[249],ce([0,1,6,2,18]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;let A=class extends N.$Vc{constructor(I){super(),this.B(new D.$Ih(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$rec=A,e.$rec=A=Ee([Q(0,j.$Cl)],A)}),define(ae[250],ce([0,1,17,6,26,7,3,2,5,13,8,156,29,33,48,9,24,22,28,18]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$lq=void 0,e.$mq=$;let d=class extends I.$Vc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,i,o,a,b,k){super(),this.z=s,this.C=i,this.D=o,this.F=a,this.G=b,this.H=k,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$ee),this.s=this.B(new O.$ee),this.t=this.B(new O.$ee),this.u=this.B(new O.$ee),this.w=this.B(new O.$ee),this.y=[],this.B((0,I.$Tc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const i=await this.getTargetPlatform();return s.allTargetPlatforms.some(o=>(0,w.$4o)(o,s.allTargetPlatforms,i))}async installFromGallery(s,i={}){try{const a=(await this.installGalleryExtensions([{extension:s,options:i}])).find(({identifier:b})=>(0,h.$up)(b,s.identifier));if(a?.local)return a?.local;throw a?.error?a.error:new w.$7o(`Unknown error while installing extension ${s.identifier.id}`,w.ExtensionManagementErrorCode.Unknown)}catch(o){throw $(o)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new w.$7o(y.localize(0,null),w.ExtensionManagementErrorCode.NotAllowed);const i=[],o=[];return await Promise.allSettled(s.map(async({extension:a,options:b})=>{try{const k=await this.N(a,!!b?.installGivenVersion,!!b?.installPreReleaseVersion,b.productVersion??{version:this.G.version,date:this.G.date});o.push({...k,options:b})}catch(k){i.push({identifier:a.identifier,operation:2,source:a,error:k})}})),o.length&&i.push(...await this.I(o)),i}async uninstall(s,i={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,i)}async toggleAppliationScope(s,i){if((0,c.$Um)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let o=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)||(o=await this.$(s,this.H.defaultProfile.extensionsResource,i));for(const a of this.H.profiles){const b=(await this.getInstalled(1,a.extensionsResource)).find(k=>(0,h.$up)(k.identifier,s.identifier));b?this.w.fire(b):this.u.fire({identifier:s.identifier,profileLocation:a.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,i,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const i=new Map,o=new Map,a=[],b=(v,S)=>`${h.$vp.create(v).toString()}-${S.toString()}`,k=(v,S,P,R)=>{const M=this.Y(v,S,P),F=`${(0,h.$zp)(v.publisher,v.name)}-${P.profileLocation.toString()}`;o.set(F,{task:M,root:R}),this.n.fire({identifier:M.identifier,source:S,profileLocation:P.profileLocation}),this.F.info("Installing extension:",M.identifier.id),E.URI.isUri(S)||this.j.set(b(S,P.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:v,extension:S,options:P}of s){const R=P.isApplicationScoped||P.isBuiltin||(0,c.$Um)(v),M={...P,installOnlyNewlyAddedFromExtensionPack:P.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(S),isApplicationScoped:R,profileLocation:R?this.H.defaultProfile.extensionsResource:P.profileLocation??this.X(),productVersion:P.productVersion??{version:this.G.version,date:this.G.date}},F=E.URI.isUri(S)?void 0:this.j.get(b(S,M.profileLocation));F?(this.F.info("Extension is already requested to install",F.task.identifier.id),a.push(F.task.waitUntilTaskIsFinished())):k(v,S,M,void 0)}return await Promise.all([...o.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const S=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),P=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),R={...v.options,context:{...v.options.context,[w.$Yo]:!0}};for(const{gallery:M,manifest:F}of(0,D.$Mb)(S,({gallery:q})=>q.identifier.id)){if(o.has(`${M.identifier.id.toLowerCase()}-${R.profileLocation.toString()}`))continue;const q=this.j.get(b(M,R.profileLocation));if(q){if(this.J(v,q.task)){const Y=q.task.identifier;this.F.info("Waiting for already requested installing extension",Y.id,v.identifier.id),q.waitingTasks.push(v),a.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,H=>H.some(X=>(0,h.$up)(X.identifier,Y)))).then(H=>{if(this.F.info("Finished waiting for already requested installing extension",Y.id,v.identifier.id),!H.find(W=>(0,h.$up)(W.identifier,Y))?.local)throw new Error(`Extension ${Y.id} is not installed`)}))}}else P.some(({identifier:Y})=>(0,h.$up)(Y,M.identifier))||k(F,M,R,v)}}catch(S){if(E.URI.isUri(v.source))(0,D.$Lb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,S.message),(0,D.$Lb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,S.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),S}})),await this.L([...o.entries()].map(async([v,{task:S}])=>{const P=new Date().getTime();try{const R=await S.run();if(await this.L(this.y.map(M=>M.postInstall(R,S.source,S.options,j.CancellationToken.None))),!E.URI.isUri(S.source)){const M=S.operation===3,F=M?void 0:(new Date().getTime()-S.source.lastUpdated)/1e3;if(t(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$Cp)(S.source),verificationStatus:S.verificationStatus,duration:new Date().getTime()-P,durationSinceUpdate:F}),C.$o&&S.operation!==3)try{await this.z.reportStatistic(R.manifest.publisher,R.manifest.name,R.manifest.version,"install")}catch{}}i.set(v,{local:R,identifier:S.identifier,operation:S.operation,source:S.source,context:S.options.context,profileLocation:S.profileLocation,applicationScoped:R.isApplicationScoped})}catch(R){const M=$(R);throw E.URI.isUri(S.source)||t(this.C,S.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$Cp)(S.source),error:M}),i.set(v,{error:M,identifier:S.identifier,operation:S.operation,source:S.source,context:S.options.context,profileLocation:S.profileLocation,applicationScoped:S.options.isApplicationScoped}),this.F.error("Error while installing the extension",S.identifier.id,(0,A.$0)(M)),M}})),a.length&&await this.L(a),[...i.values()]}catch(v){const S=(M,F,q)=>{const Y=[];M.manifest.extensionDependencies?.length&&Y.push(...M.manifest.extensionDependencies),M.manifest.extensionPack?.length&&Y.push(...M.manifest.extensionPack);for(const H of Y){if(q.includes(H.toLowerCase()))continue;q.push(H.toLowerCase());const X=i.get(`${H.toLowerCase()}-${F.toString()}`);X?.local&&(q=S(X.local,F,q))}return q},P=M=>({identifier:M.identifier,operation:2,source:M.source,context:M.options.context,profileLocation:M.profileLocation,error:v}),R=[];for(const[M,{task:F,root:q}]of o){const Y=i.get(M);Y?Y.local&&q&&!i.get(`${q.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`)?.local&&(R.push(this.Z(Y.local,{versionOnly:!0,profileLocation:F.profileLocation})),i.set(M,P(F))):(F.cancel(),i.set(M,P(F)))}for(const[M,{task:F}]of o){const q=i.get(M);if(!q?.local||F.options.donotIncludePackAndDependencies)continue;S(q.local,F.profileLocation,[q.local.identifier.id.toLowerCase()]).slice(1).some(H=>o.has(`${H.toLowerCase()}-${F.profileLocation.toString()}`)&&!i.get(`${H.toLowerCase()}-${F.profileLocation.toString()}`)?.local)&&(R.push(this.Z(q.local,{versionOnly:!0,profileLocation:F.profileLocation})),i.set(M,P(F)))}throw R.length&&await Promise.allSettled(R.map(async M=>{try{await M.run(),this.F.info("Rollback: Uninstalled extension",M.extension.identifier.id)}catch(F){this.F.warn("Rollback: Error while uninstalling extension",M.extension.identifier.id,(0,A.$0)(F))}})),v}finally{for(const{task:v}of o.values())v.source&&!E.URI.isUri(v.source)&&this.j.delete(b(v.source,v.profileLocation));if(i.size){const v=[...i.values()];for(const S of v)S.local&&this.F.info("Extension installed successfully:",S.identifier.id);this.s.fire(v)}}}J(s,i){for(const[,{task:o,waitingTasks:a}]of this.j.entries())if(o===s&&(a.includes(i)||a.some(b=>this.J(b,i)))||o===i&&a[0]&&!this.J(s,a[0]))return!1;return!0}async L(s){const i=[],o=[],a=await Promise.allSettled(s);for(const b of a)b.status==="fulfilled"?i.push(b.value):o.push(b.reason);if(o.length){if(o.length===1)throw o[0];let b=new w.$7o("",w.ExtensionManagementErrorCode.Unknown);for(const k of o){const v=k instanceof w.$7o?k.code:w.ExtensionManagementErrorCode.Unknown;b=new w.$7o(k.message?`${k.message}, ${b.message}`:b.message,v!==w.ExtensionManagementErrorCode.Unknown&&v!==w.ExtensionManagementErrorCode.Internal?v:b.code)}throw b}return i}async M(s,i,o,a,b,k){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,b,k),S=[],P=[],R=async(M,F)=>{S.push(M);const q=F.extensionDependencies||[],Y=[...q];if(F.extensionPack){const H=o?v.find(X=>(0,h.$up)(X.identifier,M)):void 0;for(const X of F.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(W=>(0,h.$up)({id:W},{id:X}))||Y.every(W=>!(0,h.$up)({id:W},{id:X}))&&Y.push(X)}if(Y.length){const H=Y.filter(X=>S.every(W=>!(0,h.$up)(W,{id:X})));if(H.length){const X=await this.z.getExtensions(H.map(W=>({id:W,preRelease:a})),j.CancellationToken.None);for(const W of X){if(S.find(B=>(0,h.$up)(B,W.identifier)))continue;const J=q.some(B=>(0,h.$up)({id:B},W.identifier));let G;try{G=await this.N(W,!1,a,k)}catch(B){if(J)throw B;this.F.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,A.$0)(B));continue}P.push({gallery:G.extension,manifest:G.manifest}),await R(G.extension.identifier,G.manifest)}}}};return await R(s,i),P}async N(s,i,o,a){let b;const k=await this.getExtensionsControlManifest();if(k.malicious.some(P=>(0,h.$up)(s.identifier,P)))throw new w.$7o(y.localize(1,null,s.identifier.id),w.ExtensionManagementErrorCode.Malicious);const v=k.deprecated[s.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),b=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:a},j.CancellationToken.None))[0],!b)throw new w.$7o(y.localize(2,null,s.identifier.id,v.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const P=await this.getTargetPlatform();throw new w.$7o(y.localize(3,null,s.identifier.id,this.G.nameLong,(0,w.$Zo)(P)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(b=await this.O(s,i,o,a),!b)throw!o&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],j.CancellationToken.None))[0]?new w.$7o(y.localize(4,null,s.displayName??s.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$7o(y.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",b.identifier.id);const S=await this.z.getManifest(b,j.CancellationToken.None);if(S===null)throw new w.$7o(`Missing manifest for extension ${b.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(S.version!==b.version)throw new w.$7o(`Cannot install '${b.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:b,manifest:S}}async O(s,i,o,a){const b=await this.getTargetPlatform();let k=null;return!i&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==o&&(k=(await this.z.getExtensions([{...s.identifier,preRelease:o}],{targetPlatform:b,compatible:!0,productVersion:a},j.CancellationToken.None))[0]||null),!k&&await this.z.isExtensionCompatible(s,o,b,a)&&(k=s),k||(i?k=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:b,compatible:!0,productVersion:a},j.CancellationToken.None))[0]||null:k=await this.z.getCompatibleExtension(s,o,b,a)),k}async P(s,i){const o={...i,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:i.profileLocation??this.X()},a=R=>`${R.id.toLowerCase()}${o.versionOnly?`-${s.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,b=this.m.get(a(s.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),b.waitUntilTaskIsFinished();const k=R=>{const M=this.Z(R,o);return this.m.set(a(M.extension.identifier),M),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${R.identifier.id}@${R.manifest.version}`),this.t.fire({identifier:R.identifier,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped}),M},v=(R,M)=>{M?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${R.identifier.id}@${R.manifest.version}`,M.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${R.identifier.id}@${R.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,h.$Bp)(R),error:M}),this.u.fire({identifier:R.identifier,error:M?.code,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped})},S=[],P=[];try{S.push(k(s));const R=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const M=this.S(s,R);for(const F of M)this.m.has(a(F.identifier))?this.F.info("Extensions is already requested to uninstall",F.identifier.id):S.push(k(F))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(S.map(M=>M.extension),R,s),await this.L(S.map(async M=>{try{if(await M.run(),await this.L(this.y.map(F=>F.postUninstall(M.extension,o,j.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}v(M.extension)}catch(F){const q=$(F);throw v(M.extension,q),q}finally{P.push(M)}}))}catch(R){const M=$(R);for(const F of S){try{F.cancel()}catch{}P.includes(F)||v(F.extension,M)}throw M}finally{for(const R of S)this.m.delete(a(R.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",R.extension.identifier.id)}}Q(s,i,o){for(const a of s){const b=this.U(a,i);if(b.length){const k=b.filter(v=>!s.some(S=>(0,h.$up)(S.identifier,v.identifier)));if(k.length)throw new Error(this.R(a,k,o))}}}R(s,i,o){return o===s?i.length===1?y.localize(6,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(7,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(8,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?y.localize(9,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(10,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(11,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}S(s,i,o=[]){if(o.indexOf(s)!==-1)return[];o.push(s);const a=s.manifest.extensionPack?s.manifest.extensionPack:[];if(a.length){const b=i.filter(v=>!v.isBuiltin&&a.some(S=>(0,h.$up)({id:S},v.identifier))),k=[];for(const v of b)k.push(...this.S(v,i,o));return[...b,...k]}return[]}U(s,i){return i.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,h.$up)({id:a},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$lq=d,e.$lq=d=Ee([Q(0,w.$6o),Q(1,l.$2l),Q(2,u.$Al),Q(3,p.$3j),Q(4,g.$jk),Q(5,m.$Cl)],d);function $(n){if(n instanceof w.$7o)return n;if(n instanceof w.$8o){const i=new w.$7o(n.message,w.ExtensionManagementErrorCode.Gallery);return i.stack=n.stack,i}const s=new w.$7o(n.message,(0,A.$4)(n)?w.ExtensionManagementErrorCode.Cancelled:w.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}function t(n,s,{extensionData:i,verificationStatus:o,duration:a,error:b,durationSinceUpdate:k}){let v,S;(0,f.$eg)(o)&&(o===!0?o="Verified":(o===!1||(v=w.ExtensionManagementErrorCode.Signature,S=o),o="Unverified")),b&&(v=b.code,b.code===w.ExtensionManagementErrorCode.Signature&&(S=b.message)),n.publicLog(s,{...i,verificationStatus:o,success:!b,duration:a,errorcode:v,errorcodeDetail:S,durationSinceUpdate:k})}class r{constructor(){this.d=new N.$vh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,N.$jh)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$jh)(s=>new Promise((i,o)=>{const a=s.onCancellationRequested(()=>{a.dispose(),o(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$nq=r}),define(ae[52],ce([0,1,6,15,2,3,34,8,29,33,12,4,9,18,28,13,7,22]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=e.$oq=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class m extends Error{constructor(n,s){super(n),this.code=s}}e.$oq=m,e.$pq=(0,y.$wi)("IExtensionsProfileScannerService");let d=class extends j.$Vc{constructor(n,s,i,o,a,b){super(),this.j=n,this.m=s,this.n=i,this.r=o,this.s=a,this.t=b,this.b=this.B(new A.$ee),this.onAddExtensions=this.b.event,this.c=this.B(new A.$ee),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$ee),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$ee),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Bc}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,i){const o=[],a=[];try{return await this.u(s,b=>{const k=[];if(i)k.push(...b);else for(const v of b)n.some(([S])=>(0,f.$up)(S.identifier,v.identifier)&&S.manifest.version!==v.version)?o.push(v):k.push(v);for(const[v,S]of n){const P=k.findIndex(M=>(0,f.$up)(M.identifier,v.identifier)&&M.version===v.manifest.version),R={identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:S};P===-1?(a.push(R),k.push(R)):k.splice(P,1,R)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),o.length&&this.f.fire({extensions:o,profileLocation:s}),k}),a.length&&this.c.fire({extensions:a,profileLocation:s}),o.length&&this.g.fire({extensions:o,profileLocation:s}),a}catch(b){throw a.length&&this.c.fire({extensions:a,error:b,profileLocation:s}),o.length&&this.g.fire({extensions:o,error:b,profileLocation:s}),b}}async updateMetadata(n,s){const i=[];return await this.u(s,o=>{const a=[];for(const b of o){const k=n.find(([v])=>(0,f.$up)(v.identifier,b.identifier)&&v.manifest.version===b.version);k&&(b.metadata={...b.metadata,...k[1]},i.push(b)),a.push(b)}return a}),i}async removeExtensionFromProfile(n,s){const i=[];try{await this.u(s,o=>{const a=[];for(const b of o)(0,f.$up)(b.identifier,n.identifier)?i.push(b):a.push(b);return i.length&&this.f.fire({extensions:i,profileLocation:s}),a}),i.length&&this.g.fire({extensions:i,profileLocation:s})}catch(o){throw i.length&&this.g.fire({extensions:i,error:o,profileLocation:s}),o}}async u(n,s,i){return this.F(n).queue(async()=>{let o=[],a;try{const b=await this.m.readFile(n);a=JSON.parse(b.value.toString().trim()||"[]")}catch(b){if((0,E.$hl)(b)!==1)throw b;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&i?.bailOutWhenFileNotFound)throw new m((0,g.$0)(b),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let b=!1;for(const k of a){$(k)||this.w(n);let v;if((0,p.$9f)(k.relativeLocation)&&k.relativeLocation)v=this.z(k.relativeLocation);else if((0,p.$9f)(k.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${k.location}`);continue}else{v=I.URI.revive(k.location);const S=this.y(v);S&&(b=!0,k.relativeLocation=S)}(0,p.$dg)(k.metadata?.hasPreReleaseVersion)&&k.metadata?.preRelease&&(b=!0,k.metadata.hasPreReleaseVersion=!0),o.push({identifier:k.identifier,location:v,version:k.version,metadata:k.metadata})}b&&await this.m.writeFile(n,N.$Ge.fromString(JSON.stringify(a)))}if(s){o=s(o);const b=o.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.y(k.location),metadata:k.metadata}));await this.m.writeFile(n,N.$Ge.fromString(JSON.stringify(b)))}return o})}w(n){const s=new m(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(n)).value.toString()}catch(a){if((0,E.$hl)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let o;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(b=>$(b))?o=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$Ge.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,E.$hl)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,E.$hl)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,E.$hl)(a)!==1&&this.t.error(a)}return o})()),this.C}F(n){let s=this.h.get(n);return s||(s=new D.$Dh,this.h.set(n,s)),s}};e.$qq=d,e.$qq=d=Ee([Q(1,E.$3k),Q(2,h.$Cl),Q(3,c.$Al),Q(4,l.$2l),Q(5,w.$3j)],d);function $(r){return(0,p.$$f)(r)&&(0,C.$5o)(r.identifier)&&(t(r.location)||(0,p.$9f)(r.location)&&r.location)&&((0,p.$dg)(r.relativeLocation)||(0,p.$9f)(r.relativeLocation))&&r.version&&(0,p.$9f)(r.version)}function t(r){return r?(0,p.$9f)(r.path)&&(0,p.$9f)(r.scheme):!1}}),define(ae[81],ce([0,1,17,6,30,15,7,35,138,2,23,14,5,20,55,88,13,8,159,16,33,48,71,12,4,9,24,3,66,52,18,28,188]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,k,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$vq=e.$uq=e.$tq=e.Translations=void 0,e.$wq=Y;var P;(function(X){function W(J,G){if(J===G)return!0;const B=Object.keys(J),ie=new Set;for(const re of Object.keys(G))ie.add(re);if(B.length!==ie.size)return!1;for(const re of B){if(J[re]!==G[re])return!1;ie.delete(re)}return ie.size===0}X.equals=W})(P||(e.Translations=P={})),e.$tq=(0,n.$wi)("IExtensionsScannerService");let R=class extends f.$Vc{constructor(W,J,G,B,ie,re,he,te,V,z,L,T){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=J,this.r=G,this.s=B,this.t=ie,this.u=re,this.w=he,this.y=te,this.z=V,this.C=z,this.D=L,this.F=T,this.g=this.B(new o.$ee),this.onDidChangeCache=this.g.event,this.h=(0,h.$0g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$Fp)(this.w,this.y)),this.G}async scanAllExtensions(W,J,G){const[B,ie]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(J)]),re=G?await this.scanExtensionsUnderDevelopment(W,[...B,...ie]):[];return this.L(B,ie,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const J=[];J.push(this.M(!!W.useCache,W.language)),J.push(this.N(W.language,!!W.checkControlFile));const[G,B]=await Promise.all(J);return this.J([...G,...B],0,W,!1)}async scanUserExtensions(W){const J=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const G=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(J,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,G,W.productVersion??this.R()),ie=W.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let re;try{re=await ie.scanExtensions(B)}catch(he){if(he instanceof b.$oq&&he.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),re=await ie.scanExtensions(B);else throw he}return re=await this.J(re,1,W,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(W,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===E.Schemas.file).map(async B=>{const ie=await this.P(B,!1,1,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(he=>(he.type=J.find(te=>(0,d.$up)(te.identifier,he.identifier))?.type??he.type,this.n.validate(he,ie)))}))).flat();return this.J(G,"development",W,!0)}return[]}async scanExistingExtension(W,J,G){const B=await this.P(W,!1,J,!0,G.language,!0,void 0,G.productVersion??this.R()),ie=await this.n.scanExtension(B);return!ie||!G.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(W,J,G){const B=await this.P(W,!1,J,!0,G.language,!0,void 0,G.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(B);return this.J(ie,J,G,!0)}async scanMultipleExtensions(W,J,G){const B=[];return await Promise.all(W.map(async ie=>{const re=await this.scanOneOrMultipleExtensions(ie,J,G);B.push(...re)})),this.J(B,J,G,!0)}async scanMetadata(W){const J=(0,h.$0g)(W,"package.json"),G=(await this.w.readFile(J)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(W,J){const G=(0,h.$0g)(W,"package.json"),B=(await this.w.readFile(G)).value.toString(),ie=JSON.parse(B);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,ie.__metadata={...ie.__metadata,...J},await this.w.writeFile((0,h.$0g)(W,"package.json"),A.$Ge.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof b.$oq&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Ge.fromString(JSON.stringify([])))}catch(J){(0,r.$hl)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,J,G,B){return G.includeAllVersions||(W=this.L(J===0?W:void 0,J===1?W:void 0,J==="development"?W:void 0,await this.getTargetPlatform(),B)),G.includeInvalid||(W=W.filter(ie=>ie.isValid)),W.sort((ie,re)=>{const he=y.$oc(ie.location.fsPath),te=y.$oc(re.location.fsPath);return he<te?-1:he>te?1:0})}L(W,J,G,B,ie){const re=(te,V,z)=>{if(te.isValid&&!V.isValid)return!1;if(te.isValid===V.isValid){if(ie&&c.gt(te.manifest.version,V.manifest.version))return this.y.debug(`Skipping extension ${V.location.path} with lower version ${V.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(c.eq(te.manifest.version,V.manifest.version)){if(te.type===0)return this.y.debug(`Skipping extension ${V.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===B)return this.y.debug(`Skipping extension ${V.location.path} from different target platform ${V.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${te.location.path} with ${V.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${V.location.path}.`),!0},he=new $.$Tm;return W?.forEach(te=>{const V=he.get(te.identifier.id);(!V||re(V,te,!1))&&he.set(te.identifier.id,te)}),J?.forEach(te=>{const V=he.get(te.identifier.id);if(!V&&W&&te.type===0){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!V||re(V,te,!1))&&he.set(te.identifier.id,te)}),G?.forEach(te=>{const V=he.get(te.identifier.id);(!V||re(V,te,!0))&&he.set(te.identifier.id,te),he.set(te.identifier.id,te)}),[...he.values()]}async M(W,J){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0,this.R()),ie=await(W&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(W,J){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const B=J?await this.O():{},ie=[],re=l.URI.file(y.$ic(y.$kc(E.$Qg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of G){const V=B[te.name]||"marketplace";switch(V){case"disabled":break;case"marketplace":ie.push((0,h.$0g)(re,te.name));break;default:ie.push(l.URI.file(V));break}}const he=await Promise.all(ie.map(async te=>this.n.scanExtension(await this.P(te,!1,0,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",he.length),(0,D.$Hb)(he)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,J,G,B,ie,re,he,te){const V=await this.f(ie??w.$w),z=await this.Q(W),L=J&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,T=L?await this.Q(L):void 0;return new M(W,z,L,T,J,he,G,B,re,te.version,te.date,this.C.commit,!this.z.isBuilt,ie,V)}async Q(W){try{const J=await this.w.stat(W);if(typeof J.mtime=="number")return J.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$uq=R,e.$uq=R=Ee([Q(4,k.$Cl),Q(5,b.$pq),Q(6,r.$3k),Q(7,s.$3j),Q(8,m.$Di),Q(9,i.$jk),Q(10,v.$Al),Q(11,n.$vi)],R);class M{constructor(W,J,G,B,ie,re,he,te,V,z,L,T,U,x,K){this.location=W,this.mtime=J,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=B,this.profile=ie,this.profileScanOptions=re,this.type=he,this.excludeObsolete=te,this.validate=V,this.productVersion=z,this.productDate=L,this.productCommit=T,this.devMode=U,this.language=x,this.translations=K}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,J){return(0,h.$3g)(W.location,J.location)&&W.mtime===J.mtime&&(0,h.$3g)(W.applicationExtensionslocation,J.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&W.profile===J.profile&&j.$7n(W.profileScanOptions,J.profileScanOptions)&&W.type===J.type&&W.excludeObsolete===J.excludeObsolete&&W.validate===J.validate&&W.productVersion===J.productVersion&&W.productDate===J.productDate&&W.productCommit===J.productCommit&&W.devMode===J.devMode&&W.language===J.language&&P.equals(W.translations,J.translations)}}e.$vq=M;let F=class extends f.$Vc{constructor(W,J,G,B,ie){super(),this.f=W,this.g=J,this.h=G,this.j=B,this.m=ie}async scanExtensions(W){const J=W.profile?await this.r(W):await this.n(W);let G={};if(W.excludeObsolete&&W.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(B)}catch{}return(0,g.$jg)(G)?J:J.filter(B=>!G[d.$vp.create(B).toString()])}async n(W){const J=await this.j.resolve(W.location);if(!J.children?.length)return[];const G=await Promise.all(J.children.map(async B=>{if(!B.isDirectory||W.type===1&&(0,h.$7g)(B.resource).indexOf(".")===0)return null;const ie=new M(B.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ie)}));return(0,D.$Hb)(G).sort((B,ie)=>B.location.path<ie.location.path?-1:1)}async r(W){let J=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){J=J.filter(B=>!B.metadata?.isApplicationScoped);const G=await this.s(W.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,W);J.push(...G)}return J}async s(W,J,G){const B=await this.g.scanProfileExtensions(W,G.profileScanOptions);if(!B.length)return[];const ie=await Promise.all(B.map(async re=>{if(J(re)){const he=new M(re.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(he,re.metadata)}return null}));return(0,D.$Hb)(ie)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,h.$0g)(W.location,"package.json"))){const J=await this.scanExtension(W);return J?[J]:[]}else return await this.scanExtensions(W)}catch(J){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,O.$0)(J)),[]}}async scanExtension(W,J){try{let G=await this.scanExtensionManifest(W.location);if(G){G.publisher||(G.publisher=$.$Nm),J=J??G.__metadata,delete G.__metadata;const B=(0,d.$zp)(G.publisher,G.name),ie=J?.id?{id:B,uuid:J.id}:{id:B},re=J?.isSystem?0:W.type,he=re===0||!!J?.isBuiltin;G=await this.t(W.location,G,M.createNlsConfiguration(W));const te={type:re,identifier:ie,manifest:G,location:W.location,isBuiltin:he,targetPlatform:J?.targetPlatform??"undefined",publisherDisplayName:J?.publisherDisplayName,metadata:J,isValid:!0,validations:[]};return W.validate?this.validate(te,W):te}}catch(G){W.type!==0&&this.m.error(G)}return null}validate(W,J){let G=!0;const B=(0,t.$Kp)(J.productVersion,J.productDate,J.location,W.manifest,W.isBuiltin);for(const[ie,re]of B)ie===p.default.Error&&(G=!1,this.m.error(this.z(J.location,re)));return W.isValid=G,W.validations=B,W}async scanExtensionManifest(W){const J=(0,h.$0g)(W,"package.json");let G;try{G=(await this.j.readFile(J)).value.toString()}catch(ie){return(0,r.$hl)(ie)!==1&&this.m.error(this.z(W,(0,u.localize)(0,null,J.path,ie.message))),null}let B;try{B=JSON.parse(G)}catch{const re=[];(0,I.$Jn)(G,re);for(const he of re)this.m.error(this.z(W,(0,u.localize)(1,null,J.path,he.offset,he.length,(0,C.$rq)(he.error))));return null}return(0,I.$Sn)(B)!=="object"?(this.m.error(this.z(W,(0,u.localize)(2,null,J.path))),null):B}async t(W,J,G){const B=await this.u(W,J,G);if(B)try{const ie=[],re=await this.w(B.default,ie);if(ie.length>0)return ie.forEach(te=>{this.m.error(this.z(W,(0,u.localize)(3,null,B.default?.path,(0,C.$rq)(te.error))))}),J;if((0,I.$Sn)(B)!=="object")return this.m.error(this.z(W,(0,u.localize)(4,null,B.default?.path))),J;const he=B.values||Object.create(null);return(0,S.$sq)(this.m,J,he,re)}catch{}return J}async u(W,J,G){const B=(0,h.$0g)(W,"package.nls.json"),ie=(V,z)=>{z.forEach(L=>{this.m.error(this.z(W,(0,u.localize)(5,null,V?.path,(0,C.$rq)(L.error))))})},re=V=>{this.m.error(this.z(W,(0,u.localize)(6,null,V?.path)))},he=`${J.publisher}.${J.name}`,te=G.translations[he];if(te)try{const V=l.URI.file(te),z=(await this.j.readFile(V)).value.toString(),L=[],T=(0,I.$Jn)(z,L);return L.length>0?(ie(V,L),{values:void 0,default:B}):(0,I.$Sn)(T)!=="object"?(re(V),{values:void 0,default:B}):{values:T.contents?T.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let z;try{z=await this.y(W,G)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const L=(await this.j.readFile(z.localized)).value.toString(),T=[],U=(0,I.$Jn)(L,T);return T.length>0?(ie(z.localized,T),{values:void 0,default:z.original}):(0,I.$Sn)(U)!=="object"?(re(z.localized),{values:void 0,default:z.original}):{values:U,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(W,J){if(W)try{const G=(await this.j.readFile(W)).value.toString();return(0,I.$Jn)(G,J)}catch{}}y(W,J){return new Promise((G,B)=>{const ie=re=>{const he=(0,h.$0g)(W,`package.nls.${re}.json`);this.j.exists(he).then(te=>{te&&G({localized:he,original:(0,h.$0g)(W,"package.nls.json")});const V=re.lastIndexOf("-");V===-1?G({localized:(0,h.$0g)(W,"package.nls.json"),original:null}):(re=re.substring(0,V),ie(re))})};if(J.devMode||J.pseudo||!J.language)return G({localized:(0,h.$0g)(W,"package.nls.json"),original:null});ie(J.language)})}z(W,J){return`[${W.path}]: ${J}`}};F=Ee([Q(1,b.$pq),Q(2,v.$Al),Q(3,r.$3k),Q(4,s.$3j)],F);let q=class extends F{constructor(W,J,G,B,ie,re,he){super(J,B,ie,re,he),this.G=W,this.H=G,this.D=this.B(new N.$uh(3e3)),this.F=this.B(new o.$ee),this.onDidChangeCache=this.F.event}async scanExtensions(W){const J=this.M(W),G=await this.I(J);if(this.C=W,G&&G.input&&M.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),G.result.map(ie=>(ie.location=l.URI.revive(ie.location),ie));const B=await super.scanExtensions(W);return await this.J(J,{input:W,result:B}),B}async I(W){try{const J=await this.j.readFile(W),G=JSON.parse(J.value.toString());return{result:G.result,input:(0,a.$6h)(G.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",W.path,(0,O.$0)(J))}return null}async J(W,J){try{await this.j.writeFile(W,A.$Ge.fromString(JSON.stringify(J)))}catch(G){this.m.debug("Error while writing the extension cache file:",W.path,(0,O.$0)(G))}}async L(){if(!this.C)return;const W=this.M(this.C),J=await this.I(W);if(!J)return;const G=J.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!j.$7n(B,G))try{this.m.info("Invalidating Cache",G,B),await this.j.del(W),this.F.fire()}catch(ie){this.m.error(ie)}}M(W){const J=this.N(W);return this.h.extUri.joinPath(J.cacheHome,W.type===0?$.$Mm:$.$Lm)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(W.location,J.extensionsResource))??this.G:this.H.defaultProfile}};q=Ee([Q(2,k.$Cl),Q(3,b.$pq),Q(4,v.$Al),Q(5,r.$3k),Q(6,s.$3j)],q);function Y(X,W){const J=(0,d.$xp)(X.manifest.publisher,X.manifest.name);return{id:J,identifier:new $.$Rm(J),isBuiltin:X.type===0,isUserBuiltin:X.type===1&&X.isBuiltin,isUnderDevelopment:W,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,publisherDisplayName:X.publisherDisplayName,...X.manifest}}class H extends R{constructor(W,J,G,B,ie,re,he,te,V,z,L,T){super(W,J,(0,h.$0g)(G,".vscode-oss-dev","extensions","control.json"),B,ie,re,he,te,V,z,L,T),this.S=(async()=>{if(w.$z)try{const U=await this.w.readFile(l.URI.file(w.$z));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$xq=H}),define(ae[251],ce([0,1,67,6,38,3,2,23,14,31,9,18]),function(ne,e,D,N,j,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;let w=class extends O.$Vc{constructor(c,p){super(),this.b=c,this.f=p,this.a=new N.$Ch(5)}async postUninstall(c){const p=this.g(c,"uninstall");p&&(this.f.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,c),this.f.info("Finished running post uninstall script",c.identifier.id,c.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",c.identifier.id,c.manifest.version),this.f.error(g)}}));try{await f.Promises.rm(this.m(c))}catch(g){this.f.error("Error while removing extension storage path",c.identifier.id),this.f.error(g)}}g(c,p){const g=`vscode:${p}`;if(c.location.scheme===I.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[g]=="string"){const l=c.manifest.scripts[g].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(c.identifier.id,c.manifest.version,`${g} should be a node script`),null):{script:(0,C.$kc)(c.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(c,p,g,l,u){return new Promise((m,d)=>{const $=this.j(c,p,g,u);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?d(n):m(void 0)};$.on("error",n=>{r((0,j.$hj)(n)||"Unknown")}),$.on("exit",(n,s)=>{r(n?`post-${p} process exited with code ${n}`:void 0)}),l&&(t=setTimeout(()=>{t=null,$.kill(),d("timed out")},5e3))})}j(c,p,g,l){const u={silent:!0,execArgv:void 0},m=(0,D.fork)(c,[`--type=extension-post-${p}`,...g],u);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const d=A.Event.fromNodeEventEmitter(m.stdout,"data"),$=A.Event.fromNodeEventEmitter(m.stderr,"data");d(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${p}`,n)),$(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${p}`,n));const t=A.Event.any(A.Event.map(d,n=>({data:`%c${n}`,format:[""]})),A.Event.map($,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),m}m(c){return(0,C.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};e.$zq=w,e.$zq=w=Ee([Q(0,y.$Cl),Q(1,E.$3j)],w)}),define(ae[113],ce([0,1,6,15,26,38,7,3,54,2,34,23,14,20,55,13,8,32,31,70,160,95,16,250,29,33,52,81,231,251,189,221,232,71,12,4,9,24,22,28,18]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,k,v,S,P,R,M,F,q,Y,H,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=e.$Eq=e.$Dq=void 0,e.$Dq=(0,M.$xi)(n.$9o);const W=".vsctmp";let J=class extends r.$lq{constructor(V,z,L,T,U,x,K,ee,_,Z,se,ue){super(V,z,se,L,Z,ue),this.eb=U,this.fb=x,this.gb=K,this.hb=_,this.db=new Map,this.qb=new E.$Cc;const ge=this.B(ee.createInstance(b.$zq));this.ab=this.B(ee.createInstance(G,$e=>ge.postUninstall($e))),this.bb=this.B(new v.$Bq(ue,_,se,this,this.F)),this.cb=this.B(ee.createInstance(a.$yq));const fe=this.B(new S.$Cq(this,this.eb,ue,x,se,_,L));this.B(fe.onDidChangeExtensionsByAnotherSource($e=>this.pb($e))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$Fp)(this.hb,this.F)),this.ib}async zip(V){this.F.trace("ExtensionManagementService#zip",V.identifier.id);const z=await this.ob(V),L=await(0,m.zip)((0,h.$0g)(this.cb.extensionsDownloadDir,(0,l.$Sg)()).fsPath,z);return g.URI.file(L)}async unzip(V){return this.F.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const{location:z,cleanup:L}=await this.kb(V),T=w.$lc(z.fsPath);try{return await(0,k.$Aq)(T)}finally{await L()}}getInstalled(V,z=this.H.defaultProfile.extensionsResource,L={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(V??null,z,L)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(V){return this.ab.scanUserExtensionAtLocation(V)}async install(V,z={}){this.F.trace("ExtensionManagementService#install",V.toString());const{location:L,cleanup:T}=await this.kb(V);try{const U=await(0,k.$Aq)(w.$lc(L.fsPath)),x=(0,s.$zp)(U.publisher,U.name);if(U.engines&&U.engines.vscode&&!(0,P.$Mp)(U.engines.vscode,this.G.version,this.G.date))throw new Error(d.localize(0,null,x,this.G.version));const ee=(await this.I([{manifest:U,extension:L,options:z}])).find(({identifier:_})=>(0,s.$up)(_,{id:x}));if(ee?.local)return ee.local;throw ee?.error?ee.error:(0,r.$mq)(new Error(`Unknown error while installing extension ${x}`))}finally{await T()}}async installFromLocation(V,z){this.F.trace("ExtensionManagementService#installFromLocation",V.toString());const L=await this.ab.scanUserExtensionAtLocation(V);if(!L||!L.manifest.name||!L.manifest.version)throw new Error(`Cannot find a valid extension from the location ${V.toString()}`);return await this.tb([[L,{source:"resource"}]],z),this.F.info("Successfully installed extension",L.identifier.id,z.toString()),L}async installExtensionsFromProfile(V,z,L){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",V,z.toString(),L.toString());const T=(await this.getInstalled(1,z)).filter(U=>V.some(x=>(0,s.$up)(x,U.identifier)));if(T.length){const U=await Promise.all(T.map(x=>this.ab.scanMetadata(x,z)));await this.tb(T.map((x,K)=>[x,U[K]]),L),this.F.info("Successfully installed extensions",T.map(x=>x.identifier.id),L.toString())}return T}async updateMetadata(V,z,L=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",V.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),V=await this.ab.updateMetadata(V,z,L),this.bb.invalidate(L),this.w.fire(V),V}async reinstallFromGallery(V){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",V.identifier.id),!this.z.isEnabled())throw new Error(d.localize(1,null));const z=await this.getTargetPlatform(),[L]=await this.z.getExtensions([{...V.identifier,preRelease:V.preRelease}],{targetPlatform:z,compatible:!0},j.CancellationToken.None);if(!L)throw new Error(d.localize(2,null));await this.ab.setUninstalled(V);try{await this.ab.removeUninstalledExtension(V)}catch(T){throw new Error(d.localize(3,null,(0,A.$hj)(T)))}return this.installFromGallery(L)}$(V,z,L,T){return this.ab.copyExtension(V,z,L,T)}copyExtensions(V,z){return this.ab.copyExtensions(V,z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...V){return this.ab.setUninstalled(...V)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(V){this.F.error(V)}}async download(V,z,L){const{location:T}=await this.cb.download(V,z,!L);return T}async kb(V){if(V.scheme===y.Schemas.file)return{location:V,async cleanup(){}};this.F.trace("Downloading extension from",V.toString());const z=(0,h.$0g)(this.cb.extensionsDownloadDir,(0,l.$Sg)());return await this.gb.download(V,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.hb.del(z)}catch(T){this.F.error(T)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(V,z,L){if(g.URI.isUri(z))return new re(V,z,L,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const T=s.$vp.create(z).toString();let U=this.db.get(T);return U||(this.db.set(T,U=new ie(V,z,L,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),U.waitUntilTaskIsFinished().finally(()=>this.db.delete(T))),U}Z(V,z){return new he(V,z.profileLocation,this.fb)}async ob(V){const z=async T=>{let U=await u.Promises.readdir(T);U=U.map(ee=>w.$kc(T,ee));const x=await Promise.all(U.map(ee=>u.Promises.stat(ee)));let K=Promise.resolve([]);return x.forEach((ee,_)=>{const Z=U[_];ee.isFile()&&(K=K.then(se=>[...se,Z])),ee.isDirectory()&&(K=K.then(se=>z(Z).then(ue=>[...se,...ue])))}),K};return(await z(V.location.fsPath)).map(T=>({path:`extension/${w.$mc(V.location.fsPath,T)}`,localPath:T}))}async pb({added:V,removed:z}){if(z){const L=V&&this.D.extUri.isEqual(z.profileLocation,V.profileLocation)?z.extensions.filter(T=>V.extensions.every(U=>!(0,s.$up)(U,T))):z.extensions;for(const T of L)this.F.info("Extensions removed from another source",T.id,z.profileLocation.toString()),this.u.fire({identifier:T,profileLocation:z.profileLocation})}if(V){const T=(await this.getInstalled(1,V.profileLocation)).filter(U=>V.extensions.some(x=>(0,s.$up)(x,U.identifier)));this.s.fire(T.map(U=>(this.F.info("Extensions added from another source",U.identifier.id,V.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:V.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(z=>this.qb.add(z)));const V=await this.hb.resolve(this.eb.userExtensionsLocation);for(const z of V.children??[])z.isDirectory&&this.qb.add(z.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(z=>this.sb(z)))}async sb(V){if(!V.affects(this.eb.userExtensionsLocation,1))return;const z=[];for(const L of V.rawAdded){if(this.qb.has(L)||!this.D.extUri.isEqual(this.D.extUri.dirname(L),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(L,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(L).startsWith(".")||!(await this.hb.stat(L)).isDirectory)continue;const T=await this.ab.scanUserExtensionAtLocation(L);T&&T.installedTimestamp===void 0&&(this.qb.add(L),z.push(T))}z.length&&(await this.tb(z.map(L=>[L,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(L=>L.identifier.id)))}async tb(V,z){const L=V.map(T=>T[0]);await this.ub(L),await this.fb.addExtensionsToProfile(V,z),this.s.fire(L.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:z})))}async ub(V){const z=await this.ab.getUninstalledExtensions();for(const L of V){const T=s.$vp.create(L);z[T.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",T.id),await this.ab.setInstalled(T),this.F.info("Removed the extension from uninstalled list:",T.id))}}};e.$Eq=J,e.$Eq=J=Ee([Q(0,n.$6o),Q(1,Y.$2l),Q(2,F.$3j),Q(3,t.$Ei),Q(4,o.$tq),Q(5,i.$pq),Q(6,$.$Ko),Q(7,M.$vi),Q(8,R.$3k),Q(9,q.$jk),Q(10,H.$Al),Q(11,X.$Cl)],J);let G=class extends f.$Vc{constructor(V,z,L,T,U,x){super(),this.j=V,this.m=z,this.n=L,this.s=T,this.t=U,this.u=x,this.h=this.B(new I.$ee),this.onExtract=this.h.event,this.c=(0,h.$0g)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$Dh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(V,z,L){const T={includeInvalid:!0,profileLocation:z,productVersion:L};let U=[];return V===null||V===0?U.push(...await this.n.scanAllExtensions({includeInvalid:!0},T,!1)):V===1&&U.push(...await this.n.scanUserExtensions(T)),U=V!==null?U.filter(x=>x.type===V):U,Promise.all(U.map(x=>this.F(x)))}async scanAllUserExtensions(V){const z=await this.n.scanUserExtensions({includeAllVersions:!V,includeInvalid:!0});return Promise.all(z.map(L=>this.F(L)))}async scanUserExtensionAtLocation(V){try{const z=await this.n.scanExistingExtension(V,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(V,z,L,T,U){const x=V.toString(),K=g.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$Sg)()}`)),ee=g.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,x));let _=await this.m.exists(ee);if(_&&T){try{await this.y(V.id,ee,"removeExisting")}catch{throw new n.$7o(d.localize(4,null,ee.fsPath,V.id),n.ExtensionManagementErrorCode.Delete)}_=!1}if(_)await this.n.updateMetadata(ee,L);else try{try{this.u.trace(`Started extracting the extension from ${z} to ${ee.fsPath}`),await(0,m.$jq)(z,K.fsPath,{sourcePath:"extension",overwrite:!0},U),this.u.info(`Extracted extension to ${ee}:`,V.id)}catch(Z){let se=n.ExtensionManagementErrorCode.Extract;throw Z instanceof m.$hq&&(Z.type==="CorruptZip"?se=n.ExtensionManagementErrorCode.CorruptZip:Z.type==="Incomplete"&&(se=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$7o(Z.message,se)}await this.n.updateMetadata(K,L);try{this.u.trace(`Started renaming the extension from ${K.fsPath} to ${ee.fsPath}`),await this.C(K.fsPath,ee.fsPath),this.u.info("Renamed to",ee.fsPath)}catch(Z){if(Z.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",V.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(Z)}. Deleted from extracted location`,K),Z}this.h.fire(ee)}catch(Z){try{await this.m.del(K,{recursive:!0})}catch{}throw Z}return this.D(ee,1)}async scanMetadata(V,z){return z?(await this.w(V,z))?.metadata:this.n.scanMetadata(V.location)}async w(V,z){return(await this.s.scanProfileExtensions(z)).find(T=>(0,s.$up)(T.identifier,V.identifier))}async updateMetadata(V,z,L){return L?await this.s.updateMetadata([[V,z]],L):await this.n.updateMetadata(V.location,z),this.D(V.location,V.type,L)}getUninstalledExtensions(){return this.z()}async setUninstalled(...V){const z=V.map(L=>s.$vp.create(L));await this.z(L=>z.forEach(T=>{L[T.toString()]=!0,this.u.info("Marked extension as uninstalled",T.toString())}))}async setInstalled(V){await this.z(z=>delete z[V.toString()])}async removeExtension(V,z){if(this.t.extUri.isEqualOrParent(V.location,this.n.userExtensionsLocation))return this.y(V.identifier.id,V.location,z)}async removeUninstalledExtension(V){await this.removeExtension(V,"uninstalled"),await this.z(z=>delete z[s.$vp.create(V).toString()])}async copyExtension(V,z,L,T){const U=await this.w(V,z),x=await this.w(V,L);if(T={...U?.metadata,...T},x)if(this.t.extUri.isEqual(x.location,V.location))await this.s.updateMetadata([[V,{...x.metadata,...T}]],L);else{const K=await this.D(x.location,V.type,L);await this.s.removeExtensionFromProfile(K,L),await this.s.addExtensionsToProfile([[V,{...x.metadata,...T}]],L)}else await this.s.addExtensionsToProfile([[V,T]],L);return this.D(V.location,V.type,L)}async copyExtensions(V,z,L){const T=await this.scanExtensions(1,V,L),U=await Promise.all(T.filter(x=>!x.isApplicationScoped).map(async x=>[x,await this.scanMetadata(x,V)]));await this.s.addExtensionsToProfile(U,z)}async y(V,z,L){this.u.trace(`Deleting ${L} extension from disk`,V,z.fsPath);const T=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,C.$kj)((0,l.$Sg)()).toString(16)}${W}`);await this.C(z.fsPath,T.fsPath),await this.m.del(T,{recursive:!0}),this.u.info(`Deleted ${L} extension from disk`,V,z.fsPath)}async z(V){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(T){if((0,R.$hl)(T)!==1)throw T}let L={};if(z)try{L=JSON.parse(z)}catch{}return V&&(V(L),Object.keys(L).length?await this.m.writeFile(this.c,N.$Ge.fromString(JSON.stringify(L))):await this.m.del(this.c)),L})}async C(V,z){try{await u.Promises.rename(V,z,2*60*1e3)}catch(L){throw new n.$7o(L.message||d.localize(5,null,V,z),L.code||n.ExtensionManagementErrorCode.Rename)}}async D(V,z,L){if(L){const U=(await this.n.scanUserExtensions({profileLocation:L})).find(x=>this.t.extUri.isEqual(x.location,V));if(U)return this.F(U)}else{const T=await this.n.scanExistingExtension(V,z,{includeInvalid:!0});if(T)return this.F(T)}throw new Error(d.localize(6,null,V.path))}async F(V){const z=await this.m.resolve(V.location);let L,T;return z.children&&(L=z.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,T=z.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:V.identifier,type:V.type,isBuiltin:V.isBuiltin||!!V.metadata?.isBuiltin,location:V.location,manifest:V.manifest,targetPlatform:V.targetPlatform,validations:V.validations,isValid:V.isValid,readmeUrl:L,changelogUrl:T,publisherDisplayName:V.metadata?.publisherDisplayName,publisherId:V.metadata?.publisherId||null,isApplicationScoped:!!V.metadata?.isApplicationScoped,isMachineScoped:!!V.metadata?.isMachineScoped,isPreReleaseVersion:!!V.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!V.metadata?.hasPreReleaseVersion,preRelease:!!V.metadata?.preRelease,installedTimestamp:V.metadata?.installedTimestamp,updated:!!V.metadata?.updated,pinned:!!V.metadata?.pinned,isWorkspaceScoped:!1,source:V.metadata?.source??(V.identifier.uuid?"gallery":"vsix")}}async G(){const V=await this.getUninstalledExtensions();if(Object.keys(V).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(V));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const U of z)V[s.$vp.create(U).toString()]||L.add(U.identifier.id.toLowerCase());try{const U=(0,s.$Ap)(z,x=>x.identifier);await D.Promises.settled(U.map(async x=>{const K=x.sort((ee,_)=>c.rcompare(ee.manifest.version,_.manifest.version))[0];L.has(K.identifier.id.toLowerCase())||await this.j(await this.F(K))}))}catch(U){this.u.error(U)}const T=z.filter(U=>U.metadata&&V[s.$vp.create(U).toString()]);await Promise.allSettled(T.map(U=>this.removeUninstalledExtension(U)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let V;try{V=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,R.$hl)(z)!==1&&this.u.error(z);return}if(V?.children)try{await Promise.allSettled(V.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(L){(0,R.$hl)(L)!==1&&this.u.error(L)}}}))}catch{}}};e.$Fq=G,e.$Fq=G=Ee([Q(1,R.$3k),Q(2,o.$tq),Q(3,i.$pq),Q(4,H.$Al),Q(5,F.$3j)],G);class B extends r.$nq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$dg)(this.options.operation)?this.l:this.options.operation}constructor(V,z,L,T,U,x,K,ee,_,Z){super(),this.manifest=V,this.identifier=z,this.source=L,this.options=T,this.m=U,this.n=x,this.o=K,this.p=ee,this.q=_,this.s=Z,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(V){const[z,L]=await this.x(V);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,L]],this.j,!z.isValid),z}async u({zipPath:V,key:z,metadata:L},T,U){let x=await this.v(z);return x?x=await this.m.updateMetadata(x,L):(this.s.trace("Extracting extension...",z.id),x=await this.m.extractUserExtension(z,V,L,T,U),this.s.info("Extracting extension completed.",z.id)),x}async v(V){return await this.w(V)?(this.s.trace("Removing the extension from uninstalled list:",V.id),await this.m.setInstalled(V),this.s.info("Removed the extension from uninstalled list:",V.id),(await this.m.scanAllUserExtensions(!0)).find(T=>s.$vp.create(T).equals(V))):void 0}async w(V){return!!(await this.m.getUninstalledExtensions())[V.toString()]}}class ie extends B{constructor(V,z,L,T,U,x,K,ee,_,Z,se){super(V,z.identifier,z,L,U,x,K,ee,_,Z),this.y=z,this.z=T,this.A=se}async x(V){let z;try{z=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(U){throw new n.$7o(U,n.ExtensionManagementErrorCode.Scanning)}const L=z.find(U=>(0,s.$up)(U.identifier,this.y.identifier));L&&(this.l=3);const T={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||L?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:L?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??L?.pinned,preRelease:(0,p.$cg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||L?.preRelease,source:"gallery"};if(L&&L.type!==0&&L.manifest.version===this.y.version)try{return[await this.m.updateMetadata(L,T),T]}catch(U){throw new n.$7o((0,O.$0)(U),n.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(T,V)}catch(U){if(U instanceof n.$7o&&(U.code===n.ExtensionManagementErrorCode.CorruptZip||U.code===n.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const x=await this.C(T,V);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),x}catch(x){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),x}}else throw U}}async C(V,z){const{location:L,verificationStatus:T}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=T,this.D(L.fsPath),[await this.u({zipPath:L.fsPath,key:s.$vp.create(this.y),metadata:V},!1,z),V]}catch(U){try{await this.z.delete(L)}catch(x){this.s.warn("Error while deleting the downloaded file",L.toString(),(0,O.$0)(x))}throw U}}async D(V){try{await(0,k.$Aq)(V)}catch(z){throw new n.$7o(z.message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Gq=ie;class re extends B{constructor(V,z,L,T,U,x,K,ee,_,Z){super(V,{id:(0,s.$zp)(V.publisher,V.name)},z,L,U,x,K,ee,_,Z),this.y=z,this.z=T}async h(V){const z=await super.h(V);return this.C(z,V),z}async x(V){const z=new s.$vp(this.identifier,this.manifest.version),T=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(K=>(0,s.$up)(this.identifier,K.identifier)),U={isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??T?.pinned,source:"vsix"};if(T)if(this.l=3,z.equals(new s.$vp(T.identifier,T.manifest.version)))try{await this.m.removeExtension(T,"existing")}catch{throw new Error(d.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&c.gt(T.manifest.version,this.manifest.version)&&await this.m.setUninstalled(T);else{const K=await this.v(z);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(d.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:w.$lc(this.y.fsPath),key:z,metadata:U},!0,V),U]}async C(V,z){try{let[L]=await this.z.getExtensions([{id:V.identifier.id,version:V.manifest.version}],z);if(L||([L]=await this.z.getExtensions([{id:V.identifier.id}],z)),L){const T={id:L.identifier.uuid,publisherDisplayName:L.publisherDisplayName,publisherId:L.publisherId,isPreReleaseVersion:L.properties.isPreReleaseVersion,hasPreReleaseVersion:V.hasPreReleaseVersion||L.properties.isPreReleaseVersion,preRelease:L.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(V,T,this.options.profileLocation)}}catch{}}}class he extends r.$nq{constructor(V,z,L){super(),this.extension=V,this.j=z,this.k=L}async h(V){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[252],ce([0,1,9,18,28,22,52,12,16,8]),function(ne,e,D,N,j,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NQ=void 0;let E=class extends O.$qq{constructor(w,h,c,p,g,l){super(f.URI.file(w.extensionsPath),h,c,p,g,l)}};e.$NQ=E,e.$NQ=E=Ee([Q(0,C.$Ei),Q(1,I.$3k),Q(2,N.$Cl),Q(3,j.$Al),Q(4,A.$2l),Q(5,D.$3j)],E)}),define(ae[253],ce([0,1,8,16,52,81,12,4,9,24,28,18]),function(ne,e,D,N,j,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;let w=class extends A.$xq{constructor(c,p,g,l,u,m,d,$){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,c.defaultProfile,c,p,g,l,u,m,d,$)}};e.$jdc=w,e.$jdc=w=Ee([Q(0,y.$Cl),Q(1,j.$pq),Q(2,O.$3k),Q(3,C.$3j),Q(4,N.$Ei),Q(5,f.$jk),Q(6,E.$Al),Q(7,I.$vi)],w)}),define(ae[19],ce([0,1,6,3,2,98,13,69,4,18]),function(ne,e,D,N,j,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=h,e.$4p=p,e.$6p=l,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,C.$wi)("storageService");var E;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var y;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var w;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function h(u){const m=u.get(e.$Zp);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}class c extends j.$Vc{static{this.a=60*1e3}constructor(m={flushInterval:c.a}){super(),this.m=m,this.b=this.B(new N.$he),this.c=this.B(new N.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new D.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new j.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,d,$){return N.Event.filter(this.b.event,t=>t.scope===m&&(d===void 0||t.key===d),$)}n(){this.j.value=(0,D.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,j.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,d){const{key:$,external:t}=d;if($===e.$Zp){switch(m){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:$,target:this.J(m)[$],external:t})}w(m){this.f.fire({reason:m})}get(m,d,$){return this.P(d)?.get(m,$)}getBoolean(m,d,$){return this.P(d)?.getBoolean(m,$)}getNumber(m,d,$){return this.P(d)?.getNumber(m,$)}getObject(m,d,$){return this.P(d)?.getObject(m,$)}storeAll(m,d){this.y(()=>{for(const $ of m)this.store($.key,$.value,$.scope,$.target,d)})}store(m,d,$,t,r=!1){if((0,O.$fg)(d)){this.remove(m,$,r);return}this.y(()=>{this.z(m,$,t),this.P($)?.set(m,d,r)})}remove(m,d,$=!1){this.y(()=>{this.z(m,d,void 0),this.P(d)?.delete(m,$)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,d){const $=[],t=this.J(m);for(const r of Object.keys(t))t[r]===d&&$.push(r);return $}z(m,d,$,t=!1){const r=this.J(d);typeof $=="number"?r[m]!==$&&(r[m]=$,this.P(d)?.set(e.$Zp,JSON.stringify(r),t)):typeof r[m]=="number"&&(delete r[m],this.P(d)?.set(e.$Zp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(m){switch(m){case-1:return this.I;case 0:return this.G;default:return this.D}}L(m){const d=this.P(m);return d?h(d):Object.create(null)}isNew(m){return this.getBoolean(e.$Yp,m)===!0}async flush(m=E.NONE){this.f.fire({reason:m});const d=this.P(-1),$=this.P(0),t=this.P(1);switch(m){case E.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),$?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),$?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,$=this.P(1)?.items??new Map;return l(m,d,$,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,d){return this.w(E.NONE),(0,f.$Bl)(m)?this.R(m,d):this.S(m,d)}M(m,d){return!(m.id===d.id||p(d)&&p(m))}N(m,d,$){this.y(()=>{const t=new Set;for(const[r,n]of m)t.add(r),d.get(r)!==n&&this.u($,{key:r,external:!0});for(const[r]of d.items)t.has(r)||this.u($,{key:r,external:!0})})}}e.$3p=c;function p(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class g extends c{constructor(){super(),this.U=this.B(new I.$Wp(new I.$Xp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$Wp(new I.$Xp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$Wp(new I.$Xp,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(1,m))),this.B(this.W.onDidChangeStorage(m=>this.u(0,m))),this.B(this.U.onDidChangeStorage(m=>this.u(-1,m)))}P(m){switch(m){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$5p=g;async function l(u,m,d,$,t,r){const n=P=>{try{return JSON.parse(P)}catch{return P}},s=new Map,i=new Map;u.forEach((P,R)=>{s.set(R,P),i.set(R,n(P))});const o=new Map,a=new Map;m.forEach((P,R)=>{o.set(R,P),a.set(R,n(P))});const b=new Map,k=new Map;d.forEach((P,R)=>{b.set(R,P),k.set(R,n(P))}),console.group($!==t?`Storage: Application (path: ${$})`:`Storage: Application & Profile (path: ${$}, default profile)`);const v=[];if(s.forEach((P,R)=>{v.push({key:R,value:P})}),console.table(v),console.groupEnd(),console.log(i),$!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];o.forEach((R,M)=>{P.push({key:M,value:R})}),console.table(P),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const S=[];b.forEach((P,R)=>{S.push({key:R,value:P})}),console.table(S),console.groupEnd(),console.log(k)}}),define(ae[114],ce([0,1,3,2,13,29,33,19]),function(ne,e,D,N,j,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Jb=e.$6Jb=void 0;let C=class extends N.$Vc{constructor(y,w){super(),this.a=new D.$ee,this.onDidChangeEnablement=this.a.event,this.b=this.B(new f(y)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(w.onDidInstallExtensions(h=>h.forEach(({local:c,operation:p})=>{c&&p===4&&this.f(c.identifier)})))}async enableExtension(y,w){return this.f(y)?(this.a.fire({extensions:[y],source:w}),!0):!1}async disableExtension(y,w){return this.c(y)?(this.a.fire({extensions:[y],source:w}),!0):!1}getDisabledExtensions(){return this.h(A.$0o)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(y){const w=this.getDisabledExtensions();return w.every(h=>!(0,O.$up)(h,y))?(w.push(y),this.g(w),!0):!1}f(y){const w=this.getDisabledExtensions();for(let h=0;h<w.length;h++){const c=w[h];if((0,O.$up)(c,y))return w.splice(h,1),this.g(w),!0}return!1}g(y){this.j(A.$0o,y)}h(y){return this.b.get(y,0)}j(y,w){this.b.set(y,w,0)}};e.$6Jb=C,e.$6Jb=C=Ee([Q(0,I.$1p),Q(1,A.$9o)],C);class f extends N.$Vc{constructor(y){super(),this.c=y,this.a=Object.create(null),this.b=this.B(new D.$ee),this.onDidChange=this.b.event,this.B(y.onDidChangeValue(0,void 0,this.B(new N.$Uc))(w=>this.f(w)))}get(y,w){let h;return w===0?((0,j.$fg)(this.a[y])&&(this.a[y]=this.g(y,w)),h=this.a[y]):h=this.g(y,w),JSON.parse(h)}set(y,w,h){const c=JSON.stringify(w.map(({id:g,uuid:l})=>({id:g,uuid:l})));this.g(y,h)!==c&&(h===0&&(w.length?this.a[y]=c:delete this.a[y]),this.h(y,w.length?c:void 0,h))}f(y){if(!(0,j.$fg)(this.a[y.key])&&this.g(y.key,y.scope)!==this.a[y.key]){const h=this.get(y.key,y.scope);delete this.a[y.key];const c=this.get(y.key,y.scope),p=h.filter(l=>!c.some(u=>(0,O.$up)(l,u))),g=c.filter(l=>!h.some(u=>(0,O.$up)(u,l)));(p.length||g.length)&&this.b.fire([...p,...g])}}g(y,w){return this.c.get(y,w,"[]")}h(y,w,h){w?this.c.store(y,w,h,1):this.c.remove(y,h)}}e.$7Jb=f}),define(ae[254],ce([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,233,19,22,63]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0,e.$9p=re;const t=A.$o?"web":(0,y.$2o)(A.$u,O.$fc),r="X-Market-Search-Activity-Id";var n;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...T){return String(T.reduce((U,x)=>U|x,0))}var i;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class v{constructor(U=k){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,x=this.d.pageSize){return new v({...this.d,pageNumber:U,pageSize:x})}withFilter(U,...x){const K=[...this.d.criteria,...x.length?x.map(ee=>({filterType:U,value:ee})):[{filterType:U}]];return new v({...this.d,criteria:K})}withSortBy(U){return new v({...this.d,sortBy:U})}withSortOrder(U){return new v({...this.d,sortOrder:U})}withFlags(...U){return new v({...this.d,flags:U.reduce((x,K)=>x|K,0)})}withAssetTypes(...U){return new v({...this.d,assetTypes:U})}withSource(U){return new v({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:x,pageSize:K,sortBy:ee,sortOrder:_,flags:Z,assetTypes:se}=this.d;return{filters:[{criteria:U,pageNumber:x,pageSize:K,sortBy:ee,sortOrder:_}],assetTypes:se,flags:Z}}get searchText(){const U=this.d.criteria.filter(x=>x.filterType===i.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function S(T,U){const x=(T||[]).filter(K=>K.statisticName===U)[0];return x?x.value:0}function P(T){const U="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(K=>K.assetType.indexOf(U)===0).reduce((K,ee)=>{const _=F(T,ee.assetType);return _&&K.push([ee.assetType.substring(U.length),_]),K},[])}function R(T){if(T.properties){const U=T.properties.filter(ee=>ee.key===o.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=U.filter(ee=>x.test(ee.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return F(T,o.Repository)}function M(T){return{uri:`${T.fallbackAssetUri}/${o.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${o.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function F(T,U){return T.files.filter(K=>K.assetType===U)[0]?{uri:`${T.assetUri}/${U}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${U}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function q(T,U){const x=T.properties?T.properties.filter(ee=>ee.key===U):[],K=x.length>0&&x[0].value;return K?K.split(",").map(ee=>(0,w.$yp)(ee)):[]}function Y(T){const U=T.properties?T.properties.filter(x=>x.key===a.Engine):[];return U.length>0&&U[0].value||""}function H(T){const U=T.properties?T.properties.filter(x=>x.key===a.PreRelease):[];return U.length>0&&U[0].value==="true"}function X(T){const U=T.properties?T.properties.filter(K=>K.key===a.LocalizedLanguages):[],x=U.length>0&&U[0].value||"";return x?x.split(","):[]}function W(T){return T.properties?.find(U=>U.key===a.SponsorLink)?.value}function J(T){return T.properties?.find(U=>U.key===a.SupportLink)?.value}function G(T){return T.indexOf("preview")!==-1}function B(T){return T.targetPlatform?(0,y.$1o)(T.targetPlatform):"undefined"}function ie(T){const U=(0,D.$Mb)(T.versions.map(B)),x=!!T.tags?.includes(y.$Vo),K=U.indexOf("web");return x?K===-1&&U.push("web"):K!==-1&&U.splice(K,1),U}function re(T,U){for(let x=0;x<T.length;x++){const K=T[x];if(K.version===T[x-1]?.version){let ee=x;if(B(K)===U)for(;ee>0&&T[ee-1].version===K.version;)ee--;ee!==x&&(T.splice(x,1),T.splice(ee,0,K))}}return T}function he(T,U,x){T.telemetryData={index:U,querySource:x,queryActivityId:T.queryContext?.[r]}}function te(T,U,x,K){const ee=T.versions[0],_={manifest:F(U,o.Manifest),readme:F(U,o.Details),changelog:F(U,o.Changelog),license:F(U,o.License),repository:R(U),download:M(U),icon:F(U,o.Icon),signature:F(U,o.Signature),coreTranslations:P(U)};return{identifier:{id:(0,w.$zp)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:U.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(ee),description:T.shortDescription??"",installCount:S(T.statistics,"install"),rating:S(T.statistics,"averagerating"),ratingCount:S(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:x,assets:_,properties:{dependencies:q(U,a.Dependency),extensionPack:q(U,a.ExtensionPack),engine:Y(U),localizedLanguages:X(U),targetPlatform:B(U),isPreReleaseVersion:H(U)},hasPreReleaseVersion:H(ee),hasReleaseVersion:!0,preview:G(T.flags),isSigned:!!_.signature,queryContext:K,supportLink:J(ee)}}let V=class{constructor(U,x,K,ee,_,Z,se,ue){this.k=x,this.l=K,this.n=ee,this.o=_,this.q=Z,this.u=se,this.w=ue;const ge=se.extensionsGallery,fe=ge?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=fe?ge.servicePPEUrl:ge?.serviceUrl,this.g=fe?void 0:ge?.searchUrl,this.h=ge?.controlUrl,this.j=(0,u.$8p)(se.version,se,this.n,this.w,this.q,U,this.o)}x(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,x,K){const ee=N.CancellationToken.isCancellationToken(x)?{}:x,_=N.CancellationToken.isCancellationToken(x)?x:K,Z=[],se=[],ue=[],ge=[];let fe=!0;for(const ve of U){ve.uuid?se.push(ve.uuid):Z.push(ve.id);const Ce=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ce}),ve.version&&ge.push({id:ve.id,uuid:ve.uuid,version:ve.version}),fe=fe&&!!ve.hasPreRelease&&!Ce}if(!se.length&&!Z.length)return[];let $e=new v().withPage(1,U.length);se.length&&($e=$e.withFilter(i.ExtensionId,...se)),Z.length&&($e=$e.withFilter(i.ExtensionName,...Z)),(ee.queryAllVersions||fe)&&($e=$e.withFlags($e.flags,n.IncludeVersions)),ee.source&&($e=$e.withSource(ee.source));const{extensions:ye}=await this.z($e,{targetPlatform:ee.targetPlatform??t,includePreRelease:ue,versions:ge,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.u.version,date:this.u.date}},_);return ee.source&&ye.forEach((ve,Ce)=>he(ve,Ce,ee.source)),ye}async getCompatibleExtension(U,x,K,ee={version:this.u.version,date:this.u.date}){if((0,y.$3o)(U.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(U,x,K))return U;const _=new v().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,U.identifier.uuid),{extensions:Z}=await this.z(_,{targetPlatform:K,compatible:!0,includePreRelease:x,productVersion:ee},N.CancellationToken.None);return Z[0]||null}async isExtensionCompatible(U,x,K,ee={version:this.u.version,date:this.u.date}){if(!(0,y.$4o)(U.properties.targetPlatform,U.allTargetPlatforms,K)||!x&&U.properties.isPreReleaseVersion)return!1;let _=U.properties.engine;if(!_){const Z=await this.getManifest(U,N.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");_=Z.engines.vscode}return(0,h.$Mp)(_,ee.version,ee.date)}async y(U,x,K,ee,_,Z,se={version:this.u.version,date:this.u.date}){if(!(0,y.$4o)(B(x),_,Z)||K!=="any"&&H(x)!==(K==="prerelease"))return!1;if(ee)try{const ue=await this.E(U,x);if(!(0,h.$Mp)(ue,se.version,se.date))return!1}catch(ue){return this.l.error(`Error while getting the engine for the version ${x.version}.`,(0,j.$0)(ue)),!1}return!0}async query(U,x){let K=U.text||"";const ee=U.pageSize??50;let _=new v().withPage(1,ee);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,$e,ye)=>(_=_.withFilter(i.Category,ye||$e),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,$e,ye)=>(_=_.withFilter(i.Tag,ye||$e),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),_=_.withFilter(i.SearchText,K)),_=_.withSortBy(0)):U.ids?_=_.withFilter(i.ExtensionId,...U.ids):U.names?_=_.withFilter(i.ExtensionName,...U.names):_=_.withSortBy(4),typeof U.sortBy=="number"&&(_=_.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(_=_.withSortOrder(U.sortOrder)),U.source&&(_=_.withSource(U.source));const Z=async(fe,$e)=>{const{extensions:ye,total:ve}=await this.z(fe,{targetPlatform:t,compatible:!1,includePreRelease:!!U.includePreRelease,productVersion:U.productVersion??{version:this.u.version,date:this.u.date}},$e);return ye.forEach((Ce,De)=>he(Ce,(fe.pageNumber-1)*fe.pageSize+De,U.source)),{extensions:ye,total:ve}},{extensions:se,total:ue}=await Z(_,x),ge=async(fe,$e)=>{if($e.isCancellationRequested)throw new j.$5;const{extensions:ye}=await Z(_.withPage(fe+1),$e);return ye};return{firstPage:se,total:ue,pageSize:_.pageSize,getPage:ge}}async z(U,x,K){const ee=U.flags;U.flags&n.IncludeLatestVersionOnly&&U.flags&n.IncludeVersions&&(U=U.withFlags(U.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(U.flags&n.IncludeLatestVersionOnly)&&!(U.flags&n.IncludeVersions)&&(U=U.withFlags(U.flags,n.IncludeLatestVersionOnly)),x.versions?.length&&(U=U.withFlags(U.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),U=U.withFlags(U.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:_,total:Z,context:se}=await this.B(U,K);if(!(U.flags&n.IncludeLatestVersionOnly)){const $e=[];for(const ye of _){const ve=await this.A(ye,x,se);ve&&$e.push(ve)}return{extensions:$e,total:Z}}const ge=[],fe=new Map;for(let $e=0;$e<_.length;$e++){const ye=_[$e],ve={id:(0,w.$zp)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},Ce=(0,I.$cg)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(le=>(0,w.$up)(le,ve))?.includePreRelease;if(x.compatible&&(0,y.$3o)(ie(ye),x.targetPlatform))continue;const De=await this.A(ye,x,se);!De||De.properties.isPreReleaseVersion&&(!Ce||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==x.targetPlatform&&De.hasPreReleaseVersion?fe.set(ye.extensionId,$e):ge.push([$e,De])}if(fe.size){const $e=new $.$ae,ye=new v().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,fe.size).withFilter(i.ExtensionId,...fe.keys()),{extensions:ve}=await this.z(ye,x,K);this.o.publicLog2("galleryService:additionalQuery",{duration:$e.elapsed(),count:fe.size});for(const Ce of ve){const De=fe.get(Ce.identifier.uuid);ge.push([De,Ce])}}return{extensions:ge.sort(($e,ye)=>$e[0]-ye[0]).map(([,$e])=>$e),total:Z}}async A(U,x,K){const ee={id:(0,w.$zp)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},_=x.versions?.find(ge=>(0,w.$up)(ge,ee))?.version,Z=(0,I.$cg)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(ge=>(0,w.$up)(ge,ee))?.includePreRelease,se=ie(U),ue=re(U.versions,x.targetPlatform);if(x.compatible&&(0,y.$3o)(se,x.targetPlatform))return null;for(let ge=0;ge<ue.length;ge++){const fe=ue[ge];if(!(_&&fe.version!==_)){if(await this.y((0,w.$zp)(U.publisher.publisherName,U.extensionName),fe,Z?"any":"release",x.compatible,se,x.targetPlatform,x.productVersion))return te(U,fe,se,K);if(_&&fe.version===_)return null}}return _||x.compatible?null:te(U,U.versions[0],se)}async B(U,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(n.Unpublished));const K=await this.j,ee=JSON.stringify(U.raw),_={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Z=new $.$ae;let se,ue,ge=0;try{if(se=await this.k.request({type:"POST",url:this.g&&U.criteria.some($e=>$e.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:_},x),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:ge};const fe=await(0,l.$Tp)(se);if(fe){const $e=fe.results[0],ye=$e.extensions,ve=$e.resultMetadata&&$e.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ge=ve&&ve.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ye,total:ge,context:{[r]:se.res.headers.activityid}}}return{galleryExtensions:[],total:ge}}catch(fe){const $e=(0,j.$4)(fe)?y.ExtensionGalleryErrorCode.Cancelled:(0,j.$0)(fe).startsWith("XHR timeout")?y.ExtensionGalleryErrorCode.Timeout:y.ExtensionGalleryErrorCode.Failed;throw ue=new y.$8o((0,j.$0)(fe),$e),ue}finally{this.o.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(ee.length),duration:Z.elapsed(),success:!!se&&(0,l.$Pp)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:ue?.code,count:String(ge)})}}async reportStatistic(U,x,K,ee){if(!this.isEnabled())return;const _=A.$o?this.x(`/itemName/${U}.${x}/version/${K}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${U}/extensions/${x}/${K}/stats?statType=${ee}`),Z=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:Z};try{await this.k.request({type:"POST",url:_,headers:ue},N.CancellationToken.None)}catch{}}async download(U,x,K){this.l.trace("ExtensionGalleryService#download",U.identifier.id);const ee=(0,w.$Cp)(U),_=new Date().getTime(),Z=$e=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:$e}),se=K===2?"install":K===3?"update":"",ue=se?{uri:`${U.assets.download.uri}${C.URI.parse(U.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${U.assets.download.fallbackUri}${C.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:U.assets.download,ge=U.queryContext?.[r]?{[r]:U.queryContext[r]}:void 0,fe=await this.D(U.identifier.id,ue,o.VSIX,ge?{headers:ge}:void 0);await this.q.writeFile(x,fe.stream),Z(new Date().getTime()-_)}async downloadSignatureArchive(U,x){if(!U.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const K=await this.D(U.identifier.id,U.assets.signature,o.Signature);await this.q.writeFile(x,K.stream)}async getReadme(U,x){if(U.assets.readme){const K=await this.D(U.identifier.id,U.assets.readme,o.Details,{},x);return await(0,l.$Sp)(K)||""}return""}async getManifest(U,x){if(U.assets.manifest){const K=await this.D(U.identifier.id,U.assets.manifest,o.Manifest,{},x),ee=await(0,l.$Sp)(K);return ee?JSON.parse(ee):null}return null}async C(U,x,K){const ee=F(x,o.Manifest);if(!ee)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},Z=await this.D(U,ee,o.Manifest,{headers:_});return await(0,l.$Tp)(Z)}async getCoreTranslation(U,x){const K=U.assets.coreTranslations.filter(ee=>ee[0]===x.toUpperCase())[0];if(K){const ee=await this.D(U.identifier.id,K[1],K[0]),_=await(0,l.$Sp)(ee);return _?JSON.parse(_):null}return null}async getChangelog(U,x){if(U.assets.changelog){const K=await this.D(U.identifier.id,U.assets.changelog,o.Changelog,{},x);return await(0,l.$Sp)(K)||""}return""}async getAllCompatibleVersions(U,x,K){let ee=new v().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?ee=ee.withFilter(i.ExtensionId,U.identifier.uuid):ee=ee.withFilter(i.ExtensionName,U.identifier.id);const{galleryExtensions:_}=await this.B(ee,N.CancellationToken.None);if(!_.length)return[];const Z=ie(_[0]);if((0,y.$3o)(Z,K))return[];const se=[];await Promise.all(_[0].versions.map(async fe=>{try{await this.y(U.identifier.id,fe,x?"any":"release",!0,Z,K)&&se.push(fe)}catch{}}));const ue=[],ge=new Set;for(const fe of re(se,K))ge.has(fe.version)||(ge.add(fe.version),ue.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:H(fe)}));return ue}async D(U,x,K,ee={},_=N.CancellationToken.None){const Z=await this.j,se={type:"GET"},ue={...Z,...ee.headers||{}};ee={...ee,...se,headers:ue};const ge=x.uri,fe=x.fallbackUri,$e={...ee,url:ge};try{const ye=await this.k.request($e,_);if(ye.res.statusCode===200)return ye;const ve=await(0,l.$Sp)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${ve}`)}catch(ye){if((0,j.$4)(ye))throw ye;const ve=(0,j.$0)(ye);this.o.publicLog2("galleryService:cdnFallback",{extension:U,assetType:K,message:ve});const Ce={...ee,url:fe};return this.k.request(Ce,_)}}async E(U,x){let K=Y(x);if(!K){this.o.publicLog2("galleryService:engineFallback",{extension:U,version:x.version});const ee=await this.C(U,x,N.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");K=ee.engines.vscode}return K}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const U=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,l.$Tp)(U),K=[],ee={},_=[];if(x){for(const Z of x.malicious)K.push({id:Z});if(x.migrateToPreRelease)for(const[Z,se]of Object.entries(x.migrateToPreRelease))(!se.engine||(0,h.$Mp)(se.engine,this.u.version,this.u.date))&&(ee[Z.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[Z,se]of Object.entries(x.deprecated))se&&(ee[Z.toLowerCase()]=(0,I.$cg)(se)?{}:se);if(x.search)for(const Z of x.search)_.push(Z)}return{malicious:K,deprecated:ee,search:_}}};V=Ee([Q(1,l.$Np),Q(2,p.$3j),Q(3,E.$Di),Q(4,d.$2l),Q(5,c.$3k),Q(6,g.$jk),Q(7,f.$3i)],V);let z=class extends V{constructor(U,x,K,ee,_,Z,se,ue){super(U,x,K,ee,_,Z,se,ue)}};e.$0p=z,e.$0p=z=Ee([Q(0,m.$1p),Q(1,l.$Np),Q(2,p.$3j),Q(3,E.$Di),Q(4,d.$2l),Q(5,c.$3k),Q(6,g.$jk),Q(7,f.$3i)],z);let L=class extends V{constructor(U,x,K,ee,_,Z,se){super(void 0,U,x,K,ee,_,Z,se)}};e.$$p=L,e.$$p=L=Ee([Q(0,l.$Np),Q(1,p.$3j),Q(2,E.$Di),Q(3,d.$2l),Q(4,c.$3k),Q(5,g.$jk),Q(6,f.$3i)],L)}),define(ae[82],ce([0,1,4,3,2,19,33,24,17,9,13]),function(ne,e,D,N,j,A,O,I,C,f,E){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$2v=e.$1v=void 0,e.$1v=(0,D.$wi)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends j.$Vc{static{y=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,O.$yp)(p.id)}@${p.version}`}static c(p){const g=w.exec(p);if(g&&g[1])return{id:g[1],version:g[2]}}static async removeOutdatedExtensionVersions(p,g){const l=await p.getInstalled(),u=[];for(const[m,d]of y.f(g)){const $=l.find(t=>(0,O.$up)(t.identifier,{id:m}))?.manifest.version;for(const t of d)$!==t&&u.push(y.b({id:m,version:t}))}for(const m of u)g.remove(m,0)}static f(p){const g=new Map,l=p.keys(0,1);for(const u of l){const m=y.c(u);if(m){let d=g.get(m.id.toLowerCase());d||g.set(m.id.toLowerCase(),d=[]),d.push(m.version)}}return g}constructor(p,g,l){super(),this.j=p,this.m=g,this.n=l,this.g=this.B(new N.$ee),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=y.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new j.$Uc))(u=>this.r(u)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const g=y.c(p.key);if(g){if(this.j.get(p.key,0)===void 0)this.h.delete(g.id.toLowerCase());else{let l=this.h.get(g.id.toLowerCase());l||this.h.set(g.id.toLowerCase(),l=[]),l.push(g.version),this.g.fire()}return}}s(p){if((0,E.$9f)(p))return p;const g=p.manifest?p.manifest.publisher:p.publisher,l=p.manifest?p.manifest.name:p.name;return(0,O.$xp)(g,l)}getExtensionState(p,g){const l=this.s(p),u=this.getExtensionStateRaw(p,g);if(u)try{return JSON.parse(u)}catch(m){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${g}): ${m}`)}}getExtensionStateRaw(p,g){const l=this.s(p),u=this.j.get(l,g?0:1);return u&&u?.length>y.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${g}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(p,g,l){const u=this.s(p);g===void 0?this.j.remove(u,l?0:1):this.j.store(u,JSON.stringify(g),l?0:1,1)}setKeysForSync(p,g){this.j.store(y.b(p),JSON.stringify(g),0,1)}getKeysForSync(p){const g=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],l=this.j.get(y.b(p),0),u=l?JSON.parse(l):void 0;return u&&g?(0,C.$Mb)([...u,...g]):u||g}addToMigrationList(p,g){if(p!==g){const l=this.t.filter(u=>!u.includes(p)&&!u.includes(g));l.push([p,g]),this.t=l}}getSourceExtensionToMigrate(p){const g=this.t.find(([,l])=>p===l);return g?g[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const g=JSON.parse(p);if(Array.isArray(g))return g}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$2v=h,e.$2v=h=y=Ee([Q(0,A.$1p),Q(1,I.$jk),Q(2,f.$3j)],h)}),define(ae[255],ce([0,1,2,29,82,230,113,9,19]),function(ne,e,D,N,j,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;let f=class extends D.$Vc{constructor(y,w,h,c,p,g){super(),y.cleanUp(),(0,A.$I4b)(y,w,h,c,g),j.$2v.removeOutdatedExtensionVersions(y,p)}};e.$zec=f,e.$zec=f=Ee([Q(0,O.$Dq),Q(1,N.$6o),Q(2,j.$1v),Q(3,N.$_o),Q(4,C.$1p),Q(5,I.$3j)],f)}),define(ae[256],ce([0,1,29,12,24,16,96,57,19,22,229]),function(ne,e,D,N,j,A,O,I,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;let y=class extends E.$Vac{constructor(h,c,p,g,l,u,m,d){super(h.userHome,l,c,p,g,u,m,d)}};e.$Gec=y,e.$Gec=y=Ee([Q(0,A.$Ei),Q(1,f.$2l),Q(2,D.$9o),Q(3,C.$1p),Q(4,I.$wcc),Q(5,O.$s4b),Q(6,N.$3k),Q(7,j.$jk)],y)}),define(ae[257],ce([0,1,104,3,22,16,2,9,14,67,24,5,6,99,21,170,37,19,13,132,20]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;const $=[D.$vec,D.$wec],t="remoteTunnelSession",r="remoteTunnelIsService";let n=class extends O.$Vc{constructor(a,b,k,v,S,P,R){super(),this.y=a,this.z=b,this.C=k,this.D=P,this.F=R,this.f=new N.$ee,this.onDidTokenFailed=this.f.event,this.g=new N.$ee,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$ee,this.onDidChangeMode=this.h.event,this.n=D.$tec,this.w=!1,this.I=(M,F)=>{F?this.j.error(M):this.j.info(M)},this.j=this.B(v.createLogger((0,d.$0g)(k.logsHome,`${D.$xec}.log`),{id:D.$xec,name:D.$yec})),this.t=new w.$th(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,I.$fk)(M)))),this.B(S.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(P.onDidChangeConfiguration(M=>{$.some(F=>M.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){i(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(b){this.j.error(b)}return this.s}J(){if(!this.u){let a;y.$j?a=this.C.appRoot:a=(0,C.$nc)((0,C.$nc)(this.C.appRoot)),this.u=(0,C.$kc)(a,"bin",`${this.z.tunnelApplicationName}${y.$i?".exe":""}`)}return this.u}async startTunnel(a){if(i(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(b){this.j.error(b)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(D.$tec);try{a&&this.O("uninstallService",["service","uninstall"])}catch(b){this.j.error(b)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",b=!1;const k=(F,q)=>{q?this.j.error(F):a+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,p.localize)(0,null)))},v=this.O("status",["status"],k);this.r=v;try{if(await v,this.r!==v)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(q=>q.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(D.TunnelStates.disconnected());return}if(b=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(D.TunnelStates.disconnected());return}finally{this.r===v&&(this.r=void 0)}const S=this.n.active?this.n.session:void 0;if(S&&S.token){const F=S.token;this.G(D.TunnelStates.connecting((0,p.localize)(1,null,S.accountLabel,S.providerId)));const q=(H,X)=>{H=H.replaceAll(F,"*".repeat(4)),k(H,X)},Y=this.O("login",["user","login","--provider",S.providerId,"--access-token",F,"--log",(0,I.$fk)(this.j.getLevel())],q);this.r=Y;try{if(await Y,this.r!==Y)return}catch(H){this.j.error(H),this.r=void 0,this.f.fire(S),this.G(D.TunnelStates.disconnected(S));return}}const P=this.Q();P?this.G(D.TunnelStates.connecting((0,p.localize)(2,null,P))):this.G(D.TunnelStates.connecting((0,p.localize)(3,null)));const R=["--accept-server-license-terms","--log",(0,I.$fk)(this.j.getLevel())];P?R.push("--name",P):R.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!b&&(M=await this.M(R)===!1),this.N(S,R,M)}async M(a){let b;try{b=await this.O("serviceInstall",["service","install",...a])}catch(k){this.j.error(k),b=1}if(b!==0){const k=(0,p.localize)(4,null);return this.j.warn(k),this.G(D.TunnelStates.connecting(k)),!1}return!0}async N(a,b,k){b.push("--parent-process-id",String(process.pid)),this.P()&&b.push("--no-sleep");let v=!1;const S=this.O("tunnel",b,(P,R)=>{R?this.j.error(P):this.j.info(P),P.includes("Connected to an existing tunnel process")&&(v=!0);const M=P.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const F={link:M[1],domain:M[2],tunnelName:M[4],isAttached:v};this.G(D.TunnelStates.connected(F,k))}else P.match(/error refreshing token/)&&(S.cancel(),this.f.fire(a),this.G(D.TunnelStates.disconnected(a)))});this.r=S,S.finally(()=>{S===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$tec,this.G(D.TunnelStates.disconnected()))})}O(a,b,k=this.I){return(0,w.$jh)(v=>new Promise((S,P)=>{v.isCancellationRequested&&S(-1);let R;const M=["ignore","pipe","pipe"];if(v.onCancellationRequested(()=>{R&&(this.j.info(`${a} terminating(${R.pid})`),R.kill())}),!this.C.isBuilt)k(`Building tunnel CLI from sources and run
`,!1),k(`${a} Spawning: cargo run -- tunnel ${b.join(" ")}
`,!1),R=(0,f.spawn)("cargo",["run","--","tunnel",...b],{cwd:(0,C.$kc)(this.C.appRoot,"cli"),stdio:M});else{k(`Running tunnel CLI
`,!1);const F=this.J();k(`${a} Spawning: ${F} tunnel ${b.join(" ")}
`,!1),R=(0,f.spawn)(F,["tunnel",...b],{cwd:(0,g.homedir)(),stdio:M})}R.stdout.pipe(new m.$PW(`
`)).on("data",F=>{if(R){const q=F.toString();k(q,!1)}}),R.stderr.pipe(new m.$PW(`
`)).on("data",F=>{if(R){const q=F.toString();k(q,!0)}}),R.on("exit",F=>{R&&(k(`${a} exit(${R.pid}): + ${F} `,!1),R=void 0,S(F||0))}),R.on("error",F=>{R&&(k(`${a} error(${R.pid}): + ${F} `,!0),R=void 0,P())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$wec)}Q(){let a=this.D.getValue(D.$vec)||(0,g.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(t,-1),b=this.F.getBoolean(r,-1,!1);if(a){const k=JSON.parse(a);if(k&&(0,u.$9f)(k.accountLabel)&&(0,u.$9f)(k.sessionId)&&(0,u.$9f)(k.providerId))return{active:!0,session:k,asService:b};this.j.error("Problems restoring session from storage, invalid format",k)}}catch(a){this.j.error("Problems restoring session from storage",a)}return D.$tec}S(a){if(a.active){const b={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(t,JSON.stringify(b),-1,1),this.F.store(r,a.asService,-1,1)}else this.F.remove(t,-1),this.F.remove(r,-1)}};e.$Cec=n,e.$Cec=n=Ee([Q(0,j.$2l),Q(1,E.$jk),Q(2,A.$Ei),Q(3,I.$4j),Q(4,h.$Aec),Q(5,c.$3i),Q(6,l.$1p)],n);function s(o,a){return o&&a?o.sessionId===a.sessionId&&o.providerId===a.providerId&&o.token===a.token:o===a}const i=(o,a)=>o.active!==a.active?!1:o.active&&a.active?o.asService===a.asService&&s(o.session,a.session):!0}),define(ae[258],ce([0,1,6,2,23,20,69,19,77,18]),function(ne,e,D,N,j,A,O,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;class E extends I.$3p{constructor(w,h,c,p){super(),this.bb=w,this.cb=h,this.db=c,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Uc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Uc),this.ab=this.hb(this.bb)}fb(){const w=this.B(new C.$FKb(this.db.getChannel("storage"))),h=this.B(new O.$Wp(w));return this.B(h.onDidChangeStorage(c=>this.u(-1,c))),h}gb(w){this.X.clear(),this.W=w;let h;if((0,I.$4p)(w))h=this.U;else{const c=this.X.add(new C.$GKb(this.db.getChannel("storage"),w));h=this.X.add(new O.$Wp(c))}return this.X.add(h.onDidChangeStorage(c=>this.u(0,c))),h}hb(w){this.$.clear(),this.Z=w?.id;let h;if(w){const c=this.$.add(new C.$HKb(this.db.getChannel("storage"),w));h=this.$.add(new O.$Wp(c)),this.$.add(h.onDidChangeStorage(p=>this.u(1,p)))}return h}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(w){switch(w){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(w){switch(w){case-1:return this.s.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$0g)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:j.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(w){if(!this.M(this.W,w))return;const h=this.Y,c=h.items;h!==this.U&&await h.close(),this.Y=this.gb(w),await this.Y.init(),this.N(c,this.Y,0)}async S(w,h){const c=this.ab,p=c?.items??new Map;await c?.close(),this.ab=this.hb(w),await this.ab.init(),this.N(p,this.ab,1)}hasScope(w){return(0,f.$Bl)(w)?this.W.id===w.id:this.Z===w.id}}e.$Hec=E}),define(ae[259],ce([0,1,3,2,18,91]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VQ=e.$UQ=void 0;class O{constructor(f,E){this.a=f,this.b=E}listen(f,E){const y=this.b(f);switch(E){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(h=>(0,A.$An)({...h},y)),added:w.added.map(h=>(0,A.$An)({...h},y)),removed:w.removed.map(h=>(0,A.$An)({...h},y)),updated:w.updated.map(h=>(0,A.$An)({...h},y))}))}throw new Error(`Invalid listen ${E}`)}async call(f,E,y){const w=this.b(f);switch(E){case"createProfile":{const h=await this.a.createProfile(y[0],y[1],y[2]);return(0,A.$An)({...h},w)}case"updateProfile":{let h=(0,j.$Dl)((0,A.$Bn)(y[0],w),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,y[1]),(0,A.$An)({...h},w)}case"removeProfile":{const h=(0,j.$Dl)((0,A.$Bn)(y[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${E}`)}}e.$UQ=O;class I extends N.$Vc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(f,E,y){super(),this.profilesHome=E,this.f=y,this.a=[],this.b=this.B(new D.$ee),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=f.map(w=>(0,j.$Dl)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const h=w.added.map(g=>(0,j.$Dl)(g,this.profilesHome.scheme)),c=w.removed.map(g=>(0,j.$Dl)(g,this.profilesHome.scheme)),p=w.updated.map(g=>(0,j.$Dl)(g,this.profilesHome.scheme));this.a=w.all.map(g=>(0,j.$Dl)(g,this.profilesHome.scheme)),this.b.fire({added:h,removed:c,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(f){this.c=f}isEnabled(){return this.c}async createNamedProfile(f,E,y){const w=await this.f.call("createNamedProfile",[f,E,y]);return(0,j.$Dl)(w,this.profilesHome.scheme)}async createProfile(f,E,y,w){const h=await this.f.call("createProfile",[f,E,y,w]);return(0,j.$Dl)(h,this.profilesHome.scheme)}async createTransientProfile(f){const E=await this.f.call("createTransientProfile",[f]);return(0,j.$Dl)(E,this.profilesHome.scheme)}async setProfileForWorkspace(f,E){await this.f.call("setProfileForWorkspace",[f,E])}removeProfile(f){return this.f.call("removeProfile",[f])}async updateProfile(f,E){const y=await this.f.call("updateProfile",[f,E]);return(0,j.$Dl)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$VQ=I}),define(ae[60],ce([0,1,2,69,4,19,3,77,18]),function(ne,e,D,N,j,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LKb=e.$KKb=e.$JKb=void 0,e.$JKb=(0,j.$wi)("IUserDataProfileStorageService");let f=class extends D.$Vc{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async c=>this.b(c))}async updateStorageData(h,c,p){return this.withProfileScopedStorageService(h,async g=>this.c(g,c,p))}async withProfileScopedStorageService(h,c){if(this.a.hasScope(h))return c(this.a);const p=await this.g(h),g=new y(p);try{await g.initialize();const l=await c(g);return await g.flush(),l}finally{g.dispose(),await this.f(p)}}b(h){const c=new Map,p=g=>{for(const l of h.keys(0,g))c.set(l,{value:h.get(l,0),target:g})};return p(0),p(1),c}c(h,c,p){h.storeAll(Array.from(c.entries()).map(([g,l])=>({key:g,value:l,scope:0,target:p})),!0)}async f(h){try{await h.close()}finally{(0,D.$Pc)(h)&&h.dispose()}}};e.$KKb=f,e.$KKb=f=Ee([Q(0,A.$1p)],f);class E extends f{constructor(h,c,p,g){super(p),this.j=h;const l=h.getChannel("profileStorageListener"),u=this.B(new D.$Wc);this.h=this.B(new O.$ee({onWillAddFirstListener:()=>{u.value=l.listen("onDidChange")(m=>{g.trace("profile storage changes",m),this.h.fire({targetChanges:m.targetChanges.map(d=>(0,C.$Dl)(d,c.profilesHome.scheme)),valueChanges:m.valueChanges.map(d=>({...d,profile:(0,C.$Dl)(d.profile,c.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(h){const c=this.j.getChannel("storage");return(0,A.$4p)(h)?new I.$FKb(c):new I.$GKb(c,h)}}e.$LKb=E;class y extends A.$3p{constructor(h){super({flushInterval:100}),this.s=this.B(new N.$Wp(h))}O(){return this.s.init()}P(h){return h===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ae[260],ce([0,1,19,9,18,56,60]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;let I=class extends O.$LKb{constructor(f,E,y,w){super(f,E,y,w)}};e.$mec=I,e.$mec=I=Ee([Q(0,A.$Ldc),Q(1,j.$Cl),Q(2,D.$1p),Q(3,N.$3j)],I)}),define(ae[39],ce([0,1,17,6,15,26,3,35,2,27,13,175,21,16,12,9,45,19,22,28,25,18]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KLb=e.$JLb=e.$ILb=e.$HLb=void 0,e.$ELb=t,e.$FLb=r,e.$GLb=n;function t(b){return!!(b&&b.ref!==void 0&&typeof b.ref=="string"&&b.ref!==""&&b.syncData!==void 0&&(b.syncData===null||r(b.syncData)))}function r(b){return!!(b&&b.version!==void 0&&typeof b.version=="number"&&b.content!==void 0&&typeof b.content=="string"&&(Object.keys(b).length===2||Object.keys(b).length===3&&b.machineId!==void 0&&typeof b.machineId=="string"))}function n(b,k){return`${(0,f.$1f)(b)}${k.isDefault?"":` (${k.name})`}`}let s=class extends C.$Vc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(k,v,S,P,R,M,F,q,Y,H,X,W){super(),this.syncResource=k,this.collection=v,this.G=S,this.H=P,this.I=R,this.J=M,this.L=F,this.M=q,this.N=Y,this.O=H,this.P=X,this.c=null,this.m="idle",this.n=this.B(new O.$ee),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$ee),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$uh(50)),this.w=this.B(new O.$ee),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(k.syncResource,k.profile),this.h=W.extUri,this.f=this.h.joinPath(P.userDataSyncHome,...(0,d.$3kb)(k.profile.isDefault?void 0:k.profile.id,k.syncResource)),this.g=this.h.joinPath(this.f,d.$llb),this.y=(0,d.$4kb)(k.profile.isDefault?void 0:k.profile.id,k.syncResource,P,this.h),this.j=(0,g.$7p)(P,S,R)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const k=await this.c;this.c=null;const v=await this.Y(k.remoteUserData,k.lastSyncUserData,!0,this.ob());this.S(v)}else{this.O.trace(`${this.D}: Checking for local changes...`);const k=await this.getLastSyncUserData();(k?await this.ub(k):!0)&&this.w.fire()}}S(k){this.m!==k&&(this.m=k,this.n.fire(k))}async sync(k,v={}){await this.U(k,!0,this.ob(),v)}async preview(k,v,S={}){return this.U(k,!1,v,S)}async apply(k,v={}){try{this.F={...v};const S=await this.ab(k);return this.S(S),this.c}finally{this.F={}}}async U(k,v,S,P){try{if(this.F={...P},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let R="idle";try{const M=await this.getLastSyncUserData(),F=await this.X(k,M);return R=await this.Y(F,M,v,S),R==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):R==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(R)}}finally{this.F={}}}async replace(k){const v=this.kb(k);if(!v)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const S=await this.getLastSyncUserData(),P=await this.X(null,S),R=await this.W(P),M=await this.qb({ref:P.ref,syncData:v},S,R,this.ob(),A.CancellationToken.None),F=[];for(const q of M){const Y=await this.sb(q,q.remoteResource,void 0,A.CancellationToken.None),{remoteChange:H}=await this.sb(q,q.previewResource,q.remoteContent,A.CancellationToken.None);F.push([q,{...Y,remoteChange:H!==0?H:2}])}await this.tb(P,S,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(k){const v=await this.j;return!!k.syncData?.machineId&&k.syncData.machineId===v}async X(k,v){if(v){const S=k?k[this.resource]:void 0;if(v.ref===S||S===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async Y(k,v,S,P){if(k.syncData&&k.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new d.$$kb((0,y.localize)(0,null,this.resource,this.pb,k.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(k,v,S,P)}catch(R){if(R instanceof d.$$kb)switch(R.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(k,v,S,P);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),k=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.Y(k,v,S,P)}throw R}}async Z(k,v,S,P){try{const R=await this.W(k),M=!R&&v===null&&this.gb()!==void 0,F=S&&!M;this.c||(this.c=(0,N.$jh)(Y=>this.eb(k,v,R,F,P,Y)));let q=await this.c;if(S&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of q.resourcePreviews)q=await this.accept(Y.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":S?await this.ab(!1):"syncing"}catch(R){throw this.c=null,R}}async merge(k){return await this.$(k,async v=>{const S=await this.rb(v,A.CancellationToken.None);await this.G.writeFile(v.previewResource,j.$Ge.fromString(S?.content||""));const P=S&&!S.hasConflicts?await this.sb(v,v.previewResource,void 0,A.CancellationToken.None):void 0;return v.acceptResult=P,v.mergeState=S.hasConflicts?"conflict":P?"accepted":"preview",v.localChange=P?P.localChange:S.localChange,v.remoteChange=P?P.remoteChange:S.remoteChange,v}),this.c}async accept(k,v){return await this.$(k,async S=>{const P=await this.sb(S,k,v,A.CancellationToken.None);return S.acceptResult=P,S.mergeState="accepted",S.localChange=P.localChange,S.remoteChange=P.remoteChange,S}),this.c}async discard(k){return await this.$(k,async v=>{const S=await this.rb(v,A.CancellationToken.None);return await this.G.writeFile(v.previewResource,j.$Ge.fromString(S.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=S.localChange,v.remoteChange=S.remoteChange,v}),this.c}async $(k,v){if(!this.c)return;let S=await this.c;const P=S.resourcePreviews.findIndex(({localResource:R,remoteResource:M,previewResource:F})=>this.h.isEqual(R,k)||this.h.isEqual(M,k)||this.h.isEqual(F,k));P!==-1&&(this.c=(0,N.$jh)(async R=>{const M=[...S.resourcePreviews];return M[P]=await v(M[P]),{...S,resourcePreviews:M}}),S=await this.c,this.cb(S.resourcePreviews),S.resourcePreviews.some(({mergeState:R})=>R==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(k){if(!this.c)return"idle";const v=await this.c;return v.resourcePreviews.some(({mergeState:S})=>S==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:S})=>S!=="accepted")?"syncing":(await this.tb(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(S=>[S,S.acceptResult]),k),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(k){const v=k.filter(({mergeState:S})=>S==="conflict");(0,D.$ub)(this.s,v,(S,P)=>this.h.isEqual(S.previewResource,P.previewResource))||(this.s=v,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const k=await this.getLastSyncUserData();return!!k&&k.syncData!==null}async db(k){const v=this.c?await this.c:null;if(v)for(const S of v.resourcePreviews){if(this.h.isEqual(S.acceptedResource,k))return S.acceptResult?S.acceptResult.content:null;if(this.h.isEqual(S.remoteResource,k))return S.remoteContent;if(this.h.isEqual(S.localResource,k))return S.localContent;if(this.h.isEqual(S.baseResource,k))return S.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(k){(0,c.$hl)(k)!==1&&this.O.error(k)}}async eb(k,v,S,P,R,M){const F=await this.qb(k,v,S,R,M),q=[];for(const Y of F){const H=Y.previewResource.with({scheme:d.$klb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)q.push({...Y,acceptedResource:H,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=P?await this.rb(Y,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,j.$Ge.fromString(X?.content||""));const W=X&&!X.hasConflicts?await this.sb(Y,Y.previewResource,void 0,M):void 0;q.push({...Y,acceptResult:W,mergeState:X?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:X?X.localChange:Y.localChange,remoteChange:W?W.remoteChange:X?X.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:k,lastSyncUserData:v,resourcePreviews:q,isLastSyncFromCurrentMachine:S}}async getLastSyncUserData(){let k=this.gb();if(k||(k=await this.jb()),!k)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const v=JSON.parse(k),S=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!v.version&&!!S&&v.version!==S,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;let P,R=1;for(;P===void 0&&R++<6;)try{const M=await this.hb();M&&(M.ref===v.ref?P=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof c.$ll&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof d.$$kb)throw M;this.O.error(M,R)}}if(P===void 0)try{const M=await this.J.resolveResourceContent(this.resource,v.ref,this.collection,this.F);P=M===null?null:this.kb(M),await this.ib({ref:v.ref,syncData:P})}catch(M){if(M instanceof d.$$kb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return P===void 0?null:{...v,syncData:P}}async fb(k,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const S=this.M.getResourceSyncStateVersion(this.resource),P={ref:k.ref,version:S,...v};this.I.store(this.z,JSON.stringify(P),-1,1),await this.ib(k)}gb(){return this.I.get(this.z,-1)}async hb(){const k=(await this.G.readFile(this.y)).value.toString();try{const v=k?JSON.parse(k):void 0;if(t(v))return v}catch(v){this.O.error(v)}}async ib(k){await this.G.writeFile(this.y,j.$Ge.fromString(JSON.stringify(k)))}async jb(){try{const k=await this.G.readFile(this.y),v=JSON.parse(k.value.toString());await this.G.del(this.y),v.ref&&v.content!==void 0?(this.I.store(this.z,JSON.stringify({...v,content:void 0}),-1,1),await this.ib({ref:v.ref,syncData:v.content===null?null:JSON.parse(v.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,v)}catch(k){k instanceof c.$ll&&k.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(k)}return this.I.get(this.z,-1)}async getRemoteUserData(k){const{ref:v,content:S}=await this.lb(k);let P=null;return S!==null&&(P=this.kb(S)),{ref:v,syncData:P}}kb(k){try{const v=JSON.parse(k);if(r(v))return v}catch(v){this.O.error(v)}throw new d.$$kb((0,y.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(k){const v=k?{ref:k.ref,content:k.syncData?JSON.stringify(k.syncData):null}:null;return this.J.readResource(this.resource,v,this.collection,this.F)}async mb(k,v){const S=await this.j,P={version:this.pb,machineId:S,content:k};try{return v=await this.J.writeResource(this.resource,JSON.stringify(P),v,this.collection,this.F),{ref:v,syncData:P}}catch(R){throw R instanceof d.$$kb&&R.code==="TooLarge"&&(R=new d.$$kb(R.message,R.code,this.resource)),R}}async nb(k){const v={version:this.pb,content:k};return this.L.writeResource(this.resource,JSON.stringify(v),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(d.$Xkb)}};e.$HLb=s,e.$HLb=s=Ee([Q(2,c.$3k),Q(3,h.$Di),Q(4,l.$1p),Q(5,d.$6kb),Q(6,d.$7kb),Q(7,d.$dlb),Q(8,u.$2l),Q(9,d.$ilb),Q(10,w.$3i),Q(11,m.$Al)],s);let i=class extends s{constructor(k,v,S,P,R,M,F,q,Y,H,X,W,J){super(v,S,P,R,M,F,q,Y,H,X,W,J),this.r=k,this.B(this.G.watch(this.h.dirname(k))),this.B(this.G.onDidFilesChange(G=>this.yb(G)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(k,v,S){try{v?await this.G.writeFile(this.r,j.$Ge.fromString(k),S?void 0:v):await this.G.createFile(this.r,j.$Ge.fromString(k),{overwrite:S})}catch(P){throw P instanceof c.$ll&&P.fileOperationResult===1||P instanceof c.$ll&&P.fileOperationResult===3?new d.$$kb(P.message,"LocalPreconditionFailed"):P}}async xb(){try{await this.G.del(this.r)}catch(k){if(!(k instanceof c.$ll&&k.fileOperationResult===1))throw k}}yb(k){k.contains(this.r)&&this.Q()}};e.$ILb=i,e.$ILb=i=Ee([Q(3,c.$3k),Q(4,h.$Di),Q(5,l.$1p),Q(6,d.$6kb),Q(7,d.$7kb),Q(8,d.$dlb),Q(9,u.$2l),Q(10,d.$ilb),Q(11,w.$3i),Q(12,m.$Al)],i);let o=class extends i{constructor(k,v,S,P,R,M,F,q,Y,H,X,W,J,G){super(k,v,S,P,R,M,F,q,Y,H,X,J,G),this.zb=W,this.Bb=void 0}Ab(k,v){const S=[],P=(0,I.$Jn)(k,S,{allowEmptyContent:!0,allowTrailingComma:!0});return S.length>0||!(0,E.$dg)(P)&&v!==Array.isArray(P)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$JLb=o,e.$JLb=o=Ee([Q(3,c.$3k),Q(4,h.$Di),Q(5,l.$1p),Q(6,d.$6kb),Q(7,d.$7kb),Q(8,d.$dlb),Q(9,u.$2l),Q(10,d.$ilb),Q(11,d.$hlb),Q(12,w.$3i),Q(13,m.$Al)],o);let a=class{constructor(k,v,S,P,R,M,F){this.resource=k,this.g=v,this.h=S,this.j=P,this.k=R,this.l=M,this.d=F.extUri,this.f=(0,d.$4kb)(void 0,this.resource,S,this.d)}async initialize({ref:k,content:v}){if(!v){this.j.info("Remote content does not exist.",this.resource);return}const S=this.m(v);if(S)try{await this.o({ref:k,syncData:S})}catch(P){this.j.error(P)}}m(k){try{const v=JSON.parse(k);if(r(v))return v}catch(v){this.j.error(v)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(k,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const S={ref:k.ref,version:void 0,...v};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(S),-1,1),await this.k.writeFile(this.f,j.$Ge.fromString(JSON.stringify(k)))}};e.$KLb=a,e.$KLb=a=Ee([Q(1,$.$Cl),Q(2,h.$Di),Q(3,p.$3j),Q(4,c.$3k),Q(5,l.$1p),Q(6,m.$Al)],a)}),define(ae[115],ce([0,1,6,26,7,3,44,2,27,21,16,114,29,33,82,48,12,4,74,9,19,22,28,18,39,241,111,25,60]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=e.$3$b=e.$2$b=void 0,e.$Z$b=k,e.$1$b=v;async function b(M,F){const q=JSON.parse(M.content);if(M.version===1||M.version===2){const Y=(await F.getInstalled(0)).filter(H=>H.isBuiltin);for(const H of q)M.version===1&&(H.enabled===!1&&(H.disabled=!0),delete H.enabled),M.version===2&&Y.every(X=>!(0,h.$up)(X.identifier,H.identifier))&&(H.installed=!0)}return q}function k(M){return JSON.parse(M.content)}function v(M,F){return M.sort((q,Y)=>!q.identifier.uuid&&Y.identifier.uuid?-1:q.identifier.uuid&&!Y.identifier.uuid?1:(0,C.$rf)(q.identifier.id,Y.identifier.id)),F?(0,O.$Un)(M,{}):JSON.stringify(M)}let S=class extends n.$HLb{constructor(F,q,Y,H,X,W,J,G,B,ie,re,he,te,V,z,L,T){super({syncResource:"extensions",profile:F},q,H,Y,X,W,J,he,te,ie,re,z),this.Cb=G,this.Db=B,this.Eb=T,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$klb,authority:"base"}),this.yb=this.wb.with({scheme:o.$klb,authority:"local"}),this.zb=this.wb.with({scheme:o.$klb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$klb,authority:"accepted"}),this.Bb=this.Eb.createInstance(P),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,U=>U.some(({local:x})=>!!x)),A.Event.filter(this.Cb.onDidUninstallExtension,U=>!U.error),A.Event.filter(L.onDidChange,U=>U.valueChanges.some(({profile:x,changes:K})=>this.syncResource.profile.id===x.id&&K.some(ee=>ee.key===w.$0o))),V.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,q){const Y=F.syncData?await b(F.syncData,this.Cb):null,H=q?.skippedExtensions??[],X=q?.builtinExtensions??null,W=q?.syncData?await b(q.syncData,this.Cb):null,{localExtensions:J,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ie}=(0,s.$Y$b)(J,Y,W,H,G,X),re={local:B,remote:ie,content:this.Hb(J,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:ie!==null?2:0},he=this.Ob(J,!1);return[{skippedExtensions:H,builtinExtensions:X,baseResource:this.xb,baseContent:W?this.Ob(W,!1):he,localResource:this.yb,localContent:he,localExtensions:J,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(F){const q=F.syncData?await b(F.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,s.$Y$b)(Y,q,q,F.skippedExtensions||[],H,F.builtinExtensions||[]);return X!==null}Hb(F,q,Y,H){const X=[...q,...Y],W=new Set,J=G=>{W.add(G.id.toLowerCase()),G.uuid&&W.add(G.uuid)};X.forEach(({identifier:G})=>J(G)),H.forEach(J);for(const G of F)W.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&W.has(G.identifier.uuid)||X.push(G);return this.Ob(X,!1)}async rb(F,q){return{...F.previewResult,hasConflicts:!1}}async sb(F,q,Y,H){if(this.h.isEqual(q,this.yb))return this.Kb(F);if(this.h.isEqual(q,this.zb))return this.Lb(F);if(this.h.isEqual(q,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(F){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),H=(0,s.$Y$b)(F.localExtensions,null,null,F.skippedExtensions,Y,F.builtinExtensions),{local:X,remote:W}=H;return{content:F.localContent,local:X,remote:W,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(F){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),H=F.remoteContent?JSON.parse(F.remoteContent):null;if(H!==null){const X=(0,s.$Y$b)(F.localExtensions,H,F.localExtensions,[],Y,F.builtinExtensions),{local:W,remote:J}=X;return{content:F.remoteContent,local:W,remote:J,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:J!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(F,q,Y,H){let{skippedExtensions:X,builtinExtensions:W,localExtensions:J}=Y[0][0];const{local:G,remote:B,localChange:ie,remoteChange:re}=Y[0][1];if(ie===0&&re===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(J)),X=await this.Bb.updateLocalExtensions(G.added,G.removed,G.updated,X,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const he=JSON.stringify(B.all);F=await this.mb(he,H?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(te=>te.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(te=>te.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(te=>te.identifier.id))}.`:""}`)}q?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(J,W),await this.fb(F,{skippedExtensions:X,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(he=>he.identifier.id))}.`:""}`))}Nb(F,q){const Y=new Set,H=[];for(const X of F)Y.add(X.identifier.id.toLowerCase()),X.installed||H.push(X.identifier);if(q)for(const X of q)Y.has(X.id.toLowerCase())||H.push(X);return H}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const q=await this.db(F);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(F,q){return v(F,q)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$2$b=S,e.$2$b=S=Ee([Q(2,E.$Di),Q(3,g.$3k),Q(4,d.$1p),Q(5,o.$6kb),Q(6,o.$7kb),Q(7,w.$9o),Q(8,i.$tMb),Q(9,o.$ilb),Q(10,f.$3i),Q(11,o.$dlb),Q(12,$.$2l),Q(13,c.$1v),Q(14,t.$Al),Q(15,a.$JKb),Q(16,l.$vi)],S);let P=class{constructor(F,q,Y,H,X,W){this.a=F,this.b=q,this.c=Y,this.d=H,this.f=X,this.g=W}async getLocalExtensions(F){const q=await this.a.getInstalled(void 0,F.extensionsResource),Y=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(F,async(X,W)=>{const J=X.getDisabledExtensions();return q.map(G=>{const{identifier:B,isBuiltin:ie,manifest:re,preRelease:he,pinned:te,isApplicationScoped:V}=G,z={identifier:B,preRelease:he,version:re.version,pinned:!!te};V&&!(0,p.$Um)(re)&&(z.isApplicationScoped=V),J.some(L=>(0,h.$up)(L,B))&&(z.disabled=!0),ie||(z.installed=!0);try{const L=W.getKeysForSync({id:B.id,version:re.version});if(L){const T=W.getExtensionState(G,!0)||{};z.state=Object.keys(T).reduce((U,x)=>(L.includes(x)&&(U[x]=T[x]),U),{})}}catch(L){this.g.info(`${(0,n.$GLb)("extensions",F)}: Error while parsing extension state`,(0,j.$0)(L))}return z})}),ignoredExtensions:Y}}async updateLocalExtensions(F,q,Y,H,X){const W=(0,n.$GLb)("extensions",X),J=[],G=new Map,B=[],ie=[],re=await this.a.getInstalled(void 0,X.extensionsResource);if((F.length||Y.length)&&await this.j(X,async(V,z)=>{await D.Promises.settled([...F,...Y].map(async L=>{const T=re.find(K=>(0,h.$up)(K.identifier,L.identifier));if(T&&T.isBuiltin){L.state&&T.manifest.version===L.version&&this.h(L.state,T,T.manifest.version,z),V.getDisabledExtensions().some(ee=>(0,h.$up)(ee,L.identifier))!==!!L.disabled&&(L.disabled?(this.g.trace(`${W}: Disabling extension...`,L.identifier.id),await V.disableExtension(L.identifier),this.g.info(`${W}: Disabled extension`,L.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,L.identifier.id),await V.enableExtension(L.identifier),this.g.info(`${W}: Enabled extension`,L.identifier.id))),B.push(L.identifier);return}const U=L.pinned?L.version:void 0,x=(await this.c.getExtensions([{...L.identifier,version:U,preRelease:U?void 0:L.preRelease}],N.CancellationToken.None))[0];if(L.state&&(T?T.manifest.version===L.version:x)&&this.h(L.state,T||x,T?.manifest.version,z),x)try{V.getDisabledExtensions().some(ee=>(0,h.$up)(ee,L.identifier))!==!!L.disabled&&(L.disabled?(this.g.trace(`${W}: Disabling extension...`,L.identifier.id,x.version),await V.disableExtension(x.identifier),this.g.info(`${W}: Disabled extension`,L.identifier.id,x.version)):(this.g.trace(`${W}: Enabling extension...`,L.identifier.id,x.version),await V.enableExtension(x.identifier),this.g.info(`${W}: Enabled extension`,L.identifier.id,x.version))),(!T||T.preRelease!==L.preRelease||T.pinned!==L.pinned||U&&T.manifest.version!==U)&&(await this.a.canInstall(x)?(J.push({extension:x,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:L.pinned&&!!L.version,installPreReleaseVersion:L.preRelease,profileLocation:X.extensionsResource,isApplicationScoped:L.isApplicationScoped,context:{[w.$Wo]:!0,[w.$Xo]:!0}}}),G.set(x.identifier.id.toLowerCase(),L)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,x.displayName||x.identifier.id),ie.push(L)))}catch(K){ie.push(L),this.g.error(K),this.g.info(`${W}: Skipped synchronizing extension`,x.displayName||x.identifier.id)}else ie.push(L),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,L.identifier.id)}))}),q.length){const V=re.filter(({identifier:z,isBuiltin:L})=>!L&&q.some(T=>(0,h.$up)(z,T)));await D.Promises.settled(V.map(async z=>{this.g.trace(`${W}: Uninstalling local extension...`,z.identifier.id),await this.a.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,z.identifier.id),B.push(z.identifier)}))}const he=await this.a.installGalleryExtensions(J);for(const{identifier:V,local:z,error:L,source:T}of he){const U=T;if(z)this.g.info(`${W}: Installed extension.`,V.id,U.version),B.push(V);else{const x=G.get(V.id.toLowerCase());x&&(ie.push(x),this.g.info(`${W}: Skipped synchronizing extension`,U.displayName||U.identifier.id)),L instanceof w.$7o&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(L.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):L&&this.g.error(L)}}const te=[];for(const V of H)B.some(z=>(0,h.$up)(z,V.identifier))||te.push(V);for(const V of ie)te.some(z=>(0,h.$up)(z.identifier,V.identifier))||te.push(V);return te}h(F,q,Y,H){const X=H.getExtensionState(q,!0)||{},W=Y?H.getKeysForSync({id:q.identifier.id,version:Y}):void 0;W?W.forEach(J=>{X[J]=F[J]}):Object.keys(F).forEach(J=>X[J]=F[J]),H.setExtensionState(q,X,!0)}async j(F,q){return this.b.withProfileScopedStorageService(F,async Y=>{const H=new I.$Uc,X=this.f.createChild(new u.$ui([d.$1p,Y])),W=H.add(X.createInstance(y.$6Jb)),J=H.add(X.createInstance(c.$2v));try{return await q(W,J)}finally{H.dispose()}})}};e.$3$b=P,e.$3$b=P=Ee([Q(0,w.$9o),Q(1,a.$JKb),Q(2,w.$6o),Q(3,i.$tMb),Q(4,l.$vi),Q(5,o.$ilb)],P);let R=class extends n.$KLb{constructor(F,q,Y,H,X,W,J,G){super("extensions",H,X,W,Y,J,G),this.p=F,this.q=q}async t(F){return F.syncData?await b(F.syncData,this.p):null}u(F,q){const Y=[],H=[],X=[];for(const W of F){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const J=q.find(G=>(0,h.$up)(G.identifier,W.identifier));J?(Y.push(J),W.disabled&&X.push(W.identifier)):W.installed&&(H.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&X.push(W.identifier))}return{installedExtensions:Y,newExtensions:H,disabledExtensions:X,remoteExtensions:F}}};e.$4$b=R,e.$4$b=R=Ee([Q(0,w.$9o),Q(1,i.$tMb),Q(2,g.$3k),Q(3,r.$Cl),Q(4,E.$Di),Q(5,m.$3j),Q(6,d.$1p),Q(7,t.$Al)],R)}),define(ae[116],ce([0,1,15,7,3,35,44,5,32,21,16,12,9,45,19,22,28,39,79,245,25,18,60,4]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QLb=e.$PLb=e.$OLb=e.$NLb=void 0,e.$MLb=i;const n="globalState.argv.",s=["locale"];function i(S,P){const R=S.storage?Object.keys(S.storage).sort():[],M={};return R.forEach(F=>M[F]=S.storage[F]),S.storage=M,P?(0,O.$Un)(S,{}):JSON.stringify(S)}const o=1;let a=class extends l.$HLb{constructor(P,R,M,F,q,Y,H,X,W,J,G,B,ie,re){super({syncResource:"globalState",profile:P},R,F,X,B,q,Y,W,J,H,G,ie),this.Bb=M,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:d.$klb,authority:"base"}),this.xb=this.vb.with({scheme:d.$klb,authority:"local"}),this.yb=this.vb.with({scheme:d.$klb,authority:"remote"}),this.zb=this.vb.with({scheme:d.$klb,authority:"accepted"}),this.Ab=re.createInstance(b),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(j.Event.any(j.Event.filter(F.onDidFilesChange,he=>he.contains(this.H.argvResource)),j.Event.filter(M.onDidChange,he=>!!(he.targetChanges.some(te=>this.syncResource.profile.id===te.id)||he.valueChanges.some(({profile:te,changes:V})=>this.syncResource.profile.id===te.id&&V.some(z=>z.target===0)))))(()=>this.Q()))}async qb(P,R,M){const F=P.syncData?JSON.parse(P.syncData.content):null;R=R===null&&M?P:R;const q=R&&R.syncData?JSON.parse(R.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=await this.Jb(q),{local:X,remote:W}=(0,m.$LLb)(Y.storage,F?F.storage:null,q?q.storage:null,H,this.O),J={content:null,local:X,remote:W,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:W.all!==null?2:0},G=i(Y,!1);return[{baseResource:this.wb,baseContent:q?i(q,!1):G,localResource:this.xb,localContent:G,localUserData:Y,remoteResource:this.yb,remoteContent:F?i(F,!1):null,previewResource:this.vb,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.zb,storageKeys:H}]}async ub(P){const R=P.syncData?JSON.parse(P.syncData.content):null;if(R===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(R),{remote:q}=(0,m.$LLb)(M.storage,R.storage,R.storage,F,this.O);return q.all!==null}async rb(P,R){return{...P.previewResult,hasConflicts:!1}}async sb(P,R,M,F){if(this.h.isEqual(R,this.xb))return this.Gb(P);if(this.h.isEqual(R,this.yb))return this.Hb(P);if(this.h.isEqual(R,this.vb))return P.previewResult;throw new Error(`Invalid Resource: ${R.toString()}`)}async Gb(P){return{content:P.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(P.localUserData.storage),removed:[],updated:[],all:P.localUserData.storage},localChange:0,remoteChange:2}}async Hb(P){if(P.remoteContent!==null){const R=JSON.parse(P.remoteContent),{local:M,remote:F}=(0,m.$LLb)(P.localUserData.storage,R.storage,null,P.storageKeys,this.O);return{content:P.remoteContent,local:M,remote:F,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:P.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(P,R,M,F){const{localUserData:q}=M[0][0],{local:Y,remote:H,localChange:X,remoteChange:W}=M[0][1];if(X===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),X!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const J=JSON.stringify({storage:H.all});P=await this.mb(J,F?null:P.ref),this.O.info(`${this.D}: Updated remote ui state.${H.added.length?` Added: ${H.added}.`:""}${H.updated.length?` Updated: ${H.updated}.`:""}${H.removed.length?` Removed: ${H.removed}.`:""}`)}R?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(P){if(this.h.isEqual(this.yb,P)||this.h.isEqual(this.wb,P)||this.h.isEqual(this.xb,P)||this.h.isEqual(this.zb,P)){const R=await this.db(P);return R&&i(JSON.parse(R),!0)}return null}async hasLocalData(){try{const{storage:P}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(P).length>1||P[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(P){const R=await this.Bb.readStorageData(this.syncResource.profile),M=[],F=[];for(const[H,X]of R)X.target===0?M.push(H):X.target===1&&F.push(H);const q=[...M,...F],Y=P?.storage?Object.keys(P.storage).filter(H=>!H.startsWith(n)&&!q.includes(H)&&R.get(H)!==void 0):[];if(!I.$o){const H=[...d.$2kb.map(X=>(0,d.$clb)(X)),d.$blb];Y.push(...H),F.push(...H)}return{user:M,machine:F,unregistered:Y}}};e.$NLb=a,e.$NLb=a=Ee([Q(2,t.$JKb),Q(3,y.$3k),Q(4,d.$6kb),Q(5,d.$7kb),Q(6,d.$ilb),Q(7,E.$Di),Q(8,d.$dlb),Q(9,p.$2l),Q(10,f.$3i),Q(11,c.$1p),Q(12,g.$Al),Q(13,r.$vi)],a);let b=class{constructor(P,R,M,F){this.a=P,this.b=R,this.c=M,this.d=F}async getLocalGlobalState(P){const R={};if(P.isDefault){const F=await this.f(),q=(0,A.$Jn)(F);for(const Y of s)q[Y]!==void 0&&(R[`${n}${Y}`]={version:1,value:q[Y]})}const M=await this.c.readStorageData(P);for(const[F,q]of M)q.value&&q.target===0&&(R[F]={version:1,value:q.value});return{storage:R}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const P=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),P.value.toString()}catch(P){this.d.debug((0,N.$0)(P))}return"{}"}async writeLocalGlobalState({added:P,removed:R,updated:M},F){const q=(0,l.$GLb)("globalState",F),Y={},H=new Map,X=await this.c.readStorageData(F),W=(J,G)=>{for(const B of J){if(B.startsWith(n)){Y[B.substring(n.length)]=G?G[B].value:void 0;continue}if(G){const ie=G[B];ie.value!==X.get(B)?.value&&H.set(B,ie.value)}else X.get(B)!==void 0&&H.set(B,void 0)}};if(W(Object.keys(P),P),W(Object.keys(M),M),W(R),Object.keys(Y).length){this.d.trace(`${q}: Updating locale...`);const J=await this.f();let G=J;for(const B of Object.keys(Y))G=(0,u.edit)(G,[B],Y[B],{});J!==G&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$Ge.fromString(G)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}H.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(F,H,0),this.d.info(`${q}: Updated global state`,[...H.keys()]))}};e.$OLb=b,e.$OLb=b=Ee([Q(0,y.$3k),Q(1,E.$Di),Q(2,t.$JKb),Q(3,d.$ilb)],b);let k=class extends l.$KLb{constructor(P,R,M,F,q,Y){super("globalState",M,F,q,R,P,Y)}async o(P){const R=P.syncData?JSON.parse(P.syncData.content):null;if(!R){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},F={};for(const q of Object.keys(R.storage))q.startsWith(n)?M[q.substring(n.length)]=R.storage[q].value:this.l.get(q,0)===void 0&&(F[q]=R.storage[q].value);if(Object.keys(M).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(M))q=(0,u.edit)(q,[Y],M[Y],{});await this.k.writeFile(this.h.argvResource,D.$Ge.fromString(q))}if(Object.keys(F).length){const q=[];for(const Y of Object.keys(F))q.push({key:Y,value:F[Y],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$PLb=k,e.$PLb=k=Ee([Q(0,c.$1p),Q(1,y.$3k),Q(2,$.$Cl),Q(3,E.$Di),Q(4,d.$ilb),Q(5,g.$Al)],k);let v=class{constructor(P,R,M,F,q){this.a=P,this.b=R,this.c=M,this.d=F,this.f=q}getSyncStoreType(P){return this.h(P)?.storage[d.$blb]?.value}async sync(P){const R=(0,d.$0kb)((0,C.$Sg)());try{return await this.g(P,R)}catch(M){if(M instanceof d.$$kb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(P,R)}throw M}}async g(P,R){const M=await this.a.readResource("globalState",null,void 0,R),F=this.h(M)||{storage:{}};F.storage[d.$blb]={value:P,version:o};const q=await(0,h.$7p)(this.c,this.d,this.b),Y={version:o,machineId:q,content:i(F,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),M.ref,void 0,R)}h({content:P}){if(!P)return null;const R=JSON.parse(P);if((0,l.$FLb)(R))return R?JSON.parse(R.content):null;throw new Error("Invalid remote data")}};e.$QLb=v,e.$QLb=v=Ee([Q(1,c.$1p),Q(2,E.$Di),Q(3,y.$3k),Q(4,w.$3j)],v)}),define(ae[117],ce([0,1,17,15,3,35,5,13,176,21,16,12,19,22,28,18,39,242,25]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=e.$7$b=void 0,e.$6$b=m;function m(t,r,n){try{const s=JSON.parse(t);if(!r)return(0,I.$dg)(s.all)?null:s.all;switch(O.OS){case 2:return(0,I.$dg)(s.mac)?null:s.mac;case 3:return(0,I.$dg)(s.linux)?null:s.linux;case 1:return(0,I.$dg)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let d=class extends g.$JLb{constructor(r,n,s,i,o,a,b,k,v,S,P,R,M){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},n,k,v,S,s,i,b,R,o,P,a,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$klb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$klb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$klb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$klb,authority:"accepted"}),this.B(j.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(r,n,s,i){const o=r.syncData?m(r.syncData.content,i.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?r:n;const a=n?this.Ob(n):null,b=await this.vb(),k=await this.Cb();let v=null,S=!1,P=!1,R=!1;if(o){let q=b?b.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new u.$$kb((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,l.$5$b)(q,o,a,k,this.zb);Y.hasChanges&&(v=Y.mergeContent,R=Y.hasConflicts,S=R||Y.mergeContent!==q,P=R||Y.mergeContent!==o)}}else b&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=b.value.toString(),P=!0);const M={content:R?a:v,localChange:S?b?2:1:0,remoteChange:P?2:0,hasConflicts:R},F=b?b.value.toString():null;return[{fileContent:b,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:F,localChange:M.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(r){const n=this.Ob(r);if(n===null)return!0;const s=await this.vb(),i=s?s.value.toString():"",o=await this.Cb(),a=await(0,l.$5$b)(i||"[]",n,n,o,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(r,n){return r.previewResult}async sb(r,n,s,i){if(this.h.isEqual(n,this.Gb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(r,n,s,i){const{fileContent:o}=s[0][0];let{content:a,localChange:b,remoteChange:k}=s[0][1];if(b===0&&k===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new u.$$kb((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(b!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(a||"[]",o,i),this.O.info(`${this.D}: Updated local keybindings`)),k!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const v=this.Pb(a||"[]",r.syncData?.content);r=await this.mb(v,i?null:r.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==r.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(r,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.vb();if(r){const n=(0,A.$Jn)(r.value.toString());if((0,D.$Lb)(n))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Hb,r)||this.h.isEqual(this.Fb,r)||this.h.isEqual(this.Gb,r)||this.h.isEqual(this.Ib,r)?this.db(r):null}Ob(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Qb()?null:m(r.syncData.content,this.Qb(),this.O)}Pb(r,n){let s={};try{s=JSON.parse(n||"{}")}catch(i){this.O.error(i)}switch(this.Qb()?delete s.all:s.all=r,O.OS){case 2:s.mac=r;break;case 3:s.linux=r;break;case 1:s.windows=r;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(u.$Ykb)}};e.$7$b=d,e.$7$b=d=Ee([Q(2,u.$6kb),Q(3,u.$7kb),Q(4,u.$ilb),Q(5,f.$3i),Q(6,u.$dlb),Q(7,y.$3k),Q(8,E.$Di),Q(9,w.$1p),Q(10,u.$hlb),Q(11,h.$2l),Q(12,c.$Al)],d);let $=class extends g.$KLb{constructor(r,n,s,i,o,a){super("keybindings",n,s,i,r,o,a)}async o(r){const n=r.syncData?this.p(r.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$Ge.fromString(n)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Jn)(r.value.toString());return!(0,D.$Lb)(n)}catch(r){return r.fileOperationResult===1}}p(r){try{return m(r,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$8$b=$,e.$8$b=$=Ee([Q(0,y.$3k),Q(1,p.$Cl),Q(2,E.$Di),Q(3,u.$ilb),Q(4,w.$1p),Q(5,c.$Al)],$)}),define(ae[118],ce([0,1,15,3,177,21,76,16,29,12,19,22,28,18,39,246,25]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$$b=e.$0$b=void 0,e.$9$b=u;function l($){return $&&$.settings&&typeof $.settings=="string"&&Object.keys($).length===1}function u($){const t=JSON.parse($);return l(t)?t:{settings:$}}let m=class extends c.$JLb{constructor(t,r,n,s,i,o,a,b,k,v,S,P,R,M){super(t.settingsResource,{syncResource:"settings",profile:t},r,n,s,i,o,a,S,P,b,k,v,M),this.Eb=R,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:g.$klb,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.$klb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.$klb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.$klb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const r=await this.getLastSyncUserData(),n=await this.X(t,r),s=this.Lb(n),i=new O.$yo(g.$Xkb,this.O);return s?.settings&&i.parse(s.settings),i.configurationModel.getValue(g.$Xkb)||{}}async qb(t,r,n){const s=await this.vb(),i=await this.Cb(),o=this.Lb(t);r=r===null&&n?t:r;const a=r?this.Lb(r):null,b=await this.Pb();let k=null,v=!1,S=!1,P=!1;if(o){let q=s?s.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,p.$qKb)(q,o.settings,a?a.settings:null,b,[],i);k=Y.localContent||Y.remoteContent,v=Y.localContent!==null,S=Y.remoteContent!==null,P=Y.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),k=s.value.toString().trim()||"{}",this.Qb(k),S=!0);const R=s?s.value.toString():null,M=a?.settings??null,F={content:P?M:k,localChange:v?2:0,remoteChange:S?2:0,hasConflicts:P};return[{fileContent:s,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:R,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async ub(t){const r=this.Lb(t);if(r===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",i=await this.Pb(),o=await this.Cb();return(0,p.$qKb)(s||"{}",r.settings,r.settings,i,[],o).remoteContent!==null}async rb(t,r){const n=await this.Cb(),s=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,p.$pKb)(t.previewResult.content,"{}",s,n):null}}async sb(t,r,n,s){const i=await this.Cb(),o=await this.Pb();if(this.h.isEqual(r,this.localResource))return{content:t.fileContent?(0,p.$pKb)(t.fileContent.value.toString(),"{}",o,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,p.$pKb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,p.$pKb)(n,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async tb(t,r,n,s){const{fileContent:i}=n[0][0];let{content:o,localChange:a,remoteChange:b}=n[0][1];if(a===0&&b===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),i&&await this.nb(JSON.stringify(this.Nb(i.value.toString()))),await this.wb(o,i,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),b!==0){const k=await this.Cb(),v=this.Lb(t),S=await this.Pb(o);o=(0,p.$pKb)(o,v?v.settings:"{}",S,k),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(o)),s?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,p.$rKb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let r=await super.db(t);if(r){const n=await this.Cb(),s=await this.Pb();r=(0,p.$pKb)(r,"{}",s,n)}return r}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return u(t)}catch(r){this.O.error(r)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:i})=>!!i)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const r=await this.Ob;return(0,p.$nKb)(r,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new g.$$kb((0,j.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$0$b=m,e.$0$b=m=Ee([Q(2,f.$3k),Q(3,I.$Di),Q(4,E.$1p),Q(5,g.$6kb),Q(6,g.$7kb),Q(7,g.$ilb),Q(8,g.$hlb),Q(9,A.$3i),Q(10,g.$dlb),Q(11,y.$2l),Q(12,C.$9o),Q(13,w.$Al)],m);let d=class extends c.$KLb{constructor(t,r,n,s,i,o){super("settings",r,n,s,t,i,o)}async o(t){const r=t.syncData?this.p(t.syncData.content):null;if(!r){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$Ge.fromString(r.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$rKb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return u(t)}catch(r){this.j.error(r)}return null}};e.$$$b=d,e.$$$b=d=Ee([Q(0,f.$3k),Q(1,h.$Cl),Q(2,I.$Di),Q(3,g.$ilb),Q(4,E.$1p),Q(5,w.$Al)],d)}),define(ae[119],ce([0,1,15,3,30,21,16,12,19,22,28,18,39,243,25]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d_b=e.$c_b=void 0,e.$b_b=p;function p(u){return JSON.parse(u.content)}let g=class extends w.$HLb{constructor(m,d,$,t,r,n,s,i,o,a,b,k){super({syncResource:"snippets",profile:m},d,t,$,r,n,s,a,b,i,o,k),this.pb=1,this.vb=m.snippetsHome,this.B(this.G.watch($.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,v=>v.affects(this.vb))(()=>this.Q()))}async qb(m,d,$){const t=await this.Hb(),r=this.Gb(t),n=m.syncData?this.Fb(m.syncData):null;d=d===null&&$?m:d;const s=d&&d.syncData?this.Fb(d.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,h.$_$b)(r,n,s);return this.Bb(i,t,n||{},s||{})}async ub(m){const d=m.syncData?this.Fb(m.syncData):null;if(d===null)return!0;const $=await this.Hb(),t=this.Gb($),r=(0,h.$_$b)(t,d,d);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async rb(m,d){return m.previewResult}async sb(m,d,$,t){if(this.h.isEqualOrParent(d,this.g.with({scheme:c.$klb,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:c.$klb,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return $===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:$,localChange:$===null?m.fileContent!==null?3:0:2,remoteChange:$===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(m,d,$,t){const r=$.map(([n,s])=>({...n,acceptResult:s}));r.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),r.some(({localChange:n})=>n!==0)&&(await this.Cb(r),await this.Db(r,t)),r.some(({remoteChange:n})=>n!==0)&&(m=await this.Eb(r,m,t)),d?.ref!==m.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(m),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of r)try{await this.G.del(n)}catch{}}Bb(m,d,$,t){const r=new Map;for(const n of Object.keys(m.local.added)){const s={content:m.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"accepted"})})}for(const n of Object.keys(m.local.updated)){const s={content:m.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"accepted"})})}for(const n of m.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"accepted"})})}for(const n of Object.keys(m.remote.added)){const s={content:m.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"accepted"})})}for(const n of Object.keys(m.remote.updated)){const s={content:m.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"local"}),fileContent:d[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"accepted"})})}for(const n of m.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"accepted"})})}for(const n of m.conflicts){const s={content:t[n]??null,hasConflicts:!0,localChange:d[n]?2:1,remoteChange:$[n]?2:1},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"local"}),fileContent:d[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"accepted"})})}for(const n of Object.keys(d))if(!r.has(n)){const s={content:d[n]?d[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=d[n]?d[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"local"}),fileContent:d[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$klb,authority:"accepted"})})}return[...r.values()]}async resolveContent(m){return this.h.isEqualOrParent(m,this.g.with({scheme:c.$klb,authority:"remote"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$klb,authority:"local"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$klb,authority:"base"}))||this.h.isEqualOrParent(m,this.g.with({scheme:c.$klb,authority:"accepted"}))?this.db(m):null}async hasLocalData(){try{const m=await this.Hb();if(Object.keys(m).length)return!0}catch{}return!1}async Cb(m){const d={};for(const $ of m)$.fileContent&&(d[this.h.basename($.localResource)]=$.fileContent);await this.nb(JSON.stringify(this.Gb(d)))}async Db(m,d){for(const{fileContent:$,acceptResult:t,localResource:r,remoteResource:n,localChange:s}of m)if(s!==0){const i=n?this.h.basename(n):this.h.basename(r),o=this.h.joinPath(this.vb,i);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,D.$Ge.fromString(t.content),{overwrite:d}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,D.$Ge.fromString(t.content),d?void 0:$),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(m,d,$){const t=d.syncData?this.Fb(d.syncData):{},r=(0,j.$3n)(t);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:o}of m)if(o!==0){const a=s?this.h.basename(s):this.h.basename(i);o===3?delete r[a]:r[a]=n.content}return(0,h.$a_b)(t,r)||(this.O.trace(`${this.D}: Updating remote snippets...`),d=await this.mb(JSON.stringify(r),$?null:d.ref),this.O.info(`${this.D}: Updated remote snippets`)),d}Fb(m){return p(m)}Gb(m){const d={};for(const $ of Object.keys(m))d[$]=m[$].value.toString();return d}async Hb(){const m={};let d;try{d=await this.G.resolve(this.vb)}catch($){if($ instanceof I.$ll&&$.fileOperationResult===1)return m;throw $}for(const $ of d.children||[]){const t=$.resource,r=this.h.extname(t);if(r===".json"||r===".code-snippets"){const n=this.h.relativePath(this.vb,t),s=await this.G.readFile(t);m[n]=s}}return m}};e.$c_b=g,e.$c_b=g=Ee([Q(2,O.$Di),Q(3,I.$3k),Q(4,C.$1p),Q(5,c.$6kb),Q(6,c.$7kb),Q(7,c.$ilb),Q(8,A.$3i),Q(9,c.$dlb),Q(10,f.$2l),Q(11,E.$Al)],g);let l=class extends w.$KLb{constructor(m,d,$,t,r,n){super("snippets",d,$,t,m,r,n)}async o(m){const d=m.syncData?JSON.parse(m.syncData.content):null;if(!d){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(d)){const r=d[t];if(r){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(n,D.$Ge.fromString(r)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(m)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};e.$d_b=l,e.$d_b=l=Ee([Q(0,I.$3k),Q(1,y.$Cl),Q(2,O.$Di),Q(3,c.$ilb),Q(4,C.$1p),Q(5,E.$Al)],l)}),define(ae[120],ce([0,1,15,21,16,12,19,22,28,18,39,25]),function(ne,e,D,N,j,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g_b=e.$f_b=void 0,e.$e_b=w;function w(g,l){try{return JSON.parse(g).tasks??null}catch(u){return l.error(u),null}}let h=class extends E.$ILb{constructor(l,u,m,d,$,t,r,n,s,i,o,a){super(l.tasksResource,{syncResource:"tasks",profile:l},u,n,s,i,m,d,r,o,$,t,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:y.$klb,authority:"base"}),this.Cb=this.Ab.with({scheme:y.$klb,authority:"local"}),this.Db=this.Ab.with({scheme:y.$klb,authority:"remote"}),this.Eb=this.Ab.with({scheme:y.$klb,authority:"accepted"})}async qb(l,u,m,d){const $=l.syncData?w(l.syncData.content,this.O):null;u=u===null&&m?l:u;const t=u?.syncData?w(u.syncData.content,this.O):null,r=await this.vb();let n=null,s=!1,i=!1,o=!1;if(l.syncData){const k=r?r.value.toString():null;if(!t||t!==k||t!==$){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const v=p(k,$,t);n=v.content,o=v.hasConflicts,s=v.hasLocalChanged,i=v.hasRemoteChanged}}else r&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=r.value.toString(),i=!0);const a={content:o?t:n,localChange:s?r?2:1:0,remoteChange:i?2:0,hasConflicts:o},b=r?r.value.toString():null;return[{fileContent:r,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:b,localChange:a.localChange,remoteResource:this.Db,remoteContent:$,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const u=l?.syncData?w(l.syncData.content,this.O):null;if(u===null)return!0;const m=await this.vb(),d=m?m.value.toString():null,$=p(d,u,u);return $.hasLocalChanged||$.hasRemoteChanged}async rb(l,u){return l.previewResult}async sb(l,u,m,d){if(this.h.isEqual(u,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return m===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:m,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(l,u,m,d){const{fileContent:$}=m[0][0],{content:t,localChange:r,remoteChange:n}=m[0][1];if(r===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),r!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),$&&await this.nb(JSON.stringify(this.Kb($.value.toString()))),t?await this.wb(t,$,d):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(t));l=await this.mb(s,d?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$f_b=h,e.$f_b=h=Ee([Q(2,y.$6kb),Q(3,y.$7kb),Q(4,y.$ilb),Q(5,N.$3i),Q(6,y.$dlb),Q(7,A.$3k),Q(8,j.$Di),Q(9,O.$1p),Q(10,I.$2l),Q(11,C.$Al)],h);let c=class extends E.$KLb{constructor(l,u,m,d,$,t){super("tasks",u,m,d,l,$,t),this.c=this.g.defaultProfile.tasksResource}async o(l){const u=l.syncData?w(l.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$Ge.fromString(u)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$g_b=c,e.$g_b=c=Ee([Q(0,A.$3k),Q(1,f.$Cl),Q(2,j.$Di),Q(3,y.$ilb),Q(4,O.$1p),Q(5,C.$Al)],c);function p(g,l,u){if(g===null&&l===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(g===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const m=u!==g,d=u!==l;return!m&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:m&&!d?{content:g,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!m?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:g,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[121],ce([0,1,44,21,16,12,19,22,28,18,39,244,25]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=void 0,e.$1ac=c,e.$2ac=p;let h=class extends E.$HLb{constructor(l,u,m,d,$,t,r,n,s,i,o,a,b){super({syncResource:"profiles",profile:l},u,d,$,t,r,n,o,a,s,i,b),this.vb=m,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.$klb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$klb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$klb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$klb,authority:"accepted"}),this.B(m.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?p(l.syncData):null}async getRemoteSyncedProfiles(l){const u=await this.getLastSyncUserData(),m=await this.X(l,u);return m?.syncData?p(m.syncData):null}async qb(l,u,m){if(!this.vb.isEnabled())throw new w.$$kb("Cannot sync profiles because they are disabled","LocalError");const d=l.syncData?p(l.syncData):null,$=u?.syncData?p(u.syncData):null,t=this.Db(),{local:r,remote:n}=(0,y.$Yac)(t,d,$,[]),s={local:r,remote:n,content:$?this.Eb($):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:n!==null?2:0},i=c(t,!1);return[{baseResource:this.baseResource,baseContent:$?this.Eb($):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:d?this.Eb(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const u=l?.syncData?p(l.syncData):null,m=this.Db(),{remote:d}=(0,y.$Yac)(m,u,u,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async rb(l,u){return{...l.previewResult,hasConflicts:!1}}async sb(l,u,m,d){if(this.h.isEqual(u,this.localResource))return this.Ab(l);if(this.h.isEqual(u,this.remoteResource))return this.Bb(l);if(this.h.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(l){const u=this.Db(),m=(0,y.$Yac)(u,null,null,[]),{local:d,remote:$}=m;return{content:l.localContent,local:d,remote:$,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:$!==null?2:0}}async Bb(l){const u=l.remoteContent?JSON.parse(l.remoteContent):null,m=[],d=[];for(const $ of this.Db()){const t=u?.find(r=>r.id===$.id);t&&(m.push({id:$.id,name:$.name,collection:t.collection}),d.push($))}if(u!==null){const $=(0,y.$Yac)(d,u,m,[]),{local:t,remote:r}=$;return{content:l.remoteContent,local:t,remote:r,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,u,m,d){const{local:$,remote:t,localChange:r,remoteChange:n}=m[0][1];r===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=m[0][0].remoteProfiles||[];if(s.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new w.$$kb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0&&(await this.nb(c(this.Db(),!1)),await Promise.all($.removed.map(async i=>{this.O.trace(`${this.D}: Removing '${i.name}' profile...`),await this.vb.removeProfile(i),this.O.info(`${this.D}: Removed profile '${i.name}'.`)})),await Promise.all($.added.map(async i=>{this.O.trace(`${this.D}: Creating '${i.name}' profile...`),await this.vb.createProfile(i.id,i.name,{shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${i.name}'.`)})),await Promise.all($.updated.map(async i=>{const o=this.vb.profiles.find(a=>a.id===i.id);o?(this.O.trace(`${this.D}: Updating '${i.name}' profile...`),await this.vb.updateProfile(o,{name:i.name,shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${i.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${i.id}' to update.`)}))),n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const i=[],o=s.length+(t?.added.length??0)<=20;if(o)for(const a of t?.added||[]){const b=await this.J.createCollection(this.F);i.push(b),s.push({id:a.id,name:a.name,collection:b,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])s.splice(s.findIndex(({id:b})=>a.id===b),1);for(const a of t?.updated||[]){const b=s.find(({id:k})=>a.id===k);b&&s.splice(s.indexOf(b),1,{...b,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,d?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const b of i)await this.J.deleteCollection(b,this.F)}throw a}for(const a of t?.removed||[])await this.J.deleteCollection(a.collection,this.F)}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,u){return this.mb(this.Eb(l),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const u=await this.db(l);return u&&(0,D.$Un)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((u,m)=>u.name.localeCompare(m.name)))}};e.$Zac=h,e.$Zac=h=Ee([Q(2,f.$Cl),Q(3,A.$3k),Q(4,j.$Di),Q(5,O.$1p),Q(6,w.$6kb),Q(7,w.$7kb),Q(8,w.$ilb),Q(9,N.$3i),Q(10,w.$dlb),Q(11,I.$2l),Q(12,C.$Al)],h);function c(g,l){const u=[...g].sort((m,d)=>m.name.localeCompare(d.name)).map(m=>({id:m.id,name:m.name}));return l?(0,D.$Un)(u,{}):JSON.stringify(u)}function p(g){return JSON.parse(g.content)}}),define(ae[261],ce([0,1,3,2,5,16,19,22,25]),function(ne,e,D,N,j,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=void 0;const f="sync.enable";let E=class extends N.$Vc{constructor(w,h,c,p){super(),this.c=w,this.f=h,this.g=c,this.h=p,this.a=new D.$ee,this.onDidChangeEnablement=this.a.event,this.b=new D.$ee,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(-1,void 0,this.B(new N.$Uc))(g=>this.m(g)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(f,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(f,{enabled:w}),this.c.store(f,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,C.$clb)(w),-1,!0)}setResourceEnablement(w,h){if(this.isResourceEnabled(w)!==h){const c=(0,C.$clb)(w);this.j(c,h)}}getResourceSyncStateVersion(w){}j(w,h){this.c.store(w,h,-1,j.$o?0:1)}m(w){if(f===w.key){this.a.fire(this.isEnabled());return}const h=C.$2kb.filter(c=>(0,C.$clb)(c)===w.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$Mac=E,e.$Mac=E=Ee([Q(0,O.$1p),Q(1,I.$2l),Q(2,A.$Di),Q(3,C.$5kb)],E)}),define(ae[262],ce([0,1,6,15,65,2,20,21,16,12,18,25]),function(ne,e,D,N,j,A,O,I,C,f,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=void 0;let w=class extends A.$Vc{constructor(c,p,g,l,u){super(),this.a=c,this.b=p,this.c=g,this.f=l,this.g=u,this.h()}async h(){for(const p of this.g.profiles)for(const g of y.$2kb)try{await this.m(this.j(g,p.isDefault?void 0:p.id))}catch(l){this.f.error(l)}let c;try{c=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,f.$hl)(p)!==1&&this.f.error(p);return}if(c.children){for(const p of c.children)if(p.isDirectory&&!this.g.profiles.some(g=>g.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(g){this.f.error(g)}}}async getAllResourceRefs(c,p,g){const l=this.j(c,p,g);try{const u=await this.b.resolve(l);if(u.children)return u.children.filter(d=>d.isFile&&!d.name.startsWith("lastSync")).sort().reverse().map(d=>({ref:d.name,created:this.n(d)}))}catch(u){if((0,f.$hl)(u)!==1)throw u}return[]}async resolveResourceContent(c,p,g,l){const u=this.j(c,g,l),m=(0,O.$0g)(u,p);try{return(await this.b.readFile(m)).value.toString()}catch(d){return this.f.error(d),null}}async writeResource(c,p,g,l,u){const m=this.j(c,l,u),d=(0,O.$0g)(m,`${(0,j.$4m)(g).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,N.$Ge.fromString(p))}catch($){this.f.error($)}}j(c,p,g=this.a.userDataSyncHome){return(0,O.$0g)(g,...p?[p,c]:[c])}async m(c){try{try{if(!await this.b.exists(c))return}catch{return}const p=await this.b.resolve(c);if(p.children){const g=p.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=g.filter(d=>Date.now()-this.n(d)>l);const m=g.length-u.length;m<10&&(u=u.slice(10-m)),await D.Promises.settled(u.map(async d=>{this.f.info("Deleting from backup",d.resource.path),await this.b.del(d.resource)}))}}catch(p){this.f.error(p)}}n(c){return new Date(parseInt(c.name.substring(0,4)),parseInt(c.name.substring(4,6))-1,parseInt(c.name.substring(6,8)),parseInt(c.name.substring(9,11)),parseInt(c.name.substring(11,13)),parseInt(c.name.substring(13,15))).getTime()}};e.$Xac=w,e.$Xac=w=Ee([Q(0,C.$Di),Q(1,f.$3k),Q(2,I.$3i),Q(3,y.$ilb),Q(4,E.$Cl)],w)}),define(ae[83],ce([0,1,3,2,5,27,181,16,12,4,24,45,19,25]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukb=e.$Skb=void 0,e.$Tkb=$,e.$Skb=(0,f.$wi)("IUserDataSyncMachinesService");const p="sync.currentMachineName",g="Safari",l="Chrome",u="Edge",m="Firefox",d="Android";function $(n){switch(n){case g:case l:case u:case m:case d:case(0,j.$h)(0):return!0}return!1}function t(){return j.$G?g:j.$E?l:j.$H?u:j.$F?m:j.$I?d:(0,j.$h)(j.$o?0:j.$u)}let r=class extends N.$Vc{static{c=this}static{this.a=1}static{this.b="machines"}constructor(s,i,o,a,b,k){super(),this.h=o,this.j=a,this.m=b,this.n=k,this.c=this.B(new D.$ee),this.onDidChange=this.c.event,this.g=null,this.f=(0,y.$7p)(s,i,o)}async getMachines(s){const i=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(s){const i=await this.f,o=await this.s(s);o.machines.some(({id:a})=>a===i)||(o.machines.push({id:i,name:this.r(o.machines),platform:t()}),await this.t(o))}async removeCurrentMachine(s){const i=await this.f,o=await this.s(s),a=o.machines.filter(({id:b})=>b!==i);a.length!==o.machines.length&&(o.machines=a,await this.t(o))}async renameMachine(s,i,o){const a=await this.s(o),b=a.machines.find(({id:k})=>k===s);if(b){b.name=i,await this.t(a);const k=await this.f;s===k&&this.h.store(p,i,-1,1)}}async setEnablements(s){const i=await this.s();for(const[o,a]of s){const b=i.machines.find(k=>k.id===o);b&&(b.disabled=a?void 0:!0)}await this.t(i)}r(s){const i=this.h.get(p,-1);if(i)return i;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,a=new RegExp(`${(0,A.$af)(o)}\\s#(\\d+)`);let b=0;for(const k of s){const v=a.exec(k.name),S=v?parseInt(v[1]):0;b=S>b?S:b}return`${o} #${b+1}`}async s(s){this.g=await this.u(s);const i=this.w(this.g);if(i.version!==c.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return i}async t(s){const i=JSON.stringify(s),o=await this.j.writeResource(c.b,i,this.g?.ref||null);this.g={ref:o,content:i},this.c.fire()}async u(s){if(this.g){const i=s&&s.latest?s.latest[c.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.j.readResource(c.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(i){this.m.error(i)}return{version:c.a,machines:[]}}};e.$Ukb=r,e.$Ukb=r=c=Ee([Q(0,I.$Di),Q(1,C.$3k),Q(2,w.$1p),Q(3,h.$6kb),Q(4,h.$ilb),Q(5,E.$jk)],r)}),define(ae[263],ce([0,1,6,65,38,7,3,2,5,20,8,178,24,19,22,25,80,83]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=void 0;const u="sync.disableMachineEventually",m="sync.sessionId",d="sync.storeUrl",$="sync.productQuality";let t=class extends I.$Vc{get n(){const s=this.H.get(d,-1);return s?E.URI.parse(s):void 0}set n(s){s?this.H.store(d,s.toString(),-1,1):this.H.remove(d,-1)}get s(){return this.H.get($,-1)}set s(s){s?this.H.store($,s,-1,1):this.H.remove($,-1)}constructor(s,i,o,a,b,k,v,S,P,R){super(),this.u=i,this.w=o,this.y=a,this.z=b,this.C=k,this.D=v,this.F=S,this.G=P,this.H=R,this.a=this.B(new I.$Wc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$ee),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$uh(this.U())),this.j=this.n,this.n=i.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,f.$3g)(this.n,i.userDataSyncStore?.url)||(this.j=this.n,this.n=i.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(v.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(b.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:i}=this.L();s?this.a.value===void 0&&(this.a.value=new r(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.C.info(i),this.a.clear()):i&&this.y.isEnabled()&&this.C.info(i))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$4m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,i,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(m,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),i)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const i=p.$$kb.toUserDataSyncError(s);i instanceof p.$alb&&this.F.publicLog2("autosync/error",{code:i.code,service:this.u.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?C.$o&&i.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(i),this.b++),this.h.fire(i)}async P(){this.H.store(u,!0,-1,1),await(0,D.$xh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(s,i,o){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$4ac=t,e.$4ac=t=Ee([Q(0,w.$jk),Q(1,p.$5kb),Q(2,p.$6kb),Q(3,p.$dlb),Q(4,p.$elb),Q(5,p.$ilb),Q(6,g.$8Jb),Q(7,c.$2l),Q(8,l.$Skb),Q(9,h.$1p)],t);class r extends I.$Vc{static{this.a="Interval"}constructor(s,i,o,a,b,k,v,S,P){super(),this.m=s,this.n=i,this.r=o,this.s=a,this.u=b,this.w=k,this.y=v,this.z=S,this.C=P,this.b=this.B(new I.$Wc),this.c=this.B(new O.$ee),this.onDidStartSync=this.c.event,this.f=this.B(new O.$ee),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$Tc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}D(){this.b.value=(0,D.$yh)(()=>{this.sync(r.a,!1),this.b.value=void 0},this.n)}sync(s,i){const o=(0,D.$jh)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(b){if((0,A.$4)(b))return}return this.H(s,i,a)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,f.$3g)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),i=this.r.userDataSyncStore;return!!i&&!!s&&(!(0,f.$3g)(i.defaultUrl,s.defaultUrl)||!(0,f.$3g)(i.insidersUrl,s.insidersUrl)||!(0,f.$3g)(i.stableUrl,s.stableUrl))}async H(s,i,o){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(i,o)}catch(b){if(this.y.error(b),a=b,p.$$kb.toUserDataSyncError(b).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(i,o),a=void 0}catch(k){this.y.error(k),a=k}}this.f.fire(a)}async I(s,i){if(this.h=await this.u.createSyncTask(this.g,s),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$alb((0,y.localize)(0,null),"DefaultServiceChanged"):new p.$alb((0,y.localize)(1,null),"ServiceChanged"):new p.$alb((0,y.localize)(2,null),"TurnedOff");const o=this.C.get(m,-1);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new p.$alb((0,y.localize)(3,null),"DefaultServiceChanged"):new p.$alb((0,y.localize)(4,null),"ServiceChanged"):new p.$alb((0,y.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const b=a.find(v=>v.isCurrent);if(b?.disabled)throw new p.$alb((0,y.localize)(6,null),"TurnedOff");const k=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-k}),this.g===null)try{this.g=await this.s.manifest(null)}catch(v){throw new p.$alb((0,j.$hj)(v),v instanceof p.$$kb?v.code:"Unknown")}this.g&&this.g.session!==o&&this.C.store(m,this.g.session,-1,1),!i.isCancellationRequested&&(b||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(ae[264],ce([0,1,8,182,16,12,45,19,28,25,18,39,119,118,117,21,120,115,116,4,121,44,27]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=void 0;let n=class{static{r=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(i,o,a,b,k,v,S,P,R,M){this.e=i,this.f=o,this.g=a,this.h=k,this.i=v,this.j=S,this.k=P,this.l=R,this.n=M,this.d=b.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const o=this.L(i.content,"profiles");return(0,d.$2ac)(o)}return[]}async getLocalSyncedProfiles(i){const o=await this.f.getAllResourceRefs("profiles",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("profiles",o[0].ref,void 0,i);if(a){const b=this.L(a,"profiles");return(0,d.$2ac)(b)}}return[]}async getLocalSyncedMachines(i){const o=await this.f.getAllResourceRefs("machines",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("machines",o[0].ref,void 0,i);if(a)return JSON.parse(a).machines.map(k=>({...k,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(i,o){return(await this.e.getAllResourceRefs(i,o?.collection)).map(({created:b,ref:k})=>({created:b,uri:this.J({remote:!0,syncResource:i,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:k,node:void 0})}))}async getLocalSyncResourceHandles(i,o,a){return(await this.f.getAllResourceRefs(i,o?.collection,a)).map(({created:k,ref:v})=>({created:k,uri:this.J({remote:!1,syncResource:i,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:v,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:i}){const o=this.K(i),a=o?this.k.profiles.find(b=>b.id===o.profile):void 0;return o&&a?{profile:a,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:i}){const o=this.K(i);if(!o)return[];const a=this.k.profiles.find(b=>b.id===o.profile);switch(o.syncResource){case"settings":return this.s(i,a);case"keybindings":return this.u(i,a);case"tasks":return this.w(i,a);case"snippets":return this.y(i,a);case"globalState":return this.D(i,a);case"extensions":return this.A(i,a);case"profiles":return this.G(i,a);case"workspaceState":return[]}}async getMachineId({uri:i}){const o=this.K(i);if(o){if(o.remote){if(o.ref){const{content:a}=await this.M(o.syncResource,o.ref,o.collection);if(a)return this.L(a,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const a=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(a)return this.L(a,o.syncResource)?.machineId}return}return(0,O.$7p)(this.h,this.j,this.i)}}async resolveContent(i){const o=this.K(i);if(!o||o.node===r.a)return null;if(o.ref){const a=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&a?this.q(o.syncResource,a,o.node):a}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(i,o,a,b,k){if(i){const{content:v}=await this.M(o,b,a);return v}return this.f.resolveResourceContent(o,b,a,k)}q(i,o,a){const b=this.L(o,i);switch(i){case"settings":return this.t(b,a);case"keybindings":return this.v(b,a);case"tasks":return this.x(b,a);case"snippets":return this.z(b,a);case"globalState":return this.E(b,a);case"extensions":return this.B(b,a);case"profiles":return this.H(b,a);case"workspaceState":return null}}async r(i,o){const a=this.k.profiles.find(b=>b.id===o);if(!a)return null;switch(i){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(i,o){const a=this.d.joinPath(i,"settings.json"),b=o?o.settingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}t(i,o){switch(o){case"settings.json":return(0,h.$9$b)(i.content).settings}return null}u(i,o){const a=this.d.joinPath(i,"keybindings.json"),b=o?o.keybindingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}v(i,o){switch(o){case"keybindings.json":return(0,c.$6$b)(i.content,!!this.l.getValue(f.$Ykb),this.g)}return null}w(i,o){const a=this.d.joinPath(i,"tasks.json"),b=o?o.tasksResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}x(i,o){switch(o){case"tasks.json":return(0,g.$e_b)(i.content,this.g)}return null}async y(i,o){const a=await this.resolveContent(i);if(a){const b=this.L(a,"snippets");if(b){const k=(0,w.$b_b)(b),v=[];for(const S of Object.keys(k)){const P=this.d.joinPath(i,S),R=o?this.d.joinPath(o.snippetsHome,S):this.d.joinPath(i,r.a);v.push({resource:P,comparableResource:R})}return v}}return[]}z(i,o){return(0,w.$b_b)(i)[o]||null}A(i,o){const a=this.d.joinPath(i,"extensions.json"),b=o?this.J({remote:!1,syncResource:"extensions",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}B(i,o){switch(o){case"extensions.json":return(0,l.$1$b)((0,l.$Z$b)(i),!0)}return null}async C(i){const{localExtensions:o}=await this.n.createInstance(l.$3$b).getLocalExtensions(i);return(0,l.$1$b)(o,!0)}D(i,o){const a=this.d.joinPath(i,"globalState.json"),b=o?this.J({remote:!1,syncResource:"globalState",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:b}]}E(i,o){switch(o){case"globalState.json":return(0,u.$MLb)(JSON.parse(i.content),!0)}return null}async F(i){const o=await this.n.createInstance(u.$OLb).getLocalGlobalState(i);return(0,u.$MLb)(o,!0)}G(i,o){const a=this.d.joinPath(i,"profiles.json"),b=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:b}]}H(i,o){switch(o){case"profiles.json":return(0,$.$Un)(JSON.parse(i.content),{})}return null}async I(i){return(0,d.$1ac)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(i){const o=i.remote?r.b:r.c,a=[];return i.location&&(a.push(`scheme:${i.location.scheme}`),a.push(`authority:${i.location.authority}`),a.push((0,t.$ef)(i.location.path,"/"))),a.push(`syncResource:${i.syncResource}`),a.push(`profile:${i.profile}`),i.collection&&a.push(`collection:${i.collection}`),i.ref&&a.push(`ref:${i.ref}`),i.node&&a.push(i.node),this.d.joinPath(D.URI.from({scheme:f.$klb,authority:o,path:"/",query:i.location?.query,fragment:i.location?.fragment}),...a)}K(i){if(i.scheme!==f.$klb)return;const o=[];for(;i.path!=="/";)o.unshift(this.d.basename(i)),i=this.d.dirname(i);if(o.length<2)return;const a=i.authority===r.b;let b,k;const v=[];let S,P,R,M,F;for(;o.length;){const q=o.shift();q.startsWith("scheme:")?b=q.substring(7):q.startsWith("authority:")?k=q.substring(10):q.startsWith("syncResource:")?S=q.substring(13):q.startsWith("profile:")?P=q.substring(8):q.startsWith("collection:")?R=q.substring(11):q.startsWith("ref:")?M=q.substring(4):S?F=q:v.push(q)}return{remote:a,syncResource:S,profile:P,collection:R,ref:M,node:F,location:b&&k!==void 0?this.d.joinPath(D.URI.from({scheme:b,authority:k,query:i.query,fragment:i.fragment,path:"/"}),...v):void 0}}L(i,o){try{const a=JSON.parse(i);if((0,y.$FLb)(a))return a}catch(a){this.g.error(a)}throw new f.$$kb((0,N.localize)(0,null),"IncompatibleRemoteContent",o)}async M(i,o,a){const b=await this.e.resolveResourceContent(i,o,a);return{ref:o,content:b}}};e.$zbc=n,e.$zbc=n=r=Ee([Q(0,f.$6kb),Q(1,f.$7kb),Q(2,f.$ilb),Q(3,C.$Al),Q(4,j.$Di),Q(5,I.$1p),Q(6,A.$3k),Q(7,E.$Cl),Q(8,p.$3i),Q(9,m.$vi)],n)}),define(ae[265],ce([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=void 0;const i="sync.lastSyncTime";let o=class extends I.$Vc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(S,P,R,M,F,q,Y,H,X,W,J){super(),this.C=S,this.D=P,this.F=R,this.G=M,this.H=F,this.I=q,this.J=Y,this.L=H,this.M=X,this.N=W,this.O=J,this.f="uninitialized",this.g=this.B(new O.$ee),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$ee),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$ee),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$ee),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$ee),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$ee),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$ee),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=R.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(i,-1,void 0),this.B((0,I.$Tc)(()=>this.bb()))}async createSyncTask(S,P){this.cb(),this.H.info("Sync started.");const R=new Date().getTime(),M=(0,E.$Sg)();try{const H=(0,s.$0kb)(M);P&&(H["Cache-Control"]="no-cache"),S=await this.D.manifest(S,H)}catch(H){const X=s.$$kb.toUserDataSyncError(H);throw k(X,M,this.F,this.I),X}const F=!1,q=this;let Y;return{manifest:S,async run(){if(F)throw new Error("Can run a task only once");Y=(0,N.$jh)(H=>q.P(S,!1,M,H)),await Y.finally(()=>Y=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-R}ms`),q.$()},stop(){return Y?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$$kb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const S=new Date().getTime(),P=(0,E.$Sg)(),R=(0,s.$0kb)(P);let M;try{M=await this.D.manifest(null,R)}catch(Y){const H=s.$$kb.toUserDataSyncError(Y);throw k(H,P,this.F,this.I),H}await this.resetLocal();const F=this,q=new j.$pe;return{id:P,async merge(){return F.P(M,!0,P,q.token)},async apply(){try{try{await F.R(M,P,q.token)}catch(Y){if(s.$$kb.toUserDataSyncError(Y).code==="MethodNotFound")F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(M,P,q.token);else throw Y}}catch(Y){throw F.H.error(Y),Y}F.H.info(`Sync done. Took ${new Date().getTime()-S}ms`),F.$()},async stop(){q.cancel(),await F.U(),await F.resetLocal()}}}async P(S,P,R,M){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,S,P,R,M));const q=F.enabled.find(Y=>Y.resource==="profiles");if(q){const Y=await q.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(Y,S,P,R,M)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(S,P,R,M,F){for(const q of S){if(F.isCancellationRequested)return;const Y=this.M.profiles.find(X=>X.id===q.id);if(!Y){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const H=this.getOrCreateActiveProfileSynchronizer(Y,q);this.n.push(...await this.S(H,P,R,M,F))}for(const[q,Y]of this.z.entries())this.M.profiles.some(H=>H.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(q))}async R(S,P,R){const M=this.ab();for(const X of M){if(R.isCancellationRequested)return;await X.apply(P,R)}const F=M.find(X=>X.profile.isDefault);if(!F)return;const q=F.enabled.find(X=>X.resource==="profiles");if(!q)return;const H=(await q.getRemoteSyncedProfiles(S?.latest??null)||[]).filter(X=>M.every(W=>W.profile.id!==X.id));H.length&&await this.Q(H,S,!1,P,R)}async S(S,P,R,M,F){return(await S.sync(P,R,M,F)).map(([Y,H])=>({profile:S.profile,syncResource:Y,error:H}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(S=>S.stop()))}async resolveContent(S){const P=await this.N.resolveContent(S);if(P)return P;for(const R of this.ab())for(const M of R.enabled){const F=await M.resolveContent(S);if(F)return F}return null}async replace(S){this.cb();const P=this.N.resolveUserDataSyncResource(S);if(!P)return;const R=await this.resolveContent(S.uri);R&&await this.W(P.profile,async M=>{if(P.syncResource===M.resource)return await M.replace(R),!0})}async accept(S,P,R,M){this.cb(),await this.W(S.profile,async F=>{if(S.syncResource===F.resource)return await F.accept(P,R),M&&await F.apply((0,f.$cg)(M)?!1:M.force,(0,s.$0kb)((0,E.$Sg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async P=>{if(P.resource!=="globalState"&&await P.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async P=>{if(await P.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(S){this.H.error(S)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(i,-1);for(const[S]of this.z.values())try{await S.resetLocal()}catch(P){this.H.error(P)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const S=await this.N.getRemoteSyncedProfiles(),P=S.map(q=>q.collection),R=await this.D.getAllCollections(),M=R.filter(q=>!P.includes(q));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const F=S.filter(q=>R.includes(q.collection));if(F.length!==S.length){const q=this.G.createInstance(n.$Zac,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(S){this.cb();const P=await this.D.getActivityData();await this.C.writeFile(S,P)}async extractActivityData(S,P){const R=(await this.C.readFile(S)).value.toString(),M=JSON.parse(R);if(M.resources)for(const F in M.resources)for(const q of M.resources[F])await this.O.writeResource(F,q.content,new Date(q.created*1e3),void 0,P);if(M.collections)for(const F in M.collections)for(const q in M.collections[F].resources)for(const Y of M.collections[F].resources?.[q]??[])await this.O.writeResource(q,Y.content,new Date(Y.created*1e3),F,P)}async W(S,P){const R=new I.$Uc;try{const M=this.z.get(S.id);if(M){const X=await this.X(M[0],P,R);return(0,f.$dg)(X)?null:X}if(S.isDefault){const X=R.add(this.G.createInstance(a,S,void 0)),W=await this.X(X,P,R);return(0,f.$dg)(W)?null:W}if(this.M.isEnabled())return null;const F=R.add(this.G.createInstance(n.$Zac,S,void 0)),q=await this.D.manifest(null),H=(await F.getRemoteSyncedProfiles(q?.latest??null)||[]).find(X=>X.id===S.id);if(H){const X=R.add(this.G.createInstance(a,S,H.collection)),W=await this.X(X,P,R);return(0,f.$dg)(W)?null:W}return null}finally{R.dispose()}}async X(S,P,R){const M=[...S.enabled,...S.disabled.reduce((F,q)=>(q!=="workspaceState"&&F.push(R.add(S.createSynchronizer(q))),F),[])];for(const F of M){const q=await P(F);if(!(0,f.$dg)(q))return q}}Y(S){const P=this.f;this.f!==S&&(this.f=S,this.g.fire(S),P==="hasConflicts"&&this.$())}Z(){const S=this.ab().map(P=>P.conflicts).flat();(0,D.$ub)(this.j,S,(P,R)=>P.profile.id===R.profile.id&&P.syncResource===R.syncResource&&(0,D.$ub)(P.conflicts,R.conflicts,(M,F)=>(0,C.$3g)(M.previewResource,F.previewResource)))||(this.j=S,this.m.fire(S))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(i,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(S,P){let R=this.z.get(S.id);if(R&&R[0].collection!==P?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),R[1].dispose(),R=void 0,this.z.delete(S.id)),!R){const M=new I.$Uc,F=M.add(this.G.createInstance(a,S,P?.collection));M.add(F.onDidChangeStatus(q=>this.Y(q))),M.add(F.onDidChangeConflicts(q=>this.Z())),M.add(F.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(S.id,R=[F,M])}return R[0]}ab(){const S=[];for(const[P]of this.z.values())S.push(P);return S}bb(){this.z.forEach(([,S])=>S.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$3ac=o,e.$3ac=o=Ee([Q(0,h.$3k),Q(1,s.$6kb),Q(2,s.$5kb),Q(3,c.$vi),Q(4,s.$ilb),Q(5,g.$2l),Q(6,p.$1p),Q(7,s.$dlb),Q(8,l.$Cl),Q(9,s.$flb),Q(10,s.$7kb)],o);let a=class extends I.$Vc{get enabled(){return this.f.sort((S,P)=>S[1]-P[1]).map(([S])=>S)}get disabled(){return s.$2kb.filter(S=>!this.r.isResourceEnabled(S))}get status(){return this.g}get conflicts(){return this.m}constructor(S,P,R,M,F,q,Y,H,X,W){super(),this.profile=S,this.collection=P,this.r=R,this.t=M,this.u=F,this.w=q,this.y=Y,this.z=H,this.C=X,this.D=W,this.f=[],this.g="idle",this.h=this.B(new O.$ee),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$ee),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$ee),this.onDidChangeConflicts=this.n.event,this.B(R.onDidChangeResourceEnablement(([J,G])=>this.F(J,G))),this.B((0,I.$Tc)(()=>this.f.splice(0,this.f.length).forEach(([,,J])=>J.dispose())));for(const J of s.$2kb)R.isResourceEnabled(J)&&this.G(J)}F(S,P){P?this.G(S):this.H(S)}G(S){if(this.f.some(([F])=>F.resource===S))return;if(S==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(S==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||S==="workspaceState")return;if(S!=="profiles"&&this.profile.useDefaultFlags?.[S]){this.z.debug(`Skipping syncing ${S} in ${this.profile.name} because it is already synced by default profile`);return}const P=new I.$Uc,R=P.add(this.createSynchronizer(S));P.add(R.onDidChangeStatus(()=>this.L())),P.add(R.onDidChangeConflicts(()=>this.M())),P.add(R.onDidChangeLocal(()=>this.j.fire(S)));const M=this.N(S);this.f.push([R,M,P])}H(S){const P=this.f.findIndex(([R])=>R.resource===S);if(P!==-1){const[[R,,M]]=this.f.splice(P,1);M.dispose(),this.L(),Promise.allSettled([R.stop(),R.resetLocal()]).then(null,F=>this.z.error(F))}}createSynchronizer(S){switch(S){case"settings":return this.t.createInstance($.$0$b,this.profile,this.collection);case"keybindings":return this.t.createInstance(d.$7$b,this.profile,this.collection);case"snippets":return this.t.createInstance(t.$c_b,this.profile,this.collection);case"tasks":return this.t.createInstance(r.$f_b,this.profile,this.collection);case"globalState":return this.t.createInstance(m.$NLb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$2$b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$Zac,this.profile,this.collection)}}async sync(S,P,R,M){if(M.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const q=[],Y=(0,s.$0kb)(R),H=(this.collection?S?.collections?.[this.collection]?.latest:S?.latest)??null,X=P?await this.I(H):{};for(const W of F){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(P){const J=await W.preview(H,X,Y);if(J)for(const G of J.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await W.merge(G.previewResource)}else await W.sync(H,Y)}catch(J){const G=s.$$kb.toUserDataSyncError(J);if(k(G,R,this.w,this.y),b(J))throw G;this.z.error(J),this.z.error(`${W.resource}: ${(0,A.$hj)(J)}`),q.push([W.resource,G])}}return q}finally{this.L()}}async apply(S,P){const R=(0,s.$0kb)(S);for(const M of this.enabled){if(P.isCancellationRequested)return;try{await M.apply(!1,R)}catch(F){const q=s.$$kb.toUserDataSyncError(F);if(k(q,S,this.w,this.y),b(F))throw q;this.z.error(F),this.z.error(`${M.resource}: ${(0,A.$hj)(F)}`)}}}async stop(){for(const S of this.enabled)try{S.status!=="idle"&&await S.stop()}catch(P){this.z.error(P)}}async resetLocal(){for(const S of this.enabled)try{await S.resetLocal()}catch(P){this.z.error(`${S.resource}: ${(0,A.$hj)(P)}`),this.z.error(P)}}async I(S){if(!this.profile.isDefault)return{};const P=this.D.getValue(s.$Xkb),R=this.enabled.find(M=>M instanceof $.$0$b);if(R){const M=await R.getRemoteUserDataSyncConfiguration(S);return{...P,...M}}return P}J(S){this.g!==S&&(this.g=S,this.h.fire(S))}L(){return this.M(),this.enabled.some(S=>S.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(S=>S.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const S=this.enabled.filter(P=>P.status==="hasConflicts").filter(P=>P.conflicts.conflicts.length>0).map(P=>P.conflicts);(0,D.$ub)(this.m,S,(P,R)=>P.syncResource===R.syncResource&&(0,D.$ub)(P.conflicts,R.conflicts,(M,F)=>(0,C.$3g)(M.previewResource,F.previewResource)))||(this.m=S,this.n.fire(S))}N(S){switch(S){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=Ee([Q(2,s.$dlb),Q(3,c.$vi),Q(4,w.$6o),Q(5,s.$5kb),Q(6,g.$2l),Q(7,s.$ilb),Q(8,l.$Cl),Q(9,y.$3i)],a);function b(v){if(v instanceof s.$$kb)switch(v.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function k(v,S,P,R){R.publicLog2("sync/error",{code:v.code,serverCode:v instanceof s.$_kb?String(v.serverCode):void 0,url:v instanceof s.$_kb?v.url:void 0,resource:v.resource,executionId:S,service:P.userDataSyncStore.url.toString()})}}),define(ae[266],ce([0,1,3,2,8,18,25]),function(ne,e,D,N,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0;function I(w,h){return{...w,profile:(0,A.$Dl)(w.profile,h.profilesHome.scheme)}}function C(w){return{created:w.created,uri:j.URI.revive(w.uri)}}class f{constructor(h,c,p){this.c=h,this.d=c,this.f=p,this.a=new Map,this.b=new D.$ee}listen(h,c){switch(c){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${c}`)}async call(h,c,p){try{return await this.g(h,c,p)}catch(g){throw this.f.error(g),g}}async g(h,c,p){switch(c){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(j.URI.revive(p[0]));case"accept":return this.c.accept(I(p[0],this.d),j.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(C(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(j.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(j.URI.revive(p[0]),j.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(c.startsWith("manualSync/")){const g=c.substring(11),l=p[0],u=this.h(l);switch(p=p.slice(1),g){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(h){const c=this.a.get(this.j(h));if(!c)throw new Error(`Manual sync taks not found: ${h}`);return c}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$kec=f;let E=class extends N.$Vc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,c){super(),this.n=c,this.b="uninitialized",this.c=this.B(new D.$ee),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$ee),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$ee),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$ee),this.onSyncErrors=this.m.event,this.a={call(p,g,l){return h.call(p,g,l).then(null,u=>{throw O.$$kb.toUserDataSyncError(u)})},listen(p,g){return h.listen(p,g)}},this.a.call("_getInitialData").then(([p,g,l])=>{this.s(p),this.t(g),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(g=>({...g,error:O.$$kb.toUserDataSyncError(g.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),c=this;return new y(h,{async call(g,l,u){return c.a.call(`manualSync/${g}`,[h,...Array.isArray(l)?l:[l]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,c,p,g){return this.a.call("accept",[h,c,p,g])}resolveContent(h){return this.a.call("resolveContent",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}saveRemoteActivityData(h){return this.a.call("getRemoteActivityData",[h])}extractActivityData(h,c){return this.a.call("extractActivityData",[h,c])}async s(h){this.b=h,this.c.fire(h)}async t(h){this.f=h.map(c=>({syncResource:c.syncResource,profile:(0,A.$Dl)(c.profile,this.n.profilesHome.scheme),conflicts:c.conflicts.map(p=>({...p,baseResource:j.URI.revive(p.baseResource),localResource:j.URI.revive(p.localResource),remoteResource:j.URI.revive(p.remoteResource),previewResource:j.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(h){this.h!==h&&(this.h=h,this.j.fire(h))}};e.$lec=E,e.$lec=E=Ee([Q(1,A.$Cl)],E);class y extends N.$Vc{constructor(h,c){super(),this.id=h,this.a=c}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ae[122],ce([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,45,19,25]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DLb=e.$CLb=e.$BLb=e.$ALb=e.$zLb=void 0;const $="configurationSync.store",t="sync.previous.store",r="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",i=100,o=1e3*60*5;let a=class extends O.$Vc{get userDataSyncStore(){return this.b}get c(){return this.h.get(d.$blb,-1)}set c(R){this.h.store(d.$blb,R,-1,C.$o?0:1)}constructor(R,M,F){super(),this.f=R,this.g=M,this.h=F,this.a=this.B(new A.$ee),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new O.$Uc);this.B(A.Event.filter(F.onDidChangeValue(-1,d.$blb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[$]),this.a.fire()}m(R){if(R&&(R=C.$o&&R.web?{...R,...R.web}:R,(0,E.$9f)(R.url)&&(0,E.$$f)(R.authenticationProviders)&&Object.keys(R.authenticationProviders).every(M=>Array.isArray(R.authenticationProviders[M].scopes)))){const M=R,F=!!M.canSwitch,q=M.url===M.insidersUrl?"insiders":"stable",Y=(F?this.c:void 0)||q,H=Y==="insiders"?M.insidersUrl:Y==="stable"?M.stableUrl:M.url;return{url:y.URI.parse(H),type:Y,defaultType:q,defaultUrl:y.URI.parse(M.url),stableUrl:y.URI.parse(M.stableUrl),insidersUrl:y.URI.parse(M.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(M.authenticationProviders).reduce((X,W)=>(X.push({id:W,scopes:M.authenticationProviders[W].scopes}),X),[])}}}};e.$zLb=a,e.$zLb=a=Ee([Q(0,g.$jk),Q(1,h.$3i),Q(2,m.$1p)],a);let b=class extends a{constructor(R,M,F){super(R,M,F);const q=this.h.get(t,-1);q&&(this.n=JSON.parse(q));const Y=this.f[$];Y?this.h.store(t,JSON.stringify(Y),-1,1):this.h.remove(t,-1)}async switch(R){R!==this.c&&(this.c=R,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$ALb=b,e.$ALb=b=Ee([Q(0,g.$jk),Q(1,h.$3i),Q(2,m.$1p)],b);let k=class extends O.$Vc{get donotMakeRequestsUntil(){return this.j}constructor(R,M,F,q,Y,H,X){super(),this.n=F,this.r=q,this.s=X,this.g=this.B(new A.$ee),this.onTokenFailed=this.g.event,this.h=this.B(new A.$ee),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$ee),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(R),this.c=(0,u.$7p)(Y,H,X).then(W=>{const J={"X-Client-Name":`${M.applicationName}${C.$o?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(J["X-Client-Commit"]=M.commit),J}),this.f=new S(i,o,this.n,this.r),this.u(),this.B((0,O.$Tc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(R,M){this.b={token:R,type:M}}t(R){this.a=R?(0,f.$0g)(R,"v1"):void 0}u(){const R=this.s.getNumber(r,-1);R&&Date.now()<R&&this.y(new Date(R))}y(R){this.j?.getTime()!==R?.getTime()&&(this.j=R,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(r,this.j.getTime(),-1,1),this.w=(0,D.$jh)(M=>(0,D.$xh)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(r,-1),this.m.fire())}async getAllCollections(R={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,f.$0g)(this.a,"collection").toString();R={...R},R["Content-Type"]="application/json";const F=await this.D(M,{type:"GET",headers:R},[],N.CancellationToken.None);return(await(0,l.$Tp)(F))?.map(({id:q})=>q)||[]}async createCollection(R={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,f.$0g)(this.a,"collection").toString();R={...R},R["Content-Type"]=I.$Qs.text;const F=await this.D(M,{type:"POST",headers:R},[],N.CancellationToken.None),q=await(0,l.$Sp)(F);if(!q)throw new d.$_kb("Server did not return the collection id",M,"NoCollection",F.res.statusCode,F.res.headers[d.$8kb]);return q}async deleteCollection(R,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=R?(0,f.$0g)(this.a,"collection",R).toString():(0,f.$0g)(this.a,"collection").toString();M={...M},await this.D(F,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async getAllResourceRefs(R,M){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,M,R),q={},Y=await this.D(F.toString(),{type:"GET",headers:q},[],N.CancellationToken.None);return(await(0,l.$Tp)(Y)||[]).map(({url:X,created:W})=>({ref:(0,f.$_g)(F,F.with({path:X})),created:W*1e3}))}async resolveResourceContent(R,M,F,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,f.$0g)(this.z(this.a,F,R),M).toString();q={...q},q["Cache-Control"]="no-cache";const H=await this.D(Y,{type:"GET",headers:q},[],N.CancellationToken.None);return await(0,l.$Sp)(H)}async deleteResource(R,M,F){if(!this.a)throw new Error("No settings sync store url configured.");const q=M!==null?(0,f.$0g)(this.z(this.a,F,R),M).toString():this.z(this.a,F,R).toString(),Y={};await this.D(q,{type:"DELETE",headers:Y},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const R=(0,f.$0g)(this.a,"resource").toString(),M={"Content-Type":I.$Qs.text};await this.D(R,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async readResource(R,M,F,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,f.$0g)(this.z(this.a,F,R),"latest").toString();q={...q},q["Cache-Control"]="no-cache",M&&(q["If-None-Match"]=M.ref);const H=await this.D(Y,{type:"GET",headers:q},[304],N.CancellationToken.None);let X=null;if(H.res.statusCode===304&&(X=M),X===null){const W=H.res.headers.etag;if(!W)throw new d.$_kb("Server did not return the ref",Y,"NoRef",H.res.statusCode,H.res.headers[d.$8kb]);const J=await(0,l.$Sp)(H);if(!J&&H.res.statusCode===304)throw new d.$_kb("Empty response",Y,"EmptyResponse",H.res.statusCode,H.res.headers[d.$8kb]);X={ref:W,content:J}}return X}async writeResource(R,M,F,q,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const H=this.z(this.a,q,R).toString();Y={...Y},Y["Content-Type"]=I.$Qs.text,F&&(Y["If-Match"]=F);const X=await this.D(H,{type:"POST",data:M,headers:Y},[],N.CancellationToken.None),W=X.res.headers.etag;if(!W)throw new d.$_kb("Server did not return the ref",H,"NoRef",X.res.statusCode,X.res.headers[d.$8kb]);return W}async manifest(R,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,f.$0g)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",R&&(M["If-None-Match"]=R.ref);const q=await this.D(F,{type:"GET",headers:M},[304],N.CancellationToken.None);let Y=null;if(q.res.statusCode===304&&(Y=R),!Y){const X=q.res.headers.etag;if(!X)throw new d.$_kb("Server did not return the ref",F,"NoRef",q.res.statusCode,q.res.headers[d.$8kb]);const W=await(0,l.$Sp)(q);if(!W&&q.res.statusCode===304)throw new d.$_kb("Empty response",F,"EmptyResponse",q.res.statusCode,q.res.headers[d.$8kb]);W&&(Y={...JSON.parse(W),ref:X})}const H=this.s.get(n,-1);return H&&Y&&H!==Y.session&&this.C(),Y===null&&H&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const R=(0,f.$0g)(this.a,"download").toString(),M={},F=await this.D(R,{type:"GET",headers:M},[],N.CancellationToken.None);if(!(0,l.$Pp)(F))throw new d.$_kb("Server returned "+F.res.statusCode,R,"EmptyResponse",F.res.statusCode,F.res.headers[d.$8kb]);if((0,l.$Qp)(F))throw new d.$_kb("Empty response",R,"EmptyResponse",F.res.statusCode,F.res.headers[d.$8kb]);return F.stream}z(R,M,F){return M?(0,f.$0g)(R,"collection",M,"resource",F):(0,f.$0g)(R,"resource",F)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(R,M,F,q){if(!this.b)throw new d.$_kb("No Auth Token Available",R,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new d.$_kb(`${M.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;M.headers={...M.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:R,type:M.type,headers:{...M.headers,authorization:void 0}});let H;try{H=await this.f.request(R,M,q)}catch(B){if(!(B instanceof d.$_kb)){let ie="RequestFailed";const re=(0,j.$0)(B).toLowerCase();re.includes("xhr timeout")?ie="RequestTimeout":re.includes("protocol")&&re.includes("not supported")?ie="RequestProtocolNotSupported":re.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":re.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,j.$4)(B)&&(ie="RequestCanceled"),B=new d.$_kb(`Connection refused for the request '${R}'.`,R,ie,void 0,void 0)}throw this.r.info("Request failed",R),B}const X=H.res.headers[d.$8kb],W={url:R,status:H.res.statusCode,"execution-id":M.headers[d.$9kb],"operation-id":X},J=(0,l.$Pp)(H)||H.res.statusCode&&F.includes(H.res.statusCode);let G="";if(J?this.r.trace("Request succeeded",W):(G=await(0,l.$Rp)(H)||"",this.r.info("Request failed",W,G)),H.res.statusCode===401||H.res.statusCode===403){if(this.b=void 0,H.res.statusCode===401)throw this.g.fire("Unauthorized"),new d.$_kb(`${M.type} request '${R}' failed because of Unauthorized (401).`,R,"Unauthorized",H.res.statusCode,X);if(H.res.statusCode===403)throw this.g.fire("Forbidden"),new d.$_kb(`${M.type} request '${R}' failed because the access is forbidden (403).`,R,"Forbidden",H.res.statusCode,X)}if(this.h.fire(),H.res.statusCode===404)throw new d.$_kb(`${M.type} request '${R}' failed because the requested resource is not found (404).`,R,"NotFound",H.res.statusCode,X);if(H.res.statusCode===405)throw new d.$_kb(`${M.type} request '${R}' failed because the requested endpoint is not found (405). ${G}`,R,"MethodNotFound",H.res.statusCode,X);if(H.res.statusCode===409)throw new d.$_kb(`${M.type} request '${R}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,R,"Conflict",H.res.statusCode,X);if(H.res.statusCode===410)throw new d.$_kb(`${M.type} request '${R}' failed because the requested resource is not longer available (410).`,R,"Gone",H.res.statusCode,X);if(H.res.statusCode===412)throw new d.$_kb(`${M.type} request '${R}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,R,"PreconditionFailed",H.res.statusCode,X);if(H.res.statusCode===413)throw new d.$_kb(`${M.type} request '${R}' failed because of too large payload (413).`,R,"TooLarge",H.res.statusCode,X);if(H.res.statusCode===426)throw new d.$_kb(`${M.type} request '${R}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,R,"UpgradeRequired",H.res.statusCode,X);if(H.res.statusCode===429){const B=H.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new d.$_kb(`${M.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",H.res.statusCode,X)):new d.$_kb(`${M.type} request '${R}' failed because of too many requests (429).`,R,"RemoteTooManyRequests",H.res.statusCode,X)}if(!J)throw new d.$_kb("Server returned "+H.res.statusCode,R,"Unknown",H.res.statusCode,X);return H}F(R){let M=this.s.get(s,-1);M===void 0&&(M=(0,w.$Sg)(),this.s.store(s,M,-1,1)),R["X-Machine-Session-Id"]=M;const F=this.s.get(n,-1);F!==void 0&&(R["X-User-Session-Id"]=F)}};e.$BLb=k,e.$BLb=k=Ee([Q(1,g.$jk),Q(2,l.$Np),Q(3,d.$ilb),Q(4,c.$Di),Q(5,p.$3k),Q(6,m.$1p)],k);let v=class extends k{constructor(R,M,F,q,Y,H,X){super(R.userDataSyncStore?.url,M,F,q,Y,H,X),this.B(R.onDidChangeUserDataSyncStore(()=>this.t(R.userDataSyncStore?.url)))}};e.$CLb=v,e.$CLb=v=Ee([Q(0,d.$5kb),Q(1,g.$jk),Q(2,l.$Np),Q(3,d.$ilb),Q(4,c.$Di),Q(5,p.$3k),Q(6,m.$1p)],v);class S{constructor(R,M,F,q){this.c=R,this.d=M,this.f=F,this.g=q,this.a=[],this.b=void 0}request(R,M,F){if(this.h()&&this.i(),M.url=R,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new d.$_kb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,R,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(R),this.f.request(M,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$DLb=S}),define(ae[267],ce([0,1,3,2,8,21,24,19,122]),function(ne,e,D,N,j,A,O,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=e.$iec=e.$hec=e.$gec=void 0;class f{constructor(c){this.a=c}listen(c,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${p}`)}call(c,p,g){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$gec=f;class E extends N.$Vc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(c){super(),this.c=c,this.b=this.B(new D.$ee),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(p=>{this.a=p,this.B(this.c.listen("onDidChangeAccount")(g=>{this.a=g,this.b.fire(g)}))})}updateAccount(c){return this.c.call("updateAccount",c)}}e.$hec=E;class y{constructor(c){this.a=c}listen(c,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${p}`)}call(c,p,g){switch(p){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$iec=y;let w=class extends C.$zLb{constructor(c,p,g,l){super(p,g,l),this.n=c,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(c){return this.n.call("switch",[c])}async getPreviousUserDataSyncStore(){const c=await this.n.call("getPreviousUserDataSyncStore");return this.r(c)}r(c){return{url:j.URI.revive(c.url),type:c.type,defaultUrl:j.URI.revive(c.defaultUrl),insidersUrl:j.URI.revive(c.insidersUrl),stableUrl:j.URI.revive(c.stableUrl),canSwitch:c.canSwitch,authenticationProviders:c.authenticationProviders}}};e.$jec=w,e.$jec=w=Ee([Q(1,O.$jk),Q(2,A.$3i),Q(3,I.$1p)],w)}),define(ae[268],ce([0,1,3,57,24,19,22,263,25,80,83]),function(ne,e,D,N,j,A,O,I,C,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;let y=class extends I.$4ac{constructor(h,c,p,g,l,u,m,d,$,t,r){super(h,c,p,g,l,m,d,$,t,r),this.B(D.Event.debounce(D.Event.any(D.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),D.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$Fec=y,e.$Fec=y=Ee([Q(0,j.$jk),Q(1,C.$5kb),Q(2,C.$6kb),Q(3,C.$dlb),Q(4,C.$elb),Q(5,N.$wcc),Q(6,C.$ilb),Q(7,f.$8Jb),Q(8,O.$2l),Q(9,E.$Skb),Q(10,A.$1p)],y)}),define(ae[269],ce([0,1,73,23,5,20]),function(ne,e,D,N,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=void 0,e.$Xbc=O,e.$Ybc=I,e.$Zbc=C,e.$Wbc=128/4;function O(f){function E(){let y=f.scheme===N.Schemas.file?(0,A.$Xg)(f):f.toString();return j.$k||(y=y.toLowerCase()),(0,D.createHash)("md5").update(y).digest("hex")}return{id:E(),configPath:f}}function I(f,E){function y(){if(f.scheme!==N.Schemas.file)return(0,D.createHash)("md5").update(f.toString()).digest("hex");if(!E)return;let h;return j.$k?h=E.ino:j.$j?h=E.birthtime.getTime():j.$i&&(typeof E.birthtimeMs=="number"?h=Math.floor(E.birthtimeMs):h=E.birthtime.getTime()),(0,D.createHash)("md5").update(f.fsPath).update(h?String(h):"").digest("hex")}const w=y();if(typeof w=="string")return{id:w,uri:f}}function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ae[270],ce([0,1,6,7,2,14,31,16,9,77,112,269,57,56,23]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;let p=class extends j.$Vc{constructor(l,u,m,d){super(),this.a=l,this.b=u,this.c=m,this.f=d,this.B(new D.$Ih(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:c.Schemas.file}).fsPath,u=await O.Promises.readdir(l),m=new f.$IKb(this.f.getChannel("storage"));await Promise.all(u.map(async d=>{const $=(0,A.$kc)(l,d);d.length===y.$Wbc||d===E.$Ii.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===d)||await m.isUsed($)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await O.Promises.rm($))}))}catch(l){(0,N.$1)(l)}}};e.$cec=p,e.$cec=p=Ee([Q(0,I.$Ei),Q(1,C.$3j),Q(2,w.$wcc),Q(3,h.$Ldc)],p)}),define(ae[123],ce([0,1,73,64,37,279,15,7,3,2,14,5,32,42,68]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$ni=e.$mi=e.$li=void 0,e.$oi=n,e.$pi=s,e.$ri=a,e.$si=b;class p{traceSocketEvent(v,S){c.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,S)}constructor(v,S=""){this.f=!0,this.debugLabel=S,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,I.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const S=P=>{this.traceSocketEvent("read",P),v(O.$Ge.wrap(P))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(v){const S=P=>{v({type:0,hadError:P,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(v){const S=()=>{v()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,I.$1)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,I.$1)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$li=p;var g;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize",k[k.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var l;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(l||(l={}));class u extends f.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,S){this.socket.traceSocketEvent(v,S)}constructor(v,S,P,R){super(),this.f=this.B(new C.$ee),this.g=this.B(new C.$ee),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:P?.byteLength||0,recordInflateBytes:R}),this.a=this.B(new m(this,S,P,R,this.f,(M,F)=>this.m(M,F))),this.B(this.a.onError(M=>{console.error(M),(0,I.$1)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new c.$gi,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let S=0;for(;S<v.byteLength;)this.a.writeMessage(v.slice(S,Math.min(S+262144,v.byteLength)),{compressed:!0,opcode:2}),S+=262144}m(v,{compressed:S,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let R=2;v.byteLength<126?R+=0:v.byteLength<2**16?R+=2:R+=8;const M=O.$Ge.alloc(R),F=S?64:0,q=P&15;if(M.writeUInt8(128|F|q,0),v.byteLength<126)M.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){M.writeUInt8(126,1);let Y=1;M.writeUInt8(v.byteLength>>>8&255,++Y),M.writeUInt8(v.byteLength>>>0&255,++Y)}else{M.writeUInt8(127,1);let Y=1;M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(v.byteLength>>>24&255,++Y),M.writeUInt8(v.byteLength>>>16&255,++Y),M.writeUInt8(v.byteLength>>>8&255,++Y),M.writeUInt8(v.byteLength>>>0&255,++Y)}this.socket.write(O.$Ge.concat([M,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),P=S.readUInt8(0),R=(P&128)>>>7,M=(P&64)>>>6,F=P&15,q=S.readUInt8(1),Y=(q&128)>>>7,H=q&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(H===126?2:0)+(H===127?8:0),this.j.fin=R,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!R,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),P=S.readUInt8(1),R=(P&128)>>>7;let M=P&127,F=1;M===126?M=S.readUInt8(++F)*2**8+S.readUInt8(++F):M===127&&(M=S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*2**24+S.readUInt8(++F)*2**16+S.readUInt8(++F)*2**8+S.readUInt8(++F));let q=0;R&&(q=S.readUInt8(++F)*2**24+S.readUInt8(++F)*2**16+S.readUInt8(++F)*2**8+S.readUInt8(++F)),this.j.state=3,this.j.readLen=M,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),t(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(S,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$mi=u;class m extends f.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Ge.alloc(0)}constructor(v,S,P,R,M,F){super(),this.n=v,this.r=M,this.s=F,this.a=this.B(new C.$ee),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.$ee),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new C.$ee),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,S?(this.b=this.B(new d(this.n,R,P,{windowBits:15})),this.f=this.B(new $(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(v,S){this.g.push({data:v,options:S}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:v,options:S}=this.g.shift();if(this.f&&S.compressed){const P=await this.w(this.f,v);this.s(P,S)}else this.s(v,{...S,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,S){return new Promise((P,R)=>{v.write(S),v.flush(M=>P(M))})}acceptFrame(v,S,P){this.h.push({data:v,isCompressed:S,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const S=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(S)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,S,P){return new Promise((R,M)=>{v.write(S),P&&v.write(O.$Ge.fromByteArray([0,0,255,255])),v.flush(F=>R(F))})}}class d extends f.$Vc{get recordedInflateBytes(){return this.j?O.$Ge.concat(this.f):O.$Ge.alloc(0)}constructor(v,S,P,R){super(),this.h=v,this.j=S,this.a=this.B(new C.$ee),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(R),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(O.$Ge.wrap(M))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent("zlibInflateWrite",v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=O.$Ge.concat(this.g);this.g.length=0,v(S)})}}class $ extends f.$Vc{constructor(v,S){super(),this.g=v,this.a=this.B(new C.$ee),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(O.$Ge.wrap(P))})}write(v){this.g.traceSocketEvent("zlibDeflateWrite",v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=O.$Ge.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),v(S)})}}function t(k,v){if(v===0)return;const S=k.byteLength>>>2;for(let Y=0;Y<S;Y++){const H=k.readUInt32BE(Y*4);k.writeUInt32BE(H^v,Y*4)}const P=S*4,R=k.byteLength-P,M=v>>>24&255,F=v>>>16&255,q=v>>>8&255;R>=1&&k.writeUInt8(k.readUInt8(P)^M,P),R>=2&&k.writeUInt8(k.readUInt8(P+1)^F,P+1),R>=3&&k.writeUInt8(k.readUInt8(P+2)^q,P+2)}e.$ni=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function n(){const k=(0,w.$Sg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;const v=process.platform!=="darwin"&&e.$ni?e.$ni:(0,j.tmpdir)(),S=(0,E.$kc)(v,`vscode-ipc-${k}.sock`);return i(S),S}function s(k,v,S){const R=(0,D.createHash)("sha256").update(k).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${S}-${v}-sock`;const M=S.substr(0,4),F=v.substr(0,6);let q;return process.platform!=="darwin"&&e.$ni&&!process.env.VSCODE_PORTABLE?q=(0,E.$kc)(e.$ni,`vscode-${R}-${M}-${F}.sock`):q=(0,E.$kc)(k,`${M}-${F}.sock`),i(q),q}function i(k){const v=r[y.$u];typeof v=="number"&&k.length>=v&&console.warn(`WARNING: IPC handle "${k}" is longer than ${v} chars, try a shorter --user-data-dir`)}class o extends h.$ai{static b(v){const S=C.Event.fromNodeEventEmitter(v,"connection");return C.Event.map(S,P=>({protocol:new c.$hi(new p(P,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(P,"close"))}))}constructor(v){super(o.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$qi=o;function a(k){return new Promise((v,S)=>{const P=(0,N.createServer)();P.on("error",S),P.listen(k,()=>{P.removeListener("error",S),v(new o(P))})})}function b(k,v){return new Promise((S,P)=>{const R=(0,N.createConnection)(k,()=>{R.removeListener("error",P),S(c.$ii.fromSocket(new p(R,`ipc-client${v}`),v))});R.once("error",P)})}}),define(ae[271],ce([0,1,64,123,218]),function(ne,e,D,N,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0,e.$Iec=new class{supports(A){return!0}connect({host:A,port:O},I,C,f){return new Promise((E,y)=>{const w=D.createConnection({host:A,port:O},()=>{w.removeListener("error",y),w.write((0,j.$lvb)(I,C,f));const h=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",h),E(new N.$li(w,f)))};w.on("data",h)});w.setNoDelay(!0),w.once("error",y)})}}}),define(ae[272],ce([0,1,64,37,133,123,6,2,5,21,9,24,220,103,105,78,15]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=e.$Edc=e.$Ddc=e.$Cdc=void 0;async function l(t,r,n,s,i){let o;for(let a=3;a&&(o?.dispose(),o=await new u(t,r,n,s,i).waitForReady(),!(i&&j.$Vg[i]||!j.$Vg[o.tunnelLocalPort]));a--);return o}class u extends I.$Vc{constructor(r,n,s,i,o){super(),this.m=n,this.n=o,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=D.createServer(),this.c=new O.$vh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,n=(0,p.$kw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,j.$Wg)(r,2,1e3,n),i=null;return this.b.listen(s,this.m),await this.c.wait(),i=this.b.address(),i||(s=0,this.b.listen(s,this.m),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async r(r){r.pause();const n=(0,p.$iw)(this.tunnelRemoteHost)||(0,p.$kw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,w.$Sl)(this.a,n,this.tunnelRemotePort),i=s.getSocket(),o=s.readEntireBuffer();s.dispose(),o.byteLength>0&&r.write(o.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),i.end()}),r.on("close",()=>i.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),i instanceof A.$li?i.socket.destroy():i.end()}),i instanceof A.$li?this.t(r,i):this.s(r,i),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),i.end()})}s(r,n){n.onClose(()=>r.destroy()),n.onEnd(()=>r.end()),n.onData(s=>r.write(s.buffer)),r.on("data",s=>n.write(g.$Ge.wrap(s))),r.resume()}t(r,n){const s=n.socket;s.on("end",()=>r.end()),s.on("close",()=>r.end()),s.on("error",()=>{r.destroy()}),s.pipe(r),r.pipe(s)}}e.$Cdc=u;let m=class extends p.$nw{constructor(r,n,s,i,o){super(n,o),this.v=r,this.w=s,this.y=i}isPortPrivileged(r){return(0,p.$lw)(r,this.m,C.OS,N.release())}t(r,n,s,i,o,a,b,k){const v=this.s(n,s);if(v)return++v.refcount,v.value;if((0,p.$ew)(r))return this.u(r,n,s,o,a,b,k);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${o}.`);const S={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=l(S,i,n,s,o);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,P),P}}};e.$Ddc=m,e.$Ddc=m=Ee([Q(0,h.$Ml),Q(1,E.$3j),Q(2,c.$Pl),Q(3,y.$jk),Q(4,f.$3i)],m);let d=class extends m{constructor(r,n,s,i,o){super(r,n,s,i,o)}};e.$Edc=d,e.$Edc=d=Ee([Q(0,h.$Ml),Q(1,E.$3j),Q(2,c.$Pl),Q(3,y.$jk),Q(4,f.$3i)],d);let $=class extends I.$Vc{constructor(r,n,s,i,o){super(),this.b=r,this.c=n,this.f=s,this.g=i,this.h=o,this.a=new Map}async openTunnel(r,n,s,i,o,a,b,k,v){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${i} on local port ${a}.`),!this.a.has(r)){const S=new d(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(r,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(n,s,i,o,a,b,k,v)}};e.$Fdc=$,e.$Fdc=$=Ee([Q(0,h.$Ml),Q(1,E.$3j),Q(2,y.$jk),Q(3,c.$Pl),Q(4,f.$3i)],$)}),define(ae[280],ce([0,1,37,38,7,2,23,8,17,3,42,151,212,213,203,204,270,193,195,21,217,94,228,95,223,16,114,254,29,107,194,113,96,12,206,207,72,4,202,74,75,234,9,208,100,24,59,19,106,22,108,109,110,49,237,82,111,25,80,262,267,247,83,261,265,266,122,60,260,248,105,227,78,272,222,238,28,239,5,240,196,215,214,81,253,18,52,211,58,259,236,249,104,264,255,10,209,99,257,252,224,190,57,210,268,256,56,258,103,271,187,225,147,140,145]),function(ne,e,D,N,j,A,O,I,C,f,E,y,w,h,c,p,g,l,u,m,d,$,t,r,n,s,i,o,a,b,k,v,S,P,R,M,F,q,Y,H,X,W,J,G,B,ie,re,he,te,V,z,L,T,U,x,K,ee,_,Z,se,ue,ge,fe,$e,ye,ve,Ce,De,le,me,we,Pe,Re,Me,Le,qe,Te,Ue,ze,Ae,oe,de,pe,be,ke,Ie,Oe,Ne,We,Be,Fe,Qe,He,_e,tt,kt,St,gt,Ct,Pt,It,Rt,Dt,Ot,Lt,jt,$t,At,mt,Nt,Mt,st,Tt,Ft,wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=pt;class qt extends A.$Vc{constructor(Se){super(),this.f=Se,this.a=this.B(new y.$9W(this)),this.b=void 0,this.c=this.B(new f.$ee),this.g()}g(){let Se=!1;const je=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,y.$0W)(process.parentPort,st.$Rcc.exit,je)}async init(){const Se=await this.h();(0,_.$Zkb)(),Se.invokeFunction(je=>{const Ge=je.get(J.$3j),Ve=je.get(V.$2l),Xe=je.get(Ie.$Cl);Ge.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(Ge),this.n(Ve,Xe),this.B(Xe.onDidChangeProfiles(()=>this.n(Ve,Xe))),this.r(Ve,Ge)}),this.B((0,A.$Sc)(Se.createInstance(w.$$dc,this.f.codeCachePath),Se.createInstance(h.$_dc),Se.createInstance(g.$cec),Se.createInstance(p.$bec),Se.createInstance(c.$aec),Se.createInstance(tt.$zec),Se.createInstance(Qe.$rec)))}async h(){const Se=new H.$ui,je={_serviceBrand:void 0,...B.default};Se.set(ie.$jk,je);const Ge=new E.$ei(Ke=>Ke==="main"),Ve=new $t.$Mdc(this.a,Ge);Se.set($t.$Ldc,Ve);const Xe=this.f.policiesData?new Ne.$idc(this.f.policiesData,Ve.getChannel("policy")):new We.$go;Se.set(We.$eo,Xe);const Je=new Mt.$9m(this.f.args,je);Se.set(s.$Ei,Je);const et=new G.$_r(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:I.URI.revive(Ke.resource)})),Ve.getChannel("logger"));Se.set(J.$4j,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,kt.localize)(0,null)})),ht=this.B(new J.$$j(ot.getLevel())),Ze=this.B(new St.$OQ(ot,[ht]));Se.set(J.$3j,Ze),this.b=this.B(new gt.$Bec(Ze)),Se.set(gt.$Aec,this.b);const Ye=this.B(new R.$Iq(Ze));Se.set(P.$3k,Ye);const ut=this.B(new M.$_q(Ze));Ye.registerProvider(O.Schemas.file,ut);const at=new Ue.$As(Ye);Se.set(Te.$Al,at);const xe=this.B(new Be.$VQ(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Se.set(Ie.$Cl,xe);const ft=this.B(new Ae.$Kdc(O.Schemas.file,this.B(new oe.$xQ(Ve.getChannel(oe.$wQ),{pathCaseSensitive:ze.$k})),O.Schemas.vscodeUserData,xe,at,Ze));Ye.registerProvider(O.Schemas.vscodeUserData,ft);const it=this.B(new d.$Go(xe.defaultProfile.settingsResource,Ye,Xe,Ze));Se.set(m.$3i,it);const dt=new At.$Hec(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},Ve,Je);Se.set(he.$1p,dt),this.B((0,A.$Tc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const bt=new It.$Vr(Ve.getChannel("request"));Se.set(re.$Np,bt),Se.set(l.$dec,new F.$ti(u.$eec,void 0,!1)),Se.set(pe.$oG,new F.$ti(de.$qec,void 0,!1));const yt=new Ot.$Rdc(-1,Ve);Se.set(Dt.$wcc,yt),Se.set(r.$Ko,new F.$ti(n.$4Q,void 0,!0));const zt=this.B(new me.$fdc(yt)),Bt=new E.$ei(Ke=>zt.getActiveClientId().then(lt=>Ke===lt));Se.set(S.$s4b,new Rt.$Dec(this.a.getChannel("extensionRecommendationNotification",Bt)));let ct;const nt=[],vt=(0,U.$rp)(je,it);if((0,U.$mp)(je,Je)){const Ke=new L.$iac(Ze,et,Je,je);if(nt.push(Ke),!(0,U.$np)(je,Je)&&je.aiConfig?.ariaKey){const lt=new Fe.$CQ(bt,vt,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,A.$Tc)(()=>lt.flush())),nt.push(lt)}ct=new T.$Zr({appenders:nt,commonProperties:(0,te.$dp)((0,D.release)(),(0,D.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,vt),sendErrorTelemetry:!0,piiPaths:(0,U.$sp)(Je)},it,je)}else{ct=U.$hp;const Ke=U.$lp;nt.push(Ke)}this.a.registerChannel("telemetryAppender",new z.$Wcc(nt)),Se.set(V.$2l,ct);const Vt=new x.$fec(it,ct,Ze,et,Je,je);Se.set(V.$3l,Vt),Se.set(Oe.$pq,new F.$ti(Pt.$NQ,void 0,!0)),Se.set(be.$tq,new F.$ti(ke.$jdc,void 0,!0)),Se.set(b.$_p,new F.$ti(b.$bq,void 0,!0)),Se.set(v.$Dq,new F.$ti(v.$Eq,void 0,!0)),Se.set(a.$6o,new F.$ti(o.$0p,void 0,!0)),Se.set(a.$ap,new F.$ti(jt.$Gec,void 0,!1)),Se.set(X.$Rr,new F.$ti(W.$Tr,void 0,!1)),Se.set($.$dn,new F.$ti(t.$Hs,void 0,!1)),Se.set(Z.$8Jb,new F.$ti(Z.$9Jb,void 0,!0)),Se.set(_.$ilb,new F.$ti(ge.$vMb,void 0,!0)),Se.set(_.$hlb,E.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),Se.set(a.$_o,new F.$ti(i.$6Jb,void 0,!1)),Se.set(ee.$tMb,new F.$ti(ee.$uMb,void 0,!0)),Se.set(K.$1v,new F.$ti(K.$2v)),Se.set(_.$5kb,new F.$ti(Ce.$ALb,void 0,!0)),Se.set(_.$6kb,new F.$ti(Ce.$CLb,void 0,!0)),Se.set(fe.$Skb,new F.$ti(fe.$Ukb,void 0,!0)),Se.set(_.$7kb,new F.$ti(se.$Xac,void 0,!1)),Se.set(_.$dlb,new F.$ti($e.$Mac,void 0,!0)),Se.set(_.$elb,new F.$ti(ye.$3ac,void 0,!1)),Se.set(De.$JKb,new F.$ti(le.$mec,void 0,!0)),Se.set(_.$flb,new F.$ti(_e.$zbc,void 0,!0)),Se.set(we.$Pl,new F.$ti(Pe.$Hdc,void 0,!1));const Et=new mt.$Nl;return Se.set(mt.$Ml,Et),Et.register(0,Nt.$Iec),Se.set(Re.$dw,new F.$ti(Me.$Fdc)),Se.set(Le.$nec,new F.$ti(qe.$pec)),Se.set(He.$sec,new F.$ti(Ct.$Cec)),new Y.$cr(Se)}j(Se){const je=new k.$dq(Se.get(a.$9o),()=>null);this.a.registerChannel("extensions",je);const Ge=E.ProxyChannel.fromService(Se.get(X.$Rr),this.q);this.a.registerChannel("languagePacks",Ge);const Ve=E.ProxyChannel.fromService(Se.get($.$dn),this.q);this.a.registerChannel("diagnostics",Ve);const Xe=new k.$fq(Se.get(a.$ap));this.a.registerChannel("extensionTipsService",Xe);const Je=E.ProxyChannel.fromService(Se.get(l.$dec),this.q);this.a.registerChannel("checksum",Je);const et=E.ProxyChannel.fromService(Se.get(pe.$oG),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=E.ProxyChannel.fromService(Se.get(fe.$Skb),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=E.ProxyChannel.fromService(Se.get(V.$3l),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Ze=new ue.$gec(Se.get(Z.$8Jb));this.a.registerChannel("userDataSyncAccount",Ze);const Ye=new ue.$iec(Se.get(_.$5kb));this.a.registerChannel("userDataSyncStoreManagement",Ye);const ut=new ve.$kec(Se.get(_.$elb),Se.get(Ie.$Cl),Se.get(J.$3j));this.a.registerChannel("userDataSync",ut);const at=this.B(Se.get(q.$vi).createInstance(Lt.$Fec));this.a.registerChannel("userDataAutoSync",E.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",E.ProxyChannel.fromService(Se.get(_.$flb),this.q));const xe=E.ProxyChannel.fromService(Se.get(Le.$nec),this.q);this.a.registerChannel(Le.$oec,xe);const ft=E.ProxyChannel.fromService(Se.get(He.$sec),this.q);this.a.registerChannel("remoteTunnel",ft)}m(Se){process.on("uncaughtException",je=>(0,j.$1)(je)),process.on("unhandledRejection",je=>(0,j.$1)(je)),(0,j.setUnexpectedErrorHandler)(je=>{const Ge=(0,N.$hj)(je,!0);Ge&&Se.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}n(Se,je){Se.publicLog2("profilesInfo",{count:je.profiles.length})}async r(Se,je){if(ze.$k){const[Ge,Ve]=await Promise.all([(0,Tt.$Tg)(je.error.bind(je)),(0,wt.$QW)(je.error.bind(je))]),Xe=(0,Ft.$wW)(),Je=(0,wt.$RW)(Ve,this.f.args["ozone-platform"]);Ge&&Se.publicLog2("clientPlatformInfo",{platformId:Ge.id,platformVersionId:Ge.version_id,platformIdLike:Ge.id_like,desktopEnvironment:Xe,displayProtocol:Ve,codeDisplayProtocol:Je})}}handledClientConnection(Se){if(Se.data!==st.$Tcc.response)return!1;const je=(0,C.$Ob)(Se.ports);return je?(this.c.fire(je),!0):!1}}async function pt(rt){try{const Se=new qt(rt);process.parentPort.postMessage(st.$Rcc.ipcReady),await Se.init(),process.parentPort.postMessage(st.$Rcc.initDone)}catch(Se){process.parentPort.postMessage({error:Se.toString()})}}const Ut=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout(Ut),pt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/17235b28ebca8f946926ec11374b67cd53c0619d/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
