/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/base/common/async","vs/base/common/strings","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],ge=function(ae){for(var e=[],y=0,S=ae.length;y<S;y++)e[y]=fe[ae[y]];return e};define(fe[40],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=y,e.$gb=S,e.$hb=C,e.$ib=M,e.$jb=j,e.$kb=P,e.$lb=l,e.$nb=p,e.$ob=u,e.$pb=k,e.$qb=o,e.$rb=a;function y(m,f){const n=S(m,f);if(n!==-1)return m[n]}function S(m,f,n=m.length-1){for(let s=n;s>=0;s--){const d=m[s];if(f(d))return s}return-1}function C(m,f){const n=M(m,f);return n===-1?void 0:m[n]}function M(m,f,n=0,s=m.length){let d=n,v=s;for(;d<v;){const i=Math.floor((d+v)/2);f(m[i])?d=i+1:v=i}return d-1}function j(m,f){const n=P(m,f);return n===m.length?void 0:m[n]}function P(m,f,n=0,s=m.length){let d=n,v=s;for(;d<v;){const i=Math.floor((d+v)/2);f(m[i])?v=i:d=i+1}return d}function l(m,f,n=0,s=m.length){const d=P(m,f,n,s);return d===m.length?-1:d}class r{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(r.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!f(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const n=M(this.e,f,this.c);return this.c=n+1,n===-1?void 0:this.e[n]}}e.$mb=r;function p(m,f){if(m.length===0)return;let n=m[0];for(let s=1;s<m.length;s++){const d=m[s];f(d,n)>0&&(n=d)}return n}function u(m,f){if(m.length===0)return;let n=m[0];for(let s=1;s<m.length;s++){const d=m[s];f(d,n)>=0&&(n=d)}return n}function k(m,f){return p(m,(n,s)=>-f(n,s))}function o(m,f){if(m.length===0)return-1;let n=0;for(let s=1;s<m.length;s++){const d=m[s];f(d,m[n])>0&&(n=s)}return n}function a(m,f){for(const n of m){const s=f(n);if(s!==void 0)return s}}}),define(fe[41],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=y,e.$L=S,e.$M=C,e.$N=M;function y(j,P){const l=Object.create(null);for(const r of j){const p=P(r);let u=l[p];u||(u=l[p]=[]),u.push(r)}return l}function S(j,P){const l=[],r=[];for(const p of j)P.has(p)||l.push(p);for(const p of P)j.has(p)||r.push(p);return{removed:l,added:r}}function C(j,P){const l=[],r=[];for(const[p,u]of j)P.has(p)||l.push(u);for(const[p,u]of P)j.has(p)||r.push(u);return{removed:l,added:r}}function M(j,P){const l=new Set;for(const r of P)j.has(r)&&l.add(r);return l}}),define(fe[14],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=S,e.$2h=C,e.$3h=M;function y(j){return(P,l,r)=>{let p=null,u=null;if(typeof r.value=="function"?(p="value",u=r.value):typeof r.get=="function"&&(p="get",u=r.get),!u)throw new Error("not supported");r[p]=j(u,l)}}function S(j,P,l){let r=null,p=null;if(typeof l.value=="function"?(r="value",p=l.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(r="get",p=l.get),!p)throw new Error("not supported");const u=`$memoize$${P}`;l[r]=function(...k){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,k)}),this[u]}}function C(j,P,l){return y((r,p)=>{const u=`$debounce$${p}`,k=`$debounce$result$${p}`;return function(...o){this[k]||(this[k]=l?l():void 0),clearTimeout(this[u]),P&&(this[k]=P(this[k],...o),o=[this[k]]),this[u]=setTimeout(()=>{r.apply(this,o),this[k]=l?l():void 0},j)}})}function M(j,P,l){return y((r,p)=>{const u=`$throttle$timer$${p}`,k=`$throttle$result$${p}`,o=`$throttle$lastRun$${p}`,a=`$throttle$pending$${p}`;return function(...m){if(this[k]||(this[k]=l?l():void 0),(this[o]===null||this[o]===void 0)&&(this[o]=-Number.MAX_VALUE),P&&(this[k]=P(this[k],...m)),this[a])return;const f=this[o]+j;f<=Date.now()?(this[o]=Date.now(),r.apply(this,[this[k]]),this[k]=l?l():void 0):(this[a]=!0,this[u]=setTimeout(()=>{this[a]=!1,this[o]=Date.now(),r.apply(this,[this[k]]),this[k]=l?l():void 0},f-Date.now()))}})}}),define(fe[7],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=S,e.$Z=C,e.$1=M,e.$2=j,e.$3=P,e.$4=r,e.$6=u,e.$7=k,e.$8=o,e.$0=m;class y{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?d.isErrorNoTelemetry(t)?new d(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(c=>{c(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=y,e.$X=new y;function S(i){e.$X.setUnexpectedErrorHandler(i)}function C(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function M(i){r(i)||e.$X.onUnexpectedError(i)}function j(i){r(i)||e.$X.onUnexpectedExternalError(i)}function P(i){if(i instanceof Error){const{name:t,message:c}=i,L=i.stacktrace||i.stack;return{$isError:!0,name:t,message:c,stack:L,noTelemetry:d.isErrorNoTelemetry(i)}}return i}const l="Canceled";function r(i){return i instanceof p?!0:i instanceof Error&&i.name===l&&i.message===l}class p extends Error{constructor(){super(l),this.name=this.message}}e.$5=p;function u(){const i=new Error(l);return i.name=i.message,i}function k(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function o(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class a extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=a;function m(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class n extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=n;class s extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=s;class d extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof d)return t;const c=new d;return c.message=t.message,c.stack=t.stack,c}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=d;class v extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype)}}e.$cb=v}),define(fe[16],ge([0,1,7,40]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=C,e.$tb=M,e.$ub=j,e.$vb=P,e.$wb=l,e.$xb=r,e.$yb=p,e.$zb=u,e.$Ab=k,e.$Bb=o,e.$Cb=a,e.$Db=m,e.$Eb=f,e.top=n,e.$Gb=s,e.$Hb=v,e.$Ib=i,e.$Jb=t,e.$Kb=c,e.$Lb=L,e.$Mb=$,e.$Nb=D,e.$Ob=E,e.$Pb=w,e.$Qb=F,e.$Rb=Z,e.$Sb=T,e.$Tb=R,e.$Ub=g,e.$Vb=O,e.$Wb=b,e.$Xb=A,e.$Yb=Y,e.$Zb=te,e.$1b=G,e.$2b=ee,e.$3b=ce,e.$4b=he,e.$5b=X,e.$6b=q,e.$7b=de,e.$8b=B,e.$$b=h;function C(H,W=0){return H[H.length-(1+W)]}function M(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}function j(H,W,z=(I,V)=>I===V){if(H===W)return!0;if(!H||!W||H.length!==W.length)return!1;for(let I=0,V=H.length;I<V;I++)if(!z(H[I],W[I]))return!1;return!0}function P(H,W){const z=H.length-1;W<z&&(H[W]=H[z]),H.pop()}function l(H,W,z){return r(H.length,I=>z(H[I],W))}function r(H,W){let z=0,I=H-1;for(;z<=I;){const V=(z+I)/2|0,_=W(V);if(_<0)z=V+1;else if(_>0)I=V-1;else return V}return-(z+1)}function p(H,W,z){if(H=H|0,H>=W.length)throw new TypeError("invalid index");const I=W[Math.floor(W.length*Math.random())],V=[],_=[],se=[];for(const re of W){const le=z(re,I);le<0?V.push(re):le>0?_.push(re):se.push(re)}return H<V.length?p(H,V,z):H<V.length+se.length?se[0]:p(H-(V.length+se.length),_,z)}function u(H,W){const z=[];let I;for(const V of H.slice(0).sort(W))!I||W(I[0],V)!==0?(I=[V],z.push(I)):I.push(V);return z}function*k(H,W){let z,I;for(const V of H)I!==void 0&&W(I,V)?z.push(V):(z&&(yield z),z=[V]),I=V;z&&(yield z)}function o(H,W){for(let z=0;z<=H.length;z++)W(z===0?void 0:H[z-1],z===H.length?void 0:H[z])}function a(H,W){for(let z=0;z<H.length;z++)W(z===0?void 0:H[z-1],H[z],z+1===H.length?void 0:H[z+1])}function m(H,W,z){const I=[];function V(re,le,$e){if(le===0&&$e.length===0)return;const be=I[I.length-1];be&&be.start+be.deleteCount===re?(be.deleteCount+=le,be.toInsert.push(...$e)):I.push({start:re,deleteCount:le,toInsert:$e})}let _=0,se=0;for(;;){if(_===H.length){V(_,0,W.slice(se));break}if(se===W.length){V(_,H.length-_,[]);break}const re=H[_],le=W[se],$e=z(re,le);$e===0?(_+=1,se+=1):$e<0?(V(_,1,[]),_+=1):$e>0&&(V(_,0,[le]),se+=1)}return I}function f(H,W,z){const I=m(H,W,z),V=[],_=[];for(const se of I)V.push(...H.slice(se.start,se.start+se.deleteCount)),_.push(...se.toInsert);return{removed:V,added:_}}function n(H,W,z){if(z===0)return[];const I=H.slice(0,z).sort(W);return d(H,W,I,z,H.length),I}function s(H,W,z,I,V){return z===0?Promise.resolve([]):new Promise((_,se)=>{(async()=>{const re=H.length,le=H.slice(0,z).sort(W);for(let $e=z,be=Math.min(z+I,re);$e<re;$e=be,be=Math.min(be+I,re)){if($e>z&&await new Promise(pe=>setTimeout(pe)),V&&V.isCancellationRequested)throw new y.$5;d(H,W,le,$e,be)}return le})().then(_,se)})}function d(H,W,z,I,V){for(const _=z.length;I<V;I++){const se=H[I];if(W(se,z[_-1])<0){z.pop();const re=(0,S.$kb)(z,le=>W(se,le)<0);z.splice(re,0,se)}}}function v(H){return H.filter(W=>!!W)}function i(H){let W=0;for(let z=0;z<H.length;z++)H[z]&&(H[W]=H[z],W+=1);H.length=W}function t(H,W,z){H.splice(z,0,H.splice(W,1)[0])}function c(H){return!Array.isArray(H)||H.length===0}function L(H){return Array.isArray(H)&&H.length>0}function $(H,W=z=>z){const z=new Set;return H.filter(I=>{const V=W(I);return z.has(V)?!1:(z.add(V),!0)})}function D(H){const W=new Set;return z=>{const I=H(z);return W.has(I)?!1:(W.add(I),!0)}}function E(H,W){return H.length>0?H[0]:W}function w(H,W){return H.length>0?H[H.length-1]:W}function F(H,W,z=(I,V)=>I===V){let I=0;for(let V=0,_=Math.min(H.length,W.length);V<_&&z(H[V],W[V]);V++)I++;return I}function Z(H){return[].concat(...H)}function T(H,W){let z=typeof W=="number"?H:0;typeof W=="number"?z=H:(z=0,W=H);const I=[];if(z<=W)for(let V=z;V<W;V++)I.push(V);else for(let V=z;V>W;V--)I.push(V);return I}function R(H,W,z){return H.reduce((I,V)=>(I[W(V)]=z?z(V):V,I),Object.create(null))}function g(H,W){return H.push(W),()=>O(H,W)}function O(H,W){const z=H.indexOf(W);if(z>-1)return H.splice(z,1),W}function b(H,W,z){const I=H.slice(0,W),V=H.slice(W);return I.concat(z,V)}function A(H,W){let z;if(typeof W=="number"){let I=W;z=()=>{const V=Math.sin(I++)*179426549;return V-Math.floor(V)}}else z=Math.random;for(let I=H.length-1;I>0;I-=1){const V=Math.floor(z()*(I+1)),_=H[I];H[I]=H[V],H[V]=_}}function Y(H,W){const z=H.indexOf(W);z>-1&&(H.splice(z,1),H.unshift(W))}function te(H,W){const z=H.indexOf(W);z>-1&&(H.splice(z,1),H.push(W))}function G(H,W){for(const z of W)H.push(z)}function ee(H,W){return Array.isArray(H)?H.map(W):W(H)}function ce(H){return Array.isArray(H)?H:[H]}function he(H){return H[Math.floor(Math.random()*H.length)]}function X(H,W,z){const I=J(H,W),V=H.length,_=z.length;H.length=V+_;for(let se=V-1;se>=I;se--)H[se+_]=H[se];for(let se=0;se<_;se++)H[se+I]=z[se]}function q(H,W,z,I){const V=J(H,W);let _=H.splice(V,z);return _===void 0&&(_=[]),X(H,V,I),_}function J(H,W){return W<0?Math.max(W+H.length,0):Math.min(W,H.length)}var K;(function(H){function W(_){return _<0}H.isLessThan=W;function z(_){return _<=0}H.isLessThanOrEqual=z;function I(_){return _>0}H.isGreaterThan=I;function V(_){return _===0}H.isNeitherLessOrGreaterThan=V,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(K||(e.CompareResult=K={}));function de(H,W){return(z,I)=>W(H(z),H(I))}function B(...H){return(W,z)=>{for(const I of H){const V=I(W,z);if(!K.isNeitherLessOrGreaterThan(V))return V}return K.neitherLessOrGreaterThan}}const ue=(H,W)=>H-W;e.$9b=ue;const x=(H,W)=>(0,e.$9b)(H?1:0,W?1:0);e.$0b=x;function h(H){return(W,z)=>-H(W,z)}class N{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let z=this.c;for(;z<this.g.length&&W(this.g[z]);)z++;const I=z===this.c?null:this.g.slice(this.c,z);return this.c=z,I}takeFromEndWhile(W){let z=this.d;for(;z>=0&&W(this.g[z]);)z--;const I=z===this.d?null:this.g.slice(z+1,this.d+1);return this.d=z,I}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const z=this.g.slice(this.c,this.c+W);return this.c+=W,z}}e.$_b=N;class ie{static{this.empty=new ie(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(z=>(W(z),!0))}toArray(){const W=[];return this.iterate(z=>(W.push(z),!0)),W}filter(W){return new ie(z=>this.iterate(I=>W(I)?z(I):!0))}map(W){return new ie(z=>this.iterate(I=>z(W(I))))}some(W){let z=!1;return this.iterate(I=>(z=W(I),!z)),z}findFirst(W){let z;return this.iterate(I=>W(I)?(z=I,!1):!0),z}findLast(W){let z;return this.iterate(I=>(W(I)&&(z=I),!0)),z}findLastMaxBy(W){let z,I=!0;return this.iterate(V=>((I||K.isGreaterThan(W(V,z)))&&(I=!1,z=V),!0)),z}}e.$ac=ie;class ne{constructor(W){this.c=W}static createSortPermutation(W,z){const I=Array.from(W.keys()).sort((V,_)=>z(W[V],W[_]));return new ne(I)}apply(W){return W.map((z,I)=>W[this.c[I]])}inverse(){const W=this.c.slice();for(let z=0;z<this.c.length;z++)W[this.c[z]]=z;return new ne(W)}}e.$bc=ne}),define(fe[42],ge([0,1,7]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=S,e.$fd=C,e.$gd=M,e.$hd=j,e.$id=P,e.$jd=l;function S(r,p){if(!r)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}function C(r,p="Unreachable"){throw new Error(p)}function M(r){if(!r)throw new y.$cb("Assertion Failed")}function j(r){r||(0,y.$1)(new y.$cb("Soft Assertion Failed"))}function P(r){if(!r()){debugger;r(),(0,y.$1)(new y.$cb("Assertion Failed"))}}function l(r,p){let u=0;for(;u<r.length-1;){const k=r[u],o=r[u+1];if(!p(k,o))return!1;u++}return!0}}),define(fe[29],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=y;function y(S,C){const M=this;let j=!1,P;return function(){if(j)return P;if(j=!0,C)try{P=S.apply(M,arguments)}finally{C()}else P=S.apply(M,arguments);return P}}}),define(fe[43],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(S){function C(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}S.is=C;const M=Object.freeze([]);function j(){return M}S.empty=j;function*P(t){yield t}S.single=P;function l(t){return C(t)?t:P(t)}S.wrap=l;function r(t){return t||M}S.from=r;function*p(t){for(let c=t.length-1;c>=0;c--)yield t[c]}S.reverse=p;function u(t){return!t||t[Symbol.iterator]().next().done===!0}S.isEmpty=u;function k(t){return t[Symbol.iterator]().next().value}S.first=k;function o(t,c){for(const L of t)if(c(L))return!0;return!1}S.some=o;function a(t,c){for(const L of t)if(c(L))return L}S.find=a;function*m(t,c){for(const L of t)c(L)&&(yield L)}S.filter=m;function*f(t,c){let L=0;for(const $ of t)yield c($,L++)}S.map=f;function*n(...t){for(const c of t)yield*c}S.concat=n;function s(t,c,L){let $=L;for(const D of t)$=c($,D);return $}S.reduce=s;function*d(t,c,L=t.length){for(c<0&&(c+=t.length),L<0?L+=t.length:L>t.length&&(L=t.length);c<L;c++)yield t[c]}S.slice=d;function v(t,c=Number.POSITIVE_INFINITY){const L=[];if(c===0)return[L,t];const $=t[Symbol.iterator]();for(let D=0;D<c;D++){const E=$.next();if(E.done)return[L,S.empty()];L.push(E.value)}return[L,{[Symbol.iterator](){return $}}]}S.consume=v;async function i(t){const c=[];for await(const L of t)c.push(L);return Promise.resolve(c)}S.asyncToArray=i})(y||(e.Iterable=y={}))}),define(fe[22],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class y{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=y}),define(fe[44],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class y{static{this.Undefined=new y(void 0)}constructor(M){this.element=M,this.next=y.Undefined,this.prev=y.Undefined}}class S{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let M=this.a;for(;M!==y.Undefined;){const j=M.next;M.prev=y.Undefined,M.next=y.Undefined,M=j}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,j){const P=new y(M);if(this.a===y.Undefined)this.a=P,this.b=P;else if(j){const r=this.b;this.b=P,P.prev=r,r.next=P}else{const r=this.a;this.a=P,P.next=r,r.prev=P}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(P))}}shift(){if(this.a!==y.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==y.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==y.Undefined&&M.next!==y.Undefined){const j=M.prev;j.next=M.next,M.next.prev=j}else M.prev===y.Undefined&&M.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):M.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):M.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==y.Undefined;)yield M.element,M=M.next}}e.$6c=S}),define(fe[25],ge([0,1]),function(ae,e){"use strict";var y,S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=M,e.$zc=j,e.$Ac=P,e.$Jc=v;function M(i,t,c){let L=i.get(t);return L===void 0&&(L=c,i.set(t,L)),L}function j(i){const t=[];return i.forEach((c,L)=>{t.push(`${L} => ${c}`)}),`Map(${i.size}) {${t.join(", ")}}`}function P(i){const t=[];return i.forEach(c=>{t.push(c)}),`Set(${i.size}) {${t.join(", ")}}`}class l{constructor(t,c){this.uri=t,this.value=c}}function r(i){return Array.isArray(i)}class p{static{this.c=t=>t.toString()}constructor(t,c){if(this[y]="ResourceMap",t instanceof p)this.d=new Map(t.d),this.e=c??p.c;else if(r(t)){this.d=new Map,this.e=c??p.c;for(const[L,$]of t)this.set(L,$)}else this.d=new Map,this.e=t??p.c}set(t,c){return this.d.set(this.e(t),new l(t,c)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,c){typeof c<"u"&&(t=t.bind(c));for(const[L,$]of this.d)t($.value,$.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=p;class u{constructor(t,c){this[S]="ResourceSet",!t||typeof t=="function"?this.c=new p(t):(this.c=new p(c),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,c){this.c.forEach((L,$)=>t.call(c,$,$,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=u;var k;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class o{constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,c=0){const L=this.c.get(t);if(L)return c!==0&&this.m(L,c),L.value}set(t,c,L=0){let $=this.c.get(t);if($)$.value=c,L!==0&&this.m($,L);else{switch($={key:t,value:c,next:void 0,previous:void 0},L){case 0:this.k($);break;case 1:this.j($);break;case 2:this.k($);break;default:this.k($);break}this.c.set(t,$),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this.c.get(t);if(c)return this.c.delete(t),this.l(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,c){const L=this.g;let $=this.d;for(;$;){if(c?t.bind(c)($.value,$.key,this):t($.value,$.key,this),this.g!==L)throw new Error("LinkedMap got modified during iteration.");$=$.next}}keys(){const t=this,c=this.g;let L=this.d;const $={[Symbol.iterator](){return $},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(L){const D={value:L.key,done:!1};return L=L.next,D}else return{value:void 0,done:!0}}};return $}values(){const t=this,c=this.g;let L=this.d;const $={[Symbol.iterator](){return $},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(L){const D={value:L.value,done:!1};return L=L.next,D}else return{value:void 0,done:!0}}};return $}entries(){const t=this,c=this.g;let L=this.d;const $={[Symbol.iterator](){return $},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(L){const D={value:[L.key,L.value],done:!1};return L=L.next,D}else return{value:void 0,done:!0}}};return $}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.d,L=this.size;for(;c&&L>t;)this.c.delete(c.key),c=c.next,L--;this.d=c,this.f=L,c&&(c.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.e,L=this.size;for(;c&&L>t;)this.c.delete(c.key),c=c.previous,L--;this.e=c,this.f=L,c&&(c.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const c=t.next,L=t.previous;if(!c||!L)throw new Error("Invalid list");c.previous=L,L.next=c}t.next=void 0,t.previous=void 0,this.g++}m(t,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this.d)return;const L=t.next,$=t.previous;t===this.e?($.next=void 0,this.e=$):(L.previous=$,$.next=L),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(c===2){if(t===this.e)return;const L=t.next,$=t.previous;t===this.d?(L.previous=void 0,this.d=L):(L.previous=$,$.next=L),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((c,L)=>{t.push([L,c])}),t}fromJSON(t){this.clear();for(const[c,L]of t)this.set(c,L)}}e.$Dc=o;class a extends o{constructor(t,c=1){super(),this.n=t,this.o=Math.min(Math.max(0,c),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class m extends a{constructor(t,c=1){super(t,c)}q(t){this.h(t)}set(t,c){return super.set(t,c),this.p(),this}}e.$Ec=m;class f extends a{constructor(t,c=1){super(t,c)}q(t){this.i(t)}set(t,c){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,c),this}}e.$Fc=f;class n{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let c=this.c.get(t)||0;return c===0?!1:(c--,c===0?this.c.delete(t):this.c.set(t,c),!0)}has(t){return this.c.has(t)}}e.$Gc=n;class s{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[c,L]of t)this.set(c,L)}clear(){this.c.clear(),this.d.clear()}set(t,c){this.c.set(t,c),this.d.set(c,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const c=this.c.get(t);return c===void 0?!1:(this.c.delete(t),this.d.delete(c),!0)}forEach(t,c){this.c.forEach((L,$)=>{t.call(c,L,$,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=s;class d{constructor(){this.c=new Map}add(t,c){let L=this.c.get(t);L||(L=new Set,this.c.set(t,L)),L.add(c)}delete(t,c){const L=this.c.get(t);L&&(L.delete(c),L.size===0&&this.c.delete(t))}forEach(t,c){const L=this.c.get(t);L&&L.forEach(c)}get(t){const c=this.c.get(t);return c||new Set}}e.$Ic=d;function v(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[c,L]of i)if(!t.has(c)||t.get(c)!==L)return!1;for(const[c]of t)if(!i.has(c))return!1;return!0}}),define(fe[2],ge([0,1,16,41,25,29,43]),function(ae,e,y,S,C,M,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=p,e.$Mc=u,e.$Nc=k,e.$Oc=m,e.$Pc=f,e.$Qc=n,e.$Rc=s,e.$Sc=d,e.$Tc=v,e.$4c=Z;const P=!1;let l=null;class r{constructor(){this.b=new Map}static{this.a=0}c(g){let O=this.b.get(g);return O||(O={parent:null,source:null,isSingleton:!1,value:g,idx:r.a++},this.b.set(g,O)),O}trackDisposable(g){const O=this.c(g);O.source||(O.source=new Error().stack)}setParent(g,O){const b=this.c(g);b.parent=O}markAsDisposed(g){this.b.delete(g)}markAsSingleton(g){this.c(g).isSingleton=!0}f(g,O){const b=O.get(g);if(b)return b;const A=g.parent?this.f(this.c(g.parent),O):g;return O.set(g,A),A}getTrackedDisposables(){const g=new Map;return[...this.b.entries()].filter(([,b])=>b.source!==null&&!this.f(b,g).isSingleton).flatMap(([b])=>b)}computeLeakingDisposables(g=10,O){let b;if(O)b=O;else{const ee=new Map,ce=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,ee).isSingleton);if(ce.length===0)return;const he=new Set(ce.map(X=>X.value));if(b=ce.filter(X=>!(X.parent&&he.has(X.parent))),b.length===0)throw new Error("There are cyclic diposable chains!")}if(!b)return;function A(ee){function ce(X,q){for(;X.length>0&&q.some(J=>typeof J=="string"?J===X[0]:X[0].match(J));)X.shift()}const he=ee.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return ce(he,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),he.reverse()}const Y=new C.$Ic;for(const ee of b){const ce=A(ee);for(let he=0;he<=ce.length;he++)Y.add(ce.slice(0,he).join(`
`),ee)}b.sort((0,y.$7b)(ee=>ee.idx,y.$9b));let te="",G=0;for(const ee of b.slice(0,g)){G++;const ce=A(ee),he=[];for(let X=0;X<ce.length;X++){let q=ce[X];q=`(shared with ${Y.get(ce.slice(0,X+1).join(`
`)).size}/${b.length} leaks) at ${q}`;const K=Y.get(ce.slice(0,X).join(`
`)),de=(0,S.$K)([...K].map(B=>A(B)[X]),B=>B);delete de[ce[X]];for(const[B,ue]of Object.entries(de))he.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${B}`);he.unshift(q)}te+=`


==================== Leaking disposable ${G}/${b.length}: ${ee.value.constructor.name} ====================
${he.join(`
`)}
============================================================

`}return b.length>g&&(te+=`


... and ${b.length-g} more leaking disposables

`),{leaks:b,details:te}}}e.$Kc=r;function p(R){l=R}if(P){const R="__is_disposable_tracked__";p(new class{trackDisposable(g){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[R]||console.log(O)},3e3)}setParent(g,O){if(g&&g!==t.None)try{g[R]=!0}catch{}}markAsDisposed(g){if(g&&g!==t.None)try{g[R]=!0}catch{}}markAsSingleton(g){}})}function u(R){return l?.trackDisposable(R),R}function k(R){l?.markAsDisposed(R)}function o(R,g){l?.setParent(R,g)}function a(R,g){if(l)for(const O of R)l.setParent(O,g)}function m(R){return l?.markAsSingleton(R),R}function f(R){return typeof R=="object"&&R!==null&&typeof R.dispose=="function"&&R.dispose.length===0}function n(R){if(j.Iterable.is(R)){const g=[];for(const O of R)if(O)try{O.dispose()}catch(b){g.push(b)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function s(R){for(const g of R)f(g)&&g.dispose();return[]}function d(...R){const g=v(()=>n(R));return a(R,g),g}function v(R){const g=u({dispose:(0,M.$db)(()=>{k(g),R()})});return g}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,u(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{n(this.f)}finally{this.f.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return o(g,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(g),g}delete(g){if(g){if(g===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(g),g.dispose()}}deleteAndLeak(g){g&&this.f.has(g)&&(this.f.delete(g),o(g,null))}}e.$Uc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,u(this),o(this.q,this)}dispose(){k(this),this.q.dispose()}B(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(g)}}e.$Vc=t;class c{constructor(){this.b=!1,u(this)}get value(){return this.b?void 0:this.a}set value(g){this.b||g===this.a||(this.a?.dispose(),g&&o(g,this),this.a=g)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const g=this.a;return this.a=void 0,g&&o(g,null),g}}e.$Wc=c;class L{constructor(g){this.a=new c,this.b=!1,this.a.value=g}get value(){return this.a.value}set value(g){this.b||g===this.a.value||(this.a.value=g)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=L;class ${constructor(g){this.b=g,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=$;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set(g){let O=g;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,k(this))},this}}e.$Zc=D;class E{constructor(){this.a=new Map}acquire(g,...O){let b=this.a.get(g);b||(b={counter:0,object:this.b(g,...O)},this.a.set(g,b));const{object:A}=b,Y=(0,M.$db)(()=>{--b.counter===0&&(this.c(g,b.object),this.a.delete(g))});return b.counter++,{object:A,dispose:Y}}}e.$1c=E;class w{constructor(g){this.a=g}async acquire(g,...O){const b=this.a.acquire(g,...O);try{return{object:await b.object,dispose:()=>b.dispose()}}catch(A){throw b.dispose(),A}}}e.$2c=w;class F{constructor(g){this.object=g}dispose(){}}e.$3c=F;function Z(R){const g=new i;try{R(g)}finally{g.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,u(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{n(this.a.values())}finally{this.a.clear()}}has(g){return this.a.has(g)}get size(){return this.a.size}get(g){return this.a.get(g)}set(g,O,b=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||this.a.get(g)?.dispose(),this.a.set(g,O)}deleteAndDispose(g){this.a.get(g)?.dispose(),this.a.delete(g)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=T}),define(fe[45],ge([0,1,25]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0,e.$bm=C,e.$cm=j;const S=new y.$Ec(1e4);function C(r){return l(r,"NFC",S)}const M=new y.$Ec(1e4);function j(r){return l(r,"NFD",M)}const P=/[^\u0000-\u0080]/;function l(r,p,u){if(!r)return r;const k=u.get(r);if(k)return k;let o;return P.test(r)?o=r.normalize(p):o=r,u.set(r,o),o}e.$dm=function(){const r=/[\u0300-\u036f]/g;return function(p){return j(p).replace(r,"")}}()}),function(){function ae(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function j(l){M.push(l,Date.now())}function P(){const l=[];for(let r=0;r<M.length;r+=2)l.push({name:M[r],startTime:M[r+1]});return l}return{mark:j,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const j of performance.getEntriesByType("mark"))M.push({name:j.name,startTime:Math.round(C+j.startTime)});return M}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=y(S))}(),define(fe[46],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class S{static create(M){return new S(M)}constructor(M){this.c=y&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ae=S}),define(fe[4],ge([0,1,7,29,2,44,46]),function(ae,e,y,S,C,M,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$ce=e.Event=void 0,e.$de=o;const P=!1,l=!1,r=!1;var p;(function(O){O.None=()=>C.$Vc.None;function b(re){if(r){const{onDidAddListener:le}=re,$e=m.create();let be=0;re.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),le?.()}}}function A(re,le){return K(re,()=>{},0,void 0,!0,void 0,le)}O.defer=A;function Y(re){return(le,$e=null,be)=>{let pe=!1,ve;return ve=re(Ee=>{if(!pe)return ve?ve.dispose():pe=!0,le.call($e,Ee)},null,be),pe&&ve.dispose(),ve}}O.once=Y;function te(re,le,$e){return q((be,pe=null,ve)=>re(Ee=>be.call(pe,le(Ee)),null,ve),$e)}O.map=te;function G(re,le,$e){return q((be,pe=null,ve)=>re(Ee=>{le(Ee),be.call(pe,Ee)},null,ve),$e)}O.forEach=G;function ee(re,le,$e){return q((be,pe=null,ve)=>re(Ee=>le(Ee)&&be.call(pe,Ee),null,ve),$e)}O.filter=ee;function ce(re){return re}O.signal=ce;function he(...re){return(le,$e=null,be)=>{const pe=(0,C.$Sc)(...re.map(ve=>ve(Ee=>le.call($e,Ee))));return J(pe,be)}}O.any=he;function X(re,le,$e,be){let pe=$e;return te(re,ve=>(pe=le(pe,ve),pe),be)}O.reduce=X;function q(re,le){let $e;const be={onWillAddFirstListener(){$e=re(pe.fire,pe)},onDidRemoveLastListener(){$e?.dispose()}};le||b(be);const pe=new i(be);return le?.add(pe),pe.event}function J(re,le){return le instanceof Array?le.push(re):le&&le.add(re),re}function K(re,le,$e=100,be=!1,pe=!1,ve,Ee){let ke,Pe,Oe,De=0,ze;const Be={leakWarningThreshold:ve,onWillAddFirstListener(){ke=re(Ve=>{De++,Pe=le(Pe,Ve),be&&!Oe&&(Fe.fire(Pe),Pe=void 0),ze=()=>{const qe=Pe;Pe=void 0,Oe=void 0,(!be||De>1)&&Fe.fire(qe),De=0},typeof $e=="number"?(clearTimeout(Oe),Oe=setTimeout(ze,$e)):Oe===void 0&&(Oe=0,queueMicrotask(ze))})},onWillRemoveListener(){pe&&De>0&&ze?.()},onDidRemoveLastListener(){ze=void 0,ke.dispose()}};Ee||b(Be);const Fe=new i(Be);return Ee?.add(Fe),Fe.event}O.debounce=K;function de(re,le=0,$e){return O.debounce(re,(be,pe)=>be?(be.push(pe),be):[pe],le,void 0,!0,void 0,$e)}O.accumulate=de;function B(re,le=(be,pe)=>be===pe,$e){let be=!0,pe;return ee(re,ve=>{const Ee=be||!le(ve,pe);return be=!1,pe=ve,Ee},$e)}O.latch=B;function ue(re,le,$e){return[O.filter(re,le,$e),O.filter(re,be=>!le(be),$e)]}O.split=ue;function x(re,le=!1,$e=[],be){let pe=$e.slice(),ve=re(Pe=>{pe?pe.push(Pe):ke.fire(Pe)});be&&be.add(ve);const Ee=()=>{pe?.forEach(Pe=>ke.fire(Pe)),pe=null},ke=new i({onWillAddFirstListener(){ve||(ve=re(Pe=>ke.fire(Pe)),be&&be.add(ve))},onDidAddFirstListener(){pe&&(le?setTimeout(Ee):Ee())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return be&&be.add(ke),ke.event}O.buffer=x;function h(re,le){return(be,pe,ve)=>{const Ee=le(new ie);return re(function(ke){const Pe=Ee.evaluate(ke);Pe!==N&&be.call(pe,Pe)},void 0,ve)}}O.chain=h;const N=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push($e=>(le($e),$e)),this}filter(le){return this.f.push($e=>le($e)?$e:N),this}reduce(le,$e){let be=$e;return this.f.push(pe=>(be=le(be,pe),be)),this}latch(le=($e,be)=>$e===be){let $e=!0,be;return this.f.push(pe=>{const ve=$e||!le(pe,be);return $e=!1,be=pe,ve?pe:N}),this}evaluate(le){for(const $e of this.f)if(le=$e(le),le===N)break;return le}}function ne(re,le,$e=be=>be){const be=(...ke)=>Ee.fire($e(...ke)),pe=()=>re.on(le,be),ve=()=>re.removeListener(le,be),Ee=new i({onWillAddFirstListener:pe,onDidRemoveLastListener:ve});return Ee.event}O.fromNodeEventEmitter=ne;function H(re,le,$e=be=>be){const be=(...ke)=>Ee.fire($e(...ke)),pe=()=>re.addEventListener(le,be),ve=()=>re.removeEventListener(le,be),Ee=new i({onWillAddFirstListener:pe,onDidRemoveLastListener:ve});return Ee.event}O.fromDOMEventEmitter=H;function W(re){return new Promise(le=>Y(re)(le))}O.toPromise=W;function z(re){const le=new i;return re.then($e=>{le.fire($e)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}O.fromPromise=z;function I(re,le,$e){return le($e),re(be=>le(be))}O.runAndSubscribe=I;class V{constructor(le,$e){this._observable=le,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{le.addObserver(this)},onDidRemoveLastListener:()=>{le.removeObserver(this)}};$e||b(be),this.emitter=new i(be),$e&&$e.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,$e){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _(re,le){return new V(re,le).emitter.event}O.fromObservable=_;function se(re){return(le,$e,be)=>{let pe=0,ve=!1;const Ee={beginUpdate(){pe++},endUpdate(){pe--,pe===0&&(re.reportChanges(),ve&&(ve=!1,le.call($e)))},handlePossibleChange(){},handleChange(){ve=!0}};re.addObserver(Ee),re.reportChanges();const ke={dispose(){re.removeObserver(Ee)}};return be instanceof C.$Uc?be.add(ke):Array.isArray(be)&&be.push(ke),ke}}O.fromObservableLight=se})(p||(e.Event=p={}));class u{static{this.all=new Set}static{this.f=0}constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${u.f++}`,u.all.add(this)}start(b){this.g=new j.$ae,this.listenerCount=b}stop(){if(this.g){const b=this.g.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this.g=void 0}}}e.$ce=u;let k=-1;function o(O){const b=k;return k=O,{dispose(){k=b}}}class a{constructor(b,A=Math.random().toString(18).slice(2,5)){this.threshold=b,this.name=A,this.g=0}dispose(){this.f?.clear()}check(b,A){const Y=this.threshold;if(Y<=0||A<Y)return;this.f||(this.f=new Map);const te=this.f.get(b.value)||0;if(this.f.set(b.value,te+1),this.g-=1,this.g<=0){this.g=Y*.5;let G,ee=0;for(const[ce,he]of this.f)(!G||ee<he)&&(G=ce,ee=he);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${ee}):`),console.warn(G)}return()=>{const G=this.f.get(b.value)||0;this.f.set(b.value,G-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class n{constructor(b){this.value=b,this.id=f++}}const s=2,d=(O,b)=>{if(O instanceof n)b(O);else for(let A=0;A<O.length;A++){const Y=O[A];Y&&b(Y)}},v=P?new FinalizationRegistry(O=>{typeof O=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(O))}):void 0;class i{constructor(b){this.w=0,this.f=b,this.g=k>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new u(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(l){const b=this.t;queueMicrotask(()=>{d(b,A=>A.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(b,A,Y)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),C.$Vc.None;if(this.m)return C.$Vc.None;A&&(b=b.bind(A));const te=new n(b);let G,ee;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(te.stack=m.create(),G=this.g.check(te.stack,this.w+1)),l&&(te.stack=ee??m.create()),this.t?this.t instanceof n?(this.u??=new c,this.t=[this.t,te]):this.t.push(te):(this.f?.onWillAddFirstListener?.(this),this.t=te,this.f?.onDidAddFirstListener?.(this)),this.w++;const ce=(0,C.$Tc)(()=>{v?.unregister(ce),G?.(),this.x(te)});if(Y instanceof C.$Uc?Y.add(ce):Array.isArray(Y)&&Y.push(ce),v){const he=new Error().stack.split(`
`).slice(2).join(`
`).trim();v.register(ce,he,ce)}return ce},this.q}x(b){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const A=this.t,Y=A.indexOf(b);if(Y===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,A[Y]=void 0;const te=this.u.current===this;if(this.w*s<=A.length){let G=0;for(let ee=0;ee<A.length;ee++)A[ee]?A[G++]=A[ee]:te&&(this.u.end--,G<this.u.i&&this.u.i--);A.length=G}}y(b,A){if(!b)return;const Y=this.f?.onListenerError||y.$1;if(!Y){b.value(A);return}try{b.value(A)}catch(te){Y(te)}}z(b){const A=b.current.t;for(;b.i<b.end;)this.y(A[b.i++],b.value);b.reset()}fire(b){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof n)this.y(this.t,b);else{const A=this.u;A.enqueue(this,b,this.t.length),this.z(A)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ee=i;const t=()=>new c;e.$fe=t;class c{constructor(){this.i=-1,this.end=0}enqueue(b,A,Y){this.i=0,this.end=Y,this.current=b,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class L extends i{async fireAsync(b,A,Y){if(this.t)for(this.h||(this.h=new M.$6c),d(this.t,te=>this.h.push([te.value,b]));this.h.size>0&&!A.isCancellationRequested;){const[te,G]=this.h.shift(),ee=[],ce={...G,token:A,waitUntil:he=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");Y&&(he=Y(he,te)),ee.push(he)}};try{te(ce)}catch(he){(0,y.$1)(he);continue}Object.freeze(ee),await Promise.allSettled(ee).then(he=>{for(const X of he)X.status==="rejected"&&(0,y.$1)(X.reason)})}}}e.$ge=L;class $ extends i{get isPaused(){return this.h!==0}constructor(b){super(b),this.h=0,this.s=new M.$6c,this.A=b?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const b=Array.from(this.s);this.s.clear(),super.fire(this.A(b))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(b){this.w&&(this.h!==0?this.s.push(b):super.fire(b))}}e.$he=$;class D extends ${constructor(b){super(b),this.k=b.delay??100}fire(b){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(b)}}e.$ie=D;class E extends i{constructor(b){super(b),this.h=[],this.k=b?.merge}fire(b){this.hasListeners()&&(this.h.push(b),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(A=>super.fire(A)),this.h=[]}))}}e.$je=E;class w{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(b){const A={event:b,listener:null};this.h.push(A),this.g&&this.m(A);const Y=()=>{this.g&&this.o(A);const te=this.h.indexOf(A);this.h.splice(te,1)};return(0,C.$Tc)((0,S.$db)(Y))}j(){this.g=!0,this.h.forEach(b=>this.m(b))}k(){this.g=!1,this.h.forEach(b=>this.o(b))}m(b){b.listener=b.event(A=>this.f.fire(A))}o(b){b.listener?.dispose(),b.listener=null}dispose(){this.f.dispose();for(const b of this.h)b.listener?.dispose();this.h=[]}}e.$ke=w;class F{constructor(b,A,Y,te){this.f=new C.$Uc;const G=this.f.add(new w),ee=this.f.add(new C.$5c);function ce(he){ee.set(he,G.add(te(he)))}for(const he of b)ce(he);this.f.add(A(he=>{ce(he)})),this.f.add(Y(he=>{ee.deleteAndDispose(he)})),this.event=G.event}dispose(){this.f.dispose()}}e.$le=F;class Z{constructor(){this.f=[]}wrapEvent(b){return(A,Y,te)=>b(G=>{const ee=this.f[this.f.length-1];ee?ee.push(()=>A.call(Y,G)):A.call(Y,G)},void 0,te)}bufferEvents(b){const A=[];this.f.push(A);const Y=b();return this.f.pop(),A.forEach(te=>te()),Y}}e.$me=Z;class T{constructor(){this.f=!1,this.g=p.None,this.h=C.$Vc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(b){this.g=b,this.f&&(this.h.dispose(),this.h=b(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ne=T;class R{static const(b){return new g(b)}constructor(b){this.g=b,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(b){b!==this.g&&(this.g=b,this.f.fire(void 0))}}e.$oe=R;class g{constructor(b){this.value=b,this.onDidChange=p.None}}}),define(fe[17],ge([0,1,4]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.CancellationToken=void 0,e.$qe=P;const S=Object.freeze(function(l,r){const p=setTimeout(l.bind(r),0);return{dispose(){clearTimeout(p)}}});var C;(function(l){function r(p){return p===l.None||p===l.Cancelled||p instanceof M?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}l.isCancellationToken=r,l.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),l.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(C||(e.CancellationToken=C={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?S:(this.b||(this.b=new y.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(r){this.f=void 0,this.g=void 0,this.g=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=C.Cancelled}dispose(r=!1){r&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=C.None}}e.$pe=j;function P(l){const r=new j;return l.add({dispose(){r.cancel()}}),r.token}}),define(fe[47],ge([0,1,17]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=e.$2e=void 0,e.$3e=C;class S{constructor(l){this.b=l,this.a=null}get(){if(this.a)return this.a;const l=new y.$pe,r=this.b(l.token);return this.a={promise:r,dispose:()=>{this.a=null,l.cancel(),l.dispose()}},this.a}}e.$2e=S;function C(P){return P}class M{constructor(l,r){this.a=void 0,this.b=void 0,typeof l=="function"?(this.c=l,this.d=C):(this.c=r,this.d=l.getCacheKey)}get(l){const r=this.d(l);return this.b!==r&&(this.b=r,this.a=this.c(l)),this.a}}e.$4e=M;class j{get cachedValues(){return this.a}constructor(l,r){this.a=new Map,this.b=new Map,typeof l=="function"?(this.c=l,this.d=C):(this.c=r,this.d=l.getCacheKey)}get(l){const r=this.d(l);if(this.b.has(r))return this.b.get(r);const p=this.c(l);return this.a.set(l,p),this.b.set(r,p),p}}e.$5e=j}),define(fe[48],ge([0,1,7,2]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=C,e.$se=M,e.$te=j,e.$ue=P,e.$ve=r,e.$we=p,e.$xe=u,e.$ye=k,e.$ze=o,e.$Ae=a,e.$Be=m,e.$Ce=f,e.$De=n,e.$Ee=s,e.$Fe=d;function C(v){const i=v;return i?typeof i.read=="function":!1}function M(v){const i=v;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function j(v){const i=v;return i?M(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function P(v,i){return new l(v,i)}class l{constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,y.$1)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let c;switch(i){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const L=c.indexOf(t);L>=0&&c.splice(L,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(v,i){const t=[];let c;for(;(c=v.read())!==null;)t.push(c);return i(t)}function p(v,i,t){const c=[];let L;for(;(L=v.read())!==null&&c.length<t;)c.push(L);return L===null&&c.length>0?i(c):{read:()=>{if(c.length>0)return c.shift();if(typeof L<"u"){const $=L;return L=void 0,$}return v.read()}}}function u(v,i){return new Promise((t,c)=>{const L=[];k(v,{onData:$=>{i&&L.push($)},onError:$=>{i?c($):t(void 0)},onEnd:()=>{t(i?i(L):void 0)}})})}function k(v,i,t){v.on("error",c=>{t?.isCancellationRequested||i.onError(c)}),v.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),v.on("data",c=>{t?.isCancellationRequested||i.onData(c)})}function o(v,i){return new Promise((t,c)=>{const L=new S.$Uc,$=[],D=F=>{if($.push(F),$.length>i)return L.dispose(),v.pause(),t({stream:v,buffer:$,ended:!1})},E=F=>(L.dispose(),c(F)),w=()=>(L.dispose(),t({stream:v,buffer:$,ended:!0}));L.add((0,S.$Tc)(()=>v.removeListener("error",E))),v.on("error",E),L.add((0,S.$Tc)(()=>v.removeListener("end",w))),v.on("end",w),L.add((0,S.$Tc)(()=>v.removeListener("data",D))),v.on("data",D)})}function a(v,i){const t=P(i);return t.end(v),t}function m(){const v=P(()=>{throw new Error("not supported")});return v.end(),v}function f(v){let i=!1;return{read:()=>i?null:(i=!0,v)}}function n(v,i,t){const c=P(t);return k(v,{onData:L=>c.write(i.data(L)),onError:L=>c.error(i.error?i.error(L):L),onEnd:()=>c.end()}),c}function s(v,i,t){let c=!1;return{read:()=>{const L=i.read();return c?L:(c=!0,L!==null?t([v,L]):v)}}}function d(v,i,t){let c=!1;const L=P(t);return k(i,{onData:$=>c?L.write($):(c=!0,L.write(t([v,$]))),onError:$=>L.error($),onEnd:()=>{c||(c=!0,L.write(v)),L.end()}}),L}}),define(fe[18],ge([0,1,22,48]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=void 0,e.$He=r,e.$Ie=p,e.$Je=u,e.$Ke=k,e.$Le=o,e.$Me=a,e.$Ne=m,e.$Oe=f,e.$Pe=n,e.$Qe=s,e.$Re=d,e.$Se=v,e.$Te=i,e.$Ue=t,e.$Ve=c,e.$We=L,e.$Xe=$,e.$Ye=D,e.$Ze=E,e.$1e=Z;const C=typeof Buffer<"u",M=new y.$V(()=>new Uint8Array(256));let j,P;class l{static alloc(R){return C?new l(Buffer.allocUnsafe(R)):new l(new Uint8Array(R))}static wrap(R){return C&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new l(R)}static fromString(R,g){return!(g?.dontUseNodeBuffer||!1)&&C?new l(Buffer.from(R)):(j||(j=new TextEncoder),new l(j.encode(R)))}static fromByteArray(R){const g=l.alloc(R.length);for(let O=0,b=R.length;O<b;O++)g.buffer[O]=R[O];return g}static concat(R,g){if(typeof g>"u"){g=0;for(let A=0,Y=R.length;A<Y;A++)g+=R[A].byteLength}const O=l.alloc(g);let b=0;for(let A=0,Y=R.length;A<Y;A++){const te=R[A];O.set(te,b),b+=te.byteLength}return O}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=l.alloc(this.byteLength);return R.set(this),R}toString(){return C?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(R,g){return new l(this.buffer.subarray(R,g))}set(R,g){if(R instanceof l)this.buffer.set(R.buffer,g);else if(R instanceof Uint8Array)this.buffer.set(R,g);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),g);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return k(this.buffer,R)}writeUInt32BE(R,g){o(this.buffer,R,g)}readUInt32LE(R){return a(this.buffer,R)}writeUInt32LE(R,g){m(this.buffer,R,g)}readUInt8(R){return f(this.buffer,R)}writeUInt8(R,g){n(this.buffer,R,g)}indexOf(R,g=0){return r(this.buffer,R instanceof l?R.buffer:R,g)}}e.$Ge=l;function r(T,R,g=0){const O=R.byteLength,b=T.byteLength;if(O===0)return 0;if(O===1)return T.indexOf(R[0]);if(O>b-g)return-1;const A=M.value;A.fill(R.length);for(let ee=0;ee<R.length;ee++)A[R[ee]]=R.length-ee-1;let Y=g+R.length-1,te=Y,G=-1;for(;Y<b;)if(T[Y]===R[te]){if(te===0){G=Y;break}Y--,te--}else Y+=Math.max(R.length-te,A[T[Y]]),te=R.length-1;return G}function p(T,R){return T[R+0]<<0>>>0|T[R+1]<<8>>>0}function u(T,R,g){T[g+0]=R&255,R=R>>>8,T[g+1]=R&255}function k(T,R){return T[R]*2**24+T[R+1]*2**16+T[R+2]*2**8+T[R+3]}function o(T,R,g){T[g+3]=R,R=R>>>8,T[g+2]=R,R=R>>>8,T[g+1]=R,R=R>>>8,T[g]=R}function a(T,R){return T[R+0]<<0>>>0|T[R+1]<<8>>>0|T[R+2]<<16>>>0|T[R+3]<<24>>>0}function m(T,R,g){T[g+0]=R&255,R=R>>>8,T[g+1]=R&255,R=R>>>8,T[g+2]=R&255,R=R>>>8,T[g+3]=R&255}function f(T,R){return T[R]}function n(T,R,g){T[g]=R}function s(T){return S.$ve(T,R=>l.concat(R))}function d(T){return S.$Ce(T)}function v(T){return S.$xe(T,R=>l.concat(R))}async function i(T){return T.ended?l.concat(T.buffer):l.concat([...T.buffer,await v(T.stream)])}function t(T){return S.$Ae(T,R=>l.concat(R))}function c(T){return S.$De(T,{data:R=>typeof R=="string"?l.fromString(R):l.wrap(R)},R=>l.concat(R))}function L(T){return S.$ue(R=>l.concat(R),T)}function $(T,R){return S.$Ee(T,R,g=>l.concat(g))}function D(T,R){return S.$Fe(T,R,g=>l.concat(g))}function E(T){let R=0,g=0,O=0;const b=new Uint8Array(Math.floor(T.length/4*3)),A=te=>{switch(g){case 3:b[O++]=R|te,g=0;break;case 2:b[O++]=R|te>>>2,R=te<<6,g=3;break;case 1:b[O++]=R|te>>>4,R=te<<4,g=2;break;default:R=te<<2,g=1}};for(let te=0;te<T.length;te++){const G=T.charCodeAt(te);if(G>=65&&G<=90)A(G-65);else if(G>=97&&G<=122)A(G-97+26);else if(G>=48&&G<=57)A(G-48+52);else if(G===43||G===45)A(62);else if(G===47||G===95)A(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${T[te]}`)}}const Y=O;for(;g>0;)A(0);return l.wrap(b).slice(0,Y)}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function Z({buffer:T},R=!0,g=!1){const O=g?F:w;let b="";const A=T.byteLength%3;let Y=0;for(;Y<T.byteLength-A;Y+=3){const te=T[Y+0],G=T[Y+1],ee=T[Y+2];b+=O[te>>>2],b+=O[(te<<4|G>>>4)&63],b+=O[(G<<2|ee>>>6)&63],b+=O[ee&63]}if(A===1){const te=T[Y+0];b+=O[te>>>2],b+=O[te<<4&63],R&&(b+="==")}else if(A===2){const te=T[Y+0],G=T[Y+1];b+=O[te>>>2],b+=O[(te<<4|G>>>4)&63],b+=O[G<<2&63],R&&(b+="=")}return b}}),define(fe[12],ge([0,1,47,22]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Of=e.$Hf=e.$Gf=void 0,e.$8e=C,e.$9e=j,e.$0e=l,e.$$e=r,e.$_e=p,e.$af=u,e.$bf=k,e.$cf=o,e.$df=a,e.$ef=m,e.$ff=f,e.$gf=n,e.$hf=s,e.$if=d,e.$jf=v,e.$kf=i,e.$lf=t,e.$mf=c,e.$nf=L,e.$of=$,e.$pf=D,e.$qf=E,e.$rf=w,e.$sf=F,e.$tf=Z,e.$uf=T,e.$vf=R,e.$wf=g,e.$xf=O,e.$yf=b,e.$zf=A,e.$Af=Y,e.$Bf=te,e.$Cf=G,e.$Df=ee,e.$Ef=ce,e.$Ff=he,e.$If=K,e.$Jf=de,e.$Kf=B,e.$Lf=ue,e.$Mf=N,e.$Nf=ne,e.$Pf=H,e.$Qf=W,e.$Rf=z,e.$Sf=I,e.$Tf=_,e.$Uf=se,e.$Wf=re,e.$Xf=le,e.$Yf=$e,e.$Zf=be,e.$1f=pe,e.$2f=ve,e.$3f=Ee,e.$4f=ke,e.$5f=Be;function C(U){return!U||typeof U!="string"?!0:U.trim().length===0}const M=/{(\d+)}/g;function j(U,...Q){return Q.length===0?U:U.replace(M,function(oe,me){const ye=parseInt(me,10);return isNaN(ye)||ye<0||ye>=Q.length?oe:Q[ye]})}const P=/{([^}]+)}/g;function l(U,Q){return Object.keys(Q).length===0?U:U.replace(P,(oe,me)=>Q[me]??oe)}function r(U){return U.replace(/[<>"'&]/g,Q=>{switch(Q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Q})}function p(U){return U.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}function u(U){return U.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function k(U,Q){let oe=0;const me=Q.charCodeAt(0);for(let ye=U.length-1;ye>=0;ye--)U.charCodeAt(ye)===me&&oe++;return oe}function o(U,Q,oe="\u2026"){return U.length<=Q?U:`${U.substr(0,Q)}${oe}`}function a(U,Q,oe="\u2026"){if(U.length<=Q)return U;const me=Math.ceil(Q/2)-oe.length/2,ye=Math.floor(Q/2)-oe.length/2;return`${U.substr(0,me)}${oe}${U.substr(U.length-ye)}`}function m(U,Q=" "){const oe=f(U,Q);return n(oe,Q)}function f(U,Q){if(!U||!Q)return U;const oe=Q.length;if(oe===0||U.length===0)return U;let me=0;for(;U.indexOf(Q,me)===me;)me=me+oe;return U.substring(me)}function n(U,Q){if(!U||!Q)return U;const oe=Q.length,me=U.length;if(oe===0||me===0)return U;let ye=me,Ce=-1;for(;Ce=U.lastIndexOf(Q,ye-1),!(Ce===-1||Ce+oe!==ye);){if(Ce===0)return"";ye=Ce}return U.substring(0,ye)}function s(U){return U.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function d(U){return U.replace(/\*/g,"")}function v(U,Q,oe={}){if(!U)throw new Error("Cannot create regex from empty string");Q||(U=u(U)),oe.wholeWord&&(/\B/.test(U.charAt(0))||(U="\\b"+U),/\B/.test(U.charAt(U.length-1))||(U=U+"\\b"));let me="";return oe.global&&(me+="g"),oe.matchCase||(me+="i"),oe.multiline&&(me+="m"),oe.unicode&&(me+="u"),new RegExp(U,me)}function i(U){return U.source==="^"||U.source==="^$"||U.source==="$"||U.source==="^\\s*$"?!1:!!(U.exec("")&&U.lastIndex===0)}function t(U){return U.split(/\r\n|\r|\n/)}function c(U){const Q=[],oe=U.split(/(\r\n|\r|\n)/);for(let me=0;me<Math.ceil(oe.length/2);me++)Q.push(oe[2*me]+(oe[2*me+1]??""));return Q}function L(U){for(let Q=0,oe=U.length;Q<oe;Q++){const me=U.charCodeAt(Q);if(me!==32&&me!==9)return Q}return-1}function $(U,Q=0,oe=U.length){for(let me=Q;me<oe;me++){const ye=U.charCodeAt(me);if(ye!==32&&ye!==9)return U.substring(Q,me)}return U.substring(Q,oe)}function D(U,Q=U.length-1){for(let oe=Q;oe>=0;oe--){const me=U.charCodeAt(oe);if(me!==32&&me!==9)return oe}return-1}function E(U,Q,oe){const me=[];let ye=0;for(const Ce of U.matchAll(Q)){if(me.push(U.slice(ye,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");ye=Ce.index+Ce[0].length,me.push(oe(Ce[0],...Ce.slice(1),Ce.index,U,Ce.groups))}return me.push(U.slice(ye)),Promise.all(me).then(Ce=>Ce.join(""))}function w(U,Q){return U<Q?-1:U>Q?1:0}function F(U,Q,oe=0,me=U.length,ye=0,Ce=Q.length){for(;oe<me&&ye<Ce;oe++,ye++){const Ae=U.charCodeAt(oe),Me=Q.charCodeAt(ye);if(Ae<Me)return-1;if(Ae>Me)return 1}const Le=me-oe,Re=Ce-ye;return Le<Re?-1:Le>Re?1:0}function Z(U,Q){return T(U,Q,0,U.length,0,Q.length)}function T(U,Q,oe=0,me=U.length,ye=0,Ce=Q.length){for(;oe<me&&ye<Ce;oe++,ye++){let Ae=U.charCodeAt(oe),Me=Q.charCodeAt(ye);if(Ae===Me)continue;if(Ae>=128||Me>=128)return F(U.toLowerCase(),Q.toLowerCase(),oe,me,ye,Ce);g(Ae)&&(Ae-=32),g(Me)&&(Me-=32);const Se=Ae-Me;if(Se!==0)return Se}const Le=me-oe,Re=Ce-ye;return Le<Re?-1:Le>Re?1:0}function R(U){return U>=48&&U<=57}function g(U){return U>=97&&U<=122}function O(U){return U>=65&&U<=90}function b(U,Q){return U.length===Q.length&&T(U,Q)===0}function A(U,Q){const oe=Q.length;return Q.length>U.length?!1:T(U,Q,0,oe)===0}function Y(U,Q){const oe=Math.min(U.length,Q.length);let me;for(me=0;me<oe;me++)if(U.charCodeAt(me)!==Q.charCodeAt(me))return me;return oe}function te(U,Q){const oe=Math.min(U.length,Q.length);let me;const ye=U.length-1,Ce=Q.length-1;for(me=0;me<oe;me++)if(U.charCodeAt(ye-me)!==Q.charCodeAt(Ce-me))return me;return oe}function G(U){return 55296<=U&&U<=56319}function ee(U){return 56320<=U&&U<=57343}function ce(U,Q){return(U-55296<<10)+(Q-56320)+65536}function he(U,Q,oe){const me=U.charCodeAt(oe);if(G(me)&&oe+1<Q){const ye=U.charCodeAt(oe+1);if(ee(ye))return ce(me,ye)}return me}function X(U,Q){const oe=U.charCodeAt(Q-1);if(ee(oe)&&Q>1){const me=U.charCodeAt(Q-2);if(G(me))return ce(me,oe)}return oe}class q{get offset(){return this.e}constructor(Q,oe=0){this.c=Q,this.d=Q.length,this.e=oe}setOffset(Q){this.e=Q}prevCodePoint(){const Q=X(this.c,this.e);return this.e-=Q>=65536?2:1,Q}nextCodePoint(){const Q=he(this.c,this.d,this.e);return this.e+=Q>=65536?2:1,Q}eol(){return this.e>=this.d}}e.$Gf=q;class J{get offset(){return this.c.offset}constructor(Q,oe=0){this.c=new q(Q,oe)}nextGraphemeLength(){const Q=De.getInstance(),oe=this.c,me=oe.offset;let ye=Q.getGraphemeBreakType(oe.nextCodePoint());for(;!oe.eol();){const Ce=oe.offset,Le=Q.getGraphemeBreakType(oe.nextCodePoint());if(Pe(ye,Le)){oe.setOffset(Ce);break}ye=Le}return oe.offset-me}prevGraphemeLength(){const Q=De.getInstance(),oe=this.c,me=oe.offset;let ye=Q.getGraphemeBreakType(oe.prevCodePoint());for(;oe.offset>0;){const Ce=oe.offset,Le=Q.getGraphemeBreakType(oe.prevCodePoint());if(Pe(Le,ye)){oe.setOffset(Ce);break}ye=Le}return me-oe.offset}eol(){return this.c.eol()}}e.$Hf=J;function K(U,Q){return new J(U,Q).nextGraphemeLength()}function de(U,Q){return new J(U,Q).prevGraphemeLength()}function B(U,Q){Q>0&&ee(U.charCodeAt(Q))&&Q--;const oe=Q+K(U,Q);return[oe-de(U,oe),oe]}function ue(U){const Q=new J(U);let oe=0;for(;!Q.eol();)oe++,Q.nextGraphemeLength();return oe}let x;function h(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(U){return x||(x=h()),x.test(U)}const ie=/^[\t\n\r\x20-\x7E]*$/;function ne(U){return ie.test(U)}e.$Of=/[\u2028\u2029]/;function H(U){return e.$Of.test(U)}function W(U){return U>=11904&&U<=55215||U>=63744&&U<=64255||U>=65281&&U<=65374}function z(U){return U>=127462&&U<=127487||U===8986||U===8987||U===9200||U===9203||U>=9728&&U<=10175||U===11088||U===11093||U>=127744&&U<=128591||U>=128640&&U<=128764||U>=128992&&U<=129008||U>=129280&&U<=129535||U>=129648&&U<=129782}function I(U,Q,oe=""){const me=U.trimStart();if(me.length<Q)return me;const ye=/\b/g;let Ce=0;for(;ye.test(me)&&!(me.length-ye.lastIndex<Q);)Ce=ye.lastIndex,ye.lastIndex+=1;return Ce===0?me:oe+me.substring(Ce).trimStart()}const V=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*_(U){let Q=0;for(const oe of U.matchAll(V))Q!==oe.index&&(yield{isCode:!1,str:U.substring(Q,oe.index)}),yield{isCode:!0,str:oe[0]},Q=oe.index+oe[0].length;Q!==U.length&&(yield{isCode:!1,str:U.substring(Q)})}function se(U){return U&&(U=U.replace(V,"")),U}e.$Vf="\uFEFF";function re(U){return!!(U&&U.length>0&&U.charCodeAt(0)===65279)}function le(U){return re(U)?U.substr(1):U}function $e(U,Q){if(!U||!Q||U.length<Q.length)return!1;const oe=Q.length,me=U.toLowerCase();let ye=0,Ce=-1;for(;ye<oe;){const Le=me.indexOf(Q[ye],Ce+1);if(Le<0)return!1;Ce=Le,ye++}return!0}function be(U,Q=!1){return U?(Q&&(U=U.replace(/\\./g,"")),U.toLowerCase()!==U):!1}function pe(U){return U.charAt(0).toUpperCase()+U.slice(1)}function ve(U,Q=1){if(Q===0)return"";let oe=-1;do oe=U.indexOf(`
`,oe+1),Q--;while(Q>0&&oe>=0);return oe===-1?U:(U[oe-1]==="\r"&&oe--,U.substr(0,oe))}function Ee(U){return U=U%(2*26),U<26?String.fromCharCode(97+U):String.fromCharCode(65+U-26)}function ke(U){return De.getInstance().getGraphemeBreakType(U)}function Pe(U,Q){return U===0?Q!==5&&Q!==7:U===2&&Q===3?!1:U===4||U===2||U===3||Q===4||Q===2||Q===3?!0:!(U===8&&(Q===8||Q===9||Q===11||Q===12)||(U===11||U===9)&&(Q===9||Q===10)||(U===12||U===10)&&Q===10||Q===5||Q===13||Q===7||U===1||U===13&&Q===14||U===6&&Q===6)}var Oe;(function(U){U[U.Other=0]="Other",U[U.Prepend=1]="Prepend",U[U.CR=2]="CR",U[U.LF=3]="LF",U[U.Control=4]="Control",U[U.Extend=5]="Extend",U[U.Regional_Indicator=6]="Regional_Indicator",U[U.SpacingMark=7]="SpacingMark",U[U.L=8]="L",U[U.V=9]="V",U[U.T=10]="T",U[U.LV=11]="LV",U[U.LVT=12]="LVT",U[U.ZWJ=13]="ZWJ",U[U.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(e.GraphemeBreakType=Oe={}));class De{static{this.c=null}static getInstance(){return De.c||(De.c=new De),De.c}constructor(){this.d=ze()}getGraphemeBreakType(Q){if(Q<32)return Q===10?3:Q===13?2:4;if(Q<127)return 0;const oe=this.d,me=oe.length/3;let ye=1;for(;ye<=me;)if(Q<oe[3*ye])ye=2*ye;else if(Q>oe[3*ye+1])ye=2*ye+1;else return oe[3*ye+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Be(U,Q){if(U===0)return 0;const oe=Fe(U,Q);if(oe!==void 0)return oe;const me=new q(Q,U);return me.prevCodePoint(),me.offset}function Fe(U,Q){const oe=new q(Q,U);let me=oe.prevCodePoint();for(;Ve(me)||me===65039||me===8419;){if(oe.offset===0)return;me=oe.prevCodePoint()}if(!z(me))return;let ye=oe.offset;return ye>0&&oe.prevCodePoint()===8205&&(ye=oe.offset),ye}function Ve(U){return 127995<=U&&U<=127999}var qe;(function(U){U[U.zwj=8205]="zwj",U[U.emojiVariantSelector=65039]="emojiVariantSelector",U[U.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$6f="\xA0";class Te{static{this.c=new S.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new y.$4e({getCacheKey:JSON.stringify},Q=>{function oe(Se){const je=new Map;for(let Ie=0;Ie<Se.length;Ie+=2)je.set(Se[Ie],Se[Ie+1]);return je}function me(Se,je){const Ie=new Map(Se);for(const[We,He]of je)Ie.set(We,He);return Ie}function ye(Se,je){if(!Se)return je;const Ie=new Map;for(const[We,He]of Se)je.has(We)&&Ie.set(We,He);return Ie}const Ce=this.c.value;let Le=Q.filter(Se=>!Se.startsWith("_")&&Se in Ce);Le.length===0&&(Le=["_default"]);let Re;for(const Se of Le){const je=oe(Ce[Se]);Re=ye(Re,je)}const Ae=oe(Ce._common),Me=me(Ae,Re);return new Te(Me)})}static getInstance(Q){return Te.d.get(Array.from(Q))}static{this.e=new S.$V(()=>Object.keys(Te.c.value).filter(Q=>!Q.startsWith("_")))}static getLocales(){return Te.e.value}constructor(Q){this.f=Q}isAmbiguous(Q){return this.f.has(Q)}getPrimaryConfusable(Q){return this.f.get(Q)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=Te;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(Q){return Ue.e().has(Q)}static get codePoints(){return Ue.e()}}e.$8f=Ue}),define(fe[49],ge([0,1,12]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=S,e.$lj=C,e.$mj=M,e.$nj=P,e.$pj=m;function S(n){return C(n,0)}function C(n,s){switch(typeof n){case"object":return n===null?M(349,s):Array.isArray(n)?l(n,s):r(n,s);case"string":return P(n,s);case"boolean":return j(n,s);case"number":return M(n,s);case"undefined":return M(937,s);default:return M(617,s)}}function M(n,s){return(s<<5)-s+n|0}function j(n,s){return M(n?433:863,s)}function P(n,s){s=M(149417,s);for(let d=0,v=n.length;d<v;d++)s=M(n.charCodeAt(d),s);return s}function l(n,s){return s=M(104579,s),n.reduce((d,v)=>C(v,d),s)}function r(n,s){return s=M(181387,s),Object.keys(n).sort().reduce((d,v)=>(d=P(v,d),C(n[v],d)),s)}class p{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=C(s,this.g),this.g}}e.$oj=p;var u;(function(n){n[n.BLOCK_SIZE=64]="BLOCK_SIZE",n[n.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function k(n,s,d=32){const v=d-s,i=~((1<<v)-1);return(n<<s|(i&n)>>>v)>>>0}function o(n,s=0,d=n.byteLength,v=0){for(let i=0;i<d;i++)n[s+i]=v}function a(n,s,d="0"){for(;n.length<s;)n=d+n;return n}function m(n,s=32){return n instanceof ArrayBuffer?Array.from(new Uint8Array(n)).map(d=>d.toString(16).padStart(2,"0")).join(""):a((n>>>0).toString(16),s/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const d=s.length;if(d===0)return;const v=this.p;let i=this.r,t=this.u,c,L;for(t!==0?(c=t,L=-1,t=0):(c=s.charCodeAt(0),L=0);;){let $=c;if(y.$Cf(c))if(L+1<d){const D=s.charCodeAt(L+1);y.$Df(D)?(L++,$=y.$Ef(c,D)):$=65533}else{t=c;break}else y.$Df(c)&&($=65533);if(i=this.w(v,i,$),L++,L<d)c=s.charCodeAt(L);else break}this.r=i,this.u=t}w(s,d,v){return v<128?s[d++]=v:v<2048?(s[d++]=192|(v&1984)>>>6,s[d++]=128|(v&63)>>>0):v<65536?(s[d++]=224|(v&61440)>>>12,s[d++]=128|(v&4032)>>>6,s[d++]=128|(v&63)>>>0):(s[d++]=240|(v&1835008)>>>18,s[d++]=128|(v&258048)>>>12,s[d++]=128|(v&4032)>>>6,s[d++]=128|(v&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,s[0]=s[64],s[1]=s[65],s[2]=s[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,o(this.p,this.r),this.r>56&&(this.y(),o(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=f.g,d=this.q;for(let w=0;w<64;w+=4)s.setUint32(w,d.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)s.setUint32(w,k(s.getUint32(w-12,!1)^s.getUint32(w-32,!1)^s.getUint32(w-56,!1)^s.getUint32(w-64,!1),1),!1);let v=this.h,i=this.l,t=this.m,c=this.n,L=this.o,$,D,E;for(let w=0;w<80;w++)w<20?($=i&t|~i&c,D=1518500249):w<40?($=i^t^c,D=1859775393):w<60?($=i&t|i&c|t&c,D=2400959708):($=i^t^c,D=3395469782),E=k(v,5)+$+L+D+s.getUint32(w*4,!1)&4294967295,L=c,c=t,t=k(i,30),i=v,v=E;this.h=this.h+v&4294967295,this.l=this.l+i&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+L&4294967295}}e.$qj=f}),define(fe[50],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(fe[51],ge([0,1,16,12]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class C{constructor(){this.b="",this.c=0}reset(o){return this.b=o,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(o){const a=o.charCodeAt(0),m=this.b.charCodeAt(this.c);return a-m}value(){return this.b[this.c]}}e.$yi=C;class M{constructor(o=!0){this.e=o}reset(o){return this.b=o,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let o=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(o)this.c++;else break;else o=!1;return this}cmp(o){return this.e?(0,S.$sf)(o,this.b,0,o.length,this.c,this.d):(0,S.$uf)(o,this.b,0,o.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=M;class j{constructor(o=!0,a=!0){this.f=o,this.g=a}reset(o){this.d=0,this.e=0,this.b=o,this.c=o.length;for(let a=o.length-1;a>=0;a--,this.c--){const m=this.b.charCodeAt(a);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let o=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===47||this.f&&a===92)if(o)this.d++;else break;else o=!1}return this}cmp(o){return this.g?(0,S.$sf)(o,this.b,0,o.length,this.d,this.e):(0,S.$uf)(o,this.b,0,o.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=j;var P;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(P||(P={}));class l{constructor(o,a){this.f=o,this.g=a,this.d=[],this.e=0}reset(o){return this.c=o,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f(o)),this.b.reset(o.path),this.b.value()&&this.d.push(3)),this.g(o)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(o){if(this.d[this.e]===1)return(0,S.$tf)(o,this.c.scheme);if(this.d[this.e]===2)return(0,S.$tf)(o,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(o);if(this.d[this.e]===4)return(0,S.$rf)(o,this.c.query);if(this.d[this.e]===5)return(0,S.$rf)(o,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=l;class r{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(p||(p={}));class u{static forUris(o=()=>!1,a=()=>!1){return new u(new l(o,a))}static forPaths(o=!1){return new u(new j(void 0,!o))}static forStrings(){return new u(new C)}static forConfigKeys(){return new u(new M)}constructor(o){this.b=o}clear(){this.c=void 0}fill(o,a){if(a){const m=a.slice(0);(0,y.$Xb)(m);for(const f of m)this.set(f,o)}else{const m=o.slice(0);(0,y.$Xb)(m);for(const f of m)this.set(f[0],f[1])}}set(o,a){const m=this.b.reset(o);let f;this.c||(this.c=new r,this.c.segment=m.value());const n=[];for(f=this.c;;){const d=m.cmp(f.segment);if(d>0)f.left||(f.left=new r,f.left.segment=m.value()),n.push([-1,f]),f=f.left;else if(d<0)f.right||(f.right=new r,f.right.segment=m.value()),n.push([1,f]),f=f.right;else if(m.hasNext())m.next(),f.mid||(f.mid=new r,f.mid.segment=m.value()),n.push([0,f]),f=f.mid;else break}const s=f.value;f.value=a,f.key=o;for(let d=n.length-1;d>=0;d--){const v=n[d][1];v.updateHeight();const i=v.balanceFactor();if(i<-1||i>1){const t=n[d][0],c=n[d+1][0];if(t===1&&c===1)n[d][1]=v.rotateLeft();else if(t===-1&&c===-1)n[d][1]=v.rotateRight();else if(t===1&&c===-1)v.right=n[d+1][1]=n[d+1][1].rotateRight(),n[d][1]=v.rotateLeft();else if(t===-1&&c===1)v.left=n[d+1][1]=n[d+1][1].rotateLeft(),n[d][1]=v.rotateRight();else throw new Error;if(d>0)switch(n[d-1][0]){case-1:n[d-1][1].left=n[d][1];break;case 1:n[d-1][1].right=n[d][1];break;case 0:n[d-1][1].mid=n[d][1];break}else this.c=n[0][1]}}return s}get(o){return this.d(o)?.value}d(o){const a=this.b.reset(o);let m=this.c;for(;m;){const f=a.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else break}return m}has(o){const a=this.d(o);return!(a?.value===void 0&&a?.mid===void 0)}delete(o){return this.e(o,!1)}deleteSuperstr(o){return this.e(o,!0)}e(o,a){const m=this.b.reset(o),f=[];let n=this.c;for(;n;){const s=m.cmp(n.segment);if(s>0)f.push([-1,n]),n=n.left;else if(s<0)f.push([1,n]),n=n.right;else if(m.hasNext())m.next(),f.push([0,n]),n=n.mid;else break}if(n){if(a?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const s=this.f(n.right);if(s.key){const{key:d,value:v,segment:i}=s;this.e(s.key,!1),n.key=d,n.value=v,n.segment=i}}else{const s=n.left??n.right;if(f.length>0){const[d,v]=f[f.length-1];switch(d){case-1:v.left=s;break;case 0:v.mid=s;break;case 1:v.right=s;break}}else this.c=s}for(let s=f.length-1;s>=0;s--){const d=f[s][1];d.updateHeight();const v=d.balanceFactor();if(v>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),f[s][1]=d.rotateLeft()):v<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),f[s][1]=d.rotateRight()),s>0)switch(f[s-1][0]){case-1:f[s-1][1].left=f[s][1];break;case 1:f[s-1][1].right=f[s][1];break;case 0:f[s-1][1].mid=f[s][1];break}else this.c=f[0][1]}}}f(o){for(;o.left;)o=o.left;return o}findSubstr(o){const a=this.b.reset(o);let m=this.c,f;for(;m;){const n=a.cmp(m.segment);if(n>0)m=m.left;else if(n<0)m=m.right;else if(a.hasNext())a.next(),f=m.value||f,m=m.mid;else break}return m&&m.value||f}findSuperstr(o){return this.g(o,!1)}g(o,a){const m=this.b.reset(o);let f=this.c;for(;f;){const n=m.cmp(f.segment);if(n>0)f=f.left;else if(n<0)f=f.right;else if(m.hasNext())m.next(),f=f.mid;else return f.mid?this.h(f.mid):a?f.value:void 0}}hasElementOrSubtree(o){return this.g(o,!0)!==void 0}forEach(o){for(const[a,m]of this)o(m,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(o){const a=[];return this.j(o,a),a[Symbol.iterator]()}j(o,a){o&&(o.left&&this.j(o.left,a),o.value&&a.push([o.key,o.value]),o.mid&&this.j(o.mid,a),o.right&&this.j(o.right,a))}_isBalanced(){const o=a=>{if(!a)return!0;const m=a.balanceFactor();return m<-1||m>1?!1:o(a.left)&&o(a.right)};return o(this.c)}}e.$Ci=u}),define(fe[9],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=y,e.$0f=S,e.$$f=C,e.$_f=M,e.$ag=j,e.$bg=P,e.$cg=l,e.$dg=r,e.$eg=p,e.$fg=u,e.$gg=k,e.$hg=o,e.$ig=a,e.$jg=f,e.$kg=n,e.$lg=s,e.$mg=d,e.$ng=v;function y(i){return typeof i=="string"}function S(i){return Array.isArray(i)&&i.every(t=>y(t))}function C(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function M(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function j(i){return typeof i=="number"&&!isNaN(i)}function P(i){return!!i&&typeof i[Symbol.iterator]=="function"}function l(i){return i===!0||i===!1}function r(i){return typeof i>"u"}function p(i){return!u(i)}function u(i){return r(i)||i===null}function k(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function o(i){if(u(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function a(...i){const t=[];for(let c=0;c<i.length;c++){const L=i[c];if(u(L))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);t.push(L)}return t}const m=Object.prototype.hasOwnProperty;function f(i){if(!C(i))return!1;for(const t in i)if(m.call(i,t))return!1;return!0}function n(i){return typeof i=="function"}function s(...i){return i.length>0&&i.every(n)}function d(i,t){const c=Math.min(i.length,t.length);for(let L=0;L<c;L++)v(i[L],t[L])}function v(i,t){if(y(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(n(t)){try{if(i instanceof t)return}catch{}if(!u(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(fe[30],ge([0,1,9]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=S,e.$4n=C,e.$5n=j,e.$6n=l,e.$7n=r,e.$8n=p,e.$9n=u,e.$0n=k,e.$$n=o,e.$_n=a,e.$ao=m,e.$bo=f;function S(n){if(!n||typeof n!="object"||n instanceof RegExp)return n;const s=Array.isArray(n)?[]:{};return Object.entries(n).forEach(([d,v])=>{s[d]=v&&typeof v=="object"?S(v):v}),s}function C(n){if(!n||typeof n!="object")return n;const s=[n];for(;s.length>0;){const d=s.shift();Object.freeze(d);for(const v in d)if(M.call(d,v)){const i=d[v];typeof i=="object"&&!Object.isFrozen(i)&&!(0,y.$_f)(i)&&s.push(i)}}return n}const M=Object.prototype.hasOwnProperty;function j(n,s){return P(n,s,new Set)}function P(n,s,d){if((0,y.$fg)(n))return n;const v=s(n);if(typeof v<"u")return v;if(Array.isArray(n)){const i=[];for(const t of n)i.push(P(t,s,d));return i}if((0,y.$$f)(n)){if(d.has(n))throw new Error("Cannot clone recursive data-structure");d.add(n);const i={};for(const t in n)M.call(n,t)&&(i[t]=P(n[t],s,d));return d.delete(n),i}return n}function l(n,s,d=!0){return(0,y.$$f)(n)?((0,y.$$f)(s)&&Object.keys(s).forEach(v=>{v in n?d&&((0,y.$$f)(n[v])&&(0,y.$$f)(s[v])?l(n[v],s[v],d):n[v]=s[v]):n[v]=s[v]}),n):s}function r(n,s){if(n===s)return!0;if(n==null||s===null||s===void 0||typeof n!=typeof s||typeof n!="object"||Array.isArray(n)!==Array.isArray(s))return!1;let d,v;if(Array.isArray(n)){if(n.length!==s.length)return!1;for(d=0;d<n.length;d++)if(!r(n[d],s[d]))return!1}else{const i=[];for(v in n)i.push(v);i.sort();const t=[];for(v in s)t.push(v);if(t.sort(),!r(i,t))return!1;for(d=0;d<i.length;d++)if(!r(n[i[d]],s[i[d]]))return!1}return!0}function p(n){const s=new Set;return JSON.stringify(n,(d,v)=>{if((0,y.$$f)(v)||Array.isArray(v)){if(s.has(v))return"[Circular]";s.add(v)}return typeof v=="bigint"?`[BigInt ${v.toString()}]`:v})}function u(n,s){const d=Object.create(null);return!n||!s||Object.keys(s).forEach(i=>{const t=n[i],c=s[i];r(t,c)||(d[i]=c)}),d}function k(n,s){const d=s.toLowerCase(),v=Object.keys(n).find(i=>i.toLowerCase()===d);return v?n[v]:n[s]}function o(n,s){const d=Object.create(null);for(const[v,i]of Object.entries(n))s(v,i)&&(d[v]=i);return d}function a(n){let s=[];for(;Object.prototype!==n;)s=s.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return s}function m(n){const s=[];for(const d of a(n))typeof n[d]=="function"&&s.push(d);return s}function f(n,s){const d=i=>function(){const t=Array.prototype.slice.call(arguments,0);return s(i,t)},v={};for(const i of n)v[i]=d(i);return v}}),define(fe[52],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=S;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(C){return y.test(C)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(P){for(let l=0;l<P.length;l++)P[l]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),j=[];for(let P=0;P<256;P++)j.push(P.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let l=0,r="";return r+=j[M[l++]],r+=j[M[l++]],r+=j[M[l++]],r+=j[M[l++]],r+="-",r+=j[M[l++]],r+=j[M[l++]],r+="-",r+=j[M[l++]],r+=j[M[l++]],r+="-",r+=j[M[l++]],r+=j[M[l++]],r+="-",r+=j[M[l++]],r+=j[M[l++]],r+=j[M[l++]],r+=j[M[l++]],r+=j[M[l++]],r+=j[M[l++]],r}}()}),define(fe[31],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8W=y;function y(S){return!!S.parentPort}}),define(fe[53],ge([13,10]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(fe[54],ge([0,1,53]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=r,e.$3m=p,e.$4m=u;const S=60,C=S*60,M=C*24,j=M*7,P=M*30,l=M*365;function r(k,o,a,m){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,y.localize)(0,null,r(new Date().getTime()+f*1e3,!1));if(!m&&f<30)return(0,y.localize)(1,null);let n;return f<S?(n=f,o?n===1?a?(0,y.localize)(2,null,n):(0,y.localize)(3,null,n):a?(0,y.localize)(4,null,n):(0,y.localize)(5,null,n):n===1?a?(0,y.localize)(6,null,n):(0,y.localize)(7,null,n):a?(0,y.localize)(8,null,n):(0,y.localize)(9,null,n)):f<C?(n=Math.floor(f/S),o?n===1?a?(0,y.localize)(10,null,n):(0,y.localize)(11,null,n):a?(0,y.localize)(12,null,n):(0,y.localize)(13,null,n):n===1?a?(0,y.localize)(14,null,n):(0,y.localize)(15,null,n):a?(0,y.localize)(16,null,n):(0,y.localize)(17,null,n)):f<M?(n=Math.floor(f/C),o?n===1?a?(0,y.localize)(18,null,n):(0,y.localize)(19,null,n):a?(0,y.localize)(20,null,n):(0,y.localize)(21,null,n):n===1?a?(0,y.localize)(22,null,n):(0,y.localize)(23,null,n):a?(0,y.localize)(24,null,n):(0,y.localize)(25,null,n)):f<j?(n=Math.floor(f/M),o?n===1?(0,y.localize)(26,null,n):(0,y.localize)(27,null,n):n===1?(0,y.localize)(28,null,n):(0,y.localize)(29,null,n)):f<P?(n=Math.floor(f/j),o?n===1?a?(0,y.localize)(30,null,n):(0,y.localize)(31,null,n):a?(0,y.localize)(32,null,n):(0,y.localize)(33,null,n):n===1?a?(0,y.localize)(34,null,n):(0,y.localize)(35,null,n):a?(0,y.localize)(36,null,n):(0,y.localize)(37,null,n)):f<l?(n=Math.floor(f/P),o?n===1?a?(0,y.localize)(38,null,n):(0,y.localize)(39,null,n):a?(0,y.localize)(40,null,n):(0,y.localize)(41,null,n):n===1?a?(0,y.localize)(42,null,n):(0,y.localize)(43,null,n):a?(0,y.localize)(44,null,n):(0,y.localize)(45,null,n)):(n=Math.floor(f/l),o?n===1?a?(0,y.localize)(46,null,n):(0,y.localize)(47,null,n):a?(0,y.localize)(48,null,n):(0,y.localize)(49,null,n):n===1?a?(0,y.localize)(50,null,n):(0,y.localize)(51,null,n):a?(0,y.localize)(52,null,n):(0,y.localize)(53,null,n))}function p(k,o){const a=Math.abs(k/1e3);return a<1?o?(0,y.localize)(54,null,k):(0,y.localize)(55,null,k):a<S?o?(0,y.localize)(56,null,Math.round(k)/1e3):(0,y.localize)(57,null,Math.round(k)/1e3):a<C?o?(0,y.localize)(58,null,Math.round(k/(1e3*S))):(0,y.localize)(59,null,Math.round(k/(1e3*S))):a<M?o?(0,y.localize)(60,null,Math.round(k/(1e3*C))):(0,y.localize)(61,null,Math.round(k/(1e3*C))):(0,y.localize)(62,null,Math.round(k/(1e3*M)))}function u(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(fe[55],ge([13,10]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(fe[56],ge([0,1,16,9,55]),function(ae,e,y,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=l,e.$ij=r,e.$jj=p;function M(u,k){return k&&(u.stack||u.stacktrace)?C.localize(0,null,P(u),j(u.stack)||j(u.stacktrace)):P(u)}function j(u){return Array.isArray(u)?u.join(`
`):u}function P(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?C.localize(1,null,u.message):u.message||C.localize(2,null)}function l(u=null,k=!1){if(!u)return C.localize(3,null);if(Array.isArray(u)){const o=y.$Hb(u),a=l(o[0],k);return o.length>1?C.localize(4,null,a,o.length):a}if(S.$9f(u))return u;if(u.detail){const o=u.detail;if(o.error)return M(o.error,k);if(o.exception)return M(o.exception,k)}return u.stack?M(u,k):u.message?u.message:C.localize(5,null)}function r(u){const k=u;return k instanceof Error&&Array.isArray(k.actions)}function p(u,k){let o;return typeof u=="string"?o=new Error(u):o=u,o.actions=k,o}}),define(fe[57],ge([13,10]),function(ae,e){return ae.create("vs/base/common/platform",e)}),define(fe[3],ge([0,1,57]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=c,e.$D=F,e.$J=Z,e.$g="en";let S=!1,C=!1,M=!1,j=!1,P=!1,l=!1,r=!1,p=!1,u=!1,k=!1,o,a=e.$g,m=e.$g,f,n;const s=globalThis;let d;typeof s.vscode<"u"&&typeof s.vscode.process<"u"?d=s.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(d=process);const v=typeof d?.versions?.electron=="string",i=v&&d?.type==="renderer";if(typeof d=="object"){S=d.platform==="win32",C=d.platform==="darwin",M=d.platform==="linux",j=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,r=v,u=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,o=e.$g,a=e.$g;const T=d.env.VSCODE_NLS_CONFIG;if(T)try{const R=JSON.parse(T),g=R.availableLanguages["*"];o=R.locale,m=R.osLocale,a=g||e.$g,f=R._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!i?(n=navigator.userAgent,S=n.indexOf("Windows")>=0,C=n.indexOf("Macintosh")>=0,p=(n.indexOf("Macintosh")>=0||n.indexOf("iPad")>=0||n.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=n.indexOf("Linux")>=0,k=n?.indexOf("Mobi")>=0,l=!0,o=y.getConfiguredDefaultLocale(y.localize(0,null))||e.$g,a=o,m=navigator.language):console.error("Unable to resolve platform.");var t;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(t||(e.Platform=t={}));function c(T){switch(T){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let L=0;C?L=1:S?L=3:M&&(L=2),e.$i=S,e.$j=C,e.$k=M,e.$l=j,e.$m=P,e.$n=r,e.$o=l,e.$p=l&&typeof s.importScripts=="function",e.$q=e.$p?s.origin:void 0,e.$r=p,e.$s=k,e.$t=u,e.$u=L,e.$v=n,e.$w=a;var $;(function(T){function R(){return e.$w}T.value=R;function g(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}T.isDefaultVariant=g;function O(){return e.$w==="en"}T.isDefault=O})($||(e.Language=$={})),e.$x=o,e.$y=m,e.$z=f,e.$A=typeof s.postMessage=="function"&&!s.importScripts,e.$B=(()=>{if(e.$A){const T=[];s.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let O=0,b=T.length;O<b;O++){const A=T[O];if(A.id===g.data.vscodeScheduleAsyncWork){T.splice(O,1),A.callback();return}}});let R=0;return g=>{const O=++R;T.push({id:O,callback:g}),s.postMessage({vscodeScheduleAsyncWork:O},"*")}}return T=>setTimeout(T)})();var D;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(D||(e.OperatingSystem=D={})),e.OS=C||p?2:S?1:3;let E=!0,w=!1;function F(){if(!w){w=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,E=new Uint16Array(T.buffer)[0]===513}return E}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function Z(T){return parseFloat(T)>=20}}),define(fe[15],ge([0,1,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let S;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const M=C.process;S={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?S={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:S={get platform(){return y.$i?"win32":y.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=S.cwd,e.env=S.env,e.$ec=S.platform,e.$fc=S.arch}),define(fe[5],ge([0,1,15]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const S=65,C=97,M=90,j=122,P=46,l=47,r=92,p=58,u=63;class k extends Error{constructor(c,L,$){let D;typeof L=="string"&&L.indexOf("not ")===0?(D="must not be",L=L.replace(/^not /,"")):D="must be";const E=c.indexOf(".")!==-1?"property":"argument";let w=`The "${c}" ${E} ${D} of type ${L}`;w+=`. Received type ${typeof $}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function o(t,c){if(t===null||typeof t!="object")throw new k(c,"Object",t)}function a(t,c){if(typeof t!="string")throw new k(c,"string",t)}const m=y.$ec==="win32";function f(t){return t===l||t===r}function n(t){return t===l}function s(t){return t>=S&&t<=M||t>=C&&t<=j}function d(t,c,L,$){let D="",E=0,w=-1,F=0,Z=0;for(let T=0;T<=t.length;++T){if(T<t.length)Z=t.charCodeAt(T);else{if($(Z))break;Z=l}if($(Z)){if(!(w===T-1||F===1))if(F===2){if(D.length<2||E!==2||D.charCodeAt(D.length-1)!==P||D.charCodeAt(D.length-2)!==P){if(D.length>2){const R=D.lastIndexOf(L);R===-1?(D="",E=0):(D=D.slice(0,R),E=D.length-1-D.lastIndexOf(L)),w=T,F=0;continue}else if(D.length!==0){D="",E=0,w=T,F=0;continue}}c&&(D+=D.length>0?`${L}..`:"..",E=2)}else D.length>0?D+=`${L}${t.slice(w+1,T)}`:D=t.slice(w+1,T),E=T-w-1;w=T,F=0}else Z===P&&F!==-1?++F:F=-1}return D}function v(t,c){o(c,"pathObject");const L=c.dir||c.root,$=c.base||`${c.name||""}${c.ext||""}`;return L?L===c.root?`${L}${$}`:`${L}${t}${$}`:$}e.$gc={resolve(...t){let c="",L="",$=!1;for(let D=t.length-1;D>=-1;D--){let E;if(D>=0){if(E=t[D],a(E,"path"),E.length===0)continue}else c.length===0?E=y.cwd():(E=y.env[`=${c}`]||y.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==c.toLowerCase()&&E.charCodeAt(2)===r)&&(E=`${c}\\`));const w=E.length;let F=0,Z="",T=!1;const R=E.charCodeAt(0);if(w===1)f(R)&&(F=1,T=!0);else if(f(R))if(T=!0,f(E.charCodeAt(1))){let g=2,O=g;for(;g<w&&!f(E.charCodeAt(g));)g++;if(g<w&&g!==O){const b=E.slice(O,g);for(O=g;g<w&&f(E.charCodeAt(g));)g++;if(g<w&&g!==O){for(O=g;g<w&&!f(E.charCodeAt(g));)g++;(g===w||g!==O)&&(Z=`\\\\${b}\\${E.slice(O,g)}`,F=g)}}}else F=1;else s(R)&&E.charCodeAt(1)===p&&(Z=E.slice(0,2),F=2,w>2&&f(E.charCodeAt(2))&&(T=!0,F=3));if(Z.length>0)if(c.length>0){if(Z.toLowerCase()!==c.toLowerCase())continue}else c=Z;if($){if(c.length>0)break}else if(L=`${E.slice(F)}\\${L}`,$=T,T&&c.length>0)break}return L=d(L,!$,"\\",f),$?`${c}\\${L}`:`${c}${L}`||"."},normalize(t){a(t,"path");const c=t.length;if(c===0)return".";let L=0,$,D=!1;const E=t.charCodeAt(0);if(c===1)return n(E)?"\\":t;if(f(E))if(D=!0,f(t.charCodeAt(1))){let F=2,Z=F;for(;F<c&&!f(t.charCodeAt(F));)F++;if(F<c&&F!==Z){const T=t.slice(Z,F);for(Z=F;F<c&&f(t.charCodeAt(F));)F++;if(F<c&&F!==Z){for(Z=F;F<c&&!f(t.charCodeAt(F));)F++;if(F===c)return`\\\\${T}\\${t.slice(Z)}\\`;F!==Z&&($=`\\\\${T}\\${t.slice(Z,F)}`,L=F)}}}else L=1;else s(E)&&t.charCodeAt(1)===p&&($=t.slice(0,2),L=2,c>2&&f(t.charCodeAt(2))&&(D=!0,L=3));let w=L<c?d(t.slice(L),!D,"\\",f):"";return w.length===0&&!D&&(w="."),w.length>0&&f(t.charCodeAt(c-1))&&(w+="\\"),$===void 0?D?`\\${w}`:w:D?`${$}\\${w}`:`${$}${w}`},isAbsolute(t){a(t,"path");const c=t.length;if(c===0)return!1;const L=t.charCodeAt(0);return f(L)||c>2&&s(L)&&t.charCodeAt(1)===p&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,L;for(let E=0;E<t.length;++E){const w=t[E];a(w,"path"),w.length>0&&(c===void 0?c=L=w:c+=`\\${w}`)}if(c===void 0)return".";let $=!0,D=0;if(typeof L=="string"&&f(L.charCodeAt(0))){++D;const E=L.length;E>1&&f(L.charCodeAt(1))&&(++D,E>2&&(f(L.charCodeAt(2))?++D:$=!1))}if($){for(;D<c.length&&f(c.charCodeAt(D));)D++;D>=2&&(c=`\\${c.slice(D)}`)}return e.$gc.normalize(c)},relative(t,c){if(a(t,"from"),a(c,"to"),t===c)return"";const L=e.$gc.resolve(t),$=e.$gc.resolve(c);if(L===$||(t=L.toLowerCase(),c=$.toLowerCase(),t===c))return"";let D=0;for(;D<t.length&&t.charCodeAt(D)===r;)D++;let E=t.length;for(;E-1>D&&t.charCodeAt(E-1)===r;)E--;const w=E-D;let F=0;for(;F<c.length&&c.charCodeAt(F)===r;)F++;let Z=c.length;for(;Z-1>F&&c.charCodeAt(Z-1)===r;)Z--;const T=Z-F,R=w<T?w:T;let g=-1,O=0;for(;O<R;O++){const A=t.charCodeAt(D+O);if(A!==c.charCodeAt(F+O))break;A===r&&(g=O)}if(O!==R){if(g===-1)return $}else{if(T>R){if(c.charCodeAt(F+O)===r)return $.slice(F+O+1);if(O===2)return $.slice(F+O)}w>R&&(t.charCodeAt(D+O)===r?g=O:O===2&&(g=3)),g===-1&&(g=0)}let b="";for(O=D+g+1;O<=E;++O)(O===E||t.charCodeAt(O)===r)&&(b+=b.length===0?"..":"\\..");return F+=g,b.length>0?`${b}${$.slice(F,Z)}`:($.charCodeAt(F)===r&&++F,$.slice(F,Z))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.$gc.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===r){if(c.charCodeAt(1)===r){const L=c.charCodeAt(2);if(L!==u&&L!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(s(c.charCodeAt(0))&&c.charCodeAt(1)===p&&c.charCodeAt(2)===r)return`\\\\?\\${c}`;return t},dirname(t){a(t,"path");const c=t.length;if(c===0)return".";let L=-1,$=0;const D=t.charCodeAt(0);if(c===1)return f(D)?t:".";if(f(D)){if(L=$=1,f(t.charCodeAt(1))){let F=2,Z=F;for(;F<c&&!f(t.charCodeAt(F));)F++;if(F<c&&F!==Z){for(Z=F;F<c&&f(t.charCodeAt(F));)F++;if(F<c&&F!==Z){for(Z=F;F<c&&!f(t.charCodeAt(F));)F++;if(F===c)return t;F!==Z&&(L=$=F+1)}}}}else s(D)&&t.charCodeAt(1)===p&&(L=c>2&&f(t.charCodeAt(2))?3:2,$=L);let E=-1,w=!0;for(let F=c-1;F>=$;--F)if(f(t.charCodeAt(F))){if(!w){E=F;break}}else w=!1;if(E===-1){if(L===-1)return".";E=L}return t.slice(0,E)},basename(t,c){c!==void 0&&a(c,"ext"),a(t,"path");let L=0,$=-1,D=!0,E;if(t.length>=2&&s(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(L=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let w=c.length-1,F=-1;for(E=t.length-1;E>=L;--E){const Z=t.charCodeAt(E);if(f(Z)){if(!D){L=E+1;break}}else F===-1&&(D=!1,F=E+1),w>=0&&(Z===c.charCodeAt(w)?--w===-1&&($=E):(w=-1,$=F))}return L===$?$=F:$===-1&&($=t.length),t.slice(L,$)}for(E=t.length-1;E>=L;--E)if(f(t.charCodeAt(E))){if(!D){L=E+1;break}}else $===-1&&(D=!1,$=E+1);return $===-1?"":t.slice(L,$)},extname(t){a(t,"path");let c=0,L=-1,$=0,D=-1,E=!0,w=0;t.length>=2&&t.charCodeAt(1)===p&&s(t.charCodeAt(0))&&(c=$=2);for(let F=t.length-1;F>=c;--F){const Z=t.charCodeAt(F);if(f(Z)){if(!E){$=F+1;break}continue}D===-1&&(E=!1,D=F+1),Z===P?L===-1?L=F:w!==1&&(w=1):L!==-1&&(w=-1)}return L===-1||D===-1||w===0||w===1&&L===D-1&&L===$+1?"":t.slice(L,D)},format:v.bind(null,"\\"),parse(t){a(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const L=t.length;let $=0,D=t.charCodeAt(0);if(L===1)return f(D)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(f(D)){if($=1,f(t.charCodeAt(1))){let g=2,O=g;for(;g<L&&!f(t.charCodeAt(g));)g++;if(g<L&&g!==O){for(O=g;g<L&&f(t.charCodeAt(g));)g++;if(g<L&&g!==O){for(O=g;g<L&&!f(t.charCodeAt(g));)g++;g===L?$=g:g!==O&&($=g+1)}}}}else if(s(D)&&t.charCodeAt(1)===p){if(L<=2)return c.root=c.dir=t,c;if($=2,f(t.charCodeAt(2))){if(L===3)return c.root=c.dir=t,c;$=3}}$>0&&(c.root=t.slice(0,$));let E=-1,w=$,F=-1,Z=!0,T=t.length-1,R=0;for(;T>=$;--T){if(D=t.charCodeAt(T),f(D)){if(!Z){w=T+1;break}continue}F===-1&&(Z=!1,F=T+1),D===P?E===-1?E=T:R!==1&&(R=1):E!==-1&&(R=-1)}return F!==-1&&(E===-1||R===0||R===1&&E===F-1&&E===w+1?c.base=c.name=t.slice(w,F):(c.name=t.slice(w,E),c.base=t.slice(w,F),c.ext=t.slice(E,F))),w>0&&w!==$?c.dir=t.slice(0,w-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(m){const t=/\\/g;return()=>{const c=y.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>y.cwd()})();e.$hc={resolve(...t){let c="",L=!1;for(let $=t.length-1;$>=-1&&!L;$--){const D=$>=0?t[$]:i();a(D,"path"),D.length!==0&&(c=`${D}/${c}`,L=D.charCodeAt(0)===l)}return c=d(c,!L,"/",n),L?`/${c}`:c.length>0?c:"."},normalize(t){if(a(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===l,L=t.charCodeAt(t.length-1)===l;return t=d(t,!c,"/",n),t.length===0?c?"/":L?"./":".":(L&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return a(t,"path"),t.length>0&&t.charCodeAt(0)===l},join(...t){if(t.length===0)return".";let c;for(let L=0;L<t.length;++L){const $=t[L];a($,"path"),$.length>0&&(c===void 0?c=$:c+=`/${$}`)}return c===void 0?".":e.$hc.normalize(c)},relative(t,c){if(a(t,"from"),a(c,"to"),t===c||(t=e.$hc.resolve(t),c=e.$hc.resolve(c),t===c))return"";const L=1,$=t.length,D=$-L,E=1,w=c.length-E,F=D<w?D:w;let Z=-1,T=0;for(;T<F;T++){const g=t.charCodeAt(L+T);if(g!==c.charCodeAt(E+T))break;g===l&&(Z=T)}if(T===F)if(w>F){if(c.charCodeAt(E+T)===l)return c.slice(E+T+1);if(T===0)return c.slice(E+T)}else D>F&&(t.charCodeAt(L+T)===l?Z=T:T===0&&(Z=0));let R="";for(T=L+Z+1;T<=$;++T)(T===$||t.charCodeAt(T)===l)&&(R+=R.length===0?"..":"/..");return`${R}${c.slice(E+Z)}`},toNamespacedPath(t){return t},dirname(t){if(a(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===l;let L=-1,$=!0;for(let D=t.length-1;D>=1;--D)if(t.charCodeAt(D)===l){if(!$){L=D;break}}else $=!1;return L===-1?c?"/":".":c&&L===1?"//":t.slice(0,L)},basename(t,c){c!==void 0&&a(c,"ext"),a(t,"path");let L=0,$=-1,D=!0,E;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let w=c.length-1,F=-1;for(E=t.length-1;E>=0;--E){const Z=t.charCodeAt(E);if(Z===l){if(!D){L=E+1;break}}else F===-1&&(D=!1,F=E+1),w>=0&&(Z===c.charCodeAt(w)?--w===-1&&($=E):(w=-1,$=F))}return L===$?$=F:$===-1&&($=t.length),t.slice(L,$)}for(E=t.length-1;E>=0;--E)if(t.charCodeAt(E)===l){if(!D){L=E+1;break}}else $===-1&&(D=!1,$=E+1);return $===-1?"":t.slice(L,$)},extname(t){a(t,"path");let c=-1,L=0,$=-1,D=!0,E=0;for(let w=t.length-1;w>=0;--w){const F=t.charCodeAt(w);if(F===l){if(!D){L=w+1;break}continue}$===-1&&(D=!1,$=w+1),F===P?c===-1?c=w:E!==1&&(E=1):c!==-1&&(E=-1)}return c===-1||$===-1||E===0||E===1&&c===$-1&&c===L+1?"":t.slice(c,$)},format:v.bind(null,"/"),parse(t){a(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const L=t.charCodeAt(0)===l;let $;L?(c.root="/",$=1):$=0;let D=-1,E=0,w=-1,F=!0,Z=t.length-1,T=0;for(;Z>=$;--Z){const R=t.charCodeAt(Z);if(R===l){if(!F){E=Z+1;break}continue}w===-1&&(F=!1,w=Z+1),R===P?D===-1?D=Z:T!==1&&(T=1):D!==-1&&(T=-1)}if(w!==-1){const R=E===0&&L?1:E;D===-1||T===0||T===1&&D===w-1&&D===E+1?c.base=c.name=t.slice(R,w):(c.name=t.slice(R,D),c.base=t.slice(R,w),c.ext=t.slice(D,w))}return E>0?c.dir=t.slice(0,E-1):L&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=m?e.$gc.normalize:e.$hc.normalize,e.$jc=m?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=m?e.$gc.join:e.$hc.join,e.$lc=m?e.$gc.resolve:e.$hc.resolve,e.$mc=m?e.$gc.relative:e.$hc.relative,e.$nc=m?e.$gc.dirname:e.$hc.dirname,e.$oc=m?e.$gc.basename:e.$hc.basename,e.$pc=m?e.$gc.extname:e.$hc.extname,e.$qc=m?e.$gc.format:e.$hc.format,e.$rc=m?e.$gc.parse:e.$hc.parse,e.$sc=m?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=m?e.$gc.sep:e.$hc.sep,e.$uc=m?e.$gc.delimiter:e.$hc.delimiter}),define(fe[32],ge([0,1,5,3,12,9]),function(ae,e,y,S,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=j,e.$pg=P,e.$qg=l,e.$rg=r,e.$sg=p,e.$tg=a,e.$ug=m,e.$vg=f,e.$wg=n,e.$xg=s,e.$yg=d,e.$zg=v,e.$Ag=i,e.$Bg=t,e.$Cg=c,e.$Dg=L,e.$Eg=E;function j(w){return w===47||w===92}function P(w){return w.replace(/[\\/]/g,y.$hc.sep)}function l(w){return w.indexOf("/")===-1&&(w=P(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function r(w,F=y.$hc.sep){if(!w)return"";const Z=w.length,T=w.charCodeAt(0);if(j(T)){if(j(w.charCodeAt(1))&&!j(w.charCodeAt(2))){let g=3;const O=g;for(;g<Z&&!j(w.charCodeAt(g));g++);if(O!==g&&!j(w.charCodeAt(g+1))){for(g+=1;g<Z;g++)if(j(w.charCodeAt(g)))return w.slice(0,g+1).replace(/[\\/]/g,F)}}return F}else if(n(T)&&w.charCodeAt(1)===58)return j(w.charCodeAt(2))?w.slice(0,2)+F:w.slice(0,2);let R=w.indexOf("://");if(R!==-1){for(R+=3;R<Z;R++)if(j(w.charCodeAt(R)))return w.slice(0,R+1)}return""}function p(w){if(!S.$i||!w||w.length<5)return!1;let F=w.charCodeAt(0);if(F!==92||(F=w.charCodeAt(1),F!==92))return!1;let Z=2;const T=Z;for(;Z<w.length&&(F=w.charCodeAt(Z),F!==92);Z++);return!(T===Z||(F=w.charCodeAt(Z+1),isNaN(F)||F===92))}const u=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(w,F=S.$i){const Z=F?u:k;return!(!w||w.length===0||/^\s+$/.test(w)||(Z.lastIndex=0,Z.test(w))||F&&o.test(w)||w==="."||w===".."||F&&w[w.length-1]==="."||F&&w.length!==w.trim().length||w.length>255)}function m(w,F,Z){const T=w===F;return!Z||T?T:!w||!F?!1:(0,C.$yf)(w,F)}function f(w,F,Z,T=y.sep){if(w===F)return!0;if(!w||!F||F.length>w.length)return!1;if(Z){if(!(0,C.$zf)(w,F))return!1;if(F.length===w.length)return!0;let g=F.length;return F.charAt(F.length-1)===T&&g--,w.charAt(g)===T}return F.charAt(F.length-1)!==T&&(F+=T),w.indexOf(F)===0}function n(w){return w>=65&&w<=90||w>=97&&w<=122}function s(w,F){return S.$i&&w.endsWith(":")&&(w+=y.sep),(0,y.$jc)(w)||(w=(0,y.$kc)(F,w)),w=(0,y.$ic)(w),d(w)}function d(w){return S.$i?(w=(0,C.$gf)(w,y.sep),w.endsWith(":")&&(w+=y.sep)):(w=(0,C.$gf)(w,y.sep),w||(w=y.sep)),w}function v(w){const F=(0,y.$ic)(w);return S.$i?w.length>3?!1:i(F)&&(w.length===2||F.charCodeAt(2)===92):F===y.$hc.sep}function i(w,F=S.$i){return F?n(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}function t(w,F=S.$i){return i(w,F)?w[0]:void 0}function c(w,F,Z){return F.length>w.length?-1:w===F?0:(Z&&(w=w.toLowerCase(),F=F.toLowerCase()),w.indexOf(F))}function L(w){const F=w.split(":");let Z,T,R;for(const g of F){const O=Number(g);(0,M.$ag)(O)?T===void 0?T=O:R===void 0&&(R=O):Z=Z?[Z,g].join(":"):g}if(!Z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:Z,line:T!==void 0?T:void 0,column:R!==void 0?R:T!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",D="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(w,F,Z=8){let T="";for(let g=0;g<Z;g++){let O;g===0&&S.$i&&!F&&(Z===3||Z===4)?O=D:O=$,T+=O.charAt(Math.floor(Math.random()*O.length))}let R;return F?R=`${F}-${T}`:R=T,w?(0,y.$kc)(w,R):R}}),define(fe[33],ge([0,1,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=M,e.$nm=j;var S;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(S||(e.Source=S={}));var C;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function M(P,...l){const r=l.reduce((k,o)=>(k[o]=!0,k),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(k=>!r[k]).forEach(k=>{for(let o=0;o<p.length;o++)if(k.search(p[o])!==-1){delete P[k];break}})}function j(P){P&&(delete P.DEBUG,y.$j&&delete P.DYLD_LIBRARY_PATH,y.$k&&delete P.LD_PRELOAD)}}),define(fe[6],ge([0,1,5,3]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=a,e.$xc=v;const C=/^\w[\w\d+.-]*$/,M=/^\//,j=/^\/\//;function P($,D){if(!$.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${$.authority}", path: "${$.path}", query: "${$.query}", fragment: "${$.fragment}"}`);if($.scheme&&!C.test($.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if($.path){if($.authority){if(!M.test($.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test($.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l($,D){return!$&&!D?"file":$}function r($,D){switch($){case"https":case"http":case"file":D?D[0]!==u&&(D=u+D):D=u;break}return D}const p="",u="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(D){return D instanceof o?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,E,w,F,Z,T=!1){typeof D=="object"?(this.scheme=D.scheme||p,this.authority=D.authority||p,this.path=D.path||p,this.query=D.query||p,this.fragment=D.fragment||p):(this.scheme=l(D,T),this.authority=E||p,this.path=r(this.scheme,w||p),this.query=F||p,this.fragment=Z||p,P(this,T))}get fsPath(){return v(this,!1)}with(D){if(!D)return this;let{scheme:E,authority:w,path:F,query:Z,fragment:T}=D;return E===void 0?E=this.scheme:E===null&&(E=p),w===void 0?w=this.authority:w===null&&(w=p),F===void 0?F=this.path:F===null&&(F=p),Z===void 0?Z=this.query:Z===null&&(Z=p),T===void 0?T=this.fragment:T===null&&(T=p),E===this.scheme&&w===this.authority&&F===this.path&&Z===this.query&&T===this.fragment?this:new f(E,w,F,Z,T)}static parse(D,E=!1){const w=k.exec(D);return w?new f(w[2]||p,L(w[4]||p),L(w[5]||p),L(w[7]||p),L(w[9]||p),E):new f(p,p,p,p,p)}static file(D){let E=p;if(S.$i&&(D=D.replace(/\\/g,u)),D[0]===u&&D[1]===u){const w=D.indexOf(u,2);w===-1?(E=D.substring(2),D=u):(E=D.substring(2,w),D=D.substring(w)||u)}return new f("file",E,D,p,p)}static from(D,E){return new f(D.scheme,D.authority,D.path,D.query,D.fragment,E)}static joinPath(D,...E){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return S.$i&&D.scheme==="file"?w=o.file(y.$gc.join(v(D,!0),...E)).path:w=y.$hc.join(D.path,...E),D.with({path:w})}toString(D=!1){return i(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof o)return D;{const E=new f(D);return E._formatted=D.external??null,E._fsPath=D._sep===m?D.fsPath??null:null,E}}else return D}}e.URI=o;function a($){return!$||typeof $!="object"?!1:typeof $.scheme=="string"&&(typeof $.authority=="string"||typeof $.authority>"u")&&(typeof $.path=="string"||typeof $.path>"u")&&(typeof $.query=="string"||typeof $.query>"u")&&(typeof $.fragment=="string"||typeof $.fragment>"u")}const m=S.$i?1:void 0;class f extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(D=!1){return D?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const D={$mid:1};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=m),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const n={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function s($,D,E){let w,F=-1;for(let Z=0;Z<$.length;Z++){const T=$.charCodeAt(Z);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||D&&T===47||E&&T===91||E&&T===93||E&&T===58)F!==-1&&(w+=encodeURIComponent($.substring(F,Z)),F=-1),w!==void 0&&(w+=$.charAt(Z));else{w===void 0&&(w=$.substr(0,Z));const R=n[T];R!==void 0?(F!==-1&&(w+=encodeURIComponent($.substring(F,Z)),F=-1),w+=R):F===-1&&(F=Z)}}return F!==-1&&(w+=encodeURIComponent($.substring(F))),w!==void 0?w:$}function d($){let D;for(let E=0;E<$.length;E++){const w=$.charCodeAt(E);w===35||w===63?(D===void 0&&(D=$.substr(0,E)),D+=n[w]):D!==void 0&&(D+=$[E])}return D!==void 0?D:$}function v($,D){let E;return $.authority&&$.path.length>1&&$.scheme==="file"?E=`//${$.authority}${$.path}`:$.path.charCodeAt(0)===47&&($.path.charCodeAt(1)>=65&&$.path.charCodeAt(1)<=90||$.path.charCodeAt(1)>=97&&$.path.charCodeAt(1)<=122)&&$.path.charCodeAt(2)===58?D?E=$.path.substr(1):E=$.path[1].toLowerCase()+$.path.substr(2):E=$.path,S.$i&&(E=E.replace(/\//g,"\\")),E}function i($,D){const E=D?d:s;let w="",{scheme:F,authority:Z,path:T,query:R,fragment:g}=$;if(F&&(w+=F,w+=":"),(Z||F==="file")&&(w+=u,w+=u),Z){let O=Z.indexOf("@");if(O!==-1){const b=Z.substr(0,O);Z=Z.substr(O+1),O=b.lastIndexOf(":"),O===-1?w+=E(b,!1,!1):(w+=E(b.substr(0,O),!1,!1),w+=":",w+=E(b.substr(O+1),!1,!0)),w+="@"}Z=Z.toLowerCase(),O=Z.lastIndexOf(":"),O===-1?w+=E(Z,!1,!0):(w+=E(Z.substr(0,O),!1,!0),w+=Z.substr(O))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const O=T.charCodeAt(1);O>=65&&O<=90&&(T=`/${String.fromCharCode(O+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const O=T.charCodeAt(0);O>=65&&O<=90&&(T=`${String.fromCharCode(O+32)}:${T.substr(2)}`)}w+=E(T,!0,!1)}return R&&(w+="?",w+=E(R,!1,!1)),g&&(w+="#",w+=D?g:s(g,!1,!1)),w}function t($){try{return decodeURIComponent($)}catch{return $.length>3?$.substr(0,3)+t($.substr(3)):$}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L($){return $.match(c)?$.replace(c,D=>t(D)):$}}),define(fe[58],ge([0,1,6]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=S,e.$Wq=C,e.$Xq=M,e.log=P;function S(r){const p=r;return p&&typeof p.type=="string"&&typeof p.severity=="string"}function C(r){const p=[];let u;try{const k=JSON.parse(r.arguments),o=k[k.length-1];o&&o.__$stack&&(k.pop(),u=o.__$stack),p.push(...k)}catch{p.push("Unable to log remote console arguments",r.arguments)}return{args:p,stack:u}}function M(r){if(typeof r!="string")return M(C(r).stack);const p=r;if(p){const u=j(p),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(k&&k.length===4)return{uri:y.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}function j(r){if(!r)return r;const p=r.indexOf(`
`);return p===-1?r:r.substring(0,p)}function P(r,p){const{args:u,stack:k}=C(r),o=typeof u[0]=="string"&&u.length===1;let a=j(k);a&&(a=`(${a.trim()})`);let m=[];if(typeof u[0]=="string"?a&&o?m=[`%c[${p}] %c${u[0]} %c${a}`,l("blue"),l(""),l("grey")]:m=[`%c[${p}] %c${u[0]}`,l("blue"),l(""),...u.slice(1)]:m=[`%c[${p}]%`,l("blue"),...u],a&&!o&&m.push(a),typeof console[r.severity]!="function")throw new Error("Unknown console method");console[r.severity].apply(console,m)}function l(r){return`color: ${r}`}}),define(fe[59],ge([0,1,18,6]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=C,e.$5h=M,e.$6h=P;function C(l){return JSON.stringify(l,j)}function M(l){let r=JSON.parse(l);return r=P(r),r}function j(l,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:r.flags}:r}function P(l,r=0){if(!l||r>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return S.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 17:return new Date(l.source)}if(l instanceof y.$Ge||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let p=0;p<l.length;++p)l[p]=P(l[p],r+1);else for(const p in l)Object.hasOwnProperty.call(l,p)&&(l[p]=P(l[p],r+1))}return l}}),define(fe[19],ge([0,1,7,3,12,6,5]),function(ae,e,y,S,C,M,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=l,e.$Gg=r,e.$Kg=u;var P;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(P||(e.Schemas=P={}));function l(a,m){return M.URI.isUri(a)?(0,C.$yf)(a.scheme,m):(0,C.$zf)(a,m+":")}function r(a,...m){return m.some(f=>l(a,f))}e.$Hg="vscode-tkn",e.$Ig="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m,f){this.f=u(m,f)}getServerRootPath(){return this.f}get g(){return j.$hc.join(this.f,P.vscodeRemoteResource)}set(m,f,n){this.a[m]=f,this.b[m]=n}setConnectionToken(m,f){this.c[m]=f}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(i){return y.$1(i),m}const f=m.authority;let n=this.a[f];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const s=this.b[f],d=this.c[f];let v=`path=${encodeURIComponent(m.path)}`;return typeof d=="string"&&(v+=`&${e.$Ig}=${encodeURIComponent(d)}`),M.URI.from({scheme:S.$o?this.d:P.vscodeRemoteResource,authority:`${n}:${s}`,path:this.g,query:v})}}e.$Jg=new p;function u(a,m){return j.$hc.join(m??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class k{static{this.a=e.$Pg}asBrowserUri(m){const f=this.b(m,ae);return this.uriToBrowserUri(f)}uriToBrowserUri(m){return m.scheme===P.vscodeRemote?e.$Jg.rewrite(m):m.scheme===P.file&&(S.$m||S.$q===`${P.vscodeFileResource}://${k.a}`)?m.with({scheme:P.vscodeFileResource,authority:m.authority||k.a,query:null,fragment:null}):m}asFileUri(m){const f=this.b(m,ae);return this.uriToFileUri(f)}uriToFileUri(m){return m.scheme===P.vscodeFileResource?m.with({scheme:P.file,authority:m.authority!==k.a?m.authority:null,query:null,fragment:null}):m}b(m,f){return M.URI.isUri(m)?m:M.URI.parse(f.toUrl(m))}}e.$Qg=new k;var o;(function(a){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(m.get("3"));const f="vscode-coi";function n(d){let v;typeof d=="string"?v=new URL(d).searchParams:d instanceof URL?v=d.searchParams:M.URI.isUri(d)&&(v=new URL(d.toString(!0)).searchParams);const i=v?.get(f);if(i)return m.get(i)}a.getHeadersFromQuery=n;function s(d,v,i){if(!globalThis.crossOriginIsolated)return;const t=v&&i?"3":i?"2":"1";d instanceof URLSearchParams?d.set(f,t):d[f]=t}a.addSearchParam=s})(o||(e.COI=o={}))}),define(fe[23],ge([0,1,32,19,5,3,12,6]),function(ae,e,y,S,C,M,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=l,e.$gh=p,e.$hh=k;function l(o){return(0,P.$xc)(o,!0)}class r{constructor(a){this.a=a}compare(a,m,f=!1){return a===m?0:(0,j.$rf)(this.getComparisonKey(a,f),this.getComparisonKey(m,f))}isEqual(a,m,f=!1){return a===m?!0:!a||!m?!1:this.getComparisonKey(a,f)===this.getComparisonKey(m,f)}getComparisonKey(a,m=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,m,f=!1){if(a.scheme===m.scheme){if(a.scheme===S.Schemas.file)return y.$vg(l(a),l(m),this.a(a))&&a.query===m.query&&(f||a.fragment===m.fragment);if((0,e.$ch)(a.authority,m.authority))return y.$vg(a.path,m.path,this.a(a),"/")&&a.query===m.query&&(f||a.fragment===m.fragment)}return!1}joinPath(a,...m){return P.URI.joinPath(a,...m)}basenameOrAuthority(a){return(0,e.$7g)(a)||a.authority}basename(a){return C.$hc.basename(a.path)}extname(a){return C.$hc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let m;return a.scheme===S.Schemas.file?m=P.URI.file(C.$nc(l(a))).path:(m=C.$hc.dirname(a.path),a.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),m="/")),a.with({path:m})}normalizePath(a){if(!a.path.length)return a;let m;return a.scheme===S.Schemas.file?m=P.URI.file(C.$ic(l(a))).path:m=C.$hc.normalize(a.path),a.with({path:m})}relativePath(a,m){if(a.scheme!==m.scheme||!(0,e.$ch)(a.authority,m.authority))return;if(a.scheme===S.Schemas.file){const s=C.$mc(l(a),l(m));return M.$i?y.$pg(s):s}let f=a.path||"/";const n=m.path||"/";if(this.a(a)){let s=0;for(const d=Math.min(f.length,n.length);s<d&&!(f.charCodeAt(s)!==n.charCodeAt(s)&&f.charAt(s).toLowerCase()!==n.charAt(s).toLowerCase());s++);f=n.substr(0,s)+f.substr(s)}return C.$hc.relative(f,n)}resolvePath(a,m){if(a.scheme===S.Schemas.file){const f=P.URI.file(C.$lc(l(a),m));return a.with({authority:f.authority,path:f.path})}return m=y.$qg(m),a.with({path:C.$hc.resolve(a.path,m)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,m){return a===m||a!==void 0&&m!==void 0&&(0,j.$yf)(a,m)}hasTrailingPathSeparator(a,m=C.sep){if(a.scheme===S.Schemas.file){const f=l(a);return f.length>y.$rg(f).length&&f[f.length-1]===m}else{const f=a.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,m=C.sep){return(0,e.$dh)(a,m)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,m=C.sep){let f=!1;if(a.scheme===S.Schemas.file){const n=l(a);f=n!==void 0&&n.length===y.$rg(n).length&&n[n.length-1]===m}else{m="/";const n=a.path;f=n.length===1&&n.charCodeAt(n.length-1)===47}return!f&&!(0,e.$dh)(a,m)?a.with({path:a.path+"/"}):a}}e.$Yg=r,e.$Zg=new r(()=>!1),e.$1g=new r(o=>o.scheme===S.Schemas.file?!M.$k:!0),e.$2g=new r(o=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function p(o,a){const m=[];for(let f=0;f<o.length;f++){const n=a(o[f]);o.some((s,d)=>d===f?!1:(0,e.$4g)(n,a(s)))||m.push(o[f])}return m}var u;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function a(m){const f=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(d=>{const[v,i]=d.split(":");v&&i&&f.set(v,i)});const s=m.path.substring(0,m.path.indexOf(";"));return s&&f.set(o.META_DATA_MIME,s),f}o.parseMetaData=a})(u||(e.DataUri=u={}));function k(o,a,m){if(a){let f=o.path;return f&&f[0]!==C.$hc.sep&&(f=C.$hc.sep+f),o.with({scheme:m,authority:a,path:f})}return o.with({scheme:m})}}),define(fe[11],ge([0,1,17,7,4,2,23,3,50,22]),function(ae,e,y,S,C,M,j,P,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=p,e.$jh=u,e.$kh=k,e.$lh=o,e.$mh=a,e.$nh=m,e.$oh=f,e.$ph=n,e.$xh=E,e.$yh=w,e.$zh=F,e.$Ah=Z,e.$Bh=T,e.$Qh=q,e.$Yh=H;function p(z){return!!z&&typeof z.then=="function"}function u(z){const I=new y.$pe,V=z(I.token),_=new Promise((se,re)=>{const le=I.token.onCancellationRequested(()=>{le.dispose(),re(new S.$5)});Promise.resolve(V).then($e=>{le.dispose(),I.dispose(),se($e)},$e=>{le.dispose(),I.dispose(),re($e)})});return new class{cancel(){I.cancel(),I.dispose()}then(se,re){return _.then(se,re)}catch(se){return this.then(void 0,se)}finally(se){return _.finally(se)}}}function k(z,I,V){return new Promise((_,se)=>{const re=I.onCancellationRequested(()=>{re.dispose(),_(V)});z.then(_,se).finally(()=>re.dispose())})}function o(z,I){return new Promise((V,_)=>{const se=I.onCancellationRequested(()=>{se.dispose(),_(new S.$5)});z.then(V,_).finally(()=>se.dispose())})}async function a(z){let I=-1;const V=z.map((_,se)=>_.then(re=>(I=se,re)));try{return await Promise.race(V)}finally{z.forEach((_,se)=>{se!==I&&_.cancel()})}}function m(z,I,V){let _;const se=setTimeout(()=>{_?.(void 0),V?.()},I);return Promise.race([z.finally(()=>clearTimeout(se)),new Promise(re=>_=re)])}function f(z){return new Promise((I,V)=>{const _=z();p(_)?_.then(I,V):I(_)})}function n(){let z,I;return{promise:new Promise((_,se)=>{z=_,I=se}),resolve:z,reject:I}}class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(I){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=I,!this.b){const V=()=>{if(this.b=null,this.f)return;const _=this.queue(this.d);return this.d=null,_};this.b=new Promise(_=>{this.a.then(V,V).then(_)})}return new Promise((V,_)=>{this.b.then(V,_)})}return this.a=I(),new Promise((V,_)=>{this.a.then(se=>{this.a=null,V(se)},se=>{this.a=null,_(se)})})}dispose(){this.f=!0}}e.$qh=s;class d{constructor(){this.a=Promise.resolve(null)}queue(I){return this.a=this.a.then(()=>I(),()=>I())}}e.$rh=d;class v{constructor(){this.a=new Map}queue(I,V){const se=(this.a.get(I)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.a.get(I)===se&&this.a.delete(I)});return this.a.set(I,se),se}}e.$sh=v;const i=(z,I)=>{let V=!0;const _=setTimeout(()=>{V=!1,I()},z);return{isTriggered:()=>V,dispose:()=>{clearTimeout(_),V=!1}}},t=z=>{let I=!0;return queueMicrotask(()=>{I&&(I=!1,z())}),{isTriggered:()=>I,dispose:()=>{I=!1}}};class c{constructor(I){this.defaultDelay=I,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(I,V=this.defaultDelay){this.g=I,this.h(),this.b||(this.b=new Promise((se,re)=>{this.d=se,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const se=this.g;return this.g=null,se()}}));const _=()=>{this.a=null,this.d?.(null)};return this.a=V===l.$be?t(_):i(V,_),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=c;class L{constructor(I){this.a=new c(I),this.b=new s}trigger(I,V){return this.a.trigger(()=>this.b.queue(I),V)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=L;class ${constructor(){this.a=!1,this.b=new Promise((I,V)=>{this.d=I})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=$;class D extends ${constructor(I){super(),this.f=setTimeout(()=>this.open(),I)}open(){clearTimeout(this.f),super.open()}}e.$wh=D;function E(z,I){return I?new Promise((V,_)=>{const se=setTimeout(()=>{re.dispose(),V()},z),re=I.onCancellationRequested(()=>{clearTimeout(se),re.dispose(),_(new S.$5)})}):u(V=>E(z,V))}function w(z,I=0,V){const _=setTimeout(()=>{z(),V&&se.dispose()},I),se=(0,M.$Tc)(()=>{clearTimeout(_),V?.deleteAndLeak(se)});return V?.add(se),se}function F(z){const I=[];let V=0;const _=z.length;function se(){return V<_?z[V++]():null}function re(le){le!=null&&I.push(le);const $e=se();return $e?$e.then(re):Promise.resolve(I)}return Promise.resolve(null).then(re)}function Z(z,I=_=>!!_,V=null){let _=0;const se=z.length,re=()=>{if(_>=se)return Promise.resolve(V);const le=z[_++];return Promise.resolve(le()).then(be=>I(be)?Promise.resolve(be):re())};return re()}function T(z,I=_=>!!_,V=null){if(z.length===0)return Promise.resolve(V);let _=z.length;const se=()=>{_=-1;for(const re of z)re.cancel?.()};return new Promise((re,le)=>{for(const $e of z)$e.then(be=>{--_>=0&&I(be)?(se(),re(be)):_===0&&re(V)}).catch(be=>{--_>=0&&(se(),le(be))})})}class R{constructor(I){this.a=0,this.b=!1,this.f=I,this.g=[],this.d=0,this.h=new C.$ee}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(I){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((V,_)=>{this.g.push({factory:I,c:V,e:_}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const I=this.g.shift();this.d++;const V=I.factory();V.then(I.c,I.e),V.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=R;class g extends R{constructor(){super(1)}}e.$Dh=g;class O{constructor(){this.a=new J,this.b=0}queue(I){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,I())):this.a.run(this.b++,I())}}e.$Eh=O;class b{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const I=new B;return this.b.add(I),I.p}g(){for(const[,I]of this.a)if(I.size>0)return!1;return!0}queueSize(I,V=j.$Zg){const _=V.getComparisonKey(I);return this.a.get(_)?.size??0}queueFor(I,V,_=j.$Zg){const se=_.getComparisonKey(I);let re=this.a.get(se);if(!re){re=new g;const le=this.f++,$e=C.Event.once(re.onDrained)(()=>{re?.dispose(),this.a.delete(se),this.h(),this.d?.deleteAndDispose(le),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$5c),this.d.set(le,$e),this.a.set(se,re)}return re.queue(V)}h(){this.g()&&this.j()}j(){for(const I of this.b)I.complete();this.b.clear()}dispose(){for(const[,I]of this.a)I.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=b;class A{constructor(I,V){this.a=-1,typeof I=="function"&&typeof V=="number"&&this.setIfNotSet(I,V)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(I,V){this.cancel(),this.a=setTimeout(()=>{this.a=-1,I()},V)}setIfNotSet(I,V){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,I()},V))}}e.$Gh=A;class Y{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(I,V,_=globalThis){this.cancel();const se=_.setInterval(()=>{I()},V);this.d=(0,M.$Tc)(()=>{_.clearInterval(se),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=Y;class te{constructor(I,V){this.b=-1,this.a=I,this.d=V,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(I=this.d){this.cancel(),this.b=setTimeout(this.f,I)}get delay(){return this.d}set delay(I){this.d=I}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=te;class G{constructor(I,V){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.a=I,this.b=V,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(I=this.b){I%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${I}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(I/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=G;class ee extends te{constructor(I,V){super(I,V),this.j=[]}work(I){this.j.push(I),this.isScheduled()||this.schedule()}h(){const I=this.j;this.j=[],this.a?.(I)}dispose(){this.j=[],super.dispose()}}e.$Kh=ee;class ce extends M.$Vc{constructor(I,V){super(),this.g=I,this.h=V,this.a=[],this.b=this.B(new M.$Wc),this.f=!1}get pending(){return this.a.length}work(I){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+I.length>this.g.maxBufferedWork)return!1}else if(this.pending+I.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const V of I)this.a.push(V);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=ce,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(z,I)=>{(0,P.$B)(()=>{if(V)return;const _=Date.now()+15;I(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.$Nh=(z,I,V)=>{const _=z.requestIdleCallback(I,typeof V=="number"?{timeout:V}:void 0);let se=!1;return{dispose(){se||(se=!0,z.cancelIdleCallback(_))}}},e.$Mh=z=>(0,e.$Nh)(globalThis,z)}();class he{constructor(I,V){this.g=!1,this.d=()=>{try{this.j=V()}catch(_){this.l=_}finally{this.g=!0}},this.f=(0,e.$Nh)(I,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=he;class X extends he{constructor(I){super(globalThis,I)}}e.$Ph=X;async function q(z,I,V){let _;for(let se=0;se<V;se++)try{return await z()}catch(re){_=re,await E(I)}throw _}class J{isRunning(I){return typeof I=="number"?this.a?.taskId===I:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(I,V,_){return this.a={taskId:I,cancel:()=>_?.(),promise:V},V.then(()=>this.d(I),()=>this.d(I)),V}d(I){this.a&&I===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const I=this.b;this.b=void 0,I.run().then(I.promiseResolve,I.promiseReject)}}queue(I){if(this.b)this.b.run=I;else{const{promise:V,resolve:_,reject:se}=n();this.b={run:I,promise:V,promiseResolve:_,promiseReject:se}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=J;class K{constructor(I,V=()=>Date.now()){this.d=I,this.f=V,this.a=0,this.b=0}increment(){const I=this.f();return I-this.a>this.d&&(this.a=I,this.b=0),this.b++,this.b}}e.$Sh=K;var de;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(de||(de={}));class B{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((I,V)=>{this.a=I,this.b=V})}complete(I){return new Promise(V=>{this.a(I),this.d={outcome:0,value:I},V()})}error(I){return new Promise(V=>{this.b(I),this.d={outcome:1,value:I},V()})}cancel(){return this.error(new S.$5)}}e.$Th=B;var ue;(function(z){async function I(_){let se;const re=await Promise.all(_.map(le=>le.then($e=>$e,$e=>{se||(se=$e)})));if(typeof se<"u")throw se;return re}z.settled=I;function V(_){return new Promise(async(se,re)=>{try{await _(se,re)}catch(le){re(le)}})}z.withAsyncBody=V})(ue||(e.Promises=ue={}));class x{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(I){this.a=void 0,this.b=void 0,this.d=!1,this.promise=I.then(V=>(this.a=V,this.d=!0,V),V=>{throw this.b=V,this.d=!0,V})}requireValue(){if(!this.d)throw new S.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=x;class h{constructor(I){this.b=I,this.a=new r.$V(()=>new x(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=h;var N;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(N||(N={}));class ie{static fromArray(I){return new ie(V=>{V.emitMany(I)})}static fromPromise(I){return new ie(async V=>{V.emitMany(await I)})}static fromPromises(I){return new ie(async V=>{await Promise.all(I.map(async _=>V.emitOne(await _)))})}static merge(I){return new ie(async V=>{await Promise.all(I.map(async _=>{for await(const se of _)V.emitOne(se)}))})}static{this.EMPTY=ie.fromArray([])}constructor(I,V){this.a=0,this.b=[],this.d=null,this.f=V,this.g=new C.$ee,queueMicrotask(async()=>{const _={emitOne:se=>this.h(se),emitMany:se=>this.j(se),reject:se=>this.l(se)};try{await Promise.resolve(I(_)),this.k()}catch(se){this.l(se)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let I=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(I<this.b.length)return{done:!1,value:this.b[I++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(I,V){return new ie(async _=>{for await(const se of I)_.emitOne(V(se))})}map(I){return ie.map(this,I)}static filter(I,V){return new ie(async _=>{for await(const se of I)V(se)&&_.emitOne(se)})}filter(I){return ie.filter(this,I)}static coalesce(I){return ie.filter(I,V=>!!V)}coalesce(){return ie.coalesce(this)}static async toPromise(I){const V=[];for await(const _ of I)V.push(_);return V}toPromise(){return ie.toPromise(this)}h(I){this.a===0&&(this.b.push(I),this.g.fire())}j(I){this.a===0&&(this.b=this.b.concat(I),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(I){this.a===0&&(this.a=2,this.d=I,this.g.fire())}}e.$Wh=ie;class ne extends ie{constructor(I,V){super(V),this.m=I}cancel(){this.m.cancel()}}e.$Xh=ne;function H(z){const I=new y.$pe,V=z(I.token);return new ne(I,async _=>{const se=I.token.onCancellationRequested(()=>{se.dispose(),I.dispose(),_.reject(new S.$5)});try{for await(const re of V){if(I.token.isCancellationRequested)return;_.emitOne(re)}se.dispose(),I.dispose()}catch(re){se.dispose(),I.dispose(),_.reject(re)}})}class W{constructor(I){this.a=new B,this.b=new ie(se=>{if(V){se.reject(V);return}return _&&se.emitMany(_),this.d=re=>se.reject(re),this.f=re=>se.emitOne(re),this.a.p},I);let V,_;this.f=se=>{_||(_=[]),_.push(se)},this.d=se=>{V||(V=se)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(I){this.d(I),this.a.complete()}emitOne(I){this.f(I)}}e.$Zh=W}),define(fe[60],ge([0,1,18,6]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=P,e.$Bn=r,e.$Cn=p;function C(u){return u.toJSON()}class M{constructor(k){this.a=k}transformIncoming(k){const o=this.a.transformIncoming(k);return o===k?k:C(S.URI.from(o))}transformOutgoing(k){const o=this.a.transformOutgoing(k);return o===k?k:C(S.URI.from(o))}transformOutgoingURI(k){const o=this.a.transformOutgoing(k);return o===k?k:S.URI.from(o)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$yn=M,e.$zn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function j(u,k,o){if(!u||o>200)return null;if(typeof u=="object"){if(u instanceof S.URI)return k.transformOutgoing(u);for(const a in u)if(Object.hasOwnProperty.call(u,a)){const m=j(u[a],k,o+1);m!==null&&(u[a]=m)}}return null}function P(u,k){const o=j(u,k,0);return o===null?u:o}function l(u,k,o,a){if(!u||a>200)return null;if(typeof u=="object"){if(u.$mid===1)return o?S.URI.revive(k.transformIncoming(u)):k.transformIncoming(u);if(u instanceof y.$Ge)return null;for(const m in u)if(Object.hasOwnProperty.call(u,m)){const f=l(u[m],k,o,a+1);f!==null&&(u[m]=f)}}return null}function r(u,k){const o=l(u,k,!1,0);return o===null?u:o}function p(u,k){const o=l(u,k,!0,0);return o===null?u:o}}),define(fe[24],ge([0,1,106,20,107,11,32,45,5,3,23,6]),function(ae,e,y,S,C,M,j,P,l,r,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=d,e.whenDeleted=t,e.configureFlushOnWrite=E,e.writeFileSync=F;var k;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(k||(e.RimRafMode=k={}));async function o(G,ee=k.UNLINK,ce){if((0,j.$zg)(G))throw new Error("rimraf - will refuse to recursively delete root");return ee===k.UNLINK?m(G):a(G,ce)}async function a(G,ee=(0,j.$Eg)((0,S.tmpdir)())){try{try{await y.promises.rename(G,ee)}catch(ce){return ce.code==="ENOENT"?void 0:m(G)}m(ee).catch(ce=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function m(G){return(0,C.promisify)(y.rm)(G,{recursive:!0,force:!0,maxRetries:3})}function f(G){if((0,j.$zg)(G))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function n(G,ee){return v(await(ee?s(G):(0,C.promisify)(y.readdir)(G)))}async function s(G){try{return await(0,C.promisify)(y.readdir)(G,{withFileTypes:!0})}catch(he){console.warn("[node.js fs] readdir with filetypes failed with error: ",he)}const ee=[],ce=await n(G);for(const he of ce){let X=!1,q=!1,J=!1;try{const K=await e.Promises.lstat((0,l.$kc)(G,he));X=K.isFile(),q=K.isDirectory(),J=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}ee.push({name:he,isFile:()=>X,isDirectory:()=>q,isSymbolicLink:()=>J})}return ee}function d(G){return v(y.readdirSync(G))}function v(G){return G.map(ee=>typeof ee=="string"?r.$j?(0,P.$bm)(ee):ee:(ee.name=r.$j?(0,P.$bm)(ee.name):ee.name,ee))}async function i(G){const ee=await n(G),ce=[];for(const he of ee)await c.existsDirectory((0,l.$kc)(G,he))&&ce.push(he);return ce}function t(G,ee=1e3){return new Promise(ce=>{let he=!1;const X=setInterval(()=>{he||(he=!0,y.access(G,q=>{he=!1,q&&(clearInterval(X),ce(void 0))}))},ee)})}var c;(function(G){async function ee(X){let q;try{if(q=await e.Promises.lstat(X),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(r.$i&&J.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw K}throw J}}G.stat=ee;async function ce(X){try{const{stat:q,symbolicLink:J}=await G.stat(X);return q.isFile()&&J?.dangling!==!0}catch{}return!1}G.existsFile=ce;async function he(X){try{const{stat:q,symbolicLink:J}=await G.stat(X);return q.isDirectory()&&J?.dangling!==!0}catch{}return!1}G.existsDirectory=he})(c||(e.SymlinkSupport=c={}));const L=new M.$Fh;function $(G,ee,ce){return L.queueFor(u.URI.file(G),()=>{const he=Z(ce);return new Promise((X,q)=>w(G,ee,he,J=>J?q(J):X()))},p.$1g)}let D=!0;function E(G){D=G}function w(G,ee,ce,he){if(!D)return y.writeFile(G,ee,{mode:ce.mode,flag:ce.flag},he);y.open(G,ce.flag,ce.mode,(X,q)=>{if(X)return he(X);y.writeFile(q,ee,J=>{if(J)return y.close(q,()=>he(J));y.fdatasync(q,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),E(!1)),y.close(q,de=>he(de))))})})}function F(G,ee,ce){const he=Z(ce);if(!D)return y.writeFileSync(G,ee,{mode:he.mode,flag:he.flag});const X=y.openSync(G,he.flag,he.mode);try{y.writeFileSync(X,ee);try{y.fdatasyncSync(X)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),E(!1)}}finally{y.closeSync(X)}}function Z(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function T(G,ee,ce=6e4){if(G!==ee)try{r.$i&&typeof ce=="number"?await R(G,ee,Date.now(),ce):await(0,C.promisify)(y.rename)(G,ee)}catch(he){if(G.toLowerCase()!==ee.toLowerCase()&&he.code==="EXDEV"||G.endsWith("."))await g(G,ee,{preserveSymlinks:!1}),await o(G,k.MOVE);else throw he}}async function R(G,ee,ce,he,X=0){try{return await(0,C.promisify)(y.rename)(G,ee)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-ce>=he)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${q}`),q;if(X===0){let J=!1;try{const{stat:K}=await c.stat(ee);K.isFile()||(J=!0)}catch{}if(J)throw q}return await(0,M.$xh)(Math.min(100,X*10)),R(G,ee,ce,he,X+1)}}async function g(G,ee,ce){return b(G,ee,{root:{source:G,target:ee},options:ce,handledSourcePaths:new Set})}const O=511;async function b(G,ee,ce){if(ce.handledSourcePaths.has(G))return;ce.handledSourcePaths.add(G);const{stat:he,symbolicLink:X}=await c.stat(G);if(X){if(ce.options.preserveSymlinks)try{return await te(G,ee,ce)}catch{}if(X.dangling)return}return he.isDirectory()?A(G,ee,he.mode&O,ce):Y(G,ee,he.mode&O)}async function A(G,ee,ce,he){await e.Promises.mkdir(ee,{recursive:!0,mode:ce});const X=await n(G);for(const q of X)await b((0,l.$kc)(G,q),(0,l.$kc)(ee,q),he)}async function Y(G,ee,ce){await e.Promises.copyFile(G,ee),await e.Promises.chmod(ee,ce)}async function te(G,ee,ce){let he=await e.Promises.readlink(G);(0,j.$vg)(he,ce.root.source,!r.$k)&&(he=(0,l.$kc)(ce.root.target,he.substr(ce.root.source.length+1))),await e.Promises.symlink(he,ee)}e.Promises=new class{get access(){return(0,C.promisify)(y.access)}get stat(){return(0,C.promisify)(y.stat)}get lstat(){return(0,C.promisify)(y.lstat)}get utimes(){return(0,C.promisify)(y.utimes)}get read(){return(G,ee,ce,he,X)=>new Promise((q,J)=>{y.read(G,ee,ce,he,X,(K,de,B)=>K?J(K):q({bytesRead:de,buffer:B}))})}get readFile(){return(0,C.promisify)(y.readFile)}get write(){return(G,ee,ce,he,X)=>new Promise((q,J)=>{y.write(G,ee,ce,he,X,(K,de,B)=>K?J(K):q({bytesWritten:de,buffer:B}))})}get appendFile(){return(0,C.promisify)(y.appendFile)}get fdatasync(){return(0,C.promisify)(y.fdatasync)}get truncate(){return(0,C.promisify)(y.truncate)}get copyFile(){return(0,C.promisify)(y.copyFile)}get open(){return(0,C.promisify)(y.open)}get close(){return(0,C.promisify)(y.close)}get symlink(){return(0,C.promisify)(y.symlink)}get readlink(){return(0,C.promisify)(y.readlink)}get chmod(){return(0,C.promisify)(y.chmod)}get mkdir(){return(0,C.promisify)(y.mkdir)}get unlink(){return(0,C.promisify)(y.unlink)}get rmdir(){return(0,C.promisify)(y.rmdir)}get realpath(){return(0,C.promisify)(y.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return n}get readDirsInDir(){return i}get writeFile(){return $}get rm(){return o}get rename(){return T}get copy(){return g}}}),define(fe[61],ge([0,1,20,5,24]),function(ae,e,y,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=s,e.$lm=d;const M=/^\d+$/,j=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var l;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(l||(l={}));let r;switch(process.arch){case"ia32":r=1;break;case"arm":case"arm64":r=2;break;default:r=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class u{constructor(i,t,c){this.exePath=i,this.displayName=t,this.a=c}async exists(){return this.a===void 0&&(this.a=await C.SymlinkSupport.existsFile(this.exePath)),this.a}}function k({useAlternateBitness:v=!1}={}){return v?r===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function o({useAlternateBitness:v=!1,findPreview:i=!1}={}){const t=k({useAlternateBitness:v});if(!t)return null;const c=S.$kc(t,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(c))return null;let L=-1,$=null;for(const w of await C.Promises.readdir(c)){let F=-1;if(i){const T=w.indexOf("-");if(T<0)continue;const R=w.substring(0,T);if(!M.test(R)||w.substring(T+1)!=="preview")continue;F=parseInt(R,10)}else{if(!M.test(w))continue;F=parseInt(w,10)}if(F<=L)continue;const Z=S.$kc(c,w,"pwsh.exe");await C.SymlinkSupport.existsFile(Z)&&($=Z,L=F)}if(!$)return null;const D=t.includes("x86")?" (x86)":"",E=i?" Preview":"";return new u($,`PowerShell${E}${D}`,!0)}async function a({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const i=S.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=v?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const L of await C.Promises.readdir(i))if(t.test(L)){const $=S.$kc(i,L,"pwsh.exe");return new u($,c)}return null}function m(){const v=S.$kc(y.homedir(),".dotnet","tools","pwsh.exe");return new u(v,".NET Core PowerShell Global Tool")}function f(){const v=S.$kc(process.env.windir,r===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(v,"Windows PowerShell",!0)}async function*n(){let v=await o();v&&(yield v),v=await o({useAlternateBitness:!0}),v&&(yield v),v=await a(),v&&(yield v),v=m(),v&&(yield v),v=await o({findPreview:!0}),v&&(yield v),v=await a({findPreview:!0}),v&&(yield v),v=await o({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=f(),v&&(yield v)}async function*s(){for await(const v of n())await v.exists()&&(yield v)}async function d(){for await(const v of s())return v;return null}}),define(fe[34],ge([0,1,5,3,15,33,9,24]),function(ae,e,y,S,C,M,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=l,e.$pm=r,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function l(u=C.env){return u.comspec||"cmd.exe"}function r(u){let k=[],o=!1;const a=function(m){if(o){k.push(m);return}(!u.send(m,n=>{if(n&&console.error(n),o=!1,k.length>0){const s=k.slice(0);k=[],s.forEach(d=>a(d))}})||S.$i)&&(o=!0)};return{send:a}}var p;(function(u){async function k(o,a,m){if(y.$jc(o))return o;if(a===void 0&&(a=C.cwd()),y.$nc(o)!=="."||(m===void 0&&j.$9f(C.env.PATH)&&(m=C.env.PATH.split(y.$uc)),m===void 0||m.length===0))return y.$kc(a,o);async function n(s){if(await P.Promises.exists(s)){let d;try{d=await P.Promises.stat(s)}catch(v){v.message.startsWith("EACCES")&&(d=await P.Promises.lstat(s))}return d?!d.isDirectory():!1}return!1}for(const s of m){let d;if(y.$jc(s)?d=y.$kc(s,o):d=y.$kc(a,s,o),await n(d))return d;let v=d+".com";if(await n(v)||(v=d+".exe",await n(v)))return v}return y.$kc(a,o)}u.findExecutable=k})(p||(e.win32=p={}))}),define(fe[62],ge([0,1,26,19]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=C;function C(j){return new Promise((P,l)=>{let r;const p=new Map;function u(o,a,m,f,n){const s=p.get(a);if(o===j||s){const d={name:k(m),cmd:m,pid:o,ppid:a,load:f,mem:n};p.set(o,d),o===j&&(r=d),s&&(s.children||(s.children=[]),s.children.push(d),s.children.length>1&&(s.children=s.children.sort((v,i)=>v.pid-i.pid)))}}function k(o){const a=/--utility-sub-type=network/i,m=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,n=/conhost\.exe.+--headless/i,s=/--type=([a-zA-Z-]+)/;if(m.exec(o))return"electron-crash-reporter";if(f.exec(o))return"winpty-agent";if(n.exec(o))return"conpty-agent";let d=s.exec(o);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?a.exec(o)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const v=/[a-zA-Z-]+\.js/g;let i="";do d=v.exec(o),d&&(i+=d+" ");while(d);return i&&o.indexOf("node ")<0&&o.indexOf("node.exe")<0?`electron-nodejs (${i})`:o}if(process.platform==="win32"){const o=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,m)=>{ae(["@vscode/windows-process-tree"],a,m)}).then(a=>{a.getProcessList(j,m=>{if(!m){l(new Error(`Root process ${j} not found`));return}a.getProcessCpuUsage(m,f=>{const n=new Map;f.forEach(s=>{const d=o(s.commandLine||"");n.set(s.pid,{name:k(d),cmd:d,pid:s.pid,ppid:s.ppid,load:s.cpu||0,mem:s.memory||0})}),r=n.get(j),r?(n.forEach(s=>{const d=n.get(s.ppid);d&&(d.children||(d.children=[]),d.children.push(s))}),n.forEach(s=>{s.children&&(s.children=s.children.sort((d,v)=>d.pid-v.pid))}),P(r)):l(new Error(`Root process ${j} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let o=function(){let a=[r];const m=[];for(;a.length;){const n=a.shift();n&&(m.push(n.pid),n.children&&(a=a.concat(n.children)))}let f=JSON.stringify(S.$Qg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+m.join(" "),(0,y.exec)(f,{},(n,s,d)=>{if(n||d)l(n||new Error(d.toString()));else{const v=s.toString().split(`
`);for(let i=0;i<m.length;i++){const t=p.get(m[i]);t.load=parseFloat(v[i])}if(!r){l(new Error(`Root process ${j} not found`));return}P(r)}})};(0,y.exec)("which ps",{},(a,m,f)=>{if(a||f)if(process.platform!=="linux")l(a||new Error(f.toString()));else{const n=JSON.stringify(S.$Qg.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(n,{},(s,d,v)=>{s||v?l(s||new Error(v.toString())):(M(d,u),o())})}else{const n=m.toString().trim();(0,y.exec)(`${n} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,v,i)=>{d||i&&!i.includes("screen size is bogus")?l(d||new Error(i.toString())):(M(v,u),process.platform==="linux"?o():r?P(r):l(new Error(`Root process ${j} not found`)))})}})}})}function M(j,P){const l=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=j.toString().split(`
`);for(const p of r){const u=l.exec(p.trim());u&&u.length===6&&P(parseInt(u[1]),parseInt(u[2]),u[5],parseFloat(u[3]),parseFloat(u[4]))}}}),define(fe[63],ge([0,1,20,3,61,34]),function(ae,e,y,S,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=j;async function j(u,k){return u===1?S.$i?p():M.$om(k):l(u,k)}let P=null;function l(u,k){if(S.$k&&u===2||S.$j&&u===3)return"/bin/bash";if(!P){let o;if(S.$i)o="/bin/bash";else{if(o=k.SHELL,!o)try{o=(0,y.userInfo)().shell}catch{}o||(o="sh"),o==="/bin/false"&&(o="/bin/bash")}P=o}return P}let r=null;async function p(){return r||(r=(await(0,C.$lm)()).exePath),r}});var we=this&&this.__decorate||function(ae,e,y,S){var C=arguments.length,M=C<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,y):S,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ae,e,y,S);else for(var P=ae.length-1;P>=0;P--)(j=ae[P])&&(M=(C<3?j(M):C>3?j(e,y,M):j(e,y))||M);return C>3&&M&&Object.defineProperty(e,y,M),M};define(fe[27],ge([0,1,16,11,18,17,14,7,4,2,59,12,9]),function(ae,e,y,S,C,M,j,P,l,r,p,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=E,e.$0h=w,e.$ci=O,e.$di=b;var o;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(o||(o={}));function a(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(m||(m={}));function f(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var n;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(n||(n={}));function s(X){let q=0;for(let J=0;;J+=7){const K=X.read(1);if(q|=(K.buffer[0]&127)<<J,!(K.buffer[0]&128))return q}}const d=L(0);function v(X,q){if(q===0){X.write(d);return}let J=0;for(let de=q;de!==0;de=de>>>7)J++;const K=C.$Ge.alloc(J);for(let de=0;q!==0;de++)K.buffer[de]=q&127,q=q>>>7,q>0&&(K.buffer[de]|=128);X.write(K)}class i{constructor(q){this.b=q,this.a=0}read(q){const J=this.b.slice(this.a,this.a+q);return this.a+=J.byteLength,J}}e.$7h=i;class t{constructor(){this.a=[]}get buffer(){return C.$Ge.concat(this.a)}write(q){this.a.push(q)}}e.$8h=t;var c;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(c||(c={}));function L(X){const q=C.$Ge.alloc(1);return q.writeUInt8(X,0),q}const $={Undefined:L(c.Undefined),String:L(c.String),Buffer:L(c.Buffer),VSBuffer:L(c.VSBuffer),Array:L(c.Array),Object:L(c.Object),Uint:L(c.Int)},D=typeof Buffer<"u";function E(X,q){if(typeof q>"u")X.write($.Undefined);else if(typeof q=="string"){const J=C.$Ge.fromString(q);X.write($.String),v(X,J.byteLength),X.write(J)}else if(D&&Buffer.isBuffer(q)){const J=C.$Ge.wrap(q);X.write($.Buffer),v(X,J.byteLength),X.write(J)}else if(q instanceof C.$Ge)X.write($.VSBuffer),v(X,q.byteLength),X.write(q);else if(Array.isArray(q)){X.write($.Array),v(X,q.length);for(const J of q)E(X,J)}else if(typeof q=="number"&&(q|0)===q)X.write($.Uint),v(X,q);else{const J=C.$Ge.fromString(JSON.stringify(q));X.write($.Object),v(X,J.byteLength),X.write(J)}}function w(X){switch(X.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return X.read(s(X)).toString();case c.Buffer:return X.read(s(X)).buffer;case c.VSBuffer:return X.read(s(X));case c.Array:{const J=s(X),K=[];for(let de=0;de<J;de++)K.push(w(X));return K}case c.Object:return JSON.parse(X.read(s(X)).toString());case c.Int:return s(X)}}class F{constructor(q,J,K=null,de=1e3){this.h=q,this.j=J,this.k=K,this.l=de,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(B=>this.q(B)),this.m({type:200})}registerChannel(q,J){this.b.set(q,J),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const J=this.o([q.type]);this.k?.logOutgoing(J,0,1,f(q.type));return}case 201:case 202:case 204:case 203:{const J=this.o([q.type,q.id],q.data);this.k?.logOutgoing(J,q.id,1,f(q.type),q.data);return}}}o(q,J=void 0){const K=new t;return E(K,q),E(K,J),this.p(K.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const J=new i(q),K=w(J),de=w(J),B=K[0];switch(B){case 100:return this.k?.logIncoming(q.byteLength,K[1],1,`${a(B)}: ${K[2]}.${K[3]}`,de),this.s({type:B,id:K[1],channelName:K[2],name:K[3],arg:de});case 102:return this.k?.logIncoming(q.byteLength,K[1],1,`${a(B)}: ${K[2]}.${K[3]}`,de),this.t({type:B,id:K[1],channelName:K[2],name:K[3],arg:de});case 101:return this.k?.logIncoming(q.byteLength,K[1],1,`${a(B)}`),this.u({type:B,id:K[1]});case 103:return this.k?.logIncoming(q.byteLength,K[1],1,`${a(B)}`),this.u({type:B,id:K[1]})}}s(q){const J=this.b.get(q.channelName);if(!J){this.v(q);return}const K=new M.$pe;let de;try{de=J.call(this.j,q.name,q.arg,K.token)}catch(x){de=Promise.reject(x)}const B=q.id;de.then(x=>{this.m({id:B,data:x,type:201})},x=>{x instanceof Error?this.m({id:B,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:B,data:x,type:203})}).finally(()=>{ue.dispose(),this.d.delete(q.id)});const ue=(0,r.$Tc)(()=>K.cancel());this.d.set(q.id,ue)}t(q){const J=this.b.get(q.channelName);if(!J){this.v(q);return}const K=q.id,B=J.listen(this.j,q.name,q.arg)(ue=>this.m({id:K,data:ue,type:204}));this.d.set(q.id,B)}u(q){const J=this.d.get(q.id);J&&(J.dispose(),this.d.delete(q.id))}v(q){let J=this.g.get(q.channelName);J||(J=[],this.g.set(q.channelName,J));const K=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:q,timeoutTimer:K})}w(q){const J=this.g.get(q);if(J){for(const K of J)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.s(K.request);break;case 102:this.t(K.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,r.$Qc)(this.d.values()),this.d.clear()}}e.$$h=F;var Z;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(Z||(e.RequestInitiator=Z={}));class T{constructor(q,J=null){this.l=q,this.a=!1,this.b=n.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new l.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=J}getChannel(q){const J=this;return{call(K,de,B){return J.a?Promise.reject(new P.$5):J.m(q,K,de,B)},listen(K,de){return J.a?l.Event.None:J.o(q,K,de)}}}m(q,J,K,de=M.CancellationToken.None){const B=this.g++,x={id:B,type:100,channelName:q,name:J,arg:K};if(de.isCancellationRequested)return Promise.reject(new P.$5);let h;return new Promise((ie,ne)=>{if(de.isCancellationRequested)return ne(new P.$5);const H=()=>{const V=_=>{switch(_.type){case 201:this.f.delete(B),ie(_.data);break;case 202:{this.f.delete(B);const se=new Error(_.data.message);se.stack=Array.isArray(_.data.stack)?_.data.stack.join(`
`):_.data.stack,se.name=_.data.name,ne(se);break}case 203:this.f.delete(B),ne(_.data);break}};this.f.set(B,V),this.p(x)};let W=null;this.b===n.Idle?H():(W=(0,S.$jh)(V=>this.u()),W.then(()=>{W=null,H()}));const z=()=>{W?(W.cancel(),W=null):this.p({id:B,type:101}),ne(new P.$5)},I=de.onCancellationRequested(z);h=(0,r.$Sc)((0,r.$Tc)(z),I),this.d.add(h)}).finally(()=>{h.dispose(),this.d.delete(h)})}o(q,J,K){const de=this.g++,ue={id:de,type:102,channelName:q,name:J,arg:K};let x=null;const h=new l.$ee({onWillAddFirstListener:()=>{x=(0,S.$jh)(ie=>this.u()),x.then(()=>{x=null,this.d.add(h),this.p(ue)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(h),this.p({id:de,type:103}))}}),N=ie=>h.fire(ie.data);return this.f.set(de,N),h.event}p(q){switch(q.type){case 100:case 102:{const J=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(J,q.id,0,`${a(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const J=this.q([q.type,q.id]);this.j?.logOutgoing(J,q.id,0,a(q.type));return}}}q(q,J=void 0){const K=new t;return E(K,q),E(K,J),this.r(K.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const J=new i(q),K=w(J),de=w(J),B=K[0];switch(B){case 200:return this.j?.logIncoming(q.byteLength,0,0,f(B)),this.t({type:K[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,K[1],0,f(B),de),this.t({type:K[0],id:K[1],data:de})}}t(q){if(q.type===200){this.b=n.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}u(){return this.b===n.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,r.$Qc)(this.d.values()),this.d.clear()}}e.$_h=T,we([j.$1h],T.prototype,"onDidInitializePromise",null);class R{get connections(){const q=[];return this.f.forEach(J=>q.push(J)),q}constructor(q,J,K){this.a=new Map,this.f=new Set,this.g=new l.$ee,this.onDidAddConnection=this.g.event,this.h=new l.$ee,this.onDidRemoveConnection=this.h.event,this.j=new r.$Uc,this.j.add(q(({protocol:de,onDidClientDisconnect:B})=>{const ue=l.Event.once(de.onMessage);this.j.add(ue(x=>{const h=new i(x),N=w(h),ie=new F(de,N,J,K),ne=new T(de,J);this.a.forEach((W,z)=>ie.registerChannel(z,W));const H={channelServer:ie,channelClient:ne,ctx:N};this.f.add(H),this.g.fire(H),this.j.add(B(()=>{ie.dispose(),ne.dispose(),this.f.delete(H),this.h.fire(H)}))}))}))}getChannel(q,J){const K=this;return{call(de,B,ue){let x;if((0,k.$kg)(J)){const N=(0,y.$4b)(K.connections.filter(J));x=N?Promise.resolve(N):l.Event.toPromise(l.Event.filter(K.onDidAddConnection,J))}else x=J.routeCall(K,de,B);const h=x.then(N=>N.channelClient.getChannel(q));return O(h).call(de,B,ue)},listen(de,B){if((0,k.$kg)(J))return K.k(q,J,de,B);const ue=J.routeEvent(K,de,B).then(x=>x.channelClient.getChannel(q));return O(ue).listen(de,B)}}}k(q,J,K,de){const B=this;let ue;const x=new l.$ee({onWillAddFirstListener:()=>{ue=new r.$Uc;const h=new l.$ke,N=new Map,ie=H=>{const z=H.channelClient.getChannel(q).listen(K,de),I=h.add(z);N.set(H,I)},ne=H=>{const W=N.get(H);W&&(W.dispose(),N.delete(H))};B.connections.filter(J).forEach(ie),l.Event.filter(B.onDidAddConnection,J)(ie,void 0,ue),B.onDidRemoveConnection(ne,void 0,ue),h.event(x.fire,x,ue),ue.add(h)},onDidRemoveLastListener:()=>{ue?.dispose(),ue=void 0}});return x.event}registerChannel(q,J){this.a.set(q,J);for(const K of this.f)K.channelServer.registerChannel(q,J)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=R;class g{constructor(q,J,K=null){const de=new t;E(de,J),q.send(de.buffer),this.a=new T(q,K),this.d=new F(q,J,K)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,J){this.d.registerChannel(q,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=g;function O(X){return{call(q,J,K){return X.then(de=>de.call(q,J,K))},listen(q,J){const K=new l.$ne;return X.then(de=>K.input=de.listen(q,J)),K.event}}}function b(X){let q=!1;return{call(J,K,de){return q?X.call(J,K,de):(0,S.$xh)(0).then(()=>q=!0).then(()=>X.call(J,K,de))},listen(J,K){if(q)return X.listen(J,K);const de=new l.$ne;return(0,S.$xh)(0).then(()=>q=!0).then(()=>de.input=X.listen(J,K)),de.event}}}class A{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const J of q.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await l.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$ei=A;var Y;(function(X){function q(B,ue,x){const h=B,N=x&&x.disableMarshalling,ie=new Map;for(const ne in h)K(ne)&&ie.set(ne,l.Event.buffer(h[ne],!0,void 0,ue));return new class{listen(ne,H,W){const z=ie.get(H);if(z)return z;const I=h[H];if(typeof I=="function"){if(de(H))return I.call(h,W);if(K(H))return ie.set(H,l.Event.buffer(h[H],!0,void 0,ue)),ie.get(H)}throw new P.$bb(`Event not found: ${H}`)}call(ne,H,W){const z=h[H];if(typeof z=="function"){if(!N&&Array.isArray(W))for(let V=0;V<W.length;V++)W[V]=(0,p.$6h)(W[V]);let I=z.apply(h,W);return I instanceof Promise||(I=Promise.resolve(I)),I}throw new P.$bb(`Method not found: ${H}`)}}}X.fromService=q;function J(B,ue){const x=ue&&ue.disableMarshalling;return new Proxy({},{get(h,N){if(typeof N=="string")return ue?.properties?.has(N)?ue.properties.get(N):de(N)?function(ie){return B.listen(N,ie)}:K(N)?B.listen(N):async function(...ie){let ne;ue&&!(0,k.$fg)(ue.context)?ne=[ue.context,...ie]:ne=ie;const H=await B.call(N,ne);return x?H:(0,p.$6h)(H)};throw new P.$bb(`Property not found: ${String(N)}`)}})}X.toService=J;function K(B){return B[0]==="o"&&B[1]==="n"&&u.$xf(B.charCodeAt(2))}function de(B){return/^onDynamic/.test(B)&&u.$xf(B.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const q=X.toString();if(q!=="[object Object]")return q}return X}function ee(X){return Array.isArray(X)?X.map(G):G(X)}function ce(X,q,J,K,de,B,ue){ue=ee(ue);const x=te[de],h=x[K%x.length];let N=[`%c[${X}]%c[${String(q).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test(B)?(N=N.concat(ue),N.push(")")):N.push(ue),console.log.apply(console,N)}class he{constructor(q,J){this.d=q,this.f=J,this.a=0,this.b=0}logOutgoing(q,J,K,de,B){this.b+=q,ce(this.d,this.b,q,J,K,de,B)}logIncoming(q,J,K,de,B){this.a+=q,ce(this.f,this.a,q,J,K,de,B)}}e.$fi=he}),define(fe[64],ge([0,1,26,11,18,17,58,7,4,2,30,34,33,27]),function(ae,e,y,S,C,M,j,P,l,r,p,u,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class a extends o.$$h{constructor(n){super({send:s=>{try{process.send?.(s.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",s=>C.$Ge.wrap(Buffer.from(s,"base64")))},n),process.once("disconnect",()=>this.dispose())}}e.$Zq=a;class m{constructor(n,s){this.i=n,this.j=s,this.c=new Set,this.g=new Map,this.h=new l.$ee,this.onDidProcessExit=this.h.event;const d=s&&s.timeout?s.timeout:6e4;this.b=new S.$th(d),this.d=null,this.f=null}getChannel(n){const s=this;return{call(d,v,i){return s.k(n,d,v,i)},listen(d,v){return s.l(n,d,v)}}}k(n,s,d,v=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const i=this.n(n),t=(0,S.$jh)($=>i.call(s,d,$)),c=v.onCancellationRequested(()=>t.cancel()),L=(0,r.$Tc)(()=>t.cancel());return this.c.add(L),t.finally(()=>{c.dispose(),this.c.delete(L),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(n,s,d){if(!this.b)return l.Event.None;this.b.cancel();let v;const i=new l.$ee({onWillAddFirstListener:()=>{v=this.n(n).listen(s,d)(i.fire,i),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const n=this.j&&this.j.args?this.j.args:[],s=Object.create(null);s.env={...(0,p.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(s.env={...s.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(s.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(s.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(s.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),s.execArgv===void 0&&(s.execArgv=process.execArgv.filter(E=>!/^--inspect(-brk)?=/.test(E)).filter(E=>!E.startsWith("--vscode-"))),(0,k.$nm)(s.env),this.d=(0,y.fork)(this.i,n,s);const d=new l.$ee,i=l.Event.fromNodeEventEmitter(this.d,"message",E=>E)(E=>{if((0,j.$Vq)(E)){(0,j.log)(E,`IPC Library: ${this.j.serverName}`);return}d.fire(C.$Ge.wrap(Buffer.from(E,"base64")))}),t=this.j.useQueue?(0,u.$pm)(this.d):this.d,c=E=>this.d&&this.d.connected&&t.send(E.buffer.toString("base64")),L=d.event,$={send:c,onMessage:L};this.f=new o.$_h($);const D=()=>this.o();process.once("exit",D),this.d.on("error",E=>console.warn('IPC "'+this.j.serverName+'" errored with '+E)),this.d.on("exit",(E,w)=>{process.removeListener("exit",D),i.dispose(),this.c.forEach(F=>(0,r.$Qc)(F)),this.c.clear(),E!==0&&w!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+E+" and signal "+w),this.b?.cancel(),this.o(),this.h.fire({code:E,signal:w})})}return this.f}n(n){let s=this.g.get(n);return s||(s=this.m.getChannel(n),this.g.set(n,s)),s}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=m}),define(fe[65],ge([0,1,31,18,27,4,9,16]),function(ae,e,y,S,C,M,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9W=void 0,e.$0W=p;class l{constructor(k){this.a=k,this.onMessage=M.Event.fromNodeEventEmitter(this.a,"message",o=>o.data?S.$Ge.wrap(o.data):S.$Ge.alloc(0)),k.start()}send(k){this.a.postMessage(k.buffer)}disconnect(){this.a.close()}}class r extends C.$ai{static b(k){(0,j.$gg)((0,y.$8W)(process),"Electron Utility Process");const o=new M.$ee;return process.parentPort.on("message",a=>{if(k?.handledClientConnection(a))return;const m=(0,P.$Ob)(a.ports);m&&o.fire(m)}),M.Event.map(o.event,a=>({protocol:new l(a),onDidClientDisconnect:M.Event.fromNodeEventEmitter(a,"close")}))}constructor(k){super(r.b(k))}}e.$9W=r;function p(u,k,o){const a=m=>{m.data===k&&(u.removeListener("message",a),o())};u.on("message",a)}}),define(fe[66],ge([13,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/contextkey",e)}),define(fe[67],ge([13,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/scanner",e)}),define(fe[68],ge([13,10]),function(ae,e){return ae.create("vs/platform/environment/node/argv",e)}),define(fe[69],ge([13,10]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(fe[70],ge([13,10]),function(ae,e){return ae.create("vs/platform/log/common/log",e)}),define(fe[71],ge([13,10]),function(ae,e){return ae.create("vs/platform/terminal/node/ptyService",e)}),define(fe[72],ge([13,10]),function(ae,e){return ae.create("vs/platform/terminal/node/terminalProcess",e)}),define(fe[73],ge([0,1,7,67]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var C;(function(r){r[r.LParen=0]="LParen",r[r.RParen=1]="RParen",r[r.Neg=2]="Neg",r[r.Eq=3]="Eq",r[r.NotEq=4]="NotEq",r[r.Lt=5]="Lt",r[r.LtEq=6]="LtEq",r[r.Gt=7]="Gt",r[r.GtEq=8]="GtEq",r[r.RegexOp=9]="RegexOp",r[r.RegexStr=10]="RegexStr",r[r.True=11]="True",r[r.False=12]="False",r[r.In=13]="In",r[r.Not=14]="Not",r[r.And=15]="And",r[r.Or=16]="Or",r[r.Str=17]="Str",r[r.QuotedStr=18]="QuotedStr",r[r.Error=19]="Error",r[r.EOF=20]="EOF"})(C||(e.TokenType=C={}));function M(...r){switch(r.length){case 1:return(0,S.localize)(0,null,r[0]);case 2:return(0,S.localize)(1,null,r[0],r[1]);case 3:return(0,S.localize)(2,null,r[0],r[1],r[2]);default:return}}const j=(0,S.localize)(3,null),P=(0,S.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const u=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:u})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const u=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:u})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const u=this.d,k=this.c.substring(this.d,this.e),o={type:19,offset:this.d,lexeme:k};this.g.push({offset:u,lexeme:k,additionalInfo:p}),this.f.push(o)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const u=this.c.substring(this.d,this.e),k=l.b.get(u);k?this.k(k):this.f.push({type:17,lexeme:u,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,u=!1,k=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(P);return}const a=this.c.charCodeAt(p);if(u)u=!1;else if(a===47&&!k){p++;break}else a===91?k=!0:a===92?u=!0:a===93&&(k=!1);p++}for(;p<this.c.length&&l.a.has(this.c.charCodeAt(p));)p++;this.e=p;const o=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:o,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=l}),define(fe[74],ge([0,1,54,14,19,5,15,23,6]),function(ae,e,y,S,C,M,j,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=p,e.$8m=u,e.$5m=/^([^.]+\..+)[:=](.+)$/;class r{get appRoot(){return(0,M.$nc)(C.$Qg.asFileUri("").fsPath)}get userHome(){return l.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return l.URI.file((0,M.$kc)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.b.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,P.$0g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:C.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$0g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const o=(0,y.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$kc)(this.userDataPath,"logs",o)}return l.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$0g)(l.URI.file((0,M.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$0g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$0g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$0g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const o=j.env.VSCODE_PORTABLE;return o?l.URI.file((0,M.$kc)(o,"argv.json")):(0,P.$0g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,M.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const o=this.args["builtin-extensions-dir"];return o?(0,M.$lc)(o):(0,M.$ic)((0,M.$kc)(C.$Qg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const o=this.args["extensions-download-dir"];return o?l.URI.file((0,M.$lc)(o)):l.URI.file((0,M.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const o=this.args["extensions-dir"];if(o)return(0,M.$lc)(o);const a=j.env.VSCODE_EXTENSIONS;if(a)return a;const m=j.env.VSCODE_PORTABLE;return m?(0,M.$kc)(m,"extensions"):(0,P.$0g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const o=this.args.extensionDevelopmentPath;if(Array.isArray(o))return o.map(a=>/^[^:/?#]+?:\/\//.test(a)?l.URI.parse(a):l.URI.file((0,M.$ic)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(o=>o==="ui"||o==="workspace"||o==="web"?o:"workspace")}get extensionTestsLocationURI(){const o=this.args.extensionTestsPath;if(o)return/^[^:/?#]+?:\/\//.test(o)?l.URI.parse(o):l.URI.file((0,M.$ic)(o))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const o=this.args["disable-extension"];if(o){if(typeof o=="string")return[o];if(Array.isArray(o)&&o.length>0)return o}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(o=>!e.$5m.test(o))}get extensionLogLevel(){const o=[];for(const a of this.args.log||[]){const m=e.$5m.exec(a);m&&m[1]&&m[2]&&o.push([m[1],m[2]])}return o.length?o:void 0}get serviceMachineIdResource(){return(0,P.$0g)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const o=j.env.VSCODE_PORTABLE;return o?l.URI.file((0,M.$kc)(o,"policy.json")):(0,P.$0g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(o){this.args.continueOn=o}get args(){return this.a}constructor(o,a,m){this.a=o,this.b=a,this.c=m,this.editSessionId=this.args.editSessionId}}e.$6m=r,we([S.$1h],r.prototype,"appRoot",null),we([S.$1h],r.prototype,"userHome",null),we([S.$1h],r.prototype,"userDataPath",null),we([S.$1h],r.prototype,"appSettingsHome",null),we([S.$1h],r.prototype,"tmpDir",null),we([S.$1h],r.prototype,"cacheHome",null),we([S.$1h],r.prototype,"stateResource",null),we([S.$1h],r.prototype,"userRoamingDataHome",null),we([S.$1h],r.prototype,"userDataSyncHome",null),we([S.$1h],r.prototype,"sync",null),we([S.$1h],r.prototype,"machineSettingsResource",null),we([S.$1h],r.prototype,"workspaceStorageHome",null),we([S.$1h],r.prototype,"localHistoryHome",null),we([S.$1h],r.prototype,"keyboardLayoutResource",null),we([S.$1h],r.prototype,"argvResource",null),we([S.$1h],r.prototype,"isExtensionDevelopment",null),we([S.$1h],r.prototype,"untitledWorkspacesHome",null),we([S.$1h],r.prototype,"builtinExtensionsPath",null),we([S.$1h],r.prototype,"extensionsPath",null),we([S.$1h],r.prototype,"extensionDevelopmentLocationURI",null),we([S.$1h],r.prototype,"extensionDevelopmentKind",null),we([S.$1h],r.prototype,"extensionTestsLocationURI",null),we([S.$1h],r.prototype,"debugExtensionHost",null),we([S.$1h],r.prototype,"logLevel",null),we([S.$1h],r.prototype,"extensionLogLevel",null),we([S.$1h],r.prototype,"serviceMachineIdResource",null),we([S.$1h],r.prototype,"disableTelemetry",null),we([S.$1h],r.prototype,"disableWorkspaceTrust",null),we([S.$1h],r.prototype,"useInMemorySecretStorage",null),we([S.$1h],r.prototype,"policyFile",null);function p(k,o){return u(k["inspect-extensions"],k["inspect-brk-extensions"],5870,o,k.debugId,k.extensionEnvironment)}function u(k,o,a,m,f,n){const d=Number(o||k)||(m?null:a),v=d?!!o:!1;let i;if(n)try{i=JSON.parse(n)}catch{}return{port:d,break:v,debugId:f,env:i}}}),define(fe[75],ge([0,1,108,3,68]),function(ae,e,y,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0,e.$tm=P,e.$um=r,e.$vm=o,e.$wm=a;const M={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.$rm=["tunnel","serve-web"],e.$sm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,C.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,C.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,C.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,C.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,C.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,C.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,C.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,C.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,C.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,C.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,C.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,C.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,C.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,C.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(m,f,n=j){const s=m.find(E=>E.length>0&&E[0]!=="-"),d={},v=["_"],i=[],t={};let c;for(const E in f){const w=f[E];w.type==="subcommand"?E===s&&(c=w):(w.alias&&(d[E]=w.alias),w.type==="string"||w.type==="string[]"?(v.push(E),w.deprecates&&v.push(...w.deprecates)):w.type==="boolean"&&(i.push(E),w.deprecates&&i.push(...w.deprecates)),w.global&&(t[E]=w))}if(c&&s){const E=t;for(const T in c.options)E[T]=c.options[T];const w=m.filter(T=>T!==s),F=n.getSubcommandReporter?n.getSubcommandReporter(s):void 0,Z=P(w,E,F);return{[s]:Z,_:[]}}const L=y(m,{string:v,boolean:i,alias:d}),$={},D=L;$._=L._.map(E=>String(E)).filter(E=>E.length>0),delete D._;for(const E in f){const w=f[E];if(w.type==="subcommand")continue;w.alias&&delete D[w.alias];let F=D[E];if(w.deprecates)for(const Z of w.deprecates)D.hasOwnProperty(Z)&&(F||(F=D[Z],F&&n.onDeprecatedOption(Z,w.deprecationMessage||(0,C.localize)(38,null,E))),delete D[Z]);if(typeof F<"u"){if(w.type==="string[]"){if(Array.isArray(F)||(F=[F]),!w.allowEmptyValue){const Z=F.filter(T=>T.length>0);Z.length!==F.length&&(n.onEmptyValue(E),F=Z.length>0?Z:void 0)}}else w.type==="string"&&(Array.isArray(F)?(F=F.pop(),n.onMultipleValues(E,F)):!F&&!w.allowEmptyValue&&(n.onEmptyValue(E),F=void 0));$[E]=F,w.deprecationMessage&&n.onDeprecatedOption(E,w.deprecationMessage)}delete D[E]}for(const E in D)n.onUnknownOption(E);return $}function l(m,f){let n="";return f.args&&(Array.isArray(f.args)?n=` <${f.args.join("> <")}>`:n=` <${f.args}>`),f.alias?`-${f.alias} --${m}${n}`:`--${m}${n}`}function r(m,f){const n=[];for(const s in m){const d=m[s],v=l(s,d);n.push([v,d.description])}return p(n,f)}function p(m,f){const s=m.reduce((i,t)=>Math.max(i,t[0].length),12)+2+1;if(f-s<25)return m.reduce((i,t)=>i.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=f-s-1,v=[];for(const i of m){const t=i[0],c=k(i[1],d),L=u(s-t.length-2);v.push("  "+t+L+c[0]);for(let $=1;$<c.length;$++)v.push(u(s)+c[$])}return v}function u(m){return" ".repeat(m)}function k(m,f){const n=[];for(;m.length;){const s=m.length<f?m.length:m.lastIndexOf(" ",f),d=m.slice(0,s).trim();m=m.slice(s),n.push(d)}return n}function o(m,f,n,s,d){const v=process.stdout.isTTY&&process.stdout.columns||80,i=d?.noInputFiles!==!0?`[${(0,C.localize)(39,null)}...]`:"",t=[`${m} ${n}`];t.push(""),t.push(`${(0,C.localize)(40,null)}: ${f} [${(0,C.localize)(41,null)}]${i}`),t.push(""),d?.noPipe!==!0&&(S.$i?t.push((0,C.localize)(42,null,f)):t.push((0,C.localize)(43,null,f)),t.push(""));const c={},L=[];for(const $ in s){const D=s[$];if(D.type==="subcommand")D.description&&L.push({command:$,description:D.description});else if(D.description&&D.cat){let E=c[D.cat];E||(c[D.cat]=E={}),E[$]=D}}for(const $ in c){const D=$,E=c[D];E&&(t.push(M[D]),t.push(...r(E,v)),t.push(""))}return L.length&&(t.push((0,C.localize)(44,null)),t.push(...p(L.map($=>[$.command,$.description]),v)),t.push("")),t.join(`
`)}function a(m,f){return`${m||(0,C.localize)(45,null)}
${f||(0,C.localize)(46,null)}
${process.arch}`}}),function(){"use strict";function ae(e,y,S){function C(j,P){const l=M(j,P),r=[l];return e.isAbsolute(l)||r.unshift(S),e.resolve(...r)}function M(j,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let r=process.env.VSCODE_APPDATA;if(r)return e.join(r,P);const p=j["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(u,"AppData","Roaming")}break;case"darwin":r=e.join(y.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,P)}return{getUserDataPath:C}}if(typeof define=="function")define(fe[76],ge([77,20,15]),function(e,y,S){return ae(e,y,S.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=ae(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(fe[78],ge([0,1,20,74,76]),function(ae,e,y,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=j,e.$$m=P;class M extends S.$6m{constructor(r,p){super(r,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,C.getUserDataPath)(r,p.nameShort)},p)}}e.$9m=M;function j(l,r){return(0,S.$8m)(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,r,l.extensionEnvironment)}function P(l,r){return(0,S.$8m)(l["inspect-sharedprocess"],l["inspect-brk-sharedprocess"],5879,r,l.extensionEnvironment)}}),define(fe[21],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=C,e.$xi=M;var y;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function P(l){return l[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=P})(y||(e._util=y={})),e.$vi=C("instantiationService");function S(j,P,l){P[y.DI_TARGET]===P?P[y.DI_DEPENDENCIES].push({id:j,index:l}):(P[y.DI_DEPENDENCIES]=[{id:j,index:l}],P[y.DI_TARGET]=P)}function C(j){if(y.serviceIds.has(j))return y.serviceIds.get(j);const P=function(l,r,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");S(P,l,p)};return P.toString=()=>j,y.serviceIds.set(j,P),P}function M(j){return j}}),define(fe[35],ge([0,1,3,12,73,21,66,7]),function(ae,e,y,S,C,M,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=r,e.$vj=c,e.$wj=L,e.$Pj=de;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",y.$j),l.set("isLinux",y.$k),l.set("isWindows",y.$i),l.set("isWeb",y.$o),l.set("isMacNative",y.$j&&!y.$o),l.set("isEdge",y.$H),l.set("isFirefox",y.$F),l.set("isChrome",y.$E),l.set("isSafari",y.$G);function r(x,h){if(l.get(x)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(x,h)}const p=Object.prototype.hasOwnProperty;var u;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const k={regexParsingWithErrorRecovery:!0},o=(0,j.localize)(0,null),a=(0,j.localize)(1,null),m=(0,j.localize)(2,null),f=(0,j.localize)(3,null),n=(0,j.localize)(4,null),s=(0,j.localize)(5,null),d=(0,j.localize)(6,null),v=(0,j.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(h=k){this.k=h,this.d=new C.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(h){if(h===""){this.h.push({message:o,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(h).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const ie=this.D(),ne=ie.type===17?s:void 0;throw this.h.push({message:n,offset:ie.offset,lexeme:C.$rj.getLexeme(ie),additionalInfo:ne}),i.c}return N}catch(N){if(N!==i.c)throw N;return}}l(){return this.m()}m(){const h=[this.o()];for(;this.y(16);){const N=this.o();h.push(N)}return h.length===1?h[0]:t.or(...h)}o(){const h=[this.s()];for(;this.y(15);){const N=this.s();h.push(N)}return h.length===1?h[0]:t.and(...h)}s(){if(this.y(2)){const h=this.D();switch(h.type){case 11:return this.z(),D.INSTANCE;case 12:return this.z(),E.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,f),N?.negate()}case 17:return this.z(),g.create(h.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",h)}}return this.t()}t(){const h=this.D();switch(h.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,f),N}case 17:{const N=h.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const H=ne.lexeme,W=H.lastIndexOf("/"),z=W===H.length-1?void 0:this.w(H.substring(W+1));let I;try{I=new RegExp(H.substring(1,W),z)}catch{throw this.B("REGEX",ne)}return G.create(N,I)}switch(ne.type){case 10:case 19:{const H=[ne.lexeme];this.z();let W=this.D(),z=0;for(let re=0;re<ne.lexeme.length;re++)ne.lexeme.charCodeAt(re)===40?z++:ne.lexeme.charCodeAt(re)===41&&z--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:z++;break;case 1:z--;break;case 10:case 18:for(let re=0;re<W.lexeme.length;re++)W.lexeme.charCodeAt(re)===40?z++:ne.lexeme.charCodeAt(re)===41&&z--}if(z<0)break;H.push(C.$rj.getLexeme(W)),this.z(),W=this.D()}const I=H.join(""),V=I.lastIndexOf("/"),_=V===I.length-1?void 0:this.w(I.substring(V+1));let se;try{se=new RegExp(I.substring(1,V),_)}catch{throw this.B("REGEX",ne)}return t.regex(N,se)}case 18:{const H=ne.lexeme;this.z();let W=null;if(!(0,S.$8e)(H)){const z=H.indexOf("/"),I=H.lastIndexOf("/");if(z!==I&&z>=0){const V=H.slice(z+1,I),_=H[I+1]==="i"?"i":"";try{W=new RegExp(V,_)}catch{throw this.B("REGEX",ne)}}}if(W===null)throw this.B("REGEX",ne);return G.create(N,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const ne=this.u();return t.notIn(N,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return t.equals(N,ne);switch(ne){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return t.notEquals(N,ne);switch(ne){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,ne)}}case 5:return this.z(),Y.create(N,this.u());case 6:return this.z(),te.create(N,this.u());case 7:return this.z(),b.create(N,this.u());case 8:return this.z(),A.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:d,offset:h.offset,lexeme:"",additionalInfo:v}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const h=this.D();switch(h.type){case 17:case 18:return this.z(),h.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(h){return h.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(h){return this.C(h)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(h,N){if(this.C(h))return this.z();throw this.B(N,this.D())}B(h,N,ie){const ne=(0,j.localize)(8,null,h,C.$rj.getLexeme(N)),H=N.offset,W=C.$rj.getLexeme(N);return this.h.push({message:ne,offset:H,lexeme:W,additionalInfo:ie}),i.c}C(h){return this.D().type===h}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=i;class t{static false(){return D.INSTANCE}static true(){return E.INSTANCE}static has(h){return w.create(h)}static equals(h,N){return F.create(h,N)}static notEquals(h,N){return R.create(h,N)}static regex(h,N){return G.create(h,N)}static in(h,N){return Z.create(h,N)}static notIn(h,N){return T.create(h,N)}static not(h){return g.create(h)}static and(...h){return he.create(h,null,!0)}static or(...h){return X.create(h,null,!0)}static greater(h,N){return b.create(h,N)}static greaterEquals(h,N){return A.create(h,N)}static smaller(h,N){return Y.create(h,N)}static smallerEquals(h,N){return te.create(h,N)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(h){return h==null?void 0:this.c.parse(h)}}e.$uj=t;function c(x){const h=new i({regexParsingWithErrorRecovery:!1});return x.map(N=>(h.parse(N),h.lexingErrors.length>0?h.lexingErrors.map(ie=>({errorMessage:ie.additionalInfo?(0,j.localize)(9,null,ie.additionalInfo):(0,j.localize)(10,null),offset:ie.offset,length:ie.lexeme.length})):h.parsingErrors.length>0?h.parsingErrors.map(ie=>({errorMessage:ie.additionalInfo?`${ie.message}. ${ie.additionalInfo}`:ie.message,offset:ie.offset,length:ie.lexeme.length})):[]))}function L(x,h){const N=x?x.substituteConstants():void 0,ie=h?h.substituteConstants():void 0;return!N&&!ie?!0:!N||!ie?!1:N.equals(ie)}function $(x,h){return x.cmp(h)}class D{static{this.INSTANCE=new D}constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return E.INSTANCE}}e.$xj=D;class E{static{this.INSTANCE=new E}constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return D.INSTANCE}}e.$yj=E;class w{static create(h,N=null){const ie=l.get(h);return typeof ie=="boolean"?ie?E.INSTANCE:D.INSTANCE:new w(h,N)}constructor(h,N){this.key=h,this.c=N,this.type=2}cmp(h){return h.type!==this.type?this.type-h.type:J(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}substituteConstants(){const h=l.get(this.key);return typeof h=="boolean"?h?E.INSTANCE:D.INSTANCE:this}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.$zj=w;class F{static create(h,N,ie=null){if(typeof N=="boolean")return N?w.create(h,ie):g.create(h,ie);const ne=l.get(h);return typeof ne=="boolean"?N===(ne?"true":"false")?E.INSTANCE:D.INSTANCE:new F(h,N,ie)}constructor(h,N,ie){this.c=h,this.d=N,this.f=ie,this.type=4}cmp(h){return h.type!==this.type?this.type-h.type:K(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){const h=l.get(this.c);if(typeof h=="boolean"){const N=h?"true":"false";return this.d===N?E.INSTANCE:D.INSTANCE}return this}evaluate(h){return h.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(h){return h.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Aj=F;class Z{static create(h,N){return new Z(h,N)}constructor(h,N){this.d=h,this.f=N,this.type=10,this.c=null}cmp(h){return h.type!==this.type?this.type-h.type:K(this.d,this.f,h.d,h.f)}equals(h){return h.type===this.type?this.d===h.d&&this.f===h.f:!1}substituteConstants(){return this}evaluate(h){const N=h.getValue(this.f),ie=h.getValue(this.d);return Array.isArray(N)?N.includes(ie):typeof ie=="string"&&typeof N=="object"&&N!==null?p.call(N,ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(h){return h.mapIn(this.d,this.f)}negate(){return this.c||(this.c=T.create(this.d,this.f)),this.c}}e.$Bj=Z;class T{static create(h,N){return new T(h,N)}constructor(h,N){this.d=h,this.f=N,this.type=11,this.c=Z.create(h,N)}cmp(h){return h.type!==this.type?this.type-h.type:this.c.cmp(h.c)}equals(h){return h.type===this.type?this.c.equals(h.c):!1}substituteConstants(){return this}evaluate(h){return!this.c.evaluate(h)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(h){return h.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=T;class R{static create(h,N,ie=null){if(typeof N=="boolean")return N?g.create(h,ie):w.create(h,ie);const ne=l.get(h);return typeof ne=="boolean"?N===(ne?"true":"false")?D.INSTANCE:E.INSTANCE:new R(h,N,ie)}constructor(h,N,ie){this.c=h,this.d=N,this.f=ie,this.type=5}cmp(h){return h.type!==this.type?this.type-h.type:K(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){const h=l.get(this.c);if(typeof h=="boolean"){const N=h?"true":"false";return this.d===N?D.INSTANCE:E.INSTANCE}return this}evaluate(h){return h.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(h){return h.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Dj=R;class g{static create(h,N=null){const ie=l.get(h);return typeof ie=="boolean"?ie?D.INSTANCE:E.INSTANCE:new g(h,N)}constructor(h,N){this.c=h,this.d=N,this.type=3}cmp(h){return h.type!==this.type?this.type-h.type:J(this.c,h.c)}equals(h){return h.type===this.type?this.c===h.c:!1}substituteConstants(){const h=l.get(this.c);return typeof h=="boolean"?h?D.INSTANCE:E.INSTANCE:this}evaluate(h){return!h.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(h){return h.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Ej=g;function O(x,h){if(typeof x=="string"){const N=parseFloat(x);isNaN(N)||(x=N)}return typeof x=="string"||typeof x=="number"?h(x):D.INSTANCE}class b{static create(h,N,ie=null){return O(N,ne=>new b(h,ne,ie))}constructor(h,N,ie){this.c=h,this.d=N,this.f=ie,this.type=12}cmp(h){return h.type!==this.type?this.type-h.type:K(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(h){return h.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Fj=b;class A{static create(h,N,ie=null){return O(N,ne=>new A(h,ne,ie))}constructor(h,N,ie){this.c=h,this.d=N,this.f=ie,this.type=13}cmp(h){return h.type!==this.type?this.type-h.type:K(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(h){return h.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Gj=A;class Y{static create(h,N,ie=null){return O(N,ne=>new Y(h,ne,ie))}constructor(h,N,ie){this.c=h,this.d=N,this.f=ie,this.type=14}cmp(h){return h.type!==this.type?this.type-h.type:K(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(h){return h.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Hj=Y;class te{static create(h,N,ie=null){return O(N,ne=>new te(h,ne,ie))}constructor(h,N,ie){this.c=h,this.d=N,this.f=ie,this.type=15}cmp(h){return h.type!==this.type?this.type-h.type:K(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(h){return h.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Ij=te;class G{static create(h,N){return new G(h,N)}constructor(h,N){this.d=h,this.f=N,this.type=7,this.c=null}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.d<h.d)return-1;if(this.d>h.d)return 1;const N=this.f?this.f.source:"",ie=h.f?h.f.source:"";return N<ie?-1:N>ie?1:0}equals(h){if(h.type===this.type){const N=this.f?this.f.source:"",ie=h.f?h.f.source:"";return this.d===h.d&&N===ie}return!1}substituteConstants(){return this}evaluate(h){const N=h.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const h=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${h}`}keys(){return[this.d]}map(h){return h.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Jj=G;class ee{static create(h){return new ee(h)}constructor(h){this.c=h,this.type=8}cmp(h){return h.type!==this.type?this.type-h.type:this.c.cmp(h.c)}equals(h){return h.type===this.type?this.c.equals(h.c):!1}substituteConstants(){return this}evaluate(h){return!this.c.evaluate(h)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(h){return new ee(this.c.map(h))}negate(){return this.c}}e.$Kj=ee;function ce(x){let h=null;for(let N=0,ie=x.length;N<ie;N++){const ne=x[N].substituteConstants();if(x[N]!==ne&&h===null){h=[];for(let H=0;H<N;H++)h[H]=x[H]}h!==null&&(h[N]=ne)}return h===null?x:h}class he{static create(h,N,ie){return he.d(h,N,ie)}constructor(h,N){this.expr=h,this.c=N,this.type=6}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let N=0,ie=this.expr.length;N<ie;N++){const ne=$(this.expr[N],h.expr[N]);if(ne!==0)return ne}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let N=0,ie=this.expr.length;N<ie;N++)if(!this.expr[N].equals(h.expr[N]))return!1;return!0}return!1}substituteConstants(){const h=ce(this.expr);return h===this.expr?this:he.create(h,this.c,!1)}evaluate(h){for(let N=0,ie=this.expr.length;N<ie;N++)if(!this.expr[N].evaluate(h))return!1;return!0}static d(h,N,ie){const ne=[];let H=!1;for(const W of h)if(W){if(W.type===1){H=!0;continue}if(W.type===0)return D.INSTANCE;if(W.type===6){ne.push(...W.expr);continue}ne.push(W)}if(ne.length===0&&H)return E.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort($);for(let W=1;W<ne.length;W++)ne[W-1].equals(ne[W])&&(ne.splice(W,1),W--);if(ne.length===1)return ne[0];for(;ne.length>1;){const W=ne[ne.length-1];if(W.type!==9)break;ne.pop();const z=ne.pop(),I=ne.length===0,V=X.create(W.expr.map(_=>he.create([_,z],null,ie)),null,I);V&&(ne.push(V),ne.sort($))}if(ne.length===1)return ne[0];if(ie){for(let W=0;W<ne.length;W++)for(let z=W+1;z<ne.length;z++)if(ne[W].negate().equals(ne[z]))return D.INSTANCE;if(ne.length===1)return ne[0]}return new he(ne,N)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(const N of this.expr)h.push(...N.keys());return h}map(h){return new he(this.expr.map(N=>N.map(h)),null)}negate(){if(!this.c){const h=[];for(const N of this.expr)h.push(N.negate());this.c=X.create(h,this,!0)}return this.c}}e.$Lj=he;class X{static create(h,N,ie){return X.d(h,N,ie)}constructor(h,N){this.expr=h,this.c=N,this.type=9}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let N=0,ie=this.expr.length;N<ie;N++){const ne=$(this.expr[N],h.expr[N]);if(ne!==0)return ne}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let N=0,ie=this.expr.length;N<ie;N++)if(!this.expr[N].equals(h.expr[N]))return!1;return!0}return!1}substituteConstants(){const h=ce(this.expr);return h===this.expr?this:X.create(h,this.c,!1)}evaluate(h){for(let N=0,ie=this.expr.length;N<ie;N++)if(this.expr[N].evaluate(h))return!0;return!1}static d(h,N,ie){let ne=[],H=!1;if(h){for(let W=0,z=h.length;W<z;W++){const I=h[W];if(I){if(I.type===0){H=!0;continue}if(I.type===1)return E.INSTANCE;if(I.type===9){ne=ne.concat(I.expr);continue}ne.push(I)}}if(ne.length===0&&H)return D.INSTANCE;ne.sort($)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let W=1;W<ne.length;W++)ne[W-1].equals(ne[W])&&(ne.splice(W,1),W--);if(ne.length===1)return ne[0];if(ie){for(let W=0;W<ne.length;W++)for(let z=W+1;z<ne.length;z++)if(ne[W].negate().equals(ne[z]))return E.INSTANCE;if(ne.length===1)return ne[0]}return new X(ne,N)}}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(const N of this.expr)h.push(...N.keys());return h}map(h){return new X(this.expr.map(N=>N.map(h)),null)}negate(){if(!this.c){const h=[];for(const N of this.expr)h.push(N.negate());for(;h.length>1;){const N=h.shift(),ie=h.shift(),ne=[];for(const H of ue(N))for(const W of ue(ie))ne.push(he.create([H,W],null,!1));h.unshift(X.create(ne,null,!1))}this.c=X.create(h,this,!0)}return this.c}}e.$Mj=X;class q extends w{static{this.d=[]}static all(){return q.d.values()}constructor(h,N,ie){super(h,null),this.f=N,typeof ie=="object"?q.d.push({...ie,key:h}):ie!==!0&&q.d.push({key:h,description:ie,type:N!=null?typeof N:void 0})}bindTo(h){return h.createKey(this.key,this.f)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(h){return F.create(this.key,h)}notEqualsTo(h){return R.create(this.key,h)}}e.$Nj=q,e.$Oj=(0,M.$wi)("contextKeyService");function J(x,h){return x<h?-1:x>h?1:0}function K(x,h,N,ie){return x<N?-1:x>N?1:h<ie?-1:h>ie?1:0}function de(x,h){if(x.type===0||h.type===1)return!0;if(x.type===9)return h.type===9?B(x.expr,h.expr):!1;if(h.type===9){for(const N of h.expr)if(de(x,N))return!0;return!1}if(x.type===6){if(h.type===6)return B(h.expr,x.expr);for(const N of x.expr)if(de(N,h))return!0;return!1}return x.equals(h)}function B(x,h){let N=0,ie=0;for(;N<x.length&&ie<h.length;){const ne=x[N].cmp(h[ie]);if(ne<0)return!1;ne===0&&N++,ie++}return N===x.length}function ue(x){return x.type===9?x.expr:[x]}}),define(fe[79],ge([0,1,51,5,12,9,6,69,21,3,19,22]),function(ae,e,y,S,C,M,j,P,l,r,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=k,e.$5k=f,e.$6k=s,e.$7k=d,e.$8k=v,e.$9k=i,e.$0k=t,e.$$k=c,e.$_k=L,e.$al=$,e.$bl=D,e.$dl=F,e.$el=Z,e.$fl=T,e.$gl=R,e.$hl=g,e.$kl=te,e.$wl=q,e.$xl=J,e.$zl=de,e.$3k=(0,l.$wi)("fileService");function k(B){return B.create===!0}var o;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(o||(e.FileType=o={}));var a;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var m;(function(B){B[B.UPDATED=2]="UPDATED",B[B.ADDED=4]="ADDED",B[B.DELETED=8]="DELETED"})(m||(e.FileChangeFilter=m={}));function f(B){const ue=B;return!!ue&&typeof ue.onDidChange=="function"}var n;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(n||(e.FileSystemProviderCapabilities=n={}));function s(B){return!!(B.capabilities&2)}function d(B){return!!(B.capabilities&8)}function v(B){return!!(B.capabilities&131072)}function i(B){return!!(B.capabilities&4)}function t(B){return!!(B.capabilities&16)}function c(B){return s(B)?!!(B.capabilities&16384):!1}function L(B){return s(B)?!!(B.capabilities&32768):!1}function $(B){return!!(B.capabilities&65536)}function D(B){return!!(B.capabilities&2048)}var E;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class w extends Error{static create(ue,x){const h=new w(ue.toString(),x);return T(h,x),h}constructor(ue,x){super(ue),this.code=x}}e.$cl=w;function F(B,ue){return w.create(B,ue)}function Z(B){return B||F((0,P.localize)(0,null),E.Unknown)}function T(B,ue){return B.name=ue?`${ue} (FileSystemError)`:"FileSystemError",B}function R(B){if(!B)return E.Unknown;if(B instanceof w)return B.code;const ue=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!ue)return E.Unknown;switch(ue[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function g(B){if(B instanceof G)return B.fileOperationResult;switch(R(B)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 9;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileTooLarge:return 7;default:return 10}}var O;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class b{constructor(ue,x,h){this.resource=ue,this.operation=x,this.target=h}isOperation(ue){return this.operation===ue}}e.$il=b;var A;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class Y{static{this.a=null}constructor(ue,x){this.c=x,this.b=void 0,this.d=new u.$V(()=>{const h=y.$Ci.forUris(()=>this.c);return h.fill(this.rawAdded.map(N=>[N,!0])),h}),this.f=new u.$V(()=>{const h=y.$Ci.forUris(()=>this.c);return h.fill(this.rawUpdated.map(N=>[N,!0])),h}),this.g=new u.$V(()=>{const h=y.$Ci.forUris(()=>this.c);return h.fill(this.rawDeleted.map(N=>[N,!0])),h}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const h of ue){switch(h.type){case 1:this.rawAdded.push(h.resource);break;case 0:this.rawUpdated.push(h.resource);break;case 2:this.rawDeleted.push(h.resource);break}this.b!==Y.a&&(typeof h.cId=="number"?this.b===void 0?this.b=h.cId:this.b!==h.cId&&(this.b=Y.a):this.b!==void 0&&(this.b=Y.a))}}contains(ue,...x){return this.h(ue,{includeChildren:!1},...x)}affects(ue,...x){return this.h(ue,{includeChildren:!0},...x)}h(ue,x,...h){if(!ue)return!1;const N=h.length>0;return!!((!N||h.includes(1))&&(this.d.value.get(ue)||x.includeChildren&&this.d.value.findSuperstr(ue))||(!N||h.includes(0))&&(this.f.value.get(ue)||x.includeChildren&&this.f.value.findSuperstr(ue))||(!N||h.includes(2))&&(this.g.value.findSubstr(ue)||x.includeChildren&&this.g.value.findSuperstr(ue)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ue){return this.b===ue}hasCorrelation(){return typeof this.b=="number"}}e.$jl=Y;function te(B,ue,x){return!B||!ue||B===ue||ue.length>B.length?!1:(ue.charAt(ue.length-1)!==S.sep&&(ue+=S.sep),x?(0,C.$zf)(B,ue):B.indexOf(ue)===0)}class G extends Error{constructor(ue,x,h){super(ue),this.fileOperationResult=x,this.options=h}}e.$ll=G;class ee extends G{constructor(ue,x,h,N){super(ue,x,N),this.fileOperationResult=x,this.size=h}}e.$ml=ee;class ce extends G{constructor(ue,x,h){super(ue,2,h),this.stat=x}}e.$nl=ce;var he;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(he||(e.FileOperationResult=he={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var X;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$vl="";function q(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}async function J(B,ue){if(!ue.hasProvider(j.URI.from({scheme:B.scheme})))return new Promise(x=>{const h=ue.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===B.scheme&&N.added&&(h.dispose(),x())})})}class K{static{this.KB=1024}static{this.MB=K.KB*K.KB}static{this.GB=K.MB*K.KB}static{this.TB=K.GB*K.KB}static formatSize(ue){return(0,M.$ag)(ue)||(ue=0),ue<K.KB?(0,P.localize)(1,null,ue.toFixed(0)):ue<K.MB?(0,P.localize)(2,null,(ue/K.KB).toFixed(2)):ue<K.GB?(0,P.localize)(3,null,(ue/K.MB).toFixed(2)):ue<K.TB?(0,P.localize)(4,null,(ue/K.GB).toFixed(2)):(0,P.localize)(5,null,(ue/K.TB).toFixed(2))}}e.$yl=K;function de(B){const ue=typeof B=="string"||B?.scheme===p.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===p.Schemas.file?1024*K.MB:ue?10*K.MB:r.$o?50*K.MB:1024*K.MB}}),define(fe[8],ge([0,1,70,56,4,49,2,25,3,23,9,6,35,21]),function(ae,e,y,S,C,M,j,P,l,r,p,u,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=m,e.log=n,e.$ek=w,e.$fk=F,e.$gk=Z,e.$hk=T,e.$3j=(0,o.$wi)("logService"),e.$4j=(0,o.$wi)("loggerService");function a(){return new Date().toISOString()}function m(R){return(0,p.$ag)(R)}var f;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$6j=f.Info;function n(R,g,O){switch(g){case f.Trace:R.trace(O);break;case f.Debug:R.debug(O);break;case f.Info:R.info(O);break;case f.Warning:R.warn(O);break;case f.Error:R.error(O);break;case f.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function s(R,g=!1){let O="";for(let b=0;b<R.length;b++){let A=R[b];if(A instanceof Error&&(A=(0,S.$hj)(A,g)),typeof A=="object")try{A=JSON.stringify(A)}catch{}O+=(b>0?" ":"")+A}return O}class d extends j.$Vc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new C.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==f.Off&&this.b<=g}}e.$8j=d;class v extends d{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...O){this.f(f.Trace)&&this.g(f.Trace,s([g,...O],!0))}debug(g,...O){this.f(f.Debug)&&this.g(f.Debug,s([g,...O]))}info(g,...O){this.f(f.Info)&&this.g(f.Info,s([g,...O]))}warn(g,...O){this.f(f.Warning)&&this.g(f.Warning,s([g,...O]))}error(g,...O){if(this.f(f.Error))if(g instanceof Error){const b=Array.prototype.slice.call(arguments);b[0]=g.stack,this.g(f.Error,s(b))}else this.g(f.Error,s([g,...O]))}flush(){}}e.$9j=v;class i extends d{constructor(g=e.$6j){super(),this.setLevel(g),this.g=!l.$i}trace(g,...O){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,g,...O):console.log(`[main ${a()}]`,g,...O))}debug(g,...O){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,g,...O):console.log(`[main ${a()}]`,g,...O))}info(g,...O){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,g,...O):console.log(`[main ${a()}]`,g,...O))}warn(g,...O){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,g,...O):console.warn(`[main ${a()}]`,g,...O))}error(g,...O){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,g,...O):console.error(`[main ${a()}]`,g,...O))}flush(){}}e.$0j=i;class t extends d{constructor(g=e.$6j,O=!0){super(),this.g=O,this.setLevel(g)}trace(g,...O){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",g,...O):console.log(g,...O))}debug(g,...O){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",g,...O):console.log(g,...O))}info(g,...O){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",g,...O):console.log(g,...O))}warn(g,...O){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",g,...O):console.log(g,...O))}error(g,...O){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",g,...O):console.error(g,...O))}flush(){}}e.$$j=t;class c extends d{constructor(g,O=e.$6j){super(),this.g=g,this.setLevel(O)}trace(g,...O){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(g),...O])}debug(g,...O){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(g),...O])}info(g,...O){this.f(f.Info)&&this.g.log(f.Info,[this.h(g),...O])}warn(g,...O){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(g),...O])}error(g,...O){this.f(f.Error)&&this.g.log(f.Error,[this.h(g),...O])}h(g){return typeof g=="string"?g:(0,S.$hj)(g,this.f(f.Trace))}flush(){}}e.$_j=c;class L extends d{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const O of this.g)O.setLevel(g);super.setLevel(g)}trace(g,...O){for(const b of this.g)b.trace(g,...O)}debug(g,...O){for(const b of this.g)b.debug(g,...O)}info(g,...O){for(const b of this.g)b.info(g,...O)}warn(g,...O){for(const b of this.g)b.warn(g,...O)}error(g,...O){for(const b of this.g)b.error(g,...O)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose();super.dispose()}}e.$ak=L;class $ extends j.$Vc{constructor(g,O,b){if(super(),this.h=g,this.j=O,this.b=new P.$Bc,this.c=this.B(new C.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$ee),this.onDidChangeVisibility=this.g.event,b)for(const A of b)this.b.set(A.resource,{logger:void 0,info:A})}m(g){return(0,p.$9f)(g)?[...this.b.values()].find(O=>O.info.id===g):this.b.get(g)}getLogger(g){return this.m(g)?.logger}createLogger(g,O){const b=this.n(g),A=(0,p.$9f)(g)?g:O?.id??(0,M.$kj)(b.toString()).toString(16);let Y=this.b.get(b)?.logger;const te=O?.logLevel==="always"?f.Trace:O?.logLevel;Y||(Y=this.s(b,te??this.getLogLevel(b)??this.h,{...O,id:A}));const G={logger:Y,info:{resource:b,id:A,logLevel:te,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(G.info),this.b.set(b,G),Y}n(g){return(0,p.$9f)(g)?(0,r.$0g)(this.j,`${g}.log`):g}setLogLevel(g,O){if(u.URI.isUri(g)){const b=g,A=O,Y=this.b.get(b);Y&&A!==Y.info.logLevel&&(Y.info.logLevel=A===this.h?void 0:A,Y.logger?.setLevel(A),this.b.set(Y.info.resource,Y),this.f.fire([b,A]))}else{this.h=g;for(const[b,A]of this.b.entries())this.b.get(b)?.info.logLevel===void 0&&A.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,O){const b=this.m(g);b&&O!==!b.info.hidden&&(b.info.hidden=!O,this.b.set(b.info.resource,b),this.g.fire([b.info.resource,O]))}getLogLevel(g){let O;return g&&(O=this.b.get(g)?.info.logLevel),O??this.h}registerLogger(g){const O=this.b.get(g.resource);O?O.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const O=this.b.get(g);O&&(O.logger&&O.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=$;class D{constructor(){this.onDidChangeLogLevel=new C.$ee().event}setLevel(g){}getLevel(){return f.Info}trace(g,...O){}debug(g,...O){}info(g,...O){}warn(g,...O){}error(g,...O){}critical(g,...O){}dispose(){}flush(){}}e.$ck=D;class E extends D{}e.$dk=E;function w(R){if(R.verbose)return f.Trace;if(typeof R.logLevel=="string"){const g=T(R.logLevel.toLowerCase());if(g!==void 0)return g}return e.$6j}function F(R){switch(R){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function Z(R){switch(R){case f.Trace:return{original:"Trace",value:y.localize(0,null)};case f.Debug:return{original:"Debug",value:y.localize(1,null)};case f.Info:return{original:"Info",value:y.localize(2,null)};case f.Warning:return{original:"Warning",value:y.localize(3,null)};case f.Error:return{original:"Error",value:y.localize(4,null)};case f.Off:return{original:"Off",value:y.localize(5,null)}}}function T(R){switch(R){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$ik=new k.$Nj("logLevel",F(f.Info))}),define(fe[80],ge([0,1,6,4,8,2]),function(ae,e,y,S,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=void 0;class j extends C.$bk{constructor(u,k,o,a,m){super(k,o,a),this.r=u,this.t=m,this.B(m.listen("onDidChangeLogLevel",u)(f=>{(0,C.$5j)(f)?super.setLogLevel(f):super.setLogLevel(y.URI.revive(f[0]),f[1])})),this.B(m.listen("onDidChangeVisibility",u)(([f,n])=>super.setVisibility(y.URI.revive(f),n))),this.B(m.listen("onDidChangeLoggers",u)(({added:f,removed:n})=>{for(const s of f)super.registerLogger({...s,resource:y.URI.revive(s.resource)});for(const s of n)super.deregisterLogger(s.resource)}))}createConsoleMainLogger(){return new C.$_j({log:(u,k)=>{this.t.call("consoleLog",[u,k])}})}registerLogger(u){super.registerLogger(u),this.t.call("registerLogger",[u,this.r])}deregisterLogger(u){super.deregisterLogger(u),this.t.call("deregisterLogger",[u,this.r])}setLogLevel(u,k){super.setLogLevel(u,k),this.t.call("setLogLevel",[u,k])}setVisibility(u,k){super.setVisibility(u,k),this.t.call("setVisibility",[this.n(u),k])}s(u,k,o){return new P(this.t,u,k,o,this.r)}static setLogLevel(u,k,o){return u.call("setLogLevel",[k,o])}}e.$_r=j;class P extends C.$9j{constructor(u,k,o,a,m){super(a?.logLevel==="always"),this.r=u,this.s=k,this.m=!1,this.n=[],this.setLevel(o),this.r.call("createLogger",[k,a,m]).then(()=>{this.u(this.n),this.m=!0})}g(u,k){const o=[[u,k]];this.m?this.u(o):this.n.push(...o)}u(u){this.r.call("log",[this.s,u])}}class l{constructor(u,k){this.a=u,this.b=k}listen(u,k){const o=this.b(u);switch(k){case"onDidChangeLoggers":return S.Event.map(this.a.onDidChangeLoggers,a=>({added:[...a.added].map(m=>this.c(m,o)),removed:[...a.removed].map(m=>this.c(m,o))}));case"onDidChangeVisibility":return S.Event.map(this.a.onDidChangeVisibility,a=>[o.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return S.Event.map(this.a.onDidChangeLogLevel,a=>(0,C.$5j)(a)?a:[o.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${k}`)}async call(u,k,o){const a=this.b(u);switch(k){case"setLogLevel":return(0,C.$5j)(o[0])?this.a.setLogLevel(o[0]):this.a.setLogLevel(y.URI.revive(a.transformIncoming(o[0][0])),o[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,a)))}throw new Error(`Call not found: ${k}`)}c(u,k){return{...u,resource:k.transformOutgoingURI(u.resource)}}}e.$as=l;class r extends M.$Vc{constructor(u,k){super(),k.call("setLogLevel",[u.getLogLevel()]),this.B(u.onDidChangeLogLevel(o=>k.call("setLogLevel",[o]))),k.call("getRegisteredLoggers").then(o=>{for(const a of o)u.registerLogger({...a,resource:y.URI.revive(a.resource)})}),this.B(k.listen("onDidChangeVisibility")(([o,a])=>u.setVisibility(y.URI.revive(o),a))),this.B(k.listen("onDidChangeLoggers")(({added:o,removed:a})=>{for(const m of o)u.registerLogger({...m,resource:y.URI.revive(m.resource)});for(const m of a)u.deregisterLogger(m.resource)}))}}e.$bs=r}),define(fe[81],ge([0,1,2,8]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=void 0;class C extends y.$Vc{constructor(j,P=[]){super(),this.a=new S.$ak([j,...P]),this.B(j.onDidChangeLogLevel(l=>this.setLevel(l)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...P){this.a.trace(j,...P)}debug(j,...P){this.a.debug(j,...P)}info(j,...P){this.a.info(j,...P)}warn(j,...P){this.a.warn(j,...P)}error(j,...P){this.a.error(j,...P)}flush(){this.a.flush()}}e.$OQ=C}),define(fe[82],ge([0,1,79,8]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=void 0;var C;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(C||(C={}));async function M(r,p,u,k,o){try{const a=await new Promise((f,n)=>{ae(["@vscode/spdlog"],f,n)});a.setFlushOn(C.Trace);const m=await a.createAsyncRotatingLogger(r,p,u,k);return o?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(a){console.error(a)}return null}function j(r,p,u){switch(p){case S.LogLevel.Trace:r.trace(u);break;case S.LogLevel.Debug:r.debug(u);break;case S.LogLevel.Info:r.info(u);break;case S.LogLevel.Warning:r.warn(u);break;case S.LogLevel.Error:r.error(u);break;case S.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function P(r,p){switch(p){case S.LogLevel.Trace:r.setLevel(C.Trace);break;case S.LogLevel.Debug:r.setLevel(C.Debug);break;case S.LogLevel.Info:r.setLevel(C.Info);break;case S.LogLevel.Warning:r.setLevel(C.Warning);break;case S.LogLevel.Error:r.setLevel(C.Error);break;case S.LogLevel.Off:r.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class l extends S.$9j{constructor(p,u,k,o,a){super(),this.m=[],this.setLevel(a),this.n=this.s(p,u,k,o),this.B(this.onDidChangeLogLevel(m=>{this.r&&P(this.r,m)}))}async s(p,u,k,o){const a=k?6:1,m=30/a*y.$yl.MB,f=await M(p,u,m,a,o);if(f){this.r=f,P(this.r,this.getLevel());for(const{level:n,message:s}of this.m)j(this.r,n,s);this.m=[]}}g(p,u){this.r?j(this.r,p,u):this.getLevel()<=p&&this.m.push({level:p,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$DQ=l}),define(fe[83],ge([0,1,52,8,82]),function(ae,e,y,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=void 0;class M extends S.$bk{s(P,l,r){return new C.$DQ((0,y.$Sg)(),P.fsPath,!r?.donotRotate,!!r?.donotUseFormatters,l)}}e.$EQ=M}),define(fe[84],ge([0,1,15]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let S;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const M=C.context.configuration();if(M)S=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(S=globalThis._VSCODE_PRODUCT_JSON,y.env.VSCODE_DEV&&Object.assign(S,{nameShort:`${S.nameShort} Dev`,nameLong:`${S.nameLong} Dev`,dataFolderName:`${S.dataFolderName}-dev`,serverDataFolderName:S.serverDataFolderName?`${S.serverDataFolderName}-dev`:void 0}),!S.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(S,{version:M.version})}}else S={},Object.keys(S).length===0&&Object.assign(S,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=S}),define(fe[85],ge([0,1,21]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,y.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"}),define(fe[86],ge([0,1,42,9]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class C{constructor(){this.a=new Map}add(j,P){y.ok(S.$9f(j)),y.ok(S.$$f(P)),y.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,P)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$co=new C}),define(fe[87],ge([0,1,4,2]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qub=void 0;class C extends S.$Vc{constructor(j){super(),this.f=j,this.type=4,this.a=new Map,this.b=new Map,this.c=this.B(new y.$ee),this.onMarkAdded=this.c.event}*markers(){for(const j of this.a.values())yield j;for(const j of this.b.values())yield j}addMark(j){const P=j?.marker||this.f.registerMarker(),l=j?.id;P&&(l?(this.a.set(l,P),P.onDispose(()=>this.a.delete(l))):(this.b.set(P.id,P),P.onDispose(()=>this.b.delete(P.id))),this.c.fire({marker:P,id:l,hidden:j?.hidden,hoverMessage:j?.hoverMessage}))}getMark(j){return this.a.get(j)}}e.$qub=C});var Ne=this&&this.__param||function(ae,e){return function(y,S){e(y,S,ae)}};define(fe[88],ge([0,1,4,2,8,14]),function(ae,e,y,S,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;var j;(function(l){l[l.Unknown=0]="Unknown",l[l.Input=1]="Input",l[l.Execute=2]="Execute"})(j||(j={}));let P=class extends S.$Vc{get value(){return this.h}get cursorIndex(){return this.j}get ghostTextIndex(){return this.m}constructor(r,p,u,k){super(),this.u=r,this.w=k,this.a=0,this.c=0,this.g="",this.h="",this.j=0,this.m=-1,this.n=this.B(new y.$ee),this.onDidStartInput=this.n.event,this.r=this.B(new y.$ee),this.onDidChangeInput=this.r.event,this.s=this.B(new y.$ee),this.onDidFinishInput=this.s.event,this.t=this.B(new y.$ee),this.onDidInterrupt=this.t.event,this.B(y.Event.any(this.u.onCursorMove,this.u.onData,this.u.onWriteParsed)(()=>this.F())),this.B(this.u.onData(o=>this.G(o))),this.B(p(o=>this.C(o))),this.B(u(()=>this.D())),this.B(this.onDidStartInput(()=>this.z("PromptInputModel#onDidStartInput"))),this.B(this.onDidChangeInput(()=>this.z("PromptInputModel#onDidChangeInput"))),this.B(this.onDidFinishInput(()=>this.z("PromptInputModel#onDidFinishInput"))),this.B(this.onDidInterrupt(()=>this.z("PromptInputModel#onDidInterrupt")))}z(r){this.w.getLevel()===C.LogLevel.Trace&&this.w.trace(r,this.getCombinedString())}setContinuationPrompt(r){this.f=r}setConfidentCommandLine(r){this.h!==r&&(this.h=r,this.j=-1,this.m=-1,this.r.fire(this.O()))}getCombinedString(){const r=this.h.replaceAll(`
`,"\u23CE");if(this.j===-1)return r;let p=`${r.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(p+=`${r.substring(this.cursorIndex,this.ghostTextIndex)}[`,p+=`${r.substring(this.ghostTextIndex)}]`):p+=r.substring(this.cursorIndex),p}C(r){this.a!==1&&(this.a=1,this.b=r.marker,this.c=this.u.buffer.active.cursorX,this.h="",this.j=0,this.n.fire(this.O()),this.r.fire(this.O()))}D(){if(this.a===2)return;this.j=-1,this.m!==-1&&(this.h=this.h.substring(0,this.m),this.m=-1);const r=this.O();this.g===""&&this.t.fire(r),this.a=2,this.s.fire(r),this.r.fire(r)}F(){if(this.a!==1)return;const r=this.b?.line;if(r===void 0)return;const p=this.u.buffer.active;let u=p.getLine(r);const k=u?.translateToString(!0,this.c);if(!u||k===void 0){this.w.trace("PromptInputModel#_sync: no line");return}const o=p.baseY+p.cursorY;let a=k,m=o===r?this.M(this.c,p,u):k.length+1,f=-1;o===r&&p.cursorX>1&&(f=this.H(p,u,m));for(let n=r+1;n<=o;n++){u=p.getLine(n);let s=u?.translateToString(!0);if(s&&u)if(this.f===void 0||this.J(s))s=this.I(s),a+=`
${s}`,m+=o===n?this.M(this.L(u,s),p,u):s.length+1;else break}for(let n=o+1;n<p.baseY+this.u.rows;n++){u=p.getLine(n);const s=u?.translateToString(!0);if(s&&u)if(this.f===void 0||this.J(s))a+=`
${this.I(s)}`;else break;else break}this.w.getLevel()===C.LogLevel.Trace&&this.w.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`),(this.h!==a||this.j!==m||this.m!==f)&&(this.h=a,this.j=m,this.m=f,this.r.fire(this.O()))}G(r){this.g=r}H(r,p,u){let k=-1,o=!1,a=r.cursorX;for(;a>0;){const m=p.getCell(--a);if(!m)break;if(m.getChars().trim().length>0){o=!this.N(m);break}}if(o){let m=0,f=r.cursorX;for(;f<p.length;){const n=p.getCell(f++);if(!n||n.getCode()===0)break;if(this.N(n)){k=u+m;break}m+=n.getChars().length}}return k}I(r){return this.J(r)&&(r=r.substring(this.f.length)),r}J(r){return!!(this.f&&r.startsWith(this.f))}L(r,p){if(!this.f||!p.startsWith(this.f))return 0;let u="",k=0;for(;u!==this.f;)u+=r.getCell(k++).getChars();return k}M(r,p,u){return u?.translateToString(!0,r,p.cursorX).length??0}N(r){return!!(r.isItalic()||r.isDim())}O(){return Object.freeze({value:this.h,cursorIndex:this.j,ghostTextIndex:this.m})}};e.$3r=P,we([(0,M.$3h)(0)],P.prototype,"F",null),e.$3r=P=we([Ne(3,C.$3j)],P)}),define(fe[89],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=void 0;class y{get command(){return this.b.command}get commandLineConfidence(){return this.b.commandLineConfidence}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get duration(){return this.b.duration}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(p){this.b.endMarker=p}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(p,u){this.a=p,this.b=u}static deserialize(p,u,k){const o=p.buffer.normal,a=u.startLine!==void 0?p.registerMarker(u.startLine-(o.baseY+o.cursorY)):void 0;if(!a)return;const m=u.promptStartLine!==void 0?p.registerMarker(u.promptStartLine-(o.baseY+o.cursorY)):void 0,f=u.endLine!==void 0?p.registerMarker(u.endLine-(o.baseY+o.cursorY)):void 0,n=u.executedLine!==void 0?p.registerMarker(u.executedLine-(o.baseY+o.cursorY)):void 0;return new y(p,{command:k?"":u.command,commandLineConfidence:u.commandLineConfidence??"low",isTrusted:u.isTrusted,promptStartMarker:m,marker:a,startX:u.startX,endMarker:f,executedMarker:n,executedX:u.executedX,timestamp:u.timestamp,duration:u.duration,cwd:u.cwd,commandStartLineContent:u.commandStartLineContent,exitCode:u.exitCode,markProperties:u.markProperties,aliases:void 0,wasReplayed:!0})}serialize(p){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:p?"":this.command,commandLineConfidence:p?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return C(this.a.buffer.active,this.a.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const p=this.executedMarker.line,u=this.endMarker.line;if(p===u)return;let k="",o;for(let a=p;a<u;a++)o=this.a.buffer.active.getLine(a),o&&(k+=o.translateToString(!o.isWrapped)+(o.isWrapped?"":`
`));return k===""?void 0:k}getOutputMatch(p){if(!this.executedMarker||!this.endMarker)return;const u=this.endMarker.line;if(u===-1)return;const k=this.a.buffer.active,o=Math.max(this.executedMarker.line,0),a=p.lineMatcher,m=typeof a=="string"?1:p.length||j(a),f=[];let n;if(p.anchor==="bottom")for(let s=u-(p.offset||0);s>=o;s--){let d=s;const v=s;for(;d>=o&&k.getLine(d)?.isWrapped;)d--;if(s=d,f.unshift(M(k,d,v,this.a.cols)),n||(n=f[0].match(a)),f.length>=m)break}else for(let s=o+(p.offset||0);s<u;s++){const d=s;let v=s;for(;v+1<u&&k.getLine(v+1)?.isWrapped;)v++;if(s=v,f.push(M(k,d,v,this.a.cols)),n||(n=f[f.length-1].match(a)),f.length>=m)break}return n?{regexMatch:n,outputLines:f}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return P(this,this.a.buffer.active)}getCommandRowCount(){return l(this)}}e.$4r=y;class S{constructor(p){this.c=p}serialize(p){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:p,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(p,u,k,o){if(u===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||k)return new y(this.c,{command:k?"":this.command||"",commandLineConfidence:k?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.b||0,cwd:p,exitCode:u,commandStartLineContent:this.commandStartLineContent,markProperties:o})}markExecutedTime(){this.a===void 0&&(this.a=Date.now())}markFinishedTime(){this.b===void 0&&this.a!==void 0&&(this.b=Date.now()-this.a)}extractCommandLine(){return C(this.c.buffer.active,this.c.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return P(this,this.c.buffer.active)}getCommandRowCount(){return l(this)}}e.$5r=S;function C(r,p,u,k,o,a){if(!u||!o||k===void 0||a===void 0)return"";let m="";for(let f=u.line;f<=o.line;f++){const n=r.getLine(f);n&&(m+=n.translateToString(!0,f===u.line?k:0,f===o.line?a:p))}return m}function M(r,p,u,k){const o=Math.max(2048/k*2);u=Math.min(u,p+o);let a="";for(let m=p;m<=u;m++){const f=r.getLine(m);f&&(a+=f.translateToString(!0,0,k))}return a}function j(r){if(!r.multiline)return 1;const p=r.source;let u=1,k=p.indexOf("\\n");for(;k!==-1;)u++,k=p.indexOf("\\n",k+1);return u}function P(r,p){const u="hasOutput"in r?r.marker:r.commandStartMarker;if(!u||!r.promptStartMarker)return 1;let k=1,o=r.promptStartMarker.line;for(;o<u.line&&(p.getLine(o)?.translateToString(!0)??"").length===0;)o++;return k=u.line-o+1,k}function l(r){const p="hasOutput"in r?r.marker:r.commandStartMarker,u="hasOutput"in r?r.executedMarker:r.commandExecutedMarker;if(!p||!u)return 1;let o=Math.max(u.line,p.line)-p.line+1;return("hasOutput"in r?r.executedX:r.commandExecutedX)===0&&o--,o}}),define(fe[90],ge([0,1,11,14,4,2,8,89,88]),function(ae,e,y,S,C,M,j,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mub=void 0,e.$nub=o;let r=class extends M.$Vc{get promptInputModel(){return this.c}get commands(){return this.f}get executingCommand(){return this.h.command}get executingCommandObject(){if(this.h.commandStartMarker)return{marker:this.h.commandStartMarker}}get currentCommand(){return this.h}get cwd(){return this.g}get C(){return!!(this.h.commandStartMarker&&!this.h.commandExecutedMarker)}get hasInput(){if(!(!this.C||!this.h?.commandStartMarker)){if(this.L.buffer.active.baseY+this.L.buffer.active.cursorY===this.h.commandStartMarker?.line){const n=this.L.buffer.active.getLine(this.L.buffer.active.cursorY)?.translateToString(!0,this.h.commandStartX);return n===void 0?void 0:n.length>0}return!0}}constructor(n,s){super(),this.L=n,this.M=s,this.type=2,this.f=[],this.h=new P.$5r(this.L),this.n=[],this.s=!1,this.D=this.B(new C.$ee),this.onCommandStarted=this.D.event,this.F=this.B(new C.$ee),this.onBeforeCommandFinished=this.F.event,this.G=this.B(new C.$ee),this.onCommandFinished=this.G.event,this.H=this.B(new C.$ee),this.onCommandExecuted=this.H.event,this.I=this.B(new C.$ee),this.onCommandInvalidated=this.I.event,this.J=this.B(new C.$ee),this.onCurrentCommandInvalidated=this.J.event,this.c=this.B(new l.$3r(this.L,this.onCommandStarted,this.onCommandExecuted,this.M)),this.B(this.onCommandExecuted(v=>{if(v.commandLineConfidence!=="high"){const i=v;v.command=i.extractCommandLine(),v.commandLineConfidence="low","getOutput"in i?i.promptStartMarker&&i.marker&&i.executedMarker&&v.command.indexOf(`
`)===-1&&i.startX!==void 0&&i.startX>0&&(v.commandLineConfidence="medium"):i.promptStartMarker&&i.commandStartMarker&&i.commandExecutedMarker&&v.command.indexOf(`
`)===-1&&i.commandStartX!==void 0&&i.commandStartX>0&&(v.commandLineConfidence="medium")}}));const d=this;this.w=new class{get onCurrentCommandInvalidatedEmitter(){return d.J}get onCommandStartedEmitter(){return d.D}get onCommandExecutedEmitter(){return d.H}get dimensions(){return d.r}get isCommandStorageDisabled(){return d.s}get commandMarkers(){return d.n}set commandMarkers(v){d.n=v}get clearCommandsInViewport(){return d.P.bind(d)}commitCommandFinished(){d.u?.flush(),d.u=void 0}},this.z=this.B(new M.$Xc(new p(this.L,this,this.w,this.M))),this.r={cols:this.L.cols,rows:this.L.rows},this.B(this.L.onResize(v=>this.N(v))),this.B(this.L.onCursorMove(()=>this.O()))}N(n){this.z.value.preHandleResize?.(n),this.r.cols=n.cols,this.r.rows=n.rows}O(){this.L.buffer.active===this.L.buffer.normal&&this.h.commandStartMarker&&this.L.buffer.active.baseY+this.L.buffer.active.cursorY<this.h.commandStartMarker.line&&(this.P(),this.h.isInvalid=!0,this.J.fire({reason:"windows"}))}P(){let n=0;for(let s=this.f.length-1;s>=0;s--){const d=this.f[s].marker?.line;if(d&&d<this.L.buffer.active.baseY)break;n++}n>0&&this.I.fire(this.f.splice(this.f.length-n,n))}setContinuationPrompt(n){this.c.setContinuationPrompt(n)}setCwd(n){this.g=n}setIsWindowsPty(n){if(n&&!(this.z.value instanceof k)){const s=this;this.z.value=new k(this.L,this,new class{get onCurrentCommandInvalidatedEmitter(){return s.J}get onCommandStartedEmitter(){return s.D}get onCommandExecutedEmitter(){return s.H}get dimensions(){return s.r}get isCommandStorageDisabled(){return s.s}get commandMarkers(){return s.n}set commandMarkers(d){s.n=d}get clearCommandsInViewport(){return s.P.bind(s)}commitCommandFinished(){s.u?.flush(),s.u=void 0}},this.M)}else!n&&!(this.z.value instanceof p)&&(this.z.value=new p(this.L,this,this.w,this.M))}setIsCommandStorageDisabled(){this.s=!0}getCommandForLine(n){if(this.h.promptStartMarker&&n>=this.h.promptStartMarker?.line)return this.h;if(this.f.length!==0&&!((this.f[0].promptStartMarker??this.f[0].marker).line>n)){for(let s=this.commands.length-1;s>=0;s--)if((this.commands[s].promptStartMarker??this.commands[s].marker).line<=n)return this.commands[s]}}getCwdForLine(n){if(this.h.promptStartMarker&&n>=this.h.promptStartMarker?.line)return this.g;const s=this.getCommandForLine(n);if(s&&"cwd"in s)return s.cwd}handlePromptStart(n){const s=this.commands.at(-1);s?.endMarker&&s?.executedMarker&&s.endMarker.line===s.executedMarker.line&&(this.M.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${s.endMarker.line} -> ${s.executedMarker.line+1}`),s.endMarker=m(this.L,s.executedMarker,1)),this.h.promptStartMarker=n?.marker||(s?.endMarker?m(this.L,s.endMarker):this.L.registerMarker(0)),this.M.debug("CommandDetectionCapability#handlePromptStart",this.L.buffer.active.cursorX,this.h.promptStartMarker?.line)}handleContinuationStart(){this.h.currentContinuationMarker=this.L.registerMarker(0),this.M.debug("CommandDetectionCapability#handleContinuationStart",this.h.currentContinuationMarker)}handleContinuationEnd(){if(!this.h.currentContinuationMarker){this.M.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.h.continuations||(this.h.continuations=[]),this.h.continuations.push({marker:this.h.currentContinuationMarker,end:this.L.buffer.active.cursorX}),this.h.currentContinuationMarker=void 0,this.M.debug("CommandDetectionCapability#handleContinuationEnd",this.h.continuations[this.h.continuations.length-1])}handleRightPromptStart(){this.h.commandRightPromptStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptStart",this.h.commandRightPromptStartX)}handleRightPromptEnd(){this.h.commandRightPromptEndX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptEnd",this.h.commandRightPromptEndX)}handleCommandStart(n){if(this.t=n,this.h.cwd=this.g,this.h.commandStartMarker=n?.marker||this.h.commandStartMarker,this.h.commandStartMarker?.line===this.L.buffer.active.cursorY){this.h.commandStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleCommandStart",this.h.commandStartX,this.h.commandStartMarker?.line);return}this.z.value.handleCommandStart(n)}handleGenericCommand(n){n?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(n),this.handleCommandStart(n),this.handleCommandExecuted(n),this.handleCommandFinished(void 0,n)}handleCommandExecuted(n){this.z.value.handleCommandExecuted(n),this.h.markExecutedTime()}handleCommandFinished(n,s){if(this.h.markFinishedTime(),this.z.value.preHandleCommandFinished?.(),this.M.debug("CommandDetectionCapability#handleCommandFinished",this.L.buffer.active.cursorX,s?.marker?.line,this.h.command,this.h),n===void 0){const v=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.h.command&&this.h.command.length>0&&v?.command===this.h.command&&(n=v.exitCode)}if(this.h.commandStartMarker===void 0||!this.L.buffer.active)return;this.h.commandFinishedMarker=s?.marker||this.L.registerMarker(0),this.z.value.postHandleCommandFinished?.();const d=this.h.promoteToFullCommand(this.g,n,this.t?.ignoreCommandLine??!1,s?.markProperties);d&&(this.f.push(d),this.u=new y.$Ih(()=>{this.F.fire(d),this.h.isInvalid||(this.M.debug("CommandDetectionCapability#onCommandFinished",d),this.G.fire(d))},50),this.u.schedule()),this.h=new P.$5r(this.L),this.t=void 0}setCommandLine(n,s){this.M.debug("CommandDetectionCapability#setCommandLine",n,s),this.h.command=n,this.h.commandLineConfidence="high",this.h.isTrusted=s,s&&this.c.setConfidentCommandLine(n)}serialize(){const n=this.commands.map(d=>d.serialize(this.s)),s=this.h.serialize(this.g);return s&&n.push(s),{isWindowsPty:this.z.value instanceof k,commands:n}}deserialize(n){n.isWindowsPty&&this.setIsWindowsPty(n.isWindowsPty);const s=this.L.buffer.normal;for(const d of n.commands){if(!d.endLine){const i=d.startLine!==void 0?this.L.registerMarker(d.startLine-(s.baseY+s.cursorY)):void 0;if(!i)continue;this.h.commandStartMarker=d.startLine!==void 0?this.L.registerMarker(d.startLine-(s.baseY+s.cursorY)):void 0,this.h.commandStartX=d.startX,this.h.promptStartMarker=d.promptStartLine!==void 0?this.L.registerMarker(d.promptStartLine-(s.baseY+s.cursorY)):void 0,this.g=d.cwd,this.D.fire({marker:i});continue}const v=P.$4r.deserialize(this.L,d,this.s);v&&(this.f.push(v),this.M.debug("CommandDetectionCapability#onCommandFinished",v),this.G.fire(v))}}};e.$mub=r,we([(0,S.$2h)(500)],r.prototype,"O",null),e.$mub=r=we([Ne(1,j.$3j)],r);class p extends M.$Vc{constructor(n,s,d,v){super(),this.c=n,this.f=s,this.g=d,this.h=v,this.B(n.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&d.clearCommandsInViewport(),!1)))}handleCommandStart(n){this.g.commitCommandFinished();const s=this.f.currentCommand;s.commandStartX=this.c.buffer.active.cursorX,s.commandStartMarker=n?.marker||this.c.registerMarker(0),s.commandExecutedMarker?.dispose(),s.commandExecutedMarker=void 0,s.commandExecutedX=void 0;for(const d of this.g.commandMarkers)d.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:n?.marker||s.commandStartMarker,markProperties:n?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",s.commandStartX,s.commandStartMarker?.line)}handleCommandExecuted(n){const s=this.f.currentCommand;if(s.commandExecutedMarker=n?.marker||this.c.registerMarker(0),s.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",s.commandExecutedX,s.commandExecutedMarker?.line),!s.commandStartMarker||!s.commandExecutedMarker||s.commandStartX===void 0)return;s.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(s.commandStartMarker.line)?.translateToString(!0,s.commandStartX,s.commandRightPromptStartX).trim();let d=s.commandStartMarker.line+1;const v=s.commandExecutedMarker.line;for(;d<v;d++){const i=this.c.buffer.active.getLine(d);if(i){const t=s.continuations?.find(L=>L.marker.line===d);t&&(s.command+=`
`);const c=t?.end??0;s.command+=i.translateToString(!0,c)}}d===v&&(s.command+=this.c.buffer.active.getLine(v)?.translateToString(!0,void 0,s.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire(s)}}var u;(function(f){f[f.MaxCheckLineCount=10]="MaxCheckLineCount",f[f.Interval=20]="Interval",f[f.MaximumPollCount=10]="MaximumPollCount"})(u||(u={}));let k=class extends M.$Vc{constructor(n,s,d,v){super(),this.n=n,this.r=s,this.s=d,this.t=v,this.c=this.B(new M.$Wc),this.g=0,this.h=0,this.B(n.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&this.s.clearCommandsInViewport(),!1))),this.B(this.r.onBeforeCommandFinished(i=>{(i.command.trim().toLowerCase()==="clear"||i.command.trim().toLowerCase()==="cls")&&(this.f?.cancel(),this.f=void 0,this.s.clearCommandsInViewport(),this.r.currentCommand.isInvalid=!0,this.s.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(n){const s=this.n.buffer.active.baseY,d=n.rows-this.s.dimensions.rows;d>0&&this.D().then(()=>{const v=Math.min(d,s);for(let i=this.r.commands.length-1;i>=0;i--){const t=this.r.commands[i];if(!t.marker||t.marker.line<s||t.commandStartLineContent===void 0)break;const c=this.n.buffer.active.getLine(t.marker.line);if(!c||c.translateToString(!0)===t.commandStartLineContent)continue;const L=t.marker.line-v;this.n.buffer.active.getLine(L)?.translateToString(!0)===t.commandStartLineContent&&this.n._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.n.buffer.active.baseY,amount:v})}})}handleCommandStart(){this.r.currentCommand.commandStartX=this.n.buffer.active.cursorX,this.s.commandMarkers.length=0;const n=this.r.currentCommand.commandStartMarker=this.r.currentCommand.promptStartMarker?m(this.n,this.r.currentCommand.promptStartMarker):this.n.registerMarker(0);this.r.currentCommand.commandStartX=0,this.g=0,this.h=0,this.f=new y.$Ih(()=>this.u(n),20),this.f.schedule()}u(n){if(this.q.isDisposed)return;const s=this.n.buffer.active;let d=this.g;for(;d<10&&n.line+d<s.baseY+this.n.rows;){if(this.C()){const v=this.F(n.line+d);if(v){const i=typeof v=="string"?v:v.prompt;if(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0),typeof v=="object"&&v.likelySingleLine){this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.r.currentCommand.promptStartMarker?.line} -> ${this.r.currentCommand.commandStartMarker.line}`),this.r.currentCommand.promptStartMarker?.dispose(),this.r.currentCommand.promptStartMarker=m(this.n,this.r.currentCommand.commandStartMarker);const t=this.r.commands.at(-1);t&&this.r.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=m(this.n,this.r.currentCommand.commandStartMarker))}this.r.currentCommand.commandStartX=i.length,this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${n.line} -> ${this.r.currentCommand.commandStartMarker.line}:${this.r.currentCommand.commandStartX}`),this.w();return}}d++}d<10?(this.g=d,++this.h<10?this.f?.schedule():this.w()):this.w()}w(){if(this.f&&(this.h=10,this.f.flush(),this.f=void 0),this.s.commitCommandFinished(),this.r.currentCommand.commandExecutedMarker||(this.c.value=this.n.onCursorMove(()=>{if(this.s.commandMarkers.length===0||this.s.commandMarkers[this.s.commandMarkers.length-1].line!==this.n.buffer.active.cursorY){const n=this.n.registerMarker(0);n&&this.s.commandMarkers.push(n)}})),this.r.currentCommand.commandStartMarker){const n=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);n&&(this.r.currentCommand.commandStartLineContent=n.translateToString(!0))}this.s.onCommandStartedEmitter.fire({marker:this.r.currentCommand.commandStartMarker}),this.t.debug("CommandDetectionCapability#_handleCommandStartWindows",this.r.currentCommand.commandStartX,this.r.currentCommand.commandStartMarker?.line)}handleCommandExecuted(n){this.f&&this.w(),this.c.clear(),this.z(),this.r.currentCommand.commandExecutedX=this.n.buffer.active.cursorX,this.s.onCommandExecutedEmitter.fire(this.r.currentCommand),this.t.debug("CommandDetectionCapability#handleCommandExecuted",this.r.currentCommand.commandExecutedX,this.r.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.r.currentCommand.commandExecutedMarker||(this.s.commandMarkers.length===0&&(this.r.currentCommand.commandStartMarker||(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0)),this.r.currentCommand.commandStartMarker&&this.s.commandMarkers.push(this.r.currentCommand.commandStartMarker)),this.z())}postHandleCommandFinished(){const n=this.r.currentCommand,s=n.command,d=n.commandStartMarker?.line,v=n.commandExecutedMarker?.line;if(!s||s.length===0||d===void 0||d===-1||v===void 0||v===-1)return;let i=0,t=!1;for(let c=d;c<=v;c++){const L=this.n.buffer.active.getLine(c);if(!L)break;const $=L.translateToString(!0);for(let D=0;D<$.length;D++){for(;s.length<i&&s[i]===" ";)i++;if($[D]===s[i]&&i++,i===s.length){const E=D>=this.n.cols-1;n.commandExecutedMarker=this.n.registerMarker(c-(this.n.buffer.active.baseY+this.n.buffer.active.cursorY)+(E?1:0)),n.commandExecutedX=E?0:D+1,t=!0;break}}if(t)break}}z(){if(this.s.commandMarkers.length!==0){if(this.s.commandMarkers=this.s.commandMarkers.sort((n,s)=>n.line-s.line),this.r.currentCommand.commandStartMarker=this.s.commandMarkers[0],this.r.currentCommand.commandStartMarker){const n=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);n&&(this.r.currentCommand.commandStartLineContent=n.translateToString(!0))}this.r.currentCommand.commandExecutedMarker=this.s.commandMarkers[this.s.commandMarkers.length-1],this.s.onCommandExecutedEmitter.fire(this.r.currentCommand)}}C(){const n=this.r.commands.at(-1);if(!n)return!0;const s=this.n.buffer.active.baseY+this.n.buffer.active.cursorY,d=(n.endMarker?n.endMarker.line:n.marker?.line)??-1;return s>d}D(){const n=this.n.buffer.active.cursorX,s=this.n.buffer.active.cursorY;let d=0;return new Promise((v,i)=>{const t=setInterval(()=>{if(n!==this.n.buffer.active.cursorX||s!==this.n.buffer.active.cursorY){v(),clearInterval(t);return}d+=10,d>1e3&&(clearInterval(t),v())},10)})}F(n=this.n.buffer.active.baseY+this.n.buffer.active.cursorY){const s=this.n.buffer.active.getLine(n);if(!s)return;const d=s.translateToString(!0);if(!d)return;const v=d.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(v){const $=this.G(v,d,">");if($)return{prompt:$,likelySingleLine:!0}}const i=d.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(i){const $=this.G(i,d,"\u276F");if($)return $}const t=d.match(/^(?<prompt>\$)/)?.groups?.prompt;if(t){const $=this.G(t,d,"$");if($)return $}const c=d.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(c)return{prompt:c,likelySingleLine:!0};const L=d.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return L?.groups?.prompt?{prompt:L.groups.prompt,likelySingleLine:!0}:void 0}G(n,s,d){if(n)return s===n&&n.endsWith(d)&&(n+=" "),n}};k=we([Ne(3,j.$3j)],k);function o(f,n,s,d){if(!d)return;const v=n.executedMarker,i=n.endMarker;if(!v||!i)return;const t=v.line,c=i.line,L=d.length,$=[];if(d.anchor==="bottom")for(let D=c-(d.offset||0);D>=t;D--){let E=D;const w=D;for(;E>=t&&f.getLine(E)?.isWrapped;)E--;D=E,$.unshift(a(f,E,w,s)),$.length>L&&$.pop()}else for(let D=t+(d.offset||0);D<c;D++){const E=D;let w=D;for(;w+1<c&&f.getLine(w+1)?.isWrapped;)w++;D=w,$.push(a(f,E,w,s)),$.length===L&&$.shift()}return $}function a(f,n,s,d){const v=Math.max(2048/d*2);s=Math.min(s,n+v);let i="";for(let t=n;t<=s;t++){const c=f.getLine(t);c&&(i+=c.translateToString(!0,0,d))}return i}function m(f,n,s=0){return f.registerMarker(n.line-(f.buffer.active.baseY+f.buffer.active.cursorY)+s)}}),define(fe[91],ge([0,1,4,2]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oub=void 0;class C extends S.$Vc{constructor(){super(...arguments),this.type=0,this.a="",this.b=new Map,this.c=this.B(new y.$ee),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(j){const P=this.a!==j;this.a=j;const l=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,l+1),P&&this.c.fire(j)}}e.$oub=C}),define(fe[92],ge([0,1,4,2]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pub=void 0;var C;(function(j){j[j.MinimumPromptLength=2]="MinimumPromptLength"})(C||(C={}));class M extends S.$Uc{get commands(){return this.a}constructor(P){super(),this.c=P,this.type=3,this.a=[],this.b=this.add(new y.$ee),this.onCommandFinished=this.b.event,this.add(this.c.onData(l=>this.h(l))),this.add(this.c.parser.registerCsiHandler({final:"J"},l=>(l.length>=1&&(l[0]===2||l[0]===3)&&this.m(),!1)))}h(P){P==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=2){const P=this.c.registerMarker(0);P&&(this.a.push(P),this.b.fire(P))}}m(){let P=0;for(let l=this.a.length-1;l>=0&&!(this.a[l].line<this.c.buffer.active.baseY);l--)P++;this.a.splice(this.a.length-P,P)}}e.$pub=M}),define(fe[93],ge([0,1,4,2]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lub=e.$kub=void 0;class C extends S.$Vc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new y.$ee),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new y.$ee),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new y.$ee),this.onDidRemoveCapability=this.g.event,this.h=this.B(new y.$ee),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(P,l){this.a.set(P,l),this.f.fire(P),this.h.fire({id:P,capability:l})}get(P){return this.a.get(P)}remove(P){const l=this.a.get(P);l&&(this.a.delete(P),this.b.fire(P),this.h.fire({id:P,capability:l}))}has(P){return this.a.has(P)}}e.$kub=C;class M extends S.$Vc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new y.$ee),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new y.$ee),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new y.$ee),this.onDidRemoveCapability=this.f.event,this.g=this.B(new y.$ee),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const P of this._stores)for(const l of P.items)yield l}has(P){for(const l of this._stores)for(const r of l.items)if(r===P)return!0;return!1}get(P){for(const l of this._stores){const r=l.get(P);if(r)return r}}add(P){this._stores.push(P);for(const l of P.items)this.b.fire(l),this.g.fire({id:l,capability:P.get(l)});this.B(P.onDidAddCapabilityType(l=>this.b.fire(l))),this.B(P.onDidAddCapability(l=>this.g.fire(l))),this.B(P.onDidRemoveCapabilityType(l=>this.a.fire(l))),this.B(P.onDidRemoveCapability(l=>this.f.fire(l)))}}e.$lub=M}),define(fe[36],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(S){S[S.Replace=1]="Replace",S[S.Append=2]="Append",S[S.Prepend=3]="Prepend"})(y||(e.EnvironmentVariableMutatorType=y={}))}),define(fe[94],ge([0,1,3,36]),function(ae,e,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0;const C=new Map([[S.EnvironmentVariableMutatorType.Append,"APPEND"],[S.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[S.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(p){this.collections=p,this.a=new Map,this.b=new Map,p.forEach((u,k)=>{this.d(u,k);const o=u.map.entries();let a=o.next();for(;!a.done;){const m=a.value[1],f=a.value[0];let n=this.a.get(f);if(n||(n=[],this.a.set(f,n)),n.length>0&&n[0].type===S.EnvironmentVariableMutatorType.Replace){a=o.next();continue}const s={extensionIdentifier:k,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};s.scope||delete s.scope,n.unshift(s),a=o.next()}})}async applyToProcessEnvironment(p,u,k){let o;y.$i&&(o={},Object.keys(p).forEach(a=>o[a.toLowerCase()]=a));for(const[a,m]of this.getVariableMap(u)){const f=y.$i&&o[a.toLowerCase()]||a;for(const n of m){const s=k?await k(n.value):n.value;if(n.options?.applyAtProcessCreation??!0)switch(n.type){case S.EnvironmentVariableMutatorType.Append:p[f]=(p[f]||"")+s;break;case S.EnvironmentVariableMutatorType.Prepend:p[f]=s+(p[f]||"");break;case S.EnvironmentVariableMutatorType.Replace:p[f]=s;break}if(n.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${C.get(n.type)}`;p[d]=(p[d]?p[d]+":":"")+a+"="+this.c(s)}}}}c(p){return p.replaceAll(":","\\x3a")}diff(p,u){const k=new Map,o=new Map,a=new Map;if(p.getVariableMap(u).forEach((m,f)=>{const n=this.getVariableMap(u).get(f),s=P(m,n);s&&k.set(f,s)}),this.getVariableMap(u).forEach((m,f)=>{const n=p.getVariableMap(u).get(f),s=P(m,n);s&&a.set(f,s)}),this.getVariableMap(u).forEach((m,f)=>{const n=p.getVariableMap(u).get(f),s=l(m,n);s&&o.set(f,s)}),!(k.size===0&&o.size===0&&a.size===0))return{added:k,changed:o,removed:a}}getVariableMap(p){const u=new Map;for(const k of this.a.values()){const o=k.filter(a=>j(a,p));o.length>0&&u.set(o[0].variable,o)}return u}getDescriptionMap(p){const u=new Map;for(const k of this.b.values()){const o=k.filter(a=>j(a,p,!0));for(const a of o)u.set(a.extensionIdentifier,a.description)}return u}d(p,u){if(!p.descriptionMap)return;const k=p.descriptionMap.entries();let o=k.next();for(;!o.done;){const a=o.value[1],m=o.value[0];let f=this.b.get(m);f||(f=[],this.b.set(m,f));const n={extensionIdentifier:u,scope:a.scope,description:a.description};n.scope||delete n.scope,f.push(n),o=k.next()}}}e.$rs=M;function j(r,p,u=!1){return r.scope?!!(r.scope.workspaceFolder&&p?.workspaceFolder&&r.scope.workspaceFolder.index===p.workspaceFolder.index):u?p===r.scope:!0}function P(r,p){if(!p)return r;const u=new Set;p.forEach(o=>u.add(o.extensionIdentifier));const k=[];return r.forEach(o=>{u.has(o.extensionIdentifier)||k.push(o)}),k.length===0?void 0:k}function l(r,p){if(!p)return;const u=new Map;p.forEach(o=>u.set(o.extensionIdentifier,o));const k=[];return r.forEach(o=>{const a=u.get(o.extensionIdentifier);a&&(o.type!==a.type||o.value!==a.value||o.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&k.push(a)}),k.length===0?void 0:k}}),define(fe[95],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=y,e.$ms=S,e.$ns=C,e.$os=M,e.$ps=j,e.$qs=P;function y(l){return[...l.entries()]}function S(l){return l?[...l.entries()]:[]}function C(l){return new Map(l)}function M(l){return new Map(l??[])}function j(l){return Array.from(l.entries()).map(r=>[r[0],y(r[1].map),S(r[1].descriptionMap)])}function P(l){return new Map(l.map(r=>[r[0],{map:C(r[1]),descriptionMap:M(r[2])}]))}}),define(fe[96],ge([0,1,11,17,4,2,8]),function(ae,e,y,S,C,M,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0;let P=class extends M.$Vc{constructor(r,p){super(),this.h=p,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new C.$ee),this.onCreateRequest=this.g.event,this.b=r===void 0?15e3:r,this.B((0,M.$Tc)(()=>{for(const u of this.f.values())(0,M.$Qc)(u)}))}createRequest(r){return new Promise((p,u)=>{const k=++this.a;this.c.set(k,p),this.g.fire({requestId:k,...r});const o=new S.$pe;(0,y.$xh)(this.b,o.token).then(()=>u(`Request ${k} timed out (${this.b}ms)`)),this.f.set(k,[(0,M.$Tc)(()=>o.cancel())])})}acceptReply(r,p){const u=this.c.get(r);u?(this.c.delete(r),(0,M.$Qc)(this.f.get(r)||[]),this.f.delete(r),u(p)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${r}`)}};e.$cs=P,e.$cs=P=we([Ne(1,j.$3j)],P)}),define(fe[28],ge([0,1,21,35,86]),function(ae,e,y,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$8r=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$7r=void 0,e.$7r=new S.$Nj("terminalTabFocusMode",!1,!0);var M;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var j;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",i.LocalEchoEnabled="terminal.integrated.localEchoEnabled",i.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",i.LocalEchoStyle="terminal.integrated.localEchoStyle",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",i.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",i.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",i.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",i.MouseWheelZoom="terminal.integrated.mouseWheelZoom",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var P;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(P||(e.PosixShellType=P={}));var l;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(l||(e.WindowsShellType=l={}));var r;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(r||(e.TitleEventSource=r={}));var p;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(p||(e.TerminalIpcChannels=p={}));var u;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(u||(e.ProcessPropertyType=u={})),e.$8r=(0,y.$wi)("ptyService");var k;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var o;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(o||(e.TerminalLocation=o={}));var a;(function(i){i.TerminalView="view",i.Editor="editor"})(a||(e.TerminalLocationString=a={}));var m;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var f;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var n;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(n||(e.ProfileSource=n={}));var s;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(s||(e.ShellIntegrationStatus=s={}));var d;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.$9r={Backend:"workbench.contributions.terminal.processBackend"};class v{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const c=this.b(t.remoteAuthority);if(this.a.has(c))throw new Error(`A terminal backend with remote authority '${c}' was already registered.`);this.a.set(c,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}C.$co.add(e.$9r.Backend,new v),e.$0r=(0,y.$wi)("localPtyService"),e.$$r=(0,y.$wi)("terminalLogService")}),define(fe[97],ge([0,1,11,2,3]),function(ae,e,y,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;class M extends S.$Vc{constructor(P,l,r,p){super(),this.a=0,this.b=!1,this.c=!1,this.B(P.onProcessData(u=>{if(this.b||this.c)return;const k=typeof u=="string"?u:u.data;for(let o=0;o<k.length;o++)k[o]===l[this.a]?this.a++:this.f(),this.a===l.length&&(p.debug(`Auto reply match: "${l}", response: "${r}"`),P.input(r),this.c=!0,(0,y.$xh)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){C.$i&&(this.b=!0)}handleInput(){this.b=!1}}e.$Aic=M}),define(fe[98],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gvb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,M,j=5){const P=M(l=>{const r=typeof l=="string"?l:l.data;let p=this.a.get(C);if(p){p.data.push(r);return}const u=setTimeout(()=>this.flushBuffer(C),j);p={data:[r],timeoutId:u,dispose:()=>{clearTimeout(u),this.flushBuffer(C),P.dispose()}},this.a.set(C,p)});return P}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const M=this.a.get(C);M&&(this.a.delete(C),this.b(C,M.data.join("")))}}e.$Gvb=y}),define(fe[37],ge([0,1,3]),function(ae,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=S,e.$fQ=C,e.$gQ=M,e.$hQ=j;function S(P){let l=P;l.includes("\\")&&(l=l.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return l=l.replace(r,""),`'${l}'`}function C(P,l,r){if(!P)return"";if(!l)return P;l.match(/[\/\\]$/)&&(l=l.slice(0,l.length-1));const p=P.replace(/\\/g,"/").toLowerCase(),u=l.replace(/\\/g,"/").toLowerCase();return p.includes(u)?`~${r}${P.slice(l.length+1)}`:P}function M(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),y.OS===1&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}function j(P){return!P.strictEnv}}),define(fe[99],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=S;var y;(function(C){C[C.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(y||(y={}));function S(C){const M=[];let j=0;for(let P=0;P<C.length-1;P++)(P-j+1>=50||C[P+1]==="\x1B")&&(M.push(C.substring(j,P+1)),j=P+1,P++);return j!==C.length&&M.push(C.substring(j)),M}}),define(fe[100],ge([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MUb=y;function y(S,C={}){let M="";return C.excludeLeadingNewLine||(M+=`\r
`),M+="\x1B[0m\x1B[7m * ",C.loudFormatting?M+="\x1B[0;104m":M+="\x1B[0m",M+=` ${S} \x1B[0m
\r`,M}}),define(fe[101],ge([0,1,2,93,90,91,92,4,87,6,37]),function(ae,e,y,S,C,M,j,P,l,r,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rub=e.ShellIntegrationOscPs=void 0,e.$sub=m,e.$tub=f,e.$uub=n;var u;(function(s){s[s.FinalTerm=133]="FinalTerm",s[s.VSCode=633]="VSCode",s[s.ITerm=1337]="ITerm",s[s.SetCwd=7]="SetCwd",s[s.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(u||(e.ShellIntegrationOscPs=u={}));var k;(function(s){s.PromptStart="A",s.CommandStart="B",s.CommandExecuted="C",s.CommandFinished="D",s.CommandLine="E",s.ContinuationStart="F",s.ContinuationEnd="G",s.RightPromptStart="H",s.RightPromptEnd="I",s.Property="P",s.SetMark="SetMark"})(k||(k={}));var o;(function(s){s.SetMark="SetMark",s.CurrentDir="CurrentDir"})(o||(o={}));class a extends y.$Vc{get status(){return this.g}constructor(d,v,i,t){super(),this.j=d,this.m=v,this.n=i,this.r=t,this.capabilities=this.B(new S.$kub),this.b=!1,this.f=[],this.g=0,this.h=new P.$ee,this.onDidChangeStatus=this.h.event,this.B((0,y.$Tc)(()=>{this.z(),this.s()}))}s(){(0,y.$Qc)(this.f),this.f.length=0}activate(d){this.a=d,this.capabilities.add(3,this.B(new j.$pub(this.a))),this.B(d.parser.registerOscHandler(633,v=>this.w(v))),this.B(d.parser.registerOscHandler(1337,v=>this.G(v))),this.f.push(d.parser.registerOscHandler(133,v=>this.t(v))),this.B(d.parser.registerOscHandler(7,v=>this.I(v))),this.B(d.parser.registerOscHandler(9,v=>this.H(v))),this.y()}getMarkerId(d,v){this.M(d).getMark(v)}t(d){const v=this.u(d);return this.g===0&&(this.g=1,this.h.fire(this.g)),v}u(d){if(!this.a)return!1;const[v,...i]=d.split(";");switch(v){case"A":return this.L(this.a).handlePromptStart(),!0;case"B":return this.L(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this.L(this.a).handleCommandExecuted(),!0;case"D":{const t=i.length===1?parseInt(i[0]):void 0;return this.L(this.a).handleCommandFinished(t),!0}}return!1}w(d){const v=this.C(d);return!this.b&&v&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==2&&(this.g=2,this.h.fire(this.g)),v}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(d){if(!this.a)return!1;const v=d.indexOf(";"),i=v===-1?d:d.substring(0,v),t=v===-1?[]:d.substring(v+1).split(";");switch(i){case"A":return this.L(this.a).handlePromptStart(),!0;case"B":return this.L(this.a).handleCommandStart(),!0;case"C":return this.L(this.a).handleCommandExecuted(),!0;case"D":{const c=t[0],L=c!==void 0?parseInt(c):void 0;return this.L(this.a).handleCommandFinished(L),!0}case"E":{const c=t[0],L=t[1];let $;return c!==void 0?$=m(c):$="",this.L(this.a).setCommandLine($,L===this.j),!0}case"F":return this.L(this.a).handleContinuationStart(),!0;case"G":return this.L(this.a).handleContinuationEnd(),!0;case"H":return this.L(this.a).handleRightPromptStart(),!0;case"I":return this.L(this.a).handleRightPromptEnd(),!0;case"P":{const c=t[0],L=c!==void 0?m(c):"",{key:$,value:D}=f(L);if(D===void 0)return!0;switch($){case"ContinuationPrompt":{const E=D.replace(/\x1b\[[0-9;]*m/g,"").replace(/\\\[.*?\\\]/g,"");return this.D(E),!0}case"Cwd":return this.F(D),!0;case"IsWindows":return this.L(this.a).setIsWindowsPty(D==="True"),!0;case"Task":return this.M(this.a),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this.M(this.a).addMark(n(t)),!0}return!1}D(d){this.a&&this.L(this.a).setContinuationPrompt(d)}F(d){d=(0,p.$gQ)(d),this.J().updateCwd(d),this.capabilities.get(2)?.setCwd(d)}G(d){if(!this.a)return!1;const[v]=d.split(";");switch(v){case"SetMark":this.M(this.a).addMark();default:{const{key:i,value:t}=f(v);if(t===void 0)return!0;switch(i){case"CurrentDir":return this.F(t),!0}}}return!1}H(d){if(!this.a)return!1;const[v,...i]=d.split(";");switch(v){case"9":return i.length&&this.F(i[0]),!0}return!1}I(d){if(!this.a)return!1;const[v]=d.split(";");if(v.match(/^file:\/\/.*\//)){const i=r.URI.parse(v);if(i.path&&i.path.length>0)return this.F(i.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this.L(this.a).serialize()}deserialize(d){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.L(this.a).deserialize(d)}J(){let d=this.capabilities.get(0);return d||(d=this.B(new M.$oub),this.capabilities.add(0,d)),d}L(d){let v=this.capabilities.get(2);return v||(v=this.B(new C.$mub(d,this.r)),this.capabilities.add(2,v)),v}M(d){let v=this.capabilities.get(4);return v||(v=this.B(new l.$qub(d)),this.capabilities.add(4,v)),v}}e.$rub=a;function m(s){return s.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(d,v,i)=>i?String.fromCharCode(parseInt(i,16)):v)}function f(s){const d=s.indexOf("=");return d===-1?{key:s,value:void 0}:{key:s.substring(0,d),value:s.substring(1+d)}}function n(s){let d,v=!1;for(const i of s)i!==void 0&&(i==="Hidden"&&(v=!0),i.startsWith("Id=")&&(d=i.substring(3)));return{id:d,hidden:v}}}),define(fe[38],ge([0,1,5,14,4,2,62,8]),function(ae,e,y,S,C,M,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=e.$Bic=void 0;var l;(function(p){p[p.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",p[p.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(l||(l={})),e.$Bic=[];let r=class extends M.$Vc{set hasChildProcesses(u){this.a!==u&&(this.a=u,this.f.debug("ChildProcessMonitor: Has child processes changed",u),this.b.fire(u))}get hasChildProcesses(){return this.a}constructor(u,k){super(),this.c=u,this.f=k,this.a=!1,this.b=this.B(new C.$ee),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const u=await(0,j.$Ds)(this.c);this.hasChildProcesses=this.j(u)}catch(u){this.f.debug("ChildProcessMonitor: Fetching process tree failed",u)}}h(){this.g()}j(u){if(!u.children)return!1;if(u.children.length===1){const k=u.children[0];let o;if(k.cmd.startsWith('"'))o=k.cmd.substring(1,k.cmd.indexOf('"',1));else{const a=k.cmd.indexOf(" ");a===-1?o=k.cmd:o=k.cmd.substring(0,a)}return e.$Bic.indexOf((0,y.$rc)(o).name)===-1}return u.children.length>0}};e.$Cic=r,we([(0,S.$2h)(1e3)],r.prototype,"g",null),we([(0,S.$3h)(5e3)],r.prototype,"h",null),e.$Cic=r=we([Ne(1,P.$3j)],r)}),define(fe[102],ge([0,1,4,2,28]),function(ae,e,y,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;class M extends S.$Vc{constructor(){super(),this.a=this.B(new y.$ee),this.onBeat=this.a.event;const P=setInterval(()=>{this.a.fire()},C.HeartbeatConstants.BeatInterval);this.B((0,S.$Tc)(()=>clearInterval(P)))}}e.$Dic=M}),define(fe[39],ge([0,1,20,19,30,5,3,15,12,9,24,36,95,94]),function(ae,e,y,S,C,M,j,P,l,r,p,u,k,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=a,e.$ts=m,e.$us=f;function a(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let w=0;return E&&E.length===4&&(w=parseInt(E[3])),w}async function m(E,w,F,Z=P.env,T=p.Promises.exists){if(M.$jc(E))return await T(E)?E:void 0;if(w===void 0&&(w=P.cwd()),M.$nc(E)!=="."){const b=M.$kc(w,E);return await T(b)?b:void 0}const g=(0,C.$0n)(Z,"PATH");if(F===void 0&&(0,r.$9f)(g)&&(F=g.split(M.$uc)),F===void 0||F.length===0){const b=M.$kc(w,E);return await T(b)?b:void 0}for(const b of F){let A;if(M.$jc(b)?A=M.$kc(b,E):A=M.$kc(w,b,E),await T(A))return A;if(j.$i){let Y=A+".com";if(await T(Y)||(Y=A+".exe",await T(Y)))return Y}}const O=M.$kc(w,E);return await T(O)?O:void 0}function f(E,w,F,Z,T){const R=j.$i&&(!w.windowsEnableConpty||a()<18309);if(!w.shellIntegration.enabled||!E.executable||E.isFeatureTerminal&&!E.forceShellIntegration||E.ignoreShellIntegration||R)return;const g=E.args,O=P.$ec==="win32"?M.$oc(E.executable).toLowerCase():M.$oc(E.executable),b=M.$nc(S.$Qg.asFileUri("").fsPath);let A;const Y={VSCODE_INJECTION:"1"};if(w.shellIntegration.nonce&&(Y.VSCODE_NONCE=w.shellIntegration.nonce),j.$i){if(O==="pwsh.exe"||O==="powershell.exe")return!g||$(g)?A=d.get(s.WindowsPwsh):L(g)&&(A=d.get(s.WindowsPwshLogin)),A?(A=[...A],A[A.length-1]=(0,l.$9e)(A[A.length-1],b,""),w.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),{newArgs:A,envMixin:Y}):void 0;if(O==="bash.exe")return!g||g.length===0?A=d.get(s.Bash):D(g)&&(Y.VSCODE_SHELL_LOGIN="1",n(w,Y),A=d.get(s.Bash)),A?(A=[...A],A[A.length-1]=(0,l.$9e)(A[A.length-1],b),{newArgs:A,envMixin:Y}):void 0;Z.warn(`Shell integration cannot be enabled for executable "${E.executable}" and args`,E.args);return}switch(O){case"bash":return!g||g.length===0?A=d.get(s.Bash):D(g)&&(Y.VSCODE_SHELL_LOGIN="1",n(w,Y),A=d.get(s.Bash)),A?(A=[...A],A[A.length-1]=(0,l.$9e)(A[A.length-1],b),{newArgs:A,envMixin:Y}):void 0;case"fish":{const te=F?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",G=M.$kc(b,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Y.XDG_DATA_DIRS=`${te}:${G}`,n(w,Y),{newArgs:void 0,envMixin:Y}}case"pwsh":return!g||$(g)?A=d.get(s.Pwsh):L(g)&&(A=d.get(s.PwshLogin)),A?(w.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),A=[...A],A[A.length-1]=(0,l.$9e)(A[A.length-1],b,""),{newArgs:A,envMixin:Y}):void 0;case"zsh":{if(!g||g.length===0?A=d.get(s.Zsh):D(g)?(A=d.get(s.ZshLogin),n(w,Y)):(g===d.get(s.Zsh)||g===d.get(s.ZshLogin))&&(A=g),!A)return;A=[...A],A[A.length-1]=(0,l.$9e)(A[A.length-1],b);let te;try{te=y.userInfo().username}catch{te="unknown"}const G=M.$kc(y.tmpdir(),`${te}-${T.applicationName}-zsh`);Y.ZDOTDIR=G;const ee=F?.ZDOTDIR??y.homedir()??"~";Y.USER_ZDOTDIR=ee;const ce=[];return ce.push({source:M.$kc(b,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$kc(G,".zshrc")}),ce.push({source:M.$kc(b,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$kc(G,".zprofile")}),ce.push({source:M.$kc(b,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$kc(G,".zshenv")}),ce.push({source:M.$kc(b,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$kc(G,".zlogin")}),{newArgs:A,envMixin:Y,filesToCopy:ce}}}Z.warn(`Shell integration cannot be enabled for executable "${E.executable}" and args`,E.args)}function n(E,w){if(j.$j&&E.environmentVariableCollections){const F=(0,k.$qs)(E.environmentVariableCollections),T=new o.$rs(F).getVariableMap({workspaceFolder:E.workspaceFolder}).get("PATH"),R=[];if(T)for(const g of T)g.type===u.EnvironmentVariableMutatorType.Prepend&&R.push(g.value);R.length>0&&(w.VSCODE_PATH_PREFIX=R.join(""))}}var s;(function(E){E.WindowsPwsh="windows-pwsh",E.WindowsPwshLogin="windows-pwsh-login",E.Pwsh="pwsh",E.PwshLogin="pwsh-login",E.Zsh="zsh",E.ZshLogin="zsh-login",E.Bash="bash"})(s||(s={}));const d=new Map;d.set(s.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(s.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(s.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(s.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(s.Zsh,["-i"]),d.set(s.ZshLogin,["-il"]),d.set(s.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],i=["--login","-l"],t=["-i","--interactive"],c=["-nol","-nologo"];function L(E){return typeof E=="string"?v.includes(E.toLowerCase()):E.length===1&&v.includes(E[0].toLowerCase())||E.length===2&&(v.includes(E[0].toLowerCase())||v.includes(E[1].toLowerCase()))&&(c.includes(E[0].toLowerCase())||c.includes(E[1].toLowerCase()))}function $(E){return typeof E=="string"?c.includes(E.toLowerCase()):E.length===0||E?.length===1&&c.includes(E[0].toLowerCase())}function D(E){return typeof E!="string"&&(E=E.filter(w=>!t.includes(w.toLowerCase()))),E==="string"&&i.includes(E.toLowerCase())||typeof E!="string"&&E.length===1&&i.includes(E[0].toLowerCase())}}),define(fe[103],ge([0,1,11,14,4,2,3]),function(ae,e,y,S,C,M,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;const P=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let l;class r extends M.$Vc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(u){if(super(),this.h=u,this.c="",this.f=new C.$ee,this.g=new C.$ee,!j.$i)throw new Error(`WindowsShellHelper cannot be instantiated on ${j.$u}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){j.$i&&(await(0,y.$xh)(300),this.getShellName().then(u=>{const k=this.getShellType(u);k!==this.b&&(this.g.fire(k),this.f.fire(u),this.b=k,this.c=u)}))}m(u){if(!u)return"";if(P.indexOf(u.name)===-1||!u.children||u.children.length===0)return u.name;let k=0;for(;k<u.children.length;k++){const o=u.children[k];if(!o.children||o.children.length===0||o.children[0].name!=="conhost.exe")break}return k>=u.children.length?u.name:this.m(u.children[k])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(l||(l=await new Promise((u,k)=>{ae(["@vscode/windows-process-tree"],u,k)})),this.a=new Promise(u=>{l.getProcessTree(this.h,k=>{const o=this.m(k);this.a=void 0,u(o)})}),this.a)}getShellType(u){switch(u.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return u.match(/python(\d(\.\d{0,2})?)?\.exe/)?"python":void 0}}}e.$Eic=r,we([(0,S.$2h)(500)],r.prototype,"checkShell",null)}),define(fe[104],ge([0,1,26,11,4,2,5,3,6,24,72,8,85,38,39,103,109,99]),function(ae,e,y,S,C,M,j,P,l,r,p,u,k,o,a,m,f,n){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;var d;(function(L){L[L.DataFlushTimeout=250]="DataFlushTimeout",L[L.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(d||(d={}));var v;(function(L){L[L.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",L[L.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",L[L.WriteInterval=5]="WriteInterval"})(v||(v={}));const i=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["python","python"],["zsh","zsh"]]);let t=class extends M.$Vc{static{s=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return P.$i?this.t?.shellType:i.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor($,D,E,w,F,Z,T,R,g){super(),this.shellLaunchConfig=$,this.N=Z,this.O=T,this.P=R,this.Q=g,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new C.$ee),this.onProcessData=this.I.event,this.J=this.B(new C.$ee),this.onProcessReady=this.J.event,this.L=this.B(new C.$ee),this.onDidChangeProperty=this.L.event,this.M=this.B(new C.$ee),this.onProcessExit=this.M.event;let O;P.$i?O=j.$oc(this.shellLaunchConfig.executable||""):O="xterm-256color",this.D=D,this.a.initialCwd=this.D,this.a.cwd=this.D;const b=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,a.$ss)()>=18309;this.F={name:O,cwd:D,env:F,cols:E,rows:w,useConpty:b,conptyInheritCursor:b&&!!$.initialText},P.$i&&(b&&E===0&&w===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new c,this.B(this.C.onTrigger(A=>{this.C?.dispose(),this.C=void 0,A.cols&&A.rows&&this.resize(A.cols,A.rows)}))),this.onProcessReady(A=>{this.t=this.B(new m.$Eic(A.pid)),this.B(this.t.onShellTypeChanged(Y=>this.L.fire({type:"shellType",value:Y}))),this.B(this.t.onShellNameChanged(Y=>this.L.fire({type:"title",value:Y})))})),this.B((0,M.$Tc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const D=(await Promise.all([this.R(),this.S()])).find(w=>w!==void 0);if(D)return D;let E;if(this.O.shellIntegration.enabled)if(E=(0,a.$us)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),E){if(this.L.fire({type:"usedShellIntegrationInjection",value:!0}),E.envMixin)for(const[w,F]of Object.entries(E.envMixin))this.F.env||={},this.F.env[w]=F;if(E.filesToCopy)for(const w of E.filesToCopy){await r.Promises.mkdir(j.$nc(w.dest),{recursive:!0});try{await r.Promises.copyFile(w.source,w.dest)}catch{}}}else this.L.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.U(this.shellLaunchConfig,this.F,E),E?.newArgs?{injectedArgs:E.newArgs}:void 0}catch(w){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",w),{message:`A native exception occurred during launch (${w.message})`}}}async R(){try{if(!(await r.Promises.stat(this.D)).isDirectory())return{message:(0,p.localize)(0,null,this.D.toString())}}catch($){if($?.code==="ENOENT")return{message:(0,p.localize)(1,null,this.D.toString())}}this.L.fire({type:"initialCwd",value:this.D})}async S(){const $=this.shellLaunchConfig;if(!$.executable)throw new Error("IShellLaunchConfig.executable not set");const D=$.cwd instanceof l.URI?$.cwd.path:$.cwd,E=$.env&&$.env.PATH?$.env.PATH.split(j.$uc):void 0,w=await(0,a.$ts)($.executable,D,E,this.N);if(!w)return{message:(0,p.localize)(2,null,$.executable)};try{const F=await r.Promises.stat(w);if(!F.isFile()&&!F.isSymbolicLink())return{message:(0,p.localize)(3,null,$.executable)};$.executable=w}catch(F){if(F?.code!=="EACCES")throw F}}async U($,D,E){const w=E?.newArgs||$.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",$.executable,w,D);const F=(0,f.spawn)($.executable,w,D);this.m=F,this.u=this.B(new o.$Cic(F.pid,this.P)),this.u.onDidChangeHasChildProcesses(Z=>this.L.fire({type:"hasChildProcesses",value:Z})),this.s=new Promise(Z=>{this.onProcessReady(()=>Z())}),F.onData(Z=>{this.H+=Z.length,!this.G&&this.H>1e5&&(this.P.trace(`Flow control: Pause (${this.H} > 100000)`),this.G=!0,F.pause()),this.P.trace("node-pty.IPty#onData",Z),this.I.fire(Z),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),F.onExit(Z=>{this.g=Z.exitCode,this.X()}),this.$(F.pid),this.W(F)}W($){setTimeout(()=>this.ab($)),P.$i||(this.w=setInterval(()=>{this.n!==$.process&&this.ab($)},200))}X(){this.P.getLevel()===u.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},250)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!P.$i||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-s.b<250;)this.P.trace("Throttling kill/spawn call"),await(0,S.$xh)(250-(Date.now()-s.b)+50);s.b=Date.now()}}$($){this.J.fire({pid:$,cwd:this.D,windowsPty:this.getWindowsPty()})}ab($){if(this.q.isDisposed)return;this.n=$.process,this.L.fire({type:"title",value:this.n});const D=this.currentTitle.replace(/ \(figterm\)$/g,"");D.toLowerCase().startsWith("python")?this.L.fire({type:"shellType",value:"python"}):this.L.fire({type:"shellType",value:i.get(D)})}shutdown($){this.P.getLevel()===u.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),$&&!P.$i?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},5e3))}input($,D=!1){this.q.isDisposed||!this.m||(this.y.push(...(0,n.$6r)($).map(E=>({isBinary:D,data:E}))),this.bb())}async processBinary($){this.input($,!0)}async refreshProperty($){switch($){case"cwd":{const D=await this.getCwd();return D!==this.a.cwd&&(this.a.cwd=D,this.L.fire({type:"cwd",value:this.a.cwd})),D}case"initialCwd":{const D=await this.getInitialCwd();return D!==this.a.initialCwd&&(this.a.initialCwd=D,this.L.fire({type:"initialCwd",value:this.a.initialCwd})),D}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty($,D){$==="fixedDimensions"&&(this.a.fixedDimensions=D)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},5)}}cb(){const $=this.y.shift();this.P.trace("node-pty.IPty#write",$.data),$.isBinary?this.m.write(Buffer.from($.data,"binary")):this.m.write($.data),this.u?.handleInput()}resize($,D){if(!this.q.isDisposed&&!(typeof $!="number"||typeof D!="number"||isNaN($)||isNaN(D))&&this.m){if($=Math.max($,1),D=Math.max(D,1),this.C){this.C.cols=$,this.C.rows=D;return}this.P.trace("node-pty.IPty#resize",$,D);try{this.m.resize($,D)}catch(E){if(this.P.trace("node-pty.IPty#resize exception "+E.message),this.g!==void 0&&E.message!=="ioctl(2) failed, EBADF"&&E.message!=="Cannot resize a pty that has already exited")throw E}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent($){this.H=Math.max(this.H-$,0),this.P.trace(`Flow control: Ack ${$} chars (unacknowledged: ${this.H})`),this.G&&this.H<5e3&&(this.P.trace(`Flow control: Resume (${this.H} < 5000)`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if(P.$j)return new Promise($=>{if(!this.m){$(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,y.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(D,E,w)=>{!D&&E!==""?$(E.substring(E.indexOf("/"),E.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",D,E,w),$(this.D))})});if(P.$k){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await r.Promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return P.$i?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,a.$ss)()}:void 0}};e.$Fic=t,e.$Fic=t=s=we([Ne(7,u.$3j),Ne(8,k.$jk)],t);class c extends M.$Vc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new C.$ee),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,M.$Tc)(()=>clearTimeout(this.a)))}}}),define(fe[105],ge([0,1,26,11,4,2,3,63,8,96,28,98,37,110,39,104,71,38,97,7,101,100,77,14,111]),function(ae,e,y,S,C,M,j,P,l,r,p,u,k,o,a,m,f,n,s,d,v,i,t,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0,e.$Gic=$;function $(O,b,A){if(typeof A.value!="function")throw new Error("not supported");const Y="value",te=A.value;A[Y]=async function(...G){this.traceRpcArgs.logService.getLevel()===l.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${te.name}(${G.map(ce=>JSON.stringify(ce)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,S.$xh)(this.traceRpcArgs.simulatedLatency);let ee;try{ee=await te.apply(this,G)}catch(ce){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${te.name}`,ce),ce}return this.traceRpcArgs.logService.getLevel()===l.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${te.name}`,ee),ee}}let D,E;class w extends M.$Vc{H(b,A){return A(Y=>{this.I.getLevel()===l.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${b}.fire(${JSON.stringify(Y)})`)}),A}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor(b,A,Y,te){super(),this.I=b,this.J=A,this.L=Y,this.M=te,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new C.$ee),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new C.$ee),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new C.$ee),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new C.$ee),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new C.$ee),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new C.$ee),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new C.$ee),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new C.$ee),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,M.$Tc)(()=>{for(const G of this.a.values())G.shutdown(!0);this.a.clear()})),this.f=this.B(new r.$cs(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames(b){n.$Bic.length=0,n.$Bic.push(...b)}async requestDetachInstance(b,A){return this.f.createRequest({workspaceId:b,instanceId:A})}async acceptDetachInstanceReply(b,A){let Y;const te=this.a.get(A);te&&(Y=await this.S(A,te)),this.f.acceptReply(b,Y)}async freePortKillProcess(b){const Y=(await new Promise((te,G)=>{(0,y.exec)(j.$i?`netstat -ano | findstr "${b}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${b}`,{},(ee,ce)=>{if(ee)return G("Problem occurred when listing active processes");te(ce)})})).split(/\r?\n/).filter(te=>!!te.trim());if(Y.length>=1){const te=/\s+(\d+)(?:\s+|$)/,G=Y[0].match(te)?.[1];if(G)try{process.kill(Number.parseInt(G))}catch{}else throw new Error(`Processes for port ${b} were not found`);return{port:b,processId:G}}throw new Error(`Could not kill process with port ${b}`)}async serializeTerminalState(b){const A=[];for(const[te,G]of this.a.entries())G.hasWrittenData&&b.indexOf(te)!==-1&&A.push(S.Promises.withAsyncBody(async ee=>{ee({id:te,shellLaunchConfig:G.shellLaunchConfig,processDetails:await this.S(te,G),processLaunchConfig:G.processLaunchOptions,unicodeVersion:G.unicodeVersion,replayEvent:await G.serializeNormalBuffer(),timestamp:Date.now()})}));const Y={version:1,state:await Promise.all(A)};return JSON.stringify(Y)}async reviveTerminalProcesses(b,A,Y){const te=[];for(const G of A)te.push(this.N(b,G));await Promise.all(te)}async N(b,A){const Y=(0,f.localize)(0,null),te=await this.createProcess({...A.shellLaunchConfig,cwd:A.processDetails.cwd,color:A.processDetails.color,icon:A.processDetails.icon,name:A.processDetails.titleSource===p.TitleEventSource.Api?A.processDetails.title:void 0,initialText:A.replayEvent.events[0].data+(0,i.$MUb)(Y,{loudFormatting:!0})},A.processDetails.cwd,A.replayEvent.events[0].cols,A.replayEvent.events[0].rows,A.unicodeVersion,A.processLaunchConfig.env,A.processLaunchConfig.executableEnv,A.processLaunchConfig.options,!0,A.processDetails.workspaceId,A.processDetails.workspaceName,!0,A.replayEvent.events[0].data),G=this.R(b,A.id);this.g.set(G,{newId:te,state:A}),this.I.info(`Revived process, old id ${G} -> new id ${te}`)}async shutdownAll(){this.dispose()}async createProcess(b,A,Y,te,G,ee,ce,he,X,q,J,K,de){if(b.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const B=++this.n,ue=new m.$Fic(b,A,Y,te,ee,ce,he,this.I,this.J),x={env:ee,executableEnv:ce,options:he},h=new Z(B,ue,q,J,X,Y,te,x,G,this.L,this.I,K&&typeof b.initialText=="string"?b.initialText:void 0,de,b.icon,b.color,b.name,b.fixedDimensions);return ue.onProcessExit(N=>{h.dispose(),this.a.delete(B),this.C.fire({id:B,event:N})}),h.onProcessData(N=>this.w.fire({id:B,event:N})),h.onProcessReplay(N=>this.y.fire({id:B,event:N})),h.onProcessReady(N=>this.z.fire({id:B,event:N})),h.onProcessOrphanQuestion(()=>this.D.fire({id:B})),h.onDidChangeProperty(N=>this.G.fire({id:B,property:N})),h.onPersistentProcessReady(()=>{for(const N of this.j.entries())h.installAutoReply(N[0],N[1])}),this.a.set(B,h),B}async attachToProcess(b){try{await this.U(b).attach(),this.I.info(`Persistent process reconnection "${b}"`)}catch(A){throw this.I.warn(`Persistent process reconnection "${b}" failed`,A.message),A}}async updateTitle(b,A,Y){this.U(b).setTitle(A,Y)}async updateIcon(b,A,Y,te){this.U(b).setIcon(A,Y,te)}async clearBuffer(b){this.U(b).clearBuffer()}async refreshProperty(b,A){return this.U(b).refreshProperty(A)}async updateProperty(b,A,Y){return this.U(b).updateProperty(A,Y)}async detachFromProcess(b,A){return this.U(b).detach(A)}async reduceConnectionGraceTime(){for(const b of this.a.values())b.reduceGraceTime()}async listProcesses(){const b=Array.from(this.a.entries()).filter(([te,G])=>G.shouldPersistTerminal);this.I.info(`Listing ${b.length} persistent terminals, ${this.a.size} total terminals`);const A=b.map(async([te,G])=>this.S(te,G));return(await Promise.all(A)).filter(te=>te.isOrphan)}async getPerformanceMarks(){return L.getMarks()}async start(b){const A=this.a.get(b);return A?A.start():{message:`Could not find pty with id "${b}"`}}async shutdown(b,A){return this.a.get(b)?.shutdown(A)}async input(b,A){return this.U(b).input(A)}async processBinary(b,A){return this.U(b).writeBinary(A)}async resize(b,A,Y){return this.U(b).resize(A,Y)}async getInitialCwd(b){return this.U(b).getInitialCwd()}async getCwd(b){return this.U(b).getCwd()}async acknowledgeDataEvent(b,A){return this.U(b).acknowledgeDataEvent(A)}async setUnicodeVersion(b,A){return this.U(b).setUnicodeVersion(A)}async getLatency(){return[]}async orphanQuestionReply(b){return this.U(b).orphanQuestionReply()}async installAutoReply(b,A){this.j.set(b,A);for(const Y of this.a.values())Y.installAutoReply(b,A)}async uninstallAllAutoReplies(){for(const b of this.j.keys())for(const A of this.a.values())A.uninstallAutoReply(b)}async uninstallAutoReply(b){for(const A of this.a.values())A.uninstallAutoReply(b)}async getDefaultSystemShell(b=j.OS){return(0,P.$qm)(b,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(b,A){if(A==="win-to-unix"){if(!j.$i)return b;if((0,a.$ss)()<17063)return b.replace(/\\/g,"/");const Y=this.O();return Y?new Promise(te=>{(0,y.execFile)(Y,["-e","wslpath",b],{},(ee,ce,he)=>{te(ee?b:(0,k.$eQ)(ce.trim()))}).stdin.end()}):b}if(A==="unix-to-win"&&j.$i){if((0,a.$ss)()<17063)return b;const Y=this.O();return Y?new Promise(te=>{(0,y.execFile)(Y,["-e","wslpath","-w",b],{},(ee,ce,he)=>{te(ee?b:ce.trim())}).stdin.end()}):b}return b}O(){const b=(0,a.$ss)()>=16299,A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Y=process.env.SystemRoot;if(Y)return(0,t.join)(Y,A?"Sysnative":"System32",b?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(b,A){try{return this.g.get(this.R(b,A))?.newId}catch(Y){this.I.warn(`Couldn't find terminal ID ${b}-${A}`,Y.message)}}async setTerminalLayoutInfo(b){this.b.set(b.workspaceId,b)}async getTerminalLayoutInfo(b){L.mark("code/willGetTerminalLayoutInfo");const A=this.b.get(b.workspaceId);if(A){const Y=new Set,G=(await Promise.all(A.tabs.map(async ee=>this.P(b.workspaceId,ee,Y)))).filter(ee=>ee.terminals.length>0);return L.mark("code/didGetTerminalLayoutInfo"),{tabs:G}}L.mark("code/didGetTerminalLayoutInfo")}async P(b,A,Y){const G=(await Promise.all(A.terminals.map(ee=>this.Q(b,ee,Y)))).filter(ee=>ee.terminal!==null);return{isActive:A.isActive,activePersistentProcessId:A.activePersistentProcessId,terminals:G}}async Q(b,A,Y){try{const te=this.R(b,A.terminal),G=this.g.get(te)?.newId;this.I.info(`Expanding terminal instance, old id ${te} -> new id ${G}`),this.g.delete(te);const ee=G??A.terminal;if(Y.has(ee))throw new Error(`Terminal ${ee} has already been expanded`);Y.add(ee);const ce=this.U(ee);return{terminal:{...ce&&await this.S(A.terminal,ce,G!==void 0),id:ee},relativeSize:A.relativeSize}}catch(te){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",te.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",A),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:A.relativeSize}}}R(b,A){return`${b}-${A}`}async S(b,A,Y=!1){L.mark(`code/willBuildProcessDetails/${b}`);const[te,G]=await Promise.all([A.getCwd(),Y?!0:A.isOrphaned()]),ee={id:b,title:A.title,titleSource:A.titleSource,pid:A.pid,workspaceId:A.workspaceId,workspaceName:A.workspaceName,cwd:te,isOrphan:G,icon:A.icon,color:A.color,fixedDimensions:A.fixedDimensions,environmentVariableCollections:A.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:A.shellLaunchConfig.reconnectionProperties,waitOnExit:A.shellLaunchConfig.waitOnExit,hideFromUser:A.shellLaunchConfig.hideFromUser,isFeatureTerminal:A.shellLaunchConfig.isFeatureTerminal,type:A.shellLaunchConfig.type,hasChildProcesses:A.hasChildProcesses,shellIntegrationNonce:A.processLaunchOptions.options.shellIntegration.nonce};return L.mark(`code/didBuildProcessDetails/${b}`),ee}U(b){const A=this.a.get(b);if(!A)throw new d.$bb("Could not find pty on pty host");return A}}e.$Hic=w,we([c.$1h],w.prototype,"traceRpcArgs",null),we([$],w.prototype,"refreshIgnoreProcessNames",null),we([$],w.prototype,"requestDetachInstance",null),we([$],w.prototype,"acceptDetachInstanceReply",null),we([$],w.prototype,"freePortKillProcess",null),we([$],w.prototype,"serializeTerminalState",null),we([$],w.prototype,"reviveTerminalProcesses",null),we([$],w.prototype,"shutdownAll",null),we([$],w.prototype,"createProcess",null),we([$],w.prototype,"attachToProcess",null),we([$],w.prototype,"updateTitle",null),we([$],w.prototype,"updateIcon",null),we([$],w.prototype,"clearBuffer",null),we([$],w.prototype,"refreshProperty",null),we([$],w.prototype,"updateProperty",null),we([$],w.prototype,"detachFromProcess",null),we([$],w.prototype,"reduceConnectionGraceTime",null),we([$],w.prototype,"listProcesses",null),we([$],w.prototype,"getPerformanceMarks",null),we([$],w.prototype,"start",null),we([$],w.prototype,"shutdown",null),we([$],w.prototype,"input",null),we([$],w.prototype,"processBinary",null),we([$],w.prototype,"resize",null),we([$],w.prototype,"getInitialCwd",null),we([$],w.prototype,"getCwd",null),we([$],w.prototype,"acknowledgeDataEvent",null),we([$],w.prototype,"setUnicodeVersion",null),we([$],w.prototype,"getLatency",null),we([$],w.prototype,"orphanQuestionReply",null),we([$],w.prototype,"installAutoReply",null),we([$],w.prototype,"uninstallAllAutoReplies",null),we([$],w.prototype,"uninstallAutoReply",null),we([$],w.prototype,"getDefaultSystemShell",null),we([$],w.prototype,"getEnvironment",null),we([$],w.prototype,"getWslPath",null),we([$],w.prototype,"getRevivedPtyNewId",null),we([$],w.prototype,"setTerminalLayoutInfo",null),we([$],w.prototype,"getTerminalLayoutInfo",null);var F;(function(O){O.None="None",O.ReplayOnly="ReplayOnly",O.Session="Session"})(F||(F={}));class Z extends M.$Vc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!=="None"}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle(b,A){A===p.TitleEventSource.Api&&(this.j.setValue("Session","setTitle"),this.P.freeRawReviveBuffer()),this.N=b,this.O=A}setIcon(b,A,Y){(!this.Y||"id"in A&&"id"in this.Y&&A.id!==this.Y.id||!this.color||Y!==this.Z)&&(this.P.freeRawReviveBuffer(),b&&this.j.setValue("Session","setIcon")),this.Y=A,this.Z=Y}S(b){this.R=b}constructor(b,A,Y,te,G,ee,ce,he,X,q,J,K,de,B,ue,x,h){super(),this.U=b,this.W=A,this.workspaceId=Y,this.workspaceName=te,this.shouldPersistTerminal=G,this.processLaunchOptions=he,this.unicodeVersion=X,this.X=J,this.Y=B,this.Z=ue,this.b=new Map,this.f=new Map,this.g=!1,this.w=new S.$Dh,this.C=this.B(new C.$ee),this.onProcessReplay=this.C.event,this.D=this.B(new C.$ee),this.onProcessReady=this.D.event,this.F=this.B(new C.$ee),this.onPersistentProcessReady=this.F.event,this.G=this.B(new C.$ee),this.onProcessData=this.G.event,this.H=this.B(new C.$ee),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new C.$ee),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=p.TitleEventSource.Process,this.j=new T(`Persistent process "${this.U}" interaction state`,"None",this.X),this.Q=K!==void 0,this.P=new R(ee,ce,q.scrollback,X,K,he.options.shellIntegration.nonce,G?de:void 0,this.X),x&&this.setTitle(x,p.TitleEventSource.Api),this.R=h,this.n=null,this.u=0,this.y=this.B(new S.$Jh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${g(q.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},q.graceTime)),this.z=this.B(new S.$Jh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${g(q.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},q.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(N=>{this.L=N.pid,this.M=N.cwd,this.D.fire(N)})),this.B(this.W.onDidChangeProperty(N=>{this.I.fire(N)})),this.a=new u.$Gvb((N,ie)=>this.G.fire(ie)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(N=>this.P.handleData(N))),this.B((0,M.$Tc)(()=>{for(const N of this.b.values())N.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach(b){this.shouldPersistTerminal&&(this.j.value!=="None"||b)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!=="Session")}async refreshProperty(b){return this.W.refreshProperty(b)}async updateProperty(b,A){if(b==="fixedDimensions")return this.S(A)}async start(){if(!this.g){const b=await this.W.start();return b&&"message"in b||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),b}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:"title",value:this.W.currentTitle}),this.I.fire({type:"shellType",value:this.W.shellType}),this.triggerReplay()}shutdown(b){return this.W.shutdown(b)}input(b){if(this.j.setValue("Session","input"),this.P.freeRawReviveBuffer(),!this.J){for(const A of this.b.values())A.handleInput();return this.W.input(b)}}writeBinary(b){return this.W.processBinary(b)}resize(b,A){if(!this.J){this.P.handleResize(b,A),this.a.flushBuffer(this.U);for(const Y of this.b.values())Y.handleResize();return this.W.resize(b,A)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion(b){this.unicodeVersion=b,this.P.setUnicodeVersion?.(b)}acknowledgeDataEvent(b){if(!this.J)return this.W.acknowledgeDataEvent(b)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value==="None"&&this.j.setValue("ReplayOnly","triggerReplay");const b=await this.P.generateReplayEvent();let A=0;for(const Y of b.events)A+=Y.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${A} chars and ${b.events.length} size events`),this.C.fire(b),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply(b,A){this.b.get(b)?.dispose(),this.b.set(b,new s.$Aic(this.W,b,A,this.X))}uninstallAutoReply(b){this.b.get(b)?.dispose(),this.b.delete(b)}sendCommandResult(b,A,Y){this.f.get(b)&&this.f.delete(b)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const b=this.n;this.n=null,b.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new S.$wh(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class T{get value(){return this.b}setValue(b,A){this.b!==b&&(this.b=b,this.f(A))}constructor(b,A,Y){this.a=b,this.b=A,this.d=Y,this.f("initialized")}f(b){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${b}`)}}class R{constructor(b,A,Y,te,G,ee,ce,he){this.f=ce,this.a=new o.Terminal({cols:b,rows:A,scrollback:Y,allowProposedApi:!0}),G&&this.a.writeln(G),this.setUnicodeVersion(te),this.b=new v.$rub(ee,!0,void 0,he),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData(b){this.a.write(b)}handleResize(b,A){this.a.resize(b,A)}clearBuffer(){this.a.clear()}async generateReplayEvent(b,A){const Y=new(await this._getSerializeConstructor());this.a.loadAddon(Y);const te={scrollback:this.a.options.scrollback};b&&(te.excludeAltBuffer=!0,te.excludeModes=!0);let G;return A&&this.f?G=this.f:G=Y.serialize(te),{events:[{cols:this.a.cols,rows:this.a.rows,data:G}],commands:this.b.serialize()}}async setUnicodeVersion(b){this.a.unicode.activeVersion!==b&&(b==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=b)}async _getUnicode11Constructor(){return E||(E=(await new Promise((b,A)=>{ae(["@xterm/addon-unicode11"],b,A)})).Unicode11Addon),E}async _getSerializeConstructor(){return D||(D=(await new Promise((b,A)=>{ae(["@xterm/addon-serialize"],b,A)})).SerializeAddon),D}}function g(O){let b=0,A=0,Y=0;O>=1e3&&(Y=Math.floor(O/1e3),O-=Y*1e3),Y>=60&&(A=Math.floor(Y/60),Y-=A*60),A>=60&&(b=Math.floor(A/60),A-=b*60);const te=b?`${b}h`:"",G=A?`${A}m`:"",ee=Y?`${Y}s`:"",ce=O?`${O}ms`:"";return`${te}${G}${ee}${ce}`}}),define(fe[112],ge([0,1,60,27,64,65,10,75,78,8,80,81,83,84,28,102,105,31,11,2]),function(ae,e,y,S,C,M,j,P,l,r,p,u,k,o,a,m,f,n,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v();async function v(){const i=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),t=parseInt(process.env.VSCODE_LATENCY??"0"),c={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,i&&await(0,s.$xh)(i);const L=(0,n.$8W)(process);let $;L?$=new M.$9W:$=new C.$Zq(a.TerminalIpcChannels.PtyHost);const D={_serviceBrand:void 0,...o.default},E=new l.$9m((0,P.$tm)(process.argv,P.$sm),D),w=new k.$EQ((0,r.$ek)(E),E.logsHome);$.registerChannel(a.TerminalIpcChannels.Logger,new p.$as(w,()=>y.$zn));const F=w.createLogger("ptyhost",{name:(0,j.localize)(0,null)}),Z=new u.$OQ(F);i&&Z.warn(`Pty Host startup is delayed ${i}ms`),t&&Z.warn(`Pty host is simulating ${t}ms latency`);const T=new d.$Uc,R=new m.$Dic;$.registerChannel(a.TerminalIpcChannels.Heartbeat,S.ProxyChannel.fromService(R,T));const g=new f.$Hic(Z,D,c,t),O=S.ProxyChannel.fromService(g,T);$.registerChannel(a.TerminalIpcChannels.PtyHost,O),L&&$.registerChannel(a.TerminalIpcChannels.PtyHostWindow,O),process.once("exit",()=>{Z.trace("Pty host exiting"),Z.dispose(),R.dispose(),g.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/17235b28ebca8f946926ec11374b67cd53c0619d/core/vs/platform/terminal/node/ptyHostMain.js.map
