/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/themables","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(le){for(var e=[],d=0,L=le.length;d<L;d++)e[d]=ke[le[d]];return e};define(ke[163],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class d{static get(){const O=new Map,R=new Map,N=new Map,b=new Map;function m(y,w){y.has(w.detail)||y.set(w.detail,-w.timestamp)}function E(y,w){const h=y.get(w.detail);h&&(h>=0||y.set(w.detail,h+w.timestamp))}let A=[];typeof le=="function"&&typeof le.getStats=="function"&&(A=le.getStats().slice(0).sort((y,w)=>y.timestamp-w.timestamp));for(const y of A)switch(y.type){case 10:m(O,y);break;case 11:case 12:E(O,y);break;case 21:m(R,y);break;case 22:E(R,y);break;case 33:m(N,y);break;case 34:E(N,y);break;case 31:m(b,y);break;case 32:E(b,y);break}let P=0;N.forEach(y=>P+=y);function p(y){const w=[];return y.forEach((h,f)=>w.push([f,h])),w}return{amdLoad:p(O),amdInvoke:p(R),nodeRequire:p(N),nodeEval:p(b),nodeRequireTotal:P}}static toMarkdownTable(O,R){let N="";const b=[];return O.forEach((m,E)=>{b[E]=m.length}),R.forEach(m=>{m.forEach((E,A)=>{typeof E>"u"&&(E=m[A]="-");const P=E.toString().length;b[A]=Math.max(P,b[A])})}),O.forEach((m,E)=>{N+=`| ${m+" ".repeat(b[E]-m.toString().length)} `}),N+=`|
`,O.forEach((m,E)=>{N+=`| ${"-".repeat(b[E])} `}),N+=`|
`,R.forEach(m=>{m.forEach((E,A)=>{typeof E<"u"&&(N+=`| ${E+" ".repeat(b[A]-E.toString().length)} `)}),N+=`|
`}),N}}e.$U=d}),define(ke[164],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=d,e.$gb=L,e.$hb=O,e.$ib=R,e.$jb=N,e.$kb=b,e.$lb=m,e.$nb=A,e.$ob=P,e.$pb=p,e.$qb=y,e.$rb=w;function d(h,f){const a=L(h,f);if(a!==-1)return h[a]}function L(h,f,a=h.length-1){for(let n=a;n>=0;n--){const i=h[n];if(f(i))return n}return-1}function O(h,f){const a=R(h,f);return a===-1?void 0:h[a]}function R(h,f,a=0,n=h.length){let i=a,u=n;for(;i<u;){const o=Math.floor((i+u)/2);f(h[o])?i=o+1:u=o}return i-1}function N(h,f){const a=b(h,f);return a===h.length?void 0:h[a]}function b(h,f,a=0,n=h.length){let i=a,u=n;for(;i<u;){const o=Math.floor((i+u)/2);f(h[o])?u=o:i=o+1}return i}function m(h,f,a=0,n=h.length){const i=b(h,f,a,n);return i===h.length?-1:i}class E{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(E.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!f(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const a=R(this.e,f,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=E;function A(h,f){if(h.length===0)return;let a=h[0];for(let n=1;n<h.length;n++){const i=h[n];f(i,a)>0&&(a=i)}return a}function P(h,f){if(h.length===0)return;let a=h[0];for(let n=1;n<h.length;n++){const i=h[n];f(i,a)>=0&&(a=i)}return a}function p(h,f){return A(h,(a,n)=>-f(a,n))}function y(h,f){if(h.length===0)return-1;let a=0;for(let n=1;n<h.length;n++){const i=h[n];f(i,h[a])>0&&(a=n)}return a}function w(h,f){for(const a of h){const n=f(a);if(n!==void 0)return n}}}),define(ke[74],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=d,e.$L=L,e.$M=O,e.$N=R;function d(N,b){const m=Object.create(null);for(const E of N){const A=b(E);let P=m[A];P||(P=m[A]=[]),P.push(E)}return m}function L(N,b){const m=[],E=[];for(const A of N)b.has(A)||m.push(A);for(const A of b)N.has(A)||E.push(A);return{removed:m,added:E}}function O(N,b){const m=[],E=[];for(const[A,P]of N)b.has(A)||m.push(P);for(const[A,P]of b)N.has(A)||E.push(P);return{removed:m,added:E}}function R(N,b){const m=new Set;for(const E of b)N.has(E)&&m.add(E);return m}}),define(ke[56],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=L,e.$2h=O,e.$3h=R;function d(N){return(b,m,E)=>{let A=null,P=null;if(typeof E.value=="function"?(A="value",P=E.value):typeof E.get=="function"&&(A="get",P=E.get),!P)throw new Error("not supported");E[A]=N(P,m)}}function L(N,b,m){let E=null,A=null;if(typeof m.value=="function"?(E="value",A=m.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(E="get",A=m.get),!A)throw new Error("not supported");const P=`$memoize$${b}`;m[E]=function(...p){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,p)}),this[P]}}function O(N,b,m){return d((E,A)=>{const P=`$debounce$${A}`,p=`$debounce$result$${A}`;return function(...y){this[p]||(this[p]=m?m():void 0),clearTimeout(this[P]),b&&(this[p]=b(this[p],...y),y=[this[p]]),this[P]=setTimeout(()=>{E.apply(this,y),this[p]=m?m():void 0},N)}})}function R(N,b,m){return d((E,A)=>{const P=`$throttle$timer$${A}`,p=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,w=`$throttle$pending$${A}`;return function(...h){if(this[p]||(this[p]=m?m():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...h)),this[w])return;const f=this[y]+N;f<=Date.now()?(this[y]=Date.now(),E.apply(this,[this[p]]),this[p]=m?m():void 0):(this[w]=!0,this[P]=setTimeout(()=>{this[w]=!1,this[y]=Date.now(),E.apply(this,[this[p]]),this[p]=m?m():void 0},f-Date.now()))}})}}),define(ke[13],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=L,e.$Z=O,e.$1=R,e.$2=N,e.$3=b,e.$4=E,e.$6=P,e.$7=p,e.$8=y,e.$0=h;class d{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(l=>{l(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=d,e.$X=new d;function L(o){e.$X.setUnexpectedErrorHandler(o)}function O(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(o){E(o)||e.$X.onUnexpectedError(o)}function N(o){E(o)||e.$X.onUnexpectedExternalError(o)}function b(o){if(o instanceof Error){const{name:t,message:l}=o,r=o.stacktrace||o.stack;return{$isError:!0,name:t,message:l,stack:r,noTelemetry:i.isErrorNoTelemetry(o)}}return o}const m="Canceled";function E(o){return o instanceof A?!0:o instanceof Error&&o.name===m&&o.message===m}class A extends Error{constructor(){super(m),this.name=this.message}}e.$5=A;function P(){const o=new Error(m);return o.name=o.message,o}function p(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function y(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class w extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=w;function h(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const l=new i;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class u extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}e.$cb=u}),define(ke[19],Se([1,0,13,164]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=O,e.$tb=R,e.$ub=N,e.$vb=b,e.$wb=m,e.$xb=E,e.$yb=A,e.$zb=P,e.$Ab=p,e.$Bb=y,e.$Cb=w,e.$Db=h,e.$Eb=f,e.top=a,e.$Gb=n,e.$Hb=u,e.$Ib=o,e.$Jb=t,e.$Kb=l,e.$Lb=r,e.$Mb=c,e.$Nb=s,e.$Ob=v,e.$Pb=g,e.$Qb=D,e.$Rb=$,e.$Sb=k,e.$Tb=S,e.$Ub=C,e.$Vb=I,e.$Wb=F,e.$Xb=j,e.$Yb=z,e.$Zb=M,e.$1b=T,e.$2b=U,e.$3b=Z,e.$4b=te,e.$5b=q,e.$6b=K,e.$7b=$e,e.$8b=ue,e.$$b=B;function O(oe,se=0){return oe[oe.length-(1+se)]}function R(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function N(oe,se,re=(G,ne)=>G===ne){if(oe===se)return!0;if(!oe||!se||oe.length!==se.length)return!1;for(let G=0,ne=oe.length;G<ne;G++)if(!re(oe[G],se[G]))return!1;return!0}function b(oe,se){const re=oe.length-1;se<re&&(oe[se]=oe[re]),oe.pop()}function m(oe,se,re){return E(oe.length,G=>re(oe[G],se))}function E(oe,se){let re=0,G=oe-1;for(;re<=G;){const ne=(re+G)/2|0,me=se(ne);if(me<0)re=ne+1;else if(me>0)G=ne-1;else return ne}return-(re+1)}function A(oe,se,re){if(oe=oe|0,oe>=se.length)throw new TypeError("invalid index");const G=se[Math.floor(se.length*Math.random())],ne=[],me=[],be=[];for(const Re of se){const fe=re(Re,G);fe<0?ne.push(Re):fe>0?me.push(Re):be.push(Re)}return oe<ne.length?A(oe,ne,re):oe<ne.length+be.length?be[0]:A(oe-(ne.length+be.length),me,re)}function P(oe,se){const re=[];let G;for(const ne of oe.slice(0).sort(se))!G||se(G[0],ne)!==0?(G=[ne],re.push(G)):G.push(ne);return re}function*p(oe,se){let re,G;for(const ne of oe)G!==void 0&&se(G,ne)?re.push(ne):(re&&(yield re),re=[ne]),G=ne;re&&(yield re)}function y(oe,se){for(let re=0;re<=oe.length;re++)se(re===0?void 0:oe[re-1],re===oe.length?void 0:oe[re])}function w(oe,se){for(let re=0;re<oe.length;re++)se(re===0?void 0:oe[re-1],oe[re],re+1===oe.length?void 0:oe[re+1])}function h(oe,se,re){const G=[];function ne(Re,fe,De){if(fe===0&&De.length===0)return;const Ae=G[G.length-1];Ae&&Ae.start+Ae.deleteCount===Re?(Ae.deleteCount+=fe,Ae.toInsert.push(...De)):G.push({start:Re,deleteCount:fe,toInsert:De})}let me=0,be=0;for(;;){if(me===oe.length){ne(me,0,se.slice(be));break}if(be===se.length){ne(me,oe.length-me,[]);break}const Re=oe[me],fe=se[be],De=re(Re,fe);De===0?(me+=1,be+=1):De<0?(ne(me,1,[]),me+=1):De>0&&(ne(me,0,[fe]),be+=1)}return G}function f(oe,se,re){const G=h(oe,se,re),ne=[],me=[];for(const be of G)ne.push(...oe.slice(be.start,be.start+be.deleteCount)),me.push(...be.toInsert);return{removed:ne,added:me}}function a(oe,se,re){if(re===0)return[];const G=oe.slice(0,re).sort(se);return i(oe,se,G,re,oe.length),G}function n(oe,se,re,G,ne){return re===0?Promise.resolve([]):new Promise((me,be)=>{(async()=>{const Re=oe.length,fe=oe.slice(0,re).sort(se);for(let De=re,Ae=Math.min(re+G,Re);De<Re;De=Ae,Ae=Math.min(Ae+G,Re)){if(De>re&&await new Promise(ze=>setTimeout(ze)),ne&&ne.isCancellationRequested)throw new d.$5;i(oe,se,fe,De,Ae)}return fe})().then(me,be)})}function i(oe,se,re,G,ne){for(const me=re.length;G<ne;G++){const be=oe[G];if(se(be,re[me-1])<0){re.pop();const Re=(0,L.$kb)(re,fe=>se(be,fe)<0);re.splice(Re,0,be)}}}function u(oe){return oe.filter(se=>!!se)}function o(oe){let se=0;for(let re=0;re<oe.length;re++)oe[re]&&(oe[se]=oe[re],se+=1);oe.length=se}function t(oe,se,re){oe.splice(re,0,oe.splice(se,1)[0])}function l(oe){return!Array.isArray(oe)||oe.length===0}function r(oe){return Array.isArray(oe)&&oe.length>0}function c(oe,se=re=>re){const re=new Set;return oe.filter(G=>{const ne=se(G);return re.has(ne)?!1:(re.add(ne),!0)})}function s(oe){const se=new Set;return re=>{const G=oe(re);return se.has(G)?!1:(se.add(G),!0)}}function v(oe,se){return oe.length>0?oe[0]:se}function g(oe,se){return oe.length>0?oe[oe.length-1]:se}function D(oe,se,re=(G,ne)=>G===ne){let G=0;for(let ne=0,me=Math.min(oe.length,se.length);ne<me&&re(oe[ne],se[ne]);ne++)G++;return G}function $(oe){return[].concat(...oe)}function k(oe,se){let re=typeof se=="number"?oe:0;typeof se=="number"?re=oe:(re=0,se=oe);const G=[];if(re<=se)for(let ne=re;ne<se;ne++)G.push(ne);else for(let ne=re;ne>se;ne--)G.push(ne);return G}function S(oe,se,re){return oe.reduce((G,ne)=>(G[se(ne)]=re?re(ne):ne,G),Object.create(null))}function C(oe,se){return oe.push(se),()=>I(oe,se)}function I(oe,se){const re=oe.indexOf(se);if(re>-1)return oe.splice(re,1),se}function F(oe,se,re){const G=oe.slice(0,se),ne=oe.slice(se);return G.concat(re,ne)}function j(oe,se){let re;if(typeof se=="number"){let G=se;re=()=>{const ne=Math.sin(G++)*179426549;return ne-Math.floor(ne)}}else re=Math.random;for(let G=oe.length-1;G>0;G-=1){const ne=Math.floor(re()*(G+1)),me=oe[G];oe[G]=oe[ne],oe[ne]=me}}function z(oe,se){const re=oe.indexOf(se);re>-1&&(oe.splice(re,1),oe.unshift(se))}function M(oe,se){const re=oe.indexOf(se);re>-1&&(oe.splice(re,1),oe.push(se))}function T(oe,se){for(const re of se)oe.push(re)}function U(oe,se){return Array.isArray(oe)?oe.map(se):se(oe)}function Z(oe){return Array.isArray(oe)?oe:[oe]}function te(oe){return oe[Math.floor(Math.random()*oe.length)]}function q(oe,se,re){const G=Y(oe,se),ne=oe.length,me=re.length;oe.length=ne+me;for(let be=ne-1;be>=G;be--)oe[be+me]=oe[be];for(let be=0;be<me;be++)oe[be+G]=re[be]}function K(oe,se,re,G){const ne=Y(oe,se);let me=oe.splice(ne,re);return me===void 0&&(me=[]),q(oe,ne,G),me}function Y(oe,se){return se<0?Math.max(se+oe.length,0):Math.min(se,oe.length)}var ie;(function(oe){function se(me){return me<0}oe.isLessThan=se;function re(me){return me<=0}oe.isLessThanOrEqual=re;function G(me){return me>0}oe.isGreaterThan=G;function ne(me){return me===0}oe.isNeitherLessOrGreaterThan=ne,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function $e(oe,se){return(re,G)=>se(oe(re),oe(G))}function ue(...oe){return(se,re)=>{for(const G of oe){const ne=G(se,re);if(!ie.isNeitherLessOrGreaterThan(ne))return ne}return ie.neitherLessOrGreaterThan}}const ve=(oe,se)=>oe-se;e.$9b=ve;const _=(oe,se)=>(0,e.$9b)(oe?1:0,se?1:0);e.$0b=_;function B(oe){return(se,re)=>-oe(se,re)}class ee{constructor(se){this.g=se,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(se){let re=this.c;for(;re<this.g.length&&se(this.g[re]);)re++;const G=re===this.c?null:this.g.slice(this.c,re);return this.c=re,G}takeFromEndWhile(se){let re=this.d;for(;re>=0&&se(this.g[re]);)re--;const G=re===this.d?null:this.g.slice(re+1,this.d+1);return this.d=re,G}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const se=this.g[this.c];return this.c++,se}removeLast(){const se=this.g[this.d];return this.d--,se}takeCount(se){const re=this.g.slice(this.c,this.c+se);return this.c+=se,re}}e.$_b=ee;class pe{static{this.empty=new pe(se=>{})}constructor(se){this.iterate=se}forEach(se){this.iterate(re=>(se(re),!0))}toArray(){const se=[];return this.iterate(re=>(se.push(re),!0)),se}filter(se){return new pe(re=>this.iterate(G=>se(G)?re(G):!0))}map(se){return new pe(re=>this.iterate(G=>re(se(G))))}some(se){let re=!1;return this.iterate(G=>(re=se(G),!re)),re}findFirst(se){let re;return this.iterate(G=>se(G)?(re=G,!1):!0),re}findLast(se){let re;return this.iterate(G=>(se(G)&&(re=G),!0)),re}findLastMaxBy(se){let re,G=!0;return this.iterate(ne=>((G||ie.isGreaterThan(se(ne,re)))&&(G=!1,re=ne),!0)),re}}e.$ac=pe;class Ce{constructor(se){this.c=se}static createSortPermutation(se,re){const G=Array.from(se.keys()).sort((ne,me)=>re(se[ne],se[me]));return new Ce(G)}apply(se){return se.map((re,G)=>se[this.c[G]])}inverse(){const se=this.c.slice();for(let re=0;re<this.c.length;re++)se[this.c[re]]=re;return new Ce(se)}}e.$bc=Ce}),define(ke[62],Se([1,0,13]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=L,e.$fd=O,e.$gd=R,e.$hd=N,e.$id=b,e.$jd=m;function L(E,A){if(!E)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function O(E,A="Unreachable"){throw new Error(A)}function R(E){if(!E)throw new d.$cb("Assertion Failed")}function N(E){E||(0,d.$1)(new d.$cb("Soft Assertion Failed"))}function b(E){if(!E()){debugger;E(),(0,d.$1)(new d.$cb("Assertion Failed"))}}function m(E,A){let P=0;for(;P<E.length-1;){const p=E[P],y=E[P+1];if(!A(p,y))return!1;P++}return!0}}),define(ke[165],Se([1,0,19]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=O,e.$9c=R,e.$0c=N,e.$$c=b,e.$_c=m,e.$ad=E;const L=(y,w)=>y===w;e.$7c=L;function O(y=e.$7c){return(w,h)=>d.$ub(w,h,y)}function R(){return(y,w)=>JSON.stringify(y)===JSON.stringify(w)}function N(){return(y,w)=>y.equals(w)}function b(y,w,h){return!y||!w?y===w:h(y,w)}function m(y,w){if(y===w)return!0;if(Array.isArray(y)&&Array.isArray(w)){if(y.length!==w.length)return!1;for(let h=0;h<y.length;h++)if(!m(y[h],w[h]))return!1;return!0}if(y&&typeof y=="object"&&w&&typeof w=="object"&&Object.getPrototypeOf(y)===Object.prototype&&Object.getPrototypeOf(w)===Object.prototype){const h=y,f=w,a=Object.keys(h),n=Object.keys(f),i=new Set(n);if(a.length!==n.length)return!1;for(const u of a)if(!i.has(u)||!m(h[u],f[u]))return!1;return!0}return!1}function E(y){return JSON.stringify(p(y))}let A=0;const P=new WeakMap;function p(y){if(Array.isArray(y))return y.map(p);if(y&&typeof y=="object")if(Object.getPrototypeOf(y)===Object.prototype){const w=y,h=Object.create(null);for(const f of Object.keys(w).sort())h[f]=p(w[f]);return h}else{let w=P.get(y);return w===void 0&&(w=A++,P.set(y,w)),w+"----2b76a038c20c4bcc"}return y}}),define(ke[75],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=d;function d(L,O){const R=this;let N=!1,b;return function(){if(N)return b;if(N=!0,O)try{b=L.apply(R,arguments)}finally{O()}else b=L.apply(R,arguments);return b}}}),define(ke[125],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=e.$vP=void 0;class d{constructor(O){this.a=O,this.b=0}nextId(){return this.a+ ++this.b}}e.$vP=d,e.$wP=new d("id#")}),define(ke[39],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var d;(function(L){function O(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=O;const R=Object.freeze([]);function N(){return R}L.empty=N;function*b(t){yield t}L.single=b;function m(t){return O(t)?t:b(t)}L.wrap=m;function E(t){return t||R}L.from=E;function*A(t){for(let l=t.length-1;l>=0;l--)yield t[l]}L.reverse=A;function P(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=P;function p(t){return t[Symbol.iterator]().next().value}L.first=p;function y(t,l){for(const r of t)if(l(r))return!0;return!1}L.some=y;function w(t,l){for(const r of t)if(l(r))return r}L.find=w;function*h(t,l){for(const r of t)l(r)&&(yield r)}L.filter=h;function*f(t,l){let r=0;for(const c of t)yield l(c,r++)}L.map=f;function*a(...t){for(const l of t)yield*l}L.concat=a;function n(t,l,r){let c=r;for(const s of t)c=l(c,s);return c}L.reduce=n;function*i(t,l,r=t.length){for(l<0&&(l+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);l<r;l++)yield t[l]}L.slice=i;function u(t,l=Number.POSITIVE_INFINITY){const r=[];if(l===0)return[r,t];const c=t[Symbol.iterator]();for(let s=0;s<l;s++){const v=c.next();if(v.done)return[r,L.empty()];r.push(v.value)}return[r,{[Symbol.iterator](){return c}}]}L.consume=u;async function o(t){const l=[];for await(const r of t)l.push(r);return Promise.resolve(l)}L.asyncToArray=o})(d||(e.Iterable=d={}))}),define(ke[166],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=N,e.$In=P,e.$Jn=p,e.$Kn=y,e.$Ln=w,e.$Mn=h,e.$Nn=f,e.$On=a,e.$Pn=n,e.$Qn=i,e.$Rn=u,e.$Sn=o;var d;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(d||(e.ScanError=d={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O||(e.ParseErrorCode=O={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function N(t,l=!1){let r=0;const c=t.length;let s="",v=0,g=16,D=0;function $(z){let M=0,T=0;for(;M<z;){const U=t.charCodeAt(r);if(U>=48&&U<=57)T=T*16+U-48;else if(U>=65&&U<=70)T=T*16+U-65+10;else if(U>=97&&U<=102)T=T*16+U-97+10;else break;r++,M++}return M<z&&(T=-1),T}function k(z){r=z,s="",v=0,g=16,D=0}function S(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&E(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&E(t.charCodeAt(r)))for(r++;r<t.length&&E(t.charCodeAt(r));)r++;else return D=3,t.substring(z,r);let M=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&E(t.charCodeAt(r))){for(r++;r<t.length&&E(t.charCodeAt(r));)r++;M=r}else D=3;return t.substring(z,M)}function C(){let z="",M=r;for(;;){if(r>=c){z+=t.substring(M,r),D=2;break}const T=t.charCodeAt(r);if(T===34){z+=t.substring(M,r),r++;break}if(T===92){if(z+=t.substring(M,r),r++,r>=c){D=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Z=$(4);Z>=0?z+=String.fromCharCode(Z):D=4;break}default:D=5}M=r;continue}if(T>=0&&T<=31)if(m(T)){z+=t.substring(M,r),D=2;break}else D=6;r++}return z}function I(){if(s="",D=0,v=r,r>=c)return v=c,g=17;let z=t.charCodeAt(r);if(b(z)){do r++,s+=String.fromCharCode(z),z=t.charCodeAt(r);while(b(z));return g=15}if(m(z))return r++,s+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),g=14;switch(z){case 123:return r++,g=1;case 125:return r++,g=2;case 91:return r++,g=3;case 93:return r++,g=4;case 58:return r++,g=6;case 44:return r++,g=5;case 34:return r++,s=C(),g=10;case 47:{const M=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<c&&!m(t.charCodeAt(r));)r++;return s=t.substring(M,r),g=12}if(t.charCodeAt(r+1)===42){r+=2;const T=c-1;let U=!1;for(;r<T;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,D=1),s=t.substring(M,r),g=13}return s+=String.fromCharCode(z),r++,g=16}case 45:if(s+=String.fromCharCode(z),r++,r===c||!E(t.charCodeAt(r)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=S(),g=11;default:for(;r<c&&F(z);)r++,z=t.charCodeAt(r);if(v!==r){switch(s=t.substring(v,r),s){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return s+=String.fromCharCode(z),r++,g=16}}function F(z){if(b(z)||m(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let z;do z=I();while(z>=12&&z<=15);return z}return{setPosition:k,getPosition:()=>r,scan:l?j:I,getToken:()=>g,getTokenValue:()=>s,getTokenOffset:()=>v,getTokenLength:()=>r-v,getTokenError:()=>D}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function P(t,l){const r=[],c=new Object;let s;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function D($,k,S,C){v.value=$,v.offset=k,v.length=S,v.type=C,v.colonOffset=void 0,s=v}try{i(t,{onObjectBegin:($,k)=>{if(l<=$)throw c;s=void 0,g=l>$,r.push("")},onObjectProperty:($,k,S)=>{if(l<k||(D($,k,S,"property"),r[r.length-1]=$,l<=k+S))throw c},onObjectEnd:($,k)=>{if(l<=$)throw c;s=void 0,r.pop()},onArrayBegin:($,k)=>{if(l<=$)throw c;s=void 0,r.push(0)},onArrayEnd:($,k)=>{if(l<=$)throw c;s=void 0,r.pop()},onLiteralValue:($,k,S)=>{if(l<k||(D($,k,S,o($)),l<=k+S))throw c},onSeparator:($,k,S)=>{if(l<=k)throw c;if($===":"&&s&&s.type==="property")s.colonOffset=k,g=!1,s=void 0;else if($===","){const C=r[r.length-1];typeof C=="number"?r[r.length-1]=C+1:(g=!0,r[r.length-1]=""),s=void 0}}})}catch($){if($!==c)throw $}return{path:r,previousNode:s,isAtPropertyKey:g,matches:$=>{let k=0;for(let S=0;k<$.length&&S<r.length;S++)if($[k]===r[S]||$[k]==="*")k++;else if($[k]!=="**")return!1;return k===$.length}}}function p(t,l=[],r=R.DEFAULT){let c=null,s=[];const v=[];function g($){Array.isArray(s)?s.push($):c!==null&&(s[c]=$)}return i(t,{onObjectBegin:()=>{const $={};g($),v.push(s),s=$,c=null},onObjectProperty:$=>{c=$},onObjectEnd:()=>{s=v.pop()},onArrayBegin:()=>{const $=[];g($),v.push(s),s=$,c=null},onArrayEnd:()=>{s=v.pop()},onLiteralValue:g,onError:($,k,S)=>{l.push({error:$,offset:k,length:S})}},r),s[0]}function y(t,l=[],r=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s($){c.type==="property"&&(c.length=$-c.offset,c=c.parent)}function v($){return c.children.push($),$}i(t,{onObjectBegin:$=>{c=v({type:"object",offset:$,length:-1,parent:c,children:[]})},onObjectProperty:($,k,S)=>{c=v({type:"property",offset:k,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:$,offset:k,length:S,parent:c})},onObjectEnd:($,k)=>{c.length=$+k-c.offset,c=c.parent,s($+k)},onArrayBegin:($,k)=>{c=v({type:"array",offset:$,length:-1,parent:c,children:[]})},onArrayEnd:($,k)=>{c.length=$+k-c.offset,c=c.parent,s($+k)},onLiteralValue:($,k,S)=>{v({type:o($),offset:k,length:S,parent:c,value:$}),s(k+S)},onSeparator:($,k,S)=>{c.type==="property"&&($===":"?c.colonOffset=k:$===","&&s(k))},onError:($,k,S)=>{l.push({error:$,offset:k,length:S})}},r);const D=c.children[0];return D&&delete D.parent,D}function w(t,l){if(!t)return;let r=t;for(const c of l)if(typeof c=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const v of r.children)if(Array.isArray(v.children)&&v.children[0].value===c){r=v.children[1],s=!0;break}if(!s)return}else{const s=c;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}function h(t){if(!t.parent||!t.parent.children)return[];const l=h(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;l.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&l.push(r)}return l}function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const l=Object.create(null);for(const r of t.children){const c=r.children[1];c&&(l[r.children[0].value]=f(c))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,l,r=!1){return l>=t.offset&&l<t.offset+t.length||r&&l===t.offset+t.length}function n(t,l,r=!1){if(a(t,l,r)){const c=t.children;if(Array.isArray(c))for(let s=0;s<c.length&&c[s].offset<=l;s++){const v=n(c[s],l,r);if(v)return v}return t}}function i(t,l,r=R.DEFAULT){const c=N(t,!1);function s($e){return $e?()=>$e(c.getTokenOffset(),c.getTokenLength()):()=>!0}function v($e){return $e?ue=>$e(ue,c.getTokenOffset(),c.getTokenLength()):()=>!0}const g=s(l.onObjectBegin),D=v(l.onObjectProperty),$=s(l.onObjectEnd),k=s(l.onArrayBegin),S=s(l.onArrayEnd),C=v(l.onLiteralValue),I=v(l.onSeparator),F=s(l.onComment),j=v(l.onError),z=r&&r.disallowComments,M=r&&r.allowTrailingComma;function T(){for(;;){const $e=c.scan();switch(c.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:z||U(11);break;case 2:U(12);break;case 6:U(16);break}switch($e){case 12:case 13:z?U(10):F();break;case 16:U(1);break;case 15:case 14:break;default:return $e}}}function U($e,ue=[],ve=[]){if(j($e),ue.length+ve.length>0){let _=c.getToken();for(;_!==17;){if(ue.indexOf(_)!==-1){T();break}else if(ve.indexOf(_)!==-1)break;_=T()}}}function Z($e){const ue=c.getTokenValue();return $e?C(ue):D(ue),T(),!0}function te(){switch(c.getToken()){case 11:{let $e=0;try{$e=JSON.parse(c.getTokenValue()),typeof $e!="number"&&(U(2),$e=0)}catch{U(2)}C($e);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return T(),!0}function q(){return c.getToken()!==10?(U(3,[],[2,5]),!1):(Z(!1),c.getToken()===6?(I(":"),T(),ie()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function K(){g(),T();let $e=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if($e||U(4,[],[]),I(","),T(),c.getToken()===2&&M)break}else $e&&U(6,[],[]);q()||U(4,[],[2,5]),$e=!0}return $(),c.getToken()!==2?U(7,[2],[]):T(),!0}function Y(){k(),T();let $e=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if($e||U(4,[],[]),I(","),T(),c.getToken()===4&&M)break}else $e&&U(6,[],[]);ie()||U(4,[],[4,5]),$e=!0}return S(),c.getToken()!==4?U(8,[4],[]):T(),!0}function ie(){switch(c.getToken()){case 3:return Y();case 1:return K();case 10:return Z(!0);default:return te()}}return T(),c.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):ie()?(c.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}function u(t,l){const r=N(t),c=[];let s,v=0,g;do switch(g=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:v!==g&&c.push(t.substring(v,g)),l!==void 0&&c.push(r.getTokenValue().replace(/[^\r\n]/g,l)),v=r.getPosition();break}while(s!==17);return c.join("")}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class d{constructor(O){this.d=O,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(O){this.c=O}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=d}),define(ke[76],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class d{static{this.Undefined=new d(void 0)}constructor(R){this.element=R,this.next=d.Undefined,this.prev=d.Undefined}}class L{constructor(){this.a=d.Undefined,this.b=d.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===d.Undefined}clear(){let R=this.a;for(;R!==d.Undefined;){const N=R.next;R.prev=d.Undefined,R.next=d.Undefined,R=N}this.a=d.Undefined,this.b=d.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,N){const b=new d(R);if(this.a===d.Undefined)this.a=b,this.b=b;else if(N){const E=this.b;this.b=b,b.prev=E,E.next=b}else{const E=this.a;this.a=b,b.next=E,E.prev=b}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(b))}}shift(){if(this.a!==d.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==d.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==d.Undefined&&R.next!==d.Undefined){const N=R.prev;N.next=R.next,R.next.prev=N}else R.prev===d.Undefined&&R.next===d.Undefined?(this.a=d.Undefined,this.b=d.Undefined):R.next===d.Undefined?(this.b=this.b.prev,this.b.next=d.Undefined):R.prev===d.Undefined&&(this.a=this.a.next,this.a.prev=d.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==d.Undefined;)yield R.element,R=R.next}}e.$6c=L}),define(ke[27],Se([1,0]),function(le,e){"use strict";var d,L,O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=N,e.$Ac=b,e.$Jc=u;function R(o,t,l){let r=o.get(t);return r===void 0&&(r=l,o.set(t,r)),r}function N(o){const t=[];return o.forEach((l,r)=>{t.push(`${r} => ${l}`)}),`Map(${o.size}) {${t.join(", ")}}`}function b(o){const t=[];return o.forEach(l=>{t.push(l)}),`Set(${o.size}) {${t.join(", ")}}`}class m{constructor(t,l){this.uri=t,this.value=l}}function E(o){return Array.isArray(o)}class A{static{this.c=t=>t.toString()}constructor(t,l){if(this[d]="ResourceMap",t instanceof A)this.d=new Map(t.d),this.e=l??A.c;else if(E(t)){this.d=new Map,this.e=l??A.c;for(const[r,c]of t)this.set(r,c)}else this.d=new Map,this.e=t??A.c}set(t,l){return this.d.set(this.e(t),new m(t,l)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,l){typeof l<"u"&&(t=t.bind(l));for(const[r,c]of this.d)t(c.value,c.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(d=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=A;class P{constructor(t,l){this[L]="ResourceSet",!t||typeof t=="function"?this.c=new A(t):(this.c=new A(l),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,l){this.c.forEach((r,c)=>t.call(l,c,c,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=P;var p;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class y{constructor(){this[O]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,l=0){const r=this.c.get(t);if(r)return l!==0&&this.m(r,l),r.value}set(t,l,r=0){let c=this.c.get(t);if(c)c.value=l,r!==0&&this.m(c,r);else{switch(c={key:t,value:l,next:void 0,previous:void 0},r){case 0:this.k(c);break;case 1:this.j(c);break;case 2:this.k(c);break;default:this.k(c);break}this.c.set(t,c),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const l=this.c.get(t);if(l)return this.c.delete(t),this.l(l),this.f--,l.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,l){const r=this.g;let c=this.d;for(;c;){if(l?t.bind(l)(c.value,c.key,this):t(c.value,c.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,l=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:r.key,done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}values(){const t=this,l=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:r.value,done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}entries(){const t=this,l=this.g;let r=this.d;const c={[Symbol.iterator](){return c},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const s={value:[r.key,r.value],done:!1};return r=r.next,s}else return{value:void 0,done:!0}}};return c}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this.d,r=this.size;for(;l&&r>t;)this.c.delete(l.key),l=l.next,r--;this.d=l,this.f=r,l&&(l.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this.e,r=this.size;for(;l&&r>t;)this.c.delete(l.key),l=l.previous,r--;this.e=l,this.f=r,l&&(l.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const l=t.next,r=t.previous;if(!l||!r)throw new Error("Invalid list");l.previous=r,r.next=l}t.next=void 0,t.previous=void 0,this.g++}m(t,l){if(!this.d||!this.e)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(t===this.d)return;const r=t.next,c=t.previous;t===this.e?(c.next=void 0,this.e=c):(r.previous=c,c.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(l===2){if(t===this.e)return;const r=t.next,c=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=c,c.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((l,r)=>{t.push([r,l])}),t}fromJSON(t){this.clear();for(const[l,r]of t)this.set(l,r)}}e.$Dc=y;class w extends y{constructor(t,l=1){super(),this.n=t,this.o=Math.min(Math.max(0,l),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,l=2){return super.get(t,l)}peek(t){return super.get(t,0)}set(t,l){return super.set(t,l,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class h extends w{constructor(t,l=1){super(t,l)}q(t){this.h(t)}set(t,l){return super.set(t,l),this.p(),this}}e.$Ec=h;class f extends w{constructor(t,l=1){super(t,l)}q(t){this.i(t)}set(t,l){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,l),this}}e.$Fc=f;class a{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let l=this.c.get(t)||0;return l===0?!1:(l--,l===0?this.c.delete(t):this.c.set(t,l),!0)}has(t){return this.c.has(t)}}e.$Gc=a;class n{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[l,r]of t)this.set(l,r)}clear(){this.c.clear(),this.d.clear()}set(t,l){this.c.set(t,l),this.d.set(l,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const l=this.c.get(t);return l===void 0?!1:(this.c.delete(t),this.d.delete(l),!0)}forEach(t,l){this.c.forEach((r,c)=>{t.call(l,r,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=n;class i{constructor(){this.c=new Map}add(t,l){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(l)}delete(t,l){const r=this.c.get(t);r&&(r.delete(l),r.size===0&&this.c.delete(t))}forEach(t,l){const r=this.c.get(t);r&&r.forEach(l)}get(t){const l=this.c.get(t);return l||new Set}}e.$Ic=i;function u(o,t){if(o===t)return!0;if(o.size!==t.size)return!1;for(const[l,r]of o)if(!t.has(l)||t.get(l)!==r)return!1;for(const[l]of t)if(!o.has(l))return!1;return!0}}),define(ke[3],Se([1,0,19,74,27,75,39]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=A,e.$Mc=P,e.$Nc=p,e.$Oc=h,e.$Pc=f,e.$Qc=a,e.$Rc=n,e.$Sc=i,e.$Tc=u,e.$4c=$;const b=!1;let m=null;class E{constructor(){this.b=new Map}static{this.a=0}c(C){let I=this.b.get(C);return I||(I={parent:null,source:null,isSingleton:!1,value:C,idx:E.a++},this.b.set(C,I)),I}trackDisposable(C){const I=this.c(C);I.source||(I.source=new Error().stack)}setParent(C,I){const F=this.c(C);F.parent=I}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,I){const F=I.get(C);if(F)return F;const j=C.parent?this.f(this.c(C.parent),I):C;return I.set(C,j),j}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,C).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(C=10,I){let F;if(I)F=I;else{const U=new Map,Z=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,U).isSingleton);if(Z.length===0)return;const te=new Set(Z.map(q=>q.value));if(F=Z.filter(q=>!(q.parent&&te.has(q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function j(U){function Z(q,K){for(;q.length>0&&K.some(Y=>typeof Y=="string"?Y===q[0]:q[0].match(Y));)q.shift()}const te=U.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return Z(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const z=new O.$Ic;for(const U of F){const Z=j(U);for(let te=0;te<=Z.length;te++)z.add(Z.slice(0,te).join(`
`),U)}F.sort((0,d.$7b)(U=>U.idx,d.$9b));let M="",T=0;for(const U of F.slice(0,C)){T++;const Z=j(U),te=[];for(let q=0;q<Z.length;q++){let K=Z[q];K=`(shared with ${z.get(Z.slice(0,q+1).join(`
`)).size}/${F.length} leaks) at ${K}`;const ie=z.get(Z.slice(0,q).join(`
`)),$e=(0,L.$K)([...ie].map(ue=>j(ue)[q]),ue=>ue);delete $e[Z[q]];for(const[ue,ve]of Object.entries($e))te.unshift(`    - stacktraces of ${ve.length} other leaks continue with ${ue}`);te.unshift(K)}M+=`


==================== Leaking disposable ${T}/${F.length}: ${U.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return F.length>C&&(M+=`


... and ${F.length-C} more leaking disposables

`),{leaks:F,details:M}}}e.$Kc=E;function A(S){m=S}if(b){const S="__is_disposable_tracked__";A(new class{trackDisposable(C){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[S]||console.log(I)},3e3)}setParent(C,I){if(C&&C!==t.None)try{C[S]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[S]=!0}catch{}}markAsSingleton(C){}})}function P(S){return m?.trackDisposable(S),S}function p(S){m?.markAsDisposed(S)}function y(S,C){m?.setParent(S,C)}function w(S,C){if(m)for(const I of S)m.setParent(I,C)}function h(S){return m?.markAsSingleton(S),S}function f(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function a(S){if(N.Iterable.is(S)){const C=[];for(const I of S)if(I)try{I.dispose()}catch(F){C.push(F)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function n(S){for(const C of S)f(C)&&C.dispose();return[]}function i(...S){const C=u(()=>a(S));return w(S,C),C}function u(S){const C=P({dispose:(0,R.$db)(()=>{p(C),S()})});return C}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return y(C,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),y(C,null))}}e.$Uc=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,P(this),y(this.q,this)}dispose(){p(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Vc=t;class l{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&y(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&y(C,null),C}}e.$Wc=l;class r{constructor(C){this.a=new l,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=r;class c{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=c;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(C){let I=C;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,p(this))},this}}e.$Zc=s;class v{constructor(){this.a=new Map}acquire(C,...I){let F=this.a.get(C);F||(F={counter:0,object:this.b(C,...I)},this.a.set(C,F));const{object:j}=F,z=(0,R.$db)(()=>{--F.counter===0&&(this.c(C,F.object),this.a.delete(C))});return F.counter++,{object:j,dispose:z}}}e.$1c=v;class g{constructor(C){this.a=C}async acquire(C,...I){const F=this.a.acquire(C,...I);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(j){throw F.dispose(),j}}}e.$2c=g;class D{constructor(C){this.object=C}dispose(){}}e.$3c=D;function $(S){const C=new o;try{S(C)}finally{C.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,I,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(C)?.dispose(),this.a.set(C,I)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=k}),function(le,e){typeof define=="function"&&define.amd?define(ke[167],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(oe,se){for(var re=0;re<se.length;re++){var G=se[re];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(oe,G.key,G)}}function d(oe,se,re){return se&&e(oe.prototype,se),re&&e(oe,re),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function L(oe,se){if(oe){if(typeof oe=="string")return O(oe,se);var re=Object.prototype.toString.call(oe).slice(8,-1);if(re==="Object"&&oe.constructor&&(re=oe.constructor.name),re==="Map"||re==="Set")return Array.from(oe);if(re==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(re))return O(oe,se)}}function O(oe,se){(se==null||se>oe.length)&&(se=oe.length);for(var re=0,G=new Array(se);re<se;re++)G[re]=oe[re];return G}function R(oe,se){var re=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(re)return(re=re.call(oe)).next.bind(re);if(Array.isArray(oe)||(re=L(oe))||se&&oe&&typeof oe.length=="number"){re&&(oe=re);var G=0;return function(){return G>=oe.length?{done:!0}:{done:!1,value:oe[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function N(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=N();function b(oe){le.defaults=oe}var m=/[&<>"']/,E=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(se){return p[se]};function w(oe,se){if(se){if(m.test(oe))return oe.replace(E,y)}else if(A.test(oe))return oe.replace(P,y);return oe}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(oe){return oe.replace(h,function(se,re){return re=re.toLowerCase(),re==="colon"?":":re.charAt(0)==="#"?re.charAt(1)==="x"?String.fromCharCode(parseInt(re.substring(2),16)):String.fromCharCode(+re.substring(1)):""})}var a=/(^|[^\[])\^/g;function n(oe,se){oe=typeof oe=="string"?oe:oe.source,se=se||"";var re={replace:function(ne,me){return me=me.source||me,me=me.replace(a,"$1"),oe=oe.replace(ne,me),re},getRegex:function(){return new RegExp(oe,se)}};return re}var i=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(oe,se,re){if(oe){var G;try{G=decodeURIComponent(f(re)).replace(i,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}se&&!u.test(re)&&(re=s(se,re));try{re=encodeURI(re).replace(/%25/g,"%")}catch{return null}return re}var t={},l=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(oe,se){t[" "+oe]||(l.test(oe)?t[" "+oe]=oe+"/":t[" "+oe]=$(oe,"/",!0)),oe=t[" "+oe];var re=oe.indexOf(":")===-1;return se.substring(0,2)==="//"?re?se:oe.replace(r,"$1")+se:se.charAt(0)==="/"?re?se:oe.replace(c,"$1")+se:oe+se}var v={exec:function(){}};function g(oe){for(var se=1,re,G;se<arguments.length;se++){re=arguments[se];for(G in re)Object.prototype.hasOwnProperty.call(re,G)&&(oe[G]=re[G])}return oe}function D(oe,se){var re=oe.replace(/\|/g,function(me,be,Re){for(var fe=!1,De=be;--De>=0&&Re[De]==="\\";)fe=!fe;return fe?"|":" |"}),G=re.split(/ \|/),ne=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>se)G.splice(se);else for(;G.length<se;)G.push("");for(;ne<G.length;ne++)G[ne]=G[ne].trim().replace(/\\\|/g,"|");return G}function $(oe,se,re){var G=oe.length;if(G===0)return"";for(var ne=0;ne<G;){var me=oe.charAt(G-ne-1);if(me===se&&!re)ne++;else if(me!==se&&re)ne++;else break}return oe.slice(0,G-ne)}function k(oe,se){if(oe.indexOf(se[1])===-1)return-1;for(var re=oe.length,G=0,ne=0;ne<re;ne++)if(oe[ne]==="\\")ne++;else if(oe[ne]===se[0])G++;else if(oe[ne]===se[1]&&(G--,G<0))return ne;return-1}function S(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(oe,se){if(se<1)return"";for(var re="";se>1;)se&1&&(re+=oe),se>>=1,oe+=oe;return re+oe}function I(oe,se,re,G){var ne=se.href,me=se.title?w(se.title):null,be=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){G.state.inLink=!0;var Re={type:"link",raw:re,href:ne,title:me,text:be,tokens:G.inlineTokens(be)};return G.state.inLink=!1,Re}return{type:"image",raw:re,href:ne,title:me,text:w(be)}}function F(oe,se){var re=oe.match(/^(\s+)(?:```)/);if(re===null)return se;var G=re[1];return se.split(`
`).map(function(ne){var me=ne.match(/^\s+/);if(me===null)return ne;var be=me[0];return be.length>=G.length?ne.slice(G.length):ne}).join(`
`)}var j=function(){function oe(re){this.options=re||le.defaults}var se=oe.prototype;return se.space=function(G){var ne=this.rules.block.newline.exec(G);if(ne&&ne[0].length>0)return{type:"space",raw:ne[0]}},se.code=function(G){var ne=this.rules.block.code.exec(G);if(ne){var me=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?me:$(me,`
`)}}},se.fences=function(G){var ne=this.rules.block.fences.exec(G);if(ne){var me=ne[0],be=F(me,ne[3]||"");return{type:"code",raw:me,lang:ne[2]?ne[2].trim():ne[2],text:be}}},se.heading=function(G){var ne=this.rules.block.heading.exec(G);if(ne){var me=ne[2].trim();if(/#$/.test(me)){var be=$(me,"#");(this.options.pedantic||!be||/ $/.test(be))&&(me=be.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:me,tokens:this.lexer.inline(me)}}},se.hr=function(G){var ne=this.rules.block.hr.exec(G);if(ne)return{type:"hr",raw:ne[0]}},se.blockquote=function(G){var ne=this.rules.block.blockquote.exec(G);if(ne){var me=ne[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ne[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},se.list=function(G){var ne=this.rules.block.list.exec(G);if(ne){var me,be,Re,fe,De,Ae,ze,W,V,J,X,he,we=ne[1].trim(),Fe=we.length>1,qe={type:"list",raw:"",ordered:Fe,start:Fe?+we.slice(0,-1):"",loose:!1,items:[]};we=Fe?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Fe?we:"[*+-]");for(var Je=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(he=!1,!(!(ne=Je.exec(G))||this.rules.block.hr.test(G)));){if(me=ne[0],G=G.substring(me.length),W=ne[2].split(`
`,1)[0],V=G.split(`
`,1)[0],this.options.pedantic?(fe=2,X=W.trimLeft()):(fe=ne[2].search(/[^ ]/),fe=fe>4?1:fe,X=W.slice(fe),fe+=ne[1].length),Ae=!1,!W&&/^ *$/.test(V)&&(me+=V+`
`,G=G.substring(V.length+1),he=!0),!he)for(var rt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");G&&(J=G.split(`
`,1)[0],W=J,this.options.pedantic&&(W=W.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(W)||st.test(W)||rt.test(W)||tt.test(G)));){if(W.search(/[^ ]/)>=fe||!W.trim())X+=`
`+W.slice(fe);else if(!Ae)X+=`
`+W;else break;!Ae&&!W.trim()&&(Ae=!0),me+=J+`
`,G=G.substring(J.length+1)}qe.loose||(ze?qe.loose=!0:/\n *\n *$/.test(me)&&(ze=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(X),be&&(Re=be[0]!=="[ ] ",X=X.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:me,task:!!be,checked:Re,loose:!1,text:X}),qe.raw+=me}qe.items[qe.items.length-1].raw=me.trimRight(),qe.items[qe.items.length-1].text=X.trimRight(),qe.raw=qe.raw.trimRight();var Pe=qe.items.length;for(De=0;De<Pe;De++){this.lexer.state.top=!1,qe.items[De].tokens=this.lexer.blockTokens(qe.items[De].text,[]);var Be=qe.items[De].tokens.filter(function(Le){return Le.type==="space"}),He=Be.every(function(Le){for(var Xe=Le.raw.split(""),ae=0,ce=R(Xe),Ie;!(Ie=ce()).done;){var Ge=Ie.value;if(Ge===`
`&&(ae+=1),ae>1)return!0}return!1});!qe.loose&&Be.length&&He&&(qe.loose=!0,qe.items[De].loose=!0)}return qe}},se.html=function(G){var ne=this.rules.block.html.exec(G);if(ne){var me={type:"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:ne[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ne[0]):w(ne[0]);me.type="paragraph",me.text=be,me.tokens=this.lexer.inline(be)}return me}},se.def=function(G){var ne=this.rules.block.def.exec(G);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var me=ne[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ne[0],href:ne[2],title:ne[3]}}},se.table=function(G){var ne=this.rules.block.table.exec(G);if(ne){var me={type:"table",header:D(ne[1]).map(function(ze){return{text:ze}}),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ne[3]&&ne[3].trim()?ne[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ne[0];var be=me.align.length,Re,fe,De,Ae;for(Re=0;Re<be;Re++)/^ *-+: *$/.test(me.align[Re])?me.align[Re]="right":/^ *:-+: *$/.test(me.align[Re])?me.align[Re]="center":/^ *:-+ *$/.test(me.align[Re])?me.align[Re]="left":me.align[Re]=null;for(be=me.rows.length,Re=0;Re<be;Re++)me.rows[Re]=D(me.rows[Re],me.header.length).map(function(ze){return{text:ze}});for(be=me.header.length,fe=0;fe<be;fe++)me.header[fe].tokens=this.lexer.inline(me.header[fe].text);for(be=me.rows.length,fe=0;fe<be;fe++)for(Ae=me.rows[fe],De=0;De<Ae.length;De++)Ae[De].tokens=this.lexer.inline(Ae[De].text);return me}}},se.lheading=function(G){var ne=this.rules.block.lheading.exec(G);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1],tokens:this.lexer.inline(ne[1])}},se.paragraph=function(G){var ne=this.rules.block.paragraph.exec(G);if(ne){var me=ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1];return{type:"paragraph",raw:ne[0],text:me,tokens:this.lexer.inline(me)}}},se.text=function(G){var ne=this.rules.block.text.exec(G);if(ne)return{type:"text",raw:ne[0],text:ne[0],tokens:this.lexer.inline(ne[0])}},se.escape=function(G){var ne=this.rules.inline.escape.exec(G);if(ne)return{type:"escape",raw:ne[0],text:w(ne[1])}},se.tag=function(G){var ne=this.rules.inline.tag.exec(G);if(ne)return!this.lexer.state.inLink&&/^<a /i.test(ne[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ne[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ne[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ne[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ne[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):w(ne[0]):ne[0]}},se.link=function(G){var ne=this.rules.inline.link.exec(G);if(ne){var me=ne[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var be=$(me.slice(0,-1),"\\");if((me.length-be.length)%2===0)return}else{var Re=k(ne[2],"()");if(Re>-1){var fe=ne[0].indexOf("!")===0?5:4,De=fe+ne[1].length+Re;ne[2]=ne[2].substring(0,Re),ne[0]=ne[0].substring(0,De).trim(),ne[3]=""}}var Ae=ne[2],ze="";if(this.options.pedantic){var W=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);W&&(Ae=W[1],ze=W[3])}else ze=ne[3]?ne[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(me)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),I(ne,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},ne[0],this.lexer)}},se.reflink=function(G,ne){var me;if((me=this.rules.inline.reflink.exec(G))||(me=this.rules.inline.nolink.exec(G))){var be=(me[2]||me[1]).replace(/\s+/g," ");if(be=ne[be.toLowerCase()],!be||!be.href){var Re=me[0].charAt(0);return{type:"text",raw:Re,text:Re}}return I(me,be,me[0],this.lexer)}},se.emStrong=function(G,ne,me){me===void 0&&(me="");var be=this.rules.inline.emStrong.lDelim.exec(G);if(be&&!(be[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Re=be[1]||be[2]||"";if(!Re||Re&&(me===""||this.rules.inline.punctuation.exec(me))){var fe=be[0].length-1,De,Ae,ze=fe,W=0,V=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,ne=ne.slice(-1*G.length+fe);(be=V.exec(ne))!=null;)if(De=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!De){if(Ae=De.length,be[3]||be[4]){ze+=Ae;continue}else if((be[5]||be[6])&&fe%3&&!((fe+Ae)%3)){W+=Ae;continue}if(ze-=Ae,!(ze>0)){if(Ae=Math.min(Ae,Ae+ze+W),Math.min(fe,Ae)%2){var J=G.slice(1,fe+be.index+Ae);return{type:"em",raw:G.slice(0,fe+be.index+Ae+1),text:J,tokens:this.lexer.inlineTokens(J)}}var X=G.slice(2,fe+be.index+Ae-1);return{type:"strong",raw:G.slice(0,fe+be.index+Ae+1),text:X,tokens:this.lexer.inlineTokens(X)}}}}}},se.codespan=function(G){var ne=this.rules.inline.code.exec(G);if(ne){var me=ne[2].replace(/\n/g," "),be=/[^ ]/.test(me),Re=/^ /.test(me)&&/ $/.test(me);return be&&Re&&(me=me.substring(1,me.length-1)),me=w(me,!0),{type:"codespan",raw:ne[0],text:me}}},se.br=function(G){var ne=this.rules.inline.br.exec(G);if(ne)return{type:"br",raw:ne[0]}},se.del=function(G){var ne=this.rules.inline.del.exec(G);if(ne)return{type:"del",raw:ne[0],text:ne[2],tokens:this.lexer.inlineTokens(ne[2])}},se.autolink=function(G,ne){var me=this.rules.inline.autolink.exec(G);if(me){var be,Re;return me[2]==="@"?(be=w(this.options.mangle?ne(me[1]):me[1]),Re="mailto:"+be):(be=w(me[1]),Re=be),{type:"link",raw:me[0],text:be,href:Re,tokens:[{type:"text",raw:be,text:be}]}}},se.url=function(G,ne){var me;if(me=this.rules.inline.url.exec(G)){var be,Re;if(me[2]==="@")be=w(this.options.mangle?ne(me[0]):me[0]),Re="mailto:"+be;else{var fe;do fe=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(fe!==me[0]);be=w(me[0]),me[1]==="www."?Re="http://"+be:Re=be}return{type:"link",raw:me[0],text:be,href:Re,tokens:[{type:"text",raw:be,text:be}]}}},se.inlineText=function(G,ne){var me=this.rules.inline.text.exec(G);if(me){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):w(me[0]):me[0]:be=w(this.options.smartypants?ne(me[0]):me[0]),{type:"text",raw:me[0],text:be}}},oe}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=g({},z),z.gfm=g({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=g({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=n(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=n(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=n(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=n(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=n(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=n(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=n(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=n(M.reflink).replace("label",M._label).replace("ref",z._label).getRegex(),M.nolink=n(M.nolink).replace("ref",z._label).getRegex(),M.reflinkSearch=n(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=g({},M),M.pedantic=g({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=g({},M.normal,{escape:n(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=n(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=g({},M.gfm,{br:n(M.br).replace("{2,}","*").getRegex(),text:n(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(oe){var se="",re,G,ne=oe.length;for(re=0;re<ne;re++)G=oe.charCodeAt(re),Math.random()>.5&&(G="x"+G.toString(16)),se+="&#"+G+";";return se}var Z=function(){function oe(re){this.tokens=[],this.tokens.links=Object.create(null),this.options=re||le.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:z.normal,inline:M.normal};this.options.pedantic?(G.block=z.pedantic,G.inline=M.pedantic):this.options.gfm&&(G.block=z.gfm,this.options.breaks?G.inline=M.breaks:G.inline=M.gfm),this.tokenizer.rules=G}oe.lex=function(G,ne){var me=new oe(ne);return me.lex(G)},oe.lexInline=function(G,ne){var me=new oe(ne);return me.inlineTokens(G)};var se=oe.prototype;return se.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var ne;ne=this.inlineQueue.shift();)this.inlineTokens(ne.src,ne.tokens);return this.tokens},se.blockTokens=function(G,ne){var me=this;ne===void 0&&(ne=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(ze,W,V){return W+"    ".repeat(V.length)});for(var be,Re,fe,De;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(be=ze.call({lexer:me},G,ne))?(G=G.substring(be.raw.length),ne.push(be),!0):!1}))){if(be=this.tokenizer.space(G)){G=G.substring(be.raw.length),be.raw.length===1&&ne.length>0?ne[ne.length-1].raw+=`
`:ne.push(be);continue}if(be=this.tokenizer.code(G)){G=G.substring(be.raw.length),Re=ne[ne.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+be.raw,Re.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):ne.push(be);continue}if(be=this.tokenizer.fences(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.heading(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.hr(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.blockquote(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.list(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.html(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.def(G)){G=G.substring(be.raw.length),Re=ne[ne.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+be.raw,Re.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.lheading(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(fe=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,W=G.slice(1),V=void 0;me.options.extensions.startBlock.forEach(function(J){V=J.call({lexer:this},W),typeof V=="number"&&V>=0&&(ze=Math.min(ze,V))}),ze<1/0&&ze>=0&&(fe=G.substring(0,ze+1))}(),this.state.top&&(be=this.tokenizer.paragraph(fe))){Re=ne[ne.length-1],De&&Re.type==="paragraph"?(Re.raw+=`
`+be.raw,Re.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):ne.push(be),De=fe.length!==G.length,G=G.substring(be.raw.length);continue}if(be=this.tokenizer.text(G)){G=G.substring(be.raw.length),Re=ne[ne.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+be.raw,Re.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):ne.push(be);continue}if(G){var Ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,ne},se.inline=function(G,ne){return ne===void 0&&(ne=[]),this.inlineQueue.push({src:G,tokens:ne}),ne},se.inlineTokens=function(G,ne){var me=this;ne===void 0&&(ne=[]);var be,Re,fe,De=G,Ae,ze,W;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)V.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Ae.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(ze||(W=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(be=X.call({lexer:me},G,ne))?(G=G.substring(be.raw.length),ne.push(be),!0):!1}))){if(be=this.tokenizer.escape(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.tag(G)){G=G.substring(be.raw.length),Re=ne[ne.length-1],Re&&be.type==="text"&&Re.type==="text"?(Re.raw+=be.raw,Re.text+=be.text):ne.push(be);continue}if(be=this.tokenizer.link(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(be.raw.length),Re=ne[ne.length-1],Re&&be.type==="text"&&Re.type==="text"?(Re.raw+=be.raw,Re.text+=be.text):ne.push(be);continue}if(be=this.tokenizer.emStrong(G,De,W)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.codespan(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.br(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.del(G)){G=G.substring(be.raw.length),ne.push(be);continue}if(be=this.tokenizer.autolink(G,U)){G=G.substring(be.raw.length),ne.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(G,U))){G=G.substring(be.raw.length),ne.push(be);continue}if(fe=G,this.options.extensions&&this.options.extensions.startInline&&function(){var X=1/0,he=G.slice(1),we=void 0;me.options.extensions.startInline.forEach(function(Fe){we=Fe.call({lexer:this},he),typeof we=="number"&&we>=0&&(X=Math.min(X,we))}),X<1/0&&X>=0&&(fe=G.substring(0,X+1))}(),be=this.tokenizer.inlineText(fe,T)){G=G.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(W=be.raw.slice(-1)),ze=!0,Re=ne[ne.length-1],Re&&Re.type==="text"?(Re.raw+=be.raw,Re.text+=be.text):ne.push(be);continue}if(G){var J="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return ne},d(oe,null,[{key:"rules",get:function(){return{block:z,inline:M}}}]),oe}(),te=function(){function oe(re){this.options=re||le.defaults}var se=oe.prototype;return se.code=function(G,ne,me){var be=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Re=this.options.highlight(G,be);Re!=null&&Re!==G&&(me=!0,G=Re)}return G=G.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+w(be,!0)+'">'+(me?G:w(G,!0))+`</code></pre>
`:"<pre><code>"+(me?G:w(G,!0))+`</code></pre>
`},se.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},se.html=function(G){return G},se.heading=function(G,ne,me,be){if(this.options.headerIds){var Re=this.options.headerPrefix+be.slug(me);return"<h"+ne+' id="'+Re+'">'+G+"</h"+ne+`>
`}return"<h"+ne+">"+G+"</h"+ne+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(G,ne,me){var be=ne?"ol":"ul",Re=ne&&me!==1?' start="'+me+'"':"";return"<"+be+Re+`>
`+G+"</"+be+`>
`},se.listitem=function(G){return"<li>"+G+`</li>
`},se.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(G){return"<p>"+G+`</p>
`},se.table=function(G,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+ne+`</table>
`},se.tablerow=function(G){return`<tr>
`+G+`</tr>
`},se.tablecell=function(G,ne){var me=ne.header?"th":"td",be=ne.align?"<"+me+' align="'+ne.align+'">':"<"+me+">";return be+G+("</"+me+`>
`)},se.strong=function(G){return"<strong>"+G+"</strong>"},se.em=function(G){return"<em>"+G+"</em>"},se.codespan=function(G){return"<code>"+G+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(G){return"<del>"+G+"</del>"},se.link=function(G,ne,me){if(G=o(this.options.sanitize,this.options.baseUrl,G),G===null)return me;var be='<a href="'+w(G)+'"';return ne&&(be+=' title="'+ne+'"'),be+=">"+me+"</a>",be},se.image=function(G,ne,me){if(G=o(this.options.sanitize,this.options.baseUrl,G),G===null)return me;var be='<img src="'+G+'" alt="'+me+'"';return ne&&(be+=' title="'+ne+'"'),be+=this.options.xhtml?"/>":">",be},se.text=function(G){return G},oe}(),q=function(){function oe(){}var se=oe.prototype;return se.strong=function(G){return G},se.em=function(G){return G},se.codespan=function(G){return G},se.del=function(G){return G},se.html=function(G){return G},se.text=function(G){return G},se.link=function(G,ne,me){return""+me},se.image=function(G,ne,me){return""+me},se.br=function(){return""},oe}(),K=function(){function oe(){this.seen={}}var se=oe.prototype;return se.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(G,ne){var me=G,be=0;if(this.seen.hasOwnProperty(me)){be=this.seen[G];do be++,me=G+"-"+be;while(this.seen.hasOwnProperty(me))}return ne||(this.seen[G]=be,this.seen[me]=0),me},se.slug=function(G,ne){ne===void 0&&(ne={});var me=this.serialize(G);return this.getNextSafeSlug(me,ne.dryrun)},oe}(),Y=function(){function oe(re){this.options=re||le.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new K}oe.parse=function(G,ne){var me=new oe(ne);return me.parse(G)},oe.parseInline=function(G,ne){var me=new oe(ne);return me.parseInline(G)};var se=oe.prototype;return se.parse=function(G,ne){ne===void 0&&(ne=!0);var me="",be,Re,fe,De,Ae,ze,W,V,J,X,he,we,Fe,qe,Je,rt,tt,nt,st,Pe=G.length;for(be=0;be<Pe;be++){if(X=G[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(st=this.options.extensions.renderers[X.type].call({parser:this},X),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){me+=st||"";continue}switch(X.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(X.tokens),X.depth,f(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(V="",W="",De=X.header.length,Re=0;Re<De;Re++)W+=this.renderer.tablecell(this.parseInline(X.header[Re].tokens),{header:!0,align:X.align[Re]});for(V+=this.renderer.tablerow(W),J="",De=X.rows.length,Re=0;Re<De;Re++){for(ze=X.rows[Re],W="",Ae=ze.length,fe=0;fe<Ae;fe++)W+=this.renderer.tablecell(this.parseInline(ze[fe].tokens),{header:!1,align:X.align[fe]});J+=this.renderer.tablerow(W)}me+=this.renderer.table(V,J);continue}case"blockquote":{J=this.parse(X.tokens),me+=this.renderer.blockquote(J);continue}case"list":{for(he=X.ordered,we=X.start,Fe=X.loose,De=X.items.length,J="",Re=0;Re<De;Re++)Je=X.items[Re],rt=Je.checked,tt=Je.task,qe="",Je.task&&(nt=this.renderer.checkbox(rt),Fe?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=nt+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=nt+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:nt}):qe+=nt),qe+=this.parse(Je.tokens,Fe),J+=this.renderer.listitem(qe,tt,rt);me+=this.renderer.list(J,he,we);continue}case"html":{me+=this.renderer.html(X.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(J=X.tokens?this.parseInline(X.tokens):X.text;be+1<Pe&&G[be+1].type==="text";)X=G[++be],J+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);me+=ne?this.renderer.paragraph(J):J;continue}default:{var Be='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return me},se.parseInline=function(G,ne){ne=ne||this.renderer;var me="",be,Re,fe,De=G.length;for(be=0;be<De;be++){if(Re=G[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(fe=this.options.extensions.renderers[Re.type].call({parser:this},Re),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Re.type))){me+=fe||"";continue}switch(Re.type){case"escape":{me+=ne.text(Re.text);break}case"html":{me+=ne.html(Re.text);break}case"link":{me+=ne.link(Re.href,Re.title,this.parseInline(Re.tokens,ne));break}case"image":{me+=ne.image(Re.href,Re.title,Re.text);break}case"strong":{me+=ne.strong(this.parseInline(Re.tokens,ne));break}case"em":{me+=ne.em(this.parseInline(Re.tokens,ne));break}case"codespan":{me+=ne.codespan(Re.text);break}case"br":{me+=ne.br();break}case"del":{me+=ne.del(this.parseInline(Re.tokens,ne));break}case"text":{me+=ne.text(Re.text);break}default:{var Ae='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return me},oe}();function ie(oe,se,re){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof se=="function"&&(re=se,se=null),se=g({},ie.defaults,se||{}),S(se),re){var G=se.highlight,ne;try{ne=Z.lex(oe,se)}catch(De){return re(De)}var me=function(Ae){var ze;if(!Ae)try{se.walkTokens&&ie.walkTokens(ne,se.walkTokens),ze=Y.parse(ne,se)}catch(W){Ae=W}return se.highlight=G,Ae?re(Ae):re(null,ze)};if(!G||G.length<3||(delete se.highlight,!ne.length))return me();var be=0;ie.walkTokens(ne,function(De){De.type==="code"&&(be++,setTimeout(function(){G(De.text,De.lang,function(Ae,ze){if(Ae)return me(Ae);ze!=null&&ze!==De.text&&(De.text=ze,De.escaped=!0),be--,be===0&&me()})},0))}),be===0&&me();return}function Re(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+w(De.message+"",!0)+"</pre>";throw De}try{var fe=Z.lex(oe,se);if(se.walkTokens){if(se.async)return Promise.all(ie.walkTokens(fe,se.walkTokens)).then(function(){return Y.parse(fe,se)}).catch(Re);ie.walkTokens(fe,se.walkTokens)}return Y.parse(fe,se)}catch(De){Re(De)}}ie.options=ie.setOptions=function(oe){return g(ie.defaults,oe),b(ie.defaults),ie},ie.getDefaults=N,ie.defaults=le.defaults,ie.use=function(){for(var oe=arguments.length,se=new Array(oe),re=0;re<oe;re++)se[re]=arguments[re];var G=g.apply(void 0,[{}].concat(se)),ne=ie.defaults.extensions||{renderers:{},childTokens:{}},me;se.forEach(function(be){if(be.extensions&&(me=!0,be.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var De=ne.renderers?ne.renderers[fe.name]:null;De?ne.renderers[fe.name]=function(){for(var Ae=arguments.length,ze=new Array(Ae),W=0;W<Ae;W++)ze[W]=arguments[W];var V=fe.renderer.apply(this,ze);return V===!1&&(V=De.apply(this,ze)),V}:ne.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ne[fe.level]?ne[fe.level].unshift(fe.tokenizer):ne[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?ne.startBlock?ne.startBlock.push(fe.start):ne.startBlock=[fe.start]:fe.level==="inline"&&(ne.startInline?ne.startInline.push(fe.start):ne.startInline=[fe.start]))}fe.childTokens&&(ne.childTokens[fe.name]=fe.childTokens)})),be.renderer&&function(){var fe=ie.defaults.renderer||new te,De=function(W){var V=fe[W];fe[W]=function(){for(var J=arguments.length,X=new Array(J),he=0;he<J;he++)X[he]=arguments[he];var we=be.renderer[W].apply(fe,X);return we===!1&&(we=V.apply(fe,X)),we}};for(var Ae in be.renderer)De(Ae);G.renderer=fe}(),be.tokenizer&&function(){var fe=ie.defaults.tokenizer||new j,De=function(W){var V=fe[W];fe[W]=function(){for(var J=arguments.length,X=new Array(J),he=0;he<J;he++)X[he]=arguments[he];var we=be.tokenizer[W].apply(fe,X);return we===!1&&(we=V.apply(fe,X)),we}};for(var Ae in be.tokenizer)De(Ae);G.tokenizer=fe}(),be.walkTokens){var Re=ie.defaults.walkTokens;G.walkTokens=function(fe){var De=[];return De.push(be.walkTokens.call(this,fe)),Re&&(De=De.concat(Re.call(this,fe))),De}}me&&(G.extensions=ne),ie.setOptions(G)})},ie.walkTokens=function(oe,se){for(var re=[],G=function(){var Re=me.value;switch(re=re.concat(se.call(ie,Re)),Re.type){case"table":{for(var fe=R(Re.header),De;!(De=fe()).done;){var Ae=De.value;re=re.concat(ie.walkTokens(Ae.tokens,se))}for(var ze=R(Re.rows),W;!(W=ze()).done;)for(var V=W.value,J=R(V),X;!(X=J()).done;){var he=X.value;re=re.concat(ie.walkTokens(he.tokens,se))}break}case"list":{re=re.concat(ie.walkTokens(Re.items,se));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[Re.type]?ie.defaults.extensions.childTokens[Re.type].forEach(function(we){re=re.concat(ie.walkTokens(Re[we],se))}):Re.tokens&&(re=re.concat(ie.walkTokens(Re.tokens,se)))}},ne=R(oe),me;!(me=ne()).done;)G();return re},ie.parseInline=function(oe,se){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");se=g({},ie.defaults,se||{}),S(se);try{var re=Z.lexInline(oe,se);return se.walkTokens&&ie.walkTokens(re,se.walkTokens),Y.parseInline(re,se)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+w(G.message+"",!0)+"</pre>";throw G}},ie.Parser=Y,ie.parser=Y.parse,ie.Renderer=te,ie.TextRenderer=q,ie.Lexer=Z,ie.lexer=Z.lex,ie.Tokenizer=j,ie.Slugger=K,ie.parse=ie;var $e=ie.options,ue=ie.setOptions,ve=ie.use,_=ie.walkTokens,B=ie.parseInline,ee=ie,pe=Y.parse,Ce=Z.lex;le.Lexer=Z,le.Parser=Y,le.Renderer=te,le.Slugger=K,le.TextRenderer=q,le.Tokenizer=j,le.getDefaults=N,le.lexer=Ce,le.marked=ie,le.options=$e,le.parse=ee,le.parseInline=B,le.parser=pe,le.setOptions=ue,le.use=ve,le.walkTokens=_,Object.defineProperty(le,"__esModule",{value:!0})}),define(ke[168],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=d;function d(h){const f=R(h);if(f&&f.length>0)return new Uint32Array(f)}let L=0;const O=new Uint32Array(10);function R(h){if(L=0,N(h,P,4352),L>0||(N(h,p,4449),L>0)||(N(h,y,4520),L>0)||(N(h,w,12593),L))return O.subarray(0,L);if(h>=44032&&h<=55203){const f=h-44032,a=f%588,n=Math.floor(f/588),i=Math.floor(a/28),u=a%28-1;if(n<P.length?N(n,P,0):4352+n-12593<w.length&&N(4352+n,w,12593),i<p.length?N(i,p,0):4449+i-12593<w.length&&N(4449+i-12593,w,12593),u>=0&&(u<y.length?N(u,y,0):4520+u-12593<w.length&&N(4520+u-12593,w,12593)),L>0)return O.subarray(0,L)}}function N(h,f,a){h>=a&&h<a+f.length&&b(f[h-a])}function b(h){h!==0&&(O[L++]=h&255,h>>8&&(O[L++]=h>>8&255),h>>16&&(O[L++]=h>>16&255))}var m;(function(h){h[h.InitialConsonant=4352]="InitialConsonant",h[h.Vowel=4449]="Vowel",h[h.FinalConsonant=4520]="FinalConsonant",h[h.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var E;(function(h){h[h.NUL=0]="NUL",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z"})(E||(E={}));var A;(function(h){h[h.fa=24934]="fa",h[h.fg=26470]="fg",h[h.fq=29030]="fq",h[h.fr=29286]="fr",h[h.ft=29798]="ft",h[h.fv=30310]="fv",h[h.fx=30822]="fx",h[h.hk=27496]="hk",h[h.hl=27752]="hl",h[h.ho=28520]="ho",h[h.ml=27757]="ml",h[h.nj=27246]="nj",h[h.nl=27758]="nl",h[h.np=28782]="np",h[h.qt=29809]="qt",h[h.rt=29810]="rt",h[h.sg=26483]="sg",h[h.sw=30579]="sw"})(A||(A={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),y=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),w=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[77],Se([1,0,27]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0,e.$bm=O,e.$cm=N;const L=new d.$Ec(1e4);function O(E){return m(E,"NFC",L)}const R=new d.$Ec(1e4);function N(E){return m(E,"NFD",R)}const b=/[^\u0000-\u0080]/;function m(E,A,P){if(!E)return E;const p=P.get(E);if(p)return p;let y;return b.test(E)?y=E.normalize(A):y=E,P.set(E,y),y}e.$dm=function(){const E=/[\u0300-\u036f]/g;return function(A){return N(A).replace(E,"")}}()}),define(ke[126],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0,e.$Bm=d,e.rot=L;function d(b,m,E){return Math.min(Math.max(b,m),E)}function L(b,m){return(m+b%m)%m}class O{constructor(){this.a=0}getNext(){return this.a++}}e.$Dm=O;class R{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Em=R;class N{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const E=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Fm=N}),define(ke[169],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=R,e.$dd=p;class d{constructor(w,h,f){this.owner=w,this.debugNameSource=h,this.referenceFn=f}getDebugName(w){return R(w,this)}}e.$bd=d;const L=new Map,O=new WeakMap;function R(y,w){const h=O.get(y);if(h)return h;const f=N(y,w);if(f){let a=L.get(f)??0;a++,L.set(f,a);const n=a===1?f:`${f}#${a}`;return O.set(y,n),n}}function N(y,w){const h=O.get(y);if(h)return h;const f=w.owner?A(w.owner)+".":"";let a;const n=w.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(a=n(),a!==void 0)return f+a}else return f+n;const i=w.referenceFn;if(i!==void 0&&(a=p(i),a!==void 0))return f+a;if(w.owner!==void 0){const u=b(w.owner,y);if(u!==void 0)return f+u}}function b(y,w){for(const h in y)if(y[h]===w)return h}const m=new Map,E=new WeakMap;function A(y){const w=E.get(y);if(w)return w;const h=P(y);let f=m.get(h)??0;f++,m.set(h,f);const a=f===1?h:`${h}#${f}`;return E.set(y,a),a}function P(y){const w=y.constructor;return w?w.name:"Object"}function p(y){const w=y.toString(),f=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return(f?f[1]:void 0)?.trim()}}),define(ke[170],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=L,e.$Jd=O;let d;function L(h){d=h}function O(){return d}class R{constructor(){this.a=0,this.d=new WeakMap}b(f){return N([b(y("|  ",this.a)),f])}c(f){return f.hadValue?f.didChange?[b(" "),E(A(f.oldValue,70),{color:"red",strikeThrough:!0}),b(" "),E(A(f.newValue,60),{color:"green"})]:[b(" (unchanged)")]:[b(" "),E(A(f.newValue,60),{color:"green"}),b(" (initial)")]}handleObservableChanged(f,a){console.log(...this.b([m("observable value changed"),E(f.debugName,{color:"BlueViolet"}),...this.c(a)]))}formatChanges(f){if(f.size!==0)return E(" (changed deps: "+[...f].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(f){const a=f.handleChange;this.d.set(f,new Set),f.handleChange=(n,i)=>(this.d.get(f).add(n),a.apply(f,[n,i]))}handleDerivedRecomputed(f,a){const n=this.d.get(f);console.log(...this.b([m("derived recomputed"),E(f.debugName,{color:"BlueViolet"}),...this.c(a),this.formatChanges(n),{data:[{fn:f._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(f,a){console.log(...this.b([m("observable from event triggered"),E(f.debugName,{color:"BlueViolet"}),...this.c(a),{data:[{fn:f._getValue}]}]))}handleAutorunCreated(f){const a=f.handleChange;this.d.set(f,new Set),f.handleChange=(n,i)=>(this.d.get(f).add(n),a.apply(f,[n,i]))}handleAutorunTriggered(f){const a=this.d.get(f);console.log(...this.b([m("autorun"),E(f.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:f._runFn}]}])),a.clear(),this.a++}handleAutorunFinished(f){this.a--}handleBeginTransaction(f){let a=f.getDebugName();a===void 0&&(a=""),console.log(...this.b([m("transaction"),E(a,{color:"BlueViolet"}),{data:[{fn:f._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=R;function N(h){const f=new Array,a=[];let n="";function i(o){if("length"in o)for(const t of o)t&&i(t);else"text"in o?(n+=`%c${o.text}`,f.push(o.style),o.data&&a.push(...o.data)):"data"in o&&a.push(...o.data)}i(h);const u=[n,...f];return u.push(...a),u}function b(h){return E(h,{color:"black"})}function m(h){return E(w(`${h}: `,10),{color:"black",bold:!0})}function E(h,f={color:"black"}){function a(i){return Object.entries(i).reduce((u,[o,t])=>`${u}${o}:${t};`,"")}const n={color:f.color};return f.strikeThrough&&(n["text-decoration"]="line-through"),f.bold&&(n["font-weight"]="bold"),{text:h,style:a(n)}}function A(h,f){switch(typeof h){case"number":return""+h;case"string":return h.length+2<=f?`"${h}"`:`"${h.substr(0,f-7)}"+...`;case"boolean":return h?"true":"false";case"undefined":return"undefined";case"object":return h===null?"null":Array.isArray(h)?P(h,f):p(h,f);case"symbol":return h.toString();case"function":return`[[Function${h.name?" "+h.name:""}]]`;default:return""+h}}function P(h,f){let a="[ ",n=!0;for(const i of h){if(n||(a+=", "),a.length-5>f){a+="...";break}n=!1,a+=`${A(i,f-a.length)}`}return a+=" ]",a}function p(h,f){let a="{ ",n=!0;for(const[i,u]of Object.entries(h)){if(n||(a+=", "),a.length-5>f){a+="...";break}n=!1,a+=`${i}: ${A(u,f-a.length)}`}return a+=" }",a}function y(h,f){let a="";for(let n=1;n<=f;n++)a+=h;return a}function w(h,f){for(;h.length<f;)h+=" ";return h}}),define(ke[171],Se([1,0,165,169,170]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$4d=e.$1d=e.$Vd=e.$Ud=void 0,e.$Rd=N,e.$Sd=m,e.$Td=A,e.$Wd=y,e.$Xd=h,e.$Yd=f,e.$Zd=a,e.$2d=i,e.$3d=u,e.$5d=t;let R;function N(r){R=r}let b;function m(r){b=r}let E;function A(r){E=r}class P{get TChange(){return null}reportChanges(){this.get()}read(c){return c?c.readObservable(this):this.get()}map(c,s){const v=s===void 0?void 0:c,g=s===void 0?c:s;return E({owner:v,debugName:()=>{const D=(0,L.$dd)(g);if(D!==void 0)return D;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(g.toString());if(k)return`${this.debugName}.${k[2]}`;if(!v)return`${this.debugName} (mapped)`},debugReferenceFn:g},D=>g(this.read(D),D))}recomputeInitiallyAndOnChange(c,s){return c.add(R(this,s)),this}keepObserved(c){return c.add(b(this)),this}get a(){return this.get()}}e.$Ud=P;class p extends P{constructor(){super(...arguments),this.b=new Set}addObserver(c){const s=this.b.size;this.b.add(c),s===0&&this.c()}removeObserver(c){this.b.delete(c)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Vd=p;function y(r,c){const s=new n(r,c);try{r(s)}finally{s.finish()}}let w;function h(r){if(w)r(w);else{const c=new n(r,void 0);w=c;try{r(c)}finally{c.finish(),w=void 0}}}async function f(r,c){const s=new n(r,c);try{await r(s)}finally{s.finish()}}function a(r,c,s){r?c(r):y(c,s)}class n{constructor(c,s){this._fn=c,this.b=s,this.a=[],(0,O.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,L.$dd)(this._fn)}updateObserver(c,s){this.a.push({observer:c,observable:s}),c.beginUpdate(s)}finish(){const c=this.a;for(let s=0;s<c.length;s++){const{observer:v,observable:g}=c[s];v.endUpdate(g)}this.a=null,(0,O.$Jd)()?.handleEndTransaction()}}e.$1d=n;function i(r,c){let s;return typeof r=="string"?s=new L.$bd(void 0,r,void 0):s=new L.$bd(r,void 0,void 0),new o(s,c,d.$7c)}function u(r,c){return new o(new L.$bd(r.owner,r.debugName,void 0),c,r.equalsFn??d.$7c)}class o extends p{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(c,s,v){super(),this.e=c,this.g=v,this.d=s}get(){return this.d}set(c,s,v){if(this.g(this.d,c))return;let g;s||(s=g=new n(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(c),(0,O.$Jd)()?.handleObservableChanged(this,{oldValue:D,newValue:c,change:v,didChange:!0,hadValue:!0});for(const $ of this.b)s.updateObserver($,this),$.handleChange(this,v)}finally{g&&g.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(c){this.d=c}}e.$4d=o;function t(r,c){let s;return typeof r=="string"?s=new L.$bd(void 0,r,void 0):s=new L.$bd(r,void 0,void 0),new l(s,c,d.$7c)}class l extends o{h(c){this.d!==c&&(this.d&&this.d.dispose(),this.d=c)}dispose(){this.d?.dispose()}}e.$6d=l}),function(){function le(O){const R=[];typeof O=="number"&&R.push("code/timeOrigin",O);function N(m){R.push(m,Date.now())}function b(){const m=[];for(let E=0;E<R.length;E+=2)m.push({name:R[E],startTime:R[E+1]});return m}return{mark:N,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const N of performance.getEntriesByType("mark"))R.push({name:N.name,startTime:Math.round(O+N.startTime)});return R}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function d(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=d(L))}(),define(ke[172],Se([1,0,39]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fP=void 0;const L=Symbol("unset");class O{constructor(){this.a=new N,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||d.Iterable.empty()}insert(m,E,A){this.d(m,P=>P._value=E,A)}mutate(m,E){this.d(m,A=>A._value=E(A._value===L?void 0:A._value))}delete(m){const E=this.c(m);if(!E)return;let A=E.length-1;const P=E[A].node._value;if(P!==L){for(this.b--,E[A].node._value=L;A>0;A--){const{node:p,part:y}=E[A];if(p.children?.size||p._value!==L)break;E[A-1].node.children.delete(y)}return P}}*deleteRecursive(m){const E=this.c(m);if(!E)return;const A=E[E.length-1].node;for(let P=E.length-1;P>0;P--){const p=E[P-1];if(p.node.children.delete(E[P].part),p.node.children.size>0||p.node._value!==L)break}for(const P of R(A))P._value!==L&&(this.b--,yield P._value)}find(m){let E=this.a;for(const A of m){const P=E.children?.get(A);if(!P)return;E=P}return E._value===L?void 0:E._value}hasKeyOrParent(m){let E=this.a;for(const A of m){const P=E.children?.get(A);if(!P)return!1;if(P._value!==L)return!0;E=P}return!1}hasKeyOrChildren(m){let E=this.a;for(const A of m){const P=E.children?.get(A);if(!P)return!1;E=P}return!0}hasKey(m){let E=this.a;for(const A of m){const P=E.children?.get(A);if(!P)return!1;E=P}return E._value!==L}c(m){const E=[{part:"",node:this.a}];let A=0;for(const P of m){const p=E[A].node.children?.get(P);if(!p)return;E.push({part:P,node:p}),A++}return E}d(m,E,A){let P=this.a;for(const w of m){if(P.children)if(P.children.has(w))P=P.children.get(w);else{const h=new N;P.children.set(w,h),P=h}else{const h=new N;P.children=new Map([[w,h]]),P=h}A?.(P)}const p=P._value===L?0:1;E(P);const y=P._value===L?0:1;this.b+=y-p}*values(){for(const{_value:m}of R(this.a))m!==L&&(yield m)}}e.$fP=O;function*R(b){const m=[b];for(;m.length>0;){const E=m.pop();if(yield E,E.children)for(const A of E.children.values())m.push(A)}}class N{constructor(){this._value=L}get value(){return this._value===L?void 0:this._value}set value(m){this._value=m===void 0?L:m}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var d=e();for(var L in d)(typeof exports=="object"?exports:le)[L]=d[L]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function d(L){if(e[L])return e[L].exports;var O=e[L]={i:L,l:!1,exports:{}};return le[L].call(O.exports,O,O.exports,d),O.l=!0,O.exports}return d.m=le,d.c=e,d.d=function(L,O,R){d.o(L,O)||Object.defineProperty(L,O,{enumerable:!0,get:R})},d.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},d.t=function(L,O){if(1&O&&(L=d(L)),8&O||4&O&&typeof L=="object"&&L&&L.__esModule)return L;var R=Object.create(null);if(d.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:L}),2&O&&typeof L!="string")for(var N in L)d.d(R,N,function(b){return L[b]}.bind(null,N));return R},d.n=function(L){var O=L&&L.__esModule?function(){return L.default}:function(){return L};return d.d(O,"a",O),O},d.o=function(L,O){return Object.prototype.hasOwnProperty.call(L,O)},d.p="",d(d.s=0)}([function(le,e,d){(function(L){var O;e=le.exports=ve,O=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],m=e.src=[],E=0,A=E++;m[A]="0|[1-9]\\d*";var P=E++;m[P]="[0-9]+";var p=E++;m[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=E++;m[y]="("+m[A]+")\\.("+m[A]+")\\.("+m[A]+")";var w=E++;m[w]="("+m[P]+")\\.("+m[P]+")\\.("+m[P]+")";var h=E++;m[h]="(?:"+m[A]+"|"+m[p]+")";var f=E++;m[f]="(?:"+m[P]+"|"+m[p]+")";var a=E++;m[a]="(?:-("+m[h]+"(?:\\."+m[h]+")*))";var n=E++;m[n]="(?:-?("+m[f]+"(?:\\."+m[f]+")*))";var i=E++;m[i]="[0-9A-Za-z-]+";var u=E++;m[u]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var o=E++,t="v?"+m[y]+m[a]+"?"+m[u]+"?";m[o]="^"+t+"$";var l="[v=\\s]*"+m[w]+m[n]+"?"+m[u]+"?",r=E++;m[r]="^"+l+"$";var c=E++;m[c]="((?:<|>)?=?)";var s=E++;m[s]=m[P]+"|x|X|\\*";var v=E++;m[v]=m[A]+"|x|X|\\*";var g=E++;m[g]="[v=\\s]*("+m[v]+")(?:\\.("+m[v]+")(?:\\.("+m[v]+")(?:"+m[a]+")?"+m[u]+"?)?)?";var D=E++;m[D]="[v=\\s]*("+m[s]+")(?:\\.("+m[s]+")(?:\\.("+m[s]+")(?:"+m[n]+")?"+m[u]+"?)?)?";var $=E++;m[$]="^"+m[c]+"\\s*"+m[g]+"$";var k=E++;m[k]="^"+m[c]+"\\s*"+m[D]+"$";var S=E++;m[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;m[C]="(?:~>?)";var I=E++;m[I]="(\\s*)"+m[C]+"\\s+",b[I]=new RegExp(m[I],"g");var F=E++;m[F]="^"+m[C]+m[g]+"$";var j=E++;m[j]="^"+m[C]+m[D]+"$";var z=E++;m[z]="(?:\\^)";var M=E++;m[M]="(\\s*)"+m[z]+"\\s+",b[M]=new RegExp(m[M],"g");var T=E++;m[T]="^"+m[z]+m[g]+"$";var U=E++;m[U]="^"+m[z]+m[D]+"$";var Z=E++;m[Z]="^"+m[c]+"\\s*("+l+")$|^$";var te=E++;m[te]="^"+m[c]+"\\s*("+t+")$|^$";var q=E++;m[q]="(\\s*)"+m[c]+"\\s*("+l+"|"+m[g]+")",b[q]=new RegExp(m[q],"g");var K=E++;m[K]="^\\s*("+m[g]+")\\s+-\\s+("+m[g]+")\\s*$";var Y=E++;m[Y]="^\\s*("+m[D]+")\\s+-\\s+("+m[D]+")\\s*$";var ie=E++;m[ie]="(<|>)?=?\\s*\\*";for(var $e=0;$e<35;$e++)O($e,m[$e]),b[$e]||(b[$e]=new RegExp(m[$e]));function ue(V,J){if(V instanceof ve)return V;if(typeof V!="string"||V.length>R||!(J?b[r]:b[o]).test(V))return null;try{return new ve(V,J)}catch{return null}}function ve(V,J){if(V instanceof ve){if(V.loose===J)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ve))return new ve(V,J);O("SemVer",V,J),this.loose=J;var X=V.trim().match(J?b[r]:b[o]);if(!X)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var we=+he;if(we>=0&&we<N)return we}return he}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}e.parse=ue,e.valid=function(V,J){var X=ue(V,J);return X?X.version:null},e.clean=function(V,J){var X=ue(V.trim().replace(/^[=v]+/,""),J);return X?X.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(V){return O("SemVer.compare",this.version,this.loose,V),V instanceof ve||(V=new ve(V,this.loose)),this.compareMain(V)||this.comparePre(V)},ve.prototype.compareMain=function(V){return V instanceof ve||(V=new ve(V,this.loose)),B(this.major,V.major)||B(this.minor,V.minor)||B(this.patch,V.patch)},ve.prototype.comparePre=function(V){if(V instanceof ve||(V=new ve(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var J=0;do{var X=this.prerelease[J],he=V.prerelease[J];if(O("prerelease compare",J,X,he),X===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(X===void 0)return-1;if(X!==he)return B(X,he)}while(++J)},ve.prototype.inc=function(V,J){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,J,X,he){typeof X=="string"&&(he=X,X=void 0);try{return new ve(V,X).inc(J,he).version}catch{return null}},e.diff=function(V,J){if(oe(V,J))return null;var X=ue(V),he=ue(J);if(X.prerelease.length||he.prerelease.length){for(var we in X)if((we==="major"||we==="minor"||we==="patch")&&X[we]!==he[we])return"pre"+we;return"prerelease"}for(var we in X)if((we==="major"||we==="minor"||we==="patch")&&X[we]!==he[we])return we},e.compareIdentifiers=B;var _=/^[0-9]+$/;function B(V,J){var X=_.test(V),he=_.test(J);return X&&he&&(V=+V,J=+J),X&&!he?-1:he&&!X?1:V<J?-1:V>J?1:0}function ee(V,J,X){return new ve(V,X).compare(new ve(J,X))}function pe(V,J,X){return ee(V,J,X)>0}function Ce(V,J,X){return ee(V,J,X)<0}function oe(V,J,X){return ee(V,J,X)===0}function se(V,J,X){return ee(V,J,X)!==0}function re(V,J,X){return ee(V,J,X)>=0}function G(V,J,X){return ee(V,J,X)<=0}function ne(V,J,X,he){var we;switch(J){case"===":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),we=V===X;break;case"!==":typeof V=="object"&&(V=V.version),typeof X=="object"&&(X=X.version),we=V!==X;break;case"":case"=":case"==":we=oe(V,X,he);break;case"!=":we=se(V,X,he);break;case">":we=pe(V,X,he);break;case">=":we=re(V,X,he);break;case"<":we=Ce(V,X,he);break;case"<=":we=G(V,X,he);break;default:throw new TypeError("Invalid operator: "+J)}return we}function me(V,J){if(V instanceof me){if(V.loose===J)return V;V=V.value}if(!(this instanceof me))return new me(V,J);O("comparator",V,J),this.loose=J,this.parse(V),this.semver===be?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(V,J){return B(J,V)},e.major=function(V,J){return new ve(V,J).major},e.minor=function(V,J){return new ve(V,J).minor},e.patch=function(V,J){return new ve(V,J).patch},e.compare=ee,e.compareLoose=function(V,J){return ee(V,J,!0)},e.rcompare=function(V,J,X){return ee(J,V,X)},e.sort=function(V,J){return V.sort(function(X,he){return e.compare(X,he,J)})},e.rsort=function(V,J){return V.sort(function(X,he){return e.rcompare(X,he,J)})},e.gt=pe,e.lt=Ce,e.eq=oe,e.neq=se,e.gte=re,e.lte=G,e.cmp=ne,e.Comparator=me;var be={};function Re(V,J){if(V instanceof Re)return V.loose===J?V:new Re(V.raw,J);if(V instanceof me)return new Re(V.value,J);if(!(this instanceof Re))return new Re(V,J);if(this.loose=J,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function fe(V){return!V||V.toLowerCase()==="x"||V==="*"}function De(V,J,X,he,we,Fe,qe,Je,rt,tt,nt,st,Pe){return((J=fe(X)?"":fe(he)?">="+X+".0.0":fe(we)?">="+X+"."+he+".0":">="+J)+" "+(Je=fe(rt)?"":fe(tt)?"<"+(+rt+1)+".0.0":fe(nt)?"<"+rt+"."+(+tt+1)+".0":st?"<="+rt+"."+tt+"."+nt+"-"+st:"<="+Je)).trim()}function Ae(V,J){for(var X=0;X<V.length;X++)if(!V[X].test(J))return!1;if(J.prerelease.length){for(X=0;X<V.length;X++)if(O(V[X].semver),V[X].semver!==be&&V[X].semver.prerelease.length>0){var he=V[X].semver;if(he.major===J.major&&he.minor===J.minor&&he.patch===J.patch)return!0}return!1}return!0}function ze(V,J,X){try{J=new Re(J,X)}catch{return!1}return J.test(V)}function W(V,J,X,he){var we,Fe,qe,Je,rt;switch(V=new ve(V,he),J=new Re(J,he),X){case">":we=pe,Fe=G,qe=Ce,Je=">",rt=">=";break;case"<":we=Ce,Fe=re,qe=pe,Je="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(V,J,he))return!1;for(var tt=0;tt<J.set.length;++tt){var nt=J.set[tt],st=null,Pe=null;if(nt.forEach(function(Be){Be.semver===be&&(Be=new me(">=0.0.0")),st=st||Be,Pe=Pe||Be,we(Be.semver,st.semver,he)?st=Be:qe(Be.semver,Pe.semver,he)&&(Pe=Be)}),st.operator===Je||st.operator===rt||(!Pe.operator||Pe.operator===Je)&&Fe(V,Pe.semver)||Pe.operator===rt&&qe(V,Pe.semver))return!1}return!0}me.prototype.parse=function(V){var J=this.loose?b[Z]:b[te],X=V.match(J);if(!X)throw new TypeError("Invalid comparator: "+V);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new ve(X[2],this.loose):this.semver=be},me.prototype.toString=function(){return this.value},me.prototype.test=function(V){return O("Comparator.test",V,this.loose),this.semver===be||(typeof V=="string"&&(V=new ve(V,this.loose)),ne(V,this.operator,this.semver,this.loose))},me.prototype.intersects=function(V,J){if(!(V instanceof me))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new Re(V.value,J),ze(this.value,X,J);if(V.operator==="")return X=new Re(this.value,J),ze(V.semver,X,J);var he=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Fe=this.semver.version===V.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Je=ne(this.semver,"<",V.semver,J)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),rt=ne(this.semver,">",V.semver,J)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return he||we||Fe&&qe||Je||rt},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(V){var J=this.loose;V=V.trim(),O("range",V,J);var X=J?b[Y]:b[K];V=V.replace(X,De),O("hyphen replace",V),V=V.replace(b[q],"$1$2$3"),O("comparator trim",V,b[q]),V=(V=(V=V.replace(b[I],"$1~")).replace(b[M],"$1^")).split(/\s+/).join(" ");var he=J?b[Z]:b[te],we=V.split(" ").map(function(Fe){return function(qe,Je){return O("comp",qe),qe=function(rt,tt){return rt.trim().split(/\s+/).map(function(nt){return function(st,Pe){O("caret",st,Pe);var Be=Pe?b[U]:b[T];return st.replace(Be,function(He,Le,Xe,ae,ce){var Ie;return O("caret",st,He,Le,Xe,ae,ce),fe(Le)?Ie="":fe(Xe)?Ie=">="+Le+".0.0 <"+(+Le+1)+".0.0":fe(ae)?Ie=Le==="0"?">="+Le+"."+Xe+".0 <"+Le+"."+(+Xe+1)+".0":">="+Le+"."+Xe+".0 <"+(+Le+1)+".0.0":ce?(O("replaceCaret pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Ie=Le==="0"?Xe==="0"?">="+Le+"."+Xe+"."+ae+ce+" <"+Le+"."+Xe+"."+(+ae+1):">="+Le+"."+Xe+"."+ae+ce+" <"+Le+"."+(+Xe+1)+".0":">="+Le+"."+Xe+"."+ae+ce+" <"+(+Le+1)+".0.0"):(O("no pr"),Ie=Le==="0"?Xe==="0"?">="+Le+"."+Xe+"."+ae+" <"+Le+"."+Xe+"."+(+ae+1):">="+Le+"."+Xe+"."+ae+" <"+Le+"."+(+Xe+1)+".0":">="+Le+"."+Xe+"."+ae+" <"+(+Le+1)+".0.0"),O("caret return",Ie),Ie})}(nt,tt)}).join(" ")}(qe,Je),O("caret",qe),qe=function(rt,tt){return rt.trim().split(/\s+/).map(function(nt){return function(st,Pe){var Be=Pe?b[j]:b[F];return st.replace(Be,function(He,Le,Xe,ae,ce){var Ie;return O("tilde",st,He,Le,Xe,ae,ce),fe(Le)?Ie="":fe(Xe)?Ie=">="+Le+".0.0 <"+(+Le+1)+".0.0":fe(ae)?Ie=">="+Le+"."+Xe+".0 <"+Le+"."+(+Xe+1)+".0":ce?(O("replaceTilde pr",ce),ce.charAt(0)!=="-"&&(ce="-"+ce),Ie=">="+Le+"."+Xe+"."+ae+ce+" <"+Le+"."+(+Xe+1)+".0"):Ie=">="+Le+"."+Xe+"."+ae+" <"+Le+"."+(+Xe+1)+".0",O("tilde return",Ie),Ie})}(nt,tt)}).join(" ")}(qe,Je),O("tildes",qe),qe=function(rt,tt){return O("replaceXRanges",rt,tt),rt.split(/\s+/).map(function(nt){return function(st,Pe){st=st.trim();var Be=Pe?b[k]:b[$];return st.replace(Be,function(He,Le,Xe,ae,ce,Ie){O("xRange",st,He,Le,Xe,ae,ce,Ie);var Ge=fe(Xe),Oe=Ge||fe(ae),ot=Oe||fe(ce);return Le==="="&&ot&&(Le=""),Ge?He=Le===">"||Le==="<"?"<0.0.0":"*":Le&&ot?(Oe&&(ae=0),ot&&(ce=0),Le===">"?(Le=">=",Oe?(Xe=+Xe+1,ae=0,ce=0):ot&&(ae=+ae+1,ce=0)):Le==="<="&&(Le="<",Oe?Xe=+Xe+1:ae=+ae+1),He=Le+Xe+"."+ae+"."+ce):Oe?He=">="+Xe+".0.0 <"+(+Xe+1)+".0.0":ot&&(He=">="+Xe+"."+ae+".0 <"+Xe+"."+(+ae+1)+".0"),O("xRange return",He),He})}(nt,tt)}).join(" ")}(qe,Je),O("xrange",qe),qe=function(rt,tt){return O("replaceStars",rt,tt),rt.trim().replace(b[ie],"")}(qe,Je),O("stars",qe),qe}(Fe,J)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Fe){return!!Fe.match(he)})),we=we.map(function(Fe){return new me(Fe,J)})},Re.prototype.intersects=function(V,J){if(!(V instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(he){return V.set.some(function(we){return we.every(function(Fe){return he.intersects(Fe,J)})})})})},e.toComparators=function(V,J){return new Re(V,J).set.map(function(X){return X.map(function(he){return he.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new ve(V,this.loose));for(var J=0;J<this.set.length;J++)if(Ae(this.set[J],V))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(V,J,X){var he=null,we=null;try{var Fe=new Re(J,X)}catch{return null}return V.forEach(function(qe){Fe.test(qe)&&(he&&we.compare(qe)!==-1||(we=new ve(he=qe,X)))}),he},e.minSatisfying=function(V,J,X){var he=null,we=null;try{var Fe=new Re(J,X)}catch{return null}return V.forEach(function(qe){Fe.test(qe)&&(he&&we.compare(qe)!==1||(we=new ve(he=qe,X)))}),he},e.validRange=function(V,J){try{return new Re(V,J).range||"*"}catch{return null}},e.ltr=function(V,J,X){return W(V,J,"<",X)},e.gtr=function(V,J,X){return W(V,J,">",X)},e.outside=W,e.prerelease=function(V,J){var X=ue(V,J);return X&&X.prerelease.length?X.prerelease:null},e.intersects=function(V,J,X){return V=new Re(V,X),J=new Re(J,X),V.intersects(J)},e.coerce=function(V){if(V instanceof ve)return V;if(typeof V!="string")return null;var J=V.match(b[S]);return J==null?null:ue((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,d(1))},function(le,e){var d,L,O=le.exports={};function R(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function b(f){if(d===setTimeout)return setTimeout(f,0);if((d===R||!d)&&setTimeout)return d=setTimeout,setTimeout(f,0);try{return d(f,0)}catch{try{return d.call(null,f,0)}catch{return d.call(this,f,0)}}}(function(){try{d=typeof setTimeout=="function"?setTimeout:R}catch{d=R}try{L=typeof clearTimeout=="function"?clearTimeout:N}catch{L=N}})();var m,E=[],A=!1,P=-1;function p(){A&&m&&(A=!1,m.length?E=m.concat(E):P=-1,E.length&&y())}function y(){if(!A){var f=b(p);A=!0;for(var a=E.length;a;){for(m=E,E=[];++P<a;)m&&m[P].run();P=-1,a=E.length}m=null,A=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===N||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(f)}}function w(f,a){this.fun=f,this.array=a}function h(){}O.nextTick=function(f){var a=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)a[n-1]=arguments[n];E.push(new w(f,a)),E.length!==1||A||b(y)},w.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=h,O.addListener=h,O.once=h,O.off=h,O.removeListener=h,O.removeAllListeners=h,O.emit=h,O.prependListener=h,O.prependOnceListener=h,O.listeners=function(f){return[]},O.binding=function(f){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(f){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(ke[40],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0;const d=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(R){return new L(R)}constructor(R){this.c=d&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ae=L}),define(ke[4],Se([1,0,13,75,3,76,40]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$ce=e.Event=void 0,e.$de=y;const b=!1,m=!1,E=!1;var A;(function(I){I.None=()=>O.$Vc.None;function F(Re){if(E){const{onDidAddListener:fe}=Re,De=h.create();let Ae=0;Re.onDidAddListener=()=>{++Ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),De.print()),fe?.()}}}function j(Re,fe){return ie(Re,()=>{},0,void 0,!0,void 0,fe)}I.defer=j;function z(Re){return(fe,De=null,Ae)=>{let ze=!1,W;return W=Re(V=>{if(!ze)return W?W.dispose():ze=!0,fe.call(De,V)},null,Ae),ze&&W.dispose(),W}}I.once=z;function M(Re,fe,De){return K((Ae,ze=null,W)=>Re(V=>Ae.call(ze,fe(V)),null,W),De)}I.map=M;function T(Re,fe,De){return K((Ae,ze=null,W)=>Re(V=>{fe(V),Ae.call(ze,V)},null,W),De)}I.forEach=T;function U(Re,fe,De){return K((Ae,ze=null,W)=>Re(V=>fe(V)&&Ae.call(ze,V),null,W),De)}I.filter=U;function Z(Re){return Re}I.signal=Z;function te(...Re){return(fe,De=null,Ae)=>{const ze=(0,O.$Sc)(...Re.map(W=>W(V=>fe.call(De,V))));return Y(ze,Ae)}}I.any=te;function q(Re,fe,De,Ae){let ze=De;return M(Re,W=>(ze=fe(ze,W),ze),Ae)}I.reduce=q;function K(Re,fe){let De;const Ae={onWillAddFirstListener(){De=Re(ze.fire,ze)},onDidRemoveLastListener(){De?.dispose()}};fe||F(Ae);const ze=new o(Ae);return fe?.add(ze),ze.event}function Y(Re,fe){return fe instanceof Array?fe.push(Re):fe&&fe.add(Re),Re}function ie(Re,fe,De=100,Ae=!1,ze=!1,W,V){let J,X,he,we=0,Fe;const qe={leakWarningThreshold:W,onWillAddFirstListener(){J=Re(rt=>{we++,X=fe(X,rt),Ae&&!he&&(Je.fire(X),X=void 0),Fe=()=>{const tt=X;X=void 0,he=void 0,(!Ae||we>1)&&Je.fire(tt),we=0},typeof De=="number"?(clearTimeout(he),he=setTimeout(Fe,De)):he===void 0&&(he=0,queueMicrotask(Fe))})},onWillRemoveListener(){ze&&we>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,J.dispose()}};V||F(qe);const Je=new o(qe);return V?.add(Je),Je.event}I.debounce=ie;function $e(Re,fe=0,De){return I.debounce(Re,(Ae,ze)=>Ae?(Ae.push(ze),Ae):[ze],fe,void 0,!0,void 0,De)}I.accumulate=$e;function ue(Re,fe=(Ae,ze)=>Ae===ze,De){let Ae=!0,ze;return U(Re,W=>{const V=Ae||!fe(W,ze);return Ae=!1,ze=W,V},De)}I.latch=ue;function ve(Re,fe,De){return[I.filter(Re,fe,De),I.filter(Re,Ae=>!fe(Ae),De)]}I.split=ve;function _(Re,fe=!1,De=[],Ae){let ze=De.slice(),W=Re(X=>{ze?ze.push(X):J.fire(X)});Ae&&Ae.add(W);const V=()=>{ze?.forEach(X=>J.fire(X)),ze=null},J=new o({onWillAddFirstListener(){W||(W=Re(X=>J.fire(X)),Ae&&Ae.add(W))},onDidAddFirstListener(){ze&&(fe?setTimeout(V):V())},onDidRemoveLastListener(){W&&W.dispose(),W=null}});return Ae&&Ae.add(J),J.event}I.buffer=_;function B(Re,fe){return(Ae,ze,W)=>{const V=fe(new pe);return Re(function(J){const X=V.evaluate(J);X!==ee&&Ae.call(ze,X)},void 0,W)}}I.chain=B;const ee=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(De=>(fe(De),De)),this}filter(fe){return this.f.push(De=>fe(De)?De:ee),this}reduce(fe,De){let Ae=De;return this.f.push(ze=>(Ae=fe(Ae,ze),Ae)),this}latch(fe=(De,Ae)=>De===Ae){let De=!0,Ae;return this.f.push(ze=>{const W=De||!fe(ze,Ae);return De=!1,Ae=ze,W?ze:ee}),this}evaluate(fe){for(const De of this.f)if(fe=De(fe),fe===ee)break;return fe}}function Ce(Re,fe,De=Ae=>Ae){const Ae=(...J)=>V.fire(De(...J)),ze=()=>Re.on(fe,Ae),W=()=>Re.removeListener(fe,Ae),V=new o({onWillAddFirstListener:ze,onDidRemoveLastListener:W});return V.event}I.fromNodeEventEmitter=Ce;function oe(Re,fe,De=Ae=>Ae){const Ae=(...J)=>V.fire(De(...J)),ze=()=>Re.addEventListener(fe,Ae),W=()=>Re.removeEventListener(fe,Ae),V=new o({onWillAddFirstListener:ze,onDidRemoveLastListener:W});return V.event}I.fromDOMEventEmitter=oe;function se(Re){return new Promise(fe=>z(Re)(fe))}I.toPromise=se;function re(Re){const fe=new o;return Re.then(De=>{fe.fire(De)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}I.fromPromise=re;function G(Re,fe,De){return fe(De),Re(Ae=>fe(Ae))}I.runAndSubscribe=G;class ne{constructor(fe,De){this._observable=fe,this.f=0,this.g=!1;const Ae={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};De||F(Ae),this.emitter=new o(Ae),De&&De.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,De){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function me(Re,fe){return new ne(Re,fe).emitter.event}I.fromObservable=me;function be(Re){return(fe,De,Ae)=>{let ze=0,W=!1;const V={beginUpdate(){ze++},endUpdate(){ze--,ze===0&&(Re.reportChanges(),W&&(W=!1,fe.call(De)))},handlePossibleChange(){},handleChange(){W=!0}};Re.addObserver(V),Re.reportChanges();const J={dispose(){Re.removeObserver(V)}};return Ae instanceof O.$Uc?Ae.add(J):Array.isArray(Ae)&&Ae.push(J),J}}I.fromObservableLight=be})(A||(e.Event=A={}));class P{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${P.f++}`,P.all.add(this)}start(F){this.g=new N.$ae,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$ce=P;let p=-1;function y(I){const F=p;return p=I,{dispose(){p=F}}}class w{constructor(F,j=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=j,this.g=0}dispose(){this.f?.clear()}check(F,j){const z=this.threshold;if(z<=0||j<z)return;this.f||(this.f=new Map);const M=this.f.get(F.value)||0;if(this.f.set(F.value,M+1),this.g-=1,this.g<=0){this.g=z*.5;let T,U=0;for(const[Z,te]of this.f)(!T||U<te)&&(T=Z,U=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${j} listeners already. MOST frequent listener (${U}):`),console.warn(T)}return()=>{const T=this.f.get(F.value)||0;this.f.set(F.value,T-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class a{constructor(F){this.value=F,this.id=f++}}const n=2,i=(I,F)=>{if(I instanceof a)F(I);else for(let j=0;j<I.length;j++){const z=I[j];z&&F(z)}},u=b?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class o{constructor(F){this.w=0,this.f=F,this.g=p>0||this.f?.leakWarningThreshold?new w(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const F=this.t;queueMicrotask(()=>{i(F,j=>j.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,j,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),O.$Vc.None;if(this.m)return O.$Vc.None;j&&(F=F.bind(j));const M=new a(F);let T,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(M.stack=h.create(),T=this.g.check(M.stack,this.w+1)),m&&(M.stack=U??h.create()),this.t?this.t instanceof a?(this.u??=new l,this.t=[this.t,M]):this.t.push(M):(this.f?.onWillAddFirstListener?.(this),this.t=M,this.f?.onDidAddFirstListener?.(this)),this.w++;const Z=(0,O.$Tc)(()=>{u?.unregister(Z),T?.(),this.x(M)});if(z instanceof O.$Uc?z.add(Z):Array.isArray(z)&&z.push(Z),u){const te=new Error().stack.split(`
`).slice(2).join(`
`).trim();u.register(Z,te,Z)}return Z},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const j=this.t,z=j.indexOf(F);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,j[z]=void 0;const M=this.u.current===this;if(this.w*n<=j.length){let T=0;for(let U=0;U<j.length;U++)j[U]?j[T++]=j[U]:M&&(this.u.end--,T<this.u.i&&this.u.i--);j.length=T}}y(F,j){if(!F)return;const z=this.f?.onListenerError||d.$1;if(!z){F.value(j);return}try{F.value(j)}catch(M){z(M)}}z(F){const j=F.current.t;for(;F.i<F.end;)this.y(j[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,F);else{const j=this.u;j.enqueue(this,F,this.t.length),this.z(j)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ee=o;const t=()=>new l;e.$fe=t;class l{constructor(){this.i=-1,this.end=0}enqueue(F,j,z){this.i=0,this.end=z,this.current=F,this.value=j}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends o{async fireAsync(F,j,z){if(this.t)for(this.h||(this.h=new R.$6c),i(this.t,M=>this.h.push([M.value,F]));this.h.size>0&&!j.isCancellationRequested;){const[M,T]=this.h.shift(),U=[],Z={...T,token:j,waitUntil:te=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");z&&(te=z(te,M)),U.push(te)}};try{M(Z)}catch(te){(0,d.$1)(te);continue}Object.freeze(U),await Promise.allSettled(U).then(te=>{for(const q of te)q.status==="rejected"&&(0,d.$1)(q.reason)})}}}e.$ge=r;class c extends o{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new R.$6c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$he=c;class s extends c{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$ie=s;class v extends o{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(j=>super.fire(j)),this.h=[]}))}}e.$je=v;class g{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const j={event:F,listener:null};this.h.push(j),this.g&&this.m(j);const z=()=>{this.g&&this.o(j);const M=this.h.indexOf(j);this.h.splice(M,1)};return(0,O.$Tc)((0,L.$db)(z))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(j=>this.f.fire(j))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$ke=g;class D{constructor(F,j,z,M){this.f=new O.$Uc;const T=this.f.add(new g),U=this.f.add(new O.$5c);function Z(te){U.set(te,T.add(M(te)))}for(const te of F)Z(te);this.f.add(j(te=>{Z(te)})),this.f.add(z(te=>{U.deleteAndDispose(te)})),this.event=T.event}dispose(){this.f.dispose()}}e.$le=D;class ${constructor(){this.f=[]}wrapEvent(F){return(j,z,M)=>F(T=>{const U=this.f[this.f.length-1];U?U.push(()=>j.call(z,T)):j.call(z,T)},void 0,M)}bufferEvents(F){const j=[];this.f.push(j);const z=F();return this.f.pop(),j.forEach(M=>M()),z}}e.$me=$;class k{constructor(){this.f=!1,this.g=A.None,this.h=O.$Vc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ne=k;class S{static const(F){return new C(F)}constructor(F){this.g=F,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$oe=S;class C{constructor(F){this.value=F,this.onDidChange=A.None}}}),define(ke[22],Se([1,0,4]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.CancellationToken=void 0,e.$qe=b;const L=Object.freeze(function(m,E){const A=setTimeout(m.bind(E),0);return{dispose(){clearTimeout(A)}}});var O;(function(m){function E(A){return A===m.None||A===m.Cancelled||A instanceof R?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}m.isCancellationToken=E,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:d.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(O||(e.CancellationToken=O={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new d.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=O.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=O.None}}e.$pe=N;function b(m){const E=new N;return m.add({dispose(){E.cancel()}}),E.token}}),define(ke[173],Se([1,0,22]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=e.$2e=void 0,e.$3e=O;class L{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new d.$pe,E=this.b(m.token);return this.a={promise:E,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$2e=L;function O(b){return b}class R{constructor(m,E){this.a=void 0,this.b=void 0,typeof m=="function"?(this.c=m,this.d=O):(this.c=E,this.d=m.getCacheKey)}get(m){const E=this.d(m);return this.b!==E&&(this.b=E,this.a=this.c(m)),this.a}}e.$4e=R;class N{get cachedValues(){return this.a}constructor(m,E){this.a=new Map,this.b=new Map,typeof m=="function"?(this.c=m,this.d=O):(this.c=E,this.d=m.getCacheKey)}get(m){const E=this.d(m);if(this.b.has(E))return this.b.get(E);const A=this.c(m);return this.a.set(m,A),this.b.set(E,A),A}}e.$5e=N}),define(ke[98],Se([1,0,13,3]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=O,e.$se=R,e.$te=N,e.$ue=b,e.$ve=E,e.$we=A,e.$xe=P,e.$ye=p,e.$ze=y,e.$Ae=w,e.$Be=h,e.$Ce=f,e.$De=a,e.$Ee=n,e.$Fe=i;function O(u){const o=u;return o?typeof o.read=="function":!1}function R(u){const o=u;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function N(u){const o=u;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function b(u,o){return new m(u,o)}class m{constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,d.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let l;switch(o){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(t);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(u,o){const t=[];let l;for(;(l=u.read())!==null;)t.push(l);return o(t)}function A(u,o,t){const l=[];let r;for(;(r=u.read())!==null&&l.length<t;)l.push(r);return r===null&&l.length>0?o(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const c=r;return r=void 0,c}return u.read()}}}function P(u,o){return new Promise((t,l)=>{const r=[];p(u,{onData:c=>{o&&r.push(c)},onError:c=>{o?l(c):t(void 0)},onEnd:()=>{t(o?o(r):void 0)}})})}function p(u,o,t){u.on("error",l=>{t?.isCancellationRequested||o.onError(l)}),u.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),u.on("data",l=>{t?.isCancellationRequested||o.onData(l)})}function y(u,o){return new Promise((t,l)=>{const r=new L.$Uc,c=[],s=D=>{if(c.push(D),c.length>o)return r.dispose(),u.pause(),t({stream:u,buffer:c,ended:!1})},v=D=>(r.dispose(),l(D)),g=()=>(r.dispose(),t({stream:u,buffer:c,ended:!0}));r.add((0,L.$Tc)(()=>u.removeListener("error",v))),u.on("error",v),r.add((0,L.$Tc)(()=>u.removeListener("end",g))),u.on("end",g),r.add((0,L.$Tc)(()=>u.removeListener("data",s))),u.on("data",s)})}function w(u,o){const t=b(o);return t.end(u),t}function h(){const u=b(()=>{throw new Error("not supported")});return u.end(),u}function f(u){let o=!1;return{read:()=>o?null:(o=!0,u)}}function a(u,o,t){const l=b(t);return p(u,{onData:r=>l.write(o.data(r)),onError:r=>l.error(o.error?o.error(r):r),onEnd:()=>l.end()}),l}function n(u,o,t){let l=!1;return{read:()=>{const r=o.read();return l?r:(l=!0,r!==null?t([u,r]):u)}}}function i(u,o,t){let l=!1;const r=b(t);return p(o,{onData:c=>l?r.write(c):(l=!0,r.write(t([u,c]))),onError:c=>r.error(c),onEnd:()=>{l||(l=!0,r.write(u)),r.end()}}),r}}),define(ke[21],Se([1,0,46,98]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=void 0,e.$He=E,e.$Ie=A,e.$Je=P,e.$Ke=p,e.$Le=y,e.$Me=w,e.$Ne=h,e.$Oe=f,e.$Pe=a,e.$Qe=n,e.$Re=i,e.$Se=u,e.$Te=o,e.$Ue=t,e.$Ve=l,e.$We=r,e.$Xe=c,e.$Ye=s,e.$Ze=v,e.$1e=$;const O=typeof Buffer<"u",R=new d.$V(()=>new Uint8Array(256));let N,b;class m{static alloc(S){return O?new m(Buffer.allocUnsafe(S)):new m(new Uint8Array(S))}static wrap(S){return O&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new m(S)}static fromString(S,C){return!(C?.dontUseNodeBuffer||!1)&&O?new m(Buffer.from(S)):(N||(N=new TextEncoder),new m(N.encode(S)))}static fromByteArray(S){const C=m.alloc(S.length);for(let I=0,F=S.length;I<F;I++)C.buffer[I]=S[I];return C}static concat(S,C){if(typeof C>"u"){C=0;for(let j=0,z=S.length;j<z;j++)C+=S[j].byteLength}const I=m.alloc(C);let F=0;for(let j=0,z=S.length;j<z;j++){const M=S[j];I.set(M,F),F+=M.byteLength}return I}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=m.alloc(this.byteLength);return S.set(this),S}toString(){return O?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(S,C){return new m(this.buffer.subarray(S,C))}set(S,C){if(S instanceof m)this.buffer.set(S.buffer,C);else if(S instanceof Uint8Array)this.buffer.set(S,C);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),C);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return p(this.buffer,S)}writeUInt32BE(S,C){y(this.buffer,S,C)}readUInt32LE(S){return w(this.buffer,S)}writeUInt32LE(S,C){h(this.buffer,S,C)}readUInt8(S){return f(this.buffer,S)}writeUInt8(S,C){a(this.buffer,S,C)}indexOf(S,C=0){return E(this.buffer,S instanceof m?S.buffer:S,C)}}e.$Ge=m;function E(k,S,C=0){const I=S.byteLength,F=k.byteLength;if(I===0)return 0;if(I===1)return k.indexOf(S[0]);if(I>F-C)return-1;const j=R.value;j.fill(S.length);for(let U=0;U<S.length;U++)j[S[U]]=S.length-U-1;let z=C+S.length-1,M=z,T=-1;for(;z<F;)if(k[z]===S[M]){if(M===0){T=z;break}z--,M--}else z+=Math.max(S.length-M,j[k[z]]),M=S.length-1;return T}function A(k,S){return k[S+0]<<0>>>0|k[S+1]<<8>>>0}function P(k,S,C){k[C+0]=S&255,S=S>>>8,k[C+1]=S&255}function p(k,S){return k[S]*2**24+k[S+1]*2**16+k[S+2]*2**8+k[S+3]}function y(k,S,C){k[C+3]=S,S=S>>>8,k[C+2]=S,S=S>>>8,k[C+1]=S,S=S>>>8,k[C]=S}function w(k,S){return k[S+0]<<0>>>0|k[S+1]<<8>>>0|k[S+2]<<16>>>0|k[S+3]<<24>>>0}function h(k,S,C){k[C+0]=S&255,S=S>>>8,k[C+1]=S&255,S=S>>>8,k[C+2]=S&255,S=S>>>8,k[C+3]=S&255}function f(k,S){return k[S]}function a(k,S,C){k[C]=S}function n(k){return L.$ve(k,S=>m.concat(S))}function i(k){return L.$Ce(k)}function u(k){return L.$xe(k,S=>m.concat(S))}async function o(k){return k.ended?m.concat(k.buffer):m.concat([...k.buffer,await u(k.stream)])}function t(k){return L.$Ae(k,S=>m.concat(S))}function l(k){return L.$De(k,{data:S=>typeof S=="string"?m.fromString(S):m.wrap(S)},S=>m.concat(S))}function r(k){return L.$ue(S=>m.concat(S),k)}function c(k,S){return L.$Ee(k,S,C=>m.concat(C))}function s(k,S){return L.$Fe(k,S,C=>m.concat(C))}function v(k){let S=0,C=0,I=0;const F=new Uint8Array(Math.floor(k.length/4*3)),j=M=>{switch(C){case 3:F[I++]=S|M,C=0;break;case 2:F[I++]=S|M>>>2,S=M<<6,C=3;break;case 1:F[I++]=S|M>>>4,S=M<<4,C=2;break;default:S=M<<2,C=1}};for(let M=0;M<k.length;M++){const T=k.charCodeAt(M);if(T>=65&&T<=90)j(T-65);else if(T>=97&&T<=122)j(T-97+26);else if(T>=48&&T<=57)j(T-48+52);else if(T===43||T===45)j(62);else if(T===47||T===95)j(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${k[M]}`)}}const z=I;for(;C>0;)j(0);return m.wrap(F).slice(0,z)}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:k},S=!0,C=!1){const I=C?D:g;let F="";const j=k.byteLength%3;let z=0;for(;z<k.byteLength-j;z+=3){const M=k[z+0],T=k[z+1],U=k[z+2];F+=I[M>>>2],F+=I[(M<<4|T>>>4)&63],F+=I[(T<<2|U>>>6)&63],F+=I[U&63]}if(j===1){const M=k[z+0];F+=I[M>>>2],F+=I[M<<4&63],S&&(F+="==")}else if(j===2){const M=k[z+0],T=k[z+1];F+=I[M>>>2],F+=I[(M<<4|T>>>4)&63],F+=I[T<<2&63],S&&(F+="=")}return F}}),define(ke[14],Se([1,0,173,46]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Of=e.$Hf=e.$Gf=void 0,e.$8e=O,e.$9e=N,e.$0e=m,e.$$e=E,e.$_e=A,e.$af=P,e.$bf=p,e.$cf=y,e.$df=w,e.$ef=h,e.$ff=f,e.$gf=a,e.$hf=n,e.$if=i,e.$jf=u,e.$kf=o,e.$lf=t,e.$mf=l,e.$nf=r,e.$of=c,e.$pf=s,e.$qf=v,e.$rf=g,e.$sf=D,e.$tf=$,e.$uf=k,e.$vf=S,e.$wf=C,e.$xf=I,e.$yf=F,e.$zf=j,e.$Af=z,e.$Bf=M,e.$Cf=T,e.$Df=U,e.$Ef=Z,e.$Ff=te,e.$If=ie,e.$Jf=$e,e.$Kf=ue,e.$Lf=ve,e.$Mf=ee,e.$Nf=Ce,e.$Pf=oe,e.$Qf=se,e.$Rf=re,e.$Sf=G,e.$Tf=me,e.$Uf=be,e.$Wf=Re,e.$Xf=fe,e.$Yf=De,e.$Zf=Ae,e.$1f=ze,e.$2f=W,e.$3f=V,e.$4f=J,e.$5f=qe;function O(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const R=/{(\d+)}/g;function N(Pe,...Be){return Be.length===0?Pe:Pe.replace(R,function(He,Le){const Xe=parseInt(Le,10);return isNaN(Xe)||Xe<0||Xe>=Be.length?He:Be[Xe]})}const b=/{([^}]+)}/g;function m(Pe,Be){return Object.keys(Be).length===0?Pe:Pe.replace(b,(He,Le)=>Be[Le]??He)}function E(Pe){return Pe.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function A(Pe){return Pe.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function P(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Pe,Be){let He=0;const Le=Be.charCodeAt(0);for(let Xe=Pe.length-1;Xe>=0;Xe--)Pe.charCodeAt(Xe)===Le&&He++;return He}function y(Pe,Be,He="\u2026"){return Pe.length<=Be?Pe:`${Pe.substr(0,Be)}${He}`}function w(Pe,Be,He="\u2026"){if(Pe.length<=Be)return Pe;const Le=Math.ceil(Be/2)-He.length/2,Xe=Math.floor(Be/2)-He.length/2;return`${Pe.substr(0,Le)}${He}${Pe.substr(Pe.length-Xe)}`}function h(Pe,Be=" "){const He=f(Pe,Be);return a(He,Be)}function f(Pe,Be){if(!Pe||!Be)return Pe;const He=Be.length;if(He===0||Pe.length===0)return Pe;let Le=0;for(;Pe.indexOf(Be,Le)===Le;)Le=Le+He;return Pe.substring(Le)}function a(Pe,Be){if(!Pe||!Be)return Pe;const He=Be.length,Le=Pe.length;if(He===0||Le===0)return Pe;let Xe=Le,ae=-1;for(;ae=Pe.lastIndexOf(Be,Xe-1),!(ae===-1||ae+He!==Xe);){if(ae===0)return"";Xe=ae}return Pe.substring(0,Xe)}function n(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Pe){return Pe.replace(/\*/g,"")}function u(Pe,Be,He={}){if(!Pe)throw new Error("Cannot create regex from empty string");Be||(Pe=P(Pe)),He.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Le="";return He.global&&(Le+="g"),He.matchCase||(Le+="i"),He.multiline&&(Le+="m"),He.unicode&&(Le+="u"),new RegExp(Pe,Le)}function o(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function t(Pe){return Pe.split(/\r\n|\r|\n/)}function l(Pe){const Be=[],He=Pe.split(/(\r\n|\r|\n)/);for(let Le=0;Le<Math.ceil(He.length/2);Le++)Be.push(He[2*Le]+(He[2*Le+1]??""));return Be}function r(Pe){for(let Be=0,He=Pe.length;Be<He;Be++){const Le=Pe.charCodeAt(Be);if(Le!==32&&Le!==9)return Be}return-1}function c(Pe,Be=0,He=Pe.length){for(let Le=Be;Le<He;Le++){const Xe=Pe.charCodeAt(Le);if(Xe!==32&&Xe!==9)return Pe.substring(Be,Le)}return Pe.substring(Be,He)}function s(Pe,Be=Pe.length-1){for(let He=Be;He>=0;He--){const Le=Pe.charCodeAt(He);if(Le!==32&&Le!==9)return He}return-1}function v(Pe,Be,He){const Le=[];let Xe=0;for(const ae of Pe.matchAll(Be)){if(Le.push(Pe.slice(Xe,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");Xe=ae.index+ae[0].length,Le.push(He(ae[0],...ae.slice(1),ae.index,Pe,ae.groups))}return Le.push(Pe.slice(Xe)),Promise.all(Le).then(ae=>ae.join(""))}function g(Pe,Be){return Pe<Be?-1:Pe>Be?1:0}function D(Pe,Be,He=0,Le=Pe.length,Xe=0,ae=Be.length){for(;He<Le&&Xe<ae;He++,Xe++){const Ge=Pe.charCodeAt(He),Oe=Be.charCodeAt(Xe);if(Ge<Oe)return-1;if(Ge>Oe)return 1}const ce=Le-He,Ie=ae-Xe;return ce<Ie?-1:ce>Ie?1:0}function $(Pe,Be){return k(Pe,Be,0,Pe.length,0,Be.length)}function k(Pe,Be,He=0,Le=Pe.length,Xe=0,ae=Be.length){for(;He<Le&&Xe<ae;He++,Xe++){let Ge=Pe.charCodeAt(He),Oe=Be.charCodeAt(Xe);if(Ge===Oe)continue;if(Ge>=128||Oe>=128)return D(Pe.toLowerCase(),Be.toLowerCase(),He,Le,Xe,ae);C(Ge)&&(Ge-=32),C(Oe)&&(Oe-=32);const ot=Ge-Oe;if(ot!==0)return ot}const ce=Le-He,Ie=ae-Xe;return ce<Ie?-1:ce>Ie?1:0}function S(Pe){return Pe>=48&&Pe<=57}function C(Pe){return Pe>=97&&Pe<=122}function I(Pe){return Pe>=65&&Pe<=90}function F(Pe,Be){return Pe.length===Be.length&&k(Pe,Be)===0}function j(Pe,Be){const He=Be.length;return Be.length>Pe.length?!1:k(Pe,Be,0,He)===0}function z(Pe,Be){const He=Math.min(Pe.length,Be.length);let Le;for(Le=0;Le<He;Le++)if(Pe.charCodeAt(Le)!==Be.charCodeAt(Le))return Le;return He}function M(Pe,Be){const He=Math.min(Pe.length,Be.length);let Le;const Xe=Pe.length-1,ae=Be.length-1;for(Le=0;Le<He;Le++)if(Pe.charCodeAt(Xe-Le)!==Be.charCodeAt(ae-Le))return Le;return He}function T(Pe){return 55296<=Pe&&Pe<=56319}function U(Pe){return 56320<=Pe&&Pe<=57343}function Z(Pe,Be){return(Pe-55296<<10)+(Be-56320)+65536}function te(Pe,Be,He){const Le=Pe.charCodeAt(He);if(T(Le)&&He+1<Be){const Xe=Pe.charCodeAt(He+1);if(U(Xe))return Z(Le,Xe)}return Le}function q(Pe,Be){const He=Pe.charCodeAt(Be-1);if(U(He)&&Be>1){const Le=Pe.charCodeAt(Be-2);if(T(Le))return Z(Le,He)}return He}class K{get offset(){return this.e}constructor(Be,He=0){this.c=Be,this.d=Be.length,this.e=He}setOffset(Be){this.e=Be}prevCodePoint(){const Be=q(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=te(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$Gf=K;class Y{get offset(){return this.c.offset}constructor(Be,He=0){this.c=new K(Be,He)}nextGraphemeLength(){const Be=we.getInstance(),He=this.c,Le=He.offset;let Xe=Be.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const ae=He.offset,ce=Be.getGraphemeBreakType(He.nextCodePoint());if(X(Xe,ce)){He.setOffset(ae);break}Xe=ce}return He.offset-Le}prevGraphemeLength(){const Be=we.getInstance(),He=this.c,Le=He.offset;let Xe=Be.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const ae=He.offset,ce=Be.getGraphemeBreakType(He.prevCodePoint());if(X(ce,Xe)){He.setOffset(ae);break}Xe=ce}return Le-He.offset}eol(){return this.c.eol()}}e.$Hf=Y;function ie(Pe,Be){return new Y(Pe,Be).nextGraphemeLength()}function $e(Pe,Be){return new Y(Pe,Be).prevGraphemeLength()}function ue(Pe,Be){Be>0&&U(Pe.charCodeAt(Be))&&Be--;const He=Be+ie(Pe,Be);return[He-$e(Pe,He),He]}function ve(Pe){const Be=new Y(Pe);let He=0;for(;!Be.eol();)He++,Be.nextGraphemeLength();return He}let _;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ee(Pe){return _||(_=B()),_.test(Pe)}const pe=/^[\t\n\r\x20-\x7E]*$/;function Ce(Pe){return pe.test(Pe)}e.$Of=/[\u2028\u2029]/;function oe(Pe){return e.$Of.test(Pe)}function se(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function re(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function G(Pe,Be,He=""){const Le=Pe.trimStart();if(Le.length<Be)return Le;const Xe=/\b/g;let ae=0;for(;Xe.test(Le)&&!(Le.length-Xe.lastIndex<Be);)ae=Xe.lastIndex,Xe.lastIndex+=1;return ae===0?Le:He+Le.substring(ae).trimStart()}const ne=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*me(Pe){let Be=0;for(const He of Pe.matchAll(ne))Be!==He.index&&(yield{isCode:!1,str:Pe.substring(Be,He.index)}),yield{isCode:!0,str:He[0]},Be=He.index+He[0].length;Be!==Pe.length&&(yield{isCode:!1,str:Pe.substring(Be)})}function be(Pe){return Pe&&(Pe=Pe.replace(ne,"")),Pe}e.$Vf="\uFEFF";function Re(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}function fe(Pe){return Re(Pe)?Pe.substr(1):Pe}function De(Pe,Be){if(!Pe||!Be||Pe.length<Be.length)return!1;const He=Be.length,Le=Pe.toLowerCase();let Xe=0,ae=-1;for(;Xe<He;){const ce=Le.indexOf(Be[Xe],ae+1);if(ce<0)return!1;ae=ce,Xe++}return!0}function Ae(Pe,Be=!1){return Pe?(Be&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function ze(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function W(Pe,Be=1){if(Be===0)return"";let He=-1;do He=Pe.indexOf(`
`,He+1),Be--;while(Be>0&&He>=0);return He===-1?Pe:(Pe[He-1]==="\r"&&He--,Pe.substr(0,He))}function V(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}function J(Pe){return we.getInstance().getGraphemeBreakType(Pe)}function X(Pe,Be){return Pe===0?Be!==5&&Be!==7:Pe===2&&Be===3?!1:Pe===4||Pe===2||Pe===3||Be===4||Be===2||Be===3?!0:!(Pe===8&&(Be===8||Be===9||Be===11||Be===12)||(Pe===11||Pe===9)&&(Be===9||Be===10)||(Pe===12||Pe===10)&&Be===10||Be===5||Be===13||Be===7||Pe===1||Pe===13&&Be===14||Pe===6&&Be===6)}var he;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Fe()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const He=this.d,Le=He.length/3;let Xe=1;for(;Xe<=Le;)if(Be<He[3*Xe])Xe=2*Xe;else if(Be>He[3*Xe+1])Xe=2*Xe+1;else return He[3*Xe+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(Pe,Be){if(Pe===0)return 0;const He=Je(Pe,Be);if(He!==void 0)return He;const Le=new K(Be,Pe);return Le.prevCodePoint(),Le.offset}function Je(Pe,Be){const He=new K(Be,Pe);let Le=He.prevCodePoint();for(;rt(Le)||Le===65039||Le===8419;){if(He.offset===0)return;Le=He.prevCodePoint()}if(!re(Le))return;let Xe=He.offset;return Xe>0&&He.prevCodePoint()===8205&&(Xe=He.offset),Xe}function rt(Pe){return 127995<=Pe&&Pe<=127999}var tt;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.$6f="\xA0";class nt{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new d.$4e({getCacheKey:JSON.stringify},Be=>{function He(ot){const ut=new Map;for(let vt=0;vt<ot.length;vt+=2)ut.set(ot[vt],ot[vt+1]);return ut}function Le(ot,ut){const vt=new Map(ot);for(const[Rt,Ut]of ut)vt.set(Rt,Ut);return vt}function Xe(ot,ut){if(!ot)return ut;const vt=new Map;for(const[Rt,Ut]of ot)ut.has(Rt)&&vt.set(Rt,Ut);return vt}const ae=this.c.value;let ce=Be.filter(ot=>!ot.startsWith("_")&&ot in ae);ce.length===0&&(ce=["_default"]);let Ie;for(const ot of ce){const ut=He(ae[ot]);Ie=Xe(Ie,ut)}const Ge=He(ae._common),Oe=Le(Ge,Ie);return new nt(Oe)})}static getInstance(Be){return nt.d.get(Array.from(Be))}static{this.e=new L.$V(()=>Object.keys(nt.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return nt.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=nt;class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(Be){return st.e().has(Be)}static get codePoints(){return st.e()}}e.$8f=st}),define(ke[127],Se([1,0,27,168,14]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=R,e.$zk=b,e.$Ak=m,e.$Bk=P,e.$Ck=v,e.$Dk=g,e.$Ek=I,e.$Fk=F,e.$Gk=j,e.$Hk=z,e.$Ik=ee,e.$Kk=se,e.$Lk=ne,e.$Mk=me;function R(...fe){return function(De,Ae){for(let ze=0,W=fe.length;ze<W;ze++){const V=fe[ze](De,Ae);if(V)return V}return null}}e.$xk=N.bind(void 0,!1),e.$yk=N.bind(void 0,!0);function N(fe,De,Ae){if(!Ae||Ae.length<De.length)return null;let ze;return fe?ze=O.$zf(Ae,De):ze=Ae.indexOf(De)===0,ze?De.length>0?[{start:0,end:De.length}]:[]:null}function b(fe,De){const Ae=De.toLowerCase().indexOf(fe.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+fe.length}]}function m(fe,De){return E(fe.toLowerCase(),De.toLowerCase(),0,0)}function E(fe,De,Ae,ze){if(Ae===fe.length)return[];if(ze===De.length)return null;if(fe[Ae]===De[ze]){let W=null;return(W=E(fe,De,Ae+1,ze+1))?u({start:ze,end:ze+1},W):null}return E(fe,De,Ae,ze+1)}function A(fe){return 97<=fe&&fe<=122}function P(fe){return 65<=fe&&fe<=90}function p(fe){return 48<=fe&&fe<=57}function y(fe){return fe===32||fe===9||fe===10||fe===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>w.add(fe.charCodeAt(0)));function h(fe){return y(fe)||w.has(fe)}function f(fe,De){return fe===De||h(fe)&&h(De)}const a=new Map;function n(fe){if(a.has(fe))return a.get(fe);let De;const Ae=(0,L.$vk)(fe);return Ae&&(De=Ae),a.set(fe,De),De}function i(fe){return A(fe)||P(fe)||p(fe)}function u(fe,De){return De.length===0?De=[fe]:fe.end===De[0].start?De[0].start=fe.start:De.unshift(fe),De}function o(fe,De){for(let Ae=De;Ae<fe.length;Ae++){const ze=fe.charCodeAt(Ae);if(P(ze)||p(ze)||Ae>0&&!i(fe.charCodeAt(Ae-1)))return Ae}return fe.length}function t(fe,De,Ae,ze){if(Ae===fe.length)return[];if(ze===De.length)return null;if(fe[Ae]!==De[ze].toLowerCase())return null;{let W=null,V=ze+1;for(W=t(fe,De,Ae+1,ze+1);!W&&(V=o(De,V))<De.length;)W=t(fe,De,Ae+1,V),V++;return W===null?null:u({start:ze,end:ze+1},W)}}function l(fe){let De=0,Ae=0,ze=0,W=0,V=0;for(let Fe=0;Fe<fe.length;Fe++)V=fe.charCodeAt(Fe),P(V)&&De++,A(V)&&Ae++,i(V)&&ze++,p(V)&&W++;const J=De/fe.length,X=Ae/fe.length,he=ze/fe.length,we=W/fe.length;return{upperPercent:J,lowerPercent:X,alphaPercent:he,numericPercent:we}}function r(fe){const{upperPercent:De,lowerPercent:Ae}=fe;return Ae===0&&De>.6}function c(fe){const{upperPercent:De,lowerPercent:Ae,alphaPercent:ze,numericPercent:W}=fe;return Ae>.2&&De<.8&&ze>.6&&W<.2}function s(fe){let De=0,Ae=0,ze=0,W=0;for(let V=0;V<fe.length;V++)ze=fe.charCodeAt(V),P(ze)&&De++,A(ze)&&Ae++,y(ze)&&W++;return(De===0||Ae===0)&&W===0?fe.length<=30:De<=5}function v(fe,De){if(!De||(De=De.trim(),De.length===0)||!s(fe))return null;De.length>60&&(De=De.substring(0,60));const Ae=l(De);if(!c(Ae)){if(!r(Ae))return null;De=De.toLowerCase()}let ze=null,W=0;for(fe=fe.toLowerCase();W<De.length&&(ze=t(fe,De,0,W))===null;)W=o(De,W+1);return ze}function g(fe,De,Ae=!1){if(!De||De.length===0)return null;let ze=null,W=0;for(fe=fe.toLowerCase(),De=De.toLowerCase();W<De.length&&(ze=D(fe,De,0,W,Ae),ze===null);)W=$(De,W+1);return ze}function D(fe,De,Ae,ze,W){let V=0;if(Ae===fe.length)return[];if(ze===De.length)return null;if(!f(fe.charCodeAt(Ae),De.charCodeAt(ze))){const he=n(fe.charCodeAt(Ae));if(!he)return null;for(let we=0;we<he.length;we++)if(!f(he[we],De.charCodeAt(ze+we)))return null;V+=he.length-1}let J=null,X=ze+V+1;if(J=D(fe,De,Ae+1,X,W),!W)for(;!J&&(X=$(De,X))<De.length;)J=D(fe,De,Ae+1,X,W),X++;if(!J)return null;if(fe.charCodeAt(Ae)!==De.charCodeAt(ze)){const he=n(fe.charCodeAt(Ae));if(!he)return J;for(let we=0;we<he.length;we++)if(he[we]!==De.charCodeAt(ze+we))return J}return u({start:ze,end:ze+V+1},J)}function $(fe,De){for(let Ae=De;Ae<fe.length;Ae++)if(h(fe.charCodeAt(Ae))||Ae>0&&h(fe.charCodeAt(Ae-1)))return Ae;return fe.length}const k=R(e.$yk,v,b),S=R(e.$yk,v,m),C=new d.$Ec(1e4);function I(fe,De,Ae=!1){if(typeof fe!="string"||typeof De!="string")return null;let ze=C.get(fe);ze||(ze=new RegExp(O.$hf(fe),"i"),C.set(fe,ze));const W=ze.exec(De);return W?[{start:W.index,end:W.index+W[0].length}]:Ae?S(fe,De):k(fe,De)}function F(fe,De){const Ae=se(fe,fe.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?z(Ae):null}function j(fe,De,Ae,ze,W,V){const J=Math.min(13,fe.length);for(;Ae<J;Ae++){const X=se(fe,De,Ae,ze,W,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(X)return X}return[0,V]}function z(fe){if(typeof fe>"u")return[];const De=[],Ae=fe[1];for(let ze=fe.length-1;ze>1;ze--){const W=fe[ze]+Ae,V=De[De.length-1];V&&V.end===W?V.end=W+1:De.push({start:W,end:W+1})}return De}const M=128;function T(){const fe=[],De=[];for(let Ae=0;Ae<=M;Ae++)De[Ae]=0;for(let Ae=0;Ae<=M;Ae++)fe.push(De.slice(0));return fe}function U(fe){const De=[];for(let Ae=0;Ae<=fe;Ae++)De[Ae]=0;return De}const Z=U(2*M),te=U(2*M),q=T(),K=T(),Y=T(),ie=!1;function $e(fe,De,Ae,ze,W){function V(X,he,we=" "){for(;X.length<he;)X=we+X;return X}let J=` |   |${ze.split("").map(X=>V(X,3)).join("|")}
`;for(let X=0;X<=Ae;X++)X===0?J+=" |":J+=`${De[X-1]}|`,J+=fe[X].slice(0,W+1).map(he=>V(he.toString(),3)).join("|")+`
`;return J}function ue(fe,De,Ae,ze){fe=fe.substr(De),Ae=Ae.substr(ze),console.log($e(K,fe,fe.length,Ae,Ae.length)),console.log($e(Y,fe,fe.length,Ae,Ae.length)),console.log($e(q,fe,fe.length,Ae,Ae.length))}function ve(fe,De){if(De<0||De>=fe.length)return!1;const Ae=fe.codePointAt(De);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$Rf(Ae)}}function _(fe,De){if(De<0||De>=fe.length)return!1;switch(fe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function B(fe,De,Ae){return De[fe]!==Ae[fe]}function ee(fe,De,Ae,ze,W,V,J=!1){for(;De<Ae&&W<V;)fe[De]===ze[W]&&(J&&(Z[De]=W),De+=1),W+=1;return De===Ae}var pe;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Ce;(function(fe){fe.Default=[-100,0];function De(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}fe.isDefault=De})(Ce||(e.FuzzyScore=Ce={}));class oe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Ae){this.firstMatchCanBeWeak=De,this.boostFullMatch=Ae}}e.$Jk=oe;function se(fe,De,Ae,ze,W,V,J=oe.default){const X=fe.length>M?M:fe.length,he=ze.length>M?M:ze.length;if(Ae>=X||V>=he||X-Ae>he-V||!ee(De,Ae,X,W,V,he,!0))return;re(X,he,Ae,V,De,W);let we=1,Fe=1,qe=Ae,Je=V;const rt=[!1];for(we=1,qe=Ae;qe<X;we++,qe++){const Be=Z[qe],He=te[qe],Le=qe+1<X?te[qe+1]:he;for(Fe=Be-V+1,Je=Be;Je<Le;Fe++,Je++){let Xe=Number.MIN_SAFE_INTEGER,ae=!1;Je<=He&&(Xe=G(fe,De,qe,Ae,ze,W,Je,he,V,q[we-1][Fe-1]===0,rt));let ce=0;Xe!==Number.MAX_SAFE_INTEGER&&(ae=!0,ce=Xe+K[we-1][Fe-1]);const Ie=Je>Be,Ge=Ie?K[we][Fe-1]+(q[we][Fe-1]>0?-5:0):0,Oe=Je>Be+1&&q[we][Fe-1]>0,ot=Oe?K[we][Fe-2]+(q[we][Fe-2]>0?-5:0):0;if(Oe&&(!Ie||ot>=Ge)&&(!ae||ot>=ce))K[we][Fe]=ot,Y[we][Fe]=3,q[we][Fe]=0;else if(Ie&&(!ae||Ge>=ce))K[we][Fe]=Ge,Y[we][Fe]=2,q[we][Fe]=0;else if(ae)K[we][Fe]=ce,Y[we][Fe]=1,q[we][Fe]=q[we-1][Fe-1]+1;else throw new Error("not possible")}}if(ie&&ue(fe,Ae,ze,V),!rt[0]&&!J.firstMatchCanBeWeak)return;we--,Fe--;const tt=[K[we][Fe],V];let nt=0,st=0;for(;we>=1;){let Be=Fe;do{const He=Y[we][Be];if(He===3)Be=Be-2;else if(He===2)Be=Be-1;else break}while(Be>=1);nt>1&&De[Ae+we-1]===W[V+Fe-1]&&!B(Be+V-1,ze,W)&&nt+1>q[we][Be]&&(Be=Fe),Be===Fe?nt++:nt=1,st||(st=Be),we--,Fe=Be-1,tt.push(Fe)}he===X&&J.boostFullMatch&&(tt[0]+=2);const Pe=st-X;return tt[0]-=Pe,tt}function re(fe,De,Ae,ze,W,V){let J=fe-1,X=De-1;for(;J>=Ae&&X>=ze;)W[J]===V[X]&&(te[J]=X,J--),X--}function G(fe,De,Ae,ze,W,V,J,X,he,we,Fe){if(De[Ae]!==V[J])return Number.MIN_SAFE_INTEGER;let qe=1,Je=!1;return J===Ae-ze?qe=fe[Ae]===W[J]?7:5:B(J,W,V)&&(J===0||!B(J-1,W,V))?(qe=fe[Ae]===W[J]?7:5,Je=!0):ve(V,J)&&(J===0||!ve(V,J-1))?qe=5:(ve(V,J-1)||_(V,J-1))&&(qe=5,Je=!0),qe>1&&Ae===ze&&(Fe[0]=!0),Je||(Je=B(J,W,V)||ve(V,J-1)||_(V,J-1)),Ae===ze?J>he&&(qe-=Je?3:5):we?qe+=Je?2:0:qe+=Je?0:1,J+1===X&&(qe-=Je?3:5),qe}function ne(fe,De,Ae,ze,W,V,J){return be(fe,De,Ae,ze,W,V,!0,J)}function me(fe,De,Ae,ze,W,V,J){return be(fe,De,Ae,ze,W,V,!1,J)}function be(fe,De,Ae,ze,W,V,J,X){let he=se(fe,De,Ae,ze,W,V,X);if(he&&!J)return he;if(fe.length>=3){const we=Math.min(7,fe.length-1);for(let Fe=Ae+1;Fe<we;Fe++){const qe=Re(fe,Fe);if(qe){const Je=se(qe,qe.toLowerCase(),Ae,ze,W,V,X);Je&&(Je[0]-=3,(!he||Je[0]>he[0])&&(he=Je))}}}return he}function Re(fe,De){if(De+1>=fe.length)return;const Ae=fe[De],ze=fe[De+1];if(Ae!==ze)return fe.slice(0,De)+ze+Ae+fe.slice(De+2)}}),define(ke[57],Se([1,0,14]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=L,e.$lj=O,e.$mj=R,e.$nj=b,e.$pj=h;function L(a){return O(a,0)}function O(a,n){switch(typeof a){case"object":return a===null?R(349,n):Array.isArray(a)?m(a,n):E(a,n);case"string":return b(a,n);case"boolean":return N(a,n);case"number":return R(a,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(a,n){return(n<<5)-n+a|0}function N(a,n){return R(a?433:863,n)}function b(a,n){n=R(149417,n);for(let i=0,u=a.length;i<u;i++)n=R(a.charCodeAt(i),n);return n}function m(a,n){return n=R(104579,n),a.reduce((i,u)=>O(u,i),n)}function E(a,n){return n=R(181387,n),Object.keys(a).sort().reduce((i,u)=>(i=b(u,i),O(a[u],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=O(n,this.g),this.g}}e.$oj=A;var P;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function p(a,n,i=32){const u=i-n,o=~((1<<u)-1);return(a<<n|(o&a)>>>u)>>>0}function y(a,n=0,i=a.byteLength,u=0){for(let o=0;o<i;o++)a[n+o]=u}function w(a,n,i="0"){for(;a.length<n;)a=i+a;return a}function h(a,n=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(i=>i.toString(16).padStart(2,"0")).join(""):w((a>>>0).toString(16),n/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const u=this.p;let o=this.r,t=this.u,l,r;for(t!==0?(l=t,r=-1,t=0):(l=n.charCodeAt(0),r=0);;){let c=l;if(d.$Cf(l))if(r+1<i){const s=n.charCodeAt(r+1);d.$Df(s)?(r++,c=d.$Ef(l,s)):c=65533}else{t=l;break}else d.$Df(l)&&(c=65533);if(o=this.w(u,o,c),r++,r<i)l=n.charCodeAt(r);else break}this.r=o,this.u=t}w(n,i,u){return u<128?n[i++]=u:u<2048?(n[i++]=192|(u&1984)>>>6,n[i++]=128|(u&63)>>>0):u<65536?(n[i++]=224|(u&61440)>>>12,n[i++]=128|(u&4032)>>>6,n[i++]=128|(u&63)>>>0):(n[i++]=240|(u&1835008)>>>18,n[i++]=128|(u&258048)>>>12,n[i++]=128|(u&4032)>>>6,n[i++]=128|(u&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=f.g,i=this.q;for(let g=0;g<64;g+=4)n.setUint32(g,i.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)n.setUint32(g,p(n.getUint32(g-12,!1)^n.getUint32(g-32,!1)^n.getUint32(g-56,!1)^n.getUint32(g-64,!1),1),!1);let u=this.h,o=this.l,t=this.m,l=this.n,r=this.o,c,s,v;for(let g=0;g<80;g++)g<20?(c=o&t|~o&l,s=1518500249):g<40?(c=o^t^l,s=1859775393):g<60?(c=o&t|o&l|t&l,s=2400959708):(c=o^t^l,s=3395469782),v=p(u,5)+c+r+s+n.getUint32(g*4,!1)&4294967295,r=l,l=t,t=p(o,30),o=u,u=v;this.h=this.h+u&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+r&4294967295}}e.$qj=f}),define(ke[41],Se([1,0,14]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(L||(L={})),function(O){const R="error",N="warning",b="warn",m="info",E="ignore";function A(p){return p?d.$yf(R,p)?O.Error:d.$yf(N,p)||d.$yf(b,p)?O.Warning:d.$yf(m,p)?O.Info:O.Ignore:O.Ignore}O.fromValue=A;function P(p){switch(p){case O.Error:return R;case O.Warning:return N;case O.Info:return m;default:return E}}O.toString=P}(L||(L={})),e.default=L}),define(ke[174],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(ke[78],Se([1,0,19,14]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class O{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const w=y.charCodeAt(0),h=this.b.charCodeAt(this.c);return w-h}value(){return this.b[this.c]}}e.$yi=O;class R{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,L.$sf)(y,this.b,0,y.length,this.c,this.d):(0,L.$uf)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=R;class N{constructor(y=!0,w=!0){this.f=y,this.g=w}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let w=y.length-1;w>=0;w--,this.c--){const h=this.b.charCodeAt(w);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,L.$sf)(y,this.b,0,y.length,this.d,this.e):(0,L.$uf)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=N;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class m{constructor(y,w){this.f=y,this.g=w,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new N(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,L.$tf)(y,this.c.scheme);if(this.d[this.e]===2)return(0,L.$tf)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,L.$rf)(y,this.c.query);if(this.d[this.e]===5)return(0,L.$rf)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=m;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(A||(A={}));class P{static forUris(y=()=>!1,w=()=>!1){return new P(new m(y,w))}static forPaths(y=!1){return new P(new N(void 0,!y))}static forStrings(){return new P(new O)}static forConfigKeys(){return new P(new R)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,w){if(w){const h=w.slice(0);(0,d.$Xb)(h);for(const f of h)this.set(f,y)}else{const h=y.slice(0);(0,d.$Xb)(h);for(const f of h)this.set(f[0],f[1])}}set(y,w){const h=this.b.reset(y);let f;this.c||(this.c=new E,this.c.segment=h.value());const a=[];for(f=this.c;;){const i=h.cmp(f.segment);if(i>0)f.left||(f.left=new E,f.left.segment=h.value()),a.push([-1,f]),f=f.left;else if(i<0)f.right||(f.right=new E,f.right.segment=h.value()),a.push([1,f]),f=f.right;else if(h.hasNext())h.next(),f.mid||(f.mid=new E,f.mid.segment=h.value()),a.push([0,f]),f=f.mid;else break}const n=f.value;f.value=w,f.key=y;for(let i=a.length-1;i>=0;i--){const u=a[i][1];u.updateHeight();const o=u.balanceFactor();if(o<-1||o>1){const t=a[i][0],l=a[i+1][0];if(t===1&&l===1)a[i][1]=u.rotateLeft();else if(t===-1&&l===-1)a[i][1]=u.rotateRight();else if(t===1&&l===-1)u.right=a[i+1][1]=a[i+1][1].rotateRight(),a[i][1]=u.rotateLeft();else if(t===-1&&l===1)u.left=a[i+1][1]=a[i+1][1].rotateLeft(),a[i][1]=u.rotateRight();else throw new Error;if(i>0)switch(a[i-1][0]){case-1:a[i-1][1].left=a[i][1];break;case 1:a[i-1][1].right=a[i][1];break;case 0:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}return n}get(y){return this.d(y)?.value}d(y){const w=this.b.reset(y);let h=this.c;for(;h;){const f=w.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(w.hasNext())w.next(),h=h.mid;else break}return h}has(y){const w=this.d(y);return!(w?.value===void 0&&w?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,w){const h=this.b.reset(y),f=[];let a=this.c;for(;a;){const n=h.cmp(a.segment);if(n>0)f.push([-1,a]),a=a.left;else if(n<0)f.push([1,a]),a=a.right;else if(h.hasNext())h.next(),f.push([0,a]),a=a.mid;else break}if(a){if(w?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const n=this.f(a.right);if(n.key){const{key:i,value:u,segment:o}=n;this.e(n.key,!1),a.key=i,a.value=u,a.segment=o}}else{const n=a.left??a.right;if(f.length>0){const[i,u]=f[f.length-1];switch(i){case-1:u.left=n;break;case 0:u.mid=n;break;case 1:u.right=n;break}}else this.c=n}for(let n=f.length-1;n>=0;n--){const i=f[n][1];i.updateHeight();const u=i.balanceFactor();if(u>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),f[n][1]=i.rotateLeft()):u<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),f[n][1]=i.rotateRight()),n>0)switch(f[n-1][0]){case-1:f[n-1][1].left=f[n][1];break;case 1:f[n-1][1].right=f[n][1];break;case 0:f[n-1][1].mid=f[n][1];break}else this.c=f[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const w=this.b.reset(y);let h=this.c,f;for(;h;){const a=w.cmp(h.segment);if(a>0)h=h.left;else if(a<0)h=h.right;else if(w.hasNext())w.next(),f=h.value||f,h=h.mid;else break}return h&&h.value||f}findSuperstr(y){return this.g(y,!1)}g(y,w){const h=this.b.reset(y);let f=this.c;for(;f;){const a=h.cmp(f.segment);if(a>0)f=f.left;else if(a<0)f=f.right;else if(h.hasNext())h.next(),f=f.mid;else return f.mid?this.h(f.mid):w?f.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[w,h]of this)y(h,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const w=[];return this.j(y,w),w[Symbol.iterator]()}j(y,w){y&&(y.left&&this.j(y.left,w),y.value&&w.push([y.key,y.value]),y.mid&&this.j(y.mid,w),y.right&&this.j(y.right,w))}_isBalanced(){const y=w=>{if(!w)return!0;const h=w.balanceFactor();return h<-1||h>1?!1:y(w.left)&&y(w.right)};return y(this.c)}}e.$Ci=P}),define(ke[18],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=d,e.$0f=L,e.$$f=O,e.$_f=R,e.$ag=N,e.$bg=b,e.$cg=m,e.$dg=E,e.$eg=A,e.$fg=P,e.$gg=p,e.$hg=y,e.$ig=w,e.$jg=f,e.$kg=a,e.$lg=n,e.$mg=i,e.$ng=u;function d(o){return typeof o=="string"}function L(o){return Array.isArray(o)&&o.every(t=>d(t))}function O(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function R(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function N(o){return typeof o=="number"&&!isNaN(o)}function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}function m(o){return o===!0||o===!1}function E(o){return typeof o>"u"}function A(o){return!P(o)}function P(o){return E(o)||o===null}function p(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function y(o){if(P(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function w(...o){const t=[];for(let l=0;l<o.length;l++){const r=o[l];if(P(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(r)}return t}const h=Object.prototype.hasOwnProperty;function f(o){if(!O(o))return!1;for(const t in o)if(h.call(o,t))return!1;return!0}function a(o){return typeof o=="function"}function n(...o){return o.length>0&&o.every(a)}function i(o,t){const l=Math.min(o.length,t.length);for(let r=0;r<l;r++)u(o[r],t[r])}function u(o,t){if(d(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(o instanceof t)return}catch{}if(!P(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Se([1,0,18]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=O,e.$Rj=R;const L=Object.create(null);function O(N,b){if((0,d.$9f)(b)){const m=L[b];if(m===void 0)throw new Error(`${N} references an unknown codicon: ${b}`);b=m}return L[N]=b,{id:N}}function R(){return L}}),define(ke[175],Se([1,0,99]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0,e.$Sj={add:(0,d.$Qj)("add",6e4),plus:(0,d.$Qj)("plus",6e4),gistNew:(0,d.$Qj)("gist-new",6e4),repoCreate:(0,d.$Qj)("repo-create",6e4),lightbulb:(0,d.$Qj)("lightbulb",60001),lightBulb:(0,d.$Qj)("light-bulb",60001),repo:(0,d.$Qj)("repo",60002),repoDelete:(0,d.$Qj)("repo-delete",60002),gistFork:(0,d.$Qj)("gist-fork",60003),repoForked:(0,d.$Qj)("repo-forked",60003),gitPullRequest:(0,d.$Qj)("git-pull-request",60004),gitPullRequestAbandoned:(0,d.$Qj)("git-pull-request-abandoned",60004),recordKeys:(0,d.$Qj)("record-keys",60005),keyboard:(0,d.$Qj)("keyboard",60005),tag:(0,d.$Qj)("tag",60006),gitPullRequestLabel:(0,d.$Qj)("git-pull-request-label",60006),tagAdd:(0,d.$Qj)("tag-add",60006),tagRemove:(0,d.$Qj)("tag-remove",60006),person:(0,d.$Qj)("person",60007),personFollow:(0,d.$Qj)("person-follow",60007),personOutline:(0,d.$Qj)("person-outline",60007),personFilled:(0,d.$Qj)("person-filled",60007),gitBranch:(0,d.$Qj)("git-branch",60008),gitBranchCreate:(0,d.$Qj)("git-branch-create",60008),gitBranchDelete:(0,d.$Qj)("git-branch-delete",60008),sourceControl:(0,d.$Qj)("source-control",60008),mirror:(0,d.$Qj)("mirror",60009),mirrorPublic:(0,d.$Qj)("mirror-public",60009),star:(0,d.$Qj)("star",60010),starAdd:(0,d.$Qj)("star-add",60010),starDelete:(0,d.$Qj)("star-delete",60010),starEmpty:(0,d.$Qj)("star-empty",60010),comment:(0,d.$Qj)("comment",60011),commentAdd:(0,d.$Qj)("comment-add",60011),alert:(0,d.$Qj)("alert",60012),warning:(0,d.$Qj)("warning",60012),search:(0,d.$Qj)("search",60013),searchSave:(0,d.$Qj)("search-save",60013),logOut:(0,d.$Qj)("log-out",60014),signOut:(0,d.$Qj)("sign-out",60014),logIn:(0,d.$Qj)("log-in",60015),signIn:(0,d.$Qj)("sign-in",60015),eye:(0,d.$Qj)("eye",60016),eyeUnwatch:(0,d.$Qj)("eye-unwatch",60016),eyeWatch:(0,d.$Qj)("eye-watch",60016),circleFilled:(0,d.$Qj)("circle-filled",60017),primitiveDot:(0,d.$Qj)("primitive-dot",60017),closeDirty:(0,d.$Qj)("close-dirty",60017),debugBreakpoint:(0,d.$Qj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,d.$Qj)("debug-breakpoint-disabled",60017),debugHint:(0,d.$Qj)("debug-hint",60017),terminalDecorationSuccess:(0,d.$Qj)("terminal-decoration-success",60017),primitiveSquare:(0,d.$Qj)("primitive-square",60018),edit:(0,d.$Qj)("edit",60019),pencil:(0,d.$Qj)("pencil",60019),info:(0,d.$Qj)("info",60020),issueOpened:(0,d.$Qj)("issue-opened",60020),gistPrivate:(0,d.$Qj)("gist-private",60021),gitForkPrivate:(0,d.$Qj)("git-fork-private",60021),lock:(0,d.$Qj)("lock",60021),mirrorPrivate:(0,d.$Qj)("mirror-private",60021),close:(0,d.$Qj)("close",60022),removeClose:(0,d.$Qj)("remove-close",60022),x:(0,d.$Qj)("x",60022),repoSync:(0,d.$Qj)("repo-sync",60023),sync:(0,d.$Qj)("sync",60023),clone:(0,d.$Qj)("clone",60024),desktopDownload:(0,d.$Qj)("desktop-download",60024),beaker:(0,d.$Qj)("beaker",60025),microscope:(0,d.$Qj)("microscope",60025),vm:(0,d.$Qj)("vm",60026),deviceDesktop:(0,d.$Qj)("device-desktop",60026),file:(0,d.$Qj)("file",60027),fileText:(0,d.$Qj)("file-text",60027),more:(0,d.$Qj)("more",60028),ellipsis:(0,d.$Qj)("ellipsis",60028),kebabHorizontal:(0,d.$Qj)("kebab-horizontal",60028),mailReply:(0,d.$Qj)("mail-reply",60029),reply:(0,d.$Qj)("reply",60029),organization:(0,d.$Qj)("organization",60030),organizationFilled:(0,d.$Qj)("organization-filled",60030),organizationOutline:(0,d.$Qj)("organization-outline",60030),newFile:(0,d.$Qj)("new-file",60031),fileAdd:(0,d.$Qj)("file-add",60031),newFolder:(0,d.$Qj)("new-folder",60032),fileDirectoryCreate:(0,d.$Qj)("file-directory-create",60032),trash:(0,d.$Qj)("trash",60033),trashcan:(0,d.$Qj)("trashcan",60033),history:(0,d.$Qj)("history",60034),clock:(0,d.$Qj)("clock",60034),folder:(0,d.$Qj)("folder",60035),fileDirectory:(0,d.$Qj)("file-directory",60035),symbolFolder:(0,d.$Qj)("symbol-folder",60035),logoGithub:(0,d.$Qj)("logo-github",60036),markGithub:(0,d.$Qj)("mark-github",60036),github:(0,d.$Qj)("github",60036),terminal:(0,d.$Qj)("terminal",60037),console:(0,d.$Qj)("console",60037),repl:(0,d.$Qj)("repl",60037),zap:(0,d.$Qj)("zap",60038),symbolEvent:(0,d.$Qj)("symbol-event",60038),error:(0,d.$Qj)("error",60039),stop:(0,d.$Qj)("stop",60039),variable:(0,d.$Qj)("variable",60040),symbolVariable:(0,d.$Qj)("symbol-variable",60040),array:(0,d.$Qj)("array",60042),symbolArray:(0,d.$Qj)("symbol-array",60042),symbolModule:(0,d.$Qj)("symbol-module",60043),symbolPackage:(0,d.$Qj)("symbol-package",60043),symbolNamespace:(0,d.$Qj)("symbol-namespace",60043),symbolObject:(0,d.$Qj)("symbol-object",60043),symbolMethod:(0,d.$Qj)("symbol-method",60044),symbolFunction:(0,d.$Qj)("symbol-function",60044),symbolConstructor:(0,d.$Qj)("symbol-constructor",60044),symbolBoolean:(0,d.$Qj)("symbol-boolean",60047),symbolNull:(0,d.$Qj)("symbol-null",60047),symbolNumeric:(0,d.$Qj)("symbol-numeric",60048),symbolNumber:(0,d.$Qj)("symbol-number",60048),symbolStructure:(0,d.$Qj)("symbol-structure",60049),symbolStruct:(0,d.$Qj)("symbol-struct",60049),symbolParameter:(0,d.$Qj)("symbol-parameter",60050),symbolTypeParameter:(0,d.$Qj)("symbol-type-parameter",60050),symbolKey:(0,d.$Qj)("symbol-key",60051),symbolText:(0,d.$Qj)("symbol-text",60051),symbolReference:(0,d.$Qj)("symbol-reference",60052),goToFile:(0,d.$Qj)("go-to-file",60052),symbolEnum:(0,d.$Qj)("symbol-enum",60053),symbolValue:(0,d.$Qj)("symbol-value",60053),symbolRuler:(0,d.$Qj)("symbol-ruler",60054),symbolUnit:(0,d.$Qj)("symbol-unit",60054),activateBreakpoints:(0,d.$Qj)("activate-breakpoints",60055),archive:(0,d.$Qj)("archive",60056),arrowBoth:(0,d.$Qj)("arrow-both",60057),arrowDown:(0,d.$Qj)("arrow-down",60058),arrowLeft:(0,d.$Qj)("arrow-left",60059),arrowRight:(0,d.$Qj)("arrow-right",60060),arrowSmallDown:(0,d.$Qj)("arrow-small-down",60061),arrowSmallLeft:(0,d.$Qj)("arrow-small-left",60062),arrowSmallRight:(0,d.$Qj)("arrow-small-right",60063),arrowSmallUp:(0,d.$Qj)("arrow-small-up",60064),arrowUp:(0,d.$Qj)("arrow-up",60065),bell:(0,d.$Qj)("bell",60066),bold:(0,d.$Qj)("bold",60067),book:(0,d.$Qj)("book",60068),bookmark:(0,d.$Qj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,d.$Qj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,d.$Qj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,d.$Qj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,d.$Qj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,d.$Qj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,d.$Qj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,d.$Qj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,d.$Qj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,d.$Qj)("debug-breakpoint-log-disabled",60075),briefcase:(0,d.$Qj)("briefcase",60076),broadcast:(0,d.$Qj)("broadcast",60077),browser:(0,d.$Qj)("browser",60078),bug:(0,d.$Qj)("bug",60079),calendar:(0,d.$Qj)("calendar",60080),caseSensitive:(0,d.$Qj)("case-sensitive",60081),check:(0,d.$Qj)("check",60082),checklist:(0,d.$Qj)("checklist",60083),chevronDown:(0,d.$Qj)("chevron-down",60084),chevronLeft:(0,d.$Qj)("chevron-left",60085),chevronRight:(0,d.$Qj)("chevron-right",60086),chevronUp:(0,d.$Qj)("chevron-up",60087),chromeClose:(0,d.$Qj)("chrome-close",60088),chromeMaximize:(0,d.$Qj)("chrome-maximize",60089),chromeMinimize:(0,d.$Qj)("chrome-minimize",60090),chromeRestore:(0,d.$Qj)("chrome-restore",60091),circleOutline:(0,d.$Qj)("circle-outline",60092),circle:(0,d.$Qj)("circle",60092),debugBreakpointUnverified:(0,d.$Qj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,d.$Qj)("terminal-decoration-incomplete",60092),circleSlash:(0,d.$Qj)("circle-slash",60093),circuitBoard:(0,d.$Qj)("circuit-board",60094),clearAll:(0,d.$Qj)("clear-all",60095),clippy:(0,d.$Qj)("clippy",60096),closeAll:(0,d.$Qj)("close-all",60097),cloudDownload:(0,d.$Qj)("cloud-download",60098),cloudUpload:(0,d.$Qj)("cloud-upload",60099),code:(0,d.$Qj)("code",60100),collapseAll:(0,d.$Qj)("collapse-all",60101),colorMode:(0,d.$Qj)("color-mode",60102),commentDiscussion:(0,d.$Qj)("comment-discussion",60103),creditCard:(0,d.$Qj)("credit-card",60105),dash:(0,d.$Qj)("dash",60108),dashboard:(0,d.$Qj)("dashboard",60109),database:(0,d.$Qj)("database",60110),debugContinue:(0,d.$Qj)("debug-continue",60111),debugDisconnect:(0,d.$Qj)("debug-disconnect",60112),debugPause:(0,d.$Qj)("debug-pause",60113),debugRestart:(0,d.$Qj)("debug-restart",60114),debugStart:(0,d.$Qj)("debug-start",60115),debugStepInto:(0,d.$Qj)("debug-step-into",60116),debugStepOut:(0,d.$Qj)("debug-step-out",60117),debugStepOver:(0,d.$Qj)("debug-step-over",60118),debugStop:(0,d.$Qj)("debug-stop",60119),debug:(0,d.$Qj)("debug",60120),deviceCameraVideo:(0,d.$Qj)("device-camera-video",60121),deviceCamera:(0,d.$Qj)("device-camera",60122),deviceMobile:(0,d.$Qj)("device-mobile",60123),diffAdded:(0,d.$Qj)("diff-added",60124),diffIgnored:(0,d.$Qj)("diff-ignored",60125),diffModified:(0,d.$Qj)("diff-modified",60126),diffRemoved:(0,d.$Qj)("diff-removed",60127),diffRenamed:(0,d.$Qj)("diff-renamed",60128),diff:(0,d.$Qj)("diff",60129),diffSidebyside:(0,d.$Qj)("diff-sidebyside",60129),discard:(0,d.$Qj)("discard",60130),editorLayout:(0,d.$Qj)("editor-layout",60131),emptyWindow:(0,d.$Qj)("empty-window",60132),exclude:(0,d.$Qj)("exclude",60133),extensions:(0,d.$Qj)("extensions",60134),eyeClosed:(0,d.$Qj)("eye-closed",60135),fileBinary:(0,d.$Qj)("file-binary",60136),fileCode:(0,d.$Qj)("file-code",60137),fileMedia:(0,d.$Qj)("file-media",60138),filePdf:(0,d.$Qj)("file-pdf",60139),fileSubmodule:(0,d.$Qj)("file-submodule",60140),fileSymlinkDirectory:(0,d.$Qj)("file-symlink-directory",60141),fileSymlinkFile:(0,d.$Qj)("file-symlink-file",60142),fileZip:(0,d.$Qj)("file-zip",60143),files:(0,d.$Qj)("files",60144),filter:(0,d.$Qj)("filter",60145),flame:(0,d.$Qj)("flame",60146),foldDown:(0,d.$Qj)("fold-down",60147),foldUp:(0,d.$Qj)("fold-up",60148),fold:(0,d.$Qj)("fold",60149),folderActive:(0,d.$Qj)("folder-active",60150),folderOpened:(0,d.$Qj)("folder-opened",60151),gear:(0,d.$Qj)("gear",60152),gift:(0,d.$Qj)("gift",60153),gistSecret:(0,d.$Qj)("gist-secret",60154),gist:(0,d.$Qj)("gist",60155),gitCommit:(0,d.$Qj)("git-commit",60156),gitCompare:(0,d.$Qj)("git-compare",60157),compareChanges:(0,d.$Qj)("compare-changes",60157),gitMerge:(0,d.$Qj)("git-merge",60158),githubAction:(0,d.$Qj)("github-action",60159),githubAlt:(0,d.$Qj)("github-alt",60160),globe:(0,d.$Qj)("globe",60161),grabber:(0,d.$Qj)("grabber",60162),graph:(0,d.$Qj)("graph",60163),gripper:(0,d.$Qj)("gripper",60164),heart:(0,d.$Qj)("heart",60165),home:(0,d.$Qj)("home",60166),horizontalRule:(0,d.$Qj)("horizontal-rule",60167),hubot:(0,d.$Qj)("hubot",60168),inbox:(0,d.$Qj)("inbox",60169),issueReopened:(0,d.$Qj)("issue-reopened",60171),issues:(0,d.$Qj)("issues",60172),italic:(0,d.$Qj)("italic",60173),jersey:(0,d.$Qj)("jersey",60174),json:(0,d.$Qj)("json",60175),kebabVertical:(0,d.$Qj)("kebab-vertical",60176),key:(0,d.$Qj)("key",60177),law:(0,d.$Qj)("law",60178),lightbulbAutofix:(0,d.$Qj)("lightbulb-autofix",60179),linkExternal:(0,d.$Qj)("link-external",60180),link:(0,d.$Qj)("link",60181),listOrdered:(0,d.$Qj)("list-ordered",60182),listUnordered:(0,d.$Qj)("list-unordered",60183),liveShare:(0,d.$Qj)("live-share",60184),loading:(0,d.$Qj)("loading",60185),location:(0,d.$Qj)("location",60186),mailRead:(0,d.$Qj)("mail-read",60187),mail:(0,d.$Qj)("mail",60188),markdown:(0,d.$Qj)("markdown",60189),megaphone:(0,d.$Qj)("megaphone",60190),mention:(0,d.$Qj)("mention",60191),milestone:(0,d.$Qj)("milestone",60192),gitPullRequestMilestone:(0,d.$Qj)("git-pull-request-milestone",60192),mortarBoard:(0,d.$Qj)("mortar-board",60193),move:(0,d.$Qj)("move",60194),multipleWindows:(0,d.$Qj)("multiple-windows",60195),mute:(0,d.$Qj)("mute",60196),noNewline:(0,d.$Qj)("no-newline",60197),note:(0,d.$Qj)("note",60198),octoface:(0,d.$Qj)("octoface",60199),openPreview:(0,d.$Qj)("open-preview",60200),package:(0,d.$Qj)("package",60201),paintcan:(0,d.$Qj)("paintcan",60202),pin:(0,d.$Qj)("pin",60203),play:(0,d.$Qj)("play",60204),run:(0,d.$Qj)("run",60204),plug:(0,d.$Qj)("plug",60205),preserveCase:(0,d.$Qj)("preserve-case",60206),preview:(0,d.$Qj)("preview",60207),project:(0,d.$Qj)("project",60208),pulse:(0,d.$Qj)("pulse",60209),question:(0,d.$Qj)("question",60210),quote:(0,d.$Qj)("quote",60211),radioTower:(0,d.$Qj)("radio-tower",60212),reactions:(0,d.$Qj)("reactions",60213),references:(0,d.$Qj)("references",60214),refresh:(0,d.$Qj)("refresh",60215),regex:(0,d.$Qj)("regex",60216),remoteExplorer:(0,d.$Qj)("remote-explorer",60217),remote:(0,d.$Qj)("remote",60218),remove:(0,d.$Qj)("remove",60219),replaceAll:(0,d.$Qj)("replace-all",60220),replace:(0,d.$Qj)("replace",60221),repoClone:(0,d.$Qj)("repo-clone",60222),repoForcePush:(0,d.$Qj)("repo-force-push",60223),repoPull:(0,d.$Qj)("repo-pull",60224),repoPush:(0,d.$Qj)("repo-push",60225),report:(0,d.$Qj)("report",60226),requestChanges:(0,d.$Qj)("request-changes",60227),rocket:(0,d.$Qj)("rocket",60228),rootFolderOpened:(0,d.$Qj)("root-folder-opened",60229),rootFolder:(0,d.$Qj)("root-folder",60230),rss:(0,d.$Qj)("rss",60231),ruby:(0,d.$Qj)("ruby",60232),saveAll:(0,d.$Qj)("save-all",60233),saveAs:(0,d.$Qj)("save-as",60234),save:(0,d.$Qj)("save",60235),screenFull:(0,d.$Qj)("screen-full",60236),screenNormal:(0,d.$Qj)("screen-normal",60237),searchStop:(0,d.$Qj)("search-stop",60238),server:(0,d.$Qj)("server",60240),settingsGear:(0,d.$Qj)("settings-gear",60241),settings:(0,d.$Qj)("settings",60242),shield:(0,d.$Qj)("shield",60243),smiley:(0,d.$Qj)("smiley",60244),sortPrecedence:(0,d.$Qj)("sort-precedence",60245),splitHorizontal:(0,d.$Qj)("split-horizontal",60246),splitVertical:(0,d.$Qj)("split-vertical",60247),squirrel:(0,d.$Qj)("squirrel",60248),starFull:(0,d.$Qj)("star-full",60249),starHalf:(0,d.$Qj)("star-half",60250),symbolClass:(0,d.$Qj)("symbol-class",60251),symbolColor:(0,d.$Qj)("symbol-color",60252),symbolConstant:(0,d.$Qj)("symbol-constant",60253),symbolEnumMember:(0,d.$Qj)("symbol-enum-member",60254),symbolField:(0,d.$Qj)("symbol-field",60255),symbolFile:(0,d.$Qj)("symbol-file",60256),symbolInterface:(0,d.$Qj)("symbol-interface",60257),symbolKeyword:(0,d.$Qj)("symbol-keyword",60258),symbolMisc:(0,d.$Qj)("symbol-misc",60259),symbolOperator:(0,d.$Qj)("symbol-operator",60260),symbolProperty:(0,d.$Qj)("symbol-property",60261),wrench:(0,d.$Qj)("wrench",60261),wrenchSubaction:(0,d.$Qj)("wrench-subaction",60261),symbolSnippet:(0,d.$Qj)("symbol-snippet",60262),tasklist:(0,d.$Qj)("tasklist",60263),telescope:(0,d.$Qj)("telescope",60264),textSize:(0,d.$Qj)("text-size",60265),threeBars:(0,d.$Qj)("three-bars",60266),thumbsdown:(0,d.$Qj)("thumbsdown",60267),thumbsup:(0,d.$Qj)("thumbsup",60268),tools:(0,d.$Qj)("tools",60269),triangleDown:(0,d.$Qj)("triangle-down",60270),triangleLeft:(0,d.$Qj)("triangle-left",60271),triangleRight:(0,d.$Qj)("triangle-right",60272),triangleUp:(0,d.$Qj)("triangle-up",60273),twitter:(0,d.$Qj)("twitter",60274),unfold:(0,d.$Qj)("unfold",60275),unlock:(0,d.$Qj)("unlock",60276),unmute:(0,d.$Qj)("unmute",60277),unverified:(0,d.$Qj)("unverified",60278),verified:(0,d.$Qj)("verified",60279),versions:(0,d.$Qj)("versions",60280),vmActive:(0,d.$Qj)("vm-active",60281),vmOutline:(0,d.$Qj)("vm-outline",60282),vmRunning:(0,d.$Qj)("vm-running",60283),watch:(0,d.$Qj)("watch",60284),whitespace:(0,d.$Qj)("whitespace",60285),wholeWord:(0,d.$Qj)("whole-word",60286),window:(0,d.$Qj)("window",60287),wordWrap:(0,d.$Qj)("word-wrap",60288),zoomIn:(0,d.$Qj)("zoom-in",60289),zoomOut:(0,d.$Qj)("zoom-out",60290),listFilter:(0,d.$Qj)("list-filter",60291),listFlat:(0,d.$Qj)("list-flat",60292),listSelection:(0,d.$Qj)("list-selection",60293),selection:(0,d.$Qj)("selection",60293),listTree:(0,d.$Qj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,d.$Qj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,d.$Qj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,d.$Qj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,d.$Qj)("debug-stackframe-active",60297),circleSmallFilled:(0,d.$Qj)("circle-small-filled",60298),debugStackframeDot:(0,d.$Qj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,d.$Qj)("terminal-decoration-mark",60298),debugStackframe:(0,d.$Qj)("debug-stackframe",60299),debugStackframeFocused:(0,d.$Qj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,d.$Qj)("debug-breakpoint-unsupported",60300),symbolString:(0,d.$Qj)("symbol-string",60301),debugReverseContinue:(0,d.$Qj)("debug-reverse-continue",60302),debugStepBack:(0,d.$Qj)("debug-step-back",60303),debugRestartFrame:(0,d.$Qj)("debug-restart-frame",60304),debugAlt:(0,d.$Qj)("debug-alt",60305),callIncoming:(0,d.$Qj)("call-incoming",60306),callOutgoing:(0,d.$Qj)("call-outgoing",60307),menu:(0,d.$Qj)("menu",60308),expandAll:(0,d.$Qj)("expand-all",60309),feedback:(0,d.$Qj)("feedback",60310),gitPullRequestReviewer:(0,d.$Qj)("git-pull-request-reviewer",60310),groupByRefType:(0,d.$Qj)("group-by-ref-type",60311),ungroupByRefType:(0,d.$Qj)("ungroup-by-ref-type",60312),account:(0,d.$Qj)("account",60313),gitPullRequestAssignee:(0,d.$Qj)("git-pull-request-assignee",60313),bellDot:(0,d.$Qj)("bell-dot",60314),debugConsole:(0,d.$Qj)("debug-console",60315),library:(0,d.$Qj)("library",60316),output:(0,d.$Qj)("output",60317),runAll:(0,d.$Qj)("run-all",60318),syncIgnored:(0,d.$Qj)("sync-ignored",60319),pinned:(0,d.$Qj)("pinned",60320),githubInverted:(0,d.$Qj)("github-inverted",60321),serverProcess:(0,d.$Qj)("server-process",60322),serverEnvironment:(0,d.$Qj)("server-environment",60323),pass:(0,d.$Qj)("pass",60324),issueClosed:(0,d.$Qj)("issue-closed",60324),stopCircle:(0,d.$Qj)("stop-circle",60325),playCircle:(0,d.$Qj)("play-circle",60326),record:(0,d.$Qj)("record",60327),debugAltSmall:(0,d.$Qj)("debug-alt-small",60328),vmConnect:(0,d.$Qj)("vm-connect",60329),cloud:(0,d.$Qj)("cloud",60330),merge:(0,d.$Qj)("merge",60331),export:(0,d.$Qj)("export",60332),graphLeft:(0,d.$Qj)("graph-left",60333),magnet:(0,d.$Qj)("magnet",60334),notebook:(0,d.$Qj)("notebook",60335),redo:(0,d.$Qj)("redo",60336),checkAll:(0,d.$Qj)("check-all",60337),pinnedDirty:(0,d.$Qj)("pinned-dirty",60338),passFilled:(0,d.$Qj)("pass-filled",60339),circleLargeFilled:(0,d.$Qj)("circle-large-filled",60340),circleLarge:(0,d.$Qj)("circle-large",60341),circleLargeOutline:(0,d.$Qj)("circle-large-outline",60341),combine:(0,d.$Qj)("combine",60342),gather:(0,d.$Qj)("gather",60342),table:(0,d.$Qj)("table",60343),variableGroup:(0,d.$Qj)("variable-group",60344),typeHierarchy:(0,d.$Qj)("type-hierarchy",60345),typeHierarchySub:(0,d.$Qj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,d.$Qj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,d.$Qj)("git-pull-request-create",60348),runAbove:(0,d.$Qj)("run-above",60349),runBelow:(0,d.$Qj)("run-below",60350),notebookTemplate:(0,d.$Qj)("notebook-template",60351),debugRerun:(0,d.$Qj)("debug-rerun",60352),workspaceTrusted:(0,d.$Qj)("workspace-trusted",60353),workspaceUntrusted:(0,d.$Qj)("workspace-untrusted",60354),workspaceUnknown:(0,d.$Qj)("workspace-unknown",60355),terminalCmd:(0,d.$Qj)("terminal-cmd",60356),terminalDebian:(0,d.$Qj)("terminal-debian",60357),terminalLinux:(0,d.$Qj)("terminal-linux",60358),terminalPowershell:(0,d.$Qj)("terminal-powershell",60359),terminalTmux:(0,d.$Qj)("terminal-tmux",60360),terminalUbuntu:(0,d.$Qj)("terminal-ubuntu",60361),terminalBash:(0,d.$Qj)("terminal-bash",60362),arrowSwap:(0,d.$Qj)("arrow-swap",60363),copy:(0,d.$Qj)("copy",60364),personAdd:(0,d.$Qj)("person-add",60365),filterFilled:(0,d.$Qj)("filter-filled",60366),wand:(0,d.$Qj)("wand",60367),debugLineByLine:(0,d.$Qj)("debug-line-by-line",60368),inspect:(0,d.$Qj)("inspect",60369),layers:(0,d.$Qj)("layers",60370),layersDot:(0,d.$Qj)("layers-dot",60371),layersActive:(0,d.$Qj)("layers-active",60372),compass:(0,d.$Qj)("compass",60373),compassDot:(0,d.$Qj)("compass-dot",60374),compassActive:(0,d.$Qj)("compass-active",60375),azure:(0,d.$Qj)("azure",60376),issueDraft:(0,d.$Qj)("issue-draft",60377),gitPullRequestClosed:(0,d.$Qj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,d.$Qj)("git-pull-request-draft",60379),debugAll:(0,d.$Qj)("debug-all",60380),debugCoverage:(0,d.$Qj)("debug-coverage",60381),runErrors:(0,d.$Qj)("run-errors",60382),folderLibrary:(0,d.$Qj)("folder-library",60383),debugContinueSmall:(0,d.$Qj)("debug-continue-small",60384),beakerStop:(0,d.$Qj)("beaker-stop",60385),graphLine:(0,d.$Qj)("graph-line",60386),graphScatter:(0,d.$Qj)("graph-scatter",60387),pieChart:(0,d.$Qj)("pie-chart",60388),bracket:(0,d.$Qj)("bracket",60175),bracketDot:(0,d.$Qj)("bracket-dot",60389),bracketError:(0,d.$Qj)("bracket-error",60390),lockSmall:(0,d.$Qj)("lock-small",60391),azureDevops:(0,d.$Qj)("azure-devops",60392),verifiedFilled:(0,d.$Qj)("verified-filled",60393),newline:(0,d.$Qj)("newline",60394),layout:(0,d.$Qj)("layout",60395),layoutActivitybarLeft:(0,d.$Qj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,d.$Qj)("layout-activitybar-right",60397),layoutPanelLeft:(0,d.$Qj)("layout-panel-left",60398),layoutPanelCenter:(0,d.$Qj)("layout-panel-center",60399),layoutPanelJustify:(0,d.$Qj)("layout-panel-justify",60400),layoutPanelRight:(0,d.$Qj)("layout-panel-right",60401),layoutPanel:(0,d.$Qj)("layout-panel",60402),layoutSidebarLeft:(0,d.$Qj)("layout-sidebar-left",60403),layoutSidebarRight:(0,d.$Qj)("layout-sidebar-right",60404),layoutStatusbar:(0,d.$Qj)("layout-statusbar",60405),layoutMenubar:(0,d.$Qj)("layout-menubar",60406),layoutCentered:(0,d.$Qj)("layout-centered",60407),target:(0,d.$Qj)("target",60408),indent:(0,d.$Qj)("indent",60409),recordSmall:(0,d.$Qj)("record-small",60410),errorSmall:(0,d.$Qj)("error-small",60411),terminalDecorationError:(0,d.$Qj)("terminal-decoration-error",60411),arrowCircleDown:(0,d.$Qj)("arrow-circle-down",60412),arrowCircleLeft:(0,d.$Qj)("arrow-circle-left",60413),arrowCircleRight:(0,d.$Qj)("arrow-circle-right",60414),arrowCircleUp:(0,d.$Qj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,d.$Qj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,d.$Qj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,d.$Qj)("layout-sidebar-left-off",60418),blank:(0,d.$Qj)("blank",60419),heartFilled:(0,d.$Qj)("heart-filled",60420),map:(0,d.$Qj)("map",60421),mapHorizontal:(0,d.$Qj)("map-horizontal",60421),foldHorizontal:(0,d.$Qj)("fold-horizontal",60421),mapFilled:(0,d.$Qj)("map-filled",60422),mapHorizontalFilled:(0,d.$Qj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,d.$Qj)("fold-horizontal-filled",60422),circleSmall:(0,d.$Qj)("circle-small",60423),bellSlash:(0,d.$Qj)("bell-slash",60424),bellSlashDot:(0,d.$Qj)("bell-slash-dot",60425),commentUnresolved:(0,d.$Qj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,d.$Qj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,d.$Qj)("git-pull-request-new-changes",60428),searchFuzzy:(0,d.$Qj)("search-fuzzy",60429),commentDraft:(0,d.$Qj)("comment-draft",60430),send:(0,d.$Qj)("send",60431),sparkle:(0,d.$Qj)("sparkle",60432),insert:(0,d.$Qj)("insert",60433),mic:(0,d.$Qj)("mic",60434),thumbsdownFilled:(0,d.$Qj)("thumbsdown-filled",60435),thumbsupFilled:(0,d.$Qj)("thumbsup-filled",60436),coffee:(0,d.$Qj)("coffee",60437),snake:(0,d.$Qj)("snake",60438),game:(0,d.$Qj)("game",60439),vr:(0,d.$Qj)("vr",60440),chip:(0,d.$Qj)("chip",60441),piano:(0,d.$Qj)("piano",60442),music:(0,d.$Qj)("music",60443),micFilled:(0,d.$Qj)("mic-filled",60444),repoFetch:(0,d.$Qj)("repo-fetch",60445),copilot:(0,d.$Qj)("copilot",60446),lightbulbSparkle:(0,d.$Qj)("lightbulb-sparkle",60447),robot:(0,d.$Qj)("robot",60448),sparkleFilled:(0,d.$Qj)("sparkle-filled",60449),diffSingle:(0,d.$Qj)("diff-single",60450),diffMultiple:(0,d.$Qj)("diff-multiple",60451),surroundWith:(0,d.$Qj)("surround-with",60452),share:(0,d.$Qj)("share",60453),gitStash:(0,d.$Qj)("git-stash",60454),gitStashApply:(0,d.$Qj)("git-stash-apply",60455),gitStashPop:(0,d.$Qj)("git-stash-pop",60456),vscode:(0,d.$Qj)("vscode",60457),vscodeInsiders:(0,d.$Qj)("vscode-insiders",60458),codeOss:(0,d.$Qj)("code-oss",60459),runCoverage:(0,d.$Qj)("run-coverage",60460),runAllCoverage:(0,d.$Qj)("run-all-coverage",60461),coverage:(0,d.$Qj)("coverage",60462),githubProject:(0,d.$Qj)("github-project",60463),mapVertical:(0,d.$Qj)("map-vertical",60464),foldVertical:(0,d.$Qj)("fold-vertical",60464),mapVerticalFilled:(0,d.$Qj)("map-vertical-filled",60465),foldVerticalFilled:(0,d.$Qj)("fold-vertical-filled",60465),goToSearch:(0,d.$Qj)("go-to-search",60466),percentage:(0,d.$Qj)("percentage",60467),sortPercentage:(0,d.$Qj)("sort-percentage",60467)}}),define(ke[79],Se([1,0,99,175]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=void 0,e.$Tj=O;function O(){return Object.values(e.$Vj)}e.$Uj={dialogError:(0,d.$Qj)("dialog-error","error"),dialogWarning:(0,d.$Qj)("dialog-warning","warning"),dialogInfo:(0,d.$Qj)("dialog-info","info"),dialogClose:(0,d.$Qj)("dialog-close","close"),treeItemExpanded:(0,d.$Qj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,d.$Qj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,d.$Qj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,d.$Qj)("tree-filter-clear","close"),treeItemLoading:(0,d.$Qj)("tree-item-loading","loading"),menuSelection:(0,d.$Qj)("menu-selection","check"),menuSubmenu:(0,d.$Qj)("menu-submenu","chevron-right"),menuBarMore:(0,d.$Qj)("menubar-more","more"),scrollbarButtonLeft:(0,d.$Qj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,d.$Qj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,d.$Qj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,d.$Qj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,d.$Qj)("toolbar-more","more"),quickInputBack:(0,d.$Qj)("quick-input-back","arrow-left"),dropDownButton:(0,d.$Qj)("drop-down-button",60084),symbolCustomColor:(0,d.$Qj)("symbol-customcolor",60252),exportIcon:(0,d.$Qj)("export",60332),workspaceUnspecified:(0,d.$Qj)("workspace-unspecified",60355),newLine:(0,d.$Qj)("newline",60394),thumbsDownFilled:(0,d.$Qj)("thumbsdown-filled",60435),thumbsUpFilled:(0,d.$Qj)("thumbsup-filled",60436),gitFetch:(0,d.$Qj)("git-fetch",60445),lightbulbSparkleAutofix:(0,d.$Qj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,d.$Qj)("debug-breakpoint-pending",60377)},e.$Vj={...L.$Sj,...e.$Uj}}),define(ke[24],Se([1,0,18]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=L,e.$4n=O,e.$5n=N,e.$6n=m,e.$7n=E,e.$8n=A,e.$9n=P,e.$0n=p,e.$$n=y,e.$_n=w,e.$ao=h,e.$bo=f;function L(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const n=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([i,u])=>{n[i]=u&&typeof u=="object"?L(u):u}),n}function O(a){if(!a||typeof a!="object")return a;const n=[a];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const u in i)if(R.call(i,u)){const o=i[u];typeof o=="object"&&!Object.isFrozen(o)&&!(0,d.$_f)(o)&&n.push(o)}}return a}const R=Object.prototype.hasOwnProperty;function N(a,n){return b(a,n,new Set)}function b(a,n,i){if((0,d.$fg)(a))return a;const u=n(a);if(typeof u<"u")return u;if(Array.isArray(a)){const o=[];for(const t of a)o.push(b(t,n,i));return o}if((0,d.$$f)(a)){if(i.has(a))throw new Error("Cannot clone recursive data-structure");i.add(a);const o={};for(const t in a)R.call(a,t)&&(o[t]=b(a[t],n,i));return i.delete(a),o}return a}function m(a,n,i=!0){return(0,d.$$f)(a)?((0,d.$$f)(n)&&Object.keys(n).forEach(u=>{u in a?i&&((0,d.$$f)(a[u])&&(0,d.$$f)(n[u])?m(a[u],n[u],i):a[u]=n[u]):a[u]=n[u]}),a):n}function E(a,n){if(a===n)return!0;if(a==null||n===null||n===void 0||typeof a!=typeof n||typeof a!="object"||Array.isArray(a)!==Array.isArray(n))return!1;let i,u;if(Array.isArray(a)){if(a.length!==n.length)return!1;for(i=0;i<a.length;i++)if(!E(a[i],n[i]))return!1}else{const o=[];for(u in a)o.push(u);o.sort();const t=[];for(u in n)t.push(u);if(t.sort(),!E(o,t))return!1;for(i=0;i<o.length;i++)if(!E(a[o[i]],n[o[i]]))return!1}return!0}function A(a){const n=new Set;return JSON.stringify(a,(i,u)=>{if((0,d.$$f)(u)||Array.isArray(u)){if(n.has(u))return"[Circular]";n.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function P(a,n){const i=Object.create(null);return!a||!n||Object.keys(n).forEach(o=>{const t=a[o],l=n[o];E(t,l)||(i[o]=l)}),i}function p(a,n){const i=n.toLowerCase(),u=Object.keys(a).find(o=>o.toLowerCase()===i);return u?a[u]:a[n]}function y(a,n){const i=Object.create(null);for(const[u,o]of Object.entries(a))n(u,o)&&(i[u]=o);return i}function w(a){let n=[];for(;Object.prototype!==a;)n=n.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return n}function h(a){const n=[];for(const i of w(a))typeof a[i]=="function"&&n.push(i);return n}function f(a,n){const i=o=>function(){const t=Array.prototype.slice.call(arguments,0);return n(o,t)},u={};for(const o of a)u[o]=i(o);return u}}),define(ke[50],Se([1,0,79]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=O;var L;(function(N){function b(m){return m&&typeof m=="object"&&typeof m.id=="string"}N.isThemeColor=b})(L||(e.ThemeColor=L={}));function O(N){return{id:N}}var R;(function(N){N.iconNameSegment="[A-Za-z0-9]+",N.iconNameExpression="[A-Za-z0-9-]+",N.iconModifierExpression="~[A-Za-z]+",N.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${N.iconNameExpression})(${N.iconModifierExpression})?$`);function m(n){const i=b.exec(n.id);if(!i)return m(d.$Vj.error);const[,u,o]=i,t=["codicon","codicon-"+u];return o&&t.push("codicon-modifier-"+o.substring(1)),t}N.asClassNameArray=m;function E(n){return m(n).join(" ")}N.asClassName=E;function A(n){return"."+m(n).join(".")}N.asCSSSelector=A;function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}N.isThemeIcon=P;const p=new RegExp(`^\\$\\((${N.iconNameExpression}(?:${N.iconModifierExpression})?)\\)$`);function y(n){const i=p.exec(n);if(!i)return;const[,u]=i;return{id:u}}N.fromString=y;function w(n){return{id:n}}N.fromId=w;function h(n,i){let u=n.id;const o=u.lastIndexOf("~");return o!==-1&&(u=u.substring(0,o)),i&&(u=`${u}~${i}`),{id:u}}N.modify=h;function f(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}N.getModifier=f;function a(n,i){return n.id===i.id&&n.color?.id===i.color?.id}N.isEqual=a})(R||(e.ThemeIcon=R={}))}),define(ke[176],Se([1,0,127,14,50]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=m,e.$Ok=A,e.$Pk=p,e.$Qk=y,e.$Rk=h,e.$Sk=f;const R="$(",N=new RegExp(`\\$\\(${O.ThemeIcon.iconNameExpression}(?:${O.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${N.source}`,"g");function m(a){return a.replace(b,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${N.source}`,"g");function A(a){return a.replace(E,n=>`\\${n}`)}const P=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function p(a){return a.indexOf(R)===-1?a:a.replace(P,(n,i,u,o)=>u?n:i||o||"")}function y(a){return a?a.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const w=new RegExp(`\\$\\(${O.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(a){w.lastIndex=0;let n="";const i=[];let u=0;for(;;){const o=w.lastIndex,t=w.exec(a),l=a.substring(o,t?.index);if(l.length>0){n+=l;for(let r=0;r<l.length;r++)i.push(u)}if(!t)break;u+=t[0].length}return{text:n,iconOffsets:i}}function f(a,n,i=!1){const{text:u,iconOffsets:o}=n;if(!o||o.length===0)return(0,d.$Ek)(a,u,i);const t=(0,L.$ff)(u," "),l=u.length-t.length,r=(0,d.$Ek)(a,t,i);if(r)for(const c of r){const s=o[c.start+l]+l;c.start+=s,c.end+=s}return r}}),define(ke[128],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$6e=L,e.$7e=O;var d;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(d||(e.Constants=d={}));function L(R){return R<0?0:R>255?255:R|0}function O(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(ke[30],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=L;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(O){return d.test(O)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(b){for(let m=0;m<b.length;m++)b[m]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),N=[];for(let b=0;b<256;b++)N.push(b.toString(16).padStart(2,"0"));return function(){O(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,E="";return E+=N[R[m++]],E+=N[R[m++]],E+=N[R[m++]],E+=N[R[m++]],E+="-",E+=N[R[m++]],E+=N[R[m++]],E+="-",E+=N[R[m++]],E+=N[R[m++]],E+="-",E+=N[R[m++]],E+=N[R[m++]],E+="-",E+=N[R[m++]],E+=N[R[m++]],E+=N[R[m++]],E+=N[R[m++]],E+=N[R[m++]],E+=N[R[m++]],E}}()}),define(ke[177],Se([1,0,19,39,30]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$St=void 0,e.$Qt=R,e.$Rt=N,e.$Tt=E;function R(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}function N(P,p,y){const w={id:(0,O.$Sg)(),name:P,uri:p,data:y};return{asString:async()=>"",asFile:()=>w,value:void 0}}class b{constructor(){this.a=new Map}get size(){let p=0;for(const y of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const y=[...this.a.keys()];return L.Iterable.some(this,([w,h])=>h.asFile())&&y.push("files"),A(m(p),y)}get(p){return this.a.get(this.b(p))?.[0]}append(p,y){const w=this.a.get(p);w?w.push(y):this.a.set(this.b(p),[y])}replace(p,y){this.a.set(this.b(p),[y])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,y]of this.a)for(const w of y)yield[p,w]}b(p){return m(p)}}e.$St=b;function m(P){return P.toLowerCase()}function E(P,p){return A(m(P),p.map(m))}function A(P,p){if(P==="*/*")return p.length>0;if(p.includes(P))return!0;const y=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[w,h,f]=y;return f==="*"?p.some(a=>a.startsWith(h+"/")):!1}e.$Ut=Object.freeze({create:P=>(0,d.$Mb)(P.map(p=>p.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$Ut.split(P).filter(p=>!p.startsWith("#"))})}),define(ke[178],Se([1,0,63]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=void 0,e.$Ug=L,e.$Wg=R;function L(b,m,E,A=1){let P=!1;return new Promise(p=>{const y=setTimeout(()=>{if(!P)return P=!0,p(0)},E);O(b,m,A,w=>{if(!P)return P=!0,clearTimeout(y),p(w)})})}function O(b,m,E,A){if(m===0)return A(0);const P=new d.Socket;P.once("connect",()=>(N(P),O(b+E,m-1,E,A))),P.once("data",()=>{}),P.once("error",p=>(N(P),p.code!=="ECONNREFUSED"?O(b+E,m-1,E,A):A(b))),P.connect(b,"127.0.0.1")}e.$Vg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,m,E,A="127.0.0.1"){let P=!1,p,y=1;const w=d.createServer({pauseOnConnect:!0});function h(f,a){P||(P=!0,w.removeAllListeners(),w.close(),p&&clearTimeout(p),a(f))}return new Promise(f=>{p=setTimeout(()=>{h(0,f)},E),w.on("listening",()=>{h(b,f)}),w.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&y<m?(b++,y++,w.listen(b,A)):h(0,f)}),w.on("close",()=>{h(0,f)}),w.listen(b,A)})}function N(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(m){console.error(m)}}}),define(ke[129],Se([1,0,128]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.$It=void 0;class L{constructor(b){const m=(0,d.$6e)(b);this.c=m,this.a=L.d(m),this.b=new Map}static d(b){const m=new Uint8Array(256);return m.fill(b),m}set(b,m){const E=(0,d.$6e)(m);b>=0&&b<256?this.a[b]=E:this.b.set(b,E)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$It=L;var O;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(O||(O={}));class R{constructor(){this.a=new L(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Jt=R}),define(ke[179],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$1t=L;var d;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(d||(e.StringEOL=d={}));function L(O){let R=0,N=0,b=0,m=0;for(let E=0,A=O.length;E<A;E++){const P=O.charCodeAt(E);P===13?(R===0&&(N=E),R++,E+1<A&&O.charCodeAt(E+1)===10?(m|=2,E++):m|=3,b=E+1):P===10&&(m|=1,R===0&&(N=E),R++,b=E+1)}return R===0&&(N=O.length),[R,N,O.length-b,m]}}),define(ke[51],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0;class d{constructor(O,R){this.lineNumber=O,this.column=R}with(O=this.lineNumber,R=this.column){return O===this.lineNumber&&R===this.column?this:new d(O,R)}delta(O=0,R=0){return this.with(this.lineNumber+O,this.column+R)}equals(O){return d.equals(this,O)}static equals(O,R){return!O&&!R?!0:!!O&&!!R&&O.lineNumber===R.lineNumber&&O.column===R.column}isBefore(O){return d.isBefore(this,O)}static isBefore(O,R){return O.lineNumber<R.lineNumber?!0:R.lineNumber<O.lineNumber?!1:O.column<R.column}isBeforeOrEqual(O){return d.isBeforeOrEqual(this,O)}static isBeforeOrEqual(O,R){return O.lineNumber<R.lineNumber?!0:R.lineNumber<O.lineNumber?!1:O.column<=R.column}static compare(O,R){const N=O.lineNumber|0,b=R.lineNumber|0;if(N===b){const m=O.column|0,E=R.column|0;return m-E}return N-b}clone(){return new d(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(O){return new d(O.lineNumber,O.column)}static isIPosition(O){return O&&typeof O.lineNumber=="number"&&typeof O.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$tt=d}),define(ke[29],Se([1,0,51]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0;class L{constructor(R,N,b,m){R>b||R===b&&N>m?(this.startLineNumber=b,this.startColumn=m,this.endLineNumber=R,this.endColumn=N):(this.startLineNumber=R,this.startColumn=N,this.endLineNumber=b,this.endColumn=m)}isEmpty(){return L.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return L.containsPosition(this,R)}static containsPosition(R,N){return!(N.lineNumber<R.startLineNumber||N.lineNumber>R.endLineNumber||N.lineNumber===R.startLineNumber&&N.column<R.startColumn||N.lineNumber===R.endLineNumber&&N.column>R.endColumn)}static strictContainsPosition(R,N){return!(N.lineNumber<R.startLineNumber||N.lineNumber>R.endLineNumber||N.lineNumber===R.startLineNumber&&N.column<=R.startColumn||N.lineNumber===R.endLineNumber&&N.column>=R.endColumn)}containsRange(R){return L.containsRange(this,R)}static containsRange(R,N){return!(N.startLineNumber<R.startLineNumber||N.endLineNumber<R.startLineNumber||N.startLineNumber>R.endLineNumber||N.endLineNumber>R.endLineNumber||N.startLineNumber===R.startLineNumber&&N.startColumn<R.startColumn||N.endLineNumber===R.endLineNumber&&N.endColumn>R.endColumn)}strictContainsRange(R){return L.strictContainsRange(this,R)}static strictContainsRange(R,N){return!(N.startLineNumber<R.startLineNumber||N.endLineNumber<R.startLineNumber||N.startLineNumber>R.endLineNumber||N.endLineNumber>R.endLineNumber||N.startLineNumber===R.startLineNumber&&N.startColumn<=R.startColumn||N.endLineNumber===R.endLineNumber&&N.endColumn>=R.endColumn)}plusRange(R){return L.plusRange(this,R)}static plusRange(R,N){let b,m,E,A;return N.startLineNumber<R.startLineNumber?(b=N.startLineNumber,m=N.startColumn):N.startLineNumber===R.startLineNumber?(b=N.startLineNumber,m=Math.min(N.startColumn,R.startColumn)):(b=R.startLineNumber,m=R.startColumn),N.endLineNumber>R.endLineNumber?(E=N.endLineNumber,A=N.endColumn):N.endLineNumber===R.endLineNumber?(E=N.endLineNumber,A=Math.max(N.endColumn,R.endColumn)):(E=R.endLineNumber,A=R.endColumn),new L(b,m,E,A)}intersectRanges(R){return L.intersectRanges(this,R)}static intersectRanges(R,N){let b=R.startLineNumber,m=R.startColumn,E=R.endLineNumber,A=R.endColumn;const P=N.startLineNumber,p=N.startColumn,y=N.endLineNumber,w=N.endColumn;return b<P?(b=P,m=p):b===P&&(m=Math.max(m,p)),E>y?(E=y,A=w):E===y&&(A=Math.min(A,w)),b>E||b===E&&m>A?null:new L(b,m,E,A)}equalsRange(R){return L.equalsRange(this,R)}static equalsRange(R,N){return!R&&!N?!0:!!R&&!!N&&R.startLineNumber===N.startLineNumber&&R.startColumn===N.startColumn&&R.endLineNumber===N.endLineNumber&&R.endColumn===N.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(R){return new d.$tt(R.endLineNumber,R.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(R){return new d.$tt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,N){return new L(this.startLineNumber,this.startColumn,R,N)}setStartPosition(R,N){return new L(R,N,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(R){return new L(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(R){return new L(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new L(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,N=R){return new L(R.lineNumber,R.column,N.lineNumber,N.column)}static lift(R){return R?new L(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,N){return!(R.endLineNumber<N.startLineNumber||R.endLineNumber===N.startLineNumber&&R.endColumn<N.startColumn||N.endLineNumber<R.startLineNumber||N.endLineNumber===R.startLineNumber&&N.endColumn<R.startColumn)}static areIntersecting(R,N){return!(R.endLineNumber<N.startLineNumber||R.endLineNumber===N.startLineNumber&&R.endColumn<=N.startColumn||N.endLineNumber<R.startLineNumber||N.endLineNumber===R.startLineNumber&&N.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,N){if(R&&N){const E=R.startLineNumber|0,A=N.startLineNumber|0;if(E===A){const P=R.startColumn|0,p=N.startColumn|0;if(P===p){const y=R.endLineNumber|0,w=N.endLineNumber|0;if(y===w){const h=R.endColumn|0,f=N.endColumn|0;return h-f}return y-w}return P-p}return E-A}return(R?1:0)-(N?1:0)}static compareRangesUsingEnds(R,N){return R.endLineNumber===N.endLineNumber?R.endColumn===N.endColumn?R.startLineNumber===N.startLineNumber?R.startColumn-N.startColumn:R.startLineNumber-N.startLineNumber:R.endColumn-N.endColumn:R.endLineNumber-N.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$ut=L}),define(ke[180],Se([1,0,29]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class L{static insert(R,N){return{range:new d.$ut(R.lineNumber,R.column,R.lineNumber,R.column),text:N,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,N){return{range:R,text:N}}static replaceMove(R,N){return{range:R,text:N,forceMoveMarkers:!0}}}e.$vt=L}),define(ke[181],Se([1,0,51,29]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.SelectionDirection=void 0;var O;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(O||(e.SelectionDirection=O={}));class R extends L.$ut{constructor(b,m,E,A){super(b,m,E,A),this.selectionStartLineNumber=b,this.selectionStartColumn=m,this.positionLineNumber=E,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return R.selectionsEqual(this,b)}static selectionsEqual(b,m){return b.selectionStartLineNumber===m.selectionStartLineNumber&&b.selectionStartColumn===m.selectionStartColumn&&b.positionLineNumber===m.positionLineNumber&&b.positionColumn===m.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,m){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,b,m):new R(b,m,this.startLineNumber,this.startColumn)}getPosition(){return new d.$tt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new d.$tt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,m){return this.getDirection()===0?new R(b,m,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,b,m)}static fromPositions(b,m=b){return new R(b.lineNumber,b.column,m.lineNumber,m.column)}static fromRange(b,m){return m===0?new R(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new R(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new R(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,m){if(b&&!m||!b&&m)return!1;if(!b&&!m)return!0;if(b.length!==m.length)return!1;for(let E=0,A=b.length;E<A;E++)if(!this.selectionsEqual(b[E],m[E]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,m,E,A,P){return P===0?new R(b,m,E,A):new R(E,A,b,m)}}e.$wt=R}),define(ke[182],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$4s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[183],Se([1,0,27,129]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.WordCharacterClass=void 0,e.$Lt=b;var O;(function(m){m[m.Regular=0]="Regular",m[m.Whitespace=1]="Whitespace",m[m.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class R extends L.$It{constructor(E,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let P=0,p=E.length;P<p;P++)this.set(E.charCodeAt(P),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(E,A){let P=null;for(const p of this.h(E)){if(p.index>A)break;P=p}return P}findNextIntlWordAtOrAfterOffset(E,A){for(const P of this.h(E))if(!(P.index<A))return P;return null}h(E){return this.e?this.f===E?this.g:(this.f=E,this.g=this.j(this.e.segment(E)),this.g):[]}j(E){const A=[];for(const P of E)this.k(P)&&A.push(P);return A}k(E){return!!E.isWordLike}}e.$Kt=R;const N=new d.$Ec(10);function b(m,E){const A=`${m}/${E.join(",")}`;let P=N.get(A);return P||(P=new R(m,E),N.set(A,P)),P}}),define(ke[130],Se([1,0,39,3,76]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.$5s=void 0,e.$7s=N,e.$8s=m,e.$9s=E,e.$5s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$5s)P.indexOf(y)>=0||(p+="\\"+y);return p+="\\s]+)",new RegExp(p,"g")}e.$6s=R();function N(P){let p=e.$6s;if(P&&P instanceof RegExp)if(P.global)p=P;else{let y="g";P.ignoreCase&&(y+="i"),P.multiline&&(y+="m"),P.unicode&&(y+="u"),p=new RegExp(P.source,y)}return p.lastIndex=0,p}const b=new O.$6c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function m(P){const p=b.unshift(P);return(0,L.$Tc)(p)}function E(P,p,y,w,h){if(p=N(p),h||(h=d.Iterable.first(b)),y.length>h.maxLen){let u=P-h.maxLen/2;return u<0?u=0:w+=u,y=y.substring(u,P+h.maxLen/2),E(P,p,y,w,h)}const f=Date.now(),a=P-1-w;let n=-1,i=null;for(let u=1;!(Date.now()-f>=h.timeBudget);u++){const o=a-h.windowSize*u;p.lastIndex=Math.max(0,o);const t=A(p,y,a,n);if(!t&&i||(i=t,o<=0))break;n=o}if(i){const u={word:i[0],startColumn:w+1+i.index,endColumn:w+1+i.index+i[0].length};return p.lastIndex=0,u}return null}function A(P,p,y,w){let h;for(;h=P.exec(p);){const f=h.index||0;if(f<=y&&P.lastIndex>=y)return h;if(w>0&&f>w)return null}return null}}),define(ke[184],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=e.IndentAction=void 0;var d;(function(N){N[N.None=0]="None",N[N.Indent=1]="Indent",N[N.IndentOutdent=2]="IndentOutdent",N[N.Outdent=3]="Outdent"})(d||(e.IndentAction=d={}));class L{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let m=0,E=b.notIn.length;m<E;m++)switch(b.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,m){if(b.getTokenCount()===0)return!0;const E=b.findTokenIndexAtOffset(m-2),A=b.getStandardTokenType(E);return this.isOK(A)}g(b,m){for(let E=b;E<=m;E++){const A=String.fromCharCode(E);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ku=L;class O{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of b)R(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),R(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),R(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),R(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&R(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$lu=O;function R(N,b,m){N.has(b)?N.get(b).push(m):N.set(b,[m])}}),define(ke[185],Se([1,0,129]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m3=e.$l3=e.State=void 0,e.$n3=p;var L;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(L||(e.State=L={}));class O{constructor(w,h,f){const a=new Uint8Array(w*h);for(let n=0,i=w*h;n<i;n++)a[n]=f;this.a=a,this.rows=w,this.cols=h}get(w,h){return this.a[w*this.cols+h]}set(w,h,f){this.a[w*this.cols+h]=f}}class R{constructor(w){let h=0,f=0;for(let n=0,i=w.length;n<i;n++){const[u,o,t]=w[n];o>h&&(h=o),u>f&&(f=u),t>f&&(f=t)}h++,f++;const a=new O(f,h,0);for(let n=0,i=w.length;n<i;n++){const[u,o,t]=w[n];a.set(u,o,t)}this.a=a,this.b=h}nextState(w,h){return h<0||h>=this.b?0:this.a.get(w,h)}}e.$l3=R;let N=null;function b(){return N===null&&(N=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var m;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(m||(m={}));let E=null;function A(){if(E===null){E=new d.$It(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<y.length;h++)E.set(y.charCodeAt(h),1);const w=".,;:";for(let h=0;h<w.length;h++)E.set(w.charCodeAt(h),2)}return E}class P{static a(w,h,f,a,n){let i=n-1;do{const u=h.charCodeAt(i);if(w.get(u)!==2)break;i--}while(i>a);if(a>0){const u=h.charCodeAt(a-1),o=h.charCodeAt(i);(u===40&&o===41||u===91&&o===93||u===123&&o===125)&&i--}return{range:{startLineNumber:f,startColumn:a+1,endLineNumber:f,endColumn:i+2},url:h.substring(a,i+1)}}static computeLinks(w,h=b()){const f=A(),a=[];for(let n=1,i=w.getLineCount();n<=i;n++){const u=w.getLineContent(n),o=u.length;let t=0,l=0,r=0,c=1,s=!1,v=!1,g=!1,D=!1;for(;t<o;){let $=!1;const k=u.charCodeAt(t);if(c===13){let S;switch(k){case 40:s=!0,S=0;break;case 41:S=s?0:1;break;case 91:g=!0,v=!0,S=0;break;case 93:g=!1,S=v?0:1;break;case 123:D=!0,S=0;break;case 125:S=D?0:1;break;case 39:case 34:case 96:r===k?S=1:r===39||r===34||r===96?S=0:S=1;break;case 42:S=r===42?1:0;break;case 124:S=r===124?1:0;break;case 32:S=g?0:1;break;default:S=f.get(k)}S===1&&(a.push(P.a(f,u,n,l,t)),$=!0)}else if(c===12){let S;k===91?(v=!0,S=0):S=f.get(k),S===1?$=!0:c=13}else c=h.nextState(c,k),c===0&&($=!0);$&&(c=1,s=!1,v=!1,D=!1,l=t+1,r=k),t++}c===13&&a.push(P.a(f,u,n,l,o))}return a}}e.$m3=P;function p(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:P.computeLinks(y)}}),define(ke[80],Se([1,0,24]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.$Hv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$Fv=e.$Ev=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$Gv=w,e.$Kv=u;var L;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(L||(e.OverviewRulerLane=L={}));var O;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=3]="Right"})(O||(e.GlyphMarginLane=O={}));var R;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var N;(function(o){o[o.Normal=1]="Normal",o[o.Underlined=2]="Underlined"})(N||(e.MinimapSectionHeaderStyle=N={}));var b;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var m;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var E;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var A;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,d.$7n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$Ev=P;class p{constructor(t,l){this._findMatchBrand=void 0,this.range=t,this.matches=l}}e.$Fv=p;var y;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y||(e.TrackedRangeStickiness=y={}));function w(o){return o&&typeof o.read=="function"}var h;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(h||(e.PositionAffinity=h={}));var f;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(f||(e.ModelConstants=f={}));class a{constructor(t,l,r,c,s,v){this.identifier=t,this.range=l,this.text=r,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=s,this._isTracked=v}}e.$Hv=a;class n{constructor(t,l,r){this.regex=t,this.wordSeparators=l,this.simpleSearch=r}}e.$Iv=n;class i{constructor(t,l,r){this.reverseEdits=t,this.changes=l,this.trimAutoWhitespaceLineNumbers=r}}e.$Jv=i;function u(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}}),define(ke[186],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AC=e.NodeColor=e.$zC=void 0,e.$BC=O,e.$CC=R,e.$DC=E,e.$EC=A,e.$FC=P,e.$GC=p,e.$HC=y,e.$IC=w;class d{constructor(f,a){this.piece=f,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$AC)return O(this.right);let f=this;for(;f.parent!==e.$AC&&f.parent.left!==f;)f=f.parent;return f.parent===e.$AC?e.$AC:f.parent}prev(){if(this.left!==e.$AC)return R(this.left);let f=this;for(;f.parent!==e.$AC&&f.parent.right!==f;)f=f.parent;return f.parent===e.$AC?e.$AC:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$zC=d;var L;(function(h){h[h.Black=0]="Black",h[h.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$AC=new d(null,0),e.$AC.parent=e.$AC,e.$AC.left=e.$AC,e.$AC.right=e.$AC,e.$AC.color=0;function O(h){for(;h.left!==e.$AC;)h=h.left;return h}function R(h){for(;h.right!==e.$AC;)h=h.right;return h}function N(h){return h===e.$AC?0:h.size_left+h.piece.length+N(h.right)}function b(h){return h===e.$AC?0:h.lf_left+h.piece.lineFeedCnt+b(h.right)}function m(){e.$AC.parent=e.$AC}function E(h,f){const a=f.right;a.size_left+=f.size_left+(f.piece?f.piece.length:0),a.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=a.left,a.left!==e.$AC&&(a.left.parent=f),a.parent=f.parent,f.parent===e.$AC?h.root=a:f.parent.left===f?f.parent.left=a:f.parent.right=a,a.left=f,f.parent=a}function A(h,f){const a=f.left;f.left=a.right,a.right!==e.$AC&&(a.right.parent=f),a.parent=f.parent,f.size_left-=a.size_left+(a.piece?a.piece.length:0),f.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),f.parent===e.$AC?h.root=a:f===f.parent.right?f.parent.right=a:f.parent.left=a,a.right=f,f.parent=a}function P(h,f){let a,n;if(f.left===e.$AC?(n=f,a=n.right):f.right===e.$AC?(n=f,a=n.left):(n=O(f.right),a=n.right),n===h.root){h.root=a,a.color=0,f.detach(),m(),h.root.parent=e.$AC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=a:n.parent.right=a,n===f?(a.parent=n.parent,w(h,a)):(n.parent===f?a.parent=n:a.parent=n.parent,w(h,a),n.left=f.left,n.right=f.right,n.parent=f.parent,n.color=f.color,f===h.root?h.root=n:f===f.parent.left?f.parent.left=n:f.parent.right=n,n.left!==e.$AC&&(n.left.parent=n),n.right!==e.$AC&&(n.right.parent=n),n.size_left=f.size_left,n.lf_left=f.lf_left,w(h,n)),f.detach(),a.parent.left===a){const o=N(a),t=b(a);if(o!==a.parent.size_left||t!==a.parent.lf_left){const l=o-a.parent.size_left,r=t-a.parent.lf_left;a.parent.size_left=o,a.parent.lf_left=t,y(h,a.parent,l,r)}}if(w(h,a.parent),i){m();return}let u;for(;a!==h.root&&a.color===0;)a===a.parent.left?(u=a.parent.right,u.color===1&&(u.color=0,a.parent.color=1,E(h,a.parent),u=a.parent.right),u.left.color===0&&u.right.color===0?(u.color=1,a=a.parent):(u.right.color===0&&(u.left.color=0,u.color=1,A(h,u),u=a.parent.right),u.color=a.parent.color,a.parent.color=0,u.right.color=0,E(h,a.parent),a=h.root)):(u=a.parent.left,u.color===1&&(u.color=0,a.parent.color=1,A(h,a.parent),u=a.parent.left),u.left.color===0&&u.right.color===0?(u.color=1,a=a.parent):(u.left.color===0&&(u.right.color=0,u.color=1,E(h,u),u=a.parent.left),u.color=a.parent.color,a.parent.color=0,u.left.color=0,A(h,a.parent),a=h.root));a.color=0,m()}function p(h,f){for(w(h,f);f!==h.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const a=f.parent.parent.right;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,E(h,f)),f.parent.color=0,f.parent.parent.color=1,A(h,f.parent.parent))}else{const a=f.parent.parent.left;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,A(h,f)),f.parent.color=0,f.parent.parent.color=1,E(h,f.parent.parent))}h.root.color=0}function y(h,f,a,n){for(;f!==h.root&&f!==e.$AC;)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=n),f=f.parent}function w(h,f){let a=0,n=0;if(f!==h.root){for(;f!==h.root&&f===f.parent.right;)f=f.parent;if(f!==h.root)for(f=f.parent,a=N(f.left)-f.size_left,n=b(f.left)-f.lf_left,f.size_left+=a,f.lf_left+=n;f!==h.root&&(a!==0||n!==0);)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=n),f=f.parent}}}),define(ke[187],Se([1,0,19,128]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yv=e.$Xv=e.$Wv=void 0;class O{constructor(m){this.a=m,this.b=new Uint32Array(m.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(m,E){m=(0,L.$7e)(m);const A=this.a,P=this.b,p=E.length;return p===0?!1:(this.a=new Uint32Array(A.length+p),this.a.set(A.subarray(0,m),0),this.a.set(A.subarray(m),m+p),this.a.set(E,m),m-1<this.c[0]&&(this.c[0]=m-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(m,E){return m=(0,L.$7e)(m),E=(0,L.$7e)(E),this.a[m]===E?!1:(this.a[m]=E,m-1<this.c[0]&&(this.c[0]=m-1),!0)}removeValues(m,E){m=(0,L.$7e)(m),E=(0,L.$7e)(E);const A=this.a,P=this.b;if(m>=A.length)return!1;const p=A.length-m;return E>=p&&(E=p),E===0?!1:(this.a=new Uint32Array(A.length-E),this.a.set(A.subarray(0,m),0),this.a.set(A.subarray(m+E),m),this.b=new Uint32Array(this.a.length),m-1<this.c[0]&&(this.c[0]=m-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(m){return m<0?0:(m=(0,L.$7e)(m),this.d(m))}d(m){if(m<=this.c[0])return this.b[m];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),m>=this.a.length&&(m=this.a.length-1);for(let A=E;A<=m;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],m),this.b[m]}getIndexOf(m){m=Math.floor(m),this.getTotalSum();let E=0,A=this.a.length-1,P=0,p=0,y=0;for(;E<=A;)if(P=E+(A-E)/2|0,p=this.b[P],y=p-this.a[P],m<y)A=P-1;else if(m>=p)E=P+1;else break;return new N(P,m-y)}}e.$Wv=O;class R{constructor(m){this.a=m,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(m){return this.g(),m===0?0:this.d[m-1]}getIndexOf(m){this.g();const E=this.e[m],A=E>0?this.d[E-1]:0;return new N(E,m-A)}removeValues(m,E){this.a.splice(m,E),this.f(m)}insertValues(m,E){this.a=(0,d.$Wb)(this.a,m,E),this.f(m)}f(m){this.b=!1,this.c=Math.min(this.c,m-1)}g(){if(!this.b){for(let m=this.c+1,E=this.a.length;m<E;m++){const A=this.a[m],P=m>0?this.d[m-1]:0;this.d[m]=P+A;for(let p=0;p<A;p++)this.e[P+p]=m}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(m,E){this.a[m]!==E&&(this.a[m]=E,this.f(m))}}e.$Xv=R;class N{constructor(m,E){this.index=m,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=m,this.remainder=E}}e.$Yv=N}),define(ke[188],Se([1,0,14,51,187]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zv=void 0;class R{constructor(b,m,E,A){this.d=b,this.f=m,this.g=E,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const m=b.changes;for(const E of m)this.o(E.range),this.p(new L.$tt(E.range.startLineNumber,E.range.startColumn),E.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,m=this.f.length,E=new Uint32Array(m);for(let A=0;A<m;A++)E[A]=this.f[A].length+b;this.j=new O.$Wv(E)}}n(b,m){this.f[b]=m,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,m){if(m.length===0)return;const E=(0,d.$lf)(m);if(E.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]+this.f[b.lineNumber-1].substring(b.column-1));return}E[E.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]);const A=new Uint32Array(E.length-1);for(let P=1;P<E.length;P++)this.f.splice(b.lineNumber+P-1,0,E[P]),A[P-1]=E[P].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$Zv=R}),define(ke[100],Se([1,0,14,183,51,29,80]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OC=e.$MC=e.$JC=void 0,e.$KC=E,e.$LC=A,e.$NC=h;const b=999;class m{constructor(n,i,u,o){this.searchString=n,this.isRegex=i,this.matchCase=u,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=E(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=d.$jf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let u=!this.isRegex&&!n;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new N.$Iv(i,this.wordSeparators?(0,L.$Lt)(this.wordSeparators,[]):null,u?this.searchString:null)}}e.$JC=m;function E(a){if(!a||a.length===0)return!1;for(let n=0,i=a.length;n<i;n++){const u=a.charCodeAt(n);if(u===10)return!0;if(u===92){if(n++,n>=i)break;const o=a.charCodeAt(n);if(o===110||o===114||o===87)return!0}}return!1}function A(a,n,i){if(!i)return new N.$Fv(a,null);const u=[];for(let o=0,t=n.length;o<t;o++)u[o]=n[o];return new N.$Fv(a,u)}class P{constructor(n){const i=[];let u=0;for(let o=0,t=n.length;o<t;o++)n.charCodeAt(o)===10&&(i[u++]=o);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let u=0,o=i.length-1;if(o===-1||n<=i[0])return 0;for(;u<o;){const t=u+((o-u)/2>>0);i[t]>=n?o=t-1:i[t+1]>=n?(u=t,o=t):u=t+1}return u+1}}class p{static findMatches(n,i,u,o,t){const l=i.parseSearchRequest();return l?l.regex.multiline?this.b(n,u,new f(l.wordSeparators,l.regex),o,t):this.c(n,u,l,o,t):[]}static a(n,i,u,o,t,l){let r,c=0;o?(c=o.findLineFeedCountBeforeOffset(t),r=i+t+c):r=i+t;let s;if(o){const $=o.findLineFeedCountBeforeOffset(t+l.length)-c;s=r+l.length+$}else s=r+l.length;const v=n.getPositionAt(r),g=n.getPositionAt(s);return new R.$ut(v.lineNumber,v.column,g.lineNumber,g.column)}static b(n,i,u,o,t){const l=n.getOffsetAt(i.getStartPosition()),r=n.getValueInRange(i,1),c=n.getEOL()===`\r
`?new P(r):null,s=[];let v=0,g;for(u.reset(0);g=u.next(r);)if(s[v++]=A(this.a(n,l,r,c,g.index,g[0]),g,o),v>=t)return s;return s}static c(n,i,u,o,t){const l=[];let r=0;if(i.startLineNumber===i.endLineNumber){const s=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return r=this.d(u,s,i.startLineNumber,i.startColumn-1,r,l,o,t),l}const c=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);r=this.d(u,c,i.startLineNumber,i.startColumn-1,r,l,o,t);for(let s=i.startLineNumber+1;s<i.endLineNumber&&r<t;s++)r=this.d(u,n.getLineContent(s),s,0,r,l,o,t);if(r<t){const s=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);r=this.d(u,s,i.endLineNumber,0,r,l,o,t)}return l}static d(n,i,u,o,t,l,r,c){const s=n.wordSeparators;if(!r&&n.simpleSearch){const D=n.simpleSearch,$=D.length,k=i.length;let S=-$;for(;(S=i.indexOf(D,S+$))!==-1;)if((!s||h(s,i,k,S,$))&&(l[t++]=new N.$Fv(new R.$ut(u,S+1+o,u,S+1+$+o),null),t>=c))return t;return t}const v=new f(n.wordSeparators,n.regex);let g;v.reset(0);do if(g=v.next(i),g&&(l[t++]=A(new R.$ut(u,g.index+1+o,u,g.index+1+g[0].length+o),g,r),t>=c))return t;while(g);return t}static findNextMatch(n,i,u,o){const t=i.parseSearchRequest();if(!t)return null;const l=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,u,l,o):this.f(n,u,l,o)}static e(n,i,u,o){const t=new O.$tt(i.lineNumber,1),l=n.getOffsetAt(t),r=n.getLineCount(),c=n.getValueInRange(new R.$ut(t.lineNumber,t.column,r,n.getLineMaxColumn(r)),1),s=n.getEOL()===`\r
`?new P(c):null;u.reset(i.column-1);const v=u.next(c);return v?A(this.a(n,l,c,s,v.index,v[0]),v,o):i.lineNumber!==1||i.column!==1?this.e(n,new O.$tt(1,1),u,o):null}static f(n,i,u,o){const t=n.getLineCount(),l=i.lineNumber,r=n.getLineContent(l),c=this.g(u,r,l,i.column,o);if(c)return c;for(let s=1;s<=t;s++){const v=(l+s-1)%t,g=n.getLineContent(v+1),D=this.g(u,g,v+1,1,o);if(D)return D}return null}static g(n,i,u,o,t){n.reset(o-1);const l=n.next(i);return l?A(new R.$ut(u,l.index+1,u,l.index+1+l[0].length),l,t):null}static findPreviousMatch(n,i,u,o){const t=i.parseSearchRequest();if(!t)return null;const l=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,u,l,o):this.j(n,u,l,o)}static h(n,i,u,o){const t=this.b(n,new R.$ut(1,1,i.lineNumber,i.column),u,o,10*b);if(t.length>0)return t[t.length-1];const l=n.getLineCount();return i.lineNumber!==l||i.column!==n.getLineMaxColumn(l)?this.h(n,new O.$tt(l,n.getLineMaxColumn(l)),u,o):null}static j(n,i,u,o){const t=n.getLineCount(),l=i.lineNumber,r=n.getLineContent(l).substring(0,i.column-1),c=this.k(u,r,l,o);if(c)return c;for(let s=1;s<=t;s++){const v=(t+l-s-1)%t,g=n.getLineContent(v+1),D=this.k(u,g,v+1,o);if(D)return D}return null}static k(n,i,u,o){let t=null,l;for(n.reset(0);l=n.next(i);)t=A(new R.$ut(u,l.index+1,u,l.index+1+l[0].length),l,o);return t}}e.$MC=p;function y(a,n,i,u,o){if(u===0)return!0;const t=n.charCodeAt(u-1);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const l=n.charCodeAt(u);if(a.get(l)!==0)return!0}return!1}function w(a,n,i,u,o){if(u+o===i)return!0;const t=n.charCodeAt(u+o);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const l=n.charCodeAt(u+o-1);if(a.get(l)!==0)return!0}return!1}function h(a,n,i,u,o){return y(a,n,i,u,o)&&w(a,n,i,u,o)}class f{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let u;do{if(this.b+this.c===i||(u=this.a.exec(n),!u))return null;const o=u.index,t=u[0].length;if(o===this.b&&t===this.c){if(t===0){d.$Ff(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||h(this._wordSeparators,n,i,o,t))return u}while(u);return null}}e.$OC=f}),define(ke[131],Se([1,0,51,29,80,186,100]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=e.$SC=e.$RC=void 0,e.$PC=A,e.$QC=P;const b=65535;function m(a){let n;return a[a.length-1]<65536?n=new Uint16Array(a.length):n=new Uint32Array(a.length),n.set(a,0),n}class E{constructor(n,i,u,o,t){this.lineStarts=n,this.cr=i,this.lf=u,this.crlf=o,this.isBasicASCII=t}}function A(a,n=!0){const i=[0];let u=1;for(let o=0,t=a.length;o<t;o++){const l=a.charCodeAt(o);l===13?o+1<t&&a.charCodeAt(o+1)===10?(i[u++]=o+2,o++):i[u++]=o+1:l===10&&(i[u++]=o+1)}return n?m(i):i}function P(a,n){a.length=0,a[0]=0;let i=1,u=0,o=0,t=0,l=!0;for(let c=0,s=n.length;c<s;c++){const v=n.charCodeAt(c);v===13?c+1<s&&n.charCodeAt(c+1)===10?(t++,a[i++]=c+2,c++):(u++,a[i++]=c+1):v===10?(o++,a[i++]=c+1):l&&v!==9&&(v<32||v>126)&&(l=!1)}const r=new E(m(a),u,o,t,l);return a.length=0,r}class p{constructor(n,i,u,o,t){this.bufferIndex=n,this.start=i,this.end=u,this.lineFeedCnt=o,this.length=t}}e.$RC=p;class y{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$SC=y;class w{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$AC&&n.iterate(n.root,u=>(u!==R.$AC&&this.a.push(u.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class h{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const u=this.b[i];if(u.nodeStartOffset<=n&&u.nodeStartOffset+u.node.piece.length>=n)return u}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const u=this.b[i];if(u.nodeStartLineNumber&&u.nodeStartLineNumber<n&&u.nodeStartLineNumber+u.node.piece.lineFeedCnt>=n)return u}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const u=this.b;for(let o=0;o<u.length;o++){const t=u[o];if(t.node.parent===null||t.nodeStartOffset>=n){u[o]=null,i=!0;continue}}if(i){const o=[];for(const t of u)t!==null&&o.push(t);this.b=o}}}class f{constructor(n,i,u){this.create(n,i,u)}create(n,i,u){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=R.$AC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=u;let o=null;for(let t=0,l=n.length;t<l;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const r=new p(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),o=this.S(o,r)}this.h=new h(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,u=i-Math.floor(i/3),o=u*2;let t="",l=0;const r=[];if(this.iterate(this.root,c=>{const s=this.R(c),v=s.length;if(l<=u||l+v<o)return t+=s,l+=v,!0;const g=t.replace(/\r\n|\r|\n/g,n);return r.push(new y(g,A(g))),t=s,l=v,!0}),l>0){const c=t.replace(/\r\n|\r|\n/g,n);r.push(new y(c,A(c)))}this.create(r,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new w(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,o=>{if(o===R.$AC)return!0;const t=this.R(o),l=t.length,r=n.G(i),c=n.G(i+l),s=n.getValueInRange2(r,c);return i+=l,t===s})}getOffsetAt(n,i){let u=0,o=this.root;for(;o!==R.$AC;)if(o.left!==R.$AC&&o.lf_left+1>=n)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=n){u+=o.size_left;const t=this.B(o,n-o.lf_left-2);return u+=t+i-1}else n-=o.lf_left+o.piece.lineFeedCnt,u+=o.size_left+o.piece.length,o=o.right;return u}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,u=0;const o=n;for(;i!==R.$AC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(u+=i.lf_left+t.index,t.index===0){const l=this.getOffsetAt(u+1,1),r=o-l;return new d.$tt(u+1,r+1)}return new d.$tt(u+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,u+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$AC){const t=this.getOffsetAt(u+1,1),l=o-n-t;return new d.$tt(u+1,l+1)}else i=i.right;return new d.$tt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const u=this.H(n.startLineNumber,n.startColumn),o=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(u,o);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const r=n.node,c=this.a[r.piece.bufferIndex].buffer,s=this.u(r.piece.bufferIndex,r.piece.start);return c.substring(s+n.remainder,s+i.remainder)}let u=n.node;const o=this.a[u.piece.bufferIndex].buffer,t=this.u(u.piece.bufferIndex,u.piece.start);let l=o.substring(t+n.remainder,t+u.piece.length);for(u=u.next();u!==R.$AC;){const r=this.a[u.piece.bufferIndex].buffer,c=this.u(u.piece.bufferIndex,u.piece.start);if(u===i.node){l+=r.substring(c,c+i.remainder);break}else l+=r.substr(c,u.piece.length);u=u.next()}return l}getLinesContent(){const n=[];let i=0,u="",o=!1;return this.iterate(this.root,t=>{if(t===R.$AC)return!0;const l=t.piece;let r=l.length;if(r===0)return!0;const c=this.a[l.bufferIndex].buffer,s=this.a[l.bufferIndex].lineStarts,v=l.start.line,g=l.end.line;let D=s[v]+l.start.column;if(o&&(c.charCodeAt(D)===10&&(D++,r--),n[i++]=u,u="",o=!1,r===0))return!0;if(v===g)return!this.f&&c.charCodeAt(D+r-1)===13?(o=!0,u+=c.substr(D,r-1)):u+=c.substr(D,r),!0;u+=this.f?c.substring(D,Math.max(D,s[v+1]-this.e)):c.substring(D,s[v+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=u;for(let $=v+1;$<g;$++)u=this.f?c.substring(s[$],s[$+1]-this.e):c.substring(s[$],s[$+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=u;return!this.f&&c.charCodeAt(s[g]+l.end.column-1)===13?(o=!0,l.end.column===0?i--:u=c.substr(s[g],l.end.column-1)):u=c.substr(s[g],l.end.column),!0}),o&&(n[i++]=u,u=""),n[i++]=u,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const u=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start);return u.buffer.charCodeAt(o)}else{const i=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(o)}}getLineCharCode(n,i){const u=this.H(n,i+1);return this.l(u)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,u,o,t,l,r,c,s,v,g){const D=this.a[n.piece.bufferIndex],$=this.u(n.piece.bufferIndex,n.piece.start),k=this.u(n.piece.bufferIndex,t),S=this.u(n.piece.bufferIndex,l);let C;const I={line:0,column:0};let F,j;i._wordSeparators?(F=D.buffer.substring(k,S),j=z=>z+k,i.reset(0)):(F=D.buffer,j=z=>z,i.reset(k));do if(C=i.next(F),C){if(j(C.index)>=S)return v;this.s(n,j(C.index)-$,I);const z=this.t(n.piece.bufferIndex,t,I),M=I.line===t.line?I.column-t.column+o:I.column+1,T=M+C[0].length;if(g[v++]=(0,N.$LC)(new L.$ut(u+z,M,u+z,T),C,c),j(C.index)+C[0].length>=S||v>=s)return v}while(C);return v}findMatchesLineByLine(n,i,u,o){const t=[];let l=0;const r=new N.$OC(i.wordSeparators,i.regex);let c=this.H(n.startLineNumber,n.startColumn);if(c===null)return[];const s=this.H(n.endLineNumber,n.endColumn);if(s===null)return[];let v=this.s(c.node,c.remainder);const g=this.s(s.node,s.remainder);if(c.node===s.node)return this.findMatchesInNode(c.node,r,n.startLineNumber,n.startColumn,v,g,i,u,o,l,t),t;let D=n.startLineNumber,$=c.node;for(;$!==s.node;){const S=this.t($.piece.bufferIndex,v,$.piece.end);if(S>=1){const I=this.a[$.piece.bufferIndex].lineStarts,F=this.u($.piece.bufferIndex,$.piece.start),j=I[v.line+S],z=D===n.startLineNumber?n.startColumn:1;if(l=this.findMatchesInNode($,r,D,z,v,this.s($,j-F),i,u,o,l,t),l>=o)return t;D+=S}const C=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const I=this.getLineContent(D).substring(C,n.endColumn-1);return l=this.n(i,r,I,n.endLineNumber,C,l,t,u,o),t}if(l=this.n(i,r,this.getLineContent(D).substr(C),D,C,l,t,u,o),l>=o)return t;D++,c=this.H(D,1),$=c.node,v=this.s(c.node,c.remainder)}if(D===n.endLineNumber){const S=D===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(D).substring(S,n.endColumn-1);return l=this.n(i,r,C,n.endLineNumber,S,l,t,u,o),t}const k=D===n.startLineNumber?n.startColumn:1;return l=this.findMatchesInNode(s.node,r,D,k,v,g,i,u,o,l,t),t}n(n,i,u,o,t,l,r,c,s){const v=n.wordSeparators;if(!c&&n.simpleSearch){const D=n.simpleSearch,$=D.length,k=u.length;let S=-$;for(;(S=u.indexOf(D,S+$))!==-1;)if((!v||(0,N.$NC)(v,u,k,S,$))&&(r[l++]=new O.$Fv(new L.$ut(o,S+1+t,o,S+1+$+t),null),l>=s))return l;return l}let g;i.reset(0);do if(g=i.next(u),g&&(r[l++]=(0,N.$LC)(new L.$ut(o,g.index+1+t,o,g.index+1+g[0].length+t),g,c),l>=s))return l;while(g);return l}insert(n,i,u=!1){if(this.f=this.f&&u,this.j.lineNumber=0,this.j.value="",this.root!==R.$AC){const{node:o,remainder:t,nodeStartOffset:l}=this.G(n),r=o.piece,c=r.bufferIndex,s=this.s(o,t);if(o.piece.bufferIndex===0&&r.end.line===this.g.line&&r.end.column===this.g.column&&l+r.length===n&&i.length<b){this.F(o,i),this.y();return}if(l===n)this.o(i,o),this.h.validate(n);else if(l+o.piece.length>n){const v=[];let g=new p(r.bufferIndex,s,r.end,this.t(r.bufferIndex,s,r.end),this.u(c,r.end)-this.u(c,s));if(this.K()&&this.M(i)&&this.I(o,t)===10){const S={line:g.start.line+1,column:0};g=new p(g.bufferIndex,S,g.end,this.t(g.bufferIndex,S,g.end),g.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(o,t-1)===13){const S=this.s(o,t-1);this.C(o,S),i="\r"+i,o.piece.length===0&&v.push(o)}else this.C(o,s);else this.C(o,s);const D=this.w(i);g.length>0&&this.S(o,g);let $=o;for(let k=0;k<D.length;k++)$=this.S($,D[k]);this.v(v)}else this.q(i,o)}else{const o=this.w(i);let t=this.T(null,o[0]);for(let l=1;l<o.length;l++)t=this.S(t,o[l])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$AC)return;const u=this.G(n),o=this.G(n+i),t=u.node,l=o.node;if(t===l){const D=this.s(t,u.remainder),$=this.s(t,o.remainder);if(u.nodeStartOffset===n){if(i===t.piece.length){const k=t.next();(0,R.$FC)(this,t),this.N(k),this.y();return}this.D(t,$),this.h.validate(n),this.N(t),this.y();return}if(u.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,$),this.y();return}const r=[],c=this.s(t,u.remainder);this.C(t,c),this.h.validate(n),t.piece.length===0&&r.push(t);const s=this.s(l,o.remainder);this.D(l,s),l.piece.length===0&&r.push(l);const v=t.next();for(let D=v;D!==R.$AC&&D!==l;D=D.next())r.push(D);const g=t.piece.length===0?t.prev():t;this.v(r),this.O(g),this.y()}o(n,i){const u=[];if(this.K()&&this.M(n)&&this.L(i)){const l=i.piece,r={line:l.start.line+1,column:0},c=new p(l.bufferIndex,r,l.end,this.t(l.bufferIndex,r,l.end),l.length-1);i.piece=c,n+=`
`,(0,R.$HC)(this,i,-1,-1),i.piece.length===0&&u.push(i)}const o=this.w(n);let t=this.T(i,o[o.length-1]);for(let l=o.length-2;l>=0;l--)t=this.T(t,o[l]);this.N(t),this.v(u)}q(n,i){this.Q(n,i)&&(n+=`
`);const u=this.w(n),o=this.S(i,u[0]);let t=o;for(let l=1;l<u.length;l++)t=this.S(t,u[l]);this.N(o)}s(n,i,u){const o=n.piece,t=n.piece.bufferIndex,l=this.a[t].lineStarts,c=l[o.start.line]+o.start.column+i;let s=o.start.line,v=o.end.line,g=0,D=0,$=0;for(;s<=v&&(g=s+(v-s)/2|0,$=l[g],g!==v);)if(D=l[g+1],c<$)v=g-1;else if(c>=D)s=g+1;else break;return u?(u.line=g,u.column=c-$,null):{line:g,column:c-$}}t(n,i,u){if(u.column===0)return u.line-i.line;const o=this.a[n].lineStarts;if(u.line===o.length-1)return u.line-i.line;const t=o[u.line+1],l=o[u.line]+u.column;if(t>l+1)return u.line-i.line;const r=l-1;return this.a[n].buffer.charCodeAt(r)===13?u.line-i.line+1:u.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$FC)(this,n[i])}w(n){if(n.length>b){const v=[];for(;n.length>b;){const D=n.charCodeAt(b-1);let $;D===13||D>=55296&&D<=56319?($=n.substring(0,b-1),n=n.substring(b-1)):($=n.substring(0,b),n=n.substring(b));const k=A($);v.push(new p(this.a.length,{line:0,column:0},{line:k.length-1,column:$.length-k[k.length-1]},k.length-1,$.length)),this.a.push(new y($,k))}const g=A(n);return v.push(new p(this.a.length,{line:0,column:0},{line:g.length-1,column:n.length-g[g.length-1]},g.length-1,n.length)),this.a.push(new y(n,g)),v}let i=this.a[0].buffer.length;const u=A(n,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let v=0;v<u.length;v++)u[v]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let v=0;v<u.length;v++)u[v]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,l=this.a[0].lineStarts.length-1,r=t-this.a[0].lineStarts[l],c={line:l,column:r},s=new p(0,o,c,this.t(0,o,c),t-i);return this.g=c,[s]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let u=this.root,o="";const t=this.h.get2(n);if(t){u=t.node;const l=this.B(u,n-t.nodeStartLineNumber-1),r=this.a[u.piece.bufferIndex].buffer,c=this.u(u.piece.bufferIndex,u.piece.start);if(t.nodeStartLineNumber+u.piece.lineFeedCnt===n)o=r.substring(c+l,c+u.piece.length);else{const s=this.B(u,n-t.nodeStartLineNumber);return r.substring(c+l,c+s-i)}}else{let l=0;const r=n;for(;u!==R.$AC;)if(u.left!==R.$AC&&u.lf_left>=n-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>n-1){const c=this.B(u,n-u.lf_left-2),s=this.B(u,n-u.lf_left-1),v=this.a[u.piece.bufferIndex].buffer,g=this.u(u.piece.bufferIndex,u.piece.start);return l+=u.size_left,this.h.set({node:u,nodeStartOffset:l,nodeStartLineNumber:r-(n-1-u.lf_left)}),v.substring(g+c,g+s-i)}else if(u.lf_left+u.piece.lineFeedCnt===n-1){const c=this.B(u,n-u.lf_left-2),s=this.a[u.piece.bufferIndex].buffer,v=this.u(u.piece.bufferIndex,u.piece.start);o=s.substring(v+c,v+u.piece.length);break}else n-=u.lf_left+u.piece.lineFeedCnt,l+=u.size_left+u.piece.length,u=u.right}for(u=u.next();u!==R.$AC;){const l=this.a[u.piece.bufferIndex].buffer;if(u.piece.lineFeedCnt>0){const r=this.B(u,0),c=this.u(u.piece.bufferIndex,u.piece.start);return o+=l.substring(c,c+r-i),o}else{const r=this.u(u.piece.bufferIndex,u.piece.start);o+=l.substr(r,u.piece.length)}u=u.next()}return o}y(){let n=this.root,i=1,u=0;for(;n!==R.$AC;)i+=n.lf_left+n.piece.lineFeedCnt,u+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=u,this.h.validate(this.c)}A(n,i){const u=n.piece,o=this.s(n,i),t=o.line-u.start.line;if(this.u(u.bufferIndex,u.end)-this.u(u.bufferIndex,u.start)===i){const l=this.t(n.piece.bufferIndex,u.start,o);if(l!==t)return{index:l,remainder:0}}return{index:t,remainder:o.column}}B(n,i){if(i<0)return 0;const u=n.piece,o=this.a[u.bufferIndex].lineStarts,t=u.start.line+i+1;return t>u.end.line?o[u.end.line]+u.end.column-o[u.start.line]-u.start.column:o[t]-o[u.start.line]-u.start.column}C(n,i){const u=n.piece,o=u.lineFeedCnt,t=this.u(u.bufferIndex,u.end),l=i,r=this.u(u.bufferIndex,l),c=this.t(u.bufferIndex,u.start,l),s=c-o,v=r-t,g=u.length+v;n.piece=new p(u.bufferIndex,u.start,l,c,g),(0,R.$HC)(this,n,v,s)}D(n,i){const u=n.piece,o=u.lineFeedCnt,t=this.u(u.bufferIndex,u.start),l=i,r=this.t(u.bufferIndex,l,u.end),c=this.u(u.bufferIndex,l),s=r-o,v=t-c,g=u.length+v;n.piece=new p(u.bufferIndex,l,u.end,r,g),(0,R.$HC)(this,n,v,s)}E(n,i,u){const o=n.piece,t=o.start,l=o.end,r=o.length,c=o.lineFeedCnt,s=i,v=this.t(o.bufferIndex,o.start,s),g=this.u(o.bufferIndex,i)-this.u(o.bufferIndex,t);n.piece=new p(o.bufferIndex,o.start,s,v,g),(0,R.$HC)(this,n,g-r,v-c);const D=new p(o.bufferIndex,u,l,this.t(o.bufferIndex,u,l),this.u(o.bufferIndex,l)-this.u(o.bufferIndex,u)),$=this.S(n,D);this.N($)}F(n,i){this.Q(i,n)&&(i+=`
`);const u=this.K()&&this.L(i)&&this.M(n),o=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let $=0;$<t.length;$++)t[$]+=o;if(u){const $=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-$}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const l=this.a[0].lineStarts.length-1,r=this.a[0].buffer.length-this.a[0].lineStarts[l],c={line:l,column:r},s=n.piece.length+i.length,v=n.piece.lineFeedCnt,g=this.t(0,n.piece.start,c),D=g-v;n.piece=new p(n.piece.bufferIndex,n.piece.start,c,g,s),this.g=c,(0,R.$HC)(this,n,i.length,D)}G(n){let i=this.root;const u=this.h.get(n);if(u)return{node:u.node,nodeStartOffset:u.nodeStartOffset,remainder:n-u.nodeStartOffset};let o=0;for(;i!==R.$AC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){o+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:o};return this.h.set(t),t}else n-=i.size_left+i.piece.length,o+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let u=this.root,o=0;for(;u!==R.$AC;)if(u.left!==R.$AC&&u.lf_left>=n-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>n-1){const t=this.B(u,n-u.lf_left-2),l=this.B(u,n-u.lf_left-1);return o+=u.size_left,{node:u,remainder:Math.min(t+i-1,l),nodeStartOffset:o}}else if(u.lf_left+u.piece.lineFeedCnt===n-1){const t=this.B(u,n-u.lf_left-2);if(t+i-1<=u.piece.length)return{node:u,remainder:t+i-1,nodeStartOffset:o};i-=u.piece.length-t;break}else n-=u.lf_left+u.piece.lineFeedCnt,o+=u.size_left+u.piece.length,u=u.right;for(u=u.next();u!==R.$AC;){if(u.piece.lineFeedCnt>0){const t=this.B(u,0),l=this.J(u);return{node:u,remainder:Math.min(i-1,t),nodeStartOffset:l}}else if(u.piece.length>=i-1){const t=this.J(u);return{node:u,remainder:i-1,nodeStartOffset:t}}else i-=u.piece.length;u=u.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const u=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start)+i;return u.buffer.charCodeAt(o)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$AC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,u=this.a[i.bufferIndex].lineStarts,o=i.start.line,t=u[o]+i.start.column;return o===u.length-1||u[o+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$AC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const u=[],o=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:o[n.piece.end.line]-o[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const l=n.piece.length-1,r=n.piece.lineFeedCnt-1;n.piece=new p(n.piece.bufferIndex,n.piece.start,t,r,l),(0,R.$HC)(this,n,-1,-1),n.piece.length===0&&u.push(n);const c={line:i.piece.start.line+1,column:0},s=i.piece.length-1,v=this.t(i.piece.bufferIndex,c,i.piece.end);i.piece=new p(i.piece.bufferIndex,c,i.piece.end,v,s),(0,R.$HC)(this,i,-1,-1),i.piece.length===0&&u.push(i);const g=this.w(`\r
`);this.S(n,g[0]);for(let D=0;D<u.length;D++)(0,R.$FC)(this,u[D])}Q(n,i){if(this.K()&&this.M(n)){const u=i.next();if(this.L(u)){if(n+=`
`,u.piece.length===1)(0,R.$FC)(this,u);else{const o=u.piece,t={line:o.start.line+1,column:0},l=o.length-1,r=this.t(o.bufferIndex,t,o.end);u.piece=new p(o.bufferIndex,t,o.end,r,l),(0,R.$HC)(this,u,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$AC)return i(R.$AC);const u=this.iterate(n.left,i);return u&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$AC)return"";const i=this.a[n.piece.bufferIndex],u=n.piece,o=this.u(u.bufferIndex,u.start),t=this.u(u.bufferIndex,u.end);return i.buffer.substring(o,t)}getPieceContent(n){const i=this.a[n.bufferIndex],u=this.u(n.bufferIndex,n.start),o=this.u(n.bufferIndex,n.end);return i.buffer.substring(u,o)}S(n,i){const u=new R.$zC(i,1);if(u.left=R.$AC,u.right=R.$AC,u.parent=R.$AC,u.size_left=0,u.lf_left=0,this.root===R.$AC)this.root=u,u.color=0;else if(n.right===R.$AC)n.right=u,u.parent=n;else{const t=(0,R.$BC)(n.right);t.left=u,u.parent=t}return(0,R.$GC)(this,u),u}T(n,i){const u=new R.$zC(i,1);if(u.left=R.$AC,u.right=R.$AC,u.parent=R.$AC,u.size_left=0,u.lf_left=0,this.root===R.$AC)this.root=u,u.color=0;else if(n.left===R.$AC)n.left=u,u.parent=n;else{const o=(0,R.$CC)(n.left);o.right=u,u.parent=o}return(0,R.$GC)(this,u),u}U(n){let i="";return this.iterate(n,u=>(i+=this.R(u),!0)),i}}e.$TC=f}),define(ke[189],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r$=e.$q$=void 0;class d{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const N=this.a.get(R);return this.a.delete(R),N}}addDragOperationTransfer(R,N){this.a.set(R,N)}}e.$q$=d;class L{constructor(R){this.identifier=R}}e.$r$=L}),define(ke[190],Se([1,0,4,3]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=void 0;class O{constructor(){this.a=new Map,this.b=new Map,this.c=new d.$ee,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,m){return this.a.set(b,m),this.handleChange([b]),(0,L.$Tc)(()=>{this.a.get(b)===m&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,m){this.b.get(b)?.dispose();const E=new R(this,b,m);return this.b.set(b,E),(0,L.$Tc)(()=>{const A=this.b.get(b);!A||A!==E||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const m=this.get(b);if(m)return m;const E=this.b.get(b);return!E||E.isResolved?null:(await E.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const E=this.b.get(b);return!!(!E||E.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Zt=O;class R extends L.$Vc{get isResolved(){return this.c}constructor(b,m,E){super(),this.f=b,this.g=m,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[191],Se([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(ke[192],Se([1,0,4,3,191]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=A;class R extends L.$Vc{constructor(p,y="",w="",h=!0,f){super(),this.h=this.B(new d.$ee),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=y,this.u=w,this.w=h,this.C=f}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,y){this.C&&await this.C(p)}}e.$bj=R;class N extends L.$Vc{constructor(){super(...arguments),this.f=this.B(new d.$ee),this.onWillRun=this.f.event,this.m=this.B(new d.$ee),this.onDidRun=this.m.event}async run(p,y){if(!p.enabled)return;this.f.fire({action:p});let w;try{await this.u(p,y)}catch(h){w=h}this.m.fire({action:p,error:w})}async u(p,y){await p.run(y)}}e.$cj=N;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let y=[];for(const w of p)w.length&&(y.length?y=[...y,new b,...w]:y=w);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$dj=b;class m{get actions(){return this.a}constructor(p,y,w,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=y,this.class=h,this.a=w}async run(){}}e.$ej=m;class E extends R{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,O.localize(0,null),void 0,!1)}}e.$fj=E;function A(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...p)=>P.run(...p),tooltip:P.label}}}),define(ke[193],Se([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(ke[194],Se([1,0,193]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=E,e.$3m=A,e.$4m=P;const L=60,O=L*60,R=O*24,N=R*7,b=R*30,m=R*365;function E(p,y,w,h){typeof p!="number"&&(p=p.getTime());const f=Math.round((new Date().getTime()-p)/1e3);if(f<-30)return(0,d.localize)(0,null,E(new Date().getTime()+f*1e3,!1));if(!h&&f<30)return(0,d.localize)(1,null);let a;return f<L?(a=f,y?a===1?w?(0,d.localize)(2,null,a):(0,d.localize)(3,null,a):w?(0,d.localize)(4,null,a):(0,d.localize)(5,null,a):a===1?w?(0,d.localize)(6,null,a):(0,d.localize)(7,null,a):w?(0,d.localize)(8,null,a):(0,d.localize)(9,null,a)):f<O?(a=Math.floor(f/L),y?a===1?w?(0,d.localize)(10,null,a):(0,d.localize)(11,null,a):w?(0,d.localize)(12,null,a):(0,d.localize)(13,null,a):a===1?w?(0,d.localize)(14,null,a):(0,d.localize)(15,null,a):w?(0,d.localize)(16,null,a):(0,d.localize)(17,null,a)):f<R?(a=Math.floor(f/O),y?a===1?w?(0,d.localize)(18,null,a):(0,d.localize)(19,null,a):w?(0,d.localize)(20,null,a):(0,d.localize)(21,null,a):a===1?w?(0,d.localize)(22,null,a):(0,d.localize)(23,null,a):w?(0,d.localize)(24,null,a):(0,d.localize)(25,null,a)):f<N?(a=Math.floor(f/R),y?a===1?(0,d.localize)(26,null,a):(0,d.localize)(27,null,a):a===1?(0,d.localize)(28,null,a):(0,d.localize)(29,null,a)):f<b?(a=Math.floor(f/N),y?a===1?w?(0,d.localize)(30,null,a):(0,d.localize)(31,null,a):w?(0,d.localize)(32,null,a):(0,d.localize)(33,null,a):a===1?w?(0,d.localize)(34,null,a):(0,d.localize)(35,null,a):w?(0,d.localize)(36,null,a):(0,d.localize)(37,null,a)):f<m?(a=Math.floor(f/b),y?a===1?w?(0,d.localize)(38,null,a):(0,d.localize)(39,null,a):w?(0,d.localize)(40,null,a):(0,d.localize)(41,null,a):a===1?w?(0,d.localize)(42,null,a):(0,d.localize)(43,null,a):w?(0,d.localize)(44,null,a):(0,d.localize)(45,null,a)):(a=Math.floor(f/m),y?a===1?w?(0,d.localize)(46,null,a):(0,d.localize)(47,null,a):w?(0,d.localize)(48,null,a):(0,d.localize)(49,null,a):a===1?w?(0,d.localize)(50,null,a):(0,d.localize)(51,null,a):w?(0,d.localize)(52,null,a):(0,d.localize)(53,null,a))}function A(p,y){const w=Math.abs(p/1e3);return w<1?y?(0,d.localize)(54,null,p):(0,d.localize)(55,null,p):w<L?y?(0,d.localize)(56,null,Math.round(p)/1e3):(0,d.localize)(57,null,Math.round(p)/1e3):w<O?y?(0,d.localize)(58,null,Math.round(p/(1e3*L))):(0,d.localize)(59,null,Math.round(p/(1e3*L))):w<R?y?(0,d.localize)(60,null,Math.round(p/(1e3*O))):(0,d.localize)(61,null,Math.round(p/(1e3*O))):(0,d.localize)(62,null,Math.round(p/(1e3*R)))}function P(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[195],Se([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(ke[47],Se([1,0,19,18,195]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=m,e.$ij=E,e.$jj=A;function R(P,p){return p&&(P.stack||P.stacktrace)?O.localize(0,null,b(P),N(P.stack)||N(P.stacktrace)):b(P)}function N(P){return Array.isArray(P)?P.join(`
`):P}function b(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?O.localize(1,null,P.message):P.message||O.localize(2,null)}function m(P=null,p=!1){if(!P)return O.localize(3,null);if(Array.isArray(P)){const y=d.$Hb(P),w=m(y[0],p);return y.length>1?O.localize(4,null,w,y.length):w}if(L.$9f(P))return P;if(P.detail){const y=P.detail;if(y.error)return R(y.error,p);if(y.exception)return R(y.exception,p)}return P.stack?R(P,p):P.message?P.message:O.localize(5,null)}function E(P){const p=P;return p instanceof Error&&Array.isArray(p.actions)}function A(P,p){let y;return typeof P=="string"?y=new Error(P):y=P,y.actions=p,y}}),define(ke[196],Se([9,10]),function(le,e){return le.create("vs/base/common/platform",e)}),define(ke[12],Se([1,0,196]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=l,e.$D=D,e.$J=$,e.$g="en";let L=!1,O=!1,R=!1,N=!1,b=!1,m=!1,E=!1,A=!1,P=!1,p=!1,y,w=e.$g,h=e.$g,f,a;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const u=typeof i?.versions?.electron=="string",o=u&&i?.type==="renderer";if(typeof i=="object"){L=i.platform==="win32",O=i.platform==="darwin",R=i.platform==="linux",N=R&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,E=u,P=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,w=e.$g;const k=i.env.VSCODE_NLS_CONFIG;if(k)try{const S=JSON.parse(k),C=S.availableLanguages["*"];y=S.locale,h=S.osLocale,w=C||e.$g,f=S._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!o?(a=navigator.userAgent,L=a.indexOf("Windows")>=0,O=a.indexOf("Macintosh")>=0,A=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=a.indexOf("Linux")>=0,p=a?.indexOf("Mobi")>=0,m=!0,y=d.getConfiguredDefaultLocale(d.localize(0,null))||e.$g,w=y,h=navigator.language):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function l(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;O?r=1:L?r=3:R&&(r=2),e.$i=L,e.$j=O,e.$k=R,e.$l=N,e.$m=b,e.$n=E,e.$o=m,e.$p=m&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=p,e.$t=P,e.$u=r,e.$v=a,e.$w=w;var c;(function(k){function S(){return e.$w}k.value=S;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=C;function I(){return e.$w==="en"}k.isDefault=I})(c||(e.Language=c={})),e.$x=y,e.$y=h,e.$z=f,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const k=[];n.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let I=0,F=k.length;I<F;I++){const j=k[I];if(j.id===C.data.vscodeScheduleAsyncWork){k.splice(I,1),j.callback();return}}});let S=0;return C=>{const I=++S;k.push({id:I,callback:C}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return k=>setTimeout(k)})();var s;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=O||A?2:L?1:3;let v=!0,g=!1;function D(){if(!g){g=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,v=new Uint16Array(k.buffer)[0]===513}return v}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function $(k){return parseFloat(k)>=20}}),define(ke[52],Se([1,0,12]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let L;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.process<"u"){const R=O.process;L={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return d.$i?"win32":d.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$ec=L.platform,e.$fc=L.arch}),define(ke[17],Se([1,0,52]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const L=65,O=97,R=90,N=122,b=46,m=47,E=92,A=58,P=63;class p extends Error{constructor(l,r,c){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const v=l.indexOf(".")!==-1?"property":"argument";let g=`The "${l}" ${v} ${s} of type ${r}`;g+=`. Received type ${typeof c}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,l){if(t===null||typeof t!="object")throw new p(l,"Object",t)}function w(t,l){if(typeof t!="string")throw new p(l,"string",t)}const h=d.$ec==="win32";function f(t){return t===m||t===E}function a(t){return t===m}function n(t){return t>=L&&t<=R||t>=O&&t<=N}function i(t,l,r,c){let s="",v=0,g=-1,D=0,$=0;for(let k=0;k<=t.length;++k){if(k<t.length)$=t.charCodeAt(k);else{if(c($))break;$=m}if(c($)){if(!(g===k-1||D===1))if(D===2){if(s.length<2||v!==2||s.charCodeAt(s.length-1)!==b||s.charCodeAt(s.length-2)!==b){if(s.length>2){const S=s.lastIndexOf(r);S===-1?(s="",v=0):(s=s.slice(0,S),v=s.length-1-s.lastIndexOf(r)),g=k,D=0;continue}else if(s.length!==0){s="",v=0,g=k,D=0;continue}}l&&(s+=s.length>0?`${r}..`:"..",v=2)}else s.length>0?s+=`${r}${t.slice(g+1,k)}`:s=t.slice(g+1,k),v=k-g-1;g=k,D=0}else $===b&&D!==-1?++D:D=-1}return s}function u(t,l){y(l,"pathObject");const r=l.dir||l.root,c=l.base||`${l.name||""}${l.ext||""}`;return r?r===l.root?`${r}${c}`:`${r}${t}${c}`:c}e.$gc={resolve(...t){let l="",r="",c=!1;for(let s=t.length-1;s>=-1;s--){let v;if(s>=0){if(v=t[s],w(v,"path"),v.length===0)continue}else l.length===0?v=d.cwd():(v=d.env[`=${l}`]||d.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==l.toLowerCase()&&v.charCodeAt(2)===E)&&(v=`${l}\\`));const g=v.length;let D=0,$="",k=!1;const S=v.charCodeAt(0);if(g===1)f(S)&&(D=1,k=!0);else if(f(S))if(k=!0,f(v.charCodeAt(1))){let C=2,I=C;for(;C<g&&!f(v.charCodeAt(C));)C++;if(C<g&&C!==I){const F=v.slice(I,C);for(I=C;C<g&&f(v.charCodeAt(C));)C++;if(C<g&&C!==I){for(I=C;C<g&&!f(v.charCodeAt(C));)C++;(C===g||C!==I)&&($=`\\\\${F}\\${v.slice(I,C)}`,D=C)}}}else D=1;else n(S)&&v.charCodeAt(1)===A&&($=v.slice(0,2),D=2,g>2&&f(v.charCodeAt(2))&&(k=!0,D=3));if($.length>0)if(l.length>0){if($.toLowerCase()!==l.toLowerCase())continue}else l=$;if(c){if(l.length>0)break}else if(r=`${v.slice(D)}\\${r}`,c=k,k&&l.length>0)break}return r=i(r,!c,"\\",f),c?`${l}\\${r}`:`${l}${r}`||"."},normalize(t){w(t,"path");const l=t.length;if(l===0)return".";let r=0,c,s=!1;const v=t.charCodeAt(0);if(l===1)return a(v)?"\\":t;if(f(v))if(s=!0,f(t.charCodeAt(1))){let D=2,$=D;for(;D<l&&!f(t.charCodeAt(D));)D++;if(D<l&&D!==$){const k=t.slice($,D);for($=D;D<l&&f(t.charCodeAt(D));)D++;if(D<l&&D!==$){for($=D;D<l&&!f(t.charCodeAt(D));)D++;if(D===l)return`\\\\${k}\\${t.slice($)}\\`;D!==$&&(c=`\\\\${k}\\${t.slice($,D)}`,r=D)}}}else r=1;else n(v)&&t.charCodeAt(1)===A&&(c=t.slice(0,2),r=2,l>2&&f(t.charCodeAt(2))&&(s=!0,r=3));let g=r<l?i(t.slice(r),!s,"\\",f):"";return g.length===0&&!s&&(g="."),g.length>0&&f(t.charCodeAt(l-1))&&(g+="\\"),c===void 0?s?`\\${g}`:g:s?`${c}\\${g}`:`${c}${g}`},isAbsolute(t){w(t,"path");const l=t.length;if(l===0)return!1;const r=t.charCodeAt(0);return f(r)||l>2&&n(r)&&t.charCodeAt(1)===A&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,r;for(let v=0;v<t.length;++v){const g=t[v];w(g,"path"),g.length>0&&(l===void 0?l=r=g:l+=`\\${g}`)}if(l===void 0)return".";let c=!0,s=0;if(typeof r=="string"&&f(r.charCodeAt(0))){++s;const v=r.length;v>1&&f(r.charCodeAt(1))&&(++s,v>2&&(f(r.charCodeAt(2))?++s:c=!1))}if(c){for(;s<l.length&&f(l.charCodeAt(s));)s++;s>=2&&(l=`\\${l.slice(s)}`)}return e.$gc.normalize(l)},relative(t,l){if(w(t,"from"),w(l,"to"),t===l)return"";const r=e.$gc.resolve(t),c=e.$gc.resolve(l);if(r===c||(t=r.toLowerCase(),l=c.toLowerCase(),t===l))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===E;)s++;let v=t.length;for(;v-1>s&&t.charCodeAt(v-1)===E;)v--;const g=v-s;let D=0;for(;D<l.length&&l.charCodeAt(D)===E;)D++;let $=l.length;for(;$-1>D&&l.charCodeAt($-1)===E;)$--;const k=$-D,S=g<k?g:k;let C=-1,I=0;for(;I<S;I++){const j=t.charCodeAt(s+I);if(j!==l.charCodeAt(D+I))break;j===E&&(C=I)}if(I!==S){if(C===-1)return c}else{if(k>S){if(l.charCodeAt(D+I)===E)return c.slice(D+I+1);if(I===2)return c.slice(D+I)}g>S&&(t.charCodeAt(s+I)===E?C=I:I===2&&(C=3)),C===-1&&(C=0)}let F="";for(I=s+C+1;I<=v;++I)(I===v||t.charCodeAt(I)===E)&&(F+=F.length===0?"..":"\\..");return D+=C,F.length>0?`${F}${c.slice(D,$)}`:(c.charCodeAt(D)===E&&++D,c.slice(D,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$gc.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===E){if(l.charCodeAt(1)===E){const r=l.charCodeAt(2);if(r!==P&&r!==b)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(n(l.charCodeAt(0))&&l.charCodeAt(1)===A&&l.charCodeAt(2)===E)return`\\\\?\\${l}`;return t},dirname(t){w(t,"path");const l=t.length;if(l===0)return".";let r=-1,c=0;const s=t.charCodeAt(0);if(l===1)return f(s)?t:".";if(f(s)){if(r=c=1,f(t.charCodeAt(1))){let D=2,$=D;for(;D<l&&!f(t.charCodeAt(D));)D++;if(D<l&&D!==$){for($=D;D<l&&f(t.charCodeAt(D));)D++;if(D<l&&D!==$){for($=D;D<l&&!f(t.charCodeAt(D));)D++;if(D===l)return t;D!==$&&(r=c=D+1)}}}}else n(s)&&t.charCodeAt(1)===A&&(r=l>2&&f(t.charCodeAt(2))?3:2,c=r);let v=-1,g=!0;for(let D=l-1;D>=c;--D)if(f(t.charCodeAt(D))){if(!g){v=D;break}}else g=!1;if(v===-1){if(r===-1)return".";v=r}return t.slice(0,v)},basename(t,l){l!==void 0&&w(l,"ext"),w(t,"path");let r=0,c=-1,s=!0,v;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(r=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let g=l.length-1,D=-1;for(v=t.length-1;v>=r;--v){const $=t.charCodeAt(v);if(f($)){if(!s){r=v+1;break}}else D===-1&&(s=!1,D=v+1),g>=0&&($===l.charCodeAt(g)?--g===-1&&(c=v):(g=-1,c=D))}return r===c?c=D:c===-1&&(c=t.length),t.slice(r,c)}for(v=t.length-1;v>=r;--v)if(f(t.charCodeAt(v))){if(!s){r=v+1;break}}else c===-1&&(s=!1,c=v+1);return c===-1?"":t.slice(r,c)},extname(t){w(t,"path");let l=0,r=-1,c=0,s=-1,v=!0,g=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(l=c=2);for(let D=t.length-1;D>=l;--D){const $=t.charCodeAt(D);if(f($)){if(!v){c=D+1;break}continue}s===-1&&(v=!1,s=D+1),$===b?r===-1?r=D:g!==1&&(g=1):r!==-1&&(g=-1)}return r===-1||s===-1||g===0||g===1&&r===s-1&&r===c+1?"":t.slice(r,s)},format:u.bind(null,"\\"),parse(t){w(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.length;let c=0,s=t.charCodeAt(0);if(r===1)return f(s)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(f(s)){if(c=1,f(t.charCodeAt(1))){let C=2,I=C;for(;C<r&&!f(t.charCodeAt(C));)C++;if(C<r&&C!==I){for(I=C;C<r&&f(t.charCodeAt(C));)C++;if(C<r&&C!==I){for(I=C;C<r&&!f(t.charCodeAt(C));)C++;C===r?c=C:C!==I&&(c=C+1)}}}}else if(n(s)&&t.charCodeAt(1)===A){if(r<=2)return l.root=l.dir=t,l;if(c=2,f(t.charCodeAt(2))){if(r===3)return l.root=l.dir=t,l;c=3}}c>0&&(l.root=t.slice(0,c));let v=-1,g=c,D=-1,$=!0,k=t.length-1,S=0;for(;k>=c;--k){if(s=t.charCodeAt(k),f(s)){if(!$){g=k+1;break}continue}D===-1&&($=!1,D=k+1),s===b?v===-1?v=k:S!==1&&(S=1):v!==-1&&(S=-1)}return D!==-1&&(v===-1||S===0||S===1&&v===D-1&&v===g+1?l.base=l.name=t.slice(g,D):(l.name=t.slice(g,v),l.base=t.slice(g,D),l.ext=t.slice(v,D))),g>0&&g!==c?l.dir=t.slice(0,g-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(h){const t=/\\/g;return()=>{const l=d.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>d.cwd()})();e.$hc={resolve(...t){let l="",r=!1;for(let c=t.length-1;c>=-1&&!r;c--){const s=c>=0?t[c]:o();w(s,"path"),s.length!==0&&(l=`${s}/${l}`,r=s.charCodeAt(0)===m)}return l=i(l,!r,"/",a),r?`/${l}`:l.length>0?l:"."},normalize(t){if(w(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===m,r=t.charCodeAt(t.length-1)===m;return t=i(t,!l,"/",a),t.length===0?l?"/":r?"./":".":(r&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return w(t,"path"),t.length>0&&t.charCodeAt(0)===m},join(...t){if(t.length===0)return".";let l;for(let r=0;r<t.length;++r){const c=t[r];w(c,"path"),c.length>0&&(l===void 0?l=c:l+=`/${c}`)}return l===void 0?".":e.$hc.normalize(l)},relative(t,l){if(w(t,"from"),w(l,"to"),t===l||(t=e.$hc.resolve(t),l=e.$hc.resolve(l),t===l))return"";const r=1,c=t.length,s=c-r,v=1,g=l.length-v,D=s<g?s:g;let $=-1,k=0;for(;k<D;k++){const C=t.charCodeAt(r+k);if(C!==l.charCodeAt(v+k))break;C===m&&($=k)}if(k===D)if(g>D){if(l.charCodeAt(v+k)===m)return l.slice(v+k+1);if(k===0)return l.slice(v+k)}else s>D&&(t.charCodeAt(r+k)===m?$=k:k===0&&($=0));let S="";for(k=r+$+1;k<=c;++k)(k===c||t.charCodeAt(k)===m)&&(S+=S.length===0?"..":"/..");return`${S}${l.slice(v+$)}`},toNamespacedPath(t){return t},dirname(t){if(w(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===m;let r=-1,c=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===m){if(!c){r=s;break}}else c=!1;return r===-1?l?"/":".":l&&r===1?"//":t.slice(0,r)},basename(t,l){l!==void 0&&w(l,"ext"),w(t,"path");let r=0,c=-1,s=!0,v;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let g=l.length-1,D=-1;for(v=t.length-1;v>=0;--v){const $=t.charCodeAt(v);if($===m){if(!s){r=v+1;break}}else D===-1&&(s=!1,D=v+1),g>=0&&($===l.charCodeAt(g)?--g===-1&&(c=v):(g=-1,c=D))}return r===c?c=D:c===-1&&(c=t.length),t.slice(r,c)}for(v=t.length-1;v>=0;--v)if(t.charCodeAt(v)===m){if(!s){r=v+1;break}}else c===-1&&(s=!1,c=v+1);return c===-1?"":t.slice(r,c)},extname(t){w(t,"path");let l=-1,r=0,c=-1,s=!0,v=0;for(let g=t.length-1;g>=0;--g){const D=t.charCodeAt(g);if(D===m){if(!s){r=g+1;break}continue}c===-1&&(s=!1,c=g+1),D===b?l===-1?l=g:v!==1&&(v=1):l!==-1&&(v=-1)}return l===-1||c===-1||v===0||v===1&&l===c-1&&l===r+1?"":t.slice(l,c)},format:u.bind(null,"/"),parse(t){w(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.charCodeAt(0)===m;let c;r?(l.root="/",c=1):c=0;let s=-1,v=0,g=-1,D=!0,$=t.length-1,k=0;for(;$>=c;--$){const S=t.charCodeAt($);if(S===m){if(!D){v=$+1;break}continue}g===-1&&(D=!1,g=$+1),S===b?s===-1?s=$:k!==1&&(k=1):s!==-1&&(k=-1)}if(g!==-1){const S=v===0&&r?1:v;s===-1||k===0||k===1&&s===g-1&&s===v+1?l.base=l.name=t.slice(S,g):(l.name=t.slice(S,s),l.base=t.slice(S,g),l.ext=t.slice(s,g))}return v>0?l.dir=t.slice(0,v-1):r&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=h?e.$gc.normalize:e.$hc.normalize,e.$jc=h?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=h?e.$gc.join:e.$hc.join,e.$lc=h?e.$gc.resolve:e.$hc.resolve,e.$mc=h?e.$gc.relative:e.$hc.relative,e.$nc=h?e.$gc.dirname:e.$hc.dirname,e.$oc=h?e.$gc.basename:e.$hc.basename,e.$pc=h?e.$gc.extname:e.$hc.extname,e.$qc=h?e.$gc.format:e.$hc.format,e.$rc=h?e.$gc.parse:e.$hc.parse,e.$sc=h?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=h?e.$gc.sep:e.$hc.sep,e.$uc=h?e.$gc.delimiter:e.$hc.delimiter}),define(ke[132],Se([1,0,46,17]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=b,e.$hr=m,e.$ir=E,e.$jr=A,e.$kr=P,e.$lr=p,e.$mr=y,e.$nr=w,e.$or=h,e.$pr=f,e.$qr=s,e.$rr=v,e.$sr=g;const O=new d.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new d.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),N=new d.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(D,$,k=!1){const S=D||"",C=$||"",I=O.value.collator.compare(S,C);return O.value.collatorIsNumeric&&I===0&&S!==C?S<C?-1:1:I}function m(D,$){const k=R.value.collator;return D=D||"",$=$||"",u(k,D,$)}function E(D,$){const k=R.value.collator;return D=D||"",$=$||"",r(D,$)||u(k,D,$)}function A(D,$){const k=R.value.collator;return D=D||"",$=$||"",l(D,$)||u(k,D,$)}function P(D,$){return D=D||"",$=$||"",D===$?0:D<$?-1:1}function p(D,$){const[k,S]=n(D),[C,I]=n($);let F=O.value.collator.compare(S,I);if(F===0){if(O.value.collatorIsNumeric&&S!==I)return S<I?-1:1;if(F=O.value.collator.compare(k,C),O.value.collatorIsNumeric&&F===0&&k!==C)return k<C?-1:1}return F}function y(D,$){D=D||"",$=$||"";const k=i(D),S=i($),C=R.value.collator,I=N.value.collator;return u(I,k,S)||u(C,D,$)}function w(D,$){D=D||"",$=$||"";const k=i(D),S=i($),C=R.value.collator,I=N.value.collator;return u(I,k,S)||r(D,$)||u(C,D,$)}function h(D,$){D=D||"",$=$||"";const k=i(D),S=i($),C=R.value.collator,I=N.value.collator;return u(I,k,S)||l(D,$)||u(C,D,$)}function f(D,$){D=D||"",$=$||"";const k=i(D).toLowerCase(),S=i($).toLowerCase();return k!==S?k<S?-1:1:D!==$?D<$?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function n(D,$=!1){const k=D?a.exec(D):[];let S=[k&&k[1]||"",k&&k[3]||""];return $&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function i(D){const $=D?a.exec(D):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function u(D,$,k){const S=D.compare($,k);return S!==0?S:$.length!==k.length?$.length<k.length?-1:1:0}function o(D){const $=D.charAt(0);return $.toLocaleUpperCase()!==$}function t(D){const $=D.charAt(0);return $.toLocaleLowerCase()!==$}function l(D,$){return o(D)&&t($)?-1:t(D)&&o($)?1:0}function r(D,$){return t(D)&&o($)?-1:o(D)&&t($)?1:0}function c(D,$,k=!1){return k||(D=D&&D.toLowerCase(),$=$&&$.toLowerCase()),D===$?0:D<$?-1:1}function s(D,$,k=!1){const S=D.split(L.sep),C=$.split(L.sep),I=S.length-1,F=C.length-1;let j,z;for(let M=0;;M++){if(j=I===M,z=F===M,j&&z)return b(S[M],C[M],k);if(j)return-1;if(z)return 1;const T=c(S[M],C[M],k);if(T!==0)return T}}function v(D,$,k){const S=D.toLowerCase(),C=$.toLowerCase(),I=g(D,$,k);if(I)return I;const F=S.endsWith(k),j=C.endsWith(k);if(F!==j)return F?-1:1;const z=b(S,C);return z!==0?z:S.localeCompare(C)}function g(D,$,k){const S=D.toLowerCase(),C=$.toLowerCase(),I=S.startsWith(k),F=C.startsWith(k);if(I!==F)return I?-1:1;if(I&&F){if(S.length<C.length)return-1;if(S.length>C.length)return 1}return 0}}),define(ke[31],Se([1,0,17,12,14,18]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=N,e.$pg=b,e.$qg=m,e.$rg=E,e.$sg=A,e.$tg=w,e.$ug=h,e.$vg=f,e.$wg=a,e.$xg=n,e.$yg=i,e.$zg=u,e.$Ag=o,e.$Bg=t,e.$Cg=l,e.$Dg=r,e.$Eg=v;function N(g){return g===47||g===92}function b(g){return g.replace(/[\\/]/g,d.$hc.sep)}function m(g){return g.indexOf("/")===-1&&(g=b(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}function E(g,D=d.$hc.sep){if(!g)return"";const $=g.length,k=g.charCodeAt(0);if(N(k)){if(N(g.charCodeAt(1))&&!N(g.charCodeAt(2))){let C=3;const I=C;for(;C<$&&!N(g.charCodeAt(C));C++);if(I!==C&&!N(g.charCodeAt(C+1))){for(C+=1;C<$;C++)if(N(g.charCodeAt(C)))return g.slice(0,C+1).replace(/[\\/]/g,D)}}return D}else if(a(k)&&g.charCodeAt(1)===58)return N(g.charCodeAt(2))?g.slice(0,2)+D:g.slice(0,2);let S=g.indexOf("://");if(S!==-1){for(S+=3;S<$;S++)if(N(g.charCodeAt(S)))return g.slice(0,S+1)}return""}function A(g){if(!L.$i||!g||g.length<5)return!1;let D=g.charCodeAt(0);if(D!==92||(D=g.charCodeAt(1),D!==92))return!1;let $=2;const k=$;for(;$<g.length&&(D=g.charCodeAt($),D!==92);$++);return!(k===$||(D=g.charCodeAt($+1),isNaN(D)||D===92))}const P=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(g,D=L.$i){const $=D?P:p;return!(!g||g.length===0||/^\s+$/.test(g)||($.lastIndex=0,$.test(g))||D&&y.test(g)||g==="."||g===".."||D&&g[g.length-1]==="."||D&&g.length!==g.trim().length||g.length>255)}function h(g,D,$){const k=g===D;return!$||k?k:!g||!D?!1:(0,O.$yf)(g,D)}function f(g,D,$,k=d.sep){if(g===D)return!0;if(!g||!D||D.length>g.length)return!1;if($){if(!(0,O.$zf)(g,D))return!1;if(D.length===g.length)return!0;let C=D.length;return D.charAt(D.length-1)===k&&C--,g.charAt(C)===k}return D.charAt(D.length-1)!==k&&(D+=k),g.indexOf(D)===0}function a(g){return g>=65&&g<=90||g>=97&&g<=122}function n(g,D){return L.$i&&g.endsWith(":")&&(g+=d.sep),(0,d.$jc)(g)||(g=(0,d.$kc)(D,g)),g=(0,d.$ic)(g),i(g)}function i(g){return L.$i?(g=(0,O.$gf)(g,d.sep),g.endsWith(":")&&(g+=d.sep)):(g=(0,O.$gf)(g,d.sep),g||(g=d.sep)),g}function u(g){const D=(0,d.$ic)(g);return L.$i?g.length>3?!1:o(D)&&(g.length===2||D.charCodeAt(2)===92):D===d.$hc.sep}function o(g,D=L.$i){return D?a(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}function t(g,D=L.$i){return o(g,D)?g[0]:void 0}function l(g,D,$){return D.length>g.length?-1:g===D?0:($&&(g=g.toLowerCase(),D=D.toLowerCase()),g.indexOf(D))}function r(g){const D=g.split(":");let $,k,S;for(const C of D){const I=Number(C);(0,R.$ag)(I)?k===void 0?k=I:S===void 0&&(S=I):$=$?[$,C].join(":"):C}if(!$)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:$,line:k!==void 0?k:void 0,column:S!==void 0?S:k!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(g,D,$=8){let k="";for(let C=0;C<$;C++){let I;C===0&&L.$i&&!D&&($===3||$===4)?I=s:I=c,k+=I.charAt(Math.floor(Math.random()*I.length))}let S;return D?S=`${D}-${k}`:S=k,g?(0,d.$kc)(g,S):S}}),define(ke[133],Se([1,0,132,127,57,17,12,14]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=A,e.$ur=f,e.$vr=r,e.$wr=k,e.$xr=z,e.$yr=T;const m=0,E=[m,[]];function A(U,Z,te,q){if(!U||!Z)return E;const K=U.length,Y=Z.length;if(K<Y)return E;const ie=U.toLowerCase();return P(Z,te,Y,U,ie,K,q)}function P(U,Z,te,q,K,Y,ie){const $e=[],ue=[];for(let ee=0;ee<te;ee++){const pe=ee*Y,Ce=pe-Y,oe=ee>0,se=U[ee],re=Z[ee];for(let G=0;G<Y;G++){const ne=G>0,me=pe+G,be=me-1,Re=Ce+G-1,fe=ne?$e[be]:0,De=oe&&ne?$e[Re]:0,Ae=oe&&ne?ue[Re]:0;let ze;!De&&oe?ze=0:ze=p(se,re,q,K,G,Ae),ze&&De+ze>=fe&&(ie||oe||K.startsWith(Z,G))?(ue[me]=Ae+1,$e[me]=De+ze):(ue[me]=m,$e[me]=fe)}}const ve=[];let _=te-1,B=Y-1;for(;_>=0&&B>=0;){const ee=_*Y+B;ue[ee]===m||(ve.push(B),_--),B--}return[$e[te*Y-1],ve.reverse()]}function p(U,Z,te,q,K,Y){let ie=0;if(!y(Z,q[K]))return ie;if(ie+=1,Y>0&&(ie+=Y*5),U===te[K]&&(ie+=1),K===0)ie+=8;else{const $e=w(te.charCodeAt(K-1));$e?ie+=$e:(0,L.$Bk)(te.charCodeAt(K))&&Y===0&&(ie+=2)}return ie}function y(U,Z){return U===Z?!0:U==="/"||U==="\\"?Z==="/"||Z==="\\":!1}function w(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const h=[void 0,[]];function f(U,Z,te=0,q=0){const K=Z;return K.values&&K.values.length>1?a(U,K.values,te,q):n(U,Z,te,q)}function a(U,Z,te,q){let K=0;const Y=[];for(const ie of Z){const[$e,ue]=n(U,ie,te,q);if(typeof $e!="number")return h;K+=$e,Y.push(...ue)}return[K,D(Y)]}function n(U,Z,te,q){const K=(0,L.$Kk)(Z.original,Z.originalLowercase,te,U,U.toLowerCase(),q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return K?[K[0],(0,L.$Hk)(K)]:h}const i=Object.freeze({score:0}),u=1<<18,o=1<<17,t=65536;function l(U,Z,te,q){const K=q.values?q.values:[q];return(0,O.$kj)({[q.normalized]:{values:K.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:U,description:Z,allowNonContiguousMatches:te}})}function r(U,Z,te,q,K){if(!U||!Z.normalized)return i;const Y=q.getItemLabel(U);if(!Y)return i;const ie=q.getItemDescription(U),$e=l(Y,ie,te,Z),ue=K[$e];if(ue)return ue;const ve=c(Y,ie,q.getItemPath(U),Z,te);return K[$e]=ve,ve}function c(U,Z,te,q,K){const Y=!te||!q.containsPathSeparator;return te&&(N.$k?q.pathNormalized===te:(0,b.$yf)(q.pathNormalized,te))?{score:u,labelMatch:[{start:0,end:U.length}],descriptionMatch:Z?[{start:0,end:Z.length}]:void 0}:q.values&&q.values.length>1?s(U,Z,te,q.values,Y,K):v(U,Z,te,q,Y,K)}function s(U,Z,te,q,K,Y){let ie=0;const $e=[],ue=[];for(const ve of q){const{score:_,labelMatch:B,descriptionMatch:ee}=v(U,Z,te,ve,K,Y);if(_===m)return i;ie+=_,B&&$e.push(...B),ee&&ue.push(...ee)}return{score:ie,labelMatch:D($e),descriptionMatch:D(ue)}}function v(U,Z,te,q,K,Y){if(K||!Z){const[ie,$e]=A(U,q.normalized,q.normalizedLowercase,Y&&!q.expectContiguousMatch);if(ie){const ue=(0,L.$yk)(q.normalized,U);let ve;if(ue){ve=o;const _=Math.round(q.normalized.length/U.length*100);ve+=_}else ve=t;return{score:ve+ie,labelMatch:ue||g($e)}}}if(Z){let ie=Z;te&&(ie=`${Z}${R.sep}`);const $e=ie.length,ue=`${ie}${U}`,[ve,_]=A(ue,q.normalized,q.normalizedLowercase,Y&&!q.expectContiguousMatch);if(ve){const B=g(_),ee=[],pe=[];return B.forEach(Ce=>{Ce.start<$e&&Ce.end>$e?(ee.push({start:0,end:Ce.end-$e}),pe.push({start:Ce.start,end:$e})):Ce.start>=$e?ee.push({start:Ce.start-$e,end:Ce.end-$e}):pe.push(Ce)}),{score:ve,labelMatch:ee,descriptionMatch:pe}}}return i}function g(U){const Z=[];if(!U)return Z;let te;for(const q of U)te&&te.end===q?te.end+=1:(te={start:q,end:q+1},Z.push(te));return Z}function D(U){const Z=U.sort((K,Y)=>K.start-Y.start),te=[];let q;for(const K of Z)!q||!$(q,K)?(q=K,te.push(K)):(q.start=Math.min(q.start,K.start),q.end=Math.max(q.end,K.end));return te}function $(U,Z){return!(U.end<Z.start||Z.end<U.start)}function k(U,Z,te,q,K,Y){const ie=r(U,te,q,K,Y),$e=r(Z,te,q,K,Y),ue=ie.score,ve=$e.score;if((ue===u||ve===u)&&ue!==ve)return ue===u?-1:1;if(ue>t||ve>t){if(ue!==ve)return ue>ve?-1:1;if(ue<o&&ve<o){const se=C(ie.labelMatch,$e.labelMatch);if(se!==0)return se}const Ce=K.getItemLabel(U)||"",oe=K.getItemLabel(Z)||"";if(Ce.length!==oe.length)return Ce.length-oe.length}if(ue!==ve)return ue>ve?-1:1;const _=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,B=Array.isArray($e.labelMatch)&&$e.labelMatch.length>0;if(_&&!B)return-1;if(B&&!_)return 1;const ee=S(U,ie,K),pe=S(Z,$e,K);return ee&&pe&&ee!==pe?pe>ee?-1:1:I(U,Z,te,K)}function S(U,Z,te){let q=-1,K=-1;if(Z.descriptionMatch&&Z.descriptionMatch.length?q=Z.descriptionMatch[0].start:Z.labelMatch&&Z.labelMatch.length&&(q=Z.labelMatch[0].start),Z.labelMatch&&Z.labelMatch.length){if(K=Z.labelMatch[Z.labelMatch.length-1].end,Z.descriptionMatch&&Z.descriptionMatch.length){const Y=te.getItemDescription(U);Y&&(K+=Y.length)}}else Z.descriptionMatch&&Z.descriptionMatch.length&&(K=Z.descriptionMatch[Z.descriptionMatch.length-1].end);return K-q}function C(U,Z){if(!U&&!Z||(!U||!U.length)&&(!Z||!Z.length))return 0;if(!Z||!Z.length)return-1;if(!U||!U.length)return 1;const te=U[0].start,K=U[U.length-1].end-te,Y=Z[0].start,$e=Z[Z.length-1].end-Y;return K===$e?0:$e<K?1:-1}function I(U,Z,te,q){const K=q.getItemLabel(U)||"",Y=q.getItemLabel(Z)||"",ie=q.getItemDescription(U),$e=q.getItemDescription(Z),ue=K.length+(ie?ie.length:0),ve=Y.length+($e?$e.length:0);if(ue!==ve)return ue-ve;const _=q.getItemPath(U),B=q.getItemPath(Z);return _&&B&&_.length!==B.length?_.length-B.length:K!==Y?(0,d.$rr)(K,Y,te.normalized):ie&&$e&&ie!==$e?(0,d.$rr)(ie,$e,te.normalized):_&&B&&_!==B?(0,d.$rr)(_,B,te.normalized):0}function F(U){return U.startsWith('"')&&U.endsWith('"')}const j=" ";function z(U){typeof U!="string"&&(U="");const Z=U.toLowerCase(),{pathNormalized:te,normalized:q,normalizedLowercase:K}=M(U),Y=te.indexOf(R.sep)>=0,ie=F(U);let $e;const ue=U.split(j);if(ue.length>1)for(const ve of ue){const _=F(ve),{pathNormalized:B,normalized:ee,normalizedLowercase:pe}=M(ve);ee&&($e||($e=[]),$e.push({original:ve,originalLowercase:ve.toLowerCase(),pathNormalized:B,normalized:ee,normalizedLowercase:pe,expectContiguousMatch:_}))}return{original:U,originalLowercase:Z,pathNormalized:te,normalized:q,normalizedLowercase:K,values:$e,containsPathSeparator:Y,expectContiguousMatch:ie}}function M(U){let Z;N.$i?Z=U.replace(/\//g,R.sep):Z=U.replace(/\\/g,R.sep);const te=(0,b.$if)(Z).replace(/\s|"/g,"");return{pathNormalized:Z,normalized:te,normalizedLowercase:te.toLowerCase()}}function T(U){return Array.isArray(U)?z(U.map(Z=>Z.original).join(j)):z(U.original)}}),define(ke[101],Se([1,0,17]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Rs=R,e.$Ss=N,e.$Ts=b,e.$Us=E,e.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},O={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const P=(0,d.$pc)(A),p=L[P.toLowerCase()];return p!==void 0?p:N(A)}function N(A){const P=(0,d.$pc)(A);return O[P.toLowerCase()]}function b(A){for(const P in O)if(O[P]===A)return P}const m=/^(.+)\/(.+?)(;.+)?$/;function E(A,P){const p=m.exec(A);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:P?void 0:A}}),define(ke[102],Se([1,0,12]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=R,e.$nm=N;var L;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(L||(e.Source=L={}));var O;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(O||(e.TerminateResponseCode=O={}));function R(b,...m){const E=m.reduce((p,y)=>(p[y]=!0,p),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!E[p]).forEach(p=>{for(let y=0;y<A.length;y++)if(p.search(A[y])!==-1){delete b[p];break}})}function N(b){b&&(delete b.DEBUG,d.$j&&delete b.DYLD_LIBRARY_PATH,d.$k&&delete b.LD_PRELOAD)}}),define(ke[2],Se([1,0,17,12]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=w,e.$xc=u;const O=/^\w[\w\d+.-]*$/,R=/^\//,N=/^\/\//;function b(c,s){if(!c.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!O.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!R.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(c,s){return!c&&!s?"file":c}function E(c,s){switch(c){case"https":case"http":case"file":s?s[0]!==P&&(s=P+s):s=P;break}return s}const A="",P="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(s){return s instanceof y?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,v,g,D,$,k=!1){typeof s=="object"?(this.scheme=s.scheme||A,this.authority=s.authority||A,this.path=s.path||A,this.query=s.query||A,this.fragment=s.fragment||A):(this.scheme=m(s,k),this.authority=v||A,this.path=E(this.scheme,g||A),this.query=D||A,this.fragment=$||A,b(this,k))}get fsPath(){return u(this,!1)}with(s){if(!s)return this;let{scheme:v,authority:g,path:D,query:$,fragment:k}=s;return v===void 0?v=this.scheme:v===null&&(v=A),g===void 0?g=this.authority:g===null&&(g=A),D===void 0?D=this.path:D===null&&(D=A),$===void 0?$=this.query:$===null&&($=A),k===void 0?k=this.fragment:k===null&&(k=A),v===this.scheme&&g===this.authority&&D===this.path&&$===this.query&&k===this.fragment?this:new f(v,g,D,$,k)}static parse(s,v=!1){const g=p.exec(s);return g?new f(g[2]||A,r(g[4]||A),r(g[5]||A),r(g[7]||A),r(g[9]||A),v):new f(A,A,A,A,A)}static file(s){let v=A;if(L.$i&&(s=s.replace(/\\/g,P)),s[0]===P&&s[1]===P){const g=s.indexOf(P,2);g===-1?(v=s.substring(2),s=P):(v=s.substring(2,g),s=s.substring(g)||P)}return new f("file",v,s,A,A)}static from(s,v){return new f(s.scheme,s.authority,s.path,s.query,s.fragment,v)}static joinPath(s,...v){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return L.$i&&s.scheme==="file"?g=y.file(d.$gc.join(u(s,!0),...v)).path:g=d.$hc.join(s.path,...v),s.with({path:g})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof y)return s;{const v=new f(s);return v._formatted=s.external??null,v._fsPath=s._sep===h?s.fsPath??null:null,v}}else return s}}e.URI=y;function w(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}const h=L.$i?1:void 0;class f extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=h),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(c,s,v){let g,D=-1;for(let $=0;$<c.length;$++){const k=c.charCodeAt($);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||s&&k===47||v&&k===91||v&&k===93||v&&k===58)D!==-1&&(g+=encodeURIComponent(c.substring(D,$)),D=-1),g!==void 0&&(g+=c.charAt($));else{g===void 0&&(g=c.substr(0,$));const S=a[k];S!==void 0?(D!==-1&&(g+=encodeURIComponent(c.substring(D,$)),D=-1),g+=S):D===-1&&(D=$)}}return D!==-1&&(g+=encodeURIComponent(c.substring(D))),g!==void 0?g:c}function i(c){let s;for(let v=0;v<c.length;v++){const g=c.charCodeAt(v);g===35||g===63?(s===void 0&&(s=c.substr(0,v)),s+=a[g]):s!==void 0&&(s+=c[v])}return s!==void 0?s:c}function u(c,s){let v;return c.authority&&c.path.length>1&&c.scheme==="file"?v=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?s?v=c.path.substr(1):v=c.path[1].toLowerCase()+c.path.substr(2):v=c.path,L.$i&&(v=v.replace(/\//g,"\\")),v}function o(c,s){const v=s?i:n;let g="",{scheme:D,authority:$,path:k,query:S,fragment:C}=c;if(D&&(g+=D,g+=":"),($||D==="file")&&(g+=P,g+=P),$){let I=$.indexOf("@");if(I!==-1){const F=$.substr(0,I);$=$.substr(I+1),I=F.lastIndexOf(":"),I===-1?g+=v(F,!1,!1):(g+=v(F.substr(0,I),!1,!1),g+=":",g+=v(F.substr(I+1),!1,!0)),g+="@"}$=$.toLowerCase(),I=$.lastIndexOf(":"),I===-1?g+=v($,!1,!0):(g+=v($.substr(0,I),!1,!0),g+=$.substr(I))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const I=k.charCodeAt(1);I>=65&&I<=90&&(k=`/${String.fromCharCode(I+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const I=k.charCodeAt(0);I>=65&&I<=90&&(k=`${String.fromCharCode(I+32)}:${k.substr(2)}`)}g+=v(k,!0,!1)}return S&&(g+="?",g+=v(S,!1,!1)),C&&(g+="#",g+=s?C:n(C,!1,!1)),g}function t(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+t(c.substr(3)):c}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(c){return c.match(l)?c.replace(l,s=>t(s)):c}}),define(ke[197],Se([1,0,2]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=L,e.$Wq=O,e.$Xq=R,e.log=b;function L(E){const A=E;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function O(E){const A=[];let P;try{const p=JSON.parse(E.arguments),y=p[p.length-1];y&&y.__$stack&&(p.pop(),P=y.__$stack),A.push(...p)}catch{A.push("Unable to log remote console arguments",E.arguments)}return{args:A,stack:P}}function R(E){if(typeof E!="string")return R(O(E).stack);const A=E;if(A){const P=N(A),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(p&&p.length===4)return{uri:d.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function N(E){if(!E)return E;const A=E.indexOf(`
`);return A===-1?E:E.substring(0,A)}function b(E,A){const{args:P,stack:p}=O(E),y=typeof P[0]=="string"&&P.length===1;let w=N(p);w&&(w=`(${w.trim()})`);let h=[];if(typeof P[0]=="string"?w&&y?h=[`%c[${A}] %c${P[0]} %c${w}`,m("blue"),m(""),m("grey")]:h=[`%c[${A}] %c${P[0]}`,m("blue"),m(""),...P.slice(1)]:h=[`%c[${A}]%`,m("blue"),...P],w&&!y&&h.push(w),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,h)}function m(E){return`color: ${E}`}}),define(ke[58],Se([1,0,21,2]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=O,e.$5h=R,e.$6h=b;function O(m){return JSON.stringify(m,N)}function R(m){let E=JSON.parse(m);return E=b(E),E}function N(m,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function b(m,E=0){if(!m||E>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return L.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof d.$Ge||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let A=0;A<m.length;++A)m[A]=b(m[A],E+1);else for(const A in m)Object.hasOwnProperty.call(m,A)&&(m[A]=b(m[A],E+1))}return m}}),define(ke[15],Se([1,0,13,12,14,2,17]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=m,e.$Gg=E,e.$Kg=P;var b;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(b||(e.Schemas=b={}));function m(w,h){return R.URI.isUri(w)?(0,O.$yf)(w.scheme,h):(0,O.$zf)(w,h+":")}function E(w,...h){return h.some(f=>m(w,f))}e.$Hg="vscode-tkn",e.$Ig="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h,f){this.f=P(h,f)}getServerRootPath(){return this.f}get g(){return N.$hc.join(this.f,b.vscodeRemoteResource)}set(h,f,a){this.a[h]=f,this.b[h]=a}setConnectionToken(h,f){this.c[h]=f}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(o){return d.$1(o),h}const f=h.authority;let a=this.a[f];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const n=this.b[f],i=this.c[f];let u=`path=${encodeURIComponent(h.path)}`;return typeof i=="string"&&(u+=`&${e.$Ig}=${encodeURIComponent(i)}`),R.URI.from({scheme:L.$o?this.d:b.vscodeRemoteResource,authority:`${a}:${n}`,path:this.g,query:u})}}e.$Jg=new A;function P(w,h){return N.$hc.join(h??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class p{static{this.a=e.$Pg}asBrowserUri(h){const f=this.b(h,le);return this.uriToBrowserUri(f)}uriToBrowserUri(h){return h.scheme===b.vscodeRemote?e.$Jg.rewrite(h):h.scheme===b.file&&(L.$m||L.$q===`${b.vscodeFileResource}://${p.a}`)?h.with({scheme:b.vscodeFileResource,authority:h.authority||p.a,query:null,fragment:null}):h}asFileUri(h){const f=this.b(h,le);return this.uriToFileUri(f)}uriToFileUri(h){return h.scheme===b.vscodeFileResource?h.with({scheme:b.file,authority:h.authority!==p.a?h.authority:null,query:null,fragment:null}):h}b(h,f){return R.URI.isUri(h)?h:R.URI.parse(f.toUrl(h))}}e.$Qg=new p;var y;(function(w){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(h.get("3"));const f="vscode-coi";function a(i){let u;typeof i=="string"?u=new URL(i).searchParams:i instanceof URL?u=i.searchParams:R.URI.isUri(i)&&(u=new URL(i.toString(!0)).searchParams);const o=u?.get(f);if(o)return h.get(o)}w.getHeadersFromQuery=a;function n(i,u,o){if(!globalThis.crossOriginIsolated)return;const t=u&&o?"3":o?"2":"1";i instanceof URLSearchParams?i.set(f,t):i[f]=t}w.addSearchParam=n})(y||(e.COI=y={}))}),define(ke[198],Se([1,0,163,15,12,2]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1D=A;class N{constructor(p,y,w){this.id=p,this.dependencies=y,this.callback=w}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,y,w)=>{typeof p!="string"&&(w=y,y=p,p=null),(typeof y!="object"||!Array.isArray(y))&&(w=y,y=null),this.c.push(new N(p,y,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const y=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!y)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(p){return new Promise((y,w)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const f=()=>{h.removeEventListener("load",a),h.removeEventListener("error",n)},a=i=>{f(),y(this.c.pop())},n=i=>{f(),w(i)};h.addEventListener("load",a),h.addEventListener("error",n),this.f&&(p=this.f.createScriptURL(p)),h.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(h)})}i(p){return new Promise((y,w)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),y(this.c.pop())}catch(h){w(h)}})}async j(p){try{const y=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,f=R.URI.parse(p).fsPath,a=y.readFileSync(f).toString(),n=h.wrap(a.replace(/^#!.*/,""));return new w.Script(n).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const m=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function A(P,p,y){if(d.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[P]&&(P=E[P]);const w=`${P}/${p}`;if(m.has(w))return m.get(w);let h;if(/^\w[\w\d+.-]*:\/\//.test(w))h=w;else{const i=`${y&&!O.$o?L.$Ng:L.$Mg}/${w}`;h=L.$Qg.asBrowserUri(i).toString(!0)}const f=b.INSTANCE.load(h);return m.set(w,f),f}else return await new Promise((w,h)=>{le([P],w,h)})}}),define(ke[23],Se([1,0,31,15,17,12,14,2]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=m,e.$gh=A,e.$hh=p;function m(y){return(0,b.$xc)(y,!0)}class E{constructor(w){this.a=w}compare(w,h,f=!1){return w===h?0:(0,N.$rf)(this.getComparisonKey(w,f),this.getComparisonKey(h,f))}isEqual(w,h,f=!1){return w===h?!0:!w||!h?!1:this.getComparisonKey(w,f)===this.getComparisonKey(h,f)}getComparisonKey(w,h=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,h,f=!1){if(w.scheme===h.scheme){if(w.scheme===L.Schemas.file)return d.$vg(m(w),m(h),this.a(w))&&w.query===h.query&&(f||w.fragment===h.fragment);if((0,e.$ch)(w.authority,h.authority))return d.$vg(w.path,h.path,this.a(w),"/")&&w.query===h.query&&(f||w.fragment===h.fragment)}return!1}joinPath(w,...h){return b.URI.joinPath(w,...h)}basenameOrAuthority(w){return(0,e.$7g)(w)||w.authority}basename(w){return O.$hc.basename(w.path)}extname(w){return O.$hc.extname(w.path)}dirname(w){if(w.path.length===0)return w;let h;return w.scheme===L.Schemas.file?h=b.URI.file(O.$nc(m(w))).path:(h=O.$hc.dirname(w.path),w.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),h="/")),w.with({path:h})}normalizePath(w){if(!w.path.length)return w;let h;return w.scheme===L.Schemas.file?h=b.URI.file(O.$ic(m(w))).path:h=O.$hc.normalize(w.path),w.with({path:h})}relativePath(w,h){if(w.scheme!==h.scheme||!(0,e.$ch)(w.authority,h.authority))return;if(w.scheme===L.Schemas.file){const n=O.$mc(m(w),m(h));return R.$i?d.$pg(n):n}let f=w.path||"/";const a=h.path||"/";if(this.a(w)){let n=0;for(const i=Math.min(f.length,a.length);n<i&&!(f.charCodeAt(n)!==a.charCodeAt(n)&&f.charAt(n).toLowerCase()!==a.charAt(n).toLowerCase());n++);f=a.substr(0,n)+f.substr(n)}return O.$hc.relative(f,a)}resolvePath(w,h){if(w.scheme===L.Schemas.file){const f=b.URI.file(O.$lc(m(w),h));return w.with({authority:f.authority,path:f.path})}return h=d.$qg(h),w.with({path:O.$hc.resolve(w.path,h)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,h){return w===h||w!==void 0&&h!==void 0&&(0,N.$yf)(w,h)}hasTrailingPathSeparator(w,h=O.sep){if(w.scheme===L.Schemas.file){const f=m(w);return f.length>d.$rg(f).length&&f[f.length-1]===h}else{const f=w.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,h=O.sep){return(0,e.$dh)(w,h)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,h=O.sep){let f=!1;if(w.scheme===L.Schemas.file){const a=m(w);f=a!==void 0&&a.length===d.$rg(a).length&&a[a.length-1]===h}else{h="/";const a=w.path;f=a.length===1&&a.charCodeAt(a.length-1)===47}return!f&&!(0,e.$dh)(w,h)?w.with({path:w.path+"/"}):w}}e.$Yg=E,e.$Zg=new E(()=>!1),e.$1g=new E(y=>y.scheme===L.Schemas.file?!R.$k:!0),e.$2g=new E(y=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function A(y,w){const h=[];for(let f=0;f<y.length;f++){const a=w(y[f]);y.some((n,i)=>i===f?!1:(0,e.$4g)(a,w(n)))||h.push(y[f])}return h}var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function w(h){const f=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(i=>{const[u,o]=i.split(":");u&&o&&f.set(u,o)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&f.set(y.META_DATA_MIME,n),f}y.parseMetaData=w})(P||(e.DataUri=P={}));function p(y,w,h){if(w){let f=y.path;return f&&f[0]!==O.$hc.sep&&(f=O.$hc.sep+f),y.with({scheme:h,authority:w,path:f})}return y.with({scheme:h})}}),define(ke[7],Se([1,0,22,13,4,3,23,12,174,46]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=A,e.$jh=P,e.$kh=p,e.$lh=y,e.$mh=w,e.$nh=h,e.$oh=f,e.$ph=a,e.$xh=v,e.$yh=g,e.$zh=D,e.$Ah=$,e.$Bh=k,e.$Qh=K,e.$Yh=oe;function A(re){return!!re&&typeof re.then=="function"}function P(re){const G=new d.$pe,ne=re(G.token),me=new Promise((be,Re)=>{const fe=G.token.onCancellationRequested(()=>{fe.dispose(),Re(new L.$5)});Promise.resolve(ne).then(De=>{fe.dispose(),G.dispose(),be(De)},De=>{fe.dispose(),G.dispose(),Re(De)})});return new class{cancel(){G.cancel(),G.dispose()}then(be,Re){return me.then(be,Re)}catch(be){return this.then(void 0,be)}finally(be){return me.finally(be)}}}function p(re,G,ne){return new Promise((me,be)=>{const Re=G.onCancellationRequested(()=>{Re.dispose(),me(ne)});re.then(me,be).finally(()=>Re.dispose())})}function y(re,G){return new Promise((ne,me)=>{const be=G.onCancellationRequested(()=>{be.dispose(),me(new L.$5)});re.then(ne,me).finally(()=>be.dispose())})}async function w(re){let G=-1;const ne=re.map((me,be)=>me.then(Re=>(G=be,Re)));try{return await Promise.race(ne)}finally{re.forEach((me,be)=>{be!==G&&me.cancel()})}}function h(re,G,ne){let me;const be=setTimeout(()=>{me?.(void 0),ne?.()},G);return Promise.race([re.finally(()=>clearTimeout(be)),new Promise(Re=>me=Re)])}function f(re){return new Promise((G,ne)=>{const me=re();A(me)?me.then(G,ne):G(me)})}function a(){let re,G;return{promise:new Promise((me,be)=>{re=me,G=be}),resolve:re,reject:G}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const ne=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(ne,ne).then(me)})}return new Promise((ne,me)=>{this.b.then(ne,me)})}return this.a=G(),new Promise((ne,me)=>{this.a.then(be=>{this.a=null,ne(be)},be=>{this.a=null,me(be)})})}dispose(){this.f=!0}}e.$qh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$rh=i;class u{constructor(){this.a=new Map}queue(G,ne){const be=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(G)===be&&this.a.delete(G)});return this.a.set(G,be),be}}e.$sh=u;const o=(re,G)=>{let ne=!0;const me=setTimeout(()=>{ne=!1,G()},re);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(me),ne=!1}}},t=re=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,re())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class l{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,ne=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((be,Re)=>{this.d=be,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=ne===m.$be?t(me):o(ne,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=l;class r{constructor(G){this.a=new l(G),this.b=new n}trigger(G,ne){return this.a.trigger(()=>this.b.queue(G),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=r;class c{constructor(){this.a=!1,this.b=new Promise((G,ne)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=c;class s extends c{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$wh=s;function v(re,G){return G?new Promise((ne,me)=>{const be=setTimeout(()=>{Re.dispose(),ne()},re),Re=G.onCancellationRequested(()=>{clearTimeout(be),Re.dispose(),me(new L.$5)})}):P(ne=>v(re,ne))}function g(re,G=0,ne){const me=setTimeout(()=>{re(),ne&&be.dispose()},G),be=(0,R.$Tc)(()=>{clearTimeout(me),ne?.deleteAndLeak(be)});return ne?.add(be),be}function D(re){const G=[];let ne=0;const me=re.length;function be(){return ne<me?re[ne++]():null}function Re(fe){fe!=null&&G.push(fe);const De=be();return De?De.then(Re):Promise.resolve(G)}return Promise.resolve(null).then(Re)}function $(re,G=me=>!!me,ne=null){let me=0;const be=re.length,Re=()=>{if(me>=be)return Promise.resolve(ne);const fe=re[me++];return Promise.resolve(fe()).then(Ae=>G(Ae)?Promise.resolve(Ae):Re())};return Re()}function k(re,G=me=>!!me,ne=null){if(re.length===0)return Promise.resolve(ne);let me=re.length;const be=()=>{me=-1;for(const Re of re)Re.cancel?.()};return new Promise((Re,fe)=>{for(const De of re)De.then(Ae=>{--me>=0&&G(Ae)?(be(),Re(Ae)):me===0&&Re(ne)}).catch(Ae=>{--me>=0&&(be(),fe(Ae))})})}class S{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new O.$ee}whenIdle(){return this.size>0?O.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,me)=>{this.g.push({factory:G,c:ne,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const ne=G.factory();ne.then(G.c,G.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=S;class C extends S{constructor(){super(1)}}e.$Dh=C;class I{constructor(){this.a=new Y,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$Eh=I;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new ue;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,ne=N.$Zg){const me=ne.getComparisonKey(G);return this.a.get(me)?.size??0}queueFor(G,ne,me=N.$Zg){const be=me.getComparisonKey(G);let Re=this.a.get(be);if(!Re){Re=new C;const fe=this.f++,De=O.Event.once(Re.onDrained)(()=>{Re?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$5c),this.d.set(fe,De),this.a.set(be,Re)}return Re.queue(ne)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=F;class j{constructor(G,ne){this.a=-1,typeof G=="function"&&typeof ne=="number"&&this.setIfNotSet(G,ne)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,ne){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},ne)}setIfNotSet(G,ne){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},ne))}}e.$Gh=j;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,ne,me=globalThis){this.cancel();const be=me.setInterval(()=>{G()},ne);this.d=(0,R.$Tc)(()=>{me.clearInterval(be),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=z;class M{constructor(G,ne){this.b=-1,this.a=G,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=M;class T{constructor(G,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=G,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=T;class U extends M{constructor(G,ne){super(G,ne),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$Kh=U;class Z extends R.$Vc{constructor(G,ne){super(),this.g=G,this.h=ne,this.a=[],this.b=this.B(new R.$Wc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of G)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(re,G)=>{(0,b.$B)(()=>{if(ne)return;const me=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$Nh=(re,G,ne)=>{const me=re.requestIdleCallback(G,typeof ne=="number"?{timeout:ne}:void 0);let be=!1;return{dispose(){be||(be=!0,re.cancelIdleCallback(me))}}},e.$Mh=re=>(0,e.$Nh)(globalThis,re)}();class te{constructor(G,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Nh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=te;class q extends te{constructor(G){super(globalThis,G)}}e.$Ph=q;async function K(re,G,ne){let me;for(let be=0;be<ne;be++)try{return await re()}catch(Re){me=Re,await v(G)}throw me}class Y{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,ne,me){return this.a={taskId:G,cancel:()=>me?.(),promise:ne},ne.then(()=>this.d(G),()=>this.d(G)),ne}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:ne,resolve:me,reject:be}=a();this.b={run:G,promise:ne,promiseResolve:me,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=Y;class ie{constructor(G,ne=()=>Date.now()){this.d=G,this.f=ne,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$Sh=ie;var $e;(function(re){re[re.Resolved=0]="Resolved",re[re.Rejected=1]="Rejected"})($e||($e={}));class ue{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,ne)=>{this.a=G,this.b=ne})}complete(G){return new Promise(ne=>{this.a(G),this.d={outcome:0,value:G},ne()})}error(G){return new Promise(ne=>{this.b(G),this.d={outcome:1,value:G},ne()})}cancel(){return this.error(new L.$5)}}e.$Th=ue;var ve;(function(re){async function G(me){let be;const Re=await Promise.all(me.map(fe=>fe.then(De=>De,De=>{be||(be=De)})));if(typeof be<"u")throw be;return Re}re.settled=G;function ne(me){return new Promise(async(be,Re)=>{try{await me(be,Re)}catch(fe){Re(fe)}})}re.withAsyncBody=ne})(ve||(e.Promises=ve={}));class _{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=_;class B{constructor(G){this.b=G,this.a=new E.$V(()=>new _(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=B;var ee;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(ee||(ee={}));class pe{static fromArray(G){return new pe(ne=>{ne.emitMany(G)})}static fromPromise(G){return new pe(async ne=>{ne.emitMany(await G)})}static fromPromises(G){return new pe(async ne=>{await Promise.all(G.map(async me=>ne.emitOne(await me)))})}static merge(G){return new pe(async ne=>{await Promise.all(G.map(async me=>{for await(const be of me)ne.emitOne(be)}))})}static{this.EMPTY=pe.fromArray([])}constructor(G,ne){this.a=0,this.b=[],this.d=null,this.f=ne,this.g=new O.$ee,queueMicrotask(async()=>{const me={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(G(me)),this.k()}catch(be){this.l(be)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await O.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(G,ne){return new pe(async me=>{for await(const be of G)me.emitOne(ne(be))})}map(G){return pe.map(this,G)}static filter(G,ne){return new pe(async me=>{for await(const be of G)ne(be)&&me.emitOne(be)})}filter(G){return pe.filter(this,G)}static coalesce(G){return pe.filter(G,ne=>!!ne)}coalesce(){return pe.coalesce(this)}static async toPromise(G){const ne=[];for await(const me of G)ne.push(me);return ne}toPromise(){return pe.toPromise(this)}h(G){this.a===0&&(this.b.push(G),this.g.fire())}j(G){this.a===0&&(this.b=this.b.concat(G),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(G){this.a===0&&(this.a=2,this.d=G,this.g.fire())}}e.$Wh=pe;class Ce extends pe{constructor(G,ne){super(ne),this.m=G}cancel(){this.m.cancel()}}e.$Xh=Ce;function oe(re){const G=new d.$pe,ne=re(G.token);return new Ce(G,async me=>{const be=G.token.onCancellationRequested(()=>{be.dispose(),G.dispose(),me.reject(new L.$5)});try{for await(const Re of ne){if(G.token.isCancellationRequested)return;me.emitOne(Re)}be.dispose(),G.dispose()}catch(Re){be.dispose(),G.dispose(),me.reject(Re)}})}class se{constructor(G){this.a=new ue,this.b=new pe(be=>{if(ne){be.reject(ne);return}return me&&be.emitMany(me),this.d=Re=>be.reject(Re),this.f=Re=>be.emitOne(Re),this.a.p},G);let ne,me;this.f=be=>{me||(me=[]),me.push(be)},this.d=be=>{ne||(ne=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$Zh=se}),define(ke[35],Se([1,0,19,7,31,27,17,12,14]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=E,e.$ok=w,e.$pk=C,e.$qk=I,e.$rk=F,e.$sk=j,e.$tk=z,e.$uk=Z;function E(){return Object.create(null)}e.$mk="**",e.$nk="/";const A="[/\\\\]",P="[^/\\\\]",p=/\//g;function y(te,q){switch(te){case 0:return"";case 1:return`${P}*?`;default:return`(?:${A}|${P}+${A}${q?`|${A}${P}+`:""})*?`}}function w(te,q){if(!te)return[];const K=[];let Y=!1,ie=!1,$e="";for(const ue of te){switch(ue){case q:if(!Y&&!ie){K.push($e),$e="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}$e+=ue}return $e&&K.push($e),K}function h(te){if(!te)return"";let q="";const K=w(te,e.$nk);if(K.every(Y=>Y===e.$mk))q=".*";else{let Y=!1;K.forEach((ie,$e)=>{if(ie===e.$mk){if(Y)return;q+=y(2,$e===K.length-1)}else{let ue=!1,ve="",_=!1,B="";for(const ee of ie){if(ee!=="}"&&ue){ve+=ee;continue}if(_&&(ee!=="]"||!B)){let pe;ee==="-"?pe=ee:(ee==="^"||ee==="!")&&!B?pe="^":ee===e.$nk?pe="":pe=(0,m.$af)(ee),B+=pe;continue}switch(ee){case"{":ue=!0;continue;case"[":_=!0;continue;case"}":{const Ce=`(?:${w(ve,",").map(oe=>h(oe)).join("|")})`;q+=Ce,ue=!1,ve="";break}case"]":{q+="["+B+"]",_=!1,B="";break}case"?":q+=P;continue;case"*":q+=y(1);continue;default:q+=(0,m.$af)(ee)}}$e<K.length-1&&(K[$e+1]!==e.$mk||$e+2<K.length)&&(q+=A)}Y=ie===e.$mk})}return q}const f=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),l=function(){return!1},r=function(){return null};function c(te,q){if(!te)return r;let K;typeof te!="string"?K=te.pattern:K=te,K=K.trim();const Y=`${K}_${!!q.trimForExclusions}`;let ie=t.get(Y);if(ie)return s(ie,te);let $e;return f.test(K)?ie=g(K.substr(4),K):($e=a.exec(v(K,q)))?ie=D($e[1],K):(q.trimForExclusions?i:n).test(K)?ie=$(K,q):($e=u.exec(v(K,q)))?ie=k($e[1].substr(1),K,!0):($e=o.exec(v(K,q)))?ie=k($e[1],K,!1):ie=S(K),t.set(Y,ie),s(ie,te)}function s(te,q){if(typeof q=="string")return te;const K=function(Y,ie){return(0,O.$vg)(Y,q.base,!b.$k)?te((0,m.$ff)(Y.substr(q.base.length),N.sep),ie):null};return K.allBasenames=te.allBasenames,K.allPaths=te.allPaths,K.basenames=te.basenames,K.patterns=te.patterns,K}function v(te,q){return q.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function g(te,q){return function(K,Y){return typeof K=="string"&&K.endsWith(te)?q:null}}function D(te,q){const K=`/${te}`,Y=`\\${te}`,ie=function(ue,ve){return typeof ue!="string"?null:ve?ve===te?q:null:ue===te||ue.endsWith(K)||ue.endsWith(Y)?q:null},$e=[te];return ie.basenames=$e,ie.patterns=[q],ie.allBasenames=$e,ie}function $(te,q){const K=U(te.slice(1,-1).split(",").map(ve=>c(ve,q)).filter(ve=>ve!==r),te),Y=K.length;if(!Y)return r;if(Y===1)return K[0];const ie=function(ve,_){for(let B=0,ee=K.length;B<ee;B++)if(K[B](ve,_))return te;return null},$e=K.find(ve=>!!ve.allBasenames);$e&&(ie.allBasenames=$e.allBasenames);const ue=K.reduce((ve,_)=>_.allPaths?ve.concat(_.allPaths):ve,[]);return ue.length&&(ie.allPaths=ue),ie}function k(te,q,K){const Y=N.sep===N.$hc.sep,ie=Y?te:te.replace(p,N.sep),$e=N.sep+ie,ue=N.$hc.sep+te;let ve;return K?ve=function(_,B){return typeof _=="string"&&(_===ie||_.endsWith($e)||!Y&&(_===te||_.endsWith(ue)))?q:null}:ve=function(_,B){return typeof _=="string"&&(_===ie||!Y&&_===te)?q:null},ve.allPaths=[(K?"*/":"./")+te],ve}function S(te){try{const q=new RegExp(`^${h(te)}$`);return function(K){return q.lastIndex=0,typeof K=="string"&&q.test(K)?te:null}}catch{return r}}function C(te,q,K){return!te||typeof q!="string"?!1:I(te)(q,void 0,K)}function I(te,q={}){if(!te)return l;if(typeof te=="string"||F(te)){const K=c(te,q);if(K===r)return l;const Y=function(ie,$e){return!!K(ie,$e)};return K.allBasenames&&(Y.allBasenames=K.allBasenames),K.allPaths&&(Y.allPaths=K.allPaths),Y}return M(te,q)}function F(te){const q=te;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function j(te){return te.allBasenames||[]}function z(te){return te.allPaths||[]}function M(te,q){const K=U(Object.getOwnPropertyNames(te).map(ve=>T(ve,te[ve],q)).filter(ve=>ve!==r)),Y=K.length;if(!Y)return r;if(!K.some(ve=>!!ve.requiresSiblings)){if(Y===1)return K[0];const ve=function(ee,pe){let Ce;for(let oe=0,se=K.length;oe<se;oe++){const re=K[oe](ee,pe);if(typeof re=="string")return re;(0,L.$ih)(re)&&(Ce||(Ce=[]),Ce.push(re))}return Ce?(async()=>{for(const oe of Ce){const se=await oe;if(typeof se=="string")return se}return null})():null},_=K.find(ee=>!!ee.allBasenames);_&&(ve.allBasenames=_.allBasenames);const B=K.reduce((ee,pe)=>pe.allPaths?ee.concat(pe.allPaths):ee,[]);return B.length&&(ve.allPaths=B),ve}const ie=function(ve,_,B){let ee,pe;for(let Ce=0,oe=K.length;Ce<oe;Ce++){const se=K[Ce];se.requiresSiblings&&B&&(_||(_=(0,N.$oc)(ve)),ee||(ee=_.substr(0,_.length-(0,N.$pc)(ve).length)));const re=se(ve,_,ee,B);if(typeof re=="string")return re;(0,L.$ih)(re)&&(pe||(pe=[]),pe.push(re))}return pe?(async()=>{for(const Ce of pe){const oe=await Ce;if(typeof oe=="string")return oe}return null})():null},$e=K.find(ve=>!!ve.allBasenames);$e&&(ie.allBasenames=$e.allBasenames);const ue=K.reduce((ve,_)=>_.allPaths?ve.concat(_.allPaths):ve,[]);return ue.length&&(ie.allPaths=ue),ie}function T(te,q,K){if(q===!1)return r;const Y=c(te,K);if(Y===r)return r;if(typeof q=="boolean")return Y;if(q){const ie=q.when;if(typeof ie=="string"){const $e=(ue,ve,_,B)=>{if(!B||!Y(ue,ve))return null;const ee=ie.replace("$(basename)",()=>_),pe=B(ee);return(0,L.$ih)(pe)?pe.then(Ce=>Ce?te:null):pe?te:null};return $e.requiresSiblings=!0,$e}}return Y}function U(te,q){const K=te.filter(ve=>!!ve.basenames);if(K.length<2)return te;const Y=K.reduce((ve,_)=>{const B=_.basenames;return B?ve.concat(B):ve},[]);let ie;if(q){ie=[];for(let ve=0,_=Y.length;ve<_;ve++)ie.push(q)}else ie=K.reduce((ve,_)=>{const B=_.patterns;return B?ve.concat(B):ve},[]);const $e=function(ve,_){if(typeof ve!="string")return null;if(!_){let ee;for(ee=ve.length;ee>0;ee--){const pe=ve.charCodeAt(ee-1);if(pe===47||pe===92)break}_=ve.substr(ee)}const B=Y.indexOf(_);return B!==-1?ie[B]:null};$e.basenames=Y,$e.patterns=ie,$e.allBasenames=Y;const ue=te.filter(ve=>!ve.basenames);return ue.push($e),ue}function Z(te,q){return(0,d.$ub)(te,q,(K,Y)=>typeof K=="string"&&typeof Y=="string"?K===Y:typeof K!="string"&&typeof Y!="string"?K.base===Y.base&&K.pattern===Y.pattern:!1)}}),define(ke[81],Se([1,0,13,176,23,14,2]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=E,e.$Vk=A,e.$Wk=P,e.$Xk=p,e.$Yk=y,e.$Zk=w,e.$1k=h,e.$2k=f;var b;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class m{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,d.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=p(this.supportThemeIcons?(0,L.$Nk)(n):n).replace(/([ \t]+)/g,(u,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${y(i,n)}
`,this}appendLink(n,i,u){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(n,i){const u=new RegExp((0,R.$af)(i),"g");return n.replace(u,(o,t)=>n.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.$Tk=m;function E(a){return A(a)?!a.value:Array.isArray(a)?a.every(E):!0}function A(a){return a instanceof m?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function P(a,n){return a===n?!0:!a||!n?!1:a.value===n.value&&a.isTrusted===n.isTrusted&&a.supportThemeIcons===n.supportThemeIcons&&a.supportHtml===n.supportHtml&&(a.baseUri===n.baseUri||!!a.baseUri&&!!n.baseUri&&(0,O.$3g)(N.URI.from(a.baseUri),N.URI.from(n.baseUri)))}function p(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function y(a,n){const i=a.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,u=i>=3?i+1:3;return[`${"`".repeat(u)}${n}`,a,`${"`".repeat(u)}`].join(`
`)}function w(a){return a.replace(/"/g,"&quot;")}function h(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function f(a){const n=[],i=a.split("|").map(o=>o.trim());a=i[0];const u=i[1];if(u){const o=/height=(\d+)/.exec(u),t=/width=(\d+)/.exec(u),l=o?o[1]:"",r=t?t[1]:"",c=isFinite(parseInt(r)),s=isFinite(parseInt(l));c&&n.push(`width="${r}"`),s&&n.push(`height="${l}"`)}return{href:a,dimensions:n}}}),define(ke[103],Se([1,0,19,31,17,12,23,14]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xw=m,e.$yw=A,e.$zw=p,e.$Aw=y,e.$Bw=a,e.$Cw=i,e.$Dw=u,e.$Ew=o,e.$Fw=t,e.$Gw=l;function m(c,s){const{os:v,tildify:g,relative:D}=s;if(D){const S=E(c,D,v);if(typeof S=="string")return S}let $=c.fsPath;if(v===1&&!R.$i?$=$.replace(/\//g,"\\"):v!==1&&R.$i&&($=$.replace(/\\/g,"/")),v!==1&&g?.userHome){const S=g.userHome.fsPath;let C;c.scheme!==g.userHome.scheme&&c.path[0]===O.$hc.sep&&c.path[1]!==O.$hc.sep?C=g.userHome.with({path:c.path}).fsPath:C=$,$=p(C,S,v)}return(v===1?O.$gc:O.$hc).normalize(A($,v===1))}function E(c,s,v){const g=v===1?O.$gc:O.$hc,D=v===3?N.$Zg:N.$2g,$=s.getWorkspace(),k=(0,d.$Ob)($.folders);if(!k)return;c.scheme!==k.uri.scheme&&c.path[0]===O.$hc.sep&&c.path[1]!==O.$hc.sep&&(c=k.uri.with({path:c.path}));const S=s.getWorkspaceFolder(c);if(!S)return;let C;if(D.isEqual(S.uri,c)?C="":C=D.relativePath(S.uri,c)??"",C&&(C=g.normalize(C)),$.folders.length>1&&!s.noPrefix){const I=S.name?S.name:D.basenameOrAuthority(S.uri);C=C?`${I} \u2022 ${C}`:I}return C}function A(c,s=R.$i){return(0,L.$Ag)(c,s)?c.charAt(0).toUpperCase()+c.slice(1):c}let P=Object.create(null);function p(c,s,v=R.OS){if(v===1||!c||!s)return c;let g=P.original===s?P.normalized:void 0;g||(g=s,R.$i&&(g=(0,L.$pg)(g)),g=`${(0,b.$gf)(g,O.$hc.sep)}${O.$hc.sep}`,P={original:s,normalized:g});let D=c;return R.$i&&(D=(0,L.$pg)(D)),(v===3?D.startsWith(g):(0,b.$zf)(D,g))?`~/${D.substr(g.length)}`:c}function y(c,s){return c.replace(/^~($|\/|\\)/,`${s}$1`)}const w="\u2026",h="\\\\",f="~";function a(c,s=O.sep){const v=new Array(c.length);let g=!1;for(let D=0;D<c.length;D++){const $=c[D];if($===""){v[D]=`.${s}`;continue}if(!$){v[D]=$;continue}g=!0;let k="",S=$;S.indexOf(h)===0?(k=S.substr(0,S.indexOf(h)+h.length),S=S.substr(S.indexOf(h)+h.length)):S.indexOf(s)===0?(k=S.substr(0,S.indexOf(s)+s.length),S=S.substr(S.indexOf(s)+s.length)):S.indexOf(f)===0&&(k=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length));const C=S.split(s);for(let I=1;g&&I<=C.length;I++)for(let F=C.length-I;g&&F>=0;F--){g=!1;let j=C.slice(F,F+I).join(s);for(let z=0;!g&&z<c.length;z++)if(z!==D&&c[z]&&c[z].indexOf(j)>-1){const M=F+I===C.length,T=F>0&&c[z].indexOf(s)>-1?s+j:j,U=c[z].endsWith(T);g=!M||U}if(!g){let z="";(C[0].endsWith(":")||k!=="")&&(F===1&&(F=0,I++,j=C[0]+s+j),F>0&&(z=C[0]+s),z=k+z),F>0&&(z=z+w+s),z=z+j,F+I<C.length&&(z=z+s+w),v[D]=z}}g&&(v[D]=$)}return v}var n;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(c,s=Object.create(null)){const v=[];let g=!1,D="";for(const $ of c)if($==="$"||g&&$==="{")D&&v.push({value:D,type:n.TEXT}),D="",g=!0;else if($==="}"&&g){const k=s[D];if(typeof k=="string")k.length&&v.push({value:k,type:n.VARIABLE});else if(k){const S=v[v.length-1];(!S||S.type!==n.SEPARATOR)&&v.push({value:k.label,type:n.SEPARATOR})}D="",g=!1}else D+=$;return D&&!g&&v.push({value:D,type:n.TEXT}),v.filter(($,k)=>{if($.type===n.SEPARATOR){const S=v[k-1],C=v[k+1];return[S,C].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map($=>$.value).join("")}function u(c,s){return R.$j||s?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):c.replace(/&&|&/g,v=>v==="&"?"&&":"&")}function o(c,s){return R.$j||s?c.replace(/\(&&\w\)|&&/g,""):R.$i?c.replace(/&&|&/g,v=>v==="&"?"&&":"&"):c.replace(/&&/g,"_")}function t(c){return c.replace(/&/g,"&&")}function l(c){if(c.endsWith("]")){const s=c.lastIndexOf(" [",c.length-2);if(s!==-1){const v=r(c.substring(0,s)),g=c.substring(s);return{name:v.name+g,parentPath:v.parentPath}}}return r(c)}function r(c){const s=c.indexOf("/")!==-1?O.$hc:O.$gc,v=s.basename(c),g=s.dirname(c);return v.length?{name:v,parentPath:g}:{name:g,parentPath:""}}}),define(ke[134],Se([1,0,21,2]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=b,e.$Bn=E,e.$Cn=A;function O(P){return P.toJSON()}class R{constructor(p){this.a=p}transformIncoming(p){const y=this.a.transformIncoming(p);return y===p?p:O(L.URI.from(y))}transformOutgoing(p){const y=this.a.transformOutgoing(p);return y===p?p:O(L.URI.from(y))}transformOutgoingURI(p){const y=this.a.transformOutgoing(p);return y===p?p:L.URI.from(y)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$yn=R,e.$zn=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function N(P,p,y){if(!P||y>200)return null;if(typeof P=="object"){if(P instanceof L.URI)return p.transformOutgoing(P);for(const w in P)if(Object.hasOwnProperty.call(P,w)){const h=N(P[w],p,y+1);h!==null&&(P[w]=h)}}return null}function b(P,p){const y=N(P,p,0);return y===null?P:y}function m(P,p,y,w){if(!P||w>200)return null;if(typeof P=="object"){if(P.$mid===1)return y?L.URI.revive(p.transformIncoming(P)):p.transformIncoming(P);if(P instanceof d.$Ge)return null;for(const h in P)if(Object.hasOwnProperty.call(P,h)){const f=m(P[h],p,y,w+1);f!==null&&(P[h]=f)}}return null}function E(P,p){const y=m(P,p,!1,0);return y===null?P:y}function A(P,p){const y=m(P,p,!0,0);return y===null?P:y}}),define(ke[32],Se([1,0,53,64,400,7,31,77,17,12,23,2]),function(le,e,d,L,O,R,N,b,m,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=v,e.writeFileSync=D;var p;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function y(T,U=p.UNLINK,Z){if((0,N.$zg)(T))throw new Error("rimraf - will refuse to recursively delete root");return U===p.UNLINK?h(T):w(T,Z)}async function w(T,U=(0,N.$Eg)((0,L.tmpdir)())){try{try{await d.promises.rename(T,U)}catch(Z){return Z.code==="ENOENT"?void 0:h(T)}h(U).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function h(T){return(0,O.promisify)(d.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function f(T){if((0,N.$zg)(T))throw new Error("rimraf - will refuse to recursively delete root");d.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}async function a(T,U){return u(await(U?n(T):(0,O.promisify)(d.readdir)(T)))}async function n(T){try{return await(0,O.promisify)(d.readdir)(T,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const U=[],Z=await a(T);for(const te of Z){let q=!1,K=!1,Y=!1;try{const ie=await e.Promises.lstat((0,m.$kc)(T,te));q=ie.isFile(),K=ie.isDirectory(),Y=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}U.push({name:te,isFile:()=>q,isDirectory:()=>K,isSymbolicLink:()=>Y})}return U}function i(T){return u(d.readdirSync(T))}function u(T){return T.map(U=>typeof U=="string"?E.$j?(0,b.$bm)(U):U:(U.name=E.$j?(0,b.$bm)(U.name):U.name,U))}async function o(T){const U=await a(T),Z=[];for(const te of U)await l.existsDirectory((0,m.$kc)(T,te))&&Z.push(te);return Z}function t(T,U=1e3){return new Promise(Z=>{let te=!1;const q=setInterval(()=>{te||(te=!0,d.access(T,K=>{te=!1,K&&(clearInterval(q),Z(void 0))}))},U)})}var l;(function(T){async function U(q){let K;try{if(K=await e.Promises.lstat(q),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(E.$i&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw ie}throw Y}}T.stat=U;async function Z(q){try{const{stat:K,symbolicLink:Y}=await T.stat(q);return K.isFile()&&Y?.dangling!==!0}catch{}return!1}T.existsFile=Z;async function te(q){try{const{stat:K,symbolicLink:Y}=await T.stat(q);return K.isDirectory()&&Y?.dangling!==!0}catch{}return!1}T.existsDirectory=te})(l||(e.SymlinkSupport=l={}));const r=new R.$Fh;function c(T,U,Z){return r.queueFor(P.URI.file(T),()=>{const te=$(Z);return new Promise((q,K)=>g(T,U,te,Y=>Y?K(Y):q()))},A.$1g)}let s=!0;function v(T){s=T}function g(T,U,Z,te){if(!s)return d.writeFile(T,U,{mode:Z.mode,flag:Z.flag},te);d.open(T,Z.flag,Z.mode,(q,K)=>{if(q)return te(q);d.writeFile(K,U,Y=>{if(Y)return d.close(K,()=>te(Y));d.fdatasync(K,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),v(!1)),d.close(K,$e=>te($e))))})})}function D(T,U,Z){const te=$(Z);if(!s)return d.writeFileSync(T,U,{mode:te.mode,flag:te.flag});const q=d.openSync(T,te.flag,te.mode);try{d.writeFileSync(q,U);try{d.fdatasyncSync(q)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),v(!1)}}finally{d.closeSync(q)}}function $(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function k(T,U,Z=6e4){if(T!==U)try{E.$i&&typeof Z=="number"?await S(T,U,Date.now(),Z):await(0,O.promisify)(d.rename)(T,U)}catch(te){if(T.toLowerCase()!==U.toLowerCase()&&te.code==="EXDEV"||T.endsWith("."))await C(T,U,{preserveSymlinks:!1}),await y(T,p.MOVE);else throw te}}async function S(T,U,Z,te,q=0){try{return await(0,O.promisify)(d.rename)(T,U)}catch(K){if(K.code!=="EACCES"&&K.code!=="EPERM"&&K.code!=="EBUSY")throw K;if(Date.now()-Z>=te)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${K}`),K;if(q===0){let Y=!1;try{const{stat:ie}=await l.stat(U);ie.isFile()||(Y=!0)}catch{}if(Y)throw K}return await(0,R.$xh)(Math.min(100,q*10)),S(T,U,Z,te,q+1)}}async function C(T,U,Z){return F(T,U,{root:{source:T,target:U},options:Z,handledSourcePaths:new Set})}const I=511;async function F(T,U,Z){if(Z.handledSourcePaths.has(T))return;Z.handledSourcePaths.add(T);const{stat:te,symbolicLink:q}=await l.stat(T);if(q){if(Z.options.preserveSymlinks)try{return await M(T,U,Z)}catch{}if(q.dangling)return}return te.isDirectory()?j(T,U,te.mode&I,Z):z(T,U,te.mode&I)}async function j(T,U,Z,te){await e.Promises.mkdir(U,{recursive:!0,mode:Z});const q=await a(T);for(const K of q)await F((0,m.$kc)(T,K),(0,m.$kc)(U,K),te)}async function z(T,U,Z){await e.Promises.copyFile(T,U),await e.Promises.chmod(U,Z)}async function M(T,U,Z){let te=await e.Promises.readlink(T);(0,N.$vg)(te,Z.root.source,!E.$k)&&(te=(0,m.$kc)(Z.root.target,te.substr(Z.root.source.length+1))),await e.Promises.symlink(te,U)}e.Promises=new class{get access(){return(0,O.promisify)(d.access)}get stat(){return(0,O.promisify)(d.stat)}get lstat(){return(0,O.promisify)(d.lstat)}get utimes(){return(0,O.promisify)(d.utimes)}get read(){return(T,U,Z,te,q)=>new Promise((K,Y)=>{d.read(T,U,Z,te,q,(ie,$e,ue)=>ie?Y(ie):K({bytesRead:$e,buffer:ue}))})}get readFile(){return(0,O.promisify)(d.readFile)}get write(){return(T,U,Z,te,q)=>new Promise((K,Y)=>{d.write(T,U,Z,te,q,(ie,$e,ue)=>ie?Y(ie):K({bytesWritten:$e,buffer:ue}))})}get appendFile(){return(0,O.promisify)(d.appendFile)}get fdatasync(){return(0,O.promisify)(d.fdatasync)}get truncate(){return(0,O.promisify)(d.truncate)}get copyFile(){return(0,O.promisify)(d.copyFile)}get open(){return(0,O.promisify)(d.open)}get close(){return(0,O.promisify)(d.close)}get symlink(){return(0,O.promisify)(d.symlink)}get readlink(){return(0,O.promisify)(d.readlink)}get chmod(){return(0,O.promisify)(d.chmod)}get mkdir(){return(0,O.promisify)(d.mkdir)}get unlink(){return(0,O.promisify)(d.unlink)}get rmdir(){return(0,O.promisify)(d.rmdir)}get realpath(){return(0,O.promisify)(d.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return o}get writeFile(){return c}get rm(){return y}get rename(){return k}get copy(){return C}}}),define(ke[104],Se([1,0,53,17,12,14,32]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=b,e.$5q=m,e.$6q=E,e.$7q=A;function b(p){if(O.$k)return p;const y=(0,L.$nc)(p);if(p===y)return p;const w=((0,L.$oc)(p)||p).toLowerCase();try{const f=(0,N.readdirSync)(y).filter(a=>a.toLowerCase()===w);if(f.length===1){const a=b(y);if(a)return(0,L.$kc)(a,f[0])}else if(f.length>1){const a=f.indexOf(w);if(a>=0){const n=b(y);if(n)return(0,L.$kc)(n,f[a])}}}catch{}return null}async function m(p,y){if(O.$k)return p;const w=(0,L.$nc)(p);if(p===w)return p;const h=((0,L.$oc)(p)||p).toLowerCase();try{if(y?.isCancellationRequested)return null;const a=(await N.Promises.readdir(w)).filter(n=>n.toLowerCase()===h);if(a.length===1){const n=await m(w,y);if(n)return(0,L.$kc)(n,a[0])}else if(a.length>1){const n=a.indexOf(h);if(n>=0){const i=await m(w,y);if(i)return(0,L.$kc)(i,a[n])}}}catch{}return null}async function E(p){try{return await N.Promises.realpath(p)}catch{const w=P(p);return await N.Promises.access(w,d.constants.R_OK),w}}function A(p){try{return d.realpathSync(p)}catch{const w=P(p);return d.accessSync(w,d.constants.R_OK),w}}function P(p){return(0,R.$gf)((0,L.$ic)(p),L.sep)}}),define(ke[105],Se([1,0,17,12,52,102,18,32]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=m,e.$pm=E,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function m(P=O.env){return P.comspec||"cmd.exe"}function E(P){let p=[],y=!1;const w=function(h){if(y){p.push(h);return}(!P.send(h,a=>{if(a&&console.error(a),y=!1,p.length>0){const n=p.slice(0);p=[],n.forEach(i=>w(i))}})||L.$i)&&(y=!0)};return{send:w}}var A;(function(P){async function p(y,w,h){if(d.$jc(y))return y;if(w===void 0&&(w=O.cwd()),d.$nc(y)!=="."||(h===void 0&&N.$9f(O.env.PATH)&&(h=O.env.PATH.split(d.$uc)),h===void 0||h.length===0))return d.$kc(w,y);async function a(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(u){u.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of h){let i;if(d.$jc(n)?i=d.$kc(n,y):i=d.$kc(w,n,y),await a(i))return i;let u=i+".com";if(await a(u)||(u=i+".exe",await a(u)))return u}return d.$kc(w,y)}P.findExecutable=p})(A||(e.win32=A={}))});var Ke=this&&this.__decorate||function(le,e,d,L){var O=arguments.length,R=O<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,d):L,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(le,e,d,L);else for(var b=le.length-1;b>=0;b--)(N=le[b])&&(R=(O<3?N(R):O>3?N(e,d,R):N(e,d))||R);return O>3&&R&&Object.defineProperty(e,d,R),R};define(ke[82],Se([1,0,19,7,21,22,56,13,4,3,58,14,18]),function(le,e,d,L,O,R,N,b,m,E,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=v,e.$0h=g,e.$ci=I,e.$di=F;var y;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(y||(y={}));function w(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(h||(h={}));function f(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(a||(a={}));function n(q){let K=0;for(let Y=0;;Y+=7){const ie=q.read(1);if(K|=(ie.buffer[0]&127)<<Y,!(ie.buffer[0]&128))return K}}const i=r(0);function u(q,K){if(K===0){q.write(i);return}let Y=0;for(let $e=K;$e!==0;$e=$e>>>7)Y++;const ie=O.$Ge.alloc(Y);for(let $e=0;K!==0;$e++)ie.buffer[$e]=K&127,K=K>>>7,K>0&&(ie.buffer[$e]|=128);q.write(ie)}class o{constructor(K){this.b=K,this.a=0}read(K){const Y=this.b.slice(this.a,this.a+K);return this.a+=Y.byteLength,Y}}e.$7h=o;class t{constructor(){this.a=[]}get buffer(){return O.$Ge.concat(this.a)}write(K){this.a.push(K)}}e.$8h=t;var l;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(l||(l={}));function r(q){const K=O.$Ge.alloc(1);return K.writeUInt8(q,0),K}const c={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object),Uint:r(l.Int)},s=typeof Buffer<"u";function v(q,K){if(typeof K>"u")q.write(c.Undefined);else if(typeof K=="string"){const Y=O.$Ge.fromString(K);q.write(c.String),u(q,Y.byteLength),q.write(Y)}else if(s&&Buffer.isBuffer(K)){const Y=O.$Ge.wrap(K);q.write(c.Buffer),u(q,Y.byteLength),q.write(Y)}else if(K instanceof O.$Ge)q.write(c.VSBuffer),u(q,K.byteLength),q.write(K);else if(Array.isArray(K)){q.write(c.Array),u(q,K.length);for(const Y of K)v(q,Y)}else if(typeof K=="number"&&(K|0)===K)q.write(c.Uint),u(q,K);else{const Y=O.$Ge.fromString(JSON.stringify(K));q.write(c.Object),u(q,Y.byteLength),q.write(Y)}}function g(q){switch(q.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return q.read(n(q)).toString();case l.Buffer:return q.read(n(q)).buffer;case l.VSBuffer:return q.read(n(q));case l.Array:{const Y=n(q),ie=[];for(let $e=0;$e<Y;$e++)ie.push(g(q));return ie}case l.Object:return JSON.parse(q.read(n(q)).toString());case l.Int:return n(q)}}class D{constructor(K,Y,ie=null,$e=1e3){this.h=K,this.j=Y,this.k=ie,this.l=$e,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(K,Y){this.b.set(K,Y),setTimeout(()=>this.w(K),0)}m(K){switch(K.type){case 200:{const Y=this.o([K.type]);this.k?.logOutgoing(Y,0,1,f(K.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([K.type,K.id],K.data);this.k?.logOutgoing(Y,K.id,1,f(K.type),K.data);return}}}o(K,Y=void 0){const ie=new t;return v(ie,K),v(ie,Y),this.p(ie.buffer)}p(K){try{return this.h.send(K),K.byteLength}catch{return 0}}q(K){const Y=new o(K),ie=g(Y),$e=g(Y),ue=ie[0];switch(ue){case 100:return this.k?.logIncoming(K.byteLength,ie[1],1,`${w(ue)}: ${ie[2]}.${ie[3]}`,$e),this.s({type:ue,id:ie[1],channelName:ie[2],name:ie[3],arg:$e});case 102:return this.k?.logIncoming(K.byteLength,ie[1],1,`${w(ue)}: ${ie[2]}.${ie[3]}`,$e),this.t({type:ue,id:ie[1],channelName:ie[2],name:ie[3],arg:$e});case 101:return this.k?.logIncoming(K.byteLength,ie[1],1,`${w(ue)}`),this.u({type:ue,id:ie[1]});case 103:return this.k?.logIncoming(K.byteLength,ie[1],1,`${w(ue)}`),this.u({type:ue,id:ie[1]})}}s(K){const Y=this.b.get(K.channelName);if(!Y){this.v(K);return}const ie=new R.$pe;let $e;try{$e=Y.call(this.j,K.name,K.arg,ie.token)}catch(_){$e=Promise.reject(_)}const ue=K.id;$e.then(_=>{this.m({id:ue,data:_,type:201})},_=>{_ instanceof Error?this.m({id:ue,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:ue,data:_,type:203})}).finally(()=>{ve.dispose(),this.d.delete(K.id)});const ve=(0,E.$Tc)(()=>ie.cancel());this.d.set(K.id,ve)}t(K){const Y=this.b.get(K.channelName);if(!Y){this.v(K);return}const ie=K.id,ue=Y.listen(this.j,K.name,K.arg)(ve=>this.m({id:ie,data:ve,type:204}));this.d.set(K.id,ue)}u(K){const Y=this.d.get(K.id);Y&&(Y.dispose(),this.d.delete(K.id))}v(K){let Y=this.g.get(K.channelName);Y||(Y=[],this.g.set(K.channelName,Y));const ie=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.m({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:K,timeoutTimer:ie})}w(K){const Y=this.g.get(K);if(Y){for(const ie of Y)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(K)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Qc)(this.d.values()),this.d.clear()}}e.$$h=D;var $;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class k{constructor(K,Y=null){this.l=K,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=Y}getChannel(K){const Y=this;return{call(ie,$e,ue){return Y.a?Promise.reject(new b.$5):Y.m(K,ie,$e,ue)},listen(ie,$e){return Y.a?m.Event.None:Y.o(K,ie,$e)}}}m(K,Y,ie,$e=R.CancellationToken.None){const ue=this.g++,_={id:ue,type:100,channelName:K,name:Y,arg:ie};if($e.isCancellationRequested)return Promise.reject(new b.$5);let B;return new Promise((pe,Ce)=>{if($e.isCancellationRequested)return Ce(new b.$5);const oe=()=>{const ne=me=>{switch(me.type){case 201:this.f.delete(ue),pe(me.data);break;case 202:{this.f.delete(ue);const be=new Error(me.data.message);be.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,be.name=me.data.name,Ce(be);break}case 203:this.f.delete(ue),Ce(me.data);break}};this.f.set(ue,ne),this.p(_)};let se=null;this.b===a.Idle?oe():(se=(0,L.$jh)(ne=>this.u()),se.then(()=>{se=null,oe()}));const re=()=>{se?(se.cancel(),se=null):this.p({id:ue,type:101}),Ce(new b.$5)},G=$e.onCancellationRequested(re);B=(0,E.$Sc)((0,E.$Tc)(re),G),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(K,Y,ie){const $e=this.g++,ve={id:$e,type:102,channelName:K,name:Y,arg:ie};let _=null;const B=new m.$ee({onWillAddFirstListener:()=>{_=(0,L.$jh)(pe=>this.u()),_.then(()=>{_=null,this.d.add(B),this.p(ve)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(B),this.p({id:$e,type:103}))}}),ee=pe=>B.fire(pe.data);return this.f.set($e,ee),B.event}p(K){switch(K.type){case 100:case 102:{const Y=this.q([K.type,K.id,K.channelName,K.name],K.arg);this.j?.logOutgoing(Y,K.id,0,`${w(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const Y=this.q([K.type,K.id]);this.j?.logOutgoing(Y,K.id,0,w(K.type));return}}}q(K,Y=void 0){const ie=new t;return v(ie,K),v(ie,Y),this.r(ie.buffer)}r(K){try{return this.l.send(K),K.byteLength}catch{return 0}}s(K){const Y=new o(K),ie=g(Y),$e=g(Y),ue=ie[0];switch(ue){case 200:return this.j?.logIncoming(K.byteLength,0,0,f(ue)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(K.byteLength,ie[1],0,f(ue),$e),this.t({type:ie[0],id:ie[1],data:$e})}}t(K){if(K.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(K.id)?.(K)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Qc)(this.d.values()),this.d.clear()}}e.$_h=k,Ke([N.$1h],k.prototype,"onDidInitializePromise",null);class S{get connections(){const K=[];return this.f.forEach(Y=>K.push(Y)),K}constructor(K,Y,ie){this.a=new Map,this.f=new Set,this.g=new m.$ee,this.onDidAddConnection=this.g.event,this.h=new m.$ee,this.onDidRemoveConnection=this.h.event,this.j=new E.$Uc,this.j.add(K(({protocol:$e,onDidClientDisconnect:ue})=>{const ve=m.Event.once($e.onMessage);this.j.add(ve(_=>{const B=new o(_),ee=g(B),pe=new D($e,ee,Y,ie),Ce=new k($e,Y);this.a.forEach((se,re)=>pe.registerChannel(re,se));const oe={channelServer:pe,channelClient:Ce,ctx:ee};this.f.add(oe),this.g.fire(oe),this.j.add(ue(()=>{pe.dispose(),Ce.dispose(),this.f.delete(oe),this.h.fire(oe)}))}))}))}getChannel(K,Y){const ie=this;return{call($e,ue,ve){let _;if((0,p.$kg)(Y)){const ee=(0,d.$4b)(ie.connections.filter(Y));_=ee?Promise.resolve(ee):m.Event.toPromise(m.Event.filter(ie.onDidAddConnection,Y))}else _=Y.routeCall(ie,$e,ue);const B=_.then(ee=>ee.channelClient.getChannel(K));return I(B).call($e,ue,ve)},listen($e,ue){if((0,p.$kg)(Y))return ie.k(K,Y,$e,ue);const ve=Y.routeEvent(ie,$e,ue).then(_=>_.channelClient.getChannel(K));return I(ve).listen($e,ue)}}}k(K,Y,ie,$e){const ue=this;let ve;const _=new m.$ee({onWillAddFirstListener:()=>{ve=new E.$Uc;const B=new m.$ke,ee=new Map,pe=oe=>{const re=oe.channelClient.getChannel(K).listen(ie,$e),G=B.add(re);ee.set(oe,G)},Ce=oe=>{const se=ee.get(oe);se&&(se.dispose(),ee.delete(oe))};ue.connections.filter(Y).forEach(pe),m.Event.filter(ue.onDidAddConnection,Y)(pe,void 0,ve),ue.onDidRemoveConnection(Ce,void 0,ve),B.event(_.fire,_,ve),ve.add(B)},onDidRemoveLastListener:()=>{ve?.dispose(),ve=void 0}});return _.event}registerChannel(K,Y){this.a.set(K,Y);for(const ie of this.f)ie.channelServer.registerChannel(K,Y)}dispose(){this.j.dispose();for(const K of this.f)K.channelClient.dispose(),K.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=S;class C{constructor(K,Y,ie=null){const $e=new t;v($e,Y),K.send($e.buffer),this.a=new k(K,ie),this.d=new D(K,Y,ie)}getChannel(K){return this.a.getChannel(K)}registerChannel(K,Y){this.d.registerChannel(K,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=C;function I(q){return{call(K,Y,ie){return q.then($e=>$e.call(K,Y,ie))},listen(K,Y){const ie=new m.$ne;return q.then($e=>ie.input=$e.listen(K,Y)),ie.event}}}function F(q){let K=!1;return{call(Y,ie,$e){return K?q.call(Y,ie,$e):(0,L.$xh)(0).then(()=>K=!0).then(()=>q.call(Y,ie,$e))},listen(Y,ie){if(K)return q.listen(Y,ie);const $e=new m.$ne;return(0,L.$xh)(0).then(()=>K=!0).then(()=>$e.input=q.listen(Y,ie)),$e.event}}}class j{constructor(K){this.a=K}routeCall(K){return this.b(K)}routeEvent(K){return this.b(K)}async b(K){for(const Y of K.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await m.Event.toPromise(K.onDidAddConnection),await this.b(K)}}e.$ei=j;var z;(function(q){function K(ue,ve,_){const B=ue,ee=_&&_.disableMarshalling,pe=new Map;for(const Ce in B)ie(Ce)&&pe.set(Ce,m.Event.buffer(B[Ce],!0,void 0,ve));return new class{listen(Ce,oe,se){const re=pe.get(oe);if(re)return re;const G=B[oe];if(typeof G=="function"){if($e(oe))return G.call(B,se);if(ie(oe))return pe.set(oe,m.Event.buffer(B[oe],!0,void 0,ve)),pe.get(oe)}throw new b.$bb(`Event not found: ${oe}`)}call(Ce,oe,se){const re=B[oe];if(typeof re=="function"){if(!ee&&Array.isArray(se))for(let ne=0;ne<se.length;ne++)se[ne]=(0,A.$6h)(se[ne]);let G=re.apply(B,se);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new b.$bb(`Method not found: ${oe}`)}}}q.fromService=K;function Y(ue,ve){const _=ve&&ve.disableMarshalling;return new Proxy({},{get(B,ee){if(typeof ee=="string")return ve?.properties?.has(ee)?ve.properties.get(ee):$e(ee)?function(pe){return ue.listen(ee,pe)}:ie(ee)?ue.listen(ee):async function(...pe){let Ce;ve&&!(0,p.$fg)(ve.context)?Ce=[ve.context,...pe]:Ce=pe;const oe=await ue.call(ee,Ce);return _?oe:(0,A.$6h)(oe)};throw new b.$bb(`Property not found: ${String(ee)}`)}})}q.toService=Y;function ie(ue){return ue[0]==="o"&&ue[1]==="n"&&P.$xf(ue.charCodeAt(2))}function $e(ue){return/^onDynamic/.test(ue)&&P.$xf(ue.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const K=q.toString();if(K!=="[object Object]")return K}return q}function U(q){return Array.isArray(q)?q.map(T):T(q)}function Z(q,K,Y,ie,$e,ue,ve){ve=U(ve);const _=M[$e],B=_[ie%_.length];let ee=[`%c[${q}]%c[${String(K).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ue)?(ee=ee.concat(ve),ee.push(")")):ee.push(ve),console.log.apply(console,ee)}class te{constructor(K,Y){this.d=K,this.f=Y,this.a=0,this.b=0}logOutgoing(K,Y,ie,$e,ue){this.b+=K,Z(this.d,this.b,K,Y,ie,$e,ue)}logIncoming(K,Y,ie,$e,ue){this.a+=K,Z(this.f,this.a,K,Y,ie,$e,ue)}}e.$fi=te}),define(ke[83],Se([1,0,21,4,3,82]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.ProtocolConstants=e.$gi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var N;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(N||(e.SocketDiagnosticsEventType=N={}));var b;(function(c){c.enableDiagnostics=!1,c.records=[];const s=new WeakMap;let v=0;function g($,k){if(!s.has($)){const S=String(++v);s.set($,S)}return s.get($)}function D($,k,S,C){if(!c.enableDiagnostics)return;const I=g($,k);if(C instanceof d.$Ge||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const F=d.$Ge.alloc(C.byteLength);F.set(C),c.records.push({timestamp:Date.now(),id:I,label:k,type:S,buff:F})}else c.records.push({timestamp:Date.now(),id:I,label:k,type:S,data:C})}c.traceSocketEvent=D})(b||(e.SocketDiagnostics=b={}));var m;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let E=null;function A(){return E||(E=d.$Ge.alloc(0)),E}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,v){if(s===0)return A();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const k=this.a[0];return v&&(this.a.shift(),this.b-=s),k}if(this.a[0].byteLength>s){const k=this.a[0].slice(0,s);return v&&(this.a[0]=this.a[0].slice(s),this.b-=s),k}const g=d.$Ge.alloc(s);let D=0,$=0;for(;s>0;){const k=this.a[$];if(k.byteLength>s){const S=k.slice(0,s);g.set(S,D),D+=s,v&&(this.a[$]=k.slice(s),this.b-=s),s-=s}else g.set(k,D),D+=k.byteLength,v?(this.a.shift(),this.b-=k.byteLength):$++,s-=k.byteLength}return g}}e.$gi=P;var p;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})(p||(p={}));function y(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class h{constructor(s,v,g,D){this.type=s,this.id=v,this.ack=g,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends O.$Vc{constructor(s){super(),this.f=this.B(new L.$ee),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new P,this.B(this.a.onData(v=>this.acceptChunk(v))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const v=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=v.readUInt32BE(9),this.g.messageType=v.readUInt8(0),this.g.id=v.readUInt32BE(1),this.g.ack=v.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,D=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",v),this.f.fire(new h(g,D,$,v)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const v=d.$Ge.alloc(13);v.writeUInt8(s.type,0),v.writeUInt32BE(s.id,1),v.writeUInt32BE(s.ack,5),v.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(v,s.data)}g(s,v){const g=this.f===0;return this.d.push(s,v),this.f+=s.byteLength+v.byteLength,g}h(){const s=d.$Ge.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,v){this.g(s,v)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class n extends O.$Vc{constructor(s){super(),this.f=new L.$ee,this.onMessage=this.f.event,this.g=new L.$ee,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new a(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(v=>{v.type===1&&this.f.fire(v.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new h(1,0,0,s))}}e.$hi=n;class i extends R.$bi{static fromSocket(s,v){return new i(new n(s),v)}get onDidDispose(){return this.b.onDidDispose}constructor(s,v,g=null){super(s,v,g),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$ii=i;class u{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$ee({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$ji=u;class o{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,v=this.a;for(;v;)v=v.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let v=0,g=this.a;for(;g;)s[v++]=g.data,g=g.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const v=new o(s);if(!this.a){this.a=v,this.b=v;return}this.b.next=v,this.b=v}}class l{static{this.a=10}static{this.b=null}static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const s=Date.now();for(let v=0;v<l.a;v++)this.c[v]=s-1e3*v;setInterval(()=>{for(let v=l.a;v>=1;v--)this.c[v]=this.c[v-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),v=(1+l.a)*1e3;let g=0;for(let D=0;D<l.a;D++)s-this.c[D]<=v&&g++;return 1-g/l.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new u,this.onControlMessage=this.u.event,this.v=new u,this.onMessage=this.v.event,this.w=new u,this.onDidDispose=this.w.event,this.x=new u,this.onSocketClose=this.x.event,this.y=new u,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??l.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new O.$Uc,this.o=s.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new h(5,0,0,A());this.p.write(s),this.p.flush()}sendPause(){const s=new h(7,0,0,A());this.p.write(s)}sendResume(){const s=new h(8,0,0,A());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,v){this.a=!0,this.r.dispose(),this.r=new O.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(v)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new h(3,0,this.h,A());this.p.write(s);const v=this.b.toArray();for(let g=0,D=v.length;g<D;g++)this.p.write(v[g]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const v=this.b.peek();if(v&&v.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const v=Date.now();v-this.m>1e4&&(this.m=v,this.p.write(new h(6,0,0,A())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const v=this.b.toArray();for(let g=0,D=v.length;g<D;g++)this.p.write(v[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const v=++this.c;this.h=this.g;const g=new h(1,v,this.h,s);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(s){const v=new h(2,0,0,s);this.p.write(v)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),v=Date.now()-s.writtenTime,g=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(v>=2e4&&g>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:v,timeSinceLastReceivedSomeData:g});return}const $=Math.max(2e4-v,2e4-g,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new h(3,0,this.h,A());this.p.write(s)}D(){this.h=this.g;const s=new h(9,0,this.h,A());this.p.write(s)}}e.$ki=r}),define(ke[199],Se([1,0,54,7,21,22,197,13,4,3,24,105,102,82]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class w extends y.$$h{constructor(a){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",n=>O.$Ge.wrap(Buffer.from(n,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$Zq=w;class h{constructor(a,n){this.i=a,this.j=n,this.c=new Set,this.g=new Map,this.h=new m.$ee,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new L.$th(i),this.d=null,this.f=null}getChannel(a){const n=this;return{call(i,u,o){return n.k(a,i,u,o)},listen(i,u){return n.l(a,i,u)}}}k(a,n,i,u=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const o=this.n(a),t=(0,L.$jh)(c=>o.call(n,i,c)),l=u.onCancellationRequested(()=>t.cancel()),r=(0,E.$Tc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{l.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,n,i){if(!this.b)return m.Event.None;this.b.cancel();let u;const o=new m.$ee({onWillAddFirstListener:()=>{u=this.n(a).listen(n,i)(o.fire,o),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(v=>!/^--inspect(-brk)?=/.test(v)).filter(v=>!v.startsWith("--vscode-"))),(0,p.$nm)(n.env),this.d=(0,d.fork)(this.i,a,n);const i=new m.$ee,o=m.Event.fromNodeEventEmitter(this.d,"message",v=>v)(v=>{if((0,N.$Vq)(v)){(0,N.log)(v,`IPC Library: ${this.j.serverName}`);return}i.fire(O.$Ge.wrap(Buffer.from(v,"base64")))}),t=this.j.useQueue?(0,P.$pm)(this.d):this.d,l=v=>this.d&&this.d.connected&&t.send(v.buffer.toString("base64")),r=i.event,c={send:l,onMessage:r};this.f=new y.$_h(c);const s=()=>this.o();process.once("exit",s),this.d.on("error",v=>console.warn('IPC "'+this.j.serverName+'" errored with '+v)),this.d.on("exit",(v,g)=>{process.removeListener("exit",s),o.dispose(),this.c.forEach(D=>(0,E.$Qc)(D)),this.c.clear(),v!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+v+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:v,signal:g})})}return this.f}n(a){let n=this.g.get(a);return n||(n=this.m.getChannel(a),this.g.set(a,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=h}),define(ke[200],Se([1,0,7,4,3,58,18]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=m;var b;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function m(p){const y=p;return y?.changed instanceof Map||y?.deleted instanceof Set}var E;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(E||(e.StorageState=E={}));class A extends O.$Vc{static{this.a=100}constructor(y,w=Object.create(null)){super(),this.r=y,this.s=w,this.b=this.B(new L.$he),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new d.$uh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((w,h)=>this.w(h,w)),y.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(y,w){if(this.c===E.Closed)return;let h=!1;(0,N.$fg)(w)?h=this.f.delete(y):this.f.get(y)!==w&&(this.f.set(y,w),h=!0),h&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,w){const h=this.f.get(y);return(0,N.$fg)(h)?w:h}getBoolean(y,w){const h=this.get(y);return(0,N.$fg)(h)?w:h==="true"}getNumber(y,w){const h=this.get(y);return(0,N.$fg)(h)?w:parseInt(h,10)}getObject(y,w){const h=this.get(y);return(0,N.$fg)(h)?w:(0,R.$5h)(h)}async set(y,w,h=!1){if(this.c===E.Closed)return;if((0,N.$fg)(w))return this.delete(y,h);const f=(0,N.$$f)(w)||Array.isArray(w)?(0,R.$4h)(w):String(w);if(this.f.get(y)!==f)return this.f.set(y,f),this.j.set(y,f),this.h.delete(y),this.b.fire({key:y,external:h}),this.D()}async delete(y,w=!1){if(!(this.c===E.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:w}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Wp=A;class P{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((w,h)=>this.a.set(h,w)),y.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$Xp=P}),define(ke[201],Se([1,0,14,12,21]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0,e.$Dt=A,e.$Et=P;let R;function N(){return R||(R=new TextDecoder("UTF-16LE")),R}let b;function m(){return b||(b=new TextDecoder("UTF-16BE")),b}let E;function A(){return E||(E=L.$D()?N():m()),E}function P(w,h,f){const a=new Uint16Array(w.buffer,h,f);return f>0&&(a[0]===65279||a[0]===65534)?p(w,h,f):N().decode(a)}function p(w,h,f){const a=[];let n=0;for(let i=0;i<f;i++){const u=O.$Ie(w,h);h+=2,a[n++]=String.fromCharCode(u)}return a.join("")}class y{constructor(h){this.a=h|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const h=new Uint16Array(this.b.buffer,0,this.d);return A().decode(h)}f(){const h=this.e();this.d=0,this.c===null?this.c=[h]:this.c[this.c.length]=h}appendCharCode(h){const f=this.a-this.d;f<=1&&(f===0||d.$Cf(h))&&this.f(),this.b[this.d++]=h}appendASCIICharCode(h){this.d===this.a&&this.f(),this.b[this.d++]=h}appendString(h){const f=h.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=h;return}for(let a=0;a<f;a++)this.b[this.d++]=h.charCodeAt(a)}}e.$Ft=y}),define(ke[202],Se([1,0,21,201]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0,e.$Ht=N;function O(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,A,P,p){this.oldPosition=E,this.oldText=A,this.newPosition=P,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${O(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${O(this.oldText)}")`:`(replace@${this.oldPosition} "${O(this.oldText)}" with "${O(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,A,P){const p=A.length;d.$Le(E,p,P),P+=4;for(let y=0;y<p;y++)d.$Je(E,A.charCodeAt(y),P),P+=2;return P}static d(E,A){const P=d.$Ke(E,A);return A+=4,(0,L.$Et)(E,A,P)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(E,A){return d.$Le(E,this.oldPosition,A),A+=4,d.$Le(E,this.newPosition,A),A+=4,A=R.c(E,this.oldText,A),A=R.c(E,this.newText,A),A}static read(E,A,P){const p=d.$Ke(E,A);A+=4;const y=d.$Ke(E,A);A+=4;const w=R.d(E,A);A+=R.a(w);const h=R.d(E,A);return A+=R.a(h),P.push(new R(p,w,y,h)),A}}e.$Gt=R;function N(m,E){return m===null||m.length===0?E:new b(m,E).compress()}class b{constructor(E,A){this.a=E,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,A=0,P=this.n(E),p=this.l(A);for(;E<this.f||A<this.h;){if(P===null){this.k(p),p=this.l(++A);continue}if(p===null){this.m(P),P=this.n(++E);continue}if(p.oldEnd<=P.newPosition){this.k(p),p=this.l(++A);continue}if(P.newEnd<=p.oldPosition){this.m(P),P=this.n(++E);continue}if(p.oldPosition<P.newPosition){const[a,n]=b.r(p,P.newPosition-p.oldPosition);this.k(a),p=n;continue}if(P.newPosition<p.oldPosition){const[a,n]=b.q(P,p.oldPosition-P.newPosition);this.m(a),P=n;continue}let h,f;if(p.oldEnd===P.newEnd)h=P,f=p,P=this.n(++E),p=this.l(++A);else if(p.oldEnd<P.newEnd){const[a,n]=b.q(P,p.oldLength);h=a,f=p,P=n,p=this.l(++A)}else{const[a,n]=b.r(p,P.newLength);h=P,f=a,P=this.n(++E),p=n}this.d[this.e++]=new R(h.oldPosition,h.oldText,f.newPosition,f.newText),this.g+=h.newLength-h.oldLength,this.j+=f.newLength-f.oldLength}const y=b.s(this.d);return b.t(y)}k(E){this.d[this.e++]=b.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=b.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,A){return new R(A.oldPosition-E,A.oldText,A.newPosition,A.newText)}static p(E,A){return new R(A.oldPosition,A.oldText,A.newPosition+E,A.newText)}static q(E,A){const P=E.newText.substr(0,A),p=E.newText.substr(A);return[new R(E.oldPosition,E.oldText,E.newPosition,P),new R(E.oldEnd,"",E.newPosition+A,p)]}static r(E,A){const P=E.oldText.substr(0,A),p=E.oldText.substr(A);return[new R(E.oldPosition,P,E.newPosition,E.newText),new R(E.oldPosition+A,p,E.newEnd,"")]}static s(E){if(E.length===0)return E;const A=[];let P=0,p=E[0];for(let y=1;y<E.length;y++){const w=E[y];p.oldEnd===w.oldPosition?p=new R(p.oldPosition,p.oldText+w.oldText,p.newPosition,p.newText+w.newText):(A[P++]=p,p=w)}return A[P++]=p,A}static t(E){if(E.length===0)return E;const A=[];let P=0;for(let p=0;p<E.length;p++){const y=E[p];y.oldText!==y.newText&&(A[P++]=y)}return A}}}),define(ke[203],Se([1,0,35,17]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=O,e.$Yt=R;function O(N,b,m,E,A,P){if(Array.isArray(N)){let p=0;for(const y of N){const w=O(y,b,m,E,A,P);if(w===10)return w;w>p&&(p=w)}return p}else{if(typeof N=="string")return E?N==="*"?5:N===m?10:0:0;if(N){const{language:p,pattern:y,scheme:w,hasAccessToAllModels:h,notebookType:f}=N;if(!E&&!h)return 0;f&&A&&(b=A);let a=0;if(w)if(w===b.scheme)a=10;else if(w==="*")a=5;else return 0;if(p)if(p===m)a=10;else if(p==="*")a=Math.max(a,5);else return 0;if(f)if(f===P)a=10;else if(f==="*"&&P!==void 0)a=Math.max(a,5);else return 0;if(y){let n;if(typeof y=="string"?n=y:n={...y,base:(0,L.$ic)(y.base)},n===b.fsPath||(0,d.$pk)(n,b.fsPath))a=10;else return 0}return a}else return 0}}function R(N){return typeof N=="string"?!1:Array.isArray(N)?N.some(R):!!N.notebookType}}),define(ke[204],Se([1,0,4,14,29,80,131,179,202,3]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=void 0;class A extends E.$Vc{constructor(p,y,w,h,f,a,n){super(),this.m=this.B(new d.$ee),this.onDidChangeContent=this.m.event,this.f=y,this.j=!a,this.g=h,this.h=f,this.c=new N.$TC(p,w,n)}equals(p){return!(p instanceof A)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,y){return this.c.getOffsetAt(p,y)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,y){const w=p+y,h=this.getPositionAt(p),f=this.getPositionAt(w);return new O.$ut(h.lineNumber,h.column,f.lineNumber,f.column)}getValueInRange(p,y=0){if(p.isEmpty())return"";const w=this.n(y);return this.c.getValueInRange(p,w)}getValueLengthInRange(p,y=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const w=this.getOffsetAt(p.startLineNumber,p.startColumn),h=this.getOffsetAt(p.endLineNumber,p.endColumn);let f=0;const a=this.n(y),n=this.getEOL();if(a.length!==n.length){const i=a.length-n.length,u=p.endLineNumber-p.startLineNumber;f=i*u}return h-w+f}getCharacterCountInRange(p,y=0){if(this.j){let w=0;const h=p.startLineNumber,f=p.endLineNumber;for(let a=h;a<=f;a++){const n=this.getLineContent(a),i=a===h?p.startColumn-1:0,u=a===f?p.endColumn-1:n.length;for(let o=i;o<u;o++)L.$Cf(n.charCodeAt(o))?(w=w+1,o=o+1):w=w+1}return w+=this.n(y).length*(f-h),w}return this.getValueLengthInRange(p,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,y){return this.c.getLineCharCode(p,y)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const y=L.$nf(this.getLineContent(p));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(p){const y=L.$pf(this.getLineContent(p));return y===-1?0:y+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,y,w){let h=this.g,f=this.h,a=this.j,n=!0,i=[];for(let s=0;s<p.length;s++){const v=p[s];n&&v._isTracked&&(n=!1);const g=v.range;if(v.text){let C=!0;a||(C=!L.$Nf(v.text),a=C),!h&&C&&(h=L.$Mf(v.text)),!f&&C&&(f=L.$Pf(v.text))}let D="",$=0,k=0,S=0;if(v.text){let C;[$,k,S,C]=(0,b.$1t)(v.text);const I=this.getEOL();C===0||C===(I===`\r
`?2:1)?D=v.text:D=v.text.replace(/\r\n|\r|\n/g,I)}i[s]={sortIndex:s,identifier:v.identifier||null,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g),text:D,eolCount:$,firstLineLength:k,lastLineLength:S,forceMoveMarkers:!!v.forceMoveMarkers,isAutoWhitespaceEdit:v.isAutoWhitespaceEdit||!1}}i.sort(A.u);let u=!1;for(let s=0,v=i.length-1;s<v;s++){const g=i[s].range.getEndPosition(),D=i[s+1].range.getStartPosition();if(D.isBeforeOrEqual(g)){if(D.isBefore(g))throw new Error("Overlapping ranges are not allowed!");u=!0}}n&&(i=this.s(i));const o=w||y?A._getInverseEditRanges(i):[],t=[];if(y)for(let s=0;s<i.length;s++){const v=i[s],g=o[s];if(v.isAutoWhitespaceEdit&&v.range.isEmpty())for(let D=g.startLineNumber;D<=g.endLineNumber;D++){let $="";D===g.startLineNumber&&($=this.getLineContent(v.range.startLineNumber),L.$nf($)!==-1)||t.push({lineNumber:D,oldContent:$})}}let l=null;if(w){let s=0;l=[];for(let v=0;v<i.length;v++){const g=i[v],D=o[v],$=this.getValueInRange(g.range),k=g.rangeOffset+s;s+=g.text.length-$.length,l[v]={sortIndex:g.sortIndex,identifier:g.identifier,range:D,text:$,textChange:new m.$Gt(g.rangeOffset,$,k,g.text)}}u||l.sort((v,g)=>v.sortIndex-g.sortIndex)}this.g=h,this.h=f,this.j=a;const r=this.t(i);let c=null;if(y&&t.length>0){t.sort((s,v)=>v.lineNumber-s.lineNumber),c=[];for(let s=0,v=t.length;s<v;s++){const g=t[s].lineNumber;if(s>0&&t[s-1].lineNumber===g)continue;const D=t[s].oldContent,$=this.getLineContent(g);$.length===0||$===D||L.$nf($)!==-1||c.push(g)}}return this.m.fire(),new R.$Jv(l,r,c)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let y=!1;const w=p[0].range,h=p[p.length-1].range,f=new O.$ut(w.startLineNumber,w.startColumn,h.endLineNumber,h.endColumn);let a=w.startLineNumber,n=w.startColumn;const i=[];for(let r=0,c=p.length;r<c;r++){const s=p[r],v=s.range;y=y||s.forceMoveMarkers,i.push(this.getValueInRange(new O.$ut(a,n,v.startLineNumber,v.startColumn))),s.text.length>0&&i.push(s.text),a=v.endLineNumber,n=v.endColumn}const u=i.join(""),[o,t,l]=(0,b.$1t)(u);return{sortIndex:0,identifier:p[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:u,eolCount:o,firstLineLength:t,lastLineLength:l,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t(p){p.sort(A.w);const y=[];for(let w=0;w<p.length;w++){const h=p[w],f=h.range.startLineNumber,a=h.range.startColumn,n=h.range.endLineNumber,i=h.range.endColumn;if(f===n&&a===i&&h.text.length===0)continue;h.text?(this.c.delete(h.rangeOffset,h.rangeLength),this.c.insert(h.rangeOffset,h.text,!0)):this.c.delete(h.rangeOffset,h.rangeLength);const u=new O.$ut(f,a,n,i);y.push({range:u,rangeLength:h.rangeLength,text:h.text,rangeOffset:h.rangeOffset,forceMoveMarkers:h.forceMoveMarkers})}return y}findMatchesLineByLine(p,y,w,h){return this.c.findMatchesLineByLine(p,y,w,h)}getPieceTree(){return this.c}static _getInverseEditRange(p,y){const w=p.startLineNumber,h=p.startColumn,[f,a,n]=(0,b.$1t)(y);let i;if(y.length>0){const u=f+1;u===1?i=new O.$ut(w,h,w,h+a):i=new O.$ut(w,h,w+u-1,n+1)}else i=new O.$ut(w,h,w,h);return i}static _getInverseEditRanges(p){const y=[];let w=0,h=0,f=null;for(let a=0,n=p.length;a<n;a++){const i=p[a];let u,o;f?f.range.endLineNumber===i.range.startLineNumber?(u=w,o=h+(i.range.startColumn-f.range.endColumn)):(u=w+(i.range.startLineNumber-f.range.endLineNumber),o=i.range.startColumn):(u=i.range.startLineNumber,o=i.range.startColumn);let t;if(i.text.length>0){const l=i.eolCount+1;l===1?t=new O.$ut(u,o,u,o+i.firstLineLength):t=new O.$ut(u,o,u+l-1,i.lastLineLength+1)}else t=new O.$ut(u,o,u,o);w=t.endLineNumber,h=t.endColumn,y.push(t),f=i}return y}static u(p,y){const w=O.$ut.compareRangesUsingEnds(p.range,y.range);return w===0?p.sortIndex-y.sortIndex:w}static w(p,y){const w=O.$ut.compareRangesUsingEnds(p.range,y.range);return w===0?y.sortIndex-p.sortIndex:-w}}e.$UC=A}),define(ke[205],Se([1,0,14,131,204]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=void 0;class R{constructor(m,E,A,P,p,y,w,h,f){this.a=m,this.b=E,this.c=A,this.d=P,this.e=p,this.f=y,this.g=w,this.h=h,this.j=f}k(m){const E=this.c+this.d+this.e,A=this.c+this.e;return E===0?m===1?`
`:`\r
`:A>E/2?`\r
`:`
`}create(m){const E=this.k(m),A=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let p=0,y=A.length;p<y;p++){const w=A[p].buffer.replace(/\r\n|\r|\n/g,E),h=(0,L.$PC)(w);A[p]=new L.$SC(w,h)}const P=new O.$UC(A,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class N{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&d.$Wf(m)&&(this.b=d.$Vf,m=m.substr(1));const E=m.charCodeAt(m.length-1);E===13||E>=55296&&E<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=E):(this.m(m,!1),this.c=!1,this.d=E)}m(m,E){!E&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const E=(0,L.$QC)(this.e,m);this.a.push(new L.$SC(m,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=d.$Mf(m)),this.k||(this.k=d.$Pf(m)))}finish(m=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const E=(0,L.$PC)(m.buffer);m.lineStarts=E,this.d===13&&this.f++}}}e.$VC=N}),define(ke[135],Se([1,0,21,12]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bb=m,e.$$bb=A;var O;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(O||(O={}));function R(P){for(let p=0,y=P.length;p<y;p+=4){const w=P[p+0],h=P[p+1],f=P[p+2],a=P[p+3];P[p+0]=a,P[p+1]=f,P[p+2]=h,P[p+3]=w}}function N(P){const p=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return L.$D()||R(p),d.$Ge.wrap(p)}function b(P){const p=P.buffer;if(L.$D()||R(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const y=new Uint8Array(p.byteLength);return y.set(p),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function m(P){const p=new Uint32Array(E(P));let y=0;if(p[y++]=P.id,P.type==="full")p[y++]=1,p[y++]=P.data.length,p.set(P.data,y),y+=P.data.length;else{p[y++]=2,p[y++]=P.deltas.length;for(const w of P.deltas)p[y++]=w.start,p[y++]=w.deleteCount,w.data?(p[y++]=w.data.length,p.set(w.data,y),y+=w.data.length):p[y++]=0}return N(p)}function E(P){let p=0;if(p+=2,P.type==="full")p+=1+P.data.length;else{p+=1,p+=3*P.deltas.length;for(const y of P.deltas)y.data&&(p+=y.data.length)}return p}function A(P){const p=b(P);let y=0;const w=p[y++];if(p[y++]===1){const n=p[y++],i=p.subarray(y,y+n);return y+=n,{id:w,type:"full",data:i}}const f=p[y++],a=[];for(let n=0;n<f;n++){const i=p[y++],u=p[y++],o=p[y++];let t;o>0&&(t=p.subarray(y,y+o),y+=o),a[n]={start:i,deleteCount:u,data:t}}return{id:w,type:"delta",deltas:a}}}),define(ke[206],Se([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(ke[136],Se([1,0,19,24,12,182,130,206]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=f,e.clampedInt=n,e.clampedFloat=u,e.stringSet=l,e.cursorStyleToString=S,e.filterValidationDecorations=be;var m;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=E;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class P{constructor(ce,Ie,Ge,Oe){this.id=ce,this.name=Ie,this.defaultValue=Ge,this.schema=Oe}applyUpdate(ce,Ie){return y(ce,Ie)}compute(ce,Ie,Ge){return Ge}}class p{constructor(ce,Ie){this.newValue=ce,this.didChange=Ie}}e.ApplyUpdateResult=p;function y(ae,ce){if(typeof ae!="object"||typeof ce!="object"||!ae||!ce)return new p(ce,ae!==ce);if(Array.isArray(ae)||Array.isArray(ce)){const Ge=Array.isArray(ae)&&Array.isArray(ce)&&d.$ub(ae,ce);return new p(ce,!Ge)}let Ie=!1;for(const Ge in ce)if(ce.hasOwnProperty(Ge)){const Oe=y(ae[Ge],ce[Ge]);Oe.didChange&&(ae[Ge]=Oe.newValue,Ie=!0)}return new p(ae,Ie)}class w{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Ie){return y(ce,Ie)}validate(ce){return this.defaultValue}}class h{constructor(ce,Ie,Ge,Oe){this.id=ce,this.name=Ie,this.defaultValue=Ge,this.schema=Oe}applyUpdate(ce,Ie){return y(ce,Ie)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Ie,Ge){return Ge}}function f(ae,ce){return typeof ae>"u"?ce:ae==="false"?!1:!!ae}class a extends h{constructor(ce,Ie,Ge,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Ge),super(ce,Ie,Ge,Oe)}validate(ce){return f(ce,this.defaultValue)}}function n(ae,ce,Ie,Ge){if(typeof ae>"u")return ce;let Oe=parseInt(ae,10);return isNaN(Oe)?ce:(Oe=Math.max(Ie,Oe),Oe=Math.min(Ge,Oe),Oe|0)}class i extends h{static clampedInt(ce,Ie,Ge,Oe){return n(ce,Ie,Ge,Oe)}constructor(ce,Ie,Ge,Oe,ot,ut=void 0){typeof ut<"u"&&(ut.type="integer",ut.default=Ge,ut.minimum=Oe,ut.maximum=ot),super(ce,Ie,Ge,ut),this.minimum=Oe,this.maximum=ot}validate(ce){return i.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function u(ae,ce,Ie,Ge){if(typeof ae>"u")return ce;const Oe=o.float(ae,ce);return o.clamp(Oe,Ie,Ge)}class o extends h{static clamp(ce,Ie,Ge){return ce<Ie?Ie:ce>Ge?Ge:ce}static float(ce,Ie){if(typeof ce=="number")return ce;if(typeof ce>"u")return Ie;const Ge=parseFloat(ce);return isNaN(Ge)?Ie:Ge}constructor(ce,Ie,Ge,Oe,ot){typeof ot<"u"&&(ot.type="number",ot.default=Ge),super(ce,Ie,Ge,ot),this.validationFn=Oe}validate(ce){return this.validationFn(o.float(ce,this.defaultValue))}}class t extends h{static string(ce,Ie){return typeof ce!="string"?Ie:ce}constructor(ce,Ie,Ge,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Ge),super(ce,Ie,Ge,Oe)}validate(ce){return t.string(ce,this.defaultValue)}}function l(ae,ce,Ie,Ge){return typeof ae!="string"?ce:Ge&&ae in Ge?Ge[ae]:Ie.indexOf(ae)===-1?ce:ae}class r extends h{constructor(ce,Ie,Ge,Oe,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Oe,ot.default=Ge),super(ce,Ie,Ge,ot),this.c=Oe}validate(ce){return l(ce,this.defaultValue,this.c)}}class c extends P{constructor(ce,Ie,Ge,Oe,ot,ut,vt=void 0){typeof vt<"u"&&(vt.type="string",vt.enum=ot,vt.default=Oe),super(ce,Ie,Ge,vt),this.c=ot,this.d=ut}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function s(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Ie,Ge){return Ge===0?ce.accessibilitySupport:Ge}}class g extends P{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertSpace:f(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function $(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var k;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(k||(e.TextEditorCursorStyle=k={}));function S(ae){switch(ae){case k.Line:return"line";case k.Block:return"block";case k.Underline:return"underline";case k.LineThin:return"line-thin";case k.BlockOutline:return"block-outline";case k.UnderlineThin:return"underline-thin"}}function C(ae){switch(ae){case"line":return k.Line;case"block":return k.Block;case"underline":return k.Underline;case"line-thin":return k.LineThin;case"block-outline":return k.BlockOutline;case"underline-thin":return k.UnderlineThin}}class I extends w{constructor(){super(142)}compute(ce,Ie,Ge){const Oe=["monaco-editor"];return Ie.get(39)&&Oe.push(Ie.get(39)),ce.extraEditorClassName&&Oe.push(ce.extraEditorClassName),Ie.get(74)==="default"?Oe.push("mouse-default"):Ie.get(74)==="copy"&&Oe.push("mouse-copy"),Ie.get(111)&&Oe.push("showUnused"),Ie.get(140)&&Oe.push("showDeprecated"),Oe.join(" ")}}class F extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ce,Ie,Ge){return Ge&&ce.emptySelectionClipboard}}class j extends P{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:b.localize(16,null),included:O.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:b.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{cursorMoveOnType:f(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":l(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":l(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Ie.loop,this.defaultValue.loop)}}}class z extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"||ce.length===0?z.OFF:ce==="true"?z.ON:ce:ce?z.ON:z.OFF}}e.EditorFontLigatures=z;class M extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?M.OFF:ce==="true"?M.TRANSLATE:ce:ce?M.TRANSLATE:M.OFF}compute(ce,Ie,Ge){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class T extends w{constructor(){super(50)}compute(ce,Ie,Ge){return ce.fontInfo}}class U extends h{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ce){const Ie=o.float(ce,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(Ie,6,100)}compute(ce,Ie,Ge){return ce.fontInfo.fontSize}}class Z extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.d,maximum:Z.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(i.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.d,Z.e))}}class te extends P{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:Ge,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:Ge,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:Ge,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:Ge,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:Ge,description:b.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{multiple:l(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??l(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??l(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??l(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??l(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??l(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class q extends P{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:b.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:f(Ie.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Ie.above,this.defaultValue.above)}}}var K;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(K||(e.RenderMinimap=K={}));class Y extends w{constructor(){super(145)}compute(ce,Ie,Ge){return Y.computeLayout(Ie,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Ie=ce.height/ce.lineHeight,Ge=Math.floor(ce.paddingTop/ce.lineHeight);let Oe=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Oe=Math.max(Oe,Ie-1));const ot=(Ge+ce.viewLineCount+Oe)/(ce.pixelRatio*ce.height),ut=Math.floor(ce.viewLineCount/ot);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:Oe,desiredRatio:ot,minimapLineCount:ut}}static c(ce,Ie){const Ge=ce.outerWidth,Oe=ce.outerHeight,ot=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const ut=Ie.stableMinimapLayoutInput,vt=ut&&ce.outerHeight===ut.outerHeight&&ce.lineHeight===ut.lineHeight&&ce.typicalHalfwidthCharacterWidth===ut.typicalHalfwidthCharacterWidth&&ce.pixelRatio===ut.pixelRatio&&ce.scrollBeyondLastLine===ut.scrollBeyondLastLine&&ce.paddingTop===ut.paddingTop&&ce.paddingBottom===ut.paddingBottom&&ce.minimap.enabled===ut.minimap.enabled&&ce.minimap.side===ut.minimap.side&&ce.minimap.size===ut.minimap.size&&ce.minimap.showSlider===ut.minimap.showSlider&&ce.minimap.renderCharacters===ut.minimap.renderCharacters&&ce.minimap.maxColumn===ut.minimap.maxColumn&&ce.minimap.scale===ut.minimap.scale&&ce.verticalScrollbarWidth===ut.verticalScrollbarWidth&&ce.isViewportWrapping===ut.isViewportWrapping,Rt=ce.lineHeight,Ut=ce.typicalHalfwidthCharacterWidth,tn=ce.scrollBeyondLastLine,Zt=ce.minimap.renderCharacters;let kt=ot>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Xt=ce.minimap.maxColumn,Yt=ce.minimap.size,et=ce.minimap.side,an=ce.verticalScrollbarWidth,Gt=ce.viewLineCount,ft=ce.remainingWidth,$t=ce.isViewportWrapping,xt=Zt?2:3;let Kt=Math.floor(ot*Oe);const Ft=Kt/ot;let gt=!1,Wt=!1,_t=xt*kt,Vt=kt/ot,xe=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:Lt,extraLinesBeforeFirstLine:nn,extraLinesBeyondLastLine:Qt,desiredRatio:rn,minimapLineCount:It}=Y.computeContainedMinimapLineCount({viewLineCount:Gt,scrollBeyondLastLine:tn,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Oe,lineHeight:Rt,pixelRatio:ot});if(Gt/It>1)gt=!0,Wt=!0,kt=1,_t=1,Vt=kt/ot;else{let Ot=!1,Ct=kt+1;if(Yt==="fit"){const mt=Math.ceil((nn+Gt+Qt)*_t);$t&&vt&&ft<=Ie.stableFitRemainingWidth?(Ot=!0,Ct=Ie.stableFitMaxMinimapScale):Ot=mt>Kt}if(Yt==="fill"||Ot){gt=!0;const mt=kt;_t=Math.min(Rt*ot,Math.max(1,Math.floor(1/rn))),$t&&vt&&ft<=Ie.stableFitRemainingWidth&&(Ct=Ie.stableFitMaxMinimapScale),kt=Math.min(Ct,Math.max(1,Math.floor(_t/xt))),kt>mt&&(xe=Math.min(2,kt/mt)),Vt=kt/ot/xe,Kt=Math.ceil(Math.max(Lt,nn+Gt+Qt)*_t),$t?(Ie.stableMinimapLayoutInput=ce,Ie.stableFitRemainingWidth=ft,Ie.stableFitMaxMinimapScale=kt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const ln=Math.floor(Xt*Vt),Jt=Math.min(ln,Math.max(0,Math.floor((ft-an-2)*Vt/(Ut+Vt)))+e.MINIMAP_GUTTER_WIDTH);let qt=Math.floor(ot*Jt);const pt=qt/ot;qt=Math.floor(qt*xe);const jt=Zt?1:2,Nt=et==="left"?0:Ge-Jt-an;return{renderMinimap:jt,minimapLeft:Nt,minimapWidth:Jt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Wt,minimapScale:kt,minimapLineHeight:_t,minimapCanvasInnerWidth:qt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:pt,minimapCanvasOuterHeight:Ft}}static computeLayout(ce,Ie){const Ge=Ie.outerWidth|0,Oe=Ie.outerHeight|0,ot=Ie.lineHeight|0,ut=Ie.lineNumbersDigitCount|0,vt=Ie.typicalHalfwidthCharacterWidth,Rt=Ie.maxDigitWidth,Ut=Ie.pixelRatio,tn=Ie.viewLineCount,Zt=ce.get(137),kt=Zt==="inherit"?ce.get(136):Zt,Xt=kt==="inherit"?ce.get(132):kt,Yt=ce.get(135),et=Ie.isDominatedByLongLines,an=ce.get(57),Gt=ce.get(68).renderType!==0,ft=ce.get(69),$t=ce.get(105),xt=ce.get(84),Kt=ce.get(73),Ft=ce.get(103),gt=Ft.verticalScrollbarSize,Wt=Ft.verticalHasArrows,_t=Ft.arrowSize,Vt=Ft.horizontalScrollbarSize,xe=ce.get(43),ln=ce.get(110)!=="never";let Jt=ce.get(66);xe&&ln&&(Jt+=16);let qt=0;if(Gt){const cn=Math.max(ut,ft);qt=Math.round(cn*Rt)}let pt=0;an&&(pt=ot*Ie.glyphMarginDecorationLaneCount);let jt=0,Nt=jt+pt,Lt=Nt+qt,nn=Lt+Jt;const Qt=Ge-pt-qt-Jt;let rn=!1,It=!1,Mt=-1;kt==="inherit"&&et?(rn=!0,It=!0):Xt==="on"||Xt==="bounded"?It=!0:Xt==="wordWrapColumn"&&(Mt=Yt);const Ot=Y.c({outerWidth:Ge,outerHeight:Oe,lineHeight:ot,typicalHalfwidthCharacterWidth:vt,pixelRatio:Ut,scrollBeyondLastLine:$t,paddingTop:xt.top,paddingBottom:xt.bottom,minimap:Kt,verticalScrollbarWidth:gt,viewLineCount:tn,remainingWidth:Qt,isViewportWrapping:It},Ie.memory||new A);Ot.renderMinimap!==0&&Ot.minimapLeft===0&&(jt+=Ot.minimapWidth,Nt+=Ot.minimapWidth,Lt+=Ot.minimapWidth,nn+=Ot.minimapWidth);const Ct=Qt-Ot.minimapWidth,mt=Math.max(1,Math.floor((Ct-gt-2)/vt)),St=Wt?_t:0;return It&&(Mt=Math.max(1,mt),Xt==="bounded"&&(Mt=Math.min(Mt,Yt))),{width:Ge,height:Oe,glyphMarginLeft:jt,glyphMarginWidth:pt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Nt,lineNumbersWidth:qt,decorationsLeft:Lt,decorationsWidth:Jt,contentLeft:nn,contentWidth:Ct,minimap:Ot,viewportColumn:mt,isWordWrapMinified:rn,isViewportWrapping:It,wrappingColumn:Mt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Vt,overviewRuler:{top:St,width:gt,height:Oe-2*St,right:0}}}}e.EditorLayoutInfoComputer=Y;class ie extends P{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ce){return l(ce,"simple",["simple","advanced"])}compute(ce,Ie,Ge){return Ie.get(2)===2?"advanced":Ge}}var $e;(function(ae){ae.Off="off",ae.OnCode="onCode",ae.On="on"})($e||(e.ShowLightbulbIconMode=$e={}));class ue extends P{constructor(){const ce={enabled:$e.On};super(65,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[$e.Off,$e.OnCode,$e.On],default:ce.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:l(ce.enabled,this.defaultValue.enabled,[$e.Off,$e.OnCode,$e.On])}}}class ve extends P{constructor(){const ce={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:b.localize(57,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:l(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends P{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,O.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,O.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:b.localize(65,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:l(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:f(Ie.padding,this.defaultValue.padding)}}}class B extends P{constructor(){super(66,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):i.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Ie,Ge){return Ge<0?i.clampedInt(-Ge*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ee extends o{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>o.clamp(ce,0,150),{markdownDescription:b.localize(66,null)})}compute(ce,Ie,Ge){return ce.fontInfo.lineHeight}}class pe extends P{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ce.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ce.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ce.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ce.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),autohide:f(Ie.autohide,this.defaultValue.autohide),size:l(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(Ie.side,this.defaultValue.side,["right","left"]),showSlider:l(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ie.scale,1,1,3),maxColumn:i.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:f(Ie.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:f(Ie.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:o.clamp(Ie.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Ce(ae){return ae==="ctrlCmd"?O.$j?"metaKey":"ctrlKey":"altKey"}class oe extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{top:i.clampedInt(Ie.top,0,0,1e3),bottom:i.clampedInt(Ie.bottom,0,0,1e3)}}}class se extends P{constructor(){const ce={enabled:!0,cycle:!0};super(86,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:b.localize(84,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),cycle:f(Ie.cycle,this.defaultValue.cycle)}}}class re extends w{constructor(){super(143)}compute(ce,Ie,Ge){return ce.pixelRatio}}class G extends P{constructor(){const ce={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ce.strings,description:b.localize(88,null)},comments:{anyOf:Ie,default:ce.comments,description:b.localize(89,null)},other:{anyOf:Ie,default:ce.other,description:b.localize(90,null)}},default:ce,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const Ut=ce?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Ie,comments:Ge,strings:Oe}=ce,ot=["on","inline","off"];let ut,vt,Rt;return typeof Ie=="boolean"?ut=Ie?"on":"off":ut=l(Ie,this.defaultValue.other,ot),typeof Ge=="boolean"?vt=Ge?"on":"off":vt=l(Ge,this.defaultValue.comments,ot),typeof Oe=="boolean"?Rt=Oe?"on":"off":Rt=l(Oe,this.defaultValue.strings,ot),{other:ut,comments:vt,strings:Rt}}}var ne;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class me extends P{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(ce){let Ie=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Ie=4,Ge=ce):ce==="interval"?Ie=3:ce==="relative"?Ie=2:ce==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ge}}}function be(ae){const ce=ae.get(98);return ce==="editable"?ae.get(91):ce!=="on"}class Re extends P{constructor(){const ce=[],Ie={type:"number",description:b.localize(97,null)};super(102,"rulers",ce,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:ce,description:b.localize(99,null)})}validate(ce){if(Array.isArray(ce)){const Ie=[];for(const Ge of ce)if(typeof Ge=="number")Ie.push({column:i.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Oe=Ge;Ie.push({column:i.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return Ie.sort((Ge,Oe)=>Ge.column-Oe.column),Ie}return this.defaultValue}}class fe extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function De(ae,ce){if(typeof ae!="string")return ce;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends P{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce,Ge=i.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=i.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Ie.vertical,this.defaultValue.vertical),horizontal:De(Ie.horizontal,this.defaultValue.horizontal),useShadows:f(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:i.clampedInt(Ie.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:i.clampedInt(Ie.verticalSliderSize,Oe,0,1e3),scrollByPage:f(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends P{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:b.localize(118,null)}})}applyUpdate(ce,Ie){let Ge=!1;Ie.allowedCharacters&&ce&&(L.$7n(ce.allowedCharacters,Ie.allowedCharacters)||(ce={...ce,allowedCharacters:Ie.allowedCharacters},Ge=!0)),Ie.allowedLocales&&ce&&(L.$7n(ce.allowedLocales,Ie.allowedLocales)||(ce={...ce,allowedLocales:Ie.allowedLocales},Ge=!0));const Oe=super.applyUpdate(ce,Ie);return Ge?new p(Oe.newValue,!0):Oe}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{nonBasicASCII:he(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Ie){if(typeof ce!="object"||!ce)return Ie;const Ge={};for(const[Oe,ot]of Object.entries(ce))ot===!0&&(Ge[Oe]=!0);return Ge}}class W extends P{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ce.fontFamily,description:b.localize(125,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),mode:l(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:l(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Ie.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily)}}}class V extends P{constructor(){const ce={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ce,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ce.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ce.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ce.backgroundColoring,description:b.localize(132,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showToolbar:l(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),keepOnBlur:f(Ie.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:f(Ie.backgroundColoring,this.defaultValue.backgroundColoring)}}}class J extends P{constructor(){const ce={enabled:R.$4s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$4s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends P{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ce.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:ce.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ce.highlightActiveIndentation,description:b.localize(148,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{bracketPairs:he(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(ae,ce,Ie){const Ge=Ie.indexOf(ae);return Ge===-1?ce:Ie[Ge]}class we extends P{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:ce.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:ce.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertMode:l(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:l(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:f(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:f(Ie.preview,this.defaultValue.preview),previewMode:l(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Ie.showMethods,this.defaultValue.showMethods),showFunctions:f(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Ie.showFields,this.defaultValue.showFields),showVariables:f(Ie.showVariables,this.defaultValue.showVariables),showClasses:f(Ie.showClasses,this.defaultValue.showClasses),showStructs:f(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:f(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Ie.showModules,this.defaultValue.showModules),showProperties:f(Ie.showProperties,this.defaultValue.showProperties),showEvents:f(Ie.showEvents,this.defaultValue.showEvents),showOperators:f(Ie.showOperators,this.defaultValue.showOperators),showUnits:f(Ie.showUnits,this.defaultValue.showUnits),showValues:f(Ie.showValues,this.defaultValue.showValues),showConstants:f(Ie.showConstants,this.defaultValue.showConstants),showEnums:f(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Ie.showKeywords,this.defaultValue.showKeywords),showWords:f(Ie.showWords,this.defaultValue.showWords),showColors:f(Ie.showColors,this.defaultValue.showColors),showFiles:f(Ie.showFiles,this.defaultValue.showFiles),showReferences:f(Ie.showReferences,this.defaultValue.showReferences),showFolders:f(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:f(Ie.showUsers,this.defaultValue.showUsers),showIssues:f(Ie.showIssues,this.defaultValue.showIssues)}}}class Fe extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(ce.selectSubwords,this.defaultValue.selectSubwords)}}}class qe extends P{constructor(){const ce=[];super(130,"wordSegmenterLocales",ce,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ce){if(typeof ce=="string"&&(ce=[ce]),Array.isArray(ce)){const Ie=[];for(const Ge of ce)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&Ie.push(Ge)}catch{}return Ie}return this.defaultValue}}var Je;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(Je||(e.WrappingIndent=Je={}));class rt extends P{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Ie,Ge){return Ie.get(2)===2?0:Ge}}class tt extends w{constructor(){super(146)}compute(ce,Ie,Ge){const Oe=Ie.get(145);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class nt extends P{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showDropSelector:l(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends P{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:f(Ie.enabled,this.defaultValue.enabled),showPasteSelector:l(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:O.$j?Be:O.$k?He:Pe,fontWeight:"normal",fontSize:O.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var Xe;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.ariaRequired=5]="ariaRequired",ae[ae.autoClosingBrackets=6]="autoClosingBrackets",ae[ae.autoClosingComments=7]="autoClosingComments",ae[ae.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ae[ae.autoClosingDelete=9]="autoClosingDelete",ae[ae.autoClosingOvertype=10]="autoClosingOvertype",ae[ae.autoClosingQuotes=11]="autoClosingQuotes",ae[ae.autoIndent=12]="autoIndent",ae[ae.automaticLayout=13]="automaticLayout",ae[ae.autoSurround=14]="autoSurround",ae[ae.bracketPairColorization=15]="bracketPairColorization",ae[ae.guides=16]="guides",ae[ae.codeLens=17]="codeLens",ae[ae.codeLensFontFamily=18]="codeLensFontFamily",ae[ae.codeLensFontSize=19]="codeLensFontSize",ae[ae.colorDecorators=20]="colorDecorators",ae[ae.colorDecoratorsLimit=21]="colorDecoratorsLimit",ae[ae.columnSelection=22]="columnSelection",ae[ae.comments=23]="comments",ae[ae.contextmenu=24]="contextmenu",ae[ae.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=26]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=28]="cursorStyle",ae[ae.cursorSurroundingLines=29]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=31]="cursorWidth",ae[ae.disableLayerHinting=32]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ae[ae.domReadOnly=34]="domReadOnly",ae[ae.dragAndDrop=35]="dragAndDrop",ae[ae.dropIntoEditor=36]="dropIntoEditor",ae[ae.emptySelectionClipboard=37]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=39]="extraEditorClassName",ae[ae.fastScrollSensitivity=40]="fastScrollSensitivity",ae[ae.find=41]="find",ae[ae.fixedOverflowWidgets=42]="fixedOverflowWidgets",ae[ae.folding=43]="folding",ae[ae.foldingStrategy=44]="foldingStrategy",ae[ae.foldingHighlight=45]="foldingHighlight",ae[ae.foldingImportsByDefault=46]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=47]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=49]="fontFamily",ae[ae.fontInfo=50]="fontInfo",ae[ae.fontLigatures=51]="fontLigatures",ae[ae.fontSize=52]="fontSize",ae[ae.fontWeight=53]="fontWeight",ae[ae.fontVariations=54]="fontVariations",ae[ae.formatOnPaste=55]="formatOnPaste",ae[ae.formatOnType=56]="formatOnType",ae[ae.glyphMargin=57]="glyphMargin",ae[ae.gotoLocation=58]="gotoLocation",ae[ae.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ae[ae.hover=60]="hover",ae[ae.inDiffEditor=61]="inDiffEditor",ae[ae.inlineSuggest=62]="inlineSuggest",ae[ae.inlineEdit=63]="inlineEdit",ae[ae.letterSpacing=64]="letterSpacing",ae[ae.lightbulb=65]="lightbulb",ae[ae.lineDecorationsWidth=66]="lineDecorationsWidth",ae[ae.lineHeight=67]="lineHeight",ae[ae.lineNumbers=68]="lineNumbers",ae[ae.lineNumbersMinChars=69]="lineNumbersMinChars",ae[ae.linkedEditing=70]="linkedEditing",ae[ae.links=71]="links",ae[ae.matchBrackets=72]="matchBrackets",ae[ae.minimap=73]="minimap",ae[ae.mouseStyle=74]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=76]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=78]="multiCursorModifier",ae[ae.multiCursorPaste=79]="multiCursorPaste",ae[ae.multiCursorLimit=80]="multiCursorLimit",ae[ae.occurrencesHighlight=81]="occurrencesHighlight",ae[ae.overviewRulerBorder=82]="overviewRulerBorder",ae[ae.overviewRulerLanes=83]="overviewRulerLanes",ae[ae.padding=84]="padding",ae[ae.pasteAs=85]="pasteAs",ae[ae.parameterHints=86]="parameterHints",ae[ae.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=89]="quickSuggestions",ae[ae.quickSuggestionsDelay=90]="quickSuggestionsDelay",ae[ae.readOnly=91]="readOnly",ae[ae.readOnlyMessage=92]="readOnlyMessage",ae[ae.renameOnType=93]="renameOnType",ae[ae.renderControlCharacters=94]="renderControlCharacters",ae[ae.renderFinalNewline=95]="renderFinalNewline",ae[ae.renderLineHighlight=96]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=98]="renderValidationDecorations",ae[ae.renderWhitespace=99]="renderWhitespace",ae[ae.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ae[ae.roundedSelection=101]="roundedSelection",ae[ae.rulers=102]="rulers",ae[ae.scrollbar=103]="scrollbar",ae[ae.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=105]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=106]="scrollPredominantAxis",ae[ae.selectionClipboard=107]="selectionClipboard",ae[ae.selectionHighlight=108]="selectionHighlight",ae[ae.selectOnLineNumbers=109]="selectOnLineNumbers",ae[ae.showFoldingControls=110]="showFoldingControls",ae[ae.showUnused=111]="showUnused",ae[ae.snippetSuggestions=112]="snippetSuggestions",ae[ae.smartSelect=113]="smartSelect",ae[ae.smoothScrolling=114]="smoothScrolling",ae[ae.stickyScroll=115]="stickyScroll",ae[ae.stickyTabStops=116]="stickyTabStops",ae[ae.stopRenderingLineAfter=117]="stopRenderingLineAfter",ae[ae.suggest=118]="suggest",ae[ae.suggestFontSize=119]="suggestFontSize",ae[ae.suggestLineHeight=120]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ae[ae.suggestSelection=122]="suggestSelection",ae[ae.tabCompletion=123]="tabCompletion",ae[ae.tabIndex=124]="tabIndex",ae[ae.unicodeHighlighting=125]="unicodeHighlighting",ae[ae.unusualLineTerminators=126]="unusualLineTerminators",ae[ae.useShadowDOM=127]="useShadowDOM",ae[ae.useTabStops=128]="useTabStops",ae[ae.wordBreak=129]="wordBreak",ae[ae.wordSegmenterLocales=130]="wordSegmenterLocales",ae[ae.wordSeparators=131]="wordSeparators",ae[ae.wordWrap=132]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=135]="wordWrapColumn",ae[ae.wordWrapOverride1=136]="wordWrapOverride1",ae[ae.wordWrapOverride2=137]="wordWrapOverride2",ae[ae.wrappingIndent=138]="wrappingIndent",ae[ae.wrappingStrategy=139]="wrappingStrategy",ae[ae.showDeprecated=140]="showDeprecated",ae[ae.inlayHints=141]="inlayHints",ae[ae.editorClassName=142]="editorClassName",ae[ae.pixelRatio=143]="pixelRatio",ae[ae.tabFocusMode=144]="tabFocusMode",ae[ae.layoutInfo=145]="layoutInfo",ae[ae.wrappingInfo=146]="wrappingInfo",ae[ae.defaultColorDecorators=147]="defaultColorDecorators",ae[ae.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ae[ae.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Le(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Le(new v),accessibilityPageSize:Le(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Le(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Le(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Le(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Le(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Le(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Le(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Le(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Le(new a(13,"automaticLayout",!1)),autoSurround:Le(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Le(new J),bracketPairGuides:Le(new X),stickyTabStops:Le(new a(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Le(new a(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Le(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Le(new a(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Le(new r(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Le(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Le(new a(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Le(new g),contextmenu:Le(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new a(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Le(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Le(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Le(new c(28,"cursorStyle",k.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:b.localize(260,null)})),cursorSurroundingLines:Le(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Le(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Le(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Le(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new a(34,"domReadOnly",!1)),dragAndDrop:Le(new a(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Le(new F),dropIntoEditor:Le(new nt),stickyScroll:Le(new ve),experimentalWhitespaceRendering:Le(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new o(40,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:b.localize(271,null)})),find:Le(new j),fixedOverflowWidgets:Le(new a(42,"fixedOverflowWidgets",!1)),folding:Le(new a(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Le(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Le(new a(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Le(new a(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Le(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Le(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Le(new T),fontLigatures2:Le(new z),fontSize:Le(new U),fontWeight:Le(new Z),fontVariations:Le(new M),formatOnPaste:Le(new a(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Le(new a(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Le(new a(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Le(new te),hideCursorInOverviewRuler:Le(new a(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Le(new q),inDiffEditor:Le(new a(61,"inDiffEditor",!1)),letterSpacing:Le(new o(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>o.clamp(ae,-5,20),{description:b.localize(285,null)})),lightbulb:Le(new ue),lineDecorationsWidth:Le(new B),lineHeight:Le(new ee),lineNumbers:Le(new me),lineNumbersMinChars:Le(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new a(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Le(new a(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Le(new r(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Le(new pe),mouseStyle:Le(new r(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new o(75,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Le(new a(76,"mouseWheelZoom",!1,{markdownDescription:O.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Le(new a(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Le(new c(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ce,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Le(new r(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Le(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Le(new r(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Le(new a(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Le(new i(83,"overviewRulerLanes",3,0,3)),padding:Le(new oe),pasteAs:Le(new st),parameterHints:Le(new se),peekWidgetDefaultFocus:Le(new r(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Le(new a(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Le(new G),quickSuggestionsDelay:Le(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Le(new a(91,"readOnly",!1)),readOnlyMessage:Le(new fe),renameOnType:Le(new a(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Le(new a(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Le(new r(95,"renderFinalNewline",O.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Le(new r(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Le(new a(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Le(new r(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new r(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Le(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new a(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Le(new Re),scrollbar:Le(new Ae),scrollBeyondLastColumn:Le(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Le(new a(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Le(new a(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Le(new a(107,"selectionClipboard",!0,{description:b.localize(325,null),included:O.$k})),selectionHighlight:Le(new a(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Le(new a(109,"selectOnLineNumbers",!0)),showFoldingControls:Le(new r(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Le(new a(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Le(new a(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Le(new _),snippetSuggestions:Le(new r(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Le(new Fe),smoothScrolling:Le(new a(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Le(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new we),inlineSuggest:Le(new W),inlineEdit:Le(new V),inlineCompletionsAccessibilityVerbose:Le(new a(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Le(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new a(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Le(new r(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Le(new r(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Le(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new ze),unusualLineTerminators:Le(new r(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Le(new a(127,"useShadowDOM",!0)),useTabStops:Le(new a(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Le(new r(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Le(new qe),wordSeparators:Le(new t(131,"wordSeparators",N.$5s,{description:b.localize(359,null)})),wordWrap:Le(new r(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Le(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Le(new r(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new r(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new I),defaultColorDecorators:Le(new a(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Le(new re),tabFocusMode:Le(new a(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Le(new Y),wrappingInfo:Le(new tt),wrappingIndent:Le(new rt),wrappingStrategy:Le(new ie)}}),define(ke[207],Se([9,10]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(ke[84],Se([1,0,79,2,180,29,190,207]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$fu=e.$eu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$du=e.$cu=e.SymbolKinds=e.SymbolTag=e.$au=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$$t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$0t=e.$9t=e.$8t=void 0,e.$_t=r,e.$bu=s;class m{constructor(K,Y,ie){this.offset=K,this.type=Y,this.language=ie,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$8t=m;class E{constructor(K,Y){this.tokens=K,this.endState=Y,this._tokenizationResultBrand=void 0}}e.$9t=E;class A{constructor(K,Y){this.tokens=K,this.endState=Y,this._encodedTokenizationResultBrand=void 0}}e.$0t=A;var P;(function(q){q[q.Increase=0]="Increase",q[q.Decrease=1]="Decrease"})(P||(e.HoverVerbosityAction=P={}));var p;(function(q){q[q.Method=0]="Method",q[q.Function=1]="Function",q[q.Constructor=2]="Constructor",q[q.Field=3]="Field",q[q.Variable=4]="Variable",q[q.Class=5]="Class",q[q.Struct=6]="Struct",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Event=10]="Event",q[q.Operator=11]="Operator",q[q.Unit=12]="Unit",q[q.Value=13]="Value",q[q.Constant=14]="Constant",q[q.Enum=15]="Enum",q[q.EnumMember=16]="EnumMember",q[q.Keyword=17]="Keyword",q[q.Text=18]="Text",q[q.Color=19]="Color",q[q.File=20]="File",q[q.Reference=21]="Reference",q[q.Customcolor=22]="Customcolor",q[q.Folder=23]="Folder",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue",q[q.Snippet=27]="Snippet"})(p||(e.CompletionItemKind=p={}));var y;(function(q){const K=new Map;K.set(0,d.$Vj.symbolMethod),K.set(1,d.$Vj.symbolFunction),K.set(2,d.$Vj.symbolConstructor),K.set(3,d.$Vj.symbolField),K.set(4,d.$Vj.symbolVariable),K.set(5,d.$Vj.symbolClass),K.set(6,d.$Vj.symbolStruct),K.set(7,d.$Vj.symbolInterface),K.set(8,d.$Vj.symbolModule),K.set(9,d.$Vj.symbolProperty),K.set(10,d.$Vj.symbolEvent),K.set(11,d.$Vj.symbolOperator),K.set(12,d.$Vj.symbolUnit),K.set(13,d.$Vj.symbolValue),K.set(15,d.$Vj.symbolEnum),K.set(14,d.$Vj.symbolConstant),K.set(15,d.$Vj.symbolEnum),K.set(16,d.$Vj.symbolEnumMember),K.set(17,d.$Vj.symbolKeyword),K.set(27,d.$Vj.symbolSnippet),K.set(18,d.$Vj.symbolText),K.set(19,d.$Vj.symbolColor),K.set(20,d.$Vj.symbolFile),K.set(21,d.$Vj.symbolReference),K.set(22,d.$Vj.symbolCustomColor),K.set(23,d.$Vj.symbolFolder),K.set(24,d.$Vj.symbolTypeParameter),K.set(25,d.$Vj.account),K.set(26,d.$Vj.issues);function Y(ue){let ve=K.get(ue);return ve||(console.info("No codicon found for CompletionItemKind "+ue),ve=d.$Vj.symbolProperty),ve}q.toIcon=Y;const ie=new Map;ie.set("method",0),ie.set("function",1),ie.set("constructor",2),ie.set("field",3),ie.set("variable",4),ie.set("class",5),ie.set("struct",6),ie.set("interface",7),ie.set("module",8),ie.set("property",9),ie.set("event",10),ie.set("operator",11),ie.set("unit",12),ie.set("value",13),ie.set("constant",14),ie.set("enum",15),ie.set("enum-member",16),ie.set("enumMember",16),ie.set("keyword",17),ie.set("snippet",27),ie.set("text",18),ie.set("color",19),ie.set("file",20),ie.set("reference",21),ie.set("customcolor",22),ie.set("folder",23),ie.set("type-parameter",24),ie.set("typeParameter",24),ie.set("account",25),ie.set("issue",26);function $e(ue,ve){let _=ie.get(ue);return typeof _>"u"&&!ve&&(_=9),_}q.fromString=$e})(y||(e.CompletionItemKinds=y={}));var w;(function(q){q[q.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var h;(function(q){q[q.None=0]="None",q[q.KeepWhitespace=1]="KeepWhitespace",q[q.InsertAsSnippet=4]="InsertAsSnippet"})(h||(e.CompletionItemInsertTextRule=h={}));var f;(function(q){q[q.Word=0]="Word",q[q.Line=1]="Line",q[q.Suggest=2]="Suggest"})(f||(e.PartialAcceptTriggerKind=f={}));var a;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(a||(e.CompletionTriggerKind=a={}));var n;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(n||(e.InlineCompletionTriggerKind=n={}));class i{constructor(K,Y,ie,$e){this.range=K,this.text=Y,this.completionKind=ie,this.isSnippetText=$e}equals(K){return R.$ut.lift(this.range).equalsRange(K.range)&&this.text===K.text&&this.completionKind===K.completionKind&&this.isSnippetText===K.isSnippetText}}e.$$t=i;var u;(function(q){q[q.Invoke=1]="Invoke",q[q.Auto=2]="Auto"})(u||(e.CodeActionTriggerType=u={}));var o;(function(q){q[q.Automatic=0]="Automatic",q[q.PasteAs=1]="PasteAs"})(o||(e.DocumentPasteTriggerKind=o={}));var t;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var l;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(l||(e.DocumentHighlightKind=l={}));function r(q){return q&&L.URI.isUri(q.uri)&&R.$ut.isIRange(q.range)&&(R.$ut.isIRange(q.originSelectionRange)||R.$ut.isIRange(q.targetSelectionRange))}var c;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(c||(e.SymbolKind=c={})),e.$au={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function s(q,K){return(0,b.localize)(26,null,q,e.$au[K])}var v;(function(q){q[q.Deprecated=1]="Deprecated"})(v||(e.SymbolTag=v={}));var g;(function(q){const K=new Map;K.set(0,d.$Vj.symbolFile),K.set(1,d.$Vj.symbolModule),K.set(2,d.$Vj.symbolNamespace),K.set(3,d.$Vj.symbolPackage),K.set(4,d.$Vj.symbolClass),K.set(5,d.$Vj.symbolMethod),K.set(6,d.$Vj.symbolProperty),K.set(7,d.$Vj.symbolField),K.set(8,d.$Vj.symbolConstructor),K.set(9,d.$Vj.symbolEnum),K.set(10,d.$Vj.symbolInterface),K.set(11,d.$Vj.symbolFunction),K.set(12,d.$Vj.symbolVariable),K.set(13,d.$Vj.symbolConstant),K.set(14,d.$Vj.symbolString),K.set(15,d.$Vj.symbolNumber),K.set(16,d.$Vj.symbolBoolean),K.set(17,d.$Vj.symbolArray),K.set(18,d.$Vj.symbolObject),K.set(19,d.$Vj.symbolKey),K.set(20,d.$Vj.symbolNull),K.set(21,d.$Vj.symbolEnumMember),K.set(22,d.$Vj.symbolStruct),K.set(23,d.$Vj.symbolEvent),K.set(24,d.$Vj.symbolOperator),K.set(25,d.$Vj.symbolTypeParameter);function Y(ie){let $e=K.get(ie);return $e||(console.info("No codicon found for SymbolKind "+ie),$e=d.$Vj.symbolProperty),$e}q.toIcon=Y})(g||(e.SymbolKinds=g={}));class D{static asEditOperation(K){return O.$vt.replace(R.$ut.lift(K.range),K.text)}}e.$cu=D;class ${static{this.Comment=new $("comment")}static{this.Imports=new $("imports")}static{this.Region=new $("region")}static fromValue(K){switch(K){case"comment":return $.Comment;case"imports":return $.Imports;case"region":return $.Region}return new $(K)}constructor(K){this.value=K}}e.$du=$;var k;(function(q){q[q.AIGenerated=1]="AIGenerated"})(k||(e.NewSymbolNameTag=k={}));var S;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(S||(e.NewSymbolNameTriggerKind=S={}));var C;(function(q){function K(Y){return!Y||typeof Y!="object"?!1:typeof Y.id=="string"&&typeof Y.title=="string"}q.is=K})(C||(e.Command=C={}));var I;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(I||(e.CommentThreadCollapsibleState=I={}));var F;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(F||(e.CommentThreadState=F={}));var j;(function(q){q[q.Current=0]="Current",q[q.Outdated=1]="Outdated"})(j||(e.CommentThreadApplicability=j={}));var z;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var M;(function(q){q[q.Published=0]="Published",q[q.Draft=1]="Draft"})(M||(e.CommentState=M={}));var T;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(T||(e.InlayHintKind=T={}));class U{constructor(K){this.b=K,this.a=null}dispose(){this.a&&this.a.then(K=>{K&&K.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$eu=U,e.$fu=new N.$Zt;var Z;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Z||(e.ExternalUriOpenerPriority=Z={}));var te;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(te||(e.InlineEditTriggerKind=te={}))}),define(ke[208],Se([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[209],Se([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[210],Se([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(ke[211],Se([9,10]),function(le,e){return le.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[212],Se([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[213],Se([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[214],Se([9,10]),function(le,e){return le.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[215],Se([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(ke[216],Se([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(ke[217],Se([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[218],Se([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(ke[219],Se([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(ke[220],Se([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(ke[221],Se([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[222],Se([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[223],Se([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(ke[224],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[225],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[226],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[227],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[228],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[229],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[230],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[231],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[232],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[233],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[234],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[235],Se([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[236],Se([9,10]),function(le,e){return le.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[237],Se([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(ke[238],Se([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(ke[239],Se([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(ke[240],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[241],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[242],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[243],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[244],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[245],Se([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[246],Se([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[247],Se([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[248],Se([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[249],Se([9,10]),function(le,e){return le.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[250],Se([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[251],Se([1,0,13,210]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var O;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(O||(e.TokenType=O={}));function R(...E){switch(E.length){case 1:return(0,L.localize)(0,null,E[0]);case 2:return(0,L.localize)(1,null,E[0],E[1]);case 3:return(0,L.localize)(2,null,E[0],E[1],E[2]);default:return}}const N=(0,L.localize)(3,null),b=(0,L.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,d.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const P=this.d,p=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:p};this.g.push({offset:P,lexeme:p,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const P=this.c.substring(this.d,this.e),p=m.b.get(P);p?this.k(p):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,P=!1,p=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const w=this.c.charCodeAt(A);if(P)P=!1;else if(w===47&&!p){A++;break}else w===91?p=!0:w===92?P=!0:w===93&&(p=!1);A++}for(;A<this.c.length&&m.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=m}),define(ke[252],Se([1,0,23,41,213,401]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=m,e.$Hp=E,e.$Ip=A,e.$Jp=P,e.$Kp=p,e.$Lp=y,e.$Mp=w;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function m(a){return a=a.trim(),a==="*"||N.test(a)}function E(a){if(!m(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=a.match(N);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(a){if(!a)return null;const n=a.majorBase,i=a.majorMustEqual,u=a.minorBase;let o=a.minorMustEqual;const t=a.patchBase;let l=a.patchMustEqual;a.hasCaret&&(n===0||(o=!1),l=!1);let r=0;if(a.preRelease){const c=b.exec(a.preRelease);if(c){const[,s,v,g]=c;r=Date.UTC(Number(s),Number(v)-1,Number(g))}}return{majorBase:n,majorMustEqual:i,minorBase:u,minorMustEqual:o,patchBase:t,patchMustEqual:l,isMinimum:a.hasGreaterEquals,notBefore:r}}function P(a,n,i){let u;typeof a=="string"?u=A(E(a)):u=a;let o;n instanceof Date?o=n.getTime():typeof n=="string"&&(o=new Date(n).getTime());let t;if(typeof i=="string"?t=A(E(i)):t=i,!u||!t)return!1;const l=u.majorBase,r=u.minorBase,c=u.patchBase;let s=t.majorBase,v=t.minorBase,g=t.patchBase;const D=t.notBefore;let $=t.majorMustEqual,k=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?l>s?!0:l<s?!1:r>v?!0:r<v||o&&o<D?!1:c>=g:(l===1&&s===0&&(!$||!k||!S)&&(s=1,v=0,g=0,$=!0,k=!1,S=!1),l<s?!1:l>s?!$:r<v?!1:r>v?!k:c<g?!1:c>g?!S:!(o&&o<D))}function p(a,n,i,u,o){const t=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return t.push([L.default.Error,O.localize(0,null)]),t;if(typeof u.name!="string")return t.push([L.default.Error,O.localize(1,null,"name")]),t;if(typeof u.version!="string")return t.push([L.default.Error,O.localize(2,null,"version")]),t;if(!u.engines)return t.push([L.default.Error,O.localize(3,null,"engines")]),t;if(typeof u.engines.vscode!="string")return t.push([L.default.Error,O.localize(4,null,"engines.vscode")]),t;if(typeof u.extensionDependencies<"u"&&!f(u.extensionDependencies))return t.push([L.default.Error,O.localize(5,null,"extensionDependencies")]),t;if(typeof u.activationEvents<"u"){if(!f(u.activationEvents))return t.push([L.default.Error,O.localize(6,null,"activationEvents")]),t;if(typeof u.main>"u"&&typeof u.browser>"u")return t.push([L.default.Error,O.localize(7,null,"activationEvents","main","browser")]),t}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&t.push([L.default.Warning,O.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return t.push([L.default.Error,O.localize(9,null,"main")]),t;{const c=(0,d.$0g)(i,u.main);(0,d.$4g)(c,i)||t.push([L.default.Warning,O.localize(10,null,c.path,i.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return t.push([L.default.Error,O.localize(11,null,"browser")]),t;{const c=(0,d.$0g)(i,u.browser);(0,d.$4g)(c,i)||t.push([L.default.Warning,O.localize(12,null,c.path,i.path)])}}if(!R.valid(u.version))return t.push([L.default.Error,O.localize(13,null)]),t;const l=[];if(!y(a,n,u,o,l))for(const c of l)t.push([L.default.Error,c]);return t}function y(a,n,i,u,o){return u||typeof i.main>"u"&&typeof i.browser>"u"?!0:h(a,n,i.engines.vscode,o)}function w(a,n,i){return a==="*"||h(n,i,a)}function h(a,n,i,u=[]){const o=A(E(i));if(!o)return u.push(O.localize(14,null,i)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return u.push(O.localize(15,null,i)),!1}else if(!o.majorMustEqual)return u.push(O.localize(16,null,i)),!1;return P(a,n,o)?!0:(u.push(O.localize(17,null,a,i)),!1)}function f(a){if(!Array.isArray(a))return!1;for(let n=0,i=a.length;n<i;n++)if(typeof a[n]!="string")return!1;return!0}}),define(ke[106],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class d{constructor(O,R=[],N=!1){this.ctor=O,this.staticArguments=R,this.supportsDelayedInstantiation=N}}e.$ti=d}),define(ke[85],Se([1,0,106]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=R,e.$ys=N;const L=[];var O;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(O||(e.InstantiationType=O={}));function R(b,m,E){m instanceof d.$ti||(m=new d.$ti(m,[],!!E)),L.push([b,m])}function N(){return L}}),define(ke[253],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class d{constructor(R,N){this.key=R,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$ar=d;class L{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const N of this.a.values())N.outgoing.size===0&&R.push(N);return R}insertEdge(R,N){const b=this.lookupOrInsertNode(R),m=this.lookupOrInsertNode(N);b.outgoing.set(m.key,m),m.incoming.set(b.key,b)}removeNode(R){const N=this.b(R);this.a.delete(N);for(const b of this.a.values())b.outgoing.delete(N),b.incoming.delete(N)}lookupOrInsertNode(R){const N=this.b(R);let b=this.a.get(N);return b||(b=new d(N,R),this.a.set(N,b)),b}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[N,b]of this.a)R.push(`${N}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,N]of this.a){const b=new Set([R]),m=this.c(N,b);if(m)return m}}c(R,N){for(const[b,m]of R.outgoing){if(N.has(b))return[...N,b].join(" -> ");N.add(b);const E=this.c(m,N);if(E)return E;N.delete(b)}}}e.$br=L}),define(ke[5],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=O,e.$xi=R;var d;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function b(m){return m[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=b})(d||(e._util=d={})),e.$vi=O("instantiationService");function L(N,b,m){b[d.DI_TARGET]===b?b[d.DI_DEPENDENCIES].push({id:N,index:m}):(b[d.DI_DEPENDENCIES]=[{id:N,index:m}],b[d.DI_TARGET]=b)}function O(N){if(d.serviceIds.has(N))return d.serviceIds.get(N);const b=function(m,E,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(b,m,A)};return b.toString=()=>N,d.serviceIds.set(N,b),b}function R(N){return N}}),define(ke[55],Se([1,0,18,2,5]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=R,e.$5i=N,e.$6i=m,e.$7i=E,e.$8i=A,e.$9i=P,e.$0i=p,e.$$i=w,e.$_i=h,e.$aj=f,e.$3i=(0,O.$wi)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof L.URI)}function N(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof L.URI)}var b;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function m(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function A(a,n){const i=Object.create(null);for(const u in a)P(i,u,a[u],n);return i}function P(a,n,i,u){const o=n.split("."),t=o.pop();let l=a;for(let r=0;r<o.length;r++){const c=o[r];let s=l[c];switch(typeof s){case"undefined":s=l[c]=Object.create(null);break;case"object":if(s===null){u(`Ignoring ${n} as ${o.slice(0,r+1).join(".")} is null`);return}break;default:u(`Ignoring ${n} as ${o.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}l=s}if(typeof l=="object"&&l!==null)try{l[t]=i}catch{u(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(l)}`)}else u(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(l)}`)}function p(a,n){const i=n.split(".");y(a,i)}function y(a,n){const i=n.shift();if(n.length===0){delete a[i];return}if(Object.keys(a).indexOf(i)!==-1){const u=a[i];typeof u=="object"&&!Array.isArray(u)&&(y(u,n),Object.keys(u).length===0&&delete a[i])}}function w(a,n,i){function u(l,r){let c=l;for(const s of r){if(typeof c!="object"||c===null)return;c=c[s]}return c}const o=n.split("."),t=u(a,o);return typeof t>"u"?i:t}function h(a,n,i){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in a?d.$$f(a[u])&&d.$$f(n[u])?h(a[u],n[u],i):i&&(a[u]=n[u]):a[u]=n[u])})}function f(a){return a.replace(/[\[\]]/g,"")}}),define(ke[38],Se([1,0,12,14,251,5,209,13]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=E,e.$vj=l,e.$wj=r,e.$Pj=$e;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",d.$j),m.set("isLinux",d.$k),m.set("isWindows",d.$i),m.set("isWeb",d.$o),m.set("isMacNative",d.$j&&!d.$o),m.set("isEdge",d.$H),m.set("isFirefox",d.$F),m.set("isChrome",d.$E),m.set("isSafari",d.$G);function E(_,B){if(m.get(_)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(_,B)}const A=Object.prototype.hasOwnProperty;var P;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const p={regexParsingWithErrorRecovery:!0},y=(0,N.localize)(0,null),w=(0,N.localize)(1,null),h=(0,N.localize)(2,null),f=(0,N.localize)(3,null),a=(0,N.localize)(4,null),n=(0,N.localize)(5,null),i=(0,N.localize)(6,null),u=(0,N.localize)(7,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=p){this.k=B,this.d=new O.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ee=this.l();if(!this.E()){const pe=this.D(),Ce=pe.type===17?n:void 0;throw this.h.push({message:a,offset:pe.offset,lexeme:O.$rj.getLexeme(pe),additionalInfo:Ce}),o.c}return ee}catch(ee){if(ee!==o.c)throw ee;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ee=this.o();B.push(ee)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ee=this.s();B.push(ee)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const ee=this.l();return this.A(1,f),ee?.negate()}case 17:return this.z(),C.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ee=this.l();return this.A(1,f),ee}case 17:{const ee=B.lexeme;if(this.z(),this.y(9)){const Ce=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ce.type!==10)throw this.B("REGEX",Ce);const oe=Ce.lexeme,se=oe.lastIndexOf("/"),re=se===oe.length-1?void 0:this.w(oe.substring(se+1));let G;try{G=new RegExp(oe.substring(1,se),re)}catch{throw this.B("REGEX",Ce)}return T.create(ee,G)}switch(Ce.type){case 10:case 19:{const oe=[Ce.lexeme];this.z();let se=this.D(),re=0;for(let Re=0;Re<Ce.lexeme.length;Re++)Ce.lexeme.charCodeAt(Re)===40?re++:Ce.lexeme.charCodeAt(Re)===41&&re--;for(;!this.E()&&se.type!==15&&se.type!==16;){switch(se.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let Re=0;Re<se.lexeme.length;Re++)se.lexeme.charCodeAt(Re)===40?re++:Ce.lexeme.charCodeAt(Re)===41&&re--}if(re<0)break;oe.push(O.$rj.getLexeme(se)),this.z(),se=this.D()}const G=oe.join(""),ne=G.lastIndexOf("/"),me=ne===G.length-1?void 0:this.w(G.substring(ne+1));let be;try{be=new RegExp(G.substring(1,ne),me)}catch{throw this.B("REGEX",Ce)}return t.regex(ee,be)}case 18:{const oe=Ce.lexeme;this.z();let se=null;if(!(0,L.$8e)(oe)){const re=oe.indexOf("/"),G=oe.lastIndexOf("/");if(re!==G&&re>=0){const ne=oe.slice(re+1,G),me=oe[G+1]==="i"?"i":"";try{se=new RegExp(ne,me)}catch{throw this.B("REGEX",Ce)}}}if(se===null)throw this.B("REGEX",Ce);return T.create(ee,se)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const Ce=this.u();return t.notIn(ee,Ce)}switch(this.D().type){case 3:{this.z();const Ce=this.u();if(this.x().type===18)return t.equals(ee,Ce);switch(Ce){case"true":return t.has(ee);case"false":return t.not(ee);default:return t.equals(ee,Ce)}}case 4:{this.z();const Ce=this.u();if(this.x().type===18)return t.notEquals(ee,Ce);switch(Ce){case"true":return t.not(ee);case"false":return t.has(ee);default:return t.notEquals(ee,Ce)}}case 5:return this.z(),z.create(ee,this.u());case 6:return this.z(),M.create(ee,this.u());case 7:return this.z(),F.create(ee,this.u());case 8:return this.z(),j.create(ee,this.u());case 13:return this.z(),t.in(ee,this.u());default:return t.has(ee)}}case 20:throw this.h.push({message:i,offset:B.offset,lexeme:"",additionalInfo:u}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ee){if(this.C(B))return this.z();throw this.B(ee,this.D())}B(B,ee,pe){const Ce=(0,N.localize)(8,null,B,O.$rj.getLexeme(ee)),oe=ee.offset,se=O.$rj.getLexeme(ee);return this.h.push({message:Ce,offset:oe,lexeme:se,additionalInfo:pe}),o.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=o;class t{static false(){return s.INSTANCE}static true(){return v.INSTANCE}static has(B){return g.create(B)}static equals(B,ee){return D.create(B,ee)}static notEquals(B,ee){return S.create(B,ee)}static regex(B,ee){return T.create(B,ee)}static in(B,ee){return $.create(B,ee)}static notIn(B,ee){return k.create(B,ee)}static not(B){return C.create(B)}static and(...B){return te.create(B,null,!0)}static or(...B){return q.create(B,null,!0)}static greater(B,ee){return F.create(B,ee)}static greaterEquals(B,ee){return j.create(B,ee)}static smaller(B,ee){return z.create(B,ee)}static smallerEquals(B,ee){return M.create(B,ee)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$uj=t;function l(_){const B=new o({regexParsingWithErrorRecovery:!1});return _.map(ee=>(B.parse(ee),B.lexingErrors.length>0?B.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,N.localize)(9,null,pe.additionalInfo):(0,N.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function r(_,B){const ee=_?_.substituteConstants():void 0,pe=B?B.substituteConstants():void 0;return!ee&&!pe?!0:!ee||!pe?!1:ee.equals(pe)}function c(_,B){return _.cmp(B)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return v.INSTANCE}}e.$xj=s;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return s.INSTANCE}}e.$yj=v;class g{static create(B,ee=null){const pe=m.get(B);return typeof pe=="boolean"?pe?v.INSTANCE:s.INSTANCE:new g(B,ee)}constructor(B,ee){this.key=B,this.c=ee,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:Y(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=m.get(this.key);return typeof B=="boolean"?B?v.INSTANCE:s.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$zj=g;class D{static create(B,ee,pe=null){if(typeof ee=="boolean")return ee?g.create(B,pe):C.create(B,pe);const Ce=m.get(B);return typeof Ce=="boolean"?ee===(Ce?"true":"false")?v.INSTANCE:s.INSTANCE:new D(B,ee,pe)}constructor(B,ee,pe){this.c=B,this.d=ee,this.f=pe,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ie(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=m.get(this.c);if(typeof B=="boolean"){const ee=B?"true":"false";return this.d===ee?v.INSTANCE:s.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Aj=D;class ${static create(B,ee){return new $(B,ee)}constructor(B,ee){this.d=B,this.f=ee,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ie(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ee=B.getValue(this.f),pe=B.getValue(this.d);return Array.isArray(ee)?ee.includes(pe):typeof pe=="string"&&typeof ee=="object"&&ee!==null?A.call(ee,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Bj=$;class k{static create(B,ee){return new k(B,ee)}constructor(B,ee){this.d=B,this.f=ee,this.type=11,this.c=$.create(B,ee)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=k;class S{static create(B,ee,pe=null){if(typeof ee=="boolean")return ee?C.create(B,pe):g.create(B,pe);const Ce=m.get(B);return typeof Ce=="boolean"?ee===(Ce?"true":"false")?s.INSTANCE:v.INSTANCE:new S(B,ee,pe)}constructor(B,ee,pe){this.c=B,this.d=ee,this.f=pe,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ie(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=m.get(this.c);if(typeof B=="boolean"){const ee=B?"true":"false";return this.d===ee?s.INSTANCE:v.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Dj=S;class C{static create(B,ee=null){const pe=m.get(B);return typeof pe=="boolean"?pe?s.INSTANCE:v.INSTANCE:new C(B,ee)}constructor(B,ee){this.c=B,this.d=ee,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:Y(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=m.get(this.c);return typeof B=="boolean"?B?s.INSTANCE:v.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$Ej=C;function I(_,B){if(typeof _=="string"){const ee=parseFloat(_);isNaN(ee)||(_=ee)}return typeof _=="string"||typeof _=="number"?B(_):s.INSTANCE}class F{static create(B,ee,pe=null){return I(ee,Ce=>new F(B,Ce,pe))}constructor(B,ee,pe){this.c=B,this.d=ee,this.f=pe,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ie(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Fj=F;class j{static create(B,ee,pe=null){return I(ee,Ce=>new j(B,Ce,pe))}constructor(B,ee,pe){this.c=B,this.d=ee,this.f=pe,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ie(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Gj=j;class z{static create(B,ee,pe=null){return I(ee,Ce=>new z(B,Ce,pe))}constructor(B,ee,pe){this.c=B,this.d=ee,this.f=pe,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ie(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Hj=z;class M{static create(B,ee,pe=null){return I(ee,Ce=>new M(B,Ce,pe))}constructor(B,ee,pe){this.c=B,this.d=ee,this.f=pe,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ie(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Ij=M;class T{static create(B,ee){return new T(B,ee)}constructor(B,ee){this.d=B,this.f=ee,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ee=this.f?this.f.source:"",pe=B.f?B.f.source:"";return ee<pe?-1:ee>pe?1:0}equals(B){if(B.type===this.type){const ee=this.f?this.f.source:"",pe=B.f?B.f.source:"";return this.d===B.d&&ee===pe}return!1}substituteConstants(){return this}evaluate(B){const ee=B.getValue(this.d);return this.f?this.f.test(ee):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$Jj=T;class U{static create(B){return new U(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new U(this.c.map(B))}negate(){return this.c}}e.$Kj=U;function Z(_){let B=null;for(let ee=0,pe=_.length;ee<pe;ee++){const Ce=_[ee].substituteConstants();if(_[ee]!==Ce&&B===null){B=[];for(let oe=0;oe<ee;oe++)B[oe]=_[oe]}B!==null&&(B[ee]=Ce)}return B===null?_:B}class te{static create(B,ee,pe){return te.d(B,ee,pe)}constructor(B,ee){this.expr=B,this.c=ee,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ee=0,pe=this.expr.length;ee<pe;ee++){const Ce=c(this.expr[ee],B.expr[ee]);if(Ce!==0)return Ce}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ee=0,pe=this.expr.length;ee<pe;ee++)if(!this.expr[ee].equals(B.expr[ee]))return!1;return!0}return!1}substituteConstants(){const B=Z(this.expr);return B===this.expr?this:te.create(B,this.c,!1)}evaluate(B){for(let ee=0,pe=this.expr.length;ee<pe;ee++)if(!this.expr[ee].evaluate(B))return!1;return!0}static d(B,ee,pe){const Ce=[];let oe=!1;for(const se of B)if(se){if(se.type===1){oe=!0;continue}if(se.type===0)return s.INSTANCE;if(se.type===6){Ce.push(...se.expr);continue}Ce.push(se)}if(Ce.length===0&&oe)return v.INSTANCE;if(Ce.length!==0){if(Ce.length===1)return Ce[0];Ce.sort(c);for(let se=1;se<Ce.length;se++)Ce[se-1].equals(Ce[se])&&(Ce.splice(se,1),se--);if(Ce.length===1)return Ce[0];for(;Ce.length>1;){const se=Ce[Ce.length-1];if(se.type!==9)break;Ce.pop();const re=Ce.pop(),G=Ce.length===0,ne=q.create(se.expr.map(me=>te.create([me,re],null,pe)),null,G);ne&&(Ce.push(ne),Ce.sort(c))}if(Ce.length===1)return Ce[0];if(pe){for(let se=0;se<Ce.length;se++)for(let re=se+1;re<Ce.length;re++)if(Ce[se].negate().equals(Ce[re]))return s.INSTANCE;if(Ce.length===1)return Ce[0]}return new te(Ce,ee)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ee of this.expr)B.push(...ee.keys());return B}map(B){return new te(this.expr.map(ee=>ee.map(B)),null)}negate(){if(!this.c){const B=[];for(const ee of this.expr)B.push(ee.negate());this.c=q.create(B,this,!0)}return this.c}}e.$Lj=te;class q{static create(B,ee,pe){return q.d(B,ee,pe)}constructor(B,ee){this.expr=B,this.c=ee,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ee=0,pe=this.expr.length;ee<pe;ee++){const Ce=c(this.expr[ee],B.expr[ee]);if(Ce!==0)return Ce}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ee=0,pe=this.expr.length;ee<pe;ee++)if(!this.expr[ee].equals(B.expr[ee]))return!1;return!0}return!1}substituteConstants(){const B=Z(this.expr);return B===this.expr?this:q.create(B,this.c,!1)}evaluate(B){for(let ee=0,pe=this.expr.length;ee<pe;ee++)if(this.expr[ee].evaluate(B))return!0;return!1}static d(B,ee,pe){let Ce=[],oe=!1;if(B){for(let se=0,re=B.length;se<re;se++){const G=B[se];if(G){if(G.type===0){oe=!0;continue}if(G.type===1)return v.INSTANCE;if(G.type===9){Ce=Ce.concat(G.expr);continue}Ce.push(G)}}if(Ce.length===0&&oe)return s.INSTANCE;Ce.sort(c)}if(Ce.length!==0){if(Ce.length===1)return Ce[0];for(let se=1;se<Ce.length;se++)Ce[se-1].equals(Ce[se])&&(Ce.splice(se,1),se--);if(Ce.length===1)return Ce[0];if(pe){for(let se=0;se<Ce.length;se++)for(let re=se+1;re<Ce.length;re++)if(Ce[se].negate().equals(Ce[re]))return v.INSTANCE;if(Ce.length===1)return Ce[0]}return new q(Ce,ee)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ee of this.expr)B.push(...ee.keys());return B}map(B){return new q(this.expr.map(ee=>ee.map(B)),null)}negate(){if(!this.c){const B=[];for(const ee of this.expr)B.push(ee.negate());for(;B.length>1;){const ee=B.shift(),pe=B.shift(),Ce=[];for(const oe of ve(ee))for(const se of ve(pe))Ce.push(te.create([oe,se],null,!1));B.unshift(q.create(Ce,null,!1))}this.c=q.create(B,this,!0)}return this.c}}e.$Mj=q;class K extends g{static{this.d=[]}static all(){return K.d.values()}constructor(B,ee,pe){super(B,null),this.f=ee,typeof pe=="object"?K.d.push({...pe,key:B}):pe!==!0&&K.d.push({key:B,description:pe,type:ee!=null?typeof ee:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return D.create(this.key,B)}notEqualsTo(B){return S.create(this.key,B)}}e.$Nj=K,e.$Oj=(0,R.$wi)("contextKeyService");function Y(_,B){return _<B?-1:_>B?1:0}function ie(_,B,ee,pe){return _<ee?-1:_>ee?1:B<pe?-1:B>pe?1:0}function $e(_,B){if(_.type===0||B.type===1)return!0;if(_.type===9)return B.type===9?ue(_.expr,B.expr):!1;if(B.type===9){for(const ee of B.expr)if($e(_,ee))return!0;return!1}if(_.type===6){if(B.type===6)return ue(B.expr,_.expr);for(const ee of _.expr)if($e(ee,B))return!0;return!1}return _.equals(B)}function ue(_,B){let ee=0,pe=0;for(;ee<_.length&&pe<B.length;){const Ce=_[ee].cmp(B[pe]);if(Ce<0)return!1;Ce===0&&ee++,pe++}return ee===_.length}function ve(_){return _.type===9?_.expr:[_]}}),define(ke[254],Se([1,0,23,41,211,5,103,12,24]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Jw=e.$Iw=e.$Hw=void 0,e.$Kw=y,e.$Lw=w,e.$Hw=(0,R.$wi)("dialogService");var E;(function(h){h[h.Confirmation=1]="Confirmation",h[h.Prompt=2]="Prompt",h[h.Input=3]="Input"})(E||(E={}));class A{a(f){return this.d(f,E.Confirmation)}b(f){return this.d(f,E.Prompt)}c(f){return this.d(f,E.Input)}d(f,a){const n=[];switch(a){case E.Confirmation:{const i=f;i.primaryButton?n.push(i.primaryButton):n.push((0,O.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,O.localize)(1,null));break}case E.Prompt:{const i=f;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(u=>u.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,O.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,O.localize)(3,null))),n.length===0&&n.push((0,O.localize)(4,null));break}case E.Input:{const i=f;i.primaryButton?n.push(i.primaryButton):n.push((0,O.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,O.localize)(6,null));break}}return n}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===L.default.Info?"info":f===L.default.Error?"error":f===L.default.Warning?"warning":"none"}f(f,a,n){const i=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&i.push(f.cancelButton);let u=i[a]?.run({checkboxChecked:n});return u instanceof Promise||(u=Promise.resolve(u)),{result:u,checkboxChecked:n}}}e.$Iw=A,e.$Jw=(0,R.$wi)("fileDialogService");var P;(function(h){h[h.SAVE=0]="SAVE",h[h.DONT_SAVE=1]="DONT_SAVE",h[h.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const p=10;function y(h){const f=[];return f.push(...h.slice(0,p).map(a=>typeof a=="string"?a:(0,d.$7g)(a))),h.length>p&&(h.length-p===1?f.push((0,O.localize)(7,null)):f.push((0,O.localize)(8,null,h.length-p))),f.push(""),f.join(`
`)}function w(h,f){const a=(0,m.$3n)(h);let n=(a.buttons??[]).map(t=>(0,N.$Ew)(t)),i=(h.buttons||[]).map((t,l)=>l),u=0,o=a.cancelId??n.length-1;if(n.length>1){const t=typeof o=="number"?n[o]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&o!==1){n.splice(o,1),n.splice(1,0,t);const l=i[o];i.splice(o,1),i.splice(1,0,l),o=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),u=n.length-1,typeof t=="string"&&(o=u-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&o!==n.length-1){n.splice(o,1),n.push(t);const l=i[o];i.splice(o,1),i.push(l),o=n.length-1}}return a.buttons=n,a.defaultId=u,a.cancelId=o,a.noLink=!0,a.title=a.title||f.nameLong,{options:a,buttonIndeces:i}}}),define(ke[137],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,d.$wi)("environmentService"),e.$Ei=(0,d.$xi)(e.$Di)}),define(ke[138],Se([1,0,212,5]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=O,e.$1o=R,e.$2o=N,e.$3o=b,e.$4o=m,e.$5o=E,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function O(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function N(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(n,i){return i==="web"&&!n.includes("web")}function m(n,i,u){return b(i,u)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===u}function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var A;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var P;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var p;(function(n){n.Install="install",n.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var y;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$6o=(0,L.$wi)("extensionGalleryService");var w;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));class h extends Error{constructor(i,u){super(i),this.code=u,this.name=u}}e.$7o=h;var f;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(f||(e.ExtensionGalleryErrorCode=f={}));class a extends Error{constructor(i,u){super(i),this.code=u,this.name=u}}e.$8o=a,e.$9o=(0,L.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,L.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,L.$wi)("IExtensionTipsService"),e.$bp=(0,d.localize2)(0,"Extensions"),e.$cp=(0,d.localize2)(1,"Preferences")}),define(ke[255],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=e.$j7b=void 0,e.$j7b=(0,d.$wi)("externalTerminal"),e.$k7b="Terminal.app"}),define(ke[256],Se([1,0,54,56,15,17,12,102,32,105,214,255]),function(le,e,d,L,O,R,N,b,m,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=e.$scc=void 0;const p=A.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends y{static{this.b="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(d,o,E.$om(),t)}spawnTerminal(o,t,l,r){const c=t.windowsExec||w.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=R.$oc(c,".exe").toLowerCase();if(s==="cmder")return o.spawn(c,r?[r]:void 0),Promise.resolve(void 0);const v=["/c","start","/wait"];return c.indexOf(" ")>=0&&v.push('""'),v.push(c),s==="wt"&&v.push("-d ."),new Promise((g,D)=>{const $=a(process),k=o.spawn(l,v,{cwd:r,env:$,detached:!0});k.on("error",D),k.on("exit",()=>g())})}async runInTerminal(o,t,l,r,c){const s="windowsExec"in c&&c.windowsExec?c.windowsExec:w.getDefaultTerminalWindows(),v=await w.f();return new Promise((g,D)=>{const $=`"${t} - ${p}"`,k=`"${l.join('" "')}" & pause`,S=Object.assign({},a(process),r);Object.keys(S).filter(z=>S[z]===null).forEach(z=>delete S[z]);const C={cwd:t,env:S,windowsVerbatimArguments:!0};let I,F;R.$oc(s,".exe")==="wt"?(I=s,F=["-d",".",w.b,"/c",k]):v?(I=v,F=["-d",".",s,"/c",k]):(I=w.b,F=["/c","start",$,"/wait",s,"/c",`"${k}"`]),d.spawn(I,F,C).on("error",z=>{D(n(z))}),g(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const o=await E.win32.findExecutable("wt");return await m.Promises.exists(o)?o:void 0}catch{return}}}e.$scc=w,Ke([L.$1h],w,"f",null);class h extends y{static{this.b="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(d,o,t)}runInTerminal(o,t,l,r,c){const s=c.osxExec||P.$k7b;return new Promise((v,g)=>{if(s===P.$k7b||s==="iTerm.app"){const D=s===P.$k7b?"TerminalHelper":"iTermHelper",k=[O.$Qg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",o||p,"-w",t];for(const I of l)k.push("-a"),k.push(I);if(r){const I=Object.assign({},a(process),r);for(const F in I){const j=I[F];j===null?(k.push("-u"),k.push(F)):(k.push("-e"),k.push(`${F}=${j}`))}}let S="";const C=d.spawn(h.b,k);C.on("error",I=>{g(n(I))}),C.stderr.on("data",I=>{S+=I.toString()}),C.on("exit",I=>{if(I===0)v(void 0);else if(S){const F=S.split(`
`,1);g(new Error(F[0]))}else g(new Error(A.localize(1,null,D,I)))})}else g(new Error(A.localize(2,null,s)))})}spawnTerminal(o,t,l){const r=t.osxExec||P.$k7b;return new Promise((c,s)=>{const v=["-a",r];l&&v.push(l);const g=a(process),D=o.spawn("/usr/bin/open",v,{cwd:l,env:g});D.on("error",s),D.on("exit",()=>c())})}}e.$tcc=h;class f extends y{static{this.b=A.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(d,o,t)}runInTerminal(o,t,l,r,c){const s=c.linuxExec?Promise.resolve(c.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((v,g)=>{const D=[];s.then($=>{$.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const k=`${i(l)}; echo; read -p "${f.b}" -n1;`;D.push(`''${k}''`);const S=Object.assign({},a(process),r);Object.keys(S).filter(j=>S[j]===null).forEach(j=>delete S[j]);const C={cwd:t,env:S};let I="";const F=d.spawn($,D,C);F.on("error",j=>{g(n(j))}),F.stderr.on("data",j=>{I+=j.toString()}),F.on("exit",j=>{if(j===0)v(void 0);else if(I){const z=I.split(`
`,1);g(new Error(z[0]))}else g(new Error(A.localize(4,null,$,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!N.$k)f.d=Promise.resolve("xterm");else{const o=await m.Promises.exists("/etc/debian_version");f.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return f.d}spawnTerminal(o,t,l){const r=t.linuxExec?Promise.resolve(t.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((c,s)=>{r.then(v=>{const g=a(process),D=o.spawn(v,[],{cwd:l,env:g});D.on("error",s),D.on("exit",()=>c())})})}}e.$ucc=f;function a(u){const o={...u.env};return(0,b.$mm)(o),o}function n(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(A.localize(5,null,u.path)):u}function i(u){let o="";for(const t of u)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(ke[33],Se([1,0,78,17,14,18,2,215,5,12,15,46]),function(le,e,d,L,O,R,N,b,m,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=p,e.$5k=f,e.$6k=n,e.$7k=i,e.$8k=u,e.$9k=o,e.$0k=t,e.$$k=l,e.$_k=r,e.$al=c,e.$bl=s,e.$dl=D,e.$el=$,e.$fl=k,e.$gl=S,e.$hl=C,e.$kl=M,e.$wl=K,e.$xl=Y,e.$zl=$e,e.$3k=(0,m.$wi)("fileService");function p(ue){return ue.create===!0}var y;(function(ue){ue[ue.Unknown=0]="Unknown",ue[ue.File=1]="File",ue[ue.Directory=2]="Directory",ue[ue.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var w;(function(ue){ue[ue.Readonly=1]="Readonly",ue[ue.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var h;(function(ue){ue[ue.UPDATED=2]="UPDATED",ue[ue.ADDED=4]="ADDED",ue[ue.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function f(ue){const ve=ue;return!!ve&&typeof ve.onDidChange=="function"}var a;(function(ue){ue[ue.None=0]="None",ue[ue.FileReadWrite=2]="FileReadWrite",ue[ue.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ue[ue.FileReadStream=16]="FileReadStream",ue[ue.FileFolderCopy=8]="FileFolderCopy",ue[ue.PathCaseSensitive=1024]="PathCaseSensitive",ue[ue.Readonly=2048]="Readonly",ue[ue.Trash=4096]="Trash",ue[ue.FileWriteUnlock=8192]="FileWriteUnlock",ue[ue.FileAtomicRead=16384]="FileAtomicRead",ue[ue.FileAtomicWrite=32768]="FileAtomicWrite",ue[ue.FileAtomicDelete=65536]="FileAtomicDelete",ue[ue.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function n(ue){return!!(ue.capabilities&2)}function i(ue){return!!(ue.capabilities&8)}function u(ue){return!!(ue.capabilities&131072)}function o(ue){return!!(ue.capabilities&4)}function t(ue){return!!(ue.capabilities&16)}function l(ue){return n(ue)?!!(ue.capabilities&16384):!1}function r(ue){return n(ue)?!!(ue.capabilities&32768):!1}function c(ue){return!!(ue.capabilities&65536)}function s(ue){return!!(ue.capabilities&2048)}var v;(function(ue){ue.FileExists="EntryExists",ue.FileNotFound="EntryNotFound",ue.FileNotADirectory="EntryNotADirectory",ue.FileIsADirectory="EntryIsADirectory",ue.FileExceedsStorageQuota="EntryExceedsStorageQuota",ue.FileTooLarge="EntryTooLarge",ue.FileWriteLocked="EntryWriteLocked",ue.NoPermissions="NoPermissions",ue.Unavailable="Unavailable",ue.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class g extends Error{static create(ve,_){const B=new g(ve.toString(),_);return k(B,_),B}constructor(ve,_){super(ve),this.code=_}}e.$cl=g;function D(ue,ve){return g.create(ue,ve)}function $(ue){return ue||D((0,b.localize)(0,null),v.Unknown)}function k(ue,ve){return ue.name=ve?`${ve} (FileSystemError)`:"FileSystemError",ue}function S(ue){if(!ue)return v.Unknown;if(ue instanceof g)return ue.code;const ve=/^(.+) \(FileSystemError\)$/.exec(ue.name);if(!ve)return v.Unknown;switch(ve[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function C(ue){if(ue instanceof T)return ue.fileOperationResult;switch(S(ue)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}var I;(function(ue){ue[ue.CREATE=0]="CREATE",ue[ue.DELETE=1]="DELETE",ue[ue.MOVE=2]="MOVE",ue[ue.COPY=3]="COPY",ue[ue.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class F{constructor(ve,_,B){this.resource=ve,this.operation=_,this.target=B}isOperation(ve){return this.operation===ve}}e.$il=F;var j;(function(ue){ue[ue.UPDATED=0]="UPDATED",ue[ue.ADDED=1]="ADDED",ue[ue.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class z{static{this.a=null}constructor(ve,_){this.c=_,this.b=void 0,this.d=new P.$V(()=>{const B=d.$Ci.forUris(()=>this.c);return B.fill(this.rawAdded.map(ee=>[ee,!0])),B}),this.f=new P.$V(()=>{const B=d.$Ci.forUris(()=>this.c);return B.fill(this.rawUpdated.map(ee=>[ee,!0])),B}),this.g=new P.$V(()=>{const B=d.$Ci.forUris(()=>this.c);return B.fill(this.rawDeleted.map(ee=>[ee,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of ve){switch(B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}this.b!==z.a&&(typeof B.cId=="number"?this.b===void 0?this.b=B.cId:this.b!==B.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(ve,..._){return this.h(ve,{includeChildren:!1},..._)}affects(ve,..._){return this.h(ve,{includeChildren:!0},..._)}h(ve,_,...B){if(!ve)return!1;const ee=B.length>0;return!!((!ee||B.includes(1))&&(this.d.value.get(ve)||_.includeChildren&&this.d.value.findSuperstr(ve))||(!ee||B.includes(0))&&(this.f.value.get(ve)||_.includeChildren&&this.f.value.findSuperstr(ve))||(!ee||B.includes(2))&&(this.g.value.findSubstr(ve)||_.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$jl=z;function M(ue,ve,_){return!ue||!ve||ue===ve||ve.length>ue.length?!1:(ve.charAt(ve.length-1)!==L.sep&&(ve+=L.sep),_?(0,O.$zf)(ue,ve):ue.indexOf(ve)===0)}class T extends Error{constructor(ve,_,B){super(ve),this.fileOperationResult=_,this.options=B}}e.$ll=T;class U extends T{constructor(ve,_,B,ee){super(ve,_,ee),this.fileOperationResult=_,this.size=B}}e.$ml=U;class Z extends T{constructor(ve,_,B){super(ve,2,B),this.stat=_}}e.$nl=Z;var te;(function(ue){ue[ue.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ue[ue.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ue[ue.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ue[ue.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ue[ue.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ue[ue.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ue[ue.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ue[ue.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ue[ue.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ue[ue.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ue[ue.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var q;(function(ue){ue[ue.FILE=0]="FILE",ue[ue.FOLDER=1]="FOLDER",ue[ue.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.$vl="";function K(ue){if(!(typeof ue.size!="number"||typeof ue.mtime!="number"))return ue.mtime.toString(29)+ue.size.toString(31)}async function Y(ue,ve){if(!ve.hasProvider(N.URI.from({scheme:ue.scheme})))return new Promise(_=>{const B=ve.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===ue.scheme&&ee.added&&(B.dispose(),_())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(ve){return(0,R.$ag)(ve)||(ve=0),ve<ie.KB?(0,b.localize)(1,null,ve.toFixed(0)):ve<ie.MB?(0,b.localize)(2,null,(ve/ie.KB).toFixed(2)):ve<ie.GB?(0,b.localize)(3,null,(ve/ie.MB).toFixed(2)):ve<ie.TB?(0,b.localize)(4,null,(ve/ie.GB).toFixed(2)):(0,b.localize)(5,null,(ve/ie.TB).toFixed(2))}}e.$yl=ie;function $e(ue){const ve=typeof ue=="string"||ue?.scheme===A.Schemas.vscodeRemote;return typeof ue!="string"&&ue?.scheme===A.Schemas.file?1024*ie.MB:ve?10*ie.MB:E.$o?50*ie.MB:1024*ie.MB}}),define(ke[257],Se([1,0,21,13,216,33]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=N;async function N(A,P,p,y,w,h){let f;try{await b(A,P,p,y,w,h)}catch(a){f=a}finally{f&&w.errorTransformer&&(f=w.errorTransformer(f)),typeof f<"u"&&p.error(f),p.end()}}async function b(A,P,p,y,w,h){m(h);const f=await A.open(P,{create:!1});try{m(h);let a=0,n=0,i=w&&typeof w.length=="number"?w.length:void 0,u=d.$Ge.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),o=w&&typeof w.position=="number"?w.position:0,t=0;do n=await A.read(f,o,u.buffer,t,u.byteLength-t),o+=n,t+=n,a+=n,typeof i=="number"&&(i-=n),t===u.byteLength&&(await p.write(y(u)),u=d.$Ge.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&m(h)&&E(a,w));if(t>0){let l=t;typeof i=="number"&&(l=Math.min(t,i)),p.write(y(u.slice(0,l)))}}catch(a){throw(0,R.$el)(a)}finally{await A.close(f)}}function m(A){if(A.isCancellationRequested)throw(0,L.$6)();return!0}function E(A,P){if(typeof P?.limits?.size=="number"&&A>P.limits.size)throw(0,R.$dl)((0,O.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],Se([1,0,35,3,17,12,2,33]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=void 0,e.$Jq=m,e.$Kq=E,e.$Oq=y,e.$Pq=w,e.$Qq=h,e.$Rq=f,e.$Sq=n,e.$Tq=i;function m(u){return typeof u.correlationId=="number"}function E(u){return u.recursive===!0}class A extends L.$Vc{static{this.a=5}constructor(o,t,l,r){super(),this.h=o,this.j=t,this.m=l,this.n=r,this.c=this.B(new L.$Wc),this.f=void 0,this.g=0}s(){const o=new L.$Uc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(t=>this.h(t))),o.add(this.b.onDidLogMessage(t=>this.j(t))),o.add(this.b.onDidError(t=>this.t(t)))}t(o){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${o}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${o}`):this.w(o)}u(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}w(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}y(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Lq=A;class P extends A{constructor(o,t,l){super(o,t,l,{type:"node.js",restartOnError:!1})}}e.$Mq=P;class p extends A{constructor(o,t,l){super(o,t,l,{type:"universal",restartOnError:!0})}}e.$Nq=p;function y(u){return u.map(o=>({type:o.type,resource:N.URI.revive(o.resource),cId:o.cId}))}function w(u){const o=new a;for(const t of u)o.processEvent(t);return o.coalesce()}function h(u,o){return typeof o=="string"&&!o.startsWith(d.$mk)&&!(0,O.$jc)(o)?{base:u,pattern:o}:o}function f(u,o){const t=[];for(const l of o)t.push((0,d.$qk)(h(u,l)));return t}class a{constructor(){this.a=new Set,this.b=new Map}c(o){return R.$k?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const t=this.b.get(this.c(o));let l=!1;if(t){const r=t.type,c=o.type;t.resource.fsPath!==o.resource.fsPath&&(o.type===2||o.type===1)?l=!0:r===1&&c===2?(this.b.delete(this.c(o)),this.a.delete(t)):r===2&&c===1?t.type=0:r===1&&c===0||(t.type=c)}else l=!0;l&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],t=[];return Array.from(this.a).filter(l=>l.type!==2?(o.push(l),!1):!0).sort((l,r)=>l.resource.fsPath.length-r.resource.fsPath.length).filter(l=>t.some(r=>(0,b.$kl)(l.resource.fsPath,r,!R.$k))?!1:(t.push(l.resource.fsPath),!0)).concat(o)}}function n(u,o){if(typeof o=="number")switch(u.type){case 1:return(o&4)===0;case 2:return(o&8)===0;case 0:return(o&2)===0}return!1}function i(u){if(typeof u=="number"){const o=[];return u&4&&o.push("Added"),u&8&&o.push("Deleted"),u&2&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(ke[258],Se([1,0,53,3,65,4,2,7]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class m extends L.$Vc{constructor(){super(),this.a=this.B(new R.$ee),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$ee),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$ee),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new L.$5c),this.m=new Set,this.n=5007,this.r=new b.$Th,this.P=!1,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,O.$Jq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new b.$Th;try{this.h.clear(),this.g.clear();for(const P of A)this.t(P)?this.h.set(P.correlationId,P):this.g.add(P);for(const[P]of this.j)this.h.has(P)||(this.j.deleteAndDispose(P),this.m.delete(P));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const P=new L.$Uc;this.j.set(A.correlationId,P),await this.r.p,!P.isDisposed&&(this.z(A,P),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,P){this.C(A,P)?(this.N(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,P),this.m.add(A.correlationId))}C(A,P){const p=this.M?.subscribe(A.path,(y,w)=>{P.isDisposed||(y?this.z(A,P):w?.type===1&&this.F(A))});return p?(P.add(p),!0):!1}D(A,P){let p=!1;const y=(w,h)=>{if(P.isDisposed)return;const f=this.G(w),a=this.G(h),n=p;p=f,!f&&(a||n)&&this.F(A)};this.N(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,d.watchFile)(A.path,{persistent:!1,interval:this.n},y)}catch(w){this.O(`fs.watchFile() failed with error ${w} on path ${A.path} (correlationId: ${A.correlationId})`)}P.add((0,L.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,d.unwatchFile)(A.path,y)}catch(w){this.O(`fs.unwatchFile() failed with error ${w} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.N(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const P={resource:N.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([P]),this.H(P,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,P){if(this.P){const p=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.I(p,P)}}I(A,P){this.P&&this.N(`${A}${typeof P.correlationId=="number"?` <${P.correlationId}> `:""}`)}J(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, filter: ${(0,O.$Tq)(A.filter)}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}async setVerboseLogging(A){this.P=A}}e.$3q=m}),define(ke[259],Se([1,0,53,7,22,31,3,77,17,12,23,2,104,32,65]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0,e.$9q=f;class h extends N.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,i,u,o,t,l){super(),this.s=n,this.t=i,this.u=u,this.w=o,this.y=t,this.z=l,this.c=this.B(new L.$Lh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new L.$Kh(r=>this.M(r),h.b)),this.g=(0,w.$Rq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,w.$Rq)(this.s.path,this.s.includes):void 0,this.j=(0,w.$Jq)(this.s)?this.s.filter:void 0,this.m=new O.$pe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const i=await y.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let i=n.path;try{i=await y.Promises.realpath(n.path),n.path===i&&(i=await(0,p.$5q)(n.path,this.m.token)??n.path),n.path!==i&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async G(n,i){const u=new N.$Uc;return this.H(n,i,u)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,i,u)),u}H(n,i,u){if(i)return!1;const o=P.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(l,r)=>{if(!u.isDisposed)if(l){const c=await this.G(n,i);u.isDisposed?c.dispose():u.add(c)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:o,type:r.type,cId:this.s.correlationId},!0)});return t?(u.add(t),!0):!1}async I(n,i,u){if(E.$j&&(0,R.$vg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const o=new O.$pe(this.m.token);u.add((0,N.$Tc)(()=>o.dispose(!0)));const t=new N.$Uc;u.add(t);try{const l=P.URI.file(this.s.path),r=(0,m.$oc)(n),c=(0,d.watch)(n);t.add((0,N.$Tc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${n}'`);const s=new Set;if(i)try{for(const g of await y.Promises.readdir(n))s.add(g)}catch(g){this.O(g)}if(o.token.isCancellationRequested)return;const v=new Map;t.add((0,N.$Tc)(()=>{for(const[,g]of v)g.dispose();v.clear()})),c.on("error",(g,D)=>{o.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${g}, ${D})`),this.D())}),c.on("change",(g,D)=>{if(o.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${g}"] ${D}`);let $="";if(D&&($=D.toString(),E.$j&&($=(0,b.$bm)($))),!(!$||g!=="change"&&g!=="rename"))if(i)if(g==="rename"){v.get($)?.dispose();const k=setTimeout(async()=>{if(v.delete($),$===r&&!await y.Promises.exists(n)){this.J(l);return}if(o.token.isCancellationRequested)return;const S=await this.N((0,m.$kc)(n,$));if(o.token.isCancellationRequested)return;let C;S?s.has($)?C=0:(C=1,s.add($)):(s.delete($),C=2),this.L({resource:(0,A.$0g)(l,$),type:C,cId:this.s.correlationId})},h.a);v.set($,(0,N.$Tc)(()=>clearTimeout(k)))}else{let k;s.has($)?k=0:(k=1,s.add($)),this.L({resource:(0,A.$0g)(l,$),type:k,cId:this.s.correlationId})}else if(g==="rename"||$!==r){const k=setTimeout(async()=>{const S=await y.Promises.exists(n);o.token.isCancellationRequested||(S?(this.L({resource:l,type:0,cId:this.s.correlationId},!0),t.add(await this.G(n,!1))):this.J(l))},h.a);t.clear(),t.add((0,N.$Tc)(()=>clearTimeout(k)))}else this.L({resource:l,type:0,cId:this.s.correlationId},!0)})}catch(l){o.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${l.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,i=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(u=>u(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(u=>u(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const i=(0,w.$Pq)(n),u=[];for(const t of i){if((0,w.$Sq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}u.push(t)}if(u.length===0)return;if(this.z)for(const t of u)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(E.$k)return y.Promises.exists(n);try{const i=(0,m.$oc)(n);return(await y.Promises.readdir((0,m.$nc)(n))).some(o=>o===i)}catch(i){return this.Q(i),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$8q=h;async function f(a,n,i,u,o=512){const t=await y.Promises.open(a,"r"),l=Buffer.allocUnsafe(o),r=new O.$pe(u);let c,s=!1;const v={path:a,excludes:[],recursive:!1},g=new h(v,void 0,D=>{(async()=>{for(const{type:$}of D)if($===0){if(s)return;s=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:k}=await y.Promises.read(t,l,0,o,null);if(!k||r.token.isCancellationRequested)break;n(l.slice(0,k))}}catch(k){c=new Error(k),r.dispose(!0)}finally{s=!1}}})()});return await g.ready,i(),new Promise((D,$)=>{r.token.onCancellationRequested(async()=>{g.dispose();try{await y.Promises.close(t)}catch(k){c=new Error(k)}c?$(c):D()})})}}),define(ke[260],Se([1,0,4,35,258,12,259,31]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class m extends O.$3q{constructor(A){super(),this.M=A,this.onDidError=d.Event.None,this.watchers=new Set}async L(A){A=this.X(A);const P=[],p=new Set(Array.from(this.watchers));for(const y of A){const w=this.S(y);w&&(0,L.$uk)(w.request.excludes,y.excludes)&&(0,L.$uk)(w.request.includes,y.includes)?p.delete(w):P.push(y)}P.length&&this.N(`Request to start watching: ${P.map(y=>this.J(y)).join(",")}`),p.size&&this.N(`Request to stop watching: ${Array.from(p).map(y=>this.J(y.request)).join(",")}`);for(const y of p)this.W(y);for(const y of P)this.U(y)}S(A){for(const P of this.watchers)if(typeof A.correlationId=="number"||typeof P.request.correlationId=="number"){if(P.request.correlationId===A.correlationId)return P}else if((0,b.$ug)(P.request.path,A.path,!R.$k))return P}U(A){const P=new N.$8q(A,this.M,y=>this.a.fire(y),()=>this.c.fire(A),y=>this.b.fire(y),this.P),p={request:A,instance:P};this.watchers.add(p)}async stop(){await super.stop();for(const A of this.watchers)this.W(A)}W(A){this.N("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}X(A){const P=new Map;for(const p of A){const y=R.$k?p.path:p.path.toLowerCase();let w=P.get(p.correlationId);w||(w=new Map,P.set(p.correlationId,w)),w.has(y)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(p)}`),w.set(y,p)}return Array.from(P.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(A){super.setVerboseLogging(A);for(const P of this.watchers)P.instance.setVerboseLogging(A)}N(A,P){this.P&&this.b.fire({type:"trace",message:this.$(A,P)})}O(A){this.b.fire({type:"warn",message:this.$(A)})}$(A,P){return P?`[File Watcher (node.js)] ${A} (${this.J(P.request)})`:`[File Watcher (node.js)] ${A}`}}e.$0q=m}),define(ke[261],Se([1,0,65,260]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class O extends d.$Mq{constructor(N,b,m){super(N,b,m),this.s()}r(N){return N.add(new L.$0q(void 0))}}e.$$q=O}),define(ke[262],Se([1,0,15,82,199,65]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class N extends R.$Nq{constructor(m,E,A){super(m,E,A),this.s()}r(m){const E=m.add(new O.$1q(d.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(E.onDidProcessExit(({code:A,signal:P})=>this.t(`terminated by itself with code ${A}, signal: ${P} (ETERM)`))),L.ProxyChannel.toService((0,L.$di)(E.getChannel("watcher")))}}e.$2q=N}),define(ke[107],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class d{constructor(...O){this.a=new Map;for(const[R,N]of O)this.set(R,N)}set(O,R){const N=this.a.get(O);return this.a.set(O,R),N}has(O){return this.a.has(O)}get(O){return this.a.get(O)}}e.$ui=d}),define(ke[263],Se([1,0,7,13,3,106,253,5,107,76]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const A=!1;class P extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class p{constructor(f=new m.$ui,a=!1,n,i=A){this.i=f,this.j=a,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$vi,this),this._globalGraph=i?n?._globalGraph??new N.$br(u=>u):void 0}dispose(){if(!this.f){this.f=!0,(0,O.$Qc)(this.h),this.h.clear();for(const f of this.g)(0,O.$Pc)(f)&&f.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(f){this.m();const a=new class extends p{dispose(){this.h.delete(a),super.dispose()}}(f,this.j,this,this.l);return this.h.add(a),a}invokeFunction(f,...a){this.m();const n=w.traceInvocation(this.l,f);let i=!1;try{return f({get:o=>{if(i)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(o,n);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...a)}finally{i=!0,n.stop()}}createInstance(f,...a){this.m();let n,i;return f instanceof R.$ti?(n=w.traceCreation(this.l,f.ctor),i=this.o(f.ctor,f.staticArguments.concat(a),n)):(n=w.traceCreation(this.l,f),i=this.o(f,a,n)),n.stop(),i}o(f,a=[],n){const i=b._util.getServiceDependencies(f).sort((t,l)=>t.index-l.index),u=[];for(const t of i){const l=this.s(t.id,n);l||this.y(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),u.push(l)}const o=i.length>0?i[0].index:a.length;if(a.length!==o){console.trace(`[createInstance] First service dependency of ${f.name} at position ${o+1} conflicts with ${a.length} static arguments`);const t=o-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,o)}return Reflect.construct(f,a.concat(u))}q(f,a){if(this.i.get(f)instanceof R.$ti)this.i.set(f,a);else if(this.k)this.k.q(f,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(f){const a=this.i.get(f);return!a&&this.k?this.k.r(f):a}s(f,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const n=this.r(f);return n instanceof R.$ti?this.u(f,n,a.branch(f,!0)):(a.branch(f,!1),n)}u(f,a,n){if(this.t.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.t.add(f);try{return this.v(f,a,n)}finally{this.t.delete(f)}}v(f,a,n){const i=new N.$br(t=>t.id.toString());let u=0;const o=[{id:f,desc:a,_trace:n}];for(;o.length;){const t=o.pop();if(i.lookupOrInsertNode(t),u++>1e3)throw new P(i);for(const l of b._util.getServiceDependencies(t.desc.ctor)){const r=this.r(l.id);if(r||this.y(`[createInstance] ${f} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),r instanceof R.$ti){const c={id:l.id,desc:r,_trace:t._trace.branch(l.id,!0)};i.insertEdge(t,c),o.push(c)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new P(i);break}for(const{data:l}of t){if(this.r(l.id)instanceof R.$ti){const c=this.w(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.q(l.id,c)}i.removeNode(l)}}return this.r(f)}w(f,a,n=[],i,u){if(this.i.get(f)instanceof R.$ti)return this.x(f,a,n,i,u,this.g);if(this.k)return this.k.w(f,a,n,i,u);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(f,a,n=[],i,u,o){if(i){const t=new p(void 0,this.j,this,this.l);t.c=String(f);const l=new Map,r=new d.$Ph(()=>{const c=t.o(a,n,u);for(const[s,v]of l){const g=c[s];if(typeof g=="function")for(const D of v)D.disposable=g.apply(c,D.listener)}return l.clear(),o.add(c),c});return new Proxy(Object.create(null),{get(c,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let D=l.get(s);return D||(D=new E.$6c,l.set(s,D)),(k,S,C)=>{if(r.isInitialized)return r.value[s](k,S,C);{const I={listener:[k,S,C],disposable:void 0},F=D.push(I);return(0,O.$Tc)(()=>{F(),I.disposable?.dispose()})}}}if(s in c)return c[s];const v=r.value;let g=v[s];return typeof g!="function"||(g=g.bind(v),c[s]=g),g},set(c,s,v){return r.value[s]=v,!0},getPrototypeOf(c){return a.prototype}})}else{const t=this.o(a,n,u);return o.add(t),t}}y(f,a){if(a&&console.warn(f),this.j)throw new Error(f)}}e.$cr=p;var y;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(y||(y={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,a){return f?new w(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(f,a){return f?new w(1,a.name):w.c}static{this.f=0}constructor(f,a){this.type=f,this.name=a,this.g=Date.now(),this.h=[]}branch(f,a){const n=new w(3,f.toString());return this.h.push([f,a,n]),n}stop(){const f=Date.now()-this.g;w.f+=f;let a=!1;function n(u,o){const t=[],l=new Array(u+1).join("	");for(const[r,c,s]of o.h)if(c&&s){a=!0,t.push(`${l}CREATES -> ${r}`);const v=n(u+1,s);v&&t.push(v)}else t.push(`${l}uses -> ${r}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(f>2||a)&&w.all.add(i.join(`
`))}}e.$dr=w}),define(ke[11],Se([1,0,218,47,4,57,3,27,12,23,18,2,38,5]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=h,e.log=a,e.$ek=g,e.$fk=D,e.$gk=$,e.$hk=k,e.$3j=(0,y.$wi)("logService"),e.$4j=(0,y.$wi)("loggerService");function w(){return new Date().toISOString()}function h(S){return(0,A.$ag)(S)}var f;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$6j=f.Info;function a(S,C,I){switch(C){case f.Trace:S.trace(I);break;case f.Debug:S.debug(I);break;case f.Info:S.info(I);break;case f.Warning:S.warn(I);break;case f.Error:S.error(I);break;case f.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(S,C=!1){let I="";for(let F=0;F<S.length;F++){let j=S[F];if(j instanceof Error&&(j=(0,L.$hj)(j,C)),typeof j=="object")try{j=JSON.stringify(j)}catch{}I+=(F>0?" ":"")+j}return I}class i extends N.$Vc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new O.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==f.Off&&this.b<=C}}e.$8j=i;class u extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...I){this.f(f.Trace)&&this.g(f.Trace,n([C,...I],!0))}debug(C,...I){this.f(f.Debug)&&this.g(f.Debug,n([C,...I]))}info(C,...I){this.f(f.Info)&&this.g(f.Info,n([C,...I]))}warn(C,...I){this.f(f.Warning)&&this.g(f.Warning,n([C,...I]))}error(C,...I){if(this.f(f.Error))if(C instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=C.stack,this.g(f.Error,n(F))}else this.g(f.Error,n([C,...I]))}flush(){}}e.$9j=u;class o extends i{constructor(C=e.$6j){super(),this.setLevel(C),this.g=!m.$i}trace(C,...I){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,C,...I):console.log(`[main ${w()}]`,C,...I))}debug(C,...I){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,C,...I):console.log(`[main ${w()}]`,C,...I))}info(C,...I){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,C,...I):console.log(`[main ${w()}]`,C,...I))}warn(C,...I){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,C,...I):console.warn(`[main ${w()}]`,C,...I))}error(C,...I){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,C,...I):console.error(`[main ${w()}]`,C,...I))}flush(){}}e.$0j=o;class t extends i{constructor(C=e.$6j,I=!0){super(),this.g=I,this.setLevel(C)}trace(C,...I){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...I):console.log(C,...I))}debug(C,...I){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...I):console.log(C,...I))}info(C,...I){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...I):console.log(C,...I))}warn(C,...I){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...I):console.log(C,...I))}error(C,...I){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...I):console.error(C,...I))}flush(){}}e.$$j=t;class l extends i{constructor(C,I=e.$6j){super(),this.g=C,this.setLevel(I)}trace(C,...I){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(C),...I])}debug(C,...I){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(C),...I])}info(C,...I){this.f(f.Info)&&this.g.log(f.Info,[this.h(C),...I])}warn(C,...I){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(C),...I])}error(C,...I){this.f(f.Error)&&this.g.log(f.Error,[this.h(C),...I])}h(C){return typeof C=="string"?C:(0,L.$hj)(C,this.f(f.Trace))}flush(){}}e.$_j=l;class r extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const I of this.g)I.setLevel(C);super.setLevel(C)}trace(C,...I){for(const F of this.g)F.trace(C,...I)}debug(C,...I){for(const F of this.g)F.debug(C,...I)}info(C,...I){for(const F of this.g)F.info(C,...I)}warn(C,...I){for(const F of this.g)F.warn(C,...I)}error(C,...I){for(const F of this.g)F.error(C,...I)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ak=r;class c extends N.$Vc{constructor(C,I,F){if(super(),this.h=C,this.j=I,this.b=new b.$Bc,this.c=this.B(new O.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$ee),this.onDidChangeVisibility=this.g.event,F)for(const j of F)this.b.set(j.resource,{logger:void 0,info:j})}m(C){return(0,A.$9f)(C)?[...this.b.values()].find(I=>I.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,I){const F=this.n(C),j=(0,A.$9f)(C)?C:I?.id??(0,R.$kj)(F.toString()).toString(16);let z=this.b.get(F)?.logger;const M=I?.logLevel==="always"?f.Trace:I?.logLevel;z||(z=this.s(F,M??this.getLogLevel(F)??this.h,{...I,id:j}));const T={logger:z,info:{resource:F,id:j,logLevel:M,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(T.info),this.b.set(F,T),z}n(C){return(0,A.$9f)(C)?(0,E.$0g)(this.j,`${C}.log`):C}setLogLevel(C,I){if(P.URI.isUri(C)){const F=C,j=I,z=this.b.get(F);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([F,j]))}else{this.h=C;for(const[F,j]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,I){const F=this.m(C);F&&I!==!F.info.hidden&&(F.info.hidden=!I,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,I]))}getLogLevel(C){let I;return C&&(I=this.b.get(C)?.info.logLevel),I??this.h}registerLogger(C){const I=this.b.get(C.resource);I?I.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const I=this.b.get(C);I&&(I.logger&&I.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=c;class s{constructor(){this.onDidChangeLogLevel=new O.$ee().event}setLevel(C){}getLevel(){return f.Info}trace(C,...I){}debug(C,...I){}info(C,...I){}warn(C,...I){}error(C,...I){}critical(C,...I){}dispose(){}flush(){}}e.$ck=s;class v extends s{}e.$dk=v;function g(S){if(S.verbose)return f.Trace;if(typeof S.logLevel=="string"){const C=k(S.logLevel.toLowerCase());if(C!==void 0)return C}return e.$6j}function D(S){switch(S){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function $(S){switch(S){case f.Trace:return{original:"Trace",value:d.localize(0,null)};case f.Debug:return{original:"Debug",value:d.localize(1,null)};case f.Info:return{original:"Info",value:d.localize(2,null)};case f.Warning:return{original:"Warning",value:d.localize(3,null)};case f.Error:return{original:"Error",value:d.localize(4,null)};case f.Off:return{original:"Off",value:d.localize(5,null)}}}function k(S){switch(S){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$ik=new p.$Nj("logLevel",D(f.Info))}),define(ke[264],Se([1,0,19,7,13,4,31,3,17,65,11]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class P extends b.$Vc{constructor(y,w){super(),this.a=y,this.b=w,this.c=this.B(new R.$ee),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$ee),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$uh(0)),this.w=[],this.y=this.B(new L.$uh(0))}watch(y,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(y,w):this.z(y,w)}n(y,w){const h={path:this.J(y),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},f=(0,d.$Ub)(this.j,h);return this.r(),(0,b.$Tc)(()=>{f(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,O.$1)(y))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,E.$Oq)(w)),w=>this.G(w),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const w of this.j)(0,E.$Kq)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const w of this.j)(0,E.$Kq)(w)&&y.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,w){const h={path:this.J(y),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},f=(0,d.$Ub)(this.w,h);return this.C(),(0,b.$Tc)(()=>{f(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,O.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,E.$Oq)(y)),y=>this.G(y),this.a.getLevel()===A.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===A.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.H(y)}H(y){this.a[y.type](y.message)}I(y){return(0,m.$ic)(y.fsPath)}J(y){const w=this.I(y);return(0,N.$yg)(w)}}e.$Uq=P}),define(ke[265],Se([1,0,53,402,7,27,21,4,31,3,17,12,23,98,32,217,33,257,264,47,262,261]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,(()=>{try{(0,L.gracefulify)(d)}catch(l){console.error(`Error enabling graceful-fs: ${(0,i.$hj)(l)}`)}})();class t extends n.$Uq{static{this.L=!1}constructor(r,c){super(r,c),this.onDidChangeCapabilities=b.Event.None,this.P=new R.$Bc(s=>p.$1g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,P.$k&&(this.M|=1024)),this.M}async stat(r){try{const{stat:c,symbolicLink:s}=await w.SymlinkSupport.stat(this.I(r));return{type:this.O(c,s),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size,permissions:c.mode&128?void 0:f.FilePermission.Locked}}catch(c){throw this.hb(c)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const c=await w.Promises.readdir(this.I(r),{withFileTypes:!0}),s=[];return await Promise.all(c.map(async v=>{try{let g;v.isSymbolicLink()?g=(await this.stat((0,p.$0g)(r,v.name))).type:g=this.O(v),s.push([v.name,g])}catch(g){this.a.trace(g)}})),s}catch(c){throw this.hb(c)}}O(r,c){let s;return c?.dangling?s=f.FileType.Unknown:r.isFile()?s=f.FileType.File:r.isDirectory()?s=f.FileType.Directory:s=f.FileType.Unknown,c&&(s|=f.FileType.SymbolicLink),s}async Q(r){const c=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${c})`);let s;for(;s=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${c})`),await s.wait();const v=new O.$vh;return this.P.set(r,v),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${c})`),(0,E.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${c})`),this.P.get(r)===v&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${c})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${c})`),v.open()})}async readFile(r,c){let s;try{c?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),s=await this.Q(r));const v=this.I(r);return await w.Promises.readFile(v)}catch(v){throw this.hb(v)}finally{s?.dispose()}}R(r){t.L&&this.a.trace(r)}readFileStream(r,c,s){const v=(0,y.$ue)(g=>N.$Ge.concat(g.map(D=>N.$Ge.wrap(D))).buffer);return(0,a.$Hq)(this,r,v,g=>g.buffer,{...c,bufferSize:256*1024},s),v}async writeFile(r,c,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(r)?this.U(r,(0,p.$0g)((0,p.$9g)(r),`${(0,p.$7g)(r)}${s.atomic.postfix}`),c,s):this.W(r,c,s)}async S(r){try{const c=this.I(r),{symbolicLink:s}=await w.SymlinkSupport.stat(c);if(s)return!1}catch{}return!0}async U(r,c,s,v){const g=new E.$Uc;try{g.add(await this.Q(r)),g.add(await this.Q(c)),await this.W(c,s,v,!0);try{await this.rename(c,r,{overwrite:!0})}catch(D){try{await this.delete(c,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{g.dispose()}}async W(r,c,s,v){let g;try{const D=this.I(r);if(!s.create||!s.overwrite){if(await w.Promises.exists(D)){if(!s.overwrite)throw(0,f.$dl)((0,h.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,f.$dl)((0,h.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(r,{create:!0,unlock:s.unlock},v),await this.write(g,0,c,0,c.byteLength)}catch(D){throw await this.ib(r,D)}finally{typeof g=="number"&&await this.close(g)}}static{this.$=!0}static configureFlushOnWrite(r){t.$=r}async open(r,c,s){const v=this.I(r);let g;(0,f.$4k)(c)&&!s&&(g=await this.Q(r));let D;try{if((0,f.$4k)(c)&&c.unlock)try{const{stat:k}=await w.SymlinkSupport.stat(v);k.mode&128||await w.Promises.chmod(v,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let $;if((0,f.$4k)(c)){if(P.$i)try{await w.Promises.truncate(v,0),$="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}$||($="w")}else $="r";D=await w.Promises.open(v,$)}catch($){throw g?.dispose(),(0,f.$4k)(c)?await this.ib(r,$):this.hb($)}if(this.X.set(D,0),(0,f.$4k)(c)&&this.Z.set(D,r),g){const $=this.Y.get(D);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${v})`),this.Y.set(D,g),$&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${v})`),$.dispose())}return D}async close(r){const c=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&t.$)try{await w.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await w.Promises.close(r)}catch(s){throw this.hb(s)}finally{c&&(this.Y.get(r)===c&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),c.dispose())}}async read(r,c,s,v,g){const D=this.ab(r,c);let $=null;try{$=(await w.Promises.read(r,s,v,g,D)).bytesRead}catch(k){throw this.hb(k)}finally{this.bb(r,D,$)}return $}ab(r,c){return c===this.X.get(r)?null:c}bb(r,c,s){const v=this.X.get(r);typeof v=="number"&&(typeof c=="number"||(typeof s=="number"?this.X.set(r,v+s):this.X.delete(r)))}async write(r,c,s,v,g){return(0,O.$Qh)(()=>this.cb(r,c,s,v,g),100,3)}async cb(r,c,s,v,g){const D=this.ab(r,c);let $=null;try{$=(await w.Promises.write(r,s,v,g,D)).bytesWritten}catch(k){throw await this.ib(this.Z.get(r),k)}finally{this.bb(r,D,$)}return $}async mkdir(r){try{await w.Promises.mkdir(this.I(r))}catch(c){throw this.hb(c)}}async delete(r,c){try{const s=this.I(r);if(c.recursive){let v;c?.atomic!==!1&&c.atomic.postfix&&(v=(0,A.$kc)((0,A.$nc)(s),`${(0,A.$oc)(s)}${c.atomic.postfix}`)),await w.Promises.rm(s,w.RimRafMode.MOVE,v)}else try{await w.Promises.unlink(s)}catch(v){if(v.code==="EPERM"||v.code==="EISDIR"){let g=!1;try{const{stat:D,symbolicLink:$}=await w.SymlinkSupport.stat(s);g=D.isDirectory()&&!$}catch{}if(g)await w.Promises.rmdir(s);else throw v}else throw v}}catch(s){throw this.hb(s)}}async rename(r,c,s){const v=this.I(r),g=this.I(c);if(v!==g)try{await this.db(r,c,"move",s.overwrite),await w.Promises.rename(v,g)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,h.localize)(2,null,(0,A.$oc)(v),(0,A.$oc)((0,A.$nc)(g)),D.toString()))),this.hb(D)}}async copy(r,c,s){const v=this.I(r),g=this.I(c);if(v!==g)try{await this.db(r,c,"copy",s.overwrite),await w.Promises.copy(v,g,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,h.localize)(3,null,(0,A.$oc)(v),(0,A.$oc)((0,A.$nc)(g)),D.toString()))),this.hb(D)}}async db(r,c,s,v){const g=this.I(r),D=this.I(c);let $=!1;if(!!(this.capabilities&1024)||($=(0,m.$ug)(g,D,!0)),$){if(s==="copy")throw(0,f.$dl)((0,h.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const S=await this.N(r);if(!S)throw(0,f.$dl)((0,h.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(c);if(C){if(!v)throw(0,f.$dl)((0,h.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);S.type&f.FileType.File&&C.type&f.FileType.File||await this.delete(c,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,c){return this.eb(r,c,!1)}async eb(r,c,s){const v=this.I(r),g=this.I(c),D=!!(this.capabilities&1024);if((0,m.$ug)(v,g,!D))return;const $=new E.$Uc;try{$.add(await this.Q(r)),$.add(await this.Q(c)),s&&await w.Promises.mkdir((0,A.$nc)(g),{recursive:!0}),await w.Promises.copyFile(v,g)}catch(k){if(k.code==="ENOENT"&&!s)return this.eb(r,c,!0);throw this.hb(k)}finally{$.dispose()}}t(r,c,s){return new u.$2q(v=>r(v),v=>c(v),s)}F(r,c,s){return new o.$$q(v=>r(v),v=>c(v),s)}hb(r){if(r instanceof f.$cl)return r;let c=r,s;switch(r.code){case"ENOENT":s=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":c=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=f.FileSystemProviderErrorCode.Unknown;break;default:s=f.FileSystemProviderErrorCode.Unknown}return(0,f.$dl)(c,s)}async ib(r,c){let s=this.hb(c);if(r&&s.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:v}=await w.SymlinkSupport.stat(this.I(r));v.mode&128||(s=(0,f.$dl)(c,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(v){this.a.trace(v)}return s}}e.$_q=t}),define(ke[266],Se([1,0,3,11]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=void 0;class O extends d.$Vc{constructor(N,b=[]){super(),this.a=new L.$ak([N,...b]),this.B(N.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...b){this.a.trace(N,...b)}debug(N,...b){this.a.debug(N,...b)}info(N,...b){this.a.info(N,...b)}warn(N,...b){this.a.warn(N,...b)}error(N,...b){this.a.error(N,...b)}flush(){this.a.flush()}}e.$OQ=O}),define(ke[267],Se([1,0,33,11]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=void 0;var O;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(O||(O={}));async function R(E,A,P,p,y){try{const w=await new Promise((f,a)=>{le(["@vscode/spdlog"],f,a)});w.setFlushOn(O.Trace);const h=await w.createAsyncRotatingLogger(E,A,P,p);return y?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(w){console.error(w)}return null}function N(E,A,P){switch(A){case L.LogLevel.Trace:E.trace(P);break;case L.LogLevel.Debug:E.debug(P);break;case L.LogLevel.Info:E.info(P);break;case L.LogLevel.Warning:E.warn(P);break;case L.LogLevel.Error:E.error(P);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(E,A){switch(A){case L.LogLevel.Trace:E.setLevel(O.Trace);break;case L.LogLevel.Debug:E.setLevel(O.Debug);break;case L.LogLevel.Info:E.setLevel(O.Info);break;case L.LogLevel.Warning:E.setLevel(O.Warning);break;case L.LogLevel.Error:E.setLevel(O.Error);break;case L.LogLevel.Off:E.setLevel(O.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class m extends L.$9j{constructor(A,P,p,y,w){super(),this.m=[],this.setLevel(w),this.n=this.s(A,P,p,y),this.B(this.onDidChangeLogLevel(h=>{this.r&&b(this.r,h)}))}async s(A,P,p,y){const w=p?6:1,h=30/w*d.$yl.MB,f=await R(A,P,h,w,y);if(f){this.r=f,b(this.r,this.getLevel());for(const{level:a,message:n}of this.m)N(this.r,a,n);this.m=[]}}g(A,P){this.r?N(this.r,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$DQ=m}),define(ke[139],Se([1,0,41,219,5]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var N;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(N||(e.MarkerSeverity=N={})),function(m){function E(w,h){return h-w}m.compare=E;const A=Object.create(null);A[m.Error]=(0,L.localize)(0,null),A[m.Warning]=(0,L.localize)(1,null),A[m.Info]=(0,L.localize)(2,null);function P(w){return A[w]||""}m.toString=P;function p(w){switch(w){case d.default.Error:return m.Error;case d.default.Warning:return m.Warning;case d.default.Info:return m.Info;case d.default.Ignore:return m.Hint}}m.fromSeverity=p;function y(w){switch(w){case m.Error:return d.default.Error;case m.Warning:return d.default.Warning;case m.Info:return d.default.Info;case m.Hint:return d.default.Ignore}}m.toSeverity=y}(N||(e.MarkerSeverity=N={}));var b;(function(m){const E="";function A(p){return P(p,!0)}m.makeKey=A;function P(p,y){const w=[E];return p.source?w.push(p.source.replace("\xA6","\\\xA6")):w.push(E),p.code?typeof p.code=="string"?w.push(p.code.replace("\xA6","\\\xA6")):w.push(p.code.value.replace("\xA6","\\\xA6")):w.push(E),p.severity!==void 0&&p.severity!==null?w.push(N.toString(p.severity)):w.push(E),p.message&&y?w.push(p.message.replace("\xA6","\\\xA6")):w.push(E),p.startLineNumber!==void 0&&p.startLineNumber!==null?w.push(p.startLineNumber.toString()):w.push(E),p.startColumn!==void 0&&p.startColumn!==null?w.push(p.startColumn.toString()):w.push(E),p.endLineNumber!==void 0&&p.endLineNumber!==null?w.push(p.endLineNumber.toString()):w.push(E),p.endColumn!==void 0&&p.endColumn!==null?w.push(p.endColumn.toString()):w.push(E),w.push(E),w.join("\xA6")}m.makeKeyOptionalMessage=P})(b||(e.IMarkerData=b={})),e.$7t=(0,O.$wi)("markerService")}),define(ke[268],Se([1,0,4,41,5]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$4v=e.Severity=void 0,e.$5v=b,e.Severity=L.default,e.$4v=(0,O.$wi)("notificationService");var R;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var N;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(N||(e.NeverShowAgainScope=N={}));function b(P){if(P){const p=P;return typeof p.id=="string"&&typeof p.label=="string"}return!1}var m;(function(P){P[P.OFF=0]="OFF",P[P.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new A,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$6v=E;class A{infinite(){}done(){}total(p){}worked(p){}}e.$7v=A}),define(ke[269],Se([1,0,52]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.context<"u"){const R=O.context.configuration();if(R)L=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,d.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:R.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(ke[108],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,d.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"});var We=this&&this.__param||function(le,e){return function(d,L){e(d,L,le)}};define(ke[109],Se([1,0,7,22,3,5]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.ProgressLocation=e.$8v=void 0,e.$8v=(0,R.$wi)("progressService");var N;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(N||(e.ProgressLocation=N={})),e.$9v=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$0v=b;class m{get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const y=this.d;this.d=()=>{y?.(),p()}}):Promise.resolve()}}e.$$v=m;let E=class extends O.$Vc{constructor(p,y){super(),this.a=new d.$Th,y.withProgress(p,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,O.$Tc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$_v=E,e.$_v=E=Ke([We(1,e.$8v)],E);class A extends O.$Vc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new O.$Uc)}start(p){this.stop();const y=++this.a,w=new L.$pe;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,O.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,O.$Tc)(()=>w.cancel())),this.b.add((0,O.$Tc)(()=>this.c?this.c.done():void 0)),{id:y,token:w.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$aw=A,e.$bw=(0,R.$wi)("editorProgressService")}),define(ke[36],Se([1,0,62,18]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class O{constructor(){this.a=new Map}add(N,b){d.ok(L.$9f(N)),d.ok(L.$$f(b)),d.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,b)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$co=new O}),define(ke[110],Se([1,0,4,36]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function O(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this.b=new d.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,E){this.a[O(m)]=E,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const N=new R;L.$co.add(e.$do.JSONContribution,N)}),define(ke[66],Se([1,0,19,4,18,208,55,110,36]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=h,e.$to=f,e.$uo=a,e.$vo=i,e.$wo=u;var E;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$ho={Configuration:"base.contributions.configuration"};var A;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const P=m.$co.as(b.$do.JSONContribution);class p{constructor(){this.h=new Set,this.i=new L.$ee,this.onDidSchemaChange=this.i.event,this.j=new L.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const r=new Set;this.n(t,l,r),P.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const l=new Set;this.o(t,l),P.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const r=new Set;this.o(l,r),this.n(t,!1,r),P.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const r=[];for(const{overrides:c,source:s}of t)for(const v in c)if(l.add(v),e.$ro.test(v)){const g=this.a.get(v),D=g?.valuesSources??new Map;if(s)for(const C of Object.keys(c[v]))D.set(C,s);const $={...g?.value||{},...c[v]};this.a.set(v,{source:s,value:$,valuesSources:D});const k=(0,N.$aj)(v),S={type:"object",default:$,description:R.localize(1,null,k),$ref:e.$oo,defaultDefaultValue:$,source:O.$9f(s)?void 0:s,defaultValueSource:s};r.push(...h(v)),this.d[v]=S,this.b.properties[v]=S}else{this.a.set(v,{value:c[v],source:s});const g=this.d[v];g&&(this.w(v,g),this.r(v,g))}this.m(r)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:r,source:c}of t)for(const s in r){const v=this.a.get(s),g=O.$9f(c)?c:c?.id,D=O.$9f(v?.source)?v?.source:v?.source?.id;if(g===D)if(l.add(s),this.a.delete(s),e.$ro.test(s))delete this.d[s],delete this.b.properties[s];else{const $=this.d[s];$&&(this.w(s,$),this.r(s,$))}}this.u()}deltaConfiguration(t){let l=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,r){t.forEach(c=>{this.p(c,l,c.extensionInfo,c.restrictedProperties,void 0,r),this.c.push(c),this.q(c)})}o(t,l){const r=c=>{if(c.properties)for(const s in c.properties){l.add(s);const v=this.d[s];v?.policy?.name&&this.e.delete(v.policy.name),delete this.d[s],this.s(s,c.properties[s])}c.allOf?.forEach(s=>r(s))};for(const c of t){r(c);const s=this.c.indexOf(c);s!==-1&&this.c.splice(s,1)}}p(t,l=!0,r,c,s=3,v){s=O.$fg(t.scope)?s:t.scope;const g=t.properties;if(g)for(const $ in g){const k=g[$];if(l&&i($,k)){delete g[$];continue}if(k.source=r,k.defaultDefaultValue=g[$].default,this.w($,k),e.$ro.test($)?k.scope=void 0:(k.scope=O.$fg(k.scope)?s:k.scope,k.restricted=O.$fg(k.restricted)?!!c?.includes($):k.restricted),g[$].hasOwnProperty("included")&&!g[$].included){this.f[$]=g[$],delete g[$];continue}else this.d[$]=g[$],g[$].policy?.name&&this.e.set(g[$].policy.name,$);!g[$].deprecationMessage&&g[$].markdownDeprecationMessage&&(g[$].deprecationMessage=g[$].markdownDeprecationMessage),v.add($)}const D=t.allOf;if(D)for(const $ of D)this.p($,l,r,c,s,v)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=r=>{const c=r.properties;if(c)for(const v in c)this.r(v,c[v]);r.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$io.properties[t]=l,l.scope){case 1:e.$jo.properties[t]=l;break;case 2:e.$ko.properties[t]=l;break;case 6:e.$lo.properties[t]=l;break;case 3:e.$mo.properties[t]=l;break;case 4:e.$no.properties[t]=l;break;case 5:e.$no.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$io.properties[t],l.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$oo};this.w(l,r),e.$io.properties[l]=r,e.$jo.properties[l]=r,e.$ko.properties[l]=r,e.$lo.properties[l]=r,e.$mo.properties[l]=r,e.$no.properties[l]=r}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,l){const r=this.a.get(t);let c=r?.value,s=r?.source;O.$dg(c)&&(c=l.defaultDefaultValue,s=void 0),O.$dg(c)&&(c=a(l.type)),l.default=c,l.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",w=new RegExp(y,"g");e.$qo=`^(${y})+$`,e.$ro=new RegExp(e.$qo);function h(o){const t=[];if(e.$ro.test(o)){let l=w.exec(o);for(;l?.length;){const r=l[1].trim();r&&t.push(r),l=w.exec(o)}}return(0,d.$Mb)(t)}function f(o){return o.reduce((t,l)=>`${t}[${l}]`,"")}function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new p;m.$co.add(e.$ho.Configuration,n);function i(o,t){return o.trim()?e.$ro.test(o)?R.localize(7,null,o):n.getConfigurationProperties()[o]!==void 0?R.localize(8,null,o):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,o,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function u(){const o=[],t=n.getConfigurationProperties();for(const l of Object.keys(t))o.push([l,t[l].scope]);return o.push(["launch",4]),o.push(["task",4]),o}}),define(ke[270],Se([1,0,19,4,166,3,27,24,18,2,55,66,36]),function(le,e,d,L,O,R,N,b,m,E,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=i;function y(l){return Object.isFrozen(l)?l:b.$4n(l)}class w{static createEmptyModel(r){return new w({},[],[],void 0,r)}constructor(r,c,s,v,g){this.b=r,this.c=c,this.d=s,this.raw=v,this.f=g,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(c=>{if(c instanceof w)return c;const s=new h("",this.f);return s.parseRaw(c),s.configurationModel});this.g=r.reduce((c,s)=>s===c?s:c.merge(s),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,A.$$i)(this.contents,r):this.contents}inspect(r,c){const s=this;return{get value(){return y(s.rawConfiguration.getValue(r))},get override(){return c?y(s.rawConfiguration.getOverrideValue(r,c)):void 0},get merged(){return y(c?s.rawConfiguration.override(c).getValue(r):s.rawConfiguration.getValue(r))},get overrides(){const v=[];for(const{contents:g,identifiers:D,keys:$}of s.rawConfiguration.overrides){const k=new w(g,$,[],void 0,s.f).getValue(r);k!==void 0&&v.push({identifiers:D,value:k})}return v.length?y(v):void 0}}}getOverrideValue(r,c){const s=this.j(c);return s?r?(0,A.$$i)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const c=[];for(const s of this.overrides)s.identifiers.includes(r)&&c.push(...s.keys);return d.$Mb(c)}getAllOverrideIdentifiers(){const r=[];for(const c of this.overrides)r.push(...c.identifiers);return d.$Mb(r)}override(r){let c=this.a.get(r);return c||(c=this.h(r),this.a.set(r,c)),c}merge(...r){const c=b.$3n(this.contents),s=b.$3n(this.overrides),v=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const D of r)if(g.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(c,D.contents);for(const $ of D.overrides){const[k]=s.filter(S=>d.$ub(S.identifiers,$.identifiers));k?(this.i(k.contents,$.contents),k.keys.push(...$.keys),k.keys=d.$Mb(k.keys)):s.push(b.$3n($))}for(const $ of D.keys)v.indexOf($)===-1&&v.push($)}return new w(c,v,s,g.every(D=>D instanceof w)?void 0:g,this.f)}h(r){const c=this.j(r);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const s={};for(const v of d.$Mb([...Object.keys(this.contents),...Object.keys(c)])){let g=this.contents[v];const D=c[v];D&&(typeof g=="object"&&typeof D=="object"?(g=b.$3n(g),this.i(g,D)):g=D),s[v]=g}return new w(s,this.keys,this.overrides,void 0,this.f)}i(r,c){for(const s of Object.keys(c)){if(s in r&&m.$$f(r[s])&&m.$$f(c[s])){this.i(r[s],c[s]);continue}r[s]=b.$3n(c[s])}}j(r){let c=null,s=null;const v=g=>{g&&(s?this.i(s,g):s=b.$3n(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===r?c=g.contents:g.identifiers.includes(r)&&v(g.contents);return v(c),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,c){this.k(r,c,!0)}setValue(r,c){this.k(r,c,!1)}removeValue(r){const c=this.keys.indexOf(r);c!==-1&&(this.keys.splice(c,1),(0,A.$0i)(this.contents,r),P.$ro.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>d.$ub(s.identifiers,(0,P.$so)(r))),1))}k(r,c,s){(0,A.$9i)(this.contents,r,c,v=>this.f.error(v)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),P.$ro.test(r)&&this.overrides.push({identifiers:(0,P.$so)(r),keys:Object.keys(this.contents[r]),contents:(0,A.$8i)(this.contents[r],v=>this.f.error(v))})}}e.$xo=w;class h{constructor(r,c){this.f=r,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||w.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,c){if(!m.$fg(r)){const s=this.h(r);this.parseRaw(s,c)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,c){this.a=r;const{contents:s,keys:v,overrides:g,restricted:D,hasExcludedProperties:$}=this.i(r,c);this.b=new w(s,v,g,$?[r]:void 0,this.g),this.c=D||[]}h(r){let c={},s=null,v=[];const g=[],D=[];function $(S){Array.isArray(v)?v.push(S):s!==null&&(v[s]=S)}const k={onObjectBegin:()=>{const S={};$(S),g.push(v),v=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{v=g.pop()},onArrayBegin:()=>{const S=[];$(S),g.push(v),v=S,s=null},onArrayEnd:()=>{v=g.pop()},onLiteralValue:$,onError:(S,C,I)=>{D.push({error:S,offset:C,length:I})}};if(r)try{O.$Qn(r,k),c=v[0]||{}}catch(S){this.g.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return c}i(r,c){const s=p.$co.as(P.$ho.Configuration).getConfigurationProperties(),v=this.j(r,s,!0,c);r=v.raw;const g=(0,A.$8i)(r,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`)),D=Object.keys(r),$=this.l(r,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:g,keys:D,overrides:$,restricted:v.restricted,hasExcludedProperties:v.hasExcludedProperties}}j(r,c,s,v){let g=!1;if(!v?.scopes&&!v?.skipRestricted&&!v?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:g};const D={},$=[];for(const k in r)if(P.$ro.test(k)&&s){const S=this.j(r[k],c,!1,v);D[k]=S.raw,g=g||S.hasExcludedProperties,$.push(...S.restricted)}else{const S=c[k],C=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&$.push(k),!v.exclude?.includes(k)&&(v.include?.includes(k)||(C===void 0||v.scopes===void 0||v.scopes.includes(C))&&!(v.skipRestricted&&S?.restricted))?D[k]=r[k]:g=!0}return{raw:D,restricted:$,hasExcludedProperties:g}}l(r,c){const s=[];for(const v of Object.keys(r))if(P.$ro.test(v)){const g={};for(const D in r[v])g[D]=r[v][D];s.push({identifiers:(0,P.$so)(v),keys:Object.keys(g),contents:(0,A.$8i)(g,c)})}return s}}e.$yo=h;class f extends R.$Vc{constructor(r,c,s,v,g){super(),this.c=r,this.f=c,this.g=v,this.h=g,this.b=this.B(new L.$ee),this.onDidChange=this.b.event,this.a=new h(this.c.toString(),g),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&s.isEqual(D.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return w.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=f;class a{constructor(r,c,s,v,g,D,$,k,S,C,I,F,j){this.a=r,this.b=c,this.c=s,this.overrideIdentifiers=v,this.d=g,this.f=D,this.g=$,this.h=k,this.i=S,this.j=C,this.k=I,this.l=F,this.m=j}get value(){return y(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(r,c,s,v,g,D,$,k,S,C){this.j=r,this.l=c,this.m=s,this.n=v,this.p=g,this.q=D,this.r=$,this.s=k,this.t=S,this.u=C,this.h=null,this.i=new N.$Bc,this.v=null}getValue(r,c,s){return this.w(r,c,s).getValue(r)}updateValue(r,c,s={}){let v;s.resource?(v=this.t.get(s.resource),v||(v=w.createEmptyModel(this.u),this.t.set(s.resource,v))):v=this.s,c===void 0?v.removeValue(r):v.setValue(r,c),s.resource||(this.h=null)}inspect(r,c,s){const v=this.w(r,c,s),g=this.A(c.resource,s),D=c.resource?this.t.get(c.resource)||this.s:this.s,$=new Set;for(const k of v.overrides)for(const S of k.identifiers)v.getOverrideValue(r,S)!==void 0&&$.add(S);return new a(r,c,v.getValue(r),$.size?[...$]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,g||void 0,D)}keys(r){const c=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,c){this.r.set(r,c),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,c){const s=[];if(!c){const{added:v,updated:g,removed:D}=o(this.j,r);c=[...v,...g,...D]}for(const v of c)for(const g of(0,P.$so)(v)){const D=this.j.getKeysForOverrideIdentifier(g),$=r.getKeysForOverrideIdentifier(g),k=[...$.filter(S=>D.indexOf(S)===-1),...D.filter(S=>$.indexOf(S)===-1),...D.filter(S=>!b.$7n(this.j.override(g).getValue(S),r.override(g).getValue(S)))];s.push([g,k])}return this.updateDefaultConfiguration(r),{keys:c,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:c,updated:s,removed:v}=o(this.l,r),g=[...c,...s,...v];return g.length&&this.updatePolicyConfiguration(r),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:c,updated:s,removed:v,overrides:g}=o(this.applicationConfiguration,r),D=[...c,...s,...v];return D.length&&this.updateApplicationConfiguration(r),{keys:D,overrides:g}}compareAndUpdateLocalUserConfiguration(r){const{added:c,updated:s,removed:v,overrides:g}=o(this.localUserConfiguration,r),D=[...c,...s,...v];return D.length&&this.updateLocalUserConfiguration(r),{keys:D,overrides:g}}compareAndUpdateRemoteUserConfiguration(r){const{added:c,updated:s,removed:v,overrides:g}=o(this.remoteUserConfiguration,r),D=[...c,...s,...v];return D.length&&this.updateRemoteUserConfiguration(r),{keys:D,overrides:g}}compareAndUpdateWorkspaceConfiguration(r){const{added:c,updated:s,removed:v,overrides:g}=o(this.workspaceConfiguration,r),D=[...c,...s,...v];return D.length&&this.updateWorkspaceConfiguration(r),{keys:D,overrides:g}}compareAndUpdateFolderConfiguration(r,c){const s=this.folderConfigurations.get(r),{added:v,updated:g,removed:D,overrides:$}=o(s,c),k=[...v,...g,...D];return(k.length||!s)&&this.updateFolderConfiguration(r,c),{keys:k,overrides:$}}compareAndDeleteFolderConfiguration(r){const c=this.folderConfigurations.get(r);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:v,removed:g,overrides:D}=o(c,void 0);return{keys:[...s,...v,...g],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,c,s){let v=this.x(c,s);return c.overrideIdentifier&&(v=v.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(v=v.merge(this.l)),v}x({resource:r},c){let s=this.y();if(c&&r){const v=c.getFolder(r);v&&(s=this.z(v.uri)||s);const g=this.t.get(r);g&&(s=s.merge(g))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let c=this.i.get(r);if(!c){const s=this.y(),v=this.r.get(r);v?(c=s.merge(v),this.i.set(r,c)):c=s}return c}A(r,c){if(c&&r){const s=c.getFolder(r);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,c)=>{const{contents:s,overrides:v,keys:g}=this.r.get(c);return r.push([c,{contents:s,overrides:v,keys:g}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(c=>r.add(c)),this.userConfiguration.keys.forEach(c=>r.add(c)),this.q.keys.forEach(c=>r.add(c)),this.r.forEach(c=>c.keys.forEach(s=>r.add(s))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>r.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}D(r){const c=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.q.getKeysForOverrideIdentifier(r).forEach(s=>c.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(v=>c.add(v))),[...c.values()]}static parse(r,c){const s=this.E(r.defaults,c),v=this.E(r.policy,c),g=this.E(r.application,c),D=this.E(r.user,c),$=this.E(r.workspace,c),k=r.folders.reduce((S,C)=>(S.set(E.URI.revive(C[0]),this.E(C[1],c)),S),new N.$Bc);return new n(s,v,g,D,w.createEmptyModel(c),$,k,w.createEmptyModel(c),new N.$Bc,c)}static E(r,c){return new w(r.contents,r.keys,r.overrides,void 0,c)}}e.$Ao=n;function i(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,c=new Map;for(const v of l)v.keys.forEach(g=>r.add(g)),v.overrides.forEach(([g,D])=>{const $=(0,N.$yc)(c,g,new Set);D.forEach(k=>$.add(k))});const s=[];return c.forEach((v,g)=>s.push([g,[...v.values()]])),{keys:[...r.values()],overrides:s}}class u{constructor(r,c,s,v,g){this.change=r,this.f=c,this.g=s,this.h=v,this.i=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of r.keys)this.affectedKeys.add(D);for(const[,D]of r.overrides)for(const $ of D)this.affectedKeys.add($);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,c){const s=this.a+r,v=this.d.indexOf(s);if(v<0)return!1;const g=v+s.length;if(g>=this.d.length)return!1;const D=this.d.charCodeAt(g);if(D!==this.b&&D!==this.c)return!1;if(c){const $=this.previousConfiguration?this.previousConfiguration.getValue(r,c,this.f?.workspace):void 0,k=this.g.getValue(r,c,this.h);return!b.$7n($,k)}return!0}}e.$Co=u;function o(l,r){const{added:c,removed:s,updated:v}=t(r?.rawConfiguration,l?.rawConfiguration),g=[],D=l?.getAllOverrideIdentifiers()||[],$=r?.getAllOverrideIdentifiers()||[];if(r){const k=$.filter(S=>!D.includes(S));for(const S of k)g.push([S,r.getKeysForOverrideIdentifier(S)])}if(l){const k=D.filter(S=>!$.includes(S));for(const S of k)g.push([S,l.getKeysForOverrideIdentifier(S)])}if(r&&l){for(const k of D)if($.includes(k)){const S=t({contents:l.getOverrideValue(void 0,k)||{},keys:l.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});g.push([k,[...S.added,...S.removed,...S.updated]])}}return{added:c,removed:s,updated:v,overrides:g}}function t(l,r){const c=l?r?l.keys.filter(g=>r.keys.indexOf(g)===-1):[...l.keys]:[],s=r?l?r.keys.filter(g=>l.keys.indexOf(g)===-1):[...r.keys]:[],v=[];if(l&&r){for(const g of r.keys)if(l.keys.indexOf(g)!==-1){const D=(0,A.$$i)(r.contents,g),$=(0,A.$$i)(l.contents,g);b.$7n(D,$)||v.push(g)}}return{added:c,removed:s,updated:v}}}),define(ke[271],Se([1,0,21,4,3,83]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ovb=e.$mvb=e.$lvb=void 0,e.$nvb=b;const N=(E,A,P)=>{const p=new Uint8Array(16);for(let h=0;h<16;h++)p[h]=Math.round(Math.random()*256);const y=(0,d.$1e)(d.$Ge.wrap(p));return[`GET ws://localhost${E}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$lvb=N,e.$mvb=d.$Ge.fromString(`\r
\r
`);async function b(E,A,P,p,y){E.write(d.$Ge.fromString((0,e.$lvb)(A,P,p)));const w=new O.$Uc;try{return await new Promise((h,f)=>{let a;w.add(E.onData(n=>{a?a=d.$Ge.concat([a,n],a.byteLength+n.byteLength):a=n;const i=a.indexOf(e.$mvb);if(i===-1)return;h(E),E.pauseData();const u=a.slice(i+e.$mvb.byteLength);u.byteLength&&y.onData.fire(u)})),w.add(E.onClose(n=>f(n??new Error("socket closed")))),w.add(E.onEnd(()=>f(new Error("socket ended"))))})}catch(h){throw E.dispose(),h}finally{w.dispose()}}class m extends O.$Vc{constructor(A,P){super(),this.g=A,this.a=this.B(new L.$he),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new L.$ee),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(p=>this.a.fire(p))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,P){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$ovb=m}),define(ke[67],Se([1,0,13,5]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=E,e.$Hl=(0,L.$wi)("remoteAuthorityResolverService");var O;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(O||(e.RemoteConnectionType=O={}));class R{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=R;class N{constructor(P,p){this.host=P,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=N;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class m extends d.$bb{static isNotAvailable(P){return P instanceof m&&P._code===b.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof m&&P._code===b.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof m&&P._code===b.NoResolverFound}static isInvalidAuthority(P){return P instanceof m&&P._code===b.InvalidAuthority}static isHandled(P){return P instanceof m&&P.isHandled}constructor(P,p=b.Unknown,y){super(P),this._message=P,this._code=p,this._detail=y,this.isHandled=p===b.NotAvailable&&y===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Kl=m;function E(A){const P=A.indexOf("+");return P===-1?A:A.substring(0,P)}}),define(ke[272],Se([1,0,7,21,22,13,4,3,15,59,40,30,83,67]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ql=D,e.$Rl=$,e.$Sl=S;const w=30*1e3;var h;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(h||(e.ConnectionType=h={}));function f(_){switch(_){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(_){const B=new O.$pe;return setTimeout(()=>B.cancel(),_),B.token}function n(_,B){if(_.isCancellationRequested||B.isCancellationRequested)return O.CancellationToken.Cancelled;const ee=new O.$pe;return _.onCancellationRequested(()=>ee.cancel()),B.onCancellationRequested(()=>ee.cancel()),ee.token}class i{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new b.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,d.$ph)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function u(_,B){const ee=new i(B);return ee.registerDisposable(_.onControlMessage(pe=>{const Ce=JSON.parse(pe.toString()),oe=K(Ce);oe?ee.reject(oe):ee.resolve(Ce)})),ee.promise}function o(_,B,ee,pe,Ce,oe,se,re){const G=new i(re),ne=A.$ae.create(!1);return _.info(`Creating a socket (${se})...`),E.mark(`code/willCreateSocket/${oe}`),B.connect(ee,pe,Ce,se).then(me=>{G.didTimeout?(E.mark(`code/didCreateSocketError/${oe}`),_.info(`Creating a socket (${se}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),me?.dispose()):(E.mark(`code/didCreateSocketOK/${oe}`),_.info(`Creating a socket (${se}) was successful after ${ne.elapsed()} ms.`),G.resolve(me))},me=>{E.mark(`code/didCreateSocketError/${oe}`),_.info(`Creating a socket (${se}) returned an error after ${ne.elapsed()} ms.`),_.error(me),G.reject(me)}),G.promise}function t(_,B){const ee=new i(B);return _.then(pe=>{ee.didTimeout||ee.resolve(pe)},pe=>{ee.didTimeout||ee.reject(pe)}),ee.promise}async function l(_,B,ee,pe){const Ce=ue(_,B);_.logService.trace(`${Ce} 1/6. invoking socketFactory.connect().`);let oe;try{oe=await o(_.logService,_.remoteSocketFactoryService,_.connectTo,m.$Jg.getServerRootPath(),`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,f(B),`renderer-${f(B)}-${_.reconnectionToken}`,pe)}catch(me){throw _.logService.error(`${Ce} socketFactory.connect() failed or timed out. Error:`),_.logService.error(me),me}_.logService.trace(`${Ce} 2/6. socketFactory.connect() was successful.`);let se,re;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(oe,null),se=_.reconnectionProtocol,re=!1):(se=new p.$ki({socket:oe}),re=!0),_.logService.trace(`${Ce} 3/6. sending AuthRequest control message.`);const G=await t(_.signService.createNewMessage((0,P.$Sg)()),pe),ne={type:"auth",auth:_.connectionToken||"00000000000000000000",data:G.data};se.sendControl(L.$Ge.fromString(JSON.stringify(ne)));try{const me=await u(se,n(pe,a(1e4)));if(me.type!=="sign"||typeof me.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(_.logService.trace(`${Ce} 4/6. received SignRequest control message.`),!await t(_.signService.validate(G,me.signedData),pe)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Re=await t(_.signService.sign(me.data),pe),fe={type:"connectionType",commit:_.commit,signedData:Re,desiredConnectionType:B};return ee&&(fe.args=ee),_.logService.trace(`${Ce} 5/6. sending ConnectionTypeRequest control message.`),se.sendControl(L.$Ge.fromString(JSON.stringify(fe))),{protocol:se,ownsProtocol:re}}catch(me){throw me&&me.code==="ETIMEDOUT"&&(_.logService.error(`${Ce} the handshake timed out. Error:`),_.logService.error(me)),me&&me.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${Ce} received error control message when negotiating connection. Error:`),_.logService.error(me)),re&&q(se),me}}async function r(_,B,ee,pe){const Ce=Date.now(),oe=ue(_,B),{protocol:se,ownsProtocol:re}=await l(_,B,ee,pe),G=new i(pe);return G.registerDisposable(se.onControlMessage(ne=>{const me=JSON.parse(ne.toString()),be=K(me);be?(_.logService.error(`${oe} received error control message when negotiating connection. Error:`),_.logService.error(be),re&&q(se),G.reject(be)):(_.reconnectionProtocol?.endAcceptReconnection(),_.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${ve(Ce)}!`),G.resolve({protocol:se,firstMessage:me}))})),G.promise}async function c(_,B){const{protocol:ee}=await r(_,1,void 0,B);return{protocol:ee}}async function s(_,B,ee){const{protocol:pe,firstMessage:Ce}=await r(_,2,B,ee),oe=Ce&&Ce.debugPort;return{protocol:pe,debugPort:oe}}async function v(_,B,ee){const pe=Date.now(),Ce=ue(_,3),{protocol:oe}=await l(_,3,B,ee);return _.logService.trace(`${Ce} 6/6. handshake finished, connection is up and running after ${ve(pe)}!`),oe}async function g(_,B,ee){const{connectTo:pe,connectionToken:Ce}=await _.addressProvider.getAddress();return{commit:_.commit,quality:_.quality,connectTo:pe,connectionToken:Ce,reconnectionToken:B,reconnectionProtocol:ee,remoteSocketFactoryService:_.remoteSocketFactoryService,signService:_.signService,logService:_.logService}}async function D(_,B,ee){return k(_,async pe=>{const{protocol:Ce}=await c(pe,O.CancellationToken.None);return new Z(_,B,ee,pe.reconnectionToken,Ce)})}async function $(_,B){return k(_,async ee=>{const{protocol:pe,debugPort:Ce}=await s(ee,B,O.CancellationToken.None);return new te(_,B,ee.reconnectionToken,pe,Ce)})}async function k(_,B){for(let pe=1;;pe++)try{const Ce=(0,P.$Sg)(),oe=await g(_,Ce,null);return await B(oe)}catch(Ce){if(pe<5)_.logService.error(`[remote-connection][attempt ${pe}] An error occurred in initial connection! Will retry... Error:`),_.logService.error(Ce);else throw _.logService.error(`[remote-connection][attempt ${pe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),_.logService.error(Ce),U.triggerPermanentFailure(0,0,y.$Kl.isHandled(Ce)),Ce}}async function S(_,B,ee){const pe=await g(_,(0,P.$Sg)(),null);return await v(pe,{host:B,port:ee},O.CancellationToken.None)}function C(_){return(0,d.$jh)(B=>new Promise((ee,pe)=>{const Ce=setTimeout(ee,_*1e3);B.onCancellationRequested(()=>{clearTimeout(Ce),ee()})}))}var I;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class F{constructor(B,ee){this.reconnectionToken=B,this.millisSinceLastIncomingData=ee,this.type=0}}e.$Tl=F;class j{constructor(B,ee,pe,Ce){this.reconnectionToken=B,this.millisSinceLastIncomingData=ee,this.durationSeconds=pe,this.c=Ce,this.type=1}skipWait(){this.c.cancel()}}e.$Ul=j;class z{constructor(B,ee,pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=ee,this.attempt=pe,this.type=2}}e.$Vl=z;class M{constructor(B,ee,pe){this.reconnectionToken=B,this.millisSinceLastIncomingData=ee,this.attempt=pe,this.type=4}}e.$Wl=M;class T{constructor(B,ee,pe,Ce){this.reconnectionToken=B,this.millisSinceLastIncomingData=ee,this.attempt=pe,this.handled=Ce,this.type=3}}e.$Xl=T;class U extends b.$Vc{static triggerPermanentFailure(B,ee,pe){this._permanentFailure=!0,this.f=B,this.g=ee,this.h=pe,this.j.forEach(Ce=>Ce.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(B,ee,pe,Ce,oe){super(),this.t=B,this.u=ee,this.reconnectionToken=pe,this.protocol=Ce,this.w=oe,this.m=this.B(new N.$ee),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(Ce.onSocketClose(se=>{const re=$e(this.t,this.reconnectionToken,!0);se?se.type===0?(this.u.logService.info(`${re} received socket close event (hadError: ${se.hadError}).`),se.error&&this.u.logService.error(se.error)):(this.u.logService.info(`${re} received socket close event (wasClean: ${se.wasClean}, code: ${se.code}, reason: ${se.reason}).`),se.event&&this.u.logService.error(se.event)):this.u.logService.info(`${re} received socket close event.`),this.y()})),this.B(Ce.onSocketTimeout(se=>{const re=$e(this.t,this.reconnectionToken,!0);this.u.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${se.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${se.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${se.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,b.$Tc)(()=>{const se=U.j.indexOf(this);se>=0&&U.j.splice(se,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=$e(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ee=[0,5,5,10,10,10,10,10,30];let pe=-1;do{pe++;const Ce=pe<ee.length?ee[pe]:ee[ee.length-1];try{if(Ce>0){const se=C(Ce);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ce,se)),this.u.logService.info(`${B} waiting for ${Ce} seconds before reconnecting...`);try{await se}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1)),this.u.logService.info(`${B} resolving connection...`);const oe=await g(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${oe.connectTo}...`),await this.G(oe,a(w)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1));break}catch(oe){if(oe.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(pe>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(y.$Kl.isTemporarilyNotAvailable(oe)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if((oe.code==="ETIMEDOUT"||oe.code==="ENETUNREACH"||oe.code==="ECONNREFUSED"||oe.code==="ECONNRESET")&&oe.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if((0,R.$4)(oe)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if(oe instanceof y.$Kl){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,y.$Kl.isHandled(oe));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}}while(!this.n&&!this.s)}C(B,ee,pe){this.w?U.triggerPermanentFailure(B,ee,pe):this.D(B,ee,pe)}D(B,ee,pe){this.m.fire(new T(this.reconnectionToken,B,ee,pe)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Yl=U;class Z extends U{constructor(B,ee,pe,Ce,oe){super(1,B,Ce,oe,!0),this.client=this.B(new p.$ii(oe,{remoteAuthority:ee,clientId:pe},B.ipcLogger))}async G(B,ee){await c(B,ee)}}e.$Zl=Z;class te extends U{constructor(B,ee,pe,Ce,oe){super(2,B,pe,Ce,!1),this.H=ee,this.debugPort=oe}async G(B,ee){await s(B,this.H,ee)}}e.$1l=te;function q(_){try{_.acceptDisconnect();const B=_.getSocket();_.dispose(),B.dispose()}catch(B){(0,R.$1)(B)}}function K(_){if(_&&_.type==="error"){const B=new Error(`Connection error: ${_.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function Y(_,B){for(;_.length<B;)_+=" ";return _}function ie(_,B){return`[remote-connection][${Y(f(_),13)}][${B.substr(0,5)}\u2026]`}function $e(_,B,ee){return`${ie(_,B)}[${ee?"reconnect":"initial"}]`}function ue(_,B){return`${$e(B,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.connectTo}]`}function ve(_){return`${Date.now()-_} ms`}}),define(ke[86],Se([1,0,15]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=L,e.$Im=O,e.$Jm=R,e.$Km=N;function L(m){return m.scheme===d.Schemas.vscodeRemote?m.authority:void 0}function O(m){if(!m)return;const E=m.indexOf("+");return E<0?m:m.substr(0,E)}function R(m){const{host:E,port:A}=b(m);if(typeof A>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:A}}function N(m,E){let{host:A,port:P}=b(m);return typeof P>"u"&&(P=E),{host:A,port:P}}function b(m){const E=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const A=m.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const P=m.match(/(.*):(\d+)$/);return P?{host:P[1],port:parseInt(P[2],10)}:{host:m,port:void 0}}}),define(ke[25],Se([1,0,14,5,86]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=R,e.$Um=P,e.$Vm=p,e.$Wm=y,e.$Xm=w,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var N;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(N||(e.ExtensionType=N={}));var b;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class m{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,a){if(typeof f>"u"||f===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof f=="string"||typeof a=="string"){const n=typeof f=="string"?f:f.value,i=typeof a=="string"?a:a.value;return d.$yf(n,i)}return f._lower===a._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$Rm=m;class E{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const a of f)this.add(a)}add(f){this.c.add(m.toKey(f))}delete(f){return this.c.delete(m.toKey(f))}has(f){return this.c.has(m.toKey(f))}}e.$Sm=E;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(m.toKey(f))}get(f){return this.c.get(m.toKey(f))}has(f){return this.c.has(m.toKey(f))}set(f,a){this.c.set(m.toKey(f),a)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=A;function P(h){return p(h)}function p(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function y(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function w(h,f){if(f){const a=`onResolveRemoteAuthority:${(0,O.$Im)(f)}`;return!!h.activationEvents?.includes(a)}return!1}e.$Ym=(0,L.$wi)("IBuiltinExtensionsScannerService")}),define(ke[140],Se([1,0,13,25]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nG=e.$mG=void 0;class O{constructor(){this.a=new Map,this.b=new WeakMap}register(N,b){this.a.set(N,b)}readActivationEvents(N){return this.b.has(N)||this.b.set(N,this.c(N)),this.b.get(N)}createActivationEventsMap(N){const b=Object.create(null);for(const m of N){const E=this.readActivationEvents(m);E.length>0&&(b[L.$Rm.toKey(m.identifier)]=E)}return b}c(N){if(typeof N.main>"u"&&typeof N.browser>"u")return[];const b=Array.isArray(N.activationEvents)?N.activationEvents.slice(0):[];for(let m=0;m<b.length;m++)b[m]==="onUri"&&(b[m]=`onUri:${L.$Rm.toKey(N.identifier)}`);if(!N.contributes)return b;for(const m in N.contributes){const E=this.a.get(m);if(!E)continue;const A=N.contributes[m],P=Array.isArray(A)?A:[A];try{E(P,b)}catch(p){(0,d.$1)(p)}}return b}}e.$mG=O,e.$nG=new O}),define(ke[273],Se([1,0,3,5]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=void 0,e.$Ml=(0,L.$wi)("remoteSocketFactoryService");class O{constructor(){this.a={}}register(N,b){return this.a[N]??=[],this.a[N].push(b),(0,d.$Tc)(()=>{const m=this.a[N]?.indexOf(b);typeof m=="number"&&m>=0&&this.a[N]?.splice(m,1)})}b(N){return(this.a[N.type]||[]).find(m=>m.supports(N))}connect(N,b,m,E){const A=this.b(N);if(!A)throw new Error(`No socket factory found for ${N}`);return A.connect(N,b,m,E)}}e.$Nl=O}),define(ke[274],Se([1,0,21,13,3,220,66,5,11,36]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=p,e.$Qp=y,e.$Rp=w,e.$Sp=h,e.$Tp=f,e.$Up=a,e.$Np=(0,b.$wi)("requestService");class A{constructor(o){this.b=o}toJSON(){if(!this.a){const o=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?o[t]="*****":o[t]=this.b[t];this.a=o}return this.a}}class P extends O.$Vc{constructor(o){super(),this.b=0,this.a=o.createLogger("network",{name:(0,R.localize)(0,null),when:m.$ik.isEqualTo((0,m.$fk)(m.LogLevel.Trace)).serialize()})}async c(o,t,l){const r=`${o} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new A(t.headers??{}));try{const c=await l();return this.a.trace(`${r} - end`,t.type,c.res.statusCode,c.res.headers),c}catch(c){throw this.a.error(`${r} - error`,t.type,(0,L.$0)(c)),c}}}e.$Op=P;function p(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}function y(u){return u.res.statusCode===204}async function w(u){return y(u)?null:(await(0,d.$Se)(u.stream)).toString()}async function h(u){if(!p(u))throw new Error("Server returned "+u.res.statusCode);return w(u)}async function f(u){if(!p(u))throw new Error("Server returned "+u.res.statusCode);if(y(u))return null;const t=(await(0,d.$Se)(u.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}function a(u){i(u)}let n;function i(u){const o=E.$co.as(N.$ho.Configuration),t=n;n={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},o.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(ke[275],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=void 0;class d{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(O){try{const R=await this.c();if(R){const N=String(d.a++);return this.b.set(N,R),{id:N,data:R.createNewMessage(O)}}}catch{}return{id:"",data:O}}async validate(O,R){if(!O.id)return!0;const N=this.b.get(O.id);if(!N)return!1;this.b.delete(O.id);try{return N.validate(R)==="ok"}catch{return!1}finally{N.dispose?.()}}async sign(O){try{return await this.d(O)}catch{}return O}}e.$L$b=d}),define(ke[111],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol="signService",e.$Pl=(0,d.$wi)(e.$Ol)}),define(ke[141],Se([1,0,275]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class L extends d.$L$b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(N=>new N.signer().sign(R))}h(){return new Promise((R,N)=>le(["vsda"],R,N))}}e.$Hdc=L}),define(ke[276],Se([1,0,12,52,30]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=N,e.$ep=b;function R(m){if(d.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function N(m,E,A,P,p,y,w,h,f){const a=Object.create(null);a["common.machineId"]=y,a["common.sqmId"]=w,a.sessionID=(0,O.$Sg)()+Date.now(),a.commitHash=P,a.version=p,a["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,d.$h)(d.$u),a["common.nodePlatform"]=L.$ec,a["common.nodeArch"]=A,a["common.product"]=f||"desktop",h&&(a["common.msftInternal"]=h);let n=0;const i=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),d.$l&&(a["common.snap"]="true");const u=R(E);return u&&(a["common.platformDetail"]=u),a}function b(m){const E=L.env.USERDNSDOMAIN;if(!E)return!1;const A=E.toLowerCase();return m.some(P=>A===P)}}),define(ke[277],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,d.$wi)("telemetryService"),e.$3l=(0,d.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var L;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var O;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(O||(e.TelemetryConfiguration=O={}))}),define(ke[87],Se([1,0,24,18,86,276,277]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=A,e.$np=P,e.$op=p,e.$pp=y,e.$qp=h,e.$rp=a,e.$sp=n,e.$tp=o;class b{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$fp=b;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=m,e.$hp=new m;class E{async publicLog(l,r,c){}async publicLogError(l,r,c){}}e.$ip=E,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!t.enableTelemetry)}function P(t,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function p(t){const l=t.getValue(N.$0l),r=t.getValue(N.$$l);if(t.getValue(N.$_l)===!1||r===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function y(t){const l={},r={},c={};f(t,c);for(let s in c){s=s.length>150?s.substr(s.length-149):s;const v=c[s];typeof v=="number"?r[s]=v:typeof v=="boolean"?r[s]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${v.length}`),l[s]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(l[s]=v)}return{properties:l,measurements:r}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const l=(0,O.$Im)(t);return w.has(l)?l:"other"}function f(t,l,r=0,c){if(t)for(const s of Object.getOwnPropertyNames(t)){const v=t[s],g=c?c+s:s;Array.isArray(v)?l[g]=(0,d.$8n)(v):v instanceof Date?l[g]=v.toISOString():(0,L.$$f)(v)?r<2?f(v,l,r+1,g+"."):l[g]=(0,d.$8n)(v):l[g]=v}}function a(t,l){const r=t.msftInternalDomains||[],c=l.getValue("telemetry.internalTesting");return(0,R.$ep)(r)||c}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,l){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const c=[];for(const D of l)for(;;){const $=D.exec(t);if(!$)break;c.push([$.index,D.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(r="";;){const D=v.exec(t);if(!D)break;const $=c.some(([k,S])=>D.index<S&&k<v.lastIndex);!s.test(D[0])&&!$&&(r+=t.substring(g,D.index)+"<REDACTED: user-file-path>",g=v.lastIndex)}return g<t.length&&(r+=t.substr(g)),r}function u(t){if(!t)return t;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of l)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function o(t,l){return(0,d.$5n)(t,r=>{if(r instanceof b||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let c=r.replaceAll("%20"," ");c=i(c,l);for(const s of l)c=c.replace(s,"");return c=u(c),c}})}}),define(ke[278],Se([1,0,14,138,25,12,2,13,52,87]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=A,e.$wp=w,e.$xp=h,e.$yp=f,e.$zp=a,e.$Ap=n,e.$Bp=i,e.$Cp=u,e.$Ep=o,e.$Fp=l;function A(r,c){return r.uuid&&c.uuid?r.uuid===c.uuid:r.id===c.id?!0:(0,d.$tf)(r.id,c.id)===0}const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(c){const s=c.manifest?c.manifest.version:c.version,v=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new p(c.identifier,s,v)}static parse(c){const s=P.exec(c);return s&&s[1]&&s[2]?new p({id:s[1]},s[2],s[4]||void 0):null}constructor(c,s,v="undefined"){this.version=s,this.targetPlatform=v,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof p?A(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$vp=p;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(r){const c=y.exec(r);return c&&c[1]?[f(c[1]),c[2]]:[f(r),void 0]}function h(r,c){return`${r}.${c}`}function f(r){return r.toLowerCase()}function a(r,c){return f(h(r??O.$Nm,c))}function n(r,c){const s=[],v=g=>{for(const D of s)if(D.some($=>A(c($),c(g))))return D;return null};for(const g of r){const D=v(g);D?D.push(g):s.push([g])}return s}function i(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function u(r){return{id:new E.$fp(r.identifier.id),name:new E.$fp(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Dp=new O.$Rm("pprice.better-merge");function o(r,c){const s=[],v=c.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const g=v.shift();if(g&&s.every(D=>!A(D.identifier,{id:g}))){const D=r.filter($=>A($.identifier,{id:g}));D.length===1&&(s.push(D[0]),v.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(r,c){if(!R.$k)return!1;let s;try{s=(await r.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){c.debug("Error while getting the os-release file.",(0,b.$0)(g))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(r,c){const s=await t(r,c),v=(0,L.$2o)(s?"alpine":R.$u,m.$fc);return c.debug("ComputeTargetPlatform:",v),v}}),define(ke[279],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=d,e.$ms=L,e.$ns=O,e.$os=R,e.$ps=N,e.$qs=b;function d(m){return[...m.entries()]}function L(m){return m?[...m.entries()]:[]}function O(m){return new Map(m)}function R(m){return new Map(m??[])}function N(m){return Array.from(m.entries()).map(E=>[E[0],d(E[1].map),L(E[1].descriptionMap)])}function b(m){return new Map(m.map(E=>[E[0],{map:O(E[1]),descriptionMap:R(E[2])}]))}}),define(ke[280],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gvb=void 0;class d{constructor(O){this.b=O,this.a=new Map}dispose(){for(const O of this.a.values())O.dispose()}startBuffering(O,R,N=5){const b=R(m=>{const E=typeof m=="string"?m:m.data;let A=this.a.get(O);if(A){A.data.push(E);return}const P=setTimeout(()=>this.flushBuffer(O),N);A={data:[E],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(O),b.dispose()}},this.a.set(O,A)});return b}stopBuffering(O){this.a.get(O)?.dispose()}flushBuffer(O){const R=this.a.get(O);R&&(this.a.delete(O),this.b(O,R.data.join("")))}}e.$Gvb=d}),define(ke[281],Se([1,0,7,79,99,50,4,18,2,221,110,36]),function(le,e,d,L,O,R,N,b,m,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gx=e.$fx=e.$ex=e.$dx=e.$cx=e.$bx=e.IconFontDefinition=e.IconContribution=e.$$w=void 0,e.$_w=f,e.$ax=a,e.$$w={IconContribution:"base.contributions.icons"};var p;(function(o){function t(l,r){let c=l.defaults;for(;R.ThemeIcon.isThemeIcon(c);){const s=h.getIcon(c.id);if(!s)return;c=s.defaults}return c}o.getDefinition=t})(p||(e.IconContribution=p={}));var y;(function(o){function t(r){return{weight:r.weight,style:r.style,src:r.src.map(c=>({format:c.format,location:c.location.toString()}))}}o.toJSONObject=t;function l(r){const c=s=>(0,b.$9f)(s)?s:void 0;if(r&&Array.isArray(r.src)&&r.src.every(s=>(0,b.$9f)(s.format)&&(0,b.$9f)(s.location)))return{weight:c(r.weight),style:c(r.style),src:r.src.map(s=>({format:s.format,location:m.URI.parse(s.location)}))}}o.fromJSONObject=l})(y||(e.IconFontDefinition=y={}));class w{constructor(){this.a=new N.$ee,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,l,r,c){const s=this.b[t];if(s){if(r&&!s.description){s.description=r,this.d.properties[t].markdownDescription=`${r} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=r),this.a.fire()}return s}const v={id:t,description:r,defaults:l,deprecationMessage:c};this.b[t]=v;const g={$ref:"#/definitions/icons"};return c&&(g.deprecationMessage=c),r&&(g.markdownDescription=`${r}: $(${t})`),this.d.properties[t]=g,this.e.enum.push(t),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const l=this.e.enum.indexOf(t);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,l){const r=this.f[t];return r||(this.f[t]=l,this.a.fire(),l)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(s,v)=>s.id.localeCompare(v.id),l=s=>{for(;R.ThemeIcon.isThemeIcon(s.defaults);)s=this.b[s.defaults.id];return`codicon codicon-${s?s.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(s=>this.b[s]);for(const s of c.filter(v=>!!v.description).sort(t))r.push(`|<i class="${l(s)}"></i>|${s.id}|${R.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const s of c.filter(v=>!R.ThemeIcon.isThemeIcon(v.defaults)).sort(t))r.push(`|<i class="${l(s)}"></i>|${s.id}|`);return r.join(`
`)}}const h=new w;P.$co.add(e.$$w.IconContribution,h);function f(o,t,l,r){return h.registerIcon(o,t,l,r)}function a(){return h}function n(){const o=(0,O.$Rj)();for(const t in o){const l="\\"+o[t].toString(16);h.registerIcon(t,{fontCharacter:l})}}n(),e.$bx="vscode://schemas/icons";const i=P.$co.as(A.$do.JSONContribution);i.registerSchema(e.$bx,h.getIconSchema());const u=new d.$Ih(()=>i.notifySchemaChanged(e.$bx),200);h.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.$cx=f("widget-close",L.$Vj.close,(0,E.localize)(2,null)),e.$dx=f("goto-previous-location",L.$Vj.arrowUp,(0,E.localize)(3,null)),e.$ex=f("goto-next-location",L.$Vj.arrowDown,(0,E.localize)(4,null)),e.$fx=R.ThemeIcon.modify(L.$Vj.sync,"spin"),e.$gx=R.ThemeIcon.modify(L.$Vj.loading,"spin")}),define(ke[88],Se([1,0,4,2,55,5,11]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=e.$jw=e.$hw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$dw=e.$cw=void 0,e.$ew=E,e.$fw=P,e.$gw=p,e.$iw=y,e.$kw=w,e.$lw=h,e.$cw=(0,R.$wi)("tunnelService"),e.$dw=(0,R.$wi)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var m;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function P(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function p(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const u of i){const o=u.split("=")[1];if(/^https?:/.exec(o)){const t=P(L.URI.parse(o));if(t)return t}}}e.$hw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(n){return e.$hw.indexOf(n)>=0}e.$jw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(n){return e.$jw.indexOf(n)>=0}function h(n,i,u,o){if(u===1)return!1;if(u===2&&w(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class f{constructor(i,u,o){this.remoteAddress=i,this.localAddress=u,this.b=o,this.a=new d.$ee,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mw=f;let a=class{constructor(i,u){this.k=i,this.l=u,this.a=new d.$ee,this.onTunnelOpened=this.a.event,this.b=new d.$ee,this.onTunnelClosed=this.b.event,this.c=new d.$ee,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],u=Array.from(this.e.values());for(const o of u){const t=Array.from(o.values());for(const l of t){const r=await l.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:u}of i.values())await u.then(o=>typeof o!="string"?o?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,u,o,t,l){this.q(i,u,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:u,localAddress:o,privacy:t,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,u){(w(i)||y(i))&&(i=e.$hw[0]);const o=this.s(i,u);if(o)return++o.refcount,o.value}openTunnel(i,u,o,t,l,r=!1,c,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${o} on local port ${l}.`);const v=this.f??i;if(!v)return;if(u||(u="localhost"),t||(t=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.t(v,u,o,t,l,r,c,s);return g?g.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(u,o),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(u,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.o(D);return(D.tunnelRemoteHost!==u||D.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&D.privacy!==c&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const u=this.e.get(i.tunnelRemoteHost);if(u){const o=u.get(i.tunnelRemotePort);o&&(o.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,o))}}}}async p(i,u,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${u}.`);const t=o.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(u),t}}async closeTunnel(i,u){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${u} `);const o=this.e.get(i);if(o&&o.has(u)){const t=o.get(u);t.refcount=0,await this.p(i,u,t)}}q(i,u,o){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(u,{refcount:1,value:o})}async r(i,u){const o=this.e.get(i);if(o){const t=o.get(u),l=t?await t.value:void 0;(!l||typeof l=="string")&&o.delete(u),o.size===0&&this.e.delete(i)}}s(i,u){const o=[i];y(i)?(o.push(...e.$hw),o.push(...e.$jw)):w(i)&&o.push(...e.$jw);const t=o.map(l=>this.e.get(l));for(const l of t){const r=l?.get(u);if(r)return r}}canTunnel(i){return!!P(i)}u(i,u,o,t,l,r,c){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${o} on local port ${t}.`);const s=o;this.j.add(s);const v=t===void 0?o:t,g={elevationRequired:l?this.isPortPrivileged(v):!1},D={remoteAddress:{host:u,port:o},localAddressPort:t,privacy:r,public:r?r!==m.Private:void 0,protocol:c},$=i.forwardPort(D,g);return $?(this.q(u,o,$),$.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),$}};e.$nw=a,e.$nw=a=Ke([We(0,N.$3j),We(1,O.$3i)],a)}),define(ke[282],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,d.$wi)("IUriIdentityService")}),define(ke[283],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ow=void 0,e.$ow=(0,d.$wi)("editSessionIdentityService");var L;(function(O){O[O.Complete=100]="Complete",O[O.Partial=50]="Partial",O[O.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(ke[284],Se([1,0,15]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=L,e.$AM=O,e.$BM=R,e.$CM=N,e.$DM=b;function L(m){return m.scheme!==d.Schemas.file&&m.scheme!==d.Schemas.vscodeRemote}function O(m){if(m.folders.length)return m.folders.every(E=>L(E.uri))?m.folders[0].uri:void 0;if(m.configuration&&L(m.configuration))return m.configuration}function R(m){return O(m)?.scheme}function N(m){return O(m)?.authority}function b(m){return O(m)!==void 0}}),define(ke[42],Se([1,0,223,17,78,23,2,5,15]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=E,e.$Hi=A,e.$Ki=P,e.$Li=p,e.$Mi=y,e.$Ni=h,e.$Oi=f,e.$Ri=i,e.$Wi=u,e.$Xi=o,e.$Zi=t,e.$1i=l,e.$2i=r,e.$Fi=(0,b.$wi)("contextService");function E(c){const s=c;return typeof s?.id=="string"&&N.URI.isUri(s.uri)}function A(c){return typeof c?.id=="string"&&!E(c)&&!p(c)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function P(c,s){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,L.$oc)(c)}:s?e.$Ii:e.$Ji;const v=c;return v.configuration?{id:v.id,configPath:v.configuration}:v.folders.length===1?{id:v.id,uri:v.folders[0].uri}:{id:v.id}}function p(c){const s=c;return typeof s?.id=="string"&&N.URI.isUri(s.configPath)}function y(c){const s=c;if(s?.uri)return{id:s.id,uri:N.URI.revive(s.uri)};const v=c;if(v?.configPath)return{id:v.id,configPath:N.URI.revive(v.configPath)};if(c?.id)return{id:c.id}}var w;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function h(c){const s=c;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function f(c){const s=c;return!!(s&&typeof s=="object"&&N.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class a{constructor(s,v,g,D,$){this.h=s,this.j=g,this.k=D,this.l=$,this.c=O.$Ci.forUris(this.l,()=>!0),this.folders=v}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=O.$Ci.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=a;class n{constructor(s,v){this.raw=v,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,R.$0g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=n;function i(c){return new n({uri:c,index:0,name:(0,R.$6g)(c)},{uri:c.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,d.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function u(c,s){return R.$1g.isEqualOrParent(c,s.untitledWorkspacesHome)}function o(c){let s;return N.URI.isUri(c)?s=c:s=c.configuration,s?.scheme===m.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.$Yi}function l(c,s){return!u(c,s)&&!o(c)}function r(c){return(typeof c=="string"?(0,L.$pc)(c):(0,R.$8g)(c))===e.$Ti}}),define(ke[285],Se([1,0,57,4,3,23,2,222,137,33,5,11,42,27,282,7,30,14,18]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=u,e.$Dl=o,e.$El=t;var i;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function u(c){const s=c;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&N.URI.isUri(s.location)&&N.URI.isUri(s.globalStorageHome)&&N.URI.isUri(s.settingsResource)&&N.URI.isUri(s.keybindingsResource)&&N.URI.isUri(s.tasksResource)&&N.URI.isUri(s.snippetsHome)&&N.URI.isUri(s.extensionsResource))}e.$Cl=(0,A.$wi)("IUserDataProfilesService");function o(c,s){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:N.URI.revive(c.location).with({scheme:s}),globalStorageHome:N.URI.revive(c.globalStorageHome).with({scheme:s}),settingsResource:N.URI.revive(c.settingsResource).with({scheme:s}),keybindingsResource:N.URI.revive(c.keybindingsResource).with({scheme:s}),tasksResource:N.URI.revive(c.tasksResource).with({scheme:s}),snippetsHome:N.URI.revive(c.snippetsHome).with({scheme:s}),extensionsResource:N.URI.revive(c.extensionsResource).with({scheme:s}),cacheHome:N.URI.revive(c.cacheHome).with({scheme:s}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}function t(c,s,v,g,D,$){return{id:c,name:s,location:v,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:$&&D?.useDefaultFlags?.globalState?$.globalStorageHome:(0,R.$0g)(v,"globalStorage"),settingsResource:$&&D?.useDefaultFlags?.settings?$.settingsResource:(0,R.$0g)(v,"settings.json"),keybindingsResource:$&&D?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,R.$0g)(v,"keybindings.json"),tasksResource:$&&D?.useDefaultFlags?.tasks?$.tasksResource:(0,R.$0g)(v,"tasks.json"),snippetsHome:$&&D?.useDefaultFlags?.snippets?$.snippetsHome:(0,R.$0g)(v,"snippets"),extensionsResource:$&&D?.useDefaultFlags?.extensions?$.extensionsResource:(0,R.$0g)(v,"extensions.json"),cacheHome:(0,R.$0g)(g,c),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let l=class extends O.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,v,g,D){super(),this.t=s,this.u=v,this.w=g,this.y=D,this.f=!0,this.h=this.B(new L.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),v=[s];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,n.$9f)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}v.push(t((0,R.$7g)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},s))}}catch($){this.y.error($)}const g=new y.$Bc,D=new Map;if(v.length)try{const $=this.Q();if($.workspaces)for(const[k,S]of Object.entries($.workspaces)){const C=N.URI.parse(k),I=v.find(F=>F.id===S);I&&g.set(C,I)}if($.emptyWindows)for(const[k,S]of Object.entries($.emptyWindows)){const C=v.find(I=>I.id===S);C&&D.set(k,C)}}catch($){this.y.error($)}this.z={profiles:v,workspaces:g,emptyWindows:D}}return this.z}D(){const s=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const v="Temp",g=new RegExp(`${(0,a.$af)(v)}\\s(\\d+)`);let D=0;for(const k of this.profiles){const S=g.exec(k.name),C=S?parseInt(S[1]):0;D=C>D?C:D}const $=`${v} ${D+1}`;return this.createProfile((0,d.$kj)((0,f.$Sg)()).toString(16),$,{transient:!0},s)}async createNamedProfile(s,v,g){return this.createProfile((0,d.$kj)((0,f.$Sg)()).toString(16),s,v,g)}async createProfile(s,v,g,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(s,v,g);return D&&await this.setProfileForWorkspace(D,$),$}async F(s,v,g){if(!(0,n.$9f)(v)||!v)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(v);return D||(D=(async()=>{try{if(this.profiles.find(C=>C.name===v||C.id===s))throw new Error(`Profile with ${v} name already exists`);const k=t(s,v,(0,R.$0g)(this.profilesHome,s),this.g,g,this.defaultProfile);await this.u.createFolder(k.location);const S=[];return this.j.fire({profile:k,join(C){S.push(C)}}),await h.Promises.settled(S),this.I([k],[],[]),k}finally{this.r.delete(v)}})(),this.r.set(v,D)),D}async updateProfile(s,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(D=>D.id===s.id);if(!g)throw new Error(`Profile '${s.name}' does not exist`);return g=t(g.id,v.name??g.name,g.location,this.g,{shortName:v.shortName??g.shortName,icon:v.icon===null?void 0:v.icon??g.icon,transient:v.transient??g.isTransient,useDefaultFlags:v.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const v=this.profiles.find(D=>D.id===s.id);if(!v)throw new Error(`Profile '${s.name}' does not exist`);const g=[];this.m.fire({profile:v,join(D){g.push(D)}});try{await Promise.allSettled(g)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])v.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])v.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[v],[]);try{await this.u.del(v.cacheHome,{recursive:!0})}catch(D){(0,E.$hl)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(s,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(D=>D.id===v.id);if(!g)throw new Error(`Profile '${v.name}' does not exist`);this.L(s,g)}unsetWorkspace(s,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,v)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(v=>v.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,v.resource))).map(v=>this.u.del(v.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(v=>!this.H(v));await Promise.allSettled(s.map(v=>this.removeProfile(v)))}getProfileForWorkspace(s){const v=this.G(s);return N.URI.isUri(v)?this.s.workspaces.get(v)??this.C.workspaces.get(v):this.s.emptyWindows.get(v)??this.C.emptyWindows.get(v)}G(s){return(0,p.$Gi)(s)?s.uri:(0,p.$Li)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(v=>this.w.extUri.isEqual(v.location,s.location))||[...this.s.workspaces.values()].some(v=>this.w.extUri.isEqual(v.location,s.location))||[...this.C.emptyWindows.values()].some(v=>this.w.extUri.isEqual(v.location,s.location))||[...this.C.workspaces.values()].some(v=>this.w.extUri.isEqual(v.location,s.location)))}I(s,v,g){const D=[...this.profiles,...s],$=[];this.s.profiles=[];for(let k of D)k.isDefault||v.some(S=>k.id===S.id)||(k=g.find(S=>k.id===S.id)??k,k.isTransient?this.s.profiles.push(k):$.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P($),this.z=void 0,this.J(s,v,g)}J(s,v,g){this.h.fire({added:s,removed:v,updated:g,all:this.profiles})}L(s,v,g){g=v?.isTransient?!0:g,g||this.L(s,void 0,!0);const D=this.G(s),$=g?this.s:this.C;N.URI.isUri(D)?($.workspaces.delete(D),v&&$.workspaces.set(D,v)):($.emptyWindows.delete(D),v&&$.emptyWindows.set(D,v)),g||this.M()}M(){const s={};for(const[g,D]of this.C.workspaces.entries())s[g.toString()]=D.id;const v={};for(const[g,D]of this.C.emptyWindows.entries())v[g.toString()]=D.id;this.R({workspaces:s,emptyWindows:v}),this.z=void 0}N(s){const v={},g=this.D();if(s.workspaces)for(const[$,k]of Object.entries(s.workspaces)){const S=N.URI.parse(k);v[$]=this.w.extUri.isEqual(S,g.location)?g.id:this.w.extUri.basename(S)}const D={};if(s.emptyWindows)for(const[$,k]of Object.entries(s.emptyWindows)){const S=N.URI.parse(k);D[$]=this.w.extUri.isEqual(S,g.location)?g.id:this.w.extUri.basename(S)}return{workspaces:v,emptyWindows:D}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Fl=l,e.$Fl=l=Ke([We(0,m.$Di),We(1,E.$3k),We(2,w.$Al),We(3,P.$3j)],l);class r extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Gl=r}),define(ke[142],Se([1,0,7,4,3,59,18,200,5,285]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=y,e.$4p=h,e.$6p=a,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,m.$wi)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var P;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var p;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function y(n){const i=n.get(e.$Zp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class w extends O.$Vc{static{this.a=60*1e3}constructor(i={flushInterval:w.a}){super(),this.m=i,this.b=this.B(new L.$he),this.c=this.B(new L.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new d.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new O.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,u,o){return L.Event.filter(this.b.event,t=>t.scope===i&&(u===void 0||t.key===u),o)}n(){this.j.value=(0,d.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,O.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,u){const{key:o,external:t}=u;if(o===e.$Zp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:o,target:this.J(i)[o],external:t})}w(i){this.f.fire({reason:i})}get(i,u,o){return this.P(u)?.get(i,o)}getBoolean(i,u,o){return this.P(u)?.getBoolean(i,o)}getNumber(i,u,o){return this.P(u)?.getNumber(i,o)}getObject(i,u,o){return this.P(u)?.getObject(i,o)}storeAll(i,u){this.y(()=>{for(const o of i)this.store(o.key,o.value,o.scope,o.target,u)})}store(i,u,o,t,l=!1){if((0,N.$fg)(u)){this.remove(i,o,l);return}this.y(()=>{this.z(i,o,t),this.P(o)?.set(i,u,l)})}remove(i,u,o=!1){this.y(()=>{this.z(i,u,void 0),this.P(u)?.delete(i,o)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,u){const o=[],t=this.J(i);for(const l of Object.keys(t))t[l]===u&&o.push(l);return o}z(i,u,o,t=!1){const l=this.J(u);typeof o=="number"?l[i]!==o&&(l[i]=o,this.P(u)?.set(e.$Zp,JSON.stringify(l),t)):typeof l[i]=="number"&&(delete l[i],this.P(u)?.set(e.$Zp,JSON.stringify(l),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const u=this.P(i);return u?y(u):Object.create(null)}isNew(i){return this.getBoolean(e.$Yp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const u=this.P(-1),o=this.P(0),t=this.P(1);switch(i){case A.NONE:await d.Promises.settled([u?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await d.Promises.settled([u?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,u=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return a(i,u,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,u){return this.w(A.NONE),(0,E.$Bl)(i)?this.R(i,u):this.S(i,u)}M(i,u){return!(i.id===u.id||h(u)&&h(i))}N(i,u,o){this.y(()=>{const t=new Set;for(const[l,r]of i)t.add(l),u.get(l)!==r&&this.u(o,{key:l,external:!0});for(const[l]of u.items)t.has(l)||this.u(o,{key:l,external:!0})})}}e.$3p=w;function h(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class f extends w{constructor(){super(),this.U=this.B(new b.$Wp(new b.$Xp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Wp(new b.$Xp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Wp(new b.$Xp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$5p=f;async function a(n,i,u,o,t,l){const r=C=>{try{return JSON.parse(C)}catch{return C}},c=new Map,s=new Map;n.forEach((C,I)=>{c.set(I,C),s.set(I,r(C))});const v=new Map,g=new Map;i.forEach((C,I)=>{v.set(I,C),g.set(I,r(C))});const D=new Map,$=new Map;u.forEach((C,I)=>{D.set(I,C),$.set(I,r(C))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const k=[];if(c.forEach((C,I)=>{k.push({key:I,value:C})}),console.table(k),console.groupEnd(),console.log(s),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];v.forEach((I,F)=>{C.push({key:F,value:I})}),console.table(C),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${l})`);const S=[];D.forEach((C,I)=>{S.push({key:I,value:C})}),console.table(S),console.groupEnd(),console.log($)}}),define(ke[112],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class d{static{this.a=!1}constructor(O){this.d=O,this.b=new Map,this.c=1}add(O){const R=this.c++;return this.b.set(R,O),this.e(),R}get(O,R){return this.b.has(O)?this.b.get(O)[R]:void 0}delete(O){this.b.delete(O),this.e()}e(){d.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$$kc=d}),define(ke[60],Se([1,0,15,23,5]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=e.$dlc=void 0;class R{constructor(){this.a=new Set(Object.keys(d.Schemas)),this.b=new Map,this.extUri=new L.$Yg(b=>{const m=this.b.get(b.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(b,m){m===null?this.b.delete(b.scheme):this.b.set(b.scheme,m)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$dlc=R,e.$elc=(0,O.$wi)("IExtHostFileSystemInfo")}),define(ke[28],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=void 0,e.$GP=(0,d.$wi)("IExtHostInitDataService")}),define(ke[286],Se([1,0,228,11,266,28]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;let N=class extends O.$OQ{constructor(m,E,A){const P=A.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",p=A.remote.isRemote?(0,d.localize)(0,null):m?(0,d.localize)(1,null):(0,d.localize)(2,null);super(E.createLogger(P,{name:p}))}};e.$knc=N,e.$knc=N=Ke([We(1,L.$4j),We(2,R.$GP)],N)}),define(ke[287],Se([1,0,7]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=e.$Vlc=void 0;class L{constructor(N,b,m){this.h=new Map,this.a=N,this.b=b,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new d.$Ih(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of E.values())A.complete()}catch(A){for(const P of E.values())P.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,N])=>N!==void 0).map(([N])=>N)}get whenReady(){return this.d}get(N,b){let m=this.f[N];return typeof m>"u"&&(m=b),m}update(N,b){this.f[N]=b;const m=this.h.get(N);if(m!==void 0)return m.p;const E=new d.$Th;return this.h.set(N,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Vlc=L;class O extends L{setKeysForSync(N){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},N)}constructor(N,b){super(N.identifier.value,!0,b),this.j=N}}e.$Wlc=O}),define(ke[288],Se([1,0,4,2]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=void 0;class O{constructor(N){this.c=N,this.a=new d.$ee,this.onDidSaveNotebookDocument=this.a.event,this.b=new d.$ee,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(N,b,m,E){const P=this.c.getNotebookDocument(L.URI.revive(N)).acceptModelChanged(b.value,m,E);this.b.fire(P)}$acceptDirtyStateChanged(N,b){this.c.getNotebookDocument(L.URI.revive(N)).acceptDirty(b)}$acceptModelSaved(N){const b=this.c.getNotebookDocument(L.URI.revive(N));this.a.fire(b.apiNotebook)}}e.$Kmc=O}),define(ke[20],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$qP=void 0,e.$qP=(0,d.$wi)("IExtHostRpcService");class L{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$rP=L}),define(ke[289],Se([1,0,25,4]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class O{#e;constructor(N,b){this.b=new L.$ee,this.onDidChange=this.b.event,this.a=d.$Rm.toKey(N.identifier),this.#e=b,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(N){return this.#e.get(this.a,N)}store(N,b){return this.#e.store(this.a,N,b)}delete(N){return this.#e.delete(this.a,N)}}e.$6lc=O}),define(ke[68],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=e.$tlc=void 0,e.$tlc=(0,d.$wi)("IURITransformerService");class L{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=N=>N,this.transformOutgoing=N=>N,this.transformOutgoingURI=N=>N,this.transformOutgoingScheme=N=>N)}}e.$ulc=L}),define(ke[290],Se([1,0,21]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Arb=O,e.$Brb=N;class L{constructor(){this.buffers=[]}add(m){let E=this.buffers.indexOf(m);return E<0&&(E=this.buffers.length,this.buffers.push(m)),E}}function O(b,m){if(m.serializeBuffersForPostMessage){const E=new L,P=JSON.stringify(b,(y,w)=>{if(w instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(w)};if(ArrayBuffer.isView(w)){const h=R(w);if(h)return{$$vscode_array_buffer_reference$$:!0,index:E.add(w.buffer),view:{type:h,byteLength:w.byteLength,byteOffset:w.byteOffset}}}return w}),p=E.buffers.map(y=>{const w=new Uint8Array(y);return d.$Ge.wrap(w)});return{message:P,buffers:p}}else return{message:JSON.stringify(b),buffers:[]}}function R(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function N(b,m){const E=m.map(p=>{const y=new ArrayBuffer(p.byteLength);return new Uint8Array(y).set(p.buffer),y}),A=m.length?(p,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const w=y,{index:h}=w,f=E[h];if(w.view)switch(w.view.type){case 1:return new Int8Array(f,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return y}:void 0;return{message:JSON.parse(b,A),arrayBuffers:E}}}),define(ke[291],Se([1,0,292,403,404,63,2,11,405]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=A;const E=!1;function A(i,u,o,t,l,r){const c=r.environment.useHostProxy,s=typeof c=="boolean"?c:!r.remote.isRemote,v={resolveProxy:$=>i.resolveProxy($),lookupProxyAuthorization:f.bind(void 0,t,l,u,{},r.remote.isRemote),getProxyURL:()=>u.getConfiguration("http").get("proxy"),getProxySupport:()=>u.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(u),addCertificatesV2:()=>y(u),log:t,getLogLevel:()=>{const $=t.getLevel();switch($){case b.LogLevel.Trace:return m.LogLevel.Trace;case b.LogLevel.Debug:return m.LogLevel.Debug;case b.LogLevel.Info:return m.LogLevel.Info;case b.LogLevel.Warning:return m.LogLevel.Warning;case b.LogLevel.Error:return m.LogLevel.Error;case b.LogLevel.Off:return m.LogLevel.Off;default:return k($)}function k(S){return t.error("Unknown log level",S),m.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:s,loadAdditionalCertificates:async()=>{const $=[];if(r.remote.isRemote&&$.push((0,m.loadSystemCertificates)({log:t})),s){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const k=i.loadCertificates();k.then(S=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",S.length)),$.push(k)}return(await Promise.all($)).flat()},env:process.env},g=(0,m.createProxyResolver)(v),D=P(v,g);return h(o,D)}function P(i,u){return{http:Object.assign(d,(0,m.createHttpPatch)(i,d,u)),https:Object.assign(L,(0,m.createHttpPatch)(i,L,u)),net:Object.assign(R,(0,m.createNetPatch)(i,R)),tls:Object.assign(O,(0,m.createTlsPatch)(i,O))}}function p(i){const u=i.getConfiguration("http");return!u.get("experimental.systemCertificatesV2",E)&&!!u.get("systemCertificates")}function y(i){const u=i.getConfiguration("http");return!!u.get("experimental.systemCertificatesV2",E)&&!!u.get("systemCertificates")}const w=new Map;function h(i,u){return i.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,l=t._load;t._load=function(c,s,v){if(c==="net")return u.net;if(c==="tls")return u.tls;if(c!=="http"&&c!=="https")return l.apply(this,arguments);const g=o.findSubstr(N.URI.file(s.filename));let D=w.get(g);if(D||w.set(g,D={}),!D[c]){const $=u[c];D[c]={...$}}return D[c]}})}async function f(i,u,o,t,l,r,c,s){const v=t[r];c&&(t[r]=c),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${v}`);const g=c||v,D=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(n(u,D,l),D.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!s.kerberosRequested)try{s.kerberosRequested=!0;const $=await new Promise((F,j)=>{le(["kerberos"],F,j)}),k=new URL(r),S=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${k.hostname}`:`HTTP@${k.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${S}`),"Negotiate "+await(await $.initializeClient(S)).step("")}catch($){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let a=!1;function n(i,u,o){a||!u.length||(a=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:u.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(ke[293],Se([1,0,134]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=O;function L(R){return{transformIncoming:N=>N.scheme==="vscode-remote"?{scheme:"file",path:N.path,query:N.query,fragment:N.fragment}:N.scheme==="file"?{scheme:"vscode-local",path:N.path,query:N.query,fragment:N.fragment}:N,transformOutgoing:N=>N.scheme==="file"?{scheme:"vscode-remote",authority:R,path:N.path,query:N.query,fragment:N.fragment}:N.scheme==="vscode-local"?{scheme:"file",path:N.path,query:N.query,fragment:N.fragment}:N,transformOutgoingScheme:N=>N==="file"?"vscode-remote":N==="vscode-local"?"file":N}}function O(R){return new d.$yn(L(R))}}),define(ke[143],Se([1,0,238,18,2,3,5,36,33,15,47,192,41]),function(le,e,d,L,O,R,N,b,m,E,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$KF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$BF=e.EditorInputCapabilities=e.$AF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=void 0,e.$rF=h,e.$sF=f,e.$tF=a,e.$uF=n,e.$vF=i,e.$wF=u,e.$xF=o,e.$yF=t,e.$zF=l,e.$CF=D,e.$DF=k,e.$EF=S,e.$FF=C,e.$GF=I,e.$HF=F,e.$IF=j,e.$JF=te,e.$LF=Y,e.$MF=$e,e.$NF=ue,e.$OF=ve,e.$mF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$nF={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.$oF="workbench.editor.sidebysideEditor",e.$pF="workbench.editors.textDiffEditor",e.$qF="workbench.editors.binaryResourceDiffEditor";var y;(function(_){_[_.PROGRAMMATIC=1]="PROGRAMMATIC",_[_.USER=2]="USER",_[_.EDIT=3]="EDIT",_[_.NAVIGATION=4]="NAVIGATION",_[_.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var w;(function(_){_[_.IDENTICAL=1]="IDENTICAL",_[_.SIMILAR=2]="SIMILAR",_[_.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function h(_){const B=_;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function f(_){const B=_;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function a(_,B,ee){for(const pe of ee.visibleEditorPanes)if(pe.group.id===B&&_.matches(pe.input))return pe.getViewState()}function n(_){if(D(_))return!1;const B=_;return O.URI.isUri(B?.resource)}function i(_){if(D(_))return!1;const B=_;return B?.original!==void 0&&B.modified!==void 0}function u(_){if(D(_))return!1;const B=_;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function o(_){if(D(_)||i(_))return!1;const B=_;return B?.primary!==void 0&&B.secondary!==void 0}function t(_){if(D(_))return!1;const B=_;return B?B.resource===void 0||B.resource.scheme===E.Schemas.untitled||B.forceUntitled===!0:!1}function l(_){if(D(_))return!1;const B=_;return O.URI.isUri(B?.base?.resource)&&O.URI.isUri(B?.input1?.resource)&&O.URI.isUri(B?.input2?.resource)&&O.URI.isUri(B?.result?.resource)}var r;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var c;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class s{constructor(){this.a=new Map}registerSource(B,ee){let pe=this.a.get(B);return pe||(pe={source:B,label:ee},this.a.set(B,pe)),pe.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$AF=new s;var v;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup",_[_.ForceDescription=64]="ForceDescription",_[_.CanDropIntoEditor=128]="CanDropIntoEditor",_[_.MultipleEditors=256]="MultipleEditors",_[_.Scratchpad=512]="Scratchpad"})(v||(e.EditorInputCapabilities=v={}));class g extends R.$Vc{}e.$BF=g;function D(_){return _ instanceof g}function $(_){const B=_;return O.URI.isUri(B?.preferredResource)}function k(_){const B=_;return D(B?.primary)&&D(B?.secondary)}function S(_){const B=_;return D(B?.modified)&&D(B?.original)}function C(_,B,ee,pe,Ce){return ve(pe,[(0,P.$gj)({id:"workbench.action.openLargeFile",label:(0,d.localize)(2,null),run:()=>{const oe={...ee,limits:{size:Number.MAX_VALUE}};_.openEditor(B,oe)}}),(0,P.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,d.localize)(3,null),run:()=>Ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}function I(_){return D(_?.editor)}function F(_){const B=_;return I(_)&&B?.group!==void 0}function j(_){const B=_;return typeof B?.groupId=="number"&&D(B.editor)}var z;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.REPLACE=1]="REPLACE",_[_.MOVE=2]="MOVE",_[_.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var M;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.GROUP_LABEL=2]="GROUP_LABEL",_[_.GROUP_LOCKED=3]="GROUP_LOCKED",_[_.EDITOR_OPEN=4]="EDITOR_OPEN",_[_.EDITOR_CLOSE=5]="EDITOR_CLOSE",_[_.EDITOR_MOVE=6]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=8]="EDITOR_LABEL",_[_.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",_[_.EDITOR_PIN=10]="EDITOR_PIN",_[_.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",_[_.EDITOR_STICKY=12]="EDITOR_STICKY",_[_.EDITOR_DIRTY=13]="EDITOR_DIRTY",_[_.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var T;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH",_[_.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class U{getOriginalUri(B,ee){if(!B)return;if(l(B))return e.$KF.getOriginalUri(B.result,ee);if(ee?.supportSideBySide){const{primary:Ce,secondary:oe}=this.a(B);if(Ce&&oe){if(ee?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(Ce,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(oe,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===T.ANY)return this.getOriginalUri(Ce,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(oe,{filterByScheme:ee.filterByScheme});B=ee.supportSideBySide===T.PRIMARY?Ce:oe}}if(i(B)||u(B)||o(B)||l(B))return;const pe=$(B)?B.preferredResource:B.resource;return!pe||!ee||!ee.filterByScheme?pe:this.b(pe,ee.filterByScheme)}a(B){return k(B)||o(B)?{primary:B.primary,secondary:B.secondary}:S(B)||i(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,ee){if(!B)return;if(l(B))return e.$KF.getCanonicalUri(B.result,ee);if(ee?.supportSideBySide){const{primary:Ce,secondary:oe}=this.a(B);if(Ce&&oe){if(ee?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(Ce,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(oe,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===T.ANY)return this.getCanonicalUri(Ce,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(oe,{filterByScheme:ee.filterByScheme});B=ee.supportSideBySide===T.PRIMARY?Ce:oe}}if(i(B)||u(B)||o(B)||l(B))return;const pe=B.resource;return!pe||!ee||!ee.filterByScheme?pe:this.b(pe,ee.filterByScheme)}b(B,ee){if(Array.isArray(ee)){if(ee.some(pe=>B.scheme===pe))return B}else if(ee===B.scheme)return B}}var Z;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.KEYBOARD=1]="KEYBOARD",_[_.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function te(_,B,ee,pe){if(!_.isSticky(B))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return ee===Z.MOUSE||ee===Z.KEYBOARD;case"mouse":return ee===Z.MOUSE;case"keyboard":return ee===Z.KEYBOARD}return!1}e.$KF=new U;var q;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(q||(e.CloseDirection=q={}));class K{constructor(){this.c=new Map,this.d=new Map}start(B){const ee=this.a=B.get(N.$vi);for(const[pe,Ce]of this.c)this.e(pe,Ce,ee);this.c.clear()}e(B,ee,pe){const Ce=pe.createInstance(ee);this.d.set(B,Ce)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,L.$hg)(this.b)}registerEditorSerializer(B,ee){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,ee,this.a):this.c.set(B,ee),(0,R.$Tc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}b.$co.add(e.$mF.EditorFactory,new K);async function Y(_,B,ee){return!_||!_.length?[]:await Promise.all(_.map(async pe=>{const Ce=O.URI.revive(pe.fileUri);if(!Ce){ee.info("Cannot resolve the path because it is not valid.",pe);return}if(!await B.canHandleResource(Ce)){ee.info("Cannot resolve the path because it cannot be handled",pe);return}let se=pe.exists,re=pe.type;if(typeof se!="boolean"||typeof re!="number")try{re=(await B.stat(Ce)).isDirectory?m.FileType.Directory:m.FileType.Unknown,se=!0}catch(ne){ee.error(ne),se=!1}if(!se&&pe.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",pe);return}if(re===m.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",pe);return}const G={...pe.options,pinned:!0};return se?{resource:Ce,options:G}:{resource:Ce,options:G,forceUntitled:!0}}))}var ie;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(ie||(e.EditorsOrder=ie={}));function $e(_){const B=_;if(!B)return!1;const ee=B;if(ee.modified)return $e(ee.modified);const pe=B;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function ue(_){return(0,A.$ij)(_)}function ve(_,B,ee){const pe=(0,A.$jj)(_,B);return pe.forceMessage=ee?.forceMessage,pe.forceSeverity=ee?.forceSeverity,pe.allowDialog=ee?.allowDialog,pe}}),define(ke[294],Se([1,0,4,239,5,3,27,36,19,24,79,281]),function(le,e,d,L,O,R,N,b,m,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WF=e.$VF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$UF=e.ViewContentGroups=e.$SF=e.ViewContainerLocation=e.Extensions=e.$RF=e.$QF=e.$PF=void 0,e.$TF=w,e.$PF="views",e.$QF=(0,L.localize)(0,null),e.$RF=(0,P.$_w)("default-view-icon",A.$Vj.window,(0,L.localize)(1,null));var p;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var y;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel",l[l.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$SF=[0,1,2];function w(l){switch(l){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class h extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new d.$ee),this.onDidRegister=this.c.event,this.f=this.B(new d.$ee),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,m.$Rb)([...this.g.values()])}registerViewContainer(r,c,s){const v=this.get(r.id);if(v)return v;const g=r;return g.openCommandActionDescriptor=s?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,N.$yc)(this.g,c,[]).push(g),s?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:c}),g}deregisterViewContainer(r){for(const c of this.g.keys()){const s=this.g.get(c),v=s?.indexOf(r);if(v!==-1){s?.splice(v,1),s.length===0&&this.g.delete(c),this.f.fire({viewContainer:r,viewContainerLocation:c});return}}}get(r){return this.all.filter(c=>c.id===r)[0]}getViewContainers(r){return[...this.g.get(r)||[]]}getViewContainerLocation(r){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(s=>s?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.h.find(c=>this.getViewContainerLocation(c)===r)}}b.$co.add(p.ViewContainersRegistry,new h);var f;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(f||(e.ViewContentGroups=f={}));function a(l,r){const c=l.group??f.More,s=r.group??f.More;return c!==s?c.localeCompare(s):(l.order??5)-(r.order??5)}class n extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new d.$ee),this.onViewsRegistered=this.c.event,this.f=this.B(new d.$ee),this.onViewsDeregistered=this.f.event,this.g=this.B(new d.$ee),this.onDidChangeContainer=this.g.event,this.h=this.B(new d.$ee),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new N.$Ic}registerViews(r,c){this.registerViews2([{views:r,viewContainer:c}])}registerViews2(r){r.forEach(({views:c,viewContainer:s})=>this.r(c,s)),this.c.fire(r)}deregisterViews(r,c){const s=this.s(r,c);s.length&&this.f.fire({views:s,viewContainer:c})}moveViews(r,c){for(const s of this.m.keys())if(s!==c){const v=this.s(r,s);v.length&&(this.r(v,c),this.g.fire({views:v,from:s,to:c}))}}getViews(r){return this.m.get(r)||[]}getView(r){for(const c of this.j){const s=(this.m.get(c)||[]).filter(v=>v.id===r)[0];if(s)return s}return null}getViewContainer(r){for(const c of this.j)if((this.m.get(c)||[]).filter(v=>v.id===r)[0])return c;return null}registerViewWelcomeContent(r,c){return this.n.add(r,c),this.h.fire(r),(0,R.$Tc)(()=>{this.n.delete(r,c),this.h.fire(r)})}registerViewWelcomeContent2(r,c){const s=new Map;for(const[v,g]of c)this.n.add(r,g),s.set(v,(0,R.$Tc)(()=>{this.n.delete(r,g),this.h.fire(r)}));return this.h.fire(r),s}getViewWelcomeContent(r){const c=[];return this.n.forEach(r,s=>c.push(s)),c.sort(a)}r(r,c){let s=this.m.get(c);s||(s=[],this.m.set(c,s),this.j.push(c));for(const v of r){if(this.getView(v.id)!==null)throw new Error((0,L.localize)(2,null,v.id));s.push(v)}}s(r,c){const s=this.m.get(c);if(!s)return[];const v=[],g=[];for(const D of s)r.includes(D)?v.push(D):g.push(D);return v.length&&(g.length?this.m.set(c,g):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),v}}b.$co.add(p.ViewsRegistry,new n),e.$UF=(0,O.$wi)("viewDescriptorService");var i;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var u;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(u||(e.TreeItemCollapsibleState=u={}));class o{constructor(r,c){this.c=!1,this.d=!1,(0,E.$6n)(this,r),this.d=!!c,this.resolve=async s=>{if(c&&!this.c){const v=await c(s);v&&(this.tooltip=this.tooltip??v.tooltip,this.command=this.command??v.command)}s.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$VF=o;class t extends Error{constructor(r){super((0,L.localize)(3,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.$WF=t}),define(ke[295],Se([1,0,240,38]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=void 0,e.$1F=new L.$Nj("chatSessionResponseVote","",{type:"string",description:(0,d.localize)(0,null)}),e.$2F=new L.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,d.localize)(1,null)}),e.$3F=new L.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,d.localize)(2,null)}),e.$4F=new L.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,d.localize)(3,null)}),e.$5F=new L.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,d.localize)(4,null)}),e.$6F=new L.$Nj("chatResponse",!1,{type:"boolean",description:(0,d.localize)(5,null)}),e.$7F=new L.$Nj("chatRequest",!1,{type:"boolean",description:(0,d.localize)(6,null)}),e.$8F=new L.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,d.localize)(7,null)}),e.$9F=new L.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,d.localize)(8,null)}),e.$0F=new L.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,d.localize)(9,null)}),e.$$F=new L.$Nj("inChatInput",!1,{type:"boolean",description:(0,d.localize)(10,null)}),e.$_F=new L.$Nj("inChat",!1,{type:"boolean",description:(0,d.localize)(11,null)}),e.$aG=new L.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,d.localize)(12,null)}),e.$bG=new L.$Nj("chatCursorAtTop",!1),e.$cG=new L.$Nj("chatInputHasAgent",!1),e.$dG=new L.$Nj("chatLocation",void 0)}),define(ke[296],Se([1,0,7,22,4,39,3,171,14,38,5,11,108,274,142,295]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.ChatAgentLocation=void 0;var a;(function(o){o.Panel="panel",o.Terminal="terminal",o.Notebook="notebook",o.Editor="editor"})(a||(e.ChatAgentLocation=a={})),function(o){function t(l){switch(l){case"panel":return o.Panel;case"terminal":return o.Terminal;case"notebook":return o.Notebook;case"editor":return o.Editor}return o.Panel}o.fromRaw=t}(a||(e.ChatAgentLocation=a={})),e.$bH=(0,A.$wi)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new O.$ee,this.onDidChangeAgents=this.d.event,this.e=h.$aG.bindTo(this.f)}registerAgent(t,l){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const c=this,s=l.slashCommands;l={...l,get slashCommands(){return s.filter(g=>!g.when||c.f.contextMatchesRules(E.$uj.deserialize(g.when)))}};const v={data:l};return this.b.push(v),(0,N.$Tc)(()=>{this.b=this.b.filter(g=>g!==v),this.d.fire(void 0)})}registerAgentImplementation(t,l){const r=this.g(t);if(!r)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(r.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return r.data.isDefault&&this.e.set(!0),r.impl=l,this.d.fire(new i(r.data,l)),(0,N.$Tc)(()=>{r.impl=void 0,this.d.fire(void 0),r.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,l){const r={data:t,impl:l};return this.b.push(r),this.d.fire(new i(t,l)),(0,N.$Tc)(()=>{this.b=this.b.filter(c=>c!==r),this.d.fire(void 0)})}updateAgent(t,l){const r=this.g(t);if(!r?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);r.data.metadata={...r.data.metadata,...l},this.d.fire(new i(r.data,r.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(l=>!!l.isDefault&&l.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(l=>!!l.isDefault&&l.locations.includes(t))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(l=>l.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new i(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(l=>l.name===t)}async invokeAgent(t,l,r,c,s){const v=this.g(t);if(!v?.impl)throw new Error(`No activated agent with id ${t}`);return await v.impl.invoke(l,r,c,s)}async getFollowups(t,l,r,c,s){const v=this.g(t);if(!v?.impl)throw new Error(`No activated agent with id ${t}`);return v.impl?.provideFollowups?v.impl.provideFollowups(l,r,c,s):[]}};e.$cH=n,e.$cH=n=Ke([We(0,E.$Oj)],n);class i{constructor(t,l){this.b=t,this.d=l}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,l,r,c){return this.d.invoke(t,l,r,c)}async provideFollowups(t,l,r,c){return this.d.provideFollowups?this.d.provideFollowups(t,l,r,c):[]}provideWelcomeMessage(t,l){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,l)}provideSampleQuestions(t,l){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,l)}}e.$dH=i,e.$eH=(0,A.$wi)("chatAgentNameService");let u=class{static{f=this}static{this.b="chat.participantNameRegistry"}constructor(t,l,r,c){if(this.g=l,this.h=r,this.i=c,this.e=(0,b.$2d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const s=c.get(f.b,-1);try{this.e.set(JSON.parse(s??"{}"),void 0)}catch{c.remove(f.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,d.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},L.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const l=await(0,y.$Tp)(t);if(!l||l.version!==1)throw new Error("Unexpected chat participant registry response.");const r=l.restrictedChatParticipants;this.e.set(r,void 0),this.i.store(f.b,JSON.stringify(r),-1,1)}getAgentNameRestriction(t){return this.e.map(r=>r[t.name.toLowerCase()]).map(r=>r?r.some(c=>(0,m.$yf)(c,c.includes(".")?t.extensionId.value:t.extensionPublisher)):!0)}dispose(){this.f=!0}};e.$fH=u,e.$fH=u=f=Ke([We(0,p.$jk),We(1,y.$Np),We(2,P.$3j),We(3,w.$1p)],u)}),define(ke[297],Se([1,0,2,29,5]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lG=e.$kG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$iG=R,e.$jG=N;function R(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof d.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(L.$ut.isIRange)}function N(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(R)}var b;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var m;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$kG=(0,O.$wi)("IChatService"),e.$lG="accessibility.voice.keywordActivation"}),define(ke[144],Se([1,0,4,7,241]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nrb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new d.$ee,this.o=new d.$ee,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,m,E,A){const P={command:b};if(m&&Object.keys(m).length>0&&(P.arguments=m),this.u("request",P),typeof A=="number"){const p=setTimeout(()=>{clearTimeout(p);const y=this.f.get(P.seq);if(y){this.f.delete(P.seq);const w={type:"response",seq:0,request_seq:P.seq,success:!1,command:b,message:(0,O.localize)(0,null,A,b)};y(w)}},A)}return E&&this.f.set(P.seq,E),P.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,m){return b.type!=="event"||m.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,L.$xh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const m=b,E=this.f.get(m.request_seq);E&&(this.f.delete(m.request_seq),E(m));break}}}}u(b,m){m.type=b,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((m,E)=>b.set(E,m)),await(0,L.$xh)(500),b.forEach((m,E)=>{m({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Nrb=R}),define(ke[298],Se([1,0,2,242,38,5]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$vJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$tJ=e.MemoryRangeType=e.State=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=void 0,e.$sJ=m,e.$uJ=A,e.$gI="workbench.view.debug",e.$hI="workbench.debug.variablesView",e.$iI="workbench.debug.watchExpressionsView",e.$jI="workbench.debug.callStackView",e.$kI="workbench.debug.loadedScriptsView",e.$lI="workbench.debug.breakPointsView",e.$mI="workbench.debug.disassemblyView",e.$nI="workbench.panel.repl",e.$oI="workbench.panel.repl.view",e.$pI=new O.$Nj("debugType",void 0,{type:"string",description:L.localize(0,null)}),e.$qI=new O.$Nj("debugConfigurationType",void 0,{type:"string",description:L.localize(1,null)}),e.$rI=new O.$Nj("debugState","inactive",{type:"string",description:L.localize(2,null)}),e.$sI="debugUx",e.$tI=new O.$Nj(e.$sI,"default",{type:"string",description:L.localize(3,null)}),e.$uI=new O.$Nj("hasDebugged",!1,{type:"boolean",description:L.localize(4,null)}),e.$vI=new O.$Nj("inDebugMode",!1,{type:"boolean",description:L.localize(5,null)}),e.$wI=new O.$Nj("inDebugRepl",!1,{type:"boolean",description:L.localize(6,null)}),e.$xI=new O.$Nj("breakpointWidgetVisible",!1,{type:"boolean",description:L.localize(7,null)}),e.$yI=new O.$Nj("inBreakpointWidget",!1,{type:"boolean",description:L.localize(8,null)}),e.$zI=new O.$Nj("breakpointsFocused",!0,{type:"boolean",description:L.localize(9,null)}),e.$AI=new O.$Nj("watchExpressionsFocused",!0,{type:"boolean",description:L.localize(10,null)}),e.$BI=new O.$Nj("watchExpressionsExist",!1,{type:"boolean",description:L.localize(11,null)}),e.$CI=new O.$Nj("variablesFocused",!0,{type:"boolean",description:L.localize(12,null)}),e.$DI=new O.$Nj("expressionSelected",!1,{type:"boolean",description:L.localize(13,null)}),e.$EI=new O.$Nj("breakpointInputFocused",!1,{type:"boolean",description:L.localize(14,null)}),e.$FI=new O.$Nj("callStackItemType",void 0,{type:"string",description:L.localize(15,null)}),e.$GI=new O.$Nj("callStackSessionIsAttach",!1,{type:"boolean",description:L.localize(16,null)}),e.$HI=new O.$Nj("callStackItemStopped",!1,{type:"boolean",description:L.localize(17,null)}),e.$II=new O.$Nj("callStackSessionHasOneThread",!1,{type:"boolean",description:L.localize(18,null)}),e.$JI=new O.$Nj("watchItemType",void 0,{type:"string",description:L.localize(19,null)}),e.$KI=new O.$Nj("canViewMemory",void 0,{type:"boolean",description:L.localize(20,null)}),e.$LI=new O.$Nj("breakpointItemType",void 0,{type:"string",description:L.localize(21,null)}),e.$MI=new O.$Nj("breakpointItemBytes",void 0,{type:"boolean",description:L.localize(22,null)}),e.$NI=new O.$Nj("breakpointHasModes",!1,{type:"boolean",description:L.localize(23,null)}),e.$OI=new O.$Nj("breakpointSupportsCondition",!1,{type:"boolean",description:L.localize(24,null)}),e.$PI=new O.$Nj("loadedScriptsSupported",!1,{type:"boolean",description:L.localize(25,null)}),e.$QI=new O.$Nj("loadedScriptsItemType",void 0,{type:"string",description:L.localize(26,null)}),e.$RI=new O.$Nj("focusedSessionIsAttach",!1,{type:"boolean",description:L.localize(27,null)}),e.$SI=new O.$Nj("focusedSessionIsNoDebug",!1,{type:"boolean",description:L.localize(28,null)}),e.$TI=new O.$Nj("stepBackSupported",!1,{type:"boolean",description:L.localize(29,null)}),e.$UI=new O.$Nj("restartFrameSupported",!1,{type:"boolean",description:L.localize(30,null)}),e.$VI=new O.$Nj("stackFrameSupportsRestart",!1,{type:"boolean",description:L.localize(31,null)}),e.$WI=new O.$Nj("jumpToCursorSupported",!1,{type:"boolean",description:L.localize(32,null)}),e.$XI=new O.$Nj("stepIntoTargetsSupported",!1,{type:"boolean",description:L.localize(33,null)}),e.$YI=new O.$Nj("breakpointsExist",!1,{type:"boolean",description:L.localize(34,null)}),e.$ZI=new O.$Nj("debuggersAvailable",!1,{type:"boolean",description:L.localize(35,null)}),e.$1I=new O.$Nj("debugExtensionAvailable",!0,{type:"boolean",description:L.localize(36,null)}),e.$2I=new O.$Nj("debugProtocolVariableMenuContext",void 0,{type:"string",description:L.localize(37,null)}),e.$3I=new O.$Nj("debugSetVariableSupported",!1,{type:"boolean",description:L.localize(38,null)}),e.$4I=new O.$Nj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:L.localize(39,null)}),e.$5I=new O.$Nj("debugSetExpressionSupported",!1,{type:"boolean",description:L.localize(40,null)}),e.$6I=new O.$Nj("breakWhenValueChangesSupported",!1,{type:"boolean",description:L.localize(41,null)}),e.$7I=new O.$Nj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:L.localize(42,null)}),e.$8I=new O.$Nj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:L.localize(43,null)}),e.$9I=new O.$Nj("terminateDebuggeeSupported",!1,{type:"boolean",description:L.localize(44,null)}),e.$0I=new O.$Nj("suspendDebuggeeSupported",!1,{type:"boolean",description:L.localize(45,null)}),e.$$I=new O.$Nj("variableEvaluateNamePresent",!1,{type:"boolean",description:L.localize(46,null)}),e.$_I=new O.$Nj("variableIsReadonly",!1,{type:"boolean",description:L.localize(47,null)}),e.$aJ=new O.$Nj("variableValue",!1,{type:"string",description:L.localize(48,null)}),e.$bJ=new O.$Nj("variableType",!1,{type:"string",description:L.localize(49,null)}),e.$cJ=new O.$Nj("variableInterfaces",!1,{type:"array",description:L.localize(50,null)}),e.$dJ=new O.$Nj("variableName",!1,{type:"string",description:L.localize(51,null)}),e.$eJ=new O.$Nj("variableLanguage",!1,{type:"string",description:L.localize(52,null)}),e.$fJ=new O.$Nj("variableExtensionId",!1,{type:"string",description:L.localize(53,null)}),e.$gJ=new O.$Nj("exceptionWidgetVisible",!1,{type:"boolean",description:L.localize(54,null)}),e.$hJ=new O.$Nj("multiSessionRepl",!1,{type:"boolean",description:L.localize(55,null)}),e.$iJ=new O.$Nj("multiSessionDebug",!1,{type:"boolean",description:L.localize(56,null)}),e.$jJ=new O.$Nj("disassembleRequestSupported",!1,{type:"boolean",description:L.localize(57,null)}),e.$kJ=new O.$Nj("disassemblyViewFocus",!1,{type:"boolean",description:L.localize(58,null)}),e.$lJ=new O.$Nj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:L.localize(59,null)}),e.$mJ=new O.$Nj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:L.localize(60,null)});const N=i=>L.localize(61,null,i);e.$nJ=N,e.$oJ="editor.contrib.debug",e.$pJ="editor.contrib.breakpoint",e.$qJ="debug",e.$rJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:L.localize(62,null)};var b;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(b||(e.State=b={}));function m(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$tJ="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var P;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(P||(e.DataBreakpointSetType=P={}));var p;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var y;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(y||(e.DebuggerString=y={})),e.$vJ=(0,R.$wi)("debugService");var w;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var h;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(h||(e.DebugVisualizationType=h={}));var f;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(f||(e.DebugTreeItemCollapsibleState=f={}));var a;(function(i){i.deserialize=u=>u,i.serialize=u=>u})(a||(e.IDebugVisualizationTreeItem=a={}));var n;(function(i){i.deserialize=u=>({id:u.id,name:u.name,iconPath:u.iconPath&&{light:d.URI.revive(u.iconPath.light),dark:d.URI.revive(u.iconPath.dark)},iconClass:u.iconClass,visualization:u.visualization}),i.serialize=u=>u})(n||(e.IDebugVisualization=n={}))}),define(ke[299],Se([1,0,14,2,17,24,15,29,22,19]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=void 0,e.$iH=P,e.$jH=p,e.$kH=y,e.$lH=w,e.$mH=h,e.$nH=f,e.$oH=a,e.$pH=i,e.$qH=t,e.$rH=l,e.$sH=c,e.$tH=v;const A=/{([^}]+)}/g;function P(D,$,k){return D.replace(A,function(S,C){return $&&C.length>0&&C[0]!=="_"?S:k&&k.hasOwnProperty(C)?k[C]:S})}function p(D){const $={};for(const k of Object.keys(D))k.startsWith("!")||($[k]=D[k]);return $}function y(D){return D.configuration.request==="attach"&&!w(D)&&(!D.parentSession||y(D.parentSession))}function w(D){let $=D.configuration.type;if($)return $==="vslsShare"&&($=D.configuration.adapterProxy.configuration.type),(0,d.$yf)($,"extensionhost")||(0,d.$yf)($,"pwa-extensionhost")?D:D.parentSession?w(D.parentSession):void 0}function h(D){return D.type&&(D.label||D.program||D.runtime)}function f(D,$,k){let S,C=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=I.exec(D);){const j=F.index+1,z=j+F[0].length;if(j<=$&&z>=k){S=F[0],C=j;break}}if(S){const j=/\w+/g;let z=null;for(;(z=j.exec(S))&&!(z.index+1+C+z[0].length>=k););z&&(S=S.substring(0,j.lastIndex))}return S?{start:C,end:C+S.length-1}:{start:0,end:0}}async function a(D,$,k,S){if(D.evaluatableExpressionProvider.has($)){const C=D.evaluatableExpressionProvider.ordered($),I=(0,E.$Hb)(await Promise.all(C.map(async F=>{try{return await F.provideEvaluatableExpression($,k,S??m.CancellationToken.None)}catch{return}})));if(I.length>0){let F=I[0].expression;const j=I[0].range;return F||(F=$.getLineContent(k.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:F}}}else{const C=$.getLineContent(k.lineNumber),{start:I,end:F}=f(C,k.column,k.column),j=C.substring(I-1,F);return{matchingExpression:j,range:new b.$ut(k.lineNumber,I,k.lineNumber,I+j.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function u(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return L.URI.parse(D.path);if((0,O.$jc)(D.path))return L.URI.file(D.path)}return D.path}function o(D){if(typeof D.path=="object"){const $=L.URI.revive(D.path);if($)return $.scheme===N.Schemas.file?$.fsPath:$.toString()}return D.path}function t(D,$){const k=$?u:o,S=(0,R.$3n)(D);return r(S,(C,I)=>{C&&I&&(I.path=k(I))}),S}function l(D,$){const k=$?u:o,S=(0,R.$3n)(D);return r(S,(C,I)=>{!C&&I&&(I.path=k(I))}),S}function r(D,$){switch(D.type){case"event":{const k=D;switch(k.event){case"output":$(!1,k.body.source);break;case"loadedSource":$(!1,k.body.source);break;case"breakpoint":$(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=D;switch(k.command){case"setBreakpoints":$(!0,k.arguments.source);break;case"breakpointLocations":$(!0,k.arguments.source);break;case"source":$(!0,k.arguments.source);break;case"gotoTargets":$(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(S=>$(!1,S));break;default:break}break}case"response":{const k=D;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(S=>$(!1,S.source));break;case"loadedSources":k.body.sources.forEach(S=>$(!1,S));break;case"scopes":k.body.scopes.forEach(S=>$(!1,S.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(S=>$(!1,S.source));break;case"setBreakpoints":k.body.breakpoints.forEach(S=>$(!1,S.source));break;case"disassemble":k.body?.instructions.forEach(C=>$(!1,C.location));break;default:break}break}}}function c(D){return D.filter($=>!$.presentation?.hidden).sort(($,k)=>$.presentation?k.presentation?$.presentation.group?k.presentation.group?$.presentation.group!==k.presentation.group?$.presentation.group.localeCompare(k.presentation.group):s($.presentation.order,k.presentation.order):-1:k.presentation.group?1:s($.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function s(D,$){return typeof D!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:D-$}async function v(D,$){const k=D.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(k!=="none"&&(await $.saveAll(),k==="allEditorsInActiveGroup")){const S=$.activeEditorPane;S&&S.input.resource?.scheme===N.Schemas.untitled&&await $.save({editor:S.input,groupId:S.group.id})}await D.reloadConfiguration()}const g=(D,$)=>!D||!$?D===$:D.name===$.name&&D.path===$.path&&D.sourceReference===$.sourceReference;e.$uH=g}),define(ke[300],Se([1,0,54,63,24,17,12,14,32,243,144]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=e.$snc=e.$rnc=e.$qnc=void 0;class P extends A.$Nrb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(a,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,a.on("data",i=>this.v(i))}sendMessage(a){if(this.l){const n=JSON.stringify(a);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${P.a}${n}`,"utf8")}}v(a){for(this.p=Buffer.concat([this.p,a]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(P.a);if(n!==-1){const u=this.p.toString("utf8",0,n).split(P.b);for(const o of u){const t=o.split(P.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+P.a.length);continue}}break}}}e.$qnc=P;class p extends P{startSession(){return new Promise((a,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),a(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",u=>{i?this.n.fire(u):n(u)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$rnc=p;class y extends p{constructor(a){super(),this.z=a}y(a){return L.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$snc=y;class w extends p{constructor(a){super(),this.z=a}y(a){return L.createConnection(this.z.path,a)}}e.$tnc=w;class h extends P{constructor(a,n){super(),this.y=a,this.z=n}async startSession(){const a=this.y.command,n=this.y.args,i=this.y.options||{};try{if(a)if(R.$jc(a)){if(!await m.Promises.exists(a))throw new Error(E.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let u=process.env;if(i.env&&Object.keys(i.env).length>0&&(u=O.$6n(O.$3n(process.env),i.env)),a==="node")if(Array.isArray(n)&&n.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:u,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const l=d.fork(n[0],n.slice(1),t);if(!l.pid)throw new Error(E.localize(2,null,n[0]));this.x=l}else throw new Error(E.localize(3,null));else{const o={env:u};i.cwd&&(o.cwd=i.cwd),this.x=d.spawn(a,n,o)}this.x.on("error",o=>{this.n.fire(o)}),this.x.on("exit",(o,t)=>{this.o.fire(o)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.n.fire(o)}),this.x.stdin.on("error",o=>{this.n.fire(o)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(u){this.n.fire(u)}}async stopSession(){return this.x?(await this.w(),N.$i?new Promise((a,n)=>{const i=d.exec(`taskkill /F /T /PID ${this.x.pid}`,function(u,o,t){if(u)return n(u)});i.on("exit",a),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,n){if(!a)return;const i=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?i.runtime=R.$kc(n,a.runtime):i.runtime=a.runtime),a.runtimeArgs&&(i.runtimeArgs=a.runtimeArgs),a.program&&(R.$jc(a.program)?i.program=a.program:i.program=R.$kc(n,a.program)),a.args&&(i.args=a.args);const u=a;return u.win&&(i.win=h.A(u.win,n)),u.winx86&&(i.winx86=h.A(u.winx86,n)),u.windows&&(i.windows=h.A(u.windows,n)),u.osx&&(i.osx=h.A(u.osx,n)),u.linux&&(i.linux=h.A(u.linux,n)),i}static platformAdapterExecutable(a,n){let i=Object.create(null);n=n.toLowerCase();for(const c of a)if(c.contributes){const s=c.contributes.debuggers;s&&s.length>0&&s.filter(v=>typeof v.type=="string"&&b.$yf(v.type,n)).forEach(v=>{const g=h.A(v,c.extensionLocation.fsPath);i=O.$6n(i,g,c.isBuiltin)})}let u;N.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?u=i.winx86||i.win||i.windows:N.$i?u=i.win||i.windows:N.$j?u=i.osx:N.$k&&(u=i.linux),u=u||i;const o=u.program||i.program,t=u.args||i.args,l=u.runtime||i.runtime,r=u.runtimeArgs||i.runtimeArgs;if(l)return{type:"executable",command:l,args:(r||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$unc=h}),define(ke[301],Se([1,0,54,31,12]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=N,e.$wnc=m;function R(E,A){return new Promise((P,p)=>{let y="";const w=d.spawn(E,A);w.pid&&w.stdout.on("data",h=>{y+=h.toString()}),w.on("error",h=>{p(h)}),w.on("close",h=>{P(y)})})}async function N(E){if(E)if(O.$i){const A=await new Promise((P,p)=>{le(["@vscode/windows-process-tree"],P,p)});return new Promise(P=>{A.getProcessTree(E,p=>{P(!!p&&p.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(E)]).then(A=>{const P=A.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var b;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(b||(b={}));function m(E,A,P,p,y){E=E.trim().toLowerCase();let w;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?w=1:E.indexOf("cmd.exe")>=0?w=0:E.indexOf("bash")>=0?w=2:O.$i?w=0:w=2;let h,f=" ";switch(w){case 1:if(h=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),p){const a=(0,L.$Bg)(p);a&&(f+=`${a}:; `),f+=`cd ${h(p)}; `}if(y)for(const a in y){const n=y[a];n===null?f+=`Remove-Item env:${a}; `:f+=`\${env:${a}}='${n}'; `}if(A.length>0){const a=A.shift(),n=P?a:h(a);f+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of A)f+=i==="<"||i===">"||P?i:h(i),f+=" "}break;case 0:if(h=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>a.includes(n))||a.length===0?`"${a}"`:a),p){const a=(0,L.$Bg)(p);a&&(f+=`${a}: && `),f+=`cd ${h(p)} && `}if(y){f+='cmd /C "';for(const a in y){let n=y[a];n===null?f+=`set "${a}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),f+=`set "${a}=${n}" && `)}}for(const a of A)f+=a==="<"||a===">"||P?a:h(a),f+=" ";y&&(f+='"');break;case 2:{h=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const a=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(p&&(f+=`cd ${h(p)} ; `),y){f+="/usr/bin/env";for(const n in y){const i=y[n];i===null?f+=` -u ${a(n)}`:f+=` ${a(`${n}=${i}`)}`}f+=" "}for(const n of A)f+=n==="<"||n===">"||P?n:h(n),f+=" ";break}}return f}}),define(ke[302],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IK=e.CellExecutionUpdateType=void 0;var L;(function(O){O[O.Output=1]="Output",O[O.OutputItems=2]="OutputItems",O[O.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$IK=(0,d.$wi)("INotebookExecutionService")}),define(ke[303],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejb=e.$djb=e.ProxyKernelState=e.$cjb=void 0,e.$cjb=100;var L;(function(O){O[O.Disconnected=1]="Disconnected",O[O.Connected=2]="Connected",O[O.Initializing=3]="Initializing"})(L||(e.ProxyKernelState=L={})),e.$djb=(0,d.$wi)("INotebookKernelService"),e.$ejb=(0,d.$wi)("INotebookKernelHistoryService")}),define(ke[304],Se([1,0,3,29,205,100]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gXb=void 0;class N extends d.$Vc{constructor(m,E,A){super(),this._source=m,this.b=E,this.c=A,this.a=void 0}f(m){const E=m.getLineCount();return new L.$ut(1,1,E,this.g(m,E))}g(m,E){if(E<1||E>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const m=new O.$VC;m.acceptChunk(this._source);const E=m.finish(!0),{textBuffer:A,disposable:P}=E.create(1);this.b=A,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const E=new O.$VC;E.acceptChunk(m);const A=E.finish(!0),{textBuffer:P,disposable:p}=A.create(1);return this.B(p),P})),this.a}findInInputs(m){const A=new R.$JC(m,!1,!1,null).parseSearchRequest();if(!A)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,A,!0,5e3)}findInOutputs(m){const A=new R.$JC(m,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(P=>{const p=P.findMatchesLineByLine(this.f(P),A,!0,5e3);if(p.length!==0)return{textBuffer:P,matches:p}}).filter(P=>!!P):[]}}e.$gXb=N}),define(ke[69],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(R){R.Delimiter="\0"})(d||(e.TestIdPathParts=d={}));var L;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class O{static fromExtHostTestItem(N,b,m=N.parent){if(N._isRoot)return new O([b]);const E=[N.id];for(let A=m;A&&A.id!==b;A=A.parent)E.push(A.id);return E.push(b),new O(E.reverse())}static isRoot(N){return!N.includes("\0")}static root(N){const b=N.indexOf("\0");return b===-1?N:N.slice(0,b)}static fromString(N){return new O(N.split("\0"))}static join(N,b){return new O([...N.path,b])}static joinToString(N,b){return N.toString()+"\0"+b}static parentId(N){const b=N.lastIndexOf("\0");return b===-1?void 0:N.slice(0,b)}static localId(N){const b=N.lastIndexOf("\0");return b===-1?N:N.slice(b+1)}static isChild(N,b){return b.startsWith(N)&&b[N.length]==="\0"}static compare(N,b){return N===b?0:O.isChild(N,b)?2:O.isChild(b,N)?3:1}constructor(N,b=N.length){if(this.path=N,this.d=b,N.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new O(this.path,1)}get parentId(){return this.d>1?new O(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let N=1;N<=this.d;N++)yield new O(this.path,N)}*idsToRoot(){for(let N=this.d;N>0;N--)yield new O(this.path,N)}compare(N){if(typeof N=="string")return O.compare(this.toString(),N);for(let b=0;b<N.d&&b<this.d;b++)if(N.path[b]!==this.path[b])return 1;return N.d>this.d?2:N.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let N=1;N<this.d;N++)this.c+="\0",this.c+=this.path[N]}return this.c}}e.$OL=O}),define(ke[89],Se([1,0,2,51,29,69]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$WL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$VL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$UL=e.$TL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$SL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$RL=e.$QL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$PL=e.TestResultState=void 0;var N;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(N||(e.TestResultState=N={})),e.$PL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var m;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$QL=[2,4,8,16,32,64];const E=M=>"runId"in M;e.$RL=E;var A;(function(M){M.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),M.deserialize=(T,U)=>({range:O.$ut.lift(U.range),uri:T.asCanonicalUri(d.URI.revive(U.uri))})})(A||(e.IRichLocation=A={}));var P;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(P||(e.TestMessageType=P={}));var p;(function(M){M.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&A.serialize(T.location)}),M.deserialize=(T,U)=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&A.deserialize(T,U.location)})})(p||(e.ITestErrorMessage=p={}));const y=(M,T)=>`${T?"s":"e"}${M}`;e.$SL=y;var w;(function(M){M.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&A.serialize(T.location)}),M.deserialize=(T,U)=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&A.deserialize(T,U.location)})})(w||(e.ITestOutputMessage=w={}));var h;(function(M){M.serialize=T=>T.type===0?p.serialize(T):w.serialize(T),M.deserialize=(T,U)=>U.type===0?p.deserialize(T,U):w.deserialize(T,U)})(h||(e.ITestMessage=h={}));var f;(function(M){M.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),M.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(h.serialize)}),M.deserialize=(T,U)=>({state:U.state,duration:U.duration,messages:U.messages.map(Z=>h.deserialize(T,Z))})})(f||(e.ITestTaskState=f={}));const a="\0",n=(M,T)=>M+a+T;e.$TL=n;const i=M=>{const T=M.indexOf(a);return{ctrlId:M.slice(0,T),tagId:M.slice(T+1)}};e.$UL=i;var u;(function(M){M.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),M.deserialize=(T,U)=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?T.asCanonicalUri(d.URI.revive(U.uri)):void 0,range:U.range?O.$ut.lift(U.range):null,description:U.description,error:U.error,sortText:U.sortText})})(u||(e.ITestItem=u={}));var o;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(M){M.serialize=T=>({expand:T.expand,item:u.serialize(T.item)}),M.deserialize=(T,U)=>({controllerId:R.$OL.root(U.item.extId),expand:U.expand,item:u.deserialize(T,U.item)})})(t||(e.InternalTestItem=t={}));var l;(function(M){M.serialize=T=>{let U;return T.item&&(U={},T.item.label!==void 0&&(U.label=T.item.label),T.item.tags!==void 0&&(U.tags=T.item.tags),T.item.busy!==void 0&&(U.busy=T.item.busy),T.item.uri!==void 0&&(U.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(U.range=T.item.range?.toJSON()),T.item.description!==void 0&&(U.description=T.item.description),T.item.error!==void 0&&(U.error=T.item.error),T.item.sortText!==void 0&&(U.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:U}},M.deserialize=T=>{let U;return T.item&&(U={},T.item.label!==void 0&&(U.label=T.item.label),T.item.tags!==void 0&&(U.tags=T.item.tags),T.item.busy!==void 0&&(U.busy=T.item.busy),T.item.range!==void 0&&(U.range=T.item.range?O.$ut.lift(T.item.range):null),T.item.description!==void 0&&(U.description=T.item.description),T.item.error!==void 0&&(U.error=T.item.error),T.item.sortText!==void 0&&(U.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:U}}})(l||(e.ITestItemUpdate=l={}));const r=(M,T)=>{T.expand!==void 0&&(M.expand=T.expand),T.item!==void 0&&(M.item=M.item?Object.assign(M.item,T.item):T.item)};e.$VL=r;var c;(function(M){M.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(f.serializeWithoutMessages)}),M.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(f.serialize)}),M.deserialize=(T,U)=>({...t.deserialize(T,U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(Z=>f.deserialize(T,Z)),retired:!0})})(c||(e.TestResultItem=c={}));var s;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(T,U)=>{T.covered+=U.covered,T.total+=U.total}})(s||(e.ICoverageCount=s={}));var v;(function(M){M.serialize=T=>({id:T.id,statement:T.statement,branch:T.branch,declaration:T.declaration,uri:T.uri.toJSON()}),M.deserialize=(T,U)=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:T.asCanonicalUri(d.URI.revive(U.uri))})})(v||(e.IFileCoverage=v={}));function g(M){return{...M,location:M.location?.toJSON()}}function D(M){return M.location=M.location?L.$tt.isIPosition(M.location)?L.$tt.lift(M.location):O.$ut.lift(M.location):void 0,M}e.$WL=3;var $;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})($||(e.DetailType=$={}));var k;(function(M){M.serialize=T=>T.type===0?C.serialize(T):I.serialize(T),M.deserialize=T=>T.type===0?C.deserialize(T):I.deserialize(T)})(k||(e.CoverageDetails=k={}));var S;(function(M){M.serialize=g,M.deserialize=D})(S||(e.IBranchCoverage=S={}));var C;(function(M){M.serialize=g,M.deserialize=D})(C||(e.IDeclarationCoverage=C={}));var I;(function(M){M.serialize=T=>({...g(T),branches:T.branches?.map(S.serialize)}),M.deserialize=T=>({...D(T),branches:T.branches?.map(S.deserialize)})})(I||(e.IStatementCoverage=I={}));var F;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var j;(function(M){M.deserialize=(T,U)=>U.op===0?{op:U.op,item:t.deserialize(T,U.item)}:U.op===1?{op:U.op,item:l.deserialize(U.item)}:U.op===2?{op:U.op,uri:T.asCanonicalUri(d.URI.revive(U.uri)),docv:U.docv}:U,M.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:l.serialize(T.item)}:T})(j||(e.TestsDiffOp=j={}));class z{constructor(T){this.k=T,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(T){const U=this.v();for(const Z of T)switch(Z.op){case 0:this.l(t.deserialize(this.k,Z.item),U);break;case 1:this.o(l.deserialize(Z.item),U);break;case 3:this.p(Z.itemId,U);break;case 5:this.q(Z.itemId);break;case 4:this.updatePendingRoots(Z.amount);break;case 6:this.c.set(Z.tag.id,Z.tag);break;case 7:this.c.delete(Z.id);break}U.complete?.()}l(T,U){const Z=R.$OL.parentId(T.item.extId)?.toString();let te;if(!Z)te=this.w(T),this.g.add(te),this.f.set(T.item.extId,te);else if(this.f.has(Z)){const q=this.f.get(Z);q.children.add(T.item.extId),te=this.w(T,q),this.f.set(T.item.extId,te)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return U.add?.(te),T.expand===2&&this.h++,te}o(T,U){const Z=this.f.get(T.extId);if(Z)return T.expand!==void 0&&(Z.expand===2&&this.h--,T.expand===2&&this.h++),(0,e.$VL)(Z,T),U.update?.(Z),Z}p(T,U){const Z=this.f.get(T);if(!Z)return;const te=R.$OL.parentId(Z.item.extId)?.toString();te?this.f.get(te).children.delete(Z.item.extId):this.g.delete(Z);const q=[[T]];for(;q.length;)for(const K of q.pop()){const Y=this.f.get(K);Y&&(q.push(Y.children),this.f.delete(K),U.remove?.(Y,Y!==Z),Y.expand===2&&this.h--)}}q(T){}updatePendingRoots(T){this.j+=T}v(){return{}}}e.$XL=z}),define(ke[113],Se([1,0,7,4,3,62,89,69]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const E=(n,i)=>n===i,P=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(u=>!i.includes(u)))}),p=(n,i)=>{let u;for(const[o,t]of P)t(n[o],i[o])||(u?u[o]=i[o]:u={[o]:i[o]});return u};class y extends O.$Vc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new d.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new L.$ee),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const u of this.tree.values())this.J(u)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const u of this.m)if(u.op===2&&u.uri===i.uri){u.docv=i.docv;return}break}case 1:{const u=this.m[this.m.length-1];if(u){if(u.op===1&&u.item.extId===i.item.extId){(0,N.$VL)(u.item,i.item);return}if(u.op===0&&u.item.item.extId===i.item.extId){(0,N.$VL)(u.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,u){const o=this.tree.get(i);if(o){if((o.expandLevels===void 0||u>o.expandLevels)&&(o.expandLevels=u),o.expand===1){const t=this.M(o);return t.isOpen()?this.L(o,u-1):t.wait().then(()=>this.L(o,u-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,u-1)):this.L(o,u-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,u){switch(u.op){case 3:this.O(b.$OL.joinToString(i.fullId,u.id));break;case 0:this.z(u.item,i);break;case 5:for(const o of u.ops)this.w(i,o);break;case 1:this.C(u.new,u.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:u.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$fd)(u)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,u){const o=b.$OL.fromExtHostTestItem(i,this.root.id,u?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==u?.actual&&this.s.getChildren(t.parent).delete(i.id);let l=this.tree.get(o.toString());if(!l){l={fullId:o,actual:i,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,u),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,u);return}if(l.actual===i){this.H(i,l,u);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(o.toString()),this.z(i,u);const r=this.s.getChildren(l.actual),c=l.actual,s=p(this.s.toITestItem(c),this.s.toITestItem(i));this.s.getApiFor(c).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=0,s&&(s.hasOwnProperty("tags")&&(this.C(i.tags,c.tags,o.toString()),delete s.tags),this.w(l,{op:4,update:s})),this.I(i,l,u);for(const[g,D]of r)this.s.getChildren(i).get(D.id)||this.O(b.$OL.joinToString(o,D.id));const v=l.expandLevels;v!==void 0&&queueMicrotask(()=>{l.expand===1&&(l.expandLevels=void 0,this.expand(o.toString(),v))}),this.y(l.actual.uri)}C(i,u,o){const t=new Set(u.map(l=>l.id));for(const l of i)t.delete(l.id)||this.D(l);this.pushDiff({op:1,item:{extId:o,item:{tags:i.map(l=>(0,N.$TL)(this.s.controllerId,l.id))}}}),t.forEach(this.F,this)}D(i){const u=this.j.get(i.id);u?u.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,N.$TL)(this.s.controllerId,i.id)}}))}F(i){const u=this.j.get(i);u&&!--u.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,N.$TL)(this.s.controllerId,i)}))}G(i,u){this.s.getApiFor(i).parent=u&&u.actual!==this.root?u.actual:void 0}H(i,u,o){this.G(i,o);const t=this.s.getApiFor(i);t.parent=o?.actual,t.listener=l=>this.w(u,l),this.J(u)}I(i,u,o){this.H(i,u,o);for(const[t,l]of this.s.getChildren(i))this.z(l,u)}J(i){let u;this.h?i.resolveBarrier?u=i.resolveBarrier.isOpen()?3:2:u=i.actual.canResolveChildren?1:0:u=0,u!==i.expand&&(i.expand=u,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:u}}),u===1&&i.expandLevels!==void 0&&this.M(i))}L(i,u){if(u<0)return;const o=[];for(const[t,l]of this.s.getChildren(i.actual)){const r=this.expand(b.$OL.joinToString(i.fullId,l.id),u);(0,d.$ih)(r)&&o.push(r)}if(o.length)return Promise.all(o).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new d.$vh;return l.open(),l}i.expand=2,this.N(i);const u=i.resolveBarrier=new d.$vh,o=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(l){o(l)}return(0,d.$ih)(t)?t.catch(o).then(()=>{u.open(),this.J(i)}):(u.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const u=this.tree.get(i);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const o=[u];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const l of t.actual.tags)this.F(l.id);this.tree.delete(t.fullId.toString());for(const[l,r]of this.s.getChildren(t.actual))o.push(this.tree.get(b.$OL.joinToString(t.fullId,r.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$gP=y;class w extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$hP=w;class h extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$iP=h;class f extends Error{constructor(i,u,o){super(`TestItem with ID "${i}" is from controller "${u}" and cannot be added as a child of an item from controller "${o}".`)}}e.$jP=f;const a=(n,i,u)=>{let o=new Map;return{get size(){return o.size},forEach(t,l){for(const r of o.values())t.call(l,r,this)},[Symbol.iterator](){return o.entries()},replace(t){const l=new Map,r=new Set(o.keys()),c={op:5,ops:[]};for(const s of t){if(!(s instanceof u))throw new h(s.id);const v=i(s).controllerId;if(v!==n.controllerId)throw new f(s.id,v,n.controllerId);if(l.has(s.id))throw new w(s.id);l.set(s.id,s),r.delete(s.id),c.ops.push({op:0,item:s})}for(const s of r.keys())c.ops.push({op:3,id:s});n.listener?.(c),o=l},add(t){if(!(t instanceof u))throw new h(t.id);o.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){o.delete(t)&&n.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$kP=a}),define(ke[145],Se([1,0,113]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=e.$lP=void 0;const L=new WeakMap,O=(N,b)=>{const m={controllerId:b};return L.set(N,m),m};e.$lP=O;const R=N=>{const b=L.get(N);if(!b)throw new d.$iP(N?.id||"<unknown>");return b};e.$mP=R}),define(ke[114],Se([1,0,15,2]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NAb=e.$MAb=e.$LAb=void 0,e.$OAb=O,e.$PAb=N,e.$LAb="vscode-cdn.net",e.$MAb=`vscode-resource.${e.$LAb}`,e.$NAb=`'self' https://*.${e.$LAb}`;function O(b,m){return b.scheme===d.Schemas.http||b.scheme===d.Schemas.https?b:(m&&m.authority&&m.isRemote&&b.scheme===d.Schemas.file&&(b=L.URI.from({scheme:d.Schemas.vscodeRemote,authority:m.authority,path:b.path})),L.URI.from({scheme:d.Schemas.https,authority:`${b.scheme}+${R(b.authority)}.${e.$MAb}`,path:b.path,fragment:b.fragment,query:b.query}))}function R(b){return b.replace(/./g,m=>{const E=m.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?m:"-"+E.toString(16).padStart(4,"0")})}function N(b){return b.replace(/-([0-9a-f]{4})/g,(m,E)=>String.fromCharCode(parseInt(E,16)))}}),define(ke[305],Se([1,0,4,3,114]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=void 0;class R{constructor(b,m,E){this.d=b,this.e=m,this.f=E,this.a=0,this.b=new L.$Uc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const A=m.getVisibleTextEditors();for(const P of this.c.values())A.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,m,E,A,P){let p;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){p=i;break}if(!p)throw new Error("not a visible editor");const y=this,w=this.a++,h=new d.$ee,f=new d.$ee,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,O.$OAb)(i,y.f)}get cspSource(){return O.$NAb}set options(i){this.b=i,y.d.$setOptions(w,i)}get options(){return this.b}set html(i){this.a=i,y.d.$setHtml(w,i)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(i){return y.d.$postMessage(w,i)}},n=new class{constructor(){this.editor=b,this.line=m,this.height=E,this.webview=a,this.onDidDispose=f.event}dispose(){y.c.has(w)&&(y.c.delete(w),y.d.$disposeEditorInset(w),f.fire(),f.dispose(),h.dispose())}};return this.d.$createEditorInset(w,p.id,p.value.document.uri,m+1,E,A||{},P.identifier,P.extensionLocation),this.c.set(w,{editor:b,inset:n,onDidReceiveMessage:h}),n}$onDidDispose(b){const m=this.c.get(b);m&&m.inset.dispose()}$onDidReceiveMessage(b,m){this.c.get(b)?.onDidReceiveMessage.fire(m)}}e.$rlc=R}),define(ke[146],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=e.$5L=void 0,e.$5L="__",e.$6L=(0,d.$wi)("IAuthenticationService"),e.$7L=(0,d.$wi)("IAuthenticationExtensionsService")}),define(ke[306],Se([1,0,5]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.VariableKind=e.$cQ=void 0,e.$cQ=(0,d.$wi)("configurationResolverService");var L;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(L||(e.VariableKind=L={}));class O extends Error{constructor(N,b){super(b),this.variable=N}}e.$dQ=O}),define(ke[307],Se([1,0,17,52,18,24,12,103,246,306,14]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,w,h,f){this.h=new Map,this.a=y,this.b=w,this.g=h,f&&(this.c=f.then(a=>this.i(a)))}i(y){if(N.$i){const w=Object.create(null);return Object.keys(y).forEach(h=>{w[h.toLowerCase()]=y[h]}),w}return y}resolveWithEnvironment(y,w,h){return this.l({env:this.i(y),userHome:void 0},w?w.uri:void 0,h)}async resolveAsync(y,w){const h={env:await this.c,userHome:await this.g};return this.l(h,y?y.uri:void 0,w)}async j(y,w,h,f){const a=R.$3n(w);N.$i&&a.windows?Object.keys(a.windows).forEach(i=>a[i]=a.windows[i]):N.$j&&a.osx?Object.keys(a.osx).forEach(i=>a[i]=a.osx[i]):N.$k&&a.linux&&Object.keys(a.linux).forEach(i=>a[i]=a.linux[i]),delete a.windows,delete a.osx,delete a.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,y?y.uri:void 0,a,h,f)}async resolveAnyAsync(y,w,h){return this.j(y,w,h)}async resolveAnyMap(y,w,h){const f=new Map;return{newConfig:await this.j(y,w,h,f),resolvedVariables:f}}resolveWithInteractionReplace(y,w,h,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,w,h,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,w){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,w)}async l(y,w,h,f,a){if(O.$9f(h))return this.m(y,w,h,f,a);if(Array.isArray(h))return Promise.all(h.map(n=>this.l(y,w,n,f,a)));if(O.$$f(h)){const n=Object.create(null),i=await Promise.all(Object.keys(h).map(async u=>[await this.m(y,w,u,f,a),await this.l(y,w,h[u],f,a)]));for(const[u,o]of i)n[u]=o;return n}return h}m(y,w,h,f,a){return(0,A.$qf)(h,P.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(P.VARIABLE_LHS))return n;let u=await this.o(y,n,i,w,f);return a?.set(i,u),u!==n&&O.$9f(u)&&u.match(P.VARIABLE_REGEXP)&&(u=await this.m(y,w,u,f,a)),u})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,w,h,f,a){let n;const i=h.split(":");i.length>1&&(h=i[0],n=i[1]);const u=l=>{const r=this.a.getFilePath();if(r)return(0,b.$yw)(r);throw new E.$dQ(l,(0,m.localize)(0,null,w))},o=l=>{const r=u(l);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,b.$yw)(c)}throw new E.$dQ(l,(0,m.localize)(1,null,w,d.$oc(r)))},t=l=>{if(n){const r=this.a.getFolderUri(n);if(r)return r;throw new E.$dQ(l,(0,m.localize)(2,null,w,n))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new E.$dQ(l,(0,m.localize)(3,null,w)):new E.$dQ(l,(0,m.localize)(4,null,w))};switch(h){case"env":if(n){if(y.env){const l=y.env[N.$i?n.toLowerCase():n];if(O.$9f(l))return l}return""}throw new E.$dQ(E.VariableKind.Env,(0,m.localize)(5,null,w));case"config":if(n){const l=this.a.getConfigurationValue(f,n);if(O.$fg(l))throw new E.$dQ(E.VariableKind.Config,(0,m.localize)(6,null,w,n));if(O.$$f(l))throw new E.$dQ(E.VariableKind.Config,(0,m.localize)(7,null,w,n));return l}throw new E.$dQ(E.VariableKind.Config,(0,m.localize)(8,null,w));case"command":return this.p(E.VariableKind.Command,w,n,a,"command");case"input":return this.p(E.VariableKind.Input,w,n,a,"input");case"extensionInstallFolder":if(n){const l=await this.a.getExtension(n);if(!l)throw new E.$dQ(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,w,n));return this.n(l.extensionLocation)}throw new E.$dQ(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,w));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,b.$yw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return f||n?(0,b.$yw)(this.n(t(E.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$yw)(d.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new E.$dQ(E.VariableKind.UserHome,(0,m.localize)(11,null,w))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new E.$dQ(E.VariableKind.LineNumber,(0,m.localize)(12,null,w))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new E.$dQ(E.VariableKind.SelectedText,(0,m.localize)(13,null,w))}case"file":return u(E.VariableKind.File);case"fileWorkspaceFolder":return o(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return d.$oc(o(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||n?d.$mc(this.n(t(E.VariableKind.RelativeFile)),u(E.VariableKind.RelativeFile)):u(E.VariableKind.RelativeFile);case"relativeFileDirname":{const l=d.$nc(u(E.VariableKind.RelativeFileDirname));if(f||n){const r=d.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),l);return r.length===0?".":r}return l}case"fileDirname":return d.$nc(u(E.VariableKind.FileDirname));case"fileExtname":return d.$pc(u(E.VariableKind.FileExtname));case"fileBasename":return d.$oc(u(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=d.$oc(u(E.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-d.$pc(l).length)}case"fileDirnameBasename":return d.$oc(d.$nc(u(E.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||w}case"execInstallFolder":{const l=this.a.getAppRoot();return l||w}case"pathSeparator":case"/":return d.sep;default:try{const l=n?`${h}:${n}`:h;return this.p(E.VariableKind.Unknown,w,l,a,void 0)}catch{return w}}}}p(y,w,h,f,a){if(h&&f){const n=a===void 0?f[h]:f[a+":"+h];if(typeof n=="string")return n;throw new E.$dQ(y,(0,m.localize)(14,null,w))}return w}}e.$sQ=P}),define(ke[147],Se([1,0,5,143]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$RD=void 0,e.$SD=E,e.$TD=p,e.$UD=y,e.$RD=(0,d.$wi)("editorGroupsService");var O;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(O||(e.GroupDirection=O={}));var R;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var N;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(N||(e.GroupLocation=N={}));var b;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var m;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function E(w){const h=w;return(0,L.$CF)(h?.editor)&&(0,L.$CF)(h?.replacement)}var A;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var P;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function p(w){const h=w;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}function y(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[308],Se([1,0,5,147]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YD=e.$XD=e.$WD=e.$VD=void 0,e.$ZD=O,e.$VD=(0,d.$wi)("editorService"),e.$WD=-1,e.$XD=-2,e.$YD=-3;function O(R){const N=R;return typeof R=="number"||(0,L.$TD)(N)}}),define(ke[148],Se([1,0,5,137]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=void 0,e.$nM=(0,d.$xi)(L.$Di)}),define(ke[149],Se([1,0,25,4,17,3,7]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=e.$N_b=e.$M_b=e.$L_b=e.$K_b=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$K_b=b;class m{static isHostExtension(n,i,u){if(i.getExtensionDescription(n))return!1;const o=u.getExtensionDescription(n);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(n,i){this.j=n,this.c=new L.$ee,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(h),this.f=new d.$Tm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const u of i)this.h.has(u)||this.h.set(u,[]),this.h.get(u).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=f(this.e,i),this.e=this.e.concat(n);const u=m.l(this.e);return this.e=f(this.e,u.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,u)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,c){this.addNode(r),this.addNode(c),this.c.has(r)?this.c.get(r).push(c):this.c.set(r,[c])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,c){const s=i.getArcs(r);for(let v=0;v<s.length;v++)if(!c.has(s[v]))return!1;return!0}getNodes(){return this.e}},u=new d.$Tm;for(const r of n)if(u.set(r.identifier,r),r.extensionDependencies)for(const c of r.extensionDependencies)i.addArc(d.$Rm.toKey(r.identifier),d.$Rm.toKey(c));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const t=i.getNodes().filter(r=>!o.has(r));let l;do{l=!1;for(let r=0;r<t.length;r++){const c=t[r];i.hasOnlyGoodArcs(c,o)&&(t.splice(r,1),r--,o.add(c),l=!0)}}while(l);return t.map(r=>u.get(r))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$L_b=m;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$M_b=E;class A{constructor(n){this.d=new y,this.c=new m(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new P(this,i)}deltaExtensions(n,i,u){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,u)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$N_b=A;class P extends R.$Vc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$O_b=P;class p{constructor(n){this.name=n;const i=(0,N.$ph)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class y{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new p(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const u=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(u),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Tc)(o))}}var w;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(w||(w={}));function h(a,n){const i=a.isBuiltin?0:a.isUnderDevelopment?2:1,u=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==u)return i-u;const o=O.$hc.basename(a.extensionLocation.path),t=O.$hc.basename(n.extensionLocation.path);return o<t?-1:o>t?1:0}function f(a,n){const i=new d.$Sm(n);return a.filter(u=>!i.has(u.identifier))}}),define(ke[309],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=e.ExtHostConnectionType=void 0,e.$nn=b,e.$on=m;var d;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(d||(e.ExtHostConnectionType=d={}));class L{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[L.ENV_KEY]=this.pipeName}}e.$kn=L;class O{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[O.ENV_KEY]="1"}}e.$ln=O;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[R.ENV_KEY]="1"}}e.$mn=R;function N(A){delete A[L.ENV_KEY],delete A[O.ENV_KEY],delete A[R.ENV_KEY]}function b(A,P){N(P),A.serialize(P)}function m(A){if(A[L.ENV_KEY])return E(A,new L(A[L.ENV_KEY]));if(A[O.ENV_KEY])return E(A,new O);if(A[R.ENV_KEY])return E(A,new R);throw new Error("No connection information defined in environment!")}function E(A,P){return N(A),P}}),define(ke[115],Se([1,0,21]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Zm=N,e.$1m=b;var L;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(L||(e.UIKind=L={}));var O;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(O||(e.ExtensionHostExitCode=O={}));var R;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function N(E){const A=d.$Ge.alloc(1);switch(E){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function b(E,A){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var m;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(ke[90],Se([1,0,5,4,11,28,115,86,87,24,2,3,231]),function(le,e,d,L,O,R,N,b,m,E,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=e.$IP=e.$HP=void 0,e.$JP=h;let y=class extends P.$Vc{constructor(a,n){super(),this.s=a,this.t=n,this.a=this.B(new L.$ee),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$ee),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$kp,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,O.$5j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,n,i){const u=this.getTelemetryDetails(),o=new w(n,i,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,n,i){this.f=a,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const n=Object.create(null);switch(n["common.extname"]=`${a.publisher}.${a.name}`,n["common.extversion"]=a.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case N.UIKind.Web:n["common.uikind"]="web";break;case N.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$Im)((0,m.$qp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const n=this.getTelemetryDetails();this.r.forEach((i,u)=>{const o=i.filter(t=>!t.isDisposed);o.length===0?this.r.delete(u):this.r.set(u,o)}),this.r.forEach(i=>{for(const u of i)u.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,n){const u=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!u)return this.r.delete(a.value),!1;let o=!1;for(const t of u)t.ignoreUnhandledExtHostErrors||(t.logError(n),o=!0);return o}};e.$HP=y,e.$HP=y=Ke([We(0,R.$GP),We(1,O.$4j)],y);class w{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,n,i,u,o,t,l){this.g=i,this.h=u,this.i=o,this.j=t,this.a=new L.$ee,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}}updateTelemetryEnablements(a,n){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let n="properties"in a?a.properties??{}:a;return n=(0,m.$tp)(n,[]),this.c&&(n=(0,E.$6n)(n,this.c)),this.b||(n=(0,E.$6n)(n,this.j)),"properties"in a?a.properties=n:a=n,a}k(a,n){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(a,n),this.h.trace(a,n))}logUsage(a,n){this.d.isUsageEnabled&&this.k(a,n)}logError(a,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,n);else{const i={name:a.name,message:a.message,stack:a.stack,cause:a.cause},u=(0,m.$tp)(i,[]),o=new Error(u.message,{cause:u.cause});o.stack=u.stack,o.name=u.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(o,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const a=this,n={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$IP=w;function h(f){const a=Date.now()-new Date(f).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$KP=(0,d.$wi)("IExtHostTelemetry")}),define(ke[26],Se([1,0,4,2,278,140,25,5]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NG=e.ActivationKind=e.$KG=e.$JG=e.$GG=e.ExtensionHostStartup=e.$FG=e.$EG=e.$DG=e.$CG=void 0,e.$HG=p,e.$IG=y,e.$LG=a,e.$MG=n,e.$CG=Object.freeze({identifier:new N.$Rm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$DG="extensions.webWorker",e.$EG=(0,b.$wi)("extensionService");class m{constructor(o){this.dependency=o}}e.$FG=m;var E;(function(u){u[u.EagerAutoStart=1]="EagerAutoStart",u[u.EagerManualStart=2]="EagerManualStart",u[u.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,l){this.c=o,this.d=t.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$nG.createActivationEventsMap(this.d)}}set(o,t,l){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const r=[],c=[],s=[],v=[],g=P(this.d),D=P(t),$=(F,j)=>F.extensionLocation.toString()===j.extensionLocation.toString()||F.isBuiltin===j.isBuiltin||F.isUserBuiltin===j.isUserBuiltin||F.isUnderDevelopment===j.isUnderDevelopment;for(const F of this.d){const j=D.get(F.identifier);if(!j){r.push(F.identifier),g.delete(F.identifier);continue}if(!$(F,j)){r.push(F.identifier),g.delete(F.identifier);continue}}for(const F of t){const j=g.get(F.identifier);if(!j){c.push(F);continue}if(!$(j,F)){r.push(j.identifier),g.delete(j.identifier);continue}}const k=new N.$Sm(this.e),S=new N.$Sm(l);for(const F of this.e)S.has(F)||s.push(F);for(const F of l)k.has(F)||v.push(F);const C=R.$nG.createActivationEventsMap(c),I={versionId:o,toRemove:r,toAdd:c,addActivationEvents:C,myToRemove:s,myToAdd:v};return this.delta(I),I}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:l,myToRemove:r,myToAdd:c}=o,s=new N.$Sm(t),v=new N.$Sm(r);for(let g=0;g<this.d.length;g++)s.has(this.d[g].identifier)&&(this.d.splice(g,1),g--);for(let g=0;g<this.e.length;g++)v.has(this.e[g])&&(this.e.splice(g,1),g--);for(const g of l)this.d.push(g);for(const g of c)this.e.push(g);return this.f=null,o}containsExtension(o){for(const t of this.e)if(N.$Rm.equals(t,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const l=R.$nG.readActivationEvents(t);for(const r of l)o.add(r)}return o}}e.$GG=A;function P(u){const o=new N.$Tm;for(const t of u)o.set(t.identifier,t);return o}function p(u,o){return u.enabledApiProposals?u.enabledApiProposals.includes(o):!1}function y(u,o){if(!p(u,o))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}class w{constructor(o,t,l,r){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=l,this.activationReason=r}}e.$JG=w;class h{constructor(o,t){this.description=o,this.value=t}}e.$KG=h;var f;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function a(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,O.$zp)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation,targetPlatform:u.targetPlatform,validations:[],isValid:!0}}function n(u,o){return{identifier:new N.$Rm((0,O.$xp)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!o,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid,targetPlatform:u.targetPlatform,publisherDisplayName:u.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None,this.onWillStop=d.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$NG=i}),define(ke[310],Se([1,0,13,149,25,26,11,7]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Rlc=e.$Qlc=e.$Plc=e.$Olc=e.$Nlc=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(a,n,i,u){this.startup=a,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=u}}e.$Nlc=m;class E{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,n){return a===-1||n===-1?-1:n-a}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Olc=E;class A{constructor(a,n,i,u,o,t){this.activationFailed=a,this.activationFailedError=n,this.activationTimes=i,this.module=u,this.exports=o,this.subscriptions=t}}e.$Plc=A;class P extends A{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Qlc=P;class p extends A{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Rlc=p;class y extends A{constructor(a){super(!0,a,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(a,n,i,u){this.g=u,this.a=a,this.b=n,this.c=i,this.d=new O.$Tm,this.f=Object.create(null)}dispose(){for(const[a,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const a=[];for(const[n,i]of this.d)a.push(i.wait());await Promise.all(a)}isActivated(a){const n=this.d.get(a);return!!(n&&n.value)}getActivatedExtension(a){const n=this.d.get(a);if(!n||!n.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return n.value}async activateByEvent(a,n){if(this.f[a])return;const i=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(i.map(u=>({id:u.identifier,reason:{startup:n,extensionId:u.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,n){const i=this.a.getExtensionDescription(a);if(!i)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(a){const n=a.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const n=this.a.getExtensionDescription(a.id);if(!n){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new y(o));return this.c.onExtensionActivationError(a.id,o,new R.$FG(a.id.value)),t}const i=[],u=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const o of u){if(this.m(o))continue;const t=this.d.get(o);if(t){i.push(t);continue}if(this.l(o)){i.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const l=this.a.getExtensionDescription(o);if(l){if(!l.main&&!l.browser)continue;i.push(this.j({id:l.identifier,reason:a.reason}));continue}const r=n.displayName||n.identifier.value,c=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${o}'`),s=this.k(a,n.displayName,[],new y(c));return this.c.onExtensionActivationError(n.identifier,c,new R.$FG(o)),s}return this.k(a,n.displayName,i,null)}k(a,n,i,u){const o=new h(a.id,n,a.reason,i,u,this.c,this.g);return this.d.set(a.id,o),o}l(a){return L.$L_b.isHostExtension(a,this.a,this.b)}m(a){const n=this.b.getExtensionDescription(a);return n?!n.main&&!n.browser:!1}};e.$Slc=w,e.$Slc=w=Ke([We(3,N.$3j)],w);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,n,i,u,o,t,l){this.c=a,this.d=n,this.f=i,this.g=u,this.h=o,this.j=t,this.k=l,this.a=new b.$vh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const n=this.g[a];if(n.value&&!n.value.activationFailed){this.g.splice(a,1),a--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new y(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const n=new Error;if(a&&a.name&&(n.name=a.name),a&&a.message?n.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(n.stack=a.stack),this.h=new y(n),this.b&&d.$4(a))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};h=Ke([We(6,N.$3j)],h)}),define(ke[311],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[312],Se([1,0,248,13,41,138,110,36,25,311,108,140]),function(le,e,d,L,O,R,N,b,m,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=void 0;const p=b.$co.as(N.$do.JSONContribution);class y{constructor(o,t,l){this.a=o,this.b=t,this.c=l}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(O.default.Error,o)}warn(o){this.d(O.default.Warning,o)}info(o){this.d(O.default.Info,o)}}e.$wG=y;class w{static a(o){const t=new m.$Sm;for(let l=0,r=o.length;l<r;l++)t.add(o[l].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new w(t,[]);if(!t||!t.length)return new w([],o);const l=this.a(o),r=this.a(t),c=t.filter(v=>!l.has(v.description.identifier)),s=o.filter(v=>!r.has(v.description.identifier));return new w(c,s)}constructor(o,t){this.added=o,this.removed=t}}e.$xG=w;class h{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=w.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,L.$1)(o)}}}e.$yG=h;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[d.localize(0,null),d.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$zG={properties:{engines:{type:"object",description:d.localize(2,null),properties:{vscode:{type:"string",description:d.localize(3,null),default:"^1.22.0"}}},publisher:{description:d.localize(4,null),type:"string"},displayName:{description:d.localize(5,null),type:"string"},categories:{description:d.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Qm},{type:"string",const:"Languages",deprecationMessage:d.localize(7,null)}]}},galleryBanner:{type:"object",description:d.localize(8,null),properties:{color:{description:d.localize(9,null),type:"string"},theme:{description:d.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:d.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:d.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:d.localize(13,null)},enabledApiProposals:{markdownDescription:d.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:d.localize(15,null),type:"string",enum:["none"],enumDescriptions:[d.localize(16,null)]},activationEvents:{description:d.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:d.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:d.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:d.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:d.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:d.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:d.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:d.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:d.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:d.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:d.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:d.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:d.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:d.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:d.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:d.localize(32,null)},{label:"onUri",body:"onUri",description:d.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:d.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:d.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:d.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:d.localize(37,null)},{label:"onRenderer",description:d.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:d.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:d.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:d.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:d.localize(42,null)},{label:"*",description:d.localize(43,null),body:"*"}]}},badges:{type:"array",description:d.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:d.localize(45,null)},href:{type:"string",description:d.localize(46,null)},description:{type:"string",description:d.localize(47,null)}}}},markdown:{type:"string",description:d.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:d.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:d.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$To}},extensionPack:{description:d.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$To}},extensionKind:{description:d.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:d.localize(53,null)},{body:["workspace"],description:d.localize(54,null)},{body:["ui","workspace"],description:d.localize(55,null)},{body:["workspace","ui"],description:d.localize(56,null)},{body:[],description:d.localize(57,null)}]},capabilities:{description:d.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:d.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:d.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[d.localize(61,null),d.localize(62,null),d.localize(63,null)]},description:{type:"string",markdownDescription:d.localize(64,null)}}},untrustedWorkspaces:{description:d.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:d.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[d.localize(67,null),d.localize(68,null),d.localize(69,null)]},restrictedConfigurations:{description:d.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:d.localize(71,null)}}}}},sponsor:{description:d.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:d.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:d.localize(74,null),type:"string"},"vscode:uninstall":{description:d.localize(75,null),type:"string"}}},icon:{type:"string",description:d.localize(76,null)},l10n:{type:"string",description:d.localize(77,null)},pricing:{type:"string",markdownDescription:d.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new h(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&P.$nG.register(o.extensionPoint,o.activationEventsGenerator),e.$zG.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,p.registerSchema(a,e.$zG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$AG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$co.add(i.ExtensionsRegistry,new n),e.$BG=b.$co.as(i.ExtensionsRegistry),p.registerSchema(a,e.$zG),p.registerSchema(A.$kk,{properties:{extensionEnabledApiProposals:{description:d.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(ke[313],Se([1,0,244,18,24,312,38,4]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8H=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:d.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:d.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:d.localize(2,null),default:""}}};var E;(function(p){function y(w,h,f){if(!w)return;const a=L.$9f(w.type)?w.type:void 0;if(!a||a.length===0){f.error(d.localize(3,null));return}const n=[];if(Array.isArray(w.required))for(const i of w.required)L.$9f(i)&&n.push(i);return{extensionId:h.value,taskType:a,required:n,properties:w.properties?O.$3n(w.properties):{},when:w.when?N.$uj.deserialize(w.when):void 0}}p.from=y})(E||(E={}));const A=R.$BG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,y)=>{for(const w of p)w.type&&y.push(`onTaskType:${w.type}`)},jsonSchema:{description:d.localize(4,null),type:"array",items:m}});class P{constructor(){this.d=new b.$ee,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,w)=>{A.setHandler((h,f)=>{this.c=void 0;try{for(const a of f.removed){const n=a.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const a of f.added){const n=a.value;for(const i of n){const u=E.from(i,a.description.identifier,a.collector);u&&(this.a[u.taskType]=u)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const w of this.all()){const h={type:"object",additionalProperties:!1};w.required.length>0&&(h.required=w.required.slice(0)),w.properties!==void 0?h.properties=O.$3n(w.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[w.taskType]},y.push(h)}this.c={oneOf:y}}return this.c}}e.$8H=new P}),define(ke[314],Se([1,0,245,18,23,24,38,313]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$fI=e.JsonSchemaVersion=e.ExecutionEngine=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$_H=e.ShellQuoting=e.$$H=e.$0H=e.$9H=void 0,e.$9H="settings",e.$0H=new N.$Nj("taskRunning",!1,d.localize(0,null)),e.$$H=d.localize2(2,"Tasks");var m;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$_H="$customized",function(M){function T(U){if(!U)return M.Strong;switch(U.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=T}(m||(e.ShellQuoting=m={}));var E;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var A;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(A||(e.RevealKind=A={})),function(M){function T(U){switch(U.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=T}(A||(e.RevealKind=A={}));var P;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(M){function T(U){switch(U.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=T}(P||(e.RevealProblemKind=P={}));var p;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(p||(e.PanelKind=p={})),function(M){function T(U){switch(U.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=T}(p||(e.PanelKind=p={}));var y;(function(M){M.defaults={echo:!0,reveal:A.Always,revealProblems:P.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var w;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(w||(e.RuntimeType=w={})),function(M){function T(Z){switch(Z.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=T;function U(Z){switch(Z){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=U}(w||(e.RuntimeType=w={}));var h;(function(M){function T(U){return L.$9f(U)?U:U.value}M.value=T})(h||(e.CommandString=h={}));var f;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function T(Z){return Z===M.Clean._id||Z===M.Build._id||Z===M.Rebuild._id||Z===M.Test._id}M.is=T;function U(Z){if(Z!==void 0)return L.$9f(Z)?T(Z)?{_id:Z,isDefault:!1}:void 0:Z}M.from=U})(f||(e.TaskGroup=f={}));var a;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var n;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function T(U){switch(U){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=T})(n||(e.TaskSourceKind=n={}));var i;(function(M){M.parallel="parallel",M.sequence="sequence"})(i||(e.DependsOrder=i={}));var u;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(u||(e.RunOnOptions=u={}));var o;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:u.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(T,U,Z,te,q,K){this._label="",this._id=T,U&&(this._label=U),Z&&(this.type=Z),this.runOptions=te,this.configurationProperties=q,this._source=K}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,U=!1){if(T===void 0)return!1;if(L.$9f(T))return T===this._label||T===this.configurationProperties.identifier||U&&T===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$aI=t;class l extends t{constructor(T,U,Z,te,q,K,Y,ie){super(T,Z,void 0,Y,ie,U),this.command={},this._source=U,this.hasDefinedMatchers=K,q&&(this.command=q)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case w.Shell:U="shell";break;case w.Process:U="process";break;case w.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(T){return T instanceof l}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$9H:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let U=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(U+=this._source.kind);const Z={type:e.$_H,folder:T,id:U};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?O.$7g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new l(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$bI=l;class r extends t{constructor(T,U,Z,te,q,K,Y){super(T,Z,te,K,Y,U),this._source=U,this.configures=q}static is(T){return T instanceof r}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?O.$7g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$9H:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let U=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(U+=this._source.kind);const Z={type:e.$_H,folder:T,id:U};return JSON.stringify(Z)}}e.$cI=r;class c extends t{constructor(T,U,Z,te,q,K,Y,ie,$e){super(T,Z,te,ie,$e,U),this.defines=q,this.hasDefinedMatchers=Y,this.command=K,this.icon=$e.icon,this.hide=$e.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof c}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new c(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$dI=c;class s extends t{constructor(T,U,Z,te,q,K){super(T,Z,te,q,K,U),this._source=U}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new s(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$eI=s;var v;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(v||(e.ExecutionEngine=v={})),function(M){M._default=M.Terminal}(v||(e.ExecutionEngine=v={}));var g;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(g||(e.JsonSchemaVersion=g={}));class D{constructor(T){this.c=new Map;for(let U=0;U<T.length;U++)this.c.set(T[U].uri.toString(),U)}compare(T,U){const Z=T.getWorkspaceFolder(),te=U.getWorkspaceFolder();if(Z&&te){let q=this.c.get(Z.uri.toString());q=q===void 0?0:q+1;let K=this.c.get(te.uri.toString());return K=K===void 0?0:K+1,q===K?T._label.localeCompare(U._label):q-K}else return!Z&&te?-1:Z&&!te?1:0}}e.$fI=D;var $;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})($||(e.TaskEventKind=$={}));var k;(function(M){M.SingleRun="singleRun",M.Background="background"})(k||(e.TaskRunType=k={}));var S;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var C;(function(M){function T(ie){return{taskId:ie._id,taskName:ie.configurationProperties.name,runType:ie.configurationProperties.isBackground?"background":"singleRun",group:ie.configurationProperties.group,__task:ie}}function U(ie,$e,ue){return{...T(ie),kind:"start",terminalId:$e,resolvedVariables:ue}}M.start=U;function Z(ie,$e,ue){return{...T(ie),kind:"processStarted",terminalId:$e,processId:ue}}M.processStarted=Z;function te(ie,$e,ue){return{...T(ie),kind:"processEnded",terminalId:$e,exitCode:ue}}M.processEnded=te;function q(ie,$e,ue){return{...T(ie),kind:"terminated",exitReason:ue,terminalId:$e}}M.terminated=q;function K(ie,$e,ue){return{...T($e),kind:ie,terminalId:ue}}M.general=K;function Y(){return{kind:"changed"}}M.changed=Y})(C||(e.TaskEvent=C={}));var I;(function(M){function T(Z){const te=Object.keys(Z).sort();let q="";for(const K of te){let Y=Z[K];Y instanceof Object?Y=T(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),q+=K+","+Y+","}return q}function U(Z){const q={_key:T(Z),type:Z.taskType};return Object.assign(q,Z),q}M.create=U})(I||(e.KeyedTaskIdentifier=I={}));var F;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var j;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(M){function T(U,Z){const te=b.$8H.get(U.type);if(te===void 0){const ie=R.$3n(U);return delete ie._key,I.create(ie)}const q=Object.create(null);q.type=te.taskType;const K=new Set;te.required.forEach(ie=>K.add(ie));const Y=te.properties;for(const ie of Object.keys(Y)){const $e=U[ie];if($e!=null)q[ie]=$e;else if(K.has(ie)){const ue=Y[ie];if(ue.default!==void 0)q[ie]=R.$3n(ue.default);else switch(ue.type){case"boolean":q[ie]=!1;break;case"number":case"integer":q[ie]=0;break;case"string":q[ie]="";break;default:Z.error(d.localize(1,null,JSON.stringify(U,void 0,0),ie));return}}}return I.create(q)}M.createTaskIdentifier=T})(z||(e.TaskDefinition=z={}))}),define(ke[315],Se([1,0,13]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=e.$P_b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((N,b)=>{this.b=N,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(N){this.f||this.h||(this.f=!0,this.g=N,this.a&&this.b(N))}resolveErr(N){this.f||this.h||(this.h=!0,this.i=N,this.a?this.d(N):(0,d.$1)(N))}then(N,b){return this.j().then(N,b)}catch(N){return this.j().then(void 0,N)}finally(N){return this.j().finally(N)}}e.$P_b=L;class O extends L{constructor(){super(),this.h=!0,this.i=new d.$5}}e.$Q_b=O}),define(ke[48],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vw=e.$sw=void 0,e.$tw=O,e.$uw=R;class d{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++d.count}}e.$sw=d;const L=[];function O(b){const m=new d(b);return L[m.nid]=m,m}function R(b){return L[b].sid}class N{constructor(m){this.value=m}}e.$vw=N}),define(ke[6],Se([1,0,48]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$2M=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var O;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput",h[h.ChatEditorInput=10]="ChatEditorInput",h[h.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(O||(e.TabInputKind=O={}));var R;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var N;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(N||(e.WebviewEditorCapabilities=N={}));var b;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var m;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var E;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var A;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class P{static{this.a=0}static mixin(f){return f._id=P.a++,f}}e.$2M=P;var p;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var y;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var w;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$3M={MainThreadAuthentication:(0,d.$tw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,d.$tw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,d.$tw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,d.$tw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,d.$tw)("MainThreadChatVariables"),MainThreadClipboard:(0,d.$tw)("MainThreadClipboard"),MainThreadCommands:(0,d.$tw)("MainThreadCommands"),MainThreadComments:(0,d.$tw)("MainThreadComments"),MainThreadConfiguration:(0,d.$tw)("MainThreadConfiguration"),MainThreadConsole:(0,d.$tw)("MainThreadConsole"),MainThreadDebugService:(0,d.$tw)("MainThreadDebugService"),MainThreadDecorations:(0,d.$tw)("MainThreadDecorations"),MainThreadDiagnostics:(0,d.$tw)("MainThreadDiagnostics"),MainThreadDialogs:(0,d.$tw)("MainThreadDiaglogs"),MainThreadDocuments:(0,d.$tw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,d.$tw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,d.$tw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,d.$tw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,d.$tw)("MainThreadEditorTabs"),MainThreadErrors:(0,d.$tw)("MainThreadErrors"),MainThreadTreeViews:(0,d.$tw)("MainThreadTreeViews"),MainThreadDownloadService:(0,d.$tw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,d.$tw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,d.$tw)("MainThreadLanguages"),MainThreadLogger:(0,d.$tw)("MainThreadLogger"),MainThreadMessageService:(0,d.$tw)("MainThreadMessageService"),MainThreadOutputService:(0,d.$tw)("MainThreadOutputService"),MainThreadProgress:(0,d.$tw)("MainThreadProgress"),MainThreadQuickDiff:(0,d.$tw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,d.$tw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,d.$tw)("MainThreadStatusBar"),MainThreadSecretState:(0,d.$tw)("MainThreadSecretState"),MainThreadStorage:(0,d.$tw)("MainThreadStorage"),MainThreadSpeech:(0,d.$tw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,d.$tw)("MainThreadTelemetry"),MainThreadTerminalService:(0,d.$tw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,d.$tw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,d.$tw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,d.$tw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,d.$tw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,d.$tw)("MainThreadCustomEditors"),MainThreadUrls:(0,d.$tw)("MainThreadUrls"),MainThreadUriOpeners:(0,d.$tw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,d.$tw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,d.$tw)("MainThreadWorkspace"),MainThreadFileSystem:(0,d.$tw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,d.$tw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,d.$tw)("MainThreadExtensionService"),MainThreadSCM:(0,d.$tw)("MainThreadSCM"),MainThreadSearch:(0,d.$tw)("MainThreadSearch"),MainThreadShare:(0,d.$tw)("MainThreadShare"),MainThreadTask:(0,d.$tw)("MainThreadTask"),MainThreadWindow:(0,d.$tw)("MainThreadWindow"),MainThreadLabelService:(0,d.$tw)("MainThreadLabelService"),MainThreadNotebook:(0,d.$tw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,d.$tw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,d.$tw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,d.$tw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,d.$tw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,d.$tw)("MainThreadInteractive"),MainThreadInlineChat:(0,d.$tw)("MainThreadInlineChatShape"),MainThreadTheming:(0,d.$tw)("MainThreadTheming"),MainThreadTunnelService:(0,d.$tw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,d.$tw)("MainThreadManagedSockets"),MainThreadTimeline:(0,d.$tw)("MainThreadTimeline"),MainThreadTesting:(0,d.$tw)("MainThreadTesting"),MainThreadLocalization:(0,d.$tw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,d.$tw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,d.$tw)("MainThreadAiEmbeddingVector")},e.$4M={ExtHostCommands:(0,d.$tw)("ExtHostCommands"),ExtHostConfiguration:(0,d.$tw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,d.$tw)("ExtHostDiagnostics"),ExtHostDebugService:(0,d.$tw)("ExtHostDebugService"),ExtHostDecorations:(0,d.$tw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,d.$tw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,d.$tw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,d.$tw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,d.$tw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,d.$tw)("ExtHostEditors"),ExtHostTreeViews:(0,d.$tw)("ExtHostTreeViews"),ExtHostFileSystem:(0,d.$tw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,d.$tw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,d.$tw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,d.$tw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,d.$tw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,d.$tw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,d.$tw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,d.$tw)("ExtHostStatusBar"),ExtHostShare:(0,d.$tw)("ExtHostShare"),ExtHostExtensionService:(0,d.$tw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,d.$tw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,d.$tw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,d.$tw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,d.$tw)("ExtHostSCM"),ExtHostSearch:(0,d.$tw)("ExtHostSearch"),ExtHostTask:(0,d.$tw)("ExtHostTask"),ExtHostWorkspace:(0,d.$tw)("ExtHostWorkspace"),ExtHostWindow:(0,d.$tw)("ExtHostWindow"),ExtHostWebviews:(0,d.$tw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,d.$tw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,d.$tw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,d.$tw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,d.$tw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,d.$tw)("ExtHostEditorTabs"),ExtHostProgress:(0,d.$tw)("ExtHostProgress"),ExtHostComments:(0,d.$tw)("ExtHostComments"),ExtHostSecretState:(0,d.$tw)("ExtHostSecretState"),ExtHostStorage:(0,d.$tw)("ExtHostStorage"),ExtHostUrls:(0,d.$tw)("ExtHostUrls"),ExtHostUriOpeners:(0,d.$tw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,d.$tw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,d.$tw)("ExtHostOutputService"),ExtHostLabelService:(0,d.$tw)("ExtHostLabelService"),ExtHostNotebook:(0,d.$tw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,d.$tw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,d.$tw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,d.$tw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,d.$tw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,d.$tw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,d.$tw)("ExtHostInteractive"),ExtHostInlineChat:(0,d.$tw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,d.$tw)("ExtHostChatAgents"),ExtHostChatVariables:(0,d.$tw)("ExtHostChatVariables"),ExtHostChatProvider:(0,d.$tw)("ExtHostChatProvider"),ExtHostSpeech:(0,d.$tw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,d.$tw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,d.$tw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,d.$tw)("ExtHostTheming"),ExtHostTunnelService:(0,d.$tw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,d.$tw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,d.$tw)("ExtHostAuthentication"),ExtHostTimeline:(0,d.$tw)("ExtHostTimeline"),ExtHostTesting:(0,d.$tw)("ExtHostTesting"),ExtHostTelemetry:(0,d.$tw)("ExtHostTelemetry"),ExtHostLocalization:(0,d.$tw)("ExtHostLocalization")}}),define(ke[91],Se([1,0,5,11,6,20]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=e.$blc=e.$alc=void 0,e.$alc=(0,d.$wi)("IExtHostApiDeprecationService");let N=class{constructor(m,E){this.c=E,this.a=new Set,this.b=m.getProxy(O.$3M.MainThreadTelemetry)}report(m,E,A){const P=this.d(m,E);this.a.has(P)||(this.a.add(P),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:m}))}d(m,E){return`${m}-${E.identifier.value}`}};e.$blc=N,e.$blc=N=Ke([We(0,R.$qP),We(1,L.$3j)],N),e.$clc=Object.freeze(new class{report(b,m,E){}})}),define(ke[316],Se([1,0,6]),function(le,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=void 0;class L{constructor(R){const N=R.getProxy(d.$3M.MainThreadClipboard);this.value=Object.freeze({readText(){return N.$readText()},writeText(b){return N.$writeText(b)}})}}e.$plc=L}),define(ke[317],Se([1,0,24,6,28,20]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0;let N=class{constructor(A,P){this.a=A.getProxy(L.$3M.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,P){const p=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){p.e(A,P,y,arguments)}})}e(A,P,p,y){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:m(y,this.b)}),this.c&&this.f(A,p,y)}};e.$jnc=N,e.$jnc=N=Ke([We(0,R.$qP),We(1,O.$GP)],N);const b=1e5;function m(E,A){const P=[];if(E.length)for(let p=0;p<E.length;p++){let y=E[p];if(typeof y>"u")y="undefined";else if(y instanceof Error){const w=y;w.stack?y=w.stack:y=w.toString()}P.push(y)}if(A){const p=new Error().stack;p&&P.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,d.$8n)(P);return p.length>b?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(ke[318],Se([1,0,2,6,26]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class R{constructor(b){this.a=b.getProxy(L.$3M.MainThreadDialogs)}showOpenDialog(b,m){return m?.allowUIResources&&(0,O.$IG)(b,"showLocal"),this.a.$showOpenDialog(m).then(E=>E?E.map(A=>d.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(m=>m?d.URI.revive(m):void 0)}}e.$mmc=R}),define(ke[319],Se([1,0,3,6]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=void 0;class O{constructor(N){this.b=0,this.a=N.getProxy(L.$3M.MainThreadLabelService)}$registerResourceLabelFormatter(N){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,N),(0,d.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Gmc=O}),define(ke[116],Se([1,0,12,14,2,5,11,6,28,20]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=e.$7lc=void 0;let A=class{constructor(p,y,w){this.f=w,this.d=new Map,this.a=y.getProxy(b.$3M.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===d.$g}getMessage(p,y){const{message:w,args:h,comment:f}=y;if(this.c)return(0,L.$0e)(w,h??{});let a=w;f&&f.length>0&&(a+=`/${Array.isArray(f)?f.join(""):f}`);const n=this.d.get(p)?.contents[a];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,L.$0e)(n??w,h??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let y;const w=await this.g(p);if(!w){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(w),f=JSON.parse(h);y=p.isBuiltin?f.contents?.bundle:f}catch(h){this.f.error(`Failed to load translations for ${p.identifier.value} from ${w}: ${h.message}`);return}y&&this.d.set(p.identifier.value,{contents:y,uri:w})}async g(p){if(p.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return O.URI.revive(y)}return p.l10n?O.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$7lc=A,e.$7lc=A=Ke([We(0,m.$GP),We(1,E.$qP),We(2,N.$3j)],A),e.$8lc=(0,R.$wi)("IExtHostLocalizationService")}),define(ke[150],Se([1,0,11,6,28,20,2,58]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;let m=class extends d.$bk{constructor(P,p){super(p.logLevel,p.logsLocation,p.loggers.map(y=>(0,b.$6h)(y))),this.r=P.getProxy(L.$3M.MainThreadLogger)}$setLogLevel(P,p){p?this.setLogLevel(N.URI.revive(p),P):this.setLogLevel(P)}setVisibility(P,p){super.setVisibility(P,p),this.r.$setVisibility(P,p)}s(P,p,y){return new E(this.r,P,p,y)}};e.$inc=m,e.$inc=m=Ke([We(0,R.$qP),We(1,O.$GP)],m);class E extends d.$9j{constructor(P,p,y,w){super(w?.logLevel==="always"),this.r=P,this.s=p,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(p,w).then(()=>{this.u(this.n),this.m=!0})}g(P,p){const y=[[P,p]];this.m?this.u(y):this.n.push(...y)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[117],Se([1,0,6,5,3,20,21]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=e.$9lc=void 0,e.$9lc=(0,L.$wi)("IExtHostManagedSockets");let b=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(d.$3M.MainThreadManagedSockets)}setFactory(P,p){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(P,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const p=++this.b,y=await this.c.makeConnection(),w=new O.$Uc;return this.d.set(p,new E(p,y,w)),w.add((0,O.$Tc)(()=>this.d.delete(p))),w.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),w.dispose()})),w.add(y.onDidClose(h=>{this.a.$onDidManagedSocketClose(p,h?.stack??h?.message),w.dispose()})),w.add(y.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData(p,N.$Ge.wrap(h)))),p}$remoteSocketWrite(P,p){this.d.get(P)?.actual.send(p.buffer)}$remoteSocketEnd(P){const p=this.d.get(P);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$0lc=b,e.$0lc=b=Ke([We(0,R.$qP)],b);class m{constructor(P,p){this.socketFactoryId=P,this.makeConnection=p}}class E extends O.$Vc{constructor(P,p,y){super(),this.socketId=P,this.actual=p,this.B(y)}}}),define(ke[320],Se([1,0,6,11,26]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;function R(b){return b&&b.title}let N=class{constructor(m,E){this.b=E,this.a=m.getProxy(d.$3M.MainThreadMessageService)}showMessage(m,E,A,P,p){const y={source:{identifier:m.identifier,label:m.displayName||m.name}};let w;typeof P=="string"||R(P)?w=[P,...p]:(y.modal=P?.modal,y.useCustom=P?.useCustom,y.detail=P?.detail,w=p),y.useCustom&&(0,O.$IG)(m,"resolvers");const h=[];let f=!1;for(let a=0;a<w.length;a++){const n=w[a];if(typeof n=="string")h.push({title:n,handle:a,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:u}=n;h.push({title:i,isCloseAffordance:!!u,handle:a}),u&&(f?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,n):f=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,A,y,h).then(a=>{if(typeof a=="number")return w[a]})}};e.$Imc=N,e.$Imc=N=Ke([We(1,L.$3j)],N)}),define(ke[321],Se([1,0,3,18,2,26,6]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;class b{constructor(E){this.b=new Map,this.a=E.getProxy(N.$3M.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,A,P){if((0,R.$IG)(E,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,P),this.a.$registerProfileContentHandler(A,P.name,P.description,E.identifier.value),(0,d.$Tc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(E,A,P,p){const y=this.b.get(E);if(!y)throw new Error(`Unknown handler with id: ${E}`);return y.saveProfile(A,P,p)}async $readProfile(E,A,P){const p=this.b.get(E);if(!p)throw new Error(`Unknown handler with id: ${E}`);return p.readProfile((0,L.$9f)(A)?A:O.URI.revive(A),P)}}e.$Rmc=b}),define(ke[118],Se([1,0,6,4,5]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=e.$4lc=void 0;class R{constructor(b){this.b=new L.$ee,this.onDidChangePassword=this.b.event,this.a=b.getProxy(d.$3M.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,m){return this.a.$getPassword(b,m)}store(b,m,E){return this.a.$setPassword(b,m,E)}delete(b,m){return this.a.$deletePassword(b,m)}}e.$4lc=R,e.$5lc=(0,O.$wi)("IExtHostSecretState")}),define(ke[322],Se([1,0,22,3,6]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;class R{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(O.$3M.MainThreadSpeech)}async $createSpeechToTextSession(b,m,E){const A=this.c.get(b);if(!A)return;const P=new L.$Uc,p=new d.$pe;this.d.set(m,p);const y=P.add(A.provideSpeechToTextSession(p.token,E?{language:E}:void 0));P.add(y.onDidChange(w=>{p.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,w)})),P.add(p.token.onCancellationRequested(()=>P.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createKeywordRecognitionSession(b,m){const E=this.c.get(b);if(!E)return;const A=new L.$Uc,P=new d.$pe;this.d.set(m,P);const p=A.add(E.provideKeywordRecognitionSession(P.token));A.add(p.onDidChange(y=>{P.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,y)})),A.add(P.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,m,E){const A=R.a++;return this.c.set(A,E),this.b.$registerProvider(A,m,{extension:b,displayName:b.value}),(0,L.$Tc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Ymc=R}),define(ke[119],Se([1,0,6,4,5]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0;class R{constructor(b,m){this.c=m,this.b=new L.$ee,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(d.$3M.MainThreadStorage)}registerExtensionStorageKeysToSync(b,m){this.a.$registerExtensionStorageKeysToSync(b,m)}async initializeExtensionStorage(b,m,E){const A=await this.a.$initializeExtensionStorage(b,m);let P;return A&&(P=this.d(b,m,A)),P||E}setValue(b,m,E){return this.a.$setValue(b,m,E)}$acceptValue(b,m,E){const A=this.d(b,m,E);A&&this.b.fire({shared:b,key:m,value:A})}d(b,m,E){try{return JSON.parse(E)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${b}): ${A}`)}}}e.$Tlc=R,e.$Ulc=(0,O.$wi)("IExtHostStorage")}),define(ke[323],Se([1,0,3,15,2,6]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0;class N{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(R.$3M.MainThreadUriOpeners)}registerExternalUriOpener(m,E,A,P){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const p=P.schemes.find(y=>!N.a.has(y));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(E,A),this.b.$registerUriOpener(E,P.schemes,m,P.label),(0,d.$Tc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(m,E,A){const P=this.c.get(m);if(!P)throw new Error(`Unknown opener with id: ${m}`);const p=O.URI.revive(E);return P.canOpenExternalUri(p,A)}async $openUri(m,E,A){const P=this.c.get(m);if(!P)throw new Error(`Unknown opener id: '${m}'`);return P.openExternalUri(O.URI.revive(E.resolvedUri),{sourceUri:O.URI.revive(E.sourceUri)},A)}}e.$cnc=N}),define(ke[324],Se([1,0,6,2,3,13,25]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=void 0;class b{static{this.a=0}constructor(E){this.c=new N.$Sm,this.d=new Map,this.b=E.getProxy(d.$3M.MainThreadUrls)}registerUriHandler(E,A){const P=E.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const p=b.a++;return this.c.add(P),this.d.set(p,A),this.b.$registerUriHandler(p,P,E.displayName||E.name),(0,O.$Tc)(()=>{this.c.delete(P),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(E,A){const P=this.d.get(E);if(!P)return Promise.resolve(void 0);try{P.handleUri(L.URI.revive(A))}catch(p){(0,R.$1)(p)}return Promise.resolve(void 0)}async createAppUri(E){return L.URI.revive(await this.b.$createAppUri(E))}}e.$dnc=b}),define(ke[92],Se([1,0,4,3,15,24,2,252,290,114,6]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=e.$Elc=void 0,e.$Flc=p,e.$Hlc=h,e.$Ilc=f;class P{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;constructor(u,o,t,l,r,c,s){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new d.$ee,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new d.$ee,this._onDidDispose=this.#h.event,this.#e=u,this.#t=o,this.#o=t,this.#i=l,this.#s=r,this.#r=c,this.#l=p(c),this.#d=y(c),this.#n=s}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return this.#u=!0,(0,E.$OAb)(u,this.#i)}get cspSource(){const u=this.#r.extensionLocation;if(u.scheme===O.Schemas.https||u.scheme===O.Schemas.http){let o=u.toString();return o.endsWith("/")||(o+="/"),o+" "+E.$NAb}return E.$NAb}get html(){return this.a(),this.#a}set html(u){this.a(),this.#a!==u&&(this.#a=u,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(this.#u=!0,this.#n.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(u)))}get options(){return this.a(),this.#o}set options(u){this.a(),R.$7n(this.#o,u)||this.#t.$setOptions(this.#e,f(this.#r,this.#s,u)),this.#o=u}async postMessage(u){if(this.#c)return!1;const o=(0,m.$Arb)(u,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,o.message,...o.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(u){if(!this.#d)return u;const o=this.#r.extensionLocation?.scheme===O.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===O.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return u.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,r,c,s,v,g)=>{const D=N.URI.from({scheme:s||"file",path:decodeURIComponent(v)}),$=(0,E.$OAb)(D,{isRemote:o,authority:t}).toString();return`${r}${$}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,r,c,s,v,g)=>{const D=N.URI.from({scheme:s||"file",path:decodeURIComponent(v)}),$=(0,E.$OAb)(D,{isRemote:o,authority:t}).toString();return`${r}${$}${g}`})}}e.$Elc=P;function p(i){try{const u=(0,b.$Ip)((0,b.$Hp)(i.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}function y(i){try{const u=(0,b.$Ip)((0,b.$Hp)(i.engines.vscode));return u?u.majorBase<1||u.majorBase===1&&u.minorBase<60:!1}catch{return!1}}class w extends L.$Vc{constructor(u,o,t,l,r){super(),this.c=o,this.f=t,this.g=l,this.h=r,this.b=new Map,this.a=u.getProxy(A.$3M.MainThreadWebviews)}dispose(){super.dispose();for(const u of this.b.values())u.dispose();this.b.clear()}$onMessage(u,o,t){const l=this.j(u);if(l){const{message:r}=(0,m.$Brb)(o,t.value);l._onMessageEmitter.fire(r)}}$onMissingCsp(u,o){this.g.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,o,t){const l=new P(u,this.a,a(o),this.c,this.f,t,this.h);this.b.set(u,l);const r=l._onDidDispose(()=>{r.dispose(),this.deleteWebview(u)});return l}deleteWebview(u){this.b.delete(u)}j(u){return this.b.get(u)}}e.$Glc=w;function h(i){return{id:i.identifier,location:i.extensionLocation}}function f(i,u,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||n(i,u)}}function a(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(u=>N.URI.from(u))}}function n(i,u){return[...(u?.getWorkspaceFolders()||[]).map(o=>o.uri),i.extensionLocation]}}),define(ke[151],Se([1,0,4,15,14,2,5,20,6]),function(le,e,d,L,O,R,N,b,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=e.$fnc=void 0;let A=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const p=this.d;return{get focused(){return p.focused},get active(){return p.active}}}constructor(p){this.c=new d.$ee,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=p.getProxy(m.$3M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:w})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,y){y!==this.d[p]&&(this.d={...this.d,[p]:y},this.c.fire(this.d))}openUri(p,y){let w;if(typeof p=="string"){w=p;try{p=R.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,O.$8e)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,w,y)}async asExternalUri(p,y){if((0,O.$8e)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(p,y);return R.URI.from(w)}};e.$fnc=A,e.$fnc=A=E=Ke([We(0,b.$qP)],A),e.$gnc=(0,N.$wi)("IExtHostWindow")}),define(ke[325],Se([1,0,317,28,20]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=void 0;const R=1024*1024;let N=class extends d.$jnc{constructor(m,E){super(m,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(m,E,A){const P=m==="error"||m==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),E.apply(console,A),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(m,E){const A=process[m],P=A.write;let p="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(y,w,h)=>{if(!this.g){p+=y.toString(w);const f=p.length>R?p.length:p.lastIndexOf(`
`);f!==-1&&(console[E](p.slice(0,f)),p=p.slice(f+1))}P.call(A,y,w,h)}})}};e.$Unc=N,e.$Unc=N=Ke([We(0,O.$qP),We(1,L.$GP)],N)}),define(ke[326],Se([1,0,150,15,267,30]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=void 0;class N extends d.$inc{s(m,E,A){return m.scheme===L.Schemas.file?new O.$DQ(A?.name||(0,R.$Sg)(),m.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,E):super.s(m,E,A)}registerLogger(m){super.registerLogger(m),this.r.$registerLogger(m)}deregisterLogger(m){super.deregisterLogger(m),this.r.$deregisterLogger(m)}}e.$7nc=N}),define(ke[327],Se([1,0,7,21,22,13,4,3,134,315,48]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$R_b=f,e.$S_b=a;function p(S,C){try{return JSON.stringify(S,C)}catch{return"null"}}const y="$$ref$$",w={[y]:-1};class h{constructor(C,I){this.jsonString=C,this.referencedBuffers=I}}function f(S,C=null,I=!1){const F=[];return{jsonString:(I?p:JSON.stringify)(S,(z,M)=>{if(typeof M>"u")return w;if(typeof M=="object"){if(M instanceof L.$Ge){const T=F.push(M)-1;return{[y]:T}}if(C)return C(z,M)}return M}),referencedBuffers:F}}function a(S,C,I){return JSON.parse(S,(F,j)=>{if(j){const z=j[y];if(typeof z=="number")return C[z];if(I&&j.$mid===1)return I.transformIncoming(j)}return j})}function n(S,C){return JSON.stringify(S,C)}function i(S){return S?(C,I)=>I&&I.$mid===1?S.transformOutgoing(I):I:null}var u;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));var o;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},l=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class c extends b.$Vc{static{P=l}static{this.a=3*1e3}constructor(C,I=null,F=null){super(),this[P]=!0,this.b=this.B(new N.$ee),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=I,this.g=F,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,z=A.$sw.count;j<z;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new d.$Ih(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const I=this.w[C];delete this.w[C],I.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,m.$Bn)(C,this.g):C}getProxy(C){const{nid:I,sid:F}=C;return this.s[I]||(this.s[I]=this.J(I,F)),this.s[I]}J(C,I){const F={get:(j,z)=>(typeof z=="string"&&!j[z]&&z.charCodeAt(0)===36&&(j[z]=(...M)=>this.U(C,z,M)),z===r?I:j[z])};return new Proxy(Object.create(null),F)}set(C,I){return this.m[C.nid]=I,I}assertRegistered(C){for(let I=0,F=C.length;I<F;I++){const j=C[I];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(C){if(this.j)return;const I=C.byteLength,F=v.read(C,0),j=F.readUInt8(),z=F.readUInt32();switch(j){case 1:case 2:{let{rpcId:M,method:T,args:U}=D.deserializeRequestJSONArgs(F);this.g&&(U=(0,m.$Bn)(U,this.g)),this.M(I,z,M,T,U,j===2);break}case 3:case 4:{let{rpcId:M,method:T,args:U}=D.deserializeRequestMixedArgs(F);this.g&&(U=(0,m.$Bn)(U,this.g)),this.M(I,z,M,T,U,j===4);break}case 5:{this.f?.logIncoming(I,z,0,"ack"),this.G(z);break}case 6:{this.N(I,z);break}case 7:{this.O(I,z,void 0);break}case 9:{let M=D.deserializeReplyOKJSON(F);this.g&&(M=(0,m.$Bn)(M,this.g)),this.O(I,z,M);break}case 10:{const M=D.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(I,z,M);break}case 8:{const M=D.deserializeReplyOKVSBuffer(F);this.O(I,z,M);break}case 11:{let M=D.deserializeReplyErrError(F);this.g&&(M=(0,m.$Bn)(M,this.g)),this.P(I,z,M);break}case 12:{this.P(I,z,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,I,F,j,z,M){this.f?.logIncoming(C,I,1,`receiveRequest ${(0,A.$uw)(F)}.${j}(`,z);const T=String(I);let U,Z;if(M){const q=new O.$pe;z.push(q.token),U=this.Q(F,j,z),Z=()=>q.cancel()}else U=this.Q(F,j,z),Z=t;this.u[T]=Z;const te=D.serializeAcknowledged(I);this.f?.logOutgoing(te.byteLength,I,1,"ack"),this.c.send(te),U.then(q=>{delete this.u[T];const K=D.serializeReplyOK(I,q,this.h);this.f?.logOutgoing(K.byteLength,I,1,"reply:",q),this.c.send(K)},q=>{delete this.u[T];const K=D.serializeReplyErr(I,q);this.f?.logOutgoing(K.byteLength,I,1,"replyErr:",q),this.c.send(K)})}N(C,I){this.f?.logIncoming(C,I,1,"receiveCancel");const F=String(I);this.u[F]?.()}O(C,I,F){this.f?.logIncoming(C,I,0,"receiveReply:",F);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j],z.resolveOk(F)}P(C,I,F){this.f?.logIncoming(C,I,0,"receiveReplyErr:",F);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j];let M;F&&(F.$isError?(M=new Error,M.name=F.name,M.message=F.message,M.stack=F.stack):M=F),z.resolveErr(M)}Q(C,I,F){try{return Promise.resolve(this.S(C,I,F))}catch(j){return Promise.reject(j)}}S(C,I,F){const j=this.m[C];if(!j)throw new Error("Unknown actor "+(0,A.$uw)(C));const z=j[I];if(typeof z!="function")throw new Error("Unknown method "+I+" on actor "+(0,A.$uw)(C));return z.apply(j,F)}U(C,I,F){if(this.j)return new E.$Q_b;let j=null;if(F.length>0&&O.CancellationToken.isCancellationToken(F[F.length-1])&&(j=F.pop()),j&&j.isCancellationRequested)return Promise.reject(R.$6());const z=D.serializeRequestArguments(F,this.h),M=++this.t,T=String(M),U=new E.$P_b,Z=new b.$Uc;j&&Z.add(j.onCancellationRequested(()=>{const q=D.serializeCancel(M);this.f?.logOutgoing(q.byteLength,M,0,"cancel"),this.c.send(D.serializeCancel(M))})),this.w[T]=new s(U,Z),this.F(M);const te=D.serializeRequest(M,C,I,z,!!j);return this.f?.logOutgoing(te.byteLength,M,0,`request: ${(0,A.$uw)(C)}.${I}(`,F),this.c.send(te),U}}e.$T_b=c;class s{constructor(C,I){this.a=C,this.b=I}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class v{static alloc(C,I,F){const j=new v(L.$Ge.alloc(F+1+4),0);return j.writeUInt8(C),j.writeUInt32(I),j}static read(C,I){return new v(C,I)}get buffer(){return this.a}constructor(C,I){this.a=C,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+C).toString();return this.b+=C,F}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+C).toString();return this.b+=C,F}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+C);return this.b+=C,I}static sizeMixedArray(C){let I=0;I+=1;for(let F=0,j=C.length;F<j;F++){const z=C[F];switch(I+=1,z.type){case 1:I+=this.sizeLongString(z.value);break;case 2:I+=this.sizeVSBuffer(z.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(z.value);for(let M=0;M<z.buffers.length;++M)I+=this.sizeVSBuffer(z.buffers[M]);break;case 4:break}}return I}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let I=0,F=C.length;I<F;I++){const j=C[I];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let z=0;z<j.buffers.length;++z)this.writeBuffer(j.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const I=new Array(C);for(let F=0;F<C;F++)switch(this.readUInt8()){case 1:I[F]=this.readLongString();break;case 2:I[F]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),M=this.readLongString(),T=[];for(let U=0;U<z;++U)T.push(this.readVSBuffer());I[F]=new A.$vw(a(M,T,null));break}case 4:I[F]=void 0;break}return I}}var g;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(g||(g={}));class D{static a(C){for(let I=0,F=C.length;I<F;I++)if(C[I]instanceof L.$Ge||C[I]instanceof A.$vw||typeof C[I]>"u")return!0;return!1}static serializeRequestArguments(C,I){if(this.a(C)){const F=[];for(let j=0,z=C.length;j<z;j++){const M=C[j];if(M instanceof L.$Ge)F[j]={type:2,value:M};else if(typeof M>"u")F[j]={type:4};else if(M instanceof A.$vw){const{jsonString:T,referencedBuffers:U}=f(M.value,I);F[j]={type:3,value:L.$Ge.fromString(T),buffers:U}}else F[j]={type:1,value:L.$Ge.fromString(n(M,I))}}return{type:1,args:F}}return{type:0,args:n(C,I)}}static serializeRequest(C,I,F,j,z){switch(j.type){case 0:return this.b(C,I,F,j.args,z);case 1:return this.c(C,I,F,j.args,z)}}static b(C,I,F,j,z){const M=L.$Ge.fromString(F),T=L.$Ge.fromString(j);let U=0;U+=v.sizeUInt8(),U+=v.sizeShortString(M),U+=v.sizeLongString(T);const Z=v.alloc(z?2:1,C,U);return Z.writeUInt8(I),Z.writeShortString(M),Z.writeLongString(T),Z.buffer}static deserializeRequestJSONArgs(C){const I=C.readUInt8(),F=C.readShortString(),j=C.readLongString();return{rpcId:I,method:F,args:JSON.parse(j)}}static c(C,I,F,j,z){const M=L.$Ge.fromString(F);let T=0;T+=v.sizeUInt8(),T+=v.sizeShortString(M),T+=v.sizeMixedArray(j);const U=v.alloc(z?4:3,C,T);return U.writeUInt8(I),U.writeShortString(M),U.writeMixedArray(j),U.buffer}static deserializeRequestMixedArgs(C){const I=C.readUInt8(),F=C.readShortString(),j=C.readMixedArray(),z=new Array(j.length);for(let M=0,T=j.length;M<T;M++){const U=j[M];typeof U=="string"?z[M]=JSON.parse(U):z[M]=U}return{rpcId:I,method:F,args:z}}static serializeAcknowledged(C){return v.alloc(5,C,0).buffer}static serializeCancel(C){return v.alloc(6,C,0).buffer}static serializeReplyOK(C,I,F){if(typeof I>"u")return this.d(C);if(I instanceof L.$Ge)return this.e(C,I);if(I instanceof A.$vw){const{jsonString:j,referencedBuffers:z}=f(I.value,F,!0);return this.g(C,j,z)}else return this.f(C,p(I,F))}static d(C){return v.alloc(7,C,0).buffer}static e(C,I){let F=0;F+=v.sizeVSBuffer(I);const j=v.alloc(8,C,F);return j.writeVSBuffer(I),j.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,I){const F=L.$Ge.fromString(I);let j=0;j+=v.sizeLongString(F);const z=v.alloc(9,C,j);return z.writeLongString(F),z.buffer}static g(C,I,F){const j=L.$Ge.fromString(I);let z=0;z+=v.sizeUInt32,z+=v.sizeLongString(j);for(const T of F)z+=v.sizeVSBuffer(T);const M=v.alloc(10,C,z);M.writeUInt32(F.length),M.writeLongString(j);for(const T of F)M.writeBuffer(T);return M.buffer}static deserializeReplyOKJSON(C){const I=C.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(C,I){const F=C.readUInt32(),j=C.readLongString(),z=[];for(let M=0;M<F;++M)z.push(C.readVSBuffer());return new A.$vw(a(j,z,I))}static serializeReplyErr(C,I){const F=I?p(R.$3(I),null):void 0;if(typeof F!="string")return this.h(C);const j=L.$Ge.fromString(F);let z=0;z+=v.sizeLongString(j);const M=v.alloc(11,C,z);return M.writeLongString(j),M.buffer}static deserializeReplyErrError(C){const I=C.readLongString();return JSON.parse(I)}static h(C){return v.alloc(12,C,0).buffer}}var $;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var k;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(k||(k={}))}),define(ke[328],Se([1,0,21,27,15,85,5]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HK=e.$EK=void 0,e.$FK=A,e.$GK=P,e.$EK=(0,N.$wi)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${b.join("")}]+`),E=7;function A(y){if(y.scheme!==O.Schemas.vscodeNotebookCell)return;const w=y.fragment.indexOf("s");if(w<0)return;const h=parseInt(y.fragment.substring(0,w).replace(m,""),E),f=(0,d.$Ze)(y.fragment.substring(w+1)).toString();if(!isNaN(h))return{handle:h,notebook:y.with({scheme:f,fragment:null})}}function P(y,w){const h=w.toString(E),a=`${h.length<b.length?b[h.length-1]:"z"}${h}s${(0,d.$1e)(d.$Ge.fromString(y.scheme),!0,!0)}`;return y.with({scheme:O.Schemas.vscodeNotebookCell,fragment:a})}class p{constructor(){this.a=new L.$Bc}getNotebook(w){if(w.scheme===O.Schemas.vscodeNotebookCell){const h=A(w);if(h){const f=this.a.get(h.notebook);if(f)return f}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$HK=p,(0,R.$xs)(e.$EK,p,1)}),define(ke[120],Se([1,0,21,35,39,101,15,17,12,38,328]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.$YK=e.CellStatusbarAlignment=e.$XK=e.NotebookEditorPriority=e.$UK=e.$TK=e.$RK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$QK=e.$PK=e.$OK=e.$NK=e.CellKind=e.$MK=e.$LK=e.$KK=void 0,e.$SK=l,e.$VK=c,e.$WK=s,e.$ZK=D,e.$1K=k,e.$KK="workbench.editor.notebook",e.$LK="workbench.editor.notebookTextDiffEditor",e.$MK="workbench.editor.interactive";var P;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(P||(e.CellKind=P={})),e.$NK=["application/json","application/javascript","text/html","image/svg+xml",R.$Qs.latex,R.$Qs.markdown,"image/png","image/jpeg",R.$Qs.text],e.$OK=[R.$Qs.latex,R.$Qs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Qs.text],e.$PK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$QK="_notAvailable";var p;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var y;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(y||(e.NotebookCellExecutionState=y={}));var w;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var h;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(h||(e.NotebookRendererMatch=h={}));var f;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var a;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var n;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var u;(function(U){U.scheme=N.Schemas.vscodeNotebookCell;function Z($e,ue){return(0,A.$GK)($e,ue)}U.generate=Z;function te($e){return(0,A.$FK)($e)}U.parse=te;function q($e,ue){return $e.with({scheme:N.Schemas.vscodeNotebookCellOutput,fragment:`op${ue??""},${$e.scheme!==N.Schemas.file?$e.scheme:""}`})}U.generateCellOutputUri=q;function K($e){if($e.scheme!==N.Schemas.vscodeNotebookCellOutput)return;const ue=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!ue)return;const ve=ue[1]&&ue[1]!==""?ue[1]:void 0,_=ue[2];return{outputId:ve,notebook:$e.with({scheme:_||N.Schemas.file,fragment:null})}}U.parseCellOutputUri=K;function Y($e,ue,ve){return U.generate($e,ue).with({scheme:ve})}U.generateCellPropertyUri=Y;function ie($e,ue){if($e.scheme===ue)return U.parse($e.with({scheme:U.scheme}))}U.parseCellPropertyUri=ie})(u||(e.CellUri=u={}));const o=U=>m.$i?U.replace(/\//g,"\\"):U;class t{constructor(Z=[],te=e.$NK){this.e=te,this.d=[...new Set(Z)].map(q=>({pattern:q,matches:L.$qk(o(q))}))}sort(Z){const te=new Map(O.Iterable.map(Z,K=>[K,o(K)]));let q=[];for(const{matches:K}of this.d)for(const[Y,ie]of te)if(K(ie)){q.push(Y),te.delete(Y);break}return te.size&&(q=q.concat([...te.keys()].sort((K,Y)=>this.e.indexOf(K)-this.e.indexOf(Y)))),q}prioritize(Z,te){const q=this.f(Z);if(q===-1){this.d.unshift({pattern:Z,matches:L.$qk(o(Z))});return}const K=new Set(te.map(ie=>this.f(ie,q)));K.delete(-1);const Y=Array.from(K).sort();this.d.splice(q+1,0,...Y.map(ie=>this.d[ie]));for(let ie=Y.length-1;ie>=0;ie--)this.d.splice(Y[ie],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,te=this.d.length){const q=o(Z);for(let K=0;K<te;K++)if(this.d[K].matches(q))return K;return-1}}e.$RK=t;function l(U,Z,te,q=(K,Y)=>K===Y){const K=[];function Y(ue,ve,_){if(ve===0&&_.length===0)return;const B=K[K.length-1];B&&B.start+B.deleteCount===ue?(B.deleteCount+=ve,B.toInsert.push(..._)):K.push({start:ue,deleteCount:ve,toInsert:_})}let ie=0,$e=0;for(;;){if(ie===U.length){Y(ie,0,Z.slice($e));break}if($e===Z.length){Y(ie,U.length-ie,[]);break}const ue=U[ie],ve=Z[$e];if(q(ue,ve)){ie+=1,$e+=1;continue}te(ve)?(Y(ie,1,[]),ie+=1):(Y(ie,0,[ve]),$e+=1)}return K}e.$TK=new E.$Nj("notebookEditorCursorAtBoundary","none"),e.$UK=new E.$Nj("notebookEditorCursorAtLineBoundary","none");var r;(function(U){U.default="default",U.option="option"})(r||(e.NotebookEditorPriority=r={}));function c(U){const Z=U;return!!((typeof Z.include=="string"||L.$rk(Z.include))&&(typeof Z.exclude=="string"||L.$rk(Z.exclude)))}function s(U,Z,te){if(Array.isArray(U.viewType)&&U.viewType.indexOf(Z)>=0||U.viewType===Z)return!0;if(U.filenamePattern){const q=c(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,K=c(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(L.$pk(q,(0,b.$oc)(te.fsPath).toLowerCase()))return!(K&&L.$pk(K,(0,b.$oc)(te.fsPath).toLowerCase()))}return!1}e.$XK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var v;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class g{static{this.d="notebook/"}static create(Z){return`${g.d}${Z}`}static parse(Z){if(Z.startsWith(g.d))return Z.substring(g.d.length)}}e.$YK=g;function D(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}const $=new TextDecoder;function k(U){const Z=[];let te=!1;for(const ie of U)(Z.length===0||te)&&(Z.push(ie),te=!0);let q=I(Z);const K=d.$Ge.concat(Z.map(ie=>d.$Ge.wrap(ie))),Y=T(K);return q=q||Y.byteLength!==K.byteLength,{data:Y,didCompression:q}}e.$2K="\x1B[A";const S=e.$2K.split("").map(U=>U.charCodeAt(0)),C=10;function I(U){let Z=!1;return U.forEach((te,q)=>{if(q===0||te.length<e.$2K.length)return;const K=U[q-1],Y=te.subarray(0,e.$2K.length);if(Y[0]===S[0]&&Y[1]===S[1]&&Y[2]===S[2]){const ie=K.lastIndexOf(C);if(ie===-1)return;Z=!0,U[q-1]=K.subarray(0,ie),U[q]=te.subarray(e.$2K.length)}}),Z}function F(U){let Z=U;do U=Z,Z=U.replace(/[^\n]\x08/gm,"");while(Z.length<U.length);return U}function j(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const Z=U.match(/^(.*)\r+/m)[1];let te=U.match(/\r+(.*)$/m)[1];te=te+Z.slice(te.length,Z.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,te)}return U}const z=8,M=13;function T(U){return!U.buffer.includes(z)&&!U.buffer.includes(M)?U:d.$Ge.fromString(j(F($.decode(U.buffer))))}}),define(ke[8],Se([1,0,19,13,81,27,101,14,18,2,30,25,33,67,120]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w){"use strict";var h,f,a,n,i,u,o,t,l,r,c,s,v,g,D,$,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$eP=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$dP=e.$cP=e.$bP=e.$aP=e.ChatLocation=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$1O=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$NO=e.$MO=e.$LO=e.$KO=e.$IO=e.$HO=e.$GO=e.$FO=e.TestRunProfileKind=e.TestResultState=e.$EO=e.$DO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$CO=e.NotebookVariablesRequestKind=e.$BO=e.$AO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$zO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.ColorThemeKind=e.$tO=e.$sO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$rO=e.$qO=e.DebugConsoleMode=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$kO=e.$jO=e.FileChangeType=e.$iO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$hO=e.$gO=e.$fO=e.$eO=e.InlineCompletionTriggerKind=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$4N=e.ConfigurationTarget=e.$3N=e.$2N=e.$1N=e.$ZN=e.DocumentPasteTriggerKind=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$SN=e.ViewBadge=e.ProgressLocation=e.$RN=e.$QN=e.TaskScope=e.ShellQuoting=e.$PN=e.$ON=e.$NN=e.TaskPanelKind=e.TaskRevealKind=e.$MN=e.TerminalLocation=e.$LN=e.$KN=e.$JN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$IN=e.$HN=e.$GN=e.$FN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$DN=e.$CN=e.$BN=e.$AN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$zN=e.$yN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.LanguageStatusSeverity=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.CodeActionTriggerKind=e.$mN=e.$lN=e.SymbolTag=e.SymbolKind=e.$kN=e.$jN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.DiagnosticSeverity=e.DiagnosticTag=e.$dN=e.$cN=e.FileEditType=e.$bN=e.$aN=e.$_M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$EN=Rt,e.$5N=Te,e.$JO=vi;function S(H){return Object.assign(H,{apply:function(...ge){if(ge.length===0)return Reflect.construct(H,[]);{const Me=ge.length===1?[]:ge[1];return Reflect.construct(H,Me,ge[0].constructor)}},call:function(...ge){if(ge.length===0)return Reflect.construct(H,[]);{const[Me,...Ye]=ge;return Reflect.construct(H,Ye,Me.constructor)}}})}var C;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var I;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let F=h=class{static from(...Q){let ge=Q;return new h(function(){if(ge){for(const Me of ge)Me&&typeof Me.dispose=="function"&&Me.dispose();ge=void 0}})}#e;constructor(Q){this.#e=Q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$5M=F,e.$5M=F=h=Ke([S],F);let j=f=class{static Min(...Q){if(Q.length===0)throw new TypeError;let ge=Q[0];for(let Me=1;Me<Q.length;Me++){const Ye=Q[Me];Ye.isBefore(ge)&&(ge=Ye)}return ge}static Max(...Q){if(Q.length===0)throw new TypeError;let ge=Q[0];for(let Me=1;Me<Q.length;Me++){const Ye=Q[Me];Ye.isAfter(ge)&&(ge=Ye)}return ge}static isPosition(Q){if(!Q)return!1;if(Q instanceof f)return!0;const{line:ge,character:Me}=Q;return typeof ge=="number"&&typeof Me=="number"}static of(Q){if(Q instanceof f)return Q;if(this.isPosition(Q))return new f(Q.line,Q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(Q,ge){if(Q<0)throw(0,L.$7)("line must be non-negative");if(ge<0)throw(0,L.$7)("character must be non-negative");this.c=Q,this.e=ge}isBefore(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<Q.e}isBeforeOrEqual(Q){return this.c<Q.c?!0:Q.c<this.c?!1:this.e<=Q.e}isAfter(Q){return!this.isBeforeOrEqual(Q)}isAfterOrEqual(Q){return!this.isBefore(Q)}isEqual(Q){return this.c===Q.c&&this.e===Q.e}compareTo(Q){return this.c<Q.c?-1:this.c>Q.line?1:this.e<Q.e?-1:this.e>Q.e?1:0}translate(Q,ge=0){if(Q===null||ge===null)throw(0,L.$7)();let Me;return typeof Q>"u"?Me=0:typeof Q=="number"?Me=Q:(Me=typeof Q.lineDelta=="number"?Q.lineDelta:0,ge=typeof Q.characterDelta=="number"?Q.characterDelta:0),Me===0&&ge===0?this:new f(this.line+Me,this.character+ge)}with(Q,ge=this.character){if(Q===null||ge===null)throw(0,L.$7)();let Me;return typeof Q>"u"?Me=this.line:typeof Q=="number"?Me=Q:(Me=typeof Q.line=="number"?Q.line:this.line,ge=typeof Q.character=="number"?Q.character:this.character),Me===this.line&&ge===this.character?this:new f(Me,ge)}toJSON(){return{line:this.line,character:this.character}}};e.$6M=j,e.$6M=j=f=Ke([S],j);let z=a=class{static isRange(Q){return Q instanceof a?!0:Q?j.isPosition(Q.start)&&j.isPosition(Q.end):!1}static of(Q){if(Q instanceof a)return Q;if(this.isRange(Q))return new a(Q.start,Q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(Q,ge,Me,Ye){let it,dt;if(typeof Q=="number"&&typeof ge=="number"&&typeof Me=="number"&&typeof Ye=="number"?(it=new j(Q,ge),dt=new j(Me,Ye)):j.isPosition(Q)&&j.isPosition(ge)&&(it=j.of(Q),dt=j.of(ge)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(Q){return a.isRange(Q)?this.contains(Q.start)&&this.contains(Q.end):j.isPosition(Q)?!(j.of(Q).isBefore(this.c)||this.e.isBefore(Q)):!1}isEqual(Q){return this.c.isEqual(Q.c)&&this.e.isEqual(Q.e)}intersection(Q){const ge=j.Max(Q.start,this.c),Me=j.Min(Q.end,this.e);if(!ge.isAfter(Me))return new a(ge,Me)}union(Q){if(this.contains(Q))return this;if(Q.contains(this))return Q;const ge=j.Min(Q.start,this.c),Me=j.Max(Q.end,this.end);return new a(ge,Me)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(Q,ge=this.end){if(Q===null||ge===null)throw(0,L.$7)();let Me;return Q?j.isPosition(Q)?Me=Q:(Me=Q.start||this.start,ge=Q.end||this.end):Me=this.start,Me.isEqual(this.c)&&ge.isEqual(this.end)?this:new a(Me,ge)}toJSON(){return[this.start,this.end]}};e.$7M=z,e.$7M=z=a=Ke([S],z);let M=n=class extends z{static isSelection(Q){return Q instanceof n?!0:Q?z.isRange(Q)&&j.isPosition(Q.anchor)&&j.isPosition(Q.active)&&typeof Q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(Q,ge,Me,Ye){let it,dt;if(typeof Q=="number"&&typeof ge=="number"&&typeof Me=="number"&&typeof Ye=="number"?(it=new j(Q,ge),dt=new j(Me,Ye)):j.isPosition(Q)&&j.isPosition(ge)&&(it=j.of(Q),dt=j.of(ge)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$8M=M,e.$8M=M=n=Ke([S],M);const T=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,L.$7)("connectionToken")};class U{static isResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.host=="string"&&typeof Q.port=="number"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,ge,Me){if(typeof Q!="string"||Q.length===0)throw(0,L.$7)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,L.$7)("port");typeof Me<"u"&&T(Me),this.host=Q,this.port=Math.round(ge),this.connectionToken=Me}}e.$9M=U;class Z{static isManagedResolvedAuthority(Q){return Q&&typeof Q=="object"&&typeof Q.makeConnection=="function"&&(Q.connectionToken===void 0||typeof Q.connectionToken=="string")}constructor(Q,ge){this.makeConnection=Q,this.connectionToken=ge,typeof ge<"u"&&T(ge)}}e.$0M=Z;class te extends Error{static NotAvailable(Q,ge){return new te(Q,y.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(Q){return new te(Q,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(Q,ge=y.RemoteAuthorityResolverErrorCode.Unknown,Me){super(Q),this._message=Q,this._code=ge,this._detail=Me,Object.setPrototypeOf(this,te.prototype)}}e.$$M=te;var q;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(q||(e.EndOfLine=q={}));var K;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(K||(e.EnvironmentVariableMutatorType=K={}));let Y=i=class{static isTextEdit(Q){return Q instanceof i?!0:Q?z.isRange(Q)&&typeof Q.newText=="string":!1}static replace(Q,ge){return new i(Q,ge)}static insert(Q,ge){return i.replace(new z(Q,Q),ge)}static delete(Q){return i.replace(Q,"")}static setEndOfLine(Q){const ge=new i(new z(new j(0,0),new j(0,0)),"");return ge.newEol=Q,ge}get range(){return this.c}set range(Q){if(Q&&!z.isRange(Q))throw(0,L.$7)("range");this.c=Q}get newText(){return this.e||""}set newText(Q){if(Q&&typeof Q!="string")throw(0,L.$7)("newText");this.e=Q}get newEol(){return this.f}set newEol(Q){if(Q&&typeof Q!="number")throw(0,L.$7)("newEol");this.f=Q}constructor(Q,ge){this.c=Q,this.e=ge}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$_M=Y,e.$_M=Y=i=Ke([S],Y);let ie=u=class{static isNotebookCellEdit(Q){return Q instanceof u?!0:Q?mn.isNotebookRange(Q)&&Array.isArray(Q.newCells):!1}static replaceCells(Q,ge){return new u(Q,ge)}static insertCells(Q,ge){return new u(new mn(Q,Q),ge)}static deleteCells(Q){return new u(Q,[])}static updateCellMetadata(Q,ge){const Me=new u(new mn(Q,Q),[]);return Me.newCellMetadata=ge,Me}static updateNotebookMetadata(Q){const ge=new u(new mn(0,0),[]);return ge.newNotebookMetadata=Q,ge}constructor(Q,ge){this.range=Q,this.newCells=ge}};e.$aN=ie,e.$aN=ie=u=Ke([S],ie);class $e{static isSnippetTextEdit(Q){return Q instanceof $e?!0:Q?z.isRange(Q.range)&&_.isSnippetString(Q.snippet):!1}static replace(Q,ge){return new $e(Q,ge)}static insert(Q,ge){return $e.replace(new z(Q,Q),ge)}constructor(Q,ge){this.range=Q,this.snippet=ge}}e.$bN=$e;var ue;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(ue||(e.FileEditType=ue={}));let ve=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(Q,ge,Me,Ye){this.c.push({_type:1,from:Q,to:ge,options:Me,metadata:Ye})}createFile(Q,ge,Me){this.c.push({_type:1,from:void 0,to:Q,options:ge,metadata:Me})}deleteFile(Q,ge,Me){this.c.push({_type:1,from:Q,to:void 0,options:ge,metadata:Me})}e(Q,ge,Me){this.c.push({_type:3,metadata:Me,uri:Q,edit:{editType:5,metadata:ge},notebookMetadata:ge})}f(Q,ge,Me,Ye){const it=ge.start,dt=ge.end;(it!==dt||Me.length>0)&&this.c.push({_type:5,uri:Q,index:it,count:dt-it,cells:Me,metadata:Ye})}g(Q,ge,Me,Ye){this.c.push({_type:3,metadata:Ye,uri:Q,edit:{editType:3,index:ge,metadata:Me}})}replace(Q,ge,Me,Ye){this.c.push({_type:2,uri:Q,edit:new Y(ge,Me),metadata:Ye})}insert(Q,ge,Me,Ye){this.replace(Q,new z(ge,ge),Me,Ye)}delete(Q,ge,Me){this.replace(Q,ge,"",Me)}has(Q){return this.c.some(ge=>ge._type===2&&ge.uri.toString()===Q.toString())}set(Q,ge){if(ge)for(const Me of ge){if(!Me)continue;let Ye,it;Array.isArray(Me)?(Ye=Me[0],it=Me[1]):Ye=Me,ie.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(Q,Ye.range.start,Ye.newCellMetadata,it):Ye.newNotebookMetadata?this.e(Q,Ye.newNotebookMetadata,it):this.f(Q,Ye.range,Ye.newCells,it):$e.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:Q,range:Ye.range,edit:Ye.snippet,metadata:it}):this.c.push({_type:2,uri:Q,edit:Ye,metadata:it})}else{for(let Me=0;Me<this.c.length;Me++){const Ye=this.c[Me];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===Q.toString()&&(this.c[Me]=void 0);break}}(0,d.$Ib)(this.c)}}get(Q){const ge=[];for(const Me of this.c)Me._type===2&&Me.uri.toString()===Q.toString()&&ge.push(Me.edit);return ge}entries(){const Q=new R.$Bc;for(const ge of this.c)if(ge._type===2){let Me=Q.get(ge.uri);Me||(Me=[ge.uri,[]],Q.set(ge.uri,Me)),Me[1].push(ge.edit)}return[...Q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$cN=ve,e.$cN=ve=Ke([S],ve);let _=o=class{static isSnippetString(Q){return Q instanceof o?!0:Q?typeof Q.value=="string":!1}static c(Q){return Q.replace(/\$|}|\\/g,"\\$&")}constructor(Q){this.e=1,this.value=Q||""}appendText(Q){return this.value+=o.c(Q),this}appendTabstop(Q=this.e++){return this.value+="$",this.value+=Q,this}appendPlaceholder(Q,ge=this.e++){if(typeof Q=="function"){const Me=new o;Me.e=this.e,Q(Me),this.e=Me.e,Q=Me.value}else Q=o.c(Q);return this.value+="${",this.value+=ge,this.value+=":",this.value+=Q,this.value+="}",this}appendChoice(Q,ge=this.e++){const Me=Q.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Me,this.value+="|}",this}appendVariable(Q,ge){if(typeof ge=="function"){const Me=new o;Me.e=this.e,ge(Me),this.e=Me.e,ge=Me.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=Q,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};e.$dN=_,e.$dN=_=o=Ke([S],_);var B;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var ee;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let pe=t=class{static isLocation(Q){return Q instanceof t?!0:Q?z.isRange(Q.range)&&E.URI.isUri(Q.uri):!1}constructor(Q,ge){if(this.uri=Q,ge)if(z.isRange(ge))this.range=z.of(ge);else if(j.isPosition(ge))this.range=new z(ge,ge);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$eN=pe,e.$eN=pe=t=Ke([S],pe);let Ce=class{static is(Q){return Q?typeof Q.message=="string"&&Q.location&&z.isRange(Q.location.range)&&E.URI.isUri(Q.location.uri):!1}constructor(Q,ge){this.location=Q,this.message=ge}static isEqual(Q,ge){return Q===ge?!0:!Q||!ge?!1:Q.message===ge.message&&Q.location.range.isEqual(ge.location.range)&&Q.location.uri.toString()===ge.location.uri.toString()}};e.$fN=Ce,e.$fN=Ce=Ke([S],Ce);let oe=class{constructor(Q,ge,Me=ee.Error){if(!z.isRange(Q))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=Q,this.message=ge,this.severity=Me}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(Q,ge){return Q===ge?!0:!Q||!ge?!1:Q.message===ge.message&&Q.severity===ge.severity&&Q.code===ge.code&&Q.severity===ge.severity&&Q.source===ge.source&&Q.range.isEqual(ge.range)&&(0,d.$ub)(Q.tags,ge.tags)&&(0,d.$ub)(Q.relatedInformation,ge.relatedInformation,Ce.isEqual)}};e.$gN=oe,e.$gN=oe=Ke([S],oe);let se=class{constructor(Q,ge){if(!Q)throw new Error("Illegal argument, contents must be defined");Array.isArray(Q)?this.contents=Q:this.contents=[Q],this.range=ge}};e.$hN=se,e.$hN=se=Ke([S],se);let re=class extends se{constructor(Q,ge,Me,Ye){super(Q,ge),this.canIncreaseHover=Me,this.canDecreaseHover=Ye}};e.$iN=re,e.$iN=re=Ke([S],re);var G;(function(H){H[H.Increase=0]="Increase",H[H.Decrease=1]="Decrease"})(G||(e.HoverVerbosityAction=G={}));var ne;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(ne||(e.DocumentHighlightKind=ne={}));let me=class{constructor(Q,ge=ne.Text){this.range=Q,this.kind=ge}toJSON(){return{range:this.range,kind:ne[this.kind]}}};e.$jN=me,e.$jN=me=Ke([S],me);let be=class{constructor(Q,ge){this.uri=Q,this.highlights=ge}toJSON(){return{uri:this.uri,highlights:this.highlights.map(Q=>Q.toJSON())}}};e.$kN=be,e.$kN=be=Ke([S],be);var Re;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Re||(e.SymbolKind=Re={}));var fe;(function(H){H[H.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let De=l=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy")}constructor(Q,ge,Me,Ye,it){this.name=Q,this.kind=ge,this.containerName=it,typeof Me=="string"&&(this.containerName=Me),Ye instanceof pe?this.location=Ye:Me instanceof z&&(this.location=new pe(Ye,Me)),l.validate(this)}toJSON(){return{name:this.name,kind:Re[this.kind],location:this.location,containerName:this.containerName}}};e.$lN=De,e.$lN=De=l=Ke([S],De);let Ae=r=class{static validate(Q){if(!Q.name)throw new Error("name must not be falsy");if(!Q.range.contains(Q.selectionRange))throw new Error("selectionRange must be contained in fullRange");Q.children?.forEach(r.validate)}constructor(Q,ge,Me,Ye,it){this.name=Q,this.detail=ge,this.kind=Me,this.range=Ye,this.selectionRange=it,this.children=[],r.validate(this)}};e.$mN=Ae,e.$mN=Ae=r=Ke([S],Ae);var ze;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(ze||(e.CodeActionTriggerKind=ze={}));let W=class{constructor(Q,ge){this.title=Q,this.kind=ge}};e.$nN=W,e.$nN=W=Ke([S],W);let V=class{static{c=this}static{this.c="."}constructor(Q){this.value=Q}append(Q){return new c(this.value?this.value+c.c+Q:Q)}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+c.c)}};e.$oN=V,e.$oN=V=c=Ke([S],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let J=class{constructor(Q,ge){if(this.range=Q,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$pN=J,e.$pN=J=Ke([S],J);class X{constructor(Q,ge,Me,Ye,it,dt){this.kind=Q,this.name=ge,this.detail=Me,this.uri=Ye,this.range=it,this.selectionRange=dt}}e.$qN=X;class he{constructor(Q,ge){this.fromRanges=ge,this.from=Q}}e.$rN=he;class we{constructor(Q,ge){this.fromRanges=ge,this.to=Q}}e.$sN=we;var Fe;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let qe=class{constructor(Q,ge){this.range=Q,this.command=ge}get isResolved(){return!!this.command}};e.$tN=qe,e.$tN=qe=Ke([S],qe);let Je=s=class{#e;static isMarkdownString(Q){return Q instanceof s?!0:Q&&Q.appendCodeblock&&Q.appendMarkdown&&Q.appendText&&Q.value!==void 0}constructor(Q,ge=!1){this.#e=new O.$Tk(Q,{supportThemeIcons:ge})}get value(){return this.#e.value}set value(Q){this.#e.value=Q}get isTrusted(){return this.#e.isTrusted}set isTrusted(Q){this.#e.isTrusted=Q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(Q){this.#e.supportThemeIcons=Q}get supportHtml(){return this.#e.supportHtml}set supportHtml(Q){this.#e.supportHtml=Q}get baseUri(){return this.#e.baseUri}set baseUri(Q){this.#e.baseUri=Q}appendText(Q){return this.#e.appendText(Q),this}appendMarkdown(Q){return this.#e.appendMarkdown(Q),this}appendCodeblock(Q,ge){return this.#e.appendCodeblock(ge??"",Q),this}};e.$uN=Je,e.$uN=Je=s=Ke([S],Je);let rt=class{constructor(Q,ge){this.label=Q,this.documentation=ge}};e.$vN=rt,e.$vN=rt=Ke([S],rt);let tt=class{constructor(Q,ge){this.label=Q,this.documentation=ge,this.parameters=[]}};e.$wN=tt,e.$wN=tt=Ke([S],tt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$xN=nt,e.$xN=nt=Ke([S],nt);var st;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var Pe;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(Pe||(e.InlayHintKind=Pe={}));let Be=class{constructor(Q){this.value=Q}};e.$yN=Be,e.$yN=Be=Ke([S],Be);let He=class{constructor(Q,ge,Me){this.position=Q,this.label=ge,this.kind=Me}};e.$zN=He,e.$zN=He=Ke([S],He);var Le;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le||(e.CompletionTriggerKind=Le={}));var Xe;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Xe||(e.CompletionItemKind=Xe={}));var ae;(function(H){H[H.Deprecated=1]="Deprecated"})(ae||(e.CompletionItemTag=ae={}));let ce=class{constructor(Q,ge){this.label=Q,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&Xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$AN=ce,e.$AN=ce=Ke([S],ce);let Ie=class{constructor(Q=[],ge=!1){this.items=Q,this.isIncomplete=ge}};e.$BN=Ie,e.$BN=Ie=Ke([S],Ie);let Ge=class{constructor(Q,ge,Me){this.insertText=Q,this.range=ge,this.command=Me}};e.$CN=Ge,e.$CN=Ge=Ke([S],Ge);let Oe=class{constructor(Q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=Q}};e.$DN=Oe,e.$DN=Oe=Ke([S],Oe);var ot;(function(H){H[H.Unknown=0]="Unknown",H[H.Word=1]="Word",H[H.Line=2]="Line",H[H.Suggest=3]="Suggest"})(ot||(e.PartialAcceptTriggerKind=ot={}));var ut;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(ut||(e.ViewColumn=ut={}));var vt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Rt(H,Q){return`${P.$Rm.toKey(H)}.${Q}`}var Ut;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval"})(Ut||(e.TextEditorLineNumbersStyle=Ut={}));var tn;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(tn||(e.TextDocumentSaveReason=tn={}));var Zt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Zt||(e.TextEditorRevealType=Zt={}));var kt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(kt||(e.TextEditorSelectionChangeKind=kt={}));var Xt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Xt||(e.TextDocumentChangeReason=Xt={}));var Yt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(H){function Q(ge){switch(ge){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=Q}(kt||(e.TextEditorSelectionChangeKind=kt={}));var et;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(et||(e.SyntaxTokenType=et={})),function(H){function Q(ge){switch(ge){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=Q}(et||(e.SyntaxTokenType=et={}));let an=class{constructor(Q,ge){if(ge&&!E.URI.isUri(ge))throw(0,L.$7)("target");if(!z.isRange(Q)||Q.isEmpty)throw(0,L.$7)("range");this.range=Q,this.target=ge}};e.$FN=an,e.$FN=an=Ke([S],an);let Gt=class{constructor(Q,ge,Me,Ye){this.red=Q,this.green=ge,this.blue=Me,this.alpha=Ye}};e.$GN=Gt,e.$GN=Gt=Ke([S],Gt);let ft=class{constructor(Q,ge){if(ge&&!(ge instanceof Gt))throw(0,L.$7)("color");if(!z.isRange(Q)||Q.isEmpty)throw(0,L.$7)("range");this.range=Q,this.color=ge}};e.$HN=ft,e.$HN=ft=Ke([S],ft);let $t=class{constructor(Q){if(!Q||typeof Q!="string")throw(0,L.$7)("label");this.label=Q}};e.$IN=$t,e.$IN=$t=Ke([S],$t);var xt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(xt||(e.ColorFormat=xt={}));var Kt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var Ft;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(Ft||(e.TerminalExitReason=Ft={}));var gt;(function(H){H[H.Low=0]="Low",H[H.Medium=1]="Medium",H[H.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class Wt{constructor(Q,ge,Me){if(this.startIndex=Q,this.length=ge,this.tooltip=Me,typeof Q!="number"||Q<0)throw(0,L.$7)("startIndex");if(typeof ge!="number"||ge<1)throw(0,L.$7)("length");if(Me!==void 0&&typeof Me!="string")throw(0,L.$7)("tooltip")}}e.$JN=Wt;class _t{constructor(Q){this.uri=Q}}e.$KN=_t;class Vt{constructor(Q){this.terminalCommand=Q}}e.$LN=Vt;var xe;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(xe||(e.TerminalLocation=xe={}));class ln{constructor(Q){if(this.options=Q,typeof Q!="object")throw(0,L.$7)("options")}}e.$MN=ln;var Jt;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var qt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(qt||(e.TaskPanelKind=qt={}));let pt=class{static{v=this}static{this.Clean=new v("clean","Clean")}static{this.Build=new v("build","Build")}static{this.Rebuild=new v("rebuild","Rebuild")}static{this.Test=new v("test","Test")}static from(Q){switch(Q){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}constructor(Q,ge){if(this.label=ge,typeof Q!="string"||typeof ge!="string")throw(0,L.$7)("name");this.c=Q}get id(){return this.c}};e.$NN=pt,e.$NN=pt=v=Ke([S],pt);function jt(H){let Q="";for(let ge=0;ge<H.length;ge++)Q+=H[ge].replace(/,/g,",,")+",";return Q}let Nt=class{constructor(Q,ge,Me){if(typeof Q!="string")throw(0,L.$7)("process");this.e=[],this.c=Q,ge!==void 0&&(Array.isArray(ge)?(this.e=ge,this.f=Me):this.f=ge)}get process(){return this.c}set process(Q){if(typeof Q!="string")throw(0,L.$7)("process");this.c=Q}get args(){return this.e}set args(Q){Array.isArray(Q)||(Q=[]),this.e=Q}get options(){return this.f}set options(Q){this.f=Q}computeId(){const Q=[];if(Q.push("process"),this.c!==void 0&&Q.push(this.c),this.e&&this.e.length>0)for(const ge of this.e)Q.push(ge);return jt(Q)}};e.$ON=Nt,e.$ON=Nt=Ke([S],Nt);let Lt=class{constructor(Q,ge,Me){if(this.f=[],Array.isArray(ge)){if(!Q)throw(0,L.$7)("command can't be undefined or null");if(typeof Q!="string"&&typeof Q.value!="string")throw(0,L.$7)("command");this.e=Q,this.f=ge,this.g=Me}else{if(typeof Q!="string")throw(0,L.$7)("commandLine");this.c=Q,this.g=ge}}get commandLine(){return this.c}set commandLine(Q){if(typeof Q!="string")throw(0,L.$7)("commandLine");this.c=Q}get command(){return this.e?this.e:""}set command(Q){if(typeof Q!="string"&&typeof Q.value!="string")throw(0,L.$7)("command");this.e=Q}get args(){return this.f}set args(Q){this.f=Q||[]}get options(){return this.g}set options(Q){this.g=Q}computeId(){const Q=[];if(Q.push("shell"),this.c!==void 0&&Q.push(this.c),this.e!==void 0&&Q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ge of this.f)Q.push(typeof ge=="string"?ge:ge.value);return jt(Q)}};e.$PN=Lt,e.$PN=Lt=Ke([S],Lt);var nn;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(nn||(e.ShellQuoting=nn={}));var Qt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Qt||(e.TaskScope=Qt={}));class rn{constructor(Q){this.c=Q}computeId(){return"customExecution"+(0,A.$Sg)()}set callback(Q){this.c=Q}get callback(){return this.c}}e.$QN=rn;let It=class{static{g=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(Q,ge,Me,Ye,it,dt){this.k=!1,this.l=this.definition=Q;let bt;typeof ge=="string"?(this.o=this.name=ge,this.w=this.source=Me,this.execution=Ye,bt=it,this.k=!0):ge===Qt.Global||ge===Qt.Workspace?(this.target=ge,this.o=this.name=Me,this.w=this.source=Ye,this.execution=it,bt=dt):(this.target=ge,this.o=this.name=Me,this.w=this.source=Ye,this.execution=it,bt=dt),typeof bt=="string"?(this.r=[bt],this.t=!0):Array.isArray(bt)?(this.r=bt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(Q){this.j=Q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:g.e,id:this.q.computeId()}:this.q instanceof Lt?this.l={type:g.f,id:this.q.computeId()}:this.q instanceof rn?this.l={type:g.c,id:this.q.computeId()}:this.l={type:g.g,id:(0,A.$Sg)()}}get definition(){return this.l}set definition(Q){if(Q==null)throw(0,L.$7)("Kind can't be undefined or null");this.B(),this.l=Q}get scope(){return this.m}set target(Q){this.B(),this.m=Q}get name(){return this.o}set name(Q){if(typeof Q!="string")throw(0,L.$7)("name");this.B(),this.o=Q}get execution(){return this.q}set execution(Q){Q===null&&(Q=void 0),this.B(),this.q=Q;const ge=this.l.type;(g.g===ge||g.e===ge||g.f===ge||g.c===ge)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(Q){if(Array.isArray(Q))this.B(),this.r=Q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(Q){Q!==!0&&Q!==!1&&(Q=!1),this.B(),this.u=Q}get source(){return this.w}set source(Q){if(typeof Q!="string"||Q.length===0)throw(0,L.$7)("source must be a string of length > 0");this.B(),this.w=Q}get group(){return this.x}set group(Q){Q===null&&(Q=void 0),this.B(),this.x=Q}get detail(){return this.A}set detail(Q){Q===null&&(Q=void 0),this.A=Q}get presentationOptions(){return this.y}set presentationOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.y=Q}get runOptions(){return this.z}set runOptions(Q){Q==null&&(Q=Object.create(null)),this.B(),this.z=Q}};e.$RN=It,e.$RN=It=g=Ke([S],It);var Mt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Mt||(e.ProgressLocation=Mt={}));var Ot;(function(H){function Q(ge){const Me=ge;return(0,m.$ag)(Me.value)?Me.tooltip&&!(0,m.$9f)(Me.tooltip)?(console.log("INVALID view badge, invalid tooltip",Me.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Me.value),!1)}H.isViewBadge=Q})(Ot||(e.ViewBadge=Ot={}));let Ct=D=class{static isTreeItem(Q,ge){const Me=Q;if(Me.checkboxState!==void 0){const Ye=(0,m.$ag)(Me.checkboxState)?Me.checkboxState:(0,m.$$f)(Me.checkboxState)&&(0,m.$ag)(Me.checkboxState.state)?Me.checkboxState.state:void 0,it=!(0,m.$ag)(Me.checkboxState)&&(0,m.$$f)(Me.checkboxState)?Me.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==St.Checked&&Ye!==St.Unchecked||it!==void 0&&!(0,m.$9f)(it))return console.log("INVALID tree item, invalid checkboxState",Me.checkboxState),!1}if(Q instanceof D)return!0;if(Me.label!==void 0&&!(0,m.$9f)(Me.label)&&!Me.label?.label)return console.log("INVALID tree item, invalid label",Me.label),!1;if(Me.id!==void 0&&!(0,m.$9f)(Me.id))return console.log("INVALID tree item, invalid id",Me.id),!1;if(Me.iconPath!==void 0&&!(0,m.$9f)(Me.iconPath)&&!E.URI.isUri(Me.iconPath)&&(!Me.iconPath||!(0,m.$9f)(Me.iconPath.id))){const Ye=Me.iconPath;if(!Ye||!(0,m.$9f)(Ye.light)&&!E.URI.isUri(Ye.light)&&!(0,m.$9f)(Ye.dark)&&!E.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Me.iconPath),!1}return Me.description!==void 0&&!(0,m.$9f)(Me.description)&&typeof Me.description!="boolean"?(console.log("INVALID tree item, invalid description",Me.description),!1):Me.resourceUri!==void 0&&!E.URI.isUri(Me.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Me.resourceUri),!1):Me.tooltip!==void 0&&!(0,m.$9f)(Me.tooltip)&&!(Me.tooltip instanceof Je)?(console.log("INVALID tree item, invalid tooltip",Me.tooltip),!1):Me.command!==void 0&&!Me.command.command?(console.log("INVALID tree item, invalid command",Me.command),!1):Me.collapsibleState!==void 0&&Me.collapsibleState<mt.None&&Me.collapsibleState>mt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Me.collapsibleState),!1):Me.contextValue!==void 0&&!(0,m.$9f)(Me.contextValue)?(console.log("INVALID tree item, invalid contextValue",Me.contextValue),!1):Me.accessibilityInformation!==void 0&&!Me.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Me.accessibilityInformation),!1):!0}constructor(Q,ge=mt.None){this.collapsibleState=ge,E.URI.isUri(Q)?this.resourceUri=Q:this.label=Q}};e.$SN=Ct,e.$SN=Ct=D=Ke([S],Ct);var mt;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(mt||(e.TreeItemCollapsibleState=mt={}));var St;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let cn=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(Q){this.value=Q}};e.$TN=cn,e.$TN=cn=Ke([S],cn);class Dt extends cn{}e.$UN=Dt;class gn extends Dt{#e;constructor(Q){super(""),this.#e=Q}asFile(){return this.#e}}e.$VN=gn;class sn{constructor(Q,ge,Me,Ye){this.name=Q,this.uri=ge,this._itemId=Me,this.c=Ye}data(){return this.c()}}e.$WN=sn;let pn=class{#e=new Map;constructor(Q){for(const[ge,Me]of Q??[]){const Ye=this.#e.get(this.#t(ge));Ye?Ye.push(Me):this.#e.set(this.#t(ge),[Me])}}get(Q){return this.#e.get(this.#t(Q))?.[0]}set(Q,ge){this.#e.set(this.#t(Q),[ge])}forEach(Q,ge){for(const[Me,Ye]of this.#e)for(const it of Ye)Q.call(ge,it,Me,this)}*[Symbol.iterator](){for(const[Q,ge]of this.#e)for(const Me of ge)yield[Q,Me]}#t(Q){return Q.toLowerCase()}};e.$XN=pn,e.$XN=pn=Ke([S],pn);let hn=class{constructor(Q,ge,Me){this.insertText=Q,this.title=ge,this.kind=Me}};e.$YN=hn,e.$YN=hn=Ke([S],hn);var wn;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(wn||(e.DocumentPasteTriggerKind=wn={}));class Pt{static{this.c="."}constructor(Q){this.value=Q}append(...Q){return new Pt((this.value?[this.value,...Q]:Q).join(Pt.c))}intersects(Q){return this.contains(Q)||Q.contains(this)}contains(Q){return this.value===Q.value||Q.value.startsWith(this.value+Pt.c)}}e.$ZN=Pt,Pt.Empty=new Pt("");class yn{constructor(Q,ge,Me){this.title=ge,this.insertText=Q,this.kind=Me}}e.$1N=yn;let on=class{constructor(Q,ge){this.id=Q,this.color=ge}static isThemeIcon(Q){return typeof Q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",Q.id),!1):!0}};e.$2N=on,e.$2N=on=Ke([S],on),on.File=new on("file"),on.Folder=new on("folder");let Ne=class{constructor(Q){this.id=Q}};e.$3N=Ne,e.$3N=Ne=Ke([S],Ne);var je;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(je||(e.ConfigurationTarget=je={}));let ye=class{get base(){return this.c}set base(Q){this.c=Q,this.e=E.URI.file(Q)}get baseUri(){return this.e}set baseUri(Q){this.e=Q,this.c=Q.fsPath}constructor(Q,ge){if(typeof Q!="string"&&(!Q||!E.URI.isUri(Q)&&!E.URI.isUri(Q.uri)))throw(0,L.$7)("base");if(typeof ge!="string")throw(0,L.$7)("pattern");typeof Q=="string"?this.baseUri=E.URI.file(Q):E.URI.isUri(Q)?this.baseUri=Q:this.baseUri=Q.uri,this.pattern=ge}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$4N=ye,e.$4N=ye=Ke([S],ye);const x=new WeakMap;function Te(H,Q){x.set(H,Q)}let Qe=class{constructor(Q,ge,Me,Ye,it){this.enabled=typeof Q=="boolean"?Q:!0,typeof ge=="string"&&(this.condition=ge),typeof Me=="string"&&(this.hitCondition=Me),typeof Ye=="string"&&(this.logMessage=Ye),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=x.get(this)??(0,A.$Sg)()),this.c}};e.$6N=Qe,e.$6N=Qe=Ke([S],Qe);let _e=class extends Qe{constructor(Q,ge,Me,Ye,it,dt){if(super(ge,Me,Ye,it,dt),Q===null)throw(0,L.$7)("location");this.location=Q}};e.$7N=_e,e.$7N=_e=Ke([S],_e);let Ze=class extends Qe{constructor(Q,ge,Me,Ye,it,dt){super(ge,Me,Ye,it,dt),this.functionName=Q}};e.$8N=Ze,e.$8N=Ze=Ke([S],Ze);let ht=class extends Qe{constructor(Q,ge,Me,Ye,it,dt,bt,Ht){if(super(Ye,it,dt,bt,Ht),!ge)throw(0,L.$7)("dataId");this.label=Q,this.dataId=ge,this.canPersist=Me}};e.$9N=ht,e.$9N=ht=Ke([S],ht);let Et=class{constructor(Q,ge,Me){this.command=Q,this.args=ge||[],this.options=Me}};e.$0N=Et,e.$0N=Et=Ke([S],Et);let zt=class{constructor(Q,ge){this.port=Q,this.host=ge}};e.$$N=zt,e.$$N=zt=Ke([S],zt);let lt=class{constructor(Q){this.path=Q}};e.$_N=lt,e.$_N=lt=Ke([S],lt);let Tt=class{constructor(Q){this.implementation=Q}};e.$aO=Tt,e.$aO=Tt=Ke([S],Tt);class Bt{constructor(Q,ge,Me){this.session=Q,this.threadId=ge,this.frameId=Me}}e.$bO=Bt;class En{constructor(Q,ge){this.session=Q,this.threadId=ge}}e.$cO=En;let Dn=class{constructor(Q,ge){this.range=Q,this.expression=ge}};e.$dO=Dn,e.$dO=Dn=Ke([S],Dn);var Kn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Kn||(e.InlineCompletionTriggerKind=Kn={}));let Ln=class{constructor(Q,ge){this.range=Q,this.text=ge}};e.$eO=Ln,e.$eO=Ln=Ke([S],Ln);let Mn=class{constructor(Q,ge,Me=!0){this.range=Q,this.variableName=ge,this.caseSensitiveLookup=Me}};e.$fO=Mn,e.$fO=Mn=Ke([S],Mn);let Pn=class{constructor(Q,ge){this.range=Q,this.expression=ge}};e.$gO=Pn,e.$gO=Pn=Ke([S],Pn);let Tn=class{constructor(Q,ge){this.frameId=Q,this.stoppedLocation=ge}};e.$hO=Tn,e.$hO=Tn=Ke([S],Tn);var Fn;(function(H){H[H.AIGenerated=1]="AIGenerated"})(Fn||(e.NewSymbolNameTag=Fn={}));var Jn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Jn||(e.NewSymbolNameTriggerKind=Jn={}));class jn{constructor(Q,ge){this.newSymbolName=Q,this.tags=ge}}e.$iO=jn;var Cn;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Cn||(e.FileChangeType=Cn={}));let zn=$=class extends Error{static FileExists(Q){return new $(Q,p.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(Q){return new $(Q,p.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(Q){return new $(Q,p.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(Q){return new $(Q,p.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(Q){return new $(Q,p.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(Q){return new $(Q,p.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(Q,ge=p.FileSystemProviderErrorCode.Unknown,Me){super(E.URI.isUri(Q)?Q.toString(!0):Q),this.code=Me?.name??"Unknown",(0,p.$fl)(this,ge),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Me=="function"&&Error.captureStackTrace(this,Me)}};e.$jO=zn,e.$jO=zn=$=Ke([S],zn);let Bn=class{constructor(Q,ge,Me){this.start=Q,this.end=ge,this.kind=Me}};e.$kO=Bn,e.$kO=Bn=Ke([S],Bn);var vn;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(vn||(e.FoldingRangeKind=vn={}));var Zn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Zn||(e.CommentThreadCollapsibleState=Zn={}));var Xn;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(Xn||(e.CommentMode=Xn={}));var Yn;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Yn||(e.CommentState=Yn={}));var In;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(In||(e.CommentThreadState=In={}));var xn;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(xn||(e.CommentThreadApplicability=xn={}));class _n{constructor(Q,ge=[]){this.tokenTypes=Q,this.tokenModifiers=ge}}e.$lO=_n;function di(H){return typeof H>"u"||(0,m.$0f)(H)}class An{constructor(Q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,Q){this.m=!0;for(let ge=0,Me=Q.tokenTypes.length;ge<Me;ge++)this.k.set(Q.tokenTypes[ge],ge);for(let ge=0,Me=Q.tokenModifiers.length;ge<Me;ge++)this.l.set(Q.tokenModifiers[ge],ge)}}push(Q,ge,Me,Ye,it){if(typeof Q=="number"&&typeof ge=="number"&&typeof Me=="number"&&typeof Ye=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(Q,ge,Me,Ye,it);if(z.isRange(Q)&&typeof ge=="string"&&di(Me))return this.o(Q,ge,Me);throw(0,L.$7)()}o(Q,ge,Me){if(!this.m)throw new Error("Legend must be provided in constructor");if(Q.start.line!==Q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ge))throw new Error("`tokenType` is not in the provided legend");const Ye=Q.start.line,it=Q.start.character,dt=Q.end.character-Q.start.character,bt=this.k.get(ge);let Ht=0;if(Me)for(const un of Me){if(!this.l.has(un))throw new Error("`tokenModifier` is not in the provided legend");const fn=this.l.get(un);Ht|=1<<fn>>>0}this.q(Ye,it,dt,bt,Ht)}q(Q,ge,Me,Ye,it){if(this.f&&(Q<this.c||Q===this.c&&ge<this.e)){this.f=!1;const Ht=this.g.length/5|0;let un=0,fn=0;for(let $n=0;$n<Ht;$n++){let bn=this.g[5*$n],Hn=this.g[5*$n+1];bn===0?(bn=un,Hn+=fn):bn+=un,this.g[5*$n]=bn,this.g[5*$n+1]=Hn,un=bn,fn=Hn}}let dt=Q,bt=ge;this.f&&this.j>0&&(dt-=this.c,dt===0&&(bt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=bt,this.g[this.j++]=Me,this.g[this.j++]=Ye,this.g[this.j++]=it,this.c=Q,this.e=ge}static r(Q){const ge=[],Me=Q.length/5|0;for(let bt=0;bt<Me;bt++)ge[bt]=bt;ge.sort((bt,Ht)=>{const un=Q[5*bt],fn=Q[5*Ht];if(un===fn){const $n=Q[5*bt+1],bn=Q[5*Ht+1];return $n-bn}return un-fn});const Ye=new Uint32Array(Q.length);let it=0,dt=0;for(let bt=0;bt<Me;bt++){const Ht=5*ge[bt],un=Q[Ht+0],fn=Q[Ht+1],$n=Q[Ht+2],bn=Q[Ht+3],Hn=Q[Ht+4],Mi=un-it,dr=Mi===0?fn-dt:fn,Gn=5*bt;Ye[Gn+0]=Mi,Ye[Gn+1]=dr,Ye[Gn+2]=$n,Ye[Gn+3]=bn,Ye[Gn+4]=Hn,it=un,dt=fn}return Ye}build(Q){return this.f?new Un(new Uint32Array(this.g),Q):new Un(An.r(this.g),Q)}}e.$mO=An;class Un{constructor(Q,ge){this.resultId=ge,this.data=Q}}e.$nO=Un;class fi{constructor(Q,ge,Me){this.start=Q,this.deleteCount=ge,this.data=Me}}e.$oO=fi;class gi{constructor(Q,ge){this.resultId=ge,this.edits=Q}}e.$pO=gi;var ei;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(ei||(e.DebugConsoleMode=ei={}));class Vn{constructor(Q){this.name=Q}}e.$qO=Vn;let Rn=class{static{this.Back={iconPath:new on("arrow-left")}}constructor(){}};e.$rO=Rn,e.$rO=Rn=Ke([S],Rn);var Ve;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Ve||(e.QuickPickItemKind=Ve={}));var dn;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(dn||(e.InputBoxValidationSeverity=dn={}));var Wn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Wn||(e.ExtensionKind=Wn={}));class at{static validate(Q){if(typeof Q.badge=="string"){let ge=(0,b.$If)(Q.badge,0);if(ge<Q.badge.length&&(ge+=(0,b.$If)(Q.badge,ge)),Q.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}else if(Q.badge&&!on.isThemeIcon(Q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!Q.color&&!Q.badge&&!Q.tooltip)throw new Error("The decoration is empty");return!0}constructor(Q,ge,Me){this.badge=Q,this.tooltip=ge,this.color=Me}}e.$sO=at;let wt=class{constructor(Q){this.kind=Q}};e.$tO=wt,e.$tO=wt=Ke([S],wt);var ti;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(ti||(e.ColorThemeKind=ti={}));class mn{static isNotebookRange(Q){return Q instanceof mn?!0:Q?typeof Q.start=="number"&&typeof Q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(Q,ge){if(Q<0)throw(0,L.$7)("start must be positive");if(ge<0)throw(0,L.$7)("end must be positive");Q<=ge?(this.c=Q,this.e=ge):(this.c=ge,this.e=Q)}with(Q){let ge=this.c,Me=this.e;return Q.start!==void 0&&(ge=Q.start),Q.end!==void 0&&(Me=Q.end),ge===this.c&&Me===this.e?this:new mn(ge,Me)}}e.$uO=mn;class kn{static validate(Q){if(typeof Q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof Q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof Q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(Q){return Array.isArray(Q)&&Q.every(ge=>kn.isNotebookCellData(ge))}static isNotebookCellData(Q){return!0}constructor(Q,ge,Me,Ye,it,dt,bt){this.kind=Q,this.value=ge,this.languageId=Me,this.mime=Ye,this.outputs=it??[],this.metadata=dt,this.executionSummary=bt,kn.validate(this)}}e.$vO=kn;class mi{constructor(Q){this.cells=Q}}e.$wO=mi;class en{static isNotebookCellOutputItem(Q){return Q instanceof en?!0:Q?typeof Q.mime=="string"&&Q.data instanceof Uint8Array:!1}static error(Q){const ge={name:Q.name,message:Q.message,stack:Q.stack};return en.json(ge,"application/vnd.code.notebook.error")}static stdout(Q){return en.text(Q,"application/vnd.code.notebook.stdout")}static stderr(Q){return en.text(Q,"application/vnd.code.notebook.stderr")}static bytes(Q,ge="application/octet-stream"){return new en(Q,ge)}static#e=new TextEncoder;static text(Q,ge=N.$Qs.text){const Me=en.#e.encode(String(Q));return new en(Me,ge)}static json(Q,ge="text/x-json"){const Me=JSON.stringify(Q,void 0,"	");return en.text(Me,ge)}constructor(Q,ge){this.data=Q,this.mime=ge;const Me=(0,N.$Us)(ge,!0);if(!Me)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Me}}e.$xO=en;class Nn{static isNotebookCellOutput(Q){return Q instanceof Nn?!0:!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&Array.isArray(Q.items)}static ensureUniqueMimeTypes(Q,ge=!1){const Me=new Set,Ye=new Set;for(let it=0;it<Q.length;it++){const dt=Q[it],bt=(0,N.$Us)(dt.mime);if(!Me.has(bt)||(0,w.$ZK)(bt)){Me.add(bt);continue}Ye.add(it),ge&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ye.size===0?Q:Q.filter((it,dt)=>!Ye.has(dt))}constructor(Q,ge,Me){this.items=Nn.ensureUniqueMimeTypes(Q,!0),typeof ge=="string"?(this.id=ge,this.metadata=Me):(this.id=(0,A.$Sg)(),this.metadata=ge??Me)}}e.$yO=Nn;var ni;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(ni||(e.NotebookCellKind=ni={}));var ii;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(ii||(e.NotebookCellExecutionState=ii={}));var qn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(qn||(e.NotebookCellStatusBarAlignment=qn={}));var ri;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ri||(e.NotebookEditorRevealType=ri={}));class $i{constructor(Q,ge){this.text=Q,this.alignment=ge}}e.$zO=$i;var si;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(si||(e.NotebookControllerAffinity=si={}));var oi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(oi||(e.NotebookControllerAffinity2=oi={}));class pi{constructor(Q,ge=[]){this.uri=Q,this.provides=(0,d.$3b)(ge)}}e.$AO=pi;class bi{constructor(Q){this.label=Q}}e.$BO=bi;var ai;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(ai||(e.NotebookVariablesRequestKind=ai={}));let Qn=class{constructor(Q,ge){this.label=Q,this.timestamp=ge}};e.$CO=Qn,e.$CO=Qn=Ke([S],Qn);var ci;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(ci||(e.ExtensionMode=ci={}));var ui;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(ui||(e.ExtensionRuntime=ui={}));var li;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(li||(e.StandardTokenType=li={}));class de{constructor(Q,ge){this.ranges=Q,this.wordPattern=ge}}e.$DO=de;class Ee{constructor(Q){this.c=Q}get autoForwardAction(){return this.c}}e.$EO=Ee;var Ue;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Ue||(e.TestResultState=Ue={}));var ct;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(ct||(e.TestRunProfileKind=ct={}));let yt=class{constructor(Q=void 0,ge=void 0,Me=void 0,Ye=!1,it=!0){this.include=Q,this.exclude=ge,this.profile=Me,this.continuous=Ye,this.preserveFocus=it}};e.$FO=yt,e.$FO=yt=Ke([S],yt);let At=k=class{static diff(Q,ge,Me){const Ye=new k(Q);return Ye.expectedOutput=ge,Ye.actualOutput=Me,Ye}constructor(Q){this.message=Q}};e.$GO=At,e.$GO=At=k=Ke([S],At);let Sn=class{constructor(Q){this.id=Q}};e.$HO=Sn,e.$HO=Sn=Ke([S],Sn);class hi{constructor(Q,ge){this.covered=Q,this.total=ge,vi(this)}}e.$IO=hi;function vi(H){if(H){if(H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`);if(H.total<0)throw new Error(`The number of covered items (${H.total}) cannot be negative`)}}class wi{static fromDetails(Q,ge){const Me=new hi(0,0),Ye=new hi(0,0),it=new hi(0,0);for(const bt of ge)if("branches"in bt){Me.total+=1,Me.covered+=bt.executed?1:0;for(const Ht of bt.branches)Ye.total+=1,Ye.covered+=Ht.executed?1:0}else it.total+=1,it.covered+=bt.executed?1:0;const dt=new wi(Q,Me,Ye.total>0?Ye:void 0,it.total>0?it:void 0);return dt.detailedCoverage=ge,dt}constructor(Q,ge,Me,Ye){this.uri=Q,this.statementCoverage=ge,this.branchCoverage=Me,this.declarationCoverage=Ye}}e.$KO=wi;class Ti{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,ge,Me=[]){this.executed=Q,this.location=ge,this.branches=Me}}e.$LO=Ti;class Fi{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,ge,Me){this.executed=Q,this.location=ge,this.label=Me}}e.$MO=Fi;class ji{get executionCount(){return+this.executed}set executionCount(Q){this.executed=Q}constructor(Q,ge,Me){this.name=Q,this.executed=ge,this.location=Me}}e.$NO=ji;var yi;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(yi||(e.ExternalUriOpenerPriority=yi={}));var Ei;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Ei||(e.WorkspaceTrustState=Ei={}));var ki;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(ki||(e.PortAutoForwardAction=ki={}));class zi{constructor(Q,ge,Me,Ye,it,dt){this.kind=Q,this.name=ge,this.detail=Me,this.uri=Ye,this.range=it,this.selectionRange=dt}}e.$OO=zi;class Bi{constructor(Q){this.uri=Q}}e.$PO=Bi;class Ui{constructor(Q,ge){this.original=Q,this.modified=ge}}e.$QO=Ui;class Vi{constructor(Q,ge,Me,Ye){this.base=Q,this.input1=ge,this.input2=Me,this.result=Ye}}e.$RO=Vi;class Wi{constructor(Q,ge){this.uri=Q,this.viewType=ge}}e.$SO=Wi;class qi{constructor(Q){this.viewType=Q}}e.$TO=qi;class Qi{constructor(Q,ge){this.uri=Q,this.notebookType=ge}}e.$UO=Qi;class Hi{constructor(Q,ge,Me){this.original=Q,this.modified=ge,this.notebookType=Me}}e.$VO=Hi;class Gi{constructor(){}}e.$WO=Gi;class Ki{constructor(Q,ge){this.uri=Q,this.inputBoxUri=ge}}e.$XO=Ki;class Ji{constructor(){}}e.$YO=Ji;class Zi{constructor(Q){this.textDiffs=Q}}e.$ZO=Zi;var Si;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(Si||(e.InteractiveSessionVoteDirection=Si={}));var Di;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(Di||(e.ChatCopyKind=Di={}));var Pi;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(Pi||(e.ChatVariableLevel=Pi={}));class Xi{constructor(Q,ge){this.label=Q,this.values=ge}}e.$1O=Xi;var Ci;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(Ci||(e.InteractiveEditorResponseFeedbackKind=Ci={}));var Ii;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Ii||(e.ChatResultFeedbackKind=Ii={}));class Yi{constructor(Q){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new Je(Q):Q}}e.$2O=Yi;class xi{constructor(Q,ge){if(typeof Q!="string"&&Q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof Q=="string"?new Je(Q):Q,this.vulnerabilities=ge}}e.$3O=xi;class _i{constructor(Q,ge){this.participant=Q,this.command=ge}}e.$4O=_i;class er{constructor(Q,ge){this.value=Q,this.baseUri=ge}}e.$5O=er;class tr{constructor(Q,ge){this.value=Q,this.title=ge}}e.$6O=tr;class nr{constructor(Q){this.value=Q}}e.$7O=nr;class ir{constructor(Q){this.value=Q}}e.$8O=ir;class rr{constructor(Q,ge){this.value=Q,this.iconPath=ge}}e.$9O=rr;class sr{constructor(Q,ge){this.uri=Q,this.edits=Array.isArray(ge)?ge:[ge]}}e.$0O=sr;class or{constructor(Q,ge,Me,Ye){this.prompt=Q,this.command=ge,this.variables=Me,this.participant=Ye}}e.$$O=or;class ar{constructor(Q,ge,Me,Ye){this.response=Q,this.result=ge,this.participant=Me,this.command=Ye}}e.$_O=ar;var Ai;(function(H){H[H.Panel=1]="Panel",H[H.Terminal=2]="Terminal",H[H.Notebook=3]="Notebook",H[H.Editor=4]="Editor"})(Ai||(e.ChatLocation=Ai={}));class cr{constructor(Q){this.content=Q}}e.$aP=cr;class ur{constructor(Q,ge){this.content=Q,this.name=ge}}e.$bP=ur;class lr{constructor(Q,ge){this.content=Q,this.name=ge}}e.$cP=lr;class On extends Error{static NotFound(Q){return new On(Q,On.NotFound.name)}static NoPermissions(Q){return new On(Q,On.NoPermissions.name)}constructor(Q,ge,Me){super(Q,{cause:Me}),this.name="LanguageModelError",this.code=ge??""}}e.$dP=On;var Ri;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Ri||(e.RelatedInformationType=Ri={}));var Ni;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped",H[H.Error=5]="Error"})(Ni||(e.SpeechToTextStatus=Ni={}));var Oi;(function(H){H[H.Recognized=1]="Recognized",H[H.Stopped=2]="Stopped"})(Oi||(e.KeywordRecognitionStatus=Oi={}));class hr{constructor(Q,ge){this.text=Q,this.range=ge}}e.$eP=hr;var Li;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Li||(e.InlineEditTriggerKind=Li={}))}),define(ke[329],Se([1,0,6,8]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;class O{constructor(N){this.a=new Map,this.b=0,this.c=N.getProxy(d.$3M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(N,b,m){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(N);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(b,m)??[]}getRelatedInformation(N,b,m){return this.c.$getAiRelatedInformation(b,m)}registerRelatedInformationProvider(N,b,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiRelatedInformationProvider(E,b),new L.$5M(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$_kc=O}),define(ke[121],Se([1,0,4,6,8,25,146,5,20]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=void 0,e.$klc=(0,b.$wi)("IExtHostAuthentication");let E=class{constructor(p){this.b=new Map,this.c=new d.$ee,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=p.getProxy(L.$3M.MainThreadAuthentication)}async getSession(p,y,w,h={}){const f=R.$Rm.toKey(p.identifier),a=[...w].sort().join(" ");return await this.d.getOrCreate(`${f} ${y} ${a}`,async()=>{await this.a.$ensureProvider(y);const n=p.displayName||p.name;return this.a.$getSession(y,w,f,n,h)})}async getSessions(p,y,w){const h=R.$Rm.toKey(p.identifier),f=[...w].sort().join(" ");return await this.f.getOrCreate(`${h} ${f}`,async()=>{await this.a.$ensureProvider(y);const a=p.displayName||p.name;return this.a.$getSessions(y,w,h,a)})}async removeSession(p,y){const w=this.b.get(p);return w?w.provider.removeSession(y):this.a.$removeSession(p,y)}registerAuthenticationProvider(p,y,w,h){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:y,provider:w,options:h??{supportsMultipleAccounts:!1}});const f=w.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(p,a));return this.a.$registerAuthenticationProvider(p,y,h?.supportsMultipleAccounts??!1),new O.$5M(()=>{f.dispose(),this.b.delete(p),this.a.$unregisterAuthenticationProvider(p)})}$createSession(p,y,w){const h=this.b.get(p);if(h)return Promise.resolve(h.provider.createSession(y,w));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$removeSession(p,y){const w=this.b.get(p);if(w)return Promise.resolve(w.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$getSessions(p,y){const w=this.b.get(p);if(w)return Promise.resolve(w.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,y){return p.startsWith(N.$5L)||this.c.fire({provider:{id:p,label:y}}),Promise.resolve()}};e.$llc=E,e.$llc=E=Ke([We(0,m.$qP)],E);class A{constructor(){this.a=new Map}getOrCreate(p,y){const w=this.a.get(p);if(w)return w;const h=y().finally(()=>this.a.delete(p));return this.a.set(p,h),h}}}),define(ke[152],Se([1,0,2,6,8,5,20,11,19,14,17,26]),function(le,e,d,L,O,R,N,b,m,E,A,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0;let y=class{static{p=this}static{this.c=0}static{this.d=250}constructor(h,f){this.h=f,this.f=new Map,this.g=h.getProxy(L.$3M.MainThreadDecorations)}registerFileDecorationProvider(h,f){const a=p.c++;this.f.set(a,{provider:h,extensionDescription:f}),this.g.$registerDecorationProvider(a,f.identifier.value);const n=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(a,null);return}const u=(0,m.$3b)(i);if(u.length<=p.d){this.g.$onDidChange(a,u);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,u.length);const o=u.map(r=>({uri:r,rank:(0,E.$bf)(r.path,"/")})),t=(0,m.$zb)(o,(r,c)=>r.rank-c.rank||(0,E.$rf)(r.uri.path,c.uri.path)),l=[];e:for(const r of t){let c;for(const s of r){const v=(0,A.$nc)(s.uri.path);if(c!==v&&(c=v,l.push(s.uri)>=p.d))break e}}this.g.$onDidChange(a,l)});return new O.$5M(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(h,f,a){if(!this.f.has(h))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:u}=this.f.get(h);return await Promise.all(f.map(async o=>{try{const{uri:t,id:l}=o,r=await Promise.resolve(i.provideFileDecoration(d.URI.revive(t),a));if(!r)return;try{O.$sO.validate(r),r.badge&&typeof r.badge!="string"&&(0,P.$IG)(u,"codiconDecoration"),n[l]=[r.propagate,r.tooltip,r.badge,r.color]}catch(c){this.h.warn(`INVALID decoration from extension '${u.identifier.value}': ${c}`)}}catch(t){this.h.error(t)}})),n}};e.$kmc=y,e.$kmc=y=p=Ke([We(0,N.$qP),We(1,b.$3j)],y),e.$lmc=(0,R.$wi)("IExtHostDecorations")}),define(ke[330],Se([1,0,13,2,8,6,15,22,14]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=void 0;class E{static{this.a=0}constructor(P,p,y){this.d=p,this.e=y,this.b=new Map,this.c=P.getProxy(R.$3M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,p){if(Object.keys(N.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const y=E.a++;this.b.set(y,p),this.c.$registerTextContentProvider(y,P);let w;if(typeof p.onDidChange=="function"){let h;w=p.onDidChange(async f=>{if(f.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;h&&await h;const a=this.$provideTextDocumentContent(y,f).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(f);if(!i)return;const u=(0,m.$lf)(n);if(!i.equalLines(u))return this.c.$onVirtualDocumentChange(f,n)}).catch(d.$1).finally(()=>{h===a&&(h=void 0)});h=a})}return new O.$5M(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(P,p){const y=this.b.get(P);return y?Promise.resolve(y.provideTextDocumentContent(L.URI.revive(p),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$nmc=E}),define(ke[153],Se([1,0,62,15,14,188,130,8,19]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.$tP=void 0,e.$sP=A;const E=new Map;function A(w,h){h?E.set(w,h):E.delete(w)}function P(w){return E.get(w)}class p extends R.$Zv{constructor(h,f,a,n,i,u,o){super(f,a,n,i),this.c=h,this.m=u,this.q=o,this.b=!1}dispose(){(0,d.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,m.$ub)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===L.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(f){return f?h.s(f):h.getText()},get eol(){return h.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(f){return h.t(f)},offsetAt(f){return h.u(f)},positionAt(f){return h.v(f)},validateRange(f){return h.w(f)},validatePosition(f){return h.x(f)},getWordRangeAtPosition(f,a){return h.y(f,a)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,d.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,d.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const f=this.w(h);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const a=this.g,n=f.start.line,i=f.end.line,u=[];u.push(this.f[n].substring(f.start.character));for(let o=n+1;o<i;o++)u.push(this.f[o]);return u.push(this.f[i].substring(0,f.end.character)),u.join(a)}t(h){let f;if(h instanceof b.$6M?f=h.line:typeof h=="number"&&(f=h),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new y(f,this.f[f],f===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const f=this.j.getIndexOf(h),a=this.f[f.index].length;return new b.$6M(f.index,Math.min(f.remainder,a))}w(h){if(!(h instanceof b.$7M))throw new Error("Invalid argument");const f=this.x(h.start),a=this.x(h.end);return f===h.start&&a===h.end?h:new b.$7M(f.line,f.character,a.line,a.character)}x(h){if(!(h instanceof b.$6M))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:f,character:a}=h,n=!1;if(f<0)f=0,a=0,n=!0;else if(f>=this.f.length)f=this.f.length-1,a=this.f[f].length,n=!0;else{const i=this.f[f].length;a<0?(a=0,n=!0):a>i&&(a=i,n=!0)}return n?new b.$6M(f,a):h}y(h,f){const a=this.x(h);if(!f)f=P(this.m);else if((0,O.$kf)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const n=(0,N.$9s)(a.character+1,(0,N.$7s)(f),this.f[a.line],0);if(n)return new b.$7M(a.line,n.startColumn-1,a.line,n.endColumn-1)}}e.$tP=p;class y{constructor(h,f,a){this.a=h,this.b=f,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$7M(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$7M(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$uP=y}),define(ke[331],Se([1,0,6,8]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=void 0;class O{constructor(N){this.a=new Map,this.b=0,this.c=N.getProxy(d.$3M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(N,b,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(N);if(!E)throw new Error("Embedding vector provider not found");const A=await E.provideEmbeddingVector(b,m);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(N,b,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiEmbeddingVectorProvider(b,E),new L.$5M(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$pmc=O}),define(ke[70],Se([1,0,6,33,8,21,5,20,60,3,7,23,15]),function(le,e,d,L,O,R,N,b,m,E,A,P,p){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=void 0;let w=y=class{constructor(f,a){this.b=new Map,this.c=new A.$Fh,this.a=f.getProxy(d.$3M.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let u;const o=n.b.get(i.scheme);return o?(await n.a.$ensureActivation(i.scheme),u=await o.impl.stat(i)):u=await n.a.$stat(i),{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===L.FilePermission.Readonly?1:void 0}}catch(u){y.e(u)}},async readDirectory(i){try{const u=n.b.get(i.scheme);return u?(await n.a.$ensureActivation(i.scheme),(await u.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(u){return y.e(u)}},async createDirectory(i){try{const u=n.b.get(i.scheme);return u&&!u.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(u.impl,u.extUri,i)):await n.a.$mkdir(i)}catch(u){return y.e(u)}},async readFile(i){try{const u=n.b.get(i.scheme);return u?(await n.a.$ensureActivation(i.scheme),(await u.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(u){return y.e(u)}},async writeFile(i,u){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(o.impl,o.extUri,o.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(o.impl.writeFile(i,u,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$Ge.wrap(u))}catch(o){return y.e(o)}},async delete(i,u){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly&&!u?.useTrash?(await n.a.$ensureActivation(i.scheme),await o.impl.delete(i,{recursive:!1,...u})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...u})}catch(o){return y.e(o)}},async rename(i,u,o){try{return await n.a.$rename(i,u,{overwrite:!1,...o})}catch(t){return y.e(t)}},async copy(i,u,o){try{return await n.a.$copy(i,u,{overwrite:!1,...o})}catch(t){return y.e(t)}},isWritableFileSystem(i){const u=a.getCapabilities(i);if(typeof u=="number")return!(u&2048)}})}async d(f,a,n){const i=[];for(;!a.isEqual(n,a.dirname(n));)try{if(!((await f.stat(n)).type&L.FileType.Directory))throw O.$jO.FileExists(`Unable to create folder '${n.scheme===p.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(u){if(L.$gl(u)!==L.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(a.basename(n)),n=a.dirname(n)}for(let u=i.length-1;u>=0;u--){n=a.joinPath(n,i[u]);try{await f.createDirectory(n)}catch(o){if(L.$gl(o)!==L.FileSystemProviderErrorCode.FileExists)throw o}}}static e(f){if(f instanceof O.$jO)throw f;if(f instanceof L.$cl)switch(f.code){case L.FileSystemProviderErrorCode.FileExists:throw O.$jO.FileExists(f.message);case L.FileSystemProviderErrorCode.FileNotFound:throw O.$jO.FileNotFound(f.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw O.$jO.FileNotADirectory(f.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw O.$jO.FileIsADirectory(f.message);case L.FileSystemProviderErrorCode.NoPermissions:throw O.$jO.NoPermissions(f.message);case L.FileSystemProviderErrorCode.Unavailable:throw O.$jO.Unavailable(f.message);default:throw new O.$jO(f.message,f.name)}if(!(f instanceof Error))throw new O.$jO(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw O.$jO.Unavailable(f.message);switch(f.name){case L.FileSystemProviderErrorCode.FileExists:throw O.$jO.FileExists(f.message);case L.FileSystemProviderErrorCode.FileNotFound:throw O.$jO.FileNotFound(f.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw O.$jO.FileNotADirectory(f.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw O.$jO.FileIsADirectory(f.message);case L.FileSystemProviderErrorCode.NoPermissions:throw O.$jO.NoPermissions(f.message);case L.FileSystemProviderErrorCode.Unavailable:throw O.$jO.Unavailable(f.message);default:throw new O.$jO(f.message,f.name)}}addFileSystemProvider(f,a,n){return this.b.set(f,{impl:a,extUri:n?.isCaseSensitive?P.$Zg:P.$2g,isReadonly:!!n?.isReadonly}),(0,E.$Tc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??P.$Zg}};e.$Alc=w,e.$Alc=w=y=Ke([We(0,b.$qP),We(1,m.$elc)],w),e.$Blc=(0,N.$wi)("IExtHostConsumerFileSystem")}),define(ke[93],Se([1,0,5,28,11,70,2]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0,e.$Clc=(0,d.$wi)("IExtensionStoragePaths");let b=class{constructor(E,A,P){this.d=A,this.f=P,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(E){return N.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,A=await this.g(E);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(N.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:N.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(E){if(this.c)return N.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return N.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Dlc=b,e.$Dlc=b=Ke([We(0,L.$GP),We(1,O.$3j),We(2,R.$Blc)],b)}),define(ke[332],Se([1,0,8,20,4]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;let R=class{constructor(b){this.a=new d.$tO(d.ColorThemeKind.Dark),this.b=new O.$ee}get activeColorTheme(){return this.a}$onColorThemeChange(b){let m;switch(b){case"light":m=d.ColorThemeKind.Light;break;case"hcDark":m=d.ColorThemeKind.HighContrast;break;case"hcLight":m=d.ColorThemeKind.HighContrastLight;break;default:m=d.ColorThemeKind.Dark}this.a=new d.$tO(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$$mc=R,e.$$mc=R=Ke([We(0,L.$qP)],R)}),define(ke[71],Se([1,0,22,4,3,234,5,11,88,6,28,20,8]),function(le,e,d,L,O,R,N,b,m,E,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uDb=e.$tDb=e.TunnelDtoConverter=void 0;class y extends m.$mw{}var w;(function(f){function a(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}f.fromApiTunnel=a;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}f.fromServiceTunnel=n})(w||(e.TunnelDtoConverter=w={})),e.$tDb=(0,N.$wi)("IExtHostTunnelService");let h=class extends O.$Vc{constructor(a,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$ee,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(E.$3M.MainThreadTunnelService)}async openTunnel(a,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,a.displayName);if(i){const u=new y(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(u),u}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,n){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:a,provider:n}),this.a.$registerPortsAttributesProvider(a,i),new p.$5M(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(a,n,i,u,o){const t=[];for(const r of a){const c=this.r.get(r);if(!c)return[];t.push(...await Promise.all(n.map(async s=>{let v;try{v=await c.provider.providePortAttributes({port:s,pid:i,commandLine:u},o)}catch{v=await c.provider.providePortAttributes(s,i,u,o)}return{providedAttributes:v,port:s}})))}const l=t.filter(r=>!!r.providedAttributes);return l.length>0?l.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(u,o)=>await a.provideTunnel(u,o,d.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,O.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,n){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const i=a.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let u=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:u,protocol:!0}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,O.$Tc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,n){if(this.g.has(a.host)){const i=this.g.get(a.host);i.has(a.port)&&(n&&i.get(a.port).disposeListener.dispose(),await i.get(a.port).tunnel.dispose(),i.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(a,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const u=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),u===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const o=this.B(u.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(u.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:u,disposeListener:o}),w.fromApiTunnel(u)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(a){const n=await Promise.all(a.map(u=>this.f(u.host,u.port,u.detail??""))),i=a.filter((u,o)=>n[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(u=>u.port).join(", ")} to ${i.map(u=>u.port).join(", ")}`),i}};e.$uDb=h,e.$uDb=h=Ke([We(0,P.$qP),We(1,A.$GP),We(2,b.$3j)],h)}),define(ke[16],Se([1,0,19,21,177,75,81,27,167,58,101,24,172,23,18,2,29,84,139,145,143,296,120,69,89,308,8,50]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u,o,t,l,r,c,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$nP=U,e.$oP=te,e.$pP=q;var g;(function(Ne){function je(x){const{selectionStartLineNumber:Te,selectionStartColumn:Qe,positionLineNumber:_e,positionColumn:Ze}=x,ht=new s.$6M(Te-1,Qe-1),Et=new s.$6M(_e-1,Ze-1);return new s.$8M(ht,Et)}Ne.to=je;function ye(x){const{anchor:Te,active:Qe}=x;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Qe.line+1,positionColumn:Qe.character+1}}Ne.from=ye})(g||(e.Selection=g={}));var D;(function(Ne){function je(x){if(!x)return;const{start:Te,end:Qe}=x;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Qe.line+1,endColumn:Qe.character+1}}Ne.from=je;function ye(x){if(!x)return;const{startLineNumber:Te,startColumn:Qe,endLineNumber:_e,endColumn:Ze}=x;return new s.$7M(Te-1,Qe-1,_e-1,Ze-1)}Ne.to=ye})(D||(e.Range=D={}));var $;(function(Ne){function je(x){return{uri:x.uri,range:D.from(x.range)}}Ne.from=je;function ye(x){return new s.$eN(h.URI.revive(x.uri),D.to(x.range))}Ne.to=ye})($||(e.Location=$={}));var k;(function(Ne){function je(ye){switch(ye){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ne.to=je})(k||(e.TokenType=k={}));var S;(function(Ne){function je(x){return new s.$6M(x.lineNumber-1,x.column-1)}Ne.to=je;function ye(x){return{lineNumber:x.line+1,column:x.character+1}}Ne.from=ye})(S||(e.Position=S={}));var C;(function(Ne){function je(Te,Qe,_e){return(0,d.$Hb)((0,d.$3b)(Te).map(Ze=>ye(Ze,Qe,_e)))}Ne.from=je;function ye(Te,Qe,_e){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:_e?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:x(Te.scheme,Qe),pattern:Ie.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:_e?.isBuiltin}}function x(Te,Qe){return Qe&&typeof Te=="string"?Qe.transformOutgoingScheme(Te):Te}})(C||(e.DocumentSelector=C={}));var I;(function(Ne){function je(x){switch(x){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ne.from=je;function ye(x){switch(x){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ne.to=ye})(I||(e.DiagnosticTag=I={}));var F;(function(Ne){function je(x){let Te;return x.code&&((0,w.$9f)(x.code)||(0,w.$ag)(x.code)?Te=String(x.code):Te={value:String(x.code.value),target:x.code.target}),{...D.from(x.range),message:x.message,source:x.source,code:Te,severity:z.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(j.from),tags:Array.isArray(x.tags)?(0,d.$Hb)(x.tags.map(I.from)):void 0}}Ne.from=je;function ye(x){const Te=new s.$gN(D.to(x),x.message,z.to(x.severity));return Te.source=x.source,Te.code=(0,w.$9f)(x.code)?x.code:x.code?.value,Te.relatedInformation=x.relatedInformation&&x.relatedInformation.map(j.to),Te.tags=x.tags&&(0,d.$Hb)(x.tags.map(I.to)),Te}Ne.to=ye})(F||(e.Diagnostic=F={}));var j;(function(Ne){function je(x){return{...D.from(x.location.range),message:x.message,resource:x.location.uri}}Ne.from=je;function ye(x){return new s.$fN(new s.$eN(x.resource,D.to(x)),x.message)}Ne.to=ye})(j||(e.DiagnosticRelatedInformation=j={}));var z;(function(Ne){function je(x){switch(x){case s.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Ne.from=je;function ye(x){switch(x){case n.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ne.to=ye})(z||(e.DiagnosticSeverity=z={}));var M;(function(Ne){function je(x){return typeof x=="number"&&x>=s.ViewColumn.One?x-1:x===s.ViewColumn.Beside?c.$XD:c.$WD}Ne.from=je;function ye(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}Ne.to=ye})(M||(e.ViewColumn=M={}));function T(Ne){return typeof Ne.range<"u"}function U(Ne){return Ne.length===0?!0:!!T(Ne[0])}var Z;(function(Ne){function je(Ze){return Ze.map(Ne.from)}Ne.fromMany=je;function ye(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function x(Ze){let ht;if(ye(Ze)){const{language:Tt,value:Bt}=Ze;ht={value:"```"+Tt+`
`+Bt+"\n```\n"}}else s.$uN.isMarkdownString(Ze)?ht={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons,supportHtml:Ze.supportHtml,baseUri:Ze.baseUri}:typeof Ze=="string"?ht={value:Ze}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const zt=Tt=>{try{let Bt=h.URI.parse(Tt,!0);Bt=Bt.with({query:Te(Bt.query,Et)}),Et[Tt]=Bt}catch{}return""},lt=new m.marked.Renderer;return lt.link=zt,lt.image=Tt=>typeof Tt=="string"?zt(N.$2k(Tt).href):"",(0,m.marked)(ht.value,{renderer:lt}),ht}Ne.from=x;function Te(Ze,ht){if(!Ze)return Ze;let Et;try{Et=(0,E.$5h)(Ze)}catch{}if(!Et)return Ze;let zt=!1;return Et=(0,P.$5n)(Et,lt=>{if(h.URI.isUri(lt)){const Tt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[Tt]=lt,zt=!0,Tt}else return}),zt?JSON.stringify(Et):Ze}function Qe(Ze){const ht=new s.$uN(Ze.value,Ze.supportThemeIcons);return ht.isTrusted=Ze.isTrusted,ht.supportHtml=Ze.supportHtml,ht.baseUri=Ze.baseUri?h.URI.from(Ze.baseUri):void 0,ht}Ne.to=Qe;function _e(Ze){if(Ze)return typeof Ze=="string"?Ze:Ne.from(Ze)}Ne.fromStrict=_e})(Z||(e.MarkdownString=Z={}));function te(Ne){return U(Ne)?Ne.map(je=>({range:D.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?Z.fromMany(je.hoverMessage):je.hoverMessage?Z.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Ne.map(je=>({range:D.from(je)}))}function q(Ne){return typeof Ne>"u"?Ne:typeof Ne=="string"?h.URI.file(Ne):Ne}var K;(function(Ne){function je(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?q(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Ne.from=je})(K||(e.ThemableDecorationAttachmentRenderOptions=K={}));var Y;(function(Ne){function je(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?q(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?K.from(ye.before):void 0,after:ye.after?K.from(ye.after):void 0}}Ne.from=je})(Y||(e.ThemableDecorationRenderOptions=Y={}));var ie;(function(Ne){function je(ye){if(typeof ye>"u")return ye;switch(ye){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ne.from=je})(ie||(e.DecorationRangeBehavior=ie={}));var $e;(function(Ne){function je(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?ie.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?Y.from(ye.light):void 0,dark:ye.dark?Y.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?q(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?K.from(ye.before):void 0,after:ye.after?K.from(ye.after):void 0}}Ne.from=je})($e||(e.DecorationRenderOptions=$e={}));var ue;(function(Ne){function je(x){return{text:x.newText,eol:x.newEol&&He.from(x.newEol),range:D.from(x.range)}}Ne.from=je;function ye(x){const Te=new s.$_M(D.to(x.range),x.text);return Te.newEol=typeof x.eol>"u"?void 0:He.to(x.eol),Te}Ne.to=ye})(ue||(e.TextEdit=ue={}));var ve;(function(Ne){function je(x,Te){const Qe={edits:[]};if(x instanceof s.$cN){const _e=new b.$Cc;for(const Ze of x._allEntries())Ze._type===1&&h.URI.isUri(Ze.to)&&Ze.from===void 0&&_e.add(Ze.to);for(const Ze of x._allEntries())if(Ze._type===1){let ht;Ze.options?.contents&&(ArrayBuffer.isView(Ze.options.contents)?ht={type:"base64",value:(0,L.$1e)(L.$Ge.wrap(Ze.options.contents))}:ht={type:"dataTransferItem",id:Ze.options.contents._itemId}),Qe.edits.push({oldResource:Ze.from,newResource:Ze.to,options:{...Ze.options,contents:ht},metadata:Ze.metadata})}else Ze._type===2?Qe.edits.push({resource:Ze.uri,textEdit:ue.from(Ze.edit),versionId:_e.has(Ze.uri)?void 0:Te?.getTextDocumentVersion(Ze.uri),metadata:Ze.metadata}):Ze._type===6?Qe.edits.push({resource:Ze.uri,textEdit:{range:D.from(Ze.range),text:Ze.edit.value,insertAsSnippet:!0},versionId:_e.has(Ze.uri)?void 0:Te?.getTextDocumentVersion(Ze.uri),metadata:Ze.metadata}):Ze._type===3?Qe.edits.push({metadata:Ze.metadata,resource:Ze.uri,cellEdit:Ze.edit,notebookMetadata:Ze.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Ze.uri)}):Ze._type===5&&Qe.edits.push({metadata:Ze.metadata,resource:Ze.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Ze.uri),cellEdit:{editType:1,index:Ze.index,count:Ze.count,cells:Ze.cells.map(tn.from)}})}return Qe}Ne.from=je;function ye(x){const Te=new s.$cN,Qe=new b.$Bc;for(const _e of x.edits)if(_e.textEdit){const Ze=_e,ht=h.URI.revive(Ze.resource),Et=D.to(Ze.textEdit.range),zt=Ze.textEdit.text,lt=Ze.textEdit.insertAsSnippet;let Tt;lt?Tt=s.$bN.replace(Et,new s.$dN(zt)):Tt=s.$_M.replace(Et,zt);const Bt=Qe.get(ht);Bt?Bt.push(Tt):Qe.set(ht,[Tt])}else Te.renameFile(h.URI.revive(_e.oldResource),h.URI.revive(_e.newResource),_e.options);for(const[_e,Ze]of Qe)Te.set(_e,Ze);return Te}Ne.to=ye})(ve||(e.WorkspaceEdit=ve={}));var _;(function(Ne){const je=Object.create(null);je[s.SymbolKind.File]=0,je[s.SymbolKind.Module]=1,je[s.SymbolKind.Namespace]=2,je[s.SymbolKind.Package]=3,je[s.SymbolKind.Class]=4,je[s.SymbolKind.Method]=5,je[s.SymbolKind.Property]=6,je[s.SymbolKind.Field]=7,je[s.SymbolKind.Constructor]=8,je[s.SymbolKind.Enum]=9,je[s.SymbolKind.Interface]=10,je[s.SymbolKind.Function]=11,je[s.SymbolKind.Variable]=12,je[s.SymbolKind.Constant]=13,je[s.SymbolKind.String]=14,je[s.SymbolKind.Number]=15,je[s.SymbolKind.Boolean]=16,je[s.SymbolKind.Array]=17,je[s.SymbolKind.Object]=18,je[s.SymbolKind.Key]=19,je[s.SymbolKind.Null]=20,je[s.SymbolKind.EnumMember]=21,je[s.SymbolKind.Struct]=22,je[s.SymbolKind.Event]=23,je[s.SymbolKind.Operator]=24,je[s.SymbolKind.TypeParameter]=25;function ye(Te){return typeof je[Te]=="number"?je[Te]:6}Ne.from=ye;function x(Te){for(const Qe in je)if(je[Qe]===Te)return Number(Qe);return s.SymbolKind.Property}Ne.to=x})(_||(e.SymbolKind=_={}));var B;(function(Ne){function je(x){switch(x){case s.SymbolTag.Deprecated:return 1}}Ne.from=je;function ye(x){switch(x){case 1:return s.SymbolTag.Deprecated}}Ne.to=ye})(B||(e.SymbolTag=B={}));var ee;(function(Ne){function je(x){return{name:x.name,kind:_.from(x.kind),tags:x.tags&&x.tags.map(B.from),containerName:x.containerName,location:re.from(x.location)}}Ne.from=je;function ye(x){const Te=new s.$lN(x.name,_.to(x.kind),x.containerName,re.to(x.location));return Te.tags=x.tags&&x.tags.map(B.to),Te}Ne.to=ye})(ee||(e.WorkspaceSymbol=ee={}));var pe;(function(Ne){function je(x){const Te={name:x.name||"!!MISSING: name!!",detail:x.detail,range:D.from(x.range),selectionRange:D.from(x.selectionRange),kind:_.from(x.kind),tags:x.tags?.map(B.from)??[]};return x.children&&(Te.children=x.children.map(je)),Te}Ne.from=je;function ye(x){const Te=new s.$mN(x.name,x.detail,_.to(x.kind),D.to(x.range),D.to(x.selectionRange));return(0,d.$Lb)(x.tags)&&(Te.tags=x.tags.map(B.to)),x.children&&(Te.children=x.children.map(ye)),Te}Ne.to=ye})(pe||(e.DocumentSymbol=pe={}));var Ce;(function(Ne){function je(x){const Te=new s.$qN(_.to(x.kind),x.name,x.detail||"",h.URI.revive(x.uri),D.to(x.range),D.to(x.selectionRange));return Te._sessionId=x._sessionId,Te._itemId=x._itemId,Te}Ne.to=je;function ye(x,Te,Qe){if(Te=Te??x._sessionId,Qe=Qe??x._itemId,Te===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Qe,name:x.name,detail:x.detail,kind:_.from(x.kind),uri:x.uri,range:D.from(x.range),selectionRange:D.from(x.selectionRange),tags:x.tags?.map(B.from)}}Ne.from=ye})(Ce||(e.CallHierarchyItem=Ce={}));var oe;(function(Ne){function je(ye){return new s.$rN(Ce.to(ye.from),ye.fromRanges.map(x=>D.to(x)))}Ne.to=je})(oe||(e.CallHierarchyIncomingCall=oe={}));var se;(function(Ne){function je(ye){return new s.$sN(Ce.to(ye.to),ye.fromRanges.map(x=>D.to(x)))}Ne.to=je})(se||(e.CallHierarchyOutgoingCall=se={}));var re;(function(Ne){function je(x){return{range:x.range&&D.from(x.range),uri:x.uri}}Ne.from=je;function ye(x){return new s.$eN(h.URI.revive(x.uri),D.to(x.range))}Ne.to=ye})(re||(e.location=re={}));var G;(function(Ne){function je(x){const Te=x,Qe=x;return{originSelectionRange:Te.originSelectionRange?D.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Qe.uri,range:D.from(Te.targetRange?Te.targetRange:Qe.range),targetSelectionRange:Te.targetSelectionRange?D.from(Te.targetSelectionRange):void 0}}Ne.from=je;function ye(x){return{targetUri:h.URI.revive(x.uri),targetRange:D.to(x.range),targetSelectionRange:x.targetSelectionRange?D.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?D.to(x.originSelectionRange):void 0}}Ne.to=ye})(G||(e.DefinitionLink=G={}));var ne;(function(Ne){function je(x){return{range:D.from(x.range),contents:Z.fromMany(x.contents),canIncreaseVerbosity:x.canIncreaseVerbosity,canDecreaseVerbosity:x.canDecreaseVerbosity}}Ne.from=je;function ye(x){const Te=x.contents.map(Z.to),Qe=D.to(x.range),_e=x.canIncreaseVerbosity,Ze=x.canDecreaseVerbosity;return new s.$iN(Te,Qe,_e,Ze)}Ne.to=ye})(ne||(e.Hover=ne={}));var me;(function(Ne){function je(x){return{range:D.from(x.range),expression:x.expression}}Ne.from=je;function ye(x){return new s.$dO(D.to(x.range),x.expression)}Ne.to=ye})(me||(e.EvaluatableExpression=me={}));var be;(function(Ne){function je(x){if(x instanceof s.$eO)return{type:"text",range:D.from(x.range),text:x.text};if(x instanceof s.$fO)return{type:"variable",range:D.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof s.$gO)return{type:"expression",range:D.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}Ne.from=je;function ye(x){switch(x.type){case"text":return{range:D.to(x.range),text:x.text};case"variable":return{range:D.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:D.to(x.range),expression:x.expression}}}Ne.to=ye})(be||(e.InlineValue=be={}));var Re;(function(Ne){function je(x){return{frameId:x.frameId,stoppedLocation:D.from(x.stoppedLocation)}}Ne.from=je;function ye(x){return new s.$hO(x.frameId,D.to(x.stoppedLocation))}Ne.to=ye})(Re||(e.InlineValueContext=Re={}));var fe;(function(Ne){function je(x){return{range:D.from(x.range),kind:x.kind}}Ne.from=je;function ye(x){return new s.$jN(D.to(x.range),x.kind)}Ne.to=ye})(fe||(e.DocumentHighlight=fe={}));var De;(function(Ne){function je(x){return{uri:x.uri,highlights:x.highlights.map(fe.from)}}Ne.from=je;function ye(x){return new s.$kN(h.URI.revive(x.uri),x.highlights.map(fe.to))}Ne.to=ye})(De||(e.MultiDocumentHighlight=De={}));var Ae;(function(Ne){function je(ye){switch(ye){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ne.to=je})(Ae||(e.CompletionTriggerKind=Ae={}));var ze;(function(Ne){function je(ye){return{triggerKind:Ae.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Ne.to=je})(ze||(e.CompletionContext=ze={}));var W;(function(Ne){function je(x){switch(x){case s.CompletionItemTag.Deprecated:return 1}}Ne.from=je;function ye(x){switch(x){case 1:return s.CompletionItemTag.Deprecated}}Ne.to=ye})(W||(e.CompletionItemTag=W={}));var V;(function(Ne){const je=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ye(Qe){return je.get(Qe)??9}Ne.from=ye;const x=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(Qe){return x.get(Qe)??s.CompletionItemKind.Property}Ne.to=Te})(V||(e.CompletionItemKind=V={}));var J;(function(Ne){function je(ye,x){const Te=new s.$AN(ye.label);return Te.insertText=ye.insertText,Te.kind=V.to(ye.kind),Te.tags=ye.tags?.map(W.to),Te.detail=ye.detail,Te.documentation=N.$Vk(ye.documentation)?Z.to(ye.documentation):ye.documentation,Te.sortText=ye.sortText,Te.filterText=ye.filterText,Te.preselect=ye.preselect,Te.commitCharacters=ye.commitCharacters,f.$ut.isIRange(ye.range)?Te.range=D.to(ye.range):typeof ye.range=="object"&&(Te.range={inserting:D.to(ye.range.insert),replacing:D.to(ye.range.replace)}),Te.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Te.insertText=new s.$dN(ye.insertText):(Te.insertText=ye.insertText,Te.textEdit=Te.range instanceof s.$7M?new s.$_M(Te.range,Te.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Te.additionalTextEdits=ye.additionalTextEdits.map(Qe=>ue.to(Qe))),Te.command=x&&ye.command?x.fromInternal(ye.command):void 0,Te}Ne.to=je})(J||(e.CompletionItem=J={}));var X;(function(Ne){function je(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:Z.fromStrict(x.documentation)}}Ne.from=je;function ye(x){return{label:x.label,documentation:N.$Vk(x.documentation)?Z.to(x.documentation):x.documentation}}Ne.to=ye})(X||(e.ParameterInformation=X={}));var he;(function(Ne){function je(x){return{label:x.label,documentation:Z.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(X.from):[],activeParameter:x.activeParameter}}Ne.from=je;function ye(x){return{label:x.label,documentation:N.$Vk(x.documentation)?Z.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(X.to):[],activeParameter:x.activeParameter}}Ne.to=ye})(he||(e.SignatureInformation=he={}));var we;(function(Ne){function je(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(he.from):[]}}Ne.from=je;function ye(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(he.to):[]}}Ne.to=ye})(we||(e.SignatureHelp=we={}));var Fe;(function(Ne){function je(ye,x){const Te=new s.$zN(S.to(x.position),typeof x.label=="string"?x.label:x.label.map(qe.to.bind(void 0,ye)),x.kind&&Je.to(x.kind));return Te.textEdits=x.textEdits&&x.textEdits.map(ue.to),Te.tooltip=N.$Vk(x.tooltip)?Z.to(x.tooltip):x.tooltip,Te.paddingLeft=x.paddingLeft,Te.paddingRight=x.paddingRight,Te}Ne.to=je})(Fe||(e.InlayHint=Fe={}));var qe;(function(Ne){function je(ye,x){const Te=new s.$yN(x.label);return Te.tooltip=N.$Vk(x.tooltip)?Z.to(x.tooltip):x.tooltip,a.Command.is(x.command)&&(Te.command=ye.fromInternal(x.command)),x.location&&(Te.location=re.to(x.location)),Te}Ne.to=je})(qe||(e.InlayHintLabelPart=qe={}));var Je;(function(Ne){function je(x){return x}Ne.from=je;function ye(x){return x}Ne.to=ye})(Je||(e.InlayHintKind=Je={}));var rt;(function(Ne){function je(x){return{range:D.from(x.range),url:x.target,tooltip:x.tooltip}}Ne.from=je;function ye(x){let Te;if(x.url)try{Te=typeof x.url=="string"?h.URI.parse(x.url,!0):h.URI.revive(x.url)}catch{}return new s.$FN(D.to(x.range),Te)}Ne.to=ye})(rt||(e.DocumentLink=rt={}));var tt;(function(Ne){function je(x){const Te=new s.$IN(x.label);return x.textEdit&&(Te.textEdit=ue.to(x.textEdit)),x.additionalTextEdits&&(Te.additionalTextEdits=x.additionalTextEdits.map(Qe=>ue.to(Qe))),Te}Ne.to=je;function ye(x){return{label:x.label,textEdit:x.textEdit?ue.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Te=>ue.from(Te)):void 0}}Ne.from=ye})(tt||(e.ColorPresentation=tt={}));var nt;(function(Ne){function je(x){return new s.$GN(x[0],x[1],x[2],x[3])}Ne.to=je;function ye(x){return[x.red,x.green,x.blue,x.alpha]}Ne.from=ye})(nt||(e.Color=nt={}));var st;(function(Ne){function je(x){return{range:D.from(x.range)}}Ne.from=je;function ye(x){return new s.$pN(D.to(x.range))}Ne.to=ye})(st||(e.SelectionRange=st={}));var Pe;(function(Ne){function je(ye){switch(ye){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ne.to=je})(Pe||(e.TextDocumentSaveReason=Pe={}));var Be;(function(Ne){function je(x){switch(x){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ne.from=je;function ye(x){switch(x){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ne.to=ye})(Be||(e.TextEditorLineNumbersStyle=Be={}));var He;(function(Ne){function je(x){if(x===s.EndOfLine.CRLF)return 1;if(x===s.EndOfLine.LF)return 0}Ne.from=je;function ye(x){if(x===1)return s.EndOfLine.CRLF;if(x===0)return s.EndOfLine.LF}Ne.to=ye})(He||(e.EndOfLine=He={}));var Le;(function(Ne){function je(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ne.from=je})(Le||(e.ProgressLocation=Le={}));var Xe;(function(Ne){function je(x){const Te={start:x.start+1,end:x.end+1};return x.kind&&(Te.kind=ae.from(x.kind)),Te}Ne.from=je;function ye(x){const Te={start:x.start-1,end:x.end-1};return x.kind&&(Te.kind=ae.to(x.kind)),Te}Ne.to=ye})(Xe||(e.FoldingRange=Xe={}));var ae;(function(Ne){function je(x){if(x)switch(x){case s.FoldingRangeKind.Comment:return a.$du.Comment;case s.FoldingRangeKind.Imports:return a.$du.Imports;case s.FoldingRangeKind.Region:return a.$du.Region}}Ne.from=je;function ye(x){if(x)switch(x.value){case a.$du.Comment.value:return s.FoldingRangeKind.Comment;case a.$du.Imports.value:return s.FoldingRangeKind.Imports;case a.$du.Region.value:return s.FoldingRangeKind.Region}}Ne.to=ye})(ae||(e.FoldingRangeKind=ae={}));var ce;(function(Ne){function je(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?D.from(ye.selection):void 0,override:typeof ye.override=="boolean"?u.$nF.id:void 0}}Ne.from=je})(ce||(e.TextEditorOpenOptions=ce={}));var Ie;(function(Ne){function je(Qe){return Qe instanceof s.$4N?Qe.toJSON():typeof Qe=="string"?Qe:ye(Qe)||x(Qe)?new s.$4N(Qe.baseUri??Qe.base,Qe.pattern).toJSON():Qe}Ne.from=je;function ye(Qe){const _e=Qe;return _e?h.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function x(Qe){const _e=Qe;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Te(Qe){return typeof Qe=="string"?Qe:new s.$4N(h.URI.revive(Qe.baseUri),Qe.pattern)}Ne.to=Te})(Ie||(e.GlobPattern=Ie={}));var Ge;(function(Ne){function je(ye){if(ye){if(Array.isArray(ye))return ye.map(je);if(typeof ye=="string")return ye;{const x=ye;return{language:x.language,scheme:x.scheme,pattern:Ie.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}Ne.from=je})(Ge||(e.LanguageSelector=Ge={}));var Oe;(function(Ne){function je(x){return!!x&&typeof x=="object"&&"documents"in x&&Array.isArray(x.documents)&&x.documents.every(Te=>Array.isArray(Te)&&Te.every(Qe=>Qe&&typeof Qe=="object"&&"uri"in Qe&&h.URI.isUri(Qe.uri)&&"version"in Qe&&typeof Qe.version=="number"&&"ranges"in Qe&&Array.isArray(Qe.ranges)&&Qe.ranges.every(_e=>_e instanceof s.$7M)))}Ne.is=je;function ye(x){return{documents:x.documents.map(Te=>Te.map(Qe=>({uri:h.URI.from(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(_e=>D.from(_e))})))}}Ne.from=ye})(Oe||(e.MappedEditsContext=Oe={}));var ot;(function(Ne){function je(x){return{start:x.start,end:x.end}}Ne.from=je;function ye(x){return new s.$uO(x.start,x.end)}Ne.to=ye})(ot||(e.NotebookRange=ot={}));var ut;(function(Ne){function je(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}Ne.to=je;function ye(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}Ne.from=ye})(ut||(e.NotebookCellExecutionSummary=ut={}));var vt;(function(Ne){function je(ye){if(ye===t.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ye===t.NotebookCellExecutionState.Pending)return;if(ye===t.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Ne.to=je})(vt||(e.NotebookCellExecutionState=vt={}));var Rt;(function(Ne){function je(x){switch(x){case s.NotebookCellKind.Markup:return t.CellKind.Markup;case s.NotebookCellKind.Code:default:return t.CellKind.Code}}Ne.from=je;function ye(x){switch(x){case t.CellKind.Markup:return s.NotebookCellKind.Markup;case t.CellKind.Code:default:return s.NotebookCellKind.Code}}Ne.to=ye})(Rt||(e.NotebookCellKind=Rt={}));var Ut;(function(Ne){function je(x){const Te={metadata:x.metadata??Object.create(null),cells:[]};for(const Qe of x.cells)s.$vO.validate(Qe),Te.cells.push(tn.from(Qe));return Te}Ne.from=je;function ye(x){const Te=new s.$wO(x.cells.map(tn.to));return(0,w.$jg)(x.metadata)||(Te.metadata=x.metadata),Te}Ne.to=ye})(Ut||(e.NotebookData=Ut={}));var tn;(function(Ne){function je(x){return{cellKind:Rt.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:ut.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(kt.from):[]}}Ne.from=je;function ye(x){return new s.$vO(Rt.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(kt.to):void 0,x.metadata,x.internalMetadata?ut.to(x.internalMetadata):void 0)}Ne.to=ye})(tn||(e.NotebookCellData=tn={}));var Zt;(function(Ne){function je(x){return{mime:x.mime,valueBytes:L.$Ge.wrap(x.data)}}Ne.from=je;function ye(x){return new s.$xO(x.valueBytes.buffer,x.mime)}Ne.to=ye})(Zt||(e.NotebookCellOutputItem=Zt={}));var kt;(function(Ne){function je(x){return{outputId:x.id,items:x.items.map(Zt.from),metadata:x.metadata}}Ne.from=je;function ye(x){const Te=x.items.map(Zt.to);return new s.$yO(Te,x.outputId,x.metadata)}Ne.to=ye})(kt||(e.NotebookCellOutput=kt={}));var Xt;(function(Ne){function je(Te){return x(Te)?{include:Ie.from(Te.include)??void 0,exclude:Ie.from(Te.exclude)??void 0}:Ie.from(Te)??void 0}Ne.from=je;function ye(Te){return x(Te)?{include:Ie.to(Te.include),exclude:Ie.to(Te.exclude)}:Ie.to(Te)}Ne.to=ye;function x(Te){const Qe=Te;return Qe?!(0,w.$fg)(Qe.include)&&!(0,w.$fg)(Qe.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Yt;(function(Ne){function je(ye,x,Te){const Qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Qe,Te),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Ne.from=je})(Yt||(e.NotebookStatusBarItem=Yt={}));var et;(function(Ne){function je(ye,x,Te){const Qe=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:x.toInternal(Qe,Te),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Ne.from=je})(et||(e.NotebookKernelSourceAction=et={}));var an;(function(Ne){function je(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Ne.from=je})(an||(e.NotebookDocumentContentOptions=an={}));var Gt;(function(Ne){function je(x){return{uri:x.uri,provides:x.provides}}Ne.from=je;function ye(x){return new s.$AO(h.URI.revive(x.uri),x.provides)}Ne.to=ye})(Gt||(e.NotebookRendererScript=Gt={}));var ft;(function(Ne){function je(x){return{message:Z.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,contextValue:x.contextValue,location:x.location&&{range:D.from(x.location.range),uri:x.location.uri}}}Ne.from=je;function ye(x){const Te=new s.$GO(typeof x.message=="string"?x.message:Z.to(x.message));return Te.actualOutput=x.actual,Te.expectedOutput=x.expected,Te.contextValue=x.contextValue,Te.location=x.location?re.to(x.location):void 0,Te}Ne.to=ye})(ft||(e.TestMessage=ft={}));var $t;(function(Ne){Ne.namespace=r.$TL,Ne.denamespace=r.$UL})($t||(e.TestTag=$t={}));var xt;(function(Ne){function je(x){const Te=(0,i.$mP)(x).controllerId;return{extId:l.$OL.fromExtHostTestItem(x,Te).toString(),label:x.label,uri:h.URI.revive(x.uri),busy:x.busy,tags:x.tags.map(Qe=>$t.namespace(Te,Qe.id)),range:f.$ut.lift(D.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&Z.fromStrict(x.error)||null}}Ne.from=je;function ye(x){return{parent:void 0,error:void 0,id:l.$OL.fromString(x.extId).localId,label:x.label,uri:h.URI.revive(x.uri),tags:(x.tags||[]).map(Te=>{const{tagId:Qe}=$t.denamespace(Te);return new s.$HO(Qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}Ne.toPlain=ye})(xt||(e.TestItem=xt={})),function(Ne){function je(x){return{id:x.id}}Ne.from=je;function ye(x){return new s.$HO(x.id)}Ne.to=ye}($t||(e.TestTag=$t={}));var Kt;(function(Ne){const je=(x,Te)=>{const Qe=x.value;if(!Qe)return;const _e={...xt.toPlain(Qe.item),parent:Te,taskStates:Qe.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(ht=>ht.type===0).map(ft.to)})),children:[]};if(x.children)for(const Ze of x.children.values()){const ht=je(Ze,_e);ht&&_e.children.push(ht)}return _e};function ye(x){const Te=new p.$fP;for(const Ze of x.items)Te.insert(l.$OL.fromString(Ze.item.extId).path,Ze);const Qe=[Te.nodes],_e=[];for(;Qe.length;)for(const Ze of Qe.pop())Ze.value?_e.push(Ze):Ze.children&&Qe.push(Ze.children.values());return{completedAt:x.completedAt,results:_e.map(Ze=>je(Ze)).filter(w.$eg)}}Ne.to=ye})(Kt||(e.TestResults=Kt={}));var Ft;(function(Ne){function je(Qe){return{covered:Qe.covered,total:Qe.total}}function ye(Qe){return"line"in Qe?S.from(Qe):D.from(Qe)}function x(Qe){if(typeof Qe.executed=="number"&&Qe.executed<0)throw new Error(`Invalid coverage count ${Qe.executed}`);return"branches"in Qe?{count:Qe.executed,location:ye(Qe.location),type:1,branches:Qe.branches.length?Qe.branches.map(_e=>({count:_e.executed,location:_e.location&&ye(_e.location),label:_e.label})):void 0}:{type:0,name:Qe.name,count:Qe.executed,location:ye(Qe.location)}}Ne.fromDetails=x;function Te(Qe,_e){return s.$JO(_e.statementCoverage),s.$JO(_e.branchCoverage),s.$JO(_e.declarationCoverage),{id:Qe,uri:_e.uri,statement:je(_e.statementCoverage),branch:_e.branchCoverage&&je(_e.branchCoverage),declaration:_e.declarationCoverage&&je(_e.declarationCoverage)}}Ne.fromFile=Te})(Ft||(e.TestCoverage=Ft={}));var gt;(function(Ne){function je(ye){switch(ye){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ne.to=je})(gt||(e.CodeActionTriggerKind=gt={}));var Wt;(function(Ne){function je(x){const Te=new s.$OO(_.to(x.kind),x.name,x.detail||"",h.URI.revive(x.uri),D.to(x.range),D.to(x.selectionRange));return Te._sessionId=x._sessionId,Te._itemId=x._itemId,Te}Ne.to=je;function ye(x,Te,Qe){if(Te=Te??x._sessionId,Qe=Qe??x._itemId,Te===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Qe,kind:_.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:D.from(x.range),selectionRange:D.from(x.selectionRange),tags:x.tags?.map(B.from)}}Ne.from=ye})(Wt||(e.TypeHierarchyItem=Wt={}));var _t;(function(Ne){function je(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Ne.from=je})(_t||(e.ViewBadge=_t={}));var Vt;(function(Ne){function je(Qe,_e,Ze){const ht=_e.fileData;return ht?new s.$VN(new s.$WN(ht.name,h.URI.revive(ht.uri),ht.id,(0,R.$db)(()=>Ze(ht.id)))):Qe===A.$Qs.uriList&&_e.uriListData?new s.$UN(Te(_e.uriListData)):new s.$UN(_e.asString)}Ne.to=je;async function ye(Qe,_e){const Ze=await _e.asString();if(Qe===A.$Qs.uriList)return{asString:Ze,fileData:void 0,uriListData:x(Ze)};const ht=_e.asFile();return{asString:Ze,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Ne.from=ye;function x(Qe){return O.$Ut.split(Qe).map(_e=>{if(_e.startsWith("#"))return _e;try{return h.URI.parse(_e)}catch{}return _e})}function Te(Qe){return O.$Ut.create(Qe.map(_e=>typeof _e=="string"?_e:h.URI.revive(_e)))}})(Vt||(e.DataTransferItem=Vt={}));var xe;(function(Ne){function je(x,Te){const Qe=x.items.map(([_e,Ze])=>[_e,Vt.to(_e,Ze,Te)]);return new s.$XN(Qe)}Ne.toDataTransfer=je;async function ye(x){const Te={items:[]},Qe=[];for(const[_e,Ze]of x)Qe.push((async()=>{Te.items.push([_e,await Vt.from(_e,Ze)])})());return await Promise.all(Qe),Te}Ne.from=ye})(xe||(e.DataTransfer=xe={}));var ln;(function(Ne){function je(x,Te){return{kind:"reply",agentId:x.participant??Te?.agentId??"",subCommand:x.command??Te?.command,message:x.prompt,title:x.label}}Ne.from=je;function ye(x){return{prompt:x.message,label:x.title,participant:x.agentId,command:x.subCommand}}Ne.to=ye})(ln||(e.ChatFollowup=ln={}));var Jt;(function(Ne){function je(ye){return"commandId"in ye?{kind:"command",title:ye.title??"",commandId:ye.commandId??"",when:ye.when??"",args:ye.args}:{kind:"reply",message:ye.message,title:ye.title,tooltip:ye.tooltip}}Ne.from=je})(Jt||(e.ChatInlineFollowup=Jt={}));var qt;(function(Ne){function je(x){switch(x.role){case 0:return new s.$aP(x.content);case 1:return new s.$bP(x.content);case 2:return new s.$cP(x.content)}}Ne.to=je;function ye(x){if(x instanceof s.$aP)return{role:0,content:x.content};if(x instanceof s.$bP)return{role:1,content:x.content};if(x instanceof s.$cP)return{role:2,content:x.content};throw new Error("Invalid LanguageModelMessage")}Ne.from=ye})(qt||(e.LanguageModelMessage=qt={}));var pt;(function(Ne){function je(Te){const Qe={};for(const _e of Object.keys(Te))Qe[_e]=Te[_e].map(Ne.to);return Qe}Ne.objectTo=je;function ye(Te){return{level:jt.to(Te.level),kind:Te.kind,value:(0,h.$wc)(Te.value)?h.URI.revive(Te.value):Te.value,description:Te.description}}Ne.to=ye;function x(Te){return{level:jt.from(Te.level),kind:Te.kind,value:Te.value,description:Te.description}}Ne.from=x})(pt||(e.ChatVariable=pt={}));var jt;(function(Ne){function je(x){switch(x){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ne.to=je;function ye(x){switch(x){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ne.from=ye})(jt||(e.ChatVariableLevel=jt={}));var Nt;(function(Ne){function je(ye){switch(ye){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Ne.to=je})(Nt||(e.InteractiveEditorResponseFeedbackKind=Nt={}));var Lt;(function(Ne){function je(x){return{kind:"markdownContent",content:Z.from(x.value)}}Ne.from=je;function ye(x){return new s.$2O(Z.to(x.content))}Ne.to=ye})(Lt||(e.ChatResponseMarkdownPart=Lt={}));var nn;(function(Ne){function je(x){return{kind:"markdownVuln",content:Z.from(x.value),vulnerabilities:x.vulnerabilities}}Ne.from=je;function ye(x){return new s.$3O(Z.to(x.content),x.vulnerabilities)}Ne.to=ye})(nn||(e.ChatResponseMarkdownWithVulnerabilitiesPart=nn={}));var Qt;(function(Ne){function je(x){return{kind:"agentDetection",agentId:x.participant,command:x.command}}Ne.from=je;function ye(x){return new s.$4O(x.agentId,x.command)}Ne.to=ye})(Qt||(e.ChatResponseDetectedParticipantPart=Qt={}));var rn;(function(Ne){function je(x){const{value:Te,baseUri:Qe}=x;function _e(Ze,ht){return Ze.map(Et=>{const zt=h.URI.joinPath(ht,Et.name);return{label:Et.name,uri:zt,children:Et.children&&_e(Et.children,zt)}})}return{kind:"treeData",treeData:{label:(0,y.$7g)(Qe),uri:Qe,children:_e(Te,Qe)}}}Ne.from=je;function ye(x){const Te=(0,E.$6h)(x.treeData);function Qe(ht){return ht.map(Et=>({name:Et.label,children:Et.children&&Qe(Et.children)}))}const _e=Te.uri,Ze=Te.children?Qe(Te.children):[];return new s.$5O(Ze,_e)}Ne.to=ye})(rn||(e.ChatResponseFilesPart=rn={}));var It;(function(Ne){function je(x){return{kind:"inlineReference",name:x.title,inlineReference:h.URI.isUri(x.value)?x.value:$.from(x.value)}}Ne.from=je;function ye(x){const Te=(0,E.$6h)(x);return new s.$6O(h.URI.isUri(Te.inlineReference)?Te.inlineReference:$.to(Te.inlineReference),x.name)}Ne.to=ye})(It||(e.ChatResponseAnchorPart=It={}));var Mt;(function(Ne){function je(x){return{kind:"progressMessage",content:Z.from(x.value)}}Ne.from=je;function ye(x){return new s.$7O(x.content.value)}Ne.to=ye})(Mt||(e.ChatResponseProgressPart=Mt={}));var Ot;(function(Ne){function je(x,Te,Qe){return{kind:"command",command:Te.toInternal(x.value,Qe)??{command:x.value.command,title:x.value.title}}}Ne.from=je;function ye(x,Te){return new s.$8O(Te.fromInternal(x.command)??{command:x.command.id,title:x.command.title})}Ne.to=ye})(Ot||(e.ChatResponseCommandButtonPart=Ot={}));var Ct;(function(Ne){function je(x){return{kind:"textEdit",uri:x.uri,edits:x.edits.map(Te=>ue.from(Te))}}Ne.from=je;function ye(x){return new s.$0O(h.URI.revive(x.uri),x.edits.map(Te=>ue.to(Te)))}Ne.to=ye})(Ct||(e.ChatResponseTextEditPart=Ct={}));var mt;(function(Ne){function je(x){const Te=v.ThemeIcon.isThemeIcon(x.iconPath)?x.iconPath:void 0;return"variableName"in x.value?{kind:"reference",reference:{variableName:x.value.variableName,value:h.URI.isUri(x.value.value)||!x.value.value?x.value.value:$.from(x.value.value)},iconPath:Te}:{kind:"reference",reference:h.URI.isUri(x.value)?x.value:$.from(x.value),iconPath:Te}}Ne.from=je;function ye(x){const Te=(0,E.$6h)(x),Qe=_e=>h.URI.isUri(_e)?_e:$.to(_e);return new s.$9O("variableName"in Te.reference?{variableName:Te.reference.variableName,value:Te.reference.value&&Qe(Te.reference.value)}:Qe(Te.reference))}Ne.to=ye})(mt||(e.ChatResponseReferencePart=mt={}));var St;(function(Ne){function je(Te,Qe,_e){return Te instanceof s.$2O?Lt.from(Te):Te instanceof s.$6O?It.from(Te):Te instanceof s.$9O?mt.from(Te):Te instanceof s.$7O?Mt.from(Te):Te instanceof s.$5O?rn.from(Te):Te instanceof s.$8O?Ot.from(Te,Qe,_e):Te instanceof s.$0O?Ct.from(Te):Te instanceof s.$3O?nn.from(Te):Te instanceof s.$4O?Qt.from(Te):{kind:"markdownContent",content:Z.from("")}}Ne.from=je;function ye(Te,Qe){switch(Te.kind){case"reference":return mt.to(Te);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return x(Te,Qe)}}Ne.to=ye;function x(Te,Qe){switch(Te.kind){case"markdownContent":return Lt.to(Te);case"inlineReference":return It.to(Te);case"progressMessage":return;case"treeData":return rn.to(Te);case"command":return Ot.to(Te,Qe)}}Ne.toContent=x})(St||(e.ChatResponsePart=St={}));var cn;(function(Ne){function je(ye){return{prompt:ye.message,command:ye.command,attempt:ye.attempt??0,enableCommandDetection:ye.enableCommandDetection??!0,variables:ye.variables.variables.map(gn.to),location:Dt.to(ye.location)}}Ne.to=je})(cn||(e.ChatAgentRequest=cn={}));var Dt;(function(Ne){function je(ye){switch(ye){case o.ChatAgentLocation.Notebook:return s.ChatLocation.Notebook;case o.ChatAgentLocation.Terminal:return s.ChatLocation.Terminal;case o.ChatAgentLocation.Panel:return s.ChatLocation.Panel;case o.ChatAgentLocation.Editor:return s.ChatLocation.Editor}}Ne.to=je})(Dt||(e.ChatLocation=Dt={}));var gn;(function(Ne){function je(ye){return{name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],values:ye.values.map(pt.to)}}Ne.to=je})(gn||(e.ChatAgentResolvedVariable=gn={}));var sn;(function(Ne){function je(ye,x,Te){return{label:ye.label,values:ye.values.map(pt.from),insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation,command:x.toInternal(ye.command,Te)}}Ne.from=je})(sn||(e.ChatAgentCompletionItem=sn={}));var pn;(function(Ne){function je(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Ne.to=je})(pn||(e.ChatAgentResult=pn={}));var hn;(function(Ne){function je(ye,x,Te){if(x.action.kind==="vote")return;const Qe=pn.to(ye);if(x.action.kind==="command"){const _e=x.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Te.fromInternal(_e)??{command:_e.id,title:_e.title}}},result:Qe}}else return x.action.kind==="followUp"?{action:{kind:"followUp",followup:ln.to(x.action.followup)},result:Qe}:x.action.kind==="inlineChat"?{action:{kind:"editor",accepted:x.action.action==="accepted"},result:Qe}:{action:x.action,result:Qe}}Ne.to=je})(hn||(e.ChatAgentUserActionEvent=hn={}));var wn;(function(Ne){function je(ye,x,Te){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:x.toInternal(ye,Te)}Ne.from=je})(wn||(e.TerminalQuickFix=wn={}));var Pt;(function(Ne){function je(ye){return{kind:yn.to(ye.kind)}}Ne.to=je})(Pt||(e.PartialAcceptInfo=Pt={}));var yn;(function(Ne){function je(ye){switch(ye){case 0:return s.PartialAcceptTriggerKind.Word;case 1:return s.PartialAcceptTriggerKind.Line;case 2:return s.PartialAcceptTriggerKind.Suggest;default:return s.PartialAcceptTriggerKind.Unknown}}Ne.to=je})(yn||(e.PartialAcceptTriggerKind=yn={}));var on;(function(Ne){function je(ye,x){return{id:x,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||0,contextValue:ye.contextValue}}Ne.from=je})(on||(e.DebugTreeItem=on={}))}),define(ke[333],Se([1,0,6,20,16,48]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=void 0;let N=class{constructor(m,E){this.a=m.getProxy(d.$3M.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>E.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,A){const P=new R.$vw(O.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(P,void 0,A?.isRefactoring??!1)}};e.$mlc=N,e.$mlc=N=Ke([We(0,L.$qP)],N)}),define(ke[334],Se([1,0,19,7,47,4,39,3,40,18,2,25,6,16,8,297,26]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=void 0;class a{constructor(o,t,l,r,c){this.j=o,this.k=t,this.l=l,this.m=r,this.n=c,this.b=m.$ae.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(r){if(o.c){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,r),c}};const o=this;this.b.reset();const l=r=>{typeof this.d>"u"&&"content"in r&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,r)};this.g={markdown(r){t(this.markdown);const c=new w.$2O(r),s=y.ChatResponseMarkdownPart.from(c);return l(s),this},markdownWithVulnerabilities(r,c){t(this.markdown),c&&(0,f.$IG)(o.j,"chatParticipantAdditions");const s=new w.$3O(r,c),v=y.ChatResponseMarkdownWithVulnerabilitiesPart.from(s);return l(v),this},filetree(r,c){t(this.filetree);const s=new w.$5O(r,c),v=y.ChatResponseFilesPart.from(s);return l(v),this},anchor(r,c){t(this.anchor);const s=new w.$6O(r,c),v=y.ChatResponseAnchorPart.from(s);return l(v),this},button(r){t(this.anchor);const c=new w.$8O(r),s=y.ChatResponseCommandButtonPart.from(c,o.m,o.n);return l(s),this},progress(r){t(this.progress);const c=new w.$7O(r),s=y.ChatResponseProgressPart.from(c);return l(s),this},reference(r,c){if(t(this.reference),"variableName"in r&&!r.value){const s=o.k.variables.variables.find(v=>v.name===r.variableName);if(s){let v;if(s.references?.length)v=s.references.map(g=>({kind:"reference",reference:{variableName:r.variableName,value:g.reference}}));else{const g=new w.$9O(r,c);v=[y.ChatResponseReferencePart.from(g)]}return v.forEach(g=>l(g)),this}}else{const s=new w.$9O(r,c),v=y.ChatResponseReferencePart.from(s);l(v)}return this},textEdit(r,c){t(this.textEdit),(0,f.$IG)(o.j,"chatParticipantAdditions");const s=new w.$0O(r,c),v=y.ChatResponseTextEditPart.from(s);return l(v),this},detectedParticipant(r,c){t(this.detectedParticipant),(0,f.$IG)(o.j,"chatParticipantAdditions");const s=new w.$4O(r,c),v=y.ChatResponseDetectedParticipantPart.from(s);return l(v),this},push(r){if(t(this.push),(r instanceof w.$0O||r instanceof w.$3O||r instanceof w.$4O)&&(0,f.$IG)(o.j,"chatParticipantAdditions"),r instanceof w.$9O)this.reference(r.value,r.iconPath);else{const c=y.ChatResponsePart.from(r,o.m,o.n);l(c)}return this}}}return this.g}}class n extends b.$Vc{static{this.b=0}constructor(o,t,l){super(),this.n=t,this.s=l,this.c=new Map,this.j=this.B(new b.$5c),this.m=this.B(new b.$Uc),this.g=o.getProxy(p.$3M.MainThreadChatAgents2)}transferActiveChat(o){this.g.$transferActiveChatSession(o)}createChatAgent(o,t,l){const r=n.b++,c=new i(o,t,this.g,r,l);return this.c.set(r,c),this.g.$registerAgent(r,o.identifier,t,{},void 0),c.apiAgent}createDynamicChatAgent(o,t,l,r,c){const s=n.b++,v=new i(o,t,this.g,s,c);return this.c.set(s,v),this.g.$registerAgent(s,o.identifier,t,{isSticky:!0},{name:l,description:r}),v.apiAgent}async $invokeAgent(o,t,l,r){const c=this.c.get(o);if(!c)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let s=this.j.get(t.sessionId);s||(s=new b.$Uc,this.j.set(t.sessionId,s));const v=new a(c.extension,t,this.g,this.s.converter,s);try{const g=await this.t(t.agentId,l),D=c.invoke(y.ChatAgentRequest.to(t),{history:g},v.apiObject,r);return await(0,L.$kh)(Promise.resolve(D).then($=>{if($?.metadata)try{JSON.stringify($.metadata)}catch(k){const S=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.n.error(`[${c.extension.identifier.value}] [@${c.id}] ${S}`,c.extension),{errorDetails:{message:S},timings:v.timings}}return{errorDetails:$?.errorDetails,timings:v.timings,metadata:$?.metadata}}),r)}catch(g){return this.n.error(g,c.extension),{errorDetails:{message:(0,O.$hj)(g),responseIsIncomplete:!0}}}finally{v.close()}}async t(o,t){const l=[];for(const r of t.history){const c=y.ChatAgentResult.to(r.result),s=o===r.request.agentId?c:{...c,metadata:void 0};l.push(new w.$$O(r.request.message,r.request.command,r.request.variables.variables.map(y.ChatAgentResolvedVariable.to),r.request.agentId));const v=(0,d.$Hb)(r.response.map(g=>y.ChatResponsePart.toContent(g,this.s.converter)));l.push(new w.$_O(v,s,r.request.agentId,r.request.command))}return l}$releaseSession(o){this.j.deleteAndDispose(o)}async $provideFollowups(o,t,l,r,c){const s=this.c.get(t);if(!s)return Promise.resolve([]);const v=await this.t(s.id,r),g=y.ChatAgentResult.to(l);return(await s.provideFollowups(g,{history:v},c)).filter(D=>{const $=!D.participant||N.Iterable.some(this.c.values(),k=>k.id===D.participant&&P.$Rm.equals(k.extension.identifier,s.extension.identifier));return $||this.n.warn(`[@${s.id}] ChatFollowup refers to an unknown participant: ${D.participant}`),$}).map(D=>y.ChatFollowup.from(D,o))}$acceptFeedback(o,t,l,r){const c=this.c.get(o);if(!c)return;const s=y.ChatAgentResult.to(t);let v;switch(l){case h.InteractiveSessionVoteDirection.Down:v=w.ChatResultFeedbackKind.Unhelpful;break;case h.InteractiveSessionVoteDirection.Up:v=w.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(r?{result:s,kind:v,reportIssue:r}:{result:s,kind:v}))}$acceptAction(o,t,l){const r=this.c.get(o);if(!r||l.action.kind==="vote")return;const c=y.ChatAgentUserActionEvent.to(t,l,this.s.converter);c&&r.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(o,t,l){const r=this.c.get(o);return r?(await r.invokeCompletionProvider(t,l)).map(s=>y.ChatAgentCompletionItem.from(s,this.s.converter,this.m)):[]}async $provideWelcomeMessage(o,t,l){const r=this.c.get(o);if(r)return await r.provideWelcomeMessage(y.ChatLocation.to(t),l)}async $provideSampleQuestions(o,t,l){const r=this.c.get(o);if(r)return(await r.provideSampleQuestions(y.ChatLocation.to(t),l)).map(c=>y.ChatFollowup.from(c,void 0))}}e.$nlc=n;class i{constructor(o,t,l,r,c){this.extension=o,this.id=t,this.u=l,this.w=r,this.x=c,this.n=new R.$ee,this.o=new R.$ee}acceptFeedback(o){this.n.fire(o)}acceptAction(o){this.o.fire(o)}async invokeCompletionProvider(o,t){return this.q?await this.q.provider.provideCompletionItems(o,t)??[]:[]}async provideFollowups(o,t,l){if(!this.b)return[];const r=await this.b.provideFollowups(o,t,l);return r?r.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(o,t){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(o,t);return l?l.map(r=>typeof r=="string"?r:y.MarkdownString.from(r)):[]}async provideSampleQuestions(o,t){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(o,t);return l||[]}get apiAgent(){let o=!1,t=!1;const l=()=>{o||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof w.$2N?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:y.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:y.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:y.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},r=this;return{get id(){return r.id},get fullName(){return(0,f.$IG)(r.extension,"defaultChatParticipant"),r.c??r.extension.displayName??r.extension.name},set fullName(c){(0,f.$IG)(r.extension,"defaultChatParticipant"),r.c=c,l()},get iconPath(){return r.d},set iconPath(c){r.d=c,l()},get requestHandler(){return r.x},set requestHandler(c){(0,E.$gg)(typeof c=="function","Invalid request handler"),r.x=c},get followupProvider(){return r.b},set followupProvider(c){r.b=c,l()},get isDefault(){return(0,f.$IG)(r.extension,"defaultChatParticipant"),r.g},set isDefault(c){(0,f.$IG)(r.extension,"defaultChatParticipant"),r.g=c,l()},get helpTextPrefix(){return(0,f.$IG)(r.extension,"defaultChatParticipant"),r.j},set helpTextPrefix(c){(0,f.$IG)(r.extension,"defaultChatParticipant"),r.j=c,l()},get helpTextVariablesPrefix(){return(0,f.$IG)(r.extension,"defaultChatParticipant"),r.k},set helpTextVariablesPrefix(c){(0,f.$IG)(r.extension,"defaultChatParticipant"),r.k=c,l()},get helpTextPostfix(){return(0,f.$IG)(r.extension,"defaultChatParticipant"),r.l},set helpTextPostfix(c){(0,f.$IG)(r.extension,"defaultChatParticipant"),r.l=c,l()},get isSecondary(){return(0,f.$IG)(r.extension,"defaultChatParticipant"),r.m},set isSecondary(c){(0,f.$IG)(r.extension,"defaultChatParticipant"),r.m=c,l()},get supportIssueReporting(){return(0,f.$IG)(r.extension,"chatParticipantAdditions"),r.p},set supportIssueReporting(c){(0,f.$IG)(r.extension,"chatParticipantAdditions"),r.p=c,l()},get onDidReceiveFeedback(){return r.n.event},set participantVariableProvider(c){if((0,f.$IG)(r.extension,"chatParticipantAdditions"),r.q=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");r.u.$registerAgentCompletionsProvider(r.w,c.triggerCharacters)}else r.u.$unregisterAgentCompletionsProvider(r.w)},get participantVariableProvider(){return(0,f.$IG)(r.extension,"chatParticipantAdditions"),r.q},set welcomeMessageProvider(c){(0,f.$IG)(r.extension,"defaultChatParticipant"),r.s=c,l()},get welcomeMessageProvider(){return(0,f.$IG)(r.extension,"defaultChatParticipant"),r.s},onDidPerformAction:(0,f.$HG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(c){r.t=c,l()},get requester(){return r.t},dispose(){o=!0,r.b=void 0,r.n.dispose(),r.u.$unregisterAgent(r.w)}}}invoke(o,t,l,r){return this.x(o,t,l,r)}}}),define(ke[335],Se([1,0,13,3,6,16,8,26]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=void 0;class m{static{this.a=0}constructor(P){this.b=new Map,this.c=P.getProxy(O.$3M.MainThreadChatVariables)}async $resolveVariable(P,p,y,w){const h=this.b.get(P);if(h)try{if(h.resolver.resolve2){(0,b.$IG)(h.extension,"chatParticipantAdditions");const f=new E(p,this.c),a=await h.resolver.resolve2(h.data.name,{prompt:y},f.apiObject,w);if(a)return a.map(R.ChatVariable.from)}else{const f=await h.resolver.resolve(h.data.name,{prompt:y},w);if(f)return f.map(R.ChatVariable.from)}}catch(f){(0,d.$2)(f)}}registerVariableResolver(P,p,y,w){const h=m.a++;return this.b.set(h,{extension:P,data:{name:p,description:y},resolver:w}),this.c.$registerVariable(h,{name:p,description:y}),(0,L.$Tc)(()=>{this.b.delete(h),this.c.$unregisterVariable(h)})}}e.$olc=m;class E{constructor(P,p){this.c=P,this.d=p,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let p=function(w){if(P.a){const h=new Error("Response stream has been closed");throw Error.captureStackTrace(h,w),h}};const P=this,y=w=>{this.d.$handleProgressChunk(this.c,w)};this.b={progress(w){p(this.progress);const h=new N.$7O(w),f=R.ChatResponseProgressPart.from(h);return y(f),this},reference(w){p(this.reference);const h=new N.$9O(w),f=R.ChatResponseReferencePart.from(h);return y(f),this},push(w){return p(this.push),w instanceof N.$9O?y(R.ChatResponseReferencePart.from(w)):w instanceof N.$7O&&y(R.ChatResponseProgressPart.from(w)),this}}}return this.b}}}),define(ke[336],Se([1,0,7,56,4,3,2,84,25,16,8,6,26]),function(le,e,d,L,O,R,N,b,m,E,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=y;function y(w,h,f){const a=w.getProxy(P.$3M.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$Tm,h.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const D=this.b.get(g.handle);return D?D.value:g}else if(g&&g.$mid===7){const D=g,$=this.b.get(D.commentControlHandle);if(!$)return D;const k=$.getCommentThread(D.commentThreadHandle);return k?k.value:D}else if(g&&(g.$mid===9||g.$mid===8)){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const $=D.getCommentThread(g.thread.commentThreadHandle);return $?g.$mid===8?$.value:{thread:$.value,text:g.text}:g}else if(g&&g.$mid===10){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const $=D.getCommentThread(g.thread.commentThreadHandle);if(!$)return g;const k=g.commentUniqueId,S=$.getCommentByUniqueId(k);return S||g}else if(g&&g.$mid===11){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const $=D.getCommentThread(g.thread.commentThreadHandle);if(!$)return g;const k=g.text,S=g.commentUniqueId,C=$.getCommentByUniqueId(S);return C?(typeof C.body=="string"?C.body=k:C.body=new A.$uN(k),C):g}return g}})}createCommentController(g,D,$){const k=n.a++,S=new u(g,k,D,$);this.b.set(S.handle,S);const C=this.c.get(g.identifier)||[];return C.push(S),this.c.set(g.identifier,C),S.value}async $createCommentThreadTemplate(g,D,$){const k=this.b.get(g);k&&k.$createCommentThreadTemplate(D,$)}async $setActiveComment(g,D){const $=this.b.get(g);$&&$.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(g,D,$){const k=this.b.get(g);k&&k.$updateCommentThreadTemplate(D,$)}$deleteCommentThread(g,D){this.b.get(g)?.$deleteCommentThread(D)}async $provideCommentingRanges(g,D,$){const k=this.b.get(g);if(!k||!k.commentingRangeProvider)return Promise.resolve(void 0);const S=await f.ensureDocumentData(N.URI.revive(D));return(0,d.$oh)(async()=>{const C=await k.commentingRangeProvider.provideCommentingRanges(S.document,$);let I;return Array.isArray(C)?I={ranges:C,fileComments:!1}:C?I={ranges:C.ranges||[],fileComments:C.fileComments||!1}:I=C??void 0,I}).then(C=>{let I;return C&&(I={ranges:C.ranges.map(F=>E.Range.from(F)),fileComments:C.fileComments}),I})}$toggleReaction(g,D,$,k,S){const C=this.b.get(g);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,d.$oh)(()=>{const I=C.getCommentThread(D);if(I){const F=I.getCommentByUniqueId(k.uniqueIdInThread);if(C!==void 0&&F&&C.reactionHandler)return C.reactionHandler(F,l(S))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(g){this.n=g}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(g){(g===void 0!=(this.p===void 0)||!g||!this.p||!g.isEqual(this.p))&&(this.p=g,this.b.range=g,this.c.fire())}get range(){return this.p}set canReply(g){this.d!==g&&(this.d=g,this.b.canReply=g,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(g){this.e=g,this.b.label=g,this.c.fire()}get contextValue(){return this.f}set contextValue(g){this.f=g,this.b.contextValue=g,this.c.fire()}get comments(){return this.q}set comments(g){this.q=g,this.b.comments=g,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(g){this.g=g,this.b.collapsibleState=g,this.c.fire()}get state(){return this.h}set state(g){this.h=g,typeof g=="object"?((0,p.$IG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=g.resolved,this.b.applicability=g.applicability):this.b.state=g,this.c.fire()}get isDisposed(){return this.j}constructor(g,D,$,k,S,C,I,F){this.m=D,this.n=$,this.o=k,this.p=S,this.q=C,this.extensionDescription=I,this.r=F,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new O.$ee,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Wc,this.l.value=new R.$Uc,this.n===void 0&&(this.n=`${g}.${this.handle}`),a.$createCommentThread(D,this.handle,this.n,this.o,E.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{a.$deleteCommentThread(D,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(z){j.range=z},get comments(){return j.comments},set comments(z){j.comments=z},get collapsibleState(){return j.collapsibleState},set collapsibleState(z){j.collapsibleState=z},get canReply(){return j.canReply},set canReply(z){j.canReply=z},get contextValue(){return j.contextValue},set contextValue(z){j.contextValue=z},get label(){return j.label},set label(z){j.label=z},get state(){return j.state},set state(z){j.state=z},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Uc);const g=$=>Object.prototype.hasOwnProperty.call(this.b,$),D={};g("range")&&(D.range=E.Range.from(this.p)),g("label")&&(D.label=this.label),g("contextValue")&&(D.contextValue=this.contextValue??null),g("comments")&&(D.comments=this.q.map($=>o(this,$,this.k,this.extensionDescription))),g("collapsibleState")&&(D.collapseState=r(this.g)),g("canReply")&&(D.canReply=this.canReply),g("state")&&(D.state=c(this.h)),g("applicability")&&(D.applicability=s(this.h)),g("isTemplate")&&(D.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(g){for(const D of this.k){const $=D[0],k=D[1];if(g===k)return $}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(g=>g.dispose())}}Ke([(0,L.$2h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class u{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(g){this.b=g,g?.resourceHints&&(0,p.$IG)(this.h,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,g?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(g){this.c=g,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this.d}set options(g){this.d=g,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,p.$IG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,p.$IG)(this.h,"activeComment"),this.f}constructor(g,D,$,k){this.h=g,this.i=D,this.j=$,this.k=k,this.a=new Map,a.$registerCommentController(this.handle,$,k,this.h.identifier.value);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(C){S.options=C},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(C){S.commentingRangeProvider=C},get reactionHandler(){return S.reactionHandler},set reactionHandler(C){S.reactionHandler=C},get activeCommentThread(){return S.activeCommentThread},createCommentThread(C,I,F){return S.createCommentThread(C,I,F).value},dispose:()=>{S.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(g,D,$){D===void 0&&(0,p.$IG)(this.h,"fileComments");const k=new i(this.id,this.handle,void 0,g,D,$,this.h,!1);return this.a.set(k.handle,k),k}$setActiveComment(g){if(!g){this.e=void 0,this.f=void 0;return}const D=this.a.get(g.commentThreadHandle);D&&(this.e=g.uniqueIdInThread?D.getCommentByUniqueId(g.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(g,D){const $=new i(this.id,this.handle,void 0,N.URI.revive(g),E.Range.to(D),[],this.h,!0);return $.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set($.handle,$),$}$updateCommentThreadTemplate(g,D){const $=this.a.get(g);$&&($.range=E.Range.to(D))}$deleteCommentThread(g){this.a.get(g)?.dispose(),this.a.delete(g)}getCommentThread(g){return this.a.get(g)}dispose(){this.a.forEach(g=>{g.dispose()}),this.g.forEach(g=>g.dispose())}}function o(v,g,D,$){let k=D.get(g);return k||(k=++v.commentHandle,D.set(g,k)),g.state!==void 0&&(0,p.$IG)($,"commentsDraftState"),g.reactions?.some(S=>S.reactors!==void 0)&&(0,p.$IG)($,"commentReactor"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:k,body:typeof g.body=="string"?g.body:E.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(S=>t(S)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function t(v){return{label:v.label,iconPath:v.iconPath?E.$pP(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted,reactors:v.reactors&&v.reactors.length>0&&typeof v.reactors[0]!="string"?v.reactors.map(g=>g.name):v.reactors}}function l(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?N.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1,reactors:v.reactors?.map(g=>({name:g}))}}function r(v){if(v!==void 0)switch(v){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function c(v){let g;if(typeof v=="object"?g=v.resolved:g=v,g!==void 0)switch(g){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function s(v){let g;if(typeof v=="object"&&(g=v.applicability),g!==void 0)switch(g){case A.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(ke[337],Se([1,0,22,57,3,15,23,2,16,92,112,6,8]),function(le,e,d,L,O,R,N,b,m,E,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;class y{constructor(l,r){this.document=l,this.b=r,this.a=1,this.c=new A.$$kc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,r){await this.f(l).undo(),r||this.disposeBackup()}async redo(l,r){await this.f(l).redo(),r||this.disposeBackup()}disposeEdits(l){for(const r of l)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=o(this.document.uri)+this.a++;return(0,N.$0g)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const r=this.c.get(l,0);if(!r)throw new Error("No edit found");return r}}class w{constructor(){this.a=new Map}get(l,r){return this.a.get(this.b(l,r))}add(l,r,c){const s=this.b(l,r.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${l} resource:${r.uri}`);const v=new y(r,c);return this.a.set(s,v),v}delete(l,r){const c=this.b(l,r.uri);this.a.delete(c)}b(l,r){return`${l}@@@${r}`}}var h;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(h||(h={}));class f{constructor(){this.a=new Map}addTextProvider(l,r,c){return this.b(0,l,r,c)}addCustomProvider(l,r,c){return this.b(1,l,r,c)}get(l){return this.a.get(l)}b(l,r,c,s){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:l,extension:c,provider:s}),new p.$5M(()=>this.a.delete(r))}}class a{constructor(l,r,c,s,v){this.d=r,this.f=c,this.g=s,this.h=v,this.b=new f,this.c=new w,this.a=l.getProxy(P.$3M.MainThreadCustomEditors)}registerCustomEditorProvider(l,r,c,s){const v=new O.$Uc;return i(c)?(v.add(this.b.addTextProvider(r,l,c)),this.a.$registerTextEditorProvider((0,E.$Hlc)(l),r,s.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,E.$Flc)(l))):(v.add(this.b.addCustomProvider(r,l,c)),n(c)&&v.add(c.onDidChangeCustomDocument(g=>{const D=this.i(r,g.document.uri);if(u(g)){const $=D.addEdit(g);this.a.$onDidEdit(g.document.uri,r,$,g.label)}else this.a.$onContentChange(g.document.uri,r)})),this.a.$registerCustomEditorProvider((0,E.$Hlc)(l),r,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,E.$Flc)(l))),p.$5M.from(v,new p.$5M(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(l,r,c,s,v){const g=this.b.get(r);if(!g)throw new Error(`No provider found for '${r}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${r}'`);const D=b.URI.revive(l),$=await g.provider.openCustomDocument(D,{backupId:c,untitledDocumentData:s?.buffer},v);let k;return n(g.provider)&&this.f&&(k=this.f.workspaceValue(g.extension)??this.f.globalValue(g.extension)),this.c.add(r,$,k),{editable:n(g.provider)}}async $disposeCustomDocument(l,r){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${r}'`);const s=b.URI.revive(l),{document:v}=this.i(r,s);this.c.delete(r,v),v.dispose()}async $resolveCustomEditor(l,r,c,s,v,g){const D=this.b.get(c);if(!D)throw new Error(`No provider found for '${c}'`);const $=m.ViewColumn.to(v),k=this.g.createNewWebview(r,s.contentOptions,D.extension),S=this.h.createNewWebviewPanel(r,c,s.title,$,s.options,k,s.active),C=b.URI.revive(l);switch(D.type){case 1:{const{document:I}=this.i(c,C);return D.provider.resolveCustomEditor(I,S,g)}case 0:{const I=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(I,S,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,r,c){this.i(r,l).disposeEdits(c)}async $onMoveCustomEditor(l,r,c){const s=this.b.get(c);if(!s)throw new Error(`No provider found for '${c}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const v=this.h.getWebviewPanel(l);if(!v)throw new Error("No webview found");const g=b.URI.revive(r),D=this.d.getDocument(g);await s.provider.moveCustomTextEditor(D,v,d.CancellationToken.None)}async $undo(l,r,c,s){return this.i(r,l).undo(c,s)}async $redo(l,r,c,s){return this.i(r,l).redo(c,s)}async $revert(l,r,c){const s=this.i(r,l);await this.j(r).revertCustomDocument(s.document,c),s.disposeBackup()}async $onSave(l,r,c){const s=this.i(r,l);await this.j(r).saveCustomDocument(s.document,c),s.disposeBackup()}async $onSaveAs(l,r,c,s){const v=this.i(r,l);return this.j(r).saveCustomDocumentAs(v.document,b.URI.revive(c),s)}async $backup(l,r,c){const s=this.i(r,l),g=await this.j(r).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},c);return s.updateBackup(g),g.id}i(l,r){const c=this.c.get(l,b.URI.revive(r));if(!c)throw new Error("No custom document found");return c}j(l){const c=this.b.get(l)?.provider;if(!c||!n(c))throw new Error("Custom document is not editable");return c}}e.$Klc=a;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function u(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const l=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,L.$kj)(l)+""}}),define(ke[338],Se([1,0,224,139,2,6,8,16,4,11,27,60]),function(le,e,d,L,O,R,N,b,m,E,A,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=e.$flc=void 0;class y{#e;#t;#n;constructor(f,a,n,i,u,o,t,l){this.d=f,this.e=a,this.f=n,this.g=i,this.h=u,this.c=!1,this.f=Math.max(i,n),this.#n=new A.$Bc(r=>o.getComparisonKey(r)),this.#e=t,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#n.keys()]),this.#e?.$clear(this.e),this.#n.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,a){if(!f){this.clear();return}this.j();let n=[];if(O.URI.isUri(f)){if(!a){this.delete(f);return}this.#n.set(f,a.slice()),n=[f]}else if(Array.isArray(f)){n=[];let o;f=[...f].sort(y.k);for(const t of f){const[l,r]=t;if((!o||l.toString()!==o.toString())&&(o&&this.#n.get(o).length===0&&this.#n.delete(o),o=l,n.push(l),this.#n.set(l,[])),r)this.#n.get(l)?.push(...r);else{const c=this.#n.get(l);c&&(c.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let u=0;for(const o of n){let t=[];const l=this.#n.get(o);if(l)if(l.length>this.g){t=[];const r=[N.DiagnosticSeverity.Error,N.DiagnosticSeverity.Warning,N.DiagnosticSeverity.Information,N.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const s of l)if(s.severity===r[c]&&t.push({...b.Diagnostic.from(s),modelVersionId:this.h(o)})===this.g)break e;t.push({severity:L.MarkerSeverity.Info,message:(0,d.localize)(0,null,l.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=l.map(r=>({...b.Diagnostic.from(r),modelVersionId:this.h(o)}));if(i.push([o,t]),u+=t.length,u>this.f)break}this.#e.$changeMany(this.e,i)}delete(f){this.j(),this.#t.fire([f]),this.#n.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#n.keys()]),this.#n.clear(),this.#e?.$clear(this.e)}forEach(f,a){this.j();for(const[n,i]of this)f.call(a,n,i,this)}*[Symbol.iterator](){this.j();for(const f of this.#n.keys())yield[f,this.get(f)]}get(f){this.j();const a=this.#n.get(f);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#n.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,a){return f[0].toString()<a[0].toString()?-1:f[0].toString()>a[0].toString()?1:0}}e.$flc=y;let w=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(f){const a=new A.$Bc;for(const n of f)a.set(n,n);return{uris:Object.freeze(Array.from(a.values()))}}constructor(f,a,n,i){this.j=a,this.k=n,this.l=i,this.g=new Map,this.h=new m.$ie({merge:u=>u.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,p._mapper),this.f=f.getProxy(R.$3M.MainThreadDiagnostics)}createDiagnosticCollection(f,a){const{g:n,f:i,h:u,j:o,k:t,l}=this,r=new class{$changeMany(v,g){i.$changeMany(v,g),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,v,g.length===0?"CLEARING":g)}$clear(v){i.$clear(v),o.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,v)}dispose(){i.dispose()}};let c;if(!a)a="_generated_diagnostic_collection_name_#"+p.c++,c=a;else if(!n.has(a))c=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do c=a+p.c++;while(n.has(c))}return new class extends y{constructor(){super(a,c,p.e,p.d,v=>l.getDocument(v)?.version,t.extUri,r,u),n.set(c,this)}dispose(){super.dispose(),n.delete(c)}}}getDiagnostics(f){if(f)return this.m(f);{const a=new Map,n=[];for(const i of this.g.values())i.forEach((u,o)=>{let t=a.get(u.toString());typeof t>"u"&&(t=n.length,a.set(u.toString(),t),n.push([u,[]])),n[t][1]=n[t][1].concat(...o)});return n}}m(f){let a=[];for(const n of this.g.values())n.has(f)&&(a=a.concat(n.get(f)));return a}$acceptMarkersChange(f){if(!this.n){const a="_generated_mirror",n=new y(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(a,n),this.n=n}for(const[a,n]of f)this.n.set(O.URI.revive(a),n.map(b.Diagnostic.to))}};e.$glc=w,e.$glc=w=p=Ke([We(1,E.$3j),We(2,P.$elc)],w)}),define(ke[339],Se([1,0,2,13,8,16,76,48]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=void 0;class m{constructor(A,P,p,y={timeout:1500,errors:3}){this.c=A,this.d=P,this.f=p,this.g=y,this.a=new N.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(P,p,y)=>{const h={dispose:this.a.push([P,p,A])};return Array.isArray(y)&&y.push(h),h}}async $participateInSave(A,P){const p=d.URI.revive(A);let y=!1;const w=setTimeout(()=>y=!0,this.g.timeout),h=[];try{for(const f of[...this.a]){if(y)break;const a=this.d.getDocument(p),n=await this.h(f,{document:a,reason:R.TextDocumentSaveReason.to(P)});h.push(n)}}finally{clearTimeout(w)}return h}h([A,P,p],y){const w=this.b.get(A);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(p,A,P,y).then(()=>!0,h=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' threw ERROR`),this.c.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const f=this.b.get(A);this.b.set(A,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,P,p,y){const w=[],h=Date.now(),{document:f,reason:a}=y,{version:n}=f,i=Object.freeze({document:f,reason:a,waitUntil(u){if(Object.isFrozen(w))throw(0,L.$8)("waitUntil can not be called async");w.push(Promise.resolve(u))}});try{P.apply(p,[i])}catch(u){return Promise.reject(u)}return Object.freeze(w),new Promise((u,o)=>{const t=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(w).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(t),u(l)}).catch(l=>{clearTimeout(t),o(l)})}).then(u=>{const o={edits:[]};for(const t of u)if(Array.isArray(t)&&t.every(l=>l instanceof O.$_M))for(const{newText:l,newEol:r,range:c}of t)o.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:c&&R.Range.from(c),text:l,eol:r&&R.EndOfLine.from(r)}});if(o.edits.length!==0)return n===f.version?this.f.$tryApplyWorkspaceEdit(new b.$vw(o)):Promise.reject(new Error("concurrent_edits"))})}}e.$omc=m}),define(ke[340],Se([1,0,4,3,2,6,153,16,18,24,8]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class P{constructor(y,w){this.a=new d.$ee,this.b=new d.$ee,this.c=new d.$ee,this.d=new d.$ee,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Uc,this.h=new Map,this.f=y.getProxy(R.$3M.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(h=>{for(const f of h)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const f of h)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(y){if(!y)return;const w=this.g.getDocument(y);if(w)return w}getDocument(y){const w=this.getDocumentData(y);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return w.document}ensureDocumentData(y){const w=this.g.getDocument(y);if(w)return Promise.resolve(w);let h=this.h.get(y.toString());return h||(h=this.f.$tryOpenDocument(y).then(f=>{this.h.delete(y.toString());const a=O.URI.revive(f);return(0,m.$hg)(this.g.getDocument(a))},f=>(this.h.delete(y.toString()),Promise.reject(f))),this.h.set(y.toString(),h)),h}createDocumentData(y){return this.f.$tryCreateDocument(y).then(w=>O.URI.revive(w))}$acceptModelLanguageChanged(y,w){const h=O.URI.revive(y),f=this.g.getDocument(h);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(w),this.a.fire(f.document)}$acceptModelSaved(y){const w=O.URI.revive(y),h=this.g.getDocument(w);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(y,w){const h=O.URI.revive(y),f=this.g.getDocument(h);if(!f)throw new Error("unknown document");f._acceptIsDirty(w),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,w,h){const f=O.URI.revive(y),a=this.g.getDocument(f);if(!a)throw new Error("unknown document");a._acceptIsDirty(h),a.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,E.$4n)({document:a.document,contentChanges:w.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(y,w){(0,N.$sP)(y,w)}}e.$hlc=P}),define(ke[72],Se([1,0,74,4,18,2,5,6,20,16,8]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0,e.$Llc=(0,N.$wi)("IExtHostEditorTabs");class P{constructor(f,a,n){this.e=n,this.d=a,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,a={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$PO(R.URI.revive(this.b.input.uri));case 2:return new A.$QO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$RO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$SO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$TO(this.b.input.viewType);case 4:return new A.$UO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$VO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$WO;case 9:return new A.$XO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$YO;case 11:return new A.$ZO(this.b.input.diffEditors.map(f=>new A.$QO(R.URI.revive(f.original),R.URI.revive(f.modified))));default:return}}}class p{constructor(f,a){this.c=[],this.d="",this.b=f,this.e=a;for(const n of f.tabs)n.isActive&&(this.d=n.id),this.c.push(new P(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,a={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return E.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(n=>n.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(n=>n.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const n=new P(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,n),f.tabDto.isActive&&(this.d=n.tabId),n}else if(f.kind===1){const n=this.c.splice(f.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(f.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,n),n}const a=this.c.find(n=>n.tabId===f.tabDto.id);if(!a)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(f.tabDto),a}activeTabId(){return this.d}}let y=class{constructor(f){this.b=new L.$ee,this.c=new L.$ee,this.e=[],this.a=f.getProxy(b.$3M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,a={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(n=>n.apiObject))},get activeTabGroup(){const n=f.d;return(0,O.$hg)(f.e.find(u=>u.groupId===n)?.apiObject)},close:async(n,i)=>{const u=Array.isArray(n)?n:[n];return u.length?w(u[0])?this.j(u,i):this.i(u,i):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(f){const a=new Set(this.e.map(r=>r.groupId)),n=new Set(f.map(r=>r.groupId)),i=(0,d.$L)(a,n),u=this.e.filter(r=>i.removed.includes(r.groupId)).map(r=>r.apiObject),o=[],t=[];this.e=f.map(r=>{const c=new p(r,()=>this.d);return i.added.includes(c.groupId)?o.push(c.apiObject):t.push(c.apiObject),c});const l=(0,O.$hg)(f.find(r=>r.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:o,closed:u,changed:t}))}$acceptTabGroupUpdate(f){const a=this.e.find(n=>n.groupId===f.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const a=this.e.find(i=>i.groupId===f.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const n=a.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(f){for(const a of this.e)for(const n of a.tabs)if(n.apiObject===f)return n}h(f){return this.e.find(a=>a.apiObject===f)}async i(f,a){const n=[];for(const i of f){const u=this.g(i);if(!u)throw new Error("Tab close: Invalid tab not found!");n.push(u.tabId)}return this.a.$closeTab(n,a)}async j(f,a){const n=[];for(const i of f){const u=this.h(i);if(!u)throw new Error("Group close: Invalid group not found!");n.push(u.groupId)}return this.a.$closeGroup(n,a)}};e.$Mlc=y,e.$Mlc=y=Ke([We(0,m.$qP)],y);function w(h){return h.tabs!==void 0}}),define(ke[341],Se([1,0,2,6,3,8,16,185,14,21,26,81]),function(le,e,d,L,O,R,N,b,m,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0;class p{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const f=this.a.indexOf(h);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),f=[];let a,n,i=14,u=14;for(const o of h){let t=a?(0,m.$Af)(a,o):0;for(t===0?n=1:n=u;t<o.length;t++)t+1===o.length?(i=u,u=9):u+=1,f.push([n,o.toUpperCase().charCodeAt(t),u]),f.push([n,o.toLowerCase().charCodeAt(t),u]),n=u;a=o,u=i}f.push([9,58,10]),f.push([10,47,12]),this.b=new b.$l3(f)}}provideDocumentLinks(h){this.c();const f=[],a=b.$m3.computeLinks({getLineContent(n){return h.lineAt(n-1).text},getLineCount(){return h.lineCount}},this.b);for(const n of a){const i=N.DocumentLink.to(n);i.target&&f.push(i)}return f}}class y{constructor(h,f){this.i=f,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(L.$3M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,f,a,n={}){if(y.j(a),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const i=this.h++;this.b.add(f),this.d.add(f),this.c.set(i,a);let u=2;n.isCaseSensitive&&(u+=1024),n.isReadonly&&(u+=2048),typeof a.copy=="function"&&(u+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,A.$IG)(h,"fsChunks"),u+=4);let o;n.isReadonly&&(0,P.$Vk)(n.isReadonly)&&n.isReadonly.value!==""&&(o={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,f,u,o).catch(l=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${f}`),console.error(l)});const t=a.onDidChangeFile(l=>{const r=[];for(const c of l){const{uri:s,type:v}=c;if(s.scheme!==f)continue;let g;switch(v){case R.FileChangeType.Changed:g=0;break;case R.FileChangeType.Created:g=1;break;case R.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:s,type:g})}this.a.$onFileSystemChange(i,r)});return(0,O.$Tc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:f,ctime:a,mtime:n,size:i,permissions:u}=h;return{type:f,ctime:a,mtime:n,size:i,permissions:u}}$stat(h,f){return Promise.resolve(this.l(h).stat(d.URI.revive(f))).then(a=>y.k(a))}$readdir(h,f){return Promise.resolve(this.l(h).readDirectory(d.URI.revive(f)))}$readFile(h,f){return Promise.resolve(this.l(h).readFile(d.URI.revive(f))).then(a=>E.$Ge.wrap(a))}$writeFile(h,f,a,n){return Promise.resolve(this.l(h).writeFile(d.URI.revive(f),a.buffer,n))}$delete(h,f,a){return Promise.resolve(this.l(h).delete(d.URI.revive(f),a))}$rename(h,f,a,n){return Promise.resolve(this.l(h).rename(d.URI.revive(f),d.URI.revive(a),n))}$copy(h,f,a,n){const i=this.l(h);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(d.URI.revive(f),d.URI.revive(a),n))}$mkdir(h,f){return Promise.resolve(this.l(h).createDirectory(d.URI.revive(f)))}$watch(h,f,a,n){const i=this.l(h).watch(d.URI.revive(a),n);this.f.set(f,i)}$unwatch(h,f){const a=this.f.get(f);a&&(a.dispose(),this.f.delete(f))}$open(h,f,a){const n=this.l(h);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(d.URI.revive(f),a))}$close(h,f){const a=this.l(h);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(f))}$read(h,f,a,n){const i=this.l(h);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const u=E.$Ge.alloc(n);return Promise.resolve(i.read(f,a,u.buffer,0,n)).then(o=>u.slice(0,o))}$write(h,f,a,n){const i=this.l(h);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(f,a,n.buffer,0,n.byteLength))}l(h){const f=this.c.get(h);if(!f){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return f}}e.$qmc=y}),define(ke[342],Se([1,0,4,35,2,6,16,8,46]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rmc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,w,h,f,a,n){this.a=Math.random(),this.b=new d.$ee,this.c=new d.$ee,this.d=new d.$ee,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,L.$qk)(a),u=typeof a=="string",o=n?.correlate,t=f(l=>{if(!(typeof l.session=="number"&&l.session!==this.a)&&!(o&&typeof l.session>"u")){if(!n?.ignoreCreateEvents)for(const r of l.created){const c=O.URI.revive(r);i(c.fsPath)&&(!u||w.getWorkspaceFolder(c))&&this.b.fire(c)}if(!n?.ignoreChangeEvents)for(const r of l.changed){const c=O.URI.revive(r);i(c.fsPath)&&(!u||w.getWorkspaceFolder(c))&&this.c.fire(c)}if(!n?.ignoreDeleteEvents)for(const r of l.deleted){const c=O.URI.revive(r);i(c.fsPath)&&(!u||w.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=b.$5M.from(this.i(y,h,a,n,n?.correlate),this.b,this.c,this.d,t)}i(y,w,h,f,a){const n=b.$5M.from();if(typeof h=="string"||f?.ignoreChangeEvents&&f?.ignoreCreateEvents&&f?.ignoreDeleteEvents)return n;const i=y.getProxy(R.$3M.MainThreadFileSystemEventService);let u=!1;(h.pattern.includes(L.$mk)||h.pattern.includes(L.$nk))&&(u=!0);let o;return a&&(f?.ignoreChangeEvents||f?.ignoreCreateEvents||f?.ignoreDeleteEvents)&&(o=14,f?.ignoreChangeEvents&&(o&=-3),f?.ignoreCreateEvents&&(o&=-5),f?.ignoreDeleteEvents&&(o&=-9)),i.$watch(w.identifier.value,this.a,h.baseUri,{recursive:u,excludes:f?.excludes??[],filter:o},!!a),b.$5M.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(y){this.a=y,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(O.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(O.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(O.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(y,w,h){this.j=y,this.k=w,this.l=h,this.a=new d.$ee,this.b=new d.$ee,this.c=new d.$ee,this.d=new d.$ee,this.g=new d.$ge,this.h=new d.$ge,this.i=new d.$ge,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,w,h,f){return new E(this.j,y,w,this.a.event,N.GlobPattern.from(h),f)}$onFileEvent(y){this.a.fire(new A(y))}$onDidRunFileOperation(y,w){switch(y){case 2:this.b.fire(Object.freeze({files:w.map(h=>({oldUri:O.URI.revive(h.source),newUri:O.URI.revive(h.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(h=>O.URI.revive(h.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(h=>O.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,w){return(h,f,a)=>{const n=function(u){h.call(f,u)};return n.extension=y,w.event(n,void 0,a)}}async $onWillRunFileOperation(y,w,h,f){switch(y){case 2:return await this.n(this.g,{files:w.map(a=>({oldUri:O.URI.revive(a.source),newUri:O.URI.revive(a.target)}))},h,f);case 1:return await this.n(this.i,{files:w.map(a=>O.URI.revive(a.target))},h,f);case 0:case 3:return await this.n(this.h,{files:w.map(a=>O.URI.revive(a.target))},h,f)}}async n(y,w,h,f){const a=new Set,n=[];if(await y.fireAsync(w,f,async(u,o)=>{const t=Date.now(),l=await Promise.resolve(u);l instanceof b.$cN&&(n.push([o.extension,l]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>h&&this.k.warn("SLOW file-participant",o.extension.identifier)}),f.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,u]of n){const{edits:o}=N.WorkspaceEdit.from(u,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(o)}return{edit:i,extensionNames:Array.from(a)}}}e.$rmc=P}),define(ke[343],Se([1,0,19,7,22,13,125,3,24,40,14,18,2,29,181,84,135,226,25,16,8,26,112,6]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u,o,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class r{constructor(W,V){this.d=W,this.e=V}async provideDocumentSymbols(W,V){const J=this.d.getDocument(W),X=await this.e.provideDocumentSymbols(J,V);if(!(0,d.$Kb)(X))return X[0]instanceof u.$mN?X.map(i.DocumentSymbol.from):r.f(X)}static f(W){W=W.slice(0).sort((X,he)=>{let we=X.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(X.location.range.end)),we});const V=[],J=[];for(const X of W){const he={name:X.name||"!!MISSING: name!!",kind:i.SymbolKind.from(X.kind),tags:X.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:i.Range.from(X.location.range),selectionRange:i.Range.from(X.location.range),children:[]};for(;;){if(J.length===0){J.push(he),V.push(he);break}const we=J[J.length-1];if(y.$ut.containsRange(we.range,he.range)&&!y.$ut.equalsRange(we.range,he.range)){we.children?.push(he),J.push(he);break}J.pop()}}return V}}class c{constructor(W,V,J,X,he,we){this.f=W,this.g=V,this.h=J,this.j=X,this.k=he,this.l=we,this.d=new t.$$kc("CodeLens"),this.e=new Map}async provideCodeLenses(W,V){const J=this.f.getDocument(W),X=await this.h.provideCodeLenses(J,V);if(!X||V.isCancellationRequested)return;const he=this.d.add(X),we=new b.$Uc;this.e.set(he,we);const Fe={cacheId:he,lenses:[]};for(let qe=0;qe<X.length;qe++)Fe.lenses.push({cacheId:[he,qe],range:i.Range.from(X[qe].range),command:this.g.toInternal(X[qe].command,we)});return Fe}async resolveCodeLens(W,V){const J=W.cacheId&&this.d.get(...W.cacheId);if(!J)return;let X;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?X=J:X=await this.h.resolveCodeLens(J,V),X||(X=J),V.isCancellationRequested)return;const he=W.cacheId&&this.e.get(W.cacheId[0]);if(he){if(!X.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return W.command=this.g.toInternal(X.command,he),W}}releaseCodeLenses(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}}function s(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class v{constructor(W,V){this.d=W,this.e=V}async provideDefinition(W,V,J){const X=this.d.getDocument(W),he=i.Position.to(V),we=await this.e.provideDefinition(X,he,J);return s(we)}}class g{constructor(W,V){this.d=W,this.e=V}async provideDeclaration(W,V,J){const X=this.d.getDocument(W),he=i.Position.to(V),we=await this.e.provideDeclaration(X,he,J);return s(we)}}class D{constructor(W,V){this.d=W,this.e=V}async provideImplementation(W,V,J){const X=this.d.getDocument(W),he=i.Position.to(V),we=await this.e.provideImplementation(X,he,J);return s(we)}}class ${constructor(W,V){this.d=W,this.e=V}async provideTypeDefinition(W,V,J){const X=this.d.getDocument(W),he=i.Position.to(V),we=await this.e.provideTypeDefinition(X,he,J);return s(we)}}class k{static{this.f=10}constructor(W,V){this.g=W,this.h=V,this.d=0,this.e=new Map}async provideHover(W,V,J,X){const he=this.g.getDocument(W),we=i.Position.to(V);let Fe;if(J&&J.verbosityRequest){const tt=J.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const st={action:J.verbosityRequest.action,previousHover:nt};Fe=await this.h.provideHover(he,we,X,st)}else Fe=await this.h.provideHover(he,we,X);if(!Fe||(0,d.$Kb)(Fe.contents))return;Fe.range||(Fe.range=he.getWordRangeAtPosition(we)),Fe.range||(Fe.range=new u.$7M(we,we));const qe=i.Hover.from(Fe),Je=this.d;if(this.e.size===k.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Je,Fe),this.d+=1,{...qe,id:Je}}releaseHover(W){this.e.delete(W)}}class S{constructor(W,V){this.d=W,this.e=V}async provideEvaluatableExpression(W,V,J){const X=this.d.getDocument(W),he=i.Position.to(V),we=await this.e.provideEvaluatableExpression(X,he,J);if(we)return i.EvaluatableExpression.from(we)}}class C{constructor(W,V){this.d=W,this.e=V}async provideInlineValues(W,V,J,X){const he=this.d.getDocument(W),we=await this.e.provideInlineValues(he,i.Range.to(V),i.InlineValueContext.to(J),X);if(Array.isArray(we))return we.map(Fe=>i.InlineValue.from(Fe))}}class I{constructor(W,V){this.d=W,this.e=V}async provideDocumentHighlights(W,V,J){const X=this.d.getDocument(W),he=i.Position.to(V),we=await this.e.provideDocumentHighlights(X,he,J);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class F{constructor(W,V){this.d=W,this.e=V}async provideMultiDocumentHighlights(W,V,J,X){const he=this.d.getDocument(W),we=J.map(Je=>this.d.getDocument(Je)),Fe=i.Position.to(V),qe=await this.e.provideMultiDocumentHighlights(he,Fe,we,X);if(Array.isArray(qe))return qe.map(i.MultiDocumentHighlight.from)}}class j{constructor(W,V){this.d=W,this.e=V}async provideLinkedEditingRanges(W,V,J){const X=this.d.getDocument(W),he=i.Position.to(V),we=await this.e.provideLinkedEditingRanges(X,he,J);if(we&&Array.isArray(we.ranges))return{ranges:(0,d.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class z{constructor(W,V){this.d=W,this.e=V}async provideReferences(W,V,J,X){const he=this.d.getDocument(W),we=i.Position.to(V),Fe=await this.e.provideReferences(he,we,J,X);if(Array.isArray(Fe))return Fe.map(i.location.from)}}class M{static{this.d=1e3}constructor(W,V,J,X,he,we,Fe){this.g=W,this.h=V,this.j=J,this.k=X,this.l=he,this.m=we,this.n=Fe,this.e=new t.$$kc("CodeAction"),this.f=new Map}async provideCodeActions(W,V,J,X){const he=this.g.getDocument(W),we=w.$wt.isISelection(V)?i.Selection.to(V):i.Range.to(V),Fe=[];for(const st of this.j.getDiagnostics(W))if(we.intersection(st.range)&&Fe.push(st)>M.d)break;const qe={diagnostics:Fe,only:J.only?new u.$oN(J.only):void 0,triggerKind:i.CodeActionTriggerKind.to(J.trigger)},Je=await this.k.provideCodeActions(he,we,qe,X);if(!(0,d.$Lb)(Je)||X.isCancellationRequested)return;const rt=this.e.add(Je),tt=new b.$Uc;this.f.set(rt,tt);const nt=[];for(let st=0;st<Je.length;st++){const Pe=Je[st];if(Pe)if(M.o(Pe))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:Pe.title,command:this.h.toInternal(Pe,tt)});else{qe.only&&(Pe.kind?qe.only.contains(Pe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action is of kind '${Pe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Pe.ranges??[];nt.push({cacheId:[rt,st],title:Pe.title,command:Pe.command&&this.h.toInternal(Pe.command,tt),diagnostics:Pe.diagnostics&&Pe.diagnostics.map(i.Diagnostic.from),edit:Pe.edit&&i.WorkspaceEdit.from(Pe.edit,void 0),kind:Pe.kind&&Pe.kind.value,isPreferred:Pe.isPreferred,isAI:(0,o.$HG)(this.m,"codeActionAI")?Pe.isAI:!1,ranges:(0,o.$HG)(this.m,"codeActionRanges")?(0,d.$Hb)(Be.map(i.Range.from)):void 0,disabled:Pe.disabled?.reason})}}return{cacheId:rt,actions:nt}}async resolveCodeAction(W,V){const[J,X]=W,he=this.e.get(J,X);if(!he||M.o(he))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(he,V)??he;let Fe;we.edit&&(Fe=i.WorkspaceEdit.from(we.edit,void 0));let qe;if(we.command){const Je=this.f.get(J);Je&&(qe=this.h.toInternal(we.command,Je))}return{edit:Fe,command:qe}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}class T{constructor(W,V,J,X,he){this.e=W,this.f=V,this.g=J,this.h=X,this.j=he,this.d=new t.$$kc("DocumentPasteEdit")}async prepareDocumentPaste(W,V,J,X){if(!this.g.prepareDocumentPaste)return;const he=this.f.getDocument(W),we=V.map(Je=>i.Range.to(Je)),Fe=i.DataTransfer.toDataTransfer(J,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(he,we,Fe,X),X.isCancellationRequested)return;const qe=Array.from(Fe).filter(([,Je])=>!(Je instanceof u.$UN));return i.DataTransfer.from(qe)}async providePasteEdits(W,V,J,X,he,we){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(V),qe=J.map(nt=>i.Range.to(nt)),Je=i.DataTransfer.toDataTransfer(X,async nt=>(await this.e.$resolvePasteFileData(this.h,W,nt)).buffer),rt=await this.g.provideDocumentPasteEdits(Fe,qe,Je,{only:he.only?new u.$ZN(he.only):void 0,triggerKind:he.triggerKind},we);if(!rt||we.isCancellationRequested)return[];const tt=this.d.add(rt);return rt.map((nt,st)=>({_cacheId:[tt,st],title:nt.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(Pe=>Pe.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(W,V){const[J,X]=W,he=this.d.get(J,X);if(!he||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(he,V)??he;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(W){this.d.delete(W)}}class U{constructor(W,V){this.d=W,this.e=V}async provideDocumentFormattingEdits(W,V,J){const X=this.d.getDocument(W),he=await this.e.provideDocumentFormattingEdits(X,V,J);if(Array.isArray(he))return he.map(i.TextEdit.from)}}class Z{constructor(W,V){this.d=W,this.e=V}async provideDocumentRangeFormattingEdits(W,V,J,X){const he=this.d.getDocument(W),we=i.Range.to(V),Fe=await this.e.provideDocumentRangeFormattingEdits(he,we,J,X);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,V,J,X){(0,P.$gg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const he=this.d.getDocument(W),we=V.map(i.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(he,we,J,X);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}}class te{constructor(W,V){this.d=W,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,V,J,X,he){const we=this.d.getDocument(W),Fe=i.Position.to(V),qe=await this.e.provideOnTypeFormattingEdits(we,Fe,J,X,he);if(Array.isArray(qe))return qe.map(i.TextEdit.from)}}class q{constructor(W,V){this.e=W,this.f=V,this.d=new t.$$kc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,V){const J=await this.e.provideWorkspaceSymbols(W,V);if(!(0,d.$Lb)(J))return{symbols:[]};const X=this.d.add(J),he={cacheId:X,symbols:[]};for(let we=0;we<J.length;we++){const Fe=J[we];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}he.symbols.push({...i.WorkspaceSymbol.from(Fe),cacheId:[X,we]})}return he}async resolveWorkspaceSymbol(W,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const J=this.d.get(...W.cacheId);if(J){const X=await this.e.resolveWorkspaceSymbol(J,V);return X&&(0,m.$6n)(W,i.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class K{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,V,J){this.d=W,this.e=V,this.f=J}async provideRenameEdits(W,V,J,X){const he=this.d.getDocument(W),we=i.Position.to(V);try{const Fe=await this.e.provideRenameEdits(he,we,J,X);return Fe?i.WorkspaceEdit.from(Fe):void 0}catch(Fe){const qe=K.g(Fe);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(W,V,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const X=this.d.getDocument(W),he=i.Position.to(V);try{const we=await this.e.prepareRename(X,he,J);let Fe,qe;if(u.$7M.isRange(we)?(Fe=we,qe=X.getText(we)):(0,P.$$f)(we)&&(Fe=we.range,qe=we.placeholder),!Fe||!qe)return;if(Fe.start.line>he.line||Fe.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Fe),text:qe}}catch(we){const Fe=K.g(we);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(we)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class Y{static{this.d={[h.NewSymbolNameTriggerKind.Invoke]:u.NewSymbolNameTriggerKind.Invoke,[h.NewSymbolNameTriggerKind.Automatic]:u.NewSymbolNameTriggerKind.Automatic}}constructor(W,V,J){this.e=W,this.f=V,this.g=J}async provideNewSymbolNames(W,V,J,X){const he=this.e.getDocument(W),we=i.Range.to(V);try{const Fe=Y.d[J],qe=await this.f.provideNewSymbolNames(he,we,Fe,X);return qe?qe.map(Je=>typeof Je=="string"?{newSymbolName:Je}:{newSymbolName:Je.newSymbolName,tags:Je.tags}):void 0}catch(Fe){this.g.error(Y.h(Fe)??JSON.stringify(Fe,null,"	"));return}}static h(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class ie{constructor(W,V){this.resultId=W,this.tokens=V}}class $e{constructor(W,V){this.f=W,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,V,J){const X=this.f.getDocument(W),he=V!==0?this.d.get(V):null;let we=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(X,he.resultId,J):await this.g.provideDocumentSemanticTokens(X,J);return he&&this.d.delete(V),we?(we=$e.h(we),this.o($e.n(he,we),we)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return $e.j(W)?$e.k(W)?W:new u.$nO(new Uint32Array(W.data),W.resultId):$e.l(W)?$e.m(W)?W:new u.$pO(W.edits.map(V=>new u.$oO(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const V of W.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(W,V){if(!$e.j(V)||!W||!W.tokens)return V;const J=W.tokens,X=J.length,he=V.data,we=he.length;let Fe=0;const qe=Math.min(X,we);for(;Fe<qe&&J[Fe]===he[Fe];)Fe++;if(Fe===X&&Fe===we)return new u.$pO([],V.resultId);let Je=0;const rt=qe-Fe;for(;Je<rt&&J[X-Je-1]===he[we-Je-1];)Je++;return new u.$pO([{start:Fe,deleteCount:X-Fe-Je,data:he.subarray(Fe,we-Je)}],V.resultId)}o(W,V){if($e.j(W)){const J=this.e++;return this.d.set(J,new ie(W.resultId,W.data)),(0,f.$0bb)({id:J,type:"full",data:W.data})}if($e.l(W)){const J=this.e++;return $e.j(V)?this.d.set(J,new ie(V.resultId,V.data)):this.d.set(J,new ie(W.resultId)),(0,f.$0bb)({id:J,type:"delta",deltas:(W.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}class ue{constructor(W,V){this.d=W,this.e=V}async provideDocumentRangeSemanticTokens(W,V,J){const X=this.d.getDocument(W),he=await this.e.provideDocumentRangeSemanticTokens(X,i.Range.to(V),J);return he?this.f(he):null}f(W){return(0,f.$0bb)({id:0,type:"full",data:W.data})}}class ve{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,V,J,X,he){this.f=W,this.g=V,this.h=J,this.j=X,this.k=he,this.d=new t.$$kc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,V,J,X){const he=this.f.getDocument(W),we=i.Position.to(V),Fe=he.getWordRangeAtPosition(we)||new u.$7M(we,we),qe=Fe.with({end:we}),Je=new E.$ae,rt=await this.h.provideCompletionItems(he,we,X,i.CompletionContext.to(J));if(!rt||X.isCancellationRequested)return;const tt=Array.isArray(rt)?new u.$BN(rt):rt,nt=ve.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),st=new b.$Uc;this.e.set(nt,st);const Pe=[],Be={x:nt,b:Pe,a:{replace:i.Range.from(Fe),insert:i.Range.from(qe)},c:tt.isIncomplete||void 0,d:Je.elapsed()};for(let He=0;He<tt.items.length;He++){const Le=tt.items[He],Xe=this.l(Le,[nt,He],qe,Fe);Pe.push(Xe)}return Be}async resolveCompletionItem(W,V){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...W);if(!J)return;const X=this.l(J,W),he=await this.h.resolveCompletionItem(J,V);if(!he)return;const we=this.l(he,W);return(X.h!==we.h||X.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(X.n!==we.n||X.o!==we.o||!(0,m.$7n)(X.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...X,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,V,J,X){const he=this.e.get(V[0]);if(!he)throw Error("DisposableStore is missing...");const we=this.g.toInternal(W.command,he),Fe={x:V,a:W.label,b:W.kind!==void 0?i.CompletionItemKind.from(W.kind):void 0,m:W.tags&&W.tags.map(i.CompletionItemTag.from),c:W.detail,d:typeof W.documentation>"u"?void 0:i.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters?.join(""),l:W.additionalTextEdits&&W.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=W.textEdit.newText):typeof W.insertText=="string"?Fe.h=W.insertText:W.insertText instanceof u.$dN&&(Fe.h=W.insertText.value,Fe.i|=4);let qe;return W.textEdit?qe=W.textEdit.range:W.range&&(qe=W.range),u.$7M.isRange(qe)?Fe.j=i.Range.from(qe):qe&&(!J?.isEqual(qe.inserting)||!X?.isEqual(qe.replacing))&&(Fe.j={insert:i.Range.from(qe.inserting),replace:i.Range.from(qe.replacing)}),Fe}}class _{async provideInlineCompletions(W,V,J,X){}disposeCompletions(W){}handleDidShowCompletionItem(W,V,J){}handlePartialAccept(W,V,J,X){}}class B extends _{constructor(W,V,J,X){super(),this.f=W,this.g=V,this.h=J,this.j=X,this.d=new pe,this.e=(0,o.$HG)(this.f,"inlineCompletionsAdditions"),this.k={[h.InlineCompletionTriggerKind.Automatic]:u.InlineCompletionTriggerKind.Automatic,[h.InlineCompletionTriggerKind.Explicit]:u.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,o.$HG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,V,J,X){const he=this.g.getDocument(W),we=i.Position.to(V),Fe=await this.h.provideInlineCompletionItems(he,we,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:i.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},X);if(!Fe||X.isCancellationRequested)return;const qe=Array.isArray(Fe)?Fe:Fe.items,Je=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],rt=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:qe}),items:qe.map((st,Pe)=>{let Be;st.command&&(tt||(tt=new b.$Uc),Be=this.j.toInternal(st.command,tt));const He=st.insertText;return{insertText:typeof He=="string"?He:{snippet:He.value},filterText:st.filterText,range:st.range?i.Range.from(st.range):void 0,command:Be,idx:Pe,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:Je.map(st=>(tt||(tt=new b.$Uc),this.j.toInternal(st,tt))),suppressSuggestions:!1,enableForwardStability:rt}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,V,J){const X=this.d.get(W)?.items[V];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X,J)}handlePartialAccept(W,V,J,X){const he=this.d.get(W)?.items[V];he&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(he,J),this.h.handleDidPartiallyAcceptCompletionItem(he,i.PartialAcceptInfo.to(X)))}}class ee{async provideInlineEdits(W,V,J){const X=this.f.getDocument(W),he=await this.g.provideInlineEdit(X,{triggerKind:this.e[V.triggerKind]},J);if(!he||J.isCancellationRequested)return;let we;const Fe=this.d.createReferenceId({dispose(){we?.dispose()},item:he});let qe;he.accepted&&(we||(we=new b.$Uc),qe=this.h.toInternal(he.accepted,we));let Je;return he.rejected&&(we||(we=new b.$Uc),Je=this.h.toInternal(he.rejected,we)),{pid:Fe,text:he.text,range:i.Range.from(he.range),accepted:qe,rejected:Je}}disposeEdit(W){this.d.disposeReferenceId(W)?.dispose()}constructor(W,V,J,X){this.f=V,this.g=J,this.h=X,this.d=new pe,this.e={[h.InlineEditTriggerKind.Automatic]:u.InlineEditTriggerKind.Automatic,[h.InlineEditTriggerKind.Invoke]:u.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const V=this.e++;return this.d.set(V,W),V}disposeReferenceId(W){const V=this.d.get(W);return this.d.delete(W),V}get(W){return this.d.get(W)}}class Ce{constructor(W,V){this.e=W,this.f=V,this.d=new t.$$kc("SignatureHelp")}async provideSignatureHelp(W,V,J,X){const he=this.e.getDocument(W),we=i.Position.to(V),Fe=this.g(J),qe=await this.f.provideSignatureHelp(he,we,X,Fe);if(qe){const Je=this.d.add([qe]);return{...i.SignatureHelp.from(qe),id:Je}}}g(W){let V;if(W.activeSignatureHelp){const J=i.SignatureHelp.to(W.activeSignatureHelp),X=this.d.get(W.activeSignatureHelp.id,0);X?(V=X,V.activeSignature=J.activeSignature,V.activeParameter=J.activeParameter):V=J}return{...W,activeSignatureHelp:V}}releaseSignatureHelp(W){this.d.delete(W)}}class oe{constructor(W,V,J,X,he){this.f=W,this.g=V,this.h=J,this.j=X,this.k=he,this.d=new t.$$kc("InlayHints"),this.e=new Map}async provideInlayHints(W,V,J){const X=this.f.getDocument(W),he=i.Range.to(V),we=await this.h.provideInlayHints(X,he,J);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(J.isCancellationRequested)return;const Fe=this.d.add(we);this.e.set(Fe,new b.$Uc);const qe={hints:[],cacheId:Fe};for(let Je=0;Je<we.length;Je++)this.l(we[Je],he)&&qe.hints.push(this.m(we[Je],[Fe,Je]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),qe}async resolveInlayHint(W,V){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...W);if(!J)return;const X=await this.h.resolveInlayHint(J,V);if(X&&this.l(X))return this.m(X,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,V){return W.label.length===0||Array.isArray(W.label)&&W.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(V&&!V.contains(W.position))}m(W,V){const J=this.e.get(V[0]);if(!J)throw Error("DisposableStore is missing...");const X={label:"",cacheId:V,tooltip:i.MarkdownString.fromStrict(W.tooltip),position:i.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(i.TextEdit.from),kind:W.kind&&i.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};if(typeof W.label=="string")X.label=W.label;else{const he=[];X.label=he;for(const we of W.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};u.$eN.isLocation(we.location)&&(Fe.location=i.location.from(we.location)),we.command&&(Fe.command=this.g.toInternal(we.command,J)),he.push(Fe)}}return X}}class se{constructor(W,V){this.e=W,this.f=V,this.d=new t.$$kc("DocumentLink")}async provideLinks(W,V){const J=this.e.getDocument(W),X=await this.f.provideDocumentLinks(J,V);if(!(!Array.isArray(X)||X.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:X.filter(se.g).map(i.DocumentLink.from)};{const he=this.d.add(X),we={links:[],cacheId:he};for(let Fe=0;Fe<X.length;Fe++){if(!se.g(X[Fe]))continue;const qe=i.DocumentLink.from(X[Fe]);qe.cacheId=[he,Fe],we.links.push(qe)}return we}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,V){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...W);if(!J)return;const X=await this.f.resolveDocumentLink(J,V);if(!(!X||!se.g(X)))return i.DocumentLink.from(X)}releaseLinks(W){this.d.delete(W)}}class re{constructor(W,V){this.d=W,this.e=V}async provideColors(W,V){const J=this.d.getDocument(W),X=await this.e.provideDocumentColors(J,V);return Array.isArray(X)?X.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(W,V,J){const X=this.d.getDocument(W),he=i.Range.to(V.range),we=i.Color.to(V.color),Fe=await this.e.provideColorPresentations(we,{document:X,range:he},J);if(Array.isArray(Fe))return Fe.map(i.ColorPresentation.from)}}class G{constructor(W,V){this.d=W,this.e=V}async provideFoldingRanges(W,V,J){const X=this.d.getDocument(W),he=await this.e.provideFoldingRanges(X,V,J);if(Array.isArray(he))return he.map(i.FoldingRange.from)}}class ne{constructor(W,V,J){this.d=W,this.e=V,this.f=J}async provideSelectionRanges(W,V,J){const X=this.d.getDocument(W),he=V.map(i.Position.to),we=await this.e.provideSelectionRanges(X,he,J);if(!(0,d.$Lb)(we))return[];if(we.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let qe=0;qe<he.length;qe++){const Je=[];Fe.push(Je);let rt=he[qe],tt=we[qe];for(;;){if(!tt.range.contains(rt))throw new Error("INVALID selection range, must contain the previous range");if(Je.push(i.SelectionRange.from(tt)),!tt.parent)break;rt=tt.range,tt=tt.parent}}return Fe}}class me{constructor(W,V){this.f=W,this.g=V,this.d=new N.$vP(""),this.e=new Map}async prepareSession(W,V,J){const X=this.f.getDocument(W),he=i.Position.to(V),we=await this.g.prepareCallHierarchy(X,he,J);if(!we)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(we)?we.map(qe=>this.h(Fe,qe)):[this.h(Fe,we)]}async provideCallsTo(W,V,J){const X=this.j(W,V);if(!X)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(X,J);if(he)return he.map(we=>({from:this.h(W,we.from),fromRanges:we.fromRanges.map(Fe=>i.Range.from(Fe))}))}async provideCallsFrom(W,V,J){const X=this.j(W,V);if(!X)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(X,J);if(he)return he.map(we=>({to:this.h(W,we.to),fromRanges:we.fromRanges.map(Fe=>i.Range.from(Fe))}))}releaseSession(W){this.e.delete(W)}h(W,V){const J=this.e.get(W),X=i.CallHierarchyItem.from(V,W,J.size.toString(36));return J.set(X._itemId,V),X}j(W,V){return this.e.get(W)?.get(V)}}class be{constructor(W,V){this.f=W,this.g=V,this.d=new N.$vP(""),this.e=new Map}async prepareSession(W,V,J){const X=this.f.getDocument(W),he=i.Position.to(V),we=await this.g.prepareTypeHierarchy(X,he,J);if(!we)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(we)?we.map(qe=>this.h(Fe,qe)):[this.h(Fe,we)]}async provideSupertypes(W,V,J){const X=this.j(W,V);if(!X)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(X,J);if(he)return he.map(we=>this.h(W,we))}async provideSubtypes(W,V,J){const X=this.j(W,V);if(!X)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(X,J);if(he)return he.map(we=>this.h(W,we))}releaseSession(W){this.e.delete(W)}h(W,V){const J=this.e.get(W),X=i.TypeHierarchyItem.from(V,W,J.size.toString(36));return J.set(X._itemId,V),X}j(W,V){return this.e.get(W)?.get(V)}}class Re{constructor(W,V,J,X,he){this.e=W,this.f=V,this.g=J,this.h=X,this.j=he,this.d=new t.$$kc("DocumentDropEdit")}async provideDocumentOnDropEdits(W,V,J,X,he){const we=this.f.getDocument(V),Fe=i.Position.to(J),qe=i.DataTransfer.toDataTransfer(X,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,W,nt)).buffer),Je=await this.g.provideDocumentDropEdits(we,Fe,qe,he);if(!Je)return;const rt=(0,d.$3b)(Je),tt=this.d.add(rt);return rt.map((nt,st)=>({_cacheId:[tt,st],title:nt.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(Pe=>Pe.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(W,V){const[J,X]=W,he=this.d.get(J,X);if(!he||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(he,V)??he;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(W){this.d.delete(W)}}class fe{constructor(W,V){this.d=W,this.e=V}async provideMappedEdits(W,V,J,X){const he=p.URI.revive(W),we=this.d.getDocument(he),Fe=J.documents.map(rt=>rt.map(tt=>({uri:p.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),qe={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Je=await this.e.provideMappedEdits(we,V,qe,X);return Je?i.WorkspaceEdit.from(Je):null}}class De{constructor(W,V){this.adapter=W,this.extension=V}}class Ae{static{this.d=0}constructor(W,V,J,X,he,we,Fe,qe){this.g=V,this.h=J,this.j=X,this.k=he,this.l=we,this.m=Fe,this.n=qe,this.f=new Map,this.e=W.getProxy(l.$3M.MainThreadLanguageFeatures)}o(W,V){return i.DocumentSelector.from(W,this.g,V)}p(W){return new u.$5M(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return Ae.d++}async s(W,V,J,X,he,we=!1){const Fe=this.f.get(W);if(!Fe||!(Fe.adapter instanceof V))return X;const qe=Date.now();we||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Je=J(Fe.adapter,Fe.extension);return Promise.resolve(Je).catch(rt=>{(0,R.$4)(rt)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(rt),this.n.onExtensionError(Fe.extension.identifier,rt))}).finally(()=>{we||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),O.CancellationToken.isCancellationToken(he)?(0,L.$lh)(Je,he):Je}t(W,V){const J=this.q();return this.f.set(J,new De(W,V)),J}static u(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,V,J,X){const he=this.t(new r(this.h,J),W),we=X&&X.label||Ae.u(W);return this.e.$registerDocumentSymbolProvider(he,this.o(V,W),we),this.p(he)}$provideDocumentSymbols(W,V,J){return this.s(W,r,X=>X.provideDocumentSymbols(p.URI.revive(V),J),void 0,J)}registerCodeLensProvider(W,V,J){const X=this.q(),he=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(X,new De(new c(this.h,this.j.converter,J,W,this.n,this.l),W)),this.e.$registerCodeLensSupport(X,this.o(V,W),he);let we=this.p(X);if(he!==void 0){const Fe=J.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(he));we=u.$5M.from(we,Fe)}return we}$provideCodeLenses(W,V,J){return this.s(W,c,X=>X.provideCodeLenses(p.URI.revive(V),J),void 0,J)}$resolveCodeLens(W,V,J){return this.s(W,c,X=>X.resolveCodeLens(V,J),void 0,void 0)}$releaseCodeLenses(W,V){this.s(W,c,J=>Promise.resolve(J.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(W,V,J){const X=this.t(new v(this.h,J),W);return this.e.$registerDefinitionSupport(X,this.o(V,W)),this.p(X)}$provideDefinition(W,V,J,X){return this.s(W,v,he=>he.provideDefinition(p.URI.revive(V),J,X),[],X)}registerDeclarationProvider(W,V,J){const X=this.t(new g(this.h,J),W);return this.e.$registerDeclarationSupport(X,this.o(V,W)),this.p(X)}$provideDeclaration(W,V,J,X){return this.s(W,g,he=>he.provideDeclaration(p.URI.revive(V),J,X),[],X)}registerImplementationProvider(W,V,J){const X=this.t(new D(this.h,J),W);return this.e.$registerImplementationSupport(X,this.o(V,W)),this.p(X)}$provideImplementation(W,V,J,X){return this.s(W,D,he=>he.provideImplementation(p.URI.revive(V),J,X),[],X)}registerTypeDefinitionProvider(W,V,J){const X=this.t(new $(this.h,J),W);return this.e.$registerTypeDefinitionSupport(X,this.o(V,W)),this.p(X)}$provideTypeDefinition(W,V,J,X){return this.s(W,$,he=>he.provideTypeDefinition(p.URI.revive(V),J,X),[],X)}registerHoverProvider(W,V,J,X){const he=this.t(new k(this.h,J),W);return this.e.$registerHoverProvider(he,this.o(V,W)),this.p(he)}$provideHover(W,V,J,X,he){return this.s(W,k,we=>we.provideHover(p.URI.revive(V),J,X,he),void 0,he)}$releaseHover(W,V){this.s(W,k,J=>Promise.resolve(J.releaseHover(V)),void 0,void 0)}registerEvaluatableExpressionProvider(W,V,J,X){const he=this.t(new S(this.h,J),W);return this.e.$registerEvaluatableExpressionProvider(he,this.o(V,W)),this.p(he)}$provideEvaluatableExpression(W,V,J,X){return this.s(W,S,he=>he.provideEvaluatableExpression(p.URI.revive(V),J,X),void 0,X)}registerInlineValuesProvider(W,V,J,X){const he=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new C(this.h,J),W);this.e.$registerInlineValuesProvider(we,this.o(V,W),he);let Fe=this.p(we);if(he!==void 0){const qe=J.onDidChangeInlineValues(Je=>this.e.$emitInlineValuesEvent(he));Fe=u.$5M.from(Fe,qe)}return Fe}$provideInlineValues(W,V,J,X,he){return this.s(W,C,we=>we.provideInlineValues(p.URI.revive(V),J,X,he),void 0,he)}registerDocumentHighlightProvider(W,V,J){const X=this.t(new I(this.h,J),W);return this.e.$registerDocumentHighlightProvider(X,this.o(V,W)),this.p(X)}registerMultiDocumentHighlightProvider(W,V,J){const X=this.t(new F(this.h,J),W);return this.e.$registerMultiDocumentHighlightProvider(X,this.o(V,W)),this.p(X)}$provideDocumentHighlights(W,V,J,X){return this.s(W,I,he=>he.provideDocumentHighlights(p.URI.revive(V),J,X),void 0,X)}$provideMultiDocumentHighlights(W,V,J,X,he){return this.s(W,F,we=>we.provideMultiDocumentHighlights(p.URI.revive(V),J,X.map(Fe=>p.URI.revive(Fe)),he),void 0,he)}registerLinkedEditingRangeProvider(W,V,J){const X=this.t(new j(this.h,J),W);return this.e.$registerLinkedEditingRangeProvider(X,this.o(V,W)),this.p(X)}$provideLinkedEditingRanges(W,V,J,X){return this.s(W,j,async he=>{const we=await he.provideLinkedEditingRanges(p.URI.revive(V),J,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ae.w(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(W,V,J){const X=this.t(new z(this.h,J),W);return this.e.$registerReferenceSupport(X,this.o(V,W)),this.p(X)}$provideReferences(W,V,J,X,he){return this.s(W,z,we=>we.provideReferences(p.URI.revive(V),J,X,he),void 0,he)}registerCodeActionProvider(W,V,J,X){const he=new b.$Uc,we=this.t(new M(this.h,this.j.converter,this.k,J,this.l,W,this.m),W);return this.e.$registerQuickFixSupport(we,this.o(V,W),{providedKinds:X?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:X?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,he)}))},Ae.u(W),!!J.resolveCodeAction),he.add(this.p(we)),he}$provideCodeActions(W,V,J,X,he){return this.s(W,M,we=>we.provideCodeActions(p.URI.revive(V),J,X,he),void 0,he)}$resolveCodeAction(W,V,J){return this.s(W,M,X=>X.resolveCodeAction(V,J),{},void 0)}$releaseCodeActions(W,V){this.s(W,M,J=>Promise.resolve(J.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(W,V,J){const X=this.t(new U(this.h,J),W);return this.e.$registerDocumentFormattingSupport(X,this.o(V,W),W.identifier,W.displayName||W.name),this.p(X)}$provideDocumentFormattingEdits(W,V,J,X){return this.s(W,U,he=>he.provideDocumentFormattingEdits(p.URI.revive(V),J,X),void 0,X)}registerDocumentRangeFormattingEditProvider(W,V,J){const X=typeof J.provideDocumentRangesFormattingEdits=="function",he=this.t(new Z(this.h,J),W);return this.e.$registerRangeFormattingSupport(he,this.o(V,W),W.identifier,W.displayName||W.name,X),this.p(he)}$provideDocumentRangeFormattingEdits(W,V,J,X,he){return this.s(W,Z,we=>we.provideDocumentRangeFormattingEdits(p.URI.revive(V),J,X,he),void 0,he)}$provideDocumentRangesFormattingEdits(W,V,J,X,he){return this.s(W,Z,we=>we.provideDocumentRangesFormattingEdits(p.URI.revive(V),J,X,he),void 0,he)}registerOnTypeFormattingEditProvider(W,V,J,X){const he=this.t(new te(this.h,J),W);return this.e.$registerOnTypeFormattingSupport(he,this.o(V,W),X,W.identifier),this.p(he)}$provideOnTypeFormattingEdits(W,V,J,X,he,we){return this.s(W,te,Fe=>Fe.provideOnTypeFormattingEdits(p.URI.revive(V),J,X,he,we),void 0,we)}registerWorkspaceSymbolProvider(W,V){const J=this.t(new q(V,this.l),W);return this.e.$registerNavigateTypeSupport(J,typeof V.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(W,V,J){return this.s(W,q,X=>X.provideWorkspaceSymbols(V,J),{symbols:[]},J)}$resolveWorkspaceSymbol(W,V,J){return this.s(W,q,X=>X.resolveWorkspaceSymbol(V,J),void 0,void 0)}$releaseWorkspaceSymbols(W,V){this.s(W,q,J=>J.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(W,V,J){const X=this.t(new K(this.h,J,this.l),W);return this.e.$registerRenameSupport(X,this.o(V,W),K.supportsResolving(J)),this.p(X)}$provideRenameEdits(W,V,J,X,he){return this.s(W,K,we=>we.provideRenameEdits(p.URI.revive(V),J,X,he),void 0,he)}$resolveRenameLocation(W,V,J,X){return this.s(W,K,he=>he.resolveRenameLocation(p.URI.revive(V),J,X),void 0,X)}registerNewSymbolNamesProvider(W,V,J){const X=this.t(new Y(this.h,J,this.l),W);return this.e.$registerNewSymbolNamesProvider(X,this.o(V,W)),this.p(X)}$provideNewSymbolNames(W,V,J,X,he){return this.s(W,Y,we=>we.provideNewSymbolNames(p.URI.revive(V),J,X,he),void 0,he)}registerDocumentSemanticTokensProvider(W,V,J,X){const he=this.t(new $e(this.h,J),W),we=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(V,W),X,we);let Fe=this.p(he);if(we){const qe=J.onDidChangeSemanticTokens(Je=>this.e.$emitDocumentSemanticTokensEvent(we));Fe=u.$5M.from(Fe,qe)}return Fe}$provideDocumentSemanticTokens(W,V,J,X){return this.s(W,$e,he=>he.provideDocumentSemanticTokens(p.URI.revive(V),J,X),null,X)}$releaseDocumentSemanticTokens(W,V){this.s(W,$e,J=>J.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,V,J,X){const he=this.t(new ue(this.h,J),W);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(V,W),X),this.p(he)}$provideDocumentRangeSemanticTokens(W,V,J,X){return this.s(W,ue,he=>he.provideDocumentRangeSemanticTokens(p.URI.revive(V),J,X),null,X)}registerCompletionItemProvider(W,V,J,X){const he=this.t(new ve(this.h,this.j.converter,J,this.m,W),W);return this.e.$registerCompletionsProvider(he,this.o(V,W),X,ve.supportsResolving(J),W.identifier),this.p(he)}$provideCompletionItems(W,V,J,X,he){return this.s(W,ve,we=>we.provideCompletionItems(p.URI.revive(V),J,X,he),void 0,he)}$resolveCompletionItem(W,V,J){return this.s(W,ve,X=>X.resolveCompletionItem(V,J),void 0,J)}$releaseCompletionItems(W,V){this.s(W,ve,J=>J.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(W,V,J,X){const he=new B(W,this.h,J,this.j.converter),we=this.t(he,W);return this.e.$registerInlineCompletionsSupport(we,this.o(V,W),he.supportsHandleEvents,n.$Rm.toKey(W.identifier.value),X?.yieldTo?.map(Fe=>n.$Rm.toKey(Fe))||[]),this.p(we)}$provideInlineCompletions(W,V,J,X,he){return this.s(W,_,we=>we.provideInlineCompletions(p.URI.revive(V),J,X,he),void 0,he)}$handleInlineCompletionDidShow(W,V,J,X){this.s(W,_,async he=>{he.handleDidShowCompletionItem(V,J,X)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,V,J,X,he){this.s(W,_,async we=>{we.handlePartialAccept(V,J,X,he)},void 0,void 0)}$freeInlineCompletionsList(W,V){this.s(W,_,async J=>{J.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(W,V,J){const X=new ee(W,this.h,J,this.j.converter),he=this.t(X,W);return this.e.$registerInlineEditProvider(he,this.o(V,W),W.identifier),this.p(he)}$provideInlineEdit(W,V,J,X){return this.s(W,ee,he=>he.provideInlineEdits(p.URI.revive(V),J,X),void 0,X)}$freeInlineEdit(W,V){this.s(W,ee,async J=>{J.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(W,V,J,X){const he=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this.t(new Ce(this.h,J),W);return this.e.$registerSignatureHelpProvider(we,this.o(V,W),he),this.p(we)}$provideSignatureHelp(W,V,J,X,he){return this.s(W,Ce,we=>we.provideSignatureHelp(p.URI.revive(V),J,X,he),void 0,he)}$releaseSignatureHelp(W,V){this.s(W,Ce,J=>J.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(W,V,J){const X=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new oe(this.h,this.j.converter,J,this.l,W),W);this.e.$registerInlayHintsProvider(he,this.o(V,W),typeof J.resolveInlayHint=="function",X,Ae.u(W));let we=this.p(he);if(X!==void 0){const Fe=J.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(X));we=u.$5M.from(we,Fe)}return we}$provideInlayHints(W,V,J,X){return this.s(W,oe,he=>he.provideInlayHints(p.URI.revive(V),J,X),void 0,X)}$resolveInlayHint(W,V,J){return this.s(W,oe,X=>X.resolveInlayHint(V,J),void 0,J)}$releaseInlayHints(W,V){this.s(W,oe,J=>J.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(W,V,J){const X=this.t(new se(this.h,J),W);return this.e.$registerDocumentLinkProvider(X,this.o(V,W),typeof J.resolveDocumentLink=="function"),this.p(X)}$provideDocumentLinks(W,V,J){return this.s(W,se,X=>X.provideLinks(p.URI.revive(V),J),void 0,J,V.scheme==="output")}$resolveDocumentLink(W,V,J){return this.s(W,se,X=>X.resolveLink(V,J),void 0,void 0,!0)}$releaseDocumentLinks(W,V){this.s(W,se,J=>J.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(W,V,J){const X=this.t(new re(this.h,J),W);return this.e.$registerDocumentColorProvider(X,this.o(V,W)),this.p(X)}$provideDocumentColors(W,V,J){return this.s(W,re,X=>X.provideColors(p.URI.revive(V),J),[],J)}$provideColorPresentations(W,V,J,X){return this.s(W,re,he=>he.provideColorPresentations(p.URI.revive(V),J,X),void 0,X)}registerFoldingRangeProvider(W,V,J){const X=this.q(),he=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(X,new De(new G(this.h,J),W)),this.e.$registerFoldingRangeProvider(X,this.o(V,W),W.identifier,he);let we=this.p(X);if(he!==void 0){const Fe=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));we=u.$5M.from(we,Fe)}return we}$provideFoldingRanges(W,V,J,X){return this.s(W,G,he=>he.provideFoldingRanges(p.URI.revive(V),J,X),void 0,X)}registerSelectionRangeProvider(W,V,J){const X=this.t(new ne(this.h,J,this.l),W);return this.e.$registerSelectionRangeProvider(X,this.o(V,W)),this.p(X)}$provideSelectionRanges(W,V,J,X){return this.s(W,ne,he=>he.provideSelectionRanges(p.URI.revive(V),J,X),[],X)}registerCallHierarchyProvider(W,V,J){const X=this.t(new me(this.h,J),W);return this.e.$registerCallHierarchyProvider(X,this.o(V,W)),this.p(X)}$prepareCallHierarchy(W,V,J,X){return this.s(W,me,he=>Promise.resolve(he.prepareSession(p.URI.revive(V),J,X)),void 0,X)}$provideCallHierarchyIncomingCalls(W,V,J,X){return this.s(W,me,he=>he.provideCallsTo(V,J,X),void 0,X)}$provideCallHierarchyOutgoingCalls(W,V,J,X){return this.s(W,me,he=>he.provideCallsFrom(V,J,X),void 0,X)}$releaseCallHierarchy(W,V){this.s(W,me,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(W,V,J){const X=this.t(new be(this.h,J),W);return this.e.$registerTypeHierarchyProvider(X,this.o(V,W)),this.p(X)}$prepareTypeHierarchy(W,V,J,X){return this.s(W,be,he=>Promise.resolve(he.prepareSession(p.URI.revive(V),J,X)),void 0,X)}$provideTypeHierarchySupertypes(W,V,J,X){return this.s(W,be,he=>he.provideSupertypes(V,J,X),void 0,X)}$provideTypeHierarchySubtypes(W,V,J,X){return this.s(W,be,he=>he.provideSubtypes(V,J,X),void 0,X)}$releaseTypeHierarchy(W,V){this.s(W,be,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(W,V,J,X){const he=this.q();return this.f.set(he,new De(new Re(this.e,this.h,J,he,W),W)),this.e.$registerDocumentOnDropEditProvider(he,this.o(V,W),(0,o.$HG)(W,"documentPaste")&&X?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:X.dropMimeTypes}:void 0),this.p(he)}$provideDocumentOnDropEdits(W,V,J,X,he,we){return this.s(W,Re,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(V,p.URI.revive(J),X,he,we)),void 0,void 0)}$resolveDropEdit(W,V,J){return this.s(W,Re,X=>X.resolveDropEdit(V,J),{},void 0)}$releaseDropEdits(W,V){this.s(W,Re,J=>Promise.resolve(J.releaseDropEdits(V)),void 0,void 0)}registerMappedEditsProvider(W,V,J){const X=this.t(new fe(this.h,J),W);return this.e.$registerMappedEditsProvider(X,this.o(V,W)),this.p(X)}$provideMappedEdits(W,V,J,X,he){return this.s(W,fe,we=>Promise.resolve(we.provideMappedEdits(V,J,X,he)),null,he)}registerDocumentPasteEditProvider(W,V,J,X){const he=this.q();return this.f.set(he,new De(new T(this.e,this.h,J,he,W),W)),this.e.$registerPasteEditProvider(he,this.o(V,W),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:X.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:X.copyMimeTypes,pasteMimeTypes:X.pasteMimeTypes}),this.p(he)}$prepareDocumentPaste(W,V,J,X,he){return this.s(W,T,we=>we.prepareDocumentPaste(p.URI.revive(V),J,X,he),void 0,he)}$providePasteEdits(W,V,J,X,he,we,Fe){return this.s(W,T,qe=>qe.providePasteEdits(V,p.URI.revive(J),X,he,we,Fe),void 0,Fe)}$resolvePasteEdit(W,V,J){return this.s(W,T,X=>X.resolvePasteEdit(V,J),{},void 0)}$releasePasteEdits(W,V){this.s(W,T,J=>Promise.resolve(J.releasePasteEdits(V)),void 0,void 0)}static w(W){return{pattern:W.source,flags:W.flags}}static y(W){return{decreaseIndentPattern:Ae.w(W.decreaseIndentPattern),increaseIndentPattern:Ae.w(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Ae.w(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Ae.w(W.unIndentedLinePattern):void 0}}static z(W){return{beforeText:Ae.w(W.beforeText),afterText:W.afterText?Ae.w(W.afterText):void 0,previousLineText:W.previousLineText?Ae.w(W.previousLineText):void 0,action:W.action}}static B(W){return W.map(Ae.z)}static C(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(V=>u.SyntaxTokenType.toString(V)):void 0}}static D(W){return W.map(Ae.C)}setLanguageConfiguration(W,V,J){const{wordPattern:X}=J;if(X&&(0,A.$kf)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this.h.setWordDefinitionFor(V,X):this.h.setWordDefinitionFor(V,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const he=this.q(),we={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ae.w(J.wordPattern):void 0,indentationRules:J.indentationRules?Ae.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ae.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Ae.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(he,V,we),this.p(he)}$setWordDefinitions(W){for(const V of W)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$ilc=Ae}),define(ke[122],Se([1,0,3,6,16,8,109,25,7,4,227,146,13,5,20,121,11,39]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=e.$2lc=void 0,e.$2lc=(0,y.$wi)("IExtHostLanguageModels");class i{constructor(l,r){this.option=l,this.stream=new m.$Zh,this.stream=r??new m.$Zh}}class u{constructor(){this.a=new Map,this.b=new m.$Zh,this.c=!1,this.d=!1;const l=this;this.apiObject={stream:l.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,l]of this.a)yield l.stream;else yield this.b}handleFragment(l){if(this.c)return;this.d=!0;let r=this.a.get(l.index);r||(this.a.size===0?r=new i(l.index,this.b):r=new i(l.index),this.a.set(l.index,r)),r.stream.emitOne(l.part)}get isStreaming(){return this.d}reject(l){this.c=!0;for(const r of this.f())r.reject(l)}resolve(){this.c=!0;for(const l of this.f())l.resolve()}}let o=class{static{n=this}static{this.a=1}constructor(l,r,c){this.j=r,this.k=c,this.c=new E.$ee,this.d=new E.$ee,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Tm,this.i=new Map,this.o=new Set,this.b=l.getProxy(L.$3M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(l,r,c,s){const v=n.a++;this.f.set(v,{extension:l.identifier,provider:c,languageModelId:r});let g;s.auth&&(g={providerLabel:l.displayName||l.name,accountLabel:typeof s.auth=="object"?s.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,r,{extension:l.identifier,identifier:r,name:s.name??"",version:s.version,tokens:s.tokens,auth:g});const D=c.onDidReceiveLanguageModelResponse2?.(({extensionId:$,participant:k,tokenCount:S})=>{this.b.$whenLanguageModelChatRequestMade(r,new b.$Rm($),k,S)});return(0,d.$Tc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v),D?.dispose()})}async $provideLanguageModelResponse(l,r,c,s,v,g){const D=this.f.get(l);if(!D)return;const $=new N.$0v(async k=>{if(g.isCancellationRequested){this.j.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:k.index,part:k.part})});return D.provider.provideLanguageModelResponse2(s.map(O.LanguageModelMessage.to),v,b.$Rm.toKey(c),$,g)}$provideTokenLength(l,r,c){const s=this.f.get(l);return s?Promise.resolve(s.provider.provideTokenCount(r,c)):Promise.resolve(0)}$updateLanguageModels(l){const r=[],c=[];if(l.added)for(const s of l.added)this.g.set(s.identifier,s),r.push(s.identifier);if(l.removed)for(const s of l.removed){this.g.delete(s),c.push(s);for(const[v,g]of this.i)g.languageModelId===s&&(g.res.reject(new p.$5),this.i.delete(v))}this.d.fire(Object.freeze({added:Object.freeze(r),removed:Object.freeze(c)})),l.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(l){const r=new Array;for(const{from:c,to:s,enabled:v}of l){const g=this.h.get(c)??new b.$Sm;if(g.has(s)!==v){v?g.add(s):g.delete(s),this.h.set(c,g);const $={from:c,to:s};r.push($),this.c.fire($)}}}async sendChatRequest(l,r,c,s,v){const g=l.identifier,D=await this.b.$prepareChatAccess(g,r,s.justification);if(!D||!this.g.has(r))throw R.$dP.NotFound(`Language model '${r}' is unknown.`);if(this.m(g,D)&&(!await this.l(l,{identifier:D.extension,displayName:D.auth.providerLabel},s.justification,s.silent)||!this.h.get(g)?.has(D.extension)))throw R.$dP.NoPermissions(`Language model '${r}' cannot be used by '${g.value}'.`);const $=Math.random()*1e6|0,k=this.b.$fetchResponse(g,r,$,c.map(O.LanguageModelMessage.from),s.modelOptions??{},v),S=new m.$vh,C=new u;this.i.set($,{languageModelId:r,res:C});let I;if(k.catch(F=>{S.isOpen()?C.reject(F):I=F}).finally(()=>{this.i.delete($),C.resolve(),S.open()}),await S.wait(),I)throw new R.$dP(`Language model '${r}' errored, check cause for more details`,"Unknown",I);return C.apiObject}async $handleResponseFragment(l,r){const c=this.i.get(l);c&&c.res.handleFragment(r)}async l(l,r,c,s){const v=P.$5L+r.identifier.value;if(await this.k.getSession(l,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:l.identifier,to:r.identifier,enabled:!0}]),!0;if(s)return!1;try{const D=c?(0,A.localize)(0,null,r.displayName,c):(0,A.localize)(1,null,r.displayName);return await this.k.getSession(l,v,[],{forceNewSession:{detail:D}}),this.$updateModelAccesslist([{from:l.identifier,to:r.identifier,enabled:!0}]),!0}catch{return!1}}m(l,r){return!!r.auth&&!b.$Rm.equals(r.extension,l)}async n(l){for(const r of this.o)try{await this.l(r,{identifier:l.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}async computeTokenLength(l,r,c){const s=this.g.get(l);if(!s)throw R.$dP.NotFound(`Language model '${l}' is unknown.`);const v=a.Iterable.find(this.f.values(),g=>g.languageModelId===l);return v?v.provider.provideTokenCount(r,c):this.b.$countTokens(s.identifier,typeof r=="string"?r:O.LanguageModelMessage.from(r),c)}getLanguageModelInfo(l){const r=this.g.get(l);if(r)return{id:r.identifier,name:r.name,version:r.version,tokens:r.tokens}}createLanguageModelAccessInformation(l){this.o.add(l);const r=this,c=E.Event.signal(E.Event.filter(this.c.event,v=>b.$Rm.equals(v.from,l.identifier))),s=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(c,s)},canSendRequest(v){const g=r.g.get(v);if(!g)return;if(!r.m(l.identifier,g))return!0;const D=r.h.get(l.identifier);if(D)return D.has(g.extension)}}}};e.$3lc=o,e.$3lc=o=n=Ke([We(0,w.$qP),We(1,f.$3j),We(2,h.$klc)],o)}),define(ke[344],Se([1,0,6,16,8,41,7,3,26]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class E{constructor(P,p,y,w){this.c=p,this.d=y,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(d.$3M.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,p){await this.a.$changeLanguage(P,p);const y=this.c.getDocumentData(P);if(!y)throw new Error(`document '${P.toString()}' NOT found`);return y.document}async tokenAtPosition(P,p){const y=P.version,w=L.Position.from(p),h=await this.a.$tokensAtPosition(P.uri,w),f={type:O.StandardTokenType.Other,range:P.getWordRangeAtPosition(p)??new O.$7M(p.line,p.character,p.line,p.character)};if(!h)return f;const a={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!a.range.contains(p)||y!==P.version?f:a}createLanguageStatusItem(P,p,y){const w=this.f++,h=this.a,f=this.g,a=`${P.identifier.value}/${p}`;if(f.has(a))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);f.add(a);const n={selector:y,id:p,name:P.displayName??P.name,severity:O.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const u=new b.$Uc,o=()=>{if(i?.dispose(),!f.has(a)){console.warn(`LanguageStatusItem (${p}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,N.$yh)(()=>{u.clear(),this.a.$setLanguageStatus(w,{id:a,name:n.name??P.displayName??P.name,source:P.displayName??P.name,selector:L.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===O.LanguageStatusSeverity.Error?R.default.Error:n.severity===O.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,u),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){u.dispose(),i?.dispose(),h.$removeLanguageStatus(w),f.delete(a)},get id(){return n.id},get name(){return n.name},set name(l){n.name=l,o()},get selector(){return n.selector},set selector(l){n.selector=l,o()},get text(){return n.text},set text(l){n.text=l,o()},set text2(l){(0,m.$IG)(P,"languageStatusText"),n.text=l,o()},get text2(){return(0,m.$IG)(P,"languageStatusText"),n.text},get detail(){return n.detail},set detail(l){n.detail=l,o()},get severity(){return n.severity},set severity(l){n.severity=l,o()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(l){n.accessibilityInformation=l,o()},get command(){return n.command},set command(l){n.command=l,o()},get busy(){return n.busy},set busy(l){n.busy=l,o()}};return o(),t}}e.$Hmc=E}),define(ke[345],Se([1,0,15,2,16,8,120]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=void 0;class b{constructor(P,p,y,w){this.start=P,this.deletedCount=p,this.deletedItems=y,this.items=w}asApiEvent(){return{range:new R.$uO(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(P){return{EOL:P.eol,lines:P.source,languageId:P.language,uri:P.uri,isDirty:!1,versionId:1}}constructor(P,p,y){this.notebook=P,this.h=p,this.j=y,this.handle=y.handle,this.uri=L.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(O.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(O.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:O.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return P.g},set mime(w){P.g=w},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(y)}return this.f}setOutputs(P){this.a=P.map(O.NotebookCellOutput.to)}setOutputItems(P,p,y){const w=y.map(O.NotebookCellOutputItem.to),h=this.a.find(f=>f.id===P);if(h&&(p||(h.items.length=0),h.items.push(...w),h.items.length>1&&h.items.every(f=>N.$ZK(f.mime)))){const f=new Map,a=[];h.items.forEach(n=>{let i;f.has(n.mime)?i=f.get(n.mime):(i=[],f.set(n.mime,i),a.push(n.mime)),i.push(n.data)}),h.items.length=0,a.forEach(n=>{const i=N.$1K(f.get(n));h.items.push({mime:n,data:i.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(O.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$tmc=m;class E{static{this.a=0}constructor(P,p,y,w,h){this.k=P,this.l=p,this.m=y,this.uri=w,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,p={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===d.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(y){return y=P.n(y),P.b[y].apiCell},getCells(y){return(y?P.p(y):P.b).map(h=>h.apiCell)},save(){return P.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,p,y){this.g=P.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:y});const w={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},h=[];for(const a of P.rawEvents)a.kind===N.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,w.contentChanges):a.kind===N.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,w.contentChanges):a.kind===N.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),h.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===N.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),h.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===N.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),h.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===N.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===N.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===N.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),h.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===N.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),h.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const f=new Map;for(let a=0;a<h.length;a++){const n=h[a],i=f.get(n.cell);if(i===void 0){const u=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});f.set(n.cell,u-1)}else w.cellChanges[i]={...w.cellChanges[i],...n}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let p=P.start|0,y=P.end|0;return p<0&&(p=0),y>this.b.length&&(y=this.b.length),P.with({start:p,end:y})}p(P){P=this.o(P);const p=[];for(let y=P.start;y<P.end;y++)p.push(this.b[y]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,p,y){if(this.j)return;const w=[],h=[],f=[];if(P.reverse().forEach(a=>{const i=a[2].map(t=>{const l=new m(this,this.l,t);return p||h.push(m.asModelAddData(t)),l}),u=new b(a[0],a[1],[],i),o=this.b.splice(a[0],a[1],...i);for(const t of o)f.push(t.uri),u.deletedItems.push(t.apiCell);w.push(u)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:f}),y)for(const a of w)y.push(a.asApiEvent())}s(P,p,y,w){const h=this.b.splice(P,p);this.b.splice(y,0,...h);const f=[new b(P,p,h.map(a=>a.apiCell),[]),new b(y,0,[],h)];for(const a of f)w.push(a.asApiEvent())}t(P,p){this.b[P].setOutputs(p)}u(P,p,y,w){this.b[P].setOutputItems(p,y,w)}v(P,p){const y=this.b[P];y.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(y.uri,p)}w(P,p){const y=this.b[P];y.apiCell.mime=p}x(P,p){this.b[P].setMetadata(p)}y(P,p){this.b[P].setInternalMetadata(p)}getCellFromApiCell(P){return this.b.find(p=>p.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(p=>p.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$umc=E}),define(ke[346],Se([1,0,4,2,16,8,48]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;class b{constructor(E,A,P,p={timeout:1500,errors:3}){this.b=E,this.c=A,this.d=P,this.f=p,this.a=new d.$ge}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(A,P,p)=>{const y=function(h){A.call(P,h)};return y.extension=E,this.a.event(y,void 0,p)}}async $participateInSave(E,A,P){const p=L.URI.revive(E),y=this.c.getNotebookDocument(p);if(!y)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:y.apiNotebook,reason:O.TextDocumentSaveReason.to(A)},P,async(f,a)=>{const n=Date.now(),i=await await Promise.resolve(f);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!P.isCancellationRequested&&i&&(i instanceof R.$cN?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(w.length===0)return!0;const h={edits:[]};for(const f of w){const{edits:a}=O.WorkspaceEdit.from(f);h.edits=h.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new N.$vw(h))}}e.$Jmc=b}),define(ke[154],Se([1,0,13,16,8]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,m,E,A,P,p){this.id=b,this.f=m,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=A,this.c=p}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(m){this.selections=[m]},get selections(){return b.a},set selections(m){if(!Array.isArray(m)||!m.every(O.$uO.isNotebookRange))throw(0,d.$7)("selections");b.a=m,b.g(m)},get visibleRanges(){return b.b},revealRange(m,E){b.f.$tryRevealRange(b.id,L.NotebookRange.from(m),E??O.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(L.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$vmc=R}),define(ke[347],Se([1,0,4,11,16]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=void 0;let R=class{constructor(b,m){this.c=b,this.d=m,this.a=new d.$ee,this.b=new d.$ee,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,m);const E=this.d.getEditorById(b);m.visibleRanges&&E._acceptVisibleRanges(m.visibleRanges.ranges.map(O.NotebookRange.to)),m.selections&&E._acceptSelections(m.selections.selections.map(O.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const m in b)this.d.getEditorById(m)._acceptViewColumn(O.ViewColumn.to(b[m]))}};e.$Lmc=R,e.$Lmc=R=Ke([We(0,L.$3j)],R)}),define(ke[348],Se([1,0,4,6,154]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;class R{constructor(b,m){this.c=m,this.a=new Map,this.b=b.getProxy(L.$3M.MainThreadNotebookRenderers)}$postRendererMessage(b,m,E){const A=this.c.getEditorById(b);this.a.get(m)?.fire({editor:A.apiEditor,message:E})}createRendererMessaging(b,m){if(!b.contributes?.notebookRenderer?.some(A=>A.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(A,P,p)=>this.d(m).event(A,P,p),postMessage:(A,P)=>{O.$vmc.apiEditorsToExtHost.has(A)&&([A,P]=[P,A]);const p=P&&O.$vmc.apiEditorsToExtHost.get(P);return this.b.$postMessage(p?.id,m,A)}}}d(b){let m=this.a.get(b);return m||(m=new d.$ee({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(b)}}),this.a.set(b,m),m)}}e.$Omc=R}),define(ke[349],Se([1,0,16,109,22,56,13]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;class b{constructor(P){this.b=0,this.c=new Map,this.a=P}async withProgress(P,p,y){const w=this.b++,{title:h,location:f,cancellable:a}=p,n={label:P.displayName||P.name,id:P.identifier.value};return this.a.$startProgress(w,{location:d.ProgressLocation.from(f),title:h,source:n,cancellable:a},P.isUnderDevelopment?void 0:P.identifier.value).catch(N.$2),this.d(w,y,!!a)}d(P,p,y){let w;y&&(w=new O.$pe,this.c.set(P,w));const h=a=>{this.a.$progressEnd(a),this.c.delete(a),w?.dispose()};let f;try{f=p(new E(this.a,P),y&&w?w.token:O.CancellationToken.None)}catch(a){throw h(P),a}return f.then(a=>h(P),a=>h(P)),f}$acceptProgressCanceled(P){const p=this.c.get(P);p&&(p.cancel(),this.c.delete(P))}}e.$Smc=b;function m(A,P){return A.message=P.message,typeof P.increment=="number"&&(typeof A.increment=="number"?A.increment+=P.increment:A.increment=P.increment),A}class E extends L.$0v{constructor(P,p){super(y=>this.throttledReport(y)),this.c=P,this.d=p}throttledReport(P){this.c.$progressReport(this.d,P)}}Ke([(0,R.$3h)(100,(A,P)=>m(A,P),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(ke[350],Se([1,0,2,6,7,16]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0;class N{static{this.a=0}constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(L.$3M.MainThreadQuickDiff)}$provideOriginalResource(m,E,A){const P=d.URI.revive(E),p=this.c.get(m);return p?(0,O.$oh)(()=>p.provideOriginalResource(P,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(m,E,A,P){const p=N.a++;return this.c.set(p,E),this.b.$registerQuickDiffProvider(p,R.DocumentSelector.from(m,this.d),A,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$Tmc=N}),define(ke[351],Se([1,0,22,4,3,6,2,8,13,19,41,50,26,16]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=w;function w(h,f,a){const n=h.getProxy(R.$3M.MainThreadQuickOpen);class i{constructor(g,D){this.e=new Map,this.f=0,this.a=g,this.b=D}showQuickPick(g,D,$,k=d.CancellationToken.None){this.c=void 0;const S=Promise.resolve(D),C=++this.f,I=n.$show(C,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},k),F={},j=I.then(()=>F);return Promise.race([j,S]).then(z=>{if(z===F)return;const M=(0,p.$HG)(g,"quickPickItemTooltip");return S.then(T=>{const U=[];for(let Z=0;Z<T.length;Z++){const te=T[Z];if(typeof te=="string")U.push({label:te,handle:Z});else if(te.kind===b.QuickPickItemKind.Separator)U.push({type:"separator",label:te.label});else{te.tooltip&&!M&&console.warn(`Extension '${g.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`);const q=te.iconPath?r(te.iconPath):void 0;U.push({label:te.label,iconPath:q?.iconPath,iconClass:q?.iconClass,description:te.description,detail:te.detail,picked:te.picked,alwaysShow:te.alwaysShow,tooltip:M?y.MarkdownString.fromStrict(te.tooltip):void 0,handle:Z})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=Z=>{$.onDidSelectItem(T[Z])}),n.$setItems(C,U),I.then(Z=>{if(typeof Z=="number")return T[Z];if(Array.isArray(Z))return Z.map(te=>T[te])})})}).then(void 0,z=>{if(!(0,m.$4)(z))return n.$setError(C,z),Promise.reject(z)})}$onItemSelected(g){this.c?.(g)}showInput(g,D=d.CancellationToken.None){return this.d=g?.validateInput,n.$input(g,typeof this.d=="function",D).then(void 0,$=>{if(!(0,m.$4)($))return Promise.reject($)})}async $validateInput(g){if(!this.d)return;const D=await this.d(g);if(!D||typeof D=="string")return D;let $;switch(D.severity){case b.InputBoxValidationSeverity.Info:$=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:$=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:$=A.default.Error;break;default:$=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:$}}async showWorkspaceFolderPick(g,D=d.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[g]);if(!$)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(S=>S.uri.toString()===$.uri.toString())}createQuickPick(g){const D=new c(g,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(g){const D=new s(g,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(g,D){this.e.get(g)?._fireDidChangeValue(D)}$onDidAccept(g){this.e.get(g)?._fireDidAccept()}$onDidChangeActive(g,D){const $=this.e.get(g);$ instanceof c&&$._fireDidChangeActive(D)}$onDidChangeSelection(g,D){const $=this.e.get(g);$ instanceof c&&$._fireDidChangeSelection(D)}$onDidTriggerButton(g,D){this.e.get(g)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(g,D,$){const k=this.e.get(g);k instanceof c&&k._fireDidTriggerItemButton(D,$)}$onDidHide(g){this.e.get(g)?._fireDidHide()}}class u{static{this.a=1}constructor(g,D){this.x=g,this.y=D,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$ee,this.q=new L.$ee,this.r=new L.$ee,this.s=new L.$ee,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(g){this.b=g,this.z({title:g})}get step(){return this.c}set step(g){this.c=g,this.z({step:g})}get totalSteps(){return this.d}set totalSteps(g){this.d=g,this.z({totalSteps:g})}get enabled(){return this.g}set enabled(g){this.g=g,this.z({enabled:g})}get busy(){return this.j}set busy(g){this.j=g,this.z({busy:g})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(g){this.k=g,this.z({ignoreFocusOut:g})}get value(){return this.l}set value(g){this.l=g,this.z({value:g})}get placeholder(){return this.m}set placeholder(g){this.m=g,this.z({placeholder:g})}get buttons(){return this.n}set buttons(g){this.n=g.slice(),this.o.clear(),g.forEach((D,$)=>{const k=D===b.$rO.Back?-1:$;this.o.set(k,D)}),this.z({buttons:g.map((D,$)=>({...r(D.iconPath),tooltip:D.tooltip,handle:D===b.$rO.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(g){this.l=g,this.q.fire(g)}_fireDidTriggerButton(g){const D=this.o.get(g);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,O.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(g){if(!this.v){for(const D of Object.keys(g)){const $=g[D];this.u[D]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function o(v){if(v instanceof b.$2N)return{id:v.id};const g=l(v),D=t(v);return{dark:typeof g=="string"?N.URI.file(g):g,light:typeof D=="string"?N.URI.file(D):D}}function t(v){return typeof v=="object"&&"light"in v?v.light:v}function l(v){return typeof v=="object"&&"dark"in v?v.dark:v}function r(v){const g=o(v);let D,$;return"id"in g?$=P.ThemeIcon.asClassName(g):D=g,{iconPath:D,iconClass:$}}class c extends u{constructor(g,D){super(g.identifier,D),this.O=g,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$ee,this.L=[],this.M=new L.$ee,this.N=new L.$ee,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(g){this.B=g.slice(),this.C.clear(),this.D.clear(),g.forEach((k,S)=>{this.C.set(S,k),this.D.set(k,S)});const D=(0,p.$HG)(this.O,"quickPickItemTooltip"),$=[];for(let k=0;k<g.length;k++){const S=g[k];if(S.kind===b.QuickPickItemKind.Separator)$.push({type:"separator",label:S.label});else{S.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=S.iconPath?r(S.iconPath):void 0;$.push({handle:k,label:S.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,tooltip:D?y.MarkdownString.fromStrict(S.tooltip):void 0,buttons:S.buttons?.map((I,F)=>({...r(I.iconPath),tooltip:I.tooltip,handle:F}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(g){this.E=g,this.z({canSelectMany:g})}get matchOnDescription(){return this.F}set matchOnDescription(g){this.F=g,this.z({matchOnDescription:g})}get matchOnDetail(){return this.G}set matchOnDetail(g){this.G=g,this.z({matchOnDetail:g})}get sortByLabel(){return this.H}set sortByLabel(g){this.H=g,this.z({sortByLabel:g})}get keepScrollPosition(){return this.I}set keepScrollPosition(g){this.I=g,this.z({keepScrollPosition:g})}get activeItems(){return this.J}set activeItems(g){this.J=g.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(g){this.L=g.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(g){const D=(0,E.$Hb)(g.map($=>this.C.get($)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(g){const D=(0,E.$Hb)(g.map($=>this.C.get($)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(g,D){const $=this.C.get(g);if(!$||!$.buttons||!$.buttons.length)return;const k=$.buttons[D];k&&this.N.fire({button:k,item:$})}}class s extends u{constructor(g,D){super(g.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(g){this.B=g,this.z({password:g})}get prompt(){return this.C}set prompt(g){this.C=g,this.z({prompt:g})}get valueSelection(){return this.D}set valueSelection(g){this.D=g,this.z({valueSelection:g})}get validationMessage(){return this.E}set validationMessage(g){this.E=g,g?typeof g=="string"?this.z({validationMessage:g,severity:A.default.Error}):this.z({validationMessage:g.message,severity:g.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(f,a)}}),define(ke[352],Se([1,0,2,4,56,3,7,6,19,132,11,25,50,16,26,15,12]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=e.$Vmc=void 0;function n(C){return C instanceof d.URI}function i(C,I){return C.scheme===h.Schemas.file&&I.scheme===h.Schemas.file&&f.$k?C.toString()===I.toString():C.toString().toLowerCase()===I.toString().toLowerCase()}function u(C){if(C)return typeof C.iconPath=="string"?d.URI.file(C.iconPath):d.URI.isUri(C.iconPath)||p.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function o(C){if(C.icon){if(d.URI.isUri(C.icon))return C.icon;if(p.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const I=C.icon;return{light:I.light,dark:I.dark}}}else return}function t(C,I){if(!C.iconPath&&!I.iconPath)return 0;if(C.iconPath){if(!I.iconPath)return 1}else return-1;const F=typeof C.iconPath=="string"?C.iconPath:d.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,j=typeof I.iconPath=="string"?I.iconPath:d.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,E.$qr)(F,j)}function l(C,I){let F=0;if(C.strikeThrough!==I.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==I.faded)return C.faded?1:-1;if(C.tooltip!==I.tooltip)return(C.tooltip||"").localeCompare(I.tooltip||"");if(F=t(C,I),F!==0)return F;if(C.light&&I.light)F=t(C.light,I.light);else{if(C.light)return 1;if(I.light)return-1}if(F!==0)return F;if(C.dark&&I.dark)F=t(C.dark,I.dark);else{if(C.dark)return 1;if(I.dark)return-1}return F}function r(C,I){if(C.command!==I.command)return C.command<I.command?-1:1;if(C.title!==I.title)return C.title<I.title?-1:1;if(C.tooltip!==I.tooltip){if(C.tooltip!==void 0&&I.tooltip!==void 0)return C.tooltip<I.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(C.arguments===I.arguments)return 0;if(C.arguments)if(I.arguments){if(C.arguments.length!==I.arguments.length)return C.arguments.length-I.arguments.length}else return 1;else return-1;for(let F=0;F<C.arguments.length;F++){const j=C.arguments[F],z=I.arguments[F];if(j!==z&&!(n(j)&&n(z)&&i(j,z)))return j<z?-1:1}return 0}function c(C,I){let F=(0,E.$qr)(C.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(F!==0)return F;if(C.command&&I.command)F=r(C.command,I.command);else{if(C.command)return 1;if(I.command)return-1}if(F!==0)return F;if(C.decorations&&I.decorations)F=l(C.decorations,I.decorations);else{if(C.decorations)return 1;if(I.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)F=(0,E.$qr)(C.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)F=(0,E.$qr)(C.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return F}function s(C,I){for(let F=0;F<C.length;F++)if(C[F]!==I[F])return!1;return!0}function v(C,I){return C.command===I.command&&C.title===I.title&&C.tooltip===I.tooltip&&(C.arguments&&I.arguments?s(C.arguments,I.arguments):C.arguments===I.arguments)}function g(C,I){return(0,m.$ub)(C,I,v)}class D{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,w.$IG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,w.$IG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,w.$IG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,F,j,z,M){this.k=I,this.l=z,this.m=M,this.d="",this.e=new L.$ee,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=j}showValidationMessage(I,F){(0,w.$IG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,F)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$Vmc=D;class ${static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,F,j,z,M,T,U){this.q=I,this.s=F,this.t=j,this.u=z,this.v=M,this.multiDiffEditorEnableViewChanges=T,this.w=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$ee,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$ee,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=$.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,F){const j=this.h.get(I);return j?(0,N.$oh)(()=>this.s.executeCommand(j.command,...j.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(c),j=(0,m.$Db)(this.o,I,c).map(T=>{const U=T.toInsert.map(Z=>{const te=this.e++;this.g.set(te,Z);const q=Z.resourceUri;let K;if(Z.command)if(Z.command.command==="vscode.open"||Z.command.command==="vscode.diff"||Z.command.command==="vscode.changes"){const re=new R.$Uc;K=this.s.converter.toInternal(Z.command,re),this.j.set(te,re)}else this.h.set(te,Z.command);const Y=(0,w.$HG)(this.w,"scmMultiDiffEditor"),ie=Y?Z.multiDiffEditorOriginalUri:void 0,$e=Y?Z.multiFileDiffEditorModifiedUri:void 0,ue=u(Z.decorations),ve=Z.decorations&&u(Z.decorations.light)||ue,_=Z.decorations&&u(Z.decorations.dark)||ue,B=[ve,_],ee=Z.decorations&&Z.decorations.tooltip||"",pe=Z.decorations&&!!Z.decorations.strikeThrough,Ce=Z.decorations&&!!Z.decorations.faded,oe=Z.contextValue||"";return{rawResource:[te,q,B,ee,pe,Ce,oe,K,ie,$e],handle:te}});return{start:T.start,deleteCount:T.deleteCount,toInsert:U}}),z=j.map(({start:T,deleteCount:U,toInsert:Z})=>[T,U,Z.map(te=>te.rawResource)]),M=j.reverse();for(const{start:T,deleteCount:U,toInsert:Z}of M){const te=Z.map(K=>K.handle),q=this.n.splice(T,U,...te);for(const K of q)this.g.delete(K),this.h.delete(K),this.j.get(K)?.dispose(),this.j.delete(K)}return this.o=I,z}dispose(){this.l=!0,this.m.fire()}}class k{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let F;(0,w.$HG)(this.x,"quickDiffProvider")&&(F=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:F})}get historyProvider(){return(0,w.$IG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,w.$IG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new R.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new R.$Uc,this.o=I;const F=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:F})}get actionButton(){return(0,w.$IG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,w.$IG)(this.x,"scmActionButton"),this.p.value=new R.$Uc,this.q=I;const F=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(j=>j.map(z=>this.y.converter.toInternal(z,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:F??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&g(this.t,I))return;this.s.value=new R.$Uc,this.t=I;const F=(I||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:F})}get selected(){return this.u}constructor(I,F,j,z,M,T,U){this.x=I,this.y=z,this.z=M,this.A=T,this.B=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Wc,this.m=void 0,this.n=new R.$Wc,this.o=void 0,this.p=new R.$Wc,this.s=new R.$Wc,this.t=void 0,this.u=!1,this.v=new L.$ee,this.onDidChangeSelection=this.v.event,this.w=k.d++,this.C=new Map,this.D=new Set,this.#e=j;const Z=d.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new D(I,F,this.#e,this.w,Z),this.#e.$registerSourceControl(this.w,M,T,U,Z)}createResourceGroup(I,F,j){const z=(0,w.$HG)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,M=new $(this.#e,this.y,this.w,I,F,z,this.x),T=L.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,T),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const I=[],F=[];for(const[j,z]of this.C){z.dispose();const M=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});L.Event.once(j.onDidDispose)(()=>{this.D.delete(j),M.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),I.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const T=j._takeResourceStateSnapshot();T.length>0&&F.push([j.handle,T]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,I,F),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(F=>{const j=F._takeResourceStateSnapshot();j.length!==0&&I.push([F.handle,j])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ke([(0,O.$2h)(100)],k.prototype,"eventuallyAddResourceGroups",null),Ke([(0,O.$2h)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let S=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,F,j,z){this.l=F,this.m=j,this.n=z,this.g=new Map,this.h=new P.$Tm,this.j=new L.$ee,this.e=I.getProxy(b.$3M.MainThreadSCM),this.f=I.getProxy(b.$3M.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const T=this.g.get(M.sourceControlHandle);if(!T)return M;const U=T.getResourceGroup(M.groupHandle);return U?U.getResourceState(M.handle):M}else if(M&&M.$mid===4){const T=this.g.get(M.sourceControlHandle);return T?T.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const T=this.g.get(M.handle);return T||M}return M}})}createSourceControl(I,F,j,z){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,F,j,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const M=a.d++,T=new k(I,this.m,this.e,this.l,F,j,z);this.g.set(M,T);const U=this.h.get(I.identifier)||[];return U.push(T),this.h.set(I.identifier,U),T}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const F=this.h.get(I.identifier),j=F&&F[F.length-1];return j&&j.inputBox}$provideOriginalResource(I,F,j){const z=d.URI.revive(F);this.n.trace("ExtHostSCM#$provideOriginalResource",I,z.toString());const M=this.g.get(I);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,N.$oh)(()=>M.quickDiffProvider.provideOriginalResource(z,j)).then(T=>T||null)}$onInputBoxValueChange(I,F){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const j=this.g.get(I);return j&&j.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(I,F,j,z){this.n.trace("ExtHostSCM#$executeResourceCommand",I,F,j);const M=this.g.get(I);if(!M)return Promise.resolve(void 0);const T=M.getResourceGroup(F);return T?T.$executeResourceCommand(j,z):Promise.resolve(void 0)}$validateInput(I,F,j){this.n.trace("ExtHostSCM#$validateInput",I);const z=this.g.get(I);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,N.$oh)(()=>z.inputBox.validateInput(F,j)).then(M=>{if(!M)return Promise.resolve(void 0);const T=y.MarkdownString.fromStrict(M.message);return T?Promise.resolve([T,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,F,j,z){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,j,z)??void 0}async $provideHistoryItems(I,F,j,z){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(F,j,z))?.map(U=>({...U,icon:o(U)}))??void 0}async $provideHistoryItemSummary(I,F,j,z){const M=this.g.get(I)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const T=await M.provideHistoryItemSummary(F,j,z);return T?{...T,icon:o(T)}:void 0}async $provideHistoryItemChanges(I,F,j,z){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(F,j,z)??void 0}};e.$Wmc=S,e.$Wmc=S=a=Ke([We(3,A.$3j)],S)}),define(ke[353],Se([1,0,6,16,2]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=void 0;class R{static{this.a=0}constructor(b,m){this.d=m,this.c=new Map,this.b=b.getProxy(d.$3M.MainThreadShare)}async $provideShare(b,m,E){return await this.c.get(b)?.provideShare({selection:L.Range.to(m.selection),resourceUri:O.URI.revive(m.resourceUri)},E)??void 0}registerShareProvider(b,m){const E=R.a++;return this.c.set(E,m),this.b.$registerShareProvider(E,L.DocumentSelector.from(b,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Xmc=R}),define(ke[354],Se([1,0,8,6,230,3,16,18]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=e.$Zmc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new d.$3N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.$3N("statusBarItem.warningForeground")]])}#e;#t;constructor(p,y,w,h,f,a=d.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new R.$Uc,this.#e=p,this.#t=y,f&&h){this.c=(0,d.$EN)(h.identifier,f);const i=w.get(this.c);i&&(a=i.alignLeft?d.StatusBarAlignment.Left:d.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(m.a++);this.e=h,this.f=f,this.g=a,this.h=this.u(n)}u(p){if((0,b.$ag)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!m.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new R.$Uc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let y;this.m?y=this.m:y=(0,O.localize)(0,null,this.e.displayName||this.e.name);let w=this.n;this.o&&(w=m.b.get(this.o.id));const h=N.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,y,this.k,h,this.r?.internal,w,this.o,this.g===d.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Zmc=m;class E{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,O.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const y={message:p};return this.b.unshift(y),this.c(),new d.$5M(()=>{const w=this.b.indexOf(y);w>=0&&(this.b.splice(w,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(p,y){this.e=new Map,this.a=p.getProxy(L.$3M.MainThreadStatusBar),this.b=y,this.c=new E(this)}$acceptStaticEntries(p){for(const y of p)this.e.set(y.entryId,y)}createStatusBarEntry(p,y,w,h){return new m(this.a,this.b,this.e,p,y,w,h)}setStatusBarMessage(p,y){const w=this.c.setMessage(p);let h;return typeof y=="number"?h=setTimeout(()=>w.dispose(),y):typeof y<"u"&&y.then(()=>w.dispose(),()=>w.dispose()),new d.$5M(()=>{w.dispose(),clearTimeout(h)})}}e.$1mc=A}),define(ke[155],Se([1,0,29,145,69,113,89,16,2]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=e.$EP=e.$DP=e.$CP=void 0;const E=(i,u,o,t)=>{let l=u;return{enumerable:!0,configurable:!1,get(){return l},set(r){if(!o(l,r)){const c=l;l=r,i.listener?.(t(r,c))}}}},A=(i,u)=>i===u,P={range:(i,u)=>i===u?!0:!i||!u?!1:i.isEqual(u),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,u)=>!(i.length!==u.length||i.some(o=>!u.find(t=>o.id===t.id)))},p=i=>u=>({op:4,update:i(u)}),y=(i,u)=>({range:(()=>{let o;const t=p(l=>({range:d.$ut.lift(b.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return o},set(l){i.listener?.({op:6}),P.range(o,l)||(o=l,i.listener?.(t(l)))}}})(),label:E(i,u,P.label,p(o=>({label:o}))),description:E(i,void 0,P.description,p(o=>({description:o}))),sortText:E(i,void 0,P.sortText,p(o=>({sortText:o}))),canResolveChildren:E(i,!1,P.canResolveChildren,o=>({op:2,state:o})),busy:E(i,!1,P.busy,p(o=>({busy:o}))),error:E(i,void 0,P.error,p(o=>({error:b.MarkdownString.fromStrict(o)||null}))),tags:E(i,[],P.tags,(o,t)=>({op:1,new:o.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),w=i=>{const u=O.$OL.fromString(i.extId),o=new f(u.controllerId,u.localId,i.label,m.URI.revive(i.uri)||void 0);return o.range=b.Range.to(i.range||void 0),o.description=i.description||void 0,o.sortText=i.sortText||void 0,o.tags=i.tags.map(t=>b.TestTag.to({id:(0,N.$UL)(t).tagId})),o},h=i=>{let u;for(const o of i.tests){const t=w(o.item);(0,L.$mP)(t).parent=u,u=t}return u};e.$CP=h;class f{constructor(u,o,t,l){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const r=(0,L.$lP)(this,u);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof a?void 0:r.parent}},children:{value:(0,R.$kP)(r,L.$mP,f),enumerable:!0,writable:!1},...y(r,t)})}}e.$DP=f;class a extends f{constructor(u,o){super(u,u,o,void 0),this._isRoot=!0}}e.$EP=a;class n extends R.$gP{constructor(u,o,t){super({controllerId:u,getDocumentVersion:l=>l&&t.getDocument(l)?.version,getApiFor:L.$mP,getChildren:l=>l.children,root:new a(u,o),toITestItem:b.TestItem.from})}}e.$FP=n}),define(ke[34],Se([1,0,18,8,16,24,6,19,11,58,29,51,2,3,5,20,155,21,48,47,40,87,90,30]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u,o,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.$LP=void 0;let r=class{#e;#t;#n;constructor($,k,S){this.b=new Map,this.c=new Map,this.#e=$.getProxy(N.$3M.MainThreadCommands),this.d=k,this.#n=S,this.#t=$.getProxy(N.$3M.MainThreadTelemetry),this.converter=new c(this,C=>{const I=this.c.get(C);return I?.result===v.Void?I:void 0},k),this.f=[{processArgument(C){return(0,E.$6h)(C)}},{processArgument(C){return(0,R.$5n)(C,function(I){if(A.$ut.isIRange(I))return O.Range.to(I);if(P.$tt.isIPosition(I))return O.Position.to(I);if(A.$ut.isIRange(I.range)&&p.URI.isUri(I.uri))return O.location.to(I);if(I instanceof a.$Ge)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor($){this.f.push($)}registerApiCommand($){const k=this.registerCommand(!1,$.id,async(...S)=>{const C=$.args.map((F,j)=>{if(!F.validate(S[j]))throw new Error(`Invalid argument '${F.name}' when running '${$.id}', received: ${typeof S[j]=="object"?JSON.stringify(S[j],null,"	"):S[j]} `);return F.convert(S[j])}),I=await this.executeCommand($.internalId,...C);return $.result.convert(I,S,this.converter)},void 0,{description:$.description,args:$.args,returns:$.result.description});return this.c.set($.id,$),new L.$5M(()=>{k.dispose(),this.c.delete($.id)})}registerCommand($,k,S,C,I,F){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:S,thisArg:C,metadata:I,extension:F}),$&&this.#e.$registerCommand(k),new L.$5M(()=>{this.b.delete(k)&&$&&this.#e.$unregisterCommand(k)})}executeCommand($,...k){return this.d.trace("ExtHostCommands#executeCommand",$),this.g($,k,!0)}async g($,k,S){if(this.b.has($))return this.#e.$fireCommandActivationEvent($),this.h($,k,!1);{let C=!1;const I=(0,R.$5n)(k,function(F){if(F instanceof L.$6M)return O.Position.from(F);if(F instanceof L.$7M)return O.Range.from(F);if(F instanceof L.$eN)return O.location.from(F);if(L.$uO.isNotebookRange(F))return O.NotebookRange.from(F);if(F instanceof ArrayBuffer)return C=!0,a.$Ge.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return C=!0,a.$Ge.wrap(F);if(F instanceof a.$Ge)return C=!0,F;if(!Array.isArray(F))return F});try{const F=await this.#e.$executeCommand($,C?new n.$vw(I):I,S);return(0,E.$6h)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this.g($,k,!1);throw F}}}async h($,k,S){const C=this.b.get($);if(!C)throw new Error("Unknown command");const{callback:I,thisArg:F,metadata:j}=C;if(j?.args)for(let M=0;M<j.args.length;M++)try{(0,d.$ng)(k[M],j.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${$}' failed. Illegal argument '${j.args[M].name}' - ${j.args[M].description}`)}const z=u.$ae.create();try{return await I.apply(F,k)}catch(M){if($===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...k);T&&($=T.command)}if(this.d.error(M,$,C.extension?.identifier),!S)throw M;if(C.extension?.identifier){const T=this.#n.onExtensionError(C.extension.identifier,M);this.d.trace("forwarded error to extension?",T,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$hj)(M)),this.id=$,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,$,z.elapsed())}}j($,k,S){$.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:$.extension.identifier.value,id:new o.$fp(k),duration:S})}$executeContributedCommand($,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",$);const S=this.b.get($);return S?(k=k.map(C=>this.f.reduce((I,F)=>F.processArgument(I,S.extension?.identifier),C)),this.h($,k,!0)):Promise.reject(new Error(`Contributed command '${$}' does not exist.`))}getCommands($=!1){return this.d.trace("ExtHostCommands#getCommands",$),this.#e.$getCommands().then(k=>($&&(k=k.filter(S=>S[0]!=="_")),k))}$getContributedCommandMetadata(){const $=Object.create(null);for(const[k,S]of this.b){const{metadata:C}=S;C&&($[k]=C)}return Promise.resolve($)}};e.$LP=r,e.$LP=r=Ke([We(0,h.$qP),We(1,m.$3j),We(2,t.$KP)],r),e.$MP=(0,w.$wi)("IExtHostCommands");class c{constructor($,k,S){this.d=$,this.f=k,this.g=S,this.delegatingCommandId=`__vsc${(0,l.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal($,k){if(!$)return;const S={$ident:void 0,id:$.command,title:$.title,tooltip:$.tooltip};if(!$.command)return S;const C=this.f($.command);if(C)S.id=C.internalId,S.arguments=C.args.map((I,F)=>I.convert($.arguments&&$.arguments[F]));else if((0,b.$Lb)($.arguments)){const I=`${$.command} /${++this.c}`;this.b.set(I,$),k.add((0,y.$Tc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),S.$ident=I,S.id=this.delegatingCommandId,S.arguments=[I],this.g.trace("CommandsConverter#CREATE",$.command,I)}return S}fromInternal($){return typeof $.$ident=="string"?this.b.get($.$ident):{command:$.id,title:$.title,arguments:$.arguments}}getActualCommand(...$){return this.b.get($[0])}h(...$){const k=this.getActualCommand(...$);return this.g.trace("CommandsConverter#EXECUTE",$[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${$[0]}`)}}e.$NP=c;class s{static{this.Uri=new s("uri","Uri of a text document",$=>p.URI.isUri($),$=>$)}static{this.Position=new s("position","A position in a text document",$=>L.$6M.isPosition($),O.Position.from)}static{this.Range=new s("range","A range in a text document",$=>L.$7M.isRange($),O.Range.from)}static{this.Selection=new s("selection","A selection in a text document",$=>L.$8M.isSelection($),O.Selection.from)}static{this.Number=new s("number","",$=>typeof $=="number",$=>$)}static{this.String=new s("string","",$=>typeof $=="string",$=>$)}static{this.StringArray=s.Arr(s.String)}static Arr($){return new s(`${$.name}_array`,`Array of ${$.name}, ${$.description}`,k=>Array.isArray(k)&&k.every(S=>$.validate(S)),k=>k.map(S=>$.convert(S)))}static{this.CallHierarchyItem=new s("item","A call hierarchy item",$=>$ instanceof L.$qN,O.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",$=>$ instanceof L.$OO,O.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VS Code TestItem",$=>$ instanceof f.$DP,O.TestItem.from)}constructor($,k,S,C){this.name=$,this.description=k,this.validate=S,this.convert=C}optional(){return new s(this.name,`(optional) ${this.description}`,$=>$==null||this.validate($),$=>$===void 0?void 0:$===null?null:this.convert($))}with($,k){return new s($??this.name,k??this.description,this.validate,this.convert)}}e.$OP=s;class v{static{this.Void=new v("no result",$=>$)}constructor($,k){this.description=$,this.convert=k}}e.$PP=v;class g{constructor($,k,S,C,I){this.id=$,this.internalId=k,this.description=S,this.args=C,this.result=I}}e.$QP=g}),define(ke[355],Se([1,0,19,15,2,84,135,38,34,16,8]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=void 0;const P=[new m.$QP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$OP.Uri,m.$OP.Position],new m.$PP("A promise that resolves to an array of DocumentHighlight-instances.",y(E.DocumentHighlight.to))),new m.$QP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$OP.Uri],new m.$PP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,f)=>{if((0,d.$Kb)(h))return;class a extends A.$lN{static to(i){const u=new a(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new A.$eN(f[0],E.Range.to(i.range)));return u.detail=i.detail,u.range=u.location.range,u.selectionRange=E.Range.to(i.selectionRange),u.children=i.children?i.children.map(a.to):[],u}}return h.map(a.to)})),new m.$QP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$OP.Uri,new m.$OP("options","Formatting options",h=>!0,h=>h)],new m.$PP("A promise that resolves to an array of TextEdits.",y(E.TextEdit.to))),new m.$QP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$OP.Uri,m.$OP.Range,new m.$OP("options","Formatting options",h=>!0,h=>h)],new m.$PP("A promise that resolves to an array of TextEdits.",y(E.TextEdit.to))),new m.$QP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$OP.Uri,m.$OP.Position,new m.$OP("ch","Trigger character",h=>typeof h=="string",h=>h),new m.$OP("options","Formatting options",h=>!0,h=>h)],new m.$PP("A promise that resolves to an array of TextEdits.",y(E.TextEdit.to))),new m.$QP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$OP.Uri,m.$OP.Position],new m.$PP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$QP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$OP.Uri,m.$OP.Position],new m.$PP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$QP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$OP.Uri,m.$OP.Position],new m.$PP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$QP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$OP.Uri,m.$OP.Position],new m.$PP("A promise that resolves to an array of Location or LocationLink instances.",w)),new m.$QP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$OP.Uri,m.$OP.Position],new m.$PP("A promise that resolves to an array of Location-instances.",y(E.location.to))),new m.$QP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$OP.Uri,m.$OP.Position],new m.$PP("A promise that resolves to an array of Hover-instances.",y(E.Hover.to))),new m.$QP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$OP.Uri,new m.$OP("position","A position in a text document",h=>Array.isArray(h)&&h.every(f=>A.$6M.isPosition(f)),h=>h.map(E.Position.from))],new m.$PP("A promise that resolves to an array of ranges.",h=>h.map(f=>{let a;for(const n of f.reverse())a=new A.$pN(E.Range.to(n),a);return a}))),new m.$QP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$OP.String.with("query","Search string")],new m.$PP("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(E.WorkspaceSymbol.to))),new m.$QP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$OP.Uri,m.$OP.Position],new m.$PP("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(E.CallHierarchyItem.to))),new m.$QP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$OP.CallHierarchyItem],new m.$PP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(E.CallHierarchyIncomingCall.to))),new m.$QP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$OP.CallHierarchyItem],new m.$PP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(E.CallHierarchyOutgoingCall.to))),new m.$QP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$OP.Uri,m.$OP.Position],new m.$PP("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:E.Range.to(h.range),placeholder:h.text}})),new m.$QP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$OP.Uri,m.$OP.Position,m.$OP.String.with("newName","The new symbol name")],new m.$PP("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return E.WorkspaceEdit.to(h)}})),new m.$QP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$OP.Uri,m.$OP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$PP("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(E.DocumentLink.to))),new m.$QP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$OP.Uri],new m.$PP("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new A.$lO(h.tokenTypes,h.tokenModifiers)})),new m.$QP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$OP.Uri],new m.$PP("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const f=(0,N.$$bb)(h);if(f.type==="full")return new A.$nO(f.data,void 0)})),new m.$QP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$OP.Uri,m.$OP.Range.optional()],new m.$PP("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new A.$lO(h.tokenTypes,h.tokenModifiers)})),new m.$QP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$OP.Uri,m.$OP.Range],new m.$PP("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const f=(0,N.$$bb)(h);if(f.type==="full")return new A.$nO(f.data,void 0)})),new m.$QP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$OP.Uri,m.$OP.Position,m.$OP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$OP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$PP("A promise that resolves to a CompletionList-instance.",(h,f,a)=>{if(!h)return new A.$BN([]);const n=h.suggestions.map(i=>E.CompletionItem.to(i,a));return new A.$BN(n,h.incomplete)})),new m.$QP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$OP.Uri,m.$OP.Position,m.$OP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$PP("A promise that resolves to SignatureHelp.",h=>{if(h)return E.SignatureHelp.to(h)})),new m.$QP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$OP.Uri,m.$OP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$PP("A promise that resolves to an array of CodeLens-instances.",(h,f,a)=>y(n=>new A.$tN(E.Range.to(n.range),n.command&&a.fromInternal(n.command)))(h))),new m.$QP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$OP.Uri,new m.$OP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>A.$7M.isRange(h),h=>A.$8M.isSelection(h)?E.Selection.from(h):E.Range.from(h)),m.$OP.String.with("kind","Code action kind to return code actions for").optional(),m.$OP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$PP("A promise that resolves to an array of Command-instances.",(h,f,a)=>y(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(n.command)}else{const i=new A.$nN(n.title,n.kind?new A.$oN(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=a.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(h))),new m.$QP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$OP.Uri],new m.$PP("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(f=>new A.$HN(E.Range.to(f.range),E.Color.to(f.color))):[])),new m.$QP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$OP("color","The color to show and insert",h=>h instanceof A.$GN,E.Color.from),new m.$OP("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:E.Range.from(h.range)}))],new m.$PP("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(E.ColorPresentation.to):[])),new m.$QP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$OP.Uri,m.$OP.Range],new m.$PP("A promise that resolves to an array of Inlay objects",(h,f,a)=>h.map(E.InlayHint.to.bind(void 0,a)))),new m.$QP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$OP.Uri],new m.$PP("A promise that resolves to an array of FoldingRange objects",(h,f)=>{if(h)return h.map(E.FoldingRange.to)})),new m.$QP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$PP("A promise that resolves to an array of NotebookContentProvider static info objects.",y(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(f=>E.NotebookExclusiveDocumentPattern.to(f))})))),new m.$QP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$OP.Uri,m.$OP.Range,new m.$OP("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof A.$7M,h=>E.InlineValueContext.from(h))],new m.$PP("A promise that resolves to an array of InlineValue objects",h=>h.map(E.InlineValue.to))),new m.$QP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$OP("uriOrString","Uri-instance or string (only http/https)",h=>O.URI.isUri(h)||typeof h=="string"&&(0,L.$Gg)(h,L.Schemas.http,L.Schemas.https),h=>h),new m.$OP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[E.ViewColumn.from(h),void 0]:[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)])).optional(),m.$OP.String.with("label","").optional()],m.$PP.Void),new m.$QP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$OP.Uri.with("resource","Resource to open"),m.$OP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$OP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[E.ViewColumn.from(h),void 0]:[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)])).optional()],m.$PP.Void),new m.$QP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$OP.Uri.with("left","Left-hand side resource of the diff editor"),m.$OP.Uri.with("right","Right-hand side resource of the diff editor"),m.$OP.String.with("title","Human readable title for the diff editor").optional(),new m.$OP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[E.ViewColumn.from(h.viewColumn),E.TextEditorOpenOptions.from(h)]).optional()],m.$PP.Void),new m.$QP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$OP.String.with("title","Human readable title for the changes editor"),new m.$OP("resourceList","List of resources to compare",h=>{for(const f of h){if(f.length!==3)return!1;const[a,n,i]=f;if(!O.URI.isUri(a)||!O.URI.isUri(n)&&n!==void 0&&n!==null||!O.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},h=>h)],m.$PP.Void),new m.$QP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$OP.Uri,m.$OP.Position],new m.$PP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new m.$QP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$OP.TypeHierarchyItem],new m.$PP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new m.$QP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$OP.TypeHierarchyItem],new m.$PP("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(E.TypeHierarchyItem.to))),new m.$QP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$OP.TestItem],m.$PP.Void),new m.$QP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$OP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$PP.Void),new m.$QP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$OP.String.with("name","The context key name"),new m.$OP("value","The context key value",()=>!0,h=>h)],m.$PP.Void),new m.$QP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$OP.Uri,m.$OP.StringArray,new m.$OP("MappedEditsContext","Mapped Edits Context",h=>E.MappedEditsContext.is(h),h=>E.MappedEditsContext.from(h))],new m.$PP("A promise that resolves to a workspace edit or null",h=>h?E.WorkspaceEdit.to(h):null))];class p{static register(f){P.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",b.$vj)}}e.$jlc=p;function y(h){return f=>{if(Array.isArray(f))return f.map(h)}}function w(h){if(!Array.isArray(h))return;const f=[];for(const a of h)R.$_t(a)?f.push(E.DefinitionLink.to(a)):f.push(E.location.to(a));return f}}),define(ke[356],Se([1,0,7,3,2,6,34,16,8]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=void 0;class E{static{this.a=0}constructor(y,w){this.extension=y,this.provider=w,this.handle=E.a++}}class A{constructor(y){this.session=y,this.responses=[]}}class P{static{this.a=0}constructor(y,w,h,f){this.f=h,this.g=f,this.b=new Map,this.d=new Map,this.e=y.getProxy(R.$3M.MainThreadInlineChat),w.registerApiCommand(new N.$QP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new N.$OP("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?b.Range.from(a.initialRange):void 0,initialSelection:m.$8M.isSelection(a.initialSelection)?b.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?b.Position.from(a.position):void 0}})],N.$PP.Void))}registerProvider(y,w,h){const f=new E(y,w);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,h?.label??y.displayName??y.name,y.identifier,typeof w.handleInteractiveEditorResponseFeedback=="function",typeof w.provideFollowups=="function",h?.supportReportIssue??!1),(0,L.$Tc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(y,w,h,f){const a=this.b.get(y);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(O.URI.revive(w)),i=b.Selection.to(h),u=await a.provider.prepareInteractiveEditorSession({document:n,selection:i},f);if(!u)return;if(u.wholeRange&&!u.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=P.a++;return this.d.set(o,new A(u)),{id:o,placeholder:u.placeholder,input:u.input,slashCommands:u.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(u.wholeRange),message:u.message}}async $provideResponse(y,w,h,f){const a=this.b.get(y);if(!a)return;const n=this.d.get(w.id);if(!n)return;const i={prompt:h.prompt,selection:b.Selection.to(h.selection),wholeRange:b.Range.to(h.wholeRange),attempt:h.attempt,live:h.live,previewDocument:this.f.getDocument(O.URI.revive(h.previewDocument)),withIntentDetection:h.withIntentDetection};let u=!1;const o={report:async D=>{if(!h.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");u||f.isCancellationRequested||await this.e.$handleProgressChunk(h.requestId,{message:D.message,edits:D.edits?.map(b.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:m.$uN.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(n.session,i,o,f));let l;try{l=await(0,d.$kh)(t,f)}finally{u=!0}if(!l)return;const r=n.responses.push(l)-1,c={wholeRange:b.Range.from(l.wholeRange),placeholder:l.placeholder};if(!P.h(l))return{...c,id:r,type:"editorEdit",message:b.MarkdownString.from(l.contents),edits:[]};const{edits:s,contents:v}=l,g=v!==void 0?b.MarkdownString.from(v):void 0;return s instanceof m.$cN?{...c,id:r,type:"bulkEdit",edits:b.WorkspaceEdit.from(s),message:g}:{...c,id:r,type:"editorEdit",edits:s.map(b.TextEdit.from),message:g}}async $provideFollowups(y,w,h,f){const a=this.b.get(y),n=this.d.get(w),i=n?.responses[h];if(a&&i&&a.provider.provideFollowups){const u=Promise.resolve(a.provider.provideFollowups(n.session,i,f));return(await(0,d.$kh)(u,f))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(y,w,h,f){const a=this.b.get(y),n=this.d.get(w),i=n?.responses[h];if(a&&i){const u=b.InteractiveEditorResponseFeedbackKind.to(f);a.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,u)}}$releaseSession(y,w){}static h(y){return typeof y=="object"&&typeof y.edits=="object"}}e.$smc=P}),define(ke[357],Se([1,0,2,34]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class O{constructor(N,b,m,E,A){this.a=b,this.b=m,this.c=E;const P=new L.$QP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$OP("showOptions","Show Options",p=>!0,p=>p),new L.$OP("resource","Interactive resource Uri",p=>!0,p=>p),new L.$OP("controllerId","Notebook controller Id",p=>!0,p=>p),new L.$OP("title","Interactive editor title",p=>!0,p=>p)],new L.$PP("Notebook and input URI",p=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const y=this.a.getEditorById(p.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:d.URI.revive(p.notebookUri),inputUri:d.URI.revive(p.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:d.URI.revive(p.notebookUri),inputUri:d.URI.revive(p.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(N,b,m,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:m,uri:N,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(N,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[N]})}}e.$Fmc=O}),define(ke[358],Se([1,0,19,7,22,4,3,27,2,25,11,6,34,16,8,114,302,26,48,303]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0,e.$Nmc=s;let u=class{constructor(g,D,$,k,S){this.m=D,this.n=$,this.o=k,this.q=S,this.b=new b.$Bc,this.c=new b.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$ee,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=g.getProxy(P.$3M.MainThreadNotebookKernels);const C=new p.$QP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$OP("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const j=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:j}}else if(F&&"notebookEditor"in F){const j=this.n.getIdByEditor(F.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return F})],p.$PP.Void),I=new p.$QP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[p.$OP.Uri],new p.$PP("A promise that resolves to an array of variables",(F,j)=>F.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(I)}createNotebookController(g,D,$,k,S,C){for(const ue of this.j.values())if(ue.controller.id===D&&E.$Rm.equals(g.identifier,ue.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const I=this.k++,F=this;this.q.trace(`NotebookController[${I}], CREATED by ${g.identifier.value}, ${D}`);const j=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${g.identifier}'`);let z=!1;const M=new R.$ee,T=new R.$ee,U={id:s(g.identifier,D),notebookType:$,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:k||g.identifier.value,preloads:C?C.map(y.NotebookRendererScript.from):[]};let Z=S??j,te,q;this.a.$addKernel(I,U).catch(ue=>{console.log(ue),z=!0});let K=0;const Y=()=>{if(z)return;const ue=++K;Promise.resolve().then(()=>{ue===K&&this.a.$updateKernel(I,U)})},ie=new b.$Bc,$e={get id(){return D},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return U.label},set label(ue){U.label=ue??g.displayName??g.name,Y()},get detail(){return U.detail??""},set detail(ue){U.detail=ue,Y()},get description(){return U.description??""},set description(ue){U.description=ue,Y()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ue){U.supportedLanguages=ue,Y()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){U.supportsExecutionOrder=ue,Y()},get rendererScripts(){return U.preloads?U.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(ue){Z=ue??j},get interruptHandler(){return te},set interruptHandler(ue){te=ue,U.supportsInterrupt=!!ue,Y()},set variableProvider(ue){(0,a.$IG)(g,"notebookVariableProvider"),q=ue,U.hasVariableProvider=!!ue,ue?.onDidChangeVariables(ve=>F.a.$variablesUpdated(ve.uri)),Y()},get variableProvider(){return q},createNotebookCellExecution(ue){if(z)throw new Error("notebook controller is DISPOSED");if(!ie.has(ue.notebook.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return F._createNotebookCellExecution(ue,s(g.identifier,this.id))},createNotebookExecution(ue){if((0,a.$IG)(g,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ie.has(ue.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.uri.toString()}`);return F._createNotebookExecution(ue,s(g.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${I}], DISPOSED`),z=!0,this.j.delete(I),M.dispose(),T.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ue,ve){ve===w.NotebookControllerAffinity2.Hidden&&(0,a.$IG)(g,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(I,ue.uri,ve)},onDidReceiveMessage:T.event,postMessage(ue,ve){return(0,a.$IG)(g,"notebookMessaging"),F.a.$postMessage(I,ve&&F.n.getIdByEditor(ve),ue)},asWebviewUri(ue){return(0,a.$IG)(g,"notebookMessaging"),(0,h.$OAb)(ue,F.m.remote)}};return this.j.set(I,{extensionId:g.identifier,controller:$e,onDidReceiveMessage:T,onDidChangeSelection:M,associatedNotebooks:ie}),$e}getIdByController(g){for(const[D,$]of this.j)if($.controller===g)return s($.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,D){const $=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${$}], CREATED by ${g.identifier.value}`),this.a.$addKernelDetectionTask($,D);const S={dispose:()=>{this.f.delete($),k.a.$removeKernelDetectionTask($)}};return this.f.set($,S),S}registerKernelSourceActionProvider(g,D,$){const k=this.i++,S=typeof $.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,C=this;this.h.set(k,$),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${g.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,D);let I;return S!==void 0&&(I=$.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(S))),{dispose:()=>{this.h.delete(k),C.a.$removeKernelSourceActionProvider(k,k),I?.dispose()}}}async $provideKernelSourceActions(g,D){const $=this.h.get(g);if($){const k=new N.$Uc;return(await $.provideNotebookKernelSourceActions(D)??[]).map(C=>y.NotebookKernelSourceAction.from(C,this.o.converter,k))}return[]}$acceptNotebookAssociation(g,D,$){const k=this.j.get(g);if(k){const S=this.n.getNotebookDocument(m.URI.revive(D));$?k.associatedNotebooks.set(S.uri,!0):k.associatedNotebooks.delete(S.uri),this.q.trace(`NotebookController[${g}] ASSOCIATE notebook`,S.uri.toString(),$),k.onDidChangeSelection.fire({selected:$,notebook:S.apiNotebook})}}async $executeCells(g,D,$){const k=this.j.get(g);if(!k)return;const S=this.n.getNotebookDocument(m.URI.revive(D)),C=[];for(const I of $){const F=S.getCell(I);F&&C.push(F.apiCell)}try{this.q.trace(`NotebookController[${g}] EXECUTE cells`,S.uri.toString(),C.length),await k.controller.executeHandler.call(k.controller,C,S.apiNotebook,k.controller)}catch(I){this.q.error(`NotebookController[${g}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(g,D,$){const k=this.j.get(g);if(!k)return;const S=this.n.getNotebookDocument(m.URI.revive(D));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,S.apiNotebook);else for(const C of $){const I=S.getCell(C);I&&this.b.get(I.uri)?.cancel()}if(k.controller.interruptHandler){const C=this.c.get(S.uri);$.length&&Array.isArray(C)&&C.length&&C.forEach(I=>I.dispose())}}async $provideVariables(g,D,$,k,S,C,I){const F=this.j.get(g);if(!F)return;const j=this.n.getNotebookDocument(m.URI.revive($)),z=F.controller.variableProvider;if(!z)return;let M;if(k!==void 0){if(M=this.s[k],!M)return}else this.s={};const T=S==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,U=z.provideVariables(j.apiNotebook,M,T,C,I);let Z=0;for await(const te of U){if(I.isCancellationRequested)return;const q={id:this.r++,name:te.variable.name,value:te.variable.value,type:te.variable.type,interfaces:te.variable.interfaces,language:te.variable.language,expression:te.variable.expression,hasNamedChildren:te.hasNamedChildren,indexedChildrenCount:te.indexedChildrenCount,extensionId:F.extensionId.value};if(this.s[q.id]=te.variable,this.a.$receiveVariable(D,q),Z++>=i.$cjb)return}}$acceptKernelMessageFromRenderer(g,D,$){const k=this.j.get(g);if(!k)return;const S=this.n.getEditorById(D);k.onDidReceiveMessage.fire(Object.freeze({editor:S.apiEditor,message:$}))}$cellExecutionChanged(g,D,$){const S=this.n.getNotebookDocument(m.URI.revive(g)).getCell(D);if(S){const C=$?y.NotebookCellExecutionState.to($):w.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:S.apiCell,state:C})}}_createNotebookCellExecution(g,D){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const S=new t(D,k,this.a);this.b.set(k.uri,S);const C=S.onDidChangeState(()=>{S.state===o.Resolved&&(S.dispose(),C.dispose(),this.b.delete(k.uri))});return S.asApiObject()}_createNotebookExecution(g,D){const $=this.n.getNotebookDocument(g.uri),k=g.getCells().find(I=>{const F=$.getCellFromApiCell(I);return F&&this.b.has(F.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has($.uri))throw new Error(`duplicate notebook execution for ${$.uri}`);const S=new r(D,$,this.a),C=S.onDidChangeState(()=>{S.state===l.Resolved&&(S.dispose(),C.dispose(),this.c.delete($.uri))});return this.c.set($.uri,[S,C]),S.asApiObject()}};e.$Mmc=u,e.$Mmc=u=Ke([We(4,A.$3j)],u);var o;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(o||(o={}));class t extends N.$Vc{static{this.a=0}get state(){return this.f}constructor(g,D,$){super(),this.m=D,this.n=$,this.b=t.a++,this.c=new R.$ee,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new O.$pe),this.h=new c(10,k=>this.s(k)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,g,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(g){await this.h.addItem(g)}async s(g){const D=Array.isArray(g)?g:[g];return this.n.$updateExecution(this.b,new n.$vw(D))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(g){let D=this.m;if(g&&(D=this.m.notebook.getCellFromApiCell(g)),!D)throw new Error("INVALID cell");return D.handle}y(g){return g.map(D=>{const $=w.$yO.ensureUniqueMimeTypes(D.items,!0);return $===D.items?y.NotebookCellOutput.from(D):y.NotebookCellOutput.from({items:$,id:D.id,metadata:D.metadata})})}async z(g,D,$){const k=this.w(D),S=this.y((0,d.$3b)(g));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:k,append:$,outputs:S})}async C(g,D,$){return g=w.$yO.ensureUniqueMimeTypes((0,d.$3b)(g),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:g.map(y.NotebookCellOutputItem.from),outputId:D.id,append:$})}asApiObject(){const g=this;return Object.freeze({get token(){return g.g.token},get cell(){return g.m.apiCell},get executionOrder(){return g.j},set executionOrder($){g.j=$,g.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:g.j}])},start($){if(g.f===o.Resolved||g.f===o.Started)throw new Error("Cannot call start again");g.f=o.Started,g.c.fire(),g.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:$})},end($,k,S){if(g.f===o.Resolved)throw new Error("Cannot call resolve twice");g.f=o.Resolved,g.c.fire(),g.h.flush();const C=S?{message:S.message,stack:S.stack,location:S?.location?{startLineNumber:S.location.start.line,startColumn:S.location.start.character,endLineNumber:S.location.end.line,endColumn:S.location.end.character}:void 0,uri:S.uri}:void 0;g.n.$completeExecution(g.b,new n.$vw({runEndTime:k,lastRunSuccess:$,error:C}))},clearOutput($){return g.t(),g.z([],$,!1)},appendOutput($,k){return g.t(),g.z($,k,!0)},replaceOutput($,k){return g.t(),g.z($,k,!1)},appendOutputItems($,k){return g.t(),g.C($,k,!0)},replaceOutputItems($,k){return g.t(),g.C($,k,!1)}})}}var l;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(l||(l={}));class r extends N.$Vc{static{this.a=0}get state(){return this.f}constructor(g,D,$){super(),this.h=D,this.j=$,this.b=r.a++,this.c=new R.$ee,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new O.$pe),this.j.$createNotebookExecution(this.b,g,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(g,D){this.f=g,this.g=D,this.a=[],this.b=Date.now()}addItem(g){return this.a.push(g),this.c||(this.c=new L.$Th,this.b=Date.now(),(0,L.$xh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const g=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>g.complete())}}function s(v,g){return`${v.value}/${g}`}}),define(ke[43],Se([1,0,4,6,5,2,20,3,8,232,13,279,22,30,280,50,7,16,34]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=e.$Zlc=e.$Ylc=e.$Xlc=void 0,e.$Xlc=(0,O.$wi)("IExtHostTerminalService");class i extends b.$Vc{constructor($,k,S,C){super(),this.u=$,this._id=k,this.w=S,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new d.$ee),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(F=>this.g=F);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(F,j=!0){I.C(),I.u.$sendText(I._id,F,j)},show(F){I.C(),I.u.$show(I._id,F)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create($,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??k?.cwd??void 0,env:$.env??void 0,icon:s($.iconPath)??void 0,color:h.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,forceShellIntegration:k?.forceShellIntegration??void 0,isFeatureTerminal:k?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:k?.useShellEnvironment??void 0,location:k?.location||this.z($.location,k?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,k,S,C,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:h.ThemeColor.isThemeColor(I)?I.id:void 0,location:k?.location||this.z($,S),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z($,k){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&k?{parentTerminal:k}:"viewColumn"in $?{viewColumn:a.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.y=$}setExitStatus($,k){this.j=Object.freeze({code:$,reason:k})}setDimensions($,k){return $===this.f&&k===this.h||$===0||k===0?!1:(this.f=$,this.h=k,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection($){this.n=$}_setProcessId($){this.g?(this.g($),this.g=void 0):this.b.then(k=>{k!==$&&(this.b=Promise.resolve($))})}}e.$Ylc=i;class u{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new d.$ee,this.onProcessData=this.a.event,this.b=new d.$ee,this.d=new d.$ee,this.onDidChangeProperty=this.d.event,this.f=new d.$ee,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,k){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${k}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,k){this.g.setDimensions?.({columns:$,rows:k})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(k=>this.a.fire(k)),this.g.onDidClose?.((k=void 0)=>{this.f.fire(k===void 0?void 0:k)}),this.g.onDidOverrideDimensions?.(k=>{k&&this.d.fire({type:"overrideDimensions",value:{cols:k.columns,rows:k.rows}})}),this.g.onDidChangeName?.(k=>{this.d.fire({type:"title",value:k})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends b.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,k,S){super(),this.Q=k,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new d.$ee,this.onDidCloseTerminal=this.H.event,this.I=new d.$ee,this.onDidOpenTerminal=this.I.event,this.J=new d.$ee,this.onDidChangeActiveTerminal=this.J.event,this.L=new d.$ee,this.onDidChangeTerminalDimensions=this.L.event,this.M=new d.$ee,this.onDidChangeTerminalState=this.M.event,this.N=new d.$ee,this.onDidChangeShell=this.N.event,this.O=new d.$ee({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new d.$ee({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=S.getProxy(L.$3M.MainThreadTerminalService),this.y=new w.$Gvb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:C=>{const I=F=>{const j=F;return this.getTerminalById(j.instanceId)?.value};switch(C?.$mid){case 15:return I(C);default:{if(Array.isArray(C))for(let F=0;F<C.length&&C[F].$mid===15;F++)C[F]=I(C[F]);return C}}}}),this.B({dispose:()=>{for(const[C,I]of this.g)I.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,k){const S=new i(this.a,(0,y.$Sg)(),$,$.name),C=new u($.pty);return S.createExtensionTerminal($.location,k,this.R($,k).resolvedExtHostIdentifier,s($.iconPath),v($.color)).then(I=>{const F=this.S(I,C);this.h[I]=F}),this.f.push(S),S.value}R($,k){if(k=k||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const S=$.location.parentTerminal;if(S){const C=this.f.find(I=>I.value===S);C&&(k.resolvedExtHostIdentifier=C._id)}}else $.location&&typeof $.location!="object"?k.location=$.location:k.location&&typeof k.location=="object"&&"splitActiveTerminal"in k.location&&(k.location={splitActiveTerminal:!0});return k}attachPtyToTerminal($,k){if(!this.getTerminalById($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const C=new u(k),I=this.S($,C);this.h[$]=I}async $acceptActiveTerminalChanged($){const k=this.b;if($===null){this.b=void 0,k!==this.b&&this.J.fire(this.b);return}const S=this.getTerminalById($);S&&(this.b=S,k!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,k){const S=this.getTerminalById($);S&&this.O.fire({terminal:S.value,data:k})}async $acceptTerminalDimensions($,k,S){const C=this.getTerminalById($);C&&C.setDimensions(k,S)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand($,k){const S=this.getTerminalById($);S&&this.P.fire({terminal:S.value,...k})}async $acceptTerminalMaximumDimensions($,k,S){this.g.get($)?.resize(k,S)}async $acceptTerminalTitleChange($,k){const S=this.getTerminalById($);S&&(S.name=k)}async $acceptTerminalClosed($,k,S){const C=this.X(this.f,$);if(C!==null){const I=this.f.splice(C,1)[0];I.setExitStatus(k,S),this.H.fire(I.value)}}$acceptTerminalOpened($,k,S,C){if(k){const j=this.X(this.f,k);if(j!==null){this.f[j]._id=$,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const I={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:R.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},F=new i(this.a,$,I,S);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId($,k){this.getTerminalById($)?._setProcessId(k)}async $startExtensionTerminal($,k){const S=this.getTerminalById($);if(!S)return{message:(0,E.localize)(0,null,$)};S.isOpen||await new Promise(I=>{const F=this.onDidOpenTerminal(async j=>{j===S.value&&(F.dispose(),I())})});const C=this.g.get($);C?C.startSendingEvents(k):this.j[$]={initialDimensions:k}}S($,k){const S=new b.$Uc;S.add(k.onProcessReady(I=>this.a.$sendProcessReady($,I.pid,I.cwd,I.windowsPty))),S.add(k.onDidChangeProperty(I=>this.a.$sendProcessProperty($,I))),this.y.startBuffering($,k.onProcessData),S.add(k.onProcessExit(I=>this.U($,I))),this.g.set($,k);const C=this.j[$];return C&&k instanceof u&&(k.startSendingEvents(C.initialDimensions),delete this.j[$]),S}$acceptProcessAckDataEvent($,k){this.g.get($)?.acknowledgeDataEvent(k)}$acceptProcessInput($,k){this.g.get($)?.input(k)}$acceptTerminalInteraction($){const k=this.getTerminalById($);k?.setInteractedWith()&&this.M.fire(k.value)}$acceptTerminalSelection($,k){this.getTerminalById($)?.setSelection(k)}$acceptProcessResize($,k,S){try{this.g.get($)?.resize(k,S)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown($,k){this.g.get($)?.shutdown(k)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(k=>this.a.$sendProcessProperty($,{type:"initialCwd",value:k}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(k=>this.a.$sendProcessProperty($,{type:"cwd",value:k}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new m.$5M(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,k,S){if(this.C.has(k))throw new Error(`Terminal profile provider "${k}" already registered`);return this.C.set(k,S),this.a.$registerProfileProvider(k,$.identifier.value),new m.$5M(()=>{this.C.delete(k),this.a.$unregisterProfileProvider(k)})}registerTerminalQuickFixProvider($,k,S){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,S),this.a.$registerQuickFixProvider($,k),new m.$5M(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,k){const S=new p.$pe().token;if(S.isCancellationRequested)return;const C=this.D.get($);if(!C)return;const I=await C.provideTerminalQuickFixes(k,S);if(I===null||Array.isArray(I)&&I.length===0)return;const F=new b.$Uc;if(this.w.value=F,!Array.isArray(I))return I?a.TerminalQuickFix.from(I,this.Q.converter,F):void 0;const j=[];for(const z of I){const M=a.TerminalQuickFix.from(z,this.Q.converter,F);M&&j.push(M)}return j}async $createContributedProfileTerminal($,k){const S=new p.$pe().token;let C=await this.C.get($)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,k);return}this.createTerminalFromOptions(C.options,k)}}async $provideLinks($,k){const S=this.getTerminalById($);if(!S)return[];this.F.delete($),this.G.get($)?.dispose(!0);const I=new p.$pe;this.G.set($,I);const F=[],j={terminal:S.value,line:k},z=[];for(const U of this.z)z.push(f.Promises.withAsyncBody(async Z=>{I.token.onCancellationRequested(()=>Z({provider:U,links:[]}));const te=await U.provideTerminalLinks(j,I.token)||[];I.token.isCancellationRequested||Z({provider:U,links:te})}));const M=await Promise.all(z);if(I.token.isCancellationRequested)return[];const T=new Map;for(const U of M)U&&U.links.length>0&&F.push(...U.links.map(Z=>{const te={id:o++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return T.set(te.id,{provider:U.provider,link:Z}),te}));return this.F.set($,T),F}$activateLink($,k){const S=this.F.get($)?.get(k);S&&S.provider.handleTerminalLink(S.link)}U($,k){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const S=this.h[$];S&&(S.dispose(),delete this.h[$]),this.a.$sendProcessExit($,k)}getTerminalById($){return this.W(this.f,$)}getTerminalIdByApiObject($){const k=this.f.findIndex(S=>S.value===$);return k>=0?k:null}W($,k){const S=this.X($,k);return S!==null?$[S]:null}X($,k){const S=$.findIndex(C=>C._id===k);return S>=0?S:null}getEnvironmentVariableCollection($){let k=this.n.get($.identifier.value);return k||(k=new l,this.Z($.identifier.value,k)),k.getScopedEnvironmentVariableCollection(void 0)}Y($,k){const S=(0,P.$ls)(k.map),C=(0,P.$ms)(k.descriptionMap);this.a.$setEnvironmentVariableCollection($,k.persistent,S.length===0?void 0:S,C)}$initEnvironmentVariableCollections($){$.forEach(k=>{const S=k[0],C=new l(k[1]);this.Z(S,C)})}$acceptDefaultProfile($,k){const S=this.s;this.s=$,this.u=k,S?.path!==$.path&&this.N.fire($.path)}Z($,k){this.n.set($,k),k.onDidChangeCollection(()=>{this.Y($,k)})}};e.$Zlc=t,e.$Zlc=t=Ke([We(1,n.$MP),We(2,N.$qP)],t);class l{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new d.$ee,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const k=this.h($);let S=this.a.get(k);return S||(S=new r(this,$),this.a.set(k,S),S.onDidChangeCollection(()=>this.d.fire())),S}replace($,k,S,C){this.f($,{value:k,type:m.EnvironmentVariableMutatorType.Replace,options:S??{applyAtProcessCreation:!0},scope:C})}append($,k,S,C){this.f($,{value:k,type:m.EnvironmentVariableMutatorType.Append,options:S??{applyAtProcessCreation:!0},scope:C})}prepend($,k,S,C){this.f($,{value:k,type:m.EnvironmentVariableMutatorType.Prepend,options:S??{applyAtProcessCreation:!0},scope:C})}f($,k){if(k.options&&k.options.applyAtProcessCreation===!1&&!k.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const S=this.g($,k.scope),C=this.map.get(S),I=k.options?{applyAtProcessCreation:k.options.applyAtProcessCreation??!1,applyAtShellIntegration:k.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==k.value||C.type!==k.type||C.options?.applyAtProcessCreation!==I.applyAtProcessCreation||C.options?.applyAtShellIntegration!==I.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==k.scope?.workspaceFolder?.index){const F=this.g($,k.scope),j={variable:$,...k,options:I};this.map.set(F,j),this.d.fire()}}get($,k){const S=this.g($,k),C=this.map.get(S);return C?g(C):void 0}g($,k){const S=this.h(k);return S.length?`${$}:::${S}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const k=new Map;for(const[S,C]of this.map)this.h(C.scope)===this.h($)&&k.set(C.variable,g(C));return k}delete($,k){const S=this.g($,k);this.map.delete(S),this.d.fire()}clear($){if($?.workspaceFolder){for(const[k,S]of this.map)S.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(k);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,k){const S=this.h(k),C=this.descriptionMap.get(S);if(!C||C.description!==$){let I;typeof $=="string"?I=$:I=$?.value.split(`

`)[0];const F={description:I,scope:k};this.descriptionMap.set(S,F),this.d.fire()}}getDescription($){const k=this.h($);return this.descriptionMap.get(k)?.description}k($){const k=this.h($);this.descriptionMap.delete(k)}}class r{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,k){this.b=$,this.d=k,this.a=new d.$ee}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,k,S){this.b.replace($,k,S,this.d)}append($,k,S){this.b.append($,k,S,this.d)}prepend($,k,S){this.b.prepend($,k,S,this.d)}get($){return this.b.get($,this.d)}forEach($,k){this.b.getVariableMap(this.d).forEach((S,C)=>$.call(k,C,S,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends t{constructor($,k){super(!1,$,k)}createTerminal($,k,S){throw new A.$_}createTerminalFromOptions($,k){throw new A.$_}};e.$1lc=c,e.$1lc=c=Ke([We(0,n.$MP),We(1,N.$qP)],c);function s(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function v(D){return h.ThemeColor.isThemeColor(D)?D:void 0}function g(D){const $={...D};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(ke[156],Se([1,0,8,3,5,6,20,43,4,2,7]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=e.$5mc=void 0,e.$5mc=(0,O.$wi)("IExtHostTerminalShellIntegration");let P=class extends L.$Vc{constructor(f,a){super(),this.h=a,this.b=new Map,this.c=new m.$ee,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$ee,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$ee,this.onDidEndTerminalShellExecution=this.g.event,this.a=f.getProxy(R.$3M.MainThreadTerminalShellIntegration),this.B((0,L.$Tc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(f){const a=this.h.getTerminalById(f);if(!a)return;const n=a.value;let i=this.b.get(f);i||(i=new p(a.value,this.f),this.b.set(f,i),i.store.add(a.onWillDispose(()=>this.b.get(f)?.dispose())),i.store.add(i.onDidRequestShellExecution(u=>this.a.$executeCommand(f,u))),i.store.add(i.onDidRequestEndExecution(u=>this.g.fire(u))),i.store.add(i.onDidRequestChangeShellIntegration(u=>this.c.fire(u))),a.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(f,a,n,i,u){this.b.has(f)||this.$shellIntegrationChange(f);const o={value:a,confidence:n,isTrusted:i};this.b.get(f)?.startShellExecution(o,u)}$shellExecutionEnd(f,a,n,i,u){const o={value:a,confidence:n,isTrusted:i};this.b.get(f)?.endShellExecution(o,u)}$shellExecutionData(f,a){this.b.get(f)?.emitData(a)}$cwdChange(f,a){this.b.get(f)?.setCwd((0,E.$wc)(a)?E.URI.revive(a):a)}$closeTerminal(f){this.b.get(f)?.dispose(),this.b.delete(f)}};e.$6mc=P,e.$6mc=P=Ke([We(0,N.$qP),We(1,b.$Xlc)],P);class p extends L.$Vc{get currentExecution(){return this.a}constructor(f,a){super(),this.j=f,this.m=a,this.b=!1,this.store=this.B(new L.$Uc),this.f=this.B(new m.$ee),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$ee),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$ee),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,u){let o=i;u&&(o+=` "${u.map(r=>`${r.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(o);const t={value:o,confidence:d.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=n.startShellExecution(t,n.c,!0).value;return n.b=!0,l}}}startShellExecution(f,a,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new y(f,a);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(f){this.currentExecution?.emitData(f)}endShellExecution(f,a){this.a&&(this.a.endExecution(f),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(f){let a=!1;E.URI.isUri(this.c)?a=!E.URI.isUri(f)||this.c.toString()!==f.toString():this.c!==f&&(a=!0),a&&(this.c=f,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class y{constructor(f,a){this.c=f,this.cwd=a,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return A.$Wh.EMPTY;this.a=new w}return this.a.createIterable()}emitData(f){this.a?.emitData(f)}endExecution(f){f&&(this.c=f),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends L.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new A.$vh);const f=this.a;return new A.$Wh(async n=>{this.b.push(n),await f.wait()})}emitData(f){for(const a of this.b)a.emitOne(f)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[359],Se([1,0,7,21,22,4,75,57,3,18,30,11,6,20,155,16,8,69,113,89]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=e.$8mc=e.$7mc=void 0;let u=class extends m.$Vc{constructor(I,F,j,z){super(),this.w=z,this.f=this.B(new R.$ee),this.g=new Map,this.s=this.B(new R.$ee),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy(p.$3M.MainThreadTesting),this.m=new D(this.h),this.j=new r(this.h,F),j.registerArgumentProcessor({processArgument:M=>{switch(M?.$mid){case 16:{const T=M,U=T.tests[T.tests.length-1].item.extId;return this.g.get(a.$OL.root(U))?.collection.tree.get(U)?.actual??(0,w.$CP)(M)}case 18:{const{test:T,message:U}=M,Z=T.item.extId;return{test:this.g.get(a.$OL.root(Z))?.collection.tree.get(Z)?.actual??(0,w.$CP)({$mid:16,tests:[T]}),message:h.TestMessage.to(U)}}default:return M}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const M=await j.executeCommand("_testing.getExplorerSelection"),T=U=>{const Z=this.g.get(a.$OL.root(U));if(Z)return a.$OL.isRoot(U)?Z.controller:Z.collection.tree.get(U)?.actual};return{include:M?.include.map(T).filter(E.$eg)||[],exclude:M?.exclude.map(T).filter(E.$eg)||[]}})}createTestController(I,F,j,z){if(this.g.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const M=new m.$Uc,T=M.add(new w.$FP(F,j,this.w));T.root.label=j;const U=new Map,Z=new Set,te=this.h,q={items:T.root.children,get label(){return j},set label(Y){j=Y,T.root.label=Y,te.$updateController(F,{label:j})},get refreshHandler(){return z},set refreshHandler(Y){z=Y,te.$updateController(F,{canRefresh:!!Y})},get id(){return F},createRunProfile:(Y,ie,$e,ue,ve,_)=>{let B=(0,b.$kj)(Y);for(;U.has(B);)B++;return new k(this.h,U,Z,this.s.event,F,B,Y,ie,$e,ue,ve,_)},createTestItem(Y,ie,$e){return new w.$DP(F,Y,ie,$e)},createTestRun:(Y,ie,$e=!0)=>this.j.createTestRun(F,T,Y,ie,$e),invalidateTestResults:Y=>{if(Y===void 0)this.h.$markTestRetired(void 0);else{const ie=Y instanceof Array?Y:[Y];this.h.$markTestRetired(ie.map($e=>a.$OL.fromExtHostTestItem($e,F).toString()))}},set resolveHandler(Y){T.resolveHandler=Y},get resolveHandler(){return T.resolveHandler},dispose:()=>{M.dispose()}};te.$registerTestController(F,j,!!z),M.add((0,m.$Tc)(()=>te.$unregisterTestController(F)));const K={controller:q,collection:T,profiles:U,extension:I,activeProfiles:Z};return this.g.set(F,K),M.add((0,m.$Tc)(()=>this.g.delete(F))),M.add(T.onDidGenerateDiff(Y=>te.$publishDiff(F,Y.map(i.TestsDiffOp.serialize)))),q}createTestObserver(){return this.m.checkout()}async runTests(I,F=O.CancellationToken.None){const j=c(I);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(j.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:I.preserveFocus??!0,targets:[{testIds:I.include?.map(M=>a.$OL.fromExtHostTestItem(M,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:S[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:I.exclude?.map(M=>M.id)},F)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,F){return(await this.j.getCoverageDetails(I,F))?.map(h.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,F){this.g.get(I)?.profiles.get(F)?.configureHandler?.()}$setDefaultRunProfiles(I){const F=new Map;for(const[j,z]of Object.entries(I)){const M=this.g.get(j);if(!M)continue;const T=new Map,U=z.filter(te=>!M.activeProfiles.has(te)),Z=[...M.activeProfiles].filter(te=>!z.includes(te));for(const te of U)T.set(te,!0),M.activeProfiles.add(te);for(const te of Z)T.set(te,!1),M.activeProfiles.delete(te);T.size&&F.set(j,T)}this.s.fire(F)}async $refreshTests(I,F){await this.g.get(I)?.controller.refreshHandler?.(F)}$publishTestResults(I){this.results=Object.freeze(I.map(h.TestResults.to).concat(this.results).sort((F,j)=>j.completedAt-F.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,F){const j=this.g.get(a.$OL.fromString(I).controllerId)?.collection;j&&(await j.expand(I,F<0?1/0:F),j.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(F=>i.TestsDiffOp.deserialize({asCanonicalUri:j=>j},F)))}async $runControllerTests(I,F){return Promise.all(I.map(j=>this.y(j,!1,F)))}async $startContinuousRun(I,F){const j=new O.$pe(F),z=await Promise.all(I.map(M=>this.y(M,!0,j.token)));return!F.isCancellationRequested&&!z.some(M=>M.error)&&await new Promise(M=>F.onCancellationRequested(M)),j.dispose(!0),z}async y(I,F,j){const z=this.g.get(I.controllerId);if(!z)return{};const{collection:M,profiles:T}=z,U=T.get(I.profileId);if(!U)return{};const Z=I.testIds.map(Y=>M.tree.get(Y)).filter(E.$eg),te=I.excludeExtIds.map(Y=>z.collection.tree.get(Y)).filter(E.$eg).filter(Y=>Z.some(ie=>ie.fullId.compare(Y.fullId)===2));if(!Z.length)return{};const q=new f.$FO(Z.some(Y=>Y.actual instanceof w.$EP)?void 0:Z.map(Y=>Y.actual),te.map(Y=>Y.actual),U,F),K=(0,i.$RL)(I)&&this.j.prepareForMainThreadTestRun(q,s.fromInternal(I,z.collection),U,j);try{return await U.runHandler(q,j),{}}catch(Y){return{error:String(Y)}}finally{K&&K.hasRunningTasks&&!j.isCancellationRequested&&await R.Event.toPromise(K.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$7mc=u,e.$7mc=u=Ke([We(0,y.$qP),We(1,P.$3j)],u);const o=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class l extends m.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,F,j,z,M){super(),this.y=I,this.z=F,this.C=j,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$ee),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new O.$pe(M));const T=this.B(new d.$Ih(()=>this.F(),o));this.B(this.j.token.onCancellationRequested(()=>T.schedule()));const U=new R.$ee;this.s=U.event,this.B((0,m.$Tc)(()=>{U.fire(),U.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,F){const[,j,z]=a.$OL.fromString(I).path,M=this.w.get(z);if(!M)return[];const T=this.g.get(j);if(!T)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(T.run,M,F)??[]}createRun(I){const F=this.y.id,j=this.y.controllerId,z=(0,A.$Sg)(),M=te=>(q,...K)=>{if(U){this.C.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.y.isIncluded(q)&&(this.H(q),te(q,...K))},T=(te,q)=>{const K=q instanceof Array?q.map(h.TestMessage.from):[h.TestMessage.from(q)];if(te.uri&&te.range){const Y={range:h.Range.from(te.range),uri:te.uri};for(const ie of K)ie.location=ie.location||Y}this.z.$appendTestMessagesInRun(F,z,a.$OL.fromExtHostTestItem(te,j).toString(),K)};let U=!1;const Z={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:te=>{const q=te.uri.toString(),K=new a.$OL([F,z,q]).toString();this.w.set(q,te),this.z.$appendCoverage(F,z,h.TestCoverage.fromFile(K,te))},enqueued:M(te=>{this.z.$updateTestStateInRun(F,z,a.$OL.fromExtHostTestItem(te,j).toString(),1)}),skipped:M(te=>{this.z.$updateTestStateInRun(F,z,a.$OL.fromExtHostTestItem(te,j).toString(),5)}),started:M(te=>{this.z.$updateTestStateInRun(F,z,a.$OL.fromExtHostTestItem(te,j).toString(),2)}),errored:M((te,q,K)=>{T(te,q),this.z.$updateTestStateInRun(F,z,a.$OL.fromExtHostTestItem(te,j).toString(),6,K)}),failed:M((te,q,K)=>{T(te,q),this.z.$updateTestStateInRun(F,z,a.$OL.fromExtHostTestItem(te,j).toString(),4,K)}),passed:M((te,q)=>{this.z.$updateTestStateInRun(F,z,a.$OL.fromExtHostTestItem(te,this.y.controllerId).toString(),3,q)}),appendOutput:(te,q,K)=>{U||(K&&(this.y.isIncluded(K)?this.H(K):K=void 0),this.z.$appendOutputToRun(F,z,L.$Ge.fromString(te),q&&h.location.from(q),K&&a.$OL.fromExtHostTestItem(K,j).toString()))},end:()=>{U||(U=!0,this.z.$finishedTestRunTask(F,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:Z}),this.z.$startedTestRunTask(F,{id:z,name:I,running:!0}),Z}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof w.$DP))throw new n.$iP(I.id);if(this.h.has(a.$OL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const F=[],j=this.y.colllection.root;for(;;){const z=h.TestItem.from(I);if(F.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),I===j))break;I=I.parent||j}this.z.$addTestsToRun(this.y.controllerId,this.y.id,F)}dispose(){this.G(),super.dispose()}}class r{get trackers(){return this.c.values()}constructor(I,F){this.g=I,this.h=F,this.c=new Map,this.f=new Map}getCoverageDetails(I,F){const j=a.$OL.root(I);return this.f.get(j)?.getCoverageDetails(I,F)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[F,{id:j}]of this.c)j===I&&this.c.delete(F)}prepareForMainThreadTestRun(I,F,j,z){return this.j(I,F,j,z)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,F,j,z,M){const T=this.c.get(j);if(T)return T.createRun(z);const U=s.fromPublic(I,F,j,M),Z=c(j);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!j.continuous,profile:Z&&{group:S[Z.kind],id:Z.profileId},exclude:j.exclude?.map(q=>a.$OL.fromExtHostTestItem(q,F.root.id).toString())??[],id:U.id,include:j.include?.map(q=>a.$OL.fromExtHostTestItem(q,F.root.id).toString())??[F.root.id],preserveFocus:j.preserveFocus??!0,persist:M});const te=this.j(j,U,j.profile);return R.Event.once(te.onEnd)(()=>{this.g.$finishedExtensionTestRun(U.id)}),te.createRun(z)}j(I,F,j,z){const M=new l(F,this.g,this.h,j,z);return this.c.set(I,M),this.f.set(M.id,M),M}}e.$8mc=r;const c=C=>{if(C.profile){if(!(C.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class s{static fromPublic(I,F,j,z){return new s(I,(0,A.$Sg)(),j.include?.map(M=>a.$OL.fromExtHostTestItem(M,I).toString())??[I],j.exclude?.map(M=>a.$OL.fromExtHostTestItem(M,I).toString())??[],z,F)}static fromInternal(I,F){return new s(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,F)}constructor(I,F,j,z,M,T){this.controllerId=I,this.id=F,this.isPersisted=M,this.colllection=T,this.c=j.map(U=>U+"\0"),this.f=z.map(U=>U+"\0")}isIncluded(I){const F=a.$OL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const j of this.f)if(F===j||F.startsWith(j))return!1;for(const j of this.c)if(F===j||F.startsWith(j))return!0;return!1}}e.$9mc=s;class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,h.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const F=a.$OL.parentId(I.item.extId);if(F&&this.h.has(F.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:F,g:j}=this;return{get added(){return[...I].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...j].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class g extends i.$XL{constructor(){super(...arguments),this.s=new R.$ee,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,F){return{...I,revived:h.TestItem.toPlain(I.item),depth:F?F.depth+1:0,children:new Set}}v(){return new v(this.s)}}class D{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(F=>F.revived)},dispose:(0,N.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new g({asCanonicalUri:F=>F});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const $=(C,I,F,j)=>{F?Object.assign(F,j):I.$updateTestRunConfig(C.controllerId,C.profileId,j)};class k{#e;#t;#n;#i;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,$(this,this.#e,this.#i,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,$(this,this.#e,this.#i,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),$(this,this.#e,this.#i,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,$(this,this.#e,this.#i,{tag:I?h.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,$(this,this.#e,this.#i,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return R.Event.chain(this.#n,I=>I.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(E.$eg))}constructor(I,F,j,z,M,T,U,Z,te,q=!1,K=void 0,Y=!1){this.controllerId=M,this.profileId=T,this.f=U,this.kind=Z,this.runHandler=te,this._tag=K,this.g=Y,this.#e=I,this.#s=F,this.#t=j,this.#n=z,F.set(T,this);const ie=S[Z];if(typeof ie!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);q&&j.add(T),this.#i={profileId:T,controllerId:M,tag:K?h.TestTag.namespace(this.controllerId,K.id):null,label:U,group:ie,isDefault:q,hasConfigurationHandler:!1,supportsContinuousRun:Y},queueMicrotask(()=>{this.#i&&(this.#e.$publishTestRunProfile(this.#i),this.#i=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#i=void 0}}e.$0mc=k;const S={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(ke[157],Se([1,0,62,13,125,16,8]),function(le,e,d,L,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=e.$yP=e.$xP=void 0;class b{static{this.c=new O.$vP("TextEditorDecorationType")}constructor(p,y,w){const h=b.c.nextId();p.$registerTextEditorDecorationType(y.identifier,h,R.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:h,dispose(){p.$removeTextEditorDecorationType(h)}})}}e.$xP=b;class m{constructor(p,y){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,y){this.k();let w=null;if(p instanceof N.$6M)w=new N.$7M(p,p);else if(p instanceof N.$7M)w=p;else throw new Error("Unrecognized location");this.l(w,y,!1)}insert(p,y){this.k(),this.l(new N.$7M(p,p),y,!0)}delete(p){this.k();let y=null;if(p instanceof N.$7M)y=p;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(p,y,w){const h=this.c.validateRange(p);this.g.push({range:h,text:y,forceMoveMarkers:w})}setEndOfLine(p){if(this.k(),p!==N.EndOfLine.LF&&p!==N.EndOfLine.CRLF)throw(0,L.$7)("endOfLine");this.h=p}}class E{constructor(p,y,w,h){this.c=p,this.d=y,this._accept(w),this.e=h;const f=this;this.value={get tabSize(){return f.f},set tabSize(a){f.n(a)},get indentSize(){return f.g},set indentSize(a){f.p(a)},get insertSpaces(){return f.j},set insertSpaces(a){f.s(a)},get cursorStyle(){return f.k},set cursorStyle(a){f.t(a)},get lineNumbers(){return f.l},set lineNumbers(a){f.u(a)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const y=Math.floor(p);return y>0?y:null}if(typeof p=="string"){const y=parseInt(p,10);return isNaN(y)?null:y>0?y:null}return null}n(p){const y=this.m(p);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const y=Math.floor(p);return y>0?y:null}if(typeof p=="string"){const y=parseInt(p,10);return isNaN(y)?null:y>0?y:null}return null}p(p){const y=this.o(p);if(y!==null){if(typeof y=="number"){if(this.h===y)return;this.g=y,this.h=y}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const y=this.q(p);if(typeof y=="boolean"){if(this.j===y)return;this.j=y}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(p)})))}assign(p){const y={};let w=!1;if(typeof p.tabSize<"u"){const h=this.m(p.tabSize);h==="auto"?(w=!0,y.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,w=!0,y.tabSize=h)}if(typeof p.indentSize<"u"){const h=this.o(p.indentSize);h==="tabSize"?(w=!0,y.indentSize=h):typeof h=="number"&&this.h!==h&&(this.g=h,this.h=h,w=!0,y.indentSize=h)}if(typeof p.insertSpaces<"u"){const h=this.q(p.insertSpaces);h==="auto"?(w=!0,y.insertSpaces=h):this.j!==h&&(this.j=h,w=!0,y.insertSpaces=h)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,w=!0,y.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,w=!0,y.lineNumbers=R.TextEditorLineNumbersStyle.from(p.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,y))}v(p,y){y.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(w)})}}e.$yP=E;class A{constructor(p,y,w,h,f,a,n,i){this.id=p,this.j=y,this.k=w,this.g=!1,this.h=new Set,this.c=f,this.d=new E(this.j,this.id,a,w),this.e=n,this.f=i;const u=this;this.value=Object.freeze({get document(){return h.value},set document(o){throw new L.$9("document")},get selection(){return u.c&&u.c[0]},set selection(o){if(!(o instanceof N.$8M))throw(0,L.$7)("selection");u.c=[o],u.l()},get selections(){return u.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof N.$8M)))throw(0,L.$7)("selections");u.c=o,u.l()},get visibleRanges(){return u.e},set visibleRanges(o){throw new L.$9("visibleRanges")},get options(){return u.d.value},set options(o){u.g||u.d.assign(o)},get viewColumn(){return u.f},set viewColumn(o){throw new L.$9("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new m(h.value,t);return o(l),u.m(l)},insertSnippet(o,t,l={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=u.c.map(c=>R.Range.from(c));else if(t instanceof N.$6M){const{lineNumber:c,column:s}=R.Position.from(t);r=[{startLineNumber:c,startColumn:s,endLineNumber:c,endColumn:s}]}else if(t instanceof N.$7M)r=[R.Range.from(t)];else{r=[];for(const c of t)if(c instanceof N.$7M)r.push(R.Range.from(c));else{const{lineNumber:s,column:v}=R.Position.from(c);r.push({startLineNumber:s,startColumn:v,endLineNumber:s,endColumn:v})}}return y.$tryInsertSnippet(p,h.value.version,o.value,r,l)},setDecorations(o,t){const l=t.length===0;l&&!u.h.has(o.key)||(l?u.h.delete(o.key):u.h.add(o.key),u.n(()=>{if(R.$nP(t))return y.$trySetDecorations(p,o.key,R.$oP(t));{const r=new Array(4*t.length);for(let c=0,s=t.length;c<s;c++){const v=t[c];r[4*c]=v.start.line+1,r[4*c+1]=v.start.character+1,r[4*c+2]=v.end.line+1,r[4*c+3]=v.end.character+1}return y.$trySetDecorationsFast(p,o.key,r)}}))},revealRange(o,t){u.n(()=>y.$tryRevealRange(p,R.Range.from(o),t||N.TextEditorRevealType.Default))},show(o){y.$tryShowEditor(p,R.ViewColumn.from(o))},hide(){y.$tryHideEditor(p)}})}dispose(){(0,d.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,d.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,d.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,d.ok)(!this.g),this.f=p}_acceptSelections(p){(0,d.ok)(!this.g),this.c=p}async l(){const p=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const y=p.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const w=y.edits.map(f=>f.range);w.sort((f,a)=>f.end.line===a.end.line?f.end.character===a.end.character?f.start.line===a.start.line?f.start.character-a.start.character:f.start.line-a.start.line:f.end.character-a.end.character:f.end.line-a.end.line);for(let f=0,a=w.length-1;f<a;f++){const n=w[f].end;if(w[f+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=y.edits.map(f=>({range:R.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,h,{setEndOfLine:typeof y.setEndOfLine=="number"?R.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$zP=A}),define(ke[73],Se([1,0,62,4,3,2,5,6,153,20,157,16,11,27,15,39,46]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.$AP=void 0;class a{constructor(u){this.value=u,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(u,o){this.h=u,this.i=o,this.a=null,this.b=new Map,this.c=new y.$Bc,this.d=new L.$ee,this.e=new L.$ee,this.f=new L.$ee,this.g=new L.$ee,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const o=[],t=[],l=[];if(u.removedDocuments)for(const r of u.removedDocuments){const c=R.URI.revive(r),s=this.c.get(c);s?.unref()&&(this.c.delete(c),o.push(s.value))}if(u.addedDocuments)for(const r of u.addedDocuments){const c=R.URI.revive(r.uri);let s=this.c.get(c);if(s&&c.scheme!==w.Schemas.vscodeNotebookCell&&c.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);s||(s=new a(new m.$tP(this.h.getProxy(b.$3M.MainThreadDocuments),c,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty)),this.c.set(c,s),t.push(s.value)),s.ref()}if(u.removedEditors)for(const r of u.removedEditors){const c=this.b.get(r);this.b.delete(r),c&&l.push(c)}if(u.addedEditors)for(const r of u.addedEditors){const c=R.URI.revive(r.documentUri);d.ok(this.c.has(c),`document '${c}' does not exist`),d.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const s=this.c.get(c).value,v=new A.$zP(r.id,this.h.getProxy(b.$3M.MainThreadTextEditors),this.i,new f.$V(()=>s.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(g=>P.Range.to(g)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,v)}u.newActiveEditor!==void 0&&(d.ok(u.newActiveEditor===null||this.b.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this.a=u.newActiveEditor),(0,O.$Qc)(o),(0,O.$Qc)(l),u.removedDocuments&&this.e.fire(o),u.addedDocuments&&this.d.fire(t),(u.removedEditors||u.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),u.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(u){return this.c.get(u)?.value}allDocuments(){return h.Iterable.map(this.c.values(),u=>u.value)}getEditor(u){return this.b.get(u)}activeEditor(u){if(!this.a)return;const o=this.b.get(this.a);return u?o:o?.value}allEditors(){return[...this.b.values()]}};e.$AP=n,e.$AP=n=Ke([We(0,E.$qP),We(1,p.$3j)],n),e.$BP=(0,N.$wi)("IExtHostDocumentsAndEditors")}),define(ke[360],Se([1,0,19,4,6,157,16,8]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;class m{constructor(A,P){this.i=P,this.a=new L.$ee,this.b=new L.$ee,this.c=new L.$ee,this.d=new L.$ee,this.f=new L.$ee,this.g=new L.$ee,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(O.$3M.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const P=this.i.allEditors();return A?P:P.map(p=>p.value)}async showTextDocument(A,P,p){let y;typeof P=="number"?y={position:N.ViewColumn.from(P),preserveFocus:p}:typeof P=="object"?y={position:N.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?N.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:y={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(A.uri,y),h=w&&this.i.getEditor(w);if(h)return h.value;throw w?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,P){return new R.$xP(this.h,A,P).value}$acceptEditorPropertiesChanged(A,P){const p=this.i.getEditor(A);if(!p)throw new Error("unknown text editor");if(P.options&&p._acceptOptions(P.options),P.selections){const y=P.selections.selections.map(N.Selection.to);p._acceptSelections(y)}if(P.visibleRanges){const y=d.$Hb(P.visibleRanges.map(N.Range.to));p._acceptVisibleRanges(y)}if(P.options&&this.b.fire({textEditor:p.value,options:{...P.options,lineNumbers:N.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const y=b.TextEditorSelectionChangeKind.fromValue(P.selections.source),w=P.selections.selections.map(N.Selection.to);this.a.fire({textEditor:p.value,selections:w,kind:y})}if(P.visibleRanges){const y=d.$Hb(P.visibleRanges.map(N.Range.to));this.c.fire({textEditor:p.value,visibleRanges:y})}}$acceptEditorPositionData(A){for(const P in A){const p=this.i.getEditor(P);if(!p)throw new Error("Unknown text editor");const y=N.ViewColumn.to(A[P]);p.value.viewColumn!==y&&(p._acceptViewColumn(y),this.d.fire({textEditor:p.value,viewColumn:y}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$qlc=m}),define(ke[361],Se([1,0,2,5,6,3,8,16,25,18]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=void 0,e.$_mc=(0,L.$wi)("IExtHostTimeline");class A{constructor(y,w){this.b=new Map,this.c=new Map,this.a=y.getProxy(O.$3M.MainThreadTimeline),w.registerArgumentProcessor({processArgument:(h,f)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&m.$Rm.equals(f,this.b.get(h.source)?.extension)){const a=h.uri===void 0?void 0:d.URI.revive(h.uri);return this.c.get(h.source)?.get(P(a))?.get(h.handle)}else return;return h}})}async $getTimeline(y,w,h,f){return this.b.get(y)?.provider.provideTimeline(d.URI.revive(w),h,f)}registerTimelineProvider(y,w,h,f){const a=new R.$Uc,n=this.d(w.id,f,a).bind(this);let i;w.onDidChange&&(i=w.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:w.id}),this));const u=this.c;return this.f({...w,scheme:y,onDidChange:void 0,async provideTimeline(o,t,l){t?.resetCache&&(a.clear(),u.get(w.id)?.clear());const r=await w.provideTimeline(o,t,l);if(r==null)return;const c=n(o,t);return{...r,source:w.id,items:r.items.map(c)}},dispose(){for(const o of u.values())o.get(w.id)?.clear();i?.dispose(),a.dispose()}},h)}d(y,w,h){return(f,a)=>{let n;if(a?.cacheResults){let i=this.c.get(y);i===void 0&&(i=new Map,this.c.set(y,i));const u=P(f);n=i.get(u),n===void 0&&(n=new Map,i.set(u,n))}return i=>{const{iconPath:u,...o}=i,t=`${y}|${i.id??i.timestamp}`;n?.set(t,i);let l,r,c;i.iconPath&&(u instanceof N.$2N?c={id:u.id,color:u.color}:d.URI.isUri(u)?(l=u,r=u):{light:l,dark:r}=u);let s;return N.$uN.isMarkdownString(o.tooltip)?s=b.MarkdownString.from(o.tooltip):(0,E.$9f)(o.tooltip)?s=o.tooltip:N.$uN.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=b.MarkdownString.from(o.detail)):(0,E.$9f)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=o.detail),{...o,id:o.id??void 0,handle:t,source:y,command:i.command?w.toInternal(i.command,h):void 0,icon:l,iconDark:r,themeIcon:c,tooltip:s,accessibilityInformation:i.accessibilityInformation}}}}f(y,w){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:w}),(0,R.$Tc)(()=>{for(const f of this.c.values())f.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$anc=A;function P(p){return p?.toString()}}),define(ke[362],Se([1,0,233,23,2,4,3,294,7,8,18,19,16,81,22,189,26]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=void 0;function a(u,o){if((0,A.$9f)(u))return{label:u};if(u&&typeof u=="object"&&typeof u.label=="string"){let t;return Array.isArray(u.highlights)&&(t=u.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),t=t.length?t:void 0),{label:u.label,highlights:t}}}class n extends N.$Vc{constructor(o,t,l){super(),this.f=o,this.g=t,this.h=l,this.a=new Map,this.b=new h.$q$;function r(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>r(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(s=>r(s)?this.r(s):s):c})}registerTreeDataProvider(o,t,l){const r=this.createTreeView(o,{treeDataProvider:t},l);return{dispose:()=>r.dispose()}}createTreeView(o,t,l){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],s=!!t.dragAndDropController?.handleDrag,v=!!t.dragAndDropController?.handleDrop,g=this.m(o,t,l),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:c,hasHandleDrag:s,hasHandleDrop:v,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(o,D),k={get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,f.$IG)(l,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,f.$IG)(l,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(S){(0,y.$Vk)(S)&&(0,f.$IG)(l,"treeViewMarkdownMessage"),g.message=S},get title(){return g.title},set title(S){g.title=S},get description(){return g.description},set description(S){g.description=S},get badge(){return g.badge},set badge(S){S!==void 0&&E.ViewBadge.isViewBadge(S)?g.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(g.badge=void 0)},reveal:(S,C)=>g.reveal(S,C),dispose:async()=>{await $,this.a.delete(o),g.dispose()}};return this.B(k),k}$getChildren(o,t){const l=this.a.get(o);return l?l.getChildren(t):Promise.reject(new b.$WF(o))}async $handleDrop(o,t,l,r,c,s,v,g){const D=this.a.get(o);if(!D)return Promise.reject(new b.$WF(o));const $=p.DataTransfer.toDataTransfer(l,async k=>(await this.f.$resolveDropFileData(o,t,k)).buffer);return v===o&&g&&await this.j($,D,g,c,s),D.onDrop($,r,c)}async j(o,t,l,r,c){const s=this.b.removeDragOperationTransfer(c);if(s)(await s)?.forEach((v,g)=>{v&&o.set(g,v)});else if(c&&t.handleDrag){const v=t.handleDrag(l,o,r);this.b.addDragOperationTransfer(c,v),await v}return o}async $handleDrag(o,t,l,r){const c=this.a.get(o);if(!c)return Promise.reject(new b.$WF(o));const s=await this.j(new E.$XN,c,t,r,l);if(!(!s||r.isCancellationRequested))return p.DataTransfer.from(s)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new b.$WF(o);return t.hasResolve}$resolve(o,t,l){const r=this.a.get(o);if(!r)throw new b.$WF(o);return r.resolveTreeItem(t,l)}$setExpanded(o,t,l){const r=this.a.get(o);if(!r)throw new b.$WF(o);r.setExpanded(t,l)}$setSelectionAndFocus(o,t,l){const r=this.a.get(o);if(!r)throw new b.$WF(o);r.setSelectionAndFocus(t,l)}$setVisible(o,t){const l=this.a.get(o);if(!l){if(!t)return;throw new b.$WF(o)}l.setVisible(t)}$changeCheckboxState(o,t){const l=this.a.get(o);if(!l)throw new b.$WF(o);l.setCheckboxState(t)}m(o,t,l){const r=this.B(new i(o,t,this.f,this.g.converter,this.h,l));return this.a.set(o,r),r}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$bnc=n;class i extends N.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,A.$fg)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,l,r,c,s){if(super(),this.I=o,this.J=l,this.L=r,this.M=c,this.N=s,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$ee),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$ee),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$ee),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$ee),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$ee),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$ee),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$ee),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$pe,s.contributes&&s.contributes.views)for(const $ in s.contributes.views)for(const k of s.contributes.views[$])k.id===o&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let v,g;const D=R.Event.debounce(this.F.event,($,k)=>($||($={message:!1,elements:[]}),k.element!==!1&&(v||(v=new Promise(S=>g=S),this.G=this.G.then(()=>v)),Array.isArray(k.element)?$.elements.push(...k.element):$.elements.push(k.element)),k.message&&($.message=!0),$),200,!0);this.B(D(({message:$,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const S=g;return v=null,this.$(k).then(()=>S())})),$&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let l=this.X(o);return l||(l=await this.Y(t)),l?l.map(r=>r.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const l=(0,A.$fg)(t.select)?!0:t.select,r=(0,A.$fg)(t.focus)?!1:t.focus,c=(0,A.$fg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(s=>this.W(o,s[s.length-1]).then(v=>this.J.$reveal(this.I,{item:v.item,parentChain:s.map(g=>g.item)},{select:l,focus:r,expand:c})),s=>this.M.error(s)):this.J.$reveal(this.I,void 0,{select:l,focus:r,expand:c})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=p.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const l=this.getExtensionElement(o);l&&(t?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(o,t){const l=!(0,P.$ub)(this.s,o);this.s=o;const r=this.t!==t;this.t=t,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async l=>{const r=this.getExtensionElement(l.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:l.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);t.forEach(l=>{l.treeItem.checkboxState=l.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(l=>[l.extensionItem,l.newState])})}async handleDrag(o,t,l){const r=[];for(const c of o){const s=this.getExtensionElement(c);s&&r.push(s)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,l),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,l){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,m.$oh)(()=>this.g?.handleDrop?this.g.handleDrop(r,o,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const l=this.j.get(o);if(l){const r=this.m.get(l);if(r){const c=await this.f.resolveTreeItem(r.extensionItem,l,t)??r.extensionItem;return this.hb(c),r.item.tooltip=this.eb(c.tooltip),r.item.command=this.fb(r.disposableStore,c.command),r.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(l=>this.W(t,l[l.length-1]).then(r=>(l.push(r),l))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,m.$oh)(()=>this.f.getParent(o))}W(o,t){const l=this.m.get(o);return l?Promise.resolve(l):(0,m.$oh)(()=>this.f.getTreeItem(o)).then(r=>this.kb(o,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(r);if(c){const s=this.m.get(c);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const l=this.getExtensionElement(o);t=l?this.m.get(l):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new w.$pe(this.Z.token);try{const l=o?this.m.get(o):void 0,r=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const c=(0,P.$Hb)(r||[]),s=await Promise.all((0,P.$Hb)(c).map(g=>this.f.getTreeItem(g)));if(t.token.isCancellationRequested)return;const v=s.map((g,D)=>g?this.db(c[D],g,l):null);return(0,P.$Hb)(v)}finally{t.dispose()}}$(o){if(o.some(l=>!l))return this.Z.dispose(!0),this.Z=new w.$pe,this.tb(),this.J.$refresh(this.I);{const l=this.ab(o);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(o){const t=new Set,l=o.map(c=>this.m.get(c));for(const c of l)if(c&&!t.has(c.item.handle)){let s=c;for(;s&&s.parent&&l.findIndex(v=>s&&s.parent&&v&&v.item.handle===s.parent.item.handle)===-1;){const v=this.j.get(s.parent.item.handle);s=v?this.m.get(v):void 0}s&&!s.parent&&t.add(c.item.handle)}const r=[];return t.forEach(c=>{const s=this.j.get(c);if(s){const v=this.m.get(s);v&&(!v.parent||!t.has(v.parent.item.handle))&&r.push(c)}}),r}bb(o){const t={};return Promise.all(o.map(l=>this.cb(l).then(r=>{r&&(t[l]=r.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const l=this.m.get(t);if(l)return this.rb(t),(0,m.$oh)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const c=this.ib(t,r,l.parent);return this.pb(t,c,l,l.parent),l.dispose(),c}return null})}return Promise.resolve(null)}db(o,t,l){const r=this.ib(o,t,l);if(t.id&&this.j.has(r.item.handle))throw new Error((0,d.localize)(0,null,t.id));return this.ob(o,r),this.qb(r,l),r}eb(o){return E.$uN.isMarkdownString(o)?p.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,l,r;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,l=o.checkboxState.tooltip,r=o.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:r}}hb(o){if(!E.$SN.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,l){this.hb(t);const r=this.B(new N.$Uc),c=this.kb(o,t,l),s=this.lb(t);return{item:{handle:c,parentHandle:l?l.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(r,t.command),contextValue:t.contextValue,icon:s,iconDark:this.mb(t)||s,themeIcon:this.jb(t),collapsibleState:(0,A.$fg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:l,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(o){return o.iconPath instanceof E.$2N?o.iconPath:void 0}kb(o,{id:t,label:l,resourceUri:r},c,s){if(t)return`${i.b}/${t}`;const v=a(l,this.N),g=c?c.item.handle:i.a;let D=v?v.label:r?(0,L.$7g)(r):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const $=this.m.has(o)?this.m.get(o).item.handle:void 0,k=this.X(c)||[];let S,C=0;do{if(S=`${g}/${C}:${D}`,s||!this.j.has(S)||$===S)break;C++}while(C<=k.length);return S}lb(o){if(o.iconPath&&!(o.iconPath instanceof E.$2N))return typeof o.iconPath=="string"||O.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof E.$2N)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return O.URI.isUri(o)?o:O.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,l,r){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(o,t);const c=this.X(r)||[],s=c.filter(v=>v.item.handle===l.item.handle)[0];s&&c.splice(c.indexOf(s),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const l of t.children){const r=this.j.get(l.item.handle);r&&this.sb(r)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const l of t.children){const r=this.j.get(l.item.handle);r&&this.sb(r)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[363],Se([1,0,4,3,2,30,16,92,6,8]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;class A extends L.$Vc{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(w,h,f,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new d.$ee),this.onDidDispose=this.#d.event,this.#h=this.B(new d.$ee),this.onDidChangeViewState=this.#h.event,this.#e=w,this.#t=h,this.#i=f,this.#n=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#i.dispose(),super.dispose())}get webview(){return this.c(),this.#i}get viewType(){return this.c(),this.#n}get title(){return this.c(),this.#r}set title(w){this.c(),this.#r!==w&&(this.#r=w,this.#t.$setTitle(this.#e,w))}get iconPath(){return this.c(),this.#a}set iconPath(w){this.c(),this.#a!==w&&(this.#a=w,this.#t.$setIconPath(this.#e,O.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(w){this.#l||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(this.#u=w.active,this.#c=w.visible,this.#o=w.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(w,h){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof w>"u"?void 0:N.ViewColumn.from(w),preserveFocus:!!h})}c(){if(this.#l)throw new Error("Webview is disposed")}}class P extends L.$Vc{static c(){return(0,R.$Sg)()}constructor(w,h,f){super(),this.j=h,this.m=f,this.g=new Map,this.h=new Map,this.f=w.getProxy(m.$3M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(w=>w.dispose()),this.g.clear()}createWebviewPanel(w,h,f,a,n={}){const i=typeof a=="object"?a.viewColumn:a,u={viewColumn:N.ViewColumn.from(i),preserveFocus:typeof a=="object"&&!!a.preserveFocus},o=(0,b.$Flc)(w),t=P.c();this.f.$createWebviewPanel((0,b.$Hlc)(w),t,h,{title:f,panelOptions:p(n),webviewOptions:(0,b.$Ilc)(w,this.m,n),serializeBuffersForPostMessage:o},u);const l=this.j.createNewWebview(t,n,w);return this.createNewWebviewPanel(t,h,f,i,n,l,!0)}$onDidChangeWebviewPanelViewStates(w){const h=Object.keys(w);h.sort((f,a)=>{const n=w[f],i=w[a];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const f of h){const a=this.getWebviewPanel(f);if(!a)continue;const n=w[f];a._updateViewState({active:n.active,visible:n.visible,viewColumn:N.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(w){this.getWebviewPanel(w)?.dispose(),this.g.delete(w),this.j.deleteWebview(w)}registerWebviewPanelSerializer(w,h,f){if(this.h.has(h))throw new Error(`Serializer for '${h}' already registered`);return this.h.set(h,{serializer:f,extension:w}),this.f.$registerSerializer(h,{serializeBuffersForPostMessage:(0,b.$Flc)(w)}),new E.$5M(()=>{this.h.delete(h),this.f.$unregisterSerializer(h)})}async $deserializeWebviewPanel(w,h,f,a){const n=this.h.get(h);if(!n)throw new Error(`No serializer found for '${h}'`);const{serializer:i,extension:u}=n,o=this.j.createNewWebview(w,f.webviewOptions,u),t=this.createNewWebviewPanel(w,h,f.title,a,f.panelOptions,o,f.active);await i.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(w,h,f,a,n,i,u){const o=new A(w,this.f,i,{viewType:h,title:f,viewColumn:a,panelOptions:n,active:u});return this.g.set(w,o),o}getWebviewPanel(w){return this.g.get(w)}}e.$Jlc=P;function p(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(ke[364],Se([1,0,4,3,92,16,6,8]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=void 0;class m extends L.$Vc{#e;#t;#n;#i;#s;#r;#a;#o;#c;constructor(P,p,y,w,h,f){super(),this.#s=!1,this.#u=this.B(new d.$ee),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new d.$ee),this.onDidDispose=this.#l.event,this.#n=y,this.#a=w,this.#e=P,this.#t=p,this.#i=h,this.#r=f}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#i.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(P){this.a(),this.#a!==P&&(this.#a=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#o}set description(P){this.a(),this.#o!==P&&(this.#o=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#r}get webview(){return this.#i}get viewType(){return this.#n}_setVisible(P){P===this.#r||this.#s||(this.#r=P,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(P){this.a(),!(P?.value===this.#c?.value&&P?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(P,p){this.d=p,this.b=new Map,this.c=new Map,this.a=P.getProxy(N.$3M.MainThreadWebviewViews)}registerWebviewViewProvider(P,p,y,w){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:y,extension:P}),this.a.$registerWebviewViewProvider((0,O.$Hlc)(P),p,{retainContextWhenHidden:w?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,O.$Flc)(P)}),new b.$5M(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(P,p,y,w,h){const f=this.b.get(p);if(!f)throw new Error(`No view provider found for '${p}'`);const{provider:a,extension:n}=f,i=this.d.createNewWebview(P,{},n),u=new m(P,this.a,p,y,i,!0);this.c.set(P,u),await a.resolveWebviewView(u,{state:w},h)}async $onDidChangeWebviewViewVisibility(P,p){this.e(P)._setVisible(p)}async $disposeWebviewView(P){const p=this.e(P);this.c.delete(P),p.dispose(),this.d.deleteWebview(P)}e(P){const p=this.c.get(P);if(!p)throw new Error("No webview found");return p}}e.$enc=E}),define(ke[365],Se([1,0,70,15,11,265,33,12]),function(le,e,d,L,O,R,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=void 0;let m=class{constructor(P,p){P.addFileSystemProvider(L.Schemas.file,new E(p),{isCaseSensitive:b.$k})}};e.$Vnc=m,e.$Vnc=m=Ke([We(0,d.$Blc),We(1,O.$3j)],m);class E{constructor(P){this.b=P,this.a=new R.$_q(this.b)}async stat(P){const p=await this.a.stat(P);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===N.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,p,y){return this.a.writeFile(P,p,{...y,unlock:!1,atomic:!1})}delete(P,p){return this.a.delete(P,{...p,useTrash:!1,atomic:!1})}rename(P,p,y){return this.a.rename(P,p,y)}copy(P,p,y){return this.a.copy(P,p,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,p){throw new Error("Method not implemented.")}}}),define(ke[366],Se([1,0,17,64,30,34,3,6,2,20]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnc=void 0;let A=class extends N.$Vc{constructor(p,y){super();const w=p.getProxy(b.$3M.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async h=>{const f=m.URI.file((0,d.$kc)((0,L.tmpdir)(),(0,O.$Sg)()));return await w.$download(h,f),f})}};e.$Tnc=A,e.$Tnc=A=Ke([We(0,E.$qP),We(1,R.$MP)],A)}),define(ke[367],Se([1,0,53,17,2,93,3,15,7,32]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class A extends R.$Dlc{constructor(){super(...arguments),this.i=null}async g(t){const l=await super.g(t);if(l.scheme!==b.Schemas.file)return l;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${l.fsPath}.`),l;const r=l.fsPath;let c=0;do{let s;c===0?s=r:s=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${c}`:`${r}-${c}`,await P(s);const v=L.$kc(s,"vscode.lock"),g=await h(this.d,v,!1);if(g)return this.i=g,process.on("exit",()=>{g.dispose()}),O.URI.file(s);c++}while(c<10);return l}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$6nc=A;async function P(o){try{await E.Promises.stat(o);return}catch{}try{await E.Promises.mkdir(o,{recursive:!0})}catch{}}const p=1e3,y=10*60*1e3;class w extends N.$Vc{constructor(t,l){super(),this.b=t,this.c=l,this.a=this.B(new m.$Hh),this.a.cancelAndSet(async()=>{const r=await f(t,l);(!r||r.pid!==process.pid)&&(t.info(`Lock '${l}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(l,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${l}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{d.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const l={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(l),{flag:"w"})}catch(l){this.b.error(l)}}}async function h(o,t,l){try{const c={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){o.error(c)}const r=await f(o,t);return!r||r.pid!==process.pid?l?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new w(o,t))}async function f(o,t){let l;try{l=await E.Promises.readFile(t)}catch(r){return o.error(r),null}try{return JSON.parse(String(l))}catch(r){return o.error(r),null}}async function a(o,t){let l;try{l=await E.Promises.stat(t)}catch(r){return o.error(r),0}return l.mtime.getTime()}function n(o){try{return process.kill(o,0),!0}catch{return!1}}async function i(o,t){const l=await f(o,t);if(!l)return o.info(`Lock '${t}': Could not read pid of lock holder.`),u(o,t);if(l.willReleaseAt){let g=l.willReleaseAt-Date.now();if(g<5e3){for(g>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${g} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);g>0;){if(await(0,m.$xh)(Math.min(100,g)),await a(o,t)===0)return u(o,t);g=l.willReleaseAt-Date.now()}return u(o,t)}}if(!n(l.pid))return o.info(`Lock '${t}': The pid ${l.pid} appears to be gone.`),u(o,t);const r=await a(o,t),c=Date.now()-r;if(c<=y)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,m.$xh)(2e3);const s=await a(o,t),v=Date.now()-s;return v<=y?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${v} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),u(o,t))}async function u(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return h(o,t,!0)}}),define(ke[368],Se([1,0,30,20,43,34]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=void 0;let N=class extends O.$Zlc{constructor(m,E){super(!0,m,E)}createTerminal(m,E,A){return this.createTerminalFromOptions({name:m,shellPath:E,shellArgs:A})}createTerminalFromOptions(m,E){const A=new O.$Ylc(this.a,(0,d.$Sg)(),m,m.name);return this.f.push(A),A.create(m,this.R(m,E)),A.value}};e.$onc=N,e.$onc=N=Ke([We(0,R.$MP),We(1,L.$qP)],N)}),define(ke[369],Se([1,0,4,36,38,5]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=e.OutputChannelUpdateMode=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=void 0,e.$$L="text/x-code-output",e.$_L="output",e.$aM="Log",e.$bM="text/x-code-log-output",e.$cM="log",e.$dM="workbench.panel.output",e.$eM=new O.$Nj("inOutput",!1),e.$fM=new O.$Nj("activeLogOutput",!1),e.$gM=new O.$Nj("activeLogOutput.levelSettable",!1),e.$hM=new O.$Nj("activeLogOutput.level",""),e.$iM=new O.$Nj("activeLogOutput.levelIsDefault",!1),e.$jM=new O.$Nj("outputView.scrollLock",!1),e.$kM=(0,R.$wi)("outputService");var N;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(N||(e.OutputChannelUpdateMode=N={})),e.$lM={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new d.$ee,this.onDidRegisterChannel=this.b.event,this.c=new d.$ee,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(A=>E.push(A)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}L.$co.add(e.$lM.OutputChannels,new b),e.$mM=new O.$Nj("activeOutputChannel","")}),define(ke[158],Se([1,0,6,5,20,25,11,369,70,28,60,194,21,18,33,4,3]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=void 0;class a extends N.$9j{get disposed(){return this.n}constructor(o,t,l,r,c){super(),this.id=o,this.name=t,this.r=l,this.s=r,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=p.$Ge.fromString(t).byteLength,(0,N.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends a{appendLine(o){this.append(o)}}let i=class{constructor(o,t,l,r,c,s){this.i=t,this.j=l,this.k=r,this.l=c,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(d.$3M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,l]of this.g)l.visible=t===this.h}createOutputChannel(o,t,l){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,c=(0,y.$9f)(t)?t:void 0;if((0,y.$9f)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const v=this.i.environment.extensionLogLevel?.find(([D])=>R.$Rm.equals(l.identifier,D))?.[1];v&&(s=(0,N.$hk)(v));const g=r?this.o(o,s,l):this.n(o,c,l);return g.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),r?this.r(o,s??this.m.getLevel(),g):this.q(o,g)}async n(o,t,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,c=this.k.extUri.joinPath(r,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),v=await this.a.$register(o,c,t,l.identifier.value);return new a(v,o,s,this.a,l)}async o(o,t,l){const r=await this.p(l),c=o.replace(/[\\/:\*\?"<>\|]/g,""),s=this.k.extUri.joinPath(r,`${c}.log`),v=`${l.identifier.value}.${c}`,g=this.l.createLogger(s,{id:v,name:o,logLevel:t,extensionId:l.identifier.value});return new n(v,o,g,this.a,l)}p(o){let t=this.d.get(o.identifier.value);if(!t){const l=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(l)}catch(r){if((0,w.$gl)(r)!==w.FileSystemProviderErrorCode.FileExists)throw r}return l})())}return t}q(o,t){let l=!1;const r=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return o},append(c){r(),t.then(s=>s.append(c))},appendLine(c){r(),t.then(s=>s.appendLine(c))},clear(){r(),t.then(c=>c.clear())},replace(c){r(),t.then(s=>s.replace(c))},show(c,s){r(),t.then(v=>v.show(c,s))},hide(){r(),t.then(c=>c.hide())},dispose(){l=!0,t.then(c=>c.dispose())}}}r(o,t,l){const r=new f.$Uc,c=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},s=r.add(new h.$ee);function v(g){t=g,s.fire(g)}return l.then(g=>{r.add(g),g.logLevel!==t&&v(g.logLevel),r.add(g.onDidChangeLogLevel(D=>v(D)))}),{...this.q(o,l),get logLevel(){return t},onDidChangeLogLevel:s.event,trace(g,...D){c(),l.then($=>$.trace(g,...D))},debug(g,...D){c(),l.then($=>$.debug(g,...D))},info(g,...D){c(),l.then($=>$.info(g,...D))},warn(g,...D){c(),l.then($=>$.warn(g,...D))},error(g,...D){c(),l.then($=>$.error(g,...D))},dispose(){r.dispose()}}}};e.$Pmc=i,e.$Pmc=i=Ke([We(0,O.$qP),We(1,E.$GP),We(2,m.$Blc),We(3,A.$elc),We(4,N.$4j),We(5,N.$3j)],i),e.$Qmc=(0,L.$wi)("IExtHostOutputService")}),define(ke[159],Se([1,0,5,7]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=void 0,e.$gn=(0,d.$wi)("remoteAgentService"),e.$hn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(O){let R=1/0;for(let b=0;b<this.maxSampleCount;b++){const m=await O.getRoundTripTime();if(m===void 0)return;R=Math.min(R,m/2),await(0,L.$xh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let N;return this.initial.length<this.maxInitialCount?this.initial.push(R):N=this.initial.reduce((b,m)=>b+m,0)/this.initial.length,this.lastMeasurement={initial:N,current:R,average:this.average.reduce((b,m)=>b+m,0)/this.average.length,high:typeof N>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>N*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[370],Se([1,0,237,66,36,42,55,3,4,159,12,24,7]),function(le,e,d,L,O,R,N,b,m,E,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=void 0,e.$DJ=Object.freeze({id:"application",order:100,title:(0,d.localize)(0,null),type:"object"}),e.$EJ=Object.freeze({id:"workbench",order:7,title:(0,d.localize)(1,null),type:"object"}),e.$FJ=Object.freeze({id:"security",scope:1,title:(0,d.localize)(2,null),type:"object",order:7}),e.$GJ=Object.freeze({id:"problems",title:(0,d.localize)(3,null),type:"object",order:101}),e.$HJ={ConfigurationMigration:"base.contributions.configuration.migration"};class y{constructor(){this.migrations=[],this.a=new m.$ee,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const w=new y;O.$co.add(e.$HJ.ConfigurationMigration,w);let h=class extends b.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async u=>{for(const o of u.added)await this.f(o,w.migrations)})),this.c(w.migrations),this.B(w.onDidRegisterConfigurationMigration(u=>this.c(u)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(u=>this.g(u,n?.uri))])}async g(n,i){const u=this.a.inspect(n.key,{resource:i}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,l]of o){const r=u[t];if(!r)continue;const c=[];if(r.value!==void 0){const s=await this.h(n,t,r.value,i,void 0);for(const v of s??[])c.push([v,[]])}for(const{identifiers:s,value:v}of r.overrides??[])if(v!==void 0){const g=await this.h(n,t,v,i,s);for(const D of g??[])c.push([D,s])}c.length&&await Promise.allSettled(c.map(async([[s,v],g])=>this.a.updateValue(s,v.value,{resource:i,overrideIdentifiers:g},l)))}}async h(n,i,u,o,t){const l=c=>{const v=this.a.inspect(c,{resource:o})[i];if(v)return t?v.overrides?.find(({identifiers:g})=>(0,P.$7n)(g,t))?.value:v.value},r=await n.migrateFn(u,l);return Array.isArray(r)?r:[[n.key,r]]}};e.$IJ=h,e.$IJ=h=Ke([We(0,N.$3i),We(1,R.$Fi)],h);let f=class extends b.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new p.$Th,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;O.$co.as(L.$ho.Configuration).registerConfiguration({...e.$FJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,d.localize)(4,null)},default:[],markdownDescription:(0,d.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,d.localize)(6,null),scope:2}}})}};e.$JJ=f,e.$JJ=f=Ke([We(0,E.$gn)],f)}),define(ke[371],Se([1,0,35,15,17,23,247,370,66,5,36]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$chb=e.$bhb=void 0,e.$dhb=h,e.$ehb=f,e.$bhb=(0,E.$wi)("editorResolverService"),e.$chb="workbench.editorAssociations";const P=A.$co.as(m.$ho.Configuration),p={...b.$EJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,N.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration(p);var y;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(y||(e.RegisteredEditorPriority=y={}));var w;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function h(a){switch(a){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}function f(a,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const o=typeof a=="string"&&a.indexOf(O.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$7g)(n);return d.$pk(typeof a=="string"?a.toLowerCase():a,o.toLowerCase())}}),define(ke[372],Se([1,0,31,15,17,12,23,2,5,284,42,148,159]),function(le,e,d,L,O,R,N,b,m,E,A,P,p){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0,e.$EM=(0,m.$wi)("pathService");let w=y=class{constructor(f,a,n,i){this.d=f,this.e=a,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const u=await this.e.getEnvironment();return this.c=u?.userHome??f})()}hasValidBasename(f,a,n){return typeof a=="string"||typeof a>"u"?this.a.then(i=>this.h(f,i,a)):this.h(f,a,n)}h(f,a,n){return f.scheme===L.Schemas.file||f.scheme===L.Schemas.vscodeRemote?(0,d.$tg)(n??(0,N.$7g)(f),a===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,a){if(f.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,E.$BM)(a.getWorkspace());if(n)return n;const i=a.getWorkspace().folders[0];if(i)return i.uri.scheme;const u=a.getWorkspace().configuration;return u?u.scheme:L.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?O.$gc:O.$hc)}async fileURI(f){let a="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const i=f.indexOf("/",2);i===-1?(a=f.substring(2),f="/"):(a=f.substring(2,i),f=f.substring(i)||"/")}return b.URI.from({scheme:L.Schemas.file,authority:a,path:f,query:"",fragment:""})}};e.$FM=w,e.$FM=w=y=Ke([We(1,p.$gn),We(2,P.$nM),We(3,A.$Fi)],w)}),define(ke[373],Se([1,0,249,19,56,4,57,3,2,55,254,11,67,142,88,42,148,26,22,18,24,38]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.OnPortForward=e.$sM=e.$rM=e.TunnelSource=e.TunnelCloseReason=e.$pM=e.$oM=void 0,e.$qM=s,e.$tM=D,e.$uM=$,e.$vM=k,e.$wM=C;const t=10*1e3,l="remote.tunnels.toRestore",r="remote.tunnels.toRestoreExpiration",c=1e3*60*60*24*14;e.$oM="onTunnel",e.$pM=new o.$Nj("forwardedPortsViewEnabled",!1,d.localize(0,null));function s(j){const z=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}var v;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(v||(e.TunnelCloseReason=v={}));var g;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$rM={source:g.User,description:d.localize(1,null)},e.$sM={source:g.Auto,description:d.localize(2,null)};function D(j,z,M){const T=j.get(k(z,M));if(T)return T;if((0,w.$iw)(z))for(const U of w.$hw){const Z=k(U,M);if(j.has(Z))return j.get(Z)}else if((0,w.$kw)(z))for(const U of w.$jw){const Z=k(U,M);if(j.has(Z))return j.get(Z)}}function $(j,z,M){const T=D(j,z,M);if(T)return T;const U=(0,w.$kw)(z)?"localhost":(0,w.$iw)(z)?"0.0.0.0":void 0;if(U)return D(j,U,M)}function k(j,z){return j+":"+z}var S;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(S||(e.OnPortForward=S={}));function C(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}class I extends b.$Vc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new R.$ee,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(M=>{(M.affectsConfiguration(I.c)||M.affectsConfiguration(I.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,M,T){let U=this.w(z,M,T,this.j,0);const Z={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;U>=0;){const te=this.j[U];te.key===z?(Z.onAutoForward=te.onAutoForward??Z.onAutoForward,Z.elevateIfNeeded=te.elevateIfNeeded!==void 0?te.elevateIfNeeded:Z.elevateIfNeeded,Z.label=te.label??Z.label,Z.requireLocalPort=te.requireLocalPort,Z.protocol=te.protocol):(Z.onAutoForward=Z.onAutoForward??te.onAutoForward,Z.elevateIfNeeded=Z.elevateIfNeeded!==void 0?Z.elevateIfNeeded:te.elevateIfNeeded,Z.label=Z.label??te.label,Z.requireLocalPort=Z.requireLocalPort!==void 0?Z.requireLocalPort:void 0,Z.protocol=Z.protocol??te.protocol),U=this.w(z,M,T,this.j,U+1)}return Z.onAutoForward!==void 0||Z.elevateIfNeeded!==void 0||Z.label!==void 0||Z.requireLocalPort!==void 0||Z.protocol!==void 0?Z:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,i.$9f)(z.host)&&(0,i.$ag)(z.port)}w(z,M,T,U,Z){if(Z>=U.length)return-1;const te=!(0,w.$iw)(M)&&!(0,w.$kw)(M),K=U.slice(Z).findIndex(Y=>(0,i.$ag)(Y.key)?te?!1:Y.key===z:this.t(Y.key)?te?!1:z>=Y.key.start&&z<=Y.key.end:this.u(Y.key)?z===Y.key.port&&M===Y.key.host:T?Y.key.test(T):!1);return K>=0?K+Z:-1}y(){const z=this.r.getValue(I.c);if(!z||!(0,i.$$f)(z))return[];const M=[];for(const U in z){if(U===void 0)continue;const Z=z[U];let te;if(Number(U))te=Number(U);else if((0,i.$9f)(U))if(I.g.test(U)){const q=U.match(I.g);te={start:Number(q[1]),end:Number(q[2])}}else if(I.h.test(U)){const q=U.match(I.h);te={host:q[1],port:Number(q[2])}}else{let q;try{q=RegExp(U)}catch{}q&&(te=q)}te&&M.push({key:te,elevateIfNeeded:Z.elevateIfNeeded,onAutoForward:Z.onAutoForward,label:Z.label,requireLocalPort:Z.requireLocalPort,protocol:Z.protocol})}const T=this.r.getValue(I.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(M)}z(z){function M(T,U){return(0,i.$ag)(T.key)?T.key:U.t(T.key)?T.key.start:U.u(T.key)?T.key.port:Number.MAX_VALUE}return z.sort((T,U)=>M(T,this)-M(U,this))}C(){return this.m}static providedActionToAction(z){switch(z){case w.ProvidedOnAutoForward.Notify:return S.Notify;case w.ProvidedOnAutoForward.OpenBrowser:return S.OpenBrowser;case w.ProvidedOnAutoForward.OpenBrowserOnce:return S.OpenBrowserOnce;case w.ProvidedOnAutoForward.OpenPreview:return S.OpenPreview;case w.ProvidedOnAutoForward.Silent:return S.Silent;case w.ProvidedOnAutoForward.Ignore:return S.Ignore;default:return}}async addAttributes(z,M,T){const Z=this.r.inspect(I.c).userRemoteValue;let te;!Z||!(0,i.$$f)(Z)?te={}:te=(0,u.$3n)(Z),te[`${z}`]||(te[`${z}`]={});for(const q in M)te[`${z}`][q]=M[q];return this.r.updateValue(I.c,te,T)}}e.$xM=I;let F=class extends b.$Vc{constructor(z,M,T,U,Z,te,q,K,Y,ie){super(),this.H=z,this.I=M,this.J=T,this.L=U,this.M=Z,this.N=te,this.O=q,this.P=K,this.Q=Y,this.R=ie,this.c=new Map,this.g=new R.$ee,this.onForwardPort=this.g.event,this.h=new R.$ee,this.onClosePort=this.h.event,this.j=new R.$ee,this.onPortName=this.j.event,this.n=new R.$ee,this.onCandidatesChanged=this.n.event,this.t=new R.$ee,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$ee,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new I(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async $e=>{const ue=await this.getAttributes($e.map(ve=>({port:ve.tunnelRemotePort,host:ve.tunnelRemoteHost})));for(const ve of $e)if(ve.localAddress){const _=k(ve.tunnelRemoteHost,ve.tunnelRemotePort),B=$(this.m??new Map,ve.tunnelRemoteHost,ve.tunnelRemotePort);this.forwarded.set(_,{remotePort:ve.tunnelRemotePort,remoteHost:ve.tunnelRemoteHost,localAddress:ve.localAddress,protocol:ue?.get(ve.tunnelRemotePort)?.protocol??w.TunnelProtocol.Http,localUri:await this.X(ve.localAddress,ue?.get(ve.tunnelRemotePort)),localPort:ve.tunnelLocalPort,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:ve.privacy,source:e.$rM}),this.f.set(_,ve)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async $e=>{const ue=k($e.tunnelRemoteHost,$e.tunnelRemotePort);if(!$(this.forwarded,$e.tunnelRemoteHost,$e.tunnelRemotePort)&&!$(this.detected,$e.tunnelRemoteHost,$e.tunnelRemotePort)&&!$(this.c,$e.tunnelRemoteHost,$e.tunnelRemotePort)&&$e.localAddress){const ve=$(this.m??new Map,$e.tunnelRemoteHost,$e.tunnelRemotePort),_=(await this.getAttributes([{port:$e.tunnelRemotePort,host:$e.tunnelRemoteHost}]))?.get($e.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:$e.tunnelRemoteHost,remotePort:$e.tunnelRemotePort,localAddress:$e.localAddress,protocol:_?.protocol??w.TunnelProtocol.Http,localUri:await this.X($e.localAddress,_),localPort:$e.tunnelLocalPort,closeable:!0,runningProcess:ve?.detail,hasRunningProcess:!!ve,pid:ve?.pid,privacy:$e.privacy,source:e.$rM})}await this.cb(),this.f.set(ue,$e),this.g.fire(this.forwarded.get(ue))})),this.B(this.H.onTunnelClosed($e=>this.W($e,v.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$oM))?(this.R.createKey(e.$pM.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,M){const T=k(z.host,z.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(z))}X(z,M){if(z.startsWith("http"))return m.URI.parse(z);const T=M?.protocol??"http";return m.URI.parse(`${T}://${z}`)}async Y(z){const M=this.N.getWorkspace(),T=M.configuration?(0,N.$kj)(M.configuration.path):M.folders.length>0?(0,N.$kj)(M.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${z}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(l)}async $(){return this.Y(r)}async ab(){const z=this.I.get(l,1);if(z)return this.I.remove(l,1),await this.cb(),z;const M=await this.Z();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const M=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(T=>T.remotePort).join(", ")}`);for(const T of M){const U=$(this.detected,T.remoteHost,T.remotePort);T.source.source!==g.Extension&&!U||T.source.source===g.Extension&&U?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===g.Extension&&!U&&this.D.set(k(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Z();this.w=this.B(new b.$Uc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}bb(){const z=this.I.keys(0,0).filter(M=>M.startsWith(r));for(const M of z){const T=this.I.getNumber(M,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const U=M.replace(r,l);this.I.remove(M,0),this.I.remove(U,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=Array.from(this.forwarded.values()),M=z.map(te=>({remoteHost:te.remoteHost,remotePort:te.remotePort,localPort:te.localPort,name:te.name,localAddress:te.localAddress,localUri:te.localUri,protocol:te.protocol,source:te.source}));let T;z.length>0&&(T=JSON.stringify(M));const U=await this.Z(),Z=await this.$();!T&&U&&Z?(this.I.remove(U,0),this.I.remove(Z,0)):T!==this.y&&U&&Z&&(this.I.store(U,T,0,0),this.I.store(Z,Date.now()+c,0,0)),this.y=T}}async eb(z,M,T){if(!z.tunnelLocalPort||!T?.requireLocalPort||z.tunnelLocalPort===M)return;const U=new Date;if(this.db.getTime()+t>U.getTime())return;this.db=U;const Z=d.localize(3,null,M,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(Z)}async forward(z,M){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.fb(z,M)}async fb(z,M){await this.Q.activateByEvent(e.$oM);const T=$(this.forwarded,z.remote.host,z.remote.port);M=M??(M!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const U=z.local!==void 0?z.local:z.remote.port;let Z;if(T)return this.hb(T,z,M);{const te=this.L.remoteAuthority,q=te?{getAddress:async()=>(await this.M.resolveAuthority(te)).authority}:void 0,K=k(z.remote.host,z.remote.port);this.c.set(K,!0),z=this.gb(K,z);const Y=await this.H.openTunnel(q,z.remote.host,z.remote.port,void 0,U,z.elevateIfNeeded?z.elevateIfNeeded:M?.elevateIfNeeded,z.privacy,M?.protocol);if(typeof Y=="string")Z=Y;else if(Y&&Y.localAddress){const ie=$(this.m??new Map,z.remote.host,z.remote.port),$e=Y.protocol?Y.protocol===w.TunnelProtocol.Https?w.TunnelProtocol.Https:w.TunnelProtocol.Http:M?.protocol??w.TunnelProtocol.Http,ue={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:M?.label??z.name,closeable:!0,localAddress:Y.localAddress,protocol:$e,localUri:await this.X(Y.localAddress,M),runningProcess:ie?.detail,hasRunningProcess:!!ie,pid:ie?.pid,source:z.source??e.$rM,privacy:Y.privacy};return this.forwarded.set(K,ue),this.f.set(K,Y),this.c.delete(K),await this.cb(),await this.eb(Y,U,M),this.g.fire(ue),Y}this.c.delete(K)}return Z}gb(z,M){const T=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(T){const U=T.get(z);T.delete(z),U&&(M.name=U.name??M.name,M.local=("local"in U?U.local:"localPort"in U?U.localPort:void 0)??M.local,M.privacy=M.privacy)}return M}async hb(z,M,T){const U=T?.label??M.name;let Z;(function(q){q[q.None=0]="None",q[q.Fire=1]="Fire",q[q.Reopen=2]="Reopen"})(Z||(Z={}));let te=Z.None;switch(U!==z.name&&(z.name=U,te=Z.Fire),(T?.protocol||z.protocol!==w.TunnelProtocol.Http)&&T?.protocol!==z.protocol&&(M.source=z.source,te=Z.Reopen),M.privacy&&z.privacy!==M.privacy&&(te=Z.Reopen),te){case Z.Fire:{this.g.fire();break}case Z.Reopen:await this.close(z.remoteHost,z.remotePort,v.User),await this.fb(M,T)}return $(this.f,M.remote.host,M.remote.port)}async name(z,M,T){const U=$(this.forwarded,z,M),Z=k(z,M);if(U){U.name=T,await this.cb(),this.j.fire({host:z,port:M});return}else this.detected.has(Z)&&(this.detected.get(Z).name=T,this.j.fire({host:z,port:M}))}async close(z,M,T){const U=k(z,M),Z=this.forwarded.get(U);return T===v.AutoForwardEnd&&Z&&Z.source.source===g.Auto&&this.F.set(U,{local:Z.localPort,name:Z.name,privacy:Z.privacy}),await this.H.closeTunnel(z,M),this.W({host:z,port:M},T)}address(z,M){const T=k(z,M);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const M of z){const T=$(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),U=typeof M.localAddress=="string"?M.localAddress:k(M.localAddress.host,M.localAddress.port);this.detected.set(k(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:U,protocol:w.TunnelProtocol.Http,localUri:this.X(U),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:w.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:d.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,U,w.TunnelPrivacyId.ConstantPrivate,w.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let M=z;this.r&&(M=await this.r(z));const T=this.ib(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(U=>U.port).join(", ")}`),this.n.fire(T)}ib(z){const M=this.m??new Map,T=new Map;return this.m=T,z.forEach(U=>{const Z=k(U.host,U.port);T.set(Z,{host:U.host,port:U.port,detail:U.detail,pid:U.pid}),M.has(Z)&&M.delete(Z);const te=$(this.forwarded,U.host,U.port);te&&(te.runningProcess=U.detail,te.hasRunningProcess=!0,te.pid=U.pid)}),M.forEach((U,Z)=>{const te=s(Z);if(!te)return;const q=$(this.forwarded,te.host,te.port);q&&(q.runningProcess=void 0,q.hasRunningProcess=!1,q.pid=void 0);const K=$(this.detected,te.host,te.port);K&&(K.runningProcess=void 0,K.hasRunningProcess=!1,K.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const z=Array.from(this.forwarded.values()),M=await this.getAttributes(z.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(M)for(const T of z){const U=M.get(T.remotePort);(U?.protocol||T.protocol!==w.TunnelProtocol.Http)&&U?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},U),U&&U.label&&U.label!==T.name&&await this.name(T.remoteHost,T.remotePort,U.label)}}async getAttributes(z,M=!0){const T=new Map,U=new Map;z.forEach(Y=>{const ie=$(this.m??new Map,w.$hw[0],Y.port)??Y;if(ie){T.set(Y.port,ie);const $e=C(ie)?ie.pid:void 0;U.has($e)||U.set($e,[]),U.get($e)?.push(Y.port)}});const Z=new Map;if(z.forEach(Y=>{const ie=this.configPortsAttributes.getAttributes(Y.port,Y.host,T.get(Y.port)?.detail);ie&&Z.set(Y.port,ie)}),this.G.length===0||!M)return Z.size>0?Z:void 0;const te=await Promise.all((0,L.$Rb)(this.G.map(Y=>Array.from(U.entries()).map(ie=>{const $e=ie[1],ue=T.get($e[0]);return Y.providePortAttributes($e,ue?.pid,ue?.detail,n.CancellationToken.None)})))),q=new Map;if(te.forEach(Y=>Y.forEach(ie=>{ie&&q.set(ie.port,ie)})),!Z&&!q)return;const K=new Map;return z.forEach(Y=>{const ie=Z.get(Y.port),$e=q.get(Y.port);K.set(Y.port,{elevateIfNeeded:ie?.elevateIfNeeded,label:ie?.label,onAutoForward:ie?.onAutoForward??I.providedActionToAction($e?.autoForwardAction),requireLocalPort:ie?.requireLocalPort,protocol:ie?.protocol})}),K}addAttributesProvider(z){this.G.push(z)}};e.$yM=F,Ke([(0,O.$2h)(1e3)],F.prototype,"cb",null),e.$yM=F=Ke([We(0,w.$cw),We(1,y.$1p),We(2,E.$3i),We(3,f.$nM),We(4,p.$Hl),We(5,h.$Fi),We(6,P.$3j),We(7,A.$Hw),We(8,a.$EG),We(9,o.$Oj)],F)}),define(ke[94],Se([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$$K=e.$0K=void 0;class d{constructor(N,b){this.line=N,this.character=b}isBefore(N){return!1}isBeforeOrEqual(N){return!1}isAfter(N){return!1}isAfterOrEqual(N){return!1}isEqual(N){return!1}compareTo(N){return 0}translate(N,b){return new d(0,0)}with(N){return new d(0,0)}}e.$0K=d;class L{constructor(N,b,m,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(N,b),this.end=new d(m,E)}contains(N){return!1}isEqual(N){return!1}intersection(N){}union(N){return new L(0,0,0,0)}with(N){return new L(0,0,0,0)}}e.$$K=L;var O;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(O||(e.TextSearchCompleteMessageType=O={}))}),define(ke[37],Se([1,0,19,35,24,31,14,5,17,13,94,7]),function(le,e,d,L,O,R,N,b,m,E,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xL=e.$vL=e.$oL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$lL=e.$kL=e.$jL=e.$iL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.TextSearchCompleteMessageType=void 0,e.$fL=a,e.$gL=n,e.$hL=i,e.$mL=g,e.$nL=D,e.$pL=S,e.$qL=C,e.$rL=I,e.$sL=F,e.$tL=j,e.$uL=z,e.$wL=T,e.$yL=te,e.$zL=q,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$_K="workbench.view.search",e.$aL="workbench.panel.search",e.$bL="workbench.view.search",e.$cL="search-result",e.$dL="search.exclude";const p="\u27EA ",y=" characters skipped \u27EB",w=(p.length+y.length+5)*2;e.$eL=(0,b.$wi)("searchService");var h;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text",Y[Y.aiText=2]="aiText"})(h||(e.SearchProviderType=h={}));var f;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text",Y[Y.aiText=3]="aiText"})(f||(e.QueryType=f={}));function a(Y){return!!Y.preview}function n(Y){return!!Y.resource}function i(Y){return!!Y.message}var u;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(u||(e.SearchCompletionExitCode=u={}));class o{constructor(ie){this.resource=ie,this.results=[]}}e.$iL=o;class t{constructor(ie,$e,ue,ve){this.ranges=$e,this.webviewIndex=ve;const _=Array.isArray($e)?$e:[$e];if(ue&&ue.matchLines===1&&l(_)){ie=(0,N.$2f)(ie,ue.matchLines);let B="",ee=0,pe=0;const Ce=Math.floor(ue.charsPerLine/5),oe=[];for(const se of _){const re=Math.max(se.startColumn-Ce,0),G=se.startColumn+ue.charsPerLine;if(re>pe+Ce+w){const ne=p+(re-pe)+y;B+=ne+ie.slice(re,G),ee+=re-(pe+ne.length)}else B+=ie.slice(pe,G);oe.push(new c(0,se.startColumn-ee,se.endColumn-ee)),pe=G}this.preview={text:B,matches:Array.isArray(this.ranges)?oe:oe[0]}}else{const B=Array.isArray($e)?$e[0].startLineNumber:$e.startLineNumber;this.preview={text:ie,matches:(0,d.$2b)($e,ee=>new r(ee.startLineNumber-B,ee.startColumn,ee.endLineNumber-B,ee.endColumn))}}}}e.$jL=t;function l(Y){const ie=Y[0].startLineNumber;for(const $e of Y)if($e.startLineNumber!==ie||$e.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,$e,ue,ve){this.startLineNumber=ie,this.startColumn=$e,this.endLineNumber=ue,this.endColumn=ve}}e.$kL=r;class c extends r{constructor(ie,$e,ue){super(ie,$e,ie,ue)}}e.$lL=c;var s;(function(Y){Y.List="list",Y.Tree="tree"})(s||(e.ViewMode=s={}));var v;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(v||(e.SearchSortOrder=v={}));function g(Y,ie=!0){const $e=Y&&Y.files&&Y.files.exclude,ue=ie&&Y&&Y.search&&Y.search.exclude;if(!$e&&!ue)return;if(!$e||!ue)return $e||ue;let ve=Object.create(null);return ve=O.$6n(ve,O.$3n($e)),ve=O.$6n(ve,O.$3n(ue),!0),ve}function D(Y,ie){return Y.excludePattern&&L.$pk(Y.excludePattern,ie)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&L.$pk(Y.includePattern,ie)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some($e=>{const ue=$e.folder.fsPath;if(R.$vg(ie,ue)){const ve=m.$mc(ue,ie);return!$e.includePattern||!!L.$pk($e.includePattern,ve)}else return!1}):!1:!0}var $;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class k extends Error{constructor(ie,$e){super(ie),this.code=$e}}e.$oL=k;function S(Y){const ie=Y.message;if((0,E.$4)(Y))return new k(ie,$.canceled);try{const $e=JSON.parse(ie);return new k($e.message,$e.code)}catch{return new k(ie,$.other)}}function C(Y){const ie={message:Y.message,code:Y.code};return new Error(JSON.stringify(ie))}function I(Y){return Y.type==="error"?!0:Y.type==="success"}function F(Y){return Y.type==="success"}function j(Y){return!!Y.path}function z(Y,ie,$e=!0){const ue=Y.searchPath?Y.searchPath:Y.relativePath;return $e?(0,N.$Yf)(ue,ie):L.$pk(ie,ue)}class M{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$vL=M;function T(Y,ie){const $e={...Y||{},...ie||{}};return Object.keys($e).filter(ue=>{const ve=$e[ue];return typeof ve=="boolean"&&ve})}class U{constructor(ie,$e){this.c=null,this.a={...ie.excludePattern||{},...$e.excludePattern||{}},this.b=L.$qk(this.a);let ue=ie.includePattern;$e.includePattern&&(ue?ue={...ue,...$e.includePattern}:ue=$e.includePattern),ue&&(this.c=L.$qk(ue))}matchesExcludesSync(ie,$e,ue){return!!(this.b&&this.b(ie,$e,ue))}includedInQuerySync(ie,$e,ue){return!(this.b&&this.b(ie,$e,ue)||this.c&&!this.c(ie,$e,ue))}includedInQuery(ie,$e,ue){const ve=this.b(ie,$e,ue),_=()=>this.c?!!this.c(ie,$e,ue):!0;return(0,P.$ih)(ve)?ve.then(B=>B?!1:_()):_()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$xL=U;function Z(Y){for(const ie in Y)if(typeof Y[ie]!="boolean")return!0;return!1}function te(Y){if(!Y)return;let ie;return $e=>(ie||(ie=(Y()||Promise.resolve([])).then(ue=>ue?K(ue):{})),ie.then(ue=>!!ue[$e]))}function q(Y){if(!Y)return;let ie;return $e=>{if(!ie){const ue=Y();ie=ue?K(ue):{}}return!!ie[$e]}}function K(Y){const ie={};for(const $e of Y)ie[$e]=!0;return ie}}),define(ke[44],Se([1,0,19,7,22,4,3,78,15,126,23,14,2,235,5,11,268,42,60,28,20,16,8,68,37,6,58]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u,o,t,l,r,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$vlc=void 0;function v(F,j,z){return new A.$Yg(M=>k(M,z)).isEqual(F,j)}function g(F,j,z){return v(F.uri,j.uri,z)?0:(0,P.$rf)(F.uri.toString(),j.uri.toString())}function D(F,j,z){return F.index!==j.index?F.index<j.index?-1:1:v(F.uri,j.uri,z)?(0,P.$rf)(F.name,j.name):(0,P.$rf)(F.uri.toString(),j.uri.toString())}function $(F,j,z,M){const T=F.slice(0).sort((Z,te)=>z(Z,te,M)),U=j.slice(0).sort((Z,te)=>z(Z,te,M));return(0,d.$Eb)(T,U,(Z,te)=>z(Z,te,M))}function k(F,j){const z=j.getCapabilities(F.scheme);return!(z&&z&1024)}class S extends a.$Pi{static toExtHostWorkspace(j,z,M,T){if(!j)return{workspace:null,added:[],removed:[]};const{id:U,name:Z,folders:te,configuration:q,transient:K,isUntitled:Y}=j,ie=[],$e=z;z?te.forEach((B,ee)=>{const pe=p.URI.revive(B.uri),Ce=S.o(M||z,pe,T);Ce?(Ce.name=B.name,Ce.index=B.index,ie.push(Ce)):ie.push({uri:pe,name:B.name,index:ee})}):ie.push(...te.map(({uri:B,name:ee,index:pe})=>({uri:p.URI.revive(B),name:ee,index:pe}))),ie.sort((B,ee)=>B.index<ee.index?-1:1);const ue=new S(U,Z,ie,!!K,q?p.URI.revive(q):null,!!Y,B=>k(B,T)),{added:ve,removed:_}=$($e?$e.workspaceFolders:[],ue.workspaceFolders,g,T);return{workspace:ue,added:ve,removed:_}}static o(j,z,M){for(let T=0;T<j.folders.length;T++){const U=j.workspaceFolders[T];if(v(U.uri,z,M))return U}}constructor(j,z,M,T,U,Z,te){super(j,M.map(q=>new a.$Qi(q)),T,U,te),this.t=z,this.u=Z,this.q=[],this.s=b.$Ci.forUris(te),M.forEach(q=>{this.q.push(q),this.s.set(q.uri,q)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,A.$9g)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let C=class{constructor(j,z,M,T,U){this.c=new R.$ee,this.onDidChangeWorkspace=this.c.event,this.g=new R.$ee,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$ge,this.C=new Map,this.h=T,this.s=M,this.t=U,this.j=new E.$Dm,this.k=new L.$vh,this.o=j.getProxy(c.$3M.MainThreadWorkspace),this.q=j.getProxy(c.$3M.MainThreadMessageService);const Z=z.workspace;this.l=Z?new S(Z.id,Z.name,[],!!Z.transient,Z.configuration?p.URI.revive(Z.configuration):null,!!Z.isUntitled,te=>k(te,M)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:m.Schemas.untitled,path:(0,A.$7g)((0,A.$9g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,M,...T){const U=[];if(Array.isArray(T)&&T.forEach(Y=>{p.URI.isUri(Y.uri)&&!U.some(ie=>v(ie.uri,Y.uri,this.s))&&U.push({uri:Y.uri,name:Y.name||(0,A.$6g)(Y.uri)})}),this.n||[z,M].some(Y=>typeof Y!="number"||Y<0)||M===0&&U.length===0)return!1;const Z=this.x?this.x.workspaceFolders:[];if(z+M>Z.length)return!1;const te=Z.slice(0);te.splice(z,M,...U.map(Y=>({uri:Y.uri,name:Y.name||(0,A.$6g)(Y.uri),index:void 0})));for(let Y=0;Y<te.length;Y++){const ie=te[Y];if(te.some(($e,ue)=>ue!==Y&&v(ie.uri,$e.uri,this.s)))return!1}te.forEach((Y,ie)=>Y.index=ie);const{added:q,removed:K}=$(Z,te,D,this.s);if(q.length===0&&K.length===0)return!1;if(this.o){const Y=j.displayName||j.name;this.o.$updateWorkspaceFolders(Y,z,M,U).then(void 0,ie=>{this.n=void 0;const $e={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(f.Severity.Error,(0,y.localize)(0,null,Y,ie.toString()),$e,[])})}return this.y(te),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let M,T="";if(typeof j=="string"?(M=p.URI.file(j),T=j):typeof j<"u"&&(M=j,T=j.fsPath),!M)return T;const U=this.getWorkspaceFolder(M,!0);if(!U)return T;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let Z=(0,A.$_g)(U.uri,M);return z&&U.name&&(Z=`${U.name}/${Z}`),Z}y(j){this.x&&(this.n=S.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:M,removed:T}=S.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:T}))}findFiles(j,z,M,T,U=O.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let Z="",te=!0;return z===null?te=!1:z!==void 0&&(typeof z=="string"?Z=z:Z=z.pattern),this.z(j,void 0,{exclude:Z,maxResults:M,useDefaultExcludes:te,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},U)}findFiles2(j,z={},M,T=O.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,j,z,T)}async z(j,z,M,T=O.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const U=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,Z={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:U,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let te;if(j){const{includePattern:q,folder:K}=I(o.GlobPattern.from(j));te=K,Z.includePattern=q}else{const{includePattern:q,folder:K}=I(o.GlobPattern.from(z));te=K,Z.filePattern=q}return this.o.$startFileSearch(te??null,Z,T).then(q=>Array.isArray(q)?q.map(K=>p.URI.revive(K)):[])}async findTextInFiles(j,z,M,T,U=O.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const Z=this.j.getNext(),te=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:q,folder:K}=I(o.GlobPattern.from(z.include)),Y=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ie={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:te,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:q,excludePattern:Y},$e=!1;if(this.u[Z]=ue=>{if($e)return;const ve=p.URI.revive(ue.resource);ue.results.forEach(_=>{const B=(0,s.$6h)(_);(0,r.$fL)(B)?M({uri:ve,preview:{text:B.preview.text,matches:(0,d.$2b)(B.preview.matches,ee=>new t.$7M(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,d.$2b)(B.ranges,ee=>new t.$7M(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):M({uri:ve,text:B.text,lineNumber:B.lineNumber})})},U.isCancellationRequested)return{};try{const ue=await this.o.$startTextSearch(j,K??null,ie,Z,U);return delete this.u[Z],ue||{}}catch(ue){throw delete this.u[Z],ue}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return p.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return p.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const M=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,M),(0,N.$Tc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder(p.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const T=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!T),!T)return;const U=await T.provideEditSessionIdentity(M,z);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(j,z,M,T){this.h.info("Getting edit session identifier for workspaceFolder",j);const U=await this.resolveWorkspaceFolder(p.URI.revive(j));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const Z=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!Z),!Z)return;const te=await Z.provideEditSessionIdentityMatch?.(z,M,T);if(this.h.info("Provider returned edit session identifier match result: ",te),!!te)return te}getOnWillCreateEditSessionIdentityEvent(j){return(z,M,T)=>{const U=function(te){z.call(M,te)};return U.extension=j,this.B.event(U,void 0,T)}}async $onWillCreateEditSessionIdentity(j,z,M){const T=await this.resolveWorkspaceFolder(p.URI.revive(j));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},z,async(U,Z)=>{const te=Date.now();await Promise.resolve(U),Date.now()-te>M&&this.h.warn("SLOW edit session create-participant",Z.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const M=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerCanonicalUriProvider(T,M),(0,N.$Tc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(j,z,M){const T=this.C.get(j.scheme);if(!T)return;const U=await T.provideCanonicalUri?.(p.URI.revive(j),z,M);if(U)return U}async $provideCanonicalUri(j,z,M){return this.provideCanonicalUri(p.URI.revive(j),{targetScheme:z},M)}};e.$vlc=C,e.$vlc=C=Ke([We(0,u.$qP),We(1,i.$GP),We(2,n.$elc),We(3,h.$3j),We(4,l.$tlc)],C),e.$wlc=(0,w.$wi)("IExtHostWorkspace");function I(F){let j,z;return F&&(typeof F=="string"?j=F:(j=F.pattern,z=p.URI.revive(F.baseUri))),{includePattern:j,folder:z}}}),define(ke[45],Se([1,0,24,4,44,6,8,270,66,18,7,5,20,11,2]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=e.$ylc=e.$xlc=void 0;function h(l,r){if(r){const c=r.split(".");let s=l;for(let v=0;s&&v<c.length;v++)s=s[c[v]];return s}}function f(l){return l instanceof w.URI}function a(l){return l&&l.uri instanceof w.URI&&l.languageId&&typeof l.languageId=="string"}function n(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function i(l){return l&&l.uri instanceof w.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function u(l){if(f(l))return{resource:l};if(a(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(n(l))return{overrideIdentifier:l.languageId};if(i(l))return{resource:l.uri};if(l===null)return{resource:null}}let o=class{constructor(r,c,s){this.a=r.getProxy(R.$3M.MainThreadConfiguration),this.c=c,this.b=s,this.d=new A.$vh,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,c){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(r,c))}};e.$xlc=o,e.$xlc=o=Ke([We(0,p.$qP),We(1,O.$wlc),We(2,y.$3j)],o);class t{constructor(r,c,s,v){this.a=new L.$ee,this.b=r,this.f=v,this.c=c,this.e=b.$Ao.parse(s,v),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,c){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Ao.parse(r,this.f),this.d=this.k(r.configurationScopes),this.a.fire(this.j(c,s))}getConfiguration(r,c,s){const v=u(c)||{},g=this.g(r?h(this.e.getValue(void 0,v,this.c.workspace),r):this.e.getValue(void 0,v,this.c.workspace));r&&this.h(r,v,s?.identifier);function D(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case N.ConfigurationTarget.Global:return 2;case N.ConfigurationTarget.Workspace:return 5;case N.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(k){return typeof h(g,k)<"u"},get:(k,S)=>{this.h(r?`${r}.${k}`:k,v,s?.identifier);let C=h(g,k);if(typeof C>"u")C=S;else{let I;const F=(j,z)=>{if((0,E.$$f)(j)){let M;const T=()=>{I=I||(0,d.$3n)(g),M=M||h(I,z)};return new Proxy(j,{get:(U,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return T(),()=>M;if(I)return M=M||h(I,z),M[Z];const te=U[Z];return typeof Z=="string"?F(te,`${z}.${Z}`):te},set:(U,Z,te)=>(T(),M&&(M[Z]=te),!0),deleteProperty:(U,Z)=>(T(),M&&delete M[Z],!0),defineProperty:(U,Z,te)=>(T(),M&&Object.defineProperty(M,Z,te),!0)})}return Array.isArray(j)?(0,d.$3n)(j):j};C=F(C,k)}return C},update:(k,S,C,I)=>{k=r?`${r}.${k}`:k;const F=D(C);return S!==void 0?this.b.$updateConfigurationOption(F,k,S,v,I):this.b.$removeConfigurationOption(F,k,v,I)},inspect:k=>{k=r?`${r}.${k}`:k;const S=this.e.inspect(k,v,this.c.workspace);if(S)return{key:k,defaultValue:(0,d.$3n)(S.policy?.value??S.default?.value),globalValue:(0,d.$3n)(S.user?.value??S.application?.value),workspaceValue:(0,d.$3n)(S.workspace?.value),workspaceFolderValue:(0,d.$3n)(S.workspaceFolder?.value),defaultLanguageValue:(0,d.$3n)(S.default?.override),globalLanguageValue:(0,d.$3n)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,d.$3n)(S.workspace?.override),workspaceFolderLanguageValue:(0,d.$3n)(S.workspaceFolder?.override),languageIds:(0,d.$3n)(S.overrideIdentifiers)}}};return typeof g=="object"&&(0,d.$6n)($,g,!1),Object.freeze($)}g(r){const c=s=>(0,E.$$f)(s)?new Proxy(s,{get:(v,g)=>c(v[g]),set:(v,g,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(v,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(v,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return c(r)}h(r,c,s){const v=m.$ro.test(r)?4:this.d.get(r),g=s?`[${s.value}] `:"";if(v===4){typeof c?.resource>"u"&&this.f.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){c?.resource&&this.f.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,c){const s=new b.$Co(r,c,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(v,g)=>s.affectsConfiguration(v,u(g))})}k(r){return r.reduce((c,s)=>(c.set(s[0],s[1]),c),new Map)}}e.$ylc=t,e.$zlc=(0,P.$wi)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,7,4,6,8,44,73,45,22,43,20,28,5,15,12,11,91,314,13]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=e.$3mc=e.$2mc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(F){function j(M){if(M!=null)return M}F.from=j;function z(M){if(M!=null)return M}F.to=z})(o||(o={}));var t;(function(F){function j(M){if(M!=null)return M}F.from=j;function z(M){if(M!=null)return M}F.to=z})(t||(t={}));var l;(function(F){function j(M){if(M!=null)return M}F.from=j;function z(M){if(M!=null)return M}F.to=z})(l||(l={}));var r;(function(F){function j(T){if(T){const U=T;return U&&!!U.process}else return!1}F.is=j;function z(T){if(T==null)return;const U={process:T.process,args:T.args};return T.options&&(U.options=l.from(T.options)),U}F.from=z;function M(T){if(T!=null)return new N.$ON(T.process,T.args,T.options)}F.to=M})(r||(r={}));var c;(function(F){function j(M){if(M!=null)return M}F.from=j;function z(M){if(M!=null)return M}F.to=z})(c||(c={}));var s;(function(F){function j(T){if(T){const U=T;return U&&(!!U.commandLine||!!U.command)}else return!1}F.is=j;function z(T){if(T==null)return;const U={};return T.commandLine!==void 0?U.commandLine=T.commandLine:(U.command=T.command,U.args=T.args),T.options&&(U.options=c.from(T.options)),U}F.from=z;function M(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new N.$PN(T.commandLine,T.options):new N.$PN(T.command,T.args?T.args:[],T.options)}F.to=M})(s||(s={}));var v;(function(F){function j(T){if(T){const U=T;return U&&U.customExecution==="customExecution"}else return!1}F.is=j;function z(T){return{customExecution:"customExecution"}}F.from=z;function M(T,U){return U.get(T)}F.to=M})(v||(e.CustomExecutionDTO=v={}));var g;(function(F){function j(z,M){let T;return z.scope!==void 0&&typeof z.scope!="number"?T=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===N.TaskScope.Workspace&&M&&M.workspaceFile?T=M.workspaceFile:T=i.$9H),{id:z._id,workspaceFolder:T}}F.from=j})(g||(e.TaskHandleDTO=g={}));var D;(function(F){function j(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}F.from=j})(D||(D={}));var $;(function(F){function j(T,U){if(T==null)return[];const Z=[];for(const te of T){const q=z(te,U);q&&Z.push(q)}return Z}F.fromMany=j;function z(T,U){if(T==null)return;let Z;T.execution instanceof N.$ON?Z=r.from(T.execution):T.execution instanceof N.$PN?Z=s.from(T.execution):T.execution&&T.execution instanceof N.$QN&&(Z=v.from(T.execution));const te=o.from(T.definition);let q;return T.scope?typeof T.scope=="number"?q=T.scope:q=T.scope.uri:q=N.TaskScope.Workspace,!te||!q?void 0:{_id:T._id,definition:te,name:T.name,source:{extensionId:U.identifier.value,label:T.source,scope:q},execution:Z,isBackground:T.isBackground,group:D.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}F.from=z;async function M(T,U,Z){if(T==null)return;let te;r.is(T.execution)?te=r.to(T.execution):s.is(T.execution)?te=s.to(T.execution):v.is(T.execution)&&(te=v.to(T._id,Z));const q=o.to(T.definition);let K;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?K=T.source.scope:K=await U.resolveWorkspaceFolder(d.URI.revive(T.source.scope)):K=N.TaskScope.Workspace),!q||!K)return;const Y=new N.$RN(q,K,T.name,T.source.label,te,T.problemMatchers);return T.isBackground!==void 0&&(Y.isBackground=T.isBackground),T.group!==void 0&&(Y.group=N.$NN.from(T.group._id),Y.group&&T.group.isDefault&&(Y.group=new N.$NN(Y.group.id,Y.group.label),T.group.isDefault===!0&&(Y.group.isDefault=T.group.isDefault))),T.presentationOptions&&(Y.presentationOptions=t.to(T.presentationOptions)),T._id&&(Y._id=T._id),T.detail&&(Y.detail=T.detail),Y}F.to=M})($||(e.TaskDTO=$={}));var k;(function(F){function j(M){return M}F.from=j;function z(M){if(M)return Object.assign(Object.create(null),M)}F.to=z})(k||(k={}));class S{#e;constructor(j,z,M){this._id=z,this.a=M,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let C=class{constructor(j,z,M,T,U,Z,te,q){this.q=new O.$ee,this.r=new O.$ee,this.s=new O.$ee,this.u=new O.$ee,this.a=j.getProxy(R.$3M.MainThreadTask),this.b=M,this.c=T,this.d=U,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=te,this.g=q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,z,M){if(!M)return new N.$5M(()=>{});const T=this.x();return this.j.set(T,{type:z,provider:M,extension:j}),this.a.$registerTaskProvider(T,z),new N.$5M(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(j,z){this.a.$registerTaskSystem(j,z)}fetchTasks(j){return this.a.$fetchTasks(k.from(j)).then(async z=>{const M=[];for(const T of z){const U=await $.to(T,this.b,this.m);U&&M.push(U)}return M})}get taskExecutions(){const j=[];return this.k.forEach(z=>j.push(z)),j}terminateTask(j){if(!(j instanceof S))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,z,M){const T=this.m.get(j.id);T&&(this.o.set(j.id,T),this.e.attachPtyToTerminal(z,await T.callback(M))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const z=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const z=await this.z(j.id);this.s.fire({execution:z,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const z=await this.z(j.id);this.u.fire({execution:z,exitCode:j.exitCode})}$provideTasks(j,z){const M=this.j.get(j);if(!M)return Promise.reject(new Error("no handler found"));const T=[],U=(0,L.$oh)(()=>M.provider.provideTasks(A.CancellationToken.None)).then(Z=>this.v(z,T,M,Z));return new Promise(Z=>{U.then(te=>{Promise.all(T).then(()=>{Z(te)})})})}async $resolveTask(j,z){const M=this.j.get(j);if(!M)return Promise.reject(new Error("no handler found"));if(z.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${M.type}].`);const T=await $.to(z,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const U=await M.provider.resolveTask(T,A.CancellationToken.None);if(!U)return;this.A(U,M);const Z=$.from(U,M.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(Z.execution)&&await this.y(Z,U,!0),await this.w(Z)}x(){return this.h++}async y(j,z,M){const T=await this.a.$createTaskId(j);!M&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,z.execution)),this.m.set(T,z.execution)}async z(j,z){if(typeof j=="string"){const U=this.l.get(j);if(!U)throw new u.$bb("Unexpected: The specified task is missing an execution");return U}const M=this.l.get(j.id);if(M)return M;let T;return z?T=Promise.resolve(new S(this,j.id,z)):T=$.to(j.task,this.b,this.m).then(U=>{if(!U)throw new u.$bb("Unexpected: Task does not exist.");return new S(this,j.id,U)}),this.l.set(j.id,T),T.then(U=>(this.k.set(j.id,U),U))}A(j,z){j._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const M=this.n.values();let T=M.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=M.next()}};e.$2mc=C,e.$2mc=C=Ke([We(0,p.$qP),We(1,y.$GP),We(2,b.$wlc),We(3,m.$BP),We(4,E.$zlc),We(5,P.$Xlc),We(6,a.$3j),We(7,n.$alc)],C);let I=class extends C{constructor(j,z,M,T,U,Z,te,q){super(j,z,M,T,U,Z,te,q),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(j,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const M=$.from(z,j);if(M===void 0)throw new Error("Task is not valid");if(v.is(M.execution))await this.y(M,z,!1);else throw new u.$_;const T=await this.z(await this.a.$getTaskExecution(M),z);return this.a.$executeTask(M).catch(U=>{throw new Error(U)}),T}v(j,z,M,T){const U=[];if(T)for(const Z of T){if(this.A(Z,M),!Z.definition||!j[Z.definition.type]){const q=Z.source?Z.source:"No task source";this.f.warn(`The task [${q}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const te=$.from(Z,M.extension);te&&v.is(te.execution)?(U.push(te),z.push(this.y(te,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:M.extension}}async w(j){if(v.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,z,M){}};e.$3mc=I,e.$3mc=I=Ke([We(0,p.$qP),We(1,y.$GP),We(2,b.$wlc),We(3,m.$BP),We(4,E.$zlc),We(5,P.$Xlc),We(6,a.$3j),We(7,n.$alc)],I),e.$4mc=(0,w.$wi)("IExtHostTask")}),define(ke[374],Se([1,0,37,29]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GL=void 0,e.$FL=O,e.$HL=R;function O(N){return"cellResults"in N}e.$GL="rawCell#";function R(N,b){let m=-1;const E=[];let A=[];return N.forEach(p=>{p.range.startLineNumber!==m&&A.length>0&&(E.push([...A]),A=[]),A.push(p),m=p.range.endLineNumber}),A.length>0&&E.push([...A]),E.map(p=>{const y=[],w=p[0].range.startLineNumber,h=p[p.length-1].range.endLineNumber;for(let f=w;f<=h;f++)y.push(b.getLineContent(f));return new d.$jL(y.join(`
`)+`
`,p.map(f=>new L.$ut(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}}),define(ke[375],Se([1,0,229,21,4,3,27,14,18,2,33,112,6,34,16,8,48,345,154,24,15,304,374,371]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u,o,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,v,g,D,$,k){this.q=g,this.r=D,this.s=$,this.t=k,this.f=new Map,this.g=new N.$Bc,this.h=new Map,this.j=new O.$ee,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new O.$ee,this.onDidOpenNotebookDocument=this.m.event,this.n=new O.$ee,this.onDidCloseNotebookDocument=this.n.event,this.o=new O.$ee,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$$kc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=s.getProxy(p.$3M.MainThreadNotebook),this.c=s.getProxy(p.$3M.MainThreadNotebookDocuments),this.d=s.getProxy(p.$3M.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const C=S.notebookEditor?.notebookUri,I=S.cell.handle,j=this.g.get(C)?.getCell(I);if(j)return j.apiCell}if(S&&S.$mid===14){const C=S.uri,I=this.g.get(C);if(I)return I.apiNotebook}return S}}),r.B(v)}getEditorById(s){const v=this.h.get(s);if(!v)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(s){for(const[v,g]of this.h)if(g.apiEditor===s)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,v){const g=this.g.get(s);if(!g&&!v)throw new Error(`NO notebook document for '${s}'`);return g}static u(s,v){if(!v)return;const g=v.filenamePattern.map(D=>w.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(v.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:v.displayName,filenamePattern:g,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,v,g){const D=r.a++,$=typeof g.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(D,g),this.b.$registerNotebookCellStatusBarItemProvider(D,$,v);let k;return $!==void 0&&(k=g.onDidChangeCellStatusBarItems(S=>this.b.$emitCellStatusBarEvent($))),new h.$5M(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,$),k?.dispose()})}async createNotebookDocument(s){const v=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&w.NotebookData.from(s.content)});return E.URI.revive(v)}async openNotebookDocument(s){const v=this.g.get(s);if(v)return v.apiNotebook;const g=await this.c.$tryOpenNotebook(s),D=this.g.get(E.URI.revive(g));return(0,m.$hg)(D?.apiNotebook)}async showNotebookDocument(s,v){E.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let g;typeof v=="object"?g={position:w.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(w.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:g={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,g),$=D&&this.h.get(D)?.apiEditor;if($)return $;throw D?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,v,g,D){const $=this.f.get(s),k=E.URI.revive(v),S=this.g.get(k);if(!S||!$)return;const C=S.getCellFromIndex(g);if(!C)return;const I=await $.provideCellStatusBarItems(C.apiCell,D);if(!I)return;const F=new R.$Uc,j=this.p.add([F]),M=(Array.isArray(I)?I:[I]).map(T=>w.NotebookStatusBarItem.from(T,this.i,F));return{cacheId:j,items:M}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,v,g,D,$){if((0,b.$8e)(v))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:v,serializer:g,options:D}),this.b.$registerNotebookSerializer(k,{id:s.identifier,location:s.extensionLocation},v,w.NotebookDocumentContentOptions.from(D),r.u(s,$)),(0,R.$Tc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(s,v,g){const D=this.x.get(s);if(!D)throw new Error("NO serializer found");const $=await D.serializer.deserializeNotebook(v.buffer,g);return new f.$vw(w.NotebookData.from($))}async $notebookToData(s,v,g){const D=this.x.get(s);if(!D)throw new Error("NO serializer found");const $=await D.serializer.serializeNotebook(w.NotebookData.to(v.value),g);return L.$Ge.wrap($)}async $saveNotebook(s,v,g,D,$){const k=E.URI.revive(v),S=this.x.get(s);if(!S)throw new Error("NO serializer found");const C=this.g.get(k);if(!C)throw new Error("Document NOT found");if(C.versionId!==g)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new A.$ll((0,d.localize)(0,null,this.z(k)),6);await this.y(k,D);const I={metadata:(0,i.$$n)(C.apiNotebook.metadata,T=>!(S.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of C.apiNotebook.getCells()){const U=new h.$vO(T.kind,T.document.getText(),T.document.languageId,T.mime,S.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);U.metadata=(0,i.$$n)(T.metadata,Z=>!(S.options?.transientCellMetadata??{})[Z]),I.cells.push(U)}const F=await S.serializer.serializeNotebook(I,$);await this.s.value.writeFile(k,F);const j=this.s.getFileSystemProviderExtUri(k.scheme),z=await this.s.value.stat(k);return{name:j.basename(k),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$wl({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(s,v,g,D,$){const k=this.x.get(s)?.serializer;if(!k)return{limitHit:!1,results:[]};const S=new N.$Cc;await(async(z,M,T)=>{await Promise.all(z.map(async U=>await Promise.all(U.filenamePatterns.map(Z=>{const te={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:Z};return this.t.doInternalFileSearchWithCustomCallback(te,M,q=>{q.forEach(K=>{S.has(K)||D.some(ie=>U.isFromSettings&&!ie.isFromSettings?!1:ie.filenamePatterns.some($e=>(0,l.$ehb)($e,K)))||S.add(K)})}).catch(q=>{if(q.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw q})}))))})(g,$,v);const I=new N.$Bc;let F=!1;const j=Array.from(S).map(async z=>{const M=[];try{if($.isCancellationRequested)return;if(v.maxResults&&[...I.values()].reduce((te,q)=>te+q.cellResults.length,0)>v.maxResults){F=!0;return}const T=[],U=this.g.get(z);if(U)U.apiNotebook.getCells().forEach(q=>T.push({input:q.document.getText(),outputs:q.outputs.flatMap(K=>K.items.map(Y=>Y.data.toString()))}));else{const te=await this.s.value.readFile(z),q=L.$Ge.fromString(te.toString()),K=await k.deserializeNotebook(q.buffer,$);if($.isCancellationRequested)return;w.NotebookData.from(K).cells.forEach(ie=>T.push({input:ie.source,outputs:ie.outputs.flatMap($e=>$e.items.map(ue=>ue.valueBytes.toString()))}))}if($.isCancellationRequested)return;T.forEach((te,q)=>{const K=v.contentPattern.pattern,Y=new o.$gXb(te.input,void 0,te.outputs),ie=Y.findInInputs(K),$e=Y.findInOutputs(K),ue=$e.flatMap(ve=>(0,t.$HL)(ve.matches,ve.textBuffer)).map((ve,_)=>(ve.webviewIndex=_,ve));if(ie.length>0||$e.length>0){const ve={index:q,contentResults:(0,t.$HL)(ie,Y.inputTextBuffer),webviewResults:ue};M.push(ve)}});const Z={resource:z,cellResults:M};I.set(z,Z);return}catch{return}});return await Promise.all(j),{limitHit:F,results:[...I.values()]}}async y(s,v){const g=await this.s.value.stat(s);if(typeof v?.mtime=="number"&&typeof v.etag=="string"&&v.etag!==A.$vl&&typeof g.mtime=="number"&&typeof g.size=="number"&&v.mtime<g.mtime&&v.etag!==A.$wl({mtime:v.mtime,size:g.size}))throw new A.$ll((0,d.localize)(1,null),3,v)}z(s){return s.scheme===u.Schemas.file?s.fsPath:s.toString()}A(s,v,g){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const D=new n.$vmc(v,this.d,s,g.visibleRanges.map(w.NotebookRange.to),g.selections.map(w.NotebookRange.to),typeof g.viewColumn=="number"?w.ViewColumn.to(g.viewColumn):void 0);this.h.set(v,D)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const g of s.value.removedDocuments){const D=E.URI.revive(g),$=this.g.get(D);$&&($.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire($.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===D.toString()&&this.h.delete(k.id)}if(s.value.addedDocuments){const g=[];for(const D of s.value.addedDocuments){const $=E.URI.revive(D.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const k=new a.$umc(this.c,this.q,this.r,$,D);g.push(...D.cells.map(S=>a.$tmc.asModelAddData(S))),this.g.get($)?.dispose(),this.g.set($,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(k.apiNotebook)}}if(s.value.addedEditors)for(const g of s.value.addedEditors){if(this.h.has(g.id))return;const D=E.URI.revive(g.documentUri),$=this.g.get(D);$&&this.A($,g.id,g)}const v=[];if(s.value.removedEditors)for(const g of s.value.removedEditors){const D=this.h.get(g);D&&(this.h.delete(g),this.k?.id===D.id&&(this.k=void 0),v.push(D))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const g=new Set;this.l.forEach(D=>g.add(D.id));for(const D of this.h.values()){const $=g.has(D.id);D._acceptVisibility($)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(s){const v=y.$OP.String.with("notebookType","A notebook type"),g=new y.$QP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new y.$OP("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>L.$Ge.wrap($))],new y.$PP("Notebook Data",$=>w.NotebookData.to($.value))),D=new y.$QP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new y.$OP("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new f.$vw(w.NotebookData.from($)))],new y.$PP("Bytes",$=>$.buffer));s.registerApiCommand(g),s.registerApiCommand(D)}}e.$Emc=r}),define(ke[376],Se([1,0,17,22,47,35,23,40,37]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class E{constructor(p,y,w){this.k=p,this.l=y,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&R.$qk(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&R.$qk(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const y=this.k.folderQueries||[];return new Promise((w,h)=>{const f=a=>{this.f++,p(a)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const n=a.toString(),i=d.$oc(n);this.j&&this.j(n,i)||this.v(f,{base:a,basename:i})}),Promise.all(y.map(a=>this.p(a,f))).then(a=>{w({limitHit:this.e,stats:a[0]||void 0})},a=>{h(new Error((0,O.$hj)(a)))})})}async p(p,y){const w=new L.$pe,h=this.q(p),f=this.r(),a=new m.$xL(this.k,p),n=!a.hasSiblingExcludeClauses();let i;try{this.h.add(w),i=b.$ae.create();const u=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,w.token),o=i.elapsed(),t=b.$ae.create();return this.g&&!this.e||(u&&u.forEach(l=>{const r=d.$hc.relative(p.folder.path,l.path);if(n){const c=d.$oc(l.path);this.v(y,{base:p.folder,relativePath:r,basename:c});return}this.s(f,p.folder,r,y)}),this.g&&!this.e)?null:(this.u(f,a,y),{providerTime:o,postProcessTime:t.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(p){const y=(0,m.$wL)(this.k.includePattern,p.includePattern),w=(0,m.$wL)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:w,includes:y,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},y,w,h){if(w===this.a){const a=d.$oc(this.a);this.v(h,{base:y,relativePath:this.a,basename:a})}function f(a){const n=d.$oc(a),i=d.$nc(a);let u=p[i];u||(u=p[i]=[],f(i)),u.push({base:y,relativePath:a,basename:n})}f(w)}u({rootEntries:p,pathToEntries:y},w,h){const f=this,a=this.a;function n(i){const u=(0,m.$zL)(()=>i.map(o=>o.basename));for(let o=0,t=i.length;o<t;o++){const l=i[o],{relativePath:r,basename:c}=l;if(w.matchesExcludesSync(r,c,a!==c?u:void 0))continue;const s=y[r];if(s)n(s);else{if(r===a)continue;f.v(h,l)}if(f.e)break}}n(p)}v(p,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(y))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,y,w,h){const f=this.c(p.cacheKey),a=new E(p,y,f&&f.token);let n=0;const i=u=>{n+=u.length,w(u.map(o=>this.d(o)))};return this.e(a,A.a,i,h).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:u.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new L.$pe),this.b.get(p)}d(p){return p.relativePath?{resource:N.$0g(p.base,p.relativePath)}:{resource:p.base}}e(p,y,w,h){const f=h.onCancellationRequested(()=>{p.cancel()}),a=i=>{i&&(n.push(i),y>0&&n.length>=y&&(w(n),n=[]))};let n=[];return p.search(a).then(i=>(n.length&&w(n),f.dispose(),i),i=>(n.length&&w(n),f.dispose(),Promise.reject(i)))}}e.$wmc=A}),define(ke[377],Se([1,0,19,74,35,103,27,15,17,23,14,18,2,100,250,55,11,42,147,372,37]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=void 0,e.$HM=D;let o=class{constructor(k,S,C,I,F){this.a=k,this.b=S,this.c=C,this.d=I,this.e=F}text(k,S,C={}){k=this.f(k,C);const I=this.a.getValue(),F=S&&S.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(S?.map(a.$Ri),C),type:2,contentPattern:k,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:I.search.usePCRE2||F||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(k,S){const C=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const I={...k,wordSeparators:C.editor.wordSeparators};return this.j(k,S)&&(I.isCaseSensitive=!0),this.k(k)&&(I.isMultiline=!0),S.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=S.notebookSearchConfig.includeMarkupInput),S.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=S.notebookSearchConfig.includeMarkupPreview),S.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=S.notebookSearchConfig.includeCodeInput),S.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=S.notebookSearchConfig.includeOutput),I}file(k,S={}){return{...this.h(k,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey,shouldGlobMatchFilePattern:S.shouldGlobSearch}}g(k,S){return k?(k=Array.isArray(k)?k.map(s):s(k),S?this.parseSearchPaths(k):{pattern:l(...Array.isArray(k)?k:[k])}):{}}h(k=[],S={}){const C=this.g(S.includePattern,S.expandPatterns),I=this.g(S.excludePattern,S.expandPatterns),F=k.length>1,j=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(T=>this.q(T,S,I)):k.map(T=>this.r(T,S,I,F))).filter(T=>!!T),z={_reason:S._reason,folderQueries:j,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:I.pattern,includePattern:C.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const T=d.$Hb(d.$Rb(this.c.groups.map(te=>te.editors.map(q=>q.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const U=T.filter(te=>(0,u.$nL)(z,te.fsPath)),Z=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...z,...Z}}const M=S.extraFileResources&&S.extraFileResources.filter(T=>(0,u.$nL)(z,T.fsPath));return z.extraFileResources=M&&M.length?M:void 0,z}i(k){const S=[],C=new N.$Bc,I={};let F=!1;return k.forEach(j=>{if(j.scheme===b.Schemas.walkThrough)return;if((0,E.$bh)(j)){const M=this.b.getWorkspaceFolder(j)?.uri??j.with({path:m.$nc(j.fsPath)});let T=C.get(M);T||(F=!0,T={folder:M,includePattern:{}},S.push(T),C.set(M,T));const U=m.$mc(M.fsPath,j.fsPath);(0,P.$hg)(T.includePattern)[U.replace(/\\/g,"/")]=!0}else j.fsPath&&(F=!0,I[j.fsPath]=!0)}),{folderQueries:S,includePattern:I,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}j(k,S){if(S.isSmartCase){if(k.isRegExp){if(A.$Zf(k.pattern,!0))return!0}else if(A.$Zf(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,y.$KC)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const S=Z=>m.$jc(Z)||/^\.\.?([\/\\]|$)/.test(Z),I=(Array.isArray(k)?k:r(k)).map(Z=>{const te=this.e.resolvedUserHome;return te?(0,R.$Aw)(Z,te.scheme===b.Schemas.file?te.fsPath:te.path):Z}),F=L.$K(I,Z=>S(Z)?"searchPaths":"exprSegments"),j=(F.exprSegments||[]).map(Z=>A.$gf(Z,"/")).map(Z=>A.$gf(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),c(Z))),z={},M=this.m(F.searchPaths||[]);M&&M.length&&(z.searchPaths=M);const T=d.$Rb(j),U=l(...T);return U&&(z.pattern=U),z}l(k,S){return S.disregardExcludeSettings?void 0:(0,u.$mL)(k,!S.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const S=k.flatMap(I=>{let{pathPortion:F,globPortion:j}=t(I);return j&&(j=v(j)),this.n(F).flatMap(M=>this.o(M,j))}),C=new Map;return S.forEach(I=>{const F=I.searchPath.toString(),j=C.get(F);j?I.pattern&&(j.pattern=j.pattern||{},j.pattern[I.pattern]=!0):C.set(F,{searchPath:I.searchPath,pattern:I.pattern?l(I.pattern):void 0})}),Array.from(C.values())}n(k){if(m.$jc(k)){const S=this.b.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==b.Schemas.file?[{searchPath:S[0].uri.with({path:k})}]:[{searchPath:p.URI.file(m.$ic(k))}]}if(this.b.getWorkbenchState()===2){const S=this.b.getWorkspace().folders[0].uri;if(k=s(k),k.startsWith("../")||k===".."){const I=m.$hc.resolve(S.path,k);return[{searchPath:S.with({path:I})}]}const C=v(k);return[{searchPath:S,pattern:C}]}else{if(k==="./"||k===".\\")return[];{const S=k.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(F=>{const j=S.match(new RegExp(`^${A.$af(F.name)}(?:/(.*)|$)`));return j?{match:j,folder:F}:null}).filter(P.$eg);if(I.length)return I.map(F=>{const j=F.match[1];return{searchPath:F.folder.uri,pattern:j&&v(j)}});{const F=k.match(/\.[\/\\](.+)[\/\\]?/),j=F?F[1]:k,z=w.localize(0,null,j);throw new Error(z)}}}}o(k,S){const C=k.pattern&&S?`${k.pattern}/${S}`:k.pattern||S,I=[{searchPath:k.searchPath,pattern:C}];return C&&!C.endsWith("**")&&I.push({searchPath:k.searchPath,pattern:C+"/**"}),I}q(k,S,C){const I=this.r((0,a.$Ri)(k.searchPath),S,C,!1);return I?{...I,includePattern:k.pattern}:null}r(k,S,C,I){let F;const j=p.URI.isUri(k)?k:k.uri;if(C.searchPaths){const Z=C.searchPaths.filter(te=>(0,E.$3g)(te.searchPath,j))[0];if(Z&&!Z.pattern)return null;Z&&(F=Z.pattern)}const z=this.a.getValue({resource:j}),T={...this.l(z,S)||{},...F||{}},U=p.URI.isUri(k)?(0,E.$7g)(k):k.name;return{folder:j,folderName:I?U:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!z.search.followSymlinks}}};e.$GM=o,e.$GM=o=Ke([We(0,h.$3i),We(1,a.$Fi),We(2,n.$RD),We(3,f.$3j),We(4,i.$EM)],o);function t($){const k=$.match(/[\*\{\}\(\)\[\]\?]/);if(k){const S=k.index,C=$.substr(0,S).match(/[/|\\][^/\\]*$/);if(C){let I=$.substr(0,C.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:$.substr((C.index||0)+1)}}}return{pathPortion:$}}function l(...$){return $.length?$.reduce((k,S)=>(k[S]=!0,k),Object.create(null)):void 0}function r($){return O.$ok($,",").map(k=>k.trim()).filter(k=>!!k.length)}function c($){return[`**/${$}/**`,`**/${$}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function s($){return $.replace(/\\/g,"/")}function v($){return s($).replace(/^\.\//,"").replace(/\/+$/g,"")}function g($){return $.replace(/([?*[\]])/g,"[$1]")}function D($,k){$=d.$Mb($,I=>I.toString());const S=[],C=k.getWorkspace();return $&&$.forEach(I=>{let F;if(k.getWorkbenchState()===2)F=(0,E.$_g)(C.folders[0].uri,I),F&&F!=="."&&(F="./"+F);else{const j=k.getWorkspaceFolder(I);if(j){const z=j.name;if(C.folders.filter(T=>T.name===z).length===1){const T=(0,E.$_g)(j.uri,I);T===""?F=`./${j.name}`:F=`./${j.name}/${T}`}else F=I.fsPath}}F&&S.push(g(F))}),S}}),define(ke[378],Se([1,0,23,2,22,13,5,377,37,42,7]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nwb=p,e.$owb=h;const P=7e3;function p(f,a){const n=a.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],u=[];for(const s of n)if(/^workspaceContains:/.test(s)){const v=s.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||f.forceUsingSearch?u.push(v):i.push(v)}if(i.length===0&&u.length===0)return Promise.resolve(void 0);const{promise:o,resolve:t}=(0,A.$ph)(),l=s=>t({activationEvent:s}),r=Promise.all(i.map(s=>y(f,s,l))).then(()=>{}),c=w(f,a.identifier,u,l);return Promise.all([r,c]).then(()=>{t(void 0)}),o}async function y(f,a,n){for(const i of f.folders)if(await f.exists(d.$0g(L.URI.revive(i),a))){n(`workspaceContains:${a}`);return}}async function w(f,a,n,i){if(n.length===0)return Promise.resolve(void 0);const u=new O.$pe,o=f.checkExists(f.folders,n,u.token),t=setTimeout(async()=>{u.cancel(),f.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},P);let l=!1;try{l=await o}catch(r){R.$4(r)||R.$1(r)}u.dispose(),clearTimeout(t),l&&i(`workspaceContains:${n.join(",")}`)}function h(f,a,n,i){const u=f.get(N.$vi),o=f.get(m.$eL),l=u.createInstance(b.$GM).file(a.map(r=>(0,E.$Ri)(L.URI.revive(r))),{_reason:"checkExists",includePattern:n,exists:!0});return o.fileSearch(l,i).then(r=>!!r.limitHit,r=>R.$4(r)?!1:Promise.reject(r))}}),define(ke[49],Se([1,0,225,17,59,23,7,3,78,2,11,6,45,310,119,44,26,149,13,25,21,287,8,67,5,28,93,20,107,71,43,122,4,378,118,289,15,116,40,12,117]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u,o,t,l,r,c,s,v,g,D,$,k,S,C,I,F,j,z,M,T,U){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=e.$bmc=e.$amc=e.$_lc=e.$$lc=void 0,e.$$lc=(0,r.$wi)("IHostUtils");let te=Z=class extends b.$Vc{constructor(B,ee,pe,Ce,oe,se,re,G,ne,me,be,Re,fe){super(),this.Y=Re,this.Z=fe,this.a=this.B(new S.$ee),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ee,this.g=pe,this.f=re,this.j=Ce,this.m=oe,this.s=se,this.t=ne,this.u=me,this.w=be,this.y=this.g.getProxy(P.$3M.MainThreadWorkspace),this.z=this.g.getProxy(P.$3M.MainThreadTelemetry),this.C=this.g.getProxy(P.$3M.MainThreadExtensionService),this.D=new N.$vh,this.F=new N.$vh,this.G=new N.$vh,this.H=new N.$vh,this.I=new ve(this.f.extensions.activationEvents),this.L=new a.$L_b(this.I,this.f.extensions.allExtensions);const De=new i.$Sm(this.f.extensions.myExtensions);this.J=new a.$L_b(this.I,$e(this.L,De)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new w.$Tlc(this.g,this.s),this.N=new I.$4lc(this.g),this.O=G,this.h=B.createChild(new g.$ui([w.$Ulc,this.M],[I.$5lc,this.N])),this.P=this.B(new y.$Slc(this.J,this.L,{onExtensionActivationError:(Ae,ze,W)=>{this.C.$onExtensionActivationError(Ae,n.$3(ze),W)},actualActivateExtension:async(Ae,ze)=>{if(a.$L_b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,ze),new y.$Rlc;const W=this.J.getExtensionDescription(Ae);return this.fb(W,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),O.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(B){n.$1(B)}}async $(){this.O.onWillDeactivateAll();let B=[];try{B=this.J.getAllExtensionDescriptions().map(oe=>oe.identifier).filter(oe=>this.isActivated(oe)).map(oe=>this.eb(oe))}catch{}await Promise.all(B)}terminate(B,ee=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${B}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ce=>{this.s.error(Ce)}),this.g.dispose();const pe=this.$();Promise.race([(0,N.$xh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ee}`):this.s.info(`Extension host exiting with code ${ee}`),this.s.flush(),this.s.dispose(),this.c.exit(ee)})}isActivated(B){return this.G.isOpen()?this.P.isActivated(B):!1}async getExtension(B){const ee=await this.C.$getExtension(B);return ee&&{...ee,identifier:new i.$Rm(ee.identifier.value),extensionLocation:E.URI.revive(ee.extensionLocation)}}ab(B,ee){return this.P.activateByEvent(B,ee)}bb(B,ee){return this.P.activateById(B,ee)}activateByIdWithErrors(B,ee){return this.bb(B,ee).then(()=>{const pe=this.P.getActivatedExtension(B);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(B=>this.J)}getExtensionExports(B){if(this.G.isOpen())return this.P.getActivatedExtension(B).exports;try{return this.P.getActivatedExtension(B).exports}catch{return null}}async cb(B){if(B.scheme===j.Schemas.file&&this.c.fsRealpath){const ee=B.fsPath;this.R.has(ee)||this.R.set(ee,this.c.fsRealpath(ee));const pe=await this.R.get(ee);return E.URI.file(pe)}return B}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(B=>new ue(B))),this.Q}async db(B){const ee=m.$Ci.forUris(pe=>R.$1g.ignorePathCasing(pe));return await Promise.all(B.map(async pe=>{if(this.wb(pe)){const Ce=await this.cb(pe.extensionLocation);ee.set(Ce,pe)}})),ee}eb(B){let ee=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(B))return ee;const pe=this.P.getActivatedExtension(B);if(!pe)return ee;try{typeof pe.module.deactivate=="function"&&(ee=Promise.resolve(pe.module.deactivate()).then(void 0,Ce=>(this.s.error(Ce),Promise.resolve(void 0))))}catch(Ce){this.s.error(`An error occurred when deactivating the extension '${B.value}':`),this.s.error(Ce)}try{(0,b.$Qc)(pe.subscriptions)}catch(Ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${B.value}':`),this.s.error(Ce)}return ee}async fb(B,ee){return this.f.remote.isRemote?this.C.$onWillActivateExtension(B.identifier):await this.C.$onWillActivateExtension(B.identifier),this.hb(B,ee).then(pe=>{const Ce=pe.activationTimes;return this.C.$onDidActivateExtension(B.identifier,Ce.codeLoadingTime,Ce.activateCallTime,Ce.activateResolvedTime,ee),this.gb(B,ee,"success",Ce),pe},pe=>{throw this.gb(B,ee,"failure"),pe})}gb(B,ee,pe,Ce){const oe=K(B,ee);this.z.$publicLog2("extensionActivationTimes",{...oe,...Ce||{},outcome:pe})}hb(B,ee){const pe=K(B,ee);this.z.$publicLog2("activatePlugin",pe);const Ce=this.wb(B);if(!Ce)return Promise.resolve(new y.$Qlc(y.$Nlc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${B.identifier.value}, startup: ${ee.startup}, activationEvent: '${ee.activationEvent}'${B.identifier.value!==ee.extensionId.value?`, root cause: ${ee.extensionId.value}`:""}`),this.s.flush();const oe=new y.$Olc(ee.startup);return Promise.all([this.xb(B,(0,R.$0g)(B.extensionLocation,Ce),oe),this.ib(B)]).then(se=>(O.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),Z.jb(this.s,B.identifier,se[0],se[1],oe))).then(se=>(O.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),se))}ib(B){const ee=this.Z.createLanguageModelAccessInformation(B),pe=new o.$Wlc(B,this.M),Ce=new o.$Vlc(B.identifier.value,!1,this.M),oe=new F.$6lc(B,this.N),se=B.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([pe.whenReady,Ce.whenReady,this.O.whenReady]).then(()=>{const G=this;let ne,me;const be=(0,f.$HG)(B,"ipc")?this.f.messagePorts?.get(i.$Rm.toKey(B.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:Ce,secrets:oe,subscriptions:[],get languageModelAccessInformation(){return ee},get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Re){return L.$kc(B.extensionLocation.fsPath,Re)},get storagePath(){return G.O.workspaceValue(B)?.fsPath},get globalStoragePath(){return G.O.globalValue(B).fsPath},get logPath(){return L.$kc(G.f.logsLocation.fsPath,B.identifier.value)},get logUri(){return E.URI.joinPath(G.f.logsLocation,B.identifier.value)},get storageUri(){return G.O.workspaceValue(B)},get globalStorageUri(){return G.O.globalValue(B)},get extensionMode(){return se},get extension(){return ne===void 0&&(ne=new ie(G,B.identifier,B,re,!1)),ne},get extensionRuntime(){return(0,f.$IG)(B,"extensionRuntime"),G.extensionRuntime},get environmentVariableCollection(){return G.u.getEnvironmentVariableCollection(B)},get messagePassingProtocol(){if(!me){if(!be)return;const Re=S.Event.buffer(S.Event.fromDOMEventEmitter(be,"message",fe=>fe.data));be.start(),me={onDidReceiveMessage:Re,postMessage:be.postMessage.bind(be)}}return me}})})}static jb(B,ee,pe,Ce,oe){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(B,ee,pe,Ce,oe).then(se=>new y.$Plc(!1,null,oe.build(),pe,se,Ce.subscriptions))}static kb(B,ee,pe,Ce,oe){if(typeof pe.activate=="function")try{oe.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const se=typeof global=="object"?global:self,re=pe.activate.apply(se,[Ce]);return oe.activateCallStop(),oe.activateResolveStart(),Promise.resolve(re).then(G=>(oe.activateResolveStop(),G))}catch(se){return Promise.reject(se)}else return Promise.resolve(pe)}lb(B,ee){this.bb(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:ee}).then(void 0,pe=>{this.s.error(pe)})}mb(B,ee=0){const Ce=Date.now();(0,T.$B)(()=>{for(let oe=ee;oe<B.length;oe+=1){const se=B[oe];for(const re of se.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-Ce>50){this.mb(B,oe);break}else this.lb(se,re)}})}nb(){this.C.$setPerformanceMarks(O.getMarks()),this.m.getConfigProvider().then(B=>{const ee=B.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(ee)this.mb(pe);else for(const Ce of pe)if(Ce.activationEvents)for(const oe of Ce.activationEvents)oe==="onStartupFinished"&&this.lb(Ce,oe)})}ob(){const B=this.ab("*",!0).then(void 0,se=>{this.s.error(se)});this.B(this.j.onDidChangeWorkspace(se=>this.pb(se.added)));const ee=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(ee),Ce=this.rb(),oe=Promise.all([Ce,B,pe]).then(()=>{});return Promise.race([oe,(0,N.$xh)(1e4)]).then(()=>{this.nb()}),oe}pb(B){return B.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ee=>this.qb(B,ee))).then(()=>{})}async qb(B,ee){if(this.isActivated(ee.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,Ce={logService:this.s,folders:B.map(se=>se.uri),forceUsingSearch:pe||!this.c.fsExists,exists:se=>this.c.fsExists(se.fsPath),checkExists:(se,re,G)=>this.y.$checkExists(se,re,G)},oe=await(0,C.$nwb)(Ce,ee);if(oe)return this.bb(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:oe.activationEvent}).then(void 0,se=>this.s.error(se))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(B){throw console.error(B),B}}async sb(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:ee}=this.f.environment;if(!B||!ee)throw new Error(d.localize(0,null));const pe=await this.xb(null,ee,new y.$Olc(!1));if(!pe||typeof pe.run!="function")throw new Error(d.localize(1,null,ee.toString()));return new Promise((Ce,oe)=>{const se=(ne,me)=>{ne?(T.$t&&this.s.error("Test runner called back with error",ne),oe(ne)):(T.$t&&(me?this.s.info(`Test runner called back with ${me} failures.`):this.s.info("Test runner called back with successful outcome.")),Ce(typeof me=="number"&&me>0?1:0))},re=(0,R.$Xg)(ee),G=pe.run(re,se);G&&G.then&&G.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),Ce(0)}).catch(ne=>{T.$t&&this.s.error("Test runner finished with error",ne),oe(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,N.$xh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(B,ee){return this.S[B]=ee,(0,b.$Tc)(()=>{delete this.S[B]})}async getRemoteExecServer(B){const{resolver:ee}=await this.ub(B);return ee?.resolveExecServer?.(B,{resolveAttempt:0})}async ub(B){const ee=B.indexOf("+");if(ee===-1)throw new t.$$M("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=B.substr(0,ee);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(B,ee){const pe=M.$ae.create(!1),Ce=()=>`[resolveAuthority(${(0,l.$Ll)(B)},${ee})][${pe.elapsed()}ms] `,oe=V=>this.s.info(`${Ce()}${V}`),se=V=>this.s.warn(`${Ce()}${V}`),re=(V,J=void 0)=>this.s.error(`${Ce()}${V}`,J),G=V=>{if(V instanceof t.$$M)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},ne=async V=>{oe(`activating resolver for ${V}...`);const{resolver:J,authorityPrefix:X}=await this.ub(V);if(!J)throw re(`no resolver for ${X}`),new t.$$M(`No remote extension installed to resolve ${X}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:X,remoteAuthority:V}},me=B.split(/@|%40/g).reverse();oe(`activating remote resolvers ${me.join(" -> ")}`);let be;try{be=await Promise.all(me.map(ne)).catch(async V=>{if(!(V instanceof t.$$M)||V._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return se(`resolving nested authorities failed: ${V.message}`),[await ne(B)]})}catch(V){return G(V)}const Re=new N.$Hh;Re.cancelAndSet(()=>oe("waiting..."),1e3);let fe,De;for(const[V,{authorityPrefix:J,resolver:X,remoteAuthority:he}]of be.entries())try{if(V===be.length-1)oe("invoking final resolve()..."),O.mark(`code/extHost/willResolveAuthority/${J}`),fe=await X.resolve(he,{resolveAttempt:ee,execServer:De}),O.mark(`code/extHost/didResolveAuthorityOK/${J}`),oe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(X,t.$0M.isManagedResolvedAuthority(fe)?fe:void 0));else{if(oe(`invoking resolveExecServer() for ${he}`),O.mark(`code/extHost/willResolveExecServer/${J}`),De=await X.resolveExecServer?.(he,{resolveAttempt:ee,execServer:De}),!De)throw new t.$$M(`Exec server was not available for ${he}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);O.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(we){return O.mark(`code/extHost/didResolveAuthorityError/${J}`),re("returned an error",we),Re.dispose(),G(we)}Re.dispose();const Ae={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};oe(`returned ${t.$0M.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let W;if(t.$0M.isManagedResolvedAuthority(fe)){const V=ee;this.Y.setFactory(V,fe.makeConnection),W={authority:B,connectTo:new l.$Il(V),connectionToken:fe.connectionToken}}else W={authority:B,connectTo:new l.$Jl(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:W,options:ze,tunnelInformation:Ae}}}async $getCanonicalURI(B,ee){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$Ll)(B)})`);const{resolver:pe}=await this.ub(B);if(!pe)return null;const Ce=E.URI.revive(ee);if(typeof pe.getCanonicalURI>"u")return Ce;const oe=await(0,N.$oh)(()=>pe.getCanonicalURI(Ce));return oe||Ce}async $startExtensionHost(B){B.toAdd.forEach(se=>se.extensionLocation=E.URI.revive(se.extensionLocation));const{globalRegistry:ee,myExtensions:pe}=q(this.I,this.L,this.J,B),Ce=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this.L.set(ee.getAllExtensionDescriptions()),this.J.set(pe),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.tb()}$activateByEvent(B,ee){return ee===1?this.D.wait().then(pe=>this.ab(B,!1)):this.G.wait().then(pe=>this.ab(B,!1))}async $activate(B,ee){return await this.G.wait(),this.J.getExtensionDescription(B)?(await this.bb(B,ee),!0):!1}async $deltaExtensions(B){B.toAdd.forEach(se=>se.extensionLocation=E.URI.revive(se.extensionLocation));const{globalRegistry:ee,myExtensions:pe}=q(this.I,this.L,this.J,B),Ce=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this.L.set(ee.getAllExtensionDescriptions()),this.J.set(pe),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){const ee=u.$Ge.alloc(B),pe=Math.random()%256;for(let Ce=0;Ce<B;Ce++)ee.writeUInt8(pe,Ce);return ee}async $updateRemoteConnectionData(B){this.X=B,this.a.fire()}};e.$_lc=te,e.$_lc=te=Z=Ke([We(0,r.$vi),We(1,e.$$lc),We(2,v.$qP),We(3,h.$wlc),We(4,p.$zlc),We(5,A.$3j),We(6,c.$GP),We(7,s.$Clc),We(8,D.$tDb),We(9,$.$Xlc),We(10,z.$8lc),We(11,U.$9lc),We(12,k.$2lc)],te);function q(_,B,ee,pe){_.addActivationEvents(pe.addActivationEvents);const Ce=new a.$L_b(_,B.getAllExtensionDescriptions());Ce.deltaExtensions(pe.toAdd,pe.toRemove);const oe=new i.$Sm(ee.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of pe.myToRemove)oe.delete(re);for(const re of pe.myToAdd)oe.add(re);const se=$e(Ce,oe);return{globalRegistry:Ce,myExtensions:se}}function K(_,B){return{id:_.identifier.value,name:_.name,extensionVersion:_.version,publisherDisplayName:_.publisher,activationEvents:_.activationEvents?_.activationEvents.join(","):null,isBuiltin:_.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}function Y(_){return _.getAllExtensionDescriptions().map(B=>B.identifier.value).join(",")}e.$amc=(0,r.$wi)("IExtHostExtensionService");class ie{#e;#t;#n;constructor(B,ee,pe,Ce,oe){this.#e=B,this.#t=ee,this.#n=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=L.$ic((0,R.$Xg)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=Ce,this.isFromDifferentExtensionHost=oe}get isActive(){return this.#e.isActivated(this.#n)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#n)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#n,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$bmc=ie;function $e(_,B){return _.getAllExtensionDescriptions().filter(ee=>B.has(ee.identifier))}class ue{constructor(B){this.a=B}setSearchTree(B){this.a=B}findSubstr(B){return this.a.findSubstr(B)}forEach(B){return this.a.forEach(B)}}e.$cmc=ue;class ve{constructor(B){this.a=new i.$Tm,this.addActivationEvents(B)}readActivationEvents(B){return this.a.get(B.identifier)??[]}addActivationEvents(B){for(const ee of Object.keys(B))this.a.set(ee,B[ee])}}}),define(ke[379],Se([1,0,59,2,6,45,26,25,20,28,5,49,11,14]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;let h=class{constructor(u,o,t,l,r,c,s){this.c=u,this.d=o,this.e=t,this.f=l,this.g=r,this.h=c,this.i=s,this.a=new Map,this.b=[]}async install(){this.j(),d.mark("code/extHost/willWaitForConfig");const u=await this.f.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new a(this.c,o,this.d,u,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,o,this.h.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(const o of u.nodeModuleName)this.a.set(o,u);else this.a.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this.b.push(o=>u.alternativeModuleName(o))}};e.$lnc=h,e.$lnc=h=Ke([We(2,A.$vi),We(3,R.$zlc),We(4,P.$amc),We(5,E.$GP),We(6,p.$3j)],h);let f=class{static{w=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(u){if(u.environment.appRoot&&w.a.size){const o=(0,y.$af)(this.c(u.environment.appRoot.fsPath)),t="[a-z0-9_.-]",l=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${r}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(u){if(!this.b)return;const o=this.b.exec(this.c(u));if(!o)return;const[,t,l,r]=o,c=w.a.get(l);if(c!==void 0)return console.warn(`${l} as been renamed to ${c}, please update your imports`),t+c+r}c(u){return u.replace(/\\/g,"/")}};f=w=Ke([We(0,E.$GP)],f);class a{constructor(u,o,t,l,r){this.c=u,this.d=o,this.e=t,this.f=l,this.g=r,this.nodeModuleName="vscode",this.a=new b.$Tm}load(u,o){const t=this.d.findSubstr(o);if(t){let l=this.a.get(t.identifier);return l||(l=this.c(t,this.e,this.f),this.a.set(t.identifier,l)),l}if(!this.b){let l="";this.d.forEach((r,c)=>l+=`	${c} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${l}`),this.b=this.c(N.$CG,this.e,this.f)}return this.b}}let n=class{constructor(u,o,t){this.e=u,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(O.$3M.MainThreadTelemetry);const l=t.getProxy(O.$3M.MainThreadWindow);this.c=(r,c)=>{const s=L.URI.parse(r);return c?this.g(r,c):s.scheme==="http"||s.scheme==="https"?l.$openUri(s,r,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this.f?l.$openUri(s,r,{}):this.g(r,c)}}load(u,o,t){const l=this.e.findSubstr(o);return l&&(this.a=l.identifier.value,this.h()),this.b=t(u),this.c}g(u,o){return this.i(),this.b(u,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ke([We(2,m.$qP)],n)}),define(ke[61],Se([1,0,46,3,17,52,5,73,72,49,8,44,307,45]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=e.$dmc=void 0,e.$dmc=(0,N.$wi)("IExtHostVariableResolverProvider");class w extends p.$sQ{constructor(a,n,i,u,o,t,l){function r(){if(i){const c=i.activeEditor();if(c)return c.document.uri;const s=u.tabGroups.all.find(v=>v.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof A.$QO||s.input instanceof A.$VO)return s.input.modified;if(s.input instanceof A.$PO||s.input instanceof A.$UO||s.input instanceof A.$SO)return s.input.uri}}}super({getFolderUri:c=>{const s=t.folders.filter(v=>v.name===c);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,s)=>o.getConfiguration(void 0,c).get(s),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=r();if(c)return O.$ic(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const c=r();if(c){const s=n.getWorkspaceFolder(c);if(s)return O.$ic(s.uri.fsPath)}}},getSelectedText:()=>{if(i){const c=i.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(i){const c=i.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>a.getExtension(c)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(R.env))}}let h=class extends L.$Vc{constructor(a,n,i,u,o){super(),this.b=a,this.c=n,this.g=i,this.h=u,this.j=o,this.a=new d.$V(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,t,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$emc=h,e.$emc=h=Ke([We(0,E.$amc),We(1,P.$wlc),We(2,b.$BP),We(3,y.$zlc),We(4,m.$Llc)],h)}),define(ke[96],Se([1,0,7,4,2,25,5,6,72,49,20,8,44,144,299,45,61,3,50,34,16]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=e.$hmc=e.$gmc=e.$fmc=void 0,e.$fmc=(0,N.$wi)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(g,D,$,k,S,C,I){this.N=D,this.O=$,this.P=k,this.Q=S,this.R=C,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new L.$ee,this.o=new L.$ee,this.q=new L.$ee,this.w=new L.$ee,this.l=g.getProxy(b.$3M.MainThreadDebugService),this.A=new L.$ee,this.C=new L.$ee,this.y=new l(this.l),this.z=new Map,this.O.getExtensionRegistry().then(F=>{F.onDidChange(j=>{this.V(F)}),this.V(F)})}async $getVisualizerTreeItem(g,D){const $=this.W(D);if(!$)return;const k=await this.H.get(g)?.getTreeItem?.($);return k?this.U(g,k):void 0}registerDebugVisualizationTree(g,D,$){const k=R.$Rm.toKey(g.identifier),S=this.jb(k,D);if(this.G.has(S))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(S,$),this.l.$registerDebugVisualizerTree(S,!!$.editItem),(0,a.$Tc)(()=>{this.l.$unregisterDebugVisualizerTree(S),this.H.delete(D)})}async $getVisualizerTreeItemChildren(g,D){const $=this.J.get(D)?.item;return $?(await this.H.get(g)?.getChildren?.($))?.map(S=>this.U(g,S))||[]:[]}async $editVisualizerTreeItem(g,D){const $=this.J.get(g);if(!$)return;const k=await this.H.get($.provider)?.editItem?.($.item,D);return this.U($.provider,k||$.item)}$disposeVisualizedTree(g){const D=this.J.get(g);if(!D)return;const $=[D.children];for(const k of $)if(k)for(const S of k)$.push(this.J.get(S)?.children),this.J.delete(S)}U(g,D){let $=this.I.get(D);return $||($=this.F++,this.I.set(D,$),this.J.set($,{provider:g,item:D})),u.DebugTreeItem.from(D,$)}asDebugSourceUri(g,D){const $=g;if(typeof $.sourceReference=="number"&&$.sourceReference>0){let k=`debug:${encodeURIComponent($.path||"")}`,S="?";return D&&(k+=`${S}session=${encodeURIComponent(D.id)}`,S="&"),k+=`${S}ref=${$.sourceReference}`,O.URI.parse(k)}else{if($.path)return O.URI.file($.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(g){const D=[];for(const $ of g.getAllExtensionDescriptions())if($.contributes){const k=$.contributes.debuggers;if(k&&k.length>0)for(const S of k)(0,w.$mH)(S)&&D.push(S.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const g=[];return this.z.forEach(D=>g.push(D)),g}async $resolveDebugVisualizer(g,D){const $=this.L.get(g);if(!$)throw new Error(`No debug visualizer found with id '${g}'`);let{v:k,provider:S,extensionId:C}=$;if(k.visualization||(k=await S.resolveDebugVisualization?.(k,D)||k,$.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${S}'`);return this.kb(C,k.visualization)}async $executeDebugVisualizerCommand(g){const D=this.L.get(g);if(!D)throw new Error(`No debug visualizer found with id '${g}'`);const $=D.v.visualization;$&&"command"in $&&this.S.executeCommand($.command,...$.arguments||[])}W(g){const D=this.m.get(g.sessionId);return D&&{session:D.api,variable:g.variable,containerId:g.containerId,frameId:g.frameId,threadId:g.threadId}}async $provideDebugVisualizers(g,D,$,k){const S=this.W($),C=this.jb(g,D),I=this.G.get(C);if(!S||!I)return[];const F=await I.provideDebugVisualization(S,k);return F?F.map(j=>{const z=++this.M;this.L.set(z,{v:j,provider:I,extensionId:g});const M=j.iconPath?this.lb(j.iconPath):void 0;return{id:z,name:j.name,iconClass:M?.iconClass,iconPath:M?.iconPath,visualization:this.kb(g,j.visualization)}}):[]}$disposeDebugVisualizers(g){for(const D of g)this.L.delete(D)}registerDebugVisualizationProvider(g,D,$){if(!g.contributes?.debugVisualizers?.some(C=>C.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const k=R.$Rm.toKey(g.identifier),S=this.jb(k,D);if(this.G.has(S))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(S,$),this.l.$registerDebugVisualizer(k,D),(0,a.$Tc)(()=>{this.l.$unregisterDebugVisualizer(k,D),this.G.delete(D)})}addBreakpoints(g){const D=g.filter(S=>{const C=S.id;return this.z.has(C)?!1:(this.z.set(C,S),!0)});this.gb(D,[],[]);const $=[],k=new Map;for(const S of D)if(S instanceof P.$7N){let C=k.get(S.location.uri.toString());C||(C={type:"sourceMulti",uri:S.location.uri,lines:[]},k.set(S.location.uri.toString(),C),$.push(C)),C.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character,mode:S.mode})}else S instanceof P.$8N&&$.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName,mode:S.mode});return this.l.$registerBreakpoints($)}removeBreakpoints(g){const D=g.filter(C=>this.z.delete(C.id));this.gb([],D,[]);const $=D.filter(C=>C instanceof P.$7N).map(C=>C.id),k=D.filter(C=>C instanceof P.$8N).map(C=>C.id),S=D.filter(C=>C instanceof P.$9N).map(C=>C.id);return this.l.$unregisterBreakpoints($,k,S)}startDebugging(g,D,$){return this.l.$startDebugging(g?g.uri:void 0,D,{parentSessionID:$.parentSession?$.parentSession.id:void 0,lifecycleManagedByParent:$.lifecycleManagedByParent,repl:$.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:$.noDebug,compact:$.compact,suppressSaveBeforeStart:$.suppressSaveBeforeStart,suppressDebugStatusbar:$.suppressDebugStatusbar??$.debugUI?.simple,suppressDebugToolbar:$.suppressDebugToolbar??$.debugUI?.simple,suppressDebugView:$.suppressDebugView??$.debugUI?.simple})}stopDebugging(g){return this.l.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,D,$){if(!D)return new P.$5M(()=>{});const k=this.d++;return this.f.push({type:g,handle:k,provider:D}),this.l.$registerDebugConfigurationProvider(g,$,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,k),new P.$5M(()=>{this.f=this.f.filter(S=>S.provider!==D),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(g,D,$){if(!$)return new P.$5M(()=>{});if(!this.cb(g,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:D,handle:k,factory:$}),this.l.$registerDebugAdapterDescriptorFactory(D,k),new P.$5M(()=>{this.h=this.h.filter(S=>S.factory!==$),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(g,D){if(!D)return new P.$5M(()=>{});const $=this.j++;return this.k.push({type:g,handle:$,factory:D}),new P.$5M(()=>{this.k=this.k.filter(k=>k.factory!==D)})}async $runInTerminal(g,D){return Promise.resolve(void 0)}async $substituteVariables(g,D){let $;const k=await this.ib(g);return k&&($={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync($,D)}X(g,D){if(g.type==="implementation")return new c(g.implementation)}Y(){}async $startDASession(g,D){const $=this,k=await this.hb(D);return this.eb(this.$(k.type),k).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const C=this.Z(S),I=this.X(C,k);if(!I)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const F=I;return this.D.set(g,F),this.db(k).then(j=>(j&&this.E.set(g,j),F.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const M=z,T={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const U=await this.K.sign(M.arguments.value);T.body={signature:U},F.sendResponse(T)}else throw new Error("no signer")}catch(U){T.success=!1,T.message=U.message,F.sendResponse(T)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(z),z=(0,w.$rH)(z,!0),$.l.$acceptDAMessage(g,z)}),F.onError(z=>{j&&j.onError&&j.onError(z),this.l.$acceptDAError(g,z.name,z.message,z.stack)}),F.onExit(z=>{j&&j.onExit&&j.onExit(z??void 0,void 0),this.l.$acceptDAExit(g,z??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),F.startSession()))})}$sendDAMessage(g,D){D=(0,w.$qH)(D,!1);const $=this.E.get(g);$&&$.onWillReceiveMessage&&$.onWillReceiveMessage(D),this.D.get(g)?.sendMessage(D)}$stopDASession(g){const D=this.E.get(g);this.E.delete(g),D&&D.onWillStopSession&&D.onWillStopSession();const $=this.D.get(g);return this.D.delete(g),$?$.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const D=[],$=[],k=[];if(g.added)for(const S of g.added){const C=S.id;if(C&&!this.z.has(C)){let I;if(S.type==="function")I=new P.$8N(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode);else if(S.type==="data")I=new P.$9N(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage,S.mode);else{const F=O.URI.revive(S.uri);I=new P.$7N(new P.$eN(F,new P.$6M(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode)}(0,P.$5N)(I,C),this.z.set(C,I),D.push(I)}}if(g.removed)for(const S of g.removed){const C=this.z.get(S);C&&(this.z.delete(S),$.push(C))}if(g.changed){for(const S of g.changed)if(S.id){const C=this.z.get(S.id);if(C){if(C instanceof P.$8N&&S.type==="function"){const I=C;I.enabled=S.enabled,I.condition=S.condition,I.hitCondition=S.hitCondition,I.logMessage=S.logMessage,I.functionName=S.functionName}else if(C instanceof P.$7N&&S.type==="source"){const I=C;I.enabled=S.enabled,I.condition=S.condition,I.hitCondition=S.hitCondition,I.logMessage=S.logMessage,I.location=new P.$eN(O.URI.revive(S.uri),new P.$6M(S.line,S.character))}k.push(C)}}}this.gb(D,$,k)}async $acceptStackFrameFocus(g){let D;if(g){const $=await this.hb(g.sessionId);g.kind==="thread"?D=new P.$cO($.api,g.threadId):D=new P.$bO($.api,g.threadId,g.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(g,D,$){return(0,d.$oh)(async()=>{const k=this.bb(g);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.ib(D);return k.provideDebugConfigurations(S,$)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(g,D,$,k){return(0,d.$oh)(async()=>{const S=this.bb(g);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(D);return S.resolveDebugConfiguration(C,$,k)})}$resolveDebugConfigurationWithSubstitutedVariables(g,D,$,k){return(0,d.$oh)(async()=>{const S=this.bb(g);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(D);return S.resolveDebugConfigurationWithSubstitutedVariables(C,$,k)})}async $provideDebugAdapter(g,D){const $=this.ab(g);if(!$)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(D);return this.eb($,k).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(S)})}async $acceptDebugSessionStarted(g){const D=await this.hb(g);this.n.fire(D.api)}async $acceptDebugSessionTerminated(g){const D=await this.hb(g);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(g){this.u=g?await this.hb(g):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(g,D){(await this.hb(g))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(g,D){const k={session:(await this.hb(g)).api,event:D.event,body:D.body};this.w.fire(k)}Z(g){if(g instanceof P.$0N)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof P.$$N)return{type:"server",port:g.port,host:g.host};if(g instanceof P.$_N)return{type:"pipeServer",path:g.path};if(g instanceof P.$aO)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}$(g){const D=this.h.filter($=>$.type===g);if(D.length>0)return D[0].factory}ab(g){const D=this.h.filter($=>$.handle===g);if(D.length>0)return D[0].factory}bb(g){const D=this.f.filter($=>$.handle===g);if(D.length>0)return D[0].provider}cb(g,D){if(g.contributes){const $=g.contributes.debuggers;if($&&$.length>0){for(const k of $)if(k.label&&k.type&&k.type===D)return!0}}return!1}db(g){const $=g.configuration.type,k=this.k.filter(S=>S.type===$||S.type==="*").map(S=>(0,d.$oh)(()=>S.factory.createDebugAdapterTracker(g.api)).then(C=>C,C=>null));return Promise.race([Promise.all(k).then(S=>{const C=S.filter(I=>!!I);if(C.length>0)return new r(C)}),new Promise(S=>setTimeout(()=>S(void 0),1e3))]).catch(S=>{})}async eb(g,D){const $=D.configuration.debugServer;if(typeof $=="number")return Promise.resolve(new P.$$N($));if(g){const S=await this.O.getExtensionRegistry();return(0,d.$oh)(()=>g.createDebugAdapterDescriptor(D.api,this.fb(D,S))).then(C=>{if(C)return C})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,k))}fb(g,D){}gb(g,D,$){(g.length>0||D.length>0||$.length>0)&&this.A.fire(Object.freeze({added:g,removed:D,changed:$}))}async hb(g){if(g)if(typeof g=="string"){const D=this.m.get(g);if(D)return D}else{let D=this.m.get(g.id);if(!D){const $=await this.ib(g.folderUri),k=g.parent?this.m.get(g.parent):void 0;D=new t(this.l,g.id,g.type,g.name,$,g.configuration,k?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(g){if(g){const D=O.URI.revive(g);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(g,D){return`${g}\0${D}`}kb(g,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${g}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(g){const D=this.mb(g);let $,k;return"id"in D?k=n.ThemeIcon.asClassName(D):$=D,{iconPath:$,iconClass:k}}mb(g){if(g instanceof P.$2N)return{id:g.id};const D=typeof g=="object"&&"dark"in g?g.dark:g,$=typeof g=="object"&&"light"in g?g.light:g;return{dark:typeof D=="string"?O.URI.file(D):D,light:typeof $=="string"?O.URI.file($):$}}};e.$gmc=o,e.$gmc=o=Ke([We(0,A.$qP),We(1,p.$wlc),We(2,E.$amc),We(3,h.$zlc),We(4,m.$Llc),We(5,f.$dmc),We(6,i.$MP)],o);class t{constructor(g,D,$,k,S,C,I){this.f=g,this.g=D,this.h=$,this.j=k,this.k=S,this.l=C,this.m=I}get api(){const g=this;return this.d??=Object.freeze({id:g.g,type:g.h,get name(){return g.j},set name(D){g.j=D,g.f.$setDebugSessionName(g.g,D)},parentSession:g.m,workspaceFolder:g.k,configuration:g.l,customRequest(D,$){return g.f.$customDebugAdapterRequest(g.g,D,$)},getDebugProtocolBreakpoint(D){return g.f.$getDebugProtocolBreakpoint(g.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(g){this.j=g}get configuration(){return this.l}}e.$hmc=t;class l{constructor(g){this.value=Object.freeze({append(D){g.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$imc=l;class r{constructor(g){this.d=g}onWillStartSession(){this.d.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(g):void 0)}onWillStopSession(){this.d.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.d.forEach(D=>D.onError?D.onError(g):void 0)}onExit(g,D){this.d.forEach($=>$.onExit?$.onExit(g,D):void 0)}}class c extends y.$Nrb{constructor(g){super(),this.h=g,g.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.h.handleMessage(g)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends o{constructor(g,D,$,k,S,C,I){super(g,D,$,k,S,C,I)}};e.$jmc=s,e.$jmc=s=Ke([We(0,A.$qP),We(1,p.$wlc),We(2,E.$amc),We(3,h.$zlc),We(4,m.$Llc),We(5,f.$dmc),We(6,i.$MP)],s)}),define(ke[380],Se([1,0,13,59,2,6,327,11,85,107,28,263,20,68,49,90]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=e.$mnc=void 0;class f{static async installEarlyHandler(i){Error.stackTraceLimit=100;const u=i.get(b.$3j),t=i.get(p.$qP).getProxy(R.$3M.MainThreadErrors);d.setUnexpectedErrorHandler(l=>{u.error(l);const r=d.$3(l);t.$onUnexpectedError(r)})}static async installFullHandler(i){const u=i.get(b.$3j),o=i.get(p.$qP),t=i.get(w.$amc),l=i.get(h.$KP),r=o.getProxy(R.$3M.MainThreadExtensionService),c=o.getProxy(R.$3M.MainThreadErrors),s=await t.getExtensionPathIndex(),v=new WeakMap;function g(k,S){if(v.has(k))return v.get(k).stack;let C="",I,F;for(const z of S)C+=`
	at ${z.toString()}`,F=z.getFileName(),!I&&F&&(I=s.findSubstr(O.URI.file(F)));const j=`${k.name||"Error"}: ${k.message||""}${C}`;return v.set(k,{extensionIdentifier:I?.identifier,stack:j}),j}const D=Symbol("prepareStackTrace wrapped");let $=g;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(k){if(k===g||!k||k[D]){$=k||g;return}$=function(S,C){return g(S,C),k.call(Error,S,C)},Object.assign($,{[D]:!0})}}),d.setUnexpectedErrorHandler(k=>{u.error(k);const S=d.$3(k),C=v.get(k);if(!C?.extensionIdentifier){c.$onUnexpectedError(S);return}r.$onExtensionRuntimeError(C.extensionIdentifier,S);const I=l.onExtensionError(C.extensionIdentifier,k);u.trace("forwarded error to extension?",I,C)})}}e.$mnc=f;class a{constructor(i,u,o,t,l){this.a=o,this.b=new N.$T_b(i,null,t),u=a.e(u,this.b);const r=new E.$ui(...(0,m.$ys)());r.set(A.$GP,{_serviceBrand:void 0,...u,messagePorts:l}),r.set(p.$qP,new p.$rP(this.b)),r.set(y.$tlc,new y.$ulc(t)),r.set(w.$$lc,o);const c=new P.$cr(r,!0);c.invokeFunction(f.installEarlyHandler),this.d=c.invokeFunction(s=>s.get(b.$3j)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",u),this.c=c.invokeFunction(s=>s.get(w.$amc)),this.c.initialize(),c.invokeFunction(f.installFullHandler)}async asBrowserUri(i){const u=this.b.getProxy(R.$3M.MainThreadExtensionService);return O.URI.revive(await u.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,u){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=O.URI.revive(u.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=O.URI.revive(u.transformIncomingURIs(i.environment.appRoot));const o=i.environment.extensionDevelopmentLocationURI;return o&&(i.environment.extensionDevelopmentLocationURI=o.map(t=>O.URI.revive(u.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=O.URI.revive(u.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=O.URI.revive(u.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=O.URI.revive(u.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=O.URI.revive(u.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=O.URI.revive(u.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=O.URI.revive(u.transformIncomingURIs(i.logsLocation)),i.workspace=u.transformIncomingURIs(i.workspace),i}}e.$nnc=a}),define(ke[381],Se([1,0,7,12,236,256,141,96,72,49,20,43,8,61,44,300,301,45,34]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=void 0;let i=class extends b.$gmc{constructor(r,c,s,v,g,D,$,k){super(r,c,s,v,D,$,k),this.pb=g,this.nb=new t}X(r,c){switch(r.type){case"server":return new h.$snc(r);case"pipeServer":return new h.$tnc(r);case"executable":return new h.$unc(r,c.type)}return super.X(r,c)}fb(r,c){const s=h.$unc.platformAdapterExecutable(c.getAllExtensionDescriptions(),r.type);if(s)return new p.$0N(s.command,s.args,s.options)}Y(){return new N.$Hdc}async $runInTerminal(r,c){if(r.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(z=>{this.nb.onTerminalClosed(z)}));const s=await this.P.getConfigProvider(),v=this.pb.getDefaultShell(!0),g=this.pb.getDefaultShellArgs(!0),D=r.title||O.localize(0,null),$=JSON.stringify({shell:v,shellArgs:g});let k=await this.nb.checkout($,D),S,C=!1;if(k)S=r.cwd;else{const z={shellPath:v,shellArgs:g,cwd:r.cwd,name:D,iconPath:new p.$2N("debug")};C=!0,k=this.pb.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(k,$)}k.show(!0);const I=await k.processId;C?await new Promise(z=>setTimeout(z,1e3)):(k.state.isInteractedWith&&k.sendText(""),s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0||v.indexOf("cmd.exe")>=0?k.sendText("cls"):v.indexOf("bash")>=0?k.sendText("clear"):L.$i?k.sendText("cls"):k.sendText("clear")));const F=(0,f.$wnc)(v,r.args,!!r.argsCanBeInterpretedByShell,S,r.env);k.sendText(F);const j=this.onDidTerminateDebugSession(z=>{z.id===c&&(this.nb.free(k),j.dispose())});return I}else if(r.kind==="external")return o(r,await this.P.getConfigProvider());return super.$runInTerminal(r,c)}};e.$xnc=i,e.$xnc=i=Ke([We(0,A.$qP),We(1,w.$wlc),We(2,E.$amc),We(3,a.$zlc),We(4,P.$Xlc),We(5,m.$Llc),We(6,y.$dmc),We(7,n.$MP)],i);let u;function o(l,r){if(!u)if(L.$i)u=new R.$scc;else if(L.$j)u=new R.$tcc;else if(L.$k)u=new R.$ucc;else throw new Error("external terminals not supported on this platform");const c=r.getConfiguration("terminal");return u.runInTerminal(l.title,l.cwd,l.args,l.env||{},c.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,c,s=!1){const g=[...this.b.entries()].map(([D,$])=>(0,d.$jh)(async k=>{if(D.name!==c||$.lastUsedAt!==-1&&await(0,f.$vnc)(await D.processId))return null;const S=Date.now();return $.lastUsedAt+t.a>S||k.isCancellationRequested?null:$.config!==r?(s&&D.dispose(),null):($.lastUsedAt=S,D)}));return await(0,d.$Bh)(g,D=>!!D)}insert(r,c){this.b.set(r,{lastUsedAt:Date.now(),config:c})}free(r){const c=this.b.get(r);c&&(c.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(ke[382],Se([1,0,17,2,105,44,73,45,42,43,20,28,95,15,11,91,23,64,61]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;let i=class extends p.$2mc{constructor(o,t,l,r,c,s,v,g,D){super(o,t,l,r,c,s,v,g),this.C=l,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const l=t;if(!t.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const r=p.TaskHandleDTO.from(l,this.C),c=await this.a.$getTaskExecution(r);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.z(c,t);return this.a.$executeTask(r).catch(()=>{}),s}else{const r=p.TaskDTO.from(t,o);if(r===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(r.execution)&&await this.y(r,t,!1);const c=await this.z(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),c}}v(o,t,l,r){const c=[];if(r)for(const s of r){this.A(s,l),(!s.definition||!o[s.definition.type])&&this.f.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const v=p.TaskDTO.from(s,l.extension);v&&(c.push(v),p.CustomExecutionDTO.is(v.execution)&&t.push(this.y(v,s,!0)))}return{tasks:c,extension:l.extension}}async w(o){return o}async G(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const l=L.URI.file((0,a.homedir)());t=new m.$Qi({uri:l,name:f.$7g(l),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const l=L.URI.revive(o),r={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(l),s=await this.b.getWorkspaceFolders2()??[],v=await this.D.getResolver(),g=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(s);for(const D of t.variables)r.variables[D]=await v.resolveAsync(g,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(d.$uc);for(let $=0;$<D.length;$++)D[$]=await v.resolveAsync(g,D[$])}r.process=await O.win32.findExecutable(await v.resolveAsync(g,t.process.name),t.process.cwd!==void 0?await v.resolveAsync(g,t.process.cwd):void 0,D)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,l){return O.win32.findExecutable(o,t,l)}};e.$pnc=i,e.$pnc=i=Ke([We(0,A.$qP),We(1,P.$GP),We(2,R.$wlc),We(3,N.$BP),We(4,b.$zlc),We(5,E.$Xlc),We(6,w.$3j),We(7,h.$alc),We(8,n.$dmc)],i)}),define(ke[383],Se([1,0,64,61]),function(le,e,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=void 0;class O extends L.$emc{m(){return(0,d.homedir)()}}e.$8nc=O}),define(ke[160],Se([1,0,19,7,22,47,15,17,23,2,37]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=e.$ymc=e.$xmc=void 0,e.$zmc=h;class P{constructor(n,i,u){this.d=n,this.e=i,this.f=u,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const u=this.g.folderQueries||[],o=new O.$pe(i);return new Promise((t,l)=>{this.a=new y(n);let r=!1;const c=(s,v)=>{if(!r&&!this.b){const g=this.h(s);h(s)&&typeof this.g.maxResults=="number"&&this.c+g>this.g.maxResults&&(this.b=!0,r=!0,o.cancel(),s=this.j(s,this.g.maxResults-this.c));const D=this.h(s);this.c+=D,(D>0||!h(s))&&this.a.add(s,v)}};Promise.all(u.map((s,v)=>this.k(s,g=>c(g,v),o.token))).then(s=>{o.dispose(),this.a.flush();const v=s.some(g=>!!g&&!!g.limitHit);t({limitHit:this.b||v,messages:(0,d.$Rb)(s.map(g=>g?.message?Array.isArray(g.message)?g.message:[g.message]:[])),stats:{type:this.f}})},s=>{o.dispose();const v=(0,R.$hj)(s);l(new Error(v))})})}h(n){return h(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const u=Array.isArray(n.ranges)?n.ranges:[n.ranges],o=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:u.slice(0,i),preview:{matches:o.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,u){const o=new A.$xL(this.g,n),t=[],l={report:s=>{if(!this.l(s))return;const v=n.folder.scheme===N.Schemas.file?(0,A.$yL)(()=>this.e.readdir(m.$9g(s.uri))):void 0,g=m.$_g(n.folder,s.uri);if(g){const D=o.includedInQuery(g,b.$oc(g),v);(0,L.$ih)(D)?t.push(D.then($=>{$&&i(s)})):D&&i(s)}}},r=this.n(n);let c;return this.d.query.type===3?c=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,r,l,u):c=await this.d.provider.provideTextSearchResults(p(this.d.query.contentPattern),r,l,u),t.length&&await Promise.all(t),c}l(n){if(h(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$wL)(this.g.includePattern,n.includePattern),u=(0,A.$wL)(this.g.excludePattern,n.excludePattern),o={folder:E.URI.from(n.folder),excludes:u,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(o.usePCRE2=this.g.usePCRE2),o}}e.$xmc=P;function p(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class y{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new f(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!m.$3g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(w(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$ymc=y;function w(a){return h(a)?{preview:{matches:(0,d.$2b)(a.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:a.preview.text},ranges:(0,d.$2b)(a.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function h(a){return!!a.preview}class f{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Amc=f}),define(ke[97],Se([1,0,3,6,5,376,20,68,11,2,160]),function(le,e,d,L,O,R,N,b,m,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=e.$Bmc=void 0,e.$Dmc=p,e.$Bmc=(0,O.$wi)("IExtHostSearch");let P=class{constructor(h,f,a){this.n=h,this.o=f,this.q=a,this.c=this.n.getProxy(L.$3M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$wmc}s(h){return this.o.transformOutgoingScheme(h)}registerTextSearchProvider(h,f){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const a=this.d++;return this.e.set(a,f),this.c.$registerTextSearchProvider(a,this.s(h)),(0,d.$Tc)(()=>{this.g.delete(h),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(h,f){if(this.i.has(h))throw new Error(`an AI text search provider for the scheme '${h}'is already registered`);this.i.add(h);const a=this.d++;return this.h.set(a,f),this.c.$registerAITextSearchProvider(a,this.s(h)),(0,d.$Tc)(()=>{this.i.delete(h),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(h,f){if(this.k.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.k.add(h);const a=this.d++;return this.j.set(a,f),this.c.$registerFileSearchProvider(a,this.s(h)),(0,d.$Tc)(()=>{this.k.delete(h),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(h,f,a,n){const i=p(a),u=this.j.get(h);if(u)return this.l.fileSearch(i,u,o=>{this.c.$handleFileMatch(h,f,o.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+h)}async doInternalFileSearchWithCustomCallback(h,f,a){return{messages:[]}}$clearCache(h){return this.l.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,f,a,n){const i=this.e.get(h);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${h}`);const u=p(a);return this.t(u,i).search(t=>this.c.$handleTextMatch(h,f,t),n)}$provideAITextSearchResults(h,f,a,n){const i=this.h.get(h);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${h}`);const u=p(a);return this.v(u,i).search(t=>this.c.$handleTextMatch(h,f,t),n)}$enableExtensionHostSearch(){}t(h,f){return new A.$xmc({query:h,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(h,f){return new A.$xmc({query:h,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$Cmc=P,e.$Cmc=P=Ke([We(0,N.$qP),We(1,b.$tlc),We(2,m.$3j)],P);function p(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(y),extraFileResources:w.extraFileResources&&w.extraFileResources.map(h=>E.URI.revive(h))}}function y(w){return{...w,folder:E.URI.revive(w.folder)}}}),define(ke[384],Se([1,0,22,13,4,3,15,41,2,136,203,184,80,25,33,11,86,87,283,6,329,355,91,121,333,334,335,316,305,34,336,45,337,96,152,338,318,330,339,340,73,72,331,49,341,70,342,60,28,356,357,319,343,122,344,116,117,320,375,346,288,347,358,348,158,321,349,350,351,20,352,97,118,353,322,354,119,93,95,90,43,156,359,360,332,361,362,71,16,8,323,68,324,92,363,364,151,44,298,115,26,94]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u,o,t,l,r,c,s,v,g,D,$,k,S,C,I,F,j,z,M,T,U,Z,te,q,K,Y,ie,$e,ue,ve,_,B,ee,pe,Ce,oe,se,re,G,ne,me,be,Re,fe,De,Ae,ze,W,V,J,X,he,we,Fe,qe,Je,rt,tt,nt,st,Pe,Be,He,Le,Xe,ae,ce,Ie,Ge,Oe,ot,ut,vt,Rt,Ut,tn,Zt,kt,Xt,Yt,et,an){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=Gt;function Gt(ft){const $t=ft.get(ue.$GP),xt=ft.get($e.$elc),Kt=ft.get(Y.$Blc),Ft=ft.get(q.$amc),gt=ft.get(kt.$wlc),Wt=ft.get(st.$KP),_t=ft.get(k.$zlc),Vt=ft.get(ut.$tlc),xe=ft.get(J.$qP),ln=ft.get(rt.$Ulc),Jt=ft.get(tt.$Clc),qt=ft.get(h.$4j),pt=ft.get(h.$3j),jt=ft.get(Ie.$tDb),Nt=ft.get(t.$alc),Lt=ft.get(Zt.$gnc),nn=ft.get(we.$5lc),Qt=ft.get(Z.$Llc),rn=ft.get(se.$9lc),It=ft.get(l.$klc),Mt=ft.get(pe.$2lc);xe.set(i.$4M.ExtHostFileSystemInfo,xt),xe.set(i.$4M.ExtHostLogLevelServiceShape,qt),xe.set(i.$4M.ExtHostWorkspace,gt),xe.set(i.$4M.ExtHostConfiguration,_t),xe.set(i.$4M.ExtHostExtensionService,Ft),xe.set(i.$4M.ExtHostStorage,ln),xe.set(i.$4M.ExtHostTunnelService,jt),xe.set(i.$4M.ExtHostWindow,Lt),xe.set(i.$4M.ExtHostSecretState,nn),xe.set(i.$4M.ExtHostTelemetry,Wt),xe.set(i.$4M.ExtHostEditorTabs,Qt),xe.set(i.$4M.ExtHostManagedSockets,rn),xe.set(i.$4M.ExtHostAuthentication,It),xe.set(i.$4M.ExtHostChatProvider,Mt);const Ot=xe.set(i.$4M.ExtHostDecorations,ft.get(I.$lmc)),Ct=xe.set(i.$4M.ExtHostDocumentsAndEditors,ft.get(U.$BP)),mt=xe.set(i.$4M.ExtHostCommands,ft.get(D.$MP)),St=xe.set(i.$4M.ExtHostTerminalService,ft.get(Pe.$Xlc)),cn=xe.set(i.$4M.ExtHostTerminalShellIntegration,ft.get(Be.$5mc)),Dt=xe.set(i.$4M.ExtHostDebugService,ft.get(C.$fmc)),gn=xe.set(i.$4M.ExtHostSearch,ft.get(he.$Bmc)),sn=xe.set(i.$4M.ExtHostTask,ft.get(nt.$4mc)),pn=xe.set(i.$4M.ExtHostOutputService,ft.get(De.$Qmc)),hn=xe.set(i.$4M.ExtHostLocalization,ft.get(oe.$8lc)),wn=xe.set(i.$4M.ExtHostUrls,new vt.$dnc(xe)),Pt=xe.set(i.$4M.ExtHostDocuments,new T.$hlc(xe,Ct)),yn=xe.set(i.$4M.ExtHostDocumentContentProviders,new z.$nmc(xe,Ct,pt)),on=xe.set(i.$4M.ExtHostDocumentSaveParticipant,new M.$omc(pt,Pt,xe.getProxy(i.$3M.MainThreadBulkEdits))),Ne=xe.set(i.$4M.ExtHostNotebook,new G.$Emc(xe,mt,Ct,Pt,Kt,gn)),je=xe.set(i.$4M.ExtHostNotebookDocuments,new me.$Kmc(Ne)),ye=xe.set(i.$4M.ExtHostNotebookEditors,new be.$Lmc(pt,Ne)),x=xe.set(i.$4M.ExtHostNotebookKernels,new Re.$Mmc(xe,$t,Ne,mt,pt)),Te=xe.set(i.$4M.ExtHostNotebookRenderers,new fe.$Omc(xe,Ne)),Qe=xe.set(i.$4M.ExtHostNotebookDocumentSaveParticipant,new ne.$Jmc(pt,Ne,xe.getProxy(i.$3M.MainThreadBulkEdits))),_e=xe.set(i.$4M.ExtHostEditors,new Le.$qlc(xe,Ct)),Ze=xe.set(i.$4M.ExtHostTreeViews,new ce.$bnc(xe.getProxy(i.$3M.MainThreadTreeViews),mt,pt)),ht=xe.set(i.$4M.ExtHostEditorInsets,new g.$rlc(xe.getProxy(i.$3M.MainThreadEditorInsets),_e,$t.remote)),Et=xe.set(i.$4M.ExtHostDiagnostics,new F.$glc(xe,pt,xt,Ct)),zt=xe.set(i.$4M.ExtHostLanguages,new Ce.$Hmc(xe,Pt,mt.converter,Vt)),lt=xe.set(i.$4M.ExtHostLanguageFeatures,new ee.$ilc(xe,Vt,Pt,mt,Et,pt,Nt,Wt)),Tt=xe.set(i.$4M.ExtHostFileSystem,new K.$qmc(xe,lt)),Bt=xe.set(i.$4M.ExtHostFileSystemEventService,new ie.$rmc(xe,pt,Ct)),En=xe.set(i.$4M.ExtHostQuickOpen,(0,V.$Umc)(xe,gt,mt)),Dn=xe.set(i.$4M.ExtHostSCM,new X.$Wmc(xe,mt,Pt,pt)),Kn=xe.set(i.$4M.ExtHostQuickDiff,new W.$Tmc(xe,Vt)),Ln=xe.set(i.$4M.ExtHostShare,new Fe.$Xmc(xe,Vt)),Mn=xe.set(i.$4M.ExtHostComments,(0,$.$slc)(xe,mt,Pt)),Pn=xe.set(i.$4M.ExtHostProgress,new ze.$Smc(xe.getProxy(i.$3M.MainThreadProgress))),Tn=xe.set(i.$4M.ExtHostLabelService,new B.$Gmc(xe)),Fn=xe.set(i.$4M.ExtHostTheming,new Xe.$$mc(xe)),Jn=xe.set(i.$4M.ExtHostTimeline,new ae.$anc(xe,mt)),jn=xe.set(i.$4M.ExtHostWebviews,new Rt.$Glc(xe,$t.remote,gt,pt,Nt)),Cn=xe.set(i.$4M.ExtHostWebviewPanels,new Ut.$Jlc(xe,jn,gt)),zn=xe.set(i.$4M.ExtHostCustomEditors,new S.$Klc(xe,Pt,Jt,jn,Cn)),Bn=xe.set(i.$4M.ExtHostWebviewViews,new tn.$enc(xe,jn)),vn=xe.set(i.$4M.ExtHostTesting,new He.$7mc(xe,pt,mt,Ct)),Zn=xe.set(i.$4M.ExtHostUriOpeners,new ot.$cnc(xe)),Xn=xe.set(i.$4M.ExtHostProfileContentHandlers,new Ae.$Rmc(xe));xe.set(i.$4M.ExtHostInteractive,new _.$Fmc(xe,Ne,Ct,mt,pt));const Yn=xe.set(i.$4M.ExtHostInlineChat,new ve.$smc(xe,mt,Pt,pt)),In=xe.set(i.$4M.ExtHostChatAgents2,new c.$nlc(xe,pt,mt)),xn=xe.set(i.$4M.ExtHostChatVariables,new s.$olc(xe)),_n=xe.set(i.$4M.ExtHostAiRelatedInformation,new u.$_kc(xe)),di=xe.set(i.$4M.ExtHostAiEmbeddingVector,new te.$pmc(xe)),An=xe.set(i.$4M.ExtHostStatusBar,new Je.$1mc(xe,mt.converter)),Un=xe.set(i.$4M.ExtHostSpeech,new qe.$Ymc(xe)),fi=Object.values(i.$4M);xe.assertRegistered(fi);const gi=new r.$mlc(xe,Ct),ei=new v.$plc(xe),Vn=new re.$Imc(xe,pt),Rn=new j.$mmc(xe);return o.$jlc.register(mt),function(Ve,dn,Wn){function at(de){return(Ee,Ue,ct)=>{const yt=de(At=>{try{Ee.call(Ue,At)}catch(Sn){L.$2(new Error(`[ExtensionListenerError] Extension '${Ve.identifier.value}' FAILED to handle event: ${Sn.toString()}`,{cause:Sn})),Wt.onExtensionError(Ve.identifier,Sn)}});return ct?.push(yt),yt}}const wt=function(){let de=!Ve.isUnderDevelopment;function Ee(){de||(pt.info(`Extension '${Ve.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),de=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")Ee();else{const yt=ct;typeof yt.scheme>"u"&&Ee(),typeof yt.exclusive=="boolean"&&(0,et.$IG)(Ve,"documentFiltersExclusive")}return ct}}(),ti={getSession(de,Ee,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,et.$IG)(Ve,"authLearnMore"),It.getSession(Ve,de,Ee,Ue)},getSessions(de,Ee){return(0,et.$IG)(Ve,"authGetSessions"),It.getSessions(Ve,de,Ee)},async hasSession(de,Ee){return(0,et.$IG)(Ve,"authSession"),!!await It.getSession(Ve,de,Ee,{silent:!0})},get onDidChangeSessions(){return at(It.onDidChangeSessions)},registerAuthenticationProvider(de,Ee,Ue,ct){return It.registerAuthenticationProvider(de,Ee,Ue,ct)}},mn={registerCommand(de,Ee,Ue){return mt.registerCommand(!0,de,Ee,Ue,void 0,Ve)},registerTextEditorCommand(de,Ee,Ue){return mt.registerCommand(!0,de,(...ct)=>{const yt=_e.getActiveTextEditor();if(!yt){pt.warn("Cannot execute "+de+" because there is no active text editor.");return}return yt.edit(At=>{Ee.apply(Ue,[yt,At,...ct])}).then(At=>{At||pt.warn("Edits from command "+de+" were not applied.")},At=>{pt.warn("An error occurred while running command "+de,At)})},void 0,void 0,Ve)},registerDiffInformationCommand:(de,Ee,Ue)=>((0,et.$IG)(Ve,"diffCommand"),mt.registerCommand(!0,de,async(...ct)=>{const yt=Ct.activeEditor(!0);if(!yt){pt.warn("Cannot execute "+de+" because there is no active text editor.");return}const At=await _e.getDiffInformation(yt.id);Ee.apply(Ue,[At,...ct])},void 0,void 0,Ve)),executeCommand(de,...Ee){return mt.executeCommand(de,...Ee)},getCommands(de=!1){return mt.getCommands(de)}},kn={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return ei.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return at(St.onDidChangeShell)},get isTelemetryEnabled(){return Wt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Wt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$IG)(Ve,"telemetry"),Wt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$IG)(Ve,"telemetry"),at(Wt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,st.$JP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(de,Ee){return st.$IP.validateSender(de),Wt.instantiateLogger(Ve,de,Ee)},openExternal(de,Ee){return Lt.openUri(de,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(de){if(de.scheme===$t.environment.appUriScheme)return wn.createAppUri(de);try{return await Lt.asExternalUri(de,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,N.$Fg)(de,N.Schemas.http)||(0,N.$Fg)(de,N.Schemas.https))return de;throw Ee}},get remoteName(){return(0,f.$Im)($t.remote.authority)},get remoteAuthority(){return(0,et.$IG)(Ve,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return at(pt.onDidChangeLogLevel)},get appQuality(){return(0,et.$IG)(Ve,"resolvers"),$t.quality},get appCommit(){return(0,et.$IG)(Ve,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(kn);const mi={createTestController(de,Ee,Ue){return vn.createTestController(Ve,de,Ee,Ue)},createTestObserver(){return(0,et.$IG)(Ve,"testObserver"),vn.createTestObserver()},runTests(de){return(0,et.$IG)(Ve,"testObserver"),vn.runTests(de)},get onDidChangeTestResults(){return(0,et.$IG)(Ve,"testObserver"),at(vn.onResultsChanged)},get testResults(){return(0,et.$IG)(Ve,"testObserver"),vn.results}},en=$t.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,Nn={getExtension(de,Ee){(0,et.$HG)(Ve,"extensionsAny")||(Ee=!1);const Ue=dn.mine.getExtensionDescription(de);if(Ue)return new q.$bmc(Ft,Ve.identifier,Ue,en,!1);if(Ee){const ct=dn.all.getExtensionDescription(de);if(ct)return new q.$bmc(Ft,Ve.identifier,ct,en,!0)}},get all(){const de=[];for(const Ee of dn.mine.getAllExtensionDescriptions())de.push(new q.$bmc(Ft,Ve.identifier,Ee,en,!1));return de},get allAcrossExtensionHosts(){(0,et.$IG)(Ve,"extensionsAny");const de=new y.$Sm(dn.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Ee=[];for(const Ue of dn.all.getAllExtensionDescriptions()){const ct=!de.has(Ue.identifier);Ee.push(new q.$bmc(Ft,Ve.identifier,Ue,en,ct))}return Ee},get onDidChange(){return(0,et.$HG)(Ve,"extensionsAny")?at(O.Event.any(dn.mine.onDidChange,dn.all.onDidChange)):at(dn.mine.onDidChange)}},ni={createDiagnosticCollection(de){return Et.createDiagnosticCollection(Ve.identifier,de)},get onDidChangeDiagnostics(){return at(Et.onDidChangeDiagnostics)},getDiagnostics:de=>Et.getDiagnostics(de),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(de,Ee){return zt.changeLanguage(de.uri,Ee)},match(de,Ee){const Ue=Ge.LanguageSelector.from(de);let ct;return(0,A.$Yt)(Ue)&&(ct=Ne.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(At=>At.document===Ee))?.apiNotebook),(0,A.$Xt)(Ue,Ee.uri,Ee.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(de,Ee,Ue){return lt.registerCodeActionProvider(Ve,wt(de),Ee,Ue)},registerDocumentPasteEditProvider(de,Ee,Ue){return(0,et.$IG)(Ve,"documentPaste"),lt.registerDocumentPasteEditProvider(Ve,wt(de),Ee,Ue)},registerCodeLensProvider(de,Ee){return lt.registerCodeLensProvider(Ve,wt(de),Ee)},registerDefinitionProvider(de,Ee){return lt.registerDefinitionProvider(Ve,wt(de),Ee)},registerDeclarationProvider(de,Ee){return lt.registerDeclarationProvider(Ve,wt(de),Ee)},registerImplementationProvider(de,Ee){return lt.registerImplementationProvider(Ve,wt(de),Ee)},registerTypeDefinitionProvider(de,Ee){return lt.registerTypeDefinitionProvider(Ve,wt(de),Ee)},registerHoverProvider(de,Ee){return lt.registerHoverProvider(Ve,wt(de),Ee,Ve.identifier)},registerEvaluatableExpressionProvider(de,Ee){return lt.registerEvaluatableExpressionProvider(Ve,wt(de),Ee,Ve.identifier)},registerInlineValuesProvider(de,Ee){return lt.registerInlineValuesProvider(Ve,wt(de),Ee,Ve.identifier)},registerDocumentHighlightProvider(de,Ee){return lt.registerDocumentHighlightProvider(Ve,wt(de),Ee)},registerMultiDocumentHighlightProvider(de,Ee){return lt.registerMultiDocumentHighlightProvider(Ve,wt(de),Ee)},registerLinkedEditingRangeProvider(de,Ee){return lt.registerLinkedEditingRangeProvider(Ve,wt(de),Ee)},registerReferenceProvider(de,Ee){return lt.registerReferenceProvider(Ve,wt(de),Ee)},registerRenameProvider(de,Ee){return lt.registerRenameProvider(Ve,wt(de),Ee)},registerNewSymbolNamesProvider(de,Ee){return(0,et.$IG)(Ve,"newSymbolNamesProvider"),lt.registerNewSymbolNamesProvider(Ve,wt(de),Ee)},registerDocumentSymbolProvider(de,Ee,Ue){return lt.registerDocumentSymbolProvider(Ve,wt(de),Ee,Ue)},registerWorkspaceSymbolProvider(de){return lt.registerWorkspaceSymbolProvider(Ve,de)},registerDocumentFormattingEditProvider(de,Ee){return lt.registerDocumentFormattingEditProvider(Ve,wt(de),Ee)},registerDocumentRangeFormattingEditProvider(de,Ee){return lt.registerDocumentRangeFormattingEditProvider(Ve,wt(de),Ee)},registerOnTypeFormattingEditProvider(de,Ee,Ue,...ct){return lt.registerOnTypeFormattingEditProvider(Ve,wt(de),Ee,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(de,Ee,Ue){return lt.registerDocumentSemanticTokensProvider(Ve,wt(de),Ee,Ue)},registerDocumentRangeSemanticTokensProvider(de,Ee,Ue){return lt.registerDocumentRangeSemanticTokensProvider(Ve,wt(de),Ee,Ue)},registerSignatureHelpProvider(de,Ee,Ue,...ct){return typeof Ue=="object"?lt.registerSignatureHelpProvider(Ve,wt(de),Ee,Ue):lt.registerSignatureHelpProvider(Ve,wt(de),Ee,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(de,Ee,...Ue){return lt.registerCompletionItemProvider(Ve,wt(de),Ee,Ue)},registerInlineCompletionItemProvider(de,Ee,Ue){return Ee.handleDidShowCompletionItem&&(0,et.$IG)(Ve,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$IG)(Ve,"inlineCompletionsAdditions"),Ue&&(0,et.$IG)(Ve,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Ve,wt(de),Ee,Ue)},registerInlineEditProvider(de,Ee){return(0,et.$IG)(Ve,"inlineEdit"),lt.registerInlineEditProvider(Ve,wt(de),Ee)},registerDocumentLinkProvider(de,Ee){return lt.registerDocumentLinkProvider(Ve,wt(de),Ee)},registerColorProvider(de,Ee){return lt.registerColorProvider(Ve,wt(de),Ee)},registerFoldingRangeProvider(de,Ee){return lt.registerFoldingRangeProvider(Ve,wt(de),Ee)},registerSelectionRangeProvider(de,Ee){return lt.registerSelectionRangeProvider(Ve,de,Ee)},registerCallHierarchyProvider(de,Ee){return lt.registerCallHierarchyProvider(Ve,de,Ee)},registerTypeHierarchyProvider(de,Ee){return lt.registerTypeHierarchyProvider(Ve,de,Ee)},setLanguageConfiguration:(de,Ee)=>lt.setLanguageConfiguration(Ve,de,Ee),getTokenInformationAtPosition(de,Ee){return(0,et.$IG)(Ve,"tokenInformation"),zt.tokenAtPosition(de,Ee)},registerInlayHintsProvider(de,Ee){return lt.registerInlayHintsProvider(Ve,de,Ee)},createLanguageStatusItem(de,Ee){return zt.createLanguageStatusItem(Ve,de,Ee)},registerDocumentDropEditProvider(de,Ee,Ue){return lt.registerDocumentOnDropEditProvider(Ve,de,Ee,(0,et.$HG)(Ve,"documentPaste")?Ue:void 0)}},ii={get activeTextEditor(){return _e.getActiveTextEditor()},get visibleTextEditors(){return _e.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(de,Ee,Ue){m.URI.isUri(de)&&de.scheme===N.Schemas.vscodeRemote&&!de.authority&&Nt.report("workspace.showTextDocument",Ve,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(m.URI.isUri(de)?Promise.resolve(qn.openTextDocument(de)):Promise.resolve(de));return _e.showTextDocument(ct,Ee,Ue)},createTextEditorDecorationType(de){return _e.createTextEditorDecorationType(Ve,de)},onDidChangeActiveTextEditor(de,Ee,Ue){return at(_e.onDidChangeActiveTextEditor)(de,Ee,Ue)},onDidChangeVisibleTextEditors(de,Ee,Ue){return at(_e.onDidChangeVisibleTextEditors)(de,Ee,Ue)},onDidChangeTextEditorSelection(de,Ee,Ue){return at(_e.onDidChangeTextEditorSelection)(de,Ee,Ue)},onDidChangeTextEditorOptions(de,Ee,Ue){return at(_e.onDidChangeTextEditorOptions)(de,Ee,Ue)},onDidChangeTextEditorVisibleRanges(de,Ee,Ue){return at(_e.onDidChangeTextEditorVisibleRanges)(de,Ee,Ue)},onDidChangeTextEditorViewColumn(de,Ee,Ue){return at(_e.onDidChangeTextEditorViewColumn)(de,Ee,Ue)},onDidCloseTerminal(de,Ee,Ue){return at(St.onDidCloseTerminal)(de,Ee,Ue)},onDidOpenTerminal(de,Ee,Ue){return at(St.onDidOpenTerminal)(de,Ee,Ue)},onDidChangeActiveTerminal(de,Ee,Ue){return at(St.onDidChangeActiveTerminal)(de,Ee,Ue)},onDidChangeTerminalDimensions(de,Ee,Ue){return(0,et.$IG)(Ve,"terminalDimensions"),at(St.onDidChangeTerminalDimensions)(de,Ee,Ue)},onDidChangeTerminalState(de,Ee,Ue){return at(St.onDidChangeTerminalState)(de,Ee,Ue)},onDidWriteTerminalData(de,Ee,Ue){return(0,et.$IG)(Ve,"terminalDataWriteEvent"),at(St.onDidWriteTerminalData)(de,Ee,Ue)},onDidExecuteTerminalCommand(de,Ee,Ue){return(0,et.$IG)(Ve,"terminalExecuteCommandEvent"),at(St.onDidExecuteTerminalCommand)(de,Ee,Ue)},onDidChangeTerminalShellIntegration(de,Ee,Ue){return(0,et.$IG)(Ve,"terminalShellIntegration"),at(cn.onDidChangeTerminalShellIntegration)(de,Ee,Ue)},onDidStartTerminalShellExecution(de,Ee,Ue){return(0,et.$IG)(Ve,"terminalShellIntegration"),at(cn.onDidStartTerminalShellExecution)(de,Ee,Ue)},onDidEndTerminalShellExecution(de,Ee,Ue){return(0,et.$IG)(Ve,"terminalShellIntegration"),at(cn.onDidEndTerminalShellExecution)(de,Ee,Ue)},get state(){return Lt.getState()},onDidChangeWindowState(de,Ee,Ue){return at(Lt.onDidChangeWindowState)(de,Ee,Ue)},showInformationMessage(de,...Ee){return Vn.showMessage(Ve,b.default.Info,de,Ee[0],Ee.slice(1))},showWarningMessage(de,...Ee){return Vn.showMessage(Ve,b.default.Warning,de,Ee[0],Ee.slice(1))},showErrorMessage(de,...Ee){return Vn.showMessage(Ve,b.default.Error,de,Ee[0],Ee.slice(1))},showQuickPick(de,Ee,Ue){return En.showQuickPick(Ve,de,Ee,Ue)},showWorkspaceFolderPick(de){return En.showWorkspaceFolderPick(de)},showInputBox(de,Ee){return En.showInput(de,Ee)},showOpenDialog(de){return Rn.showOpenDialog(Ve,de)},showSaveDialog(de){return Rn.showSaveDialog(de)},createStatusBarItem(de,Ee,Ue){let ct,yt,At;return typeof de=="string"?(ct=de,yt=Ee,At=Ue):(yt=de,At=Ee),An.createStatusBarEntry(Ve,ct,yt,At)},setStatusBarMessage(de,Ee){return An.setStatusBarMessage(de,Ee)},withScmProgress(de){return Nt.report("window.withScmProgress",Ve,"Use 'withProgress' instead."),Pn.withProgress(Ve,{location:Oe.ProgressLocation.SourceControl},(Ee,Ue)=>de({report(ct){}}))},withProgress(de,Ee){return Pn.withProgress(Ve,de,Ee)},createOutputChannel(de,Ee){return pn.createOutputChannel(de,Ee,Ve)},createWebviewPanel(de,Ee,Ue,ct){return Cn.createWebviewPanel(Ve,de,Ee,Ue,ct)},createWebviewTextEditorInset(de,Ee,Ue,ct){return(0,et.$IG)(Ve,"editorInsets"),ht.createWebviewEditorInset(de,Ee,Ue,ct,Ve)},createTerminal(de,Ee,Ue){return typeof de=="object"?"pty"in de?St.createExtensionTerminal(de):St.createTerminalFromOptions(de):St.createTerminal(de,Ee,Ue)},registerTerminalLinkProvider(de){return St.registerLinkProvider(de)},registerTerminalProfileProvider(de,Ee){return St.registerProfileProvider(Ve,de,Ee)},registerTerminalQuickFixProvider(de,Ee){return(0,et.$IG)(Ve,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(de,Ve.identifier.value,Ee)},registerTreeDataProvider(de,Ee){return Ze.registerTreeDataProvider(de,Ee,Ve)},createTreeView(de,Ee){return Ze.createTreeView(de,Ee,Ve)},registerWebviewPanelSerializer:(de,Ee)=>Cn.registerWebviewPanelSerializer(Ve,de,Ee),registerCustomEditorProvider:(de,Ee,Ue={})=>zn.registerCustomEditorProvider(Ve,de,Ee,Ue),registerFileDecorationProvider(de){return Ot.registerFileDecorationProvider(de,Ve)},registerUriHandler(de){return wn.registerUriHandler(Ve,de)},createQuickPick(){return En.createQuickPick(Ve)},createInputBox(){return En.createInputBox(Ve)},get activeColorTheme(){return Fn.activeColorTheme},onDidChangeActiveColorTheme(de,Ee,Ue){return at(Fn.onDidChangeActiveColorTheme)(de,Ee,Ue)},registerWebviewViewProvider(de,Ee,Ue){return Bn.registerWebviewViewProvider(Ve,de,Ee,Ue?.webviewOptions)},get activeNotebookEditor(){return Ne.activeNotebookEditor},onDidChangeActiveNotebookEditor(de,Ee,Ue){return at(Ne.onDidChangeActiveNotebookEditor)(de,Ee,Ue)},get visibleNotebookEditors(){return Ne.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(Ne.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(de,Ee,Ue){return at(ye.onDidChangeNotebookEditorSelection)(de,Ee,Ue)},onDidChangeNotebookEditorVisibleRanges(de,Ee,Ue){return at(ye.onDidChangeNotebookEditorVisibleRanges)(de,Ee,Ue)},showNotebookDocument(de,Ee){return Ne.showNotebookDocument(de,Ee)},registerExternalUriOpener(de,Ee,Ue){return(0,et.$IG)(Ve,"externalUriOpener"),Zn.registerExternalUriOpener(Ve.identifier,de,Ee,Ue)},registerProfileContentHandler(de,Ee){return(0,et.$IG)(Ve,"profileContentHandlers"),Xn.registerProfileContentHandler(Ve,de,Ee)},registerQuickDiffProvider(de,Ee,Ue,ct){return(0,et.$IG)(Ve,"quickDiffProvider"),Kn.registerQuickDiffProvider(wt(de),Ee,Ue,ct)},get tabGroups(){return Qt.tabGroups},registerShareProvider(de,Ee){return(0,et.$IG)(Ve,"shareProvider"),Ln.registerShareProvider(wt(de),Ee)}},qn={get rootPath(){return Nt.report("workspace.rootPath",Ve,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(de){throw new L.$9("rootPath")},getWorkspaceFolder(de){return gt.getWorkspaceFolder(de)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(de){throw new L.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(de){throw new L.$9("workspaceFile")},updateWorkspaceFolders:(de,Ee,...Ue)=>gt.updateWorkspaceFolders(Ve,de,Ee||0,...Ue),onDidChangeWorkspaceFolders:function(de,Ee,Ue){return at(gt.onDidChangeWorkspace)(de,Ee,Ue)},asRelativePath:(de,Ee)=>gt.getRelativePath(de,Ee),findFiles:(de,Ee,Ue,ct)=>gt.findFiles(de,Ee,Ue,Ve.identifier,ct),findFiles2:(de,Ee,Ue)=>((0,et.$IG)(Ve,"findFiles2"),gt.findFiles2(de,Ee,Ve.identifier,Ue)),findTextInFiles:(de,Ee,Ue,ct)=>{(0,et.$IG)(Ve,"findTextInFiles");let yt,At;return typeof Ee=="object"?(yt=Ee,At=Ue):(yt={},At=Ee,ct=Ue),gt.findTextInFiles(de,yt||{},At,Ve.identifier,ct)},save:de=>gt.save(de),saveAs:de=>gt.saveAs(de),saveAll:de=>gt.saveAll(de),applyEdit(de,Ee){return gi.applyWorkspaceEdit(de,Ve,Ee)},createFileSystemWatcher:(de,Ee,Ue,ct)=>{let yt;return typeof Ee=="boolean"?yt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:Ee&&((0,et.$IG)(Ve,"createFileSystemWatcher"),yt={...Ee,correlate:!0}),Bt.createFileSystemWatcher(gt,Ve,de,yt)},get textDocuments(){return Pt.getAllDocumentData().map(de=>de.document)},set textDocuments(de){throw new L.$9("textDocuments")},openTextDocument(de){let Ee;const Ue=de;if(typeof de=="string")Ee=Promise.resolve(m.URI.file(de));else if(m.URI.isUri(de))Ee=Promise.resolve(de);else if(!Ue||typeof Ue=="object")Ee=Pt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ct=>(ct.scheme===N.Schemas.vscodeRemote&&!ct.authority&&Nt.report("workspace.openTextDocument",Ve,"A URI of 'vscode-remote' scheme requires an authority."),Pt.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(de,Ee,Ue)=>at(Pt.onDidAddDocument)(de,Ee,Ue),onDidCloseTextDocument:(de,Ee,Ue)=>at(Pt.onDidRemoveDocument)(de,Ee,Ue),onDidChangeTextDocument:(de,Ee,Ue)=>at(Pt.onDidChangeDocument)(de,Ee,Ue),onDidSaveTextDocument:(de,Ee,Ue)=>at(Pt.onDidSaveDocument)(de,Ee,Ue),onWillSaveTextDocument:(de,Ee,Ue)=>at(on.getOnWillSaveTextDocumentEvent(Ve))(de,Ee,Ue),get notebookDocuments(){return Ne.notebookDocuments.map(de=>de.apiNotebook)},async openNotebookDocument(de,Ee){let Ue;if(m.URI.isUri(de))Ue=de,await Ne.openNotebookDocument(de);else if(typeof de=="string")Ue=m.URI.revive(await Ne.createNotebookDocument({viewType:de,content:Ee}));else throw new Error("Invalid arguments");return Ne.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(de,Ee,Ue){return at(je.onDidSaveNotebookDocument)(de,Ee,Ue)},onDidChangeNotebookDocument(de,Ee,Ue){return at(je.onDidChangeNotebookDocument)(de,Ee,Ue)},onWillSaveNotebookDocument(de,Ee,Ue){return at(Qe.getOnWillSaveNotebookDocumentEvent(Ve))(de,Ee,Ue)},get onDidOpenNotebookDocument(){return at(Ne.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(Ne.onDidCloseNotebookDocument)},registerNotebookSerializer(de,Ee,Ue,ct){return Ne.registerNotebookSerializer(Ve,de,Ee,Ue,(0,et.$HG)(Ve,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(de,Ee,Ue)=>at(Wn.onDidChangeConfiguration)(de,Ee,Ue),getConfiguration(de,Ee){return Ee=arguments.length===1?void 0:Ee,Wn.getConfiguration(de,Ee,Ve)},registerTextDocumentContentProvider(de,Ee){return yn.registerTextDocumentContentProvider(de,Ee)},registerTaskProvider:(de,Ee)=>(Nt.report("window.registerTaskProvider",Ve,"Use the corresponding function on the 'tasks' namespace instead"),sn.registerTaskProvider(Ve,de,Ee)),registerFileSystemProvider(de,Ee,Ue){return(0,R.$Sc)(Tt.registerFileSystemProvider(Ve,de,Ee,Ue),Kt.addFileSystemProvider(de,Ee,Ue))},get fs(){return Kt.value},registerFileSearchProvider:(de,Ee)=>((0,et.$IG)(Ve,"fileSearchProvider"),gn.registerFileSearchProvider(de,Ee)),registerTextSearchProvider:(de,Ee)=>((0,et.$IG)(Ve,"textSearchProvider"),gn.registerTextSearchProvider(de,Ee)),registerAITextSearchProvider:(de,Ee)=>((0,et.$IG)(Ve,"aiTextSearchProvider"),(0,et.$IG)(Ve,"textSearchProvider"),gn.registerAITextSearchProvider(de,Ee)),registerRemoteAuthorityResolver:(de,Ee)=>((0,et.$IG)(Ve,"resolvers"),Ft.registerRemoteAuthorityResolver(de,Ee)),registerResourceLabelFormatter:de=>((0,et.$IG)(Ve,"resolvers"),Tn.$registerResourceLabelFormatter(de)),getRemoteExecServer:de=>((0,et.$IG)(Ve,"resolvers"),Ft.getRemoteExecServer(de)),onDidCreateFiles:(de,Ee,Ue)=>at(Bt.onDidCreateFile)(de,Ee,Ue),onDidDeleteFiles:(de,Ee,Ue)=>at(Bt.onDidDeleteFile)(de,Ee,Ue),onDidRenameFiles:(de,Ee,Ue)=>at(Bt.onDidRenameFile)(de,Ee,Ue),onWillCreateFiles:(de,Ee,Ue)=>at(Bt.getOnWillCreateFileEvent(Ve))(de,Ee,Ue),onWillDeleteFiles:(de,Ee,Ue)=>at(Bt.getOnWillDeleteFileEvent(Ve))(de,Ee,Ue),onWillRenameFiles:(de,Ee,Ue)=>at(Bt.getOnWillRenameFileEvent(Ve))(de,Ee,Ue),openTunnel:de=>((0,et.$IG)(Ve,"tunnels"),jt.openTunnel(Ve,de).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$IG)(Ve,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(de,Ee,Ue)=>((0,et.$IG)(Ve,"tunnels"),at(jt.onDidChangeTunnels)(de,Ee,Ue)),registerPortAttributesProvider:(de,Ee)=>((0,et.$IG)(Ve,"portsAttributes"),jt.registerPortsAttributesProvider(de,Ee)),registerTunnelProvider:(de,Ee)=>((0,et.$IG)(Ve,"tunnelFactory"),jt.registerTunnelProvider(de,Ee)),registerTimelineProvider:(de,Ee)=>((0,et.$IG)(Ve,"timeline"),Jn.registerTimelineProvider(de,Ee,Ve.identifier,mt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:de=>((0,et.$IG)(Ve,"workspaceTrust"),gt.requestWorkspaceTrust(de)),onDidGrantWorkspaceTrust:(de,Ee,Ue)=>at(gt.onDidGrantWorkspaceTrust)(de,Ee,Ue),registerEditSessionIdentityProvider:(de,Ee)=>((0,et.$IG)(Ve,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(de,Ee)),onWillCreateEditSessionIdentity:(de,Ee,Ue)=>((0,et.$IG)(Ve,"editSessionIdentityProvider"),at(gt.getOnWillCreateEditSessionIdentityEvent(Ve))(de,Ee,Ue)),registerCanonicalUriProvider:(de,Ee)=>((0,et.$IG)(Ve,"canonicalUriProvider"),gt.registerCanonicalUriProvider(de,Ee)),getCanonicalUri:(de,Ee,Ue)=>((0,et.$IG)(Ve,"canonicalUriProvider"),gt.provideCanonicalUri(de,Ee,Ue))},ri={get inputBox(){return Nt.report("scm.inputBox",Ve,"Use 'SourceControl.inputBox' instead"),Dn.getLastInputBox(Ve)},createSourceControl(de,Ee,Ue){return Dn.createSourceControl(Ve,de,Ee,Ue)}},$i={createCommentController(de,Ee){return Mn.createCommentController(Ve,de,Ee)}},si={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,et.$HG)(Ve,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(de,Ee){return(0,et.$IG)(Ve,"debugVisualization"),Dt.registerDebugVisualizationProvider(Ve,de,Ee)},registerDebugVisualizationTreeProvider(de,Ee){return(0,et.$IG)(Ve,"debugVisualization"),Dt.registerDebugVisualizationTree(Ve,de,Ee)},onDidStartDebugSession(de,Ee,Ue){return at(Dt.onDidStartDebugSession)(de,Ee,Ue)},onDidTerminateDebugSession(de,Ee,Ue){return at(Dt.onDidTerminateDebugSession)(de,Ee,Ue)},onDidChangeActiveDebugSession(de,Ee,Ue){return at(Dt.onDidChangeActiveDebugSession)(de,Ee,Ue)},onDidReceiveDebugSessionCustomEvent(de,Ee,Ue){return at(Dt.onDidReceiveDebugSessionCustomEvent)(de,Ee,Ue)},onDidChangeBreakpoints(de,Ee,Ue){return at(Dt.onDidChangeBreakpoints)(de,Ee,Ue)},onDidChangeActiveStackItem(de,Ee,Ue){return(0,et.$IG)(Ve,"debugFocus"),at(Dt.onDidChangeActiveStackItem)(de,Ee,Ue)},registerDebugConfigurationProvider(de,Ee,Ue){return Dt.registerDebugConfigurationProvider(de,Ee,Ue||Xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(de,Ee){return Dt.registerDebugAdapterDescriptorFactory(Ve,de,Ee)},registerDebugAdapterTrackerFactory(de,Ee){return Dt.registerDebugAdapterTrackerFactory(de,Ee)},startDebugging(de,Ee,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Dt.startDebugging(de,Ee,{parentSession:Ue}):Dt.startDebugging(de,Ee,Ue||{})},stopDebugging(de){return Dt.stopDebugging(de)},addBreakpoints(de){return Dt.addBreakpoints(de)},removeBreakpoints(de){return Dt.removeBreakpoints(de)},asDebugSourceUri(de,Ee){return Dt.asDebugSourceUri(de,Ee)}},oi={registerTaskProvider:(de,Ee)=>sn.registerTaskProvider(Ve,de,Ee),fetchTasks:de=>sn.fetchTasks(de),executeTask:de=>sn.executeTask(Ve,de),get taskExecutions(){return sn.taskExecutions},onDidStartTask:(de,Ee,Ue)=>at(sn.onDidStartTask)(de,Ee,Ue),onDidEndTask:(de,Ee,Ue)=>at(sn.onDidEndTask)(de,Ee,Ue),onDidStartTaskProcess:(de,Ee,Ue)=>at(sn.onDidStartTaskProcess)(de,Ee,Ue),onDidEndTaskProcess:(de,Ee,Ue)=>at(sn.onDidEndTaskProcess)(de,Ee,Ue)},pi={createNotebookController(de,Ee,Ue,ct,yt){return x.createNotebookController(Ve,de,Ee,Ue,ct,(0,et.$HG)(Ve,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(de,Ee)=>Ne.registerNotebookCellStatusBarItemProvider(Ve,de,Ee),createRendererMessaging(de){return Te.createRendererMessaging(Ve,de)},createNotebookControllerDetectionTask(de){return(0,et.$IG)(Ve,"notebookKernelSource"),x.createNotebookControllerDetectionTask(Ve,de)},registerKernelSourceActionProvider(de,Ee){return(0,et.$IG)(Ve,"notebookKernelSource"),x.registerKernelSourceActionProvider(Ve,de,Ee)},onDidChangeNotebookCellExecutionState(de,Ee,Ue){return(0,et.$IG)(Ve,"notebookCellExecutionState"),at(x.onDidChangeNotebookCellExecutionState)(de,Ee,Ue)}},bi={t(...de){if(typeof de[0]=="string"){const Ee=de.shift(),Ue=!de||typeof de[0]!="object"?de:de[0];return hn.getMessage(Ve.identifier.value,{message:Ee,args:Ue})}return hn.getMessage(Ve.identifier.value,de[0])},get bundle(){return hn.getBundle(Ve.identifier.value)},get uri(){return hn.getBundleUri(Ve.identifier.value)}},ai={_version:1,registerInteractiveEditorSessionProvider(de,Ee){return(0,et.$IG)(Ve,"interactive"),Yn.registerProvider(Ve,de,Ee)},transferActiveChat(de){return(0,et.$IG)(Ve,"interactive"),In.transferActiveChat(de)}},Qn={getRelatedInformation(de,Ee){return(0,et.$IG)(Ve,"aiRelatedInformation"),_n.getRelatedInformation(Ve,de,Ee)},registerRelatedInformationProvider(de,Ee){return(0,et.$IG)(Ve,"aiRelatedInformation"),_n.registerRelatedInformationProvider(Ve,de,Ee)},registerEmbeddingVectorProvider(de,Ee){return(0,et.$IG)(Ve,"aiRelatedInformation"),di.registerEmbeddingVectorProvider(Ve,de,Ee)}},ci={registerChatResponseProvider(de,Ee,Ue){return(0,et.$IG)(Ve,"chatProvider"),Mt.registerLanguageModel(Ve,de,Ee,Ue)},registerChatVariableResolver(de,Ee,Ue){return(0,et.$IG)(Ve,"chatVariableResolver"),xn.registerVariableResolver(Ve,de,Ee,Ue)},registerMappedEditsProvider(de,Ee){return(0,et.$IG)(Ve,"mappedEditsProvider"),lt.registerMappedEditsProvider(Ve,de,Ee)},createChatParticipant(de,Ee){return(0,et.$IG)(Ve,"chatParticipant"),In.createChatAgent(Ve,de,Ee)},createDynamicChatParticipant(de,Ee,Ue,ct){return(0,et.$IG)(Ve,"chatParticipantAdditions"),In.createDynamicChatAgent(Ve,de,Ee,Ue,ct)}},ui={get languageModels(){return(0,et.$IG)(Ve,"languageModels"),Mt.getLanguageModelIds()},onDidChangeLanguageModels:(de,Ee,Ue)=>((0,et.$IG)(Ve,"languageModels"),Mt.onDidChangeProviders(de,Ee,Ue)),sendChatRequest(de,Ee,Ue,ct){return(0,et.$IG)(Ve,"languageModels"),Mt.sendChatRequest(Ve,de,Ee,Ue,ct)},computeTokenLength(de,Ee,Ue){return(0,et.$IG)(Ve,"languageModels"),Ue??=d.CancellationToken.None,Mt.computeTokenLength(de,Ee,Ue)},getLanguageModelInformation(de){return(0,et.$IG)(Ve,"languageModels"),Mt.getLanguageModelInfo(de)}},li={registerSpeechProvider(de,Ee){return(0,et.$IG)(Ve,"speech"),Un.registerProvider(Ve.identifier,de,Ee)}};return{version:$t.version,ai:Qn,authentication:ti,commands:mn,comments:$i,chat:ci,debug:si,env:kn,extensions:Nn,interactive:ai,l10n:bi,languages:ni,lm:ui,notebooks:pi,scm:ri,speech:li,tasks:oi,tests:mi,window:ii,workspace:qn,Breakpoint:Oe.$6N,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatResultFeedbackKind:Oe.ChatResultFeedbackKind,ChatVariableLevel:Oe.ChatVariableLevel,ChatCompletionItem:Oe.$1O,CallHierarchyIncomingCall:Oe.$rN,CallHierarchyItem:Oe.$qN,CallHierarchyOutgoingCall:Oe.$sN,CancellationError:L.$5,CancellationTokenSource:d.$pe,CandidatePortSource:i.CandidatePortSource,CodeAction:Oe.$nN,CodeActionKind:Oe.$oN,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$tN,Color:Oe.$GN,ColorInformation:Oe.$HN,ColorPresentation:Oe.$IN,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CommentThreadApplicability:Oe.CommentThreadApplicability,CompletionItem:Oe.$AN,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$BN,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$QN,DebugAdapterExecutable:Oe.$0N,DebugAdapterInlineImplementation:Oe.$aO,DebugAdapterNamedPipeServer:Oe.$_N,DebugAdapterServer:Oe.$$N,DebugConfigurationProviderTriggerKind:Xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DebugVisualization:Oe.$qO,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$gN,DiagnosticRelatedInformation:Oe.$fN,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$5M,DocumentHighlight:Oe.$jN,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$kN,DocumentLink:Oe.$FN,DocumentSymbol:Oe.$mN,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$dO,InlineValueText:Oe.$eO,InlineValueVariableLookup:Oe.$fO,InlineValueEvaluatableExpression:Oe.$gO,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:O.$ee,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$sO,FileDecoration2:Oe.$sO,FileSystemError:Oe.$jO,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:Oe.$kO,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$8N,InlineCompletionItem:Oe.$CN,InlineCompletionList:Oe.$DN,Hover:Oe.$hN,VerboseHover:Oe.$iN,HoverVerbosityAction:Oe.HoverVerbosityAction,IndentAction:P.IndentAction,Location:Oe.$eN,MarkdownString:Oe.$uN,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Oe.$vN,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$6M,ProcessExecution:Oe.$ON,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$rO,Range:Oe.$7M,RelativePattern:Oe.$4N,Selection:Oe.$8M,SelectionRange:Oe.$pN,SemanticTokens:Oe.$nO,SemanticTokensBuilder:Oe.$mO,SemanticTokensEdit:Oe.$oO,SemanticTokensEdits:Oe.$pO,SemanticTokensLegend:Oe.$lO,ShellExecution:Oe.$PN,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$xN,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$wN,SnippetString:Oe.$dN,SourceBreakpoint:Oe.$7N,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$lN,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$RN,TaskGroup:Oe.$NN,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$JN,TerminalQuickFixTerminalCommand:Oe.$LN,TerminalQuickFixOpener:Oe.$KN,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$MN,TerminalExitReason:Oe.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Oe.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$_M,SnippetTextEdit:Oe.$bN,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$3N,ThemeIcon:Oe.$2N,TreeItem:Oe.$SN,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$OO,UIKind:Yt.UIKind,Uri:m.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$cN,DocumentPasteTriggerKind:Oe.DocumentPasteTriggerKind,DocumentDropEdit:Oe.$YN,DocumentDropOrPasteEditKind:Oe.$ZN,DocumentPasteEdit:Oe.$1N,InlayHint:Oe.$zN,InlayHintLabelPart:Oe.$yN,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$$M,ResolvedAuthority:Oe.$9M,ManagedResolvedAuthority:Oe.$0M,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$CO,NotebookRange:Oe.$uO,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$vO,NotebookData:Oe.$wO,NotebookRendererScript:Oe.$AO,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$yO,NotebookCellOutputItem:Oe.$xO,NotebookCellStatusBarItem:Oe.$zO,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$aN,NotebookKernelSourceAction:Oe.$BO,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$EO,LinkedEditingRanges:Oe.$DO,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$FO,TestRunRequest2:Oe.$FO,TestMessage:Oe.$GO,TestTag:Oe.$HO,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:an.TextSearchCompleteMessageType,DataTransfer:Oe.$XN,DataTransferItem:Oe.$TN,TestCoverageCount:Oe.$IO,FileCoverage:Oe.$KO,StatementCoverage:Oe.$LO,BranchCoverage:Oe.$MO,DeclarationCoverage:Oe.$NO,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$PO,TabInputTextDiff:Oe.$QO,TabInputTextMerge:Oe.$RO,TabInputCustom:Oe.$SO,TabInputNotebook:Oe.$UO,TabInputNotebookDiff:Oe.$VO,TabInputWebview:Oe.$TO,TabInputTerminal:Oe.$WO,TabInputInteractiveWindow:Oe.$XO,TabInputChat:Oe.$YO,TabInputTextMultiDiff:Oe.$ZO,TelemetryTrustedValue:a.$fp,LogLevel:h.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatCopyKind:Oe.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Oe.$bO,DebugThread:Oe.$cO,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus,PartialAcceptTriggerKind:Oe.PartialAcceptTriggerKind,KeywordRecognitionStatus:Oe.KeywordRecognitionStatus,ChatResponseMarkdownPart:Oe.$2O,ChatResponseFileTreePart:Oe.$5O,ChatResponseAnchorPart:Oe.$6O,ChatResponseProgressPart:Oe.$7O,ChatResponseReferencePart:Oe.$9O,ChatResponseTextEditPart:Oe.$0O,ChatResponseMarkdownWithVulnerabilitiesPart:Oe.$3O,ChatResponseCommandButtonPart:Oe.$8O,ChatResponseDetectedParticipantPart:Oe.$4O,ChatRequestTurn:Oe.$$O,ChatResponseTurn:Oe.$_O,ChatLocation:Oe.ChatLocation,LanguageModelChatSystemMessage:Oe.$aP,LanguageModelChatUserMessage:Oe.$bP,LanguageModelChatAssistantMessage:Oe.$cP,LanguageModelSystemMessage:Oe.$aP,LanguageModelUserMessage:Oe.$bP,LanguageModelAssistantMessage:Oe.$cP,LanguageModelError:Oe.$dP,NewSymbolName:Oe.$iO,NewSymbolNameTag:Oe.NewSymbolNameTag,NewSymbolNameTriggerKind:Oe.NewSymbolNameTriggerKind,InlineEdit:Oe.$eP,InlineEditTriggerKind:Oe.InlineEditTriggerKind}}}}),define(ke[385],Se([1,0,85,158,44,152,45,34,73,43,95,96,97,119,71,91,151,70,60,118,90,72,150,11,61,116,117,121,122,156]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u,o,t,l,r,c,s,v,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.$xs)(c.$8lc,c.$7lc,1),(0,d.$xs)(l.$4j,t.$inc,1),(0,d.$xs)(h.$alc,h.$blc,1),(0,d.$xs)(b.$MP,b.$LP,0),(0,d.$xs)(v.$klc,v.$llc,0),(0,d.$xs)(g.$2lc,g.$3lc,0),(0,d.$xs)(N.$zlc,N.$xlc,0),(0,d.$xs)(a.$Blc,a.$Alc,0),(0,d.$xs)(P.$fmc,P.$jmc,0),(0,d.$xs)(R.$lmc,R.$kmc,0),(0,d.$xs)(m.$BP,m.$AP,0),(0,d.$xs)(s.$9lc,s.$0lc,0),(0,d.$xs)(n.$elc,n.$dlc,0),(0,d.$xs)(L.$Qmc,L.$Pmc,1),(0,d.$xs)(p.$Bmc,p.$Cmc,0),(0,d.$xs)(y.$Ulc,y.$Tlc,0),(0,d.$xs)(A.$4mc,A.$3mc,0),(0,d.$xs)(E.$Xlc,E.$1lc,0),(0,d.$xs)(D.$5mc,D.$6mc,0),(0,d.$xs)(w.$tDb,w.$uDb,0),(0,d.$xs)(f.$gnc,f.$fnc,0),(0,d.$xs)(O.$wlc,O.$vlc,0),(0,d.$xs)(i.$5lc,i.$4lc,0),(0,d.$xs)(u.$KP,u.$HP,0),(0,d.$xs)(o.$Llc,o.$Mlc,0),(0,d.$xs)(r.$dmc,r.$emc,0)}),define(ke[123],Se([1,0,19,11,37,94]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=void 0,e.$ync=N,e.$znc=b;function N(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}function b(P,p,y,w){const h=(0,d.$2b)(y,m),f=new O.$jL(p,h,w),a=f.preview.matches;return{ranges:(0,d.$2b)(h,E),uri:P,preview:{text:f.preview.text,matches:(0,d.$2b)(a,E)}}}function m(P){return new O.$kL(P.start.line,P.start.character,P.end.line,P.end.character)}function E(P){return new R.$$K(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let A=class{constructor(p,y){this.a=p,this.b=y}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$Anc=A,e.$Anc=A=Ke([We(1,L.$3j)],A)}),define(ke[386],Se([1,0,54,17,77,31,12,14,123,387]),function(le,e,d,L,O,R,N,b,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=P,e.$Cnc=f,e.$Dnc=n;const A=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(i,u,o,t){const l=p(i,u,o,t),r=u.folder.fsPath;return{cmd:d.spawn(A,l.args,{cwd:r}),rgDiskPath:A,siblingClauses:l.siblingClauses,rgArgs:l,cwd:r}}function p(i,u,o,t){const l=["--files","--hidden","--case-sensitive","--no-require-git"];w([u],o,!1).forEach(c=>{const s=(0,m.$ync)(c);if(l.push("-g",s),N.$j){const v=(0,O.$cm)(s);v!==s&&l.push("-g",v)}});const r=y([u],t,void 0,!1);return r.globArgs.forEach(c=>{const s=`!${(0,m.$ync)(c)}`;if(l.push("-g",s),N.$j){const v=(0,O.$cm)(s);v!==s&&l.push("-g",v)}}),u.disregardIgnoreFiles!==!1?l.push("--no-ignore"):u.disregardParentIgnoreFiles!==!1&&l.push("--no-ignore-parent"),u.ignoreSymlinks||l.push("--follow"),i.exists&&l.push("--quiet"),l.push("--no-config"),u.disregardGlobalIgnoreFiles&&l.push("--no-ignore-global"),{args:l,siblingClauses:r.siblingClauses}}function y(i,u,o,t=!0){const l=[];let r={};return i.forEach(c=>{const s=Object.assign({},c.excludePattern||{},u||{}),v=h(s,t?c.folder.fsPath:void 0,o);l.push(...v.globArgs),v.siblingClauses&&(r=Object.assign(r,v.siblingClauses))}),{globArgs:l,siblingClauses:r}}function w(i,u,o=!0){const t=[];return i.forEach(l=>{const r=Object.assign({},u||{},l.includePattern||{}),c=h(r,o?l.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function h(i,u,o){const t=[],l={};return Object.keys(i).forEach(r=>{if(o&&o.has(r)||!r)return;const c=i[r];r=a(u?f(u,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof c=="boolean"&&c?(r.startsWith("\\\\")&&(r+="**"),t.push(n(r))):c&&c.when&&(l[r]=c)}),{globArgs:t,siblingClauses:l}}function f(i,u){return L.$jc(u)?u:L.$kc(i,u)}function a(i){return i=b.$gf(i,"\\"),b.$gf(i,"/")}function n(i){return R.$rg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[388],Se([1,0,54,53,17,389,19,47,35,77,31,12,40,14,18,32,37,386,133]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=e.$Enc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(r=>r())});class u{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&m.$qk(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=c.shouldGlobMatchFilePattern?null:(0,n.$xr)(this.b).normalizedLowercase),this.u=c.excludePattern&&m.$qk(c.excludePattern),this.t=new Map,c.folderQueries.forEach(s=>{const v=Object.assign({},s.excludePattern||{},this.a.excludePattern||{}),g=s.folder.fsPath;c.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==g).forEach(D=>{(0,A.$vg)(D,g)&&(v[O.$mc(g,D)]=!0)}),this.t.set(g,new t(v,g))})}cancel(){this.l=!0,i.forEach(c=>c())}walk(c,s,v,g,D){if(this.m=p.$ae.create(!1),this.l)return D(null,this.j);s.forEach($=>{const k=O.$oc($.fsPath);this.u&&this.u($.fsPath,k)||this.J(v,{relativePath:$.fsPath,searchPath:void 0})}),this.r=p.$ae.create(!1),this.w(c,($,k)=>{this.x(this.y,this,$,v,g,S=>{if(S){const C=(0,b.$hj)(S);console.error(C),this.q.push(C),k(S,void 0)}else k(null,void 0)})},($,k)=>{this.m.stop();const S=$?N.$Hb($)[0]:null;D(S,this.j)})}w(c,s,v){const g=new Array(c.length),D=new Array(c.length);let $=!1,k=0;if(c.length===0)return v(null,[]);c.forEach((S,C)=>{s(S,(I,F)=>{if(I?($=!0,g[C]=null,D[C]=I):(g[C]=F,D[C]=null),++k===c.length)return v($?D:null,g)})})}x(c,s,...v){try{c.apply(s,v)}catch(g){v[v.length-1](g)}}y(c,s,v,g){const D=c.folder.fsPath,$=P.$j,k=()=>j&&j.kill();i.add(k);let S=U=>{i.delete(k),S=()=>{},g(U)},C="";const I=this.D(),F=(0,a.$Bnc)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),j=F.cmd,z=!Object.keys(F.siblingClauses).length,M=F.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let T=`${F.rgDiskPath} ${M}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),v({message:T}),this.s=0,this.z(j,"utf8",v,(U,Z,te)=>{if(U){S(U);return}if(this.j){S();return}const K=(C+($?E.$bm(Z||""):Z)).split(`
`);if(te){const Y=K.length;K[Y-1]=K[Y-1].trim(),K[Y-1]||K.pop()}else C=K.pop()||"";if(K.length&&K[0].indexOf(`
`)!==-1){S(new Error("Splitting up files failed"));return}if(this.s+=K.length,z){for(const Y of K)if(this.J(s,{base:D,relativePath:Y,searchPath:this.N(c,Y)}),this.j){k();break}(te||this.j)&&S();return}this.G(c,I,D,K,s),te&&(this.H(I,D,s),S())})}spawnFindCmd(c){const s=this.t.get(c.folder.fsPath),v=s.getBasenameTerms(),g=s.getPathTerms(),D=["-L","."];if(v.length||g.length){D.push("-not","(","(");for(const $ of v)D.push("-name",$),D.push("-o");for(const $ of g)D.push("-path",$),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),d.spawn("find",D,{cwd:c.folder.fsPath})}readStdout(c,s,v){let g="";this.z(c,s,()=>{},(D,$,k)=>{if(D){v(D);return}g+=$,k&&v(null,g)})}z(c,s,v,g){let D=(S,C,I)=>{(S||I)&&(D=()=>{},this.r?.stop()),g(S,C,I)},$=!1;c.stdout?(this.A(c.stdout,s,D),c.stdout.once("data",()=>$=!0)):v({message:"stdout is null"});let k;c.stderr?k=this.B(c.stderr):v({message:"stderr is null"}),c.on("error",S=>{D(S)}),c.on("close",S=>{let C;!$&&(C=this.C(k,s))&&l(C)?D(new Error(`command failed with error code ${S}: ${this.C(k,s)}`)):(this.g&&S===0&&(this.j=!0),D(null,"",!0))})}A(c,s,v){const g=new R.StringDecoder(s);return c.on("data",D=>{v(null,g.write(D))}),g}B(c){const s=[];return c.on("data",v=>{s.push(v)}),s}C(c,s){const v=new R.StringDecoder(s);return c.map(g=>v.write(g)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:s},v,g,D){g.indexOf(this.b)!==-1&&this.J(D,{base:v,relativePath:this.b,searchPath:this.N(c,this.b)});const $=k=>{const S=O.$oc(k),C=O.$nc(k);let I=s[C];I||(I=s[C]=[],$(C)),I.push({base:v,relativePath:k,basename:S,searchPath:this.N(c,k)})};g.forEach($)}H({rootEntries:c,pathToEntries:s},v,g){const D=this,$=this.t.get(v),k=this.b;function S(C){D.o++;const I=(0,f.$zL)(()=>C.map(F=>F.basename));for(let F=0,j=C.length;F<j;F++){const z=C[F],{relativePath:M,basename:T}=z;if($.test(M,T,k!==T?I:void 0))continue;const U=s[M];if(U)S(U);else{if(D.p++,M===k)continue;D.J(g,z)}if(D.j)break}}S(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,s,v,g,D){const $=c.folder,k=(0,f.$zL)(()=>v);this.w(v,(S,C)=>{if(this.l||this.j)return C(null);const I=s?[s,S].join(O.sep):S;if(this.t.get(c.folder.fsPath).test(I,S,this.a.filePattern!==S?k:void 0))return C(null);const F=[$.fsPath,I].join(O.sep);L.lstat(F,(j,z)=>{if(j||this.l||this.j)return C(null);this.L(F,z,(M,T)=>M||this.l||this.j?C(null):T.isDirectory()?(this.o++,this.M(F,z,(U,Z)=>U||this.l||this.j||(Z=Z||"",this.v[Z])?C(null):(this.v[Z]=!0,h.Promises.readdir(F).then(te=>{if(this.l||this.j)return C(null);this.I(c,I,te,g,q=>C(q||null))},te=>{C(null)})))):(this.p++,I===this.b||this.h&&w.$ag(T.size)&&T.size>this.h||this.J(g,{base:$.fsPath,relativePath:I,searchPath:this.N(c,I)}),C(null,void 0)))})},S=>{const C=S&&N.$Hb(S);return D(C&&C.length>0?C[0]:void 0)})}J(c,s){this.K(s)&&(!this.d||this.d(s.relativePath,O.$oc(s.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(s))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$uL)(c,this.c);if(this.b)return(0,f.$uL)(c,this.b,!1)}return!0}L(c,s,v){return s.isSymbolicLink()?L.stat(c,v):v(null,s)}M(c,s,v){return s.isSymbolicLink()?L.realpath(c,(g,D)=>g?v(g):v(null,D)):v(null,c)}N(c,s){return c.folderName?O.$kc(c.folderName,s):s}}e.$Enc=u;class o{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new u(c)}search(c,s,v){this.c.walk(this.a,this.b,c,s,(g,D)=>{v(g,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Fnc=o;class t{constructor(c,s){this.expression=c,this.c=s,this.d(c)}d(c){let s,v;Object.keys(c).filter(g=>c[g]).forEach(g=>{O.$jc(g)?(s=s||m.$lk(),s[g]=c[g]):(v=v||m.$lk(),v[g]=c[g])}),this.a=s&&m.$qk(s,{trimForExclusions:!0}),this.b=v&&m.$qk(v,{trimForExclusions:!0})}test(c,s,v){return this.b&&this.b(c,s,v)||this.a&&this.a(O.$kc(this.c,c),s,v)}getBasenameTerms(){const c=[];return this.a&&c.push(...m.$sk(this.a)),this.b&&c.push(...m.$sk(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...m.$tk(this.a)),this.b&&c.push(...m.$tk(this.b)),c}}function l(r){const c=r.trim().split(`
`),s=c[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return y.$1f(c[c.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}}),define(ke[390],Se([1,0,98,21,198,22]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fE=e.$0D=e.DecodeStreamErrorKind=e.$9D=e.$8D=e.$7D=e.$5D=e.$4D=e.$3D=e.$2D=void 0,e.$6D=N,e.$$D=w,e.$_D=h,e.$aE=f,e.$bE=a,e.$cE=n,e.$dE=r,e.$eE=c,e.$2D="utf8",e.$3D="utf8bom",e.$4D="utf16be",e.$5D="utf16le";function N(s){return[e.$2D,e.$3D,e.$4D,e.$5D].some(v=>v===s)}e.$7D=[254,255],e.$8D=[255,254],e.$9D=[239,187,191];const b=512,m=512,E=512*8,A=512*128;var P;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class p extends Error{constructor(v,g){super(v),this.decodeStreamErrorKind=g}}e.$0D=p;class y{static async create(v){let g;if(v!==e.$2D)g=(await(0,O.$1D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(v));else{const D=new TextDecoder;g={write($){return D.decode($,{stream:!0})},end(){return D.decode()}}}return new y(g)}constructor(v){this.a=v}write(v){return this.a.write(v)}end(){return this.a.end()}}function w(s,v){const g=v.minBytesRequiredForDetection??v.guessEncoding?E:m;return new Promise((D,$)=>{const k=(0,d.$ue)(z=>z.join("")),S=[];let C=0,I;const F=new R.$pe,j=async()=>{try{const z=await c({buffer:L.$Ge.concat(S),bytesRead:C},v.guessEncoding);if(z.seemsBinary&&v.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);z.encoding=await v.overwriteEncoding(z.encoding),I=await y.create(z.encoding);const M=I.write(L.$Ge.concat(S).buffer);k.write(M),S.length=0,C=0,D({stream:k,detected:z})}catch(z){F.cancel(),k.destroy(),$(z)}};(0,d.$ye)(s,{onData:async z=>{I?k.write(I.write(z.buffer)):(S.push(z),C+=z.byteLength,C>=g&&(s.pause(),await j(),setTimeout(()=>s.resume())))},onError:z=>k.error(z),onEnd:async()=>{I||await j(),k.end(I?.end())}},F.token)})}async function h(s,v,g){const $=(await(0,O.$1D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(v),g);let k=!1,S=!1;return{read(){if(S)return null;const C=s.read();if(typeof C!="string"){if(S=!0,!k&&g?.addBOM)switch(v){case e.$2D:case e.$3D:return L.$Ge.wrap(Uint8Array.from(e.$9D));case e.$4D:return L.$Ge.wrap(Uint8Array.from(e.$7D));case e.$5D:return L.$Ge.wrap(Uint8Array.from(e.$8D))}const I=$.end();return I&&I.length>0?(k=!0,L.$Ge.wrap(I)):null}return k=!0,L.$Ge.wrap($.write(C))}}}async function f(s){return(await(0,O.$1D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(s))}function a(s){return s===e.$3D||s===null?e.$2D:s}function n(s,v){if(!s||v<e.$7D.length)return null;const g=s.readUInt8(0),D=s.readUInt8(1);if(g===e.$7D[0]&&D===e.$7D[1])return e.$4D;if(g===e.$8D[0]&&D===e.$8D[1])return e.$5D;if(v<e.$9D.length)return null;const $=s.readUInt8(2);return g===e.$9D[0]&&D===e.$9D[1]&&$===e.$9D[2]?e.$3D:null}const i=["ascii","utf-16","utf-32"];async function u(s){const v=await(0,O.$1D)("jschardet","dist/jschardet.min.js"),g=s.slice(0,A),D=l(g.buffer),$=v.detect(D);if(!$||!$.encoding)return null;const k=$.encoding.toLowerCase();return 0<=i.indexOf(k)?null:t($.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(s){const v=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[v]||v}function l(s){let v="";for(let g=0;g<s.length;g++)v+=String.fromCharCode(s[g]);return v}function r(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const v=s.match(/windows(\d+)/);return v?"windows-"+v[1]:s}}}function c({buffer:s,bytesRead:v},g){let D=n(s,v),$=!1;if(D!==e.$4D&&D!==e.$5D&&s){let k=!0,S=!0,C=!1;for(let I=0;I<v&&I<b;I++){const F=I%2===1,j=s.readUInt8(I)===0;if(j&&(C=!0),k&&(F&&!j||!F&&j)&&(k=!1),S&&(F&&j||!F&&!j)&&(S=!1),j&&!k&&!S)break}C&&(k?D=e.$5D:S?D=e.$4D:$=!0)}return g&&!$&&!D&&s?u(s.slice(0,v)).then(k=>({seemsBinary:!1,encoding:k})):{seemsBinary:$,encoding:D}}e.$fE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[161],Se([1,0,390,32,160]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=void 0;class R extends O.$xmc{constructor(b,m,E=L,A="searchProcess"){super({query:b,provider:m},{readdir:P=>E.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,d.$dE)(P)},A)}}e.$Nnc=R}),define(ke[162],Se([1,0,54,406,389,19,74,35,14,2,37,94,407,387,123]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0,e.$Inc=t,e.$Jnc=r,e.$Knc=s,e.$Lnc=v,e.$Mnc=D;const h=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(k){this.a=k}provideTextSearchResults(k,S,C,I){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...S,folder:S.folder.toString()})}`),new Promise((F,j)=>{I.onCancellationRequested(()=>K());const z=t(k,S),M=S.folder.fsPath,T=z.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.a.appendLine(`${h} ${T}
 - cwd: ${M}`);let U=d.spawn(h,z,{cwd:M});U.on("error",ve=>{console.error(ve),this.a.appendLine("Error: "+(ve&&ve.message)),j((0,A.$qL)(new A.$oL(ve&&ve.message,A.SearchErrorCode.rgProcessError)))});let Z=!1;const te=new i(S.maxResults,S.folder,S.previewOptions);te.on("result",ve=>{Z=!0,ie="",C.report(ve)});let q=!1;const K=()=>{q=!0,U?.kill(),te?.cancel()};let Y=!1;te.on("hitLimit",()=>{Y=!0,K()});let ie="";U.stdout.on("data",ve=>{te.handleData(ve),Z||(ie+=ve)});let $e=!1;U.stdout.once("data",()=>$e=!0);let ue="";U.stderr.on("data",ve=>{const _=ve.toString();this.a.appendLine(_),ue.length+_.length<1e6&&(ue+=_)}),U.on("close",()=>{if(this.a.appendLine($e?"Got data from stdout":"No data from stdout"),this.a.appendLine(Z?"Got result from parser":"No result from parser"),ie&&this.a.appendLine(`Got data without result: ${ie}`),this.a.appendLine(""),q)F({limitHit:Y});else{te.flush(),U=null;let ve;ue&&!$e&&(ve=a(ue))?j((0,A.$qL)(new A.$oL(ve.message,ve.code))):F({limitHit:Y})}})})}}e.$Gnc=f;function a($){const k=$.split(`
`),S=k[0].trim();if(k.some(I=>I.startsWith("regex parse error")))return new A.$oL(n(k),A.SearchErrorCode.regexParseError);const C=S.match(/grep config error: unknown encoding: (.*)/);if(C)return new A.$oL(`Unknown encoding: ${C[1]}`,A.SearchErrorCode.unknownEncoding);if(S.startsWith("error parsing glob"))return new A.$oL(S.charAt(0).toUpperCase()+S.substr(1),A.SearchErrorCode.globParseError);if(S.startsWith("the literal"))return new A.$oL(S.charAt(0).toUpperCase()+S.substr(1),A.SearchErrorCode.invalidLiteral);if(S.startsWith("PCRE2: error compiling pattern"))return new A.$oL(S,A.SearchErrorCode.regexParseError)}function n($){const k=["Regex parse error"],S=$.filter(C=>C.startsWith("PCRE2:"));if(S.length>=1){const C=S[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const I=C.split(":")[1];k.push(":"+I)}}return k.join("")}class i extends L.EventEmitter{constructor(k,S,C){super(),this.g=k,this.h=S,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new O.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,S){return super.on(k,S),this}handleData(k){if(this.b)return;const S=typeof k=="string"?k:this.d.write(k);this.k(S)}k(k){let S=k.indexOf(`
`);const C=this.a+k;if(S>=0)S+=this.a.length;else{this.a=C;return}let I=0;for(;S>=0;)this.m(C.substring(I,S).trim()),I=S+1,S=C.indexOf(`
`,I);this.a=C.substring(I)}m(k){if(this.b||!k)return;let S;try{S=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(S.type==="match"){const C=u(S.data.path),I=E.URI.joinPath(this.h,C),F=this.n(S.data,I);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(S.type==="context"){const C=u(S.data.path),I=E.URI.joinPath(this.h,C);this.o(S.data,I).forEach(j=>this.p(j))}}n(k,S){const C=k.line_number-1,I=u(k.lines),F=Buffer.from(I);let j=0,z=0,M=C;k.submatches.length===0&&k.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const T=(0,R.$Hb)(k.submatches.map((U,Z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const te=u(U.match),q=F.slice(j,U.start).toString(),K=o(q),Y=K.numLines>0?K.lastLineLength:K.lastLineLength+z,ie=o(te),$e=K.numLines+M,ue=ie.numLines+$e,ve=ie.numLines>0?ie.lastLineLength:ie.lastLineLength+Y;return j=U.end,z=ve,M=ue,new P.$$K($e,Y,ue,ve)}));return(0,w.$znc)(S,I,T,this.j)}o(k,S){const C=u(k.lines),I=k.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((F,j)=>({text:F,uri:S,lineNumber:I+j}))}p(k){this.emit("result",k)}}e.$Hnc=i;function u($){return $.bytes?Buffer.from($.bytes,"base64").toString():$.text}function o($){const k=/\n/g;let S=0,C=-1,I;for(;I=k.exec($);)S++,C=I.index;const F=C>=0?$.length-C-1:$.length;return{numLines:S,lastLineLength:F}}function t($,k){const S=["--hidden","--no-require-git"];S.push($.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:I}=(0,N.$K)(k.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const j=new Set;I.forEach(z=>{j.add(z)}),S.push("-g","!*"),j.forEach(z=>{l(z).map(w.$ync).forEach(M=>{S.push("-g",M)})})}C&&C.length&&C.forEach(j=>{S.push("-g",j)}),k.excludes.map(w.$ync).forEach(j=>S.push("-g",`!${j}`)),k.maxFileSize&&S.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||S.push("--no-ignore-parent"):S.push("--no-ignore"),k.followSymlinks&&S.push("--follow"),k.encoding&&k.encoding!=="utf8"&&S.push("--encoding",k.encoding),$.pattern==="--"&&($.isRegExp=!0,$.pattern="\\-\\-"),$.isMultiline&&!$.isRegExp&&($.pattern=(0,m.$af)($.pattern),$.isRegExp=!0),k.usePCRE2&&S.push("--pcre2"),S.push("--crlf"),$.isRegExp&&($.pattern=r($.pattern),S.push("--engine","auto"));let F;if($.isWordMatch){const z=(0,m.$jf)($.pattern,!!$.isRegExp,{wholeWord:$.isWordMatch}).source.replace(/\\\//g,"/");S.push("--regexp",z)}else if($.isRegExp){let j=s($.pattern);j=v(j),S.push("--regexp",j)}else F=$.pattern,S.push("--fixed-strings");return S.push("--no-config"),k.useGlobalIgnoreFiles||S.push("--no-ignore-global"),S.push("--json"),$.isMultiline&&S.push("--multiline"),k.beforeContext&&S.push("--before-context",k.beforeContext+""),k.afterContext&&S.push("--after-context",k.afterContext+""),S.push("--"),F&&S.push(F),S.push("."),S}function l($){return D($).flatMap(S=>{const C=(0,b.$ok)(S,"/");return C.map((I,F)=>C.slice(0,F+1).join("/"))})}function r($){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;$.match(k);)$=$.replace(k,"$1\\x{$2}");const S=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;$.match(S);)$=$.replace(S,"$1\\x{$2}");return $}const c=$=>$.type==="Assertion"&&$.kind==="lookbehind";function s($){let k;try{k=new p.RegExpParser().parsePattern($)}catch{return $}let S="",C=0;const I=(z,M,T)=>{S+=$.slice(C,z)+T,C=M},F=[];return new p.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const M=F[0];if(!M)I(z.start,z.end,"\\r?\\n");else if(!F.some(c))if(M.type==="CharacterClass")if(M.negate){const T=$.slice(M.start+2,z.start)+$.slice(z.end,M.end-1);M.parent?.type==="Quantifier"?I(M.start,M.end,T?`[^${T}]`:"."):I(M.start,M.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=$.slice(M.start+1,z.start)+$.slice(z.end,M.end-1);I(M.start,M.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else M.type==="Quantifier"&&I(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){F.unshift(z)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(z){F.unshift(z)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(z){F.unshift(z)},onCharacterClassLeave(){F.shift()},onAssertionEnter(z){c(z)&&F.push(z)},onAssertionLeave(z){F[0]===z&&F.shift()}}).visit(k),S+=$.slice(C),S}function v($){return $.replace(/\n/g,"\\r?\\n")}function g($){let k=!1,S=!1,C="",I="";for(let F=0;F<$.length;F++){const j=$[F];switch(j){case"\\":S?(k?I+="\\"+j:C+="\\"+j,S=!1):S=!0;break;case"{":if(S)k?I+=j:C+=j,S=!1;else{if(k)return{strInBraces:C+"{"+I+"{"+$.substring(F+1)};k=!0}break;case"}":if(S)k?I+=j:C+=j,S=!1;else{if(k)return{fixedStart:C,strInBraces:I,fixedEnd:$.substring(F+1)};C+=j}break;default:k?I+=(S?"\\":"")+j:C+=(S?"\\":"")+j,S=!1;break}}return{strInBraces:C+(k?"{"+I:"")}}function D($){const{fixedStart:k,strInBraces:S,fixedEnd:C}=g($);if(k===void 0||C===void 0)return[S];let I=(0,b.$ok)(S,",");I.length||(I=[""]);const F=D(C);return I.flatMap(j=>{const z=k+j;return F.map(M=>z+M)})}}),define(ke[391],Se([1,0,22,162,109,15]),function(le,e,d,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=void 0;class N{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,A,P,p){const y=new L.$Gnc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const w={...A,folder:A.folder.with({scheme:R.Schemas.file})},h=new O.$0v(f=>P.report({...f,uri:f.uri.with({scheme:A.folder.scheme})}));return this.c(p,f=>y.provideTextSearchResults(E,w,h,f))}else return this.c(p,w=>y.provideTextSearchResults(E,A,P,w))}async c(E,A){const P=b(E);this.a.add(P);const p=await A(P.token);return this.a.delete(P),p}d(){this.a.forEach(E=>E.cancel())}}e.$Qnc=N;function b(m){const E=new d.$pe;return m.onCancellationRequested(()=>E.cancel()),E}}),define(ke[392],Se([1,0,32,162,161]),function(le,e,d,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=void 0;class R{constructor(m){this.a=m}search(m,E,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(y){A({message:y})}},p=new O.$Nnc(this.a,new L.$Gnc(P),d);return new Promise((y,w)=>p.search(h=>{E(h.map(N))},m).then(h=>y({limitHit:h.limitHit,type:"success",stats:h.stats}),w))}}e.$Onc=R;function N(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((m,E)=>{if(E.ranges){const A=E;return m+(Array.isArray(A.ranges)?A.ranges.length:1)}else return m+1},0)}}}),define(ke[393],Se([1,0,19,7,13,4,133,17,40,2,33,37,388,392]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=void 0;class w{static{this.a=512}constructor(u="searchProcess"){this.d=u,this.b=Object.create(null)}fileSearch(u){let o;const t=a(u),l=new R.$ee({onDidAddFirstListener:()=>{o=(0,L.$jh)(r=>this.doFileSearchWithEngine(p.$Fnc,t,c=>l.fire(c),r)),o.then(r=>l.fire(r),r=>l.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return l.event}textSearch(u){let o;const t=a(u),l=new R.$ee({onDidAddFirstListener:()=>{o=(0,L.$jh)(r=>this.f(t,c=>l.fire(c),r)),o.then(r=>l.fire(r),r=>l.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return l.event}f(u,o,t){return u.maxFileSize=this.g().maxFileSize,new y.$Onc(u).search(t,o,o)}g(){return{maxFileSize:16*A.$yl.GB}}doFileSearch(u,o,t){return this.doFileSearchWithEngine(p.$Fnc,u,o,t)}doFileSearchWithEngine(u,o,t,l,r=w.a){let c=0;const s=g=>{Array.isArray(g)?(c+=g.length,t(g.map(D=>this.h(D)))):g.relativePath?(c++,t(this.h(g))):t(g)};if(o.sortByScore){let g=this.l(o,s,l);if(!g){const D=o.maxResults?Object.assign({},o,{maxResults:null}):o,$=new u(D);g=this.j($,o,t,s,l)}return new Promise((D,$)=>{g.then(([k,S])=>{const C=S.map(I=>this.h(I));this.o(C,t,r),D(k)},$)})}const v=new u(o);return this.r(v,s,r,l).then(g=>({limitHit:g.limitHit,type:"success",stats:{detailStats:g.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}h(u){return{path:u.base?(0,b.$kc)(u.base,u.relativePath):u.relativePath}}j(u,o,t,l,r){const c=new R.$ee;let s=(0,L.$jh)(g=>{let D=[];const $=k=>{Array.isArray(k)?D=k:(l(k),c.fire(k))};return this.r(u,$,-1,g).then(k=>[k,D])}),v;if(o.cacheKey){v=this.k(o.cacheKey);const g={promise:s,event:c.event,resolved:!1};v.resultsToSearchCache[o.filePattern||""]=g,s.then(()=>{g.resolved=!0},D=>{delete v.resultsToSearchCache[o.filePattern||""]}),s=this.s(s)}return s.then(([g,D])=>{const $=v?v.scorerCache:Object.create(null),k=(typeof o.maxResults!="number"||o.maxResults>0)&&m.$ae.create(!1);return this.n(o,D,$,r).then(S=>{const C=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:g.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:S.length},messages:g.messages,limitHit:g.limitHit||typeof o.maxResults=="number"&&D.length>o.maxResults},S]})})}k(u){const o=this.b[u];return o||(this.b[u]=new h)}l(u,o,t){const l=u.cacheKey&&this.b[u.cacheKey];if(!l)return;const r=this.q(l,u.filePattern||"",o,t);if(r)return r.then(([c,s,v])=>{const g=m.$ae.create(!1);return this.n(u,s,l.scorerCache,t).then(D=>{const $=g.elapsed(),k={fromCache:!0,detailStats:v,type:this.d,resultCount:s.length,sortingTime:$};return[{type:"success",limitHit:c.limitHit||typeof u.maxResults=="number"&&s.length>u.maxResults,stats:k},D]})})}n(u,o,t,l){const r=(0,N.$xr)(u.filePattern||""),c=(v,g)=>(0,N.$wr)(v,g,r,!0,f,t),s=typeof u.maxResults=="number"?u.maxResults:Number.MAX_VALUE;return d.$Gb(o,c,s,1e4,l)}o(u,o,t){if(t&&t>0)for(let l=0;l<u.length;l+=t)o(u.slice(l,l+t));else o(u)}q(u,o,t,l){const r=m.$ae.create(!1),c=o.indexOf(b.sep)>=0;let s;for(const $ in u.resultsToSearchCache)if(o.startsWith($)){if(c&&$.indexOf(b.sep)<0&&$!=="")continue;const k=u.resultsToSearchCache[$];s={promise:this.s(k.promise),event:k.event,resolved:k.resolved};break}if(!s)return null;const v=r.elapsed(),g=m.$ae.create(!1),D=s.event(t);return l&&l.onCancellationRequested(()=>{D.dispose()}),s.promise.then(([$,k])=>{if(l&&l.isCancellationRequested)throw(0,O.$6)();const S=[],C=(0,N.$xr)(o).normalizedLowercase;for(const I of k)(0,P.$uL)(I,C)&&S.push(I);return[$,S,{cacheWasResolved:s.resolved,cacheLookupTime:v,cacheFilterTime:g.elapsed(),cacheEntryCount:k.length}]})}r(u,o,t,l){return new Promise((r,c)=>{let s=[];l?.onCancellationRequested(()=>u.cancel()),u.search(v=>{v&&(t?(s.push(v),t>0&&s.length>=t&&(o(s),s=[])):o(v))},v=>{o(v)},(v,g)=>{s.length&&o(s),v?(o({message:"Search finished. Error: "+v.message}),c(v)):(o({message:"Search finished. Stats: "+JSON.stringify(g.stats)}),r(g))})})}clearCache(u){return delete this.b[u],Promise.resolve(void 0)}s(u){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return u.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return u.finally(o)}}}}e.$Pnc=w;class h{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(i){return(0,b.$oc)(i.relativePath)}getItemDescription(i){return(0,b.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function a(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(u=>E.URI.revive(u))}}function n(i){return{...i,folder:E.URI.revive(i.folder)}}}),define(ke[394],Se([1,0,3,15,2,32,11,28,20,97,68,37,393,391,123,161]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0;let f=class extends E.$Cmc{constructor(n,i,u,o){super(n,u,o),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new d.$Uc;const t=new w.$Anc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.vscodeUserData,new y.$Qnc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new w.$Anc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.file,new y.$Qnc(n))),this.A.add(this.C(L.Schemas.file,new p.$Pnc("fileSearchProvider")))}C(n,i){const u=this.d++;return this.y=i,this.x=u,this.c.$registerFileSearchProvider(u,this.s(n)),(0,d.$Tc)(()=>{this.y=null,this.c.$unregisterProvider(u)})}$provideFileSearchResults(n,i,u,o){const t=(0,E.$Dmc)(u);if(n===this.x){const l=Date.now();return this.D(n,i,t,o).then(r=>{const c=Date.now()-l;return this.q.debug(`Ext host file search time: ${c}ms`),r})}return super.$provideFileSearchResults(n,i,u,o)}doInternalFileSearchWithCustomCallback(n,i,u){const o=t=>{if((0,P.$tL)(t)&&(t=[t]),Array.isArray(t)){u(t.map(l=>O.URI.file(l.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,o,i)}async D(n,i,u,o){return this.doInternalFileSearchWithCustomCallback(u,o,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new h.$Nnc(n,i,void 0,"textSearchProvider")}};e.$Rnc=f,e.$Rnc=f=Ke([We(0,m.$qP),We(1,b.$GP),We(2,A.$tlc),We(3,N.$3j)],f)}),define(ke[124],Se([1,0,408,63,64,409,21,13,4,3,17,12,30,82,83]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$ni=e.$mi=e.$li=void 0,e.$oi=r,e.$pi=c,e.$ri=g,e.$si=D;class h{traceSocketEvent(k,S){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,S)}constructor(k,S=""){this.f=!0,this.debugLabel=S,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,b.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const S=C=>{this.traceSocketEvent("read",C),k(N.$Ge.wrap(C))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(k){const S=C=>{k({type:0,hadError:C,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(k){const S=()=>{k()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,b.$1)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,b.$1)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$li=h;var f;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var a;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(a||(a={}));class n extends E.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,S){this.socket.traceSocketEvent(k,S)}constructor(k,S,C,I){super(),this.f=this.B(new m.$ee),this.g=this.B(new m.$ee),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:C?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new i(this,S,C,I,this.f,(F,j)=>this.m(F,j))),this.B(this.a.onError(F=>{console.error(F),(0,b.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new w.$gi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let S=0;for(;S<k.byteLength;)this.a.writeMessage(k.slice(S,Math.min(S+262144,k.byteLength)),{compressed:!0,opcode:2}),S+=262144}m(k,{compressed:S,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let I=2;k.byteLength<126?I+=0:k.byteLength<2**16?I+=2:I+=8;const F=N.$Ge.alloc(I),j=S?64:0,z=C&15;if(F.writeUInt8(128|j|z,0),k.byteLength<126)F.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){F.writeUInt8(126,1);let M=1;F.writeUInt8(k.byteLength>>>8&255,++M),F.writeUInt8(k.byteLength>>>0&255,++M)}else{F.writeUInt8(127,1);let M=1;F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(0,++M),F.writeUInt8(k.byteLength>>>24&255,++M),F.writeUInt8(k.byteLength>>>16&255,++M),F.writeUInt8(k.byteLength>>>8&255,++M),F.writeUInt8(k.byteLength>>>0&255,++M)}this.socket.write(N.$Ge.concat([F,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),C=S.readUInt8(0),I=(C&128)>>>7,F=(C&64)>>>6,j=C&15,z=S.readUInt8(1),M=(z&128)>>>7,T=z&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),C=S.readUInt8(1),I=(C&128)>>>7;let F=C&127,j=1;F===126?F=S.readUInt8(++j)*2**8+S.readUInt8(++j):F===127&&(F=S.readUInt8(++j)*0+S.readUInt8(++j)*0+S.readUInt8(++j)*0+S.readUInt8(++j)*0+S.readUInt8(++j)*2**24+S.readUInt8(++j)*2**16+S.readUInt8(++j)*2**8+S.readUInt8(++j));let z=0;I&&(z=S.readUInt8(++j)*2**24+S.readUInt8(++j)*2**16+S.readUInt8(++j)*2**8+S.readUInt8(++j)),this.j.state=3,this.j.readLen=F,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),t(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(S,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(S,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await m.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$mi=n;class i extends E.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:N.$Ge.alloc(0)}constructor(k,S,C,I,F,j){super(),this.n=k,this.r=F,this.s=j,this.a=this.B(new m.$ee),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new m.$ee),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new m.$ee),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,S?(this.b=this.B(new u(this.n,I,C,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(k,S){this.g.push({data:k,options:S}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:S}=this.g.shift();if(this.f&&S.compressed){const C=await this.w(this.f,k);this.s(C,S)}else this.s(k,{...S,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,S){return new Promise((C,I)=>{k.write(S),k.flush(F=>C(F))})}acceptFrame(k,S,C){this.h.push({data:k,isCompressed:S,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const S=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(S)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,S,C){return new Promise((I,F)=>{k.write(S),C&&k.write(N.$Ge.fromByteArray([0,0,255,255])),k.flush(j=>I(j))})}}class u extends E.$Vc{get recordedInflateBytes(){return this.j?N.$Ge.concat(this.f):N.$Ge.alloc(0)}constructor(k,S,C,I){super(),this.h=k,this.j=S,this.a=this.B(new m.$ee),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(I),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(N.$Ge.wrap(F))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=N.$Ge.concat(this.g);this.g.length=0,k(S)})}}class o extends E.$Vc{constructor(k,S){super(),this.g=k,this.a=this.B(new m.$ee),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(N.$Ge.wrap(C))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=N.$Ge.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),k(S)})}}function t($,k){if(k===0)return;const S=$.byteLength>>>2;for(let M=0;M<S;M++){const T=$.readUInt32BE(M*4);$.writeUInt32BE(T^k,M*4)}const C=S*4,I=$.byteLength-C,F=k>>>24&255,j=k>>>16&255,z=k>>>8&255;I>=1&&$.writeUInt8($.readUInt8(C)^F,C),I>=2&&$.writeUInt8($.readUInt8(C+1)^j,C+1),I>=3&&$.writeUInt8($.readUInt8(C+2)^z,C+2)}e.$ni=process.env.XDG_RUNTIME_DIR;const l={2:107,1:103};function r(){const $=(0,p.$Sg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const k=process.platform!=="darwin"&&e.$ni?e.$ni:(0,O.tmpdir)(),S=(0,A.$kc)(k,`vscode-ipc-${$}.sock`);return s(S),S}function c($,k,S){const I=(0,d.createHash)("sha256").update($).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${S}-${k}-sock`;const F=S.substr(0,4),j=k.substr(0,6);let z;return process.platform!=="darwin"&&e.$ni&&!process.env.VSCODE_PORTABLE?z=(0,A.$kc)(e.$ni,`vscode-${I}-${F}-${j}.sock`):z=(0,A.$kc)($,`${F}-${j}.sock`),s(z),z}function s($){const k=l[P.$u];typeof k=="number"&&$.length>=k&&console.warn(`WARNING: IPC handle "${$}" is longer than ${k} chars, try a shorter --user-data-dir`)}class v extends y.$ai{static b(k){const S=m.Event.fromNodeEventEmitter(k,"connection");return m.Event.map(S,C=>({protocol:new w.$hi(new h(C,"ipc-server-connection")),onDidClientDisconnect:m.Event.once(m.Event.fromNodeEventEmitter(C,"close"))}))}constructor(k){super(v.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$qi=v;function g($){return new Promise((k,S)=>{const C=(0,L.createServer)();C.on("error",S),C.listen($,()=>{C.removeListener("error",S),k(new v(C))})})}function D($,k){return new Promise((S,C)=>{const I=(0,L.createConnection)($,()=>{I.removeListener("error",C),S(w.$ii.fromSocket(new h(I,`ipc-client${k}`),k))});I.once("error",C)})}}),define(ke[395],Se([1,0,63,64,178,124,7,3,12,55,11,108,272,273,111,88,21]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=e.$Edc=e.$Ddc=e.$Cdc=void 0;async function a(t,l,r,c,s){let v;for(let g=3;g&&(v?.dispose(),v=await new n(t,l,r,c,s).waitForReady(),!(s&&O.$Vg[s]||!O.$Vg[v.tunnelLocalPort]));g--);return v}class n extends b.$Vc{constructor(l,r,c,s,v){super(),this.m=r,this.n=v,this.privacy=h.TunnelPrivacyId.Private,this.j=new Map,this.a=l,this.b=d.createServer(),this.c=new N.$vh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=g=>this.r(g),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const l=this.n??this.tunnelRemotePort,r=(0,h.$kw)(this.m)?"0.0.0.0":"127.0.0.1";let c=await(0,O.$Wg)(l,2,1e3,r),s=null;return this.b.listen(c,this.m),await this.c.wait(),s=this.b.address(),s||(c=0,this.b.listen(c,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(l){l.pause();const r=(0,h.$iw)(this.tunnelRemoteHost)||(0,h.$kw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,p.$Sl)(this.a,r,this.tunnelRemotePort),s=c.getSocket(),v=c.readEntireBuffer();c.dispose(),v.byteLength>0&&l.write(v.buffer),l.on("end",()=>{l.localAddress&&this.j.delete(l.localAddress),s.end()}),l.on("close",()=>s.end()),l.on("error",()=>{l.localAddress&&this.j.delete(l.localAddress),s instanceof R.$li?s.socket.destroy():s.end()}),s instanceof R.$li?this.t(l,s):this.s(l,s),l.localAddress&&this.j.set(l.localAddress,()=>{l.end(),s.end()})}s(l,r){r.onClose(()=>l.destroy()),r.onEnd(()=>l.end()),r.onData(c=>l.write(c.buffer)),l.on("data",c=>r.write(f.$Ge.wrap(c))),l.resume()}t(l,r){const c=r.socket;c.on("end",()=>l.end()),c.on("close",()=>l.end()),c.on("error",()=>{l.destroy()}),c.pipe(l),l.pipe(c)}}e.$Cdc=n;let i=class extends h.$nw{constructor(l,r,c,s,v){super(r,v),this.v=l,this.w=c,this.y=s}isPortPrivileged(l){return(0,h.$lw)(l,this.m,m.OS,L.release())}t(l,r,c,s,v,g,D,$){const k=this.s(r,c);if(k)return++k.refcount,k.value;if((0,h.$ew)(l))return this.u(l,r,c,v,g,D,$);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${c} on local port ${v}.`);const S={commit:this.y.commit,quality:this.y.quality,addressProvider:l,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=a(S,s,r,c,v);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,c,C),C}}};e.$Ddc=i,e.$Ddc=i=Ke([We(0,y.$Ml),We(1,A.$3j),We(2,w.$Pl),We(3,P.$jk),We(4,E.$3i)],i);let u=class extends i{constructor(l,r,c,s,v){super(l,r,c,s,v)}};e.$Edc=u,e.$Edc=u=Ke([We(0,y.$Ml),We(1,A.$3j),We(2,w.$Pl),We(3,P.$jk),We(4,E.$3i)],u);let o=class extends b.$Vc{constructor(l,r,c,s,v){super(),this.b=l,this.c=r,this.f=c,this.g=s,this.h=v,this.a=new Map}async openTunnel(l,r,c,s,v,g,D,$,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${s} on local port ${g}.`),!this.a.has(l)){const S=new u(this.b,this.c,this.g,this.f,this.h);this.B(S),this.a.set(l,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(r,c,s,v,g,D,$,k)}};e.$Fdc=o,e.$Fdc=o=Ke([We(0,y.$Ml),We(1,A.$3j),We(2,P.$jk),We(3,w.$Pl),We(4,E.$3i)],o)}),define(ke[396],Se([1,0,124,292,53,34,2,11,42]),function(le,e,d,L,O,R,N,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SP=e.$RP=void 0;class E{constructor(p,y,w){this.b=p,this.c=y,this.f=w,this.a=L.createServer((h,f)=>this.h(h,f)),this.g().catch(h=>(y.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,y){const w=(f,a)=>{y.writeHead(f,{"content-type":"application/json"}),y.end(JSON.stringify(a||null),n=>n&&this.c.error(n))},h=[];p.setEncoding("utf8"),p.on("data",f=>h.push(f)),p.on("end",async()=>{try{const f=JSON.parse(h.join(""));let a;switch(f.type){case"open":a=await this.i(f);break;case"openExternal":a=await this.j(f);break;case"status":a=await this.l(f);break;case"extensionManagement":a=await this.k(f);break;default:w(404,`Unknown message type: ${f.type}`);break}w(200,a)}catch(f){const a=f instanceof Error?f.message:JSON.stringify(f);w(500,a),this.c.error("Error while processing pipe request",f)}})}async i(p){const{fileURIs:y,folderURIs:w,forceNewWindow:h,diffMode:f,mergeMode:a,addMode:n,forceReuseWindow:i,gotoLineMode:u,waitMarkerFilePath:o,remoteAuthority:t}=p,l=[];if(Array.isArray(w))for(const v of w)try{l.push({folderUri:N.URI.parse(v)})}catch{}if(Array.isArray(y))for(const v of y)try{(0,m.$2i)(v)?l.push({workspaceUri:N.URI.parse(v)}):l.push({fileUri:N.URI.parse(v)})}catch{}const r=o?N.URI.file(o):void 0,s={forceNewWindow:h,diffMode:f,mergeMode:a,addMode:n,gotoLineMode:u,forceReuseWindow:i,preferNewWindow:!i&&!r&&!n,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",l,s)}async j(p){for(const y of p.uris){const w=N.URI.parse(y),h=w.scheme==="file"?w:y;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k(p){const y=h=>h?.map(f=>/\.vsix$/i.test(f)?N.URI.parse(f):f),w={list:p.list,install:y(p.install),uninstall:y(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&O.existsSync(this.f)&&O.unlinkSync(this.f)}}e.$RP=E;let A=class extends E{constructor(p,y){super(p,y,(0,d.$oi)())}};e.$SP=A,e.$SP=A=Ke([We(0,R.$MP),We(1,b.$3j)],A)}),define(ke[397],Se([1,0,59,384,379,291,49,366,2,15,8,396,104,325,365]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;class h extends O.$lnc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,u=i._load;i._load=function(r,c,s){return r=t(r),n.a.has(r)?n.a.get(r).load(r,m.URI.file((0,p.$7q)(c.filename)),v=>u.apply(this,[v,c,s])):u.apply(this,arguments)};const o=i._resolveLookupPaths;i._resolveLookupPaths=(l,r)=>o.call(this,t(l),r);const t=l=>{for(const r of n.b){const c=r(l);if(c){l=c;break}}return l}}}class f extends N.$_lc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(y.$Unc);const n=this.h.invokeFunction(L.$hnc);if(this.h.createInstance(b.$Tnc),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(P.$SP);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this.h.createInstance(w.$Vnc),await this.h.createInstance(h,n,{mine:this.J,all:this.L}).install(),d.mark("code/extHost/didInitAPI");const u=await this.m.getConfigProvider();await(0,R.$Snc)(this.j,u,this,this.s,this.z,this.f),d.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,u){if(i.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let o=null;u.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&d.mark(`code/extHost/willLoadExtensionCode/${t}`),o=le.__$__nodeRequire(i.fsPath)}finally{t&&d.mark(`code/extHost/didLoadExtensionCode/${t}`),u.codeLoadingStop()}return o}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const u=n[i];u===null?delete process.env[i]:process.env[i]=u}}}e.$Wnc=f}),define(ke[398],Se([1,0,54,21,4,3,126,12,23,2,32,11,271,67,111,88,395,28,20,71,373]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=void 0,e.$Xnc=o,e.$Ync=t,e.$Znc=l,e.$1nc=r,e.$2nc=s,e.$3nc=v,e.$4nc=g;function o(k){const S=k.trim().split(`
`),C=[];return S.forEach(F=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);j&&j.length>=3&&C.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),C.reduce((F,j)=>(F[j.socket]=j,F),{})}function t(...k){const S=[].concat(...k.map(r));return[...new Map(S.filter(C=>C.st==="0A").map(C=>{const I=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:l(I[0]),port:parseInt(I[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function l(k){let S="";if(k.length===8)for(let C=k.length-2;C>=0;C-=2)S+=parseInt(k.substr(C,2),16),C!==0&&(S+=".");else for(let C=0;C<k.length;C+=8){const I=k.substring(C,C+8);let F="";for(let j=8;j>=2;j-=2)F+=I.substring(j-2,j),(j===6||j===2)&&(F=parseInt(F,16).toString(16),S+=`${F}`,F="",C+j!==k.length-6&&(S+=":"))}return S}function r(k){const S=k.trim().split(`
`),C=S.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return S.map(F=>F.trim().split(/\s+/).reduce((j,z,M)=>(j[C[M]||M]=z,j),{}))}function c(k){return!!k.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||k.indexOf("out/server-main.js")!==-1||k.indexOf("_productName=VSCode")!==-1}function s(k){const S=k.trim().split(`
`),C=[];return S.forEach(I=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);F&&F.length>=4&&C.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),C}async function v(k,S,C){const I=C.reduce((j,z)=>(j[z.pid]=z,j),{}),F=[];return k.forEach(({socket:j,ip:z,port:M})=>{const T=S[j]?S[j].pid:void 0,U=T?I[T]?.cmd:void 0;T&&U&&!c(U)&&F.push({host:z,port:M,detail:U,pid:T})}),F}function g(k,S,C){const I=new Map,F=s(S);for(const j of k){const z=C.get(j.port);if(z){I.set(j.port,z);continue}const M=F.find(T=>T.cmd.includes(`${j.port}`));if(M){let T=M,U;do U=F.find(Z=>Z.ppid===T.pid),U&&(T=U);while(U);I.set(j.port,{host:j.ip,port:j.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else I.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return I}let D=class extends i.$uDb{constructor(S,C,I,F){super(S,C,I),this.D=C,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(S){if(S&&this.C)return;this.C=S;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new N.$Em;let F=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(U=>(0,h.$iw)(U.host)||(0,h.$kw)(U.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(U=>U.port).join(", ")}`);const M=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),F++>3&&I.update(M),(!C||JSON.stringify(C)!==JSON.stringify(z))&&(C=z,await this.a.$onFoundNewCandidates(C));const T=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(U=>setTimeout(()=>U(),T))}}G(S){return Math.max(S*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(S=>S.port).join(", ")}`)}async I(){let S="",C="";try{S=await A.Promises.readFile("/proc/net/tcp","utf8"),C=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(S,C),F=await new Promise(q=>{(0,d.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(K,Y,ie)=>{q(Y)})}),j=o(F),z=await A.Promises.readdir("/proc"),M=[];for(const q of z)try{const K=Number(q),Y=m.$0g(E.URI.file("/proc"),q);if((await A.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN(K)){const $e=await A.Promises.readlink(m.$0g(Y,"cwd").fsPath),ue=await A.Promises.readFile(m.$0g(Y,"cmdline").fsPath,"utf8");M.push({pid:K,cwd:$e,cmd:ue})}}catch{}const T=[],U=I.filter(q=>{const K=j[q.socket];return K||T.push(q),K}),Z=v(U,j,M);let te;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const q=await new Promise(K=>{(0,d.exec)("ps -F -A -l | grep root",(Y,ie,$e)=>{K(ie)})});this.z=g(T,q,this.z),te=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${te.map(K=>K.port).join(", ")}`)}return Z.then(q=>te?q.concat(te):q)}w(S){return async C=>{const I=new f.$Cdc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,M,T){const U=await S.makeConnection();return $.connect(U,z,M,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Il(0),connectionToken:S.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await I.waitForReady();const F=new O.$ee;return{localAddress:(0,u.$qM)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{I.dispose(),F.fire(),F.dispose()}}}}};e.$5nc=D,e.$5nc=D=Ke([We(0,n.$qP),We(1,a.$GP),We(2,P.$3j),We(3,w.$Pl)],D);class $ extends p.$ovb{static connect(S,C,I,F){const j=new R.$Uc,z={onClose:j.add(new O.$ee),onData:j.add(new O.$ee),onEnd:j.add(new O.$ee)};j.add(S.onDidReceiveMessage(T=>z.onData.fire(L.$Ge.wrap(T)))),j.add(S.onDidEnd(()=>z.onEnd.fire())),j.add(S.onDidClose(T=>z.onClose.fire({type:0,error:T,hadError:!!T})));const M=new $(S,F,z);return M.B(j),(0,p.$nvb)(M,C,I,F,z)}constructor(S,C,I){super(C,I),this.n=S}write(S){this.n.send(S.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[399],Se([1,0,85,368,382,381,394,397,398,96,49,97,95,43,71,93,367,326,11,383,61,286,106,111,141]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a,n,i,u,o,t,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.$xs)(A.$amc,b.$Wnc,0),(0,d.$xs)(n.$4j,a.$7nc,1),(0,d.$xs)(n.$3j,new t.$ti(o.$knc,[!1],!0)),(0,d.$xs)(l.$Pl,r.$Hdc,1),(0,d.$xs)(h.$Clc,f.$6nc,0),(0,d.$xs)(E.$fmc,R.$xnc,0),(0,d.$xs)(P.$Bmc,N.$Rnc,0),(0,d.$xs)(p.$4mc,O.$pnc,0),(0,d.$xs)(y.$Xlc,L.$onc,0),(0,d.$xs)(w.$tDb,m.$5nc,0),(0,d.$xs)(u.$dmc,i.$8nc,0)}),define(ke[410],Se([1,0,63,411,59,13,83,124,269,115,380,21,32,104,7,136,293,309,385,399]),function(le,e,d,L,O,R,N,b,m,E,A,P,p,y,w,h,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const n=L(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const v=globalThis._VSCODE_NODE_MODULES.module,g=v._load;v._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const i=process.exit.bind(process),u=process.on.bind(process);function o(v){process.exit=function(g){if(v)i(g);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(g,D){g==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),u(g,D)}}let t=function(v){i()};function l(){const v=(0,a.$on)(process.env);if(v.type===3)return new Promise((g,D)=>{const $=k=>{const S=k[0],C=new N.$ji;S.on("message",I=>C.fire(P.$Ge.wrap(I.data))),S.on("close",()=>{t("renderer closed the MessagePort")}),S.start(),g({onMessage:C.event,send:I=>S.postMessage(I.buffer)})};process.parentPort.on("message",k=>$(k.ports))});if(v.type===2)return new Promise((g,D)=>{let $=null;const k=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),S=108e5,C=3e5,I=new w.$Jh(()=>t("renderer disconnected for too long (1)"),S),F=new w.$Jh(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(z,M)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const T=P.$Ge.wrap(Buffer.from(z.initialDataChunk,"base64"));let U;if(z.skipWebSocketFrames)U=new b.$li(M,"extHost-socket");else{const Z=P.$Ge.wrap(Buffer.from(z.inflateBytes,"base64"));U=new b.$mi(new b.$li(M,"extHost-socket"),z.permessageDeflate,Z,!1)}$?(I.cancel(),F.cancel(),$.beginAcceptReconnection(U,T),$.endAcceptReconnection(),$.sendResume()):(clearTimeout(k),$=new N.$ki({socket:U,initialChunk:T}),$.sendResume(),$.onDidDispose(()=>t("renderer disconnected")),g($),$.onSocketClose(()=>{I.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;I.isScheduled()&&F.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const g=v.pipeName;return new Promise((D,$)=>{const k=d.createConnection(g,()=>{k.removeListener("error",$);const S=new N.$ki({socket:new b.$li(k,"extHost-renderer")});S.sendResume(),D(S)});k.once("error",$),k.on("close",()=>{t("renderer closed the socket")})})}}async function r(){const v=await l();return new class{constructor(){this.a=new N.$ji,this.onMessage=this.a.event,this.b=!1,v.onMessage(g=>{(0,E.$1m)(g,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(g)})}send(g){this.b||v.send(g)}async drain(){if(v.drain)return v.drain()}}}function c(v){return new Promise(g=>{const D=v.onMessage($=>{D.dispose();const k=JSON.parse($.toString()),S=k.commit,C=m.default.commit;if(S&&C&&S!==C&&i(55),k.parentPid){let I=0;setInterval(function(){try{process.kill(k.parentPid,0),I=0}catch(j){j&&j.code==="EPERM"?(I++,I>=3&&t(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${k.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(k.parentPid)}catch(j){(0,R.$1)(j)}}v.send((0,E.$Zm)(0)),g({protocol:v,initData:k})});v.send((0,E.$Zm)(1))})}async function s(){const v=[];process.on("unhandledRejection",(I,F)=>{v.push(F),setTimeout(()=>{const j=v.indexOf(F);j>=0&&F.catch(z=>{v.splice(j,1),(0,R.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),I&&(0,R.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const F=v.indexOf(I);F>=0&&v.splice(F,1)}),process.on("uncaughtException",function(I){(0,R.$Z)(I)||(0,R.$1)(I)}),O.mark("code/extHost/willConnectToRenderer");const g=await r();O.mark("code/extHost/didConnectToRenderer");const D=await c(g);O.mark("code/extHost/didWaitForInitData");const{initData:$}=D;o(!!$.environment.extensionTestsLocationURI),$.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,$.environment.skipWorkspaceStorageLock=(0,h.boolean)(n.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(F){i(F)}fsExists(F){return p.Promises.exists(F)}fsRealpath(F){return(0,y.$6q)(F)}};let S=null;$.remote.authority&&n.transformURIs&&(S=(0,f.$Bs)($.remote.authority));const C=new A.$nnc(D.protocol,$,k,S);t=I=>C.terminate(I)}s().catch(v=>console.log(v))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/17235b28ebca8f946926ec11374b67cd53c0619d/core/vs/workbench/api/node/extensionHostProcess.js.map
