/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/marshalling","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Pe=function(le){for(var e=[],I=0,M=le.length;I<M;I++)e[I]=Ie[le[I]];return e};define(Ie[69],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=M,e.$2h=A,e.$3h=O;function I(R){return(w,p,E)=>{let T=null,D=null;if(typeof E.value=="function"?(T="value",D=E.value):typeof E.get=="function"&&(T="get",D=E.get),!D)throw new Error("not supported");E[T]=R(D,p)}}function M(R,w,p){let E=null,T=null;if(typeof p.value=="function"?(E="value",T=p.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(E="get",T=p.get),!T)throw new Error("not supported");const D=`$memoize$${w}`;p[E]=function(...d){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,d)}),this[D]}}function A(R,w,p){return I((E,T)=>{const D=`$debounce$${T}`,d=`$debounce$result$${T}`;return function(...v){this[d]||(this[d]=p?p():void 0),clearTimeout(this[D]),w&&(this[d]=w(this[d],...v),v=[this[d]]),this[D]=setTimeout(()=>{E.apply(this,v),this[d]=p?p():void 0},R)}})}function O(R,w,p){return I((E,T)=>{const D=`$throttle$timer$${T}`,d=`$throttle$result$${T}`,v=`$throttle$lastRun$${T}`,g=`$throttle$pending$${T}`;return function(...r){if(this[d]||(this[d]=p?p():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),w&&(this[d]=w(this[d],...r)),this[g])return;const o=this[v]+R;o<=Date.now()?(this[v]=Date.now(),E.apply(this,[this[d]]),this[d]=p?p():void 0):(this[g]=!0,this[D]=setTimeout(()=>{this[g]=!1,this[v]=Date.now(),E.apply(this,[this[d]]),this[d]=p?p():void 0},o-Date.now()))}})}}),define(Ie[125],Pe([1,0,18]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=A,e.$9c=O,e.$0c=R,e.$$c=w,e.$_c=p,e.$ad=E;const M=(v,g)=>v===g;e.$7c=M;function A(v=e.$7c){return(g,r)=>I.$ub(g,r,v)}function O(){return(v,g)=>JSON.stringify(v)===JSON.stringify(g)}function R(){return(v,g)=>v.equals(g)}function w(v,g,r){return!v||!g?v===g:r(v,g)}function p(v,g){if(v===g)return!0;if(Array.isArray(v)&&Array.isArray(g)){if(v.length!==g.length)return!1;for(let r=0;r<v.length;r++)if(!p(v[r],g[r]))return!1;return!0}if(v&&typeof v=="object"&&g&&typeof g=="object"&&Object.getPrototypeOf(v)===Object.prototype&&Object.getPrototypeOf(g)===Object.prototype){const r=v,o=g,s=Object.keys(r),i=Object.keys(o),n=new Set(i);if(s.length!==i.length)return!1;for(const c of s)if(!n.has(c)||!p(r[c],o[c]))return!1;return!0}return!1}function E(v){return JSON.stringify(d(v))}let T=0;const D=new WeakMap;function d(v){if(Array.isArray(v))return v.map(d);if(v&&typeof v=="object")if(Object.getPrototypeOf(v)===Object.prototype){const g=v,r=Object.create(null);for(const o of Object.keys(g).sort())r[o]=d(g[o]);return r}else{let g=D.get(v);return g===void 0&&(g=T++,D.set(v,g)),g+"----2b76a038c20c4bcc"}return v}}),define(Ie[91],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=e.$vP=void 0;class I{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$vP=I,e.$wP=new I("id#")}),define(Ie[126],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=R,e.$In=D,e.$Jn=d,e.$Kn=v,e.$Ln=g,e.$Mn=r,e.$Nn=o,e.$On=s,e.$Pn=i,e.$Qn=n,e.$Rn=c,e.$Sn=l;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function R(t,f=!1){let a=0;const $=t.length;let u="",S=0,h=16,b=0;function m(q){let N=0,U=0;for(;N<q;){const K=t.charCodeAt(a);if(K>=48&&K<=57)U=U*16+K-48;else if(K>=65&&K<=70)U=U*16+K-65+10;else if(K>=97&&K<=102)U=U*16+K-97+10;else break;a++,N++}return N<q&&(U=-1),U}function k(q){a=q,u="",S=0,h=16,b=0}function y(){const q=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&E(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&E(t.charCodeAt(a)))for(a++;a<t.length&&E(t.charCodeAt(a));)a++;else return b=3,t.substring(q,a);let N=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&E(t.charCodeAt(a))){for(a++;a<t.length&&E(t.charCodeAt(a));)a++;N=a}else b=3;return t.substring(q,N)}function C(){let q="",N=a;for(;;){if(a>=$){q+=t.substring(N,a),b=2;break}const U=t.charCodeAt(a);if(U===34){q+=t.substring(N,a),a++;break}if(U===92){if(q+=t.substring(N,a),a++,a>=$){b=2;break}switch(t.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=m(4);ie>=0?q+=String.fromCharCode(ie):b=4;break}default:b=5}N=a;continue}if(U>=0&&U<=31)if(p(U)){q+=t.substring(N,a),b=2;break}else b=6;a++}return q}function P(){if(u="",b=0,S=a,a>=$)return S=$,h=17;let q=t.charCodeAt(a);if(w(q)){do a++,u+=String.fromCharCode(q),q=t.charCodeAt(a);while(w(q));return h=15}if(p(q))return a++,u+=String.fromCharCode(q),q===13&&t.charCodeAt(a)===10&&(a++,u+=`
`),h=14;switch(q){case 123:return a++,h=1;case 125:return a++,h=2;case 91:return a++,h=3;case 93:return a++,h=4;case 58:return a++,h=6;case 44:return a++,h=5;case 34:return a++,u=C(),h=10;case 47:{const N=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<$&&!p(t.charCodeAt(a));)a++;return u=t.substring(N,a),h=12}if(t.charCodeAt(a+1)===42){a+=2;const U=$-1;let K=!1;for(;a<U;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,b=1),u=t.substring(N,a),h=13}return u+=String.fromCharCode(q),a++,h=16}case 45:if(u+=String.fromCharCode(q),a++,a===$||!E(t.charCodeAt(a)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=y(),h=11;default:for(;a<$&&W(q);)a++,q=t.charCodeAt(a);if(S!==a){switch(u=t.substring(S,a),u){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return u+=String.fromCharCode(q),a++,h=16}}function W(q){if(w(q)||p(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:k,getPosition:()=>a,scan:f?V:P,getToken:()=>h,getTokenValue:()=>u,getTokenOffset:()=>S,getTokenLength:()=>a-S,getTokenError:()=>b}}function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function D(t,f){const a=[],$=new Object;let u;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function b(m,k,y,C){S.value=m,S.offset=k,S.length=y,S.type=C,S.colonOffset=void 0,u=S}try{n(t,{onObjectBegin:(m,k)=>{if(f<=m)throw $;u=void 0,h=f>m,a.push("")},onObjectProperty:(m,k,y)=>{if(f<k||(b(m,k,y,"property"),a[a.length-1]=m,f<=k+y))throw $},onObjectEnd:(m,k)=>{if(f<=m)throw $;u=void 0,a.pop()},onArrayBegin:(m,k)=>{if(f<=m)throw $;u=void 0,a.push(0)},onArrayEnd:(m,k)=>{if(f<=m)throw $;u=void 0,a.pop()},onLiteralValue:(m,k,y)=>{if(f<k||(b(m,k,y,l(m)),f<=k+y))throw $},onSeparator:(m,k,y)=>{if(f<=k)throw $;if(m===":"&&u&&u.type==="property")u.colonOffset=k,h=!1,u=void 0;else if(m===","){const C=a[a.length-1];typeof C=="number"?a[a.length-1]=C+1:(h=!0,a[a.length-1]=""),u=void 0}}})}catch(m){if(m!==$)throw m}return{path:a,previousNode:u,isAtPropertyKey:h,matches:m=>{let k=0;for(let y=0;k<m.length&&y<a.length;y++)if(m[k]===a[y]||m[k]==="*")k++;else if(m[k]!=="**")return!1;return k===m.length}}}function d(t,f=[],a=O.DEFAULT){let $=null,u=[];const S=[];function h(m){Array.isArray(u)?u.push(m):$!==null&&(u[$]=m)}return n(t,{onObjectBegin:()=>{const m={};h(m),S.push(u),u=m,$=null},onObjectProperty:m=>{$=m},onObjectEnd:()=>{u=S.pop()},onArrayBegin:()=>{const m=[];h(m),S.push(u),u=m,$=null},onArrayEnd:()=>{u=S.pop()},onLiteralValue:h,onError:(m,k,y)=>{f.push({error:m,offset:k,length:y})}},a),u[0]}function v(t,f=[],a=O.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(m){$.type==="property"&&($.length=m-$.offset,$=$.parent)}function S(m){return $.children.push(m),m}n(t,{onObjectBegin:m=>{$=S({type:"object",offset:m,length:-1,parent:$,children:[]})},onObjectProperty:(m,k,y)=>{$=S({type:"property",offset:k,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:m,offset:k,length:y,parent:$})},onObjectEnd:(m,k)=>{$.length=m+k-$.offset,$=$.parent,u(m+k)},onArrayBegin:(m,k)=>{$=S({type:"array",offset:m,length:-1,parent:$,children:[]})},onArrayEnd:(m,k)=>{$.length=m+k-$.offset,$=$.parent,u(m+k)},onLiteralValue:(m,k,y)=>{S({type:l(m),offset:k,length:y,parent:$,value:m}),u(k+y)},onSeparator:(m,k,y)=>{$.type==="property"&&(m===":"?$.colonOffset=k:m===","&&u(k))},onError:(m,k,y)=>{f.push({error:m,offset:k,length:y})}},a);const b=$.children[0];return b&&delete b.parent,b}function g(t,f){if(!t)return;let a=t;for(const $ of f)if(typeof $=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let u=!1;for(const S of a.children)if(Array.isArray(S.children)&&S.children[0].value===$){a=S.children[1],u=!0;break}if(!u)return}else{const u=$;if(a.type!=="array"||u<0||!Array.isArray(a.children)||u>=a.children.length)return;a=a.children[u]}return a}function r(t){if(!t.parent||!t.parent.children)return[];const f=r(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;f.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&f.push(a)}return f}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const f=Object.create(null);for(const a of t.children){const $=a.children[1];$&&(f[a.children[0].value]=o($))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,f,a=!1){return f>=t.offset&&f<t.offset+t.length||a&&f===t.offset+t.length}function i(t,f,a=!1){if(s(t,f,a)){const $=t.children;if(Array.isArray($))for(let u=0;u<$.length&&$[u].offset<=f;u++){const S=i($[u],f,a);if(S)return S}return t}}function n(t,f,a=O.DEFAULT){const $=R(t,!1);function u(Te){return Te?()=>Te($.getTokenOffset(),$.getTokenLength()):()=>!0}function S(Te){return Te?ae=>Te(ae,$.getTokenOffset(),$.getTokenLength()):()=>!0}const h=u(f.onObjectBegin),b=S(f.onObjectProperty),m=u(f.onObjectEnd),k=u(f.onArrayBegin),y=u(f.onArrayEnd),C=S(f.onLiteralValue),P=S(f.onSeparator),W=u(f.onComment),V=S(f.onError),q=a&&a.disallowComments,N=a&&a.allowTrailingComma;function U(){for(;;){const Te=$.scan();switch($.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Te){case 12:case 13:q?K(10):W();break;case 16:K(1);break;case 15:case 14:break;default:return Te}}}function K(Te,ae=[],Ne=[]){if(V(Te),ae.length+Ne.length>0){let ne=$.getToken();for(;ne!==17;){if(ae.indexOf(ne)!==-1){U();break}else if(Ne.indexOf(ne)!==-1)break;ne=U()}}}function ie(Te){const ae=$.getTokenValue();return Te?C(ae):b(ae),U(),!0}function ce(){switch($.getToken()){case 11:{let Te=0;try{Te=JSON.parse($.getTokenValue()),typeof Te!="number"&&(K(2),Te=0)}catch{K(2)}C(Te);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return U(),!0}function ye(){return $.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),$.getToken()===6?(P(":"),U(),$e()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Se(){h(),U();let Te=!1;for(;$.getToken()!==2&&$.getToken()!==17;){if($.getToken()===5){if(Te||K(4,[],[]),P(","),U(),$.getToken()===2&&N)break}else Te&&K(6,[],[]);ye()||K(4,[],[2,5]),Te=!0}return m(),$.getToken()!==2?K(7,[2],[]):U(),!0}function fe(){k(),U();let Te=!1;for(;$.getToken()!==4&&$.getToken()!==17;){if($.getToken()===5){if(Te||K(4,[],[]),P(","),U(),$.getToken()===4&&N)break}else Te&&K(6,[],[]);$e()||K(4,[],[4,5]),Te=!0}return y(),$.getToken()!==4?K(8,[4],[]):U(),!0}function $e(){switch($.getToken()){case 3:return fe();case 1:return Se();case 10:return ie(!0);default:return ce()}}return U(),$.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):$e()?($.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(t,f){const a=R(t),$=[];let u,S=0,h;do switch(h=a.getPosition(),u=a.scan(),u){case 12:case 13:case 17:S!==h&&$.push(t.substring(S,h)),f!==void 0&&$.push(a.getTokenValue().replace(/[^\r\n]/g,f)),S=a.getPosition();break}while(u!==17);return $.join("")}function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(le,e){typeof define=="function"&&define.amd?define(Ie[127],Pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(De,we){for(var ge=0;ge<we.length;ge++){var Q=we[ge];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(De,Q.key,Q)}}function I(De,we,ge){return we&&e(De.prototype,we),ge&&e(De,ge),Object.defineProperty(De,"prototype",{writable:!1}),De}function M(De,we){if(De){if(typeof De=="string")return A(De,we);var ge=Object.prototype.toString.call(De).slice(8,-1);if(ge==="Object"&&De.constructor&&(ge=De.constructor.name),ge==="Map"||ge==="Set")return Array.from(De);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return A(De,we)}}function A(De,we){(we==null||we>De.length)&&(we=De.length);for(var ge=0,Q=new Array(we);ge<we;ge++)Q[ge]=De[ge];return Q}function O(De,we){var ge=typeof Symbol<"u"&&De[Symbol.iterator]||De["@@iterator"];if(ge)return(ge=ge.call(De)).next.bind(ge);if(Array.isArray(De)||(ge=M(De))||we&&De&&typeof De.length=="number"){ge&&(De=ge);var Q=0;return function(){return Q>=De.length?{done:!0}:{done:!1,value:De[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=R();function w(De){le.defaults=De}var p=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(we){return d[we]};function g(De,we){if(we){if(p.test(De))return De.replace(E,v)}else if(T.test(De))return De.replace(D,v);return De}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(De){return De.replace(r,function(we,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(De,we){De=typeof De=="string"?De:De.source,we=we||"";var ge={replace:function(Y,he){return he=he.source||he,he=he.replace(s,"$1"),De=De.replace(Y,he),ge},getRegex:function(){return new RegExp(De,we)}};return ge}var n=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(De,we,ge){if(De){var Q;try{Q=decodeURIComponent(o(ge)).replace(n,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}we&&!c.test(ge)&&(ge=u(we,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},f=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,$=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(De,we){t[" "+De]||(f.test(De)?t[" "+De]=De+"/":t[" "+De]=m(De,"/",!0)),De=t[" "+De];var ge=De.indexOf(":")===-1;return we.substring(0,2)==="//"?ge?we:De.replace(a,"$1")+we:we.charAt(0)==="/"?ge?we:De.replace($,"$1")+we:De+we}var S={exec:function(){}};function h(De){for(var we=1,ge,Q;we<arguments.length;we++){ge=arguments[we];for(Q in ge)Object.prototype.hasOwnProperty.call(ge,Q)&&(De[Q]=ge[Q])}return De}function b(De,we){var ge=De.replace(/\|/g,function(he,ue,Oe){for(var de=!1,Ce=ue;--Ce>=0&&Oe[Ce]==="\\";)de=!de;return de?"|":" |"}),Q=ge.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>we)Q.splice(we);else for(;Q.length<we;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function m(De,we,ge){var Q=De.length;if(Q===0)return"";for(var Y=0;Y<Q;){var he=De.charAt(Q-Y-1);if(he===we&&!ge)Y++;else if(he!==we&&ge)Y++;else break}return De.slice(0,Q-Y)}function k(De,we){if(De.indexOf(we[1])===-1)return-1;for(var ge=De.length,Q=0,Y=0;Y<ge;Y++)if(De[Y]==="\\")Y++;else if(De[Y]===we[0])Q++;else if(De[Y]===we[1]&&(Q--,Q<0))return Y;return-1}function y(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(De,we){if(we<1)return"";for(var ge="";we>1;)we&1&&(ge+=De),we>>=1,De+=De;return ge+De}function P(De,we,ge,Q){var Y=we.href,he=we.title?g(we.title):null,ue=De[1].replace(/\\([\[\]])/g,"$1");if(De[0].charAt(0)!=="!"){Q.state.inLink=!0;var Oe={type:"link",raw:ge,href:Y,title:he,text:ue,tokens:Q.inlineTokens(ue)};return Q.state.inLink=!1,Oe}return{type:"image",raw:ge,href:Y,title:he,text:g(ue)}}function W(De,we){var ge=De.match(/^(\s+)(?:```)/);if(ge===null)return we;var Q=ge[1];return we.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var ue=he[0];return ue.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var V=function(){function De(ge){this.options=ge||le.defaults}var we=De.prototype;return we.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},we.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:m(he,`
`)}}},we.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var he=Y[0],ue=W(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:ue}}},we.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var ue=m(he,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(he=ue.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},we.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},we.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},we.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var he,ue,Oe,de,Ce,Ae,Ue,j,F,H,G,ee,re=Y[1].trim(),Me=re.length>1,Be={type:"list",raw:"",ordered:Me,start:Me?+re.slice(0,-1):"",loose:!1,items:[]};re=Me?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Me?re:"[*+-]");for(var He=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(Y=He.exec(Q))||this.rules.block.hr.test(Q)));){if(he=Y[0],Q=Q.substring(he.length),j=Y[2].split(`
`,1)[0],F=Q.split(`
`,1)[0],this.options.pedantic?(de=2,G=j.trimLeft()):(de=Y[2].search(/[^ ]/),de=de>4?1:de,G=j.slice(de),de+=Y[1].length),Ae=!1,!j&&/^ *$/.test(F)&&(he+=F+`
`,Q=Q.substring(F.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");Q&&(H=Q.split(`
`,1)[0],j=H,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(j)||tt.test(j)||_e.test(j)||xe.test(Q)));){if(j.search(/[^ ]/)>=de||!j.trim())G+=`
`+j.slice(de);else if(!Ae)G+=`
`+j;else break;!Ae&&!j.trim()&&(Ae=!0),he+=H+`
`,Q=Q.substring(H.length+1)}Be.loose||(Ue?Be.loose=!0:/\n *\n *$/.test(he)&&(Ue=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(G),ue&&(Oe=ue[0]!=="[ ] ",G=G.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!ue,checked:Oe,loose:!1,text:G}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=G.trimRight(),Be.raw=Be.raw.trimRight();var it=Be.items.length;for(Ce=0;Ce<it;Ce++){this.lexer.state.top=!1,Be.items[Ce].tokens=this.lexer.blockTokens(Be.items[Ce].text,[]);var at=Be.items[Ce].tokens.filter(function(je){return je.type==="space"}),gt=at.every(function(je){for(var st=je.raw.split(""),X=0,Z=O(st),me;!(me=Z()).done;){var qe=me.value;if(qe===`
`&&(X+=1),X>1)return!0}return!1});!Be.loose&&at.length&&gt&&(Be.loose=!0,Be.items[Ce].loose=!0)}return Be}},we.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]);he.type="paragraph",he.text=ue,he.tokens=this.lexer.inline(ue)}return he}},we.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},we.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var he={type:"table",header:b(Y[1]).map(function(Ue){return{text:Ue}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var ue=he.align.length,Oe,de,Ce,Ae;for(Oe=0;Oe<ue;Oe++)/^ *-+: *$/.test(he.align[Oe])?he.align[Oe]="right":/^ *:-+: *$/.test(he.align[Oe])?he.align[Oe]="center":/^ *:-+ *$/.test(he.align[Oe])?he.align[Oe]="left":he.align[Oe]=null;for(ue=he.rows.length,Oe=0;Oe<ue;Oe++)he.rows[Oe]=b(he.rows[Oe],he.header.length).map(function(Ue){return{text:Ue}});for(ue=he.header.length,de=0;de<ue;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(ue=he.rows.length,de=0;de<ue;de++)for(Ae=he.rows[de],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=this.lexer.inline(Ae[Ce].text);return he}}},we.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},we.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},we.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},we.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:g(Y[1])}},we.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]):Y[0]}},we.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var ue=m(he.slice(0,-1),"\\");if((he.length-ue.length)%2===0)return}else{var Oe=k(Y[2],"()");if(Oe>-1){var de=Y[0].indexOf("!")===0?5:4,Ce=de+Y[1].length+Oe;Y[2]=Y[2].substring(0,Oe),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Ae=Y[2],Ue="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);j&&(Ae=j[1],Ue=j[3])}else Ue=Y[3]?Y[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(he)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),P(Y,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},we.reflink=function(Q,Y){var he;if((he=this.rules.inline.reflink.exec(Q))||(he=this.rules.inline.nolink.exec(Q))){var ue=(he[2]||he[1]).replace(/\s+/g," ");if(ue=Y[ue.toLowerCase()],!ue||!ue.href){var Oe=he[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return P(he,ue,he[0],this.lexer)}},we.emStrong=function(Q,Y,he){he===void 0&&(he="");var ue=this.rules.inline.emStrong.lDelim.exec(Q);if(ue&&!(ue[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=ue[1]||ue[2]||"";if(!Oe||Oe&&(he===""||this.rules.inline.punctuation.exec(he))){var de=ue[0].length-1,Ce,Ae,Ue=de,j=0,F=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(F.lastIndex=0,Y=Y.slice(-1*Q.length+de);(ue=F.exec(Y))!=null;)if(Ce=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Ce){if(Ae=Ce.length,ue[3]||ue[4]){Ue+=Ae;continue}else if((ue[5]||ue[6])&&de%3&&!((de+Ae)%3)){j+=Ae;continue}if(Ue-=Ae,!(Ue>0)){if(Ae=Math.min(Ae,Ae+Ue+j),Math.min(de,Ae)%2){var H=Q.slice(1,de+ue.index+Ae);return{type:"em",raw:Q.slice(0,de+ue.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}var G=Q.slice(2,de+ue.index+Ae-1);return{type:"strong",raw:Q.slice(0,de+ue.index+Ae+1),text:G,tokens:this.lexer.inlineTokens(G)}}}}}},we.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var he=Y[2].replace(/\n/g," "),ue=/[^ ]/.test(he),Oe=/^ /.test(he)&&/ $/.test(he);return ue&&Oe&&(he=he.substring(1,he.length-1)),he=g(he,!0),{type:"codespan",raw:Y[0],text:he}}},we.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},we.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},we.autolink=function(Q,Y){var he=this.rules.inline.autolink.exec(Q);if(he){var ue,Oe;return he[2]==="@"?(ue=g(this.options.mangle?Y(he[1]):he[1]),Oe="mailto:"+ue):(ue=g(he[1]),Oe=ue),{type:"link",raw:he[0],text:ue,href:Oe,tokens:[{type:"text",raw:ue,text:ue}]}}},we.url=function(Q,Y){var he;if(he=this.rules.inline.url.exec(Q)){var ue,Oe;if(he[2]==="@")ue=g(this.options.mangle?Y(he[0]):he[0]),Oe="mailto:"+ue;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);ue=g(he[0]),he[1]==="www."?Oe="http://"+ue:Oe=ue}return{type:"link",raw:he[0],text:ue,href:Oe,tokens:[{type:"text",raw:ue,text:ue}]}}},we.inlineText=function(Q,Y){var he=this.rules.inline.text.exec(Q);if(he){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):g(he[0]):he[0]:ue=g(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:ue}}},De}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=i(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=i(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=i(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=i(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=i(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=h({},q),q.gfm=h({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=i(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=h({},q.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:i(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(q._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",q._label).getRegex(),N.nolink=i(N.nolink).replace("ref",q._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=h({},N),N.pedantic=h({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=h({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=h({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(De){var we="",ge,Q,Y=De.length;for(ge=0;ge<Y;ge++)Q=De.charCodeAt(ge),Math.random()>.5&&(Q="x"+Q.toString(16)),we+="&#"+Q+";";return we}var ie=function(){function De(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||le.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:N.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=N.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=N.breaks:Q.inline=N.gfm),this.tokenizer.rules=Q}De.lex=function(Q,Y){var he=new De(Y);return he.lex(Q)},De.lexInline=function(Q,Y){var he=new De(Y);return he.inlineTokens(Q)};var we=De.prototype;return we.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},we.blockTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(Ue,j,F){return j+"    ".repeat(F.length)});for(var ue,Oe,de,Ce;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ue){return(ue=Ue.call({lexer:he},Q,Y))?(Q=Q.substring(ue.raw.length),Y.push(ue),!0):!1}))){if(ue=this.tokenizer.space(Q)){Q=Q.substring(ue.raw.length),ue.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(ue);continue}if(ue=this.tokenizer.code(Q)){Q=Q.substring(ue.raw.length),Oe=Y[Y.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ue.raw,Oe.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(ue);continue}if(ue=this.tokenizer.fences(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.heading(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.hr(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.blockquote(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.list(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.html(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.def(Q)){Q=Q.substring(ue.raw.length),Oe=Y[Y.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ue.raw,Oe.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.lheading(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ue=1/0,j=Q.slice(1),F=void 0;he.options.extensions.startBlock.forEach(function(H){F=H.call({lexer:this},j),typeof F=="number"&&F>=0&&(Ue=Math.min(Ue,F))}),Ue<1/0&&Ue>=0&&(de=Q.substring(0,Ue+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(de))){Oe=Y[Y.length-1],Ce&&Oe.type==="paragraph"?(Oe.raw+=`
`+ue.raw,Oe.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(ue),Ce=de.length!==Q.length,Q=Q.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(Q)){Q=Q.substring(ue.raw.length),Oe=Y[Y.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+ue.raw,Oe.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(ue);continue}if(Q){var Ae="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Y},we.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},we.inlineTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]);var ue,Oe,de,Ce=Q,Ae,Ue,j;if(this.tokens.links){var F=Object.keys(this.tokens.links);if(F.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)F.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(Ue||(j=""),Ue=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(G){return(ue=G.call({lexer:he},Q,Y))?(Q=Q.substring(ue.raw.length),Y.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.tag(Q)){Q=Q.substring(ue.raw.length),Oe=Y[Y.length-1],Oe&&ue.type==="text"&&Oe.type==="text"?(Oe.raw+=ue.raw,Oe.text+=ue.text):Y.push(ue);continue}if(ue=this.tokenizer.link(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ue.raw.length),Oe=Y[Y.length-1],Oe&&ue.type==="text"&&Oe.type==="text"?(Oe.raw+=ue.raw,Oe.text+=ue.text):Y.push(ue);continue}if(ue=this.tokenizer.emStrong(Q,Ce,j)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.codespan(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.br(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.del(Q)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(ue=this.tokenizer.autolink(Q,K)){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(Q,K))){Q=Q.substring(ue.raw.length),Y.push(ue);continue}if(de=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var G=1/0,ee=Q.slice(1),re=void 0;he.options.extensions.startInline.forEach(function(Me){re=Me.call({lexer:this},ee),typeof re=="number"&&re>=0&&(G=Math.min(G,re))}),G<1/0&&G>=0&&(de=Q.substring(0,G+1))}(),ue=this.tokenizer.inlineText(de,U)){Q=Q.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(j=ue.raw.slice(-1)),Ue=!0,Oe=Y[Y.length-1],Oe&&Oe.type==="text"?(Oe.raw+=ue.raw,Oe.text+=ue.text):Y.push(ue);continue}if(Q){var H="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return Y},I(De,null,[{key:"rules",get:function(){return{block:q,inline:N}}}]),De}(),ce=function(){function De(ge){this.options=ge||le.defaults}var we=De.prototype;return we.code=function(Q,Y,he){var ue=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(Q,ue);Oe!=null&&Oe!==Q&&(he=!0,Q=Oe)}return Q=Q.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+g(ue,!0)+'">'+(he?Q:g(Q,!0))+`</code></pre>
`:"<pre><code>"+(he?Q:g(Q,!0))+`</code></pre>
`},we.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},we.html=function(Q){return Q},we.heading=function(Q,Y,he,ue){if(this.options.headerIds){var Oe=this.options.headerPrefix+ue.slug(he);return"<h"+Y+' id="'+Oe+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(Q,Y,he){var ue=Y?"ol":"ul",Oe=Y&&he!==1?' start="'+he+'"':"";return"<"+ue+Oe+`>
`+Q+"</"+ue+`>
`},we.listitem=function(Q){return"<li>"+Q+`</li>
`},we.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(Q){return"<p>"+Q+`</p>
`},we.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},we.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},we.tablecell=function(Q,Y){var he=Y.header?"th":"td",ue=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return ue+Q+("</"+he+`>
`)},we.strong=function(Q){return"<strong>"+Q+"</strong>"},we.em=function(Q){return"<em>"+Q+"</em>"},we.codespan=function(Q){return"<code>"+Q+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(Q){return"<del>"+Q+"</del>"},we.link=function(Q,Y,he){if(Q=l(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ue='<a href="'+g(Q)+'"';return Y&&(ue+=' title="'+Y+'"'),ue+=">"+he+"</a>",ue},we.image=function(Q,Y,he){if(Q=l(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ue='<img src="'+Q+'" alt="'+he+'"';return Y&&(ue+=' title="'+Y+'"'),ue+=this.options.xhtml?"/>":">",ue},we.text=function(Q){return Q},De}(),ye=function(){function De(){}var we=De.prototype;return we.strong=function(Q){return Q},we.em=function(Q){return Q},we.codespan=function(Q){return Q},we.del=function(Q){return Q},we.html=function(Q){return Q},we.text=function(Q){return Q},we.link=function(Q,Y,he){return""+he},we.image=function(Q,Y,he){return""+he},we.br=function(){return""},De}(),Se=function(){function De(){this.seen={}}var we=De.prototype;return we.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(Q,Y){var he=Q,ue=0;if(this.seen.hasOwnProperty(he)){ue=this.seen[Q];do ue++,he=Q+"-"+ue;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[Q]=ue,this.seen[he]=0),he},we.slug=function(Q,Y){Y===void 0&&(Y={});var he=this.serialize(Q);return this.getNextSafeSlug(he,Y.dryrun)},De}(),fe=function(){function De(ge){this.options=ge||le.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Se}De.parse=function(Q,Y){var he=new De(Y);return he.parse(Q)},De.parseInline=function(Q,Y){var he=new De(Y);return he.parseInline(Q)};var we=De.prototype;return we.parse=function(Q,Y){Y===void 0&&(Y=!0);var he="",ue,Oe,de,Ce,Ae,Ue,j,F,H,G,ee,re,Me,Be,He,_e,xe,et,tt,it=Q.length;for(ue=0;ue<it;ue++){if(G=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[G.type]&&(tt=this.options.extensions.renderers[G.type].call({parser:this},G),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(G.type))){he+=tt||"";continue}switch(G.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(G.tokens),G.depth,o(this.parseInline(G.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(G.text,G.lang,G.escaped);continue}case"table":{for(F="",j="",Ce=G.header.length,Oe=0;Oe<Ce;Oe++)j+=this.renderer.tablecell(this.parseInline(G.header[Oe].tokens),{header:!0,align:G.align[Oe]});for(F+=this.renderer.tablerow(j),H="",Ce=G.rows.length,Oe=0;Oe<Ce;Oe++){for(Ue=G.rows[Oe],j="",Ae=Ue.length,de=0;de<Ae;de++)j+=this.renderer.tablecell(this.parseInline(Ue[de].tokens),{header:!1,align:G.align[de]});H+=this.renderer.tablerow(j)}he+=this.renderer.table(F,H);continue}case"blockquote":{H=this.parse(G.tokens),he+=this.renderer.blockquote(H);continue}case"list":{for(ee=G.ordered,re=G.start,Me=G.loose,Ce=G.items.length,H="",Oe=0;Oe<Ce;Oe++)He=G.items[Oe],_e=He.checked,xe=He.task,Be="",He.task&&(et=this.renderer.checkbox(_e),Me?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=et+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=et+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(He.tokens,Me),H+=this.renderer.listitem(Be,xe,_e);he+=this.renderer.list(H,ee,re);continue}case"html":{he+=this.renderer.html(G.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(G.tokens));continue}case"text":{for(H=G.tokens?this.parseInline(G.tokens):G.text;ue+1<it&&Q[ue+1].type==="text";)G=Q[++ue],H+=`
`+(G.tokens?this.parseInline(G.tokens):G.text);he+=Y?this.renderer.paragraph(H):H;continue}default:{var at='Token with "'+G.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return he},we.parseInline=function(Q,Y){Y=Y||this.renderer;var he="",ue,Oe,de,Ce=Q.length;for(ue=0;ue<Ce;ue++){if(Oe=Q[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(de=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){he+=de||"";continue}switch(Oe.type){case"escape":{he+=Y.text(Oe.text);break}case"html":{he+=Y.html(Oe.text);break}case"link":{he+=Y.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,Y));break}case"image":{he+=Y.image(Oe.href,Oe.title,Oe.text);break}case"strong":{he+=Y.strong(this.parseInline(Oe.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Oe.tokens,Y));break}case"codespan":{he+=Y.codespan(Oe.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Oe.tokens,Y));break}case"text":{he+=Y.text(Oe.text);break}default:{var Ae='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return he},De}();function $e(De,we,ge){if(typeof De>"u"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof we=="function"&&(ge=we,we=null),we=h({},$e.defaults,we||{}),y(we),ge){var Q=we.highlight,Y;try{Y=ie.lex(De,we)}catch(Ce){return ge(Ce)}var he=function(Ae){var Ue;if(!Ae)try{we.walkTokens&&$e.walkTokens(Y,we.walkTokens),Ue=fe.parse(Y,we)}catch(j){Ae=j}return we.highlight=Q,Ae?ge(Ae):ge(null,Ue)};if(!Q||Q.length<3||(delete we.highlight,!Y.length))return he();var ue=0;$e.walkTokens(Y,function(Ce){Ce.type==="code"&&(ue++,setTimeout(function(){Q(Ce.text,Ce.lang,function(Ae,Ue){if(Ae)return he(Ae);Ue!=null&&Ue!==Ce.text&&(Ce.text=Ue,Ce.escaped=!0),ue--,ue===0&&he()})},0))}),ue===0&&he();return}function Oe(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+g(Ce.message+"",!0)+"</pre>";throw Ce}try{var de=ie.lex(De,we);if(we.walkTokens){if(we.async)return Promise.all($e.walkTokens(de,we.walkTokens)).then(function(){return fe.parse(de,we)}).catch(Oe);$e.walkTokens(de,we.walkTokens)}return fe.parse(de,we)}catch(Ce){Oe(Ce)}}$e.options=$e.setOptions=function(De){return h($e.defaults,De),w($e.defaults),$e},$e.getDefaults=R,$e.defaults=le.defaults,$e.use=function(){for(var De=arguments.length,we=new Array(De),ge=0;ge<De;ge++)we[ge]=arguments[ge];var Q=h.apply(void 0,[{}].concat(we)),Y=$e.defaults.extensions||{renderers:{},childTokens:{}},he;we.forEach(function(ue){if(ue.extensions&&(he=!0,ue.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ce=Y.renderers?Y.renderers[de.name]:null;Ce?Y.renderers[de.name]=function(){for(var Ae=arguments.length,Ue=new Array(Ae),j=0;j<Ae;j++)Ue[j]=arguments[j];var F=de.renderer.apply(this,Ue);return F===!1&&(F=Ce.apply(this,Ue)),F}:Y.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[de.level]?Y[de.level].unshift(de.tokenizer):Y[de.level]=[de.tokenizer],de.start&&(de.level==="block"?Y.startBlock?Y.startBlock.push(de.start):Y.startBlock=[de.start]:de.level==="inline"&&(Y.startInline?Y.startInline.push(de.start):Y.startInline=[de.start]))}de.childTokens&&(Y.childTokens[de.name]=de.childTokens)})),ue.renderer&&function(){var de=$e.defaults.renderer||new ce,Ce=function(j){var F=de[j];de[j]=function(){for(var H=arguments.length,G=new Array(H),ee=0;ee<H;ee++)G[ee]=arguments[ee];var re=ue.renderer[j].apply(de,G);return re===!1&&(re=F.apply(de,G)),re}};for(var Ae in ue.renderer)Ce(Ae);Q.renderer=de}(),ue.tokenizer&&function(){var de=$e.defaults.tokenizer||new V,Ce=function(j){var F=de[j];de[j]=function(){for(var H=arguments.length,G=new Array(H),ee=0;ee<H;ee++)G[ee]=arguments[ee];var re=ue.tokenizer[j].apply(de,G);return re===!1&&(re=F.apply(de,G)),re}};for(var Ae in ue.tokenizer)Ce(Ae);Q.tokenizer=de}(),ue.walkTokens){var Oe=$e.defaults.walkTokens;Q.walkTokens=function(de){var Ce=[];return Ce.push(ue.walkTokens.call(this,de)),Oe&&(Ce=Ce.concat(Oe.call(this,de))),Ce}}he&&(Q.extensions=Y),$e.setOptions(Q)})},$e.walkTokens=function(De,we){for(var ge=[],Q=function(){var Oe=he.value;switch(ge=ge.concat(we.call($e,Oe)),Oe.type){case"table":{for(var de=O(Oe.header),Ce;!(Ce=de()).done;){var Ae=Ce.value;ge=ge.concat($e.walkTokens(Ae.tokens,we))}for(var Ue=O(Oe.rows),j;!(j=Ue()).done;)for(var F=j.value,H=O(F),G;!(G=H()).done;){var ee=G.value;ge=ge.concat($e.walkTokens(ee.tokens,we))}break}case"list":{ge=ge.concat($e.walkTokens(Oe.items,we));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Oe.type]?$e.defaults.extensions.childTokens[Oe.type].forEach(function(re){ge=ge.concat($e.walkTokens(Oe[re],we))}):Oe.tokens&&(ge=ge.concat($e.walkTokens(Oe.tokens,we)))}},Y=O(De),he;!(he=Y()).done;)Q();return ge},$e.parseInline=function(De,we){if(typeof De>"u"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");we=h({},$e.defaults,we||{}),y(we);try{var ge=ie.lexInline(De,we);return we.walkTokens&&$e.walkTokens(ge,we.walkTokens),fe.parseInline(ge,we)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+g(Q.message+"",!0)+"</pre>";throw Q}},$e.Parser=fe,$e.parser=fe.parse,$e.Renderer=ce,$e.TextRenderer=ye,$e.Lexer=ie,$e.lexer=ie.lex,$e.Tokenizer=V,$e.Slugger=Se,$e.parse=$e;var Te=$e.options,ae=$e.setOptions,Ne=$e.use,ne=$e.walkTokens,z=$e.parseInline,x=$e,ve=fe.parse,Fe=ie.lex;le.Lexer=ie,le.Parser=fe,le.Renderer=ce,le.Slugger=Se,le.TextRenderer=ye,le.Tokenizer=V,le.getDefaults=R,le.lexer=Fe,le.marked=$e,le.options=Te,le.parse=x,le.parseInline=z,le.parser=ve,le.setOptions=ae,le.use=Ne,le.walkTokens=ne,Object.defineProperty(le,"__esModule",{value:!0})}),define(Ie[128],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=I;function I(r){const o=O(r);if(o&&o.length>0)return new Uint32Array(o)}let M=0;const A=new Uint32Array(10);function O(r){if(M=0,R(r,D,4352),M>0||(R(r,d,4449),M>0)||(R(r,v,4520),M>0)||(R(r,g,12593),M))return A.subarray(0,M);if(r>=44032&&r<=55203){const o=r-44032,s=o%588,i=Math.floor(o/588),n=Math.floor(s/28),c=s%28-1;if(i<D.length?R(i,D,0):4352+i-12593<g.length&&R(4352+i,g,12593),n<d.length?R(n,d,0):4449+n-12593<g.length&&R(4449+n-12593,g,12593),c>=0&&(c<v.length?R(c,v,0):4520+c-12593<g.length&&R(4520+c-12593,g,12593)),M>0)return A.subarray(0,M)}}function R(r,o,s){r>=s&&r<s+o.length&&w(o[r-s])}function w(r){r!==0&&(A[M++]=r&255,r>>8&&(A[M++]=r>>8&255),r>>16&&(A[M++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var E;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(E||(E={}));var T;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(T||(T={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),d=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),g=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ie[129],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0,e.$Bm=I,e.rot=M;function I(w,p,E){return Math.min(Math.max(w,p),E)}function M(w,p){return(p+w%p)%p}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Dm=A;class O{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Em=O;class R{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const E=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Fm=R}),define(Ie[130],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=O,e.$dd=d;class I{constructor(g,r,o){this.owner=g,this.debugNameSource=r,this.referenceFn=o}getDebugName(g){return O(g,this)}}e.$bd=I;const M=new Map,A=new WeakMap;function O(v,g){const r=A.get(v);if(r)return r;const o=R(v,g);if(o){let s=M.get(o)??0;s++,M.set(o,s);const i=s===1?o:`${o}#${s}`;return A.set(v,i),i}}function R(v,g){const r=A.get(v);if(r)return r;const o=g.owner?T(g.owner)+".":"";let s;const i=g.debugNameSource;if(i!==void 0)if(typeof i=="function"){if(s=i(),s!==void 0)return o+s}else return o+i;const n=g.referenceFn;if(n!==void 0&&(s=d(n),s!==void 0))return o+s;if(g.owner!==void 0){const c=w(g.owner,v);if(c!==void 0)return o+c}}function w(v,g){for(const r in v)if(v[r]===g)return r}const p=new Map,E=new WeakMap;function T(v){const g=E.get(v);if(g)return g;const r=D(v);let o=p.get(r)??0;o++,p.set(r,o);const s=o===1?r:`${r}#${o}`;return E.set(v,s),s}function D(v){const g=v.constructor;return g?g.name:"Object"}function d(v){const g=v.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(g);return(o?o[1]:void 0)?.trim()}}),define(Ie[131],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=M,e.$Jd=A;let I;function M(r){I=r}function A(){return I}class O{constructor(){this.a=0,this.d=new WeakMap}b(o){return R([w(v("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[w(" "),E(T(o.oldValue,70),{color:"red",strikeThrough:!0}),w(" "),E(T(o.newValue,60),{color:"green"})]:[w(" (unchanged)")]:[w(" "),E(T(o.newValue,60),{color:"green"}),w(" (initial)")]}handleObservableChanged(o,s){console.log(...this.b([p("observable value changed"),E(o.debugName,{color:"BlueViolet"}),...this.c(s)]))}formatChanges(o){if(o.size!==0)return E(" (changed deps: "+[...o].map(s=>s.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const s=o.handleChange;this.d.set(o,new Set),o.handleChange=(i,n)=>(this.d.get(o).add(i),s.apply(o,[i,n]))}handleDerivedRecomputed(o,s){const i=this.d.get(o);console.log(...this.b([p("derived recomputed"),E(o.debugName,{color:"BlueViolet"}),...this.c(s),this.formatChanges(i),{data:[{fn:o._computeFn}]}])),i.clear()}handleFromEventObservableTriggered(o,s){console.log(...this.b([p("observable from event triggered"),E(o.debugName,{color:"BlueViolet"}),...this.c(s),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const s=o.handleChange;this.d.set(o,new Set),o.handleChange=(i,n)=>(this.d.get(o).add(i),s.apply(o,[i,n]))}handleAutorunTriggered(o){const s=this.d.get(o);console.log(...this.b([p("autorun"),E(o.debugName,{color:"BlueViolet"}),this.formatChanges(s),{data:[{fn:o._runFn}]}])),s.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let s=o.getDebugName();s===void 0&&(s=""),console.log(...this.b([p("transaction"),E(s,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=O;function R(r){const o=new Array,s=[];let i="";function n(l){if("length"in l)for(const t of l)t&&n(t);else"text"in l?(i+=`%c${l.text}`,o.push(l.style),l.data&&s.push(...l.data)):"data"in l&&s.push(...l.data)}n(r);const c=[i,...o];return c.push(...s),c}function w(r){return E(r,{color:"black"})}function p(r){return E(g(`${r}: `,10),{color:"black",bold:!0})}function E(r,o={color:"black"}){function s(n){return Object.entries(n).reduce((c,[l,t])=>`${c}${l}:${t};`,"")}const i={color:o.color};return o.strikeThrough&&(i["text-decoration"]="line-through"),o.bold&&(i["font-weight"]="bold"),{text:r,style:s(i)}}function T(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?D(r,o):d(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function D(r,o){let s="[ ",i=!0;for(const n of r){if(i||(s+=", "),s.length-5>o){s+="...";break}i=!1,s+=`${T(n,o-s.length)}`}return s+=" ]",s}function d(r,o){let s="{ ",i=!0;for(const[n,c]of Object.entries(r)){if(i||(s+=", "),s.length-5>o){s+="...";break}i=!1,s+=`${n}: ${T(c,o-s.length)}`}return s+=" }",s}function v(r,o){let s="";for(let i=1;i<=o;i++)s+=r;return s}function g(r,o){for(;r.length<o;)r+=" ";return r}}),define(Ie[132],Pe([1,0,125,130,131]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$4d=e.$1d=e.$Vd=e.$Ud=void 0,e.$Rd=R,e.$Sd=p,e.$Td=T,e.$Wd=v,e.$Xd=r,e.$Yd=o,e.$Zd=s,e.$2d=n,e.$3d=c,e.$5d=t;let O;function R(a){O=a}let w;function p(a){w=a}let E;function T(a){E=a}class D{get TChange(){return null}reportChanges(){this.get()}read($){return $?$.readObservable(this):this.get()}map($,u){const S=u===void 0?void 0:$,h=u===void 0?$:u;return E({owner:S,debugName:()=>{const b=(0,M.$dd)(h);if(b!==void 0)return b;const k=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(h.toString());if(k)return`${this.debugName}.${k[2]}`;if(!S)return`${this.debugName} (mapped)`},debugReferenceFn:h},b=>h(this.read(b),b))}recomputeInitiallyAndOnChange($,u){return $.add(O(this,u)),this}keepObserved($){return $.add(w(this)),this}get a(){return this.get()}}e.$Ud=D;class d extends D{constructor(){super(...arguments),this.b=new Set}addObserver($){const u=this.b.size;this.b.add($),u===0&&this.c()}removeObserver($){this.b.delete($)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Vd=d;function v(a,$){const u=new i(a,$);try{a(u)}finally{u.finish()}}let g;function r(a){if(g)a(g);else{const $=new i(a,void 0);g=$;try{a($)}finally{$.finish(),g=void 0}}}async function o(a,$){const u=new i(a,$);try{await a(u)}finally{u.finish()}}function s(a,$,u){a?$(a):v($,u)}class i{constructor($,u){this._fn=$,this.b=u,this.a=[],(0,A.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,M.$dd)(this._fn)}updateObserver($,u){this.a.push({observer:$,observable:u}),$.beginUpdate(u)}finish(){const $=this.a;for(let u=0;u<$.length;u++){const{observer:S,observable:h}=$[u];S.endUpdate(h)}this.a=null,(0,A.$Jd)()?.handleEndTransaction()}}e.$1d=i;function n(a,$){let u;return typeof a=="string"?u=new M.$bd(void 0,a,void 0):u=new M.$bd(a,void 0,void 0),new l(u,$,I.$7c)}function c(a,$){return new l(new M.$bd(a.owner,a.debugName,void 0),$,a.equalsFn??I.$7c)}class l extends d{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor($,u,S){super(),this.e=$,this.g=S,this.d=u}get(){return this.d}set($,u,S){if(this.g(this.d,$))return;let h;u||(u=h=new i(()=>{},()=>`Setting ${this.debugName}`));try{const b=this.d;this.h($),(0,A.$Jd)()?.handleObservableChanged(this,{oldValue:b,newValue:$,change:S,didChange:!0,hadValue:!0});for(const m of this.b)u.updateObserver(m,this),m.handleChange(this,S)}finally{h&&h.finish()}}toString(){return`${this.debugName}: ${this.d}`}h($){this.d=$}}e.$4d=l;function t(a,$){let u;return typeof a=="string"?u=new M.$bd(void 0,a,void 0):u=new M.$bd(a,void 0,void 0),new f(u,$,I.$7c)}class f extends l{h($){this.d!==$&&(this.d&&this.d.dispose(),this.d=$)}dispose(){this.d?.dispose()}}e.$6d=f}),function(){function le(A){const O=[];typeof A=="number"&&O.push("code/timeOrigin",A);function R(p){O.push(p,Date.now())}function w(){const p=[];for(let E=0;E<O.length;E+=2)p.push({name:O[E],startTime:O[E+1]});return p}return{mark:R,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const R of performance.getEntriesByType("mark"))O.push({name:R.name,startTime:Math.round(A+R.startTime)});return O}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function I(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=I(M))}(),define(Ie[133],Pe([1,0,42]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fP=void 0;const M=Symbol("unset");class A{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(p,E,T){this.d(p,D=>D._value=E,T)}mutate(p,E){this.d(p,T=>T._value=E(T._value===M?void 0:T._value))}delete(p){const E=this.c(p);if(!E)return;let T=E.length-1;const D=E[T].node._value;if(D!==M){for(this.b--,E[T].node._value=M;T>0;T--){const{node:d,part:v}=E[T];if(d.children?.size||d._value!==M)break;E[T-1].node.children.delete(v)}return D}}*deleteRecursive(p){const E=this.c(p);if(!E)return;const T=E[E.length-1].node;for(let D=E.length-1;D>0;D--){const d=E[D-1];if(d.node.children.delete(E[D].part),d.node.children.size>0||d.node._value!==M)break}for(const D of O(T))D._value!==M&&(this.b--,yield D._value)}find(p){let E=this.a;for(const T of p){const D=E.children?.get(T);if(!D)return;E=D}return E._value===M?void 0:E._value}hasKeyOrParent(p){let E=this.a;for(const T of p){const D=E.children?.get(T);if(!D)return!1;if(D._value!==M)return!0;E=D}return!1}hasKeyOrChildren(p){let E=this.a;for(const T of p){const D=E.children?.get(T);if(!D)return!1;E=D}return!0}hasKey(p){let E=this.a;for(const T of p){const D=E.children?.get(T);if(!D)return!1;E=D}return E._value!==M}c(p){const E=[{part:"",node:this.a}];let T=0;for(const D of p){const d=E[T].node.children?.get(D);if(!d)return;E.push({part:D,node:d}),T++}return E}d(p,E,T){let D=this.a;for(const g of p){if(D.children)if(D.children.has(g))D=D.children.get(g);else{const r=new R;D.children.set(g,r),D=r}else{const r=new R;D.children=new Map([[g,r]]),D=r}T?.(D)}const d=D._value===M?0:1;E(D);const v=D._value===M?0:1;this.b+=v-d}*values(){for(const{_value:p}of O(this.a))p!==M&&(yield p)}}e.$fP=A;function*O(w){const p=[w];for(;p.length>0;){const E=p.pop();if(yield E,E.children)for(const T of E.children.values())p.push(T)}}class R{constructor(){this._value=M}get value(){return this._value===M?void 0:this._value}set value(p){this._value=p===void 0?M:p}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var M in I)(typeof exports=="object"?exports:le)[M]=I[M]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function I(M){if(e[M])return e[M].exports;var A=e[M]={i:M,l:!1,exports:{}};return le[M].call(A.exports,A,A.exports,I),A.l=!0,A.exports}return I.m=le,I.c=e,I.d=function(M,A,O){I.o(M,A)||Object.defineProperty(M,A,{enumerable:!0,get:O})},I.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},I.t=function(M,A){if(1&A&&(M=I(M)),8&A||4&A&&typeof M=="object"&&M&&M.__esModule)return M;var O=Object.create(null);if(I.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:M}),2&A&&typeof M!="string")for(var R in M)I.d(O,R,function(w){return M[w]}.bind(null,R));return O},I.n=function(M){var A=M&&M.__esModule?function(){return M.default}:function(){return M};return I.d(A,"a",A),A},I.o=function(M,A){return Object.prototype.hasOwnProperty.call(M,A)},I.p="",I(I.s=0)}([function(le,e,I){(function(M){var A;e=le.exports=Ne,A=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],p=e.src=[],E=0,T=E++;p[T]="0|[1-9]\\d*";var D=E++;p[D]="[0-9]+";var d=E++;p[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=E++;p[v]="("+p[T]+")\\.("+p[T]+")\\.("+p[T]+")";var g=E++;p[g]="("+p[D]+")\\.("+p[D]+")\\.("+p[D]+")";var r=E++;p[r]="(?:"+p[T]+"|"+p[d]+")";var o=E++;p[o]="(?:"+p[D]+"|"+p[d]+")";var s=E++;p[s]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var i=E++;p[i]="(?:-?("+p[o]+"(?:\\."+p[o]+")*))";var n=E++;p[n]="[0-9A-Za-z-]+";var c=E++;p[c]="(?:\\+("+p[n]+"(?:\\."+p[n]+")*))";var l=E++,t="v?"+p[v]+p[s]+"?"+p[c]+"?";p[l]="^"+t+"$";var f="[v=\\s]*"+p[g]+p[i]+"?"+p[c]+"?",a=E++;p[a]="^"+f+"$";var $=E++;p[$]="((?:<|>)?=?)";var u=E++;p[u]=p[D]+"|x|X|\\*";var S=E++;p[S]=p[T]+"|x|X|\\*";var h=E++;p[h]="[v=\\s]*("+p[S]+")(?:\\.("+p[S]+")(?:\\.("+p[S]+")(?:"+p[s]+")?"+p[c]+"?)?)?";var b=E++;p[b]="[v=\\s]*("+p[u]+")(?:\\.("+p[u]+")(?:\\.("+p[u]+")(?:"+p[i]+")?"+p[c]+"?)?)?";var m=E++;p[m]="^"+p[$]+"\\s*"+p[h]+"$";var k=E++;p[k]="^"+p[$]+"\\s*"+p[b]+"$";var y=E++;p[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;p[C]="(?:~>?)";var P=E++;p[P]="(\\s*)"+p[C]+"\\s+",w[P]=new RegExp(p[P],"g");var W=E++;p[W]="^"+p[C]+p[h]+"$";var V=E++;p[V]="^"+p[C]+p[b]+"$";var q=E++;p[q]="(?:\\^)";var N=E++;p[N]="(\\s*)"+p[q]+"\\s+",w[N]=new RegExp(p[N],"g");var U=E++;p[U]="^"+p[q]+p[h]+"$";var K=E++;p[K]="^"+p[q]+p[b]+"$";var ie=E++;p[ie]="^"+p[$]+"\\s*("+f+")$|^$";var ce=E++;p[ce]="^"+p[$]+"\\s*("+t+")$|^$";var ye=E++;p[ye]="(\\s*)"+p[$]+"\\s*("+f+"|"+p[h]+")",w[ye]=new RegExp(p[ye],"g");var Se=E++;p[Se]="^\\s*("+p[h]+")\\s+-\\s+("+p[h]+")\\s*$";var fe=E++;p[fe]="^\\s*("+p[b]+")\\s+-\\s+("+p[b]+")\\s*$";var $e=E++;p[$e]="(<|>)?=?\\s*\\*";for(var Te=0;Te<35;Te++)A(Te,p[Te]),w[Te]||(w[Te]=new RegExp(p[Te]));function ae(F,H){if(F instanceof Ne)return F;if(typeof F!="string"||F.length>O||!(H?w[a]:w[l]).test(F))return null;try{return new Ne(F,H)}catch{return null}}function Ne(F,H){if(F instanceof Ne){if(F.loose===H)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Ne))return new Ne(F,H);A("SemVer",F,H),this.loose=H;var G=F.trim().match(H?w[a]:w[l]);if(!G)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var re=+ee;if(re>=0&&re<R)return re}return ee}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}e.parse=ae,e.valid=function(F,H){var G=ae(F,H);return G?G.version:null},e.clean=function(F,H){var G=ae(F.trim().replace(/^[=v]+/,""),H);return G?G.version:null},e.SemVer=Ne,Ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ne.prototype.toString=function(){return this.version},Ne.prototype.compare=function(F){return A("SemVer.compare",this.version,this.loose,F),F instanceof Ne||(F=new Ne(F,this.loose)),this.compareMain(F)||this.comparePre(F)},Ne.prototype.compareMain=function(F){return F instanceof Ne||(F=new Ne(F,this.loose)),z(this.major,F.major)||z(this.minor,F.minor)||z(this.patch,F.patch)},Ne.prototype.comparePre=function(F){if(F instanceof Ne||(F=new Ne(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var H=0;do{var G=this.prerelease[H],ee=F.prerelease[H];if(A("prerelease compare",H,G,ee),G===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(G===void 0)return-1;if(G!==ee)return z(G,ee)}while(++H)},Ne.prototype.inc=function(F,H){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},e.inc=function(F,H,G,ee){typeof G=="string"&&(ee=G,G=void 0);try{return new Ne(F,G).inc(H,ee).version}catch{return null}},e.diff=function(F,H){if(De(F,H))return null;var G=ae(F),ee=ae(H);if(G.prerelease.length||ee.prerelease.length){for(var re in G)if((re==="major"||re==="minor"||re==="patch")&&G[re]!==ee[re])return"pre"+re;return"prerelease"}for(var re in G)if((re==="major"||re==="minor"||re==="patch")&&G[re]!==ee[re])return re},e.compareIdentifiers=z;var ne=/^[0-9]+$/;function z(F,H){var G=ne.test(F),ee=ne.test(H);return G&&ee&&(F=+F,H=+H),G&&!ee?-1:ee&&!G?1:F<H?-1:F>H?1:0}function x(F,H,G){return new Ne(F,G).compare(new Ne(H,G))}function ve(F,H,G){return x(F,H,G)>0}function Fe(F,H,G){return x(F,H,G)<0}function De(F,H,G){return x(F,H,G)===0}function we(F,H,G){return x(F,H,G)!==0}function ge(F,H,G){return x(F,H,G)>=0}function Q(F,H,G){return x(F,H,G)<=0}function Y(F,H,G,ee){var re;switch(H){case"===":typeof F=="object"&&(F=F.version),typeof G=="object"&&(G=G.version),re=F===G;break;case"!==":typeof F=="object"&&(F=F.version),typeof G=="object"&&(G=G.version),re=F!==G;break;case"":case"=":case"==":re=De(F,G,ee);break;case"!=":re=we(F,G,ee);break;case">":re=ve(F,G,ee);break;case">=":re=ge(F,G,ee);break;case"<":re=Fe(F,G,ee);break;case"<=":re=Q(F,G,ee);break;default:throw new TypeError("Invalid operator: "+H)}return re}function he(F,H){if(F instanceof he){if(F.loose===H)return F;F=F.value}if(!(this instanceof he))return new he(F,H);A("comparator",F,H),this.loose=H,this.parse(F),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(F,H){return z(H,F)},e.major=function(F,H){return new Ne(F,H).major},e.minor=function(F,H){return new Ne(F,H).minor},e.patch=function(F,H){return new Ne(F,H).patch},e.compare=x,e.compareLoose=function(F,H){return x(F,H,!0)},e.rcompare=function(F,H,G){return x(H,F,G)},e.sort=function(F,H){return F.sort(function(G,ee){return e.compare(G,ee,H)})},e.rsort=function(F,H){return F.sort(function(G,ee){return e.rcompare(G,ee,H)})},e.gt=ve,e.lt=Fe,e.eq=De,e.neq=we,e.gte=ge,e.lte=Q,e.cmp=Y,e.Comparator=he;var ue={};function Oe(F,H){if(F instanceof Oe)return F.loose===H?F:new Oe(F.raw,H);if(F instanceof he)return new Oe(F.value,H);if(!(this instanceof Oe))return new Oe(F,H);if(this.loose=H,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function de(F){return!F||F.toLowerCase()==="x"||F==="*"}function Ce(F,H,G,ee,re,Me,Be,He,_e,xe,et,tt,it){return((H=de(G)?"":de(ee)?">="+G+".0.0":de(re)?">="+G+"."+ee+".0":">="+H)+" "+(He=de(_e)?"":de(xe)?"<"+(+_e+1)+".0.0":de(et)?"<"+_e+"."+(+xe+1)+".0":tt?"<="+_e+"."+xe+"."+et+"-"+tt:"<="+He)).trim()}function Ae(F,H){for(var G=0;G<F.length;G++)if(!F[G].test(H))return!1;if(H.prerelease.length){for(G=0;G<F.length;G++)if(A(F[G].semver),F[G].semver!==ue&&F[G].semver.prerelease.length>0){var ee=F[G].semver;if(ee.major===H.major&&ee.minor===H.minor&&ee.patch===H.patch)return!0}return!1}return!0}function Ue(F,H,G){try{H=new Oe(H,G)}catch{return!1}return H.test(F)}function j(F,H,G,ee){var re,Me,Be,He,_e;switch(F=new Ne(F,ee),H=new Oe(H,ee),G){case">":re=ve,Me=Q,Be=Fe,He=">",_e=">=";break;case"<":re=Fe,Me=ge,Be=ve,He="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(F,H,ee))return!1;for(var xe=0;xe<H.set.length;++xe){var et=H.set[xe],tt=null,it=null;if(et.forEach(function(at){at.semver===ue&&(at=new he(">=0.0.0")),tt=tt||at,it=it||at,re(at.semver,tt.semver,ee)?tt=at:Be(at.semver,it.semver,ee)&&(it=at)}),tt.operator===He||tt.operator===_e||(!it.operator||it.operator===He)&&Me(F,it.semver)||it.operator===_e&&Be(F,it.semver))return!1}return!0}he.prototype.parse=function(F){var H=this.loose?w[ie]:w[ce],G=F.match(H);if(!G)throw new TypeError("Invalid comparator: "+F);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new Ne(G[2],this.loose):this.semver=ue},he.prototype.toString=function(){return this.value},he.prototype.test=function(F){return A("Comparator.test",F,this.loose),this.semver===ue||(typeof F=="string"&&(F=new Ne(F,this.loose)),Y(F,this.operator,this.semver,this.loose))},he.prototype.intersects=function(F,H){if(!(F instanceof he))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new Oe(F.value,H),Ue(this.value,G,H);if(F.operator==="")return G=new Oe(this.value,H),Ue(F.semver,G,H);var ee=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Me=this.semver.version===F.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),He=Y(this.semver,"<",F.semver,H)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),_e=Y(this.semver,">",F.semver,H)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ee||re||Me&&Be||He||_e},e.Range=Oe,Oe.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},Oe.prototype.toString=function(){return this.range},Oe.prototype.parseRange=function(F){var H=this.loose;F=F.trim(),A("range",F,H);var G=H?w[fe]:w[Se];F=F.replace(G,Ce),A("hyphen replace",F),F=F.replace(w[ye],"$1$2$3"),A("comparator trim",F,w[ye]),F=(F=(F=F.replace(w[P],"$1~")).replace(w[N],"$1^")).split(/\s+/).join(" ");var ee=H?w[ie]:w[ce],re=F.split(" ").map(function(Me){return function(Be,He){return A("comp",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){A("caret",tt,it);var at=it?w[K]:w[U];return tt.replace(at,function(gt,je,st,X,Z){var me;return A("caret",tt,gt,je,st,X,Z),de(je)?me="":de(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":de(X)?me=je==="0"?">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":">="+je+"."+st+".0 <"+(+je+1)+".0.0":Z?(A("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+Z+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+Z+" <"+(+je+1)+".0.0"):(A("no pr"),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+" <"+(+je+1)+".0.0"),A("caret return",me),me})}(et,xe)}).join(" ")}(Be,He),A("caret",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){var at=it?w[V]:w[W];return tt.replace(at,function(gt,je,st,X,Z){var me;return A("tilde",tt,gt,je,st,X,Z),de(je)?me="":de(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":de(X)?me=">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":Z?(A("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0"):me=">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0",A("tilde return",me),me})}(et,xe)}).join(" ")}(Be,He),A("tildes",Be),Be=function(_e,xe){return A("replaceXRanges",_e,xe),_e.split(/\s+/).map(function(et){return function(tt,it){tt=tt.trim();var at=it?w[k]:w[m];return tt.replace(at,function(gt,je,st,X,Z,me){A("xRange",tt,gt,je,st,X,Z,me);var qe=de(st),be=qe||de(X),ot=be||de(Z);return je==="="&&ot&&(je=""),qe?gt=je===">"||je==="<"?"<0.0.0":"*":je&&ot?(be&&(X=0),ot&&(Z=0),je===">"?(je=">=",be?(st=+st+1,X=0,Z=0):ot&&(X=+X+1,Z=0)):je==="<="&&(je="<",be?st=+st+1:X=+X+1),gt=je+st+"."+X+"."+Z):be?gt=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(gt=">="+st+"."+X+".0 <"+st+"."+(+X+1)+".0"),A("xRange return",gt),gt})}(et,xe)}).join(" ")}(Be,He),A("xrange",Be),Be=function(_e,xe){return A("replaceStars",_e,xe),_e.trim().replace(w[$e],"")}(Be,He),A("stars",Be),Be}(Me,H)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Me){return!!Me.match(ee)})),re=re.map(function(Me){return new he(Me,H)})},Oe.prototype.intersects=function(F,H){if(!(F instanceof Oe))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(ee){return F.set.some(function(re){return re.every(function(Me){return ee.intersects(Me,H)})})})})},e.toComparators=function(F,H){return new Oe(F,H).set.map(function(G){return G.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Oe.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new Ne(F,this.loose));for(var H=0;H<this.set.length;H++)if(Ae(this.set[H],F))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(F,H,G){var ee=null,re=null;try{var Me=new Oe(H,G)}catch{return null}return F.forEach(function(Be){Me.test(Be)&&(ee&&re.compare(Be)!==-1||(re=new Ne(ee=Be,G)))}),ee},e.minSatisfying=function(F,H,G){var ee=null,re=null;try{var Me=new Oe(H,G)}catch{return null}return F.forEach(function(Be){Me.test(Be)&&(ee&&re.compare(Be)!==1||(re=new Ne(ee=Be,G)))}),ee},e.validRange=function(F,H){try{return new Oe(F,H).range||"*"}catch{return null}},e.ltr=function(F,H,G){return j(F,H,"<",G)},e.gtr=function(F,H,G){return j(F,H,">",G)},e.outside=j,e.prerelease=function(F,H){var G=ae(F,H);return G&&G.prerelease.length?G.prerelease:null},e.intersects=function(F,H,G){return F=new Oe(F,G),H=new Oe(H,G),F.intersects(H)},e.coerce=function(F){if(F instanceof Ne)return F;if(typeof F!="string")return null;var H=F.match(w[y]);return H==null?null:ae((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,I(1))},function(le,e){var I,M,A=le.exports={};function O(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function w(o){if(I===setTimeout)return setTimeout(o,0);if((I===O||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:O}catch{I=O}try{M=typeof clearTimeout=="function"?clearTimeout:R}catch{M=R}})();var p,E=[],T=!1,D=-1;function d(){T&&p&&(T=!1,p.length?E=p.concat(E):D=-1,E.length&&v())}function v(){if(!T){var o=w(d);T=!0;for(var s=E.length;s;){for(p=E,E=[];++D<s;)p&&p[D].run();D=-1,s=E.length}p=null,T=!1,function(i){if(M===clearTimeout)return clearTimeout(i);if((M===R||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(i);try{M(i)}catch{try{return M.call(null,i)}catch{return M.call(this,i)}}}(o)}}function g(o,s){this.fun=o,this.array=s}function r(){}A.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];E.push(new g(o,s)),E.length!==1||T||w(v)},g.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=r,A.addListener=r,A.once=r,A.off=r,A.removeListener=r,A.removeAllListeners=r,A.emit=r,A.prependListener=r,A.prependOnceListener=r,A.listeners=function(o){return[]},A.binding=function(o){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(o){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Ie[134],Pe([1,0,14,6]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=A,e.$se=O,e.$te=R,e.$ue=w,e.$ve=E,e.$we=T,e.$xe=D,e.$ye=d,e.$ze=v,e.$Ae=g,e.$Be=r,e.$Ce=o,e.$De=s,e.$Ee=i,e.$Fe=n;function A(c){const l=c;return l?typeof l.read=="function":!1}function O(c){const l=c;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}function R(c){const l=c;return l?O(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}function w(c,l){return new p(c,l)}class p{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,I.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let f;switch(l){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const a=f.indexOf(t);a>=0&&f.splice(a,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,l){const t=[];let f;for(;(f=c.read())!==null;)t.push(f);return l(t)}function T(c,l,t){const f=[];let a;for(;(a=c.read())!==null&&f.length<t;)f.push(a);return a===null&&f.length>0?l(f):{read:()=>{if(f.length>0)return f.shift();if(typeof a<"u"){const $=a;return a=void 0,$}return c.read()}}}function D(c,l){return new Promise((t,f)=>{const a=[];d(c,{onData:$=>{l&&a.push($)},onError:$=>{l?f($):t(void 0)},onEnd:()=>{t(l?l(a):void 0)}})})}function d(c,l,t){c.on("error",f=>{t?.isCancellationRequested||l.onError(f)}),c.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),c.on("data",f=>{t?.isCancellationRequested||l.onData(f)})}function v(c,l){return new Promise((t,f)=>{const a=new M.$Uc,$=[],u=b=>{if($.push(b),$.length>l)return a.dispose(),c.pause(),t({stream:c,buffer:$,ended:!1})},S=b=>(a.dispose(),f(b)),h=()=>(a.dispose(),t({stream:c,buffer:$,ended:!0}));a.add((0,M.$Tc)(()=>c.removeListener("error",S))),c.on("error",S),a.add((0,M.$Tc)(()=>c.removeListener("end",h))),c.on("end",h),a.add((0,M.$Tc)(()=>c.removeListener("data",u))),c.on("data",u)})}function g(c,l){const t=w(l);return t.end(c),t}function r(){const c=w(()=>{throw new Error("not supported")});return c.end(),c}function o(c){let l=!1;return{read:()=>l?null:(l=!0,c)}}function s(c,l,t){const f=w(t);return d(c,{onData:a=>f.write(l.data(a)),onError:a=>f.error(l.error?l.error(a):a),onEnd:()=>f.end()}),f}function i(c,l,t){let f=!1;return{read:()=>{const a=l.read();return f?a:(f=!0,a!==null?t([c,a]):c)}}}function n(c,l,t){let f=!1;const a=w(t);return d(l,{onData:$=>f?a.write($):(f=!0,a.write(t([c,$]))),onError:$=>a.error($),onEnd:()=>{f||(f=!0,a.write(c)),a.end()}}),a}}),define(Ie[21],Pe([1,0,43,134]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=void 0,e.$He=E,e.$Ie=T,e.$Je=D,e.$Ke=d,e.$Le=v,e.$Me=g,e.$Ne=r,e.$Oe=o,e.$Pe=s,e.$Qe=i,e.$Re=n,e.$Se=c,e.$Te=l,e.$Ue=t,e.$Ve=f,e.$We=a,e.$Xe=$,e.$Ye=u,e.$Ze=S,e.$1e=m;const A=typeof Buffer<"u",O=new I.$V(()=>new Uint8Array(256));let R,w;class p{static alloc(y){return A?new p(Buffer.allocUnsafe(y)):new p(new Uint8Array(y))}static wrap(y){return A&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new p(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&A?new p(Buffer.from(y)):(R||(R=new TextEncoder),new p(R.encode(y)))}static fromByteArray(y){const C=p.alloc(y.length);for(let P=0,W=y.length;P<W;P++)C.buffer[P]=y[P];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let V=0,q=y.length;V<q;V++)C+=y[V].byteLength}const P=p.alloc(C);let W=0;for(let V=0,q=y.length;V<q;V++){const N=y[V];P.set(N,W),W+=N.byteLength}return P}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=p.alloc(this.byteLength);return y.set(this),y}toString(){return A?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(y,C){return new p(this.buffer.subarray(y,C))}set(y,C){if(y instanceof p)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return d(this.buffer,y)}writeUInt32BE(y,C){v(this.buffer,y,C)}readUInt32LE(y){return g(this.buffer,y)}writeUInt32LE(y,C){r(this.buffer,y,C)}readUInt8(y){return o(this.buffer,y)}writeUInt8(y,C){s(this.buffer,y,C)}indexOf(y,C=0){return E(this.buffer,y instanceof p?y.buffer:y,C)}}e.$Ge=p;function E(k,y,C=0){const P=y.byteLength,W=k.byteLength;if(P===0)return 0;if(P===1)return k.indexOf(y[0]);if(P>W-C)return-1;const V=O.value;V.fill(y.length);for(let K=0;K<y.length;K++)V[y[K]]=y.length-K-1;let q=C+y.length-1,N=q,U=-1;for(;q<W;)if(k[q]===y[N]){if(N===0){U=q;break}q--,N--}else q+=Math.max(y.length-N,V[k[q]]),N=y.length-1;return U}function T(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0}function D(k,y,C){k[C+0]=y&255,y=y>>>8,k[C+1]=y&255}function d(k,y){return k[y]*2**24+k[y+1]*2**16+k[y+2]*2**8+k[y+3]}function v(k,y,C){k[C+3]=y,y=y>>>8,k[C+2]=y,y=y>>>8,k[C+1]=y,y=y>>>8,k[C]=y}function g(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0|k[y+2]<<16>>>0|k[y+3]<<24>>>0}function r(k,y,C){k[C+0]=y&255,y=y>>>8,k[C+1]=y&255,y=y>>>8,k[C+2]=y&255,y=y>>>8,k[C+3]=y&255}function o(k,y){return k[y]}function s(k,y,C){k[C]=y}function i(k){return M.$ve(k,y=>p.concat(y))}function n(k){return M.$Ce(k)}function c(k){return M.$xe(k,y=>p.concat(y))}async function l(k){return k.ended?p.concat(k.buffer):p.concat([...k.buffer,await c(k.stream)])}function t(k){return M.$Ae(k,y=>p.concat(y))}function f(k){return M.$De(k,{data:y=>typeof y=="string"?p.fromString(y):p.wrap(y)},y=>p.concat(y))}function a(k){return M.$ue(y=>p.concat(y),k)}function $(k,y){return M.$Ee(k,y,C=>p.concat(C))}function u(k,y){return M.$Fe(k,y,C=>p.concat(C))}function S(k){let y=0,C=0,P=0;const W=new Uint8Array(Math.floor(k.length/4*3)),V=N=>{switch(C){case 3:W[P++]=y|N,C=0;break;case 2:W[P++]=y|N>>>2,y=N<<6,C=3;break;case 1:W[P++]=y|N>>>4,y=N<<4,C=2;break;default:y=N<<2,C=1}};for(let N=0;N<k.length;N++){const U=k.charCodeAt(N);if(U>=65&&U<=90)V(U-65);else if(U>=97&&U<=122)V(U-97+26);else if(U>=48&&U<=57)V(U-48+52);else if(U===43||U===45)V(62);else if(U===47||U===95)V(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${k[N]}`)}}const q=P;for(;C>0;)V(0);return p.wrap(W).slice(0,q)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:k},y=!0,C=!1){const P=C?b:h;let W="";const V=k.byteLength%3;let q=0;for(;q<k.byteLength-V;q+=3){const N=k[q+0],U=k[q+1],K=k[q+2];W+=P[N>>>2],W+=P[(N<<4|U>>>4)&63],W+=P[(U<<2|K>>>6)&63],W+=P[K&63]}if(V===1){const N=k[q+0];W+=P[N>>>2],W+=P[N<<4&63],y&&(W+="==")}else if(V===2){const N=k[q+0],U=k[q+1];W+=P[N>>>2],W+=P[(N<<4|U>>>4)&63],W+=P[U<<2&63],y&&(W+="=")}return W}}),define(Ie[135],Pe([1,0,28,128,13]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=O,e.$zk=w,e.$Ak=p,e.$Bk=D,e.$Ck=S,e.$Dk=h,e.$Ek=P,e.$Fk=W,e.$Gk=V,e.$Hk=q,e.$Ik=x,e.$Kk=we,e.$Lk=Y,e.$Mk=he;function O(...de){return function(Ce,Ae){for(let Ue=0,j=de.length;Ue<j;Ue++){const F=de[Ue](Ce,Ae);if(F)return F}return null}}e.$xk=R.bind(void 0,!1),e.$yk=R.bind(void 0,!0);function R(de,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let Ue;return de?Ue=A.$zf(Ae,Ce):Ue=Ae.indexOf(Ce)===0,Ue?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function w(de,Ce){const Ae=Ce.toLowerCase().indexOf(de.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+de.length}]}function p(de,Ce){return E(de.toLowerCase(),Ce.toLowerCase(),0,0)}function E(de,Ce,Ae,Ue){if(Ae===de.length)return[];if(Ue===Ce.length)return null;if(de[Ae]===Ce[Ue]){let j=null;return(j=E(de,Ce,Ae+1,Ue+1))?c({start:Ue,end:Ue+1},j):null}return E(de,Ce,Ae,Ue+1)}function T(de){return 97<=de&&de<=122}function D(de){return 65<=de&&de<=90}function d(de){return 48<=de&&de<=57}function v(de){return de===32||de===9||de===10||de===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>g.add(de.charCodeAt(0)));function r(de){return v(de)||g.has(de)}function o(de,Ce){return de===Ce||r(de)&&r(Ce)}const s=new Map;function i(de){if(s.has(de))return s.get(de);let Ce;const Ae=(0,M.$vk)(de);return Ae&&(Ce=Ae),s.set(de,Ce),Ce}function n(de){return T(de)||D(de)||d(de)}function c(de,Ce){return Ce.length===0?Ce=[de]:de.end===Ce[0].start?Ce[0].start=de.start:Ce.unshift(de),Ce}function l(de,Ce){for(let Ae=Ce;Ae<de.length;Ae++){const Ue=de.charCodeAt(Ae);if(D(Ue)||d(Ue)||Ae>0&&!n(de.charCodeAt(Ae-1)))return Ae}return de.length}function t(de,Ce,Ae,Ue){if(Ae===de.length)return[];if(Ue===Ce.length)return null;if(de[Ae]!==Ce[Ue].toLowerCase())return null;{let j=null,F=Ue+1;for(j=t(de,Ce,Ae+1,Ue+1);!j&&(F=l(Ce,F))<Ce.length;)j=t(de,Ce,Ae+1,F),F++;return j===null?null:c({start:Ue,end:Ue+1},j)}}function f(de){let Ce=0,Ae=0,Ue=0,j=0,F=0;for(let Me=0;Me<de.length;Me++)F=de.charCodeAt(Me),D(F)&&Ce++,T(F)&&Ae++,n(F)&&Ue++,d(F)&&j++;const H=Ce/de.length,G=Ae/de.length,ee=Ue/de.length,re=j/de.length;return{upperPercent:H,lowerPercent:G,alphaPercent:ee,numericPercent:re}}function a(de){const{upperPercent:Ce,lowerPercent:Ae}=de;return Ae===0&&Ce>.6}function $(de){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:Ue,numericPercent:j}=de;return Ae>.2&&Ce<.8&&Ue>.6&&j<.2}function u(de){let Ce=0,Ae=0,Ue=0,j=0;for(let F=0;F<de.length;F++)Ue=de.charCodeAt(F),D(Ue)&&Ce++,T(Ue)&&Ae++,v(Ue)&&j++;return(Ce===0||Ae===0)&&j===0?de.length<=30:Ce<=5}function S(de,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!u(de))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Ae=f(Ce);if(!$(Ae)){if(!a(Ae))return null;Ce=Ce.toLowerCase()}let Ue=null,j=0;for(de=de.toLowerCase();j<Ce.length&&(Ue=t(de,Ce,0,j))===null;)j=l(Ce,j+1);return Ue}function h(de,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let Ue=null,j=0;for(de=de.toLowerCase(),Ce=Ce.toLowerCase();j<Ce.length&&(Ue=b(de,Ce,0,j,Ae),Ue===null);)j=m(Ce,j+1);return Ue}function b(de,Ce,Ae,Ue,j){let F=0;if(Ae===de.length)return[];if(Ue===Ce.length)return null;if(!o(de.charCodeAt(Ae),Ce.charCodeAt(Ue))){const ee=i(de.charCodeAt(Ae));if(!ee)return null;for(let re=0;re<ee.length;re++)if(!o(ee[re],Ce.charCodeAt(Ue+re)))return null;F+=ee.length-1}let H=null,G=Ue+F+1;if(H=b(de,Ce,Ae+1,G,j),!j)for(;!H&&(G=m(Ce,G))<Ce.length;)H=b(de,Ce,Ae+1,G,j),G++;if(!H)return null;if(de.charCodeAt(Ae)!==Ce.charCodeAt(Ue)){const ee=i(de.charCodeAt(Ae));if(!ee)return H;for(let re=0;re<ee.length;re++)if(ee[re]!==Ce.charCodeAt(Ue+re))return H}return c({start:Ue,end:Ue+F+1},H)}function m(de,Ce){for(let Ae=Ce;Ae<de.length;Ae++)if(r(de.charCodeAt(Ae))||Ae>0&&r(de.charCodeAt(Ae-1)))return Ae;return de.length}const k=O(e.$yk,S,w),y=O(e.$yk,S,p),C=new I.$Ec(1e4);function P(de,Ce,Ae=!1){if(typeof de!="string"||typeof Ce!="string")return null;let Ue=C.get(de);Ue||(Ue=new RegExp(A.$hf(de),"i"),C.set(de,Ue));const j=Ue.exec(Ce);return j?[{start:j.index,end:j.index+j[0].length}]:Ae?y(de,Ce):k(de,Ce)}function W(de,Ce){const Ae=we(de,de.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?q(Ae):null}function V(de,Ce,Ae,Ue,j,F){const H=Math.min(13,de.length);for(;Ae<H;Ae++){const G=we(de,Ce,Ae,Ue,j,F,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(G)return G}return[0,F]}function q(de){if(typeof de>"u")return[];const Ce=[],Ae=de[1];for(let Ue=de.length-1;Ue>1;Ue--){const j=de[Ue]+Ae,F=Ce[Ce.length-1];F&&F.end===j?F.end=j+1:Ce.push({start:j,end:j+1})}return Ce}const N=128;function U(){const de=[],Ce=[];for(let Ae=0;Ae<=N;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=N;Ae++)de.push(Ce.slice(0));return de}function K(de){const Ce=[];for(let Ae=0;Ae<=de;Ae++)Ce[Ae]=0;return Ce}const ie=K(2*N),ce=K(2*N),ye=U(),Se=U(),fe=U(),$e=!1;function Te(de,Ce,Ae,Ue,j){function F(G,ee,re=" "){for(;G.length<ee;)G=re+G;return G}let H=` |   |${Ue.split("").map(G=>F(G,3)).join("|")}
`;for(let G=0;G<=Ae;G++)G===0?H+=" |":H+=`${Ce[G-1]}|`,H+=de[G].slice(0,j+1).map(ee=>F(ee.toString(),3)).join("|")+`
`;return H}function ae(de,Ce,Ae,Ue){de=de.substr(Ce),Ae=Ae.substr(Ue),console.log(Te(Se,de,de.length,Ae,Ae.length)),console.log(Te(fe,de,de.length,Ae,Ae.length)),console.log(Te(ye,de,de.length,Ae,Ae.length))}function Ne(de,Ce){if(Ce<0||Ce>=de.length)return!1;const Ae=de.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.$Rf(Ae)}}function ne(de,Ce){if(Ce<0||Ce>=de.length)return!1;switch(de.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function z(de,Ce,Ae){return Ce[de]!==Ae[de]}function x(de,Ce,Ae,Ue,j,F,H=!1){for(;Ce<Ae&&j<F;)de[Ce]===Ue[j]&&(H&&(ie[Ce]=j),Ce+=1),j+=1;return Ce===Ae}var ve;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Fe;(function(de){de.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}de.isDefault=Ce})(Fe||(e.FuzzyScore=Fe={}));class De{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Ae){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Ae}}e.$Jk=De;function we(de,Ce,Ae,Ue,j,F,H=De.default){const G=de.length>N?N:de.length,ee=Ue.length>N?N:Ue.length;if(Ae>=G||F>=ee||G-Ae>ee-F||!x(Ce,Ae,G,j,F,ee,!0))return;ge(G,ee,Ae,F,Ce,j);let re=1,Me=1,Be=Ae,He=F;const _e=[!1];for(re=1,Be=Ae;Be<G;re++,Be++){const at=ie[Be],gt=ce[Be],je=Be+1<G?ce[Be+1]:ee;for(Me=at-F+1,He=at;He<je;Me++,He++){let st=Number.MIN_SAFE_INTEGER,X=!1;He<=gt&&(st=Q(de,Ce,Be,Ae,Ue,j,He,ee,F,ye[re-1][Me-1]===0,_e));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(X=!0,Z=st+Se[re-1][Me-1]);const me=He>at,qe=me?Se[re][Me-1]+(ye[re][Me-1]>0?-5:0):0,be=He>at+1&&ye[re][Me-1]>0,ot=be?Se[re][Me-2]+(ye[re][Me-2]>0?-5:0):0;if(be&&(!me||ot>=qe)&&(!X||ot>=Z))Se[re][Me]=ot,fe[re][Me]=3,ye[re][Me]=0;else if(me&&(!X||qe>=Z))Se[re][Me]=qe,fe[re][Me]=2,ye[re][Me]=0;else if(X)Se[re][Me]=Z,fe[re][Me]=1,ye[re][Me]=ye[re-1][Me-1]+1;else throw new Error("not possible")}}if($e&&ae(de,Ae,Ue,F),!_e[0]&&!H.firstMatchCanBeWeak)return;re--,Me--;const xe=[Se[re][Me],F];let et=0,tt=0;for(;re>=1;){let at=Me;do{const gt=fe[re][at];if(gt===3)at=at-2;else if(gt===2)at=at-1;else break}while(at>=1);et>1&&Ce[Ae+re-1]===j[F+Me-1]&&!z(at+F-1,Ue,j)&&et+1>ye[re][at]&&(at=Me),at===Me?et++:et=1,tt||(tt=at),re--,Me=at-1,xe.push(Me)}ee===G&&H.boostFullMatch&&(xe[0]+=2);const it=tt-G;return xe[0]-=it,xe}function ge(de,Ce,Ae,Ue,j,F){let H=de-1,G=Ce-1;for(;H>=Ae&&G>=Ue;)j[H]===F[G]&&(ce[H]=G,H--),G--}function Q(de,Ce,Ae,Ue,j,F,H,G,ee,re,Me){if(Ce[Ae]!==F[H])return Number.MIN_SAFE_INTEGER;let Be=1,He=!1;return H===Ae-Ue?Be=de[Ae]===j[H]?7:5:z(H,j,F)&&(H===0||!z(H-1,j,F))?(Be=de[Ae]===j[H]?7:5,He=!0):Ne(F,H)&&(H===0||!Ne(F,H-1))?Be=5:(Ne(F,H-1)||ne(F,H-1))&&(Be=5,He=!0),Be>1&&Ae===Ue&&(Me[0]=!0),He||(He=z(H,j,F)||Ne(F,H-1)||ne(F,H-1)),Ae===Ue?H>ee&&(Be-=He?3:5):re?Be+=He?2:0:Be+=He?0:1,H+1===G&&(Be-=He?3:5),Be}function Y(de,Ce,Ae,Ue,j,F,H){return ue(de,Ce,Ae,Ue,j,F,!0,H)}function he(de,Ce,Ae,Ue,j,F,H){return ue(de,Ce,Ae,Ue,j,F,!1,H)}function ue(de,Ce,Ae,Ue,j,F,H,G){let ee=we(de,Ce,Ae,Ue,j,F,G);if(ee&&!H)return ee;if(de.length>=3){const re=Math.min(7,de.length-1);for(let Me=Ae+1;Me<re;Me++){const Be=Oe(de,Me);if(Be){const He=we(Be,Be.toLowerCase(),Ae,Ue,j,F,G);He&&(He[0]-=3,(!ee||He[0]>ee[0])&&(ee=He))}}}return ee}function Oe(de,Ce){if(Ce+1>=de.length)return;const Ae=de[Ce],Ue=de[Ce+1];if(Ae!==Ue)return de.slice(0,Ce)+Ue+Ae+de.slice(Ce+2)}}),define(Ie[33],Pe([1,0,13]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(M||(M={})),function(A){const O="error",R="warning",w="warn",p="info",E="ignore";function T(d){return d?I.$yf(O,d)?A.Error:I.$yf(R,d)||I.$yf(w,d)?A.Warning:I.$yf(p,d)?A.Info:A.Ignore:A.Ignore}A.fromValue=T;function D(d){switch(d){case A.Error:return O;case A.Warning:return R;case A.Info:return p;default:return E}}A.toString=D}(M||(M={})),e.default=M}),define(Ie[136],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(Ie[54],Pe([1,0,18,13]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class A{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const g=v.charCodeAt(0),r=this.b.charCodeAt(this.c);return g-r}value(){return this.b[this.c]}}e.$yi=A;class O{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,M.$sf)(v,this.b,0,v.length,this.c,this.d):(0,M.$uf)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=O;class R{constructor(v=!0,g=!0){this.f=v,this.g=g}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let g=v.length-1;g>=0;g--,this.c--){const r=this.b.charCodeAt(g);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,M.$sf)(v,this.b,0,v.length,this.d,this.e):(0,M.$uf)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=R;var w;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(w||(w={}));class p{constructor(v,g){this.f=v,this.g=g,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,M.$tf)(v,this.c.scheme);if(this.d[this.e]===2)return(0,M.$tf)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,M.$rf)(v,this.c.query);if(this.d[this.e]===5)return(0,M.$rf)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=p;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(d){d[d.Left=-1]="Left",d[d.Mid=0]="Mid",d[d.Right=1]="Right"})(T||(T={}));class D{static forUris(v=()=>!1,g=()=>!1){return new D(new p(v,g))}static forPaths(v=!1){return new D(new R(void 0,!v))}static forStrings(){return new D(new A)}static forConfigKeys(){return new D(new O)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,g){if(g){const r=g.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o,v)}else{const r=v.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o[0],o[1])}}set(v,g){const r=this.b.reset(v);let o;this.c||(this.c=new E,this.c.segment=r.value());const s=[];for(o=this.c;;){const n=r.cmp(o.segment);if(n>0)o.left||(o.left=new E,o.left.segment=r.value()),s.push([-1,o]),o=o.left;else if(n<0)o.right||(o.right=new E,o.right.segment=r.value()),s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new E,o.mid.segment=r.value()),s.push([0,o]),o=o.mid;else break}const i=o.value;o.value=g,o.key=v;for(let n=s.length-1;n>=0;n--){const c=s[n][1];c.updateHeight();const l=c.balanceFactor();if(l<-1||l>1){const t=s[n][0],f=s[n+1][0];if(t===1&&f===1)s[n][1]=c.rotateLeft();else if(t===-1&&f===-1)s[n][1]=c.rotateRight();else if(t===1&&f===-1)c.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=c.rotateLeft();else if(t===-1&&f===1)c.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=c.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const g=this.b.reset(v);let r=this.c;for(;r;){const o=g.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(g.hasNext())g.next(),r=r.mid;else break}return r}has(v){const g=this.d(v);return!(g?.value===void 0&&g?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,g){const r=this.b.reset(v),o=[];let s=this.c;for(;s;){const i=r.cmp(s.segment);if(i>0)o.push([-1,s]),s=s.left;else if(i<0)o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),o.push([0,s]),s=s.mid;else break}if(s){if(g?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:c,segment:l}=i;this.e(i.key,!1),s.key=n,s.value=c,s.segment=l}}else{const i=s.left??s.right;if(o.length>0){const[n,c]=o[o.length-1];switch(n){case-1:c.left=i;break;case 0:c.mid=i;break;case 1:c.right=i;break}}else this.c=i}for(let i=o.length-1;i>=0;i--){const n=o[i][1];n.updateHeight();const c=n.balanceFactor();if(c>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),o[i][1]=n.rotateLeft()):c<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),o[i][1]=n.rotateRight()),i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const g=this.b.reset(v);let r=this.c,o;for(;r;){const s=g.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(g.hasNext())g.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(v){return this.g(v,!1)}g(v,g){const r=this.b.reset(v);let o=this.c;for(;o;){const s=r.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):g?o.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[g,r]of this)v(r,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const g=[];return this.j(v,g),g[Symbol.iterator]()}j(v,g){v&&(v.left&&this.j(v.left,g),v.value&&g.push([v.key,v.value]),v.mid&&this.j(v.mid,g),v.right&&this.j(v.right,g))}_isBalanced(){const v=g=>{if(!g)return!0;const r=g.balanceFactor();return r<-1||r>1?!1:v(g.left)&&v(g.right)};return v(this.c)}}e.$Ci=D}),define(Ie[36],Pe([1,0,92]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=A;var M;(function(R){function w(p){return p&&typeof p=="object"&&typeof p.id=="string"}R.isThemeColor=w})(M||(e.ThemeColor=M={}));function A(R){return{id:R}}var O;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function p(i){const n=w.exec(i.id);if(!n)return p(I.$Vj.error);const[,c,l]=n,t=["codicon","codicon-"+c];return l&&t.push("codicon-modifier-"+l.substring(1)),t}R.asClassNameArray=p;function E(i){return p(i).join(" ")}R.asClassName=E;function T(i){return"."+p(i).join(".")}R.asCSSSelector=T;function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||M.isThemeColor(i.color))}R.isThemeIcon=D;const d=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(i){const n=d.exec(i);if(!n)return;const[,c]=n;return{id:c}}R.fromString=v;function g(i){return{id:i}}R.fromId=g;function r(i,n){let c=i.id;const l=c.lastIndexOf("~");return l!==-1&&(c=c.substring(0,l)),n&&(c=`${c}~${n}`),{id:c}}R.modify=r;function o(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=o;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=s})(O||(e.ThemeIcon=O={}))}),define(Ie[137],Pe([1,0,135,13,36]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=p,e.$Ok=T,e.$Pk=d,e.$Qk=v,e.$Rk=r,e.$Sk=o;const O="$(",R=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${R.source}`,"g");function p(s){return s.replace(w,(i,n)=>n?i:`\\${i}`)}const E=new RegExp(`\\\\${R.source}`,"g");function T(s){return s.replace(E,i=>`\\${i}`)}const D=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function d(s){return s.indexOf(O)===-1?s:s.replace(D,(i,n,c,l)=>c?i:n||l||"")}function v(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const g=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){g.lastIndex=0;let i="";const n=[];let c=0;for(;;){const l=g.lastIndex,t=g.exec(s),f=s.substring(l,t?.index);if(f.length>0){i+=f;for(let a=0;a<f.length;a++)n.push(c)}if(!t)break;c+=t[0].length}return{text:i,iconOffsets:n}}function o(s,i,n=!1){const{text:c,iconOffsets:l}=i;if(!l||l.length===0)return(0,I.$Ek)(s,c,n);const t=(0,M.$ff)(c," "),f=c.length-t.length,a=(0,I.$Ek)(s,t,n);if(a)for(const $ of a){const u=l[$.start+f]+f;$.start+=u,$.end+=u}return a}}),define(Ie[34],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=M;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(A){return I.test(A)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(w){for(let p=0;p<w.length;p++)w[p]=Math.floor(Math.random()*256);return w};const O=new Uint8Array(16),R=[];for(let w=0;w<256;w++)R.push(w.toString(16).padStart(2,"0"));return function(){A(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let p=0,E="";return E+=R[O[p++]],E+=R[O[p++]],E+=R[O[p++]],E+=R[O[p++]],E+="-",E+=R[O[p++]],E+=R[O[p++]],E+="-",E+=R[O[p++]],E+=R[O[p++]],E+="-",E+=R[O[p++]],E+=R[O[p++]],E+="-",E+=R[O[p++]],E+=R[O[p++]],E+=R[O[p++]],E+=R[O[p++]],E+=R[O[p++]],E+=R[O[p++]],E}}()}),define(Ie[138],Pe([1,0,18,42,34]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$St=void 0,e.$Qt=O,e.$Rt=R,e.$Tt=E;function O(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}function R(D,d,v){const g={id:(0,A.$Sg)(),name:D,uri:d,data:v};return{asString:async()=>"",asFile:()=>g,value:void 0}}class w{constructor(){this.a=new Map}get size(){let d=0;for(const v of this.a)d++;return d}has(d){return this.a.has(this.b(d))}matches(d){const v=[...this.a.keys()];return M.Iterable.some(this,([g,r])=>r.asFile())&&v.push("files"),T(p(d),v)}get(d){return this.a.get(this.b(d))?.[0]}append(d,v){const g=this.a.get(d);g?g.push(v):this.a.set(this.b(d),[v])}replace(d,v){this.a.set(this.b(d),[v])}delete(d){this.a.delete(this.b(d))}*[Symbol.iterator](){for(const[d,v]of this.a)for(const g of v)yield[d,g]}b(d){return p(d)}}e.$St=w;function p(D){return D.toLowerCase()}function E(D,d){return T(p(D),d.map(p))}function T(D,d){if(D==="*/*")return d.length>0;if(d.includes(D))return!0;const v=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[g,r,o]=v;return o==="*"?d.some(s=>s.startsWith(r+"/")):!1}e.$Ut=Object.freeze({create:D=>(0,I.$Mb)(D.map(d=>d.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Ut.split(D).filter(d=>!d.startsWith("#"))})}),define(Ie[139],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$1t=M;var I;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function M(A){let O=0,R=0,w=0,p=0;for(let E=0,T=A.length;E<T;E++){const D=A.charCodeAt(E);D===13?(O===0&&(R=E),O++,E+1<T&&A.charCodeAt(E+1)===10?(p|=2,E++):p|=3,w=E+1):D===10&&(p|=1,O===0&&(R=E),O++,w=E+1)}return O===0&&(R=A.length),[O,R,A.length-w,p]}}),define(Ie[140],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0,e.$4s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[141],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=e.IndentAction=void 0;var I;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class M{constructor(w){if(this.e=null,this.f=!1,this.open=w.open,this.close=w.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(w.notIn))for(let p=0,E=w.notIn.length;p<E;p++)switch(w.notIn[p]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(w,p){if(w.getTokenCount()===0)return!0;const E=w.findTokenIndexAtOffset(p-2),T=w.getStandardTokenType(E);return this.isOK(T)}g(w,p){for(let E=w;E<=p;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ku=M;class A{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const p of w)O(this.autoClosingPairsOpenByStart,p.open.charAt(0),p),O(this.autoClosingPairsOpenByEnd,p.open.charAt(p.open.length-1),p),O(this.autoClosingPairsCloseByStart,p.close.charAt(0),p),O(this.autoClosingPairsCloseByEnd,p.close.charAt(p.close.length-1),p),p.close.length===1&&p.open.length===1&&O(this.autoClosingPairsCloseSingleChar,p.close,p)}}e.$lu=A;function O(R,w,p){R.has(w)?R.get(w).push(p):R.set(w,[p])}}),define(Ie[142],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AC=e.NodeColor=e.$zC=void 0,e.$BC=A,e.$CC=O,e.$DC=E,e.$EC=T,e.$FC=D,e.$GC=d,e.$HC=v,e.$IC=g;class I{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$AC)return A(this.right);let o=this;for(;o.parent!==e.$AC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$AC?e.$AC:o.parent}prev(){if(this.left!==e.$AC)return O(this.left);let o=this;for(;o.parent!==e.$AC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$AC?e.$AC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$zC=I;var M;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$AC=new I(null,0),e.$AC.parent=e.$AC,e.$AC.left=e.$AC,e.$AC.right=e.$AC,e.$AC.color=0;function A(r){for(;r.left!==e.$AC;)r=r.left;return r}function O(r){for(;r.right!==e.$AC;)r=r.right;return r}function R(r){return r===e.$AC?0:r.size_left+r.piece.length+R(r.right)}function w(r){return r===e.$AC?0:r.lf_left+r.piece.lineFeedCnt+w(r.right)}function p(){e.$AC.parent=e.$AC}function E(r,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$AC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$AC?r.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function T(r,o){const s=o.left;o.left=s.right,s.right!==e.$AC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$AC?r.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function D(r,o){let s,i;if(o.left===e.$AC?(i=o,s=i.right):o.right===e.$AC?(i=o,s=i.left):(i=A(o.right),s=i.right),i===r.root){r.root=s,s.color=0,o.detach(),p(),r.root.parent=e.$AC;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===o?(s.parent=i.parent,g(r,s)):(i.parent===o?s.parent=i:s.parent=i.parent,g(r,s),i.left=o.left,i.right=o.right,i.parent=o.parent,i.color=o.color,o===r.root?r.root=i:o===o.parent.left?o.parent.left=i:o.parent.right=i,i.left!==e.$AC&&(i.left.parent=i),i.right!==e.$AC&&(i.right.parent=i),i.size_left=o.size_left,i.lf_left=o.lf_left,g(r,i)),o.detach(),s.parent.left===s){const l=R(s),t=w(s);if(l!==s.parent.size_left||t!==s.parent.lf_left){const f=l-s.parent.size_left,a=t-s.parent.lf_left;s.parent.size_left=l,s.parent.lf_left=t,v(r,s.parent,f,a)}}if(g(r,s.parent),n){p();return}let c;for(;s!==r.root&&s.color===0;)s===s.parent.left?(c=s.parent.right,c.color===1&&(c.color=0,s.parent.color=1,E(r,s.parent),c=s.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.right.color===0&&(c.left.color=0,c.color=1,T(r,c),c=s.parent.right),c.color=s.parent.color,s.parent.color=0,c.right.color=0,E(r,s.parent),s=r.root)):(c=s.parent.left,c.color===1&&(c.color=0,s.parent.color=1,T(r,s.parent),c=s.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(r,c),c=s.parent.left),c.color=s.parent.color,s.parent.color=0,c.left.color=0,T(r,s.parent),s=r.root));s.color=0,p()}function d(r,o){for(g(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,E(r,o)),o.parent.color=0,o.parent.parent.color=1,T(r,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,T(r,o)),o.parent.color=0,o.parent.parent.color=1,E(r,o.parent.parent))}r.root.color=0}function v(r,o,s,i){for(;o!==r.root&&o!==e.$AC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=i),o=o.parent}function g(r,o){let s=0,i=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,s=R(o.left)-o.size_left,i=w(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=i;o!==r.root&&(s!==0||i!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=i),o=o.parent}}}),define(Ie[93],Pe([1,0,94,30,95,142,96]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=e.$SC=e.$RC=void 0,e.$PC=T,e.$QC=D;const w=65535;function p(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class E{constructor(i,n,c,l,t){this.lineStarts=i,this.cr=n,this.lf=c,this.crlf=l,this.isBasicASCII=t}}function T(s,i=!0){const n=[0];let c=1;for(let l=0,t=s.length;l<t;l++){const f=s.charCodeAt(l);f===13?l+1<t&&s.charCodeAt(l+1)===10?(n[c++]=l+2,l++):n[c++]=l+1:f===10&&(n[c++]=l+1)}return i?p(n):n}function D(s,i){s.length=0,s[0]=0;let n=1,c=0,l=0,t=0,f=!0;for(let $=0,u=i.length;$<u;$++){const S=i.charCodeAt($);S===13?$+1<u&&i.charCodeAt($+1)===10?(t++,s[n++]=$+2,$++):(c++,s[n++]=$+1):S===10?(l++,s[n++]=$+1):f&&S!==9&&(S<32||S>126)&&(f=!1)}const a=new E(p(s),c,l,t,f);return s.length=0,a}class d{constructor(i,n,c,l,t){this.bufferIndex=i,this.start=n,this.end=c,this.lineFeedCnt=l,this.length=t}}e.$RC=d;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$SC=v;class g{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==O.$AC&&i.iterate(i.root,c=>(c!==O.$AC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartOffset<=i&&c.nodeStartOffset+c.node.piece.length>=i)return c}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<i&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=i)return c}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const c=this.b;for(let l=0;l<c.length;l++){const t=c[l];if(t.node.parent===null||t.nodeStartOffset>=i){c[l]=null,n=!0;continue}}if(n){const l=[];for(const t of c)t!==null&&l.push(t);this.b=l}}}class o{constructor(i,n,c){this.create(i,n,c)}create(i,n,c){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=O.$AC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=c;let l=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=T(i[t].buffer));const a=new d(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),l=this.S(l,a)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=w,c=n-Math.floor(n/3),l=c*2;let t="",f=0;const a=[];if(this.iterate(this.root,$=>{const u=this.R($),S=u.length;if(f<=c||f+S<l)return t+=u,f+=S,!0;const h=t.replace(/\r\n|\r|\n/g,i);return a.push(new v(h,T(h))),t=u,f=S,!0}),f>0){const $=t.replace(/\r\n|\r|\n/g,i);a.push(new v($,T($)))}this.create(a,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new g(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,l=>{if(l===O.$AC)return!0;const t=this.R(l),f=t.length,a=i.G(n),$=i.G(n+f),u=i.getValueInRange2(a,$);return n+=f,t===u})}getOffsetAt(i,n){let c=0,l=this.root;for(;l!==O.$AC;)if(l.left!==O.$AC&&l.lf_left+1>=i)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=i){c+=l.size_left;const t=this.B(l,i-l.lf_left-2);return c+=t+n-1}else i-=l.lf_left+l.piece.lineFeedCnt,c+=l.size_left+l.piece.length,l=l.right;return c}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,c=0;const l=i;for(;n!==O.$AC;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(c+=n.lf_left+t.index,t.index===0){const f=this.getOffsetAt(c+1,1),a=l-f;return new I.$tt(c+1,a+1)}return new I.$tt(c+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,c+=n.lf_left+n.piece.lineFeedCnt,n.right===O.$AC){const t=this.getOffsetAt(c+1,1),f=l-i-t;return new I.$tt(c+1,f+1)}else n=n.right;return new I.$tt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const c=this.H(i.startLineNumber,i.startColumn),l=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(c,l);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const a=i.node,$=this.a[a.piece.bufferIndex].buffer,u=this.u(a.piece.bufferIndex,a.piece.start);return $.substring(u+i.remainder,u+n.remainder)}let c=i.node;const l=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let f=l.substring(t+i.remainder,t+c.piece.length);for(c=c.next();c!==O.$AC;){const a=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);if(c===n.node){f+=a.substring($,$+n.remainder);break}else f+=a.substr($,c.piece.length);c=c.next()}return f}getLinesContent(){const i=[];let n=0,c="",l=!1;return this.iterate(this.root,t=>{if(t===O.$AC)return!0;const f=t.piece;let a=f.length;if(a===0)return!0;const $=this.a[f.bufferIndex].buffer,u=this.a[f.bufferIndex].lineStarts,S=f.start.line,h=f.end.line;let b=u[S]+f.start.column;if(l&&($.charCodeAt(b)===10&&(b++,a--),i[n++]=c,c="",l=!1,a===0))return!0;if(S===h)return!this.f&&$.charCodeAt(b+a-1)===13?(l=!0,c+=$.substr(b,a-1)):c+=$.substr(b,a),!0;c+=this.f?$.substring(b,Math.max(b,u[S+1]-this.e)):$.substring(b,u[S+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;for(let m=S+1;m<h;m++)c=this.f?$.substring(u[m],u[m+1]-this.e):$.substring(u[m],u[m+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;return!this.f&&$.charCodeAt(u[h]+f.end.column-1)===13?(l=!0,f.end.column===0?n--:c=$.substr(u[h],f.end.column-1)):c=$.substr(u[h],f.end.column),!0}),l&&(i[n++]=c,c=""),i[n++]=c,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const c=this.a[n.piece.bufferIndex],l=this.u(n.piece.bufferIndex,n.piece.start);return c.buffer.charCodeAt(l)}else{const n=this.a[i.node.piece.bufferIndex],l=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(l)}}getLineCharCode(i,n){const c=this.H(i,n+1);return this.l(c)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,c,l,t,f,a,$,u,S,h){const b=this.a[i.piece.bufferIndex],m=this.u(i.piece.bufferIndex,i.piece.start),k=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,f);let C;const P={line:0,column:0};let W,V;n._wordSeparators?(W=b.buffer.substring(k,y),V=q=>q+k,n.reset(0)):(W=b.buffer,V=q=>q,n.reset(k));do if(C=n.next(W),C){if(V(C.index)>=y)return S;this.s(i,V(C.index)-m,P);const q=this.t(i.piece.bufferIndex,t,P),N=P.line===t.line?P.column-t.column+l:P.column+1,U=N+C[0].length;if(h[S++]=(0,R.$LC)(new M.$ut(c+q,N,c+q,U),C,$),V(C.index)+C[0].length>=y||S>=u)return S}while(C);return S}findMatchesLineByLine(i,n,c,l){const t=[];let f=0;const a=new R.$OC(n.wordSeparators,n.regex);let $=this.H(i.startLineNumber,i.startColumn);if($===null)return[];const u=this.H(i.endLineNumber,i.endColumn);if(u===null)return[];let S=this.s($.node,$.remainder);const h=this.s(u.node,u.remainder);if($.node===u.node)return this.findMatchesInNode($.node,a,i.startLineNumber,i.startColumn,S,h,n,c,l,f,t),t;let b=i.startLineNumber,m=$.node;for(;m!==u.node;){const y=this.t(m.piece.bufferIndex,S,m.piece.end);if(y>=1){const P=this.a[m.piece.bufferIndex].lineStarts,W=this.u(m.piece.bufferIndex,m.piece.start),V=P[S.line+y],q=b===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(m,a,b,q,S,this.s(m,V-W),n,c,l,f,t),f>=l)return t;b+=y}const C=b===i.startLineNumber?i.startColumn-1:0;if(b===i.endLineNumber){const P=this.getLineContent(b).substring(C,i.endColumn-1);return f=this.n(n,a,P,i.endLineNumber,C,f,t,c,l),t}if(f=this.n(n,a,this.getLineContent(b).substr(C),b,C,f,t,c,l),f>=l)return t;b++,$=this.H(b,1),m=$.node,S=this.s($.node,$.remainder)}if(b===i.endLineNumber){const y=b===i.startLineNumber?i.startColumn-1:0,C=this.getLineContent(b).substring(y,i.endColumn-1);return f=this.n(n,a,C,i.endLineNumber,y,f,t,c,l),t}const k=b===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(u.node,a,b,k,S,h,n,c,l,f,t),t}n(i,n,c,l,t,f,a,$,u){const S=i.wordSeparators;if(!$&&i.simpleSearch){const b=i.simpleSearch,m=b.length,k=c.length;let y=-m;for(;(y=c.indexOf(b,y+m))!==-1;)if((!S||(0,R.$NC)(S,c,k,y,m))&&(a[f++]=new A.$Fv(new M.$ut(l,y+1+t,l,y+1+m+t),null),f>=u))return f;return f}let h;n.reset(0);do if(h=n.next(c),h&&(a[f++]=(0,R.$LC)(new M.$ut(l,h.index+1+t,l,h.index+1+h[0].length+t),h,$),f>=u))return f;while(h);return f}insert(i,n,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==O.$AC){const{node:l,remainder:t,nodeStartOffset:f}=this.G(i),a=l.piece,$=a.bufferIndex,u=this.s(l,t);if(l.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&f+a.length===i&&n.length<w){this.F(l,n),this.y();return}if(f===i)this.o(n,l),this.h.validate(i);else if(f+l.piece.length>i){const S=[];let h=new d(a.bufferIndex,u,a.end,this.t(a.bufferIndex,u,a.end),this.u($,a.end)-this.u($,u));if(this.K()&&this.M(n)&&this.I(l,t)===10){const y={line:h.start.line+1,column:0};h=new d(h.bufferIndex,y,h.end,this.t(h.bufferIndex,y,h.end),h.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(l,t-1)===13){const y=this.s(l,t-1);this.C(l,y),n="\r"+n,l.piece.length===0&&S.push(l)}else this.C(l,u);else this.C(l,u);const b=this.w(n);h.length>0&&this.S(l,h);let m=l;for(let k=0;k<b.length;k++)m=this.S(m,b[k]);this.v(S)}else this.q(n,l)}else{const l=this.w(n);let t=this.T(null,l[0]);for(let f=1;f<l.length;f++)t=this.S(t,l[f])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===O.$AC)return;const c=this.G(i),l=this.G(i+n),t=c.node,f=l.node;if(t===f){const b=this.s(t,c.remainder),m=this.s(t,l.remainder);if(c.nodeStartOffset===i){if(n===t.piece.length){const k=t.next();(0,O.$FC)(this,t),this.N(k),this.y();return}this.D(t,m),this.h.validate(i),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===i+n){this.C(t,b),this.O(t),this.y();return}this.E(t,b,m),this.y();return}const a=[],$=this.s(t,c.remainder);this.C(t,$),this.h.validate(i),t.piece.length===0&&a.push(t);const u=this.s(f,l.remainder);this.D(f,u),f.piece.length===0&&a.push(f);const S=t.next();for(let b=S;b!==O.$AC&&b!==f;b=b.next())a.push(b);const h=t.piece.length===0?t.prev():t;this.v(a),this.O(h),this.y()}o(i,n){const c=[];if(this.K()&&this.M(i)&&this.L(n)){const f=n.piece,a={line:f.start.line+1,column:0},$=new d(f.bufferIndex,a,f.end,this.t(f.bufferIndex,a,f.end),f.length-1);n.piece=$,i+=`
`,(0,O.$HC)(this,n,-1,-1),n.piece.length===0&&c.push(n)}const l=this.w(i);let t=this.T(n,l[l.length-1]);for(let f=l.length-2;f>=0;f--)t=this.T(t,l[f]);this.N(t),this.v(c)}q(i,n){this.Q(i,n)&&(i+=`
`);const c=this.w(i),l=this.S(n,c[0]);let t=l;for(let f=1;f<c.length;f++)t=this.S(t,c[f]);this.N(l)}s(i,n,c){const l=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,$=f[l.start.line]+l.start.column+n;let u=l.start.line,S=l.end.line,h=0,b=0,m=0;for(;u<=S&&(h=u+(S-u)/2|0,m=f[h],h!==S);)if(b=f[h+1],$<m)S=h-1;else if($>=b)u=h+1;else break;return c?(c.line=h,c.column=$-m,null):{line:h,column:$-m}}t(i,n,c){if(c.column===0)return c.line-n.line;const l=this.a[i].lineStarts;if(c.line===l.length-1)return c.line-n.line;const t=l[c.line+1],f=l[c.line]+c.column;if(t>f+1)return c.line-n.line;const a=f-1;return this.a[i].buffer.charCodeAt(a)===13?c.line-n.line+1:c.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,O.$FC)(this,i[n])}w(i){if(i.length>w){const S=[];for(;i.length>w;){const b=i.charCodeAt(w-1);let m;b===13||b>=55296&&b<=56319?(m=i.substring(0,w-1),i=i.substring(w-1)):(m=i.substring(0,w),i=i.substring(w));const k=T(m);S.push(new d(this.a.length,{line:0,column:0},{line:k.length-1,column:m.length-k[k.length-1]},k.length-1,m.length)),this.a.push(new v(m,k))}const h=T(i);return S.push(new d(this.a.length,{line:0,column:0},{line:h.length-1,column:i.length-h[h.length-1]},h.length-1,i.length)),this.a.push(new v(i,h)),S}let n=this.a[0].buffer.length;const c=T(i,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let S=0;S<c.length;S++)c[S]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let S=0;S<c.length;S++)c[S]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[f],$={line:f,column:a},u=new d(0,l,$,this.t(0,l,$),t-n);return this.g=$,[u]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let c=this.root,l="";const t=this.h.get2(i);if(t){c=t.node;const f=this.B(c,i-t.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===i)l=a.substring($+f,$+c.piece.length);else{const u=this.B(c,i-t.nodeStartLineNumber);return a.substring($+f,$+u-n)}}else{let f=0;const a=i;for(;c!==O.$AC;)if(c.left!==O.$AC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const $=this.B(c,i-c.lf_left-2),u=this.B(c,i-c.lf_left-1),S=this.a[c.piece.bufferIndex].buffer,h=this.u(c.piece.bufferIndex,c.piece.start);return f+=c.size_left,this.h.set({node:c,nodeStartOffset:f,nodeStartLineNumber:a-(i-1-c.lf_left)}),S.substring(h+$,h+u-n)}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const $=this.B(c,i-c.lf_left-2),u=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);l=u.substring(S+$,S+c.piece.length);break}else i-=c.lf_left+c.piece.lineFeedCnt,f+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==O.$AC;){const f=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),$=this.u(c.piece.bufferIndex,c.piece.start);return l+=f.substring($,$+a-n),l}else{const a=this.u(c.piece.bufferIndex,c.piece.start);l+=f.substr(a,c.piece.length)}c=c.next()}return l}y(){let i=this.root,n=1,c=0;for(;i!==O.$AC;)n+=i.lf_left+i.piece.lineFeedCnt,c+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=c,this.h.validate(this.c)}A(i,n){const c=i.piece,l=this.s(i,n),t=l.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===n){const f=this.t(i.piece.bufferIndex,c.start,l);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:l.column}}B(i,n){if(n<0)return 0;const c=i.piece,l=this.a[c.bufferIndex].lineStarts,t=c.start.line+n+1;return t>c.end.line?l[c.end.line]+c.end.column-l[c.start.line]-c.start.column:l[t]-l[c.start.line]-c.start.column}C(i,n){const c=i.piece,l=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),f=n,a=this.u(c.bufferIndex,f),$=this.t(c.bufferIndex,c.start,f),u=$-l,S=a-t,h=c.length+S;i.piece=new d(c.bufferIndex,c.start,f,$,h),(0,O.$HC)(this,i,S,u)}D(i,n){const c=i.piece,l=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),f=n,a=this.t(c.bufferIndex,f,c.end),$=this.u(c.bufferIndex,f),u=a-l,S=t-$,h=c.length+S;i.piece=new d(c.bufferIndex,f,c.end,a,h),(0,O.$HC)(this,i,S,u)}E(i,n,c){const l=i.piece,t=l.start,f=l.end,a=l.length,$=l.lineFeedCnt,u=n,S=this.t(l.bufferIndex,l.start,u),h=this.u(l.bufferIndex,n)-this.u(l.bufferIndex,t);i.piece=new d(l.bufferIndex,l.start,u,S,h),(0,O.$HC)(this,i,h-a,S-$);const b=new d(l.bufferIndex,c,f,this.t(l.bufferIndex,c,f),this.u(l.bufferIndex,f)-this.u(l.bufferIndex,c)),m=this.S(i,b);this.N(m)}F(i,n){this.Q(n,i)&&(n+=`
`);const c=this.K()&&this.L(n)&&this.M(i),l=this.a[0].buffer.length;this.a[0].buffer+=n;const t=T(n,!1);for(let m=0;m<t.length;m++)t[m]+=l;if(c){const m=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-m}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[f],$={line:f,column:a},u=i.piece.length+n.length,S=i.piece.lineFeedCnt,h=this.t(0,i.piece.start,$),b=h-S;i.piece=new d(i.piece.bufferIndex,i.piece.start,$,h,u),this.g=$,(0,O.$HC)(this,i,n.length,b)}G(i){let n=this.root;const c=this.h.get(i);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:i-c.nodeStartOffset};let l=0;for(;n!==O.$AC;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){l+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:l};return this.h.set(t),t}else i-=n.size_left+n.piece.length,l+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let c=this.root,l=0;for(;c!==O.$AC;)if(c.left!==O.$AC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const t=this.B(c,i-c.lf_left-2),f=this.B(c,i-c.lf_left-1);return l+=c.size_left,{node:c,remainder:Math.min(t+n-1,f),nodeStartOffset:l}}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const t=this.B(c,i-c.lf_left-2);if(t+n-1<=c.piece.length)return{node:c,remainder:t+n-1,nodeStartOffset:l};n-=c.piece.length-t;break}else i-=c.lf_left+c.piece.lineFeedCnt,l+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==O.$AC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),f=this.J(c);return{node:c,remainder:Math.min(n-1,t),nodeStartOffset:f}}else if(c.piece.length>=n-1){const t=this.J(c);return{node:c,remainder:n-1,nodeStartOffset:t}}else n-=c.piece.length;c=c.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const c=this.a[i.piece.bufferIndex],l=this.u(i.piece.bufferIndex,i.piece.start)+n;return c.buffer.charCodeAt(l)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===O.$AC||i.piece.lineFeedCnt===0)return!1;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,l=n.start.line,t=c[l]+n.start.column;return l===c.length-1||c[l+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===O.$AC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const c=[],l=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:l[i.piece.end.line]-l[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,a=i.piece.lineFeedCnt-1;i.piece=new d(i.piece.bufferIndex,i.piece.start,t,a,f),(0,O.$HC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const $={line:n.piece.start.line+1,column:0},u=n.piece.length-1,S=this.t(n.piece.bufferIndex,$,n.piece.end);n.piece=new d(n.piece.bufferIndex,$,n.piece.end,S,u),(0,O.$HC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const h=this.w(`\r
`);this.S(i,h[0]);for(let b=0;b<c.length;b++)(0,O.$FC)(this,c[b])}Q(i,n){if(this.K()&&this.M(i)){const c=n.next();if(this.L(c)){if(i+=`
`,c.piece.length===1)(0,O.$FC)(this,c);else{const l=c.piece,t={line:l.start.line+1,column:0},f=l.length-1,a=this.t(l.bufferIndex,t,l.end);c.piece=new d(l.bufferIndex,t,l.end,a,f),(0,O.$HC)(this,c,-1,-1)}return!0}}return!1}iterate(i,n){if(i===O.$AC)return n(O.$AC);const c=this.iterate(i.left,n);return c&&n(i)&&this.iterate(i.right,n)}R(i){if(i===O.$AC)return"";const n=this.a[i.piece.bufferIndex],c=i.piece,l=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return n.buffer.substring(l,t)}getPieceContent(i){const n=this.a[i.bufferIndex],c=this.u(i.bufferIndex,i.start),l=this.u(i.bufferIndex,i.end);return n.buffer.substring(c,l)}S(i,n){const c=new O.$zC(n,1);if(c.left=O.$AC,c.right=O.$AC,c.parent=O.$AC,c.size_left=0,c.lf_left=0,this.root===O.$AC)this.root=c,c.color=0;else if(i.right===O.$AC)i.right=c,c.parent=i;else{const t=(0,O.$BC)(i.right);t.left=c,c.parent=t}return(0,O.$GC)(this,c),c}T(i,n){const c=new O.$zC(n,1);if(c.left=O.$AC,c.right=O.$AC,c.parent=O.$AC,c.size_left=0,c.lf_left=0,this.root===O.$AC)this.root=c,c.color=0;else if(i.left===O.$AC)i.left=c,c.parent=i;else{const l=(0,O.$CC)(i.left);l.right=c,c.parent=l}return(0,O.$GC)(this,c),c}U(i){let n="";return this.iterate(i,c=>(n+=this.R(c),!0)),n}}e.$TC=o}),define(Ie[143],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r$=e.$q$=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const R=this.a.get(O);return this.a.delete(O),R}}addDragOperationTransfer(O,R){this.a.set(O,R)}}e.$q$=I;class M{constructor(O){this.identifier=O}}e.$r$=M}),define(Ie[144],Pe([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(Ie[145],Pe([1,0,5,6,144]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=T;class O extends M.$Vc{constructor(d,v="",g="",r=!0,o){super(),this.h=this.B(new I.$ee),this.onDidChange=this.h.event,this.w=!0,this.j=d,this.m=v,this.u=g,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(d){this.D(d)}D(d){this.m!==d&&(this.m=d,this.h.fire({label:d}))}get tooltip(){return this.n||""}set tooltip(d){this.F(d)}F(d){this.n!==d&&(this.n=d,this.h.fire({tooltip:d}))}get class(){return this.u}set class(d){this.G(d)}G(d){this.u!==d&&(this.u=d,this.h.fire({class:d}))}get enabled(){return this.w}set enabled(d){this.H(d)}H(d){this.w!==d&&(this.w=d,this.h.fire({enabled:d}))}get checked(){return this.z}set checked(d){this.I(d)}I(d){this.z!==d&&(this.z=d,this.h.fire({checked:d}))}async run(d,v){this.C&&await this.C(d)}}e.$bj=O;class R extends M.$Vc{constructor(){super(...arguments),this.f=this.B(new I.$ee),this.onWillRun=this.f.event,this.m=this.B(new I.$ee),this.onDidRun=this.m.event}async run(d,v){if(!d.enabled)return;this.f.fire({action:d});let g;try{await this.u(d,v)}catch(r){g=r}this.m.fire({action:d,error:g})}async u(d,v){await d.run(v)}}e.$cj=R;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...d){let v=[];for(const g of d)g.length&&(v.length?v=[...v,new w,...g]:v=g);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$dj=w;class p{get actions(){return this.a}constructor(d,v,g,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=d,this.label=v,this.class=r,this.a=g}async run(){}}e.$ej=p;class E extends O{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,A.localize(0,null),void 0,!1)}}e.$fj=E;function T(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...d)=>D.run(...d),tooltip:D.label}}}),define(Ie[146],Pe([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(Ie[147],Pe([1,0,146]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=E,e.$3m=T,e.$4m=D;const M=60,A=M*60,O=A*24,R=O*7,w=O*30,p=O*365;function E(d,v,g,r){typeof d!="number"&&(d=d.getTime());const o=Math.round((new Date().getTime()-d)/1e3);if(o<-30)return(0,I.localize)(0,null,E(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,I.localize)(1,null);let s;return o<M?(s=o,v?s===1?g?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):g?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?g?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):g?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):o<A?(s=Math.floor(o/M),v?s===1?g?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):g?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?g?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):g?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):o<O?(s=Math.floor(o/A),v?s===1?g?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):g?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?g?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):g?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):o<R?(s=Math.floor(o/O),v?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):o<w?(s=Math.floor(o/R),v?s===1?g?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):g?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?g?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):g?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):o<p?(s=Math.floor(o/w),v?s===1?g?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):g?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?g?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):g?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(o/p),v?s===1?g?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):g?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?g?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):g?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}function T(d,v){const g=Math.abs(d/1e3);return g<1?v?(0,I.localize)(54,null,d):(0,I.localize)(55,null,d):g<M?v?(0,I.localize)(56,null,Math.round(d)/1e3):(0,I.localize)(57,null,Math.round(d)/1e3):g<A?v?(0,I.localize)(58,null,Math.round(d/(1e3*M))):(0,I.localize)(59,null,Math.round(d/(1e3*M))):g<O?v?(0,I.localize)(60,null,Math.round(d/(1e3*A))):(0,I.localize)(61,null,Math.round(d/(1e3*A))):(0,I.localize)(62,null,Math.round(d/(1e3*O)))}function D(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ie[148],Pe([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(Ie[44],Pe([1,0,18,15,148]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=p,e.$ij=E,e.$jj=T;function O(D,d){return d&&(D.stack||D.stacktrace)?A.localize(0,null,w(D),R(D.stack)||R(D.stacktrace)):w(D)}function R(D){return Array.isArray(D)?D.join(`
`):D}function w(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?A.localize(1,null,D.message):D.message||A.localize(2,null)}function p(D=null,d=!1){if(!D)return A.localize(3,null);if(Array.isArray(D)){const v=I.$Hb(D),g=p(v[0],d);return v.length>1?A.localize(4,null,g,v.length):g}if(M.$9f(D))return D;if(D.detail){const v=D.detail;if(v.error)return O(v.error,d);if(v.exception)return O(v.exception,d)}return D.stack?O(D,d):D.message?D.message:A.localize(5,null)}function E(D){const d=D;return d instanceof Error&&Array.isArray(d.actions)}function T(D,d){let v;return typeof D=="string"?v=new Error(D):v=D,v.actions=d,v}}),define(Ie[149],Pe([1,0,43,19]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=w,e.$hr=p,e.$ir=E,e.$jr=T,e.$kr=D,e.$lr=d,e.$mr=v,e.$nr=g,e.$or=r,e.$pr=o,e.$qr=u,e.$rr=S,e.$sr=h;const A=new I.$V(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),O=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(b,m,k=!1){const y=b||"",C=m||"",P=A.value.collator.compare(y,C);return A.value.collatorIsNumeric&&P===0&&y!==C?y<C?-1:1:P}function p(b,m){const k=O.value.collator;return b=b||"",m=m||"",c(k,b,m)}function E(b,m){const k=O.value.collator;return b=b||"",m=m||"",a(b,m)||c(k,b,m)}function T(b,m){const k=O.value.collator;return b=b||"",m=m||"",f(b,m)||c(k,b,m)}function D(b,m){return b=b||"",m=m||"",b===m?0:b<m?-1:1}function d(b,m){const[k,y]=i(b),[C,P]=i(m);let W=A.value.collator.compare(y,P);if(W===0){if(A.value.collatorIsNumeric&&y!==P)return y<P?-1:1;if(W=A.value.collator.compare(k,C),A.value.collatorIsNumeric&&W===0&&k!==C)return k<C?-1:1}return W}function v(b,m){b=b||"",m=m||"";const k=n(b),y=n(m),C=O.value.collator,P=R.value.collator;return c(P,k,y)||c(C,b,m)}function g(b,m){b=b||"",m=m||"";const k=n(b),y=n(m),C=O.value.collator,P=R.value.collator;return c(P,k,y)||a(b,m)||c(C,b,m)}function r(b,m){b=b||"",m=m||"";const k=n(b),y=n(m),C=O.value.collator,P=R.value.collator;return c(P,k,y)||f(b,m)||c(C,b,m)}function o(b,m){b=b||"",m=m||"";const k=n(b).toLowerCase(),y=n(m).toLowerCase();return k!==y?k<y?-1:1:b!==m?b<m?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function i(b,m=!1){const k=b?s.exec(b):[];let y=[k&&k[1]||"",k&&k[3]||""];return m&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function n(b){const m=b?s.exec(b):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function c(b,m,k){const y=b.compare(m,k);return y!==0?y:m.length!==k.length?m.length<k.length?-1:1:0}function l(b){const m=b.charAt(0);return m.toLocaleUpperCase()!==m}function t(b){const m=b.charAt(0);return m.toLocaleLowerCase()!==m}function f(b,m){return l(b)&&t(m)?-1:t(b)&&l(m)?1:0}function a(b,m){return t(b)&&l(m)?-1:l(b)&&t(m)?1:0}function $(b,m,k=!1){return k||(b=b&&b.toLowerCase(),m=m&&m.toLowerCase()),b===m?0:b<m?-1:1}function u(b,m,k=!1){const y=b.split(M.sep),C=m.split(M.sep),P=y.length-1,W=C.length-1;let V,q;for(let N=0;;N++){if(V=P===N,q=W===N,V&&q)return w(y[N],C[N],k);if(V)return-1;if(q)return 1;const U=$(y[N],C[N],k);if(U!==0)return U}}function S(b,m,k){const y=b.toLowerCase(),C=m.toLowerCase(),P=h(b,m,k);if(P)return P;const W=y.endsWith(k),V=C.endsWith(k);if(W!==V)return W?-1:1;const q=w(y,C);return q!==0?q:y.localeCompare(C)}function h(b,m,k){const y=b.toLowerCase(),C=m.toLowerCase(),P=y.startsWith(k),W=C.startsWith(k);if(P!==W)return P?-1:1;if(P&&W){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(Ie[48],Pe([1,0,19,22,13,15]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=R,e.$pg=w,e.$qg=p,e.$rg=E,e.$sg=T,e.$tg=g,e.$ug=r,e.$vg=o,e.$wg=s,e.$xg=i,e.$yg=n,e.$zg=c,e.$Ag=l,e.$Bg=t,e.$Cg=f,e.$Dg=a,e.$Eg=S;function R(h){return h===47||h===92}function w(h){return h.replace(/[\\/]/g,I.$hc.sep)}function p(h){return h.indexOf("/")===-1&&(h=w(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function E(h,b=I.$hc.sep){if(!h)return"";const m=h.length,k=h.charCodeAt(0);if(R(k)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let C=3;const P=C;for(;C<m&&!R(h.charCodeAt(C));C++);if(P!==C&&!R(h.charCodeAt(C+1))){for(C+=1;C<m;C++)if(R(h.charCodeAt(C)))return h.slice(0,C+1).replace(/[\\/]/g,b)}}return b}else if(s(k)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+b:h.slice(0,2);let y=h.indexOf("://");if(y!==-1){for(y+=3;y<m;y++)if(R(h.charCodeAt(y)))return h.slice(0,y+1)}return""}function T(h){if(!M.$i||!h||h.length<5)return!1;let b=h.charCodeAt(0);if(b!==92||(b=h.charCodeAt(1),b!==92))return!1;let m=2;const k=m;for(;m<h.length&&(b=h.charCodeAt(m),b!==92);m++);return!(k===m||(b=h.charCodeAt(m+1),isNaN(b)||b===92))}const D=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(h,b=M.$i){const m=b?D:d;return!(!h||h.length===0||/^\s+$/.test(h)||(m.lastIndex=0,m.test(h))||b&&v.test(h)||h==="."||h===".."||b&&h[h.length-1]==="."||b&&h.length!==h.trim().length||h.length>255)}function r(h,b,m){const k=h===b;return!m||k?k:!h||!b?!1:(0,A.$yf)(h,b)}function o(h,b,m,k=I.sep){if(h===b)return!0;if(!h||!b||b.length>h.length)return!1;if(m){if(!(0,A.$zf)(h,b))return!1;if(b.length===h.length)return!0;let C=b.length;return b.charAt(b.length-1)===k&&C--,h.charAt(C)===k}return b.charAt(b.length-1)!==k&&(b+=k),h.indexOf(b)===0}function s(h){return h>=65&&h<=90||h>=97&&h<=122}function i(h,b){return M.$i&&h.endsWith(":")&&(h+=I.sep),(0,I.$jc)(h)||(h=(0,I.$kc)(b,h)),h=(0,I.$ic)(h),n(h)}function n(h){return M.$i?(h=(0,A.$gf)(h,I.sep),h.endsWith(":")&&(h+=I.sep)):(h=(0,A.$gf)(h,I.sep),h||(h=I.sep)),h}function c(h){const b=(0,I.$ic)(h);return M.$i?h.length>3?!1:l(b)&&(h.length===2||b.charCodeAt(2)===92):b===I.$hc.sep}function l(h,b=M.$i){return b?s(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}function t(h,b=M.$i){return l(h,b)?h[0]:void 0}function f(h,b,m){return b.length>h.length?-1:h===b?0:(m&&(h=h.toLowerCase(),b=b.toLowerCase()),h.indexOf(b))}function a(h){const b=h.split(":");let m,k,y;for(const C of b){const P=Number(C);(0,O.$ag)(P)?k===void 0?k=P:y===void 0&&(y=P):m=m?[m,C].join(":"):C}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:k!==void 0?k:void 0,column:y!==void 0?y:k!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(h,b,m=8){let k="";for(let C=0;C<m;C++){let P;C===0&&M.$i&&!b&&(m===3||m===4)?P=u:P=$,k+=P.charAt(Math.floor(Math.random()*P.length))}let y;return b?y=`${b}-${k}`:y=k,h?(0,I.$kc)(h,y):y}}),define(Ie[70],Pe([1,0,19]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Rs=O,e.$Ss=R,e.$Ts=w,e.$Us=E,e.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(T){const D=(0,I.$pc)(T),d=M[D.toLowerCase()];return d!==void 0?d:R(T)}function R(T){const D=(0,I.$pc)(T);return A[D.toLowerCase()]}function w(T){for(const D in A)if(A[D]===T)return D}const p=/^(.+)\/(.+?)(;.+)?$/;function E(T,D){const d=p.exec(T);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:D?void 0:T}}),define(Ie[49],Pe([1,0,21,2]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=A,e.$5h=O,e.$6h=w;function A(p){return JSON.stringify(p,R)}function O(p){let E=JSON.parse(p);return E=w(E),E}function R(p,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function w(p,E=0){if(!p||E>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return M.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof I.$Ge||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let T=0;T<p.length;++T)p[T]=w(p[T],E+1);else for(const T in p)Object.hasOwnProperty.call(p,T)&&(p[T]=w(p[T],E+1))}return p}}),define(Ie[16],Pe([1,0,14,22,13,2,19]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=p,e.$Gg=E,e.$Kg=D;var w;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatCodeBlock="vscode-chat-code-block",g.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm",g.commentsInput="comment",g.codeSetting="code-setting"})(w||(e.Schemas=w={}));function p(g,r){return O.URI.isUri(g)?(0,A.$yf)(g.scheme,r):(0,A.$zf)(g,r+":")}function E(g,...r){return r.some(o=>p(g,o))}e.$Hg="vscode-tkn",e.$Ig="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=D(r,o)}getServerRootPath(){return this.f}get g(){return R.$hc.join(this.f,w.vscodeRemoteResource)}set(r,o,s){this.a[r]=o,this.b[r]=s}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(l){return I.$1(l),r}const o=r.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const i=this.b[o],n=this.c[o];let c=`path=${encodeURIComponent(r.path)}`;return typeof n=="string"&&(c+=`&${e.$Ig}=${encodeURIComponent(n)}`),O.URI.from({scheme:M.$o?this.d:w.vscodeRemoteResource,authority:`${s}:${i}`,path:this.g,query:c})}}e.$Jg=new T;function D(g,r){return R.$hc.join(r??"/",`${g.quality??"oss"}-${g.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class d{static{this.a=e.$Pg}asBrowserUri(r){const o=this.b(r,le);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===w.vscodeRemote?e.$Jg.rewrite(r):r.scheme===w.file&&(M.$m||M.$q===`${w.vscodeFileResource}://${d.a}`)?r.with({scheme:w.vscodeFileResource,authority:r.authority||d.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,le);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===w.vscodeFileResource?r.with({scheme:w.file,authority:r.authority!==d.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return O.URI.isUri(r)?r:O.URI.parse(o.toUrl(r))}}e.$Qg=new d;var v;(function(g){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function s(n){let c;typeof n=="string"?c=new URL(n).searchParams:n instanceof URL?c=n.searchParams:O.URI.isUri(n)&&(c=new URL(n.toString(!0)).searchParams);const l=c?.get(o);if(l)return r.get(l)}g.getHeadersFromQuery=s;function i(n,c,l){if(!globalThis.crossOriginIsolated)return;const t=c&&l?"3":l?"2":"1";n instanceof URLSearchParams?n.set(o,t):n[o]=t}g.addSearchParam=i})(v||(e.COI=v={}))}),define(Ie[23],Pe([1,0,48,16,19,22,13,2]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=p,e.$gh=T,e.$hh=d;function p(v){return(0,w.$xc)(v,!0)}class E{constructor(g){this.a=g}compare(g,r,o=!1){return g===r?0:(0,R.$rf)(this.getComparisonKey(g,o),this.getComparisonKey(r,o))}isEqual(g,r,o=!1){return g===r?!0:!g||!r?!1:this.getComparisonKey(g,o)===this.getComparisonKey(r,o)}getComparisonKey(g,r=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,r,o=!1){if(g.scheme===r.scheme){if(g.scheme===M.Schemas.file)return I.$vg(p(g),p(r),this.a(g))&&g.query===r.query&&(o||g.fragment===r.fragment);if((0,e.$ch)(g.authority,r.authority))return I.$vg(g.path,r.path,this.a(g),"/")&&g.query===r.query&&(o||g.fragment===r.fragment)}return!1}joinPath(g,...r){return w.URI.joinPath(g,...r)}basenameOrAuthority(g){return(0,e.$7g)(g)||g.authority}basename(g){return A.$hc.basename(g.path)}extname(g){return A.$hc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let r;return g.scheme===M.Schemas.file?r=w.URI.file(A.$nc(p(g))).path:(r=A.$hc.dirname(g.path),g.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),r="/")),g.with({path:r})}normalizePath(g){if(!g.path.length)return g;let r;return g.scheme===M.Schemas.file?r=w.URI.file(A.$ic(p(g))).path:r=A.$hc.normalize(g.path),g.with({path:r})}relativePath(g,r){if(g.scheme!==r.scheme||!(0,e.$ch)(g.authority,r.authority))return;if(g.scheme===M.Schemas.file){const i=A.$mc(p(g),p(r));return O.$i?I.$pg(i):i}let o=g.path||"/";const s=r.path||"/";if(this.a(g)){let i=0;for(const n=Math.min(o.length,s.length);i<n&&!(o.charCodeAt(i)!==s.charCodeAt(i)&&o.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);o=s.substr(0,i)+o.substr(i)}return A.$hc.relative(o,s)}resolvePath(g,r){if(g.scheme===M.Schemas.file){const o=w.URI.file(A.$lc(p(g),r));return g.with({authority:o.authority,path:o.path})}return r=I.$qg(r),g.with({path:A.$hc.resolve(g.path,r)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,r){return g===r||g!==void 0&&r!==void 0&&(0,R.$yf)(g,r)}hasTrailingPathSeparator(g,r=A.sep){if(g.scheme===M.Schemas.file){const o=p(g);return o.length>I.$rg(o).length&&o[o.length-1]===r}else{const o=g.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,r=A.sep){return(0,e.$dh)(g,r)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,r=A.sep){let o=!1;if(g.scheme===M.Schemas.file){const s=p(g);o=s!==void 0&&s.length===I.$rg(s).length&&s[s.length-1]===r}else{r="/";const s=g.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$dh)(g,r)?g.with({path:g.path+"/"}):g}}e.$Yg=E,e.$Zg=new E(()=>!1),e.$1g=new E(v=>v.scheme===M.Schemas.file?!O.$k:!0),e.$2g=new E(v=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function T(v,g){const r=[];for(let o=0;o<v.length;o++){const s=g(v[o]);v.some((i,n)=>n===o?!1:(0,e.$4g)(s,g(i)))||r.push(v[o])}return r}var D;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function g(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(n=>{const[c,l]=n.split(":");c&&l&&o.set(c,l)});const i=r.path.substring(0,r.path.indexOf(";"));return i&&o.set(v.META_DATA_MIME,i),o}v.parseMetaData=g})(D||(e.DataUri=D={}));function d(v,g,r){if(g){let o=v.path;return o&&o[0]!==A.$hc.sep&&(o=A.$hc.sep+o),v.with({scheme:r,authority:g,path:o})}return v.with({scheme:r})}}),define(Ie[11],Pe([1,0,24,14,5,6,23,22,136,43]),function(le,e,I,M,A,O,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=T,e.$jh=D,e.$kh=d,e.$lh=v,e.$mh=g,e.$nh=r,e.$oh=o,e.$ph=s,e.$xh=S,e.$yh=h,e.$zh=b,e.$Ah=m,e.$Bh=k,e.$Qh=Se,e.$Yh=De;function T(ge){return!!ge&&typeof ge.then=="function"}function D(ge){const Q=new I.$pe,Y=ge(Q.token),he=new Promise((ue,Oe)=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Oe(new M.$5)});Promise.resolve(Y).then(Ce=>{de.dispose(),Q.dispose(),ue(Ce)},Ce=>{de.dispose(),Q.dispose(),Oe(Ce)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ue,Oe){return he.then(ue,Oe)}catch(ue){return this.then(void 0,ue)}finally(ue){return he.finally(ue)}}}function d(ge,Q,Y){return new Promise((he,ue)=>{const Oe=Q.onCancellationRequested(()=>{Oe.dispose(),he(Y)});ge.then(he,ue).finally(()=>Oe.dispose())})}function v(ge,Q){return new Promise((Y,he)=>{const ue=Q.onCancellationRequested(()=>{ue.dispose(),he(new M.$5)});ge.then(Y,he).finally(()=>ue.dispose())})}async function g(ge){let Q=-1;const Y=ge.map((he,ue)=>he.then(Oe=>(Q=ue,Oe)));try{return await Promise.race(Y)}finally{ge.forEach((he,ue)=>{ue!==Q&&he.cancel()})}}function r(ge,Q,Y){let he;const ue=setTimeout(()=>{he?.(void 0),Y?.()},Q);return Promise.race([ge.finally(()=>clearTimeout(ue)),new Promise(Oe=>he=Oe)])}function o(ge){return new Promise((Q,Y)=>{const he=ge();T(he)?he.then(Q,Y):Q(he)})}function s(){let ge,Q;return{promise:new Promise((he,ue)=>{ge=he,Q=ue}),resolve:ge,reject:Q}}class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=Q(),new Promise((Y,he)=>{this.a.then(ue=>{this.a=null,Y(ue)},ue=>{this.a=null,he(ue)})})}dispose(){this.f=!0}}e.$qh=i;class n{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$rh=n;class c{constructor(){this.a=new Map}queue(Q,Y){const ue=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===ue&&this.a.delete(Q)});return this.a.set(Q,ue),ue}}e.$sh=c;const l=(ge,Q)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,Q()},ge);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},t=ge=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,ge())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class f{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ue,Oe)=>{this.d=ue,this.f=Oe}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===p.$be?t(he):l(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=f;class a{constructor(Q){this.a=new f(Q),this.b=new i}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=a;class ${constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=$;class u extends ${constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$wh=u;function S(ge,Q){return Q?new Promise((Y,he)=>{const ue=setTimeout(()=>{Oe.dispose(),Y()},ge),Oe=Q.onCancellationRequested(()=>{clearTimeout(ue),Oe.dispose(),he(new M.$5)})}):D(Y=>S(ge,Y))}function h(ge,Q=0,Y){const he=setTimeout(()=>{ge(),Y&&ue.dispose()},Q),ue=(0,O.$Tc)(()=>{clearTimeout(he),Y?.deleteAndLeak(ue)});return Y?.add(ue),ue}function b(ge){const Q=[];let Y=0;const he=ge.length;function ue(){return Y<he?ge[Y++]():null}function Oe(de){de!=null&&Q.push(de);const Ce=ue();return Ce?Ce.then(Oe):Promise.resolve(Q)}return Promise.resolve(null).then(Oe)}function m(ge,Q=he=>!!he,Y=null){let he=0;const ue=ge.length,Oe=()=>{if(he>=ue)return Promise.resolve(Y);const de=ge[he++];return Promise.resolve(de()).then(Ae=>Q(Ae)?Promise.resolve(Ae):Oe())};return Oe()}function k(ge,Q=he=>!!he,Y=null){if(ge.length===0)return Promise.resolve(Y);let he=ge.length;const ue=()=>{he=-1;for(const Oe of ge)Oe.cancel?.()};return new Promise((Oe,de)=>{for(const Ce of ge)Ce.then(Ae=>{--he>=0&&Q(Ae)?(ue(),Oe(Ae)):he===0&&Oe(Y)}).catch(Ae=>{--he>=0&&(ue(),de(Ae))})})}class y{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new A.$ee}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:Q,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=y;class C extends y{constructor(){super(1)}}e.$Dh=C;class P{constructor(){this.a=new fe,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Eh=P;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new ae;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=R.$Zg){const he=Y.getComparisonKey(Q);return this.a.get(he)?.size??0}queueFor(Q,Y,he=R.$Zg){const ue=he.getComparisonKey(Q);let Oe=this.a.get(ue);if(!Oe){Oe=new C;const de=this.f++,Ce=A.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$5c),this.d.set(de,Ce),this.a.set(ue,Oe)}return Oe.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=W;class V{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$Gh=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,he=globalThis){this.cancel();const ue=he.setInterval(()=>{Q()},Y);this.d=(0,O.$Tc)(()=>{he.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=q;class N{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=N;class U{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=U;class K extends N{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Kh=K;class ie extends O.$Vc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new O.$Wc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(ge,Q)=>{(0,w.$B)(()=>{if(Y)return;const he=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Nh=(ge,Q,Y)=>{const he=ge.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,ge.cancelIdleCallback(he))}}},e.$Mh=ge=>(0,e.$Nh)(globalThis,ge)}();class ce{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Nh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=ce;class ye extends ce{constructor(Q){super(globalThis,Q)}}e.$Ph=ye;async function Se(ge,Q,Y){let he;for(let ue=0;ue<Y;ue++)try{return await ge()}catch(Oe){he=Oe,await S(Q)}throw he}class fe{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,he){return this.a={taskId:Q,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:he,reject:ue}=s();this.b={run:Q,promise:Y,promiseResolve:he,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=fe;class $e{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Sh=$e;var Te;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(Te||(Te={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new M.$5)}}e.$Th=ae;var Ne;(function(ge){async function Q(he){let ue;const Oe=await Promise.all(he.map(de=>de.then(Ce=>Ce,Ce=>{ue||(ue=Ce)})));if(typeof ue<"u")throw ue;return Oe}ge.settled=Q;function Y(he){return new Promise(async(ue,Oe)=>{try{await he(ue,Oe)}catch(de){Oe(de)}})}ge.withAsyncBody=Y})(Ne||(e.Promises=Ne={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=ne;class z{constructor(Q){this.b=Q,this.a=new E.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=z;var x;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(x||(x={}));class ve{static fromArray(Q){return new ve(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new ve(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new ve(async Y=>{await Promise.all(Q.map(async he=>Y.emitOne(await he)))})}static merge(Q){return new ve(async Y=>{await Promise.all(Q.map(async he=>{for await(const ue of he)Y.emitOne(ue)}))})}static{this.EMPTY=ve.fromArray([])}constructor(Q,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new A.$ee,queueMicrotask(async()=>{const he={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(Q(he)),this.k()}catch(ue){this.l(ue)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,Y){return new ve(async he=>{for await(const ue of Q)he.emitOne(Y(ue))})}map(Q){return ve.map(this,Q)}static filter(Q,Y){return new ve(async he=>{for await(const ue of Q)Y(ue)&&he.emitOne(ue)})}filter(Q){return ve.filter(this,Q)}static coalesce(Q){return ve.filter(Q,Y=>!!Y)}coalesce(){return ve.coalesce(this)}static async toPromise(Q){const Y=[];for await(const he of Q)Y.push(he);return Y}toPromise(){return ve.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Wh=ve;class Fe extends ve{constructor(Q,Y){super(Y),this.m=Q}cancel(){this.m.cancel()}}e.$Xh=Fe;function De(ge){const Q=new I.$pe,Y=ge(Q.token);return new Fe(Q,async he=>{const ue=Q.token.onCancellationRequested(()=>{ue.dispose(),Q.dispose(),he.reject(new M.$5)});try{for await(const Oe of Y){if(Q.token.isCancellationRequested)return;he.emitOne(Oe)}ue.dispose(),Q.dispose()}catch(Oe){ue.dispose(),Q.dispose(),he.reject(Oe)}})}class we{constructor(Q){this.a=new ae,this.b=new ve(ue=>{if(Y){ue.reject(Y);return}return he&&ue.emitMany(he),this.d=Oe=>ue.reject(Oe),this.f=Oe=>ue.emitOne(Oe),this.a.p},Q);let Y,he;this.f=ue=>{he||(he=[]),he.push(ue)},this.d=ue=>{Y||(Y=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Zh=we}),define(Ie[37],Pe([1,0,18,11,48,28,19,22,13]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=E,e.$ok=g,e.$pk=C,e.$qk=P,e.$rk=W,e.$sk=V,e.$tk=q,e.$uk=ie;function E(){return Object.create(null)}e.$mk="**",e.$nk="/";const T="[/\\\\]",D="[^/\\\\]",d=/\//g;function v(ce,ye){switch(ce){case 0:return"";case 1:return`${D}*?`;default:return`(?:${T}|${D}+${T}${ye?`|${T}${D}+`:""})*?`}}function g(ce,ye){if(!ce)return[];const Se=[];let fe=!1,$e=!1,Te="";for(const ae of ce){switch(ae){case ye:if(!fe&&!$e){Se.push(Te),Te="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":$e=!0;break;case"]":$e=!1;break}Te+=ae}return Te&&Se.push(Te),Se}function r(ce){if(!ce)return"";let ye="";const Se=g(ce,e.$nk);if(Se.every(fe=>fe===e.$mk))ye=".*";else{let fe=!1;Se.forEach(($e,Te)=>{if($e===e.$mk){if(fe)return;ye+=v(2,Te===Se.length-1)}else{let ae=!1,Ne="",ne=!1,z="";for(const x of $e){if(x!=="}"&&ae){Ne+=x;continue}if(ne&&(x!=="]"||!z)){let ve;x==="-"?ve=x:(x==="^"||x==="!")&&!z?ve="^":x===e.$nk?ve="":ve=(0,p.$af)(x),z+=ve;continue}switch(x){case"{":ae=!0;continue;case"[":ne=!0;continue;case"}":{const Fe=`(?:${g(Ne,",").map(De=>r(De)).join("|")})`;ye+=Fe,ae=!1,Ne="";break}case"]":{ye+="["+z+"]",ne=!1,z="";break}case"?":ye+=D;continue;case"*":ye+=v(1);continue;default:ye+=(0,p.$af)(x)}}Te<Se.length-1&&(Se[Te+1]!==e.$mk||Te+2<Se.length)&&(ye+=T)}fe=$e===e.$mk})}return ye}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Ec(1e4),f=function(){return!1},a=function(){return null};function $(ce,ye){if(!ce)return a;let Se;typeof ce!="string"?Se=ce.pattern:Se=ce,Se=Se.trim();const fe=`${Se}_${!!ye.trimForExclusions}`;let $e=t.get(fe);if($e)return u($e,ce);let Te;return o.test(Se)?$e=h(Se.substr(4),Se):(Te=s.exec(S(Se,ye)))?$e=b(Te[1],Se):(ye.trimForExclusions?n:i).test(Se)?$e=m(Se,ye):(Te=c.exec(S(Se,ye)))?$e=k(Te[1].substr(1),Se,!0):(Te=l.exec(S(Se,ye)))?$e=k(Te[1],Se,!1):$e=y(Se),t.set(fe,$e),u($e,ce)}function u(ce,ye){if(typeof ye=="string")return ce;const Se=function(fe,$e){return(0,A.$vg)(fe,ye.base,!w.$k)?ce((0,p.$ff)(fe.substr(ye.base.length),R.sep),$e):null};return Se.allBasenames=ce.allBasenames,Se.allPaths=ce.allPaths,Se.basenames=ce.basenames,Se.patterns=ce.patterns,Se}function S(ce,ye){return ye.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function h(ce,ye){return function(Se,fe){return typeof Se=="string"&&Se.endsWith(ce)?ye:null}}function b(ce,ye){const Se=`/${ce}`,fe=`\\${ce}`,$e=function(ae,Ne){return typeof ae!="string"?null:Ne?Ne===ce?ye:null:ae===ce||ae.endsWith(Se)||ae.endsWith(fe)?ye:null},Te=[ce];return $e.basenames=Te,$e.patterns=[ye],$e.allBasenames=Te,$e}function m(ce,ye){const Se=K(ce.slice(1,-1).split(",").map(Ne=>$(Ne,ye)).filter(Ne=>Ne!==a),ce),fe=Se.length;if(!fe)return a;if(fe===1)return Se[0];const $e=function(Ne,ne){for(let z=0,x=Se.length;z<x;z++)if(Se[z](Ne,ne))return ce;return null},Te=Se.find(Ne=>!!Ne.allBasenames);Te&&($e.allBasenames=Te.allBasenames);const ae=Se.reduce((Ne,ne)=>ne.allPaths?Ne.concat(ne.allPaths):Ne,[]);return ae.length&&($e.allPaths=ae),$e}function k(ce,ye,Se){const fe=R.sep===R.$hc.sep,$e=fe?ce:ce.replace(d,R.sep),Te=R.sep+$e,ae=R.$hc.sep+ce;let Ne;return Se?Ne=function(ne,z){return typeof ne=="string"&&(ne===$e||ne.endsWith(Te)||!fe&&(ne===ce||ne.endsWith(ae)))?ye:null}:Ne=function(ne,z){return typeof ne=="string"&&(ne===$e||!fe&&ne===ce)?ye:null},Ne.allPaths=[(Se?"*/":"./")+ce],Ne}function y(ce){try{const ye=new RegExp(`^${r(ce)}$`);return function(Se){return ye.lastIndex=0,typeof Se=="string"&&ye.test(Se)?ce:null}}catch{return a}}function C(ce,ye,Se){return!ce||typeof ye!="string"?!1:P(ce)(ye,void 0,Se)}function P(ce,ye={}){if(!ce)return f;if(typeof ce=="string"||W(ce)){const Se=$(ce,ye);if(Se===a)return f;const fe=function($e,Te){return!!Se($e,Te)};return Se.allBasenames&&(fe.allBasenames=Se.allBasenames),Se.allPaths&&(fe.allPaths=Se.allPaths),fe}return N(ce,ye)}function W(ce){const ye=ce;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function V(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function N(ce,ye){const Se=K(Object.getOwnPropertyNames(ce).map(Ne=>U(Ne,ce[Ne],ye)).filter(Ne=>Ne!==a)),fe=Se.length;if(!fe)return a;if(!Se.some(Ne=>!!Ne.requiresSiblings)){if(fe===1)return Se[0];const Ne=function(x,ve){let Fe;for(let De=0,we=Se.length;De<we;De++){const ge=Se[De](x,ve);if(typeof ge=="string")return ge;(0,M.$ih)(ge)&&(Fe||(Fe=[]),Fe.push(ge))}return Fe?(async()=>{for(const De of Fe){const we=await De;if(typeof we=="string")return we}return null})():null},ne=Se.find(x=>!!x.allBasenames);ne&&(Ne.allBasenames=ne.allBasenames);const z=Se.reduce((x,ve)=>ve.allPaths?x.concat(ve.allPaths):x,[]);return z.length&&(Ne.allPaths=z),Ne}const $e=function(Ne,ne,z){let x,ve;for(let Fe=0,De=Se.length;Fe<De;Fe++){const we=Se[Fe];we.requiresSiblings&&z&&(ne||(ne=(0,R.$oc)(Ne)),x||(x=ne.substr(0,ne.length-(0,R.$pc)(Ne).length)));const ge=we(Ne,ne,x,z);if(typeof ge=="string")return ge;(0,M.$ih)(ge)&&(ve||(ve=[]),ve.push(ge))}return ve?(async()=>{for(const Fe of ve){const De=await Fe;if(typeof De=="string")return De}return null})():null},Te=Se.find(Ne=>!!Ne.allBasenames);Te&&($e.allBasenames=Te.allBasenames);const ae=Se.reduce((Ne,ne)=>ne.allPaths?Ne.concat(ne.allPaths):Ne,[]);return ae.length&&($e.allPaths=ae),$e}function U(ce,ye,Se){if(ye===!1)return a;const fe=$(ce,Se);if(fe===a)return a;if(typeof ye=="boolean")return fe;if(ye){const $e=ye.when;if(typeof $e=="string"){const Te=(ae,Ne,ne,z)=>{if(!z||!fe(ae,Ne))return null;const x=$e.replace("$(basename)",()=>ne),ve=z(x);return(0,M.$ih)(ve)?ve.then(Fe=>Fe?ce:null):ve?ce:null};return Te.requiresSiblings=!0,Te}}return fe}function K(ce,ye){const Se=ce.filter(Ne=>!!Ne.basenames);if(Se.length<2)return ce;const fe=Se.reduce((Ne,ne)=>{const z=ne.basenames;return z?Ne.concat(z):Ne},[]);let $e;if(ye){$e=[];for(let Ne=0,ne=fe.length;Ne<ne;Ne++)$e.push(ye)}else $e=Se.reduce((Ne,ne)=>{const z=ne.patterns;return z?Ne.concat(z):Ne},[]);const Te=function(Ne,ne){if(typeof Ne!="string")return null;if(!ne){let x;for(x=Ne.length;x>0;x--){const ve=Ne.charCodeAt(x-1);if(ve===47||ve===92)break}ne=Ne.substr(x)}const z=fe.indexOf(ne);return z!==-1?$e[z]:null};Te.basenames=fe,Te.patterns=$e,Te.allBasenames=fe;const ae=ce.filter(Ne=>!Ne.basenames);return ae.push(Te),ae}function ie(ce,ye){return(0,I.$ub)(ce,ye,(Se,fe)=>typeof Se=="string"&&typeof fe=="string"?Se===fe:typeof Se!="string"&&typeof fe!="string"?Se.base===fe.base&&Se.pattern===fe.pattern:!1)}}),define(Ie[55],Pe([1,0,14,137,23,13,2]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=E,e.$Vk=T,e.$Wk=D,e.$Xk=d,e.$Yk=v,e.$Zk=g,e.$1k=r,e.$2k=o;var w;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class p{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,I.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=d(this.supportThemeIcons?(0,M.$Nk)(i):i).replace(/([ \t]+)/g,(c,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${v(n,i)}
`,this}appendLink(i,n,c){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,n){const c=new RegExp((0,O.$af)(n),"g");return i.replace(c,(l,t)=>i.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.$Tk=p;function E(s){return T(s)?!s.value:Array.isArray(s)?s.every(E):!0}function T(s){return s instanceof p?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function D(s,i){return s===i?!0:!s||!i?!1:s.value===i.value&&s.isTrusted===i.isTrusted&&s.supportThemeIcons===i.supportThemeIcons&&s.supportHtml===i.supportHtml&&(s.baseUri===i.baseUri||!!s.baseUri&&!!i.baseUri&&(0,A.$3g)(R.URI.from(s.baseUri),R.URI.from(i.baseUri)))}function d(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function v(s,i){const n=s.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,c=n>=3?n+1:3;return[`${"`".repeat(c)}${i}`,s,`${"`".repeat(c)}`].join(`
`)}function g(s){return s.replace(/"/g,"&quot;")}function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const i=[],n=s.split("|").map(l=>l.trim());s=n[0];const c=n[1];if(c){const l=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),f=l?l[1]:"",a=t?t[1]:"",$=isFinite(parseInt(a)),u=isFinite(parseInt(f));$&&i.push(`width="${a}"`),u&&i.push(`height="${f}"`)}return{href:s,dimensions:i}}}),define(Ie[97],Pe([1,0,18,48,19,22,23,13]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xw=p,e.$yw=T,e.$zw=d,e.$Aw=v,e.$Bw=s,e.$Cw=n,e.$Dw=c,e.$Ew=l,e.$Fw=t,e.$Gw=f;function p($,u){const{os:S,tildify:h,relative:b}=u;if(b){const y=E($,b,S);if(typeof y=="string")return y}let m=$.fsPath;if(S===1&&!O.$i?m=m.replace(/\//g,"\\"):S!==1&&O.$i&&(m=m.replace(/\\/g,"/")),S!==1&&h?.userHome){const y=h.userHome.fsPath;let C;$.scheme!==h.userHome.scheme&&$.path[0]===A.$hc.sep&&$.path[1]!==A.$hc.sep?C=h.userHome.with({path:$.path}).fsPath:C=m,m=d(C,y,S)}return(S===1?A.$gc:A.$hc).normalize(T(m,S===1))}function E($,u,S){const h=S===1?A.$gc:A.$hc,b=S===3?R.$Zg:R.$2g,m=u.getWorkspace(),k=(0,I.$Ob)(m.folders);if(!k)return;$.scheme!==k.uri.scheme&&$.path[0]===A.$hc.sep&&$.path[1]!==A.$hc.sep&&($=k.uri.with({path:$.path}));const y=u.getWorkspaceFolder($);if(!y)return;let C;if(b.isEqual(y.uri,$)?C="":C=b.relativePath(y.uri,$)??"",C&&(C=h.normalize(C)),m.folders.length>1&&!u.noPrefix){const P=y.name?y.name:b.basenameOrAuthority(y.uri);C=C?`${P} \u2022 ${C}`:P}return C}function T($,u=O.$i){return(0,M.$Ag)($,u)?$.charAt(0).toUpperCase()+$.slice(1):$}let D=Object.create(null);function d($,u,S=O.OS){if(S===1||!$||!u)return $;let h=D.original===u?D.normalized:void 0;h||(h=u,O.$i&&(h=(0,M.$pg)(h)),h=`${(0,w.$gf)(h,A.$hc.sep)}${A.$hc.sep}`,D={original:u,normalized:h});let b=$;return O.$i&&(b=(0,M.$pg)(b)),(S===3?b.startsWith(h):(0,w.$zf)(b,h))?`~/${b.substr(h.length)}`:$}function v($,u){return $.replace(/^~($|\/|\\)/,`${u}$1`)}const g="\u2026",r="\\\\",o="~";function s($,u=A.sep){const S=new Array($.length);let h=!1;for(let b=0;b<$.length;b++){const m=$[b];if(m===""){S[b]=`.${u}`;continue}if(!m){S[b]=m;continue}h=!0;let k="",y=m;y.indexOf(r)===0?(k=y.substr(0,y.indexOf(r)+r.length),y=y.substr(y.indexOf(r)+r.length)):y.indexOf(u)===0?(k=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(o)===0&&(k=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length));const C=y.split(u);for(let P=1;h&&P<=C.length;P++)for(let W=C.length-P;h&&W>=0;W--){h=!1;let V=C.slice(W,W+P).join(u);for(let q=0;!h&&q<$.length;q++)if(q!==b&&$[q]&&$[q].indexOf(V)>-1){const N=W+P===C.length,U=W>0&&$[q].indexOf(u)>-1?u+V:V,K=$[q].endsWith(U);h=!N||K}if(!h){let q="";(C[0].endsWith(":")||k!=="")&&(W===1&&(W=0,P++,V=C[0]+u+V),W>0&&(q=C[0]+u),q=k+q),W>0&&(q=q+g+u),q=q+V,W+P<C.length&&(q=q+u+g),S[b]=q}}h&&(S[b]=m)}return S}var i;(function($){$[$.TEXT=0]="TEXT",$[$.VARIABLE=1]="VARIABLE",$[$.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n($,u=Object.create(null)){const S=[];let h=!1,b="";for(const m of $)if(m==="$"||h&&m==="{")b&&S.push({value:b,type:i.TEXT}),b="",h=!0;else if(m==="}"&&h){const k=u[b];if(typeof k=="string")k.length&&S.push({value:k,type:i.VARIABLE});else if(k){const y=S[S.length-1];(!y||y.type!==i.SEPARATOR)&&S.push({value:k.label,type:i.SEPARATOR})}b="",h=!1}else b+=m;return b&&!h&&S.push({value:b,type:i.TEXT}),S.filter((m,k)=>{if(m.type===i.SEPARATOR){const y=S[k-1],C=S[k+1];return[y,C].every(P=>P&&(P.type===i.VARIABLE||P.type===i.TEXT)&&P.value.length>0)}return!0}).map(m=>m.value).join("")}function c($,u){return O.$j||u?$.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):$.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function l($,u){return O.$j||u?$.replace(/\(&&\w\)|&&/g,""):O.$i?$.replace(/&&|&/g,S=>S==="&"?"&&":"&"):$.replace(/&&/g,"_")}function t($){return $.replace(/&/g,"&&")}function f($){if($.endsWith("]")){const u=$.lastIndexOf(" [",$.length-2);if(u!==-1){const S=a($.substring(0,u)),h=$.substring(u);return{name:S.name+h,parentPath:S.parentPath}}}return a($)}function a($){const u=$.indexOf("/")!==-1?A.$hc:A.$gc,S=u.basename($),h=u.dirname($);return S.length?{name:S,parentPath:h}:{name:h,parentPath:""}}}),define(Ie[150],Pe([1,0,21,2]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=w,e.$Bn=E,e.$Cn=T;function A(D){return D.toJSON()}class O{constructor(d){this.a=d}transformIncoming(d){const v=this.a.transformIncoming(d);return v===d?d:A(M.URI.from(v))}transformOutgoing(d){const v=this.a.transformOutgoing(d);return v===d?d:A(M.URI.from(v))}transformOutgoingURI(d){const v=this.a.transformOutgoing(d);return v===d?d:M.URI.from(v)}transformOutgoingScheme(d){return this.a.transformOutgoingScheme(d)}}e.$yn=O,e.$zn=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function R(D,d,v){if(!D||v>200)return null;if(typeof D=="object"){if(D instanceof M.URI)return d.transformOutgoing(D);for(const g in D)if(Object.hasOwnProperty.call(D,g)){const r=R(D[g],d,v+1);r!==null&&(D[g]=r)}}return null}function w(D,d){const v=R(D,d,0);return v===null?D:v}function p(D,d,v,g){if(!D||g>200)return null;if(typeof D=="object"){if(D.$mid===1)return v?M.URI.revive(d.transformIncoming(D)):d.transformIncoming(D);if(D instanceof I.$Ge)return null;for(const r in D)if(Object.hasOwnProperty.call(D,r)){const o=p(D[r],d,v,g+1);o!==null&&(D[r]=o)}}return null}function E(D,d){const v=p(D,d,!1,0);return v===null?D:v}function T(D,d){const v=p(D,d,!0,0);return v===null?D:v}}),define(Ie[151],Pe([1,0,11,5,6,49,15]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=p;var w;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function p(d){const v=d;return v?.changed instanceof Map||v?.deleted instanceof Set}var E;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(E||(e.StorageState=E={}));class T extends A.$Vc{static{this.a=100}constructor(v,g=Object.create(null)){super(),this.r=v,this.s=g,this.b=this.B(new M.$he),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new I.$uh(T.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((g,r)=>this.w(r,g)),v.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(v,g){if(this.c===E.Closed)return;let r=!1;(0,R.$fg)(g)?r=this.f.delete(v):this.f.get(v)!==g&&(this.f.set(v,g),r=!0),r&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,g){const r=this.f.get(v);return(0,R.$fg)(r)?g:r}getBoolean(v,g){const r=this.get(v);return(0,R.$fg)(r)?g:r==="true"}getNumber(v,g){const r=this.get(v);return(0,R.$fg)(r)?g:parseInt(r,10)}getObject(v,g){const r=this.get(v);return(0,R.$fg)(r)?g:(0,O.$5h)(r)}async set(v,g,r=!1){if(this.c===E.Closed)return;if((0,R.$fg)(g))return this.delete(v,r);const o=(0,R.$$f)(g)||Array.isArray(g)?(0,O.$4h)(g):String(g);if(this.f.get(v)!==o)return this.f.set(v,o),this.j.set(v,o),this.h.delete(v),this.b.fire({key:v,external:r}),this.D()}async delete(v,g=!1){if(!(this.c===E.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:g}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(this.z)return this.D(v)}async D(v){return this.s.hint===w.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===w.STORAGE_IN_MEMORY}}e.$Wp=T;class D{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((g,r)=>this.a.set(r,g)),v.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$Xp=D}),define(Ie[152],Pe([1,0,13,22,21]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0,e.$Dt=T,e.$Et=D;let O;function R(){return O||(O=new TextDecoder("UTF-16LE")),O}let w;function p(){return w||(w=new TextDecoder("UTF-16BE")),w}let E;function T(){return E||(E=M.$D()?R():p()),E}function D(g,r,o){const s=new Uint16Array(g.buffer,r,o);return o>0&&(s[0]===65279||s[0]===65534)?d(g,r,o):R().decode(s)}function d(g,r,o){const s=[];let i=0;for(let n=0;n<o;n++){const c=A.$Ie(g,r);r+=2,s[i++]=String.fromCharCode(c)}return s.join("")}class v{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return T().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||I.$Cf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<o;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$Ft=v}),define(Ie[153],Pe([1,0,21,152]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0,e.$Ht=R;function A(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,T,D,d){this.oldPosition=E,this.oldText=T,this.newPosition=D,this.newText=d}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,T,D){const d=T.length;I.$Le(E,d,D),D+=4;for(let v=0;v<d;v++)I.$Je(E,T.charCodeAt(v),D),D+=2;return D}static d(E,T){const D=I.$Ke(E,T);return T+=4,(0,M.$Et)(E,T,D)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(E,T){return I.$Le(E,this.oldPosition,T),T+=4,I.$Le(E,this.newPosition,T),T+=4,T=O.c(E,this.oldText,T),T=O.c(E,this.newText,T),T}static read(E,T,D){const d=I.$Ke(E,T);T+=4;const v=I.$Ke(E,T);T+=4;const g=O.d(E,T);T+=O.a(g);const r=O.d(E,T);return T+=O.a(r),D.push(new O(d,g,v,r)),T}}e.$Gt=O;function R(p,E){return p===null||p.length===0?E:new w(p,E).compress()}class w{constructor(E,T){this.a=E,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,T=0,D=this.n(E),d=this.l(T);for(;E<this.f||T<this.h;){if(D===null){this.k(d),d=this.l(++T);continue}if(d===null){this.m(D),D=this.n(++E);continue}if(d.oldEnd<=D.newPosition){this.k(d),d=this.l(++T);continue}if(D.newEnd<=d.oldPosition){this.m(D),D=this.n(++E);continue}if(d.oldPosition<D.newPosition){const[s,i]=w.r(d,D.newPosition-d.oldPosition);this.k(s),d=i;continue}if(D.newPosition<d.oldPosition){const[s,i]=w.q(D,d.oldPosition-D.newPosition);this.m(s),D=i;continue}let r,o;if(d.oldEnd===D.newEnd)r=D,o=d,D=this.n(++E),d=this.l(++T);else if(d.oldEnd<D.newEnd){const[s,i]=w.q(D,d.oldLength);r=s,o=d,D=i,d=this.l(++T)}else{const[s,i]=w.r(d,D.newLength);r=D,o=s,D=this.n(++E),d=i}this.d[this.e++]=new O(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const v=w.s(this.d);return w.t(v)}k(E){this.d[this.e++]=w.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=w.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,T){return new O(T.oldPosition-E,T.oldText,T.newPosition,T.newText)}static p(E,T){return new O(T.oldPosition,T.oldText,T.newPosition+E,T.newText)}static q(E,T){const D=E.newText.substr(0,T),d=E.newText.substr(T);return[new O(E.oldPosition,E.oldText,E.newPosition,D),new O(E.oldEnd,"",E.newPosition+T,d)]}static r(E,T){const D=E.oldText.substr(0,T),d=E.oldText.substr(T);return[new O(E.oldPosition,D,E.newPosition,E.newText),new O(E.oldPosition+T,d,E.newEnd,"")]}static s(E){if(E.length===0)return E;const T=[];let D=0,d=E[0];for(let v=1;v<E.length;v++){const g=E[v];d.oldEnd===g.oldPosition?d=new O(d.oldPosition,d.oldText+g.oldText,d.newPosition,d.newText+g.newText):(T[D++]=d,d=g)}return T[D++]=d,T}static t(E){if(E.length===0)return E;const T=[];let D=0;for(let d=0;d<E.length;d++){const v=E[d];v.oldText!==v.newText&&(T[D++]=v)}return T}}}),define(Ie[154],Pe([1,0,37,19]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=A,e.$Yt=O;function A(R,w,p,E,T,D){if(Array.isArray(R)){let d=0;for(const v of R){const g=A(v,w,p,E,T,D);if(g===10)return g;g>d&&(d=g)}return d}else{if(typeof R=="string")return E?R==="*"?5:R===p?10:0:0;if(R){const{language:d,pattern:v,scheme:g,hasAccessToAllModels:r,notebookType:o}=R;if(!E&&!r)return 0;o&&T&&(w=T);let s=0;if(g)if(g===w.scheme)s=10;else if(g==="*")s=5;else return 0;if(d)if(d===p)s=10;else if(d==="*")s=Math.max(s,5);else return 0;if(o)if(o===D)s=10;else if(o==="*"&&D!==void 0)s=Math.max(s,5);else return 0;if(v){let i;if(typeof v=="string"?i=v:i={...v,base:(0,M.$ic)(v.base)},i===w.fsPath||(0,I.$pk)(i,w.fsPath))s=10;else return 0}return s}else return 0}}function O(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(O):!!R.notebookType}}),define(Ie[155],Pe([1,0,5,13,30,95,93,139,153,6]),function(le,e,I,M,A,O,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=void 0;class T extends E.$Vc{constructor(d,v,g,r,o,s,i){super(),this.m=this.B(new I.$ee),this.onDidChangeContent=this.m.event,this.f=v,this.j=!s,this.g=r,this.h=o,this.c=new R.$TC(d,g,i)}equals(d){return!(d instanceof T)||this.f!==d.f||this.getEOL()!==d.getEOL()?!1:this.c.equal(d.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(d){return this.c.createSnapshot(d?this.f:"")}getOffsetAt(d,v){return this.c.getOffsetAt(d,v)}getPositionAt(d){return this.c.getPositionAt(d)}getRangeAt(d,v){const g=d+v,r=this.getPositionAt(d),o=this.getPositionAt(g);return new A.$ut(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(d,v=0){if(d.isEmpty())return"";const g=this.n(v);return this.c.getValueInRange(d,g)}getValueLengthInRange(d,v=0){if(d.isEmpty())return 0;if(d.startLineNumber===d.endLineNumber)return d.endColumn-d.startColumn;const g=this.getOffsetAt(d.startLineNumber,d.startColumn),r=this.getOffsetAt(d.endLineNumber,d.endColumn);let o=0;const s=this.n(v),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,c=d.endLineNumber-d.startLineNumber;o=n*c}return r-g+o}getCharacterCountInRange(d,v=0){if(this.j){let g=0;const r=d.startLineNumber,o=d.endLineNumber;for(let s=r;s<=o;s++){const i=this.getLineContent(s),n=s===r?d.startColumn-1:0,c=s===o?d.endColumn-1:i.length;for(let l=n;l<c;l++)M.$Cf(i.charCodeAt(l))?(g=g+1,l=l+1):g=g+1}return g+=this.n(v).length*(o-r),g}return this.getValueLengthInRange(d,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(d){return this.c.getLineContent(d)}getLineCharCode(d,v){return this.c.getLineCharCode(d,v)}getCharCode(d){return this.c.getCharCode(d)}getLineLength(d){return this.c.getLineLength(d)}getLineMinColumn(d){return 1}getLineMaxColumn(d){return this.getLineLength(d)+1}getLineFirstNonWhitespaceColumn(d){const v=M.$nf(this.getLineContent(d));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(d){const v=M.$pf(this.getLineContent(d));return v===-1?0:v+2}n(d){switch(d){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(d){this.c.setEOL(d)}applyEdits(d,v,g){let r=this.g,o=this.h,s=this.j,i=!0,n=[];for(let u=0;u<d.length;u++){const S=d[u];i&&S._isTracked&&(i=!1);const h=S.range;if(S.text){let C=!0;s||(C=!M.$Nf(S.text),s=C),!r&&C&&(r=M.$Mf(S.text)),!o&&C&&(o=M.$Pf(S.text))}let b="",m=0,k=0,y=0;if(S.text){let C;[m,k,y,C]=(0,w.$1t)(S.text);const P=this.getEOL();C===0||C===(P===`\r
`?2:1)?b=S.text:b=S.text.replace(/\r\n|\r|\n/g,P)}n[u]={sortIndex:u,identifier:S.identifier||null,range:h,rangeOffset:this.getOffsetAt(h.startLineNumber,h.startColumn),rangeLength:this.getValueLengthInRange(h),text:b,eolCount:m,firstLineLength:k,lastLineLength:y,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}n.sort(T.u);let c=!1;for(let u=0,S=n.length-1;u<S;u++){const h=n[u].range.getEndPosition(),b=n[u+1].range.getStartPosition();if(b.isBeforeOrEqual(h)){if(b.isBefore(h))throw new Error("Overlapping ranges are not allowed!");c=!0}}i&&(n=this.s(n));const l=g||v?T._getInverseEditRanges(n):[],t=[];if(v)for(let u=0;u<n.length;u++){const S=n[u],h=l[u];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let b=h.startLineNumber;b<=h.endLineNumber;b++){let m="";b===h.startLineNumber&&(m=this.getLineContent(S.range.startLineNumber),M.$nf(m)!==-1)||t.push({lineNumber:b,oldContent:m})}}let f=null;if(g){let u=0;f=[];for(let S=0;S<n.length;S++){const h=n[S],b=l[S],m=this.getValueInRange(h.range),k=h.rangeOffset+u;u+=h.text.length-m.length,f[S]={sortIndex:h.sortIndex,identifier:h.identifier,range:b,text:m,textChange:new p.$Gt(h.rangeOffset,m,k,h.text)}}c||f.sort((S,h)=>S.sortIndex-h.sortIndex)}this.g=r,this.h=o,this.j=s;const a=this.t(n);let $=null;if(v&&t.length>0){t.sort((u,S)=>S.lineNumber-u.lineNumber),$=[];for(let u=0,S=t.length;u<S;u++){const h=t[u].lineNumber;if(u>0&&t[u-1].lineNumber===h)continue;const b=t[u].oldContent,m=this.getLineContent(h);m.length===0||m===b||M.$nf(m)!==-1||$.push(h)}}return this.m.fire(),new O.$Jv(f,a,$)}s(d){return d.length<1e3?d:[this._toSingleEditOperation(d)]}_toSingleEditOperation(d){let v=!1;const g=d[0].range,r=d[d.length-1].range,o=new A.$ut(g.startLineNumber,g.startColumn,r.endLineNumber,r.endColumn);let s=g.startLineNumber,i=g.startColumn;const n=[];for(let a=0,$=d.length;a<$;a++){const u=d[a],S=u.range;v=v||u.forceMoveMarkers,n.push(this.getValueInRange(new A.$ut(s,i,S.startLineNumber,S.startColumn))),u.text.length>0&&n.push(u.text),s=S.endLineNumber,i=S.endColumn}const c=n.join(""),[l,t,f]=(0,w.$1t)(c);return{sortIndex:0,identifier:d[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:l,firstLineLength:t,lastLineLength:f,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(d){d.sort(T.w);const v=[];for(let g=0;g<d.length;g++){const r=d[g],o=r.range.startLineNumber,s=r.range.startColumn,i=r.range.endLineNumber,n=r.range.endColumn;if(o===i&&s===n&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new A.$ut(o,s,i,n);v.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return v}findMatchesLineByLine(d,v,g,r){return this.c.findMatchesLineByLine(d,v,g,r)}getPieceTree(){return this.c}static _getInverseEditRange(d,v){const g=d.startLineNumber,r=d.startColumn,[o,s,i]=(0,w.$1t)(v);let n;if(v.length>0){const c=o+1;c===1?n=new A.$ut(g,r,g,r+s):n=new A.$ut(g,r,g+c-1,i+1)}else n=new A.$ut(g,r,g,r);return n}static _getInverseEditRanges(d){const v=[];let g=0,r=0,o=null;for(let s=0,i=d.length;s<i;s++){const n=d[s];let c,l;o?o.range.endLineNumber===n.range.startLineNumber?(c=g,l=r+(n.range.startColumn-o.range.endColumn)):(c=g+(n.range.startLineNumber-o.range.endLineNumber),l=n.range.startColumn):(c=n.range.startLineNumber,l=n.range.startColumn);let t;if(n.text.length>0){const f=n.eolCount+1;f===1?t=new A.$ut(c,l,c,l+n.firstLineLength):t=new A.$ut(c,l,c+f-1,n.lastLineLength+1)}else t=new A.$ut(c,l,c,l);g=t.endLineNumber,r=t.endColumn,v.push(t),o=n}return v}static u(d,v){const g=A.$ut.compareRangesUsingEnds(d.range,v.range);return g===0?d.sortIndex-v.sortIndex:g}static w(d,v){const g=A.$ut.compareRangesUsingEnds(d.range,v.range);return g===0?v.sortIndex-d.sortIndex:-g}}e.$UC=T}),define(Ie[156],Pe([1,0,13,93,155]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=void 0;class O{constructor(p,E,T,D,d,v,g,r,o){this.a=p,this.b=E,this.c=T,this.d=D,this.e=d,this.f=v,this.g=g,this.h=r,this.j=o}k(p){const E=this.c+this.d+this.e,T=this.c+this.e;return E===0?p===1?`
`:`\r
`:T>E/2?`\r
`:`
`}create(p){const E=this.k(p),T=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let d=0,v=T.length;d<v;d++){const g=T[d].buffer.replace(/\r\n|\r|\n/g,E),r=(0,M.$PC)(g);T[d]=new M.$SC(g,r)}const D=new A.$UC(T,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(p){return this.a[0].buffer.substr(0,p).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(p){if(p.length===0)return;this.a.length===0&&I.$Wf(p)&&(this.b=I.$Vf,p=p.substr(1));const E=p.charCodeAt(p.length-1);E===13||E>=55296&&E<=56319?(this.m(p.substr(0,p.length-1),!1),this.c=!0,this.d=E):(this.m(p,!1),this.c=!1,this.d=E)}m(p,E){!E&&p.length===0||(this.c?this.n(String.fromCharCode(this.d)+p):this.n(p))}n(p){const E=(0,M.$QC)(this.e,p);this.a.push(new M.$SC(p,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Mf(p)),this.k||(this.k=I.$Pf(p)))}finish(p=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,p)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const p=this.a[this.a.length-1];p.buffer+=String.fromCharCode(this.d);const E=(0,M.$PC)(p.buffer);p.lineStarts=E,this.d===13&&this.f++}}}e.$VC=R}),define(Ie[98],Pe([1,0,21,22]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bb=p,e.$$bb=T;var A;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(A||(A={}));function O(D){for(let d=0,v=D.length;d<v;d+=4){const g=D[d+0],r=D[d+1],o=D[d+2],s=D[d+3];D[d+0]=s,D[d+1]=o,D[d+2]=r,D[d+3]=g}}function R(D){const d=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return M.$D()||O(d),I.$Ge.wrap(d)}function w(D){const d=D.buffer;if(M.$D()||O(d),d.byteOffset%4===0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const v=new Uint8Array(d.byteLength);return v.set(d),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function p(D){const d=new Uint32Array(E(D));let v=0;if(d[v++]=D.id,D.type==="full")d[v++]=1,d[v++]=D.data.length,d.set(D.data,v),v+=D.data.length;else{d[v++]=2,d[v++]=D.deltas.length;for(const g of D.deltas)d[v++]=g.start,d[v++]=g.deleteCount,g.data?(d[v++]=g.data.length,d.set(g.data,v),v+=g.data.length):d[v++]=0}return R(d)}function E(D){let d=0;if(d+=2,D.type==="full")d+=1+D.data.length;else{d+=1,d+=3*D.deltas.length;for(const v of D.deltas)v.data&&(d+=v.data.length)}return d}function T(D){const d=w(D);let v=0;const g=d[v++];if(d[v++]===1){const i=d[v++],n=d.subarray(v,v+i);return v+=i,{id:g,type:"full",data:n}}const o=d[v++],s=[];for(let i=0;i<o;i++){const n=d[v++],c=d[v++],l=d[v++];let t;l>0&&(t=d.subarray(v,v+l),v+=l),s[i]={start:n,deleteCount:c,data:t}}return{id:g,type:"delta",deltas:s}}}),define(Ie[157],Pe([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(Ie[158],Pe([1,0,18,25,22,140,159,157]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=i,e.clampedFloat=c,e.stringSet=f,e.cursorStyleToString=y,e.filterValidationDecorations=ue;var p;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(p||(e.EditorAutoIndentStrategy=p={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class D{constructor(Z,me,qe,be){this.id=Z,this.name=me,this.defaultValue=qe,this.schema=be}applyUpdate(Z,me){return v(Z,me)}compute(Z,me,qe){return qe}}class d{constructor(Z,me){this.newValue=Z,this.didChange=me}}e.ApplyUpdateResult=d;function v(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new d(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const qe=Array.isArray(X)&&Array.isArray(Z)&&I.$ub(X,Z);return new d(Z,!qe)}let me=!1;for(const qe in Z)if(Z.hasOwnProperty(qe)){const be=v(X[qe],Z[qe]);be.didChange&&(X[qe]=be.newValue,me=!0)}return new d(X,me)}class g{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,me){return v(Z,me)}validate(Z){return this.defaultValue}}class r{constructor(Z,me,qe,be){this.id=Z,this.name=me,this.defaultValue=qe,this.schema=be}applyUpdate(Z,me){return v(Z,me)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,me,qe){return qe}}function o(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}class s extends r{constructor(Z,me,qe,be=void 0){typeof be<"u"&&(be.type="boolean",be.default=qe),super(Z,me,qe,be)}validate(Z){return o(Z,this.defaultValue)}}function i(X,Z,me,qe){if(typeof X>"u")return Z;let be=parseInt(X,10);return isNaN(be)?Z:(be=Math.max(me,be),be=Math.min(qe,be),be|0)}class n extends r{static clampedInt(Z,me,qe,be){return i(Z,me,qe,be)}constructor(Z,me,qe,be,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=qe,dt.minimum=be,dt.maximum=ot),super(Z,me,qe,dt),this.minimum=be,this.maximum=ot}validate(Z){return n.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(X,Z,me,qe){if(typeof X>"u")return Z;const be=l.float(X,Z);return l.clamp(be,me,qe)}class l extends r{static clamp(Z,me,qe){return Z<me?me:Z>qe?qe:Z}static float(Z,me){if(typeof Z=="number")return Z;if(typeof Z>"u")return me;const qe=parseFloat(Z);return isNaN(qe)?me:qe}constructor(Z,me,qe,be,ot){typeof ot<"u"&&(ot.type="number",ot.default=qe),super(Z,me,qe,ot),this.validationFn=be}validate(Z){return this.validationFn(l.float(Z,this.defaultValue))}}class t extends r{static string(Z,me){return typeof Z!="string"?me:Z}constructor(Z,me,qe,be=void 0){typeof be<"u"&&(be.type="string",be.default=qe),super(Z,me,qe,be)}validate(Z){return t.string(Z,this.defaultValue)}}function f(X,Z,me,qe){return typeof X!="string"?Z:qe&&X in qe?qe[X]:me.indexOf(X)===-1?Z:X}class a extends r{constructor(Z,me,qe,be,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=be,ot.default=qe),super(Z,me,qe,ot),this.c=be}validate(Z){return f(Z,this.defaultValue,this.c)}}class $ extends D{constructor(Z,me,qe,be,ot,dt,Pt=void 0){typeof Pt<"u"&&(Pt.type="string",Pt.enum=ot,Pt.default=be),super(Z,me,qe,Pt),this.c=ot,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function u(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class S extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,me,qe){return qe===0?Z.accessibilitySupport:qe}}class h extends D{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:w.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var b;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(b||(e.TextEditorCursorBlinkingStyle=b={}));function m(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var k;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(k||(e.TextEditorCursorStyle=k={}));function y(X){switch(X){case k.Line:return"line";case k.Block:return"block";case k.Underline:return"underline";case k.LineThin:return"line-thin";case k.BlockOutline:return"block-outline";case k.UnderlineThin:return"underline-thin"}}function C(X){switch(X){case"line":return k.Line;case"block":return k.Block;case"underline":return k.Underline;case"line-thin":return k.LineThin;case"block-outline":return k.BlockOutline;case"underline-thin":return k.UnderlineThin}}class P extends g{constructor(){super(142)}compute(Z,me,qe){const be=["monaco-editor"];return me.get(39)&&be.push(me.get(39)),Z.extraEditorClassName&&be.push(Z.extraEditorClassName),me.get(74)==="default"?be.push("mouse-default"):me.get(74)==="copy"&&be.push("mouse-copy"),me.get(111)&&be.push("showUnused"),me.get(140)&&be.push("showDeprecated"),be.join(" ")}}class W extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(Z,me,qe){return qe&&Z.emptySelectionClipboard}}class V extends D{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:w.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:w.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":f(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":f(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class q extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class N extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?N.OFF:Z==="true"?N.TRANSLATE:Z:Z?N.TRANSLATE:N.OFF}compute(Z,me,qe){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class U extends g{constructor(){super(50)}compute(Z,me,qe){return Z.fontInfo}}class K extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(Z){const me=l.float(Z,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(me,6,100)}compute(Z,me,qe){return Z.fontInfo.fontSize}}class ie extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(n.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class ce extends D{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:qe,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:qe,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:qe,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:qe,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:qe,description:w.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{multiple:f(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??f(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??f(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??f(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??f(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??f(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends D{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:w.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:n.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var Se;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Se||(e.RenderMinimap=Se={}));class fe extends g{constructor(){super(145)}compute(Z,me,qe){return fe.computeLayout(me,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const me=Z.height/Z.lineHeight,qe=Math.floor(Z.paddingTop/Z.lineHeight);let be=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(be=Math.max(be,me-1));const ot=(qe+Z.viewLineCount+be)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/ot);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:be,desiredRatio:ot,minimapLineCount:dt}}static c(Z,me){const qe=Z.outerWidth,be=Z.outerHeight,ot=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:be};const dt=me.stableMinimapLayoutInput,Pt=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,Vt=Z.lineHeight,Qt=Z.typicalHalfwidthCharacterWidth,ti=Z.scrollBeyondLastLine,Zt=Z.minimap.renderCharacters;let Et=ot>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Xt=Z.minimap.maxColumn,Yt=Z.minimap.size,Xe=Z.minimap.side,oi=Z.verticalScrollbarWidth,Gt=Z.viewLineCount,ht=Z.remainingWidth,$t=Z.isViewportWrapping,xt=Zt?2:3;let Kt=Math.floor(ot*be);const Ft=Kt/ot;let ft=!1,Bt=!1,_t=xt*Et,Ut=Et/ot,Qe=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:Mt,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:qt,desiredRatio:ni,minimapLineCount:Ct}=fe.computeContainedMinimapLineCount({viewLineCount:Gt,scrollBeyondLastLine:ti,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:be,lineHeight:Vt,pixelRatio:ot});if(Gt/Ct>1)ft=!0,Bt=!0,Et=1,_t=1,Ut=Et/ot;else{let Nt=!1,It=Et+1;if(Yt==="fit"){const mt=Math.ceil((ii+Gt+qt)*_t);$t&&Pt&&ht<=me.stableFitRemainingWidth?(Nt=!0,It=me.stableFitMaxMinimapScale):Nt=mt>Kt}if(Yt==="fill"||Nt){ft=!0;const mt=Et;_t=Math.min(Vt*ot,Math.max(1,Math.floor(1/ni))),$t&&Pt&&ht<=me.stableFitRemainingWidth&&(It=me.stableFitMaxMinimapScale),Et=Math.min(It,Math.max(1,Math.floor(_t/xt))),Et>mt&&(Qe=Math.min(2,Et/mt)),Ut=Et/ot/Qe,Kt=Math.ceil(Math.max(Mt,ii+Gt+qt)*_t),$t?(me.stableMinimapLayoutInput=Z,me.stableFitRemainingWidth=ht,me.stableFitMaxMinimapScale=Et):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ui=Math.floor(Xt*Ut),Jt=Math.min(ui,Math.max(0,Math.floor((ht-oi-2)*Ut/(Qt+Ut)))+e.MINIMAP_GUTTER_WIDTH);let Wt=Math.floor(ot*Jt);const pt=Wt/ot;Wt=Math.floor(Wt*Qe);const Lt=Zt?1:2,Rt=Xe==="left"?0:qe-Jt-oi;return{renderMinimap:Lt,minimapLeft:Rt,minimapWidth:Jt,minimapHeightIsEditorHeight:ft,minimapIsSampling:Bt,minimapScale:Et,minimapLineHeight:_t,minimapCanvasInnerWidth:Wt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:pt,minimapCanvasOuterHeight:Ft}}static computeLayout(Z,me){const qe=me.outerWidth|0,be=me.outerHeight|0,ot=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,Pt=me.typicalHalfwidthCharacterWidth,Vt=me.maxDigitWidth,Qt=me.pixelRatio,ti=me.viewLineCount,Zt=Z.get(137),Et=Zt==="inherit"?Z.get(136):Zt,Xt=Et==="inherit"?Z.get(132):Et,Yt=Z.get(135),Xe=me.isDominatedByLongLines,oi=Z.get(57),Gt=Z.get(68).renderType!==0,ht=Z.get(69),$t=Z.get(105),xt=Z.get(84),Kt=Z.get(73),Ft=Z.get(103),ft=Ft.verticalScrollbarSize,Bt=Ft.verticalHasArrows,_t=Ft.arrowSize,Ut=Ft.horizontalScrollbarSize,Qe=Z.get(43),ui=Z.get(110)!=="never";let Jt=Z.get(66);Qe&&ui&&(Jt+=16);let Wt=0;if(Gt){const ai=Math.max(dt,ht);Wt=Math.round(ai*Vt)}let pt=0;oi&&(pt=ot*me.glyphMarginDecorationLaneCount);let Lt=0,Rt=Lt+pt,Mt=Rt+Wt,ii=Mt+Jt;const qt=qe-pt-Wt-Jt;let ni=!1,Ct=!1,Ot=-1;Et==="inherit"&&Xe?(ni=!0,Ct=!0):Xt==="on"||Xt==="bounded"?Ct=!0:Xt==="wordWrapColumn"&&(Ot=Yt);const Nt=fe.c({outerWidth:qe,outerHeight:be,lineHeight:ot,typicalHalfwidthCharacterWidth:Pt,pixelRatio:Qt,scrollBeyondLastLine:$t,paddingTop:xt.top,paddingBottom:xt.bottom,minimap:Kt,verticalScrollbarWidth:ft,viewLineCount:ti,remainingWidth:qt,isViewportWrapping:Ct},me.memory||new T);Nt.renderMinimap!==0&&Nt.minimapLeft===0&&(Lt+=Nt.minimapWidth,Rt+=Nt.minimapWidth,Mt+=Nt.minimapWidth,ii+=Nt.minimapWidth);const It=qt-Nt.minimapWidth,mt=Math.max(1,Math.floor((It-ft-2)/Pt)),Dt=Bt?_t:0;return Ct&&(Ot=Math.max(1,mt),Xt==="bounded"&&(Ot=Math.min(Ot,Yt))),{width:qe,height:be,glyphMarginLeft:Lt,glyphMarginWidth:pt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Rt,lineNumbersWidth:Wt,decorationsLeft:Mt,decorationsWidth:Jt,contentLeft:ii,contentWidth:It,minimap:Nt,viewportColumn:mt,isWordWrapMinified:ni,isViewportWrapping:Ct,wrappingColumn:Ot,verticalScrollbarWidth:ft,horizontalScrollbarHeight:Ut,overviewRuler:{top:Dt,width:ft,height:be-2*Dt,right:0}}}}e.EditorLayoutInfoComputer=fe;class $e extends D{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(Z){return f(Z,"simple",["simple","advanced"])}compute(Z,me,qe){return me.get(2)===2?"advanced":qe}}var Te;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(Te||(e.ShowLightbulbIconMode=Te={}));class ae extends D{constructor(){const Z={enabled:Te.On};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Te.Off,Te.OnCode,Te.On],default:Z.enabled,enumDescriptions:[w.localize(50,null),w.localize(51,null),w.localize(52,null)],description:w.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:f(Z.enabled,this.defaultValue.enabled,[Te.Off,Te.OnCode,Te.On])}}}class Ne extends D{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:w.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:w.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:w.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:w.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends D{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:w.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(59,null),w.localize(60,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(61,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:w.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:w.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:w.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:f(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class z extends D{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):n.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,me,qe){return qe<0?n.clampedInt(-qe*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class x extends l{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>l.clamp(Z,0,150),{markdownDescription:w.localize(66,null)})}compute(Z,me,qe){return Z.fontInfo.lineHeight}}class ve extends D{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:w.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:w.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(69,null),w.localize(70,null),w.localize(71,null)],default:Z.size,description:w.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:w.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:w.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:w.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:w.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Z.showRegionSectionHeaders,description:w.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Z.showMarkSectionHeaders,description:w.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Z.sectionHeaderFontSize,description:w.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:f(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(me.side,this.defaultValue.side,["right","left"]),showSlider:f(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(me.scale,1,1,3),maxColumn:n.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:l.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Fe(X){return X==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class De extends D{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(82,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{top:n.clampedInt(me.top,0,0,1e3),bottom:n.clampedInt(me.bottom,0,0,1e3)}}}class we extends D{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:w.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:w.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class ge extends g{constructor(){super(143)}compute(Z,me,qe){return Z.pixelRatio}}class Q extends D{constructor(){const Z={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(85,null),w.localize(86,null),w.localize(87,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Z.strings,description:w.localize(88,null)},comments:{anyOf:me,default:Z.comments,description:w.localize(89,null)},other:{anyOf:me,default:Z.other,description:w.localize(90,null)}},default:Z,markdownDescription:w.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Qt=Z?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:me,comments:qe,strings:be}=Z,ot=["on","inline","off"];let dt,Pt,Vt;return typeof me=="boolean"?dt=me?"on":"off":dt=f(me,this.defaultValue.other,ot),typeof qe=="boolean"?Pt=qe?"on":"off":Pt=f(qe,this.defaultValue.comments,ot),typeof be=="boolean"?Vt=be?"on":"off":Vt=f(be,this.defaultValue.strings,ot),{other:dt,comments:Pt,strings:Vt}}}var Y;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends D{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(92,null),w.localize(93,null),w.localize(94,null),w.localize(95,null)],default:"on",description:w.localize(96,null)})}validate(Z){let me=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(me=4,qe=Z):Z==="interval"?me=3:Z==="relative"?me=2:Z==="on"?me=1:me=0),{renderType:me,renderFn:qe}}}function ue(X){const Z=X.get(98);return Z==="editable"?X.get(91):Z!=="on"}class Oe extends D{constructor(){const Z=[],me={type:"number",description:w.localize(97,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:w.localize(98,null),format:"color-hex"}}}]},default:Z,description:w.localize(99,null)})}validate(Z){if(Array.isArray(Z)){const me=[];for(const qe of Z)if(typeof qe=="number")me.push({column:n.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const be=qe;me.push({column:n.clampedInt(be.column,0,0,1e4),color:be.color})}return me.sort((qe,be)=>qe.column-be.column),me}return this.defaultValue}}class de extends D{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends D{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(100,null),w.localize(101,null),w.localize(102,null)],default:"auto",description:w.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(104,null),w.localize(105,null),w.localize(106,null)],default:"auto",description:w.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:w.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:w.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:w.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:w.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z,qe=n.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),be=n.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(me.vertical,this.defaultValue.vertical),horizontal:Ce(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:n.clampedInt(me.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:be,verticalSliderSize:n.clampedInt(me.verticalSliderSize,be,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Ue extends D{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:w.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:w.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:w.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:w.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:w.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:w.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:w.localize(118,null)}})}applyUpdate(Z,me){let qe=!1;me.allowedCharacters&&Z&&(M.$7n(Z.allowedCharacters,me.allowedCharacters)||(Z={...Z,allowedCharacters:me.allowedCharacters},qe=!0)),me.allowedLocales&&Z&&(M.$7n(Z.allowedLocales,me.allowedLocales)||(Z={...Z,allowedLocales:me.allowedLocales},qe=!0));const be=super.applyUpdate(Z,me);return qe?new d(be.newValue,!0):be}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,me){if(typeof Z!="object"||!Z)return me;const qe={};for(const[be,ot]of Object.entries(Z))ot===!0&&(qe[be]=!0);return qe}}class j extends D{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:w.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(120,null),w.localize(121,null),w.localize(122,null)],description:w.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:w.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:w.localize(125,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:f(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily)}}}class F extends D{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:w.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(127,null),w.localize(128,null),w.localize(129,null)],description:w.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:w.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:w.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:f(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class H extends D{constructor(){const Z={enabled:O.$4s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$4s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:w.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:w.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class G extends D{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(135,null),w.localize(136,null),w.localize(137,null)],default:Z.bracketPairs,description:w.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(139,null),w.localize(140,null),w.localize(141,null)],default:Z.bracketPairsHorizontal,description:w.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:w.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:w.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(145,null),w.localize(146,null),w.localize(147,null)],default:Z.highlightActiveIndentation,description:w.localize(148,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(X,Z,me){const qe=me.indexOf(X);return qe===-1?Z:me[qe]}class re extends D{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(149,null),w.localize(150,null)],default:Z.insertMode,description:w.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:w.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:w.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:w.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(155,null),w.localize(156,null),w.localize(157,null),w.localize(158,null)],default:Z.selectionMode,markdownDescription:w.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:w.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:w.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:w.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:w.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:w.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(196,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertMode:f(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:f(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Me extends D{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(198,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends D{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:w.localize(199,null),type:"string"},{description:w.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const me=[];for(const qe of Z)if(typeof qe=="string")try{Intl.Segmenter.supportedLocalesOf(qe).length>0&&me.push(qe)}catch{}return me}return this.defaultValue}}var He;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class _e extends D{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(201,null),w.localize(202,null),w.localize(203,null),w.localize(204,null)],description:w.localize(205,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,me,qe){return me.get(2)===2?0:qe}}class xe extends g{constructor(){super(146)}compute(Z,me,qe){const be=me.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:be.isWordWrapMinified,isViewportWrapping:be.isViewportWrapping,wrappingColumn:be.wrappingColumn}}}class et extends D{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:w.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(208,null),w.localize(209,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:f(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends D{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:w.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(212,null),w.localize(213,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:f(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?at:A.$k?gt:it,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(X){return e.editorOptionsRegistry[X.id]=X,X}var st;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSegmenterLocales=130]="wordSegmenterLocales",X[X.wordSeparators=131]="wordSeparators",X[X.wordWrap=132]="wordWrap",X[X.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=135]="wordWrapColumn",X[X.wordWrapOverride1=136]="wordWrapOverride1",X[X.wordWrapOverride2=137]="wordWrapOverride2",X[X.wrappingIndent=138]="wrappingIndent",X[X.wrappingStrategy=139]="wrappingStrategy",X[X.showDeprecated=140]="showDeprecated",X[X.inlayHints=141]="inlayHints",X[X.editorClassName=142]="editorClassName",X[X.pixelRatio=143]="pixelRatio",X[X.tabFocusMode=144]="tabFocusMode",X[X.layoutInfo=145]="layoutInfo",X[X.wrappingInfo=146]="wrappingInfo",X[X.defaultColorDecorators=147]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(214,null)})),acceptSuggestionOnEnter:je(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(215,null),""],markdownDescription:w.localize(216,null)})),accessibilitySupport:je(new S),accessibilityPageSize:je(new n(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new t(4,"ariaLabel",w.localize(218,null))),ariaRequired:je(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(220,null),w.localize(221,null),""],description:w.localize(222,null)})),autoClosingComments:je(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(223,null),w.localize(224,null),""],description:w.localize(225,null)})),autoClosingDelete:je(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(226,null),""],description:w.localize(227,null)})),autoClosingOvertype:je(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(228,null),""],description:w.localize(229,null)})),autoClosingQuotes:je(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(230,null),w.localize(231,null),""],description:w.localize(232,null)})),autoIndent:je(new $(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[w.localize(233,null),w.localize(234,null),w.localize(235,null),w.localize(236,null),w.localize(237,null)],description:w.localize(238,null)})),automaticLayout:je(new s(13,"automaticLayout",!1)),autoSurround:je(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(239,null),w.localize(240,null),w.localize(241,null),""],description:w.localize(242,null)})),bracketPairColorization:je(new H),bracketPairGuides:je(new G),stickyTabStops:je(new s(116,"stickyTabStops",!1,{description:w.localize(243,null)})),codeLens:je(new s(17,"codeLens",!0,{description:w.localize(244,null)})),codeLensFontFamily:je(new t(18,"codeLensFontFamily","",{description:w.localize(245,null)})),codeLensFontSize:je(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(246,null)})),colorDecorators:je(new s(20,"colorDecorators",!0,{description:w.localize(247,null)})),colorDecoratorActivatedOn:je(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(248,null),w.localize(249,null),w.localize(250,null)],description:w.localize(251,null)})),colorDecoratorsLimit:je(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(252,null)})),columnSelection:je(new s(22,"columnSelection",!1,{description:w.localize(253,null)})),comments:je(new h),contextmenu:je(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new s(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(254,null)})),cursorBlinking:je(new $(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:w.localize(255,null)})),cursorSmoothCaretAnimation:je(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(256,null),w.localize(257,null),w.localize(258,null)],description:w.localize(259,null)})),cursorStyle:je(new $(28,"cursorStyle",k.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:w.localize(260,null)})),cursorSurroundingLines:je(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(261,null)})),cursorSurroundingLinesStyle:je(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(262,null),w.localize(263,null)],markdownDescription:w.localize(264,null)})),cursorWidth:je(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(265,null)})),disableLayerHinting:je(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new s(34,"domReadOnly",!1)),dragAndDrop:je(new s(35,"dragAndDrop",!0,{description:w.localize(266,null)})),emptySelectionClipboard:je(new W),dropIntoEditor:je(new et),stickyScroll:je(new Ne),experimentalWhitespaceRendering:je(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(267,null),w.localize(268,null),w.localize(269,null)],description:w.localize(270,null)})),extraEditorClassName:je(new t(39,"extraEditorClassName","")),fastScrollSensitivity:je(new l(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:w.localize(271,null)})),find:je(new V),fixedOverflowWidgets:je(new s(42,"fixedOverflowWidgets",!1)),folding:je(new s(43,"folding",!0,{description:w.localize(272,null)})),foldingStrategy:je(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(273,null),w.localize(274,null)],description:w.localize(275,null)})),foldingHighlight:je(new s(45,"foldingHighlight",!0,{description:w.localize(276,null)})),foldingImportsByDefault:je(new s(46,"foldingImportsByDefault",!1,{description:w.localize(277,null)})),foldingMaximumRegions:je(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(279,null)})),fontFamily:je(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(280,null)})),fontInfo:je(new U),fontLigatures2:je(new q),fontSize:je(new K),fontWeight:je(new ie),fontVariations:je(new N),formatOnPaste:je(new s(55,"formatOnPaste",!1,{description:w.localize(281,null)})),formatOnType:je(new s(56,"formatOnType",!1,{description:w.localize(282,null)})),glyphMargin:je(new s(57,"glyphMargin",!0,{description:w.localize(283,null)})),gotoLocation:je(new ce),hideCursorInOverviewRuler:je(new s(59,"hideCursorInOverviewRuler",!1,{description:w.localize(284,null)})),hover:je(new ye),inDiffEditor:je(new s(61,"inDiffEditor",!1)),letterSpacing:je(new l(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>l.clamp(X,-5,20),{description:w.localize(285,null)})),lightbulb:je(new ae),lineDecorationsWidth:je(new z),lineHeight:je(new x),lineNumbers:je(new he),lineNumbersMinChars:je(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new s(70,"linkedEditing",!1,{description:w.localize(286,null)})),links:je(new s(71,"links",!0,{description:w.localize(287,null)})),matchBrackets:je(new a(72,"matchBrackets","always",["always","near","never"],{description:w.localize(288,null)})),minimap:je(new ve),mouseStyle:je(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new l(75,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:w.localize(289,null)})),mouseWheelZoom:je(new s(76,"mouseWheelZoom",!1,{markdownDescription:A.$j?w.localize(290,null):w.localize(291,null)})),multiCursorMergeOverlapping:je(new s(77,"multiCursorMergeOverlapping",!0,{description:w.localize(292,null)})),multiCursorModifier:je(new $(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Fe,{markdownEnumDescriptions:[w.localize(293,null),w.localize(294,null)],markdownDescription:w.localize(295,null)})),multiCursorPaste:je(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(296,null),w.localize(297,null)],markdownDescription:w.localize(298,null)})),multiCursorLimit:je(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(299,null)})),occurrencesHighlight:je(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[w.localize(300,null),w.localize(301,null),w.localize(302,null)],markdownDescription:w.localize(303,null)})),overviewRulerBorder:je(new s(82,"overviewRulerBorder",!0,{description:w.localize(304,null)})),overviewRulerLanes:je(new n(83,"overviewRulerLanes",3,0,3)),padding:je(new De),pasteAs:je(new tt),parameterHints:je(new we),peekWidgetDefaultFocus:je(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(305,null),w.localize(306,null)],description:w.localize(307,null)})),definitionLinkOpensInPeek:je(new s(88,"definitionLinkOpensInPeek",!1,{description:w.localize(308,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(309,null)})),readOnly:je(new s(91,"readOnly",!1)),readOnlyMessage:je(new de),renameOnType:je(new s(93,"renameOnType",!1,{description:w.localize(310,null),markdownDeprecationMessage:w.localize(311,null)})),renderControlCharacters:je(new s(94,"renderControlCharacters",!0,{description:w.localize(312,null),restricted:!0})),renderFinalNewline:je(new a(95,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:w.localize(313,null)})),renderLineHighlight:je(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(314,null)],description:w.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(316,null)})),renderValidationDecorations:je(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(317,null),w.localize(318,null),w.localize(319,null),""],description:w.localize(320,null)})),revealHorizontalRightPadding:je(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new s(101,"roundedSelection",!0,{description:w.localize(321,null)})),rulers:je(new Oe),scrollbar:je(new Ae),scrollBeyondLastColumn:je(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(322,null)})),scrollBeyondLastLine:je(new s(105,"scrollBeyondLastLine",!0,{description:w.localize(323,null)})),scrollPredominantAxis:je(new s(106,"scrollPredominantAxis",!0,{description:w.localize(324,null)})),selectionClipboard:je(new s(107,"selectionClipboard",!0,{description:w.localize(325,null),included:A.$k})),selectionHighlight:je(new s(108,"selectionHighlight",!0,{description:w.localize(326,null)})),selectOnLineNumbers:je(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(327,null),w.localize(328,null),w.localize(329,null)],description:w.localize(330,null)})),showUnused:je(new s(111,"showUnused",!0,{description:w.localize(331,null)})),showDeprecated:je(new s(140,"showDeprecated",!0,{description:w.localize(332,null)})),inlayHints:je(new ne),snippetSuggestions:je(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(333,null),w.localize(334,null),w.localize(335,null),w.localize(336,null)],description:w.localize(337,null)})),smartSelect:je(new Me),smoothScrolling:je(new s(114,"smoothScrolling",!1,{description:w.localize(338,null)})),stopRenderingLineAfter:je(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new re),inlineSuggest:je(new j),inlineEdit:je(new F),inlineCompletionsAccessibilityVerbose:je(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(339,null)})),suggestFontSize:je(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new s(121,"suggestOnTriggerCharacters",!0,{description:w.localize(342,null)})),suggestSelection:je(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(343,null),w.localize(344,null),w.localize(345,null)],description:w.localize(346,null)})),tabCompletion:je(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(347,null),w.localize(348,null),w.localize(349,null)],description:w.localize(350,null)})),tabIndex:je(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new Ue),unusualLineTerminators:je(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(351,null),w.localize(352,null),w.localize(353,null)],description:w.localize(354,null)})),useShadowDOM:je(new s(127,"useShadowDOM",!0)),useTabStops:je(new s(128,"useTabStops",!0,{description:w.localize(355,null)})),wordBreak:je(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(356,null),w.localize(357,null)],description:w.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new t(131,"wordSeparators",R.$5s,{description:w.localize(359,null)})),wordWrap:je(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(360,null),w.localize(361,null),w.localize(362,null),w.localize(363,null)],description:w.localize(364,null)})),wordWrapBreakAfterCharacters:je(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(365,null)})),wordWrapOverride1:je(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new P),defaultColorDecorators:je(new s(147,"defaultColorDecorators",!1,{markdownDescription:w.localize(366,null)})),pixelRatio:je(new ge),tabFocusMode:je(new s(144,"tabFocusMode",!1,{markdownDescription:w.localize(367,null)})),layoutInfo:je(new fe),wrappingInfo:je(new xe),wrappingIndent:je(new _e),wrappingStrategy:je(new $e)}}),define(Ie[160],Pe([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[161],Pe([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(Ie[162],Pe([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(Ie[163],Pe([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[164],Pe([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[165],Pe([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(Ie[166],Pe([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(Ie[167],Pe([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(Ie[168],Pe([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(Ie[169],Pe([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[170],Pe([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ie[171],Pe([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(Ie[172],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[173],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[174],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ie[175],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ie[176],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(Ie[177],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ie[178],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[179],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ie[180],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[181],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[182],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ie[183],Pe([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[184],Pe([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(Ie[185],Pe([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(Ie[186],Pe([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(Ie[187],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ie[188],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[189],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[190],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[191],Pe([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[192],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[193],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ie[194],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[195],Pe([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[196],Pe([1,0,14,162]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var A;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(A||(e.TokenType=A={}));function O(...E){switch(E.length){case 1:return(0,M.localize)(0,null,E[0]);case 2:return(0,M.localize)(1,null,E[0],E[1]);case 3:return(0,M.localize)(2,null,E[0],E[1],E[2]);default:return}}const R=(0,M.localize)(3,null),w=(0,M.localize)(4,null);class p{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const D=this.d,d=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:d};this.g.push({offset:D,lexeme:d,additionalInfo:T}),this.f.push(v)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const D=this.c.substring(this.d,this.e),d=p.b.get(D);d?this.k(d):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,D=!1,d=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(w);return}const g=this.c.charCodeAt(T);if(D)D=!1;else if(g===47&&!d){T++;break}else g===91?d=!0:g===92?D=!0:g===93&&(d=!1);T++}for(;T<this.c.length&&p.a.has(this.c.charCodeAt(T));)T++;this.e=T;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=p}),define(Ie[197],Pe([1,0,23,33,164,311]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=p,e.$Hp=E,e.$Ip=T,e.$Jp=D,e.$Kp=d,e.$Lp=v,e.$Mp=g;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function p(s){return s=s.trim(),s==="*"||R.test(s)}function E(s){if(!p(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function T(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,c=s.minorBase;let l=s.minorMustEqual;const t=s.patchBase;let f=s.patchMustEqual;s.hasCaret&&(i===0||(l=!1),f=!1);let a=0;if(s.preRelease){const $=w.exec(s.preRelease);if($){const[,u,S,h]=$;a=Date.UTC(Number(u),Number(S)-1,Number(h))}}return{majorBase:i,majorMustEqual:n,minorBase:c,minorMustEqual:l,patchBase:t,patchMustEqual:f,isMinimum:s.hasGreaterEquals,notBefore:a}}function D(s,i,n){let c;typeof s=="string"?c=T(E(s)):c=s;let l;i instanceof Date?l=i.getTime():typeof i=="string"&&(l=new Date(i).getTime());let t;if(typeof n=="string"?t=T(E(n)):t=n,!c||!t)return!1;const f=c.majorBase,a=c.minorBase,$=c.patchBase;let u=t.majorBase,S=t.minorBase,h=t.patchBase;const b=t.notBefore;let m=t.majorMustEqual,k=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?f>u?!0:f<u?!1:a>S?!0:a<S||l&&l<b?!1:$>=h:(f===1&&u===0&&(!m||!k||!y)&&(u=1,S=0,h=0,m=!0,k=!1,y=!1),f<u?!1:f>u?!m:a<S?!1:a>S?!k:$<h?!1:$>h?!y:!(l&&l<b))}function d(s,i,n,c,l){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([M.default.Error,A.localize(0,null)]),t;if(typeof c.name!="string")return t.push([M.default.Error,A.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([M.default.Error,A.localize(2,null,"version")]),t;if(!c.engines)return t.push([M.default.Error,A.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([M.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return t.push([M.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return t.push([M.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([M.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([M.default.Warning,A.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([M.default.Error,A.localize(9,null,"main")]),t;{const $=(0,I.$0g)(n,c.main);(0,I.$4g)($,n)||t.push([M.default.Warning,A.localize(10,null,$.path,n.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([M.default.Error,A.localize(11,null,"browser")]),t;{const $=(0,I.$0g)(n,c.browser);(0,I.$4g)($,n)||t.push([M.default.Warning,A.localize(12,null,$.path,n.path)])}}if(!O.valid(c.version))return t.push([M.default.Error,A.localize(13,null)]),t;const f=[];if(!v(s,i,c,l,f))for(const $ of f)t.push([M.default.Error,$]);return t}function v(s,i,n,c,l){return c||typeof n.main>"u"&&typeof n.browser>"u"?!0:r(s,i,n.engines.vscode,l)}function g(s,i,n){return s==="*"||r(i,n,s)}function r(s,i,n,c=[]){const l=T(E(n));if(!l)return c.push(A.localize(14,null,n)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return c.push(A.localize(15,null,n)),!1}else if(!l.majorMustEqual)return c.push(A.localize(16,null,n)),!1;return D(s,i,l)?!0:(c.push(A.localize(17,null,s,n)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Ie[71],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class I{constructor(A,O=[],R=!1){this.ctor=A,this.staticArguments=O,this.supportsDelayedInstantiation=R}}e.$ti=I}),define(Ie[56],Pe([1,0,71]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=O,e.$ys=R;const M=[];var A;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function O(w,p,E){p instanceof I.$ti||(p=new I.$ti(p,[],!!E)),M.push([w,p])}function R(){return M}}),define(Ie[198],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class I{constructor(O,R){this.key=O,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$ar=I;class M{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const R of this.a.values())R.outgoing.size===0&&O.push(R);return O}insertEdge(O,R){const w=this.lookupOrInsertNode(O),p=this.lookupOrInsertNode(R);w.outgoing.set(p.key,p),p.incoming.set(w.key,w)}removeNode(O){const R=this.b(O);this.a.delete(R);for(const w of this.a.values())w.outgoing.delete(R),w.incoming.delete(R)}lookupOrInsertNode(O){const R=this.b(O);let w=this.a.get(R);return w||(w=new I(R,O),this.a.set(R,w)),w}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[R,w]of this.a)O.push(`${R}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,R]of this.a){const w=new Set([O]),p=this.c(R,w);if(p)return p}}c(O,R){for(const[w,p]of O.outgoing){if(R.has(w))return[...R,w].join(" -> ");R.add(w);const E=this.c(p,R);if(E)return E;R.delete(w)}}}e.$br=M}),define(Ie[3],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=A,e.$xi=O;var I;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function w(p){return p[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=w})(I||(e._util=I={})),e.$vi=A("instantiationService");function M(R,w,p){w[I.DI_TARGET]===w?w[I.DI_DEPENDENCIES].push({id:R,index:p}):(w[I.DI_DEPENDENCIES]=[{id:R,index:p}],w[I.DI_TARGET]=w)}function A(R){if(I.serviceIds.has(R))return I.serviceIds.get(R);const w=function(p,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(w,p,T)};return w.toString=()=>R,I.serviceIds.set(R,w),w}function O(R){return R}}),define(Ie[50],Pe([1,0,15,2,3]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=O,e.$5i=R,e.$6i=p,e.$7i=E,e.$8i=T,e.$9i=D,e.$0i=d,e.$$i=g,e.$_i=r,e.$aj=o,e.$3i=(0,A.$wi)("configurationService");function O(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof M.URI)}function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof M.URI)}var w;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function p(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function T(s,i){const n=Object.create(null);for(const c in s)D(n,c,s[c],i);return n}function D(s,i,n,c){const l=i.split("."),t=l.pop();let f=s;for(let a=0;a<l.length;a++){const $=l[a];let u=f[$];switch(typeof u){case"undefined":u=f[$]=Object.create(null);break;case"object":if(u===null){c(`Ignoring ${i} as ${l.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${i} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(u)}`);return}f=u}if(typeof f=="object"&&f!==null)try{f[t]=n}catch{c(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(f)}`)}else c(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(f)}`)}function d(s,i){const n=i.split(".");v(s,n)}function v(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const c=s[n];typeof c=="object"&&!Array.isArray(c)&&(v(c,i),Object.keys(c).length===0&&delete s[n])}}function g(s,i,n){function c(f,a){let $=f;for(const u of a){if(typeof $!="object"||$===null)return;$=$[u]}return $}const l=i.split("."),t=c(s,l);return typeof t>"u"?n:t}function r(s,i,n){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in s?I.$$f(s[c])&&I.$$f(i[c])?r(s[c],i[c],n):n&&(s[c]=i[c]):s[c]=i[c])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Ie[31],Pe([1,0,22,13,196,3,161,14]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=E,e.$vj=f,e.$wj=a,e.$Pj=Te;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",I.$j),p.set("isLinux",I.$k),p.set("isWindows",I.$i),p.set("isWeb",I.$o),p.set("isMacNative",I.$j&&!I.$o),p.set("isEdge",I.$H),p.set("isFirefox",I.$F),p.set("isChrome",I.$E),p.set("isSafari",I.$G);function E(ne,z){if(p.get(ne)!==void 0)throw(0,w.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(ne,z)}const T=Object.prototype.hasOwnProperty;var D;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const d={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),g=(0,R.localize)(1,null),r=(0,R.localize)(2,null),o=(0,R.localize)(3,null),s=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=d){this.k=z,this.d=new A.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const ve=this.D(),Fe=ve.type===17?i:void 0;throw this.h.push({message:s,offset:ve.offset,lexeme:A.$rj.getLexeme(ve),additionalInfo:Fe}),l.c}return x}catch(x){if(x!==l.c)throw x;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const x=this.o();z.push(x)}return z.length===1?z[0]:t.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const x=this.s();z.push(x)}return z.length===1?z[0]:t.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),S.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),C.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=z.lexeme;if(this.z(),this.y(9)){const Fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Fe.type!==10)throw this.B("REGEX",Fe);const De=Fe.lexeme,we=De.lastIndexOf("/"),ge=we===De.length-1?void 0:this.w(De.substring(we+1));let Q;try{Q=new RegExp(De.substring(1,we),ge)}catch{throw this.B("REGEX",Fe)}return U.create(x,Q)}switch(Fe.type){case 10:case 19:{const De=[Fe.lexeme];this.z();let we=this.D(),ge=0;for(let Oe=0;Oe<Fe.lexeme.length;Oe++)Fe.lexeme.charCodeAt(Oe)===40?ge++:Fe.lexeme.charCodeAt(Oe)===41&&ge--;for(;!this.E()&&we.type!==15&&we.type!==16;){switch(we.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Oe=0;Oe<we.lexeme.length;Oe++)we.lexeme.charCodeAt(Oe)===40?ge++:Fe.lexeme.charCodeAt(Oe)===41&&ge--}if(ge<0)break;De.push(A.$rj.getLexeme(we)),this.z(),we=this.D()}const Q=De.join(""),Y=Q.lastIndexOf("/"),he=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let ue;try{ue=new RegExp(Q.substring(1,Y),he)}catch{throw this.B("REGEX",Fe)}return t.regex(x,ue)}case 18:{const De=Fe.lexeme;this.z();let we=null;if(!(0,M.$8e)(De)){const ge=De.indexOf("/"),Q=De.lastIndexOf("/");if(ge!==Q&&ge>=0){const Y=De.slice(ge+1,Q),he=De[Q+1]==="i"?"i":"";try{we=new RegExp(Y,he)}catch{throw this.B("REGEX",Fe)}}}if(we===null)throw this.B("REGEX",Fe);return U.create(x,we)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Fe=this.u();return t.notIn(x,Fe)}switch(this.D().type){case 3:{this.z();const Fe=this.u();if(this.x().type===18)return t.equals(x,Fe);switch(Fe){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Fe)}}case 4:{this.z();const Fe=this.u();if(this.x().type===18)return t.notEquals(x,Fe);switch(Fe){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Fe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),N.create(x,this.u());case 7:return this.z(),W.create(x,this.u());case 8:return this.z(),V.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:n,offset:z.offset,lexeme:"",additionalInfo:c}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,x){if(this.C(z))return this.z();throw this.B(x,this.D())}B(z,x,ve){const Fe=(0,R.localize)(8,null,z,A.$rj.getLexeme(x)),De=x.offset,we=A.$rj.getLexeme(x);return this.h.push({message:Fe,offset:De,lexeme:we,additionalInfo:ve}),l.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=l;class t{static false(){return u.INSTANCE}static true(){return S.INSTANCE}static has(z){return h.create(z)}static equals(z,x){return b.create(z,x)}static notEquals(z,x){return y.create(z,x)}static regex(z,x){return U.create(z,x)}static in(z,x){return m.create(z,x)}static notIn(z,x){return k.create(z,x)}static not(z){return C.create(z)}static and(...z){return ce.create(z,null,!0)}static or(...z){return ye.create(z,null,!0)}static greater(z,x){return W.create(z,x)}static greaterEquals(z,x){return V.create(z,x)}static smaller(z,x){return q.create(z,x)}static smallerEquals(z,x){return N.create(z,x)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$uj=t;function f(ne){const z=new l({regexParsingWithErrorRecovery:!1});return ne.map(x=>(z.parse(x),z.lexingErrors.length>0?z.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,R.localize)(9,null,ve.additionalInfo):(0,R.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function a(ne,z){const x=ne?ne.substituteConstants():void 0,ve=z?z.substituteConstants():void 0;return!x&&!ve?!0:!x||!ve?!1:x.equals(ve)}function $(ne,z){return ne.cmp(z)}class u{static{this.INSTANCE=new u}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return S.INSTANCE}}e.$xj=u;class S{static{this.INSTANCE=new S}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return u.INSTANCE}}e.$yj=S;class h{static create(z,x=null){const ve=p.get(z);return typeof ve=="boolean"?ve?S.INSTANCE:u.INSTANCE:new h(z,x)}constructor(z,x){this.key=z,this.c=x,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=p.get(this.key);return typeof z=="boolean"?z?S.INSTANCE:u.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$zj=h;class b{static create(z,x,ve=null){if(typeof x=="boolean")return x?h.create(z,ve):C.create(z,ve);const Fe=p.get(z);return typeof Fe=="boolean"?x===(Fe?"true":"false")?S.INSTANCE:u.INSTANCE:new b(z,x,ve)}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=p.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?S.INSTANCE:u.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Aj=b;class m{static create(z,x){return new m(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.f),ve=z.getValue(this.d);return Array.isArray(x)?x.includes(ve):typeof ve=="string"&&typeof x=="object"&&x!==null?T.call(x,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Bj=m;class k{static create(z,x){return new k(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=11,this.c=m.create(z,x)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=k;class y{static create(z,x,ve=null){if(typeof x=="boolean")return x?C.create(z,ve):h.create(z,ve);const Fe=p.get(z);return typeof Fe=="boolean"?x===(Fe?"true":"false")?u.INSTANCE:S.INSTANCE:new y(z,x,ve)}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=p.get(this.c);if(typeof z=="boolean"){const x=z?"true":"false";return this.d===x?u.INSTANCE:S.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Dj=y;class C{static create(z,x=null){const ve=p.get(z);return typeof ve=="boolean"?ve?u.INSTANCE:S.INSTANCE:new C(z,x)}constructor(z,x){this.c=z,this.d=x,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:fe(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=p.get(this.c);return typeof z=="boolean"?z?u.INSTANCE:S.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.$Ej=C;function P(ne,z){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?z(ne):u.INSTANCE}class W{static create(z,x,ve=null){return P(x,Fe=>new W(z,Fe,ve))}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Fj=W;class V{static create(z,x,ve=null){return P(x,Fe=>new V(z,Fe,ve))}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Gj=V;class q{static create(z,x,ve=null){return P(x,Fe=>new q(z,Fe,ve))}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Hj=q;class N{static create(z,x,ve=null){return P(x,Fe=>new N(z,Fe,ve))}constructor(z,x,ve){this.c=z,this.d=x,this.f=ve,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:$e(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Ij=N;class U{static create(z,x){return new U(z,x)}constructor(z,x){this.d=z,this.f=x,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const x=this.f?this.f.source:"",ve=z.f?z.f.source:"";return x<ve?-1:x>ve?1:0}equals(z){if(z.type===this.type){const x=this.f?this.f.source:"",ve=z.f?z.f.source:"";return this.d===z.d&&x===ve}return!1}substituteConstants(){return this}evaluate(z){const x=z.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Jj=U;class K{static create(z){return new K(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new K(this.c.map(z))}negate(){return this.c}}e.$Kj=K;function ie(ne){let z=null;for(let x=0,ve=ne.length;x<ve;x++){const Fe=ne[x].substituteConstants();if(ne[x]!==Fe&&z===null){z=[];for(let De=0;De<x;De++)z[De]=ne[De]}z!==null&&(z[x]=Fe)}return z===null?ne:z}class ce{static create(z,x,ve){return ce.d(z,x,ve)}constructor(z,x){this.expr=z,this.c=x,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Fe=$(this.expr[x],z.expr[x]);if(Fe!==0)return Fe}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=ie(this.expr);return z===this.expr?this:ce.create(z,this.c,!1)}evaluate(z){for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].evaluate(z))return!1;return!0}static d(z,x,ve){const Fe=[];let De=!1;for(const we of z)if(we){if(we.type===1){De=!0;continue}if(we.type===0)return u.INSTANCE;if(we.type===6){Fe.push(...we.expr);continue}Fe.push(we)}if(Fe.length===0&&De)return S.INSTANCE;if(Fe.length!==0){if(Fe.length===1)return Fe[0];Fe.sort($);for(let we=1;we<Fe.length;we++)Fe[we-1].equals(Fe[we])&&(Fe.splice(we,1),we--);if(Fe.length===1)return Fe[0];for(;Fe.length>1;){const we=Fe[Fe.length-1];if(we.type!==9)break;Fe.pop();const ge=Fe.pop(),Q=Fe.length===0,Y=ye.create(we.expr.map(he=>ce.create([he,ge],null,ve)),null,Q);Y&&(Fe.push(Y),Fe.sort($))}if(Fe.length===1)return Fe[0];if(ve){for(let we=0;we<Fe.length;we++)for(let ge=we+1;ge<Fe.length;ge++)if(Fe[we].negate().equals(Fe[ge]))return u.INSTANCE;if(Fe.length===1)return Fe[0]}return new ce(Fe,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ce(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());this.c=ye.create(z,this,!0)}return this.c}}e.$Lj=ce;class ye{static create(z,x,ve){return ye.d(z,x,ve)}constructor(z,x){this.expr=z,this.c=x,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Fe=$(this.expr[x],z.expr[x]);if(Fe!==0)return Fe}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(z.expr[x]))return!1;return!0}return!1}substituteConstants(){const z=ie(this.expr);return z===this.expr?this:ye.create(z,this.c,!1)}evaluate(z){for(let x=0,ve=this.expr.length;x<ve;x++)if(this.expr[x].evaluate(z))return!0;return!1}static d(z,x,ve){let Fe=[],De=!1;if(z){for(let we=0,ge=z.length;we<ge;we++){const Q=z[we];if(Q){if(Q.type===0){De=!0;continue}if(Q.type===1)return S.INSTANCE;if(Q.type===9){Fe=Fe.concat(Q.expr);continue}Fe.push(Q)}}if(Fe.length===0&&De)return u.INSTANCE;Fe.sort($)}if(Fe.length!==0){if(Fe.length===1)return Fe[0];for(let we=1;we<Fe.length;we++)Fe[we-1].equals(Fe[we])&&(Fe.splice(we,1),we--);if(Fe.length===1)return Fe[0];if(ve){for(let we=0;we<Fe.length;we++)for(let ge=we+1;ge<Fe.length;ge++)if(Fe[we].negate().equals(Fe[ge]))return S.INSTANCE;if(Fe.length===1)return Fe[0]}return new ye(Fe,x)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const x of this.expr)z.push(...x.keys());return z}map(z){return new ye(this.expr.map(x=>x.map(z)),null)}negate(){if(!this.c){const z=[];for(const x of this.expr)z.push(x.negate());for(;z.length>1;){const x=z.shift(),ve=z.shift(),Fe=[];for(const De of Ne(x))for(const we of Ne(ve))Fe.push(ce.create([De,we],null,!1));z.unshift(ye.create(Fe,null,!1))}this.c=ye.create(z,this,!0)}return this.c}}e.$Mj=ye;class Se extends h{static{this.d=[]}static all(){return Se.d.values()}constructor(z,x,ve){super(z,null),this.f=x,typeof ve=="object"?Se.d.push({...ve,key:z}):ve!==!0&&Se.d.push({key:z,description:ve,type:x!=null?typeof x:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return b.create(this.key,z)}notEqualsTo(z){return y.create(this.key,z)}}e.$Nj=Se,e.$Oj=(0,O.$wi)("contextKeyService");function fe(ne,z){return ne<z?-1:ne>z?1:0}function $e(ne,z,x,ve){return ne<x?-1:ne>x?1:z<ve?-1:z>ve?1:0}function Te(ne,z){if(ne.type===0||z.type===1)return!0;if(ne.type===9)return z.type===9?ae(ne.expr,z.expr):!1;if(z.type===9){for(const x of z.expr)if(Te(ne,x))return!0;return!1}if(ne.type===6){if(z.type===6)return ae(z.expr,ne.expr);for(const x of ne.expr)if(Te(x,z))return!0;return!1}return ne.equals(z)}function ae(ne,z){let x=0,ve=0;for(;x<ne.length&&ve<z.length;){const Fe=ne[x].cmp(z[ve]);if(Fe<0)return!1;Fe===0&&x++,ve++}return x===ne.length}function Ne(ne){return ne.type===9?ne.expr:[ne]}}),define(Ie[99],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,I.$wi)("environmentService"),e.$Ei=(0,I.$xi)(e.$Di)}),define(Ie[100],Pe([1,0,163,3]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=A,e.$1o=O,e.$2o=R,e.$3o=w,e.$4o=p,e.$5o=E,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function A(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function w(i,n){return n==="web"&&!i.includes("web")}function p(i,n,c){return w(n,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var T;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var D;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var d;(function(i){i.Install="install",i.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var v;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$6o=(0,M.$wi)("extensionGalleryService");var g;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));class r extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$7o=r;var o;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class s extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$8o=s,e.$9o=(0,M.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,M.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,M.$wi)("IExtensionTipsService"),e.$bp=(0,I.localize2)(0,"Extensions"),e.$cp=(0,I.localize2)(1,"Preferences")}),define(Ie[38],Pe([1,0,54,19,13,15,2,165,3,22,16,43]),function(le,e,I,M,A,O,R,w,p,E,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=d,e.$5k=o,e.$6k=i,e.$7k=n,e.$8k=c,e.$9k=l,e.$0k=t,e.$$k=f,e.$_k=a,e.$al=$,e.$bl=u,e.$dl=b,e.$el=m,e.$fl=k,e.$gl=y,e.$hl=C,e.$kl=N,e.$wl=Se,e.$xl=fe,e.$zl=Te,e.$3k=(0,p.$wi)("fileService");function d(ae){return ae.create===!0}var v;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var g;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(g||(e.FilePermission=g={}));var r;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(ae){const Ne=ae;return!!Ne&&typeof Ne.onDidChange=="function"}var s;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function i(ae){return!!(ae.capabilities&2)}function n(ae){return!!(ae.capabilities&8)}function c(ae){return!!(ae.capabilities&131072)}function l(ae){return!!(ae.capabilities&4)}function t(ae){return!!(ae.capabilities&16)}function f(ae){return i(ae)?!!(ae.capabilities&16384):!1}function a(ae){return i(ae)?!!(ae.capabilities&32768):!1}function $(ae){return!!(ae.capabilities&65536)}function u(ae){return!!(ae.capabilities&2048)}var S;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class h extends Error{static create(Ne,ne){const z=new h(Ne.toString(),ne);return k(z,ne),z}constructor(Ne,ne){super(Ne),this.code=ne}}e.$cl=h;function b(ae,Ne){return h.create(ae,Ne)}function m(ae){return ae||b((0,w.localize)(0,null),S.Unknown)}function k(ae,Ne){return ae.name=Ne?`${Ne} (FileSystemError)`:"FileSystemError",ae}function y(ae){if(!ae)return S.Unknown;if(ae instanceof h)return ae.code;const Ne=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Ne)return S.Unknown;switch(Ne[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function C(ae){if(ae instanceof U)return ae.fileOperationResult;switch(y(ae)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 9;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileTooLarge:return 7;default:return 10}}var P;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class W{constructor(Ne,ne,z){this.resource=Ne,this.operation=ne,this.target=z}isOperation(Ne){return this.operation===Ne}}e.$il=W;var V;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class q{static{this.a=null}constructor(Ne,ne){this.c=ne,this.b=void 0,this.d=new D.$V(()=>{const z=I.$Ci.forUris(()=>this.c);return z.fill(this.rawAdded.map(x=>[x,!0])),z}),this.f=new D.$V(()=>{const z=I.$Ci.forUris(()=>this.c);return z.fill(this.rawUpdated.map(x=>[x,!0])),z}),this.g=new D.$V(()=>{const z=I.$Ci.forUris(()=>this.c);return z.fill(this.rawDeleted.map(x=>[x,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of Ne){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==q.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Ne,...ne){return this.h(Ne,{includeChildren:!1},...ne)}affects(Ne,...ne){return this.h(Ne,{includeChildren:!0},...ne)}h(Ne,ne,...z){if(!Ne)return!1;const x=z.length>0;return!!((!x||z.includes(1))&&(this.d.value.get(Ne)||ne.includeChildren&&this.d.value.findSuperstr(Ne))||(!x||z.includes(0))&&(this.f.value.get(Ne)||ne.includeChildren&&this.f.value.findSuperstr(Ne))||(!x||z.includes(2))&&(this.g.value.findSubstr(Ne)||ne.includeChildren&&this.g.value.findSuperstr(Ne)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ne){return this.b===Ne}hasCorrelation(){return typeof this.b=="number"}}e.$jl=q;function N(ae,Ne,ne){return!ae||!Ne||ae===Ne||Ne.length>ae.length?!1:(Ne.charAt(Ne.length-1)!==M.sep&&(Ne+=M.sep),ne?(0,A.$zf)(ae,Ne):ae.indexOf(Ne)===0)}class U extends Error{constructor(Ne,ne,z){super(Ne),this.fileOperationResult=ne,this.options=z}}e.$ll=U;class K extends U{constructor(Ne,ne,z,x){super(Ne,ne,x),this.fileOperationResult=ne,this.size=z}}e.$ml=K;class ie extends U{constructor(Ne,ne,z){super(Ne,2,z),this.stat=ne}}e.$nl=ie;var ce;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var ye;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(e.FileKind=ye={})),e.$vl="";function Se(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function fe(ae,Ne){if(!Ne.hasProvider(R.URI.from({scheme:ae.scheme})))return new Promise(ne=>{const z=Ne.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===ae.scheme&&x.added&&(z.dispose(),ne())})})}class $e{static{this.KB=1024}static{this.MB=$e.KB*$e.KB}static{this.GB=$e.MB*$e.KB}static{this.TB=$e.GB*$e.KB}static formatSize(Ne){return(0,O.$ag)(Ne)||(Ne=0),Ne<$e.KB?(0,w.localize)(1,null,Ne.toFixed(0)):Ne<$e.MB?(0,w.localize)(2,null,(Ne/$e.KB).toFixed(2)):Ne<$e.GB?(0,w.localize)(3,null,(Ne/$e.MB).toFixed(2)):Ne<$e.TB?(0,w.localize)(4,null,(Ne/$e.GB).toFixed(2)):(0,w.localize)(5,null,(Ne/$e.TB).toFixed(2))}}e.$yl=$e;function Te(ae){const Ne=typeof ae=="string"||ae?.scheme===T.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===T.Schemas.file?1024*$e.MB:Ne?10*$e.MB:E.$o?50*$e.MB:1024*$e.MB}}),define(Ie[72],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class I{constructor(...A){this.a=new Map;for(const[O,R]of A)this.set(O,R)}set(A,O){const R=this.a.get(A);return this.a.set(A,O),R}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$ui=I}),define(Ie[199],Pe([1,0,11,14,6,71,198,3,72,200]),function(le,e,I,M,A,O,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const T=!1;class D extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class d{constructor(o=new p.$ui,s=!1,i,n=T){this.i=o,this.j=s,this.k=i,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(w.$vi,this),this._globalGraph=n?i?._globalGraph??new R.$br(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Qc)(this.h),this.h.clear();for(const o of this.g)(0,A.$Pc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const s=new class extends d{dispose(){this.h.delete(s),super.dispose()}}(o,this.j,this,this.l);return this.h.add(s),s}invokeFunction(o,...s){this.m();const i=g.traceInvocation(this.l,o);let n=!1;try{return o({get:l=>{if(n)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(l,i);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(o,...s){this.m();let i,n;return o instanceof O.$ti?(i=g.traceCreation(this.l,o.ctor),n=this.o(o.ctor,o.staticArguments.concat(s),i)):(i=g.traceCreation(this.l,o),n=this.o(o,s,i)),i.stop(),n}o(o,s=[],i){const n=w._util.getServiceDependencies(o).sort((t,f)=>t.index-f.index),c=[];for(const t of n){const f=this.s(t.id,i);f||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(f)}const l=n.length>0?n[0].index:s.length;if(s.length!==l){console.trace(`[createInstance] First service dependency of ${o.name} at position ${l+1} conflicts with ${s.length} static arguments`);const t=l-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,l)}return Reflect.construct(o,s.concat(c))}q(o,s){if(this.i.get(o)instanceof O.$ti)this.i.set(o,s);else if(this.k)this.k.q(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const s=this.i.get(o);return!s&&this.k?this.k.r(o):s}s(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const i=this.r(o);return i instanceof O.$ti?this.u(o,i,s.branch(o,!0)):(s.branch(o,!1),i)}u(o,s,i){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,s,i)}finally{this.t.delete(o)}}v(o,s,i){const n=new R.$br(t=>t.id.toString());let c=0;const l=[{id:o,desc:s,_trace:i}];for(;l.length;){const t=l.pop();if(n.lookupOrInsertNode(t),c++>1e3)throw new D(n);for(const f of w._util.getServiceDependencies(t.desc.ctor)){const a=this.r(f.id);if(a||this.y(`[createInstance] ${o} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),a instanceof O.$ti){const $={id:f.id,desc:a,_trace:t._trace.branch(f.id,!0)};n.insertEdge(t,$),l.push($)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new D(n);break}for(const{data:f}of t){if(this.r(f.id)instanceof O.$ti){const $=this.w(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.q(f.id,$)}n.removeNode(f)}}return this.r(o)}w(o,s,i=[],n,c){if(this.i.get(o)instanceof O.$ti)return this.x(o,s,i,n,c,this.g);if(this.k)return this.k.w(o,s,i,n,c);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}x(o,s,i=[],n,c,l){if(n){const t=new d(void 0,this.j,this,this.l);t.c=String(o);const f=new Map,a=new I.$Ph(()=>{const $=t.o(s,i,c);for(const[u,S]of f){const h=$[u];if(typeof h=="function")for(const b of S)b.disposable=h.apply($,b.listener)}return f.clear(),l.add($),$});return new Proxy(Object.create(null),{get($,u){if(!a.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let b=f.get(u);return b||(b=new E.$6c,f.set(u,b)),(k,y,C)=>{if(a.isInitialized)return a.value[u](k,y,C);{const P={listener:[k,y,C],disposable:void 0},W=b.push(P);return(0,A.$Tc)(()=>{W(),P.disposable?.dispose()})}}}if(u in $)return $[u];const S=a.value;let h=S[u];return typeof h!="function"||(h=h.bind(S),$[u]=h),h},set($,u,S){return a.value[u]=S,!0},getPrototypeOf($){return s.prototype}})}else{const t=this.o(s,i,c);return l.add(t),t}}y(o,s){if(s&&console.warn(o),this.j)throw new Error(o)}}e.$cr=d;var v;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(v||(v={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new g(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(o,s){return o?new g(1,s.name):g.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const i=new g(3,o.toString());return this.h.push([o,s,i]),i}stop(){const o=Date.now()-this.g;g.f+=o;let s=!1;function i(c,l){const t=[],f=new Array(c+1).join("	");for(const[a,$,u]of l.h)if($&&u){s=!0,t.push(`${f}CREATES -> ${a}`);const S=i(c+1,u);S&&t.push(S)}else t.push(`${f}uses -> ${a}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(o>2||s)&&g.all.add(n.join(`
`))}}e.$dr=g}),define(Ie[12],Pe([1,0,166,44,5,73,6,28,22,23,15,2,31,3]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=r,e.log=s,e.$ek=h,e.$fk=b,e.$gk=m,e.$hk=k,e.$3j=(0,v.$wi)("logService"),e.$4j=(0,v.$wi)("loggerService");function g(){return new Date().toISOString()}function r(y){return(0,T.$ag)(y)}var o;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$6j=o.Info;function s(y,C,P){switch(C){case o.Trace:y.trace(P);break;case o.Debug:y.debug(P);break;case o.Info:y.info(P);break;case o.Warning:y.warn(P);break;case o.Error:y.error(P);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function i(y,C=!1){let P="";for(let W=0;W<y.length;W++){let V=y[W];if(V instanceof Error&&(V=(0,M.$hj)(V,C)),typeof V=="object")try{V=JSON.stringify(V)}catch{}P+=(W>0?" ":"")+V}return P}class n extends R.$Vc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new A.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$8j=n;class c extends n{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...P){this.f(o.Trace)&&this.g(o.Trace,i([C,...P],!0))}debug(C,...P){this.f(o.Debug)&&this.g(o.Debug,i([C,...P]))}info(C,...P){this.f(o.Info)&&this.g(o.Info,i([C,...P]))}warn(C,...P){this.f(o.Warning)&&this.g(o.Warning,i([C,...P]))}error(C,...P){if(this.f(o.Error))if(C instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=C.stack,this.g(o.Error,i(W))}else this.g(o.Error,i([C,...P]))}flush(){}}e.$9j=c;class l extends n{constructor(C=e.$6j){super(),this.setLevel(C),this.g=!p.$i}trace(C,...P){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,C,...P):console.log(`[main ${g()}]`,C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,C,...P):console.log(`[main ${g()}]`,C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,C,...P):console.log(`[main ${g()}]`,C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,C,...P):console.warn(`[main ${g()}]`,C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,C,...P):console.error(`[main ${g()}]`,C,...P))}flush(){}}e.$0j=l;class t extends n{constructor(C=e.$6j,P=!0){super(),this.g=P,this.setLevel(C)}trace(C,...P){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...P):console.log(C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...P):console.log(C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...P):console.log(C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...P):console.log(C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...P):console.error(C,...P))}flush(){}}e.$$j=t;class f extends n{constructor(C,P=e.$6j){super(),this.g=C,this.setLevel(P)}trace(C,...P){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...P])}debug(C,...P){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...P])}info(C,...P){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...P])}warn(C,...P){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...P])}error(C,...P){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...P])}h(C){return typeof C=="string"?C:(0,M.$hj)(C,this.f(o.Trace))}flush(){}}e.$_j=f;class a extends n{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const P of this.g)P.setLevel(C);super.setLevel(C)}trace(C,...P){for(const W of this.g)W.trace(C,...P)}debug(C,...P){for(const W of this.g)W.debug(C,...P)}info(C,...P){for(const W of this.g)W.info(C,...P)}warn(C,...P){for(const W of this.g)W.warn(C,...P)}error(C,...P){for(const W of this.g)W.error(C,...P)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ak=a;class $ extends R.$Vc{constructor(C,P,W){if(super(),this.h=C,this.j=P,this.b=new w.$Bc,this.c=this.B(new A.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$ee),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(C){return(0,T.$9f)(C)?[...this.b.values()].find(P=>P.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,P){const W=this.n(C),V=(0,T.$9f)(C)?C:P?.id??(0,O.$kj)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const N=P?.logLevel==="always"?o.Trace:P?.logLevel;q||(q=this.s(W,N??this.getLogLevel(W)??this.h,{...P,id:V}));const U={logger:q,info:{resource:W,id:V,logLevel:N,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(U.info),this.b.set(W,U),q}n(C){return(0,T.$9f)(C)?(0,E.$0g)(this.j,`${C}.log`):C}setLogLevel(C,P){if(D.URI.isUri(C)){const W=C,V=P,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=C;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,P){const W=this.m(C);W&&P!==!W.info.hidden&&(W.info.hidden=!P,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,P]))}getLogLevel(C){let P;return C&&(P=this.b.get(C)?.info.logLevel),P??this.h}registerLogger(C){const P=this.b.get(C.resource);P?P.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const P=this.b.get(C);P&&(P.logger&&P.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=$;class u{constructor(){this.onDidChangeLogLevel=new A.$ee().event}setLevel(C){}getLevel(){return o.Info}trace(C,...P){}debug(C,...P){}info(C,...P){}warn(C,...P){}error(C,...P){}critical(C,...P){}dispose(){}flush(){}}e.$ck=u;class S extends u{}e.$dk=S;function h(y){if(y.verbose)return o.Trace;if(typeof y.logLevel=="string"){const C=k(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$6j}function b(y){switch(y){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function m(y){switch(y){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function k(y){switch(y){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$ik=new d.$Nj("logLevel",b(o.Info))}),define(Ie[201],Pe([1,0,6,12]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OQ=void 0;class A extends I.$Vc{constructor(R,w=[]){super(),this.a=new M.$ak([R,...w]),this.B(R.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...w){this.a.trace(R,...w)}debug(R,...w){this.a.debug(R,...w)}info(R,...w){this.a.info(R,...w)}warn(R,...w){this.a.warn(R,...w)}error(R,...w){this.a.error(R,...w)}flush(){this.a.flush()}}e.$OQ=A}),define(Ie[101],Pe([1,0,33,167,3]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var R;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(p){function E(g,r){return r-g}p.compare=E;const T=Object.create(null);T[p.Error]=(0,M.localize)(0,null),T[p.Warning]=(0,M.localize)(1,null),T[p.Info]=(0,M.localize)(2,null);function D(g){return T[g]||""}p.toString=D;function d(g){switch(g){case I.default.Error:return p.Error;case I.default.Warning:return p.Warning;case I.default.Info:return p.Info;case I.default.Ignore:return p.Hint}}p.fromSeverity=d;function v(g){switch(g){case p.Error:return I.default.Error;case p.Warning:return I.default.Warning;case p.Info:return I.default.Info;case p.Hint:return I.default.Ignore}}p.toSeverity=v}(R||(e.MarkerSeverity=R={}));var w;(function(p){const E="";function T(d){return D(d,!0)}p.makeKey=T;function D(d,v){const g=[E];return d.source?g.push(d.source.replace("\xA6","\\\xA6")):g.push(E),d.code?typeof d.code=="string"?g.push(d.code.replace("\xA6","\\\xA6")):g.push(d.code.value.replace("\xA6","\\\xA6")):g.push(E),d.severity!==void 0&&d.severity!==null?g.push(R.toString(d.severity)):g.push(E),d.message&&v?g.push(d.message.replace("\xA6","\\\xA6")):g.push(E),d.startLineNumber!==void 0&&d.startLineNumber!==null?g.push(d.startLineNumber.toString()):g.push(E),d.startColumn!==void 0&&d.startColumn!==null?g.push(d.startColumn.toString()):g.push(E),d.endLineNumber!==void 0&&d.endLineNumber!==null?g.push(d.endLineNumber.toString()):g.push(E),d.endColumn!==void 0&&d.endColumn!==null?g.push(d.endColumn.toString()):g.push(E),g.push(E),g.join("\xA6")}p.makeKeyOptionalMessage=D})(w||(e.IMarkerData=w={})),e.$7t=(0,A.$wi)("markerService")}),define(Ie[202],Pe([1,0,5,33,3]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$4v=e.Severity=void 0,e.$5v=w,e.Severity=M.default,e.$4v=(0,A.$wi)("notificationService");var O;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var R;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function w(D){if(D){const d=D;return typeof d.id=="string"&&typeof d.label=="string"}return!1}var p;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class E{constructor(){this.progress=new T,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(d){}updateMessage(d){}updateActions(d){}close(){}}e.$6v=E;class T{infinite(){}done(){}total(d){}worked(d){}}e.$7v=T}),define(Ie[102],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,I.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(le,e,I,M){var A=arguments.length,O=A<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,I):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(le,e,I,M);else for(var w=le.length-1;w>=0;w--)(R=le[w])&&(O=(A<3?R(O):A>3?R(e,I,O):R(e,I))||O);return A>3&&O&&Object.defineProperty(e,I,O),O},We=this&&this.__param||function(le,e){return function(I,M){e(I,M,le)}};define(Ie[103],Pe([1,0,11,24,6,3]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.ProgressLocation=e.$8v=void 0,e.$8v=(0,O.$wi)("progressService");var R;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$9v=Object.freeze({total(){},worked(){},done(){}});class w{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(d){this.b=d}report(d){this.a=d,this.b(this.a)}}e.$0v=w;class p{get value(){return this.a}constructor(d){this.e=d}report(d){this.b?this.b.push(d):this.b=[d],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const d=this.b.shift();this.a=d,await this.e(this.a)}}finally{this.c=!1;const d=this.d;this.d=void 0,d?.()}}drain(){return this.c?new Promise(d=>{const v=this.d;this.d=()=>{v?.(),d()}}):Promise.resolve()}}e.$$v=p;let E=class extends A.$Vc{constructor(d,v){super(),this.a=new I.$Th,v.withProgress(d,g=>(this.b=g,this.c&&g.report(this.c),this.a.p)),this.B((0,A.$Tc)(()=>this.a.complete()))}report(d){this.b?this.b.report(d):this.c=d}};e.$_v=E,e.$_v=E=Je([We(1,e.$8v)],E);class T extends A.$Vc{constructor(d){super(),this.g=d,this.a=0,this.b=this.B(new A.$Uc)}start(d){this.stop();const v=++this.a,g=new M.$pe;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},d),this.b.add((0,A.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Tc)(()=>g.cancel())),this.b.add((0,A.$Tc)(()=>this.c?this.c.done():void 0)),{id:v,token:g.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(d){this.a===d&&this.b.clear()}}e.$aw=T,e.$bw=(0,O.$wi)("editorProgressService")}),define(Ie[29],Pe([1,0,57,15]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class A{constructor(){this.a=new Map}add(R,w){I.ok(M.$9f(R)),I.ok(M.$$f(w)),I.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,w)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$co=new A}),define(Ie[74],Pe([1,0,5,29]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function A(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class O{constructor(){this.b=new I.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,E){this.a[A(p)]=E,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const R=new O;M.$co.add(e.$do.JSONContribution,R)}),define(Ie[51],Pe([1,0,18,5,15,160,50,74,29]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=r,e.$to=o,e.$uo=s,e.$vo=n,e.$wo=c;var E;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$ho={Configuration:"base.contributions.configuration"};var T;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const D=p.$co.as(w.$do.JSONContribution);class d{constructor(){this.h=new Set,this.i=new M.$ee,this.onDidSchemaChange=this.i.event,this.j=new M.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const a=new Set;this.n(t,f,a),D.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const f=new Set;this.o(t,f),D.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const a=new Set;this.o(f,a),this.n(t,!1,a),D.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const a=[];for(const{overrides:$,source:u}of t)for(const S in $)if(f.add(S),e.$ro.test(S)){const h=this.a.get(S),b=h?.valuesSources??new Map;if(u)for(const C of Object.keys($[S]))b.set(C,u);const m={...h?.value||{},...$[S]};this.a.set(S,{source:u,value:m,valuesSources:b});const k=(0,R.$aj)(S),y={type:"object",default:m,description:O.localize(1,null,k),$ref:e.$oo,defaultDefaultValue:m,source:A.$9f(u)?void 0:u,defaultValueSource:u};a.push(...r(S)),this.d[S]=y,this.b.properties[S]=y}else{this.a.set(S,{value:$[S],source:u});const h=this.d[S];h&&(this.w(S,h),this.r(S,h))}this.m(a)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:a,source:$}of t)for(const u in a){const S=this.a.get(u),h=A.$9f($)?$:$?.id,b=A.$9f(S?.source)?S?.source:S?.source?.id;if(h===b)if(f.add(u),this.a.delete(u),e.$ro.test(u))delete this.d[u],delete this.b.properties[u];else{const m=this.d[u];m&&(this.w(u,m),this.r(u,m))}}this.u()}deltaConfiguration(t){let f=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,a){t.forEach($=>{this.p($,f,$.extensionInfo,$.restrictedProperties,void 0,a),this.c.push($),this.q($)})}o(t,f){const a=$=>{if($.properties)for(const u in $.properties){f.add(u);const S=this.d[u];S?.policy?.name&&this.e.delete(S.policy.name),delete this.d[u],this.s(u,$.properties[u])}$.allOf?.forEach(u=>a(u))};for(const $ of t){a($);const u=this.c.indexOf($);u!==-1&&this.c.splice(u,1)}}p(t,f=!0,a,$,u=3,S){u=A.$fg(t.scope)?u:t.scope;const h=t.properties;if(h)for(const m in h){const k=h[m];if(f&&n(m,k)){delete h[m];continue}if(k.source=a,k.defaultDefaultValue=h[m].default,this.w(m,k),e.$ro.test(m)?k.scope=void 0:(k.scope=A.$fg(k.scope)?u:k.scope,k.restricted=A.$fg(k.restricted)?!!$?.includes(m):k.restricted),h[m].hasOwnProperty("included")&&!h[m].included){this.f[m]=h[m],delete h[m];continue}else this.d[m]=h[m],h[m].policy?.name&&this.e.set(h[m].policy.name,m);!h[m].deprecationMessage&&h[m].markdownDeprecationMessage&&(h[m].deprecationMessage=h[m].markdownDeprecationMessage),S.add(m)}const b=t.allOf;if(b)for(const m of b)this.p(m,f,a,$,u,S)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=a=>{const $=a.properties;if($)for(const S in $)this.r(S,$[S]);a.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$io.properties[t]=f,f.scope){case 1:e.$jo.properties[t]=f;break;case 2:e.$ko.properties[t]=f;break;case 6:e.$lo.properties[t]=f;break;case 3:e.$mo.properties[t]=f;break;case 4:e.$no.properties[t]=f;break;case 5:e.$no.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$io.properties[t],f.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,a={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$oo};this.w(f,a),e.$io.properties[f]=a,e.$jo.properties[f]=a,e.$ko.properties[f]=a,e.$lo.properties[f]=a,e.$mo.properties[f]=a,e.$no.properties[f]=a}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,f){const a=this.a.get(t);let $=a?.value,u=a?.source;A.$dg($)&&($=f.defaultDefaultValue,u=void 0),A.$dg($)&&($=s(f.type)),f.default=$,f.defaultValueSource=u}}const v="\\[([^\\]]+)\\]",g=new RegExp(v,"g");e.$qo=`^(${v})+$`,e.$ro=new RegExp(e.$qo);function r(l){const t=[];if(e.$ro.test(l)){let f=g.exec(l);for(;f?.length;){const a=f[1].trim();a&&t.push(a),f=g.exec(l)}}return(0,I.$Mb)(t)}function o(l){return l.reduce((t,f)=>`${t}[${f}]`,"")}function s(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new d;p.$co.add(e.$ho.Configuration,i);function n(l,t){return l.trim()?e.$ro.test(l)?O.localize(7,null,l):i.getConfigurationProperties()[l]!==void 0?O.localize(8,null,l):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,l,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function c(){const l=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))l.push([f,t[f].scope]);return l.push(["launch",4]),l.push(["task",4]),l}}),define(Ie[203],Pe([1,0,18,5,126,6,28,25,15,2,50,51,29]),function(le,e,I,M,A,O,R,w,p,E,T,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=n;function v(f){return Object.isFrozen(f)?f:w.$4n(f)}class g{static createEmptyModel(a){return new g({},[],[],void 0,a)}constructor(a,$,u,S,h){this.b=a,this.c=$,this.d=u,this.raw=S,this.f=h,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map($=>{if($ instanceof g)return $;const u=new r("",this.f);return u.parseRaw($),u.configurationModel});this.g=a.reduce(($,u)=>u===$?u:$.merge(u),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,T.$$i)(this.contents,a):this.contents}inspect(a,$){const u=this;return{get value(){return v(u.rawConfiguration.getValue(a))},get override(){return $?v(u.rawConfiguration.getOverrideValue(a,$)):void 0},get merged(){return v($?u.rawConfiguration.override($).getValue(a):u.rawConfiguration.getValue(a))},get overrides(){const S=[];for(const{contents:h,identifiers:b,keys:m}of u.rawConfiguration.overrides){const k=new g(h,m,[],void 0,u.f).getValue(a);k!==void 0&&S.push({identifiers:b,value:k})}return S.length?v(S):void 0}}}getOverrideValue(a,$){const u=this.j($);return u?a?(0,T.$$i)(u,a):u:void 0}getKeysForOverrideIdentifier(a){const $=[];for(const u of this.overrides)u.identifiers.includes(a)&&$.push(...u.keys);return I.$Mb($)}getAllOverrideIdentifiers(){const a=[];for(const $ of this.overrides)a.push(...$.identifiers);return I.$Mb(a)}override(a){let $=this.a.get(a);return $||($=this.h(a),this.a.set(a,$)),$}merge(...a){const $=w.$3n(this.contents),u=w.$3n(this.overrides),S=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const b of a)if(h.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.i($,b.contents);for(const m of b.overrides){const[k]=u.filter(y=>I.$ub(y.identifiers,m.identifiers));k?(this.i(k.contents,m.contents),k.keys.push(...m.keys),k.keys=I.$Mb(k.keys)):u.push(w.$3n(m))}for(const m of b.keys)S.indexOf(m)===-1&&S.push(m)}return new g($,S,u,h.every(b=>b instanceof g)?void 0:h,this.f)}h(a){const $=this.j(a);if(!$||typeof $!="object"||!Object.keys($).length)return this;const u={};for(const S of I.$Mb([...Object.keys(this.contents),...Object.keys($)])){let h=this.contents[S];const b=$[S];b&&(typeof h=="object"&&typeof b=="object"?(h=w.$3n(h),this.i(h,b)):h=b),u[S]=h}return new g(u,this.keys,this.overrides,void 0,this.f)}i(a,$){for(const u of Object.keys($)){if(u in a&&p.$$f(a[u])&&p.$$f($[u])){this.i(a[u],$[u]);continue}a[u]=w.$3n($[u])}}j(a){let $=null,u=null;const S=h=>{h&&(u?this.i(u,h):u=w.$3n(h))};for(const h of this.overrides)h.identifiers.length===1&&h.identifiers[0]===a?$=h.contents:h.identifiers.includes(a)&&S(h.contents);return S($),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,$){this.k(a,$,!0)}setValue(a,$){this.k(a,$,!1)}removeValue(a){const $=this.keys.indexOf(a);$!==-1&&(this.keys.splice($,1),(0,T.$0i)(this.contents,a),D.$ro.test(a)&&this.overrides.splice(this.overrides.findIndex(u=>I.$ub(u.identifiers,(0,D.$so)(a))),1))}k(a,$,u){(0,T.$9i)(this.contents,a,$,S=>this.f.error(S)),u=u||this.keys.indexOf(a)===-1,u&&this.keys.push(a),D.$ro.test(a)&&this.overrides.push({identifiers:(0,D.$so)(a),keys:Object.keys(this.contents[a]),contents:(0,T.$8i)(this.contents[a],S=>this.f.error(S))})}}e.$xo=g;class r{constructor(a,$){this.f=a,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,$){if(!p.$fg(a)){const u=this.h(a);this.parseRaw(u,$)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,$){this.a=a;const{contents:u,keys:S,overrides:h,restricted:b,hasExcludedProperties:m}=this.i(a,$);this.b=new g(u,S,h,m?[a]:void 0,this.g),this.c=b||[]}h(a){let $={},u=null,S=[];const h=[],b=[];function m(y){Array.isArray(S)?S.push(y):u!==null&&(S[u]=y)}const k={onObjectBegin:()=>{const y={};m(y),h.push(S),S=y,u=null},onObjectProperty:y=>{u=y},onObjectEnd:()=>{S=h.pop()},onArrayBegin:()=>{const y=[];m(y),h.push(S),S=y,u=null},onArrayEnd:()=>{S=h.pop()},onLiteralValue:m,onError:(y,C,P)=>{b.push({error:y,offset:C,length:P})}};if(a)try{A.$Qn(a,k),$=S[0]||{}}catch(y){this.g.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return $}i(a,$){const u=d.$co.as(D.$ho.Configuration).getConfigurationProperties(),S=this.j(a,u,!0,$);a=S.raw;const h=(0,T.$8i)(a,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`)),b=Object.keys(a),m=this.l(a,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:h,keys:b,overrides:m,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(a,$,u,S){let h=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:h};const b={},m=[];for(const k in a)if(D.$ro.test(k)&&u){const y=this.j(a[k],$,!1,S);b[k]=y.raw,h=h||y.hasExcludedProperties,m.push(...y.restricted)}else{const y=$[k],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&m.push(k),!S.exclude?.includes(k)&&(S.include?.includes(k)||(C===void 0||S.scopes===void 0||S.scopes.includes(C))&&!(S.skipRestricted&&y?.restricted))?b[k]=a[k]:h=!0}return{raw:b,restricted:m,hasExcludedProperties:h}}l(a,$){const u=[];for(const S of Object.keys(a))if(D.$ro.test(S)){const h={};for(const b in a[S])h[b]=a[S][b];u.push({identifiers:(0,D.$so)(S),keys:Object.keys(h),contents:(0,T.$8i)(h,$)})}return u}}e.$yo=r;class o extends O.$Vc{constructor(a,$,u,S,h){super(),this.c=a,this.f=$,this.g=S,this.h=h,this.b=this.B(new M.$ee),this.onDidChange=this.b.event,this.a=new r(this.c.toString(),h),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&u.isEqual(b.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=o;class s{constructor(a,$,u,S,h,b,m,k,y,C,P,W,V){this.a=a,this.b=$,this.c=u,this.overrideIdentifiers=S,this.d=h,this.f=b,this.g=m,this.h=k,this.i=y,this.j=C,this.k=P,this.l=W,this.m=V}get value(){return v(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(a,$,u,S,h,b,m,k,y,C){this.j=a,this.l=$,this.m=u,this.n=S,this.p=h,this.q=b,this.r=m,this.s=k,this.t=y,this.u=C,this.h=null,this.i=new R.$Bc,this.v=null}getValue(a,$,u){return this.w(a,$,u).getValue(a)}updateValue(a,$,u={}){let S;u.resource?(S=this.t.get(u.resource),S||(S=g.createEmptyModel(this.u),this.t.set(u.resource,S))):S=this.s,$===void 0?S.removeValue(a):S.setValue(a,$),u.resource||(this.h=null)}inspect(a,$,u){const S=this.w(a,$,u),h=this.A($.resource,u),b=$.resource?this.t.get($.resource)||this.s:this.s,m=new Set;for(const k of S.overrides)for(const y of k.identifiers)S.getOverrideValue(a,y)!==void 0&&m.add(y);return new s(a,$,S.getValue(a),m.size?[...m]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,h||void 0,b)}keys(a){const $=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,$){this.r.set(a,$),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,$){const u=[];if(!$){const{added:S,updated:h,removed:b}=l(this.j,a);$=[...S,...h,...b]}for(const S of $)for(const h of(0,D.$so)(S)){const b=this.j.getKeysForOverrideIdentifier(h),m=a.getKeysForOverrideIdentifier(h),k=[...m.filter(y=>b.indexOf(y)===-1),...b.filter(y=>m.indexOf(y)===-1),...b.filter(y=>!w.$7n(this.j.override(h).getValue(y),a.override(h).getValue(y)))];u.push([h,k])}return this.updateDefaultConfiguration(a),{keys:$,overrides:u}}compareAndUpdatePolicyConfiguration(a){const{added:$,updated:u,removed:S}=l(this.l,a),h=[...$,...u,...S];return h.length&&this.updatePolicyConfiguration(a),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:$,updated:u,removed:S,overrides:h}=l(this.applicationConfiguration,a),b=[...$,...u,...S];return b.length&&this.updateApplicationConfiguration(a),{keys:b,overrides:h}}compareAndUpdateLocalUserConfiguration(a){const{added:$,updated:u,removed:S,overrides:h}=l(this.localUserConfiguration,a),b=[...$,...u,...S];return b.length&&this.updateLocalUserConfiguration(a),{keys:b,overrides:h}}compareAndUpdateRemoteUserConfiguration(a){const{added:$,updated:u,removed:S,overrides:h}=l(this.remoteUserConfiguration,a),b=[...$,...u,...S];return b.length&&this.updateRemoteUserConfiguration(a),{keys:b,overrides:h}}compareAndUpdateWorkspaceConfiguration(a){const{added:$,updated:u,removed:S,overrides:h}=l(this.workspaceConfiguration,a),b=[...$,...u,...S];return b.length&&this.updateWorkspaceConfiguration(a),{keys:b,overrides:h}}compareAndUpdateFolderConfiguration(a,$){const u=this.folderConfigurations.get(a),{added:S,updated:h,removed:b,overrides:m}=l(u,$),k=[...S,...h,...b];return(k.length||!u)&&this.updateFolderConfiguration(a,$),{keys:k,overrides:m}}compareAndDeleteFolderConfiguration(a){const $=this.folderConfigurations.get(a);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:u,updated:S,removed:h,overrides:b}=l($,void 0);return{keys:[...u,...S,...h],overrides:b}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,$,u){let S=this.x($,u);return $.overrideIdentifier&&(S=S.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(S=S.merge(this.l)),S}x({resource:a},$){let u=this.y();if($&&a){const S=$.getFolder(a);S&&(u=this.z(S.uri)||u);const h=this.t.get(a);h&&(u=u.merge(h))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let $=this.i.get(a);if(!$){const u=this.y(),S=this.r.get(a);S?($=u.merge(S),this.i.set(a,$)):$=u}return $}A(a,$){if($&&a){const u=$.getFolder(a);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,$)=>{const{contents:u,overrides:S,keys:h}=this.r.get($);return a.push([$,{contents:u,overrides:S,keys:h}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach($=>a.add($)),this.userConfiguration.keys.forEach($=>a.add($)),this.q.keys.forEach($=>a.add($)),this.r.forEach($=>$.keys.forEach(u=>a.add(u))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>a.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>a.add($)),this.q.getAllOverrideIdentifiers().forEach($=>a.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(u=>a.add(u))),[...a.values()]}D(a){const $=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(u=>$.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(u=>$.add(u)),this.q.getKeysForOverrideIdentifier(a).forEach(u=>$.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(a).forEach(S=>$.add(S))),[...$.values()]}static parse(a,$){const u=this.E(a.defaults,$),S=this.E(a.policy,$),h=this.E(a.application,$),b=this.E(a.user,$),m=this.E(a.workspace,$),k=a.folders.reduce((y,C)=>(y.set(E.URI.revive(C[0]),this.E(C[1],$)),y),new R.$Bc);return new i(u,S,h,b,g.createEmptyModel($),m,k,g.createEmptyModel($),new R.$Bc,$)}static E(a,$){return new g(a.contents,a.keys,a.overrides,void 0,$)}}e.$Ao=i;function n(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const a=new Set,$=new Map;for(const S of f)S.keys.forEach(h=>a.add(h)),S.overrides.forEach(([h,b])=>{const m=(0,R.$yc)($,h,new Set);b.forEach(k=>m.add(k))});const u=[];return $.forEach((S,h)=>u.push([h,[...S.values()]])),{keys:[...a.values()],overrides:u}}class c{constructor(a,$,u,S,h){this.change=a,this.f=$,this.g=u,this.h=S,this.i=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const b of a.keys)this.affectedKeys.add(b);for(const[,b]of a.overrides)for(const m of b)this.affectedKeys.add(m);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,$){const u=this.a+a,S=this.d.indexOf(u);if(S<0)return!1;const h=S+u.length;if(h>=this.d.length)return!1;const b=this.d.charCodeAt(h);if(b!==this.b&&b!==this.c)return!1;if($){const m=this.previousConfiguration?this.previousConfiguration.getValue(a,$,this.f?.workspace):void 0,k=this.g.getValue(a,$,this.h);return!w.$7n(m,k)}return!0}}e.$Co=c;function l(f,a){const{added:$,removed:u,updated:S}=t(a?.rawConfiguration,f?.rawConfiguration),h=[],b=f?.getAllOverrideIdentifiers()||[],m=a?.getAllOverrideIdentifiers()||[];if(a){const k=m.filter(y=>!b.includes(y));for(const y of k)h.push([y,a.getKeysForOverrideIdentifier(y)])}if(f){const k=b.filter(y=>!m.includes(y));for(const y of k)h.push([y,f.getKeysForOverrideIdentifier(y)])}if(a&&f){for(const k of b)if(m.includes(k)){const y=t({contents:f.getOverrideValue(void 0,k)||{},keys:f.getKeysForOverrideIdentifier(k)},{contents:a.getOverrideValue(void 0,k)||{},keys:a.getKeysForOverrideIdentifier(k)});h.push([k,[...y.added,...y.removed,...y.updated]])}}return{added:$,removed:u,updated:S,overrides:h}}function t(f,a){const $=f?a?f.keys.filter(h=>a.keys.indexOf(h)===-1):[...f.keys]:[],u=a?f?a.keys.filter(h=>f.keys.indexOf(h)===-1):[...a.keys]:[],S=[];if(f&&a){for(const h of a.keys)if(f.keys.indexOf(h)!==-1){const b=(0,T.$$i)(a.contents,h),m=(0,T.$$i)(f.contents,h);w.$7n(b,m)||S.push(h)}}return{added:$,removed:u,updated:S}}}),define(Ie[104],Pe([1,0,14,3]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=E,e.$Hl=(0,M.$wi)("remoteAuthorityResolverService");var A;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class O{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=O;class R{constructor(D,d){this.host=D,this.port=d,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=R;var w;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class p extends I.$bb{static isNotAvailable(D){return D instanceof p&&D._code===w.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof p&&D._code===w.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof p&&D._code===w.NoResolverFound}static isInvalidAuthority(D){return D instanceof p&&D._code===w.InvalidAuthority}static isHandled(D){return D instanceof p&&D.isHandled}constructor(D,d=w.Unknown,v){super(D),this._message=D,this._code=d,this._detail=v,this.isHandled=d===w.NotAvailable&&v===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Kl=p;function E(T){const D=T.indexOf("+");return D===-1?T:T.substring(0,D)}}),define(Ie[58],Pe([1,0,16]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=M,e.$Im=A,e.$Jm=O,e.$Km=R;function M(p){return p.scheme===I.Schemas.vscodeRemote?p.authority:void 0}function A(p){if(!p)return;const E=p.indexOf("+");return E<0?p:p.substr(0,E)}function O(p){const{host:E,port:T}=w(p);if(typeof T>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:T}}function R(p,E){let{host:T,port:D}=w(p);return typeof D>"u"&&(D=E),{host:T,port:D}}function w(p){const E=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const T=p.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const D=p.match(/(.*):(\d+)$/);return D?{host:D[1],port:parseInt(D[2],10)}:{host:p,port:void 0}}}),define(Ie[20],Pe([1,0,13,3,58]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=O,e.$Um=D,e.$Vm=d,e.$Wm=v,e.$Xm=g,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function O(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var w;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class p{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const i=typeof o=="string"?o:o.value,n=typeof s=="string"?s:s.value;return I.$yf(i,n)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Rm=p;class E{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(p.toKey(o))}delete(o){return this.c.delete(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}}e.$Sm=E;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(p.toKey(o))}get(o){return this.c.get(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}set(o,s){this.c.set(p.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=T;function D(r){return d(r)}function d(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function v(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function g(r,o){if(o){const s=`onResolveRemoteAuthority:${(0,A.$Im)(o)}`;return!!r.activationEvents?.includes(s)}return!1}e.$Ym=(0,M.$wi)("IBuiltinExtensionsScannerService")}),define(Ie[105],Pe([1,0,14,20]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nG=e.$mG=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(R,w){this.a.set(R,w)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const w=Object.create(null);for(const p of R){const E=this.readActivationEvents(p);E.length>0&&(w[M.$Rm.toKey(p.identifier)]=E)}return w}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const w=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let p=0;p<w.length;p++)w[p]==="onUri"&&(w[p]=`onUri:${M.$Rm.toKey(R.identifier)}`);if(!R.contributes)return w;for(const p in R.contributes){const E=this.a.get(p);if(!E)continue;const T=R.contributes[p],D=Array.isArray(T)?T:[T];try{E(D,w)}catch(d){(0,I.$1)(d)}}return w}}e.$mG=A,e.$nG=new A}),define(Ie[204],Pe([1,0,21,14,6,168,51,3,12,29]),function(le,e,I,M,A,O,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=d,e.$Qp=v,e.$Rp=g,e.$Sp=r,e.$Tp=o,e.$Up=s,e.$Np=(0,w.$wi)("requestService");class T{constructor(l){this.b=l}toJSON(){if(!this.a){const l=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?l[t]="*****":l[t]=this.b[t];this.a=l}return this.a}}class D extends A.$Vc{constructor(l){super(),this.b=0,this.a=l.createLogger("network",{name:(0,O.localize)(0,null),when:p.$ik.isEqualTo((0,p.$fk)(p.LogLevel.Trace)).serialize()})}async c(l,t,f){const a=`${l} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new T(t.headers??{}));try{const $=await f();return this.a.trace(`${a} - end`,t.type,$.res.statusCode,$.res.headers),$}catch($){throw this.a.error(`${a} - error`,t.type,(0,M.$0)($)),$}}}e.$Op=D;function d(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function v(c){return c.res.statusCode===204}async function g(c){return v(c)?null:(await(0,I.$Se)(c.stream)).toString()}async function r(c){if(!d(c))throw new Error("Server returned "+c.res.statusCode);return g(c)}async function o(c){if(!d(c))throw new Error("Server returned "+c.res.statusCode);if(v(c))return null;const t=(await(0,I.$Se)(c.stream)).toString();try{return JSON.parse(t)}catch(f){throw f.message+=`:
`+t,f}}function s(c){n(c)}let i;function n(c){const l=E.$co.as(R.$ho.Configuration),t=i;i={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},l.updateConfigurations({add:[i],remove:t?[t]:[]})}n(1)}),define(Ie[205],Pe([1,0,22,75,34]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=R,e.$ep=w;function O(p){if(I.$u===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function R(p,E,T,D,d,v,g,r,o){const s=Object.create(null);s["common.machineId"]=v,s["common.sqmId"]=g,s.sessionID=(0,A.$Sg)()+Date.now(),s.commitHash=D,s.version=d,s["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=M.$ec,s["common.nodeArch"]=T,s["common.product"]=o||"desktop",r&&(s["common.msftInternal"]=r);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const c=O(E);return c&&(s["common.platformDetail"]=c),s}function w(p){const E=M.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return p.some(D=>T===D)}}),define(Ie[206],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,I.$wi)("telemetryService"),e.$3l=(0,I.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var M;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var A;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(Ie[59],Pe([1,0,25,15,58,205,206]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=T,e.$np=D,e.$op=d,e.$pp=v,e.$qp=r,e.$rp=s,e.$sp=i,e.$tp=l;class w{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$fp=w;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=p,e.$hp=new p;class E{async publicLog(f,a,$){}async publicLogError(f,a,$){}}e.$ip=E,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function D(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function d(t){const f=t.getValue(R.$0l),a=t.getValue(R.$$l);if(t.getValue(R.$_l)===!1||a===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function v(t){const f={},a={},$={};o(t,$);for(let u in $){u=u.length>150?u.substr(u.length-149):u;const S=$[u];typeof S=="number"?a[u]=S:typeof S=="boolean"?a[u]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${S.length}`),f[u]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(f[u]=S)}return{properties:f,measurements:a}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const f=(0,A.$Im)(t);return g.has(f)?f:"other"}function o(t,f,a=0,$){if(t)for(const u of Object.getOwnPropertyNames(t)){const S=t[u],h=$?$+u:u;Array.isArray(S)?f[h]=(0,I.$8n)(S):S instanceof Date?f[h]=S.toISOString():(0,M.$$f)(S)?a<2?o(S,f,a+1,h+"."):f[h]=(0,I.$8n)(S):f[h]=S}}function s(t,f){const a=t.msftInternalDomains||[],$=f.getValue("telemetry.internalTesting");return(0,O.$ep)(a)||$}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const $=[];for(const b of f)for(;;){const m=b.exec(t);if(!m)break;$.push([m.index,b.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(a="";;){const b=S.exec(t);if(!b)break;const m=$.some(([k,y])=>b.index<y&&k<S.lastIndex);!u.test(b[0])&&!m&&(a+=t.substring(h,b.index)+"<REDACTED: user-file-path>",h=S.lastIndex)}return h<t.length&&(a+=t.substr(h)),a}function c(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of f)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function l(t,f){return(0,I.$5n)(t,a=>{if(a instanceof w||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let $=a.replaceAll("%20"," ");$=n($,f);for(const u of f)$=$.replace(u,"");return $=c($),$}})}}),define(Ie[207],Pe([1,0,13,100,20,22,2,14,75,59]),function(le,e,I,M,A,O,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=T,e.$wp=g,e.$xp=r,e.$yp=o,e.$zp=s,e.$Ap=i,e.$Bp=n,e.$Cp=c,e.$Ep=l,e.$Fp=f;function T(a,$){return a.uuid&&$.uuid?a.uuid===$.uuid:a.id===$.id?!0:(0,I.$tf)(a.id,$.id)===0}const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create($){const u=$.manifest?$.manifest.version:$.version,S=$.manifest?$.targetPlatform:$.properties.targetPlatform;return new d($.identifier,u,S)}static parse($){const u=D.exec($);return u&&u[1]&&u[2]?new d({id:u[1]},u[2],u[4]||void 0):null}constructor($,u,S="undefined"){this.version=u,this.targetPlatform=S,this.id=$.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals($){return $ instanceof d?T(this,$)&&this.version===$.version&&this.targetPlatform===$.targetPlatform:!1}}e.$vp=d;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(a){const $=v.exec(a);return $&&$[1]?[o($[1]),$[2]]:[o(a),void 0]}function r(a,$){return`${a}.${$}`}function o(a){return a.toLowerCase()}function s(a,$){return o(r(a??A.$Nm,$))}function i(a,$){const u=[],S=h=>{for(const b of u)if(b.some(m=>T($(m),$(h))))return b;return null};for(const h of a){const b=S(h);b?b.push(h):u.push([h])}return u}function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new E.$fp(a.identifier.id),name:new E.$fp(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Dp=new A.$Rm("pprice.better-merge");function l(a,$){const u=[],S=$.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const h=S.shift();if(h&&u.every(b=>!T(b.identifier,{id:h}))){const b=a.filter(m=>T(m.identifier,{id:h}));b.length===1&&(u.push(b[0]),S.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}async function t(a,$){if(!O.$k)return!1;let u;try{u=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){$.debug("Error while getting the os-release file.",(0,w.$0)(h))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(a,$){const u=await t(a,$),S=(0,M.$2o)(u?"alpine":O.$u,p.$fc);return $.debug("ComputeTargetPlatform:",S),S}}),define(Ie[208],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=I,e.$ms=M,e.$ns=A,e.$os=O,e.$ps=R,e.$qs=w;function I(p){return[...p.entries()]}function M(p){return p?[...p.entries()]:[]}function A(p){return new Map(p)}function O(p){return new Map(p??[])}function R(p){return Array.from(p.entries()).map(E=>[E[0],I(E[1].map),M(E[1].descriptionMap)])}function w(p){return new Map(p.map(E=>[E[0],{map:A(E[1]),descriptionMap:O(E[2])}]))}}),define(Ie[209],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gvb=void 0;class I{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,O,R=5){const w=O(p=>{const E=typeof p=="string"?p:p.data;let T=this.a.get(A);if(T){T.data.push(E);return}const D=setTimeout(()=>this.flushBuffer(A),R);T={data:[E],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(A),w.dispose()}},this.a.set(A,T)});return w}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const O=this.a.get(A);O&&(this.a.delete(A),this.b(A,O.data.join("")))}}e.$Gvb=I}),define(Ie[210],Pe([1,0,11,92,312,36,5,15,2,169,74,29]),function(le,e,I,M,A,O,R,w,p,E,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gx=e.$fx=e.$ex=e.$dx=e.$cx=e.$bx=e.IconFontDefinition=e.IconContribution=e.$$w=void 0,e.$_w=o,e.$ax=s,e.$$w={IconContribution:"base.contributions.icons"};var d;(function(l){function t(f,a){let $=f.defaults;for(;O.ThemeIcon.isThemeIcon($);){const u=r.getIcon($.id);if(!u)return;$=u.defaults}return $}l.getDefinition=t})(d||(e.IconContribution=d={}));var v;(function(l){function t(a){return{weight:a.weight,style:a.style,src:a.src.map($=>({format:$.format,location:$.location.toString()}))}}l.toJSONObject=t;function f(a){const $=u=>(0,w.$9f)(u)?u:void 0;if(a&&Array.isArray(a.src)&&a.src.every(u=>(0,w.$9f)(u.format)&&(0,w.$9f)(u.location)))return{weight:$(a.weight),style:$(a.style),src:a.src.map(u=>({format:u.format,location:p.URI.parse(u.location)}))}}l.fromJSONObject=f})(v||(e.IconFontDefinition=v={}));class g{constructor(){this.a=new R.$ee,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,a,$){const u=this.b[t];if(u){if(a&&!u.description){u.description=a,this.d.properties[t].markdownDescription=`${a} $(${t})`;const b=this.e.enum.indexOf(t);b!==-1&&(this.e.enumDescriptions[b]=a),this.a.fire()}return u}const S={id:t,description:a,defaults:f,deprecationMessage:$};this.b[t]=S;const h={$ref:"#/definitions/icons"};return $&&(h.deprecationMessage=$),a&&(h.markdownDescription=`${a}: $(${t})`),this.d.properties[t]=h,this.e.enum.push(t),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const a=this.f[t];return a||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(u,S)=>u.id.localeCompare(S.id),f=u=>{for(;O.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const $=Object.keys(this.b).map(u=>this.b[u]);for(const u of $.filter(S=>!!S.description).sort(t))a.push(`|<i class="${f(u)}"></i>|${u.id}|${O.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const u of $.filter(S=>!O.ThemeIcon.isThemeIcon(S.defaults)).sort(t))a.push(`|<i class="${f(u)}"></i>|${u.id}|`);return a.join(`
`)}}const r=new g;D.$co.add(e.$$w.IconContribution,r);function o(l,t,f,a){return r.registerIcon(l,t,f,a)}function s(){return r}function i(){const l=(0,A.$Rj)();for(const t in l){const f="\\"+l[t].toString(16);r.registerIcon(t,{fontCharacter:f})}}i(),e.$bx="vscode://schemas/icons";const n=D.$co.as(T.$do.JSONContribution);n.registerSchema(e.$bx,r.getIconSchema());const c=new I.$Ih(()=>n.notifySchemaChanged(e.$bx),200);r.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$cx=o("widget-close",M.$Vj.close,(0,E.localize)(2,null)),e.$dx=o("goto-previous-location",M.$Vj.arrowUp,(0,E.localize)(3,null)),e.$ex=o("goto-next-location",M.$Vj.arrowDown,(0,E.localize)(4,null)),e.$fx=O.ThemeIcon.modify(M.$Vj.sync,"spin"),e.$gx=O.ThemeIcon.modify(M.$Vj.loading,"spin")}),define(Ie[211],Pe([1,0,5,2,50,3,12]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=e.$jw=e.$hw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$dw=e.$cw=void 0,e.$ew=E,e.$fw=D,e.$gw=d,e.$iw=v,e.$kw=g,e.$lw=r,e.$cw=(0,O.$wi)("tunnelService"),e.$dw=(0,O.$wi)("sharedTunnelsService");var w;(function(i){i.Http="http",i.Https="https"})(w||(e.TunnelProtocol=w={}));var p;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(p||(e.TunnelPrivacyId=p={}));function E(i){return!!i.forwardPort}var T;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function D(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function d(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const c of n){const l=c.split("=")[1];if(/^https?:/.exec(l)){const t=D(M.URI.parse(l));if(t)return t}}}e.$hw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(i){return e.$hw.indexOf(i)>=0}e.$jw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(i){return e.$jw.indexOf(i)>=0}function r(i,n,c,l){if(c===1)return!1;if(c===2&&g(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class o{constructor(n,c,l){this.remoteAddress=n,this.localAddress=c,this.b=l,this.a=new I.$ee,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mw=o;let s=class{constructor(n,c){this.k=n,this.l=c,this.a=new I.$ee,this.onTunnelOpened=this.a.event,this.b=new I.$ee,this.onTunnelClosed=this.b.event,this.c=new I.$ee,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],c=Array.from(this.e.values());for(const l of c){const t=Array.from(l.values());for(const f of t){const a=await f.value;a&&typeof a!="string"&&n.push(a)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:c}of n.values())await c.then(l=>typeof l!="string"?l?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,c,l,t,f){this.q(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:l,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(g(n)||v(n))&&(n=e.$hw[0]);const l=this.s(n,c);if(l)return++l.refcount,l.value}openTunnel(n,c,l,t,f,a=!1,$,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${l} on local port ${f}.`);const S=this.f??n;if(!S)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(l)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const h=this.t(S,c,l,t,f,a,$,u);return h?h.then(b=>{if(b){if(typeof b=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,l),b}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,l);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.o(b);return(b.tunnelRemoteHost!==c||b.tunnelRemotePort!==l)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&b.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),h)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this.e.get(n.tunnelRemoteHost);if(c){const l=c.get(n.tunnelRemotePort);l&&(l.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,l))}}}}async p(n,c,l){if(l.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const t=l.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(c),t}}async closeTunnel(n,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const l=this.e.get(n);if(l&&l.has(c)){const t=l.get(c);t.refcount=0,await this.p(n,c,t)}}q(n,c,l){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(c,{refcount:1,value:l})}async r(n,c){const l=this.e.get(n);if(l){const t=l.get(c),f=t?await t.value:void 0;(!f||typeof f=="string")&&l.delete(c),l.size===0&&this.e.delete(n)}}s(n,c){const l=[n];v(n)?(l.push(...e.$hw),l.push(...e.$jw)):g(n)&&l.push(...e.$jw);const t=l.map(f=>this.e.get(f));for(const f of t){const a=f?.get(c);if(a)return a}}canTunnel(n){return!!D(n)}u(n,c,l,t,f,a,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${l} on local port ${t}.`);const u=l;this.j.add(u);const S=t===void 0?l:t,h={elevationRequired:f?this.isPortPrivileged(S):!1},b={remoteAddress:{host:c,port:l},localAddressPort:t,privacy:a,public:a?a!==p.Private:void 0,protocol:$},m=n.forwardPort(b,h);return m?(this.q(c,l,m),m.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),m}};e.$nw=s,e.$nw=s=Je([We(0,R.$3j),We(1,A.$3i)],s)}),define(Ie[212],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,I.$wi)("IUriIdentityService")}),define(Ie[213],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ow=void 0,e.$ow=(0,I.$wi)("editSessionIdentityService");var M;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Ie[214],Pe([1,0,16]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=M,e.$AM=A,e.$BM=O,e.$CM=R,e.$DM=w;function M(p){return p.scheme!==I.Schemas.file&&p.scheme!==I.Schemas.vscodeRemote}function A(p){if(p.folders.length)return p.folders.every(E=>M(E.uri))?p.folders[0].uri:void 0;if(p.configuration&&M(p.configuration))return p.configuration}function O(p){return A(p)?.scheme}function R(p){return A(p)?.authority}function w(p){return A(p)!==void 0}}),define(Ie[45],Pe([1,0,171,19,54,23,2,3,16]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=E,e.$Hi=T,e.$Ki=D,e.$Li=d,e.$Mi=v,e.$Ni=r,e.$Oi=o,e.$Ri=n,e.$Wi=c,e.$Xi=l,e.$Zi=t,e.$1i=f,e.$2i=a,e.$Fi=(0,w.$wi)("contextService");function E($){const u=$;return typeof u?.id=="string"&&R.URI.isUri(u.uri)}function T($){return typeof $?.id=="string"&&!E($)&&!d($)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function D($,u){if(typeof $=="string"||typeof $>"u")return typeof $=="string"?{id:(0,M.$oc)($)}:u?e.$Ii:e.$Ji;const S=$;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function d($){const u=$;return typeof u?.id=="string"&&R.URI.isUri(u.configPath)}function v($){const u=$;if(u?.uri)return{id:u.id,uri:R.URI.revive(u.uri)};const S=$;if(S?.configPath)return{id:S.id,configPath:R.URI.revive(S.configPath)};if($?.id)return{id:$.id}}var g;(function($){$[$.EMPTY=1]="EMPTY",$[$.FOLDER=2]="FOLDER",$[$.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function r($){const u=$;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}function o($){const u=$;return!!(u&&typeof u=="object"&&R.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}class s{constructor(u,S,h,b,m){this.h=u,this.j=h,this.k=b,this.l=m,this.c=A.$Ci.forUris(this.l,()=>!0),this.folders=S}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=A.$Ci.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=s;class i{constructor(u,S){this.raw=S,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,O.$0g)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=i;function n($){return new i({uri:$,index:0,name:(0,O.$6g)($)},{uri:$.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,I.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function c($,u){return O.$1g.isEqualOrParent($,u.untitledWorkspacesHome)}function l($){let u;return R.URI.isUri($)?u=$:u=$.configuration,u?.scheme===p.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t($){return $.id===e.$Yi}function f($,u){return!c($,u)&&!l($)}function a($){return(typeof $=="string"?(0,M.$pc)($):(0,O.$8g)($))===e.$Ti}}),define(Ie[215],Pe([1,0,73,5,6,23,2,170,99,38,3,12,45,28,212,11,34,13,15]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=c,e.$Dl=l,e.$El=t;var n;(function($){$.Settings="settings",$.Keybindings="keybindings",$.Snippets="snippets",$.Tasks="tasks",$.Extensions="extensions",$.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function c($){const u=$;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&R.URI.isUri(u.location)&&R.URI.isUri(u.globalStorageHome)&&R.URI.isUri(u.settingsResource)&&R.URI.isUri(u.keybindingsResource)&&R.URI.isUri(u.tasksResource)&&R.URI.isUri(u.snippetsHome)&&R.URI.isUri(u.extensionsResource))}e.$Cl=(0,T.$wi)("IUserDataProfilesService");function l($,u){return{id:$.id,isDefault:$.isDefault,name:$.name,shortName:$.shortName,icon:$.icon,location:R.URI.revive($.location).with({scheme:u}),globalStorageHome:R.URI.revive($.globalStorageHome).with({scheme:u}),settingsResource:R.URI.revive($.settingsResource).with({scheme:u}),keybindingsResource:R.URI.revive($.keybindingsResource).with({scheme:u}),tasksResource:R.URI.revive($.tasksResource).with({scheme:u}),snippetsHome:R.URI.revive($.snippetsHome).with({scheme:u}),extensionsResource:R.URI.revive($.extensionsResource).with({scheme:u}),cacheHome:R.URI.revive($.cacheHome).with({scheme:u}),useDefaultFlags:$.useDefaultFlags,isTransient:$.isTransient}}function t($,u,S,h,b,m){return{id:$,name:u,location:S,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:m&&b?.useDefaultFlags?.globalState?m.globalStorageHome:(0,O.$0g)(S,"globalStorage"),settingsResource:m&&b?.useDefaultFlags?.settings?m.settingsResource:(0,O.$0g)(S,"settings.json"),keybindingsResource:m&&b?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,O.$0g)(S,"keybindings.json"),tasksResource:m&&b?.useDefaultFlags?.tasks?m.tasksResource:(0,O.$0g)(S,"tasks.json"),snippetsHome:m&&b?.useDefaultFlags?.snippets?m.snippetsHome:(0,O.$0g)(S,"snippets"),extensionsResource:m&&b?.useDefaultFlags?.extensions?m.extensionsResource:(0,O.$0g)(S,"extensions.json"),cacheHome:(0,O.$0g)(h,$),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let f=class extends A.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,S,h,b){super(),this.t=u,this.u=S,this.w=h,this.y=b,this.f=!0,this.h=this.B(new M.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new M.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new M.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new M.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$Bc,emptyWindows:new Map},this.profilesHome=(0,O.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),S=[u];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,i.$9f)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}S.push(t((0,O.$7g)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},u))}}catch(m){this.y.error(m)}const h=new v.$Bc,b=new Map;if(S.length)try{const m=this.Q();if(m.workspaces)for(const[k,y]of Object.entries(m.workspaces)){const C=R.URI.parse(k),P=S.find(W=>W.id===y);P&&h.set(C,P)}if(m.emptyWindows)for(const[k,y]of Object.entries(m.emptyWindows)){const C=S.find(P=>P.id===y);C&&b.set(k,C)}}catch(m){this.y.error(m)}this.z={profiles:S,workspaces:h,emptyWindows:b}}return this.z}D(){const u=t("__default__profile__",(0,w.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const S="Temp",h=new RegExp(`${(0,s.$af)(S)}\\s(\\d+)`);let b=0;for(const k of this.profiles){const y=h.exec(k.name),C=y?parseInt(y[1]):0;b=C>b?C:b}const m=`${S} ${b+1}`;return this.createProfile((0,I.$kj)((0,o.$Sg)()).toString(16),m,{transient:!0},u)}async createNamedProfile(u,S,h){return this.createProfile((0,I.$kj)((0,o.$Sg)()).toString(16),u,S,h)}async createProfile(u,S,h,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(u,S,h);return b&&await this.setProfileForWorkspace(b,m),m}async F(u,S,h){if(!(0,i.$9f)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(S);return b||(b=(async()=>{try{if(this.profiles.find(C=>C.name===S||C.id===u))throw new Error(`Profile with ${S} name already exists`);const k=t(u,S,(0,O.$0g)(this.profilesHome,u),this.g,h,this.defaultProfile);await this.u.createFolder(k.location);const y=[];return this.j.fire({profile:k,join(C){y.push(C)}}),await r.Promises.settled(y),this.I([k],[],[]),k}finally{this.r.delete(S)}})(),this.r.set(S,b)),b}async updateProfile(u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(b=>b.id===u.id);if(!h)throw new Error(`Profile '${u.name}' does not exist`);return h=t(h.id,S.name??h.name,h.location,this.g,{shortName:S.shortName??h.shortName,icon:S.icon===null?void 0:S.icon??h.icon,transient:S.transient??h.isTransient,useDefaultFlags:S.useDefaultFlags??h.useDefaultFlags},this.defaultProfile),this.I([],[],[h]),h}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(b=>b.id===u.id);if(!S)throw new Error(`Profile '${u.name}' does not exist`);const h=[];this.m.fire({profile:S,join(b){h.push(b)}});try{await Promise.allSettled(h)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(b){(0,E.$hl)(b)!==1&&this.y.error(b)}}async setProfileForWorkspace(u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(b=>b.id===S.id);if(!h)throw new Error(`Profile '${S.name}' does not exist`);this.L(u,h)}unsetWorkspace(u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,S)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(S=>S.isDirectory&&this.profiles.every(h=>!this.w.extUri.isEqual(h.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled(u.map(S=>this.removeProfile(S)))}getProfileForWorkspace(u){const S=this.G(u);return R.URI.isUri(S)?this.s.workspaces.get(S)??this.C.workspaces.get(S):this.s.emptyWindows.get(S)??this.C.emptyWindows.get(S)}G(u){return(0,d.$Gi)(u)?u.uri:(0,d.$Li)(u)?u.configPath:u.id}H(u){return!!([...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,u.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,u.location))||[...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,u.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,u.location)))}I(u,S,h){const b=[...this.profiles,...u],m=[];this.s.profiles=[];for(let k of b)k.isDefault||S.some(y=>k.id===y.id)||(k=h.find(y=>k.id===y.id)??k,k.isTransient?this.s.profiles.push(k):m.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(m),this.z=void 0,this.J(u,S,h)}J(u,S,h){this.h.fire({added:u,removed:S,updated:h,all:this.profiles})}L(u,S,h){h=S?.isTransient?!0:h,h||this.L(u,void 0,!0);const b=this.G(u),m=h?this.s:this.C;R.URI.isUri(b)?(m.workspaces.delete(b),S&&m.workspaces.set(b,S)):(m.emptyWindows.delete(b),S&&m.emptyWindows.set(b,S)),h||this.M()}M(){const u={};for(const[h,b]of this.C.workspaces.entries())u[h.toString()]=b.id;const S={};for(const[h,b]of this.C.emptyWindows.entries())S[h.toString()]=b.id;this.R({workspaces:u,emptyWindows:S}),this.z=void 0}N(u){const S={},h=this.D();if(u.workspaces)for(const[m,k]of Object.entries(u.workspaces)){const y=R.URI.parse(k);S[m]=this.w.extUri.isEqual(y,h.location)?h.id:this.w.extUri.basename(y)}const b={};if(u.emptyWindows)for(const[m,k]of Object.entries(u.emptyWindows)){const y=R.URI.parse(k);b[m]=this.w.extUri.isEqual(y,h.location)?h.id:this.w.extUri.basename(y)}return{workspaces:S,emptyWindows:b}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$Fl=f,e.$Fl=f=Je([We(0,p.$Di),We(1,E.$3k),We(2,g.$Al),We(3,D.$3j)],f);class a extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$Gl=a}),define(Ie[216],Pe([1,0,11,5,6,60,15,151,3,215]),function(le,e,I,M,A,O,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=v,e.$4p=r,e.$6p=s,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,p.$wi)("storageService");var T;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var D;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(D||(e.StorageScope=D={}));var d;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function v(i){const n=i.get(e.$Zp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class g extends A.$Vc{static{this.a=60*1e3}constructor(n={flushInterval:g.a}){super(),this.m=n,this.b=this.B(new M.$he),this.c=this.B(new M.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new I.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,c,l){return M.Event.filter(this.b.event,t=>t.scope===n&&(c===void 0||t.key===c),l)}n(){this.j.value=(0,I.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,c){const{key:l,external:t}=c;if(l===e.$Zp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:l,target:this.J(n)[l],external:t})}w(n){this.f.fire({reason:n})}get(n,c,l){return this.P(c)?.get(n,l)}getBoolean(n,c,l){return this.P(c)?.getBoolean(n,l)}getNumber(n,c,l){return this.P(c)?.getNumber(n,l)}getObject(n,c,l){return this.P(c)?.getObject(n,l)}storeAll(n,c){this.y(()=>{for(const l of n)this.store(l.key,l.value,l.scope,l.target,c)})}store(n,c,l,t,f=!1){if((0,R.$fg)(c)){this.remove(n,l,f);return}this.y(()=>{this.z(n,l,t),this.P(l)?.set(n,c,f)})}remove(n,c,l=!1){this.y(()=>{this.z(n,c,void 0),this.P(c)?.delete(n,l)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,c){const l=[],t=this.J(n);for(const f of Object.keys(t))t[f]===c&&l.push(f);return l}z(n,c,l,t=!1){const f=this.J(c);typeof l=="number"?f[n]!==l&&(f[n]=l,this.P(c)?.set(e.$Zp,JSON.stringify(f),t)):typeof f[n]=="number"&&(delete f[n],this.P(c)?.set(e.$Zp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const c=this.P(n);return c?v(c):Object.create(null)}isNew(n){return this.getBoolean(e.$Yp,n)===!0}async flush(n=T.NONE){this.f.fire({reason:n});const c=this.P(-1),l=this.P(0),t=this.P(1);switch(n){case T.NONE:await I.Promises.settled([c?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await I.Promises.settled([c?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,l=this.P(1)?.items??new Map;return s(n,c,l,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,c){return this.w(T.NONE),(0,E.$Bl)(n)?this.R(n,c):this.S(n,c)}M(n,c){return!(n.id===c.id||r(c)&&r(n))}N(n,c,l){this.y(()=>{const t=new Set;for(const[f,a]of n)t.add(f),c.get(f)!==a&&this.u(l,{key:f,external:!0});for(const[f]of c.items)t.has(f)||this.u(l,{key:f,external:!0})})}}e.$3p=g;function r(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class o extends g{constructor(){super(),this.U=this.B(new w.$Wp(new w.$Xp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new w.$Wp(new w.$Xp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new w.$Wp(new w.$Xp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$5p=o;async function s(i,n,c,l,t,f){const a=C=>{try{return JSON.parse(C)}catch{return C}},$=new Map,u=new Map;i.forEach((C,P)=>{$.set(P,C),u.set(P,a(C))});const S=new Map,h=new Map;n.forEach((C,P)=>{S.set(P,C),h.set(P,a(C))});const b=new Map,m=new Map;c.forEach((C,P)=>{b.set(P,C),m.set(P,a(C))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const k=[];if($.forEach((C,P)=>{k.push({key:P,value:C})}),console.table(k),console.groupEnd(),console.log(u),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];S.forEach((P,W)=>{C.push({key:W,value:P})}),console.table(C),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${f})`);const y=[];b.forEach((C,P)=>{y.push({key:P,value:C})}),console.table(y),console.groupEnd(),console.log(m)}}),define(Ie[76],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class I{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const O=this.c++;return this.b.set(O,A),this.e(),O}get(A,O){return this.b.has(A)?this.b.get(A)[O]:void 0}delete(A){this.b.delete(A),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$$kc=I}),define(Ie[46],Pe([1,0,16,23,3]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=e.$dlc=void 0;class O{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new M.$Yg(w=>{const p=this.b.get(w.scheme);return!(p===void 0||p&1024)})}$acceptProviderInfos(w,p){p===null?this.b.delete(w.scheme):this.b.set(w.scheme,p)}isFreeScheme(w){return!this.b.has(w)&&!this.a.has(w)}getCapabilities(w){return this.b.get(w)}}e.$dlc=O,e.$elc=(0,A.$wi)("IExtHostFileSystemInfo")}),define(Ie[27],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=void 0,e.$GP=(0,I.$wi)("IExtHostInitDataService")}),define(Ie[217],Pe([1,0,176,12,201,27]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;let R=class extends A.$OQ{constructor(p,E,T){const D=T.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",d=T.remote.isRemote?(0,I.localize)(0,null):p?(0,I.localize)(1,null):(0,I.localize)(2,null);super(E.createLogger(D,{name:d}))}};e.$knc=R,e.$knc=R=Je([We(1,M.$4j),We(2,O.$GP)],R)}),define(Ie[218],Pe([1,0,11]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=e.$Vlc=void 0;class M{constructor(R,w,p){this.h=new Map,this.a=R,this.b=w,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new I.$Ih(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of E.values())T.complete()}catch(T){for(const D of E.values())D.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,w){let p=this.f[R];return typeof p>"u"&&(p=w),p}update(R,w){this.f[R]=w;const p=this.h.get(R);if(p!==void 0)return p.p;const E=new I.$Th;return this.h.set(R,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Vlc=M;class A extends M{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,w){super(R.identifier.value,!0,w),this.j=R}}e.$Wlc=A}),define(Ie[219],Pe([1,0,5,2]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=void 0;class A{constructor(R){this.c=R,this.a=new I.$ee,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$ee,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,w,p,E){const D=this.c.getNotebookDocument(M.URI.revive(R)).acceptModelChanged(w.value,p,E);this.b.fire(D)}$acceptDirtyStateChanged(R,w){this.c.getNotebookDocument(M.URI.revive(R)).acceptDirty(w)}$acceptModelSaved(R){const w=this.c.getNotebookDocument(M.URI.revive(R));this.a.fire(w.apiNotebook)}}e.$Kmc=A}),define(Ie[17],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$qP=void 0,e.$qP=(0,I.$wi)("IExtHostRpcService");class M{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$rP=M}),define(Ie[220],Pe([1,0,20,5]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class A{#e;constructor(R,w){this.b=new M.$ee,this.onDidChange=this.b.event,this.a=I.$Rm.toKey(R.identifier),this.#e=w,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(R){return this.#e.get(this.a,R)}store(R,w){return this.#e.store(this.a,R,w)}delete(R){return this.#e.delete(this.a,R)}}e.$6lc=A}),define(Ie[61],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=e.$tlc=void 0,e.$tlc=(0,I.$wi)("IURITransformerService");class M{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$ulc=M}),define(Ie[221],Pe([1,0,21]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Arb=A,e.$Brb=R;class M{constructor(){this.buffers=[]}add(p){let E=this.buffers.indexOf(p);return E<0&&(E=this.buffers.length,this.buffers.push(p)),E}}function A(w,p){if(p.serializeBuffersForPostMessage){const E=new M,D=JSON.stringify(w,(v,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(g)};if(ArrayBuffer.isView(g)){const r=O(g);if(r)return{$$vscode_array_buffer_reference$$:!0,index:E.add(g.buffer),view:{type:r,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),d=E.buffers.map(v=>{const g=new Uint8Array(v);return I.$Ge.wrap(g)});return{message:D,buffers:d}}else return{message:JSON.stringify(w),buffers:[]}}function O(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(w,p){const E=p.map(d=>{const v=new ArrayBuffer(d.byteLength);return new Uint8Array(v).set(d.buffer),v}),T=p.length?(d,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const g=v,{index:r}=g,o=E[r];if(g.view)switch(g.view.type){case 1:return new Int8Array(o,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(w,T),arrayBuffers:E}}}),define(Ie[106],Pe([1,0,185,15,2,6,3,29,38,16,44,145,33]),function(le,e,I,M,A,O,R,w,p,E,T,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$KF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$BF=e.EditorInputCapabilities=e.$AF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=void 0,e.$rF=r,e.$sF=o,e.$tF=s,e.$uF=i,e.$vF=n,e.$wF=c,e.$xF=l,e.$yF=t,e.$zF=f,e.$CF=b,e.$DF=k,e.$EF=y,e.$FF=C,e.$GF=P,e.$HF=W,e.$IF=V,e.$JF=ce,e.$LF=fe,e.$MF=Te,e.$NF=ae,e.$OF=Ne,e.$mF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$nF={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$oF="workbench.editor.sidebysideEditor",e.$pF="workbench.editors.textDiffEditor",e.$qF="workbench.editors.binaryResourceDiffEditor";var v;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var g;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function r(ne){const z=ne;return!!z&&typeof z.getSelection=="function"&&!!z.onDidChangeSelection}function o(ne){const z=ne;return!!z&&typeof z.getScrollPosition=="function"&&typeof z.setScrollPosition=="function"&&!!z.onDidChangeScroll}function s(ne,z,x){for(const ve of x.visibleEditorPanes)if(ve.group.id===z&&ne.matches(ve.input))return ve.getViewState()}function i(ne){if(b(ne))return!1;const z=ne;return A.URI.isUri(z?.resource)}function n(ne){if(b(ne))return!1;const z=ne;return z?.original!==void 0&&z.modified!==void 0}function c(ne){if(b(ne))return!1;const z=ne;return!z||z.resources&&!Array.isArray(z.resources)?!1:!!z.resources||!!z.multiDiffSource}function l(ne){if(b(ne)||n(ne))return!1;const z=ne;return z?.primary!==void 0&&z.secondary!==void 0}function t(ne){if(b(ne))return!1;const z=ne;return z?z.resource===void 0||z.resource.scheme===E.Schemas.untitled||z.forceUntitled===!0:!1}function f(ne){if(b(ne))return!1;const z=ne;return A.URI.isUri(z?.base?.resource)&&A.URI.isUri(z?.input1?.resource)&&A.URI.isUri(z?.input2?.resource)&&A.URI.isUri(z?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var $;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})($||(e.SaveReason=$={}));class u{constructor(){this.a=new Map}registerSource(z,x){let ve=this.a.get(z);return ve||(ve={source:z,label:x},this.a.set(z,ve)),ve.source}getSourceLabel(z){return this.a.get(z)?.label??z}}e.$AF=new u;var S;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class h extends O.$Vc{}e.$BF=h;function b(ne){return ne instanceof h}function m(ne){const z=ne;return A.URI.isUri(z?.preferredResource)}function k(ne){const z=ne;return b(z?.primary)&&b(z?.secondary)}function y(ne){const z=ne;return b(z?.modified)&&b(z?.original)}function C(ne,z,x,ve,Fe){return Ne(ve,[(0,D.$gj)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const De={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(z,De)}}),(0,D.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Fe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:d.default.Warning})}function P(ne){return b(ne?.editor)}function W(ne){const z=ne;return P(ne)&&z?.group!==void 0}function V(ne){const z=ne;return typeof z?.groupId=="number"&&b(z.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var N;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var U;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class K{getOriginalUri(z,x){if(!z)return;if(f(z))return e.$KF.getOriginalUri(z.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:De}=this.a(z);if(Fe&&De){if(x?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===U.ANY)return this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===U.PRIMARY?Fe:De}}if(n(z)||c(z)||l(z)||f(z))return;const ve=m(z)?z.preferredResource:z.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}a(z){return k(z)||l(z)?{primary:z.primary,secondary:z.secondary}:y(z)||n(z)?{primary:z.modified,secondary:z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(z,x){if(!z)return;if(f(z))return e.$KF.getCanonicalUri(z.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:De}=this.a(z);if(Fe&&De){if(x?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(De,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===U.ANY)return this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(De,{filterByScheme:x.filterByScheme});z=x.supportSideBySide===U.PRIMARY?Fe:De}}if(n(z)||c(z)||l(z)||f(z))return;const ve=z.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}b(z,x){if(Array.isArray(x)){if(x.some(ve=>z.scheme===ve))return z}else if(x===z.scheme)return z}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function ce(ne,z,x,ve){if(!ne.isSticky(z))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$KF=new K;var ye;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ye||(e.CloseDirection=ye={}));class Se{constructor(){this.c=new Map,this.d=new Map}start(z){const x=this.a=z.get(R.$vi);for(const[ve,Fe]of this.c)this.e(ve,Fe,x);this.c.clear()}e(z,x,ve){const Fe=ve.createInstance(x);this.d.set(z,Fe)}registerFileEditorFactory(z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=z}getFileEditorFactory(){return(0,M.$hg)(this.b)}registerEditorSerializer(z,x){if(this.c.has(z)||this.d.has(z))throw new Error(`A editor serializer with type ID '${z}' was already registered.`);return this.a?this.e(z,x,this.a):this.c.set(z,x),(0,O.$Tc)(()=>{this.c.delete(z),this.d.delete(z)})}getEditorSerializer(z){return this.d.get(typeof z=="string"?z:z.typeId)}}w.$co.add(e.$mF.EditorFactory,new Se);async function fe(ne,z,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async ve=>{const Fe=A.URI.revive(ve.fileUri);if(!Fe){x.info("Cannot resolve the path because it is not valid.",ve);return}if(!await z.canHandleResource(Fe)){x.info("Cannot resolve the path because it cannot be handled",ve);return}let we=ve.exists,ge=ve.type;if(typeof we!="boolean"||typeof ge!="number")try{ge=(await z.stat(Fe)).isDirectory?p.FileType.Directory:p.FileType.Unknown,we=!0}catch(Y){x.error(Y),we=!1}if(!we&&ve.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",ve);return}if(ge===p.FileType.Directory){x.info("Cannot resolve the path because it is a directory",ve);return}const Q={...ve.options,pinned:!0};return we?{resource:Fe,options:Q}:{resource:Fe,options:Q,forceUntitled:!0}}))}var $e;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})($e||(e.EditorsOrder=$e={}));function Te(ne){const z=ne;if(!z)return!1;const x=z;if(x.modified)return Te(x.modified);const ve=z;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function ae(ne){return(0,T.$ij)(ne)}function Ne(ne,z,x){const ve=(0,T.$jj)(ne,z);return ve.forceMessage=x?.forceMessage,ve.forceSeverity=x?.forceSeverity,ve.allowDialog=x?.allowDialog,ve}}),define(Ie[222],Pe([1,0,5,186,3,6,28,29,18,25,92,210]),function(le,e,I,M,A,O,R,w,p,E,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WF=e.$VF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$UF=e.ViewContentGroups=e.$SF=e.ViewContainerLocation=e.Extensions=e.$RF=e.$QF=e.$PF=void 0,e.$TF=g,e.$PF="views",e.$QF=(0,M.localize)(0,null),e.$RF=(0,D.$_w)("default-view-icon",T.$Vj.window,(0,M.localize)(1,null));var d;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(d||(e.Extensions=d={}));var v;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$SF=[0,1,2];function g(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class r extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new I.$ee),this.onDidRegister=this.c.event,this.f=this.B(new I.$ee),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,p.$Rb)([...this.g.values()])}registerViewContainer(a,$,u){const S=this.get(a.id);if(S)return S;const h=a;return h.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:h.openCommandActionDescriptor??{id:h.id},(0,R.$yc)(this.g,$,[]).push(h),u?.isDefault&&this.h.push(h),this.c.fire({viewContainer:h,viewContainerLocation:$}),h}deregisterViewContainer(a){for(const $ of this.g.keys()){const u=this.g.get($),S=u?.indexOf(a);if(S!==-1){u?.splice(S,1),u.length===0&&this.g.delete($),this.f.fire({viewContainer:a,viewContainerLocation:$});return}}}get(a){return this.all.filter($=>$.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(u=>u?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find($=>this.getViewContainerLocation($)===a)}}w.$co.add(d.ViewContainersRegistry,new r);var o;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(f,a){const $=f.group??o.More,u=a.group??o.More;return $!==u?$.localeCompare(u):(f.order??5)-(a.order??5)}class i extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new I.$ee),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$ee),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$ee),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$ee),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Ic}registerViews(a,$){this.registerViews2([{views:a,viewContainer:$}])}registerViews2(a){a.forEach(({views:$,viewContainer:u})=>this.r($,u)),this.c.fire(a)}deregisterViews(a,$){const u=this.s(a,$);u.length&&this.f.fire({views:u,viewContainer:$})}moveViews(a,$){for(const u of this.m.keys())if(u!==$){const S=this.s(a,u);S.length&&(this.r(S,$),this.g.fire({views:S,from:u,to:$}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const $ of this.j){const u=(this.m.get($)||[]).filter(S=>S.id===a)[0];if(u)return u}return null}getViewContainer(a){for(const $ of this.j)if((this.m.get($)||[]).filter(S=>S.id===a)[0])return $;return null}registerViewWelcomeContent(a,$){return this.n.add(a,$),this.h.fire(a),(0,O.$Tc)(()=>{this.n.delete(a,$),this.h.fire(a)})}registerViewWelcomeContent2(a,$){const u=new Map;for(const[S,h]of $)this.n.add(a,h),u.set(S,(0,O.$Tc)(()=>{this.n.delete(a,h),this.h.fire(a)}));return this.h.fire(a),u}getViewWelcomeContent(a){const $=[];return this.n.forEach(a,u=>$.push(u)),$.sort(s)}r(a,$){let u=this.m.get($);u||(u=[],this.m.set($,u),this.j.push($));for(const S of a){if(this.getView(S.id)!==null)throw new Error((0,M.localize)(2,null,S.id));u.push(S)}}s(a,$){const u=this.m.get($);if(!u)return[];const S=[],h=[];for(const b of u)a.includes(b)?S.push(b):h.push(b);return S.length&&(h.length?this.m.set($,h):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),S}}w.$co.add(d.ViewsRegistry,new i),e.$UF=(0,A.$wi)("viewDescriptorService");var n;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var c;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class l{constructor(a,$){this.c=!1,this.d=!1,(0,E.$6n)(this,a),this.d=!!$,this.resolve=async u=>{if($&&!this.c){const S=await $(u);S&&(this.tooltip=this.tooltip??S.tooltip,this.command=this.command??S.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$VF=l;class t extends Error{constructor(a){super((0,M.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$WF=t}),define(Ie[223],Pe([1,0,187,31]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=void 0,e.$1F=new M.$Nj("chatSessionResponseVote","",{type:"string",description:(0,I.localize)(0,null)}),e.$2F=new M.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,I.localize)(1,null)}),e.$3F=new M.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,I.localize)(2,null)}),e.$4F=new M.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,I.localize)(3,null)}),e.$5F=new M.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,I.localize)(4,null)}),e.$6F=new M.$Nj("chatResponse",!1,{type:"boolean",description:(0,I.localize)(5,null)}),e.$7F=new M.$Nj("chatRequest",!1,{type:"boolean",description:(0,I.localize)(6,null)}),e.$8F=new M.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,I.localize)(7,null)}),e.$9F=new M.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,I.localize)(8,null)}),e.$0F=new M.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,I.localize)(9,null)}),e.$$F=new M.$Nj("inChatInput",!1,{type:"boolean",description:(0,I.localize)(10,null)}),e.$_F=new M.$Nj("inChat",!1,{type:"boolean",description:(0,I.localize)(11,null)}),e.$aG=new M.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,I.localize)(12,null)}),e.$bG=new M.$Nj("chatCursorAtTop",!1),e.$cG=new M.$Nj("chatInputHasAgent",!1),e.$dG=new M.$Nj("chatLocation",void 0)}),define(Ie[224],Pe([1,0,11,24,5,42,6,132,13,31,3,12,102,204,216,223]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.ChatAgentLocation=void 0;var s;(function(l){l.Panel="panel",l.Terminal="terminal",l.Notebook="notebook",l.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(l){function t(f){switch(f){case"panel":return l.Panel;case"terminal":return l.Terminal;case"notebook":return l.Notebook;case"editor":return l.Editor}return l.Panel}l.fromRaw=t}(s||(e.ChatAgentLocation=s={})),e.$bH=(0,T.$wi)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new A.$ee,this.onDidChangeAgents=this.d.event,this.e=r.$aG.bindTo(this.f)}registerAgent(t,f){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const $=this,u=f.slashCommands;f={...f,get slashCommands(){return u.filter(h=>!h.when||$.f.contextMatchesRules(E.$uj.deserialize(h.when)))}};const S={data:f};return this.b.push(S),(0,R.$Tc)(()=>{this.b=this.b.filter(h=>h!==S),this.d.fire(void 0)})}registerAgentImplementation(t,f){const a=this.g(t);if(!a)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(a.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return a.data.isDefault&&this.e.set(!0),a.impl=f,this.d.fire(new n(a.data,f)),(0,R.$Tc)(()=>{a.impl=void 0,this.d.fire(void 0),a.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,f){const a={data:t,impl:f};return this.b.push(a),this.d.fire(new n(t,f)),(0,R.$Tc)(()=>{this.b=this.b.filter($=>$!==a),this.d.fire(void 0)})}updateAgent(t,f){const a=this.g(t);if(!a?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);a.data.metadata={...a.data.metadata,...f},this.d.fire(new n(a.data,a.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(f=>!!f.isDefault&&f.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(f=>!!f.isDefault&&f.locations.includes(t))}getSecondaryAgent(){return O.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(f=>f.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new n(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(f=>f.name===t)}async invokeAgent(t,f,a,$,u){const S=this.g(t);if(!S?.impl)throw new Error(`No activated agent with id ${t}`);return await S.impl.invoke(f,a,$,u)}async getFollowups(t,f,a,$,u){const S=this.g(t);if(!S?.impl)throw new Error(`No activated agent with id ${t}`);return S.impl?.provideFollowups?S.impl.provideFollowups(f,a,$,u):[]}};e.$cH=i,e.$cH=i=Je([We(0,E.$Oj)],i);class n{constructor(t,f){this.b=t,this.d=f}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,f,a,$){return this.d.invoke(t,f,a,$)}async provideFollowups(t,f,a,$){return this.d.provideFollowups?this.d.provideFollowups(t,f,a,$):[]}provideWelcomeMessage(t,f){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,f)}provideSampleQuestions(t,f){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,f)}}e.$dH=n,e.$eH=(0,T.$wi)("chatAgentNameService");let c=class{static{o=this}static{this.b="chat.participantNameRegistry"}constructor(t,f,a,$){if(this.g=f,this.h=a,this.i=$,this.e=(0,w.$2d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const u=$.get(o.b,-1);try{this.e.set(JSON.parse(u??"{}"),void 0)}catch{$.remove(o.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,I.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},M.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const f=await(0,v.$Tp)(t);if(!f||f.version!==1)throw new Error("Unexpected chat participant registry response.");const a=f.restrictedChatParticipants;this.e.set(a,void 0),this.i.store(o.b,JSON.stringify(a),-1,1)}getAgentNameRestriction(t){return this.e.map(a=>a[t.name.toLowerCase()]).map(a=>a?a.some($=>(0,p.$yf)($,$.includes(".")?t.extensionId.value:t.extensionPublisher)):!0)}dispose(){this.f=!0}};e.$fH=c,e.$fH=c=o=Je([We(0,d.$jk),We(1,v.$Np),We(2,D.$3j),We(3,g.$1p)],c)}),define(Ie[225],Pe([1,0,2,30,3]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lG=e.$kG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$iG=O,e.$jG=R;function O(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof I.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(M.$ut.isIRange)}function R(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(O)}var w;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(w||(e.InteractiveSessionVoteDirection=w={}));var p;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$kG=(0,A.$wi)("IChatService"),e.$lG="accessibility.voice.keywordActivation"}),define(Ie[226],Pe([1,0,5,11,188]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nrb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new I.$ee,this.o=new I.$ee,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(w){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=w}onEvent(w){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=w}onRequest(w){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=w}sendResponse(w){w.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.u("response",w)}sendRequest(w,p,E,T){const D={command:w};if(p&&Object.keys(p).length>0&&(D.arguments=p),this.u("request",D),typeof T=="number"){const d=setTimeout(()=>{clearTimeout(d);const v=this.f.get(D.seq);if(v){this.f.delete(D.seq);const g={type:"response",seq:0,request_seq:D.seq,success:!1,command:w,message:(0,A.localize)(0,null,T,w)};v(g)}},T)}return E&&this.f.set(D.seq,E),D.seq}acceptMessage(w){this.k?this.k(w):(this.m.push(w),this.m.length===1&&this.s())}q(w,p){return w.type!=="event"||p.type!=="event"}async s(){let w;for(;this.m.length;){if((!w||this.q(this.m[0],w))&&await(0,M.$xh)(0),w=this.m.shift(),!w)return;switch(w.type){case"event":this.j?.(w);break;case"request":this.g?.(w);break;case"response":{const p=w,E=this.f.get(p.request_seq);E&&(this.f.delete(p.request_seq),E(p));break}}}}u(w,p){p.type=w,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const w=new Map;this.f.forEach((p,E)=>w.set(E,p)),await(0,M.$xh)(500),w.forEach((p,E)=>{p({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Nrb=O}),define(Ie[227],Pe([1,0,2,189,31,3]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$vJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$tJ=e.MemoryRangeType=e.State=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=void 0,e.$sJ=p,e.$uJ=T,e.$gI="workbench.view.debug",e.$hI="workbench.debug.variablesView",e.$iI="workbench.debug.watchExpressionsView",e.$jI="workbench.debug.callStackView",e.$kI="workbench.debug.loadedScriptsView",e.$lI="workbench.debug.breakPointsView",e.$mI="workbench.debug.disassemblyView",e.$nI="workbench.panel.repl",e.$oI="workbench.panel.repl.view",e.$pI=new A.$Nj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$qI=new A.$Nj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$rI=new A.$Nj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$sI="debugUx",e.$tI=new A.$Nj(e.$sI,"default",{type:"string",description:M.localize(3,null)}),e.$uI=new A.$Nj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$vI=new A.$Nj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$wI=new A.$Nj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$xI=new A.$Nj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$yI=new A.$Nj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$zI=new A.$Nj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$AI=new A.$Nj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$BI=new A.$Nj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$CI=new A.$Nj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$DI=new A.$Nj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$EI=new A.$Nj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$FI=new A.$Nj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$GI=new A.$Nj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$HI=new A.$Nj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$II=new A.$Nj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$JI=new A.$Nj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$KI=new A.$Nj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$LI=new A.$Nj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$MI=new A.$Nj("breakpointItemBytes",void 0,{type:"boolean",description:M.localize(22,null)}),e.$NI=new A.$Nj("breakpointHasModes",!1,{type:"boolean",description:M.localize(23,null)}),e.$OI=new A.$Nj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(24,null)}),e.$PI=new A.$Nj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(25,null)}),e.$QI=new A.$Nj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(26,null)}),e.$RI=new A.$Nj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(27,null)}),e.$SI=new A.$Nj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(28,null)}),e.$TI=new A.$Nj("stepBackSupported",!1,{type:"boolean",description:M.localize(29,null)}),e.$UI=new A.$Nj("restartFrameSupported",!1,{type:"boolean",description:M.localize(30,null)}),e.$VI=new A.$Nj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(31,null)}),e.$WI=new A.$Nj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(32,null)}),e.$XI=new A.$Nj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(33,null)}),e.$YI=new A.$Nj("breakpointsExist",!1,{type:"boolean",description:M.localize(34,null)}),e.$ZI=new A.$Nj("debuggersAvailable",!1,{type:"boolean",description:M.localize(35,null)}),e.$1I=new A.$Nj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(36,null)}),e.$2I=new A.$Nj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(37,null)}),e.$3I=new A.$Nj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$4I=new A.$Nj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$5I=new A.$Nj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$6I=new A.$Nj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$7I=new A.$Nj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$8I=new A.$Nj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(43,null)}),e.$9I=new A.$Nj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(44,null)}),e.$0I=new A.$Nj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(45,null)}),e.$$I=new A.$Nj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(46,null)}),e.$_I=new A.$Nj("variableIsReadonly",!1,{type:"boolean",description:M.localize(47,null)}),e.$aJ=new A.$Nj("variableValue",!1,{type:"string",description:M.localize(48,null)}),e.$bJ=new A.$Nj("variableType",!1,{type:"string",description:M.localize(49,null)}),e.$cJ=new A.$Nj("variableInterfaces",!1,{type:"array",description:M.localize(50,null)}),e.$dJ=new A.$Nj("variableName",!1,{type:"string",description:M.localize(51,null)}),e.$eJ=new A.$Nj("variableLanguage",!1,{type:"string",description:M.localize(52,null)}),e.$fJ=new A.$Nj("variableExtensionId",!1,{type:"string",description:M.localize(53,null)}),e.$gJ=new A.$Nj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(54,null)}),e.$hJ=new A.$Nj("multiSessionRepl",!1,{type:"boolean",description:M.localize(55,null)}),e.$iJ=new A.$Nj("multiSessionDebug",!1,{type:"boolean",description:M.localize(56,null)}),e.$jJ=new A.$Nj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(57,null)}),e.$kJ=new A.$Nj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(58,null)}),e.$lJ=new A.$Nj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(59,null)}),e.$mJ=new A.$Nj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(60,null)});const R=n=>M.localize(61,null,n);e.$nJ=R,e.$oJ="editor.contrib.debug",e.$pJ="editor.contrib.breakpoint",e.$qJ="debug",e.$rJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(62,null)};var w;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(w||(e.State=w={}));function p(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$tJ="vscode-debug-memory";function T(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var D;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(D||(e.DataBreakpointSetType=D={}));var d;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(d||(e.DebugConfigurationProviderTriggerKind=d={}));var v;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(v||(e.DebuggerString=v={})),e.$vJ=(0,O.$wi)("debugService");var g;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(g||(e.BreakpointWidgetContext=g={}));var r;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var s;(function(n){n.deserialize=c=>c,n.serialize=c=>c})(s||(e.IDebugVisualizationTreeItem=s={}));var i;(function(n){n.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:I.URI.revive(c.iconPath.light),dark:I.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),n.serialize=c=>c})(i||(e.IDebugVisualization=i={}))}),define(Ie[228],Pe([1,0,13,2,19,25,16,30,24,18]),function(le,e,I,M,A,O,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=void 0,e.$iH=D,e.$jH=d,e.$kH=v,e.$lH=g,e.$mH=r,e.$nH=o,e.$oH=s,e.$pH=n,e.$qH=t,e.$rH=f,e.$sH=$,e.$tH=S;const T=/{([^}]+)}/g;function D(b,m,k){return b.replace(T,function(y,C){return m&&C.length>0&&C[0]!=="_"?y:k&&k.hasOwnProperty(C)?k[C]:y})}function d(b){const m={};for(const k of Object.keys(b))k.startsWith("!")||(m[k]=b[k]);return m}function v(b){return b.configuration.request==="attach"&&!g(b)&&(!b.parentSession||v(b.parentSession))}function g(b){let m=b.configuration.type;if(m)return m==="vslsShare"&&(m=b.configuration.adapterProxy.configuration.type),(0,I.$yf)(m,"extensionhost")||(0,I.$yf)(m,"pwa-extensionhost")?b:b.parentSession?g(b.parentSession):void 0}function r(b){return b.type&&(b.label||b.program||b.runtime)}function o(b,m,k){let y,C=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=P.exec(b);){const V=W.index+1,q=V+W[0].length;if(V<=m&&q>=k){y=W[0],C=V;break}}if(y){const V=/\w+/g;let q=null;for(;(q=V.exec(y))&&!(q.index+1+C+q[0].length>=k););q&&(y=y.substring(0,V.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function s(b,m,k,y){if(b.evaluatableExpressionProvider.has(m)){const C=b.evaluatableExpressionProvider.ordered(m),P=(0,E.$Hb)(await Promise.all(C.map(async W=>{try{return await W.provideEvaluatableExpression(m,k,y??p.CancellationToken.None)}catch{return}})));if(P.length>0){let W=P[0].expression;const V=P[0].range;return W||(W=m.getLineContent(k.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const C=m.getLineContent(k.lineNumber),{start:P,end:W}=o(C,k.column,k.column),V=C.substring(P-1,W);return{matchingExpression:V,range:new w.$ut(k.lineNumber,P,k.lineNumber,P+V.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(b){return!!(b&&b.match(i))}function c(b){if(typeof b.path=="string"&&!(typeof b.sourceReference=="number"&&b.sourceReference>0)){if(n(b.path))return M.URI.parse(b.path);if((0,A.$jc)(b.path))return M.URI.file(b.path)}return b.path}function l(b){if(typeof b.path=="object"){const m=M.URI.revive(b.path);if(m)return m.scheme===R.Schemas.file?m.fsPath:m.toString()}return b.path}function t(b,m){const k=m?c:l,y=(0,O.$3n)(b);return a(y,(C,P)=>{C&&P&&(P.path=k(P))}),y}function f(b,m){const k=m?c:l,y=(0,O.$3n)(b);return a(y,(C,P)=>{!C&&P&&(P.path=k(P))}),y}function a(b,m){switch(b.type){case"event":{const k=b;switch(k.event){case"output":m(!1,k.body.source);break;case"loadedSource":m(!1,k.body.source);break;case"breakpoint":m(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=b;switch(k.command){case"setBreakpoints":m(!0,k.arguments.source);break;case"breakpointLocations":m(!0,k.arguments.source);break;case"source":m(!0,k.arguments.source);break;case"gotoTargets":m(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(y=>m(!1,y));break;default:break}break}case"response":{const k=b;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(y=>m(!1,y.source));break;case"loadedSources":k.body.sources.forEach(y=>m(!1,y));break;case"scopes":k.body.scopes.forEach(y=>m(!1,y.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(y=>m(!1,y.source));break;case"setBreakpoints":k.body.breakpoints.forEach(y=>m(!1,y.source));break;case"disassemble":k.body?.instructions.forEach(C=>m(!1,C.location));break;default:break}break}}}function $(b){return b.filter(m=>!m.presentation?.hidden).sort((m,k)=>m.presentation?k.presentation?m.presentation.group?k.presentation.group?m.presentation.group!==k.presentation.group?m.presentation.group.localeCompare(k.presentation.group):u(m.presentation.order,k.presentation.order):-1:k.presentation.group?1:u(m.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function u(b,m){return typeof b!="number"?typeof m!="number"?0:1:typeof m!="number"?-1:b-m}async function S(b,m){const k=b.getValue("debug.saveBeforeStart",{overrideIdentifier:m.activeTextEditorLanguageId});if(k!=="none"&&(await m.saveAll(),k==="allEditorsInActiveGroup")){const y=m.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await m.save({editor:y.input,groupId:y.group.id})}await b.reloadConfiguration()}const h=(b,m)=>!b||!m?b===m:b.name===m.name&&b.path===m.path&&b.sourceReference===m.sourceReference;e.$uH=h}),define(Ie[229],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IK=e.CellExecutionUpdateType=void 0;var M;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$IK=(0,I.$wi)("INotebookExecutionService")}),define(Ie[230],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejb=e.$djb=e.ProxyKernelState=e.$cjb=void 0,e.$cjb=100;var M;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$djb=(0,I.$wi)("INotebookKernelService"),e.$ejb=(0,I.$wi)("INotebookKernelHistoryService")}),define(Ie[231],Pe([1,0,6,30,156,96]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gXb=void 0;class R extends I.$Vc{constructor(p,E,T){super(),this._source=p,this.b=E,this.c=T,this.a=void 0}f(p){const E=p.getLineCount();return new M.$ut(1,1,E,this.g(p,E))}g(p,E){if(E<1||E>p.getLineCount())throw new Error("Illegal value for lineNumber");return p.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const p=new A.$VC;p.acceptChunk(this._source);const E=p.finish(!0),{textBuffer:T,disposable:D}=E.create(1);this.b=T,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(p=>{const E=new A.$VC;E.acceptChunk(p);const T=E.finish(!0),{textBuffer:D,disposable:d}=T.create(1);return this.B(d),D})),this.a}findInInputs(p){const T=new O.$JC(p,!1,!1,null).parseSearchRequest();if(!T)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,T,!0,5e3)}findInOutputs(p){const T=new O.$JC(p,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(D=>{const d=D.findMatchesLineByLine(this.f(D),T,!0,5e3);if(d.length!==0)return{textBuffer:D,matches:d}}).filter(D=>!!D):[]}}e.$gXb=R}),define(Ie[52],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(O){O.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var M;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class A{static fromExtHostTestItem(R,w,p=R.parent){if(R._isRoot)return new A([w]);const E=[R.id];for(let T=p;T&&T.id!==w;T=T.parent)E.push(T.id);return E.push(w),new A(E.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const w=R.indexOf("\0");return w===-1?R:R.slice(0,w)}static fromString(R){return new A(R.split("\0"))}static join(R,w){return new A([...R.path,w])}static joinToString(R,w){return R.toString()+"\0"+w}static parentId(R){const w=R.lastIndexOf("\0");return w===-1?void 0:R.slice(0,w)}static localId(R){const w=R.lastIndexOf("\0");return w===-1?R:R.slice(w+1)}static isChild(R,w){return w.startsWith(R)&&w[R.length]==="\0"}static compare(R,w){return R===w?0:A.isChild(R,w)?2:A.isChild(w,R)?3:1}constructor(R,w=R.length){if(this.path=R,this.d=w,R.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new A(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new A(this.path,R)}compare(R){if(typeof R=="string")return A.compare(this.toString(),R);for(let w=0;w<R.d&&w<this.d;w++)if(R.path[w]!==this.path[w])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$OL=A}),define(Ie[62],Pe([1,0,2,94,30,52]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$WL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$VL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$UL=e.$TL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$SL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$RL=e.$QL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$PL=e.TestResultState=void 0;var R;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$PL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var w;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(w||(e.ExtTestRunProfileKind=w={}));var p;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$QL=[2,4,8,16,32,64];const E=N=>"runId"in N;e.$RL=E;var T;(function(N){N.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),N.deserialize=(U,K)=>({range:A.$ut.lift(K.range),uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var D;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(D||(e.TestMessageType=D={}));var d;(function(N){N.serialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&T.serialize(U.location)}),N.deserialize=(U,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(U,K.location)})})(d||(e.ITestErrorMessage=d={}));const v=(N,U)=>`${U?"s":"e"}${N}`;e.$SL=v;var g;(function(N){N.serialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&T.serialize(U.location)}),N.deserialize=(U,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(U,K.location)})})(g||(e.ITestOutputMessage=g={}));var r;(function(N){N.serialize=U=>U.type===0?d.serialize(U):g.serialize(U),N.deserialize=(U,K)=>K.type===0?d.deserialize(U,K):g.deserialize(U,K)})(r||(e.ITestMessage=r={}));var o;(function(N){N.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),N.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(r.serialize)}),N.deserialize=(U,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>r.deserialize(U,ie))})})(o||(e.ITestTaskState=o={}));const s="\0",i=(N,U)=>N+s+U;e.$TL=i;const n=N=>{const U=N.indexOf(s);return{ctrlId:N.slice(0,U),tagId:N.slice(U+1)}};e.$UL=n;var c;(function(N){N.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),N.deserialize=(U,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?U.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?A.$ut.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var l;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(N){N.serialize=U=>({expand:U.expand,item:c.serialize(U.item)}),N.deserialize=(U,K)=>({controllerId:O.$OL.root(K.item.extId),expand:K.expand,item:c.deserialize(U,K.item)})})(t||(e.InternalTestItem=t={}));var f;(function(N){N.serialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.uri!==void 0&&(K.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(K.range=U.item.range?.toJSON()),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}},N.deserialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.range!==void 0&&(K.range=U.item.range?A.$ut.lift(U.item.range):null),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}}})(f||(e.ITestItemUpdate=f={}));const a=(N,U)=>{U.expand!==void 0&&(N.expand=U.expand),U.item!==void 0&&(N.item=N.item?Object.assign(N.item,U.item):U.item)};e.$VL=a;var $;(function(N){N.serializeWithoutMessages=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serializeWithoutMessages)}),N.serialize=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serialize)}),N.deserialize=(U,K)=>({...t.deserialize(U,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>o.deserialize(U,ie)),retired:!0})})($||(e.TestResultItem=$={}));var u;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(U,K)=>{U.covered+=K.covered,U.total+=K.total}})(u||(e.ICoverageCount=u={}));var S;(function(N){N.serialize=U=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:U.uri.toJSON()}),N.deserialize=(U,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:U.asCanonicalUri(I.URI.revive(K.uri))})})(S||(e.IFileCoverage=S={}));function h(N){return{...N,location:N.location?.toJSON()}}function b(N){return N.location=N.location?M.$tt.isIPosition(N.location)?M.$tt.lift(N.location):A.$ut.lift(N.location):void 0,N}e.$WL=3;var m;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(m||(e.DetailType=m={}));var k;(function(N){N.serialize=U=>U.type===0?C.serialize(U):P.serialize(U),N.deserialize=U=>U.type===0?C.deserialize(U):P.deserialize(U)})(k||(e.CoverageDetails=k={}));var y;(function(N){N.serialize=h,N.deserialize=b})(y||(e.IBranchCoverage=y={}));var C;(function(N){N.serialize=h,N.deserialize=b})(C||(e.IDeclarationCoverage=C={}));var P;(function(N){N.serialize=U=>({...h(U),branches:U.branches?.map(y.serialize)}),N.deserialize=U=>({...b(U),branches:U.branches?.map(y.deserialize)})})(P||(e.IStatementCoverage=P={}));var W;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(N){N.deserialize=(U,K)=>K.op===0?{op:K.op,item:t.deserialize(U,K.item)}:K.op===1?{op:K.op,item:f.deserialize(K.item)}:K.op===2?{op:K.op,uri:U.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,N.serialize=U=>U.op===0?{op:U.op,item:t.serialize(U.item)}:U.op===1?{op:U.op,item:f.serialize(U.item)}:U})(V||(e.TestsDiffOp=V={}));class q{constructor(U){this.k=U,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(U){const K=this.v();for(const ie of U)switch(ie.op){case 0:this.l(t.deserialize(this.k,ie.item),K);break;case 1:this.o(f.deserialize(ie.item),K);break;case 3:this.p(ie.itemId,K);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}K.complete?.()}l(U,K){const ie=O.$OL.parentId(U.item.extId)?.toString();let ce;if(!ie)ce=this.w(U),this.g.add(ce),this.f.set(U.item.extId,ce);else if(this.f.has(ie)){const ye=this.f.get(ie);ye.children.add(U.item.extId),ce=this.w(U,ye),this.f.set(U.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return K.add?.(ce),U.expand===2&&this.h++,ce}o(U,K){const ie=this.f.get(U.extId);if(ie)return U.expand!==void 0&&(ie.expand===2&&this.h--,U.expand===2&&this.h++),(0,e.$VL)(ie,U),K.update?.(ie),ie}p(U,K){const ie=this.f.get(U);if(!ie)return;const ce=O.$OL.parentId(ie.item.extId)?.toString();ce?this.f.get(ce).children.delete(ie.item.extId):this.g.delete(ie);const ye=[[U]];for(;ye.length;)for(const Se of ye.pop()){const fe=this.f.get(Se);fe&&(ye.push(fe.children),this.f.delete(Se),K.remove?.(fe,fe!==ie),fe.expand===2&&this.h--)}}q(U){}updatePendingRoots(U){this.j+=U}v(){return{}}}e.$XL=q}),define(Ie[77],Pe([1,0,11,5,6,57,62,52]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.TestItemEventOp=void 0;var p;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const E=(i,n)=>i===n,D=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:E,label:E,description:E,error:E,sortText:E,tags:(i,n)=>!(i.length!==n.length||i.some(c=>!n.includes(c)))}),d=(i,n)=>{let c;for(const[l,t]of D)t(i[l],n[l])||(c?c[l]=n[l]:c={[l]:n[l]});return c};class v extends A.$Vc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new I.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new M.$ee),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===n.uri){c.docv=n.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===n.item.extId){(0,R.$VL)(c.item,n.item);return}if(c.op===0&&c.item.item.extId===n.item.extId){(0,R.$VL)(c.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,c){const l=this.tree.get(n);if(l){if((l.expandLevels===void 0||c>l.expandLevels)&&(l.expandLevels=c),l.expand===1){const t=this.M(l);return t.isOpen()?this.L(l,c-1):t.wait().then(()=>this.L(l,c-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,c-1)):this.L(l,c-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,c){switch(c.op){case 3:this.O(w.$OL.joinToString(n.fullId,c.id));break;case 0:this.z(c.item,n);break;case 5:for(const l of c.ops)this.w(n,l);break;case 1:this.C(c.new,c.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:c.update}});break;case 6:this.y(n.actual.uri);break;default:(0,O.$fd)(c)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,c){const l=w.$OL.fromExtHostTestItem(n,this.root.id,c?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(n.id);let f=this.tree.get(l.toString());if(!f){f={fullId:l,actual:n,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(n,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(n)}}),this.I(n,f,c);return}if(f.actual===n){this.H(n,f,c);return}if(f.actual.uri?.toString()!==n.uri?.toString())return this.O(l.toString()),this.z(n,c);const a=this.s.getChildren(f.actual),$=f.actual,u=d(this.s.toITestItem($),this.s.toITestItem(n));this.s.getApiFor($).listener=void 0,f.actual=n,f.resolveBarrier=void 0,f.expand=0,u&&(u.hasOwnProperty("tags")&&(this.C(n.tags,$.tags,l.toString()),delete u.tags),this.w(f,{op:4,update:u})),this.I(n,f,c);for(const[h,b]of a)this.s.getChildren(n).get(b.id)||this.O(w.$OL.joinToString(l,b.id));const S=f.expandLevels;S!==void 0&&queueMicrotask(()=>{f.expand===1&&(f.expandLevels=void 0,this.expand(l.toString(),S))}),this.y(f.actual.uri)}C(n,c,l){const t=new Set(c.map(f=>f.id));for(const f of n)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:l,item:{tags:n.map(f=>(0,R.$TL)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(n){const c=this.j.get(n.id);c?c.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$TL)(this.s.controllerId,n.id)}}))}F(n){const c=this.j.get(n);c&&!--c.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$TL)(this.s.controllerId,n)}))}G(n,c){this.s.getApiFor(n).parent=c&&c.actual!==this.root?c.actual:void 0}H(n,c,l){this.G(n,l);const t=this.s.getApiFor(n);t.parent=l?.actual,t.listener=f=>this.w(c,f),this.J(c)}I(n,c,l){this.H(n,c,l);for(const[t,f]of this.s.getChildren(n))this.z(f,c)}J(n){let c;this.h?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:c}}),c===1&&n.expandLevels!==void 0&&this.M(n))}L(n,c){if(c<0)return;const l=[];for(const[t,f]of this.s.getChildren(n.actual)){const a=this.expand(w.$OL.joinToString(n.fullId,f.id),c);(0,I.$ih)(a)&&l.push(a)}if(l.length)return Promise.all(l).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const f=new I.$vh;return f.open(),f}n.expand=2,this.N(n);const c=n.resolveBarrier=new I.$vh,l=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(f){l(f)}return(0,I.$ih)(t)?t.catch(l).then(()=>{c.open(),this.J(n)}):(c.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const l=[c];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,a]of this.s.getChildren(t.actual))l.push(this.tree.get(w.$OL.joinToString(t.fullId,a.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$gP=v;class g extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$hP=g;class r extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$iP=r;class o extends Error{constructor(n,c,l){super(`TestItem with ID "${n}" is from controller "${c}" and cannot be added as a child of an item from controller "${l}".`)}}e.$jP=o;const s=(i,n,c)=>{let l=new Map;return{get size(){return l.size},forEach(t,f){for(const a of l.values())t.call(f,a,this)},[Symbol.iterator](){return l.entries()},replace(t){const f=new Map,a=new Set(l.keys()),$={op:5,ops:[]};for(const u of t){if(!(u instanceof c))throw new r(u.id);const S=n(u).controllerId;if(S!==i.controllerId)throw new o(u.id,S,i.controllerId);if(f.has(u.id))throw new g(u.id);f.set(u.id,u),a.delete(u.id),$.ops.push({op:0,item:u})}for(const u of a.keys())$.ops.push({op:3,id:u});i.listener?.($),l=f},add(t){if(!(t instanceof c))throw new r(t.id);l.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){l.delete(t)&&i.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$kP=s}),define(Ie[107],Pe([1,0,77]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=e.$lP=void 0;const M=new WeakMap,A=(R,w)=>{const p={controllerId:w};return M.set(R,p),p};e.$lP=A;const O=R=>{const w=M.get(R);if(!w)throw new I.$iP(R?.id||"<unknown>");return w};e.$mP=O}),define(Ie[78],Pe([1,0,16,2]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NAb=e.$MAb=e.$LAb=void 0,e.$OAb=A,e.$PAb=R,e.$LAb="vscode-cdn.net",e.$MAb=`vscode-resource.${e.$LAb}`,e.$NAb=`'self' https://*.${e.$LAb}`;function A(w,p){return w.scheme===I.Schemas.http||w.scheme===I.Schemas.https?w:(p&&p.authority&&p.isRemote&&w.scheme===I.Schemas.file&&(w=M.URI.from({scheme:I.Schemas.vscodeRemote,authority:p.authority,path:w.path})),M.URI.from({scheme:I.Schemas.https,authority:`${w.scheme}+${O(w.authority)}.${e.$MAb}`,path:w.path,fragment:w.fragment,query:w.query}))}function O(w){return w.replace(/./g,p=>{const E=p.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?p:"-"+E.toString(16).padStart(4,"0")})}function R(w){return w.replace(/-([0-9a-f]{4})/g,(p,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Ie[232],Pe([1,0,5,6,78]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=void 0;class O{constructor(w,p,E){this.d=w,this.e=p,this.f=E,this.a=0,this.b=new M.$Uc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const T=p.getVisibleTextEditors();for(const D of this.c.values())T.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(w=>w.inset.dispose()),this.b.dispose()}createWebviewEditorInset(w,p,E,T,D){let d;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===w){d=n;break}if(!d)throw new Error("not a visible editor");const v=this,g=this.a++,r=new I.$ee,o=new I.$ee,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,A.$OAb)(n,v.f)}get cspSource(){return A.$NAb}set options(n){this.b=n,v.d.$setOptions(g,n)}get options(){return this.b}set html(n){this.a=n,v.d.$setHtml(g,n)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(n){return v.d.$postMessage(g,n)}},i=new class{constructor(){this.editor=w,this.line=p,this.height=E,this.webview=s,this.onDidDispose=o.event}dispose(){v.c.has(g)&&(v.c.delete(g),v.d.$disposeEditorInset(g),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(g,d.id,d.value.document.uri,p+1,E,T||{},D.identifier,D.extensionLocation),this.c.set(g,{editor:w,inset:i,onDidReceiveMessage:r}),i}$onDidDispose(w){const p=this.c.get(w);p&&p.inset.dispose()}$onDidReceiveMessage(w,p){this.c.get(w)?.onDidReceiveMessage.fire(p)}}e.$rlc=O}),define(Ie[108],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=e.$5L=void 0,e.$5L="__",e.$6L=(0,I.$wi)("IAuthenticationService"),e.$7L=(0,I.$wi)("IAuthenticationExtensionsService")}),define(Ie[233],Pe([1,0,3]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.VariableKind=e.$cQ=void 0,e.$cQ=(0,I.$wi)("configurationResolverService");var M;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class A extends Error{constructor(R,w){super(w),this.variable=R}}e.$dQ=A}),define(Ie[234],Pe([1,0,19,75,15,25,22,97,192,233,13]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,g,r,o){this.h=new Map,this.a=v,this.b=g,this.g=r,o&&(this.c=o.then(s=>this.i(s)))}i(v){if(R.$i){const g=Object.create(null);return Object.keys(v).forEach(r=>{g[r.toLowerCase()]=v[r]}),g}return v}resolveWithEnvironment(v,g,r){return this.l({env:this.i(v),userHome:void 0},g?g.uri:void 0,r)}async resolveAsync(v,g){const r={env:await this.c,userHome:await this.g};return this.l(r,v?v.uri:void 0,g)}async j(v,g,r,o){const s=O.$3n(g);R.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):R.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):R.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,s,r,o)}async resolveAnyAsync(v,g,r){return this.j(v,g,r)}async resolveAnyMap(v,g,r){const o=new Map;return{newConfig:await this.j(v,g,r,o),resolvedVariables:o}}resolveWithInteractionReplace(v,g,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,g,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,g){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,g)}async l(v,g,r,o,s){if(A.$9f(r))return this.m(v,g,r,o,s);if(Array.isArray(r))return Promise.all(r.map(i=>this.l(v,g,i,o,s)));if(A.$$f(r)){const i=Object.create(null),n=await Promise.all(Object.keys(r).map(async c=>[await this.m(v,g,c,o,s),await this.l(v,g,r[c],o,s)]));for(const[c,l]of n)i[c]=l;return i}return r}m(v,g,r,o,s){return(0,T.$qf)(r,D.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(D.VARIABLE_LHS))return i;let c=await this.o(v,i,n,g,o);return s?.set(n,c),c!==i&&A.$9f(c)&&c.match(D.VARIABLE_REGEXP)&&(c=await this.m(v,g,c,o,s)),c})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,g,r,o,s){let i;const n=r.split(":");n.length>1&&(r=n[0],i=n[1]);const c=f=>{const a=this.a.getFilePath();if(a)return(0,w.$yw)(a);throw new E.$dQ(f,(0,p.localize)(0,null,g))},l=f=>{const a=c(f);if(this.a.getWorkspaceFolderPathForFile){const $=this.a.getWorkspaceFolderPathForFile();if($)return(0,w.$yw)($)}throw new E.$dQ(f,(0,p.localize)(1,null,g,I.$oc(a)))},t=f=>{if(i){const a=this.a.getFolderUri(i);if(a)return a;throw new E.$dQ(f,(0,p.localize)(2,null,g,i))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new E.$dQ(f,(0,p.localize)(3,null,g)):new E.$dQ(f,(0,p.localize)(4,null,g))};switch(r){case"env":if(i){if(v.env){const f=v.env[R.$i?i.toLowerCase():i];if(A.$9f(f))return f}return""}throw new E.$dQ(E.VariableKind.Env,(0,p.localize)(5,null,g));case"config":if(i){const f=this.a.getConfigurationValue(o,i);if(A.$fg(f))throw new E.$dQ(E.VariableKind.Config,(0,p.localize)(6,null,g,i));if(A.$$f(f))throw new E.$dQ(E.VariableKind.Config,(0,p.localize)(7,null,g,i));return f}throw new E.$dQ(E.VariableKind.Config,(0,p.localize)(8,null,g));case"command":return this.p(E.VariableKind.Command,g,i,s,"command");case"input":return this.p(E.VariableKind.Input,g,i,s,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new E.$dQ(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,g,i));return this.n(f.extensionLocation)}throw new E.$dQ(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,g));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,w.$yw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return o||i?(0,w.$yw)(this.n(t(E.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.$yw)(I.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new E.$dQ(E.VariableKind.UserHome,(0,p.localize)(11,null,g))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new E.$dQ(E.VariableKind.LineNumber,(0,p.localize)(12,null,g))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new E.$dQ(E.VariableKind.SelectedText,(0,p.localize)(13,null,g))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return l(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(l(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||i?I.$mc(this.n(t(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const f=I.$nc(c(E.VariableKind.RelativeFileDirname));if(o||i){const a=I.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),f);return a.length===0?".":a}return f}case"fileDirname":return I.$nc(c(E.VariableKind.FileDirname));case"fileExtname":return I.$pc(c(E.VariableKind.FileExtname));case"fileBasename":return I.$oc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=I.$oc(c(E.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-I.$pc(f).length)}case"fileDirnameBasename":return I.$oc(I.$nc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||g}case"execInstallFolder":{const f=this.a.getAppRoot();return f||g}case"pathSeparator":case"/":return I.sep;default:try{const f=i?`${r}:${i}`:r;return this.p(E.VariableKind.Unknown,g,f,s,void 0)}catch{return g}}}}p(v,g,r,o,s){if(r&&o){const i=s===void 0?o[r]:o[s+":"+r];if(typeof i=="string")return i;throw new E.$dQ(v,(0,p.localize)(14,null,g))}return g}}e.$sQ=D}),define(Ie[109],Pe([1,0,3,106]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$RD=void 0,e.$SD=E,e.$TD=d,e.$UD=v,e.$RD=(0,I.$wi)("editorGroupsService");var A;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var O;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var R;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var w;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EXPAND=1]="EXPAND",g[g.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var p;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function E(g){const r=g;return(0,M.$CF)(r?.editor)&&(0,M.$CF)(r?.replacement)}var T;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var D;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function d(g){const r=g;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function v(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ie[235],Pe([1,0,3,109]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YD=e.$XD=e.$WD=e.$VD=void 0,e.$ZD=A,e.$VD=(0,I.$wi)("editorService"),e.$WD=-1,e.$XD=-2,e.$YD=-3;function A(O){const R=O;return typeof O=="number"||(0,M.$TD)(R)}}),define(Ie[236],Pe([1,0,3,99]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=void 0,e.$nM=(0,I.$xi)(M.$Di)}),define(Ie[110],Pe([1,0,20,5,19,6,11]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=e.$N_b=e.$M_b=e.$L_b=e.$K_b=void 0;class w{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$K_b=w;class p{static isHostExtension(i,n,c){if(n.getExtensionDescription(i))return!1;const l=c.getExtensionDescription(i);return l?!!((l.main||l.browser)&&l.api==="none"):!1}constructor(i,n){this.j=i,this.c=new M.$ee,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(r),this.f=new I.$Tm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const c of n)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=o(this.e,n),this.e=this.e.concat(i);const c=p.l(this.e);return this.e=o(this.e,c.map(l=>l.identifier)),this.k(),this.d++,this.c.fire(void 0),new w(this.d,c)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,$){this.addNode(a),this.addNode($),this.c.has(a)?this.c.get(a).push($):this.c.set(a,[$])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,$){const u=n.getArcs(a);for(let S=0;S<u.length;S++)if(!$.has(u[S]))return!1;return!0}getNodes(){return this.e}},c=new I.$Tm;for(const a of i)if(c.set(a.identifier,a),a.extensionDependencies)for(const $ of a.extensionDependencies)n.addArc(I.$Rm.toKey(a.identifier),I.$Rm.toKey($));const l=new Set;n.getNodes().filter(a=>n.getArcs(a).length===0).forEach(a=>l.add(a));const t=n.getNodes().filter(a=>!l.has(a));let f;do{f=!1;for(let a=0;a<t.length;a++){const $=t[a];n.hasOnlyGoodArcs($,l)&&(t.splice(a,1),a--,l.add($),f=!0)}}while(f);return t.map(a=>c.get(a))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$L_b=p;class E{constructor(i,n){this.versionId=i,this.extensions=n}}e.$M_b=E;class T{constructor(i){this.d=new v,this.c=new p(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new D(this,n)}deltaExtensions(i,n,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$N_b=T;class D extends O.$Vc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$O_b=D;class d{constructor(i){this.name=i;const n=(0,R.$ph)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class v{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new d(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const c=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),l=()=>{n&&(clearTimeout(c),n=!1,this.d=!1,this.e())};i.resolve((0,O.$Tc)(l))}}var g;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(g||(g={}));function r(s,i){const n=s.isBuiltin?0:s.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==c)return n-c;const l=A.$hc.basename(s.extensionLocation.path),t=A.$hc.basename(i.extensionLocation.path);return l<t?-1:l>t?1:0}function o(s,i){const n=new I.$Sm(i);return s.filter(c=>!n.has(c.identifier))}}),define(Ie[79],Pe([1,0,21]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Zm=R,e.$1m=w;var M;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(M||(e.UIKind=M={}));var A;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var O;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function R(E){const T=I.$Ge.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function w(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var p;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ie[63],Pe([1,0,3,5,12,27,79,58,59,25,2,6,179]),function(le,e,I,M,A,O,R,w,p,E,T,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KP=e.$IP=e.$HP=void 0,e.$JP=r;let v=class extends D.$Vc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new M.$ee),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$ee),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:p.$kp,name:(0,d.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,A.$5j)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const c=this.getTelemetryDetails(),l=new g(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,w.$Im)((0,p.$qp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,c)=>{const l=n.filter(t=>!t.isDisposed);l.length===0?this.r.delete(c):this.r.set(c,l)}),this.r.forEach(n=>{for(const c of n)c.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const c=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(s.value),!1;let l=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(i),l=!0);return l}};e.$HP=v,e.$HP=v=Je([We(0,O.$GP),We(1,A.$4j)],v);class g{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,c,l,t,f){this.g=n,this.h=c,this.i=l,this.j=t,this.a=new M.$ee,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,p.$tp)(i,[]),this.c&&(i=(0,E.$6n)(i,this.c)),this.b||(i=(0,E.$6n)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},c=(0,p.$tp)(n,[]),l=new Error(c.message,{cause:c.cause});l.stack=c.stack,l.name=c.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(l,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$IP=g;function r(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$KP=(0,I.$wi)("IExtHostTelemetry")}),define(Ie[26],Pe([1,0,5,2,207,105,20,3]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NG=e.ActivationKind=e.$KG=e.$JG=e.$GG=e.ExtensionHostStartup=e.$FG=e.$EG=e.$DG=e.$CG=void 0,e.$HG=d,e.$IG=v,e.$LG=s,e.$MG=i,e.$CG=Object.freeze({identifier:new R.$Rm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$DG="extensions.webWorker",e.$EG=(0,w.$wi)("extensionService");class p{constructor(l){this.dependency=l}}e.$FG=p;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,f){this.c=l,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$nG.createActivationEventsMap(this.d)}}set(l,t,f){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const a=[],$=[],u=[],S=[],h=D(this.d),b=D(t),m=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=b.get(W.identifier);if(!V){a.push(W.identifier),h.delete(W.identifier);continue}if(!m(W,V)){a.push(W.identifier),h.delete(W.identifier);continue}}for(const W of t){const V=h.get(W.identifier);if(!V){$.push(W);continue}if(!m(V,W)){a.push(V.identifier),h.delete(V.identifier);continue}}const k=new R.$Sm(this.e),y=new R.$Sm(f);for(const W of this.e)y.has(W)||u.push(W);for(const W of f)k.has(W)||S.push(W);const C=O.$nG.createActivationEventsMap($),P={versionId:l,toRemove:a,toAdd:$,addActivationEvents:C,myToRemove:u,myToAdd:S};return this.delta(P),P}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:a,myToAdd:$}=l,u=new R.$Sm(t),S=new R.$Sm(a);for(let h=0;h<this.d.length;h++)u.has(this.d[h].identifier)&&(this.d.splice(h,1),h--);for(let h=0;h<this.e.length;h++)S.has(this.e[h])&&(this.e.splice(h,1),h--);for(const h of f)this.d.push(h);for(const h of $)this.e.push(h);return this.f=null,l}containsExtension(l){for(const t of this.e)if(R.$Rm.equals(t,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=O.$nG.readActivationEvents(t);for(const a of f)l.add(a)}return l}}e.$GG=T;function D(c){const l=new R.$Tm;for(const t of c)l.set(t.identifier,t);return l}function d(c,l){return c.enabledApiProposals?c.enabledApiProposals.includes(l):!1}function v(c,l){if(!d(c,l))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class g{constructor(l,t,f,a){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=a}}e.$JG=g;class r{constructor(l,t){this.description=l,this.value=t}}e.$KG=r;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,A.$zp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function i(c,l){return{identifier:new R.$Rm((0,A.$xp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!l,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$NG=n}),define(Ie[237],Pe([1,0,14,110,20,26,12,11]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Rlc=e.$Qlc=e.$Plc=e.$Olc=e.$Nlc=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(s,i,n,c){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=c}}e.$Nlc=p;class E{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Olc=E;class T{constructor(s,i,n,c,l,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=c,this.exports=l,this.subscriptions=t}}e.$Plc=T;class D extends T{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Qlc=D;class d extends T{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Rlc=d;class v extends T{constructor(s){super(!0,s,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(s,i,n,c){this.g=c,this.a=s,this.b=i,this.c=n,this.d=new A.$Tm,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(c=>({id:c.identifier,reason:{startup:i,extensionId:c.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const l=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new v(l));return this.c.onExtensionActivationError(s.id,l,new O.$FG(s.id.value)),t}const n=[],c=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const l of c){if(this.m(l))continue;const t=this.d.get(l);if(t){n.push(t);continue}if(this.l(l)){n.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:s.reason}));continue}const f=this.a.getExtensionDescription(l);if(f){if(!f.main&&!f.browser)continue;n.push(this.j({id:f.identifier,reason:s.reason}));continue}const a=i.displayName||i.identifier.value,$=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${l}'`),u=this.k(s,i.displayName,[],new v($));return this.c.onExtensionActivationError(i.identifier,$,new O.$FG(l)),u}return this.k(s,i.displayName,n,null)}k(s,i,n,c){const l=new r(s.id,i,s.reason,n,c,this.c,this.g);return this.d.set(s.id,l),l}l(s){return M.$L_b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$Slc=g,e.$Slc=g=Je([We(3,R.$3j)],g);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,c,l,t,f){this.c=s,this.d=i,this.f=n,this.g=c,this.h=l,this.j=t,this.k=f,this.a=new w.$vh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new v(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new v(i),this.b&&I.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Je([We(6,R.$3j)],r)}),define(Ie[238],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[239],Pe([1,0,194,14,33,100,74,29,20,238,102,105]),function(le,e,I,M,A,O,R,w,p,E,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=void 0;const d=w.$co.as(R.$do.JSONContribution);class v{constructor(l,t,f){this.a=l,this.b=t,this.c=f}d(l,t){this.a({type:l,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(A.default.Error,l)}warn(l){this.d(A.default.Warning,l)}info(l){this.d(A.default.Info,l)}}e.$wG=v;class g{static a(l){const t=new p.$Sm;for(let f=0,a=l.length;f<a;f++)t.add(l[f].description.identifier);return t}static compute(l,t){if(!l||!l.length)return new g(t,[]);if(!t||!t.length)return new g([],l);const f=this.a(l),a=this.a(t),$=t.filter(S=>!f.has(S.description.identifier)),u=l.filter(S=>!a.has(S.description.identifier));return new g($,u)}constructor(l,t){this.added=l,this.removed=t}}e.$xG=g;class r{constructor(l,t){this.name=l,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=g.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,M.$1)(l)}}}e.$yG=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$zG={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$Qm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$To}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$To}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const t=new r(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,t),l.activationEventsGenerator&&D.$nG.register(l.extensionPoint,l.activationEventsGenerator),e.$zG.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,d.registerSchema(s,e.$zG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$AG=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};w.$co.add(n.ExtensionsRegistry,new i),e.$BG=w.$co.as(n.ExtensionsRegistry),d.registerSchema(s,e.$zG),d.registerSchema(T.$kk,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Ie[240],Pe([1,0,190,15,25,239,31,5]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8H=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var E;(function(d){function v(g,r,o){if(!g)return;const s=M.$9f(g.type)?g.type:void 0;if(!s||s.length===0){o.error(I.localize(3,null));return}const i=[];if(Array.isArray(g.required))for(const n of g.required)M.$9f(n)&&i.push(n);return{extensionId:r.value,taskType:s,required:i,properties:g.properties?A.$3n(g.properties):{},when:g.when?R.$uj.deserialize(g.when):void 0}}d.from=v})(E||(E={}));const T=O.$BG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(d,v)=>{for(const g of d)g.type&&v.push(`onTaskType:${g.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:p}});class D{constructor(){this.d=new w.$ee,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,g)=>{T.setHandler((r,o)=>{this.c=void 0;try{for(const s of o.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of o.added){const i=s.value;for(const n of i){const c=E.from(n,s.description.identifier,s.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const g of this.all()){const r={type:"object",additionalProperties:!1};g.required.length>0&&(r.required=g.required.slice(0)),g.properties!==void 0?r.properties=A.$3n(g.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[g.taskType]},v.push(r)}this.c={oneOf:v}}return this.c}}e.$8H=new D}),define(Ie[241],Pe([1,0,191,15,23,25,31,240]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$fI=e.JsonSchemaVersion=e.ExecutionEngine=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$_H=e.ShellQuoting=e.$$H=e.$0H=e.$9H=void 0,e.$9H="settings",e.$0H=new R.$Nj("taskRunning",!1,I.localize(0,null)),e.$$H=I.localize2(2,"Tasks");var p;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(p||(e.ShellQuoting=p={})),e.$_H="$customized",function(N){function U(K){if(!K)return N.Strong;switch(K.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=U}(p||(e.ShellQuoting=p={}));var E;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(T||(e.RevealKind=T={})),function(N){function U(K){switch(K.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=U}(T||(e.RevealKind=T={}));var D;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(N){function U(K){switch(K.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=U}(D||(e.RevealProblemKind=D={}));var d;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(d||(e.PanelKind=d={})),function(N){function U(K){switch(K.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=U}(d||(e.PanelKind=d={}));var v;(function(N){N.defaults={echo:!0,reveal:T.Always,revealProblems:D.Never,focus:!1,panel:d.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var g;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(N){function U(ie){switch(ie.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=U;function K(ie){switch(ie){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=K}(g||(e.RuntimeType=g={}));var r;(function(N){function U(K){return M.$9f(K)?K:K.value}N.value=U})(r||(e.CommandString=r={}));var o;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function U(ie){return ie===N.Clean._id||ie===N.Build._id||ie===N.Rebuild._id||ie===N.Test._id}N.is=U;function K(ie){if(ie!==void 0)return M.$9f(ie)?U(ie)?{_id:ie,isDefault:!1}:void 0:ie}N.from=K})(o||(e.TaskGroup=o={}));var s;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function U(K){switch(K){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=U})(i||(e.TaskSourceKind=i={}));var n;(function(N){N.parallel="parallel",N.sequence="sequence"})(n||(e.DependsOrder=n={}));var c;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var l;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class t{constructor(U,K,ie,ce,ye,Se){this._label="",this._id=U,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=ce,this.configurationProperties=ye,this._source=Se}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,K=!1){if(U===void 0)return!1;if(M.$9f(U))return U===this._label||U===this.configurationProperties.identifier||K&&U===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$aI=t;class f extends t{constructor(U,K,ie,ce,ye,Se,fe,$e){super(U,ie,void 0,fe,$e,K),this.command={},this._source=K,this.hasDefinedMatchers=Se,ye&&(this.command=ye)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case g.Shell:K="shell";break;case g.Process:K="process";break;case g.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(U){return U instanceof f}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$9H:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(K+=this._source.kind);const ie={type:e.$_H,folder:U,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$7g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new f(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$bI=f;class a extends t{constructor(U,K,ie,ce,ye,Se,fe){super(U,ie,ce,Se,fe,K),this._source=K,this.configures=ye}static is(U){return U instanceof a}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$7g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$9H:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(K+=this._source.kind);const ie={type:e.$_H,folder:U,id:K};return JSON.stringify(ie)}}e.$cI=a;class $ extends t{constructor(U,K,ie,ce,ye,Se,fe,$e,Te){super(U,ie,ce,$e,Te,K),this.defines=ye,this.hasDefinedMatchers=fe,this.command=Se,this.icon=Te.icon,this.hide=Te.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof $}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new $(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$dI=$;class u extends t{constructor(U,K,ie,ce,ye,Se){super(U,ie,ce,ye,Se,K),this._source=K}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new u(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$eI=u;var S;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(N){N._default=N.Terminal}(S||(e.ExecutionEngine=S={}));var h;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(h||(e.JsonSchemaVersion=h={}));class b{constructor(U){this.c=new Map;for(let K=0;K<U.length;K++)this.c.set(U[K].uri.toString(),K)}compare(U,K){const ie=U.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(ie&&ce){let ye=this.c.get(ie.uri.toString());ye=ye===void 0?0:ye+1;let Se=this.c.get(ce.uri.toString());return Se=Se===void 0?0:Se+1,ye===Se?U._label.localeCompare(K._label):ye-Se}else return!ie&&ce?-1:ie&&!ce?1:0}}e.$fI=b;var m;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(m||(e.TaskEventKind=m={}));var k;(function(N){N.SingleRun="singleRun",N.Background="background"})(k||(e.TaskRunType=k={}));var y;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(N){function U($e){return{taskId:$e._id,taskName:$e.configurationProperties.name,runType:$e.configurationProperties.isBackground?"background":"singleRun",group:$e.configurationProperties.group,__task:$e}}function K($e,Te,ae){return{...U($e),kind:"start",terminalId:Te,resolvedVariables:ae}}N.start=K;function ie($e,Te,ae){return{...U($e),kind:"processStarted",terminalId:Te,processId:ae}}N.processStarted=ie;function ce($e,Te,ae){return{...U($e),kind:"processEnded",terminalId:Te,exitCode:ae}}N.processEnded=ce;function ye($e,Te,ae){return{...U($e),kind:"terminated",exitReason:ae,terminalId:Te}}N.terminated=ye;function Se($e,Te,ae){return{...U(Te),kind:$e,terminalId:ae}}N.general=Se;function fe(){return{kind:"changed"}}N.changed=fe})(C||(e.TaskEvent=C={}));var P;(function(N){function U(ie){const ce=Object.keys(ie).sort();let ye="";for(const Se of ce){let fe=ie[Se];fe instanceof Object?fe=U(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),ye+=Se+","+fe+","}return ye}function K(ie){const ye={_key:U(ie),type:ie.taskType};return Object.assign(ye,ie),ye}N.create=K})(P||(e.KeyedTaskIdentifier=P={}));var W;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(N){function U(K,ie){const ce=w.$8H.get(K.type);if(ce===void 0){const $e=O.$3n(K);return delete $e._key,P.create($e)}const ye=Object.create(null);ye.type=ce.taskType;const Se=new Set;ce.required.forEach($e=>Se.add($e));const fe=ce.properties;for(const $e of Object.keys(fe)){const Te=K[$e];if(Te!=null)ye[$e]=Te;else if(Se.has($e)){const ae=fe[$e];if(ae.default!==void 0)ye[$e]=O.$3n(ae.default);else switch(ae.type){case"boolean":ye[$e]=!1;break;case"number":case"integer":ye[$e]=0;break;case"string":ye[$e]="";break;default:ie.error(I.localize(1,null,JSON.stringify(K,void 0,0),$e));return}}}return P.create(ye)}N.createTaskIdentifier=U})(q||(e.TaskDefinition=q={}))}),define(Ie[242],Pe([1,0,14]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=e.$P_b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,w)=>{this.b=R,this.d=w,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,I.$1)(R))}then(R,w){return this.j().then(R,w)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$P_b=M;class A extends M{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$Q_b=A}),define(Ie[35],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vw=e.$sw=void 0,e.$tw=A,e.$uw=O;class I{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++I.count}}e.$sw=I;const M=[];function A(w){const p=new I(w);return M[p.nid]=p,p}function O(w){return M[w].sid}class R{constructor(p){this.value=p}}e.$vw=R}),define(Ie[4],Pe([1,0,35]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$2M=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var A;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var w;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var E;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class D{static{this.a=0}static mixin(o){return o._id=D.a++,o}}e.$2M=D;var d;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(d||(e.ISuggestDataDtoField=d={}));var v;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var g;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$3M={MainThreadAuthentication:(0,I.$tw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$tw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$tw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$tw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$tw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$tw)("MainThreadClipboard"),MainThreadCommands:(0,I.$tw)("MainThreadCommands"),MainThreadComments:(0,I.$tw)("MainThreadComments"),MainThreadConfiguration:(0,I.$tw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$tw)("MainThreadConsole"),MainThreadDebugService:(0,I.$tw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$tw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$tw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$tw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$tw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$tw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$tw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$tw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$tw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$tw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$tw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$tw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$tw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$tw)("MainThreadLanguages"),MainThreadLogger:(0,I.$tw)("MainThreadLogger"),MainThreadMessageService:(0,I.$tw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$tw)("MainThreadOutputService"),MainThreadProgress:(0,I.$tw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$tw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$tw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$tw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$tw)("MainThreadSecretState"),MainThreadStorage:(0,I.$tw)("MainThreadStorage"),MainThreadSpeech:(0,I.$tw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$tw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$tw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$tw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$tw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$tw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$tw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$tw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$tw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$tw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$tw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$tw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$tw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$tw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$tw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$tw)("MainThreadSCM"),MainThreadSearch:(0,I.$tw)("MainThreadSearch"),MainThreadShare:(0,I.$tw)("MainThreadShare"),MainThreadTask:(0,I.$tw)("MainThreadTask"),MainThreadWindow:(0,I.$tw)("MainThreadWindow"),MainThreadLabelService:(0,I.$tw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$tw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$tw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$tw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$tw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$tw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$tw)("MainThreadInteractive"),MainThreadInlineChat:(0,I.$tw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$tw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$tw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$tw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$tw)("MainThreadTimeline"),MainThreadTesting:(0,I.$tw)("MainThreadTesting"),MainThreadLocalization:(0,I.$tw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$tw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$tw)("MainThreadAiEmbeddingVector")},e.$4M={ExtHostCommands:(0,I.$tw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$tw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$tw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$tw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$tw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$tw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$tw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$tw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$tw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$tw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$tw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$tw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$tw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$tw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$tw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$tw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$tw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$tw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$tw)("ExtHostStatusBar"),ExtHostShare:(0,I.$tw)("ExtHostShare"),ExtHostExtensionService:(0,I.$tw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$tw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$tw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$tw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$tw)("ExtHostSCM"),ExtHostSearch:(0,I.$tw)("ExtHostSearch"),ExtHostTask:(0,I.$tw)("ExtHostTask"),ExtHostWorkspace:(0,I.$tw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$tw)("ExtHostWindow"),ExtHostWebviews:(0,I.$tw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$tw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$tw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$tw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$tw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$tw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$tw)("ExtHostProgress"),ExtHostComments:(0,I.$tw)("ExtHostComments"),ExtHostSecretState:(0,I.$tw)("ExtHostSecretState"),ExtHostStorage:(0,I.$tw)("ExtHostStorage"),ExtHostUrls:(0,I.$tw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$tw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$tw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$tw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$tw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$tw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$tw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$tw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$tw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$tw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$tw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$tw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$tw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,I.$tw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$tw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$tw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$tw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$tw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$tw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$tw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$tw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$tw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$tw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$tw)("ExtHostTimeline"),ExtHostTesting:(0,I.$tw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$tw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$tw)("ExtHostLocalization")}}),define(Ie[80],Pe([1,0,3,12,4,17]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=e.$blc=e.$alc=void 0,e.$alc=(0,I.$wi)("IExtHostApiDeprecationService");let R=class{constructor(p,E){this.c=E,this.a=new Set,this.b=p.getProxy(A.$3M.MainThreadTelemetry)}report(p,E,T){const D=this.d(p,E);this.a.has(D)||(this.a.add(D),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:p}))}d(p,E){return`${p}-${E.identifier.value}`}};e.$blc=R,e.$blc=R=Je([We(0,O.$qP),We(1,M.$3j)],R),e.$clc=Object.freeze(new class{report(w,p,E){}})}),define(Ie[243],Pe([1,0,4]),function(le,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=void 0;class M{constructor(O){const R=O.getProxy(I.$3M.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(w){return R.$writeText(w)}})}}e.$plc=M}),define(Ie[244],Pe([1,0,25,4,27,17]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0;let R=class{constructor(T,D){this.a=T.getProxy(M.$3M.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,D){const d=this,v=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){d.e(T,D,v,arguments)}})}e(T,D,d,v){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:p(v,this.b)}),this.c&&this.f(T,d,v)}};e.$jnc=R,e.$jnc=R=Je([We(0,O.$qP),We(1,A.$GP)],R);const w=1e5;function p(E,T){const D=[];if(E.length)for(let d=0;d<E.length;d++){let v=E[d];if(typeof v>"u")v="undefined";else if(v instanceof Error){const g=v;g.stack?v=g.stack:v=g.toString()}D.push(v)}if(T){const d=new Error().stack;d&&D.push({__$stack:d.split(`
`).slice(3).join(`
`)})}try{const d=(0,I.$8n)(D);return d.length>w?"Output omitted for a large object that exceeds the limits":d}catch(d){return`Output omitted for an object that cannot be inspected ('${d.toString()}')`}}}),define(Ie[245],Pe([1,0,2,4,26]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class O{constructor(w){this.a=w.getProxy(M.$3M.MainThreadDialogs)}showOpenDialog(w,p){return p?.allowUIResources&&(0,A.$IG)(w,"showLocal"),this.a.$showOpenDialog(p).then(E=>E?E.map(T=>I.URI.revive(T)):void 0)}showSaveDialog(w){return this.a.$showSaveDialog(w).then(p=>p?I.URI.revive(p):void 0)}}e.$mmc=O}),define(Ie[246],Pe([1,0,6,4]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=void 0;class A{constructor(R){this.b=0,this.a=R.getProxy(M.$3M.MainThreadLabelService)}$registerResourceLabelFormatter(R){const w=this.b++;return this.a.$registerResourceLabelFormatter(w,R),(0,I.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(w)})}}e.$Gmc=A}),define(Ie[81],Pe([1,0,22,13,2,3,12,4,27,17]),function(le,e,I,M,A,O,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=e.$7lc=void 0;let T=class{constructor(d,v,g){this.f=g,this.d=new Map,this.a=v.getProxy(w.$3M.MainThreadLocalization),this.b=d.environment.appLanguage,this.c=this.b===I.$g}getMessage(d,v){const{message:g,args:r,comment:o}=v;if(this.c)return(0,M.$0e)(g,r??{});let s=g;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const i=this.d.get(d)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,M.$0e)(i??g,r??{})}getBundle(d){return this.d.get(d)?.contents}getBundleUri(d){return this.d.get(d)?.uri}async initializeLocalizedMessages(d){if(this.c||!d.l10n&&!d.isBuiltin||this.d.has(d.identifier.value))return;let v;const g=await this.g(d);if(!g){this.f.error(`No bundle location found for extension ${d.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(g),o=JSON.parse(r);v=d.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${d.identifier.value} from ${g}: ${r.message}`);return}v&&this.d.set(d.identifier.value,{contents:v,uri:g})}async g(d){if(d.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(d.identifier.value,this.b);return A.URI.revive(v)}return d.l10n?A.URI.joinPath(d.extensionLocation,d.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$7lc=T,e.$7lc=T=Je([We(0,p.$GP),We(1,E.$qP),We(2,R.$3j)],T),e.$8lc=(0,O.$wi)("IExtHostLocalizationService")}),define(Ie[247],Pe([1,0,12,4,27,17,2,49]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;let p=class extends I.$bk{constructor(D,d){super(d.logLevel,d.logsLocation,d.loggers.map(v=>(0,w.$6h)(v))),this.r=D.getProxy(M.$3M.MainThreadLogger)}$setLogLevel(D,d){d?this.setLogLevel(R.URI.revive(d),D):this.setLogLevel(D)}setVisibility(D,d){super.setVisibility(D,d),this.r.$setVisibility(D,d)}s(D,d,v){return new E(this.r,D,d,v)}};e.$inc=p,e.$inc=p=Je([We(0,O.$qP),We(1,A.$GP)],p);class E extends I.$9j{constructor(D,d,v,g){super(g?.logLevel==="always"),this.r=D,this.s=d,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(d,g).then(()=>{this.u(this.n),this.m=!0})}g(D,d){const v=[[D,d]];this.m?this.u(v):this.n.push(...v)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Ie[82],Pe([1,0,4,3,6,17,21]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=e.$9lc=void 0,e.$9lc=(0,M.$wi)("IExtHostManagedSockets");let w=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(I.$3M.MainThreadManagedSockets)}setFactory(D,d){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(D,d),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const d=++this.b,v=await this.c.makeConnection(),g=new A.$Uc;return this.d.set(d,new E(d,v,g)),g.add((0,A.$Tc)(()=>this.d.delete(d))),g.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(d),g.dispose()})),g.add(v.onDidClose(r=>{this.a.$onDidManagedSocketClose(d,r?.stack??r?.message),g.dispose()})),g.add(v.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(d,R.$Ge.wrap(r)))),d}$remoteSocketWrite(D,d){this.d.get(D)?.actual.send(d.buffer)}$remoteSocketEnd(D){const d=this.d.get(D);d&&(d.actual.end(),d.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$0lc=w,e.$0lc=w=Je([We(0,O.$qP)],w);class p{constructor(D,d){this.socketFactoryId=D,this.makeConnection=d}}class E extends A.$Vc{constructor(D,d,v){super(),this.socketId=D,this.actual=d,this.B(v)}}}),define(Ie[248],Pe([1,0,4,12,26]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;function O(w){return w&&w.title}let R=class{constructor(p,E){this.b=E,this.a=p.getProxy(I.$3M.MainThreadMessageService)}showMessage(p,E,T,D,d){const v={source:{identifier:p.identifier,label:p.displayName||p.name}};let g;typeof D=="string"||O(D)?g=[D,...d]:(v.modal=D?.modal,v.useCustom=D?.useCustom,v.detail=D?.detail,g=d),v.useCustom&&(0,A.$IG)(p,"resolvers");const r=[];let o=!1;for(let s=0;s<g.length;s++){const i=g[s];if(typeof i=="string")r.push({title:i,handle:s,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:c}=i;r.push({title:n,isCloseAffordance:!!c,handle:s}),c&&(o?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,i):o=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,i)}return this.a.$showMessage(E,T,v,r).then(s=>{if(typeof s=="number")return g[s]})}};e.$Imc=R,e.$Imc=R=Je([We(1,M.$3j)],R)}),define(Ie[249],Pe([1,0,6,15,2,26,4]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;class w{constructor(E){this.b=new Map,this.a=E.getProxy(R.$3M.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,T,D){if((0,O.$IG)(E,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,D),this.a.$registerProfileContentHandler(T,D.name,D.description,E.identifier.value),(0,I.$Tc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,D,d){const v=this.b.get(E);if(!v)throw new Error(`Unknown handler with id: ${E}`);return v.saveProfile(T,D,d)}async $readProfile(E,T,D){const d=this.b.get(E);if(!d)throw new Error(`Unknown handler with id: ${E}`);return d.readProfile((0,M.$9f)(T)?T:A.URI.revive(T),D)}}e.$Rmc=w}),define(Ie[83],Pe([1,0,4,5,3]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=e.$4lc=void 0;class O{constructor(w){this.b=new M.$ee,this.onDidChangePassword=this.b.event,this.a=w.getProxy(I.$3M.MainThreadSecretState)}async $onDidChangePassword(w){this.b.fire(w)}get(w,p){return this.a.$getPassword(w,p)}store(w,p,E){return this.a.$setPassword(w,p,E)}delete(w,p){return this.a.$deletePassword(w,p)}}e.$4lc=O,e.$5lc=(0,A.$wi)("IExtHostSecretState")}),define(Ie[250],Pe([1,0,24,6,4]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;class O{static{this.a=1}constructor(w){this.c=new Map,this.d=new Map,this.b=w.getProxy(A.$3M.MainThreadSpeech)}async $createSpeechToTextSession(w,p,E){const T=this.c.get(w);if(!T)return;const D=new M.$Uc,d=new I.$pe;this.d.set(p,d);const v=D.add(T.provideSpeechToTextSession(d.token,E?{language:E}:void 0));D.add(v.onDidChange(g=>{d.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,g)})),D.add(d.token.onCancellationRequested(()=>D.dispose()))}async $cancelSpeechToTextSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}async $createKeywordRecognitionSession(w,p){const E=this.c.get(w);if(!E)return;const T=new M.$Uc,D=new I.$pe;this.d.set(p,D);const d=T.add(E.provideKeywordRecognitionSession(D.token));T.add(d.onDidChange(v=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,v)})),T.add(D.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}registerProvider(w,p,E){const T=O.a++;return this.c.set(T,E),this.b.$registerProvider(T,p,{extension:w,displayName:w.value}),(0,M.$Tc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$Ymc=O}),define(Ie[84],Pe([1,0,4,5,3]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0;class O{constructor(w,p){this.c=p,this.b=new M.$ee,this.onDidChangeStorage=this.b.event,this.a=w.getProxy(I.$3M.MainThreadStorage)}registerExtensionStorageKeysToSync(w,p){this.a.$registerExtensionStorageKeysToSync(w,p)}async initializeExtensionStorage(w,p,E){const T=await this.a.$initializeExtensionStorage(w,p);let D;return T&&(D=this.d(w,p,T)),D||E}setValue(w,p,E){return this.a.$setValue(w,p,E)}$acceptValue(w,p,E){const T=this.d(w,p,E);T&&this.b.fire({shared:w,key:p,value:T})}d(w,p,E){try{return JSON.parse(E)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${w}): ${T}`)}}}e.$Tlc=O,e.$Ulc=(0,A.$wi)("IExtHostStorage")}),define(Ie[251],Pe([1,0,6,16,2,4]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0;class R{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(O.$3M.MainThreadUriOpeners)}registerExternalUriOpener(p,E,T,D){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const d=D.schemes.find(v=>!R.a.has(v));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this.c.set(E,T),this.b.$registerUriOpener(E,D.schemes,p,D.label),(0,I.$Tc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(p,E,T){const D=this.c.get(p);if(!D)throw new Error(`Unknown opener with id: ${p}`);const d=A.URI.revive(E);return D.canOpenExternalUri(d,T)}async $openUri(p,E,T){const D=this.c.get(p);if(!D)throw new Error(`Unknown opener id: '${p}'`);return D.openExternalUri(A.URI.revive(E.resolvedUri),{sourceUri:A.URI.revive(E.sourceUri)},T)}}e.$cnc=R}),define(Ie[252],Pe([1,0,4,2,6,14,20]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=void 0;class w{static{this.a=0}constructor(E){this.c=new R.$Sm,this.d=new Map,this.b=E.getProxy(I.$3M.MainThreadUrls)}registerUriHandler(E,T){const D=E.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const d=w.a++;return this.c.add(D),this.d.set(d,T),this.b.$registerUriHandler(d,D,E.displayName||E.name),(0,A.$Tc)(()=>{this.c.delete(D),this.d.delete(d),this.b.$unregisterUriHandler(d)})}$handleExternalUri(E,T){const D=this.d.get(E);if(!D)return Promise.resolve(void 0);try{D.handleUri(M.URI.revive(T))}catch(d){(0,O.$1)(d)}return Promise.resolve(void 0)}async createAppUri(E){return M.URI.revive(await this.b.$createAppUri(E))}}e.$dnc=w}),define(Ie[64],Pe([1,0,5,6,16,25,2,197,221,78,4]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=e.$Elc=void 0,e.$Flc=d,e.$Hlc=r,e.$Ilc=o;class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,l,t,f,a,$,u){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$ee,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$ee,this._onDidDispose=this.#h.event,this.#e=c,this.#t=l,this.#o=t,this.#n=f,this.#s=a,this.#r=$,this.#l=d($),this.#d=v($),this.#i=u}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,E.$OAb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===A.Schemas.https||c.scheme===A.Schemas.http){let l=c.toString();return l.endsWith("/")||(l+="/"),l+" "+E.$NAb}return E.$NAb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),O.$7n(this.#o,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const l=(0,p.$Arb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const l=this.#r.extensionLocation?.scheme===A.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,$,u,S,h)=>{const b=R.URI.from({scheme:u||"file",path:decodeURIComponent(S)}),m=(0,E.$OAb)(b,{isRemote:l,authority:t}).toString();return`${a}${m}${h}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,$,u,S,h)=>{const b=R.URI.from({scheme:u||"file",path:decodeURIComponent(S)}),m=(0,E.$OAb)(b,{isRemote:l,authority:t}).toString();return`${a}${m}${h}`})}}e.$Elc=D;function d(n){try{const c=(0,w.$Ip)((0,w.$Hp)(n.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function v(n){try{const c=(0,w.$Ip)((0,w.$Hp)(n.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class g extends M.$Vc{constructor(c,l,t,f,a){super(),this.c=l,this.f=t,this.g=f,this.h=a,this.b=new Map,this.a=c.getProxy(T.$3M.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,l,t){const f=this.j(c);if(f){const{message:a}=(0,p.$Brb)(l,t.value);f._onMessageEmitter.fire(a)}}$onMissingCsp(c,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,l,t){const f=new D(c,this.a,s(l),this.c,this.f,t,this.h);this.b.set(c,f);const a=f._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return f}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Glc=g;function r(n){return{id:n.identifier,location:n.extensionLocation}}function o(n,c,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||i(n,c)}}function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(c=>R.URI.from(c))}}function i(n,c){return[...(c?.getWorkspaceFolders()||[]).map(l=>l.uri),n.extensionLocation]}}),define(Ie[111],Pe([1,0,5,16,13,2,3,17,4]),function(le,e,I,M,A,O,R,w,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=e.$fnc=void 0;let T=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const d=this.d;return{get focused(){return d.focused},get active(){return d.active}}}constructor(d){this.c=new I.$ee,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=d.getProxy(p.$3M.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:g})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(d){this.onDidChangeWindowProperty("focused",d)}$onDidChangeWindowActive(d){this.onDidChangeWindowProperty("active",d)}onDidChangeWindowProperty(d,v){v!==this.d[d]&&(this.d={...this.d,[d]:v},this.c.fire(this.d))}openUri(d,v){let g;if(typeof d=="string"){g=d;try{d=O.URI.parse(d)}catch{return Promise.reject(`Invalid uri - '${d}'`)}}return(0,A.$8e)(d.scheme)?Promise.reject("Invalid scheme - cannot be empty"):d.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${d.scheme}'`):this.b.$openUri(d,g,v)}async asExternalUri(d,v){if((0,A.$8e)(d.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(d,v);return O.URI.from(g)}};e.$fnc=T,e.$fnc=T=E=Je([We(0,w.$qP)],T),e.$gnc=(0,R.$wi)("IExtHostWindow")}),define(Ie[253],Pe([1,0,244,27,17]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=void 0;let O=class extends I.$jnc{constructor(w,p){super(w,p)}f(w,p,E){p.apply(console,E)}};e.$rpc=O,e.$rpc=O=Je([We(0,A.$qP),We(1,M.$GP)],O)}),define(Ie[254],Pe([1,0,11,21,24,14,5,6,150,242,35]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$R_b=o,e.$S_b=s;function d(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const v="$$ref$$",g={[v]:-1};class r{constructor(C,P){this.jsonString=C,this.referencedBuffers=P}}function o(y,C=null,P=!1){const W=[];return{jsonString:(P?d:JSON.stringify)(y,(q,N)=>{if(typeof N>"u")return g;if(typeof N=="object"){if(N instanceof M.$Ge){const U=W.push(N)-1;return{[v]:U}}if(C)return C(q,N)}return N}),referencedBuffers:W}}function s(y,C,P){return JSON.parse(y,(W,V)=>{if(V){const q=V[v];if(typeof q=="number")return C[q];if(P&&V.$mid===1)return P.transformIncoming(V)}return V})}function i(y,C){return JSON.stringify(y,C)}function n(y){return y?(C,P)=>P&&P.$mid===1?y.transformOutgoing(P):P:null}var c;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var l;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const t=()=>{},f=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class $ extends w.$Vc{static{D=f}static{this.a=3*1e3}constructor(C,P=null,W=null){super(),this[D]=!0,this.b=this.B(new R.$ee),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=P,this.g=W,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=T.$sw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$Ih(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const P=this.w[C];delete this.w[C],P.resolveErr(O.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+$.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+$.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,p.$Bn)(C,this.g):C}getProxy(C){const{nid:P,sid:W}=C;return this.s[P]||(this.s[P]=this.J(P,W)),this.s[P]}J(C,P){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...N)=>this.U(C,q,N)),q===a?P:V[q])};return new Proxy(Object.create(null),W)}set(C,P){return this.m[C.nid]=P,P}assertRegistered(C){for(let P=0,W=C.length;P<W;P++){const V=C[P];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(C){if(this.j)return;const P=C.byteLength,W=S.read(C,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:N,method:U,args:K}=b.deserializeRequestJSONArgs(W);this.g&&(K=(0,p.$Bn)(K,this.g)),this.M(P,q,N,U,K,V===2);break}case 3:case 4:{let{rpcId:N,method:U,args:K}=b.deserializeRequestMixedArgs(W);this.g&&(K=(0,p.$Bn)(K,this.g)),this.M(P,q,N,U,K,V===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let N=b.deserializeReplyOKJSON(W);this.g&&(N=(0,p.$Bn)(N,this.g)),this.O(P,q,N);break}case 10:{const N=b.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(P,q,N);break}case 8:{const N=b.deserializeReplyOKVSBuffer(W);this.O(P,q,N);break}case 11:{let N=b.deserializeReplyErrError(W);this.g&&(N=(0,p.$Bn)(N,this.g)),this.P(P,q,N);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,P,W,V,q,N){this.f?.logIncoming(C,P,1,`receiveRequest ${(0,T.$uw)(W)}.${V}(`,q);const U=String(P);let K,ie;if(N){const ye=new A.$pe;q.push(ye.token),K=this.Q(W,V,q),ie=()=>ye.cancel()}else K=this.Q(W,V,q),ie=t;this.u[U]=ie;const ce=b.serializeAcknowledged(P);this.f?.logOutgoing(ce.byteLength,P,1,"ack"),this.c.send(ce),K.then(ye=>{delete this.u[U];const Se=b.serializeReplyOK(P,ye,this.h);this.f?.logOutgoing(Se.byteLength,P,1,"reply:",ye),this.c.send(Se)},ye=>{delete this.u[U];const Se=b.serializeReplyErr(P,ye);this.f?.logOutgoing(Se.byteLength,P,1,"replyErr:",ye),this.c.send(Se)})}N(C,P){this.f?.logIncoming(C,P,1,"receiveCancel");const W=String(P);this.u[W]?.()}O(C,P,W){this.f?.logIncoming(C,P,0,"receiveReply:",W);const V=String(P);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(C,P,W){this.f?.logIncoming(C,P,0,"receiveReplyErr:",W);const V=String(P);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let N;W&&(W.$isError?(N=new Error,N.name=W.name,N.message=W.message,N.stack=W.stack):N=W),q.resolveErr(N)}Q(C,P,W){try{return Promise.resolve(this.S(C,P,W))}catch(V){return Promise.reject(V)}}S(C,P,W){const V=this.m[C];if(!V)throw new Error("Unknown actor "+(0,T.$uw)(C));const q=V[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,T.$uw)(C));return q.apply(V,W)}U(C,P,W){if(this.j)return new E.$Q_b;let V=null;if(W.length>0&&A.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(O.$6());const q=b.serializeRequestArguments(W,this.h),N=++this.t,U=String(N),K=new E.$P_b,ie=new w.$Uc;V&&ie.add(V.onCancellationRequested(()=>{const ye=b.serializeCancel(N);this.f?.logOutgoing(ye.byteLength,N,0,"cancel"),this.c.send(b.serializeCancel(N))})),this.w[U]=new u(K,ie),this.F(N);const ce=b.serializeRequest(N,C,P,q,!!V);return this.f?.logOutgoing(ce.byteLength,N,0,`request: ${(0,T.$uw)(C)}.${P}(`,W),this.c.send(ce),K}}e.$T_b=$;class u{constructor(C,P){this.a=C,this.b=P}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class S{static alloc(C,P,W){const V=new S(M.$Ge.alloc(W+1+4),0);return V.writeUInt8(C),V.writeUInt32(P),V}static read(C,P){return new S(C,P)}get buffer(){return this.a}constructor(C,P){this.a=C,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+C).toString();return this.b+=C,W}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+C);return this.b+=C,P}static sizeMixedArray(C){let P=0;P+=1;for(let W=0,V=C.length;W<V;W++){const q=C[W];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let N=0;N<q.buffers.length;++N)P+=this.sizeVSBuffer(q.buffers[N]);break;case 4:break}}return P}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let P=0,W=C.length;P<W;P++){const V=C[P];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const P=new Array(C);for(let W=0;W<C;W++)switch(this.readUInt8()){case 1:P[W]=this.readLongString();break;case 2:P[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),N=this.readLongString(),U=[];for(let K=0;K<q;++K)U.push(this.readVSBuffer());P[W]=new T.$vw(s(N,U,null));break}case 4:P[W]=void 0;break}return P}}var h;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(h||(h={}));class b{static a(C){for(let P=0,W=C.length;P<W;P++)if(C[P]instanceof M.$Ge||C[P]instanceof T.$vw||typeof C[P]>"u")return!0;return!1}static serializeRequestArguments(C,P){if(this.a(C)){const W=[];for(let V=0,q=C.length;V<q;V++){const N=C[V];if(N instanceof M.$Ge)W[V]={type:2,value:N};else if(typeof N>"u")W[V]={type:4};else if(N instanceof T.$vw){const{jsonString:U,referencedBuffers:K}=o(N.value,P);W[V]={type:3,value:M.$Ge.fromString(U),buffers:K}}else W[V]={type:1,value:M.$Ge.fromString(i(N,P))}}return{type:1,args:W}}return{type:0,args:i(C,P)}}static serializeRequest(C,P,W,V,q){switch(V.type){case 0:return this.b(C,P,W,V.args,q);case 1:return this.c(C,P,W,V.args,q)}}static b(C,P,W,V,q){const N=M.$Ge.fromString(W),U=M.$Ge.fromString(V);let K=0;K+=S.sizeUInt8(),K+=S.sizeShortString(N),K+=S.sizeLongString(U);const ie=S.alloc(q?2:1,C,K);return ie.writeUInt8(P),ie.writeShortString(N),ie.writeLongString(U),ie.buffer}static deserializeRequestJSONArgs(C){const P=C.readUInt8(),W=C.readShortString(),V=C.readLongString();return{rpcId:P,method:W,args:JSON.parse(V)}}static c(C,P,W,V,q){const N=M.$Ge.fromString(W);let U=0;U+=S.sizeUInt8(),U+=S.sizeShortString(N),U+=S.sizeMixedArray(V);const K=S.alloc(q?4:3,C,U);return K.writeUInt8(P),K.writeShortString(N),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(C){const P=C.readUInt8(),W=C.readShortString(),V=C.readMixedArray(),q=new Array(V.length);for(let N=0,U=V.length;N<U;N++){const K=V[N];typeof K=="string"?q[N]=JSON.parse(K):q[N]=K}return{rpcId:P,method:W,args:q}}static serializeAcknowledged(C){return S.alloc(5,C,0).buffer}static serializeCancel(C){return S.alloc(6,C,0).buffer}static serializeReplyOK(C,P,W){if(typeof P>"u")return this.d(C);if(P instanceof M.$Ge)return this.e(C,P);if(P instanceof T.$vw){const{jsonString:V,referencedBuffers:q}=o(P.value,W,!0);return this.g(C,V,q)}else return this.f(C,d(P,W))}static d(C){return S.alloc(7,C,0).buffer}static e(C,P){let W=0;W+=S.sizeVSBuffer(P);const V=S.alloc(8,C,W);return V.writeVSBuffer(P),V.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,P){const W=M.$Ge.fromString(P);let V=0;V+=S.sizeLongString(W);const q=S.alloc(9,C,V);return q.writeLongString(W),q.buffer}static g(C,P,W){const V=M.$Ge.fromString(P);let q=0;q+=S.sizeUInt32,q+=S.sizeLongString(V);for(const U of W)q+=S.sizeVSBuffer(U);const N=S.alloc(10,C,q);N.writeUInt32(W.length),N.writeLongString(V);for(const U of W)N.writeBuffer(U);return N.buffer}static deserializeReplyOKJSON(C){const P=C.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(C,P){const W=C.readUInt32(),V=C.readLongString(),q=[];for(let N=0;N<W;++N)q.push(C.readVSBuffer());return new T.$vw(s(V,q,P))}static serializeReplyErr(C,P){const W=P?d(O.$3(P),null):void 0;if(typeof W!="string")return this.h(C);const V=M.$Ge.fromString(W);let q=0;q+=S.sizeLongString(V);const N=S.alloc(11,C,q);return N.writeLongString(V),N.buffer}static deserializeReplyErrError(C){const P=C.readLongString();return JSON.parse(P)}static h(C){return S.alloc(12,C,0).buffer}}var m;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var k;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(k||(k={}))}),define(Ie[255],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=void 0;const I=function(O){const R=w=>{globalThis.removeEventListener("message",R);const p=w.data;Object.defineProperties(globalThis,{postMessage:{value(E,T){p.postMessage(E,T)}},onmessage:{get(){return p.onmessage},set(E){p.onmessage=E}}}),p.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",R)}.toString();class M extends EventTarget{constructor(O,R,w){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${I})('${R}'))`,E=new Blob([p],{type:"application/javascript"}),T=URL.createObjectURL(E),D=new MessageChannel,d=T,v={type:"_newWorker",id:d,port:D.port2,url:T,options:w};O(v,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{O({type:"_terminateWorker",id:d}),URL.revokeObjectURL(T),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(g){D.port1.onmessage=g}},onmessageerror:{get(){return D.port1.onmessageerror},set(g){D.port1.onmessageerror=g}}}),D.port1.addEventListener("messageerror",g=>{const r=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(r)}),D.port1.addEventListener("message",g=>{const r=new MessageEvent("message",{data:g.data});this.dispatchEvent(r)}),D.port1.start()}}e.$tpc=M}),define(Ie[256],Pe([1,0,21,28,16,56,3]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HK=e.$EK=void 0,e.$FK=T,e.$GK=D,e.$EK=(0,R.$wi)("notebookDocumentService");const w=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${w.join("")}]+`),E=7;function T(v){if(v.scheme!==A.Schemas.vscodeNotebookCell)return;const g=v.fragment.indexOf("s");if(g<0)return;const r=parseInt(v.fragment.substring(0,g).replace(p,""),E),o=(0,I.$Ze)(v.fragment.substring(g+1)).toString();if(!isNaN(r))return{handle:r,notebook:v.with({scheme:o,fragment:null})}}function D(v,g){const r=g.toString(E),s=`${r.length<w.length?w[r.length-1]:"z"}${r}s${(0,I.$1e)(I.$Ge.fromString(v.scheme),!0,!0)}`;return v.with({scheme:A.Schemas.vscodeNotebookCell,fragment:s})}class d{constructor(){this.a=new M.$Bc}getNotebook(g){if(g.scheme===A.Schemas.vscodeNotebookCell){const r=T(g);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(g)}addNotebookDocument(g){this.a.set(g.uri,g)}removeNotebookDocument(g){this.a.delete(g.uri)}}e.$HK=d,(0,O.$xs)(e.$EK,d,1)}),define(Ie[85],Pe([1,0,21,37,42,70,16,19,22,31,256]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.$YK=e.CellStatusbarAlignment=e.$XK=e.NotebookEditorPriority=e.$UK=e.$TK=e.$RK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$QK=e.$PK=e.$OK=e.$NK=e.CellKind=e.$MK=e.$LK=e.$KK=void 0,e.$SK=f,e.$VK=$,e.$WK=u,e.$ZK=b,e.$1K=k,e.$KK="workbench.editor.notebook",e.$LK="workbench.editor.notebookTextDiffEditor",e.$MK="workbench.editor.interactive";var D;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(D||(e.CellKind=D={})),e.$NK=["application/json","application/javascript","text/html","image/svg+xml",O.$Qs.latex,O.$Qs.markdown,"image/png","image/jpeg",O.$Qs.text],e.$OK=[O.$Qs.latex,O.$Qs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Qs.text],e.$PK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$QK="_notAvailable";var d;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(d||(e.NotebookRunState=d={}));var v;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var g;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(g||(e.NotebookExecutionState=g={}));var r;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var i;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var c;(function(K){K.scheme=R.Schemas.vscodeNotebookCell;function ie(Te,ae){return(0,T.$GK)(Te,ae)}K.generate=ie;function ce(Te){return(0,T.$FK)(Te)}K.parse=ce;function ye(Te,ae){return Te.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ae??""},${Te.scheme!==R.Schemas.file?Te.scheme:""}`})}K.generateCellOutputUri=ye;function Se(Te){if(Te.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ae=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Te.fragment);if(!ae)return;const Ne=ae[1]&&ae[1]!==""?ae[1]:void 0,ne=ae[2];return{outputId:Ne,notebook:Te.with({scheme:ne||R.Schemas.file,fragment:null})}}K.parseCellOutputUri=Se;function fe(Te,ae,Ne){return K.generate(Te,ae).with({scheme:Ne})}K.generateCellPropertyUri=fe;function $e(Te,ae){if(Te.scheme===ae)return K.parse(Te.with({scheme:K.scheme}))}K.parseCellPropertyUri=$e})(c||(e.CellUri=c={}));const l=K=>p.$i?K.replace(/\//g,"\\"):K;class t{constructor(ie=[],ce=e.$NK){this.e=ce,this.d=[...new Set(ie)].map(ye=>({pattern:ye,matches:M.$qk(l(ye))}))}sort(ie){const ce=new Map(A.Iterable.map(ie,Se=>[Se,l(Se)]));let ye=[];for(const{matches:Se}of this.d)for(const[fe,$e]of ce)if(Se($e)){ye.push(fe),ce.delete(fe);break}return ce.size&&(ye=ye.concat([...ce.keys()].sort((Se,fe)=>this.e.indexOf(Se)-this.e.indexOf(fe)))),ye}prioritize(ie,ce){const ye=this.f(ie);if(ye===-1){this.d.unshift({pattern:ie,matches:M.$qk(l(ie))});return}const Se=new Set(ce.map($e=>this.f($e,ye)));Se.delete(-1);const fe=Array.from(Se).sort();this.d.splice(ye+1,0,...fe.map($e=>this.d[$e]));for(let $e=fe.length-1;$e>=0;$e--)this.d.splice(fe[$e],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,ce=this.d.length){const ye=l(ie);for(let Se=0;Se<ce;Se++)if(this.d[Se].matches(ye))return Se;return-1}}e.$RK=t;function f(K,ie,ce,ye=(Se,fe)=>Se===fe){const Se=[];function fe(ae,Ne,ne){if(Ne===0&&ne.length===0)return;const z=Se[Se.length-1];z&&z.start+z.deleteCount===ae?(z.deleteCount+=Ne,z.toInsert.push(...ne)):Se.push({start:ae,deleteCount:Ne,toInsert:ne})}let $e=0,Te=0;for(;;){if($e===K.length){fe($e,0,ie.slice(Te));break}if(Te===ie.length){fe($e,K.length-$e,[]);break}const ae=K[$e],Ne=ie[Te];if(ye(ae,Ne)){$e+=1,Te+=1;continue}ce(Ne)?(fe($e,1,[]),$e+=1):(fe($e,0,[Ne]),Te+=1)}return Se}e.$TK=new E.$Nj("notebookEditorCursorAtBoundary","none"),e.$UK=new E.$Nj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function $(K){const ie=K;return!!((typeof ie.include=="string"||M.$rk(ie.include))&&(typeof ie.exclude=="string"||M.$rk(ie.exclude)))}function u(K,ie,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const ye=$(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Se=$(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(M.$pk(ye,(0,w.$oc)(ce.fsPath).toLowerCase()))return!(Se&&M.$pk(Se,(0,w.$oc)(ce.fsPath).toLowerCase()))}return!1}e.$XK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class h{static{this.d="notebook/"}static create(ie){return`${h.d}${ie}`}static parse(ie){if(ie.startsWith(h.d))return ie.substring(h.d.length)}}e.$YK=h;function b(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const m=new TextDecoder;function k(K){const ie=[];let ce=!1;for(const $e of K)(ie.length===0||ce)&&(ie.push($e),ce=!0);let ye=P(ie);const Se=I.$Ge.concat(ie.map($e=>I.$Ge.wrap($e))),fe=U(Se);return ye=ye||fe.byteLength!==Se.byteLength,{data:fe,didCompression:ye}}e.$2K="\x1B[A";const y=e.$2K.split("").map(K=>K.charCodeAt(0)),C=10;function P(K){let ie=!1;return K.forEach((ce,ye)=>{if(ye===0||ce.length<e.$2K.length)return;const Se=K[ye-1],fe=ce.subarray(0,e.$2K.length);if(fe[0]===y[0]&&fe[1]===y[1]&&fe[2]===y[2]){const $e=Se.lastIndexOf(C);if($e===-1)return;ie=!0,K[ye-1]=Se.subarray(0,$e),K[ye]=ce.subarray(e.$2K.length)}}),ie}function W(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+ie.slice(ce.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,N=13;function U(K){return!K.buffer.includes(q)&&!K.buffer.includes(N)?K:I.$Ge.fromString(V(W(m.decode(K.buffer))))}}),define(Ie[7],Pe([1,0,18,14,55,28,70,13,15,2,34,20,38,104,85]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g){"use strict";var r,o,s,i,n,c,l,t,f,a,$,u,S,h,b,m,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$eP=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$dP=e.$cP=e.$bP=e.$aP=e.ChatLocation=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$1O=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$NO=e.$MO=e.$LO=e.$KO=e.$IO=e.$HO=e.$GO=e.$FO=e.TestRunProfileKind=e.TestResultState=e.$EO=e.$DO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$CO=e.NotebookVariablesRequestKind=e.$BO=e.$AO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$zO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.ColorThemeKind=e.$tO=e.$sO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$rO=e.$qO=e.DebugConsoleMode=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$kO=e.$jO=e.FileChangeType=e.$iO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$hO=e.$gO=e.$fO=e.$eO=e.InlineCompletionTriggerKind=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$4N=e.ConfigurationTarget=e.$3N=e.$2N=e.$1N=e.$ZN=e.DocumentPasteTriggerKind=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$SN=e.ViewBadge=e.ProgressLocation=e.$RN=e.$QN=e.TaskScope=e.ShellQuoting=e.$PN=e.$ON=e.$NN=e.TaskPanelKind=e.TaskRevealKind=e.$MN=e.TerminalLocation=e.$LN=e.$KN=e.$JN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$IN=e.$HN=e.$GN=e.$FN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$DN=e.$CN=e.$BN=e.$AN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$zN=e.$yN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.LanguageStatusSeverity=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.CodeActionTriggerKind=e.$mN=e.$lN=e.SymbolTag=e.SymbolKind=e.$kN=e.$jN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.DiagnosticSeverity=e.DiagnosticTag=e.$dN=e.$cN=e.FileEditType=e.$bN=e.$aN=e.$_M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$EN=Vt,e.$5N=ke,e.$JO=bn;function y(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const Ee=te.length===1?[]:te[1];return Reflect.construct(B,Ee,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[Ee,...Ke]=te;return Reflect.construct(B,Ke,Ee.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var P;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let W=r=class{static from(...L){let te=L;return new r(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$5M=W,e.$5M=W=r=Je([y],W);let V=o=class{static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ke=L[Ee];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ke=L[Ee];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(L){if(!L)return!1;if(L instanceof o)return!0;const{line:te,character:Ee}=L;return typeof te=="number"&&typeof Ee=="number"}static of(L){if(L instanceof o)return L;if(this.isPosition(L))return new o(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,te){if(L<0)throw(0,M.$7)("line must be non-negative");if(te<0)throw(0,M.$7)("character must be non-negative");this.c=L,this.e=te}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,te=0){if(L===null||te===null)throw(0,M.$7)();let Ee;return typeof L>"u"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&te===0?this:new o(this.line+Ee,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,M.$7)();let Ee;return typeof L>"u"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),Ee===this.line&&te===this.character?this:new o(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};e.$6M=V,e.$6M=V=o=Je([y],V);let q=s=class{static isRange(L){return L instanceof s?!0:L?V.isPosition(L.start)&&V.isPosition(L.end):!1}static of(L){if(L instanceof s)return L;if(this.isRange(L))return new s(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,te,Ee,Ke){let Ye,lt;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new V(L,te),lt=new V(Ee,Ke)):V.isPosition(L)&&V.isPosition(te)&&(Ye=V.of(L),lt=V.of(te)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(L){return s.isRange(L)?this.contains(L.start)&&this.contains(L.end):V.isPosition(L)?!(V.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const te=V.Max(L.start,this.c),Ee=V.Min(L.end,this.e);if(!te.isAfter(Ee))return new s(te,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=V.Min(L.start,this.c),Ee=V.Max(L.end,this.end);return new s(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,te=this.end){if(L===null||te===null)throw(0,M.$7)();let Ee;return L?V.isPosition(L)?Ee=L:(Ee=L.start||this.start,te=L.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new s(Ee,te)}toJSON(){return[this.start,this.end]}};e.$7M=q,e.$7M=q=s=Je([y],q);let N=i=class extends q{static isSelection(L){return L instanceof i?!0:L?q.isRange(L)&&V.isPosition(L.anchor)&&V.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,te,Ee,Ke){let Ye,lt;if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new V(L,te),lt=new V(Ee,Ke)):V.isPosition(L)&&V.isPosition(te)&&(Ye=V.of(L),lt=V.of(te)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$8M=N,e.$8M=N=i=Je([y],N);const U=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,M.$7)("connectionToken")};class K{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te,Ee){if(typeof L!="string"||L.length===0)throw(0,M.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.$7)("port");typeof Ee<"u"&&U(Ee),this.host=L,this.port=Math.round(te),this.connectionToken=Ee}}e.$9M=K;class ie{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,te){this.makeConnection=L,this.connectionToken=te,typeof te<"u"&&U(te)}}e.$0M=ie;class ce extends Error{static NotAvailable(L,te){return new ce(L,v.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new ce(L,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,te=v.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L),this._message=L,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,ce.prototype)}}e.$$M=ce;var ye;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var Se;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Se||(e.EnvironmentVariableMutatorType=Se={}));let fe=n=class{static isTextEdit(L){return L instanceof n?!0:L?q.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new n(L,te)}static insert(L,te){return n.replace(new q(L,L),te)}static delete(L){return n.replace(L,"")}static setEndOfLine(L){const te=new n(new q(new V(0,0),new V(0,0)),"");return te.newEol=L,te}get range(){return this.c}set range(L){if(L&&!q.isRange(L))throw(0,M.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,M.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,M.$7)("newEol");this.f=L}constructor(L,te){this.c=L,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$_M=fe,e.$_M=fe=n=Je([y],fe);let $e=c=class{static isNotebookCellEdit(L){return L instanceof c?!0:L?gi.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,te){return new c(L,te)}static insertCells(L,te){return new c(new gi(L,L),te)}static deleteCells(L){return new c(L,[])}static updateCellMetadata(L,te){const Ee=new c(new gi(L,L),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(L){const te=new c(new gi(0,0),[]);return te.newNotebookMetadata=L,te}constructor(L,te){this.range=L,this.newCells=te}};e.$aN=$e,e.$aN=$e=c=Je([y],$e);class Te{static isSnippetTextEdit(L){return L instanceof Te?!0:L?q.isRange(L.range)&&ne.isSnippetString(L.snippet):!1}static replace(L,te){return new Te(L,te)}static insert(L,te){return Te.replace(new q(L,L),te)}constructor(L,te){this.range=L,this.snippet=te}}e.$bN=Te;var ae;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let Ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,te,Ee,Ke){this.c.push({_type:1,from:L,to:te,options:Ee,metadata:Ke})}createFile(L,te,Ee){this.c.push({_type:1,from:void 0,to:L,options:te,metadata:Ee})}deleteFile(L,te,Ee){this.c.push({_type:1,from:L,to:void 0,options:te,metadata:Ee})}e(L,te,Ee){this.c.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}f(L,te,Ee,Ke){const Ye=te.start,lt=te.end;(Ye!==lt||Ee.length>0)&&this.c.push({_type:5,uri:L,index:Ye,count:lt-Ye,cells:Ee,metadata:Ke})}g(L,te,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:L,edit:{editType:3,index:te,metadata:Ee}})}replace(L,te,Ee,Ke){this.c.push({_type:2,uri:L,edit:new fe(te,Ee),metadata:Ke})}insert(L,te,Ee,Ke){this.replace(L,new q(te,te),Ee,Ke)}delete(L,te,Ee){this.replace(L,te,"",Ee)}has(L){return this.c.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const Ee of te){if(!Ee)continue;let Ke,Ye;Array.isArray(Ee)?(Ke=Ee[0],Ye=Ee[1]):Ke=Ee,$e.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(L,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(L,Ke.newNotebookMetadata,Ye):this.f(L,Ke.range,Ke.newCells,Ye):Te.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:L,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:L,edit:Ke,metadata:Ye})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===L.toString()&&(this.c[Ee]=void 0);break}}(0,I.$Ib)(this.c)}}get(L){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===L.toString()&&te.push(Ee.edit);return te}entries(){const L=new O.$Bc;for(const te of this.c)if(te._type===2){let Ee=L.get(te.uri);Ee||(Ee=[te.uri,[]],L.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$cN=Ne,e.$cN=Ne=Je([y],Ne);let ne=l=class{static isSnippetString(L){return L instanceof l?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=l.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this.e++){if(typeof L=="function"){const Ee=new l;Ee.e=this.e,L(Ee),this.e=Ee.e,L=Ee.value}else L=l.c(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this.e++){const Ee=L.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const Ee=new l;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$dN=ne,e.$dN=ne=l=Je([y],ne);var z;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(z||(e.DiagnosticTag=z={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let ve=t=class{static isLocation(L){return L instanceof t?!0:L?q.isRange(L.range)&&E.URI.isUri(L.uri):!1}constructor(L,te){if(this.uri=L,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$eN=ve,e.$eN=ve=t=Je([y],ve);let Fe=class{static is(L){return L?typeof L.message=="string"&&L.location&&q.isRange(L.location.range)&&E.URI.isUri(L.location.uri):!1}constructor(L,te){this.location=L,this.message=te}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};e.$fN=Fe,e.$fN=Fe=Je([y],Fe);let De=class{constructor(L,te,Ee=x.Error){if(!q.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,I.$ub)(L.tags,te.tags)&&(0,I.$ub)(L.relatedInformation,te.relatedInformation,Fe.isEqual)}};e.$gN=De,e.$gN=De=Je([y],De);let we=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};e.$hN=we,e.$hN=we=Je([y],we);let ge=class extends we{constructor(L,te,Ee,Ke){super(L,te),this.canIncreaseHover=Ee,this.canDecreaseHover=Ke}};e.$iN=ge,e.$iN=ge=Je([y],ge);var Q;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var Y;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let he=class{constructor(L,te=Y.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$jN=he,e.$jN=he=Je([y],he);let ue=class{constructor(L,te){this.uri=L,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$kN=ue,e.$kN=ue=Je([y],ue);var Oe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Oe||(e.SymbolKind=Oe={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ce=f=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,te,Ee,Ke,Ye){this.name=L,this.kind=te,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof ve?this.location=Ke:Ee instanceof q&&(this.location=new ve(Ke,Ee)),f.validate(this)}toJSON(){return{name:this.name,kind:Oe[this.kind],location:this.location,containerName:this.containerName}}};e.$lN=Ce,e.$lN=Ce=f=Je([y],Ce);let Ae=a=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(a.validate)}constructor(L,te,Ee,Ke,Ye){this.name=L,this.detail=te,this.kind=Ee,this.range=Ke,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$mN=Ae,e.$mN=Ae=a=Je([y],Ae);var Ue;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ue||(e.CodeActionTriggerKind=Ue={}));let j=class{constructor(L,te){this.title=L,this.kind=te}};e.$nN=j,e.$nN=j=Je([y],j);let F=class{static{$=this}static{this.c="."}constructor(L){this.value=L}append(L){return new $(this.value?this.value+$.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+$.c)}};e.$oN=F,e.$oN=F=$=Je([y],F),F.Empty=new F(""),F.QuickFix=F.Empty.append("quickfix"),F.Refactor=F.Empty.append("refactor"),F.RefactorExtract=F.Refactor.append("extract"),F.RefactorInline=F.Refactor.append("inline"),F.RefactorMove=F.Refactor.append("move"),F.RefactorRewrite=F.Refactor.append("rewrite"),F.Source=F.Empty.append("source"),F.SourceOrganizeImports=F.Source.append("organizeImports"),F.SourceFixAll=F.Source.append("fixAll"),F.Notebook=F.Empty.append("notebook");let H=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$pN=H,e.$pN=H=Je([y],H);class G{constructor(L,te,Ee,Ke,Ye,lt){this.kind=L,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$qN=G;class ee{constructor(L,te){this.fromRanges=te,this.from=L}}e.$rN=ee;class re{constructor(L,te){this.fromRanges=te,this.to=L}}e.$sN=re;var Me;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Me||(e.LanguageStatusSeverity=Me={}));let Be=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};e.$tN=Be,e.$tN=Be=Je([y],Be);let He=u=class{#e;static isMarkdownString(L){return L instanceof u?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,te=!1){this.#e=new A.$Tk(L,{supportThemeIcons:te})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,te){return this.#e.appendCodeblock(te??"",L),this}};e.$uN=He,e.$uN=He=u=Je([y],He);let _e=class{constructor(L,te){this.label=L,this.documentation=te}};e.$vN=_e,e.$vN=_e=Je([y],_e);let xe=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};e.$wN=xe,e.$wN=xe=Je([y],xe);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$xN=et,e.$xN=et=Je([y],et);var tt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var it;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let at=class{constructor(L){this.value=L}};e.$yN=at,e.$yN=at=Je([y],at);let gt=class{constructor(L,te,Ee){this.position=L,this.label=te,this.kind=Ee}};e.$zN=gt,e.$zN=gt=Je([y],gt);var je;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var st;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(st||(e.CompletionItemKind=st={}));var X;(function(B){B[B.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let Z=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&st[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$AN=Z,e.$AN=Z=Je([y],Z);let me=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};e.$BN=me,e.$BN=me=Je([y],me);let qe=class{constructor(L,te,Ee){this.insertText=L,this.range=te,this.command=Ee}};e.$CN=qe,e.$CN=qe=Je([y],qe);let be=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$DN=be,e.$DN=be=Je([y],be);var ot;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(ot||(e.PartialAcceptTriggerKind=ot={}));var dt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var Pt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Pt||(e.StatusBarAlignment=Pt={}));function Vt(B,L){return`${D.$Rm.toKey(B)}.${L}`}var Qt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var ti;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(ti||(e.TextDocumentSaveReason=ti={}));var Zt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Zt||(e.TextEditorRevealType=Zt={}));var Et;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Xt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Xt||(e.TextDocumentChangeReason=Xt={}));var Yt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(B){function L(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=L}(Et||(e.TextEditorSelectionChangeKind=Et={}));var Xe;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Xe||(e.SyntaxTokenType=Xe={})),function(B){function L(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=L}(Xe||(e.SyntaxTokenType=Xe={}));let oi=class{constructor(L,te){if(te&&!E.URI.isUri(te))throw(0,M.$7)("target");if(!q.isRange(L)||L.isEmpty)throw(0,M.$7)("range");this.range=L,this.target=te}};e.$FN=oi,e.$FN=oi=Je([y],oi);let Gt=class{constructor(L,te,Ee,Ke){this.red=L,this.green=te,this.blue=Ee,this.alpha=Ke}};e.$GN=Gt,e.$GN=Gt=Je([y],Gt);let ht=class{constructor(L,te){if(te&&!(te instanceof Gt))throw(0,M.$7)("color");if(!q.isRange(L)||L.isEmpty)throw(0,M.$7)("range");this.range=L,this.color=te}};e.$HN=ht,e.$HN=ht=Je([y],ht);let $t=class{constructor(L){if(!L||typeof L!="string")throw(0,M.$7)("label");this.label=L}};e.$IN=$t,e.$IN=$t=Je([y],$t);var xt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(xt||(e.ColorFormat=xt={}));var Kt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var Ft;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Ft||(e.TerminalExitReason=Ft={}));var ft;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(ft||(e.TerminalShellExecutionCommandLineConfidence=ft={}));class Bt{constructor(L,te,Ee){if(this.startIndex=L,this.length=te,this.tooltip=Ee,typeof L!="number"||L<0)throw(0,M.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,M.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,M.$7)("tooltip")}}e.$JN=Bt;class _t{constructor(L){this.uri=L}}e.$KN=_t;class Ut{constructor(L){this.terminalCommand=L}}e.$LN=Ut;var Qe;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ui{constructor(L){if(this.options=L,typeof L!="object")throw(0,M.$7)("options")}}e.$MN=ui;var Jt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var Wt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Wt||(e.TaskPanelKind=Wt={}));let pt=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(L){switch(L){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,M.$7)("name");this.c=L}get id(){return this.c}};e.$NN=pt,e.$NN=pt=S=Je([y],pt);function Lt(B){let L="";for(let te=0;te<B.length;te++)L+=B[te].replace(/,/g,",,")+",";return L}let Rt=class{constructor(L,te,Ee){if(typeof L!="string")throw(0,M.$7)("process");this.e=[],this.c=L,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,M.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const te of this.e)L.push(te);return Lt(L)}};e.$ON=Rt,e.$ON=Rt=Je([y],Rt);let Mt=class{constructor(L,te,Ee){if(this.f=[],Array.isArray(te)){if(!L)throw(0,M.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$7)("command");this.e=L,this.f=te,this.g=Ee}else{if(typeof L!="string")throw(0,M.$7)("commandLine");this.c=L,this.g=te}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,M.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)L.push(typeof te=="string"?te:te.value);return Lt(L)}};e.$PN=Mt,e.$PN=Mt=Je([y],Mt);var ii;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ii||(e.ShellQuoting=ii={}));var qt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(qt||(e.TaskScope=qt={}));class ni{constructor(L){this.c=L}computeId(){return"customExecution"+(0,T.$Sg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$QN=ni;let Ct=class{static{h=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,te,Ee,Ke,Ye,lt){this.k=!1,this.l=this.definition=L;let wt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Ee,this.execution=Ke,wt=Ye,this.k=!0):te===qt.Global||te===qt.Workspace?(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,wt=lt):(this.target=te,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,wt=lt),typeof wt=="string"?(this.r=[wt],this.t=!0):Array.isArray(wt)?(this.r=wt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Rt?this.l={type:h.e,id:this.q.computeId()}:this.q instanceof Mt?this.l={type:h.f,id:this.q.computeId()}:this.q instanceof ni?this.l={type:h.c,id:this.q.computeId()}:this.l={type:h.g,id:(0,T.$Sg)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,M.$7)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,M.$7)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const te=this.l.type;(h.g===te||h.e===te||h.f===te||h.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.$7)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$RN=Ct,e.$RN=Ct=h=Je([y],Ct);var Ot;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Ot||(e.ProgressLocation=Ot={}));var Nt;(function(B){function L(te){const Ee=te;return(0,p.$ag)(Ee.value)?Ee.tooltip&&!(0,p.$9f)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}B.isViewBadge=L})(Nt||(e.ViewBadge=Nt={}));let It=b=class{static isTreeItem(L,te){const Ee=L;if(Ee.checkboxState!==void 0){const Ke=(0,p.$ag)(Ee.checkboxState)?Ee.checkboxState:(0,p.$$f)(Ee.checkboxState)&&(0,p.$ag)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Ye=!(0,p.$ag)(Ee.checkboxState)&&(0,p.$$f)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Dt.Checked&&Ke!==Dt.Unchecked||Ye!==void 0&&!(0,p.$9f)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(L instanceof b)return!0;if(Ee.label!==void 0&&!(0,p.$9f)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,p.$9f)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,p.$9f)(Ee.iconPath)&&!E.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,p.$9f)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,p.$9f)(Ke.light)&&!E.URI.isUri(Ke.light)&&!(0,p.$9f)(Ke.dark)&&!E.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,p.$9f)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!E.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,p.$9f)(Ee.tooltip)&&!(Ee.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<mt.None&&Ee.collapsibleState>mt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,p.$9f)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(L,te=mt.None){this.collapsibleState=te,E.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$SN=It,e.$SN=It=b=Je([y],It);var mt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(mt||(e.TreeItemCollapsibleState=mt={}));var Dt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let ai=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$TN=ai,e.$TN=ai=Je([y],ai);class kt extends ai{}e.$UN=kt;class fi extends kt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$VN=fi;class ri{constructor(L,te,Ee,Ke){this.name=L,this.uri=te,this._itemId=Ee,this.c=Ke}data(){return this.c()}}e.$WN=ri;let $i=class{#e=new Map;constructor(L){for(const[te,Ee]of L??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(Ee):this.#e.set(this.#t(te),[Ee])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,te){this.#e.set(this.#t(L),[te])}forEach(L,te){for(const[Ee,Ke]of this.#e)for(const Ye of Ke)L.call(te,Ye,Ee,this)}*[Symbol.iterator](){for(const[L,te]of this.#e)for(const Ee of te)yield[L,Ee]}#t(L){return L.toLowerCase()}};e.$XN=$i,e.$XN=$i=Je([y],$i);let li=class{constructor(L,te,Ee){this.insertText=L,this.title=te,this.kind=Ee}};e.$YN=li,e.$YN=li=Je([y],li);var wi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class St{static{this.c="."}constructor(L){this.value=L}append(...L){return new St((this.value?[this.value,...L]:L).join(St.c))}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+St.c)}}e.$ZN=St,St.Empty=new St("");class bi{constructor(L,te,Ee){this.title=te,this.insertText=L,this.kind=Ee}}e.$1N=bi;let si=class{constructor(L,te){this.id=L,this.color=te}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$2N=si,e.$2N=si=Je([y],si),si.File=new si("file"),si.Folder=new si("folder");let pe=class{constructor(L){this.id=L}};e.$3N=pe,e.$3N=pe=Je([y],pe);var Re;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Re||(e.ConfigurationTarget=Re={}));let se=class{get base(){return this.c}set base(L){this.c=L,this.e=E.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,te){if(typeof L!="string"&&(!L||!E.URI.isUri(L)&&!E.URI.isUri(L.uri)))throw(0,M.$7)("base");if(typeof te!="string")throw(0,M.$7)("pattern");typeof L=="string"?this.baseUri=E.URI.file(L):E.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$4N=se,e.$4N=se=Je([y],se);const J=new WeakMap;function ke(B,L){J.set(B,L)}let Ve=class{constructor(L,te,Ee,Ke,Ye){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=J.get(this)??(0,T.$Sg)()),this.c}};e.$6N=Ve,e.$6N=Ve=Je([y],Ve);let Ze=class extends Ve{constructor(L,te,Ee,Ke,Ye,lt){if(super(te,Ee,Ke,Ye,lt),L===null)throw(0,M.$7)("location");this.location=L}};e.$7N=Ze,e.$7N=Ze=Je([y],Ze);let Ge=class extends Ve{constructor(L,te,Ee,Ke,Ye,lt){super(te,Ee,Ke,Ye,lt),this.functionName=L}};e.$8N=Ge,e.$8N=Ge=Je([y],Ge);let ut=class extends Ve{constructor(L,te,Ee,Ke,Ye,lt,wt,Ht){if(super(Ke,Ye,lt,wt,Ht),!te)throw(0,M.$7)("dataId");this.label=L,this.dataId=te,this.canPersist=Ee}};e.$9N=ut,e.$9N=ut=Je([y],ut);let yt=class{constructor(L,te,Ee){this.command=L,this.args=te||[],this.options=Ee}};e.$0N=yt,e.$0N=yt=Je([y],yt);let zt=class{constructor(L,te){this.port=L,this.host=te}};e.$$N=zt,e.$$N=zt=Je([y],zt);let ct=class{constructor(L){this.path=L}};e.$_N=ct,e.$_N=ct=Je([y],ct);let Tt=class{constructor(L){this.implementation=L}};e.$aO=Tt,e.$aO=Tt=Je([y],Tt);class jt{constructor(L,te,Ee){this.session=L,this.threadId=te,this.frameId=Ee}}e.$bO=jt;class yi{constructor(L,te){this.session=L,this.threadId=te}}e.$cO=yi;let ki=class{constructor(L,te){this.range=L,this.expression=te}};e.$dO=ki,e.$dO=ki=Je([y],ki);var Ki;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ki||(e.InlineCompletionTriggerKind=Ki={}));let Mi=class{constructor(L,te){this.range=L,this.text=te}};e.$eO=Mi,e.$eO=Mi=Je([y],Mi);let Oi=class{constructor(L,te,Ee=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=Ee}};e.$fO=Oi,e.$fO=Oi=Je([y],Oi);let Si=class{constructor(L,te){this.range=L,this.expression=te}};e.$gO=Si,e.$gO=Si=Je([y],Si);let Ti=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};e.$hO=Ti,e.$hO=Ti=Je([y],Ti);var Fi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Fi||(e.NewSymbolNameTag=Fi={}));var Ji;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ji||(e.NewSymbolNameTriggerKind=Ji={}));class Li{constructor(L,te){this.newSymbolName=L,this.tags=te}}e.$iO=Li;var Ii;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ii||(e.FileChangeType=Ii={}));let zi=m=class extends Error{static FileExists(L){return new m(L,d.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(L){return new m(L,d.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(L){return new m(L,d.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(L){return new m(L,d.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(L){return new m(L,d.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(L){return new m(L,d.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}constructor(L,te=d.FileSystemProviderErrorCode.Unknown,Ee){super(E.URI.isUri(L)?L.toString(!0):L),this.code=Ee?.name??"Unknown",(0,d.$fl)(this,te),Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$jO=zi,e.$jO=zi=m=Je([y],zi);let ji=class{constructor(L,te,Ee){this.start=L,this.end=te,this.kind=Ee}};e.$kO=ji,e.$kO=ji=Je([y],ji);var vi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(vi||(e.FoldingRangeKind=vi={}));var Qi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Qi||(e.CommentThreadCollapsibleState=Qi={}));var Zi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Xi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var Pi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Pi||(e.CommentThreadState=Pi={}));var Yi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Yi||(e.CommentThreadApplicability=Yi={}));class xi{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.$lO=xi;function dn(B){return typeof B>"u"||(0,p.$0f)(B)}class Ci{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let te=0,Ee=L.tokenTypes.length;te<Ee;te++)this.k.set(L.tokenTypes[te],te);for(let te=0,Ee=L.tokenModifiers.length;te<Ee;te++)this.l.set(L.tokenModifiers[te],te)}}push(L,te,Ee,Ke,Ye){if(typeof L=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(L,te,Ee,Ke,Ye);if(q.isRange(L)&&typeof te=="string"&&dn(Ee))return this.o(L,te,Ee);throw(0,M.$7)()}o(L,te,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=L.start.line,Ye=L.start.character,lt=L.end.character-L.start.character,wt=this.k.get(te);let Ht=0;if(Ee)for(const ci of Ee){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const di=this.l.get(ci);Ht|=1<<di>>>0}this.q(Ke,Ye,lt,wt,Ht)}q(L,te,Ee,Ke,Ye){if(this.f&&(L<this.c||L===this.c&&te<this.e)){this.f=!1;const Ht=this.g.length/5|0;let ci=0,di=0;for(let mi=0;mi<Ht;mi++){let pi=this.g[5*mi],Hi=this.g[5*mi+1];pi===0?(pi=ci,Hi+=di):pi+=ci,this.g[5*mi]=pi,this.g[5*mi+1]=Hi,ci=pi,di=Hi}}let lt=L,wt=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&(wt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=wt,this.g[this.j++]=Ee,this.g[this.j++]=Ke,this.g[this.j++]=Ye,this.c=L,this.e=te}static r(L){const te=[],Ee=L.length/5|0;for(let wt=0;wt<Ee;wt++)te[wt]=wt;te.sort((wt,Ht)=>{const ci=L[5*wt],di=L[5*Ht];if(ci===di){const mi=L[5*wt+1],pi=L[5*Ht+1];return mi-pi}return ci-di});const Ke=new Uint32Array(L.length);let Ye=0,lt=0;for(let wt=0;wt<Ee;wt++){const Ht=5*te[wt],ci=L[Ht+0],di=L[Ht+1],mi=L[Ht+2],pi=L[Ht+3],Hi=L[Ht+4],Tn=ci-Ye,dr=Tn===0?di-lt:di,Gi=5*wt;Ke[Gi+0]=Tn,Ke[Gi+1]=dr,Ke[Gi+2]=mi,Ke[Gi+3]=pi,Ke[Gi+4]=Hi,Ye=ci,lt=di}return Ke}build(L){return this.f?new Ui(new Uint32Array(this.g),L):new Ui(Ci.r(this.g),L)}}e.$mO=Ci;class Ui{constructor(L,te){this.resultId=te,this.data=L}}e.$nO=Ui;class fn{constructor(L,te,Ee){this.start=L,this.deleteCount=te,this.data=Ee}}e.$oO=fn;class gn{constructor(L,te){this.resultId=te,this.edits=L}}e.$pO=gn;var _i;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class Bi{constructor(L){this.name=L}}e.$qO=Bi;let Ai=class{static{this.Back={iconPath:new si("arrow-left")}}constructor(){}};e.$rO=Ai,e.$rO=Ai=Je([y],Ai);var ze;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(ze||(e.QuickPickItemKind=ze={}));var hi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(hi||(e.InputBoxValidationSeverity=hi={}));var Vi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Vi||(e.ExtensionKind=Vi={}));class nt{static validate(L){if(typeof L.badge=="string"){let te=(0,w.$If)(L.badge,0);if(te<L.badge.length&&(te+=(0,w.$If)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!si.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,te,Ee){this.badge=L,this.tooltip=te,this.color=Ee}}e.$sO=nt;let vt=class{constructor(L){this.kind=L}};e.$tO=vt,e.$tO=vt=Je([y],vt);var en;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class gi{static isNotebookRange(L){return L instanceof gi?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,te){if(L<0)throw(0,M.$7)("start must be positive");if(te<0)throw(0,M.$7)("end must be positive");L<=te?(this.c=L,this.e=te):(this.c=te,this.e=L)}with(L){let te=this.c,Ee=this.e;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(Ee=L.end),te===this.c&&Ee===this.e?this:new gi(te,Ee)}}e.$uO=gi;class Ei{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Ei.isNotebookCellData(te))}static isNotebookCellData(L){return!0}constructor(L,te,Ee,Ke,Ye,lt,wt){this.kind=L,this.value=te,this.languageId=Ee,this.mime=Ke,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=wt,Ei.validate(this)}}e.$vO=Ei;class mn{constructor(L){this.cells=L}}e.$wO=mn;class ei{static isNotebookCellOutputItem(L){return L instanceof ei?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return ei.json(te,"application/vnd.code.notebook.error")}static stdout(L){return ei.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return ei.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new ei(L,te)}static#e=new TextEncoder;static text(L,te=R.$Qs.text){const Ee=ei.#e.encode(String(L));return new ei(Ee,te)}static json(L,te="text/x-json"){const Ee=JSON.stringify(L,void 0,"	");return ei.text(Ee,te)}constructor(L,te){this.data=L,this.mime=te;const Ee=(0,R.$Us)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$xO=ei;class Ri{static isNotebookCellOutput(L){return L instanceof Ri?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,te=!1){const Ee=new Set,Ke=new Set;for(let Ye=0;Ye<L.length;Ye++){const lt=L[Ye],wt=(0,R.$Us)(lt.mime);if(!Ee.has(wt)||(0,g.$ZK)(wt)){Ee.add(wt);continue}Ke.add(Ye),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?L:L.filter((Ye,lt)=>!Ke.has(lt))}constructor(L,te,Ee){this.items=Ri.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,T.$Sg)(),this.metadata=te??Ee)}}e.$yO=Ri;var tn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var Wi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Wi||(e.NotebookCellStatusBarAlignment=Wi={}));var rn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class $n{constructor(L,te){this.text=L,this.alignment=te}}e.$zO=$n;var sn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(L,te=[]){this.uri=L,this.provides=(0,I.$3b)(te)}}e.$AO=pn;class wn{constructor(L){this.label=L}}e.$BO=wn;var an;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let qi=class{constructor(L,te){this.label=L,this.timestamp=te}};e.$CO=qi,e.$CO=qi=Je([y],qi);var cn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var ln;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class _{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.$DO=_;class oe{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$EO=oe;var Le;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Le||(e.TestResultState=Le={}));var rt;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(rt||(e.TestRunProfileKind=rt={}));let bt=class{constructor(L=void 0,te=void 0,Ee=void 0,Ke=!1,Ye=!0){this.include=L,this.exclude=te,this.profile=Ee,this.continuous=Ke,this.preserveFocus=Ye}};e.$FO=bt,e.$FO=bt=Je([y],bt);let At=k=class{static diff(L,te,Ee){const Ke=new k(L);return Ke.expectedOutput=te,Ke.actualOutput=Ee,Ke}constructor(L){this.message=L}};e.$GO=At,e.$GO=At=k=Je([y],At);let Di=class{constructor(L){this.id=L}};e.$HO=Di,e.$HO=Di=Je([y],Di);class hn{constructor(L,te){this.covered=L,this.total=te,bn(this)}}e.$IO=hn;function bn(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class vn{static fromDetails(L,te){const Ee=new hn(0,0),Ke=new hn(0,0),Ye=new hn(0,0);for(const wt of te)if("branches"in wt){Ee.total+=1,Ee.covered+=wt.executed?1:0;for(const Ht of wt.branches)Ke.total+=1,Ke.covered+=Ht.executed?1:0}else Ye.total+=1,Ye.covered+=wt.executed?1:0;const lt=new vn(L,Ee,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=te,lt}constructor(L,te,Ee,Ke){this.uri=L,this.statementCoverage=te,this.branchCoverage=Ee,this.declarationCoverage=Ke}}e.$KO=vn;class Fn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee=[]){this.executed=L,this.location=te,this.branches=Ee}}e.$LO=Fn;class Ln{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.executed=L,this.location=te,this.label=Ee}}e.$MO=Ln;class zn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,te,Ee){this.name=L,this.executed=te,this.location=Ee}}e.$NO=zn;var yn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(yn||(e.ExternalUriOpenerPriority=yn={}));var En;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(En||(e.WorkspaceTrustState=En={}));var Dn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Dn||(e.PortAutoForwardAction=Dn={}));class jn{constructor(L,te,Ee,Ke,Ye,lt){this.kind=L,this.name=te,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$OO=jn;class Un{constructor(L){this.uri=L}}e.$PO=Un;class Bn{constructor(L,te){this.original=L,this.modified=te}}e.$QO=Bn;class Vn{constructor(L,te,Ee,Ke){this.base=L,this.input1=te,this.input2=Ee,this.result=Ke}}e.$RO=Vn;class Wn{constructor(L,te){this.uri=L,this.viewType=te}}e.$SO=Wn;class qn{constructor(L){this.viewType=L}}e.$TO=qn;class Hn{constructor(L,te){this.uri=L,this.notebookType=te}}e.$UO=Hn;class Gn{constructor(L,te,Ee){this.original=L,this.modified=te,this.notebookType=Ee}}e.$VO=Gn;class Kn{constructor(){}}e.$WO=Kn;class Jn{constructor(L,te){this.uri=L,this.inputBoxUri=te}}e.$XO=Jn;class Qn{constructor(){}}e.$YO=Qn;class Zn{constructor(L){this.textDiffs=L}}e.$ZO=Zn;var kn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Sn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Sn||(e.ChatCopyKind=Sn={}));var In;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(In||(e.ChatVariableLevel=In={}));class Xn{constructor(L,te){this.label=L,this.values=te}}e.$1O=Xn;var Pn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Pn||(e.InteractiveEditorResponseFeedbackKind=Pn={}));var Cn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Cn||(e.ChatResultFeedbackKind=Cn={}));class Yn{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new He(L):L}}e.$2O=Yn;class xn{constructor(L,te){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new He(L):L,this.vulnerabilities=te}}e.$3O=xn;class _n{constructor(L,te){this.participant=L,this.command=te}}e.$4O=_n;class er{constructor(L,te){this.value=L,this.baseUri=te}}e.$5O=er;class tr{constructor(L,te){this.value=L,this.title=te}}e.$6O=tr;class ir{constructor(L){this.value=L}}e.$7O=ir;class nr{constructor(L){this.value=L}}e.$8O=nr;class rr{constructor(L,te){this.value=L,this.iconPath=te}}e.$9O=rr;class sr{constructor(L,te){this.uri=L,this.edits=Array.isArray(te)?te:[te]}}e.$0O=sr;class or{constructor(L,te,Ee,Ke){this.prompt=L,this.command=te,this.variables=Ee,this.participant=Ke}}e.$$O=or;class ar{constructor(L,te,Ee,Ke){this.response=L,this.result=te,this.participant=Ee,this.command=Ke}}e.$_O=ar;var An;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(An||(e.ChatLocation=An={}));class cr{constructor(L){this.content=L}}e.$aP=cr;class ur{constructor(L,te){this.content=L,this.name=te}}e.$bP=ur;class lr{constructor(L,te){this.content=L,this.name=te}}e.$cP=lr;class Ni extends Error{static NotFound(L){return new Ni(L,Ni.NotFound.name)}static NoPermissions(L){return new Ni(L,Ni.NoPermissions.name)}constructor(L,te,Ee){super(L,{cause:Ee}),this.name="LanguageModelError",this.code=te??""}}e.$dP=Ni;var Rn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Rn||(e.RelatedInformationType=Rn={}));var Nn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Nn||(e.SpeechToTextStatus=Nn={}));var Mn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Mn||(e.KeywordRecognitionStatus=Mn={}));class hr{constructor(L,te){this.text=L,this.range=te}}e.$eP=hr;var On;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(On||(e.InlineEditTriggerKind=On={}))}),define(Ie[257],Pe([1,0,4,7]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;class A{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$3M.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,w,p){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(R);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(w,p)??[]}getRelatedInformation(R,w,p){return this.c.$getAiRelatedInformation(w,p)}registerRelatedInformationProvider(R,w,p){const E=this.b;return this.b++,this.a.set(E,p),this.c.$registerAiRelatedInformationProvider(E,w),new M.$5M(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$_kc=A}),define(Ie[86],Pe([1,0,5,4,7,20,108,3,17]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=e.$klc=void 0,e.$klc=(0,w.$wi)("IExtHostAuthentication");let E=class{constructor(d){this.b=new Map,this.c=new I.$ee,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=d.getProxy(M.$3M.MainThreadAuthentication)}async getSession(d,v,g,r={}){const o=O.$Rm.toKey(d.identifier),s=[...g].sort().join(" ");return await this.d.getOrCreate(`${o} ${v} ${s}`,async()=>{await this.a.$ensureProvider(v);const i=d.displayName||d.name;return this.a.$getSession(v,g,o,i,r)})}async getSessions(d,v,g){const r=O.$Rm.toKey(d.identifier),o=[...g].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(v);const s=d.displayName||d.name;return this.a.$getSessions(v,g,r,s)})}async removeSession(d,v){const g=this.b.get(d);return g?g.provider.removeSession(v):this.a.$removeSession(d,v)}registerAuthenticationProvider(d,v,g,r){if(this.b.get(d))throw new Error(`An authentication provider with id '${d}' is already registered.`);this.b.set(d,{label:v,provider:g,options:r??{supportsMultipleAccounts:!1}});const o=g.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(d,s));return this.a.$registerAuthenticationProvider(d,v,r?.supportsMultipleAccounts??!1),new A.$5M(()=>{o.dispose(),this.b.delete(d),this.a.$unregisterAuthenticationProvider(d)})}$createSession(d,v,g){const r=this.b.get(d);if(r)return Promise.resolve(r.provider.createSession(v,g));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$removeSession(d,v){const g=this.b.get(d);if(g)return Promise.resolve(g.provider.removeSession(v));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$getSessions(d,v){const g=this.b.get(d);if(g)return Promise.resolve(g.provider.getSessions(v));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$onDidChangeAuthenticationSessions(d,v){return d.startsWith(R.$5L)||this.c.fire({provider:{id:d,label:v}}),Promise.resolve()}};e.$llc=E,e.$llc=E=Je([We(0,p.$qP)],E);class T{constructor(){this.a=new Map}getOrCreate(d,v){const g=this.a.get(d);if(g)return g;const r=v().finally(()=>this.a.delete(d));return this.a.set(d,r),r}}}),define(Ie[112],Pe([1,0,2,4,7,3,17,12,18,13,19,26]),function(le,e,I,M,A,O,R,w,p,E,T,D){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0;let v=class{static{d=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(M.$3M.MainThreadDecorations)}registerFileDecorationProvider(r,o){const s=d.c++;this.f.set(s,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const i=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const c=(0,p.$3b)(n);if(c.length<=d.d){this.g.$onDidChange(s,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const l=c.map(a=>({uri:a,rank:(0,E.$bf)(a.path,"/")})),t=(0,p.$zb)(l,(a,$)=>a.rank-$.rank||(0,E.$rf)(a.uri.path,$.uri.path)),f=[];e:for(const a of t){let $;for(const u of a){const S=(0,T.$nc)(u.uri.path);if($!==S&&($=S,f.push(u.uri)>=d.d))break e}}this.g.$onDidChange(s,f)});return new A.$5M(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,o,s){if(!this.f.has(r))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:c}=this.f.get(r);return await Promise.all(o.map(async l=>{try{const{uri:t,id:f}=l,a=await Promise.resolve(n.provideFileDecoration(I.URI.revive(t),s));if(!a)return;try{A.$sO.validate(a),a.badge&&typeof a.badge!="string"&&(0,D.$IG)(c,"codiconDecoration"),i[f]=[a.propagate,a.tooltip,a.badge,a.color]}catch($){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${$}`)}}catch(t){this.h.error(t)}})),i}};e.$kmc=v,e.$kmc=v=d=Je([We(0,R.$qP),We(1,w.$3j)],v),e.$lmc=(0,O.$wi)("IExtHostDecorations")}),define(Ie[258],Pe([1,0,14,2,7,4,16,24,13]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=void 0;class E{static{this.a=0}constructor(D,d,v){this.d=d,this.e=v,this.b=new Map,this.c=D.getProxy(O.$3M.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,d){if(Object.keys(R.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const v=E.a++;this.b.set(v,d),this.c.$registerTextContentProvider(v,D);let g;if(typeof d.onDidChange=="function"){let r;g=d.onDidChange(async o=>{if(o.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const s=this.$provideTextDocumentContent(v,o).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(o);if(!n)return;const c=(0,p.$lf)(i);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(o,i)}).catch(I.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new A.$5M(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(D,d){const v=this.b.get(D);return v?Promise.resolve(v.provideTextDocumentContent(M.URI.revive(d),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.$nmc=E}),define(Ie[113],Pe([1,0,57,16,13,313,159,7,18]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.$tP=void 0,e.$sP=T;const E=new Map;function T(g,r){r?E.set(g,r):E.delete(g)}function D(g){return E.get(g)}class d extends O.$Zv{constructor(r,o,s,i,n,c,l){super(o,s,i,n),this.c=r,this.m=c,this.q=l,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,p.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===M.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,s){return r.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,I.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,I.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,i=o.start.line,n=o.end.line,c=[];c.push(this.f[i].substring(o.start.character));for(let l=i+1;l<n;l++)c.push(this.f[l]);return c.push(this.f[n].substring(0,o.end.character)),c.join(s)}t(r){let o;if(r instanceof w.$6M?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),s=this.f[o.index].length;return new w.$6M(o.index,Math.min(o.remainder,s))}w(r){if(!(r instanceof w.$7M))throw new Error("Invalid argument");const o=this.x(r.start),s=this.x(r.end);return o===r.start&&s===r.end?r:new w.$7M(o.line,o.character,s.line,s.character)}x(r){if(!(r instanceof w.$6M))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:s}=r,i=!1;if(o<0)o=0,s=0,i=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,i=!0;else{const n=this.f[o].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new w.$6M(o,s):r}y(r,o){const s=this.x(r);if(!o)o=D(this.m);else if((0,A.$kf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const i=(0,R.$9s)(s.character+1,(0,R.$7s)(o),this.f[s.line],0);if(i)return new w.$7M(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$tP=d;class v{constructor(r,o,s){this.a=r,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new w.$7M(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new w.$7M(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$uP=v}),define(Ie[259],Pe([1,0,4,7]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=void 0;class A{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$3M.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,w,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(R);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector(w,p);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(R,w,p){const E=this.b;return this.b++,this.a.set(E,p),this.c.$registerAiEmbeddingVectorProvider(w,E),new M.$5M(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$pmc=A}),define(Ie[65],Pe([1,0,4,38,7,21,3,17,46,6,11,23,16]),function(le,e,I,M,A,O,R,w,p,E,T,D,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=void 0;let g=v=class{constructor(o,s){this.b=new Map,this.c=new T.$Fh,this.a=o.getProxy(I.$3M.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let c;const l=i.b.get(n.scheme);return l?(await i.a.$ensureActivation(n.scheme),c=await l.impl.stat(n)):c=await i.a.$stat(n),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===M.FilePermission.Readonly?1:void 0}}catch(c){v.e(c)}},async readDirectory(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(c){return v.e(c)}},async createDirectory(n){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,n)):await i.a.$mkdir(n)}catch(c){return v.e(c)}},async readFile(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(c){return v.e(c)}},async writeFile(n,c){try{const l=i.b.get(n.scheme);return l&&!l.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(l.impl,l.extUri,l.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(l.impl.writeFile(n,c,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,O.$Ge.wrap(c))}catch(l){return v.e(l)}},async delete(n,c){try{const l=i.b.get(n.scheme);return l&&!l.isReadonly&&!c?.useTrash?(await i.a.$ensureActivation(n.scheme),await l.impl.delete(n,{recursive:!1,...c})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(l){return v.e(l)}},async rename(n,c,l){try{return await i.a.$rename(n,c,{overwrite:!1,...l})}catch(t){return v.e(t)}},async copy(n,c,l){try{return await i.a.$copy(n,c,{overwrite:!1,...l})}catch(t){return v.e(t)}},isWritableFileSystem(n){const c=s.getCapabilities(n);if(typeof c=="number")return!(c&2048)}})}async d(o,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await o.stat(i)).type&M.FileType.Directory))throw A.$jO.FileExists(`Unable to create folder '${i.scheme===d.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(M.$gl(c)!==M.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(s.basename(i)),i=s.dirname(i)}for(let c=n.length-1;c>=0;c--){i=s.joinPath(i,n[c]);try{await o.createDirectory(i)}catch(l){if(M.$gl(l)!==M.FileSystemProviderErrorCode.FileExists)throw l}}}static e(o){if(o instanceof A.$jO)throw o;if(o instanceof M.$cl)switch(o.code){case M.FileSystemProviderErrorCode.FileExists:throw A.$jO.FileExists(o.message);case M.FileSystemProviderErrorCode.FileNotFound:throw A.$jO.FileNotFound(o.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw A.$jO.FileNotADirectory(o.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw A.$jO.FileIsADirectory(o.message);case M.FileSystemProviderErrorCode.NoPermissions:throw A.$jO.NoPermissions(o.message);case M.FileSystemProviderErrorCode.Unavailable:throw A.$jO.Unavailable(o.message);default:throw new A.$jO(o.message,o.name)}if(!(o instanceof Error))throw new A.$jO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw A.$jO.Unavailable(o.message);switch(o.name){case M.FileSystemProviderErrorCode.FileExists:throw A.$jO.FileExists(o.message);case M.FileSystemProviderErrorCode.FileNotFound:throw A.$jO.FileNotFound(o.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw A.$jO.FileNotADirectory(o.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw A.$jO.FileIsADirectory(o.message);case M.FileSystemProviderErrorCode.NoPermissions:throw A.$jO.NoPermissions(o.message);case M.FileSystemProviderErrorCode.Unavailable:throw A.$jO.Unavailable(o.message);default:throw new A.$jO(o.message,o.name)}}addFileSystemProvider(o,s,i){return this.b.set(o,{impl:s,extUri:i?.isCaseSensitive?D.$Zg:D.$2g,isReadonly:!!i?.isReadonly}),(0,E.$Tc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??D.$Zg}};e.$Alc=g,e.$Alc=g=v=Je([We(0,w.$qP),We(1,p.$elc)],g),e.$Blc=(0,R.$wi)("IExtHostConsumerFileSystem")}),define(Ie[87],Pe([1,0,3,27,12,65,2]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0,e.$Clc=(0,I.$wi)("IExtensionStoragePaths");let w=class{constructor(E,T,D){this.d=T,this.f=D,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(d=>this.c=d)}async g(E){return R.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,T=await this.g(E);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(R.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(E){if(this.c)return R.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return R.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Dlc=w,e.$Dlc=w=Je([We(0,M.$GP),We(1,A.$3j),We(2,O.$Blc)],w)}),define(Ie[260],Pe([1,0,7,17,5]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;let O=class{constructor(w){this.a=new I.$tO(I.ColorThemeKind.Dark),this.b=new A.$ee}get activeColorTheme(){return this.a}$onColorThemeChange(w){let p;switch(w){case"light":p=I.ColorThemeKind.Light;break;case"hcDark":p=I.ColorThemeKind.HighContrast;break;case"hcLight":p=I.ColorThemeKind.HighContrastLight;break;default:p=I.ColorThemeKind.Dark}this.a=new I.$tO(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$$mc=O,e.$$mc=O=Je([We(0,M.$qP)],O)}),define(Ie[88],Pe([1,0,24,5,6,182,3,12,211,4,27,17,7]),function(le,e,I,M,A,O,R,w,p,E,T,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uDb=e.$tDb=e.TunnelDtoConverter=void 0;class v extends p.$mw{}var g;(function(o){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:n.protocol}}o.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==p.TunnelPrivacyId.ConstantPrivate&&n.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}o.fromServiceTunnel=i})(g||(e.TunnelDtoConverter=g={})),e.$tDb=(0,R.$wi)("IExtHostTunnelService");let r=class extends A.$Vc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$ee,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(E.$3M.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const c=new v(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new d.$5M(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,c,l){const t=[];for(const a of s){const $=this.r.get(a);if(!$)return[];t.push(...await Promise.all(i.map(async u=>{let S;try{S=await $.provider.providePortAttributes({port:u,pid:n,commandLine:c},l)}catch{S=await $.provider.providePortAttributes(u,n,c,l)}return{providedAttributes:S,port:u}})))}const f=t.filter(a=>!!a.providedAttributes);return f.length>0?f.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,l)=>await s.provideTunnel(c,l,I.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,A.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const l=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,A.$Tc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const c=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const l=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:c,disposeListener:l}),g.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(c=>this.f(c.host,c.port,c.detail??""))),n=s.filter((c,l)=>i[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(c=>c.port).join(", ")} to ${n.map(c=>c.port).join(", ")}`),n}};e.$uDb=r,e.$uDb=r=Je([We(0,D.$qP),We(1,T.$GP),We(2,w.$3j)],r)}),define(Ie[8],Pe([1,0,18,21,138,261,55,28,127,49,70,25,133,23,15,2,30,89,101,107,106,224,85,52,62,235,7,36]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n,c,l,t,f,a,$,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$nP=K,e.$oP=ce,e.$pP=ye;var h;(function(pe){function Re(J){const{selectionStartLineNumber:ke,selectionStartColumn:Ve,positionLineNumber:Ze,positionColumn:Ge}=J,ut=new u.$6M(ke-1,Ve-1),yt=new u.$6M(Ze-1,Ge-1);return new u.$8M(ut,yt)}pe.to=Re;function se(J){const{anchor:ke,active:Ve}=J;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}pe.from=se})(h||(e.Selection=h={}));var b;(function(pe){function Re(J){if(!J)return;const{start:ke,end:Ve}=J;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}pe.from=Re;function se(J){if(!J)return;const{startLineNumber:ke,startColumn:Ve,endLineNumber:Ze,endColumn:Ge}=J;return new u.$7M(ke-1,Ve-1,Ze-1,Ge-1)}pe.to=se})(b||(e.Range=b={}));var m;(function(pe){function Re(J){return{uri:J.uri,range:b.from(J.range)}}pe.from=Re;function se(J){return new u.$eN(r.URI.revive(J.uri),b.to(J.range))}pe.to=se})(m||(e.Location=m={}));var k;(function(pe){function Re(se){switch(se){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}pe.to=Re})(k||(e.TokenType=k={}));var y;(function(pe){function Re(J){return new u.$6M(J.lineNumber-1,J.column-1)}pe.to=Re;function se(J){return{lineNumber:J.line+1,column:J.character+1}}pe.from=se})(y||(e.Position=y={}));var C;(function(pe){function Re(ke,Ve,Ze){return(0,I.$Hb)((0,I.$3b)(ke).map(Ge=>se(Ge,Ve,Ze)))}pe.from=Re;function se(ke,Ve,Ze){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ze?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:J(ke.scheme,Ve),pattern:me.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ze?.isBuiltin}}function J(ke,Ve){return Ve&&typeof ke=="string"?Ve.transformOutgoingScheme(ke):ke}})(C||(e.DocumentSelector=C={}));var P;(function(pe){function Re(J){switch(J){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}pe.from=Re;function se(J){switch(J){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}pe.to=se})(P||(e.DiagnosticTag=P={}));var W;(function(pe){function Re(J){let ke;return J.code&&((0,g.$9f)(J.code)||(0,g.$ag)(J.code)?ke=String(J.code):ke={value:String(J.code.value),target:J.code.target}),{...b.from(J.range),message:J.message,source:J.source,code:ke,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(V.from),tags:Array.isArray(J.tags)?(0,I.$Hb)(J.tags.map(P.from)):void 0}}pe.from=Re;function se(J){const ke=new u.$gN(b.to(J),J.message,q.to(J.severity));return ke.source=J.source,ke.code=(0,g.$9f)(J.code)?J.code:J.code?.value,ke.relatedInformation=J.relatedInformation&&J.relatedInformation.map(V.to),ke.tags=J.tags&&(0,I.$Hb)(J.tags.map(P.to)),ke}pe.to=se})(W||(e.Diagnostic=W={}));var V;(function(pe){function Re(J){return{...b.from(J.location.range),message:J.message,resource:J.location.uri}}pe.from=Re;function se(J){return new u.$fN(new u.$eN(J.resource,b.to(J)),J.message)}pe.to=se})(V||(e.DiagnosticRelatedInformation=V={}));var q;(function(pe){function Re(J){switch(J){case u.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}pe.from=Re;function se(J){switch(J){case i.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}pe.to=se})(q||(e.DiagnosticSeverity=q={}));var N;(function(pe){function Re(J){return typeof J=="number"&&J>=u.ViewColumn.One?J-1:J===u.ViewColumn.Beside?$.$XD:$.$WD}pe.from=Re;function se(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=se})(N||(e.ViewColumn=N={}));function U(pe){return typeof pe.range<"u"}function K(pe){return pe.length===0?!0:!!U(pe[0])}var ie;(function(pe){function Re(Ge){return Ge.map(pe.from)}pe.fromMany=Re;function se(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function J(Ge){let ut;if(se(Ge)){const{language:Tt,value:jt}=Ge;ut={value:"```"+Tt+`
`+jt+"\n```\n"}}else u.$uN.isMarkdownString(Ge)?ut={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ut={value:Ge}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const zt=Tt=>{try{let jt=r.URI.parse(Tt,!0);jt=jt.with({query:ke(jt.query,yt)}),yt[Tt]=jt}catch{}return""},ct=new p.marked.Renderer;return ct.link=zt,ct.image=Tt=>typeof Tt=="string"?zt(R.$2k(Tt).href):"",(0,p.marked)(ut.value,{renderer:ct}),ut}pe.from=J;function ke(Ge,ut){if(!Ge)return Ge;let yt;try{yt=(0,E.$5h)(Ge)}catch{}if(!yt)return Ge;let zt=!1;return yt=(0,D.$5n)(yt,ct=>{if(r.URI.isUri(ct)){const Tt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Tt]=ct,zt=!0,Tt}else return}),zt?JSON.stringify(yt):Ge}function Ve(Ge){const ut=new u.$uN(Ge.value,Ge.supportThemeIcons);return ut.isTrusted=Ge.isTrusted,ut.supportHtml=Ge.supportHtml,ut.baseUri=Ge.baseUri?r.URI.from(Ge.baseUri):void 0,ut}pe.to=Ve;function Ze(Ge){if(Ge)return typeof Ge=="string"?Ge:pe.from(Ge)}pe.fromStrict=Ze})(ie||(e.MarkdownString=ie={}));function ce(pe){return K(pe)?pe.map(Re=>({range:b.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?ie.fromMany(Re.hoverMessage):Re.hoverMessage?ie.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):pe.map(Re=>({range:b.from(Re)}))}function ye(pe){return typeof pe>"u"?pe:typeof pe=="string"?r.URI.file(pe):pe}var Se;(function(pe){function Re(se){return typeof se>"u"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?ye(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}pe.from=Re})(Se||(e.ThemableDecorationAttachmentRenderOptions=Se={}));var fe;(function(pe){function Re(se){return typeof se>"u"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?ye(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?Se.from(se.before):void 0,after:se.after?Se.from(se.after):void 0}}pe.from=Re})(fe||(e.ThemableDecorationRenderOptions=fe={}));var $e;(function(pe){function Re(se){if(typeof se>"u")return se;switch(se){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=Re})($e||(e.DecorationRangeBehavior=$e={}));var Te;(function(pe){function Re(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?$e.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?fe.from(se.light):void 0,dark:se.dark?fe.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?ye(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?Se.from(se.before):void 0,after:se.after?Se.from(se.after):void 0}}pe.from=Re})(Te||(e.DecorationRenderOptions=Te={}));var ae;(function(pe){function Re(J){return{text:J.newText,eol:J.newEol&&gt.from(J.newEol),range:b.from(J.range)}}pe.from=Re;function se(J){const ke=new u.$_M(b.to(J.range),J.text);return ke.newEol=typeof J.eol>"u"?void 0:gt.to(J.eol),ke}pe.to=se})(ae||(e.TextEdit=ae={}));var Ne;(function(pe){function Re(J,ke){const Ve={edits:[]};if(J instanceof u.$cN){const Ze=new w.$Cc;for(const Ge of J._allEntries())Ge._type===1&&r.URI.isUri(Ge.to)&&Ge.from===void 0&&Ze.add(Ge.to);for(const Ge of J._allEntries())if(Ge._type===1){let ut;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ut={type:"base64",value:(0,M.$1e)(M.$Ge.wrap(Ge.options.contents))}:ut={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ut},metadata:Ge.metadata})}else Ge._type===2?Ve.edits.push({resource:Ge.uri,textEdit:ae.from(Ge.edit),versionId:Ze.has(Ge.uri)?void 0:ke?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ve.edits.push({resource:Ge.uri,textEdit:{range:b.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ge.uri)?void 0:ke?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(ti.from)}})}return Ve}pe.from=Re;function se(J){const ke=new u.$cN,Ve=new w.$Bc;for(const Ze of J.edits)if(Ze.textEdit){const Ge=Ze,ut=r.URI.revive(Ge.resource),yt=b.to(Ge.textEdit.range),zt=Ge.textEdit.text,ct=Ge.textEdit.insertAsSnippet;let Tt;ct?Tt=u.$bN.replace(yt,new u.$dN(zt)):Tt=u.$_M.replace(yt,zt);const jt=Ve.get(ut);jt?jt.push(Tt):Ve.set(ut,[Tt])}else ke.renameFile(r.URI.revive(Ze.oldResource),r.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ge]of Ve)ke.set(Ze,Ge);return ke}pe.to=se})(Ne||(e.WorkspaceEdit=Ne={}));var ne;(function(pe){const Re=Object.create(null);Re[u.SymbolKind.File]=0,Re[u.SymbolKind.Module]=1,Re[u.SymbolKind.Namespace]=2,Re[u.SymbolKind.Package]=3,Re[u.SymbolKind.Class]=4,Re[u.SymbolKind.Method]=5,Re[u.SymbolKind.Property]=6,Re[u.SymbolKind.Field]=7,Re[u.SymbolKind.Constructor]=8,Re[u.SymbolKind.Enum]=9,Re[u.SymbolKind.Interface]=10,Re[u.SymbolKind.Function]=11,Re[u.SymbolKind.Variable]=12,Re[u.SymbolKind.Constant]=13,Re[u.SymbolKind.String]=14,Re[u.SymbolKind.Number]=15,Re[u.SymbolKind.Boolean]=16,Re[u.SymbolKind.Array]=17,Re[u.SymbolKind.Object]=18,Re[u.SymbolKind.Key]=19,Re[u.SymbolKind.Null]=20,Re[u.SymbolKind.EnumMember]=21,Re[u.SymbolKind.Struct]=22,Re[u.SymbolKind.Event]=23,Re[u.SymbolKind.Operator]=24,Re[u.SymbolKind.TypeParameter]=25;function se(ke){return typeof Re[ke]=="number"?Re[ke]:6}pe.from=se;function J(ke){for(const Ve in Re)if(Re[Ve]===ke)return Number(Ve);return u.SymbolKind.Property}pe.to=J})(ne||(e.SymbolKind=ne={}));var z;(function(pe){function Re(J){switch(J){case u.SymbolTag.Deprecated:return 1}}pe.from=Re;function se(J){switch(J){case 1:return u.SymbolTag.Deprecated}}pe.to=se})(z||(e.SymbolTag=z={}));var x;(function(pe){function Re(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(z.from),containerName:J.containerName,location:ge.from(J.location)}}pe.from=Re;function se(J){const ke=new u.$lN(J.name,ne.to(J.kind),J.containerName,ge.to(J.location));return ke.tags=J.tags&&J.tags.map(z.to),ke}pe.to=se})(x||(e.WorkspaceSymbol=x={}));var ve;(function(pe){function Re(J){const ke={name:J.name||"!!MISSING: name!!",detail:J.detail,range:b.from(J.range),selectionRange:b.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(z.from)??[]};return J.children&&(ke.children=J.children.map(Re)),ke}pe.from=Re;function se(J){const ke=new u.$mN(J.name,J.detail,ne.to(J.kind),b.to(J.range),b.to(J.selectionRange));return(0,I.$Lb)(J.tags)&&(ke.tags=J.tags.map(z.to)),J.children&&(ke.children=J.children.map(se)),ke}pe.to=se})(ve||(e.DocumentSymbol=ve={}));var Fe;(function(pe){function Re(J){const ke=new u.$qN(ne.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),b.to(J.range),b.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}pe.to=Re;function se(J,ke,Ve){if(ke=ke??J._sessionId,Ve=Ve??J._itemId,ke===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ve,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:b.from(J.range),selectionRange:b.from(J.selectionRange),tags:J.tags?.map(z.from)}}pe.from=se})(Fe||(e.CallHierarchyItem=Fe={}));var De;(function(pe){function Re(se){return new u.$rN(Fe.to(se.from),se.fromRanges.map(J=>b.to(J)))}pe.to=Re})(De||(e.CallHierarchyIncomingCall=De={}));var we;(function(pe){function Re(se){return new u.$sN(Fe.to(se.to),se.fromRanges.map(J=>b.to(J)))}pe.to=Re})(we||(e.CallHierarchyOutgoingCall=we={}));var ge;(function(pe){function Re(J){return{range:J.range&&b.from(J.range),uri:J.uri}}pe.from=Re;function se(J){return new u.$eN(r.URI.revive(J.uri),b.to(J.range))}pe.to=se})(ge||(e.location=ge={}));var Q;(function(pe){function Re(J){const ke=J,Ve=J;return{originSelectionRange:ke.originSelectionRange?b.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Ve.uri,range:b.from(ke.targetRange?ke.targetRange:Ve.range),targetSelectionRange:ke.targetSelectionRange?b.from(ke.targetSelectionRange):void 0}}pe.from=Re;function se(J){return{targetUri:r.URI.revive(J.uri),targetRange:b.to(J.range),targetSelectionRange:J.targetSelectionRange?b.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?b.to(J.originSelectionRange):void 0}}pe.to=se})(Q||(e.DefinitionLink=Q={}));var Y;(function(pe){function Re(J){return{range:b.from(J.range),contents:ie.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}pe.from=Re;function se(J){const ke=J.contents.map(ie.to),Ve=b.to(J.range),Ze=J.canIncreaseVerbosity,Ge=J.canDecreaseVerbosity;return new u.$iN(ke,Ve,Ze,Ge)}pe.to=se})(Y||(e.Hover=Y={}));var he;(function(pe){function Re(J){return{range:b.from(J.range),expression:J.expression}}pe.from=Re;function se(J){return new u.$dO(b.to(J.range),J.expression)}pe.to=se})(he||(e.EvaluatableExpression=he={}));var ue;(function(pe){function Re(J){if(J instanceof u.$eO)return{type:"text",range:b.from(J.range),text:J.text};if(J instanceof u.$fO)return{type:"variable",range:b.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof u.$gO)return{type:"expression",range:b.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=Re;function se(J){switch(J.type){case"text":return{range:b.to(J.range),text:J.text};case"variable":return{range:b.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:b.to(J.range),expression:J.expression}}}pe.to=se})(ue||(e.InlineValue=ue={}));var Oe;(function(pe){function Re(J){return{frameId:J.frameId,stoppedLocation:b.from(J.stoppedLocation)}}pe.from=Re;function se(J){return new u.$hO(J.frameId,b.to(J.stoppedLocation))}pe.to=se})(Oe||(e.InlineValueContext=Oe={}));var de;(function(pe){function Re(J){return{range:b.from(J.range),kind:J.kind}}pe.from=Re;function se(J){return new u.$jN(b.to(J.range),J.kind)}pe.to=se})(de||(e.DocumentHighlight=de={}));var Ce;(function(pe){function Re(J){return{uri:J.uri,highlights:J.highlights.map(de.from)}}pe.from=Re;function se(J){return new u.$kN(r.URI.revive(J.uri),J.highlights.map(de.to))}pe.to=se})(Ce||(e.MultiDocumentHighlight=Ce={}));var Ae;(function(pe){function Re(se){switch(se){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}pe.to=Re})(Ae||(e.CompletionTriggerKind=Ae={}));var Ue;(function(pe){function Re(se){return{triggerKind:Ae.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}pe.to=Re})(Ue||(e.CompletionContext=Ue={}));var j;(function(pe){function Re(J){switch(J){case u.CompletionItemTag.Deprecated:return 1}}pe.from=Re;function se(J){switch(J){case 1:return u.CompletionItemTag.Deprecated}}pe.to=se})(j||(e.CompletionItemTag=j={}));var F;(function(pe){const Re=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function se(Ve){return Re.get(Ve)??9}pe.from=se;const J=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function ke(Ve){return J.get(Ve)??u.CompletionItemKind.Property}pe.to=ke})(F||(e.CompletionItemKind=F={}));var H;(function(pe){function Re(se,J){const ke=new u.$AN(se.label);return ke.insertText=se.insertText,ke.kind=F.to(se.kind),ke.tags=se.tags?.map(j.to),ke.detail=se.detail,ke.documentation=R.$Vk(se.documentation)?ie.to(se.documentation):se.documentation,ke.sortText=se.sortText,ke.filterText=se.filterText,ke.preselect=se.preselect,ke.commitCharacters=se.commitCharacters,o.$ut.isIRange(se.range)?ke.range=b.to(se.range):typeof se.range=="object"&&(ke.range={inserting:b.to(se.range.insert),replacing:b.to(se.range.replace)}),ke.keepWhitespace=typeof se.insertTextRules>"u"?!1:!!(se.insertTextRules&1),typeof se.insertTextRules<"u"&&se.insertTextRules&4?ke.insertText=new u.$dN(se.insertText):(ke.insertText=se.insertText,ke.textEdit=ke.range instanceof u.$7M?new u.$_M(ke.range,ke.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(ke.additionalTextEdits=se.additionalTextEdits.map(Ve=>ae.to(Ve))),ke.command=J&&se.command?J.fromInternal(se.command):void 0,ke}pe.to=Re})(H||(e.CompletionItem=H={}));var G;(function(pe){function Re(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}pe.from=Re;function se(J){return{label:J.label,documentation:R.$Vk(J.documentation)?ie.to(J.documentation):J.documentation}}pe.to=se})(G||(e.ParameterInformation=G={}));var ee;(function(pe){function Re(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(G.from):[],activeParameter:J.activeParameter}}pe.from=Re;function se(J){return{label:J.label,documentation:R.$Vk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(G.to):[],activeParameter:J.activeParameter}}pe.to=se})(ee||(e.SignatureInformation=ee={}));var re;(function(pe){function Re(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.from):[]}}pe.from=Re;function se(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.to):[]}}pe.to=se})(re||(e.SignatureHelp=re={}));var Me;(function(pe){function Re(se,J){const ke=new u.$zN(y.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,se)),J.kind&&He.to(J.kind));return ke.textEdits=J.textEdits&&J.textEdits.map(ae.to),ke.tooltip=R.$Vk(J.tooltip)?ie.to(J.tooltip):J.tooltip,ke.paddingLeft=J.paddingLeft,ke.paddingRight=J.paddingRight,ke}pe.to=Re})(Me||(e.InlayHint=Me={}));var Be;(function(pe){function Re(se,J){const ke=new u.$yN(J.label);return ke.tooltip=R.$Vk(J.tooltip)?ie.to(J.tooltip):J.tooltip,s.Command.is(J.command)&&(ke.command=se.fromInternal(J.command)),J.location&&(ke.location=ge.to(J.location)),ke}pe.to=Re})(Be||(e.InlayHintLabelPart=Be={}));var He;(function(pe){function Re(J){return J}pe.from=Re;function se(J){return J}pe.to=se})(He||(e.InlayHintKind=He={}));var _e;(function(pe){function Re(J){return{range:b.from(J.range),url:J.target,tooltip:J.tooltip}}pe.from=Re;function se(J){let ke;if(J.url)try{ke=typeof J.url=="string"?r.URI.parse(J.url,!0):r.URI.revive(J.url)}catch{}return new u.$FN(b.to(J.range),ke)}pe.to=se})(_e||(e.DocumentLink=_e={}));var xe;(function(pe){function Re(J){const ke=new u.$IN(J.label);return J.textEdit&&(ke.textEdit=ae.to(J.textEdit)),J.additionalTextEdits&&(ke.additionalTextEdits=J.additionalTextEdits.map(Ve=>ae.to(Ve))),ke}pe.to=Re;function se(J){return{label:J.label,textEdit:J.textEdit?ae.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ke=>ae.from(ke)):void 0}}pe.from=se})(xe||(e.ColorPresentation=xe={}));var et;(function(pe){function Re(J){return new u.$GN(J[0],J[1],J[2],J[3])}pe.to=Re;function se(J){return[J.red,J.green,J.blue,J.alpha]}pe.from=se})(et||(e.Color=et={}));var tt;(function(pe){function Re(J){return{range:b.from(J.range)}}pe.from=Re;function se(J){return new u.$pN(b.to(J.range))}pe.to=se})(tt||(e.SelectionRange=tt={}));var it;(function(pe){function Re(se){switch(se){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}pe.to=Re})(it||(e.TextDocumentSaveReason=it={}));var at;(function(pe){function Re(J){switch(J){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.Interval:return 3;case u.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=Re;function se(J){switch(J){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 3:return u.TextEditorLineNumbersStyle.Interval;case 1:default:return u.TextEditorLineNumbersStyle.On}}pe.to=se})(at||(e.TextEditorLineNumbersStyle=at={}));var gt;(function(pe){function Re(J){if(J===u.EndOfLine.CRLF)return 1;if(J===u.EndOfLine.LF)return 0}pe.from=Re;function se(J){if(J===1)return u.EndOfLine.CRLF;if(J===0)return u.EndOfLine.LF}pe.to=se})(gt||(e.EndOfLine=gt={}));var je;(function(pe){function Re(se){if(typeof se=="object")return se.viewId;switch(se){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=Re})(je||(e.ProgressLocation=je={}));var st;(function(pe){function Re(J){const ke={start:J.start+1,end:J.end+1};return J.kind&&(ke.kind=X.from(J.kind)),ke}pe.from=Re;function se(J){const ke={start:J.start-1,end:J.end-1};return J.kind&&(ke.kind=X.to(J.kind)),ke}pe.to=se})(st||(e.FoldingRange=st={}));var X;(function(pe){function Re(J){if(J)switch(J){case u.FoldingRangeKind.Comment:return s.$du.Comment;case u.FoldingRangeKind.Imports:return s.$du.Imports;case u.FoldingRangeKind.Region:return s.$du.Region}}pe.from=Re;function se(J){if(J)switch(J.value){case s.$du.Comment.value:return u.FoldingRangeKind.Comment;case s.$du.Imports.value:return u.FoldingRangeKind.Imports;case s.$du.Region.value:return u.FoldingRangeKind.Region}}pe.to=se})(X||(e.FoldingRangeKind=X={}));var Z;(function(pe){function Re(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?b.from(se.selection):void 0,override:typeof se.override=="boolean"?c.$nF.id:void 0}}pe.from=Re})(Z||(e.TextEditorOpenOptions=Z={}));var me;(function(pe){function Re(Ve){return Ve instanceof u.$4N?Ve.toJSON():typeof Ve=="string"?Ve:se(Ve)||J(Ve)?new u.$4N(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}pe.from=Re;function se(Ve){const Ze=Ve;return Ze?r.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(Ve){const Ze=Ve;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ke(Ve){return typeof Ve=="string"?Ve:new u.$4N(r.URI.revive(Ve.baseUri),Ve.pattern)}pe.to=ke})(me||(e.GlobPattern=me={}));var qe;(function(pe){function Re(se){if(se){if(Array.isArray(se))return se.map(Re);if(typeof se=="string")return se;{const J=se;return{language:J.language,scheme:J.scheme,pattern:me.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}pe.from=Re})(qe||(e.LanguageSelector=qe={}));var be;(function(pe){function Re(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ke=>Array.isArray(ke)&&ke.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&r.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Ze=>Ze instanceof u.$7M)))}pe.is=Re;function se(J){return{documents:J.documents.map(ke=>ke.map(Ve=>({uri:r.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Ze=>b.from(Ze))})))}}pe.from=se})(be||(e.MappedEditsContext=be={}));var ot;(function(pe){function Re(J){return{start:J.start,end:J.end}}pe.from=Re;function se(J){return new u.$uO(J.start,J.end)}pe.to=se})(ot||(e.NotebookRange=ot={}));var dt;(function(pe){function Re(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}pe.to=Re;function se(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}pe.from=se})(dt||(e.NotebookCellExecutionSummary=dt={}));var Pt;(function(pe){function Re(se){if(se===t.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(se===t.NotebookCellExecutionState.Pending)return;if(se===t.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${se}`)}pe.to=Re})(Pt||(e.NotebookCellExecutionState=Pt={}));var Vt;(function(pe){function Re(J){switch(J){case u.NotebookCellKind.Markup:return t.CellKind.Markup;case u.NotebookCellKind.Code:default:return t.CellKind.Code}}pe.from=Re;function se(J){switch(J){case t.CellKind.Markup:return u.NotebookCellKind.Markup;case t.CellKind.Code:default:return u.NotebookCellKind.Code}}pe.to=se})(Vt||(e.NotebookCellKind=Vt={}));var Qt;(function(pe){function Re(J){const ke={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)u.$vO.validate(Ve),ke.cells.push(ti.from(Ve));return ke}pe.from=Re;function se(J){const ke=new u.$wO(J.cells.map(ti.to));return(0,g.$jg)(J.metadata)||(ke.metadata=J.metadata),ke}pe.to=se})(Qt||(e.NotebookData=Qt={}));var ti;(function(pe){function Re(J){return{cellKind:Vt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Et.from):[]}}pe.from=Re;function se(J){return new u.$vO(Vt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Et.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}pe.to=se})(ti||(e.NotebookCellData=ti={}));var Zt;(function(pe){function Re(J){return{mime:J.mime,valueBytes:M.$Ge.wrap(J.data)}}pe.from=Re;function se(J){return new u.$xO(J.valueBytes.buffer,J.mime)}pe.to=se})(Zt||(e.NotebookCellOutputItem=Zt={}));var Et;(function(pe){function Re(J){return{outputId:J.id,items:J.items.map(Zt.from),metadata:J.metadata}}pe.from=Re;function se(J){const ke=J.items.map(Zt.to);return new u.$yO(ke,J.outputId,J.metadata)}pe.to=se})(Et||(e.NotebookCellOutput=Et={}));var Xt;(function(pe){function Re(ke){return J(ke)?{include:me.from(ke.include)??void 0,exclude:me.from(ke.exclude)??void 0}:me.from(ke)??void 0}pe.from=Re;function se(ke){return J(ke)?{include:me.to(ke.include),exclude:me.to(ke.exclude)}:me.to(ke)}pe.to=se;function J(ke){const Ve=ke;return Ve?!(0,g.$fg)(Ve.include)&&!(0,g.$fg)(Ve.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Yt;(function(pe){function Re(se,J,ke){const Ve=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,ke),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}pe.from=Re})(Yt||(e.NotebookStatusBarItem=Yt={}));var Xe;(function(pe){function Re(se,J,ke){const Ve=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{command:J.toInternal(Ve,ke),label:se.label,description:se.description,detail:se.detail,documentation:se.documentation}}pe.from=Re})(Xe||(e.NotebookKernelSourceAction=Xe={}));var oi;(function(pe){function Re(se){return{transientOutputs:se?.transientOutputs??!1,transientCellMetadata:se?.transientCellMetadata??{},transientDocumentMetadata:se?.transientDocumentMetadata??{},cellContentMetadata:se?.cellContentMetadata??{}}}pe.from=Re})(oi||(e.NotebookDocumentContentOptions=oi={}));var Gt;(function(pe){function Re(J){return{uri:J.uri,provides:J.provides}}pe.from=Re;function se(J){return new u.$AO(r.URI.revive(J.uri),J.provides)}pe.to=se})(Gt||(e.NotebookRendererScript=Gt={}));var ht;(function(pe){function Re(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:b.from(J.location.range),uri:J.location.uri}}}pe.from=Re;function se(J){const ke=new u.$GO(typeof J.message=="string"?J.message:ie.to(J.message));return ke.actualOutput=J.actual,ke.expectedOutput=J.expected,ke.contextValue=J.contextValue,ke.location=J.location?ge.to(J.location):void 0,ke}pe.to=se})(ht||(e.TestMessage=ht={}));var $t;(function(pe){pe.namespace=a.$TL,pe.denamespace=a.$UL})($t||(e.TestTag=$t={}));var xt;(function(pe){function Re(J){const ke=(0,n.$mP)(J).controllerId;return{extId:f.$OL.fromExtHostTestItem(J,ke).toString(),label:J.label,uri:r.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>$t.namespace(ke,Ve.id)),range:o.$ut.lift(b.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}pe.from=Re;function se(J){return{parent:void 0,error:void 0,id:f.$OL.fromString(J.extId).localId,label:J.label,uri:r.URI.revive(J.uri),tags:(J.tags||[]).map(ke=>{const{tagId:Ve}=$t.denamespace(ke);return new u.$HO(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:b.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}pe.toPlain=se})(xt||(e.TestItem=xt={})),function(pe){function Re(J){return{id:J.id}}pe.from=Re;function se(J){return new u.$HO(J.id)}pe.to=se}($t||(e.TestTag=$t={}));var Kt;(function(pe){const Re=(J,ke)=>{const Ve=J.value;if(!Ve)return;const Ze={...xt.toPlain(Ve.item),parent:ke,taskStates:Ve.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ut=>ut.type===0).map(ht.to)})),children:[]};if(J.children)for(const Ge of J.children.values()){const ut=Re(Ge,Ze);ut&&Ze.children.push(ut)}return Ze};function se(J){const ke=new d.$fP;for(const Ge of J.items)ke.insert(f.$OL.fromString(Ge.item.extId).path,Ge);const Ve=[ke.nodes],Ze=[];for(;Ve.length;)for(const Ge of Ve.pop())Ge.value?Ze.push(Ge):Ge.children&&Ve.push(Ge.children.values());return{completedAt:J.completedAt,results:Ze.map(Ge=>Re(Ge)).filter(g.$eg)}}pe.to=se})(Kt||(e.TestResults=Kt={}));var Ft;(function(pe){function Re(Ve){return{covered:Ve.covered,total:Ve.total}}function se(Ve){return"line"in Ve?y.from(Ve):b.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:se(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&se(Ze.location),label:Ze.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:se(Ve.location)}}pe.fromDetails=J;function ke(Ve,Ze){return u.$JO(Ze.statementCoverage),u.$JO(Ze.branchCoverage),u.$JO(Ze.declarationCoverage),{id:Ve,uri:Ze.uri,statement:Re(Ze.statementCoverage),branch:Ze.branchCoverage&&Re(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Re(Ze.declarationCoverage)}}pe.fromFile=ke})(Ft||(e.TestCoverage=Ft={}));var ft;(function(pe){function Re(se){switch(se){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}pe.to=Re})(ft||(e.CodeActionTriggerKind=ft={}));var Bt;(function(pe){function Re(J){const ke=new u.$OO(ne.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),b.to(J.range),b.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}pe.to=Re;function se(J,ke,Ve){if(ke=ke??J._sessionId,Ve=Ve??J._itemId,ke===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ve,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:b.from(J.range),selectionRange:b.from(J.selectionRange),tags:J.tags?.map(z.from)}}pe.from=se})(Bt||(e.TypeHierarchyItem=Bt={}));var _t;(function(pe){function Re(se){if(se)return{value:se.value,tooltip:se.tooltip}}pe.from=Re})(_t||(e.ViewBadge=_t={}));var Ut;(function(pe){function Re(Ve,Ze,Ge){const ut=Ze.fileData;return ut?new u.$VN(new u.$WN(ut.name,r.URI.revive(ut.uri),ut.id,(0,O.$db)(()=>Ge(ut.id)))):Ve===T.$Qs.uriList&&Ze.uriListData?new u.$UN(ke(Ze.uriListData)):new u.$UN(Ze.asString)}pe.to=Re;async function se(Ve,Ze){const Ge=await Ze.asString();if(Ve===T.$Qs.uriList)return{asString:Ge,fileData:void 0,uriListData:J(Ge)};const ut=Ze.asFile();return{asString:Ge,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}pe.from=se;function J(Ve){return A.$Ut.split(Ve).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return r.URI.parse(Ze)}catch{}return Ze})}function ke(Ve){return A.$Ut.create(Ve.map(Ze=>typeof Ze=="string"?Ze:r.URI.revive(Ze)))}})(Ut||(e.DataTransferItem=Ut={}));var Qe;(function(pe){function Re(J,ke){const Ve=J.items.map(([Ze,Ge])=>[Ze,Ut.to(Ze,Ge,ke)]);return new u.$XN(Ve)}pe.toDataTransfer=Re;async function se(J){const ke={items:[]},Ve=[];for(const[Ze,Ge]of J)Ve.push((async()=>{ke.items.push([Ze,await Ut.from(Ze,Ge)])})());return await Promise.all(Ve),ke}pe.from=se})(Qe||(e.DataTransfer=Qe={}));var ui;(function(pe){function Re(J,ke){return{kind:"reply",agentId:J.participant??ke?.agentId??"",subCommand:J.command??ke?.command,message:J.prompt,title:J.label}}pe.from=Re;function se(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}pe.to=se})(ui||(e.ChatFollowup=ui={}));var Jt;(function(pe){function Re(se){return"commandId"in se?{kind:"command",title:se.title??"",commandId:se.commandId??"",when:se.when??"",args:se.args}:{kind:"reply",message:se.message,title:se.title,tooltip:se.tooltip}}pe.from=Re})(Jt||(e.ChatInlineFollowup=Jt={}));var Wt;(function(pe){function Re(J){switch(J.role){case 0:return new u.$aP(J.content);case 1:return new u.$bP(J.content);case 2:return new u.$cP(J.content)}}pe.to=Re;function se(J){if(J instanceof u.$aP)return{role:0,content:J.content};if(J instanceof u.$bP)return{role:1,content:J.content};if(J instanceof u.$cP)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}pe.from=se})(Wt||(e.LanguageModelMessage=Wt={}));var pt;(function(pe){function Re(ke){const Ve={};for(const Ze of Object.keys(ke))Ve[Ze]=ke[Ze].map(pe.to);return Ve}pe.objectTo=Re;function se(ke){return{level:Lt.to(ke.level),kind:ke.kind,value:(0,r.$wc)(ke.value)?r.URI.revive(ke.value):ke.value,description:ke.description}}pe.to=se;function J(ke){return{level:Lt.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}pe.from=J})(pt||(e.ChatVariable=pt={}));var Lt;(function(pe){function Re(J){switch(J){case"short":return u.ChatVariableLevel.Short;case"medium":return u.ChatVariableLevel.Medium;case"full":default:return u.ChatVariableLevel.Full}}pe.to=Re;function se(J){switch(J){case u.ChatVariableLevel.Short:return"short";case u.ChatVariableLevel.Medium:return"medium";case u.ChatVariableLevel.Full:default:return"full"}}pe.from=se})(Lt||(e.ChatVariableLevel=Lt={}));var Rt;(function(pe){function Re(se){switch(se){case 1:return u.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return u.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return u.InteractiveEditorResponseFeedbackKind.Undone;case 3:return u.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return u.InteractiveEditorResponseFeedbackKind.Bug}}pe.to=Re})(Rt||(e.InteractiveEditorResponseFeedbackKind=Rt={}));var Mt;(function(pe){function Re(J){return{kind:"markdownContent",content:ie.from(J.value)}}pe.from=Re;function se(J){return new u.$2O(ie.to(J.content))}pe.to=se})(Mt||(e.ChatResponseMarkdownPart=Mt={}));var ii;(function(pe){function Re(J){return{kind:"markdownVuln",content:ie.from(J.value),vulnerabilities:J.vulnerabilities}}pe.from=Re;function se(J){return new u.$3O(ie.to(J.content),J.vulnerabilities)}pe.to=se})(ii||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ii={}));var qt;(function(pe){function Re(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}pe.from=Re;function se(J){return new u.$4O(J.agentId,J.command)}pe.to=se})(qt||(e.ChatResponseDetectedParticipantPart=qt={}));var ni;(function(pe){function Re(J){const{value:ke,baseUri:Ve}=J;function Ze(Ge,ut){return Ge.map(yt=>{const zt=r.URI.joinPath(ut,yt.name);return{label:yt.name,uri:zt,children:yt.children&&Ze(yt.children,zt)}})}return{kind:"treeData",treeData:{label:(0,v.$7g)(Ve),uri:Ve,children:Ze(ke,Ve)}}}pe.from=Re;function se(J){const ke=(0,E.$6h)(J.treeData);function Ve(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&Ve(yt.children)}))}const Ze=ke.uri,Ge=ke.children?Ve(ke.children):[];return new u.$5O(Ge,Ze)}pe.to=se})(ni||(e.ChatResponseFilesPart=ni={}));var Ct;(function(pe){function Re(J){return{kind:"inlineReference",name:J.title,inlineReference:r.URI.isUri(J.value)?J.value:m.from(J.value)}}pe.from=Re;function se(J){const ke=(0,E.$6h)(J);return new u.$6O(r.URI.isUri(ke.inlineReference)?ke.inlineReference:m.to(ke.inlineReference),J.name)}pe.to=se})(Ct||(e.ChatResponseAnchorPart=Ct={}));var Ot;(function(pe){function Re(J){return{kind:"progressMessage",content:ie.from(J.value)}}pe.from=Re;function se(J){return new u.$7O(J.content.value)}pe.to=se})(Ot||(e.ChatResponseProgressPart=Ot={}));var Nt;(function(pe){function Re(J,ke,Ve){return{kind:"command",command:ke.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}pe.from=Re;function se(J,ke){return new u.$8O(ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}pe.to=se})(Nt||(e.ChatResponseCommandButtonPart=Nt={}));var It;(function(pe){function Re(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ke=>ae.from(ke))}}pe.from=Re;function se(J){return new u.$0O(r.URI.revive(J.uri),J.edits.map(ke=>ae.to(ke)))}pe.to=se})(It||(e.ChatResponseTextEditPart=It={}));var mt;(function(pe){function Re(J){const ke=S.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:r.URI.isUri(J.value.value)||!J.value.value?J.value.value:m.from(J.value.value)},iconPath:ke}:{kind:"reference",reference:r.URI.isUri(J.value)?J.value:m.from(J.value),iconPath:ke}}pe.from=Re;function se(J){const ke=(0,E.$6h)(J),Ve=Ze=>r.URI.isUri(Ze)?Ze:m.to(Ze);return new u.$9O("variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&Ve(ke.reference.value)}:Ve(ke.reference))}pe.to=se})(mt||(e.ChatResponseReferencePart=mt={}));var Dt;(function(pe){function Re(ke,Ve,Ze){return ke instanceof u.$2O?Mt.from(ke):ke instanceof u.$6O?Ct.from(ke):ke instanceof u.$9O?mt.from(ke):ke instanceof u.$7O?Ot.from(ke):ke instanceof u.$5O?ni.from(ke):ke instanceof u.$8O?Nt.from(ke,Ve,Ze):ke instanceof u.$0O?It.from(ke):ke instanceof u.$3O?ii.from(ke):ke instanceof u.$4O?qt.from(ke):{kind:"markdownContent",content:ie.from("")}}pe.from=Re;function se(ke,Ve){switch(ke.kind){case"reference":return mt.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ke,Ve)}}pe.to=se;function J(ke,Ve){switch(ke.kind){case"markdownContent":return Mt.to(ke);case"inlineReference":return Ct.to(ke);case"progressMessage":return;case"treeData":return ni.to(ke);case"command":return Nt.to(ke,Ve)}}pe.toContent=J})(Dt||(e.ChatResponsePart=Dt={}));var ai;(function(pe){function Re(se){return{prompt:se.message,command:se.command,attempt:se.attempt??0,enableCommandDetection:se.enableCommandDetection??!0,variables:se.variables.variables.map(fi.to),location:kt.to(se.location)}}pe.to=Re})(ai||(e.ChatAgentRequest=ai={}));var kt;(function(pe){function Re(se){switch(se){case l.ChatAgentLocation.Notebook:return u.ChatLocation.Notebook;case l.ChatAgentLocation.Terminal:return u.ChatLocation.Terminal;case l.ChatAgentLocation.Panel:return u.ChatLocation.Panel;case l.ChatAgentLocation.Editor:return u.ChatLocation.Editor}}pe.to=Re})(kt||(e.ChatLocation=kt={}));var fi;(function(pe){function Re(se){return{name:se.name,range:se.range&&[se.range.start,se.range.endExclusive],values:se.values.map(pt.to)}}pe.to=Re})(fi||(e.ChatAgentResolvedVariable=fi={}));var ri;(function(pe){function Re(se,J,ke){return{label:se.label,values:se.values.map(pt.from),insertText:se.insertText,detail:se.detail,documentation:se.documentation,command:J.toInternal(se.command,ke)}}pe.from=Re})(ri||(e.ChatAgentCompletionItem=ri={}));var $i;(function(pe){function Re(se){return{errorDetails:se.errorDetails,metadata:se.metadata}}pe.to=Re})($i||(e.ChatAgentResult=$i={}));var li;(function(pe){function Re(se,J,ke){if(J.action.kind==="vote")return;const Ve=$i.to(se);if(J.action.kind==="command"){const Ze=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:ui.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}pe.to=Re})(li||(e.ChatAgentUserActionEvent=li={}));var wi;(function(pe){function Re(se,J,ke){return"terminalCommand"in se?{terminalCommand:se.terminalCommand,shouldExecute:se.shouldExecute}:"uri"in se?{uri:se.uri}:J.toInternal(se,ke)}pe.from=Re})(wi||(e.TerminalQuickFix=wi={}));var St;(function(pe){function Re(se){return{kind:bi.to(se.kind)}}pe.to=Re})(St||(e.PartialAcceptInfo=St={}));var bi;(function(pe){function Re(se){switch(se){case 0:return u.PartialAcceptTriggerKind.Word;case 1:return u.PartialAcceptTriggerKind.Line;case 2:return u.PartialAcceptTriggerKind.Suggest;default:return u.PartialAcceptTriggerKind.Unknown}}pe.to=Re})(bi||(e.PartialAcceptTriggerKind=bi={}));var si;(function(pe){function Re(se,J){return{id:J,label:se.label,description:se.description,canEdit:se.canEdit,collapsibleState:se.collapsibleState||0,contextValue:se.contextValue}}pe.from=Re})(si||(e.DebugTreeItem=si={}))}),define(Ie[262],Pe([1,0,4,17,8,35]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=void 0;let R=class{constructor(p,E){this.a=p.getProxy(I.$3M.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>E.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,E,T){const D=new O.$vw(A.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(D,void 0,T?.isRefactoring??!1)}};e.$mlc=R,e.$mlc=R=Je([We(0,M.$qP)],R)}),define(Ie[263],Pe([1,0,18,11,44,5,42,6,66,15,2,20,4,8,7,225,26]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=void 0;class s{constructor(l,t,f,a,$){this.j=l,this.k=t,this.l=f,this.m=a,this.n=$,this.b=p.$ae.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(a){if(l.c){const $=new Error("Response stream has been closed");throw Error.captureStackTrace($,a),$}};const l=this;this.b.reset();const f=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a)};this.g={markdown(a){t(this.markdown);const $=new g.$2O(a),u=v.ChatResponseMarkdownPart.from($);return f(u),this},markdownWithVulnerabilities(a,$){t(this.markdown),$&&(0,o.$IG)(l.j,"chatParticipantAdditions");const u=new g.$3O(a,$),S=v.ChatResponseMarkdownWithVulnerabilitiesPart.from(u);return f(S),this},filetree(a,$){t(this.filetree);const u=new g.$5O(a,$),S=v.ChatResponseFilesPart.from(u);return f(S),this},anchor(a,$){t(this.anchor);const u=new g.$6O(a,$),S=v.ChatResponseAnchorPart.from(u);return f(S),this},button(a){t(this.anchor);const $=new g.$8O(a),u=v.ChatResponseCommandButtonPart.from($,l.m,l.n);return f(u),this},progress(a){t(this.progress);const $=new g.$7O(a),u=v.ChatResponseProgressPart.from($);return f(u),this},reference(a,$){if(t(this.reference),"variableName"in a&&!a.value){const u=l.k.variables.variables.find(S=>S.name===a.variableName);if(u){let S;if(u.references?.length)S=u.references.map(h=>({kind:"reference",reference:{variableName:a.variableName,value:h.reference}}));else{const h=new g.$9O(a,$);S=[v.ChatResponseReferencePart.from(h)]}return S.forEach(h=>f(h)),this}}else{const u=new g.$9O(a,$),S=v.ChatResponseReferencePart.from(u);f(S)}return this},textEdit(a,$){t(this.textEdit),(0,o.$IG)(l.j,"chatParticipantAdditions");const u=new g.$0O(a,$),S=v.ChatResponseTextEditPart.from(u);return f(S),this},detectedParticipant(a,$){t(this.detectedParticipant),(0,o.$IG)(l.j,"chatParticipantAdditions");const u=new g.$4O(a,$),S=v.ChatResponseDetectedParticipantPart.from(u);return f(S),this},push(a){if(t(this.push),(a instanceof g.$0O||a instanceof g.$3O||a instanceof g.$4O)&&(0,o.$IG)(l.j,"chatParticipantAdditions"),a instanceof g.$9O)this.reference(a.value,a.iconPath);else{const $=v.ChatResponsePart.from(a,l.m,l.n);f($)}return this}}}return this.g}}class i extends w.$Vc{static{this.b=0}constructor(l,t,f){super(),this.n=t,this.s=f,this.c=new Map,this.j=this.B(new w.$5c),this.m=this.B(new w.$Uc),this.g=l.getProxy(d.$3M.MainThreadChatAgents2)}transferActiveChat(l){this.g.$transferActiveChatSession(l)}createChatAgent(l,t,f){const a=i.b++,$=new n(l,t,this.g,a,f);return this.c.set(a,$),this.g.$registerAgent(a,l.identifier,t,{},void 0),$.apiAgent}createDynamicChatAgent(l,t,f,a,$){const u=i.b++,S=new n(l,t,this.g,u,$);return this.c.set(u,S),this.g.$registerAgent(u,l.identifier,t,{isSticky:!0},{name:f,description:a}),S.apiAgent}async $invokeAgent(l,t,f,a){const $=this.c.get(l);if(!$)throw new Error(`[CHAT](${l}) CANNOT invoke agent because the agent is not registered`);let u=this.j.get(t.sessionId);u||(u=new w.$Uc,this.j.set(t.sessionId,u));const S=new s($.extension,t,this.g,this.s.converter,u);try{const h=await this.t(t.agentId,f),b=$.invoke(v.ChatAgentRequest.to(t),{history:h},S.apiObject,a);return await(0,M.$kh)(Promise.resolve(b).then(m=>{if(m?.metadata)try{JSON.stringify(m.metadata)}catch(k){const y=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.n.error(`[${$.extension.identifier.value}] [@${$.id}] ${y}`,$.extension),{errorDetails:{message:y},timings:S.timings}}return{errorDetails:m?.errorDetails,timings:S.timings,metadata:m?.metadata}}),a)}catch(h){return this.n.error(h,$.extension),{errorDetails:{message:(0,A.$hj)(h),responseIsIncomplete:!0}}}finally{S.close()}}async t(l,t){const f=[];for(const a of t.history){const $=v.ChatAgentResult.to(a.result),u=l===a.request.agentId?$:{...$,metadata:void 0};f.push(new g.$$O(a.request.message,a.request.command,a.request.variables.variables.map(v.ChatAgentResolvedVariable.to),a.request.agentId));const S=(0,I.$Hb)(a.response.map(h=>v.ChatResponsePart.toContent(h,this.s.converter)));f.push(new g.$_O(S,u,a.request.agentId,a.request.command))}return f}$releaseSession(l){this.j.deleteAndDispose(l)}async $provideFollowups(l,t,f,a,$){const u=this.c.get(t);if(!u)return Promise.resolve([]);const S=await this.t(u.id,a),h=v.ChatAgentResult.to(f);return(await u.provideFollowups(h,{history:S},$)).filter(b=>{const m=!b.participant||R.Iterable.some(this.c.values(),k=>k.id===b.participant&&D.$Rm.equals(k.extension.identifier,u.extension.identifier));return m||this.n.warn(`[@${u.id}] ChatFollowup refers to an unknown participant: ${b.participant}`),m}).map(b=>v.ChatFollowup.from(b,l))}$acceptFeedback(l,t,f,a){const $=this.c.get(l);if(!$)return;const u=v.ChatAgentResult.to(t);let S;switch(f){case r.InteractiveSessionVoteDirection.Down:S=g.ChatResultFeedbackKind.Unhelpful;break;case r.InteractiveSessionVoteDirection.Up:S=g.ChatResultFeedbackKind.Helpful;break}$.acceptFeedback(Object.freeze(a?{result:u,kind:S,reportIssue:a}:{result:u,kind:S}))}$acceptAction(l,t,f){const a=this.c.get(l);if(!a||f.action.kind==="vote")return;const $=v.ChatAgentUserActionEvent.to(t,f,this.s.converter);$&&a.acceptAction(Object.freeze($))}async $invokeCompletionProvider(l,t,f){const a=this.c.get(l);return a?(await a.invokeCompletionProvider(t,f)).map(u=>v.ChatAgentCompletionItem.from(u,this.s.converter,this.m)):[]}async $provideWelcomeMessage(l,t,f){const a=this.c.get(l);if(a)return await a.provideWelcomeMessage(v.ChatLocation.to(t),f)}async $provideSampleQuestions(l,t,f){const a=this.c.get(l);if(a)return(await a.provideSampleQuestions(v.ChatLocation.to(t),f)).map($=>v.ChatFollowup.from($,void 0))}}e.$nlc=i;class n{constructor(l,t,f,a,$){this.extension=l,this.id=t,this.u=f,this.w=a,this.x=$,this.n=new O.$ee,this.o=new O.$ee}acceptFeedback(l){this.n.fire(l)}acceptAction(l){this.o.fire(l)}async invokeCompletionProvider(l,t){return this.q?await this.q.provider.provideCompletionItems(l,t)??[]:[]}async provideFollowups(l,t,f){if(!this.b)return[];const a=await this.b.provideFollowups(l,t,f);return a?a.filter($=>!($&&"commandId"in $)).filter($=>!($&&"message"in $)):[]}async provideWelcomeMessage(l,t){if(!this.s)return[];const f=await this.s.provideWelcomeMessage(l,t);return f?f.map(a=>typeof a=="string"?a:v.MarkdownString.from(a)):[]}async provideSampleQuestions(l,t){if(!this.s||!this.s.provideSampleQuestions)return[];const f=await this.s.provideSampleQuestions(l,t);return f||[]}get apiAgent(){let l=!1,t=!1;const f=()=>{l||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof g.$2N?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:v.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,o.$IG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName($){(0,o.$IG)(a.extension,"defaultChatParticipant"),a.c=$,f()},get iconPath(){return a.d},set iconPath($){a.d=$,f()},get requestHandler(){return a.x},set requestHandler($){(0,E.$gg)(typeof $=="function","Invalid request handler"),a.x=$},get followupProvider(){return a.b},set followupProvider($){a.b=$,f()},get isDefault(){return(0,o.$IG)(a.extension,"defaultChatParticipant"),a.g},set isDefault($){(0,o.$IG)(a.extension,"defaultChatParticipant"),a.g=$,f()},get helpTextPrefix(){return(0,o.$IG)(a.extension,"defaultChatParticipant"),a.j},set helpTextPrefix($){(0,o.$IG)(a.extension,"defaultChatParticipant"),a.j=$,f()},get helpTextVariablesPrefix(){return(0,o.$IG)(a.extension,"defaultChatParticipant"),a.k},set helpTextVariablesPrefix($){(0,o.$IG)(a.extension,"defaultChatParticipant"),a.k=$,f()},get helpTextPostfix(){return(0,o.$IG)(a.extension,"defaultChatParticipant"),a.l},set helpTextPostfix($){(0,o.$IG)(a.extension,"defaultChatParticipant"),a.l=$,f()},get isSecondary(){return(0,o.$IG)(a.extension,"defaultChatParticipant"),a.m},set isSecondary($){(0,o.$IG)(a.extension,"defaultChatParticipant"),a.m=$,f()},get supportIssueReporting(){return(0,o.$IG)(a.extension,"chatParticipantAdditions"),a.p},set supportIssueReporting($){(0,o.$IG)(a.extension,"chatParticipantAdditions"),a.p=$,f()},get onDidReceiveFeedback(){return a.n.event},set participantVariableProvider($){if((0,o.$IG)(a.extension,"chatParticipantAdditions"),a.q=$,$){if(!$.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,$.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,o.$IG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider($){(0,o.$IG)(a.extension,"defaultChatParticipant"),a.s=$,f()},get welcomeMessageProvider(){return(0,o.$IG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,o.$HG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester($){a.t=$,f()},get requester(){return a.t},dispose(){l=!0,a.b=void 0,a.n.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(l,t,f,a){return this.x(l,t,f,a)}}}),define(Ie[264],Pe([1,0,14,6,4,8,7,26]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$olc=void 0;class p{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(A.$3M.MainThreadChatVariables)}async $resolveVariable(D,d,v,g){const r=this.b.get(D);if(r)try{if(r.resolver.resolve2){(0,w.$IG)(r.extension,"chatParticipantAdditions");const o=new E(d,this.c),s=await r.resolver.resolve2(r.data.name,{prompt:v},o.apiObject,g);if(s)return s.map(O.ChatVariable.from)}else{const o=await r.resolver.resolve(r.data.name,{prompt:v},g);if(o)return o.map(O.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(D,d,v,g){const r=p.a++;return this.b.set(r,{extension:D,data:{name:d,description:v},resolver:g}),this.c.$registerVariable(r,{name:d,description:v}),(0,M.$Tc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$olc=p;class E{constructor(D,d){this.c=D,this.d=d,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let d=function(g){if(D.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,g),r}};const D=this,v=g=>{this.d.$handleProgressChunk(this.c,g)};this.b={progress(g){d(this.progress);const r=new R.$7O(g),o=O.ChatResponseProgressPart.from(r);return v(o),this},reference(g){d(this.reference);const r=new R.$9O(g),o=O.ChatResponseReferencePart.from(r);return v(o),this},push(g){return d(this.push),g instanceof R.$9O?v(O.ChatResponseReferencePart.from(g)):g instanceof R.$7O&&v(O.ChatResponseProgressPart.from(g)),this}}}return this.b}}}),define(Ie[265],Pe([1,0,11,69,5,6,2,89,20,8,7,4,26]),function(le,e,I,M,A,O,R,w,p,E,T,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slc=v;function v(g,r,o){const s=g.getProxy(D.$3M.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new p.$Tm,r.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const b=this.b.get(h.handle);return b?b.value:h}else if(h&&h.$mid===7){const b=h,m=this.b.get(b.commentControlHandle);if(!m)return b;const k=m.getCommentThread(b.commentThreadHandle);return k?k.value:b}else if(h&&(h.$mid===9||h.$mid===8)){const b=this.b.get(h.thread.commentControlHandle);if(!b)return h;const m=b.getCommentThread(h.thread.commentThreadHandle);return m?h.$mid===8?m.value:{thread:m.value,text:h.text}:h}else if(h&&h.$mid===10){const b=this.b.get(h.thread.commentControlHandle);if(!b)return h;const m=b.getCommentThread(h.thread.commentThreadHandle);if(!m)return h;const k=h.commentUniqueId,y=m.getCommentByUniqueId(k);return y||h}else if(h&&h.$mid===11){const b=this.b.get(h.thread.commentControlHandle);if(!b)return h;const m=b.getCommentThread(h.thread.commentThreadHandle);if(!m)return h;const k=h.text,y=h.commentUniqueId,C=m.getCommentByUniqueId(y);return C?(typeof C.body=="string"?C.body=k:C.body=new T.$uN(k),C):h}return h}})}createCommentController(h,b,m){const k=i.a++,y=new c(h,k,b,m);this.b.set(y.handle,y);const C=this.c.get(h.identifier)||[];return C.push(y),this.c.set(h.identifier,C),y.value}async $createCommentThreadTemplate(h,b,m){const k=this.b.get(h);k&&k.$createCommentThreadTemplate(b,m)}async $setActiveComment(h,b){const m=this.b.get(h);m&&m.$setActiveComment(b??void 0)}async $updateCommentThreadTemplate(h,b,m){const k=this.b.get(h);k&&k.$updateCommentThreadTemplate(b,m)}$deleteCommentThread(h,b){this.b.get(h)?.$deleteCommentThread(b)}async $provideCommentingRanges(h,b,m){const k=this.b.get(h);if(!k||!k.commentingRangeProvider)return Promise.resolve(void 0);const y=await o.ensureDocumentData(R.URI.revive(b));return(0,I.$oh)(async()=>{const C=await k.commentingRangeProvider.provideCommentingRanges(y.document,m);let P;return Array.isArray(C)?P={ranges:C,fileComments:!1}:C?P={ranges:C.ranges||[],fileComments:C.fileComments||!1}:P=C??void 0,P}).then(C=>{let P;return C&&(P={ranges:C.ranges.map(W=>E.Range.from(W)),fileComments:C.fileComments}),P})}$toggleReaction(h,b,m,k,y){const C=this.b.get(h);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,I.$oh)(()=>{const P=C.getCommentThread(b);if(P){const W=P.getCommentByUniqueId(k.uniqueIdInThread);if(C!==void 0&&W&&C.reactionHandler)return C.reactionHandler(W,f(y))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,typeof h=="object"?((0,d.$IG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=h.resolved,this.b.applicability=h.applicability):this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,b,m,k,y,C,P,W){this.m=b,this.n=m,this.o=k,this.p=y,this.q=C,this.extensionDescription=P,this.r=W,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$ee,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Wc,this.l.value=new O.$Uc,this.n===void 0&&(this.n=`${h}.${this.handle}`),s.$createCommentThread(b,this.handle,this.n,this.o,E.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{s.$deleteCommentThread(b,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(q){V.range=q},get comments(){return V.comments},set comments(q){V.comments=q},get collapsibleState(){return V.collapsibleState},set collapsibleState(q){V.collapsibleState=q},get canReply(){return V.canReply},set canReply(q){V.canReply=q},get contextValue(){return V.contextValue},set contextValue(q){V.contextValue=q},get label(){return V.label},set label(q){V.label=q},get state(){return V.state},set state(q){V.state=q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Uc);const h=m=>Object.prototype.hasOwnProperty.call(this.b,m),b={};h("range")&&(b.range=E.Range.from(this.p)),h("label")&&(b.label=this.label),h("contextValue")&&(b.contextValue=this.contextValue??null),h("comments")&&(b.comments=this.q.map(m=>l(this,m,this.k,this.extensionDescription))),h("collapsibleState")&&(b.collapseState=a(this.g)),h("canReply")&&(b.canReply=this.canReply),h("state")&&(b.state=$(this.h)),h("applicability")&&(b.applicability=u(this.h)),h("isTemplate")&&(b.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,b)}getCommentByUniqueId(h){for(const b of this.k){const m=b[0],k=b[1];if(h===k)return m}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}Je([(0,M.$2h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,h?.resourceHints&&(0,d.$IG)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,h?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,d.$IG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,d.$IG)(this.h,"activeComment"),this.f}constructor(h,b,m,k){this.h=h,this.i=b,this.j=m,this.k=k,this.a=new Map,s.$registerCommentController(this.handle,m,k,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(C){y.options=C},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(C){y.commentingRangeProvider=C},get reactionHandler(){return y.reactionHandler},set reactionHandler(C){y.reactionHandler=C},get activeCommentThread(){return y.activeCommentThread},createCommentThread(C,P,W){return y.createCommentThread(C,P,W).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(h,b,m){b===void 0&&(0,d.$IG)(this.h,"fileComments");const k=new n(this.id,this.handle,void 0,h,b,m,this.h,!1);return this.a.set(k.handle,k),k}$setActiveComment(h){if(!h){this.e=void 0,this.f=void 0;return}const b=this.a.get(h.commentThreadHandle);b&&(this.e=h.uniqueIdInThread?b.getCommentByUniqueId(h.uniqueIdInThread):void 0,this.f=b)}$createCommentThreadTemplate(h,b){const m=new n(this.id,this.handle,void 0,R.URI.revive(h),E.Range.to(b),[],this.h,!0);return m.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this.a.set(m.handle,m),m}$updateCommentThreadTemplate(h,b){const m=this.a.get(h);m&&(m.range=E.Range.to(b))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.g.forEach(h=>h.dispose())}}function l(S,h,b,m){let k=b.get(h);return k||(k=++S.commentHandle,b.set(h,k)),h.state!==void 0&&(0,d.$IG)(m,"commentsDraftState"),h.reactions?.some(y=>y.reactors!==void 0)&&(0,d.$IG)(m,"commentReactor"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:k,body:typeof h.body=="string"?h.body:E.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(y=>t(y)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(S){return{label:S.label,iconPath:S.iconPath?E.$pP(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(h=>h.name):S.reactors}}function f(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?R.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(h=>({name:h}))}}function a(S){if(S!==void 0)switch(S){case T.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function $(S){let h;if(typeof S=="object"?h=S.resolved:h=S,h!==void 0)switch(h){case T.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}function u(S){let h;if(typeof S=="object"&&(h=S.applicability),h!==void 0)switch(h){case T.CommentThreadApplicability.Current:return w.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return w.CommentThreadApplicability.Outdated}return w.CommentThreadApplicability.Current}return new i}}),define(Ie[266],Pe([1,0,24,73,6,16,23,2,8,64,76,4,7]),function(le,e,I,M,A,O,R,w,p,E,T,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;class v{constructor(f,a){this.document=f,this.b=a,this.a=1,this.c=new T.$$kc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,a){await this.f(f).undo(),a||this.disposeBackup()}async redo(f,a){await this.f(f).redo(),a||this.disposeBackup()}disposeEdits(f){for(const a of f)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=l(this.document.uri)+this.a++;return(0,R.$0g)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const a=this.c.get(f,0);if(!a)throw new Error("No edit found");return a}}class g{constructor(){this.a=new Map}get(f,a){return this.a.get(this.b(f,a))}add(f,a,$){const u=this.b(f,a.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${f} resource:${a.uri}`);const S=new v(a,$);return this.a.set(u,S),S}delete(f,a){const $=this.b(f,a.uri);this.a.delete($)}b(f,a){return`${f}@@@${a}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(f,a,$){return this.b(0,f,a,$)}addCustomProvider(f,a,$){return this.b(1,f,a,$)}get(f){return this.a.get(f)}b(f,a,$,u){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:f,extension:$,provider:u}),new d.$5M(()=>this.a.delete(a))}}class s{constructor(f,a,$,u,S){this.d=a,this.f=$,this.g=u,this.h=S,this.b=new o,this.c=new g,this.a=f.getProxy(D.$3M.MainThreadCustomEditors)}registerCustomEditorProvider(f,a,$,u){const S=new A.$Uc;return n($)?(S.add(this.b.addTextProvider(a,f,$)),this.a.$registerTextEditorProvider((0,E.$Hlc)(f),a,u.webviewOptions||{},{supportsMove:!!$.moveCustomTextEditor},(0,E.$Flc)(f))):(S.add(this.b.addCustomProvider(a,f,$)),i($)&&S.add($.onDidChangeCustomDocument(h=>{const b=this.i(a,h.document.uri);if(c(h)){const m=b.addEdit(h);this.a.$onDidEdit(h.document.uri,a,m,h.label)}else this.a.$onContentChange(h.document.uri,a)})),this.a.$registerCustomEditorProvider((0,E.$Hlc)(f),a,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,E.$Flc)(f))),d.$5M.from(S,new d.$5M(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(f,a,$,u,S){const h=this.b.get(a);if(!h)throw new Error(`No provider found for '${a}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${a}'`);const b=w.URI.revive(f),m=await h.provider.openCustomDocument(b,{backupId:$,untitledDocumentData:u?.buffer},S);let k;return i(h.provider)&&this.f&&(k=this.f.workspaceValue(h.extension)??this.f.globalValue(h.extension)),this.c.add(a,m,k),{editable:i(h.provider)}}async $disposeCustomDocument(f,a){const $=this.b.get(a);if(!$)throw new Error(`No provider found for '${a}'`);if($.type!==1)throw new Error(`Invalid provider type for '${a}'`);const u=w.URI.revive(f),{document:S}=this.i(a,u);this.c.delete(a,S),S.dispose()}async $resolveCustomEditor(f,a,$,u,S,h){const b=this.b.get($);if(!b)throw new Error(`No provider found for '${$}'`);const m=p.ViewColumn.to(S),k=this.g.createNewWebview(a,u.contentOptions,b.extension),y=this.h.createNewWebviewPanel(a,$,u.title,m,u.options,k,u.active),C=w.URI.revive(f);switch(b.type){case 1:{const{document:P}=this.i($,C);return b.provider.resolveCustomEditor(P,y,h)}case 0:{const P=this.d.getDocument(C);return b.provider.resolveCustomTextEditor(P,y,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,a,$){this.i(a,f).disposeEdits($)}async $onMoveCustomEditor(f,a,$){const u=this.b.get($);if(!u)throw new Error(`No provider found for '${$}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${$}'`);const S=this.h.getWebviewPanel(f);if(!S)throw new Error("No webview found");const h=w.URI.revive(a),b=this.d.getDocument(h);await u.provider.moveCustomTextEditor(b,S,I.CancellationToken.None)}async $undo(f,a,$,u){return this.i(a,f).undo($,u)}async $redo(f,a,$,u){return this.i(a,f).redo($,u)}async $revert(f,a,$){const u=this.i(a,f);await this.j(a).revertCustomDocument(u.document,$),u.disposeBackup()}async $onSave(f,a,$){const u=this.i(a,f);await this.j(a).saveCustomDocument(u.document,$),u.disposeBackup()}async $onSaveAs(f,a,$,u){const S=this.i(a,f);return this.j(a).saveCustomDocumentAs(S.document,w.URI.revive($),u)}async $backup(f,a,$){const u=this.i(a,f),h=await this.j(a).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},$);return u.updateBackup(h),h.id}i(f,a){const $=this.c.get(f,w.URI.revive(a));if(!$)throw new Error("No custom document found");return $}j(f){const $=this.b.get(f)?.provider;if(!$||!i($))throw new Error("Custom document is not editable");return $}}e.$Klc=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function l(t){const f=t.scheme===O.Schemas.file||t.scheme===O.Schemas.untitled?t.fsPath:t.toString();return(0,M.$kj)(f)+""}}),define(Ie[267],Pe([1,0,172,101,2,4,7,8,5,12,28,46]),function(le,e,I,M,A,O,R,w,p,E,T,D){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=e.$flc=void 0;class v{#e;#t;#i;constructor(o,s,i,n,c,l,t,f){this.d=o,this.e=s,this.f=i,this.g=n,this.h=c,this.c=!1,this.f=Math.max(n,i),this.#i=new T.$Bc(a=>l.getComparisonKey(a)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let i=[];if(A.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),i=[o]}else if(Array.isArray(o)){i=[];let l;o=[...o].sort(v.k);for(const t of o){const[f,a]=t;if((!l||f.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=f,i.push(f),this.#i.set(f,[])),a)this.#i.get(f)?.push(...a);else{const $=this.#i.get(f);$&&($.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let c=0;for(const l of i){let t=[];const f=this.#i.get(l);if(f)if(f.length>this.g){t=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const u of f)if(u.severity===a[$]&&t.push({...w.Diagnostic.from(u),modelVersionId:this.h(l)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,I.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(a=>({...w.Diagnostic.from(a),modelVersionId:this.h(l)}));if(n.push([l,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,n)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[i,n]of this)o.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$flc=v;let g=class{static{d=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*d.d}static _mapper(o){const s=new T.$Bc;for(const i of o)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new p.$ie({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,d._mapper),this.f=o.getProxy(O.$3M.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:i,f:n,h:c,j:l,k:t,l:f}=this,a=new class{$changeMany(S,h){n.$changeMany(S,h),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,S,h.length===0?"CLEARING":h)}$clear(S){n.$clear(S),l.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,S)}dispose(){n.dispose()}};let $;if(!s)s="_generated_diagnostic_collection_name_#"+d.c++,$=s;else if(!i.has(s))$=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do $=s+d.c++;while(i.has($))}return new class extends v{constructor(){super(s,$,d.e,d.d,S=>f.getDocument(S)?.version,t.extUri,a,c),i.set($,this)}dispose(){super.dispose(),i.delete($)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((c,l)=>{let t=s.get(c.toString());typeof t>"u"&&(t=i.length,s.set(c.toString(),t),i.push([c,[]])),i[t][1]=i[t][1].concat(...l)});return i}}m(o){let s=[];for(const i of this.g.values())i.has(o)&&(s=s.concat(i.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",i=new v(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of o)this.n.set(A.URI.revive(s),i.map(w.Diagnostic.to))}};e.$glc=g,e.$glc=g=d=Je([We(1,E.$3j),We(2,D.$elc)],g)}),define(Ie[268],Pe([1,0,2,14,7,8,200,35]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=void 0;class p{constructor(T,D,d,v={timeout:1500,errors:3}){this.c=T,this.d=D,this.f=d,this.g=v,this.a=new R.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(D,d,v)=>{const r={dispose:this.a.push([D,d,T])};return Array.isArray(v)&&v.push(r),r}}async $participateInSave(T,D){const d=I.URI.revive(T);let v=!1;const g=setTimeout(()=>v=!0,this.g.timeout),r=[];try{for(const o of[...this.a]){if(v)break;const s=this.d.getDocument(d),i=await this.h(o,{document:s,reason:O.TextDocumentSaveReason.to(D)});r.push(i)}}finally{clearTimeout(g)}return r}h([T,D,d],v){const g=this.b.get(T);return typeof g=="number"&&g>this.g.errors?Promise.resolve(!1):this.i(d,T,D,v).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this.b.get(T);this.b.set(T,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,D,d,v){const g=[],r=Date.now(),{document:o,reason:s}=v,{version:i}=o,n=Object.freeze({document:o,reason:s,waitUntil(c){if(Object.isFrozen(g))throw(0,M.$8)("waitUntil can not be called async");g.push(Promise.resolve(c))}});try{D.apply(d,[n])}catch(c){return Promise.reject(c)}return Object.freeze(g),new Promise((c,l)=>{const t=setTimeout(()=>l(new Error("timeout")),this.g.timeout);return Promise.all(g).then(f=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),c(f)}).catch(f=>{clearTimeout(t),l(f)})}).then(c=>{const l={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(f=>f instanceof A.$_M))for(const{newText:f,newEol:a,range:$}of t)l.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:$&&O.Range.from($),text:f,eol:a&&O.EndOfLine.from(a)}});if(l.edits.length!==0)return i===o.version?this.f.$tryApplyWorkspaceEdit(new w.$vw(l)):Promise.reject(new Error("concurrent_edits"))})}}e.$omc=p}),define(Ie[269],Pe([1,0,5,6,2,4,113,8,15,25,7]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class D{constructor(v,g){this.a=new I.$ee,this.b=new I.$ee,this.c=new I.$ee,this.d=new I.$ee,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Uc,this.h=new Map,this.f=v.getProxy(O.$3M.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const g=this.g.getDocument(v);if(g)return g}getDocument(v){const g=this.getDocumentData(v);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return g.document}ensureDocumentData(v){const g=this.g.getDocument(v);if(g)return Promise.resolve(g);let r=this.h.get(v.toString());return r||(r=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const s=A.URI.revive(o);return(0,p.$hg)(this.g.getDocument(s))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),r)),r}createDocumentData(v){return this.f.$tryCreateDocument(v).then(g=>A.URI.revive(g))}$acceptModelLanguageChanged(v,g){const r=A.URI.revive(v),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(g),this.a.fire(o.document)}$acceptModelSaved(v){const g=A.URI.revive(v),r=this.g.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(v,g){const r=A.URI.revive(v),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(g),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,g,r){const o=A.URI.revive(v),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(g);let i;g.isUndoing?i=T.TextDocumentChangeReason.Undo:g.isRedoing&&(i=T.TextDocumentChangeReason.Redo),this.c.fire((0,E.$4n)({document:s.document,contentChanges:g.changes.map(n=>({range:w.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(v,g){(0,R.$sP)(v,g)}}e.$hlc=D}),define(Ie[67],Pe([1,0,270,5,15,2,3,4,17,8,7]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=e.$Llc=void 0,e.$Llc=(0,R.$wi)("IExtHostEditorTabs");class D{constructor(o,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$PO(O.URI.revive(this.b.input.uri));case 2:return new T.$QO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case 3:return new T.$RO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case 6:return new T.$SO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$TO(this.b.input.viewType);case 4:return new T.$UO(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$VO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$WO;case 9:return new T.$XO(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$YO;case 11:return new T.$ZO(this.b.input.diffEditors.map(o=>new T.$QO(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class d{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const i of o.tabs)i.isActive&&(this.d=i.id),this.c.push(new D(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return E.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(i=>i.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const i=new D(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,i),o.tabDto.isActive&&(this.d=i.tabId),i}else if(o.kind===1){const i=this.c.splice(o.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(o.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,i),i}const s=this.c.find(i=>i.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new M.$ee,this.c=new M.$ee,this.e=[],this.a=o.getProxy(w.$3M.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(i=>i.apiObject))},get activeTabGroup(){const i=o.d;return(0,A.$hg)(o.e.find(c=>c.groupId===i)?.apiObject)},close:async(i,n)=>{const c=Array.isArray(i)?i:[i];return c.length?g(c[0])?this.j(c,n):this.i(c,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(a=>a.groupId)),i=new Set(o.map(a=>a.groupId)),n=(0,I.$L)(s,i),c=this.e.filter(a=>n.removed.includes(a.groupId)).map(a=>a.apiObject),l=[],t=[];this.e=o.map(a=>{const $=new d(a,()=>this.d);return n.added.includes($.groupId)?l.push($.apiObject):t.push($.apiObject),$});const f=(0,A.$hg)(o.find(a=>a.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:l,closed:c,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(o){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===o)return i}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const i=[];for(const n of o){const c=this.g(n);if(!c)throw new Error("Tab close: Invalid tab not found!");i.push(c.tabId)}return this.a.$closeTab(i,s)}async j(o,s){const i=[];for(const n of o){const c=this.h(n);if(!c)throw new Error("Group close: Invalid group not found!");i.push(c.groupId)}return this.a.$closeGroup(i,s)}};e.$Mlc=v,e.$Mlc=v=Je([We(0,p.$qP)],v);function g(r){return r.tabs!==void 0}}),define(Ie[271],Pe([1,0,2,4,6,7,8,314,13,21,26,55]),function(le,e,I,M,A,O,R,w,p,E,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0;class d{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let s,i,n=14,c=14;for(const l of r){let t=s?(0,p.$Af)(s,l):0;for(t===0?i=1:i=c;t<l.length;t++)t+1===l.length?(n=c,c=9):c+=1,o.push([i,l.toUpperCase().charCodeAt(t),c]),o.push([i,l.toLowerCase().charCodeAt(t),c]),i=c;s=l,c=n}o.push([9,58,10]),o.push([10,47,12]),this.b=new w.$l3(o)}}provideDocumentLinks(r){this.c();const o=[],s=w.$m3.computeLinks({getLineContent(i){return r.lineAt(i-1).text},getLineCount(){return r.lineCount}},this.b);for(const i of s){const n=R.DocumentLink.to(i);n.target&&o.push(n)}return o}}class v{constructor(r,o){this.i=o,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(M.$3M.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,s,i={}){if(v.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const n=this.h++;this.b.add(o),this.d.add(o),this.c.set(n,s);let c=2;i.isCaseSensitive&&(c+=1024),i.isReadonly&&(c+=2048),typeof s.copy=="function"&&(c+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,T.$IG)(r,"fsChunks"),c+=4);let l;i.isReadonly&&(0,D.$Vk)(i.isReadonly)&&i.isReadonly.value!==""&&(l={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,o,c,l).catch(f=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(f)});const t=s.onDidChangeFile(f=>{const a=[];for(const $ of f){const{uri:u,type:S}=$;if(u.scheme!==o)continue;let h;switch(S){case O.FileChangeType.Changed:h=0;break;case O.FileChangeType.Created:h=1;break;case O.FileChangeType.Deleted:h=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:u,type:h})}this.a.$onFileSystemChange(n,a)});return(0,A.$Tc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:s,mtime:i,size:n,permissions:c}=r;return{type:o,ctime:s,mtime:i,size:n,permissions:c}}$stat(r,o){return Promise.resolve(this.l(r).stat(I.URI.revive(o))).then(s=>v.k(s))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(I.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(I.URI.revive(o))).then(s=>E.$Ge.wrap(s))}$writeFile(r,o,s,i){return Promise.resolve(this.l(r).writeFile(I.URI.revive(o),s.buffer,i))}$delete(r,o,s){return Promise.resolve(this.l(r).delete(I.URI.revive(o),s))}$rename(r,o,s,i){return Promise.resolve(this.l(r).rename(I.URI.revive(o),I.URI.revive(s),i))}$copy(r,o,s,i){const n=this.l(r);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(I.URI.revive(o),I.URI.revive(s),i))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(I.URI.revive(o)))}$watch(r,o,s,i){const n=this.l(r).watch(I.URI.revive(s),i);this.f.set(o,n)}$unwatch(r,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(r,o,s){const i=this.l(r);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(o),s))}$close(r,o){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(r,o,s,i){const n=this.l(r);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$Ge.alloc(i);return Promise.resolve(n.read(o,s,c.buffer,0,i)).then(l=>c.slice(0,l))}$write(r,o,s,i){const n=this.l(r);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(o,s,i.buffer,0,i.byteLength))}l(r){const o=this.c.get(r);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$qmc=v}),define(Ie[272],Pe([1,0,5,37,2,4,8,7,43]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rmc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,g,r,o,s,i){this.a=Math.random(),this.b=new I.$ee,this.c=new I.$ee,this.d=new I.$ee,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,M.$qk)(s),c=typeof s=="string",l=i?.correlate,t=o(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(l&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const a of f.created){const $=A.URI.revive(a);n($.fsPath)&&(!c||g.getWorkspaceFolder($))&&this.b.fire($)}if(!i?.ignoreChangeEvents)for(const a of f.changed){const $=A.URI.revive(a);n($.fsPath)&&(!c||g.getWorkspaceFolder($))&&this.c.fire($)}if(!i?.ignoreDeleteEvents)for(const a of f.deleted){const $=A.URI.revive(a);n($.fsPath)&&(!c||g.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=w.$5M.from(this.i(v,r,s,i,i?.correlate),this.b,this.c,this.d,t)}i(v,g,r,o,s){const i=w.$5M.from();if(typeof r=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return i;const n=v.getProxy(O.$3M.MainThreadFileSystemEventService);let c=!1;(r.pattern.includes(M.$mk)||r.pattern.includes(M.$nk))&&(c=!0);let l;return s&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(l=14,o?.ignoreChangeEvents&&(l&=-3),o?.ignoreCreateEvents&&(l&=-5),o?.ignoreDeleteEvents&&(l&=-9)),n.$watch(g.identifier.value,this.a,r.baseUri,{recursive:c,excludes:o?.excludes??[],filter:l},!!s),w.$5M.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(v){this.a=v,this.session=this.a.session,this.b=new p.$V(()=>this.a.created.map(A.URI.revive)),this.c=new p.$V(()=>this.a.changed.map(A.URI.revive)),this.d=new p.$V(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(v,g,r){this.j=v,this.k=g,this.l=r,this.a=new I.$ee,this.b=new I.$ee,this.c=new I.$ee,this.d=new I.$ee,this.g=new I.$ge,this.h=new I.$ge,this.i=new I.$ge,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,g,r,o){return new E(this.j,v,g,this.a.event,R.GlobPattern.from(r),o)}$onFileEvent(v){this.a.fire(new T(v))}$onDidRunFileOperation(v,g){switch(v){case 2:this.b.fire(Object.freeze({files:g.map(r=>({oldUri:A.URI.revive(r.source),newUri:A.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:g.map(r=>A.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:g.map(r=>A.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,g){return(r,o,s)=>{const i=function(c){r.call(o,c)};return i.extension=v,g.event(i,void 0,s)}}async $onWillRunFileOperation(v,g,r,o){switch(v){case 2:return await this.n(this.g,{files:g.map(s=>({oldUri:A.URI.revive(s.source),newUri:A.URI.revive(s.target)}))},r,o);case 1:return await this.n(this.i,{files:g.map(s=>A.URI.revive(s.target))},r,o);case 0:case 3:return await this.n(this.h,{files:g.map(s=>A.URI.revive(s.target))},r,o)}}async n(v,g,r,o){const s=new Set,i=[];if(await v.fireAsync(g,o,async(c,l)=>{const t=Date.now(),f=await Promise.resolve(c);f instanceof w.$cN&&(i.push([l.extension,f]),s.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",l.extension.identifier)}),o.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,c]of i){const{edits:l}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(l)}return{edit:n,extensionNames:Array.from(s)}}}e.$rmc=D}),define(Ie[273],Pe([1,0,18,11,24,14,91,6,25,66,13,15,2,30,315,89,98,174,20,8,7,26,76,4]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n,c,l,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=void 0;class a{constructor(j,F){this.d=j,this.e=F}async provideDocumentSymbols(j,F){const H=this.d.getDocument(j),G=await this.e.provideDocumentSymbols(H,F);if(!(0,I.$Kb)(G))return G[0]instanceof c.$mN?G.map(n.DocumentSymbol.from):a.f(G)}static f(j){j=j.slice(0).sort((G,ee)=>{let re=G.location.range.start.compareTo(ee.location.range.start);return re===0&&(re=ee.location.range.end.compareTo(G.location.range.end)),re});const F=[],H=[];for(const G of j){const ee={name:G.name||"!!MISSING: name!!",kind:n.SymbolKind.from(G.kind),tags:G.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:n.Range.from(G.location.range),selectionRange:n.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(ee),F.push(ee);break}const re=H[H.length-1];if(v.$ut.containsRange(re.range,ee.range)&&!v.$ut.equalsRange(re.range,ee.range)){re.children?.push(ee),H.push(ee);break}H.pop()}}return F}}class ${constructor(j,F,H,G,ee,re){this.f=j,this.g=F,this.h=H,this.j=G,this.k=ee,this.l=re,this.d=new t.$$kc("CodeLens"),this.e=new Map}async provideCodeLenses(j,F){const H=this.f.getDocument(j),G=await this.h.provideCodeLenses(H,F);if(!G||F.isCancellationRequested)return;const ee=this.d.add(G),re=new w.$Uc;this.e.set(ee,re);const Me={cacheId:ee,lenses:[]};for(let Be=0;Be<G.length;Be++)Me.lenses.push({cacheId:[ee,Be],range:n.Range.from(G[Be].range),command:this.g.toInternal(G[Be].command,re)});return Me}async resolveCodeLens(j,F){const H=j.cacheId&&this.d.get(...j.cacheId);if(!H)return;let G;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.h.resolveCodeLens(H,F),G||(G=H),F.isCancellationRequested)return;const ee=j.cacheId&&this.e.get(j.cacheId[0]);if(ee){if(!G.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return j.command=this.g.toInternal(G.command,ee),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function u(Ue){return Array.isArray(Ue)?Ue.map(n.DefinitionLink.from):Ue?[n.DefinitionLink.from(Ue)]:[]}class S{constructor(j,F){this.d=j,this.e=F}async provideDefinition(j,F,H){const G=this.d.getDocument(j),ee=n.Position.to(F),re=await this.e.provideDefinition(G,ee,H);return u(re)}}class h{constructor(j,F){this.d=j,this.e=F}async provideDeclaration(j,F,H){const G=this.d.getDocument(j),ee=n.Position.to(F),re=await this.e.provideDeclaration(G,ee,H);return u(re)}}class b{constructor(j,F){this.d=j,this.e=F}async provideImplementation(j,F,H){const G=this.d.getDocument(j),ee=n.Position.to(F),re=await this.e.provideImplementation(G,ee,H);return u(re)}}class m{constructor(j,F){this.d=j,this.e=F}async provideTypeDefinition(j,F,H){const G=this.d.getDocument(j),ee=n.Position.to(F),re=await this.e.provideTypeDefinition(G,ee,H);return u(re)}}class k{static{this.f=10}constructor(j,F){this.g=j,this.h=F,this.d=0,this.e=new Map}async provideHover(j,F,H,G){const ee=this.g.getDocument(j),re=n.Position.to(F);let Me;if(H&&H.verbosityRequest){const xe=H.verbosityRequest.previousHover.id,et=this.e.get(xe);if(!et)throw new Error(`Hover with id ${xe} not found`);const tt={action:H.verbosityRequest.action,previousHover:et};Me=await this.h.provideHover(ee,re,G,tt)}else Me=await this.h.provideHover(ee,re,G);if(!Me||(0,I.$Kb)(Me.contents))return;Me.range||(Me.range=ee.getWordRangeAtPosition(re)),Me.range||(Me.range=new c.$7M(re,re));const Be=n.Hover.from(Me),He=this.d;if(this.e.size===k.f){const xe=Math.min(...this.e.keys());this.e.delete(xe)}return this.e.set(He,Me),this.d+=1,{...Be,id:He}}releaseHover(j){this.e.delete(j)}}class y{constructor(j,F){this.d=j,this.e=F}async provideEvaluatableExpression(j,F,H){const G=this.d.getDocument(j),ee=n.Position.to(F),re=await this.e.provideEvaluatableExpression(G,ee,H);if(re)return n.EvaluatableExpression.from(re)}}class C{constructor(j,F){this.d=j,this.e=F}async provideInlineValues(j,F,H,G){const ee=this.d.getDocument(j),re=await this.e.provideInlineValues(ee,n.Range.to(F),n.InlineValueContext.to(H),G);if(Array.isArray(re))return re.map(Me=>n.InlineValue.from(Me))}}class P{constructor(j,F){this.d=j,this.e=F}async provideDocumentHighlights(j,F,H){const G=this.d.getDocument(j),ee=n.Position.to(F),re=await this.e.provideDocumentHighlights(G,ee,H);if(Array.isArray(re))return re.map(n.DocumentHighlight.from)}}class W{constructor(j,F){this.d=j,this.e=F}async provideMultiDocumentHighlights(j,F,H,G){const ee=this.d.getDocument(j),re=H.map(He=>this.d.getDocument(He)),Me=n.Position.to(F),Be=await this.e.provideMultiDocumentHighlights(ee,Me,re,G);if(Array.isArray(Be))return Be.map(n.MultiDocumentHighlight.from)}}class V{constructor(j,F){this.d=j,this.e=F}async provideLinkedEditingRanges(j,F,H){const G=this.d.getDocument(j),ee=n.Position.to(F),re=await this.e.provideLinkedEditingRanges(G,ee,H);if(re&&Array.isArray(re.ranges))return{ranges:(0,I.$Hb)(re.ranges.map(n.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(j,F){this.d=j,this.e=F}async provideReferences(j,F,H,G){const ee=this.d.getDocument(j),re=n.Position.to(F),Me=await this.e.provideReferences(ee,re,H,G);if(Array.isArray(Me))return Me.map(n.location.from)}}class N{static{this.d=1e3}constructor(j,F,H,G,ee,re,Me){this.g=j,this.h=F,this.j=H,this.k=G,this.l=ee,this.m=re,this.n=Me,this.e=new t.$$kc("CodeAction"),this.f=new Map}async provideCodeActions(j,F,H,G){const ee=this.g.getDocument(j),re=g.$wt.isISelection(F)?n.Selection.to(F):n.Range.to(F),Me=[];for(const tt of this.j.getDiagnostics(j))if(re.intersection(tt.range)&&Me.push(tt)>N.d)break;const Be={diagnostics:Me,only:H.only?new c.$oN(H.only):void 0,triggerKind:n.CodeActionTriggerKind.to(H.trigger)},He=await this.k.provideCodeActions(ee,re,Be,G);if(!(0,I.$Lb)(He)||G.isCancellationRequested)return;const _e=this.e.add(He),xe=new w.$Uc;this.f.set(_e,xe);const et=[];for(let tt=0;tt<He.length;tt++){const it=He[tt];if(it)if(N.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,xe)});else{Be.only&&(it.kind?Be.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=it.ranges??[];et.push({cacheId:[_e,tt],title:it.title,command:it.command&&this.h.toInternal(it.command,xe),diagnostics:it.diagnostics&&it.diagnostics.map(n.Diagnostic.from),edit:it.edit&&n.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,l.$HG)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,l.$HG)(this.m,"codeActionRanges")?(0,I.$Hb)(at.map(n.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:_e,actions:et}}async resolveCodeAction(j,F){const[H,G]=j,ee=this.e.get(H,G);if(!ee||N.o(ee))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(ee,F)??ee;let Me;re.edit&&(Me=n.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const He=this.f.get(H);He&&(Be=this.h.toInternal(re.command,He))}return{edit:Me,command:Be}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class U{constructor(j,F,H,G,ee){this.e=j,this.f=F,this.g=H,this.h=G,this.j=ee,this.d=new t.$$kc("DocumentPasteEdit")}async prepareDocumentPaste(j,F,H,G){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(j),re=F.map(He=>n.Range.to(He)),Me=n.DataTransfer.toDataTransfer(H,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(ee,re,Me,G),G.isCancellationRequested)return;const Be=Array.from(Me).filter(([,He])=>!(He instanceof c.$UN));return n.DataTransfer.from(Be)}async providePasteEdits(j,F,H,G,ee,re){if(!this.g.provideDocumentPasteEdits)return[];const Me=this.f.getDocument(F),Be=H.map(et=>n.Range.to(et)),He=n.DataTransfer.toDataTransfer(G,async et=>(await this.e.$resolvePasteFileData(this.h,j,et)).buffer),_e=await this.g.provideDocumentPasteEdits(Me,Be,He,{only:ee.only?new c.$ZN(ee.only):void 0,triggerKind:ee.triggerKind},re);if(!_e||re.isCancellationRequested)return[];const xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,F){const[H,G]=j,ee=this.d.get(H,G);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(ee,F)??ee;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class K{constructor(j,F){this.d=j,this.e=F}async provideDocumentFormattingEdits(j,F,H){const G=this.d.getDocument(j),ee=await this.e.provideDocumentFormattingEdits(G,F,H);if(Array.isArray(ee))return ee.map(n.TextEdit.from)}}class ie{constructor(j,F){this.d=j,this.e=F}async provideDocumentRangeFormattingEdits(j,F,H,G){const ee=this.d.getDocument(j),re=n.Range.to(F),Me=await this.e.provideDocumentRangeFormattingEdits(ee,re,H,G);if(Array.isArray(Me))return Me.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,F,H,G){(0,D.$gg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(j),re=F.map(n.Range.to),Me=await this.e.provideDocumentRangesFormattingEdits(ee,re,H,G);if(Array.isArray(Me))return Me.map(n.TextEdit.from)}}class ce{constructor(j,F){this.d=j,this.e=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,F,H,G,ee){const re=this.d.getDocument(j),Me=n.Position.to(F),Be=await this.e.provideOnTypeFormattingEdits(re,Me,H,G,ee);if(Array.isArray(Be))return Be.map(n.TextEdit.from)}}class ye{constructor(j,F){this.e=j,this.f=F,this.d=new t.$$kc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,F){const H=await this.e.provideWorkspaceSymbols(j,F);if(!(0,I.$Lb)(H))return{symbols:[]};const G=this.d.add(H),ee={cacheId:G,symbols:[]};for(let re=0;re<H.length;re++){const Me=H[re];if(!Me||!Me.name){this.f.warn("INVALID SymbolInformation",Me);continue}ee.symbols.push({...n.WorkspaceSymbol.from(Me),cacheId:[G,re]})}return ee}async resolveWorkspaceSymbol(j,F){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const H=this.d.get(...j.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,F);return G&&(0,p.$6n)(j,n.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class Se{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,F,H){this.d=j,this.e=F,this.f=H}async provideRenameEdits(j,F,H,G){const ee=this.d.getDocument(j),re=n.Position.to(F);try{const Me=await this.e.provideRenameEdits(ee,re,H,G);return Me?n.WorkspaceEdit.from(Me):void 0}catch(Me){const Be=Se.g(Me);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Me)}}async resolveRenameLocation(j,F,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(j),ee=n.Position.to(F);try{const re=await this.e.prepareRename(G,ee,H);let Me,Be;if(c.$7M.isRange(re)?(Me=re,Be=G.getText(re)):(0,D.$$f)(re)&&(Me=re.range,Be=re.placeholder),!Me||!Be)return;if(Me.start.line>ee.line||Me.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Me),text:Be}}catch(re){const Me=Se.g(re);return Me?{rejectReason:Me,range:void 0,text:void 0}:Promise.reject(re)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class fe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(j,F,H){this.e=j,this.f=F,this.g=H}async provideNewSymbolNames(j,F,H,G){const ee=this.e.getDocument(j),re=n.Range.to(F);try{const Me=fe.d[H],Be=await this.f.provideNewSymbolNames(ee,re,Me,G);return Be?Be.map(He=>typeof He=="string"?{newSymbolName:He}:{newSymbolName:He.newSymbolName,tags:He.tags}):void 0}catch(Me){this.g.error(fe.h(Me)??JSON.stringify(Me,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class $e{constructor(j,F){this.resultId=j,this.tokens=F}}class Te{constructor(j,F){this.f=j,this.g=F,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,F,H){const G=this.f.getDocument(j),ee=F!==0?this.d.get(F):null;let re=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,ee.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return ee&&this.d.delete(F),re?(re=Te.h(re),this.o(Te.n(ee,re),re)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return Te.j(j)?Te.k(j)?j:new c.$nO(new Uint32Array(j.data),j.resultId):Te.l(j)?Te.m(j)?j:new c.$pO(j.edits.map(F=>new c.$oO(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const F of j.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static n(j,F){if(!Te.j(F)||!j||!j.tokens)return F;const H=j.tokens,G=H.length,ee=F.data,re=ee.length;let Me=0;const Be=Math.min(G,re);for(;Me<Be&&H[Me]===ee[Me];)Me++;if(Me===G&&Me===re)return new c.$pO([],F.resultId);let He=0;const _e=Be-Me;for(;He<_e&&H[G-He-1]===ee[re-He-1];)He++;return new c.$pO([{start:Me,deleteCount:G-Me-He,data:ee.subarray(Me,re-He)}],F.resultId)}o(j,F){if(Te.j(j)){const H=this.e++;return this.d.set(H,new $e(j.resultId,j.data)),(0,o.$0bb)({id:H,type:"full",data:j.data})}if(Te.l(j)){const H=this.e++;return Te.j(F)?this.d.set(H,new $e(F.resultId,F.data)):this.d.set(H,new $e(j.resultId)),(0,o.$0bb)({id:H,type:"delta",deltas:(j.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class ae{constructor(j,F){this.d=j,this.e=F}async provideDocumentRangeSemanticTokens(j,F,H){const G=this.d.getDocument(j),ee=await this.e.provideDocumentRangeSemanticTokens(G,n.Range.to(F),H);return ee?this.f(ee):null}f(j){return(0,o.$0bb)({id:0,type:"full",data:j.data})}}class Ne{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,F,H,G,ee){this.f=j,this.g=F,this.h=H,this.j=G,this.k=ee,this.d=new t.$$kc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,F,H,G){const ee=this.f.getDocument(j),re=n.Position.to(F),Me=ee.getWordRangeAtPosition(re)||new c.$7M(re,re),Be=Me.with({end:re}),He=new E.$ae,_e=await this.h.provideCompletionItems(ee,re,G,n.CompletionContext.to(H));if(!_e||G.isCancellationRequested)return;const xe=Array.isArray(_e)?new c.$BN(_e):_e,et=Ne.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),tt=new w.$Uc;this.e.set(et,tt);const it=[],at={x:et,b:it,a:{replace:n.Range.from(Me),insert:n.Range.from(Be)},c:xe.isIncomplete||void 0,d:He.elapsed()};for(let gt=0;gt<xe.items.length;gt++){const je=xe.items[gt],st=this.l(je,[et,gt],Be,Me);it.push(st)}return at}async resolveCompletionItem(j,F){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...j);if(!H)return;const G=this.l(H,j),ee=await this.h.resolveCompletionItem(H,F);if(!ee)return;const re=this.l(ee,j);return(G.h!==re.h||G.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G.n!==re.n||G.o!==re.o||!(0,p.$7n)(G.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,F,H,G){const ee=this.e.get(F[0]);if(!ee)throw Error("DisposableStore is missing...");const re=this.g.toInternal(j.command,ee),Me={x:F,a:j.label,b:j.kind!==void 0?n.CompletionItemKind.from(j.kind):void 0,m:j.tags&&j.tags.map(n.CompletionItemTag.from),c:j.detail,d:typeof j.documentation>"u"?void 0:n.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters?.join(""),l:j.additionalTextEdits&&j.additionalTextEdits.map(n.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Me.h=j.textEdit.newText):typeof j.insertText=="string"?Me.h=j.insertText:j.insertText instanceof c.$dN&&(Me.h=j.insertText.value,Me.i|=4);let Be;return j.textEdit?Be=j.textEdit.range:j.range&&(Be=j.range),c.$7M.isRange(Be)?Me.j=n.Range.from(Be):Be&&(!H?.isEqual(Be.inserting)||!G?.isEqual(Be.replacing))&&(Me.j={insert:n.Range.from(Be.inserting),replace:n.Range.from(Be.replacing)}),Me}}class ne{async provideInlineCompletions(j,F,H,G){}disposeCompletions(j){}handleDidShowCompletionItem(j,F,H){}handlePartialAccept(j,F,H,G){}}class z extends ne{constructor(j,F,H,G){super(),this.f=j,this.g=F,this.h=H,this.j=G,this.d=new ve,this.e=(0,l.$HG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,l.$HG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,F,H,G){const ee=this.g.getDocument(j),re=n.Position.to(F),Me=await this.h.provideInlineCompletionItems(ee,re,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:n.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!Me||G.isCancellationRequested)return;const Be=Array.isArray(Me)?Me:Me.items,He=this.e?Array.isArray(Me)?[]:Me.commands||[]:[],_e=this.e&&!Array.isArray(Me)?Me.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((tt,it)=>{let at;tt.command&&(xe||(xe=new w.$Uc),at=this.j.toInternal(tt.command,xe));const gt=tt.insertText;return{insertText:typeof gt=="string"?gt:{snippet:gt.value},filterText:tt.filterText,range:tt.range?n.Range.from(tt.range):void 0,command:at,idx:it,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:He.map(tt=>(xe||(xe=new w.$Uc),this.j.toInternal(tt,xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,F,H){const G=this.d.get(j)?.items[F];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G,H)}handlePartialAccept(j,F,H,G){const ee=this.d.get(j)?.items[F];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,H),this.h.handleDidPartiallyAcceptCompletionItem(ee,n.PartialAcceptInfo.to(G)))}}class x{async provideInlineEdits(j,F,H){const G=this.f.getDocument(j),ee=await this.g.provideInlineEdit(G,{triggerKind:this.e[F.triggerKind]},H);if(!ee||H.isCancellationRequested)return;let re;const Me=this.d.createReferenceId({dispose(){re?.dispose()},item:ee});let Be;ee.accepted&&(re||(re=new w.$Uc),Be=this.h.toInternal(ee.accepted,re));let He;return ee.rejected&&(re||(re=new w.$Uc),He=this.h.toInternal(ee.rejected,re)),{pid:Me,text:ee.text,range:n.Range.from(ee.range),accepted:Be,rejected:He}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,F,H,G){this.f=F,this.g=H,this.h=G,this.d=new ve,this.e={[r.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const F=this.e++;return this.d.set(F,j),F}disposeReferenceId(j){const F=this.d.get(j);return this.d.delete(j),F}get(j){return this.d.get(j)}}class Fe{constructor(j,F){this.e=j,this.f=F,this.d=new t.$$kc("SignatureHelp")}async provideSignatureHelp(j,F,H,G){const ee=this.e.getDocument(j),re=n.Position.to(F),Me=this.g(H),Be=await this.f.provideSignatureHelp(ee,re,G,Me);if(Be){const He=this.d.add([Be]);return{...n.SignatureHelp.from(Be),id:He}}}g(j){let F;if(j.activeSignatureHelp){const H=n.SignatureHelp.to(j.activeSignatureHelp),G=this.d.get(j.activeSignatureHelp.id,0);G?(F=G,F.activeSignature=H.activeSignature,F.activeParameter=H.activeParameter):F=H}return{...j,activeSignatureHelp:F}}releaseSignatureHelp(j){this.d.delete(j)}}class De{constructor(j,F,H,G,ee){this.f=j,this.g=F,this.h=H,this.j=G,this.k=ee,this.d=new t.$$kc("InlayHints"),this.e=new Map}async provideInlayHints(j,F,H){const G=this.f.getDocument(j),ee=n.Range.to(F),re=await this.h.provideInlayHints(G,ee,H);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`);return}if(H.isCancellationRequested)return;const Me=this.d.add(re);this.e.set(Me,new w.$Uc);const Be={hints:[],cacheId:Me};for(let He=0;He<re.length;He++)this.l(re[He],ee)&&Be.hints.push(this.m(re[He],[Me,He]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`),Be}async resolveInlayHint(j,F){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...j);if(!H)return;const G=await this.h.resolveInlayHint(H,F);if(G&&this.l(G))return this.m(G,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,F){return j.label.length===0||Array.isArray(j.label)&&j.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(F&&!F.contains(j.position))}m(j,F){const H=this.e.get(F[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:F,tooltip:n.MarkdownString.fromStrict(j.tooltip),position:n.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(n.TextEdit.from),kind:j.kind&&n.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")G.label=j.label;else{const ee=[];G.label=ee;for(const re of j.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Me={label:re.value,tooltip:n.MarkdownString.fromStrict(re.tooltip)};c.$eN.isLocation(re.location)&&(Me.location=n.location.from(re.location)),re.command&&(Me.command=this.g.toInternal(re.command,H)),ee.push(Me)}}return G}}class we{constructor(j,F){this.e=j,this.f=F,this.d=new t.$$kc("DocumentLink")}async provideLinks(j,F){const H=this.e.getDocument(j),G=await this.f.provideDocumentLinks(H,F);if(!(!Array.isArray(G)||G.length===0)&&!F.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(we.g).map(n.DocumentLink.from)};{const ee=this.d.add(G),re={links:[],cacheId:ee};for(let Me=0;Me<G.length;Me++){if(!we.g(G[Me]))continue;const Be=n.DocumentLink.from(G[Me]);Be.cacheId=[ee,Me],re.links.push(Be)}return re}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,F){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...j);if(!H)return;const G=await this.f.resolveDocumentLink(H,F);if(!(!G||!we.g(G)))return n.DocumentLink.from(G)}releaseLinks(j){this.d.delete(j)}}class ge{constructor(j,F){this.d=j,this.e=F}async provideColors(j,F){const H=this.d.getDocument(j),G=await this.e.provideDocumentColors(H,F);return Array.isArray(G)?G.map(re=>({color:n.Color.from(re.color),range:n.Range.from(re.range)})):[]}async provideColorPresentations(j,F,H){const G=this.d.getDocument(j),ee=n.Range.to(F.range),re=n.Color.to(F.color),Me=await this.e.provideColorPresentations(re,{document:G,range:ee},H);if(Array.isArray(Me))return Me.map(n.ColorPresentation.from)}}class Q{constructor(j,F){this.d=j,this.e=F}async provideFoldingRanges(j,F,H){const G=this.d.getDocument(j),ee=await this.e.provideFoldingRanges(G,F,H);if(Array.isArray(ee))return ee.map(n.FoldingRange.from)}}class Y{constructor(j,F,H){this.d=j,this.e=F,this.f=H}async provideSelectionRanges(j,F,H){const G=this.d.getDocument(j),ee=F.map(n.Position.to),re=await this.e.provideSelectionRanges(G,ee,H);if(!(0,I.$Lb)(re))return[];if(re.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Me=[];for(let Be=0;Be<ee.length;Be++){const He=[];Me.push(He);let _e=ee[Be],xe=re[Be];for(;;){if(!xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(He.push(n.SelectionRange.from(xe)),!xe.parent)break;_e=xe.range,xe=xe.parent}}return Me}}class he{constructor(j,F){this.f=j,this.g=F,this.d=new R.$vP(""),this.e=new Map}async prepareSession(j,F,H){const G=this.f.getDocument(j),ee=n.Position.to(F),re=await this.g.prepareCallHierarchy(G,ee,H);if(!re)return;const Me=this.d.nextId();return this.e.set(Me,new Map),Array.isArray(re)?re.map(Be=>this.h(Me,Be)):[this.h(Me,re)]}async provideCallsTo(j,F,H){const G=this.j(j,F);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(G,H);if(ee)return ee.map(re=>({from:this.h(j,re.from),fromRanges:re.fromRanges.map(Me=>n.Range.from(Me))}))}async provideCallsFrom(j,F,H){const G=this.j(j,F);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(ee)return ee.map(re=>({to:this.h(j,re.to),fromRanges:re.fromRanges.map(Me=>n.Range.from(Me))}))}releaseSession(j){this.e.delete(j)}h(j,F){const H=this.e.get(j),G=n.CallHierarchyItem.from(F,j,H.size.toString(36));return H.set(G._itemId,F),G}j(j,F){return this.e.get(j)?.get(F)}}class ue{constructor(j,F){this.f=j,this.g=F,this.d=new R.$vP(""),this.e=new Map}async prepareSession(j,F,H){const G=this.f.getDocument(j),ee=n.Position.to(F),re=await this.g.prepareTypeHierarchy(G,ee,H);if(!re)return;const Me=this.d.nextId();return this.e.set(Me,new Map),Array.isArray(re)?re.map(Be=>this.h(Me,Be)):[this.h(Me,re)]}async provideSupertypes(j,F,H){const G=this.j(j,F);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(G,H);if(ee)return ee.map(re=>this.h(j,re))}async provideSubtypes(j,F,H){const G=this.j(j,F);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(G,H);if(ee)return ee.map(re=>this.h(j,re))}releaseSession(j){this.e.delete(j)}h(j,F){const H=this.e.get(j),G=n.TypeHierarchyItem.from(F,j,H.size.toString(36));return H.set(G._itemId,F),G}j(j,F){return this.e.get(j)?.get(F)}}class Oe{constructor(j,F,H,G,ee){this.e=j,this.f=F,this.g=H,this.h=G,this.j=ee,this.d=new t.$$kc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,F,H,G,ee){const re=this.f.getDocument(F),Me=n.Position.to(H),Be=n.DataTransfer.toDataTransfer(G,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,et)).buffer),He=await this.g.provideDocumentDropEdits(re,Me,Be,ee);if(!He)return;const _e=(0,I.$3b)(He),xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,s.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,F){const[H,G]=j,ee=this.d.get(H,G);if(!ee||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(ee,F)??ee;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class de{constructor(j,F){this.d=j,this.e=F}async provideMappedEdits(j,F,H,G){const ee=d.URI.revive(j),re=this.d.getDocument(ee),Me=H.documents.map(_e=>_e.map(xe=>({uri:d.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(et=>n.Range.to(et))}))),Be={documents:Me,selections:Me[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(re,F,Be,G);return He?n.WorkspaceEdit.from(He):null}}class Ce{constructor(j,F){this.adapter=j,this.extension=F}}class Ae{static{this.d=0}constructor(j,F,H,G,ee,re,Me,Be){this.g=F,this.h=H,this.j=G,this.k=ee,this.l=re,this.m=Me,this.n=Be,this.f=new Map,this.e=j.getProxy(f.$3M.MainThreadLanguageFeatures)}o(j,F){return n.DocumentSelector.from(j,this.g,F)}p(j){return new c.$5M(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Ae.d++}async s(j,F,H,G,ee,re=!1){const Me=this.f.get(j);if(!Me||!(Me.adapter instanceof F))return G;const Be=Date.now();re||this.l.trace(`[${Me.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const He=H(Me.adapter,Me.extension);return Promise.resolve(He).catch(_e=>{(0,O.$4)(_e)||(this.l.error(`[${Me.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Me.extension.identifier,_e))}).finally(()=>{re||this.l.trace(`[${Me.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),A.CancellationToken.isCancellationToken(ee)?(0,M.$lh)(He,ee):He}t(j,F){const H=this.q();return this.f.set(H,new Ce(j,F)),H}static u(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,F,H,G){const ee=this.t(new a(this.h,H),j),re=G&&G.label||Ae.u(j);return this.e.$registerDocumentSymbolProvider(ee,this.o(F,j),re),this.p(ee)}$provideDocumentSymbols(j,F,H){return this.s(j,a,G=>G.provideDocumentSymbols(d.URI.revive(F),H),void 0,H)}registerCodeLensProvider(j,F,H){const G=this.q(),ee=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new Ce(new $(this.h,this.j.converter,H,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(G,this.o(F,j),ee);let re=this.p(G);if(ee!==void 0){const Me=H.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));re=c.$5M.from(re,Me)}return re}$provideCodeLenses(j,F,H){return this.s(j,$,G=>G.provideCodeLenses(d.URI.revive(F),H),void 0,H)}$resolveCodeLens(j,F,H){return this.s(j,$,G=>G.resolveCodeLens(F,H),void 0,void 0)}$releaseCodeLenses(j,F){this.s(j,$,H=>Promise.resolve(H.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(j,F,H){const G=this.t(new S(this.h,H),j);return this.e.$registerDefinitionSupport(G,this.o(F,j)),this.p(G)}$provideDefinition(j,F,H,G){return this.s(j,S,ee=>ee.provideDefinition(d.URI.revive(F),H,G),[],G)}registerDeclarationProvider(j,F,H){const G=this.t(new h(this.h,H),j);return this.e.$registerDeclarationSupport(G,this.o(F,j)),this.p(G)}$provideDeclaration(j,F,H,G){return this.s(j,h,ee=>ee.provideDeclaration(d.URI.revive(F),H,G),[],G)}registerImplementationProvider(j,F,H){const G=this.t(new b(this.h,H),j);return this.e.$registerImplementationSupport(G,this.o(F,j)),this.p(G)}$provideImplementation(j,F,H,G){return this.s(j,b,ee=>ee.provideImplementation(d.URI.revive(F),H,G),[],G)}registerTypeDefinitionProvider(j,F,H){const G=this.t(new m(this.h,H),j);return this.e.$registerTypeDefinitionSupport(G,this.o(F,j)),this.p(G)}$provideTypeDefinition(j,F,H,G){return this.s(j,m,ee=>ee.provideTypeDefinition(d.URI.revive(F),H,G),[],G)}registerHoverProvider(j,F,H,G){const ee=this.t(new k(this.h,H),j);return this.e.$registerHoverProvider(ee,this.o(F,j)),this.p(ee)}$provideHover(j,F,H,G,ee){return this.s(j,k,re=>re.provideHover(d.URI.revive(F),H,G,ee),void 0,ee)}$releaseHover(j,F){this.s(j,k,H=>Promise.resolve(H.releaseHover(F)),void 0,void 0)}registerEvaluatableExpressionProvider(j,F,H,G){const ee=this.t(new y(this.h,H),j);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(F,j)),this.p(ee)}$provideEvaluatableExpression(j,F,H,G){return this.s(j,y,ee=>ee.provideEvaluatableExpression(d.URI.revive(F),H,G),void 0,G)}registerInlineValuesProvider(j,F,H,G){const ee=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new C(this.h,H),j);this.e.$registerInlineValuesProvider(re,this.o(F,j),ee);let Me=this.p(re);if(ee!==void 0){const Be=H.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(ee));Me=c.$5M.from(Me,Be)}return Me}$provideInlineValues(j,F,H,G,ee){return this.s(j,C,re=>re.provideInlineValues(d.URI.revive(F),H,G,ee),void 0,ee)}registerDocumentHighlightProvider(j,F,H){const G=this.t(new P(this.h,H),j);return this.e.$registerDocumentHighlightProvider(G,this.o(F,j)),this.p(G)}registerMultiDocumentHighlightProvider(j,F,H){const G=this.t(new W(this.h,H),j);return this.e.$registerMultiDocumentHighlightProvider(G,this.o(F,j)),this.p(G)}$provideDocumentHighlights(j,F,H,G){return this.s(j,P,ee=>ee.provideDocumentHighlights(d.URI.revive(F),H,G),void 0,G)}$provideMultiDocumentHighlights(j,F,H,G,ee){return this.s(j,W,re=>re.provideMultiDocumentHighlights(d.URI.revive(F),H,G.map(Me=>d.URI.revive(Me)),ee),void 0,ee)}registerLinkedEditingRangeProvider(j,F,H){const G=this.t(new V(this.h,H),j);return this.e.$registerLinkedEditingRangeProvider(G,this.o(F,j)),this.p(G)}$provideLinkedEditingRanges(j,F,H,G){return this.s(j,V,async ee=>{const re=await ee.provideLinkedEditingRanges(d.URI.revive(F),H,G);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Ae.w(re.wordPattern):void 0}},void 0,G)}registerReferenceProvider(j,F,H){const G=this.t(new q(this.h,H),j);return this.e.$registerReferenceSupport(G,this.o(F,j)),this.p(G)}$provideReferences(j,F,H,G,ee){return this.s(j,q,re=>re.provideReferences(d.URI.revive(F),H,G,ee),void 0,ee)}registerCodeActionProvider(j,F,H,G){const ee=new w.$Uc,re=this.t(new N(this.h,this.j.converter,this.k,H,this.l,j,this.m),j);return this.e.$registerQuickFixSupport(re,this.o(F,j),{providedKinds:G?.providedCodeActionKinds?.map(Me=>Me.value),documentation:G?.documentation?.map(Me=>({kind:Me.kind.value,command:this.j.converter.toInternal(Me.command,ee)}))},Ae.u(j),!!H.resolveCodeAction),ee.add(this.p(re)),ee}$provideCodeActions(j,F,H,G,ee){return this.s(j,N,re=>re.provideCodeActions(d.URI.revive(F),H,G,ee),void 0,ee)}$resolveCodeAction(j,F,H){return this.s(j,N,G=>G.resolveCodeAction(F,H),{},void 0)}$releaseCodeActions(j,F){this.s(j,N,H=>Promise.resolve(H.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(j,F,H){const G=this.t(new K(this.h,H),j);return this.e.$registerDocumentFormattingSupport(G,this.o(F,j),j.identifier,j.displayName||j.name),this.p(G)}$provideDocumentFormattingEdits(j,F,H,G){return this.s(j,K,ee=>ee.provideDocumentFormattingEdits(d.URI.revive(F),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(j,F,H){const G=typeof H.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,H),j);return this.e.$registerRangeFormattingSupport(ee,this.o(F,j),j.identifier,j.displayName||j.name,G),this.p(ee)}$provideDocumentRangeFormattingEdits(j,F,H,G,ee){return this.s(j,ie,re=>re.provideDocumentRangeFormattingEdits(d.URI.revive(F),H,G,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(j,F,H,G,ee){return this.s(j,ie,re=>re.provideDocumentRangesFormattingEdits(d.URI.revive(F),H,G,ee),void 0,ee)}registerOnTypeFormattingEditProvider(j,F,H,G){const ee=this.t(new ce(this.h,H),j);return this.e.$registerOnTypeFormattingSupport(ee,this.o(F,j),G,j.identifier),this.p(ee)}$provideOnTypeFormattingEdits(j,F,H,G,ee,re){return this.s(j,ce,Me=>Me.provideOnTypeFormattingEdits(d.URI.revive(F),H,G,ee,re),void 0,re)}registerWorkspaceSymbolProvider(j,F){const H=this.t(new ye(F,this.l),j);return this.e.$registerNavigateTypeSupport(H,typeof F.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(j,F,H){return this.s(j,ye,G=>G.provideWorkspaceSymbols(F,H),{symbols:[]},H)}$resolveWorkspaceSymbol(j,F,H){return this.s(j,ye,G=>G.resolveWorkspaceSymbol(F,H),void 0,void 0)}$releaseWorkspaceSymbols(j,F){this.s(j,ye,H=>H.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(j,F,H){const G=this.t(new Se(this.h,H,this.l),j);return this.e.$registerRenameSupport(G,this.o(F,j),Se.supportsResolving(H)),this.p(G)}$provideRenameEdits(j,F,H,G,ee){return this.s(j,Se,re=>re.provideRenameEdits(d.URI.revive(F),H,G,ee),void 0,ee)}$resolveRenameLocation(j,F,H,G){return this.s(j,Se,ee=>ee.resolveRenameLocation(d.URI.revive(F),H,G),void 0,G)}registerNewSymbolNamesProvider(j,F,H){const G=this.t(new fe(this.h,H,this.l),j);return this.e.$registerNewSymbolNamesProvider(G,this.o(F,j)),this.p(G)}$provideNewSymbolNames(j,F,H,G,ee){return this.s(j,fe,re=>re.provideNewSymbolNames(d.URI.revive(F),H,G,ee),void 0,ee)}registerDocumentSemanticTokensProvider(j,F,H,G){const ee=this.t(new Te(this.h,H),j),re=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(F,j),G,re);let Me=this.p(ee);if(re){const Be=H.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(re));Me=c.$5M.from(Me,Be)}return Me}$provideDocumentSemanticTokens(j,F,H,G){return this.s(j,Te,ee=>ee.provideDocumentSemanticTokens(d.URI.revive(F),H,G),null,G)}$releaseDocumentSemanticTokens(j,F){this.s(j,Te,H=>H.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,F,H,G){const ee=this.t(new ae(this.h,H),j);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(F,j),G),this.p(ee)}$provideDocumentRangeSemanticTokens(j,F,H,G){return this.s(j,ae,ee=>ee.provideDocumentRangeSemanticTokens(d.URI.revive(F),H,G),null,G)}registerCompletionItemProvider(j,F,H,G){const ee=this.t(new Ne(this.h,this.j.converter,H,this.m,j),j);return this.e.$registerCompletionsProvider(ee,this.o(F,j),G,Ne.supportsResolving(H),j.identifier),this.p(ee)}$provideCompletionItems(j,F,H,G,ee){return this.s(j,Ne,re=>re.provideCompletionItems(d.URI.revive(F),H,G,ee),void 0,ee)}$resolveCompletionItem(j,F,H){return this.s(j,Ne,G=>G.resolveCompletionItem(F,H),void 0,H)}$releaseCompletionItems(j,F){this.s(j,Ne,H=>H.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(j,F,H,G){const ee=new z(j,this.h,H,this.j.converter),re=this.t(ee,j);return this.e.$registerInlineCompletionsSupport(re,this.o(F,j),ee.supportsHandleEvents,i.$Rm.toKey(j.identifier.value),G?.yieldTo?.map(Me=>i.$Rm.toKey(Me))||[]),this.p(re)}$provideInlineCompletions(j,F,H,G,ee){return this.s(j,ne,re=>re.provideInlineCompletions(d.URI.revive(F),H,G,ee),void 0,ee)}$handleInlineCompletionDidShow(j,F,H,G){this.s(j,ne,async ee=>{ee.handleDidShowCompletionItem(F,H,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,F,H,G,ee){this.s(j,ne,async re=>{re.handlePartialAccept(F,H,G,ee)},void 0,void 0)}$freeInlineCompletionsList(j,F){this.s(j,ne,async H=>{H.disposeCompletions(F)},void 0,void 0)}registerInlineEditProvider(j,F,H){const G=new x(j,this.h,H,this.j.converter),ee=this.t(G,j);return this.e.$registerInlineEditProvider(ee,this.o(F,j),j.identifier),this.p(ee)}$provideInlineEdit(j,F,H,G){return this.s(j,x,ee=>ee.provideInlineEdits(d.URI.revive(F),H,G),void 0,G)}$freeInlineEdit(j,F){this.s(j,x,async H=>{H.disposeEdit(F)},void 0,void 0)}registerSignatureHelpProvider(j,F,H,G){const ee=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,re=this.t(new Fe(this.h,H),j);return this.e.$registerSignatureHelpProvider(re,this.o(F,j),ee),this.p(re)}$provideSignatureHelp(j,F,H,G,ee){return this.s(j,Fe,re=>re.provideSignatureHelp(d.URI.revive(F),H,G,ee),void 0,ee)}$releaseSignatureHelp(j,F){this.s(j,Fe,H=>H.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(j,F,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new De(this.h,this.j.converter,H,this.l,j),j);this.e.$registerInlayHintsProvider(ee,this.o(F,j),typeof H.resolveInlayHint=="function",G,Ae.u(j));let re=this.p(ee);if(G!==void 0){const Me=H.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(G));re=c.$5M.from(re,Me)}return re}$provideInlayHints(j,F,H,G){return this.s(j,De,ee=>ee.provideInlayHints(d.URI.revive(F),H,G),void 0,G)}$resolveInlayHint(j,F,H){return this.s(j,De,G=>G.resolveInlayHint(F,H),void 0,H)}$releaseInlayHints(j,F){this.s(j,De,H=>H.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(j,F,H){const G=this.t(new we(this.h,H),j);return this.e.$registerDocumentLinkProvider(G,this.o(F,j),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(j,F,H){return this.s(j,we,G=>G.provideLinks(d.URI.revive(F),H),void 0,H,F.scheme==="output")}$resolveDocumentLink(j,F,H){return this.s(j,we,G=>G.resolveLink(F,H),void 0,void 0,!0)}$releaseDocumentLinks(j,F){this.s(j,we,H=>H.releaseLinks(F),void 0,void 0,!0)}registerColorProvider(j,F,H){const G=this.t(new ge(this.h,H),j);return this.e.$registerDocumentColorProvider(G,this.o(F,j)),this.p(G)}$provideDocumentColors(j,F,H){return this.s(j,ge,G=>G.provideColors(d.URI.revive(F),H),[],H)}$provideColorPresentations(j,F,H,G){return this.s(j,ge,ee=>ee.provideColorPresentations(d.URI.revive(F),H,G),void 0,G)}registerFoldingRangeProvider(j,F,H){const G=this.q(),ee=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new Ce(new Q(this.h,H),j)),this.e.$registerFoldingRangeProvider(G,this.o(F,j),j.identifier,ee);let re=this.p(G);if(ee!==void 0){const Me=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));re=c.$5M.from(re,Me)}return re}$provideFoldingRanges(j,F,H,G){return this.s(j,Q,ee=>ee.provideFoldingRanges(d.URI.revive(F),H,G),void 0,G)}registerSelectionRangeProvider(j,F,H){const G=this.t(new Y(this.h,H,this.l),j);return this.e.$registerSelectionRangeProvider(G,this.o(F,j)),this.p(G)}$provideSelectionRanges(j,F,H,G){return this.s(j,Y,ee=>ee.provideSelectionRanges(d.URI.revive(F),H,G),[],G)}registerCallHierarchyProvider(j,F,H){const G=this.t(new he(this.h,H),j);return this.e.$registerCallHierarchyProvider(G,this.o(F,j)),this.p(G)}$prepareCallHierarchy(j,F,H,G){return this.s(j,he,ee=>Promise.resolve(ee.prepareSession(d.URI.revive(F),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(j,F,H,G){return this.s(j,he,ee=>ee.provideCallsTo(F,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(j,F,H,G){return this.s(j,he,ee=>ee.provideCallsFrom(F,H,G),void 0,G)}$releaseCallHierarchy(j,F){this.s(j,he,H=>Promise.resolve(H.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(j,F,H){const G=this.t(new ue(this.h,H),j);return this.e.$registerTypeHierarchyProvider(G,this.o(F,j)),this.p(G)}$prepareTypeHierarchy(j,F,H,G){return this.s(j,ue,ee=>Promise.resolve(ee.prepareSession(d.URI.revive(F),H,G)),void 0,G)}$provideTypeHierarchySupertypes(j,F,H,G){return this.s(j,ue,ee=>ee.provideSupertypes(F,H,G),void 0,G)}$provideTypeHierarchySubtypes(j,F,H,G){return this.s(j,ue,ee=>ee.provideSubtypes(F,H,G),void 0,G)}$releaseTypeHierarchy(j,F){this.s(j,ue,H=>Promise.resolve(H.releaseSession(F)),void 0,void 0)}registerDocumentOnDropEditProvider(j,F,H,G){const ee=this.q();return this.f.set(ee,new Ce(new Oe(this.e,this.h,H,ee,j),j)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(F,j),(0,l.$HG)(j,"documentPaste")&&G?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:G.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(j,F,H,G,ee,re){return this.s(j,Oe,Me=>Promise.resolve(Me.provideDocumentOnDropEdits(F,d.URI.revive(H),G,ee,re)),void 0,void 0)}$resolveDropEdit(j,F,H){return this.s(j,Oe,G=>G.resolveDropEdit(F,H),{},void 0)}$releaseDropEdits(j,F){this.s(j,Oe,H=>Promise.resolve(H.releaseDropEdits(F)),void 0,void 0)}registerMappedEditsProvider(j,F,H){const G=this.t(new de(this.h,H),j);return this.e.$registerMappedEditsProvider(G,this.o(F,j)),this.p(G)}$provideMappedEdits(j,F,H,G,ee){return this.s(j,de,re=>Promise.resolve(re.provideMappedEdits(F,H,G,ee)),null,ee)}registerDocumentPasteEditProvider(j,F,H,G){const ee=this.q();return this.f.set(ee,new Ce(new U(this.e,this.h,H,ee,j),j)),this.e.$registerPasteEditProvider(ee,this.o(F,j),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:G.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(j,F,H,G,ee){return this.s(j,U,re=>re.prepareDocumentPaste(d.URI.revive(F),H,G,ee),void 0,ee)}$providePasteEdits(j,F,H,G,ee,re,Me){return this.s(j,U,Be=>Be.providePasteEdits(F,d.URI.revive(H),G,ee,re,Me),void 0,Me)}$resolvePasteEdit(j,F,H){return this.s(j,U,G=>G.resolvePasteEdit(F,H),{},void 0)}$releasePasteEdits(j,F){this.s(j,U,H=>Promise.resolve(H.releasePasteEdits(F)),void 0,void 0)}static w(j){return{pattern:j.source,flags:j.flags}}static y(j){return{decreaseIndentPattern:Ae.w(j.decreaseIndentPattern),increaseIndentPattern:Ae.w(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Ae.w(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Ae.w(j.unIndentedLinePattern):void 0}}static z(j){return{beforeText:Ae.w(j.beforeText),afterText:j.afterText?Ae.w(j.afterText):void 0,previousLineText:j.previousLineText?Ae.w(j.previousLineText):void 0,action:j.action}}static B(j){return j.map(Ae.z)}static C(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(F=>c.SyntaxTokenType.toString(F)):void 0}}static D(j){return j.map(Ae.C)}setLanguageConfiguration(j,F,H){const{wordPattern:G}=H;if(G&&(0,T.$kf)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(F,G):this.h.setWordDefinitionFor(F,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ee=this.q(),re={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Ae.w(H.wordPattern):void 0,indentationRules:H.indentationRules?Ae.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Ae.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Ae.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,F,re),this.p(ee)}$setWordDefinitions(j){for(const F of j)this.h.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}e.$ilc=Ae}),define(Ie[90],Pe([1,0,6,4,8,7,103,20,11,5,175,108,14,3,17,86,12,42]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=e.$2lc=void 0,e.$2lc=(0,v.$wi)("IExtHostLanguageModels");class n{constructor(f,a){this.option=f,this.stream=new p.$Zh,this.stream=a??new p.$Zh}}class c{constructor(){this.a=new Map,this.b=new p.$Zh,this.c=!1,this.d=!1;const f=this;this.apiObject={stream:f.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,f]of this.a)yield f.stream;else yield this.b}handleFragment(f){if(this.c)return;this.d=!0;let a=this.a.get(f.index);a||(this.a.size===0?a=new n(f.index,this.b):a=new n(f.index),this.a.set(f.index,a)),a.stream.emitOne(f.part)}get isStreaming(){return this.d}reject(f){this.c=!0;for(const a of this.f())a.reject(f)}resolve(){this.c=!0;for(const f of this.f())f.resolve()}}let l=class{static{i=this}static{this.a=1}constructor(f,a,$){this.j=a,this.k=$,this.c=new E.$ee,this.d=new E.$ee,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new w.$Tm,this.i=new Map,this.o=new Set,this.b=f.getProxy(M.$3M.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(f,a,$,u){const S=i.a++;this.f.set(S,{extension:f.identifier,provider:$,languageModelId:a});let h;u.auth&&(h={providerLabel:f.displayName||f.name,accountLabel:typeof u.auth=="object"?u.auth.label:void 0}),this.b.$registerLanguageModelProvider(S,a,{extension:f.identifier,identifier:a,name:u.name??"",version:u.version,tokens:u.tokens,auth:h});const b=$.onDidReceiveLanguageModelResponse2?.(({extensionId:m,participant:k,tokenCount:y})=>{this.b.$whenLanguageModelChatRequestMade(a,new w.$Rm(m),k,y)});return(0,I.$Tc)(()=>{this.f.delete(S),this.b.$unregisterProvider(S),b?.dispose()})}async $provideLanguageModelResponse(f,a,$,u,S,h){const b=this.f.get(f);if(!b)return;const m=new R.$0v(async k=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${b.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:k.index,part:k.part})});return b.provider.provideLanguageModelResponse2(u.map(A.LanguageModelMessage.to),S,w.$Rm.toKey($),m,h)}$provideTokenLength(f,a,$){const u=this.f.get(f);return u?Promise.resolve(u.provider.provideTokenCount(a,$)):Promise.resolve(0)}$updateLanguageModels(f){const a=[],$=[];if(f.added)for(const u of f.added)this.g.set(u.identifier,u),a.push(u.identifier);if(f.removed)for(const u of f.removed){this.g.delete(u),$.push(u);for(const[S,h]of this.i)h.languageModelId===u&&(h.res.reject(new d.$5),this.i.delete(S))}this.d.fire(Object.freeze({added:Object.freeze(a),removed:Object.freeze($)})),f.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(f){const a=new Array;for(const{from:$,to:u,enabled:S}of f){const h=this.h.get($)??new w.$Sm;if(h.has(u)!==S){S?h.add(u):h.delete(u),this.h.set($,h);const m={from:$,to:u};a.push(m),this.c.fire(m)}}}async sendChatRequest(f,a,$,u,S){const h=f.identifier,b=await this.b.$prepareChatAccess(h,a,u.justification);if(!b||!this.g.has(a))throw O.$dP.NotFound(`Language model '${a}' is unknown.`);if(this.m(h,b)&&(!await this.l(f,{identifier:b.extension,displayName:b.auth.providerLabel},u.justification,u.silent)||!this.h.get(h)?.has(b.extension)))throw O.$dP.NoPermissions(`Language model '${a}' cannot be used by '${h.value}'.`);const m=Math.random()*1e6|0,k=this.b.$fetchResponse(h,a,m,$.map(A.LanguageModelMessage.from),u.modelOptions??{},S),y=new p.$vh,C=new c;this.i.set(m,{languageModelId:a,res:C});let P;if(k.catch(W=>{y.isOpen()?C.reject(W):P=W}).finally(()=>{this.i.delete(m),C.resolve(),y.open()}),await y.wait(),P)throw new O.$dP(`Language model '${a}' errored, check cause for more details`,"Unknown",P);return C.apiObject}async $handleResponseFragment(f,a){const $=this.i.get(f);$&&$.res.handleFragment(a)}async l(f,a,$,u){const S=D.$5L+a.identifier.value;if(await this.k.getSession(f,S,[],{silent:!0}))return this.$updateModelAccesslist([{from:f.identifier,to:a.identifier,enabled:!0}]),!0;if(u)return!1;try{const b=$?(0,T.localize)(0,null,a.displayName,$):(0,T.localize)(1,null,a.displayName);return await this.k.getSession(f,S,[],{forceNewSession:{detail:b}}),this.$updateModelAccesslist([{from:f.identifier,to:a.identifier,enabled:!0}]),!0}catch{return!1}}m(f,a){return!!a.auth&&!w.$Rm.equals(a.extension,f)}async n(f){for(const a of this.o)try{await this.l(a,{identifier:f.extension,displayName:""},void 0,!0)}catch($){this.j.error("Fake Auth request failed"),this.j.error($)}}async computeTokenLength(f,a,$){const u=this.g.get(f);if(!u)throw O.$dP.NotFound(`Language model '${f}' is unknown.`);const S=s.Iterable.find(this.f.values(),h=>h.languageModelId===f);return S?S.provider.provideTokenCount(a,$):this.b.$countTokens(u.identifier,typeof a=="string"?a:A.LanguageModelMessage.from(a),$)}getLanguageModelInfo(f){const a=this.g.get(f);if(a)return{id:a.identifier,name:a.name,version:a.version,tokens:a.tokens}}createLanguageModelAccessInformation(f){this.o.add(f);const a=this,$=E.Event.signal(E.Event.filter(this.c.event,S=>w.$Rm.equals(S.from,f.identifier))),u=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any($,u)},canSendRequest(S){const h=a.g.get(S);if(!h)return;if(!a.m(f.identifier,h))return!0;const b=a.h.get(f.identifier);if(b)return b.has(h.extension)}}}};e.$3lc=l,e.$3lc=l=i=Je([We(0,g.$qP),We(1,o.$3j),We(2,r.$klc)],l)}),define(Ie[274],Pe([1,0,4,8,7,33,11,6,26]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=void 0;class E{constructor(D,d,v,g){this.c=d,this.d=v,this.e=g,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(I.$3M.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,d){await this.a.$changeLanguage(D,d);const v=this.c.getDocumentData(D);if(!v)throw new Error(`document '${D.toString()}' NOT found`);return v.document}async tokenAtPosition(D,d){const v=D.version,g=M.Position.from(d),r=await this.a.$tokensAtPosition(D.uri,g),o={type:A.StandardTokenType.Other,range:D.getWordRangeAtPosition(d)??new A.$7M(d.line,d.character,d.line,d.character)};if(!r)return o;const s={range:M.Range.to(r.range),type:M.TokenType.to(r.type)};return!s.range.contains(d)||v!==D.version?o:s}createLanguageStatusItem(D,d,v){const g=this.f++,r=this.a,o=this.g,s=`${D.identifier.value}/${d}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${d}' ALREADY exists`);o.add(s);const i={selector:v,id:d,name:D.displayName??D.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const c=new w.$Uc,l=()=>{if(n?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${d}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$yh)(()=>{c.clear(),this.a.$setLanguageStatus(g,{id:s,name:i.name??D.displayName??D.name,source:D.displayName??D.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===A.LanguageStatusSeverity.Error?O.default.Error:i.severity===A.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:i.command&&this.d.toInternal(i.command,c),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){c.dispose(),n?.dispose(),r.$removeLanguageStatus(g),o.delete(s)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,l()},get selector(){return i.selector},set selector(f){i.selector=f,l()},get text(){return i.text},set text(f){i.text=f,l()},set text2(f){(0,p.$IG)(D,"languageStatusText"),i.text=f,l()},get text2(){return(0,p.$IG)(D,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,l()},get severity(){return i.severity},set severity(f){i.severity=f,l()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,l()},get command(){return i.command},set command(f){i.command=f,l()},get busy(){return i.busy},set busy(f){i.busy=f,l()}};return l(),t}}e.$Hmc=E}),define(Ie[275],Pe([1,0,16,2,8,7,85]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=void 0;class w{constructor(D,d,v,g){this.start=D,this.deletedCount=d,this.deletedItems=v,this.items=g}asApiEvent(){return{range:new O.$uO(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1}}constructor(D,d,v){this.notebook=D,this.h=d,this.j=v,this.handle=v.handle,this.uri=M.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(A.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,d=this.h.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:d.document,get mime(){return D.g},set mime(g){D.g=g},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(v)}return this.f}setOutputs(D){this.a=D.map(A.NotebookCellOutput.to)}setOutputItems(D,d,v){const g=v.map(A.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===D);if(r&&(d||(r.items.length=0),r.items.push(...g),r.items.length>1&&r.items.every(o=>R.$ZK(o.mime)))){const o=new Map,s=[];r.items.forEach(i=>{let n;o.has(i.mime)?n=o.get(i.mime):(n=[],o.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),r.items.length=0,s.forEach(i=>{const n=R.$1K(o.get(i));r.items.push({mime:i,data:n.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$tmc=p;class E{static{this.a=0}constructor(D,d,v,g,r){this.k=D,this.l=d,this.m=v,this.uri=g,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,d={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===I.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(v){return v=D.n(v),D.b[v].apiCell},getCells(v){return(v?D.p(v):D.b).map(r=>r.apiCell)},save(){return D.q()}};this.e=Object.freeze(d)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,d,v){this.g=D.versionId,this.h=d,this.acceptDocumentPropertiesChanged({metadata:v});const g={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},r=[];for(const s of D.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,g.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,g.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<r.length;s++){const i=r[s],n=o.get(i.cell);if(n===void 0){const c=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});o.set(i.cell,c-1)}else g.cellChanges[n]={...g.cellChanges[n],...i}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let d=D.start|0,v=D.end|0;return d<0&&(d=0),v>this.b.length&&(v=this.b.length),D.with({start:d,end:v})}p(D){D=this.o(D);const d=[];for(let v=D.start;v<D.end;v++)d.push(this.b[v]);return d}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,d,v){if(this.j)return;const g=[],r=[],o=[];if(D.reverse().forEach(s=>{const n=s[2].map(t=>{const f=new p(this,this.l,t);return d||r.push(p.asModelAddData(t)),f}),c=new w(s[0],s[1],[],n),l=this.b.splice(s[0],s[1],...n);for(const t of l)o.push(t.uri),c.deletedItems.push(t.apiCell);g.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),v)for(const s of g)v.push(s.asApiEvent())}s(D,d,v,g){const r=this.b.splice(D,d);this.b.splice(v,0,...r);const o=[new w(D,d,r.map(s=>s.apiCell),[]),new w(v,0,[],r)];for(const s of o)g.push(s.asApiEvent())}t(D,d){this.b[D].setOutputs(d)}u(D,d,v,g){this.b[D].setOutputItems(d,v,g)}v(D,d){const v=this.b[D];v.apiCell.document.languageId!==d&&this.m.$acceptModelLanguageChanged(v.uri,d)}w(D,d){const v=this.b[D];v.apiCell.mime=d}x(D,d){this.b[D].setMetadata(d)}y(D,d){this.b[D].setInternalMetadata(d)}getCellFromApiCell(D){return this.b.find(d=>d.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(d=>d.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$umc=E}),define(Ie[276],Pe([1,0,5,2,8,7,35]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;class w{constructor(E,T,D,d={timeout:1500,errors:3}){this.b=E,this.c=T,this.d=D,this.f=d,this.a=new I.$ge}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(T,D,d)=>{const v=function(r){T.call(D,r)};return v.extension=E,this.a.event(v,void 0,d)}}async $participateInSave(E,T,D){const d=M.URI.revive(E),v=this.c.getNotebookDocument(d);if(!v)throw new Error("Unable to resolve notebook document");const g=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:A.TextDocumentSaveReason.to(T)},D,async(o,s)=>{const i=Date.now(),n=await await Promise.resolve(o);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!D.isCancellationRequested&&n&&(n instanceof O.$cN?g.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),D.isCancellationRequested)return!1;if(g.length===0)return!0;const r={edits:[]};for(const o of g){const{edits:s}=A.WorkspaceEdit.from(o);r.edits=r.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(new R.$vw(r))}}e.$Jmc=w}),define(Ie[114],Pe([1,0,14,8,7]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(w,p,E,T,D,d){this.id=w,this.f=p,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=T,this.c=d}get apiEditor(){if(!this.e){const w=this;this.e={get notebook(){return w.notebookData.apiNotebook},get selection(){return w.a[0]},set selection(p){this.selections=[p]},get selections(){return w.a},set selections(p){if(!Array.isArray(p)||!p.every(A.$uO.isNotebookRange))throw(0,I.$7)("selections");w.a=p,w.g(p)},get visibleRanges(){return w.b},revealRange(p,E){w.f.$tryRevealRange(w.id,M.NotebookRange.from(p),E??A.NotebookEditorRevealType.Default)},get viewColumn(){return w.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(w){this.d=w}_acceptVisibleRanges(w){this.b=w}_acceptSelections(w){this.a=w}g(w){this.f.$trySetSelections(this.id,w.map(M.NotebookRange.from))}_acceptViewColumn(w){this.c=w}}e.$vmc=O}),define(Ie[277],Pe([1,0,5,12,8]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=void 0;let O=class{constructor(w,p){this.c=w,this.d=p,this.a=new I.$ee,this.b=new I.$ee,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,p);const E=this.d.getEditorById(w);p.visibleRanges&&E._acceptVisibleRanges(p.visibleRanges.ranges.map(A.NotebookRange.to)),p.selections&&E._acceptSelections(p.selections.selections.map(A.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const p in w)this.d.getEditorById(p)._acceptViewColumn(A.ViewColumn.to(w[p]))}};e.$Lmc=O,e.$Lmc=O=Je([We(0,M.$3j)],O)}),define(Ie[278],Pe([1,0,5,4,114]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;class O{constructor(w,p){this.c=p,this.a=new Map,this.b=w.getProxy(M.$3M.MainThreadNotebookRenderers)}$postRendererMessage(w,p,E){const T=this.c.getEditorById(w);this.a.get(p)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging(w,p){if(!w.contributes?.notebookRenderer?.some(T=>T.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(T,D,d)=>this.d(p).event(T,D,d),postMessage:(T,D)=>{A.$vmc.apiEditorsToExtHost.has(T)&&([T,D]=[D,T]);const d=D&&A.$vmc.apiEditorsToExtHost.get(D);return this.b.$postMessage(d?.id,p,T)}}}d(w){let p=this.a.get(w);return p||(p=new I.$ee({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(w)}}),this.a.set(w,p),p)}}e.$Omc=O}),define(Ie[279],Pe([1,0,8,103,24,69,14]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;class w{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,d,v){const g=this.b++,{title:r,location:o,cancellable:s}=d,i={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(g,{location:I.ProgressLocation.from(o),title:r,source:i,cancellable:s},D.isUnderDevelopment?void 0:D.identifier.value).catch(R.$2),this.d(g,v,!!s)}d(D,d,v){let g;v&&(g=new A.$pe,this.c.set(D,g));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),g?.dispose()};let o;try{o=d(new E(this.a,D),v&&g?g.token:A.CancellationToken.None)}catch(s){throw r(D),s}return o.then(s=>r(D),s=>r(D)),o}$acceptProgressCanceled(D){const d=this.c.get(D);d&&(d.cancel(),this.c.delete(D))}}e.$Smc=w;function p(T,D){return T.message=D.message,typeof D.increment=="number"&&(typeof T.increment=="number"?T.increment+=D.increment:T.increment=D.increment),T}class E extends M.$0v{constructor(D,d){super(v=>this.throttledReport(v)),this.c=D,this.d=d}throttledReport(D){this.c.$progressReport(this.d,D)}}Je([(0,O.$3h)(100,(T,D)=>p(T,D),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Ie[280],Pe([1,0,2,4,11,8]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0;class R{static{this.a=0}constructor(p,E){this.d=E,this.c=new Map,this.b=p.getProxy(M.$3M.MainThreadQuickDiff)}$provideOriginalResource(p,E,T){const D=I.URI.revive(E),d=this.c.get(p);return d?(0,A.$oh)(()=>d.provideOriginalResource(D,T)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(p,E,T,D){const d=R.a++;return this.c.set(d,E),this.b.$registerQuickDiffProvider(d,O.DocumentSelector.from(p,this.d),T,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(d),this.c.delete(d)}}}}e.$Tmc=R}),define(Ie[281],Pe([1,0,24,5,6,4,2,7,14,18,33,36,26,8]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=g;function g(r,o,s){const i=r.getProxy(O.$3M.MainThreadQuickOpen);class n{constructor(h,b){this.e=new Map,this.f=0,this.a=h,this.b=b}showQuickPick(h,b,m,k=I.CancellationToken.None){this.c=void 0;const y=Promise.resolve(b),C=++this.f,P=i.$show(C,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},k),W={},V=P.then(()=>W);return Promise.race([V,y]).then(q=>{if(q===W)return;const N=(0,d.$HG)(h,"quickPickItemTooltip");return y.then(U=>{const K=[];for(let ie=0;ie<U.length;ie++){const ce=U[ie];if(typeof ce=="string")K.push({label:ce,handle:ie});else if(ce.kind===w.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!N&&console.warn(`Extension '${h.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`);const ye=ce.iconPath?a(ce.iconPath):void 0;K.push({label:ce.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:N?v.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ie})}}return m&&typeof m.onDidSelectItem=="function"&&(this.c=ie=>{m.onDidSelectItem(U[ie])}),i.$setItems(C,K),P.then(ie=>{if(typeof ie=="number")return U[ie];if(Array.isArray(ie))return ie.map(ce=>U[ce])})})}).then(void 0,q=>{if(!(0,p.$4)(q))return i.$setError(C,q),Promise.reject(q)})}$onItemSelected(h){this.c?.(h)}showInput(h,b=I.CancellationToken.None){return this.d=h?.validateInput,i.$input(h,typeof this.d=="function",b).then(void 0,m=>{if(!(0,p.$4)(m))return Promise.reject(m)})}async $validateInput(h){if(!this.d)return;const b=await this.d(h);if(!b||typeof b=="string")return b;let m;switch(b.severity){case w.InputBoxValidationSeverity.Info:m=T.default.Info;break;case w.InputBoxValidationSeverity.Warning:m=T.default.Warning;break;case w.InputBoxValidationSeverity.Error:m=T.default.Error;break;default:m=b.message?T.default.Error:T.default.Ignore;break}return{content:b.message,severity:m}}async showWorkspaceFolderPick(h,b=I.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!m)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(y=>y.uri.toString()===m.uri.toString())}createQuickPick(h){const b=new $(h,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}createInputBox(h){const b=new u(h,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}$onDidChangeValue(h,b){this.e.get(h)?._fireDidChangeValue(b)}$onDidAccept(h){this.e.get(h)?._fireDidAccept()}$onDidChangeActive(h,b){const m=this.e.get(h);m instanceof $&&m._fireDidChangeActive(b)}$onDidChangeSelection(h,b){const m=this.e.get(h);m instanceof $&&m._fireDidChangeSelection(b)}$onDidTriggerButton(h,b){this.e.get(h)?._fireDidTriggerButton(b)}$onDidTriggerItemButton(h,b,m){const k=this.e.get(h);k instanceof $&&k._fireDidTriggerItemButton(b,m)}$onDidHide(h){this.e.get(h)?._fireDidHide()}}class c{static{this.a=1}constructor(h,b){this.x=h,this.y=b,this._id=$.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$ee,this.q=new M.$ee,this.r=new M.$ee,this.s=new M.$ee,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(h){this.b=h,this.z({title:h})}get step(){return this.c}set step(h){this.c=h,this.z({step:h})}get totalSteps(){return this.d}set totalSteps(h){this.d=h,this.z({totalSteps:h})}get enabled(){return this.g}set enabled(h){this.g=h,this.z({enabled:h})}get busy(){return this.j}set busy(h){this.j=h,this.z({busy:h})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(h){this.k=h,this.z({ignoreFocusOut:h})}get value(){return this.l}set value(h){this.l=h,this.z({value:h})}get placeholder(){return this.m}set placeholder(h){this.m=h,this.z({placeholder:h})}get buttons(){return this.n}set buttons(h){this.n=h.slice(),this.o.clear(),h.forEach((b,m)=>{const k=b===w.$rO.Back?-1:m;this.o.set(k,b)}),this.z({buttons:h.map((b,m)=>({...a(b.iconPath),tooltip:b.tooltip,handle:b===w.$rO.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(h){this.l=h,this.q.fire(h)}_fireDidTriggerButton(h){const b=this.o.get(h);b&&this.r.fire(b)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(h){if(!this.v){for(const b of Object.keys(h)){const m=h[b];this.u[b]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function l(S){if(S instanceof w.$2N)return{id:S.id};const h=f(S),b=t(S);return{dark:typeof h=="string"?R.URI.file(h):h,light:typeof b=="string"?R.URI.file(b):b}}function t(S){return typeof S=="object"&&"light"in S?S.light:S}function f(S){return typeof S=="object"&&"dark"in S?S.dark:S}function a(S){const h=l(S);let b,m;return"id"in h?m=D.ThemeIcon.asClassName(h):b=h,{iconPath:b,iconClass:m}}class $ extends c{constructor(h,b){super(h.identifier,b),this.O=h,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$ee,this.L=[],this.M=new M.$ee,this.N=new M.$ee,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(h){this.B=h.slice(),this.C.clear(),this.D.clear(),h.forEach((k,y)=>{this.C.set(y,k),this.D.set(k,y)});const b=(0,d.$HG)(this.O,"quickPickItemTooltip"),m=[];for(let k=0;k<h.length;k++){const y=h[k];if(y.kind===w.QuickPickItemKind.Separator)m.push({type:"separator",label:y.label});else{y.tooltip&&!b&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?a(y.iconPath):void 0;m.push({handle:k,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:b?v.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((P,W)=>({...a(P.iconPath),tooltip:P.tooltip,handle:W}))})}}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(h){this.E=h,this.z({canSelectMany:h})}get matchOnDescription(){return this.F}set matchOnDescription(h){this.F=h,this.z({matchOnDescription:h})}get matchOnDetail(){return this.G}set matchOnDetail(h){this.G=h,this.z({matchOnDetail:h})}get sortByLabel(){return this.H}set sortByLabel(h){this.H=h,this.z({sortByLabel:h})}get keepScrollPosition(){return this.I}set keepScrollPosition(h){this.I=h,this.z({keepScrollPosition:h})}get activeItems(){return this.J}set activeItems(h){this.J=h.filter(b=>this.D.has(b)),this.z({activeItems:this.J.map(b=>this.D.get(b))})}get selectedItems(){return this.L}set selectedItems(h){this.L=h.filter(b=>this.D.has(b)),this.z({selectedItems:this.L.map(b=>this.D.get(b))})}_fireDidChangeActive(h){const b=(0,E.$Hb)(h.map(m=>this.C.get(m)));this.J=b,this.K.fire(b)}_fireDidChangeSelection(h){const b=(0,E.$Hb)(h.map(m=>this.C.get(m)));this.L=b,this.M.fire(b)}_fireDidTriggerItemButton(h,b){const m=this.C.get(h);if(!m||!m.buttons||!m.buttons.length)return;const k=m.buttons[b];k&&this.N.fire({button:k,item:m})}}class u extends c{constructor(h,b){super(h.identifier,b),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(h){this.B=h,this.z({password:h})}get prompt(){return this.C}set prompt(h){this.C=h,this.z({prompt:h})}get valueSelection(){return this.D}set valueSelection(h){this.D=h,this.z({valueSelection:h})}get validationMessage(){return this.E}set validationMessage(h){this.E=h,h?typeof h=="string"?this.z({validationMessage:h,severity:T.default.Error}):this.z({validationMessage:h.message,severity:h.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new n(o,s)}}),define(Ie[282],Pe([1,0,2,5,69,6,11,4,18,149,12,20,36,8,26,16,22]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=e.$Vmc=void 0;function i(C){return C instanceof I.URI}function n(C,P){return C.scheme===r.Schemas.file&&P.scheme===r.Schemas.file&&o.$k?C.toString()===P.toString():C.toString().toLowerCase()===P.toString().toLowerCase()}function c(C){if(C)return typeof C.iconPath=="string"?I.URI.file(C.iconPath):I.URI.isUri(C.iconPath)||d.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function l(C){if(C.icon){if(I.URI.isUri(C.icon))return C.icon;if(d.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const P=C.icon;return{light:P.light,dark:P.dark}}}else return}function t(C,P){if(!C.iconPath&&!P.iconPath)return 0;if(C.iconPath){if(!P.iconPath)return 1}else return-1;const W=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,V=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,E.$qr)(W,V)}function f(C,P){let W=0;if(C.strikeThrough!==P.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==P.faded)return C.faded?1:-1;if(C.tooltip!==P.tooltip)return(C.tooltip||"").localeCompare(P.tooltip||"");if(W=t(C,P),W!==0)return W;if(C.light&&P.light)W=t(C.light,P.light);else{if(C.light)return 1;if(P.light)return-1}if(W!==0)return W;if(C.dark&&P.dark)W=t(C.dark,P.dark);else{if(C.dark)return 1;if(P.dark)return-1}return W}function a(C,P){if(C.command!==P.command)return C.command<P.command?-1:1;if(C.title!==P.title)return C.title<P.title?-1:1;if(C.tooltip!==P.tooltip){if(C.tooltip!==void 0&&P.tooltip!==void 0)return C.tooltip<P.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(C.arguments===P.arguments)return 0;if(C.arguments)if(P.arguments){if(C.arguments.length!==P.arguments.length)return C.arguments.length-P.arguments.length}else return 1;else return-1;for(let W=0;W<C.arguments.length;W++){const V=C.arguments[W],q=P.arguments[W];if(V!==q&&!(i(V)&&i(q)&&n(V,q)))return V<q?-1:1}return 0}function $(C,P){let W=(0,E.$qr)(C.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(W!==0)return W;if(C.command&&P.command)W=a(C.command,P.command);else{if(C.command)return 1;if(P.command)return-1}if(W!==0)return W;if(C.decorations&&P.decorations)W=f(C.decorations,P.decorations);else{if(C.decorations)return 1;if(P.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)W=(0,E.$qr)(C.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)W=(0,E.$qr)(C.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return W}function u(C,P){for(let W=0;W<C.length;W++)if(C[W]!==P[W])return!1;return!0}function S(C,P){return C.command===P.command&&C.title===P.title&&C.tooltip===P.tooltip&&(C.arguments&&P.arguments?u(C.arguments,P.arguments):C.arguments===P.arguments)}function h(C,P){return(0,p.$ub)(C,P,S)}class b{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,g.$IG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,g.$IG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,g.$IG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,W,V,q,N){this.k=P,this.l=q,this.m=N,this.d="",this.e=new M.$ee,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(P,W){(0,g.$IG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,W)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$Vmc=b;class m{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,W,V,q,N,U,K){this.q=P,this.s=W,this.t=V,this.u=q,this.v=N,this.multiDiffEditorEnableViewChanges=U,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$ee,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$ee,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=m.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,W){const V=this.h.get(P);return V?(0,R.$oh)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort($),V=(0,p.$Db)(this.o,P,$).map(U=>{const K=U.toInsert.map(ie=>{const ce=this.e++;this.g.set(ce,ie);const ye=ie.resourceUri;let Se;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const ge=new O.$Uc;Se=this.s.converter.toInternal(ie.command,ge),this.j.set(ce,ge)}else this.h.set(ce,ie.command);const fe=(0,g.$HG)(this.w,"scmMultiDiffEditor"),$e=fe?ie.multiDiffEditorOriginalUri:void 0,Te=fe?ie.multiFileDiffEditorModifiedUri:void 0,ae=c(ie.decorations),Ne=ie.decorations&&c(ie.decorations.light)||ae,ne=ie.decorations&&c(ie.decorations.dark)||ae,z=[Ne,ne],x=ie.decorations&&ie.decorations.tooltip||"",ve=ie.decorations&&!!ie.decorations.strikeThrough,Fe=ie.decorations&&!!ie.decorations.faded,De=ie.contextValue||"";return{rawResource:[ce,ye,z,x,ve,Fe,De,Se,$e,Te],handle:ce}});return{start:U.start,deleteCount:U.deleteCount,toInsert:K}}),q=V.map(({start:U,deleteCount:K,toInsert:ie})=>[U,K,ie.map(ce=>ce.rawResource)]),N=V.reverse();for(const{start:U,deleteCount:K,toInsert:ie}of N){const ce=ie.map(Se=>Se.handle),ye=this.n.splice(U,K,...ce);for(const Se of ye)this.g.delete(Se),this.h.delete(Se),this.j.get(Se)?.dispose(),this.j.delete(Se)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class k{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let W;(0,g.$HG)(this.x,"quickDiffProvider")&&(W=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:W})}get historyProvider(){return(0,g.$IG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,g.$IG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new O.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new O.$Uc,this.o=P;const W=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,g.$IG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,g.$IG)(this.x,"scmActionButton"),this.p.value=new O.$Uc,this.q=P;const W=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&h(this.t,P))return;this.s.value=new O.$Uc,this.t=P;const W=(P||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(P,W,V,q,N,U,K){this.x=P,this.y=q,this.z=N,this.A=U,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Wc,this.m=void 0,this.n=new O.$Wc,this.o=void 0,this.p=new O.$Wc,this.s=new O.$Wc,this.t=void 0,this.u=!1,this.v=new M.$ee,this.onDidChangeSelection=this.v.event,this.w=k.d++,this.C=new Map,this.D=new Set,this.#e=V;const ie=I.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new b(P,W,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,N,U,K,ie)}createResourceGroup(P,W,V){const q=(0,g.$HG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,N=new m(this.#e,this.y,this.w,P,W,q,this.x),U=M.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,U),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const P=[],W=[];for(const[V,q]of this.C){q.dispose();const N=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});M.Event.once(V.onDidDispose)(()=>{this.D.delete(V),N.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),P.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const U=V._takeResourceStateSnapshot();U.length>0&&W.push([V.handle,U]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,P,W),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&P.push([W.handle,V])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,A.$2h)(100)],k.prototype,"eventuallyAddResourceGroups",null),Je([(0,A.$2h)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new D.$Tm,this.j=new M.$ee,this.e=P.getProxy(w.$3M.MainThreadSCM),this.f=P.getProxy(w.$3M.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const U=this.g.get(N.sourceControlHandle);if(!U)return N;const K=U.getResourceGroup(N.groupHandle);return K?K.getResourceState(N.handle):N}else if(N&&N.$mid===4){const U=this.g.get(N.sourceControlHandle);return U?U.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const U=this.g.get(N.handle);return U||N}return N}})}createSourceControl(P,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const N=s.d++,U=new k(P,this.m,this.e,this.l,W,V,q);this.g.set(N,U);const K=this.h.get(P.identifier)||[];return K.push(U),this.h.set(P.identifier,K),U}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const W=this.h.get(P.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(P,W,V){const q=I.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const N=this.g.get(P);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$oh)(()=>N.quickDiffProvider.provideOriginalResource(q,V)).then(U=>U||null)}$onInputBoxValueChange(P,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const V=this.g.get(P);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(P,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,W,V);const N=this.g.get(P);if(!N)return Promise.resolve(void 0);const U=N.getResourceGroup(W);return U?U.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(P,W,V){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,R.$oh)(()=>q.inputBox.validateInput(W,V)).then(N=>{if(!N)return Promise.resolve(void 0);const U=v.MarkdownString.fromStrict(N.message);return U?Promise.resolve([U,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,W,V,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(P,W,V,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(W,V,q))?.map(K=>({...K,icon:l(K)}))??void 0}async $provideHistoryItemSummary(P,W,V,q){const N=this.g.get(P)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const U=await N.provideHistoryItemSummary(W,V,q);return U?{...U,icon:l(U)}:void 0}async $provideHistoryItemChanges(P,W,V,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$Wmc=y,e.$Wmc=y=s=Je([We(3,T.$3j)],y)}),define(Ie[283],Pe([1,0,4,8,2]),function(le,e,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=void 0;class O{static{this.a=0}constructor(w,p){this.d=p,this.c=new Map,this.b=w.getProxy(I.$3M.MainThreadShare)}async $provideShare(w,p,E){return await this.c.get(w)?.provideShare({selection:M.Range.to(p.selection),resourceUri:A.URI.revive(p.resourceUri)},E)??void 0}registerShareProvider(w,p){const E=O.a++;return this.c.set(E,p),this.b.$registerShareProvider(E,M.DocumentSelector.from(w,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Xmc=O}),define(Ie[284],Pe([1,0,7,4,178,6,8,15]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=e.$Zmc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$3N("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$3N("statusBarItem.warningForeground")]])}#e;#t;constructor(d,v,g,r,o,s=I.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new O.$Uc,this.#e=d,this.#t=v,o&&r){this.c=(0,I.$EN)(r.identifier,o);const n=g.get(this.c);n&&(s=n.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(p.a++);this.e=r,this.f=o,this.g=s,this.h=this.u(i)}u(d){if((0,w.$ag)(d))return d===Number.POSITIVE_INFINITY?Number.MAX_VALUE:d===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:d}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(d){this.k=d,this.v()}set name(d){this.m=d,this.v()}set tooltip(d){this.l=d,this.v()}set color(d){this.n=d,this.v()}set backgroundColor(d){d&&!p.b.has(d.id)&&(d=void 0),this.o=d,this.v()}set command(d){this.r?.fromApi!==d&&(this.p&&this.q.add(this.p),this.p=new O.$Uc,typeof d=="string"?this.r={fromApi:d,internal:this.#t.toInternal({title:"",command:d},this.p)}:d?this.r={fromApi:d,internal:this.#t.toInternal(d,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(d){this.t=d,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let d;this.e?this.f?d=`${this.e.identifier.value}.${this.f}`:d=this.e.identifier.value:d=this.f;let v;this.m?v=this.m:v=(0,A.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=p.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,d,this.e?.identifier.value,v,this.k,r,this.r?.internal,g,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Zmc=p;class E{constructor(d){this.b=[],this.a=d.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(d){const v={message:d};return this.b.unshift(v),this.c(),new I.$5M(()=>{const g=this.b.indexOf(v);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(d,v){this.e=new Map,this.a=d.getProxy(M.$3M.MainThreadStatusBar),this.b=v,this.c=new E(this)}$acceptStaticEntries(d){for(const v of d)this.e.set(v.entryId,v)}createStatusBarEntry(d,v,g,r){return new p(this.a,this.b,this.e,d,v,g,r)}setStatusBarMessage(d,v){const g=this.c.setMessage(d);let r;return typeof v=="number"?r=setTimeout(()=>g.dispose(),v):typeof v<"u"&&v.then(()=>g.dispose(),()=>g.dispose()),new I.$5M(()=>{g.dispose(),clearTimeout(r)})}}e.$1mc=T}),define(Ie[115],Pe([1,0,30,107,52,77,62,8,2]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=e.$EP=e.$DP=e.$CP=void 0;const E=(n,c,l,t)=>{let f=c;return{enumerable:!0,configurable:!1,get(){return f},set(a){if(!l(f,a)){const $=f;f=a,n.listener?.(t(a,$))}}}},T=(n,c)=>n===c,D={range:(n,c)=>n===c?!0:!n||!c?!1:n.isEqual(c),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(n,c)=>!(n.length!==c.length||n.some(l=>!c.find(t=>l.id===t.id)))},d=n=>c=>({op:4,update:n(c)}),v=(n,c)=>({range:(()=>{let l;const t=d(f=>({range:I.$ut.lift(w.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return l},set(f){n.listener?.({op:6}),D.range(l,f)||(l=f,n.listener?.(t(f)))}}})(),label:E(n,c,D.label,d(l=>({label:l}))),description:E(n,void 0,D.description,d(l=>({description:l}))),sortText:E(n,void 0,D.sortText,d(l=>({sortText:l}))),canResolveChildren:E(n,!1,D.canResolveChildren,l=>({op:2,state:l})),busy:E(n,!1,D.busy,d(l=>({busy:l}))),error:E(n,void 0,D.error,d(l=>({error:w.MarkdownString.fromStrict(l)||null}))),tags:E(n,[],D.tags,(l,t)=>({op:1,new:l.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),g=n=>{const c=A.$OL.fromString(n.extId),l=new o(c.controllerId,c.localId,n.label,p.URI.revive(n.uri)||void 0);return l.range=w.Range.to(n.range||void 0),l.description=n.description||void 0,l.sortText=n.sortText||void 0,l.tags=n.tags.map(t=>w.TestTag.to({id:(0,R.$UL)(t).tagId})),l},r=n=>{let c;for(const l of n.tests){const t=g(l.item);(0,M.$mP)(t).parent=c,c=t}return c};e.$CP=r;class o{constructor(c,l,t,f){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const a=(0,M.$lP)(this,c);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof s?void 0:a.parent}},children:{value:(0,O.$kP)(a,M.$mP,o),enumerable:!0,writable:!1},...v(a,t)})}}e.$DP=o;class s extends o{constructor(c,l){super(c,c,l,void 0),this._isRoot=!0}}e.$EP=s;class i extends O.$gP{constructor(c,l,t){super({controllerId:c,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:M.$mP,getChildren:f=>f.children,root:new s(c,l),toITestItem:w.TestItem.from})}}e.$FP=i}),define(Ie[32],Pe([1,0,15,7,8,25,4,18,12,49,30,94,2,6,3,17,115,21,35,44,66,59,63,34]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n,c,l,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.$LP=void 0;let a=class{#e;#t;#i;constructor(m,k,y){this.b=new Map,this.c=new Map,this.#e=m.getProxy(R.$3M.MainThreadCommands),this.d=k,this.#i=y,this.#t=m.getProxy(R.$3M.MainThreadTelemetry),this.converter=new $(this,C=>{const P=this.c.get(C);return P?.result===S.Void?P:void 0},k),this.f=[{processArgument(C){return(0,E.$6h)(C)}},{processArgument(C){return(0,O.$5n)(C,function(P){if(T.$ut.isIRange(P))return A.Range.to(P);if(D.$tt.isIPosition(P))return A.Position.to(P);if(T.$ut.isIRange(P.range)&&d.URI.isUri(P.uri))return A.location.to(P);if(P instanceof s.$Ge)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(m){this.f.push(m)}registerApiCommand(m){const k=this.registerCommand(!1,m.id,async(...y)=>{const C=m.args.map((W,V)=>{if(!W.validate(y[V]))throw new Error(`Invalid argument '${W.name}' when running '${m.id}', received: ${typeof y[V]=="object"?JSON.stringify(y[V],null,"	"):y[V]} `);return W.convert(y[V])}),P=await this.executeCommand(m.internalId,...C);return m.result.convert(P,y,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this.c.set(m.id,m),new M.$5M(()=>{k.dispose(),this.c.delete(m.id)})}registerCommand(m,k,y,C,P,W){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:y,thisArg:C,metadata:P,extension:W}),m&&this.#e.$registerCommand(k),new M.$5M(()=>{this.b.delete(k)&&m&&this.#e.$unregisterCommand(k)})}executeCommand(m,...k){return this.d.trace("ExtHostCommands#executeCommand",m),this.g(m,k,!0)}async g(m,k,y){if(this.b.has(m))return this.#e.$fireCommandActivationEvent(m),this.h(m,k,!1);{let C=!1;const P=(0,O.$5n)(k,function(W){if(W instanceof M.$6M)return A.Position.from(W);if(W instanceof M.$7M)return A.Range.from(W);if(W instanceof M.$eN)return A.location.from(W);if(M.$uO.isNotebookRange(W))return A.NotebookRange.from(W);if(W instanceof ArrayBuffer)return C=!0,s.$Ge.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return C=!0,s.$Ge.wrap(W);if(W instanceof s.$Ge)return C=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(m,C?new i.$vw(P):P,y);return(0,E.$6h)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(m,k,!1);throw W}}}async h(m,k,y){const C=this.b.get(m);if(!C)throw new Error("Unknown command");const{callback:P,thisArg:W,metadata:V}=C;if(V?.args)for(let N=0;N<V.args.length;N++)try{(0,I.$ng)(k[N],V.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${V.args[N].name}' - ${V.args[N].description}`)}const q=c.$ae.create();try{return await P.apply(W,k)}catch(N){if(m===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...k);U&&(m=U.command)}if(this.d.error(N,m,C.extension?.identifier),!y)throw N;if(C.extension?.identifier){const U=this.#i.onExtensionError(C.extension.identifier,N);this.d.trace("forwarded error to extension?",U,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$hj)(N)),this.id=m,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,m,q.elapsed())}}j(m,k,y){m.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new l.$fp(k),duration:y})}$executeContributedCommand(m,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",m);const y=this.b.get(m);return y?(k=k.map(C=>this.f.reduce((P,W)=>W.processArgument(P,y.extension?.identifier),C)),this.h(m,k,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this.d.trace("ExtHostCommands#getCommands",m),this.#e.$getCommands().then(k=>(m&&(k=k.filter(y=>y[0]!=="_")),k))}$getContributedCommandMetadata(){const m=Object.create(null);for(const[k,y]of this.b){const{metadata:C}=y;C&&(m[k]=C)}return Promise.resolve(m)}};e.$LP=a,e.$LP=a=Je([We(0,r.$qP),We(1,p.$3j),We(2,t.$KP)],a),e.$MP=(0,g.$wi)("IExtHostCommands");class ${constructor(m,k,y){this.d=m,this.f=k,this.g=y,this.delegatingCommandId=`__vsc${(0,f.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(m,k){if(!m)return;const y={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return y;const C=this.f(m.command);if(C)y.id=C.internalId,y.arguments=C.args.map((P,W)=>P.convert(m.arguments&&m.arguments[W]));else if((0,w.$Lb)(m.arguments)){const P=`${m.command} /${++this.c}`;this.b.set(P,m),k.add((0,v.$Tc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),y.$ident=P,y.id=this.delegatingCommandId,y.arguments=[P],this.g.trace("CommandsConverter#CREATE",m.command,P)}return y}fromInternal(m){return typeof m.$ident=="string"?this.b.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this.b.get(m[0])}h(...m){const k=this.getActualCommand(...m);return this.g.trace("CommandsConverter#EXECUTE",m[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.$NP=$;class u{static{this.Uri=new u("uri","Uri of a text document",m=>d.URI.isUri(m),m=>m)}static{this.Position=new u("position","A position in a text document",m=>M.$6M.isPosition(m),A.Position.from)}static{this.Range=new u("range","A range in a text document",m=>M.$7M.isRange(m),A.Range.from)}static{this.Selection=new u("selection","A selection in a text document",m=>M.$8M.isSelection(m),A.Selection.from)}static{this.Number=new u("number","",m=>typeof m=="number",m=>m)}static{this.String=new u("string","",m=>typeof m=="string",m=>m)}static{this.StringArray=u.Arr(u.String)}static Arr(m){return new u(`${m.name}_array`,`Array of ${m.name}, ${m.description}`,k=>Array.isArray(k)&&k.every(y=>m.validate(y)),k=>k.map(y=>m.convert(y)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",m=>m instanceof M.$qN,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",m=>m instanceof M.$OO,A.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",m=>m instanceof o.$DP,A.TestItem.from)}constructor(m,k,y,C){this.name=m,this.description=k,this.validate=y,this.convert=C}optional(){return new u(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,k){return new u(m??this.name,k??this.description,this.validate,this.convert)}}e.$OP=u;class S{static{this.Void=new S("no result",m=>m)}constructor(m,k){this.description=m,this.convert=k}}e.$PP=S;class h{constructor(m,k,y,C,P){this.id=m,this.internalId=k,this.description=y,this.args=C,this.result=P}}e.$QP=h}),define(Ie[285],Pe([1,0,18,16,2,89,98,31,32,8,7]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=void 0;const D=[new p.$QP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$OP.Uri,p.$OP.Position],new p.$PP("A promise that resolves to an array of DocumentHighlight-instances.",v(E.DocumentHighlight.to))),new p.$QP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$OP.Uri],new p.$PP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,I.$Kb)(r))return;class s extends T.$lN{static to(n){const c=new s(n.name,E.SymbolKind.to(n.kind),n.containerName||"",new T.$eN(o[0],E.Range.to(n.range)));return c.detail=n.detail,c.range=c.location.range,c.selectionRange=E.Range.to(n.selectionRange),c.children=n.children?n.children.map(s.to):[],c}}return r.map(s.to)})),new p.$QP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$OP.Uri,new p.$OP("options","Formatting options",r=>!0,r=>r)],new p.$PP("A promise that resolves to an array of TextEdits.",v(E.TextEdit.to))),new p.$QP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$OP.Uri,p.$OP.Range,new p.$OP("options","Formatting options",r=>!0,r=>r)],new p.$PP("A promise that resolves to an array of TextEdits.",v(E.TextEdit.to))),new p.$QP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$OP.Uri,p.$OP.Position,new p.$OP("ch","Trigger character",r=>typeof r=="string",r=>r),new p.$OP("options","Formatting options",r=>!0,r=>r)],new p.$PP("A promise that resolves to an array of TextEdits.",v(E.TextEdit.to))),new p.$QP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$OP.Uri,p.$OP.Position],new p.$PP("A promise that resolves to an array of Location or LocationLink instances.",g)),new p.$QP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$OP.Uri,p.$OP.Position],new p.$PP("A promise that resolves to an array of Location or LocationLink instances.",g)),new p.$QP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$OP.Uri,p.$OP.Position],new p.$PP("A promise that resolves to an array of Location or LocationLink instances.",g)),new p.$QP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$OP.Uri,p.$OP.Position],new p.$PP("A promise that resolves to an array of Location or LocationLink instances.",g)),new p.$QP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$OP.Uri,p.$OP.Position],new p.$PP("A promise that resolves to an array of Location-instances.",v(E.location.to))),new p.$QP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$OP.Uri,p.$OP.Position],new p.$PP("A promise that resolves to an array of Hover-instances.",v(E.Hover.to))),new p.$QP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$OP.Uri,new p.$OP("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>T.$6M.isPosition(o)),r=>r.map(E.Position.from))],new p.$PP("A promise that resolves to an array of ranges.",r=>r.map(o=>{let s;for(const i of o.reverse())s=new T.$pN(E.Range.to(i),s);return s}))),new p.$QP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$OP.String.with("query","Search string")],new p.$PP("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(E.WorkspaceSymbol.to))),new p.$QP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$OP.Uri,p.$OP.Position],new p.$PP("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(E.CallHierarchyItem.to))),new p.$QP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$OP.CallHierarchyItem],new p.$PP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(E.CallHierarchyIncomingCall.to))),new p.$QP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$OP.CallHierarchyItem],new p.$PP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(E.CallHierarchyOutgoingCall.to))),new p.$QP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$OP.Uri,p.$OP.Position],new p.$PP("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:E.Range.to(r.range),placeholder:r.text}})),new p.$QP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$OP.Uri,p.$OP.Position,p.$OP.String.with("newName","The new symbol name")],new p.$PP("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return E.WorkspaceEdit.to(r)}})),new p.$QP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$OP.Uri,p.$OP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$PP("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(E.DocumentLink.to))),new p.$QP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$OP.Uri],new p.$PP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.$lO(r.tokenTypes,r.tokenModifiers)})),new p.$QP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$OP.Uri],new p.$PP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$$bb)(r);if(o.type==="full")return new T.$nO(o.data,void 0)})),new p.$QP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$OP.Uri,p.$OP.Range.optional()],new p.$PP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new T.$lO(r.tokenTypes,r.tokenModifiers)})),new p.$QP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$OP.Uri,p.$OP.Range],new p.$PP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$$bb)(r);if(o.type==="full")return new T.$nO(o.data,void 0)})),new p.$QP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$OP.Uri,p.$OP.Position,p.$OP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$OP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$PP("A promise that resolves to a CompletionList-instance.",(r,o,s)=>{if(!r)return new T.$BN([]);const i=r.suggestions.map(n=>E.CompletionItem.to(n,s));return new T.$BN(i,r.incomplete)})),new p.$QP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$OP.Uri,p.$OP.Position,p.$OP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$PP("A promise that resolves to SignatureHelp.",r=>{if(r)return E.SignatureHelp.to(r)})),new p.$QP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$OP.Uri,p.$OP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$PP("A promise that resolves to an array of CodeLens-instances.",(r,o,s)=>v(i=>new T.$tN(E.Range.to(i.range),i.command&&s.fromInternal(i.command)))(r))),new p.$QP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$OP.Uri,new p.$OP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>T.$7M.isRange(r),r=>T.$8M.isSelection(r)?E.Selection.from(r):E.Range.from(r)),p.$OP.String.with("kind","Code action kind to return code actions for").optional(),p.$OP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$PP("A promise that resolves to an array of Command-instances.",(r,o,s)=>v(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new T.$nN(i.title,i.kind?new T.$oN(i.kind):void 0);return i.edit&&(n.edit=E.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(r))),new p.$QP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$OP.Uri],new p.$PP("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new T.$HN(E.Range.to(o.range),E.Color.to(o.color))):[])),new p.$QP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$OP("color","The color to show and insert",r=>r instanceof T.$GN,E.Color.from),new p.$OP("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:E.Range.from(r.range)}))],new p.$PP("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(E.ColorPresentation.to):[])),new p.$QP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$OP.Uri,p.$OP.Range],new p.$PP("A promise that resolves to an array of Inlay objects",(r,o,s)=>r.map(E.InlayHint.to.bind(void 0,s)))),new p.$QP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$OP.Uri],new p.$PP("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(E.FoldingRange.to)})),new p.$QP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$PP("A promise that resolves to an array of NotebookContentProvider static info objects.",v(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>E.NotebookExclusiveDocumentPattern.to(o))})))),new p.$QP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$OP.Uri,p.$OP.Range,new p.$OP("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof T.$7M,r=>E.InlineValueContext.from(r))],new p.$PP("A promise that resolves to an array of InlineValue objects",r=>r.map(E.InlineValue.to))),new p.$QP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$OP("uriOrString","Uri-instance or string (only http/https)",r=>A.URI.isUri(r)||typeof r=="string"&&(0,M.$Gg)(r,M.Schemas.http,M.Schemas.https),r=>r),new p.$OP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional(),p.$OP.String.with("label","").optional()],p.$PP.Void),new p.$QP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$OP.Uri.with("resource","Resource to open"),p.$OP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$OP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional()],p.$PP.Void),new p.$QP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$OP.Uri.with("left","Left-hand side resource of the diff editor"),p.$OP.Uri.with("right","Right-hand side resource of the diff editor"),p.$OP.String.with("title","Human readable title for the diff editor").optional(),new p.$OP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)]).optional()],p.$PP.Void),new p.$QP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$OP.String.with("title","Human readable title for the changes editor"),new p.$OP("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[s,i,n]=o;if(!A.URI.isUri(s)||!A.URI.isUri(i)&&i!==void 0&&i!==null||!A.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},r=>r)],p.$PP.Void),new p.$QP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$OP.Uri,p.$OP.Position],new p.$PP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new p.$QP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$OP.TypeHierarchyItem],new p.$PP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new p.$QP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$OP.TypeHierarchyItem],new p.$PP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new p.$QP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$OP.TestItem],p.$PP.Void),new p.$QP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$OP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$PP.Void),new p.$QP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$OP.String.with("name","The context key name"),new p.$OP("value","The context key value",()=>!0,r=>r)],p.$PP.Void),new p.$QP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$OP.Uri,p.$OP.StringArray,new p.$OP("MappedEditsContext","Mapped Edits Context",r=>E.MappedEditsContext.is(r),r=>E.MappedEditsContext.from(r))],new p.$PP("A promise that resolves to a workspace edit or null",r=>r?E.WorkspaceEdit.to(r):null))];class d{static register(o){D.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",w.$vj)}}e.$jlc=d;function v(r){return o=>{if(Array.isArray(o))return o.map(r)}}function g(r){if(!Array.isArray(r))return;const o=[];for(const s of r)O.$_t(s)?o.push(E.DefinitionLink.to(s)):o.push(E.location.to(s));return o}}),define(Ie[286],Pe([1,0,11,6,2,4,32,8,7]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=void 0;class E{static{this.a=0}constructor(v,g){this.extension=v,this.provider=g,this.handle=E.a++}}class T{constructor(v){this.session=v,this.responses=[]}}class D{static{this.a=0}constructor(v,g,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=v.getProxy(O.$3M.MainThreadInlineChat),g.registerApiCommand(new R.$QP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$OP("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?w.Range.from(s.initialRange):void 0,initialSelection:p.$8M.isSelection(s.initialSelection)?w.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?w.Position.from(s.position):void 0}})],R.$PP.Void))}registerProvider(v,g,r){const o=new E(v,g);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??v.displayName??v.name,v.identifier,typeof g.handleInteractiveEditorResponseFeedback=="function",typeof g.provideFollowups=="function",r?.supportReportIssue??!1),(0,M.$Tc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(v,g,r,o){const s=this.b.get(v);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(A.URI.revive(g)),n=w.Selection.to(r),c=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=D.a++;return this.d.set(l,new T(c)),{id:l,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:w.Range.from(c.wholeRange),message:c.message}}async $provideResponse(v,g,r,o){const s=this.b.get(v);if(!s)return;const i=this.d.get(g.id);if(!i)return;const n={prompt:r.prompt,selection:w.Selection.to(r.selection),wholeRange:w.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(A.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let c=!1;const l={report:async b=>{if(!r.live&&b.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:b.message,edits:b.edits?.map(w.TextEdit.from),editsShouldBeInstant:b.editsShouldBeInstant,slashCommand:b.slashCommand?.command,markdownFragment:p.$uN.isMarkdownString(b.content)?b.content.value:b.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,l,o));let f;try{f=await(0,I.$kh)(t,o)}finally{c=!0}if(!f)return;const a=i.responses.push(f)-1,$={wholeRange:w.Range.from(f.wholeRange),placeholder:f.placeholder};if(!D.h(f))return{...$,id:a,type:"editorEdit",message:w.MarkdownString.from(f.contents),edits:[]};const{edits:u,contents:S}=f,h=S!==void 0?w.MarkdownString.from(S):void 0;return u instanceof p.$cN?{...$,id:a,type:"bulkEdit",edits:w.WorkspaceEdit.from(u),message:h}:{...$,id:a,type:"editorEdit",edits:u.map(w.TextEdit.from),message:h}}async $provideFollowups(v,g,r,o){const s=this.b.get(v),i=this.d.get(g),n=i?.responses[r];if(s&&n&&s.provider.provideFollowups){const c=Promise.resolve(s.provider.provideFollowups(i.session,n,o));return(await(0,I.$kh)(c,o))?.map(w.ChatInlineFollowup.from)}}$handleFeedback(v,g,r,o){const s=this.b.get(v),i=this.d.get(g),n=i?.responses[r];if(s&&n){const c=w.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,c)}}$releaseSession(v,g){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$smc=D}),define(Ie[287],Pe([1,0,2,32]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class A{constructor(R,w,p,E,T){this.a=w,this.b=p,this.c=E;const D=new M.$QP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$OP("showOptions","Show Options",d=>!0,d=>d),new M.$OP("resource","Interactive resource Uri",d=>!0,d=>d),new M.$OP("controllerId","Notebook controller Id",d=>!0,d=>d),new M.$OP("title","Interactive editor title",d=>!0,d=>d)],new M.$PP("Notebook and input URI",d=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",d.notebookEditorId),d.notebookEditorId!==void 0){const v=this.a.getEditorById(d.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:I.URI.revive(d.notebookUri),inputUri:I.URI.revive(d.inputUri),notebookEditor:v.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",d.notebookUri,d.inputUri),{notebookUri:I.URI.revive(d.notebookUri),inputUri:I.URI.revive(d.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(R,w,p,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:p,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,w){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Fmc=A}),define(Ie[288],Pe([1,0,18,11,24,5,6,28,2,20,12,4,32,8,7,78,229,26,35,230]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0,e.$Nmc=u;let c=class{constructor(h,b,m,k,y){this.m=b,this.n=m,this.o=k,this.q=y,this.b=new w.$Bc,this.c=new w.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$ee,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=h.getProxy(D.$3M.MainThreadNotebookKernels);const C=new d.$QP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new d.$OP("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],d.$PP.Void),P=new d.$QP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[d.$OP.Uri],new d.$PP("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(P)}createNotebookController(h,b,m,k,y,C){for(const ae of this.j.values())if(ae.controller.id===b&&E.$Rm.equals(h.identifier,ae.extensionId))throw new Error(`notebook controller with id '${b}' ALREADY exist`);const P=this.k++,W=this;this.q.trace(`NotebookController[${P}], CREATED by ${h.identifier.value}, ${b}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${h.identifier}'`);let q=!1;const N=new O.$ee,U=new O.$ee,K={id:u(h.identifier,b),notebookType:m,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:k||h.identifier.value,preloads:C?C.map(v.NotebookRendererScript.from):[]};let ie=y??V,ce,ye;this.a.$addKernel(P,K).catch(ae=>{console.log(ae),q=!0});let Se=0;const fe=()=>{if(q)return;const ae=++Se;Promise.resolve().then(()=>{ae===Se&&this.a.$updateKernel(P,K)})},$e=new w.$Bc,Te={get id(){return b},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return K.label},set label(ae){K.label=ae??h.displayName??h.name,fe()},get detail(){return K.detail??""},set detail(ae){K.detail=ae,fe()},get description(){return K.description??""},set description(ae){K.description=ae,fe()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(ae){K.supportedLanguages=ae,fe()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){K.supportsExecutionOrder=ae,fe()},get rendererScripts(){return K.preloads?K.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(ae){ie=ae??V},get interruptHandler(){return ce},set interruptHandler(ae){ce=ae,K.supportsInterrupt=!!ae,fe()},set variableProvider(ae){(0,s.$IG)(h,"notebookVariableProvider"),ye=ae,K.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Ne=>W.a.$variablesUpdated(Ne.uri)),fe()},get variableProvider(){return ye},createNotebookCellExecution(ae){if(q)throw new Error("notebook controller is DISPOSED");if(!$e.has(ae.notebook.uri))throw W.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Ne=>Ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return W._createNotebookCellExecution(ae,u(h.identifier,this.id))},createNotebookExecution(ae){if((0,s.$IG)(h,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!$e.has(ae.uri))throw W.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(Ne=>Ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return W._createNotebookExecution(ae,u(h.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),N.dispose(),U.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(ae,Ne){Ne===g.NotebookControllerAffinity2.Hidden&&(0,s.$IG)(h,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(P,ae.uri,Ne)},onDidReceiveMessage:U.event,postMessage(ae,Ne){return(0,s.$IG)(h,"notebookMessaging"),W.a.$postMessage(P,Ne&&W.n.getIdByEditor(Ne),ae)},asWebviewUri(ae){return(0,s.$IG)(h,"notebookMessaging"),(0,r.$OAb)(ae,W.m.remote)}};return this.j.set(P,{extensionId:h.identifier,controller:Te,onDidReceiveMessage:U,onDidChangeSelection:N,associatedNotebooks:$e}),Te}getIdByController(h){for(const[b,m]of this.j)if(m.controller===h)return u(m.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,b){const m=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${m}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(m,b);const y={dispose:()=>{this.f.delete(m),k.a.$removeKernelDetectionTask(m)}};return this.f.set(m,y),y}registerKernelSourceActionProvider(h,b,m){const k=this.i++,y=typeof m.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,C=this;this.h.set(k,m),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,b);let P;return y!==void 0&&(P=m.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(k),C.a.$removeKernelSourceActionProvider(k,k),P?.dispose()}}}async $provideKernelSourceActions(h,b){const m=this.h.get(h);if(m){const k=new R.$Uc;return(await m.provideNotebookKernelSourceActions(b)??[]).map(C=>v.NotebookKernelSourceAction.from(C,this.o.converter,k))}return[]}$acceptNotebookAssociation(h,b,m){const k=this.j.get(h);if(k){const y=this.n.getNotebookDocument(p.URI.revive(b));m?k.associatedNotebooks.set(y.uri,!0):k.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${h}] ASSOCIATE notebook`,y.uri.toString(),m),k.onDidChangeSelection.fire({selected:m,notebook:y.apiNotebook})}}async $executeCells(h,b,m){const k=this.j.get(h);if(!k)return;const y=this.n.getNotebookDocument(p.URI.revive(b)),C=[];for(const P of m){const W=y.getCell(P);W&&C.push(W.apiCell)}try{this.q.trace(`NotebookController[${h}] EXECUTE cells`,y.uri.toString(),C.length),await k.controller.executeHandler.call(k.controller,C,y.apiNotebook,k.controller)}catch(P){this.q.error(`NotebookController[${h}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(h,b,m){const k=this.j.get(h);if(!k)return;const y=this.n.getNotebookDocument(p.URI.revive(b));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,y.apiNotebook);else for(const C of m){const P=y.getCell(C);P&&this.b.get(P.uri)?.cancel()}if(k.controller.interruptHandler){const C=this.c.get(y.uri);m.length&&Array.isArray(C)&&C.length&&C.forEach(P=>P.dispose())}}async $provideVariables(h,b,m,k,y,C,P){const W=this.j.get(h);if(!W)return;const V=this.n.getNotebookDocument(p.URI.revive(m)),q=W.controller.variableProvider;if(!q)return;let N;if(k!==void 0){if(N=this.s[k],!N)return}else this.s={};const U=y==="named"?g.NotebookVariablesRequestKind.Named:g.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(V.apiNotebook,N,U,C,P);let ie=0;for await(const ce of K){if(P.isCancellationRequested)return;const ye={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[ye.id]=ce.variable,this.a.$receiveVariable(b,ye),ie++>=n.$cjb)return}}$acceptKernelMessageFromRenderer(h,b,m){const k=this.j.get(h);if(!k)return;const y=this.n.getEditorById(b);k.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:m}))}$cellExecutionChanged(h,b,m){const y=this.n.getNotebookDocument(p.URI.revive(h)).getCell(b);if(y){const C=m?v.NotebookCellExecutionState.to(m):g.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(h,b){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const y=new t(b,k,this.a);this.b.set(k.uri,y);const C=y.onDidChangeState(()=>{y.state===l.Resolved&&(y.dispose(),C.dispose(),this.b.delete(k.uri))});return y.asApiObject()}_createNotebookExecution(h,b){const m=this.n.getNotebookDocument(h.uri),k=h.getCells().find(P=>{const W=m.getCellFromApiCell(P);return W&&this.b.has(W.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(m.uri))throw new Error(`duplicate notebook execution for ${m.uri}`);const y=new a(b,m,this.a),C=y.onDidChangeState(()=>{y.state===f.Resolved&&(y.dispose(),C.dispose(),this.c.delete(m.uri))});return this.c.set(m.uri,[y,C]),y.asApiObject()}};e.$Mmc=c,e.$Mmc=c=Je([We(4,T.$3j)],c);var l;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(l||(l={}));class t extends R.$Vc{static{this.a=0}get state(){return this.f}constructor(h,b,m){super(),this.m=b,this.n=m,this.b=t.a++,this.c=new O.$ee,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new A.$pe),this.h=new $(10,k=>this.s(k)),this.j=b.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const b=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$vw(b))}t(){if(this.f===l.Init)throw new Error("Must call start before modifying cell output");if(this.f===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let b=this.m;if(h&&(b=this.m.notebook.getCellFromApiCell(h)),!b)throw new Error("INVALID cell");return b.handle}y(h){return h.map(b=>{const m=g.$yO.ensureUniqueMimeTypes(b.items,!0);return m===b.items?v.NotebookCellOutput.from(b):v.NotebookCellOutput.from({items:m,id:b.id,metadata:b.metadata})})}async z(h,b,m){const k=this.w(b),y=this.y((0,I.$3b)(h));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:k,append:m,outputs:y})}async C(h,b,m){return h=g.$yO.ensureUniqueMimeTypes((0,I.$3b)(h),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:h.map(v.NotebookCellOutputItem.from),outputId:b.id,append:m})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(m){h.j=m,h.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(m){if(h.f===l.Resolved||h.f===l.Started)throw new Error("Cannot call start again");h.f=l.Started,h.c.fire(),h.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:m})},end(m,k,y){if(h.f===l.Resolved)throw new Error("Cannot call resolve twice");h.f=l.Resolved,h.c.fire(),h.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;h.n.$completeExecution(h.b,new i.$vw({runEndTime:k,lastRunSuccess:m,error:C}))},clearOutput(m){return h.t(),h.z([],m,!1)},appendOutput(m,k){return h.t(),h.z(m,k,!0)},replaceOutput(m,k){return h.t(),h.z(m,k,!1)},appendOutputItems(m,k){return h.t(),h.C(m,k,!0)},replaceOutputItems(m,k){return h.t(),h.C(m,k,!1)}})}}var f;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(f||(f={}));class a extends R.$Vc{static{this.a=0}get state(){return this.f}constructor(h,b,m){super(),this.h=b,this.j=m,this.b=a.a++,this.c=new O.$ee,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new A.$pe),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class ${constructor(h,b){this.f=h,this.g=b,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new M.$Th,this.b=Date.now(),(0,M.$xh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const b=this.a;return this.a=[],this.g(b).finally(()=>h.complete())}}function u(S,h){return`${S.value}/${h}`}}),define(Ie[53],Pe([1,0,5,4,3,2,17,6,7,180,14,208,24,34,209,36,11,8,32]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=e.$Zlc=e.$Ylc=e.$Xlc=void 0,e.$Xlc=(0,A.$wi)("IExtHostTerminalService");class n extends w.$Vc{constructor(m,k,y,C){super(),this.u=m,this._id=k,this.w=y,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$ee),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(W,V=!0){P.C(),P.u.$sendText(P._id,W,V)},show(W){P.C(),P.u.$show(P._id,W)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(m,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??k?.cwd??void 0,env:m.env??void 0,icon:u(m.iconPath)??void 0,color:r.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,forceShellIntegration:k?.forceShellIntegration??void 0,isFeatureTerminal:k?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:k?.useShellEnvironment??void 0,location:k?.location||this.z(m.location,k?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,k,y,C,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:r.ThemeColor.isThemeColor(P)?P.id:void 0,location:k?.location||this.z(m,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(m,k){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&k?{parentTerminal:k}:"viewColumn"in m?{viewColumn:s.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.y=m}setExitStatus(m,k){this.j=Object.freeze({code:m,reason:k})}setDimensions(m,k){return m===this.f&&k===this.h||m===0||k===0?!1:(this.f=m,this.h=k,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(m){this.n=m}_setProcessId(m){this.g?(this.g(m),this.g=void 0):this.b.then(k=>{k!==m&&(this.b=Promise.resolve(m))})}}e.$Ylc=n;class c{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new I.$ee,this.onProcessData=this.a.event,this.b=new I.$ee,this.d=new I.$ee,this.onDidChangeProperty=this.d.event,this.f=new I.$ee,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,k){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${k}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,k){this.g.setDimensions?.({columns:m,rows:k})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(k=>this.a.fire(k)),this.g.onDidClose?.((k=void 0)=>{this.f.fire(k===void 0?void 0:k)}),this.g.onDidOverrideDimensions?.(k=>{k&&this.d.fire({type:"overrideDimensions",value:{cols:k.columns,rows:k.rows}})}),this.g.onDidChangeName?.(k=>{this.d.fire({type:"title",value:k})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,t=class extends w.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,k,y){super(),this.Q=k,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new w.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$ee,this.onDidCloseTerminal=this.H.event,this.I=new I.$ee,this.onDidOpenTerminal=this.I.event,this.J=new I.$ee,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$ee,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$ee,this.onDidChangeTerminalState=this.M.event,this.N=new I.$ee,this.onDidChangeShell=this.N.event,this.O=new I.$ee({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$ee({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(M.$3M.MainThreadTerminalService),this.y=new g.$Gvb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:C=>{const P=W=>{const V=W;return this.getTerminalById(V.instanceId)?.value};switch(C?.$mid){case 15:return P(C);default:{if(Array.isArray(C))for(let W=0;W<C.length&&C[W].$mid===15;W++)C[W]=P(C[W]);return C}}}}),this.B({dispose:()=>{for(const[C,P]of this.g)P.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,k){const y=new n(this.a,(0,v.$Sg)(),m,m.name),C=new c(m.pty);return y.createExtensionTerminal(m.location,k,this.R(m,k).resolvedExtHostIdentifier,u(m.iconPath),S(m.color)).then(P=>{const W=this.S(P,C);this.h[P]=W}),this.f.push(y),y.value}R(m,k){if(k=k||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const y=m.location.parentTerminal;if(y){const C=this.f.find(P=>P.value===y);C&&(k.resolvedExtHostIdentifier=C._id)}}else m.location&&typeof m.location!="object"?k.location=m.location:k.location&&typeof k.location=="object"&&"splitActiveTerminal"in k.location&&(k.location={splitActiveTerminal:!0});return k}attachPtyToTerminal(m,k){if(!this.getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const C=new c(k),P=this.S(m,C);this.h[m]=P}async $acceptActiveTerminalChanged(m){const k=this.b;if(m===null){this.b=void 0,k!==this.b&&this.J.fire(this.b);return}const y=this.getTerminalById(m);y&&(this.b=y,k!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,k){const y=this.getTerminalById(m);y&&this.O.fire({terminal:y.value,data:k})}async $acceptTerminalDimensions(m,k,y){const C=this.getTerminalById(m);C&&C.setDimensions(k,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(m,k){const y=this.getTerminalById(m);y&&this.P.fire({terminal:y.value,...k})}async $acceptTerminalMaximumDimensions(m,k,y){this.g.get(m)?.resize(k,y)}async $acceptTerminalTitleChange(m,k){const y=this.getTerminalById(m);y&&(y.name=k)}async $acceptTerminalClosed(m,k,y){const C=this.X(this.f,m);if(C!==null){const P=this.f.splice(C,1)[0];P.setExitStatus(k,y),this.H.fire(P.value)}}$acceptTerminalOpened(m,k,y,C){if(k){const V=this.X(this.f,k);if(V!==null){this.f[V]._id=m,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:O.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},W=new n(this.a,m,P,y);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(m,k){this.getTerminalById(m)?._setProcessId(k)}async $startExtensionTerminal(m,k){const y=this.getTerminalById(m);if(!y)return{message:(0,E.localize)(0,null,m)};y.isOpen||await new Promise(P=>{const W=this.onDidOpenTerminal(async V=>{V===y.value&&(W.dispose(),P())})});const C=this.g.get(m);C?C.startSendingEvents(k):this.j[m]={initialDimensions:k}}S(m,k){const y=new w.$Uc;y.add(k.onProcessReady(P=>this.a.$sendProcessReady(m,P.pid,P.cwd,P.windowsPty))),y.add(k.onDidChangeProperty(P=>this.a.$sendProcessProperty(m,P))),this.y.startBuffering(m,k.onProcessData),y.add(k.onProcessExit(P=>this.U(m,P))),this.g.set(m,k);const C=this.j[m];return C&&k instanceof c&&(k.startSendingEvents(C.initialDimensions),delete this.j[m]),y}$acceptProcessAckDataEvent(m,k){this.g.get(m)?.acknowledgeDataEvent(k)}$acceptProcessInput(m,k){this.g.get(m)?.input(k)}$acceptTerminalInteraction(m){const k=this.getTerminalById(m);k?.setInteractedWith()&&this.M.fire(k.value)}$acceptTerminalSelection(m,k){this.getTerminalById(m)?.setSelection(k)}$acceptProcessResize(m,k,y){try{this.g.get(m)?.resize(k,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(m,k){this.g.get(m)?.shutdown(k)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(k=>this.a.$sendProcessProperty(m,{type:"initialCwd",value:k}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(k=>this.a.$sendProcessProperty(m,{type:"cwd",value:k}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new p.$5M(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,k,y){if(this.C.has(k))throw new Error(`Terminal profile provider "${k}" already registered`);return this.C.set(k,y),this.a.$registerProfileProvider(k,m.identifier.value),new p.$5M(()=>{this.C.delete(k),this.a.$unregisterProfileProvider(k)})}registerTerminalQuickFixProvider(m,k,y){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,y),this.a.$registerQuickFixProvider(m,k),new p.$5M(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,k){const y=new d.$pe().token;if(y.isCancellationRequested)return;const C=this.D.get(m);if(!C)return;const P=await C.provideTerminalQuickFixes(k,y);if(P===null||Array.isArray(P)&&P.length===0)return;const W=new w.$Uc;if(this.w.value=W,!Array.isArray(P))return P?s.TerminalQuickFix.from(P,this.Q.converter,W):void 0;const V=[];for(const q of P){const N=s.TerminalQuickFix.from(q,this.Q.converter,W);N&&V.push(N)}return V}async $createContributedProfileTerminal(m,k){const y=new d.$pe().token;let C=await this.C.get(m)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,k);return}this.createTerminalFromOptions(C.options,k)}}async $provideLinks(m,k){const y=this.getTerminalById(m);if(!y)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const P=new d.$pe;this.G.set(m,P);const W=[],V={terminal:y.value,line:k},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async ie=>{P.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const ce=await K.provideTerminalLinks(V,P.token)||[];P.token.isCancellationRequested||ie({provider:K,links:ce})}));const N=await Promise.all(q);if(P.token.isCancellationRequested)return[];const U=new Map;for(const K of N)K&&K.links.length>0&&W.push(...K.links.map(ie=>{const ce={id:l++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return U.set(ce.id,{provider:K.provider,link:ie}),ce}));return this.F.set(m,U),W}$activateLink(m,k){const y=this.F.get(m)?.get(k);y&&y.provider.handleTerminalLink(y.link)}U(m,k){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const y=this.h[m];y&&(y.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,k)}getTerminalById(m){return this.W(this.f,m)}getTerminalIdByApiObject(m){const k=this.f.findIndex(y=>y.value===m);return k>=0?k:null}W(m,k){const y=this.X(m,k);return y!==null?m[y]:null}X(m,k){const y=m.findIndex(C=>C._id===k);return y>=0?y:null}getEnvironmentVariableCollection(m){let k=this.n.get(m.identifier.value);return k||(k=new f,this.Z(m.identifier.value,k)),k.getScopedEnvironmentVariableCollection(void 0)}Y(m,k){const y=(0,D.$ls)(k.map),C=(0,D.$ms)(k.descriptionMap);this.a.$setEnvironmentVariableCollection(m,k.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(m){m.forEach(k=>{const y=k[0],C=new f(k[1]);this.Z(y,C)})}$acceptDefaultProfile(m,k){const y=this.s;this.s=m,this.u=k,y?.path!==m.path&&this.N.fire(m.path)}Z(m,k){this.n.set(m,k),k.onDidChangeCollection(()=>{this.Y(m,k)})}};e.$Zlc=t,e.$Zlc=t=Je([We(1,i.$MP),We(2,R.$qP)],t);class f{get persistent(){return this.b}set persistent(m){this.b=m,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(m){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$ee,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const k=this.h(m);let y=this.a.get(k);return y||(y=new a(this,m),this.a.set(k,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(m,k,y,C){this.f(m,{value:k,type:p.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(m,k,y,C){this.f(m,{value:k,type:p.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(m,k,y,C){this.f(m,{value:k,type:p.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(m,k){if(k.options&&k.options.applyAtProcessCreation===!1&&!k.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(m,k.scope),C=this.map.get(y),P=k.options?{applyAtProcessCreation:k.options.applyAtProcessCreation??!1,applyAtShellIntegration:k.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==k.value||C.type!==k.type||C.options?.applyAtProcessCreation!==P.applyAtProcessCreation||C.options?.applyAtShellIntegration!==P.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==k.scope?.workspaceFolder?.index){const W=this.g(m,k.scope),V={variable:m,...k,options:P};this.map.set(W,V),this.d.fire()}}get(m,k){const y=this.g(m,k),C=this.map.get(y);return C?h(C):void 0}g(m,k){const y=this.h(k);return y.length?`${m}:::${y}`:m}h(m){return this.j(m?.workspaceFolder)??""}j(m){return m?m.uri.toString():void 0}getVariableMap(m){const k=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(m)&&k.set(C.variable,h(C));return k}delete(m,k){const y=this.g(m,k);this.map.delete(y),this.d.fire()}clear(m){if(m?.workspaceFolder){for(const[k,y]of this.map)y.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(k);this.k(m)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(m,k){const y=this.h(k),C=this.descriptionMap.get(y);if(!C||C.description!==m){let P;typeof m=="string"?P=m:P=m?.value.split(`

`)[0];const W={description:P,scope:k};this.descriptionMap.set(y,W),this.d.fire()}}getDescription(m){const k=this.h(m);return this.descriptionMap.get(k)?.description}k(m){const k=this.h(m);this.descriptionMap.delete(k)}}class a{get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,k){this.b=m,this.d=k,this.a=new I.$ee}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,k,y){this.b.replace(m,k,y,this.d)}append(m,k,y){this.b.append(m,k,y,this.d)}prepend(m,k,y){this.b.prepend(m,k,y,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,k){this.b.getVariableMap(this.d).forEach((y,C)=>m.call(k,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let $=class extends t{constructor(m,k){super(!1,m,k)}createTerminal(m,k,y){throw new T.$_}createTerminalFromOptions(m,k){throw new T.$_}};e.$1lc=$,e.$1lc=$=Je([We(0,i.$MP),We(1,R.$qP)],$);function u(b){if(!(!b||typeof b=="string"))return"id"in b?{id:b.id,color:b.color}:b}function S(b){return r.ThemeColor.isThemeColor(b)?b:void 0}function h(b){const m={...b};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(Ie[116],Pe([1,0,7,6,3,4,17,53,5,2,11]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=e.$5mc=void 0,e.$5mc=(0,A.$wi)("IExtHostTerminalShellIntegration");let D=class extends M.$Vc{constructor(o,s){super(),this.h=s,this.b=new Map,this.c=new p.$ee,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$ee,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$ee,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$3M.MainThreadTerminalShellIntegration),this.B((0,M.$Tc)(()=>{for(const[i,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(o){const s=this.h.getTerminalById(o);if(!s)return;const i=s.value;let n=this.b.get(o);n||(n=new d(s.value,this.f),this.b.set(o,n),n.store.add(s.onWillDispose(()=>this.b.get(o)?.dispose())),n.store.add(n.onDidRequestShellExecution(c=>this.a.$executeCommand(o,c))),n.store.add(n.onDidRequestEndExecution(c=>this.g.fire(c))),n.store.add(n.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),s.shellIntegration=n.value),this.c.fire({terminal:i,shellIntegration:n.value})}$shellExecutionStart(o,s,i,n,c){this.b.has(o)||this.$shellIntegrationChange(o);const l={value:s,confidence:i,isTrusted:n};this.b.get(o)?.startShellExecution(l,c)}$shellExecutionEnd(o,s,i,n,c){const l={value:s,confidence:i,isTrusted:n};this.b.get(o)?.endShellExecution(l,c)}$shellExecutionData(o,s){this.b.get(o)?.emitData(s)}$cwdChange(o,s){this.b.get(o)?.setCwd((0,E.$wc)(s)?E.URI.revive(s):s)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$6mc=D,e.$6mc=D=Je([We(0,R.$qP),We(1,w.$Xlc)],D);class d extends M.$Vc{get currentExecution(){return this.a}constructor(o,s){super(),this.j=o,this.m=s,this.b=!1,this.store=this.B(new M.$Uc),this.f=this.B(new p.$ee),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$ee),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$ee),this.onDidRequestEndExecution=this.h.event;const i=this;this.value={get cwd(){return i.c},executeCommand(n,c){let l=n;c&&(l+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),i.g.fire(l);const t={value:l,confidence:I.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},f=i.startShellExecution(t,i.c,!0).value;return i.b=!0,f}}}startShellExecution(o,s,i){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new v(o,s);i?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,s){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:s}),this.a=void 0)}setCwd(o){let s=!1;E.URI.isUri(this.c)?s=!E.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(s=!0),s&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class v{constructor(o,s){this.c=o,this.cwd=s,this.b=!1;const i=this;this.value={get commandLine(){return i.c},get cwd(){return i.cwd},read(){return i.d()}}}d(){if(!this.a){if(this.b)return T.$Wh.EMPTY;this.a=new g}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class g extends M.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new T.$vh);const o=this.a;return new T.$Wh(async i=>{this.b.push(i),await o.wait()})}emitData(o){for(const s of this.b)s.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ie[289],Pe([1,0,11,21,24,5,261,73,6,15,34,12,4,17,115,8,7,52,77,62]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=e.$8mc=e.$7mc=void 0;let c=class extends p.$Vc{constructor(P,W,V,q){super(),this.w=q,this.f=this.B(new O.$ee),this.g=new Map,this.s=this.B(new O.$ee),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(d.$3M.MainThreadTesting),this.m=new b(this.h),this.j=new a(this.h,W),V.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const U=N,K=U.tests[U.tests.length-1].item.extId;return this.g.get(s.$OL.root(K))?.collection.tree.get(K)?.actual??(0,g.$CP)(N)}case 18:{const{test:U,message:K}=N,ie=U.item.extId;return{test:this.g.get(s.$OL.root(ie))?.collection.tree.get(ie)?.actual??(0,g.$CP)({$mid:16,tests:[U]}),message:r.TestMessage.to(K)}}default:return N}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await V.executeCommand("_testing.getExplorerSelection"),U=K=>{const ie=this.g.get(s.$OL.root(K));if(ie)return s.$OL.isRoot(K)?ie.controller:ie.collection.tree.get(K)?.actual};return{include:N?.include.map(U).filter(E.$eg)||[],exclude:N?.exclude.map(U).filter(E.$eg)||[]}})}createTestController(P,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const N=new p.$Uc,U=N.add(new g.$FP(W,V,this.w));U.root.label=V;const K=new Map,ie=new Set,ce=this.h,ye={items:U.root.children,get label(){return V},set label(fe){V=fe,U.root.label=fe,ce.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(fe){q=fe,ce.$updateController(W,{canRefresh:!!fe})},get id(){return W},createRunProfile:(fe,$e,Te,ae,Ne,ne)=>{let z=(0,w.$kj)(fe);for(;K.has(z);)z++;return new k(this.h,K,ie,this.s.event,W,z,fe,$e,Te,ae,Ne,ne)},createTestItem(fe,$e,Te){return new g.$DP(W,fe,$e,Te)},createTestRun:(fe,$e,Te=!0)=>this.j.createTestRun(W,U,fe,$e,Te),invalidateTestResults:fe=>{if(fe===void 0)this.h.$markTestRetired(void 0);else{const $e=fe instanceof Array?fe:[fe];this.h.$markTestRetired($e.map(Te=>s.$OL.fromExtHostTestItem(Te,W).toString()))}},set resolveHandler(fe){U.resolveHandler=fe},get resolveHandler(){return U.resolveHandler},dispose:()=>{N.dispose()}};ce.$registerTestController(W,V,!!q),N.add((0,p.$Tc)(()=>ce.$unregisterTestController(W)));const Se={controller:ye,collection:U,profiles:K,extension:P,activeProfiles:ie};return this.g.set(W,Se),N.add((0,p.$Tc)(()=>this.g.delete(W))),N.add(U.onDidGenerateDiff(fe=>ce.$publishDiff(W,fe.map(n.TestsDiffOp.serialize)))),ye}createTestObserver(){return this.m.checkout()}async runTests(P,W=A.CancellationToken.None){const V=$(P);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:P.preserveFocus??!0,targets:[{testIds:P.include?.map(N=>s.$OL.fromExtHostTestItem(N,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:y[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:P.exclude?.map(N=>N.id)},W)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,W){return(await this.j.getCoverageDetails(P,W))?.map(r.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,W){this.g.get(P)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(P){const W=new Map;for(const[V,q]of Object.entries(P)){const N=this.g.get(V);if(!N)continue;const U=new Map,K=q.filter(ce=>!N.activeProfiles.has(ce)),ie=[...N.activeProfiles].filter(ce=>!q.includes(ce));for(const ce of K)U.set(ce,!0),N.activeProfiles.add(ce);for(const ce of ie)U.set(ce,!1),N.activeProfiles.delete(ce);U.size&&W.set(V,U)}this.s.fire(W)}async $refreshTests(P,W){await this.g.get(P)?.controller.refreshHandler?.(W)}$publishTestResults(P){this.results=Object.freeze(P.map(r.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,W){const V=this.g.get(s.$OL.fromString(P).controllerId)?.collection;V&&(await V.expand(P,W<0?1/0:W),V.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(W=>n.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(P,W){return Promise.all(P.map(V=>this.y(V,!1,W)))}async $startContinuousRun(P,W){const V=new A.$pe(W),q=await Promise.all(P.map(N=>this.y(N,!0,V.token)));return!W.isCancellationRequested&&!q.some(N=>N.error)&&await new Promise(N=>W.onCancellationRequested(N)),V.dispose(!0),q}async y(P,W,V){const q=this.g.get(P.controllerId);if(!q)return{};const{collection:N,profiles:U}=q,K=U.get(P.profileId);if(!K)return{};const ie=P.testIds.map(fe=>N.tree.get(fe)).filter(E.$eg),ce=P.excludeExtIds.map(fe=>q.collection.tree.get(fe)).filter(E.$eg).filter(fe=>ie.some($e=>$e.fullId.compare(fe.fullId)===2));if(!ie.length)return{};const ye=new o.$FO(ie.some(fe=>fe.actual instanceof g.$EP)?void 0:ie.map(fe=>fe.actual),ce.map(fe=>fe.actual),K,W),Se=(0,n.$RL)(P)&&this.j.prepareForMainThreadTestRun(ye,u.fromInternal(P,q.collection),K,V);try{return await K.runHandler(ye,V),{}}catch(fe){return{error:String(fe)}}finally{Se&&Se.hasRunningTasks&&!V.isCancellationRequested&&await O.Event.toPromise(Se.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$7mc=c,e.$7mc=c=Je([We(0,v.$qP),We(1,D.$3j)],c);const l=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class f extends p.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(P,W,V,q,N){super(),this.y=P,this.z=W,this.C=V,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$ee),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new A.$pe(N));const U=this.B(new I.$Ih(()=>this.F(),l));this.B(this.j.token.onCancellationRequested(()=>U.schedule()));const K=new O.$ee;this.s=K.event,this.B((0,p.$Tc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(P,W){const[,V,q]=s.$OL.fromString(P).path,N=this.w.get(q);if(!N)return[];const U=this.g.get(V);if(!U)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(U.run,N,W)??[]}createRun(P){const W=this.y.id,V=this.y.controllerId,q=(0,T.$Sg)(),N=ce=>(ye,...Se)=>{if(K){this.C.warn(`Setting the state of test "${ye.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ye)&&(this.H(ye),ce(ye,...Se))},U=(ce,ye)=>{const Se=ye instanceof Array?ye.map(r.TestMessage.from):[r.TestMessage.from(ye)];if(ce.uri&&ce.range){const fe={range:r.Range.from(ce.range),uri:ce.uri};for(const $e of Se)$e.location=$e.location||fe}this.z.$appendTestMessagesInRun(W,q,s.$OL.fromExtHostTestItem(ce,V).toString(),Se)};let K=!1;const ie={isPersisted:this.y.isPersisted,token:this.j.token,name:P,onDidDispose:this.s,addCoverage:ce=>{const ye=ce.uri.toString(),Se=new s.$OL([W,q,ye]).toString();this.w.set(ye,ce),this.z.$appendCoverage(W,q,r.TestCoverage.fromFile(Se,ce))},enqueued:N(ce=>{this.z.$updateTestStateInRun(W,q,s.$OL.fromExtHostTestItem(ce,V).toString(),1)}),skipped:N(ce=>{this.z.$updateTestStateInRun(W,q,s.$OL.fromExtHostTestItem(ce,V).toString(),5)}),started:N(ce=>{this.z.$updateTestStateInRun(W,q,s.$OL.fromExtHostTestItem(ce,V).toString(),2)}),errored:N((ce,ye,Se)=>{U(ce,ye),this.z.$updateTestStateInRun(W,q,s.$OL.fromExtHostTestItem(ce,V).toString(),6,Se)}),failed:N((ce,ye,Se)=>{U(ce,ye),this.z.$updateTestStateInRun(W,q,s.$OL.fromExtHostTestItem(ce,V).toString(),4,Se)}),passed:N((ce,ye)=>{this.z.$updateTestStateInRun(W,q,s.$OL.fromExtHostTestItem(ce,this.y.controllerId).toString(),3,ye)}),appendOutput:(ce,ye,Se)=>{K||(Se&&(this.y.isIncluded(Se)?this.H(Se):Se=void 0),this.z.$appendOutputToRun(W,q,M.$Ge.fromString(ce),ye&&r.location.from(ye),Se&&s.$OL.fromExtHostTestItem(Se,V).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(W,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:ie}),this.z.$startedTestRunTask(W,{id:q,name:P,running:!0}),ie}F(){for(const{run:P}of this.g.values())P.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(P){if(!(P instanceof g.$DP))throw new i.$iP(P.id);if(this.h.has(s.$OL.fromExtHostTestItem(P,this.y.controllerId).toString()))return;const W=[],V=this.y.colllection.root;for(;;){const q=r.TestItem.from(P);if(W.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),P===V))break;P=P.parent||V}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(P,W){this.g=P,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(P,W){const V=s.$OL.root(P);return this.f.get(V)?.getCoverageDetails(P,W)||[]}disposeTestRun(P){this.f.get(P)?.dispose(),this.f.delete(P);for(const[W,{id:V}]of this.c)V===P&&this.c.delete(W)}prepareForMainThreadTestRun(P,W,V,q){return this.j(P,W,V,q)}cancelRunById(P){this.f.get(P)?.cancel()}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,W,V,q,N){const U=this.c.get(V);if(U)return U.createRun(q);const K=u.fromPublic(P,W,V,N),ie=$(V);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!V.continuous,profile:ie&&{group:y[ie.kind],id:ie.profileId},exclude:V.exclude?.map(ye=>s.$OL.fromExtHostTestItem(ye,W.root.id).toString())??[],id:K.id,include:V.include?.map(ye=>s.$OL.fromExtHostTestItem(ye,W.root.id).toString())??[W.root.id],preserveFocus:V.preserveFocus??!0,persist:N});const ce=this.j(V,K,V.profile);return O.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ce.createRun(q)}j(P,W,V,q){const N=new f(W,this.g,this.h,V,q);return this.c.set(P,N),this.f.set(N.id,N),N}}e.$8mc=a;const $=C=>{if(C.profile){if(!(C.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class u{static fromPublic(P,W,V,q){return new u(P,(0,T.$Sg)(),V.include?.map(N=>s.$OL.fromExtHostTestItem(N,P).toString())??[P],V.exclude?.map(N=>s.$OL.fromExtHostTestItem(N,P).toString())??[],q,W)}static fromInternal(P,W){return new u(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,W)}constructor(P,W,V,q,N,U){this.controllerId=P,this.id=W,this.isPersisted=N,this.colllection=U,this.c=V.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(P){const W=s.$OL.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const V of this.f)if(W===V||W.startsWith(V))return!1;for(const V of this.c)if(W===V||W.startsWith(V))return!0;return!1}}e.$9mc=u;class S{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(P){this.j=P,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,r.TestItem.toPlain(P.item)),this.c.has(P)||this.f.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.f.delete(P);const W=s.$OL.parentId(P.item.extId);if(W&&this.h.has(W.toString())){this.h.add(P.item.extId);return}this.g.add(P)}getChangeEvent(){const{c:P,f:W,g:V}=this;return{get added(){return[...P].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class h extends n.$XL{constructor(){super(...arguments),this.s=new O.$ee,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(P){return this.f.get(P)}getMirroredTestDataByReference(P){return this.f.get(P.id)}w(P,W){return{...P,revived:r.TestItem.toPlain(P.item),depth:W?W.depth+1:0,children:new Set}}v(){return new S(this.s)}}class b{constructor(P){this.f=P}checkout(){this.c||(this.c=this.g());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(W=>W.revived)},dispose:(0,R.$db)(()=>{--P.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}g(){const P=new h({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:P}}}const m=(C,P,W,V)=>{W?Object.assign(W,V):P.$updateTestRunConfig(C.controllerId,C.profileId,V)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(P){P!==this.f&&(this.f=P,m(this,this.#e,this.#n,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,m(this,this.#e,this.#n,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),m(this,this.#e,this.#n,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,m(this,this.#e,this.#n,{tag:P?r.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,m(this,this.#e,this.#n,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return O.Event.chain(this.#i,P=>P.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(E.$eg))}constructor(P,W,V,q,N,U,K,ie,ce,ye=!1,Se=void 0,fe=!1){this.controllerId=N,this.profileId=U,this.f=K,this.kind=ie,this.runHandler=ce,this._tag=Se,this.g=fe,this.#e=P,this.#s=W,this.#t=V,this.#i=q,W.set(U,this);const $e=y[ie];if(typeof $e!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);ye&&V.add(U),this.#n={profileId:U,controllerId:N,tag:Se?r.TestTag.namespace(this.controllerId,Se.id):null,label:K,group:$e,isDefault:ye,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$0mc=k;const y={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ie[117],Pe([1,0,57,14,91,8,7]),function(le,e,I,M,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=e.$yP=e.$xP=void 0;class w{static{this.c=new A.$vP("TextEditorDecorationType")}constructor(d,v,g){const r=w.c.nextId();d.$registerTextEditorDecorationType(v.identifier,r,O.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){d.$removeTextEditorDecorationType(r)}})}}e.$xP=w;class p{constructor(d,v){this.g=[],this.h=void 0,this.j=!1,this.c=d,this.d=d.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(d,v){this.k();let g=null;if(d instanceof R.$6M)g=new R.$7M(d,d);else if(d instanceof R.$7M)g=d;else throw new Error("Unrecognized location");this.l(g,v,!1)}insert(d,v){this.k(),this.l(new R.$7M(d,d),v,!0)}delete(d){this.k();let v=null;if(d instanceof R.$7M)v=d;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(d,v,g){const r=this.c.validateRange(d);this.g.push({range:r,text:v,forceMoveMarkers:g})}setEndOfLine(d){if(this.k(),d!==R.EndOfLine.LF&&d!==R.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=d}}class E{constructor(d,v,g,r){this.c=d,this.d=v,this._accept(g),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(d){this.f=d.tabSize,this.g=d.indentSize,this.h=d.originalIndentSize,this.j=d.insertSpaces,this.k=d.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(d.lineNumbers)}m(d){if(d==="auto")return"auto";if(typeof d=="number"){const v=Math.floor(d);return v>0?v:null}if(typeof d=="string"){const v=parseInt(d,10);return isNaN(v)?null:v>0?v:null}return null}n(d){const v=this.m(d);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(d){if(d==="tabSize")return"tabSize";if(typeof d=="number"){const v=Math.floor(d);return v>0?v:null}if(typeof d=="string"){const v=parseInt(d,10);return isNaN(v)?null:v>0?v:null}return null}p(d){const v=this.o(d);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(d){return d==="auto"?"auto":d==="false"?!1:!!d}s(d){const v=this.q(d);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(d){this.k!==d&&(this.k=d,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:d})))}u(d){this.l!==d&&(this.l=d,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(d)})))}assign(d){const v={};let g=!1;if(typeof d.tabSize<"u"){const r=this.m(d.tabSize);r==="auto"?(g=!0,v.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,g=!0,v.tabSize=r)}if(typeof d.indentSize<"u"){const r=this.o(d.indentSize);r==="tabSize"?(g=!0,v.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,g=!0,v.indentSize=r)}if(typeof d.insertSpaces<"u"){const r=this.q(d.insertSpaces);r==="auto"?(g=!0,v.insertSpaces=r):this.j!==r&&(this.j=r,g=!0,v.insertSpaces=r)}typeof d.cursorStyle<"u"&&this.k!==d.cursorStyle&&(this.k=d.cursorStyle,g=!0,v.cursorStyle=d.cursorStyle),typeof d.lineNumbers<"u"&&this.l!==d.lineNumbers&&(this.l=d.lineNumbers,g=!0,v.lineNumbers=O.TextEditorLineNumbersStyle.from(d.lineNumbers)),g&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(d,v){v.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${d}' failed:'`),this.e.warn(g)})}}e.$yP=E;class T{constructor(d,v,g,r,o,s,i,n){this.id=d,this.j=v,this.k=g,this.g=!1,this.h=new Set,this.c=o,this.d=new E(this.j,this.id,s,g),this.e=i,this.f=n;const c=this;this.value=Object.freeze({get document(){return r.value},set document(l){throw new M.$9("document")},get selection(){return c.c&&c.c[0]},set selection(l){if(!(l instanceof R.$8M))throw(0,M.$7)("selection");c.c=[l],c.l()},get selections(){return c.c},set selections(l){if(!Array.isArray(l)||l.some(t=>!(t instanceof R.$8M)))throw(0,M.$7)("selections");c.c=l,c.l()},get visibleRanges(){return c.e},set visibleRanges(l){throw new M.$9("visibleRanges")},get options(){return c.d.value},set options(l){c.g||c.d.assign(l)},get viewColumn(){return c.f},set viewColumn(l){throw new M.$9("viewColumn")},edit(l,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new p(r.value,t);return l(f),c.m(f)},insertSnippet(l,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c.c.map($=>O.Range.from($));else if(t instanceof R.$6M){const{lineNumber:$,column:u}=O.Position.from(t);a=[{startLineNumber:$,startColumn:u,endLineNumber:$,endColumn:u}]}else if(t instanceof R.$7M)a=[O.Range.from(t)];else{a=[];for(const $ of t)if($ instanceof R.$7M)a.push(O.Range.from($));else{const{lineNumber:u,column:S}=O.Position.from($);a.push({startLineNumber:u,startColumn:S,endLineNumber:u,endColumn:S})}}return v.$tryInsertSnippet(d,r.value.version,l.value,a,f)},setDecorations(l,t){const f=t.length===0;f&&!c.h.has(l.key)||(f?c.h.delete(l.key):c.h.add(l.key),c.n(()=>{if(O.$nP(t))return v.$trySetDecorations(d,l.key,O.$oP(t));{const a=new Array(4*t.length);for(let $=0,u=t.length;$<u;$++){const S=t[$];a[4*$]=S.start.line+1,a[4*$+1]=S.start.character+1,a[4*$+2]=S.end.line+1,a[4*$+3]=S.end.character+1}return v.$trySetDecorationsFast(d,l.key,a)}}))},revealRange(l,t){c.n(()=>v.$tryRevealRange(d,O.Range.from(l),t||R.TextEditorRevealType.Default))},show(l){v.$tryShowEditor(d,O.ViewColumn.from(l))},hide(){v.$tryHideEditor(d)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(d){(0,I.ok)(!this.g),this.d._accept(d)}_acceptVisibleRanges(d){(0,I.ok)(!this.g),this.e=d}_acceptViewColumn(d){(0,I.ok)(!this.g),this.f=d}_acceptSelections(d){(0,I.ok)(!this.g),this.c=d}async l(){const d=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,d)),this.value}m(d){const v=d.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const g=v.edits.map(o=>o.range);g.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=g.length-1;o<s;o++){const i=g[o].end;if(g[o+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=v.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,r,{setEndOfLine:typeof v.setEndOfLine=="number"?O.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(d){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$zP=T}),define(Ie[68],Pe([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.$AP=void 0;class s{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(c,l){this.h=c,this.i=l,this.a=null,this.b=new Map,this.c=new v.$Bc,this.d=new M.$ee,this.e=new M.$ee,this.f=new M.$ee,this.g=new M.$ee,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const l=[],t=[],f=[];if(c.removedDocuments)for(const a of c.removedDocuments){const $=O.URI.revive(a),u=this.c.get($);u?.unref()&&(this.c.delete($),l.push(u.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const $=O.URI.revive(a.uri);let u=this.c.get($);if(u&&$.scheme!==g.Schemas.vscodeNotebookCell&&$.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${$} already exists!'`);u||(u=new s(new p.$tP(this.h.getProxy(w.$3M.MainThreadDocuments),$,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set($,u),t.push(u.value)),u.ref()}if(c.removedEditors)for(const a of c.removedEditors){const $=this.b.get(a);this.b.delete(a),$&&f.push($)}if(c.addedEditors)for(const a of c.addedEditors){const $=O.URI.revive(a.documentUri);I.ok(this.c.has($),`document '${$}' does not exist`),I.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const u=this.c.get($).value,S=new T.$zP(a.id,this.h.getProxy(w.$3M.MainThreadTextEditors),this.i,new o.$V(()=>u.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(h=>D.Range.to(h)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,S)}c.newActiveEditor!==void 0&&(I.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,A.$Qc)(l),(0,A.$Qc)(f),c.removedDocuments&&this.e.fire(l),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const l=this.b.get(this.a);return c?l:l?.value}allEditors(){return[...this.b.values()]}};e.$AP=i,e.$AP=i=Je([We(0,E.$qP),We(1,d.$3j)],i),e.$BP=(0,R.$wi)("IExtHostDocumentsAndEditors")}),define(Ie[290],Pe([1,0,18,5,4,117,8,7]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;class p{constructor(T,D){this.i=D,this.a=new M.$ee,this.b=new M.$ee,this.c=new M.$ee,this.d=new M.$ee,this.f=new M.$ee,this.g=new M.$ee,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(A.$3M.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(d=>this.g.fire(d)),this.i.onDidChangeActiveTextEditor(d=>this.f.fire(d))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const D=this.i.allEditors();return T?D:D.map(d=>d.value)}async showTextDocument(T,D,d){let v;typeof D=="number"?v={position:R.ViewColumn.from(D),preserveFocus:d}:typeof D=="object"?v={position:R.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?R.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:v={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(T.uri,v),r=g&&this.i.getEditor(g);if(r)return r.value;throw g?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,D){return new O.$xP(this.h,T,D).value}$acceptEditorPropertiesChanged(T,D){const d=this.i.getEditor(T);if(!d)throw new Error("unknown text editor");if(D.options&&d._acceptOptions(D.options),D.selections){const v=D.selections.selections.map(R.Selection.to);d._acceptSelections(v)}if(D.visibleRanges){const v=I.$Hb(D.visibleRanges.map(R.Range.to));d._acceptVisibleRanges(v)}if(D.options&&this.b.fire({textEditor:d.value,options:{...D.options,lineNumbers:R.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const v=w.TextEditorSelectionChangeKind.fromValue(D.selections.source),g=D.selections.selections.map(R.Selection.to);this.a.fire({textEditor:d.value,selections:g,kind:v})}if(D.visibleRanges){const v=I.$Hb(D.visibleRanges.map(R.Range.to));this.c.fire({textEditor:d.value,visibleRanges:v})}}$acceptEditorPositionData(T){for(const D in T){const d=this.i.getEditor(D);if(!d)throw new Error("Unknown text editor");const v=R.ViewColumn.to(T[D]);d.value.viewColumn!==v&&(d._acceptViewColumn(v),this.d.fire({textEditor:d.value,viewColumn:v}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$qlc=p}),define(Ie[291],Pe([1,0,2,3,4,6,7,8,20,15]),function(le,e,I,M,A,O,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=void 0,e.$_mc=(0,M.$wi)("IExtHostTimeline");class T{constructor(v,g){this.b=new Map,this.c=new Map,this.a=v.getProxy(A.$3M.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&p.$Rm.equals(o,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:I.URI.revive(r.uri);return this.c.get(r.source)?.get(D(s))?.get(r.handle)}else return;return r}})}async $getTimeline(v,g,r,o){return this.b.get(v)?.provider.provideTimeline(I.URI.revive(g),r,o)}registerTimelineProvider(v,g,r,o){const s=new O.$Uc,i=this.d(g.id,o,s).bind(this);let n;g.onDidChange&&(n=g.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:g.id}),this));const c=this.c;return this.f({...g,scheme:v,onDidChange:void 0,async provideTimeline(l,t,f){t?.resetCache&&(s.clear(),c.get(g.id)?.clear());const a=await g.provideTimeline(l,t,f);if(a==null)return;const $=i(l,t);return{...a,source:g.id,items:a.items.map($)}},dispose(){for(const l of c.values())l.get(g.id)?.clear();n?.dispose(),s.dispose()}},r)}d(v,g,r){return(o,s)=>{let i;if(s?.cacheResults){let n=this.c.get(v);n===void 0&&(n=new Map,this.c.set(v,n));const c=D(o);i=n.get(c),i===void 0&&(i=new Map,n.set(c,i))}return n=>{const{iconPath:c,...l}=n,t=`${v}|${n.id??n.timestamp}`;i?.set(t,n);let f,a,$;n.iconPath&&(c instanceof R.$2N?$={id:c.id,color:c.color}:I.URI.isUri(c)?(f=c,a=c):{light:f,dark:a}=c);let u;return R.$uN.isMarkdownString(l.tooltip)?u=w.MarkdownString.from(l.tooltip):(0,E.$9f)(l.tooltip)?u=l.tooltip:R.$uN.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=w.MarkdownString.from(l.detail)):(0,E.$9f)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=l.detail),{...l,id:l.id??void 0,handle:t,source:v,command:n.command?g.toInternal(n.command,r):void 0,icon:f,iconDark:a,themeIcon:$,tooltip:u,accessibilityInformation:n.accessibilityInformation}}}}f(v,g){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:g}),(0,O.$Tc)(()=>{for(const o of this.c.values())o.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$anc=T;function D(d){return d?.toString()}}),define(Ie[292],Pe([1,0,181,23,2,5,6,222,11,7,15,18,8,55,24,143,26]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=void 0;function s(c,l){if((0,T.$9f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class i extends R.$Vc{constructor(l,t,f){super(),this.f=l,this.g=t,this.h=f,this.a=new Map,this.b=new r.$q$;function a($){return $&&$.$treeViewId&&($.$treeItemHandle||$.$selectedTreeItems||$.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:$=>a($)?this.r($):Array.isArray($)&&$.length>0?$.map(u=>a(u)?this.r(u):u):$})}registerTreeDataProvider(l,t,f){const a=this.createTreeView(l,{treeDataProvider:t},f);return{dispose:()=>a.dispose()}}createTreeView(l,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],$=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,S=!!t.dragAndDropController?.handleDrop,h=this.m(l,t,f),b={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:$,hasHandleDrag:u,hasHandleDrop:S,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},m=this.f.$registerTreeViewDataProvider(l,b),k={get onDidCollapseElement(){return h.onDidCollapseElement},get onDidExpandElement(){return h.onDidExpandElement},get selection(){return h.selectedElements},get onDidChangeSelection(){return h.onDidChangeSelection},get activeItem(){return(0,o.$IG)(f,"treeViewActiveItem"),h.focusedElement},get onDidChangeActiveItem(){return(0,o.$IG)(f,"treeViewActiveItem"),h.onDidChangeActiveItem},get visible(){return h.visible},get onDidChangeVisibility(){return h.onDidChangeVisibility},get onDidChangeCheckboxState(){return h.onDidChangeCheckboxState},get message(){return h.message},set message(y){(0,v.$Vk)(y)&&(0,o.$IG)(f,"treeViewMarkdownMessage"),h.message=y},get title(){return h.title},set title(y){h.title=y},get description(){return h.description},set description(y){h.description=y},get badge(){return h.badge},set badge(y){y!==void 0&&E.ViewBadge.isViewBadge(y)?h.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(h.badge=void 0)},reveal:(y,C)=>h.reveal(y,C),dispose:async()=>{await m,this.a.delete(l),h.dispose()}};return this.B(k),k}$getChildren(l,t){const f=this.a.get(l);return f?f.getChildren(t):Promise.reject(new w.$WF(l))}async $handleDrop(l,t,f,a,$,u,S,h){const b=this.a.get(l);if(!b)return Promise.reject(new w.$WF(l));const m=d.DataTransfer.toDataTransfer(f,async k=>(await this.f.$resolveDropFileData(l,t,k)).buffer);return S===l&&h&&await this.j(m,b,h,$,u),b.onDrop(m,a,$)}async j(l,t,f,a,$){const u=this.b.removeDragOperationTransfer($);if(u)(await u)?.forEach((S,h)=>{S&&l.set(h,S)});else if($&&t.handleDrag){const S=t.handleDrag(f,l,a);this.b.addDragOperationTransfer($,S),await S}return l}async $handleDrag(l,t,f,a){const $=this.a.get(l);if(!$)return Promise.reject(new w.$WF(l));const u=await this.j(new E.$XN,$,t,a,f);if(!(!u||a.isCancellationRequested))return d.DataTransfer.from(u)}async $hasResolve(l){const t=this.a.get(l);if(!t)throw new w.$WF(l);return t.hasResolve}$resolve(l,t,f){const a=this.a.get(l);if(!a)throw new w.$WF(l);return a.resolveTreeItem(t,f)}$setExpanded(l,t,f){const a=this.a.get(l);if(!a)throw new w.$WF(l);a.setExpanded(t,f)}$setSelectionAndFocus(l,t,f){const a=this.a.get(l);if(!a)throw new w.$WF(l);a.setSelectionAndFocus(t,f)}$setVisible(l,t){const f=this.a.get(l);if(!f){if(!t)return;throw new w.$WF(l)}f.setVisible(t)}$changeCheckboxState(l,t){const f=this.a.get(l);if(!f)throw new w.$WF(l);f.setCheckboxState(t)}m(l,t,f){const a=this.B(new n(l,t,this.f,this.g.converter,this.h,f));return this.a.set(l,a),a}r(l){const t=this.a.get(l.$treeViewId);return t&&"$treeItemHandle"in l?t.getExtensionElement(l.$treeItemHandle):t&&"$focusedTreeItem"in l&&l.$focusedTreeItem?t.focusedElement:null}}e.$bnc=i;class n extends R.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,T.$fg)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,t,f,a,$,u){if(super(),this.I=l,this.J=f,this.L=a,this.M=$,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$ee),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$ee),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$ee),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$ee),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$ee),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$ee),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$ee),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new g.$pe,u.contributes&&u.contributes.views)for(const m in u.contributes.views)for(const k of u.contributes.views[m])k.id===l&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(m=>this.F.fire({message:!1,element:m})));let S,h;const b=O.Event.debounce(this.F.event,(m,k)=>(m||(m={message:!1,elements:[]}),k.element!==!1&&(S||(S=new Promise(y=>h=y),this.G=this.G.then(()=>S)),Array.isArray(k.element)?m.elements.push(...k.element):m.elements.push(k.element)),k.message&&(m.message=!0),m),200,!0);this.B(b(({message:m,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const y=h;return S=null,this.$(k).then(()=>y())})),m&&this.J.$setMessage(this.I,d.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const t=l?this.getExtensionElement(l):void 0;if(l&&!t)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let f=this.X(l);return f||(f=await this.Y(t)),f?f.map(a=>a.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,t){t=t||{select:!0,focus:!1};const f=(0,T.$fg)(t.select)?!0:t.select,a=(0,T.$fg)(t.focus)?!1:t.focus,$=(0,T.$fg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(u=>this.W(l,u[u.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:u.map(h=>h.item)},{select:f,focus:a,expand:$})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:f,focus:a,expand:$})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=d.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,t){const f=this.getExtensionElement(l);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(l,t){const f=!(0,D.$ub)(this.s,l);this.s=l;const a=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const t=(await Promise.all(l.map(async f=>{const a=this.getExtensionElement(f.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(l,t,f){const a=[];for(const $ of l){const u=this.getExtensionElement($);u&&a.push(u)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,t,f){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,p.$oh)(()=>this.g?.handleDrop?this.g.handleDrop(a,l,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(l);if(f){const a=this.m.get(f);if(a){const $=await this.f.resolveTreeItem(a.extensionItem,f,t)??a.extensionItem;return this.hb($),a.item.tooltip=this.eb($.tooltip),a.item.command=this.fb(a.disposableStore,$.command),a.item}}}S(l){return this.U(l).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(a=>(f.push(a),f))):Promise.resolve([]))}U(l){const t=this.m.get(l);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$oh)(()=>this.f.getParent(l))}W(l,t){const f=this.m.get(l);return f?Promise.resolve(f):(0,p.$oh)(()=>this.f.getTreeItem(l)).then(a=>this.kb(l,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const $=this.getExtensionElement(a);if($){const u=this.m.get($);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let t;if(typeof l=="string"){const f=this.getExtensionElement(l);t=f?this.m.get(f):void 0}else t=l;return t&&t.children||void 0}return this.h}async Y(l){this.rb(l);const t=new g.$pe(this.Z.token);try{const f=l?this.m.get(l):void 0,a=await this.f.getChildren(l);if(t.token.isCancellationRequested)return;const $=(0,D.$Hb)(a||[]),u=await Promise.all((0,D.$Hb)($).map(h=>this.f.getTreeItem(h)));if(t.token.isCancellationRequested)return;const S=u.map((h,b)=>h?this.db($[b],h,f):null);return(0,D.$Hb)(S)}finally{t.dispose()}}$(l){if(l.some(f=>!f))return this.Z.dispose(!0),this.Z=new g.$pe,this.tb(),this.J.$refresh(this.I);{const f=this.ab(l);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(l){const t=new Set,f=l.map($=>this.m.get($));for(const $ of f)if($&&!t.has($.item.handle)){let u=$;for(;u&&u.parent&&f.findIndex(S=>u&&u.parent&&S&&S.item.handle===u.parent.item.handle)===-1;){const S=this.j.get(u.parent.item.handle);u=S?this.m.get(S):void 0}u&&!u.parent&&t.add($.item.handle)}const a=[];return t.forEach($=>{const u=this.j.get($);if(u){const S=this.m.get(u);S&&(!S.parent||!t.has(S.parent.item.handle))&&a.push($)}}),a}bb(l){const t={};return Promise.all(l.map(f=>this.cb(f).then(a=>{a&&(t[f]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(l){const t=this.getExtensionElement(l);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,p.$oh)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const $=this.ib(t,a,f.parent);return this.pb(t,$,f,f.parent),f.dispose(),$}return null})}return Promise.resolve(null)}db(l,t,f){const a=this.ib(l,t,f);if(t.id&&this.j.has(a.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(l,a),this.qb(a,f),a}eb(l){return E.$uN.isMarkdownString(l)?d.MarkdownString.from(l):l}fb(l,t){return t?{...this.L.toInternal(t,l),originalId:t.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let t,f,a;return typeof l.checkboxState=="number"?t=l.checkboxState:(t=l.checkboxState.state,f=l.checkboxState.tooltip,a=l.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:a}}hb(l){if(!E.$SN.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,t,f){this.hb(t);const a=this.B(new R.$Uc),$=this.kb(l,t,f),u=this.lb(t);return{item:{handle:$,parentHandle:f?f.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:u,iconDark:this.mb(t)||u,themeIcon:this.jb(t),collapsibleState:(0,T.$fg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(l){return l.iconPath instanceof E.$2N?l.iconPath:void 0}kb(l,{id:t,label:f,resourceUri:a},$,u){if(t)return`${n.b}/${t}`;const S=s(f,this.N),h=$?$.item.handle:n.a;let b=S?S.label:a?(0,M.$7g)(a):"";b=b.indexOf("/")!==-1?b.replace("/","//"):b;const m=this.m.has(l)?this.m.get(l).item.handle:void 0,k=this.X($)||[];let y,C=0;do{if(y=`${h}/${C}:${b}`,u||!this.j.has(y)||m===y)break;C++}while(C<=k.length);return y}lb(l){if(l.iconPath&&!(l.iconPath instanceof E.$2N))return typeof l.iconPath=="string"||A.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof E.$2N)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return A.URI.isUri(l)?l:A.URI.file(l)}ob(l,t){this.j.set(t.item.handle,l),this.m.set(l,t)}pb(l,t,f,a){this.j.delete(t.item.handle),this.m.delete(l),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(l,t);const $=this.X(a)||[],u=$.filter(S=>S.item.handle===f.item.handle)[0];u&&$.splice($.indexOf(u),1,t)}qb(l,t){t?(t.children||(t.children=[]),t.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const t=this.m.get(l);if(t){if(t.children)for(const f of t.children){const a=this.j.get(f.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(l){const t=this.m.get(l);if(t){if(t.children)for(const f of t.children){const a=this.j.get(f.item.handle);a&&this.sb(a)}this.m.delete(l),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ie[293],Pe([1,0,5,6,2,34,8,64,4,7]),function(le,e,I,M,A,O,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;class T extends M.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(g,r,o,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$ee),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$ee),this.onDidChangeViewState=this.#h.event,this.#e=g,this.#t=r,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(g){this.c(),this.#r!==g&&(this.#r=g,this.#t.$setTitle(this.#e,g))}get iconPath(){return this.c(),this.#a}set iconPath(g){this.c(),this.#a!==g&&(this.#a=g,this.#t.$setIconPath(this.#e,A.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(g){this.#l||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(this.#u=g.active,this.#c=g.visible,this.#o=g.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(g,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof g>"u"?void 0:R.ViewColumn.from(g),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends M.$Vc{static c(){return(0,O.$Sg)()}constructor(g,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=g.getProxy(p.$3M.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(g=>g.dispose()),this.g.clear()}createWebviewPanel(g,r,o,s,i={}){const n=typeof s=="object"?s.viewColumn:s,c={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},l=(0,w.$Flc)(g),t=D.c();this.f.$createWebviewPanel((0,w.$Hlc)(g),t,r,{title:o,panelOptions:d(i),webviewOptions:(0,w.$Ilc)(g,this.m,i),serializeBuffersForPostMessage:l},c);const f=this.j.createNewWebview(t,i,g);return this.createNewWebviewPanel(t,r,o,n,i,f,!0)}$onDidChangeWebviewPanelViewStates(g){const r=Object.keys(g);r.sort((o,s)=>{const i=g[o],n=g[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const o of r){const s=this.getWebviewPanel(o);if(!s)continue;const i=g[o];s._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.g.delete(g),this.j.deleteWebview(g)}registerWebviewPanelSerializer(g,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:g}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,w.$Flc)(g)}),new E.$5M(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(g,r,o,s){const i=this.h.get(r);if(!i)throw new Error(`No serializer found for '${r}'`);const{serializer:n,extension:c}=i,l=this.j.createNewWebview(g,o.webviewOptions,c),t=this.createNewWebviewPanel(g,r,o.title,s,o.panelOptions,l,o.active);await n.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(g,r,o,s,i,n,c){const l=new T(g,this.f,n,{viewType:r,title:o,viewColumn:s,panelOptions:i,active:c});return this.g.set(g,l),l}getWebviewPanel(g){return this.g.get(g)}}e.$Jlc=D;function d(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ie[294],Pe([1,0,5,6,64,8,4,7]),function(le,e,I,M,A,O,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=void 0;class p extends M.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,d,v,g,r,o){super(),this.#s=!1,this.#u=this.B(new I.$ee),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$ee),this.onDidDispose=this.#l.event,this.#i=v,this.#a=g,this.#e=D,this.#t=d,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#o}set description(D){this.a(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(D,d){this.d=d,this.b=new Map,this.c=new Map,this.a=D.getProxy(R.$3M.MainThreadWebviewViews)}registerWebviewViewProvider(D,d,v,g){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:v,extension:D}),this.a.$registerWebviewViewProvider((0,A.$Hlc)(D),d,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$Flc)(D)}),new w.$5M(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(D,d,v,g,r){const o=this.b.get(d);if(!o)throw new Error(`No view provider found for '${d}'`);const{provider:s,extension:i}=o,n=this.d.createNewWebview(D,{},i),c=new p(D,this.a,d,v,n,!0);this.c.set(D,c),await s.resolveWebviewView(c,{state:g},r)}async $onDidChangeWebviewViewVisibility(D,d){this.e(D)._setVisible(d)}async $disposeWebviewView(D){const d=this.e(D);this.c.delete(D),d.dispose(),this.d.deleteWebview(D)}e(D){const d=this.c.get(D);if(!d)throw new Error("No webview found");return d}}e.$enc=E}),define(Ie[295],Pe([1,0,5,29,31,3]),function(le,e,I,M,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=e.OutputChannelUpdateMode=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=void 0,e.$$L="text/x-code-output",e.$_L="output",e.$aM="Log",e.$bM="text/x-code-log-output",e.$cM="log",e.$dM="workbench.panel.output",e.$eM=new A.$Nj("inOutput",!1),e.$fM=new A.$Nj("activeLogOutput",!1),e.$gM=new A.$Nj("activeLogOutput.levelSettable",!1),e.$hM=new A.$Nj("activeLogOutput.level",""),e.$iM=new A.$Nj("activeLogOutput.levelIsDefault",!1),e.$jM=new A.$Nj("outputView.scrollLock",!1),e.$kM=(0,O.$wi)("outputService");var R;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$lM={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.a=new Map,this.b=new I.$ee,this.onDidRegisterChannel=this.b.event,this.c=new I.$ee,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(T=>E.push(T)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}M.$co.add(e.$lM.OutputChannels,new w),e.$mM=new A.$Nj("activeOutputChannel","")}),define(Ie[118],Pe([1,0,4,3,17,20,12,295,65,27,46,147,21,15,38,5,6]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=void 0;class s extends R.$9j{get disposed(){return this.n}constructor(l,t,f,a,$){super(),this.id=l,this.name=t,this.r=f,this.s=a,this.extension=$,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Clear,l)}replace(l){const t=this.m;this.info(l),this.s.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(l,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:t))}hide(){this.s.$close(this.id)}g(l,t){this.m+=d.$Ge.fromString(t).byteLength,(0,R.log)(this.r,l,t),this.visible&&(this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(l){this.append(l)}}let n=class{constructor(l,t,f,a,$,u){this.i=t,this.j=f,this.k=a,this.l=$,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(I.$3M.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(l,t,f){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,$=(0,v.$9f)(t)?t:void 0;if((0,v.$9f)($)&&!$.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const S=this.i.environment.extensionLogLevel?.find(([b])=>O.$Rm.equals(f.identifier,b))?.[1];S&&(u=(0,R.$hk)(S));const h=a?this.o(l,u,f):this.n(l,$,f);return h.then(b=>{this.g.set(b.id,b),b.visible=b.id===this.h}),a?this.r(l,u??this.m.getLevel(),h):this.q(l,h)}async n(l,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,$=this.k.extUri.joinPath(a,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger($,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(l,$,t,f.identifier.value);return new s(S,l,u,this.a,f)}async o(l,t,f){const a=await this.p(f),$=l.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(a,`${$}.log`),S=`${f.identifier.value}.${$}`,h=this.l.createLogger(u,{id:S,name:l,logLevel:t,extensionId:f.identifier.value});return new i(S,l,h,this.a,f)}p(l){let t=this.d.get(l.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(a){if((0,g.$gl)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}return f})())}return t}q(l,t){let f=!1;const a=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return l},append($){a(),t.then(u=>u.append($))},appendLine($){a(),t.then(u=>u.appendLine($))},clear(){a(),t.then($=>$.clear())},replace($){a(),t.then(u=>u.replace($))},show($,u){a(),t.then(S=>S.show($,u))},hide(){a(),t.then($=>$.hide())},dispose(){f=!0,t.then($=>$.dispose())}}}r(l,t,f){const a=new o.$Uc,$=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},u=a.add(new r.$ee);function S(h){t=h,u.fire(h)}return f.then(h=>{a.add(h),h.logLevel!==t&&S(h.logLevel),a.add(h.onDidChangeLogLevel(b=>S(b)))}),{...this.q(l,f),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(h,...b){$(),f.then(m=>m.trace(h,...b))},debug(h,...b){$(),f.then(m=>m.debug(h,...b))},info(h,...b){$(),f.then(m=>m.info(h,...b))},warn(h,...b){$(),f.then(m=>m.warn(h,...b))},error(h,...b){$(),f.then(m=>m.error(h,...b))},dispose(){a.dispose()}}}};e.$Pmc=n,e.$Pmc=n=Je([We(0,A.$qP),We(1,E.$GP),We(2,p.$Blc),We(3,T.$elc),We(4,R.$4j),We(5,R.$3j)],n),e.$Qmc=(0,M.$wi)("IExtHostOutputService")}),define(Ie[119],Pe([1,0,3,11]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=void 0,e.$gn=(0,I.$wi)("remoteAgentService"),e.$hn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let O=1/0;for(let w=0;w<this.maxSampleCount;w++){const p=await A.getRoundTripTime();if(p===void 0)return;O=Math.min(O,p/2),await(0,M.$xh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(O):R=this.initial.reduce((w,p)=>w+p,0)/this.initial.length,this.lastMeasurement={initial:R,current:O,average:this.average.reduce((w,p)=>w+p,0)/this.average.length,high:typeof R>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ie[296],Pe([1,0,184,51,29,45,50,6,5,119,22,25,11]),function(le,e,I,M,A,O,R,w,p,E,T,D,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=void 0,e.$DJ=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$EJ=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$FJ=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$GJ=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$HJ={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new p.$ee,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const g=new v;A.$co.add(e.$HJ.ConfigurationMigration,g);let r=class extends w.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const l of c.added)await this.f(l,g.migrations)})),this.c(g.migrations),this.B(g.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(c=>this.g(c,i?.uri))])}async g(i,n){const c=this.a.inspect(i.key,{resource:n}),l=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of l){const a=c[t];if(!a)continue;const $=[];if(a.value!==void 0){const u=await this.h(i,t,a.value,n,void 0);for(const S of u??[])$.push([S,[]])}for(const{identifiers:u,value:S}of a.overrides??[])if(S!==void 0){const h=await this.h(i,t,S,n,u);for(const b of h??[])$.push([b,u])}$.length&&await Promise.allSettled($.map(async([[u,S],h])=>this.a.updateValue(u,S.value,{resource:n,overrideIdentifiers:h},f)))}}async h(i,n,c,l,t){const f=$=>{const S=this.a.inspect($,{resource:l})[n];if(S)return t?S.overrides?.find(({identifiers:h})=>(0,D.$7n)(h,t))?.value:S.value},a=await i.migrateFn(c,f);return Array.isArray(a)?a:[[i.key,a]]}};e.$IJ=r,e.$IJ=r=Je([We(0,R.$3i),We(1,O.$Fi)],r);let o=class extends w.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new d.$Th,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;A.$co.as(M.$ho.Configuration).registerConfiguration({...e.$FJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$JJ=o,e.$JJ=o=Je([We(0,E.$gn)],o)}),define(Ie[297],Pe([1,0,37,16,19,23,193,296,51,3,29]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$chb=e.$bhb=void 0,e.$dhb=r,e.$ehb=o,e.$bhb=(0,E.$wi)("editorResolverService"),e.$chb="workbench.editorAssociations";const D=T.$co.as(p.$ho.Configuration),d={...w.$EJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(d);var v;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(v||(e.RegisteredEditorPriority=v={}));var g;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(g||(e.ResolvedStatus=g={}));function r(s){switch(s){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}function o(s,i){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(i.scheme))return!1;const l=typeof s=="string"&&s.indexOf(A.$hc.sep)>=0?`${i.scheme}:${i.path}`:(0,O.$7g)(i);return I.$pk(typeof s=="string"?s.toLowerCase():s,l.toLowerCase())}}),define(Ie[298],Pe([1,0,48,16,19,22,23,2,3,214,45,236,119]),function(le,e,I,M,A,O,R,w,p,E,T,D,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0,e.$EM=(0,p.$wi)("pathService");let g=v=class{constructor(o,s,i,n){this.d=o,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(o,n,s)):this.h(o,s,i)}h(o,s,i){return o.scheme===M.Schemas.file||o.scheme===M.Schemas.vscodeRemote?(0,I.$tg)(i??(0,R.$7g)(o),s===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return M.Schemas.vscodeRemote;const i=(0,E.$BM)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const c=s.getWorkspace().configuration;return c?c.scheme:M.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?A.$gc:A.$hc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const n=o.indexOf("/",2);n===-1?(s=o.substring(2),o="/"):(s=o.substring(2,n),o=o.substring(n)||"/")}return w.URI.from({scheme:M.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$FM=g,e.$FM=g=v=Je([We(1,d.$gn),We(2,D.$nM),We(3,T.$Fi)],g)}),define(Ie[120],Pe([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$$K=e.$0K=void 0;class I{constructor(R,w){this.line=R,this.character=w}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,w){return new I(0,0)}with(R){return new I(0,0)}}e.$0K=I;class M{constructor(R,w,p,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(R,w),this.end=new I(p,E)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.$$K=M;var A;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(Ie[47],Pe([1,0,18,37,25,48,13,3,19,14,120,11]),function(le,e,I,M,A,O,R,w,p,E,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xL=e.$vL=e.$oL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$lL=e.$kL=e.$jL=e.$iL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.TextSearchCompleteMessageType=void 0,e.$fL=s,e.$gL=i,e.$hL=n,e.$mL=h,e.$nL=b,e.$pL=y,e.$qL=C,e.$rL=P,e.$sL=W,e.$tL=V,e.$uL=q,e.$wL=U,e.$yL=ce,e.$zL=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$_K="workbench.view.search",e.$aL="workbench.panel.search",e.$bL="workbench.view.search",e.$cL="search-result",e.$dL="search.exclude";const d="\u27EA ",v=" characters skipped \u27EB",g=(d.length+v.length+5)*2;e.$eL=(0,w.$wi)("searchService");var r;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text",fe[fe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text",fe[fe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(fe){return!!fe.preview}function i(fe){return!!fe.resource}function n(fe){return!!fe.message}var c;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class l{constructor($e){this.resource=$e,this.results=[]}}e.$iL=l;class t{constructor($e,Te,ae,Ne){this.ranges=Te,this.webviewIndex=Ne;const ne=Array.isArray(Te)?Te:[Te];if(ae&&ae.matchLines===1&&f(ne)){$e=(0,R.$2f)($e,ae.matchLines);let z="",x=0,ve=0;const Fe=Math.floor(ae.charsPerLine/5),De=[];for(const we of ne){const ge=Math.max(we.startColumn-Fe,0),Q=we.startColumn+ae.charsPerLine;if(ge>ve+Fe+g){const Y=d+(ge-ve)+v;z+=Y+$e.slice(ge,Q),x+=ge-(ve+Y.length)}else z+=$e.slice(ve,Q);De.push(new $(0,we.startColumn-x,we.endColumn-x)),ve=Q}this.preview={text:z,matches:Array.isArray(this.ranges)?De:De[0]}}else{const z=Array.isArray(Te)?Te[0].startLineNumber:Te.startLineNumber;this.preview={text:$e,matches:(0,I.$2b)(Te,x=>new a(x.startLineNumber-z,x.startColumn,x.endLineNumber-z,x.endColumn))}}}}e.$jL=t;function f(fe){const $e=fe[0].startLineNumber;for(const Te of fe)if(Te.startLineNumber!==$e||Te.endLineNumber!==$e)return!1;return!0}class a{constructor($e,Te,ae,Ne){this.startLineNumber=$e,this.startColumn=Te,this.endLineNumber=ae,this.endColumn=Ne}}e.$kL=a;class $ extends a{constructor($e,Te,ae){super($e,Te,$e,ae)}}e.$lL=$;var u;(function(fe){fe.List="list",fe.Tree="tree"})(u||(e.ViewMode=u={}));var S;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function h(fe,$e=!0){const Te=fe&&fe.files&&fe.files.exclude,ae=$e&&fe&&fe.search&&fe.search.exclude;if(!Te&&!ae)return;if(!Te||!ae)return Te||ae;let Ne=Object.create(null);return Ne=A.$6n(Ne,A.$3n(Te)),Ne=A.$6n(Ne,A.$3n(ae),!0),Ne}function b(fe,$e){return fe.excludePattern&&M.$pk(fe.excludePattern,$e)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&M.$pk(fe.includePattern,$e)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(Te=>{const ae=Te.folder.fsPath;if(O.$vg($e,ae)){const Ne=p.$mc(ae,$e);return!Te.includePattern||!!M.$pk(Te.includePattern,Ne)}else return!1}):!1:!0}var m;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class k extends Error{constructor($e,Te){super($e),this.code=Te}}e.$oL=k;function y(fe){const $e=fe.message;if((0,E.$4)(fe))return new k($e,m.canceled);try{const Te=JSON.parse($e);return new k(Te.message,Te.code)}catch{return new k($e,m.other)}}function C(fe){const $e={message:fe.message,code:fe.code};return new Error(JSON.stringify($e))}function P(fe){return fe.type==="error"?!0:fe.type==="success"}function W(fe){return fe.type==="success"}function V(fe){return!!fe.path}function q(fe,$e,Te=!0){const ae=fe.searchPath?fe.searchPath:fe.relativePath;return Te?(0,R.$Yf)(ae,$e):M.$pk($e,ae)}class N{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$vL=N;function U(fe,$e){const Te={...fe||{},...$e||{}};return Object.keys(Te).filter(ae=>{const Ne=Te[ae];return typeof Ne=="boolean"&&Ne})}class K{constructor($e,Te){this.c=null,this.a={...$e.excludePattern||{},...Te.excludePattern||{}},this.b=M.$qk(this.a);let ae=$e.includePattern;Te.includePattern&&(ae?ae={...ae,...Te.includePattern}:ae=Te.includePattern),ae&&(this.c=M.$qk(ae))}matchesExcludesSync($e,Te,ae){return!!(this.b&&this.b($e,Te,ae))}includedInQuerySync($e,Te,ae){return!(this.b&&this.b($e,Te,ae)||this.c&&!this.c($e,Te,ae))}includedInQuery($e,Te,ae){const Ne=this.b($e,Te,ae),ne=()=>this.c?!!this.c($e,Te,ae):!0;return(0,D.$ih)(Ne)?Ne.then(z=>z?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$xL=K;function ie(fe){for(const $e in fe)if(typeof fe[$e]!="boolean")return!0;return!1}function ce(fe){if(!fe)return;let $e;return Te=>($e||($e=(fe()||Promise.resolve([])).then(ae=>ae?Se(ae):{})),$e.then(ae=>!!ae[Te]))}function ye(fe){if(!fe)return;let $e;return Te=>{if(!$e){const ae=fe();$e=ae?Se(ae):{}}return!!$e[Te]}}function Se(fe){const $e={};for(const Te of fe)$e[Te]=!0;return $e}}),define(Ie[39],Pe([1,0,18,11,24,5,6,54,16,129,23,13,2,183,3,12,202,45,46,27,17,8,7,61,47,4,49]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n,c,l,t,f,a,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=e.$vlc=void 0;function S(W,V,q){return new T.$Yg(N=>k(N,q)).isEqual(W,V)}function h(W,V,q){return S(W.uri,V.uri,q)?0:(0,D.$rf)(W.uri.toString(),V.uri.toString())}function b(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:S(W.uri,V.uri,q)?(0,D.$rf)(W.name,V.name):(0,D.$rf)(W.uri.toString(),V.uri.toString())}function m(W,V,q,N){const U=W.slice(0).sort((ie,ce)=>q(ie,ce,N)),K=V.slice(0).sort((ie,ce)=>q(ie,ce,N));return(0,I.$Eb)(U,K,(ie,ce)=>q(ie,ce,N))}function k(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class y extends s.$Pi{static toExtHostWorkspace(V,q,N,U){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:ce,configuration:ye,transient:Se,isUntitled:fe}=V,$e=[],Te=q;q?ce.forEach((z,x)=>{const ve=d.URI.revive(z.uri),Fe=y.o(N||q,ve,U);Fe?(Fe.name=z.name,Fe.index=z.index,$e.push(Fe)):$e.push({uri:ve,name:z.name,index:x})}):$e.push(...ce.map(({uri:z,name:x,index:ve})=>({uri:d.URI.revive(z),name:x,index:ve}))),$e.sort((z,x)=>z.index<x.index?-1:1);const ae=new y(K,ie,$e,!!Se,ye?d.URI.revive(ye):null,!!fe,z=>k(z,U)),{added:Ne,removed:ne}=m(Te?Te.workspaceFolders:[],ae.workspaceFolders,h,U);return{workspace:ae,added:Ne,removed:ne}}static o(V,q,N){for(let U=0;U<V.folders.length;U++){const K=V.workspaceFolders[U];if(S(K.uri,q,N))return K}}constructor(V,q,N,U,K,ie,ce){super(V,N.map(ye=>new s.$Qi(ye)),U,K,ce),this.t=q,this.u=ie,this.q=[],this.s=w.$Ci.forUris(ce),N.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,T.$9g)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let C=class{constructor(V,q,N,U,K){this.c=new O.$ee,this.onDidChangeWorkspace=this.c.event,this.g=new O.$ee,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$ge,this.C=new Map,this.h=U,this.s=N,this.t=K,this.j=new E.$Dm,this.k=new M.$vh,this.o=V.getProxy($.$3M.MainThreadWorkspace),this.q=V.getProxy($.$3M.MainThreadMessageService);const ie=q.workspace;this.l=ie?new y(ie.id,ie.name,[],!!ie.transient,ie.configuration?d.URI.revive(ie.configuration):null,!!ie.isUntitled,ce=>k(ce,N)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?d.URI.from({scheme:p.Schemas.untitled,path:(0,T.$7g)((0,T.$9g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,N,...U){const K=[];if(Array.isArray(U)&&U.forEach(fe=>{d.URI.isUri(fe.uri)&&!K.some($e=>S($e.uri,fe.uri,this.s))&&K.push({uri:fe.uri,name:fe.name||(0,T.$6g)(fe.uri)})}),this.n||[q,N].some(fe=>typeof fe!="number"||fe<0)||N===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+N>ie.length)return!1;const ce=ie.slice(0);ce.splice(q,N,...K.map(fe=>({uri:fe.uri,name:fe.name||(0,T.$6g)(fe.uri),index:void 0})));for(let fe=0;fe<ce.length;fe++){const $e=ce[fe];if(ce.some((Te,ae)=>ae!==fe&&S($e.uri,Te.uri,this.s)))return!1}ce.forEach((fe,$e)=>fe.index=$e);const{added:ye,removed:Se}=m(ie,ce,b,this.s);if(ye.length===0&&Se.length===0)return!1;if(this.o){const fe=V.displayName||V.name;this.o.$updateWorkspaceFolders(fe,q,N,K).then(void 0,$e=>{this.n=void 0;const Te={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(o.Severity.Error,(0,v.localize)(0,null,fe,$e.toString()),Te,[])})}return this.y(ce),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let N,U="";if(typeof V=="string"?(N=d.URI.file(V),U=V):typeof V<"u"&&(N=V,U=V.fsPath),!N)return U;const K=this.getWorkspaceFolder(N,!0);if(!K)return U;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,T.$_g)(K.uri,N);return q&&K.name&&(ie=`${K.name}/${ie}`),ie}y(V){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:N,removed:U}=y.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:U}))}findFiles(V,q,N,U,K=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let ie="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(V,void 0,{exclude:ie,maxResults:N,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,q={},N,U=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,V,q,U)}async z(V,q,N,U=A.CancellationToken.None){if(U&&U.isCancellationRequested)return Promise.resolve([]);const K=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,ie={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:K,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let ce;if(V){const{includePattern:ye,folder:Se}=P(l.GlobPattern.from(V));ce=Se,ie.includePattern=ye}else{const{includePattern:ye,folder:Se}=P(l.GlobPattern.from(q));ce=Se,ie.filePattern=ye}return this.o.$startFileSearch(ce??null,ie,U).then(ye=>Array.isArray(ye)?ye.map(Se=>d.URI.revive(Se)):[])}async findTextInFiles(V,q,N,U,K=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ye,folder:Se}=P(l.GlobPattern.from(q.include)),fe=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,$e={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ye,excludePattern:fe},Te=!1;if(this.u[ie]=ae=>{if(Te)return;const Ne=d.URI.revive(ae.resource);ae.results.forEach(ne=>{const z=(0,u.$6h)(ne);(0,a.$fL)(z)?N({uri:Ne,preview:{text:z.preview.text,matches:(0,I.$2b)(z.preview.matches,x=>new t.$7M(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,I.$2b)(z.ranges,x=>new t.$7M(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):N({uri:Ne,text:z.text,lineNumber:z.lineNumber})})},K.isCancellationRequested)return{};try{const ae=await this.o.$startTextSearch(V,Se??null,$e,ie,K);return delete this.u[ie],ae||{}}catch(ae){throw delete this.u[ie],ae}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return d.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return d.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const N=this.t.transformOutgoingScheme(V),U=this.A++;return this.o.$registerEditSessionIdentityProvider(U,N),(0,R.$Tc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(d.URI.revive(V));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const U=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!U),!U)return;const K=await U.provideEditSessionIdentity(N,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,q,N,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(d.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const ce=await ie.provideEditSessionIdentityMatch?.(q,N,U);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(V){return(q,N,U)=>{const K=function(ce){q.call(N,ce)};return K.extension=V,this.B.event(K,void 0,U)}}async $onWillCreateEditSessionIdentity(V,q,N){const U=await this.resolveWorkspaceFolder(d.URI.revive(V));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:U},q,async(K,ie)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>N&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const N=this.t.transformOutgoingScheme(V),U=this.A++;return this.o.$registerCanonicalUriProvider(U,N),(0,R.$Tc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(V,q,N){const U=this.C.get(V.scheme);if(!U)return;const K=await U.provideCanonicalUri?.(d.URI.revive(V),q,N);if(K)return K}async $provideCanonicalUri(V,q,N){return this.provideCanonicalUri(d.URI.revive(V),{targetScheme:q},N)}};e.$vlc=C,e.$vlc=C=Je([We(0,c.$qP),We(1,n.$GP),We(2,i.$elc),We(3,r.$3j),We(4,f.$tlc)],C),e.$wlc=(0,g.$wi)("IExtHostWorkspace");function P(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=d.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(Ie[40],Pe([1,0,25,5,39,4,7,203,51,15,11,3,17,12,2]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=e.$ylc=e.$xlc=void 0;function r(f,a){if(a){const $=a.split(".");let u=f;for(let S=0;u&&S<$.length;S++)u=u[$[S]];return u}}function o(f){return f instanceof g.URI}function s(f){return f&&f.uri instanceof g.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&f.uri instanceof g.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function c(f){if(o(f))return{resource:f};if(s(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(n(f))return{resource:f.uri};if(f===null)return{resource:null}}let l=class{constructor(a,$,u){this.a=a.getProxy(O.$3M.MainThreadConfiguration),this.c=$,this.b=u,this.d=new T.$vh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,$){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(a,$))}};e.$xlc=l,e.$xlc=l=Je([We(0,d.$qP),We(1,A.$wlc),We(2,v.$3j)],l);class t{constructor(a,$,u,S){this.a=new M.$ee,this.b=a,this.f=S,this.c=$,this.e=w.$Ao.parse(u,S),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,$){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=w.$Ao.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j($,u))}getConfiguration(a,$,u){const S=c($)||{},h=this.g(a?r(this.e.getValue(void 0,S,this.c.workspace),a):this.e.getValue(void 0,S,this.c.workspace));a&&this.h(a,S,u?.identifier);function b(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(k){return typeof r(h,k)<"u"},get:(k,y)=>{this.h(a?`${a}.${k}`:k,S,u?.identifier);let C=r(h,k);if(typeof C>"u")C=y;else{let P;const W=(V,q)=>{if((0,E.$$f)(V)){let N;const U=()=>{P=P||(0,I.$3n)(h),N=N||r(P,q)};return new Proxy(V,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return U(),()=>N;if(P)return N=N||r(P,q),N[ie];const ce=K[ie];return typeof ie=="string"?W(ce,`${q}.${ie}`):ce},set:(K,ie,ce)=>(U(),N&&(N[ie]=ce),!0),deleteProperty:(K,ie)=>(U(),N&&delete N[ie],!0),defineProperty:(K,ie,ce)=>(U(),N&&Object.defineProperty(N,ie,ce),!0)})}return Array.isArray(V)?(0,I.$3n)(V):V};C=W(C,k)}return C},update:(k,y,C,P)=>{k=a?`${a}.${k}`:k;const W=b(C);return y!==void 0?this.b.$updateConfigurationOption(W,k,y,S,P):this.b.$removeConfigurationOption(W,k,S,P)},inspect:k=>{k=a?`${a}.${k}`:k;const y=this.e.inspect(k,S,this.c.workspace);if(y)return{key:k,defaultValue:(0,I.$3n)(y.policy?.value??y.default?.value),globalValue:(0,I.$3n)(y.user?.value??y.application?.value),workspaceValue:(0,I.$3n)(y.workspace?.value),workspaceFolderValue:(0,I.$3n)(y.workspaceFolder?.value),defaultLanguageValue:(0,I.$3n)(y.default?.override),globalLanguageValue:(0,I.$3n)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,I.$3n)(y.workspace?.override),workspaceFolderLanguageValue:(0,I.$3n)(y.workspaceFolder?.override),languageIds:(0,I.$3n)(y.overrideIdentifiers)}}};return typeof h=="object"&&(0,I.$6n)(m,h,!1),Object.freeze(m)}g(a){const $=u=>(0,E.$$f)(u)?new Proxy(u,{get:(S,h)=>$(S[h]),set:(S,h,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(S,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(S,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return $(a)}h(a,$,u){const S=p.$ro.test(a)?4:this.d.get(a),h=u?`[${u.value}] `:"";if(S===4){typeof $?.resource>"u"&&this.f.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(S===3){$?.resource&&this.f.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,$){const u=new w.$Co(a,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,h)=>u.affectsConfiguration(S,c(h))})}k(a){return a.reduce(($,u)=>($.set(u[0],u[1]),$),new Map)}}e.$ylc=t,e.$zlc=(0,D.$wi)("IExtHostConfiguration")}),define(Ie[121],Pe([1,0,2,11,5,4,7,39,68,40,24,53,17,27,3,16,22,12,80,241,14]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=e.$3mc=e.$2mc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})(l||(l={}));var t;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})(t||(t={}));var f;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})(f||(f={}));var a;(function(W){function V(U){if(U){const K=U;return K&&!!K.process}else return!1}W.is=V;function q(U){if(U==null)return;const K={process:U.process,args:U.args};return U.options&&(K.options=f.from(U.options)),K}W.from=q;function N(U){if(U!=null)return new R.$ON(U.process,U.args,U.options)}W.to=N})(a||(a={}));var $;(function(W){function V(N){if(N!=null)return N}W.from=V;function q(N){if(N!=null)return N}W.to=q})($||($={}));var u;(function(W){function V(U){if(U){const K=U;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=V;function q(U){if(U==null)return;const K={};return U.commandLine!==void 0?K.commandLine=U.commandLine:(K.command=U.command,K.args=U.args),U.options&&(K.options=$.from(U.options)),K}W.from=q;function N(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new R.$PN(U.commandLine,U.options):new R.$PN(U.command,U.args?U.args:[],U.options)}W.to=N})(u||(u={}));var S;(function(W){function V(U){if(U){const K=U;return K&&K.customExecution==="customExecution"}else return!1}W.is=V;function q(U){return{customExecution:"customExecution"}}W.from=q;function N(U,K){return K.get(U)}W.to=N})(S||(e.CustomExecutionDTO=S={}));var h;(function(W){function V(q,N){let U;return q.scope!==void 0&&typeof q.scope!="number"?U=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?U=N.workspaceFile:U=n.$9H),{id:q._id,workspaceFolder:U}}W.from=V})(h||(e.TaskHandleDTO=h={}));var b;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(b||(b={}));var m;(function(W){function V(U,K){if(U==null)return[];const ie=[];for(const ce of U){const ye=q(ce,K);ye&&ie.push(ye)}return ie}W.fromMany=V;function q(U,K){if(U==null)return;let ie;U.execution instanceof R.$ON?ie=a.from(U.execution):U.execution instanceof R.$PN?ie=u.from(U.execution):U.execution&&U.execution instanceof R.$QN&&(ie=S.from(U.execution));const ce=l.from(U.definition);let ye;return U.scope?typeof U.scope=="number"?ye=U.scope:ye=U.scope.uri:ye=R.TaskScope.Workspace,!ce||!ye?void 0:{_id:U._id,definition:ce,name:U.name,source:{extensionId:K.identifier.value,label:U.source,scope:ye},execution:ie,isBackground:U.isBackground,group:b.from(U.group),presentationOptions:t.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}W.from=q;async function N(U,K,ie){if(U==null)return;let ce;a.is(U.execution)?ce=a.to(U.execution):u.is(U.execution)?ce=u.to(U.execution):S.is(U.execution)&&(ce=S.to(U._id,ie));const ye=l.to(U.definition);let Se;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Se=U.source.scope:Se=await K.resolveWorkspaceFolder(I.URI.revive(U.source.scope)):Se=R.TaskScope.Workspace),!ye||!Se)return;const fe=new R.$RN(ye,Se,U.name,U.source.label,ce,U.problemMatchers);return U.isBackground!==void 0&&(fe.isBackground=U.isBackground),U.group!==void 0&&(fe.group=R.$NN.from(U.group._id),fe.group&&U.group.isDefault&&(fe.group=new R.$NN(fe.group.id,fe.group.label),U.group.isDefault===!0&&(fe.group.isDefault=U.group.isDefault))),U.presentationOptions&&(fe.presentationOptions=t.to(U.presentationOptions)),U._id&&(fe._id=U._id),U.detail&&(fe.detail=U.detail),fe}W.to=N})(m||(e.TaskDTO=m={}));var k;(function(W){function V(N){return N}W.from=V;function q(N){if(N)return Object.assign(Object.create(null),N)}W.to=q})(k||(k={}));class y{#e;constructor(V,q,N){this._id=q,this.a=N,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let C=class{constructor(V,q,N,U,K,ie,ce,ye){this.q=new A.$ee,this.r=new A.$ee,this.s=new A.$ee,this.u=new A.$ee,this.a=V.getProxy(O.$3M.MainThreadTask),this.b=N,this.c=U,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,N){if(!N)return new R.$5M(()=>{});const U=this.x();return this.j.set(U,{type:q,provider:N,extension:V}),this.a.$registerTaskProvider(U,q),new R.$5M(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(k.from(V)).then(async q=>{const N=[];for(const U of q){const K=await m.to(U,this.b,this.m);K&&N.push(K)}return N})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,N){const U=this.m.get(V.id);U&&(this.o.set(V.id,U),this.e.attachPtyToTerminal(q,await U.callback(N))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const N=this.j.get(V);if(!N)return Promise.reject(new Error("no handler found"));const U=[],K=(0,M.$oh)(()=>N.provider.provideTasks(T.CancellationToken.None)).then(ie=>this.v(q,U,N,ie));return new Promise(ie=>{K.then(ce=>{Promise.all(U).then(()=>{ie(ce)})})})}async $resolveTask(V,q){const N=this.j.get(V);if(!N)return Promise.reject(new Error("no handler found"));if(q.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${N.type}].`);const U=await m.to(q,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const K=await N.provider.resolveTask(U,T.CancellationToken.None);if(!K)return;this.A(K,N);const ie=m.from(K,N.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(V,q,N){const U=await this.a.$createTaskId(V);!N&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,q.execution)),this.m.set(U,q.execution)}async z(V,q){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const N=this.l.get(V.id);if(N)return N;let U;return q?U=Promise.resolve(new y(this,V.id,q)):U=m.to(V.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new y(this,V.id,K)}),this.l.set(V.id,U),U.then(K=>(this.k.set(V.id,K),K))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const N=this.n.values();let U=N.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=N.next()}};e.$2mc=C,e.$2mc=C=Je([We(0,d.$qP),We(1,v.$GP),We(2,w.$wlc),We(3,p.$BP),We(4,E.$zlc),We(5,D.$Xlc),We(6,s.$3j),We(7,i.$alc)],C);let P=class extends C{constructor(V,q,N,U,K,ie,ce,ye){super(V,q,N,U,K,ie,ce,ye),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const N=m.from(q,V);if(N===void 0)throw new Error("Task is not valid");if(S.is(N.execution))await this.y(N,q,!1);else throw new c.$_;const U=await this.z(await this.a.$getTaskExecution(N),q);return this.a.$executeTask(N).catch(K=>{throw new Error(K)}),U}v(V,q,N,U){const K=[];if(U)for(const ie of U){if(this.A(ie,N),!ie.definition||!V[ie.definition.type]){const ye=ie.source?ie.source:"No task source";this.f.warn(`The task [${ye}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=m.from(ie,N.extension);ce&&S.is(ce.execution)?(K.push(ce),q.push(this.y(ce,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:N.extension}}async w(V){if(S.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,N){}};e.$3mc=P,e.$3mc=P=Je([We(0,d.$qP),We(1,v.$GP),We(2,w.$wlc),We(3,p.$BP),We(4,E.$zlc),We(5,D.$Xlc),We(6,s.$3j),We(7,i.$alc)],P),e.$4mc=(0,g.$wi)("IExtHostTask")}),define(Ie[299],Pe([1,0,47,30]),function(le,e,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GL=void 0,e.$FL=A,e.$HL=O;function A(R){return"cellResults"in R}e.$GL="rawCell#";function O(R,w){let p=-1;const E=[];let T=[];return R.forEach(d=>{d.range.startLineNumber!==p&&T.length>0&&(E.push([...T]),T=[]),T.push(d),p=d.range.endLineNumber}),T.length>0&&E.push([...T]),E.map(d=>{const v=[],g=d[0].range.startLineNumber,r=d[d.length-1].range.endLineNumber;for(let o=g;o<=r;o++)v.push(w.getLineContent(o));return new I.$jL(v.join(`
`)+`
`,d.map(o=>new M.$ut(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ie[300],Pe([1,0,177,21,5,6,28,13,15,2,38,76,4,32,8,7,35,275,114,25,16,231,299,297]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n,c,l,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(u=>u.apiEditor)}constructor(u,S,h,b,m,k){this.q=h,this.r=b,this.s=m,this.t=k,this.f=new Map,this.g=new R.$Bc,this.h=new Map,this.j=new A.$ee,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$ee,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$ee,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$ee,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$$kc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=u.getProxy(d.$3M.MainThreadNotebook),this.c=u.getProxy(d.$3M.MainThreadNotebookDocuments),this.d=u.getProxy(d.$3M.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,P=y.cell.handle,V=this.g.get(C)?.getCell(P);if(V)return V.apiCell}if(y&&y.$mid===14){const C=y.uri,P=this.g.get(C);if(P)return P.apiNotebook}return y}}),a.B(S)}getEditorById(u){const S=this.h.get(u);if(!S)throw new Error(`unknown text editor: ${u}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(u){for(const[S,h]of this.h)if(h.apiEditor===u)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(u,S){const h=this.g.get(u);if(!h&&!S)throw new Error(`NO notebook document for '${u}'`);return h}static u(u,S){if(!S)return;const h=S.filenamePattern.map(b=>g.NotebookExclusiveDocumentPattern.from(b)).filter(b=>b!==void 0);if(S.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:S.displayName,filenamePattern:h,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,S,h){const b=a.a++,m=typeof h.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(b,h),this.b.$registerNotebookCellStatusBarItemProvider(b,m,S);let k;return m!==void 0&&(k=h.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(m))),new r.$5M(()=>{this.f.delete(b),this.b.$unregisterNotebookCellStatusBarItemProvider(b,m),k?.dispose()})}async createNotebookDocument(u){const S=await this.c.$tryCreateNotebook({viewType:u.viewType,content:u.content&&g.NotebookData.from(u.content)});return E.URI.revive(S)}async openNotebookDocument(u){const S=this.g.get(u);if(S)return S.apiNotebook;const h=await this.c.$tryOpenNotebook(u),b=this.g.get(E.URI.revive(h));return(0,p.$hg)(b?.apiNotebook)}async showNotebookDocument(u,S){E.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let h;typeof S=="object"?h={position:g.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(g.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:h={preserveFocus:!1};const b=await this.d.$tryShowNotebookDocument(u.uri,u.notebookType,h),m=b&&this.h.get(b)?.apiEditor;if(m)return m;throw b?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,S,h,b){const m=this.f.get(u),k=E.URI.revive(S),y=this.g.get(k);if(!y||!m)return;const C=y.getCellFromIndex(h);if(!C)return;const P=await m.provideCellStatusBarItems(C.apiCell,b);if(!P)return;const W=new O.$Uc,V=this.p.add([W]),N=(Array.isArray(P)?P:[P]).map(U=>g.NotebookStatusBarItem.from(U,this.i,W));return{cacheId:V,items:N}}$releaseNotebookCellStatusBarItems(u){this.p.delete(u)}registerNotebookSerializer(u,S,h,b,m){if((0,w.$8e)(S))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:S,serializer:h,options:b}),this.b.$registerNotebookSerializer(k,{id:u.identifier,location:u.extensionLocation},S,g.NotebookDocumentContentOptions.from(b),a.u(u,m)),(0,O.$Tc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(u,S,h){const b=this.x.get(u);if(!b)throw new Error("NO serializer found");const m=await b.serializer.deserializeNotebook(S.buffer,h);return new o.$vw(g.NotebookData.from(m))}async $notebookToData(u,S,h){const b=this.x.get(u);if(!b)throw new Error("NO serializer found");const m=await b.serializer.serializeNotebook(g.NotebookData.to(S.value),h);return M.$Ge.wrap(m)}async $saveNotebook(u,S,h,b,m){const k=E.URI.revive(S),y=this.x.get(u);if(!y)throw new Error("NO serializer found");const C=this.g.get(k);if(!C)throw new Error("Document NOT found");if(C.versionId!==h)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new T.$ll((0,I.localize)(0,null,this.z(k)),6);await this.y(k,b);const P={metadata:(0,n.$$n)(C.apiNotebook.metadata,U=>!(y.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of C.apiNotebook.getCells()){const K=new r.$vO(U.kind,U.document.getText(),U.document.languageId,U.mime,y.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);K.metadata=(0,n.$$n)(U.metadata,ie=>!(y.options?.transientCellMetadata??{})[ie]),P.cells.push(K)}const W=await y.serializer.serializeNotebook(P,m);await this.s.value.writeFile(k,W);const V=this.s.getFileSystemProviderExtUri(k.scheme),q=await this.s.value.stat(k);return{name:V.basename(k),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$wl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(u,S,h,b,m){const k=this.x.get(u)?.serializer;if(!k)return{limitHit:!1,results:[]};const y=new R.$Cc;await(async(q,N,U)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const ce={_reason:U._reason,folderQueries:U.folderQueries,includePattern:U.includePattern,excludePattern:U.excludePattern,maxResults:U.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(ce,N,ye=>{ye.forEach(Se=>{y.has(Se)||b.some($e=>K.isFromSettings&&!$e.isFromSettings?!1:$e.filenamePatterns.some(Te=>(0,f.$ehb)(Te,Se)))||y.add(Se)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(h,m,S);const P=new R.$Bc;let W=!1;const V=Array.from(y).map(async q=>{const N=[];try{if(m.isCancellationRequested)return;if(S.maxResults&&[...P.values()].reduce((ce,ye)=>ce+ye.cellResults.length,0)>S.maxResults){W=!0;return}const U=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ye=>U.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(Se=>Se.items.map(fe=>fe.data.toString()))}));else{const ce=await this.s.value.readFile(q),ye=M.$Ge.fromString(ce.toString()),Se=await k.deserializeNotebook(ye.buffer,m);if(m.isCancellationRequested)return;g.NotebookData.from(Se).cells.forEach($e=>U.push({input:$e.source,outputs:$e.outputs.flatMap(Te=>Te.items.map(ae=>ae.valueBytes.toString()))}))}if(m.isCancellationRequested)return;U.forEach((ce,ye)=>{const Se=S.contentPattern.pattern,fe=new l.$gXb(ce.input,void 0,ce.outputs),$e=fe.findInInputs(Se),Te=fe.findInOutputs(Se),ae=Te.flatMap(Ne=>(0,t.$HL)(Ne.matches,Ne.textBuffer)).map((Ne,ne)=>(Ne.webviewIndex=ne,Ne));if($e.length>0||Te.length>0){const Ne={index:ye,contentResults:(0,t.$HL)($e,fe.inputTextBuffer),webviewResults:ae};N.push(Ne)}});const ie={resource:q,cellResults:N};P.set(q,ie);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...P.values()]}}async y(u,S){const h=await this.s.value.stat(u);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==T.$vl&&typeof h.mtime=="number"&&typeof h.size=="number"&&S.mtime<h.mtime&&S.etag!==T.$wl({mtime:S.mtime,size:h.size}))throw new T.$ll((0,I.localize)(1,null),3,S)}z(u){return u.scheme===c.Schemas.file?u.fsPath:u.toString()}A(u,S,h){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const b=new i.$vmc(S,this.d,u,h.visibleRanges.map(g.NotebookRange.to),h.selections.map(g.NotebookRange.to),typeof h.viewColumn=="number"?g.ViewColumn.to(h.viewColumn):void 0);this.h.set(S,b)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const h of u.value.removedDocuments){const b=E.URI.revive(h),m=this.g.get(b);m&&(m.dispose(),this.g.delete(b),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(m.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===b.toString()&&this.h.delete(k.id)}if(u.value.addedDocuments){const h=[];for(const b of u.value.addedDocuments){const m=E.URI.revive(b.uri);if(this.g.has(m))throw new Error(`adding EXISTING notebook ${m} `);const k=new s.$umc(this.c,this.q,this.r,m,b);h.push(...b.cells.map(y=>s.$tmc.asModelAddData(y))),this.g.get(m)?.dispose(),this.g.set(m,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:h}),this.m.fire(k.apiNotebook)}}if(u.value.addedEditors)for(const h of u.value.addedEditors){if(this.h.has(h.id))return;const b=E.URI.revive(h.documentUri),m=this.g.get(b);m&&this.A(m,h.id,h)}const S=[];if(u.value.removedEditors)for(const h of u.value.removedEditors){const b=this.h.get(h);b&&(this.h.delete(h),this.k?.id===b.id&&(this.k=void 0),S.push(b))}if(u.value.visibleEditors){this.l=u.value.visibleEditors.map(b=>this.h.get(b)).filter(b=>!!b);const h=new Set;this.l.forEach(b=>h.add(b.id));for(const b of this.h.values()){const m=h.has(b.id);b._acceptVisibility(m)}this.l=[...this.h.values()].map(b=>b).filter(b=>b.visible),this.o.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this.k=void 0:u.value.newActiveEditor&&(this.h.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this.k=this.h.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(u){const S=v.$OP.String.with("notebookType","A notebook type"),h=new v.$QP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new v.$OP("data","Bytes to convert to data",m=>m instanceof Uint8Array,m=>M.$Ge.wrap(m))],new v.$PP("Notebook Data",m=>g.NotebookData.to(m.value))),b=new v.$QP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new v.$OP("NotebookData","Notebook data to convert to bytes",m=>!0,m=>new o.$vw(g.NotebookData.from(m)))],new v.$PP("Bytes",m=>m.buffer));u.registerApiCommand(h),u.registerApiCommand(b)}}e.$Emc=a}),define(Ie[301],Pe([1,0,19,24,44,37,23,66,47]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class E{constructor(d,v,g){this.k=d,this.l=v,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=d.filePattern,this.b=d.includePattern&&O.$qk(d.includePattern),this.c=d.maxResults||void 0,this.d=d.exists,this.h=new Set,this.j=d.excludePattern&&O.$qk(d.excludePattern)}cancel(){this.g=!0,this.h.forEach(d=>d.cancel()),this.h=new Set}search(d){const v=this.k.folderQueries||[];return new Promise((g,r)=>{const o=s=>{this.f++,d(s)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=I.$oc(i);this.j&&this.j(i,n)||this.v(o,{base:s,basename:n})}),Promise.all(v.map(s=>this.p(s,o))).then(s=>{g({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,A.$hj)(s)))})})}async p(d,v){const g=new M.$pe,r=this.q(d),o=this.r(),s=new p.$xL(this.k,d),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(g),n=w.$ae.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,g.token),l=n.elapsed(),t=w.$ae.create();return this.g&&!this.e||(c&&c.forEach(f=>{const a=I.$hc.relative(d.folder.path,f.path);if(i){const $=I.$oc(f.path);this.v(v,{base:d.folder,relativePath:a,basename:$});return}this.s(o,d.folder,a,v)}),this.g&&!this.e)?null:(this.u(o,s,v),{providerTime:l,postProcessTime:t.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(d){const v=(0,p.$wL)(this.k.includePattern,d.includePattern),g=(0,p.$wL)(this.k.excludePattern,d.excludePattern);return{folder:d.folder,excludes:g,includes:v,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}s({pathToEntries:d},v,g,r){if(g===this.a){const s=I.$oc(this.a);this.v(r,{base:v,relativePath:this.a,basename:s})}function o(s){const i=I.$oc(s),n=I.$nc(s);let c=d[n];c||(c=d[n]=[],o(n)),c.push({base:v,relativePath:s,basename:i})}o(g)}u({rootEntries:d,pathToEntries:v},g,r){const o=this,s=this.a;function i(n){const c=(0,p.$zL)(()=>n.map(l=>l.basename));for(let l=0,t=n.length;l<t;l++){const f=n[l],{relativePath:a,basename:$}=f;if(g.matchesExcludesSync(a,$,s!==$?c:void 0))continue;const u=v[a];if(u)i(u);else{if(a===s)continue;o.v(r,f)}if(o.e)break}}i(d)}v(d,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||d(v))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(d,v,g,r){const o=this.c(d.cacheKey),s=new E(d,v,o&&o.token);let i=0;const n=c=>{i+=c.length,g(c.map(l=>this.d(l)))};return this.e(s,T.a,n,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:c.stats}}))}clearCache(d){this.c(d)?.cancel()}c(d){if(d)return this.b.has(d)||this.b.set(d,new M.$pe),this.b.get(d)}d(d){return d.relativePath?{resource:R.$0g(d.base,d.relativePath)}:{resource:d.base}}e(d,v,g,r){const o=r.onCancellationRequested(()=>{d.cancel()}),s=n=>{n&&(i.push(n),v>0&&i.length>=v&&(g(i),i=[]))};let i=[];return d.search(s).then(n=>(i.length&&g(i),o.dispose(),n),n=>(i.length&&g(i),o.dispose(),Promise.reject(n)))}}e.$wmc=T}),define(Ie[302],Pe([1,0,18,270,37,97,28,16,19,23,13,15,2,96,195,50,12,45,109,298,47]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=void 0,e.$HM=b;let l=class{constructor(k,y,C,P,W){this.a=k,this.b=y,this.c=C,this.d=P,this.e=W}text(k,y,C={}){k=this.f(k,C);const P=this.a.getValue(),W=y&&y.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(y?.map(s.$Ri),C),type:2,contentPattern:k,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:P.search.usePCRE2||W||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(k,y){const C=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const P={...k,wordSeparators:C.editor.wordSeparators};return this.j(k,y)&&(P.isCaseSensitive=!0),this.k(k)&&(P.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),P}file(k,y={}){return{...this.h(k,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(k,y){return k?(k=Array.isArray(k)?k.map(u):u(k),y?this.parseSearchPaths(k):{pattern:f(...Array.isArray(k)?k:[k])}):{}}h(k=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),P=this.g(y.excludePattern,y.expandPatterns),W=k.length>1,V=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(U=>this.q(U,y,P)):k.map(U=>this.r(U,y,P,W))).filter(U=>!!U),q={_reason:y._reason,folderQueries:V,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:P.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const U=I.$Hb(I.$Rb(this.c.groups.map(ce=>ce.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const K=U.filter(ce=>(0,c.$nL)(q,ce.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const N=y.extraFileResources&&y.extraFileResources.filter(U=>(0,c.$nL)(q,U.fsPath));return q.extraFileResources=N&&N.length?N:void 0,q}i(k){const y=[],C=new R.$Bc,P={};let W=!1;return k.forEach(V=>{if(V.scheme===w.Schemas.walkThrough)return;if((0,E.$bh)(V)){const N=this.b.getWorkspaceFolder(V)?.uri??V.with({path:p.$nc(V.fsPath)});let U=C.get(N);U||(W=!0,U={folder:N,includePattern:{}},y.push(U),C.set(N,U));const K=p.$mc(N.fsPath,V.fsPath);(0,D.$hg)(U.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,P[V.fsPath]=!0)}),{folderQueries:y,includePattern:P,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(k,y){if(y.isSmartCase){if(k.isRegExp){if(T.$Zf(k.pattern,!0))return!0}else if(T.$Zf(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,v.$KC)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const y=ie=>p.$jc(ie)||/^\.\.?([\/\\]|$)/.test(ie),P=(Array.isArray(k)?k:a(k)).map(ie=>{const ce=this.e.resolvedUserHome;return ce?(0,O.$Aw)(ie,ce.scheme===w.Schemas.file?ce.fsPath:ce.path):ie}),W=M.$K(P,ie=>y(ie)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(ie=>T.$gf(ie,"/")).map(ie=>T.$gf(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),$(ie))),q={},N=this.m(W.searchPaths||[]);N&&N.length&&(q.searchPaths=N);const U=I.$Rb(V),K=f(...U);return K&&(q.pattern=K),q}l(k,y){return y.disregardExcludeSettings?void 0:(0,c.$mL)(k,!y.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const y=k.flatMap(P=>{let{pathPortion:W,globPortion:V}=t(P);return V&&(V=S(V)),this.n(W).flatMap(N=>this.o(N,V))}),C=new Map;return y.forEach(P=>{const W=P.searchPath.toString(),V=C.get(W);V?P.pattern&&(V.pattern=V.pattern||{},V.pattern[P.pattern]=!0):C.set(W,{searchPath:P.searchPath,pattern:P.pattern?f(P.pattern):void 0})}),Array.from(C.values())}n(k){if(p.$jc(k)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==w.Schemas.file?[{searchPath:y[0].uri.with({path:k})}]:[{searchPath:d.URI.file(p.$ic(k))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(k=u(k),k.startsWith("../")||k===".."){const P=p.$hc.resolve(y.path,k);return[{searchPath:y.with({path:P})}]}const C=S(k);return[{searchPath:y,pattern:C}]}else{if(k==="./"||k===".\\")return[];{const y=k.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(W=>{const V=y.match(new RegExp(`^${T.$af(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(D.$eg);if(P.length)return P.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&S(V)}});{const W=k.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:k,q=g.localize(0,null,V);throw new Error(q)}}}}o(k,y){const C=k.pattern&&y?`${k.pattern}/${y}`:k.pattern||y,P=[{searchPath:k.searchPath,pattern:C}];return C&&!C.endsWith("**")&&P.push({searchPath:k.searchPath,pattern:C+"/**"}),P}q(k,y,C){const P=this.r((0,s.$Ri)(k.searchPath),y,C,!1);return P?{...P,includePattern:k.pattern}:null}r(k,y,C,P){let W;const V=d.URI.isUri(k)?k:k.uri;if(C.searchPaths){const ie=C.searchPaths.filter(ce=>(0,E.$3g)(ce.searchPath,V))[0];if(ie&&!ie.pattern)return null;ie&&(W=ie.pattern)}const q=this.a.getValue({resource:V}),U={...this.l(q,y)||{},...W||{}},K=d.URI.isUri(k)?(0,E.$7g)(k):k.name;return{folder:V,folderName:P?K:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!q.search.followSymlinks}}};e.$GM=l,e.$GM=l=Je([We(0,r.$3i),We(1,s.$Fi),We(2,i.$RD),We(3,o.$3j),We(4,n.$EM)],l);function t(m){const k=m.match(/[\*\{\}\(\)\[\]\?]/);if(k){const y=k.index,C=m.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let P=m.substr(0,C.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:m.substr((C.index||0)+1)}}}return{pathPortion:m}}function f(...m){return m.length?m.reduce((k,y)=>(k[y]=!0,k),Object.create(null)):void 0}function a(m){return A.$ok(m,",").map(k=>k.trim()).filter(k=>!!k.length)}function $(m){return[`**/${m}/**`,`**/${m}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function u(m){return m.replace(/\\/g,"/")}function S(m){return u(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(m){return m.replace(/([?*[\]])/g,"[$1]")}function b(m,k){m=I.$Mb(m,P=>P.toString());const y=[],C=k.getWorkspace();return m&&m.forEach(P=>{let W;if(k.getWorkbenchState()===2)W=(0,E.$_g)(C.folders[0].uri,P),W&&W!=="."&&(W="./"+W);else{const V=k.getWorkspaceFolder(P);if(V){const q=V.name;if(C.folders.filter(U=>U.name===q).length===1){const U=(0,E.$_g)(V.uri,P);U===""?W=`./${V.name}`:W=`./${V.name}/${U}`}else W=P.fsPath}}W&&y.push(h(W))}),y}}),define(Ie[303],Pe([1,0,23,2,24,14,3,302,47,45,11]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nwb=d,e.$owb=r;const D=7e3;function d(o,s){const i=s.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],c=[];for(const u of i)if(/^workspaceContains:/.test(u)){const S=u.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||o.forceUsingSearch?c.push(S):n.push(S)}if(n.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:l,resolve:t}=(0,T.$ph)(),f=u=>t({activationEvent:u}),a=Promise.all(n.map(u=>v(o,u,f))).then(()=>{}),$=g(o,s.identifier,c,f);return Promise.all([a,$]).then(()=>{t(void 0)}),l}async function v(o,s,i){for(const n of o.folders)if(await o.exists(I.$0g(M.URI.revive(n),s))){i(`workspaceContains:${s}`);return}}async function g(o,s,i,n){if(i.length===0)return Promise.resolve(void 0);const c=new A.$pe,l=o.checkExists(o.folders,i,c.token),t=setTimeout(async()=>{c.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},D);let f=!1;try{f=await l}catch(a){O.$4(a)||O.$1(a)}c.dispose(),clearTimeout(t),f&&n(`workspaceContains:${i.join(",")}`)}function r(o,s,i,n){const c=o.get(R.$vi),l=o.get(p.$eL),f=c.createInstance(w.$GM).file(s.map(a=>(0,E.$Ri)(M.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return l.fileSearch(f,n).then(a=>!!a.limitHit,a=>O.$4(a)?!1:Promise.reject(a))}}),define(Ie[41],Pe([1,0,173,19,60,23,11,6,54,2,12,4,40,237,84,39,26,110,14,20,21,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,22,82]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n,c,l,t,f,a,$,u,S,h,b,m,k,y,C,P,W,V,q,N,U,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=e.$bmc=e.$amc=e.$_lc=e.$$lc=void 0,e.$$lc=(0,a.$wi)("IHostUtils");let ce=ie=class extends w.$Vc{constructor(z,x,ve,Fe,De,we,ge,Q,Y,he,ue,Oe,de){super(),this.Y=Oe,this.Z=de,this.a=this.B(new y.$ee),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=ve,this.f=ge,this.j=Fe,this.m=De,this.s=we,this.t=Y,this.u=he,this.w=ue,this.y=this.g.getProxy(D.$3M.MainThreadWorkspace),this.z=this.g.getProxy(D.$3M.MainThreadTelemetry),this.C=this.g.getProxy(D.$3M.MainThreadExtensionService),this.D=new R.$vh,this.F=new R.$vh,this.G=new R.$vh,this.H=new R.$vh,this.I=new Ne(this.f.extensions.activationEvents),this.L=new s.$L_b(this.I,this.f.extensions.allExtensions);const Ce=new n.$Sm(this.f.extensions.myExtensions);this.J=new s.$L_b(this.I,Te(this.L,Ce)),U.$t&&(this.s.info(`Creating extension host with the following global extensions: ${fe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${fe(this.J)}`)),this.M=new g.$Tlc(this.g,this.s),this.N=new P.$4lc(this.g),this.O=Q,this.h=z.createChild(new h.$ui([g.$Ulc,this.M],[P.$5lc,this.N])),this.P=this.B(new v.$Slc(this.J,this.L,{onExtensionActivationError:(Ae,Ue,j)=>{this.C.$onExtensionActivationError(Ae,i.$3(Ue),j)},actualActivateExtension:async(Ae,Ue)=>{if(s.$L_b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,Ue),new v.$Rlc;const j=this.J.getExtensionDescription(Ae);return this.fb(j,Ue)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(z){i.$1(z)}}async $(){this.O.onWillDeactivateAll();let z=[];try{z=this.J.getAllExtensionDescriptions().map(De=>De.identifier).filter(De=>this.isActivated(De)).map(De=>this.eb(De))}catch{}await Promise.all(z)}terminate(z,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Fe=>{this.s.error(Fe)}),this.g.dispose();const ve=this.$();Promise.race([(0,R.$xh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(z){return this.G.isOpen()?this.P.isActivated(z):!1}async getExtension(z){const x=await this.C.$getExtension(z);return x&&{...x,identifier:new n.$Rm(x.identifier.value),extensionLocation:E.URI.revive(x.extensionLocation)}}ab(z,x){return this.P.activateByEvent(z,x)}bb(z,x){return this.P.activateById(z,x)}activateByIdWithErrors(z,x){return this.bb(z,x).then(()=>{const ve=this.P.getActivatedExtension(z);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(z=>this.J)}getExtensionExports(z){if(this.G.isOpen())return this.P.getActivatedExtension(z).exports;try{return this.P.getActivatedExtension(z).exports}catch{return null}}async cb(z){if(z.scheme===V.Schemas.file&&this.c.fsRealpath){const x=z.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const ve=await this.R.get(x);return E.URI.file(ve)}return z}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(z=>new ae(z))),this.Q}async db(z){const x=p.$Ci.forUris(ve=>O.$1g.ignorePathCasing(ve));return await Promise.all(z.map(async ve=>{if(this.wb(ve)){const Fe=await this.cb(ve.extensionLocation);x.set(Fe,ve)}})),x}eb(z){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(z))return x;const ve=this.P.getActivatedExtension(z);if(!ve)return x;try{typeof ve.module.deactivate=="function"&&(x=Promise.resolve(ve.module.deactivate()).then(void 0,Fe=>(this.s.error(Fe),Promise.resolve(void 0))))}catch(Fe){this.s.error(`An error occurred when deactivating the extension '${z.value}':`),this.s.error(Fe)}try{(0,w.$Qc)(ve.subscriptions)}catch(Fe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${z.value}':`),this.s.error(Fe)}return x}async fb(z,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(z.identifier):await this.C.$onWillActivateExtension(z.identifier),this.hb(z,x).then(ve=>{const Fe=ve.activationTimes;return this.C.$onDidActivateExtension(z.identifier,Fe.codeLoadingTime,Fe.activateCallTime,Fe.activateResolvedTime,x),this.gb(z,x,"success",Fe),ve},ve=>{throw this.gb(z,x,"failure"),ve})}gb(z,x,ve,Fe){const De=Se(z,x);this.z.$publicLog2("extensionActivationTimes",{...De,...Fe||{},outcome:ve})}hb(z,x){const ve=Se(z,x);this.z.$publicLog2("activatePlugin",ve);const Fe=this.wb(z);if(!Fe)return Promise.resolve(new v.$Qlc(v.$Nlc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${z.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${z.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const De=new v.$Olc(x.startup);return Promise.all([this.xb(z,(0,O.$0g)(z.extensionLocation,Fe),De),this.ib(z)]).then(we=>(A.mark(`code/extHost/willActivateExtension/${z.identifier.value}`),ie.jb(this.s,z.identifier,we[0],we[1],De))).then(we=>(A.mark(`code/extHost/didActivateExtension/${z.identifier.value}`),we))}ib(z){const x=this.Z.createLanguageModelAccessInformation(z),ve=new l.$Wlc(z,this.M),Fe=new l.$Vlc(z.identifier.value,!1,this.M),De=new W.$6lc(z,this.N),we=z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${z.identifier.value}`),Promise.all([ve.whenReady,Fe.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,he;const ue=(0,o.$HG)(z,"ipc")?this.f.messagePorts?.get(n.$Rm.toKey(z.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Fe,secrets:De,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return z.extensionLocation},get extensionPath(){return z.extensionLocation.fsPath},asAbsolutePath(Oe){return M.$kc(z.extensionLocation.fsPath,Oe)},get storagePath(){return Q.O.workspaceValue(z)?.fsPath},get globalStoragePath(){return Q.O.globalValue(z).fsPath},get logPath(){return M.$kc(Q.f.logsLocation.fsPath,z.identifier.value)},get logUri(){return E.URI.joinPath(Q.f.logsLocation,z.identifier.value)},get storageUri(){return Q.O.workspaceValue(z)},get globalStorageUri(){return Q.O.globalValue(z)},get extensionMode(){return we},get extension(){return Y===void 0&&(Y=new $e(Q,z.identifier,z,ge,!1)),Y},get extensionRuntime(){return(0,o.$IG)(z,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(z)},get messagePassingProtocol(){if(!he){if(!ue)return;const Oe=y.Event.buffer(y.Event.fromDOMEventEmitter(ue,"message",de=>de.data));ue.start(),he={onDidReceiveMessage:Oe,postMessage:ue.postMessage.bind(ue)}}return he}})})}static jb(z,x,ve,Fe,De){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(z,x,ve,Fe,De).then(we=>new v.$Plc(!1,null,De.build(),ve,we,Fe.subscriptions))}static kb(z,x,ve,Fe,De){if(typeof ve.activate=="function")try{De.activateCallStart(),z.trace(`ExtensionService#_callActivateOptional ${x.value}`);const we=typeof global=="object"?global:self,ge=ve.activate.apply(we,[Fe]);return De.activateCallStop(),De.activateResolveStart(),Promise.resolve(ge).then(Q=>(De.activateResolveStop(),Q))}catch(we){return Promise.reject(we)}else return Promise.resolve(ve)}lb(z,x){this.bb(z.identifier,{startup:!1,extensionId:z.identifier,activationEvent:x}).then(void 0,ve=>{this.s.error(ve)})}mb(z,x=0){const Fe=Date.now();(0,U.$B)(()=>{for(let De=x;De<z.length;De+=1){const we=z[De];for(const ge of we.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Fe>50){this.mb(z,De);break}else this.lb(we,ge)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(z=>{const x=z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(x)this.mb(ve);else for(const Fe of ve)if(Fe.activationEvents)for(const De of Fe.activationEvents)De==="onStartupFinished"&&this.lb(Fe,De)})}ob(){const z=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const x=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(x),Fe=this.rb(),De=Promise.all([Fe,z,ve]).then(()=>{});return Promise.race([De,(0,R.$xh)(1e4)]).then(()=>{this.nb()}),De}pb(z){return z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(z,x))).then(()=>{})}async qb(z,x){if(this.isActivated(x.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Fe={logService:this.s,folders:z.map(we=>we.uri),forceUsingSearch:ve||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,ge,Q)=>this.y.$checkExists(we,ge,Q)},De=await(0,C.$nwb)(Fe,x);if(De)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:De.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(z){throw console.error(z),z}}async sb(){const{extensionDevelopmentLocationURI:z,extensionTestsLocationURI:x}=this.f.environment;if(!z||!x)throw new Error(I.localize(0,null));const ve=await this.xb(null,x,new v.$Olc(!1));if(!ve||typeof ve.run!="function")throw new Error(I.localize(1,null,x.toString()));return new Promise((Fe,De)=>{const we=(Y,he)=>{Y?(U.$t&&this.s.error("Test runner called back with error",Y),De(Y)):(U.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Fe(typeof he=="number"&&he>0?1:0))},ge=(0,O.$Xg)(x),Q=ve.run(ge,we);Q&&Q.then&&Q.then(()=>{U.$t&&this.s.info("Test runner finished successfully."),Fe(0)}).catch(Y=>{U.$t&&this.s.error("Test runner finished with error",Y),De(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$xh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(z,x){return this.S[z]=x,(0,w.$Tc)(()=>{delete this.S[z]})}async getRemoteExecServer(z){const{resolver:x}=await this.ub(z);return x?.resolveExecServer?.(z,{resolveAttempt:0})}async ub(z){const x=z.indexOf("+");if(x===-1)throw new t.$$M("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=z.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(z,x){const ve=N.$ae.create(!1),Fe=()=>`[resolveAuthority(${(0,f.$Ll)(z)},${x})][${ve.elapsed()}ms] `,De=F=>this.s.info(`${Fe()}${F}`),we=F=>this.s.warn(`${Fe()}${F}`),ge=(F,H=void 0)=>this.s.error(`${Fe()}${F}`,H),Q=F=>{if(F instanceof t.$$M)return{type:"error",error:{code:F._code,message:F._message,detail:F._detail}};throw F},Y=async F=>{De(`activating resolver for ${F}...`);const{resolver:H,authorityPrefix:G}=await this.ub(F);if(!H)throw ge(`no resolver for ${G}`),new t.$$M(`No remote extension installed to resolve ${G}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:G,remoteAuthority:F}},he=z.split(/@|%40/g).reverse();De(`activating remote resolvers ${he.join(" -> ")}`);let ue;try{ue=await Promise.all(he.map(Y)).catch(async F=>{if(!(F instanceof t.$$M)||F._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw F;return we(`resolving nested authorities failed: ${F.message}`),[await Y(z)]})}catch(F){return Q(F)}const Oe=new R.$Hh;Oe.cancelAndSet(()=>De("waiting..."),1e3);let de,Ce;for(const[F,{authorityPrefix:H,resolver:G,remoteAuthority:ee}]of ue.entries())try{if(F===ue.length-1)De("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${H}`),de=await G.resolve(ee,{resolveAttempt:x,execServer:Ce}),A.mark(`code/extHost/didResolveAuthorityOK/${H}`),De("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(G,t.$0M.isManagedResolvedAuthority(de)?de:void 0));else{if(De(`invoking resolveExecServer() for ${ee}`),A.mark(`code/extHost/willResolveExecServer/${H}`),Ce=await G.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Ce}),!Ce)throw new t.$$M(`Exec server was not available for ${ee}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(re){return A.mark(`code/extHost/didResolveAuthorityError/${H}`),ge("returned an error",re),Oe.dispose(),Q(re)}Oe.dispose();const Ae={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},Ue={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};De(`returned ${t.$0M.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let j;if(t.$0M.isManagedResolvedAuthority(de)){const F=x;this.Y.setFactory(F,de.makeConnection),j={authority:z,connectTo:new f.$Il(F),connectionToken:de.connectionToken}}else j={authority:z,connectTo:new f.$Jl(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:j,options:Ue,tunnelInformation:Ae}}}async $getCanonicalURI(z,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$Ll)(z)})`);const{resolver:ve}=await this.ub(z);if(!ve)return null;const Fe=E.URI.revive(x);if(typeof ve.getCanonicalURI>"u")return Fe;const De=await(0,R.$oh)(()=>ve.getCanonicalURI(Fe));return De||Fe}async $startExtensionHost(z){z.toAdd.forEach(we=>we.extensionLocation=E.URI.revive(we.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,z),Fe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),U.$t&&(this.s.info(`$startExtensionHost: global extensions: ${fe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${fe(this.J)}`)),this.tb()}$activateByEvent(z,x){return x===1?this.D.wait().then(ve=>this.ab(z,!1)):this.G.wait().then(ve=>this.ab(z,!1))}async $activate(z,x){return await this.G.wait(),this.J.getExtensionDescription(z)?(await this.bb(z,x),!0):!1}async $deltaExtensions(z){z.toAdd.forEach(we=>we.extensionLocation=E.URI.revive(we.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,z),Fe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),U.$t&&(this.s.info(`$deltaExtensions: global extensions: ${fe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${fe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(z){return z}async $test_up(z){return z.byteLength}async $test_down(z){const x=c.$Ge.alloc(z),ve=Math.random()%256;for(let Fe=0;Fe<z;Fe++)x.writeUInt8(ve,Fe);return x}async $updateRemoteConnectionData(z){this.X=z,this.a.fire()}};e.$_lc=ce,e.$_lc=ce=ie=Je([We(0,a.$vi),We(1,e.$$lc),We(2,S.$qP),We(3,r.$wlc),We(4,d.$zlc),We(5,T.$3j),We(6,$.$GP),We(7,u.$Clc),We(8,b.$tDb),We(9,m.$Xlc),We(10,q.$8lc),We(11,K.$9lc),We(12,k.$2lc)],ce);function ye(ne,z,x,ve){ne.addActivationEvents(ve.addActivationEvents);const Fe=new s.$L_b(ne,z.getAllExtensionDescriptions());Fe.deltaExtensions(ve.toAdd,ve.toRemove);const De=new n.$Sm(x.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of ve.myToRemove)De.delete(ge);for(const ge of ve.myToAdd)De.add(ge);const we=Te(Fe,De);return{globalRegistry:Fe,myExtensions:we}}function Se(ne,z){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:z.activationEvent,reasonId:z.extensionId.value}}function fe(ne){return ne.getAllExtensionDescriptions().map(z=>z.identifier.value).join(",")}e.$amc=(0,a.$wi)("IExtHostExtensionService");class $e{#e;#t;#i;constructor(z,x,ve,Fe,De){this.#e=z,this.#t=x,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=M.$ic((0,O.$Xg)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Fe,this.isFromDifferentExtensionHost=De}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$bmc=$e;function Te(ne,z){return ne.getAllExtensionDescriptions().filter(x=>z.has(x.identifier))}class ae{constructor(z){this.a=z}setSearchTree(z){this.a=z}findSubstr(z){return this.a.findSubstr(z)}forEach(z){return this.a.forEach(z)}}e.$cmc=ae;class Ne{constructor(z){this.a=new n.$Tm,this.addActivationEvents(z)}readActivationEvents(z){return this.a.get(z.identifier)??[]}addActivationEvents(z){for(const x of Object.keys(z))this.a.set(x,z[x])}}}),define(Ie[304],Pe([1,0,60,2,4,40,26,20,17,27,3,41,12,13]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;let r=class{constructor(c,l,t,f,a,$,u){this.c=c,this.d=l,this.e=t,this.f=f,this.g=a,this.h=$,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new s(this.c,l,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,l,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const l of c.nodeModuleName)this.a.set(l,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(l=>c.alternativeModuleName(l))}};e.$lnc=r,e.$lnc=r=Je([We(2,T.$vi),We(3,O.$zlc),We(4,D.$amc),We(5,E.$GP),We(6,d.$3j)],r);let o=class{static{g=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&g.a.size){const l=(0,v.$af)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${a}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const l=this.b.exec(this.c(c));if(!l)return;const[,t,f,a]=l,$=g.a.get(f);if($!==void 0)return console.warn(`${f} as been renamed to ${$}, please update your imports`),t+$+a}c(c){return c.replace(/\\/g,"/")}};o=g=Je([We(0,E.$GP)],o);class s{constructor(c,l,t,f,a){this.c=c,this.d=l,this.e=t,this.f=f,this.g=a,this.nodeModuleName="vscode",this.a=new w.$Tm}load(c,l){const t=this.d.findSubstr(l);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((a,$)=>f+=`	${$} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${f}`),this.b=this.c(R.$CG,this.e,this.f)}return this.b}}let i=class{constructor(c,l,t){this.e=c,this.f=l,this.nodeModuleName=["open","opn"],this.d=t.getProxy(A.$3M.MainThreadTelemetry);const f=t.getProxy(A.$3M.MainThreadWindow);this.c=(a,$)=>{const u=M.URI.parse(a);return $?this.g(a,$):u.scheme==="http"||u.scheme==="https"?f.$openUri(u,a,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?f.$openUri(u,a,{}):this.g(a,$)}}load(c,l,t){const f=this.e.findSubstr(l);return f&&(this.a=f.identifier.value,this.h()),this.b=t(c),this.c}g(c,l){return this.i(),this.b(c,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([We(2,p.$qP)],i)}),define(Ie[122],Pe([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=e.$dmc=void 0,e.$dmc=(0,R.$wi)("IExtHostVariableResolverProvider");class g extends d.$sQ{constructor(s,i,n,c,l,t,f){function a(){if(n){const $=n.activeEditor();if($)return $.document.uri;const u=c.tabGroups.all.find(S=>S.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof T.$QO||u.input instanceof T.$VO)return u.input.modified;if(u.input instanceof T.$PO||u.input instanceof T.$UO||u.input instanceof T.$SO)return u.input.uri}}}super({getFolderUri:$=>{const u=t.folders.filter(S=>S.name===$);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:($,u)=>l.getConfiguration(void 0,$).get(u),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=a();if($)return A.$ic($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const $=a();if($){const u=i.getWorkspaceFolder($);if(u)return A.$ic(u.uri.fsPath)}}},getSelectedText:()=>{if(n){const $=n.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(n){const $=n.activeEditor();if($)return String($.selection.end.line+1)}},getExtension:$=>s.getExtension($)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(O.env))}}let r=class extends M.$Vc{constructor(s,i,n,c,l){super(),this.b=s,this.c=i,this.g=n,this.h=c,this.j=l,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async $=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$emc=r,e.$emc=r=Je([We(0,E.$amc),We(1,D.$wlc),We(2,w.$BP),We(3,v.$zlc),We(4,p.$Llc)],r)}),define(Ie[123],Pe([1,0,11,5,2,20,3,4,67,41,17,7,39,226,228,40,122,6,36,32,8]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=e.$hmc=e.$gmc=e.$fmc=void 0,e.$fmc=(0,R.$wi)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(h,b,m,k,y,C,P){this.N=b,this.O=m,this.P=k,this.Q=y,this.R=C,this.S=P,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new M.$ee,this.o=new M.$ee,this.q=new M.$ee,this.w=new M.$ee,this.l=h.getProxy(w.$3M.MainThreadDebugService),this.A=new M.$ee,this.C=new M.$ee,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(V=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(h,b){const m=this.W(b);if(!m)return;const k=await this.H.get(h)?.getTreeItem?.(m);return k?this.U(h,k):void 0}registerDebugVisualizationTree(h,b,m){const k=O.$Rm.toKey(h.identifier),y=this.jb(k,b);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.H.set(y,m),this.l.$registerDebugVisualizerTree(y,!!m.editItem),(0,s.$Tc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(b)})}async $getVisualizerTreeItemChildren(h,b){const m=this.J.get(b)?.item;return m?(await this.H.get(h)?.getChildren?.(m))?.map(y=>this.U(h,y))||[]:[]}async $editVisualizerTreeItem(h,b){const m=this.J.get(h);if(!m)return;const k=await this.H.get(m.provider)?.editItem?.(m.item,b);return this.U(m.provider,k||m.item)}$disposeVisualizedTree(h){const b=this.J.get(h);if(!b)return;const m=[b.children];for(const k of m)if(k)for(const y of k)m.push(this.J.get(y)?.children),this.J.delete(y)}U(h,b){let m=this.I.get(b);return m||(m=this.F++,this.I.set(b,m),this.J.set(m,{provider:h,item:b})),c.DebugTreeItem.from(b,m)}asDebugSourceUri(h,b){const m=h;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let k=`debug:${encodeURIComponent(m.path||"")}`,y="?";return b&&(k+=`${y}session=${encodeURIComponent(b.id)}`,y="&"),k+=`${y}ref=${m.sourceReference}`,A.URI.parse(k)}else{if(m.path)return A.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(h){const b=[];for(const m of h.getAllExtensionDescriptions())if(m.contributes){const k=m.contributes.debuggers;if(k&&k.length>0)for(const y of k)(0,g.$mH)(y)&&b.push(y.type)}this.l.$registerDebugTypes(b)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const h=[];return this.z.forEach(b=>h.push(b)),h}async $resolveDebugVisualizer(h,b){const m=this.L.get(h);if(!m)throw new Error(`No debug visualizer found with id '${h}'`);let{v:k,provider:y,extensionId:C}=m;if(k.visualization||(k=await y.resolveDebugVisualization?.(k,b)||k,m.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,k.visualization)}async $executeDebugVisualizerCommand(h){const b=this.L.get(h);if(!b)throw new Error(`No debug visualizer found with id '${h}'`);const m=b.v.visualization;m&&"command"in m&&this.S.executeCommand(m.command,...m.arguments||[])}W(h){const b=this.m.get(h.sessionId);return b&&{session:b.api,variable:h.variable,containerId:h.containerId,frameId:h.frameId,threadId:h.threadId}}async $provideDebugVisualizers(h,b,m,k){const y=this.W(m),C=this.jb(h,b),P=this.G.get(C);if(!y||!P)return[];const W=await P.provideDebugVisualization(y,k);return W?W.map(V=>{const q=++this.M;this.L.set(q,{v:V,provider:P,extensionId:h});const N=V.iconPath?this.lb(V.iconPath):void 0;return{id:q,name:V.name,iconClass:N?.iconClass,iconPath:N?.iconPath,visualization:this.kb(h,V.visualization)}}):[]}$disposeDebugVisualizers(h){for(const b of h)this.L.delete(b)}registerDebugVisualizationProvider(h,b,m){if(!h.contributes?.debugVisualizers?.some(C=>C.id===b))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${b})`);const k=O.$Rm.toKey(h.identifier),y=this.jb(k,b);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.G.set(y,m),this.l.$registerDebugVisualizer(k,b),(0,s.$Tc)(()=>{this.l.$unregisterDebugVisualizer(k,b),this.G.delete(b)})}addBreakpoints(h){const b=h.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(b,[],[]);const m=[],k=new Map;for(const y of b)if(y instanceof D.$7N){let C=k.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},k.set(y.location.uri.toString(),C),m.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof D.$8N&&m.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(m)}removeBreakpoints(h){const b=h.filter(C=>this.z.delete(C.id));this.gb([],b,[]);const m=b.filter(C=>C instanceof D.$7N).map(C=>C.id),k=b.filter(C=>C instanceof D.$8N).map(C=>C.id),y=b.filter(C=>C instanceof D.$9N).map(C=>C.id);return this.l.$unregisterBreakpoints(m,k,y)}startDebugging(h,b,m){return this.l.$startDebugging(h?h.uri:void 0,b,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,suppressSaveBeforeStart:m.suppressSaveBeforeStart,suppressDebugStatusbar:m.suppressDebugStatusbar??m.debugUI?.simple,suppressDebugToolbar:m.suppressDebugToolbar??m.debugUI?.simple,suppressDebugView:m.suppressDebugView??m.debugUI?.simple})}stopDebugging(h){return this.l.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,b,m){if(!b)return new D.$5M(()=>{});const k=this.d++;return this.f.push({type:h,handle:k,provider:b}),this.l.$registerDebugConfigurationProvider(h,m,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,k),new D.$5M(()=>{this.f=this.f.filter(y=>y.provider!==b),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(h,b,m){if(!m)return new D.$5M(()=>{});if(!this.cb(h,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.$(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:b,handle:k,factory:m}),this.l.$registerDebugAdapterDescriptorFactory(b,k),new D.$5M(()=>{this.h=this.h.filter(y=>y.factory!==m),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(h,b){if(!b)return new D.$5M(()=>{});const m=this.j++;return this.k.push({type:h,handle:m,factory:b}),new D.$5M(()=>{this.k=this.k.filter(k=>k.factory!==b)})}async $runInTerminal(h,b){return Promise.resolve(void 0)}async $substituteVariables(h,b){let m;const k=await this.ib(h);return k&&(m={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(m,b)}X(h,b){if(h.type==="implementation")return new $(h.implementation)}Y(){}async $startDASession(h,b){const m=this,k=await this.hb(b);return this.eb(this.$(k.type),k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const C=this.Z(y),P=this.X(C,k);if(!P)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const W=P;return this.D.set(h,W),this.db(k).then(V=>(V&&this.E.set(h,V),W.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const N=q,U={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(N.arguments.value);U.body={signature:K},W.sendResponse(U)}else throw new Error("no signer")}catch(K){U.success=!1,U.message=K.message,W.sendResponse(U)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(q),q=(0,g.$rH)(q,!0),m.l.$acceptDAMessage(h,q)}),W.onError(q=>{V&&V.onError&&V.onError(q),this.l.$acceptDAError(h,q.name,q.message,q.stack)}),W.onExit(q=>{V&&V.onExit&&V.onExit(q??void 0,void 0),this.l.$acceptDAExit(h,q??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),W.startSession()))})}$sendDAMessage(h,b){b=(0,g.$qH)(b,!1);const m=this.E.get(h);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(b),this.D.get(h)?.sendMessage(b)}$stopDASession(h){const b=this.E.get(h);this.E.delete(h),b&&b.onWillStopSession&&b.onWillStopSession();const m=this.D.get(h);return this.D.delete(h),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const b=[],m=[],k=[];if(h.added)for(const y of h.added){const C=y.id;if(C&&!this.z.has(C)){let P;if(y.type==="function")P=new D.$8N(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")P=new D.$9N(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const W=A.URI.revive(y.uri);P=new D.$7N(new D.$eN(W,new D.$6M(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,D.$5N)(P,C),this.z.set(C,P),b.push(P)}}if(h.removed)for(const y of h.removed){const C=this.z.get(y);C&&(this.z.delete(y),m.push(C))}if(h.changed){for(const y of h.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof D.$8N&&y.type==="function"){const P=C;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.functionName=y.functionName}else if(C instanceof D.$7N&&y.type==="source"){const P=C;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.location=new D.$eN(A.URI.revive(y.uri),new D.$6M(y.line,y.character))}k.push(C)}}}this.gb(b,m,k)}async $acceptStackFrameFocus(h){let b;if(h){const m=await this.hb(h.sessionId);h.kind==="thread"?b=new D.$cO(m.api,h.threadId):b=new D.$bO(m.api,h.threadId,h.frameId)}this.B=b,this.C.fire(this.B)}$provideDebugConfigurations(h,b,m){return(0,I.$oh)(async()=>{const k=this.bb(h);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(b);return k.provideDebugConfigurations(y,m)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(h,b,m,k){return(0,I.$oh)(async()=>{const y=this.bb(h);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(b);return y.resolveDebugConfiguration(C,m,k)})}$resolveDebugConfigurationWithSubstitutedVariables(h,b,m,k){return(0,I.$oh)(async()=>{const y=this.bb(h);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(b);return y.resolveDebugConfigurationWithSubstitutedVariables(C,m,k)})}async $provideDebugAdapter(h,b){const m=this.ab(h);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(b);return this.eb(m,k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(h){const b=await this.hb(h);this.n.fire(b.api)}async $acceptDebugSessionTerminated(h){const b=await this.hb(h);b&&(this.o.fire(b.api),this.m.delete(b.id))}async $acceptDebugSessionActiveChanged(h){this.u=h?await this.hb(h):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(h,b){(await this.hb(h))?._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(h,b){const k={session:(await this.hb(h)).api,event:b.event,body:b.body};this.w.fire(k)}Z(h){if(h instanceof D.$0N)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof D.$$N)return{type:"server",port:h.port,host:h.host};if(h instanceof D.$_N)return{type:"pipeServer",path:h.path};if(h instanceof D.$aO)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}$(h){const b=this.h.filter(m=>m.type===h);if(b.length>0)return b[0].factory}ab(h){const b=this.h.filter(m=>m.handle===h);if(b.length>0)return b[0].factory}bb(h){const b=this.f.filter(m=>m.handle===h);if(b.length>0)return b[0].provider}cb(h,b){if(h.contributes){const m=h.contributes.debuggers;if(m&&m.length>0){for(const k of m)if(k.label&&k.type&&k.type===b)return!0}}return!1}db(h){const m=h.configuration.type,k=this.k.filter(y=>y.type===m||y.type==="*").map(y=>(0,I.$oh)(()=>y.factory.createDebugAdapterTracker(h.api)).then(C=>C,C=>null));return Promise.race([Promise.all(k).then(y=>{const C=y.filter(P=>!!P);if(C.length>0)return new a(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(h,b){const m=b.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new D.$$N(m));if(h){const y=await this.O.getExtensionRegistry();return(0,I.$oh)(()=>h.createDebugAdapterDescriptor(b.api,this.fb(b,y))).then(C=>{if(C)return C})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(b,k))}fb(h,b){}gb(h,b,m){(h.length>0||b.length>0||m.length>0)&&this.A.fire(Object.freeze({added:h,removed:b,changed:m}))}async hb(h){if(h)if(typeof h=="string"){const b=this.m.get(h);if(b)return b}else{let b=this.m.get(h.id);if(!b){const m=await this.ib(h.folderUri),k=h.parent?this.m.get(h.parent):void 0;b=new t(this.l,h.id,h.type,h.name,m,h.configuration,k?.api),this.m.set(b.id,b),this.l.$sessionCached(b.id)}return b}throw new Error("cannot find session")}ib(h){if(h){const b=A.URI.revive(h);return this.N.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}jb(h,b){return`${h}\0${b}`}kb(h,b){if(b){if("title"in b&&"command"in b)return{type:0};if("treeId"in b)return{type:1,id:`${h}\0${b.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(h){const b=this.mb(h);let m,k;return"id"in b?k=i.ThemeIcon.asClassName(b):m=b,{iconPath:m,iconClass:k}}mb(h){if(h instanceof D.$2N)return{id:h.id};const b=typeof h=="object"&&"dark"in h?h.dark:h,m=typeof h=="object"&&"light"in h?h.light:h;return{dark:typeof b=="string"?A.URI.file(b):b,light:typeof m=="string"?A.URI.file(m):m}}};e.$gmc=l,e.$gmc=l=Je([We(0,T.$qP),We(1,d.$wlc),We(2,E.$amc),We(3,r.$zlc),We(4,p.$Llc),We(5,o.$dmc),We(6,n.$MP)],l);class t{constructor(h,b,m,k,y,C,P){this.f=h,this.g=b,this.h=m,this.j=k,this.k=y,this.l=C,this.m=P}get api(){const h=this;return this.d??=Object.freeze({id:h.g,type:h.h,get name(){return h.j},set name(b){h.j=b,h.f.$setDebugSessionName(h.g,b)},parentSession:h.m,workspaceFolder:h.k,configuration:h.l,customRequest(b,m){return h.f.$customDebugAdapterRequest(h.g,b,m)},getDebugProtocolBreakpoint(b){return h.f.$getDebugProtocolBreakpoint(h.g,b.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(h){this.j=h}get configuration(){return this.l}}e.$hmc=t;class f{constructor(h){this.value=Object.freeze({append(b){h.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.$imc=f;class a{constructor(h){this.d=h}onWillStartSession(){this.d.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.d.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.d.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(h):void 0)}onWillStopSession(){this.d.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.d.forEach(b=>b.onError?b.onError(h):void 0)}onExit(h,b){this.d.forEach(m=>m.onExit?m.onExit(h,b):void 0)}}class $ extends v.$Nrb{constructor(h){super(),this.h=h,h.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.h.handleMessage(h)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let u=class extends l{constructor(h,b,m,k,y,C,P){super(h,b,m,k,y,C,P)}};e.$jmc=u,e.$jmc=u=Je([We(0,T.$qP),We(1,d.$wlc),We(2,E.$amc),We(3,r.$zlc),We(4,p.$Llc),We(5,o.$dmc),We(6,n.$MP)],u)}),define(Ie[305],Pe([1,0,14,60,2,4,254,12,56,72,27,199,17,61,41,63]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=e.$mnc=void 0;class o{static async installEarlyHandler(n){Error.stackTraceLimit=100;const c=n.get(w.$3j),t=n.get(d.$qP).getProxy(O.$3M.MainThreadErrors);I.setUnexpectedErrorHandler(f=>{c.error(f);const a=I.$3(f);t.$onUnexpectedError(a)})}static async installFullHandler(n){const c=n.get(w.$3j),l=n.get(d.$qP),t=n.get(g.$amc),f=n.get(r.$KP),a=l.getProxy(O.$3M.MainThreadExtensionService),$=l.getProxy(O.$3M.MainThreadErrors),u=await t.getExtensionPathIndex(),S=new WeakMap;function h(k,y){if(S.has(k))return S.get(k).stack;let C="",P,W;for(const q of y)C+=`
	at ${q.toString()}`,W=q.getFileName(),!P&&W&&(P=u.findSubstr(A.URI.file(W)));const V=`${k.name||"Error"}: ${k.message||""}${C}`;return S.set(k,{extensionIdentifier:P?.identifier,stack:V}),V}const b=Symbol("prepareStackTrace wrapped");let m=h;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return m},set(k){if(k===h||!k||k[b]){m=k||h;return}m=function(y,C){return h(y,C),k.call(Error,y,C)},Object.assign(m,{[b]:!0})}}),I.setUnexpectedErrorHandler(k=>{c.error(k);const y=I.$3(k),C=S.get(k);if(!C?.extensionIdentifier){$.$onUnexpectedError(y);return}a.$onExtensionRuntimeError(C.extensionIdentifier,y);const P=f.onExtensionError(C.extensionIdentifier,k);c.trace("forwarded error to extension?",P,C)})}}e.$mnc=o;class s{constructor(n,c,l,t,f){this.a=l,this.b=new R.$T_b(n,null,t),c=s.e(c,this.b);const a=new E.$ui(...(0,p.$ys)());a.set(T.$GP,{_serviceBrand:void 0,...c,messagePorts:f}),a.set(d.$qP,new d.$rP(this.b)),a.set(v.$tlc,new v.$ulc(t)),a.set(g.$$lc,l);const $=new D.$cr(a,!0);$.invokeFunction(o.installEarlyHandler),this.d=$.invokeFunction(u=>u.get(w.$3j)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=$.invokeFunction(u=>u.get(g.$amc)),this.c.initialize(),$.invokeFunction(o.installFullHandler)}async asBrowserUri(n){const c=this.b.getProxy(O.$3M.MainThreadExtensionService);return A.URI.revive(await c.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,c){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=A.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=A.URI.revive(c.transformIncomingURIs(n.environment.appRoot));const l=n.environment.extensionDevelopmentLocationURI;return l&&(n.environment.extensionDevelopmentLocationURI=l.map(t=>A.URI.revive(c.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=A.URI.revive(c.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=A.URI.revive(c.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=A.URI.revive(c.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=A.URI.revive(c.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=A.URI.revive(c.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=A.URI.revive(c.transformIncomingURIs(n.logsLocation)),n.workspace=c.transformIncomingURIs(n.workspace),n}}e.$nnc=s}),define(Ie[306],Pe([1,0,18,11,24,44,16,19,23,2,47]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=e.$ymc=e.$xmc=void 0,e.$zmc=r;class D{constructor(i,n,c){this.d=i,this.e=n,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const c=this.g.folderQueries||[],l=new A.$pe(n);return new Promise((t,f)=>{this.a=new v(i);let a=!1;const $=(u,S)=>{if(!a&&!this.b){const h=this.h(u);r(u)&&typeof this.g.maxResults=="number"&&this.c+h>this.g.maxResults&&(this.b=!0,a=!0,l.cancel(),u=this.j(u,this.g.maxResults-this.c));const b=this.h(u);this.c+=b,(b>0||!r(u))&&this.a.add(u,S)}};Promise.all(c.map((u,S)=>this.k(u,h=>$(h,S),l.token))).then(u=>{l.dispose(),this.a.flush();const S=u.some(h=>!!h&&!!h.limitHit);t({limitHit:this.b||S,messages:(0,I.$Rb)(u.map(h=>h?.message?Array.isArray(h.message)?h.message:[h.message]:[])),stats:{type:this.f}})},u=>{l.dispose();const S=(0,O.$hj)(u);f(new Error(S))})})}h(i){return r(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const c=Array.isArray(i.ranges)?i.ranges:[i.ranges],l=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:c.slice(0,n),preview:{matches:l.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,c){const l=new T.$xL(this.g,i),t=[],f={report:u=>{if(!this.l(u))return;const S=i.folder.scheme===R.Schemas.file?(0,T.$yL)(()=>this.e.readdir(p.$9g(u.uri))):void 0,h=p.$_g(i.folder,u.uri);if(h){const b=l.includedInQuery(h,w.$oc(h),S);(0,M.$ih)(b)?t.push(b.then(m=>{m&&n(u)})):b&&n(u)}}},a=this.n(i);let $;return this.d.query.type===3?$=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,f,c):$=await this.d.provider.provideTextSearchResults(d(this.d.query.contentPattern),a,f,c),t.length&&await Promise.all(t),$}l(i){if(r(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,T.$wL)(this.g.includePattern,i.includePattern),c=(0,T.$wL)(this.g.excludePattern,i.excludePattern),l={folder:E.URI.from(i.folder),excludes:c,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(l.usePCRE2=this.g.usePCRE2),l}}e.$xmc=D;function d(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new o(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!p.$3g(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(g(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$ymc=v;function g(s){return r(s)?{preview:{matches:(0,I.$2b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,I.$2b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Amc=o}),define(Ie[124],Pe([1,0,6,4,3,301,17,61,12,2,306]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=e.$Bmc=void 0,e.$Dmc=d,e.$Bmc=(0,A.$wi)("IExtHostSearch");let D=class{constructor(r,o,s){this.n=r,this.o=o,this.q=s,this.c=this.n.getProxy(M.$3M.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$wmc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(r)),(0,I.$Tc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(r)),(0,I.$Tc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(r)),(0,I.$Tc)(()=>{this.k.delete(r),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,o,s,i){const n=d(s),c=this.j.get(r);if(c)return this.l.fileSearch(n,c,l=>{this.c.$handleFileMatch(r,o,l.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,s){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,s,i){const n=this.e.get(r);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const c=d(s);return this.t(c,n).search(t=>this.c.$handleTextMatch(r,o,t),i)}$provideAITextSearchResults(r,o,s,i){const n=this.h.get(r);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const c=d(s);return this.v(c,n).search(t=>this.c.$handleTextMatch(r,o,t),i)}$enableExtensionHostSearch(){}t(r,o){return new T.$xmc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(r,o){return new T.$xmc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$Cmc=D,e.$Cmc=D=Je([We(0,R.$qP),We(1,w.$tlc),We(2,p.$3j)],D);function d(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(v),extraFileResources:g.extraFileResources&&g.extraFileResources.map(r=>E.URI.revive(r))}}function v(g){return{...g,folder:E.URI.revive(g.folder)}}}),define(Ie[307],Pe([1,0,24,14,5,6,16,33,2,158,154,141,95,20,38,12,58,59,213,4,257,285,80,86,262,263,264,243,232,32,265,40,266,123,112,267,245,258,268,269,68,67,259,41,271,65,272,46,27,286,287,246,273,90,274,81,82,248,300,276,219,277,288,278,118,249,279,280,281,17,282,124,83,283,250,284,84,87,121,63,53,116,289,290,260,291,292,88,8,7,251,61,252,64,293,294,111,39,227,79,26,120]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n,c,l,t,f,a,$,u,S,h,b,m,k,y,C,P,W,V,q,N,U,K,ie,ce,ye,Se,fe,$e,Te,ae,Ne,ne,z,x,ve,Fe,De,we,ge,Q,Y,he,ue,Oe,de,Ce,Ae,Ue,j,F,H,G,ee,re,Me,Be,He,_e,xe,et,tt,it,at,gt,je,st,X,Z,me,qe,be,ot,dt,Pt,Vt,Qt,ti,Zt,Et,Xt,Yt,Xe,oi){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=Gt;function Gt(ht){const $t=ht.get(ae.$GP),xt=ht.get(Te.$elc),Kt=ht.get(fe.$Blc),Ft=ht.get(ye.$amc),ft=ht.get(Et.$wlc),Bt=ht.get(tt.$KP),_t=ht.get(k.$zlc),Ut=ht.get(dt.$tlc),Qe=ht.get(H.$qP),ui=ht.get(_e.$Ulc),Jt=ht.get(xe.$Clc),Wt=ht.get(r.$4j),pt=ht.get(r.$3j),Lt=ht.get(me.$tDb),Rt=ht.get(t.$alc),Mt=ht.get(Zt.$gnc),ii=ht.get(re.$5lc),qt=ht.get(ie.$Llc),ni=ht.get(we.$9lc),Ct=ht.get(f.$klc),Ot=ht.get(ve.$2lc);Qe.set(n.$4M.ExtHostFileSystemInfo,xt),Qe.set(n.$4M.ExtHostLogLevelServiceShape,Wt),Qe.set(n.$4M.ExtHostWorkspace,ft),Qe.set(n.$4M.ExtHostConfiguration,_t),Qe.set(n.$4M.ExtHostExtensionService,Ft),Qe.set(n.$4M.ExtHostStorage,ui),Qe.set(n.$4M.ExtHostTunnelService,Lt),Qe.set(n.$4M.ExtHostWindow,Mt),Qe.set(n.$4M.ExtHostSecretState,ii),Qe.set(n.$4M.ExtHostTelemetry,Bt),Qe.set(n.$4M.ExtHostEditorTabs,qt),Qe.set(n.$4M.ExtHostManagedSockets,ni),Qe.set(n.$4M.ExtHostAuthentication,Ct),Qe.set(n.$4M.ExtHostChatProvider,Ot);const Nt=Qe.set(n.$4M.ExtHostDecorations,ht.get(P.$lmc)),It=Qe.set(n.$4M.ExtHostDocumentsAndEditors,ht.get(K.$BP)),mt=Qe.set(n.$4M.ExtHostCommands,ht.get(b.$MP)),Dt=Qe.set(n.$4M.ExtHostTerminalService,ht.get(it.$Xlc)),ai=Qe.set(n.$4M.ExtHostTerminalShellIntegration,ht.get(at.$5mc)),kt=Qe.set(n.$4M.ExtHostDebugService,ht.get(C.$fmc)),fi=Qe.set(n.$4M.ExtHostSearch,ht.get(ee.$Bmc)),ri=Qe.set(n.$4M.ExtHostTask,ht.get(et.$4mc)),$i=Qe.set(n.$4M.ExtHostOutputService,ht.get(Ce.$Qmc)),li=Qe.set(n.$4M.ExtHostLocalization,ht.get(De.$8lc)),wi=Qe.set(n.$4M.ExtHostUrls,new Pt.$dnc(Qe)),St=Qe.set(n.$4M.ExtHostDocuments,new U.$hlc(Qe,It)),bi=Qe.set(n.$4M.ExtHostDocumentContentProviders,new q.$nmc(Qe,It,pt)),si=Qe.set(n.$4M.ExtHostDocumentSaveParticipant,new N.$omc(pt,St,Qe.getProxy(n.$3M.MainThreadBulkEdits))),pe=Qe.set(n.$4M.ExtHostNotebook,new Q.$Emc(Qe,mt,It,St,Kt,fi)),Re=Qe.set(n.$4M.ExtHostNotebookDocuments,new he.$Kmc(pe)),se=Qe.set(n.$4M.ExtHostNotebookEditors,new ue.$Lmc(pt,pe)),J=Qe.set(n.$4M.ExtHostNotebookKernels,new Oe.$Mmc(Qe,$t,pe,mt,pt)),ke=Qe.set(n.$4M.ExtHostNotebookRenderers,new de.$Omc(Qe,pe)),Ve=Qe.set(n.$4M.ExtHostNotebookDocumentSaveParticipant,new Y.$Jmc(pt,pe,Qe.getProxy(n.$3M.MainThreadBulkEdits))),Ze=Qe.set(n.$4M.ExtHostEditors,new je.$qlc(Qe,It)),Ge=Qe.set(n.$4M.ExtHostTreeViews,new Z.$bnc(Qe.getProxy(n.$3M.MainThreadTreeViews),mt,pt)),ut=Qe.set(n.$4M.ExtHostEditorInsets,new h.$rlc(Qe.getProxy(n.$3M.MainThreadEditorInsets),Ze,$t.remote)),yt=Qe.set(n.$4M.ExtHostDiagnostics,new W.$glc(Qe,pt,xt,It)),zt=Qe.set(n.$4M.ExtHostLanguages,new Fe.$Hmc(Qe,St,mt.converter,Ut)),ct=Qe.set(n.$4M.ExtHostLanguageFeatures,new x.$ilc(Qe,Ut,St,mt,yt,pt,Rt,Bt)),Tt=Qe.set(n.$4M.ExtHostFileSystem,new Se.$qmc(Qe,ct)),jt=Qe.set(n.$4M.ExtHostFileSystemEventService,new $e.$rmc(Qe,pt,It)),yi=Qe.set(n.$4M.ExtHostQuickOpen,(0,F.$Umc)(Qe,ft,mt)),ki=Qe.set(n.$4M.ExtHostSCM,new G.$Wmc(Qe,mt,St,pt)),Ki=Qe.set(n.$4M.ExtHostQuickDiff,new j.$Tmc(Qe,Ut)),Mi=Qe.set(n.$4M.ExtHostShare,new Me.$Xmc(Qe,Ut)),Oi=Qe.set(n.$4M.ExtHostComments,(0,m.$slc)(Qe,mt,St)),Si=Qe.set(n.$4M.ExtHostProgress,new Ue.$Smc(Qe.getProxy(n.$3M.MainThreadProgress))),Ti=Qe.set(n.$4M.ExtHostLabelService,new z.$Gmc(Qe)),Fi=Qe.set(n.$4M.ExtHostTheming,new st.$$mc(Qe)),Ji=Qe.set(n.$4M.ExtHostTimeline,new X.$anc(Qe,mt)),Li=Qe.set(n.$4M.ExtHostWebviews,new Vt.$Glc(Qe,$t.remote,ft,pt,Rt)),Ii=Qe.set(n.$4M.ExtHostWebviewPanels,new Qt.$Jlc(Qe,Li,ft)),zi=Qe.set(n.$4M.ExtHostCustomEditors,new y.$Klc(Qe,St,Jt,Li,Ii)),ji=Qe.set(n.$4M.ExtHostWebviewViews,new ti.$enc(Qe,Li)),vi=Qe.set(n.$4M.ExtHostTesting,new gt.$7mc(Qe,pt,mt,It)),Qi=Qe.set(n.$4M.ExtHostUriOpeners,new ot.$cnc(Qe)),Zi=Qe.set(n.$4M.ExtHostProfileContentHandlers,new Ae.$Rmc(Qe));Qe.set(n.$4M.ExtHostInteractive,new ne.$Fmc(Qe,pe,It,mt,pt));const Xi=Qe.set(n.$4M.ExtHostInlineChat,new Ne.$smc(Qe,mt,St,pt)),Pi=Qe.set(n.$4M.ExtHostChatAgents2,new $.$nlc(Qe,pt,mt)),Yi=Qe.set(n.$4M.ExtHostChatVariables,new u.$olc(Qe)),xi=Qe.set(n.$4M.ExtHostAiRelatedInformation,new c.$_kc(Qe)),dn=Qe.set(n.$4M.ExtHostAiEmbeddingVector,new ce.$pmc(Qe)),Ci=Qe.set(n.$4M.ExtHostStatusBar,new He.$1mc(Qe,mt.converter)),Ui=Qe.set(n.$4M.ExtHostSpeech,new Be.$Ymc(Qe)),fn=Object.values(n.$4M);Qe.assertRegistered(fn);const gn=new a.$mlc(Qe,It),_i=new S.$plc(Qe),Bi=new ge.$Imc(Qe,pt),Ai=new V.$mmc(Qe);return l.$jlc.register(mt),function(ze,hi,Vi){function nt(_){return(oe,Le,rt)=>{const bt=_(At=>{try{oe.call(Le,At)}catch(Di){M.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Di.toString()}`,{cause:Di})),Bt.onExtensionError(ze.identifier,Di)}});return rt?.push(bt),bt}}const vt=function(){let _=!ze.isUnderDevelopment;function oe(){_||(pt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")oe();else{const bt=rt;typeof bt.scheme>"u"&&oe(),typeof bt.exclusive=="boolean"&&(0,Xe.$IG)(ze,"documentFiltersExclusive")}return rt}}(),en={getSession(_,oe,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Xe.$IG)(ze,"authLearnMore"),Ct.getSession(ze,_,oe,Le)},getSessions(_,oe){return(0,Xe.$IG)(ze,"authGetSessions"),Ct.getSessions(ze,_,oe)},async hasSession(_,oe){return(0,Xe.$IG)(ze,"authSession"),!!await Ct.getSession(ze,_,oe,{silent:!0})},get onDidChangeSessions(){return nt(Ct.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Le,rt){return Ct.registerAuthenticationProvider(_,oe,Le,rt)}},gi={registerCommand(_,oe,Le){return mt.registerCommand(!0,_,oe,Le,void 0,ze)},registerTextEditorCommand(_,oe,Le){return mt.registerCommand(!0,_,(...rt)=>{const bt=Ze.getActiveTextEditor();if(!bt){pt.warn("Cannot execute "+_+" because there is no active text editor.");return}return bt.edit(At=>{oe.apply(Le,[bt,At,...rt])}).then(At=>{At||pt.warn("Edits from command "+_+" were not applied.")},At=>{pt.warn("An error occurred while running command "+_,At)})},void 0,void 0,ze)},registerDiffInformationCommand:(_,oe,Le)=>((0,Xe.$IG)(ze,"diffCommand"),mt.registerCommand(!0,_,async(...rt)=>{const bt=It.activeEditor(!0);if(!bt){pt.warn("Cannot execute "+_+" because there is no active text editor.");return}const At=await Ze.getDiffInformation(bt.id);oe.apply(Le,[At,...rt])},void 0,void 0,ze)),executeCommand(_,...oe){return mt.executeCommand(_,...oe)},getCommands(_=!1){return mt.getCommands(_)}},Ei={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return _i.value},get shell(){return Dt.getDefaultShell(!1)},get onDidChangeShell(){return nt(Dt.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$IG)(ze,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$IG)(ze,"telemetry"),nt(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$JP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return tt.$IP.validateSender(_),Bt.instantiateLogger(ze,_,oe)},openExternal(_,oe){return Mt.openUri(_,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===$t.environment.appUriScheme)return wi.createAppUri(_);try{return await Mt.asExternalUri(_,{allowTunneling:!!$t.remote.authority})}catch(oe){if((0,R.$Fg)(_,R.Schemas.http)||(0,R.$Fg)(_,R.Schemas.https))return _;throw oe}},get remoteName(){return(0,o.$Im)($t.remote.authority)},get remoteAuthority(){return(0,Xe.$IG)(ze,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return nt(pt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$IG)(ze,"resolvers"),$t.quality},get appCommit(){return(0,Xe.$IG)(ze,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Ei);const mn={createTestController(_,oe,Le){return vi.createTestController(ze,_,oe,Le)},createTestObserver(){return(0,Xe.$IG)(ze,"testObserver"),vi.createTestObserver()},runTests(_){return(0,Xe.$IG)(ze,"testObserver"),vi.runTests(_)},get onDidChangeTestResults(){return(0,Xe.$IG)(ze,"testObserver"),nt(vi.onResultsChanged)},get testResults(){return(0,Xe.$IG)(ze,"testObserver"),vi.results}},ei=$t.remote.isRemote?be.ExtensionKind.Workspace:be.ExtensionKind.UI,Ri={getExtension(_,oe){(0,Xe.$HG)(ze,"extensionsAny")||(oe=!1);const Le=hi.mine.getExtensionDescription(_);if(Le)return new ye.$bmc(Ft,ze.identifier,Le,ei,!1);if(oe){const rt=hi.all.getExtensionDescription(_);if(rt)return new ye.$bmc(Ft,ze.identifier,rt,ei,!0)}},get all(){const _=[];for(const oe of hi.mine.getAllExtensionDescriptions())_.push(new ye.$bmc(Ft,ze.identifier,oe,ei,!1));return _},get allAcrossExtensionHosts(){(0,Xe.$IG)(ze,"extensionsAny");const _=new v.$Sm(hi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),oe=[];for(const Le of hi.all.getAllExtensionDescriptions()){const rt=!_.has(Le.identifier);oe.push(new ye.$bmc(Ft,ze.identifier,Le,ei,rt))}return oe},get onDidChange(){return(0,Xe.$HG)(ze,"extensionsAny")?nt(A.Event.any(hi.mine.onDidChange,hi.all.onDidChange)):nt(hi.mine.onDidChange)}},tn={createDiagnosticCollection(_){return yt.createDiagnosticCollection(ze.identifier,_)},get onDidChangeDiagnostics(){return nt(yt.onDidChangeDiagnostics)},getDiagnostics:_=>yt.getDiagnostics(_),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(_,oe){return zt.changeLanguage(_.uri,oe)},match(_,oe){const Le=qe.LanguageSelector.from(_);let rt;return(0,T.$Yt)(Le)&&(rt=pe.notebookDocuments.find(bt=>bt.apiNotebook.getCells().find(At=>At.document===oe))?.apiNotebook),(0,T.$Xt)(Le,oe.uri,oe.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,oe,Le){return ct.registerCodeActionProvider(ze,vt(_),oe,Le)},registerDocumentPasteEditProvider(_,oe,Le){return(0,Xe.$IG)(ze,"documentPaste"),ct.registerDocumentPasteEditProvider(ze,vt(_),oe,Le)},registerCodeLensProvider(_,oe){return ct.registerCodeLensProvider(ze,vt(_),oe)},registerDefinitionProvider(_,oe){return ct.registerDefinitionProvider(ze,vt(_),oe)},registerDeclarationProvider(_,oe){return ct.registerDeclarationProvider(ze,vt(_),oe)},registerImplementationProvider(_,oe){return ct.registerImplementationProvider(ze,vt(_),oe)},registerTypeDefinitionProvider(_,oe){return ct.registerTypeDefinitionProvider(ze,vt(_),oe)},registerHoverProvider(_,oe){return ct.registerHoverProvider(ze,vt(_),oe,ze.identifier)},registerEvaluatableExpressionProvider(_,oe){return ct.registerEvaluatableExpressionProvider(ze,vt(_),oe,ze.identifier)},registerInlineValuesProvider(_,oe){return ct.registerInlineValuesProvider(ze,vt(_),oe,ze.identifier)},registerDocumentHighlightProvider(_,oe){return ct.registerDocumentHighlightProvider(ze,vt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return ct.registerMultiDocumentHighlightProvider(ze,vt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return ct.registerLinkedEditingRangeProvider(ze,vt(_),oe)},registerReferenceProvider(_,oe){return ct.registerReferenceProvider(ze,vt(_),oe)},registerRenameProvider(_,oe){return ct.registerRenameProvider(ze,vt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Xe.$IG)(ze,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(ze,vt(_),oe)},registerDocumentSymbolProvider(_,oe,Le){return ct.registerDocumentSymbolProvider(ze,vt(_),oe,Le)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(ze,_)},registerDocumentFormattingEditProvider(_,oe){return ct.registerDocumentFormattingEditProvider(ze,vt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return ct.registerDocumentRangeFormattingEditProvider(ze,vt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Le,...rt){return ct.registerOnTypeFormattingEditProvider(ze,vt(_),oe,[Le].concat(rt))},registerDocumentSemanticTokensProvider(_,oe,Le){return ct.registerDocumentSemanticTokensProvider(ze,vt(_),oe,Le)},registerDocumentRangeSemanticTokensProvider(_,oe,Le){return ct.registerDocumentRangeSemanticTokensProvider(ze,vt(_),oe,Le)},registerSignatureHelpProvider(_,oe,Le,...rt){return typeof Le=="object"?ct.registerSignatureHelpProvider(ze,vt(_),oe,Le):ct.registerSignatureHelpProvider(ze,vt(_),oe,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(_,oe,...Le){return ct.registerCompletionItemProvider(ze,vt(_),oe,Le)},registerInlineCompletionItemProvider(_,oe,Le){return oe.handleDidShowCompletionItem&&(0,Xe.$IG)(ze,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$IG)(ze,"inlineCompletionsAdditions"),Le&&(0,Xe.$IG)(ze,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(ze,vt(_),oe,Le)},registerInlineEditProvider(_,oe){return(0,Xe.$IG)(ze,"inlineEdit"),ct.registerInlineEditProvider(ze,vt(_),oe)},registerDocumentLinkProvider(_,oe){return ct.registerDocumentLinkProvider(ze,vt(_),oe)},registerColorProvider(_,oe){return ct.registerColorProvider(ze,vt(_),oe)},registerFoldingRangeProvider(_,oe){return ct.registerFoldingRangeProvider(ze,vt(_),oe)},registerSelectionRangeProvider(_,oe){return ct.registerSelectionRangeProvider(ze,_,oe)},registerCallHierarchyProvider(_,oe){return ct.registerCallHierarchyProvider(ze,_,oe)},registerTypeHierarchyProvider(_,oe){return ct.registerTypeHierarchyProvider(ze,_,oe)},setLanguageConfiguration:(_,oe)=>ct.setLanguageConfiguration(ze,_,oe),getTokenInformationAtPosition(_,oe){return(0,Xe.$IG)(ze,"tokenInformation"),zt.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return ct.registerInlayHintsProvider(ze,_,oe)},createLanguageStatusItem(_,oe){return zt.createLanguageStatusItem(ze,_,oe)},registerDocumentDropEditProvider(_,oe,Le){return ct.registerDocumentOnDropEditProvider(ze,_,oe,(0,Xe.$HG)(ze,"documentPaste")?Le:void 0)}},nn={get activeTextEditor(){return Ze.getActiveTextEditor()},get visibleTextEditors(){return Ze.getVisibleTextEditors()},get activeTerminal(){return Dt.activeTerminal},get terminals(){return Dt.terminals},async showTextDocument(_,oe,Le){p.URI.isUri(_)&&_.scheme===R.Schemas.vscodeRemote&&!_.authority&&Rt.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(p.URI.isUri(_)?Promise.resolve(Wi.openTextDocument(_)):Promise.resolve(_));return Ze.showTextDocument(rt,oe,Le)},createTextEditorDecorationType(_){return Ze.createTextEditorDecorationType(ze,_)},onDidChangeActiveTextEditor(_,oe,Le){return nt(Ze.onDidChangeActiveTextEditor)(_,oe,Le)},onDidChangeVisibleTextEditors(_,oe,Le){return nt(Ze.onDidChangeVisibleTextEditors)(_,oe,Le)},onDidChangeTextEditorSelection(_,oe,Le){return nt(Ze.onDidChangeTextEditorSelection)(_,oe,Le)},onDidChangeTextEditorOptions(_,oe,Le){return nt(Ze.onDidChangeTextEditorOptions)(_,oe,Le)},onDidChangeTextEditorVisibleRanges(_,oe,Le){return nt(Ze.onDidChangeTextEditorVisibleRanges)(_,oe,Le)},onDidChangeTextEditorViewColumn(_,oe,Le){return nt(Ze.onDidChangeTextEditorViewColumn)(_,oe,Le)},onDidCloseTerminal(_,oe,Le){return nt(Dt.onDidCloseTerminal)(_,oe,Le)},onDidOpenTerminal(_,oe,Le){return nt(Dt.onDidOpenTerminal)(_,oe,Le)},onDidChangeActiveTerminal(_,oe,Le){return nt(Dt.onDidChangeActiveTerminal)(_,oe,Le)},onDidChangeTerminalDimensions(_,oe,Le){return(0,Xe.$IG)(ze,"terminalDimensions"),nt(Dt.onDidChangeTerminalDimensions)(_,oe,Le)},onDidChangeTerminalState(_,oe,Le){return nt(Dt.onDidChangeTerminalState)(_,oe,Le)},onDidWriteTerminalData(_,oe,Le){return(0,Xe.$IG)(ze,"terminalDataWriteEvent"),nt(Dt.onDidWriteTerminalData)(_,oe,Le)},onDidExecuteTerminalCommand(_,oe,Le){return(0,Xe.$IG)(ze,"terminalExecuteCommandEvent"),nt(Dt.onDidExecuteTerminalCommand)(_,oe,Le)},onDidChangeTerminalShellIntegration(_,oe,Le){return(0,Xe.$IG)(ze,"terminalShellIntegration"),nt(ai.onDidChangeTerminalShellIntegration)(_,oe,Le)},onDidStartTerminalShellExecution(_,oe,Le){return(0,Xe.$IG)(ze,"terminalShellIntegration"),nt(ai.onDidStartTerminalShellExecution)(_,oe,Le)},onDidEndTerminalShellExecution(_,oe,Le){return(0,Xe.$IG)(ze,"terminalShellIntegration"),nt(ai.onDidEndTerminalShellExecution)(_,oe,Le)},get state(){return Mt.getState()},onDidChangeWindowState(_,oe,Le){return nt(Mt.onDidChangeWindowState)(_,oe,Le)},showInformationMessage(_,...oe){return Bi.showMessage(ze,w.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Bi.showMessage(ze,w.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Bi.showMessage(ze,w.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Le){return yi.showQuickPick(ze,_,oe,Le)},showWorkspaceFolderPick(_){return yi.showWorkspaceFolderPick(_)},showInputBox(_,oe){return yi.showInput(_,oe)},showOpenDialog(_){return Ai.showOpenDialog(ze,_)},showSaveDialog(_){return Ai.showSaveDialog(_)},createStatusBarItem(_,oe,Le){let rt,bt,At;return typeof _=="string"?(rt=_,bt=oe,At=Le):(bt=_,At=oe),Ci.createStatusBarEntry(ze,rt,bt,At)},setStatusBarMessage(_,oe){return Ci.setStatusBarMessage(_,oe)},withScmProgress(_){return Rt.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Si.withProgress(ze,{location:be.ProgressLocation.SourceControl},(oe,Le)=>_({report(rt){}}))},withProgress(_,oe){return Si.withProgress(ze,_,oe)},createOutputChannel(_,oe){return $i.createOutputChannel(_,oe,ze)},createWebviewPanel(_,oe,Le,rt){return Ii.createWebviewPanel(ze,_,oe,Le,rt)},createWebviewTextEditorInset(_,oe,Le,rt){return(0,Xe.$IG)(ze,"editorInsets"),ut.createWebviewEditorInset(_,oe,Le,rt,ze)},createTerminal(_,oe,Le){return typeof _=="object"?"pty"in _?Dt.createExtensionTerminal(_):Dt.createTerminalFromOptions(_):Dt.createTerminal(_,oe,Le)},registerTerminalLinkProvider(_){return Dt.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return Dt.registerProfileProvider(ze,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Xe.$IG)(ze,"terminalQuickFixProvider"),Dt.registerTerminalQuickFixProvider(_,ze.identifier.value,oe)},registerTreeDataProvider(_,oe){return Ge.registerTreeDataProvider(_,oe,ze)},createTreeView(_,oe){return Ge.createTreeView(_,oe,ze)},registerWebviewPanelSerializer:(_,oe)=>Ii.registerWebviewPanelSerializer(ze,_,oe),registerCustomEditorProvider:(_,oe,Le={})=>zi.registerCustomEditorProvider(ze,_,oe,Le),registerFileDecorationProvider(_){return Nt.registerFileDecorationProvider(_,ze)},registerUriHandler(_){return wi.registerUriHandler(ze,_)},createQuickPick(){return yi.createQuickPick(ze)},createInputBox(){return yi.createInputBox(ze)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Le){return nt(Fi.onDidChangeActiveColorTheme)(_,oe,Le)},registerWebviewViewProvider(_,oe,Le){return ji.registerWebviewViewProvider(ze,_,oe,Le?.webviewOptions)},get activeNotebookEditor(){return pe.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Le){return nt(pe.onDidChangeActiveNotebookEditor)(_,oe,Le)},get visibleNotebookEditors(){return pe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(pe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Le){return nt(se.onDidChangeNotebookEditorSelection)(_,oe,Le)},onDidChangeNotebookEditorVisibleRanges(_,oe,Le){return nt(se.onDidChangeNotebookEditorVisibleRanges)(_,oe,Le)},showNotebookDocument(_,oe){return pe.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Le){return(0,Xe.$IG)(ze,"externalUriOpener"),Qi.registerExternalUriOpener(ze.identifier,_,oe,Le)},registerProfileContentHandler(_,oe){return(0,Xe.$IG)(ze,"profileContentHandlers"),Zi.registerProfileContentHandler(ze,_,oe)},registerQuickDiffProvider(_,oe,Le,rt){return(0,Xe.$IG)(ze,"quickDiffProvider"),Ki.registerQuickDiffProvider(vt(_),oe,Le,rt)},get tabGroups(){return qt.tabGroups},registerShareProvider(_,oe){return(0,Xe.$IG)(ze,"shareProvider"),Mi.registerShareProvider(vt(_),oe)}},Wi={get rootPath(){return Rt.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new M.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new M.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Le)=>ft.updateWorkspaceFolders(ze,_,oe||0,...Le),onDidChangeWorkspaceFolders:function(_,oe,Le){return nt(ft.onDidChangeWorkspace)(_,oe,Le)},asRelativePath:(_,oe)=>ft.getRelativePath(_,oe),findFiles:(_,oe,Le,rt)=>ft.findFiles(_,oe,Le,ze.identifier,rt),findFiles2:(_,oe,Le)=>((0,Xe.$IG)(ze,"findFiles2"),ft.findFiles2(_,oe,ze.identifier,Le)),findTextInFiles:(_,oe,Le,rt)=>{(0,Xe.$IG)(ze,"findTextInFiles");let bt,At;return typeof oe=="object"?(bt=oe,At=Le):(bt={},At=oe,rt=Le),ft.findTextInFiles(_,bt||{},At,ze.identifier,rt)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,oe){return gn.applyWorkspaceEdit(_,ze,oe)},createFileSystemWatcher:(_,oe,Le,rt)=>{let bt;return typeof oe=="boolean"?bt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt,correlate:!1}:oe&&((0,Xe.$IG)(ze,"createFileSystemWatcher"),bt={...oe,correlate:!0}),jt.createFileSystemWatcher(ft,ze,_,bt)},get textDocuments(){return St.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new M.$9("textDocuments")},openTextDocument(_){let oe;const Le=_;if(typeof _=="string")oe=Promise.resolve(p.URI.file(_));else if(p.URI.isUri(_))oe=Promise.resolve(_);else if(!Le||typeof Le=="object")oe=St.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(rt=>(rt.scheme===R.Schemas.vscodeRemote&&!rt.authority&&Rt.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),St.ensureDocumentData(rt).then(bt=>bt.document)))},onDidOpenTextDocument:(_,oe,Le)=>nt(St.onDidAddDocument)(_,oe,Le),onDidCloseTextDocument:(_,oe,Le)=>nt(St.onDidRemoveDocument)(_,oe,Le),onDidChangeTextDocument:(_,oe,Le)=>nt(St.onDidChangeDocument)(_,oe,Le),onDidSaveTextDocument:(_,oe,Le)=>nt(St.onDidSaveDocument)(_,oe,Le),onWillSaveTextDocument:(_,oe,Le)=>nt(si.getOnWillSaveTextDocumentEvent(ze))(_,oe,Le),get notebookDocuments(){return pe.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Le;if(p.URI.isUri(_))Le=_,await pe.openNotebookDocument(_);else if(typeof _=="string")Le=p.URI.revive(await pe.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return pe.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,oe,Le){return nt(Re.onDidSaveNotebookDocument)(_,oe,Le)},onDidChangeNotebookDocument(_,oe,Le){return nt(Re.onDidChangeNotebookDocument)(_,oe,Le)},onWillSaveNotebookDocument(_,oe,Le){return nt(Ve.getOnWillSaveNotebookDocumentEvent(ze))(_,oe,Le)},get onDidOpenNotebookDocument(){return nt(pe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(pe.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Le,rt){return pe.registerNotebookSerializer(ze,_,oe,Le,(0,Xe.$HG)(ze,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,oe,Le)=>nt(Vi.onDidChangeConfiguration)(_,oe,Le),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,Vi.getConfiguration(_,oe,ze)},registerTextDocumentContentProvider(_,oe){return bi.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(Rt.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ri.registerTaskProvider(ze,_,oe)),registerFileSystemProvider(_,oe,Le){return(0,O.$Sc)(Tt.registerFileSystemProvider(ze,_,oe,Le),Kt.addFileSystemProvider(_,oe,Le))},get fs(){return Kt.value},registerFileSearchProvider:(_,oe)=>((0,Xe.$IG)(ze,"fileSearchProvider"),fi.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Xe.$IG)(ze,"textSearchProvider"),fi.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Xe.$IG)(ze,"aiTextSearchProvider"),(0,Xe.$IG)(ze,"textSearchProvider"),fi.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Xe.$IG)(ze,"resolvers"),Ft.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Xe.$IG)(ze,"resolvers"),Ti.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Xe.$IG)(ze,"resolvers"),Ft.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Le)=>nt(jt.onDidCreateFile)(_,oe,Le),onDidDeleteFiles:(_,oe,Le)=>nt(jt.onDidDeleteFile)(_,oe,Le),onDidRenameFiles:(_,oe,Le)=>nt(jt.onDidRenameFile)(_,oe,Le),onWillCreateFiles:(_,oe,Le)=>nt(jt.getOnWillCreateFileEvent(ze))(_,oe,Le),onWillDeleteFiles:(_,oe,Le)=>nt(jt.getOnWillDeleteFileEvent(ze))(_,oe,Le),onWillRenameFiles:(_,oe,Le)=>nt(jt.getOnWillRenameFileEvent(ze))(_,oe,Le),openTunnel:_=>((0,Xe.$IG)(ze,"tunnels"),Lt.openTunnel(ze,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Xe.$IG)(ze,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(_,oe,Le)=>((0,Xe.$IG)(ze,"tunnels"),nt(Lt.onDidChangeTunnels)(_,oe,Le)),registerPortAttributesProvider:(_,oe)=>((0,Xe.$IG)(ze,"portsAttributes"),Lt.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Xe.$IG)(ze,"tunnelFactory"),Lt.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Xe.$IG)(ze,"timeline"),Ji.registerTimelineProvider(_,oe,ze.identifier,mt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Xe.$IG)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Le)=>nt(ft.onDidGrantWorkspaceTrust)(_,oe,Le),registerEditSessionIdentityProvider:(_,oe)=>((0,Xe.$IG)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Le)=>((0,Xe.$IG)(ze,"editSessionIdentityProvider"),nt(ft.getOnWillCreateEditSessionIdentityEvent(ze))(_,oe,Le)),registerCanonicalUriProvider:(_,oe)=>((0,Xe.$IG)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Le)=>((0,Xe.$IG)(ze,"canonicalUriProvider"),ft.provideCanonicalUri(_,oe,Le))},rn={get inputBox(){return Rt.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ki.getLastInputBox(ze)},createSourceControl(_,oe,Le){return ki.createSourceControl(ze,_,oe,Le)}},$n={createCommentController(_,oe){return Oi.createCommentController(ze,_,oe)}},sn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,Xe.$HG)(ze,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Xe.$IG)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Xe.$IG)(ze,"debugVisualization"),kt.registerDebugVisualizationTree(ze,_,oe)},onDidStartDebugSession(_,oe,Le){return nt(kt.onDidStartDebugSession)(_,oe,Le)},onDidTerminateDebugSession(_,oe,Le){return nt(kt.onDidTerminateDebugSession)(_,oe,Le)},onDidChangeActiveDebugSession(_,oe,Le){return nt(kt.onDidChangeActiveDebugSession)(_,oe,Le)},onDidReceiveDebugSessionCustomEvent(_,oe,Le){return nt(kt.onDidReceiveDebugSessionCustomEvent)(_,oe,Le)},onDidChangeBreakpoints(_,oe,Le){return nt(kt.onDidChangeBreakpoints)(_,oe,Le)},onDidChangeActiveStackItem(_,oe,Le){return(0,Xe.$IG)(ze,"debugFocus"),nt(kt.onDidChangeActiveStackItem)(_,oe,Le)},registerDebugConfigurationProvider(_,oe,Le){return kt.registerDebugConfigurationProvider(_,oe,Le||Xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return kt.registerDebugAdapterDescriptorFactory(ze,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return kt.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?kt.startDebugging(_,oe,{parentSession:Le}):kt.startDebugging(_,oe,Le||{})},stopDebugging(_){return kt.stopDebugging(_)},addBreakpoints(_){return kt.addBreakpoints(_)},removeBreakpoints(_){return kt.removeBreakpoints(_)},asDebugSourceUri(_,oe){return kt.asDebugSourceUri(_,oe)}},on={registerTaskProvider:(_,oe)=>ri.registerTaskProvider(ze,_,oe),fetchTasks:_=>ri.fetchTasks(_),executeTask:_=>ri.executeTask(ze,_),get taskExecutions(){return ri.taskExecutions},onDidStartTask:(_,oe,Le)=>nt(ri.onDidStartTask)(_,oe,Le),onDidEndTask:(_,oe,Le)=>nt(ri.onDidEndTask)(_,oe,Le),onDidStartTaskProcess:(_,oe,Le)=>nt(ri.onDidStartTaskProcess)(_,oe,Le),onDidEndTaskProcess:(_,oe,Le)=>nt(ri.onDidEndTaskProcess)(_,oe,Le)},pn={createNotebookController(_,oe,Le,rt,bt){return J.createNotebookController(ze,_,oe,Le,rt,(0,Xe.$HG)(ze,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>pe.registerNotebookCellStatusBarItemProvider(ze,_,oe),createRendererMessaging(_){return ke.createRendererMessaging(ze,_)},createNotebookControllerDetectionTask(_){return(0,Xe.$IG)(ze,"notebookKernelSource"),J.createNotebookControllerDetectionTask(ze,_)},registerKernelSourceActionProvider(_,oe){return(0,Xe.$IG)(ze,"notebookKernelSource"),J.registerKernelSourceActionProvider(ze,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Le){return(0,Xe.$IG)(ze,"notebookCellExecutionState"),nt(J.onDidChangeNotebookCellExecutionState)(_,oe,Le)}},wn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return li.getMessage(ze.identifier.value,{message:oe,args:Le})}return li.getMessage(ze.identifier.value,_[0])},get bundle(){return li.getBundle(ze.identifier.value)},get uri(){return li.getBundleUri(ze.identifier.value)}},an={_version:1,registerInteractiveEditorSessionProvider(_,oe){return(0,Xe.$IG)(ze,"interactive"),Xi.registerProvider(ze,_,oe)},transferActiveChat(_){return(0,Xe.$IG)(ze,"interactive"),Pi.transferActiveChat(_)}},qi={getRelatedInformation(_,oe){return(0,Xe.$IG)(ze,"aiRelatedInformation"),xi.getRelatedInformation(ze,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Xe.$IG)(ze,"aiRelatedInformation"),xi.registerRelatedInformationProvider(ze,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Xe.$IG)(ze,"aiRelatedInformation"),dn.registerEmbeddingVectorProvider(ze,_,oe)}},cn={registerChatResponseProvider(_,oe,Le){return(0,Xe.$IG)(ze,"chatProvider"),Ot.registerLanguageModel(ze,_,oe,Le)},registerChatVariableResolver(_,oe,Le){return(0,Xe.$IG)(ze,"chatVariableResolver"),Yi.registerVariableResolver(ze,_,oe,Le)},registerMappedEditsProvider(_,oe){return(0,Xe.$IG)(ze,"mappedEditsProvider"),ct.registerMappedEditsProvider(ze,_,oe)},createChatParticipant(_,oe){return(0,Xe.$IG)(ze,"chatParticipant"),Pi.createChatAgent(ze,_,oe)},createDynamicChatParticipant(_,oe,Le,rt){return(0,Xe.$IG)(ze,"chatParticipantAdditions"),Pi.createDynamicChatAgent(ze,_,oe,Le,rt)}},un={get languageModels(){return(0,Xe.$IG)(ze,"languageModels"),Ot.getLanguageModelIds()},onDidChangeLanguageModels:(_,oe,Le)=>((0,Xe.$IG)(ze,"languageModels"),Ot.onDidChangeProviders(_,oe,Le)),sendChatRequest(_,oe,Le,rt){return(0,Xe.$IG)(ze,"languageModels"),Ot.sendChatRequest(ze,_,oe,Le,rt)},computeTokenLength(_,oe,Le){return(0,Xe.$IG)(ze,"languageModels"),Le??=I.CancellationToken.None,Ot.computeTokenLength(_,oe,Le)},getLanguageModelInformation(_){return(0,Xe.$IG)(ze,"languageModels"),Ot.getLanguageModelInfo(_)}},ln={registerSpeechProvider(_,oe){return(0,Xe.$IG)(ze,"speech"),Ui.registerProvider(ze.identifier,_,oe)}};return{version:$t.version,ai:qi,authentication:en,commands:gi,comments:$n,chat:cn,debug:sn,env:Ei,extensions:Ri,interactive:an,l10n:wn,languages:tn,lm:un,notebooks:pn,scm:rn,speech:ln,tasks:on,tests:mn,window:nn,workspace:Wi,Breakpoint:be.$6N,TerminalOutputAnchor:be.TerminalOutputAnchor,ChatResultFeedbackKind:be.ChatResultFeedbackKind,ChatVariableLevel:be.ChatVariableLevel,ChatCompletionItem:be.$1O,CallHierarchyIncomingCall:be.$rN,CallHierarchyItem:be.$qN,CallHierarchyOutgoingCall:be.$sN,CancellationError:M.$5,CancellationTokenSource:I.$pe,CandidatePortSource:n.CandidatePortSource,CodeAction:be.$nN,CodeActionKind:be.$oN,CodeActionTriggerKind:be.CodeActionTriggerKind,CodeLens:be.$tN,Color:be.$GN,ColorInformation:be.$HN,ColorPresentation:be.$IN,ColorThemeKind:be.ColorThemeKind,CommentMode:be.CommentMode,CommentState:be.CommentState,CommentThreadCollapsibleState:be.CommentThreadCollapsibleState,CommentThreadState:be.CommentThreadState,CommentThreadApplicability:be.CommentThreadApplicability,CompletionItem:be.$AN,CompletionItemKind:be.CompletionItemKind,CompletionItemTag:be.CompletionItemTag,CompletionList:be.$BN,CompletionTriggerKind:be.CompletionTriggerKind,ConfigurationTarget:be.ConfigurationTarget,CustomExecution:be.$QN,DebugAdapterExecutable:be.$0N,DebugAdapterInlineImplementation:be.$aO,DebugAdapterNamedPipeServer:be.$_N,DebugAdapterServer:be.$$N,DebugConfigurationProviderTriggerKind:Xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:be.DebugConsoleMode,DebugVisualization:be.$qO,DecorationRangeBehavior:be.DecorationRangeBehavior,Diagnostic:be.$gN,DiagnosticRelatedInformation:be.$fN,DiagnosticSeverity:be.DiagnosticSeverity,DiagnosticTag:be.DiagnosticTag,Disposable:be.$5M,DocumentHighlight:be.$jN,DocumentHighlightKind:be.DocumentHighlightKind,MultiDocumentHighlight:be.$kN,DocumentLink:be.$FN,DocumentSymbol:be.$mN,EndOfLine:be.EndOfLine,EnvironmentVariableMutatorType:be.EnvironmentVariableMutatorType,EvaluatableExpression:be.$dO,InlineValueText:be.$eO,InlineValueVariableLookup:be.$fO,InlineValueEvaluatableExpression:be.$gO,InlineCompletionTriggerKind:be.InlineCompletionTriggerKind,EventEmitter:A.$ee,ExtensionKind:be.ExtensionKind,ExtensionMode:be.ExtensionMode,ExternalUriOpenerPriority:be.ExternalUriOpenerPriority,FileChangeType:be.FileChangeType,FileDecoration:be.$sO,FileDecoration2:be.$sO,FileSystemError:be.$jO,FileType:g.FileType,FilePermission:g.FilePermission,FoldingRange:be.$kO,FoldingRangeKind:be.FoldingRangeKind,FunctionBreakpoint:be.$8N,InlineCompletionItem:be.$CN,InlineCompletionList:be.$DN,Hover:be.$hN,VerboseHover:be.$iN,HoverVerbosityAction:be.HoverVerbosityAction,IndentAction:D.IndentAction,Location:be.$eN,MarkdownString:be.$uN,OverviewRulerLane:d.OverviewRulerLane,ParameterInformation:be.$vN,PortAutoForwardAction:be.PortAutoForwardAction,Position:be.$6M,ProcessExecution:be.$ON,ProgressLocation:be.ProgressLocation,QuickInputButtons:be.$rO,Range:be.$7M,RelativePattern:be.$4N,Selection:be.$8M,SelectionRange:be.$pN,SemanticTokens:be.$nO,SemanticTokensBuilder:be.$mO,SemanticTokensEdit:be.$oO,SemanticTokensEdits:be.$pO,SemanticTokensLegend:be.$lO,ShellExecution:be.$PN,ShellQuoting:be.ShellQuoting,SignatureHelp:be.$xN,SignatureHelpTriggerKind:be.SignatureHelpTriggerKind,SignatureInformation:be.$wN,SnippetString:be.$dN,SourceBreakpoint:be.$7N,StandardTokenType:be.StandardTokenType,StatusBarAlignment:be.StatusBarAlignment,SymbolInformation:be.$lN,SymbolKind:be.SymbolKind,SymbolTag:be.SymbolTag,Task:be.$RN,TaskGroup:be.$NN,TaskPanelKind:be.TaskPanelKind,TaskRevealKind:be.TaskRevealKind,TaskScope:be.TaskScope,TerminalLink:be.$JN,TerminalQuickFixTerminalCommand:be.$LN,TerminalQuickFixOpener:be.$KN,TerminalLocation:be.TerminalLocation,TerminalProfile:be.$MN,TerminalExitReason:be.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:be.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:be.TextDocumentSaveReason,TextEdit:be.$_M,SnippetTextEdit:be.$bN,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:be.TextEditorLineNumbersStyle,TextEditorRevealType:be.TextEditorRevealType,TextEditorSelectionChangeKind:be.TextEditorSelectionChangeKind,SyntaxTokenType:be.SyntaxTokenType,TextDocumentChangeReason:be.TextDocumentChangeReason,ThemeColor:be.$3N,ThemeIcon:be.$2N,TreeItem:be.$SN,TreeItemCheckboxState:be.TreeItemCheckboxState,TreeItemCollapsibleState:be.TreeItemCollapsibleState,TypeHierarchyItem:be.$OO,UIKind:Yt.UIKind,Uri:p.URI,ViewColumn:be.ViewColumn,WorkspaceEdit:be.$cN,DocumentPasteTriggerKind:be.DocumentPasteTriggerKind,DocumentDropEdit:be.$YN,DocumentDropOrPasteEditKind:be.$ZN,DocumentPasteEdit:be.$1N,InlayHint:be.$zN,InlayHintLabelPart:be.$yN,InlayHintKind:be.InlayHintKind,RemoteAuthorityResolverError:be.$$M,ResolvedAuthority:be.$9M,ManagedResolvedAuthority:be.$0M,SourceControlInputBoxValidationType:be.SourceControlInputBoxValidationType,ExtensionRuntime:be.ExtensionRuntime,TimelineItem:be.$CO,NotebookRange:be.$uO,NotebookCellKind:be.NotebookCellKind,NotebookCellExecutionState:be.NotebookCellExecutionState,NotebookCellData:be.$vO,NotebookData:be.$wO,NotebookRendererScript:be.$AO,NotebookCellStatusBarAlignment:be.NotebookCellStatusBarAlignment,NotebookEditorRevealType:be.NotebookEditorRevealType,NotebookCellOutput:be.$yO,NotebookCellOutputItem:be.$xO,NotebookCellStatusBarItem:be.$zO,NotebookControllerAffinity:be.NotebookControllerAffinity,NotebookControllerAffinity2:be.NotebookControllerAffinity2,NotebookEdit:be.$aN,NotebookKernelSourceAction:be.$BO,NotebookVariablesRequestKind:be.NotebookVariablesRequestKind,PortAttributes:be.$EO,LinkedEditingRanges:be.$DO,TestResultState:be.TestResultState,TestRunRequest:be.$FO,TestRunRequest2:be.$FO,TestMessage:be.$GO,TestTag:be.$HO,TestRunProfileKind:be.TestRunProfileKind,TextSearchCompleteMessageType:oi.TextSearchCompleteMessageType,DataTransfer:be.$XN,DataTransferItem:be.$TN,TestCoverageCount:be.$IO,FileCoverage:be.$KO,StatementCoverage:be.$LO,BranchCoverage:be.$MO,DeclarationCoverage:be.$NO,WorkspaceTrustState:be.WorkspaceTrustState,LanguageStatusSeverity:be.LanguageStatusSeverity,QuickPickItemKind:be.QuickPickItemKind,InputBoxValidationSeverity:be.InputBoxValidationSeverity,TabInputText:be.$PO,TabInputTextDiff:be.$QO,TabInputTextMerge:be.$RO,TabInputCustom:be.$SO,TabInputNotebook:be.$UO,TabInputNotebookDiff:be.$VO,TabInputWebview:be.$TO,TabInputTerminal:be.$WO,TabInputInteractiveWindow:be.$XO,TabInputChat:be.$YO,TabInputTextMultiDiff:be.$ZO,TelemetryTrustedValue:s.$fp,LogLevel:r.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:be.InteractiveSessionVoteDirection,ChatCopyKind:be.ChatCopyKind,InteractiveEditorResponseFeedbackKind:be.InteractiveEditorResponseFeedbackKind,DebugStackFrame:be.$bO,DebugThread:be.$cO,RelatedInformationType:be.RelatedInformationType,SpeechToTextStatus:be.SpeechToTextStatus,PartialAcceptTriggerKind:be.PartialAcceptTriggerKind,KeywordRecognitionStatus:be.KeywordRecognitionStatus,ChatResponseMarkdownPart:be.$2O,ChatResponseFileTreePart:be.$5O,ChatResponseAnchorPart:be.$6O,ChatResponseProgressPart:be.$7O,ChatResponseReferencePart:be.$9O,ChatResponseTextEditPart:be.$0O,ChatResponseMarkdownWithVulnerabilitiesPart:be.$3O,ChatResponseCommandButtonPart:be.$8O,ChatResponseDetectedParticipantPart:be.$4O,ChatRequestTurn:be.$$O,ChatResponseTurn:be.$_O,ChatLocation:be.ChatLocation,LanguageModelChatSystemMessage:be.$aP,LanguageModelChatUserMessage:be.$bP,LanguageModelChatAssistantMessage:be.$cP,LanguageModelSystemMessage:be.$aP,LanguageModelUserMessage:be.$bP,LanguageModelAssistantMessage:be.$cP,LanguageModelError:be.$dP,NewSymbolName:be.$iO,NewSymbolNameTag:be.NewSymbolNameTag,NewSymbolNameTriggerKind:be.NewSymbolNameTriggerKind,InlineEdit:be.$eP,InlineEditTriggerKind:be.InlineEditTriggerKind}}}}),define(Ie[308],Pe([1,0,56,118,39,112,40,32,68,53,121,123,124,84,88,80,111,65,46,83,63,67,247,12,122,81,82,86,90,116]),function(le,e,I,M,A,O,R,w,p,E,T,D,d,v,g,r,o,s,i,n,c,l,t,f,a,$,u,S,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$xs)($.$8lc,$.$7lc,1),(0,I.$xs)(f.$4j,t.$inc,1),(0,I.$xs)(r.$alc,r.$blc,1),(0,I.$xs)(w.$MP,w.$LP,0),(0,I.$xs)(S.$klc,S.$llc,0),(0,I.$xs)(h.$2lc,h.$3lc,0),(0,I.$xs)(R.$zlc,R.$xlc,0),(0,I.$xs)(s.$Blc,s.$Alc,0),(0,I.$xs)(D.$fmc,D.$jmc,0),(0,I.$xs)(O.$lmc,O.$kmc,0),(0,I.$xs)(p.$BP,p.$AP,0),(0,I.$xs)(u.$9lc,u.$0lc,0),(0,I.$xs)(i.$elc,i.$dlc,0),(0,I.$xs)(M.$Qmc,M.$Pmc,1),(0,I.$xs)(d.$Bmc,d.$Cmc,0),(0,I.$xs)(v.$Ulc,v.$Tlc,0),(0,I.$xs)(T.$4mc,T.$3mc,0),(0,I.$xs)(E.$Xlc,E.$1lc,0),(0,I.$xs)(b.$5mc,b.$6mc,0),(0,I.$xs)(g.$tDb,g.$uDb,0),(0,I.$xs)(o.$gnc,o.$fnc,0),(0,I.$xs)(A.$wlc,A.$vlc,0),(0,I.$xs)(n.$5lc,n.$4lc,0),(0,I.$xs)(c.$KP,c.$HP,0),(0,I.$xs)(l.$Llc,l.$Mlc,0),(0,I.$xs)(a.$dmc,a.$emc,0)}),define(Ie[309],Pe([1,0,307,41,2,304,7,11,253]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=void 0;class E extends O.$lnc{j(){}getModule(v,g){for(const r of this.b){const o=r(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends M.$_lc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$rpc);const v=this.h.invokeFunction(I.$hnc);this.r=this.h.createInstance(E,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(v){return v.browser}async xb(v,g,r){g=g.with({path:D(g.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=A.URI.revive(await this.C.$asBrowserUri(g)),i=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),i.status!==200)throw new Error(i.statusText);const n=await i.text(),c=`${g.toString(!0)}#vscode-extension`,l=`${n}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",l)}catch(u){throw console.error(o?`Loading code for extension ${o} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${g.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}v&&await this.w.initializeLocalizedMessages(v);const f={},a={exports:f},$=u=>{const S=this.r.getModule(u,g);if(S===void 0)throw new Error(`Cannot load module '${u}'`);return S};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(a,f,$),a.exports!==f?a.exports:f}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(v){}async Bb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+v;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,w.$xh)(10)}}e.$spc=T;function D(d,v){return d.endsWith(v)?d:d+v}}),define(Ie[310],Pe([1,0,71,56,12,41,217,87,309]),function(le,e,I,M,A,O,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$xs)(A.$3j,new I.$ti(R.$knc,[!0],!0)),(0,M.$xs)(O.$amc,p.$spc,0),(0,M.$xs)(w.$Clc,w.$Dlc,0)}),define(Ie[316],Pe([1,0,21,5,79,305,255,19,60,16,2,308,310]),function(le,e,I,M,A,O,R,w,p,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=l;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const d=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(t){return/^(file|vscode-remote):/i.test(t)}const g=fetch.bind(self);function r(t){self.fetch=async function(f,a){return f instanceof Request||v(String(f))&&(f=(await t(T.URI.parse(String(f)))).toString(!0)),g(f,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,a,$,u,S){(async()=>(v(a.toString())&&(a=(await t(T.URI.parse(a.toString()))).toString(!0)),super.open(f,a,$??!0,u,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(f,a){if(/^file:/i.test(f.toString()))f=E.$Qg.uriToBrowserUri(T.URI.parse(f.toString())).toString(!0);else if(/^vscode-remote:/i.test(f.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const u=`(${function(m){function k(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const y=fetch.bind(self);self.fetch=function(P,W){return P instanceof Request?y(P,W):y(k(P),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,W,V,q,N){return super.open(P,k(W),V??!0,q,N)}};const C=importScripts.bind(self);self.importScripts=(...P)=>{C(...P.map(k))},C(m)}.toString()}('${f}'))`;a=a||{},a.name=`${name} -> ${a.name||w.$oc(f.toString())}`;const S=new Blob([u],{type:"application/javascript"}),h=URL.createObjectURL(S);return new t(h,a)}}else self.Worker=class extends R.$tpc{constructor(t,f){super(d,t,{name:w.$oc(t.toString()),...f})}};const o=new class{constructor(){this.pid=void 0}exit(t){D()}};class s{constructor(){const f=new MessageChannel,a=new M.$ee;let $=!1;d(f.port2,[f.port2]),f.port1.onmessage=u=>{const{data:S}=u;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const h=I.$Ge.wrap(new Uint8Array(S,0,S.byteLength));if((0,A.$1m)(h,2)){$=!0,n("received terminate message from renderer");return}a.fire(h)},this.protocol={onMessage:a.event,send:u=>{if(!$){const S=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);f.port1.postMessage(S,[S])}}}}}function i(t){return new Promise(f=>{const a=t.onMessage($=>{a.dispose();const u=JSON.parse($.toString());t.send((0,A.$Zm)(0)),f({protocol:t,initData:u})});t.send((0,A.$Zm)(1))})}let n=t=>D();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function l(){p.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(f){c(f)&&i(t.protocol).then(a=>{p.mark("code/extHost/didWaitForInitData");const $=new O.$nnc(a.protocol,a.initData,o,null,f.data);r(u=>$.asBrowserUri(u)),n=u=>$.terminate(u)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/17235b28ebca8f946926ec11374b67cd53c0619d/core/vs/workbench/api/worker/extensionHostWorker.js.map
